#include "bcm_osal.h"

void OSAL_UDELAY(unsigned int usecs)
{
	UNUSED1(usecs);
}

void OSAL_MSLEEP(unsigned int msecs)
{
	UNUSED1(msecs);
}

void *OSAL_ALLOC(void *p_dev, u32 mode, u32 size)
{
	UNUSED3(p_dev, mode, size);

	return OSAL_NULL;
}

void OSAL_FREE(void *p_dev, void *memory)
{
	UNUSED2(p_dev, memory);
}

void *OSAL_MEMSET(void *s, int c, osal_size_t count)
{
	char *xs = s;

	while (count--)
		*xs++ = c;
	return s;
}

void *OSAL_MEMCPY(void *dest, const void *src, osal_size_t count)
{
	char *tmp = dest;
	const char *s = src;

	while (count--)
		*tmp++ = *s++;
	return dest;
}

int OSAL_MEMCMP(const void *cs, const void *ct, osal_size_t count)
{
	const unsigned char *su1, *su2;
	int res = 0;

	for (su1 = cs, su2 = ct; 0 < count; ++su1, ++su2, count--)
		if ((res = *su1 - *su2) != 0)
			break;
	return res;
}

void *OSAL_DMA_ALLOC_COHERENT(void *p_dev, dma_addr_t *phys, u32 size)
{
	UNUSED3(p_dev, phys, size);

	return OSAL_NULL;
}

void OSAL_DMA_FREE_COHERENT(void *p_dev, void *virt, dma_addr_t phys, u32 size)
{
	UNUSED4(p_dev, virt, phys, size);
}

int OSAL_VF_CQE_COMPLETION(void *p_hwfn, void *cqe, int protocol)
{
	UNUSED3(p_hwfn, cqe, protocol);

	return 0;
}

u32 REG_RD(void *p_hwfn, u32 addr)
{
	UNUSED2(p_hwfn, addr);

	return 0;
}

void REG_WR(void *p_hwfn, u32 addr, u32 value)
{
	UNUSED3(p_hwfn, addr, value);
}

void REG_WR16(void *p_hwfn, u32 addr, u16 value)
{
	UNUSED3(p_hwfn, addr, value);
}

u32 DIRECT_REG_RD(void *p_hwfn, void *addr)
{
	UNUSED2(p_hwfn, addr);

	return 0;
}

void DIRECT_REG_WR(void *p_hwfn, void *addr, u32 value)
{
	UNUSED3(p_hwfn, addr, value);
}

u64 DIRECT_REG_RD64(void *p_hwfn, void *addr)
{
	UNUSED2(p_hwfn, addr);

	return 0;
}

void DIRECT_REG_WR64(void *p_hwfn, void *addr, u64 value)
{
	UNUSED3(p_hwfn, addr, value);
}

void OSAL_MUTEX_INIT(osal_mutex_t *mutex)
{
	UNUSED1(mutex);
}

void OSAL_SPIN_LOCK_INIT(osal_spinlock_t *lock)
{
	UNUSED1(lock);
}

void OSAL_MUTEX_ACQUIRE(osal_mutex_t *mutex)
{
	UNUSED1(mutex);
}

void OSAL_SPIN_LOCK(osal_spinlock_t *lock)
{
	UNUSED1(lock);
}

void OSAL_MUTEX_RELEASE(osal_mutex_t *mutex)
{
	UNUSED1(mutex);
}

void OSAL_SPIN_UNLOCK(osal_spinlock_t *lock)
{
	UNUSED1(lock);
}

void OSAL_LIST_PUSH_HEAD(void *entry, void *list)
{
	UNUSED2(entry, list);
}

void OSAL_LIST_PUSH_TAIL(void *entry, void *list)
{
	UNUSED2(entry, list);
}

void *__OSAL_LIST_FIRST_ENTRY(void *list)
{
	UNUSED1(list);

	return OSAL_NULL;
}

void OSAL_LIST_REMOVE_ENTRY(void *entry, void *list)
{
	UNUSED2(entry, list);
}

void OSAL_PCI_READ_CONFIG_DWORD(void *p_dev, u32 address, u32 *dst)
{
	UNUSED3(p_dev, address, dst);
}

void OSAL_MMIOWB(void *p_dev)
{
	UNUSED1(p_dev);
}

void OSAL_BARRIER(void *p_dev)
{
	UNUSED1(p_dev);
}

void OSAL_SMP_RMB(void *p_dev)
{
	UNUSED1(p_dev);
}

void OSAL_SMP_WMB(void *p_dev)
{
	UNUSED1(p_dev);
}

void OSAL_RMB(void *p_dev)
{
	UNUSED1(p_dev);
}

void OSAL_WMB(void *p_dev)
{
	UNUSED1(p_dev);
}

void OSAL_SET_BIT(u8 bit, unsigned long *bitmap)
{
	UNUSED2(bit, bitmap);
}

void OSAL_CLEAR_BIT(u8 bit, unsigned long *bitmap)
{
	UNUSED2(bit, bitmap);
}

int OSAL_TEST_BIT(u8 bit, unsigned long *bitmap)
{
	UNUSED2(bit, bitmap);

	return 0;
}

bool OSAL_TEST_AND_FLIP_BIT(u8 bit, unsigned long *bitmap)
{
	UNUSED2(bit, bitmap);

	return false;
}

void OSAL_NON_ATOMIC_SET_BIT(u8 bit, unsigned long *bitmap)
{
	UNUSED2(bit, bitmap);
}

u8 OSAL_FIND_FIRST_BIT(unsigned long *bitmap, u8 length)
{
	UNUSED2(bitmap, length);

	return 0;
}

int OSAL_BITMAP_WEIGHT(unsigned long *bitmap, u32 nbits)
{
	UNUSED2(bitmap, nbits);

	return 0;
}

void PRINT(void *dp_ctx, const char *fmt, ...)
{
	UNUSED2(dp_ctx, fmt);
}

void PRINT_ERR(void *dp_ctx, const char *fmt, ...)
{
	UNUSED2(dp_ctx, fmt);
}

void OSAL_WARN(bool condition, char *format, ...)
{
	UNUSED2(condition, format);
}

int OSAL_SPRINTF(char *buf, const char *fmt, ...)
{
	UNUSED2(buf, fmt);

	return 0;
}

int OSAL_SNPRINTF(char *buf, osal_size_t size, const char *fmt, ...)
{
	UNUSED3(buf, size, fmt);

	return 0;
}

char *OSAL_STRCPY(char *dest, const char *src)
{
	char *tmp = dest;

	while ((*dest++ = *src++) != '\0')
		/* nothing */;
	return tmp;
}

char *OSAL_STRNCPY(char *dest, const char *src, osal_size_t count)
{
	char *tmp = dest;

	while (count) {
		if ((*tmp = *src) != 0)
			src++;
		tmp++;
		count--;
	}
	return dest;
}

int OSAL_STRCMP(const char *cs, const char *ct)
{
	unsigned char c1, c2;

	while (1) {
		c1 = *cs++;
		c2 = *ct++;
		if (c1 != c2)
			return c1 < c2 ? -1 : 1;
		if (!c1)
		break;
	}
	return 0;
}

u32 *OSAL_REG_ADDR(void *p_hwfn, u32 offset)
{
	UNUSED2(p_hwfn, offset);

	return OSAL_NULL;
}

void OSAL_GET_PROTOCOL_STATS(void *p_dev, u32 type, void *stats)
{
	UNUSED3(p_dev, type, stats);
}

u32 OSAL_CRC32(u32 crc, u8 *buf, osal_size_t length)
{
	UNUSED3(crc, buf, length);

	return 0;
}

void OSAL_CRC8_POPULATE(u8 table[256], u8 polynomial)
{
	UNUSED2(table, polynomial);
}

u8 OSAL_CRC8(u8 table[256], u8 *pdata, osal_size_t nbytes, u8 crc)
{
	UNUSED4(table, pdata, nbytes, crc);

	return 0;
}

void OSAL_SET_PLATFORM_STR(void *p_hwfn, char *buf_str, u32 buf_size)
{
	UNUSED3(p_hwfn, buf_str, buf_size);
}

void OSAL_DB_REC_OCCURRED(void *p_hwfn)
{
	UNUSED1(p_hwfn);
}

u32 OSAL_DBG_ALLOC_USER_DATA(void *p_hwfn, void **user_data_ptr)
{
	UNUSED2(p_hwfn, user_data_ptr);

	return 0;
}
