/*
 * Copyright (c) 2017-2019 Cavium, Inc.
 * All rights reserved.                
 *                                     
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:                                                          
 *                                                                    
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer. 
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *                                                                         
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR        
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF       
 *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
 *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN    
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)    
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *  POSSIBILITY OF SUCH DAMAGE.                                                
 */    
/**
 * \file
 *
 * \brief Linux-specific typedefs
 *
 * This file includes Linux specific typedefs. These are needed
 * for ECORE: ECORE for Linux will look for these definitions
 * from the kernel's types.h file.
 *
 * If needed, this file may exists in the target-OS specific
 * directory, so as to allow it to be customized per target-OS.
 */

#ifndef __BCM_TYPES_H__
#define __BCM_TYPES_H__

#ifndef __bcmtype_h__
typedef unsigned long long	u64;
typedef unsigned int		u32;
typedef unsigned short		u16;
typedef unsigned char		u8;

typedef long long		s64;
typedef int			s32;
typedef signed short		s16;
typedef signed char		s8;

#if defined(IA64)  || defined(AMD64)
	typedef u64  int_ptr_t;
#else   
	typedef unsigned long int_ptr_t;
#endif

#endif //__bcmtype_h__

typedef u16			__le16;
typedef u16			__be16;
typedef u32			__le32;
typedef u32			__be32;
typedef u64			__le64;
typedef u64			__be64;

typedef u64			dma_addr_t;

#ifndef __cplusplus
typedef unsigned char           bool;
#define true                    1
#define false                   0
#endif

#define __iomem			/**/

#endif
