/**
 * \file
 *
 * \brief Linux-specific typedefs
 *
 * This file includes Linux specific typedefs. These are needed
 * for ECORE: ECORE for Linux will look for these definitions
 * from the kernel's types.h file.
 *
 * If needed, this file may exists in the target-OS specific
 * directory, so as to allow it to be customized per target-OS.
 */

#ifndef __BCM_TYPES_H__
#define __BCM_TYPES_H__

#ifndef __bcmtype_h__
typedef unsigned long long	u64;
typedef unsigned int		u32;
typedef unsigned short		u16;
typedef unsigned char		u8;

typedef long long		s64;
typedef int			s32;
typedef signed short		s16;
typedef signed char		s8;

#if defined(IA64)  || defined(AMD64)
	typedef u64  int_ptr_t;
#else   
	typedef unsigned long int_ptr_t;
#endif

#endif //__bcmtype_h__

typedef u16			__le16;
typedef u16			__be16;
typedef u32			__le32;
typedef u32			__be32;
typedef u64			__le64;
typedef u64			__be64;

typedef u64			dma_addr_t;

#ifndef __cplusplus
typedef unsigned char           bool;
#define true                    1
#define false                   0
#endif

#define __iomem			/**/

#endif
