#ifndef __ECORE_SELFTEST_API_H__
#define __ECORE_SELFTEST_API_H__

#include "ecore_status.h"

/**
 * @brief ecore_selftest_memory - Perform memory test
 *
 * @param p_dev
 *
 * @return enum _ecore_status_t
 */
enum _ecore_status_t ecore_selftest_memory(struct ecore_dev *p_dev);

/**
 * @brief ecore_selftest_interrupt - Perform interrupt test
 *
 * @param p_dev
 *
 * @return enum _ecore_status_t
 */
enum _ecore_status_t ecore_selftest_interrupt(struct ecore_dev *p_dev);

/**
 * @brief ecore_selftest_register - Perform register test
 *
 * @param p_dev
 *
 * @return enum _ecore_status_t
 */
enum _ecore_status_t ecore_selftest_register(struct ecore_dev *p_dev);

/**
 * @brief ecore_selftest_clock - Perform clock test
 *
 * @param p_dev
 *
 * @return enum _ecore_status_t
 */
enum _ecore_status_t ecore_selftest_clock(struct ecore_dev *p_dev);

/**
 * @brief ecore_selftest_nvram - Perform nvram test
 *
 * @param p_dev
 *
 * @return enum _ecore_status_t
 */
enum _ecore_status_t ecore_selftest_nvram(struct ecore_dev *p_dev);
#endif
