/****************************************************************************
 *
 * Name:        mfw_hsi.h
 *
 * Description: Global definitions
 *
 ****************************************************************************/

#ifndef MFW_HSI_H
#define MFW_HSI_H

#define MFW_TRACE_SIGNATURE	0x25071946

/* The trace in the buffer */
#define MFW_TRACE_EVENTID_MASK		0x00ffff
#define MFW_TRACE_PRM_SIZE_MASK		0x0f0000
#define MFW_TRACE_PRM_SIZE_OFFSET	16
#define MFW_TRACE_ENTRY_SIZE		3

struct mcp_trace {
	u32	signature;	/* Help to identify that the trace is valid */
	u32	size;		/* the size of the trace buffer in bytes*/
	u32	curr_level;	/* 2 - all will be written to the buffer
				 * 1 - debug trace will not be written
				 * 0 - just errors will be written to the buffer
				 */
	u32	modules_mask[2];/* a bit per module, 1 means mask it off, 0 means add it to the trace buffer */

	/* Warning: the following pointers are assumed to be 32bits as they are used only in the MFW */
	u32	trace_prod;	/* The next trace will be written to this offset */
	u32	trace_oldest;	/* The oldest valid trace starts at this offset (usually very close after the current producer) */
};

#endif /* MFW_HSI_H */


