/*
 * Copyright (c) 2017-2019 Cavium, Inc.
 * All rights reserved.                
 *                                     
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:                                                          
 *                                                                    
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer. 
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *                                                                         
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR        
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF       
 *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
 *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN    
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)    
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *  POSSIBILITY OF SUCH DAMAGE.                                                
 */    
#ifndef __ECORE_PTP_H__
#define __ECORE_PTP_H__

enum _ecore_status_t
ecore_ptp_cfg_filters(struct ecore_dev *p_dev,
		      enum ecore_ptp_filter_type type,
		      enum ecore_ptp_hwtstamp_tx_type tx_type);

enum _ecore_status_t ecore_ptp_read_rx_ts(struct ecore_dev *p_dev, u64 *ts);

enum _ecore_status_t ecore_ptp_read_tx_ts(struct ecore_dev *p_dev, u64 *ts);

enum _ecore_status_t ecore_ptp_read_cc(struct ecore_dev *p_dev, u64 *cycles);

enum _ecore_status_t ecore_ptp_adjfreq(struct ecore_dev *p_dev, s32 ppb);

enum _ecore_status_t ecore_ptp_disable(struct ecore_dev *p_dev);

enum _ecore_status_t ecore_ptp_enable(struct ecore_dev *p_dev);

#endif /* __ECORE_PTP_H__ */
