/*
 * Copyright (c) 2017-2019 Cavium, Inc.
 * All rights reserved.                
 *                                     
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:                                                          
 *                                                                    
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer. 
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *                                                                         
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR        
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF       
 *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
 *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN    
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)    
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *  POSSIBILITY OF SUCH DAMAGE.                                                
 */    

#ifndef MISC_BITS_H
#define MISC_BITS_H

/*reset_config*/

/* MISCS_REG_RESET_PL_UA */
#define MISCS_REG_RESET_PL_UA_SET		(MISCS_REG_RESET_PL_UA + 4)
#define MISCS_REG_RESET_PL_UA_CLEAR		(MISCS_REG_RESET_PL_UA + 8)
#define MISCS_REG_RESET_PL_UA_PROCESS_KILL (0x0)

#define MISCS_REG_RESET_PL_HV_SET			(MISCS_REG_RESET_PL_HV + 4)
#define MISCS_REG_RESET_PL_HV_CLEAR			(MISCS_REG_RESET_PL_HV + 8)
#define MISCS_REG_RESET_PL_HV_PROCESS_KILL (0x0)

/* MISC_REG_RESET_PL_UA */
#define MISC_REG_RESET_PL_UA_SET			(MISC_REG_RESET_PL_UA + 4)
#define MISC_REG_RESET_PL_UA_CLEAR			(MISC_REG_RESET_PL_UA + 8)
#define MISC_REG_RESET_PL_UA_PROCESS_KILL (0x0)

/* MISC_REG_RESET_PL_HV */
#define MISC_REG_RESET_PL_HV_SET			(MISC_REG_RESET_PL_HV + 4)
#define MISC_REG_RESET_PL_HV_CLEAR			(MISC_REG_RESET_PL_HV + 8)
#define MISC_REG_RESET_PL_HV_PROCESS_KILL \
	(MISC_REG_RESET_PL_HV_RST_PSWRQ | \
	 MISC_REG_RESET_PL_HV_RST_PSWRD | \
	 MISC_REG_RESET_PL_HV_RST_PSWWR | \
	 MISC_REG_RESET_PL_HV_RST_ATC)

/* PL_HV_2 - for K2/E5 only */
#define MISCS_REG_RESET_PL_HV_2_SET			(MISCS_REG_RESET_PL_HV_2 + 4)
#define MISCS_REG_RESET_PL_HV_2_CLEAR			(MISCS_REG_RESET_PL_HV_2 + 8)

/* MISC_REG_RESET_PL_PDA_VMAIN_1 */
#define MISC_REG_RESET_PL_PDA_VMAIN_1_SET		(MISC_REG_RESET_PL_PDA_VMAIN_1 + 4)
#define MISC_REG_RESET_PL_PDA_VMAIN_1_CLEAR		(MISC_REG_RESET_PL_PDA_VMAIN_1 + 8)
#define MISC_REG_RESET_PL_PDA_VMAIN_1_PROCESS_KILL (~MISC_REG_RESET_PL_PDA_VMAIN_1_RST_IGU)

/* MISC_REG_RESET_PL_PDA_VMAIN_2 */
#define MISC_REG_RESET_PL_PDA_VMAIN_2_SET		(MISC_REG_RESET_PL_PDA_VMAIN_2 + 4)
#define MISC_REG_RESET_PL_PDA_VMAIN_2_CLEAR		(MISC_REG_RESET_PL_PDA_VMAIN_2 + 8)
#define MISC_REG_RESET_PL_PDA_VMAIN_2_PROCESS_KILL (0x3FFFFF)

/* E5 ONLY */
#define MISC_REG_RESET_PL_PDA_VMAIN_3_SET		(MISC_REG_RESET_PL_PDA_VMAIN_3 + 4)
#define MISC_REG_RESET_PL_PDA_VMAIN_3_CLEAR		(MISC_REG_RESET_PL_PDA_VMAIN_3 + 8)

/* MISC_REG_RESET_PL_PDA_VAUX */
#define MISC_REG_RESET_PL_PDA_VAUX_SET  		(MISC_REG_RESET_PL_PDA_VAUX + 4)
#define MISC_REG_RESET_PL_PDA_VAUX_CLEAR		(MISC_REG_RESET_PL_PDA_VAUX + 8)
#define MISC_REG_RESET_PL_PDA_VAUX_PROCESS_KILL \
	 (MISC_REG_RESET_PL_PDA_VAUX_RST_NIG | \
	  MISC_REG_RESET_PL_PDA_VAUX_RST_NIG_HARD )
	  
#define MISC_REG_RESET_BLOCKS(path, _reg_, _bits_) \
	 do { \
		REG_WRITE(path, _reg_ ## _CLEAR, _bits_); \
		REG_WRITE(path, _reg_ ## _SET, _bits_); \
	 } while (0)
/* MISCS_REG_VAUX_EN_DIS */
#define MISCS_VAUX_VALUE		(0x3L<<0)
#define MISCS_VAUX_VALUE_POS		0
#define MISCS_VAUX_SET			(0x3L<<2)
#define MISCS_VAUX_SET_POS		2
#define MISCS_VAUX_CLR			(0x3L<<4)
#define MISCS_VAUX_CLR_POS		4
#define MISCS_VAUX_FLOAT		(0x3L<<6)
#define MISCS_VAUX_FLOAT_POS		6

/* VAUX_EN_DIS pin assignment */
#define MISCS_VAUX_EN_L			0x1   /* Bit 0 */
#define MISCS_VAUX_DIS_L		0x2   /* Bit 1 */

#define MISCS_MAIN_SEQ_BYP_SEL_VAUX_B		(1<<4)
/////////////////////////
// HW Lock Definitions //
/////////////////////////

// Masters
#define HW_LOCK_MASTER_FUNC_0                    0
#define HW_LOCK_MASTER_FUNC_1                    1
#define HW_LOCK_MASTER_FUNC_2                    2
#define HW_LOCK_MASTER_FUNC_3                    3
#define HW_LOCK_MASTER_FUNC_4                    4
#define HW_LOCK_MASTER_FUNC_5                    5
#define HW_LOCK_MASTER_FUNC_6                    6
#define HW_LOCK_MASTER_FUNC_7                    7
#define HW_LOCK_MASTER_RESERVED_8                8
#define HW_LOCK_MASTER_RESERVED_9                9
#define HW_LOCK_MASTER_RESERVED_10               10
#define HW_LOCK_MASTER_RESERVED_11               11
#define HW_LOCK_MASTER_RESERVED_12               12
#define HW_LOCK_MASTER_HOST_SCRIPTS              13
#define HW_LOCK_MASTER_MCP_RESET                 14
#define HW_LOCK_MASTER_MCP                       15

// Resources
#define HW_LOCK_RESOURCE_RESERVED_0              (1 << 0)
#define HW_LOCK_RESOURCE_RESERVED_1              (1 << 1)
#define HW_LOCK_RESOURCE_RESERVED_2              (1 << 2)
#define HW_LOCK_RESOURCE_RESERVED_3              (1 << 3)
#define HW_LOCK_RESOURCE_RESERVED_4              (1 << 4)
#define HW_LOCK_RESOURCE_RESERVED_5              (1 << 5)
#define HW_LOCK_RESOURCE_RESERVED_6              (1 << 6)
#define HW_LOCK_RESOURCE_RESERVED_7              (1 << 7)
#define HW_LOCK_RESOURCE_RESERVED_8              (1 << 8)
#define HW_LOCK_RESOURCE_RESERVED_9              (1 << 9)
#define HW_LOCK_RESOURCE_RESERVED_10             (1 << 10)
#define HW_LOCK_RESOURCE_RESERVED_11             (1 << 11)
#define HW_LOCK_RESOURCE_RESERVED_12             (1 << 12)
#define HW_LOCK_RESOURCE_RESERVED_13             (1 << 13)
#define HW_LOCK_RESOURCE_RESERVED_14             (1 << 14)
#define HW_LOCK_RESOURCE_RESERVED_15             (1 << 15)
#define HW_LOCK_RESOURCE_RESERVED_16             (1 << 16)
#define HW_LOCK_RESOURCE_RESERVED_17             (1 << 17)
#define HW_LOCK_RESOURCE_RESERVED_18             (1 << 18)
#define HW_LOCK_RESOURCE_RESERVED_19             (1 << 19)
#define HW_LOCK_RESOURCE_RESERVED_20             (1 << 20)
#define HW_LOCK_RESOURCE_RESERVED_21             (1 << 21)
#define HW_LOCK_RESOURCE_RESERVED_22             (1 << 22)
#define HW_LOCK_RESOURCE_RESERVED_23             (1 << 23)
#define HW_LOCK_RESOURCE_RESERVED_24             (1 << 24)
#define HW_LOCK_RESOURCE_RESERVED_25             (1 << 25)
#define HW_LOCK_RESOURCE_RESERVED_26             (1 << 26)
#define HW_LOCK_RESOURCE_OEM_0                   (1 << 27)
#define HW_LOCK_RESOURCE_OEM_1                   (1 << 28)
#define HW_LOCK_RESOURCE_OEM_2                   (1 << 29)
#define HW_LOCK_RESOURCE_OEM_3                   (1 << 30)
#define HW_LOCK_RESOURCE_OEM_4                   (1 << 31)
#define HW_LOCK_MAX_RESOURCE_VALUE               (31)

/////////////////////////
// CHIP DEF Definitions //
/////////////////////////
#define MISCS_REG_CHIP_NUM_K2_DRVSIM			0x1628
#define MISCS_REG_CHIP_NUM_BB_DRVSIM			0x1629

#define MISCS_REG_CHIP_NUM_K2				0x1630
#define MISCS_REG_CHIP_NUM_BB				0x1634
#define MISCS_REG_CHIP_NUM_BB_T				0x1635

#define CHIP_IS_BB(chip_num) ((chip_num == MISCS_REG_CHIP_NUM_BB_DRVSIM) || (chip_num == MISCS_REG_CHIP_NUM_BB) || (chip_num == MISCS_REG_CHIP_NUM_BB_T))
#define CHIP_IS_K2(chip_num) ((chip_num == MISCS_REG_CHIP_NUM_K2_DRVSIM) || (chip_num == MISCS_REG_CHIP_NUM_K2))

#define MISCS_REG_AVS_PVTMON_DACCODE_VMAIN_DAC_CODE_MASK 	0x000003ff
#define MISCS_REG_AVS_PVTMON_DACCODE_VMAIN_DAC_CODE_SHIFT 	0
#define MISCS_REG_AVS_PVTMON_DACCODE_VMAIN_DAC_OVERRIDE_MASK 	0x00000400
#define MISCS_REG_AVS_PVTMON_DACCODE_VMAIN_DAC_OVERRIDE_SHIFT 	10
#define MISCS_REG_AVS_PVTMON_DACCODE_VMGMT_DAC_CODE_MASK 	0x001ff800
#define MISCS_REG_AVS_PVTMON_DACCODE_VMGMT_DAC_CODE_SHIFT 	11
#define MISCS_REG_AVS_PVTMON_DACCODE_VMGMT_DAC_OVERRIDE_MASK 	0x00200000
#define MISCS_REG_AVS_PVTMON_DACCODE_VMGMT_DAC_OVERRIDE_SHIFT 	21
/* 
 * Secured Mode Definitions
 */
enum secure_modes {
	SECURITY_MODE_NON_SECURED_MODE = 0,
	SECURITY_MODE_SECURED_MODE = 1,
	SECURITY_MODE_FULLY_SECURED_MODE = 2
};

#define MISCS_REG_MFW_SECURITY_MODE_SOURCE_MASK		(0x1)
#define MISCS_REG_MFW_SECURITY_MODE_SOURCE_SHIFT	(0)
#define MISCS_REG_MFW_SECURITY_MODE_SOURCE_EXT_PIN	(0)
#define MISCS_REG_MFW_SECURITY_MODE_SOURCE_OVERRIDE	(1)

#define MISCS_REG_MFW_SECURITY_MODE_OVERRIDE_VAL_MASK	(0x6)
#define MISCS_REG_MFW_SECURITY_MODE_OVERRIDE_VAL_SHIFT	(0x1)
/* Values are SECURITY_MODE_XXX */

/* MISCS_REG_GENERIC_POR_0 definition */
#define MISCS_REG_GENERIC_POR_0_POR_OFFSET		0
#define MISCS_REG_GENERIC_POR_0_POR_MASK		0x00000001
#define MISCS_REG_GENERIC_POR_0_POR_CNT_OFFSET		1
#define MISCS_REG_GENERIC_POR_0_POR_CNT_MASK		0x00000002
#define MISCS_REG_GENERIC_POR_0_CORE_CNT_OFFSET		2
#define MISCS_REG_GENERIC_POR_0_CORE_CNT_MASK		0x0000fffc
#define MISCS_REG_GENERIC_POR_0_WD_CNT_OFFSET		16
#define MISCS_REG_GENERIC_POR_0_WD_CNT_MASK		0x000f0000
#define MISCS_REG_GENERIC_POR_0_MCP_RESET_CNT_OFFSET	20
#define MISCS_REG_GENERIC_POR_0_MCP_RESET_CNT_MASK	0xfff00000

#define MISC_REG_BLOCK_256B_EN_K2_BRB	(1<<0)
#define MISC_REG_BLOCK_256B_EN_K2_BTB	(1<<1)
#endif // MISC_BITS_H
