/*
 * Copyright (c) 2017-2019 Cavium, Inc.
 * All rights reserved.                
 *                                     
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:                                                          
 *                                                                    
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer. 
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *                                                                         
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR        
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF       
 *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
 *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN    
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)    
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *  POSSIBILITY OF SUCH DAMAGE.                                                
 */    
#ifndef __INIT_VALUES_ZIPPED_H__
#define __INIT_VALUES_ZIPPED_H__

/* initialization commands array */
ARRAY_DECL u32 init_ops[] = {
	/* GRC */
	0x00030003, 0xffff0000, 	/* if phase != 'engine', skip 3 ops */
	0x00020002, 0x002a0000, 	/* if mode != '!asic', skip 2 ops */
	0x0280c201, 0x00000000, 	/* write 0x0 to address 0x50184 */
	0x02810201, 0x00000000, 	/* write 0x0 to address 0x50204 */
	/* MISCS */
	0x000f0003, 0xffff0000, 	/* if phase != 'engine', skip 15 ops */
	0x00030002, 0x002a0000, 	/* if mode != '!asic', skip 3 ops */
	0x0048c201, 0x00000000, 	/* write 0x0 to address 0x9184 */
	0x0048d201, 0x00000000, 	/* write 0x0 to address 0x91a4 */
	0x004ba601, 0x00000001, 	/* write 0x1 to address 0x974c */
	0x00020002, 0x00300000, 	/* if mode != '(!asic)&bb', skip 2 ops */
	0x0048ca01, 0x00000000, 	/* write 0x0 to address 0x9194 */
	0x00483401, 0x00000001, 	/* write 0x1 to address 0x9068 */
	0x00020002, 0x00290000, 	/* if mode != '(!asic)&k2', skip 2 ops */
	0x00483401, 0x00000401, 	/* write 0x401 to address 0x9068 */
	0x0048ac01, 0x03ffffff, 	/* write 0x3ffffff to address 0x9158 */
	0x00010002, 0x00300000, 	/* if mode != '(!asic)&bb', skip 1 ops */
	0x00483201, 0x00000001, 	/* write 0x1 to address 0x9064 */
	0x00020002, 0x00290000, 	/* if mode != '(!asic)&k2', skip 2 ops */
	0x00483201, 0x00000401, 	/* write 0x401 to address 0x9064 */
	0x0048aa01, 0x03ffffff, 	/* write 0x3ffffff to address 0x9154 */
	/* MISC */
	0x004c0003, 0xffff0000, 	/* if phase != 'engine', skip 76 ops */
	0x0040c201, 0x00000000, 	/* write 0x0 to address 0x8184 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x28007201, 0x00000001, 	/* write 0x1 to address 0x5000e4 */
	0x00010002, 0x002a0000, 	/* if mode != '!asic', skip 1 ops */
	0x00402c01, 0x00000000, 	/* write 0x0 to address 0x8058 */
	0x00010002, 0x00300000, 	/* if mode != '(!asic)&bb', skip 1 ops */
	0x00405401, 0x00000000, 	/* write 0x0 to address 0x80a8 */
	0x00010002, 0x004c0000, 	/* if mode != '(!asic)&ports_per_eng_1', skip 1 ops */
	0x00460001, 0x00000000, 	/* write 0x0 to address 0x8c00 */
	0x00010002, 0x00450000, 	/* if mode != '(!asic)&ports_per_eng_2', skip 1 ops */
	0x00460001, 0x00000001, 	/* write 0x1 to address 0x8c00 */
	0x00010002, 0x005a0000, 	/* if mode != '(!asic)&ports_per_eng_4', skip 1 ops */
	0x00460001, 0x00000002, 	/* write 0x2 to address 0x8c00 */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x00460a01, 0x00000000, 	/* write 0x0 to address 0x8c14 */
	0x00010002, 0x002a0000, 	/* if mode != '!asic', skip 1 ops */
	0x00403401, 0x0000000c, 	/* write 0xc to address 0x8068 */
	0x00403c01, 0x33bfbfbf, 	/* write 0x33bfbfbf to address 0x8078 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x00404401, 0x003ffff8, 	/* write 0x3ffff8 to address 0x8088 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x00404401, 0x07fffff8, 	/* write 0x7fffff8 to address 0x8088 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x00404c01, 0x000000c0, 	/* write 0xc0 to address 0x8098 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x00404c01, 0x000002c0, 	/* write 0x2c0 to address 0x8098 */
	0x00010002, 0x002a0000, 	/* if mode != '!asic', skip 1 ops */
	0x00402a01, 0xffffffff, 	/* write 0xffffffff to address 0x8054 */
	0x00010002, 0x00300000, 	/* if mode != '(!asic)&bb', skip 1 ops */
	0x00405201, 0x0000000f, 	/* write 0xf to address 0x80a4 */
	0x00010002, 0x002a0000, 	/* if mode != '!asic', skip 1 ops */
	0x00403201, 0xffffffff, 	/* write 0xffffffff to address 0x8064 */
	0x00403a01, 0x1fffffff, 	/* write 0x1fffffff to address 0x8074 */
	0x00404201, 0xffffffff, 	/* write 0xffffffff to address 0x8084 */
	0x00404a01, 0xffffffff, 	/* write 0xffffffff to address 0x8094 */
	0xa2028601, 0x00000001, 	/* write 0x1 to address 0x144050c */
	0xa2031401, 0x0000000f, 	/* write 0xf to address 0x1440628 */
	0xaa028601, 0x00000001, 	/* write 0x1 to address 0x154050c */
	0xaa031401, 0x0000000f, 	/* write 0xf to address 0x1540628 */
	0xb2028601, 0x00000001, 	/* write 0x1 to address 0x164050c */
	0xb2031401, 0x0000000f, 	/* write 0xf to address 0x1640628 */
	0xba028601, 0x00000001, 	/* write 0x1 to address 0x174050c */
	0xba031401, 0x0000000f, 	/* write 0xf to address 0x1740628 */
	0xc2028601, 0x00000001, 	/* write 0x1 to address 0x184050c */
	0xc2031401, 0x0000000f, 	/* write 0xf to address 0x1840628 */
	0xca028601, 0x00000001, 	/* write 0x1 to address 0x194050c */
	0xca031401, 0x0000000f, 	/* write 0xf to address 0x1940628 */
	0x00060002, 0x00170000, 	/* if mode != 'fpga', skip 6 ops */
	0xa2028021, 0x00000000, 	/* write array of size 3 from offset 0 to address 0x1440500 */
	0xaa028021, 0x00000000, 	/* write array of size 3 from offset 0 to address 0x1540500 */
	0xb2028021, 0x00000000, 	/* write array of size 3 from offset 0 to address 0x1640500 */
	0xba028021, 0x00000000, 	/* write array of size 3 from offset 0 to address 0x1740500 */
	0xc2028021, 0x00000000, 	/* write array of size 3 from offset 0 to address 0x1840500 */
	0xca028021, 0x00000000, 	/* write array of size 3 from offset 0 to address 0x1940500 */
	0x00060002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 6 ops */
	0xa2028021, 0x00000004, 	/* write array of size 3 from offset 4 to address 0x1440500 */
	0xaa028021, 0x00000004, 	/* write array of size 3 from offset 4 to address 0x1540500 */
	0xb2028021, 0x00000004, 	/* write array of size 3 from offset 4 to address 0x1640500 */
	0xba028021, 0x00000004, 	/* write array of size 3 from offset 4 to address 0x1740500 */
	0xc2028021, 0x00000004, 	/* write array of size 3 from offset 4 to address 0x1840500 */
	0xca028021, 0x00000004, 	/* write array of size 3 from offset 4 to address 0x1940500 */
	0x00060002, 0x00210000, 	/* if mode != '(emul_reduced|emul_full)&bb', skip 6 ops */
	0xa2028021, 0x00000008, 	/* write array of size 3 from offset 8 to address 0x1440500 */
	0xaa028021, 0x00000008, 	/* write array of size 3 from offset 8 to address 0x1540500 */
	0xb2028021, 0x00000008, 	/* write array of size 3 from offset 8 to address 0x1640500 */
	0xba028021, 0x00000008, 	/* write array of size 3 from offset 8 to address 0x1740500 */
	0xc2028021, 0x00000008, 	/* write array of size 3 from offset 8 to address 0x1840500 */
	0xca028021, 0x00000008, 	/* write array of size 3 from offset 8 to address 0x1940500 */
	0x00060002, 0x00110000, 	/* if mode != '(emul_reduced|emul_full)&k2', skip 6 ops */
	0xa2028021, 0x0000000c, 	/* write array of size 3 from offset 12 to address 0x1440500 */
	0xaa028021, 0x0000000c, 	/* write array of size 3 from offset 12 to address 0x1540500 */
	0xb2028021, 0x0000000c, 	/* write array of size 3 from offset 12 to address 0x1640500 */
	0xba028021, 0x0000000c, 	/* write array of size 3 from offset 12 to address 0x1740500 */
	0xc2028021, 0x0000000c, 	/* write array of size 3 from offset 12 to address 0x1840500 */
	0xca028021, 0x0000000c, 	/* write array of size 3 from offset 12 to address 0x1940500 */
	0x00403a01, 0xffffffff, 	/* write 0xffffffff to address 0x8074 */
	/* PGLUE_B */
	0x00160003, 0xffff0000, 	/* if phase != 'engine', skip 22 ops */
	0x00020002, 0x002a0000, 	/* if mode != '!asic', skip 2 ops */
	0x1540c201, 0x00080000, 	/* write 0x80000 to address 0x2a8184 */
	0x1540ca01, 0x00000000, 	/* write 0x0 to address 0x2a8194 */
	0x00010002, 0x00300000, 	/* if mode != '(!asic)&bb', skip 1 ops */
	0x15410201, 0x00000000, 	/* write 0x0 to address 0x2a8204 */
	0x00010002, 0x00290000, 	/* if mode != '(!asic)&k2', skip 1 ops */
	0x15410201, 0x00000000, 	/* write 0x0 to address 0x2a8204 */
	0x1550d001, 0x00020000, 	/* write 0x20000 to address 0x2aa1a0 */
	0x1550d421, 0x00000010, 	/* write array of size 4 from offset 16 to address 0x2aa1a8 */
	0x1550de21, 0x00000015, 	/* write array of size 4 from offset 21 to address 0x2aa1bc */
	0x1550e821, 0x0000001a, 	/* write array of size 4 from offset 26 to address 0x2aa1d0 */
	0x1550f221, 0x0000001f, 	/* write array of size 3 from offset 31 to address 0x2aa1e4 */
	0x1550fc21, 0x00000023, 	/* write array of size 3 from offset 35 to address 0x2aa1f8 */
	0x15510621, 0x00000027, 	/* write array of size 3 from offset 39 to address 0x2aa20c */
	0x15512001, 0x000001c7, 	/* write 0x1c7 to address 0x2aa240 */
	0x1552b221, 0x0000002b, 	/* write array of size 6 from offset 43 to address 0x2aa564 */
	0x15571a31, 0x6d420001, 	/* write runtime array of size 1 from offset 27970 to address 0x2aae34 */
	0x00010002, 0x00290000, 	/* if mode != '(!asic)&k2', skip 1 ops */
	0x1557ae01, 0x00000000, 	/* write 0x0 to address 0x2aaf5c */
	0x15400001, 0x00000001, 	/* write 0x1 to address 0x2a8000 */
	0x15400801, 0x00000001, 	/* write 0x1 to address 0x2a8010 */
	0x1550e031, 0x6d400002, 	/* write runtime array of size 2 from offset 27968 to address 0x2aa1c0 */
	0x00020003, 0x00000000, 	/* if phase != 'engine0', skip 2 ops */
	0x15400230, 0x00000001, 	/* wait until address 0x2a8004 reads 0x1 */
	0x15400a30, 0x00000001, 	/* wait until address 0x2a8014 reads 0x1 */
	0x00020003, 0x00010000, 	/* if phase != 'engine1', skip 2 ops */
	0x15400230, 0x00000002, 	/* wait until address 0x2a8004 reads 0x2 */
	0x15400a30, 0x00000002, 	/* wait until address 0x2a8014 reads 0x2 */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x15522001, 0x0003600a, 	/* write 0x3600a to address 0x2aa440 */
	0x15523001, 0x00010007, 	/* write 0x10007 to address 0x2aa460 */
	0x00040003, 0xffff0002, 	/* if phase != 'pf', skip 4 ops */
	0x15427231, 0x6d3f0001, 	/* write runtime array of size 1 from offset 27967 to address 0x2a84e4 */
	0x1550b621, 0x00000032, 	/* write array of size 3 from offset 50 to address 0x2aa16c */
	0x1552ca01, 0x00000000, 	/* write 0x0 to address 0x2aa594 */
	0x15573031, 0x6d430003, 	/* write runtime array of size 3 from offset 27971 to address 0x2aae60 */
	0x00020003, 0xffff0003, 	/* if phase != 'vf', skip 2 ops */
	0x1550b401, 0x00000001, 	/* write 0x1 to address 0x2aa168 */
	0x1552cc01, 0x00000000, 	/* write 0x0 to address 0x2aa598 */
	/* CNIG */
	0x00070003, 0xffff0000, 	/* if phase != 'engine', skip 7 ops */
	0x00030002, 0x00300000, 	/* if mode != '(!asic)&bb', skip 3 ops */
	0x10c10001, 0x00000004, 	/* write 0x4 to address 0x218200 */
	0x10c17601, 0x00000000, 	/* write 0x0 to address 0x2182ec */
	0x10c1a601, 0x00000000, 	/* write 0x0 to address 0x21834c */
	0x00020002, 0x00290000, 	/* if mode != '(!asic)&k2', skip 2 ops */
	0x10c10e01, 0x00000000, 	/* write 0x0 to address 0x21821c */
	0x10c11801, 0x00000000, 	/* write 0x0 to address 0x218230 */
	/* CPMU */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x00010002, 0x00600000, 	/* if mode != '!(asic|emul_reduced|fpga)', skip 1 ops */
	0x0181f201, 0x00000000, 	/* write 0x0 to address 0x303e4 */
	/* PCIE */
	0x00040003, 0xffff0000, 	/* if phase != 'engine', skip 4 ops */
	0x00010002, 0x00300000, 	/* if mode != '(!asic)&bb', skip 1 ops */
	0x02a00201, 0x00003f02, 	/* write 0x3f02 to address 0x54004 */
	0x00010002, 0x00290000, 	/* if mode != '(!asic)&k2', skip 1 ops */
	0x02a00201, 0x00000000, 	/* write 0x0 to address 0x54004 */
	/* PSWHST */
	0x00080003, 0xffff0000, 	/* if phase != 'engine', skip 8 ops */
	0x1500c201, 0x00000a00, 	/* write 0xa00 to address 0x2a0184 */
	0x1500ca01, 0x00000000, 	/* write 0x0 to address 0x2a0194 */
	0x15010201, 0x00000000, 	/* write 0x0 to address 0x2a0204 */
	0x15020011, 0x00000048, 	/* write 72 zeros to address 0x2a0400 */
	0x15000001, 0x00000001, 	/* write 0x1 to address 0x2a0000 */
	0x15020021, 0x00000034, 	/* write array of size 2 from offset 52 to address 0x2a0400 */
	0x15024001, 0x05050042, 	/* write 0x5050042 to address 0x2a0480 */
	0x15000210, 0x00000001, 	/* wait until address 0x2a0004 reads 0x1 */
	/* PSWHST2 */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x14f0c201, 0x00000000, 	/* write 0x0 to address 0x29e184 */
	0x14f0ca01, 0x00000000, 	/* write 0x0 to address 0x29e194 */
	/* PSWRD */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x14e0c201, 0x00000000, 	/* write 0x0 to address 0x29c184 */
	0x14e0ca01, 0x00000000, 	/* write 0x0 to address 0x29c194 */
	/* PSWRD2 */
	0x00070003, 0xffff0000, 	/* if phase != 'engine', skip 7 ops */
	0x14e8c201, 0x00000000, 	/* write 0x0 to address 0x29d184 */
	0x14e8ca01, 0x00000000, 	/* write 0x0 to address 0x29d194 */
	0x14e90201, 0x00000000, 	/* write 0x0 to address 0x29d204 */
	0x14e90a01, 0x00000000, 	/* write 0x0 to address 0x29d214 */
	0x14e86601, 0x00000003, 	/* write 0x3 to address 0x29d0cc */
	0x14e80001, 0x00000001, 	/* write 0x1 to address 0x29d000 */
	0x14e80210, 0x00000001, 	/* wait until address 0x29d004 reads 0x1 */
	/* PSWWR */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x14d0c201, 0x00000000, 	/* write 0x0 to address 0x29a184 */
	0x14d0ca01, 0x00000000, 	/* write 0x0 to address 0x29a194 */
	/* PSWWR2 */
	0x00060003, 0xffff0000, 	/* if phase != 'engine', skip 6 ops */
	0x14d8c201, 0x00000000, 	/* write 0x0 to address 0x29b184 */
	0x14d8ca01, 0x00000000, 	/* write 0x0 to address 0x29b194 */
	0x14d90201, 0x00000000, 	/* write 0x0 to address 0x29b204 */
	0x14d90a01, 0x00000000, 	/* write 0x0 to address 0x29b214 */
	0x14d91201, 0x00000000, 	/* write 0x0 to address 0x29b224 */
	0x14d91a01, 0x00000000, 	/* write 0x0 to address 0x29b234 */
	/* PSWRQ */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x1400c201, 0x00000000, 	/* write 0x0 to address 0x280184 */
	0x1400ca01, 0x00000000, 	/* write 0x0 to address 0x280194 */
	/* PSWRQ2 */
	0x00080003, 0xffff0000, 	/* if phase != 'engine', skip 8 ops */
	0x1200c201, 0x00000000, 	/* write 0x0 to address 0x240184 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x12010201, 0x00000000, 	/* write 0x0 to address 0x240204 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x12010201, 0x00000000, 	/* write 0x0 to address 0x240204 */
	0x12020831, 0x174d0002, 	/* write runtime array of size 2 from offset 5965 to address 0x240410 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x1202be01, 0x00000003, 	/* write 0x3 to address 0x24057c */
	0x00060003, 0xffff0002, 	/* if phase != 'pf', skip 6 ops */
	0x12000631, 0x17300005, 	/* write runtime array of size 5 from offset 5936 to address 0x24000c */
	0x12001431, 0x17350001, 	/* write runtime array of size 1 from offset 5941 to address 0x240028 */
	0x12001831, 0x1736000a, 	/* write runtime array of size 10 from offset 5942 to address 0x240030 */
	0x12003031, 0x17400002, 	/* write runtime array of size 2 from offset 5952 to address 0x240060 */
	0x12004831, 0x1742000b, 	/* write runtime array of size 11 from offset 5954 to address 0x240090 */
	0x13000131, 0x174f55f0, 	/* write runtime array of size 22000 from offset 5967 to address 0x260000 (WB) */
	/* PGLCS */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x00010002, 0x002a0000, 	/* if mode != '!asic', skip 1 ops */
	0x000e8201, 0x00000000, 	/* write 0x0 to address 0x1d04 */
	/* DMAE */
	0x00040003, 0xffff0000, 	/* if phase != 'engine', skip 4 ops */
	0x0060c201, 0x00000000, 	/* write 0x0 to address 0xc184 */
	0x00610201, 0x00000000, 	/* write 0x0 to address 0xc204 */
	0x00640011, 0x000001c0, 	/* write 448 zeros to address 0xc800 */
	0x00000005, 0x00160000, 	/* calling callback 0 on block 22 */
	/* PTU */
	0x00080003, 0xffff0000, 	/* if phase != 'engine', skip 8 ops */
	0x2b002e01, 0x00000000, 	/* write 0x0 to address 0x56005c */
	0x2b00c201, 0x00000000, 	/* write 0x0 to address 0x560184 */
	0x2b010201, 0x00000000, 	/* write 0x0 to address 0x560204 */
	0x2b000001, 0x00000001, 	/* write 0x1 to address 0x560000 */
	0x2b000210, 0x00000001, 	/* wait until address 0x560004 reads 0x1 */
	0x2b004601, 0x00000001, 	/* write 0x1 to address 0x56008c */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x2b004821, 0x00000037, 	/* write array of size 2 from offset 55 to address 0x560090 */
	0x00010003, 0xffff0002, 	/* if phase != 'pf', skip 1 ops */
	0x2b003e01, 0x00f00000, 	/* write 0xf00000 to address 0x56007c */
	0x00010003, 0x00000002, 	/* if phase != 'pf0', skip 1 ops */
	0x2b003c01, 0x00000000, 	/* write 0x0 to address 0x560078 */
	0x00010003, 0x00010002, 	/* if phase != 'pf1', skip 1 ops */
	0x2b003c01, 0x00100000, 	/* write 0x100000 to address 0x560078 */
	0x00010003, 0x00020002, 	/* if phase != 'pf2', skip 1 ops */
	0x2b003c01, 0x00200000, 	/* write 0x200000 to address 0x560078 */
	0x00010003, 0x00030002, 	/* if phase != 'pf3', skip 1 ops */
	0x2b003c01, 0x00300000, 	/* write 0x300000 to address 0x560078 */
	0x00010003, 0x00040002, 	/* if phase != 'pf4', skip 1 ops */
	0x2b003c01, 0x00400000, 	/* write 0x400000 to address 0x560078 */
	0x00010003, 0x00050002, 	/* if phase != 'pf5', skip 1 ops */
	0x2b003c01, 0x00500000, 	/* write 0x500000 to address 0x560078 */
	0x00010003, 0x00060002, 	/* if phase != 'pf6', skip 1 ops */
	0x2b003c01, 0x00600000, 	/* write 0x600000 to address 0x560078 */
	0x00010003, 0x00070002, 	/* if phase != 'pf7', skip 1 ops */
	0x2b003c01, 0x00700000, 	/* write 0x700000 to address 0x560078 */
	0x00020003, 0x00080002, 	/* if phase != 'pf8', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x2b003c01, 0x00800000, 	/* write 0x800000 to address 0x560078 */
	0x00020003, 0x00090002, 	/* if phase != 'pf9', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x2b003c01, 0x00900000, 	/* write 0x900000 to address 0x560078 */
	0x00020003, 0x000a0002, 	/* if phase != 'pf10', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x2b003c01, 0x00a00000, 	/* write 0xa00000 to address 0x560078 */
	0x00020003, 0x000b0002, 	/* if phase != 'pf11', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x2b003c01, 0x00b00000, 	/* write 0xb00000 to address 0x560078 */
	0x00020003, 0x000c0002, 	/* if phase != 'pf12', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x2b003c01, 0x00c00000, 	/* write 0xc00000 to address 0x560078 */
	0x00020003, 0x000d0002, 	/* if phase != 'pf13', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x2b003c01, 0x00d00000, 	/* write 0xd00000 to address 0x560078 */
	0x00020003, 0x000e0002, 	/* if phase != 'pf14', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x2b003c01, 0x00e00000, 	/* write 0xe00000 to address 0x560078 */
	0x00020003, 0x000f0002, 	/* if phase != 'pf15', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x2b003c01, 0x00f00000, 	/* write 0xf00000 to address 0x560078 */
	0x00030003, 0xffff0002, 	/* if phase != 'pf', skip 3 ops */
	0x2b004001, 0x00000001, 	/* write 0x1 to address 0x560080 */
	0x2b004210, 0x00000001, 	/* wait until address 0x560084 reads 0x1 */
	0x2b004401, 0x00000001, 	/* write 0x1 to address 0x560088 */
	/* TCM */
	0x004a0003, 0xffff0000, 	/* if phase != 'engine', skip 74 ops */
	0x8c00c201, 0x00000000, 	/* write 0x0 to address 0x1180184 */
	0x8c00ca01, 0x00000000, 	/* write 0x0 to address 0x1180194 */
	0x8c00d201, 0x00000000, 	/* write 0x0 to address 0x11801a4 */
	0x8c032401, 0x00000000, 	/* write 0x0 to address 0x1180648 */
	0x8c0a6001, 0x00000000, 	/* write 0x0 to address 0x11814c0 */
	0x00020002, 0x00020000, 	/* if mode != 'bb', skip 2 ops */
	0x8c010201, 0x00000000, 	/* write 0x0 to address 0x1180204 */
	0x8c010a01, 0x00000000, 	/* write 0x0 to address 0x1180214 */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x8c010201, 0x00000000, 	/* write 0x0 to address 0x1180204 */
	0x8c010a01, 0x00000000, 	/* write 0x0 to address 0x1180214 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00000200, 	/* write 0x200 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00000400, 	/* write 0x400 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00000600, 	/* write 0x600 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00000800, 	/* write 0x800 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00000a00, 	/* write 0xa00 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00000c00, 	/* write 0xc00 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00000e00, 	/* write 0xe00 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00001000, 	/* write 0x1000 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00001200, 	/* write 0x1200 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00001400, 	/* write 0x1400 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00001600, 	/* write 0x1600 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00001800, 	/* write 0x1800 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00001a00, 	/* write 0x1a00 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00001c00, 	/* write 0x1c00 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00001e00, 	/* write 0x1e00 to address 0x11814c0 */
	0x8c0a6801, 0x00000000, 	/* write 0x0 to address 0x11814d0 */
	0x8c0a6001, 0x00000000, 	/* write 0x0 to address 0x11814c0 */
	0x8c0a6401, 0x00000000, 	/* write 0x0 to address 0x11814c8 */
	0x8c0a6001, 0x00000200, 	/* write 0x200 to address 0x11814c0 */
	0x8c0a6401, 0x00000000, 	/* write 0x0 to address 0x11814c8 */
	0x8c0a6001, 0x00000400, 	/* write 0x400 to address 0x11814c0 */
	0x8c0a6401, 0x00000000, 	/* write 0x0 to address 0x11814c8 */
	0x8c0a6001, 0x00000600, 	/* write 0x600 to address 0x11814c0 */
	0x8c0a6401, 0x00000000, 	/* write 0x0 to address 0x11814c8 */
	0x8c0a6001, 0x00000800, 	/* write 0x800 to address 0x11814c0 */
	0x8c0a6401, 0x00000000, 	/* write 0x0 to address 0x11814c8 */
	0x8c0a6001, 0x00000a00, 	/* write 0xa00 to address 0x11814c0 */
	0x8c0a6401, 0x00000000, 	/* write 0x0 to address 0x11814c8 */
	0x8c0a6001, 0x00000c00, 	/* write 0xc00 to address 0x11814c0 */
	0x8c0a6401, 0x00000000, 	/* write 0x0 to address 0x11814c8 */
	0x8c0a6001, 0x00000e00, 	/* write 0xe00 to address 0x11814c0 */
	0x8c0a6401, 0x00000000, 	/* write 0x0 to address 0x11814c8 */
	0x8c020221, 0x00000039, 	/* write array of size 3 from offset 57 to address 0x1180404 */
	0x8c020c21, 0x0000003d, 	/* write array of size 2 from offset 61 to address 0x1180418 */
	0x8c021401, 0x00000068, 	/* write 0x68 to address 0x1180428 */
	0x8c022421, 0x00000040, 	/* write array of size 3 from offset 64 to address 0x1180448 */
	0x8c022c21, 0x00000044, 	/* write array of size 3 from offset 68 to address 0x1180458 */
	0x8c024401, 0x00000002, 	/* write 0x2 to address 0x1180488 */
	0x8c027411, 0x00000002, 	/* write 2 zeros to address 0x11804e8 */
	0x8c028401, 0x00000000, 	/* write 0x0 to address 0x1180508 */
	0x8c02b201, 0x00000006, 	/* write 0x6 to address 0x1180564 */
	0x8c040a01, 0x0000000b, 	/* write 0xb to address 0x1180814 */
	0x8c040e21, 0x00000048, 	/* write array of size 8 from offset 72 to address 0x118081c */
	0x8c041e11, 0x00000006, 	/* write 6 zeros to address 0x118083c */
	0x8c045221, 0x00000051, 	/* write array of size 5 from offset 81 to address 0x11808a4 */
	0x8c045e21, 0x00000057, 	/* write array of size 2 from offset 87 to address 0x11808bc */
	0x8c046411, 0x00000006, 	/* write 6 zeros to address 0x11808c8 */
	0x8c0c0021, 0x0000005a, 	/* write array of size 64 from offset 90 to address 0x1181800 */
	0x00040003, 0xffff0002, 	/* if phase != 'pf', skip 4 ops */
	0x00030002, 0x002a0000, 	/* if mode != '!asic', skip 3 ops */
	0x8c03aa01, 0x00000040, 	/* write 0x40 to address 0x1180754 */
	0x8c03ba01, 0x00000008, 	/* write 0x8 to address 0x1180774 */
	0x8c03c801, 0x00000000, 	/* write 0x0 to address 0x1180790 */
	0x00020003, 0x00000002, 	/* if phase != 'pf0', skip 2 ops */
	0x8c048201, 0x00000000, 	/* write 0x0 to address 0x1180904 */
	0x8c048601, 0x00000000, 	/* write 0x0 to address 0x118090c */
	0x00020003, 0x00010002, 	/* if phase != 'pf1', skip 2 ops */
	0x8c048201, 0x00000008, 	/* write 0x8 to address 0x1180904 */
	0x8c048601, 0x00000008, 	/* write 0x8 to address 0x118090c */
	0x00020003, 0x00020002, 	/* if phase != 'pf2', skip 2 ops */
	0x8c048201, 0x00000010, 	/* write 0x10 to address 0x1180904 */
	0x8c048601, 0x00000010, 	/* write 0x10 to address 0x118090c */
	0x00020003, 0x00030002, 	/* if phase != 'pf3', skip 2 ops */
	0x8c048201, 0x00000018, 	/* write 0x18 to address 0x1180904 */
	0x8c048601, 0x00000018, 	/* write 0x18 to address 0x118090c */
	0x00020003, 0x00040002, 	/* if phase != 'pf4', skip 2 ops */
	0x8c048201, 0x00000020, 	/* write 0x20 to address 0x1180904 */
	0x8c048601, 0x00000020, 	/* write 0x20 to address 0x118090c */
	0x00020003, 0x00050002, 	/* if phase != 'pf5', skip 2 ops */
	0x8c048201, 0x00000028, 	/* write 0x28 to address 0x1180904 */
	0x8c048601, 0x00000028, 	/* write 0x28 to address 0x118090c */
	0x00020003, 0x00060002, 	/* if phase != 'pf6', skip 2 ops */
	0x8c048201, 0x00000030, 	/* write 0x30 to address 0x1180904 */
	0x8c048601, 0x00000030, 	/* write 0x30 to address 0x118090c */
	0x00020003, 0x00070002, 	/* if phase != 'pf7', skip 2 ops */
	0x8c048201, 0x00000038, 	/* write 0x38 to address 0x1180904 */
	0x8c048601, 0x00000038, 	/* write 0x38 to address 0x118090c */
	0x00030003, 0x00080002, 	/* if phase != 'pf8', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x8c048201, 0x00000040, 	/* write 0x40 to address 0x1180904 */
	0x8c048601, 0x00000040, 	/* write 0x40 to address 0x118090c */
	0x00030003, 0x00090002, 	/* if phase != 'pf9', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x8c048201, 0x00000048, 	/* write 0x48 to address 0x1180904 */
	0x8c048601, 0x00000048, 	/* write 0x48 to address 0x118090c */
	0x00030003, 0x000a0002, 	/* if phase != 'pf10', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x8c048201, 0x00000050, 	/* write 0x50 to address 0x1180904 */
	0x8c048601, 0x00000050, 	/* write 0x50 to address 0x118090c */
	0x00030003, 0x000b0002, 	/* if phase != 'pf11', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x8c048201, 0x00000058, 	/* write 0x58 to address 0x1180904 */
	0x8c048601, 0x00000058, 	/* write 0x58 to address 0x118090c */
	0x00030003, 0x000c0002, 	/* if phase != 'pf12', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x8c048201, 0x00000060, 	/* write 0x60 to address 0x1180904 */
	0x8c048601, 0x00000060, 	/* write 0x60 to address 0x118090c */
	0x00030003, 0x000d0002, 	/* if phase != 'pf13', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x8c048201, 0x00000068, 	/* write 0x68 to address 0x1180904 */
	0x8c048601, 0x00000068, 	/* write 0x68 to address 0x118090c */
	0x00030003, 0x000e0002, 	/* if phase != 'pf14', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x8c048201, 0x00000070, 	/* write 0x70 to address 0x1180904 */
	0x8c048601, 0x00000070, 	/* write 0x70 to address 0x118090c */
	0x00030003, 0x000f0002, 	/* if phase != 'pf15', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x8c048201, 0x00000078, 	/* write 0x78 to address 0x1180904 */
	0x8c048601, 0x00000078, 	/* write 0x78 to address 0x118090c */
	/* MCM */
	0x005e0003, 0xffff0000, 	/* if phase != 'engine', skip 94 ops */
	0x9000c201, 0x00000000, 	/* write 0x0 to address 0x1200184 */
	0x9000ca01, 0x00000000, 	/* write 0x0 to address 0x1200194 */
	0x9000d201, 0x00000000, 	/* write 0x0 to address 0x12001a4 */
	0x90010201, 0x00000000, 	/* write 0x0 to address 0x1200204 */
	0x90010a01, 0x00000000, 	/* write 0x0 to address 0x1200214 */
	0x900c0001, 0x00000000, 	/* write 0x0 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00000200, 	/* write 0x200 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00000400, 	/* write 0x400 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00000600, 	/* write 0x600 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00000800, 	/* write 0x800 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00000a00, 	/* write 0xa00 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00000c00, 	/* write 0xc00 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00000e00, 	/* write 0xe00 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00001000, 	/* write 0x1000 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00001200, 	/* write 0x1200 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00001400, 	/* write 0x1400 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00001600, 	/* write 0x1600 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00001800, 	/* write 0x1800 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00001a00, 	/* write 0x1a00 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00001c00, 	/* write 0x1c00 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00001e00, 	/* write 0x1e00 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00002000, 	/* write 0x2000 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00002200, 	/* write 0x2200 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00002400, 	/* write 0x2400 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00002600, 	/* write 0x2600 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00002800, 	/* write 0x2800 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00002a00, 	/* write 0x2a00 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00002c00, 	/* write 0x2c00 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00002e00, 	/* write 0x2e00 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00003000, 	/* write 0x3000 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00003200, 	/* write 0x3200 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00003400, 	/* write 0x3400 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00003600, 	/* write 0x3600 to address 0x1201800 */
	0x900c0801, 0x00000000, 	/* write 0x0 to address 0x1201810 */
	0x900c0001, 0x00000000, 	/* write 0x0 to address 0x1201800 */
	0x900c0401, 0x00000000, 	/* write 0x0 to address 0x1201808 */
	0x900c0001, 0x00000200, 	/* write 0x200 to address 0x1201800 */
	0x900c0401, 0x00000000, 	/* write 0x0 to address 0x1201808 */
	0x900c0001, 0x00000400, 	/* write 0x400 to address 0x1201800 */
	0x900c0401, 0x00000000, 	/* write 0x0 to address 0x1201808 */
	0x900c0001, 0x00000600, 	/* write 0x600 to address 0x1201800 */
	0x900c0401, 0x00000000, 	/* write 0x0 to address 0x1201808 */
	0x900c0001, 0x00000800, 	/* write 0x800 to address 0x1201800 */
	0x900c0401, 0x00000000, 	/* write 0x0 to address 0x1201808 */
	0x900c0001, 0x00000a00, 	/* write 0xa00 to address 0x1201800 */
	0x900c0401, 0x00000000, 	/* write 0x0 to address 0x1201808 */
	0x900c0001, 0x00000c00, 	/* write 0xc00 to address 0x1201800 */
	0x900c0401, 0x00000000, 	/* write 0x0 to address 0x1201808 */
	0x900c0001, 0x00000e00, 	/* write 0xe00 to address 0x1201800 */
	0x900c0401, 0x00000000, 	/* write 0x0 to address 0x1201808 */
	0x90020401, 0x0000006c, 	/* write 0x6c to address 0x1200408 */
	0x90021221, 0x00000072, 	/* write array of size 2 from offset 114 to address 0x1200424 */
	0x90022401, 0x00000001, 	/* write 0x1 to address 0x1200448 */
	0x90024221, 0x00000075, 	/* write array of size 3 from offset 117 to address 0x1200484 */
	0x90025001, 0x00000002, 	/* write 0x2 to address 0x12004a0 */
	0x90026211, 0x00000002, 	/* write 2 zeros to address 0x12004c4 */
	0x90027211, 0x00000002, 	/* write 2 zeros to address 0x12004e4 */
	0x90029401, 0x00000000, 	/* write 0x0 to address 0x1200528 */
	0x9002a211, 0x00000002, 	/* write 2 zeros to address 0x1200544 */
	0x9002b201, 0x00000006, 	/* write 0x6 to address 0x1200564 */
	0x90040a21, 0x00000079, 	/* write array of size 4 from offset 121 to address 0x1200814 */
	0x90041421, 0x0000007e, 	/* write array of size 5 from offset 126 to address 0x1200828 */
	0x90042021, 0x00000084, 	/* write array of size 5 from offset 132 to address 0x1200840 */
	0x90045411, 0x00000006, 	/* write 6 zeros to address 0x12008a8 */
	0x90046001, 0x00000001, 	/* write 0x1 to address 0x12008c0 */
	0x90046611, 0x00000004, 	/* write 4 zeros to address 0x12008cc */
	0x900e0021, 0x0000005a, 	/* write array of size 64 from offset 90 to address 0x1201c00 */
	0x00040003, 0xffff0002, 	/* if phase != 'pf', skip 4 ops */
	0x00030002, 0x002a0000, 	/* if mode != '!asic', skip 3 ops */
	0x9003aa01, 0x00000040, 	/* write 0x40 to address 0x1200754 */
	0x9003ba01, 0x00000008, 	/* write 0x8 to address 0x1200774 */
	0x9003c801, 0x00000000, 	/* write 0x0 to address 0x1200790 */
	0x00020003, 0x00000002, 	/* if phase != 'pf0', skip 2 ops */
	0x90048201, 0x00000001, 	/* write 0x1 to address 0x1200904 */
	0x90048601, 0x00000001, 	/* write 0x1 to address 0x120090c */
	0x00020003, 0x00010002, 	/* if phase != 'pf1', skip 2 ops */
	0x90048201, 0x00000009, 	/* write 0x9 to address 0x1200904 */
	0x90048601, 0x00000009, 	/* write 0x9 to address 0x120090c */
	0x00020003, 0x00020002, 	/* if phase != 'pf2', skip 2 ops */
	0x90048201, 0x00000011, 	/* write 0x11 to address 0x1200904 */
	0x90048601, 0x00000011, 	/* write 0x11 to address 0x120090c */
	0x00020003, 0x00030002, 	/* if phase != 'pf3', skip 2 ops */
	0x90048201, 0x00000019, 	/* write 0x19 to address 0x1200904 */
	0x90048601, 0x00000019, 	/* write 0x19 to address 0x120090c */
	0x00020003, 0x00040002, 	/* if phase != 'pf4', skip 2 ops */
	0x90048201, 0x00000021, 	/* write 0x21 to address 0x1200904 */
	0x90048601, 0x00000021, 	/* write 0x21 to address 0x120090c */
	0x00020003, 0x00050002, 	/* if phase != 'pf5', skip 2 ops */
	0x90048201, 0x00000029, 	/* write 0x29 to address 0x1200904 */
	0x90048601, 0x00000029, 	/* write 0x29 to address 0x120090c */
	0x00020003, 0x00060002, 	/* if phase != 'pf6', skip 2 ops */
	0x90048201, 0x00000031, 	/* write 0x31 to address 0x1200904 */
	0x90048601, 0x00000031, 	/* write 0x31 to address 0x120090c */
	0x00020003, 0x00070002, 	/* if phase != 'pf7', skip 2 ops */
	0x90048201, 0x00000039, 	/* write 0x39 to address 0x1200904 */
	0x90048601, 0x00000039, 	/* write 0x39 to address 0x120090c */
	0x00030003, 0x00080002, 	/* if phase != 'pf8', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x90048201, 0x00000041, 	/* write 0x41 to address 0x1200904 */
	0x90048601, 0x00000041, 	/* write 0x41 to address 0x120090c */
	0x00030003, 0x00090002, 	/* if phase != 'pf9', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x90048201, 0x00000049, 	/* write 0x49 to address 0x1200904 */
	0x90048601, 0x00000049, 	/* write 0x49 to address 0x120090c */
	0x00030003, 0x000a0002, 	/* if phase != 'pf10', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x90048201, 0x00000051, 	/* write 0x51 to address 0x1200904 */
	0x90048601, 0x00000051, 	/* write 0x51 to address 0x120090c */
	0x00030003, 0x000b0002, 	/* if phase != 'pf11', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x90048201, 0x00000059, 	/* write 0x59 to address 0x1200904 */
	0x90048601, 0x00000059, 	/* write 0x59 to address 0x120090c */
	0x00030003, 0x000c0002, 	/* if phase != 'pf12', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x90048201, 0x00000061, 	/* write 0x61 to address 0x1200904 */
	0x90048601, 0x00000061, 	/* write 0x61 to address 0x120090c */
	0x00030003, 0x000d0002, 	/* if phase != 'pf13', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x90048201, 0x00000069, 	/* write 0x69 to address 0x1200904 */
	0x90048601, 0x00000069, 	/* write 0x69 to address 0x120090c */
	0x00030003, 0x000e0002, 	/* if phase != 'pf14', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x90048201, 0x00000071, 	/* write 0x71 to address 0x1200904 */
	0x90048601, 0x00000071, 	/* write 0x71 to address 0x120090c */
	0x00030003, 0x000f0002, 	/* if phase != 'pf15', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x90048201, 0x00000079, 	/* write 0x79 to address 0x1200904 */
	0x90048601, 0x00000079, 	/* write 0x79 to address 0x120090c */
	/* UCM */
	0x004b0003, 0xffff0000, 	/* if phase != 'engine', skip 75 ops */
	0x9400c201, 0x00000000, 	/* write 0x0 to address 0x1280184 */
	0x9400ca01, 0x00000000, 	/* write 0x0 to address 0x1280194 */
	0x9400d201, 0x00000000, 	/* write 0x0 to address 0x12801a4 */
	0x94010201, 0x00000000, 	/* write 0x0 to address 0x1280204 */
	0x94010a01, 0x00000000, 	/* write 0x0 to address 0x1280214 */
	0x94032021, 0x0000008a, 	/* write array of size 2 from offset 138 to address 0x1280640 */
	0x940b8001, 0x00000000, 	/* write 0x0 to address 0x1281700 */
	0x940b8801, 0x00000000, 	/* write 0x0 to address 0x1281710 */
	0x940b8001, 0x00000200, 	/* write 0x200 to address 0x1281700 */
	0x940b8801, 0x00000000, 	/* write 0x0 to address 0x1281710 */
	0x940b8001, 0x00000400, 	/* write 0x400 to address 0x1281700 */
	0x940b8801, 0x00000000, 	/* write 0x0 to address 0x1281710 */
	0x940b8001, 0x00000600, 	/* write 0x600 to address 0x1281700 */
	0x940b8801, 0x00000000, 	/* write 0x0 to address 0x1281710 */
	0x940b8001, 0x00000800, 	/* write 0x800 to address 0x1281700 */
	0x940b8801, 0x00000000, 	/* write 0x0 to address 0x1281710 */
	0x940b8001, 0x00000a00, 	/* write 0xa00 to address 0x1281700 */
	0x940b8801, 0x00000000, 	/* write 0x0 to address 0x1281710 */
	0x940b8001, 0x00000c00, 	/* write 0xc00 to address 0x1281700 */
	0x940b8801, 0x00000000, 	/* write 0x0 to address 0x1281710 */
	0x940b8001, 0x00000e00, 	/* write 0xe00 to address 0x1281700 */
	0x940b8801, 0x00000000, 	/* write 0x0 to address 0x1281710 */
	0x940b8001, 0x00001000, 	/* write 0x1000 to address 0x1281700 */
	0x940b8801, 0x00000000, 	/* write 0x0 to address 0x1281710 */
	0x940b8001, 0x00001200, 	/* write 0x1200 to address 0x1281700 */
	0x940b8801, 0x00000000, 	/* write 0x0 to address 0x1281710 */
	0x940b8001, 0x00001400, 	/* write 0x1400 to address 0x1281700 */
	0x940b8801, 0x00000000, 	/* write 0x0 to address 0x1281710 */
	0x940b8001, 0x00001600, 	/* write 0x1600 to address 0x1281700 */
	0x940b8801, 0x00000000, 	/* write 0x0 to address 0x1281710 */
	0x940b8001, 0x00000000, 	/* write 0x0 to address 0x1281700 */
	0x940b8401, 0x00000000, 	/* write 0x0 to address 0x1281708 */
	0x940b8001, 0x00000200, 	/* write 0x200 to address 0x1281700 */
	0x940b8401, 0x00000000, 	/* write 0x0 to address 0x1281708 */
	0x940b8001, 0x00000400, 	/* write 0x400 to address 0x1281700 */
	0x940b8401, 0x00000000, 	/* write 0x0 to address 0x1281708 */
	0x940b8001, 0x00000600, 	/* write 0x600 to address 0x1281700 */
	0x940b8401, 0x00000000, 	/* write 0x0 to address 0x1281708 */
	0x940b8001, 0x00000800, 	/* write 0x800 to address 0x1281700 */
	0x940b8401, 0x00000000, 	/* write 0x0 to address 0x1281708 */
	0x940b8001, 0x00000a00, 	/* write 0xa00 to address 0x1281700 */
	0x940b8401, 0x00000000, 	/* write 0x0 to address 0x1281708 */
	0x940b8001, 0x00000c00, 	/* write 0xc00 to address 0x1281700 */
	0x940b8401, 0x00000000, 	/* write 0x0 to address 0x1281708 */
	0x940b8001, 0x00000e00, 	/* write 0xe00 to address 0x1281700 */
	0x940b8401, 0x00000000, 	/* write 0x0 to address 0x1281708 */
	0x940b8001, 0x00001000, 	/* write 0x1000 to address 0x1281700 */
	0x940b8401, 0x00000000, 	/* write 0x0 to address 0x1281708 */
	0x940b8001, 0x00001200, 	/* write 0x1200 to address 0x1281700 */
	0x940b8401, 0x00000000, 	/* write 0x0 to address 0x1281708 */
	0x940b8001, 0x00001400, 	/* write 0x1400 to address 0x1281700 */
	0x940b8401, 0x00000000, 	/* write 0x0 to address 0x1281708 */
	0x940b8001, 0x00001600, 	/* write 0x1600 to address 0x1281700 */
	0x940b8401, 0x00000000, 	/* write 0x0 to address 0x1281708 */
	0x94020201, 0x00000041, 	/* write 0x41 to address 0x1280404 */
	0x94020601, 0x00000082, 	/* write 0x82 to address 0x128040c */
	0x94020a21, 0x0000008d, 	/* write array of size 5 from offset 141 to address 0x1280414 */
	0x94021601, 0x00000083, 	/* write 0x83 to address 0x128042c */
	0x94022421, 0x00000093, 	/* write array of size 2 from offset 147 to address 0x1280448 */
	0x94022a21, 0x00000095, 	/* write array of size 4 from offset 149 to address 0x1280454 */
	0x94024221, 0x00000097, 	/* write array of size 3 from offset 151 to address 0x1280484 */
	0x94026a01, 0x00000000, 	/* write 0x0 to address 0x12804d4 */
	0x94027201, 0x00000000, 	/* write 0x0 to address 0x12804e4 */
	0x94028201, 0x00000000, 	/* write 0x0 to address 0x1280504 */
	0x94028c01, 0x00000000, 	/* write 0x0 to address 0x1280518 */
	0x9402b201, 0x00000007, 	/* write 0x7 to address 0x1280564 */
	0x9403a821, 0x0000009b, 	/* write array of size 2 from offset 155 to address 0x1280750 */
	0x9403bc01, 0x00000010, 	/* write 0x10 to address 0x1280778 */
	0x9403c201, 0x00000010, 	/* write 0x10 to address 0x1280784 */
	0x9403c801, 0x00000004, 	/* write 0x4 to address 0x1280790 */
	0x94040a21, 0x0000009e, 	/* write array of size 16 from offset 158 to address 0x1280814 */
	0x94045601, 0x00000000, 	/* write 0x0 to address 0x12808ac */
	0x94046201, 0x00000002, 	/* write 0x2 to address 0x12808c4 */
	0x94046611, 0x00000005, 	/* write 5 zeros to address 0x12808cc */
	0x940d8021, 0x0000005a, 	/* write array of size 64 from offset 90 to address 0x1281b00 */
	0x00020003, 0x00000002, 	/* if phase != 'pf0', skip 2 ops */
	0x94048201, 0x00000002, 	/* write 0x2 to address 0x1280904 */
	0x94048601, 0x00000002, 	/* write 0x2 to address 0x128090c */
	0x00020003, 0x00010002, 	/* if phase != 'pf1', skip 2 ops */
	0x94048201, 0x0000000a, 	/* write 0xa to address 0x1280904 */
	0x94048601, 0x0000000a, 	/* write 0xa to address 0x128090c */
	0x00020003, 0x00020002, 	/* if phase != 'pf2', skip 2 ops */
	0x94048201, 0x00000012, 	/* write 0x12 to address 0x1280904 */
	0x94048601, 0x00000012, 	/* write 0x12 to address 0x128090c */
	0x00020003, 0x00030002, 	/* if phase != 'pf3', skip 2 ops */
	0x94048201, 0x0000001a, 	/* write 0x1a to address 0x1280904 */
	0x94048601, 0x0000001a, 	/* write 0x1a to address 0x128090c */
	0x00020003, 0x00040002, 	/* if phase != 'pf4', skip 2 ops */
	0x94048201, 0x00000022, 	/* write 0x22 to address 0x1280904 */
	0x94048601, 0x00000022, 	/* write 0x22 to address 0x128090c */
	0x00020003, 0x00050002, 	/* if phase != 'pf5', skip 2 ops */
	0x94048201, 0x0000002a, 	/* write 0x2a to address 0x1280904 */
	0x94048601, 0x0000002a, 	/* write 0x2a to address 0x128090c */
	0x00020003, 0x00060002, 	/* if phase != 'pf6', skip 2 ops */
	0x94048201, 0x00000032, 	/* write 0x32 to address 0x1280904 */
	0x94048601, 0x00000032, 	/* write 0x32 to address 0x128090c */
	0x00020003, 0x00070002, 	/* if phase != 'pf7', skip 2 ops */
	0x94048201, 0x0000003a, 	/* write 0x3a to address 0x1280904 */
	0x94048601, 0x0000003a, 	/* write 0x3a to address 0x128090c */
	0x00030003, 0x00080002, 	/* if phase != 'pf8', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x94048201, 0x00000042, 	/* write 0x42 to address 0x1280904 */
	0x94048601, 0x00000042, 	/* write 0x42 to address 0x128090c */
	0x00030003, 0x00090002, 	/* if phase != 'pf9', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x94048201, 0x0000004a, 	/* write 0x4a to address 0x1280904 */
	0x94048601, 0x0000004a, 	/* write 0x4a to address 0x128090c */
	0x00030003, 0x000a0002, 	/* if phase != 'pf10', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x94048201, 0x00000052, 	/* write 0x52 to address 0x1280904 */
	0x94048601, 0x00000052, 	/* write 0x52 to address 0x128090c */
	0x00030003, 0x000b0002, 	/* if phase != 'pf11', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x94048201, 0x0000005a, 	/* write 0x5a to address 0x1280904 */
	0x94048601, 0x0000005a, 	/* write 0x5a to address 0x128090c */
	0x00030003, 0x000c0002, 	/* if phase != 'pf12', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x94048201, 0x00000062, 	/* write 0x62 to address 0x1280904 */
	0x94048601, 0x00000062, 	/* write 0x62 to address 0x128090c */
	0x00030003, 0x000d0002, 	/* if phase != 'pf13', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x94048201, 0x0000006a, 	/* write 0x6a to address 0x1280904 */
	0x94048601, 0x0000006a, 	/* write 0x6a to address 0x128090c */
	0x00030003, 0x000e0002, 	/* if phase != 'pf14', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x94048201, 0x00000072, 	/* write 0x72 to address 0x1280904 */
	0x94048601, 0x00000072, 	/* write 0x72 to address 0x128090c */
	0x00030003, 0x000f0002, 	/* if phase != 'pf15', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x94048201, 0x0000007a, 	/* write 0x7a to address 0x1280904 */
	0x94048601, 0x0000007a, 	/* write 0x7a to address 0x128090c */
	/* XCM */
	0x00110003, 0xffff0000, 	/* if phase != 'engine', skip 17 ops */
	0x8000c201, 0x00000000, 	/* write 0x0 to address 0x1000184 */
	0x8000ca01, 0x00000000, 	/* write 0x0 to address 0x1000194 */
	0x8000d201, 0x00000000, 	/* write 0x0 to address 0x10001a4 */
	0x00020002, 0x00020000, 	/* if mode != 'bb', skip 2 ops */
	0x80010201, 0x00000000, 	/* write 0x0 to address 0x1000204 */
	0x80010a01, 0x00000000, 	/* write 0x0 to address 0x1000214 */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x80010201, 0x00000000, 	/* write 0x0 to address 0x1000204 */
	0x80010a01, 0x00000000, 	/* write 0x0 to address 0x1000214 */
	0x80000201, 0x00000001, 	/* write 0x1 to address 0x1000004 */
	0x80020221, 0x000000af, 	/* write array of size 16 from offset 175 to address 0x1000404 */
	0x80026201, 0x0000000a, 	/* write 0xa to address 0x10004c4 */
	0x80040621, 0x000000c0, 	/* write array of size 8 from offset 192 to address 0x100080c */
	0x80042a21, 0x000000c9, 	/* write array of size 3 from offset 201 to address 0x1000854 */
	0x80043421, 0x000000cd, 	/* write array of size 3 from offset 205 to address 0x1000868 */
	0x800d8021, 0x000000d1, 	/* write array of size 64 from offset 209 to address 0x1001b00 */
	0x80000410, 0x00000001, 	/* wait until address 0x1000008 reads 0x1 */
	0x00010003, 0xffff0002, 	/* if phase != 'pf', skip 1 ops */
	0x80048231, 0x86a70001, 	/* write runtime array of size 1 from offset 34471 to address 0x1000904 */
	/* YCM */
	0x008c0003, 0xffff0000, 	/* if phase != 'engine', skip 140 ops */
	0x8400c201, 0x00000000, 	/* write 0x0 to address 0x1080184 */
	0x8400ca01, 0x00000000, 	/* write 0x0 to address 0x1080194 */
	0x8400d201, 0x00000000, 	/* write 0x0 to address 0x10801a4 */
	0x840c0001, 0x00000000, 	/* write 0x0 to address 0x1081800 */
	0x00020002, 0x00020000, 	/* if mode != 'bb', skip 2 ops */
	0x84010201, 0x00000000, 	/* write 0x0 to address 0x1080204 */
	0x84010a01, 0x00000000, 	/* write 0x0 to address 0x1080214 */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x84010201, 0x00000000, 	/* write 0x0 to address 0x1080204 */
	0x84010a01, 0x00000000, 	/* write 0x0 to address 0x1080214 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00000200, 	/* write 0x200 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00000400, 	/* write 0x400 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00000600, 	/* write 0x600 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00000800, 	/* write 0x800 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00000a00, 	/* write 0xa00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00000c00, 	/* write 0xc00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00000e00, 	/* write 0xe00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00001000, 	/* write 0x1000 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00001200, 	/* write 0x1200 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00001400, 	/* write 0x1400 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00001600, 	/* write 0x1600 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00001800, 	/* write 0x1800 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00001a00, 	/* write 0x1a00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00001c00, 	/* write 0x1c00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00001e00, 	/* write 0x1e00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00002000, 	/* write 0x2000 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00002200, 	/* write 0x2200 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00002400, 	/* write 0x2400 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00002600, 	/* write 0x2600 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00002800, 	/* write 0x2800 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00002a00, 	/* write 0x2a00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00002c00, 	/* write 0x2c00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00002e00, 	/* write 0x2e00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00003000, 	/* write 0x3000 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00003200, 	/* write 0x3200 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00003400, 	/* write 0x3400 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00003600, 	/* write 0x3600 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00003800, 	/* write 0x3800 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00003a00, 	/* write 0x3a00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00003c00, 	/* write 0x3c00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00003e00, 	/* write 0x3e00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00004000, 	/* write 0x4000 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00004200, 	/* write 0x4200 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00004400, 	/* write 0x4400 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00004600, 	/* write 0x4600 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00004800, 	/* write 0x4800 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00004a00, 	/* write 0x4a00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00004c00, 	/* write 0x4c00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00004e00, 	/* write 0x4e00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00005000, 	/* write 0x5000 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00005200, 	/* write 0x5200 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00005400, 	/* write 0x5400 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00005600, 	/* write 0x5600 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00005800, 	/* write 0x5800 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00005a00, 	/* write 0x5a00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00005c00, 	/* write 0x5c00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00005e00, 	/* write 0x5e00 to address 0x1081800 */
	0x840c0801, 0x00000000, 	/* write 0x0 to address 0x1081810 */
	0x840c0001, 0x00000000, 	/* write 0x0 to address 0x1081800 */
	0x840c0401, 0x00000000, 	/* write 0x0 to address 0x1081808 */
	0x840c0001, 0x00000200, 	/* write 0x200 to address 0x1081800 */
	0x840c0401, 0x00000000, 	/* write 0x0 to address 0x1081808 */
	0x840c0001, 0x00000400, 	/* write 0x400 to address 0x1081800 */
	0x840c0401, 0x00000000, 	/* write 0x0 to address 0x1081808 */
	0x840c0001, 0x00000600, 	/* write 0x600 to address 0x1081800 */
	0x840c0401, 0x00000000, 	/* write 0x0 to address 0x1081808 */
	0x840c0001, 0x00000800, 	/* write 0x800 to address 0x1081800 */
	0x840c0401, 0x00000000, 	/* write 0x0 to address 0x1081808 */
	0x840c0001, 0x00000a00, 	/* write 0xa00 to address 0x1081800 */
	0x840c0401, 0x00000000, 	/* write 0x0 to address 0x1081808 */
	0x840c0001, 0x00000c00, 	/* write 0xc00 to address 0x1081800 */
	0x840c0401, 0x00000000, 	/* write 0x0 to address 0x1081808 */
	0x840c0001, 0x00000e00, 	/* write 0xe00 to address 0x1081800 */
	0x840c0401, 0x00000000, 	/* write 0x0 to address 0x1081808 */
	0x84020a01, 0x00000011, 	/* write 0x11 to address 0x1080414 */
	0x84020e01, 0x00000021, 	/* write 0x21 to address 0x108041c */
	0x84022a01, 0x00000002, 	/* write 0x2 to address 0x1080454 */
	0x84022e01, 0x00000002, 	/* write 0x2 to address 0x108045c */
	0x84024221, 0x00000075, 	/* write array of size 3 from offset 117 to address 0x1080484 */
	0x84025001, 0x00000002, 	/* write 0x2 to address 0x10804a0 */
	0x84028a01, 0x00000000, 	/* write 0x0 to address 0x1080514 */
	0x84028e01, 0x00000006, 	/* write 0x6 to address 0x108051c */
	0x8402b201, 0x00000006, 	/* write 0x6 to address 0x1080564 */
	0x84040a01, 0x00000002, 	/* write 0x2 to address 0x1080814 */
	0x84040e21, 0x00000037, 	/* write array of size 2 from offset 55 to address 0x108081c */
	0x84041401, 0x00000001, 	/* write 0x1 to address 0x1080828 */
	0x84041a21, 0x000000ef, 	/* write array of size 2 from offset 239 to address 0x1080834 */
	0x84042021, 0x00000084, 	/* write array of size 5 from offset 132 to address 0x1080840 */
	0x84045801, 0x00000002, 	/* write 0x2 to address 0x10808b0 */
	0x84045c01, 0x00000002, 	/* write 0x2 to address 0x10808b8 */
	0x84046001, 0x00000001, 	/* write 0x1 to address 0x10808c0 */
	0x84046611, 0x00000004, 	/* write 4 zeros to address 0x10808cc */
	0x840e0021, 0x0000005a, 	/* write array of size 64 from offset 90 to address 0x1081c00 */
	0x00020003, 0x00000002, 	/* if phase != 'pf0', skip 2 ops */
	0x84048201, 0x00000003, 	/* write 0x3 to address 0x1080904 */
	0x84048601, 0x00000003, 	/* write 0x3 to address 0x108090c */
	0x00020003, 0x00010002, 	/* if phase != 'pf1', skip 2 ops */
	0x84048201, 0x0000000b, 	/* write 0xb to address 0x1080904 */
	0x84048601, 0x0000000b, 	/* write 0xb to address 0x108090c */
	0x00020003, 0x00020002, 	/* if phase != 'pf2', skip 2 ops */
	0x84048201, 0x00000013, 	/* write 0x13 to address 0x1080904 */
	0x84048601, 0x00000013, 	/* write 0x13 to address 0x108090c */
	0x00020003, 0x00030002, 	/* if phase != 'pf3', skip 2 ops */
	0x84048201, 0x0000001b, 	/* write 0x1b to address 0x1080904 */
	0x84048601, 0x0000001b, 	/* write 0x1b to address 0x108090c */
	0x00020003, 0x00040002, 	/* if phase != 'pf4', skip 2 ops */
	0x84048201, 0x00000023, 	/* write 0x23 to address 0x1080904 */
	0x84048601, 0x00000023, 	/* write 0x23 to address 0x108090c */
	0x00020003, 0x00050002, 	/* if phase != 'pf5', skip 2 ops */
	0x84048201, 0x0000002b, 	/* write 0x2b to address 0x1080904 */
	0x84048601, 0x0000002b, 	/* write 0x2b to address 0x108090c */
	0x00020003, 0x00060002, 	/* if phase != 'pf6', skip 2 ops */
	0x84048201, 0x00000033, 	/* write 0x33 to address 0x1080904 */
	0x84048601, 0x00000033, 	/* write 0x33 to address 0x108090c */
	0x00020003, 0x00070002, 	/* if phase != 'pf7', skip 2 ops */
	0x84048201, 0x0000003b, 	/* write 0x3b to address 0x1080904 */
	0x84048601, 0x0000003b, 	/* write 0x3b to address 0x108090c */
	0x00030003, 0x00080002, 	/* if phase != 'pf8', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x84048201, 0x00000043, 	/* write 0x43 to address 0x1080904 */
	0x84048601, 0x00000043, 	/* write 0x43 to address 0x108090c */
	0x00030003, 0x00090002, 	/* if phase != 'pf9', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x84048201, 0x0000004b, 	/* write 0x4b to address 0x1080904 */
	0x84048601, 0x0000004b, 	/* write 0x4b to address 0x108090c */
	0x00030003, 0x000a0002, 	/* if phase != 'pf10', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x84048201, 0x00000053, 	/* write 0x53 to address 0x1080904 */
	0x84048601, 0x00000053, 	/* write 0x53 to address 0x108090c */
	0x00030003, 0x000b0002, 	/* if phase != 'pf11', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x84048201, 0x0000005b, 	/* write 0x5b to address 0x1080904 */
	0x84048601, 0x0000005b, 	/* write 0x5b to address 0x108090c */
	0x00030003, 0x000c0002, 	/* if phase != 'pf12', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x84048201, 0x00000063, 	/* write 0x63 to address 0x1080904 */
	0x84048601, 0x00000063, 	/* write 0x63 to address 0x108090c */
	0x00030003, 0x000d0002, 	/* if phase != 'pf13', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x84048201, 0x0000006b, 	/* write 0x6b to address 0x1080904 */
	0x84048601, 0x0000006b, 	/* write 0x6b to address 0x108090c */
	0x00030003, 0x000e0002, 	/* if phase != 'pf14', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x84048201, 0x00000073, 	/* write 0x73 to address 0x1080904 */
	0x84048601, 0x00000073, 	/* write 0x73 to address 0x108090c */
	0x00030003, 0x000f0002, 	/* if phase != 'pf15', skip 3 ops */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x84048201, 0x0000007b, 	/* write 0x7b to address 0x1080904 */
	0x84048601, 0x0000007b, 	/* write 0x7b to address 0x108090c */
	/* PCM */
	0x000b0003, 0xffff0000, 	/* if phase != 'engine', skip 11 ops */
	0x8800c201, 0x00000000, 	/* write 0x0 to address 0x1100184 */
	0x8800ca01, 0x00000000, 	/* write 0x0 to address 0x1100194 */
	0x8800d201, 0x00000000, 	/* write 0x0 to address 0x11001a4 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x88010201, 0x00000000, 	/* write 0x0 to address 0x1100204 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x88010201, 0x00000000, 	/* write 0x0 to address 0x1100204 */
	0x88020201, 0x00000006, 	/* write 0x6 to address 0x1100404 */
	0x88040421, 0x000000f2, 	/* write array of size 4 from offset 242 to address 0x1100808 */
	0x88040e21, 0x000000f7, 	/* write array of size 3 from offset 247 to address 0x110081c */
	0x880b8021, 0x000000fb, 	/* write array of size 4 from offset 251 to address 0x1101700 */
	/* QM */
	0x00510003, 0xffff0000, 	/* if phase != 'engine', skip 81 ops */
	0x1780c201, 0x00000000, 	/* write 0x0 to address 0x2f0184 */
	0x1780ca01, 0x00000000, 	/* write 0x0 to address 0x2f0194 */
	0x17810201, 0x00000000, 	/* write 0x0 to address 0x2f0204 */
	0x17810a01, 0x00000000, 	/* write 0x0 to address 0x2f0214 */
	0x00020002, 0x00020000, 	/* if mode != 'bb', skip 2 ops */
	0x17811201, 0x00000000, 	/* write 0x0 to address 0x2f0224 */
	0x17ae9c01, 0x00000001, 	/* write 0x1 to address 0x2f5d38 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x17811201, 0x00000000, 	/* write 0x0 to address 0x2f0224 */
	0x17aebe01, 0x00000001, 	/* write 0x1 to address 0x2f5d7c */
	0x17aec010, 0x00000001, 	/* wait until address 0x2f5d80 reads 0x1 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x17c80011, 0x000001c0, 	/* write 448 zeros to address 0x2f9000 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x17c80011, 0x00000200, 	/* write 512 zeros to address 0x2f9000 */
	0x17a60031, 0x764d0001, 	/* write runtime array of size 1 from offset 30285 to address 0x2f4c00 */
	0x17a70031, 0x76800001, 	/* write runtime array of size 1 from offset 30336 to address 0x2f4e00 */
	0x17ae0031, 0x77420001, 	/* write runtime array of size 1 from offset 30530 to address 0x2f5c00 */
	0x17ae0a31, 0x77430001, 	/* write runtime array of size 1 from offset 30531 to address 0x2f5c14 */
	0x17889021, 0x00000100, 	/* write array of size 2 from offset 256 to address 0x2f1120 */
	0x1788a001, 0x00000078, 	/* write 0x78 to address 0x2f1140 */
	0x1788a401, 0x00000070, 	/* write 0x70 to address 0x2f1148 */
	0x1788a821, 0x00000103, 	/* write array of size 7 from offset 259 to address 0x2f1150 */
	0x1788ba21, 0x0000010b, 	/* write array of size 2 from offset 267 to address 0x2f1174 */
	0x1788c801, 0x00000030, 	/* write 0x30 to address 0x2f1190 */
	0x1788cc01, 0x00000007, 	/* write 0x7 to address 0x2f1198 */
	0x1788d021, 0x0000010d, 	/* write array of size 8 from offset 269 to address 0x2f11a0 */
	0x17891021, 0x00000116, 	/* write array of size 2 from offset 278 to address 0x2f1220 */
	0x17892001, 0x00000007, 	/* write 0x7 to address 0x2f1240 */
	0x17892401, 0x00000007, 	/* write 0x7 to address 0x2f1248 */
	0x17893201, 0x0000000e, 	/* write 0xe to address 0x2f1264 */
	0x17899021, 0x00000118, 	/* write array of size 2 from offset 280 to address 0x2f1320 */
	0x1789a001, 0x0000000a, 	/* write 0xa to address 0x2f1340 */
	0x1789a401, 0x0000000a, 	/* write 0xa to address 0x2f1348 */
	0x1789a821, 0x0000011a, 	/* write array of size 7 from offset 282 to address 0x2f1350 */
	0x1789ba21, 0x00000122, 	/* write array of size 2 from offset 290 to address 0x2f1374 */
	0x1789c801, 0x0000000a, 	/* write 0xa to address 0x2f1390 */
	0x1789cc01, 0x0000000a, 	/* write 0xa to address 0x2f1398 */
	0x1789d021, 0x00000124, 	/* write array of size 8 from offset 292 to address 0x2f13a0 */
	0x178a1021, 0x00000118, 	/* write array of size 2 from offset 280 to address 0x2f1420 */
	0x178a2001, 0x00000001, 	/* write 0x1 to address 0x2f1440 */
	0x178a2401, 0x00000001, 	/* write 0x1 to address 0x2f1448 */
	0x178a3201, 0x00000014, 	/* write 0x14 to address 0x2f1464 */
	0x178b4031, 0x72c20014, 	/* write runtime array of size 20 from offset 29378 to address 0x2f1680 */
	0x178b8001, 0x00000054, 	/* write 0x54 to address 0x2f1700 */
	0x178c4021, 0x00000126, 	/* write array of size 18 from offset 294 to address 0x2f1880 */
	0x178c8c31, 0x72d60004, 	/* write runtime array of size 4 from offset 29398 to address 0x2f1918 */
	0x178c9601, 0x000080a8, 	/* write 0x80a8 to address 0x2f192c */
	0x178c9a21, 0x00000128, 	/* write array of size 2 from offset 296 to address 0x2f1934 */
	0x178ca231, 0x72da0001, 	/* write runtime array of size 1 from offset 29402 to address 0x2f1944 */
	0x178ca421, 0x00000037, 	/* write array of size 2 from offset 55 to address 0x2f1948 */
	0x178cb431, 0x72db0008, 	/* write runtime array of size 8 from offset 29403 to address 0x2f1968 */
	0x178cf431, 0x72eb0004, 	/* write runtime array of size 4 from offset 29419 to address 0x2f19e8 */
	0x178d0431, 0x72ef0002, 	/* write runtime array of size 2 from offset 29423 to address 0x2f1a08 */
	0x17976c31, 0x73450008, 	/* write runtime array of size 8 from offset 29509 to address 0x2f2ed8 */
	0x179a0011, 0x00000100, 	/* write 256 zeros to address 0x2f3400 */
	0x17a70231, 0x76810001, 	/* write runtime array of size 1 from offset 30337 to address 0x2f4e04 */
	0x00030002, 0x00020000, 	/* if mode != 'bb', skip 3 ops */
	0x17a64011, 0x00000008, 	/* write 8 zeros to address 0x2f4c80 */
	0x17d00021, 0x0000012a, 	/* write array of size 448 from offset 298 to address 0x2fa000 */
	0x17d80021, 0x0000012c, 	/* write array of size 448 from offset 300 to address 0x2fb000 */
	0x00050002, 0x00150000, 	/* if mode != 'k2', skip 5 ops */
	0x178c6421, 0x0000012e, 	/* write array of size 2 from offset 302 to address 0x2f18c8 */
	0x178cc431, 0x72e30008, 	/* write runtime array of size 8 from offset 29411 to address 0x2f1988 */
	0x17a64011, 0x00000010, 	/* write 16 zeros to address 0x2f4c80 */
	0x17d00021, 0x00000130, 	/* write array of size 512 from offset 304 to address 0x2fa000 */
	0x17d80021, 0x00000132, 	/* write array of size 512 from offset 306 to address 0x2fb000 */
	0x00020002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 2 ops */
	0x17ae1e21, 0x00000134, 	/* write array of size 4 from offset 308 to address 0x2f5c3c */
	0x17ae5e21, 0x00000134, 	/* write array of size 4 from offset 308 to address 0x2f5cbc */
	0x17976431, 0x73410002, 	/* write runtime array of size 2 from offset 29505 to address 0x2f2ec8 */
	0x17a60e31, 0x764e0001, 	/* write runtime array of size 1 from offset 30286 to address 0x2f4c1c */
	0x178ac031, 0x72ae0014, 	/* write runtime array of size 20 from offset 29358 to address 0x2f1580 */
	0x178bc021, 0x00000126, 	/* write array of size 18 from offset 294 to address 0x2f1780 */
	0x17976831, 0x73430002, 	/* write runtime array of size 2 from offset 29507 to address 0x2f2ed0 */
	0x17a61031, 0x764f0001, 	/* write runtime array of size 1 from offset 30287 to address 0x2f4c20 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x178be421, 0x0000012e, 	/* write array of size 2 from offset 302 to address 0x2f17c8 */
	0x17960001, 0x00000001, 	/* write 0x1 to address 0x2f2c00 */
	0x17973201, 0x00000001, 	/* write 0x1 to address 0x2f2e64 */
	0x17960001, 0x00000000, 	/* write 0x0 to address 0x2f2c00 */
	0x000b0003, 0xffff0002, 	/* if phase != 'pf', skip 11 ops */
	0x178e1021, 0x00000139, 	/* write array of size 8 from offset 313 to address 0x2f1c20 */
	0x178e3021, 0x0000013b, 	/* write array of size 8 from offset 315 to address 0x2f1c60 */
	0x178e5021, 0x0000013d, 	/* write array of size 8 from offset 317 to address 0x2f1ca0 */
	0x178e7021, 0x0000013f, 	/* write array of size 8 from offset 319 to address 0x2f1ce0 */
	0x17975201, 0x00000001, 	/* write 0x1 to address 0x2f2ea4 */
	0x17975611, 0x00000002, 	/* write 2 zeros to address 0x2f2eac */
	0x00040002, 0x00150000, 	/* if mode != 'k2', skip 4 ops */
	0x17f81021, 0x00000139, 	/* write array of size 8 from offset 313 to address 0x2ff020 */
	0x17f83021, 0x0000013b, 	/* write array of size 8 from offset 315 to address 0x2ff060 */
	0x17f85021, 0x0000013d, 	/* write array of size 8 from offset 317 to address 0x2ff0a0 */
	0x17f87021, 0x0000013f, 	/* write array of size 8 from offset 319 to address 0x2ff0e0 */
	0x001a0003, 0xffff0004, 	/* if phase != 'qm_pf', skip 26 ops */
	0x17821a31, 0x70eb003b, 	/* write runtime array of size 59 from offset 28907 to address 0x2f0434 */
	0x17830031, 0x712e0080, 	/* write runtime array of size 128 from offset 28974 to address 0x2f0600 */
	0x17860131, 0x71ae0100, 	/* write runtime array of size 256 from offset 29102 to address 0x2f0c00 (WB) */
	0x17960231, 0x72f10038, 	/* write runtime array of size 56 from offset 29425 to address 0x2f2c04 */
	0x17970231, 0x73310008, 	/* write runtime array of size 8 from offset 29489 to address 0x2f2e04 */
	0x179a0031, 0x734d0100, 	/* write runtime array of size 256 from offset 29517 to address 0x2f3400 */
	0x179e0031, 0x744d0100, 	/* write runtime array of size 256 from offset 29773 to address 0x2f3c00 */
	0x17a64031, 0x76500010, 	/* write runtime array of size 16 from offset 30288 to address 0x2f4c80 */
	0x17a68031, 0x76600010, 	/* write runtime array of size 16 from offset 30304 to address 0x2f4d00 */
	0x17a74031, 0x76820010, 	/* write runtime array of size 16 from offset 30338 to address 0x2f4e80 */
	0x17a78031, 0x76920010, 	/* write runtime array of size 16 from offset 30354 to address 0x2f4f00 */
	0x17b00031, 0x77440200, 	/* write runtime array of size 512 from offset 30532 to address 0x2f6000 */
	0x17c80031, 0x79440200, 	/* write runtime array of size 512 from offset 31044 to address 0x2f9000 */
	0x17d00031, 0x7b440200, 	/* write runtime array of size 512 from offset 31556 to address 0x2fa000 */
	0x17e80031, 0x7f440200, 	/* write runtime array of size 512 from offset 32580 to address 0x2fd000 */
	0x17f00131, 0x81440400, 	/* write runtime array of size 1024 from offset 33092 to address 0x2fe000 (WB) */
	0x00030002, 0x00150000, 	/* if mode != 'k2', skip 3 ops */
	0x17829031, 0x71260008, 	/* write runtime array of size 8 from offset 28966 to address 0x2f0520 */
	0x17967231, 0x73290008, 	/* write runtime array of size 8 from offset 29481 to address 0x2f2ce4 */
	0x17971231, 0x73390008, 	/* write runtime array of size 8 from offset 29497 to address 0x2f2e24 */
	0x17a20031, 0x754d0100, 	/* write runtime array of size 256 from offset 30029 to address 0x2f4400 */
	0x17a6c031, 0x76700010, 	/* write runtime array of size 16 from offset 30320 to address 0x2f4d80 */
	0x17aa0031, 0x76a200a0, 	/* write runtime array of size 160 from offset 30370 to address 0x2f5400 */
	0x17e00031, 0x7d440200, 	/* write runtime array of size 512 from offset 32068 to address 0x2fc000 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x17fa0031, 0x854400a0, 	/* write runtime array of size 160 from offset 34116 to address 0x2ff400 */
	0x00020003, 0xffff0003, 	/* if phase != 'vf', skip 2 ops */
	0x17975401, 0x00000001, 	/* write 0x1 to address 0x2f2ea8 */
	0x17975a11, 0x00000002, 	/* write 2 zeros to address 0x2f2eb4 */
	/* TM */
	0x00140003, 0xffff0000, 	/* if phase != 'engine', skip 20 ops */
	0x000b0002, 0x00160000, 	/* if mode != '!fpga', skip 11 ops */
	0x16000001, 0x00000008, 	/* write 0x8 to address 0x2c0000 */
	0x1600c201, 0x00000000, 	/* write 0x0 to address 0x2c0184 */
	0x1600ca01, 0x00000060, 	/* write 0x60 to address 0x2c0194 */
	0x16010201, 0x00000000, 	/* write 0x0 to address 0x2c0204 */
	0x16025601, 0x00001415, 	/* write 0x1415 to address 0x2c04ac */
	0x16025a01, 0x00002420, 	/* write 0x2420 to address 0x2c04b4 */
	0x16026201, 0x00002411, 	/* write 0x2411 to address 0x2c04c4 */
	0x16000810, 0x00000001, 	/* wait until address 0x2c0010 reads 0x1 */
	0x16023021, 0x00000141, 	/* write array of size 2 from offset 321 to address 0x2c0460 */
	0x16024231, 0x6d490002, 	/* write runtime array of size 2 from offset 27977 to address 0x2c0484 */
	0x16024611, 0x00000002, 	/* write 2 zeros to address 0x2c048c */
	0x00010002, 0x00200000, 	/* if mode != '((emul_reduced|emul_full)&bb)&(!fpga)', skip 1 ops */
	0x16022401, 0x00000004, 	/* write 0x4 to address 0x2c0448 */
	0x00010002, 0x00100000, 	/* if mode != '((emul_reduced|emul_full)&k2)&(!fpga)', skip 1 ops */
	0x16022401, 0x0000000a, 	/* write 0xa to address 0x2c0448 */
	0x00030002, 0x00160000, 	/* if mode != '!fpga', skip 3 ops */
	0x16022601, 0x00000001, 	/* write 0x1 to address 0x2c044c */
	0x16022a01, 0x00000001, 	/* write 0x1 to address 0x2c0454 */
	0x16022e01, 0x00000001, 	/* write 0x1 to address 0x2c045c */
	0x00050003, 0xffff0002, 	/* if phase != 'pf', skip 5 ops */
	0x00040002, 0x00160000, 	/* if mode != '!fpga', skip 4 ops */
	0x16080131, 0x6d4b01a0, 	/* write runtime array of size 416 from offset 27979 to address 0x2c1000 (WB) */
	0x16100131, 0x6eeb0200, 	/* write runtime array of size 512 from offset 28395 to address 0x2c2000 (WB) */
	0x16021e31, 0x6d470001, 	/* write runtime array of size 1 from offset 27975 to address 0x2c043c */
	0x16022231, 0x6d480001, 	/* write runtime array of size 1 from offset 27976 to address 0x2c0444 */
	0x00030003, 0xffff0003, 	/* if phase != 'vf', skip 3 ops */
	0x00020002, 0x00160000, 	/* if mode != '!fpga', skip 2 ops */
	0x16080131, 0x6d4b01a0, 	/* write runtime array of size 416 from offset 27979 to address 0x2c1000 (WB) */
	0x16021c31, 0x6d460001, 	/* write runtime array of size 1 from offset 27974 to address 0x2c0438 */
	/* DORQ */
	0x001f0003, 0xffff0000, 	/* if phase != 'engine', skip 31 ops */
	0x0800c201, 0x00000008, 	/* write 0x8 to address 0x100184 */
	0x0800ca01, 0x00000000, 	/* write 0x0 to address 0x100194 */
	0x08010201, 0x00000000, 	/* write 0x0 to address 0x100204 */
	0x08038201, 0x00000001, 	/* write 0x1 to address 0x100704 */
	0x08041221, 0x00000032, 	/* write array of size 3 from offset 50 to address 0x100824 */
	0x08042201, 0x00001000, 	/* write 0x1000 to address 0x100844 */
	0x08045a11, 0x00000002, 	/* write 2 zeros to address 0x1008b4 */
	0x08046601, 0x000012b7, 	/* write 0x12b7 to address 0x1008cc */
	0x0804ee01, 0x00000600, 	/* write 0x600 to address 0x1009dc */
	0x08024401, 0x00000001, 	/* write 0x1 to address 0x100488 */
	0x08025401, 0x00000001, 	/* write 0x1 to address 0x1004a8 */
	0x08025e01, 0x00000000, 	/* write 0x0 to address 0x1004bc */
	0x08027401, 0x00000001, 	/* write 0x1 to address 0x1004e8 */
	0x08027801, 0x00000001, 	/* write 0x1 to address 0x1004f0 */
	0x08031621, 0x00000144, 	/* write array of size 2 from offset 324 to address 0x10062c */
	0x08032401, 0x00000002, 	/* write 0x2 to address 0x100648 */
	0x08032801, 0x00000020, 	/* write 0x20 to address 0x100650 */
	0x08033201, 0x00000018, 	/* write 0x18 to address 0x100664 */
	0x08033621, 0x00000147, 	/* write array of size 2 from offset 327 to address 0x10066c */
	0x08034621, 0x00000149, 	/* write array of size 2 from offset 329 to address 0x10068c */
	0x08034e21, 0x0000014c, 	/* write array of size 2 from offset 332 to address 0x10069c */
	0x08035401, 0x00000008, 	/* write 0x8 to address 0x1006a8 */
	0x08035801, 0x00000001, 	/* write 0x1 to address 0x1006b0 */
	0x08035e01, 0x00000014, 	/* write 0x14 to address 0x1006bc */
	0x08036221, 0x0000014f, 	/* write array of size 2 from offset 335 to address 0x1006c4 */
	0x08036801, 0x00000010, 	/* write 0x10 to address 0x1006d0 */
	0x08036e21, 0x00000152, 	/* write array of size 4 from offset 338 to address 0x1006dc */
	0x08039001, 0x00000008, 	/* write 0x8 to address 0x100720 */
	0x08040221, 0x00000157, 	/* write array of size 3 from offset 343 to address 0x100804 */
	0x08049001, 0x00000001, 	/* write 0x1 to address 0x100920 */
	0x08080011, 0x00000280, 	/* write 640 zeros to address 0x101000 */
	0x00060003, 0xffff0002, 	/* if phase != 'pf', skip 6 ops */
	0x08020431, 0x00000010, 	/* write runtime array of size 16 from offset 0 to address 0x100408 */
	0x08022631, 0x00100001, 	/* write runtime array of size 1 from offset 16 to address 0x10044c */
	0x08028231, 0x00110001, 	/* write runtime array of size 1 from offset 17 to address 0x100504 */
	0x08028821, 0x00000037, 	/* write array of size 2 from offset 55 to address 0x100510 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00040003, 0x00000002, 	/* if phase != 'pf0', skip 4 ops */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00040003, 0x00010002, 	/* if phase != 'pf1', skip 4 ops */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000001, 	/* write 0x1 to address 0x100500 */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000001, 	/* write 0x1 to address 0x100500 */
	0x00040003, 0x00020002, 	/* if phase != 'pf2', skip 4 ops */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000002, 	/* write 0x2 to address 0x100500 */
	0x00040003, 0x00030002, 	/* if phase != 'pf3', skip 4 ops */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000001, 	/* write 0x1 to address 0x100500 */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000003, 	/* write 0x3 to address 0x100500 */
	0x00040003, 0x00040002, 	/* if phase != 'pf4', skip 4 ops */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00040003, 0x00050002, 	/* if phase != 'pf5', skip 4 ops */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000001, 	/* write 0x1 to address 0x100500 */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000001, 	/* write 0x1 to address 0x100500 */
	0x00040003, 0x00060002, 	/* if phase != 'pf6', skip 4 ops */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000002, 	/* write 0x2 to address 0x100500 */
	0x00040003, 0x00070002, 	/* if phase != 'pf7', skip 4 ops */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000001, 	/* write 0x1 to address 0x100500 */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000003, 	/* write 0x3 to address 0x100500 */
	0x00040003, 0x00080002, 	/* if phase != 'pf8', skip 4 ops */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00010002, 0x00f60000, 	/* if mode != 'k2&ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00040003, 0x00090002, 	/* if phase != 'pf9', skip 4 ops */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000001, 	/* write 0x1 to address 0x100500 */
	0x00010002, 0x00f60000, 	/* if mode != 'k2&ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000001, 	/* write 0x1 to address 0x100500 */
	0x00040003, 0x000a0002, 	/* if phase != 'pf10', skip 4 ops */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000002, 	/* write 0x2 to address 0x100500 */
	0x00010002, 0x00f60000, 	/* if mode != 'k2&ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00040003, 0x000b0002, 	/* if phase != 'pf11', skip 4 ops */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000003, 	/* write 0x3 to address 0x100500 */
	0x00010002, 0x00f60000, 	/* if mode != 'k2&ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000001, 	/* write 0x1 to address 0x100500 */
	0x00040003, 0x000c0002, 	/* if phase != 'pf12', skip 4 ops */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00010002, 0x00f60000, 	/* if mode != 'k2&ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00040003, 0x000d0002, 	/* if phase != 'pf13', skip 4 ops */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000001, 	/* write 0x1 to address 0x100500 */
	0x00010002, 0x00f60000, 	/* if mode != 'k2&ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000001, 	/* write 0x1 to address 0x100500 */
	0x00040003, 0x000e0002, 	/* if phase != 'pf14', skip 4 ops */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000002, 	/* write 0x2 to address 0x100500 */
	0x00010002, 0x00f60000, 	/* if mode != 'k2&ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000000, 	/* write 0x0 to address 0x100500 */
	0x00040003, 0x000f0002, 	/* if phase != 'pf15', skip 4 ops */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x08028001, 0x00000003, 	/* write 0x3 to address 0x100500 */
	0x00010002, 0x00f60000, 	/* if mode != 'k2&ports_per_eng_2', skip 1 ops */
	0x08028001, 0x00000001, 	/* write 0x1 to address 0x100500 */
	0x00010003, 0xffff0002, 	/* if phase != 'pf', skip 1 ops */
	0x08028401, 0x00000001, 	/* write 0x1 to address 0x100508 */
	0x00010003, 0xffff0001, 	/* if phase != 'port', skip 1 ops */
	0x08044231, 0x00120001, 	/* write runtime array of size 1 from offset 18 to address 0x100884 */
	0x00010003, 0xffff0003, 	/* if phase != 'vf', skip 1 ops */
	0x08028601, 0x00000001, 	/* write 0x1 to address 0x10050c */
	/* BRB */
	0x012a0003, 0xffff0000, 	/* if phase != 'engine', skip 298 ops */
	0x1a006201, 0x00000000, 	/* write 0x0 to address 0x3400c4 */
	0x1a006e01, 0x00000000, 	/* write 0x0 to address 0x3400dc */
	0x1a007a01, 0x00000000, 	/* write 0x0 to address 0x3400f4 */
	0x1a008601, 0x00000000, 	/* write 0x0 to address 0x34010c */
	0x1a009201, 0x00200000, 	/* write 0x200000 to address 0x340124 */
	0x1a009e01, 0x00000000, 	/* write 0x0 to address 0x34013c */
	0x1a00aa01, 0x00000000, 	/* write 0x0 to address 0x340154 */
	0x1a00b601, 0x00000000, 	/* write 0x0 to address 0x34016c */
	0x1a00c401, 0x00000000, 	/* write 0x0 to address 0x340188 */
	0x1a00d001, 0x00000000, 	/* write 0x0 to address 0x3401a0 */
	0x1a00e801, 0x00000000, 	/* write 0x0 to address 0x3401d0 */
	0x1a00f001, 0x00000000, 	/* write 0x0 to address 0x3401e0 */
	0x00090002, 0x00020000, 	/* if mode != 'bb', skip 9 ops */
	0x1a00dc01, 0x00000000, 	/* write 0x0 to address 0x3401b8 */
	0x1a020201, 0x00000000, 	/* write 0x0 to address 0x340404 */
	0x1a020a01, 0x00000000, 	/* write 0x0 to address 0x340414 */
	0x1a052a01, 0x00000000, 	/* write 0x0 to address 0x340a54 */
	0x1a055a01, 0x00000000, 	/* write 0x0 to address 0x340ab4 */
	0x1a059601, 0x00000000, 	/* write 0x0 to address 0x340b2c */
	0x1a05c601, 0x00000000, 	/* write 0x0 to address 0x340b8c */
	0x1a063401, 0x00000070, 	/* write 0x70 to address 0x340c68 */
	0x1a064001, 0x00000070, 	/* write 0x70 to address 0x340c80 */
	0x001f0002, 0x00150000, 	/* if mode != 'k2', skip 31 ops */
	0x1a00dc01, 0x04000000, 	/* write 0x4000000 to address 0x3401b8 */
	0x1a020201, 0x00000000, 	/* write 0x0 to address 0x340404 */
	0x1a020a01, 0x00000000, 	/* write 0x0 to address 0x340414 */
	0x1a052a01, 0x00000000, 	/* write 0x0 to address 0x340a54 */
	0x1a052e01, 0x00000000, 	/* write 0x0 to address 0x340a5c */
	0x1a053201, 0x00000000, 	/* write 0x0 to address 0x340a64 */
	0x1a053601, 0x00000000, 	/* write 0x0 to address 0x340a6c */
	0x1a053a01, 0x00000000, 	/* write 0x0 to address 0x340a74 */
	0x1a053e01, 0x00000000, 	/* write 0x0 to address 0x340a7c */
	0x1a054201, 0x00000000, 	/* write 0x0 to address 0x340a84 */
	0x1a054601, 0x00000000, 	/* write 0x0 to address 0x340a8c */
	0x1a055a01, 0x00000000, 	/* write 0x0 to address 0x340ab4 */
	0x1a055e01, 0x00000000, 	/* write 0x0 to address 0x340abc */
	0x1a056401, 0x00000000, 	/* write 0x0 to address 0x340ac8 */
	0x1a057201, 0x00000000, 	/* write 0x0 to address 0x340ae4 */
	0x1a057801, 0x00000000, 	/* write 0x0 to address 0x340af0 */
	0x1a057c01, 0x00000000, 	/* write 0x0 to address 0x340af8 */
	0x1a059601, 0x00000000, 	/* write 0x0 to address 0x340b2c */
	0x1a059a01, 0x00000000, 	/* write 0x0 to address 0x340b34 */
	0x1a059e01, 0x00000000, 	/* write 0x0 to address 0x340b3c */
	0x1a05a201, 0x00000000, 	/* write 0x0 to address 0x340b44 */
	0x1a05a601, 0x00000000, 	/* write 0x0 to address 0x340b4c */
	0x1a05aa01, 0x00000000, 	/* write 0x0 to address 0x340b54 */
	0x1a05ae01, 0x00000000, 	/* write 0x0 to address 0x340b5c */
	0x1a05b201, 0x00000000, 	/* write 0x0 to address 0x340b64 */
	0x1a05c601, 0x00000000, 	/* write 0x0 to address 0x340b8c */
	0x1a05ca01, 0x00000000, 	/* write 0x0 to address 0x340b94 */
	0x1a05d001, 0x00000000, 	/* write 0x0 to address 0x340ba0 */
	0x1a05de01, 0x00000000, 	/* write 0x0 to address 0x340bbc */
	0x1a05e401, 0x00000000, 	/* write 0x0 to address 0x340bc8 */
	0x1a05e801, 0x00000000, 	/* write 0x0 to address 0x340bd0 */
	0x003d0002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 61 ops */
	0x1a044021, 0x0000015b, 	/* write array of size 4 from offset 347 to address 0x340880 */
	0x1a048021, 0x0000015d, 	/* write array of size 3 from offset 349 to address 0x340900 */
	0x1a048a21, 0x0000015d, 	/* write array of size 3 from offset 349 to address 0x340914 */
	0x1a049421, 0x0000015d, 	/* write array of size 3 from offset 349 to address 0x340928 */
	0x1a049e21, 0x0000015d, 	/* write array of size 3 from offset 349 to address 0x34093c */
	0x1a04bc21, 0x00000161, 	/* write array of size 3 from offset 353 to address 0x340978 */
	0x1a04c421, 0x00000161, 	/* write array of size 3 from offset 353 to address 0x340988 */
	0x1a04cc21, 0x00000161, 	/* write array of size 3 from offset 353 to address 0x340998 */
	0x1a04d421, 0x00000161, 	/* write array of size 3 from offset 353 to address 0x3409a8 */
	0x1a04ec21, 0x00000161, 	/* write array of size 3 from offset 353 to address 0x3409d8 */
	0x1a04f621, 0x00000161, 	/* write array of size 3 from offset 353 to address 0x3409ec */
	0x1a050021, 0x00000161, 	/* write array of size 3 from offset 353 to address 0x340a00 */
	0x1a050a21, 0x00000161, 	/* write array of size 3 from offset 353 to address 0x340a14 */
	0x1a052801, 0x00000360, 	/* write 0x360 to address 0x340a50 */
	0x1a052c01, 0x00000360, 	/* write 0x360 to address 0x340a58 */
	0x1a053001, 0x00000360, 	/* write 0x360 to address 0x340a60 */
	0x1a053401, 0x00000360, 	/* write 0x360 to address 0x340a68 */
	0x1a053801, 0x00000360, 	/* write 0x360 to address 0x340a70 */
	0x1a053c01, 0x00000360, 	/* write 0x360 to address 0x340a78 */
	0x1a054001, 0x00000360, 	/* write 0x360 to address 0x340a80 */
	0x1a054401, 0x00000360, 	/* write 0x360 to address 0x340a88 */
	0x1a055801, 0x00000360, 	/* write 0x360 to address 0x340ab0 */
	0x1a055c01, 0x00000360, 	/* write 0x360 to address 0x340ab8 */
	0x1a056021, 0x00000165, 	/* write array of size 2 from offset 357 to address 0x340ac0 */
	0x1a056621, 0x00000167, 	/* write array of size 6 from offset 359 to address 0x340acc */
	0x1a057421, 0x00000165, 	/* write array of size 2 from offset 357 to address 0x340ae8 */
	0x1a057a01, 0x00000360, 	/* write 0x360 to address 0x340af4 */
	0x1a057e01, 0x00000360, 	/* write 0x360 to address 0x340afc */
	0x1a059401, 0x00000400, 	/* write 0x400 to address 0x340b28 */
	0x1a059801, 0x00000400, 	/* write 0x400 to address 0x340b30 */
	0x1a059c01, 0x00000400, 	/* write 0x400 to address 0x340b38 */
	0x1a05a001, 0x00000400, 	/* write 0x400 to address 0x340b40 */
	0x1a05a401, 0x00000400, 	/* write 0x400 to address 0x340b48 */
	0x1a05a801, 0x00000400, 	/* write 0x400 to address 0x340b50 */
	0x1a05ac01, 0x00000400, 	/* write 0x400 to address 0x340b58 */
	0x1a05b001, 0x00000400, 	/* write 0x400 to address 0x340b60 */
	0x1a05c401, 0x00000400, 	/* write 0x400 to address 0x340b88 */
	0x1a05c801, 0x00000400, 	/* write 0x400 to address 0x340b90 */
	0x1a05cc21, 0x0000016e, 	/* write array of size 2 from offset 366 to address 0x340b98 */
	0x1a05d221, 0x00000170, 	/* write array of size 6 from offset 368 to address 0x340ba4 */
	0x1a05e021, 0x0000016e, 	/* write array of size 2 from offset 366 to address 0x340bc0 */
	0x1a05e601, 0x00000400, 	/* write 0x400 to address 0x340bcc */
	0x1a05ea01, 0x00000400, 	/* write 0x400 to address 0x340bd4 */
	0x1a060021, 0x00000177, 	/* write array of size 3 from offset 375 to address 0x340c00 */
	0x1a060821, 0x00000177, 	/* write array of size 3 from offset 375 to address 0x340c10 */
	0x1a061021, 0x00000177, 	/* write array of size 3 from offset 375 to address 0x340c20 */
	0x1a061821, 0x00000177, 	/* write array of size 3 from offset 375 to address 0x340c30 */
	0x1a063021, 0x0000017b, 	/* write array of size 3 from offset 379 to address 0x340c60 */
	0x1a063821, 0x0000017f, 	/* write array of size 4 from offset 383 to address 0x340c70 */
	0x1a064221, 0x0000017f, 	/* write array of size 4 from offset 383 to address 0x340c84 */
	0x1a064c21, 0x0000017f, 	/* write array of size 4 from offset 383 to address 0x340c98 */
	0x1a065601, 0x00000058, 	/* write 0x58 to address 0x340cac */
	0x1a066c21, 0x00000184, 	/* write array of size 3 from offset 388 to address 0x340cd8 */
	0x1a067421, 0x00000184, 	/* write array of size 3 from offset 388 to address 0x340ce8 */
	0x1a067c21, 0x00000184, 	/* write array of size 3 from offset 388 to address 0x340cf8 */
	0x1a068421, 0x00000184, 	/* write array of size 3 from offset 388 to address 0x340d08 */
	0x1a069c21, 0x00000188, 	/* write array of size 3 from offset 392 to address 0x340d38 */
	0x1a06a421, 0x0000018c, 	/* write array of size 4 from offset 396 to address 0x340d48 */
	0x1a06ae21, 0x0000018c, 	/* write array of size 4 from offset 396 to address 0x340d5c */
	0x1a06b821, 0x0000018c, 	/* write array of size 4 from offset 396 to address 0x340d70 */
	0x1a06c201, 0x000000f8, 	/* write 0xf8 to address 0x340d84 */
	0x001e0002, 0x00090000, 	/* if mode != 'bb&(!100g)&ports_per_eng_1', skip 30 ops */
	0x1a044021, 0x00000191, 	/* write array of size 2 from offset 401 to address 0x340880 */
	0x1a046021, 0x00000194, 	/* write array of size 2 from offset 404 to address 0x3408c0 */
	0x1a048021, 0x00000197, 	/* write array of size 3 from offset 407 to address 0x340900 */
	0x1a04a201, 0x00000000, 	/* write 0x0 to address 0x340944 */
	0x1a04c001, 0x000000a0, 	/* write 0xa0 to address 0x340980 */
	0x1a04f001, 0x000000a0, 	/* write 0xa0 to address 0x3409e0 */
	0x1a052801, 0x00000738, 	/* write 0x738 to address 0x340a50 */
	0x1a052c01, 0x00000738, 	/* write 0x738 to address 0x340a58 */
	0x1a053801, 0x000012c1, 	/* write 0x12c1 to address 0x340a70 */
	0x1a055801, 0x00000738, 	/* write 0x738 to address 0x340ab0 */
	0x1a055c01, 0x00000738, 	/* write 0x738 to address 0x340ab8 */
	0x1a056821, 0x0000019b, 	/* write array of size 2 from offset 411 to address 0x340ad0 */
	0x1a057a01, 0x000012c1, 	/* write 0x12c1 to address 0x340af4 */
	0x1a059401, 0x000007d8, 	/* write 0x7d8 to address 0x340b28 */
	0x1a059801, 0x000007d8, 	/* write 0x7d8 to address 0x340b30 */
	0x1a05a401, 0x000012c1, 	/* write 0x12c1 to address 0x340b48 */
	0x1a05c401, 0x000007d8, 	/* write 0x7d8 to address 0x340b88 */
	0x1a05c801, 0x000007d8, 	/* write 0x7d8 to address 0x340b90 */
	0x1a05d421, 0x0000019e, 	/* write array of size 2 from offset 414 to address 0x340ba8 */
	0x1a05e601, 0x000012c1, 	/* write 0x12c1 to address 0x340bcc */
	0x1a060201, 0x00000738, 	/* write 0x738 to address 0x340c04 */
	0x1a061021, 0x000001a1, 	/* write array of size 2 from offset 417 to address 0x340c20 */
	0x1a063201, 0x00000738, 	/* write 0x738 to address 0x340c64 */
	0x1a064221, 0x000001a1, 	/* write array of size 2 from offset 417 to address 0x340c84 */
	0x1a065201, 0x000012c1, 	/* write 0x12c1 to address 0x340ca4 */
	0x1a066e01, 0x000007d8, 	/* write 0x7d8 to address 0x340cdc */
	0x1a067c21, 0x000001a1, 	/* write array of size 2 from offset 417 to address 0x340cf8 */
	0x1a069e01, 0x000007d8, 	/* write 0x7d8 to address 0x340d3c */
	0x1a06ae21, 0x000001a1, 	/* write array of size 2 from offset 417 to address 0x340d5c */
	0x1a06be01, 0x000012c1, 	/* write 0x12c1 to address 0x340d7c */
	0x00210002, 0x00010000, 	/* if mode != 'bb&(!100g)&ports_per_eng_2', skip 33 ops */
	0x1a044021, 0x000001a3, 	/* write array of size 2 from offset 419 to address 0x340880 */
	0x1a046021, 0x000001a5, 	/* write array of size 2 from offset 421 to address 0x3408c0 */
	0x1a048021, 0x000001a7, 	/* write array of size 3 from offset 423 to address 0x340900 */
	0x1a049221, 0x000001a7, 	/* write array of size 3 from offset 423 to address 0x340924 */
	0x1a04c001, 0x00000050, 	/* write 0x50 to address 0x340980 */
	0x1a04cc21, 0x000001ab, 	/* write array of size 3 from offset 427 to address 0x340998 */
	0x1a04f001, 0x00000050, 	/* write 0x50 to address 0x3409e0 */
	0x1a04fe21, 0x000001ab, 	/* write array of size 3 from offset 427 to address 0x3409fc */
	0x1a050e01, 0x00000018, 	/* write 0x18 to address 0x340a1c */
	0x1a052801, 0x000003c8, 	/* write 0x3c8 to address 0x340a50 */
	0x1a052c01, 0x000003c8, 	/* write 0x3c8 to address 0x340a58 */
	0x1a053821, 0x000001af, 	/* write array of size 3 from offset 431 to address 0x340a70 */
	0x1a055801, 0x000003c8, 	/* write 0x3c8 to address 0x340ab0 */
	0x1a055c01, 0x000003c8, 	/* write 0x3c8 to address 0x340ab8 */
	0x1a056821, 0x000001b3, 	/* write array of size 4 from offset 435 to address 0x340ad0 */
	0x1a057a01, 0x000003c8, 	/* write 0x3c8 to address 0x340af4 */
	0x1a059401, 0x00000468, 	/* write 0x468 to address 0x340b28 */
	0x1a059801, 0x00000468, 	/* write 0x468 to address 0x340b30 */
	0x1a05a421, 0x000001b8, 	/* write array of size 3 from offset 440 to address 0x340b48 */
	0x1a05c401, 0x00000468, 	/* write 0x468 to address 0x340b88 */
	0x1a05c801, 0x00000468, 	/* write 0x468 to address 0x340b90 */
	0x1a05d421, 0x000001bc, 	/* write array of size 4 from offset 444 to address 0x340ba8 */
	0x1a05e601, 0x00000468, 	/* write 0x468 to address 0x340bcc */
	0x1a060201, 0x000003c8, 	/* write 0x3c8 to address 0x340c04 */
	0x1a061021, 0x000001c1, 	/* write array of size 3 from offset 449 to address 0x340c20 */
	0x1a063201, 0x000003c8, 	/* write 0x3c8 to address 0x340c64 */
	0x1a064221, 0x000001c5, 	/* write array of size 3 from offset 453 to address 0x340c84 */
	0x1a065201, 0x00000070, 	/* write 0x70 to address 0x340ca4 */
	0x1a066e01, 0x00000468, 	/* write 0x468 to address 0x340cdc */
	0x1a067c21, 0x000001c9, 	/* write array of size 3 from offset 457 to address 0x340cf8 */
	0x1a069e01, 0x00000468, 	/* write 0x468 to address 0x340d3c */
	0x1a06ae21, 0x000001cd, 	/* write array of size 3 from offset 461 to address 0x340d5c */
	0x1a06be01, 0x00000110, 	/* write 0x110 to address 0x340d7c */
	0x00220002, 0x00a80000, 	/* if mode != 'bb&100g', skip 34 ops */
	0x1a044021, 0x000001d1, 	/* write array of size 2 from offset 465 to address 0x340880 */
	0x1a046021, 0x000001d4, 	/* write array of size 2 from offset 468 to address 0x3408c0 */
	0x1a048021, 0x000001d7, 	/* write array of size 3 from offset 471 to address 0x340900 */
	0x1a049001, 0x00000010, 	/* write 0x10 to address 0x340920 */
	0x1a04bc21, 0x000001db, 	/* write array of size 3 from offset 475 to address 0x340978 */
	0x1a04ec21, 0x000001db, 	/* write array of size 3 from offset 475 to address 0x3409d8 */
	0x1a04fc01, 0x0000000c, 	/* write 0xc to address 0x3409f8 */
	0x1a050e01, 0x00000000, 	/* write 0x0 to address 0x340a1c */
	0x1a052801, 0x000003f4, 	/* write 0x3f4 to address 0x340a50 */
	0x1a052c01, 0x000003f4, 	/* write 0x3f4 to address 0x340a58 */
	0x1a053801, 0x000012c1, 	/* write 0x12c1 to address 0x340a70 */
	0x1a055801, 0x000003f4, 	/* write 0x3f4 to address 0x340ab0 */
	0x1a055c01, 0x000003f4, 	/* write 0x3f4 to address 0x340ab8 */
	0x1a056821, 0x000001dd, 	/* write array of size 2 from offset 477 to address 0x340ad0 */
	0x1a057a01, 0x000012c1, 	/* write 0x12c1 to address 0x340af4 */
	0x1a059401, 0x00000444, 	/* write 0x444 to address 0x340b28 */
	0x1a059801, 0x00000444, 	/* write 0x444 to address 0x340b30 */
	0x1a05a401, 0x000012c1, 	/* write 0x12c1 to address 0x340b48 */
	0x1a05c401, 0x00000444, 	/* write 0x444 to address 0x340b88 */
	0x1a05c801, 0x00000444, 	/* write 0x444 to address 0x340b90 */
	0x1a05d421, 0x000001e0, 	/* write array of size 2 from offset 480 to address 0x340ba8 */
	0x1a05e601, 0x000012c1, 	/* write 0x12c1 to address 0x340bcc */
	0x1a060021, 0x000001e3, 	/* write array of size 3 from offset 483 to address 0x340c00 */
	0x1a061021, 0x000001a1, 	/* write array of size 2 from offset 417 to address 0x340c20 */
	0x1a063021, 0x000001e7, 	/* write array of size 2 from offset 487 to address 0x340c60 */
	0x1a064221, 0x000001a1, 	/* write array of size 2 from offset 417 to address 0x340c84 */
	0x1a065201, 0x000012c1, 	/* write 0x12c1 to address 0x340ca4 */
	0x1a066c21, 0x000001ea, 	/* write array of size 3 from offset 490 to address 0x340cd8 */
	0x1a067c21, 0x000001a1, 	/* write array of size 2 from offset 417 to address 0x340cf8 */
	0x1a069c21, 0x000001ee, 	/* write array of size 3 from offset 494 to address 0x340d38 */
	0x1a06ac21, 0x000001f2, 	/* write array of size 3 from offset 498 to address 0x340d58 */
	0x1a06be01, 0x000012c1, 	/* write 0x12c1 to address 0x340d7c */
	0x1a070c01, 0x0000000c, 	/* write 0xc to address 0x340e18 */
	0x1a071601, 0x00000005, 	/* write 0x5 to address 0x340e2c */
	0x00400002, 0x003e0000, 	/* if mode != 'k2&(!ports_per_eng_4)', skip 64 ops */
	0x1a044021, 0x000001f6, 	/* write array of size 4 from offset 502 to address 0x340880 */
	0x1a046021, 0x000001fb, 	/* write array of size 4 from offset 507 to address 0x3408c0 */
	0x1a048021, 0x00000200, 	/* write array of size 3 from offset 512 to address 0x340900 */
	0x1a048801, 0x00000000, 	/* write 0x0 to address 0x340910 */
	0x1a049021, 0x00000204, 	/* write array of size 4 from offset 516 to address 0x340920 */
	0x1a049c01, 0x00000000, 	/* write 0x0 to address 0x340938 */
	0x1a04a201, 0x00000010, 	/* write 0x10 to address 0x340944 */
	0x1a04a601, 0x00000000, 	/* write 0x0 to address 0x34094c */
	0x1a04bc21, 0x00000209, 	/* write array of size 3 from offset 521 to address 0x340978 */
	0x1a04cc21, 0x00000209, 	/* write array of size 3 from offset 521 to address 0x340998 */
	0x1a04ec21, 0x00000209, 	/* write array of size 3 from offset 521 to address 0x3409d8 */
	0x1a04f401, 0x00000000, 	/* write 0x0 to address 0x3409e8 */
	0x1a04fc21, 0x0000020d, 	/* write array of size 4 from offset 525 to address 0x3409f8 */
	0x1a050801, 0x00000000, 	/* write 0x0 to address 0x340a10 */
	0x1a050e01, 0x00000008, 	/* write 0x8 to address 0x340a1c */
	0x1a051201, 0x00000000, 	/* write 0x0 to address 0x340a24 */
	0x1a052801, 0x0000029c, 	/* write 0x29c to address 0x340a50 */
	0x1a052c01, 0x0000029c, 	/* write 0x29c to address 0x340a58 */
	0x1a053001, 0x00000000, 	/* write 0x0 to address 0x340a60 */
	0x1a053401, 0x00000000, 	/* write 0x0 to address 0x340a68 */
	0x1a053801, 0x0000029c, 	/* write 0x29c to address 0x340a70 */
	0x1a053c01, 0x0000029c, 	/* write 0x29c to address 0x340a78 */
	0x1a054001, 0x00000000, 	/* write 0x0 to address 0x340a80 */
	0x1a054401, 0x00000000, 	/* write 0x0 to address 0x340a88 */
	0x1a055801, 0x0000029c, 	/* write 0x29c to address 0x340ab0 */
	0x1a055c01, 0x0000029c, 	/* write 0x29c to address 0x340ab8 */
	0x1a056011, 0x00000002, 	/* write 2 zeros to address 0x340ac0 */
	0x1a056621, 0x00000212, 	/* write array of size 6 from offset 530 to address 0x340acc */
	0x1a057411, 0x00000002, 	/* write 2 zeros to address 0x340ae8 */
	0x1a057a01, 0x0000029c, 	/* write 0x29c to address 0x340af4 */
	0x1a057e01, 0x00000000, 	/* write 0x0 to address 0x340afc */
	0x1a059401, 0x000002ec, 	/* write 0x2ec to address 0x340b28 */
	0x1a059801, 0x000002ec, 	/* write 0x2ec to address 0x340b30 */
	0x1a059c01, 0x00000000, 	/* write 0x0 to address 0x340b38 */
	0x1a05a001, 0x00000000, 	/* write 0x0 to address 0x340b40 */
	0x1a05a401, 0x000002ec, 	/* write 0x2ec to address 0x340b48 */
	0x1a05a801, 0x000002ec, 	/* write 0x2ec to address 0x340b50 */
	0x1a05ac01, 0x00000000, 	/* write 0x0 to address 0x340b58 */
	0x1a05b001, 0x00000000, 	/* write 0x0 to address 0x340b60 */
	0x1a05c401, 0x000002ec, 	/* write 0x2ec to address 0x340b88 */
	0x1a05c801, 0x000002ec, 	/* write 0x2ec to address 0x340b90 */
	0x1a05cc11, 0x00000002, 	/* write 2 zeros to address 0x340b98 */
	0x1a05d221, 0x00000219, 	/* write array of size 6 from offset 537 to address 0x340ba4 */
	0x1a05e011, 0x00000002, 	/* write 2 zeros to address 0x340bc0 */
	0x1a05e601, 0x000002ec, 	/* write 0x2ec to address 0x340bcc */
	0x1a05ea01, 0x00000000, 	/* write 0x0 to address 0x340bd4 */
	0x1a060021, 0x00000220, 	/* write array of size 3 from offset 544 to address 0x340c00 */
	0x1a060821, 0x00000224, 	/* write array of size 2 from offset 548 to address 0x340c10 */
	0x1a061021, 0x00000220, 	/* write array of size 3 from offset 544 to address 0x340c20 */
	0x1a061821, 0x00000224, 	/* write array of size 2 from offset 548 to address 0x340c30 */
	0x1a063021, 0x00000226, 	/* write array of size 3 from offset 550 to address 0x340c60 */
	0x1a063821, 0x0000022a, 	/* write array of size 3 from offset 554 to address 0x340c70 */
	0x1a064021, 0x0000022c, 	/* write array of size 4 from offset 556 to address 0x340c80 */
	0x1a064c21, 0x00000231, 	/* write array of size 4 from offset 561 to address 0x340c98 */
	0x1a065601, 0x00001e01, 	/* write 0x1e01 to address 0x340cac */
	0x1a066c21, 0x00000236, 	/* write array of size 3 from offset 566 to address 0x340cd8 */
	0x1a067421, 0x00000224, 	/* write array of size 2 from offset 548 to address 0x340ce8 */
	0x1a067c21, 0x00000236, 	/* write array of size 3 from offset 566 to address 0x340cf8 */
	0x1a068421, 0x00000224, 	/* write array of size 2 from offset 548 to address 0x340d08 */
	0x1a069c21, 0x0000023a, 	/* write array of size 3 from offset 570 to address 0x340d38 */
	0x1a06a421, 0x0000022a, 	/* write array of size 3 from offset 554 to address 0x340d48 */
	0x1a06ac21, 0x0000023e, 	/* write array of size 4 from offset 574 to address 0x340d58 */
	0x1a06b821, 0x00000243, 	/* write array of size 4 from offset 579 to address 0x340d70 */
	0x1a06c201, 0x00001e01, 	/* write 0x1e01 to address 0x340d84 */
	0x000b0002, 0x00730000, 	/* if mode != 'bb&(!100g)', skip 11 ops */
	0x1a04bc21, 0x00000248, 	/* write array of size 2 from offset 584 to address 0x340978 */
	0x1a04ec21, 0x00000248, 	/* write array of size 2 from offset 584 to address 0x3409d8 */
	0x1a04fc01, 0x00000018, 	/* write 0x18 to address 0x3409f8 */
	0x1a060001, 0x000000f8, 	/* write 0xf8 to address 0x340c00 */
	0x1a060401, 0x000000f8, 	/* write 0xf8 to address 0x340c08 */
	0x1a063001, 0x000000f8, 	/* write 0xf8 to address 0x340c60 */
	0x1a066c01, 0x00000198, 	/* write 0x198 to address 0x340cd8 */
	0x1a067001, 0x00000198, 	/* write 0x198 to address 0x340ce0 */
	0x1a069c01, 0x00000198, 	/* write 0x198 to address 0x340d38 */
	0x1a06a001, 0x00000110, 	/* write 0x110 to address 0x340d40 */
	0x1a06ac01, 0x00000110, 	/* write 0x110 to address 0x340d58 */
	0x1a000201, 0x00000003, 	/* write 0x3 to address 0x340004 */
	0x1a042001, 0x000000e1, 	/* write 0xe1 to address 0x340840 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x1a040201, 0x00000014, 	/* write 0x14 to address 0x340804 */
	0x1a000410, 0x00000003, 	/* wait until address 0x340008 reads 0x3 */
	/* SRC */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x00010002, 0x00160000, 	/* if mode != '!fpga', skip 1 ops */
	0x11c0f201, 0x00000000, 	/* write 0x0 to address 0x2381e4 */
	0x00050003, 0xffff0002, 	/* if phase != 'pf', skip 5 ops */
	0x00040002, 0x00160000, 	/* if mode != '!fpga', skip 4 ops */
	0x11c28131, 0x172a0002, 	/* write runtime array of size 2 from offset 5930 to address 0x238500 (WB) */
	0x11c29131, 0x172c0002, 	/* write runtime array of size 2 from offset 5932 to address 0x238520 (WB) */
	0x11c2a031, 0x172e0001, 	/* write runtime array of size 1 from offset 5934 to address 0x238540 */
	0x11c30231, 0x172f0001, 	/* write runtime array of size 1 from offset 5935 to address 0x238604 */
	/* PRS */
	0x00240003, 0xffff0000, 	/* if phase != 'engine', skip 36 ops */
	0x0f800201, 0x00000001, 	/* write 0x1 to address 0x1f0004 */
	0x0f800621, 0x00000037, 	/* write array of size 2 from offset 55 to address 0x1f000c */
	0x0f802201, 0x00000000, 	/* write 0x0 to address 0x1f0044 */
	0x0f802a01, 0x00000000, 	/* write 0x0 to address 0x1f0054 */
	0x0f808021, 0x0000024a, 	/* write array of size 3 from offset 586 to address 0x1f0100 */
	0x0f808821, 0x0000024e, 	/* write array of size 5 from offset 590 to address 0x1f0110 */
	0x0f809a21, 0x00000254, 	/* write array of size 2 from offset 596 to address 0x1f0134 */
	0x0f80a021, 0x00000257, 	/* write array of size 4 from offset 599 to address 0x1f0140 */
	0x0f80aa21, 0x0000025c, 	/* write array of size 5 from offset 604 to address 0x1f0154 */
	0x0f80bc21, 0x00000262, 	/* write array of size 5 from offset 610 to address 0x1f0178 */
	0x0f83a631, 0x17280001, 	/* write runtime array of size 1 from offset 5928 to address 0x1f074c */
	0x0f843801, 0x000012b7, 	/* write 0x12b7 to address 0x1f0870 */
	0x0f848021, 0x00000268, 	/* write array of size 8 from offset 616 to address 0x1f0900 */
	0x0f849221, 0x00000271, 	/* write array of size 7 from offset 625 to address 0x1f0924 */
	0x0f84a801, 0x00008915, 	/* write 0x8915 to address 0x1f0950 */
	0x0f84ba21, 0x00000279, 	/* write array of size 3 from offset 633 to address 0x1f0974 */
	0x0f84c201, 0xfffffe50, 	/* write 0xfffffe50 to address 0x1f0984 */
	0x0f84c601, 0xfffff690, 	/* write 0xfffff690 to address 0x1f098c */
	0x0f84ce01, 0xffff4910, 	/* write 0xffff4910 to address 0x1f099c */
	0x0f84d201, 0xfffff810, 	/* write 0xfffff810 to address 0x1f09a4 */
	0x0f84d601, 0xffffff10, 	/* write 0xffffff10 to address 0x1f09ac */
	0x0f84da01, 0xfffff690, 	/* write 0xfffff690 to address 0x1f09b4 */
	0x0f84e001, 0x0000304a, 	/* write 0x304a to address 0x1f09c0 */
	0x0f84e421, 0x0000027d, 	/* write array of size 2 from offset 637 to address 0x1f09c8 */
	0x0f888011, 0x0000001f, 	/* write 31 zeros to address 0x1f1100 */
	0x0f88e201, 0x00000004, 	/* write 0x4 to address 0x1f11c4 */
	0x00020002, 0x00020000, 	/* if mode != 'bb', skip 2 ops */
	0x0f810401, 0x00000000, 	/* write 0x0 to address 0x1f0208 */
	0x0f810c01, 0x00000000, 	/* write 0x0 to address 0x1f0218 */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x0f810401, 0x00000000, 	/* write 0x0 to address 0x1f0208 */
	0x0f810c01, 0x00000000, 	/* write 0x0 to address 0x1f0218 */
	0x00010002, 0x00390000, 	/* if mode != 'mf_sd', skip 1 ops */
	0x0f83b201, 0x00000001, 	/* write 0x1 to address 0x1f0764 */
	0x0f80b231, 0x171a0001, 	/* write runtime array of size 1 from offset 5914 to address 0x1f0164 */
	0x0f800410, 0x00000001, 	/* wait until address 0x1f0008 reads 0x1 */
	0x000b0003, 0xffff0002, 	/* if phase != 'pf', skip 11 ops */
	0x0f80b431, 0x171b0004, 	/* write runtime array of size 4 from offset 5915 to address 0x1f0168 */
	0x0f80c801, 0x00000001, 	/* write 0x1 to address 0x1f0190 */
	0x0f820031, 0x171f0001, 	/* write runtime array of size 1 from offset 5919 to address 0x1f0400 */
	0x0f820201, 0x00000000, 	/* write 0x0 to address 0x1f0404 */
	0x0f820431, 0x17200002, 	/* write runtime array of size 2 from offset 5920 to address 0x1f0408 */
	0x0f821631, 0x17220006, 	/* write runtime array of size 6 from offset 5922 to address 0x1f042c */
	0x0f822201, 0x00000001, 	/* write 0x1 to address 0x1f0444 */
	0x0f84b431, 0x17290001, 	/* write runtime array of size 1 from offset 5929 to address 0x1f0968 */
	0x0f84b601, 0x00000000, 	/* write 0x0 to address 0x1f096c */
	0x0f84fe01, 0x00000000, 	/* write 0x0 to address 0x1f09fc */
	0x0f88de01, 0x00000000, 	/* write 0x0 to address 0x1f11bc */
	0x00010003, 0x00000002, 	/* if phase != 'pf0', skip 1 ops */
	0x0f84a401, 0xff000000, 	/* write 0xff000000 to address 0x1f0948 */
	0x00010003, 0x00010002, 	/* if phase != 'pf1', skip 1 ops */
	0x0f84a401, 0xff100000, 	/* write 0xff100000 to address 0x1f0948 */
	0x00010003, 0x00020002, 	/* if phase != 'pf2', skip 1 ops */
	0x0f84a401, 0xff200000, 	/* write 0xff200000 to address 0x1f0948 */
	0x00010003, 0x00030002, 	/* if phase != 'pf3', skip 1 ops */
	0x0f84a401, 0xff300000, 	/* write 0xff300000 to address 0x1f0948 */
	0x00010003, 0x00040002, 	/* if phase != 'pf4', skip 1 ops */
	0x0f84a401, 0xff400000, 	/* write 0xff400000 to address 0x1f0948 */
	0x00010003, 0x00050002, 	/* if phase != 'pf5', skip 1 ops */
	0x0f84a401, 0xff500000, 	/* write 0xff500000 to address 0x1f0948 */
	0x00010003, 0x00060002, 	/* if phase != 'pf6', skip 1 ops */
	0x0f84a401, 0xff600000, 	/* write 0xff600000 to address 0x1f0948 */
	0x00010003, 0x00070002, 	/* if phase != 'pf7', skip 1 ops */
	0x0f84a401, 0xff700000, 	/* write 0xff700000 to address 0x1f0948 */
	0x00020003, 0x00080002, 	/* if phase != 'pf8', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x0f84a401, 0xff800000, 	/* write 0xff800000 to address 0x1f0948 */
	0x00020003, 0x00090002, 	/* if phase != 'pf9', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x0f84a401, 0xff900000, 	/* write 0xff900000 to address 0x1f0948 */
	0x00020003, 0x000a0002, 	/* if phase != 'pf10', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x0f84a401, 0xffa00000, 	/* write 0xffa00000 to address 0x1f0948 */
	0x00020003, 0x000b0002, 	/* if phase != 'pf11', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x0f84a401, 0xffb00000, 	/* write 0xffb00000 to address 0x1f0948 */
	0x00020003, 0x000c0002, 	/* if phase != 'pf12', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x0f84a401, 0xffc00000, 	/* write 0xffc00000 to address 0x1f0948 */
	0x00020003, 0x000d0002, 	/* if phase != 'pf13', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x0f84a401, 0xffd00000, 	/* write 0xffd00000 to address 0x1f0948 */
	0x00020003, 0x000e0002, 	/* if phase != 'pf14', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x0f84a401, 0xffe00000, 	/* write 0xffe00000 to address 0x1f0948 */
	0x00020003, 0x000f0002, 	/* if phase != 'pf15', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x0f84a401, 0xfff00000, 	/* write 0xfff00000 to address 0x1f0948 */
	0x00110003, 0xffff0001, 	/* if phase != 'port', skip 17 ops */
	0x0f839801, 0x00000000, 	/* write 0x0 to address 0x1f0730 */
	0x0f839c01, 0x000012b5, 	/* write 0x12b5 to address 0x1f0738 */
	0x0f83c201, 0x00000080, 	/* write 0x80 to address 0x1f0784 */
	0x0f83ce21, 0x00000280, 	/* write array of size 3 from offset 640 to address 0x1f079c */
	0x0f83dc01, 0x00000000, 	/* write 0x0 to address 0x1f07b8 */
	0x0f843601, 0x000017c1, 	/* write 0x17c1 to address 0x1f086c */
	0x0f843a21, 0x00000284, 	/* write array of size 2 from offset 644 to address 0x1f0874 */
	0x00020002, 0x00390000, 	/* if mode != 'mf_sd', skip 2 ops */
	0x0f83be21, 0x00000287, 	/* write array of size 2 from offset 647 to address 0x1f077c */
	0x0f83cc01, 0x00000001, 	/* write 0x1 to address 0x1f0798 */
	0x00010002, 0x00b40000, 	/* if mode != 'mf_si', skip 1 ops */
	0x0f851001, 0x00000001, 	/* write 0x1 to address 0x1f0a20 */
	0x00020002, 0x00b20000, 	/* if mode != 'sf|mf_si', skip 2 ops */
	0x0f83be21, 0x0000028a, 	/* write array of size 2 from offset 650 to address 0x1f077c */
	0x0f83cc01, 0x00000000, 	/* write 0x0 to address 0x1f0798 */
	0x00010002, 0x00ed0000, 	/* if mode != '!mf_si', skip 1 ops */
	0x0f851001, 0x00000003, 	/* write 0x3 to address 0x1f0a20 */
	/* TSDM */
	0x00060003, 0xffff0000, 	/* if phase != 'engine', skip 6 ops */
	0x7d802201, 0x00000000, 	/* write 0x0 to address 0xfb0044 */
	0x7d810201, 0x00000000, 	/* write 0x0 to address 0xfb0204 */
	0x7d820001, 0x00000018, 	/* write 0x18 to address 0xfb0400 */
	0x7d820801, 0x00000641, 	/* write 0x641 to address 0xfb0410 */
	0x7d840401, 0x0000031b, 	/* write 0x31b to address 0xfb0808 */
	0x7d840c21, 0x0000028d, 	/* write array of size 2 from offset 653 to address 0xfb0818 */
	/* MSDM */
	0x00050003, 0xffff0000, 	/* if phase != 'engine', skip 5 ops */
	0x7e002201, 0x00000000, 	/* write 0x0 to address 0xfc0044 */
	0x7e010201, 0x00000000, 	/* write 0x0 to address 0xfc0204 */
	0x7e020001, 0x00000018, 	/* write 0x18 to address 0xfc0400 */
	0x7e020801, 0x00000769, 	/* write 0x769 to address 0xfc0410 */
	0x7e041021, 0x00000290, 	/* write array of size 2 from offset 656 to address 0xfc0820 */
	/* USDM */
	0x00060003, 0xffff0000, 	/* if phase != 'engine', skip 6 ops */
	0x7e802201, 0x00000000, 	/* write 0x0 to address 0xfd0044 */
	0x7e810201, 0x00000000, 	/* write 0x0 to address 0xfd0204 */
	0x7e820001, 0x00000018, 	/* write 0x18 to address 0xfd0400 */
	0x7e820801, 0x00000fea, 	/* write 0xfea to address 0xfd0410 */
	0x7e840401, 0x00000305, 	/* write 0x305 to address 0xfd0808 */
	0x7e840c21, 0x00000293, 	/* write array of size 2 from offset 659 to address 0xfd0818 */
	/* XSDM */
	0x00060003, 0xffff0000, 	/* if phase != 'engine', skip 6 ops */
	0x7c002201, 0x00000000, 	/* write 0x0 to address 0xf80044 */
	0x7c010201, 0x00000000, 	/* write 0x0 to address 0xf80204 */
	0x7c020001, 0x00000018, 	/* write 0x18 to address 0xf80400 */
	0x7c020821, 0x00000296, 	/* write array of size 2 from offset 662 to address 0xf80410 */
	0x7c040021, 0x00000299, 	/* write array of size 3 from offset 665 to address 0xf80800 */
	0x7c041c01, 0x00000309, 	/* write 0x309 to address 0xf80838 */
	/* YSDM */
	0x00050003, 0xffff0000, 	/* if phase != 'engine', skip 5 ops */
	0x7c802201, 0x00000000, 	/* write 0x0 to address 0xf90044 */
	0x7c810201, 0x00000000, 	/* write 0x0 to address 0xf90204 */
	0x7c820001, 0x00000018, 	/* write 0x18 to address 0xf90400 */
	0x7c820801, 0x000007c7, 	/* write 0x7c7 to address 0xf90410 */
	0x7c840821, 0x0000029d, 	/* write array of size 5 from offset 669 to address 0xf90810 */
	/* PSDM */
	0x00050003, 0xffff0000, 	/* if phase != 'engine', skip 5 ops */
	0x7d002201, 0x00000000, 	/* write 0x0 to address 0xfa0044 */
	0x7d010201, 0x00000000, 	/* write 0x0 to address 0xfa0204 */
	0x7d020001, 0x00000018, 	/* write 0x18 to address 0xfa0400 */
	0x7d020801, 0x0000088f, 	/* write 0x88f to address 0xfa0410 */
	0x7d040801, 0x00000305, 	/* write 0x305 to address 0xfa0810 */
	/* TSEM */
	0x00630003, 0xffff0000, 	/* if phase != 'engine', skip 99 ops */
	0xb8002201, 0x00000000, 	/* write 0x0 to address 0x1700044 */
	0xb8002a01, 0x00000000, 	/* write 0x0 to address 0x1700054 */
	0xb8006601, 0x00000000, 	/* write 0x0 to address 0x17000cc */
	0xb8010201, 0x00000000, 	/* write 0x0 to address 0x1700204 */
	0xb9000111, 0x000010e0, 	/* write 4320 zeros to address 0x1720000 (WB) */
	0xba002201, 0x00000000, 	/* write 0x0 to address 0x1740044 */
	0xba025001, 0x00000007, 	/* write 0x7 to address 0x17404a0 */
	0xba032c01, 0x00000001, 	/* write 0x1 to address 0x1740658 */
	0xba03a421, 0x000002a3, 	/* write array of size 3 from offset 675 to address 0x1740748 */
	0xba052401, 0x00001fff, 	/* write 0x1fff to address 0x1740a48 */
	0xbb000011, 0x00005000, 	/* write 20480 zeros to address 0x1760000 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0xba010201, 0x00000000, 	/* write 0x0 to address 0x1740204 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0xba025c01, 0x00000000, 	/* write 0x0 to address 0x17404b8 */
	0x00010002, 0x00410000, 	/* if mode != 'ports_per_eng_4', skip 1 ops */
	0xba025c01, 0x00000002, 	/* write 0x2 to address 0x17404b8 */
	0x00020002, 0x00160000, 	/* if mode != '!fpga', skip 2 ops */
	0xba501e01, 0x00000007, 	/* write 0x7 to address 0x174a03c */
	0xba510201, 0x00000000, 	/* write 0x0 to address 0x174a204 */
	0xbb000021, 0x000002a7, 	/* write array of size 6 from offset 679 to address 0x1760000 */
	0xbb18b201, 0x00000000, 	/* write 0x0 to address 0x1763164 */
	0xbb21ac21, 0x000002ae, 	/* write array of size 6 from offset 686 to address 0x1764358 */
	0xbb21b811, 0x0000000a, 	/* write 10 zeros to address 0x1764370 */
	0xbb220c21, 0x000002b5, 	/* write array of size 2 from offset 693 to address 0x1764418 */
	0xbb225021, 0x000002b8, 	/* write array of size 2 from offset 696 to address 0x17644a0 */
	0xbb549421, 0x000002bb, 	/* write array of size 2 from offset 699 to address 0x176a928 */
	0xbb54a021, 0x000002be, 	/* write array of size 1022 from offset 702 to address 0x176a940 */
	0xbb63d421, 0x000006bd, 	/* write array of size 1 from offset 1725 to address 0x176c7a8 */
	0xbb63d611, 0x00000019, 	/* write 25 zeros to address 0x176c7ac */
	0xbb67d421, 0x000006bf, 	/* write array of size 65 from offset 1727 to address 0x176cfa8 */
	0xbb685621, 0x00000701, 	/* write array of size 6 from offset 1793 to address 0x176d0ac */
	0xbb686221, 0x00000703, 	/* write array of size 9 from offset 1795 to address 0x176d0c4 */
	0xbb72f421, 0x0000070d, 	/* write array of size 2 from offset 1805 to address 0x176e5e8 */
	0xbb864c21, 0x0000070f, 	/* write array of size 4 from offset 1807 to address 0x1770c98 */
	0xbb9fb421, 0x00000714, 	/* write array of size 26 from offset 1812 to address 0x1773f68 */
	0xbb9ffc21, 0x0000072f, 	/* write array of size 2 from offset 1839 to address 0x1773ff8 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0xbb18aa01, 0x00000002, 	/* write 0x2 to address 0x1763154 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0xbb18aa01, 0x00000003, 	/* write 0x3 to address 0x1763154 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb18ac01, 0x00000002, 	/* write 0x2 to address 0x1763158 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0xbb18ae01, 0x00000000, 	/* write 0x0 to address 0x176315c */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0xbb18ae01, 0x00000001, 	/* write 0x1 to address 0x176315c */
	0x00010002, 0x00410000, 	/* if mode != 'ports_per_eng_4', skip 1 ops */
	0xbb18ae01, 0x00000002, 	/* write 0x2 to address 0x176315c */
	0x00010002, 0x00c00000, 	/* if mode != 'asic|chipsim|emul_full', skip 1 ops */
	0xbb18ac01, 0x00000003, 	/* write 0x3 to address 0x1763158 */
	0xba032e10, 0x00000000, 	/* wait until address 0x174065c reads 0x0 */
	0x00030002, 0x00160000, 	/* if mode != '!fpga', skip 3 ops */
	0xba500021, 0x00000732, 	/* write array of size 2 from offset 1842 to address 0x174a000 */
	0xba500601, 0xc000ffff, 	/* write 0xc000ffff to address 0x174a00c */
	0xba501e10, 0x00000007, 	/* wait until address 0x174a03c reads 0x7 */
	0xb8022401, 0x00002e98, 	/* write 0x2e98 to address 0x1700448 */
	0xb8028121, 0x00000735, 	/* write array of size 14 from offset 1845 to address 0x1700500 (WB) */
	0xb8800021, 0x00000744, 	/* write array of size 256 from offset 1860 to address 0x1710000 */
	0x000a0002, 0x00190000, 	/* if mode != '(!chipsim)&(!skip_pram_init)', skip 10 ops */
	0xbc000121, 0x00000746, 	/* write array of size 8192 from offset 1862 to address 0x1780000 (WB) */
	0xbc400121, 0x00001641, 	/* write array of size 8192 from offset 5697 to address 0x1788000 (WB) */
	0xbc800121, 0x000025ca, 	/* write array of size 8192 from offset 9674 to address 0x1790000 (WB) */
	0xbcc00121, 0x00003538, 	/* write array of size 8192 from offset 13624 to address 0x1798000 (WB) */
	0xbd000121, 0x00004480, 	/* write array of size 8192 from offset 17536 to address 0x17a0000 (WB) */
	0xbd400121, 0x00005333, 	/* write array of size 8192 from offset 21299 to address 0x17a8000 (WB) */
	0xbd800121, 0x00006245, 	/* write array of size 8192 from offset 25157 to address 0x17b0000 (WB) */
	0xbdc00121, 0x00006f44, 	/* write array of size 8192 from offset 28484 to address 0x17b8000 (WB) */
	0xbe000121, 0x00007d89, 	/* write array of size 1008 from offset 32137 to address 0x17c0000 (WB) */
	0xbe07e121, 0x00007f62, 	/* write array of size 7184 from offset 32610 to address 0x17c0fc0 (WB) */
	0x00010002, 0x00160000, 	/* if mode != '!fpga', skip 1 ops */
	0xba502001, 0x00000001, 	/* write 0x1 to address 0x174a040 */
	0xb8800021, 0x00007f65, 	/* write array of size 13 from offset 32613 to address 0x1710000 */
	0xb8802221, 0x00007f73, 	/* write array of size 11 from offset 32627 to address 0x1710044 */
	0xb8804221, 0x00007f7f, 	/* write array of size 2 from offset 32639 to address 0x1710084 */
	0xb8804a21, 0x00007f82, 	/* write array of size 2 from offset 32642 to address 0x1710094 */
	0xb8805001, 0x001295d8, 	/* write 0x1295d8 to address 0x17100a0 */
	0xb8807a01, 0x0004940e, 	/* write 0x4940e to address 0x17100f4 */
	0xb8808201, 0x000608aa, 	/* write 0x608aa to address 0x1710104 */
	0xb8808821, 0x00007f85, 	/* write array of size 2 from offset 32645 to address 0x1710110 */
	0xb8809021, 0x00007f88, 	/* write array of size 2 from offset 32648 to address 0x1710120 */
	0xb8809a01, 0x000608fa, 	/* write 0x608fa to address 0x1710134 */
	0xb880a201, 0x00060714, 	/* write 0x60714 to address 0x1710144 */
	0xb880aa01, 0x0006091c, 	/* write 0x6091c to address 0x1710154 */
	0xb880ba01, 0x00060002, 	/* write 0x60002 to address 0x1710174 */
	0xb880c201, 0x00080ea1, 	/* write 0x80ea1 to address 0x1710184 */
	0xb880c821, 0x00007f8b, 	/* write array of size 2 from offset 32651 to address 0x1710190 */
	0xb880d001, 0x001e1a2f, 	/* write 0x1e1a2f to address 0x17101a0 */
	0xb8810221, 0x00007f8e, 	/* write array of size 2 from offset 32654 to address 0x1710204 */
	0xb8811221, 0x00007f91, 	/* write array of size 2 from offset 32657 to address 0x1710224 */
	0xb8812221, 0x00007f94, 	/* write array of size 2 from offset 32660 to address 0x1710244 */
	0xb8814201, 0x00128fe1, 	/* write 0x128fe1 to address 0x1710284 */
	0xb8818221, 0x00007f97, 	/* write array of size 6 from offset 32663 to address 0x1710304 */
	0xb8819221, 0x00007f9e, 	/* write array of size 2 from offset 32670 to address 0x1710324 */
	0xb8819a21, 0x00007fa1, 	/* write array of size 2 from offset 32673 to address 0x1710334 */
	0xb881a201, 0x000c7e38, 	/* write 0xc7e38 to address 0x1710344 */
	0xb881aa21, 0x00007fa4, 	/* write array of size 2 from offset 32676 to address 0x1710354 */
	0x00010002, 0x00160000, 	/* if mode != '!fpga', skip 1 ops */
	0xba502411, 0x00000002, 	/* write 2 zeros to address 0x174a048 */
	0x000a0003, 0x00000002, 	/* if phase != 'pf0', skip 10 ops */
	0xbb152811, 0x00000002, 	/* write 2 zeros to address 0x1762a50 */
	0xbb156811, 0x00000002, 	/* write 2 zeros to address 0x1762ad0 */
	0xbb218c01, 0x00000000, 	/* write 0x0 to address 0x1764318 */
	0xbb780c21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f018 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb545421, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a8a8 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb545421, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a8a8 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb545421, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a8a8 */
	0x000a0003, 0x00010002, 	/* if phase != 'pf1', skip 10 ops */
	0xbb152c11, 0x00000002, 	/* write 2 zeros to address 0x1762a58 */
	0xbb156c11, 0x00000002, 	/* write 2 zeros to address 0x1762ad8 */
	0xbb218e01, 0x00000000, 	/* write 0x0 to address 0x176431c */
	0xbb781021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f020 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb545821, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a8b0 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb545821, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a8b0 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb545821, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a8b0 */
	0x000a0003, 0x00020002, 	/* if phase != 'pf2', skip 10 ops */
	0xbb153011, 0x00000002, 	/* write 2 zeros to address 0x1762a60 */
	0xbb157011, 0x00000002, 	/* write 2 zeros to address 0x1762ae0 */
	0xbb219001, 0x00000000, 	/* write 0x0 to address 0x1764320 */
	0xbb781421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f028 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb545c21, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a8b8 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb545c21, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a8b8 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb545c21, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a8b8 */
	0x000a0003, 0x00030002, 	/* if phase != 'pf3', skip 10 ops */
	0xbb153411, 0x00000002, 	/* write 2 zeros to address 0x1762a68 */
	0xbb157411, 0x00000002, 	/* write 2 zeros to address 0x1762ae8 */
	0xbb219201, 0x00000000, 	/* write 0x0 to address 0x1764324 */
	0xbb781821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f030 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb546021, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a8c0 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb546021, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a8c0 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb546021, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a8c0 */
	0x000a0003, 0x00040002, 	/* if phase != 'pf4', skip 10 ops */
	0xbb153811, 0x00000002, 	/* write 2 zeros to address 0x1762a70 */
	0xbb157811, 0x00000002, 	/* write 2 zeros to address 0x1762af0 */
	0xbb219401, 0x00000000, 	/* write 0x0 to address 0x1764328 */
	0xbb781c21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f038 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb546421, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a8c8 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb546421, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a8c8 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb546421, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a8c8 */
	0x000a0003, 0x00050002, 	/* if phase != 'pf5', skip 10 ops */
	0xbb153c11, 0x00000002, 	/* write 2 zeros to address 0x1762a78 */
	0xbb157c11, 0x00000002, 	/* write 2 zeros to address 0x1762af8 */
	0xbb219601, 0x00000000, 	/* write 0x0 to address 0x176432c */
	0xbb782021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f040 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb546821, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a8d0 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb546821, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a8d0 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb546821, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a8d0 */
	0x000a0003, 0x00060002, 	/* if phase != 'pf6', skip 10 ops */
	0xbb154011, 0x00000002, 	/* write 2 zeros to address 0x1762a80 */
	0xbb158011, 0x00000002, 	/* write 2 zeros to address 0x1762b00 */
	0xbb219801, 0x00000000, 	/* write 0x0 to address 0x1764330 */
	0xbb782421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f048 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb546c21, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a8d8 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb546c21, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a8d8 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb546c21, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a8d8 */
	0x000a0003, 0x00070002, 	/* if phase != 'pf7', skip 10 ops */
	0xbb154411, 0x00000002, 	/* write 2 zeros to address 0x1762a88 */
	0xbb158411, 0x00000002, 	/* write 2 zeros to address 0x1762b08 */
	0xbb219a01, 0x00000000, 	/* write 0x0 to address 0x1764334 */
	0xbb782821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f050 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb547021, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a8e0 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb547021, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a8e0 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb547021, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a8e0 */
	0x000a0003, 0x00080002, 	/* if phase != 'pf8', skip 10 ops */
	0xbb154811, 0x00000002, 	/* write 2 zeros to address 0x1762a90 */
	0xbb158811, 0x00000002, 	/* write 2 zeros to address 0x1762b10 */
	0xbb219c01, 0x00000000, 	/* write 0x0 to address 0x1764338 */
	0xbb782c21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f058 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb547421, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a8e8 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb547421, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a8e8 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb547421, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a8e8 */
	0x000a0003, 0x00090002, 	/* if phase != 'pf9', skip 10 ops */
	0xbb154c11, 0x00000002, 	/* write 2 zeros to address 0x1762a98 */
	0xbb158c11, 0x00000002, 	/* write 2 zeros to address 0x1762b18 */
	0xbb219e01, 0x00000000, 	/* write 0x0 to address 0x176433c */
	0xbb783021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f060 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb547821, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a8f0 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb547821, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a8f0 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb547821, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a8f0 */
	0x000a0003, 0x000a0002, 	/* if phase != 'pf10', skip 10 ops */
	0xbb155011, 0x00000002, 	/* write 2 zeros to address 0x1762aa0 */
	0xbb159011, 0x00000002, 	/* write 2 zeros to address 0x1762b20 */
	0xbb21a001, 0x00000000, 	/* write 0x0 to address 0x1764340 */
	0xbb783421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f068 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb547c21, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a8f8 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb547c21, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a8f8 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb547c21, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a8f8 */
	0x000a0003, 0x000b0002, 	/* if phase != 'pf11', skip 10 ops */
	0xbb155411, 0x00000002, 	/* write 2 zeros to address 0x1762aa8 */
	0xbb159411, 0x00000002, 	/* write 2 zeros to address 0x1762b28 */
	0xbb21a201, 0x00000000, 	/* write 0x0 to address 0x1764344 */
	0xbb783821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f070 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb548021, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a900 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb548021, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a900 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb548021, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a900 */
	0x000a0003, 0x000c0002, 	/* if phase != 'pf12', skip 10 ops */
	0xbb155811, 0x00000002, 	/* write 2 zeros to address 0x1762ab0 */
	0xbb159811, 0x00000002, 	/* write 2 zeros to address 0x1762b30 */
	0xbb21a401, 0x00000000, 	/* write 0x0 to address 0x1764348 */
	0xbb783c21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f078 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb548421, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a908 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb548421, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a908 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb548421, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a908 */
	0x000a0003, 0x000d0002, 	/* if phase != 'pf13', skip 10 ops */
	0xbb155c11, 0x00000002, 	/* write 2 zeros to address 0x1762ab8 */
	0xbb159c11, 0x00000002, 	/* write 2 zeros to address 0x1762b38 */
	0xbb21a601, 0x00000000, 	/* write 0x0 to address 0x176434c */
	0xbb784021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f080 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb548821, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a910 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb548821, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a910 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb548821, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a910 */
	0x000a0003, 0x000e0002, 	/* if phase != 'pf14', skip 10 ops */
	0xbb156011, 0x00000002, 	/* write 2 zeros to address 0x1762ac0 */
	0xbb15a011, 0x00000002, 	/* write 2 zeros to address 0x1762b40 */
	0xbb21a801, 0x00000000, 	/* write 0x0 to address 0x1764350 */
	0xbb784421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f088 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb548c21, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a918 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb548c21, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a918 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb548c21, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a918 */
	0x000a0003, 0x000f0002, 	/* if phase != 'pf15', skip 10 ops */
	0xbb156411, 0x00000002, 	/* write 2 zeros to address 0x1762ac8 */
	0xbb15a411, 0x00000002, 	/* write 2 zeros to address 0x1762b48 */
	0xbb21aa01, 0x00000000, 	/* write 0x0 to address 0x1764354 */
	0xbb784821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x176f090 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xbb549021, 0x00007faa, 	/* write array of size 2 from offset 32682 to address 0x176a920 */
	0x00010002, 0x00f30000, 	/* if mode != 'asic|chipsim', skip 1 ops */
	0xbb549021, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x176a920 */
	0x00010002, 0x00120000, 	/* if mode != 'emul_reduced|emul_full', skip 1 ops */
	0xbb549021, 0x00007fb0, 	/* write array of size 2 from offset 32688 to address 0x176a920 */
	0x00010003, 0xffff0002, 	/* if phase != 'pf', skip 1 ops */
	0xb8020601, 0x00000001, 	/* write 0x1 to address 0x170040c */
	0x00050003, 0x00000001, 	/* if phase != 'port0', skip 5 ops */
	0xbb18b411, 0x00000002, 	/* write 2 zeros to address 0x1763168 */
	0xbb194411, 0x00000022, 	/* write 34 zeros to address 0x1763288 */
	0xbb542411, 0x00000002, 	/* write 2 zeros to address 0x176a848 */
	0xbb543411, 0x00000002, 	/* write 2 zeros to address 0x176a868 */
	0xbb544421, 0x00007fb3, 	/* write array of size 2 from offset 32691 to address 0x176a888 */
	0x00050003, 0x00010001, 	/* if phase != 'port1', skip 5 ops */
	0xbb18b811, 0x00000002, 	/* write 2 zeros to address 0x1763170 */
	0xbb198811, 0x00000022, 	/* write 34 zeros to address 0x1763310 */
	0xbb542811, 0x00000002, 	/* write 2 zeros to address 0x176a850 */
	0xbb543811, 0x00000002, 	/* write 2 zeros to address 0x176a870 */
	0xbb544821, 0x00007fb3, 	/* write array of size 2 from offset 32691 to address 0x176a890 */
	0x00050003, 0x00020001, 	/* if phase != 'port2', skip 5 ops */
	0xbb18bc11, 0x00000002, 	/* write 2 zeros to address 0x1763178 */
	0xbb19cc11, 0x00000022, 	/* write 34 zeros to address 0x1763398 */
	0xbb542c11, 0x00000002, 	/* write 2 zeros to address 0x176a858 */
	0xbb543c11, 0x00000002, 	/* write 2 zeros to address 0x176a878 */
	0xbb544c21, 0x00007fb3, 	/* write array of size 2 from offset 32691 to address 0x176a898 */
	0x00050003, 0x00030001, 	/* if phase != 'port3', skip 5 ops */
	0xbb18c011, 0x00000002, 	/* write 2 zeros to address 0x1763180 */
	0xbb1a1011, 0x00000022, 	/* write 34 zeros to address 0x1763420 */
	0xbb543011, 0x00000002, 	/* write 2 zeros to address 0x176a860 */
	0xbb544011, 0x00000002, 	/* write 2 zeros to address 0x176a880 */
	0xbb545021, 0x00007fb3, 	/* write array of size 2 from offset 32691 to address 0x176a8a0 */
	0x00010003, 0xffff0003, 	/* if phase != 'vf', skip 1 ops */
	0xb8020401, 0x00000001, 	/* write 0x1 to address 0x1700408 */
	/* MSEM */
	0x004f0003, 0xffff0000, 	/* if phase != 'engine', skip 79 ops */
	0xc0002201, 0x00000000, 	/* write 0x0 to address 0x1800044 */
	0xc0002a01, 0x00000000, 	/* write 0x0 to address 0x1800054 */
	0xc0006601, 0x00000000, 	/* write 0x0 to address 0x18000cc */
	0xc0010201, 0x00000000, 	/* write 0x0 to address 0x1800204 */
	0xc1000111, 0x000010e0, 	/* write 4320 zeros to address 0x1820000 (WB) */
	0xc2002201, 0x00000000, 	/* write 0x0 to address 0x1840044 */
	0xc2025001, 0x00000007, 	/* write 0x7 to address 0x18404a0 */
	0xc2032c01, 0x00000001, 	/* write 0x1 to address 0x1840658 */
	0xc203a421, 0x000002a3, 	/* write array of size 3 from offset 675 to address 0x1840748 */
	0xc2052401, 0x00001fff, 	/* write 0x1fff to address 0x1840a48 */
	0xc3000011, 0x00005000, 	/* write 20480 zeros to address 0x1860000 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0xc0036001, 0x00000000, 	/* write 0x0 to address 0x18006c0 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0xc2010201, 0x00000000, 	/* write 0x0 to address 0x1840204 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0xc2025c01, 0x00000000, 	/* write 0x0 to address 0x18404b8 */
	0x00010002, 0x00410000, 	/* if mode != 'ports_per_eng_4', skip 1 ops */
	0xc2025c01, 0x00000002, 	/* write 0x2 to address 0x18404b8 */
	0xc3000021, 0x00007fb6, 	/* write array of size 6 from offset 32694 to address 0x1860000 */
	0xc31d5201, 0x00000000, 	/* write 0x0 to address 0x1863aa4 */
	0xc31da821, 0x00007fbd, 	/* write array of size 7 from offset 32701 to address 0x1863b50 */
	0xc31db611, 0x00000017, 	/* write 23 zeros to address 0x1863b6c */
	0xc352b011, 0x00000010, 	/* write 16 zeros to address 0x186a560 */
	0xc3531011, 0x00000002, 	/* write 2 zeros to address 0x186a620 */
	0xc3535421, 0x000002b8, 	/* write array of size 2 from offset 696 to address 0x186a6a8 */
	0xc35fa821, 0x00007fc5, 	/* write array of size 5 from offset 32709 to address 0x186bf50 */
	0xc35fb211, 0x00000009, 	/* write 9 zeros to address 0x186bf64 */
	0xc3906421, 0x000006bd, 	/* write array of size 1 from offset 1725 to address 0x18720c8 */
	0xc3906611, 0x00000019, 	/* write 25 zeros to address 0x18720cc */
	0xc3935421, 0x00007fcb, 	/* write array of size 640 from offset 32715 to address 0x18726a8 */
	0xc3986421, 0x0000824c, 	/* write array of size 320 from offset 33356 to address 0x18730c8 */
	0xc39ffc21, 0x0000824e, 	/* write array of size 2 from offset 33358 to address 0x1873ff8 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0xc31d4a01, 0x00000002, 	/* write 0x2 to address 0x1863a94 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0xc31d4a01, 0x00000003, 	/* write 0x3 to address 0x1863a94 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xc31d4c01, 0x00000002, 	/* write 0x2 to address 0x1863a98 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0xc31d4e01, 0x00000000, 	/* write 0x0 to address 0x1863a9c */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0xc31d4e01, 0x00000001, 	/* write 0x1 to address 0x1863a9c */
	0x00010002, 0x00410000, 	/* if mode != 'ports_per_eng_4', skip 1 ops */
	0xc31d4e01, 0x00000002, 	/* write 0x2 to address 0x1863a9c */
	0x00010002, 0x00c00000, 	/* if mode != 'asic|chipsim|emul_full', skip 1 ops */
	0xc31d4c01, 0x00000003, 	/* write 0x3 to address 0x1863a98 */
	0xc2032e10, 0x00000000, 	/* wait until address 0x184065c reads 0x0 */
	0xc0022401, 0x00001255, 	/* write 0x1255 to address 0x1800448 */
	0xc0028121, 0x00008251, 	/* write array of size 10 from offset 33361 to address 0x1800500 (WB) */
	0xc0029921, 0x0000825c, 	/* write array of size 2 from offset 33372 to address 0x1800530 (WB) */
	0xc0800021, 0x0000825f, 	/* write array of size 256 from offset 33375 to address 0x1810000 */
	0x00070002, 0x00190000, 	/* if mode != '(!chipsim)&(!skip_pram_init)', skip 7 ops */
	0xc4000121, 0x00008261, 	/* write array of size 8192 from offset 33377 to address 0x1880000 (WB) */
	0xc4400121, 0x00009100, 	/* write array of size 8192 from offset 37120 to address 0x1888000 (WB) */
	0xc4800121, 0x0000a073, 	/* write array of size 8192 from offset 41075 to address 0x1890000 (WB) */
	0xc4c00121, 0x0000b084, 	/* write array of size 8192 from offset 45188 to address 0x1898000 (WB) */
	0xc5000121, 0x0000bc80, 	/* write array of size 8192 from offset 48256 to address 0x18a0000 (WB) */
	0xc5400121, 0x0000ca81, 	/* write array of size 4960 from offset 51841 to address 0x18a8000 (WB) */
	0xc566c121, 0x0000d147, 	/* write array of size 3232 from offset 53575 to address 0x18acd80 (WB) */
	0xc0800021, 0x0000d14a, 	/* write array of size 9 from offset 53578 to address 0x1810000 */
	0xc0801421, 0x0000d154, 	/* write array of size 3 from offset 53588 to address 0x1810028 */
	0xc0802221, 0x0000d158, 	/* write array of size 5 from offset 53592 to address 0x1810044 */
	0xc0804201, 0x00025d0b, 	/* write 0x25d0b to address 0x1810084 */
	0xc0804a21, 0x0000d15e, 	/* write array of size 2 from offset 53598 to address 0x1810094 */
	0xc0805021, 0x0000d161, 	/* write array of size 2 from offset 53601 to address 0x18100a0 */
	0xc0808201, 0x001e0147, 	/* write 0x1e0147 to address 0x1810104 */
	0xc0808801, 0x001e02cf, 	/* write 0x1e02cf to address 0x1810110 */
	0xc0808e21, 0x0000d164, 	/* write array of size 7 from offset 53604 to address 0x181011c */
	0xc080c421, 0x0000d16c, 	/* write array of size 11 from offset 53612 to address 0x1810188 */
	0xc0810221, 0x0000d178, 	/* write array of size 2 from offset 53624 to address 0x1810204 */
	0xc0810a21, 0x0000d17b, 	/* write array of size 2 from offset 53627 to address 0x1810214 */
	0xc0811221, 0x0000d17e, 	/* write array of size 2 from offset 53630 to address 0x1810224 */
	0xc0812221, 0x0000d181, 	/* write array of size 2 from offset 53633 to address 0x1810244 */
	0xc0814201, 0x001e5b29, 	/* write 0x1e5b29 to address 0x1810284 */
	0xc0814a21, 0x0000d184, 	/* write array of size 2 from offset 53636 to address 0x1810294 */
	0xc0818421, 0x0000d187, 	/* write array of size 7 from offset 53639 to address 0x1810308 */
	0xc0819421, 0x0000d18f, 	/* write array of size 5 from offset 53647 to address 0x1810328 */
	0xc081a021, 0x0000d195, 	/* write array of size 2 from offset 53653 to address 0x1810340 */
	0x00050003, 0x00000002, 	/* if phase != 'pf0', skip 5 ops */
	0xc319c811, 0x00000002, 	/* write 2 zeros to address 0x1863390 */
	0xc31a0811, 0x00000002, 	/* write 2 zeros to address 0x1863410 */
	0xc3529001, 0x00000000, 	/* write 0x0 to address 0x186a520 */
	0xc3868021, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d00 */
	0xc3931421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872628 */
	0x00050003, 0x00010002, 	/* if phase != 'pf1', skip 5 ops */
	0xc319cc11, 0x00000002, 	/* write 2 zeros to address 0x1863398 */
	0xc31a0c11, 0x00000002, 	/* write 2 zeros to address 0x1863418 */
	0xc3529201, 0x00000000, 	/* write 0x0 to address 0x186a524 */
	0xc3868421, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d08 */
	0xc3931821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872630 */
	0x00050003, 0x00020002, 	/* if phase != 'pf2', skip 5 ops */
	0xc319d011, 0x00000002, 	/* write 2 zeros to address 0x18633a0 */
	0xc31a1011, 0x00000002, 	/* write 2 zeros to address 0x1863420 */
	0xc3529401, 0x00000000, 	/* write 0x0 to address 0x186a528 */
	0xc3868821, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d10 */
	0xc3931c21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872638 */
	0x00050003, 0x00030002, 	/* if phase != 'pf3', skip 5 ops */
	0xc319d411, 0x00000002, 	/* write 2 zeros to address 0x18633a8 */
	0xc31a1411, 0x00000002, 	/* write 2 zeros to address 0x1863428 */
	0xc3529601, 0x00000000, 	/* write 0x0 to address 0x186a52c */
	0xc3868c21, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d18 */
	0xc3932021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872640 */
	0x00050003, 0x00040002, 	/* if phase != 'pf4', skip 5 ops */
	0xc319d811, 0x00000002, 	/* write 2 zeros to address 0x18633b0 */
	0xc31a1811, 0x00000002, 	/* write 2 zeros to address 0x1863430 */
	0xc3529801, 0x00000000, 	/* write 0x0 to address 0x186a530 */
	0xc3869021, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d20 */
	0xc3932421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872648 */
	0x00050003, 0x00050002, 	/* if phase != 'pf5', skip 5 ops */
	0xc319dc11, 0x00000002, 	/* write 2 zeros to address 0x18633b8 */
	0xc31a1c11, 0x00000002, 	/* write 2 zeros to address 0x1863438 */
	0xc3529a01, 0x00000000, 	/* write 0x0 to address 0x186a534 */
	0xc3869421, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d28 */
	0xc3932821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872650 */
	0x00050003, 0x00060002, 	/* if phase != 'pf6', skip 5 ops */
	0xc319e011, 0x00000002, 	/* write 2 zeros to address 0x18633c0 */
	0xc31a2011, 0x00000002, 	/* write 2 zeros to address 0x1863440 */
	0xc3529c01, 0x00000000, 	/* write 0x0 to address 0x186a538 */
	0xc3869821, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d30 */
	0xc3932c21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872658 */
	0x00050003, 0x00070002, 	/* if phase != 'pf7', skip 5 ops */
	0xc319e411, 0x00000002, 	/* write 2 zeros to address 0x18633c8 */
	0xc31a2411, 0x00000002, 	/* write 2 zeros to address 0x1863448 */
	0xc3529e01, 0x00000000, 	/* write 0x0 to address 0x186a53c */
	0xc3869c21, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d38 */
	0xc3933021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872660 */
	0x00050003, 0x00080002, 	/* if phase != 'pf8', skip 5 ops */
	0xc319e811, 0x00000002, 	/* write 2 zeros to address 0x18633d0 */
	0xc31a2811, 0x00000002, 	/* write 2 zeros to address 0x1863450 */
	0xc352a001, 0x00000000, 	/* write 0x0 to address 0x186a540 */
	0xc386a021, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d40 */
	0xc3933421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872668 */
	0x00050003, 0x00090002, 	/* if phase != 'pf9', skip 5 ops */
	0xc319ec11, 0x00000002, 	/* write 2 zeros to address 0x18633d8 */
	0xc31a2c11, 0x00000002, 	/* write 2 zeros to address 0x1863458 */
	0xc352a201, 0x00000000, 	/* write 0x0 to address 0x186a544 */
	0xc386a421, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d48 */
	0xc3933821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872670 */
	0x00050003, 0x000a0002, 	/* if phase != 'pf10', skip 5 ops */
	0xc319f011, 0x00000002, 	/* write 2 zeros to address 0x18633e0 */
	0xc31a3011, 0x00000002, 	/* write 2 zeros to address 0x1863460 */
	0xc352a401, 0x00000000, 	/* write 0x0 to address 0x186a548 */
	0xc386a821, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d50 */
	0xc3933c21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872678 */
	0x00050003, 0x000b0002, 	/* if phase != 'pf11', skip 5 ops */
	0xc319f411, 0x00000002, 	/* write 2 zeros to address 0x18633e8 */
	0xc31a3411, 0x00000002, 	/* write 2 zeros to address 0x1863468 */
	0xc352a601, 0x00000000, 	/* write 0x0 to address 0x186a54c */
	0xc386ac21, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d58 */
	0xc3934021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872680 */
	0x00050003, 0x000c0002, 	/* if phase != 'pf12', skip 5 ops */
	0xc319f811, 0x00000002, 	/* write 2 zeros to address 0x18633f0 */
	0xc31a3811, 0x00000002, 	/* write 2 zeros to address 0x1863470 */
	0xc352a801, 0x00000000, 	/* write 0x0 to address 0x186a550 */
	0xc386b021, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d60 */
	0xc3934421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872688 */
	0x00050003, 0x000d0002, 	/* if phase != 'pf13', skip 5 ops */
	0xc319fc11, 0x00000002, 	/* write 2 zeros to address 0x18633f8 */
	0xc31a3c11, 0x00000002, 	/* write 2 zeros to address 0x1863478 */
	0xc352aa01, 0x00000000, 	/* write 0x0 to address 0x186a554 */
	0xc386b421, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d68 */
	0xc3934821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872690 */
	0x00050003, 0x000e0002, 	/* if phase != 'pf14', skip 5 ops */
	0xc31a0011, 0x00000002, 	/* write 2 zeros to address 0x1863400 */
	0xc31a4011, 0x00000002, 	/* write 2 zeros to address 0x1863480 */
	0xc352ac01, 0x00000000, 	/* write 0x0 to address 0x186a558 */
	0xc386b821, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d70 */
	0xc3934c21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1872698 */
	0x00050003, 0x000f0002, 	/* if phase != 'pf15', skip 5 ops */
	0xc31a0411, 0x00000002, 	/* write 2 zeros to address 0x1863408 */
	0xc31a4411, 0x00000002, 	/* write 2 zeros to address 0x1863488 */
	0xc352ae01, 0x00000000, 	/* write 0x0 to address 0x186a55c */
	0xc386bc21, 0x0000d198, 	/* write array of size 2 from offset 53656 to address 0x1870d78 */
	0xc3935021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x18726a0 */
	0x00010003, 0xffff0002, 	/* if phase != 'pf', skip 1 ops */
	0xc0020601, 0x00000001, 	/* write 0x1 to address 0x180040c */
	0x00010003, 0x00000001, 	/* if phase != 'port0', skip 1 ops */
	0xc31d5411, 0x00000002, 	/* write 2 zeros to address 0x1863aa8 */
	0x00010003, 0x00010001, 	/* if phase != 'port1', skip 1 ops */
	0xc31d5811, 0x00000002, 	/* write 2 zeros to address 0x1863ab0 */
	0x00010003, 0x00020001, 	/* if phase != 'port2', skip 1 ops */
	0xc31d5c11, 0x00000002, 	/* write 2 zeros to address 0x1863ab8 */
	0x00010003, 0x00030001, 	/* if phase != 'port3', skip 1 ops */
	0xc31d6011, 0x00000002, 	/* write 2 zeros to address 0x1863ac0 */
	0x00010003, 0xffff0003, 	/* if phase != 'vf', skip 1 ops */
	0xc0020401, 0x00000001, 	/* write 0x1 to address 0x1800408 */
	/* USEM */
	0x00490003, 0xffff0000, 	/* if phase != 'engine', skip 73 ops */
	0xc8002201, 0x00000000, 	/* write 0x0 to address 0x1900044 */
	0xc8002a01, 0x00000000, 	/* write 0x0 to address 0x1900054 */
	0xc8006601, 0x00000000, 	/* write 0x0 to address 0x19000cc */
	0xc8010201, 0x00000000, 	/* write 0x0 to address 0x1900204 */
	0xc9000111, 0x00000b40, 	/* write 2880 zeros to address 0x1920000 (WB) */
	0xca002201, 0x00000000, 	/* write 0x0 to address 0x1940044 */
	0xca025001, 0x00000007, 	/* write 0x7 to address 0x19404a0 */
	0xca032c01, 0x00000001, 	/* write 0x1 to address 0x1940658 */
	0xca03a421, 0x000002a3, 	/* write array of size 3 from offset 675 to address 0x1940748 */
	0xca052401, 0x00001fff, 	/* write 0x1fff to address 0x1940a48 */
	0xcb000011, 0x00005000, 	/* write 20480 zeros to address 0x1960000 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0xca010201, 0x00000000, 	/* write 0x0 to address 0x1940204 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0xca025c01, 0x00000000, 	/* write 0x0 to address 0x19404b8 */
	0x00010002, 0x00410000, 	/* if mode != 'ports_per_eng_4', skip 1 ops */
	0xca025c01, 0x00000002, 	/* write 0x2 to address 0x19404b8 */
	0xcb088021, 0x0000d19b, 	/* write array of size 6 from offset 53659 to address 0x1961100 */
	0xcb3f5601, 0x00000000, 	/* write 0x0 to address 0x1967eac */
	0xcb3fac21, 0x00007fbd, 	/* write array of size 7 from offset 32701 to address 0x1967f58 */
	0xcb3fba11, 0x00000017, 	/* write 23 zeros to address 0x1967f74 */
	0xcb5ed421, 0x0000d1a2, 	/* write array of size 2 from offset 53666 to address 0x196bda8 */
	0xcb5ed811, 0x0000000c, 	/* write 12 zeros to address 0x196bdb0 */
	0xcb5ef021, 0x0000d1a5, 	/* write array of size 2 from offset 53669 to address 0x196bde0 */
	0xcb5f3421, 0x0000d1a8, 	/* write array of size 2 from offset 53672 to address 0x196be68 */
	0xcb5f7821, 0x000002b8, 	/* write array of size 2 from offset 696 to address 0x196bef0 */
	0xcb8e1821, 0x000006bd, 	/* write array of size 1 from offset 1725 to address 0x1971c30 */
	0xcb8e1a11, 0x00000019, 	/* write 25 zeros to address 0x1971c34 */
	0xcb9ffc21, 0x0000d1ab, 	/* write array of size 2 from offset 53675 to address 0x1973ff8 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0xcb3f4e01, 0x00000002, 	/* write 0x2 to address 0x1967e9c */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0xcb3f4e01, 0x00000003, 	/* write 0x3 to address 0x1967e9c */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xcb3f5001, 0x00000002, 	/* write 0x2 to address 0x1967ea0 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0xcb3f5201, 0x00000000, 	/* write 0x0 to address 0x1967ea4 */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0xcb3f5201, 0x00000001, 	/* write 0x1 to address 0x1967ea4 */
	0x00010002, 0x00410000, 	/* if mode != 'ports_per_eng_4', skip 1 ops */
	0xcb3f5201, 0x00000002, 	/* write 0x2 to address 0x1967ea4 */
	0x00010002, 0x00c00000, 	/* if mode != 'asic|chipsim|emul_full', skip 1 ops */
	0xcb3f5001, 0x00000003, 	/* write 0x3 to address 0x1967ea0 */
	0xca032e10, 0x00000000, 	/* wait until address 0x194065c reads 0x0 */
	0xc8022401, 0x000022b1, 	/* write 0x22b1 to address 0x1900448 */
	0xc8028921, 0x0000d1ae, 	/* write array of size 2 from offset 53678 to address 0x1900510 (WB) */
	0xc8029121, 0x0000d1b1, 	/* write array of size 8 from offset 53681 to address 0x1900520 (WB) */
	0xc8800021, 0x0000d1ba, 	/* write array of size 256 from offset 53690 to address 0x1910000 */
	0x00070002, 0x00190000, 	/* if mode != '(!chipsim)&(!skip_pram_init)', skip 7 ops */
	0xcc000121, 0x0000d1bc, 	/* write array of size 8192 from offset 53692 to address 0x1980000 (WB) */
	0xcc400121, 0x0000dfc6, 	/* write array of size 8192 from offset 57286 to address 0x1988000 (WB) */
	0xcc800121, 0x0000ec60, 	/* write array of size 8192 from offset 60512 to address 0x1990000 (WB) */
	0xccc00121, 0x0000fb1a, 	/* write array of size 8192 from offset 64282 to address 0x1998000 (WB) */
	0xcd000121, 0x00010a7b, 	/* write array of size 8192 from offset 68219 to address 0x19a0000 (WB) */
	0xcd400121, 0x000118ab, 	/* write array of size 276 from offset 71851 to address 0x19a8000 (WB) */
	0xcd422921, 0x00011949, 	/* write array of size 7916 from offset 72009 to address 0x19a8450 (WB) */
	0xc8800021, 0x0001194c, 	/* write array of size 13 from offset 72012 to address 0x1910000 */
	0xc8802221, 0x0001195a, 	/* write array of size 9 from offset 72026 to address 0x1910044 */
	0xc8803601, 0x00123dd6, 	/* write 0x123dd6 to address 0x191006c */
	0xc8804221, 0x00011964, 	/* write array of size 2 from offset 72036 to address 0x1910084 */
	0xc8804a21, 0x00011967, 	/* write array of size 2 from offset 72039 to address 0x1910094 */
	0xc8805021, 0x0001196a, 	/* write array of size 3 from offset 72042 to address 0x19100a0 */
	0xc8808201, 0x001e0520, 	/* write 0x1e0520 to address 0x1910104 */
	0xc8808801, 0x001e01c5, 	/* write 0x1e01c5 to address 0x1910110 */
	0xc8809021, 0x0001196e, 	/* write array of size 6 from offset 72046 to address 0x1910120 */
	0xc880c421, 0x00011975, 	/* write array of size 7 from offset 72053 to address 0x1910188 */
	0xc8810221, 0x0001197d, 	/* write array of size 4 from offset 72061 to address 0x1910204 */
	0xc8810c01, 0x001e4850, 	/* write 0x1e4850 to address 0x1910218 */
	0xc8811221, 0x00011982, 	/* write array of size 3 from offset 72066 to address 0x1910224 */
	0xc8812221, 0x00011986, 	/* write array of size 6 from offset 72070 to address 0x1910244 */
	0xc8813001, 0x000a42bc, 	/* write 0xa42bc to address 0x1910260 */
	0xc8814221, 0x0001198d, 	/* write array of size 2 from offset 72077 to address 0x1910284 */
	0xc8818221, 0x00011990, 	/* write array of size 5 from offset 72080 to address 0x1910304 */
	0x00060003, 0x00000002, 	/* if phase != 'pf0', skip 6 ops */
	0xcb000011, 0x00000002, 	/* write 2 zeros to address 0x1960000 */
	0xcb3bcc11, 0x00000002, 	/* write 2 zeros to address 0x1967798 */
	0xcb3c0c11, 0x00000002, 	/* write 2 zeros to address 0x1967818 */
	0xcb5eb401, 0x00000000, 	/* write 0x0 to address 0x196bd68 */
	0xcb8ed421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971da8 */
	0xcb8f7411, 0x00000020, 	/* write 32 zeros to address 0x1971ee8 */
	0x00060003, 0x00010002, 	/* if phase != 'pf1', skip 6 ops */
	0xcb000411, 0x00000002, 	/* write 2 zeros to address 0x1960008 */
	0xcb3bd011, 0x00000002, 	/* write 2 zeros to address 0x19677a0 */
	0xcb3c1011, 0x00000002, 	/* write 2 zeros to address 0x1967820 */
	0xcb5eb601, 0x00000000, 	/* write 0x0 to address 0x196bd6c */
	0xcb8ed821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971db0 */
	0xcb8fb411, 0x00000020, 	/* write 32 zeros to address 0x1971f68 */
	0x00060003, 0x00020002, 	/* if phase != 'pf2', skip 6 ops */
	0xcb000811, 0x00000002, 	/* write 2 zeros to address 0x1960010 */
	0xcb3bd411, 0x00000002, 	/* write 2 zeros to address 0x19677a8 */
	0xcb3c1411, 0x00000002, 	/* write 2 zeros to address 0x1967828 */
	0xcb5eb801, 0x00000000, 	/* write 0x0 to address 0x196bd70 */
	0xcb8edc21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971db8 */
	0xcb8ff411, 0x00000020, 	/* write 32 zeros to address 0x1971fe8 */
	0x00060003, 0x00030002, 	/* if phase != 'pf3', skip 6 ops */
	0xcb000c11, 0x00000002, 	/* write 2 zeros to address 0x1960018 */
	0xcb3bd811, 0x00000002, 	/* write 2 zeros to address 0x19677b0 */
	0xcb3c1811, 0x00000002, 	/* write 2 zeros to address 0x1967830 */
	0xcb5eba01, 0x00000000, 	/* write 0x0 to address 0x196bd74 */
	0xcb8ee021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971dc0 */
	0xcb903411, 0x00000020, 	/* write 32 zeros to address 0x1972068 */
	0x00060003, 0x00040002, 	/* if phase != 'pf4', skip 6 ops */
	0xcb001011, 0x00000002, 	/* write 2 zeros to address 0x1960020 */
	0xcb3bdc11, 0x00000002, 	/* write 2 zeros to address 0x19677b8 */
	0xcb3c1c11, 0x00000002, 	/* write 2 zeros to address 0x1967838 */
	0xcb5ebc01, 0x00000000, 	/* write 0x0 to address 0x196bd78 */
	0xcb8ee421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971dc8 */
	0xcb907411, 0x00000020, 	/* write 32 zeros to address 0x19720e8 */
	0x00060003, 0x00050002, 	/* if phase != 'pf5', skip 6 ops */
	0xcb001411, 0x00000002, 	/* write 2 zeros to address 0x1960028 */
	0xcb3be011, 0x00000002, 	/* write 2 zeros to address 0x19677c0 */
	0xcb3c2011, 0x00000002, 	/* write 2 zeros to address 0x1967840 */
	0xcb5ebe01, 0x00000000, 	/* write 0x0 to address 0x196bd7c */
	0xcb8ee821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971dd0 */
	0xcb90b411, 0x00000020, 	/* write 32 zeros to address 0x1972168 */
	0x00060003, 0x00060002, 	/* if phase != 'pf6', skip 6 ops */
	0xcb001811, 0x00000002, 	/* write 2 zeros to address 0x1960030 */
	0xcb3be411, 0x00000002, 	/* write 2 zeros to address 0x19677c8 */
	0xcb3c2411, 0x00000002, 	/* write 2 zeros to address 0x1967848 */
	0xcb5ec001, 0x00000000, 	/* write 0x0 to address 0x196bd80 */
	0xcb8eec21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971dd8 */
	0xcb90f411, 0x00000020, 	/* write 32 zeros to address 0x19721e8 */
	0x00060003, 0x00070002, 	/* if phase != 'pf7', skip 6 ops */
	0xcb001c11, 0x00000002, 	/* write 2 zeros to address 0x1960038 */
	0xcb3be811, 0x00000002, 	/* write 2 zeros to address 0x19677d0 */
	0xcb3c2811, 0x00000002, 	/* write 2 zeros to address 0x1967850 */
	0xcb5ec201, 0x00000000, 	/* write 0x0 to address 0x196bd84 */
	0xcb8ef021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971de0 */
	0xcb913411, 0x00000020, 	/* write 32 zeros to address 0x1972268 */
	0x00060003, 0x00080002, 	/* if phase != 'pf8', skip 6 ops */
	0xcb002011, 0x00000002, 	/* write 2 zeros to address 0x1960040 */
	0xcb3bec11, 0x00000002, 	/* write 2 zeros to address 0x19677d8 */
	0xcb3c2c11, 0x00000002, 	/* write 2 zeros to address 0x1967858 */
	0xcb5ec401, 0x00000000, 	/* write 0x0 to address 0x196bd88 */
	0xcb8ef421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971de8 */
	0xcb917411, 0x00000020, 	/* write 32 zeros to address 0x19722e8 */
	0x00060003, 0x00090002, 	/* if phase != 'pf9', skip 6 ops */
	0xcb002411, 0x00000002, 	/* write 2 zeros to address 0x1960048 */
	0xcb3bf011, 0x00000002, 	/* write 2 zeros to address 0x19677e0 */
	0xcb3c3011, 0x00000002, 	/* write 2 zeros to address 0x1967860 */
	0xcb5ec601, 0x00000000, 	/* write 0x0 to address 0x196bd8c */
	0xcb8ef821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971df0 */
	0xcb91b411, 0x00000020, 	/* write 32 zeros to address 0x1972368 */
	0x00060003, 0x000a0002, 	/* if phase != 'pf10', skip 6 ops */
	0xcb002811, 0x00000002, 	/* write 2 zeros to address 0x1960050 */
	0xcb3bf411, 0x00000002, 	/* write 2 zeros to address 0x19677e8 */
	0xcb3c3411, 0x00000002, 	/* write 2 zeros to address 0x1967868 */
	0xcb5ec801, 0x00000000, 	/* write 0x0 to address 0x196bd90 */
	0xcb8efc21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971df8 */
	0xcb91f411, 0x00000020, 	/* write 32 zeros to address 0x19723e8 */
	0x00060003, 0x000b0002, 	/* if phase != 'pf11', skip 6 ops */
	0xcb002c11, 0x00000002, 	/* write 2 zeros to address 0x1960058 */
	0xcb3bf811, 0x00000002, 	/* write 2 zeros to address 0x19677f0 */
	0xcb3c3811, 0x00000002, 	/* write 2 zeros to address 0x1967870 */
	0xcb5eca01, 0x00000000, 	/* write 0x0 to address 0x196bd94 */
	0xcb8f0021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971e00 */
	0xcb923411, 0x00000020, 	/* write 32 zeros to address 0x1972468 */
	0x00060003, 0x000c0002, 	/* if phase != 'pf12', skip 6 ops */
	0xcb003011, 0x00000002, 	/* write 2 zeros to address 0x1960060 */
	0xcb3bfc11, 0x00000002, 	/* write 2 zeros to address 0x19677f8 */
	0xcb3c3c11, 0x00000002, 	/* write 2 zeros to address 0x1967878 */
	0xcb5ecc01, 0x00000000, 	/* write 0x0 to address 0x196bd98 */
	0xcb8f0421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971e08 */
	0xcb927411, 0x00000020, 	/* write 32 zeros to address 0x19724e8 */
	0x00060003, 0x000d0002, 	/* if phase != 'pf13', skip 6 ops */
	0xcb003411, 0x00000002, 	/* write 2 zeros to address 0x1960068 */
	0xcb3c0011, 0x00000002, 	/* write 2 zeros to address 0x1967800 */
	0xcb3c4011, 0x00000002, 	/* write 2 zeros to address 0x1967880 */
	0xcb5ece01, 0x00000000, 	/* write 0x0 to address 0x196bd9c */
	0xcb8f0821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971e10 */
	0xcb92b411, 0x00000020, 	/* write 32 zeros to address 0x1972568 */
	0x00060003, 0x000e0002, 	/* if phase != 'pf14', skip 6 ops */
	0xcb003811, 0x00000002, 	/* write 2 zeros to address 0x1960070 */
	0xcb3c0411, 0x00000002, 	/* write 2 zeros to address 0x1967808 */
	0xcb3c4411, 0x00000002, 	/* write 2 zeros to address 0x1967888 */
	0xcb5ed001, 0x00000000, 	/* write 0x0 to address 0x196bda0 */
	0xcb8f0c21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971e18 */
	0xcb92f411, 0x00000020, 	/* write 32 zeros to address 0x19725e8 */
	0x00060003, 0x000f0002, 	/* if phase != 'pf15', skip 6 ops */
	0xcb003c11, 0x00000002, 	/* write 2 zeros to address 0x1960078 */
	0xcb3c0811, 0x00000002, 	/* write 2 zeros to address 0x1967810 */
	0xcb3c4811, 0x00000002, 	/* write 2 zeros to address 0x1967890 */
	0xcb5ed201, 0x00000000, 	/* write 0x0 to address 0x196bda4 */
	0xcb8f1021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1971e20 */
	0xcb933411, 0x00000020, 	/* write 32 zeros to address 0x1972668 */
	0x00010003, 0xffff0002, 	/* if phase != 'pf', skip 1 ops */
	0xc8020601, 0x00000001, 	/* write 0x1 to address 0x190040c */
	0x00020003, 0x00000001, 	/* if phase != 'port0', skip 2 ops */
	0xcb3f5811, 0x00000002, 	/* write 2 zeros to address 0x1967eb0 */
	0xcb772021, 0x00007fb3, 	/* write array of size 2 from offset 32691 to address 0x196ee40 */
	0x00020003, 0x00010001, 	/* if phase != 'port1', skip 2 ops */
	0xcb3f5c11, 0x00000002, 	/* write 2 zeros to address 0x1967eb8 */
	0xcb772421, 0x00007fb3, 	/* write array of size 2 from offset 32691 to address 0x196ee48 */
	0x00020003, 0x00020001, 	/* if phase != 'port2', skip 2 ops */
	0xcb3f6011, 0x00000002, 	/* write 2 zeros to address 0x1967ec0 */
	0xcb772821, 0x00007fb3, 	/* write array of size 2 from offset 32691 to address 0x196ee50 */
	0x00020003, 0x00030001, 	/* if phase != 'port3', skip 2 ops */
	0xcb3f6411, 0x00000002, 	/* write 2 zeros to address 0x1967ec8 */
	0xcb772c21, 0x00007fb3, 	/* write array of size 2 from offset 32691 to address 0x196ee58 */
	0x00010003, 0xffff0003, 	/* if phase != 'vf', skip 1 ops */
	0xc8020401, 0x00000001, 	/* write 0x1 to address 0x1900408 */
	/* XSEM */
	0x00570003, 0xffff0000, 	/* if phase != 'engine', skip 87 ops */
	0xa0002201, 0x00000000, 	/* write 0x0 to address 0x1400044 */
	0xa0002a01, 0x00000000, 	/* write 0x0 to address 0x1400054 */
	0xa0006601, 0x00000000, 	/* write 0x0 to address 0x14000cc */
	0xa0010201, 0x00000000, 	/* write 0x0 to address 0x1400204 */
	0xa1000111, 0x000010e0, 	/* write 4320 zeros to address 0x1420000 (WB) */
	0xa2002201, 0x00000000, 	/* write 0x0 to address 0x1440044 */
	0xa2025001, 0x00000007, 	/* write 0x7 to address 0x14404a0 */
	0xa2032c01, 0x00000001, 	/* write 0x1 to address 0x1440658 */
	0xa203a421, 0x000002a3, 	/* write array of size 3 from offset 675 to address 0x1440748 */
	0xa2052401, 0x00001fff, 	/* write 0x1fff to address 0x1440a48 */
	0xa3000011, 0x00005000, 	/* write 20480 zeros to address 0x1460000 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0xa2010201, 0x00000000, 	/* write 0x0 to address 0x1440204 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0xa2025c01, 0x00000000, 	/* write 0x0 to address 0x14404b8 */
	0x00010002, 0x00410000, 	/* if mode != 'ports_per_eng_4', skip 1 ops */
	0xa2025c01, 0x00000002, 	/* write 0x2 to address 0x14404b8 */
	0xa3000021, 0x00011996, 	/* write array of size 6 from offset 72086 to address 0x1460000 */
	0xa3269201, 0x00000000, 	/* write 0x0 to address 0x1464d24 */
	0xa326e821, 0x00007fbd, 	/* write array of size 7 from offset 32701 to address 0x1464dd0 */
	0xa326f611, 0x00000017, 	/* write 23 zeros to address 0x1464dec */
	0xa32f8c11, 0x00000010, 	/* write 16 zeros to address 0x1465f18 */
	0xa32fec11, 0x00000002, 	/* write 2 zeros to address 0x1465fd8 */
	0xa3303021, 0x000002b8, 	/* write array of size 2 from offset 696 to address 0x1466060 */
	0xa3328421, 0x00007fad, 	/* write array of size 2 from offset 32685 to address 0x1466508 */
	0xa34b8821, 0x000006bd, 	/* write array of size 1 from offset 1725 to address 0x1469710 */
	0xa34b8a11, 0x00000019, 	/* write 25 zeros to address 0x1469714 */
	0xa3550421, 0x0001199d, 	/* write array of size 15 from offset 72093 to address 0x146aa08 */
	0xa3552221, 0x000119ad, 	/* write array of size 7 from offset 72109 to address 0x146aa44 */
	0xa3553021, 0x000119af, 	/* write array of size 6 from offset 72111 to address 0x146aa60 */
	0xa39ffc21, 0x000119b6, 	/* write array of size 2 from offset 72118 to address 0x1473ff8 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0xa3268a01, 0x00000002, 	/* write 0x2 to address 0x1464d14 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0xa3268a01, 0x00000003, 	/* write 0x3 to address 0x1464d14 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xa3268c01, 0x00000002, 	/* write 0x2 to address 0x1464d18 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0xa3268e01, 0x00000000, 	/* write 0x0 to address 0x1464d1c */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0xa3268e01, 0x00000001, 	/* write 0x1 to address 0x1464d1c */
	0x00010002, 0x00410000, 	/* if mode != 'ports_per_eng_4', skip 1 ops */
	0xa3268e01, 0x00000002, 	/* write 0x2 to address 0x1464d1c */
	0x00010002, 0x00c00000, 	/* if mode != 'asic|chipsim|emul_full', skip 1 ops */
	0xa3268c01, 0x00000003, 	/* write 0x3 to address 0x1464d18 */
	0xa2032e10, 0x00000000, 	/* wait until address 0x144065c reads 0x0 */
	0xa0022401, 0x00003234, 	/* write 0x3234 to address 0x1400448 */
	0xa0028121, 0x000119b9, 	/* write array of size 14 from offset 72121 to address 0x1400500 (WB) */
	0xa0800021, 0x000119c8, 	/* write array of size 256 from offset 72136 to address 0x1410000 */
	0x000a0002, 0x00190000, 	/* if mode != '(!chipsim)&(!skip_pram_init)', skip 10 ops */
	0xa4000121, 0x000119ca, 	/* write array of size 8192 from offset 72138 to address 0x1480000 (WB) */
	0xa4400121, 0x0001292c, 	/* write array of size 8192 from offset 76076 to address 0x1488000 (WB) */
	0xa4800121, 0x00013884, 	/* write array of size 8192 from offset 80004 to address 0x1490000 (WB) */
	0xa4c00121, 0x00014306, 	/* write array of size 8192 from offset 82694 to address 0x1498000 (WB) */
	0xa5000121, 0x0001515f, 	/* write array of size 8192 from offset 86367 to address 0x14a0000 (WB) */
	0xa5400121, 0x00016009, 	/* write array of size 8192 from offset 90121 to address 0x14a8000 (WB) */
	0xa5800121, 0x00016d76, 	/* write array of size 8192 from offset 93558 to address 0x14b0000 (WB) */
	0xa5c00121, 0x0001788b, 	/* write array of size 8192 from offset 96395 to address 0x14b8000 (WB) */
	0xa6000121, 0x00018713, 	/* write array of size 7056 from offset 100115 to address 0x14c0000 (WB) */
	0xa6372121, 0x000193c1, 	/* write array of size 1136 from offset 103361 to address 0x14c6e40 (WB) */
	0xa0800021, 0x000193c4, 	/* write array of size 2 from offset 103364 to address 0x1410000 */
	0xa0800621, 0x000193c7, 	/* write array of size 3 from offset 103367 to address 0x141000c */
	0xa0801021, 0x000193cb, 	/* write array of size 7 from offset 103371 to address 0x1410020 */
	0xa0802021, 0x000193d3, 	/* write array of size 2 from offset 103379 to address 0x1410040 */
	0xa0802821, 0x000193d6, 	/* write array of size 2 from offset 103382 to address 0x1410050 */
	0xa0803001, 0x001e3d9b, 	/* write 0x1e3d9b to address 0x1410060 */
	0xa0804221, 0x000193d9, 	/* write array of size 6 from offset 103385 to address 0x1410084 */
	0xa0805001, 0x00129128, 	/* write 0x129128 to address 0x14100a0 */
	0xa0807221, 0x000193e0, 	/* write array of size 2 from offset 103392 to address 0x14100e4 */
	0xa0808221, 0x000193e3, 	/* write array of size 2 from offset 103395 to address 0x1410104 */
	0xa0808821, 0x000193e6, 	/* write array of size 3 from offset 103398 to address 0x1410110 */
	0xa0809021, 0x000193ea, 	/* write array of size 3 from offset 103402 to address 0x1410120 */
	0xa0809821, 0x000193ee, 	/* write array of size 3 from offset 103406 to address 0x1410130 */
	0xa080a001, 0x00040fea, 	/* write 0x40fea to address 0x1410140 */
	0xa080c201, 0x000614c8, 	/* write 0x614c8 to address 0x1410184 */
	0xa080c821, 0x000193f2, 	/* write array of size 2 from offset 103410 to address 0x1410190 */
	0xa080d001, 0x0006128b, 	/* write 0x6128b to address 0x14101a0 */
	0xa0810201, 0x00085522, 	/* write 0x85522 to address 0x1410204 */
	0xa0810621, 0x000193f5, 	/* write array of size 3 from offset 103413 to address 0x141020c */
	0xa0811021, 0x000193f9, 	/* write array of size 2 from offset 103417 to address 0x1410220 */
	0xa0814221, 0x000193fc, 	/* write array of size 3 from offset 103420 to address 0x1410284 */
	0xa0814a01, 0x00128dcc, 	/* write 0x128dcc to address 0x1410294 */
	0xa0818221, 0x00019400, 	/* write array of size 2 from offset 103424 to address 0x1410304 */
	0xa0818821, 0x00019403, 	/* write array of size 3 from offset 103427 to address 0x1410310 */
	0xa0819021, 0x00019407, 	/* write array of size 7 from offset 103431 to address 0x1410320 */
	0xa081a021, 0x0001940f, 	/* write array of size 3 from offset 103439 to address 0x1410340 */
	0xa081a821, 0x00019413, 	/* write array of size 3 from offset 103443 to address 0x1410350 */
	0x00040003, 0x00000002, 	/* if phase != 'pf0', skip 4 ops */
	0xa31a6811, 0x0000003e, 	/* write 62 zeros to address 0x14634d0 */
	0xa3234811, 0x00000002, 	/* write 2 zeros to address 0x1464690 */
	0xa327d401, 0x00000000, 	/* write 0x0 to address 0x1464fa8 */
	0xa354b421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a968 */
	0x00040003, 0x00010002, 	/* if phase != 'pf1', skip 4 ops */
	0xa31ae411, 0x0000003e, 	/* write 62 zeros to address 0x14635c8 */
	0xa3234c11, 0x00000002, 	/* write 2 zeros to address 0x1464698 */
	0xa327d601, 0x00000000, 	/* write 0x0 to address 0x1464fac */
	0xa354b821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a970 */
	0x00040003, 0x00020002, 	/* if phase != 'pf2', skip 4 ops */
	0xa31b6011, 0x0000003e, 	/* write 62 zeros to address 0x14636c0 */
	0xa3235011, 0x00000002, 	/* write 2 zeros to address 0x14646a0 */
	0xa327d801, 0x00000000, 	/* write 0x0 to address 0x1464fb0 */
	0xa354bc21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a978 */
	0x00040003, 0x00030002, 	/* if phase != 'pf3', skip 4 ops */
	0xa31bdc11, 0x0000003e, 	/* write 62 zeros to address 0x14637b8 */
	0xa3235411, 0x00000002, 	/* write 2 zeros to address 0x14646a8 */
	0xa327da01, 0x00000000, 	/* write 0x0 to address 0x1464fb4 */
	0xa354c021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a980 */
	0x00040003, 0x00040002, 	/* if phase != 'pf4', skip 4 ops */
	0xa31c5811, 0x0000003e, 	/* write 62 zeros to address 0x14638b0 */
	0xa3235811, 0x00000002, 	/* write 2 zeros to address 0x14646b0 */
	0xa327dc01, 0x00000000, 	/* write 0x0 to address 0x1464fb8 */
	0xa354c421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a988 */
	0x00040003, 0x00050002, 	/* if phase != 'pf5', skip 4 ops */
	0xa31cd411, 0x0000003e, 	/* write 62 zeros to address 0x14639a8 */
	0xa3235c11, 0x00000002, 	/* write 2 zeros to address 0x14646b8 */
	0xa327de01, 0x00000000, 	/* write 0x0 to address 0x1464fbc */
	0xa354c821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a990 */
	0x00040003, 0x00060002, 	/* if phase != 'pf6', skip 4 ops */
	0xa31d5011, 0x0000003e, 	/* write 62 zeros to address 0x1463aa0 */
	0xa3236011, 0x00000002, 	/* write 2 zeros to address 0x14646c0 */
	0xa327e001, 0x00000000, 	/* write 0x0 to address 0x1464fc0 */
	0xa354cc21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a998 */
	0x00040003, 0x00070002, 	/* if phase != 'pf7', skip 4 ops */
	0xa31dcc11, 0x0000003e, 	/* write 62 zeros to address 0x1463b98 */
	0xa3236411, 0x00000002, 	/* write 2 zeros to address 0x14646c8 */
	0xa327e201, 0x00000000, 	/* write 0x0 to address 0x1464fc4 */
	0xa354d021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a9a0 */
	0x00040003, 0x00080002, 	/* if phase != 'pf8', skip 4 ops */
	0xa31e4811, 0x0000003e, 	/* write 62 zeros to address 0x1463c90 */
	0xa3236811, 0x00000002, 	/* write 2 zeros to address 0x14646d0 */
	0xa327e401, 0x00000000, 	/* write 0x0 to address 0x1464fc8 */
	0xa354d421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a9a8 */
	0x00040003, 0x00090002, 	/* if phase != 'pf9', skip 4 ops */
	0xa31ec411, 0x0000003e, 	/* write 62 zeros to address 0x1463d88 */
	0xa3236c11, 0x00000002, 	/* write 2 zeros to address 0x14646d8 */
	0xa327e601, 0x00000000, 	/* write 0x0 to address 0x1464fcc */
	0xa354d821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a9b0 */
	0x00040003, 0x000a0002, 	/* if phase != 'pf10', skip 4 ops */
	0xa31f4011, 0x0000003e, 	/* write 62 zeros to address 0x1463e80 */
	0xa3237011, 0x00000002, 	/* write 2 zeros to address 0x14646e0 */
	0xa327e801, 0x00000000, 	/* write 0x0 to address 0x1464fd0 */
	0xa354dc21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a9b8 */
	0x00040003, 0x000b0002, 	/* if phase != 'pf11', skip 4 ops */
	0xa31fbc11, 0x0000003e, 	/* write 62 zeros to address 0x1463f78 */
	0xa3237411, 0x00000002, 	/* write 2 zeros to address 0x14646e8 */
	0xa327ea01, 0x00000000, 	/* write 0x0 to address 0x1464fd4 */
	0xa354e021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a9c0 */
	0x00040003, 0x000c0002, 	/* if phase != 'pf12', skip 4 ops */
	0xa3203811, 0x0000003e, 	/* write 62 zeros to address 0x1464070 */
	0xa3237811, 0x00000002, 	/* write 2 zeros to address 0x14646f0 */
	0xa327ec01, 0x00000000, 	/* write 0x0 to address 0x1464fd8 */
	0xa354e421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a9c8 */
	0x00040003, 0x000d0002, 	/* if phase != 'pf13', skip 4 ops */
	0xa320b411, 0x0000003e, 	/* write 62 zeros to address 0x1464168 */
	0xa3237c11, 0x00000002, 	/* write 2 zeros to address 0x14646f8 */
	0xa327ee01, 0x00000000, 	/* write 0x0 to address 0x1464fdc */
	0xa354e821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a9d0 */
	0x00040003, 0x000e0002, 	/* if phase != 'pf14', skip 4 ops */
	0xa3213011, 0x0000003e, 	/* write 62 zeros to address 0x1464260 */
	0xa3238011, 0x00000002, 	/* write 2 zeros to address 0x1464700 */
	0xa327f001, 0x00000000, 	/* write 0x0 to address 0x1464fe0 */
	0xa354ec21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a9d8 */
	0x00040003, 0x000f0002, 	/* if phase != 'pf15', skip 4 ops */
	0xa321ac11, 0x0000003e, 	/* write 62 zeros to address 0x1464358 */
	0xa3238411, 0x00000002, 	/* write 2 zeros to address 0x1464708 */
	0xa327f201, 0x00000000, 	/* write 0x0 to address 0x1464fe4 */
	0xa354f021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x146a9e0 */
	0x00010003, 0xffff0002, 	/* if phase != 'pf', skip 1 ops */
	0xa0020601, 0x00000001, 	/* write 0x1 to address 0x140040c */
	0x00010003, 0x00000001, 	/* if phase != 'port0', skip 1 ops */
	0xa3269411, 0x00000002, 	/* write 2 zeros to address 0x1464d28 */
	0x00010003, 0x00010001, 	/* if phase != 'port1', skip 1 ops */
	0xa3269811, 0x00000002, 	/* write 2 zeros to address 0x1464d30 */
	0x00010003, 0x00020001, 	/* if phase != 'port2', skip 1 ops */
	0xa3269c11, 0x00000002, 	/* write 2 zeros to address 0x1464d38 */
	0x00010003, 0x00030001, 	/* if phase != 'port3', skip 1 ops */
	0xa326a011, 0x00000002, 	/* write 2 zeros to address 0x1464d40 */
	0x00010003, 0xffff0003, 	/* if phase != 'vf', skip 1 ops */
	0xa0020401, 0x00000001, 	/* write 0x1 to address 0x1400408 */
	/* YSEM */
	0x00440003, 0xffff0000, 	/* if phase != 'engine', skip 68 ops */
	0xa8002201, 0x00000000, 	/* write 0x0 to address 0x1500044 */
	0xa8002a01, 0x00000000, 	/* write 0x0 to address 0x1500054 */
	0xa8006601, 0x00000000, 	/* write 0x0 to address 0x15000cc */
	0xa8010201, 0x00000000, 	/* write 0x0 to address 0x1500204 */
	0xa9000111, 0x000009d8, 	/* write 2520 zeros to address 0x1520000 (WB) */
	0xaa002201, 0x00000000, 	/* write 0x0 to address 0x1540044 */
	0xaa025001, 0x00000007, 	/* write 0x7 to address 0x15404a0 */
	0xaa032c01, 0x00000001, 	/* write 0x1 to address 0x1540658 */
	0xaa03a421, 0x000002a3, 	/* write array of size 3 from offset 675 to address 0x1540748 */
	0xaa052401, 0x00001fff, 	/* write 0x1fff to address 0x1540a48 */
	0xab000011, 0x00005000, 	/* write 20480 zeros to address 0x1560000 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0xaa010201, 0x00000000, 	/* write 0x0 to address 0x1540204 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0xaa025c01, 0x00000000, 	/* write 0x0 to address 0x15404b8 */
	0x00010002, 0x00410000, 	/* if mode != 'ports_per_eng_4', skip 1 ops */
	0xaa025c01, 0x00000002, 	/* write 0x2 to address 0x15404b8 */
	0xab000421, 0x00019417, 	/* write array of size 6 from offset 103447 to address 0x1560008 */
	0xab1e4a01, 0x00000000, 	/* write 0x0 to address 0x1563c94 */
	0xab1f2021, 0x00007fbd, 	/* write array of size 7 from offset 32701 to address 0x1563e40 */
	0xab1f2e11, 0x00000017, 	/* write 23 zeros to address 0x1563e5c */
	0xab386011, 0x00000010, 	/* write 16 zeros to address 0x15670c0 */
	0xab38c011, 0x00000002, 	/* write 2 zeros to address 0x1567180 */
	0xab390421, 0x000002b8, 	/* write array of size 2 from offset 696 to address 0x1567208 */
	0xab460821, 0x000006bd, 	/* write array of size 1 from offset 1725 to address 0x1568c10 */
	0xab460a11, 0x00000019, 	/* write 25 zeros to address 0x1568c14 */
	0xab46bc21, 0x00007fcb, 	/* write array of size 640 from offset 32715 to address 0x1568d78 */
	0xab9ffc21, 0x0001941e, 	/* write array of size 2 from offset 103454 to address 0x1573ff8 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0xab1e4201, 0x00000002, 	/* write 0x2 to address 0x1563c84 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0xab1e4201, 0x00000003, 	/* write 0x3 to address 0x1563c84 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xab1e4401, 0x00000002, 	/* write 0x2 to address 0x1563c88 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0xab1e4601, 0x00000000, 	/* write 0x0 to address 0x1563c8c */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0xab1e4601, 0x00000001, 	/* write 0x1 to address 0x1563c8c */
	0x00010002, 0x00410000, 	/* if mode != 'ports_per_eng_4', skip 1 ops */
	0xab1e4601, 0x00000002, 	/* write 0x2 to address 0x1563c8c */
	0x00010002, 0x00c00000, 	/* if mode != 'asic|chipsim|emul_full', skip 1 ops */
	0xab1e4401, 0x00000003, 	/* write 0x3 to address 0x1563c88 */
	0xaa032e10, 0x00000000, 	/* wait until address 0x154065c reads 0x0 */
	0xa8022401, 0x00002586, 	/* write 0x2586 to address 0x1500448 */
	0xa8028121, 0x00019421, 	/* write array of size 14 from offset 103457 to address 0x1500500 (WB) */
	0xa8800021, 0x00019430, 	/* write array of size 256 from offset 103472 to address 0x1510000 */
	0x00070002, 0x00190000, 	/* if mode != '(!chipsim)&(!skip_pram_init)', skip 7 ops */
	0xac000121, 0x00019432, 	/* write array of size 8192 from offset 103474 to address 0x1580000 (WB) */
	0xac400121, 0x0001a404, 	/* write array of size 8192 from offset 107524 to address 0x1588000 (WB) */
	0xac800121, 0x0001b1f0, 	/* write array of size 8192 from offset 111088 to address 0x1590000 (WB) */
	0xacc00121, 0x0001c0bc, 	/* write array of size 8192 from offset 114876 to address 0x1598000 (WB) */
	0xad000121, 0x0001cdb8, 	/* write array of size 8192 from offset 118200 to address 0x15a0000 (WB) */
	0xad400121, 0x0001dbc3, 	/* write array of size 5716 from offset 121795 to address 0x15a8000 (WB) */
	0xad6ca921, 0x0001e543, 	/* write array of size 2476 from offset 124227 to address 0x15ad950 (WB) */
	0xa8800021, 0x0001e546, 	/* write array of size 22 from offset 124230 to address 0x1510000 */
	0xa8804221, 0x0001e55d, 	/* write array of size 2 from offset 124253 to address 0x1510084 */
	0xa8804a21, 0x0001e560, 	/* write array of size 2 from offset 124256 to address 0x1510094 */
	0xa8805001, 0x00125e78, 	/* write 0x125e78 to address 0x15100a0 */
	0xa8807201, 0x001e5e04, 	/* write 0x1e5e04 to address 0x15100e4 */
	0xa8808201, 0x00040bb6, 	/* write 0x40bb6 to address 0x1510104 */
	0xa8808621, 0x0001e563, 	/* write array of size 3 from offset 124259 to address 0x151010c */
	0xa8809001, 0x001e1ce5, 	/* write 0x1e1ce5 to address 0x1510120 */
	0xa880c221, 0x0001e567, 	/* write array of size 12 from offset 124263 to address 0x1510184 */
	0xa8810221, 0x0001e574, 	/* write array of size 6 from offset 124276 to address 0x1510204 */
	0xa8811221, 0x0001e57b, 	/* write array of size 3 from offset 124283 to address 0x1510224 */
	0xa8811a01, 0x001253d0, 	/* write 0x1253d0 to address 0x1510234 */
	0xa8814221, 0x0001e57f, 	/* write array of size 5 from offset 124287 to address 0x1510284 */
	0xa8818421, 0x0001e585, 	/* write array of size 10 from offset 124293 to address 0x1510308 */
	0x00050003, 0x00000002, 	/* if phase != 'pf0', skip 5 ops */
	0xab1ac011, 0x00000002, 	/* write 2 zeros to address 0x1563580 */
	0xab1b0011, 0x00000002, 	/* write 2 zeros to address 0x1563600 */
	0xab202801, 0x00000000, 	/* write 0x0 to address 0x1564050 */
	0xab4bd021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x15697a0 */
	0xab4d2c11, 0x00000006, 	/* write 6 zeros to address 0x1569a58 */
	0x00050003, 0x00010002, 	/* if phase != 'pf1', skip 5 ops */
	0xab1ac411, 0x00000002, 	/* write 2 zeros to address 0x1563588 */
	0xab1b0411, 0x00000002, 	/* write 2 zeros to address 0x1563608 */
	0xab202a01, 0x00000000, 	/* write 0x0 to address 0x1564054 */
	0xab4bd421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x15697a8 */
	0xab4d3811, 0x00000006, 	/* write 6 zeros to address 0x1569a70 */
	0x00050003, 0x00020002, 	/* if phase != 'pf2', skip 5 ops */
	0xab1ac811, 0x00000002, 	/* write 2 zeros to address 0x1563590 */
	0xab1b0811, 0x00000002, 	/* write 2 zeros to address 0x1563610 */
	0xab202c01, 0x00000000, 	/* write 0x0 to address 0x1564058 */
	0xab4bd821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x15697b0 */
	0xab4d4411, 0x00000006, 	/* write 6 zeros to address 0x1569a88 */
	0x00050003, 0x00030002, 	/* if phase != 'pf3', skip 5 ops */
	0xab1acc11, 0x00000002, 	/* write 2 zeros to address 0x1563598 */
	0xab1b0c11, 0x00000002, 	/* write 2 zeros to address 0x1563618 */
	0xab202e01, 0x00000000, 	/* write 0x0 to address 0x156405c */
	0xab4bdc21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x15697b8 */
	0xab4d5011, 0x00000006, 	/* write 6 zeros to address 0x1569aa0 */
	0x00050003, 0x00040002, 	/* if phase != 'pf4', skip 5 ops */
	0xab1ad011, 0x00000002, 	/* write 2 zeros to address 0x15635a0 */
	0xab1b1011, 0x00000002, 	/* write 2 zeros to address 0x1563620 */
	0xab203001, 0x00000000, 	/* write 0x0 to address 0x1564060 */
	0xab4be021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x15697c0 */
	0xab4d5c11, 0x00000006, 	/* write 6 zeros to address 0x1569ab8 */
	0x00050003, 0x00050002, 	/* if phase != 'pf5', skip 5 ops */
	0xab1ad411, 0x00000002, 	/* write 2 zeros to address 0x15635a8 */
	0xab1b1411, 0x00000002, 	/* write 2 zeros to address 0x1563628 */
	0xab203201, 0x00000000, 	/* write 0x0 to address 0x1564064 */
	0xab4be421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x15697c8 */
	0xab4d6811, 0x00000006, 	/* write 6 zeros to address 0x1569ad0 */
	0x00050003, 0x00060002, 	/* if phase != 'pf6', skip 5 ops */
	0xab1ad811, 0x00000002, 	/* write 2 zeros to address 0x15635b0 */
	0xab1b1811, 0x00000002, 	/* write 2 zeros to address 0x1563630 */
	0xab203401, 0x00000000, 	/* write 0x0 to address 0x1564068 */
	0xab4be821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x15697d0 */
	0xab4d7411, 0x00000006, 	/* write 6 zeros to address 0x1569ae8 */
	0x00050003, 0x00070002, 	/* if phase != 'pf7', skip 5 ops */
	0xab1adc11, 0x00000002, 	/* write 2 zeros to address 0x15635b8 */
	0xab1b1c11, 0x00000002, 	/* write 2 zeros to address 0x1563638 */
	0xab203601, 0x00000000, 	/* write 0x0 to address 0x156406c */
	0xab4bec21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x15697d8 */
	0xab4d8011, 0x00000006, 	/* write 6 zeros to address 0x1569b00 */
	0x00050003, 0x00080002, 	/* if phase != 'pf8', skip 5 ops */
	0xab1ae011, 0x00000002, 	/* write 2 zeros to address 0x15635c0 */
	0xab1b2011, 0x00000002, 	/* write 2 zeros to address 0x1563640 */
	0xab203801, 0x00000000, 	/* write 0x0 to address 0x1564070 */
	0xab4bf021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x15697e0 */
	0xab4d8c11, 0x00000006, 	/* write 6 zeros to address 0x1569b18 */
	0x00050003, 0x00090002, 	/* if phase != 'pf9', skip 5 ops */
	0xab1ae411, 0x00000002, 	/* write 2 zeros to address 0x15635c8 */
	0xab1b2411, 0x00000002, 	/* write 2 zeros to address 0x1563648 */
	0xab203a01, 0x00000000, 	/* write 0x0 to address 0x1564074 */
	0xab4bf421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x15697e8 */
	0xab4d9811, 0x00000006, 	/* write 6 zeros to address 0x1569b30 */
	0x00050003, 0x000a0002, 	/* if phase != 'pf10', skip 5 ops */
	0xab1ae811, 0x00000002, 	/* write 2 zeros to address 0x15635d0 */
	0xab1b2811, 0x00000002, 	/* write 2 zeros to address 0x1563650 */
	0xab203c01, 0x00000000, 	/* write 0x0 to address 0x1564078 */
	0xab4bf821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x15697f0 */
	0xab4da411, 0x00000006, 	/* write 6 zeros to address 0x1569b48 */
	0x00050003, 0x000b0002, 	/* if phase != 'pf11', skip 5 ops */
	0xab1aec11, 0x00000002, 	/* write 2 zeros to address 0x15635d8 */
	0xab1b2c11, 0x00000002, 	/* write 2 zeros to address 0x1563658 */
	0xab203e01, 0x00000000, 	/* write 0x0 to address 0x156407c */
	0xab4bfc21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x15697f8 */
	0xab4db011, 0x00000006, 	/* write 6 zeros to address 0x1569b60 */
	0x00050003, 0x000c0002, 	/* if phase != 'pf12', skip 5 ops */
	0xab1af011, 0x00000002, 	/* write 2 zeros to address 0x15635e0 */
	0xab1b3011, 0x00000002, 	/* write 2 zeros to address 0x1563660 */
	0xab204001, 0x00000000, 	/* write 0x0 to address 0x1564080 */
	0xab4c0021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1569800 */
	0xab4dbc11, 0x00000006, 	/* write 6 zeros to address 0x1569b78 */
	0x00050003, 0x000d0002, 	/* if phase != 'pf13', skip 5 ops */
	0xab1af411, 0x00000002, 	/* write 2 zeros to address 0x15635e8 */
	0xab1b3411, 0x00000002, 	/* write 2 zeros to address 0x1563668 */
	0xab204201, 0x00000000, 	/* write 0x0 to address 0x1564084 */
	0xab4c0421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1569808 */
	0xab4dc811, 0x00000006, 	/* write 6 zeros to address 0x1569b90 */
	0x00050003, 0x000e0002, 	/* if phase != 'pf14', skip 5 ops */
	0xab1af811, 0x00000002, 	/* write 2 zeros to address 0x15635f0 */
	0xab1b3811, 0x00000002, 	/* write 2 zeros to address 0x1563670 */
	0xab204401, 0x00000000, 	/* write 0x0 to address 0x1564088 */
	0xab4c0821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1569810 */
	0xab4dd411, 0x00000006, 	/* write 6 zeros to address 0x1569ba8 */
	0x00050003, 0x000f0002, 	/* if phase != 'pf15', skip 5 ops */
	0xab1afc11, 0x00000002, 	/* write 2 zeros to address 0x15635f8 */
	0xab1b3c11, 0x00000002, 	/* write 2 zeros to address 0x1563678 */
	0xab204601, 0x00000000, 	/* write 0x0 to address 0x156408c */
	0xab4c0c21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1569818 */
	0xab4de011, 0x00000006, 	/* write 6 zeros to address 0x1569bc0 */
	0x00010003, 0xffff0002, 	/* if phase != 'pf', skip 1 ops */
	0xa8020601, 0x00000001, 	/* write 0x1 to address 0x150040c */
	0x00010003, 0x00000001, 	/* if phase != 'port0', skip 1 ops */
	0xab1e4c11, 0x00000002, 	/* write 2 zeros to address 0x1563c98 */
	0x00010003, 0x00010001, 	/* if phase != 'port1', skip 1 ops */
	0xab1e5011, 0x00000002, 	/* write 2 zeros to address 0x1563ca0 */
	0x00010003, 0x00020001, 	/* if phase != 'port2', skip 1 ops */
	0xab1e5411, 0x00000002, 	/* write 2 zeros to address 0x1563ca8 */
	0x00010003, 0x00030001, 	/* if phase != 'port3', skip 1 ops */
	0xab1e5811, 0x00000002, 	/* write 2 zeros to address 0x1563cb0 */
	0x00010003, 0xffff0003, 	/* if phase != 'vf', skip 1 ops */
	0xa8020401, 0x00000001, 	/* write 0x1 to address 0x1500408 */
	/* PSEM */
	0x004d0003, 0xffff0000, 	/* if phase != 'engine', skip 77 ops */
	0xb0002201, 0x00000000, 	/* write 0x0 to address 0x1600044 */
	0xb0002a01, 0x00000000, 	/* write 0x0 to address 0x1600054 */
	0xb0006601, 0x00000000, 	/* write 0x0 to address 0x16000cc */
	0xb0010201, 0x00000000, 	/* write 0x0 to address 0x1600204 */
	0xb1000111, 0x000002d0, 	/* write 720 zeros to address 0x1620000 (WB) */
	0xb2002201, 0x00000000, 	/* write 0x0 to address 0x1640044 */
	0xb2025001, 0x00000007, 	/* write 0x7 to address 0x16404a0 */
	0xb2032c01, 0x00000001, 	/* write 0x1 to address 0x1640658 */
	0xb203a421, 0x000002a3, 	/* write array of size 3 from offset 675 to address 0x1640748 */
	0xb2052401, 0x00001fff, 	/* write 0x1fff to address 0x1640a48 */
	0xb3000011, 0x00005000, 	/* write 20480 zeros to address 0x1660000 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0xb2010201, 0x00000000, 	/* write 0x0 to address 0x1640204 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0xb2025c01, 0x00000000, 	/* write 0x0 to address 0x16404b8 */
	0x00010002, 0x00410000, 	/* if mode != 'ports_per_eng_4', skip 1 ops */
	0xb2025c01, 0x00000002, 	/* write 0x2 to address 0x16404b8 */
	0x00020002, 0x00dc0000, 	/* if mode != '!(emul_reduced|fpga)', skip 2 ops */
	0xb2501e01, 0x00000007, 	/* write 0x7 to address 0x164a03c */
	0xb2510201, 0x00000000, 	/* write 0x0 to address 0x164a204 */
	0xb3000021, 0x0001e590, 	/* write array of size 6 from offset 124304 to address 0x1660000 */
	0xb300fc21, 0x0001e597, 	/* write array of size 2 from offset 124311 to address 0x16601f8 */
	0xb3142a01, 0x00000000, 	/* write 0x0 to address 0x1662854 */
	0xb3573011, 0x00000010, 	/* write 16 zeros to address 0x166ae60 */
	0xb3579011, 0x00000002, 	/* write 2 zeros to address 0x166af20 */
	0xb357d421, 0x000002b8, 	/* write array of size 2 from offset 696 to address 0x166afa8 */
	0xb38b5421, 0x000006bd, 	/* write array of size 1 from offset 1725 to address 0x16716a8 */
	0xb38b5611, 0x00000019, 	/* write 25 zeros to address 0x16716ac */
	0xb39d4c21, 0x00000284, 	/* write array of size 2 from offset 644 to address 0x1673a98 */
	0xb39ffc21, 0x0001e59a, 	/* write array of size 2 from offset 124314 to address 0x1673ff8 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0xb3142201, 0x00000002, 	/* write 0x2 to address 0x1662844 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0xb3142201, 0x00000003, 	/* write 0x3 to address 0x1662844 */
	0x00010002, 0x00170000, 	/* if mode != 'fpga', skip 1 ops */
	0xb3142401, 0x00000002, 	/* write 0x2 to address 0x1662848 */
	0x00010002, 0x000e0000, 	/* if mode != 'ports_per_eng_1', skip 1 ops */
	0xb3142601, 0x00000000, 	/* write 0x0 to address 0x166284c */
	0x00010002, 0x00060000, 	/* if mode != 'ports_per_eng_2', skip 1 ops */
	0xb3142601, 0x00000001, 	/* write 0x1 to address 0x166284c */
	0x00010002, 0x00410000, 	/* if mode != 'ports_per_eng_4', skip 1 ops */
	0xb3142601, 0x00000002, 	/* write 0x2 to address 0x166284c */
	0x00010002, 0x00c00000, 	/* if mode != 'asic|chipsim|emul_full', skip 1 ops */
	0xb3142401, 0x00000003, 	/* write 0x3 to address 0x1662848 */
	0xb2032e10, 0x00000000, 	/* wait until address 0x164065c reads 0x0 */
	0x00030002, 0x00dc0000, 	/* if mode != '!(emul_reduced|fpga)', skip 3 ops */
	0xb2500021, 0x00000732, 	/* write array of size 2 from offset 1842 to address 0x164a000 */
	0xb2500601, 0xc000ffff, 	/* write 0xc000ffff to address 0x164a00c */
	0xb2501e10, 0x00000007, 	/* wait until address 0x164a03c reads 0x7 */
	0xb0022401, 0x0000131a, 	/* write 0x131a to address 0x1600448 */
	0xb0028121, 0x0001e59d, 	/* write array of size 14 from offset 124317 to address 0x1600500 (WB) */
	0xb0800021, 0x0001e5ac, 	/* write array of size 256 from offset 124332 to address 0x1610000 */
	0x00070002, 0x00190000, 	/* if mode != '(!chipsim)&(!skip_pram_init)', skip 7 ops */
	0xb4000121, 0x0001e5ae, 	/* write array of size 8192 from offset 124334 to address 0x1680000 (WB) */
	0xb4400121, 0x0001f395, 	/* write array of size 8192 from offset 127893 to address 0x1688000 (WB) */
	0xb4800121, 0x00020276, 	/* write array of size 8192 from offset 131702 to address 0x1690000 (WB) */
	0xb4c00121, 0x00020efe, 	/* write array of size 8192 from offset 134910 to address 0x1698000 (WB) */
	0xb5000121, 0x00021aff, 	/* write array of size 8192 from offset 137983 to address 0x16a0000 (WB) */
	0xb5400121, 0x000228a3, 	/* write array of size 2408 from offset 141475 to address 0x16a8000 (WB) */
	0xb552d121, 0x00022da5, 	/* write array of size 5784 from offset 142757 to address 0x16aa5a0 (WB) */
	0x00010002, 0x00dc0000, 	/* if mode != '!(emul_reduced|fpga)', skip 1 ops */
	0xb2502001, 0x00000001, 	/* write 0x1 to address 0x164a040 */
	0xb0800021, 0x00022da8, 	/* write array of size 13 from offset 142760 to address 0x1610000 */
	0xb0802221, 0x00022db6, 	/* write array of size 9 from offset 142774 to address 0x1610044 */
	0xb0804221, 0x00022dc0, 	/* write array of size 2 from offset 142784 to address 0x1610084 */
	0xb0804801, 0x001e567c, 	/* write 0x1e567c to address 0x1610090 */
	0xb0808221, 0x00022dc3, 	/* write array of size 2 from offset 142787 to address 0x1610104 */
	0xb0808801, 0x001e01bf, 	/* write 0x1e01bf to address 0x1610110 */
	0xb0809021, 0x00022dc6, 	/* write array of size 2 from offset 142790 to address 0x1610120 */
	0xb080c221, 0x00022dc9, 	/* write array of size 2 from offset 142793 to address 0x1610184 */
	0xb080c821, 0x00022dcc, 	/* write array of size 10 from offset 142796 to address 0x1610190 */
	0xb0810221, 0x00022dd7, 	/* write array of size 4 from offset 142807 to address 0x1610204 */
	0xb0811221, 0x00022ddc, 	/* write array of size 2 from offset 142812 to address 0x1610224 */
	0xb0814221, 0x00022ddf, 	/* write array of size 2 from offset 142815 to address 0x1610284 */
	0xb0818421, 0x00022de2, 	/* write array of size 6 from offset 142818 to address 0x1610308 */
	0x00010002, 0x00dc0000, 	/* if mode != '!(emul_reduced|fpga)', skip 1 ops */
	0xb2502411, 0x00000002, 	/* write 2 zeros to address 0x164a048 */
	0x00060003, 0x00000002, 	/* if phase != 'pf0', skip 6 ops */
	0xb310a011, 0x00000002, 	/* write 2 zeros to address 0x1662140 */
	0xb310e011, 0x00000002, 	/* write 2 zeros to address 0x16621c0 */
	0xb3570c01, 0x00000000, 	/* write 0x0 to address 0x166ae18 */
	0xb38a1c21, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671438 */
	0xb38cc821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1671990 */
	0xb39d0c11, 0x00000002, 	/* write 2 zeros to address 0x1673a18 */
	0x00060003, 0x00010002, 	/* if phase != 'pf1', skip 6 ops */
	0xb310a411, 0x00000002, 	/* write 2 zeros to address 0x1662148 */
	0xb310e411, 0x00000002, 	/* write 2 zeros to address 0x16621c8 */
	0xb3570e01, 0x00000000, 	/* write 0x0 to address 0x166ae1c */
	0xb38a2021, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671440 */
	0xb38ccc21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1671998 */
	0xb39d1011, 0x00000002, 	/* write 2 zeros to address 0x1673a20 */
	0x00060003, 0x00020002, 	/* if phase != 'pf2', skip 6 ops */
	0xb310a811, 0x00000002, 	/* write 2 zeros to address 0x1662150 */
	0xb310e811, 0x00000002, 	/* write 2 zeros to address 0x16621d0 */
	0xb3571001, 0x00000000, 	/* write 0x0 to address 0x166ae20 */
	0xb38a2421, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671448 */
	0xb38cd021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x16719a0 */
	0xb39d1411, 0x00000002, 	/* write 2 zeros to address 0x1673a28 */
	0x00060003, 0x00030002, 	/* if phase != 'pf3', skip 6 ops */
	0xb310ac11, 0x00000002, 	/* write 2 zeros to address 0x1662158 */
	0xb310ec11, 0x00000002, 	/* write 2 zeros to address 0x16621d8 */
	0xb3571201, 0x00000000, 	/* write 0x0 to address 0x166ae24 */
	0xb38a2821, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671450 */
	0xb38cd421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x16719a8 */
	0xb39d1811, 0x00000002, 	/* write 2 zeros to address 0x1673a30 */
	0x00060003, 0x00040002, 	/* if phase != 'pf4', skip 6 ops */
	0xb310b011, 0x00000002, 	/* write 2 zeros to address 0x1662160 */
	0xb310f011, 0x00000002, 	/* write 2 zeros to address 0x16621e0 */
	0xb3571401, 0x00000000, 	/* write 0x0 to address 0x166ae28 */
	0xb38a2c21, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671458 */
	0xb38cd821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x16719b0 */
	0xb39d1c11, 0x00000002, 	/* write 2 zeros to address 0x1673a38 */
	0x00060003, 0x00050002, 	/* if phase != 'pf5', skip 6 ops */
	0xb310b411, 0x00000002, 	/* write 2 zeros to address 0x1662168 */
	0xb310f411, 0x00000002, 	/* write 2 zeros to address 0x16621e8 */
	0xb3571601, 0x00000000, 	/* write 0x0 to address 0x166ae2c */
	0xb38a3021, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671460 */
	0xb38cdc21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x16719b8 */
	0xb39d2011, 0x00000002, 	/* write 2 zeros to address 0x1673a40 */
	0x00060003, 0x00060002, 	/* if phase != 'pf6', skip 6 ops */
	0xb310b811, 0x00000002, 	/* write 2 zeros to address 0x1662170 */
	0xb310f811, 0x00000002, 	/* write 2 zeros to address 0x16621f0 */
	0xb3571801, 0x00000000, 	/* write 0x0 to address 0x166ae30 */
	0xb38a3421, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671468 */
	0xb38ce021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x16719c0 */
	0xb39d2411, 0x00000002, 	/* write 2 zeros to address 0x1673a48 */
	0x00060003, 0x00070002, 	/* if phase != 'pf7', skip 6 ops */
	0xb310bc11, 0x00000002, 	/* write 2 zeros to address 0x1662178 */
	0xb310fc11, 0x00000002, 	/* write 2 zeros to address 0x16621f8 */
	0xb3571a01, 0x00000000, 	/* write 0x0 to address 0x166ae34 */
	0xb38a3821, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671470 */
	0xb38ce421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x16719c8 */
	0xb39d2811, 0x00000002, 	/* write 2 zeros to address 0x1673a50 */
	0x00060003, 0x00080002, 	/* if phase != 'pf8', skip 6 ops */
	0xb310c011, 0x00000002, 	/* write 2 zeros to address 0x1662180 */
	0xb3110011, 0x00000002, 	/* write 2 zeros to address 0x1662200 */
	0xb3571c01, 0x00000000, 	/* write 0x0 to address 0x166ae38 */
	0xb38a3c21, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671478 */
	0xb38ce821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x16719d0 */
	0xb39d2c11, 0x00000002, 	/* write 2 zeros to address 0x1673a58 */
	0x00060003, 0x00090002, 	/* if phase != 'pf9', skip 6 ops */
	0xb310c411, 0x00000002, 	/* write 2 zeros to address 0x1662188 */
	0xb3110411, 0x00000002, 	/* write 2 zeros to address 0x1662208 */
	0xb3571e01, 0x00000000, 	/* write 0x0 to address 0x166ae3c */
	0xb38a4021, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671480 */
	0xb38cec21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x16719d8 */
	0xb39d3011, 0x00000002, 	/* write 2 zeros to address 0x1673a60 */
	0x00060003, 0x000a0002, 	/* if phase != 'pf10', skip 6 ops */
	0xb310c811, 0x00000002, 	/* write 2 zeros to address 0x1662190 */
	0xb3110811, 0x00000002, 	/* write 2 zeros to address 0x1662210 */
	0xb3572001, 0x00000000, 	/* write 0x0 to address 0x166ae40 */
	0xb38a4421, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671488 */
	0xb38cf021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x16719e0 */
	0xb39d3411, 0x00000002, 	/* write 2 zeros to address 0x1673a68 */
	0x00060003, 0x000b0002, 	/* if phase != 'pf11', skip 6 ops */
	0xb310cc11, 0x00000002, 	/* write 2 zeros to address 0x1662198 */
	0xb3110c11, 0x00000002, 	/* write 2 zeros to address 0x1662218 */
	0xb3572201, 0x00000000, 	/* write 0x0 to address 0x166ae44 */
	0xb38a4821, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671490 */
	0xb38cf421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x16719e8 */
	0xb39d3811, 0x00000002, 	/* write 2 zeros to address 0x1673a70 */
	0x00060003, 0x000c0002, 	/* if phase != 'pf12', skip 6 ops */
	0xb310d011, 0x00000002, 	/* write 2 zeros to address 0x16621a0 */
	0xb3111011, 0x00000002, 	/* write 2 zeros to address 0x1662220 */
	0xb3572401, 0x00000000, 	/* write 0x0 to address 0x166ae48 */
	0xb38a4c21, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x1671498 */
	0xb38cf821, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x16719f0 */
	0xb39d3c11, 0x00000002, 	/* write 2 zeros to address 0x1673a78 */
	0x00060003, 0x000d0002, 	/* if phase != 'pf13', skip 6 ops */
	0xb310d411, 0x00000002, 	/* write 2 zeros to address 0x16621a8 */
	0xb3111411, 0x00000002, 	/* write 2 zeros to address 0x1662228 */
	0xb3572601, 0x00000000, 	/* write 0x0 to address 0x166ae4c */
	0xb38a5021, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x16714a0 */
	0xb38cfc21, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x16719f8 */
	0xb39d4011, 0x00000002, 	/* write 2 zeros to address 0x1673a80 */
	0x00060003, 0x000e0002, 	/* if phase != 'pf14', skip 6 ops */
	0xb310d811, 0x00000002, 	/* write 2 zeros to address 0x16621b0 */
	0xb3111811, 0x00000002, 	/* write 2 zeros to address 0x1662230 */
	0xb3572801, 0x00000000, 	/* write 0x0 to address 0x166ae50 */
	0xb38a5421, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x16714a8 */
	0xb38d0021, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1671a00 */
	0xb39d4411, 0x00000002, 	/* write 2 zeros to address 0x1673a88 */
	0x00060003, 0x000f0002, 	/* if phase != 'pf15', skip 6 ops */
	0xb310dc11, 0x00000002, 	/* write 2 zeros to address 0x16621b8 */
	0xb3111c11, 0x00000002, 	/* write 2 zeros to address 0x1662238 */
	0xb3572a01, 0x00000000, 	/* write 0x0 to address 0x166ae54 */
	0xb38a5821, 0x00022de9, 	/* write array of size 2 from offset 142825 to address 0x16714b0 */
	0xb38d0421, 0x00007fa7, 	/* write array of size 2 from offset 32679 to address 0x1671a08 */
	0xb39d4811, 0x00000002, 	/* write 2 zeros to address 0x1673a90 */
	0x00010003, 0xffff0002, 	/* if phase != 'pf', skip 1 ops */
	0xb0020601, 0x00000001, 	/* write 0x1 to address 0x160040c */
	0x00010003, 0x00000001, 	/* if phase != 'port0', skip 1 ops */
	0xb3142c11, 0x00000002, 	/* write 2 zeros to address 0x1662858 */
	0x00010003, 0x00010001, 	/* if phase != 'port1', skip 1 ops */
	0xb3143011, 0x00000002, 	/* write 2 zeros to address 0x1662860 */
	0x00010003, 0x00020001, 	/* if phase != 'port2', skip 1 ops */
	0xb3143411, 0x00000002, 	/* write 2 zeros to address 0x1662868 */
	0x00010003, 0x00030001, 	/* if phase != 'port3', skip 1 ops */
	0xb3143811, 0x00000002, 	/* write 2 zeros to address 0x1662870 */
	0x00010003, 0xffff0003, 	/* if phase != 'vf', skip 1 ops */
	0xb0020401, 0x00000001, 	/* write 0x1 to address 0x1600408 */
	/* RSS */
	0x00040003, 0xffff0000, 	/* if phase != 'engine', skip 4 ops */
	0x11c4c201, 0x00000000, 	/* write 0x0 to address 0x238984 */
	0x11c50201, 0x00000000, 	/* write 0x0 to address 0x238a04 */
	0x11c40201, 0x00000001, 	/* write 0x1 to address 0x238804 */
	0x11c40210, 0x00000000, 	/* wait until address 0x238804 reads 0x0 */
	/* TMLD */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x2680c201, 0x00000000, 	/* write 0x0 to address 0x4d0184 */
	0x26810201, 0x00000000, 	/* write 0x0 to address 0x4d0204 */
	/* MULD */
	0x00080003, 0xffff0000, 	/* if phase != 'engine', skip 8 ops */
	0x2700c201, 0x00000000, 	/* write 0x0 to address 0x4e0184 */
	0x27010201, 0x00000000, 	/* write 0x0 to address 0x4e0204 */
	0x00020002, 0x00020000, 	/* if mode != 'bb', skip 2 ops */
	0x27200111, 0x00000800, 	/* write 2048 zeros to address 0x4e4000 (WB) */
	0x27400111, 0x00000800, 	/* write 2048 zeros to address 0x4e8000 (WB) */
	0x00020002, 0x00150000, 	/* if mode != 'k2', skip 2 ops */
	0x27200111, 0x00000a00, 	/* write 2560 zeros to address 0x4e4000 (WB) */
	0x27400111, 0x00000a00, 	/* write 2560 zeros to address 0x4e8000 (WB) */
	/* YULD */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x2640c201, 0x00000000, 	/* write 0x0 to address 0x4c8184 */
	0x26410201, 0x00000000, 	/* write 0x0 to address 0x4c8204 */
	/* XYLD */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x2600c201, 0x00000000, 	/* write 0x0 to address 0x4c0184 */
	0x26010201, 0x00000000, 	/* write 0x0 to address 0x4c0204 */
	/* PRM */
	0x000d0003, 0xffff0000, 	/* if phase != 'engine', skip 13 ops */
	0x11802201, 0x00000000, 	/* write 0x0 to address 0x230044 */
	0x11802a01, 0x00000000, 	/* write 0x0 to address 0x230054 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x11810201, 0x00100000, 	/* write 0x100000 to address 0x230204 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x11810201, 0x00000000, 	/* write 0x0 to address 0x230204 */
	0x11821201, 0x00000001, 	/* write 0x1 to address 0x230424 */
	0x00010002, 0x00390000, 	/* if mode != 'mf_sd', skip 1 ops */
	0x11820001, 0x00000001, 	/* write 0x1 to address 0x230400 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x11821401, 0x00000001, 	/* write 0x1 to address 0x230428 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x11821401, 0x00000002, 	/* write 0x2 to address 0x230428 */
	/* PBF_PB1 */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x6d002201, 0x00000000, 	/* write 0x0 to address 0xda0044 */
	0x6d002a01, 0x00000000, 	/* write 0x0 to address 0xda0054 */
	/* PBF_PB2 */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x6d202201, 0x00000000, 	/* write 0x0 to address 0xda4044 */
	0x6d202a01, 0x00000000, 	/* write 0x0 to address 0xda4054 */
	/* RPB */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x11e02201, 0x00000000, 	/* write 0x0 to address 0x23c044 */
	0x11e02a01, 0x00000000, 	/* write 0x0 to address 0x23c054 */
	/* BTB */
	0x00160003, 0xffff0000, 	/* if phase != 'engine', skip 22 ops */
	0x6d806201, 0x00000000, 	/* write 0x0 to address 0xdb00c4 */
	0x6d806e01, 0x00000000, 	/* write 0x0 to address 0xdb00dc */
	0x6d807a01, 0x00000000, 	/* write 0x0 to address 0xdb00f4 */
	0x6d808601, 0x00000000, 	/* write 0x0 to address 0xdb010c */
	0x6d809201, 0x00000000, 	/* write 0x0 to address 0xdb0124 */
	0x6d809e01, 0x00000000, 	/* write 0x0 to address 0xdb013c */
	0x6d80aa01, 0x00000000, 	/* write 0x0 to address 0xdb0154 */
	0x6d80c401, 0x00000000, 	/* write 0x0 to address 0xdb0188 */
	0x6d80d001, 0x00000000, 	/* write 0x0 to address 0xdb01a0 */
	0x6d80dc01, 0x00000000, 	/* write 0x0 to address 0xdb01b8 */
	0x6d80e801, 0x00000000, 	/* write 0x0 to address 0xdb01d0 */
	0x6d80f001, 0x00000000, 	/* write 0x0 to address 0xdb01e0 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x6d820201, 0x00000000, 	/* write 0x0 to address 0xdb0404 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x6d820201, 0x00000000, 	/* write 0x0 to address 0xdb0404 */
	0x6d800201, 0x00000003, 	/* write 0x3 to address 0xdb0004 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x6d842601, 0x00000005, 	/* write 0x5 to address 0xdb084c */
	0x00010002, 0x00050000, 	/* if mode != '100g', skip 1 ops */
	0x6d842401, 0x00000567, 	/* write 0x567 to address 0xdb0848 */
	0x6d800410, 0x00000003, 	/* wait until address 0xdb0008 reads 0x3 */
	/* PBF */
	0x00360003, 0xffff0000, 	/* if phase != 'engine', skip 54 ops */
	0x6c00c201, 0x00000000, 	/* write 0x0 to address 0xd80184 */
	0x6c00ca01, 0x00000000, 	/* write 0x0 to address 0xd80194 */
	0x6c010201, 0x00000000, 	/* write 0x0 to address 0xd80204 */
	0x6c010a01, 0x00000000, 	/* write 0x0 to address 0xd80214 */
	0x6c024031, 0x86690001, 	/* write runtime array of size 1 from offset 34409 to address 0xd80480 */
	0x6c030c01, 0x00000000, 	/* write 0x0 to address 0xd80618 */
	0x6c035031, 0x866b0001, 	/* write runtime array of size 1 from offset 34411 to address 0xd806a0 */
	0x6c035e31, 0x866c0002, 	/* write runtime array of size 2 from offset 34412 to address 0xd806bc */
	0x6c037031, 0x866e0001, 	/* write runtime array of size 1 from offset 34414 to address 0xd806e0 */
	0x6c037e31, 0x866f0002, 	/* write runtime array of size 2 from offset 34415 to address 0xd806fc */
	0x6c039031, 0x86710001, 	/* write runtime array of size 1 from offset 34417 to address 0xd80720 */
	0x6c039e31, 0x86720002, 	/* write runtime array of size 2 from offset 34418 to address 0xd8073c */
	0x6c03b031, 0x86740001, 	/* write runtime array of size 1 from offset 34420 to address 0xd80760 */
	0x6c03be31, 0x86750002, 	/* write runtime array of size 2 from offset 34421 to address 0xd8077c */
	0x6c03d031, 0x86770001, 	/* write runtime array of size 1 from offset 34423 to address 0xd807a0 */
	0x6c03de31, 0x86780002, 	/* write runtime array of size 2 from offset 34424 to address 0xd807bc */
	0x6c03f031, 0x867a0001, 	/* write runtime array of size 1 from offset 34426 to address 0xd807e0 */
	0x6c03fe31, 0x867b0002, 	/* write runtime array of size 2 from offset 34427 to address 0xd807fc */
	0x6c041031, 0x867d0001, 	/* write runtime array of size 1 from offset 34429 to address 0xd80820 */
	0x6c041e31, 0x867e0002, 	/* write runtime array of size 2 from offset 34430 to address 0xd8083c */
	0x6c043031, 0x86800001, 	/* write runtime array of size 1 from offset 34432 to address 0xd80860 */
	0x6c043e31, 0x86810002, 	/* write runtime array of size 2 from offset 34433 to address 0xd8087c */
	0x6c045031, 0x86830001, 	/* write runtime array of size 1 from offset 34435 to address 0xd808a0 */
	0x6c045e31, 0x86840002, 	/* write runtime array of size 2 from offset 34436 to address 0xd808bc */
	0x6c047031, 0x86860001, 	/* write runtime array of size 1 from offset 34438 to address 0xd808e0 */
	0x6c047e31, 0x86870002, 	/* write runtime array of size 2 from offset 34439 to address 0xd808fc */
	0x6c049031, 0x86890001, 	/* write runtime array of size 1 from offset 34441 to address 0xd80920 */
	0x6c049e31, 0x868a0002, 	/* write runtime array of size 2 from offset 34442 to address 0xd8093c */
	0x6c04b031, 0x868c0001, 	/* write runtime array of size 1 from offset 34444 to address 0xd80960 */
	0x6c04be31, 0x868d0002, 	/* write runtime array of size 2 from offset 34445 to address 0xd8097c */
	0x6c04d031, 0x868f0001, 	/* write runtime array of size 1 from offset 34447 to address 0xd809a0 */
	0x6c04de31, 0x86900002, 	/* write runtime array of size 2 from offset 34448 to address 0xd809bc */
	0x6c04f031, 0x86920001, 	/* write runtime array of size 1 from offset 34450 to address 0xd809e0 */
	0x6c04fe31, 0x86930002, 	/* write runtime array of size 2 from offset 34451 to address 0xd809fc */
	0x6c051031, 0x86950001, 	/* write runtime array of size 1 from offset 34453 to address 0xd80a20 */
	0x6c051e31, 0x86960002, 	/* write runtime array of size 2 from offset 34454 to address 0xd80a3c */
	0x6c053031, 0x86980001, 	/* write runtime array of size 1 from offset 34456 to address 0xd80a60 */
	0x6c053e31, 0x86990002, 	/* write runtime array of size 2 from offset 34457 to address 0xd80a7c */
	0x6c055031, 0x869b0001, 	/* write runtime array of size 1 from offset 34459 to address 0xd80aa0 */
	0x6c055e31, 0x869c0002, 	/* write runtime array of size 2 from offset 34460 to address 0xd80abc */
	0x6c057031, 0x869e0001, 	/* write runtime array of size 1 from offset 34462 to address 0xd80ae0 */
	0x6c057e31, 0x869f0002, 	/* write runtime array of size 2 from offset 34463 to address 0xd80afc */
	0x6c059031, 0x86a10001, 	/* write runtime array of size 1 from offset 34465 to address 0xd80b20 */
	0x6c059e31, 0x86a20002, 	/* write runtime array of size 2 from offset 34466 to address 0xd80b3c */
	0x6c05b031, 0x86a40001, 	/* write runtime array of size 1 from offset 34468 to address 0xd80b60 */
	0x6c05be31, 0x86a50002, 	/* write runtime array of size 2 from offset 34469 to address 0xd80b7c */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x6c020001, 0x00000001, 	/* write 0x1 to address 0xd80400 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x6c022801, 0x00000018, 	/* write 0x18 to address 0xd80450 */
	0x00010002, 0x00390000, 	/* if mode != 'mf_sd', skip 1 ops */
	0x6c024c01, 0x00000001, 	/* write 0x1 to address 0xd80498 */
	0x6c000001, 0x00000001, 	/* write 0x1 to address 0xd80000 */
	0x6c000001, 0x00000000, 	/* write 0x0 to address 0xd80000 */
	0x000c0003, 0xffff0001, 	/* if phase != 'port', skip 12 ops */
	0x6c025801, 0x00000082, 	/* write 0x82 to address 0xd804b0 */
	0x6c025e01, 0x00000080, 	/* write 0x80 to address 0xd804bc */
	0x6c026821, 0x00022dec, 	/* write array of size 2 from offset 142828 to address 0xd804d0 */
	0x6c026e21, 0x00022def, 	/* write array of size 2 from offset 142831 to address 0xd804dc */
	0x6c027a01, 0x00000000, 	/* write 0x0 to address 0xd804f4 */
	0x6c028c21, 0x00022df2, 	/* write array of size 2 from offset 142834 to address 0xd80518 */
	0x6c029201, 0x00000000, 	/* write 0x0 to address 0xd80524 */
	0x6c02e031, 0x866a0001, 	/* write runtime array of size 1 from offset 34410 to address 0xd805c0 */
	0x00010002, 0x00390000, 	/* if mode != 'mf_sd', skip 1 ops */
	0x6c025c01, 0x00000082, 	/* write 0x82 to address 0xd804b8 */
	0x00010002, 0x00b20000, 	/* if mode != 'sf|mf_si', skip 1 ops */
	0x6c025c01, 0x00000000, 	/* write 0x0 to address 0xd804b8 */
	/* RDIF */
	0x00040003, 0xffff0000, 	/* if phase != 'engine', skip 4 ops */
	0x18002201, 0x00000000, 	/* write 0x0 to address 0x300044 */
	0x1800c201, 0x00000000, 	/* write 0x0 to address 0x300184 */
	0x1800ca01, 0x00000000, 	/* write 0x0 to address 0x300194 */
	0x18000001, 0x00000001, 	/* write 0x1 to address 0x300000 */
	/* TDIF */
	0x00070003, 0xffff0000, 	/* if phase != 'engine', skip 7 ops */
	0x1880c201, 0x00000000, 	/* write 0x0 to address 0x310184 */
	0x1880ca01, 0x00000000, 	/* write 0x0 to address 0x310194 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x18810201, 0x00000020, 	/* write 0x20 to address 0x310204 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x18810201, 0x00000000, 	/* write 0x0 to address 0x310204 */
	0x18800001, 0x00000001, 	/* write 0x1 to address 0x310000 */
	/* CDU */
	0x00890003, 0xffff0000, 	/* if phase != 'engine', skip 137 ops */
	0x2c00e601, 0x00000000, 	/* write 0x0 to address 0x5801cc */
	0x2c010201, 0x00000000, 	/* write 0x0 to address 0x580204 */
	0x2c030001, 0x00020000, 	/* write 0x20000 to address 0x580600 */
	0x2c048031, 0x865c0003, 	/* write runtime array of size 3 from offset 34396 to address 0x580900 */
	0x2c080121, 0x00022df5, 	/* write array of size 9 from offset 142837 to address 0x581000 (WB) */
	0x2c082121, 0x00022dff, 	/* write array of size 9 from offset 142847 to address 0x581040 (WB) */
	0x2c084121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x581080 (WB) */
	0x2c086121, 0x00022e13, 	/* write array of size 9 from offset 142867 to address 0x5810c0 (WB) */
	0x2c088121, 0x00022e1d, 	/* write array of size 9 from offset 142877 to address 0x581100 (WB) */
	0x2c08a121, 0x00022e27, 	/* write array of size 9 from offset 142887 to address 0x581140 (WB) */
	0x2c08c121, 0x00022e31, 	/* write array of size 9 from offset 142897 to address 0x581180 (WB) */
	0x2c08e121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x5811c0 (WB) */
	0x2c090121, 0x00022e3b, 	/* write array of size 9 from offset 142907 to address 0x581200 (WB) */
	0x2c092121, 0x00022e45, 	/* write array of size 9 from offset 142917 to address 0x581240 (WB) */
	0x2c094121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x581280 (WB) */
	0x2c096121, 0x00022e4f, 	/* write array of size 9 from offset 142927 to address 0x5812c0 (WB) */
	0x2c098121, 0x00022e59, 	/* write array of size 9 from offset 142937 to address 0x581300 (WB) */
	0x2c09a121, 0x00022e63, 	/* write array of size 9 from offset 142947 to address 0x581340 (WB) */
	0x2c09c121, 0x00022e6d, 	/* write array of size 9 from offset 142957 to address 0x581380 (WB) */
	0x2c09e121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x5813c0 (WB) */
	0x2c0a0121, 0x00022e77, 	/* write array of size 9 from offset 142967 to address 0x581400 (WB) */
	0x2c0a2121, 0x00022dff, 	/* write array of size 9 from offset 142847 to address 0x581440 (WB) */
	0x2c0a4121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x581480 (WB) */
	0x2c0a6121, 0x00022e81, 	/* write array of size 9 from offset 142977 to address 0x5814c0 (WB) */
	0x2c0a8121, 0x00022e1d, 	/* write array of size 9 from offset 142877 to address 0x581500 (WB) */
	0x2c0aa121, 0x00022e63, 	/* write array of size 9 from offset 142947 to address 0x581540 (WB) */
	0x2c0ac121, 0x00022e8b, 	/* write array of size 9 from offset 142987 to address 0x581580 (WB) */
	0x2c0ae121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x5815c0 (WB) */
	0x2c0b0121, 0x00022e95, 	/* write array of size 9 from offset 142997 to address 0x581600 (WB) */
	0x2c0b2121, 0x00022e45, 	/* write array of size 9 from offset 142917 to address 0x581640 (WB) */
	0x2c0b4121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x581680 (WB) */
	0x2c0b6121, 0x00022e9f, 	/* write array of size 9 from offset 143007 to address 0x5816c0 (WB) */
	0x2c0b8121, 0x00022ea9, 	/* write array of size 9 from offset 143017 to address 0x581700 (WB) */
	0x2c0ba121, 0x00022e63, 	/* write array of size 9 from offset 142947 to address 0x581740 (WB) */
	0x2c0bc121, 0x00022eb3, 	/* write array of size 9 from offset 143027 to address 0x581780 (WB) */
	0x2c0be121, 0x00022ebd, 	/* write array of size 9 from offset 143037 to address 0x5817c0 (WB) */
	0x2c0c0121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x581800 (WB) */
	0x2c0c2121, 0x00022ebd, 	/* write array of size 9 from offset 143037 to address 0x581840 (WB) */
	0x2c0c4121, 0x00022ec7, 	/* write array of size 9 from offset 143047 to address 0x581880 (WB) */
	0x2c0c6121, 0x00022e9f, 	/* write array of size 9 from offset 143007 to address 0x5818c0 (WB) */
	0x2c0c8121, 0x00022ed1, 	/* write array of size 9 from offset 143057 to address 0x581900 (WB) */
	0x2c0ca121, 0x00022e63, 	/* write array of size 9 from offset 142947 to address 0x581940 (WB) */
	0x2c0cc121, 0x00022edb, 	/* write array of size 9 from offset 143067 to address 0x581980 (WB) */
	0x2c0ce121, 0x00022ee5, 	/* write array of size 9 from offset 143077 to address 0x5819c0 (WB) */
	0x2c0d0121, 0x00022eef, 	/* write array of size 9 from offset 143087 to address 0x581a00 (WB) */
	0x2c0d2121, 0x00022dff, 	/* write array of size 9 from offset 142847 to address 0x581a40 (WB) */
	0x2c0d4121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x581a80 (WB) */
	0x2c0d6121, 0x00022e13, 	/* write array of size 9 from offset 142867 to address 0x581ac0 (WB) */
	0x2c0d8121, 0x00022e1d, 	/* write array of size 9 from offset 142877 to address 0x581b00 (WB) */
	0x2c0da121, 0x00022e63, 	/* write array of size 9 from offset 142947 to address 0x581b40 (WB) */
	0x2c0dc121, 0x00022ef9, 	/* write array of size 9 from offset 143097 to address 0x581b80 (WB) */
	0x2c0de121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x581bc0 (WB) */
	0x2c0e0121, 0x00022eef, 	/* write array of size 9 from offset 143087 to address 0x581c00 (WB) */
	0x2c0e2121, 0x00022dff, 	/* write array of size 9 from offset 142847 to address 0x581c40 (WB) */
	0x2c0e4121, 0x00022f03, 	/* write array of size 9 from offset 143107 to address 0x581c80 (WB) */
	0x2c0e6121, 0x00022e13, 	/* write array of size 9 from offset 142867 to address 0x581cc0 (WB) */
	0x2c0e8121, 0x00022e1d, 	/* write array of size 9 from offset 142877 to address 0x581d00 (WB) */
	0x2c0ea121, 0x00022e63, 	/* write array of size 9 from offset 142947 to address 0x581d40 (WB) */
	0x2c0ec121, 0x00022f0d, 	/* write array of size 9 from offset 143117 to address 0x581d80 (WB) */
	0x2c0ee121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x581dc0 (WB) */
	0x2c0f0121, 0x00022eef, 	/* write array of size 9 from offset 143087 to address 0x581e00 (WB) */
	0x2c0f2121, 0x00022f17, 	/* write array of size 9 from offset 143127 to address 0x581e40 (WB) */
	0x2c0f4121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x581e80 (WB) */
	0x2c0f6121, 0x00022e13, 	/* write array of size 9 from offset 142867 to address 0x581ec0 (WB) */
	0x2c0f8121, 0x00022e1d, 	/* write array of size 9 from offset 142877 to address 0x581f00 (WB) */
	0x2c0fa121, 0x00022e63, 	/* write array of size 9 from offset 142947 to address 0x581f40 (WB) */
	0x2c0fc121, 0x00022f21, 	/* write array of size 9 from offset 143137 to address 0x581f80 (WB) */
	0x2c0fe121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x581fc0 (WB) */
	0x2c100121, 0x00022f2b, 	/* write array of size 9 from offset 143147 to address 0x582000 (WB) */
	0x2c102121, 0x00022f35, 	/* write array of size 9 from offset 143157 to address 0x582040 (WB) */
	0x2c104121, 0x00022f3f, 	/* write array of size 9 from offset 143167 to address 0x582080 (WB) */
	0x2c106121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x5820c0 (WB) */
	0x2c108121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582100 (WB) */
	0x2c10a121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582140 (WB) */
	0x2c10c121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582180 (WB) */
	0x2c10e121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x5821c0 (WB) */
	0x2c110121, 0x00022f49, 	/* write array of size 9 from offset 143177 to address 0x582200 (WB) */
	0x2c112121, 0x00022f53, 	/* write array of size 9 from offset 143187 to address 0x582240 (WB) */
	0x2c114121, 0x00022f5d, 	/* write array of size 9 from offset 143197 to address 0x582280 (WB) */
	0x2c116121, 0x00022f67, 	/* write array of size 9 from offset 143207 to address 0x5822c0 (WB) */
	0x2c118121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582300 (WB) */
	0x2c11a121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582340 (WB) */
	0x2c11c121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582380 (WB) */
	0x2c11e121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x5823c0 (WB) */
	0x2c120121, 0x00022f71, 	/* write array of size 9 from offset 143217 to address 0x582400 (WB) */
	0x2c122121, 0x00022f7b, 	/* write array of size 9 from offset 143227 to address 0x582440 (WB) */
	0x2c124121, 0x00022f85, 	/* write array of size 9 from offset 143237 to address 0x582480 (WB) */
	0x2c126121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x5824c0 (WB) */
	0x2c128121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582500 (WB) */
	0x2c12a121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582540 (WB) */
	0x2c12c121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582580 (WB) */
	0x2c12e121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x5825c0 (WB) */
	0x2c130121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582600 (WB) */
	0x2c132121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582640 (WB) */
	0x2c134121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582680 (WB) */
	0x2c136121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x5826c0 (WB) */
	0x2c138121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582700 (WB) */
	0x2c13a121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582740 (WB) */
	0x2c13c121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582780 (WB) */
	0x2c13e121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x5827c0 (WB) */
	0x2c140121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582800 (WB) */
	0x2c142121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582840 (WB) */
	0x2c144121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582880 (WB) */
	0x2c146121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x5828c0 (WB) */
	0x2c148121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582900 (WB) */
	0x2c14a121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582940 (WB) */
	0x2c14c121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582980 (WB) */
	0x2c14e121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x5829c0 (WB) */
	0x2c150121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582a00 (WB) */
	0x2c152121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582a40 (WB) */
	0x2c154121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582a80 (WB) */
	0x2c156121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582ac0 (WB) */
	0x2c158121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582b00 (WB) */
	0x2c15a121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582b40 (WB) */
	0x2c15c121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582b80 (WB) */
	0x2c15e121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582bc0 (WB) */
	0x2c160121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582c00 (WB) */
	0x2c162121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582c40 (WB) */
	0x2c164121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582c80 (WB) */
	0x2c166121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582cc0 (WB) */
	0x2c168121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582d00 (WB) */
	0x2c16a121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582d40 (WB) */
	0x2c16c121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582d80 (WB) */
	0x2c16e121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582dc0 (WB) */
	0x2c170121, 0x00022f8f, 	/* write array of size 9 from offset 143247 to address 0x582e00 (WB) */
	0x2c172121, 0x00022f7b, 	/* write array of size 9 from offset 143227 to address 0x582e40 (WB) */
	0x2c174121, 0x00022f99, 	/* write array of size 9 from offset 143257 to address 0x582e80 (WB) */
	0x2c176121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582ec0 (WB) */
	0x2c178121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582f00 (WB) */
	0x2c17a121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582f40 (WB) */
	0x2c17c121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582f80 (WB) */
	0x2c17e121, 0x00022e09, 	/* write array of size 9 from offset 142857 to address 0x582fc0 (WB) */
	0x2c180021, 0x00022fa3, 	/* write array of size 88 from offset 143267 to address 0x583000 */
	0x2c18b011, 0x00000020, 	/* write 32 zeros to address 0x583160 */
	0x2c18f021, 0x00022ffc, 	/* write array of size 32 from offset 143356 to address 0x5831e0 */
	0x2c193011, 0x00000020, 	/* write 32 zeros to address 0x583260 */
	0x2c197021, 0x0002301d, 	/* write array of size 8 from offset 143389 to address 0x5832e0 */
	0x00010003, 0xffff0002, 	/* if phase != 'pf', skip 1 ops */
	0x2c048631, 0x865f000a, 	/* write runtime array of size 10 from offset 34399 to address 0x58090c */
	/* CCFC */
	0x00100003, 0xffff0000, 	/* if phase != 'engine', skip 16 ops */
	0x1700c201, 0x00000000, 	/* write 0x0 to address 0x2e0184 */
	0x17010201, 0x00000000, 	/* write 0x0 to address 0x2e0204 */
	0x1702a821, 0x00023026, 	/* write array of size 2 from offset 143398 to address 0x2e0550 */
	0x1702f401, 0x00000000, 	/* write 0x0 to address 0x2e05e8 */
	0x17048021, 0x00023029, 	/* write array of size 14 from offset 143401 to address 0x2e0900 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x1702e001, 0x000e0000, 	/* write 0xe0000 to address 0x2e05c0 */
	0x00010002, 0x00130000, 	/* if mode != 'emul_reduced', skip 1 ops */
	0x17000001, 0x00001c5f, 	/* write 0x1c5f to address 0x2e0000 */
	0x00010002, 0x01050000, 	/* if mode != '!emul_reduced', skip 1 ops */
	0x17000001, 0x00001e7f, 	/* write 0x1e7f to address 0x2e0000 */
	0x17000210, 0x00000001, 	/* wait until address 0x2e0004 reads 0x1 */
	0x17000410, 0x00000001, 	/* wait until address 0x2e0008 reads 0x1 */
	0x17000610, 0x00000001, 	/* wait until address 0x2e000c reads 0x1 */
	0x17000810, 0x00000001, 	/* wait until address 0x2e0010 reads 0x1 */
	0x17038e01, 0x0000f820, 	/* write 0xf820 to address 0x2e071c */
	0x00020003, 0xffff0002, 	/* if phase != 'pf', skip 2 ops */
	0x17038001, 0x00000001, 	/* write 0x1 to address 0x2e0700 */
	0x17038401, 0x00000001, 	/* write 0x1 to address 0x2e0708 */
	0x00010003, 0xffff0003, 	/* if phase != 'vf', skip 1 ops */
	0x17038201, 0x00000001, 	/* write 0x1 to address 0x2e0704 */
	/* TCFC */
	0x00110003, 0xffff0000, 	/* if phase != 'engine', skip 17 ops */
	0x00050002, 0x00160000, 	/* if mode != '!fpga', skip 5 ops */
	0x1680c201, 0x00000000, 	/* write 0x0 to address 0x2d0184 */
	0x16810201, 0x00000000, 	/* write 0x0 to address 0x2d0204 */
	0x1682a821, 0x00023038, 	/* write array of size 2 from offset 143416 to address 0x2d0550 */
	0x1682f401, 0x00000000, 	/* write 0x0 to address 0x2d05e8 */
	0x16848021, 0x0002303b, 	/* write array of size 14 from offset 143419 to address 0x2d0900 */
	0x00030002, 0x00e40000, 	/* if mode != 'bb&(!fpga)', skip 3 ops */
	0x1682e001, 0x000e0000, 	/* write 0xe0000 to address 0x2d05c0 */
	0x16838801, 0x0000ffff, 	/* write 0xffff to address 0x2d0710 */
	0x1683c001, 0x00000002, 	/* write 0x2 to address 0x2d0780 */
	0x00060002, 0x00160000, 	/* if mode != '!fpga', skip 6 ops */
	0x16800001, 0x00001e7f, 	/* write 0x1e7f to address 0x2d0000 */
	0x16800210, 0x00000001, 	/* wait until address 0x2d0004 reads 0x1 */
	0x16800410, 0x00000001, 	/* wait until address 0x2d0008 reads 0x1 */
	0x16800610, 0x00000001, 	/* wait until address 0x2d000c reads 0x1 */
	0x16800810, 0x00000001, 	/* wait until address 0x2d0010 reads 0x1 */
	0x16838e01, 0x0000f820, 	/* write 0xf820 to address 0x2d071c */
	0x00030003, 0xffff0002, 	/* if phase != 'pf', skip 3 ops */
	0x00020002, 0x00160000, 	/* if mode != '!fpga', skip 2 ops */
	0x16838001, 0x00000001, 	/* write 0x1 to address 0x2d0700 */
	0x16838401, 0x00000001, 	/* write 0x1 to address 0x2d0708 */
	0x00020003, 0xffff0003, 	/* if phase != 'vf', skip 2 ops */
	0x00010002, 0x00160000, 	/* if mode != '!fpga', skip 1 ops */
	0x16838201, 0x00000001, 	/* write 0x1 to address 0x2d0704 */
	/* IGU */
	0x000a0003, 0xffff0000, 	/* if phase != 'engine', skip 10 ops */
	0x0c00c201, 0x000001d0, 	/* write 0x1d0 to address 0x180184 */
	0x0c00ca01, 0x00000000, 	/* write 0x0 to address 0x180194 */
	0x00020002, 0x00020000, 	/* if mode != 'bb', skip 2 ops */
	0x0c010201, 0x00000000, 	/* write 0x0 to address 0x180204 */
	0x0c010a01, 0x00000000, 	/* write 0x0 to address 0x180214 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x0c010201, 0x00000000, 	/* write 0x0 to address 0x180204 */
	0x00020002, 0x002a0000, 	/* if mode != '!asic', skip 2 ops */
	0x0c000001, 0x00000076, 	/* write 0x76 to address 0x180000 */
	0x0c000010, 0x00000000, 	/* wait until address 0x180000 reads 0x0 */
	0x00050003, 0xffff0002, 	/* if phase != 'pf', skip 5 ops */
	0x0c041031, 0x00150002, 	/* write runtime array of size 2 from offset 21 to address 0x180820 */
	0x0c041831, 0x00180001, 	/* write runtime array of size 1 from offset 24 to address 0x180830 */
	0x0c090801, 0x00000001, 	/* write 0x1 to address 0x181210 */
	0x0c041631, 0x00170001, 	/* write runtime array of size 1 from offset 23 to address 0x18082c */
	0x0c040031, 0x00130001, 	/* write runtime array of size 1 from offset 19 to address 0x180800 */
	0x00010003, 0xffff0003, 	/* if phase != 'vf', skip 1 ops */
	0x0c040231, 0x00140001, 	/* write runtime array of size 1 from offset 20 to address 0x180804 */
	/* CAU */
	0x00150003, 0xffff0000, 	/* if phase != 'engine', skip 21 ops */
	0x0e007001, 0x00000000, 	/* write 0x0 to address 0x1c00e0 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x0e010201, 0x00000000, 	/* write 0x0 to address 0x1c0204 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x0e010201, 0x00000000, 	/* write 0x0 to address 0x1c0204 */
	0x0e020801, 0x0000001f, 	/* write 0x1f to address 0x1c0410 */
	0x0e030231, 0x00190001, 	/* write runtime array of size 1 from offset 25 to address 0x1c0604 */
	0x0e020810, 0x00000000, 	/* wait until address 0x1c0410 reads 0x0 */
	0x0e220021, 0x0002304a, 	/* write array of size 5 from offset 143434 to address 0x1c4400 */
	0x0e220a11, 0x0000000a, 	/* write 10 zeros to address 0x1c4414 */
	0x0e221e21, 0x00023050, 	/* write array of size 6 from offset 143440 to address 0x1c443c */
	0x0e222a11, 0x0000000a, 	/* write 10 zeros to address 0x1c4454 */
	0x0e223e21, 0x00023057, 	/* write array of size 6 from offset 143447 to address 0x1c447c */
	0x0e224a11, 0x0000000a, 	/* write 10 zeros to address 0x1c4494 */
	0x0e225e21, 0x0002305e, 	/* write array of size 5 from offset 143454 to address 0x1c44bc */
	0x0e226811, 0x0000000b, 	/* write 11 zeros to address 0x1c44d0 */
	0x0e227e21, 0x00023064, 	/* write array of size 6 from offset 143460 to address 0x1c44fc */
	0x0e228a11, 0x0000000a, 	/* write 10 zeros to address 0x1c4514 */
	0x0e229e01, 0x00008004, 	/* write 0x8004 to address 0x1c453c */
	0x0e22a011, 0x000000b0, 	/* write 176 zeros to address 0x1c4540 */
	0x0e300131, 0x001a02e0, 	/* write runtime array of size 736 from offset 26 to address 0x1c6000 (WB) */
	0x00030003, 0xffff0002, 	/* if phase != 'pf', skip 3 ops */
	0x0e300131, 0x001a02e0, 	/* write runtime array of size 736 from offset 26 to address 0x1c6000 (WB) */
	0x0e400131, 0x02fa02e0, 	/* write runtime array of size 736 from offset 762 to address 0x1c8000 (WB) */
	0x0e800031, 0x05da1140, 	/* write runtime array of size 4416 from offset 1498 to address 0x1d0000 */
	/* DBG */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x0080c201, 0x00000000, 	/* write 0x0 to address 0x10184 */
	0x00a00111, 0x00000c00, 	/* write 3072 zeros to address 0x14000 (WB) */
	/* NIG */
	0x001f0003, 0xffff0000, 	/* if phase != 'engine', skip 31 ops */
	0x28002a01, 0x00000000, 	/* write 0x0 to address 0x500054 */
	0x28003201, 0x00000000, 	/* write 0x0 to address 0x500064 */
	0x28004201, 0x00000000, 	/* write 0x0 to address 0x500084 */
	0x28040231, 0x85e40001, 	/* write runtime array of size 1 from offset 34276 to address 0x500804 */
	0x28041c01, 0x00000001, 	/* write 0x1 to address 0x500838 */
	0x28042001, 0x0000070c, 	/* write 0x70c to address 0x500840 */
	0x00080002, 0x00020000, 	/* if mode != 'bb', skip 8 ops */
	0x28002201, 0x00000040, 	/* write 0x40 to address 0x500044 */
	0x28005201, 0x00000000, 	/* write 0x0 to address 0x5000a4 */
	0x28010201, 0x00000000, 	/* write 0x0 to address 0x500204 */
	0x28010a01, 0x00000000, 	/* write 0x0 to address 0x500214 */
	0x28011201, 0x00000000, 	/* write 0x0 to address 0x500224 */
	0x28011a01, 0x00000000, 	/* write 0x0 to address 0x500234 */
	0x28041e01, 0x00000002, 	/* write 0x2 to address 0x50083c */
	0x2845ae01, 0x00000001, 	/* write 0x1 to address 0x508b5c */
	0x00090002, 0x00150000, 	/* if mode != 'k2', skip 9 ops */
	0x28002201, 0x00000000, 	/* write 0x0 to address 0x500044 */
	0x28005201, 0x00000000, 	/* write 0x0 to address 0x5000a4 */
	0x28006201, 0x00000000, 	/* write 0x0 to address 0x5000c4 */
	0x28007401, 0x00000001, 	/* write 0x1 to address 0x5000e8 */
	0x28010201, 0x00000000, 	/* write 0x0 to address 0x500204 */
	0x28010a01, 0x00000000, 	/* write 0x0 to address 0x500214 */
	0x28011201, 0x00000000, 	/* write 0x0 to address 0x500224 */
	0x28011a01, 0x00000000, 	/* write 0x0 to address 0x500234 */
	0x28041e01, 0x0000000b, 	/* write 0xb to address 0x50083c */
	0x00010002, 0x00390000, 	/* if mode != 'mf_sd', skip 1 ops */
	0x28040e01, 0x00000001, 	/* write 0x1 to address 0x50081c */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x28007201, 0x00000000, 	/* write 0x0 to address 0x5000e4 */
	0x00010002, 0x008b0000, 	/* if mode != 'k2&ports_per_eng_4', skip 1 ops */
	0x28480021, 0x00000037, 	/* write array of size 2 from offset 55 to address 0x509000 */
	0x00080003, 0xffff0002, 	/* if phase != 'pf', skip 8 ops */
	0x2808fa01, 0x00000000, 	/* write 0x0 to address 0x5011f4 */
	0x280b3201, 0x00000000, 	/* write 0x0 to address 0x501664 */
	0x280cd231, 0x85ea0001, 	/* write runtime array of size 1 from offset 34282 to address 0x5019a4 */
	0x280cd831, 0x85eb0004, 	/* write runtime array of size 4 from offset 34283 to address 0x5019b0 */
	0x280ce831, 0x85ef0004, 	/* write runtime array of size 4 from offset 34287 to address 0x5019d0 */
	0x280d0131, 0x85f30020, 	/* write runtime array of size 32 from offset 34291 to address 0x501a00 (WB) */
	0x280d4031, 0x86130040, 	/* write runtime array of size 64 from offset 34323 to address 0x501a80 */
	0x28447c01, 0x00000000, 	/* write 0x0 to address 0x5088f8 */
	0x00210003, 0xffff0001, 	/* if phase != 'port', skip 33 ops */
	0x28081201, 0x00000080, 	/* write 0x80 to address 0x501024 */
	0x28081c01, 0x00000082, 	/* write 0x82 to address 0x501038 */
	0x28082021, 0x00022def, 	/* write array of size 2 from offset 142831 to address 0x501040 */
	0x28082c21, 0x0002306b, 	/* write array of size 2 from offset 143467 to address 0x501058 */
	0x2808f431, 0x85e50001, 	/* write runtime array of size 1 from offset 34277 to address 0x5011e8 */
	0x2808f601, 0x00000000, 	/* write 0x0 to address 0x5011ec */
	0x280af001, 0x00000001, 	/* write 0x1 to address 0x5015e0 */
	0x280b2e01, 0x00000000, 	/* write 0x0 to address 0x50165c */
	0x280c8401, 0x00000001, 	/* write 0x1 to address 0x501908 */
	0x280cc831, 0x85e60004, 	/* write runtime array of size 4 from offset 34278 to address 0x501990 */
	0x280ddc21, 0x0002306e, 	/* write array of size 2 from offset 143470 to address 0x501bb8 */
	0x280e0601, 0x1954fc40, 	/* write 0x1954fc40 to address 0x501c0c */
	0x280f8631, 0x86530001, 	/* write runtime array of size 1 from offset 34387 to address 0x501f0c */
	0x280fa801, 0x00000001, 	/* write 0x1 to address 0x501f50 */
	0x28442801, 0x00000001, 	/* write 0x1 to address 0x508850 */
	0x28447801, 0x00000006, 	/* write 0x6 to address 0x5088f0 */
	0x28448031, 0x86540008, 	/* write runtime array of size 8 from offset 34388 to address 0x508900 */
	0x28458021, 0x00000037, 	/* write array of size 2 from offset 55 to address 0x508b00 */
	0x28458601, 0x000012b7, 	/* write 0x12b7 to address 0x508b0c */
	0x28459411, 0x00000002, 	/* write 2 zeros to address 0x508b28 */
	0x28459c01, 0x000017c1, 	/* write 0x17c1 to address 0x508b38 */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x28459001, 0x00000001, 	/* write 0x1 to address 0x508b20 */
	0x00010002, 0x00940000, 	/* if mode != 'sf', skip 1 ops */
	0x280cae01, 0x00000000, 	/* write 0x0 to address 0x50195c */
	0x00020002, 0x00390000, 	/* if mode != 'mf_sd', skip 2 ops */
	0x28080c01, 0x00000083, 	/* write 0x83 to address 0x501018 */
	0x28081001, 0x00000082, 	/* write 0x82 to address 0x501020 */
	0x00020002, 0x00b20000, 	/* if mode != 'sf|mf_si', skip 2 ops */
	0x28080c01, 0x00000082, 	/* write 0x82 to address 0x501018 */
	0x28081001, 0x00000000, 	/* write 0x0 to address 0x501020 */
	0x00010002, 0x00930000, 	/* if mode != '!sf', skip 1 ops */
	0x280cae01, 0x00000001, 	/* write 0x1 to address 0x50195c */
	0x000c0003, 0x00000001, 	/* if phase != 'port0', skip 12 ops */
	0x00010002, 0x00ca0000, 	/* if mode != 'k2&sf&ports_per_eng_1', skip 1 ops */
	0x280cb821, 0x00023071, 	/* write array of size 8 from offset 143473 to address 0x501970 */
	0x00010002, 0x00cf0000, 	/* if mode != 'k2&sf&ports_per_eng_2', skip 1 ops */
	0x280cb821, 0x00023071, 	/* write array of size 8 from offset 143473 to address 0x501970 */
	0x00010002, 0x00b60000, 	/* if mode != 'k2&sf&ports_per_eng_4', skip 1 ops */
	0x280cb821, 0x00000134, 	/* write array of size 4 from offset 308 to address 0x501970 */
	0x00010002, 0x00900000, 	/* if mode != 'k2&(!sf)&ports_per_eng_1', skip 1 ops */
	0x280cb821, 0x0002307a, 	/* write array of size 8 from offset 143482 to address 0x501970 */
	0x00010002, 0x00960000, 	/* if mode != 'k2&(!sf)&ports_per_eng_2', skip 1 ops */
	0x280cb821, 0x0002307a, 	/* write array of size 8 from offset 143482 to address 0x501970 */
	0x00010002, 0x009c0000, 	/* if mode != 'k2&(!sf)&ports_per_eng_4', skip 1 ops */
	0x280cb821, 0x00023083, 	/* write array of size 4 from offset 143491 to address 0x501970 */
	0x000a0003, 0x00010001, 	/* if phase != 'port1', skip 10 ops */
	0x00010002, 0x00ad0000, 	/* if mode != 'bb&ports_per_eng_2', skip 1 ops */
	0x280cb801, 0x00000001, 	/* write 0x1 to address 0x501970 */
	0x00010002, 0x00cf0000, 	/* if mode != 'k2&sf&ports_per_eng_2', skip 1 ops */
	0x280cb821, 0x00023071, 	/* write array of size 8 from offset 143473 to address 0x501970 */
	0x00010002, 0x00b60000, 	/* if mode != 'k2&sf&ports_per_eng_4', skip 1 ops */
	0x280cb821, 0x00000134, 	/* write array of size 4 from offset 308 to address 0x501970 */
	0x00010002, 0x00960000, 	/* if mode != 'k2&(!sf)&ports_per_eng_2', skip 1 ops */
	0x280cb821, 0x00023088, 	/* write array of size 8 from offset 143496 to address 0x501970 */
	0x00010002, 0x009c0000, 	/* if mode != 'k2&(!sf)&ports_per_eng_4', skip 1 ops */
	0x280cb821, 0x00023091, 	/* write array of size 4 from offset 143505 to address 0x501970 */
	0x00040003, 0x00020001, 	/* if phase != 'port2', skip 4 ops */
	0x00010002, 0x00b60000, 	/* if mode != 'k2&sf&ports_per_eng_4', skip 1 ops */
	0x280cb821, 0x00000134, 	/* write array of size 4 from offset 308 to address 0x501970 */
	0x00010002, 0x009c0000, 	/* if mode != 'k2&(!sf)&ports_per_eng_4', skip 1 ops */
	0x280cb821, 0x00023096, 	/* write array of size 4 from offset 143510 to address 0x501970 */
	0x00040003, 0x00030001, 	/* if phase != 'port3', skip 4 ops */
	0x00010002, 0x00b60000, 	/* if mode != 'k2&sf&ports_per_eng_4', skip 1 ops */
	0x280cb821, 0x00000134, 	/* write array of size 4 from offset 308 to address 0x501970 */
	0x00010002, 0x009c0000, 	/* if mode != 'k2&(!sf)&ports_per_eng_4', skip 1 ops */
	0x280cb821, 0x0002309b, 	/* write array of size 4 from offset 143515 to address 0x501970 */
	0x00010003, 0xffff0001, 	/* if phase != 'port', skip 1 ops */
	0x28070821, 0x00000037, 	/* write array of size 2 from offset 55 to address 0x500e10 */
	/* WOL */
	0x00050003, 0xffff0000, 	/* if phase != 'engine', skip 5 ops */
	0x00020002, 0x00bb0000, 	/* if mode != 'k2&(!(!asic))', skip 2 ops */
	0x30002201, 0x00000000, 	/* write 0x0 to address 0x600044 */
	0x30010201, 0x00000000, 	/* write 0x0 to address 0x600204 */
	0x00010002, 0x00360000, 	/* if mode != '(k2&mf_sd)&(!(!asic))', skip 1 ops */
	0x3040ce01, 0x00000001, 	/* write 0x1 to address 0x60819c */
	/* BMBN */
	0x00040003, 0xffff0000, 	/* if phase != 'engine', skip 4 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x30802201, 0x00000000, 	/* write 0x0 to address 0x610044 */
	0x00010002, 0x00370000, 	/* if mode != 'k2&mf_sd', skip 1 ops */
	0x3080fc01, 0x00000001, 	/* write 0x1 to address 0x6101f8 */
	/* NWM */
	0x00050003, 0xffff0000, 	/* if phase != 'engine', skip 5 ops */
	0x00040002, 0x00a20000, 	/* if mode != 'k2&(!(!emul_mac))', skip 4 ops */
	0x40000401, 0x00000000, 	/* write 0x0 to address 0x800008 */
	0x40010201, 0x00000000, 	/* write 0x0 to address 0x800204 */
	0x40010a01, 0x00000000, 	/* write 0x0 to address 0x800214 */
	0x40011201, 0x0000003c, 	/* write 0x3c to address 0x800224 */
	/* LED */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x00010002, 0x00d40000, 	/* if mode != 'k2&(!asic)', skip 1 ops */
	0x35c0c201, 0x00000000, 	/* write 0x0 to address 0x6b8184 */
	/* PXPREQBUS */
	0x00020003, 0xffff0000, 	/* if phase != 'engine', skip 2 ops */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x02b00201, 0x00000000, 	/* write 0x0 to address 0x56004 */
	/* LAST_INIT */
	0x00410003, 0xffff0000, 	/* if phase != 'engine', skip 65 ops */
	0x80056010, 0x00000001, 	/* wait until address 0x1000ac0 reads 0x1 */
	0x84055c10, 0x00000001, 	/* wait until address 0x1080ab8 reads 0x1 */
	0x88055810, 0x00000001, 	/* wait until address 0x1100ab0 reads 0x1 */
	0x8c055c10, 0x00000001, 	/* wait until address 0x1180ab8 reads 0x1 */
	0x90055e10, 0x00000001, 	/* wait until address 0x1200abc reads 0x1 */
	0x94056610, 0x00000001, 	/* wait until address 0x1280acc reads 0x1 */
	0x00010002, 0x00020000, 	/* if mode != 'bb', skip 1 ops */
	0x13000111, 0x00003b60, 	/* write 15200 zeros to address 0x260000 (WB) */
	0x00010002, 0x00150000, 	/* if mode != 'k2', skip 1 ops */
	0x13000111, 0x000055f0, 	/* write 22000 zeros to address 0x260000 (WB) */
	0x80057e01, 0x01030012, 	/* write 0x1030012 to address 0x1000afc */
	0x84057201, 0x010a0012, 	/* write 0x10a0012 to address 0x1080ae4 */
	0x88056201, 0x010a0012, 	/* write 0x10a0012 to address 0x1100ac4 */
	0x8c057401, 0x010a0012, 	/* write 0x10a0012 to address 0x1180ae8 */
	0x90057601, 0x010a0012, 	/* write 0x10a0012 to address 0x1200aec */
	0x94058401, 0x010a0012, 	/* write 0x10a0012 to address 0x1280b08 */
	0x80057e01, 0x04000000, 	/* write 0x4000000 to address 0x1000afc */
	0x84057201, 0x04000000, 	/* write 0x4000000 to address 0x1080ae4 */
	0x88056201, 0x04000000, 	/* write 0x4000000 to address 0x1100ac4 */
	0x8c057401, 0x04000000, 	/* write 0x4000000 to address 0x1180ae8 */
	0x90057601, 0x04000000, 	/* write 0x4000000 to address 0x1200aec */
	0x94058401, 0x04000000, 	/* write 0x4000000 to address 0x1280b08 */
	0x80057e01, 0x00000000, 	/* write 0x0 to address 0x1000afc */
	0x84057201, 0x00000000, 	/* write 0x0 to address 0x1080ae4 */
	0x88056201, 0x00000000, 	/* write 0x0 to address 0x1100ac4 */
	0x8c057401, 0x00000000, 	/* write 0x0 to address 0x1180ae8 */
	0x90057601, 0x00000000, 	/* write 0x0 to address 0x1200aec */
	0x94058401, 0x00000000, 	/* write 0x0 to address 0x1280b08 */
	0x80057e01, 0x00000000, 	/* write 0x0 to address 0x1000afc */
	0x84057201, 0x00000000, 	/* write 0x0 to address 0x1080ae4 */
	0x88056201, 0x00000000, 	/* write 0x0 to address 0x1100ac4 */
	0x8c057401, 0x00000000, 	/* write 0x0 to address 0x1180ae8 */
	0x90057601, 0x00000000, 	/* write 0x0 to address 0x1200aec */
	0x94058401, 0x00000000, 	/* write 0x0 to address 0x1280b08 */
	0x80056010, 0x00000001, 	/* wait until address 0x1000ac0 reads 0x1 */
	0x84055c10, 0x00000001, 	/* wait until address 0x1080ab8 reads 0x1 */
	0x88055810, 0x00000001, 	/* wait until address 0x1100ab0 reads 0x1 */
	0x8c055c10, 0x00000001, 	/* wait until address 0x1180ab8 reads 0x1 */
	0x90055e10, 0x00000001, 	/* wait until address 0x1200abc reads 0x1 */
	0x94056610, 0x00000001, 	/* wait until address 0x1280acc reads 0x1 */
	0x80057e01, 0x01030012, 	/* write 0x1030012 to address 0x1000afc */
	0x84057201, 0x010a0012, 	/* write 0x10a0012 to address 0x1080ae4 */
	0x88056201, 0x010a0012, 	/* write 0x10a0012 to address 0x1100ac4 */
	0x8c057401, 0x010a0012, 	/* write 0x10a0012 to address 0x1180ae8 */
	0x90057601, 0x010a0012, 	/* write 0x10a0012 to address 0x1200aec */
	0x94058401, 0x010a0012, 	/* write 0x10a0012 to address 0x1280b08 */
	0x80057e01, 0x04000000, 	/* write 0x4000000 to address 0x1000afc */
	0x84057201, 0x04000000, 	/* write 0x4000000 to address 0x1080ae4 */
	0x88056201, 0x04000000, 	/* write 0x4000000 to address 0x1100ac4 */
	0x8c057401, 0x04000000, 	/* write 0x4000000 to address 0x1180ae8 */
	0x90057601, 0x04000000, 	/* write 0x4000000 to address 0x1200aec */
	0x94058401, 0x04000000, 	/* write 0x4000000 to address 0x1280b08 */
	0x80057e01, 0x00000000, 	/* write 0x0 to address 0x1000afc */
	0x84057201, 0x00000000, 	/* write 0x0 to address 0x1080ae4 */
	0x88056201, 0x00000000, 	/* write 0x0 to address 0x1100ac4 */
	0x8c057401, 0x00000000, 	/* write 0x0 to address 0x1180ae8 */
	0x90057601, 0x00000000, 	/* write 0x0 to address 0x1200aec */
	0x94058401, 0x00000000, 	/* write 0x0 to address 0x1280b08 */
	0x80057e01, 0x00000000, 	/* write 0x0 to address 0x1000afc */
	0x84057201, 0x00000000, 	/* write 0x0 to address 0x1080ae4 */
	0x88056201, 0x00000000, 	/* write 0x0 to address 0x1100ac4 */
	0x8c057401, 0x00000000, 	/* write 0x0 to address 0x1180ae8 */
	0x90057601, 0x00000000, 	/* write 0x0 to address 0x1200aec */
	0x94058401, 0x00000000, 	/* write 0x0 to address 0x1280b08 */
	0x00441401, 0x00000003, 	/* write 0x3 to address 0x8828 */
};
/* Data size: 27944 bytes */

ARRAY_DECL u16 init_ops_size = 0xda5;

/* block command offsets array */
ARRAY_DECL u16 init_ops_offsets[] = {
	0x0000, 0x0004, 0x0004, 0x0014, 0x0014, 0x0061, 0x0000, 0x0000, 0x0061, 
	0x0089, 0x0089, 0x0091, 0x0091, 0x0094, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0094, 0x0099, 0x0000, 0x0000, 0x0000, 0x0000, 0x0099, 
	0x00a2, 0x00a2, 0x00a5, 0x00a5, 0x00a8, 0x00a8, 0x00b0, 0x00b0, 0x00b3, 
	0x00b3, 0x00ba, 0x00ba, 0x00bd, 0x00bd, 0x00cd, 0x00cd, 0x00d0, 0x00d0, 
	0x00d5, 0x00d5, 0x010c, 0x010c, 0x0194, 0x0194, 0x0230, 0x0230, 0x02b4, 
	0x02b4, 0x02c8, 0x02c8, 0x038d, 0x038d, 0x0399, 0x0399, 0x0415, 0x0415, 
	0x0434, 0x0434, 0x04b1, 0x04b1, 0x05dc, 0x05dc, 0x05e5, 0x05e5, 0x0650, 
	0x0650, 0x0657, 0x0657, 0x065d, 0x065d, 0x0664, 0x0664, 0x066b, 0x066b, 
	0x0671, 0x0671, 0x0677, 0x0677, 0x07a7, 0x07a7, 0x0863, 0x0863, 0x092d, 
	0x092d, 0x09e1, 0x09e1, 0x0a92, 0x0a92, 0x0b5c, 0x0b5c, 0x0b61, 0x0b61, 
	0x0b64, 0x0b64, 0x0b6d, 0x0b6d, 0x0b70, 0x0b70, 0x0b73, 0x0b73, 0x0b81, 
	0x0b81, 0x0b84, 0x0b84, 0x0b87, 0x0b87, 0x0b8a, 0x0b8a, 0x0ba1, 0x0ba1, 
	0x0be5, 0x0be5, 0x0bea, 0x0bea, 0x0bf2, 0x0bf2, 0x0c7e, 0x0c7e, 0x0c94, 
	0x0c94, 0x0cad, 0x0cad, 0x0cc0, 0x0cc0, 0x0cda, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0cda, 0x0cdd, 0x0cdd, 0x0d4c, 0x0d4c, 0x0d52, 
	0x0d52, 0x0d57, 0x0000, 0x0000, 0x0d57, 0x0d5d, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0d5d, 0x0d60, 0x0000, 0x0000, 0x0d60, 0x0d63, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0d63, 0x0da5, 
};
/* Data size: 336 bytes */

/* Raw values array */
ARRAY_DECL u32 init_val[] = {
	0x00000030, 0x00000085, 0x00000001, 0x00000001, 0x00000030, 0x000061a8, 
	0x00000019, 0x000009c4, 0x00000030, 0x00000004, 0x00000001, 0x00000001, 
	0x00000030, 0x0000000a, 0x00000001, 0x00000001, 0x00000040, 0x00003718, 
	0x0000000f, 0x00000004, 0x0000f900, 0x00000040, 0x00004520, 0x0000007f, 
	0x00000007, 0x00000080, 0x00000040, 0x00008d60, 0x0000003f, 0x00000006, 
	0x000001f8, 0x00000030, 0x00005068, 0x00000007, 0x00000003, 0x00000030, 
	0x00006ac0, 0x00000007, 0x00000003, 0x00000030, 0x00004e18, 0x0000007f, 
	0x00000007, 0x00000060, 0x00000008, 0x00000010, 0x00000008, 0x00000008, 
	0x00000000, 0x00000000, 0x00000312, 0x00000001, 0x00000020, 0x050c0007, 
	0x051b0042, 0x00000212, 0x00000001, 0x00000030, 0x00000041, 0x00000068, 
	0x00000081, 0x00000020, 0x000000c1, 0x00000021, 0x00000030, 0x00000001, 
	0x00000004, 0x00000004, 0x00000030, 0x00000004, 0x00000003, 0x00000004, 
	0x00000080, 0x0000000f, 0x00000001, 0x00000001, 0x0000000f, 0x00000004, 
	0x00000007, 0x00000000, 0x00000003, 0x00000050, 0x00000001, 0x00000004, 
	0x00000004, 0x00000000, 0x00000004, 0x00000020, 0x00000004, 0x00000000, 
	0x000005a1, 0xcf159c78, 0x000261b9, 0x4340c300, 0xadf093c2, 0xcd1e68c4, 
	0x571471a3, 0x49de54a8, 0x7921c8ca, 0x9a8e4653, 0x29a3f232, 0x329abf23, 
	0x9194d272, 0x5c8ca6b3, 0xaae46534, 0x9a7f2329, 0x29aff232, 0x194d3723, 
	0xc8ca6bb9, 0x9e465343, 0xd2f2329a, 0xc3bebd94, 0x34cc00f9, 0x0000e119, 
	0x00000020, 0x00000041, 0x0000006c, 0x00000030, 0x00000001, 0x00000002, 
	0x00000002, 0x00000040, 0x00000008, 0x00000004, 0x00000003, 0x0000000a, 
	0x00000050, 0x00000008, 0x00000006, 0x00000001, 0x00000007, 0x00000007, 
	0x00000050, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000003, 
	0x00000020, 0x00000003, 0x00000004, 0x00000050, 0x00000011, 0x000000c1, 
	0x00000021, 0x000000a1, 0x00000041, 0x00000212, 0x00000002, 0x00000412, 
	0x00000002, 0x00000030, 0x00000003, 0x00000002, 0x00000003, 0x00000020, 
	0x00000030, 0x00000018, 0x00000100, 0x0000000d, 0x00000001, 0x00000006, 
	0x00000005, 0x0000000a, 0x00000006, 0x0000000d, 0x00000001, 0x00000003, 
	0x00000000, 0x00000003, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000100, 0x00000041, 0x00000061, 0x00000081, 0x00000001, 
	0x00000011, 0x000000c1, 0x00000021, 0x000000a1, 0x00000008, 0x00000005, 
	0x00000004, 0x00000009, 0x00000009, 0x00000008, 0x00000008, 0x00000006, 
	0x00000080, 0x0000000c, 0x0000000f, 0x0000000c, 0x0000000f, 0x0000000f, 
	0x0000000c, 0x0000000b, 0x0000000a, 0x00000030, 0x00000008, 0x00000005, 
	0x00000004, 0x00000030, 0x00000008, 0x00000008, 0x00000006, 0x00000741, 
	0xce159c78, 0x40830011, 0xcfc00000, 0xc30c30c2, 0x61861861, 0x61870c38, 
	0x18618618, 0x1861870e, 0x0c30c30e, 0x0bf38377, 0x21210871, 0x41e72325, 
	0x4d454941, 0x179693c3, 0x23033d1d, 0x6f0b3313, 0xec6cac3e, 0xb938397c, 
	0x085109b8, 0x19290931, 0x4a0a0f39, 0x9e1a6a2a, 0xe8e8bcb4, 0x98991819, 
	0x61f37859, 0xcbe76365, 0x1dc5c9c1, 0x07e103fd, 0x211f437b, 0x00000020, 
	0x0000000a, 0x0000000b, 0x00000040, 0x00000009, 0x00000003, 0x00000008, 
	0x00000005, 0x00000030, 0x00000009, 0x00000009, 0x0000000a, 0x00000040, 
	0x00008000, 0x00010000, 0x00018000, 0x00000000, 0x00000020, 0x00000078, 
	0x00000060, 0x00000070, 0x00000060, 0x00000070, 0x00000070, 0x00000070, 
	0x00000078, 0x00000078, 0x00000078, 0x00000212, 0x00000078, 0x00000080, 
	0x0000001f, 0x0000001f, 0x0000001f, 0x0000001f, 0x0000001c, 0x0000001f, 
	0x0000001f, 0x0000001f, 0x00000212, 0x00000006, 0x00000212, 0x0000000a, 
	0x00000070, 0x0000000a, 0x0000000a, 0x0000000a, 0x0000000a, 0x00000014, 
	0x00000014, 0x00000014, 0x00000212, 0x00000014, 0x00000812, 0x000000ff, 
	0x00001212, 0x00818000, 0x00000212, 0x000025e4, 0x0001c012, 0x03b9aca0, 
	0x0001c012, 0x83b9aca0, 0x00000212, 0x00818000, 0x00020012, 0x03b9aca0, 
	0x00020012, 0x83b9aca0, 0x00000040, 0x00000000, 0x00000001, 0x00000002, 
	0x00000003, 0x00000812, 0x00000002, 0x00000812, 0x00000004, 0x00000812, 
	0x00000001, 0x00000812, 0x00000008, 0x00000020, 0x00000038, 0x00000002, 
	0x00000020, 0x00000021, 0x00000020, 0x00000212, 0x00000010, 0x00000020, 
	0x00000034, 0x00000004, 0x00000020, 0x00000002, 0x00000080, 0x00000020, 
	0x0000000c, 0x00000014, 0x00000040, 0x00000083, 0x00000005, 0x00000011, 
	0x000000cb, 0x00000030, 0x0000001f, 0x00000010, 0x00000020, 0x00000412, 
	0x000005c0, 0x00000030, 0x000000a0, 0x000000a0, 0x00000060, 0x00000030, 
	0x00000080, 0x00000080, 0x00000050, 0x00000212, 0x00000360, 0x00000060, 
	0x00000360, 0x00000000, 0x00000360, 0x00000360, 0x00000000, 0x00000360, 
	0x00000212, 0x00000400, 0x00000060, 0x00000400, 0x00000000, 0x00000400, 
	0x00000400, 0x00000000, 0x00000400, 0x00000030, 0x000000e0, 0x00000360, 
	0x000000e0, 0x00000030, 0x000000e0, 0x00000360, 0x00000058, 0x00000040, 
	0x00000058, 0x000000e0, 0x00000360, 0x00000058, 0x00000030, 0x00000180, 
	0x00000400, 0x00000180, 0x00000030, 0x00000180, 0x00000400, 0x000000f8, 
	0x00000040, 0x000000f8, 0x00000180, 0x00000400, 0x000000f8, 0x00000020, 
	0x00000ad0, 0x00000000, 0x00000020, 0x000012c0, 0x00000000, 0x00000030, 
	0x00000320, 0x00000320, 0x00000190, 0x00000020, 0x00000738, 0x000012c1, 
	0x00000020, 0x000007d8, 0x000012c1, 0x00000212, 0x000012c1, 0x00000212, 
	0x000005b0, 0x00000212, 0x00000960, 0x00000030, 0x00000178, 0x00000178, 
	0x000000a0, 0x00000030, 0x000000a0, 0x000000a0, 0x00000050, 0x00000030, 
	0x000003c8, 0x00000000, 0x000003c8, 0x00000040, 0x000003c8, 0x000003c8, 
	0x00000000, 0x000003c8, 0x00000030, 0x00000468, 0x00000000, 0x00000468, 
	0x00000040, 0x00000468, 0x00000468, 0x00000000, 0x00000468, 0x00000030, 
	0x000000f8, 0x000003c8, 0x000000f8, 0x00000030, 0x000000f8, 0x000003c8, 
	0x00000070, 0x00000030, 0x00000198, 0x00000468, 0x00000198, 0x00000030, 
	0x00000198, 0x00000468, 0x00000110, 0x00000020, 0x000005b8, 0x00000000, 
	0x00000020, 0x00000960, 0x00000000, 0x00000030, 0x00000168, 0x00000168, 
	0x000000c8, 0x00000312, 0x00000050, 0x00000020, 0x000003f4, 0x000012c1, 
	0x00000020, 0x00000444, 0x000012c1, 0x00000030, 0x000000d4, 0x000003f4, 
	0x000000d4, 0x00000020, 0x000000d4, 0x000003f4, 0x00000030, 0x00000124, 
	0x00000444, 0x00000124, 0x00000030, 0x00000124, 0x00000444, 0x000000c0, 
	0x00000030, 0x000000c0, 0x000012c1, 0x000012c1, 0x00000040, 0x000003d8, 
	0x000003d8, 0x00000000, 0x00000000, 0x00000040, 0x00000780, 0x00000780, 
	0x00000000, 0x00000000, 0x00000030, 0x00000190, 0x00000190, 0x00000078, 
	0x00000040, 0x00000010, 0x00000190, 0x00000190, 0x00000078, 0x00000030, 
	0x00000050, 0x00000050, 0x00000028, 0x00000040, 0x00000008, 0x00000050, 
	0x00000050, 0x00000028, 0x00000060, 0x00000000, 0x0000029c, 0x0000029c, 
	0x00000000, 0x0000029c, 0x00000000, 0x00000060, 0x00000000, 0x000002ec, 
	0x000002ec, 0x00000000, 0x000002ec, 0x00000000, 0x00000030, 0x000000bc, 
	0x0000029c, 0x000000bc, 0x00000212, 0x00001e01, 0x00000030, 0x000000bc, 
	0x0000029c, 0x00000058, 0x00000312, 0x00001e01, 0x00000040, 0x00000058, 
	0x000000bc, 0x0000029c, 0x00000058, 0x00000040, 0x00001e01, 0x00001e01, 
	0x00001e01, 0x00000058, 0x00000030, 0x0000010c, 0x000002ec, 0x0000010c, 
	0x00000030, 0x0000010c, 0x000002ec, 0x000000a8, 0x00000040, 0x000000a8, 
	0x0000010c, 0x000002ec, 0x000000a8, 0x00000040, 0x00001e01, 0x00001e01, 
	0x00001e01, 0x000000a8, 0x00000212, 0x000000a0, 0x00000030, 0x00000070, 
	0x00000078, 0x00000078, 0x00000050, 0x00000002, 0x00000078, 0x0000007e, 
	0x00000078, 0x0000007e, 0x00000020, 0x00000078, 0x0000007e, 0x00000040, 
	0x0000000f, 0x00000002, 0x0000000f, 0x00000040, 0x00000050, 0x0000000f, 
	0x00000064, 0x0000000f, 0x0000001e, 0x00000001, 0x00000050, 0x00000001, 
	0x0000000e, 0x0000000e, 0x00000001, 0x00000001, 0x00000080, 0x00000013, 
	0x00000011, 0x00000018, 0x00000012, 0x00000001, 0x00039351, 0x00011061, 
	0x00019482, 0x00000070, 0x00011016, 0x000394c2, 0x00039325, 0x000194a1, 
	0x00000011, 0x00000182, 0x00000004, 0x00000030, 0x00000007, 0x00000007, 
	0xfffff810, 0x00000020, 0xffffffff, 0x0000ffff, 0x00000030, 0x00000082, 
	0x00000000, 0x00000080, 0x00000020, 0x00000001, 0x00000000, 0x00000020, 
	0x00000083, 0x00000082, 0x00000020, 0x00000082, 0x00000000, 0x00000020, 
	0x00000305, 0x0000030c, 0x00000020, 0x00000305, 0x00000314, 0x00000020, 
	0x00000306, 0x00000329, 0x00000020, 0x000009b9, 0x00000acd, 0x00000030, 
	0x0000030b, 0x0000030c, 0x0000030e, 0x00000050, 0x00000305, 0x0000030b, 
	0x0000030d, 0x0000030f, 0x00000310, 0x00000030, 0x00000007, 0x00000003, 
	0x0000003f, 0x00000060, 0x0001000a, 0x00032a08, 0x5d83924e, 0x00000000, 
	0x01020130, 0x00400804, 0x00000060, 0x00000000, 0x05ec0000, 0x00000000, 
	0x00000000, 0x037405ec, 0x04780960, 0x00000020, 0x000081fc, 0x00000000, 
	0x00000020, 0xffffffff, 0x00000000, 0x00000020, 0x00000010, 0x00000000, 
	0x00003fe0, 0x01001529, 0x00000100, 0x0000152b, 0x00000000, 0x00000000, 
	0x00000000, 0x0000152d, 0x00000000, 0x00000000, 0x00000000, 0x0000152f, 
	0x00000000, 0x00000000, 0x00000000, 0x00001531, 0x00000000, 0x00000000, 
	0x00000000, 0x00001533, 0x00000000, 0x00000000, 0x00000000, 0x00001535, 
	0x00000000, 0x00000000, 0x00000000, 0x00001537, 0x00000000, 0x00000000, 
	0x00000000, 0x00001539, 0x00000000, 0x00000000, 0x00000000, 0x0000153b, 
	0x00000000, 0x00000000, 0x00000000, 0x0000153d, 0x00000000, 0x00000000, 
	0x00000000, 0x0000153f, 0x00000000, 0x00000000, 0x00000000, 0x00001541, 
	0x00000000, 0x00000000, 0x00000000, 0x00001543, 0x00000000, 0x00000000, 
	0x00000000, 0x00001545, 0x00000000, 0x00000000, 0x00000000, 0x00001547, 
	0x00000000, 0x00000000, 0x00000000, 0x00001549, 0x00000000, 0x00000000, 
	0x00000000, 0x0000154b, 0x00000000, 0x00000000, 0x00000000, 0x0000154d, 
	0x00000000, 0x00000000, 0x00000000, 0x0000154f, 0x00000000, 0x00000000, 
	0x00000000, 0x00001551, 0x00000000, 0x00000000, 0x00000000, 0x00001553, 
	0x00000000, 0x00000000, 0x00000000, 0x00001555, 0x00000000, 0x00000000, 
	0x00000000, 0x00001557, 0x00000000, 0x00000000, 0x00000000, 0x00001559, 
	0x00000000, 0x00000000, 0x00000000, 0x0000155b, 0x00000000, 0x00000000, 
	0x00000000, 0x0000155d, 0x00000000, 0x00000000, 0x00000000, 0x0000155f, 
	0x00000000, 0x00000000, 0x00000000, 0x00001561, 0x00000000, 0x00000000, 
	0x00000000, 0x00001563, 0x00000000, 0x00000000, 0x00000000, 0x00001565, 
	0x00000000, 0x00000000, 0x00000000, 0x00001567, 0x00000000, 0x00000000, 
	0x00000000, 0x00001569, 0x00000000, 0x00000000, 0x00000000, 0x0000156b, 
	0x00000000, 0x00000000, 0x00000000, 0x0000156d, 0x00000000, 0x00000000, 
	0x00000000, 0x0000156f, 0x00000000, 0x00000000, 0x00000000, 0x00001571, 
	0x00000000, 0x00000000, 0x00000000, 0x00001573, 0x00000000, 0x00000000, 
	0x00000000, 0x00001575, 0x00000000, 0x00000000, 0x00000000, 0x00001577, 
	0x00000000, 0x00000000, 0x00000000, 0x00001579, 0x00000000, 0x00000000, 
	0x00000000, 0x0000157b, 0x00000000, 0x00000000, 0x00000000, 0x0000157d, 
	0x00000000, 0x00000000, 0x00000000, 0x0000157f, 0x00000000, 0x00000000, 
	0x00000000, 0x00001581, 0x00000000, 0x00000000, 0x00000000, 0x00001583, 
	0x00000000, 0x00000000, 0x00000000, 0x00001585, 0x00000000, 0x00000000, 
	0x00000000, 0x00001587, 0x00000000, 0x00000000, 0x00000000, 0x00001589, 
	0x00000000, 0x00000000, 0x00000000, 0x0000158b, 0x00000000, 0x00000000, 
	0x00000000, 0x0000158d, 0x00000000, 0x00000000, 0x00000000, 0x0000158f, 
	0x00000000, 0x00000000, 0x00000000, 0x00001591, 0x00000000, 0x00000000, 
	0x00000000, 0x00001593, 0x00000000, 0x00000000, 0x00000000, 0x00001595, 
	0x00000000, 0x00000000, 0x00000000, 0x00001597, 0x00000000, 0x00000000, 
	0x00000000, 0x00001599, 0x00000000, 0x00000000, 0x00000000, 0x0000159b, 
	0x00000000, 0x00000000, 0x00000000, 0x0000159d, 0x00000000, 0x00000000, 
	0x00000000, 0x0000159f, 0x00000000, 0x00000000, 0x00000000, 0x000015a1, 
	0x00000000, 0x00000000, 0x00000000, 0x000015a3, 0x00000000, 0x00000000, 
	0x00000000, 0x000015a5, 0x00000000, 0x00000000, 0x00000000, 0x000015a7, 
	0x00000000, 0x00000000, 0x00000000, 0x000015a9, 0x00000000, 0x00000000, 
	0x00000000, 0x000015ab, 0x00000000, 0x00000000, 0x00000000, 0x000015ad, 
	0x00000000, 0x00000000, 0x00000000, 0x000015af, 0x00000000, 0x00000000, 
	0x00000000, 0x000015b1, 0x00000000, 0x00000000, 0x00000000, 0x000015b3, 
	0x00000000, 0x00000000, 0x00000000, 0x000015b5, 0x00000000, 0x00000000, 
	0x00000000, 0x000015b7, 0x00000000, 0x00000000, 0x00000000, 0x000015b9, 
	0x00000000, 0x00000000, 0x00000000, 0x000015bb, 0x00000000, 0x00000000, 
	0x00000000, 0x000015bd, 0x00000000, 0x00000000, 0x00000000, 0x000015bf, 
	0x00000000, 0x00000000, 0x00000000, 0x000015c1, 0x00000000, 0x00000000, 
	0x00000000, 0x000015c3, 0x00000000, 0x00000000, 0x00000000, 0x000015c5, 
	0x00000000, 0x00000000, 0x00000000, 0x000015c7, 0x00000000, 0x00000000, 
	0x00000000, 0x000015c9, 0x00000000, 0x00000000, 0x00000000, 0x000015cb, 
	0x00000000, 0x00000000, 0x00000000, 0x000015cd, 0x00000000, 0x00000000, 
	0x00000000, 0x000015cf, 0x00000000, 0x00000000, 0x00000000, 0x000015d1, 
	0x00000000, 0x00000000, 0x00000000, 0x000015d3, 0x00000000, 0x00000000, 
	0x00000000, 0x000015d5, 0x00000000, 0x00000000, 0x00000000, 0x000015d7, 
	0x00000000, 0x00000000, 0x00000000, 0x000015d9, 0x00000000, 0x00000000, 
	0x00000000, 0x000015db, 0x00000000, 0x00000000, 0x00000000, 0x000015dd, 
	0x00000000, 0x00000000, 0x00000000, 0x000015df, 0x00000000, 0x00000000, 
	0x00000000, 0x000015e1, 0x00000000, 0x00000000, 0x00000000, 0x000015e3, 
	0x00000000, 0x00000000, 0x00000000, 0x000015e5, 0x00000000, 0x00000000, 
	0x00000000, 0x000015e7, 0x00000000, 0x00000000, 0x00000000, 0x000015e9, 
	0x00000000, 0x00000000, 0x00000000, 0x000015eb, 0x00000000, 0x00000000, 
	0x00000000, 0x000015ed, 0x00000000, 0x00000000, 0x00000000, 0x000015ef, 
	0x00000000, 0x00000000, 0x00000000, 0x000015f1, 0x00000000, 0x00000000, 
	0x00000000, 0x000015f3, 0x00000000, 0x00000000, 0x00000000, 0x000015f5, 
	0x00000000, 0x00000000, 0x00000000, 0x000015f7, 0x00000000, 0x00000000, 
	0x00000000, 0x000015f9, 0x00000000, 0x00000000, 0x00000000, 0x000015fb, 
	0x00000000, 0x00000000, 0x00000000, 0x000015fd, 0x00000000, 0x00000000, 
	0x00000000, 0x000015ff, 0x00000000, 0x00000000, 0x00000000, 0x00001601, 
	0x00000000, 0x00000000, 0x00000000, 0x00001603, 0x00000000, 0x00000000, 
	0x00000000, 0x00001605, 0x00000000, 0x00000000, 0x00000000, 0x00001607, 
	0x00000000, 0x00000000, 0x00000000, 0x00001609, 0x00000000, 0x00000000, 
	0x00000000, 0x0000160b, 0x00000000, 0x00000000, 0x00000000, 0x0000160d, 
	0x00000000, 0x00000000, 0x00000000, 0x0000160f, 0x00000000, 0x00000000, 
	0x00000000, 0x00001611, 0x00000000, 0x00000000, 0x00000000, 0x00001613, 
	0x00000000, 0x00000000, 0x00000000, 0x00001615, 0x00000000, 0x00000000, 
	0x00000000, 0x00001617, 0x00000000, 0x00000000, 0x00000000, 0x00001619, 
	0x00000000, 0x00000000, 0x00000000, 0x0000161b, 0x00000000, 0x00000000, 
	0x00000000, 0x0000161d, 0x00000000, 0x00000000, 0x00000000, 0x0000161f, 
	0x00000000, 0x00000000, 0x00000000, 0x00001621, 0x00000000, 0x00000000, 
	0x00000000, 0x00001623, 0x00000000, 0x00000000, 0x00000000, 0x00001625, 
	0x00000000, 0x00000000, 0x00000000, 0x00001627, 0x00000000, 0x00000000, 
	0x00000000, 0x00001629, 0x00000000, 0x00000000, 0x00000000, 0x0000162b, 
	0x00000000, 0x00000000, 0x00000000, 0x0000162d, 0x00000000, 0x00000000, 
	0x00000000, 0x0000162f, 0x00000000, 0x00000000, 0x00000000, 0x00001631, 
	0x00000000, 0x00000000, 0x00000000, 0x00001633, 0x00000000, 0x00000000, 
	0x00000000, 0x00001635, 0x00000000, 0x00000000, 0x00000000, 0x00001637, 
	0x00000000, 0x00000000, 0x00000000, 0x00001639, 0x00000000, 0x00000000, 
	0x00000000, 0x0000163b, 0x00000000, 0x00000000, 0x00000000, 0x0000163d, 
	0x00000000, 0x00000000, 0x00000000, 0x0000163f, 0x00000000, 0x00000000, 
	0x00000000, 0x00001641, 0x00000000, 0x00000000, 0x00000000, 0x00001643, 
	0x00000000, 0x00000000, 0x00000000, 0x00001645, 0x00000000, 0x00000000, 
	0x00000000, 0x00001647, 0x00000000, 0x00000000, 0x00000000, 0x00001649, 
	0x00000000, 0x00000000, 0x00000000, 0x0000164b, 0x00000000, 0x00000000, 
	0x00000000, 0x0000164d, 0x00000000, 0x00000000, 0x00000000, 0x0000164f, 
	0x00000000, 0x00000000, 0x00000000, 0x00001651, 0x00000000, 0x00000000, 
	0x00000000, 0x00001653, 0x00000000, 0x00000000, 0x00000000, 0x00001655, 
	0x00000000, 0x00000000, 0x00000000, 0x00001657, 0x00000000, 0x00000000, 
	0x00000000, 0x00001659, 0x00000000, 0x00000000, 0x00000000, 0x0000165b, 
	0x00000000, 0x00000000, 0x00000000, 0x0000165d, 0x00000000, 0x00000000, 
	0x00000000, 0x0000165f, 0x00000000, 0x00000000, 0x00000000, 0x00001661, 
	0x00000000, 0x00000000, 0x00000000, 0x00001663, 0x00000000, 0x00000000, 
	0x00000000, 0x00001665, 0x00000000, 0x00000000, 0x00000000, 0x00001667, 
	0x00000000, 0x00000000, 0x00000000, 0x00001669, 0x00000000, 0x00000000, 
	0x00000000, 0x0000166b, 0x00000000, 0x00000000, 0x00000000, 0x0000166d, 
	0x00000000, 0x00000000, 0x00000000, 0x0000166f, 0x00000000, 0x00000000, 
	0x00000000, 0x00001671, 0x00000000, 0x00000000, 0x00000000, 0x00001673, 
	0x00000000, 0x00000000, 0x00000000, 0x00001675, 0x00000000, 0x00000000, 
	0x00000000, 0x00001677, 0x00000000, 0x00000000, 0x00000000, 0x00001679, 
	0x00000000, 0x00000000, 0x00000000, 0x0000167b, 0x00000000, 0x00000000, 
	0x00000000, 0x0000167d, 0x00000000, 0x00000000, 0x00000000, 0x0000167f, 
	0x00000000, 0x00000000, 0x00000000, 0x00001681, 0x00000000, 0x00000000, 
	0x00000000, 0x00001683, 0x00000000, 0x00000000, 0x00000000, 0x00001685, 
	0x00000000, 0x00000000, 0x00000000, 0x00001687, 0x00000000, 0x00000000, 
	0x00000000, 0x00001689, 0x00000000, 0x00000000, 0x00000000, 0x0000168b, 
	0x00000000, 0x00000000, 0x00000000, 0x0000168d, 0x00000000, 0x00000000, 
	0x00000000, 0x0000168f, 0x00000000, 0x00000000, 0x00000000, 0x00001691, 
	0x00000000, 0x00000000, 0x00000000, 0x00001693, 0x00000000, 0x00000000, 
	0x00000000, 0x00001695, 0x00000000, 0x00000000, 0x00000000, 0x00001697, 
	0x00000000, 0x00000000, 0x00000000, 0x00001699, 0x00000000, 0x00000000, 
	0x00000000, 0x0000169b, 0x00000000, 0x00000000, 0x00000000, 0x0000169d, 
	0x00000000, 0x00000000, 0x00000000, 0x0000169f, 0x00000000, 0x00000000, 
	0x00000000, 0x000016a1, 0x00000000, 0x00000000, 0x00000000, 0x000016a3, 
	0x00000000, 0x00000000, 0x00000000, 0x000016a5, 0x00000000, 0x00000000, 
	0x00000000, 0x000016a7, 0x00000000, 0x00000000, 0x00000000, 0x000016a9, 
	0x00000000, 0x00000000, 0x00000000, 0x000016ab, 0x00000000, 0x00000000, 
	0x00000000, 0x000016ad, 0x00000000, 0x00000000, 0x00000000, 0x000016af, 
	0x00000000, 0x00000000, 0x00000000, 0x000016b1, 0x00000000, 0x00000000, 
	0x00000000, 0x000016b3, 0x00000000, 0x00000000, 0x00000000, 0x000016b5, 
	0x00000000, 0x00000000, 0x00000000, 0x000016b7, 0x00000000, 0x00000000, 
	0x00000000, 0x000016b9, 0x00000000, 0x00000000, 0x00000000, 0x000016bb, 
	0x00000000, 0x00000000, 0x00000000, 0x000016bd, 0x00000000, 0x00000000, 
	0x00000000, 0x000016bf, 0x00000000, 0x00000000, 0x00000000, 0x000016c1, 
	0x00000000, 0x00000000, 0x00000000, 0x000016c3, 0x00000000, 0x00000000, 
	0x00000000, 0x000016c5, 0x00000000, 0x00000000, 0x00000000, 0x000016c7, 
	0x00000000, 0x00000000, 0x00000000, 0x000016c9, 0x00000000, 0x00000000, 
	0x00000000, 0x000016cb, 0x00000000, 0x00000000, 0x00000000, 0x000016cd, 
	0x00000000, 0x00000000, 0x00000000, 0x000016cf, 0x00000000, 0x00000000, 
	0x00000000, 0x000016d1, 0x00000000, 0x00000000, 0x00000000, 0x000016d3, 
	0x00000000, 0x00000000, 0x00000000, 0x000016d5, 0x00000000, 0x00000000, 
	0x00000000, 0x000016d7, 0x00000000, 0x00000000, 0x00000000, 0x000016d9, 
	0x00000000, 0x00000000, 0x00000000, 0x000016db, 0x00000000, 0x00000000, 
	0x00000000, 0x000016dd, 0x00000000, 0x00000000, 0x00000000, 0x000016df, 
	0x00000000, 0x00000000, 0x00000000, 0x000016e1, 0x00000000, 0x00000000, 
	0x00000000, 0x000016e3, 0x00000000, 0x00000000, 0x00000000, 0x000016e5, 
	0x00000000, 0x00000000, 0x00000000, 0x000016e7, 0x00000000, 0x00000000, 
	0x00000000, 0x000016e9, 0x00000000, 0x00000000, 0x00000000, 0x000016eb, 
	0x00000000, 0x00000000, 0x00000000, 0x000016ed, 0x00000000, 0x00000000, 
	0x00000000, 0x000016ef, 0x00000000, 0x00000000, 0x00000000, 0x000016f1, 
	0x00000000, 0x00000000, 0x00000000, 0x000016f3, 0x00000000, 0x00000000, 
	0x00000000, 0x000016f5, 0x00000000, 0x00000000, 0x00000000, 0x000016f7, 
	0x00000000, 0x00000000, 0x00000000, 0x000016f9, 0x00000000, 0x00000000, 
	0x00000000, 0x000016fb, 0x00000000, 0x00000000, 0x00000000, 0x000016fd, 
	0x00000000, 0x00000000, 0x00000000, 0x000016ff, 0x00000000, 0x00000000, 
	0x00000000, 0x00001701, 0x00000000, 0x00000000, 0x00000000, 0x00001703, 
	0x00000000, 0x00000000, 0x00000000, 0x00001705, 0x00000000, 0x00000000, 
	0x00000000, 0x00001707, 0x00000000, 0x00000000, 0x00000000, 0x00001709, 
	0x00000000, 0x00000000, 0x00000000, 0x0000170b, 0x00000000, 0x00000000, 
	0x00000000, 0x0000170d, 0x00000000, 0x00000000, 0x00000000, 0x0000170f, 
	0x00000000, 0x00000000, 0x00000000, 0x00001711, 0x00000000, 0x00000000, 
	0x00000000, 0x00001713, 0x00000000, 0x00000000, 0x00000000, 0x00001715, 
	0x00000000, 0x00000000, 0x00000000, 0x00001717, 0x00000000, 0x00000000, 
	0x00000000, 0x00001719, 0x00000000, 0x00000000, 0x00000000, 0x0000171b, 
	0x00000000, 0x00000000, 0x00000000, 0x0000171d, 0x00000000, 0x00000000, 
	0x00000000, 0x0000171f, 0x00000000, 0x00000000, 0x00000000, 0x00001721, 
	0x00000000, 0x00000000, 0x00000000, 0x00001723, 0x00000000, 0x00000000, 
	0x00000000, 0x00001725, 0x00000000, 0x00000000, 0x00000000, 0x00001727, 
	0x00000000, 0x00000000, 0x00000000, 0x00000010, 0xffffffff, 0x00000410, 
	0x00000001, 0x00000000, 0x00000002, 0x00000000, 0x00000003, 0x00000000, 
	0x04010003, 0x00000000, 0x00000000, 0x00000000, 0x04010000, 0x00000000, 
	0x10000101, 0x00000000, 0x00000102, 0x00000000, 0x00000103, 0x00000000, 
	0x04010103, 0x00000000, 0x10000100, 0x00000000, 0x14010100, 0x00000000, 
	0x10000200, 0x00000000, 0x00030504, 0x000000ff, 0x00030504, 0x000000ff, 
	0x00030504, 0x000000ff, 0x00030504, 0x000000ff, 0x00030504, 0x000000ff, 
	0x00030504, 0x000000ff, 0x1c000300, 0x00000000, 0x1c000400, 0x00000000, 
	0x00030504, 0x000000ff, 0x04020003, 0x00000000, 0x04020000, 0x00000000, 
	0x00030504, 0x000000ff, 0x00030504, 0x000000ff, 0x00030504, 0x000000ff, 
	0x00030504, 0x000000ff, 0x00030504, 0x000000ff, 0x00030504, 0x000000ff, 
	0x00030504, 0x000000ff, 0x00030504, 0x000000ff, 0x00010290, 0x00000612, 
	0x00010001, 0x00000090, 0x00020002, 0x00040003, 0x00080006, 0x0010000b, 
	0x001f0015, 0x003e0029, 0x007b0052, 0x00f600a4, 0x01ec0148, 0x00000212, 
	0xffffffff, 0x00000040, 0xffffffff, 0xffffffff, 0x00000000, 0x00000000, 
	0x000001a0, 0x01000010, 0x00000000, 0x02000030, 0x00000000, 0x03000010, 
	0x00000000, 0x00000014, 0x00000000, 0x00020014, 0x00000000, 0x00000114, 
	0x00000000, 0x00020114, 0x00000000, 0x04000000, 0x00000000, 0x0001001c, 
	0x00000000, 0x0001011c, 0x00000000, 0x02000048, 0x00000000, 0x03000020, 
	0x00000000, 0x00000000, 0x00000000, 0x00000020, 0x01760000, 0x00000018, 
	0x00000020, 0x00000000, 0xbfff0000, 0x000000e0, 0xfff3ff01, 0x00000fff, 
	0xfff3ff05, 0x00000fff, 0x00003dc1, 0x00000ffe, 0x001ffdc1, 0x00000ffe, 
	0xffffe3ef, 0x00000fff, 0xffffffe1, 0x00000fff, 0x01ffffc1, 0x00000ffe, 
	0x00010012, 0x001e2f12, 0x0003be51, 0x7dcd9c78, 0xd5547c0d, 0x77b9f799, 
	0x99dcccee, 0x0849924c, 0x00c02010, 0x3aa04421, 0x4c4634c4, 0x090426f5, 
	0x55d01a08, 0x2835bad6, 0x8b6fa20a, 0x6d6c1636, 0x601933bd, 0x04490f86, 
	0x8eed5a15, 0xae952b16, 0x2edaee2f, 0x08deb755, 0x376d60ae, 0x5f6ad756, 
	0x8a8c06db, 0x514bb66d, 0xde58a46b, 0x739cffe7, 0x3f011f33, 0xf9b7f777, 
	0xee78e4fd, 0xe79cf73d, 0x3ef9e73c, 0xe27339cf, 0x6b1389c4, 0xdb62136f, 
	0x56309ae9, 0x46b3fa0a, 0x884eb8bf, 0xf62da283, 0x3dba8d92, 0x44225eda, 
	0xc5a36844, 0xfbc6215c, 0x1a9dd19d, 0xccbef3b7, 0xf1ede3a5, 0xafb1bb73, 
	0x77b777d2, 0x72b7b92d, 0x737510ad, 0xad77e1ac, 0xd04d0216, 0x6265cb4d, 
	0x88423dba, 0x4a6f49dd, 0x27dd5274, 0x853b8eec, 0x1cd53e08, 0xca8b796c, 
	0x16b42b67, 0x7a1a7e7a, 0xa544223e, 0x436367b5, 0xf699ca94, 0xee16fd46, 
	0x23a8335f, 0x13d6c063, 0xa1388523, 0xa12c36e0, 0xdf9df4eb, 0x2f78b474, 
	0xe962d3f5, 0x48adb768, 0x12ae3ac4, 0x12d18682, 0x07b7f542, 0x68d9edfd, 
	0x6883d2b4, 0xf186033d, 0xd5378c4c, 0xfa61db8e, 0x278eea3e, 0x71c84334, 
	0x7c71a41e, 0xe9c5ada6, 0x12d33d3d, 0xfaa7689d, 0xe373d489, 0xa6fd68ca, 
	0x07884444, 0x3c273faa, 0xf3e066ef, 0x313584d5, 0x88ef084a, 0x8fb93074, 
	0x55c56bca, 0xebd71a49, 0xa7ae8c73, 0xbdf10f19, 0xedda2131, 0x1a0ac6f3, 
	0xce27aff7, 0xe15c7613, 0x6e7a1ae7, 0x49511e8a, 0xf8547565, 0xa6af08da, 
	0x0ad5add8, 0x36634cd1, 0xebc6c91e, 0xdaf0389a, 0xc6328a6a, 0x029144c3, 
	0x73ab2bde, 0x5850b3e7, 0xf01f8065, 0x79f04ddd, 0x5e672b4d, 0xf3b9d595, 
	0x8e7f885a, 0x10224902, 0x1d74351b, 0xde12272b, 0x8d088f80, 0x9d667ef3, 
	0xa619bc5c, 0x1d79fee0, 0xdff51db8, 0xf7bfc193, 0xa34068f4, 0xb9a95f7e, 
	0x31778854, 0xf6699cce, 0x85562141, 0x47deab45, 0x25d374f4, 0x36fe007f, 
	0x3fe33499, 0xadb0fbd1, 0x3c3096c7, 0xe0296361, 0x7e696024, 0x7610c761, 
	0x5303ea8a, 0x971e3644, 0x6fdc6d99, 0x594f25c1, 0xc278332f, 0xe6c1f7c1, 
	0x146b5b36, 0xb23a9fa2, 0x56c7a32f, 0x3d505e92, 0x35bae61a, 0x2befe6d7, 
	0xd3a03109, 0x6172d6fe, 0xdd084aff, 0x6c40b6a2, 0x45d1de9b, 0x9313f570, 
	0x5ad257d8, 0x8d8a4dcc, 0x08cfc21e, 0xeeaee99b, 0x5ae88fc7, 0xf7a8518a, 
	0xb63c1d63, 0xe7883c96, 0x3d26ea37, 0xc42a618f, 0x71a2016f, 0xc74c75fd, 
	0x4b276b16, 0xa3c209fc, 0x7cf04c3d, 0xeb4dcf2a, 0x333be813, 0x44758ba9, 
	0x33bbc207, 0x82fe0826, 0xbac66595, 0xe1ebc025, 0x6fbc359b, 0x23df088d, 
	0xbf558f04, 0xc19a5c52, 0x9ad22eaf, 0x61f14a3d, 0x679310bb, 0xdd637676, 
	0xeed4a3fa, 0x58b87a25, 0xd2c7afd1, 0x47bee7c1, 0xce910163, 0xfd70cff4, 
	0xf9f79e88, 0x34d33a5d, 0x2eaebefa, 0x196d6bad, 0xa49782b8, 0xda9db135, 
	0xc398d0b5, 0x85c3ce87, 0xa8d3e79b, 0xc14ebee0, 0x87a7dd7d, 0x2c2bcebb, 
	0x8fdd49f0, 0x4234d2df, 0xd6ccbfaa, 0x17a4deba, 0x452d313d, 0x3a477ae3, 
	0xd5196c7a, 0xd8f79b7b, 0x178faa01, 0x1785cb3a, 0x90975a63, 0xf6ba03eb, 
	0x06adb6d5, 0x7ac2691e, 0x7f39c917, 0xdc75ad85, 0x53de9281, 0x5e8af37b, 
	0x8414b01d, 0x10752d6c, 0xe8a5a3a5, 0x1d6af3c1, 0x5a13a0fd, 0xb5037f47, 
	0xbe11ba27, 0xbef1b0a6, 0x04753f84, 0x8df29dcf, 0x4866c244, 0x9a6305ac, 
	0x24f29165, 0x5be215ea, 0x8f4caf5c, 0xa7307c84, 0x5d01af8b, 0xfa75ad66, 
	0x59f92cfa, 0x758af340, 0x5b8ae465, 0xa5b8e3ba, 0x958be08f, 0xca3af67c, 
	0xf3a1ae8e, 0xa3ef1fc8, 0x6e735f4a, 0xaff96e3f, 0xbf3c6f0a, 0xe383c023, 
	0x9f81b589, 0x12b9fc69, 0x5f53e0cf, 0xad19d133, 0xa5f80fab, 0x58560e75, 
	0xaac4cc7a, 0x7f71a53d, 0x7ca06141, 0x0ba225bd, 0x7afe7b92, 0xe53d03db, 
	0x09abdd5f, 0x26d3775a, 0x58d3a6d1, 0x5e268ef5, 0x2c2a7ea3, 0x834faf0f, 
	0x4e483615, 0x4c00202c, 0xfcc0afa2, 0x9e948788, 0x7b496a28, 0x2f8c7ec4, 
	0xe283c60c, 0x096ed17f, 0xb4ac138c, 0x84b0b13d, 0xfd12b93b, 0x854afcd1, 
	0x76c90c28, 0x2cb26585, 0xf15ea4d3, 0xd618f2a9, 0xdc366574, 0x016f2724, 
	0x7c0796bc, 0x5f894661, 0x0b3ac29e, 0x828963a3, 0xafaaf49f, 0x0f139e9e, 
	0xf18b5a89, 0x6efe8ad6, 0x885a71a2, 0xb9f9cadf, 0x66c13f40, 0xff7e5709, 
	0xafea90e1, 0x4045d6de, 0xa655738d, 0x9a4b60ff, 0xcce3c6f1, 0xea8e6212, 
	0x5c4f1ddf, 0xc22ffb22, 0x7b3f3bbc, 0xffd0f3ff, 0x61ff4cd1, 0xbfdc37c5, 
	0x48378cc8, 0xcf1ca76f, 0x3c78e93a, 0xa073ad0e, 0x8527de8d, 0x3e7f38b8, 
	0x42ff65f3, 0xccb9d26f, 0x15f4cbf4, 0x493a2168, 0xac0dfa65, 0xdfb9d36e, 
	0xcd5faa16, 0x6231ea70, 0xf7e825c8, 0xfebf4c9d, 0x47ae4736, 0x2193a483, 
	0xfec99770, 0xa2ee0a3f, 0x57ffd966, 0xfdba5d14, 0xb3ca7cf3, 0xbfebcfe1, 
	0xf072f082, 0x94bff463, 0xbecfa7fa, 0x07fe8a79, 0xd6a123d7, 0x7a078d43, 
	0xd7e2c92e, 0xc2f5e9a2, 0xa0de7243, 0x0c8ed307, 0x7bce1e7d, 0xe273c41e, 
	0x27e9520b, 0xe7803f6d, 0xe31fe927, 0xa7f4974f, 0x5df140ff, 0x5f27e57a, 
	0x369f5e3f, 0x857b8eb5, 0x851d4a98, 0x85d0e8b3, 0xfd37eb0f, 0xb90eb97d, 
	0x3935c5e3, 0x7778c39e, 0x5517d3d7, 0x817c86f8, 0x669d595e, 0x693e337c, 
	0xd2547f3c, 0xbbc61d7d, 0xb9e324e9, 0xf975a3f3, 0x8c87e741, 0xe3f7d6a7, 
	0x8a74d78e, 0x1b3cf0f1, 0x450adbcf, 0xd921f423, 0x0ec44799, 0xfaa64faa, 
	0xf2fd191d, 0xf4e5269e, 0xbda9289b, 0x455989f7, 0xbfb667e0, 0xda47c56a, 
	0x48e2fa5f, 0x7602e7ec, 0x370d7918, 0x69dbff13, 0xb7d12f6d, 0xafec9d31, 
	0xbfb68f92, 0xfeaeedf2, 0xbc4b15b0, 0xfe227524, 0xefece173, 0xec1db9b1, 
	0x108764b0, 0x83858beb, 0x37ff59f5, 0xc3b003d3, 0x9b2c2fd6, 0x607a425b, 
	0x079525fd, 0x54fe6f60, 0x417ee5c9, 0x7b0a5dfd, 0xa383fa83, 0x760d2c20, 
	0x10ad1190, 0x996ca96b, 0x16ed82bd, 0xd630aac3, 0x91bdfe11, 0x876a0f7d, 
	0xfaeabbe9, 0x9535765d, 0xaaec36d7, 0x7fa45327, 0x8cb2ade5, 0x467e4953, 
	0x2f5556ff, 0x61d2ee8b, 0x66ce46ef, 0xfe9a6b80, 0x3fd0f189, 0xc89761b3, 
	0x46c9b3b2, 0xf1617594, 0xaec196bc, 0xbfd95d79, 0x63fa476c, 0xfaf76c9d, 
	0xb003c963, 0x44d31f97, 0x4c619f96, 0xfb05dd6c, 0x13b1fc8b, 0xf1069bb0, 
	0xfcbc23e2, 0x9810878e, 0x1177eb9e, 0x395988d5, 0x263783fe, 0x8a9407e0, 
	0xa379ec18, 0xae5ffa5a, 0x09faef1d, 0xf78f1dae, 0x50fc76d9, 0x760d0a3c, 
	0x3c7817bc, 0x8d4e3c08, 0x817abf41, 0x7813e047, 0x45df4e5c, 0x3f3b8f08, 
	0xcd5f1e0d, 0x0bb563c5, 0xe3c527c7, 0x8f0a9f6b, 0x81fcd76f, 0x9b0c2bbf, 
	0xbddcafec, 0xec1a79a7, 0xd9c0fd0e, 0xf86c2abb, 0xe783c2cb, 0xf4c2d1fe, 
	0x71c8bc61, 0x3e02f80f, 0xeb49f335, 0xa7ea0673, 0x6022545f, 0xfbe38297, 
	0xd9b0b000, 0x23be170e, 0xd7c11add, 0x9e3dfd30, 0x881b28a7, 0x587de195, 
	0xb7ae0074, 0xcfc2fe6b, 0x3df8f63f, 0x47f8f3ef, 0x8e4e3a7f, 0x01bcf3d7, 
	0xd9ecbcfb, 0x29cf093a, 0x27ebf7c7, 0x88be7f1b, 0x3360fdec, 0xf25cb1f8, 
	0x491df12f, 0x90fe219e, 0xa7e61c26, 0x5a8d7f41, 0xec4abea1, 0xe5ef6b1b, 
	0xbf695af5, 0xfc92d584, 0xc4f251fc, 0x3a111d5f, 0x27f842ec, 0x8b1e008f, 
	0x720344ed, 0x7f5fe489, 0x511fae7d, 0x20b5e890, 0x5295bc6f, 0xde8c24de, 
	0x9049e4d9, 0x1e602dff, 0x16c8a308, 0x1fd8735d, 0xa81837d7, 0xeec20f3b, 
	0x09e5bfa6, 0x4aab720d, 0xbd636f17, 0x459d9ae2, 0x6e589f17, 0xcea5e1e5, 
	0x1c7775af, 0x98187c62, 0x2e18a967, 0x6a5ea88a, 0x6a23170e, 0xf00f1c78, 
	0x3da587a4, 0xf889345b, 0x62d9ec92, 0x09bed1d2, 0x39777af4, 0x8775a7af, 
	0xc59fad47, 0x81169375, 0x98b4d7d7, 0x5cfd08be, 0xc41cefa7, 0xe1234a0f, 
	0x1047fed9, 0x9d7210cf, 0xd47df905, 0x37ec9a7f, 0xdee88bd0, 0xd0fa75cb, 
	0xbaffb470, 0x8ebe82f9, 0xb0be6adb, 0xa1512377, 0x0c1d12f7, 0x48737d27, 
	0xe6a533cd, 0xefdf9077, 0x5c0cd115, 0x844a7ba5, 0x1e0e50ef, 0x0b3a5f1c, 
	0x8a3c5b0f, 0x0f1c3e8f, 0x0be56466, 0x246093a0, 0xaa24b6ba, 0xe144bfe6, 
	0x8669c685, 0xe1477b00, 0x0c23f181, 0x07c480fb, 0xdd7f3fd6, 0x51f2f1f2, 
	0xb78f98eb, 0xf9aebacf, 0xebb4ff78, 0xaaf571fc, 0xe5f20fab, 0x837332fd, 
	0x954abe2e, 0x7e27c936, 0xdbd7137d, 0x0dd89609, 0x8739bf78, 0xf4bbfe8f, 
	0xf3e0a9fe, 0x039f7feb, 0xf98f4b8f, 0xfa527c70, 0xbffb87cc, 0xc4875e9b, 
	0xf7e8f2a1, 0xd9fb7454, 0xb919f7d7, 0x7beb837e, 0x6f9f0720, 0xf582fcd7, 
	0x651c2844, 0xb697a47d, 0x9ef23eb2, 0xeb03fd1e, 0x688fd3fd, 0xcdadfe92, 
	0xc60e9388, 0xbfa42b55, 0x6d5d5edc, 0xf195ef6c, 0xd0b551cd, 0x2fbf3dc3, 
	0xcf71c25f, 0x18d2f7b5, 0x512010af, 0xfa4257b2, 0x4cce922b, 0x7ea3162b, 
	0xef0323db, 0xafe50e21, 0xdb6b16ae, 0xddb13f64, 0x7a585f88, 0xe3479f8c, 
	0x9fb2d36b, 0xc387a835, 0x5bfa37ac, 0x1c9d8e08, 0xbec389f7, 0x52eab8e3, 
	0x6eea2e39, 0xb0fd21bf, 0xa81f3d0e, 0x71ccdfaf, 0x18b3ead1, 0xe13e3c27, 
	0xc8e26fa1, 0x7ea7da14, 0x250458d6, 0x19505a96, 0x7633d328, 0xf8e44c16, 
	0xefbe0cf0, 0x42d31d27, 0x2bd7b8f3, 0xa7aae9ed, 0x4fc0839a, 0x1047109d, 
	0x74d54dd7, 0x0b5fd005, 0x3d91a77d, 0xe7bea55e, 0x999dd738, 0x109ac87e, 
	0xb3c4e9a4, 0xeea7ec86, 0x60a48fc7, 0x1c4d54b7, 0x7277eb65, 0x067bb19c, 
	0x6927edc9, 0x6f88519c, 0x803fab4f, 0x2c67bd7e, 0x3800814c, 0xfe76494e, 
	0x93b27ebd, 0x35ebe0b3, 0xee5fbda4, 0xeac53bf6, 0xea9d3b46, 0xbdf9e8c3, 
	0x200c6d6f, 0xf4455b1e, 0x9d5f3889, 0xdb3ba9bf, 0x8d09f85f, 0x7a12be57, 
	0x59d7da56, 0xec14e9f1, 0x237f3acb, 0x1baaafb7, 0xbad068d8, 0x5fa57814, 
	0x0bf6ae99, 0xefd69dc0, 0x4a0f840c, 0x5e88a6fc, 0x033cd246, 0xa4e213c0, 
	0xfd463ef4, 0x55f6a18e, 0x4e30467d, 0xa5557876, 0x60ff0026, 0x7a6351b9, 
	0xf8c1ce82, 0x8ad95277, 0xfc647bf9, 0x355f7dc5, 0x14f7965d, 0x00ec3c49, 
	0xbbdda93e, 0x7c7f391e, 0x114efecf, 0x7bf523ad, 0x805b8d3b, 0xfa5feb75, 
	0xb57131f3, 0xf657642e, 0x69a7dcd7, 0x614527ac, 0x078c8972, 0x79a29ec5, 
	0x214ec946, 0xc8f6cef8, 0xf95d4778, 0x96668593, 0xabe2e31d, 0x14e3776e, 
	0x7ccce883, 0xa0c8bbb4, 0x84fd9a39, 0xb5d9d85f, 0x974a215a, 0xc14fd07e, 
	0x13879e4a, 0x71f113bf, 0x6be76c67, 0x0247b74c, 0x93952744, 0xd975cbb6, 
	0x3e9e31a9, 0xf1f3d0ff, 0xfe7883f2, 0x724a3c4a, 0x5a1cfe60, 0xe3ea52c7, 
	0x417bd6f2, 0x7cd0e727, 0x5d97804a, 0xbfa0525b, 0x417cefcf, 0xd6485387, 
	0xd5798d8e, 0x23a61cee, 0x43f37d48, 0x71c37e5b, 0x0ec35ddb, 0x5e7e4688, 
	0x5c5fdb28, 0x1513f788, 0x700d7c9d, 0xa79377d1, 0xff0bdd76, 0x88d36bf4, 
	0x4d3f20ce, 0xcd43b382, 0x437bde83, 0x65a5d696, 0xc3c5cfe8, 0x970fc55a, 
	0xbc33fc2b, 0xed2fd887, 0x5187fec5, 0x3e69f924, 0xf1e687e8, 0x5bfed575, 
	0xa5bf5d6a, 0x53f173be, 0x27e4b139, 0x9c8cf6e6, 0x2386dfc1, 0x3f71f76c, 
	0xf8ee7f6e, 0xfcfd543f, 0x32cdd15a, 0x8e4f1af3, 0x73b7cabe, 0x5d3ca33f, 
	0xfd946e21, 0xff463ec3, 0x45fec3ba, 0xe131b6c1, 0xeb9608c4, 0x2e576d63, 
	0x1079652c, 0xdd852ff5, 0x2d7f6c2d, 0xb1efc3f7, 0x7ce526ef, 0x0df7d8ef, 
	0x05fbaefe, 0xdf9dfd9b, 0xbcea1e80, 0x6916cd76, 0xa75feecf, 0xc35cfc29, 
	0x1d9e38fd, 0x88a7861f, 0xf034f537, 0x7e4de6d4, 0x92afc68b, 0x787f75eb, 
	0x7f09a94d, 0x409114ce, 0xe5afad1f, 0x130e4d8c, 0xede14ba2, 0x452f1501, 
	0x8a42fc1d, 0x7939002d, 0x3d5765ff, 0xfa266e1e, 0xe489890a, 0xf55f1036, 
	0x9b32dd1e, 0xecb137d6, 0xecb0cefd, 0x885abec7, 0x6a5da679, 0xa3b6fbf3, 
	0xfbc69e5b, 0x55dfef29, 0x2995df4c, 0xd2a90efe, 0x46bbfc90, 0x15f82df1, 
	0x503f86fb, 0x33aee074, 0xbb7855e4, 0x99581f7c, 0xb784a791, 0xa2f8e200, 
	0x02ec6ad3, 0x315b76fe, 0x526ce7ec, 0x27407074, 0xb5237089, 0xc5e4aadf, 
	0xbbae3971, 0x717caece, 0x513a03cb, 0xd2bfe910, 0x968c561d, 0x1143a45f, 
	0xf2508b6d, 0x57652aee, 0xdf3b2c7c, 0x7b267d4e, 0x074e8f30, 0xc968c1ed, 
	0xb83da8ff, 0xc3dcfc42, 0xbe9f3a7a, 0x270b8f57, 0xa3effaee, 0x3f0a716f, 
	0x24bbf183, 0x536b7ecf, 0xc23fda76, 0x0e39b3ce, 0xe408f8c6, 0xb2a7c3ac, 
	0xe1d7f2db, 0xd6077e94, 0x0bd9e085, 0x9c5da91f, 0xaaab7ed2, 0xf4c87495, 
	0x89a4bc0a, 0x5f400f5e, 0xa5858f0e, 0x7d8ddd7f, 0x923d0cab, 0xac27f085, 
	0xd6f35fc3, 0x875e65e1, 0xfbc2b0a0, 0x5fc50f86, 0xb113d4ff, 0xf654e9c4, 
	0xf0198f1d, 0xf0370fa3, 0xa877fecb, 0x81b77d8e, 0x31671906, 0xcdef903e, 
	0x65f7c82f, 0xe5f7c81f, 0x2bef905f, 0xd55abd55, 0x7afb556b, 0x3bb5ded9, 
	0x6206ebfa, 0x5329891b, 0x0c07693e, 0x5e5b9bee, 0x9ea263d6, 0xc324b9e6, 
	0x0f653ea7, 0x42c9d01c, 0xe7bcfe21, 0x918f4c44, 0xfe220a5c, 0x3f0b3c3b, 
	0x187e25ab, 0xfb27442f, 0xaed7c90c, 0x5e2ff1fd, 0xd01ccf69, 0x2dbd8349, 
	0xe8bd08f1, 0xa133547f, 0x6d0dfdb7, 0x6881ea3a, 0x5539db09, 0x11bbd7a4, 
	0xf3f7a56f, 0xfd381922, 0xfb1d69b5, 0xe9355586, 0x19a7f414, 0x9ed8d5ed, 
	0x9ffd256c, 0x158f5e86, 0x8aafbf43, 0x69d7efa6, 0xbc3f7ddd, 0x303a0e38, 
	0xc71cd39b, 0x37fdba0d, 0xc9377ad8, 0x9fb52085, 0x79bfd59f, 0x10d74449, 
	0xec8d692f, 0x1734bd85, 0x69fe4274, 0xdb08a2d5, 0x3a567573, 0xe0fb5062, 
	0xf0dfcefc, 0xa46b57fe, 0x40147010, 0x17bf538f, 0xf6e87d2a, 0x78fa2967, 
	0x3767d954, 0xc302f43f, 0x974de17b, 0xbe9ba2eb, 0x35edfec7, 0x8311dfa8, 
	0x7b7373bf, 0x43489f5c, 0x2fda957e, 0x53577ec4, 0x44cbdb0f, 0x1788bdaa, 
	0x9ec89afb, 0x5a2c3d40, 0xef983bbd, 0xe47de05e, 0x51a78226, 0xa50703d9, 
	0x4a358fde, 0xbe72007b, 0x03e18bf2, 0x16aa1fb0, 0x9ed80677, 0xf6cadc58, 
	0x52f332c4, 0x76b47203, 0x0ced9871, 0xa784bfd6, 0x72b797c9, 0xb57fc1be, 
	0x097b661e, 0xadd41679, 0xa6ec076f, 0x8efc38ae, 0x78ae9aaa, 0xf8a1e594, 
	0xe7fa71cd, 0x33af2b8d, 0xb2ac07e0, 0x69e6e44f, 0x28edea2c, 0x40fcd3f3, 
	0x05e784cf, 0x9d0bd605, 0x22ab0eb4, 0x1e01eed2, 0xb5259ed9, 0x1d7e09d3, 
	0xc616fbc4, 0xa3ba85e3, 0x82f784db, 0xde98c39d, 0x17f7a7cf, 0x4830df60, 
	0x6bf207f2, 0x898e3851, 0xc6753555, 0x3b1943f4, 0x80cbb5cd, 0x7e3ec2f7, 
	0x943882ff, 0xbb5ccbb1, 0x5ce3b5ce, 0x38ed8dbb, 0x7eb75de0, 0xe15ce2a9, 
	0x483e0e98, 0x374afcf0, 0xbe05fd4a, 0xe8cf6d89, 0x744e7baf, 0xf537d86b, 
	0x3d1c8857, 0xf92bc078, 0x37a8342a, 0x7e7ec937, 0x99d8fd48, 0xa97f5c7e, 
	0xf78eb13d, 0xfda8ab4b, 0x6fd3d830, 0x63cc7485, 0x3eaffc3e, 0xf9ca51f4, 
	0x29474c10, 0xd0dd9f9e, 0x7da076c7, 0x73ba2d49, 0x49e3b7f5, 0x732d7f52, 
	0xdb02798e, 0x07b07f65, 0x3bf2b8df, 0xfe5ee406, 0xc34f007a, 0x0cbad52b, 
	0xa03fb4cb, 0xf2464793, 0xeb6ce8d1, 0x3f366c46, 0x6e78269f, 0xd04b5e6e, 
	0x40d8d81a, 0x4b6a65fe, 0x47790cbc, 0xc5cdbe6e, 0x5c4329c2, 0xa38e7538, 
	0xcf2a6de9, 0x7d26d306, 0x1e6ef78b, 0x3ee48052, 0x9b9cc1e7, 0x7ee73f1b, 
	0x5b2761eb, 0xf00cb6cb, 0xc790d8ba, 0xcff95c6f, 0x13b64f8c, 0x62f9c946, 
	0x1f9dc2ff, 0x3535e7cf, 0x33f25b4f, 0x1cfc0de8, 0xdbd0cc6e, 0xc35b32aa, 
	0xd5f85e3a, 0x1dc871d1, 0xf740fe97, 0xdf8aa5a1, 0xedff8147, 0xf8e47392, 
	0xbd683adb, 0x1c8afdef, 0x9db8eb07, 0xde106cf0, 0xa57f5066, 0xa93a4ab7, 
	0x66e66bf3, 0x37874749, 0x1fbafb51, 0xdc87169d, 0xf43f5d34, 0x33e9a747, 
	0x33557740, 0xff4451f4, 0x46f3c4db, 0x6cddbc76, 0x7cc6eb6e, 0x67b73eea, 
	0x5c321201, 0x2976173f, 0xa97d81e6, 0x9fa49f70, 0xbc9951ae, 0x216dfc25, 
	0xeefe6638, 0x34b529ec, 0xfcff869f, 0x2a0694c9, 0x76713dcf, 0x392411b5, 
	0x7558fc57, 0xf1a6ca88, 0xa32b4f33, 0xea5d03f2, 0x1e33e6d7, 0xea82ad3b, 
	0xfaface73, 0xf79508d4, 0xa078d214, 0xcf573b27, 0x8cfbd01c, 0xfe331b92, 
	0xd49f26ef, 0x3b212d17, 0xb6fad36e, 0x87155f34, 0x699c16bd, 0x10be23b7, 
	0x1b5e22b0, 0xbee6b872, 0x433a44f6, 0x9cf383ef, 0x3f871ad9, 0x3e79a817, 
	0x3f10ba26, 0x2ab9f291, 0x9e817248, 0xedd29b07, 0x6d12775b, 0x051f24fb, 
	0x21dba517, 0xe5b95def, 0xa1b6145f, 0xad041627, 0x7c68db2d, 0x503d5ae3, 
	0xa4afef4e, 0x2fe033f6, 0x4ced73ad, 0x7b498f4b, 0x6c1e8744, 0xb7cb0a8f, 
	0xaac70334, 0x2c5c4896, 0x5b5af6a7, 0x9a3efd7a, 0xe9f8b15f, 0xaafc18a6, 
	0x7aee73ee, 0xa3d8fd1a, 0x1eb05436, 0xb54f400a, 0x51f72b60, 0xfb252faa, 
	0x2ffb97a1, 0x97f63c85, 0x5f109bd9, 0x4ff625d9, 0xe89f1c45, 0x9e4a17f6, 
	0x7f514eec, 0xcdcff2a6, 0x9ed774ca, 0x1173ce46, 0xf50ac00e, 0x2e79cfde, 
	0x3d7aa265, 0x8cefbbb5, 0x7cd3ff07, 0x365df386, 0xea8abede, 0x152673d5, 
	0xdf4bfa48, 0x6b7bfa0e, 0xe0c3d4be, 0xbf8ba27b, 0x6372b9f3, 0x7d242ea3, 
	0x72a6c6ec, 0x51afef10, 0xbf300f78, 0x49fa235b, 0xbda4f92e, 0xb3ac5c10, 
	0x4fa2fd9e, 0x9a5a0fc6, 0x147ef10f, 0x324d27af, 0x31d68f38, 0x5a73fd82, 
	0x8f5cb4c7, 0x6f433a44, 0xbc3d79fe, 0xa26fe63f, 0x0bf5a475, 0x1e08fd60, 
	0x5fae63f3, 0x99eb12e0, 0xea7ff21a, 0x88ab8a46, 0xe9fec8d3, 0xa9ffc2f5, 
	0x73bb6e2b, 0x5f297af3, 0x2e3b2f40, 0x1b767beb, 0x171d83e9, 0xa36d2219, 
	0x8a66707e, 0xb558edda, 0x8106ec64, 0x910735fa, 0x9563b437, 0x31edc477, 
	0x948b8994, 0xee27b6fd, 0x57697bc1, 0x7f8530c1, 0xd78883f3, 0xb2ca1e4c, 
	0xb49d94ab, 0x9b1fec4a, 0x52d1b924, 0x24c9e96c, 0x624f114a, 0x75b22fbd, 
	0xefea1693, 0x0c1d7f94, 0x996f75cb, 0x19ac8ad3, 0xa44d2811, 0x15583fb0, 
	0x6feef495, 0xc6c9af4a, 0x327f4f93, 0x73a57d8e, 0xf038a331, 0x0cd6e922, 
	0x4ecef15a, 0x66bd31e0, 0xdfb6356b, 0x33fc9e24, 0x9fe035ed, 0x73d23ce0, 
	0xcc7e9925, 0x1f966199, 0x9a4690c4, 0xc663dee5, 0xefcfc204, 0xf4d5bf09, 
	0x62ed415d, 0x9df041af, 0xb7247535, 0x7f4bf62b, 0x61e89573, 0x89f482fb, 
	0xc919f883, 0xbbf218ad, 0x613d1176, 0xceed89b3, 0x411f25d7, 0x1b1f913d, 
	0xd163e92e, 0xa8fc3bb0, 0x5e81138c, 0xf5ddf8dc, 0xa4fb21de, 0x4ce6c7cc, 
	0x364d69b1, 0x88de227f, 0x37caf3e7, 0xe4a9ddad, 0x7e8a55c6, 0x1def1e89, 
	0xbf002f69, 0x14d6b4ec, 0x7a2ae785, 0xc3ed86be, 0x8a3c2080, 0x3fb3a588, 
	0xfe716d5a, 0x63d7b519, 0x4713e0bd, 0x9eb0b58b, 0xbde998bc, 0xa3e8d225, 
	0xd24bfee7, 0x50f0b49b, 0x2c3b63be, 0xed728fcb, 0x502ff6b1, 0xfd194d3f, 
	0xda01c6ed, 0x2bff2423, 0xf25e343f, 0x01c65274, 0x1bfcdf5e, 0xfc230f15, 
	0xe3d07fcd, 0xfd89dd83, 0x5b61c442, 0xf4cf7bd2, 0xf1dd32f7, 0x043ed83c, 
	0xb484731c, 0x45137a1f, 0x838f3498, 0x4311adf6, 0xbef7f6a3, 0x4a28bc77, 
	0xfbdfd276, 0x4f5c59bf, 0xe46fbfb8, 0x60d8c507, 0x6f94defd, 0x1f2a4d86, 
	0x7083eb38, 0x8b27ee58, 0xe0fa7524, 0x20966f9c, 0x9683f936, 0x17204ba7, 
	0x2b8c840a, 0xabd85fa1, 0xb0b5a4d4, 0x744f573f, 0xa63e449c, 0xe387b82e, 
	0x0f272cac, 0x5681d964, 0x922fb353, 0x2ea59f89, 0x67e39578, 0xead376ab, 
	0xcf79fad2, 0xfb8843d7, 0x6f781aef, 0xb5dce82a, 0xf18f2103, 0x0c8dbdbe, 
	0xb392a8a9, 0xeeb899bd, 0xae53d5c7, 0xbcff3a7e, 0x832b5399, 0xe11d7899, 
	0x7dc6f971, 0xddbfaed2, 0x73febb66, 0x8bbae41b, 0xce2b3c78, 0x462bfa40, 
	0x11eed078, 0x11cfd0dd, 0x48f3d243, 0x0947cef8, 0xe7e941bf, 0x5edd136c, 
	0x55953df8, 0x5bfd4a37, 0xec02c8f5, 0x97faba8f, 0x8c92edf5, 0x4c7d65fe, 
	0xecacbddf, 0xfafc7c89, 0x6fc49c55, 0xd10b6268, 0xe327d257, 0x37157e95, 
	0xf7c857f1, 0xfa4a1cae, 0x17c6edf2, 0xc93f1cbd, 0x0bef1bb3, 0x3ff2c9de, 
	0xa5795518, 0x52edbf34, 0xcfb6c74f, 0xe025d8cd, 0x73db28db, 0xfb0bcfff, 
	0x5bfe80ef, 0x46f4dfd9, 0xeff5cfee, 0xfd49de48, 0xc8742c5d, 0xc28b96fd, 
	0xccb58fec, 0x1fac39b1, 0x33bca534, 0xece72483, 0x88b7392c, 0x5b245ce4, 
	0xc3889dce, 0x5ce5700f, 0x41cfd281, 0x4670b9c8, 0x49f5adce, 0xae72b97c, 
	0x6bae7200, 0xaaab9ca8, 0xdf3be3b1, 0x1598f2a4, 0x049049df, 0x558bec57, 
	0x51bb02df, 0x897cf3ee, 0xfd0450e4, 0x7ea45ec0, 0xe4ea2efa, 0xe3aa9f7c, 
	0xb3788e9a, 0x005ea5bf, 0x8cb8f34e, 0xb6a305bf, 0x8325be56, 0x47c5e46f, 
	0xabefa8b7, 0x53927b55, 0x3ce1dea2, 0xbcf87f5b, 0x8c7c8eb8, 0x52fef499, 
	0xefbcaeb9, 0x76c22f56, 0x71b5fd56, 0x793f49ef, 0xe5709d9e, 0x7c07fa1f, 
	0x034bf21e, 0x38c38fc8, 0xd625b68b, 0xe1bf2b56, 0x49b3d290, 0x379949c8, 
	0x913cd2d5, 0xe2d150ed, 0x33db5d68, 0x9ebdb7fa, 0x06ec1be4, 0x7b2b0f57, 
	0xc387a32a, 0x8ec2fe52, 0xa3b6c92a, 0xce097ea4, 0xfd5c3d23, 0xcb5476d1, 
	0x047f4b71, 0xf88ad570, 0x96d475ee, 0x3f7d1df0, 0xc7d8df17, 0xcd3be0c8, 
	0xbe016ef8, 0xe117fe9b, 0xef8b943b, 0x66275a96, 0xc7e729bf, 0x048adafe, 
	0xaf3ba9d3, 0x6089e020, 0xe41abd3e, 0x209f3b93, 0xe6674be0, 0xf2b23c83, 
	0xc6795961, 0xc38f32f5, 0x52cd798f, 0xccccecfd, 0xfeafbf83, 0xe7f9f338, 
	0x208cfc38, 0xb2c913e6, 0x9fa4428f, 0x969ec186, 0x191ba8f3, 0x66d6fef9, 
	0xc04fd7d6, 0xb62baa5e, 0xed2cdbef, 0x0bb023c2, 0xf3f9a5cf, 0xf329bd3e, 
	0x4b881f84, 0x2cfefe7e, 0x65f22a6b, 0xdda58aeb, 0xed2bde3e, 0x593a0382, 
	0x4de7e4ca, 0xb2079f81, 0xb03925ab, 0x3a17f30c, 0xad00dffc, 0x069e367f, 
	0xcc8e7dd7, 0xde396d5f, 0x92ccf928, 0x971c0a78, 0x5f6c9279, 0x7feb50ef, 
	0xb0bf4675, 0xf4a6d17d, 0x7fa33a42, 0xa3d09682, 0xb0ba2c9e, 0x7b5cde24, 
	0xf73cf19d, 0xc1c7d213, 0x37f1be8c, 0x04d5e2e5, 0xd0cb0c7d, 0xffbb50c7, 
	0xd2ddc160, 0x486d8fee, 0x78413d28, 0x9f5d5f6d, 0x2af0e713, 0xa0ee81bc, 
	0xb46fc847, 0x9738fd7c, 0x0e21f291, 0xf9fef187, 0x79cf8c84, 0x30e2b3da, 
	0x12c58ef3, 0x517e87df, 0xcdbd4079, 0xc280b103, 0x53cc41d3, 0x546789e8, 
	0x5e09d3bb, 0x0727da43, 0xc4ce2169, 0x9968c1fe, 0x3b5fd907, 0x0c3c4b10, 
	0x88efa13a, 0x6df9cdcf, 0xfa94ce7b, 0x7cf09d2f, 0xc43eb906, 0xc72dbd7e, 
	0xda0c0d7e, 0x47ced2af, 0xbff9d87b, 0x22fae573, 0xb411eb92, 0x5fb1cd6b, 
	0xb95c8b03, 0x2e76c4ee, 0xff75c8cb, 0x9d5e230a, 0xf19e6725, 0xd26eb949, 
	0x9ce7bb32, 0x45df6ff0, 0x55774c3d, 0x3f9263c7, 0x5dc6e78f, 0x646f400a, 
	0xbd1017bf, 0xfcb23b44, 0x65cb244c, 0xb53e15c5, 0xa3a7c9bc, 0xd1d24b4a, 
	0xed47493c, 0x37feb4f5, 0xbd2cdd10, 0x44d3e7ea, 0x5feaffc6, 0x1fb39bd4, 
	0x03b0afea, 0x82743f72, 0x012ff8c0, 0x827d376f, 0xf3a5d0fd, 0xaa61c474, 
	0x0fde0be6, 0x2a5fb53d, 0x23fb562e, 0x7037d8a5, 0x53f652fd, 0xc9da87cb, 
	0x8e8a7dfb, 0xb30f392d, 0xe41ed672, 0x4b9ff7fb, 0xa1955674, 0xe71a5167, 
	0xdabf5bfc, 0x478fce7f, 0xf1b861bf, 0x1f33dfe8, 0x4adb8f40, 0x8f4adb8f, 
	0x7cae549f, 0x1f86fe98, 0xfc0f7e4b, 0x883df86c, 0xd97cb2ff, 0x5fa73ffb, 
	0x7e7d6a0a, 0x3445ce3f, 0xb397eae7, 0xaf6afea6, 0xd67bcff2, 0x3ebdbad3, 
	0xf09b57f5, 0xcf79ebfd, 0x8ef3e5f3, 0x9fb5c138, 0x5239f4e4, 0xbd497f3e, 
	0xf231fd77, 0x4ab47ad7, 0xfa8a5729, 0xfec6bf94, 0x223ce64b, 0xfddc7df6, 
	0x1f90941f, 0x191d4faf, 0x1bf38813, 0x8fb0ec56, 0xcef31fc7, 0x98dd9e5a, 
	0x8a8a5ce3, 0x5eb8eb7d, 0x91951cf1, 0xa7a3f513, 0x17de76cb, 0xfbdcfc63, 
	0xec62972a, 0x19cedccb, 0x7355390b, 0x236fc2c7, 0xcfb833be, 0xe3fac734, 
	0x1dffc256, 0x6dfbdeb4, 0x3bce87f8, 0xfa8e42cf, 0x45dd2ff5, 0x15b77ef4, 
	0x9c8c757b, 0x1ecdceff, 0x9f4b1ff6, 0x56b37a65, 0x7681dedf, 0x6f47d671, 
	0x6cf53f2b, 0x5e41a62b, 0x7049ef54, 0x4037ddfc, 0xbef3f1f8, 0x75c6b743, 
	0x64e7b35b, 0x95449fce, 0xf257ea3f, 0x957e77f1, 0x8e5790a7, 0x7ce32a5a, 
	0xc5767fdb, 0xd743f821, 0x84b5a299, 0x72b2b0fc, 0x8b561e91, 0xf39b6f7c, 
	0x3bc85299, 0xdff3c099, 0xb2ec9875, 0xfdb35595, 0x8445cb88, 0x3fed4d35, 
	0x5e11884d, 0x875817b7, 0x76455760, 0x7afaff37, 0x72091e75, 0x7239fa85, 
	0xe1fd5677, 0xc94feb5a, 0x1de928bd, 0x1fd665ea, 0x5f065eb9, 0xf7a34a83, 
	0x3cfb888f, 0x773d121c, 0x9a3f18c5, 0xe1ff7243, 0x3d843b0a, 0x7b2b87ab, 
	0xe7d44ef5, 0x35dbf15b, 0x93b8ff2e, 0x97c3fff4, 0x7eb83788, 0x06eafd85, 
	0x8d96df89, 0xff93221d, 0x9f52b083, 0x935e878a, 0xf17763c9, 0x72f3d2e5, 
	0x9cb71f85, 0xde337560, 0x9e101467, 0xf4dfc54d, 0xf3def8fd, 0xb4cfff78, 
	0xd1f6c07f, 0xfaeef40d, 0x6947ec3e, 0x3ef79c15, 0x2de2aeb0, 0xe50debc2, 
	0xf883d7a2, 0x1f9d7e92, 0xca9d7f7c, 0xb76bb923, 0x1dbfc261, 0x82b68a61, 
	0xf593c0a5, 0x0d1f154b, 0xb8dc0e83, 0x78dfc102, 0xa648ed00, 0x4df1c05d, 
	0xfd8fdfe1, 0x7eabf367, 0xecdcbfe9, 0xb452bd87, 0x03ddea4d, 0xe73f2afa, 
	0x71972c0b, 0x9395f6ea, 0x98c38af7, 0x08ba25b7, 0xc27debaf, 0x5bbe24e8, 
	0x9e01fa8f, 0x4d6ef07f, 0xcd57afcd, 0x9e7b3bb7, 0xc55f7827, 0x79e731ff, 
	0x47eb5f58, 0xafa425bc, 0xd01ef9e3, 0x589f0c53, 0xe909e12c, 0x1bdc15eb, 
	0x828179f9, 0x3773f5fb, 0x56895d33, 0xcb52e59b, 0x5a6287ec, 0xa5d45c56, 
	0xd2cba66f, 0xfd3bf3cc, 0x54cebf52, 0xdbd74ba5, 0x0b5ff5de, 0xae9f36bb, 
	0x8af67cef, 0x48bf7807, 0x2f308758, 0xfea9ce97, 0xf60bd486, 0x94a1c834, 
	0x595ab7ca, 0x25c243b5, 0x17d089ec, 0x1573f74c, 0xfa29b7bd, 0xf7ee800f, 
	0xa2b57f3d, 0x939e0dbb, 0xef1681c4, 0x3f00fde1, 0x7e0ebdfa, 0xf08d9ec9, 
	0xdecffd13, 0xc4cb7ac3, 0xe208e379, 0x7d8e8e8f, 0xa580e0e8, 0x3ceafc27, 
	0x6dce2f71, 0xab618f08, 0xdce276ef, 0xc111d132, 0xfbcce44d, 0xf39fe805, 
	0x3ea4dace, 0xdda8fee7, 0xcc5e14e7, 0xc3ef64a9, 0xcf72b12e, 0x6dea0f49, 
	0x33843fec, 0x2b7efb79, 0x9d73fcf7, 0x6c7fd0ff, 0xeeeffb25, 0x32fe1339, 
	0x4533e89a, 0x523e07f3, 0xc6afd405, 0x54e895fe, 0x7cc10671, 0xfb12fd6c, 
	0xb4fbe013, 0xf5af599d, 0x2527993e, 0xf821f6a2, 0x32fd7373, 0x4f7dc8bf, 
	0xf7dff2f2, 0xb1ee3c4a, 0x83af850d, 0x511e3d6a, 0xe4a83ef8, 0x71e1d616, 
	0xdfefe243, 0x92b8ff1a, 0x4fd9c0e4, 0x1397ab1a, 0xdbff772c, 0x88ebde7d, 
	0x88e7abbe, 0x3f53d416, 0x79e6ba23, 0x7727bcc9, 0xf32980bc, 0xbfeb0e3d, 
	0x59471bf5, 0xf982382e, 0xa74c77f5, 0xc87b9faf, 0x2aed79cf, 0x4ba5c7bf, 
	0x6a893f97, 0x2795acc5, 0x8fc1fb8f, 0x6623cf77, 0x5953dbc7, 0x3a0fed74, 
	0x9cc28e7c, 0x103c7269, 0x3de765df, 0xe9b7e7fa, 0xce6b4738, 0xe8d5e7a3, 
	0xc3677ecf, 0xf6dba66c, 0x4fa0c7f5, 0xf26e7ce4, 0xa7f578cb, 0x5924eb97, 
	0xb930fe6e, 0x3df411fe, 0x45f26c51, 0xb5b2f332, 0xfea1e980, 0x273ca08c, 
	0x37344e62, 0xf233aaf9, 0xdcbf55f6, 0x2f509927, 0xcaef3e38, 0x1dc95357, 
	0xcf405b82, 0x983d9cb3, 0xf5873b91, 0xaed1a611, 0x2512cee4, 0xdce3f77f, 
	0x9d80a89a, 0x076872c4, 0x09a46fd6, 0xa70f93f9, 0x4e670fbb, 0x0e7c7074, 
	0xb7daabfe, 0x21c5d4e3, 0xf3dddee7, 0xeee197fc, 0x57de7682, 0x7f397de4, 
	0x59cbed54, 0xf6ce5cf2, 0x71bbcf59, 0x17d043ff, 0x18cea6fe, 0xe2a7df88, 
	0x70bfa0ff, 0x5784e22f, 0xc94e11bc, 0xf9dd02f5, 0x73f84ce7, 0xcbc66cc9, 
	0x85bf3a37, 0xff9caeb0, 0x125d8fd9, 0xf6ebfec7, 0x6fd93a0b, 0xf5017edb, 
	0x797ec31b, 0xcd396c57, 0xddfdecf3, 0x81beb193, 0xf3f7ad99, 0x771a49b9, 
	0x7fc196b9, 0xe1db710a, 0xe36e361f, 0x371e613b, 0x83f3ac72, 0x29039c93, 
	0x2b79ca3f, 0x86799ff7, 0x8e7227cc, 0x179039f2, 0xe751f0ff, 0x964c5a40, 
	0x40e77997, 0xb4f0eb32, 0x644d53c4, 0x016f1b93, 0x97e6ffbc, 0xd05f0a71, 
	0xf7e17a66, 0xc7152f44, 0x1df668e7, 0xf3ae1638, 0xb0f78ebe, 0xdebafbce, 
	0x352f2ca4, 0xcb737ca5, 0x7ee535bf, 0x72352bc4, 0x009ef8bd, 0x3bd2b7e2, 
	0x007ef95a, 0xe7869f37, 0xe0707b0b, 0x75e60f19, 0xabc777c3, 0xf2ef2473, 
	0x7f8f4f3c, 0xf93aeb8e, 0x2e9ebc9d, 0x77cc865e, 0xee739999, 0xf7cd0f65, 
	0x370be720, 0x262f9c69, 0xed8481f3, 0xe6e503e6, 0x47f9b971, 0xaf91be6e, 
	0x3c81d236, 0xab1f3711, 0x71cd9268, 0x58f9031a, 0x289f231f, 0x9e142f93, 
	0x39925fed, 0x56f24f17, 0xdcf43dc2, 0x73c287c6, 0xa774bcaa, 0xf958ff44, 
	0x91e5424d, 0x479de60d, 0x64cda42d, 0xae8e12e0, 0xa5fce0e0, 0xa2cce721, 
	0x7edcae52, 0x675df2da, 0x5baeb105, 0xe19bdc4d, 0x951189d2, 0x77be8572, 
	0x61d07e78, 0x3fcc854b, 0xb84b8eca, 0x73bceaf1, 0x88a27c42, 0x60c29dea, 
	0xaa67bf78, 0x39c290f3, 0xc13b6491, 0x83274074, 0x925f0a71, 0xb3e0abcf, 
	0x61db2d84, 0xbb822d5c, 0x453aa80f, 0xd1bfd838, 0x9136e4c2, 0x124cd2fc, 
	0xbe643785, 0x916d1ab3, 0x768ee390, 0x81ae35e1, 0xe41a16dc, 0x9213fb32, 
	0xfde0c6bf, 0x33eec975, 0xed4e5f91, 0xa8ae80c7, 0x21fb0b3e, 0xb638dc2e, 
	0xf916ecae, 0x827bc95e, 0x7ec38c6b, 0x9fb1558a, 0x2a715def, 0xef22fda4, 
	0xf986f967, 0xe3a7cc2f, 0x747f7b2f, 0xfa5c5af5, 0xfe707111, 0x2de754f2, 
	0x42930bec, 0xf09893ae, 0x9bfb9262, 0xfd9532f0, 0x8f892945, 0xadde7916, 
	0x71c684fc, 0x02f3fa5c, 0x8387e32e, 0xe92bcffa, 0xa351fa45, 0xe434b1ae, 
	0xf152fd63, 0x1ad2b7ab, 0x3cf085bd, 0xe8efa7ca, 0xf3f3f2ca, 0xe88ad3cb, 
	0xe5cbd20b, 0xb21c68eb, 0xec848d03, 0xe0bc7cbf, 0xc54313bc, 0x4587878d, 
	0x2ff8483a, 0x1db8265f, 0xb482dbd5, 0xdec9c33e, 0xda947d2e, 0x927b4a55, 
	0xa5c1db9e, 0xad2edcfc, 0x6fd21c05, 0xf2723822, 0x7056df8e, 0x8ce4adbe, 
	0x32d7279b, 0x17ecf7fb, 0x9762ebf7, 0xc5d6aadd, 0xe310e796, 0x4cce7cd5, 
	0xf7a45b9e, 0xe7516f1c, 0xffcdc30d, 0xdfa372c9, 0x4d2dcf90, 0x973fcf3e, 
	0x097b2868, 0xfc1fc2e3, 0x9e51e562, 0xbd86e03f, 0x594fd2ed, 0xecf44458, 
	0x25b3b673, 0xaeb17b3d, 0xcbfa50f6, 0xc1895fca, 0xcb55f22e, 0x8c08697b, 
	0xae4c4f54, 0x3dbde0d7, 0x547ff634, 0x0ed2027b, 0x6cbc26b6, 0x8f4fbf62, 
	0x9d6663df, 0x1af75487, 0x45205fd0, 0x2030b672, 0xdcfb8cf5, 0xfbb5b0a8, 
	0xd3f3e4ba, 0x97f6648e, 0x75db4413, 0xf2091fc4, 0xaf88a3eb, 0xce6d5a44, 
	0xaaf354e7, 0xa9f8c90c, 0xf60e5a48, 0x0e61beab, 0x974c7097, 0xda44f5e7, 
	0x12ce39b2, 0x81d4ecb6, 0xc2587bac, 0x57f3a2e5, 0x3d5ff959, 0x24b56eb2, 
	0x949c2e61, 0xc477ff1f, 0xee1b7a0f, 0xe5f6cb9c, 0xaee54f1d, 0x5a33cc93, 
	0xbadbcf2c, 0xfe10447e, 0x447e1a40, 0x2f71ce85, 0xf869fdd8, 0x1047e403, 
	0x11f84d6e, 0x11fa86eb, 0x50f55dfc, 0xb3fd023f, 0x08fca35d, 0xcdda8fee, 
	0x0fba480d, 0xeaf6954e, 0xee23f5a7, 0x0041729c, 0xf079f676, 0x7fc1472b, 
	0x6a42fdef, 0x0f154a16, 0x485f10a8, 0xc552e5ed, 0xe4b0c407, 0xda1b2a1c, 
	0x53d6a7d6, 0x4b0d6cd9, 0xd5bfffc2, 0xfe19bf5a, 0x53bdadfe, 0xbfffc3b7, 
	0x81b4bc41, 0xbb70f5f0, 0xdb3d6cb8, 0xcdced6a9, 0x270f0b44, 0x22ac3d24, 
	0x7e2418b9, 0xe3203779, 0xb46f0f70, 0x376ecd6f, 0xb1128f78, 0xc7ec8c6f, 
	0xc7c70355, 0x7109eae6, 0xe242fc3e, 0x85e22f33, 0x395ac7e8, 0xf7327d74, 
	0x089e112a, 0x17247f7e, 0xa5f6f94f, 0xfa11ef7b, 0x8832bd83, 0xde2e48b7, 
	0x3fabdc78, 0x8851be02, 0x65bbed13, 0x2c5bc705, 0x1fb1db8e, 0xbacfe590, 
	0xb9fb01fe, 0xb01fe21f, 0x5f801bbf, 0x70f811d0, 0xe979a0bf, 0x1e39018a, 
	0x5a15b6fe, 0x5595dcd7, 0xdd36b87f, 0x183bebc0, 0xf595e9ef, 0xf58f78c1, 
	0xc73354f9, 0x02dfce7b, 0xffd9f77a, 0xd63f607a, 0xdba1edbf, 0x270ba013, 
	0x8782bc80, 0x1e6bdbe7, 0x0359fe22, 0xea73bd3c, 0x2fc64a38, 0xb536e3b5, 
	0x952fc20f, 0xc7848b7e, 0xa1dc9670, 0x326c43f0, 0x875d2fc4, 0x4dffa1fe, 
	0xf30a5a7b, 0x007a9f85, 0xdf252771, 0x908d5b96, 0xf929af6f, 0x0cdfd216, 
	0x7c3f1e40, 0x5e2bca89, 0xbbf8c569, 0xf88ed46d, 0xeed50df8, 0xe59c2be1, 
	0xab7a4877, 0xe265bd07, 0x579fbd32, 0x6d2f9971, 0x4f32e371, 0x05b72ec3, 
	0xec43cfe2, 0xd67e21e6, 0x7ed9038f, 0x59f95f96, 0x94371013, 0xbf0e957e, 
	0xef2ad7ca, 0xe78aca8f, 0x9cf1d9e8, 0x39e329e0, 0x9e200bdf, 0xe5e03df3, 
	0x5c7850c8, 0x7ee3f77a, 0x77de5b2f, 0xa9c73886, 0x339628fc, 0x5c1daa9d, 
	0x9f184fa7, 0xcb881c03, 0x9e6665b9, 0xec938fa4, 0xd5b8aa07, 0x8fec3a93, 
	0x4e56fda0, 0x8a7beadc, 0x6f98fccf, 0xbaf9d0db, 0xaa9bfd7e, 0x6fe2a9dd, 
	0x88d5b162, 0x2fac03bc, 0x2c267bdf, 0x182a1fce, 0x8f7dc38c, 0x799362e9, 
	0x1577cb98, 0x262fb55d, 0xb99a5dfe, 0x7be5cd9f, 0x3b615cf7, 0x9e8c4531, 
	0xf6172fb7, 0x38ecfe9a, 0x24bb8d20, 0xf690c703, 0x06fed46d, 0x05efc7d8, 
	0x3dbb5710, 0x8fd76730, 0xabf65ec8, 0xff1feef3, 0x1c748e1e, 0x5332c2f6, 
	0x2fef820b, 0xd01c3dc0, 0xf29f0d0b, 0xf3bc8e1e, 0x5e1d30dd, 0x70fa32d4, 
	0x8f11754b, 0x195d9423, 0x6d995d81, 0xff4a1857, 0xfc6534d3, 0xb2bac444, 
	0x7b4183ec, 0x5cc1f601, 0xed8b5e75, 0xd807f24d, 0xfb23185e, 0xf97026af, 
	0xb027693b, 0xd94a30dd, 0xd93fdc57, 0x6e4fa9f1, 0x95820437, 0x4819c441, 
	0xdf834db8, 0x01ec7028, 0xfd657774, 0xafa4e9d4, 0x68a6cafa, 0xf70eb4b5, 
	0x04169cd5, 0xeca43d1f, 0xdfc6d793, 0xfc693296, 0xdff889c9, 0x6b9f8924, 
	0x74bed282, 0xc1b5a5f9, 0x2d6ec0f1, 0xb802b32e, 0xb2b26bcf, 0x2103e0a3, 
	0x5ba223ce, 0xefdfbc78, 0xfbc7933e, 0xf167e9f3, 0x5d6a1f3c, 0x71a51ddd, 
	0xd35b160b, 0x6ef84f60, 0xfe949315, 0xf88f40f1, 0x84996faa, 0xb8df23fd, 
	0xee3249a6, 0xaff18561, 0xa95627af, 0xfcc520e2, 0x3c46218f, 0x4fbef061, 
	0xe4c7f407, 0xc1870ba9, 0x1a9e29fe, 0xc121ac4b, 0x953a4be9, 0xfa1f5faa, 
	0xf8291c6d, 0x90ccde1c, 0xbd918b28, 0x69e2fad1, 0xb94fc12f, 0x28392568, 
	0x5fd3cc11, 0xe8a0bf06, 0x70bbeae6, 0x5cef8acf, 0xf82f7d5b, 0xee2fbfd4, 
	0x753167f6, 0x540df6f8, 0x579dce02, 0x930c1c5e, 0xff1c57bd, 0xb1f10276, 
	0x8ca23dd1, 0x03a0b7e3, 0x58b1a782, 0xd03f39f0, 0xe773d607, 0x4b069795, 
	0xe71adf88, 0x7a61e7a8, 0xe3fa7c4e, 0x3bc394a0, 0x083cbcaf, 0xf9506c7e, 
	0x5b8daf69, 0xc97e4295, 0x89fde0e4, 0xe37fd435, 0x5be506d7, 0xb0b9f407, 
	0x73cb00ac, 0x49740adb, 0xabef98ff, 0xeb9617db, 0xde6f1c5c, 0x69f6b22b, 
	0x07797785, 0x4f55f3e0, 0xf079ff60, 0xf5e5ba1e, 0xefc9034a, 0x8c6ec81d, 
	0xbe3efd3b, 0x1627c637, 0xf0623c73, 0x7f650a5e, 0x8dcb8615, 0xed0d6f75, 
	0x61ef5fa7, 0xb7a40c3a, 0xd4c31384, 0x7cff487c, 0x6ae3282b, 0xe6cc7999, 
	0x5793b4f3, 0xe3b2a7d7, 0x4ebf938a, 0xdcf96af5, 0xcfb8c38d, 0x3bee3711, 
	0xcb194663, 0x41c3dc0d, 0x263d6ef3, 0x1d927bcf, 0xa6fe51e0, 0x6b60fe07, 
	0xcc6e8efc, 0x1b8de1b7, 0x9b1f403b, 0x261f3283, 0xf449e2a2, 0x659c73a7, 
	0xb38e09f5, 0x8a76fd54, 0x82fc0b8a, 0xbf1b04e3, 0xf8f18633, 0xb792a0ed, 
	0xdc07c642, 0x928351b8, 0x292fe87f, 0x393d0fed, 0xfe93b657, 0x7ee3adb9, 
	0xfe2aef96, 0x38e7e111, 0xae3d511e, 0xf4b7ca5a, 0xf39e382f, 0x1ca603ad, 
	0x3a77edd7, 0x023f017d, 0xb8ac9c71, 0xd36fee97, 0xc127d9c6, 0x03a754df, 
	0x458d0379, 0x69f42b62, 0xfc45dae3, 0xa48ed8bc, 0x5c9f8f10, 0xfa03afba, 
	0xccb578b7, 0x59f17247, 0x8ade135c, 0x1fc62e3c, 0x76e4cfad, 0x187ddc11, 
	0x1e78ecfc, 0x0acbefa1, 0x568abe24, 0x96c6d647, 0x62bfa50f, 0x9425489f, 
	0x287a08df, 0xc9f5a06e, 0x978bcfb2, 0x95f596af, 0xeb8a2e92, 0x5e35fae4, 
	0xc5dcfd4a, 0xe8ad9471, 0xe48a71a7, 0x6f615687, 0xa9f9644c, 0xb3d53aad, 
	0xf2356ffa, 0xf6bcbeea, 0xaf7dc9c2, 0x8defb93b, 0xbf2fbabc, 0x5394d8bd, 
	0x626e6677, 0x64cf57f8, 0x919f01f8, 0x3e0327e5, 0x061fcb23, 0x5f75397c, 
	0x2f827b5e, 0x97c13de7, 0xadc8def3, 0x71fe1117, 0x97eb5b3f, 0x097ef18f, 
	0x7efecbe0, 0xec53ad26, 0x150e214d, 0x7e93bad3, 0xbaf17e2a, 0xa1dae400, 
	0x195ba575, 0xe56687fe, 0xbe4fdbec, 0xf783cdb5, 0x65293a19, 0x1306b7fc, 
	0xe1396cb1, 0xe068de3b, 0x31df48be, 0xa47a476a, 0x07a95d6f, 0x635ad6fc, 
	0x92e5ad17, 0x777406e8, 0x706f7a43, 0x4fcf6320, 0xe1adde3e, 0x0e9fa23b, 
	0x5c1c5ff4, 0xf6fd8edf, 0x5f6edd62, 0xbf274d93, 0x3b7ddbb4, 0xb677af21, 
	0x957e5e63, 0x38f9302f, 0xe26c87cd, 0x7cd2dbbe, 0x5ae4d9cf, 0xfa0e67ea, 
	0x86d33d23, 0xfc1d3df6, 0xcea7fd3d, 0x68deb0b3, 0x077997ad, 0x2d9cf683, 
	0xb8d5e88c, 0x94f6c75f, 0xcabcece3, 0xf9512b17, 0x9be42127, 0xf53f416c, 
	0x8a19e382, 0xff2a433e, 0xa9dbfb8d, 0xdcff03be, 0x6944f6d0, 0x72c2df96, 
	0xe4f6e499, 0x042f56a7, 0x03da0d7f, 0x113fc313, 0x8ff372a3, 0x9c6a5791, 
	0xe3205e59, 0x772c3d13, 0x1e90d726, 0x0e8afcc3, 0x4249c2cd, 0x83b1cce3, 
	0x693e39ef, 0x784bf929, 0xbd61f58c, 0x97a07a8e, 0x887201fe, 0xb222b9ec, 
	0xa57eb53f, 0xce4146ff, 0xcfc809db, 0x524e99fe, 0xa3f649e9, 0x240fa7fb, 
	0x7ff6ef61, 0x10e19659, 0x4ce5e1d9, 0xa7ec092f, 0x9f092b86, 0x53f15634, 
	0xedf849f5, 0x1385d687, 0xac5e372c, 0x6fc5f6e7, 0xd1e1e7c8, 0xfea4eb8d, 
	0x4f75b073, 0xeb2ddac6, 0xee11bfb8, 0xf18fdb73, 0xbdebcfca, 0x0bf92476, 
	0x2f8996a3, 0x19ba208f, 0x8fac867d, 0xb4ea8b39, 0xa15f15ae, 0xb1c3c93a, 
	0x62a2c4ab, 0x1a1268ce, 0xe54352ec, 0xd9798f73, 0xcc776032, 0xb07e902f, 
	0x40b9bcfb, 0xbc6e15da, 0xbcfed466, 0xcabeea76, 0xcfb93dd1, 0xfab121e7, 
	0x569e2648, 0xddf79bd1, 0xd8ffd974, 0xcbcfb9c3, 0x5910cb1d, 0x492560fb, 
	0x52a18faa, 0x7040efdd, 0xd3c22968, 0x3fb902a2, 0xffdad468, 0x2775fcae, 
	0x637ee5e5, 0xc6bed936, 0xf804d6fa, 0x9798e4ab, 0xda9a6be5, 0xd0f3499f, 
	0x204b6e06, 0xec72573e, 0xe77c61c4, 0x725cfc51, 0xfe23be8c, 0x276a9929, 
	0xaa514790, 0xa6fae7f6, 0xf45c3584, 0x48847af4, 0x9310ab70, 0x92698e22, 
	0x1d1062bd, 0xf6e7849b, 0x28ff1902, 0xf1ab7155, 0xefcfc711, 0x7dc784db, 
	0xb4a2fb0f, 0x448fbe4c, 0xdabefc84, 0xabde72d2, 0x44264c7b, 0xf89ef92c, 
	0x8abde721, 0xd88c4e3f, 0x2b72fdf2, 0xf2e9ffb7, 0x5b1171fb, 0x87fc4f8e, 
	0x2b4125f7, 0xa253fd01, 0x09bf78fb, 0xc5c47c71, 0x188aa64a, 0x8e4a25f2, 
	0xf24e8959, 0xe6a7bf97, 0x7dd5dae1, 0xcc0d5b9b, 0x393d7fbb, 0xeea7a404, 
	0xb2a3f7a5, 0xa5e974e0, 0xfb9bad4b, 0x25e83d7c, 0xbd2e1f0b, 0x7853b60c, 
	0x7dc5e970, 0xc97a09de, 0x2f4ba79a, 0xf9a9df83, 0x95d2f4b9, 0xd6c62f47, 
	0x58f7df08, 0x97de8db2, 0x4a7e9a9e, 0x4e89dba7, 0xa252c3e2, 0x9ca7708f, 
	0x4b7cf217, 0xf87d3d8e, 0xf133abdb, 0xb7639289, 0x5cbf04bd, 0x26f95617, 
	0x1b63e62f, 0xad2c1bc8, 0xd7be0b4d, 0xb6f7b3a0, 0xdda2bff2, 0x06e43679, 
	0x46be2a58, 0x902dbf88, 0x9d268be7, 0xd91b1bd7, 0x4cb0f44c, 0xd0770b8c, 
	0x75419fba, 0x6709c7e2, 0xe2e49d51, 0xc288afc4, 0xb8cfd411, 0x9c2fb655, 
	0xbf02eb94, 0xa15f8331, 0x4fc53ce1, 0xc7e3e8f3, 0xd79bf043, 0xb9bf106e, 
	0xfc509fcf, 0xde6fc198, 0xcdf88377, 0x08ee5e7d, 0x2cab95cd, 0xdf07c167, 
	0x39fafd01, 0x01781e9f, 0xfc53ee3f, 0x8e2b5a58, 0xdd6c7e2a, 0x1be246b4, 
	0xb13a58fc, 0x54b1f993, 0x242863f1, 0x81b533f3, 0x4b1f9927, 0xe0f09d8f, 
	0x8fcb823c, 0x369744a5, 0xd12971d1, 0x286ebda9, 0x758ebe5d, 0x89263f05, 
	0x7b7e891f, 0x72ba3ad5, 0xf8927c6a, 0x96cf3d50, 0x30a49153, 0x392b9e73, 
	0xe5692137, 0x6b72573e, 0x7dced262, 0xb8d6e4ae, 0x97fdcda4, 0xafe66d06, 
	0x805fc552, 0xc06ef3b7, 0x155f336f, 0x2e5c1487, 0x327777fc, 0xf0debcfc, 
	0xfe20ee03, 0xea5e46ea, 0x83ebf9c9, 0xb3fafe3c, 0xfcf9c792, 0xf829c1f5, 
	0xfc7e7dcb, 0xc1f5fc14, 0x83ebf829, 0x9d5fcccf, 0x35015fcc, 0x4f63d2ff, 
	0x1593be7b, 0x3ef5a3ff, 0xf11b788a, 0xed7b6ad7, 0x34abf9a9, 0x567ebf8f, 
	0xd218fd20, 0xfb1cc961, 0xfbabc8d7, 0x6f659ea8, 0x481ccff6, 0xd0c7db66, 
	0x5471d9cf, 0xcb2369e8, 0xbe8f091e, 0x07d71d65, 0xb77a1d54, 0x3d577a1e, 
	0x6ceca23f, 0x2edb2382, 0x012ff774, 0xc073f64f, 0x525f6d93, 0x00dfc069, 
	0x29bfc07d, 0x61e5be41, 0xf7ea5bc8, 0xc0bf6925, 0x26bb79de, 0x4538e21a, 
	0x2f7399b9, 0x2f7e6056, 0x352be5f3, 0xef068667, 0x4d3ac7bd, 0xb3f6ac5a, 
	0xc705fddd, 0xf38c72fb, 0x3672459e, 0xd8966595, 0x0656fd40, 0xee210fcf, 
	0xd2487e70, 0xfa02f8c5, 0xea653fbf, 0xff7dfc91, 0x7db3af23, 0x9195f454, 
	0xf97a5fd2, 0x769ff619, 0xdab47cfe, 0xffdfcdef, 0xb3943f3e, 0xfe4d5fdf, 
	0xe76e76d5, 0x3a35fbe1, 0xe27dfb05, 0x5ee72297, 0xf3906012, 0x37aa2ee7, 
	0xf0703770, 0x88463dca, 0xb6d87d4a, 0xff5798bd, 0x1ef26db8, 0xe8afb54d, 
	0x9c34b42b, 0xcfb8e373, 0x11bd6a03, 0x9ffb52c7, 0xb78d9e6e, 0x8c68e236, 
	0xf34f6a78, 0xce51a2d2, 0xa5a616f7, 0x3be46e21, 0x11adb56b, 0x3eea7d5e, 
	0xe44e3778, 0x1b61fcfb, 0x1d56a07e, 0x5bf6ab59, 0x9d1e7535, 0xbd609dcf, 
	0x7de0ef63, 0xd7b85ddb, 0x04468b55, 0x12249fce, 0xd17f78b3, 0xfed5d09b, 
	0x1e77a597, 0xa4ed7894, 0x97f35271, 0xc12c9536, 0xb8a31779, 0x1f7337ac, 
	0xcc3f28b8, 0xfdfdd978, 0xead78906, 0x270fec83, 0x83931b5e, 0xd975c1e7, 
	0xc1cd784d, 0x7839cdfb, 0x81d4f627, 0x6e6bb7b7, 0xc3cbcf91, 0x9a947439, 
	0x7474c7df, 0xf2d35850, 0x797af7f7, 0x2d1acaff, 0xd19cb5f7, 0xcc7d6447, 
	0xd90fac80, 0xf591ee47, 0xfacb2fb1, 0xad2e5ed8, 0x7d658771, 0x7ef911dc, 
	0x8fac80fc, 0x47ae4c77, 0x44e973f6, 0x40de657a, 0x0f9961d5, 0xd2447551, 
	0x590194c5, 0xb904e29f, 0x4b9fbd5e, 0xcf87baa7, 0xbda75abd, 0x61a7eb2c, 
	0xc9df345e, 0x352bd798, 0x537cf177, 0xb93add97, 0xfc4fbe9c, 0x2ad3addd, 
	0x7354bfa8, 0x33ec09fa, 0xfb016f60, 0xeb4aa90c, 0x54af5c87, 0x2fb20af5, 
	0xd549efc9, 0x246c47a6, 0x886a9a59, 0xec8bae7c, 0xd615d4a4, 0x285df5c8, 
	0xdedc7fed, 0x2225e544, 0xd4d23c88, 0x7c12bb52, 0xee98da95, 0x2ef7cf5c, 
	0x7223c139, 0x8060b0df, 0xa1d5d684, 0x0aff2507, 0x239fb42b, 0x96c84e5a, 
	0x603a59fc, 0x322cf3a8, 0xf1c8517e, 0x585e3710, 0x4d85e2a7, 0xafd8258f, 
	0x316db630, 0xca16fd24, 0x110bb6f5, 0xe7dd797f, 0xfdc1da6c, 0x1dfd45da, 
	0x3bf14fdc, 0xc7c5da5c, 0x2fbc3d65, 0x73f0f5c1, 0x17928a5c, 0x55e4bd65, 
	0xc3d2ad2e, 0x7a55c306, 0x1d87d644, 0xf6caed97, 0x6576e1ad, 0xdfe1adcf, 
	0xb8c228f7, 0x9e88db1b, 0xab4ddc68, 0x36c3d56e, 0x437b97e2, 0xe6ffd106, 
	0xb56a6f91, 0x2e1b1eb4, 0xb2353e3b, 0x9830f39e, 0x1d337cbf, 0xfcafff19, 
	0x28faa4e6, 0x930d77e2, 0x097fc9ea, 0x3d7035f6, 0x3e5967f8, 0xf7f8b210, 
	0xb6428212, 0xb2aa960b, 0xcd05964e, 0x52f2c8e7, 0x837db655, 0x49b829fb, 
	0xde550995, 0xe3f4caa5, 0x5547fcb2, 0x7e5c7bee, 0x7b2a92f7, 0x1f9f22ff, 
	0x5c71a555, 0xcaa11f3e, 0x3f254348, 0x336551af, 0x2abe3c95, 0xe7e56edb, 
	0x4e3242c7, 0xac937050, 0xeafbdb6f, 0xd79eb1cf, 0x094bd103, 0xc5cd8dfe, 
	0x24d867d8, 0xef8e9ae4, 0x6b79c13d, 0xa2bee3d7, 0x0cef753e, 0x27d705d9, 
	0x51a5dc49, 0x27116a26, 0xf66c94d8, 0x51f1bb68, 0x8b9624e7, 0xa52fd235, 
	0x4390cdf7, 0x1e07f388, 0x2dfa75e5, 0xc5fae5d6, 0xbbe096b3, 0xbbe878ce, 
	0x3e0790e3, 0x81826067, 0xab29c61c, 0xdec39427, 0x42571728, 0xbdef8dee, 
	0xace81c6d, 0x1c627ec0, 0x5a74ebef, 0xd51fb193, 0x49d1f6b9, 0x51b9c738, 
	0x390c77dd, 0xb6eae323, 0xbcb4573c, 0x83f32e3b, 0x99e02f34, 0x9e190668, 
	0x71e6e1a0, 0x21d79c38, 0x7dc9a14c, 0x6a23e277, 0xe0cfbd7f, 0x444933df, 
	0x5fce3e12, 0xd05edb09, 0xe72251b7, 0x2f491653, 0x08eb5e41, 0xed401493, 
	0xfeddefd0, 0xa65f2047, 0xfc596012, 0xcc22d0bd, 0xcd30f11f, 0x73f70972, 
	0x29fa878d, 0x65c026a8, 0x483358fc, 0xcb4dc54e, 0xe5c6f1cf, 0x3f688db1, 
	0x26ba90b1, 0xbe51db7d, 0xbeef8fcf, 0x6c9b366e, 0x3cd39492, 0xb089fe69, 
	0x8689cf21, 0x44c7ce6d, 0x1dc1d87b, 0x27fd2e78, 0xee7cfb1d, 0xd37d8df3, 
	0x84f33de4, 0xfda8fba7, 0x07477175, 0x44ad7bdd, 0xbb9d7610, 0xe8bfcbbe, 
	0x6c8e8814, 0xe04db77e, 0x8cb97833, 0xb710cc1f, 0x03cfb286, 0x165818cf, 
	0x35c7d9ca, 0xce71136d, 0x063d8b19, 0x12e0add6, 0xf6a78e37, 0xa6c5abff, 
	0x99e9dfec, 0xa95678b1, 0xd5ed7890, 0x6c849d25, 0x25567efe, 0x2679539e, 
	0xf6ae2f9f, 0xe6740afe, 0x08ba3d3d, 0x62c66e7a, 0xbcf456d2, 0x0cdce225, 
	0xece19a7a, 0x863a425a, 0x21e653f8, 0x7c9d7f51, 0x3e385e2e, 0x8d3317f4, 
	0xebbbe220, 0x9c105ce6, 0xaf5e7049, 0xd1361b59, 0xfc24af3c, 0x6e01f7e0, 
	0x7484c677, 0xfc7aafaa, 0xb509cf8b, 0x0b39de4f, 0xf13a1ef7, 0xef7275ec, 
	0x875afa8d, 0xe38d1fc4, 0xab3fc4e8, 0xbbfc172e, 0x85aa2303, 0xcf21dfe5, 
	0x503df171, 0x1be7bdee, 0xcbeb22ff, 0x2af591cf, 0x1486fe79, 0xfdeef9ed, 
	0x8a971c19, 0x7dc41138, 0x8131117c, 0x76223bf7, 0xc923f384, 0x5477c75f, 
	0xacf7a9f7, 0x7a7bdc8d, 0x000f70eb, 0xa3f7ddd1, 0x9f714a6b, 0xab9f03c8, 
	0x7a212d2f, 0xef048bd1, 0x390a4ddb, 0x9bc24c66, 0xfddc5e06, 0xf77d8178, 
	0xf2e3e414, 0xf5c7c842, 0xbef03657, 0xcbd2a1cf, 0xc53ef176, 0x17ce6d77, 
	0x3cfbeccf, 0x15df8719, 0x7de6c2bc, 0x730b1b9f, 0x1a0a7df7, 0x554f796c, 
	0xdf63a399, 0x39f940a7, 0xfe942b5f, 0xb38f10a0, 0xfe76b8de, 0x87df6a59, 
	0x7d8bbcde, 0xa3bb5b9f, 0x2c371fa4, 0x3efb966e, 0x7dcbd7a7, 0x7d87251e, 
	0xb0932dce, 0xb99bede1, 0x579ee59a, 0x19dd73ad, 0x3c022ad4, 0x23f33a3a, 
	0xc7f6072d, 0xb8bc54ea, 0x3647d1e0, 0xa3b8ff21, 0xee09fa50, 0xc9baefb9, 
	0xb22e82f6, 0xb265bcc5, 0x91ab6a9f, 0x0dd7edcf, 0xa6cc29ec, 0xa85fb76f, 
	0xc3dbdc39, 0x7c641ffd, 0x72ff62f7, 0xe2d73cf0, 0x72c685b6, 0x06b5a9d0, 
	0xa9d7bdf7, 0xd3bf1d7d, 0x7ec61a5d, 0x08ce19e9, 0xd096b1e4, 0x2fd8687a, 
	0x9bdf275d, 0x7c0a5d96, 0x83c9e4d6, 0xc91f9819, 0xee2b05a3, 0xd3e65378, 
	0xb05fbcd9, 0x3f5ffae0, 0xed56bd08, 0x25747b3f, 0xb11ef3b5, 0x7e3bf475, 
	0xf80d1ec0, 0xf746efdd, 0x5df1a338, 0xc0aed5b0, 0x1ab04e3a, 0x4fcf80c7, 
	0xe1e9896b, 0x03bfaa25, 0xabd63daa, 0xdd00a9d5, 0xf9b56d4f, 0xdfbf0a7c, 
	0xbe45e12e, 0xac79e0c2, 0x7e163156, 0xe8b0f0d6, 0xfb952cf5, 0xeadbc8b9, 
	0x3fc2fc26, 0x3fc17860, 0x5df86744, 0x9477862b, 0xf92707da, 0x91740338, 
	0x6fe9d4c8, 0x7e77e40a, 0x333f6e7f, 0x046fa716, 0xb0ffa3bd, 0x29ae7dfc, 
	0x7078595d, 0xfeff33d7, 0x25d14759, 0xa3dfe3be, 0xdc71a729, 0xb69fa0f9, 
	0xab987cdc, 0xc2174f43, 0x0b8418af, 0x2257a1cf, 0x3f755e6d, 0x1eed979f, 
	0x887bd7ab, 0x14dfcfec, 0x997479ba, 0xf76c1ef3, 0x2e8f2a9f, 0x61477eaa, 
	0xcbdd1e48, 0x371fff4c, 0x42d5ee8f, 0x17c0df79, 0x1b82092b, 0x83f01c25, 
	0xfd87ff90, 0xe6bd777f, 0xe17293af, 0x0a9bf39e, 0xd67af790, 0xca0f5d63, 
	0x079cf3fb, 0xe2e80fb1, 0xf36b7d61, 0x817bec94, 0xeb79abef, 0x3be072e4, 
	0x8e072e1f, 0x867cca16, 0xef03928f, 0xf0e072b9, 0x1bd069ce, 0x2bf56e2f, 
	0xc9def039, 0xc91540e5, 0xe37f8201, 0xfbe09e57, 0xadbf6e23, 0xe88fef81, 
	0xdf04fcdc, 0x2bc6e11f, 0x80a76c88, 0xfdde17fe, 0x54f529f5, 0xc0e6fc5e, 
	0xce5eb114, 0xdb13ad53, 0x32cf8487, 0x1d164d67, 0xe6449520, 0xdf4f08df, 
	0x3dc9fc49, 0x673f65bf, 0x8fa2fcc7, 0xfeba4fe5, 0x1a74c34c, 0xbc93e681, 
	0x398741a8, 0x652bf190, 0x43e732be, 0x1c34bf63, 0xf8037ce6, 0xaaffbc89, 
	0xfcdd9ff2, 0xb3ff41e5, 0xbe7938c4, 0x869b6472, 0x7696dc7a, 0xec8f7f4a, 
	0x526e69af, 0xe0678fec, 0x5bb1f373, 0x2e199343, 0xbd45fef7, 0x3df793b4, 
	0x9556fd07, 0x57c8a11f, 0xb36e9ff4, 0xb26b1b1f, 0x066f3ec5, 0x116ab2fe, 
	0x8a1e5836, 0x106be02a, 0xf073f25e, 0xd6ab787e, 0x38fbef16, 0xcc9adbf0, 
	0xdce4f603, 0xa0365fdf, 0xa55a8e89, 0x07bfa89f, 0x079c6b76, 0xf4ed97a3, 
	0xc49e33d4, 0xbf993ee8, 0xe65fba38, 0x3e687e2f, 0x7d8dfd23, 0xf7f9d651, 
	0x5c6fe91b, 0xeb8fac9f, 0xeff1f597, 0xe3f8fac8, 0x27d91eb2, 0xe7915fe3, 
	0x86f374b8, 0xcaaf09ed, 0x593ec4fa, 0xeb2fd89f, 0xf591de93, 0x2ca9c749, 
	0x97e4d612, 0x933b6e59, 0xaefca4fb, 0x4c52e7ea, 0xa7d64779, 0xeaf5971c, 
	0xa45ef27d, 0x14b8e7ea, 0x1ebcbda7, 0x917974eb, 0xbfa4c7f4, 0xfb0587a8, 
	0x3e3d678b, 0x37190dea, 0x02bdfdc9, 0xe4d873e4, 0xab97f5c7, 0xf3716bf5, 
	0xfd793a57, 0xd1cf0f40, 0x6eaa637b, 0xce216f1a, 0x74fdf168, 0x7c72a764, 
	0x6922dae0, 0x148cf627, 0x668c4f2c, 0x51c817a9, 0xae6f60d5, 0xc6ff7bc8, 
	0x85c7ff95, 0x2b6bef8f, 0x7390355a, 0x6e589b5f, 0x6f4bb069, 0x5df7922c, 
	0x5799dfba, 0x26dea6e8, 0xcb513fff, 0xf81c5687, 0x2ce06297, 0x0777a391, 
	0x9fabc8ce, 0xde6f5393, 0x9fd8622b, 0x5d8170ba, 0x910b4f10, 0x704f079f, 
	0xf7fb530d, 0xdbd4b8e9, 0xe16f5f9c, 0xde886f77, 0x75af9447, 0x3b46efe1, 
	0x02fd29a3, 0x3fa471ee, 0xb195f9fe, 0x7922a9e5, 0x1561316f, 0xfd2d807e, 
	0x09c6d7dc, 0x476717f6, 0x6bfe9e65, 0x3ef987e7, 0xc6ff3702, 0xba75615c, 
	0xc6f82179, 0x89d3dd6c, 0x03d9b07d, 0xdb6496b7, 0x5d1ee7c9, 0xeee43cf8, 
	0xdf4fc06c, 0x3cb0ac37, 0xc5eccbc0, 0x9f710b4d, 0x0f4b8926, 0xe5b58b72, 
	0x7fb0b787, 0xf23b764d, 0xfec80acf, 0xbf59fe40, 0xa9f0e708, 0x677562b9, 
	0x8c39f9ce, 0xf993df8b, 0x6b7f5c92, 0x7df3927e, 0xde1c77cc, 0x4bbe0c57, 
	0xe2711465, 0xb71842a7, 0xcf217418, 0x47c019a7, 0xcc9687f0, 0xb19612bb, 
	0xbd2ce39f, 0xdfa8efc6, 0xfed2d34a, 0xffd0ca9e, 0x692bec6d, 0x51f0a216, 
	0xd90479ad, 0x9ec7c5cd, 0x03ddebf9, 0x00a79c42, 0xf8967b9a, 0xca5baa55, 
	0x1185b067, 0x21b17fb2, 0x946aae2b, 0xb1df8f39, 0xec3dd25a, 0x748aa2cf, 
	0x69fdee13, 0xb5509f69, 0xcb83ec95, 0xd4253646, 0x891b23fb, 0xf736c91f, 
	0xa0bdbd60, 0x682f2a1f, 0x9975e1ec, 0x9a257c8f, 0x66be05d7, 0x1fccdff6, 
	0x423d028a, 0xfc12afed, 0xd7b3727b, 0x2de73958, 0x7b4b1647, 0x8f212dc0, 
	0x69e6df30, 0x47d81ebd, 0x1e7951c5, 0xbe330c8d, 0x6cf67177, 0xf73b8de7, 
	0xfcb77fb1, 0x93108f76, 0x0c6f58a7, 0x0cf18bdb, 0xad37df81, 0xc87d390c, 
	0xd10d347f, 0x9605f782, 0x06e7cfd8, 0xcd0f1223, 0xa39bc5b3, 0x34432780, 
	0xe35e6927, 0x8bb8c212, 0x8cab8fda, 0x6e127434, 0xa355242e, 0xed67b9e6, 
	0x5967f43a, 0xb6c25f72, 0x8ff16452, 0x41d4babb, 0xb7b8e3de, 0xbf407717, 
	0xfb962a8d, 0x3f0ee336, 0x87e6cfe9, 0x87edb671, 0x251c5f3d, 0x8d3f75bd, 
	0xe19fb417, 0x43b0a1b8, 0xc6d787e0, 0xc1ff9c59, 0x9394b77c, 0xd65ca4a4, 
	0xbc5c8778, 0x0e9ee5f6, 0xfd0d77ac, 0x9b8bef87, 0x5f627756, 0x4ba978b7, 
	0x2f9f0ecf, 0x8e882d9b, 0xe552f9b3, 0xcf3d31a5, 0x0dc7ca1d, 0xb8f3824d, 
	0x3756b767, 0x386e9db2, 0x4bd671d6, 0xab57bf44, 0x16a9227b, 0x7c078532, 
	0xc8f40670, 0x5df9437d, 0xd53e4b94, 0xfe229711, 0xcb729cad, 0x671f9c42, 
	0xfc32707e, 0x941c90e0, 0xe5f23ce7, 0xa77f2581, 0xd8b1f153, 0x79c05e5d, 
	0xf708af4c, 0xf507d73d, 0x3f62d852, 0x54073dd7, 0x6ebf2513, 0xf8e7c309, 
	0xecfc2b76, 0xdf147e01, 0x3ce9dfa9, 0xce790a93, 0xf48ee48a, 0x60bed967, 
	0xefc36ebe, 0x70eb3a30, 0x7e50a57f, 0x0ddfe92e, 0xc3467bfc, 0xcf8cfdb6, 
	0xebf16461, 0x8cf76a3e, 0x4e98dff2, 0x757cfde9, 0xbf00500f, 0xd7459bfb, 
	0xfda58ae3, 0x4922ebf5, 0x23cb4bd7, 0xa2bf2cc5, 0x9781c71a, 0xe62c4f96, 
	0x823dcc73, 0x2b233deb, 0x89c55d65, 0xc9579697, 0xf78d11f6, 0x56467bdb, 
	0xf29df7cb, 0xe5e8017d, 0xd32ac616, 0xfe72c84b, 0x8d60fb09, 0x3fcd3eca, 
	0x24d642e7, 0xbcb4b3f7, 0x1efb38a6, 0x19ecb74c, 0xb3c6ab59, 0x727578d4, 
	0xc14b72bc, 0xd7df2f57, 0x999faa5b, 0x0936fdf2, 0x17af7e3f, 0x077a5cf9, 
	0xddb21fe9, 0x6615182e, 0x2e7f9e7a, 0x7fa16c4b, 0x85e3fa5d, 0x2ecc1e4a, 
	0xe5173c1e, 0xfb8edce9, 0xba3da462, 0x2794f930, 0xbb7ffd4c, 0xb387fa58, 
	0x6f35b767, 0x348f7e65, 0xefc0346d, 0x9f70b3bd, 0x9911a57b, 0xdf00d5b9, 
	0xf672cdb7, 0x35239f81, 0xce121f78, 0xe36ff01a, 0xefed5b44, 0x9b25c644, 
	0x6ada3d68, 0xc45c829e, 0xe7d92f3d, 0x5b1c178a, 0xff79076c, 0x4af166d6, 
	0xb34a2dfc, 0xe4469bde, 0xe63764bc, 0xbdf4e117, 0x8b522245, 0xf85a6ddf, 
	0xc94a673b, 0x37870443, 0xe585bfb7, 0x1f6eb7ce, 0x48b7f4c8, 0xf6899db4, 
	0x1e4bed2d, 0xf40a3adc, 0xe6417f62, 0x3787db6d, 0x757f5927, 0x42168e40, 
	0x507f904e, 0xb8e0f848, 0xae072b9d, 0xc039656d, 0xbd076272, 0x40e5245f, 
	0x7a8385e1, 0xa980e58d, 0x21c15bce, 0xa7047193, 0xb0d27c00, 0x777e66c8, 
	0xe7cb8ee5, 0xe702a7cc, 0x9b3d2d95, 0x98e5f3cf, 0x3435e7cb, 0x4355df47, 
	0xfff300e5, 0xd58e7541, 0xfd48fc51, 0xf69d1991, 0xbe127a3c, 0xf6956f2f, 
	0x63eca3a5, 0x5ec26f57, 0x80e464f2, 0xfbb9a518, 0x072a1f3b, 0x807b1f18, 
	0xeaf7c50f, 0x1f2bacfc, 0xb05fbe5c, 0x40cf97e2, 0xa0f2bbbf, 0xe00d2454, 
	0x29f25161, 0xe85895de, 0xca93fe17, 0x2b1f3b81, 0x16a21088, 0x74b733bc, 
	0x5c7a2104, 0xcef1c901, 0x931e3d3c, 0x6f3f0cf4, 0xcc95f411, 0x8d7995ff, 
	0xd249e3a6, 0xb47b37ba, 0xaefc9b0e, 0xef3f21d0, 0xfdc02ef7, 0xbf41c391, 
	0x98b11f32, 0xd1394764, 0xf4a9617b, 0x6ca80b93, 0xb8bf35a1, 0x83f1cfcf, 
	0xe19efb8b, 0xa96f2b3c, 0x932cc7da, 0xf9a16479, 0x3f10af64, 0x708fda85, 
	0xadf1589e, 0x1e689724, 0x8f5a1185, 0xd84fbc65, 0x13333c81, 0xfbf117f7, 
	0x855bd636, 0x18579911, 0x91ef215a, 0xb74d4d0d, 0x7c9cf9bb, 0x2b45648e, 
	0x4e160be7, 0xb1bdf30d, 0xc308bcc6, 0xdade981b, 0xbbe30911, 0x9d8efb74, 
	0x9e088424, 0x7437826a, 0xccefbc95, 0xc9e6d798, 0xb0a88fbe, 0xd171cc2d, 
	0x05d9e8c7, 0xbdea872b, 0x961cbed7, 0x7c161df4, 0x13742b1e, 0x52fbf5d1, 
	0x43ae82be, 0xe7456d8b, 0x7d606eb6, 0x6d2ec23e, 0x48f6c9b8, 0x70fb977a, 
	0x824fd485, 0x29cf82eb, 0xd30e9814, 0x5c59a3bb, 0xf2bf520f, 0x2079d13d, 
	0x10d40f73, 0xc747977d, 0xe85ef6f9, 0x183fa226, 0xd69f2aaa, 0xbf0df343, 
	0x48f7f803, 0xf7556cba, 0xa6739922, 0xecba5d25, 0x6401dfe3, 0x5afa4a39, 
	0xdf12bfed, 0xc376541e, 0xac0bb055, 0x7cc0791c, 0x26d5fd0c, 0x5be65ded, 
	0xb966afea, 0x7013dfe0, 0x63b5d1f9, 0x80b36ec5, 0xfeb46df9, 0x92d57ae1, 
	0x2ff2e6fc, 0x860ccff3, 0x13d879e7, 0x102cdf2e, 0xd0e0174e, 0xea0ba787, 
	0xc07c79e3, 0xe6fdc9f0, 0x4cf2507f, 0xf8e05e44, 0x83f7cb62, 0xffcb9f92, 
	0xf9e0227d, 0x14c059ff, 0x000000a6, 0x0003e1f1, 0x7dcd9c78, 0xd5547c7b, 
	0x33dae8b9, 0x4cf6667b, 0xe4ccc926, 0x18f21335, 0x440320c3, 0x2025100c, 
	0x12260d95, 0x44506a10, 0x80edb58e, 0x45ad1051, 0x6da0d7a1, 0x308649dd, 
	0x40130221, 0x7c6ad608, 0xee7aa954, 0xa0db6b45, 0xa88375a7, 0x9e8db168, 
	0x4f6d5f5e, 0xdb4ac3c3, 0x7ac7a2b4, 0xdfb95202, 0x03cced63, 0xc7fb6a2c, 
	0x174fdf9d, 0xd7b5af6b, 0xbeb7d6fa, 0x4ed6faf7, 0x1846b9a4, 0x18ee216e, 
	0xbf89f0ef, 0x7c7f9109, 0x2638956d, 0x084285c4, 0x5b084da3, 0xb167f7c0, 
	0xc7dc885d, 0x20313cf5, 0x8f7ab784, 0xfb13b6d7, 0xeac55ab9, 0x6e353f54, 
	0x090eb7da, 0xe04308a1, 0xdf75554f, 0x5658f5cb, 0x2155bb79, 0xefc21a1a, 
	0x8c3cf5dc, 0x583ec6a3, 0xb8d109af, 0x77ed114a, 0x2294f941, 0x71091736, 
	0x7b1efe65, 0x7110b767, 0x15fe109f, 0xb4d7be30, 0x33c7293d, 0xf093c860, 
	0xfa03b8eb, 0xed99b5ad, 0x9a345fd0, 0x50c5eef6, 0xe77b4cfa, 0x97f4424b, 
	0xb7c4f994, 0xbff2fd52, 0x9094531d, 0x0ac1cd10, 0xe86ff89f, 0x2b4a1497, 
	0xb13ec3d5, 0xa03bea12, 0x55eb1dbe, 0xeb93bedc, 0xedd1bff5, 0x8dc86002, 
	0x1f85d80e, 0x6c0d6ce1, 0x454423da, 0x1920bc24, 0x540f7847, 0xfaa7aa6e, 
	0x57a84ef1, 0xe39d3f36, 0x1b15c169, 0xbac2d647, 0xa30a712e, 0x0f685afd, 
	0x2ec32e1b, 0xc7a5dcc4, 0x0001ca5d, 0xcce61353, 0x50bcf0c3, 0x2801ed28, 
	0xf2eb3c8f, 0x393efe01, 0x37f09d39, 0x2f6bf96f, 0x8afe60fa, 0x0555366b, 
	0x6238f0d2, 0x40a8db45, 0x5f9eaa4b, 0x219a88a3, 0xc4bbfc31, 0x906d56a9, 
	0xbf5063fd, 0xfe4f64b2, 0x55bc34a6, 0x0bacf9bc, 0x279ad3f7, 0x09761a37, 
	0x4b4573c0, 0x4880f3e6, 0xb435c6a8, 0x8568a76e, 0x45e31cf6, 0x5fe30923, 
	0xde095a2c, 0x1b784cbe, 0xa3ee3701, 0x2177bd72, 0x0fb9a624, 0x6ef603f7, 
	0xba94337f, 0x4c5a5f30, 0x60fb2a20, 0x9c059e7f, 0xaab02bea, 0x46a79a09, 
	0x282ace68, 0x3a476985, 0xe2058002, 0xd9c9c60b, 0xfa8fa547, 0xc2141b9d, 
	0x83543f79, 0xf0036ee6, 0xe1701138, 0xa1f5025c, 0xfc3a440b, 0xb17a6136, 
	0xce9bfa1d, 0xe0004101, 0x12a149b8, 0x93608b7d, 0x14c37582, 0xcc19df5c, 
	0xb7cdf7c1, 0x54e85d64, 0xeb850cd7, 0x758bdd3e, 0xc1bd7261, 0xd22fc3b8, 
	0xf0883fd6, 0x33ed095d, 0x627b820c, 0xbc5dd08d, 0xa7b6dede, 0x501af4a8, 
	0xf007549f, 0xea2b6942, 0xf783a9cd, 0xfe60fc2e, 0x87ea02ab, 0xa376f42a, 
	0xfa9bca11, 0x1ae371db, 0x4433a29a, 0x8e77f618, 0xa6adb49e, 0xec2aedf7, 
	0x50d5fe5f, 0x1b75463f, 0x8c8891b0, 0xe91f3d5e, 0xccd161ba, 0x4223b6f9, 
	0xdba39b4c, 0x394fb06c, 0x436b699a, 0xe2f784fe, 0x8b616584, 0x96bc7127, 
	0x0f04daa4, 0x8d080062, 0x5c7ef507, 0x3a0d1d6e, 0x30a4b5f8, 0xb9d50f7e, 
	0x40d7b109, 0x3f338a3e, 0x5f89d0ac, 0x983a4bfa, 0x9eab745f, 0x5d26f6e0, 
	0x6e3acff2, 0xb2fe65ef, 0x0dae7af8, 0xe29454d0, 0xffb04dc7, 0xd2a915be, 
	0x0574c79d, 0x8098bd40, 0x4c7d6a71, 0x2dc1cd4f, 0x228d5e3c, 0xf3cadfc7, 
	0x0f6bf30d, 0xb67e4bb7, 0x0376ebb5, 0x1cb6c468, 0x8840a8e8, 0x7fe87751, 
	0xf28bd828, 0x7728e848, 0xf158c2d4, 0xf5439456, 0x01ba9be1, 0x58c46a31, 
	0xf98861b2, 0xf0024d75, 0x56f615e5, 0xa762953f, 0x1363fc8e, 0x7ca3e409, 
	0xa4b6489b, 0xfac5d9f1, 0x525a1b39, 0x719a767c, 0x1166db6d, 0x5a25e4bf, 
	0x6c2ed74f, 0xfc42cd77, 0x66ddceec, 0x4a4b3ce0, 0x859c2136, 0xce08ebe1, 
	0x7b6c537a, 0xddc9c69e, 0x7f3ae060, 0xb46cebcc, 0xc653f0f0, 0xc7259f43, 
	0xd07b7176, 0xdb867f6a, 0xe9f7214d, 0xb1af5c67, 0xee59e9f6, 0x7b50a75f, 
	0x0d80d03e, 0x13e7c9f6, 0x851b9ebd, 0x72cfd8b8, 0x2fb912f7, 0x9fdea20d, 
	0x0178043c, 0x3e062d3e, 0xfef3e48d, 0x33e35f14, 0xefcc456d, 0xefcc03c9, 
	0xbf330e5b, 0x7e601f77, 0xa216ce4f, 0x8ed3c60c, 0xf91df8a6, 0x20ccf99a, 
	0x7efe253e, 0x83b3c60e, 0xe2963dbc, 0x8d26c1ff, 0x03780af9, 0xfff117e5, 
	0x135fc962, 0x4ffbe54e, 0xc61373e3, 0x3f3f3a36, 0xa3f25b9f, 0x7ce5d601, 
	0xbe7c34ea, 0x4c1f9e0c, 0x355db9f1, 0x29ed9867, 0x240b63f9, 0xdfac04bb, 
	0x0bf3d056, 0x784d7581, 0x04dfa80c, 0xd1562df4, 0xd7ec1efc, 0x9e82737b, 
	0x231ec4c3, 0x8f97e294, 0xd1c15fa0, 0x3163f953, 0xee057fe2, 0x7f0650e3, 
	0xd9b0965c, 0x4fb0f161, 0x08a7ed0a, 0x887b650a, 0x7e204ffb, 0xbc4fbbfa, 
	0x0cc9e58f, 0xa25fd73d, 0x4fbea9f8, 0xf764f497, 0xfa645eb3, 0xc03afda0, 
	0xd6f28ffb, 0x6d3a728b, 0x6c7dac9f, 0x36706600, 0xca13eda7, 0x7c2989e7, 
	0x7233cc34, 0x9d892e50, 0xcbed0e5a, 0x07d867db, 0xb37da15d, 0xf7dac1f6, 
	0xddbc3779, 0xa9e4d22d, 0x1be73766, 0x1dc2f788, 0x3a1ab929, 0x4be59e55, 
	0xe34e91f8, 0x1a9ef0b5, 0xa7115f36, 0xeba025d2, 0xe8b3ebb4, 0x32e953f4, 
	0x853debc6, 0x22bea52e, 0x3a74bc3c, 0xc14cbd3a, 0x1f545ffe, 0x4f4e919d, 
	0xc20a47d5, 0x484fe163, 0xaf4d94fd, 0xaf4d93c2, 0x6d239e8d, 0x0e6d3a29, 
	0xf49d3236, 0x567dfd31, 0xffc1bffd, 0xd7fe87ff, 0xb3be20bf, 0xd567fff5, 
	0xbe39eef7, 0x3f7d74f6, 0xac6d9ba8, 0xda9b75df, 0x05ffd291, 0x8cd7fca0, 
	0x0f1d7d62, 0xf78e9eb3, 0x0d33a0c2, 0x3e63da8d, 0xcf091b61, 0x86fe8097, 
	0x50f5f9e7, 0x8ffea586, 0xbe07fa49, 0xeec1d0a9, 0x4f6526bc, 0x93103d90, 
	0xca674376, 0xa1fb204e, 0x24beed17, 0x2f647dd9, 0xe8e95388, 0xaa0fdaf3, 
	0x9bed28aa, 0x942c21a0, 0xf597a26e, 0xd4fbff7e, 0x522b1855, 0xcae5077a, 
	0xdeb13ff8, 0x7b9e0b39, 0x7e590677, 0xbcaf419d, 0xcaf505fe, 0x3823d517, 
	0x3f84bfd6, 0x17c7e4b3, 0xfa3723d5, 0x23d43fc5, 0x6740b5f9, 0xcb57c025, 
	0xdf8476d5, 0x6f3e7829, 0xbb60c614, 0xfc895c92, 0xadedbb13, 0xedd4b04b, 
	0x852c36ad, 0x88477f68, 0xb5ecdfc3, 0xaa1c3121, 0xfd1db5b8, 0x63ec0f3e, 
	0x89ecf010, 0x3d8d4aea, 0xa379cf65, 0x0748ffb0, 0x5103a661, 0xf4062ba7, 
	0xb7a6f877, 0x383a5da1, 0x2ebf9e16, 0x1be61df7, 0x633e13ac, 0xbb9eaa61, 
	0xe9af88c4, 0x2cf78d4d, 0xd10fe00a, 0xaded330e, 0xb6fda19b, 0x1447789e, 
	0xd675e7e9, 0x5bd63e53, 0xfe792aff, 0x7fefcbcf, 0xd3649e4e, 0x75e499c7, 
	0x234fdf6a, 0xfbbec9b7, 0x2c24f198, 0x5ceff0fb, 0xd96f18d7, 0xd215c4f6, 
	0x437b439e, 0x0f615d90, 0x2a8f5c90, 0x70703ed2, 0x1fb64dfd, 0x6ec555f3, 
	0x23f5bc00, 0x9ca3b2af, 0x1f318dc9, 0xe95d7e8b, 0xd21df686, 0xc92fe93e, 
	0xb19b8809, 0xbdb00dcc, 0xf90df961, 0xcba99e3c, 0xef5cfdf1, 0xb80bdab1, 
	0x5eab0eff, 0xab5ef5c4, 0xeff7097f, 0x10d9ecb3, 0x5f96ebb7, 0xc3db8230, 
	0x397f5c8a, 0xfb2d7bd7, 0x47fb92b8, 0x2cf8fb2d, 0x6f9adfd9, 0xad07b724, 
	0xbd7146f9, 0x867e974e, 0x66b019b0, 0x5cb63def, 0x2897c794, 0xde5f44fd, 
	0xe05180a9, 0x04dfb39f, 0x71803b4a, 0x0b639112, 0x4099ff43, 0xee319b3a, 
	0x2ee1fe61, 0xaa3df3b0, 0xe801b658, 0xfd2cd470, 0xa4bdfe0f, 0x5e7edf37, 
	0x718878c5, 0xc62f6bb8, 0x77ebc413, 0xfab748a9, 0x57bfe4d3, 0x9799b419, 
	0x92d88e80, 0x557887e6, 0x34a6d773, 0x10a2bf7f, 0x01e2d3da, 0xb65c3795, 
	0xa7e693cb, 0x9c9ec454, 0xc4219bef, 0x48b08ee5, 0xcff590c2, 0x5989e299, 
	0xf19a6f68, 0x8ba46ecd, 0xd4b6abde, 0x5de97b53, 0xe07f6a71, 0x01f8b4ee, 
	0x76402eac, 0x3884c81c, 0xbae22fc6, 0xa524bed2, 0x9a8e1a6f, 0x69744e3a, 
	0x2db458cf, 0x6fc7e545, 0xd0d69d92, 0xea3e7cb3, 0x3d3f05a5, 0x7581a81e, 
	0xe7b40e5d, 0xc2befe03, 0x61f417a5, 0x816dfbfd, 0x303dfa28, 0x67bdda03, 
	0xf81469bf, 0x354b9e60, 0x2ed920b3, 0xfd99bbf9, 0xb9f01b13, 0x48dcf903, 
	0x0fe073e7, 0x73a1abe4, 0x8cf6f933, 0x5dda5d72, 0x607fa67a, 0x2a7c922c, 
	0x0f89ef98, 0x3da0ff51, 0xf2097c44, 0xd59a25f6, 0xfe636833, 0x5bc6d13e, 
	0xde9db7b2, 0x476beef3, 0x23b669b9, 0x66eca49f, 0x39bec33d, 0x07b05df4, 
	0x4d1cfda0, 0x410fabf4, 0x7f9655fb, 0x5854d86f, 0xc8d1b79f, 0x392df7f0, 
	0xe527c135, 0x931bd484, 0xce3a7f60, 0x957ffd03, 0x9cfffa49, 0x23da48a0, 
	0x4361ae08, 0x05f24f7d, 0xe9add0e8, 0xd427efa4, 0x90f1c309, 0x2931f3d4, 
	0xd4cfee57, 0x589a20f7, 0xc94e2cae, 0x5255ef23, 0xfeb137df, 0x65f636f7, 
	0xfe4b7fe8, 0x49ec2e0c, 0xe90a01d9, 0x18afe67d, 0x37459bf3, 0xe31b2780, 
	0x62f9f419, 0xafea375e, 0x1b6b0085, 0x7bfc9fe8, 0xdda2e666, 0x414ec022, 
	0xc7bb403b, 0x85c77146, 0xdee7b73a, 0x1bb647b3, 0x71df7c36, 0x1aaf1ecf, 
	0x7730fa43, 0xbf817c58, 0xd67c307c, 0x83973bc1, 0x4780954d, 0x8a2b2623, 
	0x47ebfd0f, 0xd10144da, 0x2f92299d, 0xea19f3e2, 0x305f6848, 0xe78110da, 
	0x5d587fb1, 0x1ffe1027, 0x0c8dfc30, 0xc763c03f, 0x93718352, 0xb9e6fc69, 
	0x9797d63a, 0x59b98fc6, 0xfd0857ed, 0xeafce927, 0xeb85f555, 0x3a8bdf80, 
	0x7af9face, 0xb17737e0, 0xae2b63f9, 0xe926fc40, 0x3bf601be, 0x2a207a8e, 
	0x9203d6cc, 0xe8a766df, 0xf7aef89f, 0x697ff4cc, 0x60f7184b, 0x2b3e8f98, 
	0xd88b983f, 0x313b230f, 0xe001f926, 0xa7b65ca9, 0x9ee00abb, 0x4dd4f377, 
	0x9ee3e411, 0xd4288175, 0xd3f1ff2f, 0x20341a81, 0x77fd01d5, 0x1be1e7c6, 
	0xca1fbbc3, 0x409ba8e5, 0x3ff82dbf, 0x71b503c7, 0x43e40fa6, 0x88146c35, 
	0xde3f7097, 0x85c66408, 0x9cf962de, 0x6fddf4b0, 0xeb117db8, 0x6cf15383, 
	0xe395be3c, 0x6e1d7db4, 0xfb807fec, 0x1fef58b7, 0xb89af1e2, 0x73c230fe, 
	0x9dabd10b, 0x43377be7, 0xff07363f, 0x4b0dfdc8, 0x6b39fcff, 0x7d70bfbc, 
	0x1efed585, 0xf191eff7, 0x5ccce897, 0x7ca4ec03, 0x306dcfd0, 0x9b5cee57, 
	0xecf00f3b, 0xe4f36b9d, 0x5d1d1c81, 0x5c98f1c0, 0x5fe8cd90, 0x273d41b5, 
	0x367ade2d, 0x215a2fd4, 0xe3283fdf, 0x838c0960, 0x9d838a09, 0x7fd8fa0f, 
	0xbd0ef494, 0x93ef38bf, 0xe5e80e40, 0xdbd63151, 0x181bd00e, 0xa95d9f47, 
	0x113ed898, 0x7fa0fbfa, 0xaacb80a4, 0x67b3b602, 0xbc70a7df, 0x9ded375d, 
	0x165f8eb0, 0xab8db8f0, 0x4759af5a, 0xb55c2b7a, 0x7b98e601, 0x3d37b632, 
	0x6dc97d4e, 0xd803abfd, 0x260e185e, 0x1cbd00d7, 0x07c4b15b, 0xd7efb9f5, 
	0x38c3cd8c, 0xceb3aafa, 0x3d406eea, 0x2736f864, 0x05053f11, 0x1623af84, 
	0xd20a8afe, 0xbfc97df1, 0x9dbeb135, 0x1736fac6, 0x0ab94127, 0x41cdaf32, 
	0x46fe42e4, 0x4715817f, 0xb8c02b2c, 0x8e55e807, 0x570d87b7, 0xe3c710e2, 
	0x03e748dd, 0xe0e49fec, 0x81fec93a, 0x5c7e0315, 0x25df7205, 0x9c97f7bf, 
	0xb0b470cd, 0x6f38b05d, 0xfb0b8d34, 0x2e0276e4, 0x272fd855, 0x65ea97ec, 
	0xbf617b3c, 0xfb42eeba, 0x8035d840, 0xf3e1af57, 0x8c028f91, 0x7146e837, 
	0x91489d45, 0x9c568de3, 0xfc706c31, 0x3d5a5374, 0xbd2c4caf, 0xb7acc613, 
	0x38b6c587, 0xec4c7fee, 0x31a587de, 0xc20d7cf0, 0xc9e08533, 0xb4e46b9f, 
	0x5fc86e81, 0xf8aed475, 0x1da3fce8, 0x839011ed, 0xab7a77e4, 0x201d558c, 
	0xb0f5722f, 0x3bd280c3, 0xfa1577b6, 0x6f7f6899, 0xab5bfb03, 0x1c61b5f2, 
	0x650b1b49, 0x1e329437, 0xade8f0e5, 0xdff71f49, 0x5838f602, 0xef2f8489, 
	0xe855de92, 0x8ffbe287, 0x7c4bfbe0, 0xc105c606, 0xb13db08f, 0x9d90fd84, 
	0xa90fd96b, 0xae43f349, 0xf106fc01, 0xea1bf07d, 0x90fca676, 0x14c2b3c3, 
	0x10fcb578, 0x29dc3ff2, 0x3f0340ff, 0x4ff606a4, 0xd8243f03, 0xe087e69e, 
	0xfe8aa838, 0xe103ff09, 0xde3bf6cf, 0x015d789a, 0x6d09279e, 0x171c38d6, 
	0x319fefe4, 0x9f2c34be, 0xa27627c1, 0x7c81f53c, 0xe7169c5e, 0x259c9a1a, 
	0x7d9f3f8f, 0x758fac32, 0xc7a93921, 0x869dfd86, 0xa69857e5, 0x6009f961, 
	0xbf07949f, 0x76e7805d, 0x1534bc96, 0xcbc803c0, 0xfba06279, 0x7fa646fb, 
	0x7a436f1e, 0x599f2436, 0x16482e76, 0x6c034b94, 0xa9237ae7, 0xfdf23878, 
	0xc7612125, 0x658ef3fd, 0x14b9463a, 0x5f363a22, 0xaf53b74a, 0x9cd8392c, 
	0xfebe27ac, 0xd3a056f2, 0xc0a67522, 0x6a8f3ef3, 0x0a0cdbac, 0x92496175, 
	0xf3d26de7, 0xd00bce11, 0x78883a3e, 0x3c5a7cde, 0xc52aa917, 0x11342a11, 
	0x303b480b, 0xdf6a54f0, 0xb976862b, 0x163c34b4, 0xdfe49d39, 0xe4687fe4, 
	0xbfa80605, 0xe74b5059, 0xa86ef688, 0x781ea1fb, 0x559f6528, 0xc62ef4b4, 
	0xdbbe877e, 0x9f748ed4, 0x9cf3273b, 0x586a3725, 0xd60a30e7, 0xceb13e2d, 
	0xae9a1c5b, 0x715b7ee0, 0xe0a3e813, 0xb46e4b79, 0xd225e38f, 0x50ea2e2f, 
	0x39dcae08, 0x3a137199, 0x70403bef, 0xd2beb81a, 0xb0d71942, 0xf6cc2be8, 
	0x903fc61e, 0x647d66be, 0xbe90d9e4, 0xf787fea4, 0xb6fed1bb, 0x2fb364e2, 
	0xc61afa9d, 0xfdb33e77, 0xcd3d326b, 0xa7fec04f, 0xdd97bbd9, 0xa040bc77, 
	0xbd4d553c, 0x38b6b61f, 0x8fed22f8, 0x18ce6bdd, 0x4fe75230, 0x7997c1e5, 
	0xaa7d253f, 0xd90fdb06, 0xbb74a3f1, 0x39afe910, 0xbdefcfd8, 0x92fe72c9, 
	0x0ede8017, 0xa6c95c62, 0x05e4dfa1, 0xa7e7811d, 0xecc7b7f5, 0xed690e78, 
	0xa09bee57, 0x4d2c74d7, 0x8483da27, 0xfee487a7, 0xd09e24c5, 0x92d99d2f, 
	0xd4f3b69c, 0x5073c3fd, 0x5e3a756d, 0xee748f18, 0x034e7009, 0x1ced8d7f, 
	0x16edc11f, 0xc4c9d93a, 0xfda99d6f, 0xfb80b8a6, 0xfed33c54, 0x231e24c7, 
	0xc4bbc1a7, 0x58aeda13, 0x4eeb3827, 0xe0f297a5, 0xd90fcc47, 0x6fe461f1, 
	0x35ce6bb4, 0xb9545bfc, 0x7f9f68ff, 0xfad3e468, 0x174ff035, 0x7c06394b, 
	0x7032d0d8, 0xe1d2e833, 0x8bd938b8, 0x57fb5247, 0xe217b41c, 0x65fbd93c, 
	0xa8362b9d, 0x2ff90daa, 0xa6056e3b, 0x39f14abd, 0x8a49aba1, 0xb4aa988b, 
	0x1d9ea9e3, 0xee73c40f, 0xfdcd3c74, 0xaed86820, 0xfa47fa65, 0x2c2f3ecd, 
	0x5838fa92, 0x5684e7c8, 0x28bf1d99, 0xc0f3d61a, 0xc5ce7439, 0x92c2c276, 
	0x032fae72, 0x2538b339, 0xf2be2c67, 0xa707606b, 0x4dd415f1, 0x1e8a737b, 
	0x6868d044, 0xeaf8a775, 0x25cda4b2, 0xf55f01fe, 0x9bb655db, 0x2e9dceb3, 
	0x4ae999ef, 0x97f9abe7, 0xd8073406, 0x98d4f32d, 0xbc705eb6, 0xa0c1c50f, 
	0x75f5f013, 0x1dbc7fc6, 0xc32d71e5, 0x1ce2b51f, 0x79f217e7, 0x50efaf27, 
	0x7189d99e, 0x93154388, 0x303fa1d7, 0xe2886eba, 0x4689d1c0, 0x83c5e31c, 
	0x481286eb, 0xc25d07ff, 0x983a3e44, 0x5da1d62f, 0x7f967078, 0xab8df21d, 
	0xce3a2831, 0x80edef92, 0x28ead3fe, 0xc2f4ecce, 0x4e6be8b8, 0xf313b57b, 
	0xa55f461f, 0x9a1e5824, 0xae3fc839, 0xf315b33c, 0xe6b95c2d, 0x02204e8c, 
	0x5054d797, 0x6bde0c4f, 0xb99f2426, 0xe5f45fb0, 0x3d656b19, 0xaf8fea97, 
	0x44f08b5e, 0x1b9eb05f, 0x583e7c5e, 0xfb40943b, 0x4a7c7463, 0x31d81a62, 
	0x25ccbfa3, 0x72c513c1, 0xb2eb8128, 0x8db8eee4, 0xa062aeb1, 0x85b773eb, 
	0x7b03e27f, 0xd73266b2, 0x3a874c27, 0xf731abc8, 0x6fe81d41, 0xbbe1bbec, 
	0x0a0f64dd, 0xaf8be515, 0x84d8f58c, 0x06af6ec4, 0x1c8515f5, 0x2f9eb2a7, 
	0x0b1cc42b, 0xedfb4ba8, 0x7eac96dc, 0xc6bcfc85, 0x537e7cc8, 0x2f94d321, 
	0x1a63edc2, 0xe6abdeb3, 0x6536c7f1, 0x68b71f3e, 0x65fd17b7, 0xea4d8f4b, 
	0xbe2b9dd9, 0xa8e4c427, 0x04fda04b, 0x809da870, 0xc855ffff, 0xd6afbff6, 
	0xf3e2e8a8, 0x0f3681ea, 0x7a371b8d, 0xd5fa7ca0, 0x26b7a8f5, 0x6d18771f, 
	0xe85eff30, 0x2bfa093f, 0x63d72743, 0xf1f2781c, 0x5aba1393, 0x906a0830, 
	0xb8f9311d, 0x7601a779, 0xf0b1e4d6, 0x57de0bbe, 0xbef7bc65, 0x7768bd57, 
	0x7003d3bd, 0x4a62116d, 0x0d3c8ccf, 0xe84a4dfa, 0xa280d82a, 0x0b25ea47, 
	0x4a3db53f, 0x8d27b52e, 0x3c74f6e1, 0x8333d79d, 0x250c6bdb, 0xfbe25da3, 
	0x6e569efc, 0xdb3333af, 0x7aeb1e25, 0xc7bf9e14, 0xe25f1ccc, 0xab4f6273, 
	0x8407da97, 0x7b27db0b, 0xaf805d60, 0xe1273649, 0xa46e7e01, 0x4eb049d3, 
	0xc127eff4, 0xc72093ba, 0x91d6b45e, 0xbbc1eeb5, 0xc740dd61, 0xaed90bbb, 
	0x1c319489, 0x1ab92f40, 0xe58fd3ec, 0xfff3d6fc, 0x2225e92d, 0x97a023ed, 
	0xafd27ecc, 0x78c97a02, 0x0bd214fe, 0x76e11f8e, 0xf7cc97a0, 0xa07c79aa, 
	0x40e78c97, 0xbf28b92f, 0x84b3917d, 0x0c9bde1d, 0x4a6da2f4, 0xbee4cfd1, 
	0x7181fa4c, 0xc7c0933a, 0x5f0fa011, 0xeb85d792, 0xf9fc7c9e, 0x8b4bdf09, 
	0x7e3e4c8f, 0x21e6e547, 0x751b6f8c, 0x8f5a1e1d, 0x47fa15bb, 0x27457b6a, 
	0xf0be6dd8, 0x9f823b81, 0x06e9bf60, 0xdd743dca, 0xbeef80db, 0x0015e303, 
	0x1a36535c, 0xae83170f, 0x5e16ddae, 0x3b7e0016, 0xcfd7326f, 0xbaf5ce9f, 
	0x25b9c2fb, 0x7c4ddfe0, 0x25f0e8d7, 0x22e48e48, 0xe61e4e3f, 0x75c54547, 
	0x39642c1e, 0x5b7f3d6e, 0x30f277e2, 0x1bf5663f, 0xe7ccc7e6, 0x271f9203, 
	0xd663f30f, 0x98fcc37b, 0x22dc7cf9, 0x29420f30, 0x500cfa7c, 0x9f4f80d8, 
	0xaf64e7c4, 0x78fc8b99, 0xb7fd90a4, 0x02e2b5c9, 0x3a2b8fc9, 0xe6b8e1d6, 
	0xc9c7e47a, 0xfc19fd6d, 0x9dde0138, 0x1f9d3474, 0xf7c3cfa7, 0xc23f10be, 
	0xac45ab7e, 0x50f83317, 0x6475c73e, 0xf3fa5ff0, 0x7f4bbe74, 0xe96fce9e, 
	0x6cf9d3cf, 0x7ad7f113, 0x8c9b03cc, 0xf0c455fc, 0xfe084b26, 0xdf8049f5, 
	0xfdbb0f17, 0x256b2fa0, 0x4213187c, 0xd9f873bd, 0xb5857357, 0x838fc0ef, 
	0x679e034f, 0x88be3108, 0x96726cf9, 0x622aae5c, 0x8f9eb77a, 0x83a6ca28, 
	0x72597eac, 0x567e7ad9, 0x641d3651, 0x972597bd, 0x5c96e7ad, 0xf307fc8e, 
	0xf4c324d9, 0x390c816a, 0xa02315ed, 0x8bb8ba44, 0x6cf91df7, 0x67ccddf2, 
	0x33e62eb8, 0xb5efbcc7, 0xc9d9f3a4, 0x10b7360b, 0xae76f59f, 0x3e427a63, 
	0x067c8c9b, 0x3be911fc, 0x57bd9f3d, 0xa32079c8, 0xf78e2bc1, 0x86037b4b, 
	0xd566ad1c, 0x4a6f509d, 0x93ff51d5, 0x78e4993d, 0xb459ea2d, 0x95ef0733, 
	0xced807cf, 0x7abcbe8c, 0xa77bd52d, 0x5971fd70, 0xde8539df, 0xeb20be8b, 
	0x38476e49, 0xae0f3954, 0x580e414c, 0x3fa4f0c5, 0xfed47847, 0x30f51d54, 
	0x1f48adda, 0xa1f3df18, 0xe00cbe7f, 0xd2380369, 0xf3c471fc, 0x3fa0778b, 
	0x3d914578, 0x47541fcd, 0xd07f222e, 0x967f35ed, 0xfc32c7a8, 0x1f80a3e4, 
	0xedfea177, 0xf5e78e2e, 0x7abc046c, 0x9da574cb, 0xf41553cf, 0xca3ec003, 
	0xea9db377, 0xea9db04a, 0xd3dd404c, 0x506ac624, 0xed88a4ff, 0x3627fbca, 
	0x421fa917, 0x8e318f73, 0xb63af3ec, 0xdd5e0fb7, 0xc61aae32, 0xcfc6547d, 
	0xdf4e550e, 0x7732f48c, 0x0915eb6e, 0x21be97b0, 0x93ecb7df, 0x1ec0d331, 
	0x15717a02, 0x8bb4028a, 0xbdba4ae6, 0x08b1d245, 0xbfe3493e, 0xf64c2a3c, 
	0xa1e347e1, 0x68f9d605, 0x1aeecb53, 0x91672798, 0xe9d70e3e, 0xd23a9e6c, 
	0x59c7bb00, 0xcca4733a, 0xffe1f013, 0x8b6e0b9d, 0x8d3bf3d0, 0x0aafb488, 
	0x558779e9, 0xabaa15d7, 0x19e04d2e, 0xb5bb8481, 0x0f86e388, 0x116eff8f, 
	0x7a2c89c6, 0x3e654c7e, 0x74c45c38, 0x9681d966, 0xbaf738dd, 0x802ad65b, 
	0x2c573987, 0xfe01517f, 0xc9f4bc3d, 0xac01f402, 0x1c1ec9f7, 0xec20f690, 
	0x62d18cdf, 0xec9fe237, 0xe3b29142, 0xa78578e6, 0x43b45dfb, 0xc824d6cd, 
	0x7290ff83, 0x26f4e0e2, 0x0ba347b2, 0xe02016c6, 0x380feb73, 0x038c1895, 
	0x3abda2e3, 0x277b51e6, 0x7d243dc5, 0xfa10b8cc, 0xf18cdf03, 0xcfd35bc4, 
	0xa1c79db5, 0x31a1c83f, 0x0ebc8d13, 0x5689cfc4, 0x6393fa37, 0x687f4226, 
	0xdfbd3c3f, 0xcf3e402d, 0x4dc0edfd, 0x5ae76939, 0x70cc4f73, 0xae69dc63, 
	0x7973e797, 0x00eaadd6, 0x3365d87b, 0xe349ad56, 0xdb5b5727, 0x1f3e272a, 
	0x0a9563bb, 0x827519eb, 0x13dcdbe5, 0x1c36ceb0, 0x75c157bf, 0x7185adcc, 
	0x2f7da45e, 0xb8758568, 0xa56d5eaa, 0x28537df7, 0x99c565ce, 0xad56be9c, 
	0x670afc06, 0x0416b770, 0x4d4c6b7f, 0xa57dc09d, 0x637b407e, 0x3f507ff0, 
	0xdfef04fb, 0x35745068, 0x1f78539b, 0x7053760d, 0x876f7cb3, 0xd683bfec, 
	0x6d20b4b7, 0x7f05d17d, 0xd01c6272, 0x772acf7a, 0x522cdd7c, 0xad176fc8, 
	0x2b4c4fe8, 0xeed19b13, 0x5afcd69f, 0x2efdda2b, 0x974c9e9b, 0xab352e2f, 
	0x3a7a84ee, 0x5991847e, 0xef5919b7, 0x599dd567, 0x4a1edffd, 0x2bbf11c6, 
	0xe47c738e, 0x471c9d48, 0x15cba64f, 0x0ea32384, 0x19cba470, 0x0ea32384, 
	0x9fbe6470, 0xca44ff59, 0xf3278423, 0x7ea3333d, 0x6d517ce8, 0x4c588314, 
	0xfc43ac34, 0xb2db198c, 0xdac4f91d, 0xa00b8c4f, 0x40e7a47e, 0xfa6c631f, 
	0xc1279a76, 0x0d3a0fef, 0x87f187f2, 0x0bf3a271, 0x73b4e661, 0xa8e38279, 
	0x2cee312c, 0x04801cf3, 0x732718ec, 0x4aff8295, 0x9d10f5fe, 0x54973a23, 
	0xbe69bfb2, 0xfc7f22ae, 0xdceb4ec7, 0x5fff20d2, 0x56ee8f38, 0xab4dbe40, 
	0x8be484fe, 0x2d6a1c28, 0xa2a24044, 0x60e9e51d, 0xf636f9e4, 0xf30574eb, 
	0xfde3448f, 0xbadc70e3, 0x71a02eab, 0x2d4ebd55, 0xc6eefe83, 0x32841284, 
	0x18abae7c, 0x51ee8be3, 0xf80bb286, 0xc76f3dc4, 0xd9f90a83, 0x4bf462ee, 
	0xde66b5b5, 0x51c73e64, 0x98412f29, 0x60a3e52a, 0x35c603e0, 0x4ae792de, 
	0x89782742, 0xed5e0142, 0x21473ad2, 0xebe7be30, 0x28328e7d, 0x73acdfbd, 
	0xbbcca046, 0xad59cfa3, 0x5ee2b9d0, 0xbb3c573a, 0x46e3fd87, 0xaafc1fc6, 
	0x615d930e, 0x59420d54, 0x62966276, 0x08e29d80, 0x6252f83f, 0x48fa9437, 
	0xda1c3b32, 0xcbd74a73, 0xfef50ff0, 0x148cbb8e, 0xa367e13e, 0x2f15a8f3, 
	0xde7f3e11, 0xdbf8cb96, 0x7ef04831, 0xe0953058, 0x2e7b00dd, 0x31b8243e, 
	0xd2fb821c, 0x5bdc768e, 0xb26e9913, 0x135bd3f5, 0xd64f09ab, 0x26a6c0f3, 
	0x76ab178e, 0x6aaa0bd2, 0x37279c13, 0xc0274973, 0x94c0d091, 0x70744c3b, 
	0x9a9deb10, 0xaf50dd30, 0x32bd662b, 0x0b6fce43, 0x38c01f24, 0xe6fa1742, 
	0x072f0807, 0x85d3ee31, 0xca31bbe7, 0x1371a2b7, 0xb35e3035, 0x918550c0, 
	0xee352a78, 0xf3a9f03a, 0x245e1e40, 0xcf275dc7, 0xfcf0bb75, 0xa6950277, 
	0xb5c5f413, 0x0207df38, 0x401e39cf, 0x3b5553fa, 0x1bc407e9, 0x2d8477c7, 
	0xc1f19b39, 0x86c31ff1, 0xdd941ef1, 0x56f71809, 0x7efb5f0b, 0x5f34e741, 
	0x79902e6b, 0xc0378c2f, 0x768ad299, 0x6b962ae6, 0xa84e9788, 0x76cc56df, 
	0x849f85b5, 0x39e1544f, 0xfddcd80d, 0xc54e87de, 0x7cc5d5cf, 0xcc5cd53e, 
	0xf199f0fb, 0xaf718313, 0xcaa8f891, 0x0f9e8fc0, 0x3f124de5, 0xa63f9784, 
	0x197a22f0, 0xbd3e831f, 0xc73afe35, 0x4b3ff1e4, 0x3afa0e9e, 0x1886f185, 
	0x725bd78e, 0xff405061, 0x19cf6c85, 0x1d2f6971, 0x1578fcfd, 0x9f08c78d, 
	0xcc0523e1, 0x1b9f1247, 0xb18afdac, 0x79e0781c, 0xf9815fe6, 0x3f1e0177, 
	0xc84fc721, 0xfc7213f1, 0x893f1c84, 0x271cf7e3, 0x2d19d83e, 0xa61afda4, 
	0x884fbafb, 0xed5e9e1f, 0x53c7d8cb, 0x65e5a8f8, 0xf879cf82, 0xf437ee6c, 
	0x7c678237, 0xdf1639db, 0xb4cff067, 0x24c54dea, 0xa54e5097, 0x2b9b37c9, 
	0x281854a6, 0x7a1e591f, 0x97a676e3, 0x95f08db8, 0x15439f8d, 0x50fcdab7, 
	0xf2275f77, 0x7c29630b, 0xe6e5b385, 0xfad3df91, 0x31b44df6, 0x40fe477c, 
	0x9e7ef9f0, 0xedf9f043, 0xde70dacb, 0x603fd569, 0xe5e4b5fe, 0x3177800e, 
	0x3e3683f9, 0xde29d777, 0x335764d7, 0x689461ce, 0xa7c61b5d, 0x8fdef21d, 
	0x28768d12, 0x69af5c61, 0x8afb5374, 0xca40caad, 0x8438765e, 0x9750fd8e, 
	0xa8ea9da0, 0x5f689b0e, 0x6e2eaea1, 0x7f83b74e, 0x934f6c52, 0x586bde27, 
	0xe72fc0ce, 0xcdc7ce43, 0xa438e7e9, 0x573a4dfb, 0x7c03dd37, 0xc239eebe, 
	0x56d1cf75, 0xc886bbaa, 0x265d3432, 0xb8fb6bb7, 0xfd71c35d, 0x21f93a65, 
	0xa3af48fe, 0x765225d3, 0x3b8c9970, 0xfa3b0d07, 0x3b6f806f, 0x27fb95ea, 
	0x3c8c54be, 0x6eafb81c, 0x07c7da2c, 0x863e5703, 0x4ecd3a72, 0x593b436e, 
	0x4ec837ab, 0xebf24d7e, 0x34e339f0, 0xa8794361, 0xe7e94215, 0xef7c0a7c, 
	0x2769628d, 0xf9a0ed0f, 0xa22feecf, 0xff1a3ff9, 0xa3cbd106, 0x0b93b649, 
	0x5c9da47a, 0xcf4c8e67, 0xad7e7467, 0x43e6246f, 0xb10e6738, 0x68773cfd, 
	0x73831224, 0xb455d721, 0xc9608f8b, 0x62f1ef76, 0x503e2ecb, 0x58bb3a7c, 
	0x3271c168, 0xfc455dae, 0x71cffe19, 0xf1a9ff78, 0x0dd10f61, 0xdefe8fbe, 
	0xc2ffe31d, 0xb8fc9374, 0xede3e90a, 0xdbb5073a, 0x38e34d02, 0x9ff277ef, 
	0x07e17f31, 0xbe91efc5, 0x539f1a14, 0x470aeca6, 0x5682d21b, 0xd203f605, 
	0xb46e8b4d, 0x4be14f6e, 0xed013b05, 0x81df6a0b, 0xbed2b2e7, 0x45f65a48, 
	0xc823f582, 0xf381b8aa, 0x89e79dfc, 0xa27e7236, 0x7837fac1, 0xf18198ad, 
	0xefa66d7c, 0x1ae00d25, 0xee9c28d5, 0xdd8b2a01, 0x1b633fc0, 0x3b01e14d, 
	0xf784a0b5, 0x104cb72b, 0xeb53ab5d, 0xe600c744, 0xf0daf821, 0x5a9d419c, 
	0xc8e786d3, 0xca21d8da, 0xb1c35653, 0xcf0d88ce, 0x2f288767, 0x86dbd619, 
	0x27ccb8f2, 0xd79036c2, 0x46769aa3, 0x2ea807da, 0xb497a0ec, 0xd7c7b6cb, 
	0xbaae7bc0, 0x782a9ce0, 0xcc31736f, 0xb9cbf808, 0x0aa73a2a, 0xd9ce51cf, 
	0x5b4c6739, 0x14229dba, 0x2cfd8d15, 0xb09fc53b, 0x4b0b93ec, 0x6bfc3e90, 
	0x5bb414fa, 0x41e311fc, 0xe58253b4, 0x37cc5eb0, 0xbafd030a, 0xc76f2ccf, 
	0x225fb095, 0xcf2413cc, 0x4c221b7c, 0x913fb1ff, 0x746df8bc, 0x2e0e4a44, 
	0x8e2f934e, 0x1f945681, 0x5ff81f36, 0xc3574f68, 0xbae3ef48, 0x9f304baa, 
	0xe3c507e0, 0xc23f704b, 0xc477de41, 0xc1d7ca2f, 0x5e73ccc6, 0x97a2d77f, 
	0xf234e845, 0xafcb28eb, 0xe8a2ff5f, 0x967dd933, 0xe72b1afc, 0xb3ac6df1, 
	0xb49471d1, 0xe89616ff, 0x56ef8f04, 0xcffcdbb6, 0xc0cb78b6, 0xc650990f, 
	0x24eaa7f1, 0x42a9ab9f, 0xad71c2ef, 0xa141b3fc, 0xf63bc065, 0xb8af63ca, 
	0x58f2a717, 0x17ec65fd, 0x8c23539d, 0xbce887d6, 0x2f40245d, 0x69fb3a2a, 
	0xdf0d3dd6, 0x06af3ab6, 0x323c15f3, 0x5941f5e4, 0x5c96d3f4, 0xbf8283f4, 
	0x408bcbaa, 0xbefbfa59, 0xd7cc6abc, 0x05fc8e8d, 0xafc18bea, 0x4adf4419, 
	0xa0f7d323, 0x718db6ed, 0x6e9fb3a2, 0xc876e2b0, 0x016d5327, 0x6a983fca, 
	0x3e30352b, 0x75f3f163, 0x4b9b5f72, 0xb1f55f98, 0x740ed425, 0x8539449a, 
	0xd2f718ed, 0xf29895c7, 0x07c63f79, 0x25da39f1, 0xa88f10cb, 0x23733567, 
	0xca0231d9, 0xf4fdf8b4, 0xaf1f1689, 0xe9fe80d9, 0x01b18f54, 0xddea75f9, 
	0xbcca3633, 0x98ef3a3e, 0xe755b8fa, 0xe3a99173, 0xe7e98df5, 0xad135393, 
	0x8557bb56, 0xba7d4e75, 0xb91bb655, 0x6bbbdf54, 0x7ca39e23, 0x5bfcc6a9, 
	0xc32c22e2, 0xf4a1aa20, 0xec4b7f19, 0x715c32c5, 0x85281adf, 0x4167ba29, 
	0xb6dbd4d9, 0xfea58ed1, 0x3db13bdf, 0x46eefe16, 0xf7898f6c, 0xa5f8e31e, 
	0x75039f58, 0x578c084d, 0xf731ca4e, 0xf625ed83, 0xec3c7094, 0xdf343a14, 
	0x0bcc3a23, 0x930e98b8, 0x3b874483, 0x7a904ff7, 0x1b0ed85e, 0xb4e3d2a7, 
	0x19253dea, 0x01da557a, 0xbcf30a5f, 0x7fedbc17, 0x6a798345, 0xb83d623d, 
	0x5bf3c34c, 0xf479e7ed, 0xd8633bf5, 0x352bfe6f, 0x07772a6e, 0x4a5e700f, 
	0x6bfdc98f, 0x71897056, 0xd6e92fbf, 0xb8d2afb8, 0x18ccbf18, 0x7f07d757, 
	0xb9dfebc4, 0xcbea0bbe, 0x7ff3feac, 0x8a717289, 0xde90df47, 0xab8e5dbf, 
	0xe5277e60, 0xfdb9eb91, 0x4ae8efe4, 0xf757ad3f, 0x1efede62, 0xef186fc9, 
	0xf3db937c, 0x40e7ac06, 0xc63d133f, 0x5617489d, 0x1bbdd61d, 0x11ea83f5, 
	0x7a9986ad, 0x839e3a7f, 0xcc4d1f02, 0xf0e3f631, 0x492d8cef, 0xf6505c22, 
	0x7f4a5efb, 0x7c7efe7f, 0xbf47827f, 0x1e7df873, 0xdfca3f77, 0x7ac88f1a, 
	0x3e0afdde, 0xac63df3f, 0x4bffeacf, 0x23cea71c, 0x61f3e036, 0x2cf916bb, 
	0x7abc748a, 0x32c3f923, 0x71f5380e, 0xc3719759, 0x365be3a9, 0x4f5f9fa6, 
	0x76e2ec4d, 0x9688e383, 0xe9f533dd, 0xe3d31b5d, 0xf0cf448b, 0xd7a721ca, 
	0xf20a83d2, 0xc06721cf, 0x1f28dbaa, 0xc7b0c6a9, 0xd53c05df, 0x16be2508, 
	0x1f666fe8, 0x6e3bef9d, 0xf8457964, 0xaef36183, 0x39fbceb6, 0xa6ef368f, 
	0xfd678a3e, 0xe61ef911, 0xb2ddbf57, 0x3117cf1d, 0x9ce9161f, 0x17f8c7de, 
	0xca388fb4, 0x0eff10fd, 0xd1e3ce79, 0x8ab7ee0c, 0x19bde1fb, 0xd251ffac, 
	0xdcb7e385, 0x3d04d34f, 0x4c6e7c3f, 0xab98fd41, 0xa3c476e9, 0x34f9b765, 
	0xad79e2a1, 0x0bb4c5a3, 0x0ebf84bb, 0xfee795e1, 0xe096af32, 0x8fa3bca5, 
	0x5e105f88, 0xd5e323c6, 0xa1718bca, 0x6674599d, 0x6411defb, 0xff24467f, 
	0xc2ecfa4a, 0x4f98b3a1, 0xbfaed87b, 0xe52eaf25, 0xb3e9a44f, 0x26f0d569, 
	0x7a59e7da, 0x24fae80d, 0x3e0af5f1, 0xf759b747, 0xbe60be2e, 0xb9b9f0d3, 
	0x56125bcc, 0xbfccb5be, 0xa63cc01e, 0xe3e769d9, 0x457fcb3a, 0x1a3ef268, 
	0xea897fdf, 0xfe30e7d1, 0xdd19d166, 0xcf8c5983, 0x4f180dc3, 0xcef666d4, 
	0x86760319, 0xd0d9aec7, 0x56fcc19e, 0x13ab579c, 0x1a52f8b6, 0x30e18727, 
	0x5be64c73, 0x51d073e2, 0xa509dc97, 0xb6ba1be7, 0x5f94377d, 0xadba530d, 
	0x9fce3ce7, 0x406cfcf7, 0x52c56c6c, 0x87af6d77, 0x44e1fbf2, 0xcf14ec02, 
	0xb476ebbf, 0x7a6b3da7, 0xdf182d95, 0x1f7b0228, 0x7b3ac9ed, 0xc780fdd7, 
	0x77df2086, 0x801fa0f2, 0xdecfb07e, 0x239f29d5, 0x7489615d, 0xef95c9e8, 
	0xf61da105, 0x5925f3dd, 0xf7f6670f, 0x4f7c33cc, 0x8cdc1c52, 0xed2d81b6, 
	0x5bf64579, 0x3e4fd594, 0xf4b8fac7, 0xe1277e79, 0x3d77b268, 0xbe93fb21, 
	0x945dedd3, 0xe508dcf7, 0xce43e476, 0x607b20a3, 0xa53de702, 0xfca1afdf, 
	0xbca9c3f4, 0xe73a89f4, 0xfa5e53a9, 0x813b2953, 0x536bd0f2, 0xfbac5af7, 
	0x397dd658, 0x4e66b5cf, 0xdaf3e227, 0x883de3f0, 0x2574f3cf, 0xf3647981, 
	0x71c60406, 0x37ec1d60, 0x781ff3c8, 0x30e13935, 0xc2d7d3e7, 0xe743d5b8, 
	0xd1a4d4e6, 0x4ec5d21b, 0x4125efe0, 0x7b62dda6, 0x9c16dc26, 0xf391e093, 
	0xb747493c, 0x41fcfcc8, 0xbda1e621, 0xd3aae780, 0xf2580e58, 0xdb20a6f1, 
	0xbda25813, 0xe63b3f0c, 0x3c48e769, 0x03e7137d, 0x8afe2c7a, 0x400aec8f, 
	0xbb7bbd98, 0x0ba507ec, 0xbf20ece3, 0x110f101a, 0x6639cbcc, 0x672a7b43, 
	0x69b391ae, 0xe0b8f880, 0x91ca5c44, 0xeffca903, 0x46de26b7, 0x757399fc, 
	0x3fe8e5ef, 0x6c8ecb2b, 0xe4b13e46, 0x3e9e4a43, 0xa733f24f, 0xfca1b4c6, 
	0x038f7814, 0xc78e67f4, 0x0479436c, 0xba4012f4, 0xdf4cb9cf, 0x2481e32e, 
	0xe0b82d37, 0xcbfd8057, 0xea00cc06, 0x2301b29f, 0x9526e780, 0x6b37071f, 
	0x3802772c, 0xe1e32aaf, 0x8f8d3ef0, 0xf07afff7, 0xd87460bc, 0x52c09356, 
	0x1eb082d8, 0xd5b0c9ad, 0x35a2dd80, 0x21e0b6ea, 0x10fe8f99, 0xd371cfce, 
	0xef20399c, 0x0538d076, 0xa81fbf06, 0xe78297d9, 0x103d68f0, 0xe238d0d4, 
	0xe1f6b77d, 0x7ee72905, 0xbbf69418, 0x608e4f94, 0x58fc7440, 0x3bcfe70c, 
	0x2291c05a, 0x89ef8738, 0x99d75e51, 0xe54fd5e4, 0xcf9a9e3e, 0x3eb72595, 
	0x00505e6d, 0x7f9f3bca, 0xe7cd33de, 0x0eace795, 0xa1e6b2e8, 0xb28de5d3, 
	0x84c4f51c, 0xdfe615b1, 0x3cb5e92d, 0xc6209bf8, 0x7dd03d9f, 0xdfc0e82d, 
	0xf9e8fae0, 0xcf2ba25e, 0x7c746122, 0x794ed523, 0x17cc2165, 0x78a0affb, 
	0xa69fc25f, 0x30aa1c07, 0xa3e6d3fb, 0x05f73e75, 0x0f7597d6, 0xe53d7b21, 
	0x2f58b7c1, 0xbfc41d89, 0x2b8ac336, 0x4c6e3e03, 0x82ac05d1, 0x71e7fafc, 
	0xadc7945d, 0x7d0e28d9, 0x07f65d91, 0x457e863d, 0x7e319838, 0xf0a29e76, 
	0x3e7c1135, 0x5153e19d, 0x31bda2ef, 0x5850c5ba, 0x8b8c0a6f, 0x5b15e128, 
	0xfa58cf51, 0xf587b547, 0xc60d388d, 0x919e607f, 0x270a7fd2, 0xf822bef9, 
	0xdfc40955, 0xad0f2948, 0x64816cf7, 0xb3b0ed02, 0x466a7fd0, 0x8fb919fa, 
	0x3d05e9e2, 0xe07e30fb, 0x17fdf308, 0x3af0ade8, 0xf9b6ced8, 0x19e53e38, 
	0xaf607865, 0x3c222785, 0x4e73b01e, 0x1c837ee2, 0x84788c77, 0xca23b8c4, 
	0xd2fbae76, 0xd3eeddbe, 0x7ec42f9d, 0xd5427643, 0xc6d3bac2, 0x607b2cc9, 
	0x843bb55a, 0x726d89f6, 0xc441128b, 0x3e7b60ed, 0x7b238edb, 0x17925ded, 
	0xed28311b, 0x63e384fa, 0x4ea6bd96, 0xe70ee4b4, 0xbe9e1edb, 0xa189a942, 
	0xe943337d, 0x6fe29dd9, 0x9dbcefa0, 0xa57da0d7, 0xa0ffc82b, 0x0e7af336, 
	0xe41f9c61, 0x876fc80a, 0xc61b1f3c, 0x23904cff, 0xe59f1c51, 0x71b81e4a, 
	0xdf6956bf, 0xcb2a03fd, 0x0f5c23a9, 0xdddadc20, 0xca275462, 0x9fd9bba5, 
	0x46c666d2, 0x8ff410fd, 0xf4dc2736, 0x2bc60764, 0xfa09d10c, 0x26327b5e, 
	0x69fdb0ba, 0xb463f283, 0x09b17547, 0xb910e3ea, 0xbfbf101f, 0xe81d728a, 
	0x784455e9, 0xc7f40f83, 0x71ae388d, 0xe973e776, 0xe5a3ebe3, 0x749ecbf8, 
	0x2561f8e2, 0x82f7e341, 0x9fe34083, 0xc71b39dd, 0xd4daaf0f, 0xddf9ea71, 
	0xfd0f9c54, 0xddde9f0c, 0x173d4a1a, 0xf98750bd, 0x7838c967, 0xa54c2683, 
	0x1baae896, 0x3259feed, 0x44f40e1e, 0xdddaa0f9, 0x75acd103, 0x6d70918f, 
	0x0af775e0, 0x4351eb82, 0x47f6c3ac, 0x06c3f14d, 0x7e2c2f84, 0x0ecdd304, 
	0xfa09dd0b, 0x87ce3671, 0x01abb025, 0xec0d9deb, 0xd9bad0af, 0x5e2ed18f, 
	0xe5f909b1, 0x25f3108a, 0x79bb473d, 0x09dd68a6, 0x10f2fc7a, 0x01a883e7, 
	0x29278afd, 0xf964c26f, 0x21373415, 0x4978c17f, 0xceb539a5, 0x1c5b46fa, 
	0x3539bded, 0xdad76f7c, 0x3da44bf7, 0x445bed01, 0xbf89d50d, 0xc2fb48e6, 
	0x6f48dfd2, 0x439b87a8, 0x5d93dfec, 0xdbe41cb3, 0xafa7a045, 0xcb8c76e5, 
	0xfe43dca2, 0x59b8c22d, 0xca35ca00, 0xbedf3c0c, 0xf05bd61a, 0x551e0a50, 
	0xf3c0ede6, 0x71e80170, 0x4b6132e3, 0xfb577bc2, 0x5e02a140, 0xdcb1096e, 
	0x14dd0b2d, 0x259078c2, 0xacfd867f, 0x9adf6c0d, 0x9bdd060d, 0x64287573, 
	0x5a8597df, 0x34ef2842, 0x7fcc7c6b, 0xa0757987, 0x8dfbb47b, 0xb2c71c39, 
	0x04c195ec, 0xc71c4bcb, 0x03f3956c, 0xef2abede, 0x5c87b97d, 0x50e7818a, 
	0xee0d468d, 0x1618dabb, 0x4187c87d, 0x2ea7f441, 0x808d95d2, 0x5f45b578, 
	0xc9ed8ebc, 0xa4ef3bde, 0x475c0c71, 0x52e74597, 0xfe52aafe, 0x79d9ed5a, 
	0x3bc1e5e0, 0x0bdfbd69, 0x382c3949, 0xf83cb59f, 0x0e1f923d, 0xd0189efc, 
	0x3e56d5e3, 0x3923e8ae, 0xef4fbd6d, 0x79cd3d1d, 0x533f8ec3, 0xc783e21c, 
	0xfd4e496a, 0x4496cf82, 0xfa0339f6, 0x7b05bfe9, 0x27583cfe, 0x85e4c1d2, 
	0x1ab679ed, 0xe7fa471a, 0x9f30ef22, 0x720de65b, 0xae43ff3d, 0xbae09fe7, 
	0x381d2f6f, 0x71fdbe1a, 0x879e9bca, 0x32ee9ee7, 0x927586e3, 0xd550914e, 
	0x4cfcfd46, 0x207a827c, 0xd2b6f67c, 0xf45a8077, 0xbc51379b, 0x07ae4cc1, 
	0xef2cfcfb, 0x40ab731f, 0x7090ed6e, 0xcbeddf87, 0x95f3069f, 0x43c8011f, 
	0x854fefb8, 0xefa73e30, 0x7cc2f580, 0x49fc2dbb, 0xea165c3d, 0x6e1ef6e3, 
	0x1abe0e2f, 0xd4c9e792, 0x07f62afe, 0x2fd11cdd, 0x63b48bc8, 0xc8e8937f, 
	0x1eb03d51, 0x3ef419cf, 0x4b2df741, 0x3ca945fb, 0xece3904f, 0x7f7ea109, 
	0x60f3ee55, 0x3c7ea67f, 0xcf921f65, 0x1bc8be91, 0x39ed381b, 0x0bf9a88f, 
	0x358399f9, 0x5a708f7c, 0xefb4abf5, 0x33ee769f, 0xe8b397ac, 0x56cbd2d8, 
	0x79ee8ffc, 0x894f9e70, 0x8864b79c, 0x12cd7df2, 0xe0f549d3, 0x60cd2a3e, 
	0xbfb1c83f, 0x39f1ff23, 0x7e4de86e, 0x2c75a21e, 0xee31f3d2, 0x20e4b0bb, 
	0x2902f3e1, 0x1b548a07, 0xba0553dd, 0xa50fed36, 0x47c0c6e2, 0xf2d3f226, 
	0xe9a55da1, 0x2a3901df, 0xcf985bf9, 0xdcf63e13, 0x4f3c9e7d, 0xcff5a7ee, 
	0xea9633dd, 0x8c854ae3, 0x0c9c710f, 0x108bd25c, 0xf598f85f, 0x5e67df3a, 
	0x319b3dae, 0x4809e63e, 0xf96dfebf, 0x9452879d, 0x84de238b, 0x255ea157, 
	0x489afdc7, 0xb97da094, 0x91f31c3c, 0xb748baa3, 0xfb4b3ae1, 0x5fa1ff61, 
	0x7f3275d1, 0x1f75875e, 0xc316f5e0, 0x394b4b3a, 0xc4b0b9fe, 0xeafc8a56, 
	0xbe20dc78, 0x773f9154, 0x282bfbca, 0xe1849af7, 0x22387c04, 0x9ded0531, 
	0x83df22af, 0xed1e5bbc, 0xb18b6c5d, 0x2f3f401c, 0x70ed94b7, 0x05e50b82, 
	0xafb8fbd8, 0xa5fc4b0b, 0x3e568748, 0xef3157fe, 0xbfbc29fe, 0xb97fcb15, 
	0xa8b4e903, 0xabe3e914, 0xa59a0f28, 0x65b902fc, 0x9d74c93c, 0x76c31f4d, 
	0x3e99cfdb, 0x7e418b8c, 0x5514bd02, 0x4eb8dd8a, 0xff2c9792, 0x4f780206, 
	0xfde385ab, 0x00a07cf0, 0x70948f9e, 0xede7ef66, 0xff796821, 0xaf9ce774, 
	0x0249dc93, 0xfeee985a, 0x6f5dcf93, 0xdefad0bb, 0xe739d643, 0xe8ffa5b9, 
	0x3cf8739c, 0x0eb1fa5c, 0xd08edbb4, 0x5ca8bff7, 0xa57eca5f, 0x7ca61223, 
	0x814efc44, 0xf268f78c, 0xf3e342fc, 0x8bea930b, 0x4ad47ae5, 0x7b9d377d, 
	0x9cf25400, 0x4173d4f2, 0x8673bfb6, 0xf7839eb8, 0x633f31be, 0xdaa6951f, 
	0x5afc780f, 0x38df30e9, 0x0ee7e4de, 0x2a6677be, 0x0ca1bf3c, 0xd39ea769, 
	0x32fdcf84, 0xbceb3baf, 0x078d8446, 0x4a9a0e99, 0x99af1ef9, 0x53c621f7, 
	0xc46e8dc3, 0x179e4fb3, 0x80fd8355, 0x6227dfa5, 0x3f4017a4, 0x834f3dd1, 
	0x828745e3, 0x809d1157, 0xfc16ebdd, 0xff43b09e, 0xbd161bdc, 0x0a7fdf44, 
	0xaff6857e, 0xf0dfd24b, 0x6fde05b9, 0xf3b97581, 0x8d67df05, 0xf40f4aea, 
	0x26fd025f, 0x16fede00, 0xeff4425c, 0x9a6ff996, 0xff789c2e, 0x8b657dd0, 
	0xcfeb0a33, 0x04e43a59, 0xe1562651, 0xcedc80be, 0x55c5b5bd, 0xf4d17887, 
	0x2f013a17, 0x0ba62df9, 0xf050ecf9, 0xa8bebc1b, 0x6107df90, 0xe1f5adb8, 
	0x327c7af1, 0xfd213bdd, 0x7007cf0c, 0x2e60059d, 0xced39b1a, 0x083ef0f3, 
	0xf2318fed, 0xf0e9c6b7, 0xf169fb7c, 0xf35db30c, 0x7f3c40a6, 0x03a8e187, 
	0x0977e33c, 0x1eeec0f2, 0x46a1c148, 0x8888def9, 0x4b17fe02, 0xc1a70e38, 
	0x73dfb06d, 0xc0c89828, 0x7f5f2877, 0xba04d5a1, 0xf124db1c, 0xcef849dd, 
	0xdf9e33c0, 0x6e799c5d, 0x5d5ef653, 0xaee00469, 0x5a57d938, 0x4fe7f08d, 
	0x650b5119, 0x11aee555, 0x9c8ca0d3, 0x754ca53b, 0xf27a3109, 0x45cd32b1, 
	0xb7dffe72, 0xb459e9a6, 0xdf6912df, 0x24b900c1, 0x27bb4cee, 0x7faae45b, 
	0x6983bf84, 0xafd6188a, 0x3eb7db0b, 0xb7a0f28f, 0xa7d84ef5, 0xcba172e2, 
	0xd267c6b8, 0x72964f1b, 0x6f4338dc, 0x251c9ea0, 0xd72065e3, 0x8fd21ef0, 
	0x453cfca4, 0x1dfd1c5e, 0x93fa83e9, 0xc87ca413, 0x0c2f1794, 0xbd2c83eb, 
	0x79796419, 0x4487e87b, 0x7e87af8f, 0x3bd1654c, 0x1c027f6c, 0x493f7cad, 
	0x86b87c94, 0x04e4a3e8, 0xb7b82295, 0xfdc1ea83, 0xe92cbe50, 0x5fa17e14, 
	0x6fd0f3f3, 0xa7034e3b, 0x975079ce, 0xd3e611a9, 0x9c111f15, 0x5e9f97fb, 
	0x7eab4faf, 0xe91ff4b9, 0x81fad3f1, 0xc3efd225, 0xcff078fa, 0xa0fca17a, 
	0x5be63b6f, 0x5677e75a, 0x47b51d1e, 0x04787da5, 0x337a0be3, 0xd32303c6, 
	0x3bd73bc2, 0xf75bdf71, 0xd30cfb59, 0xd4e8eca5, 0xaf28b577, 0xb26fdb2d, 
	0x87e3b04a, 0x157f06e9, 0x065762f5, 0xb61b5cdd, 0xeeff47af, 0xb6894359, 
	0x2079eea6, 0x7d866dfd, 0xe7294bff, 0xfe3e6acb, 0x6c555ede, 0xe49bd2b6, 
	0x79f063e7, 0xa7177e54, 0x13eb7765, 0x58239fb8, 0xab5d14be, 0x1f7bf9f3, 
	0x7cf05bb7, 0x9636e52c, 0x04bf7851, 0x2cfbc3c6, 0x1cf838d6, 0xfd8627cf, 
	0x6b776317, 0xfd171cb7, 0x9d5ca297, 0xd89113fc, 0x5ef18add, 0x88f48e7c, 
	0x77eeb478, 0xf0553ce3, 0x132abedc, 0x904f98cf, 0xcf345fbd, 0x16f3a93b, 
	0xe118b7da, 0x7acdded5, 0x53798ece, 0x98e3d00e, 0x82339657, 0x38f154f5, 
	0x0d485df9, 0xbe5085fa, 0x96fcd1f4, 0xf4d6a33f, 0xf7e2bed1, 0x466f9014, 
	0x0cfa608d, 0x63b21b6c, 0x65c1369e, 0xae00f7ca, 0x70bd7c3f, 0x0715ca04, 
	0xb8bbe3ca, 0x8cfde23f, 0x333735f4, 0x63e560ae, 0xce4e7de1, 0x9dfbe43f, 
	0xfdc36e78, 0xbc8b39e5, 0x50d5fb97, 0x7e7a4464, 0x0ace7126, 0x211d1e7c, 
	0xfeb759ef, 0x303f905a, 0x5c81fd03, 0xfda19fe9, 0x69a97c8d, 0x7fad8c2b, 
	0x30997281, 0x3c1f81b6, 0x87db0461, 0xb4f1c1c5, 0xcea0f39e, 0xfc8250fe, 
	0x558e2b1d, 0x82349c1c, 0xdaa129f2, 0x9acd1371, 0x0f2ae711, 0xbe823f9e, 
	0x24f8804f, 0x12e7a639, 0x4142ea7f, 0x84ea23fd, 0x61f6cdd2, 0x1a4f9f3e, 
	0xcfd728b9, 0x43ff830b, 0x0ee667fb, 0xde65f9f0, 0x5ecefe11, 0xef3e51de, 
	0x2e3937c8, 0xa507dbe2, 0x5cb1743b, 0x3943e9a7, 0xf91a88e1, 0x64a99df4, 
	0x677b9d3f, 0x672be3db, 0xbdb22f99, 0x72dff1c1, 0x847ba0af, 0x6363da91, 
	0x76edbcf1, 0xc3d067dc, 0x8f8f8b91, 0xb6bd408d, 0xfd8b5cd8, 0xf0cc0f23, 
	0x1e51fb88, 0x73840119, 0x4dcdb554, 0x6ef37afe, 0xfce73fb2, 0xda0e7760, 
	0xb046ab9f, 0x6953521d, 0x15b75e50, 0xe91eaeb7, 0xd978c4ef, 0xf47f7bca, 
	0x47a9e61a, 0x36190d1e, 0x7aa8cbc0, 0x7cf513bd, 0x8d98836d, 0x63f6717c, 
	0xdfbf8a21, 0xc4e38233, 0xf61065e9, 0xb79e1465, 0x93705eb2, 0x1b84d55c, 
	0x9be2c8f9, 0x85c5e139, 0xf3a1c80a, 0x3a9be1ec, 0x6ab8c2f7, 0x9056e0f8, 
	0x7197672f, 0x270ff47d, 0xc4e1507c, 0xdafff4f9, 0x5697269a, 0x179bf83d, 
	0x4b563f51, 0x1a930638, 0xf75843e5, 0xc11def68, 0x7fc8fbf7, 0x40e63807, 
	0xd1937189, 0x8c5f7c3f, 0x62f1c068, 0x889396c6, 0x374f5817, 0xdd87efac, 
	0xb6bbf12b, 0xbae10db5, 0xaeb41d6d, 0x4fd94b77, 0x85eb5d17, 0x0ae901b8, 
	0x13473cf0, 0x04471c61, 0xfe307bcd, 0xeb065d5c, 0x6392999a, 0xe41743b5, 
	0x9761c7a6, 0x8bc0bacd, 0xffd377fc, 0x0dcf349a, 0xc4b0e0fa, 0x9d95644f, 
	0xaa316fbe, 0xc271eed6, 0xfe775dbe, 0x3fe8fda4, 0x7717aa46, 0x2a3deda2, 
	0xdf3ed3a0, 0xe51676b4, 0x76375fd1, 0x98b82bfe, 0xf64aaa51, 0x7450a46c, 
	0x78847b26, 0x51a3ca4d, 0xfb87c798, 0xb4f76853, 0x15a85c81, 0x5f7e2e4a, 
	0x1878ec76, 0xaa31f00f, 0xca27466a, 0xb05551bd, 0xb597c0af, 0xa5bf57e1, 
	0xd9f60f5c, 0xf98dc549, 0xce7a9162, 0x5feafce3, 0xdfe0596f, 0x3449f94e, 
	0xdd7197ee, 0x259a4720, 0x1c8f361d, 0xde317ff1, 0x9ed47978, 0x504ff5b7, 
	0xfda17897, 0x97e6f785, 0x914744eb, 0xefc34566, 0x79928e1f, 0x22de782f, 
	0x4805c3e3, 0xee1fb8f7, 0x77b78966, 0x016f3ee8, 0x3cef83da, 0xc0d4ea1a, 
	0xd8125a4e, 0xf507d9bc, 0xb77e5525, 0xd05a7806, 0x79c02b6b, 0x37bb2323, 
	0xf3c7406b, 0x32e9ffd7, 0xf80ccba4, 0x7dd45ef1, 0xa098dc93, 0x0ffb6ffc, 
	0x8a7ee806, 0xf18cd8cf, 0x3c9fafbe, 0x467cc01e, 0x919b19a1, 0x99e1238f, 
	0x0c4db6ee, 0x5af48fb7, 0x6781c921, 0xde79f047, 0x16a7996c, 0x25f4b079, 
	0xc167ac1b, 0xe6bf6f83, 0xa457f683, 0x62e2b49c, 0x97f64983, 0xfa09798c, 
	0xb47053be, 0xf9ee8178, 0xf8d03535, 0xed781e0b, 0xdf885f35, 0xc89771c3, 
	0xe5e7d87b, 0x5f7fb4e8, 0x8ddf3b1e, 0x2656b636, 0x14f977ef, 0x666f7e37, 
	0xcdeeb8d4, 0xa702d508, 0xbdf489da, 0x12f2a4e0, 0x4667b7ea, 0xa457bf70, 
	0x16eab05e, 0x4c7f343c, 0x54e47bd2, 0x2e876af8, 0x15cfa0cc, 0xeb0e4678, 
	0xbdf3a99f, 0xc477cc28, 0x84d5a9fd, 0x69fca14f, 0x107e8ddd, 0xf02b78b8, 
	0x0ee9059c, 0x89cdd5f5, 0x9b8c5cf6, 0x2e7c92df, 0x6d44e517, 0x8c7cf174, 
	0x2dfd121b, 0x4be77493, 0xa416ddd1, 0xa54f0f93, 0x79cda03f, 0x90476fe8, 
	0xfee8060f, 0x57e11da6, 0x25ff5cf1, 0x7c839e7a, 0x18fff342, 0xd6719fbf, 
	0xf4f7cc7e, 0x7f3b7427, 0x2070c19f, 0x179c11bc, 0x4c1645fa, 0x7c3844e8, 
	0x0eefa0ba, 0xfcc0f644, 0x5b12ee38, 0xea8dca3b, 0xae49f371, 0xe9854435, 
	0x46adc4c2, 0x8ffe41cd, 0x8398f9ce, 0xf8fbccc1, 0xf48da74b, 0xc6d65f22, 
	0xf685bffa, 0xfc4bf818, 0x7fd943dd, 0x2bfa83e9, 0x69207f38, 0x2e053c10, 
	0x2b4f7ed3, 0xc52ef5c2, 0x1176f027, 0x5558d5d2, 0xfc15c477, 0xeb4e957e, 
	0x479eb803, 0xf8bc2c78, 0x09df4684, 0x5d6b651d, 0x5d697863, 0xc6e5fb2a, 
	0x110bd466, 0x375be2df, 0x887a45ee, 0x89cdbddc, 0xaffbb0f4, 0x2d3e581b, 
	0xef0b90db, 0x9e11b5ed, 0x246d7b22, 0x6e8f004f, 0x1b5937bc, 0x6bb46e17, 
	0x2f164547, 0xbfccec50, 0x9efc1df8, 0x6dac7a2c, 0xfe9b9e99, 0xbe0c86fd, 
	0x77e294df, 0x28f5b790, 0x95570e07, 0x8ef5c26c, 0x276a172f, 0xd55fef8c, 
	0xb901eb9a, 0xde4cba33, 0xa77996ab, 0x6bc33bfe, 0xf0abdf30, 0xc09fa7b2, 
	0x6529d57c, 0xbde1afac, 0xbd371c7a, 0xdaa70b5d, 0xbff7cb67, 0x181cf507, 
	0x8ab592ef, 0x03ee7c8a, 0x0e5f2224, 0x289b775e, 0x68bf7944, 0x832ff92a, 
	0xae5bafc0, 0x8fe0f994, 0xf24eb10a, 0xf19420d3, 0x1732f837, 0x71a25cb8, 
	0x8c976066, 0x54fed1cb, 0xf65bce08, 0xc6a9fe35, 0xf1737bc0, 0xfd0ab0ba, 
	0xea214d43, 0x15f6bf8f, 0x27884fcc, 0xd9c61f5c, 0x1cd934e7, 0x1a160b68, 
	0x176c7dc6, 0x780a23a3, 0xe074c479, 0xa692a87d, 0x3a4e00b6, 0xd9d5ef7c, 
	0x7a09d5db, 0xbc3277c2, 0x8d2d67ae, 0x80d93277, 0x5d1c34eb, 0xb7ed4ddf, 
	0x5c5f6d6f, 0x1218bf90, 0x6257481d, 0xef4823f7, 0x5d4870be, 0xf3ad04fb, 
	0x0849a331, 0x9833402b, 0xc0cc7bac, 0x4f17fcfb, 0x0faeac79, 0x9ab127bf, 
	0xe25025cb, 0xb255c4bd, 0x31e53a5e, 0x32ef9691, 0x32a2e671, 0x8c053efa, 
	0x7de5cf47, 0xf501419c, 0xa97d54a6, 0xf21af383, 0x2bdd79ca, 0xe61966bd, 
	0x27fc0007, 0x6ea17e18, 0x27f536fc, 0x7c94c6bf, 0x3350c361, 0x5d774dda, 
	0x4733c71f, 0x3598d771, 0x88e21f94, 0x19ba45ee, 0x42ddd44c, 0x3c2513f7, 
	0x7f503d83, 0x4a37de1d, 0x499b0e18, 0xe34e5076, 0xd838fe73, 0x3a8985a3, 
	0xb255df81, 0x3bff4dec, 0x3be303a6, 0xd3967125, 0xe10d7eb8, 0xe3c29c6e, 
	0xbea81e01, 0xa9e10a68, 0xebe65cb0, 0x231eaee0, 0x6efbc3b9, 0x581d79e1, 
	0x2fc1a726, 0x87dadde1, 0x2bc1a79d, 0x89cb1fe0, 0xd0cadb33, 0x73c6cbae, 
	0x7c2d7e36, 0x871d5c82, 0xcbd8fa76, 0xe919ffe6, 0x9632aaff, 0x5c4d6fe7, 
	0x6c76865b, 0x8fb1cf0a, 0x3c479fba, 0xc7135b87, 0xc2217e31, 0x12b4cf48, 
	0xa77bffdc, 0xe88abd12, 0x3aef9e74, 0xc9995fa8, 0xe2dfd817, 0x9b32c18b, 
	0xcff95f88, 0x23f003f3, 0xce30bfe1, 0x3f364376, 0x31df592a, 0x6be4b5f9, 
	0x8bd5635f, 0xfe539076, 0x67a20145, 0xbde91f9a, 0x897781f1, 0x781f1bce, 
	0x0579e158, 0x13ae43ad, 0x73dd2ee4, 0xfc1e35f5, 0xcfdb69c9, 0x44387f04, 
	0xae8044f7, 0xf0c8dee8, 0xa202c6fe, 0x4b2c7ae3, 0xc47fb5d5, 0x2aad43fe, 
	0xc12ad77e, 0xcde26379, 0x4bd22746, 0xe9171ca1, 0xbfa47fef, 0xbc49eefb, 
	0x1ad43b67, 0x9745387f, 0x0d7342be, 0x2d92ddca, 0xef3293e6, 0xf256b083, 
	0xe4d3d430, 0xf14ec944, 0x3b4fe923, 0xaac7bea8, 0x1935149b, 0x9f69db8c, 
	0x1d24fb9d, 0xbef5816d, 0xf06b8291, 0x91ef5921, 0x7c494fed, 0xe13ae0ec, 
	0xf7a0f305, 0xf27d7eca, 0xe88d42bd, 0xf8c848a1, 0x27a4e7ee, 0x1fb5f245, 
	0x6d38b6f1, 0x9f7f113f, 0x2c6d3f6b, 0xfbc5feef, 0x687de429, 0xee17d21f, 
	0x9fb09de7, 0xbc467269, 0xa17c7099, 0xdadc7cfd, 0xfb49dd3f, 0xd3aad5b5, 
	0x89449cd7, 0x4c77fb09, 0xebed8dc2, 0x773f653e, 0x5c7afdca, 0x7f7b37ae, 
	0x593ee57b, 0xed6466fb, 0x78ff9de7, 0xe89adf3f, 0x727be72f, 0x2fc438fa, 
	0xefe417ca, 0xbf093c94, 0x18c4f2c3, 0xe33902ea, 0x187a051f, 0xcc7ba7fd, 
	0x353e65eb, 0x7288ebd1, 0xfd2dffb6, 0x5a799015, 0xc7118f01, 0x1bf9d5ef, 
	0xa94abdf8, 0xdf980217, 0xc639ed8d, 0xe22f6a5e, 0xbdb291f6, 0x177fe640, 
	0x6ed498e4, 0xc4d6f7c1, 0x783bc128, 0xa4f5d0cf, 0xfabde477, 0x0fd6e153, 
	0xde0e5926, 0x20f3c09a, 0x78caa63d, 0xfe89d939, 0x1d22a298, 0xf92b3416, 
	0x790ad7e8, 0x479e125f, 0x4f6403ec, 0xdfdd7c52, 0xc5706e13, 0x6ec91f68, 
	0xd793302c, 0xb61c69da, 0x847b8323, 0xd56de317, 0x16b13f97, 0x14c0b8e9, 
	0x782cf3aa, 0x02f5d6be, 0xbadf51da, 0xc89178c2, 0x01e02a77, 0x84d02dc6, 
	0xc08af789, 0xdb18ba2e, 0xf1f7de57, 0x115fca2c, 0x599d12ef, 0xafca1ff6, 
	0xb1b33b74, 0x9a47f39c, 0xf9703e3a, 0x359a9e61, 0xc055efd7, 0xf32f192f, 
	0x58352b16, 0x55e32833, 0x7da75183, 0xda03c489, 0x44e14995, 0x6bdf4d3b, 
	0x9c45ceb3, 0x1ab69df8, 0x5701cf83, 0xf91eb394, 0x009b8c96, 0x0a73cabf, 
	0x7babebb6, 0x03eb5b9e, 0xbd0e57b8, 0xf7fe9657, 0x15aa6086, 0x1e04ebc6, 
	0x26a8d1d1, 0x48bde93f, 0x9b6148cf, 0xd271f840, 0xb6463bfb, 0x18363fa1, 
	0xbe82b29e, 0x7d6517ff, 0xfc08b2bb, 0xdee883f0, 0xaf9c4e9b, 0xa4fd9cb9, 
	0xcfe3ce53, 0x6f5e904e, 0x7110939d, 0xfdc334a2, 0x07ec9b6b, 0x17db3878, 
	0xa832b924, 0xdfe92da9, 0xdc963413, 0x23e29b32, 0xd25a5335, 0xa9b805e7, 
	0x29f7059f, 0x68be03e3, 0xc6761c1f, 0x995b88fb, 0x578f903f, 0x7046f0a7, 
	0x7ceb901f, 0x3f8f5fe9, 0xd391dbc2, 0x46d16de2, 0x5dc3e3b6, 0xc97df879, 
	0x080c5cd6, 0x7d0447e7, 0xee3f2887, 0xe51fa38b, 0x31db352b, 0xa4bf969e, 
	0xfbf4daee, 0xd84d5eee, 0x1cfc7cdb, 0x1d03abef, 0x90fb845e, 0x3bfa742b, 
	0xebcbf945, 0xebfbc5ae, 0x762857e3, 0xc4a39e1f, 0xc000de6d, 0xb67283ff, 
	0x790bf38f, 0x4a15de9d, 0xce1f7e2f, 0x31c45cb7, 0x72defadf, 0x92bc0ff6, 
	0x89b77d1e, 0x7cf93ef8, 0xbe6bec36, 0xddf6e3cc, 0x3c71fdc2, 0xfbc2978c, 
	0x48394ad7, 0x4e0b3051, 0x3846dbcc, 0x2425efe9, 0x85c01fb1, 0xeeff2efc, 
	0xec9d2c01, 0x7e0f55eb, 0x93fd0ba5, 0x50d2d141, 0xcb1aed88, 0xd9ca57bf, 
	0xa1f5a07e, 0x34b40abc, 0x4bfb434c, 0xb165cd5d, 0xb8bbc32c, 0x7acb289c, 
	0x5b5ed128, 0x31d8cb28, 0x2c8b7e7e, 0x2adcb2e3, 0x1729decb, 0x2ca4f953, 
	0xef8942f7, 0x81cb2ebd, 0x03fcfcd5, 0x71b7aa59, 0x2fe5cc59, 0x635cf9ca, 
	0x3f34fc30, 0xdecb289f, 0x595c72e3, 0xc72e3dee, 0xd4c0e595, 0x2cae3c59, 
	0xd1660bd5, 0xc65962f3, 0x5b7ee69f, 0x59f42965, 0x74d55714, 0xaaf18fe2, 
	0x54fe8ecd, 0xdb452afe, 0xfd29df84, 0xc63b6f76, 0xe253fe1d, 0x3f354f2d, 
	0xf996bb60, 0x6fb53be9, 0x3ffda394, 0xfa6eb2f6, 0x7dde698e, 0xd777d1cf, 
	0x60f3de57, 0x1e7692bb, 0x59b7cc3c, 0x3747ecf7, 0x8e07e4e8, 0xb7e07b99, 
	0x8787f30a, 0x7597f3f8, 0x8e805b0d, 0x8ef3943e, 0x93d8b69e, 0x909ffdfe, 
	0x484feefc, 0x07a89dd3, 0x820effa8, 0x122fbe9f, 0xe2e4aa9a, 0xa150b7fd, 
	0x201891de, 0x7f985c38, 0x7e6c3a1f, 0x8bfd61e4, 0x6d4528b7, 0x90b9cb05, 
	0x063ff751, 0xc17a17cc, 0x5bda48fc, 0xd64f48e5, 0x48af87b9, 0xc309279e, 
	0x1d43798e, 0x8e5dffe5, 0x5c632f7f, 0x76884039, 0x2f7d2cf6, 0x4c7bf7c5, 
	0x2deae315, 0x2ef7ac15, 0x83cb7192, 0x60747725, 0x2eb42a5c, 0xf3cf1f3c, 
	0x3af36daa, 0x42f3940c, 0x821e54ec, 0x510fa0e7, 0xf810e00e, 0x8eb072f7, 
	0xedec99f2, 0x10e7bfb4, 0xdf78cd88, 0xf7e88477, 0x03d57757, 0x1d5614af, 
	0xb03f042d, 0x55f8bd66, 0xd7f5f837, 0xdf155b9d, 0x2e65f502, 0xa1ae9efd, 
	0xd2dcb9d4, 0x6d76cfe3, 0xd6efc21b, 0x65fb849b, 0x31bb9be7, 0x436cba2e, 
	0x80f5def8, 0xf88f6a89, 0x7fce46c9, 0x53e467d9, 0xfb06de3d, 0x8b6aa812, 
	0x2c223c23, 0x52be31ca, 0x18c52a67, 0xc6f29e67, 0x5828e2ea, 0x7bbc1724, 
	0xca06b8ac, 0xeacffd2f, 0xa7283a92, 0x88978ebb, 0x2a8f300e, 0xa33c1e38, 
	0x83504972, 0xd282ccfa, 0xc27ef0bb, 0x9dd0ee97, 0xd25c8718, 0x75c4cb0b, 
	0x58dcb357, 0xb9a4f176, 0x674bffb8, 0x3679433d, 0x81795fd7, 0xb902054f, 
	0x3e33e961, 0xc6fd19cc, 0x0bf817ad, 0xb5cdfea1, 0xa0cbf8cf, 0x45cd5d7e, 
	0xc557a4f9, 0x1179355e, 0x6e4481c6, 0xb3f100b2, 0x5fd2377b, 0xb3b9f841, 
	0xb02cbf30, 0xea957944, 0xac31adcd, 0x57ccfadf, 0x5a3c53d6, 0x961fbc03, 
	0x36700c74, 0xd78cfb9f, 0xb6ddf78b, 0x00d41786, 0x91756bd2, 0x349ddf4b, 
	0x9cff8a0c, 0x67485f09, 0x8152cf18, 0x93fbf06f, 0xdd213d16, 0x23b1f7d1, 
	0xfa20b8b1, 0xe508fa1b, 0x599d366e, 0xfe47e5f4, 0x57f14fea, 0x5466de8a, 
	0x7a466ef8, 0xe781599b, 0x9dadd70b, 0x4638c4e5, 0x1f53de48, 0xb93d60ac, 
	0x971bc654, 0xa8e7c79e, 0x3ba75851, 0xf788fbc2, 0x94b141ea, 0x1f79ba77, 
	0x94d5def1, 0x358a337d, 0x0540eb80, 0x7f53b5fb, 0x1ab8abbf, 0x7bda71f6, 
	0xa16a4a53, 0xaee4f0bc, 0x3c0e6992, 0xc41a987d, 0xc199ecf3, 0x3f70bbaa, 
	0xf1363e89, 0x1d03767e, 0xa315d12f, 0x5ab9e60b, 0xafb5bdd2, 0x9ea33ed6, 
	0x43b3efe4, 0x2e3e34ff, 0x337037d8, 0xc00d89de, 0xbd9cf05a, 0xd58446a0, 
	0xca03e25a, 0xc27da1e3, 0xbfa1f773, 0x077f19ab, 0xbcfb0cf1, 0xde05c274, 
	0xe9e91db0, 0x1da8bcf6, 0xbce3e9e9, 0xa7a4769a, 0xdaebf3db, 0xce3e9e91, 
	0xb74f4417, 0x6f2834fb, 0x0fb1f6de, 0x35b8a434, 0xcd7afb7c, 0x6b8ba29e, 
	0x6b780db7, 0x7b82be60, 0x1cf05bc2, 0x0ca9f109, 0x0a7e7e7e, 0x6afc0f97, 
	0x5e781edb, 0x13ba1e15, 0x896573f8, 0x0f6cb0fe, 0xbd0237c7, 0xef067dfd, 
	0xd933cca7, 0x6ef6c153, 0x0de03375, 0xe7aa1cf0, 0x7054f7e7, 0x27de0b1c, 
	0xd65db379, 0xdadc550f, 0xda15fc81, 0xcf0b32d4, 0x197d2c73, 0xa71e71b0, 
	0x04b02fd5, 0x93bf8676, 0x69f8c4e2, 0x424fb481, 0xd6355d41, 0xaed4f7e2, 
	0xfdf22274, 0x01aec0fb, 0x5c94397b, 0x047bc4e4, 0x4ee85f81, 0x7f26919f, 
	0xc6de8fd1, 0xbadaa6f7, 0xd71cfd3f, 0x5857372a, 0xebc61371, 0x17b17cca, 
	0xbf184cf5, 0xacf80bab, 0xc4de7a43, 0xf7fe9cf4, 0xcefca6fc, 0xed39b1dc, 
	0x6f1b37dc, 0xd97eebc3, 0x9bd1dfbc, 0xc648775a, 0xf82adafd, 0x1ce2783b, 
	0xc41ecfe0, 0x1891eae3, 0x53a90ae7, 0x25bc6246, 0xf0cb2c54, 0x8f1891ea, 
	0xe5944d09, 0x3cfcd5c2, 0x5bcb8bb6, 0xe5971964, 0x1ef65956, 0xca4ffee3, 
	0x7e31ef72, 0x072cbafe, 0xf9e844a6, 0xa754b207, 0xcb2c5972, 0xec116df0, 
	0x56645c67, 0x42adf7e0, 0x521eb913, 0xf1e991f5, 0xdd6b3533, 0x6137a8d5, 
	0xe917469f, 0xf0b4ff14, 0x67d4877c, 0x89f80956, 0xaff4dea3, 0xee336f33, 
	0xc97b8b4f, 0xafa42673, 0x4767186e, 0xa169db05, 0xeb6381fa, 0xe6cf101a, 
	0x858fae89, 0x73de51b8, 0xc83a3804, 0x0ef4d0ff, 0x600bb3cc, 0x67f00a7e, 
	0x9967e860, 0x77afb97c, 0x5403e631, 0x6d8ef47b, 0x24c27969, 0x9cb00fdf, 
	0xaef78768, 0xb87cce9b, 0x43e052ec, 0x5fe5c1a0, 0xf1bc3e67, 0x5087c09b, 
	0x60f0051f, 0x3ba6fb3c, 0xe307f76e, 0xe73f1468, 0xba5e7dc7, 0x00bdc65e, 
	0x43b7cc1e, 0x19873c38, 0xf3b8f48e, 0x37fd7265, 0xb827fa4b, 0xc71cfc43, 
	0x12a7d61d, 0xaefc90de, 0xeed6a849, 0xfac65bc9, 0xd0d0ed1b, 0xbb57e2d5, 
	0x869f51ea, 0xbd7c8aff, 0x3f1df8f4, 0xdefbe4cf, 0x3fbe4bdf, 0x5c5ac37f, 
	0x694bf1b7, 0x6025d787, 0xf9c7de9f, 0x8dc9483e, 0xfdf3e765, 0x90af4b04, 
	0xf30cd99e, 0xa47cf254, 0x7d490f6f, 0xfbaef80b, 0x88e294d5, 0xe5cbf3e3, 
	0x3f2c95a9, 0x508774be, 0xf5adf5d3, 0x97d240dd, 0xc4fea487, 0xc170987d, 
	0x53f6dadc, 0x1aa86ff5, 0xf7ec0fe4, 0x07c8060d, 0x176298b4, 0xe579e1d5, 
	0x7240abb2, 0xba67c8e8, 0x3dcf1db3, 0x50057ce5, 0xcdaf9e52, 0x3f6154e6, 
	0xbbb06d82, 0x5d830fa0, 0xb65abf1c, 0x3a45ef81, 0xa55f592a, 0x14fc0be8, 
	0xff8ee7ce, 0x2c32fa43, 0x33c4cafa, 0xf5780b8d, 0xf12177e3, 0xa9f36b67, 
	0xe27453ab, 0xf0445b6b, 0x7cca54d6, 0x9f1edb1b, 0xf3ef0c7a, 0x39446ff7, 
	0xbf3c9178, 0x9b24e8b0, 0x6fa4ce3e, 0x2f689f10, 0x9c8abe90, 0x2b788f59, 
	0x1f882e99, 0xe6562e80, 0x60c639f2, 0xf1585da3, 0x25c5d53e, 0x86c33fc5, 
	0x4d7cf98a, 0x0bfec395, 0xb1cc7b9f, 0x0777686b, 0xc62aed1a, 0x442ca02b, 
	0x7254e778, 0xbde5605c, 0xf9c7aa3f, 0x7962ce56, 0xeef2ce7b, 0x7e9f78bd, 
	0x72cfd0fc, 0x421af1d2, 0x3ee805bb, 0xf2c63fb4, 0x07d0cb74, 0x9c647f24, 
	0x113cfaf0, 0x82137947, 0x83d77cf9, 0x7964af9e, 0xe73f7a31, 0x8002863d, 
	0x77b601b7, 0x0eced292, 0x57d9d9a4, 0x95c7b84b, 0x9e56bfc3, 0x5f5cff6a, 
	0x50dfe3cc, 0xa57af2c9, 0xefbf25d7, 0x4a1e5061, 0x4ae2f947, 0xbed2fbf7, 
	0x48cf7e87, 0xed4ef9fa, 0xca7fcad2, 0x98b698ff, 0x60f4fefe, 0xaff142bd, 
	0x36f6c162, 0x11fc53ae, 0x2fae54e8, 0x51422fb5, 0x0275cad7, 0xcf8e869d, 
	0x14ce48ea, 0x3eb951e2, 0xe1e503c4, 0xf1095c60, 0x7bdb3e70, 0x903a5f14, 
	0x76592f8a, 0x0a5715a0, 0x415378c9, 0xfc91c70d, 0xae0dc2fb, 0xc207d41a, 
	0xc044f78b, 0x4f9d522e, 0xeb5ce108, 0x5546f2b2, 0xc61097e4, 0xf119628f, 
	0x069efa23, 0x433ea9c5, 0x1bcac8fc, 0xf6c952dd, 0xb2af15ba, 0x8c2e4fe2, 
	0x5c64c553, 0x95c653a9, 0x8d2b5f80, 0xabfd0289, 0x6292f8b4, 0xe3d9f83f, 
	0xcb25664b, 0x8978ece7, 0xd5afda4b, 0x0f8a6175, 0xe7649c51, 0x9f24e269, 
	0x70a79df6, 0x315dce82, 0xdd71836e, 0xd3cefb4f, 0x15a215f5, 0x27a2c1f9, 
	0x251bfdeb, 0xe4aa3f5c, 0x5f1a46b8, 0x751ea2b4, 0xdfe7d964, 0x2569fda9, 
	0x28be81c6, 0x5fe359fd, 0xe97ac953, 0x3539e6d3, 0xcafdf4fe, 0xfa7f12cf, 
	0xfe8b8e3e, 0x3a17ca33, 0x7af9855f, 0xc99fff91, 0x0797d749, 0xb5ecb314, 
	0x1a8e78b5, 0x614373a3, 0xbfc6e0bc, 0xc55d5ed7, 0xd8cae07e, 0x2526248c, 
	0x54353e0e, 0xfdf7871f, 0xa41f990f, 0xb39c3b9f, 0x5c3bffdc, 0x4566aaff, 
	0x8890b8c3, 0xf75c0e9a, 0xe89e6118, 0x2e3b47ae, 0x5ae37fbc, 0x79a8befc, 
	0xf45edb62, 0xb7fbc3fb, 0x79286481, 0x1f89fc24, 0x8ef464f8, 0x25f3aff0, 
	0xc5fc215f, 0x79e2ae9a, 0x3d39fe1f, 0x7783dfd4, 0xdfe3d50e, 0xe80a2935, 
	0x571acf14, 0xbf5a07fe, 0xf808f91f, 0x64f28fc4, 0xfc9e4a75, 0xa548fca6, 
	0x7d5bf98a, 0xa40f9d0a, 0x8974f3cd, 0x14fb54eb, 0x0dc60ce5, 0xca3b79ad, 
	0x92b927df, 0xd1c97f3d, 0xb9748e93, 0x82798859, 0x9c8fcc45, 0xb8f9c1ff, 
	0x38ee8155, 0x0ace9fc6, 0x97085cb3, 0xcb03fe33, 0xec0baafc, 0xd5bcc1b0, 
	0x71977f1c, 0xa21d43ea, 0xcf8073be, 0x8ef003bf, 0x77d459bf, 0xe3fe5927, 
	0x890fff7c, 0x001164ca, 0x0003db41, 0x7de59c78, 0xd554780b, 0x93daf6b9, 
	0x4ccecc9d, 0x43249932, 0xe4c0902e, 0xc0210c02, 0x201d6940, 0x82081dd6, 
	0x5eb456d5, 0x80efe2d0, 0x36d28201, 0x9ea36c5a, 0x10933dd6, 0x880c4412, 
	0x8d8e5124, 0xf5a96396, 0xa7ad49f4, 0xb871dbc6, 0x3da9e8b4, 0xe947ab4d, 
	0x5170d2f1, 0xb06b4ea9, 0xf58bd350, 0xad6fdeff, 0xc404b99d, 0xfe72ff9e, 
	0x79e7f9e7, 0x7b2eb174, 0xeb7d6fad, 0x5beb2efd, 0x144cef6b, 0x0b65610e, 
	0x0f1d6f91, 0x8885c75a, 0xf5f9096f, 0x1228852b, 0x946d5842, 0xaf92dcf7, 
	0xae9942bf, 0x51081510, 0x6d618860, 0x2657973d, 0xd4d30b97, 0x64422dc5, 
	0x75614c89, 0xfc2ebd52, 0xa38fd46d, 0xa61fea83, 0xa9e51b7c, 0x26b96bbd, 
	0xefca1aac, 0x52fae12e, 0x3a59a1af, 0xed932fe5, 0x26463dbd, 0xc69615c6, 
	0x4a8915fd, 0x52fe2fa6, 0xce3f3f36, 0xcbc5e392, 0x85e705b2, 0x23be3e1c, 
	0xfca51f29, 0xb68691d6, 0xa23e213e, 0xa76f77df, 0xc29c05f9, 0x75108f71, 
	0xe2fc2a93, 0x530de514, 0x76caf2ef, 0x43d0f63b, 0xad619586, 0xdca8f1a4, 
	0x2f688532, 0x3717e29f, 0x8aaa3b53, 0x50be03de, 0xcb1080bb, 0x91995a26, 
	0x27ced4ed, 0xcf952b44, 0xd8510bf6, 0x9f65c42c, 0x54ad6d15, 0xf8dd3f4e, 
	0x8fb11093, 0xe46e990a, 0x3eb794bd, 0x41e714fa, 0xe3d13b4f, 0x29e85bed, 
	0x5ffae11a, 0x310976b7, 0x686f5333, 0x9c7ea02d, 0xda900759, 0xfea36eed, 
	0xe621618d, 0xb4a5ea51, 0x15c3b768, 0x41b4a26d, 0x0751af8e, 0x72f9522f, 
	0xa4a6f9d0, 0xa5327db7, 0x845bad61, 0x6b866741, 0x6b885073, 0xcf527a3f, 
	0x8e758c3e, 0xb5f9422e, 0xcf5f7b7f, 0xf576895e, 0xfd4f2057, 0x5e7075b4, 
	0xeabf90b3, 0xf46f5767, 0xf2337cca, 0x5dad06f9, 0xb3c4a523, 0xff54b982, 
	0x3e7a83c2, 0xcfd577f5, 0x2ff3d1df, 0x7f8eda20, 0xda8bada6, 0x7868f35f, 
	0xf317b1a3, 0x5d686b69, 0x76c5e985, 0xca1f2445, 0x797ed423, 0xd411e1cc, 
	0x6e57aafe, 0x843204f5, 0x7fdbd2f8, 0xbd2904f6, 0xf35b83e6, 0xeb5e9442, 
	0xa09e4bfc, 0x34e95ff5, 0xfc6d1dbd, 0xd29077bc, 0x24e1f046, 0x21fe66f2, 
	0xb1f3cb9d, 0xbf8f445e, 0xab1098e0, 0x12ec5e0a, 0x86d17fd4, 0x8863ae48, 
	0xa9be47ca, 0xdffbe20b, 0xf18f3a3e, 0xdf58f450, 0x7f13d446, 0xbfb504fa, 
	0x83edc1ec, 0x7def0f9c, 0xa2fb5048, 0xed25c702, 0x0f719784, 0x390a0e0f, 
	0x2f2835ef, 0x575ab1a0, 0xcba2fcd3, 0x3ce4267e, 0xe74462da, 0xbaef91cc, 
	0x7fbb4f81, 0x93bd0861, 0xc4299b9e, 0x3a27fa30, 0xbfea2c73, 0x22ff9770, 
	0x694a79ed, 0xdfd4a21d, 0xd46b6f4c, 0x8b7a8fd1, 0xd0d603eb, 0xf230b58f, 
	0x33067207, 0x43dcb9f8, 0x5172c69c, 0xe97a2cbf, 0xe5d7e01d, 0x0c32af8f, 
	0x3c571087, 0x4391a4f3, 0xc2ebe5e3, 0xae51badd, 0xe881b5bf, 0xa39f98ec, 
	0x8f38d2b5, 0xba22db2c, 0x424df954, 0x8872cd7c, 0xd4cbc20c, 0x7ad0d15c, 
	0x21b1e684, 0xd00e21e2, 0xbf6563d4, 0x4f1e6272, 0x79e48db9, 0xeecd3f58, 
	0xfce78c3c, 0xb6bfcc51, 0x6945b452, 0xae16bf1d, 0x06b412ef, 0x7fcfae33, 
	0xd0db7c1d, 0xa80519a8, 0xec966c5f, 0x134e2c20, 0x11b6b7e6, 0x3ebde646, 
	0xf299bc54, 0xbe51c773, 0x1c5dc683, 0x85b3b59b, 0x122cd1e9, 0x9a0dfcd4, 
	0x0173eb07, 0xbfa5c252, 0x6155d25c, 0xf4828568, 0xf376d1c6, 0xa621ced2, 
	0x8fa0b733, 0x758050f9, 0xf9623124, 0x979a36f1, 0xcafaa36e, 0x476e5f82, 
	0x21c87cfb, 0xa6c2fee1, 0x00f9dd7c, 0x439125eb, 0x9f2c447a, 0x3083152f, 
	0xa26fcc75, 0x15e573d2, 0x6bc907d4, 0x3e77d2fe, 0xe7a9df5e, 0x77d74c2f, 
	0x60a6bf76, 0x77d18d7c, 0xff354fd0, 0x0acefa0d, 0x77d64e2d, 0xaa3be85e, 
	0x592e12f4, 0xf43d51cf, 0x67a4dd5c, 0x1084e2fd, 0xf56f96af, 0x7f4137eb, 
	0x54ab743b, 0xb6b4ad88, 0x2ab2f882, 0xe7e0584b, 0x372d68d7, 0xadfc2b55, 
	0x9f3fbce4, 0x2132ffe4, 0xbcd31de7, 0x6ee34a22, 0x975c91f0, 0xf89bb108, 
	0xb90cdf9a, 0x12f42617, 0xf888b770, 0xb7ea0bfb, 0x5b9f99be, 0x380473b7, 
	0x0986acf8, 0xd343134c, 0x2f000eba, 0x0d9bfde6, 0xda6865e0, 0x1781e7ce, 
	0x84edfef3, 0x79df0d9b, 0x2b380db5, 0xc01ab5f0, 0x2b938d8b, 0x88d82d1e, 
	0x58ba2775, 0x3c4e8f9e, 0x40becf47, 0x79e686e1, 0x6f5f5a95, 0xf51db85b, 
	0xa3fdbec7, 0xf11cf14c, 0x71703a3d, 0x09e2505d, 0xba9f05f3, 0xbd47a7c1, 
	0x77c20e6d, 0x5fdea3fe, 0x85c44411, 0xb3dc6442, 0xee25a91a, 0x338917f8, 
	0x7be3f52f, 0xf1bb7070, 0xf229c4bc, 0x7ff02fc0, 0x2f578f61, 0xb85cfe26, 
	0xcde7abc7, 0xe3dd3926, 0xf7403428, 0xe801708e, 0x7bc8fef2, 0xe17641c0, 
	0x23d49f02, 0xf776afd4, 0xfbf4253f, 0xbd349b85, 0x39bfea93, 0x5a26b74a, 
	0x6be2dd69, 0x57be156e, 0x4dec7152, 0x0a94f1c2, 0x88ce1769, 0xe6b735e3, 
	0x069e57eb, 0xad6e6bc7, 0xefff2e4c, 0x0cd2f1c6, 0x157d8311, 0x0ef4eb5d, 
	0x7008975a, 0x44057984, 0xdb3d6b2c, 0x7ba63e9d, 0xfcb0484b, 0xe24b39e1, 
	0x3c7ff759, 0xe0017dde, 0xf09e249d, 0x626cbe3e, 0xc9fcde85, 0x215fe6e5, 
	0xcac7270f, 0xf24b3c4f, 0xfb8e9463, 0xae99fbe7, 0x165c79c0, 0xafdf335f, 
	0xf01fe9a7, 0x2a375ed7, 0x616ed9d4, 0xebc9c2dd, 0xd8faf546, 0x5a582b75, 
	0xab0acd19, 0xf90c7bf5, 0x89ab4123, 0x1d67f7cb, 0xf947a24f, 0xe7a56761, 
	0x7b7af0ff, 0xcedf242b, 0x96afeeb6, 0xac91525f, 0xb0796c7f, 0x9ee59ce5, 
	0xff4360d6, 0x646f3691, 0x4abfbcac, 0x094dc675, 0x76502fb9, 0x98597e80, 
	0x7689e917, 0x1fdb2de8, 0xd6e0ff88, 0x310bb67c, 0x4a43cf49, 0xa7d7d2de, 
	0x8accd1a8, 0xf012fb50, 0xfe5ff49b, 0xefcc4373, 0xc1fbf831, 0x579c05ad, 
	0xdc7fd1fd, 0xc8668b8f, 0x7c906fb8, 0x5dfcc2cc, 0x8d383f54, 0x0d23e4f9, 
	0xbc2bf5c8, 0xea1f47cc, 0xf3a44eb1, 0x84e76c1c, 0xf24a6fae, 0xbf4a275b, 
	0xfc8da8b2, 0x74aba20b, 0x63c030b3, 0x64ed93a2, 0xded98169, 0x79bf4065, 
	0x27ded83f, 0x327192f9, 0x236ccfc9, 0xfc05d97b, 0x9ff18b7f, 0xd4856f2e, 
	0x1cb37657, 0xccd1f417, 0x6f5e1719, 0x2dff68be, 0xba09d4fc, 0x7649b7f3, 
	0xec97a6d1, 0x0bde726c, 0xec93c57e, 0x7d172aa4, 0x194be621, 0xf2c9dbf8, 
	0x8564f127, 0x051e293e, 0xe32160f2, 0xbd7067d1, 0x6489fc0e, 0xf3e5f9fc, 
	0xd06bb8e9, 0x49457718, 0xbd3a7ef2, 0x56315651, 0xa63fa1de, 0xf6c17ff8, 
	0xf60c7612, 0xef15fc11, 0xc247fe4b, 0x1e85c7f0, 0x15fe12b1, 0xb44637f9, 
	0xe55fac6f, 0x06517e37, 0x0fc04e7f, 0xfc245e7e, 0x4355f82c, 0x7f2b3f09, 
	0xfc1b50cb, 0xcb3f74cc, 0x8f6ccbb6, 0x0ddd953b, 0xc72ed99f, 0xd0691e9f, 
	0xddc28e89, 0xae25f7b1, 0xe3f02cac, 0x3ee42b3f, 0xff4edd22, 0x87ebca84, 
	0xf108fd13, 0xc8751159, 0xd0c385f6, 0xd5a65627, 0xdef7e34b, 0x0234b1b1, 
	0xaf9b1dfb, 0x7723f7ec, 0xcd8efdb0, 0xf6c0d9df, 0x09bb91fb, 0xf5df45cb, 
	0xcf6179d7, 0x3701cd07, 0x311b17d5, 0x8c79a2dd, 0x2cdb302f, 0xb90a17ca, 
	0x9d8a215f, 0x363cffbc, 0xd910c7f2, 0x2fe5e9e7, 0xebbef057, 0x3a3fb1a7, 
	0x39668f18, 0x91aee3af, 0xabc7ac06, 0x742a87e5, 0xd018bfe2, 0x38d06f58, 
	0x8f31779a, 0xc76eb963, 0x6e4cd17a, 0xa011f394, 0x78ebed5b, 0xbafb137c, 
	0x8f3fdcc3, 0x6fd12e3f, 0x99b3f0d1, 0x1f05fbc9, 0x2fd8e8f9, 0x2a1e9116, 
	0x76fff920, 0xb0c9c925, 0x09054fd2, 0xc4e8f53f, 0x5a6cf40f, 0xa52adb8f, 
	0x34cc2add, 0x7a423c0f, 0x46fe1f32, 0x3f8ffc3f, 0xc927a2e8, 0xf957b8df, 
	0xbc7ef71b, 0xa3c571bf, 0xbfbd3abf, 0xfec8f241, 0xe7a05586, 0x6fe130fd, 
	0xfca63d14, 0xe6cefb8d, 0x9debd46f, 0x4a5667d8, 0xdfc3e41c, 0xfeece7b8, 
	0x6f6a74c6, 0xfcdf9c7c, 0xff8dfd89, 0x7a8271dd, 0x7f18ebc6, 0xa9e943a3, 
	0xd31bfa33, 0xf3c20ef4, 0xb7e94af2, 0xc46fe17a, 0x58fbfe59, 0xbe91b58f, 
	0xdf4932bf, 0xc9e52fdf, 0x4a851bd6, 0x224dd46f, 0x844f00ce, 0xd41bd62f, 
	0xf25ff7ce, 0x3f34ac13, 0xa13f64c1, 0x7613f6c0, 0x909fbc7c, 0xe427e69f, 
	0x3f213f2b, 0xf8e84fdd, 0x984fc37f, 0x1b177c48, 0x8c27eece, 0x32bcbb2f, 
	0x75c96ed5, 0xf8f250ab, 0x3add8dff, 0x9248fe23, 0x5fc58d4f, 0xf67f9291, 
	0xda1fd937, 0xa87f06de, 0x3850fe04, 0x7e521fc9, 0x0fa56ee3, 0x22596268, 
	0x1a4bee49, 0x4cec3a63, 0x4a87f281, 0xfca4867b, 0x1f2690bf, 0xf5d43fb6, 
	0x2a1fc77f, 0x9de98b69, 0xf2a15744, 0x0fe04a87, 0x58539f91, 0x22eb6b10, 
	0xaf785b7d, 0xa9de87f4, 0x0a87f548, 0xb0943f95, 0x3167240b, 0xccdd85d8, 
	0x1f78e4c7, 0x61e788f8, 0xfb3fd1ef, 0x1f89bb85, 0xdcb76fa0, 0xf9c30837, 
	0x13382f8f, 0xe7b6daf6, 0x153e78f6, 0x2219f477, 0xb767d793, 0xfed847dc, 
	0x3eb1af82, 0x7498f117, 0x07f6c17f, 0xfe204fd8, 0x8a1c54f8, 0x10bf01fd, 
	0x7194aabf, 0x1d1769c7, 0x71a34d7e, 0xd1b13e1d, 0xd7ee7da2, 0x2a038896, 
	0xd576c6ee, 0x2faaeca7, 0x3afa9ecd, 0xd4581f42, 0xeeb0efcf, 0x82e6ae32, 
	0x59f3e27f, 0xbecbf86e, 0x46a77e63, 0xe2a1d246, 0x709f3e91, 0xa9fcc66d, 
	0x2fd262e3, 0x6644cbbe, 0xc205f207, 0x7c7c4053, 0x5fed52a1, 0xfc80ef29, 
	0x60ba683d, 0x9cfe4b64, 0xe6cec16d, 0x637f238f, 0xd52f825c, 0xed475455, 
	0x7125533f, 0x669cbd37, 0x3d7fe374, 0x795430fe, 0x40c3f8fa, 0x1afde9e5, 
	0xe19bbb94, 0x71e61c2f, 0x78f957ff, 0xc371f600, 0x88b8f999, 0xcefe09c4, 
	0x38f3e291, 0xd7bbe17e, 0xd0fc097f, 0x46ee475a, 0x2135f10b, 0x54ddb5fa, 
	0x10dab2ee, 0xd2c02e2f, 0xe23ccab7, 0x11e40ec9, 0x7f21ec17, 0x415ff493, 
	0xf784feb8, 0xd66fe238, 0x10071df2, 0x31d85c5f, 0x7826648e, 0x8bbcb5a7, 
	0xb335b0fc, 0x49d96e16, 0x78a726f9, 0xbf8ab36f, 0x7fb5ba81, 0x8877f67e, 
	0x4f21e5c7, 0xc67d37f4, 0xfb50770a, 0xfb66ada6, 0xd6bed45d, 0xb5bbbe65, 
	0x96eee585, 0xc7c86d8e, 0x95058718, 0x43d036d1, 0x423caaea, 0x698a11eb, 
	0xce4b8845, 0xa296e57b, 0x0b10a640, 0x5153fede, 0x3f73d290, 0x4438a5b8, 
	0x3fce79e9, 0x21768b17, 0xc64ab9fe, 0xad27eb6d, 0xbf28312a, 0x3dfc70b0, 
	0xf73fe882, 0x21199176, 0xa3eaaffc, 0xb5de6269, 0xe74ddf12, 0x8d22ea7f, 
	0xc976bdf8, 0x34757953, 0x172bbade, 0xa5d27578, 0xca7dac37, 0xf032439b, 
	0xc82c6fe5, 0xabfe51f7, 0x2fca9e9b, 0xe09afca3, 0xc3e03ca2, 0x6ba26a4b, 
	0x7ea1f911, 0x0855db91, 0x8bddecfe, 0xbfd7b5b8, 0xbad042bf, 0x7ed2ac15, 
	0xd246f9c9, 0xc6ff9466, 0x53ba5f53, 0x3b5faae1, 0xfe0fd726, 0xa7ace37f, 
	0xcf887272, 0xcbfe9dde, 0x1f74c482, 0xd9f125f4, 0x56222d57, 0x46ef520f, 
	0x517d57c4, 0xcad209c2, 0xc2e06ad0, 0x21ba4fd6, 0x9657a8b4, 0xce57e45b, 
	0xe41a1dd4, 0xc1a9609c, 0x426afa0c, 0xd79505ab, 0xd5adba5c, 0xbebbf8c0, 
	0x7e4d9ad3, 0x5255b9de, 0x7739be7e, 0xe0c0156e, 0x5cfef6f9, 0x12db76c1, 
	0x9ea46fd6, 0x077a536d, 0xe01a01b8, 0xa57edb8f, 0xcbda67ad, 0x539ba7a9, 
	0x5bfc0df5, 0x6125f61f, 0x7c702fd5, 0xd003e1f9, 0xdb9cdfb4, 0x43f6c550, 
	0x2d6fbd8f, 0xd073e84b, 0x1d8e95a5, 0x2726cd7f, 0xf4f87f9f, 0xad1bf60c, 
	0xd687a92a, 0x7c913f42, 0xc934fdaf, 0x403ce11f, 0x96aecd7c, 0x8eb8e9b8, 
	0xf43965ed, 0x7f037018, 0xf573de75, 0xe7e10645, 0xf9ef3566, 0xa8a279bf, 
	0xf7537096, 0xb9e2bcde, 0xa3f67e94, 0x28eb8a27, 0x97e6f335, 0x9b8459e8, 
	0x807bca92, 0x76e3c61f, 0x846d9f89, 0x66a655cb, 0x84e341dd, 0xd63ee4ab, 
	0x2b8d91c6, 0x5e4265fa, 0x5b63f104, 0xcbf9f26f, 0x6fe08dd0, 0x839a0901, 
	0x28378af4, 0x965cfafc, 0x8cf218bb, 0xde73d20b, 0xce537391, 0xab86ce11, 
	0xe417b3b5, 0xdf8033f8, 0x637cf8db, 0xf17f95dd, 0xdf815b04, 0xad42f2db, 
	0xdf3cafc0, 0xdba6eaf8, 0x37a506bc, 0xebc5ff76, 0xfe1bf4a5, 0x3234eedb, 
	0xdd5c3812, 0x8c13943d, 0xdfeeff62, 0x6bdd11a1, 0x93fa94ef, 0x4e711b7e, 
	0x7e15e053, 0x60b6e117, 0xd93d19e4, 0xf4a15c6e, 0x37d08de9, 0x37bcf0f7, 
	0x72caf576, 0x0b076491, 0x8a56fafa, 0x83a3ac26, 0x3737cdd7, 0x2e39e5c3, 
	0xf51e87c7, 0x0f96b0ad, 0xcd382f40, 0xe80cbba2, 0x228fdb8d, 0x1bd09b7e, 
	0xde949bfe, 0xb5f50178, 0xab646b2e, 0x42dacf3a, 0xc6237446, 0x00e249bb, 
	0x67d355fe, 0xb02f5ea4, 0x79a11fc8, 0xae4535ce, 0x8fed3775, 0xac78e4aa, 
	0xfd2a8e5f, 0xf431fa42, 0xd545798b, 0x2e3f7f99, 0xee7f508e, 0xd4c3e061, 
	0x7e4bf593, 0x632f3cad, 0xe95470fd, 0xa68f5a0b, 0x9a2e0bd9, 0xdf563adb, 
	0xa1328e10, 0xccb06ee7, 0x0ffc8b4c, 0xc2145e11, 0xd5d355f9, 0x6584ea2f, 
	0x9911cbe1, 0x5f1fa4ad, 0x177de350, 0x77fe85f3, 0xec753344, 0xe98dee47, 
	0x7df6fe7c, 0x05f99333, 0xe25876bd, 0xb5f095b5, 0x87893ce6, 0x0f098ba6, 
	0x5fd73b24, 0xfeb0f12b, 0xca0784ab, 0xf5eb504f, 0xcb6fdb95, 0x66f2a12f, 
	0xf43e7f6b, 0xbaedf326, 0xa6cf1f04, 0xfffe6dbf, 0x3d7f7abd, 0xe25ab3f0, 
	0xc023f78d, 0x3b8961d1, 0x977007c8, 0x4f0a1722, 0x6d34fde9, 0xae3eeb95, 
	0x3161f887, 0x2dfabc7f, 0xde171c09, 0xe417487b, 0x6e021d7f, 0xbcfb7f99, 
	0x7de15fe0, 0xcf417783, 0x971cddb2, 0x7e3a71c0, 0x588f26cf, 0xe58bf06f, 
	0x72ecfab9, 0xfd2557d6, 0xb8a75e3d, 0xefc69fa2, 0x907192ad, 0x6d625f04, 
	0x1185abf0, 0x33cf73e3, 0xe887a5f2, 0x3e563e3c, 0x87abffc8, 0xc1c6105d, 
	0xcc77f032, 0x2f3a9c39, 0x79efff65, 0x1c2307f6, 0xa2fe521f, 0x3fb267ed, 
	0xcffcafd8, 0xcc173e5e, 0x61247bba, 0x7309a7ef, 0x5cd38aa3, 0xe7cd91d6, 
	0x39d51b72, 0x445d65cb, 0xdb33e1bf, 0x93f19710, 0x3e916547, 0x1f10efce, 
	0x38bec844, 0x7f0696bc, 0x55be49d6, 0x048fcd16, 0x89ff6346, 0x4fed50d6, 
	0x2ad83f39, 0x73ece5cf, 0xcb1f6a38, 0x86e3e7a2, 0xb0af5857, 0x9f65e7de, 
	0x39f26e59, 0xd5aa67c7, 0xda4f9bf9, 0x74c36c8b, 0x9f848fc0, 0xe9e8a1d5, 
	0xa86731a0, 0x4bcbd376, 0x572fd9aa, 0x5c7a57fe, 0x8bf813e8, 0xc5fce9da, 
	0xf7a7d5c9, 0x355aff17, 0xd1f55e7a, 0x055e7556, 0xa5dc6dfa, 0xf4fc53a7, 
	0x1cf909c4, 0x45cb07c7, 0x4a7c7275, 0x438838d0, 0xf1d8e7e5, 0xda4fe969, 
	0x9619777c, 0x8e4cc3a3, 0xce467d7f, 0x6e9e6d37, 0x3d80e623, 0x579f2f6f, 
	0xed80ff0d, 0xe18fad3f, 0x7fb0fb16, 0x7e6aaf79, 0x546f9f35, 0x97d07f92, 
	0x7da88fe4, 0x66557be2, 0xfa41beb5, 0x5017ec27, 0x87dc9f3b, 0x9b9f822c, 
	0x887d8673, 0x9c64a71d, 0xd6cd0e32, 0x1ce0f3e4, 0xfc612fb5, 0x5f3ebcd1, 
	0xf681fd2d, 0x3a4bcff2, 0x1d2acfb1, 0x3ebc4ebb, 0x0673e671, 0xfaf681f6, 
	0x7296af2c, 0x85cbaf66, 0x9cd45f94, 0xeffb6768, 0xfbfe9728, 0xdff0d555, 
	0x54bfcbdb, 0x1890fe2d, 0xeef1882f, 0x1f7dfe61, 0x773982f1, 0x2f7df55f, 
	0x65aac795, 0x91e82b1c, 0xc4f41d72, 0xc7925eb4, 0xa205fe19, 0x83eb2fc7, 
	0x4733be34, 0x51608bda, 0x7846db4c, 0x4ab44e0a, 0xad4491b7, 0x6eefdcae, 
	0x4ecdfda3, 0xbceb43f4, 0xdf55fb7a, 0xa46a9e87, 0xdfe22de7, 0x14b3329a, 
	0x97ed91fe, 0x75fb45ad, 0x397f5e94, 0xc4e673b7, 0xc03e6fb6, 0x43f80ced, 
	0xeefa73ab, 0x5bb920ea, 0x818733ed, 0x98c4e0ff, 0xe896d916, 0xe86f192f, 
	0x357f1ecf, 0xda26f3fa, 0x245abf51, 0xb3b793ff, 0x3ff767e7, 0xcfe95e66, 
	0x73fc7f55, 0xb9fb3b76, 0xdefe3a74, 0xe0e036fa, 0xcc79d8e4, 0xcc6bf518, 
	0x3373f852, 0xaba255fc, 0xabaeb12f, 0x56d2cc73, 0x6e7023b4, 0x2a567f63, 
	0x615019a0, 0x790f3283, 0xba9f078e, 0x19f7fb14, 0xcfd71a21, 0xc1ae8afd, 
	0xf794f6a4, 0x6fb44b2e, 0x4d687654, 0x2768be53, 0x2c1b5879, 0x29b3ed14, 
	0x8d7eb6ef, 0x7f8f007d, 0x47b7f552, 0xf4501ff5, 0x56379c90, 0x7c8118be, 
	0xd2574138, 0x3a914e38, 0x23574d8e, 0x1ef98bcd, 0x7d07fc52, 0x3e41f349, 
	0xf4a33e79, 0x7da2bc85, 0x1efa58e5, 0x7cfb96a9, 0xa0902fee, 0x323fbecf, 
	0x391be47b, 0x7e8b76c9, 0x2f24225b, 0xbd3f17dd, 0x8f1771c0, 0x4df42ef3, 
	0x160753e7, 0x9f920480, 0xa8fb5d5d, 0xcefd6d7e, 0x77ce6cfc, 0xb7da48ff, 
	0x44e4ed6d, 0x46d58ecf, 0x7bd78761, 0x31e39f45, 0x61bba73c, 0xadb8e6af, 
	0x3daf4017, 0x7bede6ae, 0xe5835df0, 0xf4fc1776, 0x600b9599, 0x50ccc48c, 
	0xc6c5d788, 0xd5393749, 0x4fd463d0, 0x3afd41a9, 0x3b7b630b, 0x318e392c, 
	0x9171c724, 0xad543eff, 0xfcf037ce, 0x9edfd51e, 0xc35ef194, 0x1ff6c178, 
	0xc7dec256, 0x2a5d36bb, 0x54ac6cf5, 0xd2adf267, 0x24afc897, 0xc1dcec9f, 
	0xdfce04f6, 0xf7f7fb57, 0xebc2bfb7, 0x4ea07ef8, 0xef7d1174, 0xbba7cdbb, 
	0x15862e48, 0x2fcc4efe, 0x7b0fb0b4, 0xed13e03f, 0xfd6f50eb, 0xb5faa2d5, 
	0x0fc4935d, 0x7aec8f10, 0xe036d2f6, 0xa5d4f423, 0xa1e9407a, 0xcefed937, 
	0xdb785d83, 0xd69797c6, 0xef9487f1, 0x91b7caba, 0xf414f3d6, 0x97945ce6, 
	0xff289be8, 0xf5b89136, 0xab87c4d3, 0xa61191e7, 0x531e784c, 0x479d0cef, 
	0x41fe9046, 0xcf7eaceb, 0xce708fc0, 0xf489ef27, 0x5bdae04c, 0x256c9416, 
	0xafae1e3d, 0xf2a49d80, 0xe0ce703b, 0x19ecbf9c, 0x926ef581, 0x2f9248fb, 
	0x8fe209f7, 0x57108a7f, 0x777f3f11, 0xc207d4fb, 0xfa9e2fe4, 0x5b4392db, 
	0xcef7ce88, 0x26f3f4d9, 0x59bdee7a, 0xd82b4d0d, 0xb0eb320f, 0x3e8def7e, 
	0xb13f4d6f, 0x4dcbae52, 0x4f7d728d, 0x4ed7ff50, 0xfd493326, 0xe07a689d, 
	0x927edf41, 0xe414dd17, 0x59938a7e, 0x25bbdae6, 0x90b7f27e, 0x5ba13cfe, 
	0xeebf2a6d, 0x4bd402ce, 0x75bf093e, 0x4ec9f704, 0x2578f43e, 0xc18de9fc, 
	0x3d467525, 0xf61a4dd2, 0x07f981d3, 0xa01e5bdd, 0x38964f49, 0xdb3ed538, 
	0x947ec0ca, 0xeee052fc, 0x5fd2c9b6, 0xcbc9eb7f, 0x1bfe608e, 0xeb0bba03, 
	0x8b1453d9, 0x3b38ae20, 0xdf2774c7, 0x2c99abbf, 0xef4ed5d7, 0x86503c1d, 
	0x3407d6e7, 0xfc7c7e13, 0xdb453fd2, 0x8379421e, 0x5d9bfc0b, 0x46179f2d, 
	0xb7f82ec7, 0x218997eb, 0x3ed3ed0f, 0x4fee5935, 0xfac83767, 0x77ba6b37, 
	0xf5075ce1, 0xe312c745, 0x98bb27ad, 0x8b813eb1, 0xe6b5cbf5, 0xccbfda36, 
	0x4e56f96e, 0x8db37df2, 0x0eecb34e, 0x939897da, 0x3b349fa5, 0xfd10bcd7, 
	0x7b7e3ece, 0x1da9378e, 0x4f393ae4, 0x36c5747e, 0x75b6771a, 0x724bd7a3, 
	0x5d7c0a74, 0xf884f12d, 0x8fc229d3, 0xf13f0937, 0x1f5967e6, 0x8f396a9d, 
	0x1cd4f1e5, 0xc7f84f55, 0xdadd54ef, 0x54da750b, 0xe2fcadbc, 0xd162a135, 
	0xc8e9988e, 0x37e06792, 0xcc5cd7bc, 0xf504e8fa, 0x4e7ea5e7, 0x028a71cc, 
	0xb054d7e9, 0xf2bf5d9e, 0xffaa7c99, 0xc6629efd, 0xf2438f3d, 0x2bfcf6f1, 
	0x7e7f019f, 0x02feb6ef, 0xa26de6ff, 0xe366f20b, 0x25b3f880, 0x707ca112, 
	0x8183d481, 0x4f17ac05, 0xd37caa56, 0xf53f9c79, 0x01fb2737, 0xb7920f3c, 
	0xdf760f93, 0xf8a6f461, 0x1ce07707, 0xea781e3c, 0xa97e1dd2, 0xd59a3a27, 
	0x4f20e338, 0x52b1bd36, 0x2724bbd6, 0x8794eba0, 0xbfad256c, 0xa73e6d33, 
	0x3f44bf54, 0x1673a1fb, 0x1db7741c, 0x8f8dfc56, 0xa529efe5, 0xbaf9d2e7, 
	0xdcf39cf1, 0x761341a4, 0x19c7f156, 0xb57d7a90, 0x6ebd64db, 0x4a53b5eb, 
	0x981e61df, 0xf15cece7, 0x84e1e039, 0xb7d86961, 0xab84309d, 0x6935f88b, 
	0x41373cb2, 0x352afd8a, 0xc93778e5, 0x52ec91d3, 0xe7ac6a99, 0x4a622e49, 
	0x7cb1562e, 0x4efd8bbf, 0x9d6c7cba, 0xd921ef2c, 0x3e557fe9, 0x9f5d15ba, 
	0xe5d23e54, 0x70457a01, 0xc8ec9b1c, 0x8d37254a, 0x19434798, 0xebceaefc, 
	0xf61a7caf, 0xafebbde7, 0x1b80223c, 0xb5e005e8, 0x3d23ec90, 0xcbc9e275, 
	0x877ec41e, 0xf2e915ed, 0x9c1d35df, 0xf6d8798c, 0xc979b865, 0xb633d802, 
	0x7712d953, 0xee1567ac, 0x3f81f1ec, 0x3bf8572e, 0xf55bebe9, 0xf1ddd27d, 
	0x39676f5b, 0xb6c9e5b2, 0x4d6fc16b, 0x670832b5, 0x5be757bf, 0xa6733cf6, 
	0x2a0e7e48, 0x2f578ef9, 0x879e54ba, 0x53b07598, 0x68df7fb6, 0xc0e05288, 
	0x7d5e3f1e, 0xf03aa5db, 0xf5cf21df, 0x97a187a0, 0x38d20f59, 0xfea45399, 
	0x6331f9b3, 0x1557f90e, 0x16ffe763, 0x90dc04f8, 0x7d236d3e, 0x6cb3633a, 
	0x84ffcf6f, 0xe71a7ccb, 0x4ea7cc92, 0x0586d1e8, 0xe3a6bf68, 0xc3c6df4a, 
	0x5f012f52, 0xe51a7ce9, 0xc279c28f, 0x740b5afe, 0xd36ff54b, 0xb40c5c01, 
	0xd03ac3cd, 0xefc0563a, 0x3fb12510, 0x51c6dce1, 0x9e2bd830, 0x4765d84f, 
	0x835fa1e1, 0x13b7f78e, 0x2ed9879d, 0x97b5d1df, 0x37a916d2, 0x673f1432, 
	0x396c54dc, 0x1fe0efa0, 0x7a4fbcd1, 0xb7ce374c, 0x7c9074d6, 0x6c4f3cd1, 
	0x8c19f2be, 0x948b7ef7, 0x067faa37, 0xc76c3ee7, 0x7257b023, 0xd87bf3bf, 
	0xf20df073, 0xe790983c, 0x29d64f13, 0x67e7247d, 0x7dd811eb, 0x566ef31d, 
	0xde8b38b8, 0x4616fd62, 0xfd15764a, 0x7eb01b12, 0x2d4cb627, 0xe9c9592d, 
	0xcf64a50b, 0xbb6f33e3, 0xf7e68cb4, 0x6fb964e1, 0x18d571b1, 0x1c3b60c8, 
	0xd2e4badf, 0x4e17a449, 0x008e723c, 0x6cbf89de, 0x9cbc6d3f, 0xa3b481fa, 
	0x3d4fce36, 0x1fe3f52c, 0xe33eff50, 0x99c419ed, 0x7b02fb6d, 0xe67f25eb, 
	0xa4af2559, 0x087f5857, 0xb3a475af, 0x1ee39654, 0x7bec5204, 0xe36b71d3, 
	0x2faa09fc, 0x9bcf1f7c, 0x3e8fd875, 0x09cdf68e, 0x50e36d7b, 0xad7f212b, 
	0x7449d143, 0x38eb51ac, 0x090ab76a, 0x5eac620f, 0xd61f9d1d, 0x366f0923, 
	0xeffed89e, 0xaf87d84d, 0xc9fb914c, 0x2fdca0ee, 0x39c1fa9f, 0xdf84accf, 
	0x33f170f5, 0x9f59e7e1, 0x1e861d3f, 0x1bdddf9f, 0x6fb640be, 0xbdd84e6a, 
	0xfb7c17b7, 0xd623f0d7, 0xa97b739e, 0xded93db7, 0x13fbc79d, 0x2ed83e5b, 
	0x6a277f52, 0x375a2e88, 0xdb139287, 0xbc229dde, 0xf613336d, 0x2da79ece, 
	0x0fb02787, 0xbd8c7f0a, 0x82fd20ee, 0x6f4ebae7, 0x897a6daf, 0x6738159f, 
	0xb69574a1, 0x9b6dd952, 0x874fc83e, 0x6dcfb7cc, 0x627cfb64, 0x6ee3b28f, 
	0xfb90aff3, 0xc1eb1ecd, 0x1ede3d88, 0x92c3d785, 0x8f03e04f, 0x76cce7bf, 
	0x9bdbe79f, 0x7dc7d766, 0xdb6e7b72, 0xdb7f53f1, 0x31c473f4, 0xc9673bdf, 
	0x4bf0f5a1, 0x5f9dfa03, 0x05e37e92, 0xd1cfe41d, 0x3fc0c672, 0x01f48fde, 
	0x84ce92ff, 0x12e0397e, 0x84fed587, 0x58e5aef8, 0x536cfd17, 0xb0c17ed2, 
	0x85e227f7, 0x41c8d3ce, 0xd7e914f1, 0x46de0521, 0xf290c1e5, 0x51c84ae0, 
	0x9953f61d, 0x7a1bbc89, 0xc46ee399, 0xdd9563d7, 0xc73fc2ef, 0xd67a06fe, 
	0x68d61d69, 0xc50fe14c, 0xd48db134, 0x2af9bb5e, 0xcd66f9ce, 0x1c6c786a, 
	0xc199b9e9, 0xd2f55ecb, 0x996477bc, 0xcd0f76ff, 0xfc4fb67b, 0xdc52774b, 
	0x7ed4dbaf, 0xbe524374, 0xf8f19fc2, 0x01ce92d7, 0xec7e3fc7, 0xbf3d1350, 
	0xd1f33cf3, 0xbf9ce32f, 0xf265fac8, 0x9f69b3f3, 0x71c645bf, 0x4453d7f9, 
	0x7257c979, 0x2f9ec9c1, 0xebc3fbdd, 0x83827b54, 0x6f10cce8, 0x4f7fdee3, 
	0x3d3269ae, 0x774f62b9, 0xacc178d2, 0x43885bd8, 0x5fa92f76, 0x76fec45f, 
	0x3eb6afdf, 0xcd44fecf, 0xc49f9d9d, 0xfc69886f, 0xdf9a4d7e, 0x48c03f00, 
	0x4ee6b7da, 0xbdbf7e95, 0x01fd637e, 0xcac26bf2, 0x0fca102f, 0xe0fd8d5c, 
	0x10f20d09, 0xe052b530, 0x954c7fea, 0x576a41f1, 0x27a1ff0a, 0x4b76fc57, 
	0x658fd33d, 0xfd0df9a1, 0xf563d607, 0xb95f45d4, 0x3be793b9, 0x1afc1fca, 
	0xa3be8b03, 0x3fc4f870, 0x5ffd7215, 0xf9c62cb7, 0xaeb7c662, 0xf6adfe21, 
	0xe9dcfd4b, 0x3e608f36, 0x6b9ca73d, 0x7f4f693a, 0xead3c2a7, 0xbe5f47a9, 
	0x36f181a9, 0x44eccefe, 0x8f7a9a7f, 0xb90e3d22, 0xfeda2699, 0x54be2165, 
	0x1053affd, 0x2aea743f, 0xf7d75b1e, 0x33fbc6a0, 0x25e2156b, 0x77fd66dd, 
	0x8fd31fdc, 0x68eb172d, 0x1aff3892, 0xefab0395, 0x4fd423b5, 0xe477de96, 
	0xedb18ecd, 0xb73bfdec, 0xfa8c49bf, 0xc6a68d1d, 0x7b980cf3, 0x39272f27, 
	0x59793c0b, 0xbbd272ef, 0xd9773fab, 0x0eb1cb83, 0x6478bfd3, 0x83922939, 
	0x66e6ef34, 0xb7ff74e0, 0x777124bf, 0xf190bdb8, 0x0de41574, 0x625b40eb, 
	0xb4aa7331, 0x2fd1ab3b, 0x53a98be9, 0x3a66dea5, 0xef8d27d6, 0x3c57e395, 
	0xf15e712b, 0x1c6c436c, 0xe2af37d6, 0xe0c5fcc3, 0x1eb7f5bb, 0xf51bc95d, 
	0xa914fb7b, 0xbad42b87, 0x738bfcf4, 0x97bc36cd, 0x4bc27642, 0x3228ee9d, 
	0xe7af117b, 0x0dd31071, 0x8fb1d35a, 0xe638875a, 0x36ee3931, 0x14c76ba2, 
	0x76ff076a, 0xcfea19d9, 0xbadd5f37, 0xc4b2b08f, 0x3f127634, 0x57cc7877, 
	0x1c822e77, 0x33c40bd7, 0x1fed3e7a, 0xe2fb4ade, 0xe726719e, 0xfcac97bb, 
	0xa601d37d, 0x74afadff, 0xae3cfe32, 0xf42e109f, 0x6b6e6ffa, 0x5ec7dc87, 
	0xaa33964f, 0xf7cd557f, 0x7775c831, 0x78fbfd5e, 0xb7146b1f, 0xdda3d66d, 
	0x8ee21cea, 0xf221e042, 0xefc942e3, 0x26ee5b6d, 0x21cdda3a, 0x85b15f55, 
	0x5ec0b7ea, 0xb4c5fce3, 0x26fde3a6, 0xcd5b27cc, 0xb3e693a7, 0x2f6c6a65, 
	0xd64865cb, 0xef34a58b, 0x80eb13e7, 0xccf7d8f6, 0xcbf2906e, 0xd3ad3cfe, 
	0x3d8eb532, 0x7e7ab1b9, 0xb6a0e47e, 0xa6cfed8d, 0x185e7815, 0x33fb8d31, 
	0xa49d15ac, 0xdaa68b17, 0xe55293f7, 0x601f7d39, 0x5f7095e3, 0xfbc6bb06, 
	0xe5636385, 0xf34dd3be, 0xdfd6ad5a, 0x54edf892, 0xe7bc0af1, 0xd83c3676, 
	0x236e43cf, 0x96c72951, 0xb22e2bb2, 0x6c46ddcb, 0xa06b9f32, 0x7c84cedf, 
	0x00792b75, 0x66686fde, 0xbbf929bd, 0xf926f89c, 0x616e702b, 0xecf025e3, 
	0x16eb93ee, 0x1b22fd63, 0x1dcf491a, 0x2a673ea8, 0xcf3cdde2, 0x19fde4e1, 
	0x965b3de1, 0x407881df, 0x0ff7e48e, 0x84fe56be, 0x2fd89bd1, 0x1d36f5d8, 
	0x8f38afd0, 0xd7dc3b47, 0x32ddde85, 0xa247e125, 0x89cdddfd, 0x17c13af1, 
	0x579f575a, 0x42788e98, 0x99feb0cf, 0x2773fd0c, 0x19c41feb, 0xbdb34eb0, 
	0x5fb58e66, 0x4ac39fe9, 0xf5205d1f, 0x4fbdfc1c, 0x6ebc9eba, 0xd59eb561, 
	0x52bb3d6a, 0x9b5790f4, 0xd5f7a49b, 0xa8b6623e, 0x7d67c7b7, 0x6bfdc760, 
	0x5fcf52c3, 0xabfa553f, 0x6b0e15b3, 0xbcd5ef97, 0x4f776f64, 0xaddcf891, 
	0x5d84e070, 0x5a7ee797, 0x69fb9e44, 0xb92ec8db, 0xee7b2aa7, 0xfddbfd97, 
	0xb0c9accc, 0xbe31afef, 0x1c6cfeec, 0x152f3e90, 0xaffd12db, 0x647de436, 
	0x6e74479c, 0x7b0f3b1b, 0x023cf69e, 0xed45be34, 0xf58243ba, 0x48a79fe0, 
	0x3167a03a, 0xc5f2b3af, 0xb2f85332, 0x04f8c84e, 0xeffb93e9, 0x40fff292, 
	0x3a9cddfb, 0x6d3f6b80, 0x23fe70a1, 0xe7c37f86, 0x67bbe130, 0x81c073c9, 
	0xdf1ef897, 0x6b9fb67f, 0xe03a0b9f, 0x0bc738cf, 0x850dcf83, 0x359179c5, 
	0x41ef17bc, 0x9f6ed5d6, 0x8df0f8ca, 0xbb907c44, 0xfa8ad126, 0x75cd0f1d, 
	0x9f947ea0, 0x94974425, 0x234658df, 0x28e2a3fc, 0xda4b37ce, 0x3f293fad, 
	0xfd98a7a8, 0x527f1da0, 0x6ed2d07e, 0x0610f7ca, 0x1fa0c6b7, 0x6a7f4a1d, 
	0xa18b4d59, 0xe11dab0f, 0x58dbe80c, 0xefca0ee6, 0xcb4fa57c, 0xfd4f2073, 
	0xc57a0fc1, 0xd9b38ab4, 0x4bb89fce, 0x6b6d43ea, 0x88bef421, 0xa4cebe42, 
	0x367159f7, 0xbb53ef43, 0xfef563ed, 0xe6f9fd68, 0xc05eb61f, 0x3ba7bf7a, 
	0x1483813b, 0xfa784afd, 0xff6954f1, 0x9957a4cf, 0xe927efa3, 0x3d5671d5, 
	0x546b1bdb, 0x3fa0c47f, 0x357c8f66, 0xbf47ee35, 0xf3c4e1ae, 0x9552dfcc, 
	0xf3e0993f, 0x867fdc3a, 0xf590ef3d, 0xc6a8f5b3, 0xff50b7fd, 0xf4f989bd, 
	0x8f5c7daa, 0xcf9edf1a, 0xbc65530b, 0xf547dfe2, 0xd94f1ab5, 0x4b32aee3, 
	0xb73f108b, 0xb145643e, 0x5cea59fc, 0xa5c221d4, 0x67de9e7c, 0x121fc2f5, 
	0xebb7a466, 0xc03f2902, 0xf23ed65f, 0x35dca903, 0x5efc8be7, 0xde3cc8aa, 
	0x8dc7df2b, 0x06bf8039, 0xce973caf, 0x04575cfa, 0x7d9b1aed, 0x2fda26fa, 
	0x14661989, 0xd07715fb, 0x9fa8b22b, 0xfcbfedec, 0xcebb9f35, 0xf1afe2f9, 
	0xa8797c74, 0x46215c59, 0xff344ff7, 0x5b07dc2e, 0xf59a225f, 0xb83ef0c7, 
	0x7c7ec308, 0x3f2020c5, 0x82daf886, 0xe432f166, 0x9bd7c55d, 0xa1875e69, 
	0xef0b85ef, 0x661b7417, 0xd9dffa19, 0x3c478faf, 0xfe035282, 0xe311dc6b, 
	0x96ee547b, 0x70da0b6b, 0xe88677a9, 0xa1c2bb45, 0x55c801c6, 0xaabab1e3, 
	0x7fa53f50, 0xa6f8a954, 0x5a540b4c, 0x2cb1532d, 0xb8bac0e6, 0xdc0e6273, 
	0x0579c13f, 0x511c2370, 0x6455ee07, 0xf6890b2f, 0xd18348e3, 0x01a426f6, 
	0x1fa5137d, 0x2bf7954c, 0xdbf997b2, 0xb8bd5137, 0x167be4c8, 0xe16b0e25, 
	0xbb10b45b, 0x67448672, 0xb6335203, 0x4fa945c7, 0x9c927464, 0x9b332aed, 
	0xefb948bb, 0x37b2b72a, 0x97985cb3, 0x7450eeb4, 0xa6399f83, 0x3e031223, 
	0xb288d2cd, 0x447f8f33, 0xa63ed779, 0xa452d287, 0xb0e6336e, 0x36bad368, 
	0xa869eb46, 0x275a3173, 0x43bf7fb7, 0x0ae15ee0, 0x0dacf4c1, 0x93e69e51, 
	0x5a389013, 0x858ae78b, 0xf5202eb8, 0xeb0edda4, 0x3aec3e0e, 0x43d4709f, 
	0x515d95e9, 0x26bb71f8, 0x1390b99b, 0x5feb9fd7, 0xd63cdfea, 0x3f42adbf, 
	0x6aecf784, 0x798c3ba2, 0xdc601fac, 0xe7115f11, 0xf7071e10, 0x28f6f38f, 
	0x2032b7f1, 0xe157b3cf, 0xbcc4e6b9, 0x093ee1d7, 0xb7aecbc9, 0x9f852b1e, 
	0xfd465d91, 0x2883e099, 0xbdb65d05, 0x6161f04d, 0xcc6dfa29, 0xd5ef3c11, 
	0xe0f98c66, 0x7be68f3e, 0x335e6277, 0xbf9c6f30, 0x561f2406, 0xff32cec7, 
	0xff626172, 0x78cdebb2, 0xd92ff629, 0xb03bd6c7, 0x4e35db21, 0x70e2f454, 
	0xa061a871, 0xdf6cb0e7, 0x6174f24b, 0x1689c640, 0x55b43e2b, 0x9e816a2f, 
	0x5d68cb15, 0x57f0cfb0, 0xe51a5db3, 0x422ce103, 0x22bdd676, 0x6bfd0a5c, 
	0xd1165bef, 0x3f1217f3, 0x6b398eda, 0x7f73c22d, 0x1a1c4fc7, 0x8aed7ff1, 
	0x2bad52a1, 0xfc101f71, 0xb598fdc2, 0xdb72a265, 0x4b56ac73, 0x3e268f11, 
	0x40bb6c55, 0x9cf115f2, 0x8f18f346, 0x091dfb6b, 0x7e1439be, 0x5ac4398e, 
	0xbb22176a, 0xb68ffb49, 0x7cc1511c, 0x9ff24e5c, 0xa34be091, 0xb2edf25f, 
	0x8d3fd480, 0xccfbae78, 0xde72e3fc, 0x37be50af, 0x917d9e51, 0x6df317bf, 
	0x8115e39c, 0x5b9d7da4, 0x4fbc8537, 0x62ba626b, 0xecb306cd, 0x3e879551, 
	0x1f524d13, 0x363d1eb0, 0x42c67f16, 0x192213ef, 0x256bf41f, 0x5b99ae3e, 
	0x651c0395, 0xe80cd16d, 0xae2f5b37, 0xbddd7b99, 0x8b39eb1a, 0x1d6421ef, 
	0xf9c6e038, 0x65d2eba7, 0x78bef2f7, 0x94361fae, 0xf58b3dfc, 0xb237fc34, 
	0x71d7ec45, 0xd3f69cfc, 0x561d1377, 0x4f3e3520, 0xefc059f4, 0x1f6225ba, 
	0x8f411b9f, 0x2e72611f, 0x4d84bdc2, 0xeaafb901, 0x7eb28cc9, 0xbe493d87, 
	0xfe84e217, 0xc6ed937f, 0xcc31fc10, 0xa339e30b, 0x4bbd4ad3, 0x8657df79, 
	0x6a5ddafd, 0xf6fe7b5c, 0xb50b9d7c, 0xf993cc32, 0x1f9639d1, 0x93428da5, 
	0x21e398f4, 0x7374739f, 0xf06276fc, 0x9fbd8eba, 0x257dbe02, 0x98fa0862, 
	0x3fe0137e, 0x6d22f950, 0x504fdb88, 0x760cb9f2, 0x8cad3c70, 0x58ddef83, 
	0x127fa413, 0xc4db109b, 0x739ecaed, 0xfa4cbe72, 0xc478da37, 0x693f6c5f, 
	0x1a7f95d2, 0x2e07681f, 0x1879fb04, 0xecbb64e7, 0x8a9cafe7, 0x8fdc03b2, 
	0xec82f655, 0x1dc82f6f, 0xd269683f, 0xdc97f14f, 0x4a7ec0d3, 0x3f05df34, 
	0xfe496e65, 0xbe53f601, 0xbf05cdbe, 0x3c65ea83, 0x336eba24, 0x5f2527fb, 
	0xb264fc43, 0x66db79b9, 0x7e3ed5d8, 0xe64337be, 0x29599c4b, 0x839d98f1, 
	0x11829ce6, 0x85b0bb89, 0xdc322a7e, 0x5038e13f, 0xb134476b, 0xa5ff261f, 
	0xef00fba4, 0xb3f42d4b, 0x71a1fce3, 0x243f4977, 0x47edbc8a, 0x7c14e3a4, 
	0x36ddb088, 0xfafba323, 0xfd076c0d, 0x867d2bf0, 0xa187d73c, 0xd8027be6, 
	0xfcc6ac4f, 0x4a3ddb05, 0x56ff7e0d, 0x3162cfd9, 0x787b8998, 0xd6164bd4, 
	0xde4050e1, 0x3ce3b047, 0x8ec609e3, 0x62ffd81b, 0xd7f619ff, 0x2eed28d7, 
	0x7d8237be, 0xc26dee04, 0x617a92ce, 0xc5d5db3b, 0xce7de5f3, 0xae79013b, 
	0x5ef23c51, 0xc47c7bca, 0xfca3f637, 0xdf3ef941, 0x6d1f5d6c, 0xa3be5c0f, 
	0x495bc4f4, 0x6977be79, 0xf6c17bc8, 0xc73a6d3c, 0x3c93df61, 0x7fcd30ff, 
	0x33fb9725, 0x2a7c131a, 0x5fa4271e, 0xf0070866, 0xdbcf0633, 0xfc17b92f, 
	0x4b1f1c61, 0x7be331c1, 0xb8a3c714, 0x5d7052b6, 0xfea9a6da, 0x1fd01362, 
	0x946829e8, 0xd45f81f4, 0xe650ac6f, 0x8d8f85fd, 0xece82bc5, 0x3ffa79a2, 
	0xc5af8d0a, 0x0012077d, 0x659a97e8, 0x5738f191, 0x7dca0ff1, 0xfc361405, 
	0x1d632fd9, 0x170d391a, 0xa7b25e12, 0xfbd97e49, 0xe21d7b42, 0x4ba8b195, 
	0xbd3579c6, 0x8c8fdf9d, 0xcaff3418, 0xcecf9269, 0xf44be139, 0x69fba4be, 
	0x62b5bc73, 0x0d0fdb27, 0x53fd39fb, 0x927b6794, 0xe16379c9, 0xeb8b5aa4, 
	0xefb06a37, 0xab3425ba, 0xe090d284, 0x9268b1bc, 0xf3e47f6d, 0xef8d34cb, 
	0x3fb45835, 0x0ce13b22, 0xdab964c6, 0xe31ee127, 0xc712c3e1, 0xe31c54ab, 
	0x799be930, 0xbbec1f44, 0xc2f88f8d, 0xabc65458, 0xc67b8685, 0x8fee0798, 
	0xef26982d, 0xcc6b3801, 0x95b9e44b, 0x1e7c9237, 0xf4da5467, 0x2a8c7a4b, 
	0x3e727e7b, 0x2e67f4e9, 0x733fa54c, 0xc5df3d91, 0x3e6abe72, 0xf3c99699, 
	0xb2990cc9, 0x0cf1203c, 0xd7b3ae7a, 0xafa926e1, 0x0c75e592, 0x3ea84b5e, 
	0x8da5af09, 0xef51c631, 0x811c56cf, 0x22f8dadc, 0xce15f4fc, 0xf219f155, 
	0x7fe13bd7, 0xbe7e3057, 0x68e89c7f, 0x34d1729e, 0xc2fce3ec, 0x7dc96e9c, 
	0xed1fdf1e, 0xba479b75, 0xffb4bf18, 0xf7f73927, 0x25e74ceb, 0x9e75ce8a, 
	0x01720458, 0x5bdf98bf, 0x1bb93c25, 0x4ea07113, 0xfb822c77, 0x74a78834, 
	0xc79c4b6d, 0x26fdd53b, 0x03f11e3b, 0xc4a45fe5, 0x9bbe6827, 0xf60239d5, 
	0x0a6fbcb5, 0xbee4475a, 0x3c7f1cc9, 0xdc7aeceb, 0x0b96c7ee, 0x84d2d396, 
	0xe6987b5f, 0xfee1183b, 0xc4710f32, 0xf989962d, 0x901f781b, 0x39ebffe6, 
	0x64be665f, 0x1ba2d95f, 0xd35faf54, 0x22273d32, 0x99b833f9, 0xcfc2b7db, 
	0xa116aecc, 0x87ecfdce, 0x9160f5e2, 0x1a7f0bed, 0xcfb676fe, 0x173efabc, 
	0x744b6afc, 0xae74a41c, 0x9deb673f, 0xdfdcfb48, 0x5d9efd23, 0xc83bba67, 
	0x1d3d1037, 0x243ef9d3, 0xfff212f1, 0x987f9cc0, 0xbb3c93a6, 0xd4d50dae, 
	0x0a4738d2, 0xec3efcae, 0xbcbac3d0, 0x8f0227af, 0x707ec74d, 0x852b1fe6, 
	0x342cb7bc, 0x2a8ea7dc, 0x0e777e39, 0xc846ebfd, 0x7e56dec0, 0xd5867d4f, 
	0x3ca0f78a, 0x6154b5af, 0xab79eff3, 0x53f70aa5, 0x5599cf3d, 0xb982f712, 
	0xc13c71e9, 0xbf0992fb, 0xf9c34d09, 0x02eff95c, 0xc8def0eb, 0xbafce7ee, 
	0xc9b484d6, 0x25967d07, 0x3f5ae9a6, 0x32d5fdf2, 0x51a7d2bf, 0xe8de137f, 
	0x67bf0bdf, 0xab0373f7, 0x777ca833, 0xef8edfcc, 0xed8eed15, 0x38e32879, 
	0xa441e0d2, 0x55f5f19e, 0xcfb1efc9, 0xf32f759b, 0xc03c33d9, 0x0d8eefe3, 
	0xf0e78dbc, 0xa3d628a6, 0x190317f4, 0xffac2788, 0xe1a7b7f4, 0xfd92987d, 
	0xe9f3ad7d, 0x4d7d92b9, 0xfc2a969c, 0x65ff8d54, 0x8df8cbc4, 0x7da83a45, 
	0xcf7ca669, 0x6f426aa2, 0xb37ecbc4, 0xccfdc115, 0xf1ab8552, 0x956aeabf, 
	0xb456aded, 0x7b48d40f, 0x70673591, 0xb9e2702f, 0xdf011bc9, 0xf04fa107, 
	0xe7498a7d, 0x607f2869, 0xe1a70fce, 0xfaca6dfe, 0x3b7bffa0, 0x466e43a6, 
	0x47b9e9d7, 0xaffde3a6, 0x846b27fe, 0xebcf77ba, 0x3ae8f8f4, 0xa9d72e3d, 
	0x4dc72f65, 0x5aa9d746, 0x5fc2ebd8, 0x367cf28f, 0xaef38554, 0xae2eb3cd, 
	0xba4e6ed1, 0x5fd55057, 0xbff34a5f, 0x830f7418, 0x716303ae, 0xd37aba03, 
	0x57f8eae8, 0x41f58fc6, 0xff5d0a6d, 0xbfd74a36, 0x34acba49, 0xaa85d4fc, 
	0xd0ac7bec, 0xd236ce8f, 0x071c437f, 0x7dafc08c, 0xbdc3e88b, 0xb19e9b65, 
	0x2c657eb8, 0xdd7192df, 0xd5d32777, 0x52538ff6, 0x28fafd70, 0xba4baf5d, 
	0x9a090f40, 0xd7e36fc7, 0xe6791c64, 0x8a570a9b, 0x9b7abe6f, 0xcfae4e8f, 
	0xc67aecd2, 0xfd9ae13b, 0x66a1dded, 0xeff5ee2f, 0xe7e03ef6, 0xc8386874, 
	0x8f502c69, 0xb0ffcf7a, 0xbf7189c7, 0x972dfdbb, 0xf0f6e7c8, 0x439e00fb, 
	0xf6678d96, 0x47877742, 0x4f247df8, 0x8c5e3d8e, 0x143ddfc7, 0xc27ca288, 
	0x2c45e16b, 0xb65bcb27, 0xf09e6fc3, 0xe72b537a, 0x441ffa5b, 0xa1a1f77e, 
	0xcd1f1147, 0x8cf42a32, 0xfd81f220, 0xbe308fbc, 0xf9019d57, 0xa2fcd438, 
	0x2c5ecfcc, 0x654703f3, 0xa35627fb, 0x4b1de7bd, 0x98396bd1, 0x3fa1e19e, 
	0xc908fd70, 0x070fda23, 0x5921f874, 0xd4972423, 0x87ba927e, 0x7fb87bb5, 
	0xafad0675, 0x2a81a5e7, 0xe0fa8fcb, 0x3ddbb441, 0x8ee7e21c, 0xe59c7c4e, 
	0xe5a46b25, 0xeefdc815, 0x650f7de3, 0xc0f11fa0, 0xcf7f90db, 0xbcebfead, 
	0xe126cb64, 0x1dfd169c, 0x7f441c0f, 0x86c5cfa3, 0x1373c03f, 0x8fde68de, 
	0x8fbb0a7b, 0x3d0dbff7, 0xb8d5b9e1, 0x573d1b6e, 0x4581fbfe, 0x79c82cf3, 
	0x41f40d59, 0x45fa96f9, 0x13fd10cf, 0xf971f54f, 0x0f7bf404, 0x295d4bf6, 
	0xe1513cf2, 0x12c5f5c7, 0xe582ff25, 0xdca6627f, 0xf33c934f, 0x7974cf3d, 
	0xe5532bd7, 0x134f9afc, 0xf0244f72, 0xe9acc2fb, 0x265bc035, 0xf0c208fc, 
	0x6a33f9e1, 0x7bc46f0a, 0xd3c656b4, 0x708ba6e8, 0x3bddf586, 0xba851efa, 
	0x83df2ed7, 0x13fbc3ce, 0x626fef78, 0x6eef7c8f, 0xceef7ca9, 0xe1ebf88f, 
	0xcb6ab8a4, 0x7fb9f8cf, 0xf71ffda0, 0xdf997b13, 0x5fba793b, 0x9433bfb3, 
	0x6b357716, 0xe34707a0, 0x76c101ae, 0x93fd5e28, 0xfb21c2a8, 0x9fffa26b, 
	0xdd6efe58, 0x93ca4930, 0xfa0efadf, 0x9efcfec9, 0x2f9fa0ef, 0xbd977d28, 
	0xa12b43b4, 0xec2fb27e, 0xa43e0bd9, 0xe7d7673f, 0x3557d45d, 0x31f603bf, 
	0x0fd07ac6, 0xe4489cfe, 0x4ba21cf3, 0x882e95c5, 0x4c78fbca, 0xc8b56677, 
	0x992709d3, 0x6c92bdea, 0x7a0989e4, 0x187df2d5, 0xcfbd532f, 0xf5239995, 
	0x5235b5f8, 0xf4a857de, 0x3f191a86, 0x6f9cf5fa, 0x4b1b79c8, 0xf4be63a6, 
	0x474cbbfc, 0x0e473f3a, 0x6eb73f33, 0x5ef395cc, 0x6b8e57fa, 0x749e1f47, 
	0x90de7e06, 0x1921cfca, 0x857876c7, 0x29807e03, 0xffc879ac, 0x7703fd0e, 
	0x9fccadc3, 0x7639f497, 0x5eb1d3ff, 0x0b63fe89, 0x35666f58, 0x23e705ff, 
	0x54f2d7c2, 0x9b884799, 0x5c60ae67, 0x4d0e2e3b, 0xe6f78b9f, 0x7827ac87, 
	0xcbded2dd, 0x783d7e84, 0xcdfbe63b, 0xccd38c9a, 0x393bdf97, 0x264a7ecc, 
	0x4ff27bfc, 0x3fc84b32, 0xc91daf71, 0x927f93f4, 0xac968dfb, 0x96f3e500, 
	0x51e9648c, 0x1c8c87d4, 0x6e0f39dc, 0x75fe81aa, 0x42301daf, 0x7eb3ced4, 
	0x023739c4, 0x3af0775c, 0x2df5ae12, 0xcc1099bc, 0xd70258af, 0x896b7dea, 
	0x9ae042c7, 0x0a7c5ff4, 0x04dafae1, 0xef7413ae, 0x7538c9a8, 0x5d2dba3a, 
	0xa5a757f9, 0xf7d9d2fb, 0xfa6c7f31, 0xa030ff3d, 0xbb7d32d7, 0xbedf4f4e, 
	0x8e3e9fbf, 0xfd4e184b, 0xb8dff124, 0xd3e99438, 0x32068f60, 0xf9cd28cb, 
	0x5aab286a, 0x308ffd03, 0x0fb73c1e, 0xefc2d564, 0x1d3c39bb, 0x3f7f0cf7, 
	0x4b4f9feb, 0xe93bf887, 0xc4b03378, 0xebacbb09, 0x378b9631, 0x3f60eb75, 
	0xf89329c6, 0xfbd54d1f, 0x1c948719, 0x4434a3ec, 0x1ab3f072, 0x38996fb9, 
	0xf7fb7fc1, 0x32ad281a, 0x9a17fe5f, 0x994fc4cf, 0xf1cedb7f, 0x4daaf32d, 
	0xeaae7e78, 0x3df52ea7, 0xfea85f8f, 0xd6cf7eec, 0x13d09bcf, 0x031e981b, 
	0x721cbef6, 0x4fca43f0, 0x89ce0eb4, 0xcf7cae9c, 0x4f9ca0c1, 0x57afe62e, 
	0xfac26df7, 0x8c9c6d9f, 0x989b2509, 0xfd3faa2f, 0xfc0fd4b3, 0x8b433d6d, 
	0xf25f8014, 0xf3e536fb, 0x4759e185, 0x9e46a576, 0xef78e9c3, 0xbe391ef5, 
	0xd7a5f087, 0x9fa3a30a, 0xfd883dc7, 0x173fcd2a, 0x23a6d87a, 0x20f85741, 
	0xe899cff4, 0x3680e3b2, 0xa95626df, 0xc2aa1df3, 0xd63fa1fd, 0x899df3c8, 
	0x33df529f, 0xe228fda1, 0x13e5a3f7, 0x5388f954, 0x2316f3e3, 0x73fd8f51, 
	0x9d7349fc, 0x5efcd7d2, 0xca11fc69, 0x13257f4b, 0x61bf8bff, 0x1c9fa5e7, 
	0x975ace7f, 0xefc4bfec, 0xfcf6ecb5, 0x76bc663e, 0xf9c1deb4, 0x83ac0c2f, 
	0x3e5f1f9f, 0x63ebd322, 0x31fa5eaa, 0x57de17c0, 0x7907ba43, 0xddc6f89f, 
	0xcb296fb4, 0x89bbab35, 0xe679650f, 0x1f153b9b, 0x38d95fd0, 0xbe4a56f1, 
	0xced6f638, 0x64fca496, 0xfa94edeb, 0x94f1e6a9, 0xb7e2c5fa, 0x624bf529, 
	0xdfa94dbf, 0xf88cde68, 0x7326d956, 0x87f93745, 0xe15a9965, 0x3a94c5ce, 
	0xcd6f670f, 0x97e25d06, 0x62f3ed29, 0xcfa54cbf, 0x7d2a55fa, 0xf9298be6, 
	0x94a5e2c9, 0x5ec6a7e7, 0x6c5fa94a, 0xfd4a47fd, 0x94e5f312, 0x0dd68dfa, 
	0x4ed8be8a, 0x6f7327f0, 0x809fced6, 0x3b8c07be, 0xec5f4033, 0xe7da533f, 
	0xf4a6af59, 0x2d7cce37, 0x5e2c5f25, 0xf62fa54f, 0xd67d2a7a, 0x33fca91b, 
	0x9f4a937f, 0x5fe54a18, 0x81bbb9b8, 0xfaf0f3e9, 0x4b645665, 0xb4dcadfe, 
	0x89a47c95, 0x171ca5d3, 0x885b14d7, 0x62bb149f, 0xd35f711b, 0xf893f28f, 
	0xf72c819e, 0x579704b9, 0x17a7edda, 0x3bbdb8c7, 0x579413f6, 0x2a9f72ab, 
	0x9705b9f7, 0x14fd514f, 0x7dc21fa1, 0x7ee2cb91, 0x04fdaa02, 0x5704ffd5, 
	0x35e51dac, 0x83f47b76, 0xfb8b6ef6, 0x13e555a9, 0xdc13ff54, 0x7ca29fb1, 
	0x6cb7ea9c, 0xe22f6c53, 0xe65ce318, 0xf79a2ec6, 0x5e32e9aa, 0x8fd55e38, 
	0x3fdc5977, 0x10e387e1, 0xf8cba66b, 0xce3538f7, 0xe3c9b738, 0x72f73994, 
	0xd540713c, 0xc73a280f, 0xdde376ab, 0x473b8f16, 0xfaaa53d1, 0xdc99752f, 
	0xee555cff, 0x975ee555, 0x67f94368, 0xaaa53f54, 0xc9b7529f, 0xf6ec84fd, 
	0x16ebdcaa, 0x5f3e5007, 0xfc512fb5, 0xee097129, 0x67954ebf, 0x974cf2aa, 
	0x67f94119, 0x8a253f55, 0xc16e253f, 0x3caa9bfd, 0xba679553, 0x2f28bdcd, 
	0xa15be34c, 0xbe06d62b, 0x19be2a75, 0x8970deaa, 0xeedf3268, 0x54297c54, 
	0x63ba16f4, 0x6f8e3e07, 0xf7876a86, 0xa5ced158, 0xfd15b3ca, 0xfb932ed9, 
	0x39e551cf, 0x25c73caa, 0x51ee515a, 0xfa2b67f4, 0xf726ddb3, 0x39e555e3, 
	0x2dc73caa, 0x40bca3f6, 0xfd52e3f5, 0xf7165cb8, 0xb9e553ef, 0x2eb95e6a, 
	0x522ffb93, 0x3f54b8fd, 0xfdc5b72e, 0x15edd897, 0x936eb9fd, 0xf1a777fb, 
	0x458aedcd, 0xc57eb7c1, 0x6e353cb7, 0x9ad62b9e, 0x14c7b7cc, 0x3faadc5f, 
	0xefb63bb7, 0x53cb7c74, 0x63b9e474, 0xcab95e3c, 0x596c9fc7, 0xfbeaf7c7, 
	0x1e93f7d5, 0xc0a0fca1, 0xdef8ac77, 0x950dfc6c, 0xcff5541f, 0xeaf6c80d, 
	0x7bf195fb, 0xfdbd6407, 0x555aa5fd, 0x17fcaa6f, 0xd932fd54, 0xbe37fe1e, 
	0x213b0377, 0xfd533fdf, 0x9f223f5c, 0xb2f9916b, 0x8769350f, 0x513fa5ab, 
	0x6da691f6, 0xe9a1fca3, 0x8b570eca, 0x5cee70db, 0xf97cc13e, 0xfd48cdae, 
	0x1f25ecdf, 0xdf2ddcb2, 0xf1d4a30b, 0xe79883c3, 0x91fb8690, 0x0645d3e5, 
	0x0be560e2, 0xf17722fa, 0x97e906bd, 0x29fbedfb, 0xe3f64181, 0x46af7e1f, 
	0xff4dd9fa, 0x1bd6fece, 0xf7e40a7b, 0xd92ddf9f, 0xe561f1c7, 0x5dfc4ff7, 
	0xa5199f18, 0x639360fd, 0x807ec5a2, 0xfdb4273c, 0xc71a3dfa, 0xf58eca33, 
	0x5f97e039, 0xbfccd06c, 0xdecd79c6, 0x5c6e2087, 0x3aff4454, 0x2e0fc891, 
	0x5385dbb6, 0x6f9f1dda, 0x9cf9fb97, 0xf17f2ed2, 0x8dd7fa6e, 0x7f9dfd49, 
	0x69efe7fa, 0x61fd7fa4, 0x7d3fb96c, 0x8d7e133f, 0xc9d9f0f9, 0xd99fa40b, 
	0x10f98fbf, 0xfedb26be, 0x98e3bd2e, 0xbd9fe095, 0xb79d19af, 0xa533f697, 
	0xba48e7d8, 0xf71bf7d2, 0xbc59f8ab, 0xf713a5a1, 0x5117e3d8, 0xd78897da, 
	0x0b4dcc8a, 0x87cafef9, 0x1bdf03a6, 0xd871763c, 0xefc8f461, 0x798fc070, 
	0x10e9a973, 0x2603083b, 0xf113dba5, 0x8ec3f46b, 0x8a85a7c5, 0xbbe4ff83, 
	0xcb1f8b88, 0x7c5df83e, 0x9a08cc37, 0x27080703, 0x2066180f, 0xbee92dba, 
	0x2a638641, 0x6b8b75ce, 0x6f873de5, 0x19dd3d0f, 0x15d4a01a, 0x8fde2efb, 
	0xe44ed671, 0x17ef49f5, 0xaa748dfd, 0xdcefe4f6, 0xa353586f, 0x7d3e8fc4, 
	0x29f10075, 0xd419f9fb, 0xf7d2766f, 0xe701c853, 0xe7f4e473, 0x48603db8, 
	0x4a6f0bed, 0xa4607bb4, 0x19e05421, 0x3719ce7b, 0x0aeb16f4, 0x3f20b799, 
	0xf9c369b8, 0x89fa076c, 0x397f941b, 0x8cc73ea9, 0x77b725b4, 0x90cde5a5, 
	0x3bbf9229, 0x26150c18, 0x0ab2dfc7, 0x748c77e4, 0x088f38a4, 0x7e590a87, 
	0xeb9ca47b, 0xf21e52b7, 0xabf2901b, 0xa57aa9d7, 0xa82ff407, 0x3903d2bc, 
	0xc80ebcab, 0xa9f91653, 0x8fa2ffb8, 0xbbfa4268, 0xe5c3d696, 0x131fd696, 
	0xacbb5822, 0x1fe24f56, 0x90f785d3, 0x113b356f, 0xfbb9c237, 0x79ef8b71, 
	0xef3f87ed, 0x0df7caf6, 0x90b58944, 0x32c54bf7, 0x2397981e, 0x4a51c8f4, 
	0xe1e4f79b, 0x28f1ab3b, 0x0d381f3d, 0x5a87971f, 0xa28e9ef8, 0x1cb1e3d3, 
	0xe6dec7d0, 0xbeb6bce1, 0x9ef57cb1, 0x758ed03f, 0xda27dbcc, 0xb7ef17c0, 
	0xd741dafa, 0x19bdb9e8, 0x22bce073, 0x81cc697b, 0x729e927b, 0x335e80e1, 
	0xa1af527c, 0x9bed41bd, 0x335ea56b, 0xfbcc7ed4, 0x95ddab2d, 0xb7639e5c, 
	0x1337dab7, 0x17cf471d, 0xf7081dfc, 0xf9c0e178, 0xab0af78e, 0xc32fbd5d, 
	0xb9b8b871, 0xebfb6a3f, 0xe0728738, 0xf18790bb, 0x0f67b11d, 0xec409c70, 
	0xa3fde06c, 0xb4cb8fe2, 0xe2308e1c, 0x77f0afa4, 0x0381b564, 0x10ae3807, 
	0x63f43a13, 0x16dbf536, 0x1d367c86, 0x1f28fd40, 0xf642efec, 0xdfd9be28, 
	0x2defb693, 0xb4140f05, 0xf8fc94ed, 0xbf139d40, 0x5f17724d, 0x8fc55fba, 
	0x3dbd04c4, 0xe675b381, 0xcfb8f1a2, 0x249cceb1, 0x7e77a7bf, 0x9f4f674b, 
	0x3ef253d4, 0x21e8e98a, 0x95abeffa, 0xf34451f7, 0xfb171c7b, 0x54f3bbc1, 
	0xac57eb3c, 0x62fc56af, 0xc5fc4a6e, 0xb5756fd6, 0x4acde4f4, 0x2fe9254f, 
	0x41ac3387, 0xb0bfc78f, 0xeb15b3a8, 0xcebaeabc, 0xfbe93f88, 0x5d254bab, 
	0x04c473eb, 0xbae7ec8b, 0xe73a8670, 0xa20ef4b4, 0xa7943bcb, 0xa4783e23, 
	0xeb0dbba0, 0x5b3ef5ed, 0x597e26ed, 0xbc3deab5, 0x919c54e6, 0xfac0cf1d, 
	0x59ce4b79, 0x3de30cec, 0xd51fe22f, 0x739574e7, 0x0415c0bd, 0x1e701dc4, 
	0x1f62fc0d, 0x9dc4f345, 0x2b6f961e, 0xa5f1a715, 0x7edb79f2, 0x302e49fa, 
	0xdc5bb73f, 0xa8fa788b, 0xfbd5307e, 0xf3835e3e, 0xf6c14efd, 0xe71e6452, 
	0xf8a3927b, 0xe57ae917, 0x1fc879f4, 0xe4d295c7, 0xb7f0e588, 0x3a72fe89, 
	0xba774934, 0x298f6a5e, 0xe00e9a9c, 0x4d371460, 0x38dc653f, 0xd3297fd0, 
	0x4f3ecfb7, 0xf88471b3, 0xd4fcfc4f, 0xaf86b3e7, 0xe3a3f6e1, 0x67fa972c, 
	0x7df11e54, 0xbd25c449, 0xa26fb5e7, 0x9d143675, 0xd88340c6, 0x83d665f4, 
	0xd34bfe72, 0xe9223c70, 0x85ab7f89, 0x5ce78ef5, 0xc6d8e58b, 0xbd481e47, 
	0xc0b2bf85, 0x94f119df, 0x5e42fad3, 0xdc78d88c, 0xbfc7b257, 0x0b7fb6c1, 
	0xf7213a5b, 0x3b0faf9e, 0x7bacfef0, 0x496fb486, 0xe2be3274, 0x00ce96d1, 
	0xb55729e9, 0x05e6678c, 0x6b46de85, 0xdedcfde6, 0xef30e056, 0x52f7240b, 
	0x3e1f79ce, 0xf7c1fa8d, 0x0f5f3dcd, 0x1cfcbf72, 0x7ca93bce, 0xa5d0e102, 
	0xf9e39fbe, 0xf514737a, 0x5a9d9f68, 0x9554afbe, 0xae3d1297, 0x85f2d19c, 
	0xf803edc9, 0xe7ea0630, 0xe344bd4a, 0x937bb345, 0x2f944bfa, 0x9b9ea69c, 
	0x7675f686, 0xa77dc17f, 0xb7e78feb, 0xbf5ee056, 0xeda5f703, 0xad7cf379, 
	0x2315f3b1, 0x1aa7474e, 0x7b25f117, 0xe6d293be, 0x4496462b, 0xcec77b3b, 
	0xf5f7ca97, 0x2f9d8ef6, 0x6e4c2f95, 0x1a5f3e9f, 0x3a59da37, 0xbe54be76, 
	0x63bd7bf0, 0xfbe54be7, 0xaf73fb92, 0xde703b08, 0x8185f799, 0x693b64f6, 
	0xe32235db, 0x4c523d89, 0x74c2fde4, 0xa9d2767b, 0xe32c3ee3, 0xdb3381f7, 
	0x264f4e33, 0x17d6dae1, 0x7ecc7269, 0x476c9bd9, 0x0f9e715b, 0x76fb89bd, 
	0x66ac9ff7, 0x35c375bb, 0x8f703837, 0xc6533021, 0x936fef03, 0xb261bdf3, 
	0x8d8edefc, 0xe433c5db, 0xa22f39f7, 0x97fb6834, 0x4be97fa0, 0x2fc2bfac, 
	0x02f938ca, 0xbbdf87ea, 0xe39d7c1e, 0xa9995f98, 0xf95bbf4b, 0x1586628f, 
	0xf24fbdc5, 0x9ef03303, 0xef974b84, 0x6b90decf, 0x7c344465, 0xbdfc95f7, 
	0xc22fce3e, 0x73fbb9bd, 0x7abe5c62, 0x7907bc86, 0xa0a4abec, 0x5ab728c3, 
	0xc82fb423, 0x8e1c2e5d, 0xb215e802, 0xba49d7c7, 0x89e692ba, 0x979ebb71, 
	0xc27e63cf, 0x3bd30efb, 0xba608040, 0xbb62df9a, 0x39e0f752, 0x91bb0f32, 
	0xff2b37ec, 0x0d1386f7, 0xa749f0fb, 0xe9ea5aba, 0x8033a284, 0xfba24cf3, 
	0x6662f608, 0x4f2afc1e, 0xfb8f9cb5, 0x3ef97b73, 0x11f95bb3, 0x7bbe34ad, 
	0xd99f8243, 0x8e59f917, 0x741f6a3d, 0x47b5c2ab, 0xf9c60ff9, 0x155bce52, 
	0x97cb46ae, 0xbda51c84, 0xf6b81cb2, 0x58c1ff28, 0x8f69481c, 0x8f00fb14, 
	0x7f66df8a, 0xbb3fad21, 0xc701f3fc, 0x701fd534, 0xde7151ed, 0x29438bec, 
	0x885ef3ed, 0x352f5945, 0x63bdf9f8, 0x69ef0bcc, 0x7d4ccf56, 0x0830c18f, 
	0x9eb25dd7, 0xe1357b71, 0x07e12fb7, 0x838473b8, 0x1d5cd3ef, 0xe7a4ecee, 
	0xdf219c1f, 0x779fb3ab, 0x728a3d2b, 0x5969f77c, 0xf433dded, 0xbafd24e1, 
	0xc82fee42, 0x85fbe4cf, 0xd8e143e2, 0x0f884fb6, 0x99109e94, 0xafc2164b, 
	0xf684b63b, 0xdf006453, 0x2bef0534, 0xbf108926, 0xc77b80b7, 0xbb6a42c6, 
	0x6f68ba7c, 0xb523924a, 0xb2fea39e, 0x0af1eca1, 0xea5c1769, 0x9bfb107c, 
	0xbd04beae, 0xb7719fc0, 0x4fa44f9c, 0x573de3d6, 0xf7d87edb, 0x3757e365, 
	0x3df04677, 0x3acb8586, 0x00fcc9a3, 0xd5efd13f, 0xf77b3bcb, 0xaea5d924, 
	0xe25db39f, 0xd04f6cf9, 0xfa53fdc1, 0xf7f50cd4, 0xa3143e2a, 0xf0f40af6, 
	0xf3124bbc, 0xb13e8836, 0x6d9f413d, 0x6a7d6cdf, 0xe674cbd3, 0x3774e827, 
	0xbbe1e537, 0xaee38cce, 0x3b5f8e04, 0xfeed8e03, 0xcfd34c5e, 0x4b5f8e36, 
	0x8e36cfd3, 0xcfd34b5f, 0xf6ed8e36, 0xdb1c29af, 0xf1c6d87a, 0xd9fa696b, 
	0x696bf1c6, 0xb1c6d9fa, 0xeff3dedd, 0xf39ec712, 0x6ef816fd, 0x330ff8e3, 
	0xd5978e24, 0xb9919d1e, 0xd38e2c61, 0xea81f7f1, 0x173a644f, 0x5a3ebdf2, 
	0x0ecf7c07, 0x36bec7fc, 0xbdbeecae, 0xd61dc00e, 0x9f85b801, 0x3e7c78c2, 
	0x8f1b3b81, 0x0fc3f8e9, 0x01d042fb, 0xaf7a36e5, 0xec3e892c, 0x1df5ed8f, 
	0xef4d95c5, 0x1b578906, 0x879eb6b7, 0xc9fc465c, 0xb7a935ed, 0xdc56cd6a, 
	0xcf55c840, 0x6b3cebdb, 0xa42f94a6, 0xaffb9798, 0xb1d1c631, 0x6f18876b, 
	0x7e69abf1, 0x9c8dc0f9, 0x2f3ca8e7, 0x04cb7da7, 0x1efa95e2, 0x06e7f66d, 
	0xe837b0a3, 0xfecbfc07, 0xfb8eec73, 0x2f4df9e4, 0xcfe3607c, 0x63747df2, 
	0xfb1460e1, 0x25333991, 0xca4fdc9e, 0x6ec03aef, 0x70dd8ec1, 0xb28e3355, 
	0xe701fee4, 0xbed5332f, 0x8e65e4a1, 0x4c0f3473, 0xa8c27de5, 0x8379ea3d, 
	0xff3451ed, 0x507fb91c, 0x1f7188f6, 0xacbc3cc6, 0xfe1fc02f, 0x63c93d0e, 
	0x6435e594, 0xeffec9e9, 0xa841d659, 0x9d78a3f7, 0xabac482f, 0xc51d5c31, 
	0x5a67187b, 0xb938035f, 0xeffb528f, 0xfa94cd16, 0x38e2afcf, 0x700bef3c, 
	0xef1974ef, 0x77e84463, 0x030dcf3c, 0x21d05eea, 0xbfefde79, 0x7e625e71, 
	0xc77da52b, 0x0ce36939, 0xfb3487c5, 0x128fef66, 0xfbcc9071, 0xd3657c64, 
	0x55db73bd, 0xf71da43c, 0x6909ad23, 0xb8f195f1, 0xa668bf87, 0x37acaf8c, 
	0x910cea9f, 0xf5e5f20b, 0x77f085d7, 0xc4bbd705, 0xcf4ef87d, 0xce1719fc, 
	0xc39e7dc4, 0xd0365141, 0xee1c763e, 0x34d67617, 0xb90bf043, 0x3cf57e9f, 
	0xfd4d5fd5, 0x2ce393bb, 0x7bf8338b, 0xfb3b76a1, 0xd54f6e79, 0xdf94cf97, 
	0x35dbb091, 0xfa745b2f, 0x6e798b38, 0xcbb79e21, 0x0f5814f7, 0x30f20e23, 
	0xe1f71a52, 0xae3279e0, 0x2f2e72d1, 0x9d37c3d4, 0x2120e32b, 0x8781ddf9, 
	0xb0faabd7, 0xb9caffaa, 0xcefcbdaa, 0xaac31eca, 0x18799e81, 0x907b8ff1, 
	0x61fd3517, 0xc1e9aaae, 0xf922a73d, 0x01d0205d, 0x17788bfd, 0x9efcefde, 
	0x780bdf90, 0x03b14e6b, 0x394043df, 0xd60dabde, 0x3b09986e, 0x61b171c8, 
	0xbc3e8fec, 0x2f8efc01, 0xd23d773b, 0x3ade666b, 0xf1dee713, 0x801f9455, 
	0x6e72cbdc, 0xf5daafd7, 0x7233ee27, 0x876aa0bb, 0x71d5cffa, 0xdad8e85c, 
	0x679095c9, 0x2c757edb, 0x5fe12bd5, 0x0f358585, 0xb1dc6def, 0xfc3a6dbc, 
	0x9f5bf246, 0x13f752e8, 0xc44f9ff2, 0xe5b66ef9, 0x29e9b32d, 0xefbecce0, 
	0x6478b9b0, 0xd3d6d941, 0x3e9725c4, 0x7058fecf, 0x7fe934ce, 0xfb1bf9ed, 
	0x90f0ff63, 0x64b8d8f8, 0xcccf6d5d, 0x9506f794, 0x1bfddb3c, 0xd66e4493, 
	0x37fffa10, 0x47edbfee, 0x32dfd92e, 0xf7e38f79, 0x8f1e3e2d, 0xa64c23df, 
	0xcf8fc0a7, 0xa647088c, 0xd73880e9, 0x93343ed5, 0x43990ae3, 0xc3139611, 
	0x6a61d7be, 0xd178ab90, 0x9f31d69f, 0xe7aef3fd, 0x1b4a8e74, 0x3875a528, 
	0xd1e8f4aa, 0x47be350f, 0x27dd5478, 0xa7d2b9fc, 0x5eb7a531, 0xd62974a1, 
	0xdf66bc75, 0xbef831bf, 0x05fd6674, 0x7e8e67f0, 0x2fe1b228, 0x915a9b1f, 
	0xa9f9f58d, 0xbdaabbf2, 0x5db1c311, 0xb5df97b6, 0xefe48cb6, 0x0efa575a, 
	0xed77f0d7, 0xa2bf6740, 0x73071933, 0x0de99e64, 0x5e2f1d8e, 0xb87da9a2, 
	0xff1ec7a4, 0xf75333c7, 0x4425d5b5, 0x3a58c147, 0x74fa529e, 0xe7133d0c, 
	0x50a6db45, 0x371e937f, 0x224a3bf8, 0x20b91356, 0x574d9f41, 0xa6d7eaa5, 
	0x356e946f, 0xd787da1f, 0xa3fd3ee0, 0xe2f10718, 0x19fe54b2, 0xdc14bdea, 
	0xe27852f3, 0x5f44a0fb, 0x03de4ba4, 0xf51bdf96, 0x9657fdc9, 0x2ee48fda, 
	0x0aac8af5, 0xbe1efbac, 0xf41b9627, 0xcb0acfef, 0x934a3a7e, 0xbd064fee, 
	0x1cbf5dfc, 0x6c6fa033, 0xf8eefec2, 0xe3e51acd, 0x423dea4d, 0xd3a20e75, 
	0x11ffbc38, 0xec57bef2, 0x1cef8976, 0x55df071a, 0x51fd35c9, 0x2cb8f20b, 
	0x5427df24, 0xbe7b0df1, 0xf44b4bb9, 0xac37e84d, 0x7d649bea, 0xf117d2a6, 
	0xf075a1da, 0xe8cf7063, 0x14497274, 0x7322fdf3, 0x93cf016f, 0x54df03cf, 
	0xcea159f2, 0x032f2105, 0xeff82791, 0x3dbfa06f, 0xeeacf249, 0xf49d1d1f, 
	0xded382d1, 0x39480a97, 0xcd73677e, 0x667fba27, 0x6d5d6dcb, 0xbefe2cc1, 
	0x4752c76d, 0xf70be435, 0xfcdfa8d0, 0x13ef963b, 0xcf527d72, 0x79e45a73, 
	0xb4bb6f8e, 0x14efa2ef, 0x07f8f3cb, 0xb15ddfe4, 0x489ec9e9, 0xfb0fdff2, 
	0x6d8e5826, 0xf5abadf9, 0xc33c82cf, 0x2bd3e1ee, 0x23c72822, 0x7410b57d, 
	0xce789d1d, 0xdb2f1077, 0x32edbeb2, 0xc2a88f15, 0xe276d9fa, 0x380fb54e, 
	0x550d8df6, 0x7e8492de, 0x57ac33be, 0x27a10e41, 0xe2557df9, 0xbfe3be3f, 
	0x4f1da6f5, 0xd0843be0, 0x4c7bf887, 0xeb07e57c, 0xf83ff4b1, 0x938ed7fe, 
	0xc3b74c15, 0x92279b1b, 0x6433a5f4, 0xc66e0f4c, 0x384ae5f7, 0x9d2e0acd, 
	0x9ce9173e, 0x3cde9ce5, 0xd8f3c433, 0x82f9ffed, 0xbbabd23a, 0x5383feab, 
	0x4f943edb, 0xc7dddf96, 0x57ace97b, 0xc38ec9f1, 0x3d42defc, 0x16c389c7, 
	0xe9c14f7f, 0xa0e828fd, 0x9672bf75, 0x3abcefe0, 0x1ef84b0a, 0x7a4f3f23, 
	0xa4b3f3ea, 0xfeae55ff, 0x6658875e, 0xb413fdf1, 0x2d19fe87, 0x5eb4b21f, 
	0xf68a5e55, 0x697caab9, 0x282bfb6a, 0xfe5f3f85, 0x205f1969, 0xc1ef8aa7, 
	0x9767f68c, 0x3df6969b, 0xb434dcf5, 0x67f5573f, 0xc3fa5346, 0x4df402b9, 
	0x7dff6eb9, 0xb803989b, 0xbce93a38, 0x7ad9f856, 0x69bedfd0, 0xe0e0f988, 
	0x9e508ef9, 0x6ea738e4, 0xe7b672e0, 0x1347297e, 0xb475fbd5, 0x53cf7cfe, 
	0x065d615f, 0xf7ef1fbf, 0x8d3bacc3, 0xfd15b152, 0x3677d5f9, 0x2efd7c8d, 
	0x151233dc, 0xccfdadd1, 0x1323b657, 0xc0d7e8de, 0x5259e6df, 0x432bb9ef, 
	0x41bf49d7, 0x8de1338e, 0xd7de0650, 0xba21cac8, 0x36ac8e89, 0xbe108fda, 
	0x5d7765dc, 0xd6577d8e, 0x83df3f5c, 0x7df2c3d4, 0x1fc5238e, 0xfc95cd45, 
	0x4d5a4277, 0x654e53c2, 0x5bc2d56c, 0xe5c05d24, 0xbb496797, 0x9cdfba31, 
	0xf78ab23f, 0xab037503, 0x95d44fb0, 0xfd87d1fd, 0xbfb8add1, 0xefd41c34, 
	0x54e53d22, 0x11cf4876, 0x5bd9474c, 0x6efe1ac3, 0x6472bb99, 0x3edde615, 
	0xe25bc64b, 0x27ee11fe, 0x9852543e, 0x09df7e81, 0xb8034615, 0xa0d01b4f, 
	0xb1b99dc7, 0x476fec7a, 0xddc632f5, 0x34a39ea3, 0xf4f9c547, 0xe9e78b36, 
	0x3970315a, 0x8584ef9f, 0xfee329d6, 0x5caf708b, 0x2ade5aaf, 0xfe16ec92, 
	0x3d745c46, 0xf58a33cf, 0x3c96647d, 0xaf03765f, 0xb84f784d, 0x83dc12e9, 
	0xcefb51ce, 0xe2538107, 0xff1d8e43, 0x57ef265b, 0x33ec39e1, 0x8487cb46, 
	0xb1caabd6, 0xe3b1ccef, 0xdb534b82, 0x87eb1f7f, 0x67fe3b7a, 0xa3577bc9, 
	0xa6e5d9fd, 0x9ea7bed0, 0xc733bec3, 0x8e9a0b8e, 0x7f20fe94, 0x48769efc, 
	0x4fd72fe2, 0x43f25069, 0xe2501f7e, 0xc7c4e8e3, 0xd3f782a3, 0xfa97de54, 
	0xee2b5dfe, 0x044479cf, 0xbc7ae6fc, 0xfc2946e3, 0xf2adf736, 0x071b187d, 
	0x91e3e4fa, 0x57be5e92, 0x5a69797f, 0x506df73f, 0xfbf987f5, 0x3d6f5acd, 
	0x7fdce7be, 0xc6e32979, 0xf5a1155a, 0xf336aac9, 0xec4e77f0, 0x44efecfe, 
	0x567aebc7, 0x43a71945, 0xf39c27ac, 0xcf92ab63, 0xb93a6cc5, 0x411ff55e, 
	0xe05b84ff, 0xcfd128e1, 0xec8785fe, 0x376a26f1, 0xe1ded425, 0x2fb7a997, 
	0xc0a6eff5, 0x77c5211e, 0xe46fd01b, 0x47bf6aa4, 0xfe400fb5, 0x383ed83a, 
	0xd7a0dfa0, 0x1f7c0332, 0x5f15ee3b, 0x92a838e7, 0x9d43316f, 0xb6df6e73, 
	0xd9397e0f, 0x1db3afd9, 0x7193c91d, 0x93ed411e, 0x38ec2fcf, 0x386fc94c, 
	0xbd39930e, 0xe9efb4e4, 0x6fd678fe, 0xab1d7ed9, 0x5d408968, 0x7c8395e8, 
	0xb6aae2de, 0x5efe4f2e, 0x8384cbf7, 0x80fdf00c, 0x17f19353, 0xde07a7aa, 
	0xbf3b759c, 0x58f8c417, 0x079d7b89, 0xfb21bdf9, 0x797ba6fe, 0x0ff7032c, 
	0x91c4a08d, 0xc2a1fe5d, 0x33bf7dbb, 0x3b5a697b, 0x2d742f15, 0x0acf2d4b, 
	0x5ee35c4a, 0x6dc9fa03, 0x9fffad4a, 0xed2d4576, 0x0003d191, 0x7dc59c78, 
	0xd554780b, 0x673ef0b5, 0x999cccce, 0x03c9924c, 0xc43a8a08, 0x61012641, 
	0x61260180, 0xac066720, 0xfa357291, 0x76ab455b, 0xf5a35aa0, 0x5feac1b7, 
	0xccf5b6e4, 0x3e24c224, 0xb062b018, 0xb180dede, 0xe37b520d, 0xab6c16a3, 
	0xab158827, 0x6dbd4ded, 0x06d7af45, 0xa9b62b84, 0x50356b45, 0x6b5affab, 
	0xf02f33af, 0xffefdb75, 0xecd83ef9, 0xaf7bdad7, 0xed7af6b5, 0xd368f67d, 
	0x271ce885, 0x39692f84, 0xd0859b42, 0x1c3442c3, 0xc88b4216, 0x3969bf72, 
	0xdcb289f4, 0x61a901d3, 0xfbb40439, 0xbdacfe00, 0xd5ca8849, 0xd2113f90, 
	0x77a85b90, 0x509f3f42, 0x5442fdba, 0x682afb40, 0xad4cc5af, 0x3f80b567, 
	0xbbfaf766, 0xa45d3f20, 0xd7485ecc, 0x2c8a770c, 0x32e35bf4, 0x06afd0d3, 
	0xf681cfda, 0x9d07d8ca, 0xdf6a66e6, 0x5bfc0af9, 0x4089f479, 0x0e1098cf, 
	0x59a62a61, 0xc7646e30, 0x7cbecce7, 0x20bbd31e, 0xd284c575, 0x44fd8d59, 
	0xd21fb32a, 0x59953346, 0xa981c427, 0x7187457e, 0x7e38c2e7, 0xc1a5c718, 
	0xe210aefa, 0x02284060, 0x4219affe, 0x1b5fa1d5, 0xefd613ae, 0x6bf5c9f2, 
	0x797146ad, 0x99b7972d, 0xa093e5c5, 0xdcbfd71c, 0x720f2e2a, 0x1470a4fb, 
	0xf6e74f95, 0x395146ed, 0xa87ae2a6, 0x29bd708f, 0x58afac34, 0x4c54e126, 
	0xf7079532, 0x32847e23, 0x4d71c1e8, 0xed093065, 0x0fa2356e, 0x019c425a, 
	0x7d60ebfd, 0x20adcc62, 0xac30b51e, 0xf9d78eaf, 0x84be3cad, 0x8ddadc2a, 
	0xb7682788, 0x01498852, 0xf6c40401, 0x4f0022a6, 0x81ad3093, 0xa7e11176, 
	0x99846b76, 0xf8557c06, 0x8a0a474c, 0x91d9bf47, 0x4207f47e, 0x26f1852c, 
	0xe197bcc2, 0xcadc61bc, 0x2acc50b4, 0x9d5fafa8, 0xcafa82ee, 0x2029d020, 
	0x8c1efdc7, 0xb45cc1ab, 0x007cb86b, 0x69d5af52, 0x81a41f22, 0xdd11c60f, 
	0x902b0d95, 0x7d95226e, 0x7567e71a, 0x5a7e6166, 0xeaaee030, 0x309be216, 
	0x1ce30e8e, 0xf34fc9b8, 0xfe07ad1c, 0x8df300db, 0xfa038404, 0x9fd433ff, 
	0xb28f4058, 0x01d142e5, 0xe84aab0f, 0xebb62574, 0xd3d9d3c8, 0xe98ed25a, 
	0x2e2b6dec, 0xda75e0ef, 0x2f6f2bf4, 0xbee5c7e9, 0x134250a4, 0x47437965, 
	0xb37e9e9e, 0x006ebdb8, 0xe7e6265d, 0xfa86adaf, 0x693a798d, 0x436fb748, 
	0x1c6bfb8a, 0x595337c2, 0x7eaba1c0, 0x97efd3b8, 0x547c45eb, 0xca7b59ae, 
	0xbf8463dd, 0xef589d23, 0x96549533, 0xe3ad03f6, 0x53576822, 0x3edcbfb0, 
	0x7f61ea8b, 0xceae3739, 0x30a4afef, 0xd87dcc9b, 0x03ada036, 0x0689aabe, 
	0xc7fa62d6, 0x7aee8413, 0xbeafc010, 0x22389a6f, 0x993fadc4, 0x3fe04c2f, 
	0xf28a7a11, 0x2b9c4cf7, 0x8fe4cef3, 0xec0edde7, 0x29ac7eb5, 0x0dc423dc, 
	0xc587d633, 0xfea8845f, 0xe6da7c5e, 0x6bd7800a, 0x2af5c02d, 0xff585338, 
	0xc3744501, 0x99c1c434, 0x3491652d, 0x5250dfce, 0xd0c1fe30, 0x0cf132ba, 
	0xd1d1cb80, 0xb6de20f0, 0xcbb21cb3, 0xcede98fb, 0xda4b1d1c, 0x5c58e8e5, 
	0x88e90dbe, 0x2c7472fd, 0xa3a397e9, 0x6e3a41e1, 0x64e8b967, 0x56329e3a, 
	0x0c375edc, 0xa6cbae0f, 0xdc5094db, 0xc29b7483, 0x0cfa7374, 0xa20f8b92, 
	0x3138445c, 0x8b9674e3, 0x70eaba5b, 0xa2e4833c, 0x6edcf1b3, 0xaca6ed01, 
	0xd1e1fb91, 0xa9bc5c9c, 0xf8489cdb, 0x7804bd49, 0xa6f4729a, 0x8fab3d65, 
	0x22538b95, 0x23d4e7e6, 0xf3083e52, 0xf811f278, 0xf7cf3aa2, 0xb8ee9f28, 
	0x2959e113, 0x405367dc, 0x40dd665e, 0xc5619697, 0x4ff9f30f, 0xbc9cafe6, 
	0x2f245a8c, 0x475c7add, 0x8941f4b9, 0xfb0374bc, 0xfe339516, 0xc54375dd, 
	0xb73f4ce5, 0xce5c553f, 0xd87dd2f2, 0x33951774, 0x8c87dc3d, 0x4a0ff2a2, 
	0xcc7ba5e4, 0x32e77aa2, 0x513e0799, 0x3904bca5, 0x8743f209, 0xd74bca3c, 
	0x979271e5, 0x7979407f, 0x3ae5e518, 0x32ebf105, 0x883bfca4, 0x5e48aff2, 
	0xc1ca0a5a, 0x91d74729, 0x018774bc, 0x0f6c690f, 0xe7e81352, 0xe5e514c6, 
	0x80979012, 0x319d6d7f, 0xd25fb9d4, 0xf8e4253d, 0x5717e059, 0xba6c4aa8, 
	0x631b884a, 0xaf6b866f, 0xf2d87c83, 0x6d5c61f8, 0x7987b402, 0xe7ff1c6f, 
	0x909bcd70, 0x37e6533f, 0xb84bfe2d, 0xa7e41566, 0x904ea18a, 0x5fbd5a0b, 
	0x719c03f1, 0x570b199f, 0x6747bb41, 0x3f8b0d1e, 0x957edd23, 0x3c7cbd46, 
	0x75dca3fa, 0x9ddca5f9, 0x77729112, 0x46e8d78a, 0x2d253bb9, 0x95f02ff5, 
	0xe897728a, 0xd3ae34ff, 0x707e46e8, 0xca2a0245, 0x0167d3dd, 0xcebf70ee, 
	0xeee520dc, 0xc80fc06c, 0x94997d79, 0xe4b38d5b, 0x5d30f43e, 0x2443fdeb, 
	0x24b302e7, 0xf1f2ec9d, 0x97e63b76, 0xc7692880, 0x5d6a72fc, 0xb329f971, 
	0x30f57ee4, 0xc8749c1f, 0xe5c7ee2a, 0x48b61f27, 0xca3962ee, 0xbf6e4f5d, 
	0xac9fb716, 0xb5dc910f, 0x2cf48fe7, 0xe46ebb94, 0x6ebfd873, 0xe99ebfde, 
	0xaee51a46, 0xdbadb9a7, 0xc5eb959f, 0xcd65317d, 0x72cb3e67, 0xd6375577, 
	0xe5150cfb, 0xaee587aa, 0xbb96cb3e, 0xe69eff72, 0x0f583d33, 0xc6c677fb, 
	0xeee563b1, 0xbb94908c, 0xd793c233, 0x90291bae, 0xa6db81bb, 0x43bfe009, 
	0x292c007a, 0x4039efc8, 0xd417b6f9, 0xe57bb962, 0x17b0a691, 0x59a2eee5, 
	0xdba006e2, 0x85dc82bf, 0x431d19f2, 0x9a9d7724, 0xd9ca07c4, 0x3c178c2c, 
	0xfd4ee275, 0x9edfec19, 0x351abe42, 0xb7f64744, 0x47a7c6c0, 0x1e7a8e85, 
	0x02f65db4, 0xe6183921, 0x89cb14e9, 0xb6fab58f, 0x5944ff21, 0xdb2c399e, 
	0xb7cdbf99, 0xf4263843, 0x054666b3, 0xd551b98a, 0x40efe612, 0xd6f6af8e, 
	0xe3926d74, 0xf912f2da, 0x7674ff13, 0xc2781ea0, 0xf50b3311, 0x67135b80, 
	0xa901ea15, 0x5599af3f, 0xcc5607ac, 0x2503d52a, 0xb9f44aed, 0x2cf57e5d, 
	0x259dcfa9, 0xafd73cfa, 0x79639f44, 0xcea81ea1, 0xf5b7b716, 0x6fe987f9, 
	0x375c0f5b, 0xcec7da4b, 0x8f697998, 0x3d6d9fe4, 0xdea07a85, 0xa03d429f, 
	0xdaf81eb1, 0xb40f5b2c, 0xb01ea4a4, 0x8dca14b4, 0x3b5f2da3, 0x0ed01e9e, 
	0x9e3edf1c, 0x6ebc0314, 0x3b49e3cc, 0x20b2a46a, 0x9046b4a7, 0xcf2768ff, 
	0x7fb9236c, 0x3777ef37, 0xa441cbf2, 0xdf724183, 0xf4327689, 0x91f7807f, 
	0x1672c7db, 0xf2c2e4ed, 0x3b472e5a, 0x927cb0b9, 0x7689d71c, 0x90796172, 
	0x5c9da3db, 0x89fece58, 0x82e4ed13, 0xee514c72, 0x714fd9bb, 0xeb0d4d66, 
	0xae4ed86b, 0x52686499, 0xf7241bee, 0x728f20ab, 0xb4bd79df, 0x659fef93, 
	0x9267c9db, 0x0c6677dc, 0x3ae32769, 0xb5f7238f, 0xb94a67a3, 0x1f72921f, 
	0xf7246bda, 0x7fb94531, 0x6b93b4ab, 0x2497407c, 0xeb42d3d9, 0x20843a67, 
	0x03df82f5, 0xc9cb5efb, 0xb0d94b5b, 0x906ef10f, 0x5fc0d5bc, 0x5ffcc2c9, 
	0x64e2b966, 0x8b7e8b7d, 0x2b9da0c8, 0x08bede48, 0xf23b13f5, 0x48bb0478, 
	0x17ecff43, 0x727df825, 0x6d6fb496, 0x545d80fa, 0x03e98edc, 0xf9515176, 
	0x6c1fbc73, 0x545d83bc, 0x2fe72fdc, 0x8bfa1a1a, 0x6b3960bf, 0x5b3aa1d3, 
	0x22ec1edc, 0x3392f50d, 0x556ce526, 0xc67f20c0, 0xe2156fc6, 0x2ac7fc0f, 
	0xd3dd1ff6, 0xdd6fb22d, 0xca14fe3d, 0x1f1917d9, 0x76be0fb0, 0x6a526af7, 
	0xa3b4d7a4, 0x76865c4f, 0x7dbf482b, 0xede5d7b7, 0x10cc7759, 0x78c067dd, 
	0x4e0f91d1, 0xae5e46fe, 0x1da57bfa, 0xec8a442b, 0x4eeb5dd5, 0x75b37294, 
	0x69e8e494, 0x79904e53, 0x955fc757, 0xa1772c15, 0xfd5da89f, 0x281549e3, 
	0x79275f4f, 0x7453715a, 0xabe4045a, 0x34ed4c18, 0xbc7f9057, 0x6d93e500, 
	0x95dea2cf, 0xc8a1abfe, 0x6a726a7d, 0xb950b971, 0x4e7ae55e, 0x0e172e2d, 
	0xec1cf3b6, 0x716a7307, 0xbfb8d0b9, 0x5b35fdc6, 0x277f701e, 0x7f7277f7, 
	0x172e2d4e, 0x7177ae2e, 0x9716a73d, 0x77c3370b, 0x2d4e7c33, 0xd73a172e, 
	0xa9cf5ceb, 0xc3c2e5c5, 0x9f0c3df0, 0x85cb8b53, 0x5cbdeb97, 0xe5c5a9cf, 
	0x97e18ca2, 0x2d4e7c31, 0xee3e172e, 0x9cfee3ef, 0xca2e5c5a, 0xf7397fb9, 
	0x72e2d4e7, 0x15f5c151, 0xc5a9cf5c, 0xe192a2e5, 0x4e7c3257, 0x92072e2d, 
	0xee7efecb, 0xe5c5a9cf, 0x57fb8aa2, 0x2d4e7f71, 0x5cd5172e, 0x9cf5cd5f, 
	0x6a2e5c5a, 0xc30d7e18, 0x72e2d4e7, 0x6bfdcb51, 0x16a73fb9, 0xdc718b97, 
	0xe7f71c7f, 0x3172e2d4, 0x73c7eb9e, 0x9716a73d, 0x7f0c098b, 0xd4e7c302, 
	0xc75172e2, 0xcf5c75f5, 0x62e5c5a9, 0xc89fc322, 0xb8b539f0, 0xf5c09c5c, 
	0xa73d7027, 0x138b9716, 0x0c89fe19, 0xcb8b539f, 0x3fee24c5, 0x6a73fb89, 
	0x8938b971, 0xfdc49ffb, 0x5cb8b539, 0x27f5cc9c, 0x16a73d73, 0x18538b97, 
	0x9f0c29fe, 0x45cb8b53, 0x5c03eb80, 0xe5c5a9cf, 0x9fc33262, 0xb539f0cc, 
	0x73d45cb8, 0x73d73d7d, 0x38b9716a, 0xca9fe195, 0xb8b539f0, 0x7fb9045c, 
	0x6a73fb90, 0xc298b971, 0x7f70a7fd, 0x172e2d4e, 0x69fd71a7, 0xc5a9cf5c, 
	0xc32a62e5, 0x39f0ca9f, 0x845cb8b5, 0xf5c43eb8, 0x2e5c5a9c, 0x037e181a, 
	0xe2d4e7c3, 0xf5c8d172, 0xa9cf5c8d, 0x1a62e5c5, 0xf0c69fc3, 0x7ca8b539, 
	0x1d9265d4, 0x84ba7f89, 0xe2768fec, 0x41d6e680, 0xf52a43d8, 0x0bd9e8d0, 
	0x0d3adfd3, 0xf329e7f4, 0x5275fd1b, 0x643a673e, 0xda1b7a9a, 0x551b3ab5, 
	0xcd20b7d0, 0xb8f0371a, 0xfb7617a8, 0x4fafb485, 0x0137ee37, 0x4e3bf7de, 
	0xf3902e12, 0xbf7039c2, 0xc6db7480, 0x2d37bf0d, 0x7f38c210, 0xfd40f718, 
	0xa7184385, 0xec2e4d18, 0xb6ff6810, 0x9fa8142d, 0x0a66e9c4, 0x98eb6ffb, 
	0xe4473692, 0x75be113c, 0x333d2093, 0xb47b406a, 0xa42f97ab, 0x7187efc1, 
	0x6dbc02d6, 0x75b4e3ed, 0xdb46f3a0, 0x84ab5e18, 0x779fb397, 0x1ae9ab8c, 
	0xbbe7f52f, 0xe8fdd76c, 0x677a2103, 0x01db363f, 0x5a73a27e, 0x6aed71dd, 
	0xe7a83fd4, 0x3733ebf2, 0x81dcfce1, 0x0e7a413a, 0xdf5c7fec, 0x1dcf1bc5, 
	0x468df5c2, 0xa17e72a3, 0xa1af8d28, 0xeb815afe, 0x8bd68bbd, 0x3d70adfa, 
	0x8d2040ee, 0x6f009cf0, 0xa32bf82d, 0xbfecb356, 0x1f08b9a7, 0x6d04ff6e, 
	0x0d19c01d, 0xa2fae545, 0x6e639a51, 0xc9e3bd7d, 0x7d76383f, 0xb9f5a5bf, 
	0xfad87ce6, 0x90579ea4, 0xfbc99e4f, 0xc3908623, 0x7b067e93, 0x4fdbbff1, 
	0xadfff1a2, 0x11509c7d, 0xcf19abcf, 0x158216e1, 0x700bfd40, 0x91ffa8dc, 
	0x38afbdee, 0x6ff56f10, 0x437895cc, 0xaee58d7d, 0x8c0a43c3, 0x87fe9b13, 
	0x12df18d9, 0x5aa963b5, 0x3a2fc81c, 0x99df4f91, 0xd72a27f1, 0x4fdcbed0, 
	0xe134c77e, 0x9a6d7b21, 0x81fefc90, 0x076f3139, 0xe8f5f295, 0xc60d68ca, 
	0x795c0f4d, 0xb9a5d91f, 0x54d24df8, 0xaed16f90, 0x3a3cd2c9, 0xf4855afe, 
	0x667733a8, 0x5c7f1d25, 0xdf9e5675, 0xc4fbf845, 0xc7db83d7, 0xcf66fb4b, 
	0x0cef6407, 0xad1e60fe, 0x501986e7, 0xf541fb06, 0x5f624d5b, 0xff01eede, 
	0x4ac5fc97, 0x4ed0b0b7, 0xf1f1a974, 0x532124d9, 0x8b9c02cb, 0xf65946c3, 
	0x873f002a, 0x8bd78fe3, 0x6dd026e9, 0x3754f330, 0x5bc7f5c5, 0xfef7c89d, 
	0x242efed9, 0xeef4d4c2, 0x975c713b, 0xc5e1fe90, 0xec9bab5e, 0x4cacd332, 
	0xfa34816f, 0xec02f1ab, 0xd0d9caeb, 0x842fea0f, 0x848deabf, 0xc048718e, 
	0xfd81d7cf, 0x3a987800, 0x775d6866, 0x1536f1e5, 0x4f02a3e6, 0x4aec1e7f, 
	0x2faaaf1c, 0x80440e3d, 0x666c18b8, 0x84ceb7f4, 0x7f1195f9, 0x5e3869b4, 
	0x94462e85, 0x63ce3003, 0xd016ede7, 0x5cdca2be, 0xa16cf14c, 0x923abf90, 
	0x168c6289, 0x81d7b9e6, 0x9da24e74, 0xb0bcf805, 0xfe42e8d1, 0x69d7f4ad, 
	0xfb4326eb, 0xaf2ff30c, 0x734f7467, 0xb7e6de51, 0xd1f79351, 0xf607dca0, 
	0xd24dd638, 0xdbc02e2f, 0x09efe89d, 0x9e60efb4, 0xb25f8055, 0xb87f112f, 
	0x4c17c42e, 0xe3c442f4, 0x731e3c91, 0xae3c4678, 0x047a3c20, 0x766b9bf0, 
	0xb7e478db, 0xad4e3c52, 0xc23f7d03, 0x5cba0678, 0xeb8e663c, 0x03ca12ba, 
	0xc7915f80, 0xd78cc5eb, 0x5422a8aa, 0x602efff0, 0x47349ebc, 0xabca33c6, 
	0x85c079e5, 0x0b842f38, 0x83ec1b78, 0x18b370fc, 0x4f3c480c, 0x77e246bc, 
	0x85c3f033, 0xdb203f58, 0x2a7ea185, 0x030f0bb4, 0x9a66bec0, 0x8c57b95c, 
	0xe120ddeb, 0xcfcfaf87, 0xc185fb03, 0xf2ff2a7f, 0xaa23f272, 0x13f254fa, 
	0x847a62a6, 0x624791f6, 0xc0cae8dd, 0x8ccbcbfa, 0xe051acae, 0xf4009c5f, 
	0xf555ba03, 0x76893db4, 0x1e3885fa, 0x226d1b8e, 0xcd45547a, 0xc2526af1, 
	0xeb00fdc1, 0xfbdb0679, 0x0fb4ee80, 0xb40638ed, 0x8ff1e497, 0x7f00ba43, 
	0x462f9078, 0x19ee9987, 0x1f2b2729, 0xea0dfeab, 0x9f36a9a1, 0x9a5bfdd8, 
	0xb12ede88, 0x057c935c, 0x0559fcf6, 0x42f3077c, 0x023617f8, 0x76be705d, 
	0x277fd5ff, 0x7c97ad9f, 0xa6635ae6, 0x9fe4d5d3, 0xff4033a6, 0x3a57671a, 
	0xb9aa7803, 0xc3ad3864, 0x91ccb7c0, 0x8bde62e7, 0x9138d387, 0xa701e5b2, 
	0x39403f1d, 0xca1b365b, 0x47653e81, 0x65aff905, 0xe0ef0bd7, 0x967d4821, 
	0x77d020fa, 0xbdd7fa00, 0x1e5ef405, 0x21e0fb58, 0x0f682fe4, 0x9e196afe, 
	0x78ff011b, 0xd17537af, 0x934e7847, 0xf4add77e, 0x9d3ce6e0, 0xa88c97bc, 
	0xdfec46ca, 0x0ed29af7, 0x317dc2f3, 0x8a85f69e, 0x0c2ca4f2, 0xdbcc11fe, 
	0xb52b361b, 0x52f73a3e, 0xca2f2053, 0x4c7183ce, 0x6e892b8c, 0x8a96e7c9, 
	0x78e5ea7c, 0xffee3f4f, 0xc5efe0eb, 0x5fa1b7c3, 0x48e3b5ea, 0x794bdf9f, 
	0x8db8c7ac, 0x9521e397, 0x78e50cff, 0xf866b4fe, 0x7959ff36, 0x52bcbafc, 
	0x782b817f, 0x39f20958, 0xc2abcc18, 0xb4e284bd, 0x38e99fe8, 0x61f521be, 
	0x0e233dcd, 0x9bc43ecf, 0xf247d4a8, 0xdce6d5f8, 0x957c4731, 0x8299d6f0, 
	0xe28e4239, 0x95ea2a9a, 0xc0f1f9cd, 0xfc85d8de, 0x6bec7a0e, 0x26d14748, 
	0xfd40ebf9, 0xa7a85d84, 0x29b57f61, 0x93df1397, 0x30fc823e, 0xf75135ca, 
	0xb7e2175a, 0x93f07aea, 0xce0f8f00, 0xfa0e6279, 0x933e55ad, 0x6d1592e2, 
	0xe5052d01, 0xcf7e1cfe, 0x56fc42e8, 0x1adda2c5, 0x1ca48bee, 0xce6ceaa7, 
	0xbedf3987, 0x4a3be65a, 0xc9eb75f4, 0xf0f3afa4, 0x3c234e6e, 0x41e80c6f, 
	0x343853fb, 0xdb3defe8, 0xe50a9bce, 0x7c2c5e01, 0xaf1abf6c, 0x46de2b94, 
	0xedfc8d33, 0xeee81d5d, 0xd743e02a, 0xfb89bf1a, 0xf79be6df, 0xd538c8e7, 
	0xcdfe6c5f, 0x3995fbad, 0x25bd7fa8, 0xaf1ffeeb, 0xd90a7c33, 0x2b78a55d, 
	0xc9557f9d, 0xd64aabba, 0xaeebc55d, 0x50bab6a9, 0xaf517bce, 0xac87f960, 
	0xbfacc7f3, 0x4d469746, 0x7fdf60ad, 0x895fce63, 0x11aefeae, 0x7c47d94d, 
	0xe0fc8c39, 0x12d0f9bf, 0x2fafe805, 0x149dbe3e, 0xa26fb528, 0xe6fb26bf, 
	0x49276bb9, 0x11f0e6fb, 0x6d2ff30d, 0x11ded853, 0x469301ea, 0xbc7bb12d, 
	0x3dd9e391, 0xf883b2d4, 0xaa23ce94, 0x0badfaf3, 0xcc4d4ae5, 0x3f12a7de, 
	0x2294f335, 0x7e20d4fc, 0xafd38f06, 0x2985f011, 0x5f9029e2, 0x896ce557, 
	0x0f3beaa7, 0x7582a92d, 0x446b7f55, 0x6a67fb43, 0x6febee44, 0x222939cc, 
	0x247c04de, 0x638f84fc, 0x6ff403e7, 0xcd43f3cb, 0x7e22a6bc, 0x3d50f9c0, 
	0xbebd83f3, 0xf682770a, 0xeacfb57d, 0xa85c80ca, 0x67492e76, 0x19ef482c, 
	0x0f81d2ee, 0xfdf186ce, 0xf7712e78, 0x0da71cb0, 0xbcc169e4, 0x1ca1b3bd, 
	0xcb0d63e4, 0xb71f9053, 0xb920ae0d, 0x2538c5e7, 0x4c1f11c6, 0x78eebed2, 
	0x3c4de418, 0xb495e322, 0xbdefdc0e, 0x6718b581, 0x47ad47fc, 0x0446739b, 
	0x4ce289f9, 0x5b900f38, 0x366ac7a8, 0x02638b59, 0xeae697eb, 0xc9c8fed1, 
	0x07639439, 0x050eef08, 0x39d1e5f8, 0xebb44797, 0x7c901f31, 0xbcbc83a9, 
	0x2213e91c, 0xc770acbe, 0x9bfcbca5, 0xf4806ea1, 0x2a7d39c0, 0x46579bc6, 
	0x9c291da4, 0x9cf02667, 0xb488c2eb, 0xb8e1bc33, 0x9a6356aa, 0x4235e8f2, 
	0xe7911b5c, 0x86eba5a7, 0xe8ca9271, 0x6e7f5fa7, 0xda0d277f, 0xd07f34df, 
	0xc01bd517, 0x0a7d49e5, 0xf39b39be, 0x5b67831f, 0x243ed35e, 0xda49fdbb, 
	0x9cd4d76f, 0x5cacf844, 0x7d234d93, 0xa959fded, 0xc64fa40c, 0xd34f7d6e, 
	0xdce57d3e, 0xf25f72e9, 0x42dd53be, 0x3f70229d, 0xa9f4485e, 0x089ad4de, 
	0xda149912, 0xd447888f, 0xc768152f, 0xb00afdd3, 0x3cd057df, 0xaf8c2cb4, 
	0xf2ef2cd6, 0x95cc9d03, 0x616497b3, 0x1d3374df, 0xb56d7546, 0x03ee7059, 
	0xb26aeef6, 0x9bc64c2f, 0x086f5410, 0xbc515fe9, 0xb92ffc92, 0xbff30fae, 
	0xdafc3bca, 0xebe7683a, 0xfd150b08, 0x37db24c4, 0x16ae12ed, 0xea8aa09a, 
	0x05efff62, 0x2346fff0, 0x0dca5a56, 0x62d6d143, 0xe4150bbb, 0x8663c40b, 
	0xccd423d6, 0x99bf1259, 0x356b347d, 0x2ef8f303, 0x3c6143ef, 0xcd7b7c4b, 
	0xfc4827a3, 0xbc23eeb5, 0x205fae67, 0x5f9422fd, 0x29ff7805, 0xe46dede2, 
	0xc9d491c7, 0xf83f6788, 0xfee99bbb, 0x39e78a93, 0x1c3bad65, 0x07e39051, 
	0x0dcf20be, 0xf0a810f4, 0xf25ebcda, 0x33defc70, 0xe58148ce, 0xc6339c23, 
	0xca7b41de, 0x676612e3, 0x287afe81, 0xe3d7f522, 0xf3871a90, 0x099f59f2, 
	0x89ff614d, 0xf79a5ed0, 0xe49b0fc0, 0x6af707bc, 0x2e4daf98, 0xf56b79a4, 
	0x9028b4fe, 0x50ae65e7, 0x939be702, 0xdd0ac3cb, 0x874d88f7, 0xb03e3011, 
	0xed054cee, 0xdaf25c26, 0xc977c87e, 0xd86f1df3, 0xae26f64f, 0xb663ec8b, 
	0x2cfe3037, 0x10396bf1, 0x9f18879f, 0x505f1b07, 0x8d9d4f90, 0x7ae387c2, 
	0xce8a442a, 0xa76013bb, 0x286f3065, 0x49212f68, 0xf0ca1f91, 0xf244655c, 
	0x64d1fb1d, 0xb32d9707, 0x2efed0ca, 0x28a237eb, 0x8cbacacf, 0x398fe81d, 
	0xf360be39, 0xfc00338f, 0x43cd2575, 0x5d7b75c3, 0x48ab2a46, 0x1c63f746, 
	0xc21683e2, 0x286d378f, 0xfc62a7e4, 0xa614e29b, 0x180465f3, 0x467ce933, 
	0x34e7974c, 0x67193ac9, 0xa91bf51f, 0x31cadfae, 0x1fce6ff0, 0xe615ebaf, 
	0x9227c885, 0x3db96dff, 0x05fda02a, 0x3941af68, 0x48cf0ee0, 0xd46e7cf1, 
	0x0565fc2f, 0x0ef905fb, 0xfd4af7cf, 0x8e8ce77a, 0x085f3c72, 0xabc50446, 
	0xef7f6360, 0x0f78b58d, 0x00fd4ac6, 0x1996ba9c, 0x80688e7f, 0x1c732fdf, 
	0x7f2df84b, 0x0c17e806, 0x81d61bee, 0xbfbf73ce, 0xeb03cdaf, 0xb874ca3a, 
	0x74423cc8, 0x947e99ad, 0x5be1e5fa, 0x96ef8895, 0x3c901f19, 0x38c1c7b6, 
	0xe61b9e2b, 0x87c7ebe0, 0xed2b9aef, 0xe74c8ba9, 0x359fd45c, 0xb5735dd3, 
	0x06f8428e, 0x199687e9, 0x123f7365, 0xf0f8e07e, 0xabf073ab, 0x09757e18, 
	0x9ff3c17c, 0xfb7b5730, 0x01d7e023, 0xc2c789fc, 0xff07393f, 0x727f8624, 
	0x42ab7c09, 0x8fd4ffce, 0xf8e87f9e, 0xdae71bf0, 0x2b986ff8, 0xb738dff1, 
	0xe326ff18, 0xc347e667, 0xfe1f1f0f, 0xe7fcdcbc, 0xf1e7fcf2, 0x841ec3fc, 
	0x15988aef, 0x3e0b3f12, 0xf001be1a, 0xa82c3e51, 0xba47e9db, 0x1c684646, 
	0xb1c68f18, 0xe7f84ae3, 0x62cf5a0e, 0x5c140f5e, 0x3dd1fb27, 0xffc01389, 
	0x5c68f791, 0xd55cffb8, 0xf3a3afd2, 0x9d9fb921, 0x19c6b728, 0xe7810e32, 
	0x3fb4234d, 0x8a68d70d, 0x4edfbbc0, 0xe88a5c71, 0xbdb1b969, 0x9f682751, 
	0x374d5a7a, 0x43075dfa, 0x1f785ceb, 0xb48275c1, 0x9e860e8b, 0xa7b96176, 
	0x396372d5, 0x8c3eeff6, 0x73a098fe, 0x78af5b71, 0xf51b855a, 0xdb90c1d8, 
	0xc1db7e85, 0x5c2e99d0, 0x70d5a7a7, 0xab7790eb, 0x27fbbe72, 0x2816913c, 
	0x738a5627, 0x2a45fd0b, 0x87c7989f, 0x2a8e01db, 0xfd45f7b4, 0x82e4d362, 
	0xe3867573, 0x7769d68b, 0x1579016d, 0xf3d7fa80, 0x8caef0f3, 0x8035db9e, 
	0x5cf4747e, 0xd18ad20d, 0xdf14d5a7, 0x95bc44d7, 0x085ea4f9, 0xe6153c60, 
	0xa96b5151, 0xda57d229, 0x7ea0a650, 0x4f903aff, 0x14b57f24, 0x81abc9fa, 
	0xdda1661f, 0x6fefb419, 0xdf214eec, 0xe011fc54, 0xabf7cc6f, 0x94f00718, 
	0x28735e7c, 0x9c4e9943, 0xbc1a92b7, 0x0d948843, 0xe8308a67, 0x943a94be, 
	0x555d80ca, 0x9c0946f1, 0x6a7025f1, 0x2d538484, 0xc20f4e08, 0x34e2bb41, 
	0xd5dccfa9, 0x27f38496, 0x005d5380, 0x49c00267, 0xe547ce15, 0xe704a8f9, 
	0x533e7b0e, 0xadd19c65, 0xe53822ee, 0xca70c5a3, 0x9ce04b6b, 0x97a9f3ca, 
	0xe187b9f3, 0xdc7e3394, 0xe53e72f5, 0x1f7048a0, 0xbbf27abc, 0x52afbc69, 
	0x9ce3bf56, 0x38cbb45a, 0xfa8e5cee, 0xb1b3cf18, 0x9ca0b87c, 0xfd5f25ed, 
	0x5f7b5158, 0xce39df7d, 0x567dc140, 0xfabe67de, 0x7d9c7391, 0x39e6aa90, 
	0xdf11b6b7, 0xbcc14293, 0x4673186f, 0x2dac8f4e, 0x8df367e8, 0xb9ceb54f, 
	0x9fb0b875, 0x2daf8e75, 0x199defdf, 0xf78b9a3f, 0x4f185cbc, 0x38bd3a06, 
	0x64b9b1fb, 0xd267eb8f, 0xea7688f9, 0x927c3ff2, 0xaf10b2b8, 0x34efb8e9, 
	0xa764e85d, 0x5f30ba19, 0x5cb9ebc8, 0xfa1841fc, 0xfa72501e, 0x428c9192, 
	0x7214fb70, 0xb62ac13f, 0xb7dea93a, 0xf9e341c7, 0x86eb8f50, 0x80b9e2f0, 
	0xded5c2e7, 0xbb2bf410, 0x861bcc72, 0xab6bfcb4, 0xc62aa2cb, 0xacb2ad91, 
	0x5fc7da97, 0xd236be24, 0xe986ef38, 0x4f33c7c9, 0xa17a2a52, 0xefb6a1bc, 
	0x98dd99a7, 0x7c3c7726, 0x2c93a41b, 0x9099c365, 0x47011b2e, 0x78f15311, 
	0x23482eef, 0xca5be1c9, 0x1eb2ed21, 0x26b7f6a7, 0x52ef3047, 0x7916fa45, 
	0xf599e69f, 0xdf394377, 0x46ad107f, 0x2318ec9a, 0xf13b429d, 0x3fd2b9dd, 
	0xbdbda63c, 0x1ed0a2bf, 0x4a95a5f7, 0xa1f3dda1, 0x7b7097ed, 0xea14e6e3, 
	0x576b0fb9, 0xbc4e2e61, 0x772d8e28, 0x96e3f199, 0xdc71862b, 0x5c558772, 
	0x1021f78e, 0x7cf7859d, 0x6f4adee8, 0x17c51a66, 0xc62344da, 0x16ccb73d, 
	0x968f50f3, 0x31ad784d, 0xe1f183d2, 0xfdcbf12c, 0xf6b07df6, 0x3b434eef, 
	0x7537f5aa, 0x4dd61ed2, 0x3c04fd05, 0xaa7940b7, 0xaa7693cf, 0x05ea5f3e, 
	0xa3c31cfb, 0x17daffb2, 0x167de28f, 0xcee8ba71, 0x7bff01ee, 0x1ad3f49e, 
	0xbb737d62, 0x24b1be91, 0x7a041b5e, 0x17bb1a06, 0xf6f4ca63, 0x3af63d19, 
	0xd8dfd104, 0xdc9debc5, 0x85f21279, 0xd50f7371, 0x1a4da45b, 0x36735ba6, 
	0xebd20cff, 0xbb7d9793, 0x024bd202, 0x78416f67, 0x8322924b, 0xab9997fd, 
	0x6b5abde5, 0x80bfe772, 0xfc7ef7b9, 0xff324d9e, 0xebc214ab, 0xe08b1b12, 
	0x96ae2add, 0xfb64aff7, 0x53d1f9e0, 0x7a0faed1, 0xafda3745, 0x69f02f1e, 
	0x7e4f40aa, 0xf4efde4e, 0x877b9580, 0xc2bbbfbc, 0xd2207f04, 0xfe8525bf, 
	0x2ddeff6e, 0xc72f502b, 0xe51f867c, 0xd7deff7e, 0xb3dc6157, 0x34acef7f, 
	0xbdae03da, 0x0055de47, 0xf0b94b7e, 0xafde1da0, 0x77ac0bd7, 0x0569280d, 
	0x5607f5fa, 0x530887fc, 0xed02a37e, 0x57d6c5fb, 0xd3ec20c5, 0x8958efaf, 
	0x6f9401ce, 0xab91f2a5, 0xe4396236, 0xc1bf53f7, 0x0ff39fb8, 0xf9c03e71, 
	0x307ed45d, 0xcfb8661e, 0xf581bd73, 0x60bbe095, 0x6df20dbc, 0xfd2b3e32, 
	0x2d7ab138, 0xd63113ed, 0xa573c299, 0x5b2d81f2, 0xf90bfe71, 0xd5ec583e, 
	0x190baf89, 0x4c7ba21f, 0xdd293fe0, 0xdf5cbed0, 0xebb610ff, 0x01ed043f, 
	0x9020797e, 0xfaff2956, 0x2dbe3843, 0x9303ca2f, 0x66ed949f, 0xfc073a51, 
	0x212cf70f, 0x207c80a6, 0x71dd0872, 0x5084e488, 0x63fe0377, 0x9d73a7cc, 
	0x7cd96f52, 0x12f992be, 0xf0f3f253, 0x02becd7e, 0x3de47aff, 0x79bf9bf2, 
	0x35f24b86, 0xe08787f8, 0xce28c9df, 0x46443f61, 0xb193a966, 0x4fc82938, 
	0x9057f822, 0xf5c5903d, 0x5687ea25, 0x7e2f10a6, 0xfa41b1c3, 0xd60a4a99, 
	0xca9c5d19, 0xf05d73ca, 0x626e0033, 0x212ee6eb, 0x4ff21eed, 0xa7893e82, 
	0x3d17bdc8, 0x7dca7089, 0x55fba386, 0x2db7dfc8, 0x8c7d40ad, 0xe4f579c7, 
	0xe914bbf9, 0x8f087a7f, 0x3c41e161, 0x04bd43ce, 0xd77e0bf5, 0xe0957144, 
	0x9d0955e3, 0x06f81638, 0x627fcdda, 0xe9056ee7, 0xcd7ecba3, 0x8a92a6b5, 
	0x5bd43f43, 0xe4fa2fd0, 0x3e899bc4, 0xf581cb7e, 0xc4747ef3, 0x7cdef681, 
	0xcfd35fa6, 0x27229eab, 0x7bf21750, 0x873ee08b, 0x3e68fb02, 0xa3ea0bce, 
	0xb62c354f, 0x05e325e7, 0x707283c2, 0x20ebce01, 0xeb03bbf1, 0xf6573ef1, 
	0x233efc55, 0x0fa017e5, 0xa2e3ff9a, 0x9f687edd, 0xe8267e80, 0x7e2b2694, 
	0xf9c14fb3, 0xde704b59, 0xa930e055, 0xb9773c41, 0xf7effc89, 0xe34b6fd1, 
	0xe53593f8, 0xd03e508b, 0xac3e4710, 0xac596e0c, 0xf7ed8abc, 0x50989187, 
	0x9f4038af, 0x689c9e47, 0x4d9eb9e1, 0xc9e7fbff, 0x3cdf4578, 0x5a3b8f79, 
	0x4aaefb0e, 0x0a7bf888, 0xf98b8bf1, 0xb76f6ec6, 0x5f687ec3, 0xa50ba7fb, 
	0xde67da53, 0x5d5df3a2, 0xf800dd2c, 0xeb2f9ff5, 0xd45e4fa3, 0xdc8af883, 
	0x6006f717, 0x3941bfbe, 0xfa327a08, 0x6434b282, 0x0d9efb52, 0x2be9fe32, 
	0x6a458f8c, 0x4893e24d, 0xca2c8aff, 0xf45b44e1, 0x9d7fbc5d, 0xd614c848, 
	0x5bae2b75, 0xb51f19e8, 0x81dc81f7, 0xb757e5f6, 0x34fa8add, 0x3bd8cd71, 
	0x9d1e20a2, 0x9911cef8, 0x3c53b8e7, 0xde2363b3, 0xea804c2f, 0xe03f6c11, 
	0xe42a1274, 0x60f9f2db, 0x0c6358ff, 0x413704ba, 0xb1d703ba, 0xc1ee87ca, 
	0xe727911b, 0xb730ffa1, 0x072bac0f, 0xb2997dd1, 0x9f8afd19, 0xe970be91, 
	0x88b857e0, 0x0afc8baf, 0x7f685fdc, 0x7727fa46, 0x6d57fde2, 0xace7c4be, 
	0x279d9f9b, 0xe6e795fd, 0x02ef1469, 0xd0fe8715, 0x09c50add, 0x95335e82, 
	0x0897b906, 0xa352aafc, 0xf6b8678d, 0xe7875f22, 0xb1ce2886, 0x39c641ad, 
	0x908437c2, 0x1ff9f23f, 0x52ffe496, 0xfb013ed4, 0x2fc9eb10, 0xe72d61a7, 
	0x2c3bf221, 0x0d4a61d7, 0x738c18f7, 0xc0a5f900, 0xffa248ff, 0xa02fe051, 
	0xc2fe80ff, 0xb81f99c1, 0x888fa942, 0xd2b2840f, 0x119a5a6e, 0xc787c47b, 
	0xc3098207, 0xb844f48f, 0x5478cf48, 0x15bcf078, 0x79fdc3c7, 0xae13e670, 
	0x504e30e9, 0xdf189d24, 0x1bc77bfe, 0xca3c83a7, 0x5670fdfe, 0xca2cb1e1, 
	0xd0b7c3d3, 0xbfe581fd, 0x03cfb7af, 0x23ddbda6, 0x79403ec8, 0xafb9c3f9, 
	0x317f43ce, 0x1b06ffa7, 0xfebfea04, 0x4c7e55c1, 0x6b0d7d5d, 0xefcc4195, 
	0xebfe900c, 0xf289b55b, 0x6585f63b, 0xa2efcefd, 0x01dfec3e, 0x07eb1efb, 
	0xeb2a3df6, 0xf32b9d57, 0xfacb4f0d, 0x5d57a49d, 0xc05eab03, 0x73965cfc, 
	0x55bed6fd, 0x56fd8cc8, 0x03afd483, 0xfec35f3b, 0xb7ebbef6, 0x72c46d56, 
	0x302b7fda, 0xcd2b73bf, 0xd23ecf6f, 0x7dc1ae53, 0x117b62ef, 0x9f214a1d, 
	0x7869eff6, 0x2a54e392, 0x61febdea, 0x4ed0c7d0, 0x929cd8e9, 0x52af6df9, 
	0xa28891bd, 0x7e1fecdc, 0x3db2cff3, 0x6f943dd8, 0x36fa4b5a, 0x1ca23fb0, 
	0x0cf1b4c2, 0x0feccf3c, 0x4c9cfcad, 0xcb02bfef, 0xbd0f6f13, 0x4accf1c3, 
	0x3be25024, 0xa4aade76, 0xde561e7d, 0xd50f7ae5, 0xf2f3b7ef, 0x7cf97bbc, 
	0x4cf1c7c9, 0x379f236a, 0xb05fe8f9, 0xf7de5113, 0x01bade87, 0x2a3c11e7, 
	0x05b7dce8, 0x3d20d7da, 0xf18a84d5, 0xf00448af, 0xefa41af3, 0xc8148e19, 
	0xb6ecc4b3, 0xf223ae2c, 0x7cc54a5e, 0x1bdf693c, 0xbe381d30, 0x945427c7, 
	0x92be0783, 0x647de074, 0xfc9567e0, 0xeaa176ed, 0x149e684b, 0xc9bb2427, 
	0x9efa6102, 0x1f1e33d4, 0x07e86df8, 0xf8470d24, 0x35ff188b, 0xf89d751c, 
	0x4f3c9afd, 0x6a86e8f5, 0x437283ae, 0x31fbc238, 0xd0751d35, 0xe4eaa83e, 
	0x76459767, 0x7038a33e, 0x2851513e, 0x65f36307, 0x07b6cd7c, 0x0a63750c, 
	0x4e7403e7, 0x1bcff9e1, 0x8fe64b91, 0x687d40eb, 0xa377668c, 0xdeee4bde, 
	0x3341fe04, 0xe4ce23e7, 0x3f20bbae, 0xd87969cf, 0xde615bfe, 0xf017f283, 
	0x626a8602, 0x70c9c809, 0x2e24df7e, 0xb766f990, 0x90ccc7f5, 0x4b8da710, 
	0x42c41a22, 0xf7869f67, 0xe397f58d, 0xc702a9ea, 0x933b7beb, 0x6864f2c0, 
	0x6fa46dfd, 0x767b65df, 0xcedf6dd5, 0xf1fa21c7, 0xf61fa45c, 0xb4a9f05d, 
	0x29879e57, 0xd7ed0b9a, 0x1b9e0a2d, 0xb6d3fc37, 0xb1d607b8, 0x68aae586, 
	0xf0fb46db, 0x69ca3397, 0x7fac9a1f, 0xca98a61a, 0xa1a9d04e, 0xcd29f673, 
	0x35db6399, 0x752b76b4, 0xa9a20028, 0xf7094d7b, 0x0bbf3c5e, 0x97fbf219, 
	0x7cd4ccc0, 0x8e01d794, 0x9087233b, 0x65e3b4dd, 0xf97e9bb2, 0x4dda4f86, 
	0xebe930c6, 0xb0f4ee0b, 0x9476901c, 0x81d7ee7d, 0x2ae502f2, 0xc4160f9e, 
	0x527755a3, 0x82f478c1, 0x3bfc3697, 0xa13d3fee, 0x5f047f10, 0x03f740da, 
	0x0b5f0e3e, 0xd671174f, 0xbf6daacf, 0xe89f9d15, 0xcbb49762, 0xbe036f40, 
	0xb64e7e16, 0x92a4bd07, 0x9bb752fd, 0x61b811d6, 0xf5875c8a, 0xdfcfc516, 
	0xf942d4df, 0x24368ff9, 0xd6fcc326, 0x2ff9c937, 0xfa657539, 0xf017c434, 
	0x1963d925, 0xdd815f58, 0xd80499f4, 0xc67c507d, 0x0d12c78c, 0x22339ff0, 
	0x480113fb, 0x5eb0b33f, 0x32fa420d, 0x6633cbef, 0xf1073d1e, 0x2b78e670, 
	0x497e0291, 0xee99b5bc, 0x73e12c4f, 0x9c768101, 0xdda4bfb4, 0x0a4ffe07, 
	0xfcc259c6, 0x1fa6f60c, 0xb94c97cb, 0xdb768fda, 0x40373e12, 0xf1e58bb9, 
	0xda3f0ae0, 0x7ef84b6b, 0x48cbc216, 0xe783dc3b, 0xbadf3638, 0x61ab2ed0, 
	0xfb0eac7b, 0x5da0764d, 0x51cffd05, 0xa2dd313a, 0xb000ee38, 0x0b344d6f, 
	0x075a2aed, 0x90b3ddf0, 0xbfa30e86, 0x86d57602, 0xc6555dbc, 0x3dbb1571, 
	0xeabb43b6, 0x1f57e665, 0x692b55da, 0xabb5c75e, 0x7acbe77c, 0x7646d13d, 
	0x4a3fa2d5, 0x6fe5aabb, 0xf8c73f0d, 0x5338d966, 0x6722594d, 0xf1bd1157, 
	0x21eb669e, 0xff790f3a, 0xc3e241ab, 0xacef9b46, 0x5f5d12df, 0xa4aa6dba, 
	0xf3da5673, 0x6967b611, 0xafbceb5f, 0x867ef077, 0xfe951bd4, 0x40e38443, 
	0x47ba4f38, 0x75679ba7, 0x4d7a433f, 0x873802ad, 0xa776cbe7, 0xbefa4cf9, 
	0x3b9f603c, 0x36b3cdf9, 0x8ab61f20, 0xb087b44e, 0xb921fa1d, 0x25ec8d79, 
	0x6a613bfe, 0xd0ebce50, 0xad9e695f, 0xfe68d7bf, 0x23fc9eaf, 0x2b3bd705, 
	0x11d420dc, 0x32febbb4, 0xb9e323ff, 0x238bc642, 0x50dafbfd, 0x2cbab84e, 
	0xe9e0377f, 0xbc76f9fd, 0x31f36ff8, 0x8f5b942e, 0xf7e30d6e, 0xdfd3355a, 
	0x58f68f9f, 0x8a250ccb, 0xd57edd76, 0x74463d4c, 0xc71bb919, 0x97f850f9, 
	0xe2437c03, 0x3dbbc649, 0x3ff73c51, 0x8a37be16, 0xcc79eff1, 0x7da153bf, 
	0xa42be619, 0x015cd0bf, 0x7d720efc, 0xb8ace0d6, 0xd17f720e, 0x8fe47d94, 
	0x575d1a2e, 0x60f801b9, 0xd959ad51, 0x6b38fc0d, 0x7f3e4df5, 0xe8b05f81, 
	0xf88e330c, 0xf680159e, 0x2a2fd887, 0x32a7e7b0, 0x3f46a6fd, 0x2bdbffc4, 
	0xefeffff7, 0xb724529d, 0x6a55c322, 0xf7ecb300, 0xd130e489, 0x272b5065, 
	0x3c9c7d3a, 0x37ff328b, 0xfe8e7ef3, 0x2acacdec, 0xaf0177e8, 0xc7ded9bb, 
	0xf72a9cc2, 0x86f175b7, 0xf13d24b3, 0xe79c71be, 0x566332dd, 0xb792e914, 
	0x0979e5ab, 0xf9d21fe1, 0xf3ae9b51, 0x3f2e32a2, 0xc6c7da9f, 0x6203fe33, 
	0x3944f77d, 0x629dc62e, 0x075e5c15, 0xca0b9be5, 0xe8bf4867, 0xe37bf602, 
	0x4449df7c, 0xf107fac5, 0xe38ed07c, 0x3edfa084, 0x3c33f79e, 0x5ff982df, 
	0x6b779b90, 0xaa9ce8b4, 0xde006f90, 0xf97e39d9, 0xd9f79e27, 0x1a763ed4, 
	0x325fcfcf, 0xf96d93ef, 0x88be5256, 0x7ae587db, 0xc8ef28a2, 0x8ddc9cff, 
	0xfb1373f6, 0x6cf6b3d1, 0x7803f809, 0x46e77e39, 0x3cd57e01, 0x3daccba6, 
	0x8f4e2913, 0x173ca0f6, 0xb9e2aa5c, 0x73b33077, 0x4d61f923, 0x9a35ce52, 
	0xa869698e, 0xe17d5fdf, 0xd347942e, 0x0bad3184, 0x5e94e3f6, 0x6f1277a9, 
	0xa875dfb3, 0xe72c9889, 0x91358d87, 0x37089d81, 0x242bff49, 0xf19a5feb, 
	0x8927da15, 0xf7ce5cfd, 0xf2b81f0d, 0x6bb82a6f, 0x99077bf9, 0xcfb90fce, 
	0xf1d47d7d, 0xcb9f8166, 0xa7abec7e, 0x7f4594dc, 0x7d4c1e2b, 0xc427d32e, 
	0x76cf1937, 0x33182a7c, 0x4f3718fd, 0xcc1fb2d4, 0xe5474e74, 0xdb3a60f7, 
	0xa46c420d, 0x0f03c07b, 0xefdf89bb, 0x3a3eff3f, 0x7dad1edf, 0x914ce28c, 
	0xf687e95a, 0x8a35ea67, 0xaeae6517, 0x5835bb45, 0xf1dab76a, 0x4143cca3, 
	0x2c13e605, 0x258363b1, 0xc4b06c76, 0xb1cf058e, 0xe9ade49b, 0x42f8c6ea, 
	0x9910db9b, 0xb4ad20a7, 0x0f257ac4, 0xfcd98e7f, 0xec371bb4, 0x5fb64398, 
	0xf40bed0d, 0x95409cdc, 0x885d7ee6, 0x09815d73, 0x3bbec01b, 0x7e7c99d7, 
	0x6a90edc3, 0x03c71b66, 0xdf60329b, 0xcebdadb5, 0x04e5e78f, 0xd9d3046f, 
	0xc02afb9a, 0x0d57e053, 0xb8f9d589, 0x09c1c7e0, 0xfe4bda94, 0x652f48b7, 
	0x7295197e, 0x9229ec66, 0x69fdd727, 0x73bbe51c, 0x9bb62f78, 0xfda470f2, 
	0x912fc222, 0xcf5baabc, 0x822dda70, 0xd3c5ed73, 0x5eb64e88, 0xabf79889, 
	0x4dadd80d, 0xfb04afca, 0xafaae8d7, 0xdd3a21fd, 0x1136ca2a, 0x52be7eaf, 
	0xfaf3c41d, 0x375c2e09, 0x965f9394, 0xf8f20498, 0x0407ca4a, 0x7e794209, 
	0x3cb0f907, 0x749cb697, 0x0d54d5cf, 0x5c5c87f6, 0x4deb26df, 0x1ee8c799, 
	0xe7e45bd5, 0x9f9a7abb, 0x35de4174, 0x8d9e9c2f, 0x497d43f4, 0xe7c18076, 
	0xf285c284, 0xd7af3edd, 0x52cee14d, 0xeb8dd37f, 0x23ece78f, 0x8e31cff0, 
	0xfc8b25a6, 0x61d7f27a, 0x2301f89c, 0xefc1f68a, 0x05bd1e50, 0x0ec6ddf9, 
	0xbb97e7bc, 0xc64076ef, 0x3dfd8569, 0xced36edb, 0xdcf23ebb, 0xcec9f43f, 
	0xf965cffd, 0xefb26cef, 0xd9fc4b97, 0x751c4874, 0x192b9b77, 0xabbf188f, 
	0x9a007197, 0xc84bf20f, 0x06fdd2af, 0x3eb01df0, 0x4d0bf1ce, 0x50d3eee4, 
	0x3898e2bc, 0x3016ccc5, 0x0371f2e9, 0xf53fa498, 0xc031eb51, 0x5f7f01c8, 
	0x723fd56d, 0x7f27403d, 0x1f8e0ae7, 0x215e9940, 0x23cf88d2, 0x9d67e951, 
	0x913e72cb, 0x5c716f5b, 0x388fe6c7, 0x3f2475c6, 0xa1bee7db, 0x0f943ddd, 
	0x8f93d73d, 0x3cbe10ff, 0xc61775f9, 0x35e30a6d, 0x56ffeba5, 0xf3c2169f, 
	0x96073be0, 0x983cf084, 0x382b35e2, 0xd60cf37e, 0x0fd08577, 0x776073bc, 
	0x3f039e48, 0x90aff2ed, 0xfe78cae7, 0x73c7f7fd, 0x4e78a2cc, 0x39e243e2, 
	0x162eff77, 0xdc42bcd2, 0x849fa7f3, 0x707fde7c, 0xdff6077c, 0x842d41a6, 
	0xa7aeea7a, 0x01d21ebf, 0xbb3de6fe, 0xffbf2443, 0xbf02f84e, 0xba3f44a7, 
	0xd09ac8d6, 0xf7a25e30, 0x2f7a25e2, 0xe2f7a25e, 0xe16efa25, 0x7187c798, 
	0x4c8f85c5, 0x78fd15bc, 0x1c812b8a, 0x55f6f45c, 0xbdec0d3e, 0xb86f0ff9, 
	0xebc8ebd5, 0x4a18111b, 0xed839d21, 0x9efb5de2, 0x5c13fe28, 0x71c3bd66, 
	0xc8f4950e, 0x051e7665, 0xd8d7e41d, 0x82bc65ed, 0x0f8051e2, 0xbe5cc39f, 
	0xa7bce0b1, 0xd8ce6ddc, 0x93cb04b0, 0xa76e3bbe, 0xc36d5673, 0x701e5819, 
	0x5da2a2dc, 0xda134573, 0xb736a0c7, 0x063ecf1d, 0xfd4343bb, 0x3c93757b, 
	0xaea64adf, 0xcdf6926a, 0x97684dd5, 0x017ade11, 0x8df3250f, 0x5e37cc97, 
	0x10cbbeb2, 0x4ac7287d, 0xf37771d6, 0xdcf09ad7, 0xba10fd17, 0xa51ed1f7, 
	0xb7c512f8, 0x02514e30, 0x6e325127, 0x44dc64a2, 0xde1f7c09, 0x0df7c073, 
	0xcfb3fed8, 0x4936d7bd, 0xef4ec2bb, 0xb7c93b60, 0x9a0e9422, 0x7e55bd79, 
	0xdf4d386d, 0xc379ed83, 0x3631ef21, 0xfda73f4b, 0xceb7a4cf, 0x1c65d76f, 
	0x9d5dbdbc, 0x30fbe262, 0xbfea3162, 0x6dafb38f, 0x8f6f287e, 0x9126d7a6, 
	0x50ef63fe, 0xf190db3c, 0x9c65e09f, 0x366a7be7, 0xa3db055f, 0xc7c616ef, 
	0xcf386b83, 0x3788a371, 0x6e236db0, 0x19f0248c, 0x34952bc5, 0xdbb9afea, 
	0x99090f37, 0xd0a178a7, 0xe9eb9555, 0xc73b6bdc, 0x90ff2007, 0x1774a768, 
	0x35ca23fa, 0x10bfea4a, 0x145b7dee, 0x01fb97bf, 0x173e3c7f, 0x1f2ab466, 
	0xd36edd47, 0xcfa80f57, 0xc6f3f8c3, 0xbce4f8c9, 0x6034361f, 0xf301263c, 
	0xa14773c6, 0x8d14f11b, 0xccf144db, 0x3a3bac04, 0x941f1858, 0x972f2d74, 
	0x8eff6f76, 0x18911b15, 0x3fa18b89, 0x190d31c6, 0xdd6c8cc7, 0xede9df40, 
	0x7af6926e, 0x18ced4a0, 0x75e880fc, 0xf4833428, 0x37f1884f, 0xa0933daf, 
	0x690e8cf3, 0xd6fed89f, 0x3ef24d33, 0xef2a856e, 0xf47bccdd, 0xc5fa3f41, 
	0xfa9268bf, 0x1c375ca1, 0xef9117e6, 0xfd0049a1, 0x03d7cb6d, 0xb7ae64f2, 
	0x3dc6177e, 0x7d26bc2a, 0x1c6f32d7, 0xf0fc15d0, 0x448e7cf9, 0x4053c6f2, 
	0xd067a65f, 0xbd363396, 0x18e98bdb, 0x7b52f584, 0xd0d7b3a6, 0x6b78ce49, 
	0xe315b84f, 0xed659e1a, 0x98ce5f24, 0xf744d23b, 0xd3d575d4, 0xeabafe4d, 
	0xf4263f41, 0xffe415bd, 0xafbae155, 0x9350fbc3, 0xcd878c55, 0xc49bfdc5, 
	0x20b6f0b8, 0x8778b3ee, 0xda0c5fbd, 0x5c7d362f, 0x2ec8b37d, 0x8f926d16, 
	0xd6377d5c, 0xfefcbed2, 0x063c06c4, 0x83b8e0aa, 0x08f5e06b, 0xf3f1c5da, 
	0xc8687ded, 0xcf425ffd, 0x833ee2bf, 0xda57c479, 0x7e5459e3, 0x9f78dd0c, 
	0x877ff2fd, 0xb736e88b, 0x857e4323, 0x1cfb374d, 0xa3ee2e73, 0x368fde0c, 
	0x374e781d, 0xee8aafa7, 0x45e18133, 0x0fb9a5f1, 0x52f8a36c, 0x7fc67cf0, 
	0xbfe087eb, 0xf7cff183, 0x392b8374, 0xdfbedcbf, 0x6786f52c, 0xe787c059, 
	0x0159fa92, 0x38f48a9f, 0xbf83a6df, 0x7ba1fc99, 0xbc432f27, 0x8ab88c87, 
	0x5fbf2afa, 0xe5fbf3aa, 0x7557d43a, 0x6c52f745, 0xfefdccba, 0x1f842196, 
	0x2fde28ef, 0xe7e23d36, 0xff12fdcb, 0x782b4c8c, 0x907d109f, 0x5fb92b0e, 
	0xc51ba4ab, 0x33fd607b, 0x09f78b9b, 0xf9d2a38c, 0xec8bb1aa, 0x6ace13fa, 
	0x43ad7294, 0xb8ae13de, 0xfb812061, 0x4cff8456, 0xcc91d171, 0x447efce9, 
	0xc9cb3cb1, 0xdb8fbe39, 0xc48de670, 0x2ad6fa77, 0xdf82bd53, 0xa17b03bf, 
	0xf413f0e2, 0xf71d90fd, 0x1df28b98, 0xae049f7c, 0xf89c5007, 0xeeb8a70c, 
	0x9479791d, 0x36f32958, 0x2c665b1e, 0xd1f8c66c, 0x2ddb9d87, 0x00e7966e, 
	0x668d9bd9, 0xcde2b7a9, 0xbc6cb7a8, 0x2dc0c16b, 0xe4a7df74, 0x37ef27dc, 
	0x44ff9f16, 0x436d5577, 0x7575a9b9, 0x60bb53fa, 0x90aa5d3e, 0x08ab32e7, 
	0x7c7ef3df, 0x8abc566e, 0x094d26f9, 0x16caf9e0, 0xa0c157da, 0x0906d4a8, 
	0x4fcef4ff, 0x27d81eff, 0x4895bf40, 0xcc271c07, 0xb42a79f2, 0x18f87dc3, 
	0xc03be7c8, 0x847967df, 0x3ced15fb, 0x3df0f817, 0xf8dd2407, 0x73d13b5e, 
	0xec53d325, 0x67e88e7d, 0x6893affd, 0x7946a71d, 0x102fad1d, 0x2b9f0edd, 
	0x7aca95f5, 0x2b83c6c9, 0x2810f122, 0x30265efd, 0xdf56f04a, 0x71dfefcb, 
	0x8327f1dc, 0x282fdf0a, 0xa6c64efe, 0x851ce87b, 0x670dc3e2, 0x08a9455d, 
	0x0d97be09, 0xe7c9be23, 0xcf0ae302, 0xe7ba4c03, 0xf01e7a5e, 0x738e66f5, 
	0x7fc93b59, 0xcef73fff, 0x2c5371a3, 0xd8ce1a07, 0x71c24ca9, 0x78bde682, 
	0xceda502e, 0x2f700f3e, 0x9e2a72db, 0x01cfe417, 0x2f0fc4d2, 0xf9b9bece, 
	0x9ccaf778, 0xcf71469a, 0x9aebcd7d, 0x91327df1, 0xe493eb05, 0x93b75c99, 
	0x1dfd8de5, 0x37fbf925, 0xaf45ebe6, 0x9bf926e8, 0x5718dd15, 0x910d3a72, 
	0x834bbb05, 0xa62ac814, 0xde9862e8, 0x1645d327, 0xc4d8e3bf, 0x29190874, 
	0xf54f577a, 0x854e949b, 0x8abae13d, 0x0875cb52, 0xf797f3bf, 0x139014db, 
	0x7fca265d, 0x37dc36f3, 0x77d192f3, 0xcede40cd, 0xe4e2e5f5, 0x44f91a46, 
	0xa8aacf3f, 0x6dfbc11d, 0xb1ea0a7d, 0x7da59a57, 0xd04f7de3, 0x6703c83d, 
	0x0ef4a9f6, 0xf7459b5c, 0x22d53dfa, 0xfe96f68d, 0x5087b1f5, 0x72d7e87e, 
	0x661e2bda, 0xff8e5eb9, 0x87d13dea, 0xb4b8ee51, 0x4bdd05e4, 0xe4bc5df0, 
	0xe055b7b5, 0x0bc9783b, 0xf9293f29, 0x9307ca4d, 0x3d3f29cb, 0x23e53b79, 
	0xe51bc3d6, 0x6b45d439, 0x7bbf05ff, 0x4bddf413, 0xe1cb6ad9, 0x66f9f487, 
	0x27fe6f69, 0x135e13db, 0xa6bef1ea, 0xd6e3b429, 0xbb7d73b7, 0x1dfefc71, 
	0x1e61df5c, 0xeb97bebf, 0xc3e3ad7b, 0xfce4501f, 0xc7e5e206, 0xfcf0cfad, 
	0xfbf1c633, 0x6b3eb967, 0xd3963d52, 0x78056e3b, 0xdfc2fd26, 0x0bbe209b, 
	0x1bdebff5, 0xd5f4987d, 0x1033f480, 0x4acf94ef, 0xb6f745fd, 0x4b4f78b2, 
	0x5f757da7, 0x26c3bf33, 0x2425bef8, 0x4f9946eb, 0x7d240806, 0xd66baa97, 
	0x6b1b665b, 0x15eb8434, 0x2bc50704, 0x0bfbc7da, 0xd9bc50e1, 0xbb62f652, 
	0xba5df7ef, 0x7f690e39, 0xe951ae92, 0x065698f7, 0x89ff5278, 0xc6811fd0, 
	0x7af96d87, 0xea10ef6a, 0xb2eb8abd, 0x3dff5243, 0xd979ef4d, 0x6735dffb, 
	0xae501ff9, 0xb6db9bb9, 0xe29fdfdb, 0x6717e77d, 0xa3b9bc4b, 0xdbca0546, 
	0xb97492d8, 0xb6b1720a, 0x3819da5c, 0xbbec148f, 0x8edc5058, 0xf9cb6576, 
	0x5f0fdd2a, 0xd3d544b4, 0xc20e2e90, 0x4d7e047e, 0x8f6ffbe8, 0xc2dde838, 
	0x9435e30d, 0xde070edb, 0xa5ba1343, 0xddff6374, 0xf7e3b755, 0xbeaebe4d, 
	0xb59fc815, 0x6e13c9b5, 0x8c4cfe07, 0x177b5c0f, 0xc91513e4, 0x5e413637, 
	0xe6e4693b, 0x7df086db, 0xf67e24b0, 0x219e9628, 0xe32edc0e, 0x02de6f63, 
	0xceb65bfc, 0xe4937f78, 0xffd6abe7, 0xb8cb948b, 0x9d5f4f4e, 0x5bfd82e8, 
	0xe257141b, 0xa0dac0bd, 0xeb5807bc, 0xdeef2f33, 0xc672698d, 0x5c682a0f, 
	0x90d3f747, 0x5bb4fa46, 0x9d35313b, 0x6a2f2003, 0x56eba263, 0x8df8920c, 
	0xa397285d, 0x5a8e41b3, 0xe2d9df30, 0xe487de0a, 0xa3bee5e7, 0xf6953d04, 
	0xba49efcb, 0x7a2ed8b2, 0xbf09f105, 0x1ada316b, 0xf7e16afd, 0x18cd6ed4, 
	0x7183cfb2, 0x8c35621d, 0xda22f203, 0x7bf1a66c, 0x8cc7ef79, 0xe5205813, 
	0xb79e3db0, 0xa0c03c64, 0x1fe2779c, 0xdf9ecf04, 0xc2cf0079, 0x57a349ef, 
	0xe1b1fca0, 0x08a37538, 0x094fa80e, 0xf0e191a7, 0xb0226af7, 0x296bce58, 
	0xcd47f9c3, 0xef4162eb, 0x7d1c7c0c, 0xd295e14a, 0x78661c49, 0x9fde992b, 
	0x92be9d70, 0x9f580675, 0x5407f6d7, 0xd7fecfd2, 0xb17adfa4, 0x957fbf97, 
	0x92c2bcfa, 0x6f7dd2fa, 0xc47d0d28, 0x8adbfbb8, 0x2b8bcbbe, 0xe0007a46, 
	0xf678f18d, 0x57426277, 0x7d3e113a, 0x47f0062f, 0x97fef914, 0x7de1db13, 
	0xf13f01aa, 0x7a3868ff, 0x45df2143, 0xa3d78beb, 0x73d682e9, 0x78d9fb84, 
	0x94b076a1, 0x80f017a8, 0xe1f314fb, 0xed47ef8f, 0x1d6c4ec0, 0xe515b2d9, 
	0x8ae5d346, 0x4dc2e30f, 0x9b5cf2b5, 0x457041ca, 0xcf6e36af, 0x059efb40, 
	0xf2b71e52, 0x8d745639, 0x2e1efb71, 0x5fe40b3f, 0x1f477f13, 0x9fb64ebd, 
	0x607e9319, 0x07cc87d3, 0xd3e70beb, 0x24e7cf64, 0x0af3c0e1, 0x5faf7f1f, 
	0x1da9941b, 0x687ec2b7, 0x768a61c7, 0x33cf8f8f, 0xbde40762, 0x3bf3df33, 
	0x8100cc1f, 0xea40b3be, 0xc717806f, 0xab0147ef, 0x404e7815, 0xed919eed, 
	0xbcfcbef4, 0x79d31c50, 0x3574fe97, 0x7c232f9e, 0x1e6a6f3c, 0x733de856, 
	0xbfc7685f, 0x5c0e3d22, 0xe01d9269, 0x14554e1d, 0x74e7df7e, 0x06ec6e05, 
	0x41f9d77b, 0xbd7f82f2, 0x3e05e11d, 0x1094f0d8, 0x9db9f59f, 0x3e34e877, 
	0x7ad397bd, 0x73c0b278, 0x1dcce725, 0x168ebef4, 0x316b16a8, 0xf5b7538e, 
	0x270768bb, 0x7bd156f6, 0x5543f13f, 0x6c74be54, 0xf4e51a72, 0x4bb626a8, 
	0xdf10643d, 0x42d374da, 0x07badad5, 0xe3b67f89, 0xf1d1bfbd, 0xbde5dbcd, 
	0xc68ef93f, 0xbb66bea8, 0x9fce77e4, 0xce56f9c7, 0xdb23592f, 0x889df947, 
	0xfac9379f, 0xb3abd480, 0x402f4f13, 0x2fc70ffb, 0xaa084fbc, 0x7de17b72, 
	0x869d2bc2, 0xb67fde57, 0x40fa4c1a, 0x42fbd055, 0x9ed82196, 0xaff21436, 
	0xe1486cee, 0xde94857e, 0xf6ce1129, 0x8e5b8c21, 0x11d7a206, 0x3872dbff, 
	0xaf7c790c, 0xc7209cc2, 0x06c7cfb3, 0x0bef43be, 0x0be980f8, 0x41f739ed, 
	0xf10fbe93, 0x4f7bf176, 0xeaaaeb11, 0x33a2f902, 0x2453dd3d, 0x902c8c3f, 
	0xe3676b71, 0xe0e7ba04, 0x2ca91af4, 0x0cfba5f0, 0x81607f59, 0x4e75b73c, 
	0x4bf7409b, 0x10c6659d, 0xf5938fd5, 0xc5deb887, 0x9332aef5, 0x94ffc1ea, 
	0xc64552ef, 0x507192ae, 0xbf859eb9, 0xe6ec973f, 0xc4376717, 0xe4d7ef0a, 
	0x23b688fc, 0x7ecc47e4, 0xf4d7ef85, 0x91fc85fd, 0xf7936fab, 0x37ba1254, 
	0x82fa4f5d, 0xf96c8bcf, 0xd3ff4a62, 0xe9b12f96, 0x4957d3b0, 0x7ec14e3e, 
	0xf81b7d68, 0x4d521dad, 0xd17d7b25, 0xf45393db, 0x35d830be, 0xbcbce1d9, 
	0x5fb93111, 0xc47111be, 0x2f0bde90, 0x04d1c879, 0x6def2de5, 0xa6e31279, 
	0x6447bcc7, 0xaf5e39cb, 0xdfc13ebd, 0x719ae269, 0x13bf36de, 0x3b5f039f, 
	0x7c8e859b, 0x73e53fff, 0x4393ee27, 0x0f3e00ff, 0xf59e6545, 0x9044ecc0, 
	0xffca5dd6, 0x257f7ca5, 0x3de0f39f, 0xd7973c69, 0xeb69550e, 0xc0f8975f, 
	0x602d2773, 0x4439434c, 0xdc0ae4f2, 0x7e3556ff, 0xa07204a7, 0xd6f1dee8, 
	0xff1cf205, 0xc72902e8, 0xa760d5a2, 0xdcbd3f65, 0x91381a07, 0xfdf96bef, 
	0x62dadad9, 0xa659f979, 0x8a9c25eb, 0x6d10fbd2, 0xbbbe936f, 0x971952ec, 
	0x913fe115, 0x7b78dbbe, 0xcc77d493, 0x5124fa9f, 0x3e241aee, 0xd4ded153, 
	0xe1f9169d, 0x6c6dfea5, 0x8f0967fa, 0x858defb9, 0x71dceefc, 0x99de9bb3, 
	0x3ce4bad5, 0xa4f8de11, 0x70cb5384, 0x5f465cf1, 0x00f1f420, 0x7158f2ff, 
	0x4fbf25fc, 0xd27da35e, 0xdc77d47e, 0x22fbdaf9, 0x9a12fd36, 0xb57f3a87, 
	0x07982a12, 0xd035f8b6, 0x03d716a3, 0x089ed7e3, 0x7d0f8170, 0xc7e1d95f, 
	0x9b8ab6c3, 0x20ebfb56, 0xf2f9a77d, 0xfc4dc618, 0x075477eb, 0x7735ce61, 
	0xe805558d, 0xdf97443c, 0x77cb3635, 0x4ce14ab1, 0xd4aa377a, 0xd29cfb21, 
	0x9327e2a4, 0x093b99c1, 0x372d69ee, 0x39d0dc12, 0x3bde093b, 0xbf041dcd, 
	0xd54d0bf1, 0x7be4ba93, 0x3ad7ecd4, 0xf0047f71, 0x39f0109c, 0xb05bfd81, 
	0xcc5ce9c1, 0xdfb657de, 0x6cbcf822, 0xf2a353b8, 0x4f07ec09, 0xdef4998d, 
	0xf988d4ef, 0xad1f54b9, 0xd3efcddb, 0xce0a233d, 0x64b1ddc9, 0x57140a25, 
	0x814de197, 0x2e5f763c, 0xce98f2bc, 0xb5487e92, 0xbb0fef49, 0xf2ef2b96, 
	0xe71781b9, 0xb4e7f360, 0x074d9345, 0xb95a73d0, 0x095774a9, 0xfdeb2cf1, 
	0xb1effbdc, 0x8c966a64, 0x9f07c5ab, 0xfbf8f591, 0x6e446f10, 0x8ffde18f, 
	0x621b1996, 0x937ee49f, 0xf742363b, 0xed961a8f, 0xa3dc63f3, 0x27df6637, 
	0xe3262bb9, 0xef0cbd56, 0x5e0a9fdb, 0xb7848968, 0x0b6f0735, 0xf0cadbc3, 
	0xe47d8bee, 0x05adc6f7, 0x6fdf60f0, 0x3fb9c1cf, 0x6fbdef26, 0xf83f3867, 
	0x3802f3e4, 0x7becc48f, 0x7cf30f3e, 0x5c61891e, 0x67cf11ae, 0xe3b4bde4, 
	0x227a23de, 0x79c7df66, 0x1f78562c, 0xa088d267, 0x9827aa73, 0xe3d4c93e, 
	0x6a09f70c, 0x0f172d37, 0xa3e977e1, 0x10e9b101, 0x8eed379e, 0xc33bf1f9, 
	0xdea2a9b0, 0x363b1b70, 0xf8e55f22, 0x6ef02ea2, 0xdb5e40ba, 0x81d7a57c, 
	0xf6e1a99c, 0xd24c9760, 0x9f60ff81, 0x57c0bdb8, 0xeefc8cc8, 0x136994f1, 
	0xd2bce277, 0xc80f1931, 0xe426af7d, 0xccef34fb, 0xcf0c75f8, 0x9dfc9cbb, 
	0x37ec4763, 0xda971931, 0x7c71931b, 0x17d29719, 0xb8ef7c17, 0x13371f02, 
	0x48ff7a59, 0x79d14f17, 0x308c8cf8, 0xd9a720bf, 0x579c2265, 0x069f7862, 
	0x97bc19ef, 0x758d77a2, 0xe0a76b94, 0x007d81fe, 0xec9bac4e, 0xf77ecd17, 
	0xc61770c6, 0x672e30b7, 0xf78fabbf, 0x7ef44574, 0xafb5ab8a, 0xdf407195, 
	0x8ebaa2d7, 0x1bae39df, 0x5690fdd3, 0x83dab5dd, 0xdc6b98f7, 0x4d2fa796, 
	0x3087bcf0, 0xbcb01ff2, 0xf43ec047, 0x44a4384d, 0xfb771853, 0xb26bad33, 
	0x9372e32e, 0x45eedb7d, 0x7cf93279, 0xbff45eeb, 0x193d7f27, 0x3cc4a9eb, 
	0x30a79fe8, 0x515b942f, 0x520e0c18, 0x1ad8367c, 0x8f9ff1a1, 0x61ca4dfd, 
	0x155dda5d, 0xda1a621d, 0xf9ab9507, 0x05d3c1bd, 0x5c2943bf, 0x07a08e78, 
	0x249aa7a3, 0x21d70c27, 0xf74ece79, 0x73e22622, 0xafef0594, 0x0de10169, 
	0x75fd8528, 0x7d29ca17, 0x7c0ff43a, 0x48677f7c, 0xae463ff6, 0x1577c88f, 
	0x1265fd9b, 0x8e309fdf, 0x230e9b1a, 0x5f033ac0, 0x51c51689, 0x693d9c5f, 
	0x63f8f1e1, 0xf8964674, 0x44678ac0, 0x83bf1a57, 0xfb885fac, 0x68a6e2b2, 
	0xba1ef4e3, 0xf91db5ef, 0x4cce6c40, 0xafdcbc43, 0xcf077c8d, 0x9f9f2787, 
	0x788dda3c, 0xbf11baff, 0x57b9da45, 0x1dced065, 0xc7bc24e9, 0xfd3ce5ea, 
	0x5ba22deb, 0x4c80f755, 0xc99aee31, 0xcc0ae7df, 0xdc742f0c, 0x5f0e7050, 
	0xce2f47c2, 0x30b0b39e, 0xa2fbeade, 0x6f52d7cd, 0x0afdfb09, 0x9901c4c0, 
	0xde9efa2f, 0xb08467e6, 0xd4ccf89b, 0x7854a39f, 0x9ef32d7e, 0x7bde6597, 
	0xa3bde640, 0xb6f65f32, 0x27bd97cc, 0xf4ddbef3, 0x7be9af5d, 0xfe51528e, 
	0x7f2f996b, 0x0e2be659, 0xa8c57cc8, 0x4dbe57cc, 0xd63955a9, 0x7a1eeb89, 
	0x5539e30a, 0x9df415c1, 0xf26f9567, 0xa9cf18f3, 0xddf15daa, 0xaa43d65b, 
	0x69e644a5, 0x6b932348, 0x9d296a7b, 0x5cfc003c, 0xdda944b5, 0xcf608b50, 
	0x3aa53b20, 0x33d6fe0b, 0x42ee7f78, 0x5ee4cbc2, 0xf4d7953f, 0x31ea2a5a, 
	0x7cb966b5, 0x0ff6cd17, 0x98fcfcf6, 0x2a7673fb, 0xeb76b3bf, 0x7f6b4e78, 
	0x19ddfd6f, 0xbf88585f, 0xe46df1a7, 0x1d68ebd3, 0x9129478b, 0x1aaf9afe, 
	0xa42b58e4, 0x7ef8d809, 0x88ddc37c, 0xdf183de2, 0xe8f7b979, 0xfb7e5de8, 
	0x55509e9e, 0xe515ee85, 0x057df952, 0x97cc55e4, 0xbfbcc2b5, 0x7c4de928, 
	0xdea9a6ad, 0xf7a7e6d5, 0x4fc3355e, 0xf5feee76, 0xe42fbf2a, 0x7cf7f7a4, 
	0x8127dfe8, 0xa26189c8, 0x9eb35bae, 0x14bb62ed, 0x05dbaee5, 0x0c3902f9, 
	0x28ae7cab, 0x1cfa3b3f, 0xd6e043be, 0x905dca4a, 0x8c23842f, 0x28d57ae2, 
	0xf24ad7ae, 0x30f692ae, 0x2fc0ad2f, 0xf6369f74, 0xe07bbe2c, 0xa2b9e216, 
	0x05f21572, 0xabce3576, 0x692aef28, 0xaa2af30f, 0xd5157987, 0x5779256b, 
	0xcadf7b71, 0xdcafb261, 0x17bd0a23, 0x1f4a7e89, 0x858acdf0, 0xe7fabdf2, 
	0x781dfe90, 0xf08a200e, 0xc424718e, 0x09fcdebb, 0xf04a2ef1, 0xfbe096a9, 
	0x61fe35ff, 0xfb78457e, 0xe7074cff, 0x177a2afe, 0xf7966f4f, 0x2e7cf24b, 
	0xd01f51f7, 0xd8740c21, 0xf7c848b0, 0x1b192e46, 0xf305be46, 0x5e7fe491, 
	0xc9f8bc1e, 0x5fdec1e4, 0xb0794a7e, 0xf3c1e48f, 0x885d5e8b, 0xf49e32ef, 
	0x6e8288ee, 0x0e8b2bfd, 0xc3bb442c, 0xf3e0176e, 0x6adf93c5, 0x8f2e3153, 
	0x6ed137f7, 0xb4a1637a, 0xf38b3ebf, 0xfe10efa7, 0xcb95fc9d, 0x27df97de, 
	0x48378e88, 0x6acc75af, 0xa3447690, 0xfe4e6cf5, 0xa5f8828b, 0xd028f190, 
	0x44ff8a97, 0x922fc621, 0xa8ed37f1, 0xf802e742, 0xed1853ce, 0x1296a9f9, 
	0xc3bf43de, 0x25bf86a4, 0xf922fd44, 0xafbd1c2e, 0x8fe111b4, 0x1785db3d, 
	0xf2411401, 0xea1ae48c, 0x4a9d2d7b, 0xfe6b5f01, 0x87d5c2a9, 0x0fe4156a, 
	0x450f21c6, 0x1df7814d, 0x0d1e2fd9, 0x9a05fe40, 0xb0138c9f, 0xfca00c5c, 
	0x9fdf0b3a, 0x46eb6808, 0xb0e35df0, 0x9c7e0b58, 0xff78bb3e, 0xf4a16368, 
	0x5f8411da, 0xd83ffe47, 0x7ce08f19, 0x0f63adf4, 0xfa16f7e3, 0x9de29023, 
	0x3a719fcd, 0x53047d1c, 0x65e83fa2, 0x91f47f7d, 0x74daf7c2, 0xc8523c4d, 
	0xc233884f, 0xfc50c047, 0xa97c06df, 0x959b3a4a, 0x09f7a078, 0x3e585f18, 
	0x67bf8238, 0x1ccaf802, 0xb2bfaf8b, 0xbf86529d, 0xab7882cf, 0x3a15b907, 
	0xf8329d8e, 0x1be7a20b, 0xcf449bc0, 0xcf445db6, 0xfc4f6bc6, 0xcf11f7c8, 
	0xfb1cf5e1, 0x44bc623e, 0x7d1645cf, 0xfc1ebe22, 0xebe4a7d5, 0xd7c922d8, 
	0x5f21168b, 0xf01bfed7, 0x6d7c89b5, 0x7b195e50, 0xbbe74522, 0xaaa5dedc, 
	0x6d7f9c69, 0xbbd6e19f, 0x8cb7dff3, 0xc54dbfbb, 0x16db61ef, 0xc8f3b9f1, 
	0x7db76453, 0x7f985d5d, 0xb5d70d37, 0x2f093ffc, 0x3d4d57ed, 0x1b083dee, 
	0xed3ffe0f, 0xb10ffba0, 0x557100e9, 0x253cff21, 0x547d9ddf, 0x059949f2, 
	0xcf23b17c, 0x0fdf6517, 0xc833723c, 0xe6d53285, 0x0370fc07, 0xe0946ed1, 
	0x864fb2f3, 0x9f1ff14f, 0x625f9f12, 0xe097b67c, 0xe845eaf3, 0x7c5a7caf, 
	0x3cf8cf5e, 0xde93e6cb, 0x2a77e4e7, 0xc22c4e4b, 0x89f831eb, 0x05021e01, 
	0x9fb7d071, 0x2b73dfa6, 0xb91f858b, 0x75d7f819, 0xefd34ad4, 0x15b224d4, 
	0x3ef8036b, 0xaf7e965d, 0x83fbfdcb, 0xb7f7c2e9, 0xe16da0cb, 0xefe984ef, 
	0xc6bc510d, 0xf7f15efd, 0x1fd82ef2, 0xb8bf6075, 0x1d84be40, 0x8c32f2f9, 
	0xcdc41673, 0x21407172, 0xfdb94ae3, 0x685225ac, 0xb0e28d3f, 0x3e386728, 
	0x81b99cea, 0x543808f0, 0xe9538fd9, 0xe42c87bd, 0xe5c69e61, 0x3af7dc8e, 
	0x5a987e85, 0xed0bbbd3, 0xdbf632f5, 0x6467c746, 0xb02cf29c, 0x5ecfd1ef, 
	0x60b2fd2e, 0x5ffa8aa2, 0xec87a87a, 0x3e0f4bf2, 0x2e22f746, 0x79117be5, 
	0x917fbcfb, 0x651f2fe3, 0x516f7f9f, 0xfcb15fa1, 0x3ec98bc9, 0xe5b634bf, 
	0xe4c77c05, 0x3a0ad8d2, 0x5274bcbf, 0xf1dfc55c, 0x5c5974b9, 0x5c577301, 
	0x0fd0fe7a, 0x09efe0ee, 0xfc36df10, 0x6bdbbf9c, 0x34811f92, 0x996d75c5, 
	0xf422c8fd, 0xa0fb2e4b, 0xc097ef39, 0x5eb38f78, 0x4877e971, 0x194c6b7f, 
	0x41fe929f, 0xef586edd, 0x23bd6d4f, 0x20e7bacc, 0xdfd1bd5f, 0x6635f74b, 
	0xf2f894fe, 0x68d6d7d2, 0x821c4dd8, 0xcf099b7e, 0x844d6d74, 0xf0477880, 
	0x872d0879, 0x10ff7a67, 0x882b4fe3, 0x37cf140e, 0xddfb080f, 0x6eafa20c, 
	0xcbac3fb2, 0x7fac8377, 0x2dcbe0ca, 0xb6e7f939, 0x3dfc69fd, 0xab073c1b, 
	0xff68a6ce, 0x90a7d03d, 0xb2dab0bb, 0xddf2ddb0, 0x5fbc4d2b, 0x7e92ea35, 
	0xa29869ba, 0x53ca47ab, 0xc6446f79, 0xfd2284b7, 0xed203d59, 0xeb28d1e5, 
	0xe697be27, 0x5708b7f4, 0xd83bc17b, 0xcc67d621, 0x16a1a3e7, 0x9f343ed9, 
	0x068f38ee, 0x39f6a260, 0x3d3cbac1, 0xf4277fb0, 0x36bbf8d7, 0x82b0b4ed, 
	0xf60b4bf2, 0xb4dde8a5, 0x2773730a, 0xd99eabec, 0x3fbe1956, 0x6c5a13db, 
	0x113eabbf, 0x6155d9f9, 0x277bc76c, 0x573877f6, 0x31131c84, 0xb840f1ce, 
	0x0fef8fb3, 0x581ed512, 0x8b79c5da, 0xabbe5dfa, 0x15e23365, 0xbef788c9, 
	0x2f97feec, 0x7c8cddad, 0xef67f97e, 0x90ef8ad9, 0xf6152cf6, 0xc56ea3ef, 
	0xce7b6277, 0x0ef6b733, 0x53dfe7e5, 0x7156c77f, 0xf1be414f, 0xb7177a44, 
	0x5bdbf1a7, 0x3f71f6eb, 0xe38bb3a0, 0xbc8b5a3e, 0xcde36607, 0xa9ad5e75, 
	0x8a98fbca, 0x54d52efc, 0xe5c89c1e, 0xf3655c72, 0x337ed966, 0xf82bcfe8, 
	0x6b96c41c, 0x7cacbdf8, 0xf157537f, 0x7dfd9b1e, 0x7f0b5d47, 0xef223cbf, 
	0x17feb69b, 0x21828eff, 0x379cb1df, 0x5dfa2fea, 0xd8be9c85, 0xc71674ab, 
	0x41520199, 0x2f35d99c, 0x0539e2ac, 0xed0533ce, 0x5e3328ae, 0x7b2673c4, 
	0x7f840f3d, 0x63cf27dc, 0x79bc9016, 0x644fe960, 0x8880ba3e, 0x72e9e366, 
	0xfbda2ba0, 0xfbc16e90, 0x40436bee, 0x6cf7191f, 0x9b6b7ec2, 0x58de71d7, 
	0xfa43f760, 0x35a9f7fc, 0xd717e216, 0xf24fb03f, 0x7233c0ed, 0xbb480d1f, 
	0x7c001d4b, 0x07f587cc, 0x4bbe6f48, 0xb3e8c476, 0x3f5fc755, 0xfeb737af, 
	0x201b5c5c, 0xa751fc80, 0x0c99517e, 0xbe4797c5, 0xbff3fa42, 0x08e3bd4f, 
	0xaf6d3f7e, 0x5e214bf7, 0xc58eff1f, 0x909f9a97, 0x6916f6f9, 0xed8ab5d7, 
	0x47c4f785, 0x92de76d3, 0x6d352ff9, 0xd18873c7, 0xf5291b8e, 0xf243104c, 
	0x4bc36bbb, 0xe50d3dfb, 0x2df35e78, 0x22d43f59, 0x9e8eabef, 0x9ee544df, 
	0xe90efca5, 0x0bb2ab52, 0x1b0ee9f0, 0x95af7ec2, 0xd167c2b8, 0x659e4077, 
	0xcbbf0501, 0x9ef978f6, 0x67d9874f, 0xfb4d97bf, 0x7bc96439, 0xc54b617d, 
	0xbdfb5b73, 0x936afd54, 0xc7bc8df7, 0x8c8b4f7e, 0x0cf8561f, 0xd07ae73a, 
	0x6573e790, 0x79a3ae5f, 0x9a1ef8b8, 0x9fdf94be, 0x2055836f, 0x1adef99e, 
	0xe15f4cfe, 0xae5b353d, 0xc370003d, 0x985f916f, 0xef815dee, 0x82fc80b0, 
	0x3ebb6576, 0x53ee1548, 0x1fe0d5f7, 0x859ea156, 0x3bec1775, 0xed1d657d, 
	0xbf83843b, 0xeafe17d7, 0x5dcefa2c, 0xf68eaebf, 0xdf90ca51, 0x716855e1, 
	0x97f9779a, 0xddf07aeb, 0x51568691, 0x6ec5df8f, 0xb6bc6432, 0xfd504b42, 
	0xbdfe0d57, 0x863abf85, 0xf299bbf0, 0x6234eea3, 0xbc3741a0, 0x7e715799, 
	0x79e39ffe, 0x9b96feaa, 0xf72f4dde, 0xb916641a, 0x3c4e8daa, 0x85a9bf97, 
	0x9770977f, 0x06affc9b, 0xc9abf43f, 0xaeda3f8f, 0xf7c16c8b, 0x27c43e4e, 
	0x14ac138c, 0xe5306ccf, 0xfdf2713b, 0xefc74357, 0x12f10cf3, 0x7fca4de7, 
	0xbbfb90de, 0xd29eed82, 0x05c0e4f7, 0xfa365e18, 0xb4a5df11, 0x15bdf49a, 
	0x72c3dfde, 0x77e827cd, 0x8ccbca64, 0xeb3f7127, 0x0afa3b1d, 0x57eb79ef, 
	0x7a2be8ef, 0x2eb7569f, 0xc96f78a2, 0x2fb42c77, 0xdf7c170e, 0xe49e2650, 
	0x4cd48c77, 0x6b72b1f7, 0xdf6d8b79, 0xfd3ecc7e, 0x40f53958, 0xe8bbe14b, 
	0x7240305a, 0xa8debf4a, 0x9fc9db54, 0x5a0bbf91, 0xc5676c5b, 0x5cbfe90c, 
	0x5032f2c3, 0xeebbef7a, 0xebabcd00, 0x8f3966a4, 0x79a2ff91, 0x91a3badd, 
	0xbb73b9f2, 0x1b00c01b, 0x750fcbcc, 0xbca0a1aa, 0x902abb28, 0xdf9c0a0e, 
	0xecafcd10, 0xbf3e066f, 0x4bd7fc0c, 0xfbe25eef, 0xf2ced25d, 0xd5ad3c11, 
	0x1fe829af, 0xa53e83d6, 0x85d1e9df, 0xb6627285, 0x3da13fad, 0xd7a31bd8, 
	0x73ee5e41, 0xbb6de607, 0xf26ffcb4, 0x33b948de, 0x92adea9e, 0x13bdede7, 
	0x9d619780, 0xfdf4c3e1, 0x3bab9d02, 0xfdfa3b33, 0x7bc5327d, 0xa13e151c, 
	0xd80dfdd0, 0x609df8a7, 0x17f53ee1, 0x673f1fd8, 0x596eb97c, 0xec2af74e, 
	0x2a5ceefd, 0x97c03f7f, 0x73ddfb94, 0xeb8d25b4, 0x56df7952, 0x7c930cf5, 
	0xe9f86a98, 0x86428f77, 0x70b83f8c, 0xb058df7f, 0x09867bbf, 0x233cf3ae, 
	0xbb8df685, 0xb8552db1, 0xbdfc9dcf, 0x4ee5884c, 0x52ababf8, 0xf3839df8, 
	0xffffb93a, 0x0ae7db9c, 0x96eaa7ad, 0x567e7de2, 0x2ae7dedc, 0x4b8fcfd5, 
	0xfb855c7d, 0xd56ee41c, 0x855333d1, 0x47aabcfb, 0xee2773ee, 0x7bf883f3, 
	0xb2174630, 0xd1b5597f, 0xbdfcfb85, 0x702f1916, 0x571f3ee2, 0xf8e5cfb8, 
	0xdcbcfba5, 0xf85fdf27, 0x0bd09ebf, 0x000000fd, 0x0003ac81, 0x7db59c78, 
	0xd7545c0b, 0x33b9f899, 0x302e6677, 0x33a820e0, 0xa8787548, 0x123258a3, 
	0xbc4d1112, 0x08f8e880, 0x9a349312, 0x8033b774, 0xa8a90902, 0x9a6b1079, 
	0xa0e8033b, 0x09350126, 0xeac5bb68, 0x2da626a6, 0xb756e9a6, 0x4d45e9bb, 
	0x4dad7d35, 0x9fe6adb3, 0x24c41fee, 0x9a5365a4, 0x6e8c5b76, 0x9df7dfb3, 
	0x57866773, 0x7efcabcc, 0x71f7387a, 0x75fbdf1e, 0xd813d92e, 0x631a6d2b, 
	0x29632abd, 0xc9258c83, 0x624e358c, 0xe7631e6c, 0x36300d56, 0x4d8350e0, 
	0x1e0c66bf, 0xc01f7fa1, 0xe147f6cf, 0xda634fba, 0x3e498c9d, 0x52d13d7e, 
	0x197ad414, 0x4f504e4b, 0x49913f53, 0xb319178d, 0x6d41abc4, 0xe3e1b407, 
	0xde1e1d87, 0x03c08f86, 0xe82ebe8a, 0x8c187182, 0x4cc605ff, 0x8c137e38, 
	0x23ac2d87, 0x884f3ef1, 0x532a78c1, 0x7815ed25, 0x8d4ccedc, 0xcfbef015, 
	0xc20e9ac1, 0x2d829e7b, 0x3f85d60c, 0xd7cf869a, 0xe6805904, 0x1967690d, 
	0x27d1cdb3, 0x8b19f934, 0xca55ac63, 0x6557be87, 0x69f187a6, 0x2b05c25d, 
	0xe9a75af5, 0xc66ebd32, 0xa07b94ff, 0x5c35f74f, 0x75ccb30a, 0x6307524b, 
	0x526eaf56, 0x02b61d60, 0x7580e4dd, 0x77f559c4, 0x700cbef7, 0x3b2a77b2, 
	0xf773c0b7, 0xfd4c13ab, 0x9edc22d0, 0xc3953684, 0x32d380cf, 0xfb02ab80, 
	0x63316779, 0x30dd680e, 0xe709c21f, 0xe34396d1, 0xb06664bc, 0x15cfa68e, 
	0xfa05ad32, 0xb195bf3d, 0x1cf8fbbf, 0x98d2dbea, 0x297d8562, 0x7585300f, 
	0x827ac2e1, 0xa6fd60d3, 0x0194aa8d, 0x1dc5b5ad, 0x8bcb86ca, 0xd9522ee6, 
	0x7fff40ff, 0xb831d355, 0x3dabbc9e, 0xb2be00c4, 0x2edfe01d, 0x6d0ad0f0, 
	0xb16df6a6, 0xad35044f, 0x4eb05bf3, 0xc8526159, 0xf5c3ef01, 0xf8ee7a26, 
	0x7839d9b7, 0x08405bc0, 0x266cbc26, 0x220badf8, 0xa71e985c, 0x7eecbac1, 
	0x3ee18e2d, 0x08d4015a, 0x3780334f, 0xe3539f0e, 0x85e3cc18, 0x8c5f6869, 
	0xb3f3e3c5, 0xe2b30754, 0xbe3525fe, 0xc5e3443f, 0x4e8fae6b, 0xc77ac667, 
	0xf5989ba4, 0xdd614ee5, 0x2fb07f48, 0x65e3d705, 0x07dc3d92, 0x64e0dd74, 
	0x74141f8f, 0x53ad26fe, 0xa80df5c1, 0x037ed30a, 0x27a71f5d, 0xf5c15ff8, 
	0x21541f12, 0x68aebe1d, 0x9d7d1f1d, 0x10e81db2, 0x41312fe8, 0x48e9a53d, 
	0x593bc76f, 0x73f0dc39, 0x3d007678, 0xee91fbb0, 0xb9c23ae0, 0xf8375f9c, 
	0xa001e922, 0x7bd21767, 0x3ba09ec7, 0xd3d9efba, 0x31382955, 0x7303674a, 
	0x85685e86, 0x78c00ffb, 0xf5d1f571, 0x66363c58, 0xa3c3927a, 0x5161f60d, 
	0x1555a954, 0x95ff03cf, 0x47d65d22, 0xbf72cdf9, 0x3354c13e, 0x46ff1d3e, 
	0xa446f1d0, 0x3a58fae3, 0x7b1d3956, 0xb8af1d38, 0xdfe39534, 0xf88caefb, 
	0x3599cc1f, 0xfd231d36, 0x07599f43, 0x2be025bb, 0x4c143a96, 0x9f8e90d5, 
	0xeb963a22, 0x0e37263d, 0x085365b3, 0xb20d9af9, 0x6e371c46, 0xec2bc702, 
	0x99d3912b, 0x288cfd2e, 0xe0079559, 0xceb883fd, 0x997c68f7, 0xf566eae8, 
	0x197be0a8, 0xd6103be1, 0xfa89be8d, 0x6a8e86fb, 0x15659130, 0x52f8068c, 
	0x4089829a, 0x87e52c2c, 0x7d010f4c, 0x49829ad8, 0xf1c393ac, 0xe2f7ec18, 
	0xe5d83514, 0x05d4fce3, 0xcc12f27c, 0x7e47ace7, 0x187d8fd1, 0xef9c115f, 
	0xa1afe58f, 0x15fcb163, 0xa1332785, 0x5e4763bc, 0x1afc2335, 0xe1ccdf16, 
	0xe0957e19, 0xe75ffaf9, 0xf045fc1a, 0x123ae033, 0xbee68b9e, 0xe0347044, 
	0xd333f72a, 0xfca6e831, 0x5788a996, 0x3f702e83, 0x2d2f20ad, 0x89b1fa79, 
	0xe5c67eb4, 0x37c71163, 0xd869e3ee, 0x86d15587, 0x84c803ed, 0xf60f23ef, 
	0x2eed7481, 0xfb3f97a0, 0xd866fc7d, 0x59fb123e, 0xf04d31f1, 0x6f90af79, 
	0xd72daf67, 0xb87fc346, 0x3179237c, 0xf1391c71, 0x0e87d477, 0x9181cb95, 
	0xfc5af17a, 0x67e05938, 0xf95e9460, 0x2811f9ac, 0x589fe001, 0x6b7629ef, 
	0xb6d1f9a3, 0xe5099963, 0xa66c9c51, 0xaba28e75, 0xfc02d089, 0x22f588e7, 
	0x4bbd099d, 0xe9e06674, 0xa7d7d2a3, 0xf40c3bd6, 0xbff8690e, 0xfe49de8f, 
	0xee360b2a, 0x950e1f19, 0x7eee5c45, 0x5c7c385a, 0x38def0fd, 0x82f481fa, 
	0x4a17aa23, 0xfe0c9e04, 0x9094f202, 0x41eb229e, 0x9e16abfb, 0xf5fd8377, 
	0xd08a5a05, 0xc37a4c97, 0xc19f2b1c, 0xfce16b6e, 0x12389678, 0x7bd613e8, 
	0x40ffd89b, 0x02d1c36e, 0x5681bba0, 0x3b731e43, 0xe41b206c, 0xe1c92771, 
	0x95760624, 0x7af0e515, 0x65ca2758, 0xd73287d8, 0x842a926d, 0xf214eebc, 
	0x097a09d8, 0xc60e75c6, 0x80d739d8, 0xfd93ee2f, 0x26f87c79, 0x99a299cf, 
	0xdc9c823e, 0xa4e509fa, 0x93f0e515, 0xd1f6dc62, 0x9c0586e3, 0xcd7b8e46, 
	0x1a3edb75, 0xd0693e3f, 0x5bd4a7e1, 0x88671d96, 0xdf386cde, 0x88fd98a4, 
	0x447f0e79, 0xbee6bfbe, 0xbef9503e, 0x864da1b2, 0x1be9ced6, 0xf421d7f7, 
	0xcf8fbb72, 0x77ef0edb, 0xcfde78c1, 0xbf137f60, 0x2f5106aa, 0x4bd7dc8c, 
	0xc67e111f, 0xdf1bc6be, 0x79e804b6, 0x5fb5d222, 0x818ca732, 0xe16834af, 
	0x233e57bd, 0x74144d7c, 0x8c0fd91d, 0x7472f137, 0xd04737bc, 0xc7dd47f3, 
	0x8e8aa3bc, 0x2e133772, 0x258c2c85, 0x0c49f3ac, 0xce65a1e4, 0xedb0c7b9, 
	0x33cee311, 0xe50e7a33, 0x5e19a867, 0x0c14543f, 0x9b2d3e03, 0x815cfd37, 
	0xe7d8bcf6, 0x48dfdfbc, 0xe78db9cf, 0xe1838a4a, 0xef73e8b6, 0x37bd7115, 
	0xa6720421, 0x16d5f607, 0xb7a0644e, 0x912c391c, 0x2a1b4255, 0xfc818c7f, 
	0xb9d7bc49, 0x6cd5f513, 0x07ad2c1f, 0x6ff179f5, 0x3822189f, 0xa3ba3477, 
	0x529ca7ef, 0x98c1ae7f, 0x4e7d886f, 0x79fcea6c, 0x6f18a36a, 0x406df42f, 
	0xa7c67be7, 0xd9fc5673, 0xe85b83d0, 0xa43d88f1, 0x5e3d269e, 0xd7327933, 
	0xa41bea6f, 0x14ef27c7, 0x7d014efa, 0xdbcfcf0f, 0xfa893ae5, 0x62fa6fb0, 
	0xff0d9bf2, 0x585cd172, 0xe22c03d9, 0xa0b5b237, 0x935c61b7, 0x5e109543, 
	0xf9d03f13, 0x05a1b2be, 0xdcecdab8, 0x727e20de, 0xa929f946, 0xa7d3f058, 
	0xce8363e4, 0xf413f023, 0xd9fc569d, 0x749189c8, 0xa70c0f68, 0xd3c0af43, 
	0xb670e8b5, 0xa5c7cf58, 0x64ce8343, 0x94731fa4, 0x0177931e, 0xfd20b61d, 
	0xfa0aae85, 0xc9d2d13b, 0xafe061e7, 0x60fe9158, 0x439981dc, 0x2b600b47, 
	0xe782de03, 0xed162da9, 0x871ed0ed, 0xd7e88376, 0xd436f037, 0x13efafc0, 
	0xbf4467fd, 0x9fef38eb, 0xc76bed14, 0x44b7f5f9, 0xb788707f, 0x4dbccba6, 
	0xcfefccbd, 0x82ef7d14, 0x45f9f36f, 0x34b43b7b, 0x3fd7e8bf, 0xc3d0dbcc, 
	0xde3efafc, 0x2df169bf, 0xcf036f44, 0x275deb88, 0xafb873f8, 0x2eafb12e, 
	0xb12eafb1, 0x57d8af2f, 0x9757d897, 0xec5797d8, 0xcbec4bab, 0x25d5f62b, 
	0xf625d5f6, 0xeafb15e5, 0x12eafb12, 0xfb12eafb, 0x757d8af2, 0x89757d89, 
	0x7d89757d, 0xbabec579, 0xc4babec4, 0x5f62bcbe, 0x4ab9515d, 0x7d8af2fb, 
	0xb289f5c1, 0xd0fd4249, 0xcd07ed37, 0x9337d80a, 0x88df6b8f, 0xc16bf4e7, 
	0x709796ff, 0xa790d97f, 0x7f3d8453, 0xdbc798b4, 0xc02080a6, 0x980f94fe, 
	0xdfdf6b1e, 0x2fe9c258, 0x1df384b9, 0x5c60a5c5, 0xf7c4655d, 0xc95ff026, 
	0xd9f27f5e, 0xdb52a690, 0x6606f18c, 0x74893fe9, 0xb05e5036, 0xb5b3ec99, 
	0x3a062f9c, 0xa6d75f79, 0x603b3d90, 0xfff699d2, 0xa92b4e41, 0xc14f4da9, 
	0x180bcbba, 0xbf06c1fa, 0x59a9bfc5, 0x6e4edf50, 0xfc05ebe2, 0xcf90551c, 
	0xf578c46a, 0xc0dfbc0d, 0x251dd6e5, 0xffd00f9c, 0x675c7b20, 0x5ecb7f64, 
	0xf20edb27, 0xf80d6e28, 0x0e80e019, 0x56a8ecc8, 0x7bd1cf4e, 0x7794eab2, 
	0xdce23ec0, 0x8e24b7fa, 0xfbff4e77, 0x157a25a0, 0x7e71e0ed, 0xb78274dd, 
	0xf5f827a9, 0xbdefa299, 0xd162dbcc, 0xa8f97ede, 0xbe3b41e6, 0xd7c928e0, 
	0xbccebe4e, 0x3e9c43e2, 0x2175c50b, 0xd45d7037, 0x7c217587, 0x4fc22daa, 
	0x87347656, 0x8efaf03b, 0xefc056e6, 0xb85c84b7, 0x316cf790, 0xf3f013fb, 
	0xfcd1ff31, 0x55bef09d, 0x0fe27823, 0x9fc98c80, 0x07684563, 0x92c7de4f, 
	0x7de7c04c, 0x0b5159db, 0x5a7d85ca, 0x9a4ec4e2, 0x4f48c2c7, 0xb94f84c8, 
	0xc1b5158a, 0x795e6b7d, 0x272d0633, 0x760efda3, 0x43b0a4ef, 0xbd9065b6, 
	0x8fe0eccc, 0xbd7c23b0, 0xbc0a0f48, 0x01280d3f, 0xe62fafdf, 0xf7778ff0, 
	0xe27eb57b, 0xcf0cb72b, 0x4fdc664f, 0xe593f781, 0x9fdf44df, 0x6941b0a4, 
	0xc667ae80, 0xe02a675e, 0x4fd461ef, 0xc01fc216, 0xe304ddc5, 0xff707c98, 
	0x4137e839, 0x5f8f9e1f, 0x0e79e20b, 0xe93b0ff4, 0x48a1cbbe, 0xf2f38c9a, 
	0x8aed1de7, 0x3dbde685, 0x93f3e19e, 0x2fc83ac4, 0x2d65bf40, 0x683bf1cc, 
	0x404e0113, 0x3f402567, 0xec17e829, 0x1f3e8b8b, 0xcc2f38c2, 0x95d3997d, 
	0xa7d28b6c, 0x5d918925, 0xd2dbf206, 0x7933f40a, 0xbd1c530e, 0xf7c7c748, 
	0x1e1cdc38, 0xfda18fc2, 0x8e037c18, 0x1fa4cbcf, 0x84277c9f, 0xb581b971, 
	0x8ebf17c0, 0x37c187d2, 0x5f109f06, 0x4bf0c6b5, 0x2fce14c1, 0x62fce19e, 
	0x52fc98f9, 0xbe17e11b, 0x92fc91be, 0xa0c1fb00, 0x92fc78c3, 0xfde2fc80, 
	0x5acbf03b, 0xaf9c0be0, 0xb897e0dc, 0x3ffff412, 0x9624bf29, 0x217b7d70, 
	0xdb09426f, 0x44bf3e32, 0xd3c086e4, 0x50351f94, 0xc780c19c, 0x02313928, 
	0xb4e7c82e, 0xed3b807e, 0xe1c05eb3, 0x08cf86b3, 0x7f15e438, 0x0467c39e, 
	0x38b5803c, 0xf3e1631c, 0x737fec26, 0x8b59eff9, 0xc0404f80, 0x4f8415eb, 
	0x89138d3e, 0x7e50bcef, 0x5195ed14, 0xe5965270, 0x7177bda0, 0x718cd696, 
	0xfd0f1a2f, 0x36b41f85, 0xcf262823, 0x2760eb81, 0x582cce4d, 0xa469fa8f, 
	0xaf2179fd, 0x1fe504a8, 0x27ec872c, 0xf460ae7a, 0x3505f13c, 0x9963ce12, 
	0x768cd9db, 0xa768abe2, 0xcbaa9c60, 0xffe84b21, 0x24602dcf, 0xfff71837, 
	0xa129ce41, 0x9107ae1a, 0xe8bf26bf, 0xa87be10e, 0x4f7f850f, 0xf59150fa, 
	0xf8de38f7, 0xe8bd517b, 0x34f5a3bf, 0xeead43ea, 0x43ea0771, 0x0d0bf4f5, 
	0x8d73d8f4, 0x333d6107, 0xab8c22b4, 0xd50f640c, 0x06eebee2, 0x8c1b8aba, 
	0xbf086789, 0xb47ffd06, 0xf94be3c7, 0xe7825ff3, 0xccaed012, 0xfdd3a299, 
	0xee9bb504, 0x2bf7e24f, 0xef197dc5, 0x09cadf03, 0x9c13ee8c, 0xd55e103b, 
	0x6f38bf1c, 0x6bb78081, 0x332cbc34, 0x581b1cb8, 0x629ad7a4, 0x11faa9fc, 
	0x758ab4eb, 0x5a35e35a, 0xbf94a5a7, 0x8758bf77, 0x9ad3ac55, 0x2c3ad1a0, 
	0x06fdf893, 0xd626df71, 0x47d04b69, 0xc211f3ac, 0xa1a2c0eb, 0xe13ba25a, 
	0xdeb78c4f, 0x44ad629a, 0x79f3f946, 0x7606a77d, 0x41764e7e, 0xe735c216, 
	0x0daad146, 0xda235dbc, 0x283ed12a, 0x6f38ed5a, 0xb0f688f7, 0xb445ff68, 
	0x5f6f10fa, 0xd125ed15, 0x6cb445fe, 0x13b53641, 0xda2d9b45, 0x535b791b, 
	0xfc8954fc, 0xc3c75c67, 0xde1afafc, 0xa20ca082, 0x8df9b0fe, 0xe38f1d7c, 
	0xf244d6db, 0x43162679, 0x70ff0957, 0xd664e284, 0x9e22c939, 0xc02d49a3, 
	0xd02ad62f, 0xbc513d17, 0xcc20bdd8, 0x915c706b, 0x9376118f, 0xdbc88d6d, 
	0x513fa2a8, 0xcd92f8a7, 0x8042d264, 0xde85a787, 0xd415b19a, 0x833f8c15, 
	0x3ae8df69, 0xd84b9517, 0x01c8c6f7, 0x80768a24, 0xed3a8cfb, 0xb427608e, 
	0x181ddaf9, 0x7bd632ef, 0xccdfa369, 0xd66f1f00, 0x02ab12e8, 0x4ea799f9, 
	0x3121fb40, 0x58b1f8ef, 0x002d637d, 0xae23dafa, 0xeb2de11f, 0xe707ee8c, 
	0x4038c469, 0xf4038c01, 0xf7085893, 0x12bc108f, 0xfff446f4, 0xd3e404b4, 
	0xf22e60eb, 0x02595b33, 0x89d421ea, 0x809a8e22, 0xb8d158f2, 0xbfd8699f, 
	0xed1dbef0, 0xb74f784e, 0x4ce4fc02, 0x77231db7, 0xd1f76e03, 0x76c9f5d8, 
	0x5af98096, 0x535ce819, 0xa0f28e60, 0xfc78af81, 0x2822badf, 0x9f12a5f0, 
	0x276cf1c8, 0x4cd64ffa, 0x16b5b79e, 0xe1daf918, 0xf60db47e, 0x1cf6768d, 
	0x377646bb, 0xeb0c3be2, 0x29aa3d51, 0x055ffc2c, 0xbfb646f5, 0xeffa0e38, 
	0x57cf0c94, 0xb24b95c5, 0xff30f304, 0xfeafc8cf, 0x7893b3c5, 0x43dfd89c, 
	0x57fad779, 0xb1b88be6, 0xb12f2c36, 0x253bee68, 0x4ee8fcc3, 0xa37ba3f0, 
	0x95ecf47e, 0x4f088217, 0x208ecaeb, 0x31fdc22b, 0x1aeb0fa2, 0x7e0ed82d, 
	0xf012d25d, 0xefbf9125, 0xce1d1172, 0xd27f504e, 0x9e64fb0e, 0x30ed89b5, 
	0x44fca79f, 0x6ee893a7, 0x25dbe701, 0xbdb7eedc, 0x510c18df, 0x8849953c, 
	0x138acf07, 0xc23d1e9c, 0xe0bdd95e, 0x1623fa28, 0x076c4b1b, 0xf254bebc, 
	0xcc4ebe37, 0xa11c618f, 0xf5c411d0, 0x6c113581, 0x13d83f41, 0x3c0ebbc1, 
	0xe2817a80, 0xc71718e3, 0x7b274d7c, 0xa7e45e3d, 0x7c6e3fa9, 0xc663fcbc, 
	0xcc7e61c7, 0xe5e3446b, 0xf4f587d0, 0x0725abfa, 0xd551e00c, 0x0e01a7e3, 
	0x1d9a8a6d, 0xfde3e36a, 0xca7803e0, 0xc064921c, 0x878044cb, 0x1bfefd03, 
	0x5b4f4887, 0xe20bfae6, 0x826e897a, 0x94afb348, 0x9b612da4, 0x93418eb0, 
	0x40f286be, 0xc510a5d1, 0x820a8a4f, 0xa781b700, 0x13ff72ae, 0x9dfe079f, 
	0xfc25e305, 0xf61fba39, 0x8190eca4, 0x9cf164de, 0x0f8d3ef1, 0xf9e133b7, 
	0xcfa2f794, 0xe6b0fb19, 0xd8240bfb, 0x73725fd7, 0x203fa096, 0xb4932d0f, 
	0x738f2889, 0x4ade5097, 0x79b767c8, 0xc061c91d, 0x6f0807cb, 0xae29d337, 
	0x30f68fde, 0x87c199d2, 0xc63a180e, 0x953e020e, 0xc1365f10, 0x6149036f, 
	0x7ee1c72e, 0xbfcc2e13, 0xff9f072b, 0x0aa777ea, 0x67ed55ba, 0x78671f81, 
	0xca27245a, 0xa427199f, 0xb5b36c74, 0xbe142743, 0x7ec2bfdf, 0x2c95d7dd, 
	0x8dec6291, 0x4397ec81, 0xb645dc46, 0x3ce9f3c2, 0x11633abe, 0x886767b7, 
	0x4ae7d0b8, 0xfdfd5db9, 0x3dd76e52, 0xb1d86a5b, 0x9985ec8c, 0xc60e695e, 
	0x95e60ea1, 0x3df9412f, 0x0e7ba0ab, 0x298e71d9, 0x6eb63b6c, 0x47f28735, 
	0x20e70f5f, 0xfc273d7d, 0xc96ce661, 0x179e2071, 0x16b88a66, 0x78f95a93, 
	0x6f180e39, 0x6f3e12ed, 0xf187cc0e, 0x45055992, 0xe04f0839, 0xb1ef8a77, 
	0xda30b3cf, 0xc7b99e43, 0x0bba9e49, 0xfd58acd4, 0xd19dfee0, 0xe5c46947, 
	0x6eb825c6, 0x07c6a459, 0xcdc54e41, 0x8404d305, 0xf73b6cc4, 0x01ff88bb, 
	0xc8fcee9e, 0x638e0a38, 0xfe12d7c4, 0x609146a1, 0xf0971b5d, 0x6a66737c, 
	0xe5ea58a0, 0xae15a672, 0x68eb85ef, 0x19c7312f, 0x65fa3392, 0xadc1472e, 
	0x7187e92b, 0x44d9b732, 0xb5335afc, 0xed7bf807, 0xd2b970af, 0x10f2f40e, 
	0x18a0fff2, 0xe1a5f907, 0xa5e71a7d, 0x05af3c13, 0x14bb67f4, 0x433efe22, 
	0x9001cdf1, 0x6f823d07, 0x5ee91d61, 0xf90261d5, 0x4eec2092, 0xa1297be8, 
	0x693f68ae, 0x015dfba5, 0x2bf61e7c, 0xceb69ca1, 0xb526582f, 0x5d1efee0, 
	0x7ef00521, 0xff78adcd, 0x61c594e2, 0xef9df607, 0x78fcc26c, 0x778e12c7, 
	0x45777177, 0x7be51dd0, 0x1bc7888f, 0xac29c7cf, 0x8be4193c, 0x4550c57b, 
	0x9efa3b9b, 0x1e495721, 0x3ff57ee3, 0xc9787e52, 0x42ef5e5a, 0xb463b572, 
	0xf1117e3c, 0xf944f40e, 0xa8f898c9, 0x5097e6c9, 0x8d5e671e, 0x84d873d4, 
	0x0d5db6fc, 0xeb1cfec2, 0xb002376c, 0xf3c25a5e, 0xd0769943, 0x0baa7e33, 
	0x284be662, 0x823b0d46, 0x733d1bc7, 0xbd0df786, 0x8a70136c, 0x7257b303, 
	0xf8bb3c0b, 0xb6fdb17a, 0x068bcfa0, 0x81ff8ebe, 0xe4def5f6, 0x967f5a78, 
	0x7a7b23c8, 0x5be17d84, 0xd6789340, 0xe6ee7908, 0x0287ff72, 0x9e76994e, 
	0xb13d9e2f, 0xd013427b, 0x78606cf3, 0x717f8c47, 0xe7cf0962, 0x906cf3e1, 
	0xec62d7df, 0xca34c40e, 0x330b4cdb, 0xacec01b7, 0x5bb2dd56, 0x299b8e8a, 
	0xcd44ed17, 0xf81e3b3a, 0x5f4c0a66, 0xd1f2827e, 0xda1e62d8, 0x7a566f58, 
	0x72471286, 0x7a8bf60b, 0x5b9aa4c1, 0xe2881fd1, 0xcf957cd3, 0x520e9f27, 
	0xb519fe5f, 0xef1af2cc, 0x7de0de5b, 0xb7de25eb, 0xbf89040e, 0x99ff9415, 
	0xbdb58d16, 0xe4d3eb8c, 0xf7f51a9d, 0x3f40ff23, 0xf91b676f, 0x63d21213, 
	0x3bf9b4df, 0x5a64ae51, 0xe3ccde78, 0xd40dfe3e, 0xe60e717b, 0xcb67014e, 
	0x97cd1a56, 0x31933ca1, 0xfa26f6ae, 0x63d95d8b, 0x58dfabe1, 0xc497f3bf, 
	0x2b2ead57, 0x971f3b97, 0xf59e70ee, 0x7c6e9fb4, 0x4794e2fe, 0xc87ca277, 
	0xbb711776, 0x982eed00, 0x9c847ffc, 0xbe7d34b8, 0x332af909, 0xecf28335, 
	0x91f247b3, 0x54dadbc8, 0x32f6525d, 0xe78157f6, 0x9e355537, 0xbeeb83ed, 
	0x32fbb26e, 0x79c74c6d, 0xae28df81, 0x3c02f34c, 0xc61f383d, 0x7cf94a4c, 
	0xc3ca3f38, 0x2661e7f1, 0x90fc079c, 0x7018f361, 0x1324f9b4, 0x00f347ce, 
	0xdcc53cdc, 0xb88ab4de, 0x1279d825, 0x37e6adc5, 0xbe7327c4, 0xf646d59b, 
	0x1b577e83, 0xd08a6be0, 0x27738b17, 0x4f3cca94, 0x7974869e, 0xb72fa0af, 
	0xbc60774f, 0xdeaaf660, 0x276838f2, 0x6d7b7295, 0x8a5a969d, 0xee653cfa, 
	0x9eb952a4, 0xdf9f13e4, 0xda0f627d, 0x6977a0b1, 0x0e91b3bf, 0x421e69b8, 
	0xde42e0bf, 0x7fb252f1, 0x91dde946, 0x54bb29fa, 0xf443ffbe, 0xa7e80753, 
	0xc9fa31e5, 0x00e39cd1, 0xfbaffe7e, 0x1a9cb873, 0x0ae69fa1, 0xd2f433fa, 
	0xe57025ec, 0x12f50c8f, 0xea261bc9, 0x0be93c61, 0x064ed0b2, 0x41b2c632, 
	0xa23a4fae, 0xaafacef0, 0x6b29e88d, 0x2962a6da, 0x9105e84e, 0xce5f69cf, 
	0x40fa97e9, 0xaf182e8f, 0x0f88d4a8, 0x5c7446bf, 0x6339fdf7, 0x3a11b3da, 
	0xa507f4b6, 0xec96bb18, 0xeb3f9857, 0x599f1c6f, 0xe6276c49, 0xad5e3dd3, 
	0x01ec8f33, 0xb2b92f5e, 0x7939d794, 0x7661b532, 0x0d3f247b, 0x786ef8f6, 
	0xa55666c6, 0x2cf9e1c7, 0x0097c82b, 0x2af91f7f, 0x1575e30b, 0x80ecde42, 
	0x1f8fb97d, 0x36f27476, 0x9f4c9b0c, 0x854a4275, 0xd0373ef7, 0xed2eebc3, 
	0x5eedcf9d, 0xff69e38e, 0xc63933ba, 0xd79f077e, 0x75f2855c, 0xe9ebe488, 
	0xfed02707, 0x67f622be, 0x893ce85b, 0x82f38bf8, 0x88b3f69c, 0xa1f9013e, 
	0x4df6ff20, 0xf127687b, 0xe48272a5, 0x990fc187, 0xff71896e, 0xf4b70d50, 
	0x2bc69f12, 0xa15f3967, 0xdaa6f13f, 0x334e526d, 0x3bd849b6, 0x904f8bb3, 
	0x9df0663f, 0x5acf0701, 0x42fc8f16, 0x96f08ff7, 0x7c8c29d7, 0xb012ec0e, 
	0xc5df6713, 0xf974b2fd, 0x11e309a4, 0x0cde8219, 0xf825d87a, 0xbc3a5827, 
	0xabf407ce, 0x8e1c212a, 0xfef095fc, 0x53fdae5c, 0xb9c5cfe9, 0xaf68a5cd, 
	0x2555d865, 0x566de9c8, 0x67b9f890, 0xa3dbbbff, 0x5f90cafc, 0xdfd3be81, 
	0xdd7e27ec, 0x4eb5d625, 0x9ef449db, 0x29577732, 0x7f4815c6, 0xcb75fc80, 
	0xb6546119, 0xe937806e, 0x73d7073d, 0x8501e959, 0x272cf7ec, 0x129e89c5, 
	0x98af94fb, 0x082a864f, 0xe7904a0f, 0x07c41537, 0xced065c6, 0x7d34e837, 
	0xf70db170, 0x160fb7f7, 0x3ad89c53, 0x1bc923f8, 0x2966ffd3, 0x7740f7d7, 
	0xfd7fac61, 0xf81fee16, 0xfa15eddd, 0x770d0857, 0x7f0be8a6, 0x0d492b2a, 
	0xfa247ea2, 0xa771fae5, 0x9be934f6, 0xbc238ec3, 0x4d7c830d, 0x4736f1c3, 
	0x647bacf5, 0x9ba6b6de, 0x3307e3f3, 0x7fd15eb9, 0xb7f8f84d, 0x694ea32e, 
	0xecab7aec, 0xb29816eb, 0xe387b6f1, 0xefdcd171, 0xc4d35c13, 0x4c27e1fa, 
	0x74f841e8, 0x3cf45d60, 0xbf435929, 0xee48dfef, 0x9889fbc1, 0xff359c77, 
	0x2cd3a272, 0x9bf514f8, 0xb709fdc6, 0x19fa0bc0, 0x7f22df64, 0xb02c3ac2, 
	0xe897c981, 0x47c6377a, 0xb5a61e2c, 0x59797d22, 0x0b73ca37, 0x97c9bf58, 
	0xbf93efa2, 0x06fc1072, 0x77ad6145, 0x635d7c62, 0x7f0c687a, 0xf187ee05, 
	0x87dc117e, 0x63fc0c35, 0xc4bed33b, 0xe316cea8, 0xfed9e950, 0x4317b61f, 
	0x391daa9b, 0x7d3efa04, 0x5ec0fe95, 0xd7b28fca, 0xcd26ff1f, 0x92ae30cb, 
	0xa83cb9b4, 0x0bcf7ec0, 0x0afb053d, 0x8097b8f2, 0x96f7908b, 0x75de3c39, 
	0x7209f85e, 0xff8a5ad6, 0xc817feb0, 0x11ebba4f, 0xce21c137, 0x28ff2617, 
	0xf938f4ae, 0x1fe87147, 0xa3fd6385, 0x0fcd4bb7, 0xa91fe58c, 0x9f1dbc92, 
	0x9710fce7, 0x4e35f9cf, 0xa121d3e8, 0xa3b64607, 0x02fea3e8, 0x6dd9c7d1, 
	0x5edf38d3, 0xcd163e83, 0x4d7ae21d, 0x1f4189d0, 0x94aef217, 0xb099fac6, 
	0x8ccfc35f, 0x2d7e79e7, 0xc5c9d45e, 0x45a21f93, 0x3cf13be2, 0x53e7c4ff, 
	0x72809654, 0x06f10733, 0xceee3372, 0x70028486, 0xead613e2, 0xfc3f1409, 
	0xbc30eb42, 0x5f8dce2d, 0xa4d3fa8a, 0xe50b7e74, 0x9ebd48c3, 0xc5c794b8, 
	0x5c4c6dde, 0x7760f28a, 0x8bb5126e, 0xf43f9373, 0x3ca5d4bd, 0xa6372a2f, 
	0x5126f78a, 0x8c8ff35b, 0x438b5cec, 0x99571866, 0x75c454b6, 0x07d1327d, 
	0x03e919e2, 0xe0db5295, 0x753174f8, 0xa40ba729, 0x58e7ec27, 0x6f313997, 
	0x342d9013, 0xb71c2aff, 0x1ee243fe, 0x083dc78c, 0x71f8da43, 0x14fd1e8f, 
	0xce9295f1, 0xd00f9112, 0x36b2450f, 0x5aeda965, 0xee5dda35, 0x7849dc90, 
	0x03cd8cc8, 0x2310791a, 0x737d06ee, 0x14069e2c, 0xf9afcd27, 0xf02cecc2, 
	0xb3e0825b, 0xd4a52524, 0xeb1e0f36, 0xd6bef462, 0xcc7fa91b, 0xfcd30fec, 
	0xaad48399, 0x01e44359, 0x8f3a59eb, 0xe59f6417, 0xe7d9d475, 0x79c67f78, 
	0xc3d19fde, 0xcfd99fe7, 0x7e9133fb, 0x7e408f31, 0x79c1f01b, 0x64171b16, 
	0xbfb8abe6, 0xc893f694, 0x2d78a6ff, 0xeb4775a4, 0x8364d7cb, 0x4dfa01df, 
	0xf129ac3e, 0x097cf860, 0x700c9ce0, 0xe5de0596, 0x227e2cc3, 0x29647f5c, 
	0xfae36fe7, 0xda96b71a, 0x096207da, 0x61ca7ef4, 0x89961568, 0xfdf41776, 
	0x79fc5529, 0x3353e79e, 0x7dd895fb, 0xa157596a, 0xfdf107bd, 0xf65f5a67, 
	0xcfbe16e9, 0x39aed0b3, 0x58d4a3ff, 0xcb7801fd, 0xe8b8c4d4, 0xd878e217, 
	0x5e86b70f, 0xc617bf45, 0x71a01ccb, 0x7850d659, 0xae69f86c, 0x20b33c58, 
	0xc84139e2, 0xfc5e08c9, 0x81ae5e06, 0x9e085867, 0x073c2047, 0x76ecf063, 
	0x66c19e10, 0x192ad4ca, 0xca2cefcb, 0xf1c37162, 0x33277480, 0xd36bfc9d, 
	0x47934ea4, 0x2aabc68b, 0x60cee917, 0x0587e22b, 0xb2659eb9, 0xf7a65f98, 
	0x538eeb5e, 0x38cabd38, 0x5ca5f6ef, 0x4efbc97e, 0xb8f8c04e, 0x659c9781, 
	0x9c604f9c, 0x61c610f6, 0xd42cda3d, 0xefd14cd3, 0xf385796a, 0x3b1bc635, 
	0x60fb7296, 0xc4e3ee71, 0xcf9f06c7, 0x7cf9c659, 0x296da9b0, 0x2cf7f3b7, 
	0x799f3b45, 0xb80619c0, 0xa7217438, 0x183d308e, 0x4db8bc20, 0x36ff1780, 
	0xc318f6bf, 0xcb98467c, 0x4d2bd023, 0x81ada13b, 0x53fc017d, 0xf8fe7bab, 
	0x9369d814, 0xf97da73e, 0x271bb069, 0xc55c6535, 0x8d64ea7e, 0x273ac2b5, 
	0x9bbd6d81, 0x67e895e7, 0x0bf43592, 0xf801c7ac, 0x4d84b860, 0xedf9ef4a, 
	0x3e812753, 0x4f55b552, 0x4dca3e82, 0xd054b0e8, 0xbb73eaf3, 0x157ee0b2, 
	0x7b1da273, 0xc85c533d, 0x9cc9ccff, 0x044d2f68, 0xdd1131ba, 0xcfea2730, 
	0xa6a76164, 0xbcedad5a, 0xd5f0161e, 0x072ba512, 0xb98cf43b, 0xfd5d3867, 
	0x0d6e8639, 0xf0893d7a, 0xb2d5fa27, 0x2afd067f, 0x582a755d, 0x194ec427, 
	0xf189c8fa, 0x7c8ebc3a, 0x1eb270e7, 0x9da8e1d3, 0x1f442a89, 0x0cb7ee8a, 
	0xa2ddc9fc, 0xbd50d6ef, 0xbbbeea9f, 0xf2ff6621, 0x03ecef5b, 0x825ae578, 
	0x3cc3d7bb, 0xfcfd7665, 0x66e3f43e, 0x207c5e35, 0xed0fef99, 0x14371c0e, 
	0x3372af53, 0xe03973e0, 0x5336e9d3, 0xf032715d, 0x783a96e2, 0xe6ddf44f, 
	0x11ea670b, 0x6ff30a4e, 0xd384b806, 0xf4238255, 0x9cd92df5, 0x8abfd03f, 
	0x1bec0fe5, 0x71f361fc, 0x8ddbf73e, 0x126e8f38, 0x6af4927a, 0x1a9f8882, 
	0xc5f895f2, 0x32be6d7d, 0x27e485f8, 0xc659bfb4, 0x83fc4de1, 0x6b626c72, 
	0xc927f508, 0xd36b8eb5, 0xfd57e567, 0x68da63ea, 0xca935cfa, 0xc7c59fe5, 
	0xa596e6f9, 0xbb452d6f, 0x4f942dee, 0x269cbf28, 0x0f840ba2, 0x533a938e, 
	0xb9ce21df, 0x103c2364, 0x614f484e, 0x5e3a7585, 0xb48d3d24, 0x9dd0f288, 
	0x17da22f2, 0x082aeecf, 0xd8f73d91, 0x99474e61, 0x7a68ca83, 0x79c23a42, 
	0x336767ae, 0xb7ce9ed1, 0xc1256515, 0xed5fa63e, 0xfc4c94b9, 0xaf6d9ccb, 
	0x92117c70, 0x23979e91, 0x4e873bbe, 0xa3f48cbd, 0x11b27d5e, 0x4a3fe3da, 
	0x659f9589, 0xbefcf576, 0x075d8c53, 0x2ba711fa, 0xf97b49bb, 0x5b674e69, 
	0xfac359c3, 0x3e8107af, 0x4e2fee2b, 0xfdfe8190, 0xca2717f7, 0x53f987e0, 
	0x127998b3, 0x054c4f5d, 0xd761503d, 0x43c06d9c, 0xfe5c7ceb, 0x5efa3994, 
	0x9cbf3190, 0x936ae6cb, 0xcdc25c81, 0xac44c0ed, 0x1df2be42, 0x5c018f8c, 
	0x29961e48, 0x76068a5a, 0x2e1b586f, 0xf53a0d1f, 0xe242fec3, 0xc6477dbd, 
	0xfc2d8f18, 0xe8678e2e, 0x70f3c8f5, 0x831f9f1d, 0xafb4fe3f, 0xefa3f914, 
	0xa1b717f2, 0x0cb392bd, 0xe8055ce5, 0x51bf3c39, 0xc55de421, 0x7a871661, 
	0xd7197f2f, 0xe3d7317b, 0x161ebac7, 0xdce2cdf6, 0xcc3ecbf9, 0xe3e49a5e, 
	0x8d9bf472, 0x8e50cb85, 0x4e03cc5e, 0xf8f07b44, 0xdd13aa45, 0x846270be, 
	0xc2347a9f, 0x66f3139f, 0xd676113f, 0xe42dd680, 0x39416688, 0x2b493292, 
	0x532cbe45, 0xed2b1c39, 0xbc33c93a, 0x1d7ef48f, 0x5ff03df2, 0xe3273b0a, 
	0x7e86ebfd, 0x1d1074e4, 0x761d7af0, 0xfd13876e, 0xbd099fc3, 0x42bdc06b, 
	0xf718ec93, 0xa330ec9a, 0x6539246e, 0x3650f906, 0x408e8238, 0x918bec16, 
	0x5aa60157, 0x09f2427f, 0xf3f401e4, 0x6fcea7dc, 0xe51af211, 0xa27781af, 
	0x661fb867, 0x3ef131a6, 0x74b5cdb2, 0x8258af9f, 0x3f76d3f8, 0xaa728c99, 
	0x7cddd8f1, 0x603b9dde, 0x925bb97d, 0x03cf1375, 0x8f78f3b4, 0x1af58ed6, 
	0xfe431f30, 0x0bd9e634, 0x3d03315b, 0xbe1f9d97, 0x22d6bc8f, 0xd84ff23b, 
	0xfb40e951, 0x2ff37721, 0x7cb1631f, 0xacf2d0f7, 0x723a3042, 0x27ec9ee5, 
	0xe95cfc60, 0x1eba1f97, 0x6b3f7794, 0x69de4b19, 0x9e00ef24, 0xd1c8599a, 
	0x70cec4cf, 0x50127b70, 0xc849799c, 0x7fb30f93, 0x566a6df2, 0xdc863697, 
	0x84d67c4c, 0xe9432972, 0x31ad3c3e, 0x6e72ef2a, 0x8bc19cd6, 0xd45527a4, 
	0x3cd91557, 0x0d7d02ef, 0x12df28fb, 0x443c84ab, 0x45c5b6f9, 0x7abd20f8, 
	0xf10f2a38, 0xafde337d, 0x069aee0f, 0xd46ffd8b, 0xf2a39b97, 0xf8ee6dcb, 
	0x0ce7c629, 0x29e50cbb, 0x75e44faf, 0x3efc0673, 0xc04d3b73, 0xfc0c596f, 
	0xe63c9a3e, 0xdd382470, 0x6e9e1a3f, 0xb461ff47, 0xf5ff48e7, 0x3d207872, 
	0xc060f41a, 0xa439f70b, 0xe807d0c5, 0xa7db8409, 0xda325fdd, 0xfe0255c7, 
	0xcbf7a3f9, 0x2299dc0a, 0xfdc99c9f, 0x9ba70f84, 0xbceade88, 0x7f3e58fc, 
	0x9afdb86e, 0x57ec847a, 0x86dba5b7, 0x86ee6a7a, 0x7cc25e3f, 0x9253e82b, 
	0x9f42f163, 0x6bcbd48e, 0xf9152d54, 0xd032f493, 0x6e6da4d6, 0x58f0e7fd, 
	0x86a57a65, 0x1fb28fef, 0x4e093c05, 0x93c16355, 0xf3c11df3, 0xcb4fa70c, 
	0x823be225, 0x374567c3, 0xb7735c06, 0xb825fa70, 0x404d3c22, 0x7870ca47, 
	0x1a2f658e, 0x3828e276, 0xec003f0a, 0xc4e3d35a, 0x1e4fea08, 0x57fc12cf, 
	0x62f3f625, 0x3e258ed4, 0x55fc17cb, 0xe311e827, 0xd93a9d5d, 0xe11f867f, 
	0xec6febb7, 0x7dc68579, 0xf1b6e9e1, 0x697bade5, 0xe1e28f92, 0xda7ed09f, 
	0x87d93b9d, 0x75b0c1fe, 0x77b90af4, 0xfe3d0c69, 0x9a77d0e2, 0x05dbe3dc, 
	0x47072f64, 0x0ac9edcb, 0x0a1d63b3, 0x57cf07bd, 0x4efe5d34, 0x64ed0793, 
	0xa3eb7bd0, 0xdfc7057a, 0x7f5f19ed, 0x3c68fa1a, 0xd7e869fd, 0x4067f531, 
	0x425397e8, 0xad1deecf, 0xbfa5af3f, 0x046ef222, 0xf25effbc, 0xf407f08e, 
	0x8edc28a3, 0xc46dd08d, 0xbf10ff2f, 0xfe5a3039, 0xdf23d28d, 0xfa8134ee, 
	0x74ea1360, 0x146fd815, 0xfb4df47d, 0xe7da3b41, 0x3dcd9315, 0x7ec37788, 
	0xf1e268ab, 0xf32bb439, 0xbb4a9d61, 0x202ff494, 0x2b522aa7, 0xbe785e4d, 
	0x1af3c7ca, 0xb7e0f317, 0x3274313f, 0x42f70e28, 0xdfb4f5d6, 0xa7ec23f8, 
	0xc3b432af, 0x87687c6a, 0xb30ed059, 0xd987bad2, 0x3b0af761, 0x5ef06aec, 
	0xb9ddf3a2, 0xef1e3e75, 0xb8c3e8da, 0x6def78fa, 0xd938f1f6, 0xf166d0cc, 
	0x8f523c1e, 0xfa4c2df5, 0xff7c16d7, 0x925f7a21, 0xbef8fdf5, 0x33c78725, 
	0x732df78d, 0xdea9bb5a, 0xa835b329, 0xf36e1f00, 0x27b23b71, 0x8a6dbf04, 
	0x5738b78e, 0x37f5d0fb, 0x9b9bf58a, 0x43ad871a, 0x32677551, 0x292caf3c, 
	0xc56f1b5f, 0x743e5a71, 0x9c62dd9c, 0x1eed343f, 0xbc85ff36, 0xff587c27, 
	0xb2dc4f7b, 0x0aa7dfa3, 0x93075e30, 0x35493e5c, 0x4e9a39bd, 0x293337fd, 
	0xf7d18fe8, 0x00e52e42, 0xa3f2592d, 0x5cb92372, 0x7e411b52, 0xc63728c9, 
	0x790b8ba0, 0x95e7c4ff, 0x1f3a3dee, 0xbc8bf5e6, 0x42dfcd29, 0xfe63b4f3, 
	0xf99cb932, 0xd7a3d9ad, 0x40bcfe31, 0xd88f18f7, 0xc96367ea, 0x77994bab, 
	0x6f7b405e, 0xe1a6a2a3, 0xe05ab2b9, 0xc79d10b7, 0x007bec64, 0xa6d95a8f, 
	0x56a53c60, 0x135e7be4, 0xe369f074, 0xfc09fe8e, 0x9cfac91c, 0x1eb027a9, 
	0xedc450be, 0xb43da6fb, 0xb5a3e31f, 0x6ecf594b, 0x13dd4c77, 0xc41decfc, 
	0xa8935cba, 0x9c9a71c3, 0x71c9f30f, 0xbac0afff, 0x9abac1e6, 0xf9263f7c, 
	0xfd22e38b, 0x4fe3f319, 0x2fcff123, 0xb477e47c, 0x79fe205e, 0x973a6f3c, 
	0x3e7e6e27, 0x8a67a36d, 0x71c49d89, 0xdf93e97e, 0x98b0f3e3, 0xf71bc679, 
	0x24ffdc99, 0x7bd6347a, 0x0bd9d054, 0xcd7fef42, 0x15eb8177, 0x4a3eaa1c, 
	0xd5649797, 0x48ed9df9, 0x75a5bfaf, 0xe3d9f41b, 0x41957ee3, 0xbd431797, 
	0xe27f1e3e, 0x9f10257a, 0xb9c8eb42, 0xf208cd59, 0xc7c50db8, 0xba8db39a, 
	0xf5165520, 0x90e75425, 0x9fb5b76e, 0x5edef984, 0x39d6f3c9, 0xaa3a86de, 
	0x40599d57, 0xb5f5dced, 0xdf8f51fb, 0xc1598f7b, 0xaf95e7f3, 0xa064529d, 
	0xb32abaeb, 0xe712ea62, 0xb6fe80da, 0xac2ee915, 0x64c9aa4c, 0x40fa0992, 
	0xd9c612a6, 0xc002bc69, 0x07b6815b, 0xb754f8f3, 0xbf5bef0d, 0xf18f1dd8, 
	0xee079a63, 0x4a2c5fcb, 0x6b2cf7c0, 0x8f3ac524, 0xb1fb72e2, 0xad96cd0e, 
	0xfc253d0f, 0x0ef58427, 0xdb97b9d3, 0x5ede634e, 0xdc34f93b, 0x2e7731af, 
	0x2ffd0bdb, 0xdd6e3737, 0xded0f587, 0xa0c965ce, 0xdadcea57, 0xefe854d6, 
	0xe9baff78, 0xc62fb7e8, 0xb027e1f7, 0xafdd20ec, 0xfba41558, 0xcfe5cef7, 
	0xfa0b383f, 0xd743de30, 0xf30dfbf1, 0xc5e1ff79, 0xb4b907d0, 0xf51b7975, 
	0x98d63c0d, 0x532cbd78, 0x1b8a79d8, 0x31da959e, 0xcd78186e, 0xbe061f1c, 
	0xc38abc38, 0x196dab73, 0x7b0109f9, 0x73ac01d6, 0x95fadba8, 0x377ca06f, 
	0x9c46f5e2, 0xf400af2b, 0x8d91c822, 0xd7fff4b3, 0xb8ecfb02, 0xe153f385, 
	0xd53cf514, 0x84987a89, 0xf88f1f75, 0x049f2fa6, 0xe57d37d7, 0x9788ed2b, 
	0x09ccd78a, 0x98151758, 0xfc8ed958, 0x29de2c0a, 0x2103ae01, 0x03f41f80, 
	0xac78a587, 0xbb28ddbf, 0xe375b637, 0xd2e51abc, 0x34dd6e6a, 0xe18fde73, 
	0xef7b5dba, 0xb01fca29, 0xd6ad631f, 0xff41edd6, 0x3f7e14be, 0x8d956c0e, 
	0xf77f9aa9, 0xfaafdc5e, 0xf062bb9f, 0xc2e6b350, 0x876e3caa, 0x1673b73d, 
	0x87f197be, 0x7be39727, 0xa64def6d, 0x6fdcc073, 0x2ef588d8, 0x14cd0fdc, 
	0x44f93bdf, 0x00effc71, 0x1f141c3c, 0x8dfcf1e6, 0x23257e8f, 0x3eb3f48e, 
	0x8dc3ed13, 0xdea6870d, 0x30fdc560, 0x5f641fb6, 0x0ccd8fe1, 0x68563bcc, 
	0x6a7f9f95, 0xe9eeba28, 0x79330be6, 0xd8ab543c, 0x70b97209, 0xc787ba82, 
	0xa6f8d475, 0xf6278819, 0xafb15efc, 0xfd016fa6, 0xd01db15f, 0x9c8b882a, 
	0x997537c8, 0x43d793aa, 0x79c0ed9c, 0x4e979665, 0x2396a6f5, 0x0e0798ed, 
	0xa6cee90c, 0xd2de31b7, 0xf60480ff, 0x31a522c9, 0xee93031d, 0x33f7e72b, 
	0x492dd78a, 0xaa7fbca7, 0x9d3ac791, 0x47ad794e, 0xcaf37e45, 0x8f11c7f9, 
	0x75b715d5, 0x14a6f3e0, 0xe7881be7, 0x5ca79c9b, 0xa6720ab2, 0xdcddd390, 
	0x87cecb2b, 0xe971e862, 0xb76f5e2a, 0x577c5ca5, 0xdaf5c983, 0x859e7017, 
	0x0753eb0c, 0xd3d6175a, 0x8582a139, 0xbee31c84, 0x6b2163be, 0xce1e08d0, 
	0x4f3c5673, 0x33ea9e72, 0x52bbfce3, 0xeb44a74f, 0xf2263758, 0x960f31f3, 
	0x54c3f973, 0xe6f51536, 0xcbfddf51, 0xfbe7bf51, 0x60d8ceb3, 0xa1e9d59f, 
	0x42e41938, 0xa9bea2f5, 0x62d4cf68, 0xece01fbf, 0xd5b7cbeb, 0x9e48be10, 
	0xb7bd63de, 0x8d0ccf1d, 0xede8078e, 0x502fc01a, 0xb2d00ec1, 0xcf649cba, 
	0xd8e3bda9, 0xccd50e77, 0x8fde61fd, 0xb04e73f8, 0xdc618edf, 0xd0cdd789, 
	0x4fa02db9, 0x2969e875, 0xfe41d752, 0x5afed8dd, 0x21ca5573, 0x59ef57b4, 
	0x688babf3, 0xff14d72f, 0xf98bf28a, 0xcddb59f5, 0x6fffc17e, 0x8fcbfd62, 
	0xb6fef11a, 0xbc0a84de, 0xb76d73bf, 0x4982e309, 0xc41cae73, 0x65addc38, 
	0xe3ca56b0, 0x8eb895e9, 0xdc93dfcf, 0x4660f687, 0xf84bbac2, 0x49fa737c, 
	0x8d1fd525, 0x4d3ad6fb, 0xcdc7da0a, 0x853c81af, 0x33aa7271, 0x00b3b2a6, 
	0x13a35f4f, 0x58e6e1cf, 0xc1046597, 0xf9466ece, 0x8057f301, 0x18d9a37d, 
	0x3e9172de, 0xc1442132, 0xe0f1142e, 0x31d27396, 0xe555673c, 0xa1f0bb37, 
	0x3d6f57c2, 0xa9bdeb8c, 0xfe419a5f, 0xacccdb99, 0xafe69f20, 0x9be371e0, 
	0x20668b07, 0xd575c1fd, 0xe0e4f286, 0x1e7e0af2, 0xae30b99b, 0x2e73d4ca, 
	0xcf7ac7dc, 0x333c2ed3, 0x68f4315e, 0x163ff71a, 0xd6c797d2, 0x8754ccfb, 
	0x49f40bb2, 0xa549d00e, 0x70871cc3, 0x0f7d7da4, 0x43d732fa, 0x3f262b2a, 
	0x637a68a4, 0x57740296, 0x22eb2abb, 0x14d4f5d6, 0x014d7ca7, 0x3ea074f8, 
	0xe920efa2, 0x94576169, 0x9ed78bce, 0x6eeb8a9a, 0x5b7a1c71, 0x51b7b902, 
	0x59b9214d, 0x89d7bc53, 0xf43eb5f2, 0x5eeec3ab, 0x0ddb271a, 0xfc01d4e3, 
	0xfcbc8367, 0x5f9fd0b2, 0xe17b074e, 0x24ef4e49, 0x0bfe99b7, 0x07afbbac, 
	0x1c1e49fe, 0xdbf49f9d, 0x95cf1399, 0x0dd4597f, 0x1db0b1e4, 0x6718d2e9, 
	0x1ede827a, 0x6f7ee1ee, 0xcff53642, 0xbc617f60, 0x625878fe, 0x0f42ebec, 
	0x1d81c7e4, 0x116e7805, 0xb3d6b9f2, 0x824209da, 0x2eb0a13d, 0xf98ad792, 
	0x40738416, 0x3940a929, 0x425d6852, 0xc0279779, 0x4e4092a3, 0xf8d3d13d, 
	0x3a07ac1b, 0x024730a0, 0xfea68bc6, 0x87089bea, 0x668a1aeb, 0x97fb1c22, 
	0xd211b8f3, 0x5b8c1b47, 0x67abf699, 0xdc289694, 0x39be859a, 0x148e60e0, 
	0x380ea7b0, 0x16501c61, 0x9a7389f7, 0x2515afd5, 0x1e093b58, 0x587da16f, 
	0x25cb28b5, 0xcebeb4e9, 0xe39ff064, 0x72b97157, 0x7e2fa89f, 0xd6081902, 
	0x92b9c4fd, 0xddf5096e, 0x2cf79e4a, 0xcd84f514, 0xf9d8f191, 0x2af3a46e, 
	0xdf914fd7, 0x96e787df, 0x850b73c3, 0x2c3eacfe, 0xf9064dc5, 0xfc9597f0, 
	0xcbcc119c, 0xaad700cc, 0xcf153626, 0xaaa5d507, 0xfced6d05, 0x291f51be, 
	0x585deaea, 0x47b46f57, 0xb40af27d, 0x35172beb, 0x4ca9bc92, 0x19a7f2e7, 
	0x507947c6, 0x0f91d78b, 0x513a5556, 0xd93c0431, 0xc009d794, 0xd06bdbf5, 
	0xbfcbecce, 0x00a3ac53, 0x92e3f1f7, 0x5477cc76, 0x5bbfc3c9, 0xc758bcf4, 
	0x1e1c15e6, 0x4a3d4615, 0x7ac2ee83, 0x939f01a3, 0xe5494bfc, 0x76756e76, 
	0xf5c49a56, 0xc0125c70, 0x510aff63, 0xf3c2ae6f, 0x32bb3d78, 0xfdc22a43, 
	0x17f44eaa, 0xd72bb3aa, 0xf937404a, 0x2833ec9e, 0xeb94072f, 0x164ee999, 
	0x7a0b1653, 0x99f497a8, 0x00d9e513, 0x6bf6ae90, 0x03f74dba, 0xd0998b2c, 
	0x914f282e, 0x4bf9e077, 0x9e3ee405, 0xb90876a3, 0xad8656ef, 0x8a0aec0f, 
	0xfc263087, 0x7e8ebc06, 0x274a92c5, 0x6091339e, 0x8d63c43c, 0x9fcc4fb1, 
	0x3cc5dca1, 0x1d1fe70b, 0x6eb7e1d7, 0x417f90d1, 0x1841ea7f, 0x9f4966a3, 
	0x2b3ad126, 0x8dba429f, 0xaf2a17f8, 0x36705ffb, 0xdc7c4d98, 0xf3873c19, 
	0x138c6174, 0xd648b7f0, 0x3ed9ee67, 0xf9d4ce5a, 0x7f215e6e, 0xba62ff0c, 
	0xf89ba5d9, 0x4907cf7a, 0x5fddaeaf, 0x6bf5cbd3, 0xf3fa848d, 0xd93f7b4c, 
	0x7ef6bec7, 0x6b8defd8, 0x7e300f60, 0x8a9b2665, 0xeac99772, 0xdd57dc54, 
	0x7d42ee90, 0xedbb481e, 0x17ed0620, 0xa869cdf9, 0xbbef41cf, 0x9adc79f8, 
	0x37b7c803, 0x65389415, 0xae4d67d2, 0x2d3dfa11, 0x3e83bf56, 0xbefb80bf, 
	0xe403ed0f, 0xebe7d40b, 0xb94fef91, 0xd48c3850, 0xf395d7eb, 0x91c4c8fa, 
	0xe84ebd7a, 0x77e05575, 0x659f5ea4, 0x39d575e8, 0x2e2ef3c8, 0xa1a55efa, 
	0xa9bdd5df, 0xf946f7a7, 0x8f9c5aa9, 0x3bf44530, 0xc81d0ff8, 0x57c4f557, 
	0x97008f44, 0x01efd080, 0x3aafe73b, 0xb9fbbf43, 0xdfe8377e, 0x036bd06c, 
	0xd3faff23, 0x15ecedd2, 0xa7c63e9c, 0xf8aec35f, 0x76d8c77d, 0xf5107a85, 
	0xb427f56b, 0x401bf22b, 0xfb08f7ef, 0x576a2ba2, 0x8d527924, 0x15d91138, 
	0x78f05f64, 0x8da834bd, 0x213d038e, 0xc774dce8, 0xda2e532e, 0x6760d5c7, 
	0x817d85f8, 0xd35028eb, 0x06eefe48, 0x7c62a079, 0x51d77c4e, 0xe516b3c0, 
	0x6780af43, 0x40f968dc, 0xebf785f0, 0x05f9ee50, 0xbe02033c, 0x7dc346f3, 
	0x9e099c24, 0x765d7e30, 0xd2e5139f, 0x77cf7078, 0x8fd7bd82, 0x0b8ce6fa, 
	0x85aa8feb, 0x52bb597e, 0x7f808fd0, 0x9d324f5c, 0x9bec367f, 0xbc971eb8, 
	0x779d20e3, 0xafc198d6, 0x8b4bad0a, 0xcf01dfe5, 0x9cc58d62, 0x6bf035cf, 
	0x1407b9e4, 0xfbce26b3, 0x04d9c0b8, 0x60ed1fbc, 0xe0b8d13d, 0x43ad0a86, 
	0xa3c989eb, 0x2077c08f, 0xc229eb89, 0x1ef818e3, 0x91f88e23, 0xce5cdbf0, 
	0x7e0894fd, 0x2efc73e7, 0x81d6d8ba, 0x3fe2fdf8, 0x7541585c, 0xf24a8ae4, 
	0x1742fc0d, 0x6155c7d6, 0xaff803dc, 0x6aafc054, 0xf6ae6989, 0x4b83c614, 
	0x5c1e30d3, 0xfe898ab5, 0xbfa8edcb, 0x687e9b2a, 0xb6fb002b, 0xdfb455b2, 
	0x545e7684, 0x8adbd46e, 0x32fea3cf, 0xcd3a5bfa, 0x2f7bf153, 0xfeb92bd5, 
	0xc812d3a9, 0xeb023b4e, 0xf69ebebd, 0xa8f91533, 0x7988df6a, 0xc0bf0226, 
	0x36ec37fa, 0x371c23c7, 0x53ffb9d8, 0x7a4cdbbb, 0xdaa272b5, 0x78bafd81, 
	0x8f005f90, 0xf4afaeea, 0x9d5bdda2, 0x9177a8b4, 0x6edfea37, 0xe910f178, 
	0x165f0add, 0x9827fbcd, 0xade604b7, 0x5ded6d36, 0xea42fe84, 0x343e7a56, 
	0xe426dfe1, 0xa0fafd83, 0xc74be7bd, 0xd74f2fd0, 0x07dcecf6, 0x078f766d, 
	0x983f99cf, 0x0b6af9da, 0x7107d6c8, 0x073e00bc, 0x64d0087e, 0x4b9f7e5d, 
	0x2d37f182, 0x72057d06, 0xbaa3d368, 0x540bbf13, 0xcef8c4b9, 0x0b46fa96, 
	0x15fba1c8, 0x6f5c39f6, 0xa4b5c605, 0x5b96b898, 0x70efc34f, 0x3d8d6bd5, 
	0x47821eae, 0x3e7831da, 0xaf8f2571, 0x4a5fe146, 0xc200f9f1, 0xdfbc04ff, 
	0x60e28a74, 0x0fde5681, 0x40161e20, 0x8da08bfb, 0x6be3a7d3, 0xaf0237a8, 
	0x83b1b41d, 0x1713ddf4, 0x765551d2, 0xcbd20765, 0x0b6669fa, 0x3aa3af3f, 
	0xfc28b9f1, 0x5e10072d, 0x12173375, 0x823c0d3c, 0x0fb6cf09, 0x2d0b7be0, 
	0x23a456ec, 0xb975b7ce, 0x9e317b0b, 0xbd656752, 0x222ce54d, 0x9f2fb010, 
	0x23647de3, 0x4f2a9c63, 0xfe04d389, 0xde837cdd, 0x1fe48ddc, 0x394fb954, 
	0x30dcfed1, 0x81ec98b8, 0x6eff199b, 0x9e787ad0, 0x697631f5, 0x0bcba37e, 
	0xb706c8fe, 0x3c05e5d9, 0x4f80a3fc, 0x9fde13a5, 0x82f4780a, 0xf88779bc, 
	0x462d21f9, 0xcdf3192f, 0xabe3c95e, 0xa0ab3c46, 0x83ce8531, 0xdf0aeb1b, 
	0xf4f3e9ca, 0x6f376e1a, 0x1eb2e714, 0x59d7c359, 0x12f40db1, 0xbef9b7d8, 
	0x60917fbe, 0x4b9e85bf, 0x9277e8f9, 0xf212ea7e, 0x7f68f375, 0xbfbee00d, 
	0xf5e1077b, 0xbfd65bc0, 0xc2661e3f, 0xe07eb13e, 0xe478f85a, 0x47ae049d, 
	0x1d13a687, 0x4acef23e, 0xe28bb967, 0x1b604f78, 0xe8f6e72a, 0x0f0e50f7, 
	0xd3817c62, 0x5d05806b, 0xd2a7405d, 0x785c8fd0, 0x04d2f6fe, 0xd02f54f3, 
	0xb92b0df2, 0x94f3aebc, 0x0497bcb8, 0x818e0e3e, 0x217a8b0f, 0xfbe8fb68, 
	0xfffbfb86, 0x8f72f186, 0xf689fa4e, 0xe9d1f55f, 0xb11e1630, 0xe03c27fb, 
	0x6d3ded7e, 0x81abc02d, 0x65a92d54, 0x548dc62f, 0xb8c52e16, 0x5b777683, 
	0x1c3fce98, 0xdd66b8c0, 0x031ee6cd, 0xad67180f, 0x5bb22596, 0x3b390f40, 
	0x8a95bbf0, 0xbe44e4d7, 0xd5bdb8d3, 0x8b8f2b75, 0xe27ea254, 0xe27413df, 
	0x5798e9f7, 0x08a0baa7, 0x42b3d33e, 0xf26d5798, 0x76895aed, 0xbfb4df66, 
	0x957ce3b6, 0x0be7c349, 0xfa333888, 0x97181d59, 0x2acde233, 0x2b742f9f, 
	0x7f0cd7b7, 0x90646e0b, 0x14f60c9d, 0xebe4d7ce, 0xd4c72958, 0xcdcf3495, 
	0xa61779a6, 0xbc206714, 0x1026879b, 0xdf05b9df, 0xb4d4fb35, 0xcf4029ae, 
	0xe83bafaf, 0xa57941ed, 0x3c0175a7, 0xbe70d6ea, 0xf2015e6b, 0xb4bfee19, 
	0x4d37c05c, 0x02f3c76f, 0xa347e095, 0xdab1ca9c, 0x1cbf22a6, 0xe016f3c0, 
	0x3809d5af, 0x9e6fd23c, 0xbf1ce78a, 0x017a083a, 0xd84f7dde, 0xeabac625, 
	0x5499e6fc, 0xec71fd37, 0x750f3c6d, 0x2c6079c5, 0xe786fb3b, 0xe26a3ada, 
	0xd83676a2, 0xff91fbdd, 0xe69e312a, 0x0ededc63, 0xe41abb08, 0xdbda2d4f, 
	0x734f14bd, 0x8e28d935, 0x30f8c4e6, 0x8fa4dbd9, 0x3fabb265, 0xf60d9daa, 
	0x32e30bb9, 0x8a128e15, 0xfddd9013, 0xc76fae24, 0xb6db7b30, 0xcfcbd386, 
	0xf9df156f, 0x1b6f691c, 0x216792f6, 0xbdb46401, 0xb2debbad, 0xefa27e72, 
	0x76f61b6d, 0xe2453fd7, 0x6b0fa869, 0xbeeb5c85, 0x85ffe455, 0xd9d86dbd, 
	0x4768e323, 0x12b5ff7d, 0x77e871f3, 0xd8479e12, 0x8f2354dd, 0x5a4d12f1, 
	0xad76f68b, 0x084f69a7, 0x006fe888, 0xbd0c735b, 0x2aa4e659, 0xbb58dad6, 
	0xb00f7f8d, 0x1cd7c850, 0x9e1d4377, 0x99b9ca2b, 0x077ec5d5, 0xf1b758c4, 
	0x429a961d, 0x14fce29d, 0xefd167cf, 0xfef9d601, 0xe34df442, 0x0a71c71c, 
	0xe7bf62ea, 0xf5c17081, 0x79f52615, 0x1ffeb8ad, 0xf765fe37, 0x7767e8cb, 
	0x7cc6ef56, 0x1b693c0f, 0xb5f6bec0, 0x356ebc9d, 0x0c73fda4, 0xc3cae63f, 
	0xf059b1f8, 0x6df14d63, 0xbfbc2f26, 0x9314f66d, 0xcaca24f7, 0x9e78c95f, 
	0x7f9bbe26, 0x8ab6c11f, 0x98b9a79f, 0x11fdbf07, 0x157e30f9, 0xfe78c3b7, 
	0xbb712438, 0xafe6d3f0, 0xf9050e50, 0x1c349ff9, 0x7acee48f, 0xc8710f41, 
	0x9c9ca777, 0x95394eef, 0x09f5c3e5, 0x277ae3d2, 0x7d8003cf, 0xa16e1698, 
	0x262479d6, 0x955815fe, 0xa5ef3265, 0x41e36465, 0xaac0279a, 0xf245509a, 
	0x479e22eb, 0x9c4c78c2, 0xdfafb19f, 0xa567f5ca, 0xfb98f813, 0x65b5fb3f, 
	0xe178c7d0, 0x0c5718db, 0xb1d0b138, 0xbdf48192, 0x437122cc, 0xe0decec3, 
	0xdcdff233, 0x80a0df8e, 0xfa892f7e, 0x335e4953, 0xe345e6b3, 0xbc5f20ad, 
	0x7c91d512, 0x646abf3c, 0xade28dbc, 0xfce3e768, 0xb7e3a3bd, 0x3cdfda3a, 
	0xfc6630ee, 0x466390d6, 0xa3f3171c, 0x1c50cfe8, 0x6bfc282f, 0x1a9b4790, 
	0xf8f14e72, 0xfa8ed694, 0x783bdde7, 0xa386effc, 0xfe70d2eb, 0x4e01e21b, 
	0xb0beb0dd, 0xff0b9b88, 0xe7e056a8, 0x026941e6, 0xc181a1ca, 0x0c1e5c05, 
	0x0f2e182d, 0x77fd5c44, 0xdcb8f077, 0x7b6a090d, 0xf169c02b, 0x9404d150, 
	0x39ffd03f, 0x9021c77e, 0xbca2a6c6, 0xa692ebae, 0x7ce08162, 0xa3e413a0, 
	0xfe4eb31e, 0x635526f2, 0x2c1e91db, 0xd9ef94fd, 0x0daa61e4, 0xae504ceb, 
	0xa02dfdc1, 0x3f7fb677, 0x2e4e9d66, 0xdd360297, 0x7cf18ad9, 0x03ebf0ff, 
	0x697e42ed, 0x7a63dfc2, 0x31edd9c7, 0xa9ed6a72, 0xf9005c48, 0xdfaedabd, 
	0x7f2627bd, 0xbb216f72, 0x8fca05fe, 0x8f1b2768, 0xc82bf888, 0xaf6d628f, 
	0xe6bae903, 0xb01d0bf5, 0xfefd560d, 0x15a2fc7f, 0xe68a2be3, 0xf6fd836c, 
	0xb4f2e6ad, 0xa07264de, 0xf1f030dc, 0x91af8173, 0x54c45074, 0x8761c207, 
	0x4ddabef8, 0x8c9cb82b, 0xff08c9d6, 0xef95d164, 0x220f77e0, 0x0bf000f6, 
	0x0ed2b5c2, 0x3ca08fd7, 0xe30ab1da, 0x18ca4817, 0xede7c46f, 0x1f27ca1e, 
	0xd960f8a4, 0x8b5efd70, 0xf5e784f2, 0x75088ec8, 0x57d27d73, 0xd27fbfce, 
	0x15627be4, 0xa21e0fb7, 0xb4c08d7a, 0x8a57efe1, 0x0eef51f7, 0x3e5447b3, 
	0x9e221bce, 0x47b11753, 0x8f6e54d8, 0xf6b1a9b0, 0x61955d48, 0xe69d7c8f, 
	0x299366db, 0x62f1880f, 0xc6012efc, 0x49f39391, 0xf3137ecf, 0x5cfd70e4, 
	0x72d1e1f2, 0x143d6473, 0x987e3ac3, 0xe66bfd6f, 0x8d738a78, 0x4e32773a, 
	0x776cee5e, 0x6bd229f6, 0xa9ea3cec, 0x9b9dc9d4, 0xd3429ce9, 0xa74f39c1, 
	0xe754fd62, 0xbf607de6, 0xe0e37f55, 0xc29efb91, 0x0e3f37b6, 0x87c5cefa, 
	0x60a76b0a, 0x24f5b1dd, 0x94e9c3cf, 0x5bbf5d87, 0xe893b0bf, 0xf9bd7f48, 
	0xf8f3ec19, 0x1cddf553, 0x62d665cf, 0x9e537f8a, 0x483e6188, 0xf7ae26fb, 
	0x5db7359e, 0xbbbfcdc4, 0xe489d78a, 0x7f44659f, 0xfe9be026, 0x6293ac5e, 
	0xcf805afe, 0xa68f430d, 0x72165cd5, 0xf169e819, 0x6873405d, 0xbfc0fb3f, 
	0x353c0369, 0x6e1e8898, 0xea226a60, 0x3f58ab89, 0x0ef3c265, 0x3df4ed45, 
	0xb68fe9cc, 0xad2ed03b, 0xbf03bc6a, 0x6bbdee3f, 0xebacf7f8, 0x06be8116, 
	0xf2a736fc, 0xdfff4f75, 0xbb8c4e53, 0x9a291ed7, 0x73a0c8e0, 0xcbc44e6b, 
	0x67549bf4, 0xfdddc81b, 0x81fbf8eb, 0x49e703d4, 0xfde17bd8, 0x7ccf7c16, 
	0x75dcf300, 0xc6858d99, 0xc3b40879, 0x83a6f623, 0x5f1e53e7, 0x2ec1f3c7, 
	0xa0dfef37, 0x820e2715, 0xa55caf9c, 0x665d63b6, 0x076dc560, 0x73f95beb, 
	0xfc2ed16b, 0x8c4289f1, 0xbb9f3407, 0xd08bdbcc, 0xcff6831e, 0x9f7d6fa2, 
	0x0b851df7, 0x1684cda9, 0xfe8be7af, 0x6f96d152, 0xcf58d6a5, 0x46a7910a, 
	0x0bfca0f8, 0x88395fc4, 0x1fadecf9, 0x7a4b7d80, 0x7280bb4f, 0xee36fdbf, 
	0xa93735c7, 0x3a0168df, 0x35a7de69, 0xdb7c0e3c, 0xdd9da75c, 0x83a510d9, 
	0xd755fbe6, 0x15074e2e, 0xfd05cf8f, 0xf9fc0138, 0xff82d88b, 0x3afa83be, 
	0x52eb9dc6, 0xe4300f41, 0xe276466b, 0x99587f23, 0x930a6606, 0xa04f80fd, 
	0xa8cab08b, 0x7fb2acde, 0xfa139a65, 0x07179875, 0x8874dcbe, 0xb4bbf105, 
	0x16733eb5, 0x38af939d, 0x63758174, 0x259fb95b, 0xb73a1583, 0x1fac46f3, 
	0xbced4b28, 0x6dd02f67, 0xf7759aed, 0xe9d0c5a5, 0xf76ddf4a, 0x8a7d144d, 
	0x112c297b, 0x406507e3, 0x0197984e, 0x7b42ed7c, 0x27be27c6, 0xabc57cb0, 
	0xecdd218f, 0x6d7a04cc, 0xb1fe76bd, 0x03b71f79, 0x6abf227d, 0xa0bf7ff0, 
	0x71d75b97, 0xf3306e38, 0xd587c8ef, 0x9a467839, 0xc0feb86d, 0xdd4fdc45, 
	0x7e1c521b, 0xbe7c2c07, 0xb00e7bfb, 0xcedc9703, 0xa275c4e3, 0xf5c3672e, 
	0xbfc7ef77, 0xa561b3ff, 0x0cf5bfba, 0x1f4319f8, 0x75f36338, 0x1d7069b5, 
	0xf5007a74, 0x9b5f8c1a, 0xb47ef777, 0x0d9c1773, 0xfc61b966, 0x59dd73c2, 
	0x8167586e, 0xbcc6cc1e, 0x0237c2da, 0x87d81915, 0xcf303c79, 0x7b255542, 
	0x3bb6f282, 0x4a6ace50, 0xec121e6c, 0x7f8c0c8c, 0x3db93a65, 0xa293fb51, 
	0x179f8c24, 0x909252f8, 0x4f0cc1ce, 0x66907ac2, 0x16065147, 0x77e3376b, 
	0x5077f9fd, 0xd71fc89c, 0xa175f017, 0x847a841d, 0x77d4d939, 0x82ea9c60, 
	0x801af653, 0xeb3b3567, 0x96d907ea, 0x2bf73b79, 0x059aecca, 0x155277f9, 
	0x1d7917b4, 0xb191b862, 0x2038c629, 0x465a5b6f, 0xfc3a4dd7, 0x19533cfc, 
	0x93900b8a, 0xeb7e8057, 0xca3a8b37, 0x15cfa3bd, 0xebc3280c, 0xac49fd26, 
	0x19cfc3fd, 0xf3c4e07c, 0xc93ad140, 0x6efc4e33, 0x53fec444, 0x69c23b24, 
	0x10e1e232, 0xb38b7963, 0xc454df9e, 0x36f1ee58, 0x7ce8d7e6, 0xa7515aca, 
	0x67f1f270, 0x3eaecfb1, 0xe618ebc5, 0xd45b313c, 0xe1fbc21f, 0xd2366ac3, 
	0xe5e76e47, 0x1c8f58c3, 0x5f6c674e, 0x9db179cc, 0x3dbded66, 0x099a7fc4, 
	0xecc80dc7, 0xbc439ddd, 0x807b71af, 0x82fd2eea, 0x2a788cef, 0xfd8e839e, 
	0x1e4942fb, 0x91c6f299, 0xaf88b878, 0x10c7b433, 0x381d864f, 0x48e65d5e, 
	0x5d44703b, 0x355711a6, 0xdbe1ebe2, 0x623a7e78, 0x2cbc89d7, 0x147fbfc3, 
	0xca14f3a0, 0x0c857958, 0x3fa37f8c, 0x0b7f891a, 0xf6114d7b, 0xb42ec81a, 
	0x358a8a3b, 0x2dbf83a6, 0x27c355af, 0xf2233f11, 0xd45f1961, 0x49cfcc14, 
	0xc3e5064a, 0x587c91dc, 0x58ff9cf4, 0xcc4cb0f9, 0x7970e987, 0x1da1aead, 
	0x3181292a, 0x538561f3, 0xdf6bc518, 0xbe72e32e, 0xcf7f95ba, 0xf3bda461, 
	0xa79132ab, 0x9bec19ba, 0x8c75d1ce, 0xec453d06, 0xce7824a0, 0x47647583, 
	0x0766196e, 0x23f6fbc1, 0x77dc38d1, 0xa185bcc5, 0xeff0b7a3, 0x0b7f3c20, 
	0xa00f1dda, 0x6fdf49bf, 0xa31c79e2, 0xa3e3640e, 0xf58a9c3f, 0xe57b0137, 
	0xdd4efc54, 0x4e956dc6, 0xdacecefc, 0x51dfb9db, 0xe76d5938, 0xd3d3b7df, 
	0x97ce80da, 0xbbf3cede, 0x4eee311b, 0xd69e95f6, 0x635eb312, 0xcedfb71d, 
	0x7ced71d7, 0x72803b0e, 0xe802baa7, 0xbc9f634e, 0xe9ffc44e, 0x5e3644ea, 
	0x4eac3a97, 0x7f576024, 0xc514ec78, 0xd91ce8b1, 0xf3eaa97d, 0x9b7eb87b, 
	0xea59fbb3, 0xa313df1f, 0xec4c6a5f, 0x6a7fd70c, 0x466789e8, 0x3a8c53e7, 
	0xb34e0333, 0xa17ae36e, 0x3ede16ff, 0x518ce42a, 0xe7349287, 0xfad8c1ea, 
	0x6e21e6e1, 0xefef182f, 0x0fd702f9, 0xfdf07ad8, 0xcbb15c3f, 0xd9038a66, 
	0x7c8d9ec9, 0xa04f4c3f, 0x65b017bc, 0x5bd81d42, 0xc8ff70b7, 0x6afa4f58, 
	0x7ad1a76e, 0xabdfe22f, 0xd5e575e1, 0x5e652ea2, 0x9afd4838, 0xce1d727f, 
	0x6cd44000, 0x3d404eed, 0x66aabd75, 0x889e82b4, 0xd1d7cd5b, 0xac6734cc, 
	0x2a7e49ff, 0x4ebda7f9, 0x2184f586, 0x42fe8ec9, 0x6083fa05, 0x79385557, 
	0x3fe18c1d, 0x1daa63cc, 0xd81247f5, 0xd1ccd649, 0x575c047e, 0xe724b56d, 
	0xbb257e0c, 0x0335f80b, 0xaf51b5e5, 0xf7e74813, 0x8ad6145b, 0xdf9f1d7a, 
	0xebd45ebb, 0x75eb44b4, 0xe743fea8, 0xe7581cf5, 0xe83d7581, 0x8cae7fa7, 
	0x62bdfdd3, 0x83aea31e, 0x892e3dea, 0x8c7c8e3a, 0x9387fccb, 0x1cf5145d, 
	0x5b5fbfc0, 0x4645f3cd, 0xf3da10fd, 0x2aabb7f8, 0x7754259d, 0x2dfbfe03, 
	0xf9865754, 0x8fb11abc, 0x440e3c49, 0xd446dfe7, 0x1798481b, 0x49fd700c, 
	0x211c3fdf, 0x9e442b0f, 0x59e46035, 0x541fc21d, 0x6acf3c3e, 0x17ed6029, 
	0x7118ce51, 0x99c79526, 0x1c6f2202, 0x46f07610, 0x45ab7df1, 0x179fbf02, 
	0x6e3295ed, 0x6fcb5cc7, 0x32bbd6da, 0xc6881bc3, 0x03ae2871, 0x199517cf, 
	0x6df81bf1, 0xfe23ca0b, 0xfde2b877, 0x1ce7e22e, 0xb434b2eb, 0x7e236bc7, 
	0xfdc69a95, 0xc78d352a, 0xc997975d, 0xe5e58754, 0xe71669df, 0x71576a01, 
	0xaeb22b3f, 0x11c1fcf1, 0x57abc575, 0xb7c5751b, 0xce5c6196, 0xe71ab388, 
	0xcaeea97a, 0xbcd5e42f, 0x3b22fca8, 0xfff09969, 0x27e6c7d6, 0x1eef88d9, 
	0x0c738c7c, 0xd6ef5121, 0xe229ebcb, 0xe9be30c0, 0xa4660baf, 0xb72f8cb6, 
	0xaaf1ee30, 0x637fea35, 0xe1d6185d, 0xd6065d63, 0xf8ba2fe1, 0x3bf067cb, 
	0xcd6bc5a5, 0x8b51a754, 0xceb03cf5, 0xc0bfcc5a, 0xbe278abe, 0xbb89187a, 
	0xd50a6b66, 0xa61e5307, 0xd3375a33, 0xef8d765f, 0xc3ed2850, 0xf8255fd6, 
	0xe66be0c6, 0xfe402e2e, 0xf00df8a4, 0xf604dcc3, 0xa9775e53, 0x5ff702ff, 
	0x3c2e6765, 0xb7a913bf, 0xbbe89b36, 0x721ccc96, 0xc8d03d60, 0xd9d61cb8, 
	0x8a579f21, 0xd7e6b43a, 0x47f08fc0, 0x287562e3, 0xbd84fa57, 0x776af20a, 
	0x0af5cb88, 0x5db96fb4, 0x53958e6b, 0x45aa9f14, 0x0cc9a4fb, 0x7558de46, 
	0x7265f770, 0xeed77eb9, 0x67d58e7f, 0x6647eef7, 0x0cce98dc, 0x2c73f3fc, 
	0xe950fa11, 0x056d567c, 0xf8cf49d0, 0xd76bebf9, 0x4f6ce42b, 0x577e89e8, 
	0xda2fe503, 0xf77c9197, 0x9857ad27, 0xed08729e, 0x5db9dd90, 0x947d7265, 
	0xdf3eb1ef, 0xc09ef581, 0x0e80fbd7, 0xee1b2e5e, 0x1bf8472f, 0xfc82baf9, 
	0x372ef8b3, 0x39f839c6, 0xf08f7f96, 0xfe73bff7, 0x754ddf3e, 0x300d5ff8, 
	0x7d87bf83, 0x1be504e7, 0xd55e5bd9, 0x306bdf49, 0x3fec5af8, 0x27e23760, 
	0x7889972f, 0x1f8c7ecd, 0xf562fae3, 0x75d6b5e3, 0x5f38ccae, 0xf9e1bf03, 
	0x927ff71a, 0x2c7699dc, 0xba70f097, 0x2343c84c, 0xcfc45c8e, 0x2c165665, 
	0x7198eefc, 0x1fae0529, 0xe0c3b189, 0xe5478c39, 0xc8dd62cf, 0x42971837, 
	0x14b8c3be, 0xbb78739e, 0xdfdff86c, 0xf2e26da8, 0x2773cf3f, 0x8dd697ad, 
	0x2dfc7e44, 0xfd5b778a, 0x37fe69f3, 0xdf86eb23, 0xf8dd6136, 0x6e7465db, 
	0x8723bf01, 0xbf5f46f9, 0xabc88b80, 0x2317038d, 0xbe001eae, 0xbac4abc9, 
	0xf00f9839, 0xbe08a7f0, 0xb5f1c4fe, 0xd7ddff96, 0xf3986ee7, 0x0558f2e1, 
	0xe20afc79, 0xc7908ae5, 0x28e7618e, 0xc731e462, 0xebe186d7, 0x89e88baa, 
	0xd2c6ba9f, 0xc6d5d613, 0xc237e1be, 0x5f08efd7, 0x4e99ef9b, 0xe2f937e3, 
	0xfb8b0f56, 0xa0bd3907, 0x0bfe825d, 0xa31d83c9, 0x47b212ed, 0xd21d847a, 
	0xa097631b, 0xfb0b30dc, 0x67a8a2e3, 0x876d1aeb, 0xaf6ddd50, 0x5da047b0, 
	0xecc1f6f0, 0xa5af30b9, 0xc197f38c, 0x9aecc39f, 0xc4372e56, 0xdec858f7, 
	0xedee751d, 0x918bea13, 0x8eb1aff6, 0x9c42fa51, 0xff3f1cbb, 0xa02ff3ca, 
	0xf8b19db7, 0xc52c3ca8, 0xb2bd81e7, 0xf80f8220, 0x9cd7cf0d, 0xc3e11bfb, 
	0xeb49d2b7, 0x34af4cae, 0xf26ddea1, 0x978e1a2d, 0x6beebe22, 0xbe0d69c5, 
	0x3af9c6ad, 0xf9c65f31, 0xde645976, 0x860e9c65, 0xc9e5c4fe, 0x9247eb05, 
	0xd5be4d27, 0x158f31ab, 0x0fdc2b95, 0x718ae434, 0xf312a82e, 0xe79c7e70, 
	0x9d63d58e, 0xcf4caa1f, 0x0cdc2132, 0x88e108bb, 0x8e1098e7, 0xacf7dfc8, 
	0x245176e6, 0x3c0e3ede, 0x58aefa0d, 0xfc1df06d, 0xfc777c86, 0xdd5f34cf, 
	0xbec5f36d, 0x97baf0ce, 0x4dddf271, 0x0f567bbe, 0xc93483b3, 0xcbed2758, 
	0xdf30eff0, 0x7cc4eb86, 0xfaf3ae1b, 0x39d7c3e5, 0xffcdde6e, 0xf80bd95b, 
	0xe3816fc5, 0xac8c1e7a, 0xbca37e17, 0xe5abc3db, 0x99297958, 0x7c28fe68, 
	0xf281dafe, 0xe0093aaf, 0x6c7cf803, 0xe3027c04, 0x3ef3dbcd, 0x8f77bfc9, 
	0xcdbcd0e4, 0x699b7991, 0x9f9baa5e, 0xde5e4638, 0xe1007e0b, 0x70e1b1fb, 
	0x8c5c3951, 0x2e147cfc, 0x48f3e5c3, 0x908ed4b8, 0x85f5919b, 0x5beb48ff, 
	0xfad3b76b, 0x09f4223a, 0xf9c26dbf, 0xfe9c36bf, 0x46fcf9bb, 0x2701f81d, 
	0xefe63430, 0x89eb0ed1, 0x4f4f81d6, 0x8dcea9d0, 0xe61f5dce, 0x9748e775, 
	0x0d6f5875, 0x6ac2fb7c, 0xeb00fe7e, 0xa9ded1d2, 0xe175e42e, 0xbc61b7e8, 
	0x3801cf16, 0x5c7ea2e2, 0x0c5bf08b, 0x03ce8e3f, 0xd382fb70, 0x87f39391, 
	0x501dc761, 0xfdcd532a, 0xefa45edc, 0x71fa88cb, 0xefc71bac, 0x8ce31a3b, 
	0x58df17ac, 0xcd01e3ce, 0xa4799fc2, 0xe3133cdf, 0x9e454194, 0xdca77f89, 
	0x43fa37d8, 0x0669dc18, 0x3cc3b33e, 0x0fdce575, 0x6bc7ea35, 0xc61c7eb1, 
	0xbcd5effb, 0x1579bcfe, 0x734b0eff, 0xbfa4ee93, 0xc7ea2a57, 0x21f85bff, 
	0x4ee3f531, 0x7b522f61, 0xe233f7d4, 0xaf3a40f7, 0xb7d68f1f, 0xeb06bf42, 
	0x285cfbd7, 0x1c9ea99f, 0xea2d5ef0, 0x79d36bc7, 0xbf8e38fd, 0x651ee300, 
	0xd3f45e7d, 0xfd183b0c, 0x60befc33, 0x81b55ea4, 0x1b9419cb, 0x9bb780a9, 
	0xf8ef8857, 0x37bffe62, 0x4819b75a, 0xf8c34acf, 0x9f7a5d51, 0xfee20a4b, 
	0x2567dd79, 0x38c389d6, 0x401d44d3, 0x38d6417e, 0x2760e275, 0xa5e946f7, 
	0x0cee9b6e, 0xa70a3c02, 0x1fdf5f0d, 0x93ff1f84, 0xb23c7ce5, 0xdec2fdab, 
	0xca3471a6, 0x5ababfd7, 0xc7a039d8, 0x2d73ff31, 0x4363697f, 0xb37fd109, 
	0x859a1bb0, 0x847ef0dd, 0x72e7dfee, 0x49effcf9, 0xb88be81f, 0xff19183e, 
	0x5e0a7ac0, 0xb8bba33f, 0xc79532fc, 0x07ff0dda, 0x998bc104, 0x0003c441, 
	0x7dd59c78, 0xd5547c7b, 0x479ef0b5, 0x92103326, 0x33380491, 0xa0793009, 
	0x014e2023, 0x8728806d, 0x40475e24, 0x44de401a, 0x61849933, 0xa0a0d474, 
	0x1e4e5401, 0x1aa3c213, 0xac3c3514, 0xb54b51e1, 0xadbd8db7, 0x40eb6942, 
	0x2db560a8, 0xeb42d6ad, 0xb41097ed, 0xa5fae6d8, 0x60235ed6, 0x9f63d6f9, 
	0xbd142579, 0xf47cffbd, 0xf3eccf57, 0x5ef58fd8, 0x23b5af6b, 0x9b342154, 
	0xfca28110, 0x8843837a, 0xd5a154e0, 0xcee2130f, 0xd5262132, 0x30aa1108, 
	0x212e8865, 0xe6a4186e, 0xf084336a, 0xc66d6f7d, 0xefb826c4, 0xd3e30b36, 
	0x7ba9fe02, 0xb07cf822, 0x4444e7ba, 0xc2667b88, 0x5c42d5ad, 0x1b4d7f82, 
	0xbd8f0884, 0x076217e3, 0xf34bb7bd, 0x8842b109, 0xbc2ce588, 0x5b2392ff, 
	0xbf60abf6, 0x35699e3d, 0x6d785de2, 0x597c34e5, 0x6126ac84, 0xe6e216ac, 
	0x8086435e, 0x4ef4f5f9, 0xe10b11a9, 0x9814df41, 0xb985b430, 0xe4768346, 
	0x16a2699a, 0xbe612bda, 0x1e7007d6, 0x0a96d691, 0xcdf7a621, 0x689b10c8, 
	0x5ad0bf5e, 0x233bf084, 0xd615ad0e, 0x1a706ed9, 0x557c42ed, 0x3b468ea8, 
	0x6de94bcd, 0x51c46bc2, 0x34efeb07, 0xe60d1445, 0x44d542b5, 0x3b70fbd3, 
	0xc0ab5ce5, 0x9a85bb79, 0x8bf6f30a, 0xf00c6b73, 0x5b801efc, 0xe6e30fd3, 
	0x79a34cad, 0x7ff5c0ad, 0x69d5f702, 0xdf375f3c, 0xdb2c59ef, 0xf8df5e2e, 
	0xaa9eb70b, 0x51e1233f, 0x384f8310, 0x85efe60f, 0x686fce71, 0xc215afb5, 
	0x7ab44f08, 0x7d703221, 0xc89af835, 0x3359f9a6, 0x3faba585, 0x16e3a2dc, 
	0xdfba384a, 0x7dfce071, 0xa35a5321, 0x279fd60b, 0x349d6976, 0xc60d4ece, 
	0xd4bf9d09, 0x09c6e22a, 0x001c01a7, 0xe8142b7e, 0xa40bbe1f, 0x78062b75, 
	0x6707abff, 0x490f0838, 0x1061b8eb, 0x71e615c0, 0x0e6f92af, 0xd5fb41b7, 
	0x965d5acf, 0x17f2f3fe, 0x2f013e32, 0xc605e20a, 0x8b3e29dd, 0xdf8c9b8d, 
	0xf55eb0e5, 0x1bc60193, 0x544e511c, 0xe3645d10, 0xf33a747c, 0xc037802b, 
	0xc98a8def, 0xe1896c69, 0x11fa0f37, 0x0ac21740, 0x7c3a02eb, 0x332bebc9, 
	0x9cc1bf43, 0x1cf99b7a, 0x6777675c, 0x65fa7d23, 0xedd39fdb, 0x01074010, 
	0xb7d11677, 0x5191dacf, 0xd07c85d6, 0x1b765190, 0x73bf015c, 0x6330857b, 
	0x570f80bf, 0x661be319, 0xdfc40bfb, 0xe25f408d, 0xe82f0936, 0x1e0735d7, 
	0x54c42c7d, 0x55a93c21, 0x7c064c42, 0x8840fea7, 0xefe35fc3, 0x1a2166c2, 
	0xeb1edf80, 0x856d5d35, 0xe6edea71, 0x086fedab, 0x9cb67331, 0xb15ad0b7, 
	0xe3b555df, 0xeeb02c3a, 0x613f907b, 0x7f216f5e, 0x9d1f22f6, 0xc8f9e256, 
	0xd2a6f92f, 0x01be226e, 0x78456ffa, 0x235afcc1, 0x8db9aed0, 0xa8e913f9, 
	0x72adfa0e, 0x7ce06495, 0x13e6837d, 0xc37a369f, 0xd71c6665, 0xfc01a805, 
	0x481877d4, 0xde8f743e, 0x7dcf8ad0, 0xb40b0d39, 0xb7fb8636, 0x0045ee10, 
	0x5e0127d7, 0x980eb059, 0x8ef75157, 0xa11f76d3, 0xd609b1ca, 0x212ccb71, 
	0xfda7006c, 0x99978fe5, 0xe66d5ae1, 0x60fef0f7, 0x6cd57f98, 0x467b5e31, 
	0x94e6f688, 0x16f0025d, 0xb52a7b4a, 0x7fac4f7e, 0x34aaa95f, 0x15fc893c, 
	0xa2ea6e71, 0xbf37777e, 0xbd9afc41, 0x9d51c689, 0x7ffe609b, 0xa1d8bc00, 
	0x5fa15bbf, 0x51eed701, 0x4edf129f, 0xe4cbfdad, 0x7fbf5854, 0xe913a98e, 
	0xd837ef5f, 0x997770c8, 0xd03d1896, 0x8ed723ef, 0x228e7a30, 0xf66e7cdf, 
	0x381c3f00, 0x7eeb445c, 0x40ace001, 0xc226677f, 0xf10abfaf, 0xc300f7a8, 
	0x1a0c2dc7, 0x00a823c0, 0x7284ffdc, 0x48e3e562, 0x25a3bed7, 0x59b844bf, 
	0xdc719105, 0x8ad67efa, 0x0551ebeb, 0x2763adc9, 0xbc3b08a6, 0x925b1fe0, 
	0xd68cfc6a, 0x58ea2e91, 0x463f211e, 0x365cb036, 0x3c93ef8b, 0x79bca1f2, 
	0x98aaf11f, 0xfd087e37, 0x9d7f25b8, 0x2ad0f290, 0xe52ec4f9, 0xb4223180, 
	0x3e3003ff, 0x11ac3297, 0x34b7f7c6, 0xcad71aa4, 0xc0030dfe, 0xaa70f5bd, 
	0xa8fa05c8, 0xdfe8937b, 0x14e256d7, 0xda7d60db, 0x38046160, 0xcdf0087d, 
	0xa0043806, 0xc00fd407, 0x18dbd94f, 0x745bcb1f, 0x7f77c07c, 0xf0d43c46, 
	0x92f0f115, 0x666557f7, 0xf200b7a0, 0x33d44ad7, 0xfe316fcc, 0xc876a7cb, 
	0x56fc499d, 0x233e0769, 0x7bbe04ba, 0x03bbbf83, 0x7764cfe4, 0x1e45f1fe, 
	0x1f016a21, 0xefd83585, 0xc7f332e9, 0x921efeb1, 0x3bf7ad74, 0x393ddbd5, 
	0xa47bc615, 0xd22e566b, 0x61bf7041, 0xf113b190, 0xfe265dd8, 0x781eef0e, 
	0x5e708cd3, 0xc10d7cd7, 0x6fdb3839, 0xc40e9214, 0x84ad7951, 0x36bbf1fe, 
	0xfe43eefc, 0x19b4e2ae, 0x2ff93bf1, 0xc26da10e, 0x1c3be1f1, 0x14fb07ff, 
	0x34a1e71c, 0x55c02be0, 0x5d75eae0, 0xf570ed45, 0x08aba8fc, 0xdc9a1de6, 
	0x9c0030ed, 0x17cf4d57, 0xaad79816, 0xf905110d, 0xe78b32c6, 0x7a652fed, 
	0x87bcfc04, 0x352aac70, 0x08a374ea, 0xfaf800fb, 0xc2d4fae9, 0x103e4997, 
	0x02a03c7d, 0xfb811e1d, 0x3c4934bf, 0x3d214647, 0x654b3a85, 0x6d0bb01b, 
	0x7044c45f, 0xefe45d0e, 0x6b07983f, 0x356ebc47, 0x12f9420d, 0x59b26adc, 
	0xa2c1de60, 0xc61a617c, 0x9865f17a, 0x9ef03bcf, 0x207bde03, 0x6dbd2262, 
	0x70b80f16, 0xe41521fd, 0x93d259ee, 0xc08e507b, 0xae11727c, 0xf8ce60c7, 
	0xb8b998dc, 0xa55fdf13, 0x054f1fe4, 0xe27d9ff8, 0x30284541, 0xa722f70f, 
	0xf3fbf580, 0x8e1a9dd4, 0x06bd056b, 0x69142bf2, 0xa0a18870, 0x039a5c7f, 
	0xce26fbef, 0xaeb0156f, 0x3b0df9e0, 0x5ad4f5e3, 0xc448c34f, 0xf4179367, 
	0xd56dd014, 0xb73e1d76, 0xc0f844ec, 0x93c42e5b, 0x45eb47ce, 0x89d8d5c4, 
	0x5a6d69e3, 0x62f7f433, 0xb73e176f, 0x3fc09be0, 0x66a6673e, 0x506afe04, 
	0x85cf491a, 0xe34e2522, 0x92fd3193, 0x1e581f3e, 0xb9ceeee8, 0x3c7b87ac, 
	0x16cf5245, 0x4bb5ff31, 0x7d48f3fe, 0xfe622f6f, 0xc6e7cab4, 0xb68fc453, 
	0x63b0db5a, 0x2d24094f, 0xf9e30f51, 0x78aede11, 0x8ad2defc, 0x71c32ef8, 
	0x018e2e90, 0x57bcc21f, 0x60a92f41, 0xace6f827, 0x66df154f, 0xfd23ae3e, 
	0x0677f20c, 0x27a05fca, 0x737e7fd0, 0xac1d6171, 0x4f9697df, 0xf42caa78, 
	0x217e113b, 0xd8f889af, 0x0e511697, 0x54d3fc20, 0xdf00dbe5, 0x9dfce76a, 
	0x6cdf986e, 0xeb05cf18, 0x8d32be0a, 0x591835e8, 0x7069d74f, 0xe2fa84df, 
	0x19bb2687, 0x7067e8e9, 0x5605b805, 0x6a075d30, 0x43f5d3ce, 0xc50307a9, 
	0x3f1dfef2, 0xba47fa62, 0x73a3173a, 0x215f915f, 0x37e6b03e, 0xeafdc2a5, 
	0x46ae92c2, 0x7b6aafe0, 0xbc46d749, 0xbe85347e, 0xe3ae36af, 0xa3e4966b, 
	0xf6b8d734, 0xda0f2863, 0xd61c783e, 0x7d702811, 0x90207a84, 0xc7e7f6d5, 
	0x49e18e9f, 0x05e3eabf, 0x9e011f90, 0xbc602aab, 0x7bcf4495, 0xd09a5f90, 
	0x001aaaee, 0x6f129d8f, 0xe8c76e2e, 0xc3f7e58a, 0x44ef9a3f, 0x983c3eb8, 
	0xcf1935e9, 0x33800ac1, 0xed09b5e0, 0x3e026fc7, 0x22efac4e, 0xd314e15b, 
	0x3f5f3245, 0x29dd483c, 0xc8cef3f5, 0xe074fea6, 0xd54fe39b, 0x06fb45ae, 
	0x1be103c6, 0xa44eaa74, 0x4507df5f, 0x6c6e62a9, 0x25bda19e, 0x4ef5e2a7, 
	0x03f98fb0, 0xd22b52f4, 0x1973b5f3, 0x5af5d11e, 0x42684f59, 0x085f2073, 
	0xc602f815, 0x2129e15f, 0x8c521839, 0xca376356, 0x24b9e6bd, 0x4a7e0ef7, 
	0x5ff96f72, 0xdc862f59, 0x3f811f20, 0x3f7a91ee, 0xb9f59732, 0x156a9ccf, 
	0xf2caf0e7, 0x3f70c7ec, 0x9eeae813, 0xbc938ef7, 0xfdf1a7f3, 0x3bf80a7b, 
	0x24875f1d, 0x9732bd5f, 0xcb38c7f5, 0x3f7c4ead, 0xf7a14e68, 0x436fcf50, 
	0xbe82af7d, 0x28a37d47, 0xb8079446, 0xecdf9658, 0x777a34bf, 0xe33b45cd, 
	0x57ed34fe, 0x77d2d64f, 0x16b86e7f, 0xf78781ed, 0xdf0e9ca0, 0x0407689c, 
	0xbfea46cc, 0xe8c8bdda, 0x0fdc7b01, 0x90a0f2eb, 0x3b21de51, 0x30ea07e0, 
	0x9adf6392, 0xf001dbab, 0x8a80ec0b, 0x5d6b459b, 0x3533ce17, 0x0fde0ebb, 
	0xb229e745, 0x1b229e79, 0x6de8d9e7, 0xa6f68b9f, 0xbe79b8f0, 0x5437cf2a, 
	0xca15f3c5, 0xb90f491f, 0xfba64d0e, 0x04022667, 0x22de90d6, 0xa3eba27d, 
	0x49f3c595, 0x3c44eccf, 0x09fd8c7e, 0x6f58cfea, 0xdf25f9a4, 0xe3cc5a3f, 
	0x27e130bc, 0xce1d5f34, 0x7cbc492f, 0xb76be25d, 0x145cc8f7, 0xf7e9212e, 
	0xfb2e6dfd, 0xfb2b3e7d, 0xdfa42b7d, 0xcfbf0017, 0x6db94162, 0xec923926, 
	0x167efdf7, 0x0e3ebff3, 0xe11729e0, 0xd91ffe43, 0xacdfec07, 0xc3777c94, 
	0x7d684b4b, 0x88cc3fe4, 0xbfa45bf3, 0x3e642be0, 0x9ffea2fa, 0xfc95de69, 
	0x901be03f, 0xbaf6c17b, 0x00ff78ec, 0x0b31dbf5, 0x07fa17d3, 0xa7d0269d, 
	0xdfe44f38, 0x039fe46a, 0x958708ad, 0xa155ffe8, 0xcfff06dc, 0xa9ffe717, 
	0xcd577649, 0xa2fbf73f, 0x18cb407a, 0xe1932c76, 0xd1ed1c75, 0x6dfad734, 
	0xb41e206f, 0xfbdb5da6, 0xb490b3cb, 0x7ef25e6b, 0xaa14f446, 0xea27bb62, 
	0x17fd44ff, 0x5f68f790, 0xf282ffa1, 0x54f6cade, 0x9ed930a0, 0x08be382a, 
	0xe0076ae4, 0xe0e810bb, 0x0f7f113f, 0x4ea9ecc4, 0x7e622f29, 0xbc765d4d, 
	0xc2fe335f, 0x095ff246, 0xf863fb9f, 0x775ff38d, 0xbbfce3da, 0xf77f215f, 
	0xf013bf4a, 0xfd2bd2b3, 0x47bc24d7, 0x3f0958ed, 0xdc4d7681, 0x67f43ef8, 
	0x68fe62bb, 0x4e87ed00, 0xa276dfe9, 0x3fb0309d, 0xf1e152bb, 0xe6f67f74, 
	0x9343f65e, 0xefbd33f1, 0xe4cbf908, 0x7f5056cf, 0xd02a7e09, 0xadfd93ad, 
	0xc95bd908, 0xac2a0ff3, 0x6bd1fb67, 0x819338d2, 0xa21ad55e, 0x67d2274f, 
	0x36bfea30, 0x19e7d024, 0x40adaf9d, 0x562f209f, 0xf902f8cb, 0xafd03d93, 
	0xefda1157, 0x0655fe80, 0xe211d4d7, 0x1a50c348, 0x63ecd0c2, 0x700acdbf, 
	0x14d7771b, 0xf3ed0d83, 0xc127ec59, 0x975c06e8, 0x637c8f2e, 0x6dcc7b23, 
	0xe1415fd0, 0xec1b9a4b, 0x68b67b3b, 0xecc33f02, 0x237f26ca, 0xcb7c7445, 
	0x0efd0e70, 0x6ff3de7e, 0x2c2a5ed3, 0x7ad96b84, 0xf5c256be, 0xcb575c20, 
	0xb76c9376, 0xdef6e61c, 0x81fedcc3, 0xaf2ebf6c, 0xf5f02f27, 0xfe7e05cc, 
	0xb49785c9, 0x4e757003, 0xdea0497b, 0x62d21574, 0x9d2f1626, 0xc7a87a87, 
	0x27125e2c, 0x5eb4fe69, 0x27bf0100, 0xa11481db, 0x556d1d92, 0x9d0335c7, 
	0xfe6f3dde, 0xbd70ac5f, 0xfbaf1e6b, 0x05f844f4, 0xab9c70f2, 0xf6085436, 
	0x459bb8c5, 0xcd2ffd88, 0x48adff80, 0x55dd4a13, 0x5b32be31, 0xf01ea185, 
	0xc46a72b0, 0xba14fa80, 0x08eb8037, 0x6866a376, 0x1bdc3b44, 0x0dfe879a, 
	0xfb1077f5, 0x7cd10c2b, 0x9084853c, 0x6d9cdbb0, 0x95e9c6ee, 0x88ded4ed, 
	0x399c1bf5, 0xb367315f, 0x0efa40be, 0x81144b59, 0x76c135f1, 0xa1dac061, 
	0x3ff3d008, 0x02cf7987, 0x6c2b093a, 0x28cd9fb7, 0xb13aba71, 0x3aeb925d, 
	0x92adfc82, 0x02b7effd, 0x3b246cfd, 0x7685db2f, 0xffbed083, 0xda7fd273, 
	0xeedf0d8b, 0x6bf44f2f, 0x393ebeb2, 0x50b5f58f, 0xd94f184e, 0xf6137be8, 
	0x2764183f, 0xf98c83c6, 0x21da2b6a, 0xdda08ed0, 0x4f9fec0a, 0x158c0d7a, 
	0xced123a4, 0xcbad0371, 0x16097a40, 0xc6ab6d4e, 0x9b680471, 0x2dbd7df8, 
	0xe9fd70f2, 0x525bccd6, 0x3bcf9fd9, 0xf37ea567, 0x9da99b7a, 0x516d47df, 
	0xd3fa8c70, 0x7ee2de0a, 0x5747bcc7, 0xbe59f571, 0x5c0f757f, 0xd31a2ac1, 
	0x127fa1ae, 0x871b79a1, 0xdca3d4b6, 0xa07a1a28, 0x1edced1a, 0xf8d75abb, 
	0xfe0af32e, 0x8f43875f, 0x8b6845bd, 0x59b79ee0, 0xd98fa89c, 0xde023d07, 
	0xbff9285f, 0xc465e691, 0x8cb6ef7e, 0x33bc85db, 0x8afddbd9, 0xe7c242a1, 
	0x5578312b, 0x0ffa023e, 0x32a876f4, 0x88ab43b2, 0x42bb5783, 0x072f50f0, 
	0x07c03b1f, 0x6dc231e9, 0xaf282e1d, 0x7663db53, 0xd9f754c7, 0x0c6da9c9, 
	0x9faf08ff, 0x7a0461e0, 0xbf98bad5, 0xdab75835, 0x2341acf7, 0x1a0c46b8, 
	0xc26161e9, 0xda07c136, 0x364ed2c5, 0x22301d66, 0x9e9fee7c, 0x8dfd0fb9, 
	0x7dbde7bb, 0x38ebe506, 0xdd4771cb, 0x5293b450, 0xc1753fd8, 0x62bf8010, 
	0x822a1719, 0x95eaafef, 0x8bc607f6, 0xe4938895, 0xec97effb, 0x6784f841, 
	0x08da5d8a, 0x1b7a7e21, 0x3390adcb, 0xce728ad2, 0x1bb99c5f, 0x2617dbed, 
	0xa25e7afc, 0xdb69127d, 0x31eb47dc, 0xa6720e3e, 0x1923c46e, 0x87880a60, 
	0xa6a9fd44, 0x8e3445c7, 0xaafe93e7, 0xfeabfa5f, 0x3e7bd034, 0x5c53638a, 
	0x0277f750, 0x6bc57e69, 0x8de93f67, 0x8897e40a, 0xc9e80272, 0x7b55f302, 
	0x79c1ffd9, 0x622c6f04, 0x08fec7bf, 0x7c077f5d, 0xedbb4260, 0x3dfb3306, 
	0xf7e4ccc3, 0x57b015f8, 0x7643de38, 0xd828e075, 0x40bf6bdd, 0x6dec07bc, 
	0x95fc3734, 0xe227bc7a, 0xfa712410, 0x881c7bc5, 0xb3de3d1f, 0x413de302, 
	0xc642a7e8, 0xf4930a7b, 0xea6feea4, 0x23539ef1, 0x27bc54be, 0x58da072a, 
	0x9d7c00be, 0x360b5718, 0x00ad5876, 0xc65cc32f, 0xa4bf3f6f, 0xe16a70f1, 
	0xc8b6b821, 0x82b85eeb, 0xed2e1baa, 0xeb2fdf40, 0xbbed3ae4, 0x3bdf7c71, 
	0x1ec5527b, 0x4a5757e9, 0x06ec8bff, 0x797cc7f6, 0xc50b5762, 0x86ed13a3, 
	0xf837690a, 0x9c536fad, 0x93f7f753, 0x8e3d36fd, 0xfeff43e0, 0xae3f9c44, 
	0x82bc1114, 0x8aefa7e7, 0x837c0bb7, 0xfbc18e40, 0x0ed2154d, 0x70e3f249, 
	0xf0475c5c, 0x096d6bfc, 0xaf7d4ddf, 0xe8f7e10b, 0x0b271c87, 0x78e68df4, 
	0x2145f018, 0xc25f57bc, 0x7cdd7d7c, 0xa0d6e621, 0x7cdd7ffd, 0xfd1e47f4, 
	0xbe2e5670, 0xf59b1e1f, 0x6427ef04, 0x76bc2689, 0xe79e383a, 0x4589a699, 
	0x59a15534, 0x9a69af49, 0xbafc46de, 0x77e26ba7, 0x49bb6d71, 0xaf42f863, 
	0xf6efd8a9, 0xe23fd81d, 0x67c059f3, 0xa4d0ba65, 0x4668e4df, 0xef959479, 
	0x3e0f01b0, 0xb9f19f30, 0x79a55cbc, 0x08886555, 0x9f3357be, 0x1f7d01fd, 
	0xc1f52024, 0x333f70bd, 0x107bff11, 0x0d15e1ff, 0x7727bf12, 0x39c37e20, 
	0x5a9db8fb, 0xfadb13b6, 0x1d47023c, 0x07c2519a, 0x1b8a33f7, 0xe7733e18, 
	0xd1b85c73, 0x19be773b, 0x6e095ffa, 0xc9bdea0c, 0x1a1fbeca, 0xab064e40, 
	0x9817a70e, 0xad797ed0, 0x29f30ec1, 0x9074cf9f, 0x1ee2f63e, 0xd790dff4, 
	0x38faee10, 0x897ec161, 0xf315cf4e, 0xabc49fd9, 0xf3fbbe1b, 0xed4f8ced, 
	0x66690bd3, 0x9f4377e8, 0x58ed0d29, 0x22770bf0, 0x12a382dc, 0xfa3f42fd, 
	0x869fd085, 0x8ca5617e, 0xbc11130f, 0xf2e17e47, 0x75a58c6f, 0xf75f3ddc, 
	0x5fd7e10b, 0xcef73d71, 0x9db0f8a7, 0x98b1a0f5, 0xade8dbd7, 0x57109f99, 
	0x81287097, 0xb3bec9ef, 0xf5c35cb3, 0x67d2bce2, 0x83d9c627, 0x97b38857, 
	0xece3d7cc, 0xc7c7e7eb, 0xf6bc75d9, 0xc4a2ffe3, 0x54a07b38, 0xbb38c933, 
	0x588ed363, 0xbf38c57f, 0xd0b7da5e, 0xd3c2214c, 0x9f242df1, 0x5e27fad5, 
	0xdbfce580, 0x72375a26, 0x41b1f20e, 0x2bd456a8, 0xda35bf40, 0x125e64bb, 
	0x99655cae, 0x0c3e8de6, 0xe30be642, 0xa6bf28cb, 0x2989bf30, 0xdb96f1f4, 
	0x20f50f59, 0x67ee816e, 0x12226b14, 0x58b87906, 0x8f5a3e6d, 0x5a19fcf2, 
	0xc8f5a057, 0xf5fb3f78, 0x5dfe9b7b, 0x333f3988, 0xfb79c62c, 0x4e0f1757, 
	0x5be5bd03, 0x0d243c5d, 0x24f7f7e4, 0x3872fb9d, 0x32d0f98e, 0x51da0380, 
	0xd0e31cf0, 0xc15534e1, 0x6b1cd938, 0x3db1f7f7, 0x3768da07, 0x5e455b37, 
	0x736bd833, 0x4b665a5c, 0x6835b403, 0x187f7267, 0x009ee897, 0x931e1c70, 
	0x17d9feef, 0x33748bbe, 0x6a65aac7, 0x91e8c54f, 0xbcf899e2, 0x3d839e0a, 
	0x7d7a421b, 0x0adfdf9a, 0xdb726d7a, 0x67947c8c, 0x3c89c493, 0x0edfd22d, 
	0x7de1ce6b, 0x1126cd8f, 0xc3ff3a41, 0xa0ff1e52, 0x25cfc79c, 0x823da37d, 
	0x83e630e8, 0x7690119d, 0x6a35e008, 0x317c5587, 0x6ec7ac3b, 0xec823f27, 
	0xaf693a9f, 0x0bd33c00, 0xbb20fec1, 0x306ed126, 0x7b236b0e, 0x544322a1, 
	0x28f8c53c, 0x896dfade, 0x0f492eff, 0xe101d003, 0xc3d24bbf, 0x41d3fa57, 
	0xba75fe32, 0xe407bb20, 0xac2c58b5, 0x977f3875, 0x0539456a, 0xc11bb2f8, 
	0xdbd0072f, 0x5fa4404d, 0x37b6d1fd, 0xfbcdae11, 0x215102d5, 0xe1215be1, 
	0xd57ddf0d, 0x84f059dc, 0xc42be10d, 0xfd115af6, 0x7da4d9b7, 0x8022f18c, 
	0x2342b186, 0xed247c3c, 0x805b7990, 0x783c27ce, 0xd5f70455, 0xf0474e30, 
	0x5b3baab3, 0x3d2c9fd0, 0x4ce38196, 0x8691996c, 0x01e69d72, 0xcecc09f3, 
	0xe1f836cf, 0xfd7e07bb, 0xc2771c75, 0x155e7203, 0x57da3b7e, 0xc8b3b780, 
	0x6a0e23ef, 0x5f3e9df4, 0x16c76997, 0x3174eb6c, 0xfdb3eda1, 0xfcbf9b93, 
	0x69a4e77c, 0x4607ec29, 0x0c0fd15a, 0x9f513cc2, 0xa6a8388f, 0xcba33ee1, 
	0xe8ebfa74, 0xc1dfa617, 0xe4c134f4, 0xfcd1f5a0, 0xc15b2f51, 0x76f7a78f, 
	0x9bf189bc, 0x30b5abac, 0x81cc17f6, 0x8c7f0175, 0xb61b3a03, 0xbb1eb63f, 
	0x7f32b855, 0x8be8c420, 0xeaaf679d, 0xd9b4bc22, 0x693af2cf, 0x4e2ace9f, 
	0x91437c61, 0xad43c0fb, 0x4058c2a2, 0xeb8e38f3, 0xe1047685, 0x32d54736, 
	0x5dbf014f, 0x81aaf30f, 0xd30e6579, 0xf900696e, 0x9a4e299b, 0xcbd21335, 
	0xafe97a91, 0x402d98a5, 0x95a2e917, 0x14b501f7, 0x52f5cbc4, 0x77df5c2f, 
	0xc47681c9, 0xdeb12e3f, 0x3b8f2716, 0x7a5e819a, 0xfc848be7, 0x90d58084, 
	0x8e1ff386, 0x7987caf3, 0x78a21df4, 0x4d2e3fdc, 0xbc74efa7, 0xf00c855c, 
	0x34f4fe83, 0xfbd3c1e1, 0x597c7f51, 0xbaebe8fc, 0xc23d740a, 0xd7c1ce7b, 
	0xb167c532, 0xe279f571, 0xcd4f98ba, 0x7afaa7c4, 0xe3447875, 0x7f402b9a, 
	0x79e4c5b5, 0x9f2fea48, 0x30d35fd4, 0x507089ae, 0xebfa46fe, 0x91b8bfa7, 
	0x38062bfa, 0xbfa8352b, 0x212ad7e0, 0xde96f41e, 0x2e6afb81, 0xb00ff807, 
	0x7fc8a9ae, 0x77deb7a0, 0x4bf64adf, 0x774fa8f7, 0x098178e0, 0x197d04e6, 
	0xdf481b36, 0xf1849e90, 0x0698ef82, 0x5f78bbb5, 0xcfef03cd, 0x93d743bd, 
	0xe841ebf0, 0xc102f5b3, 0x58c4f3b9, 0xf7a3479a, 0xe8171a0e, 0x9d63f584, 
	0x7d4fee91, 0x13eaffdd, 0xcd4d47e0, 0xb0adb4d0, 0xf316a99e, 0x067fa7e2, 
	0x3b929674, 0xf079eaae, 0xbfb18657, 0xe18ebd1f, 0x6c05bceb, 0x602e942f, 
	0x1c578ffd, 0x799fd93f, 0xb143b7ac, 0x281ed0fa, 0x683f2271, 0xed8d9cc2, 
	0x18e96b3a, 0xf92dbf6c, 0x8bacd1e3, 0x6936eda7, 0xd13ed1ef, 0x3f1831b1, 
	0x1d7dda8a, 0xba15dfbc, 0x1a03f383, 0xd03ba1bd, 0xf054d1ae, 0xf284fec7, 
	0x52d0ec59, 0xc2068b09, 0x2a1511a7, 0x071485d9, 0xce40b8b5, 0x90393c62, 
	0xb37a406b, 0x5345335a, 0xf787de17, 0x68acdf81, 0x7bdd8227, 0x1f5848ff, 
	0x33f021c9, 0xe2e78e59, 0xa3c5903e, 0x7b4f903a, 0x9d98c2d4, 0x95392568, 
	0x74e8f18b, 0x005849b7, 0xf62ee92f, 0x81813727, 0x7f437292, 0x4db2733b, 
	0xb69e3038, 0x64d05dc9, 0x3bb7f570, 0x0e19dcab, 0xe7ed0671, 0xbf6827cc, 
	0x3b53d07b, 0x9ad7ed04, 0xabf1c76e, 0x2895255c, 0xb2b09ee7, 0x4d63d2ff, 
	0xff7553b4, 0xb44009f9, 0x5c58fde1, 0x4f6fde01, 0x49eb4c99, 0xb43e53d0, 
	0xfce3ab63, 0x78ff24e7, 0xf0da7f00, 0x25e3469e, 0xdfe92bea, 0xb835d23e, 
	0xbaebe712, 0xee2f6a70, 0x886ddd8b, 0xe4197dec, 0x3e8057eb, 0x51179cec, 
	0x1dcbf380, 0xc62ce4bc, 0x9a7f740d, 0xd0dbe8fc, 0xd336fe6e, 0xe4d5d829, 
	0x3be5a5a7, 0xecc46f0c, 0xe817ebe8, 0xc5e03476, 0x18efcb11, 0x8ed920bf, 
	0xb40ed9fe, 0xf7c303a3, 0xc0145f91, 0x38dc87bc, 0x6ed93dfb, 0x037af136, 
	0x5aa7f75b, 0x0b09fde1, 0x59372e98, 0xe035dff3, 0x3f33fabe, 0xa572d54e, 
	0xf32d519d, 0xc7ae2835, 0x4f9472f6, 0xd3cfd82b, 0xc968dfe5, 0xfdc57827, 
	0x9d06ebcd, 0x0bb0a076, 0x7bd074ac, 0x5b56af53, 0xefebee51, 0xdfb017db, 
	0x5ddf946c, 0xd0147e87, 0x47c5e6cb, 0x17a4668c, 0x471092ab, 0xab4f6509, 
	0x085a042c, 0xbe48f35e, 0x3919f302, 0xc51ae587, 0x13ae00d9, 0xa21a7345, 
	0x1ba9e80b, 0x6dfd02f1, 0x41b7bd41, 0x630abce5, 0xf907babe, 0x853427c6, 
	0x66f92ef0, 0x81cba05c, 0xcee9527c, 0x801e7a22, 0xb47f682f, 0x1141b0b2, 
	0x0a07c425, 0xf81d81f1, 0xbfd30ce0, 0xe9d25aa9, 0x9974630f, 0x6c9bfb2e, 
	0x0f897353, 0x07c4f9ac, 0xba453a51, 0xf5c621fd, 0x807c457e, 0x18286b74, 
	0x69ff0e90, 0x73d1e75c, 0xeacfe41d, 0x9763d676, 0xe03d3bd6, 0x8f196b14, 
	0x5339418c, 0x18e2fa3f, 0x3a5fa9d0, 0x3a59739e, 0x8bd9119f, 0x0ee8fee3, 
	0x37d13f86, 0xdf300bed, 0x6f810a06, 0xf7c9c477, 0xc87f44f4, 0x74c9f727, 
	0xf9401ef9, 0x0ff9c6de, 0x2c87df28, 0xfc08f5d0, 0xe3c21bfa, 0xcaef9273, 
	0x7ca5c3cb, 0xff202fb7, 0x59df2a27, 0xe2fe825e, 0xfa7ea2bc, 0x7983c784, 
	0x75ce7e52, 0xf4655f77, 0xf1690c60, 0x7ebfa407, 0xe91bf7fe, 0x5c74677b, 
	0xc70ab5f8, 0x5e20b919, 0x0c8d188f, 0x6b57a9ef, 0x0f1c13ea, 0xf17a6e2d, 
	0xc90cebca, 0xdfa8c0fd, 0x8d02f277, 0x4dcfbb5b, 0x1d1b5ee3, 0xee395af7, 
	0x7e0905f8, 0x5f5e51df, 0xfc93dfd4, 0x7ebde8db, 0xef85ea01, 0xefc81e20, 
	0x23b13903, 0x08aabf2e, 0xf9b8befc, 0x39e08a04, 0x32f85ff0, 0xc3f61f7e, 
	0x05d4df7e, 0x2e9f7ef1, 0x6dc5fa87, 0xca8f6fc6, 0x34738219, 0x45cd4abf, 
	0xefef4fbf, 0xaf5f9c25, 0x0c72a3cc, 0xed253f90, 0xc21e9d0b, 0xe3c21e92, 
	0xbe1e88ab, 0xd7cf8516, 0xbfdc1e98, 0x7563fda7, 0x0fe918c9, 0x87a44bcf, 
	0x64af0c19, 0x827c8cfd, 0xb7ac7deb, 0x8dbf69c4, 0xef62b4f4, 0xed8d3d62, 
	0x3f602def, 0x422db268, 0x51f80b7a, 0xb80c7e43, 0xfc8b96bf, 0x5a2ac9b9, 
	0xfc63fb0c, 0x567afc40, 0xf24f85f2, 0x5b8b8c01, 0xc3d7a896, 0x28edf36e, 
	0x52eec337, 0xe9a987e2, 0x8d0faae0, 0xcbcf6ff9, 0xf2949ef1, 0x01deaf0f, 
	0x2fde26e4, 0xe763e781, 0xf00a312f, 0xe60ec603, 0x4570d47d, 0xadca2e49, 
	0xbf8106eb, 0xf61a7c06, 0x48089c82, 0xd86307b9, 0x4c0efca4, 0x09b87905, 
	0xed1877bf, 0x98e3d67e, 0x0176b0ef, 0x46ac27e3, 0xb959e21c, 0xf70fa44e, 
	0x92e8bf31, 0x8c0dec72, 0x8be43653, 0x2fbdb8b8, 0xa8398c55, 0x8ad89f91, 
	0x1989f572, 0x52ad5f20, 0x394a776e, 0x74be2ed4, 0x6fc13efc, 0xf41f7904, 
	0xe9b8d096, 0xa133db0a, 0xdd805154, 0x393f72ea, 0xa96bef2e, 0x98dbfb23, 
	0x17147ad9, 0xfa7da57f, 0x76597c7e, 0xf981ecc2, 0x469feed5, 0x40bdddf3, 
	0x17e133b7, 0x4f9e63c5, 0x1cf50794, 0x1dbcbd67, 0x92e7289b, 0x68c5fae9, 
	0xed0bf0ff, 0x891795d8, 0x6d7c0fae, 0x7fefe4bc, 0x7203944f, 0x7a6a7e1f, 
	0xdfafc5db, 0x3ea47482, 0x40f5cbf6, 0x385c9fd7, 0xb314d69d, 0xc4fed127, 
	0x16a5d7f5, 0x135fa365, 0xf7f2278b, 0x65b8c2af, 0xbabe5764, 0x644f1a20, 
	0x7d44653d, 0x89e32699, 0xa7e8ef48, 0x335fdcd8, 0xa1a7fd22, 0xe307b8dd, 
	0x2a5f85c7, 0x8af368be, 0x368f11db, 0x76495aaf, 0x191c17a5, 0x1466bbc2, 
	0xda35e91b, 0x637e21b7, 0xb76f4f3f, 0xf3d154a7, 0x662f9a7d, 0x8ed0d947, 
	0x3fc65f7b, 0xb3e14f01, 0xe6ae4c93, 0x66da1f18, 0xb8361cbb, 0xef217e3f, 
	0xff2f2dd3, 0x9da882ed, 0x57d988e5, 0x1c0e1763, 0x785fcca7, 0x9ce53899, 
	0x87738a36, 0xec125b4b, 0x57da1b2b, 0x57d9c74f, 0xb0e70c0d, 0xc8c6afb4, 
	0xc5526c79, 0x19efb8bb, 0x2695f696, 0x7363ff3a, 0x60b3e129, 0x275b8c0b, 
	0xd937aab4, 0x05b99baf, 0xd9b2caf4, 0xdcdf6922, 0xfbf08d90, 0x0a19c1ea, 
	0x196ad1ca, 0xee3ca6a7, 0xadaf2837, 0xb97f7e35, 0x1bb22f3a, 0x3d2ad8e5, 
	0xc659bbbf, 0x82fcf5fd, 0x807dc496, 0xda6dfb90, 0x7165f70f, 0xe635777e, 
	0x7dc8553b, 0xf7fd13f1, 0xdd6943c3, 0x5effdc0e, 0x48e1fb85, 0x4e32ad17, 
	0xb9f345ae, 0xb2bdbf69, 0x761cdf30, 0x13bbf7d1, 0xad2fbff6, 0xf4b769dd, 
	0x7bed179f, 0x3ceb8fbf, 0xbe603d92, 0xc338d246, 0x7c0ab7e0, 0x87a7e372, 
	0xda16ac72, 0xd4345707, 0x04e7984f, 0x8ac6eb32, 0xd3ce1c86, 0x3ee3648f, 
	0xf389a778, 0xf3455600, 0x5e5257f2, 0x97992ac6, 0x197993ef, 0x2f32aa0f, 
	0x359f9f43, 0xbcb56e09, 0x3c44125f, 0x5e7fd27d, 0x2c52fefa, 0x5f242b4e, 
	0xfc90bd5f, 0xffe02bb9, 0xe529f014, 0xb9e3476d, 0xef11ea1b, 0x78c4a2b6, 
	0xb9e3006e, 0xb9e3e343, 0xbd788e8e, 0x39a1569e, 0x4a7dee30, 0xe5fd9bea, 
	0xd78c2e37, 0xf41f3aef, 0xa7a2f7a3, 0xa07bf412, 0xe3e31854, 0x0d9fd8ba, 
	0x02ddfbbe, 0xfb4bbf5d, 0x03f132eb, 0xed8d52e1, 0x32379c5d, 0xd7f693b9, 
	0xd7981e8c, 0x1cba85ac, 0x07285f84, 0xf62f385b, 0xa5a389f1, 0x90b39f7e, 
	0x4f2937f8, 0xe385fc6b, 0xb833b43b, 0x94ad13cc, 0xd2a79b3f, 0x4730a17e, 
	0x53fc1f88, 0x6411efe7, 0xc0e03ecf, 0x88bec1e7, 0xdbf691a3, 0xb942edce, 
	0x3935e451, 0xfdfef08c, 0xe7586f88, 0x0a1d854d, 0x05d72fea, 0xa7ef1765, 
	0xff283a35, 0x7d484b34, 0xbf139a55, 0xe6f206bf, 0x631ba471, 0xa4d3e2e6, 
	0xa9ef31e7, 0x8765f51a, 0xbaa7fb03, 0xe77f388c, 0x07a7582d, 0x42e2f9d6, 
	0xf329f799, 0xc23d8e8e, 0x2e3d79fb, 0x5a699f7d, 0xf5d25e62, 0x838704d3, 
	0x9ab78e22, 0xaf28af18, 0xf33ff962, 0xaf3ff9a3, 0xa63c025e, 0x5f9f5e31, 
	0xca6a71c8, 0xf981da9f, 0x310bb53e, 0x7ff680bf, 0x8f9e653b, 0xb214ea87, 
	0xdf46aeb9, 0x0ecbfe8f, 0xcff99111, 0xa3f7fd15, 0x9762f98d, 0xbbc02b76, 
	0x4ea9fc12, 0xfc0d1f99, 0x96fd65fd, 0x02b85c68, 0x5fcbfbf4, 0x8df93fde, 
	0x7eeae78c, 0xb3e37dca, 0xa43da1f6, 0xc95f37ef, 0x8570dcde, 0x51dd98fd, 
	0xac5f84ba, 0x930e99ff, 0x7cf463f6, 0x390b0bb7, 0x9ffc0ddf, 0x6347ce0c, 
	0xbdffcd3b, 0x2ca31929, 0x9c0d5f68, 0x42e0f6ef, 0x16ef9091, 0xec8a73ab, 
	0x689cfaa2, 0x9f5e939d, 0x3cdcf321, 0xaf487289, 0x9e62b98b, 0x94a7a49b, 
	0x9b9e7a45, 0x3ca073ba, 0xe413a0b7, 0xdfdee037, 0x3ce1c86e, 0xc99f9622, 
	0xd4f20874, 0xb4e75899, 0x9d7c6772, 0x39d65053, 0x7a7942ad, 0xbdbcdc43, 
	0xe4fbef3c, 0x49347bfa, 0x513d72ff, 0xb7f32bb9, 0x3139d7fa, 0x27972e7c, 
	0x67c91df6, 0xf4953ce1, 0xd72f0ae0, 0x2dc32521, 0x0f5277ca, 0x9187b00a, 
	0xc9786ece, 0x037b40e1, 0xf90e6ef4, 0x1477eeb7, 0x79fd7ff4, 0xff236f60, 
	0x6279c23c, 0x8f27cc01, 0xa69c371b, 0xc6e2eb3a, 0x62703a03, 0x6e9cc17f, 
	0xbac030c5, 0xb78cbcaa, 0x93d615fb, 0xfe83f3c9, 0x3f66f413, 0xf7f526bc, 
	0x8043ea19, 0x7dafcde7, 0x3eb114a6, 0x90a89e74, 0xe29b68f9, 0x8ac086f2, 
	0x32e8fd20, 0xd7c7e825, 0x73b66fb0, 0x3fd39d65, 0xa09e5216, 0xf3d40bcc, 
	0x5dd7fb05, 0xe5209e70, 0xdf917607, 0xab4e7540, 0xf5fef217, 0xae17ec1e, 
	0x9228593f, 0xce1c9aed, 0x2d923c07, 0x6f5c06e3, 0xfc9ceb23, 0xe9c75768, 
	0xcb237093, 0x36f57eb7, 0xfe223ea7, 0x92762b4d, 0xa45ac97c, 0x6bf08dfb, 
	0x0cdbd615, 0x2bfc445f, 0x59c66deb, 0x587f656e, 0x4ba587fa, 0x6dde5e58, 
	0xca0f67b9, 0x55e75b11, 0xbded09a2, 0xefed08ca, 0xd7fb74db, 0xdfece5fb, 
	0x926747fb, 0x8af9225c, 0xa498a97c, 0x31c7abfd, 0xa2a2f393, 0xe6036ffb, 
	0xfda5f8f9, 0x7b69fb4b, 0x64d5cbfa, 0xe565fbb9, 0xa18be7ea, 0x72624fcb, 
	0xaeaeeef5, 0xda134abd, 0x7e19d3d1, 0xf4ea9556, 0xf18939fc, 0x198b43ca, 
	0xf4bcb17e, 0xf5899c5b, 0xb39f7226, 0xd127cf51, 0xc48eb072, 0x2fcd1cdf, 
	0xd77a8919, 0x07cf513f, 0xb9f12310, 0xa935af4e, 0xfec8a7c5, 0x168eda10, 
	0xd8eabf9a, 0xb71c7186, 0x43f5cb9a, 0x9bdb0511, 0x1bdf3117, 0x9e719e81, 
	0x9dfe0555, 0x15c15f48, 0xcf5914a6, 0x0af3d0e2, 0x3b813ec8, 0x7cf83d4d, 
	0xc1e50a5a, 0xcb10394b, 0xdcfb97d7, 0x10cf5c4d, 0xc6ae88b2, 0xf89f1a32, 
	0x93e6db0d, 0x6c6686dc, 0x0e1dcdbe, 0x5a6e2663, 0xddedb29a, 0xc3b8e578, 
	0xcf6fb82a, 0x45b1e216, 0x7a87f7ec, 0xd7c40ba7, 0x7d6df0cd, 0x0edefd18, 
	0x3fde0787, 0x7b65301b, 0x690eeec0, 0xd80f1ca6, 0x9e92b520, 0x0035707d, 
	0xcc2fee7e, 0x210f7ce4, 0xe4e2d61e, 0xae0af566, 0x7ac6a897, 0xcb16bc0a, 
	0x4f5c1df6, 0xa3e644b1, 0xeb2d5f54, 0xbeb23c22, 0x12e38fa2, 0xb8c3a767, 
	0xbe86af40, 0xc0568e4b, 0x988bbdef, 0x25cd435f, 0x38808f34, 0x896f68e2, 
	0x270ba3c5, 0xf3e24665, 0x1c259425, 0x612fb64f, 0xd3cf47bf, 0xb662c9ff, 
	0x5dbd7533, 0xc9c808f9, 0x748f6833, 0x936862bf, 0xe6274476, 0x4f1fe5c1, 
	0x31fac8f5, 0x4f1af3c0, 0x595dcb07, 0x316c363f, 0xbe222bd7, 0xd5c53e51, 
	0x7c1c7055, 0x06a5d728, 0x1714aa86, 0xd9376e09, 0x6c08ced0, 0x78b20d37, 
	0x7a0e3e30, 0x33d615b9, 0x784d9cd6, 0x85df5f6d, 0x6ae841f6, 0x0fa49773, 
	0xe5c45997, 0x3800fc9d, 0xe29bde0e, 0x4c78a7cd, 0x63c71164, 0x24aeb242, 
	0x1a4aeb24, 0xc671f9ae, 0xdbac06e4, 0xeb04fb6a, 0x69ca1e4b, 0x70f36c7b, 
	0x5db416b8, 0x43f87683, 0x9bf56d59, 0xdf5fe99f, 0xe7f22a15, 0x0fde601a, 
	0xf5405f5c, 0x506c0f5c, 0x5a215eb9, 0x1d51a5c7, 0xd72b0ad7, 0x615a5531, 
	0xb79875fe, 0x5ce7eb29, 0x2e8eee6a, 0x4e86afa4, 0x61d12747, 0xfd59d62e, 
	0x5fb622c7, 0x3413edfa, 0xbf154e1e, 0x245ad786, 0x587634bd, 0xd03af931, 
	0x601fef2c, 0x3c4c0ffa, 0x6d2175cc, 0x493cdefc, 0x3e688107, 0xe40ecb56, 
	0xc7cc80cf, 0x7147ab8a, 0xf9fabc20, 0xd12cbf13, 0x27d65cf9, 0x2ad9bd72, 
	0xc25feb95, 0xcdeb47af, 0xe7c3ef88, 0xcfeb134a, 0xff08184e, 0xde7adde1, 
	0xef06b89b, 0xeeb98b6b, 0xf39dbc2c, 0x6f8802f8, 0x02f8f3c4, 0x063a7a61, 
	0x3de0fb8f, 0xaae5d007, 0x6d979c13, 0x86bfdf16, 0x2d5441f6, 0xdcceeb97, 
	0x2ceeb807, 0x63f20d72, 0xf5aceeac, 0x03fef84f, 0xa19bb01e, 0x3ecfb3ff, 
	0x98ad14e8, 0x1b223f17, 0xab2165e3, 0x02aed5c8, 0x8184f0fb, 0x43f62edb, 
	0xef6f9582, 0x5adc3cc0, 0xf448c36f, 0x8fd09a33, 0xdcd47ce6, 0xe4b27af8, 
	0xfae4b27c, 0xbd6587b3, 0xec15f3d9, 0xf45f0767, 0x37af8b9c, 0xd2cc4c0b, 
	0xca687ed0, 0xfec1ec8b, 0x48cc4f1b, 0x5b6b37a8, 0x3331fbcc, 0xa3bf4b17, 
	0x89a7e64f, 0xbd42449b, 0xeb6fcc99, 0x7bcf9429, 0x33f75b65, 0x5095ddce, 
	0xe57c466f, 0x455f4fea, 0x2cdeb98b, 0xa3c016f8, 0xaa585c93, 0xe0ac0b37, 
	0xd230b37a, 0x1be436fd, 0x595b5bf0, 0x19fd531e, 0xb4a99bd6, 0xf179400f, 
	0x5cfe1595, 0xe793d7aa, 0x1edf2003, 0x4bfce568, 0x7b1b37aa, 0x8a374ec7, 
	0xdeb2c5eb, 0xc469f5ec, 0x67e04187, 0xcb16dabc, 0x67594bbc, 0x059dd7a6, 
	0x5e93fd65, 0x3ac21b67, 0xe503b5db, 0x93fc325d, 0xd1836ceb, 0x2288db3a, 
	0xe3d36ceb, 0xd9d7a9f1, 0x34b5814e, 0x67500f55, 0x2777fbab, 0x63c624a6, 
	0xb2cbbcf4, 0x0cbbca3a, 0xeb22f546, 0x57797eab, 0x5b3af407, 0x780c07ce, 
	0x1f6ceb12, 0x46cd7e07, 0xeb4457fb, 0x3af8956c, 0x711627db, 0x47be135e, 
	0x3fc8b6f9, 0xb3be0720, 0xa043f588, 0x7241dbaa, 0xd7d650a9, 0x50bf4bb9, 
	0xad385d7d, 0x2972facd, 0x2db5f1e6, 0x2e17f947, 0xfca0c6d0, 0x55b5670b, 
	0xce4bfca0, 0x23c7d71b, 0xf3c719bb, 0xe275f5ea, 0x79f1c200, 0xa3f4ffe9, 
	0x6f3273db, 0x4b87af53, 0x7f6bd7d2, 0x6b75f5ce, 0x297f4b07, 0xd283ae89, 
	0xfd1e7a5f, 0x4f983196, 0xf8f59eba, 0xbafae4c1, 0xeba46c94, 0x3b2283b5, 
	0xb22ebeb8, 0x93dfeb03, 0x337824e9, 0x2485d7d7, 0x9cf0057d, 0xfd0fac08, 
	0xc9d7d648, 0x595a0679, 0xb19f801e, 0xbdc7fc87, 0xebe3a71d, 0x72953eed, 
	0x7be4b776, 0x076e7291, 0xfafa73f9, 0x38d27da5, 0xc28c91fa, 0x667cf886, 
	0x5203f3f6, 0x73b6860e, 0xf308733e, 0x77147d98, 0xd530b8a6, 0x2d1ca215, 
	0x3e6076ea, 0x173dc033, 0x560399f3, 0xccf98d91, 0xf5c45dbf, 0x3295d524, 
	0x65bff99f, 0x11e7b33e, 0x9d2aefc2, 0xf32efeaf, 0x735e6599, 0xf7b90140, 
	0x89ffa427, 0x396f14d9, 0x5a2eb89a, 0x91f1c607, 0xf8e2ba1f, 0x1fe390aa, 
	0x8bd4f4fd, 0x1cf67ad1, 0x04ce67c9, 0xf5fc89b9, 0xf779715f, 0x6b1ca407, 
	0x95e5fc96, 0x949156fc, 0x38dedcd7, 0xea3871ac, 0x84cedd3b, 0xcf2eeb7e, 
	0xc97f515f, 0x384370c3, 0x293e3ea3, 0x2cf507f9, 0xee48bfc6, 0x2d7a4a56, 
	0xe06fd188, 0xb3c8f932, 0x2a6e3ca5, 0x3cfc24cc, 0xd47195ef, 0xc90f3a24, 
	0xe5006f38, 0x47c817fb, 0x3ae20c0e, 0xbe17d201, 0xe38f74fe, 0xf9fb7d52, 
	0xbe127b4b, 0x473c8e33, 0x1f72cef5, 0xf0f7d751, 0x16bbc974, 0xdf787796, 
	0x2b85f98f, 0xd87ecaf1, 0x54ae4bed, 0x44fbc1e7, 0x1e75ebff, 0xffe85f72, 
	0x648f3ab7, 0x8e3084f8, 0xaf3ff156, 0x38ebd0eb, 0x0cb91e08, 0x10e3ae5f, 
	0x35d14e63, 0x85d68632, 0x7bf9207e, 0x7a7ff92a, 0xd4760a1e, 0xc3fac03b, 
	0x05c6ff12, 0x9a138c5b, 0x05ad7c65, 0x3897d0e3, 0x713b36ae, 0x794af97f, 
	0x621fe8c5, 0xb97f78bc, 0xfc7c4965, 0x2637ea39, 0x2fee1ff3, 0x5fdf89ef, 
	0xad5e508e, 0x033cbfbe, 0xfbbe0ff9, 0xbfe662d1, 0x245e7f64, 0x483497d5, 
	0x0ef46d7e, 0xbf26625f, 0xf39ebd44, 0xb76322e8, 0x8bed8b8e, 0x97c7f5eb, 
	0x229a6bab, 0x9efc3de9, 0xfe962bac, 0xb120b84d, 0x25c6f90e, 0x9693dfcc, 
	0x49c875e8, 0xd7a02ff5, 0x11ab1f49, 0x323b9e07, 0xf3a3de0c, 0xdce2925f, 
	0x574a79fa, 0x916eebf2, 0xd7ec9d7c, 0xd403bf51, 0x3fdf26f9, 0x9df3ad1a, 
	0x25e304ba, 0xed1a3ab1, 0x4cb5cdd6, 0xfe638fc7, 0x48479cb1, 0xe72423ce, 
	0xf8f39211, 0x21e7d4a6, 0x9c908f39, 0xbe1fa3c7, 0x38f9d0a9, 0xf7294fb8, 
	0x8ddf38cb, 0x897333f1, 0x9336ef9e, 0xf490e3f0, 0xb387e8f7, 0x66750eb8, 
	0x774813e6, 0x93984c2f, 0x91e13f34, 0x5df9a478, 0x17e41c37, 0x994ad3f0, 
	0x363e1b4f, 0x71e290a3, 0x68ab66a5, 0x0ac9d58b, 0xe9367d53, 0x81d1932f, 
	0x49776ad7, 0xef7ff636, 0xbf0d9378, 0x537af7bb, 0xdc46c031, 0xb8a351bb, 
	0x0d357dc3, 0xfe802f94, 0xabe03344, 0x9fef096a, 0x4197d7df, 0x2eb23bfe, 
	0x79f7effa, 0x08fb7645, 0xdcd403b4, 0xeb71e076, 0xbbb7e952, 0x1f70559f, 
	0x69773ef5, 0x7839d52e, 0x5daec9b2, 0xc1c7cf04, 0xbe917bf3, 0x566eaec0, 
	0xe79c76fd, 0xceea598a, 0x5623b016, 0xd3b65a4c, 0xaeebc36a, 0xebdf9433, 
	0x576817c9, 0xb71c9d07, 0xfdd95e6d, 0x0aef9c7d, 0x7b06efcc, 0xd9713826, 
	0xab53b44e, 0xe2e436fb, 0x2e3fe47e, 0x569dc34d, 0x31f32a51, 0x59ebbaf4, 
	0xf9c02e38, 0xdfde5afe, 0xa93cc6af, 0xbafdf0e3, 0x4fb46c8e, 0x5e82f3ee, 
	0x297ca3aa, 0x619e7c6b, 0x5f23ab95, 0x153e64f8, 0xa8055fbc, 0xf3f7846a, 
	0x3729df30, 0x2e363796, 0xf2a0a5d0, 0x5dfaefbf, 0xfc835705, 0xdd5d2eb8, 
	0xede609b2, 0x15c8cfb7, 0x6a0f9c0d, 0x79c718fd, 0x56ed1b2a, 0xfd139bc0, 
	0xabe22081, 0xf8f7c625, 0xb11b9d1e, 0x311b9e46, 0xb768af86, 0x69c36c34, 
	0xc60b4aa9, 0x9e5653cb, 0xd775c3b2, 0x44ab8e12, 0x24d622e3, 0xebc4fafb, 
	0xbf5f6859, 0x25d9e130, 0x3fb3d503, 0xfff98cbd, 0xf45ddeeb, 0x1d754afc, 
	0x308fb90e, 0xd1b773fa, 0x54f6f283, 0x5811e51f, 0x0df3e5de, 0xdf44b9be, 
	0xf526f847, 0x5bf7a0f7, 0xa68e304b, 0xead8bcc9, 0x1e372cad, 0x6f645ebd, 
	0x5f69ba02, 0x642d72c2, 0x036e3716, 0xbe995a3b, 0x04706a6f, 0x8e598d96, 
	0x5a87d33e, 0x05aa8230, 0x969c8bbe, 0xf0fbff74, 0xf0d7580b, 0x7855c932, 
	0x8e7ba9ff, 0xd82ffbe1, 0xffde199f, 0x6fd5cbbd, 0x339ca59a, 0x589c384b, 
	0xd1e0fbc2, 0x89518a3c, 0xfafa7afb, 0x8f1c5cf1, 0x9d87162f, 0x3900f085, 
	0xdd747af7, 0xf5f70bf0, 0x5f68464e, 0xd377e0ef, 0xe83cfe49, 0x6870413d, 
	0x5e1c31b3, 0x1246f098, 0x93ee475f, 0x5b37e772, 0x327c03c7, 0x833c6fc0, 
	0x3643b057, 0xfc823b52, 0x1812ca12, 0x1338c756, 0xfa3ebfd5, 0x8139677f, 
	0xa2b9856d, 0x693e4143, 0xe85ec156, 0x66e7e780, 0x87681539, 0xc60d31de, 
	0xed567873, 0xfa1a7513, 0xd1135e4b, 0xdf72b9b3, 0xcd37f469, 0x989dfe95, 
	0xef1de37f, 0xe00a792a, 0x6dab2738, 0xc7f456e2, 0xc4a57ee6, 0x1a08f801, 
	0x9d700da1, 0x34df9de5, 0xfd03e254, 0x73de7d70, 0x5fe625ce, 0x217aca67, 
	0x4ff385af, 0xc6ca80e7, 0x66dba23c, 0xa8ebe6fe, 0xc55b271f, 0x98bbcc10, 
	0x29c1b7de, 0xe7d5f8e2, 0xeecafce5, 0xe5dd5f51, 0x0084f806, 0xfa01dffe, 
	0xbab803eb, 0x29f1637a, 0xc74be63f, 0xd74f67e5, 0xf9389dcf, 0x27c3a277, 
	0x0e880bab, 0x8f8a3bff, 0xd87496ff, 0x4817f047, 0xe9df8087, 0x8481ffc8, 
	0xbe04c93c, 0xd1f0171f, 0xe7c431f9, 0x859a2f20, 0x7cc34f39, 0x833b5522, 
	0xd3e9bcf8, 0xc045f943, 0x769745e7, 0x7c0d5c14, 0xe0fce1bf, 0x771806fd, 
	0xfdecc5c3, 0xd8fe7806, 0xa7f6b3c7, 0x381e64d8, 0x9f63f3f0, 0x829fdb2c, 
	0x83ca027e, 0x1daf944c, 0x337d7c4a, 0xe749dde0, 0x9f9ccd62, 0xca71a66b, 
	0xf8af689c, 0x9414c7dd, 0x67297e17, 0xbdf80a82, 0x39496e30, 0x57d604e0, 
	0x7676e129, 0x55db29b4, 0x0506ed81, 0xaea99beb, 0x69eb0bb9, 0xfa014fc0, 
	0xc3a2a7b9, 0x7ecdf589, 0x7de32911, 0xed66c8f7, 0x1fce2fba, 0x6bfe97e3, 
	0xa97631fc, 0xbf013fbe, 0xed4daf30, 0xc2c73ca3, 0x1fc91ce6, 0xfe5297e3, 
	0xcfc620fc, 0x5bae130b, 0x1b1fc49a, 0x7f135f25, 0x4470c198, 0xdcf0d7fa, 
	0x3c9f8441, 0x0fe2906f, 0x60de793e, 0x8cd9f710, 0x2c734754, 0x1f3bee47, 
	0x76887190, 0x9f249fb9, 0x79f04647, 0xbff3b118, 0xf4df91b6, 0x79a06cd1, 
	0x8ad437dc, 0x459e6087, 0x79359f74, 0x3fe6469f, 0xe974964d, 0xfa06ebd0, 
	0xee5d13ce, 0xd1146f7e, 0x38516de5, 0xeb94b6dc, 0xc52d6606, 0x2b4ea7bc, 
	0xff6885cb, 0x6fe5122b, 0x75425d72, 0xcf95bcf4, 0xc5e81f68, 0xfea38f1f, 
	0xe9d52c17, 0xdd117e1e, 0x56b8222f, 0xeeafba48, 0xf024a4bb, 0x7f8fac9d, 
	0x6ac7ea4a, 0x4fea973c, 0x226def52, 0xf3c473ba, 0x4ecbf005, 0x902e3e7c, 
	0x0fd82d9b, 0xcabf7b21, 0x7349fecb, 0xf8bcf4e7, 0xfedd103a, 0x3930aaaf, 
	0x0fcc4744, 0x684f4668, 0x73d5e632, 0x8f2c715e, 0x9703fa4e, 0xf24abfab, 
	0x207b7407, 0xeafbcbdd, 0xf787b5e1, 0xf4c73616, 0x9e4cb8b0, 0xc15e7eaf, 
	0x6b1dfd65, 0x175d426b, 0xb3b473ea, 0x7f995dee, 0x3b42e0dc, 0x01aa7229, 
	0x6dc767f7, 0x7afe4d3f, 0x75b57d92, 0xdf37ef29, 0x91ca6357, 0xf3139476, 
	0x4fdbfb10, 0xa7ed13aa, 0xb05702a0, 0xf8979e07, 0xaae73f23, 0x7dd5fefe, 
	0xb45c92de, 0xdd8f365f, 0x0d7b17be, 0xf4f0fe7b, 0xc51bd658, 0xf2c3be5b, 
	0x7427e913, 0x4a803c99, 0x23ed097b, 0xed1cfd12, 0x45cf3f4f, 0x4939f3e9, 
	0x7d13cf9f, 0xc37f52aa, 0x2e732e7a, 0x798adbc3, 0xf3b7de17, 0x074a0cb9, 
	0xcba0cb9d, 0x993b682d, 0x416f405e, 0x3bb0163f, 0xd675836e, 0xc338e62c, 
	0x4e25d1d9, 0xced05f94, 0xc988cd71, 0x11ac7baf, 0x0cf9fc67, 0xe11da17e, 
	0x332219f3, 0x3b49d7c3, 0x0df31872, 0xf981579e, 0x2f815b0f, 0xfde52c8f, 
	0x246f5d18, 0xf9e2dde7, 0x62db1374, 0x8d3fd879, 0x42fc0df2, 0x263e2dfd, 
	0x8ad0fdfd, 0xea1d30af, 0x9306b6f9, 0xb23a6bcc, 0xc5fbdcd4, 0xc7937cf3, 
	0xde3a2b7b, 0xcade3c5b, 0x3fbc68cf, 0xfea16cde, 0x4277f9fb, 0xc079fbee, 
	0x47b8041f, 0x115eb296, 0xcf918f56, 0x273f6123, 0xfc80be3c, 0xb7f790a7, 
	0xf3c0bf34, 0x5f6d935d, 0x617aaec2, 0x134b7bc2, 0x127544ed, 0x39cd05da, 
	0x6ecf356d, 0xb62cfae7, 0x5fa3b453, 0xfc3c76ff, 0x7563de1f, 0x0ad85eb0, 
	0xac9bf870, 0xede98cbb, 0x10847844, 0x5fdc2e1e, 0x147c7867, 0x0c47c785, 
	0x496feb0f, 0x81f2fc3f, 0x3ff08931, 0x52799462, 0xeb2a5d7f, 0x6aea139f, 
	0x2e9fa8af, 0xa23ffe33, 0xd60fff74, 0xc243e24f, 0x05cdf8c7, 0x4757e603, 
	0x844f59fd, 0x64defdfc, 0x8263087c, 0x00f28b3f, 0xc610cffd, 0xe7cf810d, 
	0xca0aa814, 0x459bac0f, 0x78493ab9, 0x0ec26ea9, 0xa0a99c56, 0xd0dcbd7f, 
	0x9a4f2c65, 0xeb0f3185, 0x4360c365, 0xe6fedca1, 0x9811e072, 0xe7e944f7, 
	0xb44de9cc, 0x4a9ce6c7, 0x7d021f6c, 0xa126b8b6, 0xe195b32e, 0x3ee2b6ab, 
	0x39875eb3, 0x5a5f61f1, 0xfd5c434e, 0x34fc15a5, 0xac04cf98, 0x9fd4dd03, 
	0xbdbcbe6e, 0xb78eca6a, 0xd3ed5757, 0x40dc934e, 0xbece35bb, 0xf40fb55c, 
	0x5bb4974d, 0x5a9da137, 0x53b4b8f1, 0x1679683f, 0x8f55d4ed, 0xaf7d0267, 
	0x41f3da6b, 0x53b408cb, 0x5499cedf, 0x6a9d803b, 0x7ed132d7, 0x879a299b, 
	0xa4b27ce2, 0xecab365d, 0xfbc150f4, 0xa0ea5beb, 0xda79cdff, 0xfa07cc5e, 
	0x75a1ebb2, 0xacbae5f8, 0xd8f61d72, 0xe0c9def8, 0xeb62f9ef, 0x7328e3d0, 
	0x3af8bfa0, 0x3197dba1, 0xe32f961d, 0x1db24a78, 0x3ff65fe6, 0xa5bcc3b3, 
	0xcbe74495, 0x067ce996, 0x3ccf90bf, 0xdf505f5c, 0xfaf4429d, 0x197cb7a0, 
	0xf488fbca, 0x78ed9253, 0x3b27bedd, 0x66e882be, 0x9315d60b, 0x4d7e4f7d, 
	0x78a4b2d5, 0x76f13bc5, 0x8213e4db, 0xe91d34e8, 0x40fd17b6, 0x111ba955, 
	0x5c6d378b, 0x7879f036, 0x0e38cb0d, 0xcd6f7bf5, 0x64fbe432, 0xf23300fe, 
	0x606b9623, 0xe5fd68d5, 0x4dafd454, 0xb91aabb6, 0xe2eac0ff, 0x69a79821, 
	0xbfa4356d, 0x9c9895f2, 0xcba65bae, 0x7285f805, 0xe49a7ec1, 0x38c95a52, 
	0x8206af09, 0xf74f3a97, 0x25971aeb, 0x87f2cb9d, 0x9a3ff5f8, 0x55d6e6a1, 
	0x9c2ae8c6, 0x41547405, 0xf70539f1, 0x6674a3b9, 0x2cdf3d05, 0xf702abe9, 
	0x849e8187, 0x097e1794, 0x9f09369f, 0x457463f7, 0xfc4c0874, 0xff8e12cc, 
	0xfb642a4d, 0x91d8502e, 0xcdf712b6, 0x39c709c4, 0x60cfcba0, 0x5835155d, 
	0x14ac2cef, 0x013f0467, 0x960e09cf, 0x61dba636, 0x705561bc, 0x353e4e3f, 
	0x1794ddf7, 0xc804472f, 0x36c38c31, 0x90f9f77b, 0xfdc8478f, 0x3673b425, 
	0x772fea6d, 0x2f7ddeec, 0x8e893a98, 0xfbb07ab4, 0xebd32f8e, 0x797f2394, 
	0x8fa636bc, 0x786f4e26, 0xffe81578, 0xa65f0709, 0x6939a234, 0xbc67869d, 
	0x7fab6d78, 0x3aff5872, 0x7e5baa66, 0xc754db9f, 0x9b3d37dc, 0xd64240e3, 
	0xe366a72f, 0xff581e39, 0xbe7de78b, 0x1ef98cb4, 0x8e11a5eb, 0x08703d7a, 
	0xc06199eb, 0xb45fb8e1, 0xca2df58f, 0x598ebd1d, 0xd7fb8baf, 0xbc25cbeb, 
	0xeb13ba85, 0xa99743cb, 0xb2fdff2f, 0x7397d5cb, 0xbeac7cfd, 0xea91b23c, 
	0x2b77666c, 0xcae5f509, 0x797d6eff, 0x1567cc2f, 0x31784be1, 0x4f5f183e, 
	0x78c0dcdd, 0x8636b419, 0xb1968f97, 0x3f1fd5fd, 0x3ae5f589, 0x3ccea81e, 
	0xb92f5f2e, 0x88c7fcbe, 0xd733e037, 0xac5b83c1, 0x81d72ba6, 0xbe7cf8e3, 
	0x03af3ff8, 0x87a4b1ff, 0xaa75fae4, 0x9ec50f5b, 0xef99db37, 0x73c078a2, 
	0xb9e4ba08, 0xebc46f09, 0x9f2b48d3, 0x00e7c073, 0xce732ef8, 0x9fc72f81, 
	0xcfd2f88b, 0x1be7d039, 0x2aeeb7d5, 0xa3a3ccbb, 0x58e60ef3, 0xd49ea98a, 
	0x0f847e88, 0x1510cdcf, 0x06e7e836, 0xdc6b77a0, 0xcb4ddb3e, 0xac41ee19, 
	0x7206da97, 0xf148d6a3, 0x3a841be7, 0x8bd0fd04, 0x39783eb8, 0xfa8332cb, 
	0x9439fac3, 0x793e78db, 0x9cc5c80b, 0x513bd672, 0xa548adbb, 0x727d47f3, 
	0xe7f460bf, 0x40dbb925, 0xcc0f042e, 0xc2e7b0c8, 0x81cd76b8, 0x37d19d71, 
	0xc76dec89, 0xf729d885, 0x77934201, 0x6bfac69d, 0xd41557b0, 0xef3fa3ab, 
	0x6286d568, 0x54c3693e, 0x7c4abfc9, 0x87a55a5e, 0x395654e5, 0x4b8737eb, 
	0x16cedbee, 0x7f317abb, 0xaddbe669, 0x7cfc2d35, 0xbc67ee31, 0x9e2a687e, 
	0xf93fecc3, 0xc0cf5f19, 0xffb6e415, 0x9cb6d913, 0xea7db6e7, 0xc1e6ba34, 
	0x964fef15, 0xd7937fed, 0xc57475b2, 0x21ba7c79, 0xdfdd6eb6, 0x0b33dbd7, 
	0xc0413e79, 0xf401b2d3, 0xc8cca053, 0x573c97f6, 0xe3396165, 0x67849e61, 
	0x73e4b2cd, 0x1b3af450, 0xcf05073e, 0xf3fcc161, 0xe2b39e10, 0x850f3f89, 
	0xe9c23beb, 0x9e5b9ef0, 0xbf8c3773, 0x4250f3c3, 0xc00b4e78, 0xde7296ed, 
	0x73c9f257, 0xfcf27c5a, 0xdd1539de, 0x55bcc7df, 0xee5cee5d, 0xf3fe969c, 
	0x458bf993, 0xff5b6e30, 0x98025a73, 0xc7cf8597, 0xd579a45f, 0xf3d13e48, 
	0xadbbf02f, 0x34664007, 0x85d75d80, 0x0ce3b057, 0xb675bf68, 0xf64a553c, 
	0x7fc63a5b, 0xdaff7383, 0xec8c7992, 0xcf6df4b7, 0x3b96fd92, 0xa3388069, 
	0xdbb64d7e, 0x72ee7b74, 0xe586ab71, 0xaadc5aff, 0x2f6eb96e, 0x97b42fc1, 
	0x39223e2a, 0xa9983071, 0x18e5ffeb, 0xe9b4e95f, 0xe5c6ab71, 0x2349fb49, 
	0xffe9c4b7, 0xdb6f1a2f, 0x9ded9cb1, 0x669bc52b, 0x35f5d725, 0x26f1407f, 
	0xcd2b68e3, 0xbae5d9ef, 0x72ecf2fd, 0x2c77e7f6, 0x41bb3aa7, 0x33b2bdba, 
	0xfe6abe69, 0x7438b896, 0x30bbf300, 0xbb611c6e, 0x8dfd222d, 0x72cf7790, 
	0xe4aec3b4, 0x3bd1c64f, 0xbd208de7, 0x0fb7f5b4, 0xf4803d74, 0x9f597288, 
	0x00e3184f, 0xc3919798, 0x3c5101e7, 0x07ee69e1, 0x39dfabe9, 0x3d17da27, 
	0x928364e7, 0xadc9ce78, 0x12739e0a, 0xa4d507dd, 0xfeb2b1fe, 0x72975e49, 
	0xe3d1e190, 0x79aeb63e, 0xcb6d108f, 0xe28aded9, 0x7a4c4d27, 0x51aece36, 
	0x173c97a6, 0x0d5c3f64, 0xb8657b3e, 0xac37a4f5, 0x9483f993, 0x073e21af, 
	0xd193117b, 0x28bb13ae, 0x5274821e, 0x7f13718d, 0xd11bfa2e, 0x154bbb79, 
	0xefe9f02b, 0x2c394b96, 0xbba08cfd, 0x7bf789d4, 0xd3af0fd2, 0x99ee1ec0, 
	0xe61d7873, 0xbfcec5a7, 0xb0f29d7b, 0xeb1dac7a, 0xbab8dcb4, 0x916134ee, 
	0x8d62a1f6, 0xa741a3d3, 0x287fa6b0, 0x59cb5bc4, 0x99bcf86e, 0x0eb78a66, 
	0x9e71a69a, 0xc3f39597, 0xdff9ea87, 0xf8930511, 0xfbce5f5e, 0x2b7cfa5b, 
	0xf20b26ed, 0xa2c10025, 0xfb96bed1, 0xd8f76c75, 0xcb8c2ac5, 0x079f088a, 
	0x485ca3da, 0xe51f9798, 0xffc2264f, 0x43cc3ae2, 0xeda3ae8a, 0x7b6dc538, 
	0x1efef0ac, 0x1bea97ea, 0xac5f30fc, 0x97e5d40b, 0x7fdf57af, 0xac2cf690, 
	0x5e76fd8f, 0x02f78f5f, 0x7ca7c9c1, 0xacf575b1, 0xd74ebc38, 0xadc6cf23, 
	0x44b2b42b, 0x50e8bcc1, 0xf5828945, 0x0e8aa1c8, 0xefa2f305, 0x8b92595d, 
	0xa4d3d179, 0x5e61f07e, 0x5e58daf4, 0xc9295fb4, 0x8ce8bca5, 0x4bc7a712, 
	0x98d94c79, 0x39437c8f, 0x5c0a73f3, 0x5cf1ab0d, 0xe73e2c91, 0x93ffdf50, 
	0x39e2e4e7, 0x285fbcf5, 0xe85fbc1c, 0x85fb8d3e, 0xf5eb96d7, 0x47ef8958, 
	0x847857e1, 0x7a2cc0e8, 0x61a6fe29, 0x4de620fd, 0xbf41bac8, 0xbaa267cc, 
	0xe2e30fc1, 0x28d369eb, 0xf1b2f05f, 0x875cd1f5, 0x24e71d13, 0xcbf5138f, 
	0xaedf232e, 0xa938dfb4, 0xf06f975c, 0x0ddbe48b, 0x8dfbf1e5, 0xfbcf3d61, 
	0xd3c552fa, 0x1bde7989, 0xdbcf3172, 0xc47ace5e, 0xdb24b2b7, 0xd6f51db3, 
	0xf3cc5c8c, 0xeb68b1ee, 0xdf135fb4, 0x4da1fcf1, 0xdf326cf9, 0xda6e995d, 
	0xe5e94f7e, 0x9f711bf7, 0xf73ce31c, 0x7d779c28, 0x59697ad9, 0xbf4411d7, 
	0x77e622b3, 0x94fee7ea, 0xbf05d745, 0xe73bf406, 0x771ca395, 0x01deb195, 
	0x8759da3f, 0x679910f1, 0x138cbf72, 0xcb0bbc84, 0x30bf4e51, 0x92795161, 
	0xfb849f9c, 0x7b4581ad, 0x411a0ff7, 0xcf7bcb76, 0x5a9fdcb0, 0x95e0013f, 
	0x4c8ecf7b, 0x5fab3390, 0xfcc8a531, 0x027d68cf, 0x34a1ffce, 0x0d0f3f96, 
	0x3c51cad1, 0x5a657ead, 0xcb53e50a, 0x72fac27c, 0xcb8dd7de, 0xed0e7def, 
	0xe53f359d, 0xb9f102ba, 0x2be31236, 0x39f53ae2, 0x235b7fdc, 0xafb3d8fd, 
	0x7e891bee, 0x87cf3eaf, 0xa2463bdb, 0xce555adc, 0x646bdcfb, 0xbb6d5fbd, 
	0x1fde1469, 0x6bca7fa8, 0xc1e5248c, 0xe4937c1d, 0xe9e8f742, 0xab7a40df, 
	0x95d70efd, 0xe43eb40e, 0xea4535df, 0xadf78c48, 0x43ef7691, 0x2ef98969, 
	0x551f255b, 0xfead79cb, 0xf03f626e, 0x8bfa34ef, 0x0fb2e3d5, 0xb4517e61, 
	0x68be775f, 0xcd6cfb02, 0xe31cb510, 0x9bbfabfb, 0x54d23708, 0x9f3bf235, 
	0xfe8cef84, 0x7f9905f0, 0x7d02fd1a, 0xa1aff83e, 0xa6de8e26, 0x4e221dfa, 
	0x668e065e, 0xb538b9d2, 0x7876df53, 0xb8a23f68, 0xe6137dab, 0x98518ad1, 
	0xe926d1b7, 0x7afdf62d, 0x034fca07, 0xaf271bf6, 0xa34d0b6b, 0xc5b5ce10, 
	0x53d7a946, 0x69ef8da8, 0xc5a85768, 0x3d8f485d, 0x321c98af, 0xf081d0df, 
	0x9eb839e8, 0x6f3673e6, 0x9fc67fc4, 0x7b50febf, 0x84fd0387, 0x749f0087, 
	0x2eb44a9e, 0x07a464a3, 0xc236a7f8, 0xda6b21f5, 0xc07a461b, 0x672cec4e, 
	0xf9796c7b, 0xbeb1cb0f, 0x6995e7b3, 0x7e8b820e, 0xd7acb9ee, 0xd6251409, 
	0xd03ce0eb, 0x2fbd580e, 0x8df590fb, 0xdff05c18, 0x6efa5e96, 0x424dbbe4, 
	0xf99898ac, 0x28c3aa0d, 0xac6f37cc, 0xbe30f840, 0xf5719e02, 0x3af0e74d, 
	0xae91bcc9, 0xc2369ad3, 0x5fcaa7fd, 0xb5f3a72f, 0x1d71a70b, 0x4827ac94, 
	0xab8a93ae, 0xff291a13, 0x3e238ace, 0x9e0d7eef, 0x2ff98b8f, 0x8bca1cee, 
	0xcc4cec0c, 0x078b3527, 0x131d5247, 0x7ed295e6, 0xbe3236b1, 0x475a373e, 
	0x8d65f327, 0xd4ffdaa6, 0x45da09f5, 0x78bf410f, 0x444f792e, 0x15e727be, 
	0x903cafcd, 0xfdce07a4, 0xe105f892, 0xfa8f9fa5, 0x7b3a38ad, 0x4cddc7f8, 
	0xb81ddf27, 0xd3e748ce, 0x715cf235, 0x4a1fdf1d, 0xc92ff9be, 0xc1a70f37, 
	0x5d1e01ba, 0x0f318f28, 0x43da0fbb, 0x91fd3ce9, 0x787f3718, 0xe11fd476, 
	0xafedd93c, 0x0d9ea2a5, 0x79eb328c, 0x112f54e9, 0x5bd7a138, 0xbc4f6e08, 
	0x8e3e7f55, 0xd16fabda, 0x9e7163db, 0xcfa2fb81, 0x1af3d0a7, 0x6bfd6fd9, 
	0xce7df7f4, 0x9d29ff3e, 0x3bb55493, 0xdc2ceb95, 0x8b73a3bf, 0xe54eef56, 
	0xe3a2803a, 0xc10fb40e, 0xfd09ba0f, 0xa617bf9a, 0xf77f44de, 0xe09bada8, 
	0x0ec2f7f0, 0x9f3c7bfa, 0xfd71bf48, 0x7728d329, 0x567f9e17, 0xf20dca3a, 
	0x429dc860, 0xb7fae2e4, 0x294fad27, 0x65d7d2ed, 0xdfd9ba46, 0x8014e74d, 
	0xee36d00a, 0xf1de38c7, 0x4ff7f429, 0xf382e192, 0x2970829e, 0x3d16bae2, 
	0x7ac4faff, 0xf296c7ce, 0x03713030, 0x7ce5af3f, 0x47eac0db, 0x26f8bdb9, 
	0x3ee05e02, 0x3a70bcf9, 0x1cb8473f, 0x843f7092, 0x27779ef4, 0xaf607bd2, 
	0x28eb7f3c, 0x6fe2cd5f, 0xdaef90a3, 0xdc28ea2c, 0x748b5c17, 0xcf3fec1c, 
	0xde92139e, 0x1e05fd24, 0xeee189ba, 0x0f7040d9, 0x8faf2ddc, 0xdffbe06c, 
	0x78caf1d5, 0x49b9a9eb, 0xbccacdd6, 0x5974cf78, 0xedf3cacf, 0xe99d3959, 
	0x6bb646bb, 0xb64d73e5, 0x7d69bcf5, 0x251b85bd, 0x8853681d, 0xf585d62e, 
	0xd471bd7a, 0xf3d61e5e, 0x9d7247a6, 0x812a3abc, 0x78e50aef, 0x3fcce99e, 
	0xf1c937b5, 0xc59effb9, 0x57f02537, 0x6ff2dc78, 0xeec13e20, 0x78f90e79, 
	0xa72c8bcd, 0xfbea6aff, 0xa7175ea3, 0x2fa83ffb, 0x72c8bf56, 0xc3ddf03b, 
	0xbde007a9, 0x5387cdc0, 0x3bef00dd, 0x103ae4ee, 0xbae8bdfd, 0x93ae73f4, 
	0x34e1fcf8, 0x99c62475, 0x981d6f81, 0x83c512a7, 0xdd45274e, 0x31767f5c, 
	0x5fcf1232, 0xcbab964f, 0x24ef2bcb, 0xfc728b79, 0x72b2e2db, 0xef2be496, 
	0xe79e5377, 0x7e63ca8f, 0x7a9ebc51, 0xe3214eec, 0xfa88c273, 0x3f679cc2, 
	0xc866728a, 0xb44619c5, 0x145c860b, 0xcbb03a86, 0x5da5176d, 0x099b4d70, 
	0x932182ed, 0x76069d45, 0x5a67798e, 0x0b1d7c5d, 0x13a48af2, 0x9757fe13, 
	0x11b5e943, 0x23fa0293, 0x4f66135d, 0xd2e86083, 0x9b1fec7b, 0xd02ff035, 
	0x3f65a85e, 0x8ba57d23, 0x7e547be4, 0x51dff0d7, 0xb01f3e48, 0x6cac1d5f, 
	0xe996c047, 0x287484bb, 0x0cfbf3f4, 0xcfaaf758, 0x5f3c8867, 0x393b9efa, 
	0x137a435e, 0xec5ef7f3, 0xa8bb466b, 0xfebcb767, 0xdc3aaf94, 0x38de6186, 
	0x01d863ac, 0xda136de8, 0x37ce828b, 0xb11ede1c, 0xdcd0fc60, 0xccf3d2a6, 
	0xcf82d556, 0xfdf9076d, 0xaeb036ac, 0x148e186c, 0x44bbfc06, 0xf46a0e23, 
	0xd501d87c, 0x4a9a7588, 0x1d203544, 0xf38bbf0e, 0x54ee6d25, 0x8549f7f9, 
	0x65e01b61, 0xc79c5df9, 0xea2f1e6c, 0xceb59ed1, 0x1f23d7b4, 0xbca7cf5b, 
	0x7fce2bb7, 0xed7f9eb5, 0x4c39c610, 0x5db0d6d8, 0x19fe5e22, 0x879a83e6, 
	0x0fe3873c, 0x977bf952, 0x2eed052b, 0x756d44db, 0x17062b93, 0x1d7b44f3, 
	0xd89b6bf6, 0xf931bab6, 0xdf7e36fe, 0x9f7096d2, 0xce18eefe, 0x87f78eb3, 
	0xfce27b0d, 0x628e3d77, 0xb5d5af3d, 0xc7593d00, 0xb016ba8a, 0xb57ecf67, 
	0x798760c5, 0xbea779bc, 0xf5f4c6bf, 0x07e007be, 0xd4076dbf, 0xfc93eb14, 
	0xf52dd69c, 0x4b5dad98, 0x42ed2fbc, 0x9cc46b5b, 0xc7873f70, 0xc489b5b5, 
	0xb4be65f7, 0xf12460ed, 0x7ef978fe, 0xbef05844, 0x19c01075, 0x68d5a1f4, 
	0xac1673a1, 0x01fe6163, 0xdfcc075c, 0x66507c88, 0xf6bd83b4, 0xcf7f9c81, 
	0xc033c04c, 0x7f1662c7, 0xbcf604d8, 0xf3cdad25, 0x96f3d82a, 0xeb1bad2c, 
	0x6d392c92, 0xbb60afa5, 0x0ed41d40, 0xd78cb0f8, 0x88dd5e52, 0xea0262e7, 
	0xcce6eae2, 0x82ef682e, 0x187fe22b, 0x5fe225f3, 0x8eb7f891, 0xb8c1fc07, 
	0xff1d3cb6, 0x6abb43e1, 0xfbfe29ff, 0xf085be5e, 0x4c2e7b6f, 0x78c4625c, 
	0xa980e9b9, 0x7583f51e, 0xbfc0a165, 0x2add6223, 0xaaf8ebaf, 0x274867cf, 
	0x4b780574, 0x61fd053f, 0xc464fe3c, 0x6ea1ed80, 0x2719da95, 0xe307b504, 
	0xd7c06039, 0xbfd31736, 0x31b417bd, 0xf886c8cc, 0x56c0ff04, 0xbff05708, 
	0xff40bcd3, 0x40721ed0, 0xa7a0ec98, 0x8335dbd3, 0x68cbde1d, 0x6db0188d, 
	0xb1188b6f, 0xed8bbe6d, 0xaa0eab92, 0x43e7d426, 0xc59e3c23, 0x6d9fd89b, 
	0x4caebcb1, 0x5dd17fec, 0x28397fbc, 0xf20bd60d, 0x7c04ead6, 0x81063c22, 
	0x75cb5a84, 0xcc29f58c, 0xbc3f56cf, 0x19ef0397, 0xa3559f91, 0x7739fa15, 
	0x818dc727, 0xafd80c7e, 0x29f8f919, 0x2c99bfc9, 0xa0cad227, 0x97297693, 
	0x1b76cb76, 0xbbbaafcb, 0xf2831e38, 0x42a0fd83, 0xbb258fdd, 0x9961ff0e, 
	0x24a9f646, 0xdf015b7c, 0xbc7f3fc0, 0x4b36fd93, 0x03a5d316, 0x8a718ce0, 
	0x443e52cd, 0xbd27b7df, 0x3df4c39f, 0xdfdf97aa, 0xc2befc96, 0xbf7d14f4, 
	0x9e77fb80, 0x24f7f7e4, 0xea4aefbf, 0x9bfb3c7f, 0x907f8829, 0xc02a2927, 
	0xdcdf6e2b, 0x8f5a4de6, 0xba43c79b, 0xf18d696d, 0xdfa717cb, 0xbe5e778e, 
	0xff77e90d, 0xfc01bf9f, 0x1a373563, 0x1f538eb0, 0x453cb2cf, 0xd1ebe7b7, 
	0x0315b79e, 0xb67bc07f, 0xa8479034, 0x2354d29f, 0x0adb77e6, 0x77f88c2a, 
	0x8f5da0fb, 0xd9961df9, 0x11c3066d, 0xab2ecf68, 0x62d2fb47, 0xf487563e, 
	0x188b4e61, 0x4cea79f0, 0x76811fb8, 0xf63bd011, 0xe412f28b, 0x8ca8a5a1, 
	0x16d899c7, 0x3824e3d6, 0xc9ddef8f, 0x393169f5, 0xf3c616d9, 0xa88e9144, 
	0xef8921de, 0x11714da0, 0xbfd473a4, 0xbd573296, 0x44ddf511, 0x7b3893a0, 
	0xc03b7861, 0x0fa63b39, 0xbb3e9132, 0xb9e2ce59, 0x93b8df03, 0x3cfebaf5, 
	0xb73e4dab, 0xc47cfc0f, 0x815cf941, 0x7ff46fe7, 0x9f887a0e, 0x1efe06bb, 
	0x7c40b1cf, 0x7d0df7ea, 0x1d71ebd3, 0x8f6f04ff, 0x6173dca0, 0x3fac1ffe, 
	0xe87fe315, 0x447eb53f, 0x89b95ffa, 0xfa8584f3, 0xb255c531, 0x6f9c7fe0, 
	0x35678c28, 0x5bf91b86, 0x6823de96, 0x078d14df, 0xed035ace, 0x2cbabeac, 
	0x80d9d68d, 0x0a14f7e3, 0xcf6716bb, 0xdf127f22, 0x2e1cfe49, 0x4a7c8ce1, 
	0x269f25f7, 0xbd43a7f3, 0xe24e3c82, 0x17ec3cb7, 0xf80a30e0, 0x7ebbfe20, 
	0x77c4907c, 0x259df96e, 0xf65ef58d, 0xeca7e629, 0x9253f12b, 0x7ec1c87c, 
	0xd2bceae0, 0x78f893bc, 0x7bbf1c82, 0x68cdabd4, 0xbf3199ef, 0x1bcbde04, 
	0xec31b7b4, 0x7373ab86, 0xb801fa63, 0x9e2fcf2f, 0xb159ae91, 0xf0c674ae, 
	0xbfd22b3a, 0x66b6f879, 0x77c3dfe4, 0x9e453d71, 0x51870b51, 0x9d78c9fe, 
	0x7957da59, 0x13c39b9b, 0x0f323ef0, 0xbc09fbfc, 0x5f0d6d7f, 0xe1c53ce9, 
	0xcdfabdf2, 0x83c474e1, 0xe7df45db, 0xa6103e6d, 0xf1a93bbf, 0x748cea9e, 
	0xcdda1375, 0x66b43267, 0x66dfbbfc, 0xe426e34b, 0xb61319d3, 0x5740a9d1, 
	0x09a5a6ff, 0x08ccf8f9, 0xff7e1798, 0x2eb34362, 0x9c1e91e7, 0xcc3ab513, 
	0x179e7597, 0xd5df709b, 0x83de1432, 0xeb179def, 0xf3f7282c, 0xd5bb513c, 
	0x2f3bdf8a, 0x35feb8ca, 0xded0d957, 0x625a71a5, 0x8e502df0, 0x1bd01558, 
	0xe0cd1e05, 0xc927db89, 0x563b48f3, 0x75eb4299, 0x984c6a0e, 0xe5b3cd07, 
	0xee8f9f5f, 0x83cf246f, 0x97d5d8ec, 0x1a464f9f, 0x7815f9d8, 0x70083905, 
	0xf00528cc, 0x2819b8c2, 0x8c9c6107, 0xcf8da05b, 0xed493f6f, 0x06c6c6c1, 
	0xbdd283b4, 0xbb74ff2c, 0xad7c66cf, 0xd527ea3e, 0xf20a3da3, 0xa0f9ee30, 
	0x9f3a7699, 0x66f606d0, 0x6f9f9d8b, 0xa6baba07, 0xb5bfe582, 0xb5370b58, 
	0xee307be1, 0x6c7ad8b6, 0xb3f276c5, 0xeb579f06, 0x307da00f, 0x001fd451, 
	0xb77addbb, 0x59fddeb9, 0x15058e0c, 0x3ffd77ec, 0xb4a90e40, 0x00033f51, 
	0x7ded9c78, 0xd5547c0b, 0x7bdaefb9, 0x24c99276, 0x320bc984, 0x0cc263ca, 
	0x36392698, 0x1863a462, 0x82020760, 0x515a54f5, 0x849d1503, 0x8f091309, 
	0xa316d298, 0x84249ee0, 0x20268304, 0x00682a48, 0xf6a6696b, 0xb58b50a2, 
	0x3c01ddbd, 0x5147a9e0, 0xed2de2d1, 0xb78a5e1d, 0xe2a93db9, 0x78f4ac69, 
	0x6b5befbe, 0x5e766667, 0xbfa9e8f8, 0xfdf9bbfb, 0x5ef6b974, 0xbeb5ed7b, 
	0xdffe3df5, 0x52d68f63, 0x197be4c6, 0xfe3269fc, 0xb152e53b, 0xd8c33c1c, 
	0x16ed9bb9, 0xe258c4d6, 0x33eac625, 0xfe04fb19, 0x2c601f1a, 0x6726be79, 
	0x54b6812d, 0x8c2c0b97, 0x6a638c8d, 0xacc656fd, 0x8ec61ea5, 0xa1f304c3, 
	0x3b3b18d5, 0xd6756bee, 0x347be832, 0x31897b59, 0x9d467d9b, 0xeeb1817c, 
	0xb7fdc16f, 0x3069fd18, 0xecc3dbae, 0xbe916dda, 0x61ad46f5, 0x09b19393, 
	0x2e92c63e, 0x989bde46, 0xe9cdcaa1, 0xf011bef0, 0xbf314cbe, 0x6ef18863, 
	0xe0733e31, 0x6f186ef1, 0x1fe3e6af, 0xaa25f1c5, 0x7912dc1c, 0xf6e37ade, 
	0x581cc686, 0x04b35594, 0x709319db, 0x9f40357d, 0x092ebed5, 0xcf0899e6, 
	0xd569f7b3, 0xbdf42096, 0x3eb072f1, 0x4c1db18d, 0x2ce9aabe, 0x31ced363, 
	0xcfe659a9, 0xe788f5b5, 0x34a63357, 0x5e813d00, 0x32c62cde, 0x3902d0fd, 
	0x2c601c46, 0x49f6cad7, 0xcc4e90e7, 0x37df4327, 0x628e6a72, 0x3e573c8b, 
	0x649c85fe, 0x4eee17e8, 0x7ac1977d, 0x522c1b4a, 0x93e70d30, 0x53187ce9, 
	0x8cd3d6e5, 0xad2cd6c1, 0xdc5b18f3, 0x15333e5d, 0x44789fe8, 0xe3e1991e, 
	0x7ec134f3, 0x2cf7f1d9, 0x1ec623ec, 0x698a3839, 0x39cfd0cd, 0xff3830ad, 
	0x3257b386, 0x81f3912d, 0x5c25cf06, 0x78f1acc1, 0x3d52597e, 0x4f7c59f6, 
	0xe8e70497, 0x63e79fcd, 0xa33f421f, 0xe7019837, 0x96584775, 0x3f3fec19, 
	0xe5f54983, 0xc9666eb0, 0x75918961, 0xd64ced5b, 0xad125f80, 0x927b67cc, 
	0x677ac731, 0x1d1ab3ce, 0x1ae715f7, 0x74577de9, 0xbcaecb53, 0x5e57fbc8, 
	0x4731fde2, 0xcc7f5036, 0xb1b2d4cb, 0xec7f7827, 0x771fde29, 0x75c7f78e, 
	0x8bf8fef3, 0x12fe3fbc, 0x348f3bef, 0x32f9df51, 0x04fb2cb5, 0xe29f67ef, 
	0x78e709fd, 0xef37427f, 0xbef22ebb, 0xbbef12eb, 0xdf53348f, 0x6cb532fd, 
	0x9fde09e2, 0x27f78a78, 0x49fde39d, 0x739fbcdd, 0x7a362364, 0x736831ce, 
	0x5bd3b213, 0x2a4e404a, 0x9c336774, 0x9d0ff275, 0xa1874de9, 0x2b59d38d, 
	0x0b8fca8c, 0xa1474db2, 0x9bc9913f, 0x6f724f81, 0x9d1e5b08, 0x46747c8d, 
	0x5bef147a, 0xcdd21259, 0xdc93740b, 0xfe414d8c, 0xe3f5d3f0, 0x52f910ac, 
	0xe708357a, 0x398f58ad, 0x6eef3834, 0x401b06a6, 0x3588508e, 0xc80db1e0, 
	0x1f91ab9f, 0x9a768754, 0xe4e349d6, 0x4fde7aa3, 0xa37e116c, 0x79880ff9, 
	0x19e7fd1c, 0xb555f9ec, 0x67f63e4d, 0xf1876f18, 0xd3c8916f, 0x74fc863f, 
	0x3dbb4f43, 0xfd78d722, 0x9ff40f47, 0x662b90df, 0x32c13965, 0xd718575a, 
	0xab726675, 0xae177d8f, 0xc82af4f7, 0x3cfe8baf, 0xf02bf395, 0x7263f239, 
	0x60cc8e45, 0xcfb8ad3d, 0xe079a89e, 0xb92e901c, 0x47f1e60c, 0xde1d9ff1, 
	0x65f08ee9, 0x39d9ca22, 0xbca1afba, 0x0b360eb1, 0x2dd78fdf, 0x3e659c7e, 
	0x5532f7c3, 0xb52ef7a1, 0x02aebd30, 0x7aa82f9e, 0x7e80e943, 0x424d12e1, 
	0x7a6028b9, 0xed83ac33, 0xa09b7a65, 0x64e41053, 0xead33c69, 0xf41f882b, 
	0x79e46260, 0xb68e27d0, 0xfb80f928, 0xb73e335a, 0x5edad746, 0x6c97f9c2, 
	0xee4f4093, 0x39241df1, 0xd27589b3, 0x9d3ac179, 0x1e742dce, 0xe9871fc4, 
	0xb9f84ff9, 0x55bd3959, 0xa3dd0e7e, 0xbff6989a, 0xd62aeb19, 0x9c0491d8, 
	0xf63ed7ef, 0x0e8e711d, 0xf48c2d6a, 0x7dc90a7e, 0x6b2e3b12, 0x4f3a865b, 
	0x70b7ef98, 0x2e98d54d, 0x709e730f, 0x34de961e, 0xca43fa86, 0x9fc6b3b1, 
	0x62cd6b41, 0xcb7fb071, 0x9f8f495e, 0xb9ffb512, 0x92f3c74c, 0xf3c74cac, 
	0xcdfdf3ba, 0xd637ea1a, 0xd70f3db3, 0x8725bbd7, 0xd4da97d6, 0x82c16524, 
	0x941fd752, 0xd6eb60c6, 0xc4df3cf6, 0x5817f1d7, 0xbfabf387, 0x8c3e59f7, 
	0xc5fbaf5a, 0xe223f93a, 0x7d014917, 0x30e4f6f2, 0x0deb27e7, 0x9fcc1a79, 
	0x8ff4a4bc, 0xbd52b7a8, 0x17b657fa, 0x67463b43, 0xb26f381d, 0x0e419ace, 
	0x2c3a3353, 0xded0f14d, 0x74d49e14, 0x667d5b04, 0x176876e7, 0xd8df5fa8, 
	0xbe967c4b, 0x34b180b1, 0xeb8b99cd, 0xc1d7fdc4, 0xff26bbf3, 0x1d80a7c9, 
	0x79698f62, 0xd267a7c8, 0x38310f6e, 0xe7a674d7, 0x77e08036, 0xdcdd4c2a, 
	0x20b7fb4b, 0x9555997d, 0x3ed13cf0, 0x23f8b8e1, 0xe607971e, 0x7529cf8d, 
	0xf5d075d5, 0x69fb8320, 0xc0d2c0ad, 0xf16ff167, 0x6b43d6fb, 0x17b0d9be, 
	0xb7b736e4, 0x9116bd96, 0xff935db3, 0x5d00a7d3, 0xb9ebb7d3, 0x07f3f90c, 
	0xc4978eb0, 0xfde9da3a, 0xb8647f64, 0xa0f60497, 0x3e235e3b, 0x3e383fc1, 
	0x2e65ef16, 0xc7672234, 0xe90ebcfd, 0x2e66ef13, 0x7f11d619, 0x4f44b435, 
	0x17678c9f, 0x24b9873f, 0xc6db6718, 0xb38e1bc2, 0x9f8bc63e, 0x09eba4e2, 
	0x890dc70a, 0xb9c67de2, 0xddb8ca38, 0xad0ad6c5, 0xaf0b3a6d, 0x3156f187, 
	0xdca3941e, 0x16b4eb06, 0x6da94876, 0x975f8f30, 0x137e40da, 0xeb079ec0, 
	0xb237fc61, 0x6d9768c2, 0xdbc2b3d3, 0x10529db0, 0xf8740ade, 0x22f5ee06, 
	0xb4fbfbae, 0x35dcc4ee, 0xd38ba20e, 0xdc8b7b49, 0xd2275aff, 0xd7acaf61, 
	0xb2337dd6, 0xbb5719ee, 0xb26e90cb, 0x7f47e3b5, 0x5fa3fb22, 0x4abd7681, 
	0x9f5ecbac, 0xcf067845, 0xa712fac1, 0xc9e615af, 0xdfd9fb17, 0x40a65b98, 
	0x8dff9e9b, 0xbc47a532, 0x572dfa0f, 0xcfae837f, 0xe860bab8, 0xa13d35f9, 
	0x4fe62029, 0x8c5fcc8c, 0x5f7cc3f3, 0xe68530df, 0x719fe635, 0xf370d175, 
	0xf7cd43c9, 0x1d57ce24, 0xd499cebd, 0x9e5f2277, 0x6bffb28e, 0x505e112e, 
	0xfae2483e, 0xf48b7f57, 0x49f72ff1, 0xc0c17831, 0xf02e0607, 0x7f513ac2, 
	0xa0f61fd9, 0xca7d05da, 0x6cee51ea, 0x3d843da0, 0xe09ed191, 0xe8fca379, 
	0xaa7cc605, 0xf1977a4c, 0xfdbe9cbe, 0xa1979e10, 0x26bcd8cf, 0xd8c82476, 
	0xcb0b7cd7, 0x538007d8, 0x45dedc27, 0x126982fa, 0x71e3a73e, 0x4ea073e2, 
	0x7f5b5d68, 0x1ae0d41c, 0x85d0bb8b, 0x7d88a0f2, 0x6a781775, 0x8f4ee218, 
	0xbba3f887, 0x7106a8a7, 0x4e95daa9, 0x9b4e4f7a, 0xea3e441f, 0x6f7a7596, 
	0xa8d24152, 0xcf385186, 0x5f1eba5e, 0x3a096ec8, 0xbe307a23, 0x37ea9344, 
	0x6b7254d3, 0x47671f19, 0xde712e79, 0x6ae30ad2, 0xd07bdf90, 0x5d10d5ae, 
	0xa26e9ad8, 0x38a5d163, 0x399deba2, 0xf36ccbb7, 0xd01ff310, 0x37c5ef08, 
	0x9f3df3f0, 0x7ed068fb, 0x7e478f9a, 0xbe2be434, 0x534b79d0, 0x9373d447, 
	0x5efad599, 0xd1dcfdd4, 0xaf1e7c9a, 0xc1947f1f, 0x82fbf77b, 0xc7604965, 
	0x2babe37f, 0x5e80f763, 0xf582c51c, 0xe83ef867, 0x449aac3c, 0x49aecd76, 
	0xe49ef0cd, 0xb07dc649, 0xf98f64c3, 0x9c0b5a79, 0x807872c5, 0x708c8df1, 
	0x5add71b1, 0xe38651d0, 0x83e3e392, 0x9c691788, 0x47a423e0, 0xe698da06, 
	0x69bbf198, 0x2ba906fc, 0xded9bc7a, 0x4b3f8d45, 0x63e213e3, 0x8ffb1bc6, 
	0xb6ce738c, 0xf6fdc584, 0x6311fdc8, 0x30b1c234, 0x29c5854f, 0xcf169fee, 
	0x8479d145, 0x6ce718df, 0x435c721c, 0xa9ef98d0, 0x8d29c721, 0x69477cc6, 
	0x238e899c, 0x26c56bd6, 0xeb8bbe3a, 0x82c2911f, 0x1133ed43, 0xe307c5cf, 
	0xee3b0d46, 0x349b8d30, 0x2fa038dc, 0xec339b8e, 0xc7058a7c, 0x9f3b0e35, 
	0x668dc69b, 0x22579e43, 0xbb8e179e, 0x4071b86a, 0x73ff5f17, 0x193815b5, 
	0xe1839ff9, 0xf1137b1b, 0x3d25e213, 0x89be3838, 0x1e7acbcb, 0x69c588f5, 
	0xbef0f167, 0xe8034538, 0x02e1e5c8, 0xfa40f213, 0xf414e408, 0x425fe2e9, 
	0x6c56f20b, 0xbe40e93d, 0x9e7aed96, 0xb3bf9e1d, 0x759e50e7, 0xaabedc00, 
	0x3f483ff6, 0xc0377198, 0x3dad5cc8, 0xcd40af82, 0x74f3bab3, 0x4deb873f, 
	0xee45d576, 0x89755c8f, 0x11fc07e4, 0xccce0c5b, 0x78487d41, 0x2bd130f8, 
	0x14f50da7, 0xdf985ee2, 0xa4af977b, 0x3d5b04a9, 0x1ce00765, 0x716acdef, 
	0x6f684cd3, 0xc16c6fd7, 0xf1b51cfe, 0xf67b8e21, 0x7f40d768, 0x60829315, 
	0xb564959f, 0x3d7e59f1, 0x360cf82f, 0x87841df3, 0xabc72e54, 0x84e5ed6a, 
	0xe0ff00bb, 0x88ff707e, 0x7eaf3c73, 0x7c02c8e4, 0xa57ff535, 0x5cf48e3e, 
	0x8ac927f3, 0x3c55fb72, 0xaaf1c25b, 0x7db77e44, 0x561d0c6e, 0x9395a6d5, 
	0xa3ba64fe, 0x43e626db, 0x7a55db7a, 0xc483e92f, 0x555beffe, 0x5c75a4eb, 
	0xc779f47f, 0xf7af7818, 0x4a177bdd, 0xbe015cf0, 0x54c1700f, 0x46db8d85, 
	0x7bd1847a, 0xc4758927, 0xb0a57775, 0xa07ac8ca, 0x8f8c9c75, 0x6d557fbc, 
	0xfe47ad1e, 0xccbcaef7, 0x65a779a8, 0x7788b8f2, 0x1f9a930e, 0xd5b93a01, 
	0xfe4ad691, 0xf003b43e, 0xfebda127, 0x9c53febc, 0x238057c0, 0xee79e02f, 
	0xdb2608aa, 0xc1a7ff81, 0x3de1127b, 0x801650f3, 0x5f03150f, 0x12b49f01, 
	0x30abd53d, 0x42fc804e, 0x57e98af6, 0xe69d02b5, 0x065c7395, 0xc02fc47f, 
	0xf7483987, 0x39691f08, 0xcb9f932f, 0x9f8325fd, 0xf5f652fe, 0x305fee72, 
	0xd94f9a29, 0xef838e76, 0xbf0991ec, 0xddfa35de, 0xdba042dc, 0x8358afb9, 
	0xabc43645, 0xdc472cdf, 0xfdd2e061, 0xd3ca5bbe, 0x2e291ec1, 0x83b43390, 
	0x9e5d5325, 0x26ded07d, 0x1c7ddf5a, 0xb688d71f, 0x44dbb441, 0x6f02f1db, 
	0x91ed159f, 0x6f73f817, 0x31fc3689, 0x68befebf, 0xfafc4b95, 0xbd3ad128, 
	0x593eba6e, 0xd2d025b4, 0xbbeb45fb, 0x11af5f9f, 0xb768836d, 0x97e3b689, 
	0xb7967dbc, 0xb88bb144, 0xe7f25f8e, 0xf92de2df, 0x67fe51a3, 0x887595a2, 
	0xa4296abe, 0xb45a6cc7, 0xdb54ca3f, 0xe9d08a05, 0xea3a9eb6, 0x7ef2f527, 
	0xfd4f5e92, 0xea1663e4, 0xfde71f27, 0x7f792711, 0x355a9844, 0xa7ef02e5, 
	0x23fbf0f4, 0xa47f797b, 0xfb7d40de, 0xf6fa8531, 0x7a9fbce3, 0xc353f792, 
	0x1769aad4, 0x87ad3f78, 0xe5ef4fdf, 0x3d7d74fd, 0xc58e33f5, 0x38e33f51, 
	0xc49e67ef, 0x7995d6be, 0x369c4342, 0x7a72883a, 0x74c3f953, 0x3b04cade, 
	0x745cd1e9, 0xf9df6144, 0x2c55fd6a, 0xca75fb4c, 0x12fcffb0, 0x83ec68cb, 
	0xfd1c7bdf, 0xf8c024de, 0xdf84e775, 0x8fe6807e, 0x55cef947, 0x614bd7eb, 
	0x12a93f8c, 0x41db12e2, 0x4ddea3a9, 0x3f65d474, 0xd0b355d1, 0xf77f58f8, 
	0xaeffafee, 0x520fde85, 0xde88f92a, 0xc8a4a7f1, 0x0c3f9179, 0x1b3dc77e, 
	0x78c4696f, 0xcb6acad6, 0xffca3b08, 0x97e48dc9, 0x278f4ca6, 0xc2f8b6fd, 
	0x174bf246, 0xf905ff9f, 0x2fd18ba5, 0xa5fb46b5, 0xf687cafb, 0x7d73f74b, 
	0xd2d2fc26, 0x2fc88bc3, 0x1a1ec865, 0xd6ee46ad, 0xe8c6dcb8, 0x5378bef7, 
	0x3ffe3c9f, 0x27d34f12, 0x3eba405d, 0x69b07e12, 0xa83ab616, 0xab576810, 
	0x6cfc61f7, 0xc3e86af1, 0x757ec5a8, 0x8be5fa15, 0xe3cf7afd, 0x1df16170, 
	0x1474d49a, 0xfb6d06da, 0x5d6a56c6, 0xf6806fdb, 0x70f1d388, 0xfd6ab61b, 
	0x0f682ef6, 0xe709ace8, 0xd571d03b, 0x7da117f6, 0xc66e8d92, 0x1ef84fe7, 
	0xe84ef9a4, 0xf40bd8bf, 0xff4a7c5f, 0xb435c6db, 0x67faa4ae, 0xa778dfd1, 
	0x375de31c, 0x57285f95, 0x73693ed0, 0xcafdcf48, 0xe2395ef7, 0x838c16e6, 
	0x82ae3d83, 0x3c39125b, 0xa8cbdfa0, 0x8e70905f, 0xfd415d91, 0x5163955c, 
	0x72ab5f90, 0xef910bea, 0x29c8e136, 0xa79f3f42, 0x939225eb, 0xf1005c51, 
	0xb39dd54c, 0xc00e502a, 0xf46e11be, 0xb44e59b1, 0xe13d3067, 0x1b5609e5, 
	0xbc5573f1, 0x9acb3842, 0x9f1af803, 0x57e46bb7, 0x1ec2a929, 0x9e68f98a, 
	0xb3ef2297, 0xd0df4159, 0x245d5b7a, 0xf8f9931f, 0x8f5fe1f1, 0xd95bbb23, 
	0xa1fc2415, 0x831f34a9, 0x6fdf21c5, 0xc16599ca, 0x67f2fbf5, 0xf405648d, 
	0xa3c40ade, 0x81269f30, 0x00e426fc, 0x02bcf2e3, 0xfdfc39f1, 0xff99f501, 
	0x24e3a9aa, 0xf8efcf98, 0x9018e778, 0xf7d1b293, 0xcb416765, 0x185dd8b2, 
	0x7e1f1a07, 0xfb469c60, 0x9d457ee3, 0x62b45555, 0x45901e60, 0x2a55c63b, 
	0xd7e4cd83, 0xcfc23165, 0x3892d6b5, 0x4ff30a20, 0x6092efda, 0x85760d5d, 
	0xece768c9, 0xfc1d7760, 0xf583b439, 0x3f2b7d78, 0xcf8e6697, 0xe0338c24, 
	0x2d77b47d, 0x847d8463, 0x88e5da73, 0x0c92abc8, 0xcec02bd7, 0x0c090daa, 
	0x75dde170, 0x7de0df60, 0xff07abdf, 0xc72c2e72, 0x59d95ba5, 0x7e5877da, 
	0x827be412, 0xdddf231e, 0x1b049fb9, 0xfbec66ae, 0x96c4aa45, 0x90e23d10, 
	0xfdd913be, 0xff7e7889, 0xa60cc9f9, 0xe85ea1d5, 0x17982a0d, 0x93f9e1c9, 
	0x838f96ee, 0x95a7fa0a, 0xf4b0b953, 0xfe911206, 0xeeafe37d, 0x053c360d, 
	0x8a2d4bd7, 0xf50c9bd0, 0x59d2c4e2, 0x439f8c69, 0x234dea2b, 0xddd709fe, 
	0x8b4af88c, 0xfd4d3a6b, 0x929c716b, 0x7e913ba3, 0xfac14b13, 0xb2cfb13a, 
	0x89cd75f9, 0x0afb80eb, 0x593e87de, 0x3823358b, 0x38b8c39f, 0x3c3e3fbc, 
	0x8957e283, 0x64f1de70, 0xd71b34a7, 0x23e256b3, 0x131e8758, 0x78a18567, 
	0x50f5137e, 0xd835f119, 0x999a6ead, 0x7608bc8d, 0x2c7e7149, 0x2f9e0129, 
	0x6d3d00b0, 0xf9454c39, 0xce67ceb1, 0x2f2be004, 0x8f0471ac, 0x9a4cb35b, 
	0x7ce0b74f, 0x33e58ed3, 0x1c17cc1b, 0x10a1353f, 0xe172a9ce, 0xdcf14d83, 
	0x730bce3e, 0xaeeb697b, 0x917cf2e3, 0x12e92d5a, 0x231f27ef, 0x6edfd87b, 
	0x36bea05e, 0xccb512f2, 0x9eec847e, 0x5a997f66, 0xf7827a96, 0x7ef14f53, 
	0x4fde39da, 0xf4fde6eb, 0x7e9fbc8b, 0x8e33f789, 0x32d45d90, 0x6596a65e, 
	0xccfde09e, 0xf23ed053, 0x6e29bc3f, 0x55c2074e, 0x46dac9ed, 0x75f018ed, 
	0x54e692f6, 0xe429e758, 0xff7fe01d, 0x7cbcf756, 0xd1424f58, 0x4ed197fc, 
	0xc2b7c57c, 0x05697a8f, 0xf507bed2, 0x484bfdd3, 0x1259b13f, 0xc2bd79c6, 
	0xfa14aeff, 0x66baabc9, 0xbf0d0227, 0x6292cfb7, 0xfefb7385, 0xe82959c1, 
	0xa29fdc87, 0x73826c6d, 0x37adf65e, 0xc278c15e, 0x4e3c25f6, 0xc0fc2d34, 
	0xcbbe68c8, 0x01f8ff57, 0x441783f2, 0xda1d72df, 0x873e3fcf, 0x9d9a607a, 
	0x6ed057cd, 0xe06f55ab, 0x2e4d69fd, 0xa9ce0326, 0x30fe945a, 0x4779b3b7, 
	0x9abe5c71, 0x5abee8c7, 0x1bd44df5, 0x8154355e, 0x0d5730fa, 0xe0152bbd, 
	0x7e59d0fd, 0xe0f78fff, 0xbec5c7fd, 0x92582d97, 0xf1c69d2c, 0x8e2efc7f, 
	0x979d9caf, 0xfcb87985, 0xe318b938, 0x667a3b2e, 0x5a8d655c, 0xe6886a27, 
	0x2cc36232, 0xac3b13d4, 0xc1d37b80, 0x401d239e, 0x018da79e, 0x3e732cfd, 
	0x77827e22, 0x25103e8d, 0xee5c19f7, 0xa9857de1, 0xdeeb911d, 0x469e9c39, 
	0x93a09f7f, 0xdfcdf6d1, 0x9c56ef54, 0x0f527afc, 0x3ae207cf, 0xb997df31, 
	0xc27cf23c, 0xe4892939, 0x0d975ced, 0x74a09bf7, 0xa425c149, 0x8acd2477, 
	0x24b0cf71, 0xeef57f41, 0x1c421e37, 0xbacdad52, 0xdd58e28a, 0x984a91c1, 
	0xd06929d6, 0x96e67fde, 0xd35f1197, 0xb908cefa, 0x02727e47, 0xcf3c613f, 
	0x60480ced, 0x393bef3f, 0x5ee786cb, 0xc362dc7b, 0xe7e95f73, 0xdfca4bf1, 
	0x5b78c66d, 0xb6f28869, 0x135e5aed, 0xbc2dffdc, 0x7107b53b, 0x304b4bfa, 
	0x908b5dae, 0xaf5423ed, 0x1f7dde3c, 0x73a1b5c6, 0x9d17f856, 0x894a260b, 
	0x0baf2e70, 0x0928abbd, 0xe2217656, 0xc2589c7f, 0x5d4fcee3, 0xf2097c7d, 
	0xd08741ad, 0xf425131d, 0xb49fc09b, 0x1f15183f, 0x3d5b8bef, 0xe7c73d79, 
	0xdc27ae07, 0xff46eb8e, 0xb4e9f60c, 0xb8879c08, 0xeff95571, 0xbfdc2896, 
	0x6d7f42ca, 0x3cc38e15, 0xfea553ad, 0x2e61e54d, 0xc9315a1f, 0x751ce547, 
	0xe5e60b5d, 0x55acea26, 0xdb1bfca3, 0xd5f222f6, 0x5441ed4c, 0x6c7db30e, 
	0x3773f43f, 0x59843538, 0xf3832f94, 0xc7f758cb, 0x847f1825, 0x07f41cbf, 
	0x50f58857, 0x4de60b1e, 0xcde5c69e, 0xb43287c8, 0x32d7405c, 0x3c1caceb, 
	0x951f1a27, 0x2ae785d7, 0x55f5819f, 0x8e6ebca2, 0xeb07cfdc, 0xb0f9276c, 
	0x5016a5d4, 0xfc1539bb, 0xf7281dc8, 0xfee444f7, 0x3fee64ce, 0x27081d81, 
	0xc46f29f9, 0x898f406c, 0x986dae70, 0xbdd9eb07, 0x68fc06db, 0x73ff73f1, 
	0x1ee3b3a2, 0x8f1c3394, 0xf22dd8f8, 0x27913655, 0x4c7c164b, 0xdfe827f9, 
	0xabee61f9, 0x7737c089, 0xcdcd47fe, 0x2b715189, 0x77c2efaf, 0x2f3cc313, 
	0x92798569, 0x460e5cfd, 0x29aabae3, 0x77f949bf, 0xe934ee7a, 0xf3c4ea8d, 
	0xb9e0f991, 0x8f9fab1e, 0x4ceee7c7, 0x2dd23a60, 0xe805ed11, 0x5eca567f, 
	0x8d32dc45, 0x9d6c8f15, 0xbd585a85, 0x1f76ed19, 0x7eb17dbd, 0x2b65ede8, 
	0x185fe8fc, 0x6f9af974, 0x1cc9d12c, 0x70b8a61f, 0x5568fd18, 0x255c7ea2, 
	0xe2fb91c5, 0x161d86c2, 0x5d99e171, 0xc15ebc49, 0xc5ab0788, 0x817c1e22, 
	0x6f049afc, 0xa136bc6c, 0xc1e29984, 0x79f68217, 0x4b79dd78, 0x4293e82b, 
	0x671dc73f, 0x617fc326, 0x78d0647c, 0x1ddf98b0, 0x8072bf3b, 0x3f3ffc89, 
	0x8a6f9077, 0x1dcf9efb, 0x223bb41d, 0x67e00d75, 0x4777ad59, 0xff8c35e9, 
	0x1e75e056, 0xeb099dff, 0xbf41ef48, 0x89d1267b, 0x247969f4, 0x2aad0a5f, 
	0xa3927e0b, 0xf9df44f0, 0xa4a6f298, 0x7d0a2e4f, 0x97f0567b, 0xf6e1e85b, 
	0x4f9973e8, 0x904dcbef, 0x804e88bb, 0xfee15abb, 0xd5cb28ad, 0xe5884f18, 
	0x38b8fcef, 0xf42e7f8a, 0x952a7d73, 0xeddfdec7, 0x3f220aeb, 0xed83fc63, 
	0xac47b8c3, 0xd4c6bc5d, 0x77d4d9bf, 0x951ef39a, 0xf8bf922f, 0x3c393bfe, 
	0x1cfdbd1e, 0xebf4cf9d, 0x1e879115, 0x82b1ef2c, 0x7f8ef3ce, 0x7bc98a2f, 
	0xe588fa18, 0xff221e80, 0xe4dc274e, 0x7f3cad64, 0xfcf2b56f, 0x31373fea, 
	0x2b71882d, 0x4f5c57e0, 0x2a3ca316, 0x0895056b, 0x29f6d1eb, 0xf8849e46, 
	0x3cf1aad9, 0x3adf1ec9, 0xf1f76f7a, 0x591b8a2c, 0x51b8f2e6, 0x071ef259, 
	0x1e61a9e6, 0xddf81e3d, 0xe62ce227, 0x4116f9f8, 0x8f8acbf7, 0xcb7f406e, 
	0x38f53b88, 0x9b5f609a, 0xf44edcfd, 0xfab6678f, 0x1a678a07, 0xfce60475, 
	0x2b597763, 0x7f398b9d, 0xcf15971d, 0x8f7de0ea, 0x88fdb9f9, 0x29fbcf9b, 
	0xd683f335, 0xcd9d48f6, 0x1477a10e, 0x51e52957, 0xf5cc9ede, 0xc75fe1a8, 
	0xff27cee5, 0xd606ca7a, 0x950c7945, 0xc67a09c5, 0x5fff249d, 0x409e3b8f, 
	0xa927b1fd, 0x7986c7d5, 0xde05dc7f, 0xfe43d71f, 0x97be3ab0, 0x0783c7f7, 
	0xdf220ec0, 0x754c7c53, 0x6dd2b31e, 0xd5c789b9, 0xfccfe89c, 0x129f9cdf, 
	0xe1c9f6bf, 0xfa1b6d18, 0x5f5b8a9b, 0x8f764cda, 0xfb85b35d, 0xc3d7879b, 
	0x4fe03d9a, 0x79f13100, 0xcc14dba2, 0xf14e038f, 0xf57c95c4, 0xfd6f1e61, 
	0xf9038e1d, 0x89e238a3, 0xb47e5db5, 0x29db8a47, 0x29e6fee1, 0x563fd712, 
	0xd07e81dd, 0x0383daaa, 0xf88fc39f, 0x3daa2c39, 0x3a6ee9c4, 0xff6abb8f, 
	0xbe65e685, 0xbb77f278, 0x07c4ecb3, 0xd426bcda, 0x6179eca8, 0x93be0ca7, 
	0x4c7c8ae6, 0xb5d75f01, 0x220b683f, 0x363ca15e, 0x8064c3e6, 0xa22ebc67, 
	0xe4aee905, 0x76d5ab1e, 0x56a4ebd1, 0xd814af18, 0x57d036d9, 0xe5bc67e3, 
	0x8e7e054f, 0x6d82c11b, 0x3017e8ad, 0xae2a3d87, 0x83e46598, 0xb43f3806, 
	0xb82a13eb, 0x658c757e, 0xed3237a4, 0x7606c3ac, 0x77ec133b, 0x7ee47752, 
	0x0573c096, 0xf2a2ff68, 0x4bfdc6d4, 0x791a5ec2, 0x4823b478, 0xac026537, 
	0x01ed1b3b, 0x59f3690b, 0x6775209f, 0x0e5a4278, 0x5e44cebf, 0x4ca1e91c, 
	0xbf1191cc, 0x06f7132a, 0x9d83fed1, 0x92f671a1, 0x405ce90f, 0x5578d3fb, 
	0x8961e3e2, 0xea3f3621, 0xd81f5c79, 0x01526551, 0xf9bfabe1, 0xb6fabe39, 
	0xabe223fb, 0xd12e33f1, 0x59935939, 0xfce4107b, 0xed9965e9, 0x3c443b84, 
	0x8bafcc7b, 0x44ceb49f, 0x1bcba61c, 0x6d14df91, 0x8f9c83ee, 0x967a685e, 
	0xea2d13eb, 0x9fdd069c, 0x0697d512, 0x5d08e7d8, 0x1ed1da0a, 0x34fe78fa, 
	0x6a67d8c7, 0xa027e905, 0xc83bdb0f, 0x3e73cefe, 0x85fcf208, 0x87ed16d4, 
	0xe788fc0b, 0xb2fff282, 0xf902ab3f, 0xe70ec335, 0x2f9f84bf, 0xe6c623d9, 
	0x44ca3da0, 0x62f2047b, 0x55faf111, 0x2215d9b5, 0x7ae0e10f, 0xfe25cf57, 
	0x2983f917, 0x5c471d8c, 0xbbad6277, 0x83bdf882, 0xd517b1c7, 0xfa40ac4e, 
	0x51c2e59a, 0xf3c57c01, 0x207fc4a0, 0x997fc4f2, 0x75ae353e, 0xd843e089, 
	0xa215b5c7, 0xa1f041de, 0x7f224e27, 0x9157d8c5, 0x455bb3e0, 0xf305999b, 
	0xd4629f81, 0x6e75d91f, 0x7ad5166f, 0x324f902a, 0xffea77ef, 0xa877d386, 
	0x79ab9e1a, 0xa6725b5d, 0xeae34456, 0x95bfb8be, 0x7e71e58d, 0xfb88ac75, 
	0x163ebe8b, 0x56d7fee3, 0x2ffdc5f4, 0x57780e2b, 0x3c158ded, 0x81e2230f, 
	0xa784f1d5, 0xbcc1facd, 0x589eb30f, 0x9d0b7b54, 0x2abedf4b, 0xfe8e5f61, 
	0xe77d62fb, 0x1cefb0b8, 0x6d02ff31, 0xe405f69e, 0xa8ff7051, 0x027e0cc7, 
	0x75839906, 0x4479c65b, 0xc2ed9fe4, 0x71d9d97c, 0xfc035f2c, 0xc5e9afb7, 
	0xca433a20, 0xc796bd64, 0x602a407d, 0x7a9309df, 0x59f923ef, 0x89610dea, 
	0xfdf57741, 0xf683adbc, 0x63e7c820, 0xdf90b5af, 0xeb8e7c07, 0x863ff1a5, 
	0xa0f45379, 0xe9da1db6, 0x84de69c7, 0x79f7bd09, 0x1ee781ae, 0x1467cf11, 
	0xbf50ea84, 0x1a437914, 0x8bb351c8, 0x47e83249, 0xd612eb80, 0xe7f8d117, 
	0x618e8f51, 0x2768658d, 0xf82359f3, 0x463a8a0d, 0xcaf980d9, 0xd87585f9, 
	0x55ef9b8f, 0xeb625436, 0x3bb6c46e, 0x8732e41f, 0x7df103ec, 0x249575fc, 
	0x23ce71bf, 0x347ac23f, 0xcf278e43, 0xdee748dc, 0x3960613d, 0xbc71c40e, 
	0x958234df, 0x20117e53, 0xb5bbd608, 0xd57d7056, 0xe261f6b9, 0xbf8f434f, 
	0xe70b793d, 0xe74aab23, 0x02cd50f8, 0x6b9dcfb2, 0xe21c91b7, 0xf74e413c, 
	0xc60bd432, 0xbcf79f73, 0xc3dbad17, 0x78d76bdf, 0x97d5d0de, 0xe7447437, 
	0x3df72eaf, 0x7036bd86, 0x357df9b7, 0x79899eeb, 0xbc639a9f, 0x6a9c754f, 
	0x9d93e784, 0x0876d8bf, 0x64729470, 0x6c0e83d9, 0x730fd595, 0x4dbbf03c, 
	0x52959fa0, 0x2cbf1ac5, 0x5f70cf22, 0xaf23d68a, 0x5e3df909, 0xdf55edc1, 
	0xa70364f8, 0x03885db1, 0x8c2a7ef0, 0x30ed16bb, 0xa6d6bf5c, 0x7196b4b7, 
	0xe3c4dbfc, 0xa8b702f0, 0x7c4bd372, 0x78f29dbc, 0x3f0f0827, 0x5f3a7afb, 
	0xc275e7b7, 0x92d7b6c3, 0x81b0f063, 0xaff9bd9f, 0xb3b53971, 0x3961fa98, 
	0xd38d27c1, 0x77117af8, 0x35f6bdbf, 0xac7687e2, 0xc91adc8f, 0xd7fd6e33, 
	0x79887e3b, 0x261fedf2, 0x38a36d2c, 0xfa0efa9e, 0xf6ba6607, 0xe9ca9f9d, 
	0xf7eeb359, 0x57cf6744, 0x3477683f, 0x79d15f12, 0x3d01cffa, 0x1fd6de40, 
	0xc1e29290, 0x75f1d83f, 0xb8e31db5, 0x769ef77e, 0x4dce83f4, 0xca177478, 
	0x3516faf7, 0xab19d35b, 0x8840f338, 0xa7be3ef0, 0x13a5b18e, 0xf2875e3e, 
	0xf5433ebc, 0x9b3e4104, 0xfabdf4af, 0x1b9bf808, 0xb06e3c2d, 0xea674ae3, 
	0x9ae78033, 0x8cd57537, 0x3d3df785, 0x3a6a40ef, 0x129eabf8, 0xb8686f9e, 
	0x23def7c1, 0xaffd7025, 0xe0cfed7a, 0xd22e961c, 0xc44c793f, 0xfcb19039, 
	0x737d3e09, 0xe06f8c17, 0x70494df3, 0x8bcdfd4e, 0xd5aef7e0, 0x3f813646, 
	0x5e1f1fe0, 0xee18a5bc, 0x2cb1872b, 0x49ff799f, 0x08ebcddb, 0xee1a8a55, 
	0xef768ef8, 0xd5cf64eb, 0xfdf81a59, 0x7a6c91fe, 0x0f5e096b, 0x0ec6f2bf, 
	0x7d3276c6, 0x6867cf0d, 0x913c9b79, 0x83dfc3f7, 0xdc8e030f, 0x0b8feb28, 
	0x7eb8703c, 0x45b73c3f, 0x7c62abd4, 0x5016eb15, 0x467d014f, 0xf2823fa2, 
	0xf88b2fb8, 0x62c7bd41, 0x0df531f0, 0x74fc047f, 0xd4072baa, 0x20afe7da, 
	0x3f448c1f, 0xf6aee804, 0xb3ebca3e, 0x78a20fd0, 0xc18e533f, 0x300e6f3e, 
	0xe4eb1f36, 0x782abfd9, 0xad6b4e5f, 0xa7223c47, 0x7a8c3f6f, 0x14b1a3c1, 
	0x8d8ccfd2, 0x63c0f515, 0x75ab5d71, 0xd4c2fff0, 0xf1c3d71f, 0x4bb478fa, 
	0x40e60c9e, 0xad6d389c, 0xb8a41d9a, 0xfbe781a0, 0x7df0b5e7, 0xb23cd50f, 
	0xbcd7df13, 0xf23dfb5b, 0xdb1b74c7, 0x63bf7283, 0xfbc21a8b, 0xffaf77de, 
	0xbc19e63d, 0x22c6cae7, 0xd36e9b9e, 0x665f903b, 0xc7adf15d, 0xad8b5f91, 
	0xfbac78f2, 0x06f22f5a, 0xc733ed33, 0x9cfc61db, 0x3fca4cca, 0x39baf218, 
	0x1fc171c0, 0x5681cda0, 0xe07bc176, 0xb23c2bbf, 0xad03de55, 0x010d29aa, 
	0x13beaf7c, 0xa634c1fd, 0xe321bc91, 0xc4af5c63, 0x710e3759, 0x632f9a75, 
	0x63ac0276, 0x71a1ce76, 0xceb0bfc8, 0x51f01a5d, 0x9d92fe45, 0xfc351f18, 
	0xc1fc264a, 0x1733711d, 0xaf483d22, 0x6bdbfb06, 0x43173ec3, 0xeffa09bf, 
	0xefac1ac0, 0x2f13f633, 0x6c3d43cb, 0x8f25203b, 0xde5d00ea, 0x3ca0a52d, 
	0x11a5bb59, 0xfc4f60f1, 0x1bc23aa3, 0xfade904b, 0xff028f53, 0x77d592db, 
	0xac1d01f7, 0x53d5f573, 0x17891d60, 0xf3c55fdb, 0x81fca2b1, 0xe4deb1b2, 
	0xbb8e3194, 0xee09701a, 0x933f7ac7, 0x7aaeb083, 0xdc63b32b, 0x367969ff, 
	0xa8a625e5, 0xf009d9ce, 0x93036b3e, 0xdd335e31, 0xe78c3da6, 0xa4394561, 
	0x415566f3, 0x987a33c2, 0x3eb040e2, 0xcf9a2fe4, 0xe7c7d62e, 0xc40a1251, 
	0xbe30db7b, 0x8f1c3cec, 0x39161d75, 0x5aba4155, 0x7b9552ea, 0xde6de323, 
	0xf40544ba, 0x4f816d84, 0xa8987c46, 0xcdd6193a, 0x5e6192d9, 0x9bd433f2, 
	0xc3bcc79f, 0x6ddd677c, 0x3f913ef8, 0xc6727d5a, 0x8ebce8d8, 0x948ccd67, 
	0xe81bbee8, 0x5cf40599, 0xb1390ced, 0xea2364ae, 0x71b79861, 0xa8f3c672, 
	0xb2cf9a87, 0xacc7ce04, 0xb1c1d79d, 0x1c28a6f6, 0x64b9dabc, 0x4685e333, 
	0x33fa082c, 0x287cf424, 0x281dad43, 0xed79fa6e, 0xe9ce1464, 0x9a123c44, 
	0x0c7df1fe, 0x1be6b5fc, 0x75c39cc7, 0xf3f71d9e, 0x3f19fa10, 0x38fdcc9d, 
	0xf800fe63, 0x18ab5a9d, 0x35c215ff, 0xee6b849d, 0xe71db37c, 0x0fa0d809, 
	0x2a1c0b74, 0xabd031b1, 0x8c738121, 0x66b81875, 0x7940d2b3, 0x4c37c27d, 
	0xed1e7b8c, 0x811e9308, 0x80d5bffe, 0x013fc11c, 0xca2092ef, 0x2dd17363, 
	0x9ffc0641, 0x83b6f4dd, 0xb9f5c2a5, 0x9c1972a7, 0xcf20e877, 0x3881c60b, 
	0xf31cbddc, 0xc4bf1c6d, 0x411dd08f, 0x093fd91f, 0xbaf01de9, 0x7886de28, 
	0x8295f108, 0x19f607f8, 0x19ea7887, 0xd7e4eeb8, 0xbd4f10e3, 0x33be3837, 
	0x99e4daf0, 0xbf252ccf, 0xe11af007, 0x38ae2324, 0x85da6e3c, 0x86bca9b8, 
	0xd73a65c7, 0xed14b73e, 0x2389f124, 0xc3fc2742, 0x759ab33a, 0x831a5abf, 
	0x84cce02f, 0xd17c247e, 0xcaafc77d, 0x78cd50b1, 0x1957642e, 0x2e97bfe6, 
	0x1fed1962, 0x4f94f244, 0x401e81bb, 0x9773eeb7, 0x82f1fe78, 0x1811de97, 
	0x1f06e7a3, 0x2f17eb85, 0xaf653cf1, 0xca11f697, 0xe524f110, 0x3831c16f, 
	0xc68d3ade, 0xd8ca5a9f, 0x429fc835, 0xe033ba2e, 0x35973e3e, 0xbbeb9e8d, 
	0xbbcf16ef, 0xd31cfdc5, 0x7cf17cfd, 0x1982dfe1, 0x9913df78, 0x2a12e91f, 
	0xe04bf714, 0x6e7fbe3e, 0x1fbc79e4, 0x1ffd7370, 0x17287d5a, 0x564a1ce9, 
	0x86c1060f, 0xb5d046fd, 0x33698e8f, 0xba07a81d, 0x360e3ff3, 0x87fb14fc, 
	0xf57fa9b2, 0x356794c7, 0x28cc55c6, 0x3744a961, 0xd1276dad, 0xc7297bbd, 
	0x7aee9c39, 0xa1d709a6, 0x369c01fd, 0x3d5483f1, 0x5dbfff5a, 0x9bd571c3, 
	0x3daf1c35, 0x52c1fb54, 0xaa0fe785, 0xcf199d78, 0x25dd926b, 0x3f67d8fb, 
	0x35fd933f, 0x7f61adec, 0x7a4e86f1, 0x4b3b234c, 0xe1fd16f6, 0x478b0ecc, 
	0xc6f3bb23, 0xee7f1c1b, 0xfcfdaed7, 0x876cc47a, 0x7fe0aa76, 0xe8ab0bbf, 
	0x677240dd, 0xb42143b6, 0x617eb877, 0x77e356ef, 0x3ec8e74f, 0x417d6014, 
	0x3adaf3bc, 0xdfec27c5, 0x96edfd33, 0x6e885781, 0x7fd41f68, 0xdfadd091, 
	0xa2714179, 0x867b24dd, 0xf7c32a78, 0xb665c457, 0x73f57d64, 0x1d0fb40e, 
	0x71cb5caf, 0x7edd5550, 0x48f5bb8a, 0xa33af951, 0x96bc8ab5, 0xf542ddf1, 
	0x7e971e52, 0x40bceaea, 0xdc4b5e4c, 0xeb06bf47, 0x2f669bb5, 0xa01e610f, 
	0xdbe7f05a, 0x5009af93, 0x27e4c27e, 0x8bbcc28f, 0x55f77c5f, 0xc705fe48, 
	0x8e997b3d, 0xd64fd07e, 0xa84dd4f9, 0x5e81e247, 0x8af6c177, 0x1360d635, 
	0x05c614f6, 0xbc820ed0, 0xb907ee07, 0xaaec470d, 0xd0053ed9, 0x2c7da38e, 
	0xd1f6489d, 0x9f64bbb0, 0x72dec29c, 0x7be3097e, 0x5bc76803, 0xb435dbfb, 
	0xb8b7c887, 0x0172462f, 0x1f4a2e48, 0xfab19969, 0x56e5f088, 0x3e5cbbc4, 
	0x7b409708, 0xe1c5c854, 0xb08f8e1a, 0xbbfe92b5, 0xf20ae88d, 0x133ca324, 
	0x704673de, 0xc412e208, 0x330e06f5, 0xafe138ec, 0x1fe65c28, 0x38e5cea5, 
	0xeb627c25, 0xed773c0e, 0x21e6fbdb, 0xbc1f094e, 0x7e84476e, 0x42538121, 
	0x521d8537, 0x9e88fd14, 0x270fb4e5, 0x00d427ee, 0xf44c2e76, 0x10129c23, 
	0xa6e884b8, 0xf98f7047, 0x88bf903c, 0x113e069e, 0x4c7037f4, 0xae70a6e0, 
	0x5a6c7604, 0x7101c4e9, 0x673c484a, 0xb8829c45, 0x40ec24a6, 0x9d2810bb, 
	0x63bf30c8, 0x1e3d064d, 0x3842e7e4, 0x829c0545, 0x9c4cb8eb, 0x6058e782, 
	0x973094e0, 0xcb81c703, 0x0707ffe1, 0x35ab7fe4, 0x815b6d81, 0x3ca19967, 
	0x1dcc377a, 0xaadb76e0, 0x28f679aa, 0x707031be, 0xf8307108, 0x775521e4, 
	0xbc260e20, 0xe932f48b, 0xbd97a785, 0xc1c688e9, 0x70990281, 0x44e1e11a, 
	0xec572bcc, 0xe207fcc4, 0x9affac62, 0x17287053, 0xde0334e9, 0x5fd3d05d, 
	0x87870d2f, 0xdcde8b43, 0xbc453ec9, 0x845f88c9, 0xfce14f90, 0xb9c3f743, 
	0x81fe8584, 0xcd3699f3, 0x437f90c5, 0xb69d2fc2, 0xc708e41e, 0x309f0327, 
	0xaf085bf2, 0xf065fc1b, 0xed24f4c1, 0xf5cb9455, 0x0bb5bf93, 0xadae92eb, 
	0xe0dd38e1, 0x1dfeb30f, 0x7fdfae8c, 0xe3dfb1f6, 0x5d74cc06, 0x40627b9f, 
	0x30e71aba, 0xc70faefb, 0x71a06e65, 0x04ca0b3b, 0x3a8e415d, 0x39c2df10, 
	0x7b3cf17a, 0x9c223fc8, 0xf9387e47, 0xe8c46fe7, 0xdb81b505, 0xbd2ba04b, 
	0x431b90cf, 0x03edeb0e, 0x9eb32deb, 0x0871b922, 0xb838ba3e, 0x41fc327e, 
	0x764fde1d, 0xe5cf4b32, 0x2e7a7175, 0xb359c77e, 0x9f5a1dee, 0xca5af7a1, 
	0xe7280e81, 0x47c2da49, 0xc4bf69e2, 0x07a4213f, 0x839cf5f0, 0x80ed525b, 
	0x0f7b7e97, 0x7f7d6f8f, 0xb88a9c82, 0xb65ada75, 0x6ceb7110, 0x6e22a6a6, 
	0xf7a575c5, 0x3f5b7988, 0xf6353dbf, 0xb60ea6a1, 0xfc024f8f, 0xef9e477b, 
	0x6bfefe99, 0xd09f3c0e, 0x1b7c3f1d, 0x759ac2fd, 0xdc68ca96, 0xfd73a6a2, 
	0x867ea12c, 0xee05fa7d, 0xd01df1da, 0xffdf51d3, 0xf5c65c6f, 0xc3203bf3, 
	0x3d9ce1f3, 0x38fe124c, 0xce78138f, 0x0b977f03, 0xf84d929c, 0x2b60fc8b, 
	0xa71cebfa, 0xfcff258c, 0xa897e253, 0x2fc083f8, 0xae110f1c, 0xc0dffee1, 
	0x2f632678, 0xf28199e1, 0x89071778, 0x80dc6003, 0x4fe800e2, 0xc7bf69d4, 
	0xbf9ec7ef, 0x76f7e79b, 0xf9f8077c, 0xe00e2474, 0x644f4b09, 0x4a0b3cc0, 
	0x0acf7fb9, 0xc2f63966, 0xf9076ffb, 0xe5ca38ea, 0xb7e519ca, 0x7279841f, 
	0xfeb77e80, 0xf2e317fc, 0xcea1bde1, 0xddf89999, 0xdbd2ec83, 0x36e79835, 
	0xb00d94b0, 0xfa4f34bf, 0xb46c84ec, 0xd1f1328b, 0xdf2cbfed, 0xf783ef89, 
	0x2dfdc4ef, 0x09790528, 0xd1337bd2, 0xc95e59cf, 0x1f882471, 0x3962f3c3, 
	0xe7581cb3, 0xd23d05ef, 0xe9e4f20c, 0xd744a4f5, 0xd03ae147, 0x5e147abe, 
	0x564dea07, 0x4e8106c7, 0x3659776e, 0x4de8237e, 0x3a832366, 0xe11e779f, 
	0xc9666cf4, 0xf3d47de4, 0x74d3f545, 0xc7e42f94, 0x7ec0f5ba, 0xcf1d52f1, 
	0x1caf6887, 0x5d72f384, 0x56d7959a, 0xd515f98e, 0xa28ff185, 0x56cef52b, 
	0xaf2e7bc0, 0x7d8368ee, 0x76e1ef06, 0x7a51903d, 0x5d27eb16, 0x487b2c97, 
	0x7f800b4e, 0x6e5b3f80, 0x3c448ad4, 0xd6a7465d, 0x256b0390, 0xf7bce3af, 
	0xeb4f2e1e, 0xbad2726f, 0x6f49be9e, 0x79ba01ef, 0xe2ef98b2, 0xdd5f5c39, 
	0x2c0fd82b, 0x5ab3b37a, 0x714be3e3, 0x4ea6931f, 0xf4333f45, 0xa88a2fd4, 
	0xde57f7dd, 0x456de21e, 0xa82bfa6e, 0x5f38a687, 0xd5eb0a78, 0x3ae02742, 
	0x3bd0cbe0, 0x114f5c62, 0xf3165e7f, 0xf70b4064, 0x7b1ef22b, 0x38f39f08, 
	0x2eb1bb43, 0xdd76efcb, 0x664cf58c, 0x2ae532fb, 0x74e90876, 0xd417f1b9, 
	0x611ad61b, 0x1f89522f, 0xc91e6266, 0x579fb7b0, 0x602b1c8f, 0x45a77f87, 
	0xd7af37e6, 0xadc3a7d0, 0xa6dd66b3, 0x99a27d18, 0x4ff64ffc, 0x23dbdfc0, 
	0xefc0687e, 0x1c9fa175, 0xb5689ef8, 0x2fe85dfb, 0xb6f33607, 0x75df06e1, 
	0x4fd18b5b, 0x8d3ed9d5, 0xe5ac00e2, 0xa97df628, 0xefb0dbfb, 0x97d1eebf, 
	0x68babe28, 0xe7a815cb, 0xbe009fc0, 0x31c6fa79, 0xe8237df4, 0xd71209b9, 
	0xc0cfd92b, 0xefc0b5f5, 0xbf8c6a8e, 0x3b9fe5f6, 0xef457c79, 0xb27207dc, 
	0xe012f111, 0x40b600c2, 0x131dc0df, 0xc3cc161d, 0x1809b559, 0xce58ef37, 
	0x18421beb, 0xf9c4ae47, 0x9c63b7cf, 0xe1718020, 0xf57e515d, 0xf696da1d, 
	0xe5cf18c3, 0xf800f3bf, 0x23d6f476, 0x5fd5cf18, 0xb24ae979, 0xceb7a30b, 
	0xbeae78c1, 0x9431eda3, 0x6defb3bf, 0xae78c12a, 0x95eb667e, 0xdf1bdf24, 
	0xc3dc71e0, 0x71473e0f, 0x23d6b4dc, 0x794dc714, 0x71c60c6d, 0x8e22f1b5, 
	0xf83baaeb, 0x7ed38b8f, 0x7f98f40c, 0xa711eff1, 0x99f3dc05, 0x5fc0b4e2, 
	0x07b1e88c, 0x54327bef, 0x9e77d507, 0x6c66c695, 0x9f5a7110, 0x859a0ff0, 
	0xf85a703f, 0x45176807, 0x2f8e649e, 0x7b4e2623, 0xc9eb9aac, 0xdeb9cbad, 
	0x3b6a5d96, 0x1c11adfa, 0xef0d29a5, 0x369c465e, 0x5979f407, 0xf8c13704, 
	0xa06dad4e, 0xa7dd6cf8, 0xb7decf8a, 0x8b3e363c, 0x4e51cff1, 0x5f846bf0, 
	0xc27e8894, 0xb47bf43e, 0x423c1f07, 0xadddd9f1, 0x409d5257, 0xefb033d3, 
	0x56baf9c4, 0x7e00d8f0, 0xfd8182cf, 0x5dc4169e, 0xc7bf786c, 0x9efd59f6, 
	0xdf8c5f05, 0x183bf863, 0x079ffa0d, 0x29efdf2e, 0x9f1b1e5c, 0x23ec2f5d, 
	0xebc84f7e, 0xc29ec012, 0xc33e9f3a, 0x718e9812, 0xe31b357e, 0xb8df4f87, 
	0x6a8e3760, 0x13b37aae, 0x69757bcf, 0x73d466c5, 0x7d701fa1, 0xeb755cd3, 
	0xebd7b419, 0x87bfb1dd, 0xfd097a80, 0x1ed16c10, 0x5a48ce86, 0x1f3dff1d, 
	0x134bae07, 0xd7f42cb8, 0xee0b3a4f, 0xe51b7a15, 0x9db2ae23, 0xdc21df7e, 
	0xf09db9d5, 0x5bbd230f, 0xfbc7c192, 0x1e608f01, 0xf85d82ae, 0xcb7144ae, 
	0xaebcd5a9, 0x14372a71, 0x8fbe9e30, 0x03aa3e64, 0xb65f83f2, 0x85cfc701, 
	0x39cdf316, 0x6de31e30, 0x41fdfe4e, 0x67a3dd5f, 0x6d86a8e3, 0xfdbffd7c, 
	0x2068f304, 0xc5cf1877, 0x91bdd97c, 0x57d3d97c, 0x4787da30, 0xa8fdfd89, 
	0xbf7ce582, 0x73bf606b, 0x039f75a1, 0xb881515c, 0xfa85db23, 0x7d63af1a, 
	0xe2f800c7, 0x70be1321, 0x08199db4, 0x6d29685f, 0xcbc95f20, 0x968b3d39, 
	0x82f841df, 0x3d334570, 0x0cdb55b7, 0x9d776bf8, 0x265a17c0, 0xbfa18b9e, 
	0x71e4ab6f, 0xc7396562, 0x2727ee17, 0xb8a8be10, 0x09e9ed89, 0x2d17c7f7, 
	0xf8e05f02, 0x30be047f, 0xc8405dec, 0xec05a06d, 0x03e52b60, 0x78f94f28, 
	0xb377a725, 0xb078e385, 0x9bf89dc3, 0xc6471839, 0x5f90ff3a, 0x1d11a571, 
	0xf5c91754, 0xeebe8cf7, 0x56aef8a2, 0x97bb4ae2, 0xbfa9bbee, 0x6eebe8d9, 
	0x879afe26, 0xb2fc1baa, 0xf57219e5, 0x4977f8fb, 0x2fa34ebc, 0x52a790df, 
	0xcb9421be, 0x3b0c30eb, 0x352bec08, 0xc0ef3ce8, 0x0bf22c7e, 0x80df2265, 
	0x519d897e, 0xe566ddbd, 0x5f2253c8, 0x3d78d55f, 0xdd403f63, 0x1bd73ef5, 
	0x59ae7f98, 0x31ddccf7, 0x38a606f5, 0x7dfd0071, 0xd9c63f7c, 0xa53d3f81, 
	0xd2f7e913, 0x23824702, 0x5e436814, 0x7fa0b317, 0xc0e59f61, 0x2b53d07c, 
	0xadff1e79, 0xee4cf00a, 0x8a5271c1, 0x187a895c, 0x7f6c1cf8, 0x6b99c9e0, 
	0xdfdc3e70, 0x276f8c51, 0x47a499c9, 0x5132ea93, 0x827fa28f, 0x2bf0cc76, 
	0xf93ffecc, 0xdc4ce023, 0xfbfb97ba, 0xf9e3edb7, 0x4e4bf245, 0xf51d7f0b, 
	0x83f7076e, 0x7d7eec17, 0x37c89667, 0x67b28f6e, 0x71132c37, 0xd8ec6196, 
	0xd0a78da7, 0xaf029d7e, 0x94f122f9, 0x3bd7eed0, 0x31819d71, 0x8f7fd93a, 
	0xf47445c7, 0xdc063a0b, 0x97b38e9c, 0xa66cfc71, 0x7f2f998b, 0x473f377d, 
	0x23d8938a, 0x65f930fe, 0x4c81df51, 0xc271c658, 0xef5c65b8, 0x0fdc602c, 
	0xd1cbff03, 0x1e63eb0c, 0xb99ac7f0, 0x8f6cd55f, 0xaf7abff2, 0xbefe894f, 
	0xe497d0c6, 0xc73d0187, 0x57fee32c, 0x635ff840, 0x7fea0d96, 0xbff60705, 
	0xfc81ecf4, 0x3ac5abaf, 0xa753de03, 0x7eb4bbf1, 0x9f6e57fe, 0x272315ff, 
	0x5ffb878a, 0xff099693, 0xffca3f2b, 0x96fe12ca, 0x7d27df9d, 0xbc1e8838, 
	0xe867bd5c, 0x86fde353, 0xdc3d44de, 0xf17a0850, 0x7287962b, 0x9e1f422d, 
	0xd447e88e, 0x3a9768cf, 0xde5356d7, 0x8697122c, 0x4b8e8a93, 0x351ee29b, 
	0x51e560eb, 0x1d1b0c7e, 0xadf91f7b, 0x377f8dbe, 0xf8aaf580, 0xdbd600dd, 
	0xffb8cbab, 0xa2ac0ddd, 0x603f7f45, 0x56accdd8, 0xab0a9bb2, 0xd51aefa6, 
	0x8b714638, 0xef4e8b22, 0xcdfc1649, 0xcea872e2, 0xe7abd02c, 0xa0fc6036, 
	0x7c612823, 0x0e3b4140, 0x935baf7a, 0x939035ab, 0xe1fc6e23, 0xdecfa044, 
	0x9bf7092e, 0x3652cf68, 0x295d5364, 0xefc6dbb7, 0xfaf188da, 0x26b61ecd, 
	0x6bef8eda, 0xce17efa5, 0xe9c51e4c, 0xceff9271, 0x5e5bfc5a, 0xacee4bd2, 
	0x106843e2, 0x0dd12ee0, 0xb7be95f9, 0xbf459ac8, 0x3bd8161f, 0x89f65333, 
	0x24736878, 0xf4a0b16e, 0xa7b45ccd, 0x8162dc46, 0xf803b807, 0xdb8cb827, 
	0x0b9090f5, 0x287904e6, 0xcb8771e3, 0x5f004f8b, 0x012e226a, 0x9301ed7a, 
	0xb8303c5c, 0x12e2985c, 0x0dc732f5, 0xd89ed32c, 0x564e2e5f, 0x464a3889, 
	0x2e5c9bd6, 0x7269d566, 0x17122e44, 0xc6a17219, 0x515b86e0, 0xbc5c820f, 
	0xeb01728b, 0xe5c1df76, 0xb17286c2, 0x7817223d, 0x1ffab4bf, 0x6141172f, 
	0xa69f489f, 0x1f39738a, 0xf43357a5, 0x775836dc, 0x1b48ec08, 0x8abf7f8c, 
	0xbea30beb, 0xc16de90d, 0x387f71ef, 0xf3fa4ed3, 0xf9c2d067, 0xc05e45f9, 
	0xf1d8f42f, 0x1d8f4e2a, 0x0f7cf01f, 0xbea2a7fa, 0x32fac24c, 0x289b2ff4, 
	0xf84ba74f, 0x55cbd9bd, 0xe44cdea2, 0x768dbf3f, 0x3f0886ea, 0xfb15c5f5, 
	0xb44eabdb, 0x7f28b657, 0xc6fd17b3, 0x1affe94f, 0x695a6f7e, 0xe115e526, 
	0x3579414f, 0xe8ad13c7, 0x00eff29f, 0x3f225dc6, 0xe1f89075, 0x814ff021, 
	0x96fe17bf, 0x5cf6fbc7, 0x6b89e231, 0xc6f8f7f0, 0x1ae27d8c, 0xfb4eefe8, 
	0x83ae27e7, 0xc58ceefe, 0x21b75c4f, 0x7b0cdf62, 0x8e1f7c46, 0xe18f1bc4, 
	0xf1145c39, 0xedfeb83a, 0xa37edc53, 0xdf41b45c, 0x09fdb873, 0xecc1c794, 
	0xfb9c1d4a, 0x7223abd7, 0xf1d97753, 0xedcc8b3c, 0xf372c0c9, 0xcf11955c, 
	0x3ea6e433, 0xc36c6e46, 0xa9ffcdc8, 0xab1b958a, 0xfde09ec9, 0x41b94eff, 
	0xb6f7d0ba, 0x944fc883, 0x7614c81d, 0x03b44de0, 0xd932ad7f, 0xb145bd81, 
	0x0b60a076, 0x7bf201d9, 0x767f72b6, 0xf1ebbc14, 0x303f9e2a, 0xd448439f, 
	0xb0e71991, 0xe54dc609, 0x748b91f2, 0x2d28bf25, 0xf0336792, 0x1e712cc8, 
	0x853d6259, 0x7f44774c, 0x201d79b7, 0x713086d0, 0xfdf22677, 0x29f7e30c, 
	0x456ef6e3, 0xa49199fe, 0x79fa8abf, 0x157f4d86, 0x56150feb, 0xf1e50a30, 
	0xa743b436, 0xd14be323, 0x9a5d80ee, 0x177e0291, 0x52d64f5e, 0xa9cf119a, 
	0x7ff71aac, 0xbd1140e4, 0x2d7008b3, 0x56540bc6, 0x4db8c767, 0xb245f4a0, 
	0x43d6c51f, 0x02df7c76, 0x45e60f5c, 0x3f71160e, 0xdb88a3b5, 0x7e8f312f, 
	0x89ad88b4, 0x9dbea3a6, 0x1be217ec, 0xc3e43394, 0x371c0de0, 0x3f90fae1, 
	0x071ca3b5, 0xc719efe1, 0x81329be0, 0xce030e7b, 0xdef03f41, 0xc3d2f801, 
	0x06c5c0fd, 0xd03f0a5f, 0x7f16738c, 0x2a197cc1, 0x746a6fb8, 0xbfdb113c, 
	0x6c1dd544, 0x1e50b02b, 0xc9f5f88e, 0xd9a4fefe, 0x6f00b44f, 0xf08fdef9, 
	0x8aaff131, 0x24380738, 0xc1970f3a, 0xe70311fd, 0xecd45914, 0xbeb25c68, 
	0x010be797, 0xdc71b8b7, 0x1e608efa, 0x7ac29f9e, 0xb537545c, 0xeb1b2bb7, 
	0x3cbf0031, 0x2332f949, 0x57b7f26e, 0x9aee89db, 0x712fbf4c, 0x6987bc44, 
	0x3df45d33, 0x5fbc03e6, 0x9fbe2551, 0x3aa4ab8a, 0x1bcf56dc, 0xfa7267c4, 
	0x6f94b3c9, 0x834f7035, 0xbba9f897, 0x13e71a7a, 0xea43af0f, 0x780f39c3, 
	0xa3a4f963, 0x306de49d, 0x4e1a6d79, 0xbe7f195e, 0xdfc6a605, 0x2e98c037, 
	0xb7699efe, 0xafdfcbcf, 0x2103f7f1, 0x5a2768dc, 0x56358d54, 0x39c03a08, 
	0x635a026c, 0x6a3ef89f, 0x51e5fd5f, 0x347943cd, 0xa88661e4, 0x3bf92687, 
	0xea51e42d, 0x71beefbf, 0xfe366ac9, 0x148cc83e, 0xea4dbb35, 0x28f58f4f, 
	0x7724597f, 0xfbc3a0d9, 0x5869ffad, 0xc79fc90f, 0x88a3f02b, 0xfe8a54fb, 
	0x66075e1a, 0xc999eba6, 0x97845585, 0x858fc107, 0x942883f8, 0xdbb9023f, 
	0x0bb7e511, 0xe3cd36bd, 0x8b718c3a, 0x10d7a8dd, 0x296865ef, 0x22fecfa8, 
	0x1fe98bfc, 0x30d76d1f, 0x7ce8bf1e, 0xc005c52e, 0xbd09d6f2, 0xae92bd39, 
	0x7cad3c3b, 0x7b23e63c, 0x1dbd7197, 0x421571c0, 0xddb88a4f, 0xef87e46b, 
	0x967be18e, 0x18f7c261, 0xeb14a947, 0x14f14adb, 0x8f3b41c7, 0xf40f3e6f, 
	0x9ceb0cdb, 0x97e223df, 0xfa8a4fe8, 0xcf5880b7, 0x4dffb87e, 0x391645c4, 
	0xd32dc44d, 0xf1191710, 0x8e9eb847, 0x8e9eb87d, 0xf98bf7f7, 0x18867ae0, 
	0xa7f7819f, 0xd09a9958, 0x5fdaf14d, 0x80f9e36d, 0x21d72d3d, 0xfe13ed9b, 
	0xec0f2e83, 0x8ba85c3f, 0x1cba1ff5, 0x6649a728, 0xc30ee1ff, 0x503a087f, 
	0xff866d6e, 0xc27111e0, 0x72b1a982, 0x7fc9bb75, 0xfe928f60, 0x72f759ad, 
	0x5bfd4c55, 0xa91eac7a, 0x563c7759, 0xbd8e8ccf, 0xafd5d4ff, 0xbd4e5d55, 
	0x3c65a6c8, 0x8bd46dce, 0x7d08fd60, 0xa165f9e7, 0x442db1c7, 0xccf4c18f, 
	0x99e9c327, 0xf3c66dca, 0x840e2a9f, 0xf0d53c38, 0x1e507acf, 0x9fd21def, 
	0x73f857bb, 0x87872667, 0xe316171c, 0xc4d1fb22, 0x7ed2f67e, 0xed372e26, 
	0x3f699f67, 0x0c4e3cbd, 0x7f42e2e7, 0xd725ce11, 0xf07b2e74, 0x5768425c, 
	0x51d7af30, 0xf73f42ec, 0xdcb9f361, 0x0173a5ef, 0xfc40e33b, 0xb92bd811, 
	0x2f4a3d15, 0xc015fd09, 0xea2f7af3, 0x8d4c667c, 0x3a3d03b5, 0xbc3067ad, 
	0xfc677187, 0xbc306bfe, 0x57f26677, 0xaf450f96, 0xcd6f3acf, 0x31e5c2ba, 
	0x562a33f2, 0x87f5cc3e, 0xf72bbae6, 0x69efc6dd, 0xfe8f2d14, 0xbab078be, 
	0x388f1c43, 0x169f90d3, 0xd4468ea3, 0x23f39be1, 0x24241e46, 0x1f29eaea, 
	0x63a91854, 0x43f1ea32, 0xc7a11d46, 0xfe9cf945, 0xbf3c37f5, 0x4698f983, 
	0x5121a3b0, 0x7c16e847, 0xa0ebb97b, 0xa2d39e3a, 0x9e2fc82e, 0xfbc83d5f, 
	0xba977f1c, 0x7550c755, 0x74bf66ab, 0xcc55bad0, 0x79f35e07, 0x1b9d56ea, 
	0x4d6caf31, 0x8f7db5d6, 0x702e99c1, 0xaadd79da, 0x2074d49a, 0xaa6b3e2a, 
	0x9aa0fa53, 0x560e9dd7, 0x44f484a7, 0xd745fbbc, 0x5ff51929, 0x45fc0b2c, 
	0x775d9fdc, 0x9a929d60, 0x549e28ca, 0xc92b6eb3, 0xc129d517, 0x571efd3e, 
	0x93a006e3, 0xc0ef59df, 0xc2857b3c, 0x75e0c2f1, 0xf9e83b5b, 0xf236b240, 
	0xffd84691, 0xc70bfdd4, 0x8ef5e235, 0xc7f631e5, 0x94f3ef14, 0xa7d3faf0, 
	0xd8cdde45, 0x9ea253df, 0x5972f306, 0x7d7c5f3d, 0x7d320ebc, 0x510dfa0d, 
	0xbf54f1f5, 0xf1e3ea2e, 0xa6e1227e, 0xdd3c7d48, 0x1fdd31cf, 0xefbe3ea4, 
	0xf1f520fe, 0xeac1fdc6, 0xf7123fe3, 0xb2f1f523, 0xeee3e283, 0x2c0e898f, 
	0xea8ba66d, 0x7f4127e3, 0xbf9c6452, 0x359df8d2, 0xaefe026d, 0x6ea287c1, 
	0xaac9e902, 0x7f87af07, 0xfb8f397f, 0xede449fc, 0x737daa1e, 0x93f982b9, 
	0xfc3d4f2f, 0xaf0f5e74, 0x50b1bb7e, 0x22f81bd4, 0xeeb35d7c, 0xaa07cb4f, 
	0xbd140c6b, 0x58d75311, 0xd27deeb3, 0x31f22af7, 0xd070abaf, 0x8a77c47e, 
	0x2c1f7dda, 0x322fdfc7, 0xdd66afbf, 0x67f3b147, 0x31f1f2c6, 0x9be51ba0, 
	0x560cb9c4, 0x056abd5f, 0x515df3a7, 0xe779f22d, 0xda05795a, 0xabea018f, 
	0xc11d6047, 0x29d5f500, 0xeb57d703, 0xc19d44bb, 0xc4af9beb, 0xedb0eafa, 
	0xfdf8d999, 0x726e2f94, 0x3bfe3fdd, 0x45af2302, 0xd11dd97a, 0x1e7e86c7, 
	0x791b1f4c, 0x53bbe42f, 0xbe3570b8, 0x474e2fbe, 0xba2758fa, 0xa66e9e91, 
	0xfff8c4ef, 0xc784a0ff, 0xf416eeb3, 0x416d025e, 0xa2b5a475, 0xe545f41d, 
	0xb9c24b6f, 0x241d9452, 0x5df51b3b, 0xc781a05c, 0x52cec051, 0xefa845dd, 
	0x89d5383b, 0xadd46afc, 0x85dd4486, 0xa899a761, 0x27ea30bb, 0xd86d3b0c, 
	0xd84950e5, 0x7f0b1521, 0x77501fec, 0xa0a77681, 0xcdebf2e6, 0xe167b823, 
	0xdef9cb8a, 0x6a7b8cc2, 0x4409c1d6, 0x7e4c79e7, 0x4cb3d10b, 0xb061c39c, 
	0x175f288f, 0x3125c487, 0xf1c36fe3, 0x5f1f07ab, 0x2b3beeb3, 0x2b39e462, 
	0xd583fdf6, 0x2579fedf, 0xade48bcf, 0x96feb81c, 0x474f6cea, 0x6f5145e9, 
	0xab97551b, 0xd67c5f23, 0x97035bfa, 0xd617560c, 0x4e2c1eaf, 0xf5e0ecb3, 
	0x95dfa65b, 0x1cfdfd88, 0x0e6efc66, 0xe9ce5efe, 0xac2efaa8, 0xba8b0dbf, 
	0x9ea460db, 0xf62ba8cb, 0x813c761c, 0xfd460175, 0xbfa741ad, 0xfa74e0ad, 
	0xdbaf0578, 0x46ddf232, 0xd38cdb3e, 0x94b875cc, 0xc88b2f17, 0x4b7751bd, 
	0x5144f079, 0xe45a7b7f, 0xbe5458bd, 0x8371eb0b, 0x635c3a91, 0x7a107f3d, 
	0x5c3dfc76, 0x2bbe600f, 0x79221e46, 0xe79e5cae, 0xca7df1e2, 0x1f5e3177, 
	0x9c60f983, 0x06e22e67, 0xfec7bf11, 0x0ee3d665, 0xe3c32f52, 0x31ee23f7, 
	0x3d465ef2, 0xd1adacee, 0xb15bfbf1, 0x4dd7971e, 0xfb8f580c, 0x27116abd, 
	0xaddc7ac5, 0x9b132f58, 0x5ffbc2f7, 0xe7d7bc86, 0x3d45c7ad, 0x176f57d2, 
	0xe86b8f55, 0x3d77bfa3, 0x0cefe1ae, 0x7cbeceb7, 0xd7c8816d, 0x10fac67e, 
	0x0f6b3d39, 0xf560fbf2, 0x08fd4621, 0xbc9455c9, 0x6bfb9e84, 0xa8827e7b, 
	0x5ebe010f, 0x41d331d0, 0x9d483372, 0x5f958ac8, 0xaa913ace, 0x875cfc95, 
	0xc0b113ab, 0x44eaa1b8, 0x80907a8c, 0x564bdfd0, 0x5b2b7972, 0x481d4439, 
	0xe49bde54, 0x97522cbf, 0xd8cad77f, 0x2ff637fc, 0x48642eb3, 0xac58703d, 
	0x7375802b, 0x03d0064b, 0x207a7db9, 0xe8442eb6, 0x852bfd81, 0x581fc81e, 
	0x2ffde00f, 0x5ce81e83, 0x29baa6eb, 0x27d0fe23, 0x0e599e2f, 0x2705af5e, 
	0x089d4035, 0x09da9efe, 0xc5566b8a, 0x89d737dc, 0x412f570c, 0xd9031275, 
	0x612f510f, 0xfc1849d4, 0x65ce29dd, 0x0cbf1f6f, 0x77f83f66, 0xe3797d1c, 
	0xe651fb3e, 0x75e76e28, 0xf2a37363, 0xce0d4fbf, 0x91fb6637, 0xbcdf1439, 
	0x7df3f2b9, 0x4ac2f1cf, 0xec296f51, 0xbe26adc7, 0x865ffbc1, 0x560fa27a, 
	0x89ba98b0, 0x727673be, 0x8eae19be, 0x63bb99e2, 0xfe9028eb, 0x0c51d503, 
	0xeef46756, 0x8cea61ca, 0xe7375e0a, 0xfcf164bb, 0x5bbe7c21, 0xf3df539c, 
	0x57cf4d73, 0xb438a09e, 0x2249f6c2, 0x29d46eae, 0xc1b7e399, 0x09b7e281, 
	0x97adf8e6, 0x7b03d5c7, 0x18e91925, 0x8dd5c46f, 0xaa6aadf8, 0x399afa53, 
	0xb1bafeae, 0xd7e7111e, 0xbfee5fc8, 0x0f54bd9e, 0x52cf5e6d, 0xd4764f5c, 
	0x52a70a7a, 0xb7b02dce, 0x3363d68b, 0xb4d4a7af, 0x8f797e9e, 0xd4dd4537, 
	0xc54395c2, 0x3da21783, 0xc77b38a0, 0xc43ae390, 0xccdd7338, 0x574feab4, 
	0xf57d7337, 0x199bafff, 0x7c866eaa, 0xbd9fd5ed, 0xdfc0c66e, 0xe7fe4117, 
	0xec4fe945, 0xfeaf520f, 0xb8f7f0a9, 0xbf87cfea, 0x697e0947, 0x99c3df11, 
	0xffa8eeed, 0x748dfc66, 0x61ef2a19, 0x13497fae, 0xeae1e971, 0x8ab57e5f, 
	0xab8789e7, 0x8ab3d97f, 0xa235b9eb, 0xc5fea01d, 0x585febc5, 0x5d1cd6a6, 
	0x15b392ff, 0xfaff6a71, 0xc851ea97, 0x9f500bcf, 0x2fc64594, 0x4663fa14, 
	0xbc79e80a, 0x065bdf8e, 0x9e5feaa3, 0x4579e22c, 0xa2fbbfcc, 0x93d65feb, 
	0xfbe469bf, 0xebce985b, 0x7115f65f, 0x54d0743d, 0x516af2ff, 0x7fd21eac, 
	0xf91e7a47, 0x25feb629, 0x7faa65db, 0x863fbf21, 0xbe04ca9f, 0x77fc3c3b, 
	0x32acaf10, 0xcb11077f, 0x8bff7857, 0x745fcbb4, 0x8077cbfd, 0x03357d0f, 
	0x8700bfd5, 0x12ff590c, 0xf40e479b, 0xfd50bf02, 0x2ff54e8b, 0x97fabe81, 
	0xecb7ea02, 0xfaf1762d, 0xd4830b97, 0xd7321cbf, 0xdf29b8bf, 0xde5fea27, 
	0x5febc55a, 0x873adfc0, 0xd445b9e7, 0xee3f0089, 0x3223dfa1, 0x530ed7ec, 
	0xa9a54bfd, 0x378365fe, 0x4e3a4f96, 0xae1abd91, 0x55a3e2fe, 0xb717f5b1, 
	0xf574faaf, 0xe31e3817, 0x0ed0a551, 0x58317f55, 0xb544793e, 0xf3989709, 
	0xe3ef8cc9, 0xb3875161, 0x9c3a8985, 0x658ea235, 0xa38751bb, 0xc3ce1d53, 
	0x1738757d, 0x0da70ea8, 0x7cf1bcce, 0xcb670ea4, 0x5c3875a0, 0x1d765c2f, 
	0x0eb9a54e, 0xb4ffe407, 0xff5207d0, 0xd5f50973, 0x5176cce1, 0xfd698e1d, 
	0x4e1d462d, 0xa70ea9a5, 0xc75eb629, 0xd5c3be7c, 0xe7121cad, 0xf95bae63, 
	0xd1b1d52f, 0x000000bf, 0x000390d1, 0x7ded9c78, 0xd554740d, 0x33b9ffb5, 
	0x64932677, 0xc90481c0, 0x12061260, 0x11b40630, 0x70080628, 0x69e1aaf9, 
	0x1567d89f, 0x4906be2d, 0x11ac5608, 0x84849092, 0x240249dc, 0x4280267c, 
	0xd141d02a, 0xb10f88f2, 0xf7d44fb5, 0x56025efe, 0xb3f5ada8, 0x0df69f42, 
	0xd33e2a11, 0x8b6968d7, 0xff7feb56, 0x333739f6, 0xb5802499, 0xfeb5d5ff, 
	0xeb96b1eb, 0x7b9ee67a, 0x6fc7f73e, 0x4ecfb3ef, 0x6036a771, 0x122112da, 
	0xb9b8844a, 0x74e10854, 0xc63fd60c, 0x5eb06eb3, 0xaa714429, 0xf843f510, 
	0xe99424f7, 0x47bc24f7, 0xfc2579fd, 0x9faab27b, 0x3d13f78c, 0x14eb88c2, 
	0x7ad93722, 0xfa79fb73, 0x9b19185d, 0x63a2169e, 0xc4fbb6dc, 0xe278a81f, 
	0xbea82ebc, 0xc27997fb, 0x3322178c, 0x067b4665, 0x856f4cfd, 0xad96f6a0, 
	0xeb84bcba, 0x40bf4cf9, 0x9842c97f, 0xc268424d, 0xa6edbff0, 0x7f2d78f1, 
	0x0e108b7d, 0xfd9a3861, 0xa4b5def4, 0x09cf47dd, 0xfe87adf4, 0x9857aea3, 
	0xf9efd2b7, 0x9521f4b9, 0xff30961d, 0x7dc4884b, 0x786f2f27, 0x945d0850, 
	0x3453cc38, 0x37e9972a, 0xd9310b8f, 0x1fa36569, 0x9a627d2f, 0xab5f6f68, 
	0xdb442858, 0xf0dfcb79, 0x33433d22, 0x21611c32, 0x65b38b16, 0xcf6a08da, 
	0xbf989474, 0x84e8e214, 0xd547c229, 0x761df78b, 0xde3ef4e8, 0xc5afa297, 
	0x257925fb, 0xf98bde82, 0x777c98b9, 0x5ca6eb7d, 0xc6a22151, 0xc78afc63, 
	0x84d56cb3, 0x92b5f31e, 0x3d8baf04, 0xf9718edf, 0xfeb289f7, 0xeb1f2dd7, 
	0xa67685d6, 0x18c768f6, 0xc79db3da, 0x225699ae, 0x73e217ee, 0x96a6b7fa, 
	0x7dcba5e6, 0x96ecb4dd, 0x1eb47c0f, 0xb696738d, 0x710ae6f9, 0x1734bbee, 
	0x58a72f6a, 0x167607ee, 0x3bf71afd, 0x3ffa3db9, 0x1bcfd627, 0x0513e958, 
	0x65d0cfe8, 0xca00b9f9, 0x5f2b0203, 0x9e500bd7, 0xf0e44332, 0x0fde1af7, 
	0xa3594c0a, 0x9cb0bea1, 0x2eefad26, 0xd79bf2c3, 0x9434fbf3, 0xb507bbe9, 
	0x87577f30, 0x4ca10676, 0x2981ebdf, 0xcbe541c2, 0x4fee6852, 0x530b7ad2, 
	0xd070ba67, 0xc8f49cfc, 0x349bf6b0, 0x9fc0d2d6, 0xc7884473, 0x5af6f697, 
	0x63dcf7b4, 0x5b95bdb2, 0x28418e30, 0x477b7017, 0xcf6e41c4, 0xf0795372, 
	0xe27321fc, 0x34efe49e, 0xbf38c38c, 0xf2e7335d, 0x034b3538, 0xc754fcbd, 
	0xcdc18eef, 0xc5e882f5, 0x08e3b491, 0x8071a3e8, 0x43382bb8, 0xc4f3c788, 
	0x9e29e098, 0x94e83a47, 0x8aef485a, 0xf3f0e7e3, 0x5b86b4fc, 0x8e072e1e, 
	0x600ad3f1, 0xdb2d363d, 0x35ed0bb6, 0x98ef99d5, 0x9fefce34, 0xf417486f, 
	0x4ef7eefd, 0xbbe8fba6, 0x5552f773, 0xb3bcc7e2, 0xa84369a5, 0xb5b973bc, 
	0xa6896ccb, 0x6e68e17f, 0xb566bd05, 0x0759e8fb, 0xa28aeffa, 0x9fd1437f, 
	0x2f596f4d, 0x3970de5f, 0x966a84e8, 0xe0dbd145, 0x31d5fc9e, 0x17bdc4ee, 
	0xf713d3e2, 0xb9d8ba4a, 0x4475585c, 0xffe9db3f, 0x39765093, 0x2c1faf6e, 
	0x77d0f5db, 0xe15be296, 0x0b8dfc31, 0x46fede79, 0x136fd75a, 0x5e98f97d, 
	0x87c44b9b, 0x350e1442, 0xe9da9b33, 0xd595a579, 0xcced13b2, 0xe589bf9c, 
	0xc36ef986, 0xd7f62121, 0x32f5c03c, 0x969fa6ef, 0x23ab3da1, 0xf4f7c7e8, 
	0x489cb44b, 0xae0f39e9, 0xbde4fd4f, 0x46b671f7, 0xe5779deb, 0xfb417efb, 
	0x84767c55, 0xfd403c70, 0xe3fe5b54, 0x65fbf41d, 0x0db417e2, 0x8de24ee2, 
	0xdf582519, 0x4cf36640, 0x8dd4efcc, 0x76fb242d, 0xe7799f8e, 0xcf1e0a96, 
	0x8f1a2698, 0xccd205a9, 0xe78e8a53, 0x99437a4a, 0x377f93e9, 0xbcda5e99, 
	0x11a09de2, 0x37a64fa1, 0x14c1e7d0, 0x466bc627, 0x1eca13f1, 0xe2659353, 
	0x258f9e27, 0xa9679dcb, 0xaf345bee, 0x6867167c, 0xba63fb9f, 0x0b48e395, 
	0x3f4b7a4b, 0xfd2de92b, 0x47ffa253, 0x3e1d4e86, 0xbe7bca81, 0xbdc31ff2, 
	0xb83f7744, 0x69e026ae, 0x9c6f6214, 0xd0419808, 0xdae925b5, 0xf3445c47, 
	0x30bd3bc8, 0xea3a234d, 0xf309f14c, 0x6e65ea36, 0xad55cd23, 0xe761d123, 
	0xbbfc292b, 0xd237bf41, 0x12178ff7, 0xee1d13dd, 0x03f34adc, 0xad18663d, 
	0x7eb47be6, 0x838f0eb9, 0x30d8a508, 0xf39406f5, 0x68d2ed16, 0x7f46da5f, 
	0xe3459ad2, 0x0871ce2a, 0xe62119c7, 0x0ba7b564, 0xf060df9a, 0x7e11c7f3, 
	0xd7b8dafe, 0xb8d0a576, 0xcd256706, 0x2267a389, 0xe40e4bed, 0xebc3c7ba, 
	0x9ca5f220, 0x3da71d8e, 0x1f1819be, 0xd8233eca, 0x66b94bf0, 0x7b96cff8, 
	0x3d42549d, 0xf33de4a1, 0x7163ad31, 0xfb1036a7, 0x11744c53, 0xa6be2b0c, 
	0x7b8db679, 0xf7a0bf6d, 0x0866a753, 0xab9e8077, 0xfeb89b8d, 0x97225a53, 
	0xebdb8c6b, 0x197c92ef, 0x18e96964, 0x2d387d04, 0x4985fcd1, 0x6e6265f2, 
	0x6a389cc6, 0x27f073f7, 0x3759d7e8, 0x53b27a08, 0xe56ef8d0, 0x41b30b69, 
	0xb590e388, 0xfef3111f, 0xa077a1f0, 0xdbefec58, 0xd4dab8d4, 0xbf54dab8, 
	0xe86d3f76, 0x3e3220b7, 0x9c7b7dbb, 0x6b53ff76, 0x9907dcc4, 0x1a2b8d8e, 
	0x4fda8dfe, 0xfda33730, 0x2b560969, 0x3c7627d6, 0x8fc2c9b9, 0x91060579, 
	0xa65d049e, 0xa02dd958, 0xdd959f37, 0x47fc1734, 0xf926533b, 0x3c58f41b, 
	0xe83f75f9, 0xa3c16da8, 0xcfe23527, 0x3e7225ae, 0xb9bc776d, 0x6f41f84b, 
	0xb5de9507, 0xde9be01c, 0x1d6cf77a, 0xef5639d6, 0xeeef4226, 0x0bbbd289, 
	0xa1e58972, 0xa0386777, 0xf5621267, 0x6df7adae, 0x8c5b7bbd, 0x1ca4b5de, 
	0x93cb643c, 0x937e59ac, 0xfba8c9e5, 0xa1c5c87b, 0x1ec9e53d, 0x3c16ffac, 
	0x3b6f5743, 0x88bfc42c, 0x7ea668b0, 0xd5d089f6, 0xf10b665b, 0xb5f86e68, 
	0x1e2f242d, 0xa1689611, 0x872717f1, 0x3ad2b7ea, 0xae57cbfe, 0xef47c6bc, 
	0xbde57df7, 0x513bc18e, 0xb6f5702f, 0xfe17a8b9, 0x872a3ae9, 0x2794f466, 
	0x0cd71ea5, 0xefa23877, 0x95848e58, 0x787da19c, 0x21b2b0c4, 0xb4ae484f, 
	0x6ddfc49a, 0xe450fa31, 0x4fcc1c7b, 0x5fbf9296, 0x7c78de54, 0x4dc667cc, 
	0x288e57c4, 0x249b993d, 0xa661a4f5, 0x4672cdbd, 0xcb5e9fa4, 0xbf53eee3, 
	0x3ab59a3d, 0x77b0f41d, 0x39e967fa, 0xa1b1ef54, 0xe973c335, 0x68f7c8e9, 
	0xeb06be72, 0x52b7d659, 0x63c0683f, 0xa874d301, 0xc26503b2, 0xb7d07527, 
	0xda33ed4d, 0xafc22b4d, 0x78c74ff4, 0x7b73f563, 0x8e579489, 0x32674133, 
	0xd16a60e4, 0x77f78d2e, 0x806fef21, 0xcfb557f6, 0xb7e98ff8, 0xee8bef15, 
	0x6627d68f, 0xb4fc4f72, 0x3dddd56c, 0x7d8e0fdf, 0x6fb72f7f, 0x6afd350e, 
	0xbfda633f, 0xfa37bf9f, 0xdfc65f7d, 0x6fed0c17, 0xe83d957c, 0x77c18cd3, 
	0xef82e1fd, 0x8b831fdd, 0x8ec17163, 0x3e87e63a, 0x2fbfb170, 0xde7c5c5c, 
	0x167f06ca, 0x803b0e87, 0xc5c3facb, 0xcc82fb6d, 0x78b8dd9f, 0x40896e7e, 
	0xf862f3ff, 0xef171633, 0x2e050ef0, 0x5af0a89e, 0x68288a6e, 0xd1442098, 
	0xd94dce55, 0x214bdf44, 0x5e11ce57, 0x09b8ccc8, 0xd0373d7a, 0xf7f030f6, 
	0x97bafae4, 0xcbf01f4d, 0x842ffbee, 0x76dafe5f, 0xe0e2ffc5, 0xae0e0bbf, 
	0x8b12fb53, 0x18fd6d83, 0x21b3b7a5, 0xf4638b27, 0x3645f123, 0x473bc7eb, 
	0xe71fadf5, 0xe3f5b28f, 0x1facedce, 0xe3cdf2c5, 0xf5ef6fc1, 0x9c58f7e0, 
	0xcfdfe36c, 0xba92bf88, 0xa6ff1d2e, 0xbfc6c77e, 0x1ec3f75d, 0x5e2a1c2b, 
	0xf8c99c6e, 0xe056ecf7, 0x7efb574d, 0xcc937f85, 0xff7f8067, 0x39d6f5c0, 
	0xb8475984, 0xe4b8cd69, 0x1bb70467, 0xb477fdb8, 0x8aef4d8e, 0x54455238, 
	0x4d8dad16, 0x1a539c11, 0x9c45b458, 0x2088f9e5, 0x38b257f7, 0xe2c47e5a, 
	0xb8cb7a65, 0xf2f152fe, 0x78d9960f, 0xcdebe0b9, 0x53978ced, 0x8fbf01b6, 
	0xe1427f6f, 0x93f595e5, 0xcbc7fffe, 0xbfd0bef6, 0xb4dfb956, 0x3e150b0f, 
	0xa71bdc3e, 0x45ce88f2, 0x29f78df6, 0x7f5f1bd4, 0x7d367c79, 0x3f6fd319, 
	0xfb0f2cf8, 0x6efc0a5d, 0xad3f01ec, 0x71837ece, 0x66e2a5da, 0xda83fefc, 
	0xc58ae3de, 0xc8df2ce9, 0xafceb00e, 0xb13eb0d5, 0x1cafd1eb, 0x445788f3, 
	0x6048d126, 0x68e41d7c, 0x68e447bd, 0x7ce37a13, 0xd5ca4787, 0xda1afec8, 
	0xe1b818db, 0xb37f07ae, 0xde3a225c, 0x600f5675, 0xc6c9b97e, 0x8f08db9d, 
	0x87c37825, 0xeaf44c7e, 0xf4f031b9, 0x49af4938, 0x4fef89eb, 0xd7b22b8e, 
	0x21700c6d, 0x6ef823fc, 0x6592cd7f, 0xfc0f7962, 0xa4d827b1, 0x591fd1f8, 
	0x67abfc0f, 0xcb7dd63f, 0x7e8fc87a, 0xd6f864f1, 0xf1a2336d, 0x2dd6f864, 
	0x2e4f1947, 0x5f67607e, 0x36f8b278, 0x87cb2785, 0xb82c9e30, 0xc671db75, 
	0xf1bcff93, 0xdfe4f17f, 0x2d664f1c, 0xc9e0fd13, 0xc61765b6, 0xbb2c4f93, 
	0xd1fc9e30, 0xae781eb2, 0x9a7c9e17, 0x4f1fefbf, 0xc2ecb73e, 0x65f9f278, 
	0x4793c617, 0x686f8e7a, 0xf62fff6c, 0x8a489f18, 0x8f52ff7d, 0xcf4a46f7, 
	0x5f21a7f7, 0xdb8376b0, 0x3a9db047, 0xbfb8f75f, 0xea27f4c3, 0x688c9f49, 
	0xc0f7e93c, 0x76ff959f, 0xe91067b6, 0x2befaa7d, 0x77ac4f91, 0x385d21db, 
	0x48babf48, 0x14bddc9c, 0xfee49dfd, 0xdbd67e8c, 0x65abf95c, 0x23fb097a, 
	0xea5d7f5e, 0xe3991ff1, 0x99a48e59, 0x7817188b, 0xc90271a3, 0x2f739f13, 
	0x3d313fbd, 0x97fdf40d, 0x2093a7cf, 0x80a27857, 0x971e8171, 0xfd10e923, 
	0x02da0695, 0xc3d7d790, 0x222e7a2f, 0x611c699f, 0x73e281c8, 0xcd10bfad, 
	0x7deafe91, 0xabffb77d, 0xd8bf3962, 0xa21db976, 0x9a43acab, 0xf8f11470, 
	0xa38c82db, 0xa7d320ac, 0x10b5b447, 0x16175f7d, 0xefa13fec, 0x637d4987, 
	0x07ee5905, 0xf482639c, 0xe2f5e27e, 0x7e077d70, 0xbf8bbb8f, 0x1f1dc3d7, 
	0xc0fd43ad, 0x9f98d7a9, 0x6e5d61cc, 0xf38afefe, 0xb0aeb4fc, 0xd48cef98, 
	0x2387c463, 0x73be6c69, 0xe82a7bfc, 0x61b4202a, 0xdbe1bbe0, 0x5ccb0d4f, 
	0x5d16c423, 0x5877a0d7, 0xef7ed2af, 0x35e481bc, 0x30b85f8f, 0xe78eb69e, 
	0x34ef9883, 0x76e3a8d4, 0xd31db25d, 0xeba4f0a5, 0x197fa915, 0xdef8469f, 
	0xe594ef4c, 0x7964e7e1, 0x1cb2a7f8, 0xd728da38, 0x0ccb8e4c, 0x9bca8cfc, 
	0x536942f2, 0xafcf01d7, 0xfb4b9a5c, 0xb11af134, 0xf5c951d4, 0x47f8a535, 
	0x9f5add62, 0x830bf06b, 0xb9fe7dc6, 0x287de8cc, 0x1d7f08f4, 0xd90dfae1, 
	0x433f0686, 0x892dd111, 0xc7223157, 0x53abebc9, 0x376f283b, 0xac787ed4, 
	0xabc7ef31, 0xf7eaab67, 0x5dcdfa10, 0x468a9a4a, 0x772aed29, 0x6c6d1cf5, 
	0xf3e3ed02, 0x90965b47, 0x1ddc7e9c, 0x5d9687fe, 0xadb8e442, 0xeb9266ea, 
	0x82e1e84f, 0x5af384ed, 0xc0c5819d, 0xe7e3ee83, 0xfca2860a, 0x290e82d2, 
	0xc0276697, 0x142fe20f, 0x30a3ef1a, 0xef1f60c7, 0x837988f6, 0x4e48850a, 
	0xd224a111, 0x88063b83, 0x461f6a19, 0x464a1f62, 0x7e0e5d4f, 0x5bd2080e, 
	0x44621fcc, 0x35a3f890, 0x2668e8d1, 0x7d3c0cba, 0x8e77f974, 0x0ff0bbe2, 
	0x589e93b7, 0xcd5516e7, 0x0f573ef4, 0x1a9cbfb7, 0xa799f3d1, 0x03e70847, 
	0xe5c2f291, 0x72603cf2, 0xeb0b54fd, 0xb75f3d07, 0x5b86e09a, 0xbdf1aa0b, 
	0xcffa887c, 0x6b5eb4f8, 0xe47c60e9, 0x2778d1f7, 0x6fed615f, 0x919fbd26, 
	0xb42d6867, 0x4a96cf8f, 0xc26bb4ff, 0xbbc52743, 0xa58e59f4, 0x9f195e61, 
	0xa49a0ace, 0xeb935d07, 0x663e3b27, 0x3b4118ba, 0x574fadd8, 0x3c683f63, 
	0xce254a6b, 0x10cbccce, 0xee0b924e, 0xeed6091b, 0xe3ba7da0, 0x3e25fdcd, 
	0x577e7ef9, 0x336d5c64, 0x44c12e89, 0x2c9a1cd7, 0x9c7108f6, 0x1a5891e6, 
	0xcc6b9799, 0x078c4d8e, 0xdcd03e84, 0xdd01c42a, 0xfb4cddd8, 0x7f87a8d5, 
	0x7d8692d9, 0xe79acab3, 0x0bc29d62, 0xcfad47b6, 0xe16138ba, 0xb9e9a4dc, 
	0xcc3c03c3, 0xdc0fc2ff, 0xa8f544fd, 0x8ba21e93, 0xef8fd403, 0x40afa223, 
	0xdf9448fd, 0x3977ba29, 0xa2e412e4, 0xe582d394, 0x05fa68d6, 0x8c645674, 
	0x6c3d8e15, 0x6c3db39f, 0x0abb8908, 0xb5f5924b, 0x4b3d93ef, 0xf6a12e63, 
	0x48a6b33a, 0x81d916ff, 0xdf0537f8, 0xd01638d3, 0xfed4e5fb, 0x48ce5530, 
	0xfbcefbbb, 0x0a1cb14f, 0xe2169c95, 0x3f7f7a36, 0xcc52bfbd, 0x82bcb218, 
	0x5d5a0399, 0xed74475c, 0xff927293, 0x682c90e5, 0x2980e556, 0xa8e0cce5, 
	0xbc6ea372, 0xa4e24ebf, 0x5d90367b, 0x7f36e0d2, 0x706af580, 0x4cd7bf85, 
	0xce3ebdf4, 0xddf4147a, 0xa1b787a0, 0x0ff5753c, 0x205e07b4, 0xabd57039, 
	0x87e240e6, 0x6b488711, 0x4daeb8d2, 0xfc41bc24, 0xc5df385b, 0x16ba27f3, 
	0xa9bce11a, 0xc367eff5, 0xe54a5dde, 0x6bdc687b, 0x67211d69, 0xe58f854b, 
	0x36bf38a9, 0x97c87df5, 0xe42a5a43, 0x1114d2e5, 0x59157c86, 0xd2e804f3, 
	0x4f8ce967, 0xac075486, 0xefe00b9f, 0xba7a1322, 0xe3b84dd3, 0x33aeb4db, 
	0xe340d14c, 0x08a07bb8, 0xf07b4ec2, 0xd0f1eea0, 0x88f72e78, 0xf042c482, 
	0x70256045, 0x0877ed21, 0x1bab9dfb, 0xed2a7e27, 0xcf75c4b0, 0xa81771a8, 
	0x8c88cc79, 0xa8ddc79f, 0xf7b0b7c6, 0x3ebc79f8, 0xe4da5e35, 0xd807a222, 
	0x7de2f773, 0xa263e297, 0xafd377ff, 0x27e07a0b, 0x12aab6cd, 0x7c46396c, 
	0xda54bcb0, 0x616e0d8b, 0xa5f147d6, 0xd9b3eaeb, 0x2eee3fb0, 0xd21dfe95, 
	0xad827b0f, 0xf2c1b911, 0x837202e4, 0x9e08cce5, 0x46d9db5f, 0x96178fc8, 
	0x64b99e33, 0x9ad011f9, 0x429d60e7, 0xd15f3f95, 0xf2055fbf, 0x3fbbb203, 
	0x7ebfcabf, 0xe82b4867, 0xde07f302, 0x1ca5fcc2, 0x3e1ff390, 0xcee5adfd, 
	0x7bcd443f, 0xfa0d6880, 0x134fef7a, 0xd5fc138d, 0x4f7c4894, 0x2239b5df, 
	0xc47f8cf4, 0x9cb7e7df, 0xb60ff497, 0x45fff1a5, 0x71503f8e, 0xa1e59cbc, 
	0x1edce7c9, 0xe6134c73, 0xb476639f, 0xe6efc71c, 0xa02f2d67, 0x97a7f59e, 
	0x49c6a0ff, 0x3c8faceb, 0xda88e552, 0x011f7b27, 0x83ff6184, 0xb1972191, 
	0x0f20837f, 0xe305b546, 0x4639e217, 0x33dda8d3, 0xe396bad3, 0x979ecb5c, 
	0x88b8975b, 0x0b6171f6, 0x4df3b5ce, 0xb3d957cd, 0x33cfc81d, 0x172fced3, 
	0xbdfea7bf, 0xdcd83066, 0xf07bf7e7, 0x97c7ea3d, 0x7288df40, 0x33ab69f0, 
	0xda26d77c, 0x174fd737, 0xf2412cfc, 0x49c6fd71, 0x9d4cb851, 0x2e88bb07, 
	0xfa0c1e70, 0xe92b5df0, 0x2ca5ed00, 0xdf43fd97, 0x6a3e239c, 0x9f231975, 
	0x339e004d, 0x7ed48d83, 0xd3786a5b, 0xb6fbe27a, 0x23526b4c, 0xb25b6bad, 
	0xc67f0a99, 0x45c7d878, 0xa1e33e8a, 0xfb668f8f, 0x27c7ff68, 0x699a1b58, 
	0x994ffedd, 0x21db671c, 0xca5abf29, 0x4ebb3ca4, 0x54d5bfe1, 0xdbca87be, 
	0x552afbd5, 0x61ff02ce, 0x3ecac2be, 0xefd2f985, 0x79a97777, 0x07bf919c, 
	0x6eca3e25, 0x89d647f1, 0x083231c6, 0x99f5437f, 0xde91da31, 0xd164f474, 
	0xb5c652a8, 0xf06f14b4, 0x3ae58e81, 0x47e94fc1, 0xf463bc60, 0x7d647385, 
	0x9f1239c6, 0xd223bc2a, 0x4d7690de, 0x9743bf2f, 0xf4175dc4, 0xeb4dc58f, 
	0x55cda31a, 0xc656b27e, 0xfe513f5f, 0x9939a721, 0xf0f471c6, 0x85879065, 
	0x8788cd4f, 0xc170af3f, 0x08b6bf28, 0x3c3344e7, 0xeca02bf0, 0xfd76924c, 
	0xb6fb5b86, 0x92df1beb, 0x7d7b023c, 0x52ecd553, 0xbc5c47ef, 0x8bf5a9a7, 
	0x45edd7cb, 0xae829437, 0xafbffe49, 0x81b9ffe4, 0x4f37c0ab, 0x2edf42b7, 
	0x1be6eece, 0xf686f83f, 0x865fcf83, 0xae5a6f4f, 0xd179f145, 0xd15a63d5, 
	0x9392937e, 0xffb9bf79, 0xd4a16d4e, 0x59e4826b, 0x192b92ad, 0xd66d5769, 
	0x283bbea4, 0x7b0eee48, 0x3c878ac5, 0xb98e2a19, 0x495fde4c, 0xc23ea50f, 
	0x268f24e5, 0xcf9274bd, 0x2676ecf3, 0x537bbb1d, 0x2543ed2a, 0xbc9067b5, 
	0x55e5729e, 0x6f5499e9, 0x81e1ce74, 0x3be4ef18, 0xbba09886, 0x116bea62, 
	0xd7e4ddd1, 0x80dc666e, 0x266fb0fa, 0x77d5f4fd, 0xa6672fb0, 0x86e92bdd, 
	0xf14456f8, 0xdf406bbf, 0xe4a71a7c, 0x33fbfd8d, 0xf3fda5cb, 0xf7949974, 
	0xf1df1cb6, 0xc1c5b887, 0xfc72deba, 0x782e9f81, 0xb7bb4854, 0xf044fd03, 
	0xe91bf1a0, 0x18dc257f, 0x464b2785, 0xbdb295d7, 0x4a78bc07, 0x4ab9f9c9, 
	0x792817be, 0x9c97df1f, 0xf257df37, 0xdf2fb7ef, 0x5af6e343, 0xb0673c9a, 
	0xe19cf2fc, 0x339c49ec, 0x262cbd7c, 0xe25720fe, 0x7ebf6e94, 0xebf630e3, 
	0x18cfcb77, 0x3f2ddf39, 0x313cfd69, 0xd3f20f72, 0x963ef575, 0x58f7ac9f, 
	0xfd28ee7e, 0xa867e4eb, 0xbfb3f214, 0x44bd417d, 0xdaacf7aa, 0x46af5b5f, 
	0xe8a5bee4, 0x10540097, 0xb06636e3, 0xb91fb7df, 0xe3928faf, 0xe3d947d6, 
	0x3a34a27e, 0xc7d2e70e, 0xbb8f34fd, 0xb7dc97ad, 0x794ab6b2, 0xb3fd50f0, 
	0x6d4eaf34, 0x3d097b80, 0x45fe4933, 0xbbb656e1, 0x9d4f0e49, 0xfc08ea3f, 
	0xfda0dfe0, 0x3f094422, 0xff7586a2, 0xe38ca949, 0x17e7f698, 0xd117c3f7, 
	0x01a05d96, 0x6068b8b7, 0x462f73f0, 0x57252efd, 0x834e17c1, 0x1f3edce9, 
	0x7b279d72, 0xdf3e3de9, 0x5cfe83f5, 0xe71fa0a1, 0x9bb3e215, 0xea3e40f6, 
	0xd06b0efb, 0xa838bafb, 0x72dd5e61, 0x15b675da, 0x44240071, 0x708fc127, 
	0x8449f954, 0xb7db9339, 0x4b79656a, 0x8ed5c499, 0x41871da4, 0x6f59c5cf, 
	0x741e4194, 0x4de53b9f, 0xcee173e1, 0x7393851c, 0xaeafe263, 0x1267398b, 
	0xb9c50fd7, 0x270bd917, 0x77eb941e, 0x9467a6c3, 0x7124589c, 0x3f2f63a1, 
	0x2569e72d, 0x32ef882f, 0x8c5e5203, 0xade13926, 0x81fdf3c3, 0x672cf599, 
	0x4f88b35e, 0xf0f88f26, 0x30578b4f, 0xbf648c3d, 0x876bf436, 0x45ce03b2, 
	0xea89e1f6, 0xb19f1947, 0xc11cd11d, 0xe6bc0783, 0x0f4fa1f7, 0x7aff084c, 
	0xa19e1a5d, 0x7841dd7f, 0x586a40f3, 0x0efcd234, 0x6b2e0664, 0x240e7ea4, 
	0x5f5dac17, 0xc25bcf4c, 0x6ff5caff, 0x4fd89f09, 0x02c0f7fa, 0x0af5adf1, 
	0xc49fafa7, 0x56e7c04b, 0xf275fc16, 0x5b9e465c, 0x3cf51495, 0x54792ab7, 
	0x14955b9e, 0x92ab73c9, 0x4adcea51, 0x2a0d539e, 0x56e7c519, 0xf54ffdb6, 
	0x5c02d41e, 0xa1539e4f, 0xf64df5cc, 0x7dfed99f, 0x702b9fdb, 0xef84d5be, 
	0x51e7951e, 0x3cf24525, 0xe502e50a, 0xf889cc17, 0xf12d4b71, 0x0133e827, 
	0xe529dcbf, 0xe579277f, 0xdb9d3388, 0x0be07fa4, 0x41460ff9, 0x0ff9453e, 
	0x5b1a0b80, 0xc6c3f8a3, 0xfc11a941, 0xea47c660, 0xd9adfac5, 0xce718fff, 
	0xa81479a7, 0xeded2bfd, 0x6f7bce9f, 0x53a03bd2, 0x65fd0fdb, 0xac77ebfd, 
	0xc3d65c9a, 0xfca196ef, 0xb587f0b2, 0xf8beef42, 0xd039b6d2, 0x5d161fbb, 
	0xd14bbbf6, 0xb4cbb3bb, 0xfbbd68b2, 0x14ff9f01, 0xb01b6701, 0x758e8cef, 
	0xc7b46eca, 0x78517a85, 0x637f5baa, 0x460b6d5c, 0xdfb6deb1, 0x63bbfadb, 
	0x1765cddc, 0xe9b4638a, 0x965be39f, 0x6d84fc44, 0x43ecac1b, 0x2349e03e, 
	0x29a219f7, 0x5e78d68b, 0x0cc5c717, 0xefc59f70, 0x638a9eaa, 0x77d6545d, 
	0x3f5b6b1c, 0x7fa8ac71, 0xf35638e1, 0x7ceaedda, 0x57c90d60, 0x6477eedd, 
	0xf1f21b38, 0xbe05f445, 0x522c9c86, 0xcee151f2, 0x4e3f6957, 0x065bdcd6, 
	0xe6bfb53d, 0xfb9065bb, 0xe3ee8b7b, 0x8455b2e7, 0x35e3a358, 0x347dedb3, 
	0x21af6ffc, 0xe6eb3cbd, 0xae89fc20, 0x01d9be3b, 0x63bae779, 0xa6fb1048, 
	0x9c2b4f03, 0x1fbb089c, 0xfb247ffd, 0x5c629e83, 0xeeb8e34c, 0xbf5c6dd9, 
	0x082fbc75, 0xf8eb52bf, 0x57d01d79, 0xc141ccfa, 0xd7c00525, 0xfe414787, 
	0x3de7b3b8, 0xa9d5fa0c, 0xa8c1259f, 0x851a737d, 0x3c5ca5eb, 0xe059feb2, 
	0xfe54e105, 0x8ba3f60b, 0xefd88f94, 0xaff8f0ff, 0x1f5b71c8, 0xf1bebef1, 
	0x1e7b44c1, 0xf47e3e0e, 0x47d07a89, 0xb916d8de, 0xc3aeeeff, 0x61b8afa0, 
	0x9f86e3c2, 0x4b40ae3d, 0x5b4eb137, 0x437e9d78, 0x710bb92d, 0x9ac4242e, 
	0x5c880aaf, 0x823803d6, 0x3ef963af, 0xd811c65d, 0xde4622f8, 0x5a58557f, 
	0x43521843, 0x4ee9a1ea, 0x28bef161, 0xd13d333d, 0xf53345fa, 0xfac13d3b, 
	0x6cd9ce05, 0xc31bf23d, 0xfaecfee4, 0x71f3a886, 0x068681fd, 0xaf74eaff, 
	0xbd6935a1, 0x952b89f5, 0x37f504e4, 0x83eed3c3, 0xbf9f549f, 0xa27f0fda, 
	0xcd67788b, 0x1bc7bda3, 0x7362bf07, 0xdf95b8d4, 0x572b33b0, 0xe3627396, 
	0xb8cebf96, 0x9d4f5629, 0x5c9cf699, 0x44bc1c4f, 0xb8de85e1, 0xe83e27a6, 
	0xde3b8fb5, 0xe1fc7de0, 0xef52496b, 0xfbc6bee6, 0x97aaf098, 0x996371f7, 
	0xfdd8efa4, 0x1a68611c, 0xe7f6cae8, 0x9cfe31e8, 0xa969676b, 0x2a1cfedd, 
	0xd811fedb, 0xd82bf0d7, 0xd07490fe, 0x37c532ef, 0xeb0fd97e, 0x07b36dcd, 
	0xe0fc5fb2, 0x033c79ef, 0xe3c69a6f, 0x80e2f923, 0x7718eb3c, 0xb628f982, 
	0x78f65bfe, 0x77f1cf1b, 0x879cae7a, 0x2fe91dfd, 0x614ce33f, 0x17e761fa, 
	0x5cbfdc92, 0xc0fd51fa, 0xa4ca675f, 0xd950a53f, 0x7f5e34c3, 0xc3fc2b4b, 
	0xf0b7f142, 0xec1ce7db, 0xc457786f, 0x3f88acf9, 0x7d76fd8f, 0xcfd8f3f8, 
	0x9f10bef7, 0x97f3fb50, 0xfde7f6f5, 0xe023b8f5, 0x5063b890, 0xf88cd8b0, 
	0xe4bd2705, 0x88592d6f, 0x4a9bede7, 0xbbf6cb8e, 0xe7fb65de, 0x8f5a129d, 
	0x2fe972f8, 0xd08fb6ed, 0xf6dedecf, 0xf019ea0f, 0x624c8eff, 0xe543c83b, 
	0x3b115d45, 0xfa7fb6c8, 0x515e3ff3, 0x5c7fedde, 0xf47feb13, 0x1b1ff8c4, 
	0xee381955, 0x893b823a, 0x72835fca, 0x13f43b83, 0xd86c6fe5, 0xa37f0696, 
	0x017e6ee9, 0x6fa146fe, 0x87db7bd0, 0x3a4b9597, 0xb87d98b8, 0xec789758, 
	0x4fda44da, 0x5779fc0f, 0x23b741f9, 0x1e35110e, 0x66c7fe96, 0x43c2b75a, 
	0xd0642a5a, 0x8f12e535, 0xf672ce2f, 0xff58f7a0, 0x1ff410df, 0xe9b66fe5, 
	0xed0efedd, 0xe25c6131, 0xb47f6477, 0xa10b9d62, 0x14dda5c7, 0x96a7c7a3, 
	0x3f9fb4f7, 0xe3d4f7f0, 0x067650c2, 0x79c56ddb, 0xe883ad19, 0xd25cb739, 
	0x2dfa3e7b, 0x683f78b9, 0x7d947b7f, 0xb53a7c3e, 0x43f621f0, 0xceff6858, 
	0xbe97a972, 0xadb9ce3c, 0x8c7e87bc, 0xf1e239c1, 0x1411ed70, 0x8f13fc63, 
	0x36302aaf, 0x12fdbd9a, 0xbaceca0d, 0x7b6f8d4d, 0xee3c6dd1, 0xabbaaf3b, 
	0x0115761c, 0xb3af3dcc, 0xbfa445df, 0x715cb1a2, 0xe467e09d, 0xf484eabc, 
	0x969c70d3, 0xd2e91870, 0xdc6173bf, 0x3e4c2689, 0x56e753ef, 0x30fdd89a, 
	0xff05cf8d, 0x0f41ce16, 0x64056835, 0xd2e59b4f, 0x963ee57f, 0x32847cca, 
	0xebad5cfc, 0xb5ea16fd, 0x2378ca26, 0x3ef11d7b, 0x733e4ba5, 0x83747f10, 
	0xea9fc1a9, 0xfacf3f0e, 0x8ae73ec0, 0xf4e38f6e, 0x1e76a0af, 0xa87ae390, 
	0xdb3e322b, 0x1bfb609f, 0xfb408fd8, 0xe4e03dbb, 0x9a1c47ef, 0x8fdce3cd, 
	0xae3b5271, 0xdff73b63, 0x4dcfc513, 0x1e6f190f, 0x6844259c, 0x45b01860, 
	0x629ad684, 0x0e5c8be3, 0xd9441d3e, 0x5cc37378, 0x5be13bd8, 0x9bfc4c7e, 
	0x82d2cd3f, 0x304fe183, 0xbb91c434, 0xcede52bc, 0x27b4354d, 0x7ea79fe1, 
	0xf22f38fc, 0x9ce1af5a, 0xe5b9da8a, 0x426fb201, 0xfc1a1b0f, 0x2c374df0, 
	0xc73f4070, 0x67d8d1e2, 0x3fb9967c, 0x3b9c6a29, 0xe87ed345, 0x6cb741c3, 
	0x77308275, 0x3971d735, 0xfc2de6fe, 0x6d59fbfe, 0x8ed6fe5c, 0x238e5c9d, 
	0x2512dede, 0x38e776a7, 0x957d871e, 0x9ff5a0bf, 0x94894f56, 0xf6b417e3, 
	0x08858f8d, 0xebd99702, 0xfedefb1c, 0xb079343d, 0x837dcea9, 0x443bb641, 
	0xff5a49f0, 0x09edd9b8, 0x1bee4790, 0x73d32eeb, 0x7805ffa4, 0xfb4c9dc3, 
	0x13ca8c7d, 0xf2469ac2, 0x31f112a9, 0xb3ddbf24, 0x4fa8891d, 0xcbc402e5, 
	0x1c91e530, 0x6a6b1f8c, 0xfae6f738, 0xbcee4fb4, 0x496b5f82, 0xe83776fc, 
	0x8c7212b9, 0x3dcba6e4, 0xddc44eea, 0xfd9ae3d9, 0x88036795, 0x4333d287, 
	0xcf7e0cff, 0x43c7da35, 0xa29eb2cf, 0x09e287f6, 0x91e645b9, 0x6eee29e3, 
	0xf7a3da10, 0xe88bfa02, 0x9d09d068, 0xe9d066f9, 0x706fee06, 0xd2453f27, 
	0xfa4e5939, 0x8f939654, 0xf272e6ae, 0x8629f8cf, 0x43cb21bc, 0xcbe596de, 
	0xe5f2cb4f, 0xf43cb29d, 0xfd0f2c9c, 0x8e539654, 0xca72e1ae, 0x9099e8cf, 
	0x38c00d63, 0x72087213, 0x7b0cbed1, 0x58fc50eb, 0x923d6467, 0xe7c5c27d, 
	0x1af8864a, 0x9e9937af, 0xd0ccd712, 0xd09539e4, 0x015c6b80, 0x589a78c1, 
	0x73e4e7ca, 0xe8b4abaa, 0x7e5b2a73, 0xfd614443, 0x9ff9a93e, 0xdd32e072, 
	0x3ec7f850, 0xd6e79aa7, 0xc8ec3ecc, 0x42def6bf, 0xbaf3727f, 0x0f8ed380, 
	0x424bfc60, 0x9223ed20, 0xc0f4a77f, 0x646bbfc3, 0x00e2a4b1, 0x1a5f9cbe, 
	0x51cd1771, 0x9fec08f1, 0xd22c75a6, 0x073807c5, 0x1f0ee75c, 0x9f17707c, 
	0xdb69be97, 0xe39eeb11, 0x3137197e, 0xcfde3a7e, 0x8542e7b9, 0x8dedae97, 
	0x37012e93, 0x88ac4b1c, 0x33810dc6, 0x7d2c370a, 0x0329cf90, 0x06e30b7a, 
	0x539d6eab, 0xd470fde9, 0x73f41eb9, 0x7d01c291, 0xc2a5eb9c, 0xe94e73b7, 
	0xd117df6f, 0x88aed7cf, 0x492fb3b1, 0x215d4f3f, 0xfa1e46f1, 0xf46bfaed, 
	0x7f70b533, 0xbcdf3f44, 0xbf37fa42, 0x61be7ebc, 0xf3f505c5, 0xb0373c17, 
	0x2b0df3f5, 0xff4cfd6c, 0x66fc21f7, 0x6ce85703, 0x35bf481f, 0x962065fc, 
	0x128f5881, 0xe40ea79c, 0xfb99767a, 0x47a77aa7, 0x7b0c3d0e, 0xee7dd02c, 
	0x5f59fa6e, 0xc0af645b, 0xc6b3e52f, 0xbef1bce0, 0xc02b45aa, 0x67b971af, 
	0xf86b69fd, 0xedd785bc, 0x9e8faecb, 0xec0cf291, 0x922cfca3, 0x45072c21, 
	0x44e2e43a, 0x1390a1c2, 0xdbb637e0, 0x9375ed32, 0x24f9dff1, 0x7df29d4f, 
	0xbb38de37, 0x297c42f6, 0x9fcd99e5, 0x101b17c0, 0x963b0c17, 0xdd95d2f8, 
	0xbf9d841c, 0xffd48576, 0x8c845781, 0x3df6caab, 0x19ed6be3, 0xe895b8b7, 
	0x73addf22, 0xcbde04fc, 0x68e16338, 0xfc2ba28a, 0x43637c43, 0xe00ad379, 
	0x755a7ca6, 0x7d64696d, 0x5473eef4, 0x2df1fa4b, 0x6fd477e9, 0x93067874, 
	0x15fdf901, 0x46866f12, 0xaaa74c07, 0x363a0297, 0x21ef5c1d, 0x8d2d7f7a, 
	0xdb158ee3, 0x43c0e856, 0x8ebc7ce3, 0x1cd78973, 0xc7212eb4, 0x271cdd90, 
	0x1bb1b0f3, 0xc72170e7, 0xfc762d9b, 0xf1a89ae5, 0xa3bd1485, 0x13e67cfd, 
	0x3dc7ed9d, 0xf2dc642b, 0x6597a01d, 0xf03f7daa, 0xca9b8c89, 0x68e7ab17, 
	0xb4b5d001, 0x69ce49fb, 0xfd23c74d, 0xc26ffbd2, 0xb795695f, 0x38f3fd31, 
	0xcdcc7e48, 0x8047080a, 0x6f3967bb, 0xffdedb8f, 0x7b50f8d8, 0x834e887f, 
	0xaccf9b90, 0xf62df190, 0x87eec4fe, 0xfb62f23e, 0x1fbceff1, 0x3668f309, 
	0x9cbed50b, 0x4c5f7fee, 0x666fc64b, 0xd7f3c854, 0x8532f5d8, 0xbeb75be4, 
	0x7cd063da, 0x8c2b845d, 0x3e7eb283, 0xbd78d7d7, 0x9a4363dc, 0x3eb51f56, 
	0xf0398139, 0x9c1da2ef, 0x43869863, 0xa42a25fa, 0x2f5edeff, 0xc490c75e, 
	0x2e81c07b, 0x2d93f86f, 0x320fb033, 0xd034360e, 0x47af5b14, 0xa1e380b9, 
	0x1f9b9743, 0x15f6bf2b, 0xe3939f9b, 0xf62f7e50, 0x7de3d90f, 0x15edfcaa, 
	0x314f7e3a, 0x13fb261c, 0x77e09dc4, 0xbc90df1b, 0xecf28dda, 0xfc005d40, 
	0x21da357f, 0xa6e7339c, 0x04c3034f, 0xa0e383cf, 0x95df6bfb, 0xddd6f2e0, 
	0xf6cfe34d, 0xaee5c099, 0xbf34a1b1, 0xbf9e7f6c, 0xea7bdf90, 0xd33c47de, 
	0x6d97b630, 0xc94d36fa, 0x3f075807, 0xd3dcdfad, 0xa26cbfa1, 0x3b89eef9, 
	0x4f666acd, 0x3ed8875c, 0xc5ae9e87, 0xdb970b62, 0x79720f5d, 0xa3b373b4, 
	0x7824f1ff, 0x738178e7, 0xbdabbce2, 0x7827a7f0, 0x37d6074d, 0x7c62d92e, 
	0x88dc0f18, 0xf6aef3fd, 0x425cfbf0, 0x1317841d, 0x4d6203f3, 0x5458f100, 
	0x9ee81c26, 0xc18e6a6f, 0xc861f451, 0x0e9742f1, 0x57717e62, 0xd7498e20, 
	0x6d4a4d47, 0xef23ec88, 0x7a6f537b, 0x390bc84c, 0x1cf4adb4, 0x6701a05b, 
	0x702c6eba, 0xf8b13468, 0x0fcf8364, 0x0287e6e6, 0x3af9807a, 0x73fa4c90, 
	0x9e27ea88, 0x67f801ec, 0xc04406e6, 0xd739eb4b, 0x6381ef43, 0xecdf723d, 
	0x827de47d, 0x348fffbd, 0x3df630bf, 0x2be702b5, 0xfe255e36, 0x8aad9875, 
	0xcb3e246f, 0x3f303f01, 0xde3ded2e, 0xe5b575d8, 0x47ef7f03, 0xb05657fb, 
	0xba44ba1e, 0x9fa7a58a, 0x01535f94, 0x17b76679, 0xf9a20f2b, 0x88ae83fe, 
	0x8f9ba53f, 0x1572b8d4, 0xf0a1debf, 0x9c6a13c0, 0xebab38f9, 0xd491f9c4, 
	0x2e2ab3a3, 0xf96c4f2c, 0x9474a07e, 0x790fbe23, 0x519ddfc2, 0x8e532472, 
	0x38d44963, 0xed0b5676, 0x37cbd114, 0x98259fa8, 0xdf143797, 0x4f4b3844, 
	0x98d53f0e, 0x63a6f78e, 0x9eafd123, 0x0ed8e05a, 0x70e833bf, 0x7908ec09, 
	0x674dd8de, 0xc27fbdaa, 0xe64577fe, 0xc688f4d5, 0xfcec6a76, 0x5fb8afb1, 
	0xc4229f91, 0x3fd94280, 0x529fcbce, 0x47a68bfe, 0xfb1c9da4, 0x7d1437dd, 
	0xed90ab2d, 0xb9278f77, 0x437cf1ef, 0x6e17f3ad, 0xf6917bcf, 0xbdb85c8e, 
	0x53d5d18b, 0xe74c95e5, 0x015b8673, 0x4fd71598, 0x4be8ac1e, 0x8dd707ca, 
	0x77409379, 0xc6de47a7, 0x07da7f7e, 0x7b0ed82d, 0xf5d7da4f, 0xfe762e8a, 
	0x1e0e3228, 0xa3f4a9a7, 0x91d9271a, 0xb5f49d5e, 0xd77e533b, 0xcf964cfd, 
	0x5c48571f, 0x5cab188a, 0xa42a29f8, 0xbbdfb75e, 0xeb6f3d95, 0x8f50879f, 
	0xdf576fea, 0xf72152bd, 0xd2413dcb, 0x4855bfeb, 0xf1976a5c, 0xc892a5ef, 
	0xef565fb8, 0x55aeefed, 0x5030b0f2, 0xb61e00ef, 0x5f2ec0f9, 0x523d3f2a, 
	0x6d5be321, 0xa0be677e, 0x9affccf5, 0x0024138c, 0x618f43db, 0xbd951a3f, 
	0xae5a7f1c, 0xb22baf97, 0xfd3ef66f, 0xdc80fca4, 0x1cff2ba7, 0x6f5932c8, 
	0x91cb2669, 0xfad11583, 0xc2807189, 0x3c189e63, 0xfdda9eb6, 0x4aef9ab9, 
	0x3a9717c5, 0x9e8a3daf, 0x5e3cfcbe, 0xc71e67ec, 0x8bc3c87b, 0xfca3a3cd, 
	0x931fd665, 0x673ad42b, 0xf684994e, 0x59bdc63a, 0xb1c476c1, 0x91bdf39f, 
	0xeb0c4f87, 0x1e023f3e, 0x38084f76, 0x1fa55cf8, 0x6599d9b9, 0x2471d9d5, 
	0x50c47184, 0xf5db0af1, 0xe04ba384, 0x4ec6110f, 0x85d5da37, 0xe9bfdd43, 
	0x197187e9, 0xf7c9073b, 0xb81fe712, 0x8add9c25, 0x30bcf6f3, 0x903ca35f, 
	0x9e26ce1c, 0x33ec53c5, 0xca1f0e71, 0xee724adc, 0xaba3bd5a, 0x27e93765, 
	0x26fa7dbd, 0xec5b53f6, 0xb777ca4f, 0x9878dc8f, 0xaf5960e3, 0xd65dbca3, 
	0x8e92dd4f, 0x9beb0ffa, 0xc273f18f, 0x43b62e83, 0x8a3fae47, 0xf1631d7a, 
	0xcebd5afe, 0x780be0f9, 0x3375733f, 0xd503fde9, 0xf44d9905, 0x784340fe, 
	0x90ddbae6, 0xe95cc6d7, 0x9b12b28f, 0x1347e0f2, 0x4cf49f8c, 0xf4f50d23, 
	0x34bfe1b1, 0x177de6ed, 0xe4eca2db, 0xe4dd7ab9, 0x38e42b07, 0x3f6f6643, 
	0x41c29754, 0xc1ecc573, 0x8f5cbf58, 0x198f0818, 0xd230c33d, 0x9a88e9bb, 
	0x7c585c40, 0x641394a5, 0x6ff06b03, 0x8ba2b1dd, 0xa3d6c4e9, 0xa67492c2, 
	0x9c838667, 0xc9c9400f, 0x2cad78c8, 0xc36317d6, 0x78f1d7a3, 0xc7edacad, 
	0x0d8ece31, 0x8cfd4ebc, 0x64ee7223, 0xebd7f068, 0xe33fca59, 0x0fad3e11, 
	0x87ed8cff, 0x6d87e3b1, 0x9a93fd7b, 0xefd92a9b, 0xc332fcab, 0x525d252b, 
	0x33d8013b, 0xca1f6551, 0x418d7264, 0xfb38a3dc, 0x4bd018e6, 0x4c55d545, 
	0xdcd7b54f, 0x70e7c956, 0x891d5efb, 0xe33bbfdf, 0x80fdfe5a, 0xa3edb453, 
	0x2956dc31, 0xed65fde7, 0x131513c9, 0xbae7612b, 0x07cf24bd, 0xcd46f109, 
	0x47dc4aa4, 0xc0d0fe23, 0x4d547717, 0x1f9d84ae, 0xe0adcea7, 0x35be6957, 
	0xbec157e2, 0xccd25f21, 0x757f294a, 0xe9de5f15, 0x8bff6389, 0x2aab9023, 
	0x7edb9f5a, 0xdb9f1e04, 0xfc4873e4, 0xb22e9b83, 0x269cb67f, 0x087808fb, 
	0xe3ad12f6, 0x3bfdaa0d, 0xd95e5c56, 0xc2841e83, 0x3d2563bf, 0x860fcc5c, 
	0xf1af2d7b, 0x7d31d562, 0x53e37479, 0xbaea95c4, 0x33e1b558, 0x3ef963a6, 
	0xdce1af50, 0x7f5ba3d0, 0x9aadef96, 0x9c619f75, 0x225b4eb4, 0x4a9dc4fa, 
	0xd48867f8, 0xfe342d87, 0xdca52abb, 0xa2cbf5b7, 0xef17a94a, 0xebc45f2b, 
	0x58555c68, 0x65a71d19, 0xa503aae3, 0x22dad6a6, 0xa52a77c4, 0xb9eb6a9d, 
	0x457ca97b, 0xe18fc457, 0xc87e12ca, 0xf71595c1, 0x3e200e56, 0x2ef8a8e9, 
	0x7e5057b7, 0xe6273f1f, 0xe3bb4b1a, 0xc4dfe8c8, 0x94a962d1, 0xa896f263, 
	0x68e2c78d, 0xca9ef8fd, 0x54f7c148, 0x81bf545c, 0x352ee7eb, 0x005f11f7, 
	0x269e106f, 0x9efe4ef3, 0xa3ef215b, 0x9cfdc964, 0xa9773138, 0x95b57aa0, 
	0xac9f3f52, 0xfa3a65a9, 0x12b06556, 0xfe0b3bf2, 0xdede56ce, 0x211ad7ba, 
	0x6dae0a67, 0x4a79859a, 0x59dbbe3f, 0x0c7cded0, 0x7a302872, 0x45946adb, 
	0xdb665c0f, 0x6d2bebd5, 0x12beba5c, 0x62a3b738, 0xa9f3cf03, 0x83a666f2, 
	0xc06b7f6e, 0xbd4ab7f6, 0x96caadf1, 0xe005e84a, 0x0eb5f050, 0x5e8611dc, 
	0xaaf92ed8, 0x8e7c8fe4, 0x1aff97fb, 0x9908fd24, 0xd7dfac05, 0xd08cfe29, 
	0xf7471c97, 0x3e0b7bbe, 0x33b83d03, 0xfe6f3e0b, 0xa864eb1c, 0xdeea34fb, 
	0x9fa40894, 0xc1775c94, 0xeebd50fb, 0xc359c541, 0xe786ff9a, 0xd0b9f643, 
	0x2e60e16f, 0x50e7dd15, 0x1c6f4ae3, 0x9bda9236, 0x7450cf38, 0xe5460501, 
	0x189d3669, 0xfbdd0d10, 0x8269d367, 0xbd3074c7, 0x5e98b64c, 0xe80729a8, 
	0x23ea9e22, 0x3ce260ee, 0xf8798fa2, 0x3c1dc65c, 0xde51e570, 0x72d3899f, 
	0x7f2aefe5, 0xe7f0f0ca, 0xdc0f172c, 0xfaca9a18, 0xd8b0c6ef, 0xc4ffa021, 
	0x86a72e34, 0x40eb3c39, 0xa26f485e, 0xdb303e75, 0xe84cdb14, 0x96e4c0c9, 
	0xfabeb1af, 0xd8e943d5, 0xc1efa157, 0x6886a5fb, 0x60db3e81, 0x75fd2a94, 
	0x1e953983, 0xf035e239, 0x65ba65f7, 0x23f72a7c, 0x044c7e26, 0xb707dc7b, 
	0xe86f8afd, 0x2ea3ef3d, 0xa8fbb4bb, 0xe2160bc4, 0x7c070762, 0x4776671c, 
	0x194ae9d5, 0xc67a2b17, 0x379ee199, 0x8bf2a070, 0x255e4c5c, 0xddf8c956, 
	0xac197958, 0xf7d32dfc, 0x61ff9ac9, 0x6315787e, 0x30efe8f9, 0xafea5cef, 
	0x559dbcc7, 0x9a10f798, 0xf35415b0, 0xff99185d, 0x1f9be6c5, 0xfbc95667, 
	0xccb7d640, 0x2f3de8ff, 0xd88bdbd6, 0x71f3e6ee, 0xf9a7abd6, 0x9f0457f7, 
	0x40df194b, 0x17ab2fbd, 0x3ef9ff89, 0x279d4068, 0xc69557dc, 0xe99612f3, 
	0xe3475cef, 0xf6fe721c, 0xfbde84bc, 0x9dd9f362, 0xa9546557, 0xef11effd, 
	0xe5b0d13f, 0x91c794b3, 0x7d9685fb, 0x9f9d50bf, 0x8f4438c8, 0xc2ea3847, 
	0xbfe73bfc, 0xc05c7960, 0xfac74cf3, 0x210cf7db, 0xbdc6500f, 0xb80b3341, 
	0x2cf552c2, 0x5ae26efe, 0xe38cb0e3, 0x9eb9c316, 0x8ab9e4a1, 0xcd3e620b, 
	0xf87b76e2, 0xd956a781, 0x0fd28df1, 0xb429d67c, 0x7740799f, 0xdc43e6f4, 
	0x05569e9f, 0x1ba573fa, 0xae5dc0f9, 0x0d86e1c5, 0xcbae9fc4, 0x3f366dcd, 
	0xc447fdd6, 0x43d13e5f, 0xf58d3b03, 0x8fad5ebc, 0x8e6971c9, 0x1e63581f, 
	0x07fcf5a7, 0x6fe58fea, 0xdfeb1660, 0xc0ff3593, 0x7351bcfd, 0x57c71563, 
	0x325c26cf, 0x75f67408, 0xb8e4f7ee, 0x5e325579, 0x9031fae9, 0xfabdf62b, 
	0xa4f97dd8, 0x5efe16e6, 0x9db377cc, 0xdc874b11, 0x96711f6f, 0x3e8e1788, 
	0xc924ed67, 0x6614f9c7, 0xa8b0a498, 0xef852f3c, 0x050d3ba1, 0xd8ff1473, 
	0xea8e1538, 0x0bf41a63, 0x17538a01, 0xf08bc3e0, 0x5fbce459, 0xdf9b13ca, 
	0x4dabf962, 0x8a857ff9, 0x4aca2d8b, 0xbd49f34c, 0x4a4cf7c3, 0x9cebc6b3, 
	0xc659a627, 0xa36d62ef, 0xb84f9cf9, 0x194db8d4, 0x441be2f7, 0xde48e5fb, 
	0x2335cce7, 0x7c542974, 0xa52afaec, 0x7a3e945f, 0x1a4e62a2, 0x4a45fffc, 
	0xcee715be, 0x38c9f34a, 0x59da0099, 0xefcf539c, 0xe7d23bf9, 0x99feea45, 
	0x37764b10, 0xaef7c29f, 0x2c8be474, 0xc74fadce, 0x8e738b77, 0x416db970, 
	0xbf20fa51, 0x39c4075a, 0xb87da8a5, 0xa8dfee49, 0xfeccdfdf, 0x5e7f69e9, 
	0x007c8adb, 0x751fb445, 0x5976df7c, 0xea33e626, 0x37fc238f, 0x7c8a7f43, 
	0x30c34f99, 0xf6a19e32, 0x8c8dab0b, 0x3c726757, 0xc61f2660, 0x580f190a, 
	0x11e92e34, 0x557ed79c, 0x4c1a6398, 0x383933c4, 0x91e2c62f, 0x10f3c726, 
	0xd05bfb41, 0xc8fc219e, 0xbcf8b18b, 0xfda06fe1, 0x5324b89c, 0xcfd00b8f, 
	0x38c64739, 0x792fe00a, 0x61fc24eb, 0x648eb233, 0x48ea5fc0, 0xe51a7f9a, 
	0xf833230d, 0xd5d0de5c, 0x7990aa79, 0xf538eccb, 0xd5a34cc2, 0x67bfc1dc, 
	0x17abc746, 0xe17b5a66, 0x4acb6d1f, 0x5c4e7992, 0xb70e384b, 0xee92f908, 
	0xac9ff9e6, 0x7f6512db, 0x91673ad1, 0x52b3189e, 0x3f9a6be5, 0x660dc655, 
	0xed82614d, 0xcf2a98ac, 0x78f22b41, 0xa8773b53, 0xb28d677c, 0x437cfe0c, 
	0xf00c97e2, 0xe0fc7763, 0xce3807d9, 0xafc2b37d, 0x8fd2551d, 0x17579852, 
	0x0d4e798f, 0x93711c64, 0x0af42f22, 0x428aec3f, 0x52fb2715, 0xc5b3c495, 
	0xff60ae53, 0x3afd5469, 0xc7c55877, 0x331b8e42, 0xbdad8373, 0x571e5fcf, 
	0x5edf99e7, 0xa89dcf29, 0x39f4577e, 0xe71ea151, 0x3b1a7e41, 0x9568eece, 
	0xec7bf73c, 0x2eabd79a, 0xea294f25, 0x1c9fbf03, 0xc7eb9277, 0xee5e379e, 
	0x2f380513, 0x09b6f3e2, 0xfac47d11, 0x427102ff, 0xfde5331b, 0x71a47fe2, 
	0x5fdd018f, 0x37a7c537, 0x60d45e20, 0xcffd333d, 0xd79c7ead, 0xbc5c71d8, 
	0x95c4017e, 0x58c7ad1a, 0x56ad1bbe, 0xb3af5a93, 0xce715d6a, 0x2ffafd9b, 
	0xaa615df0, 0x2f93c9f5, 0xddacfaf0, 0x83a299fe, 0x4c3f10bb, 0xfcaf65f2, 
	0x61bffc1e, 0x9cdad9a4, 0xf27cfd4f, 0x63efab7c, 0x8e48efa5, 0x63e8ad5d, 
	0x5f4548c3, 0x62be9239, 0x70b0a5e9, 0x37f21f9b, 0x27a66e96, 0x73bf7c58, 
	0x11eb48f1, 0x6a66c7f0, 0x1fb5445f, 0xbc1b574b, 0xaa306656, 0x9d63c59f, 
	0x422586de, 0xe3a94acc, 0x275bbcfb, 0x11a99bbc, 0xc8ed170f, 0x412f57d4, 
	0x8def9f7b, 0x9ffa6f6e, 0x9cb0664f, 0xe6df198f, 0x3ca7190a, 0xd79337d3, 
	0x5937d3b3, 0xb9329bf6, 0xb61efa4f, 0x4e21c652, 0x1032b44f, 0x8539b4e7, 
	0x7fe03b9e, 0x841d33d4, 0xff800f6b, 0xe5d019e9, 0x530cdafc, 0xbf7191ac, 
	0x37cf9c6d, 0xe895e88b, 0x1ff009e1, 0xf8c86dc6, 0x5571eee2, 0x667c954c, 
	0xa64b7eaa, 0x1e67cdf6, 0x28d6afe2, 0x556fcafe, 0xd47d65fc, 0x63773842, 
	0xf61d5660, 0x36c7dec8, 0x3b1ccf15, 0xa609e9ff, 0x79dba7a2, 0xef2a45fe, 
	0xc39f4cc0, 0xb173b907, 0x3a0058f5, 0x30fb08f8, 0x007d87d3, 0x325b35fd, 
	0xa5e659be, 0x95796d30, 0x3457dc01, 0xe897e88c, 0xf5a4c8a9, 0xefca7492, 
	0x76eb56ff, 0x7a5ce625, 0x08dbf5f1, 0xd93a20be, 0x203235e8, 0x4aa6366f, 
	0xbe84b4b9, 0xea24a2bf, 0x0cc2d2fd, 0x0b1b35d8, 0x09bfd992, 0xf205ba7e, 
	0xc8f320a7, 0xbd5e4aad, 0xae9fdf4a, 0xa2e57e92, 0x79f39eeb, 0xc65fc01b, 
	0x039c9f6f, 0x96cc32fe, 0x573c913f, 0x75ba12e3, 0x1f2909d3, 0xb49c811f, 
	0x4b4d27f3, 0xb1327da0, 0x2027a4ce, 0x4f527da7, 0x5e658318, 0x41f3ce15, 
	0xfa345aeb, 0xf8fd5b3f, 0x0a7f3bbe, 0x88c3f88d, 0x8b7c839c, 0x95b7e5c7, 
	0x96c31cf2, 0xe7211b5f, 0x17e51f30, 0x294ac6f8, 0xa6bb1f7f, 0xfdf46564, 
	0x35ce5b35, 0x441b19ce, 0x67f86b3e, 0xeb2ddfb6, 0x1ea86f23, 0x1f40c630, 
	0x29fe009f, 0x2fe3e2f9, 0xeb9c3ac6, 0x3f1b0f3d, 0x58b062e8, 0x30cff6c3, 
	0xf3b1bf8e, 0x08067505, 0x43f7d84d, 0x3257ec3d, 0x677971a3, 0x7bc8f4d6, 
	0x534e4394, 0x02fc35f9, 0x2ce143f8, 0x05f312e3, 0x9c240e95, 0xb7822671, 
	0xf0c6eb4e, 0x262af86d, 0xf4760faf, 0xbe77b058, 0x991ab49e, 0x7ae1c427, 
	0x8ee299d8, 0xdd2a87e4, 0xa78fe19b, 0x67705975, 0xadfb2568, 0x2f0bfcd5, 
	0x7c67f893, 0xb38bd2b5, 0x07cd631d, 0x738dd869, 0x2900e0d2, 0xb2a851bc, 
	0x77e7176b, 0x4e3eaa79, 0xc749a3dd, 0x43d28a7d, 0xe592d976, 0xf6965471, 
	0x90403a79, 0x71e5bfbd, 0xee32938e, 0x3c64cadc, 0xe3a66592, 0xe661797e, 
	0xefd8adbb, 0x5eb92bdf, 0xa5d38d7c, 0xb47e40fc, 0xa62db857, 0x9e737fff, 
	0xc1a7ed52, 0x16ea5d67, 0x71e61aa7, 0xac10f999, 0xfe53a6bb, 0x7f22bfae, 
	0x5f147907, 0x5e25c533, 0x91c9ffa5, 0xf901c7f2, 0xdf2ff340, 0xd8efc477, 
	0x8a2bc42a, 0x1e0fcb2e, 0xb87ce3f1, 0x0d33a0fc, 0x35dc59eb, 0xdc388d9d, 
	0x8fde4673, 0xb2477db2, 0xf4f4fef1, 0x639cfe23, 0x7d60fef4, 0xd06d0e5a, 
	0x0a7df4fb, 0x4434bf8d, 0x7a443fdf, 0xfa493722, 0xa0fbed17, 0xbfbb5faa, 
	0xdfd295f6, 0x1e07a556, 0xb75c216b, 0xb7de1bd5, 0x93953779, 0x6df864c5, 
	0xea56bcaa, 0x27d85dba, 0x67f40f71, 0xcedcf235, 0xafa3e488, 0x67a4eff9, 
	0xab1d6872, 0x93ff2dab, 0x721724ed, 0x0c4c8e33, 0x9d725c4b, 0x9e4f25c2, 
	0xf0ebdfe2, 0xf93e347b, 0xd9fe4f51, 0x2911f585, 0xab1fe296, 0x9d30ff07, 
	0xfbe48f1c, 0xe47bce29, 0x9719f224, 0x0fdd7fed, 0xd56cb6bd, 0x6dc7ccfb, 
	0x107d69e7, 0x73fe7b57, 0xeefa0eff, 0xe05fb7f4, 0x6fe6e9f5, 0x107fd871, 
	0x959befdf, 0xf71b4396, 0x2b5fcd32, 0x569d7fed, 0x93fad0e6, 0x983d2b7c, 
	0x366ff2c8, 0x12f8e7d1, 0x3fd03f49, 0x3062e8bd, 0xfb8c23cd, 0xce04cee0, 
	0x85eb4c17, 0x0adefd32, 0x3c9b2ffe, 0xf07e0d2b, 0x78cea3d2, 0xc6b295e0, 
	0x540d53ea, 0xde556caf, 0x1183bca9, 0x86db637f, 0xd700e1cc, 0xee0ca1d5, 
	0x3bf50977, 0x1b2dfa8b, 0x2f2a7559, 0xaa139e87, 0xed737eb8, 0x6a2e33bf, 
	0x27c19af1, 0x496c9ec9, 0x1a6bef0d, 0xe34ccf4e, 0x96bf587b, 0x5ce3f0e4, 
	0x510b7b46, 0x720ff68f, 0x9a514168, 0x78ade346, 0x9ee04322, 0x48ad4557, 
	0x74aebf83, 0x216fbab6, 0x4fe1afc4, 0xf5a1ec5e, 0xc356f1a7, 0x283e27be, 
	0xe7c47926, 0xbd330195, 0xb3e814f5, 0x3d67ec3e, 0x4e23a666, 0x8cb55876, 
	0xebf08e87, 0x47985d9c, 0xc5cf53d9, 0x725bdd31, 0xa90ecb5d, 0x1e5509f2, 
	0xa99be547, 0x17c64c7c, 0x1c3ea596, 0xe018bc87, 0xff9fe84b, 0x2968fc57, 
	0x5f1fd4bd, 0xfdee1d12, 0xffbfb8ef, 0xc852ca38, 0x2c65c51e, 0xfba02fd8, 
	0x812759f6, 0xe15a60ef, 0xeef5d8fb, 0xe8094434, 0xbc9668f8, 0xabf65b8f, 
	0xfadd7159, 0x6457fa40, 0x27653c3e, 0xf623e2e9, 0x30d31697, 0x5fdc90d7, 
	0xa4b17c81, 0xa84f3af7, 0xfedb4fb8, 0xf1229dc9, 0xb65521c6, 0x76b1d7f1, 
	0x87655fc6, 0xd22bb96c, 0xc7ba7d78, 0xc62b42f5, 0x39e27c55, 0x27f2d7de, 
	0x2dbe625f, 0x687e21cd, 0x5fc0efa1, 0x5c7fb7c4, 0xa11deca9, 0x7243cce8, 
	0xf7af14fa, 0x25c7cd9d, 0xff2e81df, 0xc3da52b4, 0xf70f4278, 0xbf542faf, 
	0xf9ab678b, 0xfce5c39b, 0x95c870c5, 0xfdd90615, 0xbae96790, 0x78022fad, 
	0xb664bc5f, 0x2e5c9b2a, 0xf7f192ed, 0xbbfdbac5, 0xe57a1c35, 0x5f791abe, 
	0x6efc18a0, 0x65f135f3, 0x848fcaa9, 0x7c5f0675, 0x1bc646b3, 0xf9a2e8ad, 
	0xd9d88c2e, 0xf11fe865, 0xcf7dae05, 0x64ae7cc8, 0x465d62ef, 0xbbe0bd8a, 
	0x8bc6508a, 0xa75fc471, 0x869e5c5f, 0x5965a15c, 0x4410656f, 0xd63d9b10, 
	0x7c8be424, 0x0648ebaf, 0x3f9a9502, 0xfb17be99, 0xcdfde369, 0xa7279901, 
	0x5d96eaac, 0xfe05a788, 0xd6997b64, 0x7eb37802, 0xb7b66afe, 0xc2c99b37, 
	0x8e9a223d, 0x46cfd85f, 0x28fbec3d, 0xff6dba3b, 0xbef98fc1, 0x22f890a8, 
	0xf031ac28, 0x1b38f197, 0xe5879fa9, 0xbaf7a4bd, 0xbf11d3ea, 0x56ef1dd4, 
	0x70e9ed23, 0x2ba7b2b5, 0xe4fd24f2, 0x3a4ee74c, 0xfdc1fa4b, 0xfe46a70a, 
	0x4c0bc26e, 0xfa42d55f, 0x19f96c29, 0xab47f74b, 0xf4adffa5, 0x5a6dc91c, 
	0x156a0ab7, 0x1eca0777, 0xfe27195b, 0x2787e545, 0x9b9d5e79, 0x714f76c1, 
	0x6c1691b2, 0x34df38e4, 0x4cb2f7e0, 0xc92da3b2, 0xe712cdbf, 0xcdcf91f8, 
	0x69e796aa, 0xc3e21e65, 0x058ed502, 0x8e9f5cf9, 0xfff68aef, 0x63962ed3, 
	0xe5229c7f, 0x67e6a8b3, 0x34a2de71, 0x2bd967ec, 0x1fc47e92, 0xdfbe3e9c, 
	0xb87dd2ea, 0x6a63fadf, 0xe78bab37, 0x5c390093, 0xe58337bc, 0xba261272, 
	0x4d7ff78c, 0x945efd1c, 0x44f58b3b, 0xa9d67851, 0x9c0e78b5, 0x68bff2cc, 
	0x4503d4a4, 0x285ea413, 0x9f5a86f6, 0x1cfd0a3c, 0xfbfeb71e, 0xff0cccf4, 
	0x38a07a10, 0xe5113c39, 0xf6e6f3d8, 0xbc77256a, 0x917dff24, 0x3cd6cbdf, 
	0x3596edcb, 0x779f227f, 0xb3e972a9, 0x3eac4fdc, 0x1c9afb29, 0xf93cd947, 
	0x92fd3fbe, 0xd58bfaa4, 0xcf4db433, 0xb66cfe40, 0x3a58b4ed, 0xfbcaf3b1, 
	0x1d5da4f2, 0xe9637723, 0xfaa534a6, 0xebb90e94, 0x2437f591, 0x86de7f4a, 
	0xd8d392bb, 0x1796effe, 0x6e59d3ab, 0xe6f193ef, 0x3d77619b, 0x36ae9bda, 
	0xd25d8824, 0xc17620af, 0xddf650af, 0xd4afa93c, 0x5b1eca78, 0x455e6714, 
	0x4c130ced, 0xd790551f, 0x0daa622f, 0x33ced863, 0xddf04f88, 0xa277cec3, 
	0xb1f7f6e5, 0xb5af441e, 0x73d427e0, 0xbb62ed65, 0x487f9ed3, 0xabe659ca, 
	0x7b3eb50e, 0x3655eb23, 0x738ddcd2, 0x9e4faac1, 0x9fed1ddf, 0x5af450e8, 
	0xe9892fba, 0x492bf37a, 0xf7a7bdc2, 0xeeff12ba, 0x3e013962, 0x1f9bd63e, 
	0x68dda94b, 0x7019423f, 0x6f6a815a, 0xef75ef61, 0x8d29f350, 0xe3654791, 
	0xd631ffbe, 0xb5e1ddf9, 0x78f6ffd2, 0x50cd37fd, 0x2ca13ce4, 0x150fe14f, 
	0xbf3864b7, 0xfcc7d277, 0x71d47647, 0x5ce01769, 0xa39def73, 0x59ae706b, 
	0x6eb8eca4, 0xde56217b, 0xae35be3f, 0xfb54446e, 0x8cbf0db3, 0x81fd209b, 
	0x74cc5376, 0x4af0fbb4, 0x01339f19, 0x39c2eee3, 0xb13fe180, 0x89f6fe06, 
	0x90ff3235, 0x200f638c, 0xa8f0010f, 0xfe231f68, 0x8c25e706, 0x91af59a3, 
	0xf0a4d7dd, 0xef6519f4, 0x5c04b88d, 0x39ed05fd, 0xe32bdf3b, 0xbc3c83f0, 
	0xfc36ed3e, 0x6dbb083b, 0x43f9c840, 0xbf0059c4, 0x4bff7cd3, 0xcf5b59e9, 
	0x82fe4195, 0xdef22bcf, 0xcb2cfe01, 0xc9fd977b, 0xdf0366cd, 0xc8f62ed7, 
	0x272cba7b, 0x3db37e68, 0x4b5fa1c6, 0x10ed377b, 0x2d5357b5, 0x8597fbef, 
	0xacde9ca4, 0xfab172f0, 0x90a51a3b, 0x3f251eb3, 0x9fd937e1, 0x6fb90bb4, 
	0xb2a7cb4b, 0xa535297c, 0x9d5cdd7c, 0xee7d1699, 0x2c5cca2a, 0x9d6ac557, 
	0xc6336ce5, 0xb9a7f249, 0x700674fa, 0xd1c5597c, 0x7be06edb, 0xf507d630, 
	0x9571a2d3, 0xf6b2bbe4, 0x8dd9fc9e, 0x471242a3, 0x8143b2f5, 0x63de14ab, 
	0xd2b0bb67, 0xe126f5a2, 0x33856caa, 0x06d39fd8, 0x147ef55c, 0xeea7daae, 
	0xe5521fcf, 0x635fcaf9, 0xcfc0bdeb, 0xc479def8, 0xf4fd95be, 0xe5baab87, 
	0x48d7cab7, 0xf90e9104, 0xe92d515a, 0xf2e28bfc, 0xfbaf250c, 0x6b45e7c3, 
	0x822fbca4, 0x2ef3c09e, 0xfa952e55, 0xfbeae7e2, 0xfd49afa2, 0xfe4f3454, 
	0xdde1567e, 0x79df5f02, 0x3dc63b73, 0xc4eff926, 0x8fc74c6b, 0xe9b6e2dd, 
	0x233611dc, 0xe4fd9bdf, 0x71cfb5a1, 0x45e8dcf9, 0x230b67c5, 0xfe7640e7, 
	0x84df9b14, 0xf361f7ba, 0xd15fcd89, 0x782e5af9, 0x99ceabae, 0xb84a5f38, 
	0xe8f29e77, 0xb94b84b8, 0xe112f5e7, 0x4fca8f26, 0x3cbdf7cb, 0xeb946b42, 
	0xbb3cc014, 0x97ca95f1, 0x4be777a2, 0x97cc9a11, 0x2f5bf542, 0x50252f90, 
	0xec52f9c0, 0xe58bb273, 0xebf5894b, 0xf7d9dfdb, 0x02ccf489, 0x72744fbe, 
	0x7d35dbdc, 0x79da2f9d, 0xd55ef913, 0xc9c79929, 0x71e65737, 0x87f92c1a, 
	0x507d38f3, 0xf0e27123, 0x89a9bfe9, 0xe3a5a7be, 0xe701567e, 0xf760d271, 
	0x72d3dec7, 0x3df0084f, 0x523573ad, 0x9e9efdef, 0xea3de790, 0x4d9bf745, 
	0x11ff4afd, 0xbfb2bde7, 0xd76fedb3, 0xdeea59d5, 0x1fb9bd16, 0xac7fa9e7, 
	0x80d0f3e1, 0xe7719353, 0x3d59f1b1, 0xcfba2fcf, 0xdfe70d35, 0x34535ce5, 
	0x112ece5b, 0x8f9b0f69, 0x1dfbb37d, 0xebcf7b90, 0xf72541fa, 0xdee8454f, 
	0xf531df6e, 0x1da44e47, 0xfe369e2c, 0xe421d608, 0x857d3175, 0x582933f4, 
	0x9df390ff, 0x442ef813, 0xcd7116e8, 0x7c69d738, 0x81458857, 0xbfdc3a8c, 
	0x0df2ac59, 0xe10fb9f2, 0x3f394595, 0x40aeb87a, 0xfbc9079d, 0xa7cd69b0, 
	0xfee05f24, 0x646dfa22, 0xcb17cabf, 0x2ab09427, 0xd3d4957b, 0xd4277e32, 
	0xbfdf32f8, 0xe6583c5b, 0xa3e90967, 0x4e31e2d2, 0x9e3bda67, 0x63bf12b9, 
	0xce34a59c, 0xf405d084, 0x8f634a78, 0xe9fde97c, 0x2eaf5e71, 0x37ae17d6, 
	0xae9bfe58, 0xfd8e89b7, 0x91f38245, 0x87170ca5, 0x969c6fe1, 0xc8fb67ed, 
	0xd6ed2558, 0x9d24ab79, 0x5584cfdb, 0xbe815733, 0x7ecbe642, 0xea353f79, 
	0xc5f1d6bc, 0xb98887e5, 0xe1999a27, 0x743905df, 0x7c07f533, 0x2d6aea36, 
	0xe1ee326d, 0x5e7c18e6, 0x69f2422f, 0x9a8dfb8f, 0x795d78db, 0x872724fc, 
	0x66ae1814, 0x0306e227, 0x4c99f71c, 0x88549474, 0xabf982b8, 0xf1b11fc0, 
	0x123f7c03, 0xfd5f54e7, 0x13790520, 0xc33b470b, 0x718ba00d, 0x8dfcbb19, 
	0xd42b3e11, 0x7b9d421d, 0xff50723b, 0x483b426b, 0x95f17438, 0x449391c2, 
	0xfe92afbf, 0xc5718ecc, 0xece23ebc, 0xf6871c87, 0x33a69fd4, 0x2c9e3c3f, 
	0xe2c9deff, 0x5fb08f09, 0xd2d57924, 0x58938855, 0xa4e1b134, 0xefdf4758, 
	0x839f62b9, 0xe80d71f8, 0xcd71e897, 0x683fa75e, 0xc705b9f2, 0xed4fde21, 
	0x5e42ef8f, 0xec2f2920, 0x173d8cfd, 0x3ecab35d, 0xd55f282f, 0xec4179d7, 
	0x03ea28b9, 0x571c9eaf, 0x5e59f5cd, 0x879c8c2c, 0xfb53cac6, 0x97e6d45c, 
	0xbcd3dd8b, 0x5e5ad563, 0x35975ff7, 0x6fbcfb72, 0x5c27571c, 0xb8c95f4a, 
	0xd69625b8, 0xe723f524, 0xdb511cc1, 0x1da1af33, 0x374e3787, 0x7be41d86, 
	0xa015c6db, 0x0f1bbb97, 0x07b8e78f, 0x59e5da61, 0x584c9f7c, 0x761e6057, 
	0x3994c41e, 0xdea55f24, 0xb9fa5549, 0xdbbd78ef, 0xb5961e3e, 0x747df246, 
	0xf8c5cebc, 0x3b5af6fc, 0x9c67a25e, 0x852f9d9e, 0x2bd693d7, 0xc73b7c2f, 
	0x75a31c6d, 0xcbf34b9f, 0xb3f994cb, 0xbb7da98f, 0xa76cde78, 0x962ee5a3, 
	0x37990ea3, 0x1737d45b, 0xd0b66f23, 0x5f3e685a, 0xaa7c95a9, 0x5da3b2df, 
	0xc73afce0, 0xd9bca872, 0x37d3c8f5, 0x1c9cdb20, 0x96d1479d, 0x8141b017, 
	0x55acaec3, 0x06c7b379, 0xe41e5c78, 0xd21e26cd, 0x23d5f2ef, 0x47de366f, 
	0xcef6cde7, 0x4790f514, 0x26cde45e, 0xde8c327c, 0x3feb9e27, 0xe8aeb66f, 
	0x38f45755, 0xf79e56a0, 0x12f7568f, 0x3e656bca, 0x8d2f3b57, 0xffabb940, 
	0x5e7f317c, 0xd18be765, 0xaf1ffc78, 0xbb7fdf92, 0x8855adea, 0x644b1677, 
	0xb14a505c, 0xc5fd6f94, 0xff7fd9a9, 0xf7255de5, 0xffb7ba6c, 0xe74d858e, 
	0x7d057971, 0x99c939d2, 0x53c4e200, 0x73fe8546, 0xe7c451eb, 0xe3767e9f, 
	0xebb79a70, 0xfdb9ff07, 0xc349e228, 0x1c303ecf, 0xa78df6f9, 0x7ab8abb7, 
	0x4fdb17f4, 0xd884fdec, 0x15d7bb7e, 0xe691177f, 0x7a63ba5b, 0x2465415a, 
	0xc829c77f, 0xa7c952cd, 0x0ba7c561, 0x2d27e2f7, 0xe3e32c2d, 0x7b320abb, 
	0x5379bfe7, 0x9e2fdbc9, 0x2f5fd51f, 0xf3b1daa2, 0xda82fea3, 0xea3f33eb, 
	0x641ef25d, 0xbccf6d62, 0x9d1fa840, 0x6bb1f51f, 0x15f6d606, 0x13ec91d7, 
	0x25a7c181, 0x4a7e0d3f, 0x76f913ce, 0x3441cf30, 0x495697af, 0xb72dd47c, 
	0xeb72905e, 0x06c3c7b2, 0xeec4bff2, 0xa8797f5b, 0xe8f5a98f, 0xf2750f2f, 
	0x1cb551aa, 0xc6fa490f, 0x8f7a7e44, 0x383abbfa, 0x6cf9a3a9, 0xf311f352, 
	0x8957d62d, 0xfea1cb5e, 0xfea69ade, 0x9c61dade, 0xfc56aecf, 0x639e7dda, 
	0xedb2f7e7, 0xb64deb2a, 0x723cecab, 0x4670a67a, 0x7af4e9e7, 0x2d4c7ee5, 
	0x2e011c08, 0xf32b5adb, 0xdee2e66e, 0x94fbf124, 0x674f3b5a, 0xe6f23d5c, 
	0x5e92477b, 0xf2fe066c, 0xcbd3f9f0, 0x27af32b5, 0x9c6273fd, 0xe8b56ba4, 
	0x9fa6e3bf, 0x4e9e5437, 0x6276c1d3, 0xfd838668, 0x565d9f44, 0x11737a07, 
	0x8f9c45cc, 0xabd3a79d, 0xf448fccb, 0x1fef8ea2, 0x0b8eed9b, 0xec84e9e5, 
	0x99d3ce89, 0x71c2bc60, 0x3a79dd03, 0x3765c96f, 0x6e7e676f, 0xfd67fccf, 
	0xf7dce9e5, 0x62bff62b, 0x1b54fe7d, 0xee29dfd1, 0xbcca4fc3, 0x8debd67c, 
	0x494f83cf, 0xfbe10c1f, 0x9226ce09, 0xcdd4a563, 0xef92bdc0, 0xb6a55f70, 
	0x7ae7c656, 0x79dd2533, 0xc8bcd553, 0x79a1695e, 0x123b6779, 0xcf804b3d, 
	0xcf203302, 0xba4ad7d6, 0xfdc9e6f3, 0x085c7bc0, 0x7195aa6a, 0xd35d5e4a, 
	0xf7e2ef82, 0x365204f6, 0xe22737d8, 0x00c2f451, 0xe2f163e7, 0xf7d5203e, 
	0x7eff7726, 0x7ec1ee27, 0x96a4aabb, 0xdf4958e5, 0xf2b18df1, 0x78d8a52b, 
	0x1bf4b37a, 0xfa76b15c, 0x6613c997, 0x4fcab7fc, 0xad317e7a, 0x590bca5b, 
	0x45ef6f1c, 0xc053be1e, 0xc0b94439, 0xc62d67b3, 0xd079dffd, 0xbde67cc5, 
	0xdbc71e6b, 0xaa6b8c77, 0xc6fe50bd, 0xdf07756b, 0xf4562c7b, 0xa5f2a5e9, 
	0x6b77cfac, 0x5d8b7ca5, 0x40f22f27, 0x80fc559e, 0x9c20dafd, 0x45e903c8, 
	0xf7aa481e, 0xc7e95ad5, 0xb77caaf1, 0x43bfe55e, 0xb77d1a79, 0x8cdfde97, 
	0x3c98d878, 0x6f155e90, 0x12079b12, 0xf25791f5, 0xfccf7f02, 0xccf7f965, 
	0x9e9ae7ad, 0xe958fe47, 0xb5c9862f, 0xf7a2c7e6, 0xa18c37df, 0xfc1ba16f, 
	0xbb1315f7, 0xf0966be3, 0x3ce221df, 0xfe55c783, 0x2bc72a40, 0xd100997e, 
	0xce2471f2, 0xf84bced1, 0x340fe455, 0x53c2fe55, 0xd6a19f2a, 0xaba67f9b, 
	0xb79c1a7b, 0x63caa170, 0xa71a8c18, 0xa577f38a, 0xa817bad2, 0xbed4857c, 
	0x1c3840a7, 0x270fbe3e, 0xaa1a14f3, 0x14f2c5fe, 0x25f5fbce, 0xf72da9f1, 
	0x31396e48, 0x295abcb9, 0x5f90bd97, 0x92dc9467, 0xabe7047e, 0xae3b1fc4, 
	0xf116a379, 0xc073f6f3, 0x73cf64e5, 0x0063249e, 0x7314cde3, 0x11ffbc80, 
	0x611fe76f, 0x25c4cb7f, 0x78eb1d3e, 0x49cee156, 0xf03b7a71, 0x33b5a4cd, 
	0x356fc89c, 0xdd4e4971, 0xd38e34e5, 0x353fd2b5, 0x0ed6ad69, 0x36fda5fa, 
	0xff7ed207, 0x17c656ae, 0xe7d14efe, 0xe98d0680, 0x8bd64ceb, 0x3fb50f4e, 
	0x0018c4b0, 0x68c06ebb, 0xefa05fe9, 0xaf10f688, 0xf11ef91d, 0x51711359, 
	0xae03ca8f, 0xec17f991, 0x5dfb11f7, 0x6fc034e4, 0x5c92707b, 0x729303cf, 
	0xe42b9474, 0x49fb76fa, 0x23bf48fe, 0xaa98e6ce, 0xceaf3447, 0xf13a9d15, 
	0xc691e0fb, 0xb59dfc46, 0x9de64281, 0xea6d5c1c, 0x5f95c241, 0x09ae24fd, 
	0xd9e0dc76, 0x3a658e52, 0x07a09b92, 0xde193f32, 0x7ff1fd04, 0x9d9de201, 
	0x000000a2, 0x000075d1, 0x568d9c78, 0xd75b686f, 0xe9ef3f15, 0x9d4e7955, 
	0x0d2567a7, 0x5a825a76, 0xa9f76852, 0x6a287a81, 0xee2cbd27, 0xe299aca6, 
	0x42eae90f, 0x05adb2e8, 0xbc6064af, 0xe0a1c8b4, 0x52c44b2b, 0x53b2c56b, 
	0x86d8ed2f, 0xa30b183c, 0x8a57441f, 0x85e1f653, 0xe840d616, 0xbf5b0a54, 
	0x6125c474, 0xcb256819, 0x812d2db2, 0xbdee77ed, 0x273def4f, 0xab983323, 
	0x9ce779df, 0xeb9ffe7b, 0x3194b03c, 0x10e4487f, 0x9269ed51, 0x5f00427f, 
	0x919cc835, 0x89e6b5d0, 0x13bf83fe, 0x01fba0b3, 0x4dac73dd, 0x59d3e944, 
	0xf4046067, 0x305fe80e, 0xfcc2dfdd, 0x7d87428f, 0x2657223d, 0xa4b3ddfd, 
	0xf55118dc, 0xc087a21e, 0xf014ef77, 0xcfa1852e, 0x3f2c7d65, 0x67a43570, 
	0xb6f18f98, 0x716d6f80, 0x5f088de0, 0x88c3ff48, 0xdeb08fa6, 0x60fd3ec1, 
	0x9c69ff94, 0xe28f72c4, 0xb7bc8afb, 0xd217d315, 0xf2eb23bb, 0x5fbddf1c, 
	0xa53ddf7d, 0x5cff294e, 0x627657c0, 0x0a5e9af2, 0xd7d43bfc, 0x17c63277, 
	0xf7d43fd2, 0xa4f7a294, 0xcfaa2493, 0xd1367e23, 0x2e890789, 0x745b6e9d, 
	0xb6f39804, 0x43da79ce, 0xae389fd6, 0xc72c9939, 0x3d83f8d7, 0x57d12448, 
	0xf74d5b97, 0x97974407, 0x0adb355b, 0xdf8a31f3, 0xd6fd37ac, 0x8b9ed352, 
	0x7903a9e4, 0x3db583ae, 0xff819f52, 0x5fce35d6, 0x59ebd156, 0x6d77b7a9, 
	0x3c6b49e6, 0xfef7b7bc, 0x678f93cc, 0x0638bf15, 0xbdc28efc, 0xd3e29af2, 
	0x4163e972, 0x6327ca3e, 0xa5e90e79, 0x1e7c7587, 0xee5fff66, 0x68c3f7c7, 
	0xa7fc64dc, 0x06535e65, 0xe33676e8, 0xfac9ef8a, 0x44f38a6a, 0xcfe412fb, 
	0xfe1a065d, 0x0fdc658a, 0xc9807acc, 0x01ad9af6, 0xea12e7c9, 0x09264d31, 
	0xfaccef60, 0xbae2063b, 0x47b3f877, 0x0f760744, 0xdfd232e6, 0x8f41bfc0, 
	0x61ab886a, 0x67d8fea8, 0x1714d53d, 0xe2f3a721, 0x51f546fd, 0xf419a8ef, 
	0x83ee56cd, 0x2dbd477d, 0x87e8169d, 0x3348ba03, 0x35ed347d, 0x1fa0c33b, 
	0x505f7530, 0xc822fb9a, 0xc05b6f43, 0xf74cb9ef, 0xfe2a7326, 0xde3d9447, 
	0xb9e3c684, 0x475e9e7e, 0x4e62bd0c, 0xc9cbdfe5, 0xe6ae7b78, 0x7d1e15b3, 
	0xe65178e1, 0x3d19eb43, 0x0f4471ac, 0xa4b46fe7, 0xa8cf5ae9, 0xead16efb, 
	0x77d27a86, 0x03f5c791, 0xe434aa90, 0xb7f19559, 0xf5096a45, 0x3ff8e69b, 
	0x345dfaaf, 0x1adabd24, 0x1fcbfd09, 0xcb12276b, 0xb7bba5c8, 0x9c53f4c6, 
	0xe7fbe457, 0xb286afba, 0xd3853b90, 0x8a3c9123, 0x11fb6d93, 0x463a9b4e, 
	0xda54e70f, 0x388afe32, 0xfd75642d, 0x7df0bcab, 0x1177af2a, 0x6ad43bdf, 
	0xbc98c5ff, 0x8b5edf1d, 0xf0eddf10, 0xe54df258, 0x57afab6e, 0x9f96e60f, 
	0x6bf3f208, 0x93b43fd8, 0x3fb0aae6, 0x2ed90af5, 0x2eba3ae4, 0x6139d353, 
	0x15bc28ae, 0x552de4fe, 0x5896d0d7, 0x77c5437a, 0x0dbf7c09, 0x11c707e6, 
	0x448ae4fc, 0x6f7d4463, 0x0cb3de80, 0xb3b78f39, 0xb6ffdce4, 0xb11ecec3, 
	0xaec0e604, 0x8ba41a05, 0x57431fa1, 0x6e57cf51, 0xbd46cfe3, 0x94cea0e5, 
	0xde758dde, 0x61d7eb1b, 0x7a07ba3a, 0xf5ba8287, 0xd83b75e3, 0x463773af, 
	0x3fcfafbf, 0x60ffe724, 0xef2bc77b, 0x02441d11, 0x9767b8ea, 0xbf973195, 
	0x6bb4ec09, 0xcb8cbacd, 0x486f9677, 0x786edfb3, 0x880fa398, 0xce123894, 
	0x597a6741, 0xd74f2ded, 0xbfcf5177, 0x13ff5d71, 0x5b1d4eaa, 0x1e35777f, 
	0x0ab3dfd6, 0xdf787697, 0x53dd4b7a, 0x7ba87be3, 0xc2eaa13e, 0xbbd17594, 
	0x78e19034, 0x28ff31e4, 0xf87a8779, 0x0f50f83e, 0x3de61ab4, 0x057b7ff0, 
	0xceaabab9, 0x3fdf14e2, 0x9b6feb29, 0x9bf93f9e, 0xca7ce49b, 0x155f397f, 
	0xabebce26, 0xce758ca7, 0x79f16ba7, 0x8b071e4b, 0x9e418f32, 0x55af2b8c, 
	0xf7abea05, 0x8b0f60bb, 0x5ff8b12d, 0x2773efe8, 0x8a05c796, 0x7f4fbfe5, 
	0x7217e033, 0x7a6b3b5f, 0x5ed474af, 0x7bd03e71, 0xc27b57c2, 0x50fdeba9, 
	0x39de7356, 0xf4b7bfa3, 0xe67778be, 0x689e72db, 0xe005def9, 0x8c3f286e, 
	0x2f78b8b8, 0x15964ef4, 0x3bd3d69f, 0xad615673, 0x69a7ce47, 0x15124f39, 
	0xecc5fbf8, 0x517a15bd, 0x3fd029d9, 0x72ff1ff9, 0x52ae86cc, 0xad18b5b2, 
	0xbd4ed297, 0x4e61af47, 0x6eb9deaf, 0xe18e811e, 0xfd47ff63, 0xe975037c, 
	0x58b4dee2, 0xf9e79814, 0x3e2f1faf, 0x10f386be, 0x779c984e, 0xf2d51cf4, 
	0x473d61f9, 0xae41fcb5, 0x03f1349b, 0xf3c4b527, 0x1aa45873, 0xdc39c3e7, 
	0x57d7979f, 0xeee7bc13, 0x786d17e8, 0x4fc06dc7, 0x81dd7e05, 0x4cbf16ef, 
	0xcaeb58af, 0xb0fca039, 0xf024e036, 0x88930478, 0x1a5bc863, 0x18f94a03, 
	0x8dd5bc86, 0xf147c860, 0x42a26233, 0xf9b8e4ff, 0xf4b9e72e, 0x0371b5d2, 
	0x0fe177e7, 0xe70c9fc1, 0x3f927d1f, 0x1eb4da6e, 0x05d701d6, 0x2fcf03ef, 
	0x4d2b3ec8, 0x8468d72f, 0xfe1906eb, 0x671fd13b, 0x27ea0b9f, 0xd44aa975, 
	0x7ac12f26, 0x3bf35e78, 0x7a7fe382, 0x22c7f656, 0x9d96d7f7, 0xec05b5f4, 
	0x7ee982b7, 0xf25b6af4, 0xe6cf6c99, 0xc3fb5249, 0xa4fce5f2, 0xafbf5d71, 
	0xf145fd07, 0xe8089afe, 0xafd18cc2, 0x1534fbf4, 0xefd27fa3, 0x773a2747, 
	0x027ee372, 0x18528ecb, 0x322b7323, 0x4fbc435e, 0x9ce3acf9, 0xdcc2bee5, 
	0x4c826c79, 0x06cceb93, 0xe6a47e1d, 0x79e39dcf, 0x1552bf05, 0xb289e5c4, 
	0xf603b43b, 0x998d36a6, 0xcf98cf95, 0x1806354f, 0xeb8e7fbf, 0x77a960b3, 
	0x434f6058, 0x9f4d7deb, 0xe329a2f3, 0xdd6a6d88, 0x6b5681a8, 0x9ea06c7f, 
	0x1e602f4b, 0x0bee74e2, 0xaa97a0f6, 0xafc66f03, 0x2bb75157, 0x2c55de15, 
	0xc05e2fe7, 0x9b55a4ef, 0xfa5949fc, 0xa782e6ff, 0x8fc0a8ec, 0x8db40e27, 
	0x79e856c4, 0x406a73a9, 0x9e55b5eb, 0xbabafaac, 0xfaf9006f, 0xc533db15, 
	0xe64cfcf6, 0x8697bc37, 0x6f917f64, 0xb94bf7d6, 0xc04f8e39, 0x1a2e7b0f, 
	0x613ef947, 0x9bc97df0, 0x6a3b4ff7, 0xc2681c2f, 0xab9bb18e, 0x91ef0246, 
	0xf77fc14f, 0x1df56314, 0xf7a96a7d, 0xfa0fea04, 0xc2dfda0b, 0xefc05c0e, 
	0xf40bae6b, 0xabe92f65, 0x61e60afe, 0xb1bf7580, 0x5bf5ecde, 0x21711be9, 
	0x2c7ecbed, 0x2b7ef198, 0x32701b58, 0xee059fde, 0xe33628c7, 0x51f2c6fd, 
	0x2beea9fc, 0x53ed13d6, 0xdac313d6, 0x73f641df, 0xc5fdec37, 0x6aa77e9a, 
	0x38d59f3f, 0xcfcf87e8, 0xef517c2a, 0xdc6b3f81, 0x6dc65855, 0x65d9f945, 
	0x2e5a7f3f, 0xfa86ea1e, 0xff109c64, 0xb2b2e1c2, 0x7c2deb57, 0xd2eca33e, 
	0x9c9f0b7a, 0xe5eb5855, 0x4ebee6fe, 0x3ec37b6a, 0x9fb11cf7, 0x60e5c0e7, 
	0x727a480e, 0xf3ece233, 0x0e7955e9, 0xed16fd06, 0x6a0ce5ff, 0x2fdfcbe7, 
	0x2f24748a, 0x7ef7872c, 0x5bfecbc1, 0x7b3e71b4, 0xacb85fe3, 0x076c473f, 
	0xf7be5af3, 0x3e81ae68, 0xbd4547fc, 0xe39e6d1b, 0x4519a75c, 0xe73f1bbf, 
	0x98c5def1, 0x0b7f13a7, 0xf7d481f7, 0xf38fd690, 0x744cb3bf, 0x00000029, 
	0x000e0822, 0xffffffff, 0x00007f86, 0x000000d0, 0x001e2f12, 0x001e437f, 
	0x00124438, 0x001e45dd, 0x001e2965, 0x001e97a9, 0x001e2ab5, 0x001e2a79, 
	0x001e2aa4, 0x001e2a52, 0x001e31ea, 0x001e2a90, 0x001e5e8a, 0x000000b0, 
	0x0000207d, 0x00001fc8, 0x001e3c36, 0x001e35c5, 0x001e3cdd, 0x00022439, 
	0x0002243a, 0x000021a9, 0x000022a7, 0x00002440, 0x001e3492, 0x00000020, 
	0x0004945d, 0x001e9735, 0x00000020, 0x00049490, 0x001e93dc, 0x00000020, 
	0x00060c75, 0x00060a23, 0x00000020, 0x001e0c2c, 0x000608c5, 0x00000020, 
	0x001e16b2, 0x001e1551, 0x00000020, 0x000a467f, 0x000a48e3, 0x00000020, 
	0x00124607, 0x0012460e, 0x00000020, 0x00123d26, 0x00123e9a, 0x00000060, 
	0x000c6527, 0x000c799d, 0x001262a6, 0x001260d3, 0x000c7e88, 0x000c796e, 
	0x00000020, 0x000c7e88, 0x000c72f2, 0x00000020, 0x000c649f, 0x000c7a1f, 
	0x00000020, 0x000c64d7, 0x00123d26, 0x00000020, 0x00000080, 0x00000000, 
	0x00000020, 0x00000000, 0x00000007, 0x00000020, 0x00000000, 0x00000001, 
	0x00000020, 0x00000000, 0x000000aa, 0x00000020, 0x17c112b5, 0x000000fa, 
	0x00000060, 0x0001000a, 0x00032a08, 0x5d83924e, 0x00000000, 0x01020258, 
	0x00400804, 0x00000070, 0x00000022, 0x00000000, 0x00000400, 0x00000000, 
	0x00000000, 0x00000000, 0x00001388, 0x00000050, 0xffffffff, 0xffffffff, 
	0xffffffff, 0xffffffff, 0x000000c8, 0x00002800, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 0xffffffff, 0x00000000, 
	0xffffffff, 0x00000000, 0x00014012, 0xffff0000, 0x00000020, 0x01860000, 
	0x00000018, 0x000000a0, 0xffff0007, 0x00000fff, 0x007c00fd, 0x00000fe3, 
	0x007fffff, 0x00000f70, 0x01fc01bf, 0x00000ffe, 0xfffffdc3, 0x00000fff, 
	0x00000020, 0x807c3fff, 0x00000fe7, 0x00010012, 0x001e12d3, 0x0003a781, 
	0x7dcd9c78, 0xd554780f, 0x3b99f799, 0xc9fceeff, 0xc90fe6e4, 0x100c0204, 
	0x1b4124c2, 0x28024a2c, 0xe0904277, 0x9a8a0e8a, 0x144ed175, 0x36ecac6b, 
	0xbf46ee2a, 0x8433bd6e, 0x13200930, 0xafc419fe, 0xac543f06, 0x6cfd1a5d, 
	0xe9f76d8b, 0x6b01620d, 0x4ad2dc5d, 0x180eb4bb, 0x6d8dba13, 0xb636e974, 
	0x7df7be54, 0x77b9b9cf, 0xf5b44126, 0xf3cbe7d9, 0xef73d7b4, 0xf39ee7b9, 
	0xeff7bfbe, 0xfe70cf79, 0xedf3f9fc, 0x5376308f, 0x86398dbe, 0xc631b319, 
	0x113eb834, 0xeb80ff86, 0x5b62c736, 0x6ff80efc, 0x3bc6f759, 0x6c3a7318, 
	0x8cbbdd6c, 0x3ebbb37d, 0x5d8c42c5, 0xd3ceb32b, 0x55353f70, 0x827afaab, 
	0x737257b1, 0x31907b18, 0xbf8d5fbf, 0x4c7bc1a5, 0x309476f7, 0x197391e6, 
	0x8ab1807b, 0xf2aa1feb, 0xabb8e64b, 0xe00fa89e, 0xe5664c38, 0xdc6253f1, 
	0xee97be34, 0xafbd19fc, 0x3f706956, 0xb155b5a5, 0x4a8cd065, 0xbc1378de, 
	0xe379aa57, 0x6247ce3a, 0xb63026eb, 0x66bb3d7f, 0xe7633e5d, 0xc0e67ac5, 
	0xc616e442, 0x8155c366, 0x53fc9feb, 0xc62ffb19, 0xbda536f2, 0xd84f9836, 
	0x3b75d4c9, 0x43073b18, 0x72f3c016, 0x775b2b3f, 0x9991c61a, 0xfe60cace, 
	0xb0c15ef0, 0xaf7c3758, 0xd78f7672, 0xaef307d6, 0xb6eb6d57, 0x3ad777c2, 
	0xf3cc1afd, 0x0ac59916, 0x257b42e6, 0x62eeeb63, 0x0b5919ec, 0xfdb5e0a6, 
	0x7cc6474e, 0x3578c1e6, 0xc6569df0, 0x0b8c63e7, 0x62bae4e3, 0xf7852d70, 
	0x0eae5877, 0xaec76d7e, 0xe0878f30, 0xadd7035a, 0x642ceda2, 0xceaeeeb4, 
	0xd0327de3, 0xa1c4f9c7, 0xd9c6195c, 0xd789edba, 0x77e65de4, 0x0fde7e9c, 
	0xe12772de, 0x9f61697e, 0xbe066dec, 0xa71873e1, 0x30e5ad34, 0xac1f9fb8, 
	0xbfe80e63, 0x765edfe0, 0x2f5cc357, 0xf721eb7f, 0x536338c2, 0x6025a624, 
	0x4cec531e, 0x9eb1abc7, 0xbefe3629, 0xfd8a9d71, 0x7d1a3be8, 0xc1e7ef07, 
	0x1ef89578, 0x29a567dd, 0x0e13ef5c, 0xaafe2159, 0xd453a9a5, 0x947534bf, 
	0x9aeb4320, 0x893e6692, 0x1a256b9e, 0x53326ae0, 0xded06dbd, 0xcffb75ba, 
	0x05d04799, 0x2a82cce8, 0x0ca2ff3d, 0xae977f73, 0x83e05e3d, 0x2ef7bf1b, 
	0xf344aee1, 0xf114b5d0, 0x25ca4b63, 0x72a77c1a, 0x52929af3, 0x2671ea20, 
	0x95b311f0, 0xfdd79832, 0x06ccb923, 0x7ad03ee3, 0xc87d94be, 0x17e747d8, 
	0x7ee082c1, 0xabeda590, 0x338d7ee1, 0x6fe30ed6, 0x665f3e1b, 0xf73bfe7d, 
	0x0f7ec61a, 0x94886eb8, 0xfb8ef832, 0x533734bf, 0xd4ae9319, 0xc66ebd4b, 
	0x4cc88e86, 0xf1660b7b, 0x2c0013d5, 0x1b79a768, 0xbe01a419, 0xde1ec287, 
	0x2ab6f28e, 0xd11a99b3, 0x2da99d45, 0x3ccff9a3, 0x76b77281, 0xdf019fbd, 
	0xdb0985de, 0xc3d3f780, 0x9ad83fe9, 0x1900ae51, 0x85f3c1f7, 0xb6878f1f, 
	0x0887884f, 0xc4dfba3e, 0xf79eb385, 0xf272156f, 0x846a09cd, 0x9def8ff0, 
	0x67b4f1c1, 0x6d8cdd92, 0x8f3bef11, 0x29867f6f, 0xd95e3d8c, 0x387b6aa3, 
	0xbc059e5e, 0x5c6abd38, 0x15fb894b, 0x8b812f30, 0x0ac5dc88, 0x6c75c7de, 
	0xfce075a5, 0x2da4e119, 0x7cc4c597, 0x60ebe5df, 0x7723841d, 0xf79cc4b2, 
	0xf95d62d3, 0x61ccddc1, 0x8d67f799, 0x109fade3, 0xe28c6fc7, 0xe266f558, 
	0x0d3ef998, 0x1e70bb8e, 0xade3831f, 0x0467c702, 0xfe1a2b8e, 0x4abf1c5a, 
	0xe31d9e38, 0x00faee38, 0x95800c70, 0xca97f736, 0xf78e219f, 0xe2da96bb, 
	0x26dea6f9, 0xe9bf433a, 0xfd3c6d60, 0x7a0bd58c, 0x5090647b, 0x40fdc5c0, 
	0x39b77617, 0x34af926f, 0xa06dd7dd, 0x1382a5a7, 0x62dd6927, 0xff73bf7d, 
	0xbd91d68a, 0x826bfbbe, 0x3fafdb0e, 0x2f503afd, 0x5e17b3b1, 0x88fcf64f, 
	0x9b8fb16e, 0xe83407df, 0x0b25f998, 0x3e7bb61d, 0xb8defcfd, 0xb466fcc8, 
	0x748499ba, 0x0bdeba06, 0x41be9cb8, 0x34bb43ef, 0x5af96e0d, 0xdeec1b44, 
	0x56975aef, 0xaefd7ca1, 0x84ccb0f5, 0x708bcbbd, 0x7205d53b, 0xe6702650, 
	0xf23a662d, 0x177c5cad, 0xeb0ca5ed, 0xe9a619ba, 0xa0da097d, 0x13563afb, 
	0xb40f753f, 0x988536ab, 0x0f18877d, 0xc838f7e6, 0x5c0f7e6d, 0xaa677afd, 
	0xf1f71cdb, 0x6f5c5d55, 0x4867b578, 0xaf51bc4f, 0x3ad10f4a, 0xea6e2cbc, 
	0x5ab25d91, 0x657e809e, 0x0024f332, 0x1cf05507, 0x9f319b75, 0x8af8dfc7, 
	0x7fc056ca, 0x8102d637, 0x9d9da8d8, 0x9b4f54c9, 0x9091f44e, 0x53cc2aee, 
	0xdaa27d23, 0x9eee7834, 0x5c1764c8, 0x8490ef59, 0x5275b6c6, 0x53b92309, 
	0xff63b21f, 0x6f2f31ed, 0xfec24d33, 0x67dc35cc, 0x85643903, 0x7c20f123, 
	0x3c1f2f27, 0xf49dc00d, 0x3a8ecd05, 0x225ab989, 0xbfa65db6, 0xf34caab0, 
	0x7f48c476, 0x38c07794, 0xc3e7100b, 0x342dde62, 0x2711e28f, 0x7758b7ad, 
	0x15ca38c1, 0x353e0e36, 0xf745c478, 0x51f91a83, 0x5c8049e0, 0xa02f2edc, 
	0xe0ff81ef, 0xd93d436d, 0x6ab32f5e, 0xfb0cbf1a, 0xe384dfc1, 0x13be69eb, 
	0x1595d24e, 0xd176f3f5, 0x9f176f10, 0x73e2ede5, 0xa1fa4deb, 0xced43a46, 
	0x1da477bf, 0xbe94b7bf, 0xaf8cadb3, 0x86ccba63, 0xf1e086f3, 0x8acc4581, 
	0xd48e585f, 0x29cafa0e, 0xe5fb5907, 0x21647cf0, 0x73c62d39, 0xe723d0e6, 
	0x217e341c, 0x46bc87be, 0xfa6bca7a, 0x36cf2802, 0x5bf3b3c0, 0x9906bff0, 
	0x01ef5139, 0xa790249e, 0x94806beb, 0xdaa89b80, 0x02f524d3, 0xed45e1fe, 
	0x5d7e7816, 0x6403e492, 0x239c80ad, 0x19f9c6d5, 0xf958168a, 0x0439436b, 
	0x7569023c, 0x975a5cf7, 0x7183fc8e, 0x1cbbf475, 0xe4282f2c, 0x157a8826, 
	0x4ebe0ade, 0x8f0b57eb, 0x1e147e70, 0x13a93a23, 0x84f6f04e, 0xa2d55d34, 
	0x345dbc33, 0x7f933ebc, 0x5aabbe38, 0x5e38602b, 0xc071e990, 0x92d7d0c1, 
	0xaf9b7b4c, 0xf2f00db3, 0x4403d176, 0x986c1657, 0xfca5fd85, 0xbfb0b363, 
	0x194f7673, 0x1e73fce3, 0xce78d38f, 0x83b47113, 0x1578eb2a, 0xe8feaeed, 
	0x2fba5cc6, 0x77e3891d, 0xbef07580, 0xed66294f, 0xe8b67d70, 0x5ac736ab, 
	0x96addc78, 0x72165d13, 0x8d16f83a, 0x75c30ccc, 0xe8698b87, 0xf533be57, 
	0xbe197691, 0x35887253, 0x6d8c4327, 0xe50ff610, 0xb39031ec, 0x15d542e0, 
	0x14977e07, 0x0bbc5732, 0xd86fc2da, 0xa126fd04, 0x2856ac5f, 0x1fb7fe38, 
	0xdff8d20b, 0x7844dfce, 0xa03a2d75, 0x77204038, 0xe0ab3fec, 0x7edfb63a, 
	0xc60d72e0, 0xc0f2bedf, 0x7ee40ce5, 0x2e46d7fb, 0x7b7f7f47, 0xf7dd08c3, 
	0xa849857d, 0xb998588f, 0xc1fe603a, 0x022e4c55, 0xd40414be, 0xf3aff476, 
	0x83612ca3, 0x3b31416b, 0x85e20eb8, 0xd3b63d7c, 0xbc15ef0d, 0x9ea3b4a1, 
	0x097dce65, 0x74147005, 0x82b6aaa9, 0x0f7240f8, 0x4b6ccab3, 0x6cd37ed0, 
	0xccd74f6f, 0x91fcf9a3, 0x067ae3cd, 0x6dfc36f4, 0x0fed093f, 0x7ea2eda9, 
	0x70f3ad43, 0x133e38be, 0x766dc3ef, 0xb58be30e, 0xfbd63bfc, 0x5407adc1, 
	0x09381cf6, 0x805f1039, 0xca677e1d, 0xbda3b53f, 0x950ee92f, 0xc17ee1c6, 
	0xb5b31d17, 0x9266a09d, 0x00ca04ce, 0x0dd69500, 0xb8bab8c3, 0x73fd26de, 
	0x937ce148, 0x107533ff, 0x706668db, 0xb1ab277c, 0x477d5e23, 0xd5f50c42, 
	0x15442350, 0x6883c337, 0xde20ef0d, 0xf2e11fd7, 0x3a7af255, 0xafdcf681, 
	0xe01b1d04, 0xfa02743a, 0x1dba0cff, 0x8d9021ab, 0xefe31fbe, 0x9847490f, 
	0xfb9005f6, 0x94394050, 0x7801d62f, 0x0f1137f9, 0xe25ff399, 0x4ba7a062, 
	0x476bab2e, 0x75725d7d, 0xbfab64eb, 0x981ea257, 0xde1e7e8c, 0xbd636347, 
	0x8f81f48f, 0x21f710f9, 0x5ed0fba6, 0xed5f5ff5, 0xf31f71e2, 0xe125fb0b, 
	0x609d273a, 0x26fb8c3e, 0xb87d531e, 0xcf77d28e, 0x0939446c, 0x08fd4c1e, 
	0x1fe0bcfd, 0x42f4967b, 0xdec9d4bb, 0x0fe286d8, 0xb3cb9dfa, 0x56792766, 
	0x1f7d275e, 0xfae6129e, 0xd23ae7a1, 0x2a3d5fe7, 0xdaae7d0b, 0x8a6287d0, 
	0x29bd209a, 0x56e307ab, 0xc74ce07b, 0x8fa868a7, 0x2f7e1b35, 0xf4907f2f, 
	0xed0e85af, 0xabc047c8, 0x963c034b, 0x6bb52adc, 0xb78298a0, 0xc86b26c7, 
	0xd11837ef, 0x2a18d829, 0x741bbc46, 0xfb91fdf0, 0x8d30d5a3, 0x78842017, 
	0x92e26208, 0x5be87196, 0x017d1127, 0xf8ad9367, 0xe80afe0d, 0xc7c9a6fa, 
	0xf32fc3e0, 0x5eedc6b6, 0xa265e5b0, 0xc82e4173, 0xe7b1c80d, 0xed095eba, 
	0x5951e22f, 0x05d8f1c6, 0x891bf9fc, 0x7ea5abfb, 0x9b3a8fe1, 0x9807e813, 
	0x02f578f3, 0x38196538, 0xbaf77df5, 0x1b2a7171, 0xce055538, 0xb29c0c1a, 
	0x32869c2c, 0xfa223a71, 0xaa5c0b0f, 0x11e9c017, 0xcfd4e385, 0x1219e5e3, 
	0x722c538f, 0x47f44ed6, 0x18705a7c, 0xc73e7c44, 0x993db3ef, 0x38c559f7, 
	0x9625bcf8, 0x38464f85, 0xf1c23a9b, 0xd9b06539, 0x5cec08b7, 0x971c6bc9, 
	0xd9547f25, 0x4bafa00b, 0x63da3d1d, 0x97071c7f, 0xfd69e7ad, 0xc59abfe5, 
	0x2e032871, 0xf769bda1, 0x69e7a224, 0x1d9cc44c, 0x75eccf8b, 0x0b980415, 
	0x52b064f5, 0x5c95dc25, 0x2bb9231d, 0x9e9461f8, 0x2e9edc97, 0xb5dc38fa, 
	0xe432ee21, 0x7e42e9da, 0x3c61f307, 0xee2096b8, 0xe4b47a2c, 0xc13b8123, 
	0xddc41297, 0x2577130a, 0xfefc3b88, 0xf93b8e52, 0x4051e609, 0xe84f3c2e, 
	0x6fd82172, 0x5227afd9, 0xdbbcd077, 0x98960053, 0xe0ec9fc0, 0x1bcd1e71, 
	0xd06e4afe, 0xea0f6954, 0x04a49085, 0xed1ff9e1, 0xe78e1489, 0x1bf40965, 
	0x20fc1fbd, 0x157c7281, 0xc6213a7e, 0xbdec7d01, 0x3c0258f5, 0xa4c39002, 
	0x7c3cc12a, 0x7e8c91de, 0xc1253abe, 0xf15ca1b6, 0x994cefe7, 0x2a768ed7, 
	0x513c2678, 0x7ec97ae2, 0x6299f10e, 0xbfd827a4, 0xc489fa8f, 0x9074f41f, 
	0xd5cf8e5f, 0xb2361c38, 0x15cc0e77, 0xafdd0549, 0x534338e0, 0xa3cec9ba, 
	0x3046de7f, 0xa337f2c9, 0xe1ef88a7, 0xef9cb589, 0x77d29627, 0x2278fdf6, 
	0xd9a4371f, 0x64ff5599, 0x88039bf9, 0xc2efb40b, 0xc06164ef, 0x27ec2ec5, 
	0xf78f884b, 0x4259fe8b, 0x57772c3b, 0x5466f6b3, 0x899fba67, 0xbc79d6e7, 
	0xb718945f, 0xfe3807df, 0x618f84fd, 0xf3811adb, 0x793fd85d, 0x1cb97181, 
	0x1e6ee39b, 0xf8045fb7, 0x8eb03ec3, 0xa87f92ab, 0x7e460780, 0x8136b85a, 
	0xe7b113fa, 0xccb1ff00, 0xc3375315, 0xbfa266fa, 0xaf3e2ef2, 0x88f5b768, 
	0x7fac24fc, 0xba69ece6, 0xdfef09ad, 0xef86d3b7, 0x05d6baa9, 0x5adc97eb, 
	0xcbf81370, 0x5c660277, 0x4178d0f7, 0x45981be2, 0x1a3477a2, 0x087074e4, 
	0x81e30ffd, 0x41e90d9c, 0x46a4ab8a, 0xfbc1571e, 0x8f048bba, 0xd7fe9079, 
	0x28e548b5, 0x26b7d7e7, 0x954f51ca, 0xf285bfa1, 0x8e5a84fc, 0x7d42cbcf, 
	0xff79f133, 0x703a5bf4, 0x7d16cfbd, 0xea7cc243, 0xcbbe9af6, 0x41e13f85, 
	0x903b28f9, 0x0e21dacf, 0xe89deb2d, 0x9fd700d8, 0x095fffd5, 0x50b2b5fd, 
	0xe516f29c, 0x940e5e8b, 0x55f583ad, 0x788cbde6, 0xff16e432, 0xc09c51d6, 
	0x148f504a, 0xfa8da0ca, 0xc96aad91, 0x97afee09, 0x504e29a4, 0xf1e19e27, 
	0xee61c4c2, 0xe11a4ec7, 0x06fa49ed, 0x211e976a, 0x3d2f474f, 0x4f93dbc6, 
	0x34e4f6f0, 0x6729d55d, 0x30ca7b78, 0x84753e7f, 0x32eaa7b7, 0xe84743b5, 
	0x258e87aa, 0x04ed3da9, 0xf34b4f6f, 0xc0cfd3e7, 0x76a6dfb5, 0x7bae037c, 
	0x984b1fa5, 0xf05c7c57, 0x0955667f, 0xa2edebad, 0xffdc489f, 0xbff8668d, 
	0x653cd7cb, 0x0e22bff8, 0x5671fc31, 0x4bb79c72, 0xc4f6f24e, 0x389ede7e, 
	0xce93dbc4, 0x73a4f6f2, 0x887a5dbc, 0xbe95afe6, 0xf936574e, 0x3e4f6f38, 
	0xfa53dbc9, 0x10ca7b79, 0xcb3d4f6f, 0xf1cf53db, 0xad10e876, 0x4ebd0b4f, 
	0x38ed3657, 0xc93b4f6f, 0xe9fbd3db, 0x033f4faa, 0xd92be5d7, 0xba62e4da, 
	0x6c4f5032, 0x2eb65cf9, 0x795d0af9, 0xa1b354bb, 0x8cbcbeff, 0x9e833679, 
	0x9f50be5d, 0x50faed49, 0xb822a6c1, 0xd413d5ae, 0x0dd0b01f, 0x2abe5938, 
	0xe7c49a5d, 0x274ad3ab, 0x3fa4dff6, 0xeb87ac92, 0x66c1f676, 0x958daf1c, 
	0x79a11c6c, 0x5e80481c, 0xc1ff005b, 0xcd9a45f3, 0xa17f6b88, 0x496c3e11, 
	0x89cc23d2, 0xc9c1ab76, 0x9ac2d2fd, 0xbbcf1978, 0xc42eb66b, 0x2e644d53, 
	0x4740d3f9, 0x386147e4, 0x9ded02b6, 0x0153c8cb, 0xfbfc448e, 0x6d5f4c3f, 
	0xb3a710fa, 0xdb51ac34, 0x994f718e, 0xdb9b441d, 0xc3ca2747, 0x4d991bdc, 
	0x51a8823b, 0xd407a86d, 0x7bcf1b61, 0x63adaa28, 0x01efef17, 0xf7845c79, 
	0x74fa7077, 0xf62bf094, 0x8798e7c7, 0x41543868, 0xdba40af9, 0x9e665d9e, 
	0x3eb2e210, 0x167037dc, 0x3c98be86, 0x95fa7944, 0xcb8a328f, 0x4adadcde, 
	0x00ee1df3, 0x66e0d4e5, 0x3ab7d13a, 0xb7d21f7d, 0x07c61721, 0x7d2c367a, 
	0xfa01e6d8, 0xa0ef812d, 0xec586f5d, 0x346b57b5, 0x04f31c6e, 0x827a3543, 
	0xcdaa21c7, 0x406df401, 0x6ee9c7bd, 0x857bc38b, 0x4eeff01a, 0x6c2eaf3e, 
	0xb4e95c8f, 0x570ddfc6, 0x11b7665f, 0x909a7adf, 0xb1dfa36f, 0xf86efb33, 
	0x7546bb8e, 0x34aa7d92, 0x1cdba3be, 0x449617a0, 0x68c7da55, 0x38ddfa58, 
	0x1f0697da, 0x1d6127b3, 0x49f70d57, 0x8c99dfd8, 0x899e59db, 0x0ef448af, 
	0xfee3733f, 0x40eeba8a, 0x4dc9fc9c, 0x44170fa8, 0xe80a4755, 0x2b69273f, 
	0x30ab3f45, 0x8d69c8bd, 0x2f0ddfff, 0x3f38c875, 0x89abc334, 0xace1328f, 
	0xce34fe26, 0xf3294e77, 0x7b534fc4, 0xccadd207, 0x79c26eaf, 0xbd35094d, 
	0x965c0765, 0x09b15a6d, 0xdcf615fb, 0x3e7c13f3, 0xfc8bb3a7, 0xccfcdb83, 
	0x65abf983, 0x8d36a837, 0x41580ff4, 0x43aab7d4, 0x22796dd8, 0xdc0995b6, 
	0xf77e7d3e, 0xd7da38ae, 0x9869c9e9, 0xbef3603b, 0x442da1f9, 0xcec952b8, 
	0xa1207b82, 0x5ab9aa1e, 0xee173c5a, 0x87a3f35f, 0xcd0841d6, 0x39b31fe6, 
	0x64abbdf0, 0x9251a1dd, 0xa49e735c, 0xa5e85cf8, 0x2225d39e, 0xfb91308f, 
	0xc97aa387, 0x34fd4fd5, 0xefef10d7, 0xafd70b3e, 0x82bfb9d8, 0x20943c13, 
	0x3ef8c87e, 0x768dddd0, 0x75805964, 0x14bebae0, 0x52f61786, 0x05e4385e, 
	0x0caf7f7d, 0x94e8088e, 0xbaf90adb, 0x27c48d17, 0x32aebfa3, 0x61f21a69, 
	0xbcf4cc8a, 0x644e38d5, 0x2a6ff232, 0x9ec05ce6, 0xf753394f, 0x6017ee0c, 
	0xcf6ace5a, 0x6f5a2d9e, 0xd863fb47, 0xaec259b5, 0x7b01aacd, 0x6be37a86, 
	0x668edf60, 0x61360de4, 0x26ce60de, 0x87b2735b, 0x3ced47b1, 0x0de46eff, 
	0xfd542ce6, 0x539ddf98, 0xcdc05708, 0x6f97e11c, 0x41bc8bb3, 0x7e4147a3, 
	0x58a4765c, 0x09e00de4, 0x3dd70bf8, 0xbcccddf2, 0x97cbf941, 0xf6fe306b, 
	0x5e5e1fd9, 0xf6e37e03, 0x7ca43fab, 0xd7afac01, 0x70780436, 0x7fa0f41c, 
	0x711d5e59, 0x93884d2b, 0xe03cf6f8, 0x97076ae7, 0xc38732f3, 0x6c05798d, 
	0x3334bfa3, 0x7ae3736c, 0x1b5d75c2, 0xf84f5864, 0x783617ea, 0xfa7a1e50, 
	0x2f303c84, 0xe5039dca, 0x57e26ee1, 0x25cfce0e, 0xa40af0e4, 0xce66400b, 
	0x217d87da, 0xbf63dfcc, 0xd4374141, 0xc80fc28b, 0x65ec37b9, 0xcb7fd00d, 
	0x005799d1, 0x113d035f, 0xe171c2bf, 0xbd20764f, 0x403bb05f, 0x7262732e, 
	0xf134028e, 0x939d59df, 0x7b7ef607, 0x2fe758af, 0x05817f0c, 0xe8305fd0, 
	0x1e0fc57a, 0xdfa1040a, 0x00f1bd15, 0xfa1e69f2, 0x7fd0a711, 0x6ff11ef8, 
	0xf713fa1e, 0x47ee7de0, 0xbf51fcd0, 0x266df739, 0x16a557b9, 0xfafee20d, 
	0x8c52d56f, 0xe5aa1436, 0x2d708079, 0xbaa86c7d, 0x3557c796, 0x12de22b5, 
	0xf3c41bcf, 0xd41bc8a8, 0x1181bc88, 0xfe8b358f, 0xab7fa22d, 0x7689afe8, 
	0x6253b452, 0xbfd16efc, 0xf1f7b447, 0xe8bd83b6, 0xe8733f41, 0xf3afb884, 
	0x1e31caf7, 0x7f39b5fc, 0x6b2d5e7d, 0x9d25f7c5, 0x685f6cfc, 0xf606d2b1, 
	0x77d423f1, 0x1cc2c380, 0x44f30cb6, 0xfa0bbec6, 0xb16aca49, 0x22d732bf, 
	0xf89fffaf, 0x3f28234b, 0xdfb807a4, 0x63b7aa04, 0x912eae08, 0x710d5f67, 
	0x633faf9a, 0x27b41efe, 0xfb0cbac6, 0x8bf62654, 0xd09ddfc1, 0x5fde6251, 
	0xbb79e0e9, 0xef9e76f3, 0x7214b6ff, 0x57b63fa0, 0xd2574a9a, 0xe55fb80f, 
	0x74e51c76, 0x9da067d3, 0x066d1497, 0xfa0b6ce2, 0xee344dd1, 0x1aabd20c, 
	0xe36af113, 0x73f7ee0c, 0x98287a3f, 0x5425f7c7, 0xac6bde11, 0xebefe34c, 
	0xafad34ae, 0xfd0788ec, 0x83877cc0, 0x465eb6ec, 0x6ecc8d71, 0x9c7902ea, 
	0x3bdd1ff4, 0x5dffe014, 0xbe781f38, 0xed89defc, 0x6eb8af28, 0x7e8137dc, 
	0x9089789e, 0xff31fbe7, 0xe209fd13, 0x893eea7c, 0xe721b9ec, 0xe83bed37, 
	0xfd453e6e, 0x1e6bfa7f, 0x14f4ffa7, 0x3084ebcf, 0x02af73af, 0xce3f5501, 
	0x2c30e803, 0xad01f7be, 0x5967c68f, 0x45b3fefe, 0x6cdf3415, 0x7dfc9fbf, 
	0x0beeff9c, 0x1b32c7e8, 0x732f55e5, 0xb2c7ea64, 0xd01df085, 0xbfa0654b, 
	0x89963f51, 0x873ceabc, 0x5ab18fd0, 0xd1beabca, 0x47e850b4, 0x7e8e3278, 
	0x680fb074, 0x45e7f09e, 0x2faa337b, 0xe08f401b, 0xdc33803e, 0x659bf389, 
	0x5b7453e4, 0x5572068b, 0xffc844bf, 0x3e5cf9b1, 0xf2e7cc4f, 0x33ed1699, 
	0x9f3c3da2, 0x7cc8e1cb, 0xbda2af21, 0x457bb44f, 0x3fa203ff, 0x0b2b7213, 
	0x7f45d6f9, 0x1aadf626, 0xd0a8f3c4, 0xfa3e6207, 0x5bda5aa2, 0xeee7951e, 
	0xc8ada53a, 0xae28e7e4, 0x7df32a99, 0x88a72656, 0x757159af, 0x5bb508f8, 
	0xb7953abe, 0x6beae2b3, 0xb88c8963, 0xb55bb97a, 0xcf9863ed, 0x1c612f83, 
	0x147cf222, 0xf9129f4f, 0xf7bf9e3e, 0xcd3eb9c4, 0xd433fba7, 0xe130ed0e, 
	0x7fe90f37, 0x896f384d, 0xfefbc71b, 0xb3d60f52, 0x0179452c, 0x54b3313b, 
	0x96de20f5, 0x2f81fe22, 0x28bc17ac, 0xf26f33b4, 0xa5f801fc, 0x593f3879, 
	0x85f919b7, 0x617e6b7c, 0x51e3c928, 0x38d02fdc, 0x8087f319, 0xbee15216, 
	0x60e020bc, 0xcbabb0a6, 0x21abf137, 0x9f408fef, 0x457e61ea, 0x5cf9767f, 
	0xb3367095, 0x0893d450, 0x12916d9c, 0x29c7ac0e, 0x41e69b2b, 0x541a875c, 
	0x0868e20f, 0x7f705e37, 0x2df041a5, 0x4d9e51a0, 0x16fbe06a, 0x7f24a45b, 
	0xb747664f, 0x721b7d83, 0xf639e925, 0xb7477cc7, 0x0716d798, 0xba0dc3cf, 
	0x5f703b37, 0x8f87a87f, 0x35f1136b, 0xd23cefd0, 0x0e27530f, 0xfb59b7b4, 
	0x8295b845, 0x743649fb, 0xe7c25f54, 0x93f732b3, 0x138e3ec4, 0xf92723fc, 
	0xf21f7ac9, 0x5679f687, 0x54eb3c93, 0x6aa653b7, 0x99e71571, 0xd52798ca, 
	0x803fa113, 0x516947f5, 0xacda743f, 0x357e626b, 0xa5f39a7e, 0xe8276cef, 
	0x01581820, 0xbac6113d, 0x13d614a3, 0xf5e0e73d, 0x7a8ca144, 0xf070ffa2, 
	0x5fb9793c, 0x89eb5af7, 0xa9f7135e, 0xec4ba88e, 0xc25e020b, 0x1137a70e, 
	0x31437512, 0xfe044f51, 0xd8dcf4de, 0xef10ed9e, 0x2bbc9149, 0x150881f2, 
	0x367bd38e, 0x9e187c41, 0x1eb4c36d, 0xf887ec5b, 0xd9b62965, 0x0bf00efa, 
	0x9e7b65c2, 0x34bf06ee, 0x3d63685c, 0xe7bb8e1a, 0xc3178c69, 0xc7cedb0e, 
	0xc98d78e3, 0xf0db805d, 0x24ae3ddc, 0x26f0a9d8, 0xc78dba9b, 0xc4077a8f, 
	0x0eaae7e6, 0x3aa03d92, 0xcbcd3493, 0xf185980f, 0x4f307d61, 0x77e0b5e7, 
	0x7ec38e00, 0x8a178de6, 0x557fe0fb, 0xb09a7ba8, 0xd2e5a108, 0xe1cf88d7, 
	0x32f7ee0b, 0x2fddefda, 0xfd78f970, 0xfbdfb75f, 0xb227614d, 0x9f697bf7, 
	0x7bee6537, 0xeefd0dbf, 0xbdf7316d, 0xbf8c779f, 0x97cc6def, 0xf83bbff6, 
	0x348fd13c, 0xef8dbbf6, 0x7bbf6c5d, 0x5f515cf1, 0x3ee3c3d3, 0xca713bb0, 
	0x2caccb97, 0x2729f985, 0x3abb67df, 0x69f1e4e4, 0xfb63e473, 0x3dfaab9d, 
	0xcefda9d9, 0xbfce08ba, 0x471f55c7, 0xf790d7bf, 0x3f9e0ea3, 0x9a18ae35, 
	0x62b77e60, 0xd6bd9fe4, 0x639f10f8, 0xa5cb455d, 0xd00f2220, 0x35cea23a, 
	0xf1a847e8, 0x2eff18b7, 0xcbb75ffa, 0xccfbf480, 0xd670eb7d, 0x2754f5be, 
	0xd1e8871f, 0x4e7dfd82, 0xe3d94fb4, 0xf7f3f36c, 0x87dfd003, 0x340392f3, 
	0x9723a76e, 0x1b5f8fae, 0xc7a67aa7, 0xc72bfd85, 0xb97a96fe, 0x57fd6265, 
	0x5e31ab89, 0x16762e44, 0xaaf287dc, 0x1d603d12, 0xff10f2c3, 0x24df5f0e, 
	0x9f1fdf27, 0xf8c2f34a, 0xf600f51f, 0x3e32f9e3, 0xf729f63f, 0xb3fe0dc7, 
	0xbdf1fdac, 0xe227f761, 0x7fa162e3, 0x738b862f, 0xa2779f55, 0xdf90a61c, 
	0x951f395b, 0xe8f93287, 0x091fe781, 0xe3b16dbf, 0xe5ade193, 0xee88abd2, 
	0x3525b758, 0x2d2dbaf3, 0xbad7a968, 0x711aa23d, 0xaafe5590, 0xf28bdd64, 
	0xd7c9c137, 0x8bd6ea0f, 0xedf8f5f2, 0x53b9710f, 0x77e1dcb9, 0x05b28fd0, 
	0x05ba1959, 0x797167d3, 0x8cbcd8bb, 0x4efdaaba, 0x725ea329, 0x4dfb9395, 
	0x78f7ae06, 0xbfa39736, 0xf005f8f7, 0xa2c83fbd, 0xba70d613, 0x558384c8, 
	0x3df30384, 0x7d442599, 0xd789b45c, 0x3e614593, 0xa575c24b, 0xfafb9051, 
	0x828de490, 0xc9c47fbd, 0x4f1f2ceb, 0xef5f1216, 0x308df686, 0x2974d75e, 
	0x2c3a024f, 0xae1e6a61, 0xbbc96edf, 0x7eb2eb5a, 0xc27bfee7, 0xd71dd6dd, 
	0x38844c96, 0xc9e36ba2, 0xd6bfa39f, 0xb2caea25, 0x7f307beb, 0x583ed0a6, 
	0x75fdd935, 0xc9df514e, 0xfb4528de, 0xa56d5616, 0xd68e87e8, 0x75a5fd61, 
	0xcbbace57, 0xbf7d70b6, 0xf28133af, 0xfda27711, 0x88da35b2, 0xffcfd95f, 
	0x891feabb, 0xe4e8ff7e, 0xd5ca9e72, 0x748dbeaa, 0xa8224676, 0x47102b37, 
	0x6f2f1c3d, 0xe3573d93, 0x3a1075d9, 0xeb46af8f, 0x63b34057, 0xae847c3b, 
	0x2758f87a, 0xf04e2bb5, 0x3f9a4576, 0xdbc33caf, 0x79fcc395, 0xf2ba39d5, 
	0x4e8be2fc, 0xe467ef23, 0xe21f5519, 0x4389f2ab, 0xc4da6f01, 0x43f0a54f, 
	0xfd330b2a, 0xa71772a3, 0xe38b9e6f, 0x1f90d2a4, 0xfed3f355, 0x3af9aaa6, 
	0x78040ea8, 0xe3bfcf06, 0x66e49a79, 0x9fdf2976, 0xc9babd9a, 0x153e036b, 
	0xb093fbc1, 0x5f8c4eee, 0xe259c461, 0x79e04b3b, 0xbd73be08, 0x98855ef8, 
	0x8ec67ecf, 0xd6dabea1, 0xb64cbe7a, 0x67dc35c8, 0x6ddf801d, 0xe497aa6d, 
	0xe626d406, 0x78b8a72d, 0xa325d09d, 0xd52a9b75, 0xe2e65d63, 0xd70dc07a, 
	0xfd1be714, 0x5fe350cd, 0xef8477be, 0xedb6e093, 0x87b48ffe, 0xb13688b7, 
	0x23e5e989, 0xc6afbc1e, 0xd1bb8f91, 0x7e83dd5f, 0x7989d6ad, 0xafe8dd8f, 
	0xabfa1886, 0xda5f28e5, 0x957f51d6, 0xfe2c49ea, 0xbfab2cea, 0x68e767fa, 
	0xf9f28b3e, 0xbf728b5f, 0xe56b7258, 0x31fec7df, 0xc3d419e9, 0x1d375161, 
	0x74fd7e16, 0xac1e7380, 0xbe4e27fb, 0x27f9069e, 0xeaa1ef44, 0x37ff6cbc, 
	0xa070887c, 0x78e75f85, 0xdbce38a8, 0xbb792715, 0x2bb79fb2, 0x021af087, 
	0x97720fbd, 0xf675ad5f, 0xab9500c1, 0xa76cf9a7, 0xcc744e48, 0x56becea7, 
	0x23f055b4, 0xdf001d79, 0x7d8cd28f, 0xce4fee21, 0x08db7ac6, 0x1a6369e6, 
	0xda1157e6, 0x9f92afe8, 0x95fa6439, 0xb592435a, 0x107c8439, 0x6b3fc0ff, 
	0x78a6f4e2, 0x7289e805, 0xa4f3d06e, 0x3e6cf390, 0x3c598f40, 0x1c7e00ce, 
	0x77dd38be, 0xe89af88b, 0x1fb1873d, 0x027c8d3b, 0xc78e759b, 0xccffa4f1, 
	0xd630b179, 0x5cdd925b, 0xef91e5cd, 0xe4e1680f, 0x30fef132, 0x24c6c8e2, 
	0xf18757ee, 0x00fcd9bb, 0xfdcdeabc, 0xbd8a1fdc, 0x9c7e7174, 0xf883f614, 
	0x4fad7a42, 0x9c3cc66e, 0x866aa91a, 0x15f3adf9, 0x412fd0b8, 0xcb78c679, 
	0x53ef9939, 0x26692f38, 0xef07db79, 0xade51e7f, 0x8691c84c, 0x0fae1289, 
	0x98ab4fd0, 0xe483e5cd, 0x24eefd07, 0xe5332f3c, 0x5f025be8, 0x2ea9ee83, 
	0xa225d7c4, 0x82cc18ae, 0x3630f10f, 0x7672e13e, 0x9421d840, 0xe7a75137, 
	0x150a73c3, 0xc40fe07e, 0xbb2b1512, 0xaf21d13a, 0xa3e786bc, 0x712efb97, 
	0xecb41fd9, 0x97d75c1b, 0xeb166aeb, 0x07e975a0, 0x772fc1bb, 0x7b9d604e, 
	0x4e9d2841, 0xbe46db7d, 0x59bcd07f, 0x58dafb42, 0xbd7ae3ca, 0xb1a3d794, 
	0xc6b7e252, 0x35f72ef3, 0xefc8634f, 0xc02f1007, 0x26e696ef, 0x0fd8f305, 
	0xbd2d2c2a, 0xc941f684, 0xff40c3c8, 0xafef1b76, 0xbf9fc0bb, 0xcaf56944, 
	0xdeb93e1b, 0xcde1bf80, 0xb1af3c09, 0x8b798bce, 0xdddbac4a, 0xfa1af5c1, 
	0xdbfe8675, 0xe0fdc2df, 0xae96b0fd, 0x31eac697, 0xcfa8fe83, 0xa6895ce8, 
	0x2edb6997, 0xa2edefde, 0x95d51746, 0xa259d129, 0xe90ca27e, 0xbb85fb42, 
	0x31a3fb2c, 0x3cc42e7e, 0x6e79923f, 0x5cc723c4, 0x7b0190fc, 0x17b8b7e6, 
	0x6e388219, 0xc5de7997, 0x14d48bf4, 0x1bfe45f9, 0x48884852, 0x7b303825, 
	0x7eec752c, 0xb43f2155, 0x41140a54, 0x7b9fd3dc, 0x5c40a287, 0x27b08af3, 
	0x6fbfef11, 0x3232b8c1, 0x7ac5cf5b, 0xc7f408ef, 0xfaf17bf8, 0x07e60aa5, 
	0x364df522, 0x823f7c1b, 0xaf0068e7, 0xb3432a8b, 0x5dd61159, 0x7bf057ac, 
	0xb78e6e25, 0x16fa7545, 0x1c0c8b8c, 0x5e9cfd99, 0xe16e17ec, 0xfde65bfb, 
	0xbef17357, 0x8eedcddf, 0x99188751, 0x911df3cf, 0xfb42aa89, 0x22cfe0eb, 
	0xa54c22fd, 0xcec3bc3c, 0x38a43271, 0xbe4b355a, 0x5014ac26, 0x9417e13d, 
	0x017f6b20, 0x2dc4eefd, 0x2b082798, 0xce7d4493, 0x9f5e56fc, 0xc13ff223, 
	0xfc2dbc05, 0x29798641, 0x3cf6ff78, 0x796eaef8, 0x2ecfa1bf, 0xe48268ea, 
	0x15f434df, 0x5fa97e20, 0x2833da8c, 0xd5b06cce, 0xa98ed04b, 0x63b9db80, 
	0x5f0917e7, 0xd4d3b0af, 0xcff6356f, 0x5fdc0f9e, 0x8189df8b, 0xe7dd6038, 
	0x6adb5a90, 0x7db147cd, 0xae3fe495, 0xe90269bc, 0x9d7da1d5, 0xbaafac11, 
	0x8b2d4969, 0xebdf8256, 0x3cf8a3a8, 0xf8bcc0a2, 0x5fd8c56b, 0x4df3c45f, 
	0xd0167ce6, 0x25976f7a, 0x59f30ed6, 0xed6c87a5, 0x1f3b1adf, 0x28bd4ef0, 
	0x7aff5fc7, 0xa4efcf25, 0x67cc67e7, 0x15a13a28, 0xaf5fdbf3, 0x9be165ab, 
	0xaf30fd04, 0x22a368d0, 0x182ab87f, 0x2435c12f, 0x7ee2d5ae, 0x1641ae94, 
	0xe2635c2b, 0x4918dc25, 0xfe3cf449, 0x169fe8a6, 0x4fec61d7, 0xed4b5fb8, 
	0xe333eebd, 0x61eb07d0, 0x1f878d4f, 0xe57e8c56, 0x134fc527, 0xf20e67e2, 
	0xf285ba5f, 0x647e062d, 0x9e3a0bc0, 0xbc4f9169, 0x21567e00, 0xfbcb542e, 
	0xe10fc017, 0x519782c6, 0xcffc18fc, 0xdfc19f9a, 0xcd64fc51, 0xe14ffe07, 
	0xb11c73e3, 0x32525f7d, 0xaf4592f0, 0xcce4fc51, 0xbcd0fc27, 0x7cd38115, 
	0x9714a381, 0xd1c38fcb, 0xcc11c42a, 0x8e060beb, 0xbd15e7b2, 0xd1c0c949, 
	0xe47005c8, 0x04702f9d, 0x451c05df, 0x02228e04, 0xa3811147, 0x4451c088, 
	0x859228e0, 0x51c088a3, 0x2228e044, 0xc2c91470, 0x91c0c451, 0x471b3f3c, 
	0xd0da7999, 0xba17aa11, 0xd114c4e2, 0xaaea95be, 0x85d323d2, 0xdd51a37f, 
	0xc4ff59a0, 0xf2f2dfeb, 0xf35a3341, 0xd70f58b4, 0x66d3c964, 0x34f1a77f, 
	0xa706e7b5, 0xf5ae7f70, 0x9acefa41, 0xf22e7365, 0xfd8ff29d, 0x0be4538e, 
	0xe2f4cec9, 0x88cf43fa, 0xb4718a73, 0x0cd2ff3f, 0x99a8f9fa, 0x738a745f, 
	0x308f648a, 0xd435822f, 0xdfd3dedc, 0xe3f65cf4, 0x1d395ac7, 0x35e51a63, 
	0xc12e8f5c, 0x99de8bfc, 0x7a69bf02, 0x4153cf31, 0x3f411cfc, 0x7a8e6a65, 
	0xa99fda0d, 0x3b339785, 0xb9bb69ee, 0xae2059dd, 0x5fb9b9d7, 0xeeb954f9, 
	0xdc1b3f45, 0xccf7d246, 0xe70c7e19, 0x2aa23553, 0x8f31876d, 0x3e505716, 
	0x0f33b156, 0x7ee1a6da, 0xfc7ca31d, 0x64f9fea1, 0xa6ac9dff, 0x8e5fe498, 
	0x71150e28, 0x32fdf22a, 0xdc2ae1c7, 0x7cc7b857, 0x9f9c1f4f, 0xdd8fc799, 
	0x5372fb4a, 0x3de1b771, 0xefd14f98, 0x9cffe4dd, 0x173c0165, 0xed5c3155, 
	0xe78d50d8, 0xda20f4b5, 0xd8e1c585, 0x7f701c4f, 0xc5cb908a, 0xe51f6ac3, 
	0x7f226361, 0x34fe00d0, 0xe5299de8, 0x93cbf93a, 0x069580cf, 0x6eb9363e, 
	0x5f5da373, 0xb0250e1c, 0x6642bf9e, 0xf25ccf21, 0x6f58832f, 0x8803e530, 
	0xc5bde132, 0xb87fb92b, 0xc15cb3c7, 0x1c3fe0fb, 0x0ae07dc3, 0x164de756, 
	0xd85db630, 0xe91ce35d, 0xaf9e6e9b, 0x8bff93fd, 0xbcf2f1ee, 0xb9c6dd07, 
	0xef3cccd1, 0xf271ee0b, 0xcbc75bbc, 0x88fcf2ef, 0x86a27134, 0xd702bc76, 
	0x5bdc6d0d, 0x17fbff44, 0x133f3e62, 0xef8a757c, 0x9ff4ba6e, 0xce5e78dc, 
	0xe78a5f38, 0x8f200347, 0x9c79b88f, 0x350b9c68, 0x721a03ce, 0x638c47bc, 
	0x052e5b5c, 0xfd8fbce4, 0xca1f9c6d, 0x8847e21c, 0x63f065f5, 0x250fc1ba, 
	0xa63f2e32, 0x934c7e0b, 0x5b1f82e3, 0xd31f963e, 0x44fcdff3, 0xcc43b8fc, 
	0xb75c8c73, 0xdd76a71c, 0xf66ea295, 0x5c91dfc4, 0x8df94fef, 0x901739f3, 
	0x5e6937eb, 0x73eb9217, 0x31b94f55, 0x59e466ef, 0x486ef3b3, 0xd4338c5f, 
	0x43e7df00, 0x3c0294fb, 0xf3dd537f, 0x781f0294, 0xcfae947e, 0xbd415d13, 
	0xbc5dc4b3, 0x865bcd1f, 0xaf9f80fe, 0x59f0dee3, 0x3ef82f93, 0xbcace5d9, 
	0x37912ef9, 0xe6f225df, 0x77f18af7, 0x7ca0afd5, 0x4aaf2edd, 0x175df379, 
	0x7919dbc9, 0x41dbca73, 0xfbe235a7, 0x77f2b2bb, 0x1ff379d9, 0x8bcf33ba, 
	0x593fbb35, 0x775efcde, 0xf8dcde66, 0xe6f2c5de, 0x4afc9c86, 0xf7bd0fc8, 
	0x4071e601, 0x7d68c67f, 0xfcfe78e5, 0xe4241976, 0x18cf3301, 0xf44e7f91, 
	0x17f4b96e, 0xfdf79e6e, 0xccb3fb95, 0x67f31afb, 0xc95f7959, 0xc26e15ad, 
	0x6759a0dc, 0x873d685a, 0x1645d864, 0xd6b42e6a, 0x5a38de9b, 0xc24daa57, 
	0x1023e8fe, 0x4986d43e, 0xb8857fb4, 0xe82efc45, 0xf8728dde, 0x81c561f7, 
	0x856d8a79, 0xeb08bf7c, 0xb6ffb012, 0xaccbe733, 0x457bfcf8, 0x877c949d, 
	0x59907fb1, 0x50f40f34, 0x2ea082e5, 0x93aaf3f1, 0x5ff6fbac, 0xac15ef86, 
	0x1a4bf3e1, 0xf7186679, 0xb6ab32cb, 0xd6b9d195, 0xb518c29c, 0x56efb863, 
	0x6ec4e0b9, 0x37f665d6, 0x4f9c65d6, 0xe62a7e87, 0xbf7d8c6f, 0xfbec6c80, 
	0xf6f1e5f9, 0xa47ff6fd, 0xa20e317a, 0x20b3ca3c, 0xbebcf567, 0x7b29f290, 
	0xf2335e49, 0x4868ae30, 0x4eee057d, 0xb3e57185, 0x569e2758, 0xcaed097f, 
	0xea1a4d95, 0x8f312ae3, 0xda5df14a, 0x9d134bef, 0x0c9d23ce, 0xd3cecb39, 
	0x5ec59f4c, 0x6f7b75c3, 0xdc479e50, 0x3f0e6de6, 0x1be9f68f, 0xeb1eb6ba, 
	0xc8b282a4, 0xa5dea0cf, 0x1bcc013c, 0xf2544bf5, 0x0a1c61f6, 0x65d1e6f1, 
	0x5735b7a8, 0x956fd927, 0x6f223bfb, 0x5f2334c6, 0xe139f3c3, 0xd8cf69fa, 
	0x833b8f30, 0x10dd6275, 0x9e4485e6, 0xbf41f689, 0x712de6a6, 0x63f3329f, 
	0x1f7c45bb, 0xc7d396be, 0xe719cbc8, 0x5a1d70df, 0x7e68bb1b, 0xd03c8988, 
	0xf89d3fd4, 0x29b9e60d, 0x6efa041f, 0x8cae8ae8, 0x1d8c68f3, 0x6ed63929, 
	0xfc8da7e6, 0x658e28f2, 0x65b9e795, 0x7ffd04ad, 0x743daf23, 0x3d622475, 
	0x352e13f7, 0x6f75ebf6, 0x052bac2f, 0x634de9eb, 0x7ab42cfe, 0x57edd20e, 
	0xa85ecb4b, 0x0376e3e3, 0x95aebb7d, 0x45297d68, 0x71806c71, 0x6cc5c2aa, 
	0xaaebf427, 0x32e07266, 0xc9557f93, 0xfa28f642, 0x47d68f1b, 0xba38e7ac, 
	0xee196afc, 0xe7fdd2c7, 0x7d4d712c, 0x0fcc5ed3, 0x8c2fb574, 0xb10579d0, 
	0xd176f83f, 0x77fa321d, 0xf285a57e, 0x3be15b94, 0xce67d02e, 0xabc196a2, 
	0xf771cc3a, 0x3ed3a47f, 0x5702dddb, 0x9fdebd86, 0x3f5a7912, 0xa8fdf2f3, 
	0xc7b4647b, 0xeb019678, 0x699f3123, 0x95af1c03, 0xd6047e79, 0xb173bf4b, 
	0x5f6a1c3f, 0xa8fb83df, 0xf69de512, 0x60ff8787, 0x65267e03, 0xfb4cefae, 
	0xfb8c80fe, 0xae972d5b, 0x9069f925, 0xaf51941f, 0x4d259bb1, 0x63b6979c, 
	0xf30c2ebe, 0xb7f8c22e, 0x28dfcdee, 0x8125cec2, 0xee646baf, 0x9bb18c3f, 
	0x1e5209e8, 0x6b9c5f29, 0xf87e463d, 0x2ea203ed, 0xb27af87e, 0xcf4fada3, 
	0x6ae738c9, 0x7cbcd1d8, 0x55e82998, 0x3db358a9, 0x9e71788d, 0x79fca389, 
	0xf5194ee4, 0xeb3235f1, 0xd30abca4, 0xc20e1395, 0x2c47d51d, 0x2137e716, 
	0x79ac5336, 0xa2af262c, 0xf3134a78, 0x111a8073, 0xa65ce9fd, 0xaae15f51, 
	0xeb090d06, 0xfb66b8ea, 0x4537849b, 0x8cfdb78d, 0xbff84287, 0x6306f951, 
	0x310b7548, 0xaddf5b8e, 0x475e74ad, 0x585cc89e, 0xab225c17, 0x401f512e, 
	0x9008077a, 0x2157b58b, 0xfbc1cb1b, 0x65cb3a25, 0x8fbde107, 0x50eb0b98, 
	0xc623e8c7, 0x76e749eb, 0xf9825c1f, 0x90f4abb4, 0x7ffe0e23, 0xa73f3e74, 
	0x81b6257f, 0x3e05ac9f, 0x220ef30f, 0xab5f48ae, 0xd47a8cbe, 0x7f93ae90, 
	0xbaa42b62, 0xfba8d61d, 0xe829bef8, 0xa0ef7c2d, 0x1bd719b2, 0xbd730afd, 
	0xde7d0770, 0xc4e30bb5, 0x21975106, 0x7c8d92e4, 0xedfce32e, 0xd69d44e7, 
	0x69907225, 0x53fcd397, 0x86d5ee78, 0x4f4897d7, 0xaea98778, 0xcf00b5e2, 
	0xb39e8da3, 0x3c223aa3, 0x9a798357, 0xb179b330, 0x1eae78ce, 0xe0f7776a, 
	0x3f00b5f7, 0xf1e215a7, 0x1feb946a, 0xffa72b5b, 0xd9fe44e7, 0x936b5f38, 
	0xc1ab77f9, 0x5ea9d87e, 0x25fb642d, 0x0ef34e7d, 0xc57ea825, 0x91758357, 
	0xb004d48f, 0xeb725ae6, 0xbb586db9, 0x63fe92c7, 0xe681d112, 0x78379363, 
	0xce6d1d44, 0x74f075c9, 0x1d672c5e, 0xad5fd07c, 0xcf0068fe, 0xaec614fa, 
	0xef1c2ff9, 0x2940a192, 0xd88483d6, 0xb93f486b, 0xf49f98ee, 0x36f7d09b, 
	0x4782b751, 0xb3ff88c4, 0x97ce321d, 0x23260a85, 0xf19e1afd, 0xceaebad2, 
	0xcdf0977f, 0x193b5c0e, 0x5de27bd7, 0xa9d4e117, 0x089c9f0c, 0xd327403e, 
	0x63c41ac2, 0x2767454f, 0xc85711da, 0xfee117df, 0xc19c4f8d, 0xec27aab8, 
	0x5cacbca0, 0x7c20de07, 0xa4e853c7, 0x57d37138, 0xaff28498, 0x8e30d4d9, 
	0x7cde59e7, 0x90e066c6, 0x85594cea, 0xaf656eb5, 0x7a47740a, 0x01754c2a, 
	0x436be4df, 0xbcf599b3, 0xa797c0a8, 0x1c1cd5f0, 0x1ea393df, 0xc58d8c7c, 
	0x854be7a9, 0x41315e46, 0x61692305, 0x1f437497, 0xec2dbca8, 0x34437c84, 
	0x6e05a521, 0x17c58ef6, 0xf8457dc3, 0x83982eee, 0xfa1e356b, 0xf5dea9d1, 
	0x3dc716d1, 0x73377f14, 0xb93376fc, 0x5cc57b5c, 0x87d42ecf, 0x42dd8380, 
	0x78876c0f, 0xb7b8f100, 0xcf1871d5, 0x13e28ced, 0xce38f3fe, 0x3ccda6cb, 
	0xdddf7689, 0xe399be53, 0x3613f686, 0xb85cf97e, 0xadf10bd0, 0x6dffef87, 
	0x11858c28, 0xd0b0770f, 0xdae12fc0, 0x09d59eb9, 0xeb43c8ff, 0xf1cf30f3, 
	0xcc11c084, 0xc9d57d6b, 0x06cf38a3, 0x042b888f, 0x883e4d1d, 0x7ea3227a, 
	0x649e8b28, 0xbe094faf, 0xaab8e3f4, 0xa8df7e2e, 0x3b5bdb82, 0xb74597ef, 
	0x472e42dd, 0x68e829d7, 0x73c327c8, 0x77c9e3f1, 0x5d764caf, 0xf065b12f, 
	0xf746d64b, 0xbd7166e3, 0xfb1b9fc2, 0x8c77c640, 0x26f41875, 0x9ffcc2ca, 
	0x9cf511ac, 0x85f681ac, 0xef187f71, 0x3fb6eb27, 0xd2597187, 0xc2f455a9, 
	0x81de697d, 0x0efa1af2, 0x68eaa3af, 0x558f7438, 0x2965d4ae, 0xec627af6, 
	0xa2c287bc, 0x1486f40e, 0xd90473c3, 0xd44c5775, 0xddfb1be7, 0xf7a97976, 
	0x941bb70c, 0xaf6a73ef, 0x97b97095, 0x481a5f29, 0x30a17b08, 0x45aff73f, 
	0x1cfc459b, 0x34fea2bf, 0x868f3996, 0x1497e7eb, 0xe6b3bed2, 0x87f41d7f, 
	0xd6881ae7, 0xafe7089a, 0x25b40ca1, 0x9fa1afe2, 0x0d78b805, 0x82a5b7eb, 
	0x58ff3f13, 0xd24d12fb, 0xb7dc54ba, 0xfaa378e7, 0x9251c40c, 0x725b53eb, 
	0xfc8dc719, 0x4d9b89a1, 0x4d8f611e, 0x87fb9bbe, 0xf218fe16, 0x62ebe064, 
	0x14f58af2, 0xc8650fb8, 0x157918e3, 0x8ce068f2, 0xfa4ef2e4, 0x7e7e8a9e, 
	0xf90c9f36, 0x98d5e434, 0x999f299f, 0x4cbb0178, 0x4c2b247e, 0x0ace7f93, 
	0xd3bc895f, 0x43df9631, 0x3379e80c, 0x7f718fae, 0x4cee5b35, 0xee485cba, 
	0xc8ba0cf4, 0xcd61f97a, 0xafd13f5c, 0x43902fff, 0xcb905eb3, 0x1fc9d321, 
	0xfff4fa24, 0xc867f2f5, 0x59176199, 0xd64b7e96, 0xc822a37f, 0x896749f7, 
	0x13d1043c, 0x598b3ae8, 0xafe48de4, 0x35dcac64, 0xae71abb4, 0x3164d8ef, 
	0xec78c9bf, 0xe45e9834, 0x1038ac52, 0xa307f479, 0x75a62f4c, 0x24038db2, 
	0xb4e7a36f, 0xcc3c553e, 0x7e8c1c44, 0x61d78a76, 0xb5bcf9d0, 0xb5393641, 
	0x57ae1e0d, 0x98831e9b, 0x36cb856e, 0xff7c277d, 0x2d4f0dc6, 0x1f2844f3, 
	0xddfcb0c0, 0xdf73353b, 0xdd5ca1b1, 0x4fc453b6, 0xdabb6c31, 0x35763c17, 
	0xda5f67de, 0x5afec094, 0xbc12db60, 0x026d72ef, 0x9518dfbe, 0x9fc96298, 
	0x3bdbb8c2, 0x7abfde33, 0x6623a3f3, 0xd2f3863c, 0xbe394c0a, 0x0dc6f5d0, 
	0x1cf7cdd2, 0xd972f182, 0x5e124db9, 0xae7cae7b, 0xcd1bcf8f, 0x95db8367, 
	0x468db791, 0x2df33b13, 0xa9960ddf, 0xeb4a3f8f, 0x40759552, 0xe9351ba7, 
	0xde56de1b, 0xbad2736e, 0x6feff475, 0x13ee9992, 0xe81777f1, 0x8da3a085, 
	0x3fa13ff6, 0xf98c5de5, 0xe3cbd4fc, 0xbd715ecf, 0xab8f2e74, 0xde6bf52e, 
	0xac38d337, 0x03b97de6, 0x38a3efdf, 0x9a65b944, 0xb9d4b76e, 0xdfc3d9fc, 
	0x1fbe3e63, 0xe9f515e8, 0x097d9d43, 0x8bd51e71, 0x5ebcbfe7, 0x02c24f66, 
	0x252eb27c, 0x7db3030f, 0x1bf95f5c, 0xc5de9041, 0x9d18f8f8, 0xd6e39f6f, 
	0xd036281c, 0x739f1096, 0x032f7192, 0xe61478fa, 0x0dea3d43, 0xb3ac5ee8, 
	0x31b5109d, 0x5464eb09, 0x7fd032f8, 0x287cd336, 0xb0584147, 0x6abd0606, 
	0xfa049ed5, 0x34fbf93f, 0xf587506f, 0xa2f29e34, 0xe309531f, 0x7d78fb05, 
	0xec55ca27, 0xa373513f, 0x47146b9c, 0x6f354656, 0xa3ade637, 0x26ee2760, 
	0xa0eda63a, 0xe65c94c7, 0x797f78c7, 0xea2741f3, 0x9b3295f1, 0xb2ae7a80, 
	0x160c5231, 0xc21f9f03, 0xe36f30f8, 0x3c0efa3e, 0xfffeb157, 0xff985173, 
	0x66271a6a, 0xac916b87, 0xeb7f7106, 0x3ffb9916, 0x62c1da95, 0x8b20ffec, 
	0x82ecd64e, 0x9fb1a74f, 0x5571193e, 0xcc4e6b24, 0x797955bf, 0xfb7ab5de, 
	0x63c7ca34, 0x5fcf009e, 0xa4efc504, 0x577596cd, 0x27ca2eea, 0xe53f4ae8, 
	0x21fcf4bf, 0xe5ef3ec6, 0xf0a4c87e, 0x352b1761, 0xd92936f9, 0x29efe747, 
	0xa09fbd8e, 0x2ff943e6, 0x1ce7e46a, 0x3c78f9e6, 0x78e6ed1a, 0x7f187d01, 
	0xd519e81f, 0xf00b6f24, 0xff9e0ea9, 0x160f3c2d, 0xe0ab846a, 0x0cae4599, 
	0xef7c00bb, 0x68a57b40, 0x0bc7ac5e, 0xe61afe62, 0xeace1c19, 0x2edee8a7, 
	0x17ba6bb2, 0x9f38bcf3, 0x83fbc838, 0xed067b8d, 0xa64fa8cd, 0x819fb61d, 
	0x641646f7, 0x6a1a57be, 0x0e458dfb, 0x47e9a801, 0xc6c7f0c9, 0xb91c1fbd, 
	0x1abbeb32, 0xcac6fefd, 0xab1c5320, 0x9c611f31, 0x8578e457, 0xc61fb6bf, 
	0x5add0681, 0xecebda31, 0x97f00af1, 0x47e43e8c, 0x646813e4, 0xabb7ccc2, 
	0x4faef889, 0x7e72c7ea, 0xcdbdd5d9, 0xcb043fcc, 0xf1ee9d38, 0xd0e6fcf2, 
	0xe87c860d, 0xc8cc1e74, 0x12a65407, 0x5583cc5e, 0x8f9a23e2, 0xe72012c4, 
	0x49b39d10, 0x5477f06b, 0x582ae532, 0xcfbdc7cf, 0xe2b5f9cb, 0x13e52a87, 
	0x62b47b0a, 0x5c3e7dfc, 0xf3e61f9f, 0x77af2f67, 0xd4123a08, 0xf5ef695f, 
	0x3ebac1e6, 0xf78df710, 0x8f54c180, 0x5944e062, 0xc5f28d39, 0xab19aeb8, 
	0x19b11e69, 0xcc426768, 0xaf89a7b7, 0x1f3167b3, 0xede46c27, 0xe19e8586, 
	0x520f84e7, 0x53020b3e, 0x1de883ac, 0x47d7079d, 0xe3ddae97, 0x4971f3c5, 
	0x1ae7cf2f, 0x4ef487fa, 0xea43d093, 0x66cff585, 0xab4fef81, 0xf2f45e7f, 
	0xeb8b8f7d, 0x162f3e9f, 0x87fa9b3b, 0xde91b3ef, 0x12b27d41, 0xac678cf4, 
	0xc8d099fe, 0xfd0c9aeb, 0x0f746971, 0x23d205e9, 0xcb57f22a, 0x57a43fd0, 
	0xf2bd094e, 0x1f21e90a, 0xaf48efe6, 0x193f5330, 0xfeb46cfa, 0x9759f510, 
	0xa0105bd0, 0xc69ac64d, 0x2de796b5, 0xb09e9fa0, 0x21d639c8, 0xa4e61f01, 
	0xd559c274, 0x8ef2463e, 0xe697d9f4, 0x94b7d9f4, 0xe82c25d3, 0x38ba0612, 
	0xc55efa0d, 0xe881277f, 0xda01fdc3, 0xdcdef107, 0xe32cf5eb, 0x6e3ac3eb, 
	0xcf0c8f5c, 0xcf5cbdbb, 0x3a20f41b, 0x0cfd26ca, 0xcfd364fa, 0xfac6afd0, 
	0x63dd7e89, 0x4eba36e9, 0x8fa22f41, 0xbe865e85, 0x58fbf4b7, 0x25b8193a, 
	0xff632e3d, 0x836fe914, 0x70e6412f, 0xbf48bce1, 0x5bfa9997, 0x38f561c9, 
	0x3be80f4f, 0x07d209c2, 0x380951e8, 0x76427516, 0xf98ce7f4, 0xf5a4eb1b, 
	0x287db8c5, 0x20a2f1c0, 0x2e9dbc21, 0xbd763d58, 0x72cfcfa4, 0x734a923b, 
	0xf879423b, 0xf68c5aa8, 0x6a48ed0a, 0x249f999d, 0x5bb1623b, 0xdbc93d86, 
	0xe7e2ecd8, 0x2dbf419c, 0x7e0ff213, 0x0a34495e, 0xafac080e, 0x3f643411, 
	0xf307a3cd, 0x9e975e2b, 0x9f8ef4a0, 0x41be7039, 0x5ed0b926, 0x33f58895, 
	0x54e2c9f5, 0x013d9647, 0x463557fa, 0x39996c5c, 0xf623d41f, 0xec47ae7e, 
	0xf7906038, 0xf4823d43, 0xc03f60bd, 0x46e1fa0d, 0xcfe90bbf, 0xee7e5149, 
	0xb7a0301e, 0xf87f910c, 0xcb4fd580, 0xf75ec7f6, 0xdd801c70, 0x1bfdc5ec, 
	0xfc74e3f0, 0xa26bb83d, 0xfdea1709, 0x7fa02939, 0xe517d01e, 0x2167c264, 
	0xcf5ec327, 0x2272b1d1, 0xfc22721b, 0x31396c9a, 0x272d9d70, 0x8126ef84, 
	0xcfd30ef7, 0x1feab921, 0xfe10e7eb, 0xcae536ef, 0xde430390, 0x0b71efc8, 
	0xa209e6bf, 0x883de10b, 0xb09263fb, 0xbf71a7f7, 0xc730fc0c, 0xd86f3b58, 
	0xd98f836d, 0x3da8c17e, 0x80e27187, 0x25bb1bef, 0xa832e22f, 0xae54eff0, 
	0xdb05cbec, 0x3b85fdc2, 0xfb81dfb8, 0x9e704b71, 0x3fee2f67, 0x3fb87304, 
	0x7f82e4a4, 0x293f2694, 0xd7c1d5d2, 0x9dfc21db, 0xce77d614, 0xbfbfe6ae, 
	0xbb235410, 0xb5b9ee30, 0xd919712f, 0xc5ec955b, 0x16fc3eed, 0xeb5ba7bd, 
	0x2a52abba, 0x1f26dbe9, 0x2156ff3f, 0x5a710170, 0x738c0f64, 0x0e6b0fa7, 
	0xbc20394c, 0x5cf029de, 0xd5578e66, 0xf9e07718, 0xcbd620cd, 0xf2345fa2, 
	0x4eb59739, 0xb09f1efb, 0x03bfc293, 0xbf9d2e7f, 0xe915c4c6, 0x2fd4d919, 
	0xedea80de, 0x17eac6d2, 0x5e2dcdef, 0xafbd134f, 0x3e4dab4a, 0xfe0a3f93, 
	0xa7ab8567, 0xd7be276e, 0xa145e4d0, 0x8ff580a9, 0xdd715fa7, 0x002b0f68, 
	0x098f883f, 0x2f77e20d, 0x76e50fc0, 0x4bb0cd49, 0x6f118d15, 0xabfb0f30, 
	0x3c0d6fa4, 0x028f3e8c, 0xfd714abe, 0x4dc9fcfc, 0xb04f7723, 0xaf3793c6, 
	0xff01fe06, 0x8ebc626f, 0x6e3ebbe1, 0x172ea9af, 0x9564eaed, 0x7e2158f0, 
	0x9a700c4f, 0x3e0af796, 0x22f7e9a7, 0x1557113a, 0xb113790d, 0x0fd0d65e, 
	0x7fdcf5ca, 0xefe3be40, 0xa91ea06e, 0xfbe4d0fc, 0x6df946ff, 0x4af7cb19, 
	0xe7ac3be4, 0x7df00ba9, 0xb2ddf22f, 0x9e13796f, 0xd0fbe5ff, 0xd027d421, 
	0xe71fff26, 0xc7325ec9, 0x1c728caf, 0xf9057c98, 0x4ab60083, 0x6af833d5, 
	0x7db671c8, 0xf65afe24, 0xe5ae2b1f, 0xf2154f71, 0x9bce08f3, 0xbfb279db, 
	0xba237bf4, 0x22e297b7, 0xc7541bdd, 0xda2abbf2, 0xbe46f847, 0x7d413da1, 
	0xe0b6edd0, 0x9fcb21a0, 0xe3046a60, 0x3baf8806, 0x83ba3d45, 0x076ba3d7, 
	0xfc4b1e51, 0xb454bcfc, 0x5af441d7, 0xbed6ed51, 0xd7a67244, 0x0ebedea2, 
	0xffa1379e, 0xd08760e6, 0x85960f6f, 0xf602de1e, 0xc788bbba, 0xc4ceddc3, 
	0x7c78c794, 0xf80b6fbb, 0x8966d1c1, 0xfae25a35, 0x4c6e30e5, 0xa021cbc4, 
	0xc1f37153, 0xe25a77c9, 0x77f7ece5, 0x7f27a89f, 0xd7a6d83e, 0x38197ea2, 
	0xc5c5a893, 0xc555b00c, 0xee5b57a8, 0x601874e7, 0xd1e212a5, 0xf1f19f68, 
	0xeb60f77a, 0x3f759722, 0xaf5536fc, 0xb76f8195, 0x5a94aac9, 0xe409d26a, 
	0xdc0356b3, 0xd437aa7b, 0x9b775fa2, 0x27184aaa, 0x3b0416de, 0x1b07f70d, 
	0x2bb45af4, 0x0b5e8a83, 0x41c99816, 0x1ef40fe8, 0x612a59a8, 0x7be32b3c, 
	0x493f385d, 0xd60d38c2, 0x97ce10f1, 0x31bf8ef8, 0xdd38c0a3, 0x3e316e34, 
	0xc5a98dbf, 0xf3187c56, 0x4fd4fbc0, 0xfcf8373c, 0x67af9fb0, 0xcf945fb4, 
	0xe5c1cf2b, 0xb076a769, 0x7c3ceb16, 0x1a1fee31, 0xdcfd1afd, 0x73f3cd4e, 
	0x59b07f7f, 0xf94645ab, 0xc73d79aa, 0x0f6ab360, 0x8d033bc2, 0x177f1daa, 
	0x2eab7bdb, 0xaefcc355, 0xd0d5fe84, 0xe380703f, 0x7dc6c760, 0xf71896f6, 
	0xb907eea3, 0xaafcf1d8, 0x9b802d43, 0x6f66a340, 0x5efcdd79, 0x3150f7a0, 
	0x40ec7bf6, 0xe405bd9b, 0x4788a779, 0x5adb7f11, 0xf21ddc4c, 0x9dcdfdf3, 
	0x62bf1e51, 0xf3c1d77c, 0x673c0ea5, 0x559ff183, 0x80761abf, 0x665392e2, 
	0xafc8681c, 0x45ac1e25, 0x81c460bd, 0x7af2363b, 0x6b0ff007, 0xe9d74083, 
	0x3039ddf0, 0xa15440ce, 0xad5ea179, 0xb2fdcd5a, 0xab8f9e0a, 0xf714ee7f, 
	0x78e9f6d7, 0x29f70b65, 0x0aef0e82, 0x8f82ca3e, 0xe4974169, 0x5d127e58, 
	0x657a4dfa, 0x7c4c73f3, 0xe71fff0c, 0x94499f7a, 0xdf7b04b7, 0xe99ce824, 
	0x211e918f, 0xe741333a, 0x100f0253, 0x72360d27, 0xbf91fafe, 0x9881d740, 
	0x73c30f6a, 0xc2974c7f, 0x29e9afc2, 0x14ba7ec1, 0x9debacb2, 0x1979df29, 
	0xf540eff5, 0x6fb889a2, 0x4bbf2e3f, 0xaafb3e4c, 0xfcd64b0f, 0x89f7ad04, 
	0x3603834f, 0x9f1e31e7, 0x57a06b37, 0x252f9ef2, 0xe7eedd3e, 0xdc16e3fb, 
	0x31e75ad5, 0xba43eb00, 0x4d47b8d2, 0x1bf318ba, 0xd0a6efc0, 0x04f903ef, 
	0xe82838fb, 0x7b97ed00, 0x6d56fda8, 0x44e50ba8, 0x7ae2a9cf, 0x2716c4e6, 
	0x70006bc8, 0xb78f95b9, 0x414792d1, 0xbf9334ba, 0x7d7e3aa6, 0x79a7d394, 
	0x1e97ef0f, 0x61bf7f36, 0x5a96ce60, 0xcc80dbc4, 0xbd7a21cf, 0xc82a6d7a, 
	0x9d00a1f9, 0xb8f3f4df, 0xde5758d7, 0x759233c6, 0x071f065d, 0x79562f80, 
	0xf9eb19f2, 0xe36cd160, 0xdadb0af7, 0x425faea9, 0x9d7a1b3e, 0xf9df01f8, 
	0x587bd077, 0x4b5d751f, 0x7fda315d, 0xfe0cafc3, 0x73c5ab54, 0x5ce2031a, 
	0x512d4ec6, 0xfb3e80ab, 0xc71e7e3f, 0x997a89e7, 0xbcf3f57f, 0xb047a184, 
	0xe50aa77e, 0xe204f405, 0xff99a07d, 0x86af8b00, 0xf51075d3, 0x37a129c6, 
	0x6aaf4e34, 0xc436d3b0, 0x27898b78, 0xb81b9ec3, 0x4af5ecf9, 0x9f509e26, 
	0x6687b9d1, 0x6ba40ebe, 0x01ca6628, 0xfe14fde1, 0x47c80ede, 0x21a79cc4, 
	0xfe609b1f, 0xf163b5b6, 0xc001ea6e, 0x407af017, 0xe8b37905, 0x463ba181, 
	0x8ecbaf7f, 0x8640687a, 0x5d8d777e, 0x30fde61f, 0x83081d4e, 0x877ee0dd, 
	0xe21ee5ce, 0xaf185d8e, 0x28837bc0, 0xdefd3abf, 0x3b2be830, 0x10af0bbb, 
	0xb3f8fc9f, 0x29c43b93, 0x1a819bda, 0x97f44e43, 0x58fda87b, 0xeb8f286d, 
	0x43c730aa, 0xb7919579, 0xb337e7e6, 0x2ce3677e, 0x9dac5fb5, 0xf441f7cd, 
	0x3677e99b, 0x83397f9a, 0x3ab5479e, 0x183bfd1b, 0xa7646ea2, 0xf5849f7b, 
	0x20f97996, 0x6d575819, 0xcaa56efc, 0xf6772feb, 0xdfe9d9b6, 0xde799175, 
	0x83eec6ef, 0x4dcf5176, 0x21e29ffa, 0x7d6dfd1d, 0xebe3f909, 0xc3a0d5f9, 
	0xe79e7ebb, 0x8ff6121e, 0xd0b695f8, 0xe88df05d, 0xbe01765e, 0x23c7364d, 
	0x1df4593e, 0x7a1145f1, 0x62fc8626, 0x70bfd476, 0x0977625f, 0xbd7cc23e, 
	0xefa06d97, 0x9d98c40c, 0x6a7298e5, 0x4cfd08e0, 0xe7a1befc, 0x94355e40, 
	0xddcf4357, 0x0c26ea22, 0xbf3c90fc, 0xd1a5e664, 0xb1eb593e, 0x4bcf1aa2, 
	0x4071fa19, 0x477081e0, 0x835d9ffa, 0x0aef84f4, 0xf82fa33b, 0xbed6dd19, 
	0x1801dff7, 0xf616cdcf, 0xdd79cc7e, 0x8f4153ed, 0x20f4fdf0, 0x794575f2, 
	0x1c77f7cf, 0x1d877f42, 0xf83ad1fc, 0xf7cf695e, 0x5777c236, 0x3badd804, 
	0x76bd26ec, 0xe063ed66, 0x6c3d7f7c, 0xfcdfc1b6, 0xdc457b9b, 0xf5c17f8f, 
	0xb58f83da, 0xae15ed9a, 0xb6b2ffc8, 0x87b44b83, 0x716f6dad, 0xeaba0fcf, 
	0xa5279c60, 0x5df01dc4, 0x5af63baf, 0xf475c817, 0xa32c0e3b, 0xf2c2fb45, 
	0xdd34fb2d, 0x164dd6b0, 0x7dda34bf, 0x0fd5b8f0, 0x47a3adfd, 0xd8c25ae9, 
	0xd9350e7b, 0xf81e7205, 0xfbc1db41, 0x767de10e, 0xd966fe0d, 0x4bd88e7b, 
	0x7da43f1d, 0xae366ba1, 0xf51c7dc3, 0xcf991d97, 0x3877f173, 0xe439dfa2, 
	0x1dd17b46, 0x73f08ed0, 0xd8eb2a73, 0x5cf6f220, 0x9c60f42f, 0x51d7b3b9, 
	0x0d69758c, 0xef7fee01, 0xb3e3cd1c, 0x7927de6b, 0xf900b438, 0xe8603ef9, 
	0x1e29876f, 0x1dff25af, 0xfdc5dd70, 0x9bf25af7, 0xa0f7e2b2, 0xfc41fa1f, 
	0xeef7303f, 0xb18eb605, 0x8f1815fd, 0x715929f2, 0x67dcc0fa, 0xd71d6017, 
	0x0b3c3c98, 0x1346fdb5, 0xd70bb872, 0x7bb9f7b7, 0xff9cc316, 0x40f0c1c5, 
	0x1fd1d814, 0x83a0c8ee, 0x6dfcc3ea, 0xd68707e0, 0xef09b83f, 0xd114beab, 
	0xddb9c7b5, 0x910be3c9, 0xc2f8a217, 0xe7b42b8c, 0x838ae333, 0x62de841b, 
	0x17ae3bf8, 0x0da42b8f, 0xe6457199, 0x5c697ffb, 0xaf0e40f1, 0xae371933, 
	0xe309fd58, 0x5c66cd8a, 0x21f8c1e1, 0x294afc8f, 0x5068ae23, 0x8ae247ff, 
	0x9ebe01a9, 0x9c15c70b, 0xc571d92e, 0xdf1e1cb1, 0xdb872f7f, 0x520bf207, 
	0xfe805fa6, 0xfc2d3042, 0x5719b883, 0x78f0e5f4, 0xeda0703c, 0xf22c07ae, 
	0xa7c9f3bb, 0x11f4f25e, 0x234a586e, 0x2e3691f9, 0xde2178a5, 0x79def305, 
	0x9e03c1cb, 0xdd5c0cfa, 0xa3db8db3, 0x6e76e6e0, 0x78fbad7f, 0xde90efa8, 
	0x1ff11f68, 0x71147a31, 0xea27596e, 0xd08ff447, 0x7e14e25e, 0xf79ffc2b, 
	0x0bbf991c, 0xb70e74f0, 0x48b5c61f, 0xfc33ebe3, 0x2944a044, 0x03c0fefe, 
	0xc1e08ea2, 0xed076796, 0xac6728bd, 0xd177eb34, 0x87bfad4a, 0x0ba880fc, 
	0xd679b078, 0x5c3fec61, 0xbf89c07c, 0x937f00e3, 0xc378c04f, 0xa8c9e1da, 
	0x77582e0f, 0x8d751692, 0xfd1f79aa, 0x0abaecab, 0x9f811f73, 0x883f077b, 
	0x223507c7, 0xa7ff43fe, 0x407c6c69, 0xfd0a52fe, 0xefd03fa4, 0x7fa20ef2, 
	0x26740d34, 0x8e3ec1d0, 0xf629f45f, 0xdbc76aeb, 0x23adfbaf, 0x6fae47fd, 
	0xfade7f63, 0x25fb8be7, 0x83ffbfe0, 0x51aa47f0, 0x1fe6879e, 0x347f18ce, 
	0x69d62cbf, 0xd92f2fc9, 0xde6bdfc2, 0xce09b802, 0x3d421ed4, 0x56ebe46a, 
	0x85e7d404, 0x5a48689e, 0xf9fc2b9f, 0xbe7aa940, 0xd7ec55f3, 0xe466dfe3, 
	0x5ca1b70b, 0xf47fbe86, 0xdf673e10, 0x3d907b45, 0xb3d0914e, 0xc2af3113, 
	0x2dbdddf3, 0x1ade446b, 0x561cc1fd, 0xd8097e8d, 0xd17e6335, 0x585fb82d, 
	0xfbc6d7a8, 0x8059ffc9, 0xef236979, 0xc1c2defa, 0x689f3c5c, 0x13b477e8, 
	0x29f76fb4, 0x8f11bbf5, 0x336a4707, 0xda8243eb, 0x6b0e3e41, 0xeabf7fc3, 
	0xde5c033f, 0x3a0daa87, 0xd06d7d73, 0xc888e079, 0xfa2ea88f, 0x43a0953d, 
	0xb77f5872, 0xf1e01fc5, 0xfb806e40, 0x0b77c465, 0x97aa063e, 0xf0defe52, 
	0x6012d08b, 0x571b391e, 0x6ff6135f, 0xb533c6c7, 0x790dd8a8, 0x8b5c441f, 
	0x46fd0a38, 0x9f907f92, 0x14ef9441, 0x3ef62be2, 0xc8cf57c7, 0x6dcbe076, 
	0xc7fb9748, 0xde80938b, 0x8a0e47e0, 0x579852f3, 0x1eff4051, 0xaefcf00f, 
	0x13bd2711, 0x8e938cc8, 0x849c7806, 0x179c14f9, 0x999859e5, 0x4afca167, 
	0xfa4e3593, 0x25d5cbc3, 0x6f309e5c, 0xe3c3583d, 0x55f2318f, 0x04f5f203, 
	0xe503afc9, 0x1971e489, 0xf7fd6fef, 0xff6b0633, 0x8bd696ad, 0xef7c27f1, 
	0x8e2580bd, 0xa9f8577e, 0x82ff2149, 0x35eff76e, 0x478a4ee3, 0xa05e781b, 
	0xc793f4a5, 0xa23f349f, 0x9c37fa6f, 0xefdfe9be, 0x1f75bdfc, 0x1099e802, 
	0x74e00afe, 0x882dafd0, 0xa2bfbee3, 0x807d8ad7, 0xc807da5a, 0x17065bf2, 
	0x8ffdcdde, 0xf0bd5af5, 0x751f7a9b, 0xb02fe38d, 0xd8af839e, 0x58247f4c, 
	0xd33d7b16, 0x467ba86f, 0xda6b13e4, 0xbf227c36, 0xdfa678e1, 0xeefef990, 
	0xce888713, 0x57e136c1, 0xc62d2cd5, 0xec6ddbbc, 0xf8b32d64, 0xf965b709, 
	0xc6070f0d, 0x21061bf7, 0xe47cc10e, 0x870dfa20, 0xf0837ead, 0x3e00ce0f, 
	0xf03f614f, 0x1a7fc007, 0x4fe4ea0c, 0x2468340c, 0x5fe8036f, 0xf7c0df90, 
	0x5eab6f13, 0x325c554a, 0xbdb807be, 0xfc4dc6ad, 0xe837eb19, 0x7e023f3c, 
	0x830dfa0b, 0xe3aac3f8, 0x1f780df8, 0xdcf1b0f5, 0x05761bf0, 0x8391f332, 
	0x8f1437e8, 0xcb2e47cd, 0x433e79e5, 0x5475fe4e, 0x43c9c64e, 0x7869fb42, 
	0x07fb873e, 0xe59dfe77, 0xe4c5ccfc, 0xd9efb0dd, 0x79217f72, 0x3337317e, 
	0x05fcf1ef, 0xcf2599e7, 0x39b296f3, 0xdd9fd04b, 0x7c2fdbfb, 0x49b1e424, 
	0x4cfa1be4, 0x47394639, 0x21f91aba, 0x758d8e43, 0x6d529e01, 0x1457ef60, 
	0x8c9de665, 0xbc4671f3, 0xc824741e, 0x05da37cf, 0xb1d52a6c, 0xac0dc194, 
	0x9ecad933, 0xf916ee2c, 0x5cd5d2d0, 0x71e44f3f, 0x20ed0bac, 0x6c3bd7be, 
	0xc68ce9d6, 0xa2df42af, 0x80fe467f, 0x5e5093c8, 0x93cd6d30, 0x7919f5f0, 
	0x867d6312, 0xf5b1709f, 0xa3e3b5fd, 0x1d9db43e, 0xbf090fab, 0x279e3331, 
	0x1c2fa71c, 0xb9fb1bcf, 0xb7bc3283, 0xf0db82dc, 0x8deb8a61, 0xf9f0f8ef, 
	0xf117e8dd, 0xf31077a8, 0x989f282e, 0xf17e5977, 0xc04ce2bc, 0xa470984d, 
	0x93fc28be, 0x8de8389a, 0x137efbef, 0x103af3c0, 0x7a95bcff, 0xbdd0ec95, 
	0x7f65efdb, 0x96c37e71, 0xfe28edcb, 0xbf3cb9f3, 0x41e8e9f1, 0x963c9874, 
	0x5c6da30e, 0x9bef8a7f, 0xfc8a1e63, 0xf3f05931, 0x3b32bc2e, 0xf3bca1e6, 
	0x30fe930f, 0xfc839be8, 0xc35e45d1, 0x35cc5fc8, 0xdf9415f3, 0x8b791328, 
	0x424f59b4, 0xe35d8b79, 0x7e99d9c5, 0x779767fe, 0xb9d2e50a, 0x9de40b8e, 
	0xca347c8c, 0xfa129cb1, 0x689bfd0c, 0x259f35f4, 0xf9b1714f, 0xe27af91a, 
	0xbeac724f, 0x0cdbd2c5, 0xae1d1b7d, 0x5b30e745, 0xd9eb66df, 0xb7377d8b, 
	0x3a8fd477, 0xce147e84, 0x7de791bf, 0xe5eeb762, 0xb13bf87c, 0x2fb7f1ef, 
	0x700ab631, 0x7c42d2d4, 0xed04bca5, 0x7f099443, 0x57fc8d25, 0x2e49bd83, 
	0xcca7d57f, 0x5c8cd3bc, 0x1f0177ae, 0xb7f03752, 0xfabbe409, 0x9fdf82c7, 
	0x69df0f20, 0x8537cbca, 0x6f50c4bc, 0xfe180eac, 0x9b8a41d9, 0xcf2cff0d, 
	0x4b3d52af, 0xcc15fa1e, 0x0b831fd4, 0x38fdad9f, 0xf4ec08bf, 0x8fdc7cf7, 
	0x60df1238, 0xd14dd9ca, 0x8c124d03, 0x0991a2b7, 0x17d0c2bf, 0x4fe49720, 
	0xf567bcf4, 0x750e2027, 0x5e304b2a, 0xb6289d3d, 0xa27f127f, 0x11cef06e, 
	0xf7809fd3, 0xf8abca1d, 0x02891dfe, 0xd09fd5bb, 0x7c27f425, 0x68ed4b35, 
	0xfcb27337, 0x7f2c9c89, 0x42f72da2, 0x75e004fe, 0x4ec27f7c, 0xb3da04fe, 
	0x5f09fc71, 0x08794e83, 0x3c8ba29f, 0x0f415c04, 0xdcaa34e6, 0xa2be009f, 
	0xfe13e13f, 0xdddbed04, 0x13f817f5, 0x4f77c017, 0x1a93af2e, 0x78d1f383, 
	0x8e204b40, 0x7f1d6efd, 0x81fc8ace, 0x1799b496, 0xb1a0b8c5, 0x2d56f485, 
	0x38b8ffeb, 0xf913ed40, 0x6076d8a7, 0x7e203fc8, 0x338b183f, 0x25d6ff23, 
	0xe6a182fc, 0x431f7fd1, 0x8bce3aa2, 0x425dbbc4, 0x7388982e, 0x756c9e73, 
	0x2e2f38d5, 0x8c064f0f, 0x3ca8fb7c, 0x9fddebc8, 0xb51bbdbd, 0x77b117a7, 
	0xfc15fc63, 0xbe7e4efd, 0x2bf518a0, 0x77a9bfc6, 0xea3179e8, 0xc6c515df, 
	0x9c58ad73, 0x1fc8ce63, 0x4cf909ff, 0xb07a0875, 0x22b6e81f, 0x76f7f797, 
	0x7889d0de, 0xa7687b04, 0xecd153b8, 0x54541718, 0x5f204f86, 0x74c4c982, 
	0xeb47778c, 0xde7a5a61, 0xbf304291, 0x519e754d, 0x118010bf, 0x3725f510, 
	0x2f755e63, 0x8c43af1f, 0x4e4ef587, 0x1836eff1, 0x8f15d779, 0xf58f5fde, 
	0x84b53717, 0x7e34f61c, 0x763adf6f, 0x819bd4ca, 0x284e8bd3, 0x4eff9a1f, 
	0xdcf7d518, 0x3b3d7941, 0xaa80c3da, 0xaa29de51, 0x7fb8c549, 0x66f3001a, 
	0x8791bdc5, 0x4d6e76f2, 0x79e1d7b0, 0x49fc97b4, 0xc45e4bb0, 0xb47fd1a7, 
	0x4e711dae, 0x522fd6fb, 0xd7d880bf, 0xf2163ca5, 0xb24e4b2d, 0xe2dd58f3, 
	0xc7002a77, 0x7990c16a, 0xc3df009e, 0x815b4ddf, 0x55b0d3bf, 0xbaf22fd4, 
	0x25ff3573, 0x52c3afde, 0x00fff507, 0xc44afed3, 0x0003dc51, 0x7dcd9c78, 
	0xd554780b, 0x333ef0b5, 0x24999e67, 0x32499333, 0x5e10c179, 0xc304a023, 
	0x4e58c123, 0xc6912842, 0x4468ad1a, 0x8d4301ad, 0x68223408, 0x33392f44, 
	0x84504219, 0x8f824101, 0x012a3e36, 0xf6a37b72, 0xea3ea6f6, 0xc7c561e1, 
	0x2b6b696d, 0xa08fb7bf, 0xd3fd4b70, 0x6f4fea5e, 0xb5febe23, 0xf3275ed6, 
	0xf7fed400, 0xba7df17f, 0xaf6bdfb3, 0x6bdad6bd, 0x9ecebdad, 0xbb54f0e0, 
	0x4f8850f8, 0xf4239b3f, 0x34d710a8, 0x89644a6b, 0x453b5710, 0x109c758f, 
	0x5f42108a, 0xfe0d842d, 0x442138ee, 0x17c96e83, 0x4e82212e, 0x121ce831, 
	0xf7f833e2, 0x769976b7, 0xcd3b63b6, 0xd31075d9, 0xbe86e890, 0xad9340b6, 
	0xd0d316ab, 0xa418eea2, 0xbd745d1e, 0xa6f4e90a, 0x4c2eaece, 0xafbd9d07, 
	0xb2155a40, 0xf81767df, 0x162faacf, 0x26265ec2, 0x7084cb88, 0xc413e854, 
	0xde3c2131, 0xe909d17c, 0xaf42bcee, 0x755a1a7a, 0xb8404dd7, 0xdbe01f85, 
	0xc64df508, 0xc4205178, 0x3bd0bb0e, 0x43794076, 0xf50bc58d, 0xa953b93d, 
	0x1285385e, 0x5ae3463f, 0x5109afbc, 0x53a285ea, 0x0f3afc42, 0xe683bafe, 
	0x682ec451, 0xa1dea177, 0x3159e003, 0x6ee5867d, 0xe2b0c704, 0x1c5eb3ff, 
	0x9042219e, 0x467864fe, 0x1f10bf45, 0xc578b7fb, 0xa47f215f, 0x19456662, 
	0x0a42efa4, 0x042a50e5, 0xd310bb8c, 0x6f78840f, 0x8d2b1cf4, 0x7eab742b, 
	0xddaeb12c, 0x1d69d379, 0x70b2fae6, 0xaceeb07d, 0xa4075856, 0x09bae1e2, 
	0xeb496bfa, 0xd69b7f89, 0x0cdaf6b3, 0x5ecebba1, 0x7ac8d54f, 0x9eb9ceaa, 
	0xde18732b, 0xbaeb69e5, 0xe8866073, 0x367dc049, 0x3e7d979c, 0xe0d2bb9c, 
	0xf16f996c, 0x8d35f8c2, 0xce139d17, 0x56ce112b, 0xfafe1384, 0x7bc0e71f, 
	0x3d0cc0f3, 0x3769e924, 0x062793d0, 0xfa7d00f4, 0xf5b57e01, 0xc3a670fc, 
	0x26ef3bb7, 0x6cfabaaf, 0x93b8213a, 0xe5f0e4e9, 0x7db0ef04, 0xbde139d4, 
	0x5bde0465, 0xf2ef0dce, 0xeb174901, 0x088f0986, 0x3b804ef7, 0x85cfc713, 
	0x2ff51ffd, 0x2f985e1d, 0x1acf6d6b, 0x1dca186f, 0x5a72c0c2, 0xfae4eac7, 
	0xa15b35ae, 0xc44e7b7e, 0x4422fe2b, 0x715beb04, 0xe1059a9d, 0xbf0934d7, 
	0xc416121a, 0x3850a3bb, 0xa3ff88ed, 0x16faa37f, 0xbf091ceb, 0xf3158d71, 
	0x322bf62f, 0xf20b742f, 0xda9fb093, 0x7c7ac0af, 0x0d79187e, 0x91c303e4, 
	0x9b6b0ea0, 0xa7bf5baa, 0x76c07a4b, 0x456eaf16, 0xa0b88a7c, 0xc17ec471, 
	0x415668e3, 0x05c72374, 0x23845438, 0x7b0c283b, 0xaceff013, 0xc209d536, 
	0x587f31c2, 0x708446f5, 0x0b66db5d, 0xd1a33e42, 0x86be21b0, 0xfd0b7546, 
	0x4297c8f7, 0x43101880, 0xf96a2331, 0xd555c690, 0x2f4f1c4e, 0x03f3fdc6, 
	0x42973b2e, 0x1bab0e1a, 0x750d305a, 0x8429386e, 0xdea8d757, 0x4e890e17, 
	0x371fcf98, 0x8e1f3202, 0x1a620e76, 0x11fc3754, 0xfbeb89f0, 0x4761d22b, 
	0xde5fe100, 0x75f7e121, 0xf7dc6289, 0x90dabc24, 0x761d607e, 0x6fc11af1, 
	0xedf84b0f, 0x477e1265, 0x713fc205, 0xc11c51d8, 0x315b01fa, 0x819dc7c8, 
	0xe61f923d, 0x9d70b80f, 0x9b36faee, 0x94f1a147, 0x56d3ac08, 0xe812720c, 
	0xa299426a, 0x1fbf2138, 0x4a9d73e6, 0xf210ff94, 0x40f79845, 0xaf20e81e, 
	0x0bb6a45f, 0x1589f2c8, 0x665ffda9, 0x914db7ba, 0xa774e4e3, 0x40f2e3f5, 
	0x05c2508f, 0x5682fcb2, 0x3cb2af94, 0x7db537b7, 0x646c00fe, 0x036e4241, 
	0x08f1141e, 0xb08761a4, 0x9a7c22e4, 0xbeda11b2, 0x70f9ff0a, 0xe2e32afc, 
	0x9e88dafb, 0xdca3d61a, 0x9045a29e, 0x80a56dfe, 0xaea36805, 0xe851ebb5, 
	0xbbf84bf7, 0x1c5bda1c, 0x8551edba, 0x7446c8e8, 0x8e846074, 0x9474c96c, 
	0xfb03f48f, 0x2a51743b, 0x2ae3a87d, 0xacaf905a, 0xc4d81e7c, 0x19ca2aeb, 
	0xf1c54518, 0x9e39768c, 0x9872e805, 0x4888d7e9, 0xb77a227a, 0xbee20f85, 
	0x0e47a5aa, 0xbc873ae1, 0x6bf6245a, 0x7fe423e8, 0x8287bae6, 0x0dbfa171, 
	0x5d36b005, 0x219dc84f, 0xc1afed01, 0x963ca1f1, 0x1062ded4, 0x768d199c, 
	0xc921ec5f, 0x8e965f17, 0x73ec4e90, 0x485eac06, 0x80fdc9af, 0xa53dd0f8, 
	0x275b0acd, 0x9587f35c, 0x6f1b38a0, 0x3789dfc6, 0x03dfdd44, 0x85566d8f, 
	0x3ff6f915, 0xc21f5472, 0xc9b6b8e3, 0xfcddb026, 0x6705100a, 0x901da3c3, 
	0xc2cbe872, 0xb0ec2273, 0xaaaa9f22, 0x9f02ad91, 0x83b5509e, 0xc5a817a8, 
	0x5247ce92, 0x0bd3a48f, 0xcb1cf27c, 0xe802b487, 0xca4f9477, 0xc6b1ccdf, 
	0x477f4c55, 0xfda13a36, 0x2557ee74, 0x53fb99fb, 0x71cdedca, 0xf4cdfbd2, 
	0xf30bb949, 0xc7807539, 0x19f47283, 0x0ed28fc8, 0x2ae7ea16, 0x9418396f, 
	0x5bda66f0, 0x3a9b2e90, 0x8fa59e50, 0x8eea2d6b, 0xfb343ca0, 0x7e815fab, 
	0x55aa6848, 0xfd71f889, 0x99e9c10a, 0xb7599c2d, 0xe01d310a, 0xb962b570, 
	0x7cc39645, 0x8a7fd859, 0xd3f57670, 0x5f91073c, 0x88997d61, 0x04de7357, 
	0xc983a11c, 0x8c2ec070, 0x21e22fd0, 0x9030a0f3, 0xdb3cf11f, 0x979e58b8, 
	0x79e4cbf1, 0x799de782, 0x9e33d49e, 0x5a7fc344, 0xb75b3f70, 0xd6f4934f, 
	0xbef2435f, 0x499746e9, 0x7c9e8a7f, 0xcb7578ee, 0x0db62c09, 0x74e94646, 
	0xe8b9d06e, 0xe2fd5bf3, 0x2543a276, 0x1d177c82, 0xa3f50bb8, 0xf690eda1, 
	0x77e87d23, 0x2081feb1, 0xb8cd218b, 0x191f592b, 0xb658627a, 0xd72cd17f, 
	0x554ed86d, 0xfdaecaf5, 0x9010df88, 0xa651f022, 0xbc43eb7e, 0xcf67fc6e, 
	0x343d96d6, 0x15cf949c, 0xe7d4a5b7, 0xd4a5b71b, 0xa797d78f, 0x56d44fd4, 
	0x89e7e4a4, 0xf9f92995, 0xfe94cac6, 0x0f598deb, 0xdf6b5e81, 0xa83d8a10, 
	0x3c7b6a42, 0x483ce763, 0xbb3a631d, 0x719f08ec, 0x6cfb4a53, 0x3e1529bd, 
	0x3e4a716d, 0x85492c5f, 0x0a9258cf, 0x4a737e9f, 0x39ad3cfd, 0x2c5f3f25, 
	0x7ebf694d, 0x0e87e2f0, 0x25337c11, 0xceead57c, 0x63be1057, 0x8e70fdea, 
	0x803e40ad, 0x293bcc73, 0xfd00b75f, 0x1622dd79, 0x6dfdd907, 0x2e1c8fe6, 
	0x541b71cf, 0x7b973b7e, 0xd41be727, 0xc21c433e, 0x9c783bf2, 0xc9cf2e1c, 
	0x0d7ca830, 0x1c70fb97, 0x5b9f43a0, 0xe2ee71a3, 0x6e5c6c71, 0x2c116b73, 
	0x8f6cdbbf, 0x0cfb60e3, 0xc7b9c68d, 0xb6e5cf6c, 0x963f6d0c, 0x7dbfb9fb, 
	0xf1dfd883, 0x7adde42e, 0x7f4b0e2c, 0x0067da0c, 0x7e183b3d, 0xf1a0db87, 
	0xbaa536ed, 0x71f0f803, 0x78f3f7ae, 0xe69d0cfe, 0xfd943bb1, 0xd626ff58, 
	0xe714cab7, 0x1cbaf075, 0x7bcd0619, 0x793b971d, 0x445ba77c, 0x867afcb1, 
	0x73cb973f, 0x2c7adadd, 0x9dcb91bf, 0x43338e3c, 0x9bf2c01c, 0x2e5c9c78, 
	0x5ed0cdcf, 0xdcc5f2c1, 0x97d79b3e, 0xb03a36ed, 0x9f6e66fc, 0x6ef9e5cf, 
	0xca5fc683, 0x9ebcd9e5, 0x20e30cec, 0xe3c2df96, 0x7e7973e4, 0x07e34186, 
	0x7016f0d2, 0xb788f58b, 0x3c978c43, 0xadcf3f86, 0xdbc64faf, 0xf00fae61, 
	0xf10c8178, 0x96f0b9ca, 0xcbc9ebc7, 0xc3dea9d0, 0x0c0e49ed, 0x40a81cb0, 
	0x97703039, 0x62300238, 0x1b5ef906, 0x0ab6f996, 0x8a41a03a, 0x9669e708, 
	0x45efd807, 0xed97efae, 0x4a289fed, 0x41ca1b64, 0x9fedff29, 0xc856ca29, 
	0xd5ca67bf, 0x5d554d71, 0x9c9eff40, 0xc7f7c7d0, 0xd2bfd530, 0x35a90d5d, 
	0x7c60ba24, 0x05a0c64f, 0x58cf50ed, 0xc159b2cd, 0x67b2d074, 0xa83bc21e, 
	0x14d0b46c, 0xdd473c16, 0x2e57a04d, 0x59337296, 0x7937770f, 0x96751ec9, 
	0x720a3e81, 0x508f844d, 0x98ffdefd, 0xb799f544, 0x73c7ee35, 0x999794cf, 
	0x0a328b6a, 0x3af96987, 0xf5dfd5c9, 0x7d5ca5fa, 0x0f7c88d4, 0x5fbc0592, 
	0x14076b96, 0xd353a15c, 0x9b4f282d, 0x229e52ec, 0xb3ff503e, 0x497f5fe0, 
	0xc3277be4, 0xd9ef605f, 0x9f4887a7, 0x3affcb33, 0x4c1f2cc1, 0x6a607f29, 
	0x57a5ff6a, 0x90ffbb9c, 0xb8e7975d, 0xa9dd7d60, 0xc8d7e9b6, 0x60339e3c, 
	0x65de73fa, 0xf21ea9d1, 0xf7aa4ebf, 0x2469fd48, 0x6bcb4eef, 0x3b789a15, 
	0x5e303f39, 0x5fe849ef, 0xe888bf4e, 0x98aaf070, 0xeb57c082, 0x4ea3c606, 
	0xfee45a21, 0x5f388bab, 0xad45e926, 0xd72b7ce2, 0x06f9c45f, 0x7384ef59, 
	0x5619c690, 0x808b9d04, 0x5463eeca, 0x4037e96e, 0xf9c7f8ae, 0x070c3595, 
	0x05ae61d8, 0x8de90b5e, 0xc78d2f75, 0x6b84cb73, 0x45ec5f8f, 0x5317b7bd, 
	0xc8f7af18, 0xc39e728b, 0xef4f3455, 0x3a4790bb, 0x93455a3d, 0xfae69ef4, 
	0xf99f9c93, 0x961facb2, 0xc538f7ed, 0x7b6fb424, 0x4e3dae19, 0x137f526d, 
	0x6ea4dbd1, 0xf387a3a0, 0x70891da4, 0x1fd2bde8, 0x67f615b3, 0xa051a42f, 
	0x117f87fb, 0xc97778b0, 0xa7a88df2, 0xfda12ffb, 0xee0dbf25, 0x5ae976a3, 
	0x64abb7e2, 0xed5fce3a, 0xa868fb47, 0xe4efcb99, 0x73f5db14, 0xdf84febb, 
	0x73f5da87, 0xbdb74c3b, 0x7c74fb40, 0xe8c5cdc3, 0xdded31e0, 0x8b73e3db, 
	0x3768db2d, 0x617ea027, 0x06b7ac68, 0x40e3a7f5, 0xad7a6bff, 0xc997bd13, 
	0x3f80bb71, 0x25ccf757, 0xa63bfd7b, 0xd9eb613e, 0x5bd61b3d, 0xccf297e5, 
	0x09a3e1b2, 0x1dffa1d3, 0xc4d1f2ff, 0xa7d866e0, 0x89ebb490, 0xbd41a69f, 
	0x2df481bf, 0x375328a7, 0x9fcd9d34, 0x7fc91c96, 0x2fa0d1ce, 0xdd75420d, 
	0xc4dfa4eb, 0xb84b739e, 0x3e25ee1a, 0x805b73fc, 0x3b74d9f5, 0xa7845bf9, 
	0x1b393b11, 0x73a464ec, 0xe11b656f, 0x945214ab, 0xff39d34b, 0xa7be9955, 
	0xbdf4bd4a, 0x528d144f, 0x01f4a09b, 0x754bd4bf, 0xdd20cb48, 0xa41d6909, 
	0xca257e43, 0xb5538ffa, 0xcbeafb63, 0x7f60963a, 0x39c08ae1, 0x18e27c7d, 
	0xe83e0097, 0x36b94bf4, 0x5a71182e, 0x13af04fc, 0x36d04ded, 0x25775b9d, 
	0x3181bfe9, 0x8602954b, 0x2ce19fb3, 0xe9cfda4b, 0x9955fe5c, 0xe437cfa6, 
	0x972ed855, 0xdff398f0, 0x4f7a7309, 0xe719e625, 0x9db63805, 0xbc3dc70d, 
	0x93c1677f, 0x3d8d1957, 0xfe8de30d, 0x120c539b, 0xbc8d2c2b, 0x84cf8096, 
	0xae57ac6b, 0x046f84cf, 0x6c0f5e6e, 0x679c52f8, 0x0ab3ce15, 0xf8a903ca, 
	0xf7a0ad53, 0x2dfc909e, 0xd51156f5, 0x345fa80b, 0x13a0905e, 0xc4e92023, 
	0xa6bf4aa9, 0xf615ec2b, 0xc30e91c7, 0x81d02f51, 0x441d0b4b, 0x0eb986bf, 
	0xe6c5f150, 0x50f94915, 0x127f5d58, 0x51ae4fcb, 0x09fc88fe, 0x3fca0ad6, 
	0xcc0fe58d, 0x7092efa3, 0xf6999d20, 0x41e613aa, 0x4285763a, 0xa1f71d51, 
	0xca35fb81, 0x5d7ae67e, 0x3900cfec, 0x6e502ad9, 0x363949d6, 0xf2841717, 
	0x77bbd460, 0x7e0943c5, 0x4dee99d3, 0x9da212fe, 0x7eda5efc, 0xc5cf953f, 
	0xf3297d73, 0xae73ac1b, 0x71c788db, 0xa7f57a1f, 0x03c69eb1, 0xc239a2f9, 
	0xde236713, 0xa7bb0302, 0x58fc12b8, 0x6276bd93, 0x99fd0b30, 0xfe944d9f, 
	0x137e54cc, 0x9d68d7e1, 0xe937dfef, 0x2350fd73, 0x0ddb03f6, 0xfd2fff3e, 
	0xe65a7768, 0xe3a7b9c3, 0x3f545a38, 0xf6e9f8d7, 0x6f3c9b47, 0xca26db03, 
	0x10d67bf1, 0x6e3e173f, 0xdb67e14b, 0xd37fe628, 0xf397c94e, 0xd1effcf8, 
	0xe60ca2bc, 0xdf7c863b, 0x1f6828aa, 0x95aa5ad9, 0xbb97e85d, 0xf3ae3b6b, 
	0x5becd8ca, 0x837fe592, 0xe38df52a, 0xe038bddf, 0x6ee4260d, 0xc0259743, 
	0x99c1397c, 0xf1beff24, 0x9da7b6f0, 0x7155fe30, 0xcb2744cb, 0x4fee38bf, 
	0x0809c2dd, 0x63d3f6ef, 0xfef6bc24, 0xf2c9283f, 0x2abff190, 0xd389b5fe, 
	0xb6d57ea1, 0xd56d29eb, 0x7944afef, 0x847d1ad8, 0x47ff2ad2, 0xbbdb8eb4, 
	0x055898de, 0xffdfb7f5, 0xf94d4a4b, 0xe41e305f, 0x7fa452cf, 0x207de54d, 
	0xafac057f, 0x689ce516, 0x0fb45612, 0xcacfde7d, 0x85ef402c, 0x03f4d039, 
	0x64dd9f94, 0xd47f526f, 0xdfa473f7, 0xe65720aa, 0x6eb34ce1, 0x5ded902c, 
	0xc283e5c9, 0x0bcb8bba, 0x99059d60, 0xd6975e5c, 0x33d4521e, 0xf948660a, 
	0xdd6db408, 0xdea92bb8, 0x7584d72c, 0x7f43f70f, 0x3ca5c156, 0x1949669e, 
	0x5159fe0f, 0xfa37bd0e, 0x0b9e18e5, 0x4ea1a3be, 0x9bfc173c, 0x3cf05a2a, 
	0x273e602f, 0x8946d0ff, 0x2fe88d8f, 0x4076826e, 0x7fe8851f, 0x99788a58, 
	0xdea021d5, 0x45a2babf, 0x26cf3f40, 0xbb9e0b71, 0x4053b788, 0x41939e37, 
	0x01fb19b1, 0x019e6def, 0xba2860e9, 0xbdcb1079, 0x973816ea, 0xa03c7ff2, 
	0xfc037ca2, 0x729c70c6, 0x35da275c, 0xd0d606ab, 0xf924dfb9, 0xfdc7ff38, 
	0x2cb3a456, 0x348d6e8f, 0x16837de1, 0x57c83d43, 0x8112dd9c, 0x8756b379, 
	0x03c0dee8, 0xcfea063a, 0x1cbfe6ef, 0xda618ed3, 0xdf60d31e, 0x35b4cbfc, 
	0x75ca1f35, 0x72caffe3, 0x6d693cf8, 0x51ea635b, 0xf3e007e4, 0xc008f328, 
	0x996982d9, 0x96e405ba, 0x1adb496f, 0x47a65f5c, 0x0e6046b3, 0x07e832df, 
	0x15e5a1f9, 0xb0f5926b, 0x82bf3e4c, 0xbab5693f, 0xbf85af00, 0x80bab5ea, 
	0xee8c878e, 0xfed019f1, 0x2e791cf2, 0x303ebd0c, 0xeffd8a3e, 0xf493be1d, 
	0x5044e09d, 0x87ef50b8, 0x332fe03c, 0xf38b9b53, 0xd6f3c88c, 0xb4c2f9a4, 
	0xd27ab98e, 0xf7cd9639, 0x1131994d, 0xc5e0b143, 0xd779447d, 0xdf7159a4, 
	0x760b6f32, 0xd4da9fa0, 0xa0207c3f, 0xbfb443a3, 0xac3bf431, 0xcd5e3a46, 
	0x6deb8d74, 0xb452b969, 0x9eb0b8f0, 0x80cf4865, 0xb7f66caf, 0xe88d068a, 
	0x92b9fb0f, 0xeb3507cb, 0x802f2e2e, 0xdfb36675, 0xb6a5d456, 0x39e983bf, 
	0x20adfd9b, 0x473e8990, 0x35cb33c6, 0xfb87bacd, 0xabed805d, 0x26ad3c78, 
	0x2bf43c65, 0xad7c3ae2, 0x2d3d3e92, 0x3c4bf690, 0x8e997e10, 0x48635e80, 
	0x2866de27, 0xc477da4f, 0xdfac0773, 0x103a2593, 0x780f54ef, 0x3c076df6, 
	0x5adf3b42, 0x247747a1, 0xd1dfe7f0, 0xbc4411db, 0x2fb2d76e, 0x6bfa226e, 
	0xef1b4829, 0x7689d591, 0xf3e01e59, 0x535f78fd, 0xfb8052d6, 0x89ac5ab8, 
	0xd10dd124, 0x83cb0fb5, 0x322e906b, 0x3c90f797, 0xa5a55ac9, 0x2709a7d0, 
	0x11b8f3d5, 0xb409771c, 0x0f79ba03, 0xf53b47e0, 0x43ad2cbd, 0xa6bb4077, 
	0x429b05b6, 0xcd240d32, 0x2b0a71e7, 0xa298679e, 0x46e3877d, 0x5efb734e, 
	0xdc708f6e, 0xfc907dd6, 0x95a74e74, 0x8f78c9fc, 0xc8fd2833, 0xd653d03a, 
	0xea0f0a2f, 0x1cb45e74, 0xf21dfe44, 0xcec93b8a, 0xa863bb61, 0x3a4ee2a9, 
	0xc9b387af, 0x772402d3, 0x63dd8a67, 0x4a9b87fa, 0x093cb17c, 0xc19fdbdf, 
	0x7f0477b8, 0x11dbfa64, 0x01d7fc5e, 0xe72ebcfb, 0xdf941cb9, 0x75b717c7, 
	0x59e085a0, 0x76c310d2, 0xc5a2cdd9, 0x3c4307bc, 0xc2e8077d, 0xc879fb8a, 
	0x227f4561, 0x3cbac3d5, 0xa5c7d816, 0x79112f44, 0xf045a57f, 0x1ce48afe, 
	0xf274fbf9, 0x421afb87, 0xb2eb0622, 0xf9ce52a9, 0x20dfa0c3, 0xa37ad93f, 
	0x47af6a5e, 0x07bda0bb, 0x3c68a7ef, 0xe93942e1, 0x1baaf06f, 0x235c7ea0, 
	0x12cfa0e8, 0x6788a2be, 0xa3bad7d7, 0xbadfd44e, 0x3f48da2a, 0x747a4b89, 
	0x68e1e2ff, 0x78e7e81c, 0xc47efe69, 0xd9ef879f, 0xadce385c, 0x705df989, 
	0x3c7e6e78, 0xc75eafc9, 0x052a84e3, 0xd744b0bb, 0xf67c24a9, 0xbb7f228f, 
	0x78dcf63a, 0x42b8f3b4, 0x7d60ca1c, 0x3dd70321, 0x6eeb0c35, 0x4e39f892, 
	0xaed234f7, 0x5b293c07, 0x80277e01, 0x027ef9dd, 0xf0470bae, 0x789112d2, 
	0x178822d1, 0x3b9e4dbb, 0xf0445760, 0x2c30bf3c, 0xdc9b62f1, 0x6bfb4118, 
	0x8db2ada8, 0xc245a2e8, 0x02b9ca6f, 0x8f50f7d4, 0x96d15c3b, 0x989e1fac, 
	0x7efe4eda, 0xc722c83c, 0xaafe4fd0, 0x55ccf282, 0x68d7de6c, 0xe9d613aa, 
	0xcdf3c80a, 0xcf94ff2c, 0x21cb1761, 0x3b5a534f, 0x78fe5b96, 0x5203b96a, 
	0xf172f7bc, 0x4b53913d, 0x6ae5c7eb, 0xbbc35348, 0xb79e3964, 0x5e5b962e, 
	0x4e7db53d, 0x248aa6b7, 0x82ebed79, 0xc3de117c, 0x7ffa0439, 0x82cd1e5c, 
	0x472847f7, 0x55c8fef1, 0x0ff7a865, 0xb7c59d13, 0xd03e70b8, 0x747ec0bb, 
	0xeef407dd, 0x27647945, 0xc8081479, 0xb86523fb, 0x40f5263d, 0xe00ce3a3, 
	0x4e6677d3, 0x786dfde9, 0xf729e9d8, 0x45abbe37, 0x35ffd48b, 0xe598daf2, 
	0x57735ca6, 0x6d8e96e9, 0x768b5fd8, 0x247f412d, 0xa006f9d0, 0x2c1a2bcf, 
	0x567f984e, 0x6e5f9e40, 0x7513ffde, 0xedfc0e30, 0x275436ea, 0xd786bbf4, 
	0xbb7c66eb, 0x294a5f40, 0xe2bb7c67, 0xde7b6a7a, 0x66af572f, 0xf3e7294b, 
	0x4a1215c7, 0xdfe3394a, 0x724b09a5, 0x7fa8a639, 0x5c1f79bb, 0xb279a0ba, 
	0xbb3e65eb, 0xf33eb358, 0xd2d5e12e, 0xc8277e8f, 0x3dc0ffa3, 0x4678ab45, 
	0xf43e6213, 0x347ea20f, 0x7682c1bc, 0xb745bb90, 0xa27edda0, 0x09edd201, 
	0xb400817c, 0x9e221fa9, 0x05fa1da0, 0x444d841b, 0x4566bdb1, 0xe9802ffb, 
	0xb96ed083, 0xd73b62f0, 0xda00ed44, 0xc31ed98d, 0xae6ed78a, 0xbc160d05, 
	0xe9d576c7, 0xad4fb694, 0x4f6f780f, 0x9b43339c, 0xfc3fa35b, 0x01b31c3e, 
	0xc55e17a9, 0x828be8f4, 0xea15b49d, 0x6345b417, 0x5ebe4117, 0x7f264f9e, 
	0x3407d0bb, 0xe961e5c4, 0x8bbf4647, 0x1bef2a2f, 0x515bdd71, 0xa2d24dbe, 
	0xcfb4f9f1, 0xe5c038b1, 0xfab26faa, 0x80b11f00, 0x6f8fbbb4, 0x3ae0b069, 
	0x9d001686, 0x7994b9c2, 0xa1584875, 0xf920247f, 0x3be09dc9, 0x5df9d20b, 
	0x22b8fb69, 0x7705f520, 0xdb52ef82, 0xa52ef825, 0xa75e4efc, 0xa977c13b, 
	0x677c12fd, 0x8bbbbe41, 0xe09dcef9, 0xc0f694bb, 0x3417e477, 0x697577e1, 
	0x3ee62f44, 0x8b7e90ba, 0x7c947ed0, 0xf2029ee8, 0x5eedd61a, 0xc6f310d0, 
	0x1f117ae5, 0x1e636fc0, 0xe157f791, 0x2eb87dd8, 0x827a82dd, 0x9b91f59b, 
	0x6b4e5da0, 0x3ce90f82, 0xf99fbc47, 0x1260f6cc, 0x42da3a1f, 0xdf27ea2a, 
	0xda0cbf61, 0x6b5f643f, 0xbb61ffec, 0xf52ad1c6, 0x7e36d171, 0x9b3dda22, 
	0xeb259c5e, 0xfda8f3c3, 0xebf0a0a3, 0x43e77629, 0xd8bff401, 0xdd91b566, 
	0x4c69d8e9, 0xd84ae3dc, 0xad15c735, 0xe51d51e3, 0xb8f71ce8, 0x25520928, 
	0xe8e518b2, 0x51ca3706, 0x42715ef3, 0xfc414459, 0x33f8cb3d, 0x7ef377cb, 
	0x798ef79a, 0xbb6a7afd, 0x589f2c80, 0x9fbfda91, 0xc29d53f7, 0xd6975c7c, 
	0x9a9dcb8f, 0x3e7ee0ae, 0xde69fbcb, 0xa6f6e657, 0x901fcfb6, 0xfee666f7, 
	0x0534cbd9, 0xfb86cff7, 0xa85314b7, 0x749c1177, 0x9423ff1f, 0x955e38a7, 
	0xe9e59536, 0x983fdc51, 0xd5e3ee97, 0xbc11e38b, 0x3cb3b320, 0x3c88f1fd, 
	0xfec2397d, 0x80a7d888, 0x3999fb37, 0x9e4b9f97, 0x3c81c7da, 0xba1ffe95, 
	0xa7974a4a, 0xf790956a, 0xf4378c99, 0xf7883fbf, 0xef406709, 0x4fb3be00, 
	0xe8389112, 0x36a7c769, 0xe7805e28, 0x5fbc80bd, 0x3afed954, 0xc1f58611, 
	0x8301b6df, 0x36da22e4, 0xcf1e3784, 0x96a7afd6, 0x2ad83ef3, 0xca52bbf6, 
	0x656d1f79, 0xbe72d491, 0x88f5b00f, 0x5f7871d4, 0xcdd72c6c, 0x3ee94c72, 
	0xc6c7f798, 0x2f5bdaf2, 0x6162def3, 0xa4896679, 0xdff47eaf, 0xabe51e40, 
	0xf15d5b5a, 0xffc4218c, 0x0eaf9118, 0x6aabf105, 0x5f28a240, 0x45229e31, 
	0xca0a6abe, 0x6819fb4d, 0x42d9e307, 0xb50b0780, 0xc36c7927, 0xad6be514, 
	0xbc0eaf94, 0x5e76819f, 0x5223508f, 0x7fd051cd, 0xc57996a5, 0x5d47a043, 
	0x1030fe10, 0x03c640f8, 0xc8e1fea1, 0x70dbf687, 0xe40a3f3f, 0xe57a8edc, 
	0x578c0127, 0xf52c5fb2, 0x2bed73c9, 0x2bd557ca, 0x5c7dabe5, 0x7693e905, 
	0x76fe4eb7, 0xda57cb3b, 0xb7089dcf, 0x8eabfb4e, 0xae50590b, 0xbdf2e596, 
	0xd415d0b1, 0xf2cf8e5f, 0xfa30e22a, 0x78dd60f3, 0xca5d3ca7, 0x25730ba7, 
	0xe247d99f, 0xfe89aa62, 0xcdfe32c7, 0x295c82f2, 0x7123ed87, 0xbb6a5a31, 
	0xd498b891, 0x92b9a5fe, 0x7123ed1f, 0x46fd6931, 0xe23462e2, 0x7e472c47, 
	0xc5c48fb4, 0x1fcfb6a4, 0x4d1f88d0, 0x9c9f71f8, 0xc6f8a4fe, 0xe27f1270, 
	0xc014d3bd, 0x14f1104b, 0xbd7ca08f, 0xfc02f190, 0xe488ff57, 0x6e8daecf, 
	0x09e0175c, 0x35f2caf1, 0xaf94d723, 0x1ce92f92, 0xed33fac5, 0x270e0f65, 
	0x1e9272f8, 0x17f6ff22, 0x6d49d7c9, 0xa1144ed2, 0x7f5889cc, 0x7e9219d2, 
	0xe4cdc3a5, 0xdb786a67, 0x6b5f2692, 0x08eed172, 0xf937715f, 0x916d27d7, 
	0xfecbd5f2, 0xc5b7f402, 0x23fd9da5, 0x1f49f3d4, 0x13573d46, 0x63d071ad, 
	0x20ac2f6b, 0x4e90289f, 0x5ee93c6b, 0x44ad1547, 0x0dd98ea7, 0xb205bdfb, 
	0x7478f49c, 0x49db255d, 0x55da0e30, 0x0c0ad4c6, 0xf9e849bd, 0x6ec80bdd, 
	0xa5cf79c2, 0xfa989fe7, 0x38c85599, 0xcdea451f, 0x738a55f3, 0x3fc44e29, 
	0x6b44dc61, 0xd5dc6a6e, 0x3343a652, 0x31a32aee, 0x57d31dad, 0xf96a6b56, 
	0xa9c5c44a, 0xab957c44, 0x971fad2e, 0xdc64cbdb, 0x6a6e6b55, 0x4b6655dc, 
	0xdb8c7b6a, 0x577132fa, 0x719ae677, 0xef37fa57, 0xe1f4e797, 0x7f3beefb, 
	0xf03dd5dc, 0xd3d1395f, 0xbbf9089c, 0x7f43eec1, 0x4e667a98, 0x67c3fddb, 
	0xb9b579cb, 0x34bec522, 0x4aa7bbe5, 0xe26ef923, 0x0eb94549, 0xfa8aa0fa, 
	0xff5c9255, 0x23d4ae4e, 0x6cdea65c, 0xaf9675ca, 0x3f4ae4cf, 0xd8a76986, 
	0x4a4b0d1a, 0xd6dbe339, 0xca535baa, 0xf7e5538b, 0x5338f948, 0x4a4aebde, 
	0x7cf314f9, 0x31ca5230, 0x699bbf45, 0x7f40d8bf, 0xeb3f7ac5, 0x9d62fecd, 
	0xa0a6bae5, 0x3c86ecde, 0xbddb75ca, 0x7efe6f52, 0xe7d729ae, 0x5b4f882b, 
	0xc82fac03, 0xeb954ceb, 0xead79416, 0xd724f999, 0xbfd0615d, 0x275ed8a2, 
	0x2985d37d, 0x81abf5ca, 0xfd0f80b5, 0x9817d81e, 0x679213c7, 0xc803ed15, 
	0xf7cdd55d, 0x6e79519c, 0x7a833da3, 0x123de02d, 0x07c7157f, 0x0ff00c39, 
	0x7b4dde32, 0x9044f8f5, 0xb9095dbb, 0xe95cdbfb, 0xf08d72a7, 0xe3fa4e83, 
	0xfbf0d3cf, 0x1daa6e6a, 0xd698d199, 0x521f846e, 0x3f308fcb, 0x54777898, 
	0xe11bf5a4, 0x59f49d07, 0x973f472c, 0x521f846b, 0xcb74e7db, 0x3d5b6e7b, 
	0x57d45bc8, 0x249f5043, 0x3f88dd6f, 0xd36eb790, 0x11bb04ae, 0x2aebade5, 
	0x95ebc46f, 0x62fd25eb, 0x91edbdad, 0xf51878a4, 0xa137cbcc, 0x4f520a9e, 
	0xda4fb96c, 0x5d5f28a3, 0x88d89a55, 0x8375e6f1, 0x04fa8d9f, 0xf52e2c78, 
	0x57caf3d2, 0x7abe90a1, 0xcc914360, 0x79272dd7, 0xa17c613a, 0xa5bdf3cc, 
	0xc2787da5, 0xfcbfba74, 0xef55c913, 0x2aca8196, 0x9fd097ba, 0xea6ef946, 
	0xdf2038ad, 0xa7cc286f, 0x798a1a9c, 0x7fde645f, 0x86a73d70, 0x95649f79, 
	0xf32acd79, 0x9706a73a, 0xabfb950b, 0xfee01ca6, 0xdc6c2e5c, 0x39fdc6df, 
	0xd85cb835, 0xf5cedeb9, 0x2e5c1a9c, 0x83be3c1c, 0xe0d4e7c7, 0x7ae4e172, 
	0x6a73d727, 0xb0983970, 0x8f177c72, 0xe5c1a9cf, 0x6ef5cdc2, 0xe0d4e7ae, 
	0xe3c19172, 0x9cf8f067, 0x3c2e5c1a, 0xfdc3dfdc, 0x5cb83539, 0x4cff7264, 
	0xc1a9cfee, 0xeb8b22e5, 0x539eb8b3, 0x3645cb83, 0xe3cd9f8f, 0x39706a73, 
	0xbfb26c98, 0x6a73fb97, 0x71f0b970, 0xe7f71f7f, 0xe172e0d4, 0xd73f7ae7, 
	0xb9706a73, 0x73f1e1c8, 0x0d4e7c78, 0xee01172e, 0x9cfee01f, 0x722e5c1a, 
	0xf72e7fb9, 0x72e0d4e7, 0x79f5c791, 0xc1a9cf5c, 0xc79f22e5, 0x39f1e7cf, 
	0x045cb835, 0xf5c83eb9, 0x2e5c1a9c, 0x02fc780a, 0x83539f1e, 0xd72145cb, 
	0xa73d7217, 0x228b9706, 0xc788bf1e, 0x72e0d4e7, 0x8bfdcc51, 0x06a73fb9, 
	0xee128b97, 0x39fdc25f, 0x8c5cb835, 0x5c51fae2, 0xe5c1a9cf, 0x3f8f3462, 
	0xd4e7c79a, 0xe21172e0, 0x73d710fa, 0x18b9706a, 0xe18fe3c3, 0xb83539f1, 
	0x7d72945c, 0x6a73d729, 0xcb18b970, 0xf1e58fe3, 0x5cb83539, 0xe3fee38c, 
	0x06a73fb8, 0xdcf18b97, 0xe7f73c7f, 0x3172e0d4, 0x7027eb81, 0x9706a73d, 
	0xfe3c898b, 0x539f1e44, 0x9845cb83, 0xcf5cc3eb, 0xe2e5c1a9, 0x02ff1e02, 
	0x83539f1e, 0x95e541cb, 0x9eb893f5, 0xc5cb8353, 0x327f1e64, 0x41a9cf8f, 
	0x4b71e9e5, 0x787beed0, 0x9dfc928f, 0xee90abd2, 0x714e1d54, 0xce795312, 
	0x2aa4fd0d, 0x27c65dba, 0x75ef378c, 0xbcdd1ef1, 0x1c69d847, 0xbbf74f1a, 
	0x5b7bed4e, 0x0e781f19, 0xfdf2f21c, 0x6eda85f4, 0xe47837bc, 0xf790b170, 
	0x78dde1db, 0x2fd8f0cf, 0x7780ff0a, 0xab4743f3, 0xa0fe3de4, 0x1151fb8c, 
	0x6ddf509f, 0xefa44ed4, 0xc9af002d, 0x1c8fed71, 0xf1c5171e, 0x3af1851e, 
	0x3a1a5ce1, 0xc88ffdc9, 0xf34bc7fe, 0x8ff8e04f, 0x0fc8040c, 0x2558343d, 
	0xee3808e3, 0xbe285c48, 0x88e27a87, 0x216a7d5e, 0xe68fd5e9, 0xf1879cbd, 
	0x2c9fdb41, 0x4d7ea73e, 0x5a62cee7, 0x0fef05b7, 0x135dbd4c, 0x889f2dd2, 
	0x79a6284f, 0x615e0d9d, 0x9c767699, 0xf7f759c2, 0x7ca3bfdd, 0xa4679fe9, 
	0xf79bcfdc, 0x8b4736f9, 0x38e3e295, 0xffe7c6de, 0x7ffa1e75, 0xee32f99c, 
	0x9355ac26, 0x4b0ea65d, 0x70f419fb, 0xfc2fde2f, 0xb26fffd0, 0xaf01acdd, 
	0xda7d431a, 0x3fb90af0, 0x4905e99f, 0xf1e90bf7, 0x247e8b6c, 0x63fe98e3, 
	0x8e393b9c, 0xb8a8dc29, 0x098e2f3f, 0x525f2ded, 0x9b28931c, 0xff41fa42, 
	0xeed93cbe, 0x45d13b70, 0xca67f7ff, 0x777ada75, 0xf7138b2b, 0x4df123fa, 
	0x013c7d9f, 0xf16daeed, 0x514f1443, 0xa02ef78e, 0x51645cdf, 0xa19714bc, 
	0xe871996b, 0x255695ff, 0x208fef23, 0x9ea5f274, 0x32c33e53, 0xec7d8745, 
	0x05b79aef, 0x66f2fff5, 0x10fe8a75, 0xdfa337e5, 0xbfe7d2e7, 0x77e705be, 
	0x5f957ef2, 0x9bd26c64, 0xeab19884, 0x137007ca, 0xcafd7d2f, 0x5d3f782d, 
	0x4716b17e, 0x6e2bec3b, 0xf50adfa8, 0x8b7cff0f, 0xda5f7580, 0x27e908ad, 
	0xbff8d910, 0x4e70a539, 0x0c667e02, 0x9db1596b, 0xe8ce7c09, 0xf1859fde, 
	0x70a27302, 0xd838e2ae, 0xcad1f40f, 0x0a9648c1, 0x197c8af9, 0x67960a2f, 
	0x34b7de26, 0x780bf9e1, 0xcaff7eab, 0x2ff9c57f, 0xe2f3049d, 0x8b36803e, 
	0x6f60e076, 0x0defc0a5, 0x252bba86, 0x13b60b1d, 0x57496cc5, 0x8a89b79c, 
	0xccaf1c6c, 0x66950629, 0xe64aabe4, 0x7b94ca8b, 0x514cb297, 0x95767a8f, 
	0x186ea837, 0xf8c79893, 0x9bd92543, 0x2478abff, 0xdf4469fc, 0x84bf4859, 
	0xae57c847, 0xe13372ba, 0xe30bf615, 0xe55a2e6b, 0x967f22f3, 0xf407b5bb, 
	0x0bdfa86a, 0xdedf88f5, 0x9656fc54, 0xf2015e82, 0x3d6192e6, 0xc09f962b, 
	0x80bd25ef, 0x32af185f, 0x0007f80a, 0x09dfb1ca, 0x7e336621, 0x7fd2f93d, 
	0xef2fd530, 0x6b752eff, 0x655db19b, 0xefe8a577, 0x0d2079c1, 0x0c153c49, 
	0xc2ec7c49, 0xaf7d6175, 0xf506576c, 0xecaed095, 0x8925ca08, 0xc62fc43f, 
	0xe7bd4e45, 0x6be0ccba, 0xa4329e72, 0xcfe09cd7, 0xff64bb82, 0xbbd430b2, 
	0x487d3f61, 0xa1f48a07, 0x17536309, 0x1865b7de, 0x625ae29b, 0xd085e51d, 
	0xfe56f00e, 0x40dfcff0, 0x14de5739, 0x7178b6c9, 0xb777e87e, 0x5714a3c4, 
	0x9e2c665a, 0x479c43e0, 0x9a5655c6, 0x30f484f2, 0xd14fe758, 0x1ff11a4e, 
	0xe917bd40, 0x41d314e8, 0x81bed9af, 0x7691b5f4, 0x7f40efbc, 0x230ec53f, 
	0xd2587774, 0xfe39935d, 0x8e23c024, 0xe88bf87f, 0x7f8e4db0, 0x44abfa1e, 
	0x8935bbba, 0xe7267eee, 0xb1ad68bf, 0x60320a29, 0x74f0c79a, 0x7b4d5f01, 
	0x09c7bf74, 0x7803dcf0, 0x4e7ec2f6, 0x9be7ec7b, 0x7a7f1e88, 0xcfb4cf2c, 
	0xae573e51, 0xd3e07282, 0xec8233f2, 0xe298f2fd, 0xabf387ee, 0x0679c61c, 
	0xfd0edde0, 0x5ec01f83, 0x7ce98f75, 0x3bf224e6, 0xe92b5fb7, 0xe22c4663, 
	0x4fb92114, 0x74b03fc4, 0x708ff02b, 0x93fa9b1a, 0x478ce4e4, 0xa014798f, 
	0x0fc869d3, 0x11323f92, 0xc7eeb29e, 0x40b4a0ff, 0xf10df239, 0x2c1e2bc9, 
	0xed5dd19f, 0xf32fba41, 0x65ba0f08, 0xf078022e, 0x06569adc, 0xde406b74, 
	0xfb4fdfad, 0x03daaa7f, 0x71989c96, 0x4f15c01f, 0xa7fca9e0, 0x1dfc25d5, 
	0x75fa2660, 0x4a468fca, 0x2c8fbbf8, 0x6a3997cc, 0xcbf0ecdf, 0x12ab8c7a, 
	0x6da78f2c, 0x82e99c5a, 0xe07b4c75, 0x1e31cbd6, 0xf95fc4c5, 0xe31b252a, 
	0xf792fe3c, 0xc3b47c9d, 0x03da3dca, 0x67d7b011, 0xa0f7eef4, 0xd75f4d9c, 
	0x5603d779, 0xca54f2ae, 0xe7c83c7a, 0x7bf6a7e5, 0x646c7ef0, 0x69bebcbd, 
	0xc4bac30f, 0x05975f97, 0x448293ed, 0x796b617b, 0x858de293, 0x0de28bb8, 
	0xd6892aba, 0x7cee978e, 0xf008e513, 0x5c728371, 0xf0235988, 0xde11b2da, 
	0xcd95fe44, 0x2fac4f94, 0xed03188b, 0x8f2f2919, 0x1cacbca0, 0xf8a6ceac, 
	0xcdeee0cb, 0x23a04788, 0xf2f40e8f, 0x4c87f94f, 0x9da1657c, 0x8c78765c, 
	0x4bf2811a, 0xc80fc0fd, 0xbbbadfaf, 0xaa4002a4, 0x22547e34, 0xadfe84ae, 
	0xd72bde92, 0xb8e7fe42, 0xc44f9908, 0xee937c3f, 0x48f013eb, 0x0376cefc, 
	0xab1c823d, 0x40fd86ea, 0x7a07eab9, 0x71caf984, 0x352067fc, 0x4194f046, 
	0x2bf18378, 0x438ca5a6, 0xe78e53f4, 0x3bc9f207, 0xbfca9e92, 0x7f44b8bf, 
	0x172fc13c, 0x77d1f5ed, 0xaefe230c, 0x3f3f3ca0, 0xbdf797ca, 0xc7bf7589, 
	0xb43c36eb, 0xeeb96eee, 0x0dbd7bbf, 0x957e9137, 0x7ed9ff8e, 0xbfe2337d, 
	0x5eb9b0ea, 0xd7d25f29, 0xafebc953, 0x257f5b4c, 0x127cbfaf, 0xac17c3ef, 
	0xdf97c8d7, 0xa81d0c61, 0x7924d5d4, 0x095f32b5, 0xeb349ea2, 0x451ec5c5, 
	0xa211fff2, 0xad6e97a7, 0x8bdcf8c7, 0xaf382c1f, 0xc7a2983e, 0xf945bc55, 
	0xcb165737, 0x29bba9fc, 0x3d9df2ee, 0x51d7a98a, 0x9c48e17c, 0x4014d0a6, 
	0x3e73e827, 0xc38cdf9a, 0xca2d5e14, 0xe22b1bdf, 0x95b38635, 0xf2137de8, 
	0xf391cce9, 0xeb8996d9, 0xd1e7e44d, 0xc4ccd6fd, 0x9e784d79, 0xd29ab87e, 
	0xd42bf944, 0xe00f566f, 0xf6744e3d, 0x4f5a9e80, 0x78859c78, 0xbc42fa47, 
	0xfbc0987f, 0x33fbc42c, 0xd00f6744, 0x723a4d7e, 0x58cfbc4e, 0xdab8a3e5, 
	0xfe7f7b19, 0xcdd3de00, 0xeb5be7fc, 0x99feb07d, 0x41ec583f, 0x9076713d, 
	0x17f9c8fd, 0x86ef5105, 0xf9e208f2, 0xc23e6de2, 0xc8c96db7, 0xe9ce083a, 
	0x2e49fb5d, 0x7d33f2cd, 0x64121d33, 0x523f91a7, 0x8d3cb1e9, 0x351ccb1e, 
	0xe2672f24, 0xcf7302f9, 0xc605f3c4, 0xe92833bd, 0x2663e67e, 0x2f9ea4fd, 
	0x72879e33, 0xc17ce25f, 0xf61fb6f3, 0x339e1667, 0xe1662f20, 0x72483339, 
	0x9039f5a4, 0x78c2d78b, 0xc75e56c1, 0xa0ee7962, 0x2fb495be, 0x4a0cf589, 
	0x41f48839, 0xe83ca2eb, 0xfac4ae3d, 0xb235d7d2, 0x25f5b4de, 0x3f2031fc, 
	0x9eb3cf01, 0x940b65f7, 0x4463fdbf, 0xfd4f9e27, 0x4f3b4417, 0x66fffca2, 
	0xda7af910, 0xbf1518c0, 0x25d69f1f, 0x13f63fe5, 0x59c8e7c9, 0x3e4a96fd, 
	0xf09b68f1, 0xc7ee48dc, 0xf214f472, 0x07efd98d, 0xf105b7f9, 0xffb3019d, 
	0xd26f5c34, 0x1f139efe, 0xadfda5ff, 0x27e1e796, 0x77bf079a, 0x58e5be3a, 
	0x71e3fa26, 0x2c2fd1af, 0xb1ebf36c, 0x39f21dbe, 0xabae90a7, 0xceb7683d, 
	0xe72c9432, 0x096c4283, 0x4ae3fbca, 0x6167d4bf, 0xb8ca4d3d, 0xfa43eff3, 
	0xeef223fc, 0xcef24e88, 0xf025b3f4, 0xbf1040f1, 0xc7c74f8f, 0xfa760c54, 
	0x66ff4120, 0xebdab73c, 0x74f878a3, 0xf4e50339, 0xbdf995dd, 0x9579e887, 
	0xe5777fea, 0x82672914, 0x2cee4973, 0x3f6129cf, 0xb77c6a6c, 0x3abdbfe8, 
	0x3b4ee497, 0x67ccc1d1, 0x48ed0534, 0xcdfd2435, 0x37bc1f88, 0x6211292c, 
	0xf918b0d3, 0x503b6257, 0xc8fc99b9, 0x71826886, 0xc226ff4a, 0x4a9f2039, 
	0xbe3aa5ec, 0xb6bd924f, 0x6cf482c2, 0xc16eb1c3, 0x5ec176ef, 0xe1bca26e, 
	0xddd5f380, 0x2fdfedaa, 0x484577e4, 0x471e502f, 0x0e08823d, 0xe582f5e0, 
	0x0c87f04f, 0x9fa9eb83, 0x922a9e18, 0x7f2161df, 0x78c5da1f, 0xfa9c78b7, 
	0xc6849de7, 0x27913ace, 0xa9c7de30, 0x271811e9, 0x896153fb, 0x05e6de40, 
	0x7cf30f31, 0x231fdb0d, 0xfcae22bd, 0x5a458840, 0xbc008d48, 0x4fda61d7, 
	0xe2e7d1df, 0x02229abc, 0x29d03e32, 0x1d619bf4, 0x89d5116e, 0x843e02bf, 
	0x71c2cb23, 0x27e15efb, 0x0ed9d17e, 0x69fa3676, 0x1d786a9f, 0xbf2b9e9a, 
	0xfcb1086f, 0xded43917, 0xc10fdb2b, 0xd0b5fa1f, 0xd0a8feac, 0xf93e083b, 
	0xab4c045e, 0x0af6a74c, 0x0138a3c2, 0xf75a66de, 0x9bcf8a7e, 0x7e38f9a6, 
	0x301bf7d1, 0x5e812dd8, 0xff52187f, 0x03722b77, 0xdd2efc36, 0x4a81fbc8, 
	0xd78739f5, 0xc500bf53, 0x32bdadfb, 0x48467680, 0xa9a7f913, 0x98ffcf5c, 
	0xd43c1152, 0x9be0f949, 0xb7828a94, 0x37e0be64, 0xc76c5a90, 0x00337172, 
	0x9fb81d0f, 0x11184ea2, 0x39afefbc, 0xd97a4392, 0xed77e58f, 0x88975d46, 
	0xda1378c9, 0xe80cb55f, 0x5f84ddf3, 0x7c945542, 0xcda31f7a, 0x1030f647, 
	0x85e33e74, 0xdd0053e2, 0xa7a42e96, 0x9fef60f9, 0xef99f090, 0xbe1c608e, 
	0x9129a3d3, 0x7c9eb443, 0xd1c3de83, 0x35298782, 0x5e084782, 0x1da8e0ad, 
	0x5269d7df, 0x657f74ac, 0x2577d014, 0x3952c7ec, 0xca40bcbd, 0xef594ffb, 
	0x53205459, 0xf44bc327, 0x40788b3b, 0x302bef97, 0x25a9d61d, 0xa15e9744, 
	0x6835dd11, 0x59db8411, 0x9e2dfde3, 0x62aa25d3, 0x893778e9, 0x30a29dae, 
	0x9d3a7fa5, 0xa2228a0f, 0xdf984307, 0xbf251471, 0xf74e901b, 0x1ee3f416, 
	0xf2fdd04b, 0xc94559e1, 0x76f42bf5, 0x13e09fea, 0xd75784cd, 0x3d5e099b, 
	0x419b7142, 0xe215cfa1, 0xfc8215db, 0xfd602d71, 0xc0ac3f20, 0x1a66970b, 
	0xd326b75f, 0xf887ae1f, 0x24f0aeac, 0x9428d9e1, 0x45e8cbef, 0x0d539fe4, 
	0x2a06e8ed, 0xd074192f, 0x524ea3bc, 0xf5c28c6a, 0x7c24fe8f, 0x314f7e23, 
	0x1a7ef10b, 0x823eb7a7, 0xd15ccb78, 0x772c5bf2, 0x1f560f34, 0x1de73fd4, 
	0xc971238a, 0xaa42d727, 0x0a1dff9c, 0x6521b110, 0xe97bdb08, 0xfdb30add, 
	0x4a4be1ea, 0x0374f192, 0x72cb75c8, 0x94103768, 0xb1d45bef, 0xf6876b1d, 
	0x05bf4137, 0x0750e25d, 0xbf5523ad, 0xf2867c3b, 0x91ce1eeb, 0x4df8d3fb, 
	0x7b478efa, 0xf40bf8bd, 0x9038a03b, 0xefd7e7b3, 0xbe71e6d2, 0x850bdf4a, 
	0x79e52f6a, 0x2679a5af, 0xc17fe715, 0x773e8b3c, 0x6db5ec9e, 0x1207d416, 
	0x74f819f2, 0x993e8930, 0x904e5d9e, 0xf429d5db, 0x8d27f2cf, 0x241ef17e, 
	0xca75be85, 0xc39034bb, 0x37f24935, 0x67363148, 0xfcba73d1, 0x868e8155, 
	0xf28901d0, 0x5dcb317b, 0x89b7212d, 0xe427a78e, 0x249749b4, 0x200f09af, 
	0x5cb20f38, 0xcc95fc82, 0x3d7c23cf, 0xefff5722, 0xdb9271c8, 0xf9485f34, 
	0xb728262d, 0x27dd4e09, 0x28316bdf, 0xb7c7f16f, 0x7658fee1, 0x80bdf80c, 
	0xb6fc9ccc, 0x972429dc, 0x29619cb5, 0xae6f03c7, 0x4b5fc84f, 0xa15fd1ce, 
	0x1f59d77f, 0xa699200a, 0xd9addfcb, 0xd29fc506, 0xd3dd263d, 0xd25c670a, 
	0xf34e3389, 0x07194eea, 0xbbe5386f, 0xf985c217, 0x2f636e7d, 0xc3ef7bee, 
	0x2cb0efd7, 0x5151ba21, 0x4cdd076f, 0x2cdaf5a5, 0xf4177be6, 0x2e994cce, 
	0xf86b1aed, 0x7cd0556d, 0xd867cf3a, 0x35bd5d70, 0xfde9ebb9, 0xbdf942a9, 
	0x81fde37a, 0x1fb03e79, 0xdab4d7dc, 0x75eaced0, 0x87f41e8b, 0xa8efc28d, 
	0x5ee7de40, 0x884af60e, 0x61fbe9ca, 0x878ca14b, 0xd61a351d, 0x2fbf0db3, 
	0xcf005000, 0x0f94834a, 0xd0e289de, 0x278241d6, 0x62fb4e3b, 0xe975cb64, 
	0xf3aeb8d9, 0x949093ca, 0x7195fa27, 0x2cf6afda, 0x1728bbe3, 0x97d8ac57, 
	0xeb38c0ab, 0xb2d63a5a, 0xfdb4827f, 0xb5b15975, 0xe804eed2, 0xae1f84f4, 
	0x22dcd964, 0x9c59c00b, 0x7f421b51, 0x8f6842ef, 0xe5aebbe4, 0x9fe4b585, 
	0x692d9deb, 0xffa1fa0a, 0x8bd65d6e, 0x273be96b, 0xd621ef21, 0xf39a8ded, 
	0x9dc72514, 0xb96a742d, 0xc6ada051, 0xc31c658f, 0x71a7a80a, 0xc72f3ef7, 
	0xc844b96d, 0x87df007f, 0xf780f74c, 0xbd294685, 0xc809f50b, 0xf26ae0d9, 
	0x4eb8e897, 0xffa18e13, 0x7ec758ec, 0xab2422c5, 0xc92eafe3, 0x2feff64d, 
	0x1a31d53c, 0x486231e3, 0x2a62ef3f, 0x12bbf07a, 0x3fecef7d, 0xdd324204, 
	0xbce383d4, 0x824d4eb0, 0x967fa463, 0xa0e363b6, 0x09eab74c, 0x5eff537c, 
	0xe2161fee, 0x3bc6551a, 0x8a2bde34, 0x2cdd02b6, 0xcec9603c, 0x7b97f183, 
	0x7df8d1f4, 0x0ba442c4, 0x7c338843, 0x07fdeb2e, 0x227899d6, 0xfbca0876, 
	0xe3178259, 0x7b05304e, 0x583f5d64, 0xfe22ef67, 0x9c6116e7, 0x667fde89, 
	0x01247a9d, 0x6179fa67, 0xaa341dc6, 0xafe8b9d5, 0x964ffe3d, 0x7bf78e10, 
	0xbe93c1d4, 0xbc71d5d3, 0x2f91481c, 0x15470e80, 0x33fdff4a, 0xa603eed8, 
	0xf73b8057, 0xef7e92eb, 0xcc211428, 0xd79ba9ef, 0xf756f28a, 0x3e9172c6, 
	0x9159a284, 0x2748225f, 0x285a7798, 0x00f7b0bf, 0xfc8403bd, 0x3bc17e80, 
	0x940edadc, 0x47f4d7cb, 0xebe7c8ad, 0xd40df9f6, 0x8d392c97, 0xe68fc81d, 
	0xd7eb0b7c, 0x3f613967, 0xdcb47a16, 0xcfd8cd8d, 0xabdf1478, 0xb4783e00, 
	0xd3dbc60b, 0x2762c4fb, 0x3a0a1bb4, 0x7691de89, 0x3e239cf0, 0x0bbe416b, 
	0xf80e7ccd, 0xee55df44, 0x6e09d80c, 0x077bce2b, 0xd6f1e1c3, 0x9d9fa2e6, 
	0x7083d1d6, 0x5e6e12eb, 0xc06b3ac7, 0xce3bbf40, 0x709ad38b, 0xd21708e9, 
	0x3684478b, 0x13af2736, 0x617203d6, 0xb16a788f, 0xb86cf073, 0x71a79f08, 
	0x841f12dd, 0x7ac4c1cf, 0xbf20fd68, 0xe63bf932, 0x138b62ac, 0x37bc4c76, 
	0xdc2188c1, 0x63c55799, 0xc3ed4ba8, 0xd7c87838, 0x20b01d37, 0x942d2efe, 
	0xbd7e6ddf, 0x9bec86b5, 0x33a136a1, 0xd005581f, 0xa8a64677, 0x2d7ba0ee, 
	0x68b96361, 0x72093945, 0x73bf03b6, 0x3c5c97d1, 0x1597f30f, 0xacf23b4a, 
	0xf8da1ef7, 0x791e9cfb, 0xffbe67bf, 0xf1dcb1a0, 0xcf933487, 0x285f9315, 
	0x5af414be, 0x941b73e4, 0x87f07ca3, 0x877f24da, 0xf31938e5, 0x4c4d5c24, 
	0xef1c596f, 0xa5e4b39b, 0x6fb41758, 0x93fe942c, 0xcdf78e2c, 0x0c52f559, 
	0x9672c7ef, 0xff127d41, 0x5f71bbe1, 0x910afe6e, 0xf98bbf3c, 0x4bed6734, 
	0x395ec3b1, 0x71a482ce, 0xdafcc196, 0xe7f8a4a9, 0x97cf182f, 0xa14b1ef8, 
	0xeed3aaef, 0x7e0d6d4f, 0xa0fd6bb2, 0x5d81e4d7, 0x5ef886db, 0xd067ef45, 
	0x5c25813d, 0xc64f72c1, 0xaf71a909, 0x690add88, 0x0f7e5797, 0x23b8aa1e, 
	0xbcc21ef9, 0xbed674e7, 0x74154d74, 0x85e77e75, 0x0c1e486b, 0xbb483cb3, 
	0x162facf7, 0x0bef8c36, 0x62d7dc70, 0x02eb6eab, 0xd16c5e7a, 0x25cf886c, 
	0xe436e9cf, 0x357b25a7, 0x4ff2139b, 0xe23b4a17, 0x3e472866, 0x71ca19bf, 
	0xfd673721, 0x36e913b2, 0x2d549fb7, 0xa424fcd1, 0x27e69780, 0x2cbc0520, 
	0x27d3927d, 0x7fcf2a0c, 0xf6c3683e, 0xdbab1ef9, 0x1f967c0e, 0x1f23d630, 
	0xaef49e05, 0x77a67a47, 0x8bde8069, 0x072b079e, 0xbc2f5f30, 0x40f7f139, 
	0xf8bc056d, 0xd46aaf40, 0xe41c5e45, 0xb16abd53, 0x37037fa1, 0xd3a07ee7, 
	0x941e10eb, 0xfc1f0823, 0x27f386bb, 0x607181de, 0x3962d7c1, 0x72c5afe4, 
	0x298457f8, 0x2bd793c0, 0x41bddcd3, 0xa48e094a, 0x9df3097b, 0xe0179a1c, 
	0x1e8a77a8, 0x3f3c53ef, 0x011bdfc8, 0x1bff886f, 0x8eb86f01, 0x4ef4ff1b, 
	0x06e5e227, 0x8606ff9e, 0xde50bba7, 0xd872984b, 0x29d08fa5, 0xfb44af7d, 
	0x06617a06, 0x712133eb, 0x73d91260, 0x86b8e9df, 0xe347b5e3, 0xd3aae079, 
	0x5ea7c8ed, 0x3c53b75d, 0x68afa9ae, 0x5535dfa6, 0xe6bd215f, 0x072deb18, 
	0xb6b91f40, 0xd0f78622, 0x76177385, 0x6e8e9be2, 0xe36ab1bb, 0xba528c21, 
	0xe4153c38, 0x54fcdd62, 0x5e36883f, 0x07ec93bc, 0xff4f3b99, 0x297df26f, 
	0xc0b90883, 0x0baad577, 0x65fb7fa0, 0xa0b2bbe3, 0xadaad3bf, 0xeae9efc0, 
	0x8c96ca2b, 0xe913f692, 0x2d137947, 0xef13d42e, 0xfdabfb98, 0xda016fa8, 
	0xf7df286d, 0x0ad8d734, 0x6b9a4f41, 0x1e5e6fbf, 0x924505a4, 0xb8dcf60f, 
	0xf8029966, 0x4fcdf7db, 0x7db3886c, 0x9327690e, 0xfb7c85dc, 0xd66a17e5, 
	0xbbbebf24, 0x04f7e248, 0xef342dcb, 0xbb475f48, 0x30b7ed01, 0xcf1fcff0, 
	0xc6f61fcf, 0x6557c95c, 0xf7c957c0, 0xc4e2137d, 0x71d5fa37, 0x29000871, 
	0x4112505c, 0x48baa8ff, 0x9c24cf7e, 0x8bdd71a1, 0xb8dafd11, 0x8e6fa96e, 
	0x757296eb, 0x379c375c, 0x653c00ef, 0xcb5bdfb0, 0xf3a5b0e0, 0x609de840, 
	0xe8f9ee7f, 0xffc5288a, 0x60637c23, 0xd6ce1f5f, 0x3a157be5, 0x373d8bc9, 
	0x5801d16b, 0x686f9eff, 0xe0930451, 0x0dedfe87, 0xecf41fd0, 0xc1d38c1e, 
	0x7e4eaf73, 0x2cfa487f, 0x7ed13ba4, 0x83e51c78, 0xf9bce52f, 0xa62f75dc, 
	0xe81d867e, 0x3c60780f, 0x8f549fc5, 0x6f94e9d8, 0x1d3e65d5, 0xe35f403f, 
	0xc3499ce9, 0x9f0dfb53, 0x57bd468c, 0xa339b7ad, 0x8fb7d821, 0x17e423b2, 
	0x2c1fe1b9, 0xbab83df8, 0x3ec81fe8, 0x121753db, 0x993aef58, 0xecd8ef4d, 
	0xb4637f9b, 0x737bca01, 0x627afd60, 0xd15df77f, 0x26f0ad10, 0xc0b4df7d, 
	0x63fa3efb, 0xc7ff2fda, 0x5e89fa1f, 0x0786f08d, 0x78a09f48, 0xcb9c0719, 
	0x56e78e78, 0x7c8ede0c, 0x197ae748, 0x4286fb9e, 0x7e451d7e, 0x1908ebe7, 
	0x7c2be90a, 0x2ab3036e, 0x49ac7df8, 0x5e05f667, 0x711f593d, 0xae74e854, 
	0x6fdcf0bb, 0x9b1befe2, 0x8ac4de29, 0xfce7e9f5, 0xd21eba9e, 0xed31724b, 
	0x7ce93827, 0x4345fd27, 0x28fa6eba, 0x67f90f3e, 0x679947e9, 0xaf57db00, 
	0x2bbde0b5, 0x20728b8e, 0x8d983750, 0x0020567a, 0xbfbf1af2, 0xf36421bb, 
	0x5021e125, 0xeb822475, 0x9035540b, 0xa4b5c417, 0xde7fee90, 0x7c987e06, 
	0xebfe6cea, 0x2dbc62bd, 0xf8357280, 0x0502faec, 0xaf55cfa5, 0xcf887ae0, 
	0x2f3be60c, 0x3fee69f2, 0x1ebc49e7, 0xba44caee, 0xf78a31bf, 0x7c45aec8, 
	0x7405f02f, 0x4922e7ff, 0x9a9d26f7, 0x62f44ff4, 0x2fe2e9d2, 0xba24b7a6, 
	0xdc7bf036, 0x5b39dbf3, 0xc4c37fa5, 0x8c17f33b, 0xa3fd0cb7, 0x60d5fc23, 
	0x3cfe84dc, 0xe626abe2, 0xae993d33, 0x7a27de1a, 0x9d9fd34e, 0x7d6c4356, 
	0x91dae505, 0x04ee8b8f, 0xd5f0b07d, 0x81c7bc42, 0x741c53ff, 0x22b2e179, 
	0x704b3f7c, 0xe81dae3c, 0xd205bf57, 0xed1eb122, 0xe25f80ff, 0xc1d3f5cd, 
	0xd763d44c, 0xe7b8c914, 0x2394a140, 0x991a9fae, 0x7772e4ee, 0xefbe3da2, 
	0x41f7f582, 0x517aceda, 0xf38c9177, 0x4bc4bfaf, 0x51bdacef, 0x4aefbf28, 
	0xd3371fa7, 0x5ba03b8f, 0x37dc7e90, 0xe99258f4, 0xe3f4cdc7, 0xfa9fa34e, 
	0x867435af, 0x025dce41, 0x79818cf3, 0x79c86f9c, 0xecb35784, 0xa82b7d81, 
	0x930cec69, 0x3cb35b83, 0x39fdeb0e, 0x839f0bb4, 0x3f735cde, 0x9cef8659, 
	0xb26aa9ee, 0xfce49305, 0xfaff7c88, 0x41e50da0, 0x1795bd3a, 0xefc22f6e, 
	0x8a3e6096, 0x7c2f2e67, 0x69d7e248, 0x7d65bbe6, 0xa0bbe250, 0xdf13e806, 
	0xf1265b7c, 0xdfeb0ed6, 0x57f87805, 0xc01a6b80, 0x50feced5, 0xe0272f38, 
	0xfadad9fb, 0xf8a37a11, 0xfd2ea72e, 0xf2457d23, 0x5c7270fc, 0xbe37c51e, 
	0x97cf7286, 0xc7405f42, 0x23d56ef4, 0x7d0b1d26, 0xe91bc7e2, 0x92289b5c, 
	0x167b0bfc, 0xf48ddc2c, 0x49f8fae4, 0xa672828b, 0xa445b34c, 0xd2017efd, 
	0x21d5ee75, 0xdfcd529b, 0xc681fe5d, 0x011c2309, 0xf307b18f, 0x8fe32aee, 
	0x09ef9811, 0x38dd9fe6, 0x9be234df, 0xe6f8d20b, 0x79be6482, 0x9bfa47a2, 
	0x575cb376, 0xebcc229c, 0x263fb309, 0x0bb2fecc, 0x7820ced0, 0x5fc39f7d, 
	0xe57f2a5a, 0x468e0fd6, 0xdf94c23d, 0xce9c5ea6, 0x1c97f537, 0x36e2f679, 
	0x67f7afb9, 0xf715e826, 0xf1f61bb5, 0x569fdc2e, 0xa0a04fdc, 0x6ce824bf, 
	0x3d8f9423, 0xe48ce925, 0xe3edc62d, 0xf0d1bff6, 0xaf1ca96e, 0xe78c337b, 
	0x1468e4b8, 0x2af48df1, 0x748e1700, 0x4a9d9d3a, 0x4b1417a7, 0x0c79753a, 
	0xfda7e20b, 0x057615f2, 0xcde333e8, 0xa52eb090, 0x8f38bdf2, 0x154eef29, 
	0x3a4cbf49, 0xc51d035d, 0x7a428fd0, 0x439f6bcc, 0x9cbfacdf, 0x24a7df4d, 
	0x9b7d333d, 0xe980b572, 0xa4b16276, 0xdd0482db, 0x621c5296, 0x52fd30a7, 
	0x26c748a5, 0xd98b5add, 0xc1f18faf, 0xb1b58724, 0x4de9b714, 0xbf6003d5, 
	0xf79f114b, 0x4a119fb3, 0x45dc7ec7, 0xe74b18eb, 0x9f6e8240, 0xf5d5f3c4, 
	0xdba49366, 0xe94fa006, 0xee7922ef, 0x28b1efae, 0x719e69fb, 0x9dbc0798, 
	0x748abc88, 0xe90f7c6c, 0xe3fde496, 0xb5bf3909, 0xbf3dfa41, 0xb9e3de48, 
	0xc8fa9ba2, 0xde573ca0, 0xe8073a4c, 0xfdfd70fc, 0x75e000e7, 0x466bbe19, 
	0xbde11ff2, 0x2a82c9aa, 0xec77a9ac, 0x8e237d41, 0x033d02eb, 0xcf80a9d2, 
	0x3fe75386, 0x99178e0f, 0x2a281f72, 0x5e331f69, 0xfcfc92f7, 0xd02fd21d, 
	0xa022c14d, 0xfa0963cb, 0xfe3d78cd, 0xc6dfa637, 0x81b41648, 0x32fdf079, 
	0x5bd03d77, 0x5507cb1c, 0xcd52e7e9, 0xdde8b2f7, 0xd1d59c8e, 0x984ff44c, 
	0xf01f81f6, 0x5e7a89db, 0xef4eb67c, 0x7b4b7627, 0x9806ec91, 0x1d14dfcf, 
	0xfac26d67, 0xfee05d0a, 0xfd50e787, 0x6c8e7850, 0x6b459e1f, 0x921d9f39, 
	0xc39c476e, 0xef84990e, 0x321d81a3, 0x32b3df09, 0x954310ed, 0x34971ded, 
	0x3bb6491e, 0xd544b72c, 0xef6cd009, 0x67e25cdc, 0xbd00ff18, 0x1d0f699f, 
	0xf64b58df, 0x368b82c7, 0xd0fecb9c, 0xd8a4b75b, 0x9dc2c61f, 0xa3fb09c3, 
	0x5e3d68c6, 0xc7f64b50, 0xcf03b732, 0xd9efd0e9, 0xa42ba8fe, 0xddf9197b, 
	0x851975c5, 0xc351fdf2, 0xaa8087f4, 0x298df307, 0x7c4dfc91, 0x60f8f28c, 
	0x0be11b8d, 0x4b257be2, 0xd3d60f89, 0xea1c5cef, 0xc73c62f1, 0x6c27e2dc, 
	0xb8738f78, 0xc1d39e44, 0xaf7984b7, 0x6ff703bf, 0x4fe968e5, 0xbfd7b85c, 
	0x0b31fd15, 0x9f3cb52d, 0x2dbc4211, 0x1eaf771c, 0x3ff481eb, 0x997e9ae7, 
	0x115e5431, 0xf32ebce3, 0x7dcbc87e, 0xceb0a909, 0xf517b185, 0x175fd02a, 
	0x76a3fd5e, 0xdf859fdc, 0xadf31482, 0x40f4ca1f, 0xab7f2c85, 0xa383f282, 
	0x7ec06f60, 0x5ceff85d, 0xd28daa7e, 0xbe32d9ad, 0x32c52ff8, 0x1961746e, 
	0xddd1738f, 0xf1c82aed, 0x9f323585, 0x21715cbf, 0x5bd635ff, 0x4fc8765d, 
	0x87637ff0, 0xfeb73d00, 0x88e3e0bd, 0x4f43fcf7, 0xbff9438c, 0x2f1e2110, 
	0x8daeb7c4, 0x3ec1f76c, 0x6c63ba8c, 0xbe036f9d, 0xcdf32a27, 0xf9d4c7f3, 
	0x66561f60, 0x007f1e0d, 0xe5fd44ec, 0xc81caed2, 0x644b735f, 0x2fc856e0, 
	0xeba859fa, 0x4dbf6836, 0x0adb1ed5, 0xc2a795f9, 0x92fb616f, 0xcc7aae27, 
	0xfb78f907, 0xbc70b7d8, 0x29aa93c5, 0x7a12d0bf, 0xafd42b6b, 0xb727f550, 
	0x35890c82, 0xa637458f, 0x9f75b928, 0xcfe40cab, 0x4ef5cdca, 0x73ed9c1f, 
	0xf6a6aebb, 0x5296a7eb, 0x6ab30dff, 0x3a78431e, 0xf8d294e7, 0xa5cfe653, 
	0x8f975bfa, 0xb782faa1, 0x6ff5fd65, 0x6b1f2887, 0x7c1d9b9e, 0x50ddc685, 
	0x035efc00, 0x389d1582, 0x3b839935, 0x9779801e, 0xfe8a3283, 0xb6d78ec7, 
	0x27f6307d, 0xd42f3e50, 0x68e409ba, 0x9ded78cd, 0x72ee301d, 0xe7786847, 
	0xb3d76c06, 0xa43ceb7c, 0x8be2fec7, 0x7ebd63b7, 0x7fe266f9, 0xdf7e1d71, 
	0xbf449409, 0x7813503f, 0x3bbe1e62, 0xfbf0ea37, 0x12f7f0f3, 0xfd8c338a, 
	0x0bf3e051, 0xcf890b7b, 0xf5dafc2f, 0x819b886f, 0x59145ee6, 0xaeb937e8, 
	0xffd050c6, 0x8d48e8b5, 0x6a1def1d, 0xbb7cf87f, 0xf8cb53f4, 0x468feb8c, 
	0x25c748ed, 0xfa036d6e, 0xb7e9af37, 0xbafe6064, 0x22af82f7, 0x40775ceb, 
	0x197ec9d8, 0xfa80dd6a, 0xaf3f2997, 0x8280e17b, 0x10c39976, 0x26af0476, 
	0x63b5d8d7, 0x42c7fa3f, 0xea2179f8, 0xa0feffc1, 0x9d755f94, 0xbdae5859, 
	0x354bbf29, 0xd366365a, 0xed007739, 0xf93afcfb, 0x7eab8e7e, 0xfb13d905, 
	0xfbcc5f98, 0xaf7ed30e, 0xb825ba05, 0x7dbf488f, 0xb7666fed, 0x547a7d93, 
	0x916ad1fa, 0x5acfe17e, 0xa37c5fa4, 0xe7be44a7, 0x4dbb3b55, 0x79417ea7, 
	0x921430bf, 0x7f68a0f7, 0x93b1e4ea, 0xb6762571, 0x9f656dff, 0x4cdbff6f, 
	0x669c3ffb, 0xcdf9a7ff, 0xa3d04e56, 0xa235dfc8, 0x43217f0b, 0xf7e50f7c, 
	0xbdc7cc69, 0x411297e8, 0x52ef8e3d, 0x983eafe6, 0xd0357a81, 0x03fa8f4d, 
	0x8fd38fbc, 0xb44ee07c, 0xf4117bef, 0xa6af805e, 0xa887e3b5, 0x840cd79f, 
	0x7a9fa20e, 0xc96ee5a1, 0x25bb81af, 0xbce04e5f, 0x9fcca7c9, 0x3097c87d, 
	0x53e442fe, 0x413e6fac, 0xd27f01e3, 0xf3a411af, 0x905992e3, 0x79bcba07, 
	0x37ca18ce, 0x4bf597cf, 0xf9fc90af, 0xbf997ccd, 0x37ccb469, 0x17ed944d, 
	0x57ed954f, 0xddcd3566, 0x5bfc8b54, 0xcdfe4e73, 0xcca7c557, 0x1bf983bf, 
	0x9ffd7f90, 0xbfc078e2, 0xfed0f983, 0xa9f28706, 0xadf22e6f, 0xe6c69be4, 
	0x1e704a83, 0xd77fd7f2, 0xbe413e8b, 0xb9fb50f5, 0xfda9d35d, 0xca16a9fa, 
	0x4a55986f, 0x81ce75e3, 0x5be421fc, 0xcbadde39, 0x782faa15, 0xff5fd65b, 
	0x637ca0b6, 0x940ad8f3, 0x6f2b25fb, 0x3f672cab, 0xf2974c15, 0x89a6337d, 
	0xeaf6eb7d, 0x3d5e6fb8, 0x3749df8e, 0x7e72f971, 0x64256aaf, 0xdb67437d, 
	0x419d7a55, 0x101e9576, 0xb0dd2393, 0x2684371f, 0x7d55db27, 0x61354f68, 
	0x008f5f1a, 0x055da1e4, 0xf4174fe7, 0xf67adc99, 0x64b79439, 0xcfe401d1, 
	0x45179bfa, 0x7394c6c5, 0xf92e582b, 0x3371b9cb, 0x4a0b9f9c, 0xd39da1f6, 
	0xf0ed25f7, 0xafffa51d, 0x7decf0ed, 0xdf7876c9, 0xd8b87659, 0xb170ed27, 
	0xef0ed92f, 0x3cf0b25b, 0x5d3eb876, 0xeea7e1da, 0xd7f8efc5, 0xe0963615, 
	0xbf66d8bb, 0x0fd862fa, 0xefe7f43f, 0xf2426b96, 0xf296e13e, 0x7d6fc9eb, 
	0xa0dfc5cb, 0x7d969a28, 0xf2db3fd2, 0xfcf946ba, 0x5f880743, 0xbbbcf8f3, 
	0xfda1eb15, 0x13af58ad, 0xe4fdd37d, 0x8422e575, 0xe80bcdeb, 0x2d33f436, 
	0x4f2076c3, 0x41bb6197, 0x68cb83f4, 0xe97edc9d, 0x31102e6f, 0x6a205fea, 
	0xb6681f29, 0xbf202d38, 0x145f5d17, 0xaf96efc2, 0x7c21aab7, 0xa2d1622f, 
	0xea17909c, 0x0dbaa3f5, 0xdeb843bf, 0xf93d52a2, 0xfa5f01e7, 0xf286cd11, 
	0x517279b8, 0x9a93ef08, 0xa64ce527, 0xa5fa526f, 0x57afbe9f, 0x08afe9fa, 
	0xe3683f49, 0x18c98e4b, 0x6dfe408f, 0xc98bef28, 0x8dcfc871, 0xe42c27fc, 
	0xe93c0ecf, 0xcb7cc1ed, 0x8b72179c, 0x16bcdce1, 0xde357fe9, 0xb7f6ca13, 
	0xafc6f82e, 0x6139ff50, 0x3c21fab9, 0x9e1f89ff, 0x41ec3a22, 0xb2ff48fb, 
	0xf3e2d07e, 0x7d2541f9, 0x6d1efca8, 0x507e59df, 0xa6418ba0, 0x83b52813, 
	0x3b1d8f9c, 0x29b41f87, 0x3f0ffff7, 0x7179da68, 0x8c98a147, 0x84f78274, 
	0x9a420f24, 0xb98dfd05, 0x28edf8e2, 0xb1fee83f, 0x308efd89, 0x9012dd8e, 
	0xf7c1a83f, 0x44fee98e, 0x4e2e53f2, 0x6bfeb7dc, 0x72338cb1, 0xe2b01c4d, 
	0xca7e4849, 0xfa22ff24, 0x1f7db11b, 0xfc700fce, 0xbcd7f794, 0x88f3ecbf, 
	0x78454450, 0x7e4c5a9e, 0xd0cb4c52, 0x825439ae, 0x909095fe, 0x639e0d76, 
	0xc88cffa8, 0xc087d64d, 0x77e38840, 0xadab7d95, 0xc5ffba1e, 0xc68caf73, 
	0x8e391c9d, 0x0d86a2f7, 0xf387cfc7, 0xe220fac9, 0x9dceb627, 0x2b6ef7a4, 
	0x43a87195, 0x875c5fd3, 0x5f799ce7, 0x0bee6607, 0x8bfe515b, 0x8f519fd0, 
	0xbd9685d2, 0xba7ef48d, 0x85eb1142, 0xac7dd4f6, 0x63007547, 0x16d59674, 
	0xc719fbe1, 0x8c9d6dbf, 0x595f610a, 0x19008c6c, 0xa38ce2b0, 0xf786df47, 
	0x09fd2f9a, 0xa79a6ef5, 0xe8afe122, 0xf4fdf213, 0xf49fcb15, 0xb6ff60ba, 
	0x3e2b3c32, 0xa8fc9076, 0xf87d88f6, 0x89c20dee, 0xac354bfa, 0xfb29ef07, 
	0x71425d96, 0x9c629802, 0x0af70980, 0xc02fbdfe, 0x2877bf4f, 0x6f046fd1, 
	0x6d82f623, 0x44f7b4ab, 0xca0fed11, 0x9d0fda05, 0xf84295ee, 0xddf03d3d, 
	0x7517d7e2, 0xe3759da3, 0xc6de8b1b, 0x3959e7df, 0x217d905a, 0x3bd51a9c, 
	0x287e816e, 0x2905be77, 0xb425dde0, 0xe70f1c1d, 0x9d164c3c, 0xf3223ce1, 
	0xef32a3ae, 0x7354a41a, 0xf779949f, 0x319f5929, 0x8619f32c, 0x1cf3078c, 
	0x0d6517a6, 0xcf9911cf, 0x99f32a3c, 0x596a9483, 0xeb3e6527, 0x1ecfac94, 
	0x5c6cf996, 0xc02f75cf, 0xb7f404e9, 0xea81d472, 0x2d5fc451, 0xf22fd1eb, 
	0x6c93e9d5, 0xf3597bf8, 0xcdb61d67, 0xedef80de, 0x845fa3e9, 0x9ebf75fc, 
	0x922e39dd, 0xdfeb5bd0, 0xf780dc28, 0x6afdd753, 0x828a63b6, 0x523eb438, 
	0x9f2bf509, 0x0331d87c, 0xa463ddd2, 0xa6efb37d, 0xcfd01b35, 0xb91af162, 
	0x7b7e6e78, 0xfc16f3ea, 0x9edaa51d, 0x0e1fa901, 0x1aa1df98, 0x74a7f7f2, 
	0xef313fe9, 0x1a8df293, 0xa27202bb, 0xc9f58fb6, 0x29b4d981, 0x8f79ffb5, 
	0xdc7bf3cc, 0x3a03a5b5, 0xc357a1e9, 0xf83728b8, 0xdf6a2af7, 0x355edb5d, 
	0xb5e9e900, 0xdfb54f52, 0x0bef5323, 0x05f4bcb2, 0xf9ce9f99, 0xf0da72af, 
	0x1e22a511, 0x6af2843e, 0xfc5a5fc4, 0x9220adac, 0xddf747b0, 0xcbf257f4, 
	0xf92318ef, 0x276be6bc, 0xec2207d6, 0xdc482fb7, 0x09bf91a7, 0xc632d6d6, 
	0xa432defc, 0xbe8fbfb0, 0xa5bd55df, 0x93c006ea, 0xd306fd0b, 0x84fecf20, 
	0x1b25bf3e, 0xca1f5de5, 0xbf47ac21, 0x5f924f41, 0x39d72421, 0x047ec754, 
	0x687a7796, 0x942c5d78, 0xf7352390, 0x57fa0a1a, 0xc1431e1c, 0xcf8f44ef, 
	0x2bfde831, 0x936bbe07, 0xb1b57a83, 0x0a777cce, 0xf7fa9ef9, 0xc1d0f826, 
	0x51deae7e, 0x3be07e12, 0xf91ce905, 0xe93a074f, 0xfc90ad2b, 0xe5c52906, 
	0xf340345c, 0xce133c53, 0xc1ed281f, 0x04ed0a73, 0x12cd571c, 0x05377a11, 
	0x3f408dd2, 0x53ff5bba, 0x41f081ac, 0xf5e34034, 0x6ef878f2, 0x758184ed, 
	0x7cd6ff68, 0xaa837acc, 0xecf3c64c, 0xe4e97e78, 0xa7692eb2, 0xbf1e3ee0, 
	0x883936c5, 0x4a6b0b78, 0x73ca2d59, 0xce4104a1, 0x3ddda2d4, 0x3caf6490, 
	0x49d256bb, 0x4e3225d3, 0xc13ec922, 0x15ab27df, 0x0073b49a, 0xdd4f241e, 
	0x6d49ffa2, 0x7d71e448, 0xb7fc6794, 0x338ffe5f, 0xb0ffa473, 0x83be136c, 
	0xbd70a4b7, 0x63f2c638, 0x67a7ea23, 0x6e492514, 0xfa807c90, 0xbe830abe, 
	0x417dc2f3, 0xa2f415bd, 0x07140450, 0xc85086fd, 0xa772c837, 0x48772127, 
	0x7f5e408e, 0xd90761aa, 0xb8c8b781, 0x10f11c13, 0xf9dd09c9, 0x767b8ca6, 
	0xaef325bd, 0xfbbcc8df, 0x87bbccb8, 0xb4e33e64, 0x2c7c67cc, 0x67191ef3, 
	0xa4de7baa, 0x25be6454, 0x91bf99f3, 0x32e3acf9, 0xf324359f, 0x3e65a7d9, 
	0x960ee3fb, 0xbdaf0027, 0x31fc91bc, 0xad963319, 0xbf857bc7, 0x6cac8e57, 
	0x057e647d, 0xdfa791ca, 0x623946a9, 0x45b98fca, 0x39c444ef, 0xfb57ede4, 
	0x18656d4a, 0x4cf53e17, 0x6f95ca2e, 0x5c5075b7, 0x7ad1cacd, 0x1fb916e7, 
	0xc9780f15, 0xe31dbc6e, 0x6cfcea31, 0x4581d637, 0x7c1fa491, 0x3a267a59, 
	0xc0737d86, 0xff36751e, 0x13e7a26f, 0xffe227cc, 0x550f5d3c, 0xc353af0c, 
	0x5efa75ff, 0x0e39d317, 0x16255351, 0x0d3d5ebb, 0x3f8d759a, 0x12d9096a, 
	0x29d7befa, 0xd9c38c54, 0x519bf059, 0x83ec0f18, 0x187f14f6, 0x87f1901b, 
	0x2ffe525d, 0xa19fe877, 0x1edcba7d, 0xf0bbc50a, 0x58fe221e, 0x6daf9cb9, 
	0xcdfa164b, 0xb3b2752a, 0x7b4a1fa3, 0xd5fb3b7b, 0x7f7ce69e, 0x1dbff4a5, 
	0xff39a990, 0x24af7fc2, 0xfe799e7f, 0xb07bfedf, 0x510a0f9b, 0x9f7f2595, 
	0x267e1fec, 0x5f7be8ed, 0x5ce7f31d, 0xb4dffa07, 0x0be6bb67, 0xaa5ff6b1, 
	0x17ae7307, 0xa5979ee2, 0x64f50ddd, 0xefed9b67, 0x77f329dc, 0xdbe6577d, 
	0xfcbb4b76, 0xd31a7fee, 0x71479de2, 0x68ed37af, 0x83e2bd64, 0xcf663e84, 
	0xc73afa01, 0xb7df63bd, 0x9c62644e, 0xea746d9a, 0xb7df63bd, 0x2774c95e, 
	0xed13bb97, 0xc2eb49e3, 0xf0f5f776, 0x41d823fd, 0x478db9ce, 0x2dae5f90, 
	0xbc87bd4d, 0xf7dcf8be, 0x2f687d90, 0x99fc90f7, 0x5f90f78c, 0x7fae5ed6, 
	0x0c3ebe2e, 0x2545c676, 0xfbc18c42, 0xfbcce78d, 0xef19311d, 0xba6af277, 
	0x1dfbcbd7, 0x77ef1931, 0xfde54b6a, 0xed7dba4e, 0xec81ae7c, 0x13e6beeb, 
	0xafd22bef, 0xb9ebed2e, 0x01d320c1, 0x85e5d7d9, 0x3fa34763, 0xef34143f, 
	0xbccbc719, 0x9633de57, 0x4d1c4e17, 0xe653b17a, 0x5904d06b, 0xa981a94e, 
	0x847e90a8, 0xabaf7d11, 0x2fbe20ea, 0xe2f5d352, 0xad3a9813, 0x5cf8f7f2, 
	0xf1f33df5, 0x8ff47d1d, 0x4e210cb9, 0xbcef918d, 0x2f1c617d, 0xd5d6b7fb, 
	0xdf21fc99, 0x41375c71, 0x9d3bb8e7, 0xce3338b4, 0x48a1ec97, 0x05929c62, 
	0x61007f60, 0x14158f16, 0x906a00f7, 0xbaca7682, 0xd617e63a, 0x2c0c806b, 
	0x061347c4, 0x7eff26d6, 0xe6d9bad2, 0xfde522bc, 0xa0d38748, 0xde533878, 
	0xe0cf68a8, 0xdc79b3b8, 0x06cf1990, 0x197f52f0, 0x08724bc7, 0xe4fd60e1, 
	0x78b4e8c0, 0xc177f35e, 0xfa29e826, 0x3abdcd43, 0x19b53efd, 0xbd476bb7, 
	0x4f449823, 0x8cdc77a8, 0x36694dfa, 0x1e514bfa, 0x9ed4c2c6, 0xf40cef7e, 
	0x63847d9d, 0x323d9b94, 0xfbe4f7c5, 0x19af52c2, 0x7943f389, 0x57f2c83b, 
	0xc5938a4f, 0x87ee617e, 0x19f41772, 0x7b60b794, 0x7a3efbd0, 0x4e7fd485, 
	0xd61dba60, 0x2dc5ef87, 0x22c87d61, 0x7f9649e7, 0xad8e7ee9, 0xcfddf2d9, 
	0x9dae37bf, 0xc35ebde2, 0x88a2f6b8, 0x7fbe5de5, 0x20bf41c1, 0xb3c61dae, 
	0x64e806fd, 0xaff4a974, 0x6d0a06f6, 0xb35ebf18, 0x3e79eae9, 0xeb713ce5, 
	0xc3ee944d, 0x6367edf3, 0xf975f8cc, 0xfc7a68fe, 0xc139c8fa, 0x145fe871, 
	0x1e7e9ecf, 0xe70ebc74, 0x37e7d433, 0x3f714795, 0xac62fe3b, 0x9eb8012f, 
	0xfd0cf935, 0x9ea98be7, 0xf1c7af7e, 0xf421fbe6, 0xfc61f7a3, 0x3f8a49d1, 
	0xebdf87da, 0x4287d5f7, 0x2df64068, 0xbda48508, 0x71444e3b, 0x101ef1ff, 
	0xd11ccff5, 0x2e80f783, 0xe30fb035, 0xc7a00c8d, 0x47f45686, 0xf28fbee5, 
	0xbdef1da3, 0xba7e1fd1, 0x0dea3e77, 0xc9e1d3ae, 0x6bbf1e34, 0x9f5d37d7, 
	0x2ce10bbf, 0x71a8c613, 0xfbc6ded2, 0x6f8bf26d, 0x8c00fe93, 0xe1b8a4b3, 
	0x63c76941, 0x6700fe8a, 0xadf3db19, 0xf9013f09, 0x2e224407, 0x8c0bf4c9, 
	0x6e3809f8, 0x404fdd29, 0x744dca71, 0xd571474f, 0xb8c8942f, 0xb0df3560, 
	0x0fd9d4ce, 0x8fe12ab0, 0xccb46a7f, 0xf64b6abb, 0xc9a41c61, 0xa02fa827, 
	0x20fd01bc, 0xf899f284, 0xd5f300ee, 0xf7f3a649, 0xfc44fc12, 0x7cdcf3b8, 
	0x7e1f22a5, 0xdefdce05, 0x3dfebf04, 0xece785fc, 0xf90bf979, 0x99f3096a, 
	0xbd47b645, 0xeaf90be5, 0x3d22f80b, 0x13e4d27e, 0x6eb63f93, 0x1caf5aa9, 
	0x8cbcfe63, 0xf318f3f9, 0x9fcc6be7, 0x213f998b, 0xcab7935f, 0x02f7bf86, 
	0x5f2c79fc, 0xc630f7d2, 0xe39df45d, 0x5740e0be, 0x9bd11ce2, 0x79c64fc7, 
	0x9a0bee46, 0xc17dd3c6, 0x3a900a86, 0x6ff1088f, 0xd7e8bfb0, 0x2da8ee39, 
	0xa2e8bc42, 0x7ff708ba, 0x31a1c545, 0x1c9d8c28, 0xa0779e47, 0xe0c62dc6, 
	0x1f706cfd, 0xeb817efe, 0xfcefbc80, 0xc6ad269f, 0x000000f9, 0x000403d1, 
	0xbded9c78, 0xd554780d, 0xf6ba37bd, 0x4cf63e64, 0x0f9326be, 0x43009266, 
	0x12132498, 0x82411e20, 0xa809d962, 0x5a36d2d1, 0x753d68aa, 0x41e880c0, 
	0x689e888d, 0x2109ec2b, 0x413a8024, 0x36b1123e, 0xbc90445a, 0x7d6b60e7, 
	0x74e7b1e3, 0xe88961f3, 0x4adad1b1, 0x837db5cf, 0xe9bd4a84, 0xf6f2d83d, 
	0xfbeb4a46, 0xdad7fdff, 0xdb404999, 0xdee739f7, 0x39e7dcfb, 0xac5d1e79, 
	0xfafaf7bd, 0xebffff7f, 0xfa2cd6bf, 0x9e83627e, 0x8a604423, 0x2126fe10, 
	0x5bf7df3c, 0x2a82ed8e, 0x09df6b86, 0xef2e0a21, 0x483d10da, 0x3d70dd75, 
	0x83221213, 0xc19e8bbe, 0xc4870d77, 0x33f22152, 0xb82e2d2c, 0x283e217c, 
	0x4dd70bc4, 0x109a11ec, 0x5bf4beeb, 0xdf49d687, 0xe7fc192d, 0xab109d50, 
	0x7b70e1dc, 0x2de610bb, 0x9af7d662, 0x6edefe05, 0x6459704d, 0x8dbd3f52, 
	0x1311dd0e, 0x8f4c2c22, 0xf3c78279, 0xf3d3af98, 0xfeb5d30c, 0x0ee7ea03, 
	0xe7c61f7a, 0xcfbc76c6, 0xc7bf215f, 0x505a4797, 0x5c9bfa98, 0xb2bbef0a, 
	0xd65f7dee, 0xeeb2437d, 0xf4f5961b, 0x7e9eb2b3, 0x8e33d65e, 0xc67ae7ac, 
	0xcc8a5c9b, 0xf33d6577, 0x1acf597d, 0x61acf592, 0x2b3ecf59, 0xa9e7d9eb, 
	0x96d5f9bc, 0xbeeb417c, 0xb8c9cd67, 0x82c421d6, 0x405e2b6a, 0xbd9f4900, 
	0xca9f836c, 0xdcbcafab, 0x70f04c55, 0x9df3df5f, 0x67688d9a, 0x3e6efaf1, 
	0x5a0b7016, 0xe3ff2ddf, 0xbe947761, 0xe146f45b, 0xe6f3c046, 0x0a8f0a37, 
	0x8f16e7ea, 0x8db17ee5, 0x75da6dfa, 0x5fbd0d4d, 0x51d97bbc, 0xbfefde8d, 
	0x9a8d81ed, 0x63d2c421, 0xa9f974b7, 0xdc6fb7fe, 0xfd4e9ef2, 0xcb9e663b, 
	0xefdea2af, 0x10ef5e6d, 0xb26ed4dd, 0x08f8f6d9, 0xa8f3578f, 0x162b669f, 
	0x42938916, 0x991e886c, 0x8fff7182, 0x8d6af489, 0xa6f74310, 0xc1208a55, 
	0x114eb459, 0xbfac4279, 0xbc016cda, 0x121ad14d, 0xf46faa5e, 0xa8cbe384, 
	0xe7f0bf3f, 0xd3b9e846, 0x172fd629, 0x091fae22, 0x932d9e61, 0xdc4615e7, 
	0xfcceb442, 0x95156161, 0xfd23844d, 0xd26ed477, 0xa2351bac, 0x38d55b97, 
	0xac43ab66, 0x896217cf, 0xb9120ad0, 0x5ce37c42, 0xfb7012a0, 0x716f1fc6, 
	0x7bbd9663, 0xcf84f509, 0x4dc301d0, 0xc3988b83, 0xec7a8959, 0x2fdf830d, 
	0xe30ae65d, 0xc86fa5fb, 0x9ef0cbf7, 0xfd54cbea, 0xefa7bc76, 0x37df576f, 
	0xea8df7aa, 0x2e65f2fd, 0xdfcbea17, 0xbf785c30, 0x953d9fe4, 0x7e675a71, 
	0x7de1708f, 0xf9cd2b6f, 0xcf791094, 0x44beb906, 0x04120a38, 0xfaefbcaf, 
	0x395f507b, 0xe2fcd5ff, 0x54dc420d, 0xc4b3d72c, 0xf3bfbf29, 0x0cfeafba, 
	0x58e53a70, 0x123443bc, 0xce75e89c, 0x19d9c06e, 0xe052bb16, 0x77f821ec, 
	0x45b5ae01, 0x6ef3cd26, 0x5cc681e0, 0x0285f232, 0x7f1089f1, 0x30be74fe, 
	0xbe6f1e89, 0x7d006c5d, 0x5f85d12c, 0xcdba808b, 0x1fc1c7af, 0xa07cea87, 
	0xf40d0d8f, 0xea2121ec, 0x685a0688, 0x44cbbd3e, 0xab6bfa0f, 0x3cc02d6e, 
	0xfc12afe8, 0xfbbc44b4, 0xe845e800, 0xe54132a2, 0x05239ac6, 0x8f5a5ae2, 
	0x8e598683, 0x9b9f8c71, 0x624b3744, 0xdc07afcb, 0x2cef6f30, 0x3de35621, 
	0xcbeafff1, 0x34fcbbe7, 0xe94017ce, 0x3c487002, 0x7c4bf7e5, 0xaf0a4dea, 
	0x91160724, 0x7f9d10fc, 0xbc4c6e59, 0x57086e40, 0xf89c84dc, 0xa96d2e6f, 
	0xcf541f92, 0xd22c297b, 0xd91cb14e, 0xdfee882f, 0xa22a7a25, 0x612d86f1, 
	0xf5e21e3a, 0x28f804b9, 0x3fffe3d1, 0xaf9bfbe9, 0x952f0608, 0x3c77ae74, 
	0xf0a77c46, 0x2a219e92, 0x277c0ee3, 0xab0eb04a, 0xe581120d, 0x13ff8947, 
	0xfae35580, 0x8f5cb0fe, 0x9612ac2e, 0x6a98c23b, 0xfd869c12, 0x89bcc239, 
	0x936f04aa, 0xcdf871c6, 0x337bcc12, 0xbf9b8af1, 0x279ea733, 0x70d7b679, 
	0xfdf3c54d, 0xb305eb3e, 0xd77d8856, 0x82bbed7d, 0x6b7bdbd6, 0x718b52b8, 
	0x83bc70fb, 0xfe8a57e7, 0x2ee5c6cd, 0x138f20ed, 0xc337bd41, 0xca3f153a, 
	0x7e2e7feb, 0xd59d1087, 0x4233c034, 0xd438c4ec, 0xb0dee76f, 0xb80d5e33, 
	0x89d0528a, 0xdc986345, 0x26f5c19f, 0x70f5d553, 0x76a77804, 0xe7907b96, 
	0x43b37917, 0xcf04ebcd, 0x31f414bf, 0xade237ec, 0xc538973f, 0x5fd29f7f, 
	0x1e7a3adb, 0x7be614ee, 0xfbeef5c9, 0x737ef663, 0xdc68e019, 0x6c9c8715, 
	0x638b6eb0, 0xc3842fbe, 0x4e6fa2c2, 0x7c920b67, 0xe8ae5f62, 0xc8ba23e9, 
	0xafede677, 0x0efe7921, 0x09a1b3c1, 0x8fb5f974, 0x05868720, 0x8d23778d, 
	0xa15af18f, 0x6e6fac07, 0x996ff966, 0x697f7d26, 0x3df8b521, 0x499a4dd3, 
	0xda837b70, 0xdfd4d58b, 0xf53fc222, 0xd10b7bdb, 0x90538d23, 0x01ddc221, 
	0x4744e612, 0x05ff5097, 0x5ffe73c0, 0xc087efc6, 0x7cff99ef, 0x112f9afc, 
	0x5e15077e, 0x109f1c69, 0x803a473d, 0x669752df, 0xf443d5e3, 0x787ebc0c, 
	0x10f6bc11, 0x7ffc0f5e, 0xf182d787, 0xf0967d78, 0xebc18c6a, 0x4fc23efe, 
	0xe33e635e, 0xcf94ea75, 0xe076ebc7, 0x24f809ad, 0xd27ee10b, 0x7d27c0e3, 
	0xbf3dfbd7, 0x3cfea0e9, 0xf02a7ef4, 0x06fb6cb6, 0x0b86ffc9, 0xf7ef4376, 
	0x6912b406, 0x0ed7dc0f, 0x3927407b, 0x15c954b0, 0x547d13e2, 0x7dca88ae, 
	0xcea0bcf4, 0xf2a22b96, 0x14bfea19, 0x6af30572, 0xe011f53c, 0x1cbe43ae, 
	0x6cce90bc, 0xe618f4f9, 0xa7ca4671, 0xbe7879d4, 0xc25a989f, 0x827c4472, 
	0x48a7b879, 0x1d03cc3a, 0x08f39226, 0xebed514d, 0xc85efb64, 0x5ee3c119, 
	0xedcfdaad, 0x7b5dba20, 0x94b0f9ab, 0x08c69657, 0xe76cf511, 0x1495e5d4, 
	0xeb7fa468, 0xa2d7be0a, 0x94f12775, 0x168e5bae, 0x7433b76a, 0x3ff114d9, 
	0x0ed43e69, 0x5bdad1f6, 0x03161efb, 0x86a6bcd4, 0xc17fbf3b, 0x963a0ecf, 
	0x23d15fe1, 0x172dde92, 0x77282dfa, 0x6f24dd78, 0xd4a57ef6, 0xdd724795, 
	0x573dfc5b, 0xec037608, 0xc63fd23a, 0x601b0df5, 0xc6ffeda8, 0x4b905c9f, 
	0x81f6fefb, 0xd79a34bb, 0x069685fd, 0x8fbf71fd, 0x3c0588f4, 0xaaec1a59, 
	0xb21b45de, 0xb0932348, 0xd12b5a15, 0xabfabedd, 0xc10f449a, 0x3a6791c5, 
	0xc7e6be48, 0xba87dd4e, 0x34cf08d0, 0xebdf49be, 0x7ac7e883, 0xc499fd0a, 
	0xa3c41daf, 0x0c7d41c3, 0xbb13ed9f, 0x7cbbe297, 0xba6b9094, 0x6a7bdb83, 
	0x27e834cc, 0xed2b04e7, 0xf5978632, 0x67c13b54, 0xf202013f, 0xbc4faf7c, 
	0x6eebc780, 0x1ce4d3fd, 0x4b917dc0, 0x9c861adf, 0x439c32bd, 0x229c6a70, 
	0xe82f7cf9, 0x138c03fb, 0x903d2d11, 0x8186571f, 0xf7ae9b3f, 0xa7b1335f, 
	0x0bdfc681, 0x27c295b9, 0x3d793dfb, 0xdd64fe35, 0x047de474, 0xfb0e1f3e, 
	0xc5cc7f99, 0x59c56109, 0x2b965d5f, 0x96f54df5, 0xf48fc02c, 0x3f5ca0ed, 
	0xe02f68f4, 0xba1bebc7, 0x0c7e152f, 0x0ce56a5f, 0x84e2695b, 0xfd0c6782, 
	0xf5d4b584, 0xfa75f0db, 0xc31b9c4b, 0xe7c07e92, 0x992d35ce, 0x3c3c77e8, 
	0x487bb86d, 0x48bdb4be, 0xd91c07e3, 0x589e1390, 0xe48d244b, 0x72e270cb, 
	0xc3ff8053, 0x2f187e92, 0x246f0a8d, 0x6a6b8647, 0x71717be4, 0xde62f4fc, 
	0x16fbaf54, 0x2f24f9d9, 0xdac8f0cc, 0x87979a56, 0xc6d37eec, 0xd0cdd137, 
	0x41f3a27c, 0xd7c84f85, 0xc3d77d28, 0xeec1af7c, 0x5c37f1b4, 0xd9d6b233, 
	0xabd9faa3, 0x96390cf0, 0xec3d64bb, 0x1efe1b52, 0x09edb9a7, 0x86c6bfc9, 
	0xf077896c, 0x6f7849b7, 0x7b9e3309, 0x5bccc720, 0x1d04acaf, 0xc95cb79b, 
	0x58bee2f6, 0x5efbc0a9, 0x92797be0, 0xfbef09ce, 0xf78c621b, 0x72667dfd, 
	0x7b29af9c, 0x241dff68, 0xdd4130e7, 0xf093a6bc, 0x3d174131, 0x77908d39, 
	0xf7074cf9, 0xd8fed82f, 0xcd9f3504, 0x0bab2744, 0xecba0984, 0xc43633cd, 
	0xec2c4f49, 0xb09d33e9, 0xa46afacd, 0x84be2600, 0xc1bfc71c, 0x71bc0fa7, 
	0xea752fcb, 0xb763a1f7, 0xfe27ed3c, 0xb9d5609c, 0x096f9b35, 0xfd9f0bce, 
	0xd479bae3, 0x544be174, 0xfc2e6112, 0xae072ab1, 0x07f9f930, 0xe3bea254, 
	0x4a35b30a, 0xf7aaab65, 0x2f71ab36, 0xfc2e1c67, 0x7d6537c3, 0xc2f7c489, 
	0x7ed93e92, 0x452fcd31, 0xe0fc2c8e, 0xd9ffd961, 0xeeb8e587, 0xffd2ca6f, 
	0xf25e7caa, 0x52cfacaa, 0xd955abf5, 0x1225e720, 0x1f087f24, 0x4e48ebde, 
	0x5c16de13, 0xc157cffd, 0xdb7fd9df, 0x52f964ff, 0x55c1f797, 0xb8dbad1a, 
	0xc806f976, 0xeb1efda3, 0xf78f2551, 0xec7e216e, 0xee28b27d, 0x49c42ad8, 
	0x33dcdbe2, 0x256147cc, 0x069bf687, 0x90bfccc1, 0x772d90e5, 0x6c8f8ae2, 
	0x7b7b5dba, 0xae58e5be, 0xe5244fe8, 0x1e96e408, 0x74197293, 0x5f128aee, 
	0x37c85c75, 0x7b187ca3, 0xbb1ea96e, 0x4d270e90, 0x13d70716, 0xf97fe57d, 
	0xc383962a, 0xda824df4, 0xbd120d6b, 0xfae172a3, 0xa2821104, 0x5fc6fa6f, 
	0xf2748e2e, 0xd86c8c84, 0x1313f0dd, 0xd9ff72d7, 0xe50bee89, 0xcb58e407, 
	0xeadca4e9, 0x130e145d, 0x75ef44b8, 0x6c77f661, 0x2fcb6639, 0x3f045b96, 
	0xa22dec2f, 0xad8950c3, 0x694e8997, 0x068b75bc, 0xf4bec327, 0x0d7bdd9e, 
	0xd9ef13ec, 0x47f72568, 0xedfafdb6, 0xba6bcd28, 0xaa139d69, 0xfc893585, 
	0x4b264b8b, 0xcaf58a7b, 0xdacf2956, 0x02b94963, 0x9e4aebf8, 0x284c1e41, 
	0x5b027191, 0xcd72d9ce, 0xb63f0e35, 0x1f8f1b1c, 0x0e5b5fbb, 0x08bbdcb1, 
	0xa1cbc67e, 0xf3017af1, 0xb8667e86, 0x513e3c13, 0x50bbdafa, 0xc4758dda, 
	0x88a464bf, 0x9dafe0e7, 0xba85bae5, 0xf11331a8, 0xb6dca4ee, 0xe82f5ef5, 
	0xe873f06d, 0xfacf2d2d, 0x17b3d66b, 0xba2a6bf4, 0xc75c9a5b, 0xfe5fd167, 
	0x06be8897, 0x509ddd15, 0xb93d7beb, 0x3da549ae, 0x35ff7c2f, 0xeff75f9a, 
	0xa43c15cf, 0xe4bbf3d6, 0x2f4e6e7a, 0xa6d579e4, 0x3b06d93f, 0x6f28b6b0, 
	0x75e4357f, 0x5d57b3de, 0x3deef342, 0x6af16ff6, 0xd77ec3a6, 0x1d7f7a01, 
	0xf8482fe1, 0xb5b1ff5b, 0xc6112261, 0x6e7c14f7, 0x1af6da2e, 0x76213be6, 
	0xe43761e9, 0x3d03e5f6, 0xbb6cf3b0, 0xb2b270a7, 0x7bb02edf, 0xaa9e3f12, 
	0x0725b9e8, 0x136e2cfd, 0x41bed654, 0x2b9f60ed, 0xbbe42dbb, 0x2b5a2da5, 
	0x9db6ed46, 0xb36ed225, 0x37da97ed, 0x56a2e206, 0x79e35bce, 0x8f40b694, 
	0x850bf3d9, 0x44986cb6, 0x5ace7a03, 0xb7bbcc61, 0x7e4cf08e, 0xd25def67, 
	0xf347583f, 0xddfa26e9, 0x425efd42, 0xd25d64f2, 0x3f83283f, 0xb5186c60, 
	0x2fe0cbaf, 0xdfc1fed8, 0x07fa8c95, 0xc9c32665, 0x69dc4728, 0x8c673ab8, 
	0x76764cdd, 0x4bb3f019, 0xb4f4efd9, 0xfb077cfc, 0x9e78e507, 0x0f3c1fe2, 
	0xbf9ef5b8, 0x41fec5dd, 0x57ffa8f5, 0x6f5ffec1, 0xb63ffd98, 0x7ee43f3b, 
	0xf90798a2, 0xcf50fb09, 0x06fd679f, 0xfe167d70, 0x3cf38d02, 0xe184bbc6, 
	0x4fce3158, 0x13f548a8, 0x313f859e, 0x6e5bdfc8, 0x2e9afbd2, 0x513d6aa2, 
	0x725a87ac, 0x0151d69d, 0xcdf3c6f9, 0xc1bf1cf9, 0x9837eb18, 0x0326a78d, 
	0xc57eb62f, 0x5dd73b77, 0xba2c07e8, 0x52e0a062, 0xda1be729, 0xf49751b3, 
	0xeba07f03, 0x5c338c84, 0x56f04432, 0xc2d2e772, 0x1f7112ce, 0xe8d91c3d, 
	0xf4da5f07, 0x809d7f4d, 0x2379d317, 0xf98a23be, 0x28afd27d, 0x057e463c, 
	0x2250dbf5, 0x4ef432e9, 0x91389b43, 0xbf7a4ba4, 0xafe3d94d, 0x453ad2b7, 
	0xe0227738, 0x27c7bf55, 0x3d7037e1, 0x387cf7d7, 0xeae0e98b, 0xe22573c0, 
	0x5fd98001, 0xafef718c, 0xe49bba16, 0x989023b1, 0xe1bffd08, 0xb38b425b, 
	0xa5704ddd, 0x3259cef6, 0x7513d0ce, 0xc258770a, 0x89e39079, 0x83b4ef86, 
	0x681befd7, 0x38e87ae3, 0xd0aca447, 0xef6e3efb, 0x1e09a21e, 0xcb3d1c87, 
	0x530f77f8, 0x6b6bb1fd, 0x5ef92ea2, 0xc102fac3, 0x649c4b97, 0x86573bb7, 
	0xc869db45, 0x7413330b, 0xb09a58f5, 0xbf90af60, 0x4e3cc3ec, 0xdce6b8a8, 
	0x9a257c7f, 0x2b8849b1, 0x915b9bde, 0xbd09fb27, 0xa19be3cb, 0x063ca9f7, 
	0xce8b3f3a, 0xf7d61f75, 0x1eb7fdd8, 0x5ad9bd83, 0x8aa9bbd1, 0x5fb73be6, 
	0x56de810b, 0x8d0b648c, 0xf9a3bffa, 0x5c6a50d3, 0x0c50456a, 0xee1e11a6, 
	0xdac571a8, 0x2503ed68, 0xff672f92, 0xa150c2fd, 0xf8ebf21b, 0x7e27002f, 
	0xd0addf4f, 0xf51cfde9, 0x2dd7297c, 0x43f5486d, 0x53456b72, 0x93bb53b1, 
	0xca41a7e8, 0x71ed6345, 0x4f40d4f2, 0xf56bae7e, 0x523f1e92, 0xf4d6f8e3, 
	0x7d690456, 0xc2f4d9a2, 0x89f0cc3f, 0xcedb90f5, 0x01af5285, 0x7e34ed6e, 
	0xe6b0aae6, 0xa503f2a5, 0x5fc102a7, 0x977f3895, 0xa70d9f84, 0x9aefd10f, 
	0xdcb6bc24, 0x4822be7a, 0xd641bb65, 0xe24ff515, 0xf9a0e63a, 0x3e74dc76, 
	0x37efa7ea, 0x1e2df1df, 0x4795d1ff, 0x502fd82a, 0x6daf34f3, 0x2c40bf67, 
	0xff5179a1, 0xe09b03e4, 0x9d190433, 0xa42f8077, 0xf021715c, 0xc0f4c8db, 
	0x70bf3bf1, 0xf3d21d32, 0x35cf4684, 0x0f812f94, 0xb8548a66, 0xf191aaef, 
	0x704f6e08, 0xc6515d27, 0x9495a576, 0x52175c67, 0xd320919e, 0x7d79f806, 
	0xb894f1e9, 0xe49abb93, 0x16039497, 0xb7f8f3e6, 0xf08d4d1a, 0xf44520ef, 
	0xe3f4024b, 0xc38aac8f, 0xd55b2d1f, 0x30fdacb3, 0xd174434a, 0x5346b2f3, 
	0xe5435e74, 0x51f31e9a, 0x2df65d6a, 0xcd4df5e3, 0x720d5f3c, 0x761796c1, 
	0xc2553159, 0xb0264c55, 0x05723c90, 0x0a968e49, 0x3b79989e, 0x76d0a9d5, 
	0x5c68160b, 0x1dc30bf7, 0x63576949, 0xe978641d, 0x2c218f04, 0x5c01fa83, 
	0x27985045, 0x7e8fdf93, 0xef88f907, 0x09ddf462, 0x8d9a6f7e, 0x9d04dcfc, 
	0xc1c9d36d, 0xd744255a, 0x54b29cc8, 0xeb9b76b8, 0xbb0780ca, 0x7b69822e, 
	0x32869ed0, 0x0cf0ee31, 0x83ff7f92, 0x1090df9e, 0x33bf085b, 0x243a4aa6, 
	0x68e3ce79, 0x089bc4ba, 0xb7013c13, 0x690e9235, 0xe34bc33c, 0xdef7d316, 
	0x38978033, 0xe073f5ba, 0xbbf55135, 0x55def10d, 0xc7f4e7c9, 0xa3a6c2fa, 
	0x9b48b1dd, 0x0e853067, 0x3c033a6c, 0xaba42e86, 0xa24e82bf, 0x747cd1ef, 
	0xc9bae725, 0xbf537266, 0x4ecaf5c3, 0x7f729669, 0xbcb23d3c, 0x3b74541b, 
	0x6529fb8b, 0xbf3a02bd, 0x7d23c016, 0x2f18ed23, 0x39358fea, 0x66bb64ef, 
	0xa9c661a5, 0x32f425de, 0xd15bbde0, 0xe95470c1, 0xbb738259, 0xc613e496, 
	0xfa494bdb, 0x3cecdddf, 0xf92b55aa, 0xcbf14278, 0xb9d0e7d0, 0xb38e32d3, 
	0x777a941c, 0x51dde2d3, 0x5d365dc4, 0xc1d51bdf, 0x8f9ef7cf, 0xcaf49cb2, 
	0xdf4d22fd, 0xe97d65e8, 0x3cd2fc27, 0xbd91b9f5, 0x3bcefa4e, 0x62cad573, 
	0xc3bcf3c8, 0xa76127b5, 0xbfdec9ba, 0xe112e98d, 0x16ca117b, 0x097ec63f, 
	0xc25737c1, 0xbb481459, 0x304828df, 0x090599bf, 0xe9028f09, 0xa8098807, 
	0x0bdf45a7, 0xaba23a88, 0x326d42bb, 0xf6ca639e, 0x3c601109, 0x3c761cb9, 
	0x56bc0033, 0xeb915ec3, 0x667ac5cc, 0x0279ceac, 0xaa7c7ceb, 0x37a123d4, 
	0x84bd5ffc, 0xcff93426, 0xf71cb94d, 0xd2763027, 0xa685e9fb, 0x74c97e07, 
	0xbc83689f, 0x7b8e149c, 0xc556e760, 0x25ced96a, 0xc6b566ec, 0x87235500, 
	0x7ec3dced, 0xbec8abf6, 0x47f191cd, 0x0f7a03cb, 0xced9c636, 0x3708660d, 
	0x6749dcec, 0x3c007ac8, 0xb5dac7da, 0xc03996c4, 0xc3d59577, 0xb5d92f76, 
	0xf74fa89d, 0x06139b19, 0xe43367af, 0xc2a58df4, 0xe19cfe80, 0xcc823733, 
	0x798cdca8, 0x2d79697e, 0x9bd45bfb, 0xabe245e7, 0xabeb46ff, 0x049a3e26, 
	0xcf956d38, 0xfe639fe1, 0x6beb1fe8, 0x85f3941f, 0xaa7fbcdd, 0x3af6fb94, 
	0xd782dd79, 0xfcf655e9, 0x5e627598, 0x59ebcf78, 0x233ae17a, 0xf78f5a61, 
	0xebda75c2, 0x0649d7b2, 0x54be27a5, 0x94daefad, 0xeb90acf5, 0xec3e7499, 
	0xe5f9234e, 0x5e073e24, 0xb1f8430d, 0xd5e734bf, 0x80fd3b9b, 0xb18fa9a3, 
	0x221a16b7, 0xb20def07, 0x5fe412d8, 0xd25938de, 0x78be9cd9, 0xbe4ee180, 
	0xa4bde27c, 0x75ea4a3f, 0xfcf7b2ab, 0xe999d326, 0x3e2c3d47, 0xb97d7ae4, 
	0x9073a778, 0x484c4fdf, 0xe9289a3a, 0xb8989cd2, 0xc0ec73f6, 0xebce4244, 
	0x8dcfd26b, 0xa04d8966, 0x619bd087, 0xd73bf637, 0x9ce3b19e, 0xed6d9f72, 
	0x0ec3f8da, 0x37723396, 0xbf13b6ca, 0xe3d33bf6, 0xf1667f20, 0xc3a60f37, 
	0xf7d10faf, 0x67b59fe0, 0x5fb37c54, 0xc02225c6, 0x6b9ee213, 0xb018795f, 
	0x3cb9e110, 0xecc7b5a1, 0xdd8f4c71, 0x6fd4f3ef, 0x88dc3748, 0x4bcf069b, 
	0xbd126c7b, 0xa98f7ee7, 0xf1d8cf7e, 0xf3c76a18, 0x86af99d2, 0xf0dcc68e, 
	0x61592693, 0xcf9a46e7, 0x826e886f, 0x09d7a06b, 0xdb2537fc, 0xd7c5970d, 
	0xb62e38aa, 0xe96fc496, 0x49b3b4bb, 0xdcc884f8, 0xd6d4b910, 0x3d86eb59, 
	0x1a13f43d, 0x3f7c9827, 0xba60f9a9, 0xbcfd0278, 0x32e396b2, 0x9d7973cd, 
	0xf744d995, 0x5e14a21f, 0x4e22d5c4, 0x1d263fa9, 0x2f30f9ab, 0x3d2dcb2c, 
	0x1c36e7c9, 0x5b465943, 0xdbbea13c, 0x128bbeab, 0x9f88bbdf, 0x8504efe0, 
	0x7e0d7817, 0x1e7770cb, 0x0c33efa2, 0x17d68277, 0x0bb2243c, 0xa444f4a8, 
	0x27e913bf, 0xf839e17c, 0x6061720f, 0x923ced64, 0x7cf0a7af, 0x0378ca5b, 
	0x7c905ba6, 0xdcb71d0a, 0xbbf9f230, 0x7eed0bbe, 0x33cc18c4, 0xb5ace7b0, 
	0xc386ff12, 0xb43770c9, 0xef5d2a61, 0x4903bb50, 0xbfa215bc, 0xc7269441, 
	0xf90dddc7, 0xc2f3f01a, 0xcf58d30b, 0x334b7538, 0x2e0e2027, 0x8ae1ee38, 
	0x2ece8e18, 0x9118be21, 0x4353d57a, 0x8a076eed, 0xdbe80f2c, 0xb9870bad, 
	0x587ffe13, 0xb8e252d3, 0x954577ce, 0x81c42059, 0xc4710df6, 0xd6b7dd81, 
	0x567e729a, 0xfee9f026, 0xc44d37c3, 0x7125dd33, 0xd9e339fb, 0x899f66fd, 
	0xe5bba538, 0xb79875f2, 0x04951b7b, 0x551ef71f, 0x2cb0f03f, 0xddf2a90f, 
	0x5ffbe587, 0x7f99faab, 0xabc77592, 0x557bccb2, 0xf5532f3e, 0xb2ca3fea, 
	0xff8b954e, 0x50afdf28, 0x4c2ba6f5, 0x8950b7ae, 0xdf5536fa, 0xbe07eaa3, 
	0x6177a5c9, 0xb33f0dcc, 0xcdc667d2, 0x53b35276, 0x7fb047e7, 0xbf135ee0, 
	0xca97ed51, 0x7543dcf5, 0xe03e97c9, 0x95e6bdc5, 0x631e991b, 0xf7dd1e92, 
	0x62fc1d50, 0xc9d37e48, 0x847c4641, 0xff8349e8, 0x220284e8, 0x26aa9ff8, 
	0x7da9e754, 0x4e479202, 0xd04e1745, 0x09e7c909, 0x339c9f84, 0xb035df0a, 
	0x5fde0ce3, 0xf6a01f48, 0x58275469, 0x767f60b7, 0x920872c0, 0x19119927, 
	0x848b83ff, 0x8d08677d, 0x8e8156c7, 0x6066d646, 0x0f92f57e, 0x7e77d097, 
	0x94db97d0, 0xfa909976, 0xe6a1b877, 0x5874413e, 0x7372901f, 0xebe49eb8, 
	0xae7be5cf, 0x2dfeff8f, 0xe9a7d153, 0xa2c25c03, 0x089be65f, 0xb96716d1, 
	0x1f616469, 0x539fa6d2, 0xd61666fd, 0xdbf9397b, 0xb8ec539b, 0x7d6a07cb, 
	0xfa1fdfd8, 0x71d32d4a, 0x0ddc7f45, 0x7c72eb5b, 0xf853fc4f, 0x57774d8e, 
	0xaa3c426d, 0x1366cde2, 0xfe9b70f1, 0x1f0dfb4b, 0xa73155e0, 0x435f7856, 
	0xb74fb1ff, 0x470a3c12, 0x36b5f5e9, 0xa2916bd0, 0x81c872cf, 0x18a388e5, 
	0x22e7809b, 0xe3459f45, 0x1c68b9e8, 0xfa29171d, 0x5bf4522d, 0x48b7e8a4, 
	0xa2916fd1, 0xbf4522df, 0x8b7e8a45, 0x2916fd14, 0xf4522dfa, 0xb7e8a45b, 
	0x916fd148, 0x4522dfa2, 0x7e8a45bf, 0x16fd148b, 0x522dfa29, 0xe8a45bf4, 
	0x6fd148b7, 0x1ee08b30, 0x8e89bac3, 0xdf6bf909, 0x30fe9537, 0x10549f59, 
	0xe852071d, 0x38e882b8, 0x36c74290, 0x8b748a9e, 0xa9cac0f5, 0xc7e0474f, 
	0xd67b5217, 0x49f7ef23, 0xf520323d, 0xa792b94b, 0x79ff4415, 0x415ff429, 
	0x42979ff4, 0xbf9397ff, 0x1248c4fe, 0xe21aa7df, 0xcdec8259, 0x0b36a2b9, 
	0x112e6d62, 0x3d92e43d, 0xdd1577fe, 0x7fd072db, 0xf1ff28cf, 0x466bfd3c, 
	0x61d78ff9, 0xad28d7cb, 0x5e89f312, 0x579b497d, 0xd0bc95c6, 0xdda6a7c7, 
	0xbb4bf5e4, 0xbef503b1, 0xf853cc88, 0x75fe8446, 0xe16d193f, 0x8ef91d03, 
	0x4d8a7ee4, 0xf7151e57, 0x5cccbe1a, 0x61a4e0ab, 0xcdc87ebc, 0x18b914a6, 
	0xe7c408f5, 0x27b728dc, 0x3e2bf79f, 0x87d24bb3, 0x5fc499f7, 0x1bac61a0, 
	0x956db8f2, 0xd6aa371a, 0x53eb06bb, 0xd3c143f2, 0x2f928f7f, 0x39193cb6, 
	0xc6bf61aa, 0x913d4d5d, 0xe072f0dd, 0xab93c61d, 0x6cefcfbc, 0xfcb73c85, 
	0xbd69abf0, 0x316ec29f, 0x5c80e584, 0x074df877, 0x3b74acec, 0xc027e6ee, 
	0xb86bf58f, 0xb27090de, 0xfc474f5e, 0xafcd256b, 0x9d8c6ba0, 0x078ed27e, 
	0xe9d21c92, 0xf3dbdf7b, 0xc6a7bdb9, 0xe32fb0d0, 0x801727ad, 0x46bfdce4, 
	0xf23a2286, 0x209f4811, 0xb9191cce, 0xfa4de786, 0xf4e10fc6, 0x9623e072, 
	0xf85b64af, 0xae3f4a45, 0x3af08caf, 0x85ab1e18, 0xbd688cb8, 0x04178085, 
	0x876f897e, 0xc41c264a, 0x7d7745ba, 0x7017da99, 0xe4703fc0, 0x69f8b576, 
	0xd4a95f1c, 0x4fcd33cb, 0xd0fbd835, 0xb7042dab, 0xd83eb4e9, 0xab06bee7, 
	0x2f9fed14, 0x24e224f8, 0xbf33c3fb, 0x60770b4f, 0x74efe4de, 0xfdb7d727, 
	0x1039661f, 0x2a9470ff, 0xe8f4e93d, 0x2e9274e2, 0x9d3cf43c, 0x404560e8, 
	0x938f8a94, 0x5cf6df78, 0xbffe0395, 0x2749c36e, 0xf029623b, 0xd7fe6965, 
	0xf7f43b65, 0xebfd08cb, 0x7c0b823e, 0xd3c3f87a, 0x17a49a69, 0xccaf6df4, 
	0xfcc6a9ae, 0xb0f8c47f, 0x0e7f4fe7, 0x875a57c8, 0xf5c96ad6, 0x83fbaea3, 
	0xf7fa8da2, 0x85a234dd, 0x5e5758bd, 0xae5de229, 0xd45a7d99, 0x5a21b48b, 
	0x75c2e86f, 0x74952c4d, 0x56bac2ec, 0x5cfc94a2, 0xc19d7582, 0xcafe8aba, 
	0xff0e1975, 0xfa1db2b5, 0x84a465fb, 0xa7ae8ddb, 0x2073d695, 0xc9f13f89, 
	0xde9b0ee3, 0xfebe9f40, 0x7ec1efc1, 0xf5a42caa, 0xd99ffc91, 0x9e22f71c, 
	0xcd0937f6, 0x4bbcbc87, 0x807d6abb, 0x1f4da91b, 0xf692ebe8, 0x2be81f5a, 
	0xea7694e4, 0xbd0795f4, 0x67a0ecac, 0xa0bfa04f, 0x5f93bf00, 0xc43f02d1, 
	0x1adcad67, 0x91f1a988, 0xb430e58f, 0x86be7a76, 0x5f83c84a, 0x0a515ee4, 
	0x178d1c3a, 0xe3f70618, 0xbc0d2c32, 0xb73d5c31, 0xd60f4059, 0x361bfe48, 
	0xae3e0ea8, 0x5c39fc97, 0x0deb235f, 0x6445ceca, 0x257e46ed, 0x62c3a6f5, 
	0xbd1e99bd, 0x83bad02e, 0xe0d4c5e4, 0x9494222b, 0xdf5bf833, 0xe69ae8a4, 
	0xc690a935, 0xc5735e27, 0xfe760384, 0x892ddfe4, 0x04c83ec3, 0x181d32fd, 
	0xf736fc1a, 0xcfef26fb, 0x7119f24d, 0xc7456df8, 0xf49d268d, 0x52a5cddb, 
	0xcb56b8de, 0x0022117c, 0xbe04e3ad, 0x6fc23733, 0xd1eacd74, 0xd95fd2bc, 
	0xdf21ded8, 0xaa2adfc3, 0x3bfde1ee, 0xeb848657, 0xfec59f64, 0xbe486ea4, 
	0x3f811e86, 0x86d67c46, 0x32886eba, 0xff3975fd, 0x5dd019c4, 0x89f82963, 
	0xa284e8f9, 0x385f7a4f, 0xcefe9e30, 0xeef15c72, 0xd5abe0cf, 0x77f7f4a3, 
	0xfa491fcc, 0x7f40d61b, 0xe7f4719e, 0x5abe4a8a, 0xab7f4a3d, 0x7119fd15, 
	0x6f0c4bd8, 0xb76bb79a, 0x5f5b43a4, 0xbfa770d8, 0x087fc738, 0x9f446d76, 
	0x31663d79, 0x1bdaefe6, 0xb5c67f65, 0x91b6dc37, 0xefb443f8, 0x493c83ca, 
	0x3948729c, 0x84f2b515, 0xbff93bca, 0xf1c4a5d7, 0x4a2d59e7, 0xee9c393f, 
	0x63527d14, 0xdefabf70, 0xa18b68b0, 0x51b4b68c, 0x9b0327bf, 0xf5bf214a, 
	0xc6e741bd, 0x8b5c30df, 0x2afcaf01, 0x85f6c5eb, 0x8e32dfc8, 0xe5e34a3f, 
	0x72e58c47, 0xbf5c5f1f, 0xdfa4fc91, 0xdf190996, 0x93368c37, 0x58dba5e3, 
	0x2dbd6dde, 0xaff7e79d, 0xd74ced91, 0x866a3f05, 0xd872cf19, 0xf170bd64, 
	0xbd245d3c, 0x3cf4ef02, 0x17f3ed13, 0x47e73849, 0xcab05ca4, 0x7bfd5ca4, 
	0x265fbe55, 0x6fc303e3, 0x7b0c7e0d, 0xcdbdf88c, 0x8bf7c20c, 0xdafa56cf, 
	0x7e087e09, 0xe43dc243, 0x414bfb90, 0x0f2913eb, 0x6d9acdfe, 0xddfc5bdb, 
	0x33b54b42, 0x05feb8d2, 0x2bb23dfb, 0xa951f885, 0x1b04cf8c, 0xed52cbb4, 
	0xacb7e19a, 0x7984778f, 0x3f58697d, 0x3c915ee7, 0x997dcbe8, 0x05c920e5, 
	0xeb5f9b96, 0xfe90ec38, 0x30e121bc, 0xf246e09d, 0x37d55429, 0xc3f6a4db, 
	0x9cc7d659, 0x241dca13, 0x933439f1, 0x2efa6a4c, 0x56ee1418, 0x7f86a3f2, 
	0x5b71ffdc, 0x43607e14, 0xaa78e09b, 0xc1ff44e5, 0x38859161, 0x42763509, 
	0xd4a61b6e, 0x6bdffaa3, 0x9828c869, 0x8f5f6f11, 0xe5aad01c, 0x1d011e77, 
	0x743579cc, 0x3fe97404, 0x95fbc834, 0xb13cdf73, 0xca807110, 0x2b4dfdbf, 
	0x10334ee2, 0xb2e7a96f, 0x38e9e795, 0xfc826af4, 0xd53faad0, 0x17befeee, 
	0xfeb283f5, 0x6f5902c8, 0xf209fe31, 0xab91eaac, 0x8e7df87f, 0x5ef8c818, 
	0x9f05eb18, 0x00ec7d76, 0xa57c1e7c, 0xeac3c646, 0x3cc34e6f, 0x30f42d6f, 
	0xaf2d54bd, 0x19d27ce0, 0x105a73ab, 0xf433fb0f, 0x0f5e1ad2, 0x31d0e9cb, 
	0x81e39c7f, 0xe80b46cd, 0xf9036aad, 0x552fc4c9, 0x75e724a5, 0x81eb6694, 
	0x8e1b9e18, 0x1f3c83ae, 0xf8fc8bad, 0x6a9fa90f, 0xfceb99e8, 0xf1da4255, 
	0xeaba3fec, 0x4f28ad12, 0x820f073a, 0x869c8bce, 0xb5d78dbe, 0xd4125fec, 
	0xb523e4fe, 0xbb98bb00, 0xe97ff6ee, 0xd79e31fa, 0xc9fde166, 0x5d121d3f, 
	0x33f9e1af, 0xc605f7da, 0xe24bfd89, 0xf55f9e08, 0x781d5deb, 0x9fbfc56e, 
	0x005c5fe2, 0xb33fbe87, 0x51bc2d5e, 0xbffb01c5, 0x6cf374c4, 0x1eb817ef, 
	0xb60a6fba, 0x7dd746e5, 0x0d4ce272, 0xd2614ef1, 0xf73ea9ba, 0x116b7327, 
	0x3d4627ef, 0x29e9b904, 0x53db3a14, 0x24f8c1ae, 0x4d71cf1a, 0x17fc869f, 
	0x40d0d867, 0x6701391f, 0x4058e419, 0xf1d06bf1, 0x87c62b50, 0xcdf9869f, 
	0x4727c9fd, 0xec138f90, 0x7d85e83f, 0x599c2a12, 0x9c307625, 0x722b60da, 
	0x32fdd03b, 0x0f6d9b57, 0x63c15960, 0x19bf0c0d, 0xfb704e6b, 0xecc1d350, 
	0x5ce9e056, 0xbbf62b6d, 0xe73f2ae7, 0x6d39a4e4, 0x4f8277b0, 0xce800f9a, 
	0xc6d688c5, 0x5a48d376, 0x887ce21b, 0xce3afdb7, 0xfac6ec74, 0x47128782, 
	0x9bd0e781, 0xf8edb897, 0xec85e827, 0x47d074ca, 0x1f783591, 0x710927e7, 
	0xd45ae035, 0xe852e2ff, 0x3bd1f76f, 0xcfd423d3, 0x06522470, 0xf1a3303d, 
	0xd5195f6d, 0xb8ab5e6b, 0x245b721a, 0x7fd823cc, 0x6bbe4398, 0xf227ee42, 
	0xac9134df, 0x6fe43753, 0x2b375b18, 0xca6fc17f, 0xdf29edf7, 0xa92dfbd3, 
	0x85a4e7ef, 0x9c758c7f, 0x5bad1a74, 0x6f5ee852, 0x5c6e71ca, 0xefda7f0a, 
	0x5f7a88dc, 0x225db448, 0xd3f99ff9, 0x73af7690, 0xc663ca50, 0xfe9fde23, 
	0x781fbf0d, 0x1f494ae4, 0x4f996bf5, 0x295cb70a, 0xf3c6c6f9, 0x2468af4d, 
	0xc29a4406, 0x99877e8f, 0xde0a5cf6, 0x4c1c35a7, 0x625ffb57, 0xbfb52363, 
	0x32f4fae3, 0xa1b9f00d, 0xe6a9720c, 0xaaeea581, 0x6e7c2496, 0x13f03f40, 
	0x8c1f34de, 0x72e25387, 0x7de1df4a, 0x2bc2936e, 0xc32ce9f6, 0xfa2ebd0d, 
	0xb5e7770d, 0x37b47129, 0xbce08e7b, 0x9dec1540, 0x86af5e7c, 0xad17197c, 
	0xcbf480af, 0xca9bf2a1, 0xfe87bffc, 0xcbd81e12, 0xdc0bc895, 0xcdffe88e, 
	0x6fe01365, 0x46efa1fd, 0xcff993e4, 0xe3bf49f7, 0xfc6bb4b8, 0x25fa536e, 
	0x5b251f24, 0x7ee5b9d5, 0xf54de592, 0xfaf86c33, 0x572bfc95, 0xf6e9c079, 
	0xd230bbfe, 0xfc397df1, 0x413c200b, 0x6f7d1bd6, 0xb6e526be, 0xd75c1bf0, 
	0xe39fc52d, 0x957494fc, 0x7dfd3bbf, 0x1e904b23, 0x78f79471, 0xf22989ab, 
	0x17c6b1fe, 0xf5df4071, 0x3b0fb0f9, 0x9bb999f1, 0xb3be086b, 0x03a48c27, 
	0xd1bd974f, 0x4cd4b9b4, 0x75c633fa, 0xf0847109, 0x34219c51, 0xd95127e4, 
	0x70688886, 0x7987cd5a, 0x42dcb23d, 0x591fd878, 0x6296965b, 0x47a6ba1f, 
	0xfe090ed9, 0x07f25ab8, 0xc13f48f4, 0x9d9cccbd, 0xb74297aa, 0x7ea15e92, 
	0x5ea8c642, 0xeb663d63, 0xeccba715, 0x7820e3b5, 0x73a38fae, 0x9bbf3097, 
	0x6985e74a, 0xbfb0dbd6, 0x478dce88, 0x47dce853, 0x1e74c134, 0xbee74c15, 
	0xf8bf9901, 0x24e7479f, 0x5ce852cf, 0x9e0e48c4, 0x3afe7450, 0xe7c9a0c4, 
	0x18cfc864, 0xf2aeef43, 0xcb297a58, 0x0f2c3d83, 0xb58e6f0a, 0xf2ce2f01, 
	0xff77a61a, 0xf1f9532c, 0x7d04e686, 0x11bd1195, 0x87b70bbc, 0x24b59b9d, 
	0x372721bc, 0x58f016fe, 0x33eea5ab, 0xff8717c2, 0x27d59fec, 0xe8aa32e9, 
	0xfd30fd14, 0x606e2a9a, 0xba7fd1b9, 0x1fff07e2, 0xc726e7ec, 0x5f4beb55, 
	0x3f27cb29, 0xd239f273, 0xba49dd6f, 0xb7ff4f1e, 0x3f83f5a9, 0xf7b2b9f8, 
	0x6e624743, 0x1fdacf9c, 0x78865439, 0x07795082, 0x9c773904, 0x2ba20ced, 
	0x48f07b82, 0x2af91b93, 0x37b488c1, 0xfc6fcfc6, 0x0be346bc, 0xfcf6de6a, 
	0x2adf4bea, 0xfd3e27cb, 0xc7807ca8, 0x7f3e052b, 0x5d0d5183, 0x56ccdfc6, 
	0xe02edfc4, 0x1ef371df, 0x93eec636, 0xba13ebd8, 0x3829fb83, 0xf09d5a40, 
	0x9b0fc1fb, 0x0b968cf5, 0x0ff849e9, 0xc2f13db2, 0xbd2593ed, 0xfd323758, 
	0xda80f0fc, 0xf3fa5517, 0xfcf8fd02, 0xdfca7a58, 0x41e5af5b, 0x5d2544a0, 
	0x725fefe5, 0xda8ee310, 0xb4ad56b7, 0x33e22d6f, 0x66ae6782, 0xbdf48368, 
	0xf2cfdfab, 0x604ff75d, 0xc17cfeb9, 0x16ae59ef, 0x8ca6a8fc, 0x2399defd, 
	0xb72a11a5, 0x9be58dbb, 0xb7c55f25, 0x79f8956c, 0xb67bda97, 0x37be3f28, 
	0x78002fb9, 0xc64cb1ff, 0xeca4fe87, 0xf66c225b, 0xfb56b20f, 0xa11fb20f, 
	0x9f90f5ce, 0x91b894d7, 0x0f2545ad, 0x957a0d2d, 0x257ecf56, 0x29bdba98, 
	0x84f1d719, 0x775f3c83, 0x8bda0494, 0x9a6b2bf0, 0xe3295fa4, 0x8f119e69, 
	0xf1d8eb8a, 0x8e72ac91, 0x1cbdf88f, 0xf0fcb91f, 0x33c7c974, 0x224efc47, 
	0x17a54cfe, 0xe8ef90c2, 0x7e1df217, 0x6c5fb54c, 0x58e093bb, 0xe1f4ed2e, 
	0x22fdcd68, 0x71cb8e25, 0xecb894a1, 0x33aeb8f8, 0x3f1ffd2c, 0xf91b68d1, 
	0xf928fe03, 0x2a51a741, 0x8dbaa83f, 0x2745a0fd, 0x7e3e79f2, 0xa0fc33f3, 
	0x641fb635, 0x92db39a5, 0x49ab2cfa, 0x51d941fa, 0xa3b28f29, 0x59541fb6, 
	0x3b283f0e, 0xeca0fd2a, 0xb907e966, 0xc63b48b6, 0xc674cb35, 0xf2019809, 
	0x3ce09f4f, 0x9bad2315, 0x75a01bd6, 0xf182765f, 0xce7d8694, 0x2f32e539, 
	0xdeb2e30f, 0x92bd4bf0, 0x568bf09d, 0x79b877ea, 0xb35c3c2c, 0x05f699c4, 
	0x869e6528, 0x37f06f2b, 0xc55d47b0, 0x7b8fd5c6, 0xb4c70fe1, 0x2e54a3f6, 
	0xda5b5cb4, 0xfb538a50, 0xd74bec53, 0xe7579a62, 0xe308f985, 0xeb3cc0cb, 
	0xbfe92ed4, 0xe5cd1e85, 0xef40d3d1, 0xab661919, 0x914a0d79, 0x15943d06, 
	0x1eb68a8b, 0x59ee192e, 0xe416eab1, 0xd6977d2d, 0xb03c7b05, 0xa157ee5a, 
	0xb5157ec4, 0x267ec34f, 0xbd51b3f7, 0x3df7ab0f, 0x3c67b849, 0x88d23610, 
	0xef96325e, 0x82739f5d, 0xa21cb4cb, 0xa3078cd3, 0x33c11a66, 0xf601d943, 
	0x972d6f7c, 0x72cdfff4, 0x7efc0fc9, 0xabdbcf39, 0xecbdd3f6, 0xd5f3596f, 
	0x03ab1af9, 0xd8d1927c, 0xe5ec3af3, 0x927b43bf, 0x9a2b19ab, 0x3bf6343a, 
	0xee344e09, 0x3499d8a9, 0x767af641, 0x4734e9d3, 0x674ced00, 0xdc727767, 
	0x075135ac, 0x2701f8e2, 0xcebd2bf1, 0x6dfdc972, 0xdf55ef6e, 0x3a339cb3, 
	0xb6a7afe2, 0xfd77ffab, 0xce33b45a, 0xd9f1d63e, 0xe446f878, 0xe3d872c1, 
	0x196e097f, 0xc02c0e2b, 0xd8bc6dbc, 0x1e167ddf, 0xc7266f40, 0xe41944c3, 
	0x1b05f3c4, 0x58be39cb, 0xd921e323, 0x9b285390, 0x49e852ad, 0xe73d74f1, 
	0x71576c79, 0xfd4fc429, 0xdb238621, 0xff145b6b, 0x785be5ea, 0x8d3a62be, 
	0x6054364f, 0xa31fd485, 0xf9a56d78, 0xae2b5c91, 0xe61df693, 0xa1cab887, 
	0xc7d7fa72, 0x2facbe6a, 0x17d05fe8, 0xcefb9df4, 0xe40bf3e4, 0x58efe0fa, 
	0x647a1fae, 0x95ffac9a, 0xf0273d72, 0x8e57965d, 0xb0ffe972, 0x7256ef3c, 
	0xe967f18a, 0xc280fedc, 0xece99f5f, 0x2098bd80, 0x48e987d3, 0x1f7f6f8e, 
	0xd76e16d8, 0xefc8cf58, 0x38f55733, 0x226f1cbd, 0x4572c5c5, 0x7efec7ce, 
	0xf2ac224a, 0x4d9d2507, 0x33f9d435, 0x95532f45, 0xd3f348dd, 0xbfd80efd, 
	0xd14bbf44, 0x2753f62e, 0x0ccca1c9, 0xafe5276a, 0xdb3c7057, 0xd46f02f2, 
	0x05f61b6f, 0x64f84375, 0xf383b63d, 0xf66a6fc1, 0xf49fa945, 0xcf8f9625, 
	0xe2ad5d71, 0x7f6a0de4, 0x8e3e9dec, 0xd3ee8c8b, 0x397dc88e, 0x2e8e4352, 
	0xe8e15fa6, 0x7932df82, 0x3f083c5d, 0x6f7fd273, 0x78fd5109, 0x70d3ccb9, 
	0x36fd280d, 0x3da8bfe8, 0xe6de0627, 0x4ca72fba, 0x036f65e2, 0x3c2fb1fb, 
	0xbbdf2553, 0x5f841ccf, 0xbca78a38, 0xf1907891, 0xe4f19c74, 0x2bfa57ba, 
	0x0e7d4dfa, 0x73e2dfe8, 0xa7fa03a2, 0xa6dd3750, 0xeba27f3d, 0x2f1cf2a1, 
	0x0fc2b31c, 0xebc82ccc, 0xdafa77c2, 0x42d7fd52, 0xbc557db2, 0x8b33b387, 
	0x389e6bcf, 0x58fcf1e8, 0x84b11abd, 0xdcbb783b, 0x4b4eaf2f, 0x7dfb45ea, 
	0x6016f221, 0x3ed259c7, 0x6d673d29, 0x4f3e6532, 0x877ef22b, 0x28f3936e, 
	0x8f507f3d, 0x65bf221f, 0x7a0b3c5a, 0x919df2a3, 0xa9f3a94d, 0x3e7b35d4, 
	0x7a99fa3a, 0xaef3fcde, 0xfb1bc9cf, 0x2520f823, 0x6ba2210f, 0x4452e43a, 
	0x05ed2950, 0x5d38ed9d, 0x7a299de8, 0x0fef6c33, 0x78f95e39, 0xa7ae585b, 
	0x7bca4ce3, 0x81dbf721, 0xa3f676e7, 0x6bf6b56b, 0x7ce0ff25, 0xf3c9c9c4, 
	0xf2af205b, 0x7b5e32a3, 0x3fdb7e01, 0xfaec3e65, 0xf8a2fbb2, 0xefe9393d, 
	0x2df8a9e3, 0x4c75ee75, 0xf52fc012, 0xdf1240f8, 0x5b8ca562, 0xe7ce9d90, 
	0x979ea6a2, 0x06ec94fa, 0xc13a8fc9, 0xcd1d7417, 0x0e54ad11, 0xe8c773eb, 
	0x57314ac7, 0x0a9cde40, 0x8fd8ead7, 0x491e44ad, 0x29ceb938, 0x40eaa704, 
	0x79ac3d4a, 0x6ed50183, 0xca9efaaf, 0xf95e5be1, 0x1da535b8, 0x0d7eb5e0, 
	0x38f965f0, 0xe5ef1a7f, 0xb7b62639, 0xb2764a86, 0x1bf9e81d, 0x5487ff9a, 
	0xc85b339e, 0xbfde10d3, 0x9ec3d631, 0x183b9cf6, 0xbc0e8937, 0xa4b734ef, 
	0xae1bdfe2, 0x7a2f8811, 0x48f3c9ce, 0x1c253743, 0xa3979da2, 0x6f86ef81, 
	0x936a5ea0, 0x8585f0f3, 0xc07a4d56, 0x60b43517, 0xaddd8a4b, 0x893e47f0, 
	0xf9222fe6, 0xe2d0d250, 0x20b1084f, 0xf7b2e52a, 0x99e3979c, 0xaf834bee, 
	0x362e8904, 0x761e6547, 0xc721de4a, 0x08779197, 0x9b7f27be, 0x6a3a71fb, 
	0xcfd4125b, 0xaf52a297, 0xbb22ef7a, 0x27146c9e, 0xec9edbfa, 0xe8cfd1ef, 
	0x7823ebcf, 0xea395e40, 0x99bd03d6, 0x6ebd9daa, 0xa8dcfdbb, 0xe3e32394, 
	0x418e99dd, 0x56e433a6, 0xee5f7da3, 0xb64ea3d7, 0x4fc6c7fb, 0xa71c6089, 
	0x3f1a314d, 0x05b73f25, 0xc74cc8f1, 0x17f698c0, 0xb91b5dc6, 0xa91aef3f, 
	0xade252a7, 0xde5fd02d, 0xd62fd2c5, 0x8a578517, 0xfae8f914, 0xcf6fcca2, 
	0x43a1abbc, 0x3fdce10f, 0xf41372d1, 0xf428aad6, 0x49e94058, 0xf0e1835f, 
	0xf788f7ab, 0xb37c14fb, 0x4eb420be, 0x5135bba2, 0x799cffa9, 0x3be0fe52, 
	0xaf7827ec, 0xf1c8386b, 0x1e3295f7, 0xef31eb64, 0x84e1911a, 0x8b145f3c, 
	0x36bd548b, 0xd2631f9e, 0xf23c4e5f, 0x9e9f0905, 0x8f8bd63a, 0xef924df5, 
	0x06e0f547, 0x0e3b3fe6, 0xff249a28, 0x20777c91, 0x23e9986e, 0x7bfc26fa, 
	0xfa51be1c, 0x898711d1, 0xf1ef7dca, 0xb60c7ef8, 0xbfa66ac5, 0x79f788f5, 
	0x0112a2ef, 0x4bc4bf7d, 0x5be08fa6, 0xec3c317f, 0xf21fc288, 0x8fef890a, 
	0x3ffdb61c, 0xa6551f0e, 0xecd7af1d, 0x4cf3f7b8, 0x4d94c6ff, 0xfb1937ec, 
	0x87ef885a, 0x342f3497, 0x307f219f, 0x5d044ec5, 0x2d5967a5, 0xcf4a8fd8, 
	0xb43aeab4, 0xcf4f5ca4, 0x1cf11cb0, 0xfb82aed5, 0xe3cb3b4f, 0x1c03695b, 
	0xc75c30f1, 0x835cb4b9, 0x2d3eeeb2, 0xcfcc6eeb, 0xd9583195, 0xc33c3b01, 
	0x26df75b8, 0x12e6e5d8, 0x9b299f35, 0xce7f71b7, 0xb7b2848f, 0xec3f7c68, 
	0xbbb0a5ab, 0x16ebc07e, 0x25e7065d, 0x0f091a8b, 0xd291fcff, 0xded24768, 
	0x11bbf922, 0x243c5674, 0x1d13b656, 0xda544bfe, 0x8abaf6bb, 0x9c4f09e7, 
	0x8f38a9e8, 0x0f8e1cca, 0x8e1d3d31, 0x8b03a722, 0xffa3f2cc, 0x7056f71f, 
	0x0e072fff, 0xf3ddde33, 0xf6fc3ee5, 0xfbcb387f, 0x1baedbf0, 0xb9790d99, 
	0x87e49b6d, 0xb52de76d, 0xc440617f, 0x520f6d88, 0x64bf653d, 0x1cf360db, 
	0xed5787f0, 0xbc557acb, 0xbda8edef, 0x7456fcdf, 0xcaacbecc, 0x855afb57, 
	0x8bd1ffcc, 0xc1ec070d, 0x23625993, 0x7f619fce, 0x78077a02, 0xc4229f68, 
	0x9d721555, 0x3e7b281f, 0xfecc2477, 0xb544a4c6, 0xa4ddfe13, 0xa9db20c1, 
	0x7c20d8e9, 0x5077e149, 0xb5f217e1, 0xdd821c5c, 0xdea5f8cc, 0xce586727, 
	0xdda83bce, 0x636db448, 0xc5df124f, 0x875f354f, 0x27ed4732, 0x233ced0e, 
	0x74ebb0e5, 0x6870f82b, 0x20a701e7, 0x6b78a1db, 0x7ae275f3, 0x58279a31, 
	0x13ae34ec, 0x587c336f, 0x349c9cbe, 0xabec2367, 0x7170fae2, 0xaef3fa9c, 
	0x40f9da70, 0xfa07e02d, 0xe958f388, 0xd4874f73, 0x72ffbcaf, 0x76f92fc4, 
	0x530b1858, 0xd3fef3fb, 0x3780475b, 0x15f9485d, 0xf1bb2418, 0x2a67e44e, 
	0xfa4bbc7f, 0xd63f76e3, 0xc53f493a, 0xa0ad3d43, 0x71189733, 0x26dcb9f2, 
	0xbcfb1efa, 0xd73efca6, 0xf1d6fd2f, 0x8e3b0cfd, 0x45ad7fb3, 0xd24703db, 
	0x5f083c14, 0xc95f0ad9, 0x8236b8f5, 0x34778baf, 0x24a7344f, 0xd138b0f9, 
	0x27dcd137, 0x83dee39f, 0xfa82e7d4, 0x8e7a5748, 0xf58e9226, 0x2e958586, 
	0x864557f3, 0xbc5ac78c, 0x44d5953f, 0xb87aa528, 0xfa67e642, 0xbf4fab6f, 
	0xce5df49c, 0xc0cdc196, 0x0e47f607, 0xb48efef0, 0x557eca3b, 0x97c0f4ae, 
	0xd96cae59, 0xacf0c455, 0xf3cb2f04, 0xa3886936, 0x47518438, 0x51c8a9ee, 
	0xa47e8a74, 0x49a663bd, 0xdad0c77b, 0x9c45bc95, 0xd942babe, 0x5937fe3b, 
	0x4527452e, 0xf9ecfca5, 0xb5d3cb32, 0x1c76ebaf, 0xd4e585b8, 0xf8b3ed67, 
	0x42bfb54d, 0x117c7e3d, 0x1b134e38, 0xc74f944d, 0xbd0e8226, 0x7d83c259, 
	0xfdafef34, 0xc537411b, 0x482c18df, 0x8e18a3f5, 0x1a6aff34, 0x4255c5fe, 
	0x9ec0abac, 0x3d7e98ca, 0xfd402edc, 0x44e614a2, 0xec217af3, 0x07e2c2fd, 
	0x276f3f09, 0xe1f8a1e9, 0x5d322657, 0xfbe5739b, 0x5f1857a6, 0x71a3adc3, 
	0xf61fde11, 0xc1a58e2d, 0xcb0acb8e, 0x7f1d8b78, 0xfdca8ac9, 0x77152ce7, 
	0x6e329bf1, 0xc9b88e92, 0xe569f020, 0x05b47ac9, 0xe23a7976, 0x8e227726, 
	0xc7055f72, 0xe19fea8d, 0x2dcd4d38, 0xf9b8c857, 0x394f1912, 0x07189979, 
	0x47d72927, 0x0cf230f5, 0xf839ea13, 0x83fc41d8, 0xff242475, 0x3d178f8c, 
	0xc2892515, 0x03a63e79, 0x0be43276, 0x572e4afc, 0x6c53d60b, 0x478f8f3f, 
	0x52748987, 0xe32fdaf1, 0x98dabf89, 0x44f1b9ff, 0x8e886bf6, 0xc87fa266, 
	0xeae76579, 0x733fa533, 0x9e7eeeba, 0x235ef38f, 0xd243be7d, 0x6859c721, 
	0x3c43ad4d, 0xcfbcf58f, 0x3acf9865, 0xc6c31f20, 0x0ebfd861, 0x17e08712, 
	0xa71acce7, 0xee396353, 0xdf38d0cc, 0xebfb30e1, 0xf987a9d1, 0xb924e33c, 
	0xb78be47e, 0xf08f129a, 0x582e3f73, 0xaf4f70cf, 0x6673e6af, 0xa86617e4, 
	0x975e61fd, 0x0b8feebd, 0x27a02bda, 0x85777fc6, 0xdfd11782, 0xf15f9c19, 
	0x467894ad, 0x07edbc4c, 0x3b3c4ba8, 0x1c5d1257, 0x76c83d40, 0xd125738c, 
	0x3db53547, 0x7ac79bde, 0x8f0a6abe, 0x5f537193, 0x71f7ee31, 0xcf8c2f86, 
	0x116fdc71, 0x3f8ca1d1, 0x93c3a06b, 0x69155d81, 0x7bdf240f, 0xe0de89eb, 
	0x994d57bf, 0xfc8b5ddd, 0xa03e5ad2, 0x74b1999c, 0x2a11c776, 0xd86f6af3, 
	0x1dff83ec, 0xa86b8917, 0x788cf59c, 0x1e17ef0c, 0xef136bbc, 0x2eb8185b, 
	0x2b7f02e0, 0x8d668ef3, 0x068e2496, 0xe6a455f6, 0x2f65d8dd, 0x2dcf20e0, 
	0xd2efca6a, 0xda778f10, 0x70848471, 0x2d743d30, 0xd1183ce4, 0x78eb50be, 
	0xf03de53d, 0x555db881, 0x33fb05b8, 0x26458af3, 0xbca933ef, 0x18c4b119, 
	0x27ef3df3, 0x885f6185, 0x95673843, 0x40ff2311, 0xc54d1fca, 0x57a93499, 
	0x71dafd24, 0x37bdbb07, 0xce0ee32a, 0x35cf830c, 0x9fb1c37a, 0x9a4e6702, 
	0xf4b2e237, 0xff07e39e, 0x79d2eb4a, 0xbc86a65d, 0xc6546f72, 0xdcbfd011, 
	0x81ac3b3f, 0xe4a27efe, 0x363eb0eb, 0x9c19ef3e, 0x3e44e2d2, 0xe7c8385e, 
	0x520d1c27, 0x24170d7f, 0xb8aa3f24, 0xd25faf83, 0x36d4e60d, 0x3749751b, 
	0x9ba27eee, 0x628fce6a, 0x13f771ba, 0x74c01cdd, 0x6139629e, 0x5d7932f9, 
	0xee374541, 0x9ba0cfea, 0x0cbf2d88, 0x93dd710d, 0x522a0f81, 0x619cc7f7, 
	0x79a13749, 0x71d0bf4b, 0xc7dca518, 0x5dc7150f, 0xf346bc4f, 0xd74859f6, 
	0xcf45a115, 0x51571d68, 0x7884f8b9, 0xcfed45b4, 0x0afc509f, 0xd7e0743d, 
	0x7f7b37cc, 0x0fd48975, 0x0f2c8d5d, 0x21982e9e, 0xc534d9e5, 0xe80f34ff, 
	0xa17d519f, 0x2c233bf8, 0x3f1a4cd2, 0x9e946d30, 0xf8778fd8, 0xab65bc44, 
	0xb95f092a, 0x46f068ba, 0x613a2790, 0xf7827e81, 0xc4eddcaf, 0xafff13ab, 
	0x23c8f5ea, 0xc7a11e05, 0xbd49a6d2, 0xe5879865, 0x6ae832fe, 0x367ff550, 
	0x118f4789, 0x893c416e, 0x71fb4744, 0x3aeb22f3, 0xd75e2bf3, 0xa4f3f7bc, 
	0x632e8b5c, 0x53e6fafd, 0xcc3cec33, 0xa719ebb1, 0xfe0272ff, 0xc7df2c69, 
	0x01a3c1e9, 0xbdc9099a, 0x5fc951d0, 0x30fc71e1, 0xf793d7ec, 0x1e7c682c, 
	0x46e3f397, 0xaf8941f3, 0x68730f30, 0xeb961f74, 0xeab0fba3, 0x29835c5c, 
	0x133e83df, 0x74f1ce63, 0xa5f9521d, 0x8b4b671c, 0x41871a0c, 0x8e76ee9f, 
	0xedf5598b, 0xe76adfbc, 0x49a74581, 0xa56d67fb, 0x55e17d60, 0x4be9a1f9, 
	0x198ffdec, 0x67c79d72, 0xd9c7fef2, 0x5c78fadf, 0xffb97cd7, 0xf4067ec1, 
	0x43666e8b, 0x367acc3e, 0x7df18e27, 0x5f7853fd, 0x4b9ed661, 0x5f7fe0e2, 
	0x1b4b457f, 0x2d9999f3, 0x1c4303f3, 0xb3fa1357, 0xcd8b2f2c, 0xac5fa574, 
	0xf66fe06c, 0x711b2d5e, 0x463ccb87, 0xaf6453f6, 0xf81f80d5, 0x69998ca4, 
	0xf87c9bef, 0x94fcaa69, 0x4feb607c, 0x92279b96, 0xfeae64f9, 0x4fabb60a, 
	0xf5e1ae06, 0xb4a7fab8, 0xe76fae21, 0xc62dcd8f, 0x72595959, 0xb1864bbe, 
	0x9f39f94d, 0x5b9a9ec0, 0x625f3635, 0x3beb3cee, 0x857c955b, 0x5b74e81b, 
	0x51fb3b47, 0xcb70fcf6, 0xd309fce3, 0x9a03e5db, 0x992f438a, 0x8afc7f06, 
	0x438e71e3, 0xe24fcaeb, 0xe1c050bc, 0xd0e363db, 0x039a74e2, 0x6ddffce7, 
	0x5cb861cb, 0x90d7103e, 0xf1c57987, 0x17679c83, 0x1fe3269b, 0x5fe92b6b, 
	0xb27d33f7, 0xadd313fe, 0x80e73e16, 0x97f53838, 0x7ec2355e, 0x3ebcfa7e, 
	0xff4d67ce, 0xdab72ab2, 0x5322e1fb, 0x7ea41006, 0x65468ece, 0xe52d0802, 
	0xd74b9c48, 0xae9a5cbb, 0xcf9d65f7, 0xce750b7b, 0x030ae05b, 0x979cf759, 
	0xfbd4fff5, 0x8caff52b, 0x7d56a138, 0x769cdfcf, 0xd9db0625, 0x7861ace3, 
	0xf137fb1b, 0x67718e3e, 0x18afccab, 0x79a8271b, 0xde75eb8f, 0xcfc68bea, 
	0x6ad7f6e7, 0x9c6a44e2, 0x935dac61, 0xda747813, 0xda9df898, 0xe2b1ad17, 
	0x2acbbf1c, 0xce121cb2, 0xa45be706, 0xf2072cc7, 0x03c8bcce, 0xa279c29e, 
	0xe40dbef2, 0xff817a5f, 0x4cff8c9d, 0x631583dc, 0xf10cb03b, 0xfa57d76d, 
	0x523b8aca, 0x68d732f3, 0xcf63c25e, 0x05e78bb4, 0xf6cd3f3f, 0x369e9f3f, 
	0x95732f36, 0xfb127d86, 0x0757e23b, 0xf9b085ee, 0x3d01f415, 0x21ad7c48, 
	0x20fd184f, 0xed3a55ee, 0x5f7269f9, 0xe13ce2c3, 0x1f4956f4, 0x61e6e959, 
	0xd2b2b7c4, 0x3fad39e9, 0x9fbcb57d, 0x1874e080, 0xe79d1de7, 0x7c98b70e, 
	0x38d2d44e, 0xc19a7d4f, 0x4a3c6be7, 0x2c46b98e, 0x5c87eb47, 0x14dd7a97, 
	0xb393df7c, 0xd628f124, 0x646ede9d, 0xdcb33e42, 0xe2f326f4, 0xfce2cd0d, 
	0xe4879630, 0x4ef325c7, 0xca8fcf46, 0xcf298ff8, 0x0caf0f05, 0xc8c7398e, 
	0x249f1df9, 0x7920c3ef, 0xa60af9ca, 0x2b7992d0, 0xed59dfd0, 0x06cdafac, 
	0xa22e8792, 0x0daa47fb, 0xd978d3dc, 0x47cf8d01, 0xcdabe9ce, 0x565e9d81, 
	0x9d90f129, 0xb9c02d69, 0x82e9ec8e, 0xe46ca9ed, 0x50bce0ab, 0x2713519e, 
	0x3ff67627, 0xbcf9c43e, 0xba12ff24, 0xe1337ff4, 0x357b396f, 0xab79f39d, 
	0xe655fe7a, 0xd0995afb, 0x7ea45f63, 0xeee25273, 0xc725ad22, 0x67b290f9, 
	0x2ad20e88, 0x71919e65, 0xf21c416e, 0xb902e198, 0x3f9d4d3b, 0xd0b3851a, 
	0x71f4e700, 0x5b1c3670, 0x059fce19, 0x3f0506bf, 0x8e0f1267, 0xcf77bdcf, 
	0xcb7ac5df, 0xa031eea1, 0x9f79fbf5, 0x86dfe146, 0xb84861b3, 0x31ef4a1b, 
	0xc4933c3d, 0xfdcfb08b, 0xb0838b56, 0x84ff18eb, 0xc94fecef, 0x73e7cff0, 
	0xc8c503f2, 0x0316a95b, 0xf0ba5eb3, 0xc7619e5c, 0x9f3a13fb, 0x3ef1b517, 
	0xbe1b4ede, 0x2d17e547, 0x2623884e, 0xb864d5f8, 0x8d395e71, 0x7c998ee7, 
	0x6694ce3f, 0x327ff3c1, 0xfbc95190, 0x384bb966, 0x6a7cc93e, 0x15e7c971, 
	0x3e0ad5dc, 0x53791e76, 0x60b5a057, 0x6a965dac, 0x3e55399f, 0x15cf8db5, 
	0xdccabc81, 0x2a4fc18f, 0x7bef1a1f, 0x29f87e54, 0xd5226fc5, 0x233e267e, 
	0x74572d38, 0xde29fd80, 0x95888f87, 0xf1a3e790, 0x976479c1, 0xaace3807, 
	0x54e63e21, 0x7cd131f1, 0xe09aa385, 0x3dc4bbbd, 0xd403f78a, 0xef88dffe, 
	0x8837ac83, 0xfac63fb2, 0xcd2f6cfd, 0x1c35e3fa, 0xa16217c7, 0x212fbbcc, 
	0x733e9178, 0x189c2427, 0x6aa70c2e, 0x92ae5386, 0x725c3663, 0x0a44a701, 
	0xffdd127c, 0xa9a9f09b, 0x343925cc, 0x55f24f3b, 0x6d785936, 0xe33559c8, 
	0x4bbde84e, 0xa13a0fda, 0xaf0048f7, 0xf8cffec7, 0x4a5777f6, 0x4e14663b, 
	0x70a70455, 0xcf3d3f8a, 0xf2b93860, 0x4b93860c, 0x02c87fc5, 0xdd135474, 
	0xf9767cfe, 0x31bd3818, 0xd4e2270a, 0x036f98fb, 0x15cfaf7c, 0x3a499ab5, 
	0xcfc075c6, 0x7d6a8de7, 0x87ad6c37, 0xae4b22dc, 0xe757e69e, 0xe3d4096f, 
	0xde5bf4bb, 0xbf3e27a9, 0x1065e685, 0xbe1416fe, 0x9af315b3, 0xaef110ed, 
	0xd8272934, 0x00f9213e, 0x334ceb7d, 0xc73b04bf, 0x565f34e5, 0x2ed42d7a, 
	0x3f182bf3, 0x5cf9545f, 0x79c177c8, 0x27f14340, 0x067ee7c6, 0x189fd872, 
	0xf83de9d6, 0x1fe32a25, 0x91d7618b, 0x5c2631de, 0xac12881e, 0x147c6416, 
	0xde02b488, 0xe8c72a2b, 0x2dbcfb0f, 0x86f40dd1, 0x57a4374d, 0x545fce38, 
	0xdac5f529, 0x6e99bbca, 0xa9ee0456, 0x13fc58bc, 0x62dd84f0, 0x6f6ed3c3, 
	0xcaf6da54, 0xf98edc03, 0x1f9284fe, 0x07e527af, 0x3c2a50ce, 0x1ee3918c, 
	0xb96c0fa5, 0x81357c6d, 0x57b205f4, 0x90f41a3d, 0xb0e7d86e, 0xda7d33d6, 
	0xbbf25ff1, 0x2cac39e5, 0xdf93b443, 0x38cc0a23, 0x7920fdee, 0xccdc4712, 
	0x9e9daa25, 0xd39f9cd3, 0x873f3634, 0x9eed4ee0, 0x28d6fc02, 0x2179def8, 
	0x3bb02f7c, 0xbdb28eba, 0xab72cabe, 0xd89be6bc, 0xc89e08ee, 0xb4bbf650, 
	0x37f652b3, 0x09c8cfd8, 0x7b64aaec, 0xec13f943, 0xca4d2c77, 0x7e551147, 
	0x4c9e7db8, 0x7c7b49e9, 0xcf8c9efb, 0x48665f3c, 0xb1233ab8, 0x3fc52d16, 
	0xf0902e18, 0x9195cfb4, 0xbcec259f, 0x7931f6aa, 0xf3868655, 0x13f7b063, 
	0xae54f929, 0xe145ff06, 0xe7551192, 0x6e32c22b, 0x18f88192, 0xa547a78d, 
	0x95119bff, 0x547a5879, 0x6d4dbff9, 0x2e4407ec, 0x7755f955, 0xec9f7b48, 
	0xbffb8be3, 0xbffa8eb7, 0x1effe90e, 0x7ff54caa, 0xff4897d3, 0x7c9115d7, 
	0xc5f752ee, 0xfd64f2b9, 0xc71e8a67, 0x3e317f97, 0xbf1cf2b6, 0xccecfabf, 
	0x963e2abf, 0x6559f813, 0xc7691daa, 0x3c1fd8c7, 0xe925f0a1, 0x32c6e99f, 
	0x3d3d18c5, 0x3f20e71a, 0x73afd53a, 0x034e69cd, 0x56353da4, 0x8c3de71a, 
	0x913c3f8b, 0xb1eb7c21, 0x219baf6f, 0x84682fee, 0xe415af30, 0x9c716709, 
	0xbdf10ada, 0x087a5d23, 0xcf8dabf6, 0xebefd755, 0x767823ce, 0xef9f7e6e, 
	0xb789723f, 0x3b1c5572, 0x7f66f417, 0x32e6fd47, 0xdf790abf, 0xe565c394, 
	0x458184be, 0x4f7e404f, 0x5fa532f2, 0x3cfce84d, 0xe80237ec, 0xb1f973a7, 
	0xee56b4c0, 0x5ff558bf, 0xe2ffae3c, 0xb717fd71, 0x2b62146e, 0x3ec28bee, 
	0xc77bc946, 0x9be0fdd4, 0x2750f8ec, 0x50a25ddb, 0x285257dd, 0xbf212bef, 
	0x89daf08e, 0x57a9417c, 0x23bdd50b, 0xe77f5885, 0x9f3977a6, 0xddf6eb70, 
	0x65bcaf9c, 0xce83a4ba, 0x4f9c794d, 0x2c1dd512, 0xcd6eb7e7, 0xfaa6aa2b, 
	0x1e32e999, 0x4d75c0bd, 0xef00faed, 0x9ce2157b, 0x8c849ddb, 0x544f2a02, 
	0xbe3155e6, 0x388a5175, 0x70b73d17, 0x95fd014f, 0x6dfb5076, 0x2aafbf4a, 
	0x5ec16476, 0xe977f1a3, 0xbb6d8f3c, 0x50ff0740, 0x851ff725, 0xf98fa0b9, 
	0x8e55927c, 0xe4ef8b3c, 0x789c5f09, 0xdb58da3a, 0x3a4bf71c, 0x31bb0a3f, 
	0xbb0e51dd, 0x94b7a451, 0x446a7ca1, 0x7ebe872b, 0xe1f34472, 0x0b6fbfd2, 
	0xfa7a1ca3, 0x3bf211c9, 0xce6d1ea9, 0xf7b1f3e5, 0x6944fc3e, 0xf7bdc690, 
	0x20ecc1dc, 0xe4707ad1, 0x97d853f1, 0x956f9977, 0x7ba61f22, 0xb6b7dcba, 
	0xfb13bbe7, 0x4ee3b02a, 0xd04efd39, 0x39640fe5, 0xd3c54aab, 0xf108a374, 
	0xce1f7bdb, 0xde7804dd, 0xfec3975b, 0x73ab3dc2, 0xf55f6137, 0x8fb92af5, 
	0x0627f76c, 0xe1e02ec5, 0x43dbaaee, 0xd56fcd1a, 0xb05b535d, 0xbb1c35ff, 
	0xc7603854, 0xae7afba9, 0x5b4ffd52, 0xf98c79d0, 0x07dbc170, 0x3f0c2441, 
	0xee87e3b2, 0xfb845a98, 0xc8f95629, 0x0f5e82ae, 0xc0e710dc, 0xe603d116, 
	0x7f9a6ab3, 0xec9fdf17, 0xf79f78d0, 0x52efea65, 0xd147975a, 0xe2d03451, 
	0x35ab8087, 0xfee3f7ae, 0x4f3576bd, 0xfd88bd1a, 0x257fb506, 0xd022fa8c, 
	0x00e4254b, 0xcebad195, 0xbbc7e05d, 0x2138e497, 0x93c89f4f, 0xb35896fc, 
	0x4c588321, 0x8a37eddc, 0xfad24fda, 0x4390d175, 0x1a9a6832, 0xd8b1796f, 
	0x727e9714, 0xaa7dea51, 0xd0458f44, 0xa4aacb37, 0x73a84d9e, 0xf8d2f723, 
	0xbc69bb69, 0x79999ca7, 0x757ba704, 0x847b8d51, 0x3e218ca8, 0xcf86ccbd, 
	0x0bb17f57, 0xfe551afc, 0x7237bd1f, 0xc3782956, 0x4a0fee5e, 0xb5c1597b, 
	0x90fcf4f1, 0x8f3250fe, 0x175fb87b, 0x5947e4ed, 0x244cb7b8, 0xcf2e1fcf, 
	0x4fd84230, 0xfa4ab07e, 0x792cd19d, 0x7b81ac4f, 0x2a9ca492, 0xe5654e3d, 
	0xc8af43d7, 0x52ad197b, 0xaa2ff1f0, 0x1c34fda4, 0xcbb18ef5, 0x73abefc7, 
	0x79cf907f, 0x95c2f507, 0xa7bccfbc, 0x52acf80b, 0x5cde95e7, 0x23fb07bc, 
	0x0c7ad3dd, 0x9ec52531, 0xea13be03, 0xf1cfbef9, 0xfec6a85b, 0xff8e48a1, 
	0xfd0bbafc, 0x3e278c0a, 0x0addef07, 0x19e44fef, 0xddf3c0a5, 0x6d4e79fd, 
	0x001d0a4a, 0xbe140bdf, 0x759ca487, 0xef4920ff, 0x7febbad1, 0xd8d57901, 
	0x3dcc7f3c, 0xe0e9e374, 0xf8edd3f7, 0xcf87a4b4, 0xf4bf575c, 0x3e7c6cc7, 
	0x48d3fa71, 0x7595bf6a, 0x0d3df36f, 0x5d8c3849, 0xc13fd32f, 0xd7855afd, 
	0xaafb9513, 0xbcaa4710, 0x5c48a725, 0xae794e44, 0xca72ce38, 0xcb174573, 
	0xcc9550a9, 0xf3fe20ef, 0x3ea2ff81, 0x17fc09b1, 0x1ef8380d, 0x9202cf08, 
	0x347e343f, 0xca77ef46, 0x454761ef, 0x2ebbe90b, 0xbe3f2f2a, 0xcb2fdf8b, 
	0xdd057195, 0xfea19ed0, 0x4a0e89eb, 0xdc8f3c62, 0x0f44ea30, 0x0e52fd3d, 
	0xea16f7e0, 0x6ba87a6d, 0x499e5a31, 0xe54cefae, 0xffe82aa1, 0xe99d1a7a, 
	0xd1936ea2, 0x51f17442, 0xd82ae1e5, 0xff09c3b9, 0x98c07b98, 0xf92697df, 
	0x046693df, 0x46be7de4, 0x5196fc2d, 0xee6752b9, 0xe4835c42, 0xf8931ecb, 
	0x57503bb6, 0x8f45f586, 0xf30e7b6d, 0x973ab1d8, 0x7de2f7cf, 0x6de320cf, 
	0x65d7ded7, 0x77fd43d9, 0x11cf18b7, 0x19b48a85, 0x5e3bfe72, 0x4f7133c8, 
	0x6b3ebdd3, 0x7db9f017, 0x0b9f57f5, 0x0afbe5fb, 0x8abbc3c2, 0x3eeaa30e, 
	0xb1fb8166, 0x1eb19f24, 0xaed24afe, 0xe53b65cb, 0x7ddb6106, 0xafc3a0b9, 
	0x2360fb28, 0xf32ce8e8, 0x52c7d2a9, 0x9f2f42ef, 0x23fd556e, 0x44605bfe, 
	0x49b780fa, 0xed1287c2, 0x18e0ce1a, 0xb7311987, 0x28f715fe, 0x5f3e7c35, 
	0x208add09, 0xe3c4f92e, 0x1c160743, 0xc3c6bf41, 0x3e93369b, 0xc83d8dd5, 
	0x37ead92b, 0x4e94d86e, 0xc6ec5065, 0xb0d6d67e, 0x47df8331, 0xdfb067ad, 
	0xf0dab5b3, 0x0e327de1, 0x8f9c1ff1, 0x3fe7ce5f, 0x5813cfda, 0xfabfe257, 
	0x9fab7ff9, 0x6c9dda27, 0x173e80b7, 0xfbc7fd34, 0xa7a2cffd, 0xffe7eaff, 
	0x613cfd5f, 0x2ba7a58c, 0xd8be9e89, 0xbe17ed24, 0x09e95507, 0xe884fae3, 
	0xdbcc2f37, 0xd8f9513c, 0xc1efec74, 0xfc9e801f, 0xe9d6cf77, 0x4f61f7b0, 
	0xd85feaa5, 0xfd33884d, 0xe989f2a1, 0x65fa7fac, 0xafb6d27c, 0xfec0ded8, 
	0x463ea0f2, 0x9a3b738f, 0x7ceabddf, 0xff0fbdd3, 0xbfc439f4, 0x5282cf44, 
	0x4518dfe9, 0x3351a738, 0x4f29fa43, 0x1f39380e, 0xad3be77e, 0x971162e5, 
	0x87d7b865, 0xf20e7b7a, 0xdeefe77e, 0xc3de4e7d, 0xdce1946d, 0x07e54ec6, 
	0x655be669, 0xf988bcf2, 0x77c1f61c, 0x7e3fa5f9, 0xf807bab7, 0xf76c91c9, 
	0xd73d9c46, 0xe917b28d, 0x0723d3f9, 0xa01839b3, 0x97eeffec, 0x3ed2cb1a, 
	0xc833efa0, 0x7faa17ee, 0x08674bf8, 0xbb65cbae, 0x3f126f0e, 0x7f1bfabb, 
	0x659d788a, 0x933f37db, 0xf650ecfd, 0x5188f6ea, 0x707a49da, 0x086c0cf6, 
	0x9afc0b89, 0xbb2a17bb, 0x36f29ff6, 0x3fa764e9, 0x9fd47d3d, 0xcae794c8, 
	0x0ef88e8c, 0xf9167ffa, 0xadd43149, 0xba2fac6c, 0xe81ee970, 0x9064eff9, 
	0xef80451f, 0xde380476, 0x3025df4a, 0xf8a8efef, 0x72a73f00, 0xb7690cde, 
	0xee5d3cbe, 0x9f0ca333, 0xef2eb781, 0xa8ea35bd, 0xbefa5abf, 0xae93f944, 
	0xd7607bd3, 0x96970b19, 0x8738025d, 0xf66eb28d, 0xe739452f, 0xbb49e5bf, 
	0x3e111a2e, 0x11dd11d8, 0xc13d5382, 0xdfe69c43, 0x3faa7ab3, 0xa371e7c2, 
	0x8732f183, 0x4f30f41f, 0xcf8ea1c6, 0x1b874493, 0xe64a1e1f, 0x84295dbf, 
	0x2e4afb0f, 0xfbce5351, 0x7bea03bf, 0xf7512f75, 0x807b439b, 0x32fca7ef, 
	0xf8f860bf, 0x371f993c, 0x8fdf8f38, 0x7fab67c6, 0xd9f1b9f2, 0xb277daa8, 
	0x811589fd, 0xcf88e9e1, 0x9f721e02, 0x7f09e09d, 0x78fac451, 0xb1b7b2df, 
	0xdf4ffb06, 0x1db157d0, 0xc88bd5a9, 0xaed245cf, 0xf8fe2cfe, 0x9db6fb6c, 
	0x97e6d0f9, 0xd6fb7dff, 0x74f790aa, 0x10b6d718, 0x485bdc5d, 0xceec1bf6, 
	0xe09b7963, 0x70f3dde7, 0xbfbe7dae, 0x63b8ed8c, 0x7cd37fe4, 0xb2e53556, 
	0xdc784fbf, 0xe9eb4033, 0x3dd5f65e, 0xcfd29d0d, 0x7475a1ad, 0x1eeafeaf, 
	0xbee889e0, 0xf1bdfe1c, 0x9de58deb, 0xd9376834, 0xab7eea83, 0x2ce9f072, 
	0xa7cdc7e5, 0x18179c27, 0x3fe04514, 0xb5075dd0, 0x11f936fb, 0xe7b237d8, 
	0x68fafc6f, 0xb653f636, 0x8e682eb7, 0x3e9e2013, 0x9ce0453f, 0x2b3caad8, 
	0xce04f71b, 0xe9adac6f, 0xa3c8a7f4, 0xf02296f4, 0x690cf94f, 0xf27cd9e7, 
	0xbe11c0e4, 0x903c45e7, 0x957d47e6, 0x8c9f23f2, 0x2d132cee, 0x7cc3be49, 
	0x19558f30, 0xfc93a8a2, 0xbcef1de3, 0x4e28b8fb, 0xb9c767ce, 0x37c0e7ce, 
	0x94e48e4f, 0x4a7edfc3, 0x53c8aefd, 0xd1b2f7d1, 0xbf09f80f, 0x0ced740b, 
	0x943b87c9, 0x00fac2bc, 0x3e036f97, 0x27675c9a, 0x9c5facd9, 0x8131e121, 
	0x9019e44a, 0x7664db7c, 0xfcbfc85e, 0x45abda5c, 0xfe326f38, 0xd6f105fd, 
	0xbd729fea, 0xb55c9afe, 0x79c4d7df, 0xb3f85f1c, 0x7dc78edf, 0x6695bc46, 
	0x56f139fe, 0x2f983d7b, 0x2f085ff6, 0x772b9035, 0xd22c6f9f, 0xfc42a410, 
	0xa5dfbe82, 0xe7dc018b, 0x95afb3be, 0x8e39f5f7, 0x35c64b11, 0x0bb4de98, 
	0xe3e31ae3, 0x6cbe3619, 0x1a736cfc, 0xbfdd6a39, 0xcb5775e1, 0x53e9a17b, 
	0x9da9e207, 0x3bfce28b, 0xc83d2e0b, 0x646245f9, 0x973d489e, 0xbb5111ad, 
	0x0fe0f790, 0x580fd70a, 0x5f30f890, 0xd396f70d, 0x7f953b7c, 0x12c5c2e7, 
	0xefb085bb, 0xd8128ea3, 0xf513247c, 0x2fc68379, 0x6e67a64d, 0x15352517, 
	0xcf894a18, 0x5def8309, 0x2978b69f, 0x122dbbdf, 0x99e43e3d, 0x1ac67d7c, 
	0x3b2fd709, 0x2b07bde4, 0xf7ce111d, 0x70475772, 0xed4bac6e, 0x37de8d4f, 
	0xde7c4f5e, 0x6737c42e, 0x87d7b8c8, 0xb066879e, 0xf791ecbe, 0x544b6ad3, 
	0xad69de3c, 0xbb71961b, 0xedbb8672, 0x96081d07, 0x7e2beea5, 0xdf3e46a7, 
	0x80377ea5, 0x26365af0, 0x9468267f, 0x766e73cb, 0x7f7056bc, 0x4b9e4ed4, 
	0x5657d39b, 0xad13cf43, 0x67903d91, 0x8e7597c3, 0x4c1c33cd, 0xf21b67b9, 
	0xaad788d7, 0xb78e3dfc, 0xb44776d9, 0x81f19f21, 0xbbf13ffb, 0xde4ef886, 
	0x03bf275f, 0x29cf531c, 0xfff7d7fd, 0xf78f7ecf, 0xebbf219b, 0xaefc328d, 
	0xfe88e407, 0x411c8a50, 0x0f92b49e, 0x6c7e8fc8, 0xbe773a86, 0x86c3e644, 
	0x0f3aa0cd, 0xfbc708f6, 0xb5ceb71b, 0x87398ddb, 0x77781399, 0x2e2f3c86, 
	0x0fbd89e5, 0x68f4f0e0, 0x95de3390, 0xbd49f363, 0xbd49f2e3, 0x0749f3e3, 
	0xa45f783a, 0x4c89c1e7, 0xf95f196f, 0x0ba4f90b, 0x9e05e7c7, 0x2fba919a, 
	0x9f2a1ba2, 0xbfcf5e74, 0x95693e73, 0xf349f321, 0x4f9921cc, 0x3a7e9c6a, 
	0x96a5f91d, 0xcceb79c0, 0x1dad3d2d, 0x8b74d7b8, 0x8ebbb279, 0x8ac6c5ca, 
	0xcf3fc997, 0x551c537c, 0x8eee92f1, 0x9a47cc09, 0xf9576fca, 0x81987f4e, 
	0x66ec977c, 0xa9d6ee79, 0xde689df2, 0x49e9df32, 0xa93be643, 0x2539dff8, 
	0x35e7c767, 0xb3988b6f, 0xd927cf53, 0x2727bdfb, 0xdce389cd, 0xb1ab7388, 
	0x573ab368, 0x78a20300, 0xda1bc4a6, 0xed71e169, 0xb076c94e, 0x8c879cd7, 
	0xc929f145, 0x1abd6c7e, 0x3bb8f61c, 0xf3070f48, 0x7d73bb84, 0xa1f57eca, 
	0x4f108b25, 0xfd4656da, 0xdec7cea6, 0x1a184f6f, 0x77f729f4, 0x8c5cf22d, 
	0x92531d45, 0xe7fbb1f3, 0xeff04ff1, 0x0be3b83c, 0x19edfb52, 0x3bfb5f33, 
	0xd6ec2457, 0xd35df16a, 0x063ef8a2, 0x118bdf0b, 0x085d7a54, 0xf44b8795, 
	0x2b8af9cc, 0xf783cf05, 0x3d1fb097, 0xb509fa53, 0xa6f8ca54, 0x3285fbe0, 
	0x79c3434c, 0xf34960f7, 0xcef35297, 0xc7843d9d, 0x1dbcf29d, 0x4ee125ce, 
	0xf849f84c, 0x39eb412e, 0x7a68f515, 0xd0bc0a77, 0x6be642be, 0x0a0aafc2, 
	0x961fef1f, 0xc4f894cd, 0xbe762ffa, 0xb8e57339, 0x6725b57d, 0x83c67df8, 
	0xbed57f45, 0x2d1cf25a, 0x4df48cad, 0x84d5f606, 0xf38f27bc, 0x5f32fdbd, 
	0xee9386d9, 0xc1a53827, 0xf6f2a1dd, 0xd78cbe64, 0x7318e75c, 0x7c24499f, 
	0x1a7cf108, 0x3f09c072, 0xf329deaa, 0x9c9c1b95, 0xe7f76c7f, 0x7b130b0d, 
	0xf90cc18b, 0xaed42a3b, 0xbda4e705, 0x1b1b70e1, 0xda3e3418, 0x1db1c379, 
	0xf05203b0, 0x422fc1a5, 0xc95fb37e, 0xbeaf751b, 0x870e47cc, 0x6fa4f205, 
	0xa756de03, 0xf25b2fe4, 0xfc58747c, 0x1935ef94, 0xce7b1ace, 0x1d32e1d9, 
	0x37f71a3d, 0x0ceb7e7a, 0x6786663b, 0x163dd644, 0x7a1be1e7, 0x3e96973f, 
	0xc367f1c0, 0xbdd65c7b, 0xe8fdf283, 0x919cbdef, 0x6447d3ef, 0xbce2dd3d, 
	0x3fa3233c, 0x0319eb8d, 0x5c799eb2, 0xb90733d6, 0xcb4eb234, 0x53cf167a, 
	0xa9a72fed, 0x72120679, 0xdf69da7f, 0xf7283453, 0x8512ada7, 0xf7daa0e7, 
	0xbd39fa54, 0xfdf72fcb, 0xaf5e4c0b, 0x822787ad, 0x49df78ae, 0x3e2efdf0, 
	0x12f2d9b7, 0x6375d8e4, 0x63dbd9e9, 0xc3b47bc8, 0x1d9ce254, 0x8f7d87b5, 
	0x5f3d24ef, 0x7fe548e3, 0x9cf44f6e, 0xa0691ba9, 0x33d04ce7, 0x7a2a6f7d, 
	0xe887fb66, 0x50b19dd9, 0x5dda6f20, 0xdf2268d5, 0xe817cede, 0x5cd6bcc2, 
	0xfde1a798, 0xf28392e2, 0x6efc821c, 0xaff4fbfc, 0xe617f7cb, 0xd7dfc817, 
	0xe4784d3e, 0x090363fb, 0xc9ed5dfe, 0x27b038c9, 0x91df7f75, 0xf01475db, 
	0xefef6c9d, 0x557f967f, 0xec2bfd23, 0xbc5e7ffb, 0xc8af5ec4, 0xfb075c18, 
	0xb7e71dae, 0xc4f993ba, 0xa880de76, 0xafe711ff, 0xf790691f, 0xb32d0518, 
	0x3a7ebc78, 0xf5bc917a, 0x2613b951, 0x5e452f84, 0x2e8fd4ae, 0xeb6f2f95, 
	0xe6f22749, 0xc7e939f9, 0x2f1cf917, 0x2271bb9f, 0xfbc63e7f, 0x3c072cff, 
	0x19c5cde5, 0x39b7e42e, 0x684d9cf8, 0x7e11785b, 0x2db425ff, 0x848af7c6, 
	0x73af8956, 0xe64c557d, 0xbb1adfc3, 0x9ffc9db9, 0x8f8c6350, 0xb17c39b1, 
	0x4d7b1e7b, 0xa0c64888, 0xd722f123, 0x1e91b71b, 0x7eb1ad0c, 0x4c0499b0, 
	0x337635a8, 0x247783df, 0x24dbe076, 0x892f43fb, 0xbfa0f7af, 0x563e31dd, 
	0xbe2dda17, 0xdc43bdfe, 0x658fcfee, 0x15a2bce0, 0xe71571db, 0x5cd9cfb9, 
	0x3b7c328d, 0xf86ef7f7, 0x91fe9b07, 0xbd8df7ca, 0xbcd8cf32, 0x55e08db9, 
	0x823ab59b, 0x4e4e997b, 0xb1bbeffa, 0x8d2dcebe, 0x6f5f61eb, 0x5170b4dd, 
	0x9be619fc, 0x1ebfb57c, 0xbfb77c82, 0x0f4929bb, 0xd3fca9f9, 0xabde50b9, 
	0x9db37445, 0xc9ab01f3, 0x96fec230, 0xdb05ef21, 0x45cad77a, 0xf92147d8, 
	0x81b3df91, 0xda7052f1, 0x9c17fdc5, 0x84fd7ae1, 0x09ad2e11, 0x602cdf16, 
	0xefe5fb04, 0xfec7053f, 0x1c28941e, 0x54cfbf92, 0x28a5cc38, 0x94e54b3a, 
	0x7f7d854b, 0x36f9d161, 0xe07ce3ec, 0x0b27bdc2, 0x17edfe8a, 0xf6a8fbfc, 
	0x0588967a, 0xfc6447b8, 0x77cfc7fc, 0x8c706f78, 0x5aebc05f, 0xffff5c9a, 
	0xc1777e02, 0x00000025, 0x0002fea1, 0x7ded9c78, 0xd5547c0d, 0x37b9e89d, 
	0x24c99277, 0x4cc93b84, 0x26108132, 0xaf970261, 0xc9804032, 0x804ee407, 
	0xe2b75502, 0xab5d8ab6, 0xec6dd413, 0xf568b6eb, 0xf6c7ec6d, 0x1242484e, 
	0xf9512711, 0x8a06d6a8, 0xdbe7d8af, 0xdd2b56d2, 0x891bdb6e, 0x29ad282b, 
	0xb4ba36da, 0x5a6b144d, 0x5b1b7bf3, 0xcbb4bede, 0xfffffbae, 0x773339cf, 
	0xd5608126, 0xf95f6db7, 0xdcce5cb5, 0xffc7cf73, 0x551cebfb, 0x6befe597, 
	0xccc82c67, 0xc1846b62, 0xdad8ab1f, 0x78bb4f82, 0x669f1dbc, 0xda8b84c9, 
	0xb5367625, 0x69e82703, 0xa83b0607, 0xdbc43a5d, 0xfdfcc3a5, 0x9ede51ac, 
	0x87ef0e35, 0xcf3fc056, 0x27b3efd1, 0xadb3eff8, 0x2feec652, 0x3f4ed660, 
	0xc6618563, 0xf630768a, 0xbfc1973f, 0x5b4c656e, 0x18ac8662, 0x1d7057f5, 
	0x82073b3b, 0xaecbad2a, 0x8b1972b3, 0xc6d83333, 0x5d58a9d7, 0x3e835fd0, 
	0x2d7b52af, 0xfd5fa1b6, 0xfbe87b89, 0x59fc83b5, 0x0593d36f, 0xbf52744f, 
	0xa8bb53b2, 0x4f40365d, 0xf68a77cb, 0xe59c5769, 0x15ceebef, 0xbce6bb50, 
	0x3c5fbe87, 0xe8b64f46, 0x6f7a6e85, 0xcc79a79c, 0xea6e1379, 0x36a6cf37, 
	0xefa51cab, 0x7a71caed, 0xf8178ab2, 0x7d28f173, 0xf04cd56f, 0x5c898cf1, 
	0x9070b7ea, 0x987f3eff, 0x1ce0bf7f, 0x18fe771f, 0x6785ad3d, 0x29c6bcf9, 
	0x033aacfe, 0xe00f7ddf, 0xfa9dbee5, 0xeebe6cf9, 0x58f833bc, 0xf6b61d6a, 
	0xbbbbd633, 0x6415956d, 0xf3f84dec, 0xd631cfe5, 0x3801f083, 0xbdf83ef7, 
	0xdefc3a55, 0x1557b61b, 0x85e1c9de, 0xe378d37f, 0xfa1f2fd0, 0xacf34cdd, 
	0x655c238d, 0xf6d6cddb, 0xeff7bb40, 0xf952ad77, 0x82ccf577, 0x52af61b6, 
	0x82f1cb7f, 0x4e317eed, 0xd879a56f, 0xd578c04a, 0x10e8ebe9, 0xefb9e8eb, 
	0x1e8eb4db, 0x90aab036, 0xa95ec7be, 0xeb923bef, 0xb0e2cb30, 0xd727cd5f, 
	0x40f59661, 0xa763a7bb, 0xe70cb79c, 0x5a7ce9ed, 0xe3d58bac, 0x1c71c75f, 
	0xc6dea7a0, 0x3b71d669, 0x644f4787, 0xacc3c040, 0xf7e4f1c4, 0x8bd875a9, 
	0x82651d69, 0x62f6dcce, 0x093ac75a, 0xff0eb30f, 0x6efc49ee, 0x7dbe0455, 
	0x1dbfce4a, 0x322fd7e6, 0xab3befbf, 0x9a783ef4, 0x9838094f, 0xa7eff10b, 
	0xcd6fcd26, 0x1243f9a3, 0x9a3cd60e, 0x626de3ff, 0xcd017b7e, 0x6c94fcdf, 
	0x3c7dc22f, 0x3ad1f12d, 0xfbae1c0d, 0x53070e47, 0x74aac1c2, 0x47c0ef7e, 
	0x12c5d105, 0x02b30709, 0xbe67a2e9, 0x479b075c, 0x4f3968f8, 0xe1293870, 
	0x381a6870, 0x84380be4, 0xb0f4969f, 0x3939c718, 0x216c0e09, 0xe72d5fcd, 
	0xfe690b67, 0x1e82ed75, 0x7f3405ac, 0x5ed929ec, 0x2b3f7f84, 0x34e4f0e1, 
	0xe02538eb, 0x07a49c30, 0xc9d9ef1a, 0xf8445870, 0xe5d24fa8, 0xeac7c222, 
	0xf9ff0976, 0x01c18eb4, 0xed460eb1, 0xbc75cbef, 0x2e3e116c, 0xffbba7c8, 
	0xdbd1e081, 0xaec3f927, 0xe29f7e72, 0x78415b53, 0x5c5dfef4, 0xbfc3e3ce, 
	0xbfdc997a, 0xcfdfe06d, 0x76ec77c1, 0xf0759704, 0xabf445b4, 0xfdfc80f4, 
	0x6bfefe01, 0xdc455382, 0xfb4376d9, 0x67ada380, 0xfd1903b4, 0x8def1983, 
	0xde61f78c, 0x0fde1166, 0xf3e0a216, 0x21b3eade, 0xef70e005, 0x330f8783, 
	0x4a7af768, 0x817ef52d, 0xe55f8e0f, 0x3349c900, 0xac626894, 0x250adb2f, 
	0x01cc1f40, 0x23bb927d, 0x963bf725, 0x0e415e00, 0x58fa76f7, 0x15ca1376, 
	0x0e3cf6c6, 0x0f9ab97f, 0x0deed0eb, 0x0f678f06, 0x00773873, 0xf512c79c, 
	0xf0d5d83b, 0x05c493be, 0xe8ad6f7c, 0x18cf8e3c, 0xe9f00fdb, 0x3aebb328, 
	0xfb19f007, 0xeb0003d4, 0xb2ac5f0e, 0xd67869f3, 0xb577859b, 0xe4b633e1, 
	0x63a3ac08, 0x6fbf4c43, 0x235c63b7, 0x18fd83b2, 0xa0696c06, 0xa2c2c771, 
	0x30da147d, 0x06fed8ee, 0xf7884ede, 0x4fbb4447, 0xf81b3bb4, 0x9fd12cba, 
	0xf5ea7589, 0xe3a89dbc, 0xf1d7f7fd, 0xd89d56fe, 0x5f789d47, 0x6bfbdbcb, 
	0xcf523b79, 0xfbe66ffb, 0xe621db1c, 0x47e3166b, 0x2d65bb44, 0xe5af376f, 
	0xcb5b6fdf, 0x6da29bfb, 0x68baf788, 0x34f5884f, 0x8877f18b, 0xaf588b76, 
	0x78a6da25, 0x7f98a57f, 0x44c7689b, 0x86da283b, 0x8ad6c768, 0xb0be62fe, 
	0xb10ec780, 0x7f98b71e, 0x888ff45c, 0x1fbc5076, 0xe2d9e314, 0x8f68b0fd, 
	0xd109f68a, 0xb0ed121e, 0x98b36f98, 0x4076898f, 0x7ec4fbb4, 0xfafef18e, 
	0x6347ce0a, 0x96ce029d, 0x0d4b7380, 0x7c22476f, 0xc1d33fdc, 0x241d341f, 
	0x3d1d38f1, 0xef8f19fc, 0x78931e2a, 0x7f9f0e98, 0xf145c3c6, 0x74e38490, 
	0x8713f8f8, 0xd30e1263, 0x1c0ff3c1, 0x4c7dc90e, 0x79778f07, 0x4c75c91f, 
	0xb9b79fb7, 0x19e3f40e, 0xd836abd8, 0x4bdfe850, 0xb7634ebb, 0x163f7f91, 
	0xf372eb10, 0x16bd8175, 0x4b80f8c7, 0x46bb680f, 0xe12b6c00, 0xf31dafd5, 
	0xaf3e111a, 0xe7eb336a, 0xea8de58c, 0x62c56d45, 0x9bda3f5c, 0x03f4f367, 
	0x71dcbbfc, 0x7b409f11, 0x0b7ed992, 0x7b1745ec, 0x493acca6, 0xbae1f30b, 
	0xd685540a, 0xc7e674c5, 0x6d4d8e36, 0x36d495f7, 0x99b78d4d, 0x11f7c655, 
	0x50871464, 0x778e3159, 0x5d91804d, 0x478b3d0a, 0x1de51c79, 0xe324ab89, 
	0xf67b4129, 0xe3c38d00, 0x88efaa18, 0xf3e3403f, 0x345a86f8, 0x22958674, 
	0xb6f1985f, 0xe9f2d31f, 0xb5bb49ff, 0xaeb33f6f, 0x373e1f81, 0xe52b6cc4, 
	0xe8318c8f, 0x036e357f, 0xe0a5b7fa, 0x8242cf03, 0xd0f074cf, 0xd3bb2159, 
	0x215b7ef9, 0xf092b7be, 0x5ef4c562, 0x12c7efe7, 0xdcc3ad3a, 0xa789eb08, 
	0x3e1976e0, 0x17da96bf, 0x5a0d0b3c, 0xa73a2b0f, 0xce8bbed1, 0xd2f871b7, 
	0x0e6cdcfa, 0x73995f8f, 0xae307286, 0x8b1cfcf5, 0x15cd6fe0, 0x16b9ad71, 
	0xb0f55fe0, 0xd0b4f717, 0x55dcb7ef, 0xeb78ed4a, 0xbe2ebe76, 0xd2af8e3e, 
	0x729e8767, 0xe1bc7137, 0x740b3fbe, 0x2f414fa3, 0xdcdbbd72, 0x7eaacccc, 
	0x31a3f4fb, 0xc78277d3, 0x8f387c77, 0x9fb8985a, 0x9755fac1, 0xaf10b7e5, 
	0x6dacbb2e, 0x5e1e9fd7, 0x193e4ddf, 0x91e2d2d7, 0x3f441345, 0x03d21176, 
	0x6eb8dd3c, 0xfe0856cb, 0x70fc7aa5, 0x45c51776, 0x64fd05b3, 0xac127c13, 
	0x9411e09c, 0x1da93578, 0x8d8ddf14, 0x5b5afdf2, 0x7026cc13, 0xe97df4d8, 
	0x7dc6e62c, 0x66cb3aab, 0xb4e99323, 0x8474e90f, 0xf38e50f0, 0xa474dfe4, 
	0xca71e0dc, 0x9a71739c, 0x3d3ce73f, 0x15a07b99, 0xbbb605e3, 0xfe08bd53, 
	0xff8e0923, 0x8bf7e12b, 0x5e0d9fe0, 0xdef38d99, 0xda8366e9, 0x57ebc9d9, 
	0x1adb2cdd, 0xf66c7f86, 0xf7f70cfd, 0x4a0bd0a2, 0x4be9fec0, 0xc55ecff0, 
	0x04b5e8ec, 0x070e415c, 0xf6827fb0, 0x61ba72a5, 0x031a1e5c, 0xbfbed6d4, 
	0xbecdc396, 0xffdb0b3a, 0xf4915478, 0x729c22af, 0x6b989c04, 0xe30e5e38, 
	0xe4610b7a, 0x4f1d603b, 0xc3c8531f, 0x5c56cc32, 0x5309e96f, 0x25270061, 
	0x592fe2c8, 0x15c51f34, 0x20e0f192, 0x9e3ce3b3, 0xbaaf10ca, 0xb011d625, 
	0xbb279c6d, 0x0029663a, 0xf057d7ff, 0x639a8ab8, 0xd4b28fa9, 0x5a6461ba, 
	0x7b11ae57, 0x1e818b5e, 0x4e5d7a41, 0x4e8957f8, 0x7c7167b6, 0xfd666eeb, 
	0xeacbc384, 0x76767ea0, 0xdd9efc33, 0x601bacc9, 0xd93b9b9b, 0xb458c280, 
	0x7ceff584, 0xe2c82699, 0xe1a66a71, 0xf183f23e, 0x79a3161c, 0xd10a13b5, 
	0x7848368b, 0xbc435d36, 0xd6f5c2ed, 0x90b3470f, 0xd70dffff, 0xf6bbf40b, 
	0xab2b7eff, 0xe8b4f61e, 0x238f4b2f, 0x5d89b13d, 0x47802ea1, 0x4257c674, 
	0x4ca1c00a, 0xdb9d9453, 0x9c637f05, 0x107fc608, 0xf94af7d6, 0x7fb18713, 
	0x7e492f52, 0xc21e05b7, 0xa677efc0, 0x48ec79f8, 0xd941e880, 0xb7a8e9c6, 
	0xf1e5f37b, 0xa67a6983, 0xad3d2cf8, 0x2ede31e2, 0xc54f8739, 0x7c4f392a, 
	0xc40302cb, 0x14e05687, 0x0be9593d, 0xdc3a5dbc, 0xe75f9931, 0xb7c64cad, 
	0x5802f953, 0x2fd9fae7, 0x97fb88bd, 0x375aeaf2, 0xe9a6f200, 0xb1b6cfd7, 
	0x7ec771f5, 0x7216eb9d, 0xfb7cf4a5, 0x24be7de4, 0x6dcb3ce8, 0xd7134fc5, 
	0x72957d01, 0x7ade20fc, 0xc819d142, 0x1662a117, 0x68f6bc47, 0x2cf103fd, 
	0xef46df7c, 0x42f1828b, 0x21e69865, 0x950515fc, 0xba6dbc79, 0xb0fefbf8, 
	0x78b77842, 0xe06ff59b, 0x1bbe39ef, 0xe90b3575, 0xc02ed97b, 0xd77c4333, 
	0xc5d01a68, 0xfe38cb8b, 0x9dcc8617, 0xd8992794, 0xfc5f7844, 0x8c019ea1, 
	0x7bc10da3, 0x334267b4, 0x21677458, 0xcd142be0, 0x1b428c4b, 0xd9d601e9, 
	0xd9eceb0b, 0x52839299, 0x5efce05e, 0x07f667ec, 0x1a287e11, 0x150e015b, 
	0xb0f9dbbf, 0xe455df05, 0x0330fb5d, 0xfcc2aa3a, 0x08675f0b, 0x557ba0e3, 
	0x0cdeb566, 0x1c381fef, 0x6db74462, 0x7ec2770f, 0x421b137a, 0x605eaf88, 
	0xa1fbd6bf, 0x0a7dd7df, 0xcd337a43, 0xa993b1d0, 0x8d4eb579, 0xed9760a9, 
	0x6ca42c7d, 0x0d5ff581, 0x23b2dff8, 0xafb01df5, 0xeef82df2, 0xca4307fe, 
	0xf7b428d6, 0x8fe60adb, 0x3f7625b4, 0x656f7fee, 0x7e0cc3df, 0xf39889cf, 
	0x2ef7ae91, 0x09d642b2, 0xa5877ef8, 0xd965ac80, 0xe71f3661, 0xa1f2099d, 
	0x8272e6cd, 0xe761b6f4, 0x5cbefae1, 0x01ac333c, 0xc4b5961c, 0x5e977be9, 
	0xe8463ac2, 0xf8e3157d, 0xf9fec72e, 0x310f13db, 0x0eb7fc87, 0xc7727972, 
	0xa9470e4a, 0x0f42dc07, 0xffb8dfe4, 0xa7ef3867, 0x52c41e51, 0xe8f8cce3, 
	0x7e64e3d4, 0xa5bfe33f, 0x4fb29f7f, 0x2f881bac, 0x77240347, 0xf8977ca4, 
	0x99ab2d0c, 0x76839d5b, 0x122ffecb, 0x17d6ddbc, 0x1f9f60bb, 0xe1b7f7c1, 
	0xdc0181ef, 0xe423e497, 0x96ef6103, 0x9ae91f10, 0x2be48f58, 0x3b74beb9, 
	0xdb0bf240, 0x500ef5c6, 0x530fe52c, 0x0790aef6, 0xd0897356, 0x9e7c259f, 
	0x53c7a7b7, 0x85cb9bfa, 0xb4545da4, 0xff4847ff, 0x473fb34c, 0x0589bdf9, 
	0xe3fff724, 0x502006cd, 0xd6293ec6, 0x86e41735, 0x2bfb4d52, 0xb673b74b, 
	0xc1b97195, 0xcc363bf7, 0x5a69bae5, 0xbf09c80c, 0x5c8e31b7, 0xa6373139, 
	0xa1eb4e3e, 0xf38caff1, 0xca5720fe, 0x83afa4dc, 0x6a8f3c15, 0x5afdf056, 
	0x0f286715, 0x0a7e5318, 0x192d6573, 0xa85b8f36, 0x1fa4121f, 0x3f5c2dac, 
	0x2609cc2c, 0xf580199e, 0xfbfec415, 0x8f40f93d, 0xf7fb820b, 0x37df87ac, 
	0xfa0258c5, 0xfd379dd7, 0xaac626fa, 0x7f75fa73, 0x66ab6337, 0xb855dc8e, 
	0x37bffa01, 0x0335dad6, 0x58be17de, 0xf3413452, 0x1e7c76e5, 0xf665dbbe, 
	0x7e7fff23, 0x165677e5, 0xcde301bd, 0x66e66de4, 0xf3c884fe, 0x8a3e3826, 
	0x446ebe31, 0x33627f4d, 0xb9ab2b63, 0xc7925c3e, 0x2e1f71da, 0xe104a276, 
	0x565dfbe3, 0xb081ca3b, 0x6c33f715, 0x06b9022f, 0xd7dd5974, 0xfbf847ef, 
	0x3ebf8026, 0x66d2d8c2, 0x84e518a5, 0x54b9906f, 0x1d9eff78, 0xefec62d1, 
	0x0d15321a, 0xdbbcb7e0, 0xfa4623fb, 0xb4e25e2f, 0x0282c777, 0x421d9fde, 
	0x57da0e51, 0x020a3927, 0x9276e349, 0x58029da5, 0x944f0fab, 0x9fc85d84, 
	0xf1d20966, 0xd0a64db2, 0xf48ba6ab, 0x80edc1bd, 0x13cf3570, 0xdeb9bed0, 
	0xfaec279d, 0x19adbc8c, 0x71f5c53a, 0xf4f00bd5, 0xd13a77c3, 0x86755597, 
	0x7576dee8, 0xb70b78c1, 0xf284dd74, 0x8b376ee1, 0xb859dea1, 0xee73c380, 
	0x4f8e337c, 0xe18ecf29, 0x6fbf00f7, 0xd5fcf354, 0x9f900f62, 0xd7b3e51f, 
	0x17ef8015, 0xbb91575f, 0xbbb50b7c, 0xf63366ca, 0xc23f20af, 0xcf943fd0, 
	0xaf00e372, 0x01f40790, 0x51df33c8, 0xe04ad2e6, 0x715ccf99, 0xaa17df18, 
	0x9e4055c8, 0x3661cb2d, 0xcfbe37da, 0xc6c1bbf4, 0xc1d0a161, 0xbb8c0ab3, 
	0xaad82fbb, 0x550f7c02, 0xdc69f973, 0x76e2e5d9, 0xf0895d85, 0xd1bc8bf5, 
	0x1507c85d, 0x476073f0, 0x26e9d925, 0x3762f7e7, 0xbfb043d7, 0xf130f561, 
	0xec2f7f07, 0x215d31a0, 0x08fd48fc, 0xe108777c, 0x4f909771, 0x5eb9abfb, 
	0xb473bf52, 0x5be00ab2, 0xe610b26c, 0x10f933a3, 0xe5c623dc, 0x8861d801, 
	0xf470df57, 0x21100938, 0xbb709797, 0x0307f24c, 0x80b7249a, 0x766765d9, 
	0xc415bf91, 0x29327e75, 0xee6cd867, 0x3fd2a967, 0x6fda7329, 0x0cb2cfb0, 
	0x46982b3f, 0xdedc4377, 0x1cb85a55, 0xdbbe7c93, 0xc7aceccd, 0xbce65f88, 
	0xcddf4390, 0x36fe2619, 0x6da947cb, 0xf6f38f97, 0x876c09dc, 0x48e7b9ed, 
	0xcfb3595e, 0x01e53877, 0xff000e0b, 0xc4f42abf, 0xa5fdb712, 0xd5be8087, 
	0xe583fb9b, 0x07cb9df0, 0xfc209af4, 0xfb8bbfcc, 0x2cd64da3, 0x5f4e7fe4, 
	0x12ceba63, 0x03fb3eb0, 0xc6e3f209, 0xca5b799a, 0xce8213fd, 0x8cd7bee6, 
	0xc2283e0b, 0xf5e8ad7d, 0x6bfe61b6, 0xc6d7bdc5, 0xc0f3e075, 0xfa1b7a93, 
	0xdbe381b1, 0x8293eee2, 0x578e01af, 0xcb929dfc, 0x8fa0bf60, 0x9afc32b2, 
	0x835fa72c, 0x28f11bf2, 0x6c3656e1, 0x5ffc40cd, 0x48faf681, 0xe46d7f8a, 
	0x273de85f, 0x8c719ec7, 0xd5fe0710, 0x453df908, 0x6e422728, 0x9bfc72a6, 
	0x6a6be0aa, 0x6d43ff83, 0xc4594bd0, 0xfdf03af7, 0x33df14c9, 0xf5ce5761, 
	0xdcb8bbd8, 0x4728dc51, 0xdd34cd56, 0xbebde17b, 0x96ab33a4, 0x27e3bc51, 
	0x64c52eb8, 0x9700fbfc, 0xb136cb07, 0x7c387bfc, 0x7294f647, 0x057ad2b8, 
	0x14e9335c, 0xafd4ece1, 0xae2b8441, 0x20ff622b, 0xe052f27e, 0x87e9a665, 
	0xd7d0b0b1, 0x7578f99b, 0x9770fd2f, 0x5fd57e13, 0xe06b71ad, 0x1c8dd594, 
	0xbcec0ceb, 0x8434fc30, 0xf0f4c8df, 0xd8993c0b, 0xc0467689, 0x87dd6565, 
	0x9f0096dd, 0x9ffd13e1, 0x2bf829d2, 0x54b3ff63, 0x7dcb1fe1, 0x29da4a1e, 
	0x653b4e59, 0x712f1c12, 0xef5c41bd, 0x7bd629c9, 0xb471ff7c, 0x9ca08e5b, 
	0x6d9afec0, 0x228f00be, 0xa7b7d9d4, 0xd9bcc5e4, 0xfa4f3ed7, 0x99dd633e, 
	0x36965efe, 0x65dea26c, 0x2383f806, 0xf242f929, 0x1eb274a6, 0xc4d97926, 
	0x967abce5, 0x2493924d, 0x3e48473f, 0x4c3e48c4, 0x7ca52723, 0x7d60dbbc, 
	0xfabfd0d9, 0x3355e589, 0x92aadfa0, 0xc80679e1, 0xe6e29285, 0x327b86ed, 
	0xeb09b3ff, 0xe497ae2c, 0xef90b0fc, 0x2dff28cd, 0xefde59e3, 0xfd607bc5, 
	0x7e83cf8b, 0x63d69978, 0x8fe821a9, 0x376019f5, 0xe2337dcf, 0xc6fae5ca, 
	0xdbd875e5, 0x677dc3be, 0x1ccc3fd1, 0xa38e1327, 0x1bc27f08, 0xf849d397, 
	0xf6063b0b, 0xb43fa36d, 0xdb91a72c, 0xb4478015, 0x8b2f802b, 0x3a1fc174, 
	0xb720e5c2, 0x725686af, 0xcc800539, 0x3a57874a, 0x123aacfd, 0x98be422d, 
	0xfab6e029, 0xaa2adf7b, 0x23a7a6d7, 0xf6b3dff0, 0xa98cfe22, 0x89b43df9, 
	0x93f84deb, 0x4076e71b, 0x63ec9c6e, 0xdf03db96, 0x44cc5c87, 0xe1f648fd, 
	0x9297f461, 0x58b91df5, 0x337a1267, 0x3ec0f4aa, 0xf070057f, 0x12aebe82, 
	0x113664f1, 0x9c60ba55, 0xfbc3bfd0, 0xf777c527, 0x0f4a77d3, 0x08d2b7ac, 
	0xdfc056b2, 0x01df991b, 0xff9175fd, 0x924efd0d, 0x6c7597fe, 0xf99708b9, 
	0xaedaa543, 0xafbefc26, 0xdc630d49, 0x7eb0ed86, 0x7a4dd44c, 0xbcb832aa, 
	0x307a0355, 0x9410c157, 0x18f78347, 0x50d709d7, 0xf8c8ca87, 0xc9d1add7, 
	0x9e949ef1, 0xdb933f00, 0x7817ae3d, 0x3ff4897c, 0xf90d75c8, 0xee2ade70, 
	0x7a79cf87, 0x78c1f358, 0x57696081, 0x48ea9c59, 0x295bce8a, 0x3bf120b9, 
	0x85915e1d, 0x515e072d, 0x76dc614f, 0x1e16bc5a, 0xfb8c4bfb, 0x05ce305c, 
	0x1843f22d, 0x410db7e7, 0xa3f28dd5, 0xb474c024, 0xf0de36d3, 0x3607b73e, 
	0xad5961bf, 0x347d01a6, 0x42951afa, 0xa1f65f68, 0x1714edd3, 0x62cf80cf, 
	0x3c0337d8, 0xb95da0d5, 0x70078c5d, 0x3d33712a, 0xd12bc60f, 0xb0bc8e99, 
	0xdca7c171, 0xd1b655b0, 0x5e90d468, 0xa3b52f41, 0x29fa40ef, 0x6a70fa81, 
	0xbdfb41fd, 0x0991fd04, 0xdc27a93f, 0x094d42c6, 0x7e096ed3, 0x3a2b0e6a, 
	0x937052cc, 0x55eae07a, 0x7ca55f9c, 0xf2e22d75, 0x4818e295, 0xc73d95af, 
	0xe5573e51, 0xfc057a0b, 0x5cbd7274, 0x6ef5c9d4, 0xffe72751, 0xf7e84ea2, 
	0xee3c55c1, 0xf38e7c8d, 0x291eaa84, 0x16fa3922, 0x392d40e9, 0xa0e2af76, 
	0xaff16983, 0x87e4595b, 0x768e3d0b, 0x562fd720, 0xf847ed19, 0xc54c9f5b, 
	0xd7ea2eb3, 0x6b2fd105, 0x5879d94a, 0x79d439f7, 0xee1afa11, 0xe16bf1e4, 
	0x8e285e07, 0x2ccd5a1a, 0x9cf7470e, 0xe777f704, 0x999eb824, 0x747ac3a3, 
	0xf77fcf9d, 0xad07292a, 0x00a70e72, 0x6df91efd, 0xf5ec2aae, 0xa6775c32, 
	0xb2735b9d, 0x33a47aeb, 0x8af00eb7, 0xc92ebe12, 0xe5c54dee, 0xfdeecd2f, 
	0x47797054, 0x9ecbe89c, 0xd7ec9673, 0xf773b34b, 0xc2637a08, 0xac9b75de, 
	0x6063e31c, 0x9d230d8f, 0x27373b49, 0xfb61ca47, 0x5067114d, 0xaf1db8bb, 
	0xcd3e10f6, 0x324b845c, 0x10f28c6e, 0xdbf503e9, 0x4d3ef44d, 0x766d8fbf, 
	0x7617fe73, 0x77d99555, 0xf9cefd08, 0x5f2fc0b5, 0x5cb06843, 0x9172c7a1, 
	0xb9aab2be, 0x7eed0dff, 0xb80f69cb, 0xfe6929b7, 0x305d867f, 0x79fb80b7, 
	0x788b9f67, 0xd2fe30dc, 0x80177330, 0x9f80351c, 0xcf6a6f90, 0x3eee79db, 
	0xc35b6ec6, 0x13a5bffd, 0xa7d21e0d, 0xa7d003b8, 0xc79a332e, 0x6ff97fa0, 
	0x9e50ba86, 0xb2f90834, 0x0b1e64d4, 0xd01103e3, 0xd04eb807, 0x485b3d5f, 
	0x5f627f4e, 0x4153610b, 0xef80d504, 0x7bfc9bbf, 0xecb2e7fe, 0x9bec6ffe, 
	0xf063efe0, 0x706661be, 0x3fd03ed1, 0x8eb1250d, 0xb630677b, 0x777d6236, 
	0xa3b7f52f, 0x199f8377, 0x42ee9cf5, 0x0a7b58b9, 0xf4d889ec, 0x26bb0dfd, 
	0x27822d57, 0x16f8b1c0, 0xcd6e3678, 0xe5e9bcc5, 0x1afd386b, 0x782bd195, 
	0x02d1e3bd, 0xac63e005, 0x3942ba68, 0x1f63f9c8, 0x680847f0, 0xb57ae308, 
	0x96586bbb, 0xf54fc53f, 0x6bc53e02, 0xbf913cb8, 0xaf5b951b, 0xad2fc150, 
	0xf5216ebd, 0x97334167, 0x23e607ec, 0xfa079c7c, 0xf85dbdca, 0x7fec09c9, 
	0x42ca15ed, 0x3b86d3c0, 0x148aac9b, 0xf23e025f, 0x75c03fd0, 0xc67ac367, 
	0x1fef063e, 0x6af0ba41, 0x6c63ec0a, 0x79858d51, 0xf9f04562, 0xf162a358, 
	0xc3d3497a, 0xaec79e80, 0x6bcd3682, 0xf9d0187b, 0x36d976d8, 0x9b7da8f3, 
	0x61e76fec, 0xb97eb97f, 0xde675c6e, 0xb77f410e, 0x2e583ee0, 0x1423ec73, 
	0x84a8eb16, 0xeefd5c75, 0x55f5e3ad, 0x1cdeaebc, 0x1f90f255, 0x0bfadaaa, 
	0x7fc43eb4, 0xd0c9ec9c, 0x3b3e4a75, 0x183ad8ca, 0x53640daf, 0x5862b06d, 
	0x657e801f, 0x779bf531, 0xbe20b633, 0x63abb79c, 0x1da07b95, 0xb862acb9, 
	0xe5881c10, 0xd30cedae, 0x15c6ab3b, 0x4525ab36, 0x1dd6d88f, 0x8551eaed, 
	0x683b4585, 0x5b5177e1, 0xebd233d2, 0xbda8e6ca, 0xdf452278, 0x7be19b2b, 
	0x88af7d07, 0x8e79ed45, 0xd62535fe, 0xf403dd5f, 0x5b18de1a, 0x35e81bb7, 
	0xed77b7ec, 0xc1ddf6e3, 0xfc70078e, 0xffbdfe91, 0xea62fd84, 0x91bf7c1e, 
	0xd387b13d, 0x07ad6ff3, 0xfc7b3fb0, 0xc21f311e, 0x35f295fb, 0x6b0fc8dd, 
	0x05ffc147, 0x768353b9, 0xbae3f02c, 0xf90ba8f1, 0xdeacfd73, 0x6a08fa3d, 
	0xe83ddea5, 0x35772f2f, 0x64ddb946, 0xe8cc3c51, 0x220f2935, 0x14ff99e3, 
	0x339876e1, 0xa67a89ae, 0xdf92b778, 0xa7fb4c39, 0xc7d83c78, 0x57c3f41e, 
	0xdcd7e91d, 0x8798ef24, 0x0d6ce3c7, 0x1ddac5f5, 0x9c71868a, 0x76ac9be2, 
	0x1e606794, 0xc3fcf07a, 0xa6a896ba, 0x9fbbdb41, 0x7c11b4b9, 0x67b42e9a, 
	0xe3c77f8a, 0x723620ef, 0xf676ce31, 0x0c2b8489, 0x547d5ef8, 0xc49f0929, 
	0x8ed30eb8, 0xc735ff42, 0x8c6125a2, 0x187981cb, 0x3571a718, 0x3bdb4794, 
	0x15078a15, 0xc02a605b, 0x8eee96ba, 0x32cd03e6, 0xd4cbd07d, 0x38fbf957, 
	0x87b14dd0, 0xa1191db5, 0x8f380279, 0x0058d1ff, 0xe8deb8f5, 0x2f00336d, 
	0x3903ef4b, 0xb76ef306, 0xaf315bfa, 0xa7ba7b51, 0x35e3083d, 0x71868a59, 
	0x076c232d, 0x4e30bdd8, 0xf0dda26b, 0xc4fd7632, 0x7587164c, 0x2b36c0df, 
	0xff438f6d, 0xce16ebaf, 0x0d807d77, 0x1e508567, 0xe0d7cf33, 0xb6121bfb, 
	0x3eaaf489, 0x71125c3e, 0x08c3f631, 0xbe14b6aa, 0xbe4331d0, 0x46be5852, 
	0x25b70571, 0xc53606e2, 0x537c8d0f, 0x3c466f8b, 0xfa80355e, 0xae889f53, 
	0x117ef1c0, 0xfabe71e1, 0xcb691f17, 0xb17a3807, 0x0c95ca1f, 0xa3ea5c3b, 
	0x13db9346, 0xdfe6fa99, 0x4bbc7357, 0x2f7c433d, 0x2dd80df5, 0xe9c7180d, 
	0x008f8f4d, 0x3565b3c5, 0xf1493e3c, 0xbbb2269a, 0xaf27a8bd, 0x63c00ff8, 
	0x5f7bd84c, 0xf78038a3, 0x3b53cc98, 0xa7d26afc, 0xf7db0bde, 0xb8016714, 
	0xb6161634, 0x16371d23, 0x7116eacd, 0xfa3776a0, 0xdd03c7db, 0x0f527f48, 
	0x9535fd91, 0x9d9d3f3f, 0xe5a7a9da, 0x8f142f99, 0x26d8bb20, 0x1ce29c3b, 
	0x2f1e6af6, 0xcae86df4, 0xdf08b5aa, 0x1b27f42e, 0x5cf5ca66, 0xe5f6bc5a, 
	0x5af199d5, 0xb5e300ab, 0xc5a52f60, 0x1e046b6b, 0x2bb5e332, 0xba3eb86a, 
	0xbdc786bc, 0x7b5e30eb, 0xb667c63f, 0x8fb002ba, 0x1e1533ba, 0xbdd6d78c, 
	0x78c6ede4, 0x79aba3ed, 0x2ae816bc, 0xc45ae88f, 0x4d47fd6b, 0xf3fad78a, 
	0xfad78a4d, 0xc1e1563f, 0xb406f6fa, 0x373f9077, 0xa0ab3c1c, 0xfa0f38dc, 
	0xddb2fc17, 0xf3f90566, 0xe6ef3075, 0x6dff681d, 0x9c38a3c9, 0xc666d788, 
	0x3f02961d, 0xfc651c20, 0xc0571936, 0x67cf2d78, 0xeb5e3c5c, 0xf189523b, 
	0xb2e30306, 0x342f9fc8, 0xc7bb421d, 0x6fd5fc27, 0x8de43f03, 0xed0af83b, 
	0xcc2c722d, 0xac39fcf4, 0x985afd03, 0x477983cf, 0xbccc7957, 0xedc7f09b, 
	0x84f82627, 0x9378f355, 0x8e29a1b1, 0x7b4c86f1, 0xd291ec8a, 0x9210ede9, 
	0xf8cfd0d3, 0xa772f468, 0x440a5f9e, 0xe4747e84, 0x184f1ae9, 0xc7b062ed, 
	0x0e7ca356, 0x6184a4de, 0x5d981f1d, 0xd9f8eb4b, 0x9eef2e6a, 0xdd7f862d, 
	0xe0dcf98a, 0xfe81e7c9, 0xc83fb074, 0x5d82d55e, 0x6cfb063f, 0xffee1b06, 
	0x1fd59139, 0x01f99c77, 0x99c62fd8, 0x97f6ddeb, 0xde13b2be, 0x2c1fdabf, 
	0x7f2195df, 0xf64b9454, 0xc9febc65, 0x007cef8e, 0x0fe726f5, 0x79da3784, 
	0xe804ef08, 0x72d6efb7, 0x75da4f7b, 0x4ce9414b, 0x15c4f709, 0x2a67f704, 
	0x72fe782b, 0xfc3b848d, 0x9aaee00b, 0xff8c7700, 0x7e61bc23, 0x001bc20f, 
	0x2f6ad3f1, 0xb7957f7f, 0x7207dd8b, 0x6c0dd7eb, 0x25da0b77, 0xf285008c, 
	0xdcf9e84c, 0x630f4023, 0xd09b3ba1, 0x90fb44d7, 0x4ffb9fc3, 0x7c93bed2, 
	0x972ff20d, 0xbfec70fc, 0x71f76530, 0xd6ed0509, 0x4f95bda4, 0xd26f56f6, 
	0xfb27cade, 0xded250ea, 0xafed419a, 0x19aded27, 0x9af97fd8, 0xf80b3b0a, 
	0x1c6b7de6, 0x63c01ef6, 0x4f973e29, 0x74e6beb1, 0x5a9df3fb, 0x94cafcc7, 
	0xb17c8ddd, 0xd3c1c17c, 0xb80f3c79, 0x5af00ba5, 0x3d252b15, 0x66ed18be, 
	0x2d15c7e4, 0xf0adb057, 0x432f4e8f, 0xd1da4843, 0xba5f85e7, 0x5d03c6e4, 
	0x5f9d5718, 0x9615e779, 0x906cdc63, 0xbfcf68ff, 0xbae4e46a, 0xe47f794b, 
	0xea6f091f, 0xe20ce30f, 0x7186bfef, 0xd0bac34f, 0xe5f2179e, 0xbdbff295, 
	0xe610f50b, 0x59ced01d, 0xde5e6ada, 0x7dffe303, 0x49bb972d, 0x493013b9, 
	0x559faf9f, 0xafedcdd8, 0xf253d242, 0xd8160dfd, 0x3fb47d03, 0x13088f91, 
	0x279829bf, 0x00761c50, 0xf1e2549e, 0x8b970084, 0x044f8caa, 0x201d872c, 
	0x03b034ed, 0x5c0ed04b, 0x92bef397, 0xd3e7186c, 0xa8af5cb5, 0x224a471b, 
	0x413b29ed, 0xefa4a3fa, 0xa36afe1d, 0x407db539, 0x8a534076, 0x80ed323e, 
	0x58643e4c, 0x393a522f, 0x78c3e7de, 0x388e2de0, 0x6f3f1f5f, 0xbac0b0d2, 
	0xe8f59ee6, 0x2ec8c61f, 0xcdbcecbf, 0xcf41a7f4, 0x175454e6, 0x671b87c1, 
	0x4f22e32a, 0x1ef772dc, 0xfa585f78, 0xc1d90f55, 0xd79192b6, 0xf2df1d38, 
	0x65fff5d6, 0x969d3a1f, 0x07b4c8c7, 0x0cbfbea4, 0x176d1af3, 0x72de67b6, 
	0x95a9635e, 0xf78c4df5, 0x069cba8b, 0xd858bf21, 0x38a1e82a, 0xa801d810, 
	0x763c649f, 0xff730162, 0xd02791d6, 0x36fe8d99, 0xde3123e6, 0x6e5af1f5, 
	0xe43cc807, 0xf1358fd2, 0x1fc880b8, 0xd34cbe80, 0x426f3263, 0x912fe67e, 
	0x261fc0af, 0xab91dcbe, 0x38af91c4, 0x3d8d1bfd, 0x494fc805, 0x18bf413e, 
	0x7e8553d6, 0xdfa9fdf1, 0xe7c753df, 0xbf71d777, 0xfdcd38d8, 0x0abef961, 
	0xff473afd, 0x00ab7cda, 0xd0e7d5ed, 0xfb0dbf1f, 0x4e1fc45f, 0xb960fca4, 
	0x297e49de, 0xbe5fcfca, 0x5ca97e7b, 0xbd6177ff, 0x97e4e345, 0x239fa2e6, 
	0x43f252fd, 0x557fd187, 0xd5a8ffc8, 0xdc3dcd62, 0xe6f8ed1f, 0x6f47f41e, 
	0x7f72f66d, 0x0a7b33f4, 0x6a6d1fd0, 0xfe5b7a2e, 0x5ee0ff68, 0x863107c1, 
	0xe0ff67fe, 0x66de16a2, 0x347f0a6c, 0xd9583fd8, 0x6e1fea92, 0xdf0507b7, 
	0xf90f7b5e, 0x7b9bca9f, 0xfbdfc19f, 0xb8fddd56, 0x7f8763a0, 0x5cc7fd29, 
	0xc98ae3e4, 0xebe49dfc, 0xd7af9ccd, 0x31ea58e5, 0x7febdd47, 0xd73b49d4, 
	0x3a965fe1, 0x1668cafd, 0x8eabf5da, 0x3cdcf344, 0xe3c598ee, 0xd61e6690, 
	0x11ddac79, 0x5001502f, 0x9666cdb5, 0xa4fe84da, 0xba1b22a2, 0xf42c959b, 
	0x71cddd27, 0x66cbeb15, 0xa05d0334, 0x15bf031e, 0x6f4b77e3, 0x6e78dd62, 
	0xaf1df8d6, 0xc9bb3863, 0x97fa71eb, 0x702adb86, 0xa65897fa, 0x6d59fe8f, 
	0xb6c055b3, 0x634bfca7, 0xf1405e30, 0x012ff44b, 0xcdb0b5df, 0x097f8756, 
	0x1c1ef476, 0xf001f3c7, 0xb8ce412b, 0x007903ef, 0x347ed4f3, 0x98dc27b1, 
	0x9fc92bf2, 0x033ad30c, 0xb268f754, 0xd05bfdee, 0x12ff010e, 0xbda755e3, 
	0xe11ee1dd, 0xfc2abe57, 0xf74455cc, 0xbd77ce16, 0xd825fe0e, 0x48ef86b5, 
	0xf5c83d49, 0xe5d7003d, 0x7e927fa8, 0x3b49a587, 0xb9d84bb7, 0xf1949718, 
	0x014faa7c, 0x632d2d84, 0x2efed033, 0xa2be0f34, 0x36a978f2, 0xfdb5ebc4, 
	0xec82a728, 0xd4adc938, 0xfbaf36b8, 0x84f00a5c, 0x2b9af2ef, 0x061eb15a, 
	0xd9173d7c, 0x9f8ca609, 0xfc0e4583, 0xa4c6d054, 0xb4e5999d, 0x098ec7ab, 
	0xf522daf9, 0x05ea944b, 0xcb157953, 0xfd150675, 0x5ffc9342, 0x7909972d, 
	0xc4a3aa6a, 0xa89666f6, 0xaa39229b, 0xeb7cf116, 0x1faac37b, 0x48a6ecf5, 
	0x13e31fa3, 0x7ead821b, 0xc68da3a4, 0xaba47e93, 0x8fd5410d, 0xfa71a3fe, 
	0xff5c36a5, 0xafd1a346, 0x6e245d77, 0xfd5a5fae, 0xa7513eb1, 0x4e5c8731, 
	0x52b203ab, 0x4ec1d2f0, 0x466bfece, 0x45e601f6, 0xb9efd10b, 0x4ee1e109, 
	0x0e698787, 0x0d67bee0, 0xb3e7d232, 0x0492cc73, 0x1fe991f1, 0xc3f0a572, 
	0xea00c65c, 0x9ff0a31d, 0x93be90db, 0x3b0245e7, 0x0a48bce9, 0xf02fcc6f, 
	0x0021e9c0, 0xd5df00f4, 0x897799e7, 0x138a36ba, 0xfc2a1b18, 0x17ffd38a, 
	0x827696eb, 0x9e55aa71, 0x40462f93, 0x565dfd2d, 0x70f3c5b7, 0x861748b9, 
	0xf5a2a7a8, 0x2a7ac49d, 0x2a7ac1e6, 0x6071f786, 0x74d066dc, 0x7ac4bca1, 
	0xc86f9a2d, 0x725d6172, 0x29fa6a24, 0x1d8d3c7e, 0xdee03262, 0x85575111, 
	0x55d60b76, 0x877a0935, 0x761544fd, 0x23b8eeff, 0xb8e5ac4f, 0x3fca7359, 
	0x971d74fc, 0x973fd2db, 0xd5d36175, 0x889ff971, 0x7af35494, 0xf8e779db, 
	0xcef31afd, 0x42317bf3, 0xdbc7e403, 0xd7ee41a1, 0x78c10d57, 0x47193ab1, 
	0x872cabb3, 0x1d75499f, 0xbfafc16f, 0xabd1e846, 0x9b5db8ea, 0x0a7bebf2, 
	0xeeab0eb0, 0xf96b934c, 0xdbf3f249, 0x7f7e40cb, 0x7afdc239, 0xae01dff2, 
	0xbf230f7e, 0x2acfb6be, 0x7d09f6d0, 0x3ed7e30b, 0x1d61731a, 0x7debf496, 
	0x61f7cfe8, 0xad2fac3c, 0x6057eb0e, 0xa7196c4f, 0x62eb8ebc, 0xcdcfbd7e, 
	0x5f84ef5c, 0x3d7e13ef, 0xd7e4dbf8, 0xea997b4b, 0xdbf2a6ad, 0xf141ef31, 
	0xc9579132, 0x07ffdff0, 0x6fa8c7fa, 0x9463fd84, 0xad3ba2c7, 0xa776e229, 
	0x737a96bd, 0xe3276e2a, 0xecdddb75, 0xd518f2a8, 0xaffe132d, 0x39c9b8c1, 
	0xb924171e, 0x583df18d, 0x6e23faa7, 0xea8e875f, 0xfae00f64, 0xd13edd44, 
	0x2e999fa7, 0xfb95dbac, 0xb5bc7eb9, 0x4d8fe314, 0x38b3f5ee, 0xfd13e73d, 
	0xe29ffb4a, 0x7d94b17d, 0xd4bfdd7f, 0x5f40fa96, 0x6ff250de, 0x6f3c06a5, 
	0x859f1c0c, 0xb84c0ef2, 0x0efb0641, 0x656678e5, 0x98fe31c7, 0xf9e38038, 
	0x52cd8d1f, 0xabedfe60, 0x333bfe79, 0x50ed283e, 0x02d1e5df, 0x44c5d7ca, 
	0x9df253fe, 0x9df79e9e, 0x03f1e119, 0x67f5a03d, 0xe3a1937f, 0x26e7619b, 
	0x5c8731d4, 0x545b0ece, 0xf611ffe7, 0x2375a964, 0x12c9f3ae, 0xf392e5f8, 
	0x797cbedf, 0xb924ce7e, 0x70d1cb05, 0x3ae20f9c, 0xfaf2dfc0, 0x37a07c38, 
	0x55380b9d, 0x49cfcfcb, 0x661d98b9, 0x7809cf54, 0x4bd74e28, 0x87ae7e51, 
	0xb15ffac9, 0xb21ea4cf, 0x85db478b, 0xfe1b7c3c, 0x1ecf9191, 0xaffb8bb8, 
	0x1b35dcbf, 0x2e87e5e9, 0x1ab14bc4, 0xf4fd5977, 0xd9cbf13b, 0x27216027, 
	0x6a6dbe30, 0xaef85ead, 0x3678a4d3, 0x1b5af598, 0xda18b3e0, 0xedf73718, 
	0x7a0635b7, 0x34cfdf45, 0x92c74bcd, 0x79b21250, 0x959e5c35, 0x553cf274, 
	0x7b4f6371, 0x1086ec00, 0x43ba5efc, 0x6101e9d0, 0xb8888cbf, 0xff1151f8, 
	0x4b76111e, 0xa707152c, 0xc9e6f7f8, 0x45fbca76, 0xf7f5663c, 0xa95c0f80, 
	0x71fc3838, 0x61bb3e61, 0xfde8f993, 0xf6ce511b, 0x8b5d74b5, 0xff40be75, 
	0x3cf553db, 0xc79eaa46, 0xe3c23b93, 0x1e7ace91, 0x38e22b8a, 0xc7a3e639, 
	0x8df9525b, 0x698ebb77, 0x54159ac3, 0xeb11b4c7, 0x2f00dc98, 0xd3e4c751, 
	0x7374f7ec, 0x798bd8bb, 0x44c75919, 0x2a58cf71, 0x6390d9ee, 0x3c33c5ff, 
	0x3ed5d7ce, 0xa547e1db, 0x8fdc8af2, 0x1be3c45a, 0xcc947e99, 0xf0cfce2f, 
	0x70d78ea3, 0xf85ebfb9, 0xd47e9973, 0x4043f47c, 0x78c7cd5e, 0xcab5ca08, 
	0xaa6fc95b, 0x6d22aebd, 0x3e5aec9c, 0x3ac27c8e, 0xbe325be7, 0xac21fe83, 
	0x4bb8c18b, 0x78a3cfc1, 0xe0173314, 0x1c2207fb, 0xbfc773ae, 0x0fe100b7, 
	0x155b826d, 0x4f68b7d8, 0x47cf7f03, 0x69b205f9, 0x5fd5f93e, 0x399e7692, 
	0xce2fe09f, 0x0d3d2cb1, 0x79a42ee3, 0xdff29c69, 0x3f235e04, 0x00b9a662, 
	0xbc2d4ee9, 0x8f3a35f2, 0x20b02a71, 0x95e7fd02, 0x52b2fc1d, 0x0139117a, 
	0x5df13146, 0x5433e38c, 0xe90bb5b9, 0x19fb10d8, 0xe1fe0f9b, 0x3cbfe241, 
	0xf35abfa4, 0xd8353387, 0xe44d12df, 0x94a35c43, 0xaf8cceb7, 0x07e422dd, 
	0xac708f7d, 0x731356fc, 0x95559ff8, 0x421fa4a5, 0xfc6ede95, 0xcfc071fe, 
	0xb64f8d5f, 0x67610d03, 0xd526dd60, 0xd6a6e8a1, 0x9a00e3c9, 0xf6a143a8, 
	0x7af112ff, 0x9c467b17, 0x2225602b, 0x9f56905e, 0xaa8f599a, 0xc792ecba, 
	0x3f92a7da, 0x9d486ba6, 0x45f98fec, 0x23ac95fd, 0x484bacc8, 0xf8476bfa, 
	0xc7296379, 0x8ccbdca4, 0x513e18eb, 0x5d6615f7, 0x396fdc5d, 0xd6187a89, 
	0xeb8ba5b1, 0x4e782d83, 0x3fb10de3, 0x86df4f8a, 0x4b8f2e76, 0x4de3858f, 
	0x65cc7ec2, 0xe77c14f1, 0xe71e2dbb, 0x31dc030c, 0xf5e417ae, 0x03ae2a5f, 
	0xf11425f8, 0x6311b8f2, 0x9d5d6b7f, 0x77b49f7a, 0xdec87bdd, 0x9f99a25d, 
	0x75bb7c17, 0x478083f7, 0x8cde1b8c, 0x44f826f4, 0xcb830dc6, 0x43f0dc79, 
	0x7370de3c, 0x961b8c8d, 0xe4817d52, 0x1e22d08f, 0x39be443f, 0x0fc69b97, 
	0xf4991fc4, 0x34286d9f, 0x1f4bf11f, 0xe53719c6, 0xbf0447ba, 0x1fcc9c9c, 
	0x14c2fe34, 0x9c7e49ff, 0xc8425f8e, 0x7d2ed087, 0x8a6bd8ee, 0x6542cf83, 
	0xe4d417cb, 0x48ff3a5e, 0x68be217e, 0x2651f14a, 0x478a4cff, 0x84c93e0b, 
	0x123bccb7, 0x4f4d775d, 0x3cdf54cf, 0x49d526c2, 0xed23543f, 0x2d2f5e67, 
	0xb54be6ed, 0x1e0db21f, 0x47e64fa7, 0xdebc79f2, 0xf1b0e92b, 0x8fa5f102, 
	0x97c6d7fe, 0x52f88be6, 0x08f71ca6, 0xfff9edf9, 0xba4b8e4c, 0x111c3a24, 
	0xe97bd974, 0x295638f4, 0x5a562cf3, 0x85fe631e, 0x22952cf2, 0x1de2b2cf, 
	0xe32cb3ce, 0x6b3b9679, 0x0ff27e79, 0xf4d2cf27, 0x2fdb8790, 0xc39d6b5f, 
	0x5f339ef5, 0x14aefa42, 0x7fb5dff5, 0xd70e21f3, 0xd3ae113b, 0x40b3abd5, 
	0xf23ef94c, 0x0179c645, 0xfb5fbf59, 0x2ea35bf1, 0xfa1c726b, 0xd47be03a, 
	0x4b0eb217, 0x1fc629fa, 0x4c629fa8, 0x98b8a7e3, 0xb4f186d9, 0x6f6f9087, 
	0xf9a5f823, 0xc03b8b27, 0xfb3907df, 0x284b3741, 0x43d61a21, 0x3e228475, 
	0x0adbbf03, 0xc357bdd8, 0x47e0ad5c, 0x30566d5f, 0xc93d973a, 0xc972b16f, 
	0xdfc6996f, 0xf98fce99, 0x189794b8, 0xa8c9199f, 0x05d87103, 0xba430798, 
	0x9e98da58, 0xf23236cf, 0xaea16aaa, 0x83ee1186, 0xb0c2569f, 0x6a7373ae, 
	0xb563de68, 0xff0aaf32, 0x5b3e48ba, 0x03ecf917, 0x77fa3bf8, 0xaffe3311, 
	0x3e47bfad, 0x34b5db7d, 0x0bfc07ff, 0xd44f3e88, 0xb3eef8f2, 0x37aff0c5, 
	0x9e7f3c2e, 0x3c0a7f98, 0x5c9e04b9, 0xcfc22788, 0x8f5f024d, 0x4c878f4d, 
	0x246a79fc, 0xffba2ddc, 0x20beeae3, 0x78161ecb, 0xfdb17038, 0xbd8f205e, 
	0x63ca2aff, 0x0e0dfedf, 0xf7245fef, 0xafda0bfb, 0xfdcb63cc, 0xbe767cca, 
	0xbfff67c8, 0x5eb0bbf2, 0xe94afd03, 0xffc2197f, 0x6bbf0e9a, 0x784f128d, 
	0x256fd8bb, 0x844dfff2, 0xbcbeabdf, 0x53bfdf90, 0xfe0be927, 0x19da2b75, 
	0x40b7ef53, 0xc96c77e0, 0x4fef649d, 0xdcaa27a7, 0xd813d726, 0x417791ff, 
	0x3d002c4f, 0xafabfb01, 0x13d343fb, 0x3d09cf15, 0x17e762f1, 0x74f57652, 
	0xebca78f9, 0x1bdc39e1, 0x7c7ca5af, 0xf8f934d5, 0x2ebc44e7, 0x8f916f09, 
	0x23f086ff, 0x5ead1fa4, 0xf802f605, 0x67585522, 0xb3ace131, 0xac8fffb0, 
	0xa6b3ee27, 0xae385396, 0x2e3103ac, 0xb7c22f24, 0xa9ecff11, 0xfe70435b, 
	0x3fc93a8b, 0xf08baff0, 0x3fc94ccf, 0x8c93dcf2, 0x4f738817, 0x3fd6390d, 
	0x53417888, 0x271483fb, 0x24e33971, 0xea9ee799, 0xee7d4cce, 0x3f9c7329, 
	0xbd9f7af6, 0xbd600e42, 0x54d6a1cf, 0x175fcfbd, 0x57f8867e, 0x3c3effee, 
	0x67fe84df, 0xdea9b6c0, 0x8856e014, 0x6ccc29f2, 0xbb3397ca, 0x3a32eb1f, 
	0x939fdc22, 0x3cf28175, 0xfc888b14, 0xebf5c187, 0xf4b0bae4, 0x436379fa, 
	0x6c764593, 0xf817dd46, 0x2c6ab901, 0x0005c715, 0x03c51e52, 0xaf38a468, 
	0x6d2c2fc8, 0x4e4039ec, 0x8e1e4642, 0xa94d15f2, 0x5e665bfc, 0x2985c64e, 
	0x7da3172f, 0xe5e497fd, 0x4b561bae, 0x2109dee9, 0xe6fc3fbf, 0x00cb4aa7, 
	0x9df5db8f, 0x7f193eb4, 0x7fa731be, 0xda717dd6, 0x76f305d7, 0xd80c3cfc, 
	0xff085b5d, 0x3f181159, 0x159b0d74, 0xbb7916ca, 0xdbb79111, 0x4d76f222, 
	0x52776f22, 0x4446ede4, 0x49c78ebe, 0xe3ca3c68, 0xf9827fd9, 0xfe87a1bb, 
	0xd377f228, 0xd79493d9, 0xddbc898b, 0x87df0bc9, 0x5180f320, 0x9c8fe14f, 
	0xfe54b9f1, 0x16e8aace, 0x2faee7fa, 0x50dfce4c, 0xc9a6fc3e, 0xabcc1af9, 
	0xe3189e53, 0xa677c807, 0x29ed0fb5, 0x7f74d6a3, 0xb733fb9e, 0xc102feee, 
	0xa4f443c3, 0x3e30f346, 0xb54db86f, 0x3f67da15, 0xe40ca8a1, 0xbccd8cd3, 
	0xafd0000e, 0xeb1e5c62, 0x20feb000, 0x22a99b7f, 0x9b37b911, 0x11e5c62a, 
	0x2b9f9824, 0x7971e7ae, 0x63f00faa, 0x7ca7415c, 0xbefc097e, 0x5758877c, 
	0x4f2e2a69, 0x516104f5, 0x8a923037, 0x01facbcb, 0x7ac78f19, 0x593be405, 
	0xc85b3e8f, 0x689f35cd, 0x2dbd4129, 0x3e2207eb, 0x45f71153, 0x8c978468, 
	0x227ea0b8, 0xe2cb0ea3, 0x87c0bff1, 0xf0957cb9, 0xd73d40ff, 0x78c4f8df, 
	0xa4e714de, 0x2afdf90b, 0xf58cbf5c, 0xf8cbfc71, 0x0af1fc0e, 0x7a422fbe, 
	0x2ff5e792, 0x167aa80b, 0x3c5bd9d2, 0x4eb93faf, 0xf9d2f4db, 0x4fd259ff, 
	0xdb678561, 0xce42bbe8, 0x7d1ebc7f, 0xb5ea05f6, 0x7f1cf52e, 0xcebc33e9, 
	0x5e59f4a0, 0xcc98a067, 0x71cc7247, 0xf038ddbf, 0x92f107f5, 0x0de3b423, 
	0x31cd04b3, 0x25cbce75, 0x9227ae3a, 0x4de977bc, 0x99f29f1c, 0x1fa65f38, 
	0xae94f22d, 0x798998e2, 0xb8eb134a, 0xaf514c0e, 0x9dedf885, 0x816eaf8c, 
	0xe30beeaf, 0x75c780ab, 0x19af882e, 0xe3a4bf5c, 0xf2bf6eab, 0xe32be1fb, 
	0x37b401fe, 0x7c0eff71, 0x49dd9c15, 0xefe015df, 0x5c19af80, 0x7bbdbe5e, 
	0x5f152e17, 0xebe26577, 0xfa25230b, 0x5f1fdfce, 0xbe3ce32c, 0xda0fdef3, 
	0x41e26147, 0x19cfcf71, 0xe7e97236, 0x7977e13d, 0xafec943e, 0x09ff38a0, 
	0x3cfdc42f, 0xb1758576, 0x9e25db78, 0xb81764ff, 0xaed32877, 0x1b2ce80c, 
	0xa3651ce3, 0x156a6373, 0xbf0e706d, 0x19da4977, 0x4eb9ecef, 0x5a0da769, 
	0x314bde4c, 0xb40f09c7, 0x7b70cf3f, 0xf79f9cb2, 0x78c7cab4, 0xde39ee7b, 
	0x9e1e7b9e, 0xb1f719d9, 0xb2e1f125, 0x49fd44ca, 0x9069ef10, 0xc3f52a71, 
	0x6843c1c3, 0x37dc65bf, 0x2340ed21, 0x9d21f39f, 0x74e26c77, 0xc310f983, 
	0x77e9466f, 0x7ea20350, 0x53dc48ad, 0x2d9bdbc4, 0x96b55f6a, 0x3e0373c7, 
	0x07dd61a6, 0x7a8ddb5e, 0xbfc198c3, 0x4cfeafbf, 0x647bde3d, 0x91b6f3b4, 
	0x7d6754cf, 0xbef8b348, 0x8f3cad68, 0x509ee8cb, 0x666506f7, 0xc02e1cf2, 
	0xd79376e9, 0xf437b873, 0xc13d6017, 0x803de527, 0xb7fea6cc, 0xf84d7d9b, 
	0xbdd9e25e, 0xbf033e21, 0xce6fdf87, 0x3e70161a, 0xde2ce1ca, 0x107af3e7, 
	0x9ef38e73, 0xf9ffb44c, 0x08af7d7c, 0xaf9ca13b, 0xee205e27, 0xed8b9c07, 
	0x8c7df03b, 0x8fbf85e3, 0xc6f1c4ce, 0xc2aa831a, 0x71734de3, 0x94dbc5bc, 
	0x3b93e472, 0x25d879c4, 0xfa8b9b26, 0xf621f610, 0x30674e97, 0xdeb86bef, 
	0x30f1998f, 0x32d7b9e5, 0xde1afe35, 0xa72f14e7, 0x2ede9afb, 0xd9cd861d, 
	0xf8877f62, 0x67f6a6fe, 0xa49c2fd4, 0x1f0c717b, 0x7574d7c7, 0x8ad673bb, 
	0x38b6607c, 0xa7ee2287, 0x148e4298, 0x7cfdd20c, 0xe5268e5c, 0x01a390b2, 
	0x3ef48f9c, 0xff5853c8, 0x0a4607ca, 0x7a499e50, 0x99737494, 0x82fdef98, 
	0x47bba67e, 0xde792ea6, 0x43cbdf99, 0x1c46b6e7, 0x9dd33975, 0x03d0caaf, 
	0x7a1de724, 0xf7931dfb, 0x322cbeae, 0x0f5ef0e7, 0xde6dcefc, 0x0a72768b, 
	0x67cb53ae, 0xeff9c423, 0x5db76125, 0x02100f5f, 0x0de573bf, 0xafd06fb0, 
	0x7f46a781, 0x9478c5e0, 0x1eefbd9f, 0xac39dd47, 0x8dbc68a7, 0x31ef05c3, 
	0xc1e0f958, 0x0deb8522, 0xf7889f5e, 0x6f649c04, 0x59017ef9, 0x67b8ee47, 
	0xe91eea82, 0xd4a6811e, 0xd4ef02bd, 0x6f0454bd, 0x8cb0cbd4, 0x3ec05f8e, 
	0xd7971eb1, 0xe1a51691, 0x4b7b10f7, 0xef24e7f7, 0x6dd64889, 0x22fb4f3e, 
	0x4ebe21bc, 0x06f03f71, 0xec1d0ebc, 0xb657b2d8, 0x55754f3d, 0xf9116643, 
	0x116683e7, 0x06ea89f2, 0xe34fda39, 0x032b3c92, 0xf401d58d, 0x74186658, 
	0x6794892f, 0x0464bd49, 0x9b20b55b, 0xfd4aaf56, 0x8cf78651, 0x57fba51c, 
	0x939d12ca, 0xcc0babf5, 0x97dd07f4, 0xbd655fae, 0x89ddda3e, 0x377653ab, 
	0x16e301c2, 0x9c618fe8, 0x6e5250e2, 0xdca37af3, 0x9f5f3c13, 0xe99d4759, 
	0x1bd66567, 0x995dfa65, 0x73d69d7a, 0xee9f9f33, 0x952dd18d, 0x96dce8ea, 
	0x405f3c9a, 0x067dc5ef, 0x7bd0ffe0, 0xcb2fdff1, 0xd15cb3a4, 0xc839b5df, 
	0x01ce11b2, 0x1a33fa26, 0x6d89e24f, 0x5ca2b60e, 0xb1fe8177, 0x7a92781c, 
	0x389dfc06, 0x6cbbc7f1, 0xc33c482f, 0xd2143b7a, 0x63d72a63, 0xb9704768, 
	0x0b87ec22, 0x1f50afc4, 0x043c1da1, 0xa5e4e8fa, 0x20b111d8, 0x25dcefca, 
	0xc5868720, 0xd70811fd, 0x1111d80b, 0x4f5023b4, 0x7046b618, 0xd61ad88c, 
	0x9d840451, 0xd3ff595f, 0x8f2045b5, 0x8d98b36a, 0x7fd9e5fe, 0x807a3c31, 
	0x0090dbdf, 0x0d87f2bf, 0x30833ee2, 0xe0afc3d0, 0x06dee939, 0xe90ac3c5, 
	0x82cba4dc, 0x6e277cef, 0x1857d451, 0x74d879ab, 0xfbce9db1, 0x9e1abc11, 
	0xf1c9739b, 0x8eb29916, 0x4c7545c9, 0x0f3a31bd, 0x2ea7e322, 0x9c54bf51, 
	0xc0d4bf59, 0x86eacaf5, 0x1611fb8c, 0x4c75495d, 0x1dcf22c5, 0x1e58c75c, 
	0x9f2bbdf0, 0x2c61abdf, 0xfe7696da, 0xc54d0583, 0xc64f7f99, 0x691cf16d, 
	0x247bf442, 0xc977af95, 0xc8a2fcfc, 0x4f9f92bb, 0xcbec375b, 0xd013aa95, 
	0x75f2bd38, 0xe3ce86ea, 0x7791adf2, 0xb9069ee5, 0x44eb998e, 0x7137e19c, 
	0x5d23ed0d, 0x1e29439c, 0xbe20ce88, 0x0023f713, 0x006d3c1a, 0xf86362af, 
	0xe806ef75, 0xeefb1657, 0xfa01ef37, 0x1d791f6a, 0xd5e8a3cf, 0x667b63b1, 
	0xffbc3d02, 0xad17af97, 0x99479c77, 0xc72cd850, 0x3b6c11f9, 0x8f5493cf, 
	0x51479e67, 0x38e7da5e, 0xd372b25f, 0xd70bebc8, 0xe189b3e3, 0xdfb0e7f1, 
	0x626df766, 0x6b3ec56c, 0x6a5ed2e6, 0x22e7e1ef, 0xe6ba5bed, 0x379039d2, 
	0x13f9e1f7, 0x376170ff, 0xf9f6afac, 0xd6cea96b, 0x44c4fdc0, 0x74cdd57d, 
	0x060e41bf, 0x632f6a5b, 0xc08f89dd, 0x1c9426fe, 0x16632fe4, 0xcfc463b4, 
	0xed6b4f74, 0x3aedadfa, 0x47aa6db5, 0x3025f791, 0xe80eae71, 0xc07fdc5b, 
	0x4ef8a3cf, 0x1bd4d42c, 0xfb007fa9, 0x871779d3, 0x03477dbd, 0x89f1aff7, 
	0x3ee393f6, 0x5b9f8d04, 0xdcfc6b89, 0xfdc4d30a, 0xf9da1a39, 0x354476eb, 
	0xb5e2b73c, 0xa3718698, 0x83c51686, 0x612308e1, 0x3b8c34bb, 0x9e0e5825, 
	0x332dd15b, 0xce2bf687, 0xce9318ad, 0x9cd56cad, 0xc0bc56e7, 0x2b73ce07, 
	0x3cf0362f, 0x8f316185, 0x178adcf3, 0xe2847ff9, 0x81ef74dc, 0xbb4f4471, 
	0x61ebc117, 0x422f78dd, 0x6e7e59d9, 0xbbd568c5, 0xdc45978d, 0x18ebde09, 
	0xeaa58a9f, 0x98fbf541, 0xffb87686, 0x10777a2b, 0xb88ba1d6, 0xdbd1b793, 
	0x8e4cf46d, 0xbd1bf9cf, 0x1822f769, 0x28fb3d8d, 0x3af06c7e, 0xa1df796b, 
	0x378ea7ac, 0x445dfcf0, 0x2c7140db, 0x613e6985, 0x6f5c2877, 0x9e0b3f71, 
	0x817dff69, 0xc3ef512b, 0x20f522ba, 0xfe423e4f, 0xc2071692, 0xe9346c8b, 
	0x19c912dc, 0xa3fb5de8, 0xde0f3e2d, 0xf316dabf, 0x35d57de1, 0x02f8becf, 
	0x73e685c2, 0xe4213be0, 0x9df02e97, 0xef3367a9, 0x4a78c059, 0x245ce3a7, 
	0xf38e13b6, 0x5fe724ca, 0x82bb7a16, 0xbd4a6ee8, 0xed7888ae, 0xfdd2ebb3, 
	0xd320633a, 0x4568abaf, 0x2e0637be, 0x6c1dd7e4, 0xdf52f7c2, 0xafd2031a, 
	0x5673783b, 0x075fb26c, 0xebf1a7ef, 0x7288f992, 0xbf4c9ebe, 0xfbf0a0ee, 
	0x7c075fb8, 0x0abafc2b, 0x63afd38f, 0xbe1efa19, 0x63ea7f23, 0x58575036, 
	0x8f5a59e8, 0xa6def3f0, 0x7e8f503d, 0xffad30e3, 0xdaf7dc35, 0x63f95635, 
	0xa9f6fefc, 0xcf39b7fd, 0xe289fe50, 0xaf0f40a8, 0x58f9e3af, 0x520e778c, 
	0x77df911c, 0xeb98e321, 0xfe447f85, 0x77abc70c, 0x8505fb98, 0xd67fd0a3, 
	0xcb798fcf, 0xdf713be8, 0x8bb7b099, 0x8f16b67c, 0xb365f7c2, 0x18da4bbc, 
	0x274a57f7, 0xf76f6fdb, 0x2bdf8b3e, 0xb29a566e, 0xe19e5037, 0xac6f147d, 
	0x19bdffe3, 0xc242a7e2, 0x1075468b, 0xbda1a66e, 0x9db9fd4e, 0x6dedc6d9, 
	0x11712db3, 0xed2bd23b, 0x1da4cec8, 0x3c79e1e9, 0x27fb41e6, 0x7274cfe9, 
	0x1afc923b, 0xee8063f4, 0x1d931f29, 0xe7bfa28b, 0x159d81f5, 0x143a71a3, 
	0xc1e8a718, 0x4ede5a58, 0x110139fa, 0xe03d41af, 0x63403cc6, 0x904ef2f4, 
	0x52eb75ff, 0x473eca76, 0x1fd80b1d, 0xde4203d1, 0xc7f5c01c, 0xf801f8ec, 
	0x39f9334e, 0x05aecf9b, 0x53ab70c9, 0xe329b00e, 0xa7bed2ed, 0xe4c8fbb8, 
	0x11d8fbb8, 0xc83d5a77, 0x433e7b24, 0x1b964cae, 0x1fcd3f96, 0x983b90c8, 
	0xf9e619cf, 0x977fe4a7, 0xa263d704, 0x8afb06f5, 0xb9c51bba, 0x81de792a, 
	0xc912fbdf, 0xbdeffe0f, 0xb01f214f, 0xca7d74cf, 0xa9319751, 0x1a9d47ee, 
	0x5e00db5e, 0xe1173fd0, 0x05e103b5, 0xac0dfd92, 0x7511689f, 0xe26ed279, 
	0x467a0cf5, 0xc60b85bd, 0x2d16f5e1, 0xd84f2ebc, 0xdf829c53, 0x7d8b7a81, 
	0xd8b7aa41, 0xb9edc0d3, 0xc2bf0162, 0xc645bd64, 0x76e912fa, 0x8eb53bdd, 
	0xf4b145e2, 0x7d658b7a, 0xbb71e4af, 0x17f74b68, 0x8e21dea9, 0x7eb84af7, 
	0xbc6eb9fd, 0xe301b40f, 0x7c6a6c0f, 0x7037d7a4, 0xd81bfe3a, 0x5fd84adf, 
	0xa719be56, 0xc7695f65, 0x67c6dcf1, 0xfd1336d7, 0xd1af185e, 0xc4701f17, 
	0xe3e39c3b, 0x90946fd3, 0x1375819d, 0x1f5895d9, 0x1dd19601, 0x924fb708, 
	0x93fadedd, 0xb29f44b9, 0xe0bb24ff, 0xb9da7a2b, 0xe827b42b, 0x0bb0935c, 
	0x7cf38dd6, 0xcef5e517, 0x75e9f632, 0xc355fcfc, 0xde746357, 0x24afde4a, 
	0xcfd77bf3, 0xe62976fc, 0x5b98e793, 0x514f5073, 0xe30bbafe, 0x0da72c05, 
	0x6d1e1fda, 0x85fd7ca4, 0xf8e151ce, 0x63f08718, 0x9de61ede, 0x8966ca33, 
	0xe307a1b8, 0xcd1f6049, 0x39c9f8c2, 0x3d60578c, 0x6963d7ca, 0xb7ae8a75, 
	0x2578a758, 0xd9e229d6, 0x4eb9779a, 0xa75195d1, 0x7ccea578, 0xadc53ace, 
	0x3ce7d33e, 0x81ae754f, 0xef67c79f, 0xb7aa79d0, 0xca65376a, 0x5ee32537, 
	0x9be429aa, 0x7fb15790, 0xe511bbde, 0x7b6ddf55, 0xde4b6ed0, 0xbeedc21b, 
	0xc24a7549, 0x4bae0cdf, 0x86d21bde, 0xa8b8507c, 0x1f270ae5, 0xd44c1b64, 
	0xb0526d29, 0x3bfb094e, 0xfea10def, 0x35b8108f, 0x625dd7ca, 0xdf9235be, 
	0x6bd7c437, 0x27d77ade, 0x9ce9fe88, 0x1e2aa198, 0xe78c4e7e, 0x8a6ecfa5, 
	0x067610bb, 0xfb03139e, 0x2904ef5a, 0xf8929db2, 0x61829b5a, 0x7e8d9603, 
	0xa4c24945, 0x6e786273, 0xf0d1f30c, 0x8f47ca3f, 0xf47bf036, 0xc7df367c, 
	0x78f7d818, 0xf097ec4e, 0xe0b8e97b, 0x1fe152bb, 0xd2f2a48c, 0x3f27eed2, 
	0x83fc2c21, 0x4fff6111, 0x36ec4e71, 0x9cf23fc1, 0x260bf498, 0x7b8a4fd7, 
	0x9efc0383, 0x3f5bb7c8, 0x34f69ff9, 0x0000257f, 0x00037fd1, 0x7dcd9c78, 
	0xd594780b, 0xbef9f099, 0x333266f9, 0x1924c099, 0x4c021260, 0x880610c2, 
	0x546a2d12, 0x1084be5a, 0xaa5e3dc2, 0x077775ae, 0xbb5b100c, 0xf9f6b47f, 
	0xcf5d9bb1, 0x0098424c, 0x894104ca, 0xb45136b6, 0xf1fddd68, 0x76b62db2, 
	0x835881fb, 0xcb694fb2, 0xdfeb6976, 0xda968846, 0x696c6fec, 0xff5d2d1b, 
	0xb9be72f7, 0xfb52e125, 0x1e79bb3c, 0x9df39c3d, 0xdbde7beb, 0x9cf7df79, 
	0x10917179, 0x4ff81ee2, 0xad72c9c8, 0x42453710, 0x798035c2, 0x11ecb26b, 
	0x1ec98de2, 0xb2117c53, 0xe26a3735, 0xfa7e215e, 0xbb2174ee, 0x62f0bbf0, 
	0xafc8bd7d, 0x6f58658b, 0x277e2982, 0x39e6f544, 0x1096f15e, 0x76e16aee, 
	0xfb5a849d, 0x81f1349b, 0x9aef2b10, 0x8847a426, 0x27875529, 0xe885a7e8, 
	0x66c0f6f8, 0x75c42851, 0x9f42fc07, 0x36e6c424, 0xfd41f5a1, 0x7b66438e, 
	0xbda214af, 0xc3398856, 0xb7301842, 0xfc42ddf6, 0xbf2214d8, 0xf5358715, 
	0x63cbcc18, 0xc87af940, 0xce2f4dfa, 0xbd212de7, 0xeefc7143, 0x273ce2f6, 
	0xbc69bfc0, 0x6ee3f96f, 0xcbefa798, 0x35d70fba, 0x9f71fa07, 0x1a3bf281, 
	0x3a85ceb7, 0xba431b83, 0xcfe30a3f, 0x7175f37b, 0xe08f8844, 0xea3ef3af, 
	0x7e612e25, 0x2eba9dee, 0x9d7ea08a, 0xf21f85d0, 0x1e2e90d1, 0xbe14b486, 
	0xfa1481ef, 0x5a1172c7, 0xd1e1007c, 0x6232dd34, 0x0e288487, 0x84162d08, 
	0xdbadeff9, 0xbf724b14, 0x22bf41af, 0x0f8c375f, 0x301a7528, 0xdd26ff4f, 
	0xc0fc61d0, 0x31135d26, 0x3c026fa8, 0xc2855d60, 0x95043a34, 0x5fa1ab3b, 
	0x78b1dd77, 0xafd687b5, 0xadf0873d, 0x00823a4b, 0xa700a9f7, 0x3c34e1ea, 
	0x0775f29c, 0x3fa27bae, 0x7a816c68, 0xba264613, 0xcd015cb6, 0x8e3f0b36, 
	0x69497b07, 0xfb838283, 0x458a874b, 0x6a66c114, 0xd7ec2eb1, 0xbe0021df, 
	0xea5fb8ee, 0x1d7e09bb, 0x151812ee, 0xf84429c6, 0x84988bf7, 0x8fc4a77e, 
	0xe650166d, 0xabd6b95c, 0xb98d5c01, 0xaf6778a1, 0x6aa14310, 0xf50cdfa1, 
	0x61fc0136, 0xe33bfd1f, 0x3affec01, 0xf5c014d9, 0x8c85d14d, 0xddf356ef, 
	0x1277869d, 0xff43f2fa, 0xeb0a62d7, 0x0b726a19, 0xfdfcfd89, 0xf4e16109, 
	0x762d0cdb, 0x87d4f092, 0xfb9803eb, 0xc9859f70, 0xad442cfb, 0x660cf10f, 
	0x64a1f942, 0x10ffc850, 0xef846b42, 0x30655a58, 0x87cb08be, 0x03dc62f8, 
	0xf1e949f9, 0x375c609b, 0xb8471f8c, 0xc63e330c, 0x4ff1a676, 0x7c990ab4, 
	0x4b5ef08b, 0x107da32e, 0x1a700ffe, 0x0bc3d106, 0xfe87b726, 0x4e3e112b, 
	0x10a3731c, 0xe108d68f, 0xb795bce2, 0xcdbb1a00, 0x7e90c783, 0x9c0be646, 
	0xb47d7fef, 0xf9020008, 0xd6c65316, 0xd6a4bd52, 0xf281682c, 0x2f6ed576, 
	0x32a2a364, 0xafd0bd73, 0xeeb802e5, 0xbc420372, 0xbb62fd08, 0x86efa841, 
	0xdf6c45f4, 0xd104eb38, 0xe70b35a9, 0x52b33523, 0x795dbcc2, 0x43f795bd, 
	0x81cade69, 0x300057da, 0x90a4ae43, 0x2edd0b7f, 0xd0ed8a4b, 0x46bf74c9, 
	0x4deb88f4, 0xd426f5a8, 0xeb19dd7a, 0x27dab1fd, 0xbd69ce9b, 0x891e2157, 
	0x9aad7259, 0x55e13377, 0xe8fd062c, 0x63659708, 0x4455b3ac, 0xf5195be4, 
	0xb89d6007, 0xcce9b08f, 0xc3ce4c67, 0x739f690a, 0x1a04e6e0, 0x7bbac173, 
	0x0b5d0680, 0x1fdc9d68, 0x7f424f80, 0x12bb847b, 0xe00428e1, 0xdffc3b43, 
	0x60faa22d, 0xd5436e1a, 0x7962278c, 0xf4b42452, 0xe13c117e, 0x21a00f7b, 
	0x91c613ce, 0xe1a3058e, 0x9596aaea, 0x618437c8, 0xa95bfd99, 0x528c723c, 
	0x2f09ce73, 0xa248e7e5, 0xac69ff57, 0xbaeaf9e7, 0xafbe0316, 0x41de868b, 
	0xeb1a8bf8, 0xbd192ca0, 0x057f080f, 0x0ca3c247, 0xab82cabc, 0xb80cdf3d, 
	0xbf695c13, 0x1101f733, 0xfef4dee7, 0x0a7f8b8d, 0x53af049e, 0xe0638e0a, 
	0x8d6e0a5f, 0xf8b9e74c, 0x76ff03d8, 0x11c34fac, 0x8fe69037, 0x073e6c70, 
	0xcc079b1c, 0x86e5c173, 0x3b60e22d, 0xa2e101f1, 0xeba66875, 0x71fa8c74, 
	0xfca77ae1, 0x1ce1e646, 0xbc7a2b27, 0xc5a1d3a1, 0x33237f80, 0x66163a25, 
	0xccb5e33e, 0x76a11c4f, 0x38b589f9, 0x1f77c8be, 0x87c876e1, 0xce2a40a6, 
	0x84759c10, 0x670825cb, 0x0b572d4e, 0xc0098bf0, 0xbed4a21f, 0x8461e118, 
	0xee51db7b, 0xff80fb15, 0x8a7f285b, 0xd536fea4, 0x2bd385db, 0x54f8f30e, 
	0xa815f40e, 0xfd030803, 0x0f7c514c, 0x4da410d3, 0x281dbd15, 0x602a8b17, 
	0x535ea05b, 0x0cb8d7b8, 0x46921be7, 0x30adf20f, 0x8ee411c0, 0xf433ad11, 
	0xb617a801, 0x1084b11c, 0x908970ab, 0x9df09d37, 0xb81d2ae0, 0x8a03875f, 
	0x31233a3f, 0x4d84df9c, 0x4317c221, 0xf6a2fe9c, 0x6b6f802b, 0x09b8ab4d, 
	0xfc11affb, 0xfbacedc7, 0x36c4ddb8, 0xd453975e, 0x43bf4868, 0x63ffa809, 
	0x0df5c6ac, 0xf4633394, 0xa31fa433, 0xb8b6f37d, 0xcf8a1d03, 0xecbee1ff, 
	0x61aef914, 0x69c5b9e4, 0xe3f1054c, 0x287007ff, 0x45783806, 0xf3a9e494, 
	0x167824b8, 0x051acc05, 0xf306236f, 0x5e40fa70, 0xb5fab929, 0xbe6ae431, 
	0xd673f0ce, 0xbf3e2c8b, 0x3b79f14a, 0x034af40d, 0xb8ff97d7, 0x314710e5, 
	0xfe12a585, 0x71839c83, 0x2c74bff2, 0x5c32d62e, 0xbf523e50, 0x2f32236f, 
	0xdd5c1277, 0xef849622, 0x380e1093, 0x872c05df, 0x67772803, 0xd936fc01, 
	0x9e3a55f2, 0x0e4afac3, 0x3487084f, 0x8ba64ec7, 0x1179e018, 0x17c44bc8, 
	0xeaeb4fe8, 0x0375f5e2, 0x8a149b4f, 0xbe0048fe, 0xf9f112fd, 0x24fef86e, 
	0xac60ffb4, 0xf13d4af5, 0x8cd7ae2a, 0xc02ffb6d, 0x43bf857b, 0x4e99b8b7, 
	0xe39e3c95, 0xc708bd33, 0x37f41f88, 0x471f8d07, 0x1c6e0f38, 0x8bb641d0, 
	0x97193afc, 0x5ef94780, 0xf30c7f58, 0x637d4290, 0x2600dc67, 0xdfdcf20e, 
	0xbeee002e, 0xf1e13f0a, 0x3ce3805e, 0xbd71a380, 0x9bbc063f, 0xdf4126f5, 
	0x89bb98ef, 0xb5be5ffa, 0xf56fca17, 0x0c7b5e13, 0x8475b859, 0xa1e34bca, 
	0x08ae7cd1, 0xb4bac9e5, 0x35f14cbc, 0x2f9130bf, 0xa0f30815, 0x7e0c75b5, 
	0x4372b176, 0x57e049f1, 0x7b4fe421, 0xccaaae46, 0xef23defc, 0xe7677e23, 
	0xf3657e49, 0x9d339253, 0xd4111dd5, 0x81706f7f, 0xdf7d8178, 0x8b55497c, 
	0xdd15e306, 0x416df621, 0x4e392840, 0xc078117c, 0xf790a450, 0x37967ae3, 
	0x33aac83d, 0xcfcdb6e4, 0x7086237b, 0x4df34fed, 0x4b9fbe5b, 0x79251cfe, 
	0x271ce623, 0x6f39c8f8, 0x3c741a62, 0xcb627285, 0x23ee3735, 0xe5aab3f9, 
	0xb6f386b4, 0x1cdfa464, 0x3f2007ad, 0x4c6ea0ef, 0x9a61e11d, 0x5fd19e0a, 
	0xcedf7e51, 0xe4cf0c99, 0xefcc0e9d, 0xb0997a3f, 0x27ce0df9, 0x8ff614af, 
	0x80d4c5e8, 0x116145ac, 0x43bf7668, 0x9b1033fe, 0x9bf0f08e, 0x5fba6f84, 
	0x399f386a, 0x9c35cb2b, 0xf819044f, 0x4b1eb486, 0xe7f80a78, 0x8ebd378f, 
	0x005737f4, 0xf8cf5adf, 0x2fd0cc9c, 0x5bd4708d, 0x39f196b8, 0xfbbe18b9, 
	0x8fc758cd, 0xffc3e759, 0x6a1fba6c, 0x41d1644a, 0xf089bc41, 0x8c3fbf18, 
	0xbbb405df, 0xbe19f709, 0xdffe2877, 0x0c7e7a4a, 0x82bfadf9, 0xe75bd7f1, 
	0xc10f12af, 0x8d4e13ba, 0xe54920e9, 0xc73e49f9, 0xc76334c0, 0x5b8d5360, 
	0x42a6b1fd, 0x906bb3d6, 0xeb1e763e, 0xd74893d0, 0xcf1ba396, 0x716cef09, 
	0x155e0374, 0xfb8fe23f, 0xdd18bf99, 0x0e5e94cb, 0x6120d7f5, 0x0a083f22, 
	0x8e51cbd2, 0x89bd4174, 0x7e41e101, 0xdf5bd29f, 0x5ea073c9, 0xde2f0e1c, 
	0x4d758314, 0x07090e68, 0x0808c3cc, 0x72c83747, 0x1abadedf, 0x3af623e4, 
	0x475c7e45, 0xfc8fd17e, 0xff349eef, 0x14e83e00, 0xa7c487c0, 0x3f10bf99, 
	0x9103f186, 0xcf114e29, 0x9f303be0, 0x3e1f942e, 0x841f75a1, 0xea6f1e3e, 
	0x38ce5f10, 0x13f56d37, 0xfc240cbf, 0x1f5a440e, 0x37d84bf2, 0x8a3fe45f, 
	0x3e45b811, 0x7cc17469, 0x84f3a94e, 0x5c69f15b, 0x2265c21f, 0x75e347c2, 
	0xdfdc0376, 0xfc7d65ae, 0x7862a400, 0xe5bcbc0c, 0xf4e91d1d, 0x71e617b1, 
	0x84edf4fe, 0xb55ba797, 0xcc25e0f3, 0xe3e38be0, 0x03af3da5, 0x7c011e4a, 
	0x724cfe49, 0xf402638b, 0x81fbc9a1, 0xfebf4015, 0xf02f0047, 0xaa2bb41c, 
	0x3869dd69, 0xee3a3ee0, 0x86d3c349, 0xf7a286df, 0xe9fbc56a, 0xc29cbb7a, 
	0xa404f944, 0x0472865b, 0x925a7390, 0x24b292f5, 0x5ab147ec, 0x87d1437f, 
	0xf150df3c, 0xe35f5c34, 0x9f5e5e53, 0xae1a75bc, 0x455de1bf, 0x46f4a397, 
	0xa38d77a5, 0x98b41607, 0xe3935f07, 0xfeb4c7f3, 0xfc995966, 0x6f64d0ef, 
	0xefb5d11d, 0x04d3dab5, 0x1ca1613f, 0xa8a5753b, 0x3e919392, 0x7d207736, 
	0x54df2d14, 0x72d3cb2f, 0x94fa03da, 0x869fcbb4, 0xc5eb3754, 0x261d700f, 
	0xf979e5d1, 0x288ff550, 0x58b4b8df, 0xd256a1f1, 0x5ff53e57, 0x1c0e757e, 
	0xebcbbf6f, 0x6c87c5ce, 0xf3a934b8, 0xd15b8563, 0x8bbbae1f, 0x3de420e0, 
	0xfa814eb4, 0xa86c06a0, 0xe150e004, 0xe40f64b3, 0x96e5022b, 0x0826f506, 
	0x3b22ddb1, 0xd7eee984, 0x18fbbda9, 0x38273de7, 0xd4a019ef, 0x657da2f4, 
	0xaff7b852, 0xad208712, 0xa1db2d92, 0xf269b2ef, 0x6e5887f9, 0x6e003bc6, 
	0x7f58ca93, 0x75f3ba01, 0xa3709f31, 0xe8b27ade, 0x2dfb84e1, 0xd44ac3c2, 
	0xf8ebdb5b, 0xc9b5f63c, 0x33c3aa9f, 0xb263d8ab, 0x7ac65ebe, 0x4777c55c, 
	0x7e604566, 0x814e51bb, 0xc66a763e, 0x8c37097d, 0x5ad3ee5f, 0x2c42bd12, 
	0xd43d63ad, 0x0be513e6, 0xcdea374d, 0x0b4801e5, 0x63cf1eb1, 0x8a9bd425, 
	0xcaab5ce7, 0xd3f0fb8f, 0xffd4029b, 0x12568a37, 0xf77f277c, 0xed751f80, 
	0xc67cffdd, 0xd764fc8f, 0x515c1ff5, 0xd76c7203, 0x94af7b86, 0xa8579021, 
	0xca60b5ef, 0x8eb470fa, 0x8a1b3aed, 0x8b1bafae, 0x583b842e, 0xa06ee7c6, 
	0xff8c6587, 0xf8d37bfe, 0x5f91ed8f, 0x0dfd1436, 0x0bf06fef, 0x07830f44, 
	0xe979a5ae, 0xc869c945, 0xbf4d4e8f, 0xd3944dea, 0x02fa84df, 0x74b728f5, 
	0xebcbfc23, 0x2f89d5d6, 0x79023e40, 0x7ad96f98, 0x7a0edb59, 0x6609a9d9, 
	0xf4c03122, 0xf2dfe783, 0xbb977ba2, 0x145360fb, 0xdc6fca9c, 0x31f65cb4, 
	0xae58a17e, 0x2b801bf8, 0xfa548be1, 0x0f11d0b7, 0x9072dde7, 0x811563ec, 
	0x0093695f, 0x58362aef, 0xaf281eb1, 0xc1fefc98, 0x17f70f12, 0xfa9afd84, 
	0x097a4d8b, 0x637bd3cc, 0xfd41a628, 0x5d314db9, 0xb1c539f0, 0x7418c8ff, 
	0xf138e270, 0x2eef77bd, 0x05707c51, 0x3b9bc1d1, 0x6074572f, 0x69df886a, 
	0xe63a903a, 0xa0f86b85, 0x21e90476, 0x8c0af0ce, 0x3d3682c4, 0xd6abfac0, 
	0xdf70c775, 0x8c1e1686, 0xbe32f7eb, 0x54429d19, 0x4e890bee, 0xd8617fe0, 
	0x302bcec3, 0x0277891f, 0x22fbc27c, 0xcc6a96c6, 0xde1bfeb3, 0x82dcea17, 
	0x5f634b7a, 0x7353e700, 0xbf34b5eb, 0xafdf4553, 0x5815fe43, 0x919952f4, 
	0xfaaef507, 0x70f22020, 0x90fba53f, 0xf718f183, 0x453fc2a9, 0x7885be74, 
	0xf1e130fc, 0xdfa00394, 0xd87a1c20, 0x3fe1517e, 0x37e70b38, 0x5ef71e1e, 
	0x893f1e20, 0xe4f28c78, 0xe71fb158, 0x4d57fd19, 0x3493f1e1, 0x7c7851cf, 
	0xd4574be3, 0x15cb3ac0, 0xfc2b96fe, 0x3bf8843d, 0x4cfbf88c, 0xe2ebb89d, 
	0x33db17f1, 0x05c6ff7f, 0x6f1a6fe1, 0x6978d00f, 0x8124bb7e, 0x6e7cb6fc, 
	0xba75bf36, 0x72ec0f01, 0x36e5b7e0, 0xf363ddbf, 0x5bf304db, 0x44875358, 
	0x809dabbc, 0xfd30aef0, 0xfdc613a2, 0x9d7f7d71, 0x38f10671, 0xaed9caa6, 
	0x158fe158, 0x06faf2a0, 0xd26fd3d2, 0x79aad2f3, 0xdaebcb3f, 0x2f919e89, 
	0xd7651ea1, 0x7be06ad3, 0xbae7c83b, 0xdf89d41f, 0xa96c3e02, 0xfc045fcd, 
	0xcf906670, 0x6b9821d7, 0xc7d402c7, 0xd94ffd94, 0x26610c17, 0x9ea77f10, 
	0xafc8bcb0, 0xbd022f89, 0x7c880d95, 0x2ded45d1, 0x7963e017, 0x687990b5, 
	0x9dfe01d7, 0xe9ffb0c8, 0x376e7d81, 0xffc0e1f0, 0x7404f1a9, 0x194f5fda, 
	0xd7efc1a4, 0x9690c378, 0xbbc077be, 0x1fe9d200, 0x885fc81d, 0xb33439fc, 
	0xa2c8e49f, 0x2f48e591, 0xdb427379, 0xa1f2852e, 0xd2f04906, 0x435e189a, 
	0x45aa5f3b, 0xfe9a9f78, 0x0f08adcd, 0xeee6ef1b, 0xe9fb242c, 0x74259ddc, 
	0x62f1b24e, 0xeff7ed44, 0x7cbadf15, 0x07aa14ee, 0x9da3b7ed, 0xb07bbf15, 
	0x4b14de7c, 0xfc451f95, 0x97d472c6, 0x2ff14c3e, 0xd1094780, 0xa4f64279, 
	0x3cbf2ffb, 0xa2b77f25, 0x95eb9aac, 0xe7ff715b, 0xd5ab1dde, 0xf0043ce9, 
	0x77366102, 0xbe89e43b, 0xb2ed0f85, 0xbcec1b73, 0x2dfca1e5, 0xd37d5507, 
	0x4f2ff54b, 0x0f943de5, 0x53dbb41c, 0x66d5f9fd, 0xa631624b, 0xb801ec52, 
	0x968bf7cc, 0x654c61c4, 0x8f3063c3, 0x4b3070f9, 0x936906be, 0x283a27a5, 
	0xce1fbf5d, 0xf2a3f3e6, 0x989207a9, 0xf0cfe38a, 0x2ef1f0b9, 0x947ce780, 
	0x4bfeb0bf, 0x091be5f3, 0x62d37f68, 0x3e28cb86, 0xf947bd68, 0x9c794509, 
	0x0973e0bf, 0xfd0e78f4, 0xc7887e6f, 0x85b3e4bf, 0x507fd147, 0x13db15ed, 
	0xf61e7a66, 0xe6bccbf7, 0xac51fdf6, 0xead1dd77, 0x7affaa2e, 0x5e33cf10, 
	0xc58f75b1, 0x395babf5, 0x6f983a45, 0x1f76fdda, 0xe95df941, 0xfd595d95, 
	0x9e0fe69a, 0xbf5c3867, 0x92d0e115, 0x9c11c79a, 0xb22bd847, 0x7ec64fea, 
	0x9b94e987, 0x857acc3f, 0xf6a76acf, 0xdf5937de, 0xd5c60ef0, 0x1e0867f8, 
	0xef3ae39e, 0x5427ea1b, 0xe559740e, 0x4f10db15, 0x9f25fcec, 0xa411c1fd, 
	0xab5ed9f7, 0xf6e95a4b, 0xaf9f4ae5, 0x206f17ca, 0xfb9eded8, 0x179c76f0, 
	0x47fd47a4, 0x8ebfdab2, 0xad79e7ed, 0x54f6a9ad, 0xe79d1d7e, 0xdccd78e6, 
	0x3e5823f2, 0x65766bcb, 0x13f77797, 0x04caf1df, 0x73cea796, 0x234f7748, 
	0x4b54bf5e, 0x357a2cfc, 0x76ee6a2d, 0xcb875fc8, 0x7f089abc, 0xd7ca836e, 
	0x1f2dfca8, 0xae46fd70, 0x7375eb6f, 0x11e5572f, 0x03e04fd5, 0x76e2176e, 
	0x336af5a3, 0xb690fedb, 0x6c76db6b, 0xd86543f2, 0xdb6f3823, 0x36fd9423, 
	0xd1cfae75, 0x572323bf, 0x73f33379, 0x4cde7de4, 0x9f2f847b, 0xa7a432ed, 
	0x3e3a65ef, 0xf96efb4c, 0x5ec83b8e, 0x81bb25e1, 0x21f8f59b, 0x9cdc43b4, 
	0x847387e6, 0x3b2b6bb2, 0x4ea3754b, 0x6879bf7e, 0xfa8cb87f, 0xfa13782b, 
	0xf5eecd71, 0xb1a0bfa2, 0x1b9f19fe, 0xd95ef7fa, 0x763b7f7b, 0x8ad8ed50, 
	0xdb315deb, 0xc2820aff, 0x28e5babd, 0xad9681fa, 0xda25777a, 0xf5fd963f, 
	0xda005f49, 0x0b4470af, 0xd41822be, 0x6e86a7c8, 0x86e6f252, 0xbe00e8a4, 
	0xb84dacb1, 0xe0ffb662, 0x35c0636b, 0x820bf70d, 0xf959b06b, 0xba3f7105, 
	0x119c3e3e, 0x757699ae, 0x04a3afa4, 0xf880b367, 0x48f9c205, 0xd704ce1a, 
	0xf0da780c, 0x057afd85, 0xdbe08bf7, 0x50af8697, 0xb55733e7, 0x0f7c92f4, 
	0xf20379c1, 0xb73b758d, 0xfc6a1f23, 0x295f7ef4, 0xc3bd43ee, 0xfaf4053a, 
	0xff85d00a, 0x5ef0d19e, 0x619c0061, 0xfbf6865f, 0xc4d1ced9, 0xdf773372, 
	0x80357e53, 0x113a703f, 0x8f5e2f99, 0x7a1d7f01, 0x4bef0f6c, 0x72bb9f13, 
	0x646f05db, 0xfb54677d, 0xaef5e219, 0x05f6e8e4, 0x05db8655, 0x4ca0b68c, 
	0x05fe1038, 0x062d0a77, 0xb25634f0, 0x3d03e5fe, 0xefe841ec, 0x3e7ac2ff, 
	0xa0ac7c01, 0xc043cb8d, 0xafac93df, 0x4d9f943a, 0xea49fd63, 0x68fe2e78, 
	0xd14fcb31, 0xbfe911fb, 0x6886d6fb, 0xfe6d87df, 0xf10f7c36, 0x5edca7ff, 
	0xd7a533a6, 0xdd0cac16, 0x53057897, 0xbf384f90, 0xa8f24932, 0xec68b6e0, 
	0xb7c70d01, 0xc976523e, 0x3fb01dba, 0x2f5eca05, 0x803fd89a, 0xeb09ae7e, 
	0x7ccc9d10, 0x587fd394, 0xe71bf2cc, 0x8e9e952b, 0xfc0e2078, 0xcef5e69c, 
	0xe7e310b4, 0xe5e90b70, 0x695d6ff5, 0x1fc92be3, 0xe1d05e7b, 0x9e8658a1, 
	0x51f4585e, 0x79225c96, 0xc0f3c3d4, 0xf6512e71, 0x5075d3d1, 0x07867def, 
	0x0f9c15ca, 0xd42605e9, 0x97ae9b5b, 0xbb25bf2a, 0xe7cfe11c, 0xfe422315, 
	0x4bc7e50b, 0x48cd1ddb, 0xc6affb3f, 0xf96d67f4, 0xf51d19d4, 0xe19062a2, 
	0xe6fb8041, 0xdf447772, 0x6e2fb69a, 0xe9d766b9, 0x8e0a65ea, 0x80bd8f40, 
	0x77f82e17, 0xf797eee2, 0x2f9fa005, 0x3b8c3b43, 0xe5e5b1d8, 0x6fd86539, 
	0xbf7474d2, 0xe8eb7445, 0x31b776c2, 0x6cbe13fc, 0xf5a3fdfb, 0xbbbdce7c, 
	0xd5fcf59e, 0x5363e582, 0x1f98fafc, 0x547537da, 0xde10f2ec, 0x00dd5d88, 
	0xc67acab7, 0x4fe52697, 0xf3e7aaa9, 0x867a9ceb, 0xc064d35b, 0xdf08404f, 
	0x7a7e398b, 0x7b40e9af, 0x0ff6014d, 0x7cf522ed, 0x5eabbd4e, 0x3efd13c1, 
	0x03bfca3d, 0xef3a9aed, 0x2a7dc76e, 0xe7b91788, 0x6b7df9f1, 0x9f10857b, 
	0x4213f555, 0x8481be38, 0xf647dce4, 0xd34aa6b1, 0x7ea1fb21, 0x81d74eb4, 
	0xf6719cfe, 0x2d82ac2b, 0x527ac0ef, 0xe89cf03a, 0x5c75eaac, 0x04f98476, 
	0xccfc73f9, 0x47779cf7, 0x36139fd9, 0x2e7425db, 0xf814812e, 0x27e2d181, 
	0x87e0ba3d, 0x48921c8f, 0x97e521d7, 0x4261aa69, 0xfed8fd56, 0x5b61099d, 
	0x11d01c8e, 0x951a877f, 0x3f64c77f, 0x1afd178e, 0x27ee8c77, 0xac69dfe5, 
	0x7aceff23, 0x3b3e9fb5, 0xa2e9032e, 0xe20fbd2b, 0xe38ed112, 0xefc0dc78, 
	0x75bedd60, 0x92df3a49, 0x7f22c83d, 0x2a15fb01, 0x7b215c0f, 0x4317e7d3, 
	0x8de11fc1, 0x7060a17c, 0x741ba3a9, 0x709f02e0, 0x9adf6124, 0xd77afed5, 
	0x60b73db1, 0x9ce8b7ef, 0x950df056, 0xfa721f5a, 0xaa0e9543, 0x152af7f4, 
	0xf6895ed7, 0xfcd43b89, 0x0f388a0b, 0x6588e974, 0x9584efec, 0xfd80e121, 
	0x3a8cacf1, 0x3b5f3e34, 0x2afbe0ba, 0x76485768, 0x9df54149, 0xe8123f4a, 
	0x9afb423f, 0xb941fa0f, 0xaea27e83, 0x28171e34, 0xf5a5cfff, 0x4aec5f6c, 
	0x8e2805d4, 0xc8cf5724, 0xfca7a7f1, 0xb21fca10, 0x801df945, 0xef28627e, 
	0x1f1afd72, 0xfd024fd7, 0xfd8658ca, 0x927e7cf0, 0xca02dc54, 0x7f68f0c3, 
	0xc83ffa3a, 0x1ffcaf7e, 0x94bfc942, 0x26d3641f, 0xfe399dcd, 0xb28efe78, 
	0x5d53cc57, 0x7217fda3, 0x1e904265, 0xed04fc04, 0xcf0b1791, 0xecfc34bf, 
	0x5ff5ec71, 0xee0afc28, 0xcf10c68c, 0xeb8c396c, 0x78691cb2, 0xfd32bc12, 
	0xf8f3eeea, 0x16fd9487, 0x5f6895fa, 0xf431bdba, 0xac582bce, 0x4780ecfc, 
	0xd08db60b, 0x1bd4753c, 0x78f67a52, 0x374894fe, 0x1f6a01eb, 0xf5cd7a6d, 
	0x2cfbe4a3, 0x1767f11d, 0x53d44a88, 0xfaab0df3, 0x71e94dc1, 0x8dae477a, 
	0xeec3c264, 0xa5ce353f, 0x782fce30, 0x5a31ed9c, 0xebae0147, 0xc90bfb93, 
	0xa79c213e, 0x2f9417ef, 0x90c4bb21, 0x8c255a29, 0xab9dff5f, 0xe2f11b85, 
	0xb7ccd5f4, 0x78476d84, 0xabb6f49e, 0xa2276bfb, 0x315835be, 0xe3f20765, 
	0x54bc552b, 0xd631feaa, 0xacfeedfb, 0xae8d5e6f, 0x167be023, 0x5cdf27cd, 
	0x4878e81a, 0x0b278588, 0x50fb425f, 0x7f0d0fca, 0x73e9aded, 0x0a2dd845, 
	0x0b303f59, 0xc486bf91, 0xf59285bb, 0xe54bca1b, 0xdb84d067, 0xdf8f7a4f, 
	0xe3de93f4, 0x7657e2de, 0x512fce23, 0x84908f7a, 0xd57dd63f, 0xf14e6f84, 
	0x4885c53a, 0xb863c6fd, 0xfd9243cf, 0x13def2bd, 0x1fe61fa2, 0x224d9ed3, 
	0x33e7b64f, 0x2a9b0fe3, 0x72576843, 0x2046560e, 0x588a758d, 0x9bee117b, 
	0x44de4d68, 0x04c4aed8, 0xdc3d5de8, 0x1eb1912e, 0x796328a7, 0x956bcee0, 
	0x847a1780, 0x326c44e5, 0x1971c3f4, 0x4c5d1453, 0xfcd27119, 0xca2e58a7, 
	0xb529fb07, 0x293ac782, 0xf382725f, 0xbdfc0325, 0x4be734f4, 0x82fbe187, 
	0x069f1c25, 0xf84753e5, 0x942cec7b, 0x6537d1ff, 0xd0bdda09, 0x36fc8e4f, 
	0xfe69d2e6, 0x1f6789b1, 0x337ff945, 0xe808bf2c, 0xe6a0d62d, 0xbbbaf503, 
	0xbdf00a54, 0xe97a2dc9, 0x76a34bbb, 0x666678ff, 0x89db90b0, 0xca9fa042, 
	0x0dcfcc25, 0x222f1d9f, 0xdfd86eb5, 0x7cd896cb, 0x3b280ade, 0xc7f10041, 
	0xd8b52cd9, 0x68c3a800, 0xf2272abf, 0x4479f00d, 0xd3507e67, 0xb0fe2012, 
	0x50c7f998, 0xd1fda0af, 0xbc7c616f, 0xa056ed01, 0x5fd70e10, 0xbef504b3, 
	0x79a0cb98, 0x2f230995, 0x4af90c59, 0xf3a41fde, 0xdaa3c62e, 0x3867a46e, 
	0x82bce0d7, 0x995e2f0a, 0x7d017008, 0xeb813630, 0xdb09767f, 0xe501e325, 
	0x8f32103f, 0x3cac5ee3, 0x78db67b4, 0xeb096cb7, 0x39d2e335, 0x15ce88e4, 
	0xe7478cfd, 0xf759de36, 0x4496109d, 0xbe27e93c, 0x3f7e99aa, 0xb2997dc5, 
	0xd60ef592, 0x3daa878b, 0x5158fe59, 0x1e95fa62, 0x5d7ff54d, 0xb212f37f, 
	0x63fe0287, 0xea5bb6f9, 0x9fe98f89, 0x62195b3e, 0x187d36fe, 0x9d4263f9, 
	0x4779d447, 0x863e4a2f, 0x83efe0fc, 0x292a2e2a, 0xe8bd93a6, 0x9ebf14fd, 
	0x56a8f38e, 0x98687afc, 0x31d75bdb, 0xf78bd31f, 0xc1f91cfc, 0x9e3907df, 
	0x1ecfea09, 0xcd6f7921, 0x4dff48b6, 0xbeb8c5eb, 0x1b3c2078, 0x527c69f9, 
	0xf50d46d5, 0xb28b139c, 0x3f2da7e5, 0x0295fb24, 0x6ff62866, 0x001687c8, 
	0x35f9c61f, 0x49e62b0a, 0x636561db, 0x1f187442, 0xff747e9f, 0xa53e123f, 
	0x8a9ac7e9, 0x93cf5e7c, 0x31ceed81, 0x78f389e6, 0x5bf1e14b, 0xa9c78f17, 
	0x9c95c675, 0x7b1cf934, 0xee638283, 0xd9e9befa, 0x121bfbc9, 0xdec90fb1, 
	0xcf487d2a, 0x7f5b3e55, 0x8fca2514, 0x9675ce71, 0x24ffb035, 0xa8799d77, 
	0x977e0117, 0xf21a9a0d, 0xd0798881, 0xcafe87ed, 0x4a2f9002, 0x81b077e3, 
	0x96fb13cf, 0x22ae79f0, 0xbbb409a8, 0x945e9d96, 0x97219ad7, 0x3febbda7, 
	0x71708ad8, 0x01f7b15b, 0xfa869f0f, 0x0c0fc8ad, 0xa9e28b51, 0xf434202d, 
	0xd4a9951b, 0x8a3bffee, 0xc2585f3e, 0x1f6995e7, 0x867a954e, 0x617a487e, 
	0x597eba49, 0x5b47ea28, 0xe703f53c, 0xf8fefbb4, 0xdf682d99, 0x8dc3a296, 
	0x43fb1f42, 0x720c9fbb, 0x3cee669c, 0xd4e3fbef, 0xfdda79ac, 0x4cd0f0da, 
	0x80672d91, 0xcce532de, 0x8386068c, 0x57f0bf4d, 0x94dae749, 0x9bf451dc, 
	0xa7746723, 0x6bb7b955, 0xf9b05f34, 0x5ed831a5, 0x7641f180, 0xf8f9c15c, 
	0xbd3269a5, 0xc7097cfc, 0x5dbf113d, 0xb6a7c69b, 0xe116a225, 0x98fb7c03, 
	0xdb667a0e, 0x88fdbf2f, 0x843c7cc6, 0x0c3fd07a, 0x38225edd, 0x7e07ebdf, 
	0xf9ff0fff, 0x6df99feb, 0x6ebf60bc, 0x677b9d19, 0xca08f2de, 0x660b900d, 
	0xfbfa7371, 0xa76c8217, 0x7ee78519, 0x301fcd60, 0xde3b6493, 0x37e4652d, 
	0x05ff3936, 0xa2f887e5, 0xa0e80c5f, 0xe06c4d9f, 0x01a18b38, 0x95319765, 
	0xcb2fc23f, 0x1fa87e70, 0x71eddc20, 0x8e08c1b7, 0x26be69bd, 0xfc524e6f, 
	0x799c3433, 0xcfcd23bc, 0x6f8ab564, 0x0f949bf0, 0x721f9c59, 0x6b3f3217, 
	0x90bed24a, 0xdce3019e, 0x4805f68f, 0x49afc57b, 0xff02f0ff, 0x0e1b3e44, 
	0xb23d3d3f, 0x3ccdea85, 0x7d48e70b, 0x02e66476, 0x8b9583e0, 0x032f2a5e, 
	0x606fe899, 0x45046c39, 0x74c94edf, 0xeb19f6cd, 0xf9c8ec64, 0x31a39df9, 
	0x399ea16a, 0x3845bf8a, 0xed7cedee, 0x4c072bdd, 0x81846f6c, 0xee8c965f, 
	0x92c689e7, 0x7207d406, 0xe028eef1, 0x9fef9e0d, 0x22ff0a59, 0x8bd3aeff, 
	0x1f2ec17c, 0xe5d23eaf, 0xf3e3f3b0, 0x4bfcf6df, 0xbfe2c61b, 0x5d13fe36, 
	0xbf5e8d74, 0x1f097fcd, 0x3e9f9c17, 0x4dc3e3c6, 0x7387cced, 0x3fbe06e9, 
	0xfc87fb42, 0x27ef08fe, 0xe07365d9, 0xcc0636ea, 0xff38ed3f, 0xa3ab18fe, 
	0x7383da26, 0x061997db, 0x63d043f3, 0xcf88a712, 0xc85d1379, 0x04ecc5ee, 
	0x1b398fe1, 0x2bd410f5, 0xb6f70093, 0x2877e60e, 0x91de71d7, 0xb43e5f84, 
	0x90b6f91e, 0x4739d00f, 0x431f96ce, 0x96fca3ae, 0x6add7299, 0xdd3df8a1, 
	0x2478980f, 0xc943be23, 0xa023d275, 0x5f65323c, 0xf8a79224, 0x3ccfcd3b, 
	0x24b92318, 0x4cd99ca6, 0x96729af3, 0x4c3c1152, 0x47832178, 0xc7251529, 
	0x26f25f39, 0x39074be7, 0x69043a5f, 0xf805f15c, 0xcb867a9b, 0xfb7ea2a7, 
	0x0d3dcf4d, 0x6e70af88, 0xc121fedb, 0x5bd4f81b, 0x5f009f8a, 0xab5e6aab, 
	0x7f156b69, 0x6e7e3e22, 0x77cb947e, 0x68b8c076, 0x8ff9b0e7, 0xb544afcd, 
	0xcdba7d24, 0x844bf2c7, 0x82ecbf58, 0x5f901efa, 0x1b3bf2ab, 0xf6a4bf50, 
	0x81aaff68, 0xbe6e78fa, 0xfd4345a4, 0x70e839c7, 0x7c1f7f13, 0x8fd8a265, 
	0x26a081f7, 0x486777c8, 0x97133ebc, 0x74d7f8d1, 0xc39ae80f, 0x866d978c, 
	0x68ace346, 0xbe286ee8, 0x58e2e30b, 0xd8e6754f, 0xf2505efb, 0x234871e8, 
	0x98670f30, 0xc0d23fbf, 0x0d15bc76, 0xf0bcd38f, 0x9cc1fa3b, 0x905d2155, 
	0x44f981bc, 0x1f305e71, 0x1d9dafd0, 0xbf4dc526, 0x9a71f931, 0x2c055197, 
	0xf75c41f0, 0x7b0f64dd, 0x3ca9a9f6, 0x0f0a70af, 0x7a6d3e89, 0xd00573a4, 
	0xbfdbdb63, 0x4d8673a6, 0x613cce4f, 0x7442bea1, 0xf4f175d6, 0x1c01f2ea, 
	0xabdf7a6d, 0xbee013e8, 0x1a5fe1b8, 0x5aee3fd0, 0x7cf0d210, 0x74141a19, 
	0xacd5c5ff, 0x317bd04d, 0xf6f6fbdf, 0xe517c865, 0xc46776b7, 0x359c559d, 
	0xe9c5b9d4, 0xecfd81e8, 0xa094b807, 0x2a9b735e, 0x9e8e1a8f, 0x97f28c92, 
	0x396e5c1d, 0xeca7ebb2, 0xf841c278, 0xb40e16ee, 0xad9d55e3, 0xcaa3c6ff, 
	0x44f9d93f, 0x376b9f3a, 0xef8dbaa8, 0x1a78c0d7, 0xaaeffbf6, 0x6f1c2adf, 
	0xe1a78d12, 0x7b4fe03c, 0x63bf84ae, 0xa1957c3c, 0x5e782bce, 0x7c8bd0cb, 
	0x059f81a1, 0xb79531eb, 0xf3085a5e, 0xc61a136b, 0x49b5573b, 0xb466e0f1, 
	0xf6f93e3b, 0x2e58c3be, 0x42fef5ff, 0xf9beb72c, 0x3f61db20, 0x680805db, 
	0x9cf3abd4, 0x513bb37f, 0x3114f142, 0x0a8ca7d4, 0xbc666573, 0x54e86184, 
	0x6a5875cf, 0x6aadd7e8, 0x46feda17, 0x6f72bba4, 0x4253da35, 0x2c5eab52, 
	0x7ce27fc4, 0x88d3ae31, 0x105a344d, 0xf993feaf, 0xf099b47d, 0x330df5fc, 
	0x002e3f98, 0xfdc62844, 0xf6943d62, 0x707c4e31, 0x10c1f222, 0xf63e2be8, 
	0xbe644d2b, 0x7dd22728, 0x2faca59b, 0xb3f4a002, 0x6feacf68, 0xbe5073a1, 
	0x4149f74d, 0xfe0c867e, 0x9b707e47, 0xa6e7d9ff, 0x33df457c, 0x8ff43fa1, 
	0x1f8513e8, 0xa4faeffd, 0xfb023d5e, 0xbc333465, 0x62f7c167, 0xc2b37f84, 
	0x7b9c3713, 0x4c46cf91, 0xbd52e30d, 0x3bfcf94b, 0xf71df113, 0x3cf92fc7, 
	0xb435341a, 0x8c7b63d7, 0xab0cd04f, 0x78814dff, 0x79e1a03b, 0x2b9ee3e8, 
	0x8eb8fd71, 0x6437a450, 0x2edc300c, 0xc4e60e0e, 0x7c20384c, 0xc0169e09, 
	0x1382ad73, 0xd5172b9e, 0x7019ddf8, 0xf3abf219, 0x8d73f2ac, 0x52930727, 
	0x2042779d, 0xe0bfb14f, 0x49ee8b69, 0xcb3571d8, 0x0c70e213, 0x46e7dae1, 
	0xaa22a5fd, 0x5f01c6f5, 0x30f8a17e, 0xf90ea5e4, 0xfa7bdbaa, 0x83831f11, 
	0x4af183c2, 0x33dec1c1, 0x7ea08fdb, 0x287f9f26, 0xcf4bbe83, 0x4e12ba2a, 
	0xfd55d20f, 0xd2aba652, 0x9079bd34, 0x69e552ae, 0x9faecb7a, 0x3c6043d2, 
	0xd20f6fa6, 0xf5b3ecf7, 0xd328feff, 0x9f5be5cd, 0xe973e748, 0x9f8a767b, 
	0xd7bf53d4, 0x1f80bf61, 0x64fc53b3, 0xdbe987b1, 0xe37d20f4, 0xd997a477, 
	0xb743a286, 0xefa4c9e9, 0xafed6470, 0x8d318783, 0xf40f9f2d, 0x0df48a5b, 
	0x2fecd93a, 0xf40dd149, 0x3c9e361d, 0xda5df483, 0x40f1bf26, 0x3f5b9621, 
	0xf73df456, 0x70efa07e, 0xfe1be2bd, 0x0f44aecd, 0xf21777d1, 0x6d4570cd, 
	0x91877d16, 0x255ea1be, 0xeff235d2, 0x02e272c3, 0x35d98bc0, 0x33b7d11a, 
	0xa0d56a6c, 0x94b1de70, 0xabe551f9, 0x280dc942, 0x93a67961, 0xf3a1c8dc, 
	0x41e9a0e0, 0x8bfda6fa, 0x209cf5a7, 0x65d937d2, 0x48f7a54d, 0x96da7bd2, 
	0x0013b9f2, 0x8bb67955, 0x8ef49be8, 0x5d78d347, 0x95d78399, 0xd76df439, 
	0xeafebc27, 0xa027c652, 0x2b6248ef, 0xc62571e1, 0x199b867b, 0x0fc288de, 
	0x06a3fc22, 0xd2dc53fb, 0x1130f683, 0xdf483cb1, 0xa77e8a9d, 0x9f137d22, 
	0x378a1e94, 0x2e9e5a0d, 0x0f75a7a5, 0xef7f7d13, 0x72afac38, 0x5fcf5ac1, 
	0x7ec9be88, 0x0be9ac19, 0x1b865119, 0x0e1c2fe6, 0xa6df5da6, 0x4f04d9ef, 
	0x9c11dfa5, 0xfcfafe60, 0x0cee23ab, 0xef3b8cb8, 0xff2c9eea, 0x8885e939, 
	0x5cfb0bd7, 0xead2deb8, 0x7e91c7be, 0x69f8a33f, 0x389cf569, 0x27e56fd2, 
	0xf147be7a, 0x501ecaf3, 0xed1e7c86, 0x8ebd8378, 0xef4e59fb, 0x3d30b87d, 
	0x9c94f4ce, 0xf1f2425e, 0xa72e8a3b, 0xe48ae9a7, 0x4d3caa63, 0xd3f5d957, 
	0xe98d36fe, 0x7c35f818, 0xf8ed9c8f, 0x1fd392ad, 0x3a44ffde, 0x91c74b9f, 
	0xfd405eb4, 0x8dfaaebe, 0x2c82f5a4, 0xa2bafd39, 0x8e8a488b, 0x33b4e5b3, 
	0x39443f24, 0x1135e90d, 0x2574ff58, 0x925f23a7, 0xec740932, 0x3c749e34, 
	0xe5cb187d, 0x58851dbe, 0x20f77e2e, 0x195df3cf, 0x79d392ce, 0x8da72217, 
	0x16dfa041, 0xaf486f84, 0x573ffa86, 0x32637bf3, 0xa3b7ebfc, 0x05f714e9, 
	0x0bb43bf5, 0x9d34f4c5, 0x70e5a596, 0x9fbe9d16, 0x67e9d3a6, 0xbd3a693d, 
	0x4d8873d0, 0x23b9f6a7, 0x4e8a38d0, 0xccedfce9, 0x9a48d3a1, 0x061c954e, 
	0xf83c8338, 0x19d3a2a3, 0xd0b0e4a3, 0xd1648eba, 0x25c76be9, 0x46a8e1ca, 
	0x4f8fe6e7, 0x1d71d3a7, 0x2cdea165, 0x3870bd3a, 0x757d7698, 0x4e8f1d0e, 
	0x6f6e226b, 0xcee32e1a, 0xf3ef987b, 0xf1bbe7d8, 0xefd36de6, 0xd11fc571, 
	0xf0e78e0e, 0xde5f7d48, 0x692e025f, 0xef8ab73a, 0xfe74423f, 0x58e77258, 
	0xe899be74, 0x5cc69aeb, 0xfa20ef3a, 0xe8a7954a, 0x7ebb3dae, 0xa2a5ce8a, 
	0x9e744973, 0xd170f677, 0xcd072423, 0xe9bdb193, 0xf7fe86bc, 0xe5e4f58c, 
	0x554be3e8, 0xe8e379bf, 0xe91df8e3, 0x7d1c6f28, 0x790a15dc, 0x3e930e4b, 
	0xcece70bc, 0xb5e79d34, 0x3373b949, 0x5abff7c6, 0xd13d74fc, 0x9d89e3f9, 
	0x76066e58, 0xd37f3cf2, 0x79d067f1, 0xeda9bb5e, 0x0ef4501f, 0x10c2de69, 
	0xc7386bc9, 0xb7fe3e91, 0x855f7cf6, 0xe9105e73, 0x9cf04a1f, 0x5e5b1917, 
	0xd24a0d97, 0xfad2cbc7, 0x8ff40cf8, 0x1981f064, 0x0cf09eea, 0x77716fbc, 
	0x9f1f4a63, 0xf10b767e, 0xe1c5d081, 0xc4ca15bf, 0x3e69ddff, 0xd2244a10, 
	0xe3eb6ef8, 0x4bc81f36, 0xc696e3e9, 0x3e925af2, 0xcb98d6de, 0xe58d2c07, 
	0xe472d4b5, 0x04c76bf5, 0xa52febc1, 0xa81f338f, 0x33e3e94e, 0x9a1f8e2e, 
	0x30ecb233, 0xa7825f00, 0xab5cf005, 0xf8fa84e0, 0x3b909aec, 0xe07c1171, 
	0x63d3d066, 0x3603e7e7, 0xec2de7fd, 0x0ebffa25, 0xf8e401f7, 0x1c489af4, 
	0xbbc925df, 0x886bcf76, 0x6c056d87, 0x639e865f, 0xa7d36f48, 0xe5376f09, 
	0xc75c41c5, 0x176c8df3, 0x92c19489, 0x5fd17e59, 0xed884f9b, 0x908a97ac, 
	0x4d3858c4, 0x9bf233f8, 0xa2aab1dd, 0xa8cfa611, 0x3c57faa4, 0xe7cded40, 
	0x7b1da337, 0xcc8cd178, 0xf77c0673, 0x78e2bfa2, 0xe5d3f2a3, 0xfd73ddd8, 
	0xbdbb695f, 0x7db25339, 0x7f6ecb3f, 0xb2b1fb5e, 0xcc4d999b, 0xc77c0d57, 
	0x971fb6c4, 0xf880ffb3, 0x2bf4dfb5, 0x28ff80bf, 0x1ca885e1, 0x8ddb4aec, 
	0x12758d45, 0xffe443cf, 0xe1667aa6, 0xfdb46309, 0xdb155679, 0x7a2b8f9f, 
	0x27a1d948, 0x2756548d, 0xf8bd3e88, 0xc944470e, 0xd91b37c7, 0x05c369af, 
	0xed9b75f7, 0xe61bbe9f, 0xe964f41f, 0xc86fb86f, 0x34be239f, 0xb2fd615d, 
	0xa5ffb700, 0xfa85eb82, 0xfd434e7d, 0x2903e456, 0xf4ef4fbf, 0x9fd8751d, 
	0x222ee81c, 0x6448be3b, 0xe8b583e1, 0x8efdac81, 0xabf769fe, 0x4dbe2f54, 
	0x9907f4cb, 0xf05c545b, 0xa7bbf416, 0xa3a741fc, 0xc95fb47e, 0x57ddda8f, 
	0x35ce346a, 0xdfc18c0f, 0xbd07f3c7, 0xcdfd708b, 0xb8d0bf68, 0xcaec14f4, 
	0x6e9b27c2, 0xe15cfed2, 0x907f20bf, 0x1dfdfd30, 0xff557659, 0x27ed2780, 
	0xab63d14a, 0x8a7bf859, 0x7c73e233, 0xde525e06, 0xcdc34bc6, 0x324b2e71, 
	0x084ff8e2, 0xf72a27c2, 0x08e09da2, 0x9a7e27de, 0xf7e8efce, 0xafc61378, 
	0xd1f32698, 0x45fba66e, 0x2ff180a1, 0x99d83c05, 0xc5e53fb1, 0x29ba2225, 
	0xbdb8af9d, 0x9bade57b, 0x7335fbd2, 0x168165ed, 0xe8f2afd8, 0xdbb5be65, 
	0xbb207da0, 0xdca2ccfd, 0xedb93ff6, 0xf6ac91d6, 0xb04b2dc5, 0xebf973fd, 
	0xb4bbdf41, 0x5d13e06c, 0x7bbcb187, 0xaf00e7eb, 0xbeef6fcb, 0xffa29d77, 
	0x977e4007, 0x186dcbe7, 0x116977b7, 0x51111bdf, 0xc057ff33, 0xad0096a7, 
	0x6fc31dac, 0x021ed021, 0x75d488f0, 0x187e29c7, 0xd1f1cce0, 0x61feca7a, 
	0xdfd93fb1, 0xbfdce90f, 0x42e2697d, 0x5f33cc07, 0xe7dd90ec, 0x927703c0, 
	0x2437e7ed, 0x710a0381, 0xc7ccc049, 0xbb1553fb, 0x839ebcc4, 0x00976e90, 
	0x079b487b, 0x42d4f5e6, 0xabe540ba, 0x3f64c9c4, 0x9742e1da, 0xb7fc22f6, 
	0x807af36b, 0x623a2a3e, 0x84533ecf, 0x6fdae0f7, 0x3464667a, 0x542c56fe, 
	0xcc8d487a, 0x1d63fd47, 0xa432e5ac, 0xbf2e7acb, 0xa7db1975, 0xcfec9cb0, 
	0x92d7d821, 0xf2107c8c, 0x13683740, 0xcc723e25, 0xf9aebb24, 0xef59a987, 
	0xca045555, 0xaa5e3ee9, 0x03b7355d, 0x58e94ab9, 0x16fe45f0, 0x22fea431, 
	0x1ff0abdf, 0xf64972a6, 0x314db9a3, 0x379a238a, 0xcbc4e0e5, 0xde97ae01, 
	0x73b1d6f3, 0xb81cd9ca, 0x15ff1456, 0x1f007dd9, 0x412c77bc, 0x5b75d07b, 
	0xdf78b9d6, 0xbb153e71, 0x786ceaac, 0x6e765ef7, 0x56ac1f78, 0x9d7f76f0, 
	0x7758ede0, 0xee5b786e, 0xf41c60e7, 0x9c365e41, 0xc1427786, 0x78c47c9b, 
	0xb9642bbf, 0xf9193d63, 0xce4be420, 0x2637e70f, 0xfdf7e9c3, 0xaad5768c, 
	0x5cd3845d, 0x8f689b78, 0x7af0ab5b, 0x3bf8f8d9, 0xd360f8b3, 0x808b8e84, 
	0x79cd7af3, 0x7761d107, 0x1323b347, 0x0495e6be, 0x437c14cf, 0xc7bc1157, 
	0x95ed6f85, 0xbe08873d, 0x24efafd1, 0x42fe7ef8, 0x0e72fbe0, 0xe0a8bf3e, 
	0x9f0a72fb, 0xbca9be19, 0xe285ef82, 0x79ddaa73, 0xf0d32be0, 0x1b3c7c55, 
	0x7ec7dfae, 0xcf0a1f40, 0x02e27abf, 0xe3197384, 0x63ff4db3, 0x6fc483e8, 
	0x73d3e2a4, 0xb7f64e80, 0x556fbf8f, 0x2924ffb7, 0xca3e822e, 0x90b42f6f, 
	0xf303be0f, 0x5cf87dba, 0xf8f3f8f3, 0xc2bad560, 0xe75ce21d, 0x9cf99cc0, 
	0xb55a1fcf, 0x413136b6, 0x2fadfb4f, 0x966d73b9, 0xff42dadf, 0x4bdd8668, 
	0xc53e4a2f, 0x238ecdf3, 0x5d47c54d, 0x5967c49f, 0x9eb0f652, 0x323fb5ea, 
	0xd9593e30, 0x0c65c4c5, 0x0ece5b77, 0xe9661635, 0x9ef17a3f, 0x7d964477, 
	0xcb6f3ecc, 0xf2bfef08, 0xe83f2a77, 0x2adf0a7b, 0x1888efab, 0x3d24e714, 
	0xf3d61fe8, 0xc0b3e964, 0xf3873e97, 0x8f6215f8, 0x5838e528, 0xa6a6df05, 
	0x3acfc252, 0xc73e7b23, 0xdb3f0482, 0x20b9f5df, 0x8c149fbf, 0xa7719088, 
	0x688deb10, 0xabf0177d, 0xdeac860d, 0xdeb4f40e, 0x20f0dbd5, 0x11a0c7c8, 
	0xf03b767f, 0xd179f5af, 0xbf20dba5, 0xbb5a40a1, 0x8ad4fbe0, 0xcb3e7ba9, 
	0xf137f2f2, 0x961f6127, 0x7e4e5d4d, 0x73cf2497, 0x1cf6cfea, 0x5e7ee739, 
	0x84325da4, 0x93a60e76, 0xda4bb28b, 0x3ff697fb, 0x253b1ccb, 0x89c5a3fb, 
	0x320fb516, 0x1a6b7472, 0x5094fa6e, 0x6933e304, 0xbbe87aff, 0x91a4ec8b, 
	0x9fa2d627, 0xa2af4335, 0x9ca0af77, 0x8f3032ec, 0xd3c061bc, 0x78ff78f5, 
	0xee075abd, 0x90f4af4f, 0x248f691d, 0xf6ec2e7b, 0x37b18bec, 0x9d37181b, 
	0xd6737f35, 0xe7c20f09, 0xbf94b3d7, 0x7758f09c, 0xbb17caca, 0x9967bd78, 
	0x6f0e454f, 0x72afaf4d, 0x73c6f941, 0x8c48c7ca, 0xe26beddf, 0x6d77d872, 
	0x535fe817, 0x3e247fcb, 0x622f102f, 0x94878a1e, 0xfb5493d2, 0x3c41efed, 
	0xffb975b8, 0x2e6fac2e, 0xe5d1efc3, 0x5f015fcc, 0xe62d7ee8, 0x92f9073f, 
	0xaf74c599, 0x8a77e116, 0xffc9f6e3, 0x3bff47ee, 0xb28869c5, 0x530f1cc3, 
	0x31529476, 0xa7e738ed, 0xe9f9c9bd, 0x3e9f9c83, 0x6719f9c4, 0x58e7cf38, 
	0x04e1c900, 0x294743e5, 0x39c7e515, 0xe726fe5f, 0x5f39062b, 0x99f9c431, 
	0xe74f3867, 0x2ff2e71e, 0x0b033e32, 0xb3f04c3e, 0xe95dfdc2, 0x95accdf3, 
	0x8dd627a6, 0xf65313f7, 0x5714a9a0, 0x180316e8, 0x7077f4e7, 0x317a2af6, 
	0x3b8c2ebd, 0x665e68b1, 0xe51e7f59, 0x7e718ecb, 0x4fce09da, 0x9cd4a01b, 
	0xd3f39a7e, 0x8cfbf987, 0xb0cfce11, 0xf50f94dc, 0x8e856a53, 0xf2cd7cd1, 
	0x1f2f9c13, 0xa715efe0, 0xcc315f39, 0x708e67df, 0xf305a67e, 0xdfc00aff, 
	0xe1bcf1cf, 0xe26fe57e, 0x8c2b5678, 0x20503e72, 0x403c6196, 0x591e3aee, 
	0xd70e76ce, 0xdc73b614, 0xfc8cc709, 0x1f9275ec, 0xf2976ec3, 0xf4fb2927, 
	0x7ef9cb63, 0x9c6fcd85, 0x1f38c790, 0xcf9567e0, 0x33fe147a, 0x89ccab3f, 
	0x5afe60a3, 0xc53d7cc7, 0xaeba6ccf, 0x265f3693, 0xbbc3667e, 0xd783f717, 
	0x97f59535, 0xfa7c6eff, 0xf4f898ee, 0x2cafe5d5, 0x315af8e7, 0x6e90f88f, 
	0x5af9e3ce, 0x5eb646f3, 0x9d4cff38, 0x7e39aae3, 0x214b71d4, 0x7f3493f1, 
	0x9a3e4932, 0xbdce3e4a, 0x3ca25bbe, 0xe9d3ec72, 0x945f27bd, 0x2d3c50e3, 
	0x8039d121, 0x79de2469, 0x77be531a, 0xc5276424, 0xf7b33c4f, 0x9e4be272, 
	0xc7665146, 0xc8efdbdb, 0xf54dfbd1, 0x6fdd5c56, 0x9a570cd7, 0x934dbbaf, 
	0x424237fa, 0xf78dbe74, 0x96c622a3, 0xe28f7c16, 0x68dfad24, 0xc16e7509, 
	0x5642e7f7, 0x856fee80, 0x3ea1d77b, 0x7b03f788, 0x91dfde25, 0xd214b922, 
	0x3f6d5185, 0x8dc154e0, 0xdecadbe2, 0x16624cfa, 0x77a903e4, 0x17b43505, 
	0x12d4a4fa, 0x653109af, 0x4487db05, 0x82f57dce, 0x29f14116, 0xfbe8fba9, 
	0x67a2fdf9, 0xeea4597e, 0xf744dfb3, 0x6fde5f17, 0xd664cbdb, 0x7bf61dbb, 
	0xe145851d, 0xdf7f3815, 0x5278e97c, 0x9ef93ad0, 0x720fbaa0, 0x621ffa6a, 
	0xb427cf28, 0x061abbf2, 0xe381abbe, 0xea948bee, 0x1afbe34f, 0xaef8158e, 
	0xea4dc4c3, 0xf8478d7d, 0x43800d7d, 0xe21afbd6, 0xdf0d7ac4, 0xafffed39, 
	0x53bd2929, 0xa3aa83bd, 0xc15def4e, 0x4c6f39f1, 0xff017f86, 0x5e50b5dd, 
	0xf0d285a1, 0xdbf1fb27, 0x9eb03e6a, 0xcae6b9bc, 0xdde73958, 0x73fde925, 
	0xbad52d0e, 0x301a41d6, 0x0cf6eeb5, 0x5bdcf5bb, 0xbe61c656, 0x3a1c60b3, 
	0x0b9fa03f, 0x66bce9d6, 0x7f7c2ad3, 0xaf4e3525, 0x2187c9a5, 0xff64590d, 
	0x6416abcd, 0x6c5671cf, 0xf184955a, 0x69e48ede, 0xf18c9eee, 0x49ce5ca0, 
	0x14e18fbf, 0x8847ba5e, 0x62fc86fb, 0x13e60ad2, 0x096e2ef4, 0xbf14adfa, 
	0xbd5d0a4d, 0xd8f6cb3f, 0x6b7b2090, 0x21da3bea, 0x3a8fe43c, 0xa9a8f184, 
	0x8ba083b8, 0x172138fd, 0xc2f1b7d5, 0xf6ecf7d6, 0x75ae2ed0, 0xe9ddf7a5, 
	0x27be1a13, 0x3a8509ec, 0x1aa8e2e9, 0x3e8a13d7, 0xc73345a4, 0x88787985, 
	0x9ef5749e, 0x65f78698, 0xfdd33e41, 0xd02f6859, 0xfb8f5ade, 0xa7b61bf5, 
	0x27a01c60, 0xd291fd12, 0x6f7a341b, 0x3df64273, 0x0e3fd05e, 0x593ebe91, 
	0xf17bbd66, 0xce310029, 0x3e3c591f, 0x2e0c17f8, 0xc5e8e572, 0x190718e5, 
	0xb736b91c, 0x990f153c, 0x94349729, 0x3e872c4b, 0x30ba5ca6, 0xfc5228be, 
	0x428f8650, 0x5f77e57a, 0xd3015572, 0x4bdef85a, 0x11751f74, 0x001d51e8, 
	0x3eb3bd97, 0x7b7887df, 0xe7bf0145, 0x75dea552, 0x75b3f1b1, 0x3107fb05, 
	0xa8ef38c5, 0x6ed0784f, 0xe62fd7bc, 0x778afbe0, 0x83dd1e21, 0x1664f870, 
	0xdf6efe1c, 0xf517b89c, 0xe4bba160, 0xefa7c883, 0x64e7815e, 0xd6466f9b, 
	0xf7fa4d5c, 0x203f9bbc, 0xe591d87f, 0x5c60569b, 0x5d59e820, 0x8a832ef4, 
	0x4f9f1de7, 0x84dc5db3, 0xefc586f3, 0x19c5643d, 0xb966ff8a, 0x51e47224, 
	0x5cedfeae, 0x37f130fe, 0x93cb0d47, 0x0c103756, 0xcbcafbc8, 0x8cf47e41, 
	0x8fa8a70f, 0xbd6c30e3, 0x748dd708, 0xf482fa04, 0x7fe75fb2, 0xcb9dfac4, 
	0x96315f9f, 0x14db9e5c, 0xfdfdc52b, 0x73d1ca1c, 0x9d85efee, 0xfa569e63, 
	0x7d67c08e, 0xaebf8463, 0x8f1a317d, 0x0d510dcf, 0x5fe234ef, 0x972a19de, 
	0xcd296779, 0xff15578e, 0xe987f163, 0x4bc77ab7, 0xfa2c1f6e, 0xdabb5f13, 
	0xe3e3e86d, 0x8fdd4f87, 0x557ba9f2, 0xaecf3c36, 0x19deff60, 0x1143c745, 
	0x2f7f7f15, 0x14ee3fbf, 0x2f0879fd, 0xba2e14bf, 0xbcca694f, 0x354cfbac, 
	0x16acefd9, 0x15c9bc3e, 0xef144981, 0x9fb85cb1, 0xd277e99a, 0x74c4af39, 
	0x947ffbaa, 0x5df8f1c7, 0x27ca8b16, 0x74799ab4, 0x23f3e9cf, 0xb4b1d579, 
	0xf3f89bdd, 0xb847b432, 0x67f7ceb3, 0x7e417f15, 0xa22cf74f, 0x02e50f32, 
	0x1f7e7df2, 0x80e7e388, 0x845d906f, 0x175bf9f8, 0xaf973f1e, 0xc9a1dbf4, 
	0xf10172d9, 0xbf63f480, 0xb294f5b0, 0x86b07bac, 0x8e61bdf5, 0x97c1cf93, 
	0xf1fcff3f, 0xb9c4f071, 0xe992b43c, 0xb2a5f18d, 0xf14a163a, 0xd5738c91, 
	0xfdf3c86c, 0x73e1e96d, 0xf43df580, 0x66be5563, 0x513a204d, 0x9e785371, 
	0xc13f2008, 0xec31a938, 0x7ed71f6c, 0xc0bdae30, 0x7e817b62, 0x6533c715, 
	0xa53fabc4, 0x739df7f6, 0x89c6d7da, 0x7188da6f, 0x6da7a00a, 0x047871ac, 
	0xe0f4ef8d, 0x171b03fb, 0xbd41e13e, 0x1c95baf3, 0x2731b02f, 0x9e5530ce, 
	0x2a986713, 0x338ec637, 0x23b67f5c, 0xe649f1c8, 0x74caf123, 0xba8ed73e, 
	0x7127153e, 0x1bfbc698, 0x54faefd5, 0x342bc49c, 0x83c3fc1e, 0x8efc5676, 
	0x0deb0071, 0xa2c93e3b, 0xc2e752f1, 0x4bdb839a, 0x558d31ea, 0xf9862bcf, 
	0xe30259b5, 0xc9b7d616, 0xcf126de2, 0x3017ce8d, 0x9b63616e, 0xc6289a3c, 
	0x5b61b172, 0xdf84bcc6, 0xaaba42ea, 0xfcc389cc, 0x65579aa2, 0xe5527c0e, 
	0x9549f039, 0x0d9f038f, 0x15ca3b67, 0x5ed5be7c, 0xc2e7ce99, 0x7e3a4367, 
	0xc5e38bcb, 0xe61c7257, 0x96fc7486, 0xbc23e197, 0x8efc1f08, 0x521b9871, 
	0x2cde11f0, 0x3be598f8, 0x6c23ae31, 0xf844aec6, 0x7a59b654, 0x4367c017, 
	0x1b7bb45b, 0xa2f4e375, 0xd6361dfe, 0xdb2a9c13, 0x62ae82e4, 0xc1656efc, 
	0x1e1cf729, 0xf9172fae, 0x95eefeb0, 0x5d9d6fec, 0x1f4ff7c4, 0x9a76c55d, 
	0x557e785c, 0x9e1723ad, 0x781cf2a9, 0x81c7caa6, 0xe359e967, 0x6ad71c93, 
	0x953f377a, 0x37cee7ce, 0xe0968e23, 0x37eaacf9, 0x0b368e23, 0x782acf9e, 
	0x64e3a696, 0xdf59e1b2, 0x1aaa71b7, 0x6c310907, 0x4e617c1e, 0x244dc12d, 
	0x5ab3c624, 0x18b83d8f, 0x9f1269d2, 0xbea510af, 0xff409fdb, 0x9c736943, 
	0x81a50ffc, 0x8f1fce0a, 0xb4b479d1, 0xebb7ba2c, 0x1df94c15, 0xb59f529b, 
	0xebaf1b64, 0x27802dc3, 0x4f5ee1a5, 0x4b579c37, 0xbb3a2beb, 0x3c7d313a, 
	0xa40967bf, 0x4f9c8755, 0x29ddf818, 0xd2b25df0, 0xbbfb9380, 0xea09f073, 
	0xee0eceef, 0x752bf0ef, 0xb7cc660f, 0x65bc6174, 0xd0fe565b, 0x2e3e78b3, 
	0xaff352ad, 0xf9a3ee8a, 0xe972f3a9, 0x44ffb58b, 0xf3559fdf, 0xa75f966d, 
	0xad526dfc, 0x577afcc7, 0xeb72a63d, 0xa53780f3, 0x7d33c40b, 0xc476900d, 
	0x3d011e06, 0xf2cbf4b8, 0xf5e09eaf, 0xeb8adf2c, 0x74f7d5d9, 0x7eb0f7df, 
	0xd59fbf9c, 0xfc03ed9e, 0x3b1a3d2c, 0x1fdb15b6, 0x1ef5f83d, 0x3b1cbfcc, 
	0x07c3f941, 0x9f5df08b, 0xbee2dbd2, 0x948e40c7, 0xefe43cae, 0x19e7157d, 
	0xc3cb6f77, 0xc41ecc71, 0xf25dd2db, 0xbdbf8d28, 0xc71ba7b6, 0xa51fb5f7, 
	0xfa1e8ffe, 0x5efc3ea7, 0x15ba3f1f, 0x9d0f87f3, 0x3c2e7825, 0xc106fce5, 
	0xda2cfdb3, 0xa70d4a03, 0x603fc77b, 0xff0da73b, 0xc12544a2, 0x7df48feb, 
	0xcf6de6e1, 0xcdfc71c7, 0x17bfa38f, 0xc19e6bd2, 0xb25c6ef1, 0x6648db74, 
	0xee1f43fd, 0x0b4ef9c4, 0x4d9d77e5, 0x5fbe1bc3, 0xffdf09de, 0xdf8bf019, 
	0x2ee9b19b, 0x94fe9e9b, 0x05eb27a2, 0x1e0393b4, 0x383d7735, 0x69d29fba, 
	0x1fbfbfbd, 0xdd6160f1, 0x086dedd6, 0x96ff454f, 0xd5fc60f4, 0xaf7c55a4, 
	0xe5c98df4, 0x142ec8ab, 0x4dfc95b9, 0x92956a62, 0x2a6fec47, 0x7f221e3d, 
	0x8d2ee953, 0x9e969fdb, 0x1cbed55e, 0xa2906aed, 0xc76a59be, 0xfe83ed2d, 
	0xa7fdd27b, 0x32702fbe, 0xcf4bf4bd, 0x4e53d43e, 0xb489fba4, 0xeb7a4a72, 
	0x50c3907e, 0xe0a55e1e, 0x56ba0210, 0x701ec8f5, 0xa9feed80, 0x9fae31fc, 
	0x7ce70fca, 0x3ef9c81f, 0x785cf9c2, 0xf9e77e81, 0x95c55c61, 0xcd993f33, 
	0x7ae59a72, 0xf74e5c38, 0xaa62c3be, 0xeb96c078, 0xcb1a6ef4, 0x683fb0f9, 
	0xecab58ec, 0xfc7299dd, 0x5feced02, 0x67bf0b76, 0x6b8fbe90, 0xf3c03f67, 
	0x1e97bac9, 0x76ced50e, 0xe291fdb3, 0xced42f29, 0xbbfebb9e, 0x24d7786c, 
	0xeaa57e09, 0x983d043d, 0x67b97c24, 0x5ab7db15, 0xef54fded, 0x04c68977, 
	0xefa8f7ed, 0x7c54d65f, 0x47b3c27e, 0x97f9477d, 0xe09dc71a, 0x6ae81671, 
	0xe3d8c49c, 0x45dfccbc, 0xbfb3d275, 0x5fa3db84, 0x8f7efed5, 0x27f74fea, 
	0xfd535f69, 0x3b7fb9fb, 0x1978e3af, 0x4e7f75df, 0x54fd705e, 0xefeca17f, 
	0x9eec5fb6, 0x7be73e54, 0xefa9f390, 0x45f1eca1, 0xf6f7e790, 0x683d87dc, 
	0xd7bdcb6f, 0xc6ab8ff1, 0x2a91d7be, 0xf07f91cf, 0x7e0ffa47, 0x4327fd47, 
	0x3feb651e, 0x53b6d386, 0x9aff1079, 0xcbcf82c3, 0xfde127a0, 0x98ab2dcc, 
	0xa646549f, 0xe70cfd90, 0xf0ddf787, 0x52fbda3b, 0x567c3ff7, 0xf9176c67, 
	0x8ddb9e63, 0x79b7c77c, 0x3be436f5, 0x117edf2b, 0x9b4b90e3, 0x0c1f283b, 
	0x853dddb2, 0x9d0e381f, 0xac4eac7f, 0x5fda90f7, 0xafd03c7b, 0xd4ce313a, 
	0xb95bcf2e, 0x15da157b, 0x62b53d6d, 0xf959c3e5, 0xe11fc88d, 0xbe7eb3fc, 
	0xe54413c3, 0x59fa083b, 0x5819eb0f, 0x552ae1be, 0x2dbd621e, 0x3a2e5d5c, 
	0x624e905b, 0x34fb822e, 0xdb8c21f3, 0xdedffc05, 0xfdfa3c5d, 0x3c3fda19, 
	0xa0ec8d5f, 0xedcbb2fd, 0x0fd04373, 0x38021beb, 0x88a7dda2, 0xcbc223f9, 
	0x06272c38, 0xa79ec806, 0xf9ea7fa1, 0xf49db655, 0xfbafe679, 0xa8f14d3f, 
	0x09f33eeb, 0x090a6f8e, 0x1bedea2f, 0x7e037ded, 0x2364f68b, 0xb9bb70ec, 
	0x97ed1d1f, 0xf6c55adf, 0xc32637a6, 0xb35ef0bf, 0xf4f897bc, 0x88f86fa5, 
	0x069c6c7f, 0xac2771fc, 0x471d902f, 0xf61af53a, 0x76bc6d83, 0xe005b7aa, 
	0x7ea7f53f, 0x25cf05bd, 0x5ad2eec7, 0x83f07da0, 0x639f94b2, 0xbc3ffa80, 
	0x428f652a, 0x6bc4d6bb, 0x6dbbe0e7, 0x9b7c66eb, 0xf3cd63ec, 0x861b9daf, 
	0x6fa2c374, 0x8ef2adcf, 0x01f7673e, 0x4e2c246e, 0xbed83df1, 0xeb7fac7b, 
	0xbf298c5a, 0x6cd7db0f, 0xc5ca1bfe, 0xf27966be, 0xbef700cb, 0xbb97ccdb, 
	0x75f7ce41, 0x378893c8, 0xa3d61d7d, 0xfc9cb02f, 0x47e00ed2, 0xca620d55, 
	0x20ab906e, 0xe03c77fb, 0x13fa34c7, 0x5efa3bd4, 0x1ab6f894, 0xf7d3bda4, 
	0xdbef9c80, 0x63b7256b, 0xf2cdc7ff, 0x5a9825ae, 0x7be067fe, 0x539f21b3, 
	0xadeef772, 0x7bebc870, 0x8a2ef533, 0x1af1df07, 0xbdb6355e, 0x46be345e, 
	0x671bbaf9, 0x334f7e71, 0x753fe7d9, 0x2fbf61b5, 0xb3bd67ab, 0x2beddead, 
	0x0d61ba2c, 0xa5f5379e, 0x42f4692f, 0x238cc44e, 0x58d39f5f, 0xc3cdefcb, 
	0xf9e51239, 0xac8fcbd3, 0x33e33846, 0xbcdefc7d, 0x0f7eff69, 0xfda25dc5, 
	0x9a716319, 0xb0373f94, 0x45261629, 0x080bdd4a, 0xa05daa6c, 0x70d337ec, 
	0xf448811e, 0x52bbcc3a, 0x9a736176, 0x6b8e4f3a, 0xe74b3997, 0xc7b58bec, 
	0x6cf7fb64, 0xb5705ebf, 0xc2b3e7ed, 0x37859f38, 0x0c624d08, 0x7b64d062, 
	0xca0690b9, 0x5d6ac6a5, 0x21a9bbd1, 0xc21db1fc, 0x0e5da97f, 0xe12ae870, 
	0x59b9de94, 0x64d3f4cd, 0xbe0e15cc, 0x65f5a63f, 0x806735f0, 0xaab3b4e5, 
	0xcfda20f7, 0xbfd9659d, 0xd599f72f, 0x51b9d76c, 0x633df6a5, 0xe10c4f98, 
	0x9ae5b4d8, 0x2fb03c57, 0x7158d743, 0xae3cbdef, 0x9cdefa01, 0xab6f4cd5, 
	0x065f609a, 0x62b7deb0, 0x986e1e78, 0x1889e968, 0x3a447bec, 0x023ff7f0, 
	0x999c8b03, 0xfbd978ef, 0x14bf3f89, 0xb2c42bdf, 0xd88749e4, 0x24f7fb48, 
	0x3f6d9fed, 0x168f1931, 0x72469937, 0xc6efbe80, 0x476fcb7b, 0xaef81a96, 
	0x8ee0606e, 0xe7efd11f, 0xc85d104d, 0x1ebbafa7, 0x777041e6, 0x3fc5bd93, 
	0xdaf4f189, 0x04c4f59f, 0x684339db, 0xdef45ce7, 0x32485a07, 0x2c3ee33e, 
	0x88eb8a6f, 0xbea76677, 0x5f940178, 0x76a5fc5f, 0xc1b9b77c, 0x1e2a196d, 
	0xd4e2a9c4, 0x9efcc39d, 0x7b31fb01, 0xa63f2a4f, 0xf4fd8659, 0x7946590a, 
	0x3b632add, 0xf652ee96, 0x46b0d70d, 0xa508de69, 0x9ddb1e56, 0x8083bfd3, 
	0x1bd8ddfd, 0xf2fea177, 0xba1f45e9, 0x1aef006a, 0xe666baaf, 0xcfb43c82, 
	0xbe46acb4, 0xbe2feb78, 0xf6a5fc45, 0x95c77ebe, 0xdd49aad0, 0x0f540eaf, 
	0x94c685dc, 0x478c89a6, 0xa4be5b4d, 0x3fbc3c79, 0x6a6b3f68, 0x25aa3af7, 
	0xe28c7fed, 0x3fb6220b, 0x607f22d0, 0x9e4efd93, 0x90113fba, 0x0bbf49c2, 
	0xf9847487, 0x333a4f91, 0x9d4df3ed, 0x9ef03b97, 0x97baa07d, 0xe3522de2, 
	0x51e38438, 0xd262271c, 0x89dca5ef, 0xa6bef4e5, 0x74bcf449, 0x9e88e7c5, 
	0xf28eb245, 0x35df543f, 0x29fae8b7, 0x159dfbf4, 0xca356bff, 0x07f01baf, 
	0xacff485e, 0x6a367d23, 0xa037e4e8, 0xfed3d23c, 0x00d78e3a, 0x07bfcd56, 
	0x77e54e62, 0xc7941237, 0xd81efcf6, 0xbeff0cff, 0xe8cc3973, 0x403e6977, 
	0xd6a25ff4, 0x93d74ad9, 0xdf61cfc8, 0x6befb56f, 0xfd9abd3e, 0xcffab96d, 
	0x73ab5657, 0x93fe8e77, 0xff471f2a, 0xe739efc1, 0xaa7fd271, 0x2777f88a, 
	0xca29def1, 0xa9dfb455, 0xbc1e1e7b, 0xe2a4ff6f, 0x447eb62f, 0xd5584b7a, 
	0xc3bd41ef, 0xdcfc8d5a, 0x22b327e6, 0xaf283d07, 0x985fdc2d, 0xdefdb34f, 
	0xf52e90bf, 0xf78b8a3e, 0xde71e44d, 0xb37cc3cc, 0x4cc8179a, 0x1fdd8f9a, 
	0xe7f683f6, 0xe6fc517f, 0x3f0ad5a5, 0x9bcf76ac, 0x83f98cf1, 0xe9fd62bc, 
	0x4bde0f55, 0xbe6af6f9, 0x52f97d97, 0x9ecef08b, 0xad931bcf, 0xd467acd5, 
	0x62719e91, 0x1ceb2ba6, 0x90aeb557, 0x76b971ce, 0x3f11a0cb, 0xc9197bb1, 
	0x8a07decb, 0x5b75cb47, 0xc6c0fd6e, 0xa9bf857b, 0xbfe72b7c, 0xcd28e2b8, 
	0xfbe78527, 0x1591fcb9, 0xb7fc27df, 0x387ae1eb, 0xe2b19e15, 0xb9d52b6f, 
	0x1e5bce03, 0xde8317f4, 0xe83d41e6, 0x562765bd, 0x777fa1bb, 0x490f32c0, 
	0x1c566f82, 0xb5aaacde, 0x01382352, 0xa3141acb, 0xde804f7e, 0x26f1c13f, 
	0x6f535fb0, 0xffe6bf64, 0xe68a7e5e, 0xf6756c77, 0x872e27bc, 0xd7a6df92, 
	0x555bdf4b, 0x991a2d7e, 0x0fbc44e5, 0x25725613, 0xfaf3aa95, 0xdebf0a87, 
	0xf606b487, 0x0e4a0fe7, 0xfad8fdd9, 0x6e47385a, 0xbe7450ad, 0xfd764d74, 
	0x108d57a7, 0x11ac977c, 0x85c479f6, 0x87adaf7a, 0xba61ae56, 0x9fd57a7a, 
	0xbe9a5ea8, 0xe51d1336, 0x5f3dc9af, 0xa51d1074, 0xd5f453ca, 0x653f5d9e, 
	0xa7cc935f, 0x425e1ed0, 0x94d7e3f6, 0x89b3ed7d, 0xb9f3a5af, 0xfb5cb5f6, 
	0xd30d7071, 0xd8fdae73, 0x1efc67a6, 0x8bd0cd6c, 0x9533ce73, 0x68a7ed21, 
	0xc50cacaf, 0x41f4b99e, 0x1efda7b2, 0x6d8dbef5, 0x24dbedbd, 0xe7dc13f3, 
	0x77c9e34a, 0x6969def1, 0x9fbdec9b, 0xbfe6beec, 0x7e631b6f, 0xca9c6a95, 
	0xdfc8b970, 0xfbc6f0cd, 0xf9b69f26, 0x9de9f218, 0x42a37be9, 0xf68363bd, 
	0x99ae757a, 0xa9f9748d, 0x62fba935, 0xc7102f64, 0x3eea225a, 0xfce2e44e, 
	0xbcf7d900, 0x2f02e373, 0xe36fced4, 0xf180734d, 0xcf06f103, 0x1d87a579, 
	0x50b85e36, 0xd472c30f, 0x1bf652c3, 0x3ec39437, 0x963caed5, 0xc73a0ba6, 
	0x71c358ac, 0x7f13d797, 0xa65470e9, 0x4480cbf8, 0x26b95bbc, 0x9b828e8b, 
	0x4f113f09, 0x0fcc6287, 0x35f14e31, 0x13e23bfb, 0x8ace73ac, 0xf50f7c9f, 
	0x513f1494, 0x67eec6fc, 0x9d3b4d63, 0x70e372db, 0xeaff40dd, 0xbfbd18fe, 
	0xdea09ce0, 0x7f8f3a25, 0xe707e6dc, 0x546637bb, 0xae3ee8bb, 0x2644ba61, 
	0xd15bbedf, 0x111a9da5, 0x69ef87ae, 0xd3de7226, 0xfd823944, 0xce477be1, 
	0x477abf61, 0xb517df93, 0xd9bcd1df, 0x931ae7a6, 0xbdcfcbde, 0xe79f64ff, 
	0xf8e64c66, 0xe6df3b1c, 0xbccdafac, 0x0bdf650f, 0x572fbfb4, 0xfe7630f1, 
	0xbac7c763, 0x147fa607, 0x7ffbf8bb, 0xd49977a9, 0x81713d7d, 0x7f6d01f7, 
	0xfb253eae, 0x24db64be, 0xba9e9efb, 0xefc35eff, 0x626eae82, 0xefa3fe3c, 
	0xff906b2b, 0xc33e5045, 0xf4dbdffa, 0xe3cf1b9a, 0xdfec6bbd, 0x3bf73913, 
	0xefc7224d, 0x8b46f74d, 0xd6561ee8, 0x37b7823b, 0xa73fbd31, 0xf7fce0f0, 
	0xf7daccc9, 0x5f9f4f01, 0x1823bf63, 0xc4b1fdaa, 0xf69664fb, 0x13de1d50, 
	0xb87d6deb, 0xc4b1c718, 0x956e7443, 0x35f1d9bf, 0x2771e72c, 0xc4dfb134, 
	0xbe75d6a9, 0x555efd77, 0xdf73faf3, 0x02bb6bf5, 0xed127ce0, 0xbf1a0310, 
	0xb0056d7f, 0x7b60d77f, 0xd0407f81, 0xd27e47bb, 0x3c1e39b7, 0xcef2c4da, 
	0xdea6873e, 0x0f79cbfb, 0xb27df729, 0x76e1ae9f, 0x7efbee7f, 0x19ee3b4e, 
	0x4f947af4, 0xd9fbefb9, 0x15ea1af0, 0xfd30ef59, 0xd403e156, 0x05e28d7f, 
	0xb5621f61, 0x7edef1a3, 0xd15c2b1f, 0x59c618fd, 0xef4b1a81, 0x9e8ac2c6, 
	0xdf1d7d40, 0xfc862bef, 0xb9fd6ad5, 0x7e8df8ef, 0x893acf9f, 0xeacafce7, 
	0x63ea3958, 0x7dd5cd46, 0xab5fa865, 0xf0f333f7, 0xa3839d1d, 0xbeae5df9, 
	0x99dfbf63, 0xf3f5c557, 0x5efd8e16, 0xa1befa5e, 0xffbb618c, 0xd477330f, 
	0x000000a4, 0x0001b141, 0x5cdd9c78, 0xd554740b, 0x64cffeb9, 0x31330c92, 
	0x04c03c99, 0x09226b22, 0xe8664999, 0xd60d4204, 0xea913396, 0x806582c8, 
	0x75d610bc, 0xd702ad42, 0x857a88d6, 0x21339636, 0x27541e40, 0xd2d62028, 
	0x5ea8be20, 0xa1f6f56f, 0x4eaef7bd, 0xb6a0ada8, 0x72cb2d17, 0x2036aeaf, 
	0x36d36c58, 0xa446dad8, 0x7d8ffef5, 0x04932666, 0x597b4912, 0x71d72d65, 
	0x3ecfb39f, 0xefeff1fb, 0xdfeffeff, 0xe119b013, 0x8f806ec8, 0x8d96dff0, 
	0x90fe8500, 0x35e14e13, 0x1d36d0cf, 0xe1f8d807, 0x01d0ad8a, 0x0d9b4060, 
	0xaf77deb0, 0x80349807, 0x2c0d7ce5, 0xa9deb193, 0x1bcde9f9, 0xd1fafe00, 
	0x015a307c, 0x4e07a6c0, 0xd37bd137, 0x010f9b7a, 0x3b6064b4, 0xe3cf0039, 
	0xaf7c0e7b, 0xf181b0df, 0xc37f7c73, 0x60683851, 0x0dcb1db9, 0xde0d5ef8, 
	0x1c2a72c3, 0xfbe0699c, 0xe30cfa00, 0x331aba3a, 0xe88003e1, 0xd8181746, 
	0x74c0880f, 0x4d7e1b2a, 0xcb9d4eca, 0xfb94a8ae, 0xbd3da407, 0x1aed0226, 
	0xd9df57c0, 0xbc210594, 0xda5b054e, 0x3cd600b3, 0x00c7c2d0, 0xb2386eba, 
	0x68012615, 0x638d383a, 0x38d38edc, 0xbe73dfc4, 0x985746da, 0x9bdb0279, 
	0xa285ff39, 0xb1401b42, 0x1eb9b20d, 0x1eaad9e8, 0x37e07b97, 0x3b4fd4d9, 
	0xbf53a744, 0xf7baca4b, 0x492f3e00, 0xdf3fa635, 0x33a2f54e, 0x09c59ea8, 
	0xa5eb0033, 0xe9be82a6, 0x3dce58f3, 0x6bcd0efa, 0x3f0f53bf, 0x2bf34f50, 
	0xd0eb99ff, 0x9101df9f, 0xe5e7c79f, 0xda7f3847, 0x27cf899d, 0xbcc27b41, 
	0xf7e17cf1, 0x292470bb, 0xd5e7c537, 0x14408868, 0xe66f3fce, 0xf09e78f8, 
	0xe6cb6fda, 0x8f38a3f7, 0xecfda507, 0xde3556a3, 0x1c5e3526, 0xfef1714f, 
	0x3cadeee9, 0xe2ce331f, 0xcc572d78, 0xf38f919b, 0x2fec07f5, 0xb4a011fc, 
	0x23945a34, 0x8c3c70f3, 0x0252d3f6, 0x01db4d81, 0xf62353be, 0x1f26ff80, 
	0x4fefccd9, 0x30af8b7e, 0xa79484e5, 0xd2f94bf4, 0xd2f94a3f, 0x7fce52b3, 
	0xf3970b71, 0x142be55f, 0xc172911c, 0x7a9e525b, 0xfb53ca42, 0x8fed3ca5, 
	0x1b4e8d7c, 0x89e16bc4, 0x23f5d81e, 0xfbd76fb2, 0xf5c9def7, 0x6a57ea34, 
	0xd76cf46a, 0xce671e7a, 0xfb00a57d, 0xc0d53782, 0x5cefec69, 0x03ee2fec, 
	0xa69f716b, 0x18d4bda1, 0xfce01aad, 0xba6c4fb8, 0xf347d9c4, 0x0fce7908, 
	0x180b3de8, 0x387bfcf8, 0x3e335b2e, 0x75a2b9c7, 0xd1e6efc6, 0x469c5afc, 
	0x2dbce01e, 0xf9a007cb, 0x79d5aa85, 0x6ebaff34, 0x44bef7e5, 0xe7e3adef, 
	0xd7b434d1, 0xce1c1b06, 0x7fefc4a9, 0x0abfbf16, 0x8ffabfaf, 0xf7fbe887, 
	0x80ae7ff4, 0x5dcf8fbe, 0xff2c09da, 0x3a6f37f6, 0xe3dcb89b, 0x4f4f75c4, 
	0x49d36303, 0x30f687de, 0x68ceb7d6, 0xf589c87c, 0xe7a06deb, 0xdf71cf9a, 
	0xef00f7f6, 0xd8a34b43, 0xb235fdcf, 0x4bfeb1af, 0x2f35bed4, 0x580385aa, 
	0x5b70f40f, 0xeb0e8d3d, 0x067ed1b5, 0xf8afd68d, 0xf43deef2, 0x3f7805dd, 
	0xdbcf04fb, 0x6263eebe, 0xee58b97f, 0x6c90f351, 0x0aedc387, 0x9bdf02ed, 
	0xd1170fe9, 0xcd56b0fe, 0xf6885bdb, 0x0ff5e772, 0xd4edc0d4, 0x764a346c, 
	0x98e8be99, 0xe07f61a6, 0x79a07ce8, 0xe80de18b, 0x4e3f8800, 0x8211e643, 
	0xd2f6a510, 0xbd5eb8bd, 0x642abd78, 0xddf80568, 0x6e3076b4, 0xdb047ec4, 
	0xfb2acda1, 0xbe2f9a09, 0x00eb437d, 0x37df0e77, 0xefa22785, 0xd92cfcef, 
	0xaeb6f46d, 0xf6bb73df, 0x67ad0170, 0xed93b8b4, 0x7b69c8d6, 0xe558cb12, 
	0xbeebb728, 0xe539fa8c, 0x979e428d, 0x6b7a726b, 0xfdbc7de0, 0x7f728dfc, 
	0xffb9a7c7, 0xf0f02965, 0xcd1fae36, 0xf8014c1c, 0xe7d89554, 0xbc14ae67, 
	0xa4ccec44, 0xe27025f9, 0x7235b5f9, 0xe769c0d9, 0x8b3d00f9, 0x3cbad5ca, 
	0x991bf34f, 0x0ed83f64, 0x9bb631db, 0x38229035, 0x08c6f6d7, 0x111cd738, 
	0x1d8a0ffc, 0x19d5ccb6, 0x44df681f, 0x9f690ec8, 0xb3ef8685, 0xb2fb2adf, 
	0xa93b3ed2, 0xf0d155f6, 0xefb0957d, 0xd0ef3fb8, 0xafb4037b, 0xb4d7de74, 
	0x6ac52ccf, 0xabee257f, 0x7de33ef8, 0xe70cfbc5, 0x9df84adb, 0xa77ebfb0, 
	0x3f792bd6, 0x733bef25, 0xd3c15cbd, 0xd5100eb2, 0xb2d75c0c, 0xddebb45a, 
	0xec88fe5c, 0xd90de3c3, 0x67cf6ec9, 0x7d45b6e7, 0xaef10ffa, 0x88d35167, 
	0x5932ddf6, 0xd3df0370, 0x05509fa8, 0x97fb738c, 0x79c73ee0, 0x960330fb, 
	0xd372fed0, 0xfc007678, 0x364bfd7e, 0x514f3e27, 0xab8ec7cf, 0x8cb3b4c6, 
	0x3f2760ab, 0x5727985f, 0xb8bf7d73, 0xed8cfb14, 0x79912de5, 0xc3789cbf, 
	0xe1bce18e, 0x7b3b5fb2, 0x6d17099b, 0xfe8d3810, 0x6fd63273, 0x5d587ea6, 
	0xd2f1d781, 0x719d1792, 0xdfb5356f, 0x03fb7b33, 0xff59be58, 0xfbb176c2, 
	0xf7681d85, 0x66999d97, 0xf56f1858, 0xfaa762ad, 0xe6bc21d6, 0xb06bc994, 
	0x9af0237f, 0xd1ee3552, 0x99f30d78, 0xdcb5fe84, 0x1dfa382c, 0xe6572f7c, 
	0xdb1074ab, 0xa5a2850b, 0x6ea25fc2, 0xa5ede7da, 0x09d0a52d, 0x168af9b0, 
	0xe58ecdb7, 0xe4f2afeb, 0xe1abb5e1, 0xaf1f27ac, 0x3357a32e, 0x75aac8fa, 
	0x7d3bf507, 0xad1a07f0, 0x7e2de33b, 0xd837e7d7, 0x2b40b8df, 0xada6fea3, 
	0x24f5a0d7, 0xc8d9a7bd, 0xdbbf70ce, 0x2cff58fc, 0xf6a2d3f5, 0xf47baf0f, 
	0x799fd932, 0x4c9bb24e, 0x931bec8b, 0x8f1be97f, 0xb441be0a, 0x6eebf084, 
	0xe15297e5, 0xeb2a32e5, 0x907e53ae, 0xef19777d, 0xff64d07f, 0x597337e7, 
	0xfdcd580f, 0xd5cfcc5f, 0x5c2307fe, 0x81af8436, 0xabef2e51, 0xf80abbef, 
	0x7fe251fb, 0xc8f5d764, 0xfbf89abb, 0x7f842f0a, 0xcb8dd259, 0x8a303db8, 
	0xa076e55f, 0x57b488e4, 0x9ddf27d2, 0x479f8a79, 0x72740e67, 0x5e2cfcb9, 
	0xc33b239f, 0x5f3458fd, 0x7843db2f, 0x1f0fabf2, 0xbe43f9a3, 0x4eb86bf5, 
	0x97be8570, 0xe342b886, 0x3a7e534b, 0x33881f86, 0xc64dfd89, 0xff6a6693, 
	0x72b8e1bd, 0x3c8278e1, 0x6e3863a4, 0xfc11f3f0, 0x8992c775, 0x2c0fd7f5, 
	0x1d7f30b9, 0xe295d3f3, 0x4fca2777, 0x99fe6c5f, 0xff247de6, 0xb1e4e30c, 
	0x8fc4b384, 0xa367c621, 0x4f0507f9, 0xa9ada719, 0xd7e52afa, 0x11b9740f, 
	0xbf1fc807, 0xc0ead78b, 0xa7db0b62, 0x630b533f, 0x62d36179, 0xd75e2f6d, 
	0x0484c92e, 0x81fb73bc, 0xdb6aac71, 0x11d9483c, 0x32dcffbf, 0x746de3c1, 
	0xf7df881d, 0x6c592f55, 0x5aaffb41, 0x6ffae1e9, 0x381cff62, 0xd806774e, 
	0xbe7a11c3, 0xc1e6b17c, 0x4375bbf9, 0xef245193, 0xd9ef413d, 0xea22b710, 
	0x3f78fefe, 0x81dba5c1, 0xaf1e75fd, 0xb6756783, 0xf5835b55, 0xe033ce16, 
	0xe113420d, 0x9ad5fd01, 0x587ae161, 0xbfdfc71f, 0xbe3ccb14, 0xb0d21da8, 
	0xeb2ccabc, 0x33af2e0e, 0x541d47eb, 0xd9bfecdf, 0x8f0997ef, 0x731b5c71, 
	0xee0b0eac, 0x6f5b774b, 0x7b85d5a6, 0x436fdf1c, 0xd4acf59c, 0xc1b17032, 
	0x8f6fd563, 0x0bcf88bc, 0xcbdf2c7b, 0x7cdfbc43, 0x952736ec, 0xeed27b2b, 
	0x8b3df2c3, 0x83935f6f, 0xf522b60e, 0x80313411, 0x9856f9b9, 0xff21ebca, 
	0x284ceca8, 0xe0ad3a57, 0x77ff941f, 0xe05ef419, 0x8c839de5, 0x9610969a, 
	0xbc0eace7, 0xca5eb65e, 0x9c0d65c0, 0x67f7f183, 0x5faf0287, 0xbfdf509e, 
	0x5ee97f59, 0xff7c6e7e, 0x3da927be, 0x2f9da3ed, 0x6ddcfdf3, 0x9cbf7c39, 
	0x2db7daec, 0xfc7d0190, 0x679fc63d, 0x1c25e830, 0x8cba38c3, 0xe1ca99ec, 
	0xd723e090, 0x2bd7007f, 0xc10fefc8, 0xde8c67e9, 0xfdeb0d56, 0xc359a1ab, 
	0xfc9f3b68, 0x62b2bcc1, 0xf2764ff4, 0xd92712df, 0x1c714d23, 0xe5a3f9f5, 
	0x975939f0, 0xb9e7ee08, 0xaf60bc4f, 0x6d69d044, 0xec16ecd6, 0xf733c6cf, 
	0xd5fc937f, 0xbb01f5a6, 0xe01fbf95, 0x3abdc838, 0x7fb0b0e0, 0x0708f234, 
	0xbb61353c, 0x896ae395, 0x19931093, 0xd27f4d6f, 0x276e96d2, 0xad5be67f, 
	0x5ebc5395, 0x4e54db56, 0x3b8f697c, 0x5cdbed9d, 0x152c9fff, 0xd943bafc, 
	0x39e837f5, 0x7dc3c3da, 0xf86d0a0b, 0xb29fafbd, 0x6fd0da16, 0xb8dab9b7, 
	0x22fdd9bc, 0xc63eb997, 0x1c17c85d, 0x8f0fd41d, 0xdd176cee, 0xbb92fd81, 
	0x7c212e10, 0xdc26fd37, 0xac9bf313, 0xdeaf541b, 0x99d936fb, 0xf4a87e0b, 
	0xf00fc101, 0xde065de9, 0x6a2f56bf, 0x3f2bf195, 0xa4fca6dc, 0xc12b7113, 
	0x29f7f66f, 0x474be45d, 0xb5f71da1, 0xd6e09275, 0x517e6397, 0x3a05ca70, 
	0x9c960ceb, 0xbe0ceb08, 0x4237ffd7, 0x3ee4b1df, 0x4f530bf8, 0xb7679118, 
	0x0afb4bb7, 0x9bfdcd37, 0xc1f42fec, 0x7113394f, 0xe26e363b, 0x6ea0d80b, 
	0x8cdcfec3, 0x9f41b6e3, 0xfed3e305, 0x7cf2499a, 0xf221d2bd, 0xbae12775, 
	0x08cde72f, 0x2cae08c5, 0x57fc23b1, 0x69e0a2f8, 0x4d74abe1, 0xc2061f75, 
	0x8c144b7b, 0x44d6225f, 0xedb72672, 0x28bbf9e4, 0x281090e2, 0x88eb471e, 
	0x9b197cf7, 0x80ee0ae7, 0x51ac765b, 0x15c7907a, 0xfe161f75, 0x658a39e1, 
	0xa3d70c7f, 0x2dbf5a1e, 0xad296b7e, 0xe882cb53, 0x449edf2d, 0x4b6dc2ba, 
	0xfc505759, 0x4ce5c691, 0xf41d77b0, 0xc7f088cc, 0xd1da08cc, 0x275d9577, 
	0x85e7878c, 0x5cea75c7, 0x8a4f69e3, 0x401e30ab, 0xf68698dc, 0xfb5668ee, 
	0x53e3bf0d, 0x4e37c83c, 0x74bdd41e, 0x71241e34, 0x507978c7, 0x20e16e82, 
	0x78be741e, 0x8831d4ca, 0xb1af10ff, 0x40eb417a, 0xa96a7ec3, 0x188545e2, 
	0xe24738ef, 0x9e47a243, 0xbf3d0f8f, 0x0b95e254, 0x5bd643e5, 0xd1e31c9b, 
	0x90de7c2d, 0xef90f883, 0xbae251d6, 0x2b1fd1b9, 0xd36670bf, 0xa2e76e7e, 
	0xff3447e2, 0x8c23f123, 0x5a0eba6f, 0x89a8e387, 0x7ea38caf, 0xcab8cfae, 
	0xe1487a78, 0x1c3ec269, 0xf89a8e2f, 0x8fea38cb, 0x27db4fe3, 0x62b42aae, 
	0xcf7844f0, 0x7b7844eb, 0x7fde3e28, 0xbc1d9c58, 0x14db7274, 0x647f97c1, 
	0x7645dd9c, 0x3beb8eb8, 0x9edefec8, 0xcd17777e, 0x606d6f83, 0x6afe10d1, 
	0x88e100b5, 0xeec7b37f, 0x34c1463f, 0x3c893ed8, 0x6bd70e0a, 0xbd1f5714, 
	0x59c792b4, 0x8f99b88a, 0x14caf078, 0x25d23ffc, 0x606ed5a1, 0xf1afdf7b, 
	0x7906b948, 0xe3be18f2, 0xf164505e, 0x6fb75017, 0x8f38fcd0, 0x3c2d320b, 
	0x7ed495af, 0xff8fb533, 0x9dd90777, 0xbe7c4ed3, 0x719ab525, 0xad14f41b, 
	0x16bbdf1b, 0x7e9365eb, 0xbae240b5, 0x7f44cb95, 0xb1902370, 0x1c44693f, 
	0x0708f554, 0xb18bfbcd, 0xb5ca873c, 0xac01de58, 0x67a90d07, 0xdb4037de, 
	0x7bee5bbf, 0xaa95dda8, 0x2fea5d5d, 0x2f77df53, 0x16b5f993, 0xbc69d8f7, 
	0x8f7e5465, 0x573acfbf, 0x79941cac, 0xf6aa5771, 0xeeced8dd, 0xa55eef84, 
	0xbd0d0fda, 0x79897e8f, 0xd5c4f5ad, 0x7997e059, 0x6be33f23, 0x907afe43, 
	0x20d35570, 0x96adf097, 0xdffc92f5, 0x4479e1cc, 0xf6f3cfae, 0xbc9594ca, 
	0xb179b12e, 0x577e8659, 0xcf268fdd, 0xe46d29cb, 0xda2dd179, 0xe61182fe, 
	0xfd686065, 0xc57bf6b1, 0x87bf6532, 0xfda349ff, 0x53c7fd34, 0xfeccced8, 
	0xd08ecf9f, 0xf75ed9de, 0x7e2d580c, 0x7bd19be2, 0xf9de9ed8, 0xee65d137, 
	0x3debd989, 0xbd6a0f32, 0x676c3060, 0x1f5cd1dd, 0xfcbd693d, 0xa5965eb2, 
	0xabb7adaf, 0xff712578, 0xb332d79a, 0xfef255ff, 0xf1effb90, 0xfd3b733a, 
	0xc134360b, 0xddff78de, 0xbc73b036, 0x9e31f748, 0xf32f1a04, 0xf8907c8c, 
	0x77c4e300, 0x38c42e29, 0x00215eb1, 0x6b7f6682, 0xe0cc4e2c, 0x2c7b7138, 
	0xb8e0cc4e, 0x9c5891f0, 0x9f970978, 0x9789c58b, 0xeb8afd50, 0x1f14a28b, 
	0xf24cb4be, 0xc52b9e4e, 0x5ae9f9df, 0x8c3f4231, 0x3c3f4dbf, 0x9baf12d5, 
	0xed7151f3, 0x8976d3b1, 0x436ccff3, 0x542f3e7f, 0x9663a400, 0xb04ddc53, 
	0x62fd7b38, 0xcf6bac20, 0xc788cd06, 0x3d2a6fe1, 0x82b9fbd5, 0xf713b24e, 
	0x138b0dda, 0xb56d24ed, 0xdd2798e8, 0x056c3ad7, 0x2bd69f52, 0xfd500fa6, 
	0x32fb09fd, 0xf76a1968, 0x0e74bee6, 0x696b37dd, 0x5d1af17d, 0x3beceb22, 
	0xaf0f1f10, 0xebde55bf, 0xd48e6807, 0xfc665bb3, 0x789ef8a7, 0x76fdc62d, 
	0x9647b5e2, 0x0cf5af09, 0x52b75ae4, 0x0453559c, 0x7e875c16, 0xe9335e7d, 
	0xc79c1003, 0xafd5956f, 0x8ae4a709, 0x8c5e125f, 0x817858fc, 0x6377b659, 
	0xf695ab59, 0x648f14ca, 0xd63c26bf, 0xadba2dde, 0x90d0e3bd, 0x1eb4d1e7, 
	0xbbbf1d60, 0x4fe9f789, 0x9fca43b5, 0x407d26ed, 0x82f30af2, 0xf2f5c045, 
	0x3fe1eb81, 0xea75c77b, 0x672e64f9, 0x1e629e51, 0x07e20cf2, 0xee6b7565, 
	0x340e38d5, 0x679c68b2, 0x264f0997, 0x82f5c8bf, 0xce285b45, 0x28874b2e, 
	0xb77ecfb5, 0x1d6beb88, 0xd0d3bed4, 0xb08785ba, 0xf175d59f, 0xf7f69fbb, 
	0x3d59623c, 0xf34abf76, 0xd634eb41, 0x18f580f8, 0x5774afc2, 0xe48bfb78, 
	0x1ed91e77, 0xa67e4c99, 0xd4ef2807, 0x6dab8972, 0xb6f5fa17, 0x68baf3cb, 
	0x0ab51c7e, 0xde516c4f, 0x28d7a4ff, 0xfc8bac1d, 0x98a1e522, 0xb2a7b87f, 
	0x79bcdc5e, 0xd087f0ae, 0x74ff39e7, 0x9562b6f3, 0x85adca97, 0xbf8ed0bb, 
	0x16ebfbb8, 0xb2be5fac, 0xf6e02de8, 0x37897622, 0x9687fc64, 0x1f3d73e5, 
	0xabd91fad, 0x3f93b0cd, 0x68be6b1c, 0x97ecad4e, 0xbc8be6f1, 0x2a26aeca, 
	0xf349545f, 0xd17cae36, 0xc6ee3215, 0x63a6d1ff, 0xd7aaef3d, 0xd7e7817a, 
	0x7dcbfe15, 0x16338f10, 0x3f2b8d15, 0x58baf56a, 0x8f16b577, 0xd6c6bbac, 
	0x4aeb89d7, 0xb80dc5f1, 0xf69768ee, 0xe411c15a, 0x912b36cf, 0xf7597cd9, 
	0xf33acd96, 0xf3b32d94, 0xab9e38ba, 0x46909e15, 0xcf479bf5, 0x05eb8547, 
	0x58cc3e57, 0x71714b5a, 0xaeaa3e72, 0x28f9bc76, 0x723fcf33, 0x5ace8a3e, 
	0x73743e90, 0x51f2f8ed, 0xe726d4b7, 0xff6e46a3, 0x6b2f652e, 0x5a3ae4eb, 
	0x9dea89be, 0x724d1ceb, 0xbc87c9be, 0x78d7ed34, 0x7ecf9c1d, 0xf920afea, 
	0xbc8eb721, 0x77d96d02, 0x92dd8e6a, 0x94ebfa2b, 0xd307a235, 0xc9d7343a, 
	0x8dd34738, 0xcebbdfa9, 0xd46717a1, 0x553c5e8b, 0x13a99bcd, 0xa4aeeb27, 
	0x7db93af7, 0xdd4d7bd1, 0x395ab9f8, 0x1fac90d7, 0xec4e95bb, 0x8e1745d1, 
	0xc836d0e9, 0x25f07e11, 0xd6ff93d6, 0x8ff5317a, 0x347b80f8, 0xfbff5add, 
	0x6b7bd6e8, 0x5cb7c785, 0x21e33822, 0x22311add, 0x24ebcf6c, 0x3b7c285c, 
	0x4af493bf, 0x272ed753, 0x74a5db1d, 0xad96276d, 0x9e909fae, 0xf9ec29ed, 
	0x3db1b7c5, 0x4fecfebf, 0x54f6cf49, 0xb5dabcf6, 0xffecf583, 0x7ac059ce, 
	0x1dee9ef6, 0x0ecf471f, 0x4fad7787, 0xd36fb3d0, 0x9e87120e, 0x3ddedb73, 
	0xecded8d9, 0xc6617a5b, 0x69af54b5, 0x23b9bdd7, 0x91690f3c, 0x24f811f2, 
	0x897631c6, 0x3747746f, 0xeea70ff9, 0xa471be20, 0x9b5bd956, 0x9db29ec7, 
	0xdb15f0f8, 0x37820f09, 0xa3751604, 0x17aa2cfd, 0xe330aebb, 0x76cc8023, 
	0xb4dbd9e2, 0x1f9c768c, 0x9db04ddf, 0xbd95eeae, 0xff4f3459, 0x05ed2752, 
	0xb8d3a0cb, 0x83237185, 0xa73cd0f0, 0x77a33c13, 0x713bbf12, 0xada6767d, 
	0x62f3f58f, 0xdb1703a5, 0x33f72758, 0xdaa23e7e, 0xca76f531, 0xd6fc7247, 
	0x5749d9a3, 0x6f64fb9e, 0x43df8d86, 0x707a239e, 0xd695f106, 0x7483b0e6, 
	0xebd232f1, 0xf8bae27b, 0x71ebd24e, 0xc3d2ce1f, 0xdfdf8bac, 0x7f53abd8, 
	0x66f60f3d, 0xcf4e2e90, 0x42ae58c3, 0x7c2ad1ff, 0x1b37bf87, 0xf2c36fdb, 
	0x4396a0ac, 0x3d1cc2a2, 0xd7c40760, 0xbb0c07b2, 0x52768ed1, 0xae93b16d, 
	0x7d7493b7, 0xd51ddf7c, 0x20ee5798, 0xfac5df7d, 0xf495b17e, 0x84b47f74, 
	0xee4b7c74, 0xafa413d1, 0xb897ad9f, 0xb437d661, 0xff8e3c92, 0x626e7e31, 
	0xc251ff3d, 0x65bad8ff, 0x32f9ae08, 0x18d94fd0, 0x0291eca7, 0xae3b7719, 
	0x279aa653, 0x7f197f33, 0x7f24cd1e, 0x538641a5, 0xfe49f7ce, 0x3421d4d7, 
	0xde72ffca, 0x3ce2c8cf, 0xf24c7eb4, 0x25d4e3d0, 0xd4c23d4c, 0x8dd2d235, 
	0xf0a56fcc, 0x9cf8b3f7, 0x0cee8645, 0xa78ddd63, 0x6b6239ff, 0x7bcaf803, 
	0x649d133f, 0x3654e7ac, 0x37453ecb, 0xf9efa61c, 0xf8408c32, 0x471d04c1, 
	0xea2b34e9, 0xefd0bf25, 0xe12583f7, 0x6e43a9be, 0x957c93aa, 0x16b7b799, 
	0x8f1aecbb, 0xda4cf847, 0x0ecce728, 0x961ffb2b, 0x9f0f3ebf, 0xa26ea6b9, 
	0x2f8cbfce, 0x5d637d5f, 0xfd1abe72, 0xcfc7ef43, 0x9ba81f57, 0x5dd67d18, 
	0x4f19cae9, 0x1e783abe, 0x0e7e367d, 0x9d8bb605, 0x873a76c2, 0x4de2ab72, 
	0xfa28f3b1, 0x928f392a, 0xf887f821, 0xe6f849d6, 0xfb7c16ae, 0x91cf8e39, 
	0x382daf18, 0x2d5ce596, 0x267924b8, 0x50e75128, 0x8985fcf9, 0x840f8c4f, 
	0x80517a23, 0x27c20874, 0xf31bb048, 0xd3ab47bc, 0x39fb4c5a, 0x7c43bf0d, 
	0x5e965374, 0x045c5dfc, 0x2ede5fcb, 0x7e1a4db6, 0x99d4d72e, 0xf12cfcf9, 
	0x873c0bcc, 0x41f955db, 0x43ae3e7a, 0x116f5569, 0xd0eb03d9, 0xb26bfa09, 
	0x1de25cde, 0x769b37aa, 0x3b6ae7c8, 0xb68e7ec6, 0xe7dceea2, 0x3f5c4d68, 
	0x06777d71, 0xd71d8fb4, 0xe2603f4d, 0x26f389ba, 0x6f389bae, 0x7be31fae, 
	0x26eb8e20, 0x8fd6c7ce, 0xc29f40fc, 0xfbc290f3, 0xcdebe1de, 0x70a7def8, 
	0x5c715bfd, 0x2ab0bf67, 0xce26eb8e, 0x28b09fb3, 0x992110ff, 0xbbffaa26, 
	0xb7c70fe8, 0xe75f153e, 0x709f258b, 0xe4cfb2a3, 0x01f1027c, 0x28e0ebc2, 
	0xd19fd8fa, 0x2734e616, 0x3357a7ea, 0x375e38bf, 0x66853f54, 0x5575f795, 
	0x23afba3b, 0x1f580819, 0x53bed4b3, 0xadd771c7, 0xe8afa245, 0x2eb00701, 
	0x8e13e4b6, 0x818f38c1, 0xb48ff12a, 0xdc5f097f, 0x8c8beb97, 0x32f543bd, 
	0xea56d7e2, 0x6ba0f217, 0x0597e946, 0xc73767ef, 0x41a335fb, 0xa62fa0f8, 
	0xa22f0aeb, 0xee12937a, 0xfd17aa9f, 0x75d317d2, 0x74c5ea93, 0xfa41dd5d, 
	0x50f7dd25, 0x2bae98fd, 0x2f577ff5, 0x7f8e62f3, 0xd36bb8d8, 0xc6e745ea, 
	0x791b1ef1, 0x38f04fbc, 0x6bf97c0f, 0x5bb34f62, 0x67aec7cb, 0xea6b573d, 
	0x593bcb59, 0xa495597f, 0x4e248567, 0x774ee93b, 0xfd4b76d8, 0xfae53c44, 
	0x486e25fb, 0xff831bd4, 0xc2e37acf, 0x637aa1fa, 0x51bd3470, 0xe93bf9cf, 
	0x3bb77b8d, 0x86d67d64, 0x1abb129f, 0x489f7ecd, 0xe3dfdbb0, 0xf9c699be, 
	0x5dd11c09, 0x584b6764, 0x467f5eb7, 0x17cb1d74, 0xb819ceb5, 0x6e945b9e, 
	0xdc82ea60, 0x7551d92e, 0x1a7d90f5, 0xb8f4fb54, 0x3c84dfb2, 0x87ed0e47, 
	0x00fda486, 0xf78721ab, 0x8725be69, 0x3ef8b1f4, 0x09fdc15d, 0x887cb82e, 
	0xc0799abd, 0xce8cbe58, 0x749f12db, 0x213d6182, 0x46f1a4fa, 0x100c9f5c, 
	0x4d9c441f, 0x2f723d27, 0x273e16e1, 0xa555525e, 0xa7c94c04, 0x296d2e6d, 
	0x25ab7124, 0x25da1a23, 0x51d9d8f3, 0x71e1f406, 0xd00c0bed, 0x3f5f57c6, 
	0xd5253adf, 0x7daf8e0f, 0xf81977f3, 0x55d2b26f, 0x6ace8b27, 0x6efe564c, 
	0x2b99e932, 0x1301be94, 0x158d3bfc, 0x2483174a, 0xb2d0e71d, 0x07f0f59d, 
	0xbc22da2c, 0xbb82fbde, 0x2efe87ea, 0xe44b47a3, 0x2efda3cb, 0xf430d5c3, 
	0xe5631977, 0x9bd74fcb, 0x9cc4dffa, 0xefeb186b, 0x9f547e31, 0x6f9197cc, 
	0xe32f978f, 0xc54cfd7c, 0xcf7fcc09, 0xfd93d7e1, 0x8df3b0f4, 0xdda72f8a, 
	0x7ca1345a, 0x1de76219, 0xfbf20da3, 0xe75d631b, 0xe63db937, 0x785e3121, 
	0xbc41de1e, 0xc0779122, 0xa2cfbf28, 0xfbde2279, 0x6f62f55f, 0x2d3bf4c5, 
	0x86379d1b, 0x4ed9ff19, 0x7aabf6f8, 0xf94f9f3a, 0xca779a60, 0x9c51a707, 
	0x78c4d8d7, 0x27ca7c77, 0x942b7bf8, 0xe58beebe, 0x168fd135, 0x58ddf824, 
	0xfde8735e, 0xba0fcaa0, 0x7c883f29, 0xc179482d, 0x16b7f63e, 0x1f94a7de, 
	0x91ce1fbc, 0xdb33fcd7, 0xce532bff, 0x60e13f72, 0x3eb5eb90, 0x1efc53e3, 
	0xf389b171, 0x705edcc7, 0x1c8ed730, 0x6e9f5d19, 0xe83f436f, 0x68de8889, 
	0xc017595e, 0x241b5bfe, 0x13a94fee, 0x7eae8fbd, 0x2f55572c, 0xa9bb24ed, 
	0x28fedeaa, 0x94605f8b, 0x79dda1f6, 0xf79805d6, 0x0de751ee, 0x256b3567, 
	0xbf7f8f54, 0x5ec5df87, 0xf242da3b, 0x1db68c3c, 0xf0fe888c, 0x3db5e235, 
	0xb4a55ebc, 0x66171b3e, 0xe0f20177, 0x21fcea3d, 0x5430fd0e, 0xefd477f2, 
	0xcee784fe, 0x44a9b879, 0x4ebff6c3, 0x3cc4373c, 0xde316677, 0xce41b2bf, 
	0x2dbf237b, 0xbfe3b785, 0xcaaef3ab, 0xe332f9e6, 0x5adddf1b, 0xb624e569, 
	0x1633d11b, 0xcc0e3f76, 0x407ce5a7, 0xacfe9a7a, 0x3647bfb2, 0xbbc0953f, 
	0xd743d56c, 0x42ffdd55, 0x3aef1243, 0x77991815, 0xfd8ed5e9, 0x5de047bb, 
	0x8feb4303, 0xa4fe2ed5, 0xbcb476ec, 0xbe9eb9b1, 0x3e695ad5, 0x3bacefce, 
	0xd00b4a9b, 0x740eabde, 0xe38f9e3f, 0x99be1afe, 0xd850f88f, 0x8bebeb20, 
	0xf44f5806, 0x09d2581e, 0x87bf1e61, 0x388591f5, 0x3d78877f, 0x8f4eb4dd, 
	0x5f8b3ad3, 0x22b3e7e0, 0x1a358761, 0x8f1e95d7, 0x3b862fc5, 0xa7d93e31, 
	0xccc798e2, 0x9a5be4f8, 0xe3d5f69b, 0xe2b96e2a, 0xec9b80f9, 0x03cfd706, 
	0x7b7ee43f, 0xd03deca8, 0x203fa4fd, 0xf1c7e7eb, 0x75eaee5a, 0x8ff9d1e7, 
	0xecf1dd7c, 0x93cf1e31, 0xf89fe2f9, 0x779f2b5c, 0x1e3e2ebd, 0x79ac1cf3, 
	0xea29f5ee, 0x97eb8847, 0x7995da25, 0xf73cd63e, 0xe5a22b3a, 0x8fb6fc50, 
	0xee51f0ec, 0xc7f5196f, 0xfd8b1f3c, 0x97fea32d, 0xabd7f9d1, 0xba977bf1, 
	0x719dbdcb, 0xe81cf33b, 0x0fd526fe, 0x4e55582e, 0x1703d7bf, 0x024157da, 
	0x87ab044e, 0x09c289da, 0xa466e917, 0x9d2d398f, 0x9068ad74, 0xeb4a987d, 
	0x6bce2ebd, 0x7ca3cb46, 0xbbf9b961, 0x8c372f9e, 0xaf9ebbf4, 0xce73c834, 
	0x7f171c8b, 0x8282f4ac, 0xf38c69a3, 0xd57c7d05, 0xf2929ea7, 0xbff401d4, 
	0xf9e68d03, 0xa0da7d5f, 0xf9469fdc, 0xd8f12f3d, 0xdd6d7835, 0xf18438b0, 
	0x09f297bc, 0x677df145, 0xcabf72f2, 0xe524542b, 0x5cb93e15, 0xa342f7c6, 
	0x4badbd5c, 0xe2125b16, 0xc5d20aa6, 0x282aaed1, 0xe47f406e, 0xb17dbead, 
	0xbfdefc86, 0x3b4868b2, 0x33a28ded, 0x5fec579a, 0x57a7d931, 0xf22f6df1, 
	0x903b105f, 0x46749ab8, 0xe03ee3b2, 0x67df5a38, 0x8bd3239e, 0xca892759, 
	0x76dc5cef, 0xf77146d8, 0x9223a4fd, 0xa0fe0f5d, 0x467fea84, 0x2b6f37f9, 
	0x759fbbb6, 0x2787e2c5, 0x927f3eb1, 0x4b22bdd6, 0xd15d212f, 0x992b679d, 
	0x3d0e71d2, 0xfc2dd5d1, 0xdefe2434, 0xd0bd23cc, 0xc733e720, 0x7efa979a, 
	0x52f2d8c3, 0xe7fc513f, 0x09576545, 0xfb17553a, 0x91741b4f, 0xa7d31b3e, 
	0xe44e4d42, 0xafe6a3dc, 0xe4f1bda8, 0xd9affaaf, 0xd3fc44d0, 0xe87f1bb4, 
	0xbbeb2cb5, 0x1996fa09, 0x8c3d51a7, 0x174abcd3, 0xd0bf57f3, 0x77eb8ed4, 
	0x03c4a365, 0x755e3cb1, 0x5ddff701, 0xe703fe8d, 0x7cf897ff, 0xca91d905, 
	0x2a6f7aef, 0xc5751d62, 0x9357d172, 0x9e85d379, 0xd2f3337f, 0x477bfc17, 
	0xe2729bd2, 0x6f59a9ba, 0x35e7b2be, 0x0fa09aea, 0xf1d1343b, 0x3b0fa9ce, 
	0xe1b9d51b, 0x7b5df271, 0xc3e944e3, 0xce3b6fb8, 0xc736e79f, 0x9bc73b1d, 
	0xf46e8e07, 0xc51a33cb, 0x3eae3ebe, 0xc4e3477c, 0xbbc99efc, 0x1e31c8a0, 
	0xbaf5ebbe, 0xa6f7beb8, 0x7f6ef991, 0xf124dc30, 0x70ebfa3a, 0xd8f31e3c, 
	0xe0ffb174, 0x8fac4d0b, 0x70d8f3e8, 0x85ce2a2c, 0x1ccbf754, 0x4ddc02d7, 
	0x3cf9a971, 0x70f3ae76, 0xd275cf98, 0x3884817e, 0x6ec7f79b, 0xffbb2fda, 
	0xd7e28774, 0xfb0c2f61, 0xdf260c3b, 0xb25bf936, 0xdfac9bfe, 0x5dfe05c2, 
	0x30eff306, 0xa52fb57c, 0xfb19eb4d, 0xbfe061df, 0xc2ec70db, 0x89e662f5, 
	0x8dd76305, 0xb7386fdf, 0xddfe6c6e, 0xa1c71e0a, 0x3c93f3e1, 0x9dd016df, 
	0x5da4db07, 0xd9d58e75, 0x3531fb47, 0x8ed1f33a, 0x2c5c7af8, 0xc7ed2c3a, 
	0xfed87491, 0xa6eb8255, 0x206d79bd, 0xa55b07bf, 0x7de15c70, 0xe752ef5c, 
	0xaf2a4203, 0x0d2ef4ae, 0x5eaf3626, 0xc9eaf2a1, 0xe29b617c, 0x1875e61b, 
	0x431e405f, 0xf978e1fa, 0x42f88782, 0x0be7c7df, 0x930be21e, 0xf417c3c6, 
	0xbf27dddf, 0xabe87803, 0x8dbcd14f, 0x7ab2ce72, 0x6933dd14, 0x09a5b9fe, 
	0x2e373dd4, 0x4157384f, 0xaff4defc, 0xd215f3b1, 0xd28d4f0f, 0x8af9d55f, 
	0xbb87ea89, 0xc268f85a, 0xed1bcb39, 0x55d15f3c, 0x1bfe9e5b, 0xd6e370e2, 
	0xee270e18, 0xf870118b, 0x5f63f50c, 0x9ca374f0, 0x78bc9727, 0xda4cf414, 
	0xf7bfc987, 0x3d12f189, 0xde3dbf21, 0xa08cffdf, 0x39477997, 0xb97fb72f, 
	0x4f934ff8, 0xe43f958d, 0xbd289f2c, 0xf9e31c0c, 0xcbe525fb, 0x4b2f4027, 
	0xe5e10fe0, 0xd21fc313, 0xfe589a6e, 0x14f956e0, 0xa7ce0dc4, 0xf29f2978, 
	0xc15fbd1a, 0x61bdea18, 0x0f49c739, 0x0f9c2435, 0xf737c04e, 0x998b0dd2, 
	0x2e70c787, 0x12647c5a, 0x24315bdb, 0x8d5a5de0, 0x9e26f5c4, 0xb56f749d, 
	0x9c298edb, 0x878fcfd3, 0x7f1fe1a3, 0xe5dfc3df, 0xe0e3343c, 0xfb070a75, 
	0x39aab748, 0xb3de7c49, 0xde31fb30, 0x0f171f67, 0xe31dd693, 0xdfbf8e09, 
	0x9f057e9e, 0x0aaef44f, 0xf8e08a2c, 0x3675aa77, 0x955e74f3, 0xcf9a80ef, 
	0x883ff23a, 0xb05bb7ef, 0xe500c55e, 0x4efff01b, 0xaf4175c7, 0xa657b5c2, 
	0x794e0460, 0xac35f591, 0x2b7c2ccb, 0x8ccdf185, 0xfd7d4d87, 0xefe6e5e9, 
	0x7fdefeef, 0xdaae08f7, 0xe577f829, 0x6e9f9c36, 0xd87586c2, 0xc9c14ebf, 
	0xd06f8d8b, 0xef251e7e, 0xeb4a38cb, 0x8a4f9897, 0xfd361bad, 0x3eefae20, 
	0x78e6af5a, 0xb3a4857c, 0xc187ce8b, 0x0f738c7a, 0xa19dc425, 0x6ef2d86c, 
	0xdf139e62, 0xf5a47dbc, 0xbd244445, 0xf596b6d5, 0x0d8ff5d6, 0xe7fc5f5d, 
	0x678f7f50, 0xf3cca761, 0x0f4fedeb, 0x9cbaf79f, 0x075b9667, 0x03ffd7e2, 
	0xc3d76f47, 0x00065022, 0xffffffff, 0x00007f86, 0x00000090, 0x001e12d3, 
	0x00122ac7, 0x00122a30, 0x001e2bb1, 0x001e1008, 0x001e602e, 0x001e110c, 
	0x001e109f, 0x001e10fa, 0x00000030, 0x001e15ee, 0x001e10e8, 0x00122b75, 
	0x00000050, 0x00001aae, 0x00122577, 0x001e2719, 0x001e240a, 0x00001c31, 
	0x00000020, 0x00025ccf, 0x001e5d8f, 0x00000020, 0x001e5b68, 0x00025dcc, 
	0x00000070, 0x00040585, 0x001e016f, 0x0004049f, 0x0004000f, 0x00040004, 
	0x00040654, 0x00040726, 0x000000b0, 0x00062333, 0x000608dd, 0x0006088a, 
	0x001e422a, 0x001e28a4, 0x0006400e, 0x0006229d, 0x000643cb, 0x00064390, 
	0x00064365, 0x001e18a0, 0x00000020, 0x00083dd8, 0x00083ccf, 0x00000020, 
	0x000835a5, 0x000833b1, 0x00000020, 0x00122faf, 0x00122ed4, 0x00000020, 
	0x0012298a, 0x001229d1, 0x00000020, 0x001e59b4, 0x001e5abe, 0x00000070, 
	0x001e4dc5, 0x00124ad0, 0x00124bde, 0x000c544d, 0x000c50fb, 0x000c4f98, 
	0x000c5776, 0x00000050, 0x000c4509, 0x000c4573, 0x000c4622, 0x000c458f, 
	0x000c4665, 0x00000020, 0x00124910, 0x001246b5, 0x00000020, 0x00bebc20, 
	0x00000003, 0x00000060, 0x0001000a, 0x00032a08, 0x5d83924e, 0x00000000, 
	0x010205ff, 0x00400804, 0x00000020, 0x000c0000, 0x0008000c, 0x00000020, 
	0x00100014, 0x00100024, 0x00000020, 0xffff5090, 0x50a0ffff, 0x00000020, 
	0x01961100, 0x00000018, 0x00000020, 0xff81ffff, 0x00000fff, 0x00000080, 
	0xfffc1ff9, 0x00000fff, 0xfffff7fb, 0x00000fff, 0xffffffb9, 0x00000fff, 
	0xfffc1ff9, 0x00000fff, 0x00010012, 0x001e2353, 0x00038221, 0x7dd59c78, 
	0xd555780b, 0xfbdae899, 0xfbcfb23c, 0x90203c9c, 0x902487a8, 0x480d1980, 
	0xb2b804c6, 0x34f17909, 0x580a4520, 0x1114110f, 0x01b52035, 0x0493ec2d, 
	0x0268f808, 0x22d6a088, 0x9def16da, 0xb63b1b7b, 0x9ddb75f5, 0x76bc1010, 
	0x72331f06, 0x0f0d6867, 0xa664ea6b, 0xb0699968, 0x63ffb94e, 0x024af3ed, 
	0xdfbdb954, 0x5cb2bf4d, 0xd6bdaf7b, 0xaff5febf, 0xb9d6bdff, 0x85c2e170, 
	0x78849b2d, 0xf6114f29, 0xdaac42b3, 0xae6b4fac, 0xdba7f017, 0xb0a0dba2, 
	0x637eba47, 0xf5d23d60, 0x5eaa501f, 0x2843f3b3, 0xb824f07d, 0xf50b9f0e, 
	0x4de8540f, 0xe7eff07d, 0x9fb09f3e, 0xbebca213, 0x0e78d4bf, 0xae5c05ca, 
	0x6d1e93fa, 0xadc421de, 0xdaa974af, 0xa1d2215e, 0xbbc6086d, 0xe2121bc7, 
	0x57a62153, 0x423593c3, 0xa70df26c, 0x6c3085ef, 0x671849c6, 0x444d74c1, 
	0xb42ff084, 0xa07a5bb9, 0x1af3605c, 0xde97081d, 0xb2a0b1f4, 0x8fc687ab, 
	0x1187ff34, 0x1382c387, 0xdfbd46fe, 0xe305e72a, 0x43096167, 0xd6f3905d, 
	0x700681a1, 0x34f9c56c, 0x16c29c20, 0x4f6581dd, 0x282eeeda, 0x6db9f61d, 
	0x52b78fd0, 0xa46f6fe4, 0xe09b6afe, 0x692d559f, 0x9569e20a, 0xaa8946b3, 
	0x33c15442, 0xa1cfe20f, 0x7ee5ff52, 0xe71c4d11, 0x83ce397a, 0xe5940e38, 
	0x01b34413, 0xa0bd2f80, 0xd0e85128, 0xf344299e, 0x814e3013, 0x39fdba59, 
	0xf087eefe, 0xa22ddd9d, 0x7e7c41ad, 0x8bfb74a4, 0xaaec3842, 0x6212ce68, 
	0x1eef1cb9, 0x6fe1396f, 0xc68d3395, 0xc6b7c6b3, 0xc2e38a9d, 0xf9cae6bc, 
	0x4a9ee7bd, 0xd1ea7fed, 0x37dcfca9, 0xcaf5d07d, 0xda8e6cda, 0x460df3cd, 
	0x54f71c0d, 0xea6e8eda, 0x4e801bff, 0x95719f98, 0x1518df7c, 0x2f736eb8, 
	0x696cdd6b, 0xe7c2274a, 0x8778467d, 0x26e214ad, 0x7005c2f8, 0x7f3ced79, 
	0xdbd3eba1, 0x979fc6f7, 0xd70555d9, 0xb54c2c2d, 0xa78d24ed, 0x75a0cdb4, 
	0xd86eb856, 0xc4937eb0, 0xb6f238af, 0xe217ac4d, 0x20dd1ff1, 0xb6dfa40c, 
	0x5e7176d1, 0x85641f88, 0x9b341eb9, 0x7654bd8c, 0xf77be145, 0xa139a148, 
	0x8c061b9c, 0x773c3bfe, 0x871a6bec, 0x15341e74, 0x67aa0231, 0xc0137754, 
	0xf0c898e9, 0x0a5dcac5, 0x1c9943ad, 0x759410f7, 0xd644fe50, 0xdc285f1d, 
	0xacedcece, 0x5cbef8f5, 0xe964278f, 0x5529e82d, 0xb7ac2546, 0x36d12857, 
	0xc39c57ee, 0x954b67f7, 0x1f1650b1, 0xfd60552f, 0xdd01c7cb, 0x98543d20, 
	0xc67aeaa5, 0xf62ffc07, 0xb509a6bd, 0x3a03de09, 0x6c369695, 0xe62a5fd7, 
	0xf530ab41, 0xcee855f8, 0x3bd783bf, 0xde882cdc, 0x25789f68, 0xe8c4f63d, 
	0x5f4911f1, 0xeb09528f, 0x21eb8e94, 0xffe1042a, 0x8385efee, 0xc4f8a430, 
	0xa5e893b3, 0x9dddd0ec, 0x52bff002, 0xd602a9b7, 0xdbaf4d51, 0x9d22f621, 
	0xf7760775, 0x486578d3, 0x9ebcde7f, 0x9f029152, 0x8f9f26d1, 0x2e513a45, 
	0xf5ac4e8b, 0x369dfd12, 0xaa2f8ba4, 0xb75c1246, 0x67e41363, 0x8bd10666, 
	0xa24dea37, 0xe01e6f17, 0x8ff1d07b, 0x9f80aa94, 0xe7f116b2, 0x1bf0df8d, 
	0x21f57f1a, 0x3095df18, 0x1da6517e, 0x03c9f5f1, 0x6c79e963, 0x6313a07c, 
	0xe3e320d4, 0xbe332ff3, 0x27da1bf9, 0x93ca5a07, 0xd127d7c7, 0xbb7d57fc, 
	0x0efe6924, 0xb91d3fb9, 0xecb02fd0, 0xda7f7263, 0x9e9a2135, 0x8c463860, 
	0x9fc7fee2, 0xa5fbd38d, 0x1bbf19e8, 0xbe0b5d74, 0xf076bae4, 0x943aaeba, 
	0xbdaebc9d, 0x95d784e9, 0xf349790d, 0x2d3be4da, 0x51b16bec, 0xeba77d1b, 
	0x1477a74c, 0x20fccc7e, 0xf91736bb, 0x76de9a99, 0xa3a7d215, 0xe90727b8, 
	0xc5d5e1d3, 0x8ef4d836, 0xb7479ecc, 0x3d8ba901, 0x2f7e2646, 0x80f7f0a6, 
	0x2db3f4e0, 0xfc2c4c42, 0x73b9d11d, 0xac26596a, 0x7e953891, 0xbefc2eeb, 
	0xf4f3e252, 0x519b5335, 0x88c77a1e, 0x2061adb3, 0x01f2c14b, 0xe224f1f1, 
	0x47b08a63, 0xa6c25f81, 0xa1db45b1, 0x7ed0579d, 0x97684ffb, 0x8df080d3, 
	0xfd79c5ca, 0x3455e8fa, 0x7ffe696e, 0x2595dc12, 0x61b3078d, 0x3332b4bc, 
	0xaacde384, 0x2b286b2f, 0x594b7281, 0xca0fb183, 0x7ea91b97, 0xa31beafa, 
	0xdba8f082, 0xacdf980d, 0xf81cf0fd, 0xfcc3acf4, 0x57b1d67e, 0x15ea7eb8, 
	0x75939fae, 0x065cabe7, 0x779973cf, 0x944fdf9e, 0xd6596af5, 0xb2a1af95, 
	0xbf7c4a1e, 0xc8b7d64e, 0x2e7adb7a, 0xe7e7aff7, 0xe1facb2f, 0x4e106bf5, 
	0x133d6bfb, 0xc12740a3, 0xb28a8dad, 0x14af9e0c, 0x26cc0286, 0xe6cc2698, 
	0xa06c108f, 0xe0dfa02f, 0x75c50696, 0x29b7de92, 0x05ec7720, 0x9a729b61, 
	0xeeb0fbea, 0x04561e58, 0x00a1df7f, 0xc0057d9e, 0x37542335, 0x618f2e15, 
	0x5070cebf, 0xedcf196c, 0x07afee15, 0x0c299fdb, 0x62cfed5b, 0xdf67687b, 
	0xed85fd4a, 0x1c243b5b, 0x9ebbf127, 0x8853a574, 0x168b57e1, 0x41b3b3e4, 
	0x16bf6076, 0xb1cdb33c, 0x1c4f4b62, 0xa8e6d99e, 0x4f302da6, 0x43c0216f, 
	0x2be67bcf, 0x1d9e80d3, 0xd428f69d, 0x519e10d3, 0xa6847871, 0x5997a8ab, 
	0x2f7594f0, 0xb7581453, 0xb3a285e1, 0xb7b514f9, 0xe87dc56f, 0x93b4b715, 
	0x11d86482, 0xa87bd63f, 0xa0fbf007, 0xde352cd3, 0x478775a1, 0xafe21750, 
	0xd42aea93, 0xedd425e7, 0x4a677529, 0xbd27a17b, 0x0aeaf32f, 0x6b667f8e, 
	0x8f004847, 0x2fe84e08, 0x2555032d, 0x9673f4b8, 0xb4499147, 0x210e1199, 
	0xc30433bf, 0x38075491, 0x75093bc4, 0x99dd4a7b, 0x48e01ed2, 0x38c00f7c, 
	0xf0df31b6, 0x194f0147, 0xa11cfbc5, 0xfa67e436, 0x51fbdbdd, 0x31b81278, 
	0xd168e57e, 0x0033d183, 0x1bb0a57f, 0x7dbfa047, 0xf08d5322, 0x35fdc6fe, 
	0x829570b1, 0x31f699fb, 0xc0ad3bf4, 0x05a8df78, 0x1918497d, 0xed77282d, 
	0xc5e89a69, 0x1ae9f792, 0x99a2e585, 0xfa829f77, 0x6cce35ad, 0xfdf1d087, 
	0xc67de1f7, 0x8ecf8259, 0xade1c67c, 0x6e7e9057, 0xa2cbd6ea, 0x0dd06e30, 
	0x97f01af2, 0x0ffd85ee, 0xa7177970, 0xba71a947, 0xa79ea0da, 0x009c54ef, 
	0xd60689f0, 0x929c0c07, 0x2b0ecef0, 0x36210cb6, 0x5a85f1ca, 0xfbc3b761, 
	0x237ba074, 0x07a46482, 0xc2859f90, 0x82ee26c2, 0x535e1ef9, 0x649d00a1, 
	0xa45444b4, 0x2e60f857, 0x60b0c9d2, 0xd0c53bf8, 0xd5d0eabf, 0xff42311f, 
	0xf08658de, 0x02555d00, 0x211e4afe, 0xd176e87c, 0xadc71a75, 0xbf21360f, 
	0x474b7a21, 0x830463fe, 0xa259ded0, 0x61478207, 0x57d7379c, 0xbb719684, 
	0x47bf8c20, 0x58683d61, 0x33c3b8ca, 0x116281c3, 0xd929571f, 0xc5d7d8a3, 
	0x463821c7, 0x28945e10, 0x0d416ea8, 0xa70f07f0, 0x8084c0b5, 0xb054dc2f, 
	0x1088402f, 0xed0edaba, 0xbcb0a7be, 0x021f007a, 0xa7bc323e, 0x30de38ec, 
	0x62877eef, 0xbfdc3b70, 0x51fc6fb0, 0x1163e893, 0xf4a93bea, 0xc33f9561, 
	0xdd78e717, 0xcfe223a2, 0xe455a561, 0xe521bac7, 0x492fcf40, 0xbeccf4ae, 
	0xf1f9e589, 0x07af9234, 0xdf72c97e, 0x7ae397d2, 0xf1154fe8, 0x43d3114d, 
	0xa9c81145, 0x451f5265, 0x8cf307b9, 0xd37825ee, 0xc7f780bf, 0x962baf3d, 
	0xea167dde, 0x6d67cd8e, 0xf7ef81a3, 0x7c610d39, 0xa16a88c8, 0x2c3f60cf, 
	0x5f660de3, 0xc26ced01, 0xf0415a6c, 0xcd27089a, 0xb7ca1d73, 0x2b404c45, 
	0xda1da34d, 0xbb0d452b, 0x14774f11, 0xb2b8651e, 0x61e492eb, 0x9229f155, 
	0x79c55587, 0xa1e00ae9, 0xb5b8416a, 0xb8963a75, 0xb89ca065, 0x83d6a1ef, 
	0xae7aca58, 0x59b94769, 0xb6d11055, 0x535540c3, 0x06ada54c, 0x03e175ca, 
	0x8cb1848f, 0xf807b43c, 0x2152d55f, 0x72fdb15a, 0x075ad1a3, 0x60d9885c, 
	0x1eb1b678, 0xfb377f4a, 0xf7acefc5, 0xdb313530, 0xbdb46469, 0xba3ddf09, 
	0x3eeb676f, 0x6f897728, 0xb23d676f, 0x5fd83bf1, 0xca33b4a5, 0xd49b6574, 
	0x5d01b61f, 0x5d5fb0aa, 0xbf590767, 0xfad2dfb2, 0x7c569d2d, 0xad67eb59, 
	0x413643db, 0xf85a877a, 0x584c12b9, 0x0aa2aac7, 0x5578c045, 0x088e122d, 
	0x52eb81c0, 0x63841424, 0x14e384ba, 0xe501a84e, 0x919acff3, 0xee347ccf, 
	0xe77e3b49, 0xa22733cf, 0xa866067d, 0x70267dff, 0x837bc13f, 0xaeaa7820, 
	0xe517309b, 0xa681d664, 0xb07ca3df, 0x2516be83, 0xe3b4de7b, 0x41ae7b7b, 
	0x387a7ffa, 0x83d6c5bc, 0xe471fd75, 0x2a075907, 0xe3f943de, 0x3d3e002f, 
	0x9bbae99e, 0xf4708d38, 0xb3ba38d0, 0x5fbb4a17, 0x3740cd18, 0x3be06165, 
	0x71d32a61, 0x5822f29c, 0xc71a0e83, 0xe784f389, 0xfe1cf879, 0x503f10d2, 
	0x8246409f, 0xfbe4d3d0, 0x586f7e0a, 0xdefcf9f5, 0x73d7dab4, 0xbeb2685d, 
	0xdaebdb96, 0x69da9511, 0xeea89ac7, 0x5775ce3a, 0xbbba950f, 0xb3eeeb97, 
	0xcfd3defc, 0x4cd98f75, 0x1b11ef75, 0xb8c7bdd5, 0x75ce3bee, 0x4dd52f5f, 
	0xcdac377f, 0x149adfad, 0xa62d60d4, 0xb025b7c0, 0xf27e6ebf, 0xcc3660f3, 
	0x2e9a96ff, 0x728a3f87, 0xf7155ae0, 0x4deffcdd, 0x3c4ebd22, 0xa4e1f205, 
	0x93470b94, 0x06a8bbf4, 0x20fec2fb, 0x8f4077e8, 0xc3b65513, 0x3fcefd2d, 
	0x1d27d605, 0x16c330ed, 0xefdabd05, 0x55caefe5, 0x8d15dfa9, 0xbb7a45cf, 
	0xa941f7e9, 0xd41bc1df, 0xbf403aef, 0xd96e3183, 0x5dfa45d3, 0x1cf1ce1d, 
	0x52e569ea, 0xfd272b4f, 0xaea1626b, 0xc18cdf22, 0xe0f2f7b9, 0x7099719c, 
	0xace0b5ce, 0x93f43d65, 0x95cf991b, 0x141dcfe6, 0x9f7c18ce, 0x6b8e7c31, 
	0x51dd7323, 0x5fb87fde, 0x3d57f6be, 0x44072cdd, 0x5501ca06, 0x05cfd1e8, 
	0x84ebe3ce, 0x93a9eaef, 0xee347ae2, 0x3e6167b7, 0xf1e71233, 0x879c668b, 
	0xa3cf0c7f, 0xf61e653e, 0xcc3f0029, 0xf3099fc3, 0x427d9109, 0xe729dddf, 
	0x277f9a51, 0x69162dc1, 0xcf779f34, 0x57bc228f, 0xd0dbd416, 0xe50b301f, 
	0x1d5dc92c, 0xc6b31621, 0xf41a7d49, 0x360fdc6a, 0x7bf61784, 0x31ed979a, 
	0x133e63f8, 0x8cfb4a16, 0x83489cb8, 0x947fd1f1, 0xa5570e11, 0x43b60785, 
	0xe8e7287c, 0xfd0d3dbd, 0x6f1ed70f, 0x3fa5fc41, 0xfc636fdb, 0xd708f9e8, 
	0x063f72cd, 0x3b424ec0, 0x3e53f619, 0x1ac7a7ee, 0xb85dd827, 0x628a27ff, 
	0x45983763, 0x919b9bad, 0x8be7fa41, 0xed3f090e, 0x27cbf80a, 0x69d85cfb, 
	0xcb4bfcdd, 0xfc7d703a, 0x58ed5937, 0xf61db81c, 0x9a3fac69, 0xd74ed4f9, 
	0xd0df583b, 0x557fbde9, 0xf3c18763, 0xfb26e828, 0x9b7828c7, 0x7dfa314a, 
	0xc13e8fae, 0xb86731f5, 0xca0fa63e, 0x0685003d, 0x4cfb9cf3, 0xf404bf24, 
	0x4e77d99c, 0x88e51e78, 0x6dfa0c37, 0xfa176e38, 0x815182f2, 0x2cdb35eb, 
	0xf0fc8370, 0xa273acac, 0x4f73d10f, 0x3c0553b0, 0x1eb2ae7f, 0xadd4afe5, 
	0x315c11f9, 0x9a5148bf, 0xdc68b350, 0x3f015aab, 0x277555be, 0xefb3c034, 
	0xd5df3d9e, 0xfd9f2196, 0xd41752d6, 0x02f4923f, 0x5e20e7df, 0x0392c30c, 
	0x0e1e8913, 0x24f182fc, 0x70abcdb2, 0xff76be5f, 0xec07aa70, 0x5f5172d3, 
	0x6072875b, 0x8729e114, 0xe4b3ade4, 0x3f9fa857, 0x74c1d796, 0x5df65995, 
	0x0d1b3a2f, 0x3fb469fd, 0x8fa0397d, 0x957981ed, 0xeb0a9b09, 0x95d7ef6a, 
	0xa7df7816, 0x8ea33e8a, 0x75a0c817, 0x3f4853ad, 0x30d2012c, 0x1e105e99, 
	0xd7c32a73, 0x6f6e4f67, 0x5b141ed7, 0x1f07ce50, 0xe14b5b14, 0x8c1a2ebd, 
	0x1487a085, 0x47940995, 0xd7a0617d, 0x7df6f185, 0xeab7bf1a, 0x5054114e, 
	0x408beabf, 0x74447fbb, 0xa3e8ffb0, 0x709bc371, 0xd983d9df, 0xfd58ff64, 
	0xa265859a, 0x03c9fb11, 0x652fd9d0, 0x5dbfc44b, 0x3ed95e33, 0xb9a53e88, 
	0xd8135345, 0xe0e37db5, 0xeff1f3bb, 0xe76b0e50, 0xc7b872e3, 0xbf7d975a, 
	0x98c5bf24, 0x3af0d7e5, 0xaec805b4, 0x50e675ef, 0xec8f803b, 0x0e3c98aa, 
	0x157fb61a, 0x522c7971, 0xf99a7bfd, 0xb1063bb7, 0xad2afa03, 0xf91d3079, 
	0x9441fa3c, 0x888f3e93, 0x07177e12, 0x7a09f50d, 0xf915b07f, 0x0ea6f14d, 
	0x5f7f8091, 0xbae2a98e, 0x054cca7a, 0xbf4f07ed, 0xe0d25a50, 0xd8a112bb, 
	0xc7bf107b, 0x1813f654, 0x4789d20a, 0x613fd3e2, 0x95d2274f, 0xe189e12a, 
	0xf48ca4b7, 0xb932be9b, 0x179fd26e, 0xe33b7f7b, 0xfa11b5df, 0xe6d3fe83, 
	0xf485ad0b, 0xfc8f2304, 0x2157e8b1, 0x890a31ba, 0x7f49366e, 0xe147d0a8, 
	0xd065edfb, 0xe299ea3b, 0xe3c21e58, 0x22156f10, 0x0d86755f, 0x83ec05a5, 
	0x044aea47, 0x28e0efef, 0xb5987efc, 0xea31842f, 0xafd22b44, 0x7f40e346, 
	0x15c80679, 0xc2b2faed, 0x571c2e89, 0xb9bc466f, 0x87e57d6f, 0xbc8ff502, 
	0x3eb453b6, 0x449e36b7, 0x9647f1fd, 0xfc71949e, 0x672ba463, 0xf50a3eae, 
	0x65adf76f, 0x69193eb4, 0x83b4369d, 0xff31af89, 0x20657e20, 0x007a82bf, 
	0xa1b0dbf9, 0xfc50dbf9, 0xc57f952c, 0xd5f31bf9, 0xf3333f38, 0xc153c64d, 
	0xccf7d211, 0x1f5c6382, 0xa3eb9c7d, 0xc7d4a87b, 0x113942f4, 0x5c51a3e6, 
	0xf8831cc4, 0xc776bb98, 0x8ccf38f3, 0x23cf82a7, 0xaf921eff, 0xca7a04cd, 
	0x8f91efe2, 0x697881bd, 0xe437f388, 0x7804ee6b, 0x7e38db77, 0x9747db12, 
	0xb6a2dfc9, 0x1edfc92f, 0x5ea2e48e, 0x57daceb9, 0x6cdbf803, 0x0307d91b, 
	0x18ae9bf8, 0x654f40d9, 0xe6fe4542, 0x28307dc0, 0x3ed20b7f, 0x6361fd80, 
	0x3cf306fe, 0x737f343f, 0x08fb7f20, 0xb7f010f9, 0xb7f0249f, 0x4527dcb0, 
	0x4b896f92, 0xee5d37f0, 0x6d1948a7, 0xbf6be238, 0xa5af841d, 0x33e027f0, 
	0x4b4f5c51, 0xc66870af, 0x37f18387, 0x0e5e67f4, 0xc6d87b7f, 0xcb2fbf7e, 
	0x5f0a44df, 0x1e861b9b, 0xfb7f10d7, 0xfccbffa7, 0x6fe64d4d, 0xd08f6286, 
	0x13d214fc, 0x44ef1c26, 0xb3f007f8, 0xc0439632, 0x161d7907, 0xe12875c9, 
	0x5d4b4875, 0x7fffa987, 0xf8a1b7f2, 0xfd875d9a, 0xc0287e80, 0x8869c63f, 
	0xbe401cdf, 0xce41d8d4, 0x43c622f5, 0xb68f505f, 0x2ee323fc, 0x76b4fd69, 
	0x44207c61, 0xe2e3fae7, 0x27e71188, 0xb67fa07d, 0x6ef8942c, 0x461875a1, 
	0xb8107af6, 0xbe5a51e4, 0x25ff38e1, 0xec9d27b0, 0x7e46180f, 0x37ce536b, 
	0xfd8c3758, 0x080f92e0, 0x0f7e387d, 0x0f674ded, 0xf7d060c2, 0x8370c1f0, 
	0xbb22f0fc, 0xb3d50b7b, 0x08b96c8f, 0x087b1dbc, 0xfe28b15e, 0xb378307c, 
	0x9fc70a1c, 0x15d7ecc3, 0x8f1f6075, 0x15c5db88, 0xff0375a8, 0xd7ea1afa, 
	0xead600a8, 0xc029fa0a, 0x7a59b44a, 0xb245f233, 0x7e12d627, 0x2d9f1f49, 
	0x1a59c5fd, 0xea00b4cc, 0x7366bd77, 0x0f7aa32d, 0xace75306, 0xa41918ac, 
	0x76b6e979, 0x676293c0, 0x5c6a54bf, 0xd9dc4074, 0x4d99c56e, 0x04592cf5, 
	0x337bb322, 0xdbe64dd1, 0xf7ac8a54, 0x82759eb9, 0x70cec3eb, 0xd71f587d, 
	0xfae39f87, 0x27362ff0, 0x7ec8d3e2, 0xe2314a9b, 0x388fae7d, 0xce6bf5c1, 
	0x35faa56d, 0xc229505f, 0x0f54addd, 0xa71addbf, 0x3bcbf857, 0xbebcf5c3, 
	0x0af38c56, 0xc489fb3b, 0xaf5e5ec8, 0x15071491, 0xc08d0f60, 0x4b05745e, 
	0x1d21b8b5, 0xa7fe47fd, 0x18a7f323, 0x605a5fe8, 0xcab1fb47, 0xbcd0da61, 
	0x3f7cbd9f, 0x147741d9, 0x1f1cec7a, 0x8907f649, 0xa0172095, 0x7ab5bedf, 
	0x0abc6259, 0xb3b247ec, 0xd1bd3d94, 0xd2b3c60e, 0x00f3ed01, 0xef902367, 
	0xe41aa7dd, 0x9a79f90f, 0x0ef20ed2, 0x2f8a466d, 0xf8be3979, 0xa35bb8d1, 
	0x58e71a41, 0x7311fa27, 0xb81b9d70, 0x686e582e, 0xffb853ce, 0x5f08a2ea, 
	0xef8f1e5f, 0x19afb75f, 0x527fb4f9, 0x27e48dff, 0x352afb96, 0x5fed453e, 
	0xb49fff24, 0xc12916db, 0x36ccb8f5, 0x06ce17de, 0x14fd0425, 0xb4ce39d9, 
	0xb5ff0bc4, 0xf141e686, 0xee52b34d, 0x0d86959f, 0x53c647f7, 0x1f119ac7, 
	0x76253dc7, 0xf6fe738e, 0x8459c720, 0x158df70d, 0x0fbf44e7, 0xe316bde2, 
	0xd7afa0ca, 0x283ac2e6, 0x621607e8, 0x46e3e027, 0x1806ef18, 0xe31776af, 
	0xf59d8a6f, 0x4ca9ff83, 0x1b87fc22, 0xf69fe274, 0x0534c882, 0x156ceef1, 
	0xe6bd0606, 0x276e89b5, 0xebca9bb6, 0xbdbb41a4, 0x63abb483, 0x8705a0ff, 
	0xc03a6068, 0x0aafec27, 0xb4e2bc53, 0x68479e1f, 0xf10645be, 0xede8a311, 
	0xec6ed4ed, 0x631a54fb, 0x7959404f, 0x53e96be3, 0xad9ac3a0, 0x012f9191, 
	0xbaef7d9d, 0x9a774cf1, 0x432e89c8, 0x77f87dbb, 0x35e68e29, 0xabfb09fe, 
	0x0433522a, 0xee3c6de0, 0xeb7d849d, 0x76b6fb94, 0xc23ca997, 0xca233efe, 
	0xd23e6b16, 0xef5c2cdb, 0x3d4a5c7a, 0xe832f99f, 0xfe8fc487, 0x0b4d7d3c, 
	0xa0fd210b, 0x65df9063, 0x8fe49654, 0xd6743b07, 0x23cff9e2, 0x4e2fa51d, 
	0xd1683927, 0x72ced44b, 0xe81d2ada, 0x35efc7c7, 0x15fd1f23, 0x1dcc13e5, 
	0x47af306d, 0x64b68a8b, 0x2ab3df41, 0x9edb4a7a, 0x425af6e3, 0x1eed0f5c, 
	0x7be2738c, 0xaabb3ba2, 0x6a99dd32, 0x102f4130, 0xfb94ef18, 0xbc68eda5, 
	0x221fa11f, 0xed5f613d, 0x0c97e918, 0xe3b25f93, 0xb7259b23, 0xbf92fc92, 
	0x3ae2bc42, 0xf113dc60, 0x42e8ece5, 0xeb4d4dbd, 0x286f5051, 0xaa8370ff, 
	0x7b2e3c00, 0x07ee3a67, 0x62b3be6b, 0x1da1f5fa, 0x6b5de102, 0xc294d1e9, 
	0x502d6623, 0x9af5123b, 0x5210df59, 0xb56836af, 0xf4c63566, 0x77dc74ec, 
	0x02bd877e, 0xe50b39e7, 0x87d03edd, 0x8412b0f5, 0x7e0a7772, 0x26c1157c, 
	0x8ab58bd4, 0x518bd274, 0xf6047949, 0x827bccfb, 0xcf0fa85d, 0x0fa6387a, 
	0xf6fdbf53, 0x80387d64, 0x2fe930fa, 0x4f87d717, 0x3e9cbfdb, 0xbda4baec, 
	0x43ec3fff, 0x37a4fbd8, 0xdabfeaa5, 0xb5ffb622, 0xfd455d7e, 0xda6755d8, 
	0x08c44ed0, 0x2ffa60d8, 0xfa0937d9, 0xc3ea4bb1, 0xac3eaa5a, 0xf6b87d4b, 
	0x9ab0fa92, 0x3237ef64, 0xf552d49f, 0x0fa91ab0, 0x0fa01ccf, 0xc3ea2537, 
	0x3d944d2e, 0x7f7b3172, 0xe1f5c5e6, 0x8cafdb5f, 0xde1aec3e, 0xd40ae4a8, 
	0xfc4d7f87, 0x37e9a5da, 0xae041cec, 0x782d87be, 0xf4129e98, 0x9f5a26e1, 
	0xfa49e9f9, 0x87d42cf0, 0x07f1c58f, 0x768a8e76, 0x49916b8e, 0x5fab8e76, 
	0x3ee23ad0, 0xead0ba40, 0xccdbf274, 0x6ba7b09a, 0x8eb87d50, 0xda29c9d7, 
	0x969f9254, 0xebcb5c3e, 0xb875c6e0, 0xadfda13b, 0x7af80eb0, 0xe38ff423, 
	0x87d64dad, 0x10a28d03, 0xd8773df5, 0xddbf5150, 0xa3bd0b5e, 0x1264dc3c, 
	0xff90f99d, 0xea83f430, 0xcf27a4cb, 0xc0327a90, 0xa2b6a33f, 0xa5b6f910, 
	0x3c00ceef, 0xd148dc91, 0x4a356797, 0xe396b5fd, 0x608fa8bb, 0x80348f7f, 
	0xfb911d7e, 0x7bd688be, 0xa87bd914, 0xd13c9357, 0x02ad6e09, 0xc71867f4, 
	0xa7d02dff, 0xac99624f, 0x1ea5bb47, 0x62f555fd, 0xa8b3ff5a, 0xdd90566f, 
	0x793715af, 0x21d330d5, 0x515f29ca, 0x78035f97, 0x30da6e41, 0xac5dc4cf, 
	0x811e307a, 0x23d40131, 0x1e4dc5bd, 0x9bdf0fb1, 0xae9fea2a, 0xe21f26e2, 
	0xe4dc5fd5, 0xf1c87b47, 0x49cbaa57, 0x3a1110f1, 0xc8787ace, 0x5973b964, 
	0xd1e50972, 0xd85f7e59, 0x5f43cfcf, 0x1753dd40, 0x6177f6e9, 0xdc689e7e, 
	0x52589301, 0xd5dcee1d, 0x76f17c0d, 0xeb1b8775, 0x6d947b13, 0x303f0055, 
	0xc377278f, 0x0f582bbc, 0x7577bd22, 0xfa91fc82, 0xd00e7bd8, 0xef481a2f, 
	0xf6ef5151, 0x83cd5ca0, 0x8b5b7172, 0x4ea03d20, 0x37647941, 0xffbeb4dc, 
	0xf17ac9d5, 0x870cef12, 0xbd20bdf8, 0x407ee288, 0xd1e82a5e, 0x5410344b, 
	0x561e032f, 0x3f8c5587, 0x742ebd43, 0xa082f406, 0x1cbc6488, 0xf7ca275f, 
	0xa959b903, 0xf4078889, 0x6c5b25f1, 0x289036ea, 0xaf58386f, 0xa4945ad3, 
	0xaecf9f38, 0xed29dc2f, 0xebac08d8, 0xef936712, 0xc3e42ad1, 0x104796e6, 
	0x2dffa926, 0xa01c03f1, 0xa3192d4b, 0xc35d7147, 0x1e302fa8, 0xc235fbf3, 
	0x1fa59feb, 0x901c7e58, 0x5f684deb, 0xef383836, 0x9c32a335, 0xeaf4113f, 
	0x9fea2725, 0xa7197997, 0xfba86ed1, 0xbb02a4ce, 0xaf2de30b, 0x5ca17815, 
	0xa349a3f0, 0xf85ca133, 0xe746d78b, 0xefe8b942, 0x80298d27, 0x9f07ee72, 
	0x7182298f, 0x2a282edb, 0x2f3423c6, 0x744e09e7, 0x497ebc72, 0xb9392096, 
	0x1f3ba3bb, 0x3547def5, 0xf8842c71, 0x2dcfcd1d, 0xf79e03bd, 0x62105e84, 
	0x81977c2a, 0xf7e3e2eb, 0x27ac9c0b, 0x1af87f96, 0xbdb775c9, 0xe3068d53, 
	0xe2c4f7f8, 0x64268e02, 0x554cda3c, 0xe49369ca, 0xaadcb6ba, 0x36d67f33, 
	0x151d725a, 0x1567e462, 0xff033d56, 0xaca8e19d, 0xab4c7b40, 0x7d72c0d8, 
	0x76f5cb11, 0xaf5cb247, 0x49ac7c5d, 0xb17d23b4, 0xc1cd7f5c, 0xfd3d9df3, 
	0xbe154edd, 0x4d1b75af, 0xbc8fb06d, 0xd76d5533, 0x1d8bac28, 0xd4be4758, 
	0x215af806, 0x46d66fe9, 0x427e4553, 0x39f00efc, 0x442d4eb3, 0x9b09e0fe, 
	0x009bcb6a, 0xe94dadcf, 0x47b71fb8, 0xf2a5ef98, 0x003f54b9, 0x28857fd8, 
	0x9da91e47, 0x0e6a7c40, 0x2225abcc, 0x206b97f9, 0x1679a39f, 0x30361e21, 
	0x89395bbf, 0x6be49119, 0x40de6e33, 0x6fd52b7c, 0x05fe41e0, 0x03e7b970, 
	0xe716db9f, 0x7e6e336b, 0xafc887ed, 0x5b5f2abf, 0x3ca0ace2, 0xd78883e0, 
	0xbc1fdc06, 0xec3aadcf, 0xe5b67dc3, 0xe2224fb4, 0x9277dc65, 0xfe985afe, 
	0x83b645fe, 0x3ea2a67d, 0xc5b2d0e1, 0x07ac5296, 0xd7056385, 0x2ae4981d, 
	0x9a7185b2, 0x014a99da, 0x7c4109b2, 0xcf57fb13, 0x61415c20, 0x0ec82adc, 
	0xae0e5031, 0x5f8a4d34, 0xc6178060, 0x33d33db7, 0x91d220ed, 0x0e30375d, 
	0x3d83f7d7, 0xd960af9c, 0x920f6823, 0x9fb3ae5e, 0xaa6fe7fc, 0x1c9fc0ed, 
	0x584d6d6d, 0x7f60e53f, 0x87da4780, 0xa1767f60, 0x62760efd, 0x9a87da13, 
	0x9072f817, 0x68bd21db, 0x4fd26195, 0xfd1d41a6, 0xd98b7dcd, 0x83e6d3de, 
	0x42f9885d, 0x79cb3931, 0x7f07c45d, 0x9ea0fdcc, 0x14145ae7, 0xfcbb9e5b, 
	0x54273c7e, 0xf08bdaaf, 0x5c97fe31, 0xd6eff9cd, 0x807ae27a, 0xe4e71784, 
	0x3f6858fe, 0x080f10ef, 0x2fa45864, 0x6dd8012c, 0x7ff9f067, 0x4122f3f0, 
	0xed50c17a, 0x97af5ffe, 0xbfa17fc5, 0xfbbfe41e, 0xfee5ced0, 0x12df08c3, 
	0x29144a21, 0xbef06c07, 0xe53f6d7c, 0xc9e17e7d, 0x79fe5270, 0x5fe4e7e5, 
	0x3b6af901, 0xe705fc60, 0xb4f985e3, 0x50cf9c0f, 0x2fff53e3, 0x923e384b, 
	0x871cbfe3, 0x36d8e087, 0x0bc47c70, 0x87c681e2, 0x7b72fbf9, 0x89095ff4, 
	0x7b0fe44f, 0xa5df4984, 0x0dbed1c0, 0x9a047c08, 0x66a760cf, 0x4f50b949, 
	0xbedf3dc3, 0xbd87ca4d, 0x4bd42e52, 0x4242f139, 0x9c8a5b3e, 0xadf920d8, 
	0xe7ceed07, 0xf4754ed8, 0xe94bb40e, 0x5db8d8fd, 0xdbfca97a, 0xc58e920d, 
	0xafa493b1, 0x0653bfab, 0xc8874bb7, 0xfc0317bf, 0xd6c120d7, 0x69661c20, 
	0x7f0473d3, 0x307ab287, 0x36948f38, 0x70f978bd, 0x69c16c3e, 0x3d79407e, 
	0x1347ba27, 0x5c83379c, 0x18d8fb21, 0xe445f64b, 0x7824f496, 0x561505b5, 
	0x9de4895c, 0xca677fc5, 0xf6068bb8, 0x1ec13040, 0xe389b940, 0xa6cc7ad6, 
	0x2e885d36, 0xa9eb8f27, 0x7e87b907, 0x97788f1e, 0x5b77899b, 0xd909ffb1, 
	0x7ee31307, 0xd90639b5, 0xd646ee89, 0x26fdddd7, 0xfd3113d9, 0x0bd9623f, 
	0x3df3b241, 0x2fb24d2b, 0xfda51afa, 0x83e388b6, 0xe1bb54de, 0x2c1bb62e, 
	0x367289f9, 0x39206ed1, 0xd1ca547a, 0xd3f2e2bb, 0x9f28a792, 0xb3cbee19, 
	0xceae481b, 0x931e3960, 0x8a7df4ab, 0x47201d3c, 0xe520dda5, 0x876f25b1, 
	0x9e481bb2, 0xf47290ce, 0x5afe5c64, 0xaee495f2, 0xebe4257e, 0xb18fd3fe, 
	0x51e6b9de, 0x2859cfa0, 0xfe82d607, 0xed541b0b, 0x1fc87823, 0x903fa068, 
	0x8b51d7fc, 0x3ffed20f, 0x13b1f9ee, 0x1fe4a9fd, 0x82fd265c, 0xa5efd147, 
	0x845c77a7, 0xe4c5fcef, 0x441faa6e, 0xf7e15718, 0x25dfb8b1, 0x23b522fc, 
	0xb1c67e6e, 0xf64df515, 0x045f908f, 0xbf8471fb, 0xfd15be9b, 0xd138ef22, 
	0x356ea22f, 0x05b27f73, 0xea7f4fda, 0x2d4f28bb, 0x8bf54f7a, 0x12451bb8, 
	0x1a567bfd, 0x025f1ce9, 0x9835d93b, 0xf7f3845f, 0x4788bf2c, 0x53b841e6, 
	0x64ea20f3, 0x8ba2c41e, 0x347c41e7, 0x77ca03ee, 0x68fcbb20, 0x8ea47f82, 
	0xeca1dbed, 0x6af9bef2, 0x2c1fa25f, 0x79e42fc6, 0x7e9f7c09, 0x495efe3e, 
	0xdb8cfa93, 0xaa48ff24, 0x1cfd043f, 0xad63e49a, 0xeaffd740, 0x087cbcbc, 
	0xf167dfcb, 0xcf905bd9, 0xcc41e425, 0xc188ff44, 0x69f58a7c, 0x86dbdb90, 
	0x0b7d53e6, 0x1f3179ac, 0x952dd6b4, 0xf129697f, 0xc7caafc2, 0x3cfe4936, 
	0xf3c33f14, 0xc0e31f7f, 0x33267c56, 0xed21fcd2, 0x87b3b327, 0xfc1fa026, 
	0x9ebc608d, 0x35faa34d, 0xd79a54fd, 0xea176498, 0x1f6c23e1, 0xafdf9186, 
	0xf5bfacda, 0xde78fe9d, 0xc8e6d669, 0xd377761f, 0xf6a2c0f9, 0x7b2fb426, 
	0x843eef46, 0xf39ed9e7, 0xbe3034ec, 0xf70d3a32, 0x68bc6a75, 0x16718e34, 
	0xa61d33cf, 0x472cb3bc, 0xd32393f8, 0x45485f30, 0xa39e2a77, 0x60d58f13, 
	0x5b4769bd, 0xdbf5d613, 0x7e9d5cf9, 0x4bbd7d16, 0x39d2742f, 0xcba3c0ab, 
	0xefc56e3e, 0x6181158a, 0xda77809d, 0xa58f3e02, 0xbb40b767, 0xe97a15aa, 
	0x19beb2e3, 0xe36df236, 0x7700699b, 0xd07e4aab, 0x5a934679, 0xcea27c02, 
	0x40256d50, 0x8e351b27, 0x6b79dcbb, 0xbc019024, 0x68987caa, 0xbb261c7d, 
	0x49b4faec, 0x15afa021, 0x413daa4f, 0xd7aea780, 0x5ff4899d, 0x155dbbd7, 
	0xcfc78051, 0xb02aec7a, 0x1e40b3eb, 0x9c7170cf, 0x6ea3e2c6, 0xbdbcafb1, 
	0xc539da0b, 0x7ed8c3be, 0x18ffc458, 0x6a9eeff4, 0xb7f60dfb, 0xff8f4c74, 
	0xfef41989, 0x9f5083a9, 0x289919af, 0x21c901c7, 0xbf495bf2, 0xaebfe5be, 
	0x8dd0785e, 0xb3957dfb, 0xcfccda26, 0x78c81ec9, 0xcca85f78, 0x7f7bfb40, 
	0x521ffa33, 0xd3d7ebf5, 0x4962de58, 0x8fa9447e, 0x97558a3a, 0x3cf64233, 
	0xaf7ac1e5, 0xe8187a83, 0xfe57cee9, 0x3ed7f184, 0xf627f1a7, 0xc744e9eb, 
	0x2ac3f655, 0x173353da, 0x4c971e31, 0x8c7ebce4, 0xb15da011, 0xa8538e4a, 
	0xb24b38f1, 0x7d697cf8, 0x7b4559b0, 0xb7663aa4, 0xadaaf3f3, 0x5fa1766f, 
	0x63ea5aa2, 0x9db1a4ef, 0xefc7c4be, 0x3b6348df, 0xcd44babe, 0x44b0f947, 
	0xfcbefd63, 0xf7940dc3, 0xf333aee7, 0xd9f46ed1, 0xdfc62f39, 0xb20be7a0, 
	0x6fef394f, 0x805a8f69, 0x179e24f2, 0xe919a873, 0x52613020, 0x065be607, 
	0xebfb2766, 0xbaac6303, 0x607d7641, 0xdfe49e91, 0x54b476af, 0xf5b7bc20, 
	0xb8e01456, 0xdf6c7181, 0xfb02e37f, 0xc9812237, 0xbfa8dfe4, 0x6ff275e6, 
	0x7ce348ec, 0x4fd7e5be, 0x9dc73f26, 0x531f5f53, 0x2eb7a50c, 0x6051a0ac, 
	0xf9aac1f1, 0x77dfe46d, 0x2abf624f, 0xa5ea13ae, 0xd1ddae33, 0x2a807e85, 
	0x304403f4, 0x76d5407f, 0xbd75873d, 0xf00fd13d, 0xbfe31a51, 0x2bac2366, 
	0x803f673d, 0x3f209167, 0x6c2c3780, 0xbea807e8, 0xdbb1fd9d, 0xb0cb801b, 
	0x3f51739e, 0xfd2ead40, 0x77ac2500, 0x2e1e02d4, 0x7c2007e6, 0x1ade2114, 
	0xc9e9df99, 0x1bea807e, 0x7803f707, 0x0c891f51, 0xdf5403f4, 0x00fc6578, 
	0x9281abd3, 0xac7c20d6, 0xe8a7573f, 0x4eb70ecf, 0xe302ece7, 0x82b9fd2c, 
	0xd297e9e2, 0x78901f9f, 0x49efe617, 0xfd7b7e7f, 0x5cee52b5, 0xa05b39ee, 
	0xd9ce41f8, 0xf9f31606, 0xf7038246, 0x8b785147, 0x58e12c23, 0x2a38e126, 
	0x6bf680e1, 0x0acf38d2, 0x63cd25e5, 0x10d1c731, 0x08638c7e, 0xc5c930e3, 
	0x093a3fec, 0x58d3b7be, 0x67050c7e, 0x75e119e0, 0x57f41d82, 0xfa405db2, 
	0x2388964d, 0xd240dac3, 0xfd2d2a05, 0x0488645f, 0x38cad7bc, 0xfff50053, 
	0xf5843d24, 0x418f2aff, 0x8d71fffa, 0x267b84f9, 0xf847fbd0, 0x9b877f5c, 
	0x3c60efe9, 0x33f28021, 0x85502e21, 0xfd1b3572, 0xb2e86af7, 0x948366e4, 
	0x9749e19b, 0xc8d7ffa5, 0x427781b8, 0xab5ffeb2, 0x0371c9ab, 0xd757ffa9, 
	0x57ffa4a8, 0xc0c5be21, 0xfe94347d, 0xfac23b3f, 0xdc5fee3f, 0x88f1b34f, 
	0x1f641891, 0x8fff52e9, 0xe40dc4a4, 0xd9f6b43e, 0x67bffa50, 0xb4ffeb31, 
	0xf7c64e7f, 0x1b8e95dd, 0xfcc29f20, 0x2b079213, 0x2266df88, 0x0fedbdff, 
	0x5035321b, 0xfb4f6fb2, 0x33706663, 0x0fe1d1c8, 0x7d436565, 0x7a74c68a, 
	0xb31fe147, 0xcefcf0c2, 0x561f5feb, 0x09fdc0e0, 0xe7fd0412, 0xe7815e9a, 
	0x6efe9679, 0x41dda652, 0xebd3357c, 0x959abe20, 0x9abe20e9, 0x7e20eb95, 
	0xe359df4a, 0x3cd259de, 0xe4b5c70c, 0x298f3591, 0xd7aece92, 0x5e9c3f58, 
	0x4e35937d, 0xe9638d13, 0xad11c513, 0xfce49bbd, 0x3bd40cae, 0x764a4586, 
	0xb9133e81, 0x93db2d3e, 0x857fe925, 0xb6069394, 0x80d529ef, 0x4b4efe4e, 
	0xf8c6b38e, 0xc417bc08, 0x165da647, 0xf167991f, 0x42ff0391, 0xb7c174fb, 
	0xd3ef26a7, 0xf685ffe3, 0x25af67e9, 0xe4de839f, 0xe746bafb, 0x5b0cdb75, 
	0xf2f2b9e2, 0x8b9d2671, 0xa59bd40f, 0x4757a5aa, 0xd5e8ebe3, 0xc5cf0d84, 
	0xe639e1bb, 0x4f40055b, 0x1d5d7f23, 0x7ae2ebfb, 0x5141fb16, 0xebc44acf, 
	0xa8d7895e, 0x23e5f394, 0xc9bc6f2f, 0x43759f38, 0xf7c9bb8f, 0x2cff6680, 
	0x6cd53e61, 0xdf7b7a37, 0xffe5211a, 0x5a57cc3e, 0xe81fd4ea, 0xba4c73a2, 
	0xd2f9bdb1, 0x36f937ef, 0xaf49e126, 0xf9377ee1, 0x9bf8c9a2, 0x5e03cfc9, 
	0x9e60afbe, 0x7623ea4b, 0xa33aaba6, 0xfe0416cb, 0xfbae5db4, 0xf94eaf42, 
	0x7516f331, 0x991ed0d9, 0xb7ef0ad7, 0x45ddc425, 0xdded93f8, 0xdc89f7a8, 
	0x0269b06d, 0x32860f53, 0x231bdf50, 0x1d1e3ff6, 0x9e6e8e78, 0xd1a04fc4, 
	0x4ce7cf8c, 0xdf26fdfc, 0x8ebecd5e, 0xf762e6e9, 0xc1e7944a, 0x7a5db47a, 
	0xa64f403d, 0x0f5a32fc, 0xfe3d7031, 0x6c3b6341, 0x204d8956, 0xda36fe9f, 
	0x3807dfe1, 0xafca35e0, 0xd0444b87, 0x6b9f113e, 0x3d039764, 0x3f826a18, 
	0x4263f2d3, 0x4cf5137b, 0xef83e603, 0x474dff61, 0xd2dbfd3b, 0x3c04af0e, 
	0x785cf107, 0xbc6bf5e0, 0xc5047768, 0x6f3fb887, 0xed45c253, 0x3f87a495, 
	0xb97d86ec, 0x617d5362, 0x8ac0ea08, 0x1703401b, 0x73eab577, 0xa25d9246, 
	0x2f4ce4c7, 0x83354db2, 0x957709fc, 0x11e1b41c, 0x9acabbdc, 0x3deeb02b, 
	0x0d3135d0, 0x93f858e0, 0x4f510771, 0x77d3ad8e, 0xb0e4c62a, 0xd705bfde, 
	0x3bdf1be9, 0xfc043a35, 0xaa1ff6f4, 0x075748df, 0x9bf413ae, 0x0be7028e, 
	0xfd0d51cf, 0x63ad43b5, 0xf3907f5f, 0x072c22fc, 0x1466fcd3, 0xc05a7fe5, 
	0x99468cec, 0xc5cf284f, 0xf401c5d7, 0x71fe2514, 0xb003ee96, 0xddeeb1fa, 
	0x027bc808, 0x278ef936, 0xcb4cf3d3, 0xfcd5f13f, 0xafe85515, 0x7a7d4348, 
	0x99e72e5a, 0x3e2bfaa7, 0xd9af30d6, 0x5d5457f2, 0x4b0afecb, 0x57f00f3e, 
	0x7f64d584, 0xe7488345, 0x8cbf8e3c, 0x3f9622bf, 0x31b73b10, 0x03f9a2e9, 
	0x5f6a157d, 0x3a08bf6c, 0x4624d867, 0x34ebc424, 0xbb633bf6, 0x5e12f5f4, 
	0x8bb86fe8, 0xf41b89f7, 0x57f1cbf4, 0xce5f5cd8, 0x0c37315f, 0x879c2523, 
	0x1cf995ad, 0xfa2557a8, 0xabd2862b, 0xf9ad2afa, 0xad66deb1, 0x15beaa5b, 
	0xf8e7c948, 0x05d77aaa, 0xd286c729, 0x26f936bf, 0x19e912b8, 0x7f3390cf, 
	0xca25752e, 0xbcf63d03, 0x1a3da92c, 0x4def3826, 0xcf49c9be, 0xf9eb1acd, 
	0xc7fdc94d, 0xa4b4fff8, 0xeb6acdfe, 0xf3f26579, 0xf16e7e2a, 0x5ca4f7fb, 
	0x919be4d8, 0x0f1c870c, 0xdfca79ec, 0x6ff60b74, 0x0ea17c59, 0xc0db50f0, 
	0x9fbe9065, 0x9caf0c97, 0xe5932047, 0x1140a04f, 0xeede813b, 0x321c7177, 
	0x09cfef20, 0xc7964c4c, 0x7f58bbb7, 0x74817e40, 0xdf6fdb75, 0x0cbee1b2, 
	0x7fb1f1c8, 0x5d405bcc, 0x279ffb14, 0x7c9b6bfd, 0x0decbbb7, 0xf941af52, 
	0x96f40e3d, 0x28fc0951, 0xeb251766, 0x6c5ceb33, 0x538ea797, 0x66a98b07, 
	0x0b41f325, 0x8e0370ae, 0x5e327f77, 0x7b794867, 0x53ce86a2, 0x5d47323a, 
	0xe69badbb, 0xefe473f9, 0xd7e88281, 0x6f1cb077, 0xf6936edd, 0x423fd90c, 
	0xe7b77d21, 0xa4dfbe3d, 0xa2f52c2e, 0x2cff689b, 0x79a1507e, 0xd027f4c6, 
	0x110dfab7, 0x98ae9bd3, 0xcf2c547e, 0xd3fe82a7, 0x7bade52a, 0xe9bfbc7d, 
	0x4b79f25a, 0x6d15dfab, 0x250eb7ac, 0x2587cb77, 0x92de6ffb, 0xc5dba2fc, 
	0x76911374, 0xfd8ba756, 0x534db704, 0x5663286d, 0xbe08ffa0, 0xff72d6f7, 
	0xd3f89cf0, 0x2aeddebc, 0x82ac4de6, 0xc05eb211, 0x20ccccfa, 0x5c37a9f0, 
	0xeb930ed2, 0x35add167, 0xb8e4cfee, 0x37a9432f, 0x9aa7ffa0, 0x88ce69ce, 
	0x06743698, 0x79f9caa6, 0x9301dfd2, 0xa0b573a0, 0x40b894bf, 0xdf79017f, 
	0x0339e785, 0x1a267aad, 0x5e785f3d, 0x863d4972, 0xcc9f73d6, 0x06e65e03, 
	0x2e223db9, 0xdeaf14f7, 0x91a9f78c, 0xfd210cbc, 0x7e992cfc, 0x9bf7936a, 
	0x7112ddf5, 0x3b91d86c, 0xe7372fd8, 0xc8d78405, 0xdbc50dae, 0xf9faf7e1, 
	0xddf8f7f8, 0x4ecfa20c, 0x45f69d97, 0xa8bf3277, 0xff40ed96, 0x3b8d7cc3, 
	0xfb5b9d25, 0x9f27d2ca, 0xeafb5970, 0x9b57da2d, 0xe64cbf7c, 0x72fe310f, 
	0x0cf9f92c, 0x497bf9eb, 0xee3975cf, 0x167d729d, 0x9645fd9e, 0x74ffcf06, 
	0xd003ec01, 0x9c5daa87, 0xd463f41f, 0xaed01a99, 0xc1f2413a, 0x95cbac19, 
	0x387212e7, 0x2aedbabf, 0x3faaebc4, 0xbbfcf2e9, 0x0279e2ae, 0x6fe72547, 
	0xc4e8bec1, 0x6f3c2afa, 0xbb884a70, 0xcd416d6b, 0xd3557945, 0xc730e912, 
	0x5bf0f4cd, 0xd4763749, 0x39e25737, 0x3f8fd654, 0xcf93e785, 0xbca5fbc6, 
	0x7a97dc6e, 0x7798bbed, 0x5d54f19a, 0xf7ca3b54, 0xc43ca15b, 0x0f30aefb, 
	0x67490bf5, 0x253e789f, 0xdfb03bfc, 0x7f792c5e, 0x5093faad, 0xc638055e, 
	0x70f3f8c1, 0x9e3ce5dc, 0x8b98d837, 0x73e61476, 0x7df39705, 0xc467e844, 
	0x03de62f9, 0xef3847b6, 0xf9bbb428, 0x77daadfe, 0x005e5ec9, 0x1e2472fa, 
	0x10b19a77, 0x3c608bc6, 0x241fc60a, 0xb05edd3f, 0xcbfcf28f, 0x1e1f3932, 
	0x7cbcc1e1, 0xdbd79b97, 0x1ce194be, 0x5d3e66ee, 0xcedc9056, 0xfbf996ef, 
	0x3b58ee12, 0x788f5f99, 0x7865eb6c, 0x6e02dda9, 0xfa1bcd67, 0xe76d5e57, 
	0xf10d75f7, 0xc758da73, 0x5e25b57c, 0x326f9958, 0x0f7f239f, 0x1fa1a1e6, 
	0xaf306bef, 0x7e4e7a1e, 0xa17ed381, 0xbcd08f44, 0xdb7d9f28, 0xe4e69b02, 
	0xdc4745f7, 0xc7452f44, 0x1f5d7f28, 0x63eb9c7b, 0x749979e5, 0xcc20cf3a, 
	0xf7a0338c, 0xc962bd05, 0x3ecf9467, 0x98fb8dce, 0xaf11d8f2, 0x43aec798, 
	0x0cf6b5bf, 0x3d4fd7c4, 0xefd1bad7, 0xcc037186, 0xcdbaf42f, 0xd32fec76, 
	0x3e44efa3, 0x476ab355, 0x65853886, 0x7ca8d3fa, 0x09ebadcc, 0xa16031d9, 
	0x3f71ab8b, 0xa7f5b8d4, 0x1fb77e11, 0x352743da, 0xb0841f45, 0x27bc99fd, 
	0xb09fa20f, 0x910cdb26, 0x3c63c6df, 0x7a834c6d, 0xea357e87, 0xf6466a29, 
	0xceee91af, 0x46e4dde5, 0xabbddaff, 0x802d3fe6, 0xbdcb41ee, 0xb5c605ba, 
	0x20643495, 0xfde4b29e, 0xbed25934, 0xb9a6f333, 0xee4e8033, 0x12fdc91d, 
	0x9fb1471c, 0xd5afc25a, 0x63497e7f, 0xea4bee06, 0x3ebc612f, 0xa1f8a4d5, 
	0xb0476ea7, 0x9bef1865, 0x2e4a6c3f, 0x1c0d1f71, 0x5dc68eb7, 0x9d96f6bd, 
	0xe8613f38, 0xde8fdc0e, 0x210dde7b, 0xcdaf575e, 0x7ec04f78, 0x9bd801af, 
	0xbeb2df30, 0xefe7072e, 0x633eafbd, 0x9f6a49de, 0xafb62af1, 0x7e842f7f, 
	0xf9ab39e4, 0xcbfb921e, 0xab53e254, 0xaed7bed7, 0xcbbdfcc2, 0x1698c8ef, 
	0x6c33c04d, 0xd6479c69, 0x42877aea, 0x79a0c2fc, 0x1f7c7f61, 0x7bc0ee88, 
	0x0caab238, 0x939b67ca, 0xfba1de2b, 0x778d7231, 0xf7c34750, 0xa3e13f78, 
	0xe3559f72, 0xdf002a3d, 0xc33d1cec, 0x60718568, 0xd0cffa5f, 0x30e68b7d, 
	0x451cfbb4, 0x9fbee34f, 0xd0866fd3, 0x67a73d1f, 0x13e2065a, 0x827463ef, 
	0xfa1ab95d, 0x6b720ade, 0x6c551eee, 0xa2ea197d, 0xe90a9bf7, 0xf38523bd, 
	0x836fc025, 0x93232bd4, 0xe4595fa5, 0x26f7de50, 0xbd359fe6, 0x8f8c219d, 
	0x064745d8, 0x56782dd6, 0xaf98f7c3, 0x7e52b7d4, 0xc076c65f, 0xbe8fa95c, 
	0x33ed7c88, 0xf32613b4, 0x9f7e06fb, 0x0de79a35, 0xde97dc28, 0x9c7beb87, 
	0xd92b57d6, 0x3c06ec15, 0x2fd97967, 0xfb207fe4, 0xe00f5c55, 0x6ada1d43, 
	0x3df24bc6, 0x01aed038, 0xf4e818e9, 0x8635d124, 0xb59cc4c9, 0xe72e893b, 
	0x8e719ec2, 0x40e93926, 0x0fe690fb, 0x903ef378, 0x6e282c51, 0x8a819551, 
	0x592bbdf6, 0x4345dbae, 0x9eefb48e, 0xf7f6856e, 0xd6d2f3ca, 0x048df778, 
	0xfe81effc, 0x351c8c3b, 0xed99e388, 0x9cff444d, 0xd61ab06f, 0x7fe809ea, 
	0x8f56e835, 0x477f8c4d, 0x207bbef8, 0x261afb9e, 0xf3259db3, 0x6f225611, 
	0xc7a09738, 0xf2993fdf, 0xf03d71e0, 0x43c601ec, 0x639fce29, 0x5b5d44ec, 
	0x44ee5638, 0xdcbb9e3a, 0x80fe40c8, 0x6eb8bff9, 0x6ebc99dd, 0xecf21a73, 
	0x6a0e819b, 0xc79d604a, 0xaf045e63, 0x3ffa167b, 0xde73c65e, 0x5e789e12, 
	0xdd712861, 0x84191f01, 0x0b7ef857, 0xcb677d94, 0x72fede19, 0xb2c73f6a, 
	0x89fa523b, 0x1dd8a7ad, 0xf3ff6eec, 0x74e313d7, 0x0abda728, 0x22409beb, 
	0x2cfec8eb, 0xb8a3fe81, 0x48327b9e, 0xc72ceb8e, 0x475a2ec1, 0xb2350570, 
	0xa22f88ab, 0xbf22209f, 0x1253ba43, 0xbfb609da, 0xad3ad232, 0x7f3246f3, 
	0x3a5be397, 0x5f02f3e6, 0x6bdf8b4e, 0x96f8c511, 0xc5196d73, 0x17bf30b7, 
	0xadd8f2f1, 0xb39d3f36, 0x778e4e2f, 0xcec61739, 0xe89e90af, 0xf5df73c7, 
	0x78066e32, 0xe7591675, 0xbdced855, 0x0a1b0fed, 0x3db82f50, 0xe8058fed, 
	0xfc365ae7, 0x2ed9d1a1, 0x0e8ee7f2, 0x8dc57d43, 0x82298d0f, 0x1fb75dfa, 
	0xf609331c, 0xf66e67ff, 0x2eac66f7, 0x750f1fcb, 0x65ce75a7, 0x1bdf73a8, 
	0x5be74982, 0x7931f162, 0x36e7dbee, 0x02f718a3, 0x60e2891d, 0x189f7f98, 
	0xc3cabb07, 0x51b0287c, 0x3ac3e524, 0xa60e388a, 0xc3e50585, 0x15d7affa, 
	0x2f85838a, 0x59e60e2f, 0x4c1c73a4, 0x007bede6, 0x838b171f, 0xbf5e6539, 
	0xffe648b3, 0xf2d83b4b, 0xfc795bd7, 0xcad1ce03, 0x49b4d87c, 0xca3071c9, 
	0xe57a3fff, 0x4b9dfcf2, 0xeec18ef5, 0xfcc8f0a5, 0xfc4a672d, 0xb741cf06, 
	0x24455d01, 0x38e3ed7e, 0x85ce821f, 0x073e2b50, 0x3b13c162, 0x24675ee7, 
	0xebb7739d, 0x3b43ce82, 0x170efef1, 0xe3e51dd3, 0xd284fee0, 0x6bbb2139, 
	0x741efbd0, 0x93a9efe9, 0xfbd49c7e, 0x3f67ae1e, 0x4ea36042, 0x3e91a1e7, 
	0xf5c9465a, 0xa0e3293f, 0xa58dd147, 0x6b66f9d3, 0x1e32fddd, 0xf3c5748a, 
	0x8e38bcb8, 0x9d27a237, 0x61b600ff, 0xe38e2c1b, 0xf2a0e2b4, 0x3948bd3c, 
	0xc4bce1ff, 0x83a20ff9, 0xff9f4319, 0xf3e15c70, 0x7fd55f1f, 0xc3fe93e8, 
	0xbee7a134, 0x312a3981, 0x9e7de1bf, 0x3c273cc4, 0x49fa8677, 0xdcf84e9c, 
	0x43ef25fc, 0xfe0d85d0, 0x65fe708f, 0xf45843ee, 0xc087dee7, 0x7de0727c, 
	0x086fd208, 0x86fd12ed, 0xfda47acf, 0xb845ef20, 0xbb70df94, 0x0dfacbe7, 
	0xbf04a461, 0x1e6715a1, 0xb8c1cf70, 0x7d5d73e4, 0xafef934b, 0x3afbd2f9, 
	0xa9789fc5, 0xf3065e7d, 0x25f9ff24, 0xc64bbbf6, 0x63d484e5, 0x9dfb7e91, 
	0x931cc784, 0xb9e99bce, 0x29af3847, 0xafd718f7, 0xabf5ce3a, 0xc77ca07a, 
	0xa24fdd63, 0xcfcbdd5f, 0x5b3a46af, 0x6d39141d, 0xce7f41d3, 0xbdc738e6, 
	0x049e8258, 0x8f9d0626, 0xafb617bd, 0xa7bd02f1, 0x9abdc6b8, 0x4ff41426, 
	0xdfb4171f, 0xcf3c4594, 0x08a0d9b5, 0xc2f7c19d, 0x0dff5054, 0xb8c67f8b, 
	0x3953d807, 0xafc98fb8, 0xd34ffd01, 0x020aae2a, 0x3f9f32de, 0x97f3027e, 
	0xa9b9a645, 0xc405a693, 0x4e105ebe, 0xd5961ee8, 0xf097f361, 0x75c369df, 
	0xa4afcf03, 0xf6866f9e, 0x5d9ef123, 0xf17d46ff, 0x0cc3d204, 0x361a6fbe, 
	0x777f7e0a, 0x98c7df64, 0x76bb3337, 0x9fbc16d2, 0x77ccc66e, 0xb91f2277, 
	0xa5b2523b, 0x5011e619, 0xd9069dcc, 0x83d8437d, 0x4fd8cf46, 0xf1f7689d, 
	0x11de20fa, 0xf31ceb7e, 0x9e3fb98c, 0x69c4768f, 0x6481d83f, 0xcbd2081f, 
	0x03a39c68, 0x691471e1, 0xc16a6f3b, 0x91910473, 0x05c11df8, 0xead369f0, 
	0x8e601646, 0x791f4db0, 0xbbf1e125, 0xbf9266cd, 0x4c07df98, 0xadbfb02f, 
	0xe1c9ed99, 0x13bea2ef, 0x86cc7fd8, 0x7862ff75, 0x80f784de, 0x8ef94a7e, 
	0x9b13fd01, 0x0f06f41d, 0x57c027ea, 0x3362dd32, 0xa47fadd2, 0xbc02b6a9, 
	0xd51f5ca2, 0x7071f64a, 0x3f5fee14, 0xbfa0ddba, 0x57ef2f22, 0x10a531cf, 
	0x7a5a1bf9, 0x0166a74c, 0xa488f1c2, 0x3cae4b2f, 0x9809e922, 0x43df1e54, 
	0xb3c6f326, 0x8f58f21b, 0x9143dd8c, 0xe854f74f, 0xc302ffac, 0x987d6428, 
	0x369f56e5, 0xd1b0e982, 0x1ef89332, 0xc8cd3504, 0x107be0eb, 0x7be0bff2, 
	0x93f76211, 0x637ee31d, 0x197abee7, 0xe5ef3a4e, 0x6c31888d, 0x73cb43ff, 
	0x8fa57798, 0x164cbc41, 0x098b617a, 0xa7bf7efd, 0xf29ff310, 0xf7a4958d, 
	0x503e8a07, 0x3bcc1745, 0x517be4db, 0x37641582, 0x7ca4dd0b, 0xe37973b5, 
	0xa60f28bd, 0x911cfda3, 0x473d3df7, 0xe46afa72, 0x7a3b319b, 0x65b0674f, 
	0xb476d0f7, 0x9ed1da47, 0xee5d1d98, 0x76ba3b45, 0x5157c8fa, 0x61f5c35f, 
	0x7bccd53b, 0x678495db, 0x2eb5bbc2, 0xbc7df784, 0x6b67887e, 0x3af4aefd, 
	0x3f0e1e04, 0xd036764e, 0xe037bc8b, 0x0fcbaeca, 0x1d706323, 0x52225d68, 
	0x92efe04f, 0xcc74f1ee, 0xe73fc956, 0xb76bceb6, 0xfa3f205d, 0x81bd2ddf, 
	0x4432b1e7, 0x5f2d06f9, 0xf0fac29b, 0x2c145a75, 0x6718e129, 0xf0372f4c, 
	0xd303d4be, 0xc7563ee9, 0xd3b42681, 0xf342251c, 0x7339429f, 0xfaabad0f, 
	0xeff9531d, 0xb4ae9504, 0x74b8a5ed, 0x81dae900, 0xfefc4765, 0x77cf4b74, 
	0x471e4664, 0x8a63bfbf, 0x7af18c38, 0x5a29ae47, 0x688fd0ab, 0xac036fd2, 
	0x3ba973c2, 0xf2e7da12, 0x1cbdebf7, 0xa5555987, 0x64afbf27, 0x97b6f87a, 
	0xc8f714e3, 0xbdeb427c, 0xa026f790, 0xfc01dc3f, 0xdf1d6339, 0x15f64073, 
	0x07a3cfac, 0xe112b744, 0xc03d40f5, 0xd85e2c5f, 0xf14a9076, 0xccfbee0a, 
	0x6def0848, 0x73eee7f5, 0x3ee8376d, 0x50dbfd8f, 0x9514ab4f, 0x7f48a718, 
	0xdf86d1b6, 0x92e9ed2f, 0x1b5189f9, 0xf5b76fda, 0x8df55db2, 0x2147600b, 
	0x8fbd4f3f, 0x12f382b0, 0x5d74f763, 0x42d7b317, 0xd1bf8ff8, 0xe83447ca, 
	0xa3ad765c, 0x6bfa1e65, 0xf520e223, 0xf9c49feb, 0x4f86cb88, 0x0db99d1e, 
	0x43ce32ed, 0x7ecbde7c, 0x4e3715f9, 0xcf00531e, 0x7d79aaef, 0x8ffa314c, 
	0x8879c922, 0x66c1f535, 0x677b6ff4, 0xe033df26, 0xee83bc99, 0x0b71a819, 
	0x54f43bca, 0xf44479f0, 0x5fda242b, 0x7db2f4bf, 0x10f30330, 0x7f647f19, 
	0x93ebf9d1, 0x5ac43cf1, 0xef0d773c, 0x3cba2fb7, 0x9d666bfb, 0x27d443cc, 
	0x67efd408, 0x662ffcc2, 0x8a1e117f, 0xff525f10, 0xa8f2b3ae, 0xadaecf58, 
	0x621e78b9, 0x248ede65, 0xe6b6abfb, 0x5a21e4ca, 0xe1ffb67a, 0xeb2fedc1, 
	0xca7f069e, 0x8f1a99f9, 0xa806ded1, 0x3f49f02a, 0xb547de1b, 0x329b9f02, 
	0xd3be6bbe, 0x4f0e37ba, 0x42118e4d, 0xa8baad3d, 0xae788422, 0xe62db8c6, 
	0x429b8694, 0x55377f1c, 0xe0d51f79, 0x5917efe7, 0x430551f7, 0x9a2f3f14, 
	0x62a3ef24, 0xc6a6563c, 0x91270b71, 0x1eeb063e, 0x42b8fb22, 0x7dfcf41d, 
	0xc8845865, 0x6eeb92fe, 0xe60d41d1, 0xe90319c3, 0x17f652e0, 0xecc5dfd2, 
	0xa7fad8af, 0x8e925fda, 0xca193a2c, 0xb71aaafe, 0x5a2fec83, 0xba7193ff, 
	0xf2a2e8b1, 0xf75fdb0a, 0xcf697cc8, 0xe31f2322, 0xabe07e18, 0xf9e1eac3, 
	0xa3cf2592, 0x5b5fe01d, 0x35c63cf7, 0xb99f98fc, 0xc73b4a12, 0x745b1e59, 
	0x830a1430, 0xb8e3e97a, 0xda2d2d82, 0x7cb0fc85, 0x11fe4182, 0xf9862f3c, 
	0x6671fed5, 0x92e78ee9, 0x5748bbe3, 0x4a4771fe, 0xc428bc77, 0xf8a44036, 
	0x9453fa8c, 0x5feb0395, 0x91ac3ed5, 0xce8661e7, 0x97c1b92f, 0x33525f98, 
	0x6a4bf399, 0xea1b4c72, 0x26a28111, 0xf40843ca, 0x0da77ac3, 0x1e52276a, 
	0x94dc3782, 0x99e6f7ce, 0x89d98bb6, 0x7a276901, 0x224bf353, 0x78d0dfd2, 
	0xa3f13b71, 0xfc501f71, 0x901ff288, 0x7dc8943f, 0x50cdf922, 0x137d0ef9, 
	0x05ef41d4, 0xc3ceb6ad, 0xc3ceb04c, 0x7cbbfbf0, 0x4006276c, 0x3b1cbd7f, 
	0x97df66f1, 0xf0ef13b5, 0x5723e625, 0x0330f3cb, 0xaa7eafe5, 0x59ca10f5, 
	0x4fcecd63, 0x308a1f25, 0xa865c29f, 0xc797dd8e, 0x9f7e297c, 0xb2e7cf08, 
	0xb9ca53f9, 0xafcb2f99, 0xd78e917a, 0xfcb7cd0d, 0x3ea26101, 0xfe4fa2f1, 
	0xd55cc03e, 0x33e1fd40, 0x770feb1f, 0x5d12b614, 0x740d837a, 0xf2fdd7bf, 
	0xc1ff865c, 0x07c81386, 0xcabefbac, 0x95d88532, 0x7f834f70, 0x11e2b9a9, 
	0x76469f99, 0xfbca416d, 0x31bef0e5, 0x1757bde1, 0x5f70aabb, 0xe9bba8f7, 
	0xfe31eb3d, 0xd5ff7c05, 0xf78e3e53, 0xf1bc65f9, 0x25de12e7, 0xdd78a7de, 
	0x369a2dd6, 0x66fbbf0c, 0xd03c8a24, 0x6c62f52f, 0xb0abbf47, 0xe785e790, 
	0xe4af31c9, 0x7cf7ef1e, 0xfe8b8c1e, 0x7cc146ba, 0xe90bd206, 0x99bd4cde, 
	0xfa1761ee, 0xa66bd474, 0x73e0bf57, 0x2773c1ad, 0x83de726f, 0x61239dfc, 
	0xf8bdfbc0, 0x7c075a3b, 0x239dfa2e, 0xe8a7e0c0, 0x8ccbd0e7, 0x45333e44, 
	0x150d7ec8, 0xaff33bef, 0xa3c6db0b, 0xc960f4be, 0x7df0f1f4, 0xb5aa87d4, 
	0xecf7b848, 0xf03b5b4d, 0xc71f5ec1, 0xae780343, 0x73c409fd, 0x6b9f20f0, 
	0xb5ce927f, 0x0da6bc3b, 0x4af7b5cf, 0x01b7d8b9, 0x714b1dc6, 0x0823ca60, 
	0xce7bcbd4, 0x98855e64, 0xf51faa7b, 0xfd5f7136, 0xe2da8fc3, 0x92cf7eeb, 
	0x27825ba7, 0x986471e3, 0x41307a77, 0x3e5fffaf, 0x78a163ce, 0x8f9949f6, 
	0x7fea7407, 0xee17bad6, 0x71897d9f, 0x30eadf63, 0x1fe677dd, 0x06f071d7, 
	0x3eb7e243, 0xa59edf7e, 0x99fc537f, 0xc5db1ce5, 0x7fab3c72, 0x3fd5ea37, 
	0xcc2fd81e, 0x7fef85bf, 0xc68e7803, 0xd75ff7c7, 0xf3c71f30, 0xa361d83f, 
	0xb7e6807b, 0x7dbc60b5, 0xfaffbae0, 0xf4fdd732, 0x63fdd625, 0x0f53ff7a, 
	0xee0d6860, 0x802fbe0f, 0xe04d2dce, 0x1d73a1f5, 0x2dbbfc8d, 0xfa9f5e97, 
	0x16bef0cf, 0x7ade5f71, 0x7a2dabd4, 0x2d729668, 0xf95a1f75, 0xb0fba90d, 
	0x8f907f15, 0x1dfe7cf4, 0x1f79338b, 0x58d2b9d0, 0xa0cb35fc, 0xcc5e3c73, 
	0xff028a6f, 0xfc784679, 0x904aef80, 0x9b8a7eab, 0xb7c8cd18, 0x6f9cfd7a, 
	0x0cdcb593, 0x8d50be61, 0xa4877f97, 0x1f846fe6, 0xfec1bfef, 0x9078c4de, 
	0x3f651d4d, 0xdd4af98f, 0x9a79816e, 0x0d84f253, 0x97eb5ee0, 0x4c6c8ef7, 
	0xbf2abdfe, 0x3f94738c, 0x67ba53d8, 0x4955e62c, 0xcfda15fb, 0x9c5bb802, 
	0xabbe7495, 0x9cd76c26, 0x96be01fb, 0xf917e528, 0x34d93527, 0x70916f28, 
	0x16fde0b5, 0x534487c8, 0x4237e288, 0x811da20d, 0xbcc4b721, 0xde7e51b3, 
	0x37d9561f, 0xc4e28ba9, 0x75873f14, 0x75029cad, 0xbe04aefc, 0x6778c36f, 
	0x09d8c39d, 0x9f30d7fd, 0xdc705bbe, 0x308df371, 0xc09bec0e, 0xaeafd943, 
	0x0f9f1bdc, 0xc20bfdfe, 0x782745b3, 0xd9a37cd4, 0xdfee7e00, 0x801db06f, 
	0xeb83d3bf, 0xc486a254, 0x15e6481d, 0xfe57b441, 0x54e59fb7, 0xfa20cf96, 
	0xcca17bf2, 0xef07bd64, 0x886ec84f, 0xa1294d7c, 0xb12e28ef, 0xeefccfd4, 
	0xfdaffbb0, 0xa4ca67c8, 0xec79b3fe, 0x6fec0cec, 0x194df9f3, 0x131f98b5, 
	0xe31f9410, 0x8aadfc47, 0xe882e5c7, 0xad3c434a, 0x3ce1b26c, 0xd6ca1afb, 
	0x4cf7ca25, 0x3985e70f, 0xa10f0436, 0x81b1c81f, 0xb58e40fd, 0x3e595ebc, 
	0x83b6d95d, 0xedb774f3, 0xb8517a82, 0xc8395b49, 0x05e3cc73, 0x8a2ec8fa, 
	0x0fb5cd7c, 0xa46c5fd3, 0xdff567d7, 0xc47d40ef, 0x3c41dfca, 0x3c76dca2, 
	0x15a23bac, 0x4be17c42, 0xfc2bbdfe, 0xad2338c3, 0xf7940ae7, 0x5fc11b51, 
	0x5ef944d6, 0x7c364eb4, 0x235b04ae, 0x1041aebc, 0x278079d2, 0xfae2cf8c, 
	0xad1f01b6, 0x60c11069, 0x36d72e30, 0x84347d8f, 0x226956e3, 0x78c33ee2, 
	0x44227ff2, 0x8b2ba4a9, 0xff9f371e, 0x7cf6a845, 0xdd879f1c, 0xce51f977, 
	0xdd557458, 0x741e5060, 0x0ede1d7c, 0x085c3af1, 0x2543ae25, 0x0327c3ae, 
	0x4bf741d7, 0x74065cb9, 0xee3036d1, 0xc07eec59, 0x7e40f98f, 0x167141b7, 
	0x7c4687da, 0xf2d7fa1f, 0x1fb492bd, 0x3f5c3257, 0x8fdf10bb, 0x9c7ee473, 
	0xc7a3f723, 0xd8a47ccf, 0xf98fd1bd, 0x3bf54359, 0xba1efed4, 0x2fea56bf, 
	0x27bfce90, 0xdbfbd5f2, 0x8c0ef341, 0x3df052bc, 0x5de5f0c3, 0xc07ef829, 
	0x52bb8dfd, 0x7cf075f0, 0xfea95c27, 0x26fee35e, 0xfd9fb419, 0x795866aa, 
	0x6337a8b0, 0x59ca10ae, 0xe7f39f9b, 0x6a4cf936, 0xee30ebaf, 0x064e5093, 
	0xf70bb87e, 0xc0c32c9d, 0x7dc49ec7, 0xae41eb27, 0xca097e6f, 0xd873e4bb, 
	0xf0b93503, 0x7937ef3d, 0xefc5e2df, 0x7e490caf, 0x4ed8da2c, 0xc4543079, 
	0x216f7a7a, 0x0bb9e9e9, 0xfef41faf, 0xe061b9ca, 0x19cf189c, 0x8b4afee2, 
	0xff761e9f, 0x7c59da8a, 0xef69f895, 0x4d66f9a5, 0x48d57eea, 0xd7ed8d3d, 
	0x36df3839, 0xda48a7ca, 0xc89c96af, 0x0af00e5a, 0x6ed02729, 0x323c75c5, 
	0xa08afd70, 0xb8b9c8bf, 0xb2f9219c, 0x10d7f653, 0x685efb2f, 0x4edb7ba4, 
	0xe6adfd5f, 0x6f9ab8c4, 0xdf65f33f, 0x7ba4ecfe, 0xd6016d49, 0xe30094d7, 
	0x70dc7337, 0xeafa776a, 0xefe3371b, 0xb47be20b, 0x1daf32a7, 0x87e7ca6e, 
	0xf05277f0, 0x71eb9e39, 0x5af34260, 0x942d5b92, 0x4ca0274f, 0x2684aff0, 
	0xab89e758, 0x71476fc8, 0xef87c060, 0xd9596344, 0x1bfe504b, 0x7ca1e394, 
	0xdf2e15e5, 0xc8dfe592, 0x4ca359f2, 0xc76087de, 0x97d0113c, 0x45fe8b7e, 
	0xa177e928, 0x77b34102, 0x6296255b, 0x98cdb3fe, 0xfc0a6d5f, 0x9d40a85d, 
	0xb1dab6a9, 0x12f37e34, 0x1f888fbe, 0x38f28e3f, 0x7fc3fc62, 0x63e93ce3, 
	0xaed0d2db, 0x8e6378e5, 0xbf8c3cc7, 0x3034ba5b, 0x9939efc4, 0xd0fb23bf, 
	0x7f269e9f, 0xef98b61f, 0x7c7b79a7, 0x7e935e8c, 0x51e649cf, 0x8f430dcf, 
	0x8b44f109, 0xe5dfad0e, 0x7c79840a, 0x37b6daff, 0xabd17ef1, 0x56d6c6dd, 
	0xf5870e3d, 0xbeb72afe, 0x78f883b5, 0x0e789bdd, 0xa1f9f81f, 0x1f9893ec, 
	0x63de6e69, 0xb392fb72, 0x01bde25c, 0xb7eadd01, 0xafca10ee, 0x39beb72c, 
	0x7cdd5fa9, 0xdcf96ff7, 0xf11db1bf, 0x470632b0, 0xee91c237, 0xdb125a36, 
	0x0dbf62e7, 0xf3822f74, 0xa5df42ac, 0x266953f5, 0x8d13cefd, 0xc74271cf, 
	0xedd78571, 0x0e7ca8ed, 0x16eb9274, 0xadfd715b, 0xf06d7fba, 0xd9a3ea30, 
	0x30c5b16e, 0x5487dfe3, 0x3fb05ed8, 0x4de23d72, 0xedd81b44, 0x501e719b, 
	0x7fdfc21e, 0x775f7f8b, 0x11f7f518, 0x3dfe3d6e, 0xe7a36f3d, 0xea46dd23, 
	0x7cf843f3, 0x9cd8db98, 0x3758fcfc, 0x9b70cf3e, 0xe63cf82d, 0xf4fdc297, 
	0xe92bd322, 0x5f1c3ddf, 0x3ca5ba45, 0x8facb3f4, 0xdd52fd23, 0x64b7f594, 
	0x27b718fd, 0xa63ad5bf, 0x21de7a6b, 0x15f679fb, 0xbf8db7ee, 0x4a5bfcb3, 
	0xf16df188, 0xeb015701, 0x47992e19, 0xfd7e92ef, 0x3dbee437, 0xa1f1f728, 
	0x5867f480, 0xcb9a2bbf, 0xe1627bfc, 0xa7dd0086, 0x746c2d9c, 0x644ebaae, 
	0x6a7f9ea2, 0xf2266369, 0x20eff8b8, 0x7dc16a6d, 0x7f9c7a1f, 0x9039a907, 
	0xa68567ac, 0xa2bbf4e8, 0x01284ca1, 0x5dfc90c6, 0x976856d1, 0x37a6fb83, 
	0x4f5afc93, 0xdfcb6635, 0xfa256a9d, 0xdfe3acaf, 0x922cf515, 0xa0fa2bbf, 
	0x487bf49e, 0xf29f193e, 0xfbea7d49, 0x664f9601, 0xc181e3de, 0x2dd0ff7e, 
	0x1667ca74, 0x7c55c6d9, 0xc1ccd44e, 0x25f7c9f8, 0xdbcc9e1e, 0xfc2efbcb, 
	0x6ad5f91e, 0x50f7c07f, 0xe8a3638a, 0x3baeb177, 0x3978469a, 0x157e07ed, 
	0xb7dfb111, 0xe58de90b, 0x78ad3fc8, 0xf8c19d72, 0x4f1cbd53, 0xdfc0e0b6, 
	0x763a464b, 0x4e78aea1, 0x0622f77e, 0x5a72f41f, 0xcc9d6ccf, 0x310ae0b4, 
	0xaccfde5d, 0xbfb75e60, 0x67682841, 0x44f79b06, 0xad439e91, 0xdd7982ba, 
	0x0b75caef, 0x0bf3c6dc, 0x7ba230ac, 0xf6fc3ed1, 0x1c11ce81, 0x124b52c7, 
	0xcfb611f8, 0xfb1f7c46, 0x4b4be277, 0x7966c8df, 0x7926c918, 0xe67ff578, 
	0xe0dbb8c8, 0x7928697c, 0x06fc3738, 0x15783be1, 0xeff98dc0, 0x03bf4161, 
	0x3b744a2a, 0x3b3a57dd, 0xfc017762, 0xde7805ef, 0x68ff3e31, 0x04e786d8, 
	0x3067f9e9, 0xf9689968, 0x8f8418cc, 0xc93dfe36, 0x1b9e8def, 0x461d5f25, 
	0x0e8df47c, 0x8bbfa2e5, 0x0be4baf7, 0x82bf4d6a, 0x177eb728, 0xd3ab55cf, 
	0x5d01e2ef, 0xf629efd3, 0x926aeecd, 0x63b36574, 0xbefe5f9c, 0xc9e2d958, 
	0xd6b79e34, 0xc68185b4, 0x73ffe796, 0xd773f500, 0x30f4a28c, 0xb2aba5d0, 
	0xca18bdb1, 0x157ffbdf, 0xb4f27bc0, 0xaa6d864d, 0x47ddf721, 0x68f62744, 
	0x16ff10ab, 0xe1173f60, 0xaba77f87, 0x5af195a8, 0xa36d71c4, 0x16f495a8, 
	0x28f5a8b3, 0xa27be7b7, 0xd73bef93, 0xbd257e6e, 0xdf73c604, 0xf1819fde, 
	0x7c4a3ffb, 0x21e2f95a, 0xc539cf79, 0x1a4f11e7, 0x2f384b68, 0x7f000f99, 
	0xf7c72619, 0xb35f108b, 0x8f7418b7, 0x7ee218ac, 0xba3e58f5, 0xc677fa1d, 
	0x78add0f3, 0xdec8cbbf, 0xf305ae39, 0xa008be03, 0x85fc4abe, 0x5ee845f3, 
	0x4ef4013a, 0x4fb90efe, 0xd9740ffe, 0x0000cabb, 0x00032641, 0x7ddd9c78, 
	0xd51d740b, 0xb999e875, 0xf4fee773, 0xad7d5d19, 0x2d7d7d8f, 0xb628a164, 
	0xb8b9ae10, 0x1c723c4e, 0x5918c7d0, 0x978fd838, 0xac013226, 0x94112ea4, 
	0x30bca080, 0xc92d9657, 0x1b2d70c6, 0x0ad2136c, 0x2b0ea49a, 0xbeda456d, 
	0x1934da65, 0xb49836cb, 0x2bca154d, 0x2b819f6e, 0x54bf6bb0, 0xaba10d6d, 
	0x785657b2, 0xdee673fb, 0x36c923b9, 0xaabb5601, 0xcce1f0b5, 0x3ece7339, 
	0xdef677fb, 0x42b99f67, 0x59b5b6d8, 0x0a617a88, 0x822165eb, 0xcedb109a, 
	0xdd98a108, 0x01312a4f, 0x3c3d840f, 0xec21a509, 0xaa1ed03d, 0xe13bf686, 
	0xa5b49af1, 0x18888484, 0x0af71442, 0x24305531, 0x5fa137ac, 0xb31c4a67, 
	0xfd43aea0, 0x6217588b, 0x5afc8a00, 0x85bbd411, 0x6ca03028, 0xbfb10786, 
	0x841711ab, 0x584efd68, 0x3f50c358, 0x1e2d50d4, 0xe276a214, 0x8fefaa1a, 
	0xdfe21b97, 0xad68b9e1, 0xfcfe60b6, 0x012ae9ad, 0xefd417f3, 0x7c5111af, 
	0x25ef022e, 0xbf02b0b1, 0x8f0452a0, 0xf83d53f5, 0x8b6a50d7, 0xbe05062a, 
	0xc97c2797, 0xe5e44223, 0x63b1b4c5, 0xb9ec4e38, 0xff280021, 0xfc3eb4be, 
	0xa6d72859, 0x06dbedb7, 0xd6111ae5, 0x4dc442d3, 0x849a57e1, 0xdc0e9bd0, 
	0xf28142b8, 0x2b038753, 0x8dd0fc61, 0x8c2160b1, 0x056adfeb, 0xff8c2a03, 
	0x81453ec9, 0x115185fe, 0xe7819fd1, 0x092f8b5a, 0xfe1f78b8, 0xe3023c76, 
	0xd68d132d, 0x0d8c4293, 0xe01b767d, 0x2577e44e, 0x506312c6, 0xac75acfe, 
	0x8af3863f, 0xc202f531, 0x6ff86a6b, 0x7f505dfe, 0x09f7e090, 0x06185fc0, 
	0xcceb06dc, 0x9fb2994f, 0xfcf3e0ad, 0x16637dd5, 0x1829ffbc, 0x2f780833, 
	0x1114c58a, 0x00ff79e3, 0x8dc60de6, 0xf80228a4, 0xf52c336e, 0xfd0e7809, 
	0xfe01e722, 0x544718cf, 0x399f6f1c, 0xf78d7616, 0xf517b41a, 0xd68ee166, 
	0x07be0407, 0x010cd470, 0x7757045f, 0x41b60a9e, 0xdf0399f9, 0xedfd420c, 
	0x3e7c0ff9, 0x7871f504, 0xf825e8cf, 0x166e90ab, 0x4c74458c, 0x1e3a232c, 
	0x2c2691fa, 0x61510fe0, 0xfcff9d13, 0x8754e5ab, 0x81275565, 0x04abee0f, 
	0x7048583e, 0x01ff2154, 0x60575fc2, 0xddf1dddc, 0xd41af886, 0xccdf124b, 
	0xcc30441b, 0x8507586f, 0xc1004ea8, 0x0c5884a7, 0x61778af3, 0xa0d4869c, 
	0xd4eb0798, 0x08db6534, 0x1be993f2, 0x4c9a71c6, 0xf529f21f, 0xaebb2f7b, 
	0x16989eea, 0x3ff581e8, 0xca5bfc0c, 0xe56e15e3, 0x4758217e, 0x39e1e7fe, 
	0x681abbac, 0x7ae5385f, 0x6ffb81be, 0xef3f3e45, 0xe61eaf9a, 0xf7cecc9b, 
	0xdf77ce30, 0xf235f32c, 0x8986fefb, 0xde9fc441, 0x9f100564, 0x4997f199, 
	0x4f0c8278, 0x60c6bdc1, 0x878f1e70, 0x295fcdf4, 0x68e632e1, 0x2bdb235f, 
	0xdda76e18, 0x57d1f492, 0x592aff01, 0x4e6f047c, 0xdfe03504, 0x60e9c6c8, 
	0xabfc2550, 0xa1d32f48, 0x1f13f59f, 0x8ffe6bd2, 0x8cfd3197, 0xc3f586b0, 
	0x3b73e717, 0xc79406a8, 0x926fd230, 0xc34cafe8, 0xeb903fbb, 0xfed1fe17, 
	0xb3df0b06, 0x6a9fb1fb, 0xff219f00, 0x077bc154, 0xb6dd7f00, 0x68dc82a2, 
	0x0032a6d3, 0xc5529df4, 0xe349d594, 0xc2810f12, 0xbdfdf1a0, 0x3cd9a296, 
	0xaf67c21f, 0xb4a6f862, 0xf05afedc, 0xf403b17e, 0x5fb8df91, 0xb41afe0c, 
	0xbad7a29b, 0x7d748855, 0x87a81842, 0x715e8962, 0x54ffb66b, 0xba9ddb90, 
	0x02c50c2e, 0x64254d7c, 0x0c6026bf, 0x61a67e78, 0xbd00527f, 0x88e2e30a, 
	0xd71d9ad5, 0x7d109c5e, 0x80034e38, 0x67c2417e, 0x1fcfe565, 0x9cee97b4, 
	0x959687e6, 0x6c3d07e5, 0xccf7fb25, 0x1ff10f7c, 0xffc590bc, 0x80dd225f, 
	0xdfe8c4cf, 0x75dd70f8, 0x3a602c77, 0xac350aa4, 0xa8abd39f, 0x728699df, 
	0xd0cbe105, 0xff7cb0c1, 0x27f8b222, 0xd6bac3bc, 0x7bc460c5, 0x89f12e10, 
	0x7099be91, 0xe073ed4d, 0x8c107d61, 0x9bab7188, 0xb7e124ca, 0x2948f41d, 
	0x343e3bc1, 0x91f9f90f, 0x7fc2e131, 0xaaa6ae96, 0xeae96776, 0xd7e009f0, 
	0x7e4afb87, 0x8411c573, 0x970e591f, 0x8c67c19d, 0x3e7804e9, 0x74b3a56a, 
	0x7a056a9f, 0x1e967dfc, 0x005bfe99, 0xf238f0ff, 0xfa1f1875, 0x38225deb, 
	0xd2c47a40, 0x4a68be71, 0xb4df9044, 0xb6065098, 0x04d95108, 0xf0f68508, 
	0xf8434b7e, 0xc9336182, 0x9045667c, 0x6247edaf, 0x3f4daf92, 0xd098abf1, 
	0x2fdf782d, 0x7ac11c7e, 0x70466120, 0x458609df, 0x0025e23f, 0xe5a01a78, 
	0x4f5c7e19, 0x7e5ba499, 0x92f18faa, 0x1d890848, 0xb3aaaf1a, 0xa49c2049, 
	0x9e110fb7, 0xb4efa8fd, 0xbc475044, 0x3704bcc0, 0x1117b3e8, 0xc3c6f0ee, 
	0x1bae88bb, 0xbd638efb, 0x15ff6e30, 0x9b55abce, 0x7809a4fe, 0xc0e4cc30, 
	0xf10e33df, 0xeb1d0cbf, 0x851bae81, 0x49d0f238, 0x3f2c8b61, 0x7fe8094e, 
	0x80fbc4ab, 0xf16ebfab, 0x7f782d7e, 0xe249fa9e, 0xf4f00b7a, 0xf5102c16, 
	0x0fdbf609, 0x9815e6fd, 0x3c00f63b, 0x1bcdf2f3, 0x1fe41586, 0x7ce40718, 
	0x27a99e5e, 0xdf7be48b, 0x212ffee5, 0x6589e7ff, 0x8cb0c743, 0x03073f55, 
	0x97c44bfb, 0xade01e51, 0xe3a0dda6, 0xab14eef2, 0xd34eddb7, 0xd4219346, 
	0xf504a287, 0x15612062, 0x07145ea3, 0xee2092ac, 0x68764883, 0xeb117eff, 
	0xcb8b65b1, 0x017bb48b, 0x7dc6e8be, 0x3583f602, 0xb7bdeb1a, 0x0db23c17, 
	0xddfe5df5, 0x28d0fce2, 0x2c45036c, 0xf9fc0e3f, 0x125f4d2b, 0x2812bdf7, 
	0xa01ec88b, 0xff82aef7, 0xcbfdc2af, 0xeafda328, 0x8d7f6b8e, 0x45b5fbe6, 
	0xc77602d0, 0xa3bea69a, 0x97080315, 0x75f3845d, 0x717a27f4, 0x4ef8eddf, 
	0xf1f717a2, 0x2e3eb18e, 0x2af965c7, 0x7477b094, 0x9fac93fc, 0xf575cc3f, 
	0x5e4b2e05, 0xb275e7e0, 0xcb8174de, 0x70dcb2d5, 0x92efdb81, 0xefebdef5, 
	0x4a1fb2a1, 0xd64fbe7c, 0x63eb23bf, 0xfe39720f, 0x57083de0, 0xc5040b50, 
	0x81bf6939, 0xeb08debc, 0xecfac08b, 0xc48aa7f8, 0xafba593b, 0xdb130bf5, 
	0xb7302edf, 0xc8cf60a5, 0x9f5df58f, 0x17e5985a, 0x1494282d, 0x88ebcc88, 
	0x3b64f7c7, 0x985f37d0, 0x11eb1bd7, 0xd1eb265f, 0x02fc5c1b, 0xec7137fa, 
	0x83da3f19, 0x818b7f09, 0x2f503bfb, 0x3d3cf88a, 0x80245638, 0x54d045ff, 
	0xffc46d93, 0x3449c985, 0x7835852b, 0xd102ca1a, 0x83da07bf, 0x30f562f9, 
	0x6bd825c9, 0xd4279ed8, 0x81e72da4, 0x8b17cbf9, 0x1287b471, 0xcf7f9679, 
	0xe1c01616, 0xb8b1f210, 0x3927ac5e, 0xf9687922, 0x445198d3, 0x24828bf3, 
	0x669965c8, 0x8b39dd6d, 0xb01b2bde, 0xbfcc24b5, 0x43e98d6a, 0x2a3f9efd, 
	0x203f504a, 0x2f3ca1ff, 0x48a5bc5b, 0x1bf24f7b, 0x6b5c53c0, 0x109d6abd, 
	0xc55854a2, 0x7c4cc603, 0x76c45ddf, 0xcdff1d96, 0x7c8df159, 0x92f64c5c, 
	0x5ef28855, 0x5fa8f4f6, 0x99bc4169, 0xa7d7c409, 0x6b36e6c3, 0xadb8e008, 
	0xa8c5ed8b, 0xc3ed2bda, 0x06fbb242, 0x7917c412, 0xfbc7c079, 0xa98c7ed0, 
	0x3c42bdbe, 0x6a15e724, 0xfe83547f, 0x1eb0b579, 0xe2f12f18, 0xd015ab3d, 
	0xa63ded2f, 0x5abe004f, 0x2aacdbde, 0x25d796ac, 0xfecade41, 0xd471e2a4, 
	0x39c96a2f, 0x4f9e96b5, 0xad8dbf8e, 0xdd683b4d, 0xefe34920, 0x15fc5da0, 
	0x9fd71fa3, 0x9af47687, 0xcb0c1d2c, 0xa7180c32, 0x342cc868, 0x4bc49e60, 
	0xda2eae0f, 0x180dfdcc, 0xdb116f77, 0x8bce2627, 0x3aea17f4, 0x497947a4, 
	0x6b11b0ac, 0x63fd537e, 0x5bdbe70b, 0xc687dda4, 0x36fe32bb, 0x716fffd3, 
	0xde75a63f, 0x02097801, 0xf161e0be, 0x0f850b7b, 0xac6b6cf9, 0xaa61d780, 
	0x53dfa07b, 0xd6084f30, 0x80a50bdf, 0xee9e5af9, 0xbf581436, 0x70cc74f9, 
	0xad3f21fa, 0xb3be03ca, 0x8e361f89, 0xa14a3eb0, 0x9e8a523e, 0x473f122d, 
	0x047d04fe, 0x8e09fde3, 0xb5d52ef3, 0xdd6cc1e4, 0x59ed086f, 0xf63dd4b2, 
	0x699ff052, 0xdbf77e9f, 0x5d84afac, 0x0fd2f646, 0x83ae14c6, 0x97b6ef3d, 
	0x1380c5d6, 0xec75bed0, 0x93b07aa4, 0x24ed6736, 0x8e10d3f8, 0x3f760da9, 
	0xaaa603fb, 0x75a280ed, 0xc4a9e921, 0xf34ebf6d, 0x7d07d6b6, 0x57afd431, 
	0x008da225, 0x7e8b1dd7, 0x1bfae340, 0x3cf83dcd, 0x714669dc, 0xc179ffff, 
	0x6fc48b0f, 0x2c5ba0c3, 0xf48b2adf, 0x2077f933, 0x1064beff, 0xb21537e7, 
	0x86ffe19b, 0x1faa3f78, 0x3f55baa2, 0x6dfcf004, 0xdbe76391, 0xa93b13f5, 
	0x6193eafd, 0xeb8d5faa, 0x145662d2, 0x975ff6e1, 0x70095e28, 0x2bbb0604, 
	0x3885d79f, 0x8f7b7885, 0xfc8558f0, 0xfcb456f6, 0x3f2fd89b, 0xf447facf, 
	0xde104493, 0xc306fe43, 0xc595da4e, 0x8f5f8f36, 0xcbbdaee3, 0x8f5957ca, 
	0x3d35ffd4, 0x4abf5717, 0x29f575a5, 0xd3e2ed2a, 0x13431780, 0x5d5df3ff, 
	0x49fe8f8e, 0xf20f8c01, 0xf62ab7ec, 0x7e1e0036, 0x45ebc96f, 0xfdccef5a, 
	0x47aabfce, 0xae84be61, 0x0497e4c3, 0x614d0e50, 0xb21e126b, 0x90f650b7, 
	0xcfe8358e, 0x773fa195, 0x73e5107c, 0xf920fa81, 0x31540b73, 0x6c102626, 
	0xbe836c53, 0xe7ae4a0b, 0x094037e7, 0xe9a0baf2, 0xfce32e41, 0x1d3ed63c, 
	0xb02eb410, 0xd8dc6037, 0xa74d5045, 0x3f545d69, 0x8043fc63, 0xc25fb6eb, 
	0x1b6c7791, 0x35fde7b5, 0x139ba194, 0xaaed0501, 0x2637c0a3, 0x0ea19a94, 
	0x9b77a300, 0xd67c4696, 0x7b471c65, 0x167dfa05, 0x3fd185fb, 0x5a637b45, 
	0xf45bea28, 0xc1ea00de, 0xfc88afb8, 0xf94f4741, 0xafe74ca2, 0x368cf2c8, 
	0x704a5019, 0x1404ef3d, 0xcf20b678, 0x5853240e, 0x46515e7f, 0xad47c166, 
	0x1f0aa7e3, 0x4fd993fe, 0xfd049fd0, 0xa2d4d757, 0x9c58bea0, 0xb20d5168, 
	0x8190accf, 0x0edba57a, 0x61cffd61, 0x71c8208e, 0xa24eed0c, 0xc031e80b, 
	0xb22d1687, 0xfcf433d4, 0x7107ab04, 0x05d0ed02, 0x26343b1e, 0xcd05d0ed, 
	0xedba8e9b, 0xa454cd4c, 0xe47c21bf, 0x6476386f, 0xba9ddb0f, 0xfca1f4e8, 
	0x7d26b5e5, 0x17f2e99a, 0x0b8ed97a, 0x56a3cdc7, 0xafbdeb85, 0x957ffdb2, 
	0x70333fb4, 0x7e737b4a, 0x547b215c, 0x424e38d7, 0xf7086976, 0x9127b01f, 
	0x879fa00e, 0x11ad1e61, 0x83e046fc, 0x9f6cf3ca, 0x6163fd3a, 0x9ee1107b, 
	0x0bf1bd04, 0x68a3da4b, 0xd81da20f, 0x2413728a, 0x3bb1ccff, 0x136c76b3, 
	0xec5569f1, 0x9737b21a, 0xf044c506, 0xc99da54f, 0x9bd91a7e, 0x8faeab75, 
	0xefff432c, 0x28a3ceb6, 0x30bfd52f, 0x7c60d086, 0x1f7ee914, 0x4d0ec1d6, 
	0x3a9fdfa3, 0xabfc602a, 0x2b7e00be, 0xf5f819c0, 0xc8454793, 0x3f02dfe5, 
	0x2e0b3ce0, 0xbf6176a6, 0x80e94d05, 0xaf6d93d8, 0x1468df7d, 0x8a48ff1c, 
	0xf17e4cd4, 0x6a432737, 0xc5eebb2a, 0x5ca10ec2, 0xa4249c92, 0x1ca4251c, 
	0x96f2961d, 0x9874f290, 0xb77de0ed, 0x570762ce, 0x1af52258, 0xc296c1db, 
	0xa39d1efd, 0x976bd0df, 0x5d4197b7, 0x1388c75a, 0x7f064e38, 0x49a7fda3, 
	0xa7a4d9af, 0xe82e713d, 0x437ee0ae, 0xfe4a61fc, 0xf1fc9498, 0x0ebd7652, 
	0x0b7e389f, 0xe49b47f1, 0x0fe4b48f, 0xf0efed91, 0xea07f109, 0x8fa0e08f, 
	0xf89b17f7, 0xc25bf1d7, 0xf8705fd2, 0x82fc72e0, 0x4fbe0bfb, 0xc77a42fc, 
	0x4ff36654, 0xf2149aea, 0xb17f16ab, 0x92dcb235, 0xf92dd37c, 0xa037ea05, 
	0x7e3ee2fc, 0x2b6da1fd, 0x4837c92d, 0x1bebdadf, 0xa8ee8b85, 0x979fc8c7, 
	0x7ebf43f3, 0xc8a3e2e1, 0x68a3d4c5, 0x2b76346f, 0x0e6fc879, 0xc1ebf99f, 
	0x0cf873af, 0x423bede1, 0x69ec9fed, 0xb5fac3c9, 0xcdea3f00, 0x803be22b, 
	0x7e0ad43b, 0x23bfe85d, 0x71e279ff, 0xfa41aac2, 0x09c4e7dd, 0x8b9f132e, 
	0x69f9bbcd, 0xa71b207f, 0x8e1cf8a3, 0x337d8fe3, 0xb9f1883a, 0x1fe8a397, 
	0xf57683a9, 0x1bfec19f, 0x26fc1df3, 0xe7e447fa, 0x7c3d4a4f, 0x475c6662, 
	0x81d5369b, 0xe09fc8b3, 0x2f5107e7, 0xbfbc28b7, 0x716cca1b, 0x8b6b509d, 
	0x86bb41aa, 0x5cab9d71, 0x178c1d71, 0xb89cb770, 0xfe81c510, 0x9ef1f2e5, 
	0x57197aa9, 0xae3d9d68, 0x9ccf8de0, 0xe24f2869, 0xd27f1cfa, 0x97f7b00f, 
	0xb4a8bf72, 0x0bdff0cf, 0xb543b651, 0x8f38a0b0, 0xf183ae37, 0x61e9209a, 
	0xd57687cb, 0xc595e899, 0x5a389c79, 0x99847ed6, 0x13a3f65c, 0x05aa99e7, 
	0xde1e09b8, 0xa602eb7f, 0xe662a7f2, 0x7f63393e, 0x0842f55c, 0xdf677fed, 
	0x5c58fdc5, 0x6b9ddf62, 0x4ee874ff, 0xb959ecfb, 0xfdc90e6f, 0x2bfb90d7, 
	0x76318b94, 0x7dccdf7f, 0x6abfbbd6, 0xc9250b0f, 0xd1308271, 0x5bb60ef7, 
	0xd661a301, 0xd176b95b, 0xff798a77, 0x57fcbf82, 0x29fe79f9, 0x0e365ff4, 
	0x64fde385, 0x2fd0f9ef, 0xc3b5e828, 0x4d7cbeb8, 0x0bbf9051, 0x18af58fb, 
	0x1245f78f, 0x89906e78, 0xc893fbdb, 0xdf639a68, 0xdf64d589, 0x2722ed69, 
	0xd94d1f1e, 0x063fd411, 0xf49359da, 0x5f5c4e7e, 0xfdc702fb, 0x2d35fe43, 
	0x3d28f718, 0x696f4824, 0xfbc4e9a6, 0x87b47f89, 0x51acc6fa, 0xea3fd3d0, 
	0xdc020bcb, 0x9d3b7f15, 0x57250067, 0xad5eb316, 0x5f97db3c, 0x739af501, 
	0xbbd23e76, 0x88a63ea8, 0x28deacd1, 0xe24ce86c, 0xc15febfe, 0x62d1baf1, 
	0xdff50bf6, 0x60a88e31, 0xcd8615af, 0xabe80a64, 0xbee08bb7, 0x6f6eb067, 
	0x19c03ac3, 0xbf3c014c, 0x5afecc59, 0xb4b6ebe0, 0xf490ac6b, 0xfbdc0a5f, 
	0x2133ec05, 0xc61d77a4, 0x4e2926d5, 0xb2714056, 0x1bfb4d98, 0xd9e82260, 
	0x7fd8826f, 0xc1c72b71, 0xf620a460, 0x77dcdd0f, 0xd854ed02, 0x3ed24267, 
	0xd3f9d109, 0xad4144c6, 0x3f0fdb0f, 0x37f57886, 0x7dc65ea4, 0x3fdb88c7, 
	0xd503f7c1, 0x38fd1066, 0xb9415f78, 0x45429bf4, 0x1e030afe, 0x8f125207, 
	0x3edf88f5, 0x94a75ba6, 0x66e2b9f3, 0x66e28a66, 0x68f9dfc9, 0xc6b6b0f5, 
	0xbe9987b1, 0x6919f399, 0x97206b0f, 0x2e5644c6, 0x1f40230b, 0x24dfff80, 
	0x40cdfc1d, 0xb9f13bc7, 0xcfe5947d, 0x30743a3e, 0x9561770b, 0x7faef649, 
	0xd47a4993, 0x03296d3f, 0x6ef5b7a0, 0xcf18d3e1, 0xcda5d92a, 0x8d67c727, 
	0xe4726ebb, 0xf8a54277, 0xbb17a3b7, 0xef805f19, 0xd33f1c71, 0x972c8bff, 
	0x1f207f0e, 0xe885fb49, 0xd965fc87, 0xf905f933, 0x0e2fcdcb, 0xbcdf10ff, 
	0x8b66f92c, 0xecd88fe4, 0x79e743fc, 0xf209f073, 0xc43bda31, 0x5f92c32f, 
	0x6bf96736, 0x9beb3153, 0x03e7f8b9, 0x079e55d3, 0x784507d5, 0x23d06de8, 
	0x1838563d, 0xc7ebbf22, 0xfd44c718, 0x3bcc7182, 0xfbbf598b, 0xbd221d57, 
	0x0299e8e3, 0xa80277a9, 0x007e162f, 0x739b73bd, 0xcdfbc83e, 0x57733d0c, 
	0xaf4cfc82, 0xdea0895e, 0xa9ea4b79, 0x419eace1, 0xbe0061fd, 0xdfb3178f, 
	0x196fece5, 0xe7ced23d, 0xb23d5e87, 0x8ae384a4, 0xc45bafa1, 0x80dbfe07, 
	0xf2c99e0f, 0x0514d041, 0xcc7aaf28, 0xd5d6ba22, 0xb91addb3, 0x4d34e411, 
	0xfccfd27c, 0x109f3b3c, 0xf565b47f, 0x2cd3b84a, 0x743a3a40, 0x33173926, 
	0xef2bc4f9, 0x09b3bd19, 0xeaceefc6, 0x10ff4705, 0xf92cbd3f, 0x3b51f509, 
	0x17c899eb, 0xbe44ef59, 0x9013fcc8, 0xdf23a37c, 0x8f5e1f98, 0xd9885f20, 
	0xa03f4dce, 0x7688569d, 0x63ee20da, 0xbcb1a760, 0x5fb4ec7b, 0xb4edbb16, 
	0x4039dfc2, 0x8de91a76, 0xdbb7dcb4, 0xa069da66, 0x9ba45447, 0x1077fb81, 
	0xedd30bf5, 0x496bc34c, 0xddc2b7dc, 0xa5faca96, 0xbc384153, 0xc39d1b76, 
	0x73cccbfd, 0x882bf438, 0xf35ed2de, 0x5bf6bda3, 0xe623bd2e, 0x694cd7b0, 
	0xec7a7427, 0x38ceafb5, 0xcf735387, 0x1a76bce1, 0xf095b7b7, 0x6c206bb9, 
	0x59569d93, 0x33bae7c2, 0xf41f7ae2, 0xf9c64dfc, 0x8e363e84, 0x62ebd8e7, 
	0x8e742920, 0x1abfb87d, 0xdc768fd7, 0x0befcbc1, 0xde584b9b, 0xf377ef48, 
	0x6d7840be, 0xf6747966, 0xd763cd01, 0x6e83f665, 0x991de293, 0x94c7a0fd, 
	0x91f081fb, 0x1c57349c, 0xd8cc3a45, 0xaed9ba0f, 0xa0fe3b26, 0x6c3d2e8b, 
	0xf524bd9f, 0xf7ed0068, 0xf376998a, 0x5a9de0e5, 0xbca7d8e3, 0xbfde2bee, 
	0x55fceb3c, 0xd91db3f7, 0x7dd6607d, 0xc792a3ed, 0xb1e53982, 0x6e61f897, 
	0x525d4c79, 0x8b71031e, 0xd05bb1e5, 0x8699eb39, 0xcfa8fd8d, 0xf9163dc3, 
	0xf2e9ff49, 0x26afc0f8, 0x3ca4fb8f, 0x405f6086, 0xca547c79, 0x052842e3, 
	0x7962d794, 0xa9fe4cef, 0x82e803bb, 0xa27cc378, 0xc82b8bef, 0xc4a67a27, 
	0xb7544f9d, 0x89f2926c, 0x1a27cc74, 0x992e7821, 0x25f7944f, 0xcbaa27ce, 
	0x05a4bf03, 0xfbaf30f8, 0x5035b189, 0x6a7b1adf, 0xef2876e7, 0xfa192d1b, 
	0x636b942c, 0x505de1d1, 0x227cc80e, 0x0a89f38b, 0xa89f397a, 0x3e717fe0, 
	0xe720d151, 0x4b2fe513, 0x9fe80306, 0x608e060c, 0x52cac95e, 0xa07e7f5e, 
	0x427687c5, 0xe517e654, 0x290d19af, 0x537eeca9, 0xb617b197, 0xd6e0a30f, 
	0xf603ec65, 0x9e64ea4b, 0x4ec79d51, 0x19e4f3a8, 0x68cf3045, 0x4769f704, 
	0x517db12f, 0x1f84ed27, 0x679ecc97, 0x46798854, 0x056d2f40, 0xa5cff9cb, 
	0x37f5905d, 0xf0053244, 0xec1f60eb, 0x6fe3985b, 0x8f4053f8, 0xfc33258b, 
	0x52938a0d, 0xd673679c, 0x652c889f, 0xe39ce67d, 0xbdb9cf0b, 0xf3a51f13, 
	0x5c6597fa, 0x2554e807, 0xac10fdf7, 0x83e48067, 0x73deebe3, 0x17693afb, 
	0xf3cbd5d4, 0x7ec756fb, 0xb07a73e0, 0xde1ce803, 0xe00d471b, 0xa5c03c79, 
	0xa22f53c5, 0xdc65461c, 0x5d87ec0d, 0x9ec3ffd8, 0x2ed25fd3, 0xbbb673c5, 
	0x67dc2d7b, 0xdd69f6bc, 0xcffb5cda, 0xf3243f19, 0xf866eaba, 0x4027401d, 
	0x4ca523ed, 0xf6f50d0f, 0x61dfb719, 0xe83f3c29, 0x371f8c71, 0xdee2381f, 
	0xefd10a3f, 0x0ffcc0af, 0xe3d79b91, 0x672685e8, 0xbcc9495f, 0xc4e6a11e, 
	0x5fde4dd9, 0x48eb71a2, 0x8ebe5e8e, 0xda0095f7, 0x7639dd99, 0xd421d126, 
	0x8e1e79ca, 0xd8e9599d, 0xd29b3799, 0x281f14ce, 0xccec03cf, 0x66761cc8, 
	0x4ab4bf2e, 0x99dac93e, 0xf921e79c, 0x676b2ead, 0x41e79ace, 0xf926d2fc, 
	0x0e5fc5c4, 0x57c8e8ff, 0x9fe787f6, 0xe9fd4b9f, 0x8d75c1d8, 0x1cb3a422, 
	0xf98eb004, 0x083b8164, 0x9c4d80ce, 0x439e9262, 0x8a7186fd, 0x86a4affc, 
	0x6aebaf90, 0xd5bbe505, 0xbeb97095, 0x3e87cf94, 0xcdfeca57, 0xff6528ff, 
	0x43244c41, 0xf38a7e74, 0xb5fd07be, 0xfd02c864, 0x23bafa70, 0x9b207101, 
	0x52e307bf, 0xf07f9ede, 0xf9c7c6a5, 0x8c3d361c, 0xbc3679e7, 0xf7ee707f, 
	0x8f4b89c5, 0xdce9cf4f, 0xe307d616, 0xfcf279d4, 0xf8e12f9e, 0xcf279d5c, 
	0xfa5cf32f, 0xd94bc775, 0x7993aafe, 0xe15ff97b, 0x5e82bdbc, 0xf4cbdbce, 
	0xe9ede4f7, 0x67779ccd, 0x79d47c4b, 0xb466f6f2, 0xb476e1af, 0x9c570c73, 
	0x1494fe10, 0x80a99bc9, 0xe87e2247, 0x79b2f7e0, 0xcce7b979, 0xb1d0dc4e, 
	0x5a40d547, 0xbae178c1, 0x3bfa4818, 0xe347fe34, 0xaee9ac7f, 0xaf5473e6, 
	0xe958f3bd, 0x4e9deda5, 0x3fc2e515, 0x178c142d, 0x38e6e346, 0xefac37db, 
	0x66637f1d, 0xe7c1a07e, 0xec47a813, 0xd101f259, 0x8fadf9de, 0x7a6c5e21, 
	0xcf3794e2, 0x84be2f1e, 0xafed43bd, 0x1ffae694, 0x3f138b97, 0xc5abfa57, 
	0xca5ebf89, 0x713c2272, 0x0d13cc62, 0x7a447e48, 0xf9c23c14, 0x9ce3c6a1, 
	0x9fbc5a17, 0xf2bd42f3, 0xaf798799, 0xb7adbb18, 0x6af79c42, 0xd5ef3085, 
	0xce64f396, 0x52169b05, 0x7fa66bde, 0xce6ffa0c, 0xf3f6f7f6, 0x23f593ce, 
	0xec8b7f40, 0x10fb447e, 0x27f4a9f1, 0x77783ad6, 0x87de09fc, 0x9d53fbbc, 
	0x90f87fd7, 0x5c8954fb, 0x55fb5cef, 0x2ed8b7e3, 0xd2ba6bcd, 0x48f7f73c, 
	0xb4bb1c4e, 0x4bb60ef1, 0x6976b2f3, 0x43b655e8, 0x14a8a743, 0x0f5cd3e1, 
	0xf259414f, 0xb8c315fb, 0x99e6348f, 0xfbb9e60a, 0xa11fecf3, 0x35b8da5d, 
	0x7eddfdf6, 0xabb3ef28, 0xb9438f86, 0xdd89f476, 0x0c79418f, 0x6fc052ec, 
	0x6976cd83, 0xb681d8d9, 0xd956404a, 0x550e1e5f, 0x5ef378c3, 0x4297858a, 
	0x32477a59, 0xd3ed18bc, 0x2ec91bc1, 0xf9c6563d, 0xc30f254b, 0xef18233c, 
	0xcb04444a, 0xa3ee217d, 0xe73e418d, 0xc034055c, 0x52a456b8, 0x06df6844, 
	0x45db120b, 0xe5215f45, 0x8a19807b, 0xc2688eeb, 0xad3b6fb7, 0x8684f4a3, 
	0xf899f579, 0x53e5317e, 0xe2a52b76, 0xd6cf1a76, 0x5fbe6147, 0x2df2488a, 
	0x0b316e68, 0x0a4a0f98, 0xaa058f10, 0x28a1f52a, 0x210d7ca4, 0xab4c6ef3, 
	0x044ed724, 0x55f9c54e, 0xadc57cb2, 0xb4350bdd, 0xe5873edf, 0x3051c118, 
	0xa1f30db5, 0xb626150e, 0x89749e51, 0x1b7c27e6, 0x984b2eb8, 0xb6e3ef06, 
	0x81864131, 0x2c927459, 0x4d28bb6a, 0xc73d19a5, 0x9734e8f5, 0xe55ef8c5, 
	0xa45ec62b, 0x7d696567, 0xb7ac1e71, 0x1c7cd0aa, 0x612387cf, 0x7960e29b, 
	0xf5026b61, 0xb43fd561, 0xadfb82de, 0x377f9a08, 0xfb12f07c, 0xffec2f7f, 
	0x7d9c01af, 0x8208fcd2, 0x4bfd00bd, 0xae0a2d03, 0xde59aca7, 0x45881847, 
	0x5efb2314, 0xb8be3663, 0x71bd190b, 0xd80bf1c4, 0x686c680f, 0x451feb1b, 
	0x17f5cbfe, 0xcf977f1a, 0x4718a22f, 0xf637ba04, 0x4da5f638, 0x7f8d4ce7, 
	0xcdc27ece, 0x184fd265, 0x28973dca, 0x8039d9df, 0xbdd1427e, 0x57d12e7c, 
	0xde6bfbc6, 0xfe52745f, 0x90587949, 0xc230505f, 0xd879427e, 0x84fd2ede, 
	0xf44b9e00, 0x57fef197, 0xec9375f0, 0x9067b240, 0x3e447a3f, 0x4cc40f9d, 
	0x5fa213f2, 0x17e87d35, 0x7e337bc7, 0x4fc7be42, 0xf01fb8a0, 0xb1d23e63, 
	0x47cccfb0, 0x8a51613f, 0x5842b6ed, 0x0213f48f, 0xc0465fcc, 0x75a45f1d, 
	0x65fae3d6, 0xe32fb19c, 0xef280427, 0x4bdf7f78, 0xc8233cf2, 0x2419b2f6, 
	0x0cdab2fb, 0x6ef25d20, 0xfdc09d4f, 0xff6e2cac, 0xba3bd20d, 0x4beef0ff, 
	0xa60909fa, 0xe265cb73, 0xd5baa089, 0x2037281d, 0xd19feacb, 0x2a3fb4bc, 
	0xe63f6440, 0x7fc1049f, 0x767ea498, 0xea87fd00, 0x2851cb74, 0xd3a8ff4a, 
	0xa709812c, 0x76f7b2ca, 0x37a89206, 0x3bfa1ccc, 0xf8cbe6f3, 0x7fc7a354, 
	0xc1483e40, 0x7e78e5f8, 0xca468001, 0xdbfe5e99, 0x3ca2fcf9, 0x6ea71f62, 
	0x7a8e3ec2, 0x64f9b1bb, 0xdca9fc4e, 0x701d0389, 0x87c240e2, 0x5e8ca071, 
	0xf2f473ed, 0xbc97e904, 0xbed1a151, 0x16cbecef, 0x6bc065eb, 0x11ea5c6e, 
	0xdf0ec7d6, 0xff497f20, 0xfc43e881, 0x67f926d3, 0x1c6f964b, 0x64be423e, 
	0x08f973b8, 0xa9c652f9, 0x20bf6483, 0x1e524d3f, 0x1fd23e64, 0x2be717f9, 
	0xff49fc02, 0x1c8f9721, 0xf8ca19fe, 0xc39e340f, 0x399f0e87, 0xd4fc457c, 
	0xb369f926, 0x2597a3e4, 0xf2ce6cff, 0xc457c39d, 0xe787e66f, 0x8e53942b, 
	0xda615b53, 0xff82b697, 0x71c97240, 0x1ff45afe, 0x0ec45f28, 0xa07fd9a5, 
	0x21f708fd, 0x7d286f3c, 0xf913b52e, 0x24d6b1bd, 0x84b1a03b, 0xd8cbd7cb, 
	0xe594999e, 0xc437a919, 0xfb411284, 0x225351be, 0x396fd764, 0xd9151212, 
	0xc25fc6fd, 0x9bd576f6, 0xe822fe7d, 0x3b632817, 0x67097afc, 0x1aed826d, 
	0xed187798, 0xc0c1fc9a, 0xde65fbf3, 0xc10bb5b9, 0xf9e1f184, 0xbdffd8ab, 
	0x1388f399, 0xed5cff3c, 0x8bfd9cf4, 0x1b17c610, 0xf3817fa5, 0x49a11fa2, 
	0x7fa51a78, 0x76c4db51, 0xf4b9e67f, 0xb397d62f, 0xfe946bfe, 0x1373e945, 
	0x95ef68c3, 0xe0a1598d, 0xd2feaecb, 0xf20da8bf, 0x1bb779f8, 0x7f8041c3, 
	0x46af94ad, 0x1d205fe9, 0x42bf6d66, 0xfcbda2ff, 0x402ff6a3, 0xe343dc03, 
	0xa2ff287f, 0xfe17fa5c, 0xba2ff001, 0xff1e1d69, 0xeddcb2a2, 0x05ff945f, 
	0x4fa017fb, 0x1759ff28, 0x93728686, 0x59de768f, 0x0c710f94, 0x03fc8bfd, 
	0x1a67df2c, 0xdd9b6ff6, 0x8ff790bf, 0x07ce6d46, 0xa9e3b8fc, 0xecbed23d, 
	0x0753c4f3, 0xd354f1bd, 0x82ff6977, 0xce50bfdb, 0xd84145fe, 0xfe2576da, 
	0x9972f2c5, 0xfd01fbdf, 0xe7bc308b, 0xf8e5efbe, 0xec15b517, 0x623f23e7, 
	0x6047ecbd, 0xcf98aa57, 0x42d70890, 0x74daf559, 0x299d5eb8, 0x1ada259f, 
	0x444eaf79, 0x1110bfd8, 0x9f9017f4, 0x2d45fedd, 0x73816bd8, 0xe831feae, 
	0xdfdb39bf, 0x0f3bcfdb, 0x0f3253ee, 0xe643ce81, 0xb6a6a7da, 0xde66f13a, 
	0xca7d9d07, 0x7a357fbb, 0xb00f8bfc, 0x797f318f, 0x969e29ce, 0xfdae67fa, 
	0xa7b3e30c, 0xe77cdf98, 0xe3156018, 0xf00aa11d, 0xf8c3f68f, 0x16baf171, 
	0x6adfe573, 0xdaf447ac, 0xe0fb53e9, 0xf624beb9, 0x2151befa, 0xe7b3ca46, 
	0xdee83bbe, 0x6f5aad87, 0xf0145fa1, 0xeeef1859, 0xbed10ab6, 0x42edbad7, 
	0xb69ff601, 0xdbc556c9, 0x7c213cf0, 0x92237978, 0xcf9a7a80, 0x14180503, 
	0xa455e981, 0x7ef97e3f, 0xbcb23c80, 0xda1b74ba, 0x804dc185, 0xf9ece2aa, 
	0xa290d6b2, 0x43faa9fb, 0xeff216f9, 0xd29655e9, 0x9a50f784, 0x5ed35f4c, 
	0x7c282718, 0x18909f48, 0xfa9f1051, 0x0febae15, 0xd767df25, 0xad20fe03, 
	0xe11525e7, 0xf5e26c89, 0x7af137f8, 0x3f00dd22, 0xa60629d2, 0xde1fc011, 
	0xd0fad164, 0x0043143f, 0xaafbf4ff, 0x25913d7b, 0x5e313d72, 0x7b175e8f, 
	0x25d4607d, 0xbacf718f, 0x0ebac0b6, 0x3865d6b8, 0x07d6faeb, 0xff89d75a, 
	0x10aaebea, 0xffb38e3e, 0xaeb40fef, 0xaf8bffb7, 0x555a242b, 0x086339f7, 
	0xa41e3f0f, 0x7fa24b7b, 0x584f9f3b, 0xce547829, 0x4af1a7f7, 0xb7ed3f44, 
	0xafef3f66, 0xc6d43ab6, 0xe0f40a65, 0xb7960ac6, 0xa24ad450, 0x6a1e035c, 
	0xfd43cf13, 0x6b76e9d3, 0x885f95d4, 0xc09e85f7, 0xd254bef3, 0x942ef800, 
	0x5fa03db3, 0x3c0e5b0c, 0xa5e9ff38, 0xa46f0463, 0xde0956c9, 0x429b8c30, 
	0x50f186f9, 0xd8f333ce, 0x403cf2b5, 0xfaecc911, 0xe20f3975, 0x7483d8c1, 
	0xeb9e639b, 0x3f44f33c, 0x15c53cdc, 0xcecbf74c, 0x1ae30953, 0xb13cfabf, 
	0xfe279d2b, 0xc9f3d6e1, 0xc35bc52b, 0x8acf5b87, 0xf9a79d2b, 0xe373cdc3, 
	0x62b3ce95, 0x74adbc0e, 0x54b901e6, 0xef2ff25c, 0xf057f9c1, 0xa2e61b3c, 
	0xda31e2cf, 0xacf3320f, 0x9e71fb36, 0x9c92aa90, 0x73b96bfe, 0xd6f38e8f, 
	0x3e635b23, 0x7f2033e5, 0x0515466b, 0x19be9ffa, 0x338030ec, 0xf8a631af, 
	0xa0a67e38, 0x7637af5d, 0x1f8c3e2b, 0x66199e81, 0x7f414e3f, 0x654d0440, 
	0x1e9741cf, 0xfbf8f7c2, 0xedca0a12, 0x5677f9e6, 0xf303bd14, 0x10327ea3, 
	0xd7e3c13e, 0x79f1cb76, 0x2636bd1c, 0xe19537c7, 0x9c5e7650, 0x39a9ef0f, 
	0x796bfbe3, 0x2a6190fc, 0x52de3843, 0x7ac20953, 0xc3b60aed, 0x1fb83a3e, 
	0x07ba28ae, 0xe19302ed, 0xe351fa5e, 0x02f18865, 0xe7d233fe, 0x1f7f1fa3, 
	0x71ff5fc3, 0xf0ca3fc1, 0xe35c7d37, 0x4fc78f7f, 0x39f85c7c, 0x209be3cc, 
	0x161f2807, 0x55b703fb, 0x7a447cb0, 0x3c82a284, 0x587ff358, 0xdccf7c51, 
	0xcf37bef7, 0xfba0af1f, 0x1f5f788f, 0xa3e348ed, 0xbc2cf3e5, 0x28fc913f, 
	0xf91f1f18, 0xe3c8fff8, 0xf82e3ec7, 0xe3f249ff, 0xbbff05c7, 0xc7d37e3c, 
	0x792ffe35, 0x85c7c4fc, 0x1a3cf09f, 0x568fc33f, 0x2c3908d9, 0x8fedc9f6, 
	0xb4f53f52, 0xfd157545, 0x8d969b96, 0x147c3f5e, 0x803898cb, 0xc4d1daf5, 
	0x632c1af0, 0x50e86fa9, 0xf862d896, 0x88d72825, 0x528f5dfc, 0xd8bbe2b9, 
	0x787636be, 0xb06fb617, 0xe3c9d81f, 0x03cf1ec7, 0x5506f27b, 0xf991f3de, 
	0x29f6cdb3, 0x9a2b37e9, 0x9eb2f985, 0x3fa872fa, 0x8937aae8, 0x9bda73d7, 
	0x6f6eeea1, 0xd716ea74, 0xaf69ed3f, 0x1bdb7337, 0xac9e394c, 0xcbea7a37, 
	0x9bf7dccd, 0xb37adcac, 0x32cf0b95, 0xa7b97d4f, 0x3b9dbd7f, 0x0b9d837e, 
	0xbea7a34f, 0x5ebfd3c4, 0x6f5391bc, 0xfc7bba86, 0x72fa9e65, 0xbf03bfa7, 
	0x6cdedb99, 0x9a37b6e6, 0x712fe3b9, 0x5bf33bfa, 0x2b06f5b9, 0xa7a37fb7, 
	0x9dcadcbe, 0x9dcec9af, 0xc0f6d9af, 0xf72fa9ef, 0x6f17aff4, 0xf50fcee6, 
	0xf53df99c, 0xf5fe9e25, 0xb37b6e66, 0xfcee66f9, 0xa772fa9e, 0xb9fe867f, 
	0xb72b66f5, 0x3b95a37f, 0x772b12df, 0x03db7abe, 0xdf81edbf, 0xe9e25f53, 
	0x9ed22f5f, 0xeb3da7f5, 0x9fd67b4f, 0x4cc9bfdb, 0xa66fc2e7, 0x7b4feb3d, 
	0xacf69fd6, 0x60deb73f, 0xe8df8ee5, 0xd2b12fa9, 0xe07bf59e, 0x97db73b7, 
	0xfc8f69d9, 0x24d3c2e7, 0x3ff23d26, 0x9cffe1e9, 0xd469863a, 0xa57af0bb, 
	0x08cb7cb0, 0xf339931f, 0xf19cccc5, 0xffad3044, 0x1fed24df, 0x137798a3, 
	0x007617ac, 0xbcc9682f, 0x280a2163, 0xd8eb76ee, 0xa5cf0fb8, 0xd0ad0eca, 
	0x31b9ee30, 0x4294b420, 0x254ff8e3, 0x69fa14b1, 0x27ca2d2a, 0x2373dcfa, 
	0x79801e74, 0x5fb9e7ed, 0x6cca9a60, 0x1fdd0f5e, 0x75aafd16, 0xa52fde94, 
	0x7ebf3afb, 0x3fcf0860, 0xd5fcd6ce, 0xe48bce3c, 0xee7cf5ef, 0x01bdde8f, 
	0xac211bbf, 0xe718a5d5, 0xfdd42bfe, 0xf2c7af18, 0x8137ee3d, 0xd043a2e7, 
	0x9fd6907e, 0xd942b756, 0xfb8c2c24, 0xf6910d05, 0xf60ef941, 0xbed057bf, 
	0x8ccafb81, 0xf8f00ff7, 0xee82f95d, 0xbc5c1145, 0x8a29e8df, 0xaa7a9a4f, 
	0x275efb2d, 0xbee125e6, 0xd3b57874, 0xdcede08f, 0xa309d4f6, 0xc7f1966d, 
	0xcf19fc78, 0x4cee1947, 0x3bf710fd, 0x3cd6f35b, 0xc0c98bcc, 0x33dc306d, 
	0x2fd3c2f2, 0xdd549c52, 0xdf457f5d, 0x3e32107b, 0x23062eba, 0xcb7abc63, 
	0x51f28545, 0x6e1f77e4, 0x10ad59ea, 0x053a2afd, 0x82d8638e, 0x1ada29c6, 
	0x1e06ffb3, 0x96ddb56b, 0xe79b2f32, 0x1d39e167, 0x8b67477e, 0xb2f973a0, 
	0x7d3b6b3a, 0xa442a53f, 0x7cf0b5a3, 0x76e78cc1, 0xefae5bf4, 0x4053fc9e, 
	0x68e1efc1, 0x5101f399, 0x107bdfca, 0x002bc60a, 0x54678a6e, 0xf6c2c2e9, 
	0x93db2560, 0x12660535, 0xccff8dc7, 0x7edef050, 0xad26c9cd, 0x83788628, 
	0xde1b7e37, 0xb578394e, 0x0175c7df, 0xd3d4c41f, 0xc6a575d9, 0x8ff95d79, 
	0x43644da6, 0xbe107aef, 0xfc03efb3, 0xccfc008f, 0x3f73aa0f, 0x3a609cf9, 
	0x31fff8e0, 0x00d2bcaf, 0xd74f233b, 0xdf581e09, 0x2df81468, 0xe4fec95e, 
	0x7ed1d8d4, 0xf4d4ffc7, 0xbf79ffac, 0xf69576c5, 0x97eb7123, 0x8565ed61, 
	0x3addeeb1, 0x77d6d3ae, 0x06f1871d, 0x0d67e217, 0x7f0854a0, 0x1e7256d7, 
	0xf8eb54ee, 0xa75801a9, 0xc8fb64e8, 0xe5b4d389, 0xcfcc5199, 0x607cc36d, 
	0xe300d3a4, 0x392a37f3, 0x4f4bd60f, 0xffbf071a, 0xfa6c2434, 0x8fc48dbe, 
	0x736eeeff, 0xb0f82cf7, 0xd5c73e34, 0x3f91cf91, 0x3df43dfc, 0xd0a8cd32, 
	0xb9e33706, 0xe1afb9e3, 0x77d01df7, 0x6533fd44, 0x58f89c71, 0xa799c723, 
	0x47cf72fa, 0xfbe7769d, 0xa517f065, 0x24f5793c, 0x632103f9, 0xb158e8a4, 
	0x7f32bd6b, 0x62ac3541, 0x09662fd6, 0x1f466fd6, 0x47c9337f, 0x5853e531, 
	0xdc113ebc, 0x62724c54, 0x211cf3ca, 0xaf02ff28, 0xdefdd2a3, 0x3b9d0603, 
	0xd8f24d8a, 0x78ce5853, 0xda7c0eb6, 0xf25db37a, 0x5e1b35a4, 0xbdfc9ded, 
	0xff5cfb16, 0xdbb7e46e, 0x908e512a, 0x9766c50f, 0xe24c30de, 0x3c241abf, 
	0x1e0c3f9e, 0x6949f479, 0xc1f3261f, 0xcea3d43e, 0x2228f03d, 0xd7f9ede8, 
	0x151dfbd1, 0x88dd62b6, 0x0bc701fb, 0xa4271803, 0x3f239bf5, 0xade967f5, 
	0xca118dc7, 0x9ebd7e2b, 0x5bb4d2f2, 0x47b8a2df, 0xca48a955, 0xd22484bc, 
	0xd74dab49, 0x7ac0cf5a, 0x145b0f6e, 0xc95a0c0f, 0xdcdd9731, 0x719f7cee, 
	0x19e28275, 0x189f1fa0, 0xdf6d983b, 0x6aec0cb0, 0xb86eab8c, 0xf4e30a78, 
	0xc6cca89f, 0xdb8f9149, 0x673a553b, 0x3bd84f69, 0x3646bbf9, 0xd61db421, 
	0xc4f08fb4, 0x9daf787f, 0xc14c63ed, 0xf9a0f682, 0x674d8ffb, 0x3edeb7fb, 
	0xbbefadfc, 0x75ab18ea, 0xb341bfbf, 0x6ca760fe, 0x63f7c6ef, 0xd330cef6, 
	0x3e7b7ea1, 0xbfd32fd6, 0x7fa73c73, 0x29f4f960, 0x00e1146d, 0x3df5867e, 
	0xddf2eb02, 0x2d067007, 0xc76a4b92, 0x7fe89b7b, 0x65d2497e, 0x3d239f90, 
	0x572af132, 0x0fa7947f, 0x877e370a, 0xa6fc6721, 0x7185c504, 0x80df983d, 
	0xe1b88ef8, 0xf47af6c2, 0x8953be6f, 0xfcd69ae7, 0xfca4a83f, 0x0b7caf49, 
	0xca0ed4fb, 0xc199308b, 0x35ce50af, 0xcb3627dc, 0xe9e7d173, 0xd373dcfd, 
	0x4e7495d6, 0x28327c1a, 0x46f437bf, 0x96bbd60d, 0x771f7c19, 0x1ad3d36c, 
	0x732f6f7e, 0x9243fa2e, 0xd347f50f, 0x79412bd5, 0x1bf33e88, 0xee91ddfc, 
	0x9f5f71a7, 0x5b3e2e5b, 0x3a71728c, 0xf9125afe, 0x900aa6fc, 0xf58b9077, 
	0xe21f6b71, 0xcd21aba1, 0x626052fe, 0xd6c40f04, 0x9c91f537, 0xf17c3d74, 
	0x2831cad4, 0x5db826eb, 0xddb14b35, 0xec3eb1af, 0x7c8afd5a, 0x9f1fb27e, 
	0x75bfb577, 0xfbe03b6a, 0xddc02ab6, 0x7fbf50bb, 0x180ed4fc, 0xb9f30b47, 
	0xe611769c, 0xbf10fbc3, 0x1977d008, 0xf736afd6, 0xa8b53a21, 0x39021c99, 
	0xfb430aeb, 0xa62fe610, 0xeb5cbbe8, 0x21f6ba47, 0x7d5faf0b, 0x26cad4e1, 
	0x205c3728, 0x47fb9c78, 0xb24487fe, 0x5f2b247f, 0xc38e2ab1, 0xbca55bff, 
	0xeb89a07f, 0x9b2f2853, 0x8c0762a2, 0x5e5099a7, 0xfd07eb83, 0x00f31674, 
	0x42e0daa3, 0xef48376c, 0x6d71ad6a, 0x8ae9e610, 0xf597849b, 0x3c5be071, 
	0xf2726bff, 0x7b00a039, 0x85e03d63, 0xe82b5b9e, 0xb225faf9, 0x13ae21df, 
	0xaefc617e, 0x603fa08b, 0x5b9febbd, 0x15d204f2, 0xd0e7c649, 0xf11fa413, 
	0xddf8027b, 0x89f10d97, 0xa3fcf157, 0xbca2dfab, 0x82bf5876, 0xbc2b4feb, 
	0x6ac14c3f, 0xc0fa3ce8, 0x5e8f3a0a, 0x2492ecff, 0x9e33a7f2, 0xebb5cf37, 
	0x0fd92062, 0x5354c076, 0x2eb4f9ee, 0x37d7fdf3, 0x0437deaf, 0xa1febcac, 
	0xbdfc53f1, 0x61a25158, 0x5f3fee3b, 0xa9c5eace, 0xae3c15be, 0xe2cde75c, 
	0xf03f7144, 0x9c6dc751, 0x2e4b09b7, 0x039338c1, 0xd927939f, 0x1c8f6fd1, 
	0x197dfc02, 0x4ffb11e8, 0xa1bf83a4, 0xd827be93, 0x34393975, 0xa7c46af5, 
	0x04efe215, 0x48d7de8a, 0xf45adf0e, 0x92c39649, 0xc3926a9e, 0x95359de1, 
	0xcf2f9201, 0xa9af6d77, 0x6daef9ca, 0xac25c80f, 0xb3df6bb3, 0x2a972835, 
	0xbae16de6, 0x59fd7887, 0x825edcb9, 0xb8a131df, 0x5ea905fd, 0xcf7f7e70, 
	0x6ebfa411, 0xf2d87f72, 0x82bca01e, 0x177f5e7a, 0x9e0b6de2, 0xe03b419f, 
	0xa1fc434d, 0x4378813d, 0xeeb94579, 0x27c076c6, 0xcd5d57ec, 0xd7099780, 
	0x75bc1efb, 0x8976c9d5, 0xd0dd8cb7, 0x0dd914fa, 0xfc423d5e, 0x1fd2ee5d, 
	0x32589e8e, 0xa91871c1, 0x81fab227, 0x07ea0af5, 0x5f41d76a, 0xb0fd5958, 
	0xce50f53e, 0xca175df9, 0x31add23d, 0x59fc2176, 0x7a6b7394, 0x5eb38c2f, 
	0xa19c31d2, 0xdefdae63, 0xa9c4e4b5, 0x47a8a31d, 0xf579d0cf, 0x65af5bad, 
	0x9396f6fa, 0x67a59f1d, 0x1d7942bd, 0xc61ca98a, 0x7fc76332, 0x3ea8e899, 
	0xc79f8e3e, 0xbdf23a02, 0xcbf3214e, 0xf78ea731, 0x188f4903, 0xfa425fdb, 
	0x17e62a2b, 0x137f31b7, 0xc2e35afd, 0xacbcc31a, 0xf3c7f520, 0x7b5f6645, 
	0x0521f884, 0x08b28374, 0x377e44e4, 0x77f701e3, 0x108e5151, 0x917e2ebf, 
	0x047cbc7a, 0x78759bed, 0x1ddf8b1e, 0x2e74db8a, 0x4a4f8814, 0x17b9de3d, 
	0x3eb7adf1, 0xf03c7a44, 0x878cb8f0, 0x7bc451d9, 0x5b274320, 0xd4ad7ac5, 
	0x1ce781e7, 0x813c557a, 0x029e07ef, 0xcfef0e7d, 0x1e7d66ab, 0xf09c6c78, 
	0xe60b0feb, 0x2f308baf, 0x529da1f8, 0x2dabeb9f, 0x47f6ebca, 0x34a1bec5, 
	0x3ea3c1e7, 0x857f6b6f, 0x457d1df6, 0x5cfa892a, 0xd71eb38f, 0xef5eb197, 
	0xfe528f6c, 0x2643e768, 0x9f472de9, 0xff3ea5a7, 0xf3eb155e, 0x17d1d5d6, 
	0xd76cdd78, 0x0f7cf005, 0x01eb69e6, 0xd6867839, 0x163df9c7, 0x10e04dcb, 
	0x6dbfd094, 0xfc0cf014, 0x39621fe2, 0x39601c09, 0x900e51d1, 0xdf3137ef, 
	0x1ca44beb, 0x95d0ca6c, 0x42be8cf4, 0x415d6f3e, 0x47ebe2cf, 0x12abe786, 
	0x537f78ff, 0x73fa6bee, 0xe7a3947f, 0xc6eb3f69, 0x8f493a37, 0x75d23adf, 
	0xd197e904, 0x28bf32e7, 0xf6887c0d, 0xddecfeba, 0x93dd7ab9, 0x37e8145f, 
	0xd7a0ce89, 0x3306fbe8, 0x48de2fda, 0xf32ea1fb, 0xfee6f544, 0x1d79ea24, 
	0xfe8bbcf5, 0xfcf4b9fe, 0x7f3d5ca6, 0xd251b3d3, 0x5ef01df3, 0xca5f9e8e, 
	0x7ea6fe7a, 0xf9ea2f73, 0xd88fe07a, 0xf47afff9, 0x491fece9, 0xf81d3da2, 
	0x35fff4a8, 0xf4953543, 0xfeaf63fd, 0xfd56677f, 0x2a39581f, 0xf44dbff5, 
	0xb41937f0, 0x773fe16e, 0xd374f104, 0x0017af28, 0xc89c5288, 0xf917e8f4, 
	0x7f9761bd, 0x117ee0a3, 0xdf02fc40, 0xbc621db5, 0x936b783a, 0x3ea00b78, 
	0x52ed7ec0, 0xfe30f7cf, 0x97de8e02, 0xfb380cf8, 0x4667c4a5, 0xd1769bef, 
	0xf533bdb1, 0xfe4cbace, 0x5e37d487, 0x95e3b2bd, 0xd592bd1c, 0x488fac27, 
	0xf5658c9f, 0x3b609e88, 0x01fbd1d3, 0xaf480fd4, 0x2217d581, 0xc41f51c7, 
	0x1e5047a6, 0x39b4bc9c, 0x43e07ef4, 0xe0e07deb, 0x9f78177f, 0x9143f95e, 
	0xf67377cd, 0xc3ef4765, 0x6abcb78c, 0xf523e8b9, 0xa47de934, 0xe903d02f, 
	0xfef7d5ea, 0xfa35db04, 0x400fd801, 0xf504fddf, 0xbf247bfd, 0x4bbfb80f, 
	0x7484f28e, 0xaeebe6f3, 0xe5b0d6bd, 0xd8ab993d, 0x8724084f, 0x92268e28, 
	0xdfa9e798, 0x6e79495e, 0x455f27e0, 0x8fc56cf7, 0x9eff90eb, 0x9542198c, 
	0x57bc1ff1, 0x55e088aa, 0xf3c06f14, 0xd1aba81e, 0xffb36f89, 0xbfb9d56f, 
	0xf5ded1d7, 0xc75c19ca, 0x67d1b193, 0x604d3ef1, 0x0c5d5f69, 0x3d45eb9e, 
	0x72846edf, 0xdfa335ed, 0xea5d0fae, 0xba1ee31e, 0x024a88c7, 0x96430c65, 
	0x838279d6, 0x02da89ce, 0x92e18e96, 0x47c1f00e, 0x475dfe5c, 0x3c19fa59, 
	0xe328ea37, 0xdd0ea373, 0x047c3dde, 0xa61882ca, 0x80aa8901, 0x1acf707d, 
	0x9ec4eb8c, 0x718833de, 0x13d4d1ab, 0x76ebb837, 0x37c0a3fd, 0x2def9b35, 
	0x5b343ab9, 0x1f6d6eff, 0xf31d97ec, 0x20d77d6d, 0xfd39af7e, 0xb02d3dad, 
	0xa44c40de, 0x6077ea2c, 0x17ec1aef, 0x00577fbb, 0x5f5779c7, 0x138e2378, 
	0x03bbdd2b, 0x91bcaddb, 0xdb2f14e3, 0xb5161bb1, 0xdaeeb358, 0xe8d6fecb, 
	0xff7805a3, 0xe3117ec3, 0x8085551b, 0xdb4f186f, 0x60f842b0, 0xeab07d5f, 
	0x0efc6afe, 0xbf8d62ee, 0x79d65747, 0xc628496f, 0x5cf8c174, 0x629e79bc, 
	0xe3fc60b4, 0x9f43e241, 0xb6274b30, 0x0bcd5c03, 0x7940673f, 0xf4c3f55d, 
	0x85ec6d7c, 0x55e2f224, 0x3f8847f5, 0xe8522ed7, 0x5f75777b, 0x4465ea7a, 
	0x5efc9572, 0xa4c255f3, 0x7139ddef, 0x91029abe, 0x9fecfcc4, 0x821e7354, 
	0x357dc4bb, 0xd27ee72b, 0xe39e1a2f, 0x6571916e, 0xece3d41f, 0xdbd54fa7, 
	0xf83899fd, 0xd21cac8e, 0x8f8e7f75, 0xc4f3c71e, 0x7f55f408, 0x7ef6e293, 
	0x9c8af3cc, 0x3fc97a6c, 0x429fef4a, 0xf2722f3b, 0x3d287ffc, 0xbc28bcae, 
	0xa58dd4df, 0xb78c9bc4, 0xf386a67d, 0xcc3de9a9, 0x797e979b, 0x3f72cda7, 
	0xbaf1bc57, 0x5f1967ea, 0xeaebe326, 0xcfaf8956, 0x57c46128, 0x8db7edcd, 
	0x754c9e60, 0x689c505a, 0x8526dbed, 0x20f9e04a, 0x6616afd6, 0xf6b7f118, 
	0xbd40116d, 0xf21b0ed7, 0x4f965f48, 0x889e6335, 0xe37eeab9, 0xd13ed7e0, 
	0x004b8d97, 0xbdf1347f, 0xf6c4fb37, 0x05de80c7, 0x771ed7d6, 0xf0ae63c7, 
	0xe5bbac7d, 0xf1bd29ca, 0x7635b3b1, 0x323fed35, 0x73f4e64e, 0xdf0e65e2, 
	0x209ffb65, 0x498488fc, 0xff0e05e7, 0xf15c6fb5, 0x178ae284, 0x9e933f13, 
	0x59c943b1, 0xb85cc9e5, 0x966705df, 0x0b8e741f, 0x208b7a4a, 0xf664c5f0, 
	0xba6e629c, 0x197b759b, 0x0b3b156f, 0x654e6e50, 0xd989e6e5, 0x5a4de5e4, 
	0xbc867f87, 0x98f845bc, 0x932a5e5b, 0x24d17f48, 0x2edd5f4a, 0x8dc707e5, 
	0x753f941b, 0xe99fe6b6, 0xec23927d, 0x04f45cdf, 0x3f0905c6, 0x0e3e24f3, 
	0xeb0f86ce, 0xfaf7495a, 0x8e10c781, 0x1f1c339f, 0x5ca61f21, 0xaaf812fa, 
	0x37c971e5, 0xd97cecc6, 0xbc5709f2, 0x9ef072ec, 0x20d709ad, 0x51ede33e, 
	0x39883f8a, 0x1b97afe2, 0x0ae36aa7, 0x7cf607db, 0xb685aafb, 0xdf564cef, 
	0xb46dde01, 0x15e733f3, 0xa44f7c35, 0x04e386a6, 0xd655560f, 0xe7c9f7e0, 
	0xc10d77a6, 0xfdbd21a7, 0x6ac77a6e, 0xd66f4d2e, 0xd4cf448f, 0x7f6fe1e5, 
	0xf0457133, 0x7ac35ebf, 0xfe0674f4, 0x1dfc1aa6, 0xef178403, 0x39ad9dc5, 
	0x5ebc2b3d, 0xb73c84b8, 0x976cf823, 0x927ca2bc, 0xd68a7ebc, 0x83a7c8e7, 
	0xbccfc20f, 0xdcd3912b, 0x2f1dcdf5, 0x2f14a337, 0x586efcc7, 0xce72db6f, 
	0x27bb05ab, 0xf2b9a939, 0xe4539bbc, 0xe5e2667f, 0x325f4e9f, 0xf18ede5e, 
	0xe7878a72, 0x3303cbc6, 0xee23e5e3, 0x978c56f6, 0x2b1c0317, 0x7e5e29a7, 
	0x5e373ab0, 0xa208481e, 0xd6612073, 0xcbc572ed, 0x97899703, 0xe7f68207, 
	0xfdb8fadd, 0xfe17d0f6, 0x78ee6fa4, 0x3626ab79, 0xe7e972ef, 0x8baccc40, 
	0x3d373e30, 0x2fd618fa, 0xdb913fd3, 0xcbc64dbf, 0x7e5e3203, 0xbc6e4d67, 
	0xbc466dbc, 0xc832e81c, 0x978b67cf, 0x2f11cdb7, 0xd9dc1cbf, 0x5f1cb978, 
	0x3d71cbc6, 0x6f88e7c8, 0x2dbcbc77, 0xb47f2f13, 0xbbe5e386, 0x3e5e306b, 
	0x857e3e23, 0x9ad9f4fb, 0x3f7c3503, 0xe3bff99a, 0x3be81a37, 0x88371df9, 
	0x7903edcf, 0xc7e615b9, 0x5f55597b, 0x4a8bd9fc, 0xddfff611, 0x6724fe9c, 
	0x5e2e1f60, 0xf3b7fd0e, 0xec5437f3, 0xebf52cf7, 0x70471168, 0xc7cf8e9c, 
	0xc77b6f49, 0x5dbf2bb3, 0xf6979da3, 0x7d595bd1, 0x7be6b677, 0xc822b724, 
	0x174363fb, 0x5d97ffe8, 0x49cf08fa, 0x8cef505b, 0xd2f9deb1, 0x577e7453, 
	0x7039bf83, 0x8df6f41a, 0xe47e2817, 0xd4b8f9e8, 0xd7a971f3, 0x4b0fdf49, 
	0xe57ddf7d, 0x3e201e7a, 0xe100bfbf, 0xd68d41fe, 0x47dc1b3b, 0x97ee10af, 
	0xcdb8263e, 0x82bfbdc6, 0x49d8e39d, 0x91fe6b67, 0xff739ae0, 0xd6c8c0c1, 
	0xece5ef99, 0x25e74017, 0xe7454f20, 0x124f1f51, 0xc3d2e77d, 0x5b5f55d7, 
	0x5d5d9b33, 0xc3ef6a55, 0xf4b740fb, 0x5c4dac5f, 0x57d6e503, 0x1d59ef38, 
	0xcb83c12d, 0x3a861e5b, 0x73bec1da, 0xd31bd50a, 0xb9e80ab5, 0xd44d965b, 
	0xf4cccfaa, 0xd5ad3adf, 0xc3f7f251, 0x8efc5ed6, 0x4a25a766, 0xac42d3fa, 
	0xa8a3521f, 0xb30bd73f, 0x8e4fde44, 0xc9d77ae3, 0x3eceda78, 0xbc61da30, 
	0x5ed6a29b, 0x62a9a78c, 0xf9ef2e22, 0x9df7922d, 0xa8fef96b, 0x1dfdd0b1, 
	0x6aba701b, 0xc6b5ee73, 0x7fd885cd, 0xbf2e2a57, 0x3c2d6ad3, 0x4defdf85, 
	0xbbf2e304, 0x1df97147, 0x9e7c459b, 0xe308ba34, 0xd4c2da1a, 0x639e04a2, 
	0xa2ff7efd, 0xc37fd095, 0x5a2caf33, 0x1d0df509, 0xdc211717, 0xd7b40fad, 
	0xf573c036, 0xae8bcd7b, 0xe4f8b2c1, 0xcd4b8a69, 0x930617e5, 0x7d2a17e4, 
	0x9e1d7cfc, 0xde008c53, 0xefad26a2, 0x38bb7ee6, 0xb4dce305, 0xcf96bc73, 
	0xee28cc25, 0x03e62b8f, 0xf98bbf4b, 0x43b5d383, 0x1ac08f80, 0x7f94aefe, 
	0xab57f400, 0xad2b5d10, 0x4c7a0112, 0x182a663f, 0x50f75c6f, 0xbd00b17f, 
	0xe78315da, 0xd5747fb0, 0xfb37b943, 0xd74446fb, 0xefbca017, 0x29f8ad62, 
	0xdc714c3c, 0x671926e8, 0x744e3398, 0xd79d056e, 0x92681d4d, 0x857c11df, 
	0xe17e35ee, 0x1dbbfcbb, 0x3dd13899, 0x1388e73b, 0xf24f9f2d, 0x7a89c4e9, 
	0xd3744e39, 0x40273e56, 0xc59ea03c, 0x247ccbf5, 0x1bae3f5a, 0x93278f7f, 
	0x1f382f6f, 0xd96016f8, 0xde977ad4, 0xef144615, 0x11b9e0a7, 0xcdd4d7e6, 
	0x2de9f8e7, 0x715f450f, 0xb760b7ee, 0x14a3fa5b, 0x99ea7467, 0x3ca68efb, 
	0x291eb25f, 0xe1c1ee76, 0xe7bc0c87, 0x75fe0e4b, 0x9b6833cc, 0x0db1ef79, 
	0xfa1c85cf, 0xd3e9650c, 0x85c7718a, 0x85722f78, 0xf1905fcc, 0x8d3ba046, 
	0x956bf487, 0xa492fbf4, 0x3dd736df, 0x50571bb9, 0x3d0671dc, 0x111d0277, 
	0xe7fe320f, 0xded7aba5, 0x7dfa3f81, 0x6ba49892, 0x64b8e15a, 0xf6458547, 
	0xdc4a54cf, 0x6177d16f, 0x7bf6be18, 0x8ee935ff, 0x12254eeb, 0xd1f1bbf7, 
	0xd1476151, 0x10c4d65f, 0xe0122efd, 0xedfda72b, 0x82bc2f75, 0xbe0e69f3, 
	0x7b70573b, 0x9eeb905f, 0xef601dfe, 0xb19c3ee0, 0x1fbc6273, 0x5fbc73e3, 
	0xdcfcc8f5, 0xfb4e55fb, 0x9f39f303, 0x50b789c7, 0xc3d7df89, 0x7c6bb330, 
	0x5e7a37f8, 0xfca9be23, 0x61f900c5, 0xe223bf02, 0xb1deeeaf, 0x2695ee93, 
	0x845e30bb, 0xfb85dfbf, 0xbbc5b2c7, 0x861fa3e7, 0x7a45e3bf, 0x8255a0f9, 
	0xbdf9c2fa, 0x7d06dd2e, 0x21eb2dd6, 0xfa97bfec, 0xe8943c77, 0xfc0bbca5, 
	0x3bd4255d, 0x5fdfe0df, 0x4223d172, 0x9efe5fe7, 0x7feefa7e, 0xf3c11d85, 
	0x44a78e8c, 0x46f7fbaf, 0xdfcab63a, 0x3c02fae5, 0x883ff997, 0xddcfa5b8, 
	0x17439e3d, 0x4f29c6b0, 0x5ef9d5a6, 0x8bdfc9a4, 0x57f924dc, 0x6484d79e, 
	0x9fe9dbfc, 0x6a8fdef9, 0x6233fc53, 0x81a29ffe, 0xe3bc9cb2, 0xe31be401, 
	0x0d2f1929, 0xa638e73a, 0xdfc14c7a, 0x773f01a9, 0x50df8b22, 0xb5c50577, 
	0x8a0dba8b, 0x84c4476b, 0xc01efa8a, 0x46fd7156, 0xf745dedc, 0xda627aea, 
	0xd0ced020, 0xeccefde1, 0x051a40fb, 0xaf6083f7, 0xf4b2f241, 0x74efb631, 
	0xc61f79eb, 0xf2d10de5, 0xdecb80fa, 0x0979fa5a, 0xd2df5c97, 0x970f1976, 
	0x5781b5df, 0xb7c3775e, 0xe4d3e614, 0x008eb8fb, 0xe08f477e, 0x8efe1a13, 
	0xc0096153, 0xf19ffb07, 0x17ffa1f0, 0x021c44b9, 0x3a7ba346, 0x9f0ebd05, 
	0x0f7442bc, 0x413e4ab5, 0xf965b77a, 0xf98ea3a4, 0x438563a1, 0xfa614b5f, 
	0x4aade866, 0xaf38fac4, 0xdc762831, 0x5eac6505, 0xe47c00ec, 0x9f082ac5, 
	0x2ae2834b, 0xf5d9a7eb, 0x0f96d817, 0x715c2ff9, 0xe308369d, 0xcd315d2f, 
	0xaae32ff2, 0x6698ef4b, 0xebbf20fd, 0x596ef4b6, 0x8a59f897, 0xb34fd7ae, 
	0x00f230f8, 0xfbf2dd0f, 0xf48ed882, 0xbe3e114a, 0x5876cc5f, 0x3742eed3, 
	0xefa71c7f, 0x73552cae, 0x87a960f9, 0xe87a962f, 0x174bd4bc, 0x76eeea15, 
	0x3dd753cd, 0xdb9985fd, 0xedb99aae, 0x7baea79a, 0xf3cb0bfa, 0xdf79e5be, 
	0xfd3dd753, 0xdf81ed85, 0xa9efc0f6, 0x42fe9eeb, 0xff59e1bc, 0xbff59e1b, 
	0x1bff59e1, 0xe1bff59e, 0x9e1bff59, 0x59e1bff5, 0xf59e1bff, 0x3cb7de7b, 
	0xbaea7bef, 0x3db0bfa7, 0xf81edbf0, 0xd3dd753d, 0x7337885f, 0xce7a87e7, 
	0xeeba9efc, 0xdccc2fe9, 0x6dccd576, 0xdd753cd7, 0x5db41fd3, 0xe796fbee, 
	0xf75d4f7d, 0x07b617f4, 0xbf03db7e, 0xfa7baea7, 0x59ebd6c3, 0xfeb3da7f, 
	0x69fd67b4, 0x9ed3facf, 0xeb3da7f5, 0x9fd67b4f, 0xf3dfacf6, 0xdf79e5be, 
	0xfd3dd753, 0xdf81ed85, 0xa9efc0f6, 0x42fe9eeb, 0x7ff87a4c, 0x93ffc3d2, 
	0xf49ffe1e, 0x3b4e7ff0, 0xcfda01b8, 0x4102b434, 0x3b40555f, 0x6dc28dd8, 
	0x7df3e637, 0x75fe6d50, 0xc715cf96, 0xe380bfda, 0xeb094e58, 0x765cb5a8, 
	0xb723ac25, 0xa5dd43ae, 0xe67f517f, 0x6efbc3b4, 0xe7ef8a7d, 0xf77de1d4, 
	0xd0ce3aef, 0x91a141bf, 0x6fe315be, 0xe93078ca, 0xdaf919db, 0xbce8e7a3, 
	0xd0cad0ef, 0xdf3efe15, 0xfd901677, 0xf3efc73d, 0xaeadebf9, 0x448bb266, 
	0x3dfe31fd, 0x9f7f59ba, 0xfc96f7ee, 0xe7dc02f1, 0xa3a7df9c, 0xceeba5df, 
	0xf79e0efe, 0xf7eb5e1e, 0xc84dfcf8, 0xc4ad67bc, 0xaa9bc789, 0x3a8a7efc, 
	0xf93b5165, 0x584341ed, 0xc421ded7, 0x4547a051, 0xb9c73caf, 0x7fdfe653, 
	0xe20bde8b, 0xbcc2ddf9, 0x3efe0a85, 0xec05b1e3, 0x3ce73aef, 0xc46e3c99, 
	0xe7cc9d65, 0xfc7ee1ee, 0x1f7c7f7b, 0x8bcd6cf0, 0xbbbf300b, 0xa5edcd75, 
	0x3dde8794, 0x5a5f139e, 0x718a279b, 0x793d6b5d, 0xe42f18d0, 0xe2888cef, 
	0xbf3997e1, 0x2bde0876, 0xd73c718f, 0xd0a42f95, 0x79e132ef, 0xff367975, 
	0xf2bf1336, 0xfbaedde6, 0x316ef2d5, 0xd8e9179f, 0x16c4f186, 0x1cd13c77, 
	0xb6dfe771, 0x116ff279, 0x6ff239de, 0xca679cfd, 0xc82bd9d1, 0x89df7dbf, 
	0xb70323c3, 0xbe2c3ede, 0xdf7d97df, 0xd36b971b, 0xd94edf2c, 0x8f6ccb8e, 
	0x8f30fed9, 0x573c5df7, 0xcedfe6f7, 0x9e39dfe8, 0x7f9bdfd3, 0x380b6ffb, 
	0x01fff89e, 0x9258bd00, 0x0003ae31, 0x7dad9c78, 0x5754780d, 0x673ee8b5, 
	0xf99cccce, 0xc9993249, 0x1807e4cf, 0x21264242, 0x76d2da40, 0x940e5880, 
	0xc6815096, 0xaf62cfd6, 0xaf5a86cf, 0x8a862951, 0x396d2c6d, 0x40210933, 
	0x25a0434b, 0x7b735a14, 0xebda5ebd, 0x557aa5f5, 0x079efaf4, 0xf5682d28, 
	0x516d5bc6, 0x5e05a6ab, 0x2a9a8eb1, 0xcd2c5357, 0x75ed6b5b, 0x424ce666, 
	0x7cbeefab, 0xfb5ecdda, 0xf6bdace7, 0xb5af6bda, 0x3c7bdaf6, 0xfd98a9ba, 
	0x1aaf7842, 0x0b8b457f, 0x628485a1, 0x77084c7e, 0x6dcc52d4, 0x1313de12, 
	0xfefe0262, 0x9e108b79, 0x873dfa9c, 0xed943ea0, 0xbf99171d, 0xdae99a95, 
	0x028425d1, 0xfc876bff, 0xedcb310d, 0xa7a2a2ef, 0x77d510cc, 0xfc4f1ff6, 
	0xeb0867a2, 0x0a96a109, 0x60690e51, 0x86eb9413, 0x03960efc, 0x97a6eb5e, 
	0x429bc4c5, 0xc6a1d398, 0xedd22146, 0x22fbe947, 0x5bc426da, 0x5059b442, 
	0x82885db6, 0x638d4707, 0xfa7b4e00, 0xc01b7984, 0x8f45fada, 0x426b780e, 
	0xf0023f74, 0x1281e244, 0x0e3a46f8, 0x29e110e9, 0x3fe13afa, 0xbb4b6dee, 
	0x68bd2007, 0x42c3db28, 0xaedf999c, 0xd44283e8, 0x98d0dd43, 0x86e36710, 
	0xb542f622, 0xb203a404, 0xec97799d, 0xae3c4347, 0xa3e64d14, 0x5df70c42, 
	0x38c055b7, 0x3ca1863d, 0x91c72857, 0xf7e92dda, 0xe7a809cd, 0xcfb5b94a, 
	0xfd84d10b, 0xf4a2179e, 0xb40f12df, 0x6fd4861c, 0x4ef1c56c, 0xe3415d8b, 
	0xa57f54bb, 0x337ea1cb, 0xdb8ebbf7, 0x4ca5f541, 0x2f4efc37, 0x4eb893cc, 
	0x973bf084, 0xf502dfaa, 0xeb657723, 0x9c6078d1, 0x32eb5d69, 0xd2e7243f, 
	0x21698a84, 0xb153ef38, 0xfc875a5d, 0x41e5394b, 0x5b93d923, 0x37979fdf, 
	0x39788612, 0xf8fd7f27, 0x9650e66d, 0x99b0f49f, 0x1ece8134, 0x9efc614c, 
	0x26df8e8f, 0x8272b0da, 0x12ba78da, 0xfe0462ed, 0x4dfce091, 0x18f2c790, 
	0xdf389be7, 0xf23af329, 0x5c6bd227, 0x0847a911, 0x8abe0ea4, 0x030ea170, 
	0xad8b2c8f, 0xc5ff298b, 0x055f0078, 0xa2a90d6e, 0x59cff202, 0xc39f23f7, 
	0xc051d587, 0x4a102b53, 0xf8426bf7, 0x77a2e543, 0x5899f226, 0x75867c86, 
	0x83641f4d, 0x3e049686, 0x250ba6d6, 0xbbf68299, 0x29a1fda0, 0xe896d7e8, 
	0x24379812, 0x73b1c57e, 0xd0a33d45, 0x945c363e, 0xcf4c9e6a, 0xb36346e2, 
	0x59cc79fa, 0x3d9f868a, 0x5098f46a, 0x2dcd4cff, 0x5dfc0129, 0x337db47c, 
	0xdac5a9e2, 0xd90cbdaf, 0x3aa96e36, 0xb09bcf8c, 0x8049d0d4, 0xc73e4897, 
	0x97a8417a, 0x80fbff82, 0x806ab5bf, 0xd8dc2297, 0x0f0b985c, 0xcd8df5da, 
	0x4e5e60bb, 0x83df0f5f, 0x84a81b85, 0xa6eb07f5, 0x79f006b8, 0x6b71f08b, 
	0x780a9f80, 0xaf47c099, 0x56792f95, 0xb2f08939, 0x59f3e2e5, 0xacbba4ba, 
	0xba6fac94, 0x1ff40f34, 0x8a3a8a17, 0x72c34359, 0x44773ee1, 0x2df0fb60, 
	0xd612b149, 0x03dbf43b, 0x2df553df, 0x66fd7047, 0x0df3c1e8, 0x8fd24beb, 
	0x5aad21f9, 0xe015fcc2, 0x9ee16967, 0xfd1f2547, 0x5f4c8b79, 0x3b7a409f, 
	0x99f36fbf, 0x4554cbbf, 0x0cc6a431, 0x4d748be2, 0x438381e2, 0x0a352e34, 
	0x94a61bf8, 0x740aff1f, 0x7e431e69, 0xe70bbdfa, 0x59bf2bfb, 0x5612e348, 
	0x7e71c358, 0xc8163fe4, 0x0e8830bc, 0x7ba14afe, 0x6422fe80, 0xc90b7eba, 
	0xf0f4189a, 0x50e71c39, 0x15e911aa, 0xafe214b2, 0xdb03c49b, 0xbbe97be0, 
	0xcadfef47, 0xf00fbffc, 0x78936e2a, 0x174d0615, 0xe61fadf2, 0xedbe6544, 
	0xa343fe83, 0xadf5a1ff, 0xa7957a44, 0x4247c874, 0x000daddf, 0xcf0006bd, 
	0x774dd410, 0xea2df93a, 0x97e41e17, 0xebeaf448, 0xfeb4edbc, 0x33d004ba, 
	0xe54d5c38, 0x71c34b50, 0x684b1359, 0x2a5851bc, 0x982b3798, 0x7d65075f, 
	0x0fa57d7b, 0xc82dfd33, 0x60207943, 0x7f207f12, 0xe473279a, 0x8f2cbf43, 
	0x2e913d01, 0x90375c5e, 0x953a43a6, 0xce41788f, 0x94ff9a0a, 0xb5f00fd8, 
	0x2f911dfc, 0xcf912e67, 0x1e09575f, 0x9f829757, 0x76972c9d, 0x28607cd9, 
	0xdf0e6f5a, 0x6f887b8c, 0xd05fa13c, 0xa78ce9fc, 0x77a4b437, 0x89ca28db, 
	0x5f6d8aef, 0xf3d5f277, 0x4367a690, 0xf6cf9f7f, 0x0a95f367, 0xd1fb13a2, 
	0x1c4d0cfa, 0x847905a1, 0xc7c6dbe6, 0x43cf23a6, 0x7c6daf86, 0x4f84bcfa, 
	0x01e268fa, 0x16c1d75c, 0xb3864943, 0xd14511fc, 0x6d09fc8c, 0x60b1f052, 
	0xd22fcc35, 0xbbdc375f, 0x7de56657, 0x77d726a9, 0xfdf8f67a, 0xd60beeb8, 
	0xe01f54c7, 0xe4a66d31, 0xd69ebb13, 0xbd2bf927, 0x26fefc6b, 0x5aee5790, 
	0xbe167768, 0x3d686cd3, 0xdf171fb0, 0x1ca2f4a0, 0xd7b22e8e, 0xb43920bd, 
	0xefd1fa18, 0xec157ea2, 0xf7c1da97, 0x82af0022, 0x3225ddfe, 0x347eb05f, 
	0xeb2fdbe9, 0x23f09cfb, 0x80af0c15, 0x660ee5f5, 0xeb734be0, 0x8b59422f, 
	0x5ca40be5, 0xfb39ef82, 0x3697c2cb, 0x03784854, 0xfbb16fd6, 0x55f11d8b, 
	0xc68fee4c, 0x7bfc3af7, 0xb726abdc, 0xe34dc767, 0x0bc79315, 0xfced94f5, 
	0x3b2c7d5d, 0xc6f2cbde, 0x4f9fc62b, 0x3c98af6e, 0xd91f805e, 0xbc79315f, 
	0x7dba5f00, 0x71ecfc0a, 0xfd9d77c1, 0x9f4be165, 0xbc793fda, 0x3db23f00, 
	0xf2fa3e87, 0x8fd94551, 0xacdae9e3, 0x1ff0e48d, 0x4d3e6fef, 0xb3321c2c, 
	0x7fe6cbf2, 0xe6963511, 0xf9e8f1ca, 0xe1f21a15, 0x4a35f6a5, 0x75f0e7cf, 
	0xfcffae5c, 0xd77a4b75, 0x2aff71c7, 0x6e48263f, 0xf87eae9a, 0x4c41679e, 
	0x73cafdc1, 0x82128765, 0x92351a6f, 0x391e9ece, 0x309d4f2e, 0xf6f9b530, 
	0x145f1816, 0x4851f7c6, 0xce593b9b, 0xfad13b40, 0xedd39263, 0x3c90162f, 
	0x11fa19bb, 0x918907a0, 0x36e72469, 0x2e08d3cc, 0x04ca5642, 0x66b988ba, 
	0xb83e44ca, 0xedbed168, 0xb03cfc67, 0x809327df, 0x73e82b7f, 0x9327ca31, 
	0x20d06788, 0xa3ae1778, 0x9638c03f, 0x1da22a8c, 0x726962e1, 0x568dc829, 
	0x0fa0aaa1, 0xaa8612fa, 0xb7c78c7f, 0x1aa3e49d, 0xafbb2b7a, 0xf51d7b60, 
	0x841bd0cc, 0x507f61ef, 0x9b39d5e2, 0x279695f6, 0xf9e2ceaf, 0x62bece6a, 
	0x5b5723ef, 0x7a48444a, 0x135cfca1, 0x64df1e83, 0x6f0f517c, 0x5f41fc01, 
	0x228cc5f1, 0x6ad7f013, 0x377cb8e5, 0x74e14d2c, 0x6d7596f9, 0x70703d46, 
	0xf44f53a6, 0x39eb92ad, 0x256a1f23, 0x3e42edbf, 0x13eacb1f, 0x54cdf5fa, 
	0x2cf9906f, 0x50915f03, 0x320f5d70, 0x84fadb9f, 0x51dc5d7e, 0x39f21f7f, 
	0xe7205bb6, 0xaf26b7d7, 0x3abe1b3f, 0x7f7034ae, 0x8b5ae7c8, 0x6377cfec, 
	0x5f5f51c2, 0x773e231e, 0x50a460bf, 0x636bb95e, 0x1bed85c2, 0x1def36bb, 
	0x1f027a02, 0xe3b2c6f8, 0x2c09edb2, 0x235e7e27, 0xc72d83d7, 0xf7d0417d, 
	0x8cd7df90, 0xb410ffde, 0xa77c26ff, 0x8fbda738, 0x478407ed, 0x62ebfbe0, 
	0x636a6687, 0x55b77239, 0x8fc113da, 0xc215bf45, 0x9428bb79, 0x288547dd, 
	0x7779e1aa, 0x7dda58af, 0x7d4ff03b, 0xf08dc14c, 0x6841d82c, 0x0910cc4f, 
	0xe61be705, 0xc197d54d, 0xa2e39b78, 0xface5cf7, 0xc74df9e2, 0x85d68f58, 
	0x8e00efdc, 0xb6df9376, 0xd90ec06b, 0xebe2cb1b, 0x7d14356d, 0xd6cf1c8f, 
	0x3b472c98, 0x7c57deca, 0xf64d4341, 0xfdd8f963, 0x6fb8e35b, 0x3bdfdc8c, 
	0xa60f4394, 0xa9cd7a67, 0xe78f1ffb, 0xc28957ec, 0x8e194f70, 0x44a5f9e7, 
	0xfa83c62f, 0xa6647487, 0x8ed097b4, 0xf1640e4a, 0x370a7b41, 0x051d8cb3, 
	0x167089f8, 0x411aed3f, 0xb3fe6df5, 0x8b3c25f1, 0x62fa78b3, 0x0766459d, 
	0xa7cd35f3, 0x9f3e5f53, 0x96dedfc7, 0x0dfbf9a9, 0x1f36e396, 0x7e49e7bb, 
	0xdfc79f3c, 0xbf92f9ee, 0xb7f1e7cf, 0x51dc6e7b, 0xc72c8fff, 0x5ef63e6d, 
	0x0d9fd793, 0xefe49f7f, 0xedfc79f3, 0xd470925d, 0xfe493777, 0xf9207ed6, 
	0x198bab5b, 0xfcb247ae, 0xf591a81d, 0x32fec5d6, 0x327e7dd3, 0x65f3e77f, 
	0xe107af11, 0x21bcd2f6, 0x901f6e7f, 0xae7688fc, 0x2e76c356, 0x23f225f3, 
	0xcfc8b9da, 0x9f13afa8, 0x3791cc9e, 0x7cf9a7cc, 0x80dd7f89, 0xf606af97, 
	0xa5f59c9f, 0x87e242e9, 0x79d943f0, 0xcd9bf0cf, 0xe3e031c7, 0xdb3f2ca1, 
	0xd7ae02fb, 0xa9fcb9ad, 0xfb7fb429, 0xf924ac9a, 0xf6bc7811, 0x75e0af3c, 
	0x3fea2987, 0x8f81b7be, 0xb1bfaed0, 0x4c3e455d, 0xde9060df, 0xb3338f6d, 
	0xfc615bce, 0xf16ed007, 0xab423f92, 0xf6854b69, 0x7e907ecb, 0xf76b05da, 
	0xf19fd263, 0xed4be461, 0x1f533082, 0x3ed0f597, 0xf246a1bb, 0x095eef95, 
	0xe10e7dc7, 0x479d959e, 0xdf729916, 0xbe79841a, 0x8ced86aa, 0x942e4be8, 
	0xeb879dff, 0xeccddf69, 0x69d3835f, 0x5f154aff, 0xde0ded2d, 0xb43d68bf, 
	0x0a4238e3, 0x23e91cd2, 0xda75cbce, 0xc6bb271b, 0xdff672d4, 0x5b079af7, 
	0x0679a00f, 0xf38dd27d, 0x2c6981da, 0x871bf345, 0xf265bdf9, 0x4ee3bafc, 
	0xa46bc53a, 0x7ff5b45c, 0xb44af71a, 0xdfee4677, 0x8917df06, 0x3738d2df, 
	0xe3946e1d, 0xe3465539, 0x985c6d8b, 0xbcabdf1d, 0xfca49dbf, 0x3ece64d1, 
	0xa64ccf78, 0x955d9e4b, 0x4f1c93f5, 0xcce49fa2, 0x77b5b152, 0x4d9bc017, 
	0x4cabd237, 0xffb6dd37, 0x5c2fc705, 0x8efe82aa, 0xff48d48f, 0xfa56b78b, 
	0x8b7ebc5f, 0x66ab0ffc, 0xe506ac7e, 0x1ebf7e7a, 0xb73f74c3, 0x7337eb8b, 
	0x1db8ebbf, 0xfd08df54, 0xf8e7ce05, 0x5fa4ea5f, 0xd7f552e5, 0x90febd23, 
	0x8ff257ad, 0x1c8aff40, 0xe9ce993c, 0x4dbb1caf, 0x1ab337ca, 0x7f976bff, 
	0x301e6c2e, 0x60378f81, 0xd86f780a, 0xc8db97f0, 0x3178724f, 0x7306d44d, 
	0x0c9bf4b1, 0x36bea62e, 0x3ef9c93c, 0xc5b7ff2e, 0x25d26fd2, 0xcdd39ff3, 
	0xfd07ea2a, 0x3798a526, 0x13b70da6, 0x841b4c7f, 0x4cb3b9f9, 0xbf3eb498, 
	0x9bf217f2, 0x3768bfa0, 0x485d09d0, 0xf9df4f68, 0xeb8a88a9, 0xc7dbe104, 
	0x60f2cfd0, 0x32b1fa0d, 0x7fe3257e, 0xb4092da9, 0xa9ba6583, 0xed06a066, 
	0x0c1df4e4, 0xac539bbf, 0x86f5cc37, 0xae26fdb9, 0x30f5cc37, 0x476c2f8d, 
	0x8799d23f, 0x3d70f967, 0x2d5afbdb, 0x4c356588, 0xfea15778, 0x9f529965, 
	0x40f6fd05, 0x9ecbee3f, 0x9f145fe6, 0x1efdfacc, 0x3b9bd7b2, 0xe502b8fe, 
	0x80df989b, 0xbf89aabf, 0x8e459f80, 0x9eb4407f, 0xf9adfd24, 0x3f9906f2, 
	0x6fe90d74, 0xbf897df7, 0xae60f683, 0x6beb06fe, 0xed7d44dc, 0xbf5c9a99, 
	0xc4efcd80, 0x7f272bc7, 0x0a219b47, 0xcfdca33c, 0xefddf833, 0xbe7b77d1, 
	0x69df97e6, 0xfeefa16b, 0xea84abae, 0x0a42d19f, 0x4b50a9b0, 0x5a12943a, 
	0xa4cba6a8, 0x551f0ef1, 0x2df7e256, 0xc392fdf9, 0xd72c6aa9, 0x87493ca5, 
	0xee8825be, 0x3ac29035, 0xfce02f48, 0xcd3d32f5, 0x45f4f572, 0xd3f1f485, 
	0xbf97a96e, 0x67f5f2ce, 0x7f1f5235, 0xe456d213, 0xed851ad7, 0xff474b64, 
	0xb27769cb, 0xa768fd15, 0xa4be1a2f, 0x3ac07a8a, 0xde51af9a, 0x49a2eabf, 
	0xc067f51d, 0x7ea24f57, 0xeefa9bae, 0x5475d9fd, 0x66f33253, 0x1cf182a5, 
	0x739b3c66, 0xc30162f8, 0xfe6997af, 0x8531d2f7, 0x1f1200fd, 0xbc23fbfb, 
	0xa9dfd9df, 0xe11e018b, 0x84fc78c9, 0x7c24ebe5, 0x7aa616ca, 0xcccfce60, 
	0x462eb3f8, 0x4e6fde69, 0x67e2cc9e, 0x242b35e3, 0xcbf1b5fb, 0x01e3cde0, 
	0x7e337ab9, 0x0efc05e7, 0x9d6b93fa, 0x12ed5bf4, 0x9023ee16, 0xbb4a6e9f, 
	0x63b209e2, 0xfe89eb74, 0x59ddf4fd, 0x895607c8, 0x6ccd9be4, 0x45683ccf, 
	0xa6650784, 0xa813dcfb, 0x6a783e8f, 0x7b4f31d6, 0xa19b1c76, 0x736fd768, 
	0xda8d1df2, 0x3f0873d6, 0x93e539f7, 0xe96f5fe8, 0x29cfbf24, 0xdba01f29, 
	0x0f5ca659, 0xb47fc9d3, 0x66fbf245, 0xf62f4ef8, 0x329351df, 0x2c4e1e71, 
	0xa446ed96, 0xfbc7b1dc, 0x6da555a0, 0x414f7ec3, 0xed8bda39, 0xf29e542d, 
	0xec07fdc8, 0x8ad9a4b2, 0x50a476f8, 0xa22770df, 0xec8eb3c2, 0x7dc0a4c6, 
	0xd475dfc1, 0x923f68b4, 0x8c135bed, 0xe24532d7, 0x78b92a65, 0xe23da079, 
	0x24c44ee5, 0x12136b5e, 0xced936af, 0xf8972a1d, 0xb67f7334, 0xb9eb6afd, 
	0x73d20ab1, 0x94d09ab5, 0x78ec1972, 0x217daf5a, 0xea2d3df9, 0x8816f5a3, 
	0x214e7c4e, 0x3bb897bf, 0x9a0e0ed7, 0x3bb6c46b, 0xbb89ae91, 0xa56b7be9, 
	0xdeeb8e5d, 0x53a59fdc, 0xf52623a0, 0x2f50b5aa, 0xd2017da7, 0xf5b9f50a, 
	0xa3f502ed, 0xaa2633d3, 0xcb26eb42, 0x887b9433, 0xa472c997, 0x54dcb1a0, 
	0x0d72ce3f, 0x6fc0a1f8, 0xb28ff774, 0x357923bc, 0x66e90d31, 0x7d53091c, 
	0x959e3fea, 0x17d5ea8b, 0xafd035aa, 0x0071b0c4, 0x9122b7c7, 0xbc95369a, 
	0x17297112, 0xfbc1d8df, 0xf7f725bb, 0x2c2b0cef, 0xb23ca517, 0xd89ae2e5, 
	0x7fc4b3cd, 0x38c3c8e5, 0x9775a3c8, 0xfc938796, 0xa4235dad, 0x480c944f, 
	0x5d0c49bd, 0xf2b0f249, 0x5f54dc1f, 0x9049010d, 0x394ba68f, 0x6d0f2f9a, 
	0x7626b839, 0x8b922cc7, 0xc2fbf2cd, 0xb950a9d3, 0xea2963bb, 0x5fa7a7df, 
	0x7fe71bbd, 0xefeaddf9, 0x21189fd9, 0xac3f31aa, 0xccf5bd61, 0x438bcbfc, 
	0x6ffdd983, 0x2c5a8779, 0xa5519ae5, 0x3143eee7, 0xcf1f40e3, 0xade78f9b, 
	0xf5ade71f, 0xff10d327, 0xd00060bd, 0xa3f7f378, 0x3cd28edb, 0x37c3ffbc, 
	0x485e6b55, 0x1d565daf, 0xd2eb7c85, 0xc8516981, 0x353fbeb7, 0xf383c5ad, 
	0x678d3f76, 0xacffcae5, 0x1bcafcc2, 0xe51cfc2f, 0x570fbd95, 0xe3e55fa2, 
	0x49143f24, 0x7ae89357, 0x979ffa7a, 0x85dbb8d2, 0xf455fdba, 0xa3344e87, 
	0x2ce0fedf, 0x2353f7e9, 0x03a44983, 0x0ef187b5, 0x81fe92cc, 0x079952ca, 
	0x3f45425d, 0xb947d614, 0x0a8f819e, 0xd1c33f75, 0x602caa7e, 0xfeb3ab78, 
	0x7ed14801, 0xee52bcaa, 0x5516b02f, 0xfa6583f4, 0x5086e1b3, 0x6876e29f, 
	0x8fbe553f, 0x475433fb, 0x26a7f07f, 0xfa4d5f11, 0xac463cf9, 0x8050f497, 
	0x9e9c1f23, 0xf114ddf1, 0x41df0e99, 0xca146cbd, 0xaffa3e41, 0x5e918c49, 
	0x41e52cd4, 0x3fb65055, 0x499bfd3d, 0x17afe3d2, 0x6f4937bf, 0x505394b6, 
	0x8a8b19ee, 0xe82f485d, 0x9095d77b, 0x76a58b9e, 0xa43c23b5, 0xb5197c3d, 
	0xbedd214b, 0x27ae4b35, 0x8be1cb7f, 0xff7187a4, 0x2b0ee7d1, 0x9f447fb8, 
	0x3d70531b, 0x8296837a, 0xc7b7bdfa, 0xf61ae14c, 0x1cd4a2eb, 0xfaa23e21, 
	0x6345e9fe, 0x7e9f5849, 0x1fa8f130, 0x812910dd, 0x8a90ee76, 0xb37f217e, 
	0xad7d473c, 0x0329bbfc, 0xc5c62df3, 0x7cb16f65, 0xceafbf84, 0x9634fb92, 
	0x597a9f93, 0x17f445d7, 0xf793f6d9, 0x0e7fe014, 0x61ed66d3, 0x0bfc03b0, 
	0x388a2eba, 0xfd8fd5e3, 0x33b47d41, 0x3b5049ae, 0x59781d7b, 0xb3f3c02f, 
	0x8acf40dd, 0x3e298e1f, 0xfc49afa2, 0xb88bf554, 0xcf1ff98a, 0xfa6efb92, 
	0x736ea787, 0x89233f61, 0x83da14f6, 0x21dfc61b, 0x41eb47ba, 0x0f7c8281, 
	0xffee01e4, 0xf28290e0, 0x2d605bd4, 0xfb395a4d, 0x887de227, 0xcc7690f1, 
	0x6f473332, 0xd77fb3f0, 0x8e8823d3, 0x631347fa, 0x768a2fa8, 0xf6f9c153, 
	0xe696b15c, 0x031bd6df, 0xd6a4df60, 0x70a6bcd3, 0xf91b7fff, 0xae31e51e, 
	0xa043a003, 0xa203e3b9, 0x7185fb83, 0xdff981fe, 0xdb7bfb6f, 0xd90adfa0, 
	0x032ff90e, 0xfd95351f, 0xf7fe470c, 0x56e07edb, 0x30bffd67, 0x7f6dfbff, 
	0xff9269af, 0x0d9fd339, 0x29e54c37, 0xeffc876e, 0x46c0fdb7, 0xce1fd1ca, 
	0x90238e37, 0x6bed7c90, 0xd259b486, 0xf786f881, 0x746f904f, 0x055fa31e, 
	0xfd2ca1f0, 0x30ddce90, 0x99a14f7e, 0x72a779c4, 0x1faaaf98, 0xde611d02, 
	0x7dbed0ab, 0x8abf4b24, 0x8dea1c1f, 0x2f953f42, 0xf22ac6c5, 0x89b039fa, 
	0x2a0f81cb, 0xffb3c283, 0x35cfa408, 0x69c4558f, 0xff707a3d, 0xde24be8e, 
	0xf9650e4c, 0xe915f2a9, 0xad55027f, 0xff872fac, 0xefd43aa3, 0x9e47b847, 
	0x2e24bde3, 0xd176876e, 0x3f228c17, 0xad714fcc, 0x32a3bcf3, 0x7fc87a68, 
	0x22f452f4, 0xd9f459f2, 0x6f1c5ea1, 0x8b8d8fe5, 0xa5e314e6, 0xf0d3c272, 
	0xf2b77fa0, 0xfdf88305, 0xa248a174, 0xd034eeff, 0x9e0dfd03, 0x1f7bf19a, 
	0x64b4c98c, 0xe35f69c8, 0x9f698afe, 0x9e4dfb29, 0xb887fae7, 0xb459c53e, 
	0x51521c92, 0xebbda2fe, 0xce84743e, 0x81bd6cc5, 0x45e903e5, 0xfa7fd651, 
	0xf522ffc9, 0xe922f187, 0x3f501407, 0xd6cbdcf7, 0xd297465f, 0xf17792b9, 
	0xa7a576d4, 0xee2d5976, 0x1b2e67bf, 0x8e50c64f, 0x8bd23e5d, 0xc4abf4f5, 
	0xe65d2e58, 0x885d3d03, 0xe8dbb3ff, 0x01ca8a5c, 0xfd2ab0ff, 0xc8bfa41b, 
	0x98f97dfd, 0x07bdeb49, 0x5760aced, 0xf739e04c, 0x39eac519, 0xeb30f00c, 
	0xb1fd85a5, 0x875c1e63, 0xd22973ee, 0xf5bd605f, 0x5ec3f8c1, 0xcf7f1161, 
	0x093f48b5, 0xd6ea9f75, 0x98f9e24f, 0xcfa0bd10, 0x690dae17, 0x0a0ec0db, 
	0x850ec07b, 0xe3fc8a7e, 0xf482fddd, 0xc93e7929, 0x5d45ffe7, 0x8aebd221, 
	0xa1972042, 0x243322ff, 0xbf867d1e, 0xc5d2fc8f, 0x17fa33f5, 0x399dd7ec, 
	0x4b5e8b74, 0x981c8b74, 0x1e3e6e9a, 0xc6a0cc07, 0xfb86897a, 0xe390c867, 
	0x79d4bf85, 0x22e5c693, 0x17f6027d, 0x022ba73c, 0x06fbd6d9, 0x2a3f7964, 
	0xc43a6c36, 0xe8820e99, 0xfdcb73e0, 0xe9448d4c, 0x80d8b7bc, 0x5faa40f1, 
	0x39e14d1b, 0xf3e4da49, 0x1fc93e96, 0x302c3cb6, 0xf517a242, 0xef2e0ed9, 
	0xe767e592, 0xa4b4d12f, 0xcf3c279c, 0xa6df1b38, 0xc0257fa1, 0x84de00f1, 
	0x77c0e9a5, 0xff4ad68f, 0x59df0d96, 0xc05be52b, 0xf3c677f6, 0xd47fb1ea, 
	0xef84ecd3, 0xe7e415ad, 0x3fb1340f, 0x1daf35bf, 0xd2c375c3, 0xde1215e2, 
	0x3fd9f580, 0xacec365a, 0xcd2cc5af, 0xc7e4079e, 0x0fe420c8, 0xa77eca40, 
	0xb752d040, 0xb07e0e83, 0x03ebfa56, 0x53be222d, 0x85bd23c6, 0x26813cf1, 
	0x2f40ebd0, 0xd2363c0b, 0x22618023, 0xd44c7af7, 0xea01ffa3, 0x55df015f, 
	0xd87a27c6, 0x00bee9ae, 0xd85c8af4, 0x17677cb2, 0x6da0bcf0, 0xde5dfb28, 
	0x667cec3f, 0x54b168df, 0x02e44efc, 0x87c831f0, 0xddd1a348, 0xcce1f207, 
	0xfa2a236d, 0x3cb18f55, 0x3f79e02a, 0x5af416bb, 0x8417e30d, 0xf4f58747, 
	0xaf295aab, 0x81ce980b, 0x01db96c3, 0x46073a67, 0x9e7d674c, 0xc309c0a7, 
	0x76ff6709, 0xece190e0, 0x181ee987, 0xa6380e12, 0x3016df68, 0x26c303fd, 
	0x92ad1795, 0x1b5514fd, 0x935e67ae, 0xc3ec33fc, 0xf42e1aef, 0x8c7a050b, 
	0x922033c4, 0xe795ac5f, 0xe10f6872, 0x80e81bfe, 0x38f20df1, 0xc3f8e6f7, 
	0xbda3cb54, 0x7a827485, 0x5ad55fd0, 0xe78783cb, 0x85c30e81, 0xdd30abf5, 
	0x8bd6f503, 0x383bd610, 0xe2b527e7, 0xa0fdf0b3, 0xbcd24ae5, 0xf4b79a09, 
	0x6fa99d13, 0xa7e213cc, 0xfd3f72b5, 0x37dcad79, 0x43902923, 0xd6fca1bb, 
	0x57cf54ae, 0xeb85f39c, 0x54320037, 0x9070cf5b, 0xd5bf115f, 0x9234f283, 
	0x4e3298f2, 0x7eed70c8, 0x4acfe715, 0xf9a0aff5, 0xf987e9ec, 0xd4647c0c, 
	0xaee38c53, 0x338efe93, 0xfe91185f, 0x0f815be3, 0x5aa95f61, 0x7f29f72f, 
	0xdafbf49d, 0xc27152f3, 0x458f9152, 0xfebe739d, 0x9ecaebc4, 0x79c3f2ef, 
	0x2bbe78f5, 0x09f09c47, 0x8f3da71e, 0xed794325, 0xc87a5e18, 0x215d7152, 
	0x8283f51c, 0xd472baec, 0xc5165a8f, 0x07f8d93d, 0x9c3ca106, 0xce00af9d, 
	0x00b3ac1f, 0x2682b3af, 0xdc611bb0, 0xf48eb705, 0xbc724284, 0xdc8f97e8, 
	0x07b5fd7b, 0xd8db7ae4, 0x1971c617, 0x7c055f34, 0x56ae71ae, 0x75ed85fa, 
	0x342e7186, 0x3496179f, 0x6759c9ec, 0x8698aee1, 0xdb26ca7a, 0x6c76c5df, 
	0x7b026ec6, 0x70c0f509, 0x34e28c67, 0x355d5744, 0x7e0f97da, 0xf1e3fd87, 
	0x1ec764e3, 0xe652b8ac, 0x078f124b, 0x343da1b7, 0xb9f70ea3, 0xd55dc3d0, 
	0xbf852768, 0xbd7d5560, 0x9d0f6b37, 0x21eecc51, 0x84e4e505, 0x1b724cda, 
	0xb93923f0, 0x61fa85c2, 0xc24e4661, 0x2dfa027a, 0xc97293ae, 0xbcf33786, 
	0x64e46617, 0x9c8cbd5e, 0xd617c274, 0x98593949, 0xed799391, 0x70d27232, 
	0x1c227ce3, 0xcf2164e5, 0x6761f967, 0xb8662d7d, 0x2964e573, 0xbf9c7fac, 
	0xa43f9e52, 0xa5c9ca3b, 0xfb18bf50, 0xc03e3169, 0x9e267272, 0x99361503, 
	0x0b2728dd, 0x8adb6e9f, 0xe594b272, 0xff50f5e4, 0xbf9c318a, 0xe5735b2d, 
	0x2d85e964, 0xbe7db01b, 0xa1fd2c9c, 0x2bfe9318, 0x64c4d050, 0x02d15979, 
	0x49f0157a, 0x02abd305, 0xf20f63f8, 0x17b305ed, 0xa3695bd7, 0xf28fdbd1, 
	0x0f7ee5f3, 0xe69fd3da, 0xcb615775, 0x2883904f, 0x0cfb2b3f, 0x1b75f90d, 
	0x5fddb3f3, 0x0cafcb25, 0xa64f5edc, 0xf9e7d670, 0x9d37ecab, 0x959f9670, 
	0xe038cfb0, 0x2c951f3c, 0xa6386d3f, 0x782b3f28, 0x7e592a5e, 0xe5a7e567, 
	0xe276e679, 0xcfca0f67, 0xfca3c82a, 0x9488f8ac, 0x6ceb9b9f, 0x83c2b9f9, 
	0x94e2b3f2, 0x5273a1e1, 0xf94eeb90, 0x9e287a69, 0x03d402f3, 0xc27959f9, 
	0x7159f924, 0xd028e40a, 0xf45312a9, 0xcf22bc4c, 0xd6e5a213, 0x4957d431, 
	0x2d58a27e, 0xb22ea07a, 0x732d8851, 0xec0d3acc, 0xdba7d2f9, 0xd4f60f48, 
	0xce50eaa6, 0xf52d3e96, 0x0fe6a9bf, 0xf00567e5, 0x72c6968e, 0x78ed3f29, 
	0xfc8cd2d5, 0xf7683cb4, 0x40adfcd1, 0x38ad8d3c, 0x0c2f159f, 0x4f418a79, 
	0x3f2dbafa, 0x9b9b67ff, 0xc0d3e7e4, 0x3d59c59f, 0x8ebcabff, 0xdd25aaaa, 
	0xafb0fdc2, 0x98877e01, 0x13f86dbf, 0x567e5275, 0x96b96d05, 0xaeed8f57, 
	0xff84e990, 0x9f949d73, 0x9fb24d55, 0x76bca192, 0x1a0c8f0c, 0x876f5c1e, 
	0x2d55bd78, 0xb3b4e5b0, 0xcc1f717e, 0xff16454f, 0x1f72438a, 0x02abe7b6, 
	0x5fd60fe7, 0xaabfaf05, 0xe517ab26, 0xdaf7d567, 0xe5fa86b6, 0x967e5178, 
	0x9dfd7bde, 0x799f3f2c, 0xb2e38c28, 0xab1f283c, 0x87ebaed8, 0xf59c917a, 
	0x584fcb67, 0xc9ed377f, 0x28057f59, 0x5bdf473f, 0x4a74167e, 0x60c4507b, 
	0x73f28247, 0x9bfa4c7a, 0xff219c4e, 0x6acbdb53, 0x9e7cfc9e, 0x13e067e4, 
	0xec167e52, 0x88b3f293, 0xcfc2e9f5, 0xd3a5bf46, 0xf5708739, 0xe8a9fc63, 
	0x8b39d174, 0xf18dde3b, 0x7443693d, 0xba3e83f6, 0x3c09e3fc, 0xa57b4442, 
	0x5e373fb3, 0x31db68f1, 0x87ca373c, 0x98df5fe3, 0x90f68f6c, 0xe88499f5, 
	0x74f47332, 0x67f90d6b, 0xe953fbf1, 0x261a67e9, 0x74bcd1ba, 0x5c8af5c8, 
	0x1eeb0e79, 0xebc5fff2, 0xc1bf86d8, 0xe79595fc, 0xf232f579, 0xe3ff09dc, 
	0xd79e7924, 0x4dcf232e, 0xc25fbe2d, 0xe5b67f71, 0xb3874179, 0x353316be, 
	0x08cfe391, 0x55129c83, 0x3d3f2290, 0x7fe79592, 0x6f7a93a9, 0x65b58b61, 
	0x7e973ca7, 0x3cae5773, 0xbd27e81f, 0xaf2f7c37, 0xdeb6d9d3, 0x3a1eddfb, 
	0x053b0047, 0x0be104fd, 0xa54d8f13, 0x06ef86f7, 0x9efd2079, 0x1cf254da, 
	0x62714bbe, 0xf857a611, 0x0fddd982, 0x68dc29f2, 0xbf1c90f4, 0x7285dfa7, 
	0xe4b676bc, 0x9fb662f7, 0x2e9a76ce, 0x3185e394, 0x59bae0a1, 0x15d79b3c, 
	0xb8c2ebaf, 0xbaf384e1, 0x9d366c2e, 0x850b9670, 0x6709cb09, 0x21a14d3f, 
	0xd79c0754, 0xe1ab6179, 0xfe8a6380, 0xef5e62b9, 0xe68fa085, 0xd66ec1e9, 
	0xe3943583, 0x394790a5, 0xc820f91e, 0x05884b71, 0x463a3ed0, 0x7486b07a, 
	0xfd021c8d, 0xb460f510, 0x5c721c57, 0x0dbf51b8, 0x207a805f, 0x85064b1f, 
	0x0478e51b, 0x5fa86bf7, 0xc1ea2982, 0xf07a965f, 0xb3127393, 0xc72c4db5, 
	0x01e17be1, 0xfbe063b0, 0xb3c8d4a1, 0xcb18f7c8, 0x7c39728d, 0xd92dfb37, 
	0x4dfb0c2e, 0x29c36fd2, 0x1b878fb9, 0xd1f65e61, 0x5b5e90fc, 0x435da9b8, 
	0xb3d3f6bd, 0xe7b65ca5, 0x7ebecce5, 0xf4d42e17, 0xb43f305d, 0x092d4dae, 
	0x5ea03af5, 0x330bd405, 0xf1bb6dbd, 0xbf25b323, 0x669bf0da, 0xe613f5cb, 
	0xc6edb479, 0x479e3d4c, 0xe1b46edb, 0xca5b377f, 0x8fcf30e7, 0xda66376d, 
	0x1bb6dc31, 0x27eb8e11, 0x7683c76c, 0x76dbeb38, 0x905ef163, 0x3bd728cf, 
	0x297e7ee5, 0x04dc323b, 0x1cf90174, 0xf49fac7e, 0x4ba60edb, 0x1ee7def8, 
	0x59f7c03b, 0x4eb01a90, 0x30bb944c, 0xdeee1f65, 0xfa04e383, 0x0c5b9d20, 
	0x7c38fdb1, 0x62747faf, 0x7ff245fa, 0x3eabbef4, 0x5fd2142b, 0x92ab6e8f, 
	0xc934d6f9, 0x9575d9df, 0x3d8eef32, 0xa3f5861e, 0xfe4e32de, 0xba6a87fe, 
	0x3f5fa366, 0xe4c389f0, 0x8c8717e7, 0x4567c803, 0x7f96a79b, 0xbeb901f8, 
	0x18f9cc8d, 0x170c6feb, 0x5cab972a, 0x70c5a9ce, 0xc37992e1, 0xcba6f325, 
	0x2e121796, 0x71af6e34, 0x862d4e7b, 0x77b7370b, 0x2d4e7b73, 0x1fbf4b86, 
	0xce5c45ea, 0xe170c5a9, 0xdcbdfee5, 0xc316a73f, 0x3ae5ce85, 0x316a7397, 
	0x7fb8f85c, 0xa9cff71f, 0xe7e170c5, 0x73973f72, 0x045c316a, 0xf700ffb8, 
	0x70c5a9cf, 0x41f6e411, 0xc5a9cf6e, 0xedc05170, 0xa73db80b, 0x2145c316, 
	0x39721797, 0x45c316a7, 0xc45ff711, 0x316a73fd, 0xd91c541c, 0x39edc43e, 
	0x8a2e18b5, 0xb7317db9, 0xb862d4e7, 0x98797308, 0x18b539cb, 0x7fdc222e, 
	0xd4e7fb84, 0xe128b862, 0x9edc25f6, 0xa2e18b53, 0x7297db94, 0x862d4e7b, 
	0x2f2e328b, 0x2d4e72e3, 0xee728b86, 0xe7fb9cbf, 0x88b862d4, 0xcb947972, 
	0x2e18b539, 0x0affb82a, 0x8b539fee, 0xc81260e1, 0xe72e4af2, 0xa8b862d4, 
	0xb8abfee2, 0x862d4e7f, 0x5f6e6a8b, 0xb539edcd, 0x71a62e18, 0x9edc69fb, 
	0x62e18b53, 0xe74f973a, 0x862d4e72, 0xffdc198b, 0x539fee0c, 0xc622e18b, 
	0xe72e31e5, 0x98b862d4, 0xe4cffdc9, 0x18b539fe, 0xbcb86a2e, 0xb539cb86, 
	0x71662e18, 0x6fee7cff, 0x0cffe7da, 0xbedcb517, 0x6a73db96, 0x71d45c31, 
	0xcf6e3afb, 0x3170c5a9, 0x7367cb9b, 0xc316a739, 0x5ff73d45, 0x6a73fdcf, 
	0xb9c45c31, 0x9ce5ce3c, 0x0d170c5a, 0xf7037fdc, 0x70c5a9cf, 0x8de5c8d1, 
	0xc5a9ce5c, 0xfb873170, 0x73fdc39f, 0xed3c116a, 0xc50f4931, 0x14991ebf, 
	0x72851ea3, 0xc8def738, 0x8babcd4a, 0x3c729873, 0xa94586e6, 0x6e31b3bd, 
	0x28709ee4, 0xb7b73d9a, 0x765609cf, 0xb9d30b2c, 0x778a2eb1, 0x7dc63af3, 
	0x9f10d9e2, 0xf635cf83, 0xe58ffde0, 0x1f1495fd, 0x031ddc21, 0xf6af4fb8, 
	0x69a7fd77, 0x22cbbc60, 0x44588f8e, 0x0394358d, 0xb1fdd2af, 0x075714dd, 
	0x21f69deb, 0xde58938e, 0xfbc2935f, 0xbfa12b42, 0xbfd0cbde, 0x173bedcc, 
	0x3583f9f1, 0x0bebdf40, 0xdd3a1f93, 0x51c648ba, 0xe33916c4, 0x256eda25, 
	0xfea1bc7d, 0x9718f5fd, 0xf8635d7e, 0xde52fb12, 0x2fe0feb9, 0xe6bf1ce9, 
	0x39f25777, 0xc09c7e7f, 0x9c477ada, 0xd4dc5e40, 0xad6eb395, 0x1b55fb47, 
	0xe932e15f, 0x309addbc, 0x7cfbb22b, 0x13a53cfe, 0xe7d8efe3, 0x3ee7b996, 
	0xb8a2d35e, 0x443f2a48, 0x58ed0ae7, 0xffc3ccef, 0x97c6e6a8, 0xd54ddbf9, 
	0x6bffd73e, 0x7344cbe2, 0xc3f3ed13, 0xeb2652ff, 0x7da0989d, 0x572bf87e, 
	0x2bdf78d1, 0x7c6cecfe, 0x18e31b9b, 0xd22acd34, 0x6ace9e60, 0x4abdf1d6, 
	0x265f3ef6, 0x7f7bfd65, 0xb65bd4bd, 0xa11a0a43, 0xea5eb878, 0x9857e5dd, 
	0x16bbea7f, 0x4cd50353, 0x98cb3e51, 0xe5397bb1, 0x4ede1e3b, 0x480e6fe9, 
	0x43e561fb, 0x1f7fc811, 0x7b9ccf6c, 0xcda7e5bd, 0x0f48066b, 0xacce2832, 
	0x77218afc, 0xdb4c71df, 0x366afdd5, 0x678ed9be, 0x87bbe9b6, 0xbaf1b1f1, 
	0xf3d4521f, 0xc72f54be, 0xc8eb780d, 0xee38657f, 0xa53ef0cb, 0x392cbc75, 
	0xf1dcfc15, 0x6fdb8512, 0x781771a2, 0x7b9e303a, 0xc9d22b74, 0x2b76b555, 
	0x9dbb03ae, 0x47d40d76, 0xa2e687c7, 0xe30d2b73, 0xb2af0185, 0xfc2f4245, 
	0xac5f10b5, 0x53513d67, 0x53be1c25, 0x849bed88, 0xfd4c37de, 0x0c7b471e, 
	0x39e053c6, 0xe4cefd97, 0x471d0fef, 0x612cf978, 0x5bfce8a5, 0x37edb9d0, 
	0xf15da5eb, 0x49dfac0d, 0x21e594f4, 0x76b4e741, 0x8669f979, 0x876ea747, 
	0xd4b20a79, 0xe2e79d05, 0x63b424bd, 0x1398afd3, 0x43d1cf7c, 0x7687f0eb, 
	0xd26dfa5e, 0xc704d6e3, 0xff297a8d, 0x5e179d86, 0x623c1faa, 0xffca75e7, 
	0x6244f8fd, 0x64c7ce98, 0x848edafc, 0xc83bab8c, 0x2780abf9, 0x1a2aff65, 
	0x3056e982, 0x8cbda8ac, 0x6adf4fbb, 0x33554de7, 0x19f63f25, 0x79e3c532, 
	0xdf28c4ad, 0x66e9047e, 0x2f287e88, 0x8f75102d, 0xc27e4b8e, 0x591697ef, 
	0xe5768f75, 0xd9cd4be4, 0x51b97c8e, 0x89d7c8ef, 0x6f5f23b8, 0x5dfd1dc5, 
	0xca383667, 0x8e8d1857, 0xe966adf2, 0xdd2167be, 0xdeefb466, 0x5d7ba901, 
	0xe7e03ee5, 0xa1f26f52, 0x7e210f9d, 0x3f139546, 0xcfc4ed51, 0x979476aa, 
	0xf89cd39b, 0xe51dd319, 0xa38662f5, 0x866b3afc, 0x19857ca3, 0x1437e273, 
	0xf09cb7da, 0x94fc4b0b, 0x696fc488, 0x9fda1770, 0x89d79605, 0xf23ba99f, 
	0x89cf86a5, 0xf23bf09f, 0x49df9675, 0xa4e0333f, 0xe274119f, 0xf51c0a27, 
	0x187a8eb7, 0x09fbbbbf, 0x7d9e23bf, 0x4a7e21d7, 0xe21721e0, 0xf13b1667, 
	0xfa4ec233, 0x3f138889, 0x9fa4e22b, 0x9fa4e259, 0x4fc4ea51, 0xb3f13994, 
	0x59f89cca, 0x59efc601, 0x9f4cdf89, 0xed91dfa4, 0x782360bb, 0x1571d78b, 
	0x7fa1c7c6, 0xf6f56fce, 0xe1053fa3, 0x19470fb0, 0x820bf51e, 0xd578645f, 
	0xea8b729c, 0x10e7ac07, 0x44fdc13e, 0x080d1e19, 0x59712b82, 0x41fb12bf, 
	0xa4dfb27f, 0x05e6307e, 0xf860cfeb, 0x0db5bf0c, 0x57866ee1, 0x3f583f62, 
	0x5e3f5260, 0xc30667ee, 0xe7ac0467, 0xedc15e11, 0x30477c61, 0x6fc2b5de, 
	0x7abae2f4, 0x0769de1f, 0xf19d31f9, 0xa937ee9f, 0x7a1fe07f, 0x962960df, 
	0xfb9b3fa3, 0xf41808ab, 0x23abe01d, 0xdbe42f78, 0xfcdbfedc, 0xae3ce9dd, 
	0xbe9301e9, 0x69f0c05b, 0xbf34ffdc, 0x3117fd41, 0x2bc631fe, 0x087d17e6, 
	0x34f8662f, 0xc05a67ee, 0xdc227ea0, 0x88f18c4f, 0xc209c405, 0xdcd5e183, 
	0x505fb54f, 0x4fdce5ff, 0xf41bbf90, 0x83a26e8b, 0xa9fb9f5d, 0xbfea080e, 
	0xdfcfaeca, 0x31c4060d, 0xf6e4cf84, 0xfa66dd36, 0xdba43e8d, 0x02ee3c1d, 
	0x49c52efe, 0x83add0e6, 0x7f7267cb, 0x89c60333, 0x015ba377, 0x301053e3, 
	0x9967bbe8, 0xfbf88a7f, 0xfa8b7e45, 0x27f99d7f, 0xdbf470cc, 0x76d7fc20, 
	0x515efe7d, 0x7e7ea2c0, 0x7867d763, 0x8b3e6038, 0x3c32dff0, 0xfc87f8c4, 
	0x3df9fa82, 0x386113f7, 0xfc227b9e, 0x1887864d, 0x504050cf, 0x7ee47f3f, 
	0x048f0c22, 0xe717822c, 0x6fd8add1, 0x76dd20f4, 0x70953f32, 0x6c5f8979, 
	0xc3dba5cd, 0xc662974c, 0x3c6038b7, 0x2b746efb, 0x01257ae1, 0xfdeb1c71, 
	0x70f1f188, 0x99bf1eff, 0x8c8bf844, 0x85c797bf, 0xfe102af7, 0xb87b8613, 
	0x3cc04f1f, 0xb997f082, 0xcb8f2f1f, 0xfe08b01b, 0x73afae53, 0xa45fba3f, 
	0xae73fe10, 0xc078601f, 0x17fc116f, 0x1fb9d70c, 0x228e203d, 0x4fdc57fc, 
	0x8081e180, 0x1e5f7045, 0x237e7cdd, 0x2afb7485, 0xe5cfcdd3, 0xca99bf7e, 
	0x9837dba5, 0x871e3e2e, 0x9d1c602f, 0x2e7e6e8a, 0x2a4c07f7, 0xa7efe32f, 
	0x413c395f, 0xbe11c0fe, 0xce43fbff, 0xf4fe3df3, 0xc504f8f8, 0xfe718d81, 
	0x728fce0d, 0x325be0fd, 0x3cca162f, 0xa90907ea, 0x62bdd01f, 0xd0063dfb, 
	0x97ec3413, 0xbea3ffef, 0x9c43e540, 0xfcf38abf, 0x01b785fe, 0x1af74668, 
	0xfb3b64bb, 0x9cadfc3e, 0xd2ecf8e7, 0xdbd48a8b, 0x74ae3cf8, 0x63765142, 
	0xf59c42dc, 0xaad1dab6, 0x977fb0ed, 0xf6f48c45, 0x4d0e981d, 0x5214bfdb, 
	0x0cef4197, 0xb54c0594, 0xb3a4056f, 0x24c1f52c, 0xd4faa6a6, 0x90cfa471, 
	0xf48a50f2, 0x62f8bc96, 0xe221dda7, 0xe9f8be32, 0xf2ca37df, 0x2f8a428e, 
	0x30a1e5fe, 0xff65f1e9, 0xe094ae2b, 0xa313be77, 0xe27db054, 0xa07c9069, 
	0xfca5b3fe, 0xf4b3fc2b, 0x8c2e43cb, 0x87e39e23, 0xe3946f91, 0xd3f7fd47, 
	0x37aff045, 0xd765f9b3, 0xde17f33b, 0x73c2ff07, 0xd3b72fb9, 0x7e1b5f7d, 
	0x5eb38574, 0x3f339b43, 0x51e65c69, 0xfbdecb8a, 0x1f996ac9, 0xed1c6956, 
	0xaef7c3ff, 0x25c455f7, 0x3135adec, 0xbb7cbdf9, 0xdcf3b6ca, 0xdbd5c6b5, 
	0xec94a5af, 0xd0c9770c, 0xee4f3815, 0x81d56312, 0xde0f781d, 0xe3cf7d14, 
	0xe8ab76bd, 0x96945dc1, 0xf78e3a1f, 0x87a28dd9, 0x8306861e, 0x0f74257d, 
	0x5ff12c3d, 0xa0de5f50, 0x925e7ae1, 0xd0f44928, 0x917b21bb, 0xfcf9cb1e, 
	0x56d58c49, 0xef361da3, 0x1a9f7c7b, 0xa55eefe3, 0x3c6299f3, 0x20d19a7f, 
	0xf5b58eed, 0xde9e8833, 0xed8c5584, 0x71415cc5, 0x8913fa41, 0xf4f3b44e, 
	0xf593a33e, 0x9ff23769, 0xfc9d129e, 0xf28b83de, 0x172e0877, 0x844ffc6e, 
	0x1de2f9ed, 0xf490c9fd, 0x9df12793, 0xc1c7088e, 0x9b5cef16, 0x45237092, 
	0x3b5b8c70, 0x4976714b, 0x47ebdff4, 0x7e053abb, 0x4eae85f7, 0x5ff5bbd4, 
	0x30ee7a72, 0x0d5f65a5, 0xa6c2e239, 0xe80d1227, 0x30ddf5ff, 0xe84bef42, 
	0x7e28dacb, 0xc399f437, 0xb0dd05a1, 0x57691e0f, 0xba713ba1, 0x040fde50, 
	0xe124d79c, 0xc5cb15bb, 0xa90f68c3, 0x895bffe8, 0xa9ce83f7, 0x34a24a18, 
	0x0aba232f, 0x69e8f473, 0x6e268afc, 0x7b626d3c, 0xfd42494b, 0x4219bb60, 
	0xc4c9417f, 0x04be8a27, 0x313db3f0, 0x561749f5, 0x38a61fd4, 0xecfebcfd, 
	0xd5e6947e, 0x3b115fb2, 0xc63766fa, 0x203e030d, 0xb5981e97, 0xf33ff886, 
	0xc49ad30e, 0xda18fec5, 0xee945ddb, 0xaa76906f, 0x437b676d, 0xfbc292a6, 
	0xef45ba38, 0x5ac66805, 0x17fc9fad, 0xc8afeb42, 0xfb515fd6, 0xde1a0d77, 
	0xe24dd3a3, 0xf5130a6b, 0xca8efcf1, 0xa95f18f6, 0x79e72e5f, 0x63f63d52, 
	0x07aaf6db, 0x472a19ec, 0xfec2e431, 0xf1e3413f, 0xff45429a, 0x34321e80, 
	0x6ff61f73, 0x98ffa925, 0xd37bdfec, 0x3fbfd75f, 0x34662a62, 0xc4377be7, 
	0xde19449a, 0x78ab7433, 0x3f79e74e, 0x43bde5e4, 0x97e4f305, 0x78fefa80, 
	0x876e2ab9, 0x7e9161bc, 0x9f0087ab, 0x54cb5d28, 0x8496fde9, 0x13d5373c, 
	0x39610f90, 0x531d7bb4, 0x300b4553, 0xc0974d7d, 0xff84d4fb, 0x9fde2827, 
	0x9c2bd0f8, 0x6a2be5f1, 0x79e035b7, 0x4863da53, 0x14700db9, 0xf68f5803, 
	0x13a7ce0f, 0x50dabdd6, 0xc706ce96, 0x09d766b1, 0xf51321c8, 0x4fea65f1, 
	0x072f8e4d, 0x973b07fe, 0xbeff45e2, 0x73f10f76, 0x06f7585a, 0x638e5fb1, 
	0xdf573f87, 0x4397ba7e, 0xf5ca9a71, 0x39161c42, 0xb71c9e71, 0x9d3bf199, 
	0x4efc9078, 0x2797cf48, 0x906faf40, 0xcfe8aaf1, 0x4b13a31e, 0x906df2a3, 
	0xbf6a4b1b, 0x0f7180d0, 0x1df6aba7, 0xdcf88e99, 0xdfa0f8c7, 0xa27c47db, 
	0x35eb833c, 0x57fb296a, 0xf5047eca, 0x436f2223, 0x39975e3f, 0xca0f45f0, 
	0xcb27a7a3, 0x58f76c23, 0x87ae095f, 0xb53a5c8c, 0xa1d2e484, 0x7294da73, 
	0xbfccabe9, 0x5fe1eb6b, 0x972c9c7f, 0x9beb3a7e, 0x72fd1f44, 0x4aa69e9b, 
	0x4125afab, 0x9f832372, 0xc9ece30a, 0xfd41738e, 0xbf1a9eff, 0x8df879fd, 
	0x16fc25cd, 0xf24eb97d, 0xcf7e1e69, 0x2e7bf065, 0xde8b3f0f, 0x032ef2eb, 
	0xba421f7e, 0x9bc1bf7e, 0xef4e3f73, 0x65c3ef91, 0xe73973f0, 0x7f7cb261, 
	0x92edf891, 0x2068ddf2, 0x4bffa73c, 0xfe7894fd, 0xcfe7833c, 0x7ea3a4a7, 
	0xf00bd03b, 0xbcb157d4, 0xd9cb10fd, 0x0f04c3e6, 0x56bde47a, 0x5a61d17d, 
	0x8f0f18bf, 0xaafab671, 0x58218ba1, 0x4b8e412f, 0x2efbc2ce, 0x17fbc6ee, 
	0x19680f0c, 0x6df64a3e, 0x720af797, 0xf7807ee5, 0x7ca2ef03, 0x9a07fe79, 
	0x13aacf5f, 0x2da3f20a, 0x377cb3cf, 0x5c65361c, 0x993cc445, 0xfc829fa5, 
	0x1c326eba, 0x9a7547ec, 0xc90af149, 0xb9f3a406, 0x28ef8a1a, 0x90e52959, 
	0xd3d8963b, 0x57a6b804, 0x8bbc751d, 0xb2acc774, 0xeaaff446, 0x06b86889, 
	0x361679da, 0x0a42940f, 0xea27d250, 0xf28ddd6a, 0x039f6f1e, 0x44df2a1f, 
	0xa6723ceb, 0xa7bfbe97, 0x9f75e341, 0xcb0c7fab, 0xf23eb477, 0xf2bfa2fc, 
	0x0cf4185e, 0xbc971174, 0xcfe22617, 0xf176a0ee, 0x0d152817, 0x86f9963f, 
	0xc2fd2057, 0xc88de9bc, 0xfc4d214f, 0x143c1fdd, 0xdc33ffaf, 0x970b5f0f, 
	0xd1f74e3f, 0x2dedf927, 0x14dfbd37, 0xda2e2833, 0x3761f57d, 0x75636f3a, 
	0xee491bb3, 0x05ac38af, 0xaff47f41, 0x1487771a, 0x0fd09f29, 0x29c4cc17, 
	0x6bcab8c9, 0xcedfa51a, 0x28d15f86, 0x998299e3, 0x7abca538, 0x27253899, 
	0x8ae905bc, 0x4a7132ed, 0x7132ed79, 0x13ce324a, 0x14a718e1, 0x3929c4cc, 
	0xc9f717eb, 0xc54bcf38, 0x147e0275, 0x51bcb247, 0x5b0605c6, 0xf20ec0c4, 
	0x930b1b03, 0x8a3df4a5, 0x3ade0923, 0x257dc292, 0xc38171c0, 0x302e328d, 
	0x6f7e39dd, 0x6b9e10cf, 0x4432fec0, 0x3fd0d1f4, 0x97c6ca19, 0x33b73e13, 
	0x96fc363e, 0x10271946, 0x3b97c6ca, 0xcbe365eb, 0xa676f01d, 0x5f1b284f, 
	0x8d976cee, 0xdcfa272f, 0xb109f4ce, 0xe6dfda7f, 0xdec5afac, 0x9f803e9d, 
	0x68e9f486, 0xa1367194, 0x07607116, 0x0f8dc5f9, 0x7be01d23, 0xd09f483d, 
	0xb38a21ad, 0xe5f1d909, 0xe4dc768d, 0x0d7b8a12, 0xd4f2585d, 0x31af8a0e, 
	0x43a7dc14, 0x7dc54b7e, 0x6ef4ec13, 0x4e3107cc, 0x73de2ce3, 0x44df4930, 
	0x723c623a, 0x4191e310, 0x105e0e5f, 0xec8f1cdd, 0x2f8db8c2, 0xb6bd4a36, 
	0xf8db8ec8, 0x714a88c4, 0x27c2b71b, 0x44f10b76, 0xc8d78ca3, 0xbc81879f, 
	0x3e63e879, 0x81879fcd, 0x0d83cc4b, 0x21f2cddf, 0x2e061e7f, 0x97030f31, 
	0xbc818798, 0xe1ea2879, 0x2876e478, 0x7997781f, 0xbc63ba01, 0xe31dd206, 
	0x7a609e35, 0x7a9ffd00, 0x180fc72c, 0x607130ba, 0x8c35e280, 0x3e795b99, 
	0xd4235e31, 0x1af14432, 0xc4e8e645, 0x7e69fbf4, 0xb84b944c, 0x0ab6a6c9, 
	0x194699f1, 0x1dfc4777, 0x29e57d47, 0xa8054b92, 0x3ed28d4f, 0xdd7dcaa4, 
	0x748978a0, 0x767bde67, 0xf1d27eb6, 0xc29de648, 0x02a3cea9, 0x462b1f78, 
	0x5f745771, 0xa7be2dc4, 0x6a6eb949, 0x0199f7b9, 0x65d9177f, 0x745972c2, 
	0x7ba0c39f, 0xc7613027, 0xadc73ee8, 0x1d281e32, 0x2f3d9232, 0xfc3ba3c9, 
	0xd1bbe67f, 0x3be2617e, 0x3f125d2d, 0x0b4b5edb, 0x8e275ef9, 0xa9c9ecdb, 
	0x0c6fe36f, 0xf3f57e90, 0x0f2493ba, 0xee6a1ffd, 0x06417191, 0x9bfebde9, 
	0xdee9bada, 0x6ab924d2, 0x6bae51ba, 0x49a95031, 0xe3bb8eae, 0xb57df780, 
	0xc6fda23f, 0x83cba2bb, 0x55fe39e7, 0x24a1dd87, 0xb890ebbe, 0xdfb88628, 
	0x65f139fd, 0x59ef7951, 0xaf749388, 0xefdf9848, 0x60b3fdc1, 0x9f64bbfc, 
	0x245133bf, 0xf31c544c, 0xb515eef4, 0x0b7c22bf, 0xe00d6e31, 0x07a48a3d, 
	0x36f69bcc, 0x3e3973a6, 0xc7a92eee, 0x0c28f4d8, 0xd11cfbca, 0x533fd239, 
	0x30a56658, 0x2ef0b68e, 0x8637a0ab, 0x17315371, 0xee0651c6, 0x0ef802b2, 
	0x6f3f8658, 0xadf6f5b7, 0x832728dd, 0x73de823d, 0xfeeebf84, 0x7852f91c, 
	0x17953f7b, 0xe3ef805e, 0xdf5826bd, 0x9c639fa8, 0x06339e1c, 0xedb6e334, 
	0x8b5ef1cb, 0x0ed0fe31, 0xc96367bc, 0x7621b57c, 0x68d6be61, 0xd03a7b47, 
	0xfcbbe864, 0xb9e66f74, 0x2e8f2901, 0x16bf43eb, 0x80fe2de0, 0x8a966171, 
	0xf2640eef, 0xdcf1aeb0, 0xce6f9332, 0xeaf227cb, 0x56f9791b, 0xcdb0bf59, 
	0x8b4ff3e2, 0xde82d7ee, 0x95ceeeac, 0xab176c9f, 0x13ef4e50, 0xc51dcfb8, 
	0x27a44ef8, 0xfdcccfae, 0x6be3d636, 0x9d28de38, 0x9b1ee9d0, 0x2651c78e, 
	0x82741bae, 0x9f07be4e, 0xa41cff8d, 0x03a05575, 0x8e7ac0bf, 0xca642a7c, 
	0xf52d3377, 0xe5e7c019, 0x243f7946, 0x74c9cf7b, 0x62b9bca1, 0x539ef38e, 
	0x3dfe4e7c, 0xd97abca7, 0xfc074f78, 0xef2239b2, 0xbb5e539e, 0x0ba7bc6c, 
	0x73c21fe5, 0xdbf939ef, 0x18b5f59c, 0x3e5cfdc8, 0x03c8f8c1, 0x7bce6f38, 
	0xd8e70b4e, 0xff8c9cf7, 0xd5e87de0, 0xe7ba52be, 0xe450fb44, 0xa02fe02e, 
	0x43ef2147, 0xc4c9cef7, 0xfc53767b, 0xbf2d85f0, 0x3287ddca, 0x35fbe3df, 
	0x189f7f85, 0xf73e441b, 0x23b67f03, 0x34f48fdf, 0x23d672fb, 0xdfb053ee, 
	0xae7e3f04, 0x89cbea27, 0x944f6ba7, 0xba8fdee6, 0x0f7c8e7f, 0x390ba827, 
	0x271e583f, 0xfb41ef7e, 0x1f28f493, 0xf2ce51fb, 0xd765487a, 0x8b2efa41, 
	0x67ba67de, 0x0cab8c8e, 0x250ee266, 0x473d3edd, 0xf86d01fa, 0x7d4e39ba, 
	0x4cc79ecb, 0xa1dc4cbd, 0x39a9fe13, 0x660b1f72, 0xdaf30ee2, 0xe50ee265, 
	0xe31c223c, 0xcb7d6d0e, 0xbebb479e, 0x3b918f3d, 0xfb863ee4, 0x61dc6e79, 
	0x6106bcfe, 0xde79fade, 0x87bb1f70, 0xbde149d7, 0x772affd7, 0xb0bc2b1f, 
	0xb1f78464, 0xbd64ef5f, 0x20b1f70d, 0x21d763ee, 0x563ee57d, 0x198fb798, 
	0xcb1f7873, 0x3ca5cf93, 0x892fa5df, 0x6f30fdb1, 0xb189cfa5, 0x89bfa941, 
	0xf79ccee1, 0x83c53547, 0xc7f2b0f2, 0xc75a5eb1, 0xeb9faf50, 0x6bf8e5f5, 
	0xee822da2, 0xfbed4475, 0x70a1c6cd, 0x5613ed1f, 0xedea4fa4, 0x21077c11, 
	0xfa222fc7, 0xf4e97da1, 0x8b7c31fa, 0x9e2dd2b8, 0xfa3afb43, 0x1fb459a5, 
	0x5e7db256, 0x924563d1, 0x97bddfb4, 0xf9e42fde, 0x95fdeb07, 0x07fbd041, 
	0xecc6f7b3, 0xf811927b, 0xdfc73464, 0xe945d110, 0x9035fb20, 0x88afe1ce, 
	0x3f7c24b1, 0x490d788c, 0x31eec9fc, 0xbee5870e, 0xece45d0c, 0x716ea533, 
	0x612ef11c, 0x4f0bdfbc, 0xdf1b3f1b, 0xef0f8e08, 0x76313d9d, 0x44fa02b3, 
	0x14bb8f29, 0xde73d7f1, 0x77add719, 0x273c1ccc, 0xfcf3affb, 0x233fc3b8, 
	0x9f3eebbb, 0x2c95df97, 0xc9e27d26, 0xde67354f, 0xf3f5ce2f, 0x9f1d89ae, 
	0xab577643, 0xddf0b7b4, 0x39df7c3c, 0xfa16cef3, 0x311f501f, 0xdd08fa32, 
	0x09c4b65f, 0x690afd15, 0xb8d5c643, 0xdc2943d5, 0xe3bb8517, 0xce97fa28, 
	0xef4cbcd4, 0x3112073d, 0x74f00bd1, 0x922ee25b, 0x3cff7ce7, 0xe73e406d, 
	0x1ab7143d, 0x32b6f7a7, 0x13d0fe72, 0x78961df2, 0x74ff6042, 0x0bfa199f, 
	0xfb48bce2, 0x97ef4237, 0xdf2f36c0, 0x14fb0311, 0xeb2ecbef, 0x9ef683df, 
	0x8be0ed7e, 0x08d21714, 0x6fc00b1b, 0xe784858c, 0x92ff92d7, 0xe3e22eb8, 
	0xa5bce0ef, 0x1cdf40fd, 0x9ed0583f, 0x656fec77, 0x4ea83bf6, 0xbde93d20, 
	0x8dcf183d, 0x0ff7f406, 0xd8d17ed0, 0x9ca1ea3b, 0xf2e209f7, 0xfbef02fd, 
	0xd7e82286, 0x848ee3b0, 0xb1f96d66, 0x371baec8, 0x5bdf05d2, 0xaa53c44b, 
	0x384d6f7c, 0xc44bbbf6, 0x233f612f, 0x2d1fb666, 0x68fd4cd1, 0xbe074fd8, 
	0xfd1ef443, 0x87791e14, 0x4fc83fe3, 0x7e856e97, 0x4dd3df81, 0xff5f1c36, 
	0x2625efc6, 0xb7326fc8, 0x7c74e8ef, 0x4c76752f, 0xfad20fde, 0xf40ed893, 
	0x155aedfe, 0x70527bd4, 0x51a5893c, 0xbced7b7f, 0xad015e41, 0xbf18e856, 
	0x30e98a54, 0x81fb37f2, 0xc8ed337b, 0x34ee9cbb, 0xfa458e38, 0xdbb7d3dd, 
	0x4c4fe979, 0x0135ddbf, 0xdfe91543, 0x30ea7a71, 0xe49b33a5, 0xefe90d7b, 
	0x71d03cc9, 0xf8f18cc2, 0x63c9bcf1, 0xf425f7c9, 0x73329176, 0x601806f3, 
	0xce966f38, 0xe8a510ef, 0xf4c3221d, 0x2487bf13, 0xb58acfbf, 0xcbb5a8bf, 
	0xbf7af067, 0xef1a8c8e, 0x8c6a7e45, 0x46798ec5, 0x77d25f09, 0xedd92ccf, 
	0xabe82713, 0x6fd057ee, 0x873c4fe0, 0x7cb9e27c, 0x1fbe04e4, 0x8dbe3672, 
	0x6f28e9de, 0x6012523e, 0xe70a6ef9, 0x94fc8abd, 0x735e9fde, 0x1285df84, 
	0x950bbe0a, 0x99d85b6e, 0x3a772efb, 0xedc650b4, 0x5d790be9, 0x1999bdf1, 
	0x66f79d0b, 0x53a88fc6, 0xd1fe9bbe, 0xfbcca923, 0xa6ef39c7, 0x145569cf, 
	0x6cf187dc, 0x2a11df0e, 0x11f3c98b, 0x3d503b7c, 0x3549e58b, 0xd4ba60ae, 
	0xd03bef8d, 0x45dbd87b, 0xf8ec1df6, 0xf78e8dc2, 0xcc3c6dc4, 0xcbaeb4a3, 
	0xfa8dcb75, 0xd2f37941, 0x4b3c6460, 0xb144b28f, 0xd04f4022, 0xadec1d41, 
	0xe749fc95, 0x373f7691, 0x87217bf1, 0x717ebe64, 0xa61bc505, 0xf592de9b, 
	0x42874c42, 0x23f9f3ce, 0x3dc885f2, 0x21327c77, 0x390739cf, 0x7cf397bf, 
	0xcbdd228f, 0x9f4fbe79, 0xed92ecee, 0xedfeb83b, 0xd2fdb79c, 0x738e9fc0, 
	0x3975dfd3, 0xfc3359ce, 0x38eb7c08, 0xe71efd6f, 0x66daf3ed, 0x7a21cfe0, 
	0xadab6aff, 0xf73ae217, 0xe7828504, 0x4598e929, 0x1b1d25f2, 0x7e0f0779, 
	0x82d2f9ec, 0x1ce1ec66, 0x3253c1bd, 0xe3cf1fb4, 0x3cf2253c, 0x1e99a3ce, 
	0xa9e79fbc, 0x6d767a35, 0xf95c54c5, 0xfc8f522f, 0x2f7c56d1, 0x422ad6a2, 
	0xf5e5e439, 0x94302da9, 0xbebec11f, 0xc2d7d617, 0x93f38a31, 0x138ae4ef, 
	0xcfa0e8ef, 0x8e126ced, 0x62d3af77, 0x0e7f1df4, 0x3f7c5e5e, 0x5775f019, 
	0xdd60f7cb, 0x4efd0798, 0xdf2bc17b, 0x576a6d7b, 0x36a77c14, 0xe51dea7e, 
	0x8c7f0e50, 0xa2ef931e, 0x1477adc7, 0x3296c75a, 0xe6e4722a, 0x77bd06db, 
	0xf4126eec, 0x76c6871e, 0x31f999c7, 0x1ffe8755, 0xf27a926f, 0xeef4a410, 
	0xcce78f30, 0xcb0551fc, 0xaefe8e11, 0x1df47c74, 0xfce72865, 0xcf7eaa72, 
	0x7db5fbf2, 0xa1718fc0, 0x3c44a0ea, 0xfbb6e3cd, 0x052dc6f5, 0x79fb19e1, 
	0x69c3bf19, 0x3cce59f3, 0xd07df961, 0x1fe325de, 0x3f8e2495, 0xd38fe306, 
	0xddfbcafc, 0x3be4864f, 0xb2a65dc2, 0x6e3fee5d, 0xec07477c, 0xb798a5dc, 
	0x7b7f80e9, 0x735dffd0, 0xc4eb49b2, 0xbf60c3df, 0xdf1edda1, 0xd3993991, 
	0xf6a9763e, 0x4a349ba7, 0xdda1378f, 0x250fa45c, 0x3b64267f, 0xf7ecf3b4, 
	0x9268df64, 0xdbfbb9f7, 0x5fa1344e, 0x7af621b8, 0xe7079e13, 0xe5c23f97, 
	0xd4fe9027, 0xfa1348ef, 0xd7ec1565, 0xb37eef7c, 0x7c265eed, 0xb7bbd8d4, 
	0xeed49a1b, 0x742ed497, 0x66227689, 0xb2157d28, 0x3fc9f23d, 0xd4cfb5e5, 
	0xcf052c33, 0xf67aeca3, 0x53be9077, 0xb17f37c5, 0x7e5437e6, 0x46e377a9, 
	0x09a1fce7, 0xabd22cf5, 0xfa8cefd0, 0x4faa3ada, 0x7db02ffe, 0x5a1f704a, 
	0xe78d1b0d, 0x26d56c0e, 0xcc9bd1f3, 0x50ce795e, 0x9456c2f2, 0xf445e26f, 
	0xe89fa743, 0x9b7afb97, 0xcf8fd7dc, 0x76e348b9, 0x20e5496b, 0x3de895e4, 
	0xc75b8a49, 0xf4e6affa, 0x3077c3ab, 0x390e051f, 0x895cfa43, 0x4b30573c, 
	0xef255ea4, 0x9fd25c71, 0xbddf0834, 0xddf77e45, 0xcb9e49fc, 0x99c3a6a7, 
	0x3de85b9a, 0xd67def31, 0x618fdb93, 0x7793e52a, 0x07c510d3, 0xb14c7b78, 
	0x4b25f313, 0x1af797af, 0xc1f51f8d, 0x39dbf17e, 0xbe9173e5, 0xa5139a7f, 
	0xefaf02f4, 0xbee3b609, 0xe08aa739, 0xdf5c1234, 0x7a961cd7, 0x37ea5c4d, 
	0x1df66a67, 0xe957bdc9, 0x7eed9b7d, 0xdef84390, 0x1436688a, 0xe1b6673c, 
	0x72845fb0, 0x87f87afd, 0x5b78c5ef, 0xf98fe214, 0x8e1c6573, 0x15d67efd, 
	0xfe3f2573, 0xb9a69cdb, 0x573c2eb8, 0xeb3f7d4c, 0x73cd4db3, 0xa25ebd69, 
	0x82ee68bc, 0x2f1eb8b9, 0x373d5e55, 0xf5f3ed41, 0x15e9f5ba, 0x6fba6e91, 
	0xbed0466e, 0x7b98a33e, 0x3fbea486, 0xada41cfb, 0xf63be573, 0xca42cf74, 
	0x87ca0893, 0x68b13e1b, 0xdbec2d76, 0xeff8de37, 0x7da49bb3, 0xc65e7f56, 
	0x0dbfd4c5, 0xc7682ae9, 0xdf6ca1e7, 0x3b13f158, 0x02fd5da8, 0x45beaed9, 
	0xc77b63b6, 0xe905386a, 0x0446cdfa, 0x9e9ba5fd, 0x7b41ec8c, 0x8acc7560, 
	0xf030efd0, 0xa0faebb9, 0x5e267e7d, 0xaea7fcc4, 0x9d264d16, 0x07b75f87, 
	0xcd8f18fd, 0xb4a7ef95, 0xe21d3de3, 0xf88aa34f, 0x8f3dda73, 0x4e2e76d9, 
	0xf7e9e9cb, 0x74f5c41c, 0xe77cbb67, 0xd507f572, 0x1be61561, 0x239f90ec, 
	0xb3ed93fc, 0xd903717a, 0x18ff21f8, 0xeb74e1ca, 0x74876962, 0x6d2a77c8, 
	0x5b6e9879, 0x0588f644, 0xdfc3bd7a, 0xda7dfcd4, 0x83bfa08f, 0x771b1f38, 
	0x1c977eb9, 0xc6cbceca, 0xee3546f3, 0x247b1b67, 0xbe606c1f, 0x7a2fc298, 
	0xfd8ee890, 0x667ec4ac, 0x72f90efd, 0x30d751f5, 0xf895cbeb, 0x402fd5df, 
	0x55c1ea5e, 0xbfd5c038, 0x74e6f3b4, 0x342e9fcc, 0xb95ea20e, 0xec84676a, 
	0x417e8d9a, 0xeeaf00ef, 0x31fb96ba, 0x9c1edda9, 0xabbb9037, 0xdbb0ad17, 
	0xfaf8442f, 0xeb34ae5d, 0xbf98d57b, 0x41780fcb, 0x1e38bbfb, 0xf51cbf2d, 
	0x6ddfb46f, 0xcf0f737b, 0x225fd08b, 0x4f1bf33b, 0x1cced2e9, 0xd6fe425b, 
	0xa74b9a9b, 0xbb6d4bb6, 0xec8ae393, 0xef5518f7, 0xd0ed22a8, 0x6c6eb43d, 
	0xe3bebeba, 0x9e7883e6, 0x0886f1b1, 0xbaeef7f9, 0x42b7df7c, 0x9b76c0d3, 
	0x5d66fd2b, 0xc6375aee, 0x713e7f1d, 0x1bb8af8b, 0xe373e6f0, 0xdf9e95bf, 
	0x9a6cf1c1, 0xba7cbf4c, 0xfce19f11, 0x7d858b9b, 0x4cf0848f, 0x27a09e01, 
	0xec755c6f, 0x116781eb, 0x3da9e5af, 0xbf3ec020, 0xe59d96f8, 0xc0fabf52, 
	0x1d2547ae, 0xacee35df, 0xd7e4fbeb, 0xbe43791e, 0xdb602beb, 0xd3dbfcc4, 
	0xbc876463, 0x2c959c9e, 0x103e3c41, 0xf4861a59, 0x12474a93, 0xaf6036e9, 
	0x72d77e4f, 0xfae9bb7d, 0xbb697157, 0x8f13f002, 0xfdba471e, 0xa4d4b7b9, 
	0xdc88a375, 0x391edcf1, 0xcf5f7480, 0xd9f35f74, 0xfbe96fca, 0xe768729d, 
	0x45ef8d18, 0x9dcf07f4, 0xeadee527, 0xe9b5aefb, 0xebb3f445, 0xadef867f, 
	0xbe1a7c03, 0xa2faf97f, 0x61d15e5b, 0xfc5f5fde, 0xee51c785, 0x823f5d02, 
	0xe74603ef, 0xbde55f31, 0x0b122a63, 0xd0fb3ce8, 0x8fced977, 0xcbdef45a, 
	0x4e533fb7, 0xb2dd4ff9, 0xf2fd1ab9, 0x667c329b, 0x3cf7c955, 0xfc817f9b, 
	0xe8cd50f5, 0xb1fef95c, 0x9840d77c, 0x5a6cfef2, 0x57e96915, 0x3f7be5b1, 
	0x0abd7bb5, 0x81d80ce4, 0x7e59cd69, 0x42a8b8e7, 0x7421b5f9, 0x61fdbd37, 
	0x9da359db, 0xf774858b, 0xef9ef29b, 0x9df78912, 0xc2adaea7, 0xe8373477, 
	0x7fde8b77, 0xdf81fb42, 0xd2fee5c7, 0xe76f6cba, 0xaab88fd7, 0x20f4ced0, 
	0xdd3ed01e, 0xe5dbf5c1, 0x1b67bc3b, 0xd70c796f, 0xb0f686fb, 0x1cd5edb6, 
	0xc59eef3b, 0x14fbced2, 0x27695bac, 0xa5910956, 0xd9ba9dff, 0xb27c73b3, 
	0xbf49f9bd, 0x8fbe18f1, 0x7f2edf9e, 0xf1e687bd, 0xfd0c3aef, 0xf673f880, 
	0x3ce4331d, 0x7f1117f4, 0x5154f39e, 0xe58db3bd, 0xffe4d7a4, 0x3f86562e, 
	0x6774dfd9, 0x7c829779, 0x6d6ea77a, 0x5e0533d9, 0xf96c3be9, 0xdca3e593, 
	0xb7d60777, 0x7dc2ab1f, 0xf180f5fc, 0xe1c79d18, 0xfef84c3d, 0xfc07bf27, 
	0xd6e1167a, 0xc71ca65b, 0xadbfa85b, 0x2c32da6e, 0x674932ed, 0x03b05f9a, 
	0xf6be5f56, 0xdedfc415, 0xa2f9ec47, 0x4396de79, 0xbf393edf, 0x8d56d11e, 
	0xc9e695eb, 0x1b3f3c9a, 0x9d7e5e71, 0xc5e1eed3, 0xdf26e478, 0xe377a589, 
	0xc75a5a8c, 0xdf947740, 0xf4ba8feb, 0xfe38999e, 0x5feb2d50, 0x2dbfb8b5, 
	0x64e3279f, 0xc0253ee9, 0x7cdf9ebb, 0xd78bf706, 0xb0b7d6fd, 0x585c7f5d, 
	0xf1845f65, 0x68fb003e, 0xa3abb53b, 0x48c56f77, 0x68f7e21d, 0xeb23183b, 
	0xcd1577f0, 0xd1d80f70, 0x799db0fd, 0x21fe88bf, 0xdbfb0ebd, 0xb0215d67, 
	0x87eccddd, 0xb89a7ba4, 0xe7b0de4f, 0xddd79e2c, 0xa2d46d50, 0x05b5d6dd, 
	0x47e25df6, 0xfef10eab, 0xa4a8cc64, 0x51daa2fe, 0x7e7097cf, 0xc5f91d45, 
	0xeaebf64c, 0xdd68eb6b, 0xb138feda, 0x4bf9367c, 0x21ef1d85, 0xd7d8ef48, 
	0x3f90295e, 0x8d3b3a00, 0xf7c2d6fd, 0xb437ee80, 0x4f50eaa5, 0xab974cf8, 
	0xd0f3c851, 0xd747a446, 0x2a556396, 0xf3a1b1e0, 0x1dfe46da, 0x3e7946a1, 
	0xdbbe231a, 0xbf827c00, 0xf6eab723, 0xfd037cff, 0xc117ab2c, 0x6dbae37c, 
	0x5d1f425e, 0xce59b5dd, 0xefdca77f, 0xf7ff9ebb, 0xdf8e51a7, 0x03fed258, 
	0xb1bb4f3c, 0xc1ed78d6, 0xeb41a400, 0xdf5ef887, 0xe978cd1a, 0xfc399dc1, 
	0x383d2978, 0x60f49fb6, 0xe253def3, 0x8ddc1404, 0xb77cecf4, 0x9faa49fa, 
	0xafe2fac4, 0xce9bbfa9, 0x97faed6d, 0x3e51b3d2, 0xfb67a94f, 0xf1040c56, 
	0xb99d5806, 0x6989d687, 0xb9a9bf48, 0xc3f6813c, 0x3888dd6a, 0x5d529f7e, 
	0x07ef8d56, 0xa9453509, 0x8bee4f39, 0xa2fefa6b, 0xbf603c52, 0x1ecff3e4, 
	0x87c258fc, 0xe87e3af1, 0xa2c1d617, 0xa1e63bb9, 0xb06afabe, 0x18f7823e, 
	0x70277be9, 0xe08f2ff9, 0xe9ae56ef, 0xbef2aa3a, 0xca314f8a, 0xf6e3aeef, 
	0x383de339, 0x891b9e4f, 0xff7a54fb, 0xa6507c42, 0x11fed5ef, 0x68a67fdc, 
	0x5975aab7, 0x326bbc22, 0xba63ee5d, 0x0abda697, 0xfc2ecbeb, 0x8a33b05d, 
	0xbed10d48, 0xafe5f52c, 0xa2eff8e0, 0xcbeb6875, 0x0f9fb42e, 0x7665befe, 
	0xe13f942d, 0x997f6735, 0xb7aad1f8, 0x7e2ed4fc, 0xec61d202, 0xf8dfae5f, 
	0xfad7e498, 0xc7e853f3, 0x8a86cdde, 0x12dbcbeb, 0xdfffa173, 0x3bf41317, 
	0x5f85af65, 0x263e46ee, 0x1b94a93f, 0x77a4def4, 0x4177e641, 0x4f1fa853, 
	0x79f5b3cc, 0xc77ca8e3, 0xee14eaf9, 0xaefcedab, 0xe45bea33, 0xcdf69ebf, 
	0xecbeae64, 0x55eb1439, 0xd1d9f1da, 0x334f31d8, 0x4e976b0c, 0x41efb17a, 
	0xc4814c31, 0x1ef90eee, 0xebfb3369, 0x0cf47df9, 0xf849f65f, 0xed793d24, 
	0x40fbfc4b, 0xecaef971, 0x27a1c2f5, 0x51534c83, 0xa47bd64f, 0xbce2f69e, 
	0x99c9e84b, 0x8fd231f6, 0xd862357d, 0xfc4a1dfe, 0xc283efaf, 0x7f68efd6, 
	0x29955df0, 0x2c7ea4d7, 0xd77d52e3, 0xd63f4886, 0xea3746fd, 0x88d705b7, 
	0x46ff1db4, 0xdc1bf4fd, 0x1eeb8c8f, 0x7df379e7, 0xbf4b86d5, 0x3b27d433, 
	0xe837edda, 0xacdc4277, 0xe7f4e727, 0x1e4f4a9e, 0xffcdf7b7, 0xf4327aef, 
	0x1fbb31bc, 0xa50a2d96, 0xbfd4ff50, 0xdcbc221d, 0x50a48eb7, 0xf33ffe4f, 
	0x7a854fd8, 0xfe7be832, 0x93d236e1, 0xdfc6ff6d, 0xf399d74a, 0xa7c83ca5, 
	0x32bd3e5b, 0xb9f30aef, 0x65ff3d8d, 0xc827808d, 0xed3bfd1b, 0xac9ea1af, 
	0x7aaf97b9, 0xfface414, 0x5867fd6b, 0xf6fcfe4f, 0x7fcfdc7d, 0xab2e4f43, 
	0x7f67c228, 0xaeb0f785, 0x52961194, 0xcf33f8ef, 0xcb58506f, 0xf9ec882e, 
	0x64f4a5d6, 0xebe4f50d, 0x52636e90, 0x1cc78e4f, 0x6359727a, 0xeee9125b, 
	0x3f8cb6fe, 0x4e8dafd0, 0xbffb27a9, 0xf50476d6, 0x52f981e4, 0x35edf64f, 
	0x13ef7386, 0x79c3f5d8, 0x57d9727a, 0x2e4f48db, 0x43a0dafb, 0x3e7fbe4f, 
	0xa8dfd5f3, 0x68ef0727, 0xf93d0f7f, 0xdf74f9ba, 0xe4f43dfe, 0xfe792ab2, 
	0xf9278405, 0xbb27af92, 0xca170dc7, 0x9ebe6f31, 0x9eb0489c, 0x6dece32c, 
	0x2cddd93d, 0x7977a85c, 0x91393d6d, 0xb93d5778, 0x4970d060, 0xa14db93d, 
	0xf77e56f8, 0xbfcedd37, 0xe7fb60e7, 0x7e6c3d6d, 0x74b0f482, 0x655ebda3, 
	0xc6d9fd1c, 0x3fb69397, 0xbacafc88, 0xf4a98bf5, 0x465fbc64, 0xbda6727a, 
	0x9c6c4970, 0xf373fdeb, 0x7ff97ed9, 0xfe6d93d4, 0x73bf7914, 0x4fc5d6e4, 
	0x5e714cf7, 0xe0ca6e94, 0x5ca3e193, 0x2fdf193d, 0x0595f1c3, 0x5f38e3cc, 
	0x5f900165, 0x3b26f958, 0x8e3cc65e, 0x9e5f507e, 0x1bf34c7e, 0x14b179c5, 
	0x3e68bbd4, 0x4ddd21b7, 0x68f1cf15, 0xeafdc15f, 0x7247b5f2, 0xbd0ce7f5, 
	0x5f5b09e3, 0x4f7c6456, 0xd86fefde, 0x3f3795f3, 0x0fed9a85, 0x99727a92, 
	0x167ba4df, 0x4a623505, 0xf9a9f93d, 0xd6cfdcf2, 0x2efab593, 0xdda193d2, 
	0xb93d5cd6, 0x97c001fc, 0x93d3cef0, 0x55e8ce31, 0x94368f8c, 0x58e4f529, 
	0x8776c0b3, 0xb0bcf3e7, 0xbcb9ec9e, 0x3764f49f, 0x1fb0c9ea, 0xff645b68, 
	0xe99c9eb6, 0x27abbfef, 0x41dfcab7, 0x3764f5b1, 0x7dc5c9eb, 0xdac9e926, 
	0x86325740, 0x9af6aaf7, 0xea13cd1a, 0xc7e853cb, 0x1b5a5b25, 0x3e91f9e7, 
	0xbe469f87, 0x3daa812b, 0x2eedca16, 0x7e7cef39, 0x3ce7ebe5, 0x950bdfdf, 
	0xfa85be8c, 0x78d6a871, 0xc600e1fa, 0xd97f1a4f, 0xc9e7127d, 0x7ff30278, 
	0x33fc7eab, 0x5fd8e3a4, 0x77bf1faf, 0x3f4ebffd, 0xb53cb946, 0x31df7a1f, 
	0x33a887a4, 0xd55f5252, 0x2f9dfc54, 0xa770bdfc, 0xa4529c5e, 0xd28cbc5e, 
	0xefe5f3d3, 0xc79af987, 0xfacc5ea5, 0x44efde11, 0x5e6860fd, 0x67fa3e7a, 
	0x357ecf49, 0xe30fbfdb, 0x5673ecee, 0xb1dbf5c1, 0x0e3dfc9e, 0xefd16eaf, 
	0xcf9c5fc5, 0xf902f07a, 0x95a8a79e, 0xb7e5c1ef, 0xb8ebfaa7, 0x09ffc81f, 
	0x934d97f7, 0x9dea5ddb, 0x6c0bffc4, 0x00843171, 0x0003d7f1, 0x7dbd9c78, 
	0xd554780d, 0x33b9f099, 0xc9372677, 0x424c9924, 0x49906048, 0x24201808, 
	0xc9849093, 0x01372064, 0x462ff011, 0x1dad48aa, 0xb4b45590, 0x8a088a0d, 
	0x80499deb, 0x2009df84, 0xb46db506, 0xdfaea5ae, 0x8daeb82e, 0x2f5f7eee, 
	0x69511f11, 0xa5afd41b, 0x8826ee96, 0xcf7cdd7f, 0x06ed2917, 0xdf7bf5b4, 
	0x73339cf7, 0xbb680267, 0x1e797cfb, 0xce7b9e39, 0xef3de73d, 0x7de739ff, 
	0x32560cef, 0x0b1846c6, 0x28e3f6bc, 0x9ffe1f7b, 0x62c6d9e9, 0xc4b616c6, 
	0xc623ec6c, 0xbd5bafd2, 0x2c67494b, 0xdb7f4323, 0x5eac6218, 0x628eb377, 
	0xa3bab7a8, 0xb4c60eec, 0xcadd03ab, 0x16858c1b, 0x3a7a8c1e, 0xb31eb9e0, 
	0x78e177a9, 0xe95cff77, 0x7b2d7ec2, 0x1cc7bc18, 0xfd065165, 0xb9586bd2, 
	0xa1d8c051, 0x1651cdce, 0xc2eaf683, 0x319e767e, 0xe031741b, 0xb59d61bf, 
	0x76333719, 0x37300f54, 0x6dcc9dd4, 0xbcc05633, 0xcf7e46cb, 0x1ddda106, 
	0x84bf636c, 0x11eb8f86, 0xe4a67658, 0xf1c0bf57, 0xea8545b5, 0xfbc4a1d6, 
	0xb601d5e6, 0xdd0c0601, 0x6056e5a6, 0xa3affef9, 0xdbb400ec, 0x3bfc664c, 
	0xc94c9963, 0x1a3800eb, 0x997a2b3f, 0x2e045d15, 0x06321fa6, 0x58041f08, 
	0x2dea0d86, 0xf59bfa96, 0xfbb61887, 0x6d7ebc82, 0xf6c310f0, 0x2b820165, 
	0x05d440a3, 0x9c67f89c, 0x3132e3e3, 0xc717ae0e, 0xba890365, 0x23870e33, 
	0x6d500882, 0x555e692c, 0x593ba94d, 0x4b2a9c12, 0x25b55386, 0xb3c703af, 
	0x25e387ce, 0x2b3c61d5, 0xbdc20a7c, 0xd49b8f8e, 0x0ebc96cf, 0x023db8c0, 
	0x32f1cdf8, 0x6328fed6, 0xa6c30169, 0xf76f5e01, 0x12db6e03, 0xfa866fcf, 
	0x1cb7e044, 0x21c7d417, 0xcbf4a45b, 0xfe9dcfe7, 0xf9b7e7e4, 0x94e69f39, 
	0x4f4d76f2, 0x8f9caf79, 0xf928be9f, 0x6c33eab9, 0xe02ff748, 0x8023cb6f, 
	0x4fa816ef, 0x8d2cb284, 0x38451ed9, 0xe0177b4c, 0xcff41579, 0xd86a71c5, 
	0x44a36d84, 0x85a31bad, 0x01876e34, 0xc635bba5, 0xc382e2f9, 0xaefcc288, 
	0x4366c62a, 0xa7f4657f, 0x3e00e351, 0xb6fe62ff, 0x99d98c0d, 0x0fc818a1, 
	0x30bde013, 0x1ecc1d94, 0xaaffa131, 0xb3e476c1, 0x11815d9c, 0xdbc617a3, 
	0x3b689b64, 0xa09bf84f, 0xfef77f42, 0xde8ec4c0, 0x3bb99c04, 0x6ffde63f, 
	0x9fbc2367, 0x63444761, 0x3da08ffb, 0x22da6433, 0x7c5d281e, 0xd78e30dd, 
	0x00c911bd, 0xfdf0bb3d, 0xaee64fd5, 0xd27bf920, 0x34f7720d, 0xa11b4fac, 
	0xf419137e, 0x1fb11843, 0x58bcc0db, 0xcbc279ef, 0xd7e4748c, 0x3ca127b7, 
	0x79506d9e, 0x5093199d, 0x604dd7ee, 0xe888739a, 0x11e5113c, 0x055bf408, 
	0x92cec4f4, 0x07f67eed, 0xbe07e7a8, 0x650adae7, 0x5184fe9f, 0xd602fa84, 
	0xdb75780f, 0xf72f849c, 0xf63db30c, 0x58179418, 0xac256c47, 0x2da0d36b, 
	0xa9cfe617, 0xaa6570e2, 0x400f8eb0, 0xd80eb79e, 0x09f82699, 0x4041f9e5, 
	0x12d01369, 0x8c8d15fa, 0xa53fafe5, 0x2f1fd7f0, 0xba7f5fc1, 0xe7c97f04, 
	0x72fe0b9f, 0xbff6826d, 0xa399ba41, 0x4791c011, 0x47a075e5, 0xb733ea1f, 
	0x6fdc4d93, 0x074b0bd5, 0xff40dddb, 0x39bf0253, 0x010502cb, 0xd04e85bf, 
	0xe545f893, 0x1efa49f0, 0xef30fec6, 0x47ba505b, 0x6f4438f8, 0x2cf99f78, 
	0x5e1cabef, 0x7bad87c0, 0xb623d388, 0x9773f798, 0x8c5db631, 0xcef590c3, 
	0x6e80b00b, 0x7532ceae, 0xdba0a0eb, 0xcf74b1e1, 0x6ed690b8, 0x44f414ac, 
	0xe69b283e, 0xdf7df7c5, 0x3e71759d, 0xe7bef870, 0x7ef48ad9, 0xfb6de883, 
	0x67fde9a9, 0xd613cc27, 0x7f5f28bd, 0xcbddfc40, 0x44ed3050, 0x0ebea5ff, 
	0xaf7afbd2, 0xe08378c7, 0x25f9c3cb, 0x051ac07c, 0x0ee4bd56, 0x520fbac3, 
	0xdba3b2bf, 0xc7659d68, 0xdfd364a9, 0xa7e9f5e5, 0xecab74a0, 0xde6167eb, 
	0xf76c541f, 0xb34fa0ab, 0x8f7f75ef, 0x66e63f01, 0x8e45ef19, 0x1af6bad1, 
	0x36178e1e, 0xf800e022, 0xded788dc, 0xecf578b1, 0x915c3e03, 0x73f62bc0, 
	0xd5e2b41f, 0x06dc11b4, 0xf1133b87, 0x5e1cbe1a, 0xa71a8f5f, 0x9ebc1aff, 
	0x13fbb3f3, 0xc65ccd78, 0x1cdccaf1, 0x014e579f, 0xab1d3e88, 0x9d7ce2ff, 
	0x73e4ffa2, 0x3732ffa9, 0xde1d98f9, 0xfb4308cb, 0x43e8cb9e, 0x1eb177d0, 
	0x6edcefae, 0xd7c8772e, 0x9b5e1719, 0xda28f8ff, 0xbe214303, 0x84c5f0bf, 
	0x6ed01b3d, 0x7b3b1b1b, 0xc48d1eb8, 0xb2f67f50, 0xbe60d7ae, 0x5c8f830d, 
	0x1afd8a31, 0xda0fc40d, 0xc666e8f7, 0xe57005be, 0x671da08d, 0x84d3b46e, 
	0xd86f1879, 0xc65d9069, 0xa7fc0ebf, 0xe97a43c5, 0x5c1d2b9e, 0x33c3314f, 
	0xf35e12a2, 0xb9416cce, 0x59403cd6, 0xf01a98e6, 0xc773c394, 0x4addd5ac, 
	0xafd75f11, 0x3e7d00be, 0xfd957265, 0x0e75890f, 0x151fdb5f, 0xf151547a, 
	0xe9f4dbfd, 0x1962af9d, 0xbf303d66, 0x75966bc3, 0xea12c7ce, 0xe9971648, 
	0x393f018b, 0xb64be816, 0x758edc01, 0x5f6a74e6, 0xeaaffa27, 0x08b63a7d, 
	0xeb7a4dca, 0x4397a036, 0x555815e8, 0xbbe0176b, 0x3e96f015, 0x5d1fe092, 
	0xc765dbea, 0x63ff58ed, 0x9baf3e4b, 0xc3f22a05, 0xa4521ebf, 0xbea3b5be, 
	0xf6fa10cd, 0x748c1f7a, 0x1bd4023f, 0x3f20619d, 0xbfd45199, 0x30a9b736, 
	0x52c757e0, 0x30c3ffa1, 0xde62516f, 0xffce2af2, 0xae02358e, 0xc570c9d5, 
	0xbb443bdb, 0xac76f171, 0x5a36b973, 0x7a964523, 0x580fd421, 0xea528bea, 
	0x65f5292d, 0xa5b7ef29, 0xfef037d4, 0xab5bafa0, 0x8d9a9e81, 0x241919e5, 
	0xa8c7655f, 0x4806cb34, 0x4fd3e80f, 0x9c18dd62, 0x81e929fe, 0x75d4aadb, 
	0xd11336c4, 0x8cf69c5e, 0xe5e21eff, 0x07d06cfd, 0xaaf96385, 0xc40cc9ce, 
	0xfadff017, 0xfc132fd8, 0x4ae96aa7, 0x5bb9e00c, 0x2ff97bf0, 0x5d208eea, 
	0x7d3f929c, 0xf90cf581, 0xd78d3475, 0x586f5b19, 0x60cdafde, 0x57ec1446, 
	0xddbd78f9, 0x2b2c64e8, 0xfce2fac4, 0x1559ed06, 0x6414ceb2, 0xbd16ace3, 
	0xd691b6cf, 0xf2f6c363, 0xe00f781c, 0x3811dacd, 0xc9190216, 0x863812da, 
	0x64dd40fe, 0xf20edfd6, 0xe995375a, 0xd5c3a748, 0x281abe1c, 0x76df20dd, 
	0x2ca10b28, 0x123f30bf, 0x18f5cd3d, 0x0584d1f2, 0xf50b98c1, 0x4720a2eb, 
	0xd053194e, 0xb47098ef, 0x843a1621, 0x2126064f, 0x2f82aa1f, 0x07e9381f, 
	0x06a2c294, 0x6bd00800, 0x6c6f2be5, 0x40fdfd47, 0xe82e7019, 0xe30cacbb, 
	0x40fed8b7, 0xf7375319, 0xa4d0dba2, 0x3f3ea144, 0x471db96f, 0xdb7c08db, 
	0x34fe4611, 0xcbf9a0ae, 0xfd153103, 0x0fee36c3, 0xb730fcd7, 0xf059c71d, 
	0xb02ec32d, 0x3cf90276, 0xee96dcab, 0xd15c7184, 0x7a86ff43, 0x4fa02d3c, 
	0x9d7ef066, 0xdd57bbb0, 0xc2ffa8c7, 0x30bde03b, 0xcf6a6dd9, 0xf47667ca, 
	0x399f54af, 0x1d9de919, 0x63087906, 0x9a7e93a9, 0xfd43d9ef, 0xd3998e8b, 
	0xc16fac18, 0xf71dbabd, 0xf8304f0f, 0x55e87417, 0xd7aa30f7, 0x437906cc, 
	0x73316ab9, 0x3acdde91, 0x570bf3d7, 0xf99f7a32, 0xc7e22f75, 0x7c68c6d5, 
	0x7fd71b57, 0xdb8f0d55, 0x172483dd, 0x7d5fec5e, 0x8777619f, 0x9ea94f89, 
	0x6c15d01d, 0x698d342f, 0x70556f08, 0x0357f50f, 0x5e3849fe, 0x7f06bdf5, 
	0xb893e99f, 0xab3eebdc, 0x19f6cefd, 0x3fdd7ef4, 0xfb8bdddf, 0xe06cf2af, 
	0x6447c05b, 0x95fbddf5, 0x26efec5e, 0xcb0052bb, 0x9f6af1c6, 0x8af6e37f, 
	0x47a79834, 0x9b748c99, 0x76e866b5, 0x1b33cf7c, 0xe3bee27a, 0xe9bee9ae, 
	0xd89e6760, 0x08b4faf4, 0xb99e89f0, 0x3ac1aedc, 0x13c00cf4, 0x3f6cede8, 
	0xcbe60bac, 0x93f8e32a, 0x74cb39f3, 0xdffd3bf2, 0xfb9ff8e2, 0xc1ac52b1, 
	0x757bfe7c, 0x91bcc7c2, 0xe60d62a6, 0xa428cc71, 0x8468e37a, 0x7f211fea, 
	0x4a61bee2, 0xab8e3b4b, 0xef7a7eb3, 0x4ec56f83, 0x358c33b0, 0xac12b669, 
	0xf45d3c77, 0x9e6fb614, 0x5f0455e2, 0x6dfa853c, 0x3b52c973, 0x0f92b2fa, 
	0x7ce14cb6, 0x00f915b0, 0xd69fbbfa, 0x9e044623, 0xde763a0b, 0xb6155b47, 
	0x13872575, 0xc18d2c66, 0xee829df8, 0xb3d52e30, 0x75e14c7c, 0x700634b3, 
	0xee1c25aa, 0xea5298ea, 0xdd7842ee, 0xeecda7c4, 0x1be412e6, 0xdd28abd6, 
	0x8ae81fe8, 0xcc7e05d2, 0x4f632b07, 0x5fc055b1, 0x576a5185, 0x87c41937, 
	0xa063e42e, 0xfbda5a8b, 0xb671f22c, 0xbc77b74f, 0x44a1fc8e, 0x7cae3d70, 
	0x7b40dda3, 0xe49baf72, 0x17c7bd4a, 0xe783e2dd, 0x1b34d8db, 0xfa8d93c0, 
	0x33d429fe, 0x85bb667e, 0x5e9180a1, 0xbe0a2e81, 0x5fd7c0bf, 0xabe7fb82, 
	0x70536cca, 0xf60db57c, 0x8b5708e1, 0xb7cac531, 0x63eea7a0, 0x70babb16, 
	0xa129c6f7, 0x8ef9aa4e, 0x4d76b943, 0x3ca0abd8, 0x50a7e897, 0x3e98794f, 
	0x3fe803ad, 0xe92761fc, 0x93c6c8c9, 0xffd238ec, 0x5d1a3d82, 0x9133f249, 
	0xe89f4c5d, 0x37001700, 0x0c6099e1, 0x93e815f5, 0x813eab7c, 0xbe51f37f, 
	0xe57a126f, 0x08f41d26, 0xf945df94, 0xe83ac1ab, 0x0ab7a811, 0x2994b37d, 
	0x979728b6, 0xa6778489, 0x8bfab78f, 0xbd86a5e5, 0x2f3d3367, 0x8d7c7c40, 
	0x02757e01, 0x294afc85, 0x1a3dc307, 0xd8c57e33, 0xc93dbf91, 0x06e1034c, 
	0xaf70843d, 0xe4087ae6, 0xffdf0f39, 0x20d1ca06, 0x9f7933f9, 0xe7497cab, 
	0xe67c90b6, 0xe986fed3, 0xa6b7e8f9, 0x7a3d8ff9, 0x40e50385, 0xf3025fdb, 
	0x15f4b7ab, 0x3d3d4394, 0x23ef8d8d, 0xd8f1cc78, 0x5e9bbbff, 0xa669189f, 
	0xf5813f75, 0xddb60cf2, 0xcecdfe00, 0xf5c5de30, 0xf2f5df97, 0xd31e50d7, 
	0xe8fcbf0e, 0x5627f454, 0x1b5fde2f, 0x00cafea5, 0xed11b9c0, 0xc331d920, 
	0xf2a0ca76, 0x528fb43a, 0x843f710e, 0x74fa5beb, 0xc41b4d91, 0xf91db5b2, 
	0xd2df9b55, 0x63bd71ae, 0xbd813c43, 0x96a17da0, 0x9a82fdcf, 0xea3b58f6, 
	0x6f3dd6a5, 0xb3fd8abf, 0xeeed7da3, 0xd9db906e, 0xcd2c8edc, 0xf590f6e6, 
	0xc49ded9a, 0xd1da47e7, 0xbec4d60f, 0x9ff8f4f2, 0x3f66bf12, 0xfb8fd038, 
	0xc60decb0, 0xf7405da9, 0xaa1d846b, 0x93ec12bb, 0x9ef79f07, 0xa5e3e7da, 
	0x2960e40b, 0xefb88638, 0xa2e9e0f9, 0x8e0cfba8, 0x10bbdbab, 0x5fee6afe, 
	0xd8b4f768, 0xf5901371, 0x6e0fd02d, 0x5bf68ede, 0x436dc7bb, 0x07f36b9a, 
	0xc25cf8a2, 0xfb9b3357, 0x103dd78d, 0xedff442c, 0x3bb00d86, 0xd8577807, 
	0x4f50da27, 0x85fd18b4, 0xf9cae708, 0xb1bfde8c, 0xed8456d3, 0x7a8ba7e1, 
	0x3e077eb0, 0xc67fbe47, 0x7e3847b0, 0xab4e907b, 0x807e83e6, 0x3cb615f6, 
	0xa0d9cf6a, 0xafbf2117, 0x33fde66c, 0x07541997, 0x3f2116fc, 0xc7ccd1df, 
	0xc825855f, 0xe75ab68d, 0x5b6ef8eb, 0x7581897b, 0xf846ee78, 0x07ff04dd, 
	0x034de0cd, 0x0137b22d, 0x264e907d, 0x331d228b, 0xe3ada67d, 0x4c8b702e, 
	0x1dec879b, 0x1ff077da, 0x2f5ce5b4, 0x7ac9eb0c, 0xcd63d6e0, 0xf20f5c1e, 
	0x67d00f6f, 0xdfc3e00a, 0x92539096, 0xa3d39437, 0x7768a720, 0xa973f18f, 
	0x9253932f, 0x87a7293f, 0xca5f7612, 0x10ffc92b, 0x0d77ffd9, 0xc9b4e51d, 
	0xf2141d1e, 0xa72b1beb, 0x947b40c3, 0x3f03653f, 0x5e7923cf, 0xf41ee421, 
	0xe319f326, 0x198e8f10, 0xdda25fee, 0xb333c84e, 0x77bb3ca1, 0x0fa489b3, 
	0x4c9ce937, 0xb5679dcc, 0x08d61373, 0x3c85d679, 0x8e1e466b, 0xca59e527, 
	0x0ff289bf, 0x23e88ecd, 0xf3fbe0ef, 0x6f244310, 0x3927f526, 0x1ce42c5f, 
	0x270d69ea, 0xeafd451f, 0xb47d1e2c, 0xe333e40c, 0x3f02d186, 0xfe31b7c9, 
	0xbbaf2873, 0x7a879c2d, 0x70bb39d3, 0xe48bd23f, 0x1ee42c3b, 0x9bfecdc6, 
	0xc8a6ff1f, 0x99ef9161, 0xbae3f6cb, 0xc44ebf41, 0xf452cd75, 0x925d806b, 
	0x1624fce4, 0xe513b1aa, 0x08326ebd, 0x437fc59e, 0xe0af70be, 0x1bf3c774, 
	0x7f91dfe9, 0x1f563c56, 0xfa4ebf4b, 0x5dfea979, 0x81b17faa, 0xb0d1ec45, 
	0x3f90fbf0, 0x1d6205d6, 0x5a5fc265, 0xea11ec21, 0xf60dd2b1, 0x77fa1a50, 
	0x2831decc, 0xc25751ec, 0xea7f242f, 0x157f7845, 0xf84ca5d0, 0xfb16433b, 
	0x10e0fe84, 0x815e67be, 0x99fc94fa, 0xea4fe121, 0x48de17e8, 0x2bf481fe, 
	0xa49bcfe1, 0x19ec53cf, 0x842b63f9, 0xfd26141f, 0x469e3ded, 0x74ced3cd, 
	0xeb8aff09, 0x9f3849ef, 0x5fa487f4, 0x6fa5bce9, 0x43d8b332, 0xfd410fe9, 
	0xff33b259, 0x67dba9e3, 0x85949f81, 0x8fc5a8fe, 0xd28fb54a, 0xeed1512f, 
	0x36e81ca3, 0x8309f93b, 0xcf0bbd8a, 0x229b9a11, 0x2cf967c4, 0x85d67682, 
	0xd3ac027e, 0x708ee251, 0x1a98c54f, 0x5369e7e3, 0x7556df51, 0x43dd532a, 
	0x4d3487e8, 0xfe162f75, 0xfa87e803, 0xe4c54d63, 0x109fa067, 0xd209f84e, 
	0x4a9808af, 0x706df231, 0x7e4c5220, 0x8315fa01, 0x1a23f697, 0xfea11e4e, 
	0x24a541a1, 0x662d4e89, 0x88fce5e9, 0xb1b9ffb9, 0xff034ca4, 0x8942ed2e, 
	0xf1a6ca1f, 0x40094e0f, 0x0bcaff39, 0x57af1053, 0x54b079cd, 0xd5e04f4b, 
	0x41fb8ab5, 0xc2986fe4, 0x37f800df, 0x21d6f0ff, 0xf94bc1e4, 0x6ef7c11d, 
	0xcb347f24, 0x86af48cf, 0xfa839fd0, 0xa0e3f45c, 0x7f0f779c, 0x114dfc1e, 
	0x2b8d75f9, 0x55c27ef9, 0x1d42fdc6, 0xd35fc1fb, 0x75f9063d, 0x203fdc21, 
	0x71f077fc, 0xca1d61e6, 0x38c3ac46, 0x823ca2af, 0xe78bac7f, 0x5f80774d, 
	0x78d1650b, 0xea8be273, 0xaa95fd58, 0xdf4cbe9f, 0x90bfa028, 0xbd4f480f, 
	0xa43fd091, 0x3e84cc4f, 0x7c023d20, 0xf7aebd98, 0xe927c409, 0xf16f800d, 
	0x73b266a2, 0xf6220b59, 0xd16de008, 0x0d42c12d, 0xdcd7a536, 0xedd0a175, 
	0x60f87b44, 0x37942151, 0xe450bd6c, 0xedf8bb03, 0x8dde3e6a, 0x50986c8f, 
	0x3f15f506, 0xe224f5bc, 0x39997325, 0x35a8f901, 0x8fb8998d, 0x63f6045c, 
	0xac8fd83e, 0x1b0de319, 0xac6b71f0, 0x9cedcedf, 0x3969dede, 0x3976972f, 
	0xffb01eeb, 0xff1ec98b, 0x607dcf0c, 0x45a38775, 0x7e8edfd4, 0x89f3ea4a, 
	0x5b8c0f38, 0x36ed8e31, 0x1d424f80, 0x9fa87d0d, 0xd945fb42, 0xda1f50fb, 
	0xbc0bd0a3, 0x785fbef4, 0xce75875c, 0xcc72c49a, 0x80dcf045, 0x06ffd612, 
	0xd608b9c0, 0xfd437213, 0x3ccf2831, 0xe009a3b5, 0x887e83ab, 0x14eb39af, 
	0x237a06cd, 0x8fcfcf94, 0xca6c5eab, 0xbabe73c6, 0xd8b29a67, 0xe71750c7, 
	0xfce2757c, 0x9f86beb5, 0xf28ba6b7, 0x8fbe1a86, 0xde7b3ef6, 0x7b797083, 
	0xb9c4788e, 0x12d91e3c, 0x3c031e1e, 0x12a068d4, 0xe3ff1e00, 0x87285c47, 
	0xc2cf4cb5, 0xe82a84f3, 0xef4c7c87, 0xf3fdf007, 0x9d4fb21e, 0x3aa7defc, 
	0xd1d0df5f, 0x7dca7a41, 0x0153f39c, 0x34c29dca, 0xe803f237, 0x6fa402db, 
	0x9eb0c3e5, 0xb7d7c07e, 0xd06b76ef, 0xb5d622af, 0xb0271b3f, 0xd0540adb, 
	0x7b172187, 0x65fe0620, 0x767c3da5, 0x1bfb0bbf, 0x7bf18fb5, 0x8fedb58a, 
	0xa357ff43, 0x5f006c93, 0x26b4e6e5, 0x32b723b4, 0xfebe1273, 0x932fe01c, 
	0xe11109fb, 0x9fb87827, 0x84fc2f50, 0xf827ee7a, 0x2ab09f84, 0xac7827ee, 
	0xe11ae3f6, 0x9f892fc7, 0x46eee40f, 0x71f1afb8, 0x3aec013f, 0x3e35f5f1, 
	0xcb5fd7ee, 0x201f3a14, 0x5df30afb, 0x230af887, 0xb8592a5f, 0x01fc924f, 
	0xf6138fa3, 0x3ed59c69, 0x7615284d, 0x0f8720fe, 0x86fc86e4, 0xec8eadaf, 
	0x7a0f3b43, 0xbcf423de, 0xc995ca47, 0x71fe75ed, 0xf828ff28, 0xbde8fe06, 
	0x36f18650, 0xf715e3fa, 0xb426f8ff, 0x004da13f, 0xfbc0a0c7, 0xf12fc21e, 
	0x077dc549, 0x1e90d1de, 0xc8365030, 0x1fc0fdfb, 0x4d27c0b9, 0x123bbaa5, 
	0x6628d3c6, 0xb9019f3a, 0x39fb258f, 0x69188ee0, 0x26bc686b, 0xa34f87f4, 
	0xf826dabf, 0x15a9e61f, 0xd83e79e7, 0x117de248, 0xc84043c9, 0x43c84043, 
	0x2807909f, 0x5973071d, 0x4f3027c7, 0xcb61e819, 0x16f0d339, 0x878d2fae, 
	0x8ca3b24f, 0xc8f184fc, 0x82075f4f, 0xfd7abee1, 0x3505822f, 0xf78afeb0, 
	0xde001f81, 0xf1d103e5, 0x7dc3f728, 0xf62ca7a0, 0xde8ef800, 0xbac1726b, 
	0xdd0f2f10, 0xb876403a, 0xea017e6f, 0xff206f81, 0x3a1e7e20, 0xafdf1fb0, 
	0xefa3fcdc, 0xeb8a3fee, 0xbddb2f0b, 0xce67e903, 0x5ff38b7b, 0xcf586ef1, 
	0x8f0acfe4, 0x6bb578e3, 0x8afd0d14, 0xe3bdd84a, 0x97ad5879, 0x0bfda0e5, 
	0x065905b1, 0xe416ace0, 0xed0f18d8, 0xd3bb5583, 0x0a575341, 0xe6fa94f9, 
	0x912fb116, 0xfac3e565, 0x95cfc8b5, 0xa22b3d2e, 0x768a7d20, 0x4b8f386b, 
	0x7f604577, 0x3f31d55d, 0xb2a41910, 0x73f8c22f, 0xf78e3fc4, 0x81e02f93, 
	0xf245dfad, 0x1d89f8f3, 0x3d0a4fb8, 0xb8e3ebfe, 0x51f1c0dd, 0xdcf5c7ef, 
	0x7ab71193, 0xe825f05e, 0xee80cf89, 0xb5fcc0d7, 0xe76c949b, 0xc3971c6a, 
	0xd82d66f9, 0xdc04b6d0, 0x9d396a93, 0xd88adadb, 0xe7412196, 0x43ce82c3, 
	0xfec7fe82, 0x795de8fb, 0xf1ce98a6, 0xdf7ba2db, 0xb69f01f1, 0xaf66ffb5, 
	0xdaf2f40f, 0xe3bcef6d, 0x6ed6f983, 0x07cfb89f, 0xe01070f2, 0xeeb8032a, 
	0x73efb6ed, 0xdf7a5f82, 0xdf25fe8f, 0x69fde505, 0x495b0f20, 0xb67fbc6e, 
	0xe3de2cd1, 0x60693ebc, 0xe7c25feb, 0x5c76e7bd, 0x77d2f885, 0x84e1fcff, 
	0xceff7cfe, 0x6ef5fdf8, 0x8fdea3b4, 0xf7d0f3f9, 0xbce20323, 0xe86af493, 
	0xf9f9d424, 0x98ea3668, 0x5dfd7eb8, 0xbf558e53, 0x174cd6ce, 0xcc7991ea, 
	0xffbac1c8, 0xd8d923bd, 0x25977a4e, 0x8c20b0fc, 0x1eb8f583, 0xfce97986, 
	0xe1eb8471, 0xe74fc835, 0x07978e10, 0xcfd0b9e8, 0x475093a1, 0xf5c0333d, 
	0x6fb11ccc, 0xddb3550e, 0x4b2fc89d, 0x2ee89df4, 0xf7e1acce, 0x9cbc7329, 
	0x7856a1ee, 0xf5cbed8e, 0x2f78319d, 0xc776ccd4, 0x1050ce00, 0x6d7a83de, 
	0x7b7aca4f, 0xc2cdebe3, 0x42bb4af5, 0x3f75c3eb, 0xad2564ad, 0x5da1fa0b, 
	0x9ed1b841, 0xc0a4f6d7, 0x3ee02bdd, 0x52aee1c4, 0x1f68dd7d, 0x83f0ae42, 
	0xea58599d, 0xf2e76c77, 0xd83b78b9, 0x4a73ef07, 0xce7f389e, 0x4fbc7842, 
	0xc0b39d82, 0xd5a9e127, 0x073b24f4, 0xe2b2cecb, 0x7de7c259, 0xe68f3eae, 
	0x78f0e5ef, 0xeef8149f, 0xf01be0b4, 0xe5c35255, 0x242f952c, 0xa53e259e, 
	0x0d63fe1c, 0x1a9efb97, 0xdff7befe, 0xaaeaf952, 0xbd57c49d, 0xcf8e7e12, 
	0x09ca5dda, 0x45d33ebe, 0xe7593ef5, 0x99a0d5fc, 0x873c56d9, 0xf64fab60, 
	0xbf89d35b, 0x5fc8df08, 0xf6a11caf, 0xd60e30d9, 0x1c62af89, 0x20df5a0e, 
	0x57b7b7c7, 0xe3fe05d4, 0x7f55da74, 0xc3d2f082, 0x89f6d79f, 0xf5afe0ba, 
	0x28286d3f, 0xf8ac3905, 0xd7b276a7, 0x8d9ea00f, 0x457eb97d, 0x213ea314, 
	0xfa48347d, 0xc4322728, 0x27ed18e5, 0xb80fafd9, 0xdfdd633c, 0xde24f45e, 
	0xc359be03, 0x42421ae3, 0x9cbf418f, 0x9d84eef6, 0x09a1fd43, 0xfd09a1fd, 
	0x58fe81a1, 0x22fdcb5e, 0xfe703fa9, 0xf8c55ba3, 0xe1dfee30, 0x76e5ef7a, 
	0xc0fa09d2, 0x8bf929db, 0x9cfbdfe3, 0x37e70fa4, 0x6f845fc9, 0x4d73c3a4, 
	0x3e267849, 0x0a773c43, 0xf3f812be, 0x2cf0273e, 0xf0f80cf8, 0x9fb8db37, 
	0x7c8a22b9, 0x87f012fd, 0x677a22ff, 0x3d0f3f80, 0xc380f92f, 0x91fefa11, 
	0x577fab01, 0xdf9c19a7, 0x5e908edf, 0xe24cc399, 0xc0039203, 0x49330373, 
	0x43caa4af, 0xf9c3efdc, 0x7d7cc4fb, 0x3d083e09, 0xe02ee82f, 0xfcff7d0e, 
	0xf42fd580, 0x4cfd287e, 0x18e11b33, 0x6487dfc3, 0xf6bb873b, 0xc6c75815, 
	0xeed73f04, 0xf8e0eb90, 0x872c690e, 0x8442f1d6, 0x9ee12af0, 0x0eb499a3, 
	0x5b7fb709, 0xea43ad13, 0xce3fc24b, 0x5bf0a1f7, 0x0ef80a4f, 0x426f7a89, 
	0x5fbf899e, 0x24b57581, 0x8776b9f8, 0x57a09758, 0x6609e848, 0x3f063d80, 
	0x389861e2, 0x9fc12473, 0x96cf302a, 0x1fd52a62, 0xba13fee0, 0x699fe4fe, 
	0x43c39c8a, 0x1ce7c7e4, 0xa95a8268, 0xadbb26e1, 0x1e8593ea, 0xe3cb7bbb, 
	0xf902bf16, 0x75fe07d9, 0x6ba3b181, 0x7677f390, 0x2cffd92f, 0xcf910bf4, 
	0xa85fc0bb, 0xa036bfde, 0xdf773fa0, 0xb7d03bad, 0x5ec87f5c, 0x5ffee6e0, 
	0xc1e00176, 0xe5b9f7ff, 0xef027f6c, 0xb9e0ffe8, 0x783dfa0b, 0x3f6fe2ee, 
	0x02e51fb0, 0xb8f1f6fc, 0xa8eb91ff, 0x07772e7a, 0x28fd2542, 0xbf817fe9, 
	0x88fd1e3e, 0xff7e5aea, 0x74ad7211, 0xf55abfa3, 0x74038ddc, 0x9ef6f28f, 
	0xffbfb0c7, 0x789dd6ed, 0x8f8df00e, 0x4c2a4c2e, 0x685fb803, 0xf58d7f27, 
	0xaf9d08b1, 0xba805ea0, 0xba38ba7a, 0x7eec77a5, 0x60beac7e, 0xf037fbe7, 
	0xe66879fb, 0x785dd2fe, 0x54f1cd3f, 0x3b4a62e9, 0x77e5fff8, 0x7f46ed14, 
	0xf049f6ae, 0xf654c29b, 0xfcb646e1, 0x62761bb3, 0xa5c38e5c, 0x5700dd2b, 
	0xc3d72d66, 0xe873a7b5, 0x933cb71c, 0xfe801eed, 0xeed913e5, 0x9bf1663e, 
	0xd705366c, 0xc11ee30b, 0x374915f8, 0x856fd887, 0xdc46e74e, 0x6cccfcf0, 
	0x70ebee7e, 0x761678c9, 0x5fd710e4, 0x8f3c61ca, 0xcec370b8, 0x32dbf01e, 
	0x65bf5e60, 0x7604d0de, 0xfe862fa4, 0x00323b3b, 0x0f6804e5, 0x603ddb58, 
	0x27ef8177, 0x3d3f72d6, 0x56fe0254, 0xfa838f8c, 0x2baf91c9, 0xfac4dc91, 
	0xa66f512b, 0xd7c63fa1, 0xebe0ea1f, 0x162d3f47, 0x015bfee6, 0xb96a6bee, 
	0xebfb89fd, 0x53e86fdf, 0x36fc260f, 0xdbf26eb9, 0xada5dcf0, 0xd87add48, 
	0xafc2b7c2, 0x1d7dfab3, 0xbfdcbf07, 0xe058fb93, 0x1c045733, 0xee0ddbda, 
	0xf9137e57, 0xabf886ab, 0xe7f5e710, 0x7c0bff83, 0xb448fb75, 0xed51ce90, 
	0xb79c22b6, 0x7c07f119, 0xaf17fb77, 0xff60b914, 0x7ed1cdff, 0x3aaf073a, 
	0xe787dcd3, 0x026fd007, 0x227283f6, 0x26fd038e, 0xdfa13b94, 0x18985e7f, 
	0x51dfd280, 0x251583bc, 0x168febe8, 0xf1e0f909, 0xee25b588, 0xc9f00c2d, 
	0xf093a2f2, 0xb86b4ffd, 0xf1af605e, 0xb7f61775, 0xc03e24ec, 0x0fe926f3, 
	0x41f6250f, 0x2593f0aa, 0xbdf8e29e, 0xf12c5f84, 0xe3fd55f7, 0x34f9d210, 
	0x11593ff9, 0x48b557b0, 0x032a41df, 0xa8e83fb8, 0xe3287ce5, 0x891d2480, 
	0xe027777e, 0xefb48b6a, 0xbc3c079d, 0xbdd5ebb6, 0x0ec24736, 0x0cfe156e, 
	0xde87b14b, 0x36ff606d, 0x18f1f426, 0xec2c347b, 0x92477bd1, 0xf3d0defc, 
	0x7ae42fd2, 0x851f6e3e, 0x23ed2c1f, 0x16832ff9, 0x4fd8583f, 0xf6e3c7a9, 
	0xcfd81b73, 0xc63e8496, 0x0b3f4979, 0xdef4383f, 0x377f24f9, 0x23f0bcf4, 
	0x895f612f, 0xdd04078e, 0x39f82bfe, 0xd7c3f128, 0xef3f0639, 0xf0277b49, 
	0xc06479d2, 0xefd0cf8a, 0x3f401e5e, 0x8a9fee30, 0x1edc407d, 0xe24e3f0b, 
	0x847f1523, 0xa0e79c37, 0x5bf48fc0, 0x91f813df, 0x3f3ce8f8, 0xce1fc560, 
	0xa447dd6b, 0x57a127e2, 0xaf50df80, 0xc14a7a6c, 0x3bf285f3, 0x7dc11d7e, 
	0xb1536874, 0xf4243e92, 0x87d5bc2d, 0x632ce57a, 0x7baf784e, 0x62ff5928, 
	0xdf425adc, 0x4181919a, 0xa466b7d4, 0xb53e20cf, 0x4fdb3d09, 0xd380b5f2, 
	0xd0fb1541, 0x8a3ba0b4, 0xc163f67a, 0x2e3c6adf, 0x3d73f594, 0xa0c394cb, 
	0xcf50d227, 0x9b9b01ee, 0x26d367a2, 0xc03efeb0, 0xeb065a6b, 0xf5f2801f, 
	0xe69b3d14, 0x67a82331, 0x7f72d58f, 0x8cc4ad32, 0x89fd9ea0, 0x3e6ab3d0, 
	0xe5567ae3, 0xd3fc8bfa, 0xdb97b708, 0xa3f84d1f, 0x9e9368e0, 0x10ad7c26, 
	0xfa0fa97e, 0xb1ce299f, 0x76dcb8c7, 0xb6e5c63f, 0xb6e5cc3b, 0x89ffd61b, 
	0x76800f38, 0x5261e305, 0xe7ea35f5, 0xde84b2fc, 0x8566b666, 0x35ca10ec, 
	0x36e00de8, 0xf5c7dfda, 0x8cf425cd, 0x795fd3d4, 0xeff02e3f, 0x78e7594c, 
	0xcff2ceb1, 0x5d237672, 0x2ce1d543, 0x8fdaf3e4, 0xfa145873, 0x3be9e795, 
	0xe7cedf11, 0xe0077773, 0xdfe838f9, 0x247a7e82, 0xe5507b73, 0x7e13397e, 
	0xa1fbfa0a, 0xc296709a, 0x7398a5cf, 0xe9d7f72a, 0x7160f0dc, 0x587809d4, 
	0x67dccb1b, 0xe8a40cdb, 0x069f6879, 0xfc7fbae5, 0xf16ddf2c, 0x4f526ddb, 
	0x91f7eca7, 0x81e3237f, 0x451ce27e, 0xc428e715, 0x5ae780d7, 0x61bac7f0, 
	0x975190bf, 0xbb569bd0, 0x559c7e8f, 0xdd84866f, 0x3f2d45ff, 0xfdebfc77, 
	0xedbef33e, 0x278cce42, 0x7c8b3b18, 0x0ab37286, 0x97f717fc, 0x97720dc3, 
	0x744dde93, 0xea4bf821, 0x557c5f38, 0xff6b87f8, 0x7b2b7eab, 0xc5adf848, 
	0x76bf8011, 0xfb1d654a, 0xe8d5f03d, 0x07e476d5, 0x88dce83a, 0xbcfcd6f7, 
	0xd8b96e73, 0x2698b5bf, 0xb7547ffa, 0xd6e78bec, 0x87affe71, 0xd78470b2, 
	0x4b731f11, 0x6b73bc39, 0x9e7c7f78, 0x490f6d69, 0x817e603d, 0x76b8317e, 
	0x54fd0531, 0x6e78998d, 0x7e04ec3f, 0x2bce26fe, 0xe9fd2ee2, 0x8e66ff74, 
	0x86f7134e, 0xc021f22c, 0xabadab38, 0xc56503db, 0x311b91f0, 0x27ee72ee, 
	0x72fe29d3, 0xdd8d99ee, 0xb8d61de5, 0x2eebebcb, 0xd7297717, 0x3bbeba95, 
	0x72c27d05, 0xcc5d627d, 0x3ef07a54, 0x7e3aaee2, 0x46b732fe, 0x9871833f, 
	0x1c786b73, 0xc352dce6, 0x8d1af9de, 0x2efb7db7, 0x7e35af28, 0x398209db, 
	0xd0384777, 0x1feb8d99, 0x51cf68fc, 0x35e11234, 0x7318b3fb, 0xbe7ec5dd, 
	0x70e5d39b, 0xde04c4d7, 0x7e71d4d6, 0xf0ad7b9d, 0xd3d64d4f, 0xf7989459, 
	0x08e7c466, 0xed07ad91, 0xbdd2b419, 0x2511bcf1, 0x6ad3ef1f, 0xc0109cae, 
	0xf1c6c438, 0x4153ca3f, 0xbdb6c2fe, 0x3ef132ef, 0xdf9601d2, 0xf5877a83, 
	0x8f7e10e5, 0xba222e2e, 0x575baacf, 0x1af3f147, 0x379c2f3f, 0x31745a02, 
	0xc91d51c6, 0x59dff8a5, 0xe8985f30, 0xd5f78197, 0x4dac79e1, 0xfc1503ec, 
	0x686fac37, 0x860efbc3, 0x678425a9, 0xbc2dd13f, 0xbc71fa1c, 0x9a5f29d3, 
	0xc659cbd0, 0x379c0c92, 0xc722b9fc, 0x173b41c9, 0x9d45d0ae, 0xf6963bbc, 
	0xee0f4e59, 0x96d53407, 0x6c2bf781, 0x13a7a734, 0xf816d3e0, 0x727c21b6, 
	0x03e5ccbc, 0xd13f70db, 0x36d0f9f8, 0x2c657bb4, 0x953d454f, 0x76158936, 
	0x2b2abdd3, 0xe47ce2ec, 0xe99bfe40, 0xf708fdef, 0x87488043, 0xd8effd41, 
	0xbdf5876f, 0x1e9cc57f, 0x816567d4, 0x5ef097c1, 0xffb6ac37, 0x1b63df89, 
	0x7a11538e, 0x4a8679df, 0xebcc39c3, 0x4cfef869, 0x3b4b6536, 0x946d2f1f, 
	0x99a66230, 0x3b5d62b4, 0x0da9a546, 0x9ebfbdd0, 0xd3d7927e, 0xcf73f1cf, 
	0x39e9cfcc, 0xa76d1d73, 0x9538ebba, 0x5e5deb2c, 0xebc53acf, 0x3d7867d9, 
	0x5b4a187b, 0x1137b2de, 0x630cccce, 0x9008b19b, 0x8cceb5fe, 0x550f186a, 
	0xbdf6146d, 0xedb126f3, 0x00bdde78, 0xff7896eb, 0xe7e3ac7f, 0x3e082f29, 
	0xc5f20dff, 0x722718bd, 0x6f1c2df2, 0x5046c6a6, 0xff729d2e, 0x922a760c, 
	0xf747f1ce, 0xe3c001ca, 0xa10f481b, 0x45c33427, 0x837c09f2, 0xd3e2847e, 
	0x120f785c, 0xe2efbc4e, 0x0ba68571, 0xe65d5ef1, 0xe2e2957b, 0xcf1e74ca, 
	0x3de3e306, 0xf7bceeb5, 0xccf8053a, 0x3e78ed0f, 0x42b17614, 0xeac3d3f4, 
	0xef98e394, 0x6b09e120, 0xfc03b0ac, 0xf617b09b, 0x004e301d, 0x33f6656c, 
	0x17c82f1c, 0x2fbf3f01, 0x09d62139, 0x3b36550e, 0xa23fb89f, 0x047c82f5, 
	0x49bc785b, 0x99fbe340, 0x6662d186, 0xcbfec6ac, 0xb0ce11b2, 0x30e82fd8, 
	0x099be51c, 0x583a427e, 0x1afdf0e3, 0x20771973, 0x749e005e, 0x5ddecbe4, 
	0x8ec3ef14, 0x025afe50, 0xa2e28c8f, 0xd62ca866, 0xa6eb42d1, 0x2e313231, 
	0x273f8ca6, 0x31e44fff, 0x83e90efd, 0x48f67c72, 0x9d7f8304, 0xe7056135, 
	0xfadd585f, 0x83cbde16, 0xbdd3ab8f, 0xed9e94ff, 0x31a6a714, 0xa1d5e7c2, 
	0x1e63b7a7, 0xa70e6d9c, 0x0da1882b, 0x2fc92bf5, 0x40bc392c, 0xf149a3ca, 
	0x40eae195, 0x3cb7f21b, 0x3c1cd317, 0x52f917be, 0xc66405c4, 0xe4fe7316, 
	0xf585dd75, 0x3cc9d73f, 0x50ffa01e, 0xce906f82, 0x7aa7c403, 0x01ba49d6, 
	0xa906b337, 0x863fb3d4, 0x6661cd32, 0xb3a50f3e, 0x53fc846e, 0x8d116dc7, 
	0x0002edee, 0x739dd427, 0xc90a8502, 0xce93efb5, 0x87bfdc66, 0xc2caed77, 
	0xfa873f52, 0x7b86ac34, 0xba7a831e, 0xcbdf9c6a, 0xbb1bf2ed, 0x6facb09e, 
	0x964f5f06, 0xfde0a4da, 0xf00bc48b, 0xf01bada7, 0x7e3ff732, 0xc9e616fd, 
	0xfdc39e4c, 0x88c5475f, 0x8eed0e92, 0x3a6140ca, 0x3c9c3bb4, 0xcca2adce, 
	0xc5e945bf, 0xfa217f76, 0x1b6515cd, 0xf647ae28, 0x7e9ed0af, 0x0e34eb16, 
	0xa17e99f0, 0x9a6bdc49, 0xe30ba44a, 0x83334159, 0x5f23353f, 0xf214c7c4, 
	0xce1998f8, 0x3c1db129, 0xe310a4bf, 0xd274e3cc, 0xf8e3faf9, 0xc109eb90, 
	0x36507c7a, 0xd02eb28b, 0x5047f326, 0x754ad39e, 0x5df0275a, 0x35e024ee, 
	0x2de5b9ad, 0xce72373c, 0xe78ed9ee, 0xbe029546, 0xed3a05b4, 0x8785b547, 
	0x091c63b6, 0xc2f905e1, 0x810de627, 0xe7a41dfe, 0x5f2fc885, 0x9ab9ef86, 
	0xc18f7db9, 0xd3fd8af1, 0x485e7c13, 0xc60ca2fa, 0x43c7c15d, 0x0de1217d, 
	0xddb983ab, 0x1978d157, 0x869c79fb, 0xd8e5c45d, 0xe4ea0e28, 0xf43f94e7, 
	0x920c85ec, 0x5c39c1d7, 0x27e4c75e, 0xcc01fe60, 0x4fe044bb, 0x448910bf, 
	0x1ed960f7, 0x635f9289, 0x69cec844, 0x04f98286, 0x8f297e72, 0x1bb4067a, 
	0x16f93e9c, 0xede238fa, 0x3053af0c, 0x7c43c26e, 0x487baa5f, 0x23c3340e, 
	0x8313c2e4, 0xf817ad75, 0x62c3519d, 0x41431ee2, 0xf9ed035d, 0xb2e47bd6, 
	0xe71e5e1b, 0x433ce505, 0x5939bfc4, 0xbb4bdf94, 0x59f91e59, 0x03bec8ec, 
	0xef05af18, 0x4ddb79e3, 0x8afdcada, 0xf115c70f, 0x710165eb, 0x46e3ccff, 
	0x41b3766f, 0x919bc93b, 0x4c3939f7, 0xb8a8ff2c, 0xde7c4677, 0x71f5e9b2, 
	0x773a0718, 0xcc26f8b8, 0xeb761947, 0xf25f8e91, 0xb8bff021, 0xc4ab045f, 
	0xaf7958fb, 0x8623cf26, 0x59bff419, 0x2076c3e4, 0xd2f38cdd, 0xfe05de0f, 
	0xdf114cca, 0x2823a335, 0xacf3f8e3, 0x42e1167a, 0x56586f38, 0xb86fd0c5, 
	0x60b4e301, 0x14b7d7bd, 0xae35a1e1, 0x3f0920a3, 0xd8d1783a, 0xdbdf8cbf, 
	0xfeb888b7, 0x8c8e8be9, 0xb71078a7, 0xceb0f141, 0x8c3bd8ea, 0x8a56f8e4, 
	0xfc11bb6b, 0xeb7f110f, 0xcde7c6b1, 0x7eff7190, 0xe2833789, 0xbc456efb, 
	0x0a7d120e, 0x7e5f1046, 0x9519fc7d, 0xc33d2bce, 0xf3e7dd2a, 0xf3c41938, 
	0x01c74e62, 0xee3bef1e, 0xcc63ed24, 0x1a548371, 0xdf78e18f, 0x78faf4dc, 
	0x96a7e78e, 0xb1cf1e5e, 0x4bcbfba4, 0xc887f9e1, 0x40b764cf, 0xbf09148f, 
	0xa16ced10, 0x5476e1ee, 0x59e053ac, 0xf04ffdc2, 0xb52cfb9e, 0xf0073f8f, 
	0xc737b166, 0x721875f3, 0xebaeb41d, 0x7bb21efd, 0xd0f382ff, 0x714188f9, 
	0x7e23e693, 0xef2d83a2, 0xfdb0afe4, 0xc5094086, 0x123a4859, 0x7a0b167d, 
	0xae3a090c, 0xdf9ee3e0, 0x7b67618c, 0x04f7a1de, 0x302f09bd, 0x17c00dd5, 
	0x80d51f68, 0x2be22796, 0x32145f38, 0x4a8ab9d3, 0xcbe6bec3, 0xcc3e66f1, 
	0xc72e9ae3, 0x6805b19f, 0x2fc7c237, 0x79e21f6a, 0xebcf975b, 0x325d7993, 
	0x78f28fbf, 0x9e3c8856, 0xf3e79845, 0xf7cc1ce1, 0xb223fed3, 0xd78c3a67, 
	0xc5ecac34, 0x110fa13c, 0x261edc9f, 0xd796b3eb, 0xc3eacf29, 0x7ae4cfdf, 
	0x7a45962b, 0xb951102c, 0x3d70b49c, 0x3f66dcc6, 0x6f9961ea, 0xd59e44c5, 
	0x19183ef5, 0x3a3ef1f3, 0xcc0db8af, 0xd052687b, 0xffa5571f, 0xe00afc25, 
	0xcbca4299, 0x6df5c65c, 0x91b75da2, 0x3a676e1f, 0xee429d99, 0x3ea5a9c7, 
	0xfba977b2, 0xc29ef93f, 0x8f8c30a6, 0xe344fd01, 0x7189feca, 0xed379c79, 
	0x373f6913, 0x85f9ca25, 0x3ef8b5db, 0x777ff412, 0xd09e827a, 0xf1f28b6f, 
	0x4e577dd8, 0x6913fb80, 0x977de481, 0x1330d606, 0xc03723f8, 0x57e03ff7, 
	0x97b9f93a, 0x26f0c079, 0xb0e94df6, 0x4558cf17, 0x9acccdfd, 0xefb97f44, 
	0x8e3ae784, 0x3c3efa93, 0xa86b6c37, 0xed2ddb0c, 0xda1fc80a, 0x6a5f0907, 
	0x46abf729, 0x751d8c4b, 0x8dfaea26, 0xfa01d631, 0x3c6a8161, 0xdae5f42a, 
	0xc797d076, 0x92ce3f91, 0x9fa1b63e, 0x79e3669b, 0xffc7a75a, 0x9bfe8234, 
	0x2538c5b3, 0x64363df6, 0x945e7a53, 0xc4d2cbf0, 0xc046537d, 0x2717f6cd, 
	0x71c748e0, 0x50384f30, 0x14f63ea8, 0xda007f7e, 0xcbe44eef, 0x4efa5b3b, 
	0x539239e1, 0xf7853bef, 0x4cfd3306, 0x5c5ff991, 0x739cb22f, 0xf3915f7c, 
	0xb867df39, 0x313d928f, 0x755748dc, 0x71899195, 0xbbba1686, 0x2e59ee91, 
	0x997dc15d, 0xd2658aba, 0x56ec0cbe, 0xcbdf3f27, 0xf0b7be45, 0x5bd0ae5f, 
	0xabf5c60a, 0xcc1ccdab, 0x556d7227, 0x38f3b48e, 0xe66ed130, 0x58cc1ca2, 
	0x83ed8be8, 0x3f043af1, 0xcde7f5c8, 0x7e369b77, 0x0219188e, 0x66c8cdfc, 
	0x7e2c8fb1, 0x7fd0c7f4, 0x6b1fc935, 0xfd83fe42, 0xf847db35, 0xf7797fe7, 
	0x8cf7e8f6, 0x1ca2ba72, 0x6e5f5439, 0x338451f7, 0xcfee0cfc, 0x71cc722b, 
	0x577f018f, 0xbb070f8c, 0x55f813b3, 0xc71c1fd1, 0x9bbed3f5, 0x369fa22f, 
	0xe818b0f4, 0x861f7927, 0x2de21c7e, 0x6690156d, 0x753fb130, 0x6dd232ae, 
	0xabd2303e, 0x83cf0d0c, 0xf2edf035, 0xa72b1c5e, 0xf7c64fb8, 0xac283735, 
	0x86ce4255, 0xf7b47f44, 0xbc2258a0, 0xed479c3d, 0xa81be93a, 0xf4bb620f, 
	0x210f485f, 0x49010b5e, 0x99a36f40, 0xd34ebc89, 0x75bec26e, 0x2fef8043, 
	0x18f57de0, 0x23aaafdf, 0xd3ab8a06, 0xe5cfbc66, 0xf34a56c9, 0xa186da0e, 
	0x187cc65c, 0x98f3036f, 0xfcadafa4, 0x62a9e30f, 0x21ef80df, 0xe79ef8dc, 
	0x798f2e45, 0xe011bef0, 0x38a731fb, 0x44d74ad7, 0x0f2f183f, 0x3c5f35e4, 
	0xd87cf787, 0x19fc753f, 0x66d8be75, 0xd23fa71f, 0xa78c3177, 0x66a6e258, 
	0x9b63f9d4, 0x4da938cb, 0x8f4a676e, 0x0e96f5f1, 0x93d4faf0, 0xec953ebc, 
	0x87a0efa2, 0xccbfc5db, 0xe2a0fc1e, 0xa4af9d00, 0x07ca85da, 0xbd72f773, 
	0x3f6c67ac, 0xbe14fc8a, 0x62a8f90d, 0x6bbf91bc, 0xbe4fa134, 0xcf8a7c2a, 
	0x7feaf990, 0x01ad7c21, 0xe0634fb4, 0xe088a87b, 0x8574c56b, 0xe01eab11, 
	0x2119c0fb, 0x3c795ff0, 0xa281e502, 0xa7cd639f, 0xf295ff00, 0xe51c668d, 
	0xeb1a6bfe, 0xf2acff27, 0xca3f5fa1, 0xfb2375e3, 0xe1d36f91, 0xc7130efd, 
	0x8b937113, 0x4b75ffb8, 0xd0c791db, 0x7e8e5aef, 0x78968beb, 0x67ee52e4, 
	0xdc9ff3c5, 0xffc2f965, 0xe7ebe7ca, 0x37f09471, 0xbf285dee, 0x02f5e9be, 
	0xf14f2711, 0x1bf4979a, 0xe4af8c7a, 0xd82f0d6f, 0xb0faa030, 0xfe16e03e, 
	0x99e11b92, 0x6698fc2f, 0xff82afe1, 0x9cf88b93, 0xac7ee7ef, 0x1fea7986, 
	0x8b943f90, 0xb73e07eb, 0x7cd5dc61, 0x6147ccbf, 0x6d3f5639, 0xb6c59386, 
	0x023dfd8a, 0x3de2f384, 0x9ce59801, 0xce4fbe51, 0xd01b7d21, 0xc41f22dc, 
	0xd0f8803d, 0xa077dcf4, 0x88c54cff, 0xaf78001d, 0x2e7af4de, 0xaf9255fa, 
	0x3a4fbde0, 0x81d763bc, 0x33ce2969, 0x122b3d62, 0xebf091eb, 0x359cf760, 
	0x3ad07589, 0xe73a229f, 0x7ac4d57a, 0x791f3c74, 0x03d7cbe6, 0xce0e69fe, 
	0x4c1feb4b, 0x5762cfac, 0xe0eddf72, 0x39fb4b72, 0xcf18e40d, 0x0f77969b, 
	0xeb4f3fa0, 0xc6ed74e2, 0x221d61f1, 0xc1cb96ae, 0x3c556d35, 0xa73577ee, 
	0x5b4de607, 0x89aff6f3, 0xb20794e9, 0xdd572da4, 0x8d01ed8a, 0xc135a2f2, 
	0x4d3ff017, 0x3135df38, 0x0dfa0f80, 0x1e7904b7, 0x9f9e32f5, 0xc36f3c34, 
	0xc12f8740, 0x17886927, 0x4cd26fbc, 0xb09bef05, 0xc5d95f7d, 0xd9e0c6ec, 
	0xdd91affd, 0x3ef47d18, 0x3fefb6d8, 0x3ac0a99f, 0x389cf7aa, 0xd67d7686, 
	0x7085c338, 0x9430d9cf, 0x559bba03, 0xed0d4cba, 0x0f4bb55e, 0x559f4ec0, 
	0x2819629c, 0xefd05347, 0xb478a2ab, 0x9847bc74, 0x7677af93, 0x4f75231d, 
	0xeba52471, 0x02e67456, 0x280e27aa, 0x7d7a7f3c, 0x59c3e931, 0x18bb59df, 
	0x14e685cf, 0xe1fffbf2, 0x7ca4fabe, 0x4fcc9a89, 0xcedf2277, 0x3f5d81ee, 
	0xf67169f0, 0x4f94dde1, 0x3a4fedf2, 0x5a73ef11, 0xde21b7bb, 0xeb787e6a, 
	0xbb639231, 0x1bde1c6d, 0x28505f94, 0xc4e287cf, 0xdb4e31d3, 0xfdf0f316, 
	0x87ea016d, 0x8052a0d0, 0x8fe028f1, 0x8f5c6816, 0xb9fbac7a, 0x46e7df9a, 
	0xa645de70, 0xd17a3aa2, 0x44e5b52d, 0x6d459e61, 0x7cd26be7, 0xe7ae1718, 
	0xc52f5c60, 0xae9e239d, 0x04779466, 0xf9c38df3, 0xff1ec08a, 0x4ac7ee2b, 
	0x6b9c685a, 0xa064adbe, 0xdf29653d, 0xa67098ef, 0x65f7863e, 0x148eac37, 
	0x82df5f20, 0xd22f09f1, 0x519f69ea, 0x0f53feb1, 0x1ed5279e, 0x1a75b5bc, 
	0x66ff578c, 0xf5edf917, 0x99ec0fc7, 0xf358fc0e, 0xa67badcc, 0x6db55942, 
	0x785adef1, 0xd6e3b55e, 0x091db5bd, 0x2d4ea67d, 0xffc1f7a3, 0x2af3c56d, 
	0x4b603fd2, 0xb8f3d537, 0xec2f399a, 0xe7f11479, 0x1ef1f598, 0x9471573c, 
	0xfb8dbe0f, 0x615b59c0, 0xfa8f783d, 0x513b8f1c, 0xb9adc34b, 0x5b276443, 
	0xde5157f2, 0xc6f28456, 0xe0f6aea7, 0x4c2667f7, 0x4fd0c5f3, 0xb2545f53, 
	0x7bf31f6d, 0x67b7ca4c, 0x19e782aa, 0x91163635, 0xc28aa7df, 0x73d49f3f, 
	0x7aa5e8ff, 0xbfb03f9e, 0xcc0fe45e, 0x223c6533, 0xcb78439d, 0xdf358f4c, 
	0x024fee3f, 0xf5fdd35f, 0x7f415d0c, 0x68fb89c4, 0x0a49f746, 0x1bcf4fdd, 
	0xcff758f5, 0x7e51b2de, 0xf9e3ed3f, 0x5ec2156e, 0x7485eb0f, 0xfec3a07e, 
	0xdba0f30c, 0xecbdf9eb, 0xbf18fef0, 0xefc0d9cf, 0x62ae6a73, 0xe3dfdc4d, 
	0xa3c9d8fb, 0x7f411b7f, 0x23e8d271, 0x59473c11, 0xb9edcf5e, 0x9be069e3, 
	0x19ae783d, 0xfa869d6e, 0x81c6d379, 0x07d25e8e, 0x20d61f22, 0x79f320bb, 
	0x5c1f187d, 0x1c1fc963, 0xd8183268, 0xd7a14aa7, 0xd4501a6e, 0xa57ef0cd, 
	0x3ea26666, 0xf3cafd03, 0x31f55313, 0x368fb3cc, 0xaf0f3c48, 0x186ba5d8, 
	0xb7313e8f, 0xd47b5f77, 0x6fbc1eb2, 0x75cefe85, 0xe4e90b8a, 0xf1f1df94, 
	0x67577f26, 0x0b9f9066, 0x5de94479, 0x4b174c98, 0xe2845d9c, 0x9d245a0e, 
	0xe393a24c, 0xb409c0f6, 0x4c458eb3, 0xfa71dbc4, 0xba265ea1, 0x2b361ab5, 
	0x933532dd, 0xe0d396f2, 0x97fbac7d, 0xc2eed4e8, 0x5d2b397c, 0xb5d0a617, 
	0xc035d045, 0xc31ebae9, 0xf9f1ce0b, 0xf79879e9, 0xf00a2c73, 0x7f413b78, 
	0x1eb97aef, 0x598c2fee, 0x5ebe204f, 0x69dc776a, 0x37f7580c, 0x8c86658e, 
	0x3d63b47f, 0x9f28335b, 0x197cc553, 0xc223f09f, 0x3f40cf02, 0x6c54d07f, 
	0x634bae30, 0xc6032fd4, 0x372e75a5, 0xe61a9d69, 0x3f84b26d, 0xd979859d, 
	0xaf58a704, 0x01bc43f0, 0x75e16f51, 0xc1fa2f5c, 0x78fb3b8e, 0xe7c8857c, 
	0x1beb2c74, 0x4b6be6b0, 0xf5aa3b3a, 0x3b5bc608, 0x8c111896, 0x3d6dfec7, 
	0xf4968fbf, 0xbc1ab477, 0xc111b97d, 0xb3474403, 0x73be411e, 0xe43de104, 
	0x375c809b, 0xef43a7a7, 0x8f3a401b, 0x4666cb91, 0x31ba22eb, 0x82588f81, 
	0x8080ce3e, 0xc683d04f, 0xcc7df8c1, 0xd2f9823b, 0xc4fe8f11, 0xb1e2407e, 
	0xa0ae926e, 0x905570ff, 0x838ca9cb, 0x3cb336f3, 0xd707a70f, 0x87a6a51b, 
	0x8fce7beb, 0xbdf260f6, 0x4b0f9c75, 0x3a0fe918, 0x738964b7, 0xde87c960, 
	0xf59e40e6, 0x3a5bd2fc, 0x8f50df96, 0x5aeb8bbd, 0x623e3177, 0xc0579e22, 
	0x67d71255, 0xb3ea8bb6, 0x2f887814, 0x8f009c68, 0x947095e7, 0xbd043808, 
	0x1be355d3, 0x31405ce2, 0x9dfb4126, 0x79a47971, 0x4e6d7012, 0xffce6fe1, 
	0x4e5205ce, 0xa73bbf39, 0x109c528d, 0xf05babf1, 0xc3bf186f, 0x129f1265, 
	0x5d0506fe, 0xc96e0259, 0xce3f04d7, 0x5380a773, 0xce2fcf7c, 0xfc128bbf, 
	0x40b0fc4b, 0x6be0a7c8, 0x0ff31f9a, 0x2bd64fae, 0x6cbbf063, 0x1ddae294, 
	0xfc44ecad, 0x76f91c7e, 0xa7c49981, 0xe9ce9ae9, 0xd24de42d, 0x68334337, 
	0x48cf521d, 0x4f631dbe, 0x3ba64fae, 0x86f04bce, 0x68e1d793, 0xe8477a15, 
	0xd182c727, 0xfc973e64, 0x95f812ba, 0x47f49be3, 0x70e5c838, 0xa342facc, 
	0x68e6ef14, 0xac70f4e5, 0x5a21eb89, 0xb27d2a57, 0x9631fbf1, 0xe2bd4975, 
	0x5bb747bf, 0xd75f17e9, 0xe257c14a, 0x9f3832fb, 0x5e68af95, 0x235c1b8c, 
	0x12ef8bf4, 0x3e4ba6fc, 0xee9d04bf, 0x8ee3b649, 0x0758a665, 0x1de83f5f, 
	0xd23b2f49, 0x029f2e2f, 0x692f496e, 0x915ea427, 0x9bae4476, 0xe9f388e8, 
	0x5e925d62, 0x7fdb24f7, 0x01d1b2c7, 0x1c7577eb, 0x091f42ad, 0x0faea67a, 
	0x051ce2fc, 0xf43cffec, 0x6b197b77, 0xe8d99974, 0xb94705ef, 0x37cc1c5f, 
	0x0defd0b3, 0x5d1db3e6, 0x194f508b, 0xa81fb8d9, 0xed067d43, 0xef15ce73, 
	0x05f685c8, 0xa97ad7a8, 0x39f9e91f, 0x897cd7a8, 0xa205cabc, 0xfb81be7c, 
	0xb81bf345, 0x9455345f, 0xe78b7fde, 0x9f7c506b, 0x7f392fb7, 0x7893ea43, 
	0xc3c8869e, 0x327cf190, 0x879e261f, 0xbcf5e221, 0x1879c97d, 0xbfd2bf32, 
	0x7856fc06, 0x97389fdf, 0x4dfdc2c9, 0x1d9edbc5, 0x2fc1a7a8, 0xd323fda7, 
	0x673c2c8c, 0x74c9359d, 0x3f969e61, 0xbe3f787a, 0xee6a3b3f, 0xfcbe3f42, 
	0xfa077d82, 0x681e0de3, 0x5efdcadf, 0xdf1457ba, 0x88689cf5, 0x9bc8817d, 
	0x81e9ad9c, 0x4b8c644e, 0x1f364fe4, 0x1d957e2a, 0x48c8fcc2, 0xd7e5fa16, 
	0xf537e018, 0xca1e7c12, 0x8035049f, 0x30eba4fb, 0xf22c316e, 0x8fc18b2d, 
	0xd38ecf1a, 0x3a0201f7, 0x2b56039d, 0x8a9f6c66, 0x3bdd9879, 0x8622bec4, 
	0xd3e60afb, 0xf9fcd6dc, 0xc7d62f09, 0x328cf1ac, 0xffcf149f, 0x8b62014e, 
	0x1e82ccd2, 0xbe22bf71, 0x67ce208b, 0xf6078274, 0x5c4fb427, 0x23bfc0df, 
	0x1b9efb04, 0xbf23df71, 0x798d526f, 0xc7848395, 0x6fc44ebc, 0x263eed74, 
	0xf38045fd, 0x2a0f307a, 0xefc6e3ac, 0xf8fc3d00, 0xefc3923d, 0x8e3676f0, 
	0xecec5fe2, 0x56cefcb8, 0x2469c794, 0xdf5e81e5, 0xe705fe76, 0x04fbc8a0, 
	0x71bed5bc, 0x5b062f7e, 0x7df03614, 0xaddfc540, 0x758217d8, 0x4cbe7654, 
	0x2e956df9, 0x4dcaef4e, 0xbf183943, 0xbfc82670, 0xf993e907, 0x06bbe2ef, 
	0xdf1149ea, 0x3ee79297, 0xfc87a5bc, 0xe8bf3c4d, 0xaa791230, 0xad8f1895, 
	0x6659bc00, 0x69eb09b6, 0x6f68a358, 0xb1ef30fa, 0x15a2e767, 0xb3dcbf98, 
	0x353c0753, 0x63eccd78, 0xfd085ed8, 0x9f589e40, 0x95e703b1, 0xec0d03f9, 
	0xa0376f28, 0x3f9b18dd, 0xf786e0d0, 0x99a5e23f, 0xf228fc06, 0xc65d2a07, 
	0xc37f38b5, 0xc5ae15a9, 0x5a6cbc43, 0x1e5ced8c, 0x7eebee6b, 0x502a760c, 
	0xe385d89e, 0x1158ed55, 0xb94bf5c0, 0x0d8214da, 0xfc4b3adc, 0xf853c89b, 
	0x2a0f47c6, 0x5fc06e20, 0x869bed06, 0x79495563, 0xfc77e506, 0x61f29f3a, 
	0xf1bb99c7, 0x15bf787b, 0xda0348fe, 0x478a41cd, 0x3ff1471d, 0xf0fa1b25, 
	0x579511fb, 0x765f3a32, 0xc6aa7c88, 0xe1f63617, 0x3f6e2177, 0xdc5de7bb, 
	0xb3fe22b7, 0xe21c9ca1, 0x9f32a27a, 0xbe27cbd3, 0xf3d2b12b, 0x4942bece, 
	0x4e5f159f, 0x1ebfd81f, 0x006ef9c7, 0x894a39fc, 0xf062f38f, 0xb9d3cd5e, 
	0xfe1ef03b, 0x8fbf20bd, 0xaec55ff0, 0xe4dd7dc5, 0xe6ef3fd1, 0x762f9ffb, 
	0xe3f72cc7, 0x5ef02fc4, 0xf627d3e3, 0x4f8a7eb2, 0x5c0bc9fd, 0x9d6f168f, 
	0xb57ce974, 0x7c7035df, 0xfee0689c, 0xc98ff794, 0xbfe2ce7a, 0xad1ebcf0, 
	0xa7ef293f, 0x027820ae, 0xb31d63ed, 0x8a35fcc9, 0x19a79e8f, 0xa3279f3c, 
	0x83d56dd9, 0x4ee19acd, 0xd9b24bca, 0x333e7da8, 0xfca758dd, 0x8fe79c25, 
	0xbb527a29, 0xf3df9490, 0xafbb5e38, 0x7007f313, 0xffb720fe, 0x5bddbc7d, 
	0x91d72fd1, 0x5f176c93, 0x97f185db, 0x3724fc96, 0x441437b6, 0x1bdae293, 
	0xa9375934, 0xcf4d2afd, 0xc927e6b5, 0x1eb97638, 0x3f827710, 0x840bbd75, 
	0xf3eb96fe, 0xca485c56, 0x29e78ceb, 0x5d7c60b1, 0x50d9e798, 0x9c524af0, 
	0xea26837b, 0xd240de22, 0xdcdaa1b3, 0x8686fb85, 0xdc4ec625, 0xe06eac27, 
	0x73a48cfe, 0x473c2b43, 0x76372f7c, 0xcd9d70c6, 0x57dc2ee6, 0x3de10434, 
	0x20375fe8, 0xdd393cf3, 0x9d64461a, 0x5fca45e3, 0x5db83350, 0xb8a11b3b, 
	0x46679974, 0xe8598eeb, 0xcde22031, 0x461a1d05, 0x8fac5d44, 0x95f3f215, 
	0x1c654eaa, 0x765993ea, 0x7bea38fd, 0xbea53fa9, 0x71507c6d, 0xd27dfe31, 
	0x44ca7d24, 0xabd4829c, 0x09c397a4, 0xeef78afd, 0xc80fc906, 0x7d091bc1, 
	0xc57af52b, 0xe2efb5fa, 0x10d2cb79, 0x9f52bfd7, 0xe3fc3e57, 0xd8de7c7c, 
	0x58297871, 0xfd18d656, 0xaab1e294, 0x6b752a8c, 0x9939c02f, 0xe8c6afdb, 
	0x49781dda, 0xed65bd56, 0xeab79471, 0x28e69f2d, 0xfaafb411, 0x636bc40e, 
	0x1bbc7ebe, 0x6fde58a0, 0x417ea173, 0x74f183bd, 0xebeb2a8d, 0x341b9cb0, 
	0xb96ea13a, 0x7a646a87, 0xccadfb52, 0x33f7e170, 0x7fa0a31a, 0xe38c5fb0, 
	0xc551c713, 0xe3e3067b, 0x70bfe358, 0x657b6b1c, 0x260fcc16, 0xfd5771b8, 
	0x6a273c31, 0x863c1a3c, 0xef783dfb, 0xd43f5258, 0xf563451f, 0x6faa9d46, 
	0x127d06e8, 0xbbc38574, 0xd964b1b3, 0x9cd82e3c, 0xfc015c6e, 0x45e6567b, 
	0x45e8bf08, 0x7eb83fa9, 0xd713fc90, 0x527e4207, 0x03ea43e5, 0xdf9159ef, 
	0x45fee520, 0x722c07a1, 0x9beafa8f, 0x79c9e7c0, 0x4fae42b9, 0x014e3cca, 
	0x92470bcf, 0x3f18c0f4, 0x789e052d, 0x9149c59e, 0x78e129c7, 0x7b1f3921, 
	0xcb3c6a81, 0x9e6db3bf, 0xf87e89df, 0xe37d7115, 0xc0c779c6, 0x6fa29035, 
	0x4ebcc9ce, 0xbc37fa9d, 0x19f69e74, 0x6dd335f3, 0x866ce7cd, 0xc42e08f1, 
	0xcf45a0df, 0xe09bb808, 0x79bd24fd, 0x6e2fd085, 0x798d3e7e, 0x05faa99d, 
	0x9ce1b4e5, 0x78d4efc8, 0xf71f9a3f, 0x24fece7d, 0xff465dfa, 0x3cea3ad3, 
	0xe53ca4b6, 0xbcf173ba, 0xba27d24e, 0x3b56dcc6, 0xf52ce920, 0x528bd4a6, 
	0xc43a48af, 0x90bce3d7, 0x1db8ff44, 0x4f5e4c28, 0x9498279d, 0x4e775ca7, 
	0x7b4909e4, 0xf3c9b1e0, 0xda8bdc80, 0xf9937783, 0x8176c1a4, 0x8de0d1e8, 
	0x13bde526, 0x5cfa16dc, 0xc875e305, 0xf25a0e75, 0xbbf4269b, 0xfb89f4ad, 
	0x38a09eff, 0x7bf0e04f, 0x2be64ddf, 0xf380379a, 0x1f9492be, 0x956fca9f, 
	0x9e37ff42, 0x8f7ca62a, 0xbe953bc6, 0xbfdc83ba, 0xf298bcc1, 0x0bb17ecf, 
	0xf52d8fbf, 0x4f83c34f, 0xb379e165, 0x7529f84f, 0xe30c39a3, 0xf7c41a02, 
	0x8cf3ca98, 0x57a0039d, 0xd81d572b, 0xbfb83019, 0x4c7e2cc3, 0x69fb97a5, 
	0xef762f95, 0xff09616c, 0x62a5f1a1, 0xc8008ff2, 0xbf4f789d, 0x2777b3d2, 
	0x7ea92dfa, 0x270bdd4f, 0x425c61f6, 0x1de3ffaa, 0x5f5de789, 0xf426df9c, 
	0xd555e527, 0x5603fd69, 0xa2d9d63a, 0x8bb95603, 0x7f8119eb, 0x9a4d6fc9, 
	0xafca4eee, 0xa4877e12, 0xce19c91f, 0x5ee42237, 0x0b84dbf2, 0x7555f949, 
	0x2b0185da, 0xaf6ceafd, 0x2de5580c, 0xe65f4e95, 0xacb7f9df, 0xefdf89dd, 
	0xd3b2bb06, 0xedb1847d, 0x7f230fc2, 0x99d9256f, 0x017da19f, 0xbe176f7f, 
	0xaedffe07, 0x1ec2c5ce, 0x80dbbf81, 0xb0b4ee76, 0xa1d90a57, 0x2457989d, 
	0xfef2d2ed, 0x834be528, 0xe619fa5d, 0x5b0add21, 0xfd97dc75, 0x71a976b5, 
	0x6f6e46cf, 0xbf8f8e0c, 0x03fd1eda, 0x9be023d8, 0x7e3d0b1f, 0x17e4bb29, 
	0x7cc6f5fb, 0x6eb1f293, 0xb6cb943f, 0x4f9b18ac, 0x7c8978da, 0x7e211dd2, 
	0xe6d7fb4e, 0x3e7e3693, 0x4f9adbb4, 0xb721775a, 0xb3f8599c, 0x915c85e1, 
	0x71f3ca4f, 0x92960694, 0x0bb03a4f, 0xed67cfef, 0xcf1b397f, 0x1cf14a31, 
	0xcdee27c3, 0x0ce6de40, 0x5ca0e50c, 0x36465d06, 0xbe4e7bd2, 0xf101e1a9, 
	0x1de2d294, 0xe51cf8b9, 0xf3ee98b3, 0xe86bf434, 0x37d60ede, 0xdf42a4f1, 
	0x39fba23b, 0x00ca6718, 0xc39429c8, 0x78f7c985, 0x22b89f74, 0xbf176f71, 
	0x12f3c457, 0x4227dc4d, 0x4bdf7e5d, 0x3f483f9e, 0x92ffd52c, 0x3bcd52fe, 
	0x3c7f287b, 0xdf92ffd5, 0x99fe9283, 0xefcbafdc, 0xd93ccd37, 0x9a12a064, 
	0x2f7e2ab0, 0x1b728798, 0xc4f2541a, 0xc69e60bd, 0x8fc965e3, 0xa152799b, 
	0xbe26617b, 0xdcfb5483, 0xbe907789, 0xee8532d7, 0x298feb05, 0x720e78f9, 
	0x9417b89d, 0xcbec1dfe, 0x4afd588f, 0xb357df79, 0x6b9e7ce3, 0x43abec33, 
	0xfa403cfc, 0x6e78d585, 0x80b9e0a2, 0xeefe26f1, 0xc009c503, 0xabde20f3, 
	0x91b9d20d, 0x686fbfc2, 0x52ffbed2, 0x734d6bf7, 0xcce6fcb9, 0xffc3fbe5, 
	0xff89f62b, 0x86d7eebf, 0x6afd7217, 0x3ac93a6e, 0x51fb896c, 0xef407fa9, 
	0x842bdc44, 0xbe3c021e, 0xd9df1215, 0xbe367bc7, 0x0e3d24bf, 0x6ca766fa, 
	0x68677eb7, 0x8f1bea0e, 0x7d5b3f38, 0x87657de9, 0xa23dc3c0, 0x4f5fac4c, 
	0xbcdac7b9, 0x22fcf48b, 0x9f8e0f89, 0xda01cde0, 0x79750657, 0x14f1ccbe, 
	0xa7b88fc7, 0xf2f5e792, 0x4be255dc, 0x398f279e, 0x93f89577, 0x048bf9e7, 
	0x693e04fe, 0x2bce00de, 0x812f93ce, 0x97edef57, 0xeb1397ba, 0x7e76c9f1, 
	0x59bc1b2e, 0xf5f31f9e, 0x8dfdc507, 0x8975573c, 0x3f8249f3, 0xa49f389c, 
	0x6258fdf3, 0x3a7bf17d, 0x7eb93eb1, 0xe5a3f097, 0xf6f780bd, 0x89f13e14, 
	0x3d9738ba, 0xccfbe21d, 0x7ce2cde0, 0x2823e059, 0x5d2483ee, 0xed06d583, 
	0x4c4b832f, 0xccd65fda, 0x065fde4d, 0x5fda4d5b, 0xb49b9706, 0x1b360cbf, 
	0x060cbfb4, 0xce5fda0d, 0xb7be4b29, 0xc8fbfa0a, 0xeefc92af, 0xcf4e74d0, 
	0xdeb1436a, 0x633ad15b, 0x7df27ef8, 0x181fbd15, 0xb8a08f4b, 0xfb8972bf, 
	0x47c0a0ab, 0xcf179cfc, 0xbf6f8185, 0xb5e7973f, 0x407de506, 0xe00fbcb5, 
	0xf24379f0, 0xe9d38afe, 0xef9373eb, 0xa19a9caf, 0x25fdcf58, 0x92ff12bc, 
	0x716ade1e, 0x3def2e0e, 0xc0bef9e5, 0xc61fe133, 0xa597399d, 0xff0463ec, 
	0x959e59f8, 0x57f7125f, 0x88be9266, 0x7f7293c3, 0xf5e7f125, 0x95a3dca7, 
	0xb8a7df24, 0xf6202354, 0x5db64773, 0x29d7c491, 0xedafb3f7, 0x9fd93f24, 
	0x27368f7c, 0xdf93e524, 0xfbc1cd67, 0x16d7c923, 0x29fbcaba, 0xcb41df92, 
	0x5b8088fd, 0xfefc6df2, 0xfbe4f6ea, 0xf93faf56, 0x484e647e, 0xcfb8a7c8, 
	0x2efb79a2, 0xbc97a722, 0x6e78173f, 0xc13cf7e1, 0x7075f125, 0xdf250cf9, 
	0xfeea5d63, 0x06b7ee9c, 0xf2467a13, 0x7a83a485, 0x8473fb99, 0xac44b837, 
	0x285fca43, 0x0c6adef9, 0x5dbe4b9f, 0xdf96f922, 0x3732be33, 0xac4b1ef5, 
	0xd3df9caf, 0x2e9c8305, 0xc5c6a5c1, 0xbd84e7ef, 0x7490eb91, 0xb153eb8a, 
	0xb97df8ee, 0xc112d75c, 0xb19ef2e7, 0x389d793c, 0xc16e95af, 0x3cf2c9a5, 
	0xf852ff86, 0x5a7acc7e, 0x3e853d25, 0x167de5d1, 0x9de803c7, 0x55fba481, 
	0xfe021f29, 0xb8aefdf8, 0x9bf29547, 0xef2acf7a, 0x4fc8c7cd, 0xd49f58ab, 
	0xcfb8ba47, 0x060feb12, 0x7c153e85, 0xb63eba99, 0x6be39f8c, 0x3d5fce22, 
	0xdfa15d38, 0xd2777219, 0xbae98cbe, 0xaa66f182, 0xf7e17006, 0x2e3cddf7, 
	0x667c1338, 0x9477f73c, 0xdcf046f6, 0x6c36e6c9, 0x36a77be2, 0x71e23ff4, 
	0x5183a5f8, 0x7cfa776c, 0xd20eb65b, 0xf1fa1477, 0xeb866d77, 0x1dfed980, 
	0xf3716bde, 0x8700e93c, 0xff3cf1c3, 0x165aa1de, 0xfc43864e, 0xdc5b8bee, 
	0x4cd5b0c3, 0xd02f7ca1, 0x4b8317d7, 0x5c3cbf2d, 0x5701728e, 0xa615c019, 
	0x88fed8fb, 0x017022fb, 0x3bc20dbf, 0x71e3278e, 0xf7388ae3, 0x7a2cbca3, 
	0x7233f16e, 0xc2ff71e7, 0x8eff8f35, 0xc8876388, 0x51616ebb, 0x8cd72b8a, 
	0xe689e608, 0x8e7ee3cf, 0x26f7c76c, 0xf2243d62, 0xf81fb1a5, 0xb8f379f9, 
	0xcc7f611c, 0x233c71a7, 0x328e33e2, 0xf5f0f305, 0x53eff179, 0x12c27e6c, 
	0xce9d5b9f, 0xa643dfa2, 0xdf911974, 0xa31ab820, 0x3a7355df, 0xd9eff7e5, 
	0x193bf114, 0xe4ef3e53, 0xb9fb8bfc, 0x87fdf174, 0xd43ac42b, 0xbb878045, 
	0x94ddd4a1, 0x8fba9fd7, 0xa5df134e, 0xf825de87, 0x92f4d33e, 0x9abbc518, 
	0x065f9825, 0x857aa2d4, 0x7f9b4f18, 0x75d234f2, 0x3608005b, 0x57b89974, 
	0xbdc51777, 0x4b937bca, 0xfe52bdc5, 0x0763e028, 0x2adf6ed0, 0x534276c6, 
	0xe7821cfe, 0x277f9c7d, 0xe19fe406, 0x6d9d0479, 0x70530fc4, 0x4f82ddfe, 
	0xcefe6376, 0x51c0cbea, 0xf3bfc5d8, 0x387972d9, 0xd6037c70, 0xf72e6e37, 
	0xfbd7b35b, 0xd747dc15, 0xa4a554bd, 0xd95d5ca3, 0xe85ae4a7, 0xd753650f, 
	0x031dfa0a, 0x051f2925, 0x75d9d4e8, 0x59d3dfb1, 0x700ec4ac, 0x3a3c403e, 
	0xfa4faf8f, 0x8fe21d3d, 0x8d7df473, 0x8d7df4f5, 0xceaefd4b, 0xe1e79b94, 
	0xfc541377, 0xa21ec26e, 0xa0c77d13, 0x0dffe517, 0xe29d2b14, 0xa11ca5f4, 
	0x5bf7595c, 0xddbc4f24, 0x70d4fdc4, 0x477eff01, 0x45077be2, 0xeb2a3bf4, 
	0xff516576, 0xf4e965a9, 0x53a9835d, 0xa577e9eb, 0x3bbacea6, 0xff52bbfe, 
	0xdf7e08f9, 0xf6799ee0, 0x7df62ffb, 0x602bf003, 0xfabd5371, 0x63e6bb2f, 
	0x304fbfc9, 0x2eb065d5, 0xe5a9f790, 0x803b69bd, 0xf486a76f, 0xc53f3cc3, 
	0x03fadfac, 0x37aa63f0, 0xbd7cf046, 0xe7fbcae6, 0x95fb7c61, 0xe91e4881, 
	0x5275ef91, 0xcf69ddbc, 0xff70fb2d, 0x01d7ef2b, 0xcc375e4f, 0x8bafecf7, 
	0xe83e79f9, 0x699be439, 0x9e2e48fe, 0xf02c3c87, 0xbf113ffd, 0xf93c7167, 
	0xc223011d, 0xecc023bf, 0xd01d1f94, 0x28f9acdb, 0x7e65ebce, 0xeb0fe032, 
	0xef281bad, 0x3e1ce315, 0x2e7e7a47, 0x53d033fc, 0xdb733794, 0xcf9f9106, 
	0x8013cc54, 0x2a71ea7e, 0x5e5de399, 0xfede64bf, 0xfb4f5e39, 0x7af2823c, 
	0x95660ed0, 0x83fd47ed, 0xaf375df9, 0x864f157e, 0xb5196e32, 0xfc55de23, 
	0xfdfe4c3d, 0x5fb476a9, 0x3e0fa869, 0x3c05efc0, 0x13f22ed0, 0x7dfde3e7, 
	0xb60ed7c6, 0x333ebee3, 0xec97cb8b, 0xcc659d97, 0x76876aef, 0x924fbbf1, 
	0x8f30ff6e, 0x64b28ffb, 0x15d3bfa9, 0xb0f9413e, 0x77e223bd, 0x55730b11, 
	0x56fe3f6c, 0xa6bbc0ae, 0x0ba77f58, 0xbc28eded, 0x7ce46beb, 0x75efe4cd, 
	0xd7bfc999, 0x7d92f005, 0x15fa16d2, 0x1cd717cc, 0xbec25bfa, 0xa1f918fd, 
	0x8897cae6, 0xd635a60f, 0x043a07e7, 0x03fc71fd, 0x057bf49d, 0x1cd03e71, 
	0x9d8f7bf4, 0xf945d967, 0x3e097fe0, 0x3a5ff490, 0x2a7c9e0f, 0xa56500f8, 
	0xb335e784, 0x40e78042, 0x7d561fc2, 0x519f29ac, 0x5c0a721e, 0xfcc3cc6f, 
	0x3d703186, 0x0e34f9c1, 0x3f88c997, 0x71f25f0b, 0x75c0a63c, 0x89fc72e2, 
	0x6b7c8970, 0xfbf92867, 0x793cf115, 0x467dc455, 0xf46e6d03, 0xdc453a83, 
	0xa3a83ed5, 0xfdc3d0df, 0x9c8d9988, 0x0367ceae, 0x3baae86d, 0x65e06d0f, 
	0x85df28bf, 0xf3a74c12, 0xe91f5143, 0xca7bbaa3, 0x675c46cc, 0xa1f8005a, 
	0xd003f508, 0x15e9236d, 0xcb8e33c2, 0xf8530df3, 0x881fc365, 0xa37f565f, 
	0xaefd2be4, 0xc90fe49b, 0x792bb62f, 0x7dfca19e, 0x4d65a9b7, 0xa9379e0a, 
	0x46dfb760, 0xf28c65a1, 0xef2fe14d, 0x9e2e291c, 0xc3765c7f, 0x94194f46, 
	0x34ff0bd5, 0x5223bf0f, 0xf0466192, 0x796a6a7c, 0xe39e2b71, 0xf4599d4c, 
	0xedeefd36, 0xd185eca5, 0x90f295f9, 0x8aa677e5, 0x5277f91b, 0x5e5b7fd8, 
	0xdbe13167, 0x71423339, 0x942a33e1, 0xb3af309b, 0x367852f8, 0x8f9e134f, 
	0xf915284d, 0x4b927ece, 0xe64ba74f, 0xcf145f3f, 0x032efc71, 0xf0250efc, 
	0x660fbd7b, 0x276134fa, 0x7b215da4, 0xd84b09f2, 0xbf914313, 0x01f541a3, 
	0xb4a64f01, 0xb23105c7, 0x3f0b4a2b, 0xe46b4f97, 0x5cfccdfc, 0x5617aabe, 
	0x80fbb236, 0x11139e3e, 0xb27e87a4, 0xfce38dd1, 0xfa468bf9, 0x71ab809d, 
	0x6cdc339c, 0xcd63ce81, 0xbf504928, 0x8354171a, 0x5ec70ff4, 0x6a5f74e3, 
	0x38f3683a, 0x3971d470, 0x1fb8c6ba, 0xbbf925f0, 0xa4d7d740, 0x3904ea3d, 
	0x1778c6cf, 0x7ff79bd4, 0x2cff21ac, 0x112ef412, 0xffd9f571, 0xebad75e7, 
	0x4ce39434, 0x989edbad, 0x46cd4a6f, 0x7e43d945, 0x21177d29, 0x4fefb4ab, 
	0x57c25eb1, 0xbf45a757, 0xa039c438, 0xc2ee1a5a, 0x319a23df, 0x6c5c5189, 
	0x532fb0b6, 0x8c2ef44b, 0x91bc7ddf, 0xe2a8edc7, 0xa255c51c, 0xf6586477, 
	0xeb10ae35, 0x779cb0c8, 0x338f3a29, 0x820fe78b, 0x4b7dc1de, 0x927eca69, 
	0x1c3163f6, 0xee07436f, 0x40a15d1f, 0xe5bf7587, 0x4e427113, 0xc2d93fc1, 
	0xfe7ea88e, 0xfea9d7bb, 0x1e46a1e4, 0x98d8abcf, 0x504c0ce7, 0x170bce22, 
	0xd6eab9e9, 0x6395ea62, 0xcb2ef3cd, 0xc007f9e3, 0xa5b92dfa, 0xfc8b9ed4, 
	0x8dc97d38, 0x7777e36f, 0xc30b7ce5, 0xc4179485, 0x57b8f7f0, 0xb1f55c60, 
	0x76ffd41c, 0xd2efcba6, 0x8d971e50, 0xa7de500d, 0xe749bd83, 0xee8ceabd, 
	0x4d3bf8dd, 0x00e79825, 0xd5eae07a, 0xc1d12f30, 0x11e6b6ed, 0xefa11631, 
	0xf88f9824, 0x289e77e4, 0x6dcf0bcf, 0xbe92f14f, 0x34f8a377, 0x69b183ca, 
	0x73ce1646, 0xd9f503e5, 0x995e787e, 0xa8bce7a6, 0xf950f426, 0x7f265f77, 
	0x49eb9589, 0xcf785cf9, 0xb4cae3c9, 0xa6579e5c, 0x6d3cf2e7, 0x62a4ddfe, 
	0x8c0dcc0d, 0xc6f3365f, 0xf037083d, 0xc798f5d1, 0xf93bcb63, 0x65efb40b, 
	0xaeb38bb5, 0xbe7b3e00, 0x97379f91, 0xe2f6cbba, 0x125ab3f9, 0x61f7413b, 
	0x7f6831df, 0x61f7136f, 0xd4ee5f92, 0x4d45eff9, 0xf1270cd0, 0x81ccd3c1, 
	0xc411307c, 0x1c60f90c, 0x07c81dd3, 0xcbdca97f, 0x5bb0d8fd, 0x4b47eefc, 
	0x84d1998c, 0x0dfa001e, 0x7377fcf3, 0x8cc9f6f1, 0xc77e16cd, 0xe19e0243, 
	0xc124f4ef, 0x35effd3b, 0x04a3f913, 0x1c5288de, 0x86f7f25e, 0x84f265d8, 
	0x1f0df38f, 0xe91577e5, 0x89923cfc, 0xcfd43eb8, 0xc74e50c3, 0x98dbd15f, 
	0x5855fdf8, 0x5409d347, 0xe08b1a14, 0xffa6adf7, 0xfbb51d47, 0xda5abb44, 
	0x81bbdf4b, 0xd3a4517d, 0x28e51f12, 0xbdf629f5, 0xe5045f34, 0x2cf5f999, 
	0x5365ebb4, 0xe80c48f4, 0xf6174136, 0xd5e39c56, 0x67b15b03, 0x0f748f09, 
	0xfb5ea8e0, 0x43afa433, 0x680855c8, 0xc96d7a82, 0x80530e68, 0xa3c083df, 
	0x4fc16bfb, 0xfe81b941, 0x556e65f5, 0xf055efa1, 0x0bd61578, 0xf0262cf3, 
	0xdebe7823, 0x7e83ef80, 0x6bca2b9c, 0xc7462916, 0x641df48b, 0x670f7e3f, 
	0x77cf2149, 0xc239456c, 0x3028087b, 0xefc155df, 0xe2eff13a, 0x27245c10, 
	0xc5cf227a, 0x586fdf81, 0xd9e3909c, 0x9afaafdf, 0xbf17f442, 0x9f909543, 
	0xb9f956f1, 0x8c2ce509, 0x72058fbf, 0x5c68f38d, 0xfd9f986e, 0x55e3023c, 
	0x29ef523c, 0x0b317925, 0x31d53d70, 0xc1fd00a5, 0xe3f38eaa, 0xb3ee810a, 
	0xb47f9c57, 0x0b3ff014, 0x4886a9f3, 0xc5efc48e, 0xfca2f970, 0x9267ee19, 
	0xa9cbe5bf, 0xc0e35f1f, 0xec91f8fd, 0xd52efc3a, 0x30e7a607, 0x7e6aabac, 
	0x31c20f64, 0xcff0eead, 0x75a67e50, 0x0059d91d, 0x83dcd4fd, 0x499b42fb, 
	0xfc6ffccf, 0xd3b6613e, 0x6efc7bf7, 0x6003ffda, 0x006a5249, 0x00038bb1, 
	0x7dbd9c78, 0xd555780b, 0x273ef095, 0x727bdee7, 0x6e4e4373, 0xc024375e, 
	0x217203c9, 0xed108609, 0x9272a04d, 0x4783c810, 0xc7623a40, 0x1620bc6f, 
	0xb46ff6aa, 0xe43e86d8, 0x06e010dc, 0x1504dcb0, 0x32223eb0, 0x33fdfb15, 
	0x83b6b53f, 0x279f7e33, 0x762d1548, 0xe8db4b62, 0x58846d30, 0xb0674db1, 
	0xcb04ffa3, 0xd6b5ff5f, 0xf2bee7de, 0xef4edb00, 0x9f66e9f7, 0xac7ecfb3, 
	0xed7b5af7, 0x6b4e859d, 0x32afc1f7, 0xdb1878a6, 0xf36310f1, 0x1dfab066, 
	0x863ec65e, 0x8cedaedf, 0x531833ad, 0xb8db183b, 0x12ed3184, 0x8d1b9e63, 
	0x831b796e, 0x2629299f, 0xeecef5d4, 0xfb79c7c5, 0xa5ded083, 0xc697525a, 
	0x93316958, 0x4e6320e4, 0xf0cdd768, 0xa56ecebb, 0x1551fe1d, 0x77f94f80, 
	0x7318c7dd, 0xc6ea4330, 0xea99d376, 0x674c622c, 0xe1f3324c, 0xc3da1fbd, 
	0x634aa57b, 0x6c679fdd, 0x897c0f54, 0x9fa30dfd, 0x734fdf09, 0x9d03d1b2, 
	0xf65ab358, 0x9fa282ce, 0x563bf085, 0xeece8665, 0x625fcc60, 0x8c0dcc84, 
	0xda30ead5, 0xc6b9e1b7, 0x18beb072, 0x09b296e6, 0xbd6053c6, 0xd5f8c077, 
	0x42cebcf7, 0x6ff8e250, 0x963ad633, 0xe3efa4c1, 0xdd9533ba, 0x55655ed8, 
	0x8fd073d2, 0xa824535f, 0xf633f5d7, 0x8b34f5f0, 0x1c6df36c, 0x5a4508d7, 
	0x43ea34a0, 0x08bf7861, 0xec611ffb, 0x6b6ca2d3, 0xf86ecc96, 0x86c7d5be, 
	0x63e75eb1, 0xda06ab2c, 0x7e3a66ab, 0x0f0836bf, 0xd23ad036, 0x4c64eecf, 
	0x38d98366, 0x2d7b074f, 0x957e84cf, 0x32335347, 0x72f179e1, 0x3ce3b036, 
	0xa7586e94, 0x2cb5ed89, 0x5cb19976, 0x83d9b7f8, 0xd61e50f5, 0xd53aedad, 
	0xc552da6f, 0x3aeb804c, 0x6133dac6, 0xd355493c, 0xc5565fb1, 0x7e821c7e, 
	0xf5af6fe7, 0x6e342a96, 0x3aa3ce2e, 0x7832e522, 0x72fba0be, 0xd8c1cf8e, 
	0x1f970dc2, 0x2b71852a, 0x197284b7, 0xc8c2b3ae, 0x75a55f32, 0x84015d67, 
	0xaf95012a, 0xf8d9199f, 0xcda8cf5c, 0x1cef81ab, 0xdda606fb, 0xb397f000, 
	0xdf827e86, 0xf50c682d, 0x73631699, 0xebeef86e, 0xfd539f58, 0x8e34ebc6, 
	0xc5a1e5b6, 0x1c52bfd0, 0x9feb8b39, 0x67e6badb, 0xd5e20b6a, 0x43f3d8ba, 
	0xca69df18, 0x74087f0f, 0x55f40a50, 0xbac3f485, 0xba31cbe5, 0x514de9b3, 
	0x3ab7a719, 0xe88de88b, 0x4eef8989, 0x0a0bfa08, 0xd7d3c6fc, 0x656e818d, 
	0x8a8f4630, 0x6ce8daff, 0x06f93e32, 0x47f009f2, 0xf009f23f, 0x74d54ccb, 
	0x59230d75, 0xca99b25a, 0xb9662cd8, 0x80691e70, 0x3093e76e, 0x29cc93df, 
	0xd4e5baf3, 0xc4653e89, 0xe0574c1f, 0x3b7aa0d3, 0x1fbe17e2, 0xfe6654d5, 
	0x1ed16602, 0x63175661, 0x6270ccf9, 0xca66b27f, 0x3cfc752c, 0x330f1f47, 
	0x58b057f3, 0x7d0dd678, 0x612caa14, 0x9198333e, 0x4d679f38, 0x9f339fc7, 
	0xa639663c, 0x3a514f9a, 0x31414293, 0xd28bd03e, 0xc342046d, 0xf6009e54, 
	0x2dbddfe3, 0xf261b3e6, 0x7c6223f1, 0x1896e79a, 0x2c8a59fc, 0xf462db29, 
	0x81107440, 0x4d4db3e7, 0x376b1cb9, 0x82e1cb9a, 0x03253ef3, 0x858e7c1d, 
	0x74246c76, 0x9c705c13, 0x7985548b, 0x69ec661e, 0xd473e383, 0x06dddf09, 
	0x4077e363, 0xb8ec2960, 0xf55fe917, 0x44d94d33, 0xaea8b3ed, 0x754ca0b1, 
	0x4e50c596, 0xadbe7c1a, 0x39dd2c85, 0x148def4c, 0xed857fe4, 0x3b527118, 
	0x443da9ff, 0x5433fe6d, 0x7967b9b2, 0x2839ee7d, 0xedfd8535, 0x13dda1ef, 
	0x94379ff3, 0xef3b180f, 0xf90c7bcd, 0xf334c2e5, 0x4c3350ad, 0x80783bda, 
	0x0f993cc1, 0xe7c22b84, 0xb9cf1f24, 0xc978d86e, 0x8f6f3f1c, 0xe5085973, 
	0xe02abac8, 0xeebe6287, 0xa6279211, 0x9ae50a3c, 0x56e3987a, 0x41f69e7a, 
	0xbb4f3d17, 0x7b7c85d2, 0x0265884b, 0x99f11f5c, 0xced843f2, 0xb80639c8, 
	0x8bed0f9a, 0x2fcfee80, 0x5ccc2a91, 0x9b878ec6, 0xdee00c42, 0xd818c4bc, 
	0x202507d1, 0x86c5f902, 0xeb8315ff, 0x4c74bb11, 0x9ca10faf, 0x19dabd92, 
	0x23c71ba4, 0x27cddb97, 0x50a10f09, 0x17cf8c7e, 0x84c796aa, 0xbe360f7e, 
	0x450fb065, 0x3650b9bb, 0xc8634d75, 0xb7654bdf, 0x7b227202, 0xf94339e9, 
	0xc357ca3d, 0xa73e7c8b, 0x9d7508ce, 0x04f8f5a7, 0x769fd51d, 0x9850fbd2, 
	0x4f9597e4, 0xf96fcd72, 0x5c5a7e48, 0x4087b69e, 0x6f9c0362, 0x0c5debf7, 
	0x43aab6f0, 0x03bac7ce, 0xe2f406e1, 0x212edb18, 0x1088ff7e, 0xeeacf802, 
	0xfa47c86c, 0xcff98cfd, 0xc691acf9, 0xc6117e99, 0xfbe341f9, 0x90f6b784, 
	0xef7e3a7b, 0x283db377, 0x297c610f, 0xd619fd84, 0xd434f374, 0xea3316c7, 
	0xd425e3ef, 0x99974c1f, 0x593e5017, 0xe05bcd16, 0x8fcc5db7, 0xd612ede9, 
	0xb7c42fb1, 0xfeb750b7, 0x23be219d, 0xb5d46f84, 0xdcebf7c8, 0xb9ea1dd0, 
	0x1bd27ae2, 0xb51fb58e, 0xae1c459b, 0x5b5c034f, 0x708bd355, 0xd0cfe7a5, 
	0xd008a5bc, 0xcef5edd3, 0x783eed7a, 0x0f65efde, 0xf8745c83, 0x9876af4d, 
	0xe2fd35e0, 0xdf2fd02e, 0x5c11eb7a, 0xe8373cef, 0x3be08359, 0x2effe91d, 
	0xddeccee3, 0xd47ebe41, 0x0d197737, 0xdb104711, 0xcf107b99, 0x12bfff50, 
	0xbcc717c8, 0xc42023c8, 0xb9e028d8, 0xef506ffb, 0x3e803ac1, 0x2d976cd7, 
	0xf350cbd4, 0x866a3f11, 0x8cf5c3d4, 0xe342dbd4, 0x894e9e13, 0x1ea03b75, 
	0xd9e3c671, 0x3cf1b7c8, 0x9e3c6bb4, 0x5258d07f, 0x3c456caf, 0x40be2681, 
	0x085d39ef, 0xfef8d87c, 0xc287c29f, 0x841bde00, 0x263578bc, 0xd6c30c27, 
	0xb66e1ce3, 0xf976b8bc, 0xd75a69f0, 0xe881f264, 0xdefa21e0, 0x16cdf881, 
	0xbebdbd78, 0x12fb5ea1, 0x417e39d6, 0xa3cbf53e, 0xf92fd7e3, 0xd2177934, 
	0xf5dabc11, 0x965f7c7d, 0x81f41ef8, 0x8f781de3, 0x4bde17b2, 0x846940b0, 
	0x922e5bda, 0xbfc6c377, 0x33f19ca3, 0x2638742b, 0x3a78a497, 0x3badf985, 
	0x01a7d7d2, 0x5c82345d, 0xf9c0ed49, 0xdd9ea67d, 0x4f9fd7f3, 0x0e399e4c, 
	0x2b622e80, 0xa0d65b02, 0x4df28a5c, 0x1cc1c81d, 0x4d6c7e7c, 0x39d3f03f, 
	0x4bdcef98, 0x7b173931, 0x3f4d717f, 0x49abf77c, 0xe2d7fbdf, 0xbef8f3fb, 
	0x5bf7a263, 0xefff62d6, 0x31fdfa4c, 0xd2717f7a, 0xff522fef, 0x3df24e6f, 
	0x27de580b, 0x86023f91, 0xc7a019f7, 0x7f3b44b7, 0xf90d7b1a, 0xbebb8575, 
	0xcb46e50f, 0xb9db27bd, 0xa1646fdd, 0x61c36cbd, 0xa1666a95, 0xcf095dbe, 
	0xdcb6df51, 0x5b3b51fb, 0xd4b6cd03, 0xcc955d91, 0x46d96ddf, 0xda08799f, 
	0x401ef46d, 0x63a2b13d, 0x77c09af1, 0xd2b86ca1, 0x283ae54e, 0x39f94017, 
	0xa73fdf5e, 0x0d9beebf, 0x559ae650, 0x8d2c357b, 0xe31cdfad, 0x9001e6f2, 
	0x59a7fb23, 0xad33d421, 0x44727f6b, 0xf3ca9b7d, 0x7f3d0b5a, 0xfd8ded0a, 
	0x086f0cd3, 0xdb94bfe7, 0xf581df6d, 0xf18875a5, 0x982e896a, 0xfb8c55b9, 
	0x8b9d943c, 0x4467b0d7, 0xdf631bbf, 0x7b5daeb7, 0xd7fea35e, 0x953b411e, 
	0x8c43bbfa, 0x013c7d03, 0xbf4166fd, 0x641b74df, 0x6787ec17, 0xd9428fbb, 
	0x2065e0da, 0xf57ff697, 0x6fd43ec1, 0xa7ac1bfb, 0xa82dae10, 0x79b1c29f, 
	0x7e7f8f24, 0x3e615cbf, 0x7dbfa31c, 0x4c8972cd, 0x422cd572, 0xfdc2b2f9, 
	0x37943eb9, 0x3f10caa8, 0x0258eb6d, 0x2d4c2abd, 0x29447e12, 0x300f11fa, 
	0xbe9ba4a3, 0x9cb88ab7, 0xff04f4d1, 0xe34b34c1, 0x6c5607fd, 0x994e5ce8, 
	0xaee5c9ba, 0x7985567e, 0x94529504, 0xe60dadfb, 0x00eb2893, 0xfea36f8f, 
	0x047f7b05, 0x96c0f7d7, 0xd724a5a5, 0xcffbc035, 0xbfe80489, 0xc205fda8, 
	0xb646ed08, 0xdaa1886d, 0xbd03f823, 0xc7e00b7d, 0xa7c7883e, 0x4bd3e057, 
	0xbeff1cf8, 0x81ba88ef, 0xca1af3ca, 0x13c02ad1, 0xdb03bb8c, 0xf16ffe81, 
	0xaf50de58, 0xf2407fa8, 0x3e7c8bdd, 0xc936b9ee, 0x6fef1f73, 0x927d73dc, 
	0xf6c4fef6, 0xc3f1f931, 0xfca3e210, 0x14cd6aef, 0xf55717a0, 0x73139200, 
	0x3d245f15, 0x6cdbb51c, 0x8f64923d, 0x2ed87f29, 0x4c0cf145, 0x50bc0254, 
	0x6bb9e305, 0x7875eb74, 0x7b9b70ef, 0xcacbb04d, 0xc1356dc1, 0xc046531e, 
	0xbc38d6ae, 0xb176e15f, 0xaadfed07, 0xefc4998d, 0xa5ff7c12, 0xc2ede34b, 
	0x424cd905, 0xf0f02eb8, 0xacd7c6d2, 0x1da76e06, 0x0dfee06c, 0x80e40ca1, 
	0xb9761247, 0x74869ed6, 0x24b0ef22, 0xcbf119b3, 0x3fe89ab6, 0x8557e0e9, 
	0xe41e1d68, 0x931f4a87, 0x5527405c, 0xe9092c8b, 0x338c1aa5, 0xcbc411e7, 
	0x4de90f7a, 0x0346ffa1, 0xe7ecad81, 0x396a3f28, 0xfbb030e1, 0xcd6affa0, 
	0x7e82e4d7, 0xffa28346, 0xbff52d70, 0x3000fd10, 0xb52347d8, 0xb543bbfc, 
	0x76f0ee42, 0xe8bfa09a, 0x94bf04bc, 0x22af59a5, 0x5867961f, 0x0934e1af, 
	0x2e1f203f, 0x600b3e03, 0x6f75659d, 0xbaef684a, 0x5ea0c640, 0xbefc5b2a, 
	0xfaf006b4, 0x2d438065, 0xe30bb9f0, 0x574f0007, 0x022fb9a1, 0xbbafccfd, 
	0xb606af65, 0x5374e577, 0xfb7c808a, 0x4dc79eb8, 0xc929969c, 0x318e50c3, 
	0xbc377ba9, 0xfd69d3af, 0x0d2b69ca, 0xf4076fdd, 0x09b4f68f, 0x14ba2efd, 
	0xacb63bab, 0x03794349, 0x7a4672d0, 0x1c1e7e08, 0xde2ec7c7, 0x78f00997, 
	0x561f092c, 0xc15f8736, 0xfd44e190, 0x605100af, 0xd9fc033c, 0xad67f20e, 
	0x90278080, 0xf0b9f112, 0xe61fd013, 0xf845d9f8, 0x08f682ab, 0x6a5acec7, 
	0xb0edb73c, 0x68aefc84, 0x8c878a3e, 0xe23de25a, 0xd3e97e17, 0x92fdf7f8, 
	0xe1fd4691, 0x2bce81fc, 0xd0129e61, 0x1634dcf7, 0x61dc908a, 0x8dfa30a1, 
	0x3c40eb06, 0x32d77758, 0xb8bbe90d, 0xaf9c35fd, 0x18f7c193, 0xfd0e98ef, 
	0x1c4afb41, 0x330dc70f, 0x41f4df82, 0x15768268, 0xb891f3fa, 0x3dff0975, 
	0x6b17efda, 0xd09db919, 0xd989d91f, 0x48e89d7c, 0x65751d12, 0x0200d886, 
	0xc70858fe, 0x8235d4ad, 0x1674d553, 0xbc60f332, 0xe08ca17b, 0xe765743a, 
	0xac179c45, 0x8744f3e3, 0x01670469, 0xb52dd1b7, 0xfc620e1c, 0xf637aeea, 
	0x7481d746, 0x37e6283c, 0x7ad3dfc4, 0x59d0be30, 0xfa0b9fcb, 0x134f951e, 
	0xb246a61f, 0x69794fb2, 0x6fd0d79c, 0xde1e2d71, 0x719c8123, 0x5c397add, 
	0xdaf417cd, 0x6ee11d7e, 0x39b7a149, 0x4e06b1bd, 0xa730e67f, 0x38dfc43b, 
	0xf0e62b7a, 0x6ab7a64c, 0x0ea6f6f8, 0x878a2fa2, 0xc397838c, 0x57bc421f, 
	0x291d3846, 0xe2f78708, 0x8ff02dd6, 0xa27e87f4, 0x8bd8d0ab, 0xe312a7f2, 
	0xfd207767, 0x1faee649, 0xa227a78c, 0x89fa09a3, 0xf650e1c2, 0xf6e1c135, 
	0xec0dc3fa, 0x3bfc00bf, 0x7da1f70e, 0x141c7c4b, 0xbcfc4d7c, 0xc2e9feed, 
	0x893d084e, 0x212f9c74, 0x9d5e807e, 0xb15fe026, 0x4bf69d38, 0x4deb83cc, 
	0x8f9b53a6, 0xb8dd70aa, 0xf73a37fe, 0xfa72e700, 0xd4ba09f4, 0x9baee8e2, 
	0x13f033d3, 0xc02f2bc9, 0xa38adbb3, 0x826f8153, 0xe82bf637, 0x8f706afb, 
	0xd39bbff6, 0xd87864f5, 0x3d24f803, 0x860f8494, 0xc7e80d71, 0xfb95bf40, 
	0xc6f8d147, 0x3f8f9925, 0x02e2c726, 0x8f38e748, 0xac8a57f4, 0xfdbf3894, 
	0x6f2e46ce, 0x307d44b0, 0x08cdfaa7, 0xf8d87903, 0x1b23b708, 0xcda685f7, 
	0x86ef8e83, 0x574045f7, 0x563e428d, 0x83767c80, 0xe7836df0, 0xf6dcf099, 
	0x9bd496b3, 0x0bbdfa1a, 0x50339794, 0x65cf2cdf, 0xc7b7b626, 0x71e46fcb, 
	0x3c6cbb17, 0x6bb69039, 0xc0dfac4b, 0x7881ac57, 0x3edc953d, 0x4846ff4e, 
	0x976e3009, 0x22077a35, 0x651a6ba8, 0x628b53b0, 0x1d2f67df, 0xfc017069, 
	0x18d0150c, 0x1fc9ef11, 0x77d06736, 0x638d7e02, 0x7ef16b1f, 0x57f412ff, 
	0x4468cfc1, 0x7e8c3e3f, 0x893115ae, 0x2819ac8e, 0x9e471a07, 0x1fa1a19f, 
	0x0f5a59aa, 0x5eb4fbf7, 0x82acfbf2, 0x4e763f78, 0xfe8fdb1d, 0x5bf9536b, 
	0xaefc318f, 0xc6017cf0, 0x4962bf9b, 0xa1a7f71a, 0x388f5e5f, 0x568e1186, 
	0x97ebcc24, 0x3bef7c24, 0x64f923ed, 0x1f08ed45, 0xafa2ffb6, 0xf7d18bb8, 
	0x101cefa6, 0xdba38de7, 0x3e61b286, 0xcf9e970d, 0x5c13b767, 0x26f6f3a6, 
	0xbe379df9, 0xe31d3a9f, 0xedd832b3, 0x3f7a2e83, 0xa9c78c63, 0xa6ed4f0a, 
	0x76678576, 0xd69d1fa3, 0xaabb70a8, 0xb86bbf00, 0x5ec05b54, 0xc63e7e12, 
	0xd7f326dd, 0xbf92de40, 0xb33982a6, 0xfb379e09, 0xa8733fc8, 0xfbc1afe0, 
	0xf4080d0a, 0x9afef1b9, 0x3ad7f6d3, 0x10ed7f6d, 0xd052f1c5, 0x0f28635f, 
	0x97d91a0a, 0x48fbba90, 0x0a71d81e, 0x5388a780, 0x3600fc00, 0x1efbd38d, 
	0x0bbebe41, 0xe82c3ae1, 0x11ea986a, 0x17971547, 0xb840c714, 0x6cf80b0e, 
	0x62b2eb10, 0x125777f4, 0x7411adfd, 0x7ec99767, 0xb1274d8f, 0x7a38c6b8, 
	0x0f444df0, 0x893e0740, 0x0fb563f0, 0x9de18aee, 0x97641ce2, 0x78e7f99b, 
	0x7df0839c, 0xe037c0bb, 0x200ec7c3, 0xa8dd3e9e, 0xf1f5fc74, 0x697cc151, 
	0xb9012f18, 0x5e4191e0, 0xa7c858ff, 0xb2c0b938, 0xaa80bfa0, 0xc66b0768, 
	0x31636bf3, 0xe79629f0, 0xabc4272f, 0x832cab16, 0x3f9f13f8, 0xf387d7f3, 
	0xfb6646e2, 0xfbc21313, 0x13fbfaf6, 0x2e7ff0e8, 0xc6b5f3de, 0xb73de2a9, 
	0x61237fd7, 0x075c761e, 0x7e8e91f0, 0xfaffe124, 0xf84174f1, 0xc5d04779, 
	0xef0f416c, 0xb9a8fa08, 0x681c5d3a, 0x04e3f1e4, 0xeb9b78fa, 0x4126ef01, 
	0xe8925b0f, 0xfd18eee0, 0x611b5c9c, 0xbe315ddd, 0x1aca3a22, 0x83a2beff, 
	0xbf2099a5, 0xec8efe02, 0x0658fddd, 0x58b9461f, 0x2efdfed1, 0xe605e7a4, 
	0xbafc4f76, 0x0562b8ec, 0xfc0523ac, 0xbb9d94f2, 0xeff0213d, 0x7eb18f2b, 
	0xfbe17cf0, 0xfc8dff8b, 0xf1d700be, 0xba0bb51c, 0x419d6847, 0x15abd42f, 
	0xe5fdfc89, 0x6d1564cb, 0x160005dc, 0x806557c4, 0xedbdb105, 0xad5ec8a7, 
	0xdae7e517, 0x2abd7535, 0x9e0e3bc6, 0x6ca172d4, 0x993be279, 0x55e6b0d9, 
	0x6a32ebdb, 0xdf6b1852, 0x8b19cfff, 0xd369bca1, 0x24409947, 0xdb17e56c, 
	0xb11de2b5, 0xc4b34478, 0xcea18556, 0xbd15b04e, 0x631c2768, 0x2e487a2b, 
	0xdf7c03b3, 0x7a45cacd, 0x7cdb7472, 0x012bd3b3, 0x8a7bccbf, 0xaefc44cd, 
	0x1f66fb58, 0xebad47fa, 0xfca1f636, 0x4cc661cb, 0x3e5a47b4, 0xc06535eb, 
	0x7d8adfe7, 0x266d181f, 0x9b756bb7, 0xdc44731e, 0x7dd22660, 0x86f3296b, 
	0xbe7b5336, 0x1cb4c42f, 0xb2699fe4, 0x8d15edc4, 0x1a7df2e5, 0xeba8bf61, 
	0x2b7d3973, 0xac911f54, 0xcd0721d0, 0x2de70737, 0xe45b306b, 0x89e58503, 
	0xb13cc3fd, 0x477548af, 0xbe1e70c5, 0x05052d77, 0xfad67c06, 0x997f6799, 
	0x51e013b7, 0x7da0e46a, 0xfd0d6727, 0xd180fd12, 0x9bc8804b, 0xdf18be89, 
	0x97e4650f, 0xae9c3c3b, 0x2c698f46, 0xffdf337c, 0xc7a3d7c2, 0xba811654, 
	0x0acdea2c, 0x3c11078f, 0xf78eece2, 0x12c6fc84, 0x199a37fd, 0xd351c3cc, 
	0xe17183db, 0x211d3779, 0xa3f5b4eb, 0x75c35f17, 0xa2e9dc93, 0xf2074bfd, 
	0x399b9661, 0x72fdf04c, 0x197db9fa, 0x80965894, 0x438c1eeb, 0x7b1b75cf, 
	0x60fbc022, 0xbc401de7, 0x102d8138, 0xc3a773ce, 0x0affd077, 0x9fa0efb4, 
	0x8bc37e8c, 0x3b436c78, 0x076628b1, 0x4754da9e, 0xdaa02676, 0xf3ed0ddb, 
	0xb40e184e, 0xeb9b4617, 0xd4699db8, 0xb743fa25, 0x98dd91d5, 0x8a501c7b, 
	0x88b65a72, 0x6466548f, 0x5ae51fa3, 0xe71e7be4, 0xc6b2eb4d, 0xadd68baf, 
	0xc1b3edc5, 0xc5c1076f, 0x2f1f159c, 0x85997a02, 0x631afbf8, 0xe2136c83, 
	0x4fc04b47, 0x0fe00573, 0xf0f6b7d7, 0xb9e448e3, 0xd566062f, 0x16f17d80, 
	0xf7a053ca, 0x9efb5bd6, 0x7e007840, 0x1e28c57f, 0x129e28cf, 0xfb3b0bd3, 
	0xd5ad1e70, 0x5f6e3ea1, 0x5f715c01, 0xb437e1ad, 0xec2ad45f, 0x1bcd15b3, 
	0xe81c7635, 0x0317f8ae, 0x76b6aeb8, 0x055bf72f, 0x2c5a003c, 0xe399f30c, 
	0xde10fab6, 0xc84669cd, 0xea38f984, 0x68c0fb7a, 0x41d3ad67, 0xb46f035e, 
	0xf45ef5ea, 0x00c75aa3, 0x94ef60ce, 0xdede4db9, 0x8fd1792f, 0xc75f5d1a, 
	0x1d60efed, 0x5e75a64d, 0x7dc6487b, 0x4bda7621, 0x3e1261fe, 0x8f56dcca, 
	0xfc4f8719, 0x8f1dee45, 0x0e3172a7, 0x5a4cd833, 0xc4559ddf, 0x3b66c5af, 
	0x9deb51d1, 0x037d211d, 0xc74233b6, 0xf7cbc218, 0x63abc44b, 0xda1ee0de, 
	0x83f9c29f, 0xf141fd5d, 0x9f714b8d, 0xcc6c35ac, 0xfc053f44, 0x5add99e6, 
	0xac69ff0c, 0x973bbb21, 0xb7bff5e3, 0x67889627, 0xd952e287, 0x9f392c16, 
	0x96cbc558, 0xe823dd66, 0x8fa63f25, 0xd010f4a3, 0x7fef910b, 0xbe6cc2fc, 
	0xbd57e32f, 0xc73dc83a, 0x02b780ec, 0x6e5470fa, 0x63f295e9, 0xb92a6ce3, 
	0x87ca6969, 0x15c17171, 0xfec4bb27, 0xfd0147be, 0xf0dec8e6, 0x96297860, 
	0x8e3c7fa1, 0x03a58efb, 0x9426e1a9, 0x7b2b6f0f, 0x1e507d91, 0x7dfb50e7, 
	0x49877f7c, 0xafa3e061, 0xe0a937c1, 0x792f2c9f, 0x9f7b296a, 0x1ef28ef8, 
	0x3fdcbdaa, 0x6c06aeae, 0xd4bf7fa3, 0xe3228408, 0x3e712df7, 0x0231f4ff, 
	0xf707a4f6, 0xa72c9993, 0xc98cfc63, 0x7ebce95d, 0x4a4fd452, 0x001f5e58, 
	0xff7e893d, 0x6bb64c89, 0xd1638e01, 0x44f3a67e, 0xae77f93e, 0x94218379, 
	0x4971ca1b, 0x5def2062, 0xae6ed5b2, 0x5d1179a1, 0xfaa494b8, 0xd9db97e3, 
	0xe7ed501b, 0x2aabb2fe, 0xe9e286b0, 0x88ffb8c7, 0x687bd3df, 0xbf0c728f, 
	0xbb57af8f, 0x1f687dcd, 0x4af5f755, 0x584e1748, 0x24e1ccae, 0xd6fd43f5, 
	0xe09f7ca5, 0xe00c9400, 0x8a4d54e4, 0xc0bc380f, 0x83e46107, 0x5e578a41, 
	0xa84e9e75, 0x075711bf, 0x2def8b15, 0x3f3ac197, 0xf13cfabe, 0xae26b67b, 
	0xbfc7df0e, 0xa1ad7677, 0x40ea3879, 0x8f8ce50c, 0xff309aa7, 0x15c38c2a, 
	0x3b45ad8f, 0xf7014170, 0xc0619dab, 0x9183c803, 0xc3329032, 0x616ade22, 
	0x77e4f5bf, 0xe48d753a, 0xb94b53c1, 0x8f5571dc, 0x3c991d91, 0x172f945f, 
	0xfa2b6e91, 0xf6714ad7, 0x47dca399, 0xddb255f6, 0xb762aec9, 0xb237fda1, 
	0x67b6ed0b, 0x64dfa297, 0xb76471db, 0xd71d8505, 0x498e7682, 0xec3f89fc, 
	0xc516f516, 0x421fefcb, 0xa4240cf1, 0x1067e825, 0xe5e333ae, 0x1c5eb270, 
	0x78a3ce29, 0x7a0e9b02, 0x9cd9eb9d, 0x374fa073, 0x6668b75d, 0x53e84ba9, 
	0xfff0ef7c, 0xe5b7c68c, 0xe48cbe83, 0x4dac5283, 0x655aefcc, 0x437b8e21, 
	0xefc40dc9, 0x89525b95, 0xa8ef2bdf, 0xfcaf7e25, 0xf893e7c2, 0xf8498dfd, 
	0xee1492dd, 0xb7b88a5f, 0xb2845f25, 0x3fc0f172, 0x32c25f86, 0xbd610ec4, 
	0x967ac430, 0xd422b943, 0x728547b3, 0x5edd7d5d, 0x77b9df1e, 0x91c2316f, 
	0x2a5fa849, 0x0bb625db, 0x4b4bb6ed, 0xdb12ae28, 0x3f1a9dbf, 0xce5fb7f3, 
	0x6879852a, 0xe10bc01e, 0xd3c25de9, 0x676bbbf9, 0x2abac154, 0xc52f2182, 
	0x2f803d55, 0x268ef920, 0x00e1191c, 0x79bfa2e3, 0x3b26ccc8, 0x5076e348, 
	0x2c7fd94d, 0xeb7cfb25, 0xf0066cb6, 0x9433aebe, 0x76d37485, 0x008eb6ef, 
	0x1bb6a7e8, 0x9f3b0e8d, 0x76dfff09, 0xc39e807f, 0xe107ebfa, 0xcc6975c9, 
	0x707da2ea, 0x2aedc1c3, 0xce48a3b0, 0x63c40e99, 0x6a22c35b, 0x1730f2ef, 
	0x39660be9, 0xeb6dff10, 0xb1f839e0, 0x5e4ee16d, 0x00e3d856, 0xdb1c003f, 
	0xb077cf82, 0x473baa7e, 0x39de7c78, 0x0cf54bca, 0x59ea5387, 0x7a91f79e, 
	0x23ddd78e, 0xc0cf425d, 0x87a845f8, 0xb8bf505a, 0x64bf509b, 0xe99ceeec, 
	0x3858fd07, 0x7a8e3d9d, 0xc13f4a33, 0x8bf529e6, 0x22e5fa82, 0xb35edc96, 
	0xa44dbd8a, 0x91ff845f, 0x718b7a09, 0x36f88c7f, 0xa874dfbb, 0x639ceeb0, 
	0x7df70396, 0x27683e68, 0xebb23066, 0xe920cc8b, 0xf8046f47, 0x4bc10361, 
	0xce2afc3a, 0xf4935673, 0x52c9c221, 0x4acc9fd0, 0xf2daa79e, 0x9659e709, 
	0x8fc04f30, 0xb3e3f11b, 0x57ee274c, 0x9cb69fe5, 0xe3683fb8, 0x4b01a94f, 
	0x18f9c746, 0x4a7f107b, 0xe429d0c9, 0x94de7b33, 0xde94743f, 0xe60876bf, 
	0x4663ea9d, 0x1e3126ca, 0x56ee0ff4, 0xd3947cbf, 0x8e06ef59, 0xfc099ec7, 
	0xd88bf9d8, 0x4ab1fa00, 0x63f0b0e9, 0xba3fe519, 0xc2e848c1, 0x5195247c, 
	0xf82a627e, 0xe8463b3b, 0x2be44bbd, 0xaf942999, 0x9fc8b864, 0x5e3b75d5, 
	0x7442bae4, 0x5d53d4c1, 0xfdf0fa31, 0x1b35206b, 0x8efcde84, 0xf47c7a67, 
	0x861d4adc, 0x8f6b63ba, 0x87d51e7b, 0xe37e98dd, 0x8efd46fa, 0x55ca1269, 
	0xf9cc31a3, 0x2eecff3b, 0xe8fc87ea, 0xd4de341f, 0xfb61fc84, 0xc94115d1, 
	0xc6017e47, 0x3fdca707, 0xdbe41334, 0x610f9057, 0x0cd512c0, 0x65c4c4fd, 
	0x8d1699b2, 0xcf28f863, 0xc834e007, 0xce38f9eb, 0xa25fa41c, 0xec4d8d8b, 
	0x6dfbe43e, 0x1db6bf44, 0x6d7f9315, 0x7f0fddd9, 0x93b8ba12, 0xa5b9e2e8, 
	0x40b93777, 0xe435542e, 0x23fdc21f, 0x35737e7b, 0x25e5bf3e, 0x2fc03920, 
	0x4dbcdcaf, 0xd8a4b0a2, 0x1e04d3ff, 0xa53d7ded, 0xfca26834, 0xaba7de4c, 
	0x8fa94cd4, 0x93f5c9c0, 0x3f5126b3, 0xff95de55, 0x8ea7ea67, 0x13f4a9a6, 
	0x77dc3dc9, 0x7b212c8a, 0xae27deef, 0x7573bd27, 0x34dbdff9, 0x2927bd89, 
	0x7dc49f84, 0x6e1acacf, 0x952e55df, 0xf4acfec8, 0x4d67f2f0, 0x537b2fdc, 
	0xe26bbf94, 0xb29ae8f1, 0x3d3d38c7, 0xcf72f3ca, 0x107e6f7b, 0xafbae9e9, 
	0xf2859f3c, 0x95102db7, 0x07246983, 0x2de5b39f, 0x3a061fab, 0x20123b6d, 
	0xc98ae979, 0xbb97275d, 0x4ebb96cc, 0xae5fbb92, 0x8f14efa5, 0xaf388921, 
	0xa74fc453, 0x77509f94, 0xd1c8268f, 0xdfa390a0, 0x7dcc3a23, 0x0751cb91, 
	0x7143a7ca, 0xe56c7874, 0xde387494, 0xa217ff4e, 0x9f2a2543, 0x97e7154c, 
	0x6125d3b2, 0x54e483bc, 0x1b5390aa, 0xf68bf962, 0x1676d5ba, 0x323c9274, 
	0x4bbae34f, 0x92654880, 0x91fe3c47, 0xa976b2aa, 0x423c6194, 0x71dab8a2, 
	0xb965e766, 0xfa808e28, 0x83e507b6, 0x7fbc62e4, 0x5fdf05c3, 0x985c32e7, 
	0x8dcef9e8, 0xfdc1587a, 0x46a18709, 0x13ff3880, 0x0df289e9, 0x5bc4548d, 
	0x2f0da6c5, 0x24072449, 0xa94afb92, 0xbb7588de, 0x45dde55d, 0x80c7ee12, 
	0x4b3ca45c, 0xc7fa19b5, 0xf4c3257c, 0xbf38bb0d, 0xea979f23, 0x76cc9e5c, 
	0x84c8be19, 0xf49e7ffc, 0x1dff9457, 0x33b74cd2, 0x7f57ff9e, 0x9bf0bd42, 
	0x91f7aca6, 0xa4db7fff, 0x45f3125c, 0x4890c0fb, 0xf92f2d9e, 0x17be44cf, 
	0xfe94abfc, 0x8ff7f9a5, 0x726ff253, 0x7964c1be, 0x4f9f4ca2, 0x2ff65df6, 
	0xd4ff7b74, 0x8d89497b, 0xf77f9533, 0xdf918f8b, 0xdca59633, 0x33bf1137, 
	0x52bbfc99, 0x0d47370e, 0xddbb5ba7, 0xaf9c65ec, 0xc8e9444b, 0xb79fb666, 
	0xcd71c796, 0x37a70894, 0x688cbb59, 0x5b28ebe7, 0xb7c3f626, 0xe7053afc, 
	0x88ab36bd, 0x5cacb3c7, 0x1c2feb05, 0xbf2af117, 0x517a45d5, 0xd2affbe4, 
	0x03a04be1, 0x9aefe8e6, 0xca7c6267, 0xc5ded092, 0x336e50fe, 0xed16b9bf, 
	0x855d68bb, 0x43e53e7a, 0xae56adae, 0xe627978e, 0xb9432d57, 0x3ef6ad74, 
	0x7149977c, 0x89983632, 0x7cec01f2, 0x2cb00f3a, 0xd3404e7a, 0xb3fef292, 
	0x2a76f213, 0x5fbf0d0c, 0xa1fff22e, 0x9ba67695, 0x4533f5f2, 0xe9132dbc, 
	0xea338edf, 0x8ad9b519, 0xf4fbc603, 0xdde9ece9, 0x549c7cb1, 0xc137e785, 
	0xafc440af, 0x903ef80a, 0x3ed16055, 0x9a785190, 0x20e15bf3, 0xe218cfaf, 
	0x87c819f5, 0xa0f8877f, 0xe66348fd, 0x267cfe45, 0x8d6ee3ae, 0x711a4415, 
	0xfed18a5f, 0x04b017e6, 0x1687a81a, 0x00be7f28, 0xd28f36d3, 0xf309cb7b, 
	0xba3002ff, 0x69c03d74, 0x241f9188, 0xff7ae7ad, 0x7093b05e, 0x2a0be0ff, 
	0xcf988818, 0x437fb3a7, 0x666b2179, 0xacafb701, 0xd73b8c01, 0x34330dab, 
	0x53f67bc0, 0xbf30e743, 0xef27d611, 0xeab6f8c2, 0x4eff1863, 0x2e64fcc5, 
	0xd210e5ef, 0x093ef247, 0xca0e5e18, 0x0731f433, 0x4355cbc6, 0x1dac78c6, 
	0x42f3b6f7, 0xf30dfe29, 0x632c574e, 0x79c39bb0, 0x264bf388, 0x6795dbae, 
	0xd837e898, 0x1ae57570, 0x4a044c21, 0x1eb87479, 0xc9d52ff9, 0xd83e78cc, 
	0x21c78cb1, 0x8fd6f2ed, 0x2810e5eb, 0x5c7dd4fe, 0x3fadb62f, 0xbbf28999, 
	0x34cbac09, 0xcb43c798, 0x3a6afef8, 0xbee487ae, 0x2de231f5, 0xfa85fb1d, 
	0xb3d31f52, 0x88ae514a, 0x089adcb8, 0xf3d37733, 0xcfc82f61, 0xf8f36fd1, 
	0x37fb133a, 0x7f8e1f34, 0x71e3c439, 0xa13fb732, 0xd36f805f, 0x78ccf6f0, 
	0x2ee3d938, 0x48effa35, 0xfd5e69d1, 0xee3126d2, 0x3479b173, 0xf70ceb35, 
	0xb1e79283, 0x2652f039, 0xcf9a45ea, 0x51f3f1a6, 0x10723e91, 0xc6a656fc, 
	0x8da83dd7, 0x7844f9f0, 0xfdc647fc, 0xb90aaf9d, 0xfb02ea91, 0x7838a1fa, 
	0x267bfce0, 0x77ce3f58, 0xd93878cb, 0x3e0c9878, 0xc904e50c, 0xb9c79533, 
	0xf2dd9f85, 0x79b0ead1, 0x6541cf12, 0x3237982a, 0x2930175a, 0x3dc2984e, 
	0xc52ed1bd, 0x28d072e4, 0x47472065, 0x794ea0fb, 0x26295695, 0xeef9d80f, 
	0x79498f11, 0x95951158, 0xfad02f86, 0x376f504a, 0x88255d1b, 0x05c65877, 
	0xddf80fdc, 0xb4ff6e32, 0x2862f47c, 0xfd0b6e3e, 0xde1c5095, 0x7f6f72e4, 
	0x949cc695, 0xc49462c7, 0x8bf7ebc7, 0xda931473, 0x0e5ebedb, 0x77ce76af, 
	0x9c601c76, 0x1000d27e, 0xedd0f071, 0x7fb5cbf5, 0x092dfae2, 0x3734d7cf, 
	0x66c8a15a, 0x7b0de7cc, 0x5887a423, 0x0a7dca16, 0x55fd413b, 0x295df721, 
	0x4dd35ae6, 0x534ffafd, 0x4907f969, 0x87731b0e, 0xca2e7d78, 0xa9f0debf, 
	0x7d0f942c, 0xbfd383bb, 0x2368fb4b, 0xce519f24, 0xc98ede85, 0x20d39265, 
	0x665d9a9b, 0xcf300bc1, 0xdefc222f, 0xd01675a3, 0x39580eb9, 0x16c093e9, 
	0xf7b7c7da, 0xf228be3b, 0x86dd9ad1, 0xabe79fb5, 0x14fc277c, 0x1d92677e, 
	0x7625e360, 0xa09585ae, 0xecdfdf5c, 0x005ee7e5, 0x082f283f, 0x4fd0c32f, 
	0xf7c97f46, 0x832328c2, 0xcc1e614f, 0xb9ea78e4, 0x1a4d3c26, 0x85cd61cf, 
	0x4f425d7c, 0x9a7f4b82, 0xf2c4fae4, 0x5fae5e3d, 0x8d67efe2, 0x4b2cfaf1, 
	0x9a7ebaa5, 0x0c1f4b4a, 0x8868bd53, 0xf9868bd7, 0xbc8be2fb, 0x3e798c5e, 
	0xf5fa81ff, 0x979c9883, 0x7d079c85, 0x7f83704b, 0x547df216, 0xc7ec50a3, 
	0xfc021e52, 0x79e59c66, 0xf1ce3309, 0x5e11ccfa, 0xebca399f, 0xf5e03eb3, 
	0x5d785759, 0x31f3453f, 0xb25433f5, 0x5ebcb3a2, 0xccca0e74, 0xa3d84ce5, 
	0xcc2478ac, 0x4a1177e7, 0x8bde365d, 0xc8b94034, 0xf04dfb5c, 0xe32cf4eb, 
	0xe9fc455f, 0x57e00f48, 0x9fb05bff, 0x73fae21f, 0x5f53c02f, 0x57907508, 
	0x697f4337, 0x66179f40, 0x3bb9f9da, 0x2e6718c3, 0x695e5f76, 0xfe2393e7, 
	0x301dbbf0, 0xa86a916e, 0xef8d4f98, 0x78e0cf23, 0xfac6fd89, 0x8a7ea269, 
	0xd92bcb94, 0xaae8fd04, 0xfbe176a9, 0xb52bcbec, 0xe77c13b9, 0x748f8d8c, 
	0x0b9f6d10, 0xfed44ee3, 0x5b138f13, 0x83679da7, 0x6fafc4e3, 0x02d7f6b2, 
	0x79df7197, 0x6d13d712, 0xfda499ef, 0xd4c38e35, 0x3ce789f5, 0x1b3f7c7c, 
	0xf6258e84, 0xc4b8e9f3, 0xc9b7a7c2, 0xa657a47e, 0xb1e96749, 0x53990d25, 
	0x44c231c5, 0xdbd806e7, 0x7e726866, 0xcc31edb5, 0x7db934f0, 0x3c764d93, 
	0x7a9fb463, 0x40a3b093, 0xc927652e, 0xb978eca5, 0x5cbafb84, 0x9375db3e, 
	0x0937c8e2, 0x67f70b3b, 0xd69f6987, 0xf7c8bdc8, 0xed2f736b, 0x18de7aa4, 
	0x6459e7af, 0xab8f8dff, 0xfe7af10c, 0xe74f7f30, 0xe6ff309e, 0xb51f7f12, 
	0xe2a9cd1b, 0xae3cfd3a, 0xd5fdf363, 0x18a231e0, 0xafb73752, 0x5cf0d3b4, 
	0x15bf5b76, 0x03e4f6f2, 0x6aede325, 0x859d3b07, 0x2e7b05eb, 0x6187e483, 
	0x7bec2566, 0x22191be7, 0xf1033ddf, 0x0eb25e7a, 0xc53290bc, 0xfc233b7c, 
	0x87d7e3fc, 0x7cc53598, 0x9626f31d, 0xdf6535b7, 0x53f94e5b, 0x15e31387, 
	0xc1395f19, 0xeb1b15e3, 0x1990ce28, 0xbcc2cc06, 0xfe804dea, 0x1e23d830, 
	0x5c03dde3, 0xefb5bcee, 0x85e7ec29, 0xfe49fb29, 0xdeb7eede, 0x7fd0f234, 
	0x4a2fee4d, 0xf20e836f, 0xb333d4ff, 0xf44a9e84, 0x79fb66ff, 0x6cf667bc, 
	0x5d99ef1e, 0xff24f9f9, 0x4f975fef, 0x1461ef1c, 0x685d9fef, 0x9bcfdc30, 
	0x7b9a6a5d, 0x5b67d061, 0xce9cba7e, 0x1f3c69ed, 0x1c84bff5, 0x3a3e63f6, 
	0xc0fa25e6, 0x98f1e2ef, 0xe387bd03, 0x6e704f9e, 0xa1f112f3, 0x6597c291, 
	0xc71458a5, 0x14d39434, 0x4194b769, 0x490c775e, 0xf28d1c7c, 0xbf1d87fa, 
	0xea7c6851, 0x297e3a3f, 0xfc043b23, 0xfd8e7a0b, 0xc84abb73, 0x534fe083, 
	0x72e67eb0, 0x64abe70e, 0x55fc137f, 0x6fed8bc4, 0xae67e132, 0xf00461d2, 
	0xcbb2e58f, 0xdbe7ee12, 0x7f6ce97e, 0x93f884bd, 0xfbee9ec7, 0xf1fbf0ad, 
	0x18b40af9, 0x62769c78, 0x9e1cc6fb, 0x33d93efb, 0x487a731f, 0x976667b2, 
	0x81be53e7, 0xf604279d, 0x92fe8593, 0x683e7984, 0x8b2cfbe7, 0x22fc03f8, 
	0xbfd077f4, 0x149ddd71, 0x707e0017, 0x68f59ba6, 0xe33d8297, 0x05577dc5, 
	0xe48d35d6, 0x71a9218f, 0x9ba7dff6, 0xc76a5db9, 0xa6ba1d27, 0x7466dc60, 
	0xb8c3d81e, 0x83db6e2f, 0x7fd84c0d, 0xdff68c86, 0xec265ae8, 0x8f338043, 
	0xa39c260b, 0x3ecc3a75, 0xe1d5cf73, 0x27febc90, 0x233517e6, 0x3bff6c5c, 
	0x3b22d9b5, 0x4c6eddd0, 0x0682f9e7, 0xb82bc78b, 0x17e6329d, 0xdc583d01, 
	0x3f7901ff, 0xe425fd95, 0x4a69c239, 0xf0748079, 0xc49f8279, 0x978735e5, 
	0x0017ef13, 0xfab472fb, 0xb6c7c193, 0x6e715597, 0x6e66bae3, 0x3fcb246f, 
	0xcb5e0ad0, 0x579e1e3d, 0x9d1597b3, 0xf681c9c3, 0xe089aef2, 0xed19a2ba, 
	0x84ae1b67, 0xbcee786f, 0xd04ff8e1, 0x3f71d55e, 0x0063f695, 0x7a312d8e, 
	0x4ca8fdb2, 0x9f20c7c1, 0x193f11a7, 0x7ca4b4e6, 0xa64fca24, 0xbbf264bc, 
	0xefc93735, 0xe42dc37c, 0x61eb9bb5, 0x7ee22dcb, 0xfdde88d3, 0xde90d3f5, 
	0x1a599b53, 0xf79d1bee, 0x28c7e2fe, 0x964d5307, 0x053e5916, 0x5cb9db1e, 
	0xb536bf37, 0x5a38475c, 0xb8ed2f08, 0x6b2efc97, 0x79e155c9, 0x198be505, 
	0xc53efe9c, 0x4f36b6e9, 0xaa73a7c4, 0x54f91333, 0x47ea7ce5, 0x5a75f238, 
	0x3878fe66, 0xea166eca, 0xe0018da2, 0x7ba7ee4b, 0xb9d2afc3, 0xa5f70d09, 
	0x0d0c860a, 0x0450a5f7, 0xfa623a46, 0xd4d870b0, 0x08c5df68, 0x91c7c565, 
	0x98f7fc66, 0xb3c741a6, 0x7d32db5c, 0xbca2ef30, 0x943a99cb, 0xda7abe25, 
	0xd1ea8d07, 0x3c9bd04a, 0xe6219e3e, 0x67d47a47, 0xf39ba231, 0xa81d8eaf, 
	0x8f4a9ee9, 0xf03fbd72, 0x7dbfbe75, 0x95883b75, 0xf1631d91, 0xeb533338, 
	0xaf554f48, 0xa5e9b6ac, 0x60f08c6c, 0xd23ce195, 0x48bdd6ef, 0xf79fe98f, 
	0xdf4abe93, 0xd15bd9d4, 0x8ea7af1d, 0xa71c4f36, 0x225f6834, 0xdfdfbbbd, 
	0x269612f3, 0xafa743ed, 0x1a7bfa0b, 0xb43a84b1, 0x4bd6cf4a, 0xde2d9ea9, 
	0xdee5fa7b, 0x1a5ca057, 0x3d05e94c, 0xa83fed93, 0x7e914fa1, 0x80f3d1b7, 
	0xf4b34b0b, 0xe911f830, 0x7a879ab7, 0x6fa4af40, 0x63d20a65, 0x77eefffa, 
	0x2583dbed, 0x1eb87b9b, 0xca4d07ca, 0x307f4a53, 0x87ec7e98, 0xa56a3e50, 
	0xe9180186, 0x34b9aca7, 0xfc62539f, 0x7bb5ace7, 0x2719d148, 0xe9fc6177, 
	0x43db6b0c, 0x7e719076, 0x57d42957, 0x3369f888, 0xfc03dcdb, 0xcfc2dd98, 
	0x63d38ed5, 0x9b8a39da, 0x32573d9e, 0x5274dc71, 0xc16c163d, 0x79bca9f8, 
	0xa58f412c, 0x8f48316f, 0xe3126fa5, 0x7fc71307, 0xe31b6911, 0xef175f55, 
	0x7f79273b, 0xe7efbc54, 0xf0b767ef, 0xfbe89efc, 0x13fbc417, 0xc92dfdfc, 
	0xf1e59fdf, 0xcdba2065, 0x04f63f18, 0x079432cd, 0x01da93f3, 0x3e466d9f, 
	0x7601d69c, 0x5768abf4, 0x2d724bbd, 0x44ec13a3, 0x2623ef5c, 0xf64273dd, 
	0x9bb461d5, 0xb3847ad8, 0x81397204, 0xfe07e79e, 0xd63d081f, 0x9077a0d6, 
	0x258656dc, 0x62b6dda4, 0xe7c211d6, 0xfb2f3ad5, 0x1d2e8eb4, 0xae3c90e3, 
	0x54ef7f65, 0x7fe1e312, 0x4b147a10, 0xcdb4738c, 0xf4763ad3, 0xe0cbdc03, 
	0xccc87dc9, 0x71e20ad9, 0x912291eb, 0xa7edc97f, 0x6c7fada3, 0xaa85ee56, 
	0xf744df52, 0x1d06946c, 0x0be52a52, 0x6edeff50, 0xcf0c3bb3, 0xb17acc2f, 
	0xf6a3e31b, 0xec39deb8, 0xe31fd992, 0xa5914543, 0x5e500bde, 0x723d4871, 
	0xced45e6c, 0x7557e09f, 0x95e55fa3, 0x79f195ad, 0xa9255e41, 0x5c7a84ee, 
	0x8fb6111e, 0xf6c203cf, 0xf1f875f1, 0xcac689b8, 0xa63e0e50, 0x5e78bbeb, 
	0x43f655fe, 0x3c2d82aa, 0xffd56eee, 0x7e90101c, 0xb9a7fad7, 0xd0a4b55c, 
	0x14674e69, 0xde030fcf, 0xb79fffa1, 0x3c28b766, 0x4873639f, 0xc5d121d0, 
	0xb4df5e7a, 0x13dc9e1c, 0xea107e7b, 0x496eaf64, 0xf2df7f6c, 0x8a0bb520, 
	0x7f7367ba, 0x4fc0b3d9, 0x7fef7fd9, 0x1ce3ed17, 0xc72f7e7c, 0x07f77d13, 
	0x08dcdbb3, 0x42c39af3, 0xf642d026, 0x9f68071f, 0x4460e46e, 0xe531b981, 
	0x42177f37, 0x6e42aafc, 0xf8f0aeba, 0x20113bf1, 0xde63903d, 0xcf1ba623, 
	0x22fa38c5, 0xea1494dd, 0xc7dc300f, 0xcaafe28c, 0xf11b7c94, 0xaa431b7e, 
	0xb41fc78a, 0x7a2c8363, 0x0f0a2d7e, 0x583d6e23, 0x89f0e76f, 0x27ce4dd6, 
	0xdf2847c8, 0xd2de5bef, 0xd1767982, 0x9ede11f7, 0x80fde71d, 0xcfc4de9d, 
	0xed6f1b6b, 0xced71a39, 0xd90eed12, 0x79bfaced, 0x4a7e0278, 0x2735b72e, 
	0x4b1d81e2, 0xefb2671c, 0xa73f3da9, 0x8fb634fb, 0x9d926bf2, 0xcd4de364, 
	0x50f3ec35, 0x4387befc, 0x83ef124b, 0x3e783768, 0x6121b346, 0x138ed61c, 
	0xa7908668, 0x8c11f749, 0x5c79171e, 0x23873e22, 0x6d5f908c, 0x64ee8ee6, 
	0x3b44cedc, 0xa26822b9, 0x9d9ababe, 0x5f38b579, 0xaa46fe6c, 0x92a5e788, 
	0x03e3b77e, 0x731a7f62, 0x28ae5126, 0xb81f7c55, 0x69faf314, 0x67df853f, 
	0x70539f61, 0xbfc0fa28, 0xd3a378c3, 0x8639fdf8, 0xb8c7c3c8, 0xfb7bca00, 
	0xfb4d687b, 0x71d9b7ac, 0x823fdc09, 0xec0fb97a, 0xe5619069, 0x57cc2f00, 
	0xd13671a2, 0xe292f3ba, 0x71897916, 0x2e79460b, 0xb9edc61a, 0xf6f1f77e, 
	0x5f0ebd9a, 0xf472dc7c, 0x50fc6244, 0x220e46f6, 0xe226dfdf, 0xccc3b21c, 
	0x16e227db, 0x3b3db8e7, 0xa5e7847d, 0x8a4d1f4c, 0x3ecb5c57, 0x3a0e2c57, 
	0x03e1133c, 0xe200da86, 0x27d6fe71, 0x6b7dc16f, 0x3fde0fd5, 0x57dd7b8c, 
	0xf30dff33, 0x3ae193d6, 0x79499e0e, 0xb66be764, 0xd2e6e365, 0x286d6d48, 
	0xfa5ea0a0, 0xcf3c16a7, 0xebc854b3, 0xd899697f, 0xcfd787de, 0xb684b1e3, 
	0x8cdf3cb3, 0xfbe91a19, 0xb387123d, 0x5ce9059b, 0x33aeba60, 0x9133338c, 
	0x94bf0177, 0xf6a72a31, 0xb20be99b, 0xe2072d5f, 0xe4306eb7, 0x68b07944, 
	0xce29c068, 0xcf8c7d5f, 0xc423bee9, 0x297dd273, 0x774ceda9, 0x037ca26e, 
	0xf4016f3a, 0x470f709c, 0x293a1f74, 0xe5c6c0ee, 0xf6b7f609, 0xb7209e50, 
	0x4c2b2a87, 0xf984d3d6, 0xdf1dc123, 0xf2bbbb04, 0xe30b306c, 0x86e7950c, 
	0xbd401e7b, 0x48b9fb80, 0x7d728f97, 0xa176535e, 0xbd3ca265, 0xe1eb1ea5, 
	0x04f2713d, 0x7cc2e210, 0xc83d36b9, 0xb063baf5, 0xd533191b, 0xb0c75d1f, 
	0x3081ce93, 0x553bae27, 0x775c4165, 0x579e51db, 0x0b9228a2, 0xcab723fd, 
	0x6ae7cc74, 0xba3bdbd3, 0x967ca1fa, 0x7db4a1e7, 0xbee07599, 0x049df818, 
	0xe2d3ca2f, 0xbfa84ae7, 0x1ef87d7c, 0x46e8df8a, 0xb6e7ea07, 0x8f6a5597, 
	0x1c635b79, 0xfc8b2e3f, 0xede54324, 0x38363df9, 0xc13f50df, 0x14fcd271, 
	0xb8b3ffd1, 0xd6617c5f, 0x8a2f9e12, 0x1f006d79, 0x8d3cf505, 0xe257f3c3, 
	0x0ced02e9, 0xefd00fb4, 0x670d57cc, 0x3cee2b24, 0xdb47f0a6, 0x223a04e6, 
	0xcfdb7df0, 0x28611d03, 0x98056a6f, 0xa3cb8d6e, 0x9e274d30, 0xc9556797, 
	0xbd6dc978, 0xfdd8bc16, 0x3a0755b4, 0xc7b2eed0, 0xe91b0ccd, 0xd1964fb8, 
	0xded1d2c9, 0x7a5930cb, 0x6e785de4, 0x5711e91a, 0xfbebbbec, 0x4fe73a25, 
	0x9f81d6e7, 0xa51ac66a, 0xbf78f3fe, 0x67d0eb1a, 0x496979d3, 0xc77f261f, 
	0xb37c0fd3, 0x47efe606, 0x918eac3b, 0xc004a6fd, 0xe6377ade, 0xedc52abf, 
	0xfc1cae74, 0x47fa0f53, 0x69d7fc51, 0x35efcca6, 0x913f08f2, 0x0ed0f1f2, 
	0x4c33f9e0, 0xd16473dc, 0x39850e77, 0xbda0a50f, 0xfe103ac7, 0x54fd276d, 
	0x6dc7fb26, 0xff52d72f, 0x13ee84f0, 0x945bf7cc, 0xbbfb6e6f, 0x3dd615f9, 
	0xf5f27f28, 0x09e61f60, 0xada876d9, 0x17ef0837, 0x7005f0e3, 0xef63fb54, 
	0xcfb8a69d, 0xab4fb6c0, 0xf794e74c, 0x250f047b, 0xa64de7e4, 0x1c02d69f, 
	0xedb20ec9, 0x952f1f3b, 0xda00fd52, 0xbd278f49, 0xa5bb29af, 0xa738a275, 
	0x54b5df9d, 0x15b9fb9c, 0xfc02cbbe, 0xfe05a8fc, 0x0bc0bef5, 0x9d2cc3f9, 
	0xf864d3fc, 0x5cf9e49d, 0x0e335f88, 0x33a7886f, 0xe94f083b, 0xf8312943, 
	0x7de15c12, 0x0f7c8ffe, 0x41e2a9b0, 0xca8708d7, 0x99796ebb, 0x3e44a4f2, 
	0x9c9cb253, 0xe0873f2c, 0xb151fc03, 0x3beb387b, 0x93da8b0a, 0x49341e76, 
	0xd4c75a3a, 0x6bca1df1, 0x5f957686, 0x0c5acda9, 0xf6275cfd, 0xfd131f45, 
	0xa805bf43, 0x04f8eccf, 0x02533fe5, 0x58ff9253, 0x1ff23bf5, 0xf5c1fcef, 
	0x2a1f2f5c, 0xc6f1ff25, 0x1f8ec55a, 0x3e3fe24f, 0xd0714ad8, 0x5e7997cd, 
	0x2b1ff094, 0x683888b7, 0x38c2405e, 0xfdb57292, 0x7ee249dd, 0x13ee3ef6, 
	0xc56deff3, 0x2f3b2cbc, 0x11fa056e, 0xc96fdd3a, 0x5cc678f3, 0x0f8ffa12, 
	0xe87b72b5, 0x943f5c41, 0x7409606f, 0x9c34cd37, 0x48e27f78, 0xd401c1f1, 
	0x74cc19e3, 0x8f2bf9e2, 0x904c3a69, 0x2ceb3927, 0x11f30847, 0xdc237f40, 
	0xc8117ff3, 0x779d7d46, 0x9d1fea2a, 0xa6a8ff45, 0xfa2b78ec, 0x247e7119, 
	0x8273edd1, 0x03e7c76e, 0x4178be09, 0x9c715eff, 0x90780c7d, 0xfce75e51, 
	0xed1916c3, 0x299d6545, 0xc1aede53, 0xb2bc6156, 0xe4846d6d, 0x44f98cbf, 
	0xe3cf7750, 0x5b3ba6fe, 0xc4f110ee, 0x7758240c, 0xc0f24aab, 0xca2afe0d, 
	0x53aff717, 0x9e792f49, 0x81cf2d3b, 0x69d552f7, 0x3192c392, 0xd402f27c, 
	0x7ed82b1d, 0xbace6f9e, 0x9c9f8042, 0xf509a374, 0x03f2029a, 0xc2f282d5, 
	0x8bcc3ff0, 0xeb71cf93, 0x71a6d197, 0x789c369f, 0x05e72aae, 0x6f4147f0, 
	0x0238474d, 0x0e14725c, 0xdf42e707, 0xe5c02af3, 0xcf9e5699, 0xfe13f362, 
	0x893a9f68, 0x076da7ff, 0xbc0b7738, 0xfef8461c, 0x47d92b5b, 0x3f28ae02, 
	0xee5cfd23, 0xe2c7f6f5, 0x24250ea5, 0xde7cc2f5, 0xadb47185, 0x94168f98, 
	0x89bcf132, 0x93cf4f52, 0xf55d50f1, 0x4e27926b, 0xb9e1298f, 0xac3ca8a1, 
	0x93de19d0, 0x1dfbcf60, 0x89a5f79c, 0x9931cbce, 0x699a37e7, 0xf12fc132, 
	0x250ac99e, 0xc99e1b78, 0xae6d9fc9, 0xd872083f, 0xfb625bb3, 0xfd167ef8, 
	0x6edfe132, 0xb001d751, 0x94cdfb05, 0xbfd057ac, 0x7785f634, 0xe5be1e61, 
	0xcf84d0d9, 0xd93a4f75, 0xb9c42703, 0x3b9f6663, 0x339e27f6, 0x6538d6be, 
	0x7144db6a, 0x097f904a, 0xf3b04a71, 0xd8447974, 0x36283575, 0x97dd329c, 
	0x79f88ba7, 0xe494fdd2, 0x87d9c557, 0x080df209, 0xd986b0a9, 0x45ed5ff7, 
	0x93e8a9ba, 0xf5ba0b8e, 0x0166dd20, 0xfcf17761, 0x071e1cd6, 0x7ee2f734, 
	0x9123d644, 0x541f78bd, 0x9ed0a3c5, 0x79d137ef, 0xec406acd, 0x6e348d8e, 
	0xb15f8e0e, 0xa2cfeecb, 0x808ae07c, 0xd7bedc71, 0xde5fff18, 0x2ad7f3c6, 
	0x8e3b6c8e, 0x62fb917c, 0xec1b2720, 0x975d66f0, 0xe5b0ced0, 0x46b14d79, 
	0x7b2a62f7, 0xcc5ee932, 0x1edc6df5, 0xe16ce9b7, 0x32039953, 0x6dc6a0cc, 
	0x0522fdd0, 0x60fa927d, 0x03d9d611, 0x2c878e11, 0x5cf96bcc, 0x5a5bcf1b, 
	0x38933f70, 0xa79d017f, 0x110eff22, 0xa002bbbd, 0xc1cf9175, 0x0cdee91e, 
	0x800873fa, 0x2f54fd02, 0x97bee8b1, 0x180b229b, 0x7fe885da, 0xcccb9d25, 
	0x559defc7, 0x8bf23e46, 0x4dee1f7d, 0x4eca451d, 0xde27db1d, 0x3deb4c23, 
	0x3ce8f086, 0x601f1f1e, 0xeadfdee2, 0x4a7edb83, 0xfde101f7, 0x065744bf, 
	0x34294fcd, 0xdd1642b2, 0xf9f748eb, 0xfe7c1f56, 0x9123dd30, 0x94e6f435, 
	0x43a1c2f6, 0xfefc1f7c, 0xf9ede3a9, 0x28cbc669, 0xb04ed4ef, 0xbed14bb3, 
	0xd19fb8b3, 0x6de3f7ce, 0x67471bfa, 0xf2f18955, 0x27f15fa8, 0xd8b1577e, 
	0xa4657410, 0xaf9b1633, 0x73a2efcb, 0xdb151576, 0x9c836b8f, 0xd7ef514f, 
	0x2032bde0, 0x26d47e2f, 0x3247ecfc, 0x3c273ce9, 0xcde4dd7f, 0xc7e70f5e, 
	0xe78351e0, 0x5da10ed8, 0x03f7403c, 0xdd06632b, 0x0ce8e3e3, 0xf1104a49, 
	0x0fc249a7, 0xf66ef3a6, 0xd5154cbd, 0xf9a207eb, 0x5cee2c5f, 0xd7403fa9, 
	0x050e8c9f, 0x8a2bee12, 0xb00b2fbe, 0x7746334e, 0xeecfa04e, 0xbdfd0527, 
	0x55efe82d, 0x041b7f41, 0xa312bdfd, 0x9c55b5bb, 0x0ee9930e, 0xa04cdde9, 
	0x9c4b234b, 0x387ba35b, 0x4f563faf, 0x1f22a5f7, 0xebbcf9e0, 0xd2539e01, 
	0xe28f4da5, 0xa74da41c, 0xa8fb926c, 0x0836fe89, 0xa3896c7a, 0x7fa7415b, 
	0x7e44ba29, 0x3260fb47, 0x3e3904fa, 0xc7c77240, 0x820e48d2, 0xa389e878, 
	0x4666cf3b, 0xbfc655ef, 0x4a458353, 0x4726304a, 0xbdf5da53, 0x3d11ff68, 
	0xbfdf106e, 0xd55e9e3a, 0x501793e0, 0xefbb8ca1, 0x1f8e13f7, 0x0f310be5, 
	0xfc65a167, 0x1ddf165e, 0x3171f6be, 0xa1f6828e, 0xc4c7f029, 0x6d5b3a3d, 
	0x43502ffb, 0x5ec766f9, 0x9f1e7114, 0xfdfb0335, 0xf1e62fe7, 0xabf973f3, 
	0x5d80751f, 0xc28cc855, 0x73aed017, 0x81798fe8, 0x7e281e0f, 0xc5ec8db3, 
	0xf7e156dd, 0x3cd53f41, 0xd231f875, 0x466f82fb, 0xb66a3665, 0x314ff8c7, 
	0x1f225243, 0xc90a480d, 0xa347ce57, 0xe47b624a, 0x25e3a22b, 0x7ea5ee22, 
	0xb0be6199, 0xed997da2, 0x6f8c7efe, 0x57c17586, 0xe257c17e, 0xbf9551fb, 
	0xd64eebb7, 0xb1bed12e, 0x80560f7d, 0xb0e4d7df, 0xf9b303ef, 0x9d00baf0, 
	0x079d1eff, 0x8b7ae04b, 0x33bdebce, 0x0ec42f2f, 0x622dd9c7, 0x79db00bf, 
	0xea55f4e3, 0xa19fbe0a, 0x2f603ee0, 0xdc64b13e, 0x73edb78f, 0xf95247e8, 
	0xc60a5d3e, 0xe36c3efc, 0xffacc579, 0x985fca75, 0xc71669b3, 0xf6832443, 
	0x0b3a2e13, 0xd810bec4, 0xe7c76fe3, 0x1348c3cb, 0x9ca3cbe4, 0xe910e713, 
	0x7264cc3c, 0xac31746e, 0x9271eb8f, 0x2ade369f, 0x8e5e87aa, 0x47285f97, 
	0xeb1e0259, 0xc24d1e05, 0x436e1463, 0x364e0f1c, 0x873d24e8, 0xc38ad272, 
	0x2177908b, 0xf3b053e4, 0xfee1920a, 0x85f70e2b, 0xcf185f22, 0xbe82f4c9, 
	0xef82b79e, 0x17b9d133, 0x89f0be78, 0x9f8401da, 0x9a40e8f2, 0xd4fc987b, 
	0x99eb0a90, 0x0ade7cbd, 0x2e48bff5, 0xb1ff68aa, 0x5fdbc3c5, 0x693e3162, 
	0x7d36601f, 0xdd27d38f, 0x0cc7df78, 0xdd798dcb, 0x9e3c85e5, 0xb7256cb7, 
	0x3367f21f, 0xcf8caf61, 0x6a75c16f, 0x72078c26, 0xc71568a0, 0xe5a76663, 
	0x7ca43b46, 0x7c31c790, 0xfd1b991b, 0x725617f6, 0x45c688ba, 0xf0a452c6, 
	0x60167879, 0xdc51c656, 0x18526017, 0x1aa99ae0, 0x6c60d84a, 0x27c88568, 
	0x7ed0f916, 0x7e1150dd, 0xd6e66199, 0x8dc53c78, 0x4319c8fb, 0x33cf0e30, 
	0xfdbe2377, 0xbca0a486, 0x92da785d, 0xdb067f70, 0xfb80dfad, 0xd1ddccce, 
	0x88dfc622, 0x34d275f9, 0x9c07ed46, 0x1f418f28, 0xfd8e5f90, 0xd326bc63, 
	0x42bf7984, 0x9f169f58, 0x7987eca7, 0x799dfb8b, 0xb96a809e, 0xa3373ef9, 
	0x5551807c, 0xbf85d7c4, 0x666cfbed, 0x0aa1fc88, 0xbdf093d0, 0xf147d272, 
	0x0bbe7817, 0xb1cfccfb, 0xaf143ddc, 0x5cc2bb66, 0xcd3e913e, 0xa7d45f5f, 
	0x942c77e2, 0xc8271f1e, 0xc62a18f7, 0xb34eebd3, 0xe49fa96e, 0x45af98bb, 
	0x78c51df3, 0x237ddc73, 0x6a8d63e5, 0xf6b7ac17, 0x748521b4, 0xf9a32f9c, 
	0xe8319f96, 0x65d972be, 0xe3c28fa8, 0x6fc9e33a, 0x908abc23, 0xef0bbf2e, 
	0x04f5841f, 0x4b2bbcf1, 0x57e5bd47, 0x3de1a607, 0x80c739d5, 0xf363525f, 
	0x3af5fd00, 0x6e1931c2, 0xfda6cb12, 0x4bd8ff3f, 0xb8e8136e, 0xfba6587c, 
	0xc9596f2b, 0xecf5bdef, 0x141d150e, 0x144e19fe, 0x9f827fe4, 0x8b34e2d1, 
	0x333f0af6, 0xb27d2268, 0xff7c8396, 0xdf5dcee6, 0x7fcbb78e, 0xd9fd07b8, 
	0x5da8baf2, 0x2ec49eee, 0x3cbb0b0f, 0xf979768c, 0xcf68b2ad, 0xc732f2ed, 
	0xbb78e6d2, 0xd47e7cbc, 0x2bba272e, 0xbb6debd7, 0xc7f58bdc, 0xbcbb7057, 
	0x7ff41abc, 0xae5d9c7f, 0xae784916, 0x73d3d6d9, 0xc8c26bdc, 0xfcad450f, 
	0xad1fd3de, 0xe5b7ebe0, 0x37c2db68, 0xe8fb965e, 0xda30901e, 0x607505e1, 
	0x75893f97, 0x2ede27b3, 0xb7256fbf, 0x6fdee6db, 0x4d3ce2a8, 0xaa5e5d82, 
	0x1797644b, 0xdbc49f01, 0x526565e5, 0x9babca2a, 0xe8ff6002, 0x7684ddf4, 
	0x037b6b79, 0xb0ade5d9, 0xb47fb23e, 0x5a1fed89, 0xb1e11faf, 0xed41db8d, 
	0xdc630275, 0x325b29fe, 0x845e5db1, 0x75f00ef6, 0xb25ef4c9, 0xfc96cbcb, 
	0x6972ec75, 0xf28cd186, 0xbf2574a6, 0xebe49917, 0x4bebb41d, 0x66f511e7, 
	0x0f7eeb2f, 0xf84dabfb, 0x2bf91b7b, 0x9649fcb9, 0x878b299f, 0xc9ab940d, 
	0x5396d3f2, 0x91487f99, 0x2654984c, 0x64ee2833, 0x7ca0f588, 0xe4897a13, 
	0xabd46284, 0x39211718, 0xd72e4fa5, 0xcb8a7262, 0x4d4e5b35, 0xb96cd726, 
	0x9435cb64, 0x4f91aeaf, 0x9c84d720, 0x86b966ba, 0x5ae7aaf2, 0xf7459ae4, 
	0xe4d5feb3, 0xaa9dd3da, 0x5cb93296, 0x6af63923, 0x72d9ae4c, 0xc9079ecc, 
	0xaf011eaf, 0x3d7e02cd, 0xc98cba31, 0xfc59aeb5, 0xaf188bef, 0xea36f9ed, 
	0x21dc57ed, 0x85ee2e7c, 0x1a7d7d01, 0xea3975f5, 0x9dca20eb, 0xd7d730a2, 
	0xefaa56b3, 0x957d3b5f, 0xe7079878, 0xa5633fed, 0x1842bde3, 0xf0fa417b, 
	0xe9154c7b, 0x4930a4ad, 0xb6db2e1e, 0xcbcaf318, 0x5317054f, 0xffb8831e, 
	0xe74f7cb5, 0xa467bc62, 0x2a16ccfc, 0xd5dbc3fd, 0x22e1fdf8, 0x7de2a42d, 
	0x6633fe8c, 0x0331ca3a, 0xa6de71f7, 0x9e376d7d, 0x1cabf227, 0x37c8457e, 
	0xdcf5e36f, 0x9bef1b92, 0xa2e6f1a3, 0x3bb9603d, 0x65b86036, 0x25bebdc0, 
	0x9a0e5e7e, 0xdbb3ff97, 0x88b9b316, 0x5d45facf, 0xb9f8c64f, 0x451eff1c, 
	0x96a1ed04, 0x20cf5d45, 0xc63f01bd, 0x5d0bb3d9, 0x015ecd56, 0x9a1cf0e7, 
	0xc9f9078f, 0xde239603, 0x4bc516f7, 0xb3e71da1, 0x18bf50e1, 0x3f2bedef, 
	0xec98bed5, 0x82e41959, 0x16307084, 0x60aff90b, 0x645fba3d, 0x7cc3e86c, 
	0x608f2864, 0xc22a7049, 0x14586ef9, 0x10bfa79f, 0x07ca78e4, 0xf786f3f1, 
	0x1b9f2eb0, 0x76e5c3e0, 0xe595f126, 0x5d113c23, 0x41fd3c02, 0x7fa227a0, 
	0x38bcc543, 0x3ea198ff, 0xb3e72ef8, 0x6657d930, 0xc3973f26, 0xb3c8a1e9, 
	0xf6e25321, 0x2f7c8689, 0x62a6df2f, 0xc74d9c3e, 0x5bfbd145, 0xfee12d4d, 
	0x025f4e95, 0xbe432ebf, 0x21357982, 0x7d2154bf, 0xdccf3c2b, 0x397c8867, 
	0xd00ae333, 0x2eb0fdd9, 0xffb323f4, 0x18c3404f, 0x2647f035, 0xc7f003d2, 
	0x7947f220, 0x3c427d69, 0x295fc6cb, 0xbf401dc6, 0x21dc6397, 0x939e5ece, 
	0x4044f6c6, 0xc55c1d15, 0xef1f97f5, 0x9f03bb39, 0x2e3f749b, 0x3e357ab4, 
	0x00a730ee, 0xeb07cde8, 0xa8abd7f2, 0x2cc68ab7, 0x5ff83767, 0x9501be05, 
	0x8f3c4bfb, 0xfd7abca0, 0x19c713ab, 0xdb6ffbec, 0x55cec953, 0xbeb4fdc5, 
	0xb66d1a5a, 0xd46fef7d, 0xb8a5a9df, 0x2dfbdcc3, 0xfa86f115, 0x11c79bb7, 
	0xa40ee212, 0x255e015f, 0xdc62a5ba, 0xb6abd6c1, 0xabd64d9e, 0x9846dc73, 
	0xbd510ee2, 0x6877189b, 0x69dff836, 0x718f3d41, 0x854c6687, 0x77a14e0a, 
	0xee2b7d6d, 0xf0f5b2f1, 0xd2077164, 0x915e30af, 0x0ee297bb, 0xf92e5eb6, 
	0x261dc70b, 0xf689bbd7, 0x9f9985da, 0xf9e383da, 0x28bf5b3f, 0x72cd1efe, 
	0xf272e645, 0x0c3ee606, 0x74085514, 0x44e900b2, 0x28bec79c, 0xab9245ec, 
	0x749b7764, 0xd7c919af, 0x191c4477, 0x023725e0, 0xca3e721f, 0x733371e2, 
	0xacc5e62d, 0x0995b500, 0x4d83687a, 0x337fb87f, 0xd8b6de55, 0xce3dca8f, 
	0x44f38df3, 0xf313f1be, 0x144e5687, 0x75f7b67f, 0xf00df162, 0x62cfc8a3, 
	0x0647da6e, 0x39798f7d, 0x5f237c76, 0xca502905, 0x00f31df9, 0x4a45f5d5, 
	0xabc130ca, 0xc50ef51e, 0x9c628e5b, 0xd0af87f4, 0x93c628bd, 0x5f4e2817, 
	0x4f9150e5, 0xdb8ab67e, 0xdfdb6b25, 0x48fb895d, 0x42002b45, 0x7e1647a0, 
	0x8f3feb04, 0x1ed65bf9, 0x1cab3fbc, 0xc72eb5f3, 0x7fcab5f2, 0x7f213333, 
	0x1bf9646b, 0xfe93d46e, 0x76d34247, 0xc868e941, 0xac0e83dc, 0xb083641f, 
	0x5f9fc9a3, 0xbf224578, 0x3ac57fd0, 0xf209adf8, 0x0cabcaa2, 0xebe3ee49, 
	0xc087fba4, 0xcb8de86e, 0x38572a6b, 0xf23e171e, 0x5f7e01c6, 0xd14fd0ce, 
	0x09d8945f, 0xfccc1f91, 0xd94f0728, 0x5e5256f6, 0xe2779cb8, 0xaeff2827, 
	0x8460bf65, 0x6abe94f0, 0x36ee73aa, 0xdd71ca9c, 0x431650fd, 0x4784412f, 
	0x6e7984af, 0xfd7b7ee5, 0x5b11ee3c, 0x89c7df3f, 0x4ce8b7ee, 0xf98eddf2, 
	0x955486f2, 0x728fe7c2, 0x3b6eba33, 0x8bdc4daf, 0x3c0caabd, 0x1c578c64, 
	0x50bb23af, 0xeb41933b, 0x2cdff0cb, 0xc8e5dfe1, 0xc849e7f4, 0xb06f0b54, 
	0xe820fdb8, 0xee2aee7f, 0x74eca787, 0x7dbf73d1, 0xa1c05cdf, 0xf9cfdfe2, 
	0x3fbe4af5, 0xafb2f4f5, 0x587a42af, 0xe82591f8, 0xf81d1180, 0x9fc0e893, 
	0x4db7074c, 0x7f220742, 0xe37eb62f, 0xc826b7e0, 0xfff72877, 0x2a5ff065, 
	0x3e7f07e2, 0x9aae57fe, 0xc989deea, 0x4af0bff0, 0x28c90a48, 0x60dd6167, 
	0xf0af395f, 0xe591d9fd, 0x0ba46e99, 0x03f35fdb, 0x3ed0abde, 0x52fb7582, 
	0xbe85e3c6, 0x07e2240f, 0xeb0fdae9, 0x00dc7dc3, 0xf18fbf96, 0x514ad8cd, 
	0xced8e1b7, 0x6e504ff3, 0x3ffeb9e1, 0xaffd5e5d, 0x279d5355, 0x2bcb4bfe, 
	0x57a9fb77, 0xc84d1f68, 0xe2ac6fab, 0x5d368ffb, 0x4a00ad16, 0x45ee87be, 
	0xb6cdbb25, 0x73575163, 0x19ec163b, 0xd923bf80, 0x29d39b7e, 0xeda9b7ec, 
	0x12d2e558, 0x359efe29, 0x2cd2ed05, 0x7e8357e8, 0xb14fb027, 0x3634fb44, 
	0x29f6e4de, 0x60d7f1d2, 0xc75b293d, 0x6e7fa9db, 0xa4ce797c, 0x27bfe5f1, 
	0x97c76179, 0xf1e42ce7, 0xc47d98e5, 0x3edb0fed, 0x17378e4a, 0xee3724f8, 
	0xef33bcd3, 0xbfbf30e6, 0xf149d06c, 0x7338a4df, 0x7f93c601, 0xc64f1717, 
	0x7449a638, 0x3f8f8ce0, 0xf9fc6017, 0x37fb710b, 0xb338b26c, 0x76174718, 
	0x49f7c197, 0x8e778b26, 0x338d15be, 0xdb6bf593, 0x7c760505, 0xbe3b2df9, 
	0x5a5fdfcc, 0x45a1e3c5, 0x4b5d5f60, 0xe840797c, 0x5f1e4fcb, 0xf8aad9fe, 
	0x5e4172f8, 0xfec854a7, 0xfa8bf47a, 0x9133f69e, 0x72ff1b8e, 0x28f28c74, 
	0x74e16fd1, 0x9078f64c, 0x27a4ebdb, 0xbfa74ed0, 0xf3edc6d3, 0x346952d1, 
	0x66bfeede, 0xe7e31d3b, 0x7f90fb71, 0x411eddaa, 0x7275b939, 0x73899dfb, 
	0x83a09a73, 0xef46a651, 0x3de8b0d7, 0x4580ce53, 0x53adbee3, 0x7bb14351, 
	0x677cec67, 0x7db51cfb, 0x7e7259df, 0x9d897387, 0x887371df, 0xf2ca19f6, 
	0x3bf34756, 0x68c8ce28, 0xbceda1bf, 0x49979f7d, 0xc33e00fb, 0xa5aef3a2, 
	0x7ba861ab, 0xfe615f39, 0xe2b2aae6, 0xc4dcfcd5, 0x1e07b202, 0xf675e5fe, 
	0xd0692db9, 0xb0dcf09c, 0x761b9c4b, 0xaec37388, 0x0ec373a4, 0xee8d0e71, 
	0x961d9465, 0x14d0d1eb, 0xdaffbdf6, 0x3b26c2f2, 0x3982cc37, 0xe6a9de74, 
	0x7ceceb1f, 0x7cb4f568, 0xd6edf72d, 0xbe2696af, 0xcf05337f, 0x656e3939, 
	0x4c73c5bf, 0x1e795b8e, 0xfad4a3ad, 0xa2a5ea88, 0xd87fad9e, 0xf34b14b3, 
	0x200e27f1, 0xcf6a9a3f, 0xa40f982b, 0x2c5584f7, 0xf187cb8d, 0xb9f352fd, 
	0xef300783, 0x99e953f9, 0xfdebfef8, 0xd7fde9bb, 0x2ef9bf83, 0x0667dfbe, 
	0x696167f7, 0x29ccf87d, 0x37341f28, 0x9efec7ed, 0xf7e2bf63, 0xf93f1829, 
	0xbf50d3e6, 0xd9eb9c5b, 0xc0f73462, 0xcd5bde3a, 0x6ee38fe5, 0x3c7be863, 
	0x0fbad11e, 0x3faba9da, 0xd5ef1abb, 0xda65eb62, 0x8deb6367, 0xbe23ca66, 
	0x8281fdda, 0xb45fb02f, 0xb7d5d40f, 0x7e747ef3, 0xbf5ae67e, 0xcddfc557, 
	0xca0dc762, 0x6aeafb1f, 0xf1937fae, 0x731a6179, 0xaec43da0, 0xb52f2f31, 
	0x3cbca4d9, 0x6b205e47, 0x8aef7c31, 0xd5f257de, 0x6eeffcd5, 0x65e5e624, 
	0x445e5e63, 0x3de907ac, 0xa7c87008, 0x5c705371, 0x76c609c7, 0x94e0b8f1, 
	0x4f9466e7, 0x8fc6f09d, 0x6cd5ebf7, 0x8f403cc2, 0x0e77db87, 0x9efb683f, 
	0x383b71b8, 0x6920c1fc, 0x59c6bb46, 0xeaa79f65, 0x91768d5d, 0x79e9302b, 
	0xb6e7e22a, 0x72777acf, 0xf14869bd, 0xc1b33af7, 0x6fa82b4f, 0xa24edd82, 
	0xb9abc3fb, 0x0655597e, 0xcf1f7aff, 0xd93c8bb5, 0x56fcf0ef, 0x52c6a7d7, 
	0xda3c1cd0, 0x46e34fda, 0x96758df3, 0xf07be382, 0xfe45945c, 0xb3e40ef1, 
	0x5cfc23ec, 0x58d8a796, 0xd98a2a14, 0xc01ed99d, 0xe55e481b, 0xe5849703, 
	0xca1e027b, 0xb2925d51, 0x927afdb0, 0x7d6f3fe3, 0xb345e38f, 0xd0a66dd7, 
	0x2b01543d, 0xd367d705, 0x264e1459, 0x1eb45387, 0xd68af8e6, 0xfeaebc23, 
	0x7e14ed81, 0x4a0f9d05, 0xf2340f3e, 0x768296b4, 0x4947fab4, 0x1e80350a, 
	0xf78a3106, 0x983767af, 0x15b3b46e, 0x71c85e71, 0xfb41db44, 0x9114003d, 
	0xfabb42bf, 0x66df3cd1, 0x38c1f643, 0x552580ce, 0xe5e0c575, 0xed1aa341, 
	0x3fae6696, 0x9233f3a3, 0x349cdfe6, 0xf75e76ff, 0x60b806ae, 0xfdee33bd, 
	0x995e7125, 0x2e7860ec, 0xc57a89f6, 0x314bccfb, 0x82a5ab38, 0x7bd8f4bf, 
	0xaf7f6e7a, 0xbf28f7c3, 0x5c7efe35, 0x06f1aa5e, 0x7fca1fd9, 0x5e535f94, 
	0xd7fd2aea, 0xfb083f5c, 0xa547cec3, 0xba16ee7d, 0x32b57817, 0x32669e41, 
	0x7dfb17bf, 0x11782f74, 0x6abbb5f8, 0xf677ceae, 0x7fdb06f9, 0xf92ef9b2, 
	0x67147bef, 0x41f966d4, 0xefe22bbe, 0xf3b61620, 0x972551bc, 0x37e1dd51, 
	0x7f413452, 0xc2e6dfb8, 0xff60f9f3, 0x3d85dab9, 0xe70919a6, 0xf53fffce, 
	0x0086f5ca, 0x00002721, 0x52ad9c78, 0x5153683d, 0xb9373d18, 0xca352f09, 
	0x8d34a123, 0xf01a4920, 0x0e288325, 0xccf8288d, 0x3c8389a0, 0xd2e22c1c, 
	0x0e0b0458, 0x20311455, 0x4db134de, 0xa03fb104, 0x5cdd1074, 0x22dc49db, 
	0xe820c874, 0xf0452220, 0x8a198e27, 0x7a83a828, 0x520d7dee, 0x41f07514, 
	0xfbde72f8, 0xeef9f9ee, 0x52d82a17, 0x7cbd024c, 0x8004e141, 0xf104a020, 
	0x17c0a869, 0xcc41b862, 0xbe205f10, 0x883b71a2, 0x62a38b30, 0x107db8d0, 
	0x23dfa5aa, 0xf3cbb06e, 0xd59d8311, 0xe728ba1b, 0x3dc8a989, 0x15ee71f7, 
	0x9fcbd6eb, 0xdaf259e3, 0x903ea712, 0x41aedeef, 0xde045e4f, 0xa2ee86c5, 
	0xa9b77402, 0x90095ab5, 0xbe62c4d9, 0x50587d41, 0x91ee3c63, 0x685ab141, 
	0xa297d8d7, 0x5f1b2aa0, 0xbecc356d, 0x6d7a82b0, 0xe463c0f4, 0xf1bda881, 
	0xae7df8fd, 0xfd3019d3, 0xc7e333ce, 0x71f4bdcd, 0xad25bd4e, 0x8bec5ccb, 
	0x07e2158c, 0x7665b024, 0xfc62b93c, 0xea3f8d25, 0xc6bad76e, 0x9464fb27, 
	0xe8406d3e, 0x23f4eb64, 0xfed0962b, 0xea6c3c77, 0xa1d899ef, 0x7c0d2afd, 
	0x1ae0f3e7, 0x3ea00cb1, 0x2157a408, 0x752be996, 0x0ee5895d, 0x76255eeb, 
	0xe65181c7, 0xc7014c4b, 0x25dff276, 0x48f73692, 0xdf8a1ef0, 0xc39ccd46, 
	0x1a2d4a29, 0xe66549df, 0xa73d0ae4, 0xd492b474, 0xf138e8ba, 0x75c4798d, 
	0xa6e4499e, 0xbf7fe303, 0xfdecd28f, 0xaf939f98, 0x1533937e, 0xf206b93c, 
	0xb6de7485, 0xd8f91fe1, 0xfa233c34, 0x09396ebe, 0x21435984, 0xc433f5b8, 
	0x15e9b409, 0x89d5c3a1, 0x1f31b582, 0x62dbb79f, 0xece74ddf, 0x597da16d, 
	0xf239ddeb, 0x5e7746c2, 0xcb5db6fb, 0x6fbe91ec, 0xccfbd1ee, 0x96eb4d50, 
	0xa9ad3ebf, 0xf7f67322, 0xe6df6075, 0xfd969d7d, 0x7d9acd7d, 0x7dfd905d, 
	0xd57deacd, 0xf9c3bff3, 0x515d45cf, 0x4befd05f, 0x297dc9a2, 0xd8fe3d1f, 
	0xee72ad62, 0x88efef36, 0x3ce1e137, 0x15642cfb, 0xddb3dce7, 0x3505e35a, 
	0xcf34ffe0, 0x897a790c, 0xd8fb4df9, 0xd81edfbf, 0xdd015f4f, 0xcf35f8df, 
	0x725ff2ff, 0xefa6c28b, 0xd08fd473, 0x7aabde77, 0xbffb4a72, 0xd193e1ea, 
	0xcfc96a15, 0xe53fa587, 0x0e53fd68, 0x611fb199, 0xfd77e7f8, 0x92b7a9d4, 
	0x7edd1a69, 0x972c01fd, 0x000059fe, 0x000f7622, 0xffffffff, 0x00007f86, 
	0x000000d0, 0x001e2353, 0x00123f42, 0x00123e60, 0x001e4603, 0x001e2909, 
	0x001e3049, 0x001e2d37, 0x001e2774, 0x001e2a20, 0x001e2acb, 0x001e267b, 
	0x001e2ac5, 0x0012408d, 0x00000090, 0x0012382d, 0x001e3a7c, 0x001e334b, 
	0x001e315e, 0x00123de7, 0x00123642, 0x001e3113, 0x001e3c95, 0x001e3919, 
	0x00000020, 0x00121a11, 0x001e2cee, 0x00000020, 0x00121c52, 0x001e1e83, 
	0x00000030, 0x0012190d, 0x001e1776, 0x00121fb1, 0x00000060, 0x001e00e3, 
	0x001e0719, 0x00040017, 0x00040ef2, 0x000409d8, 0x001e0002, 0x00000070, 
	0x001e1497, 0x001e100d, 0x001e0f6d, 0x001e1109, 0x001e11df, 0x001e15ea, 
	0x001e1313, 0x00000040, 0x00084c30, 0x00124aed, 0x001e4963, 0x001e4806, 
	0x00000030, 0x001249d4, 0x00124896, 0x001247c3, 0x00000060, 0x001e4449, 
	0x001244c7, 0x00124587, 0x000a40be, 0x001241eb, 0x001240a0, 0x00000020, 
	0x0012512e, 0x000c50c4, 0x00000050, 0x00124aed, 0x000e4c30, 0x001249d4, 
	0x001e4f36, 0x001e4ff7, 0x00000060, 0x0001000a, 0x00032a08, 0x5d83924e, 
	0x00000000, 0x01020200, 0x00400804, 0x000000f0, 0x98180003, 0x98180005, 
	0x000000ff, 0x000000ff, 0x98180004, 0x98180006, 0x94140000, 0x000000ff, 
	0x000000ff, 0x000000ff, 0xb4340001, 0x000000ff, 0xcc4c000a, 0x000000ff, 
	0xcc4c000a, 0x00000712, 0x000000ff, 0x00000060, 0x00000000, 0x00000000, 
	0x94140002, 0x000000ff, 0xa424000b, 0x000000ff, 0x00000020, 0x01460000, 
	0x00000018, 0x000000e0, 0xfffff807, 0x00000fff, 0x07ffff01, 0x00000ffc, 
	0x0fffff01, 0x00000ffc, 0xfffff001, 0x00000fff, 0x00fff079, 0x00000e00, 
	0xf8003ff9, 0x00000fff, 0x0fffff01, 0x00000ffc, 0x00010012, 0x001e32b5, 
	0x0003d811, 0x7dd59c78, 0xd5547c0d, 0x9999f799, 0x4c991f3b, 0x80493b92, 
	0x0370c424, 0x35604211, 0xb0236a10, 0x042102f5, 0xb6b06db5, 0xa1d6dad2, 
	0x2bf16542, 0x1134aa12, 0x09326772, 0xa406a009, 0x41929412, 0xb6ad96d8, 
	0x5a5ad6a5, 0x620bdbed, 0x17776ec5, 0xfad4aa3f, 0xb2d0d06a, 0xc5a2dd36, 
	0x7d6cac6e, 0xce73ff9f, 0x404cdccd, 0xdf76feec, 0x7efcdf77, 0x7ee77e70, 
	0xe79cf39c, 0x73cfdf3c, 0xfeffbcee, 0xb677effb, 0xa66b3109, 0x84a76847, 
	0x4d789818, 0x4426589f, 0x88a1dd6b, 0xe4c42637, 0xfdeda89a, 0x16aff51a, 
	0x42b1add3, 0x6a7aefec, 0xfea1e897, 0x93d339d1, 0xb9deb506, 0xeb6a35d3, 
	0x7b597623, 0xabef10be, 0x42155ef1, 0x68849a84, 0xe30a7b46, 0x1c4bbb3c, 
	0x5663a217, 0xd14b5b22, 0x2b0b977b, 0xafe042b1, 0xfba2cad8, 0x66371c97, 
	0x97515e60, 0x1b53956d, 0xea2cfbb6, 0xd8db468b, 0xdb442dd1, 0xf1292dcc, 
	0x166e3c25, 0x944fd45b, 0x47eac308, 0x16b62adf, 0xa643ffd3, 0xfa2dfc91, 
	0xc5678f36, 0xa7e006bc, 0xe3f412bf, 0x1ae5132b, 0xf912cdf7, 0xc84372fe, 
	0xef4fb9f7, 0xe4ea9c95, 0x0287e3fb, 0xf98f1fdc, 0x7e72be3f, 0xaff1a099, 
	0xd9666ebc, 0x71083647, 0xee27e7c5, 0x4bda7e06, 0x0423be09, 0xde134867, 
	0x59d6e931, 0x108f02ff, 0x8bfeb4b5, 0x660f123d, 0xbc601440, 0x3285fd56, 
	0x29e79071, 0x2cd2ef10, 0xcd010485, 0x97645adf, 0x8a573d63, 0x60f15f93, 
	0x1142dade, 0x062157f8, 0x126ece57, 0xb1e3d22f, 0x15fd42d9, 0x7bd2af88, 
	0xe5d60734, 0xeb02b117, 0xf717de38, 0x31419e02, 0x867c49b7, 0xcb9eaa9e, 
	0xbed0770f, 0xf5c7fee0, 0xe1036d22, 0x5b363075, 0xe3495fde, 0x029ebc59, 
	0x335fa7ac, 0x6867adcb, 0xe13e63fe, 0x00e97da5, 0x7ee9bb1c, 0x61eeec44, 
	0x5ddd893c, 0x29a0e704, 0xdf7a2c9a, 0xe8573e9e, 0x42593174, 0x8e18c7e3, 
	0x6b43ec72, 0x077bc4bf, 0xbff7a3e6, 0x49232c20, 0x7ecdb7ef, 0xbb889761, 
	0xf2e7d3e0, 0x6067f4fc, 0xe50b873d, 0x037fe87a, 0x158eb278, 0xbdc10088, 
	0x65dec4a1, 0xfd9740dd, 0x780252fb, 0x17707ada, 0xdae4fbe6, 0x9e8205f9, 
	0x979344ff, 0x9b1c4fe1, 0xbbf475a4, 0xae78bbe0, 0x27e34b58, 0xe3bf8eb0, 
	0x7c632cfd, 0xc265bc2b, 0xc71df0c1, 0xfb030c3a, 0xf0a4d831, 0xdde256be, 
	0x1fb07ac2, 0xebc8e6c7, 0xd077e242, 0x35eb0b6b, 0x7d1bb221, 0x213ef27a, 
	0x9715cdd6, 0xebd74fde, 0x8a34fd4f, 0xfef2fef9, 0x42e84465, 0xf9ee789c, 
	0x10b9625d, 0x3cb09081, 0xa26f097b, 0x20f1ff3f, 0xf46667ad, 0xe83af135, 
	0x4f12ef69, 0x38e0dcb7, 0xa2754bf1, 0x409ef2d8, 0x7581dd1b, 0x6affb756, 
	0x9d59d617, 0xfd0eecf8, 0x9efba4a0, 0x7bde92e3, 0x8a39ef08, 0xbe2856cf, 
	0x8a3e2b8a, 0xf80a4587, 0x9ecafe5c, 0x8b4419b2, 0x275a3ed5, 0x2ad1a8f8, 
	0x2ab55f03, 0x759b6a3e, 0xb0fe0c28, 0x47c52c86, 0x6b2c6f92, 0x3fb7b97e, 
	0xcfad37cd, 0xec44324d, 0xa4b37cfc, 0xe34df24b, 0x2ecb1375, 0xa17cdf01, 
	0xf986f98a, 0x7be2b177, 0x75d13f82, 0xc04cd0c8, 0xb5dd31ab, 0xab295a94, 
	0x96bff54b, 0xf07ca7e6, 0x2fefad13, 0x63f19d6a, 0x9e30329f, 0x250b3019, 
	0xcdd0a21c, 0xa222f14f, 0x897b824b, 0x4fc327e2, 0x35f345fc, 0x3fa8ae82, 
	0xedfda968, 0x42abe61a, 0x3d107d37, 0xf11d6217, 0x6acdb122, 0x152be7a0, 
	0x7dc914bd, 0x697180df, 0x8ba025bc, 0xa3c7a319, 0x9e8216f5, 0x1f0422da, 
	0x976357ed, 0x7897d797, 0xf03ef9f9, 0xc43915c1, 0x5f34b157, 0xb241f265, 
	0xbc5a1444, 0xc6de121f, 0x5a1f7253, 0x6cee484b, 0x5cf9d170, 0xdfa243e2, 
	0xf92d84eb, 0x3ec1eb6c, 0xbc2655b0, 0x3161a4f4, 0x9f33f77d, 0x14c9ff0b, 
	0xf800dbe0, 0xef54fda9, 0x6b9642fc, 0x747c1943, 0x3d11f119, 0x978f557e, 
	0xf0aed3d7, 0xc33fcc39, 0x1df84be3, 0x2e5e25fc, 0xea7e4948, 0xa3d4fc97, 
	0x94af4ee4, 0x3f0eed3b, 0xcc338c65, 0xe480a94f, 0x7e0b37a7, 0x43eab804, 
	0x127ad456, 0xf89e59cf, 0xafd3f071, 0xc23a8977, 0x55c0c553, 0x3d2207d8, 
	0x74c033cb, 0xb7ee1af9, 0x8967b0bc, 0x5128f207, 0x3fc89afc, 0xd96d5f1b, 
	0x59bca425, 0xf14cbdd2, 0xbfbe62d7, 0xf92e3f43, 0x7cb767a7, 0x5bde8baf, 
	0xa13abe0e, 0xb16889f8, 0x2cb4fc05, 0x5f0e47cd, 0xd2a51f31, 0x7bd0e57c, 
	0xd62caf9a, 0x92be695f, 0x36fc0afa, 0x6af929d0, 0xfe315b90, 0x3f8fecb4, 
	0x0d92ed43, 0x1046652d, 0x0faab574, 0x727e65eb, 0xa5f311f1, 0xe627f8ad, 
	0xdd60abe2, 0xd067dac4, 0x4745176a, 0xc7f125d0, 0xc903f03c, 0x0fe013fb, 
	0x65701cab, 0x1743a5d2, 0x1ddf6a9d, 0x4fb9603a, 0x6a7ad17c, 0x71ede1be, 
	0xa92ccbd1, 0x5522fc17, 0x8eb9fe0e, 0x1c124e86, 0x23b9a183, 0xb3a766e4, 
	0x1f7bceff, 0xf49af295, 0x331561a4, 0x0f5e585e, 0x257f05eb, 0x5eab53d3, 
	0x0160fcc8, 0xe3c8b39e, 0x52df394c, 0xfa92ef6a, 0xe2fae489, 0x5e717cd1, 
	0xf5995eb9, 0x8e8742df, 0xfb50edde, 0xd65de8e0, 0xf5a359c3, 0xe3bbeb2e, 
	0x4b2f2f4a, 0x7de1bdeb, 0x5e184fe8, 0x667eb47d, 0x7a0cbcbd, 0xa0fb94d8, 
	0x49087dab, 0xb991d7bd, 0xfb3b170f, 0x8ed61a60, 0xcac3edb3, 0x4387db14, 
	0x95c73f52, 0x5fc61d7e, 0xa6ebd1c8, 0xf687dee1, 0xf7253352, 0xf20cbfa1, 
	0x694ed327, 0xe77f1c05, 0x736393a2, 0x7de19c78, 0x93d61fd8, 0xf4ebff63, 
	0xc2c9beeb, 0x7b015f6a, 0xc83ea5f7, 0xfb06e881, 0x9afdb735, 0x4fd71e24, 
	0x66fa16c9, 0x51fc7ffd, 0x0b2bde83, 0xe347db09, 0xb1757417, 0x0fabd41e, 
	0xf7e208f5, 0x86b242f6, 0xf6120f89, 0x4f5c6ce1, 0xa54e7ec0, 0xdb0c4bc7, 
	0x7e291dcf, 0x4cdd904e, 0xcd5713f7, 0xcf549e9d, 0x36ae076d, 0x4e81492d, 
	0x962d13e2, 0x3e371b1f, 0xe9f3129b, 0x3487a3b9, 0x25ed55d8, 0x79843d74, 
	0x3f21fbe6, 0x269425ae, 0x76564f09, 0xfe3e0da1, 0x3fb8b0ac, 0xc0a56c23, 
	0xd9e813c7, 0xcdf40afc, 0x10443dcd, 0x093d6a5d, 0x7b05a16f, 0x7369f695, 
	0xacf0f417, 0xc6886e44, 0xa32c444b, 0x57e11b7b, 0xb42cbbdf, 0x0fbff792, 
	0x67f6dc74, 0x12c5ffa2, 0x49b66fce, 0xf137b63c, 0xa9eb063c, 0xe90bd130, 
	0x784eb8b5, 0x8d13f820, 0x38da1a8f, 0xe1af2b6a, 0x9e88bc7e, 0xfefea5eb, 
	0x1ba74cf9, 0xc27e684b, 0x2ec235ff, 0x14c2bc07, 0x57443de5, 0x349f5617, 
	0x42af207a, 0x87211375, 0xc74505bd, 0x9f779a75, 0x665ba3b2, 0xdb88f76e, 
	0x2471745c, 0xb80174c2, 0x646dbdfe, 0xb5c7bc0b, 0x44ac4860, 0x3d92f04b, 
	0xcfb33f51, 0xc49b7053, 0xfc0bf00f, 0x7c2af778, 0x6278909c, 0x0bc0cdf2, 
	0x1e9c40e8, 0x99969f8d, 0x57c47b0f, 0x5facfc24, 0xb7d07e09, 0x796e6737, 
	0xe6d9d745, 0xcfcf2eff, 0xf0ae3af8, 0x5ede1427, 0x7f40e357, 0x68613e36, 
	0xa41f0037, 0x1e24b33f, 0xcf8cffc0, 0xa67c2ef9, 0x996dfca4, 0x038613f9, 
	0x7e7f0378, 0xe0e5985a, 0xc3ca8ef7, 0x0b8762e5, 0x2c39435f, 0x7c5afecf, 
	0x4dfd61f5, 0x3a30ff69, 0x27109ec1, 0xe50ada38, 0x13274473, 0xff3cd0b6, 
	0x3565cf42, 0xdad7fdf1, 0xd01e42b7, 0xf8f4e2f5, 0xebd743f5, 0xb7e1df18, 
	0x7579de9a, 0xaaf7bd3a, 0x92f98f7a, 0xe034b3c7, 0x93f2a6bf, 0xa110e846, 
	0xc0ef4bc5, 0xb0f1ebee, 0xa03cb85d, 0xc761daa5, 0xe239e886, 0x8e687d6b, 
	0x5a6afa16, 0x4a3ecc1e, 0xa3f7a02b, 0xeefffd3d, 0x28fbfda1, 0xb137afbd, 
	0x70013a9f, 0x80bf5365, 0x463fcbfa, 0x1b7ea0eb, 0x0afb48f1, 0xb7788eb9, 
	0x05dbbb84, 0xcf687477, 0x15273d6f, 0x7a4fb4dc, 0x47f652fb, 0x7347ffd6, 
	0xaff1a74a, 0xdfe5f6b8, 0xd9e88e41, 0xd674a757, 0xd073f69f, 0x41e0d1a7, 
	0x33fae75e, 0x3dbf1e41, 0xc369f742, 0xecfe68cb, 0x8d3eea53, 0x99e8d557, 
	0x3d3da42c, 0xbd761ba1, 0xba237849, 0x56dfdddf, 0x6aeb5c29, 0x4df5981b, 
	0x8784f5cf, 0xc85c9e43, 0x8eccf8c7, 0xdb63f0a9, 0x458e5692, 0x157e2472, 
	0xcfe82859, 0xe8913b25, 0xfbcf3aef, 0xf6e88d1e, 0xdd933fce, 0x5b400649, 
	0x6c4fb0b8, 0xb44abf81, 0xc0fa0633, 0x8cfe6f8c, 0xe7f8d914, 0xd43077ac, 
	0xa25eba25, 0x82d996f1, 0xffa9574c, 0x43f7dd8a, 0xf49ae7a2, 0x23bae77d, 
	0x455a6617, 0x4344576c, 0xb8f21fa2, 0xc9777801, 0xca57a8d7, 0xbe28dfa1, 
	0x30f1e476, 0x75a10d1e, 0xa3c2e1bd, 0x7bc617a2, 0x9ebbc2b1, 0xdde31fc6, 
	0xbe267f05, 0x053cd14f, 0x4fbad4a7, 0x2ac57f60, 0x7c3c73ec, 0xf410b4f5, 
	0xd335d578, 0x83dbe274, 0xe2bd9325, 0x09bef49d, 0x45b55cd3, 0xbaab2dfa, 
	0x3e78519f, 0x045bf0a9, 0xfef34efc, 0xbc6fc0bf, 0xa07ccbd1, 0x44f18d0b, 
	0x26cacc72, 0xb21d9e1a, 0xc974bb72, 0xf82fc04f, 0x8927adc2, 0x0df713fe, 
	0x21ee71c9, 0x9a161a80, 0x68bf810b, 0x796f93d3, 0xfc6e210c, 0xf07e15ec, 
	0xded4deb7, 0xe3763d0c, 0x1d7e6dbb, 0xf82797f4, 0x786f9bfd, 0xd8d08b5c, 
	0x5ec9acb7, 0xbfbc93a8, 0x29e0a5b5, 0x71cc97c8, 0x195623eb, 0xc73eb3f8, 
	0xe7a7125a, 0x965e4e1a, 0xf48386ef, 0xe01e11a8, 0x967454f6, 0xd62f1010, 
	0x3cb7da1a, 0xde689bb2, 0xbbab61c9, 0xcea9c68b, 0xde80bf16, 0x3c66141a, 
	0xe2f47849, 0xee1a64b9, 0x04b3d0c5, 0x118f63b7, 0xbfb0d9bd, 0xdedf4316, 
	0x70bb7d07, 0xc5a10c2b, 0xd0adcd13, 0x119f6c53, 0x9edf169e, 0x15b8869a, 
	0xe2f1fd75, 0x0dcdfeb4, 0x8f56ed5b, 0x884fbfba, 0x7ccc8b55, 0x9f8df3ec, 
	0xee2f9f9c, 0x03e4fc65, 0x5e0db93f, 0xf19d7811, 0xcfc6ef93, 0x01e240aa, 
	0x86e2cdd0, 0x0b8f0af9, 0xde680666, 0xd0be8d31, 0xfae937d8, 0xf7afd33e, 
	0xbe48ba48, 0xb0ba7678, 0x78cefb5c, 0x4bdcb8e1, 0x85ffb2af, 0x5f33f6f5, 
	0xbf249c94, 0x9d787da0, 0xceb0a54f, 0x1c39a1f6, 0xcef76b8f, 0xbd1cf8e5, 
	0x5ae580fd, 0xd5ef09df, 0xac93b07d, 0xc8a72ff9, 0x827b2108, 0x23d275fc, 
	0xed9e9b0d, 0xb4580f23, 0x9f7cf9bd, 0x57ffe097, 0xae971f25, 0x14fd205d, 
	0x665a97a5, 0x98fe646e, 0x0cb73d0c, 0x6fe906f6, 0x6fe5f69b, 0x5c85df48, 
	0xf856267a, 0x0da67a81, 0x047c067a, 0x7a06333d, 0xe0b7ab66, 0x30aba22d, 
	0xb9f84bc1, 0x09586bc5, 0x8f88efa2, 0x319d82c6, 0x85ed84bf, 0x0c9fabf6, 
	0x236adec3, 0x323d0cbd, 0x254e7040, 0x999fb4fc, 0x7cf47c24, 0x9cf92bdc, 
	0x3d32b4f1, 0xdd3c28df, 0xe4f18939, 0xaeb733d8, 0xa87b602e, 0xe9a4cd7d, 
	0x5f412bd3, 0xc7d8b5d6, 0xde393ea5, 0x4f9480aa, 0x063ed2b7, 0x5d3a241e, 
	0x69372be7, 0xb783649c, 0x3f7824dc, 0x3435cf49, 0xd8af39e1, 0xff0c56bc, 
	0xc3c42add, 0x3ee4871b, 0x6fa368c6, 0xae8eea36, 0xbfb27c92, 0x96b0f103, 
	0x6e43c727, 0xfb445adc, 0x5d687a40, 0xee31f51b, 0xec395f5a, 0x190d9bc4, 
	0xe3479907, 0xdfe348df, 0x2f022f44, 0x601ef69f, 0x1364357c, 0x92be88be, 
	0xf43e5d46, 0x78b64347, 0xef3bf80e, 0x462a8bfa, 0xd816ffac, 0xc577ac63, 
	0xd23b5d73, 0x8a6c35ef, 0x144ed2da, 0xde38bbe3, 0x62ef8e64, 0xdf1ad3bf, 
	0x1ed172c5, 0xf17245df, 0x4f5fa54e, 0x29d7f9fc, 0xa6c357d0, 0xf6827d25, 
	0xd5c95d76, 0x575a5e7d, 0x1123c2b1, 0x0d49db3b, 0x07db5def, 0x6bb1c63b, 
	0x0db44dd6, 0x332d31f8, 0x6afa645f, 0x227f3a3f, 0xf5726ee8, 0x5c1f8e29, 
	0x5dd33a0b, 0xfd8f65f4, 0x572fbb40, 0x30ee57d1, 0x85eabd7d, 0x916ab31d, 
	0xeb6af6cd, 0x3db3c7af, 0xc384e37b, 0xb73af806, 0x55811348, 0x43ace5a3, 
	0x108fe057, 0x280f7dd9, 0x93e1c43b, 0x8ee3d2a4, 0xe0b0d7fd, 0x3ae30365, 
	0x67176aeb, 0xf069ed0c, 0xf606d3e5, 0x66c8bdb7, 0xe665adbb, 0xd7b0bd1f, 
	0xceb453da, 0x6ea7e298, 0xceb46dd8, 0xf73ad71e, 0x75c0fb8d, 0xf7a3e68e, 
	0x6d6e2e98, 0xa6e3c05c, 0xc3e3d6f9, 0xdedf0e7c, 0x054c7988, 0x2c3edba7, 
	0xf92bfa2a, 0x3677cb36, 0xe29afdbe, 0x2f70da43, 0x3b69bee4, 0x85915df1, 
	0x222543f9, 0xa45e3f04, 0x6fb07dea, 0x7209a96e, 0xfd344edc, 0xb3c6fb8c, 
	0xf6f7dc25, 0x1043fad5, 0x31237efa, 0xcde7f891, 0x0ebcc519, 0x79e727ef, 
	0x6bfa01fe, 0xf4374941, 0x7ff1b9e6, 0x0116d0da, 0xbfc641ff, 0x49ff8c35, 
	0xfefb4e3c, 0x4d767491, 0x16559d26, 0x367495ff, 0xd0e1f18d, 0xfb82db79, 
	0x34a1c5db, 0xf3a0b93c, 0xc6bf9823, 0x5b1e74c7, 0x9bfe6230, 0x57dfe733, 
	0x31fb81fc, 0xbe39fe7a, 0xb39d0cff, 0xf921595c, 0x89f5fd9b, 0x1fc64a76, 
	0xf2ffd92c, 0x8685699e, 0x92e5ebe2, 0xa3af01ef, 0x8b0a6e57, 0xf9a7a007, 
	0x39697db9, 0xe781b900, 0x6cfc0e48, 0x4d7b94ac, 0x8b96719d, 0xcb62df3c, 
	0xe7fd0e53, 0x43c83bc8, 0x47a7ec9d, 0xc8e87d95, 0x1c3cb4c5, 0x63173f29, 
	0x3b53b7df, 0xdb172b49, 0xd6e63ca4, 0xffc8f7a0, 0xeba0d5bc, 0xba92d7a4, 
	0x3df8dfec, 0xaeab7f6a, 0x2c911d93, 0x79f3f7a5, 0x9ce5217c, 0x773e85e5, 
	0xc65fabd1, 0xfc10add9, 0x7057bfd2, 0xd318de89, 0x44c67269, 0x6ffe9cf9, 
	0xf6fadfdc, 0xd1e2a134, 0xcdfce823, 0x7ef1b719, 0x704add0b, 0x7d502b5e, 
	0x313f03c8, 0xae80f318, 0xe374fedb, 0x57ed0f04, 0xa42fd28d, 0xbec0167f, 
	0xa870da99, 0x9ae2f10c, 0xd9463fa1, 0xfd890aef, 0xed33a7b0, 0x9393d6b2, 
	0xfb047e38, 0x3c85942d, 0xce13d49a, 0xf9216f3e, 0xffdc106b, 0x8d7193ec, 
	0x3c1b925b, 0x40775a71, 0x7cdd30f3, 0x98e527df, 0x6fed1ef3, 0x3b7bca44, 
	0xf53ef90a, 0x0b9ee7f2, 0x82f4916d, 0xa0bae878, 0x170fa1b0, 0x5019f31d, 
	0xd764ad6e, 0x745e4fc0, 0xe008c9ec, 0xae48f7e5, 0x9be6a03c, 0x76d6f97a, 
	0x24c639e8, 0x6fb9cbd9, 0xf2f6cf5e, 0x7f9f97ba, 0xc9eb6d0e, 0x6ed8ca37, 
	0xccbf7fee, 0x3a2cefed, 0x8da5f726, 0x744f19c6, 0x0dd148ba, 0x1b758fc3, 
	0x16cf5976, 0xbfde23ac, 0xef45d255, 0xbecf045d, 0xfc8fd2b1, 0xa5975a8e, 
	0x5d62a6ec, 0x6f64bcc4, 0x2c7d0c56, 0x5a8f6dcb, 0xcfd1fac3, 0x289ad1fa, 
	0x7ad55e38, 0xfc28c9ec, 0x6b76eb11, 0x9fe8805a, 0xbacd0e7c, 0x68bdb477, 
	0x2d35dedd, 0x75fe7950, 0x32fd4b5a, 0x2af8485f, 0xf53c498a, 0x9d7cbd12, 
	0x70419ce0, 0x00ad45de, 0x0e886bbc, 0x8207af88, 0x02288615, 0x02c309f5, 
	0x7866849e, 0x70f684bf, 0x6b70c604, 0x7d32c1ef, 0x7e5f5c99, 0x7da7884a, 
	0x5cce8fd2, 0xbc5fb38f, 0x86b6c02e, 0xeb4a93d6, 0xac75e1ff, 0x63ec75a1, 
	0xc5d80df0, 0x6e1927e4, 0xcb17583f, 0x556f7fd9, 0x364f50fb, 0x7cf1e81f, 
	0xad41b2f4, 0x6b44f10b, 0x9c3f7a59, 0x7f8acf71, 0x9acb33c0, 0x70d237e6, 
	0xe7642206, 0x865ef5f3, 0x23c74d33, 0xe5ec9ff7, 0xfb0bd05d, 0x5bbbc572, 
	0x4305fd95, 0x65f89ebb, 0x5b3ecb9b, 0xbbc9e0dc, 0xff87dd51, 0x9561d0d8, 
	0x6df7976e, 0x06625cd2, 0xb47ea9ec, 0x6de016f6, 0xdb1e6a56, 0x3f2a35ff, 
	0x935fc0ee, 0x866f8fce, 0x2de9aa9c, 0x2d5f611f, 0xf6ca3fba, 0x9713f02b, 
	0xaced8572, 0xf6df78af, 0x7ee9ab69, 0x9ebfa5c3, 0x33b699d5, 0xcdf47fd7, 
	0x7cd08488, 0xd5e019ed, 0x0cf75f8a, 0x229af1c9, 0xec63ff45, 0xf7f938be, 
	0xfc8ec8a2, 0x7359d688, 0x9725f1fa, 0x77d6e71e, 0x1a976229, 0x87ec4672, 
	0x6a472079, 0x77323c54, 0xe67696d6, 0xec8959d3, 0xdc346a48, 0xc7693593, 
	0x0c14ccd5, 0xa3eaee7f, 0x4d23b111, 0xd2228bef, 0xeea9aacf, 0x081b688f, 
	0x7b773bef, 0x2fb15b3c, 0xb2fb0476, 0xdb396768, 0x3707a04b, 0xaea15cdd, 
	0x2ff9f15f, 0xf5d165f5, 0x8ed2682f, 0xd6cbec72, 0x147e0b97, 0xe8e8ae3a, 
	0x70fcb499, 0x26dfc5e6, 0xd036fe7a, 0x3cf96ad1, 0xf11eb7f6, 0x6bfe9bde, 
	0x4ff709f6, 0x35bef8d1, 0xdcafdee7, 0xf8768ee4, 0xe7908bc5, 0x666af7a1, 
	0xeb8e3987, 0x95f185e0, 0xa6bb8695, 0xb688cdf6, 0xd3c0affd, 0xc64dcbd7, 
	0x315617d3, 0xa7801a9e, 0x3e1db726, 0x6f18cf92, 0xb558d704, 0x417c6e6f, 
	0x1f9bd7af, 0x02bd64e9, 0x007f543c, 0x9bda261e, 0x1f356fc1, 0x74eb4c4b, 
	0x614585c9, 0xc48f67c2, 0xfb83588b, 0x1275a71b, 0x7fabeddf, 0x7c81ea27, 
	0x62bccbf0, 0x57e3cecd, 0x4a059f41, 0x26e408ed, 0x5fa917e7, 0xbfe24a73, 
	0x3813d55d, 0xa5c38679, 0x17e96f32, 0xefbc51fd, 0xad1a89e4, 0x169be704, 
	0x60e4bca9, 0xf323a5ef, 0xc979c332, 0x5c979cd9, 0x70a875d2, 0x6c7afd84, 
	0x1f4bdb3e, 0xb7887c21, 0xee8cbe55, 0x76cd9adb, 0x8f99c12f, 0x3828cc7c, 
	0x3a3ca5fb, 0x005f9c1f, 0x5710b69c, 0x8f9c12c6, 0x7e70b0f9, 0x02a1e57c, 
	0x9c30ebd0, 0x138602d6, 0x067a0a7c, 0x874e005f, 0x1fae995e, 0xc57ef73d, 
	0xd128a242, 0x604df6af, 0x869c1e5f, 0x6132c23c, 0x287fc116, 0xab1d14d6, 
	0x95fbe3fd, 0xaf59a388, 0xa091e3ba, 0x77d01ea7, 0xb8e2aac8, 0xf49a10a3, 
	0xd24d4cef, 0xce81a599, 0x107b1f20, 0xcab32ba7, 0x34fe92e2, 0x4e222bf6, 
	0xa5f854dc, 0x8ffa63dd, 0xfdb5b0b1, 0x2ccc3b88, 0x7eab4bb9, 0x4ba8710b, 
	0xf75eb735, 0xfeb7c668, 0xccd98c23, 0x48de9d6f, 0x3d4b8ee3, 0x6d4755d0, 
	0xdba2789e, 0xbfdc3903, 0x42c3eef5, 0xb703fb94, 0xc27b216f, 0xe8ba1c08, 
	0xd7df291e, 0xa7117876, 0x0790d5eb, 0xf14d0d08, 0x0acdc7ba, 0x72daa389, 
	0x6b561f8e, 0xac73e7a4, 0xfdc65f36, 0x7287c41e, 0x47be6168, 0x89bd3f21, 
	0x9745d138, 0x3a0fd879, 0x865c6738, 0x697ac088, 0xfc0e3c64, 0xba971991, 
	0x81f5abd3, 0xc67fd64e, 0x5c7b8bea, 0xe108ad71, 0xcb61f48d, 0xe0983fd5, 
	0x9fe19b41, 0xbfeb0cb7, 0x44505d8e, 0x2ed6252d, 0xd613ed0b, 0x8cbbef34, 
	0x4acd32cf, 0x642e3bcf, 0xf43a13fb, 0xfd865db0, 0xc0e2796e, 0x18a8ed34, 
	0x779d9bce, 0x1f1a7cfc, 0xeed2bdef, 0x8f77ef8c, 0xcbb21adf, 0x92c1fe30, 
	0xd6ec1a23, 0xe79f7471, 0x3971e579, 0x9e5a81cf, 0xfe1a7fe7, 0x9f7c561f, 
	0x4b070fb9, 0x071fdb04, 0x2b3b5e4b, 0x6cde20dd, 0xdfe0af5d, 0xee1f7ffb, 
	0xbc013a61, 0x78bd14cb, 0x7742f4d2, 0xd6162ed9, 0x345fe904, 0xa5aa3b4a, 
	0x827440bf, 0x051b1b1f, 0xd6dd59ec, 0xa9d93d64, 0x4720caf7, 0x68d54e5b, 
	0x9c5ecf2c, 0xd5be7063, 0xa2d9f994, 0x5d9f1952, 0x0b7afa7f, 0xdbf5d179, 
	0x45c75ce3, 0x548d1e53, 0xcad5fbd0, 0x36d98c1f, 0x976d57cf, 0x5a79a01d, 
	0x05995642, 0xb080fc23, 0xd27b7e65, 0x1f7dc804, 0xbc32c2e4, 0x90857047, 
	0x0cb27e1f, 0x17ef55f4, 0xea09fb66, 0x069d12d7, 0xc710eeb1, 0xf6cfad37, 
	0xf403ab0a, 0xfc8586f4, 0x932beb4c, 0xecfce3ae, 0xea5f2904, 0x1b77bd4f, 
	0xf52889ed, 0x41ad5ed3, 0xf1884d7d, 0xda8a5de8, 0xc937bc09, 0xbffc60f6, 
	0x48c7f1a1, 0xe71c76f8, 0x0ed971f8, 0x5f5bb7f2, 0x38a4b3d8, 0x5f12eaaa, 
	0xb07d7c87, 0xfabc83cc, 0x1655be17, 0x75dbe975, 0x7cb24e2f, 0xbf64fef4, 
	0xdfb0af13, 0x07f75cb7, 0xe17df37f, 0x6824e525, 0x8e95a4de, 0x7b2ab76b, 
	0x5b23feaa, 0x467a8576, 0xa6ce47d7, 0xb1b7f4f1, 0xf386730f, 0x13f7d8bb, 
	0x0bbf3f6f, 0xcbcb68fe, 0x6e1c92d4, 0xc73c7d7d, 0x424fa0dd, 0x089ea4cb, 
	0x7abf3e11, 0xd7f70164, 0x4fee3eda, 0xbefd4bf4, 0xeabfeb4e, 0x1b9cf727, 
	0xde9f863e, 0xb1d8efab, 0xe7e9984b, 0xebfdbc4e, 0x338bf05d, 0x85be85e7, 
	0x1a3d05dd, 0xeebfb922, 0x5578fedf, 0xfb979c96, 0xec214704, 0xca79cc8b, 
	0xe0493d3b, 0x98d1cc81, 0x78a5e88f, 0x9b8086e8, 0xedbae85f, 0x44bce01b, 
	0x00e480ac, 0x52f6d4a1, 0xa91748bf, 0xda5ff87c, 0x3163c641, 0x2b7e27de, 
	0x23ef1123, 0x8775f1b9, 0x26f174bf, 0xa7ee80e8, 0xbf76fd70, 0xb89d23f4, 
	0x8b8d317f, 0xaf93adbc, 0xf978bf60, 0x1758bf68, 0x16d7f621, 0x004c7d15, 
	0x049ca83e, 0x6fcb758d, 0x69c5960f, 0xafb3459c, 0x46eeabea, 0x5f7d6978, 
	0xa41fccaf, 0x03ade7c0, 0x446bd61e, 0x2f914742, 0x2cbfea28, 0x2fe77210, 
	0x7419be86, 0x9d036ff7, 0xce3ce69e, 0x7eb3c061, 0x7dd7d597, 0x0278f990, 
	0x9d168bea, 0x7c8a3e7c, 0x9a2ffac9, 0xd64f9813, 0x9fc167b4, 0x9ecaf75c, 
	0xcd344f3e, 0xb8fbc8ff, 0x793d45e5, 0x184b907d, 0x2f947907, 0xa37ca5f8, 
	0xeec3f657, 0xb91ef275, 0x20088146, 0xe5295a1f, 0xd2875392, 0xac7c9212, 
	0xf9be4887, 0x1715df54, 0xf32fdbb8, 0xada89b6f, 0x14b6fc24, 0xa895bcc9, 
	0xe340b125, 0x27a245ea, 0xb22aeaa2, 0x01db4a6e, 0xf3ef7857, 0x09967e23, 
	0x8242faef, 0xa6db8093, 0xf5315ce0, 0x51750d1a, 0x347a4aa4, 0xf27ea3c2, 
	0xa8f911b2, 0x2e788a96, 0xaf822eec, 0xf302fa07, 0xe8fd7e02, 0x98f23af5, 
	0x3ed2fc1b, 0x7248b962, 0xbb6d1df0, 0xc9dbf21f, 0x51ca648b, 0xff043796, 
	0xf7e97e63, 0xde835cb3, 0xf1b5988a, 0xa7eeb95e, 0xbcfb1f61, 0x9157dac5, 
	0xffa4b5ff, 0xb3f19118, 0xb5bdeafd, 0xd0fc47fe, 0xe53fec7b, 0x64cb9e33, 
	0x432adbbc, 0x0f33a5bd, 0x7c2e51db, 0xea7c54ee, 0xfb68efb4, 0x420b9c79, 
	0x554bfe92, 0x7514a1fc, 0x79a93724, 0x57f6c8fe, 0xb9cee419, 0x90f183d6, 
	0x6f8af18f, 0x63ce35fa, 0x87f80f0b, 0x720346ec, 0x0f4aac93, 0x5dec9ef8, 
	0xda4cfa23, 0x40d6a3ef, 0xd17e244e, 0x6571d71d, 0xb069ad62, 0x1a64579d, 
	0x6bd72fc8, 0xb043e649, 0x4749d727, 0x5f507af6, 0x5f6ae5f4, 0x89a1f231, 
	0x09c46988, 0x176a1bee, 0xa0ddeb14, 0xc84e8a83, 0x93a26ceb, 0x67820cc0, 
	0x3c429992, 0xe747fd6d, 0x932f22e7, 0x185c2a1b, 0x985e1c84, 0x07ec4bc8, 
	0x711bd79f, 0x22dd7f1a, 0xa5fc2e6f, 0xd015e6b8, 0x0dbef407, 0xa0bfa7fa, 
	0xc64d4be4, 0xc917f6d1, 0x55eeb178, 0xfb9337f1, 0xfb23cb21, 0xbe87d321, 
	0x335f65b0, 0x2f3d662e, 0x38be8952, 0x48befbc1, 0xe415bdf5, 0x37facaf7, 
	0xafd88e40, 0x6a3db3f5, 0xbb4a4e06, 0xe53c0034, 0x75c8330b, 0x783c66a8, 
	0xa255e386, 0x6c6e05eb, 0x472929cf, 0x9bce787d, 0x78e093df, 0x5af2dfb2, 
	0x1da99cfc, 0x4768e391, 0xdded9f65, 0xbbd920ae, 0x7a5fb81b, 0x4bb7e784, 
	0x37bf528f, 0x5d02e528, 0xbc98e0bf, 0x1b8f017e, 0xc3ae1e12, 0xbc3bb624, 
	0xf2aae991, 0xb4fed417, 0x17a61df8, 0x02fa9bfa, 0x1ea7b75f, 0xd29cd6e3, 
	0x1931f12f, 0xf1bd7fef, 0x0fb0fbe6, 0x41e4def4, 0x329c6f19, 0xe6f5adc4, 
	0x8a6e7a19, 0xef74bc4f, 0x63dc74da, 0xcd98e4df, 0x7158f5f6, 0x3b012bac, 
	0xfba8bcde, 0xb647c730, 0x13ff446d, 0x9eba1ba9, 0xd66036a2, 0xcf36fd6c, 
	0x11eb1cfb, 0x67e591c8, 0x5a16bfc9, 0xd0efef5c, 0xe5ff43a7, 0x5fa72921, 
	0xa9baaa0a, 0x63ae71ed, 0x0e823d02, 0x98c3e013, 0x21d4e38a, 0x3d306a0c, 
	0x959efcb1, 0x259a5ba6, 0xe49bf79f, 0x21dfe71b, 0xf9719e8f, 0x577f8ab7, 
	0xfc45ae20, 0x6ad55837, 0x15b9e944, 0x2dbe5837, 0x4d9dc81e, 0xf16bd065, 
	0xf9f3a252, 0x203cfc42, 0x646e71f5, 0xfb0a2fa0, 0xb7394857, 0x84e663fc, 
	0x7fcbf26e, 0xf67e901a, 0x9e07253a, 0xe3bcca0f, 0xbeaae9ba, 0x1c80e085, 
	0xf7be568f, 0xca4c5658, 0x6a41acd7, 0x6674e72b, 0x4ae7a49d, 0x72c41fa5, 
	0x93d841f8, 0xb20159be, 0x3e1327bf, 0xcb0f08b2, 0x91aec8db, 0x25f5c67c, 
	0xe60a572d, 0x1ca61a03, 0x75e7dc7d, 0xeb865ea3, 0x7772ac4f, 0xacdb4cdd, 
	0xe43e65bd, 0x84e62a2f, 0x305c5572, 0x2976cbd4, 0x8b89dbe3, 0xaf6dde5a, 
	0xd3580f22, 0xb8e72f1b, 0x59c64840, 0xfb94846a, 0xee038fc8, 0x7d790103, 
	0xce62c6c6, 0x0e34ce7b, 0x649df445, 0xfc65040f, 0x7e3b5eb0, 0xcfed1b64, 
	0xf77142ba, 0x8563f866, 0x63ee47fd, 0x215622b9, 0xa1f186be, 0x07719d9c, 
	0x446ddfef, 0x4a273e49, 0xd10b632d, 0x7e3463c5, 0x6276e488, 0xda2371f0, 
	0xd8fbaae3, 0x9d630e20, 0x0301c289, 0x566258f6, 0x10e8eb92, 0x9d128eff, 
	0xbdfaf9de, 0x7c4eaae5, 0x5df13742, 0x27a5e227, 0x2ca47f58, 0xbc531fd2, 
	0x4f40fb87, 0xfcfebe77, 0x5d73ac6e, 0x05e71d61, 0xf8c80bde, 0x546d4776, 
	0x2f5f8bc6, 0xe3f5dcb0, 0x92bf7483, 0xd46ff5d6, 0x5b73f116, 0x8d3c710c, 
	0x23de04ff, 0xa9543dfc, 0xdd7e2395, 0x31eba119, 0x0dd8ebae, 0x633cea26, 
	0xd490bdb1, 0x73823e69, 0xcbea4075, 0x8eb2d9b6, 0x7f97ee8e, 0x71a2eb0f, 
	0x0df9e9ab, 0x71f55ef4, 0x3d357cf9, 0xdbcc4bff, 0xc7879e94, 0xc25c6a17, 
	0x5fba4ad7, 0x5af5c4de, 0x70375c55, 0xb083cf74, 0xa1fdd7c7, 0x237c40d5, 
	0x25f3cbae, 0xdf2c9109, 0xfb38bd07, 0xc24af285, 0x87bc29df, 0xccb56af8, 
	0x1fa43f13, 0xf76032ae, 0x949cad27, 0x6ec6af94, 0xb764e9d8, 0x98c936ee, 
	0xf1e07851, 0xee6a8e89, 0xf6561e8f, 0x79f051d3, 0x696faa8b, 0xbd24f951, 
	0x9fa9dbda, 0xa2203964, 0x05773744, 0xc810bda4, 0x1d455fb3, 0x1fdefe95, 
	0xfefc855e, 0x55c0e818, 0x203a72a7, 0x4a0edff9, 0x78d4b4fa, 0x3d4a0fdf, 
	0x376e1fa6, 0x61c4eeb0, 0x7551e89f, 0xc9d3f823, 0xe2a8d946, 0x5b8c28b3, 
	0xa2e9e67f, 0x7ae69f7b, 0x64e51d1c, 0x786ccfeb, 0xaf155ef1, 0x8e1e9885, 
	0x0d84fb4b, 0xcd244e7e, 0x6f04b1bc, 0x8744f3e2, 0xd4809a20, 0xab886dc3, 
	0x4a59aec2, 0xb25fd9d7, 0xaec5ee8c, 0x15b1a17a, 0xc8e3c716, 0x7ec14def, 
	0xafb7bb1b, 0x9f109e7c, 0x82faca0b, 0x11be799f, 0xa728f9c0, 0x3ac6a94e, 
	0x33100116, 0xe408dead, 0x6f56e5cc, 0xf436887e, 0x66472521, 0xe467590a, 
	0x1b0b71f8, 0x80d09113, 0x2ec8e7f2, 0x9fc95cbc, 0xf7e45d06, 0x7a9ec014, 
	0x56f59024, 0x01fc9f9a, 0xd1de7f29, 0xbd80107e, 0xec0d3883, 0x8ce04f83, 
	0x5ba66ac5, 0x3d43be23, 0x1b54ed2f, 0x3e4cf871, 0x7b9284fc, 0x2f821f0e, 
	0x960fdb05, 0x7247fb0f, 0x4b3a8232, 0xefa1f36a, 0x42e4ae7f, 0x7fde527d, 
	0xa2fd202d, 0xaf9f3c06, 0x13e7e39e, 0xa45fa1f9, 0x89f587f1, 0xb14f2952, 
	0xfaff2caf, 0x099c3c95, 0xba6e68f9, 0x756bee57, 0x4f3a093c, 0x950b5d32, 
	0x2e004867, 0x77db7fb2, 0x1e41492e, 0x3c777638, 0xf230f0bf, 0x0be3e742, 
	0xf024c1f0, 0x85873a97, 0x80e76171, 0x2507421f, 0x2c5f63dd, 0xdc5afd67, 
	0xe187bb07, 0x5ab0fd45, 0x4942bae7, 0x3d3fd0a7, 0xf554d704, 0x512342de, 
	0x76d2062e, 0x3bdf23b6, 0x9045372b, 0x5f36a4e7, 0x9d7a395c, 0xad7ed46b, 
	0xd1307d43, 0xfd194be3, 0x6df27084, 0xe7ad2f04, 0xa3380ce5, 0x919f141b, 
	0x193a031f, 0x2ef7f7a6, 0xc53c853e, 0x2c6f8a65, 0x57bc1ecd, 0x3e92c7c5, 
	0xfe890725, 0x625ecca6, 0x90fd1e20, 0xfbce8b92, 0x7e528393, 0x23ad518d, 
	0xfc821f2f, 0x97f78e3a, 0xe34b5794, 0xc57beca1, 0x4dc839f2, 0x45c811c8, 
	0x49c837c8, 0x92169e67, 0x83a3c07f, 0x562e477f, 0x29bca504, 0xa814f350, 
	0x85b00271, 0x2c7bf34e, 0xf81f3157, 0xfb13f209, 0x7ed5d09d, 0xb11def57, 
	0x5af41ddf, 0x745e4b97, 0x43f97cd0, 0xd0f17969, 0x9303cbc5, 0x27ea1948, 
	0x6be7b8de, 0x7f88e76c, 0xec92fc45, 0x4377359e, 0xf30486e0, 0xbfe2874d, 
	0x4053fce1, 0xd567bdea, 0x79f438fe, 0x95e2382e, 0x795c309a, 0x932a87a4, 
	0x72534d4f, 0x0eb60909, 0xfcf14cb2, 0x0cdbd986, 0xd9d01f27, 0xe496ee76, 
	0xd6d353fa, 0x0f6b968e, 0x438fba29, 0x2e8a1b2e, 0xc1be2b4e, 0x36e7d875, 
	0x8f8227fc, 0x86a1f1e8, 0x1e875c79, 0xb275946f, 0xa65efb99, 0xd65a31e4, 
	0x96174b97, 0x3127c7bb, 0x3a7b0552, 0x4f875c73, 0x4da96f09, 0x377adf12, 
	0x8d43d9d1, 0xfe3b3e6a, 0xdecb8174, 0x7a7a3a24, 0x8d97da92, 0xb7ee0aed, 
	0xbaf370d3, 0x2ae32f88, 0x917e4dde, 0x82ffbf0d, 0xc9d0326a, 0xc70f8a2f, 
	0xbd721653, 0xc9a27c7c, 0x6178c0f9, 0xaf3b9a72, 0xb8ec7a86, 0xc91f7d73, 
	0xa0daed5b, 0xf3720b78, 0xcdc841f3, 0x6abf8a45, 0x206b3f6a, 0xf6a8b29e, 
	0xf61d5157, 0x22afed4b, 0xa5de4fc8, 0x7b0f51f0, 0x72ecf896, 0x9feb473c, 
	0x80c3bb59, 0x76bcbf3c, 0xa3de3e47, 0xef44247e, 0xfa941cdd, 0xb8dbe1c4, 
	0x4af1bf92, 0xd39bef92, 0x46e31cf2, 0x8bbe4fd9, 0xe7ab88e1, 0xdcb6dec9, 
	0xff33a2fe, 0xe65eca5d, 0xd718adfa, 0x1d02ed75, 0xba4e7e30, 0xf133b3ea, 
	0xc7591a12, 0x759612d5, 0x475571ec, 0x0513e4e0, 0x874457f2, 0x069273eb, 
	0x0d12d6ea, 0x827b6e5e, 0xa1dadd4e, 0x44c3c86e, 0xa53e7cc3, 0xccebc0e2, 
	0xe7c149bb, 0x3ae183b4, 0x4e3a4203, 0xadd7247e, 0x3cb1d5e5, 0x7cba8b8b, 
	0x6c7f55c0, 0xff8cf9e4, 0x6ffb3bf0, 0xa2bf033f, 0xeaa6442c, 0x16fe34f2, 
	0x83ae715b, 0xfde8844f, 0x0623967e, 0xa0f308e8, 0x7799c41e, 0xa7f25063, 
	0x4dfd2f33, 0xcf7e901e, 0x5a741fb0, 0x919ca7f6, 0x55fe11fd, 0x50777faf, 
	0x47d7c35b, 0xef8857f8, 0x3f57e3b8, 0x9f937cf3, 0x7dc79c43, 0xc5d7f39d, 
	0xc73bf423, 0xcefd1c65, 0xefd1defa, 0x281c6427, 0x3e4bfd2e, 0xffe8eccf, 
	0x5effdeb4, 0xdf7ac430, 0x4abe2b8c, 0xf8bbb475, 0x184c92a2, 0xd02e8bf2, 
	0xf080fc65, 0x3acdf316, 0x7c387f07, 0xf859bd04, 0x7fd434c4, 0x93cab94e, 
	0x1d817d8d, 0x85f9c3e3, 0x3e486590, 0x2fc4fba2, 0x0c8b83cb, 0x35c7bfd4, 
	0xc971e88f, 0xfd80b6b3, 0xa23fe396, 0xbf53316e, 0x17d639e8, 0xcf832f41, 
	0x26c29b5d, 0xfd4908ae, 0x4dbc2279, 0xdfef19c6, 0x71f50bb2, 0xe3d7539f, 
	0x88c3a289, 0xbd13c503, 0x35913829, 0x27cb217a, 0x9be2f9e8, 0xd6bf8f46, 
	0x3ba0cbff, 0x4a8ff22e, 0x85f6387e, 0x720b1c57, 0x711ce41c, 0xfbb28898, 
	0xf92d551e, 0x68772cbb, 0xc738aaa6, 0x4bff1c39, 0x30ce2a68, 0x599fafc2, 
	0x35609bf2, 0xf323e1fb, 0x0ab7f459, 0x9f3323fa, 0xc6fb3425, 0x5f4fd2d3, 
	0x6fb93905, 0xff66c89c, 0xc2744f3a, 0x30e86edf, 0x59f2a2fe, 0x9024f537, 
	0xdce44acf, 0x1b36f8cd, 0x60e2d671, 0xffc1dbc9, 0xef59f21f, 0x3be33468, 
	0x27c273a0, 0x1cf41ff8, 0xcb4fe1c5, 0xe41871cb, 0x39571101, 0x34e394ba, 
	0x954de537, 0xd39e9b71, 0x47ebf70c, 0x947d554b, 0x498a3a15, 0xbc050f50, 
	0x10875916, 0x4bd74cc7, 0x9c79e58d, 0x6eaf3fba, 0x1777a07a, 0xc485c7f9, 
	0xfa05f8d9, 0x656e75cb, 0xaa9ee7ca, 0xf88c39c2, 0xe9fff219, 0x755529fd, 
	0x9f43e8e5, 0xf884a4f5, 0x40c7e517, 0xfacec20f, 0x3aaf4747, 0xaf88e475, 
	0x7b7a280e, 0xfe375d3d, 0x6d4eca37, 0xc8bf27f0, 0x7e2b4171, 0x9a9bcc9d, 
	0x389fc1af, 0x212ebcaf, 0x449c853e, 0x8cabef5e, 0x8c4d3287, 0xd0b5ebce, 
	0xe2dbe475, 0x0235ebc8, 0xb178739f, 0x5f3f1de7, 0xce17c9e9, 0xfe43d79e, 
	0x8c73e306, 0xaf3a4d6c, 0x64617f17, 0x4960ef5e, 0x7ff9e31d, 0x102c9e5a, 
	0x89c07292, 0xf92c1f07, 0x7bea486c, 0x3fc43492, 0xb3c74735, 0x20a7f95c, 
	0x42ce0f6a, 0x60aea797, 0x9cdc9cba, 0xe8b2e92b, 0x31bf860d, 0x1974c554, 
	0xc83a290d, 0x73ce4fa0, 0xdcdeae83, 0x56f50bb3, 0x7aa4487a, 0xada7902a, 
	0x287f0c38, 0x52fcd43a, 0xe7eae894, 0x5cfd4f4a, 0xed9555d1, 0x7460e791, 
	0xc70547c2, 0x072f384d, 0x00763eb9, 0x55b3f9f6, 0x3752c75c, 0x4e692eb2, 
	0xcc22a783, 0xfae4d7f2, 0xb30e8683, 0x47d56efc, 0x74bcebfe, 0xf0745610, 
	0x83a1dc4a, 0xe60e9b88, 0xd05cec84, 0x011d70c1, 0xbe824fdd, 0xa491f95e, 
	0x794bde83, 0x827a9c83, 0xf52303fa, 0x9b7daff9, 0x538fd042, 0x62e60e1b, 
	0x3790133d, 0xd0d53921, 0x750a92d0, 0x0951e3a5, 0xc7a5d65d, 0x21cf85c3, 
	0xd7aab2de, 0x297ec623, 0x9f63b70d, 0xf2645aac, 0x611bc6b9, 0xf92f5c47, 
	0xc92c99e9, 0x432ccf5f, 0xbf63595c, 0x8e3719cb, 0xcd2338fa, 0xcb7903af, 
	0x3e90d10d, 0x4afcc16f, 0xce06f7f4, 0x9c46ad12, 0x51bb0ff8, 0x5f0f10cf, 
	0x6e7887dd, 0x5efc9d7d, 0x67dad4c9, 0xa26fe0cb, 0x44ec72ee, 0x9085bd57, 
	0x632dcff6, 0x5fbba34c, 0x1d45cfde, 0xfd806855, 0x309e68fd, 0x0eb21543, 
	0xe5d7bbab, 0xa9850787, 0xbd1c3d73, 0xf8fe0cb7, 0xd07a2332, 0x47884fb5, 
	0xea55bcd2, 0xb07c6fbc, 0xd973e0d5, 0x5b2c1c57, 0x191a7909, 0xb88e7030, 
	0x36fa91b5, 0xfcf8bbc7, 0xb3ed6b72, 0xbb372b55, 0xec5c43e0, 0x5a78e96b, 
	0xaac1e77c, 0xb471c590, 0xe78c68f2, 0x9e86ef2f, 0xbf8f39db, 0xcfc4e273, 
	0xae56e334, 0x2488e9d7, 0x5c78bcf9, 0xb13f038d, 0xcfebe492, 0xc93c64b3, 
	0x5f5babf1, 0x9c22e797, 0x259a7f79, 0x84af58e3, 0xf1c71fa4, 0xb7ec65cc, 
	0x7c798b95, 0xfb027cae, 0xb8ab2f87, 0xdb0ff299, 0xc47288ce, 0x17675b7f, 
	0xfdcb888e, 0x85fa4b24, 0x7ef1ab2f, 0x13bbf8ae, 0x7bc32de3, 0xefe7fb36, 
	0x57c4f468, 0xa0337d94, 0xf947a1ec, 0x58b65cdc, 0xf822eca6, 0x8e49d5e1, 
	0xf906e9eb, 0xc4eeb42d, 0x678c39c9, 0xae68dbf6, 0x9afc6977, 0x19c773a6, 
	0x248f4a12, 0x8cc91e94, 0x3421fd7f, 0x3bf5fe32, 0xdb9cdf65, 0x1f191f4f, 
	0x89c84bfb, 0xf8e02d7f, 0x8fb0fc57, 0x103e41e7, 0x1556ab71, 0xd4b232b7, 
	0xd7152df9, 0x7992cd2a, 0xa6799fa9, 0x105ea165, 0xcbd62a71, 0xc1f6f763, 
	0x91fc749e, 0xfe392cfc, 0x998f0aeb, 0xb45bbdf1, 0xbb07bdb4, 0x398b89c9, 
	0xb07d62f0, 0xcf569c97, 0xfa08bfb1, 0x53f37c1a, 0xc98de76c, 0x17bcec72, 
	0x7add8f38, 0xae41747f, 0xabf84b92, 0xae305939, 0x86a725c4, 0xfec33ee9, 
	0x4f5cf8c3, 0x3a076196, 0x14d783f1, 0x73c3de9e, 0xc9e7e0a7, 0xaa94ccb8, 
	0xb7f21181, 0x5977f215, 0x1506fe5a, 0xfe42d0de, 0x73c949fe, 0x61d1275e, 
	0x863d95e2, 0xf1cea3c7, 0x17e3496e, 0xf855cff8, 0xbe25d6ef, 0xcaef8c43, 
	0x4cb9c82c, 0x03f1c0ff, 0xfa97bed8, 0x83fa0fa5, 0x1dd401fd, 0x74bc92f4, 
	0xd95ebf3d, 0xe149eb49, 0xa3968e02, 0x209d724f, 0xf3ac53ec, 0x4bc7b696, 
	0xf9d04123, 0xdcf76cbb, 0x529ceb74, 0x5e37fa8d, 0xdaf8def3, 0xd8f459c0, 
	0x1eb38f81, 0x9661a27b, 0xfe56a7b4, 0xe5a1fb8a, 0x8f503fb3, 0x64d19e91, 
	0xf0d4cfbe, 0xdfd4e01c, 0xd2cbaf75, 0x15fd217e, 0x5adc0bff, 0xfda857fe, 
	0x8f19d06d, 0xc3865fec, 0xfcc8f68e, 0xb2e12695, 0x587f439f, 0xbe9115df, 
	0x6f5a3bdb, 0x5aa57938, 0x788d93db, 0xf24b2c63, 0x7d874353, 0x352ae025, 
	0xce20f07f, 0x3f9995f3, 0xa18be158, 0xbd2791ff, 0xcbbea5fb, 0x7e7e995f, 
	0x9b9bbe94, 0x48d4f650, 0x6428b73d, 0x58e7a147, 0x3f73f1bf, 0xd294f696, 
	0x2df6bf6f, 0x975c42cb, 0xd2bf4ff5, 0xf5a4cf27, 0x5493eb10, 0x7a38ff5a, 
	0x93cbc9c5, 0x3f87e27f, 0xa6e4b071, 0x5157b62c, 0x403f06d7, 0xca8db5d5, 
	0x3df53b8f, 0xd33887a0, 0xdf95b7c3, 0x324dd5d3, 0x42e96aa7, 0xc01d7df9, 
	0x86d6e341, 0x587177e4, 0xaf3e11be, 0x633cd4f8, 0x17e571e5, 0x047895ee, 
	0xfef93b7f, 0x6ab07db8, 0x3c967ea5, 0x5bac8572, 0x3b60ba21, 0x5cf3a844, 
	0xc6f38d55, 0x2be4bea3, 0x4e5644de, 0xb71f5a53, 0x5ca6bf40, 0x7e3e8178, 
	0x078fad26, 0x0653da5e, 0x63e8eb7d, 0xad2f97c6, 0x335f197f, 0xea7278d3, 
	0xcb085f95, 0x73cb7478, 0x4679f3cf, 0x4378d7e8, 0xbeb27f5a, 0xcb7d6913, 
	0x9551f67a, 0xf4a659ef, 0x67a53cef, 0xfa7ad307, 0x5876fa7c, 0x3b7d2a4f, 
	0xbd2a4f4a, 0x40727acb, 0xf31d4de9, 0xc9f58a7e, 0x22b97d08, 0x49fd571d, 
	0xcf9dc658, 0x17bf2fa5, 0x4cad7a96, 0xa527acb5, 0xfb0130bf, 0x2c9e90fb, 
	0x1101f3e3, 0xb37aacf3, 0x41c65aa5, 0xe67f41d6, 0xbcc8fee3, 0x32c277d6, 
	0x2c3e3abe, 0x20f7e8f5, 0xf5a756f7, 0x3233bae7, 0xbd3e7dbe, 0x46751098, 
	0x95e64c6f, 0xc49e948a, 0x2e0d8479, 0x54ed3c79, 0x4f7acfda, 0x138e6fc9, 
	0x84e3a4f6, 0xe16f6653, 0x2ea760bc, 0xea9d51f3, 0x6f0383bc, 0x0fda586e, 
	0x3e24b327, 0x6c5e275a, 0x3ec2dcb1, 0xd2bc7076, 0xce965ea8, 0xbf5f61a3, 
	0x3cfd23b7, 0x6ee5edf9, 0xb4f9393c, 0xbc79f924, 0x41f6a14e, 0x851119d9, 
	0xbb28df97, 0xcc5f69c5, 0xdf8cf292, 0x8c3b7953, 0xb0fcd167, 0x2ff91603, 
	0xa1fc42ca, 0xbdfa24de, 0xb28b8857, 0x84b21ea4, 0x2487078a, 0x30789d1e, 
	0xcb975b44, 0xcb1e877e, 0x12b1e577, 0x5098add7, 0xb4b88f53, 0xbd7bcdef, 
	0xd79e971c, 0x7ff1f32d, 0xb9b884de, 0xf3263fb0, 0xa750e65e, 0xca3fba36, 
	0x1a4fcdbf, 0xfd96ff6e, 0x9f7293da, 0xdfa34d42, 0x02b90a9f, 0x73f4b7f9, 
	0xcaabb71c, 0xa7a113ab, 0xbb5bb9f8, 0x4fbd2dfe, 0x461da589, 0xf7078a91, 
	0x777f721a, 0x5dedfda8, 0xaadc7a39, 0x4fe3718c, 0x164bff1f, 0xb0fe2b8f, 
	0xc6e7f7f1, 0x70c5f817, 0xd21ff1c5, 0x94aa5aeb, 0xfe0290dd, 0x4b32e1c4, 
	0x8987e3d1, 0xb6386f9f, 0xc78aa5a0, 0xd6efab33, 0x7a2af35c, 0x31dffa67, 
	0xc33bee9a, 0x2a141ed2, 0xb59ffdbe, 0xa586670b, 0x93c810bd, 0x8517d5f5, 
	0xea775ea5, 0x85db47ad, 0x74157ddf, 0x9b85d8ef, 0x1aaed2c3, 0xdb4d279d, 
	0x279c1f89, 0xe657b29d, 0xadb5cb49, 0xa4f3f9d6, 0x8d279571, 0x7b64de7f, 
	0xc6586173, 0x5279d3a1, 0xcd49e553, 0xdcd27991, 0x6e693c8c, 0x8af49e66, 
	0x93c987f0, 0x755d8636, 0xfad22b09, 0x7c6f7110, 0x707100bf, 0xeefc4eb4, 
	0x5e0e21bf, 0x2ddb7386, 0x10ca870d, 0xf0435f07, 0xf3e29c34, 0x27a0bbfb, 
	0xb707105a, 0x6fc1c746, 0x72fe4b0a, 0xc1c673da, 0x47c82d8f, 0x7707199b, 
	0x64d471ce, 0x8aa8fb8c, 0xfb2ab547, 0x208d1de6, 0x1f1dcb7a, 0x7b0f979f, 
	0xe3e2317a, 0xcb87b431, 0x0771f1dc, 0xe0511b9e, 0x9e1a76f8, 0x44ed71d1, 
	0xdae283f8, 0xf5c817d8, 0x8eb5d973, 0xd147b19f, 0x1737c3b7, 0xc83f79aa, 
	0x2f88c8df, 0xb2e795ef, 0x5c77364c, 0xdc54dff1, 0xbf2f8aef, 0xf40a6d7c, 
	0x6670cdf3, 0x6fd9f97c, 0x8e3bf08c, 0x32571f8d, 0x9c8f8ae4, 0x299cde27, 
	0x77e7323f, 0xb57290fc, 0xd4b0aece, 0x6327c8ab, 0xb23fb490, 0x3fe21777, 
	0xdd078ae7, 0xed05f6a7, 0x2191fd08, 0x79d74697, 0x62fb19d4, 0xc80f3ae9, 
	0x6c87d429, 0x7d05c170, 0x4f1cf0cc, 0xc2baefe7, 0xaccbd767, 0x0f92cf27, 
	0x8fd29dfc, 0x847652bf, 0x443cbf63, 0x3d08c3f6, 0xa0cab21c, 0x1e157f87, 
	0x6c32c759, 0x7e4684af, 0xd55ff1af, 0xf1a92f78, 0xe0af1f59, 0xdc795a38, 
	0x832ee352, 0xbd71a5fe, 0xdea95ed2, 0x9e879f22, 0x68eb1a7f, 0x65fe1e82, 
	0xed7bc658, 0xd3bd2a2f, 0xbc01dedb, 0xe01ebd9d, 0xc4f87afc, 0x0fcc8d50, 
	0xfce5ef7b, 0xf20c7f70, 0xa9f0f48d, 0xcab2f0bb, 0x5f3f9f0f, 0x51b83e6b, 
	0xf41d1bea, 0x32782e72, 0xd7e91cf5, 0xe8464ac7, 0xf77f24b9, 0xb9eb43f5, 
	0x5563e4ea, 0x87760f12, 0x75ef95df, 0xf239eff4, 0xa587afbe, 0x346b451c, 
	0xd7ff3d49, 0xd7337de4, 0x75f79c3b, 0x07e3b5e6, 0x48fc5df2, 0xa26073f4, 
	0x35087e7c, 0xcf8de7bc, 0x89c67b2b, 0xbe2b97cf, 0x0df15d79, 0x37e140ea, 
	0x7ed4d2de, 0xb777e229, 0x1a727dae, 0x1f4b3ee8, 0xf43fcf27, 0x2eb8d35a, 
	0x481bc714, 0x395c0d5e, 0x77a2cda4, 0x20b92e07, 0xdbe8fa1b, 0x3cf7cc9a, 
	0x25afa5fc, 0x637c8f10, 0x08475b42, 0xc59b0d75, 0xdf345d5d, 0xffa96c94, 
	0x17d42f80, 0x7e9ae746, 0x8531adc8, 0x733886a6, 0x74fbf154, 0xe03c6e7a, 
	0x14eefea9, 0x27efb7cc, 0xdedf3cd9, 0xf1b3d399, 0xda5ba01d, 0xa5ce54e6, 
	0xba6fb7fe, 0x3ff60a70, 0x0d5b5b1c, 0x89d416fc, 0x3e23ef4b, 0x6d6c7f09, 
	0x62f33935, 0xcd29c3cc, 0xa7d900f3, 0xe46e5cea, 0xd47eb586, 0x8b3785c3, 
	0x15af196a, 0xc88a98c8, 0xa8fc9b97, 0xeca37fc7, 0x1dd6248e, 0x50cf635e, 
	0xec5635f7, 0x1fc00b88, 0x23ca6efb, 0x54ee008e, 0x2e254755, 0x3d74dc13, 
	0xf9f3ad52, 0x52db31b4, 0x86b70f1e, 0xba367a0f, 0xef83dfb9, 0x017f5148, 
	0x5f7447e2, 0xbb843d03, 0xe02745aa, 0x50d31b9b, 0x8db85c07, 0xae10922c, 
	0x693a26d7, 0x5d1e8c7f, 0xf9a0ce74, 0xf7f189ee, 0x4dccc6f0, 0xffa43d25, 
	0x8d1eb7f3, 0x868e5fc3, 0xcf7c11c5, 0xfe729850, 0x50244a70, 0x51f039df, 
	0xfdc62f82, 0xcc313ddb, 0x837feb4f, 0x15b0a5ec, 0xb663f3c7, 0x00fe78c5, 
	0xfba72de0, 0x6fd33ab5, 0x3fcc6e70, 0xf7df196f, 0x75f9762f, 0xe7a5df03, 
	0x7dfcdc69, 0x6a06e746, 0xb6199f83, 0x77a03a07, 0xb4d668c7, 0x1ba651e4, 
	0x04c68036, 0xeae8dfa8, 0x7de47b0b, 0xbef23daf, 0x640fd196, 0xed757f3c, 
	0x1ba79c74, 0xddd31013, 0x413ef1cf, 0x24ad85ff, 0x76baabaf, 0xc41bc73a, 
	0x6369bca5, 0xe31f52b6, 0x3cd56ac4, 0x40478c96, 0xa709096f, 0x27d5d476, 
	0x27dc4738, 0xd7dc4738, 0x8c81fa32, 0xdd3135e7, 0x398a67dd, 0xbf76e12d, 
	0x543d5d17, 0x6149cfc4, 0xa5c8de20, 0xfdf1897d, 0x2ee89c78, 0xeef1fcb0, 
	0xded4fdda, 0xd4515b2e, 0x6f1f71c5, 0x740d51fe, 0xdc713039, 0x537df841, 
	0x5b39ba3f, 0xe6e03b23, 0x40d7ae9b, 0x4c4737ff, 0xda90bdd1, 0x88d9e142, 
	0x3d7f66f5, 0xafdb791b, 0x9d7c3b67, 0xa6907df1, 0x358e381b, 0x648bf1f7, 
	0xd3d8eb5c, 0xf7d99f9c, 0xff7c254f, 0x2fcf98a6, 0x9bc2795c, 0xf9085683, 
	0xd06737d4, 0xa17cae88, 0x0c12b4a8, 0xcf86f21f, 0x695ce5d0, 0x8a936ad7, 
	0xab6339d4, 0xc1aaf104, 0x3d1b646f, 0xa91c922f, 0x14742398, 0x1288f553, 
	0x73c4c3c4, 0xcd29e542, 0x4ae39d12, 0xd85cfeaa, 0xa14ef825, 0x65f7a0b7, 
	0xb970977c, 0x7ae52be1, 0xa505cab8, 0xe70fe3e8, 0xe8f86fdd, 0xe0a1a57b, 
	0x8ebbe407, 0x085c72f6, 0x49c4e13c, 0x02ef96cf, 0xc177cebc, 0xfc5ddfdc, 
	0x9d1be356, 0x193c936f, 0xea07764f, 0xd7104a02, 0x37dfc599, 0x004eb8b0, 
	0x8547a1f1, 0x18f46d28, 0xdf1fd4ed, 0xf7423c40, 0x838f688b, 0xd05d9764, 
	0x37dc6c28, 0x2596908e, 0xeaa258b9, 0x94fde86f, 0xc06755cf, 0x749ac3fe, 
	0xbabc7ddc, 0xd914155e, 0xd1ef09bb, 0x1fc1a11c, 0x7f69cf07, 0xabe0f8af, 
	0x6873cae8, 0x45d64d51, 0xdb0d9beb, 0xb967c123, 0x4eaae9e0, 0x84857d30, 
	0xe8eefa86, 0x9c2d6b3d, 0x9f228dcb, 0x3cba76cf, 0xebbd1677, 0xe5b905a4, 
	0x389d64b1, 0xdeac5fbf, 0xc5f0962b, 0xec7ee34f, 0x8c4acf3e, 0x377c086b, 
	0x09f38821, 0x3a46ae34, 0x79bc892a, 0xf40917d2, 0xb03b75f3, 0x22b9711f, 
	0xde66873e, 0x3439f360, 0x390ef08d, 0xa87d539a, 0x59c57203, 0x0f36a8b7, 
	0x2c8e99c6, 0x518f23a6, 0x35cf1075, 0xfa1f3e59, 0x213c6adf, 0xfb5741f7, 
	0x187dcba0, 0xc4a37bc6, 0x407be33b, 0x5785dfe1, 0xbff08ba3, 0x1a7f8d22, 
	0x4e18f387, 0xb91bd43d, 0x07d84ef6, 0x0a56a65d, 0x3bae6b3e, 0x5867fcc0, 
	0xf6dc8597, 0xd467f37b, 0xd0daa1f5, 0xf0ab78c8, 0x6f8cc0bc, 0x02915e79, 
	0xf81782e0, 0xc175829c, 0xb28adc2b, 0x1b2fd901, 0xa709fd94, 0x19c27f65, 
	0x770e37d9, 0x05f8df71, 0x05fca2b7, 0x857f2fd9, 0xc9e2735b, 0xc4d7ef10, 
	0x693fb253, 0xd927f648, 0x8e2a7f92, 0x38a9be48, 0x1e17fb2a, 0x9d0bfd93, 
	0x65270cf3, 0x773cb27f, 0xb9a4fa61, 0x65fafb64, 0xc9d5453d, 0xfaabf730, 
	0x3e9d1e39, 0xf64a71c7, 0x17e84383, 0x7ea20d1d, 0x2f47ea63, 0x7b0f4088, 
	0x85327603, 0x632bfbda, 0xe6b2872c, 0xbdd77ea6, 0x054c2d00, 0x3cf5bbf0, 
	0xbf542bf7, 0x9174f4d4, 0xdd359cff, 0x2efeeda8, 0x2fccb3b5, 0x516aff71, 
	0x689bf1bb, 0x9077a763, 0x83aacf3c, 0x92621088, 0xedc6fc76, 0xcb7ce14f, 
	0xe5b23e6f, 0xb97d7407, 0xc9175d7d, 0xa235acb9, 0x321faefa, 0xe49d9a5c, 
	0x44bd0756, 0x4b94ed33, 0xe962f91c, 0x4ec248bf, 0x5f811599, 0xc0eebe16, 
	0x1be173a5, 0xc0d39977, 0xe5870ff7, 0xdb3c3ffe, 0x34f409da, 0x5aaf39df, 
	0x7da5b9c6, 0xa7d9bcd0, 0x7fecb6fa, 0x2c1fb1d9, 0x977352c6, 0xf6cf3ce9, 
	0x4efdf342, 0xea06911f, 0x27da477f, 0xa9cef7ab, 0x7eacfd06, 0xab76b54c, 
	0xed539f6c, 0xa4ff6a80, 0x7544f15a, 0xf9b5356d, 0xed50adaa, 0xcf35aa25, 
	0xd52af6c8, 0xeded572e, 0xcee6b5aa, 0xaab671e0, 0x1f6aaf76, 0xa77dad53, 
	0x6d939f6c, 0xc8f4c461, 0x238885bc, 0x48585a6e, 0x7969adfd, 0xda472b3a, 
	0xea39958b, 0xf2c23cfb, 0x32b39e73, 0xd922f6c9, 0x8e2f6ce7, 0x5ec03ec5, 
	0xa67ae4ba, 0xd0fde193, 0xbb19fea5, 0x607de15f, 0xe1f3af2e, 0xac56a93f, 
	0x6abe6d93, 0x897b542b, 0xf09fcd6a, 0x4abe1eba, 0x563dc9b6, 0x47e77f07, 
	0xa8fa4bc1, 0xa0a47214, 0x9c01f97f, 0xb11d59fb, 0x48b7db4a, 0x3ef87ff8, 
	0xb226f7dd, 0xb2a38234, 0xb9d152fa, 0x448ced12, 0x53b449e7, 0xded40db5, 
	0x7ea7f64a, 0xcef2fd1a, 0xebcbb00d, 0xfe78e9e6, 0x159327eb, 0x1ebe37b0, 
	0x26592732, 0xce2aeb39, 0xabe7f7d1, 0xf6e7602b, 0x6e1dbc05, 0x8e34593c, 
	0xeca8e329, 0x4f81dc0f, 0xdc3f9397, 0x39f82b97, 0x8b7c43c2, 0xf9874f8c, 
	0x6376003b, 0x66f73cb7, 0xa6fe70fa, 0xc9da4730, 0xc2fe0bb0, 0x429767fc, 
	0x342eef1e, 0x893f75b7, 0x574a5096, 0x07426b77, 0x588eec3f, 0xaf9226d6, 
	0x9dcd4bbb, 0xbb3fc4dd, 0x87443fc1, 0x576d3fbb, 0xb31dfacb, 0xfd402bb7, 
	0x4df4c40b, 0xc2fdd36b, 0x600fc7d0, 0x34239aff, 0x1b974dbe, 0x9df38f6c, 
	0x9857c646, 0x6e55f5f0, 0x9b2768c3, 0xa1ce1656, 0x8c22d955, 0x23069eef, 
	0x197da7b6, 0xf1f613ae, 0x1e598aed, 0x235557c6, 0xde9c69f5, 0x08475c88, 
	0x7e409c3f, 0x1fde157d, 0x9bd47047, 0xd83ef8dd, 0x74978bee, 0x5f77d183, 
	0x0b707b18, 0x3fc2fbad, 0xd23f267b, 0xfb1fda3e, 0x42d2be36, 0x415cd2fb, 
	0xf700c670, 0x9db00fa7, 0xa1e348d0, 0xcbd73dbe, 0x590e4ef3, 0xefda0959, 
	0x9e322387, 0x9b798590, 0x9ddcebd2, 0xe7104efb, 0x049d79a8, 0x8d297377, 
	0xbd6d9e67, 0x678f30de, 0x1037f8d3, 0x1856983d, 0xebc31375, 0xd3dafac5, 
	0xfac4adeb, 0x3e6cff79, 0x5a98f53f, 0xc2472477, 0xa074f38d, 0xb78c4acb, 
	0xeedefd28, 0x691e119f, 0xd037bb3d, 0x3ba023f5, 0xb6577f0f, 0xcb826af9, 
	0x385fdc02, 0xb07efa00, 0x17ffde4e, 0xb2fa01e0, 0xd5c7fa81, 0x83ff04f3, 
	0x8185e70b, 0x995f0747, 0x260d10f8, 0x1e02ab9f, 0x14ff6f40, 0xc3b37591, 
	0xaf5a8ef6, 0x8b4afeb3, 0x9e7da2e0, 0xcfbc596c, 0x7a05c87e, 0xe691b2bf, 
	0x08ebbac3, 0xe603d07e, 0xf75e9e3f, 0x9baf472f, 0x8ce34cf1, 0x8918f75c, 
	0xbf39ddff, 0xcab9c2cf, 0x7583f4e0, 0xd9f2b80f, 0x97df91cd, 0x57a6747a, 
	0xf3c43bae, 0x78c06e3b, 0x3be00f0b, 0xf333c14e, 0x7c60eed7, 0x2efc615b, 
	0x6f34bbc0, 0xb6fbcd35, 0x8ba213a2, 0x56d9c452, 0x10b2a6d7, 0x51f07657, 
	0x88c2b115, 0x4d5d54d7, 0xc60eef9e, 0xa7f1fb1f, 0xe82bbde8, 0xd040e0fd, 
	0x07a37ef9, 0xdb994ff3, 0x25d3e59f, 0xc02ea11d, 0xa529a3a1, 0xf69c5676, 
	0x8c1c4b23, 0x7980d91f, 0x3fc16776, 0x43cf8d1f, 0xd2d656dc, 0xb4ff047c, 
	0xb85878ea, 0x1ccaa6f8, 0x3469cf89, 0x2dcf084e, 0x5388eba5, 0xe0e1f928, 
	0xeb2af18d, 0x3ed23d7b, 0xd1d696a3, 0x374f73bc, 0x11f933d6, 0xe2ba545d, 
	0x9ccd4132, 0x5d2869b8, 0x8d6134df, 0x2bbeffa8, 0x5df6477e, 0x3777e1dc, 
	0x7bbe41bf, 0xe0775f88, 0xb72453bb, 0x22dc80ee, 0xc35600bd, 0xc93f17f9, 
	0x4baf2d8b, 0x5ebc84b9, 0x2ffbf28e, 0x5fa5792c, 0xa95eb844, 0x47717402, 
	0x7e0d24ef, 0xfd473f28, 0x4bfa6709, 0xf3d58ba3, 0xc9ee1863, 0x15937ff0, 
	0x9f9d7c03, 0x9a85c573, 0xc72a4e77, 0xca926ff7, 0x8503bd5e, 0x1dff34a2, 
	0xb0981607, 0xd3187753, 0x0bd22cb5, 0x2fdffa13, 0xafdcbec5, 0x5f9d9d9b, 
	0xff183816, 0x3d17d025, 0xb3d94cb7, 0x1347c1c7, 0x77f8dbfa, 0xbd8d9a39, 
	0x9baf82e5, 0x8eff40df, 0xe45289b1, 0x10ec68a7, 0x35ab4602, 0x57519fef, 
	0xda1dcf7a, 0x7f695bde, 0x9f92da7a, 0xc876495a, 0x5797db5d, 0xd61530de, 
	0xbe4747b7, 0xa39a1cca, 0xb340edbb, 0x7c36f062, 0xe6d4d027, 0xf26679f3, 
	0x84f95217, 0x48e78fbf, 0xf2546b7e, 0xaf657ee8, 0x71d3429b, 0xac845c5e, 
	0x7bae1ed2, 0xfdf14ab5, 0x7239c5a3, 0x8e2a93df, 0x812fdce3, 0xef483bfd, 
	0x097ebb6d, 0xcce60fbe, 0x9e4724b3, 0xc94aba63, 0x839c12d9, 0xdfe3541e, 
	0xf60f7e9b, 0x5f76da2f, 0x8ef603b2, 0x571adc66, 0xe82951f6, 0xd1c8ffc8, 
	0xf8b9a66b, 0xf213fa10, 0x6348ffd6, 0xf3f2411c, 0xfde8cdc5, 0xbd724f4f, 
	0xb1477f4f, 0x8442132f, 0x0ba8e5ed, 0x58a9df97, 0x8f526dbd, 0xdfcbcd47, 
	0xb0fac1bf, 0x7247e4ff, 0x0dc9279d, 0x0ad583e8, 0x3d6fb44f, 0x152d7bfc, 
	0x3f0e3f7b, 0x78d2a8a5, 0x2aba07da, 0x9fe14ab2, 0xd5f0aedc, 0x25cea4d3, 
	0x11d316e9, 0xe85ce3ae, 0x6e324d3d, 0x8bbaf98a, 0xeb7bd7d3, 0x43efcba6, 
	0x5dbbfcd1, 0xd55ab774, 0xec0b272d, 0xe27dc852, 0xe7e83cb3, 0xbe2bc262, 
	0x9a744ca7, 0x4e15ef87, 0x708325a8, 0xcf4bcd40, 0xf3243777, 0xee0c0f60, 
	0xfeca13b7, 0xcf48d2cb, 0xbdbfb8ee, 0xa939f214, 0x6116faf4, 0xc5d7bb2e, 
	0x27edab87, 0x8731f14a, 0x3e4ac63b, 0xa812ff83, 0x5f3e56c0, 0x99c2fa0a, 
	0xf5336b72, 0xf592789f, 0x80efbe03, 0xbb66acba, 0xfc22cf21, 0xc2851914, 
	0xa96ff347, 0xf38a5c3d, 0xdfbf7453, 0x1c9270c7, 0x7a8bb827, 0x7c642d26, 
	0xeed93ad1, 0x499e7e00, 0x74dcd7cf, 0x2ae32c38, 0x7c13beff, 0x786bcf4b, 
	0x55ba79be, 0xb87e2495, 0x970f97ff, 0xe13ed546, 0xb3f176bd, 0xf79254ee, 
	0xa3f62371, 0xfed2f004, 0xbd129616, 0x2bfd897c, 0xe348ade1, 0x076521b1, 
	0xbf6b8f11, 0x78c9dade, 0xbc23995b, 0x7eaec7e4, 0x5d6efdfd, 0x3fc0e7e5, 
	0x37eff4fe, 0x56be04ec, 0xdfcb5a3f, 0x146e28f5, 0xb65f8c31, 0x4789184f, 
	0x38638e99, 0xb27e40d7, 0xd6481f80, 0xbceb1458, 0x7ffa41a0, 0x384ae763, 
	0xa78bf61a, 0x4703af30, 0xead05745, 0xdaeb4c9c, 0x2621e76b, 0xdf921a50, 
	0x49509809, 0xf672ce0e, 0xcbf46dcb, 0x054b4df6, 0x0575c84e, 0x32928751, 
	0xc647210b, 0xd41a3be3, 0x3d8ca86f, 0x8df7a5ef, 0xf3c46890, 0xfcb90f44, 
	0xc39118dd, 0x4405edf6, 0xf501c117, 0x994781fd, 0x19ceb9fe, 0xd9ffb370, 
	0x8f8567bb, 0xd9efabc6, 0xf927e153, 0x5d6f6f75, 0xf04ef02e, 0xdd7000fe, 
	0xb86776dd, 0x95f67912, 0xefd8d975, 0xb65643bb, 0x039f173a, 0xd2c7a23b, 
	0xdf6f6172, 0xbd791415, 0x391e9e32, 0x2673e3ec, 0x863e5d39, 0x5c7c0227, 
	0x6ed9fadc, 0x7643f5c1, 0x49fb24f4, 0xbfcdbe76, 0x1d16651f, 0x5523bf91, 
	0xaefe5474, 0xd931f154, 0xf797ee2f, 0xfeca4e4b, 0x8a777f59, 0xb90a32d8, 
	0xe33cfe49, 0xcbaac7bd, 0xfdb73c07, 0x2cdc76b4, 0x1fef43b2, 0x271e7e2b, 
	0x4b71763d, 0x63d619f4, 0xa48df744, 0x3f1a0b97, 0x63ae33fd, 0x34f9d7da, 
	0xd63d5de2, 0x19abae61, 0xa82ac077, 0x8fdff295, 0x92eb6ef1, 0x4b81e7f1, 
	0x3fe07306, 0x10e9a27c, 0x94e315fb, 0x00ee377f, 0xffd00ff9, 0x00d35bf7, 
	0xfcee3a47, 0x3b8cb8e9, 0x7113bfbf, 0x3e6de6e7, 0x29ff3b8e, 0x79dc6467, 
	0xafb25cf5, 0x2e6f0ec8, 0xa2d93a24, 0xc6e483e8, 0xee2a397b, 0x5347f6bc, 
	0x1bda9fb0, 0xf3b8a917, 0x6dc70c7b, 0x223d987f, 0x3e5fecee, 0xa290fd9b, 
	0x8776c15c, 0x27d976ff, 0xbd0f9179, 0xc79eee3a, 0x4eee8a0b, 0x90ec4baf, 
	0x125c0ef0, 0x7a1f85c8, 0x9f1575d6, 0xae7a3d7f, 0xba1df118, 0x4c67ad73, 
	0xd2cf5aae, 0xf7a38e4e, 0xfa66a9ee, 0x4c733bdc, 0xc7ad07ee, 0xfb3666bf, 
	0xe817a05b, 0x6b7fb185, 0x62453f33, 0xc377bd64, 0xb972933e, 0x4ffaf7be, 
	0x278853fb, 0x0eb0e3db, 0x1f72fd6a, 0x63be0f2d, 0x8a5fcf44, 0x94ba45df, 
	0xc26c68e0, 0xbcf327ba, 0xbcd80ee3, 0x775a80ee, 0xfb7cfaa0, 0x389dd3f9, 
	0xa77abf67, 0xee757f5c, 0x066cfdc8, 0x57fad3bf, 0xfebcda17, 0xfe475566, 
	0x3df95c91, 0xf14a9153, 0x7cbe1bfa, 0x47ff5ab1, 0x7c5fff18, 0x49fd633f, 
	0xb0abeeb9, 0x7fdf749f, 0xc843c29f, 0x08780abe, 0x97e430dc, 0x03bf29fb, 
	0xf34fde92, 0xeb3aebdc, 0xcf5c8e7e, 0x79fb19e5, 0xd27cf5ae, 0x6ed8cfd9, 
	0xff47cfa6, 0xcf5aba7e, 0x73fe7927, 0x4dbfc7ad, 0x75a0a5d1, 0xf8219db0, 
	0x2ed11bbb, 0x76a36f19, 0x288ee00c, 0x430df5b8, 0xc46ee663, 0x71e5aeba, 
	0x1ebc9d79, 0x1232f98b, 0x5aeb70fb, 0x69f721f1, 0x7a4fb395, 0xb155d78a, 
	0x2ad759c2, 0xfccfa7de, 0x1cbae474, 0x8af417fc, 0xbf278031, 0xc6e31cc7, 
	0xb905ffbb, 0x9a4b81ee, 0xed82fe19, 0x4c33de32, 0x1c3e3b67, 0x90fbad9d, 
	0xf81c27f0, 0x62ce9263, 0xfe0ad915, 0xb05fc304, 0xbee476bd, 0xe1fb961c, 
	0xf4d0bf7c, 0x61df810b, 0x93c84418, 0xe0286fbf, 0x66ff0826, 0x8e952a7a, 
	0xdaa268cb, 0xea237187, 0x8346887b, 0x207fd268, 0x8e5cf6c4, 0x5b418989, 
	0x975bfefd, 0x7f0c7bcc, 0x5a86f11f, 0x13a23efe, 0xcfb319cf, 0x2f3d45ca, 
	0x80a2cf7e, 0xeaa692f4, 0x1a9f4851, 0xfe3283d9, 0xeb764d9c, 0x9bbfb3af, 
	0x92f07a87, 0xa4fa6122, 0xdd83115d, 0xb08df831, 0xe3bb3801, 0x53fe8473, 
	0x14f39706, 0xce390fa4, 0x3a246e1d, 0xe1f5f1a1, 0xde5ed038, 0x92a5ec87, 
	0xc22ec43f, 0x219862ff, 0x7dde4e1f, 0xbbca43e7, 0xd1fc3bef, 0xd1d318f5, 
	0x791d6b63, 0x3f9e7df7, 0x3ec65d7c, 0xe38e1aec, 0xafce9c71, 0x8dfe88f2, 
	0x6979e323, 0x77f0447f, 0xe463f3c0, 0x9a3e11ed, 0x699f9397, 0xa5e87a2a, 
	0xfb3899fe, 0xc93bcd11, 0x7c1430be, 0xb61bbfa4, 0xa41231ed, 0x267a1bd7, 
	0x3893b425, 0xa1f72fe7, 0xef12a50e, 0x331c2cf2, 0x228e3a22, 0x0baf51cf, 
	0x91ec9f33, 0x8eeb567f, 0x5dfc9976, 0x8b5efaea, 0x6da8390b, 0x3f5ffd84, 
	0x1eb9c456, 0x4372b2de, 0x09b33f6a, 0x1e6d02ae, 0x665305fb, 0x3ec0e96f, 
	0xc879dc13, 0x25d4e6fb, 0x949eb6f2, 0x1bbfc2f4, 0x1130fcab, 0xd85da5b3, 
	0xdf3a9760, 0xddeb917f, 0x33efbfc3, 0x14a7b7d0, 0x61d5cf79, 0x5e7d8e33, 
	0x20eedf3d, 0xde7188b4, 0xfc22c7b8, 0x68e47d8f, 0xeb1be029, 0x6cb0ebad, 
	0x6847af7a, 0xa1255df8, 0x3b5f5cdb, 0xc76f4ab6, 0x64f594f7, 0xbf7614aa, 
	0x16c57e4e, 0x8262bc57, 0xf8276278, 0xbda97579, 0xb04fbf13, 0x1dbd11fa, 
	0xd23f36f3, 0x83fe0498, 0x72cf9285, 0x59fc326e, 0x79d96fb4, 0x98791cf2, 
	0x12df995a, 0x982f3e7e, 0x95c435b0, 0x4b5b2c0a, 0x9f76a76e, 0x247f76ce, 
	0x5a4d27a1, 0xa341f47f, 0x2a3b24c3, 0x4c5bde97, 0xc97b35ef, 0x8ff5a4ec, 
	0xa4f9ffbb, 0x573dff0e, 0xbf785b8e, 0xd419f5ce, 0x8e011476, 0xc4ee8f07, 
	0x938845f7, 0x78caf676, 0x177ec763, 0xdc7f0a9e, 0xd9734f63, 0xd63f85f3, 
	0xf716c43b, 0x24eb9d7d, 0xeb2b92ff, 0x621e3158, 0x963fcda1, 0xf8ff34f3, 
	0x9a234ee8, 0xfbd03e7e, 0x729fc3a9, 0xaf75f9e5, 0x1971fc78, 0xdaea6bb7, 
	0xefef5e90, 0xe6dea7a1, 0x552533ef, 0xf04ef87d, 0x6817c715, 0x49e6dffe, 
	0x9e24f0bf, 0xb415f6a3, 0x9d8e1fe4, 0xd1587568, 0xbf32df34, 0x9255bdb2, 
	0xf0e57907, 0xccbfc3a9, 0x4ef758a7, 0xba1d3729, 0xda92f87b, 0xfa052b6a, 
	0xabf0bd31, 0xba49e4a6, 0xf2875e1a, 0x64f22b5f, 0xc942ae3c, 0x9e94b11f, 
	0x542ff827, 0x4cba28fb, 0xc3f3d62f, 0xb7cca26c, 0x5f627d24, 0xc9f4664f, 
	0xfbb0169e, 0xbd92964b, 0x3934390e, 0xcb7c80cf, 0xe87290ea, 0x3cccf648, 
	0xfd857e75, 0x895e4703, 0x87bf9346, 0xb197d966, 0x6d7df83c, 0x1dc61e4d, 
	0xeb09740c, 0x49dfc13a, 0x92cffa4c, 0xb1106a67, 0xc967a3e0, 0x8cefa933, 
	0xe7267939, 0x5f93b59c, 0x407fbb62, 0x7fa499e5, 0x2fb1e7c0, 0x42f71b5e, 
	0xff83d6df, 0x9fbdf1f3, 0xedf5f191, 0xfe1ddf8a, 0xf191cfac, 0x0f8efc6c, 
	0xf8e7c3be, 0xb77d42c3, 0xe7f77f89, 0x1f1dfcb8, 0xf2e7e790, 0xaf5b5fa4, 
	0xf5f8f1d5, 0x75478f43, 0xa56afe57, 0x7c862be9, 0x0586bbf9, 0xd6a3c8c5, 
	0xbf14648b, 0xb1aab46b, 0x763bbf9d, 0xf927d2e3, 0x5f314dfe, 0xdc0dce09, 
	0x094172bc, 0x4d2dc7e4, 0xacba25ed, 0xefc12907, 0x74576d88, 0x437bf994, 
	0xa6915d8e, 0xe823e5a7, 0xd82fb1c9, 0xec2bf87e, 0x3ef25bbd, 0xce6e1e9c, 
	0xd4f87a53, 0xafff2c43, 0xc94444fc, 0x993ce6ff, 0xff90c9f7, 0x3f48e3c8, 
	0xee38f39d, 0x7d77c07d, 0xf6aeb123, 0x81b1084b, 0x0a4f3d99, 0x99199f19, 
	0x235d0f47, 0xa78487cf, 0xef533ccb, 0xf33fb86f, 0xbfc38587, 0x77e2306b, 
	0x22739c38, 0xfd5cfe4e, 0x3f93814e, 0x2746737f, 0xbe68e5d3, 0xadcf2bbc, 
	0xe5f1473f, 0x9e9f5203, 0x3fdb8f0f, 0xe6771e24, 0xb2ba3d29, 0xff99ed9b, 
	0xe51bfe15, 0x3bcced07, 0x72551eab, 0xd059e620, 0xb5d69b3e, 0xed8ff42c, 
	0x8f005988, 0x3969d39e, 0x47b3bf00, 0x7922cfca, 0x9f0325ae, 0x3ae2aec7, 
	0x4cb7cb84, 0x7591fd52, 0xd64fa109, 0xce9243fa, 0x43eefc46, 0xf200f407, 
	0x9e9b1791, 0x55ec607f, 0x5f7f7e32, 0xe70f3fbb, 0x4966b355, 0x7c42c9be, 
	0x85ed23c2, 0xc79e097b, 0x325d64f2, 0x83d08df2, 0x75392b8f, 0x7947fb24, 
	0x8deaa3fc, 0x9e7f3e31, 0x237c24b0, 0x3c26c5e4, 0x8fe47247, 0xc962f92e, 
	0x31a7637c, 0xaf788a50, 0xc45efe89, 0x6476ff09, 0x8a68709c, 0xdcaf223e, 
	0xae18997f, 0xbc60ee53, 0xa67d6294, 0x71c13d31, 0x8a5590ca, 0xe07993f8, 
	0xbff42f49, 0x1bb88079, 0x379ec671, 0xf03db9aa, 0x2ed972e4, 0x5fad0fb8, 
	0x2f23f633, 0xd79bf494, 0xf1f247dc, 0xbea13ca5, 0x48f32467, 0xcd90fdc3, 
	0xbee1bf71, 0x48a2fb2e, 0x657a073e, 0xbf4d3f7f, 0xfaabf723, 0x5bef4c33, 
	0xafecbe45, 0xd7dcdffd, 0xa3e7945e, 0x07a4f9bc, 0xf5e4fb5d, 0x8b8f7f0b, 
	0x6df787fe, 0x7de1e98a, 0x903f24b5, 0x3c80d1dd, 0xc867238d, 0xce76e8be, 
	0x9eee421f, 0x1e5dfece, 0x17ba5bea, 0xf82a59dd, 0x2ba27f7b, 0xee83fbf3, 
	0x656df5bc, 0x0bbea3c2, 0xb79c0417, 0x7dda5995, 0x789885f3, 0x4f783181, 
	0x111bc13b, 0x514fad81, 0xc1f0857f, 0xfd923bbd, 0x6191eb1e, 0xae70b2fd, 
	0xd0c95bac, 0x73884523, 0xb643ce21, 0x411fbe3c, 0x0df0b276, 0xff2bd68e, 
	0xe885e407, 0x000000fd, 0x0003d5b1, 0x7de59c78, 0xe554780d, 0x267bf699, 
	0x264e6667, 0x09932601, 0xce48424c, 0xfc32424c, 0x1947e108, 0x88072d30, 
	0x89fd7e88, 0x6d6d2a96, 0xa2b1693b, 0xb6ba2db5, 0x3d5fb6a5, 0x13249933, 
	0x15004d40, 0x48276958, 0xa2dd522b, 0xf5db2d6b, 0xac407abb, 0xa16fd2e0, 
	0xd7696d9f, 0x544036bd, 0x6cbba6ea, 0xd6a6ddd7, 0x3f73dfad, 0x26667bef, 
	0xdbbb143f, 0x5df5d77e, 0x97d2eb9b, 0x3fbcfcf7, 0xf73cfbcf, 0xe73ef3f3, 
	0xde65639d, 0x10bcf8a0, 0x4c534dc3, 0x7a2106fb, 0xe08ab457, 0xbb442172, 
	0x08df8ba5, 0x5ff4db61, 0xa09110af, 0x85eb3d30, 0xb4f945a8, 0x61113510, 
	0x61090c96, 0xf8a3621a, 0x8593108e, 0xcf4f39e5, 0xde78e10a, 0x92ec2140, 
	0xf1eea8b7, 0x5f1f4f0b, 0xb997b4b7, 0xea5e3314, 0x5e33fbe1, 0x0dd452e6, 
	0xb0dd7ac9, 0x21bfd7ac, 0xc96ff5eb, 0xcb3479ba, 0x9704f375, 0xac92fa22, 
	0xf5965f47, 0xc7ac90d8, 0xe1bd6586, 0x786f590d, 0x8f1bd64b, 0xf1bd72f6, 
	0xe6629704, 0xf33eb24b, 0xaeff2a65, 0xc45377ec, 0xa6f5f1bf, 0x34eebe21, 
	0xae92a79d, 0xb8999a0a, 0x3a644ea3, 0x53e815b7, 0xcfa4957a, 0xf9f7bc31, 
	0xcb393a22, 0xe92a5d85, 0x52e21a14, 0xe0d31604, 0xa2bfdeff, 0xe84213f3, 
	0x70a73fe6, 0x8710ad7f, 0x87a63507, 0x8e973cef, 0x884a42ef, 0xe0f9e9db, 
	0x3fdd7c5d, 0xedfbaf22, 0xd95c7233, 0xd37af86b, 0xbe3952f9, 0x3bbe340b, 
	0x75e32fa6, 0x23cdeba3, 0x5db37af2, 0xbcd78d4d, 0xd1f3c82b, 0x023781c5, 
	0xfe079328, 0xd3fdca83, 0xb379d384, 0x187dc75a, 0xb8c0bb77, 0xebce8e83, 
	0xcbdacafb, 0x2dc68d35, 0x38c1c70c, 0x31e340bf, 0x6fd7457e, 0xd7cdbcf8, 
	0xd149c293, 0x625d35f5, 0x6a59e745, 0x53b2dcb6, 0xef3dce34, 0x526ca916, 
	0xe9c63bae, 0x194c9d8f, 0x92ee3c1d, 0x636f3d2c, 0xde991b5e, 0x65a3fa1a, 
	0x1bf4fee5, 0xf9a29684, 0xd14112f9, 0x69a5403d, 0xcbd51aea, 0x05eff422, 
	0x122bef44, 0xa609f8a6, 0x50ef4ad7, 0xbec2185d, 0xa1f9fe91, 0xa2eec29d, 
	0xa87ecd71, 0x9e3f5044, 0x5fb29106, 0x0a0ee7a0, 0x8277da0f, 0x5e9f6e1e, 
	0xdd41bae4, 0xab1f4cda, 0xa5097c44, 0x8e3f53ac, 0xd6f8906f, 0x47e55e0c, 
	0xffb5367f, 0x9d7f6a53, 0xcf0f6c23, 0xfb46c4a7, 0xa0b4bea1, 0xbdbc7979, 
	0xedc53b1e, 0xfae4c7e8, 0xdd6527e8, 0x59ea9a7b, 0xec57a8eb, 0xc253b8c2, 
	0x42f538fe, 0xb8d0c934, 0x4cfdaa6f, 0x1fcbfc50, 0xa0d5ff4e, 0x1ff404db, 
	0x399f474b, 0x25feeb5f, 0xfb5d16ca, 0x36e9a5c5, 0xf6159ddc, 0x75fdd03f, 
	0x37587c72, 0x76de99f0, 0x5833dca4, 0x03af2ba0, 0x315afa95, 0xc8907ed7, 
	0x04a6f59b, 0x110f498d, 0x7e8a93bd, 0xdb17d526, 0x91bf3c73, 0x7fdbadf2, 
	0xe8f83af8, 0xf2507a46, 0x52f79e0b, 0xa2a4993b, 0xf164f83f, 0x49fa39a1, 
	0x3c13c6aa, 0x3d9bf01f, 0xb1975858, 0x09ff00f4, 0x72a78f9a, 0x3a5111e7, 
	0x8248cf9e, 0xe5d7cc75, 0x8bd14bb7, 0xb916ebf9, 0x3c7f68ee, 0xf83ad89f, 
	0xe3a8f984, 0x5805f39d, 0xed40bec8, 0x988650d3, 0x30df6c9f, 0x6ffc27bf, 
	0xdffb6970, 0x85237592, 0xbfe73075, 0xa37cd36c, 0xe061df7e, 0x6a79c889, 
	0x85cb1e59, 0xe21219d6, 0xbeebfa6d, 0x401f8847, 0x4a142f6e, 0xfe304aab, 
	0x04cf4e30, 0x3ea9d91f, 0x829da71e, 0x4504d6bc, 0x9d3eb812, 0xabc212ca, 
	0x8b741529, 0xe179a870, 0x41f05ec9, 0x1bf7419d, 0x8f48dae9, 0xfaa5da96, 
	0x3df78b3b, 0x09df5aba, 0xf53801e5, 0xe6d7e486, 0xc6ee24b7, 0x7ae66e8f, 
	0x629704fc, 0x3eb24bd6, 0x772a65eb, 0xe331ff4e, 0x72e0fd59, 0x692f718d, 
	0x25c77d69, 0x5fa9655f, 0xb3a3189d, 0x2a2aca8a, 0xf7cc281f, 0xc24f319f, 
	0xce143797, 0x2ebe6a5c, 0x72f3b97e, 0x453419e7, 0xe9724e8b, 0x6d083923, 
	0x5da1ed90, 0x2a7ff81f, 0x252bbff8, 0xb21ea8fa, 0xb9ca3653, 0xc7ccf7c4, 
	0x1c85d342, 0x1e34a3cf, 0xe96961af, 0x741f7ca0, 0x865a7ba4, 0x263e279f, 
	0x82661791, 0xd41a0a5f, 0x871e7adf, 0x8bd7ba03, 0x93fb7ea3, 0x4c431444, 
	0x32cd1882, 0xe3f4329c, 0x25cb27ca, 0xfa81a870, 0xe7c94d7f, 0x6f2e1fc0, 
	0x216bdc79, 0xca527d7e, 0xcd585bdd, 0xdc4f7ef0, 0xa0d7e22e, 0x84fcca95, 
	0x73ff8245, 0xb41c3de9, 0x1d53ff99, 0x0a7ac88e, 0xf4161ef3, 0xcfcc0dfc, 
	0x78d0cec2, 0x34d41f17, 0xb5c6df9a, 0xc27a16a2, 0xe06b6b57, 0xfa258de3, 
	0x694712cb, 0xc82a5f40, 0xee1248ad, 0xe9edcf81, 0x75eb1ba2, 0xb80ef088, 
	0x1ae83764, 0x72f063ea, 0xf6e489b8, 0xadcb8b86, 0xd6d2716f, 0x367781aa, 
	0xc2895dcb, 0x0ea3963b, 0xc7c73f25, 0xe4979fcb, 0xcb5dea4f, 0x4a335f6f, 
	0x9283b30e, 0x70f4a3be, 0x0275feb1, 0xe31f8f5c, 0x249f89d2, 0xced6f6be, 
	0x85f690af, 0xbcb4eb35, 0xfa26cb3e, 0x808586f6, 0x2e65783e, 0x3f1f49d1, 
	0x0767f2bf, 0xbc68e7ad, 0x7a50ab9f, 0xa946de78, 0xf7ae8407, 0xe5bd7f51, 
	0xf41f7df2, 0xd48bc4b0, 0xf0b49451, 0x5b7e3cbd, 0x9e1ff8c7, 0x5e52522c, 
	0x83f25d1d, 0xc1fe62f0, 0x3a499c96, 0xf315e585, 0x4b45060d, 0x60ffda98, 
	0xf43bd485, 0x7ce317be, 0x27de89b8, 0xe846097c, 0x5fbcb0fe, 0x70f2b841, 
	0x724ebab7, 0x5e5dbe13, 0xe4a0bd2f, 0x2390542b, 0xe545faf7, 0x9cd0f1a8, 
	0x1f0296d6, 0xf96086e9, 0xdee03d61, 0xaffff43f, 0xdad2f41c, 0x9052be76, 
	0xb67ff003, 0x33ff3c7f, 0xf142ffdf, 0xcd2e2ffb, 0x7af963df, 0xf32353f8, 
	0xce213932, 0x719da5fa, 0x69bbeeae, 0xda06ed41, 0xb374ab13, 0x49f2ee30, 
	0xad3f5562, 0x28b9797f, 0x94f1a5e9, 0xa99d164f, 0x088fa50a, 0x346fcaaf, 
	0x55fad39f, 0x676a717b, 0xdf4348b2, 0x1da6c50e, 0xf58ddd06, 0xa09bdd7f, 
	0x20be32f5, 0xda601a4b, 0x7b5973f1, 0x16a74b8c, 0xf299f37c, 0x86db225c, 
	0x16fbacd2, 0x6133e0d1, 0x4de6e771, 0xf7ed57cc, 0x7e7a5c19, 0xecfee34e, 
	0xc0a5cec6, 0x9a7040df, 0x1df5a6e8, 0x0ac1e2ba, 0x4ec40e1d, 0x75eb0e7b, 
	0xaf5a7da8, 0x9e5f3dc0, 0xf4f24ad3, 0xe3e7a284, 0x0a71f89f, 0xfd5cfdfa, 
	0xf506d3f7, 0xf7136817, 0xb9fe6966, 0x3007a90a, 0xbe6887df, 0x49edab46, 
	0x081efd91, 0xe68a4f0b, 0x486e4065, 0x9e837c7f, 0x38017e9b, 0xfa335f73, 
	0x708a9839, 0x7e16fb3f, 0xecfffb83, 0x5bc6573d, 0xdc4f7e89, 0x7c19b33e, 
	0xa24f7fe0, 0xfdf6a6c5, 0xe02d376b, 0x02c8dd72, 0xd7eae89b, 0x8f3886fd, 
	0xe2adda92, 0xd2f4f575, 0x7c56dff3, 0x13e17abf, 0x5cffb015, 0x1e7b53fa, 
	0x6a1bee8d, 0xd25b461e, 0x56cf01a3, 0x4adbcc8f, 0xc954feed, 0x875ac6d7, 
	0xf441baf5, 0xfcc41def, 0xf8a44712, 0x5ab65a3a, 0xba79873e, 0xd35fedeb, 
	0xf7a6ee92, 0x6562498d, 0xd3cf20ff, 0xf5f44bd3, 0x7ba29bb7, 0xb33f6c83, 
	0x0bafae9f, 0xedfd9d32, 0x45a7bd71, 0xc53d03b6, 0xfb81d2fc, 0xeb07bd11, 
	0x40df1161, 0xbea4255f, 0x3d0552fa, 0x5f1267f9, 0x717faa52, 0xd2779541, 
	0x1d79417f, 0x5a7a0aeb, 0x91375c8e, 0xeb84a9bb, 0x77596a9e, 0xf872c27e, 
	0x872941ec, 0xbc4b27b7, 0x1a8cd7b0, 0xfcdec061, 0xc836df8c, 0x2faf13b2, 
	0x4dc4a9f8, 0x418e99af, 0x1a76e2f0, 0x5a09eff2, 0x1edc209a, 0x4b49cbbe, 
	0xe89453bb, 0x92ff18dd, 0xb499da34, 0x277441a1, 0x9a83ff81, 0xe939f5c6, 
	0xf3f441ee, 0x9fde445c, 0xb49bf3ce, 0xbe608ac1, 0xac831be5, 0xd9f58c6f, 
	0x1d84c7ac, 0x67f74427, 0x4730dca8, 0xb280d9ef, 0xd687bba1, 0x7f0b07f7, 
	0xe6b3c721, 0x9fc6354c, 0x2c95f0f8, 0x496f93b7, 0x109f0c44, 0xc8ffc353, 
	0xb97db9f4, 0xc2cfad1d, 0x467c94ca, 0x60635758, 0x2e133f9c, 0x4518d50e, 
	0x4301a438, 0x6a740ed9, 0xd4a7696c, 0x9b87b700, 0x709b4cca, 0x4af1b4a7, 
	0x9ec937f6, 0xc5eff9fd, 0x193b93a3, 0xf0e9808f, 0x47862fd9, 0xafe4437a, 
	0x3ee17544, 0x8f893afe, 0x2125c3fa, 0x9fbd7f8c, 0xf8be91c6, 0x7addae73, 
	0x05ce6fd6, 0x6cbaa01d, 0xaafd701f, 0xe707f832, 0x2965db26, 0x099737d2, 
	0xe871868f, 0x7019562d, 0x42f236ba, 0x3b688659, 0x71ec91af, 0x531b93c6, 
	0xff7a13c0, 0xb834b3e8, 0x26a66257, 0x8a695276, 0x487a4112, 0x73ebcf57, 
	0xd4522457, 0x7b0165ee, 0xbcc5f40b, 0x0799bf79, 0xb12f317d, 0xd7973e74, 
	0x2a26f2aa, 0x4d73d20f, 0xbb49e787, 0xbb5c31cc, 0x0440380c, 0xde3574d0, 
	0xdb48ec34, 0x447209d1, 0xa5f79fc3, 0x4b0b8483, 0x0e5ed242, 0xdf48fa90, 
	0x8f27eb8c, 0x4bf7a909, 0x7b6467b3, 0x6fe71fb0, 0xd106194a, 0xb75ab665, 
	0x42b3429b, 0x6ab5953a, 0xf126e59c, 0xe38c36ff, 0x7e58f337, 0x91b94b22, 
	0x52d71d3c, 0xf391bfdf, 0x45a6bf60, 0xb87cc7de, 0x85e52d6e, 0xdeb8bcc5, 
	0xfcd3eeae, 0xaca4bdb8, 0xb5bd765f, 0x1f3cb805, 0xe7d52276, 0xc4d2ffd3, 
	0xae34556f, 0xd7900bca, 0xc77010d6, 0xe1383b3b, 0x844ac63a, 0x9b9e7983, 
	0x88a6956c, 0xa9d0b1fe, 0xccc3c84e, 0x7534a746, 0x5961d68c, 0xdd20a947, 
	0xbc9c4afa, 0x66e3b20c, 0x0588f5aa, 0x3bf45eac, 0x04aaed73, 0x86f333c8, 
	0xcc7af2df, 0xf4c95e4c, 0x2aa7799f, 0xf7ccb233, 0x306ab1eb, 0xd4135bef, 
	0x267dd12e, 0x90ed93b5, 0xe05d9f65, 0xab35a6e3, 0xcff1054a, 0x4a6765cc, 
	0x2989e549, 0x78e6bfaa, 0xd49d10ca, 0xfa63584e, 0x5487bf71, 0xfe8289bf, 
	0xaa13fee2, 0x23632a7f, 0x09fd863d, 0xaf245f25, 0xe036c331, 0x1672babf, 
	0x01bf793b, 0x49a0be3e, 0xf3de1279, 0x621d073f, 0xd3744d41, 0xe191b77b, 
	0x058cbc03, 0x2f037797, 0x26fa8387, 0xbac481c4, 0xc496992b, 0xf9e1cfc7, 
	0x0f77fa06, 0xfb70f9e1, 0x6f589b95, 0x0e3ae507, 0x5d654b9b, 0xe7b0c1f1, 
	0x52edeb24, 0xb322b2bb, 0x8b9a781d, 0xbf08d701, 0x86b5c062, 0xb10c5f85, 
	0xdbffdbfe, 0xf5737028, 0x27195b2f, 0xfefb4ece, 0x84778e59, 0x9b90a3da, 
	0x589e9f49, 0x0481893e, 0xd21413e6, 0x3ac06c8e, 0xe0b4b8d3, 0x55f434d2, 
	0x0d876d43, 0xfe4e3a7b, 0xae3d685e, 0x88d6eacf, 0xc283b3be, 0xe69a7caa, 
	0xf43613e9, 0xc3bbf109, 0xb1c25476, 0xc1682f61, 0x73c41e3b, 0xf0639d2e, 
	0xf11cf0c7, 0x0d740a7c, 0xabb41d47, 0xaea7cd11, 0xcbde1e07, 0x6f99e278, 
	0x7d661f47, 0xe331d64f, 0xd07129b5, 0x1eb26510, 0x8abcf650, 0x455b79af, 
	0x4698fbf0, 0xbd7e90d6, 0x30229b8b, 0x03b7e694, 0xc20827ec, 0xddd7a215, 
	0x324387a1, 0xbd97660e, 0xc8c5f745, 0xdfb4860b, 0xfee2b71b, 0x427b132f, 
	0xdf6a0ee2, 0xdbba6597, 0x8e29de1f, 0xaa551f12, 0x309046f8, 0x57fe4325, 
	0xc397aead, 0x5d84ac1e, 0x4f30b078, 0xb8c327ea, 0x851d62dc, 0x0d2220bf, 
	0x142e3947, 0xd7ac75b4, 0xaf4ec9b9, 0x148227e4, 0x3bef37aa, 0xf7a09bd4, 
	0x25919f9b, 0x1213e3fc, 0xd2437c47, 0x9f98bf4e, 0x7aa3f3cf, 0x514b9860, 
	0x30ba46f6, 0x6946aaaf, 0x395fd3ef, 0xb9aafefc, 0xaaa8ded2, 0x95e3e595, 
	0xa6febf12, 0xffadfa52, 0xddc552a7, 0x23f3c222, 0x81516c66, 0xb3b01b71, 
	0xbed71f30, 0xa5ebcdaa, 0xaf3ad38a, 0x9720c553, 0xacbce856, 0xb8642e87, 
	0xeb22395e, 0xd7174e95, 0x5cbcc7c3, 0xf5949f0f, 0x5eb2d3aa, 0x35a5c835, 
	0x4facbcf5, 0x4fef20bd, 0xbec2f11b, 0x6fe491fb, 0x78c34ce1, 0x97b41ea6, 
	0xfdf95db2, 0x035a734d, 0x07ddf6c5, 0xcf5fb033, 0x02cf2fd5, 0x8d56cd6f, 
	0x1597bbed, 0xdeb8baee, 0xd80c2adc, 0x70986677, 0xb9bc708b, 0x4ce3d25c, 
	0x2d77d948, 0xfbbed85b, 0xcae5b9ea, 0xfdc33bbe, 0x627efd4f, 0x51577d94, 
	0x7b28b5ae, 0x9ac4c222, 0xd60b657c, 0x65f222af, 0x92a6ce59, 0x55a2bfe4, 
	0xd4b06fd5, 0x814716f3, 0xaab6922a, 0x6cf01e3b, 0xb3aa42c5, 0xbbd8b21e, 
	0xdfcb68ac, 0x0dfef8d7, 0x35fbee9d, 0x48c37f7c, 0x55f9a08b, 0x09a549dc, 
	0x10ebfc7d, 0xaf8a8dec, 0x9b39ea38, 0x214f6fa9, 0xa44cf31c, 0xfc06bd7f, 
	0x45f6a6aa, 0x8fc43ddd, 0x486fae53, 0xbc841f77, 0x7e05291c, 0xa95fb536, 
	0xd7c098f7, 0xa687b606, 0x74473f5c, 0x5b9a7cd3, 0x05b99184, 0xfd4ea9d7, 
	0xf5779157, 0xf491f814, 0x29effc23, 0xb17b0777, 0x7e26ef3e, 0xe4d89d82, 
	0xa96a301f, 0x5d73d37f, 0x3153f806, 0x9cadf48f, 0x02df5e57, 0x68b6668f, 
	0xf2223822, 0xb7770d7f, 0xb08d0d1f, 0x676ec3d5, 0xdbce4943, 0x5bc93cff, 
	0xa03f49c6, 0x76aa7015, 0x4ad5ecc8, 0xb03dce59, 0x4a998573, 0xfc56aca3, 
	0x80e318bc, 0x7ef7d9bd, 0x6f1723b6, 0x3cb8f891, 0x3812a334, 0x1ce650d0, 
	0xfbd23c83, 0x6c57ae06, 0x38f2cbee, 0x92df48eb, 0x4e7b5bfd, 0x314dcff4, 
	0x0f6166de, 0x3066ae12, 0x5d11333f, 0x9e66fd05, 0xf7c1f897, 0xb29bef21, 
	0x5b2c1fac, 0x1ddc83ee, 0x31fb91ba, 0xf1570537, 0xe8364bbc, 0x44537360, 
	0x7e897957, 0xcf153908, 0x44f601a3, 0xb5bf4155, 0xbdfe4a54, 0xe629c952, 
	0x6c497f09, 0x13e791ba, 0x52ddf179, 0x7cde691e, 0x7c4be0fd, 0xa67357fd, 
	0xfb11ebcb, 0x5ec8aa48, 0xb663ed76, 0x6ec1778b, 0xef0996a6, 0x7a83b36a, 
	0x6d46e12d, 0x92a7f0b9, 0x31c25fe0, 0x2bf6ae7a, 0xea0c3e52, 0xd005d17f, 
	0x4da9da5f, 0xb0695a2d, 0x7277f783, 0x3f492181, 0x5a4ccdc4, 0xeae1c457, 
	0x879778d5, 0xd70254d6, 0x3392bf9b, 0xe717d3ca, 0x2aef9743, 0xc1f41e1f, 
	0xacf971bf, 0x3af361f2, 0xec32a5d0, 0x3e675eb0, 0x73d706ba, 0xb2a3d606, 
	0x150b22b5, 0xbea85376, 0x6e6a7212, 0xbda0cf6e, 0x54f6318a, 0xce32cded, 
	0x10b43510, 0x62921bf6, 0x71a0c855, 0x219d1876, 0x44f9da83, 0x4190b9f0, 
	0xf456eeed, 0xecd6c50e, 0xf50bfe86, 0x8788c388, 0xdba5855c, 0x5a21a547, 
	0x6f358fb0, 0x7eecc7bf, 0x14f1e59a, 0x8c9f54e2, 0x7db25494, 0x015e333a, 
	0x9f5576bd, 0x6dd8855d, 0xeb34caf3, 0xaae6f583, 0x819ff84a, 0x970a1ff7, 
	0xcb19be13, 0xbb1b5313, 0x5f42ce24, 0xcbeb6e86, 0x5fb01388, 0x1f89fd68, 
	0x1808332e, 0xb21e251a, 0x2a121fdf, 0xe354414e, 0xe9578038, 0x71719b45, 
	0x92d5e91e, 0x1f1e3cf5, 0xfee871f8, 0xc31c4d41, 0xe52a4afc, 0x625556fc, 
	0x3116be7e, 0xdc6f7515, 0x2dfa8a9a, 0xea30ce89, 0xc2e7ac1b, 0x4b95b7a8, 
	0x3c416d3c, 0xf7ac1bf4, 0xf5886785, 0xf9a128bd, 0x9c8b8dce, 0x77c7887f, 
	0x183d2352, 0x83f6f23a, 0x31bbcf18, 0x9adf5a24, 0x0852ad07, 0x1888bcec, 
	0xf7fbe12c, 0x37df1774, 0xbde3c10d, 0x0959de39, 0xf2d4f979, 0x882256df, 
	0x4d96e1b6, 0xa3d120e1, 0xaaa6c96c, 0x7bde9508, 0x596aab06, 0xd07e888f, 
	0x7d6dd277, 0xcdf3c13f, 0xeea6e74f, 0x7299e626, 0xf053a1cf, 0x55adcad7, 
	0xae8f410f, 0x4e879dd5, 0x26bd3277, 0xf27f7439, 0x26bde8d2, 0xdea4edc9, 
	0xc23cf748, 0x57e9b30b, 0x4c6a67ab, 0x7788d5af, 0xfdf597f9, 0x31abd794, 
	0x5cbd61a7, 0x746e1df9, 0x834b44fd, 0x9236689f, 0x1a72479f, 0x0fec39ce, 
	0xba2789fa, 0xfdfe3e89, 0xfcf7f671, 0x4fc64dfb, 0x9bf27eef, 0x685e220f, 
	0xdde89fb3, 0xafc34f1f, 0xbf0427f4, 0x7e4fdde7, 0x85f819f2, 0x3078c0ff, 
	0xf5a42fd6, 0xc6770088, 0xa5f3c7cb, 0x859a99b0, 0x0bff00c7, 0xdf3d14e0, 
	0xa1e4a556, 0x2f32d6c5, 0xbef0a030, 0xfabbdb45, 0xba21c233, 0x1b1c242f, 
	0x5de41944, 0x3469b34d, 0x3d0f2eee, 0x6ff2595b, 0x1c619c05, 0x2ab850ac, 
	0xfca312e3, 0x0799b698, 0x29b98fd8, 0xfcb2b874, 0xfe53da02, 0xbbaf9288, 
	0x79c82f43, 0x18c3b18d, 0xb949771f, 0x2d9f2412, 0xc8af886b, 0x691dae5f, 
	0xbf9e63f6, 0xf3397b7b, 0x1dcf6b85, 0xdcf6912f, 0xe37a21dd, 0xef6826df, 
	0x12d7b2b4, 0xaae3df34, 0x385fb95d, 0xe8708e3a, 0x4c238e06, 0x84c9657e, 
	0x8fcc0471, 0xb8319bed, 0xd38d4cb8, 0x9a4dedf3, 0x388d4d01, 0xa7d82ec2, 
	0xbfc52a67, 0x212c1f12, 0xd828dd7f, 0x0cdfc353, 0xe3457d98, 0xc652a57e, 
	0x7a1ebe71, 0x97f57195, 0xccb8d789, 0x9ec8e3c7, 0x760a4a74, 0x223670d8, 
	0x5b5d74b2, 0xe1f0fd27, 0xbed47b26, 0x7219c2cf, 0x02fe81ff, 0x38194e2a, 
	0x031bf72f, 0x656e8817, 0xdc839a61, 0x911b2e07, 0x948ecbd7, 0x66bfbc60, 
	0x912cf5dc, 0xc85cf4f6, 0x1c82faf1, 0x679fd80b, 0x3cdf9c94, 0x3b05fe9e, 
	0xe33fbf34, 0xfa1f689d, 0x586f21eb, 0xfb0babc5, 0x5fa0bbd0, 0x6a69c704, 
	0x8fc0da69, 0xd74961c9, 0xd01f9261, 0xe9a3f301, 0x35ccb789, 0x9a9c7e2b, 
	0xb91f9ec0, 0xa076853a, 0x028eec4f, 0x0a1ddd0e, 0x33e22787, 0x5993ecef, 
	0xb18c778e, 0x5adb87db, 0x9f4f41e7, 0x00e2fbab, 0x6076bbee, 0xedb0cad7, 
	0x6b5942a9, 0x87f68a7b, 0x2ed2c29a, 0xfd4b0c6e, 0x8d3d9d95, 0xd87c239f, 
	0xee21b88b, 0x9cfae297, 0x7eba8e69, 0xeb817216, 0x8e3d7415, 0x30dec279, 
	0xc7367d9c, 0x55dca8b7, 0x42fb7f68, 0xd57dae37, 0x2bbae400, 0x4e200d60, 
	0xddd195d1, 0xe4034438, 0xba0bebb3, 0x41ab5792, 0x257639a7, 0x8df95cdb, 
	0x36fafd71, 0xe315bcf5, 0xebe477e7, 0xe6ff5c8d, 0xeecfd857, 0x37bc1969, 
	0x89a50abb, 0x09e88970, 0x1ecdeee6, 0x76e66945, 0x10f6ce12, 0x4d5df458, 
	0xc9e3bb65, 0x5b9328ea, 0xd27ee20e, 0x945ebd14, 0x46b7fd56, 0x6e74ee24, 
	0xe321baa6, 0x62657d21, 0xefe34b28, 0x2718f454, 0xa4e7ce7f, 0x52fc85fc, 
	0xb30df56f, 0xb13c1dfc, 0xb931e940, 0x3f9790af, 0x07a4ff6a, 0x5ca748f6, 
	0x178e375f, 0x28ebf924, 0x9360f1c4, 0x85eeffa2, 0x8f41cf6b, 0x1eb01bdf, 
	0x71855ac9, 0x0beff7b8, 0x4c1c8fd8, 0xe71db9e2, 0x86514a5a, 0xf9e845cf, 
	0xc8f101ad, 0xdf3e474e, 0xc09651b2, 0x6dcb1e8f, 0xf410c777, 0xbd80b6e1, 
	0x96bb546f, 0x3297fb5d, 0x93a87d1e, 0xbf600efc, 0x182bc71a, 0xeb0103c7, 
	0xafcfc51b, 0x4892ed52, 0xe325be34, 0x706f0dd7, 0x55861a29, 0xa190c9fe, 
	0xc6ff67fa, 0xfd2a3c6e, 0x7b2799aa, 0x095ff5d5, 0x79c07f71, 0xd6e1fc04, 
	0x74be17bb, 0x25b57216, 0x9db5ece0, 0x55dbfbc2, 0x32feea1c, 0xf6c81ce7, 
	0x7b69ecca, 0xcf2a0f31, 0x7e29af06, 0x05c7077f, 0xc2ec0736, 0x2d7d7cfb, 
	0x580def5f, 0xe10faf63, 0xdac07f7a, 0xf87afa37, 0x11df5c15, 0xf5c0df10, 
	0xf2115c7c, 0xdcfc1fb6, 0x4dafed2a, 0xaee93cad, 0x7d4ab42f, 0x4fee41b1, 
	0x22bf2574, 0xfd54ebeb, 0xe7c8affa, 0x5de7c8d7, 0x876bba7f, 0xed559eba, 
	0x010faf80, 0x77fd2417, 0x88ca78d3, 0x571053ce, 0xda5280df, 0xcb7f78a7, 
	0x1fd3c446, 0xa78a8f0a, 0x7bbbb8ab, 0x98adcc9f, 0xda8bbfda, 0x08194f1c, 
	0x63d3c0eb, 0xafc1452f, 0x91b3bd9f, 0xdd5cf9f9, 0xa43e9977, 0xe2ee3966, 
	0xadc79ff6, 0xb8c95e8f, 0xfe2584e5, 0xaf8c869b, 0x86bf1189, 0xd4a63ef8, 
	0x0a63e54f, 0x5da24457, 0xdd2c5dc6, 0xf68b3f6d, 0xada4c6f5, 0x2664ce21, 
	0x7a3932da, 0x73dcec2e, 0x131f5f98, 0x8e8e090f, 0x8c1f6087, 0x70960ae3, 
	0xab195f10, 0xd31ed06f, 0x4d7d485b, 0x1c835aed, 0x84fa902f, 0x074c23e3, 
	0x63ee4cbb, 0xe336653a, 0x3ff32da9, 0x18e60fe8, 0x2d70938f, 0xf8f29626, 
	0xe68dff5c, 0xf34f806b, 0x8fdc1ef1, 0x5faa14a3, 0xaafef18b, 0x17f7e41f, 
	0x15f718bd, 0x0291597f, 0x5ef92e9f, 0x82982a75, 0x2aee4c77, 0x10d357d9, 
	0x1c72896f, 0xdce2a3ce, 0x4f1f5825, 0x7c45e883, 0xd311d618, 0xf3964361, 
	0xd94b2c39, 0xdebeeec7, 0x5f6a312e, 0xbc4c45af, 0x26fd07af, 0x3e4d69ed, 
	0x4c7cb41f, 0x9fde4757, 0xb24ef886, 0xd9346790, 0x4fcab8ac, 0xf941ade3, 
	0x6fbdec24, 0x70fee4e7, 0x1ef1c73a, 0x5bfc19dd, 0x75b7ef92, 0xbe98b07b, 
	0xab1ebeae, 0xdcf28ba7, 0xf210fe64, 0xf6178e58, 0xd0863d15, 0xfef27f15, 
	0x7eb2ad2c, 0x60fc8882, 0x4c7d6089, 0xde54fbcf, 0x15ef1f97, 0xfb8761eb, 
	0xb2638cb1, 0x3c9bb63f, 0xf02ebea1, 0x7b6bc7af, 0x947cc877, 0xf7e197d2, 
	0x993e6445, 0x0665bfae, 0x7cd6dea9, 0x83b4b477, 0x6ed0d7fb, 0x888df61b, 
	0x25513f9f, 0x59fd2de5, 0x7e8e4361, 0xa22def4e, 0xa4bd16fa, 0xb7f247dc, 
	0xbf94b165, 0xe528d97c, 0x52a9a5ed, 0xfe8cfeaf, 0xbfe7a09d, 0xd504f54d, 
	0xfde584b7, 0xb76e4a2d, 0x95cc78a8, 0xdc42df74, 0xa277bd59, 0xf765fa4a, 
	0xf40125ea, 0x115cef73, 0xec7cfc43, 0x5bb2457e, 0x2eff200c, 0x20697a1d, 
	0xf8650678, 0x711fe011, 0x19ff6f67, 0x41a2f7f6, 0xd59dcf9a, 0xd38eddb2, 
	0x19b9e121, 0x114557d7, 0xf978ea3f, 0xc065d2ce, 0xed8ac367, 0xf23fe7a2, 
	0x08b9ddf3, 0xf3419be1, 0x3e78d08c, 0x062ab652, 0x169d3abb, 0x1b60db51, 
	0x88799a2d, 0x05d4d370, 0xb5f488ec, 0x89dbba3b, 0xfbd5e96e, 0x5c69d772, 
	0x3b53b5cf, 0xd7d47f5b, 0xbdfc4edb, 0xfbce5aa2, 0xcf8cbae3, 0x83d9a7a5, 
	0x8ade3f72, 0x7b7b4bf6, 0x778d3f5a, 0xd7dc9541, 0xb51ef2db, 0xd158642f, 
	0xbdf77a5e, 0x20ced2d5, 0xf079e34b, 0xd850534b, 0xde68c7f0, 0x6963c85d, 
	0x6b76378a, 0xa760a700, 0x697c17af, 0x5ed0fa74, 0xcf1823d2, 0xf136a020, 
	0x664bcd5d, 0x26a7fc17, 0x38803251, 0x1cd888ad, 0x79a1a9bf, 0xe49da8f8, 
	0xfb144557, 0xe7e45532, 0x1986b4e9, 0x888617e5, 0x9837dae6, 0x7e78a2df, 
	0xf67715f5, 0x9deeaf02, 0xdc471d6b, 0xda276080, 0x4f645a5b, 0x68cf4399, 
	0x3ecf7fe7, 0xca37d994, 0x6fd7741e, 0xb3e4b576, 0x7eed93d5, 0x327abbb4, 
	0x5a0c07f5, 0xb0944cbc, 0x83f7627f, 0xac539d1e, 0xaa77ee28, 0xd7735dfb, 
	0x763f400f, 0x5306714e, 0x355d6eb4, 0x8cdde764, 0xf70e4efb, 0x953f1377, 
	0xeadb5d11, 0x74253b17, 0x5977333d, 0xdf831d14, 0xad8c8f41, 0xf30b6d45, 
	0x48a912b5, 0xa8d45ec1, 0x0a37cacf, 0x9e2516e3, 0x0815f608, 0x2788a2cf, 
	0xdf24da66, 0xeaebf92e, 0xb3c641bd, 0xd9f0018a, 0x07d488d9, 0x476c6f84, 
	0x79c9a6e6, 0x2703f55d, 0x38447887, 0x909deb22, 0xf76fa22f, 0xf6659585, 
	0xf2b7b500, 0x8bcc9ca5, 0xcf014eb4, 0x03c32b33, 0x0f34eb82, 0xd5e76fa2, 
	0xb3f0bde1, 0x03ad3533, 0x0eea77d8, 0x43f00188, 0xd80ced26, 0x18d956b4, 
	0xd5718f3d, 0xf5a35e90, 0x7b21a9ed, 0x63d118e1, 0x8432c444, 0x8dad3d9f, 
	0xe96710a7, 0xc94657b2, 0xecd91756, 0xcf4e98ca, 0x4db5d765, 0x4fe8a3b1, 
	0xed3ec18f, 0xbb5f24b6, 0xd0ff3ba5, 0xffc72934, 0xb3ea5531, 0x051c336e, 
	0x0acf85dd, 0xcc2aff2b, 0x38961c38, 0x3c38899c, 0xf9c4eb8e, 0x36dfc3cf, 
	0xa977a4bd, 0x39844f6c, 0x2f6c3eae, 0x7579c8db, 0xd95265d9, 0x7e0c2b08, 
	0xf651ee75, 0xc0c330bd, 0xdac44caf, 0xc70c7981, 0x3ef2375b, 0xda17b289, 
	0xdebfd283, 0x9f91f68c, 0xef265d99, 0xb198cbdb, 0x50abf63e, 0x3abbe318, 
	0x415be340, 0x2c3d67cf, 0x8b915ef7, 0x0b1f7c62, 0x497d1d88, 0x16476a6e, 
	0x1b12d3fa, 0xb59dd7a1, 0x688320ad, 0x087b6f4f, 0xe50777ef, 0x7607f77e, 
	0x3d630cae, 0xd8446bda, 0x46e5435e, 0x90f9144f, 0xc279f7d7, 0x9fbcf388, 
	0x7c032ba0, 0x8e375b32, 0xdb7417ca, 0x362ad25d, 0x2cdbee31, 0xf9c34797, 
	0xcba60b7d, 0x7eb46596, 0xf8defc50, 0xf443f45e, 0x5833be15, 0x87e75a47, 
	0x00daceb0, 0x2e896572, 0x6b25d051, 0xd45dea36, 0x21d1467f, 0x7e903a0b, 
	0x74516e1a, 0xfdbbfd52, 0xee1d74b9, 0x29da7453, 0xd965b4e9, 0x5151018e, 
	0xc6a99ef4, 0x76cd39ed, 0xafbc6180, 0xe4bf68e2, 0x33df5f83, 0x645f04ba, 
	0x51961d94, 0xf1177e78, 0x1546e577, 0x7a1dbb37, 0x29e2bec3, 0x489da3b6, 
	0x2de8ec96, 0xbef01537, 0xe23f226c, 0x8fd827e0, 0x21cbeaf8, 0xfae11f55, 
	0x974d3257, 0xd34823f0, 0x8c03e714, 0x5c5c23f1, 0x36e4a2dd, 0x2f4ad72f, 
	0xfea4ab05, 0xcaa4e8f9, 0x3313c401, 0x89fb30a1, 0x39e118e9, 0x3b0afdf0, 
	0xf8934a77, 0xea42aa7d, 0x4e37bc41, 0x52ac791f, 0xee1427b6, 0xc47438d2, 
	0x085aaab3, 0x9f1fc957, 0x8f84d71c, 0xe506b670, 0x39b46053, 0x6a21eb8c, 
	0xf8057b4f, 0x702954fa, 0x3e93a3e9, 0x67388bd0, 0xc703e047, 0x145d7f61, 
	0xfbd18d4f, 0x7714effa, 0xf5ece2c7, 0xc6bbd8c0, 0xb596ede3, 0x37986e92, 
	0xcdfa4bf4, 0x74033903, 0xbd73b268, 0x2a2f17c4, 0x0e9e3d3d, 0x874c5fc2, 
	0x1694e10e, 0xfebca3eb, 0xc9f61e21, 0xd5e70778, 0x50710c85, 0xb666b8e7, 
	0x84daf517, 0xa5c9fac6, 0x9d74885f, 0x5edd3976, 0xfdc37447, 0xc1006493, 
	0x9e3e41ce, 0x5e5567b4, 0xd0f6c4de, 0xb6e3ffc7, 0xeac3f05e, 0x06bebff2, 
	0x94ef14fb, 0x4d05bf5e, 0xd7e99e68, 0x0b80e6f7, 0x2e7679e9, 0xf901f8a5, 
	0x7fcc1351, 0xc71dfe94, 0xb2ef4a07, 0xf7485dfe, 0xe0f9a3e3, 0x7f5f97a3, 
	0xe3fe9c3c, 0x8f3bbbaf, 0xaafde371, 0xa27d4bed, 0x6a6bffa0, 0xfa27fea5, 
	0xc30e4295, 0x58bc4b23, 0x577e374f, 0x2be3df6d, 0x7a41e78e, 0x586adf41, 
	0x39bf34d6, 0xb90c2fa4, 0x3771c78f, 0xbca5e85b, 0x75b0925f, 0x685a7bb6, 
	0x29d913be, 0x893b4937, 0x8c41e554, 0x7c9a7403, 0x23dd68b6, 0x17f38676, 
	0xc7bd9e89, 0xdeb7bce5, 0x107d3130, 0x23e97367, 0xdae2fd94, 0x5fb05d3b, 
	0x52e94ec9, 0x4a95b971, 0xaef5bb4f, 0x5df7c946, 0x9ff2c937, 0x85f302a6, 
	0xa934dcf8, 0x55373eff, 0xf0d4fdf2, 0x4e22a6a7, 0x3d9f7c98, 0xc8ec30f0, 
	0xf98bd588, 0xa6115cb2, 0xc5607ead, 0xd920f400, 0xff40d74d, 0xa2bd7cb2, 
	0xf8720fe4, 0xbae38a40, 0x723bd9e9, 0xca449f32, 0xbee42e9d, 0xa4e3067f, 
	0xdfd0e2fb, 0x9fda9d30, 0x8695f190, 0xaa9c5f85, 0xeb2038cb, 0x23634c83, 
	0xcf49a9fb, 0x8458b3f6, 0x67f11d74, 0x7cdec147, 0xb171fca7, 0x6ff820bc, 
	0x8fec53e7, 0x731fc00d, 0xea77b5fd, 0x6198d54f, 0xcbfe9ff6, 0xcee54c7e, 
	0xc27fc5e7, 0x9550fc0e, 0xeab97bcc, 0x760e5607, 0x6917c733, 0xc219e78d, 
	0x95167ec4, 0xd869e876, 0xc1276485, 0xf77b9aae, 0xd2088d29, 0xfd9fbdf5, 
	0xeff44830, 0x5effaa7a, 0x31c8f983, 0x9325e547, 0xeef58e3d, 0xbee5860c, 
	0x3be7ebb9, 0x6c42bf32, 0x9dcb7992, 0xa79cc5c1, 0x2ad75c3c, 0xb48536f3, 
	0x4bdfd263, 0xe8f69d5a, 0xcb666638, 0xd3c4f1a5, 0xbbe27760, 0xbde7e603, 
	0xd9a97c05, 0x7033bf28, 0x86f185f1, 0x4fa4b37c, 0xc17f601b, 0x83805cfb, 
	0x3cf17119, 0xdeac61e4, 0xaab1f171, 0xb2f9e65a, 0xff7171fe, 0xa4ebe2b0, 
	0xd5f07fc4, 0x7e667e58, 0x2baebac3, 0xa3df52e9, 0xb1ff3f30, 0x3cfaec71, 
	0xf1c81f1e, 0x78d8fef8, 0x1e0c66bc, 0x72e892ff, 0xf8e9d146, 0xbb970e9f, 
	0x486f12c2, 0x9388a38e, 0x344e3588, 0x0de25c7b, 0xe1a9c0fc, 0xfd8a9d7f, 
	0x67143f85, 0x86e23ef0, 0x829bc317, 0x3a764cbd, 0x5d76e5ec, 0x6f64cbd9, 
	0x97b78e96, 0xb5de7b5d, 0x797b5d3f, 0xc7f7b2b3, 0xa8e9cbdb, 0x97b05927, 
	0x79dbdac7, 0xfd8c79fb, 0x99ae7f9a, 0xeef467ec, 0x8cb6a3b3, 0x53fe71af, 
	0xeef68ede, 0xaccff967, 0x3745fe93, 0x228bf1c6, 0xca45bc7b, 0xb87b58db, 
	0x401ec6a7, 0x79e78d1c, 0xc19fbc7c, 0xf7f5bbf3, 0x0ff1c7d8, 0x78ad1c55, 
	0x73b1f627, 0x571916c7, 0x0b9675cf, 0x4f10ed76, 0xc29510ec, 0xee8f6453, 
	0x14e3269c, 0x8ed6396e, 0x5495bd62, 0xdc53d376, 0x26be28ce, 0x3ec190ed, 
	0xdfd2974d, 0x23ed4f6c, 0xb7f1493b, 0x7b5d47ab, 0x449fb5c9, 0x4744f7d1, 
	0x0c7f9f49, 0xa9c64dfa, 0xefd0138d, 0x7f23e7e4, 0x6db86a77, 0x9299f61a, 
	0x19df49ab, 0xc45fbb05, 0x3bc452ad, 0xe7753e5d, 0x4eba4c25, 0xbf2895ef, 
	0xed7ad2f8, 0x1dff69fa, 0x2576daf4, 0x6fd3178f, 0x4877c353, 0xd24c7f3a, 
	0x137452f9, 0xd052ac6b, 0xae78c3a5, 0x7e09e654, 0xa3cc9a79, 0x474deffa, 
	0xdbe09bd8, 0x11fff8b1, 0xc15777bc, 0x537b641e, 0x9db293ee, 0x337272c8, 
	0x0f1dabc7, 0x8803d597, 0x54f15e17, 0xfe2bef3f, 0x7df72230, 0x3e4e38dc, 
	0xa5f0b36e, 0x1bb6e31c, 0xfe4259b7, 0xc3d71275, 0xf8e1b71c, 0xdb8a854d, 
	0x4191dd90, 0x83eb07fc, 0xa7f2187d, 0xbb5dafba, 0x1cadf917, 0xdc5431bf, 
	0xb7a9d686, 0x708f7086, 0xe25dbbb4, 0x1588f768, 0xce49f8cd, 0x7a6279d7, 
	0x14db6512, 0x677a91c4, 0x7fd945b7, 0x8df8cb8d, 0x79ebba5b, 0x7fadf950, 
	0x92f8911e, 0x71c6e359, 0x37ca909c, 0xe63e3109, 0x0c5638e3, 0x803ff8f8, 
	0x2bf867a7, 0x6bfdc621, 0x4e38a8d7, 0xac278abb, 0x0de2a65b, 0x40e3884e, 
	0x2e4e38f9, 0xe2227ac4, 0xc7f8c36c, 0x2ab5fbe2, 0xe38f92be, 0xa17153ac, 
	0xba171976, 0x10b6ece9, 0x00eaee40, 0x8fec8f8d, 0x4679d76b, 0x029ba5e9, 
	0x97a936f6, 0x09d96dec, 0xd7b5caf4, 0x45121e87, 0x1bbdea7a, 0xdf30848e, 
	0x10ec6b6b, 0xb5ad73c6, 0xef38e392, 0x5843a649, 0x13846bdf, 0xeae43d65, 
	0x471b8481, 0x9be94671, 0xc9497a71, 0x696b96d9, 0x0a7f499d, 0x47d606ef, 
	0x53a4a63d, 0xd338e22f, 0xba71c7c6, 0x1649c710, 0xd2e5d7c6, 0x56f4a121, 
	0xd65bd5dc, 0x524e38e8, 0x8a837dd1, 0x76bb5ce3, 0x8d17f440, 0x3a9eac7b, 
	0x283ff1f9, 0x6e4ff38e, 0x6734871c, 0x38f8f0c9, 0x8ffb124e, 0x8916fdc0, 
	0xd879c0fb, 0x745fae11, 0xfb15cd2d, 0x3265e9a1, 0xf74cd28e, 0xddeba4ae, 
	0x3f38db1b, 0x8edcb7a6, 0x67dcdd41, 0xf67af094, 0x1a6e8884, 0xe20697ca, 
	0x331bdfd0, 0xcf0a78d1, 0x88c7b159, 0x7de91b9f, 0xb2def613, 0xc659ae97, 
	0xb769d47a, 0x29f616b7, 0xf214efe8, 0x6ec8baaa, 0x0e68b0af, 0x17bfeddf, 
	0xfbec3b76, 0x9ff9d910, 0xdb7e92ae, 0x9dfdc85e, 0x1dbffeca, 0x39bb45bb, 
	0xe9b1f6de, 0x10f76522, 0x1a45a61f, 0xac07a972, 0xebcdf814, 0xe00a79f9, 
	0xc7d95fe0, 0x1afe00fb, 0xfa5c835b, 0xf035a60e, 0xd2c46f8d, 0xcd9b8720, 
	0x43cbe4a0, 0xe3f60f69, 0x6c5cd6f5, 0xcebbb505, 0xc4595749, 0x36d79b57, 
	0xdfaa2da6, 0xb346ae74, 0x11569f08, 0x78d0d77d, 0x48ec743e, 0x696fe495, 
	0xbbb0e977, 0x0a4e3e64, 0x953738f9, 0x559f5489, 0x46bd2758, 0xb1e9fbee, 
	0x73814fe0, 0x8f256e7a, 0x75d2f6c3, 0x0483e7ea, 0x07e819ac, 0x7fbf9c6f, 
	0x483b5dd2, 0xc6d1ebf1, 0xccbe9904, 0x15f21a7f, 0xc909e386, 0x1e3bea67, 
	0x8bf87c1d, 0x704efe62, 0x4bcdd2dc, 0x8ae92237, 0x1a93be0c, 0xf0573d9e, 
	0x7b5ddf77, 0xcbc66821, 0xe0e7957e, 0xf320b4d5, 0xaeefa8eb, 0xe0efd7d3, 
	0x96d189b8, 0x54fb0d5c, 0xc18e97df, 0x6fc2f08f, 0x01fd4a8a, 0x37b6f09c, 
	0xc6d777f2, 0x5bdba31b, 0x18a9e4bd, 0xcaf577de, 0x817163e6, 0xc6a3437d, 
	0x18f58a3a, 0xa7ac2336, 0x18fefef2, 0x9cdd2c3f, 0x330e841b, 0x6da7f4de, 
	0x97d51bd2, 0x3db7b53f, 0x4171fcc9, 0x9f5dde43, 0xd886f8e0, 0x447ddc2d, 
	0x4a2d5bd6, 0x8a7ab96f, 0xc4f486f9, 0xfc84bcf0, 0x71f95c2e, 0xbef0f0c2, 
	0x1d72a79d, 0x6efa2be7, 0xa797a43c, 0x1bcf5f78, 0x125ed2a1, 0x30a635f2, 
	0x1c7dbb8f, 0x81e5fbdf, 0x8753d66e, 0x338efe4c, 0x9c2bed3d, 0x6a786f77, 
	0xcb9f224e, 0x9c691bf5, 0xbea94bfd, 0xfaf7f179, 0xef1febaf, 0xf85eae27, 
	0xfb44c8f9, 0xe6e7d8dd, 0x110d9aef, 0xe246bbeb, 0xf7ad1f47, 0x1a0e4a0b, 
	0xa2357e16, 0xfb4e3be3, 0xf9cae314, 0x8f79f945, 0x7573b75a, 0xf9cbdddf, 
	0xe827586c, 0x7aefe509, 0x199ecfe1, 0x71cd874f, 0x663d8fb5, 0xfb52fbbf, 
	0xba2ef8d9, 0xdb9b3f78, 0xd7df8f89, 0x65fd8cde, 0x961807e4, 0xec4be75c, 
	0x963da76b, 0xfc7a6cf5, 0xaf4176be, 0x16bbb948, 0xf40af772, 0xaf50989b, 
	0xa3237ab8, 0x8feb20f4, 0xd72fd2a4, 0x7923d78c, 0x756c69f9, 0xfef18de5, 
	0x32c5611a, 0x33f1efce, 0x343bf9c6, 0xfe02ea9e, 0x389dfc17, 0xad750fef, 
	0x3c04fb93, 0xe3c75bae, 0xd1bd58ff, 0xf68d6353, 0xe3e8c677, 0xa62e38fc, 
	0xefdd2247, 0xefc88f58, 0x3d8d9d39, 0xd87ed55b, 0x0c9f722b, 0x19bec1f4, 
	0xab5bb3ec, 0x31cdfddc, 0x2ac600fb, 0xda67fb8e, 0xcb7ac817, 0xbf1f796f, 
	0x2e8b33fb, 0xf3f00fb1, 0x27cbefc8, 0x6d3fe372, 0x694f8bf5, 0xaaae6fa4, 
	0xa694ebbf, 0x51a044f4, 0x64830dea, 0xd488f5fc, 0xc5f56363, 0x03a30715, 
	0x0bb2ac91, 0x1fe8281f, 0x23c7fe77, 0x29f6be52, 0x48fa0dff, 0xa7123e63, 
	0x55ee0f60, 0x4de22776, 0xf173cfc8, 0x3ffbf3a4, 0xb6ec21fb, 0xf9ff0bd5, 
	0xf933cbf7, 0x03dceac9, 0x71116796, 0xa22479e5, 0x3c9139df, 0xd88efe8f, 
	0x8ddd6795, 0xd6792957, 0xfb94f8dd, 0x6bfff15d, 0x22f95679, 0x4e7959ff, 
	0xf873edbf, 0x4964dafb, 0x35f82ed7, 0x5dc1ec53, 0xcd3ee42b, 0xba7f0b82, 
	0xeee993f8, 0xda7dac9b, 0x76f1a6ac, 0xd68bef34, 0x3deb851a, 0x75359f8b, 
	0xef31d91f, 0xf38bd7d9, 0xc3fe5c06, 0x8d77e0f8, 0xae123f8d, 0xa5d77e45, 
	0xf143b3f8, 0x03f92da7, 0x27f30cf6, 0x2ff9ca13, 0x83e321c5, 0xf1c503cb, 
	0x5f1427fb, 0xd93e2c5e, 0x85eed934, 0xd934d45f, 0x94ee3132, 0x7eb713b2, 
	0x3bfb0762, 0x0ae96f18, 0xe452de39, 0xefcb55af, 0xdbbe7831, 0xe48bb8d4, 
	0xb905f20c, 0x34d7c41f, 0xc78c851b, 0xb9a7e04d, 0x2190b971, 0x91a116e3, 
	0xe1b6b758, 0xc5e7af9d, 0x5f9026f2, 0x31c9f1c1, 0x4f9c1379, 0x41f6a831, 
	0x379f1e9e, 0x1d0ff9c1, 0xcdd1bf05, 0x89fce083, 0x426f2174, 0x1c648fc0, 
	0xa2ded113, 0x3c3fd07c, 0xc0fec23f, 0xd46e3243, 0x961d338e, 0x2639641a, 
	0x58c67651, 0x238c853e, 0xf7848f21, 0x730790e7, 0xf0c1e55c, 0x7edeecbc, 
	0x6aafbfaa, 0xa74bfe6c, 0xf2997fcc, 0x83d868c9, 0x0d6d97bc, 0xff3705c0, 
	0xc2dbfc05, 0x6c56ad79, 0x76f1aed7, 0x031bb537, 0xb65d6c3f, 0xd6fb17a3, 
	0x72d70b5d, 0x5bf3747c, 0x2969a767, 0x80f2ef95, 0x5edd77dc, 0x66a2fbc5, 
	0x345f78b0, 0x774ceb62, 0xe3fef75a, 0x7451bef2, 0xa15deb1f, 0x714a4ff2, 
	0x8ba1987e, 0xba49b7a9, 0x7ec8b8ed, 0xfda8df4f, 0x08eeb51e, 0xca2fad6c, 
	0xe4ff0197, 0x34ce5eb0, 0xfaf0bbe4, 0xeff5aaf7, 0xc7f3ac28, 0x626a3ad5, 
	0xa38971c3, 0xc519fcf4, 0x835fc00f, 0xa1ba8de8, 0xa5ba67f2, 0x67fbbb5c, 
	0x58e52fe4, 0x3ece465e, 0x0bd2fe83, 0xf610f47f, 0xf4f8dcf3, 0xc1ed6bc7, 
	0xce778ade, 0x246e2e07, 0xc8fe489b, 0x539548df, 0x6f463439, 0xb09c2a0d, 
	0xdf10f8e5, 0x92195c61, 0xf7a44fcf, 0xfb027fa0, 0xf2a45884, 0x113f588c, 
	0x3edd089f, 0x15cc4c30, 0x7b2dcfad, 0xd1f90da8, 0x6e8eed66, 0x5fbf6621, 
	0x7459b713, 0x664c96bd, 0x599a27ea, 0xa3fef4b1, 0x68fe2fc4, 0xdce10762, 
	0x9e071bac, 0xf2e1ae0b, 0x59c65188, 0x27dcf71d, 0xbecb00ed, 0x3477de97, 
	0x4122b3b6, 0xe07dff82, 0x17e07103, 0x1c5303e0, 0x37f24338, 0xfcc69d7b, 
	0x33fb5399, 0xa6b5da73, 0x35ef520d, 0xf216960d, 0x75efe90d, 0xe74ec5e0, 
	0xf38e6ce8, 0xe3ef3fb4, 0x3ed889f5, 0x579f157b, 0x78fe4394, 0xbe3dc90d, 
	0xdeed114b, 0x3a7f71ab, 0x21f822c1, 0xa0eacaa2, 0xc1af8fcc, 0xe70a8678, 
	0x49fbe51c, 0x63a00388, 0x7666bb6d, 0x9dfa150e, 0xe4268865, 0xa476ce3f, 
	0x235356bf, 0xace70ff7, 0xbb04d159, 0x357f1dcc, 0x07180df9, 0x1dda97cf, 
	0x7c4f79d8, 0x61a9bed4, 0xe57186df, 0xfacfce70, 0xa7cbbf42, 0x8847f1d9, 
	0xd22fcdfe, 0xaf7edcfc, 0x85f7ea29, 0x23b2f2cc, 0x4ff9afa0, 0xe8a37c5b, 
	0x3a2292dc, 0xab9d02cf, 0x8cbb5fb8, 0xaab7f7fc, 0xb66abc65, 0xd790dd7b, 
	0x47cb8373, 0xac5aa78d, 0xf8e7d9f3, 0xa4b321dc, 0x9e2e30b1, 0xd669d107, 
	0x00e05c94, 0x69206b8d, 0xacdcf1c5, 0xa259a935, 0x4f965d68, 0xdc26e391, 
	0x41e71d7b, 0x5a28e3b9, 0x9f6cbb77, 0xca288f1c, 0x93c772af, 0xdbac475f, 
	0x5375a2fa, 0xfd6a39eb, 0x1bf5ab16, 0x74f7eb52, 0x7aee1c61, 0x4e49ebb9, 
	0x02e7ebf9, 0xe826a74c, 0xbe5557a3, 0xabf9b8d9, 0x1319caf5, 0x2f9e57af, 
	0x1f2dbad4, 0xff61c549, 0xed91ef6b, 0x7bc81e63, 0xb95d18b9, 0xe7177ddd, 
	0x3cffb703, 0xf44fdf3d, 0xe9e8140c, 0x4da907ca, 0x4c67d787, 0x6737f43f, 
	0x66e583b0, 0xc7d206ce, 0x3b63848d, 0x7cb3be8a, 0x4c21513c, 0x2612b019, 
	0x35ecefc9, 0x5130ef85, 0x3b3ba03f, 0x9877f337, 0xbe42488e, 0xe0f13ebd, 
	0xa6fbc2a6, 0x16b623df, 0xce100fd5, 0xffbd15f7, 0x1c1e70b8, 0x9ca7fef5, 
	0x8e7a1feb, 0x2262f9ee, 0x7fdefe8b, 0x0ab8ab46, 0x1d8a0def, 0x07954f5c, 
	0x6f756eb9, 0x07fae4ef, 0xe633af98, 0xc684f020, 0x79f9be53, 0x36cc9dd4, 
	0x6acfd62f, 0x5bbdfac6, 0x7e09cd34, 0x01164d89, 0x0bf5f47d, 0x7d10089a, 
	0xb5fd10f7, 0xf57c0ba7, 0x8457a4f5, 0x93d151fe, 0x30a959f4, 0x59b73f5f, 
	0x26f821f2, 0x966feca7, 0x3ebcf5cf, 0xfe48a7b6, 0xa86920ad, 0x14240a4f, 
	0x3f3e801f, 0xebe676b0, 0xe8859f38, 0x73d571cb, 0x85be4b75, 0x9fafbffc, 
	0xfe3ffd97, 0x6c2450fa, 0x8d5b710a, 0x3e6eb7d4, 0x87cfd7e1, 0xbcd3e785, 
	0x13f439be, 0xf6e5fc51, 0xc6a227b3, 0xb8f1c863, 0x06bf04fc, 0x3f07cc7a, 
	0x2dce0ce7, 0x3fb019c9, 0x2d0b940e, 0x15e70475, 0x77e1baa4, 0x80b41fb2, 
	0x47ed1f9f, 0xc08e5af9, 0x3999897e, 0xc1141fce, 0x6a8fd93b, 0xf29561fd, 
	0x7ae55e0f, 0x1f9539e0, 0xc3a44e1d, 0x7116e236, 0x5fb3f22f, 0x8359d05f, 
	0x6b59aabc, 0xc4434b4b, 0xed7a735f, 0x58f463ec, 0x16eb66f4, 0x51e803ac, 
	0x32f3c1d1, 0xdb5e692b, 0x6b1e646a, 0xdf056bb4, 0xcbf6df07, 0x3fee16fb, 
	0xe8712355, 0x7a08eb92, 0xef1d6c5c, 0xb52f5a2a, 0xad0d627e, 0xd7cbad0f, 
	0x77c89fe9, 0xd1173a64, 0xf9e3eb17, 0x5c3f8164, 0x73ab56fa, 0xefbdf94a, 
	0x03ad5f82, 0xe7e757c8, 0xa1ef0b1a, 0x207f9c3d, 0x02e6def0, 0x24f5d13f, 
	0x3790a3e2, 0x5f215fc4, 0x130fde1e, 0x233b1e07, 0xf0a599db, 0xd90eb1fb, 
	0xbe34e3cf, 0x9307448d, 0x8d48f0e8, 0x5fb741c4, 0xd511efee, 0x7e85eddf, 
	0x17bc6a3c, 0xd0697f9b, 0x7446f854, 0xbd5f3d25, 0x7dfe5849, 0xf63be9e3, 
	0x76f4b1bd, 0x64352fdb, 0xbfdd2e7b, 0x4b3de5fd, 0xdd5f67a1, 0xbf3c65e0, 
	0x2b613a6a, 0x2b33b5f2, 0xedd9bfb8, 0x0f429787, 0x9f149c24, 0x9758f4d7, 
	0x0abbdcd5, 0xfee6cae5, 0xf7ec42ed, 0x93f7b75b, 0xaa7fb11d, 0x91f717f9, 
	0xdc213f5c, 0x7bfc80f8, 0x99ed3e22, 0xd95fd480, 0xdcf449ee, 0xaadfce15, 
	0x5e9ac1f8, 0xf61b0bae, 0x5d0decd8, 0xac441801, 0xf5ae889f, 0xf71857c4, 
	0x027b4dec, 0x6f6777b0, 0xfb19319a, 0x4ba72b2c, 0x29fa38bf, 0x8f8c4df1, 
	0xd159b7d7, 0x07c0a875, 0xa5f8b5af, 0x697e01bd, 0x7735e82c, 0x34db5e1d, 
	0xfaeb09a3, 0x078c8d5a, 0x26cafa58, 0xd6c6f1e4, 0x4f8a4d5b, 0x7c8d1572, 
	0x442e6dde, 0x6f47b07c, 0xa4afee6b, 0x5fe757e5, 0x051edd10, 0x4c1b2e5d, 
	0xced41935, 0x8ffe2abf, 0x4ab5155f, 0x590f1710, 0xe5073b4d, 0xb21596fd, 
	0x385d908c, 0x42dfc68f, 0x293aedfd, 0x14cb0bed, 0xe5dbfdc1, 0xdf5d28f5, 
	0x26b1f07d, 0x67b47c41, 0x7c51f1b8, 0x90dbbd2f, 0xa78d3d76, 0xb775a34f, 
	0xc60f2d0e, 0x56b5f28b, 0x9a8f4204, 0x7fbb8fc4, 0x4e347e14, 0x44b2cafa, 
	0x14f34730, 0xfe19ab11, 0x195880f9, 0x6dd5ce07, 0xcd1f3912, 0x88fcc2c7, 
	0x386d976e, 0x427e0b3c, 0x90ffce2d, 0x09598c76, 0xb3584a7b, 0x8f4b4b80, 
	0x57109aa5, 0x2ad79f21, 0x335c621b, 0x747ee8cb, 0xbd03e106, 0xf6483adf, 
	0x61eb2950, 0x84769211, 0x7d451c80, 0xfbf807dd, 0x01d4eeec, 0xf1087df9, 
	0x5e51694b, 0xdc05c626, 0xb5efbf38, 0x68adc212, 0x73e13d9d, 0x5f1be7d5, 
	0x2a7f2128, 0x55fbd6a2, 0xa52d8f65, 0x946d9ffa, 0x47760dfa, 0x78ebb2f3, 
	0xb14cf61d, 0x7feec0e7, 0xa928f862, 0xb7cd6a02, 0x4fce35f0, 0xc4768a0e, 
	0x1da01663, 0xee27b792, 0xad01c6fa, 0x6ddff58f, 0x9768a9c0, 0x15cb1b76, 
	0x63657bc9, 0xcde8ffa1, 0x556ebdc2, 0x4fc82bee, 0x45c07c7e, 0x4fea8be2, 
	0x4854a689, 0x7de411f2, 0xd7197ae7, 0x135a3849, 0xb26cc7f4, 0x2587b2eb, 
	0x2b7be07f, 0x60f2f4eb, 0x7eddbe71, 0xda25be75, 0x3c4c77c7, 0xbcef6d9e, 
	0xfc1bc87f, 0x158881c4, 0xec24fbef, 0xb0567d66, 0xb8dbef94, 0x250fd2ef, 
	0xf2f1ffec, 0x7c457245, 0x2f8d5a79, 0x88c98861, 0x3b0c24ef, 0x7d88e240, 
	0xf9c38e09, 0x4dd14182, 0x34df487a, 0x7cb3f783, 0x393e2788, 0x313d2f5e, 
	0x738682f2, 0xf2eb7477, 0x83ad3774, 0xc71d7838, 0x4323eefb, 0xfb52f59a, 
	0x9c9fae69, 0xa5759215, 0x3ef1f2c7, 0x5f5ea7a5, 0xc474e370, 0x08f77cfb, 
	0xf75463ef, 0xf14a2737, 0x09e12f1d, 0xc22cf0e3, 0x3fd5e405, 0x8c9b46b1, 
	0x3459896d, 0xc013d40f, 0xa740ad0b, 0x5da5dad7, 0xb8fba095, 0x2535cf4e, 
	0x229fbe69, 0x417adc7a, 0x9f4b9bad, 0xd2df14bb, 0xc41bd67a, 0x2e59eb0f, 
	0xe3c5a172, 0x1d2c66f1, 0x14867719, 0xe05d3cde, 0x067ab187, 0x669fc3fd, 
	0xefe4ea3c, 0xaab9d553, 0xf4e2ae22, 0xdc91cea3, 0x3e7f3d3a, 0xd2473cb4, 
	0x39e40712, 0xc42cce8f, 0xfe572f79, 0x576be5f8, 0x1ebfda3e, 0x3feb47a5, 
	0x5d3c1841, 0x29ac51e2, 0xc3fef1b9, 0xf626cb90, 0x9cb6aceb, 0xe005e078, 
	0x866f6d98, 0x2d5be71d, 0xd61d821e, 0x6ddbda66, 0x51f9df3e, 0xf2e38f7c, 
	0xed38bd5b, 0xfb526e07, 0x52e55293, 0xca4fc1df, 0x8e775e80, 0x83cf9e79, 
	0x9fecf693, 0xde8fdeda, 0x4e430e22, 0x51f058f4, 0xecf359c8, 0x4b416be0, 
	0xf07215d2, 0x077f7a35, 0x72ffd3ad, 0xcdad45f5, 0xd61afe74, 0x697201a3, 
	0x85771007, 0x4257defd, 0xcf249ff3, 0x85f5758f, 0xb11e1208, 0x65356a7f, 
	0x376b2e39, 0x7df477f1, 0x1ae23356, 0xc2a0bfc0, 0x14977c49, 0xc8eb4f5b, 
	0x026b52fa, 0x38beb2ae, 0x3ec7f4a7, 0xef8d53e8, 0x1ed7febb, 0x4fbca57d, 
	0x263ec5f3, 0xf216678d, 0x1a9f98b7, 0x402bce99, 0x40e43daf, 0x2a777f80, 
	0xde7d24b9, 0xab433f02, 0xc57afc95, 0x05bd6e77, 0xe0f98738, 0xa49acdfb, 
	0x1ec8fecd, 0x7c44a9e1, 0xde0dcf82, 0x3a05c726, 0x51afb8f1, 0x6cfcc6e3, 
	0x87d50f9a, 0xdb1a9d14, 0xa1ee3f24, 0x267fbc5b, 0xdf82f7ec, 0x0d061e48, 
	0x5d46875a, 0x845bf793, 0x193e85e9, 0x28d05779, 0x1b1a53f2, 0x335ffbe5, 
	0x08d52e45, 0xb069a7bd, 0x5a98f61b, 0x1fa3c623, 0xbf41a59c, 0x78ab2f35, 
	0x6931f78d, 0xf59f70fd, 0x3513f914, 0xafc79ba2, 0x2269a7c7, 0xa08f9ead, 
	0xfaa3f99f, 0x297cfa89, 0x241f53d0, 0x257f463d, 0x23f53341, 0x39f07269, 
	0x83d096a8, 0xadda2f68, 0x8d5ed8a5, 0xb6873e08, 0xdeb1ccda, 0x1576e7e1, 
	0x55c798e8, 0x83bd64d3, 0x1f3e1644, 0xdf92e15b, 0x82f9e534, 0x46fd070a, 
	0x2c93d3aa, 0xd0dfa0e0, 0x60bd411e, 0x0973cbaf, 0xb8f3fae8, 0xd51ce2ee, 
	0x37bae35f, 0xf9bac69e, 0xbc474a45, 0x7031f786, 0xf3e2983f, 0xf22d7c46, 
	0x707f7bbb, 0xa9d44cc5, 0xd1f102bc, 0x95807e71, 0xfd11f3e2, 0xf92bc391, 
	0xaddcaffb, 0x73b5af8c, 0xd7fdf2e7, 0xf10cd017, 0x73fb44fd, 0x48db7d7c, 
	0x27f75f0d, 0x2ef9036c, 0x87799cae, 0x83ec32f5, 0x656dc3eb, 0xdfce20e2, 
	0x3fb0a5cb, 0x3ca17e4b, 0x31585a77, 0x9bf013d8, 0x3f49cefa, 0xac697a0b, 
	0x047e201c, 0xe64a88ff, 0x1b3fb677, 0xfcc6f20b, 0x79ec15a0, 0x3d332fd7, 
	0x2bf799a2, 0x8357deb0, 0x3d30575f, 0x71759c5c, 0xd75bc5d4, 0x95e5739e, 
	0x0593f8e5, 0x7fb6607b, 0x1a42d376, 0xbeb502ef, 0x21799f2e, 0x97929647, 
	0xc7cb4bbe, 0xb42b8365, 0xab67e120, 0xe317979a, 0x8f60a5bb, 0x351bf1e9, 
	0xfc60fa01, 0x78398bc8, 0x6c7f06ab, 0xe3bb3f2c, 0xcdd9f5d2, 0xf81cf10b, 
	0x63e05836, 0xf8348bb2, 0x92afcca1, 0x97e21ade, 0x9f137645, 0x271d520b, 
	0xf7541dfe, 0x8dd78709, 0xf138dfe5, 0xf7c406ef, 0xd79a3bc4, 0x2cbcd4fb, 
	0xa5eb975d, 0x427225e6, 0x937e7ce3, 0x351ae4e4, 0x835eb92f, 0xb5dec738, 
	0x1c2ec8af, 0xe3b8fac4, 0xd15d38e0, 0x2d8dbd7c, 0x597a0bcd, 0x9e1cb27f, 
	0x8a62fbab, 0x33e06afd, 0x1b1bd1d1, 0x49c8ec89, 0xbeb159fd, 0x5a0b1fc8, 
	0xb7bf1931, 0xbca7c062, 0x453648bf, 0xfe45d3e8, 0xeb9214f5, 0xb25fe0b3, 
	0x2fe872fb, 0xdeeb7cc9, 0xe7c8fd67, 0xc007d9a7, 0xe067d0bf, 0x3453d613, 
	0x923dc5be, 0xbfeff94e, 0x79dfca67, 0x5e285e18, 0xd246fd0c, 0x53bfff19, 
	0x803169d1, 0x78c2f6e1, 0x936b8fbc, 0xd0c1bdf0, 0x94e324fc, 0x61058917, 
	0x2a1f9fec, 0x4ed0e4cb, 0x5e3b45e2, 0xe3781788, 0xb05fb67e, 0x9417d68f, 
	0x0fd8edcf, 0x88e750be, 0x838e7688, 0xce3588f3, 0x68ed48e3, 0xaa8be212, 
	0x6dfeea7f, 0x2eb689c8, 0x35f9c1e8, 0x6700fbfc, 0x78435f30, 0x7e7cb9e5, 
	0x38d06fbe, 0x7ef3f3d7, 0xa1b49df9, 0x7c72f7f6, 0x1f5dd5ae, 0x5fda5cbc, 
	0xe7c97e1b, 0xc6eefc6f, 0x009e6ee5, 0x7fcbefbf, 0x46f3236f, 0x2f3489eb, 
	0xfc9e7e71, 0x398c58ce, 0xb99f4eb7, 0xadbb9e41, 0x0f9c18f2, 0xbd4714ed, 
	0xde7b92f4, 0x5377dd64, 0xb7b75cf2, 0xe07e9cf9, 0xbe9ee22f, 0xfc01fdb6, 
	0x8dff809e, 0x5f38bdc4, 0xa45d6df7, 0xe6e8bee0, 0xbceac3fc, 0x1efc8f6e, 
	0x6b3e993b, 0x5f0e7cf3, 0x912ad2e0, 0xe4a729e1, 0xe8d0af24, 0xcd264df3, 
	0x7c4ddbcb, 0x012949ce, 0xd61ae3e5, 0xa073e2db, 0x2fc0dd78, 0x9e4a76e5, 
	0x79a567e3, 0x8bdae53c, 0x3e35dcea, 0xaaf7c1e5, 0x4f8b7550, 0x8a232639, 
	0x7db030e5, 0xc1f20f57, 0xfc9d67fe, 0x49da861e, 0xc3df1da3, 0x30ed0c0b, 
	0x8d343bca, 0xb2a8ccec, 0xdfd4b2cf, 0x6ccb9264, 0xbb24739b, 0xc48f8853, 
	0xcabefe27, 0xb0fe93ef, 0x508bbf50, 0x5297cf3c, 0xcbef2e3c, 0x726aee54, 
	0x2f9ee7e7, 0xa790f8e8, 0x8b34f979, 0xb65a3af1, 0x8bd1cf8b, 0x9033fa85, 
	0x8d01e0b7, 0x403058f5, 0x43fea5f3, 0x780660e9, 0x69f0fbe8, 0xa095b5fe, 
	0x4676ca27, 0x0f68e7bd, 0x2660c4ec, 0x2eaacda9, 0x6cdd79f0, 0xc13f0b33, 
	0xb2a79bab, 0xab45ef34, 0x62cf812d, 0xb41ead16, 0x59fea20e, 0xd8acff55, 
	0xbfe693b6, 0xe38b06e8, 0x106e8b82, 0xc4d81d8f, 0xb3abc8f2, 0x3ed663e8, 
	0x662d2f99, 0xfaa64cf5, 0x7ba79357, 0xbeb4a28f, 0x951944f0, 0x2d89e2dd, 
	0xe7c5bcfc, 0xcfba2de5, 0xed5db55e, 0xbc266c33, 0x9e67545e, 0xd2873ecc, 
	0x8b129a82, 0x8eff25e6, 0xdd679fdf, 0xc01a2df9, 0xdbac2ba2, 0x8ee1fc55, 
	0xec9f9e34, 0xa5b8c974, 0xd3b27fea, 0xffde5bb9, 0xa13dce12, 0xbb7ab9f5, 
	0xbfa26b8a, 0xdfaac7a0, 0x3877c726, 0xe8b0b843, 0xb41eb453, 0x3bebf57e, 
	0x1cb00c5f, 0x5cf1d359, 0xbadc17fd, 0x4c584b03, 0x93d7219e, 0x24eb40f8, 
	0x9c87d6ba, 0xc75d5b1e, 0x5c3eca77, 0x99eba7ef, 0xf9d517ce, 0x514c402e, 
	0x775ba0ff, 0x9e2ed16a, 0xefca9f87, 0xb7bd15f7, 0xc3e5d3af, 0x33ffdc19, 
	0xe199dd6e, 0x7be13ff6, 0xd5eff347, 0xc93f7bf1, 0xf13757bf, 0xea87127b, 
	0xace3f287, 0x7bfe71e7, 0x13f59c7e, 0xcf5eb38d, 0xfc9bcfb8, 0xeeb754fc, 
	0xf87e7898, 0x3a6543ad, 0xd8eef1dd, 0x86760275, 0xd97fe1f7, 0x176ffd8a, 
	0x8b81eb17, 0xb5b0d7e8, 0x786f6a3e, 0xf0b2a1f1, 0xc43f257e, 0x6ff03e97, 
	0xdc5bde94, 0xe247bfc7, 0x1eedf37b, 0x0dcb16e0, 0x4d97cfe1, 0x47cb9e39, 
	0x6b77c282, 0x287c1cb1, 0x3ae0e525, 0xcedc3bd6, 0xfb5f0299, 0x1dbf0766, 
	0x1f4fe628, 0x10964ef9, 0xfb1abdcb, 0xcf54a54b, 0x16b3c516, 0x622a2efd, 
	0xc5f17145, 0xde7723fe, 0xef27f2af, 0xe0c68fbb, 0x2edbef13, 0xf7f753f7, 
	0x07f787de, 0xf43ce157, 0xddeb1e65, 0x539fc03b, 0x7f3c8c9d, 0x4aeca446, 
	0xf33873f4, 0x63ff5150, 0x3d8e1bdb, 0x17ca8e6b, 0x1eff0435, 0x1787f2c7, 
	0xad2077f0, 0xf98e9a83, 0x5fd7ebbd, 0xe6fdf1d2, 0xbac391f2, 0x657cbefc, 
	0xb3c249e2, 0xde7951c3, 0x47245f81, 0x961bf9e4, 0xc2eb8c56, 0xf8000efd, 
	0xe213eb2e, 0x715f57bb, 0x655e7e08, 0xc421d939, 0x39adde57, 0xbb926edf, 
	0x225649ca, 0xfb75c59b, 0xbaa2fc28, 0x56cb66f9, 0x59d0ca42, 0x37f9cf8b, 
	0xb9f3b7e6, 0x8458deff, 0x39f545f3, 0x1d2dc3c1, 0x785d9f38, 0x5abc249e, 
	0xf139c534, 0xafee9264, 0xd057a517, 0x219fae1a, 0xccf38bc7, 0xfd108f39, 
	0xc9ca28d1, 0x7e13f1ae, 0x65bf299e, 0xa2c77604, 0xd3497daf, 0xea5c6056, 
	0x7387853b, 0x2fc77c41, 0xce3a3c4a, 0xf8af5e7b, 0x75a49453, 0x79ef2f5c, 
	0xa13b0fc1, 0xedcdb172, 0x8fddebd5, 0x78bad2f7, 0x66c79a77, 0x7a560213, 
	0x003f8f53, 0xfbccb7fc, 0xfc0bfa16, 0xf9e4f861, 0x7f266718, 0xbe20ab57, 
	0xf3bef459, 0x5a87915b, 0x13aec0fa, 0xfd880ae4, 0xce5ea433, 0xff2651e7, 
	0xc15322a6, 0x1e7297e7, 0xcd7a1654, 0xd7d7e42c, 0x427cd2b5, 0x4a986fd4, 
	0x3792a9e0, 0xa1e4e2df, 0xd317a96a, 0x8b8e88bb, 0x9db5b1ee, 0xbbdeb949, 
	0x9baf6f48, 0xe239cf27, 0xc38f8379, 0x55952256, 0xd159bff3, 0xbf3c77a5, 
	0x38c0f3b8, 0xd02aeecb, 0x445d3c67, 0xf7c5d24c, 0xf697451d, 0xed174c39, 
	0xd64ba03b, 0xf7a7db32, 0x6ddfd614, 0x77a562f7, 0xf8a458ab, 0x0d9b77e3, 
	0x0cbb97bc, 0xf3758af9, 0x0affd6ad, 0x23ffec7f, 0x4bfec7f1, 0x74c4c7f2, 
	0xbc98fe20, 0x5befc688, 0x6216d10f, 0x1e542dfa, 0xe65b7694, 0x5d445227, 
	0x4df32dbb, 0xa9cf63ea, 0x533bc0ad, 0x3c4128ef, 0x47795a37, 0x6d773e27, 
	0x0ab15868, 0x1733b999, 0x94b9d93d, 0xa955e6ca, 0x59b15855, 0xce97f81f, 
	0xa7395177, 0xb70559c4, 0x5cdcbf55, 0xf578f981, 0x530b2617, 0x97ddc7ce, 
	0x07be9fc3, 0xe117d29f, 0xddd58d11, 0x5bdd43c7, 0xd8beba35, 0xa1f7ba9f, 
	0xe5bc7da2, 0x0f238ede, 0x95f5c71e, 0x29e96e0f, 0x7512dfac, 0xc8e2697e, 
	0xcdc0ada9, 0xefc473c4, 0xf7df91c7, 0x67117bb3, 0xee70125b, 0xbf3d23ed, 
	0xfff57b70, 0xa2d09e46, 0x19f715dd, 0xe70e2b8c, 0xf21b96cb, 0xc4f2b79c, 
	0xe38a4bbb, 0xaeec579d, 0x52a33b60, 0xb5877efd, 0x85e7c84d, 0x097f025e, 
	0xf39f089e, 0x2b73f2a3, 0x9475efd5, 0x27e91f93, 0xc920e0bf, 0x63e246c1, 
	0x3ab3f34f, 0x198cb1f6, 0x7a0a68e2, 0xe708fafe, 0x71be3221, 0xbfc587de, 
	0x11348097, 0xb34987b6, 0x55bf5377, 0x838889f3, 0xf78447a8, 0x229f543b, 
	0x17e641ed, 0xebeedbf0, 0x911fe0ba, 0x7d67289e, 0x4a1717f1, 0xee3473fa, 
	0xe779973f, 0x83ef576c, 0x40f9bafc, 0x31ecbcea, 0xade547bf, 0x7738fc75, 
	0x6966dbc6, 0x1c4667f2, 0xdfc093ff, 0xebb69675, 0x7d78c29a, 0xa4f38466, 
	0x9029b8b5, 0xa5fc4c87, 0x5bef05e3, 0xbe7f06a6, 0x3c8fe68e, 0x3bafb610, 
	0x1e801ca4, 0x52afdff9, 0x0e2e9c79, 0x0fe4e5e8, 0x084b5d50, 0x13677d4d, 
	0x5015dfe0, 0xfdf879f9, 0xf84dba2f, 0x8f385222, 0x96d7d17f, 0xfda4d61e, 
	0x73e1cf2c, 0xc72304fd, 0x09f98bf5, 0x233df8c3, 0x2eb3cf6a, 0x1e3979c2, 
	0x6768f098, 0x26be7044, 0x9a7a57b5, 0x58b4a74b, 0xec7fd48f, 0xb2a31598, 
	0xcdda49a3, 0x9bf6be8b, 0x3f3bfcad, 0xe6506f38, 0x7e809e1f, 0x7996ac1b, 
	0xef15baec, 0xc36d19c6, 0x2084874d, 0xca492d7c, 0xef1c40bc, 0x4a8c3f08, 
	0x5433f3b3, 0x908272e9, 0x1ac0f7eb, 0xfb2b76a2, 0xc93b1afa, 0x380f100e, 
	0x7b17f72c, 0xdfcf0fbe, 0xbaf9fe35, 0xb3ff32f9, 0xfd622c32, 0xf2d9abc4, 
	0xc415127b, 0x93ce0f67, 0x6edf3271, 0xcf4d2cbb, 0x7b824b1b, 0x85595f81, 
	0x8c70e367, 0xe63804f0, 0x2cf4d87b, 0x7d7d2e00, 0x43c204f0, 0xc7b73d79, 
	0x4ef8895c, 0xac4aeb16, 0x7f1aa379, 0xb8f09cb6, 0x36a2e70f, 0xa9fdae32, 
	0xc4bdeae5, 0x78df1b83, 0xe2e572e7, 0xecdc5544, 0xcb1bde46, 0xf2d2e851, 
	0xf4f353e3, 0x50fe5c29, 0x0c6be654, 0x7c352756, 0x7ac5e9ff, 0xba3cbeff, 
	0x3be621f8, 0x4ef801f0, 0xca29b4c0, 0xe61bd497, 0xe70ea0f7, 0x6537bf0d, 
	0x85ecf3ec, 0xda9f43fc, 0x10f270fc, 0x85691f7f, 0xabfb9e65, 0xc9562f2a, 
	0xf36cc651, 0xbe253fc3, 0xb87f414c, 0xdbeae9fc, 0xf887b9e1, 0xee8410f7, 
	0x4fd8989c, 0xdaafd335, 0x2dbe7ec5, 0x67b27cfd, 0xf8ffc477, 0xb513e7fe, 
	0x8bce7bf2, 0xfd639ff9, 0x79f83acb, 0x6f75eb84, 0xa3f03524, 0x8f1873e8, 
	0x757cf4fc, 0xf1775e91, 0xb9373bc4, 0xd16b7a12, 0x491e6957, 0x4a2b21f8, 
	0x433f5883, 0x6c2fa8e8, 0x35bef4b2, 0x2756bc42, 0xc462a2e5, 0xb3de70d6, 
	0x086091b7, 0x531b7eb9, 0xf225ce3a, 0xe39278ee, 0x874dbe62, 0xf7c6dd75, 
	0x573e7e35, 0x552b47cf, 0xabf64e7c, 0x18f3c997, 0x3a99747e, 0xb1134f5f, 
	0xb67cf4d3, 0x6bb60eef, 0x77a9b67d, 0xde1298e5, 0xea8973e2, 0x267e7cf5, 
	0x298548e3, 0x2a7d94f3, 0x14c2bfaf, 0xe387a83d, 0x5b7df941, 0xd31f7d4e, 
	0x705f7f22, 0xa7f49d7f, 0x809a736b, 0x77dbe79d, 0x22d434b8, 0x03ee5d71, 
	0xb4702f08, 0xd08a6476, 0x6e163f08, 0x56efe0ab, 0xd01e882a, 0xc92db527, 
	0x0b971107, 0x3f771b13, 0xb01ceb43, 0xb36b7f19, 0x8978cf83, 0x0b6a595e, 
	0xbc461472, 0x217e7898, 0x3beae1f9, 0x539f1484, 0xb3c6a7d4, 0xe3af7e53, 
	0x2cf2edd3, 0x25df0370, 0xa4d93125, 0x83fd79c1, 0x9fbf9909, 0x25f6e393, 
	0x44f23f35, 0xfb3f7784, 0x9e84a2fb, 0xb0efc0ef, 0x8f7c7e58, 0xaa3fcee0, 
	0xeff9d4e2, 0xefab1610, 0xfe6c6a85, 0x6cff439d, 0x8154b1c2, 0x1f74be8e, 
	0xfdf21547, 0x09fd979d, 0xa86cde75, 0xb061d685, 0xbee37f20, 0x94b29b9f, 
	0xa90873bf, 0x84de49fe, 0x87ee49ef, 0x762d0ee3, 0x17bf8caa, 0x93efdb77, 
	0xad4cffed, 0xa7f41783, 0x1eb10779, 0xbf02def4, 0x4853b653, 0x07ff021c, 
	0xce340eb1, 0xddd25c60, 0xfa4ee8a7, 0x6079c6cc, 0x61f74541, 0x8f3aa97b, 
	0xaba4a96a, 0x4bc20efa, 0x13b91e38, 0x8aff55f7, 0x83d7600f, 0x90f74b4f, 
	0xec8a2a7f, 0xd94fc4fa, 0xe61d27ae, 0x4d6b23ca, 0xfde73df3, 0xb5dd5f98, 
	0x5154ff44, 0x98e88f9c, 0x82d3b22d, 0xd8750a9b, 0x0f37a161, 0x4dcbf9af, 
	0x51cb0ed2, 0xc45b15fd, 0x58b80f90, 0xdfae17d9, 0xa7db6d91, 0xf8c6e769, 
	0xcbdf341d, 0x80e7cc5b, 0xfe3759a3, 0x8e3ef578, 0xcbd7963f, 0xb67d8473, 
	0x8c76c5d0, 0xbda2f137, 0x1c2ffa5f, 0x63e7739f, 0x9f84be9c, 0xf087fa42, 
	0x0ffa4b3c, 0x3cb64a7e, 0x69573bff, 0xafec35d8, 0xf40a7eb8, 0xd7993cd4, 
	0x911938c0, 0x13dfc5f8, 0xf6497c61, 0x8f82f673, 0x6efafb61, 0x3aefdfe6, 
	0x1cb9f906, 0xa3ce66f1, 0x943e64b1, 0x8bab3e7a, 0x3f7c6d17, 0x254f7ea0, 
	0x45f4bddb, 0x8eb0b271, 0xf52ff72d, 0x3f10d62f, 0x7cb08e74, 0xfcd6ff00, 
	0x6b69e3e7, 0xa78a97e3, 0xbbbf8cfd, 0xa54e858b, 0x154cdfa0, 0x3c55334f, 
	0xe0a9efcd, 0x7df015df, 0xe30a5d78, 0x5934df35, 0x6d3d7b1f, 0x4c11c429, 
	0x567f8cfd, 0xe878be51, 0xf1065ccd, 0xf6dd7ab4, 0x8e2e1ef4, 0x1f6f59a7, 
	0x9e2a3c3c, 0x15cef6f6, 0x6f69e2a3, 0x9e38ab7e, 0x7fb131f5, 0x6d678a8b, 
	0x169c029e, 0xded3c542, 0xc72f76fa, 0x52deded3, 0xd67dfcfc, 0x9bf8cbdf, 
	0xfdcb6c73, 0xa539a388, 0xc429e7c8, 0xf0bd06d3, 0xb3cd167b, 0x337fbdde, 
	0x57b669e2, 0x0aacd3c6, 0x99f88c3b, 0x34f1961d, 0x2c9b9f15, 0x3db9bbc2, 
	0x1e1537ab, 0x3d334f1f, 0x0f1559f6, 0x17b7bb31, 0x32ded3c5, 0xbbe2528d, 
	0xbccbd52f, 0x185cb332, 0xd7795788, 0x1c4ee3e7, 0x217ef367, 0x38e2771f, 
	0xefc79e1b, 0xd2437a22, 0x97bfcade, 0x38b9c7c9, 0x307de6ae, 0xb8e2e71f, 
	0xdbdf45da, 0xe38fef97, 0xf267de6a, 0xbdf8cdfd, 0xbfcd1dfd, 0xef3571c7, 
	0xd5eff24f, 0xb63de45d, 0xf943bc77, 0xcd5c7271, 0x71f9effb, 0x4e344fd6, 
	0xf26ae22f, 0x9f9f9379, 0x5c55d6ea, 0x3d11ec8d, 0x3c44f447, 0xe2a3720d, 
	0xb388f564, 0xf3e915f5, 0xe291ec09, 0xdb7d5af8, 0xdf7ae60e, 0x80a4f79b, 
	0xed5c6ee7, 0x5fcbe872, 0x82cb7bd0, 0x1679f176, 0x79de2ab5, 0xafed49b4, 
	0xcd56ce23, 0x3c7622f2, 0xb1e2724f, 0x35ff067f, 0x03fff88a, 0x7386fe32, 
	0xc8661bb7, 0xc38e747c, 0x9e178701, 0x841c81ec, 0x7112a4de, 0x78bb6dd3, 
	0x4f1ef51c, 0xe85b5d97, 0x977eec2f, 0x3ed9586c, 0x76133392, 0x6ae420c8, 
	0xe67607a0, 0xded2bdcc, 0xc641a2bc, 0xe5b95c63, 0x9fd803f3, 0x3d28d6b1, 
	0x1e3d0a5e, 0x3b2e898e, 0x99203c82, 0x89cfe5cf, 0xeb9bb029, 0x658e473d, 
	0xdeffb887, 0xc7a013be, 0xf2363d0b, 0x9c903633, 0x6ff53b50, 0x8b7e70f6, 
	0xfd359c30, 0xb87b3768, 0x8464fb14, 0x33ce3ac5, 0x2ff5fb74, 0x58fa93eb, 
	0xf9e4a5b4, 0xf10a56fb, 0xc3c6e08f, 0x1075f43a, 0xdbf91276, 0xb5c27281, 
	0x7bf39c22, 0xb3fe7c3c, 0xcf8a536f, 0xc0fb2ff7, 0xf5f9bdcc, 0x6302ffa0, 
	0xf5b7f070, 0xbd83fed2, 0xcad5df81, 0xfc676ece, 0x7e8cd409, 0xfc5dd4cf, 
	0x8cfbf8b6, 0xeb5fa50a, 0xfd5b3e3d, 0x10e0404e, 0x7698f38f, 0x3fdd7088, 
	0x8827f412, 0x926b1fcf, 0x9fdb18f6, 0x5282b7b0, 0xbe62d7cf, 0x9f2fa649, 
	0xcea75b2b, 0x07619ead, 0xba5e3bf9, 0xfdf719bf, 0x039f20f1, 0xf47e7c30, 
	0xae3fc8f7, 0x9121cf77, 0x78f14dfb, 0xd37c8e85, 0x068e9dca, 0xbf438a3e, 
	0xcbdf12ff, 0xe8acfd2b, 0x29db70b3, 0x678827ce, 0x7da3ef49, 0x17e855d8, 
	0x7609bffa, 0x1bea9395, 0xf0a571e4, 0x9c5c677d, 0xf54bc679, 0xfd3eee19, 
	0xc0adbeb2, 0xc46dfae9, 0xfbbe166f, 0xaabed876, 0xf83364f7, 0x7b0fdc2e, 
	0x1ac1ea8a, 0xabf6c7a7, 0xbd819df9, 0x3e475872, 0xeca5b0f8, 0xb10f6509, 
	0x9071859d, 0x5033d13f, 0xa424ff64, 0x537a157d, 0xa178ba63, 0x41b74029, 
	0x9d5f8e47, 0x9f9f900b, 0xfeff2f6a, 0x6a7ed2d5, 0xcaafffb9, 0x0f11695a, 
	0xa422bd13, 0x60e9c29f, 0x20bfc617, 0xf484329b, 0xcf587b97, 0xeeeb49be, 
	0x3a7d5e60, 0x6521e3e2, 0xd8c68757, 0x2966a9d7, 0xa517ffaf, 0x00cab2f2, 
	0x0002a021, 0x7ded9c78, 0xd5547c0d, 0x93b9f799, 0x0f9333b9, 0x40926661, 
	0xf3730988, 0x21092105, 0xcc060124, 0x97c82e6b, 0xb6a2fad5, 0x3b6eed7e, 
	0xb562a571, 0x8dd65836, 0x13bd6ddd, 0x08c13206, 0x104c0413, 0xd6505a35, 
	0x4b5d8b6a, 0x4eeefad1, 0x745a8a94, 0x6dad6b61, 0xa820eedd, 0xbc8ae9a0, 
	0xacb217d4, 0x9cf3cfbe, 0xdcccef73, 0xf0933b99, 0xfefafeda, 0x0fdf97de, 
	0x3dee672e, 0xf9e73ce7, 0x3ff3cf3a, 0xe37b9ee7, 0x27fcc674, 0x2439fc19, 
	0xaaf05369, 0x632cec49, 0xaffc3731, 0xad673197, 0xc1d3dedb, 0xcdc86398, 
	0xbef1b31c, 0x79e5cf4a, 0x39f10657, 0xbf80d61b, 0x4efe4d23, 0xc7fc26f6, 
	0x9887c7ef, 0xf7b0afec, 0x6bdf871c, 0x1cf8efc5, 0x3252383c, 0x035d93bf, 
	0x553e6505, 0xd7629994, 0x546ef03a, 0xcc615ed2, 0xfea12eed, 0xfadfd09c, 
	0x989578d9, 0x91ae8274, 0xc06f6c1c, 0x79bbebcf, 0xf872aafd, 0xcfb869ff, 
	0xf195ec8e, 0xd7dc5fbe, 0x9ff01d38, 0xf408ed1c, 0x58ba7763, 0xad8caf0c, 
	0x35d5095d, 0x2be302a8, 0x91e811dc, 0xc1ebbee0, 0x0a987b2b, 0x1d5707e5, 
	0x777c6090, 0xc033c237, 0x7cf8a397, 0x42b33431, 0x190645b3, 0x73df82eb, 
	0xcd6df7e1, 0x4d5b0ab5, 0x7767a8fc, 0xf8512f41, 0x55c50b9b, 0x2f91ea1b, 
	0x89345c9f, 0xb302c7f8, 0xaeed7ee8, 0xe8ecbc99, 0xc6094ffc, 0xe652fbf7, 
	0xacbf4072, 0x25a7eba8, 0xdc9b191b, 0xd7d8aadc, 0x9d1f9f40, 0x009b6fa9, 
	0xd6f53074, 0x477bf033, 0x7d851cd9, 0x9e1c7d9c, 0xc09d3b87, 0xff471811, 
	0x6e81165a, 0x04cefe91, 0xfa7397fa, 0x57e837af, 0xfa26bb45, 0x0e547da3, 
	0xf2f315b5, 0xcf1a56a1, 0x67e6b697, 0x8a8bffa1, 0xdee0e41d, 0x1167e9c4, 
	0xd728fbf5, 0x45da9d09, 0xc71c15ec, 0xcb5fd415, 0x7a434cc5, 0x5fbbfb7c, 
	0xfd4b3bcd, 0x7d7fc24f, 0xe8e5ea6f, 0x84eb9424, 0xb97fce72, 0x42d69340, 
	0xb46f3e3b, 0x7f0cf507, 0x1ddf87cf, 0xfc3f7bf8, 0x55fbac7e, 0x32676f1b, 
	0xa27df3d6, 0x9993a397, 0x8775de78, 0xa8491fa8, 0xd7ab5f67, 0x937aa12b, 
	0x24b472f4, 0x786abd63, 0x47aa2eee, 0xab9be2d6, 0x7453a397, 0x5bd6d3ba, 
	0xa52bd46c, 0xf518d77a, 0xbbd6334a, 0x42f3a0c9, 0x834ef3a2, 0xdff10bce, 
	0x3e0328ff, 0x76c3d425, 0xb7ddc818, 0x80d9add9, 0x9cd503cf, 0xd7f9155f, 
	0x3c501907, 0xb6cab267, 0xd2ac612e, 0x19babea6, 0x61c8abda, 0x50adeed1, 
	0x74195ef6, 0xf27b720d, 0x13f0fd40, 0x0b71cb92, 0x1bd17ff0, 0xe603cc3d, 
	0x87a87a3a, 0x0776c11d, 0xadbf4483, 0x83b6837b, 0xcfe0cfb1, 0xab19bbfa, 
	0x1bad31b3, 0x86a5ccf5, 0x779cf023, 0x775cc2e7, 0x945bae00, 0xa794375e, 
	0xb8152a3e, 0xab738e41, 0x449391e0, 0x1bdaf0c7, 0x48f340c9, 0xf2ea5caf, 
	0x575fb85e, 0x96d06da9, 0xd757cd03, 0xa87a8a3c, 0x82bc97fb, 0x15b2aff9, 
	0x90afbb71, 0x0ffa8a99, 0xf7d61705, 0x86af6cd9, 0xd3fb426f, 0xc52f7b72, 
	0xfa17d8f6, 0x8384afd1, 0x1297fdb9, 0x31c8e1bd, 0x690adb18, 0xde23a3a2, 
	0x158c597f, 0xb673d430, 0x423e1838, 0xe0460e7c, 0x77d2bcf9, 0xb85bfc93, 
	0xe30fc60e, 0x16ae3f29, 0x706dbd90, 0x8e1f9187, 0xed4165d1, 0x68d3e005, 
	0xa179a48f, 0x36bb30ac, 0x6c37b680, 0xba9d81b7, 0xa85268cf, 0xd9b79e07, 
	0xe177eeb4, 0x9742d77e, 0x9ef3c71d, 0xb8e78f9f, 0xcd683a9f, 0xc0c37353, 
	0x6e148fe7, 0xdbb45eb7, 0x1d8f44ad, 0x39d9e2f9, 0xfe85eb9c, 0xeb439b65, 
	0xd2c3dfa6, 0xa3a7903e, 0xa1fb2dd6, 0x75f0295e, 0xf071f905, 0xa8b7c007, 
	0x1173db9b, 0x3e2313d2, 0xab8c1a49, 0x8e3f034c, 0xf80cfcfe, 0x23aff075, 
	0x9b2fe131, 0x28d51d38, 0x1dbc95c7, 0xd7ac7fb2, 0xa0f4ed41, 0xba4eca5c, 
	0xc7f01eed, 0x3edc28af, 0x644ccecb, 0x1ae037d2, 0x81cb6c0e, 0x49011c7e, 
	0xc137bf5b, 0xbcb8bb4f, 0xbdb122ca, 0xff47de32, 0xbf6a74fe, 0x25fb9bcd, 
	0xb752a7e4, 0x38a2c822, 0x56d9892e, 0x615d78e2, 0x73589198, 0x048c169e, 
	0xb8609e88, 0x588de717, 0x7743fa2e, 0x96d41aa9, 0x91cdf3c1, 0x1d3fac3e, 
	0x94b947db, 0x7cf0dd02, 0x47cc1693, 0x397403ff, 0xc3b31e51, 0x3f28f9c3, 
	0x99335c7d, 0x51450cea, 0x1f2e25bf, 0x11e5f03f, 0x9d654fa0, 0x0517d01a, 
	0x719580fa, 0x8cbc857a, 0x59f3edfb, 0xd75cfc17, 0xfd80d91d, 0x76c36937, 
	0xf02f7f6c, 0xf60d64a7, 0x7645d0b7, 0x72a3fa83, 0x7106d2fd, 0xfa171e5c, 
	0x15140569, 0x755fa9e5, 0x254dfa7b, 0x827f93b7, 0xf58cf42b, 0x7065e692, 
	0x07cd12b0, 0xfd0c3c2b, 0x44f3c930, 0xf82b7cc2, 0x42def58a, 0x4aeef37d, 
	0x134767d2, 0x5e31cfcc, 0x1959e71f, 0x125bd9e7, 0xe7c671e6, 0xf10d996b, 
	0x8dfe707e, 0xf3e7b8e1, 0x1d0ec2fb, 0xca32df82, 0x1f3e29b7, 0xa66fe59b, 
	0x77fc364b, 0x136ff750, 0xcbd6ffb9, 0xaff889d1, 0xd6eeffb5, 0xfc9ba9fd, 
	0x0cbd24d1, 0x9fc99f9a, 0x85f31b56, 0x6b9bfa87, 0x8c9e17cc, 0xea362dfd, 
	0x35dea979, 0xc66f3d46, 0x7419377a, 0x779d1216, 0x6616741a, 0xf46433a4, 
	0x6dfd4457, 0xca2bfa33, 0xa34edfd8, 0x6fea62bf, 0x715fd1af, 0x1bf6fec6, 
	0x58f98cf5, 0xf8f9a3d4, 0x53f7b45a, 0x04ccf3a9, 0x3d9f6f21, 0xb857d7a4, 
	0x5472f43c, 0x5ce6ff21, 0x3916bc34, 0x08a552e5, 0x5ae2adf8, 0x1567bd65, 
	0x72a64b63, 0xa89e2f3d, 0xed96fdd2, 0x79c3ae57, 0xcc04f1c2, 0x3fd7a817, 
	0x3fd39938, 0x03c6f304, 0xd1baf7fd, 0x72c4dc7f, 0x8732c7c1, 0x41578ff0, 
	0x3fa842fd, 0xa18356e2, 0xe36eb937, 0x468edd5f, 0x1b5da4a0, 0xfc2667d7, 
	0x647cd323, 0x59aaf647, 0x9176583d, 0x4eeb8167, 0x17e8a3db, 0xff06ee5a, 
	0xf6070f40, 0xa997fea1, 0x138c7645, 0x2bf3de47, 0xa36d7e3c, 0xca9e6e8e, 
	0x16521fc7, 0x5bced13b, 0x941b3a1e, 0x0fb5d216, 0x914724e3, 0x61860fea, 
	0xa2c59bfe, 0x11616f48, 0x0887ecab, 0xb7705c23, 0xfc7c03df, 0xbf1f2379, 
	0xdf96bb63, 0x9ae7f60d, 0xfd147ee7, 0xf01df842, 0x2b957013, 0xd41b344b, 
	0x87bbd7b3, 0x573da09b, 0x0d3d26ab, 0x28763a74, 0xe748d9b6, 0x1883b1c3, 
	0x3906ef96, 0xfc627494, 0x02922ca7, 0xe9f05f50, 0x709f2101, 0x420cab01, 
	0xf56a057b, 0xe22ae701, 0xc5c579c6, 0x6571cd0b, 0x4f7c5c4a, 0xf2b8da45, 
	0xfbe2e3bc, 0x2cae302b, 0x078b894b, 0x2e27ce2a, 0x14c2a8fe, 0xc5c4a7d7, 
	0xff4f4bdf, 0x7bc5c779, 0xc5c7322a, 0x1e60574f, 0x7ed18f21, 0xf1f48ad5, 
	0x7f463c9e, 0xdf516cd3, 0x316d8f8a, 0xfed8f889, 0x56b2c750, 0x357af509, 
	0xcdafc1e9, 0xf80ebc7c, 0x06bfbf08, 0x2276e7bf, 0xb8d28f1f, 0x235eca3a, 
	0xb013827e, 0x86c7bce1, 0xf9072afe, 0x1cdf7a78, 0x2f3dc7ce, 0x8f1f20e4, 
	0x7ce36c4d, 0xe9bad21c, 0x85ed12b9, 0xf21fea20, 0x5938e313, 0xfa04aee9, 
	0x3d0d983f, 0x63cc0dff, 0x6e4977ef, 0x47c267a0, 0x37575cfe, 0x7f9b4b63, 
	0x76e8fd43, 0xd74e94ff, 0xddd383d0, 0x03fa1367, 0x9c508b95, 0x011e9d17, 
	0xc15cbffe, 0xd0276fed, 0x3cbe076b, 0x74cd5b75, 0xfe469836, 0x27d60f43, 
	0x4fab6dd3, 0xfe52dba2, 0xaf302b07, 0x85fd436b, 0xefea1172, 0x24f7a404, 
	0xde8527f1, 0x6bd11f68, 0xde8999e8, 0x4ede9187, 0x856cf7a4, 0x7a0654fd, 
	0x1d5f5bcf, 0x5a879495, 0x12b3abea, 0x5be86cf9, 0xca6bc8c8, 0x19b6df48, 
	0xea194d79, 0xf22c1fdb, 0xf38c7913, 0xfa457571, 0x631e4779, 0x516e501c, 
	0xe71e817f, 0x041498ba, 0x3e548cfe, 0x527c50af, 0xff4c46db, 0x41e786ac, 
	0x2e5c45ed, 0xe26d9b72, 0xf29bf054, 0x41cab3df, 0x7077e9e8, 0xa4f309bf, 
	0xe0a4d7bf, 0x19676066, 0x162e8f9f, 0xbc22d079, 0xa1cfe56e, 0xea2bc65f, 
	0x45957e99, 0xe505ffbb, 0xb2fee08b, 0xdb12b390, 0x2c6ddb09, 0x3f8cc5d2, 
	0x7f69b05f, 0xc619df7b, 0xadd1d540, 0xb40bf6b3, 0x19449bd5, 0x7ef9b3e7, 
	0xdc0742db, 0xbf7497f0, 0x35fc4121, 0x00fba4bf, 0xe4bfafda, 0xfca2d385, 
	0xc25bcc2b, 0x0f63bf40, 0x18e8befe, 0xc4bf3436, 0xc6d978c6, 0x97e6ced0, 
	0xedb21a2c, 0xcea2e7c1, 0x3f748de0, 0xfe821b68, 0x02b91dce, 0x99ce64f5, 
	0x7e30afc0, 0xe0feea5f, 0x181cb2de, 0x528ddb67, 0x2be05ac5, 0xe6e21b8e, 
	0xae0bed65, 0xab0f3090, 0x15f07ce6, 0xab37ebf1, 0x5edebeb9, 0x29ddc7cd, 
	0x45e717ae, 0x5e30dd83, 0x2d44d4f9, 0xebfdee31, 0xe0bf3e6a, 0x94f904b5, 
	0x20d51ec7, 0x147a5f93, 0xc58e38ae, 0x3f6236c7, 0x3c818f94, 0x34b3957d, 
	0x5eeefe7d, 0xc811d8c7, 0x8cec2e83, 0xf0edb7cf, 0x706dee7b, 0x0fa87dff, 
	0x41345ff4, 0x1f306a0b, 0x21dd9b87, 0xe4fc8be4, 0x40aecbb0, 0x53723f9f, 
	0xd5f28ffc, 0x2834ddd0, 0x0ee3064e, 0x9cbdfce3, 0x0f67a9f4, 0x5dcfdd94, 
	0x41526a19, 0x3e9c552e, 0x848886cf, 0x6650e7f6, 0x9d2fb431, 0xeec2b00e, 
	0xb7fbf043, 0x88877e20, 0x886de599, 0xec5ca374, 0xe51247ca, 0x8fa079ab, 
	0x8573bfd0, 0x7ce192bb, 0xe619daae, 0xe780dfeb, 0xdbbd46af, 0x1d24b4f1, 
	0xec863a43, 0x46f37768, 0x220c0ddd, 0x99613db3, 0x834706f2, 0xa25672c2, 
	0x9258fe3f, 0x8f9c7172, 0x1da0dad8, 0x7b5af6a5, 0x1f688dc9, 0xa16e84aa, 
	0xcb29e847, 0x67ec96e9, 0x934f57e3, 0x472bf29b, 0x57ca21f3, 0x069ec1da, 
	0x07fe9ec0, 0xf31b3f3c, 0x8c1dd03a, 0x7a03ee3b, 0xd3d0d3f2, 0xad88f03e, 
	0x6de5181c, 0xec39e852, 0x5b8c15ef, 0x34c2fea0, 0x47b639fd, 0x794898ed, 
	0xe6bb7806, 0x1fd8bcfe, 0x255d7f8c, 0x0b0ae78f, 0x27c44ea2, 0xf1184fe0, 
	0xabb09f46, 0x25fae791, 0xcf7d0f8c, 0x84dc961d, 0x9c216844, 0xc35c7e77, 
	0xa79bccf5, 0x4daf8885, 0xceef0951, 0x7ef2a05b, 0xefd02e51, 0x6f6e4af6, 
	0xe7e06ede, 0xbae7e436, 0x1473f120, 0xf39e01f4, 0x376fd8da, 0xfa7bfb73, 
	0x9fa26f5e, 0xad178cc9, 0xb9fbd254, 0x42f7c811, 0x2bbc88d7, 0x98397404, 
	0x9c82f686, 0x9a9c79e1, 0xd18a8673, 0x78f8379c, 0xfae1b7e4, 0x6b7fe63c, 
	0x18e386e8, 0x4231ddff, 0x0e0a5557, 0x3c637e72, 0xb135b727, 0x9c03c41c, 
	0xbbf6dc8b, 0x409fd7e2, 0x2293dafd, 0x7e853b1f, 0x7ac6ed4e, 0x3e528a4c, 
	0xbb75ace8, 0x3c038e98, 0x894bfd42, 0xcc5781b8, 0x4aa28aff, 0x5cb5281a, 
	0xbc8d1eca, 0xa398f54f, 0x35670122, 0x7a4d4cf2, 0x5579ae1b, 0x01456e9c, 
	0x2839033b, 0x10c45b88, 0x0798963f, 0xa480dd71, 0x0f834b6d, 0xe1075838, 
	0x27cc4e07, 0x21f5a021, 0x30f584ee, 0xc54a1caf, 0x20eaeb97, 0xe788eedf, 
	0x0f6794db, 0xa9e08e22, 0x35bc38c4, 0x8877e20f, 0x57a8c3c3, 0xb99c0aef, 
	0x55047117, 0xe12a08e0, 0xad1e7a08, 0x1d72cee3, 0x2f8811c7, 0x93552e58, 
	0x84d90470, 0xc07e1023, 0xcebb23db, 0x9c395d2b, 0x38eb8b84, 0x11c72d41, 
	0x19bc79cc, 0xfe7ca057, 0x3d7a8496, 0xfda5d67e, 0xe3d793df, 0xd707609d, 
	0xf200ed17, 0x11e92271, 0xdcfd7dca, 0xdb9b3954, 0x256ae5d3, 0x2845c477, 
	0x61fa14df, 0xbf1c7f96, 0x5f6e24d2, 0xc825aecc, 0x75f34473, 0x71c66f6a, 
	0x57d01a9d, 0xfc7c69f7, 0x70d75a61, 0x4b75be20, 0xfa423e7c, 0x9427dfa5, 
	0x7902e711, 0x5278c5bb, 0x0ee918f4, 0xf1827d08, 0x6eff6a15, 0xbe100eef, 
	0x31963844, 0x213eb11e, 0xe20c2e8f, 0xfdd754bc, 0x5fbc06f0, 0xea1754c1, 
	0x8bd4ef93, 0x6527283d, 0x3b733834, 0xf5771077, 0x507153b8, 0xdb288e33, 
	0xbc79cba2, 0xf0fae510, 0xc60174a4, 0xe068ad07, 0x0bff40cf, 0xc8c7ee98, 
	0xee348e3f, 0x9f010fcb, 0x4503cd8f, 0xf43c0809, 0x22738115, 0x17e0fc3f, 
	0x6b972e60, 0xbbcfdc9d, 0x4ee22934, 0xfe0587d0, 0x70ddb557, 0x7f2fbb9d, 
	0x3cf8eecb, 0xc3b9ef31, 0x032f643d, 0xb64bf647, 0x7ed57cf8, 0xf38ec3ae, 
	0xfae7bcf7, 0xc44725ed, 0xec65153c, 0x079f1564, 0xd786f3cc, 0x32dca798, 
	0x90edb4e2, 0x71bce2c7, 0xb307c403, 0xb72f313b, 0xaaab5d13, 0xcc54f3cc, 
	0x79c52ece, 0xfc83fa0a, 0xa9e710a0, 0xf53cf8e2, 0x30bf3c31, 0x478e7f4d, 
	0x1e7034c1, 0x91f3e218, 0xd142bfb9, 0x7c550ddf, 0x79c22a9e, 0xcd159b8a, 
	0xf305cc53, 0xdd4fce0f, 0xb8c09f30, 0x1f1e76ec, 0xff215ab9, 0x5f6dff06, 
	0xff461eeb, 0xdc43b612, 0x28b81208, 0x2d9f08c4, 0x13a8b170, 0xc05fb6e8, 
	0x063c6216, 0xe422c7f1, 0x5d7b5c93, 0x6e784cce, 0x1d87dbc1, 0xf7df500d, 
	0x15ebb3ec, 0x0feffb28, 0x3ae0ca38, 0xf5fed5ff, 0x141aafe4, 0x170ee21b, 
	0x9e7d7356, 0xb25596bf, 0x64d578a3, 0xbc9af106, 0x424959e3, 0xece3b0bf, 
	0x14360441, 0xd17793b4, 0x693bf68e, 0xee20d33e, 0x65f519b9, 0x630055d8, 
	0x78ae8df7, 0x5b58f09d, 0x4beeebff, 0x475e9ec9, 0xafe21c7c, 0xffce1209, 
	0xd07eee30, 0x5f3c3097, 0xce3bcf04, 0xa2e5223d, 0xaeae2ede, 0xde7b40f4, 
	0x88dfed7f, 0x17e0b9f6, 0xca19febf, 0x3d1051cd, 0xa3bc7888, 0x17313621, 
	0xab8611c6, 0xe3f383c7, 0xb86dc20a, 0x093f92c5, 0xa2a31e86, 0xedc29c14, 
	0x31bbfeee, 0x81303d1f, 0x6979e2ad, 0x3703db84, 0x0e6107ee, 0xfa056517, 
	0xac61ed6d, 0x965e2baf, 0xadcb938b, 0xb6c4e94e, 0x5a7884ae, 0x2fdd0e1e, 
	0xab4cf8ca, 0x363b85f3, 0x92d1f3d1, 0x4ae91b8d, 0xc3e403fe, 0x029f206c, 
	0xaf94c5ff, 0x3b59fa7e, 0xb9b19030, 0xea1a3ddb, 0x01442167, 0x0347980e, 
	0x67ad199b, 0x8e7b3016, 0x99d922f6, 0x826f9f1d, 0x823fa1c1, 0x940ea2e7, 
	0x4e114437, 0xc80f47b0, 0x65e413ab, 0x1dbcfe9b, 0x395719e3, 0x7af38fdb, 
	0x9a2555cb, 0xa76e5ded, 0x0a447d62, 0x21fb894f, 0xe3a4cfc4, 0xc59b8fe7, 
	0x870804a6, 0x35592d73, 0x99bf01ec, 0x4b72e22f, 0x1f76ad1c, 0x9982d763, 
	0xa387c604, 0xcb75f1e9, 0x3a7fa043, 0x8a91568e, 0x866e11a3, 0x3cddd9f8, 
	0x1fbe06fe, 0x6fe212d4, 0x6fa1cb8a, 0x87d635b9, 0x00691a82, 0x86ed05bf, 
	0x7bf3aa9c, 0xe81ec158, 0xf8c3477e, 0xad30d67a, 0x6cd90f27, 0xdf8457c1, 
	0x74ed495a, 0x6fb88105, 0x26b75e22, 0x5a46c7ee, 0x42d56fc1, 0x00761df9, 
	0x841c27db, 0x89d56ef2, 0xe5776372, 0xb4b43c52, 0xbfd694a5, 0xcb48f8cc, 
	0xa8b5fef6, 0x3d2f60df, 0xa92f2fe8, 0x81a379e6, 0xb8e2ac8b, 0x8eb55b48, 
	0x1ab17d2f, 0x328ee7f3, 0x338478f0, 0x46fd1931, 0xb885c62e, 0xebc7d00e, 
	0x57f77ce9, 0xaf059c73, 0x4d38094d, 0xaf810ff9, 0x9dd7ec31, 0xcf79ae96, 
	0xbce00e79, 0xe9d7d458, 0x8db8839c, 0x07eb5c14, 0x9b5454fe, 0xd38d3bf0, 
	0x71d6af67, 0x9f417a9b, 0xb7093abd, 0xb84cdc89, 0x7cd76b8d, 0x2a2fc7e2, 
	0x9167ffb8, 0xbef7e8f7, 0xae38f305, 0x8dd6b2f0, 0x1e2b19e3, 0x28fc007b, 
	0x87c7193b, 0x59bc8817, 0x188a7e7f, 0x71563fff, 0x578f49ba, 0x1ff8f5c5, 
	0x8bdfdf85, 0xedc1dced, 0xc39de904, 0x26f921d8, 0x2b914ac6, 0xaa45f930, 
	0xf576bd04, 0x7f00ff8a, 0x8783d178, 0x405f90fb, 0x7ba404c5, 0x75657369, 
	0xf2263c5a, 0xfa31e138, 0x8f0999b8, 0xc74aacf9, 0x33abea8f, 0xc79131e2, 
	0xc7f913eb, 0x93ead322, 0xc78966f8, 0x1e2354e4, 0xec9fe3a3, 0x28fbf565, 
	0xf98f1d7f, 0xf42e3eba, 0xd1bdba97, 0x86cba2b8, 0x0bf2096d, 0xb272495f, 
	0x592eb8fd, 0x417e877e, 0x41dbecfe, 0xe3eecb81, 0xe6d2dbf8, 0x11f9e9c5, 
	0xe87e27ee, 0xf1f998ed, 0x2f8fc1a1, 0xb847e666, 0x1e913ebf, 0x3eb0a876, 
	0x7e4b0e89, 0xc495547c, 0xf8c97d8f, 0x9e73d154, 0xf317eb30, 0x33cf315b, 
	0x932ebaf9, 0x52bd39fa, 0x1be720ef, 0x3fce95ea, 0x114bc887, 0x429dea0f, 
	0x267ce476, 0x54b7b718, 0xf5f6e7bb, 0x071e6aed, 0xc5d4f618, 0x196fe4f1, 
	0xf61214f6, 0x2f5d3b74, 0x20aaeabe, 0xf37217c6, 0xca779455, 0x53ce515e, 
	0x04b2dd3f, 0x9f5990f1, 0x412efe0d, 0x24ad6f6e, 0x57dfecf9, 0xe4317c47, 
	0xe4987cb6, 0x41a3a7b9, 0xdcba7de0, 0xdcbd2efe, 0xdd35dade, 0x1dbc577d, 
	0xa96edcb3, 0x50c571d6, 0xb5bdb966, 0x1e913eab, 0x4faa5cb6, 0x6e52c3a2, 
	0x1c26a8df, 0x7fad19df, 0x2256e41e, 0x8c795070, 0x536e2afb, 0xfad7e7d2, 
	0x21c43e3a, 0x8634c0b9, 0xf304d9ec, 0xdb09a626, 0x07bae0e6, 0xc8c759c4, 
	0x2ec7301f, 0x37e42fb8, 0x9dbf1307, 0x9cf4f1a9, 0x0936c0a6, 0x39594bfc, 
	0x5f1ccfef, 0x2216fb1b, 0xfb882951, 0xec7c76a3, 0x8bcb79c4, 0x082a25fb, 
	0xb7bca07f, 0x41d7ff22, 0xe1be775a, 0x4dea20ba, 0xd070f7a5, 0x6d9cf18d, 
	0x1de71071, 0x0848e6e7, 0xa8ef0941, 0xbc34fb42, 0x19ce625b, 0x29b97183, 
	0xef184aa3, 0xddb1ecfb, 0x5aeb8861, 0xcc2caa96, 0xb5d81af0, 0x8bb7cb07, 
	0xc781edf2, 0x0d7cb006, 0x2abc3594, 0x067fbb05, 0x7268afd7, 0xe5b7f418, 
	0xe163cabb, 0xbf5578fd, 0xa7c804f2, 0x82ec7d65, 0xcb59e830, 0x9ee72546, 
	0xaa9d70b5, 0x88bf09ec, 0xc1ed9557, 0x27d51af6, 0x7546f9e9, 0x573f3d27, 
	0x790fd099, 0x3504cb5c, 0x6bc02e1c, 0x8f00f034, 0xf1ee2aa7, 0xfaa25e22, 
	0x23325e04, 0xcb70810c, 0xe63cf8d7, 0xcf64373b, 0x169cf185, 0x40b7a1f3, 
	0xe59ca3b3, 0xd3390c9b, 0x4ef9167e, 0x9fb4ce43, 0xf5c79f05, 0xd7cbd949, 
	0x217a8cbf, 0x9c217f03, 0xe066de59, 0x5b33842f, 0xf469dbd6, 0xedfd4e57, 
	0xcf2bfa35, 0xa37edfd8, 0xf7aa54de, 0x6a6f51a6, 0x27027afa, 0xe9d0663e, 
	0x313f3a23, 0xa3a5f4e8, 0x5375c653, 0xcf42bcfe, 0x51cbd24f, 0x38c5375a, 
	0xfc043ec7, 0x1f71f1dc, 0x3d09ebad, 0x3c196df3, 0xd743fe88, 0x867e7317, 
	0xeed14d71, 0x16fbbeb8, 0xe66f216f, 0x683bbd18, 0xf881abec, 0x39e20e75, 
	0x02dea027, 0x6f485fbe, 0xf70a3bef, 0xd755fa8f, 0x9d85877b, 0x96764c39, 
	0x6f685762, 0xf43dbc23, 0x2576295f, 0x06f50eec, 0x390c97d7, 0x49f8362c, 
	0x6be4a6fb, 0xbed27e0c, 0xb9aad7a9, 0x44fcea9d, 0x27fed2fe, 0x43763b73, 
	0xc9df849e, 0x96790c93, 0x6a83d464, 0x4bf27fa3, 0x7fa35cf2, 0x35854bf2, 
	0xdcc17d7c, 0xbd781bff, 0x09c74e23, 0x978a9f2c, 0xffba6b7f, 0x555ca98e, 
	0xf6365c93, 0xd5d959cd, 0x851d637e, 0x37e5efd6, 0x4994758d, 0x98e3ed19, 
	0xfb427eb1, 0x8c4fe4e7, 0x3fda13f5, 0xbe316657, 0xf1e49af6, 0xa77bf0a4, 
	0x63ad0f41, 0x7a0d7bca, 0x6fd31d68, 0x3b4a6ed1, 0xd0ed1937, 0xa77ca67a, 
	0xc6614ed1, 0x718c8571, 0x7909fed1, 0xda2e319b, 0x8b05f13f, 0x8f306ffe, 
	0x20f3db0b, 0x7b7a829f, 0xf49f3913, 0x62a7df32, 0xa0dd8749, 0xdbedcddf, 
	0x919ddfa0, 0x7e836afe, 0xe793175a, 0x327bf41a, 0xa8d8b7f6, 0xe454fb47, 
	0xb47a8c6b, 0x9aeae54f, 0x9772f6f4, 0x30eedf49, 0xd356e1f1, 0x078bca7d, 
	0xd38b79e3, 0xa8fcb794, 0x1f8dfb86, 0x5bcfa4d5, 0x63279b14, 0x25f852de, 
	0xfe705bc8, 0xde51af9a, 0xb64d40f2, 0x0d5765bc, 0x807e6f5f, 0x779b4bae, 
	0x0f5da4d4, 0x6fcf12ce, 0xd7e3d1ab, 0xd719355d, 0x9e3bcf83, 0xb8935edf, 
	0xcf1cc19f, 0xde388b33, 0x8313eb87, 0xe62a4f02, 0x2de20e38, 0x7df0cb84, 
	0xe608a17a, 0xe2bf10bd, 0x8888c77e, 0xe2ab6fc3, 0x79b42df2, 0x16c89e28, 
	0xe4ad6f17, 0xe62bc67c, 0xc7088ec9, 0x78b8f4c1, 0xda04fbac, 0xda16ebff, 
	0x2cca7027, 0xe45fb137, 0x6e5d1ac3, 0xeed26b87, 0x8c792ea3, 0x2e9bcce2, 
	0x31e5e3cb, 0x37f917ef, 0xdebeafe2, 0xf22fdf1e, 0xb287d23b, 0xe89b66ff, 
	0xf7fa0988, 0x3f6fe9c4, 0x75c4e157, 0x953d8bb4, 0x77a0ad3d, 0xb1bcaf4b, 
	0xafda1107, 0x02f6e34f, 0x988bfe79, 0x08e31bdf, 0xf5fc71f0, 0x6b1c7d34, 
	0xfbfd71a6, 0x6f2926b0, 0x4e5af92e, 0xf88c38e2, 0x4e51f03d, 0x780678d2, 
	0xf9b4bcde, 0xdbd7a67f, 0x7e28c792, 0xd261f837, 0xf46ad7db, 0x9270fdf8, 
	0xe1ae1ede, 0x536a5ff2, 0x9c7336fb, 0x108de3ec, 0xfb102da7, 0x3bbf097e, 
	0x2ad8eb8e, 0x557f0dc5, 0xab4fafa9, 0x5d18c15d, 0x7a417f09, 0x2c3d000e, 
	0x75a766c7, 0x3b6e9ca6, 0x7affb3e1, 0xbd7884bd, 0xb614d0f7, 0x330411fe, 
	0x957bed18, 0x13abdf71, 0x6ed572f1, 0xb8d2ed17, 0xc26ea9d7, 0xb4aab75b, 
	0x75c0e54e, 0x671455e9, 0xe58eb86a, 0xb7ebe4ab, 0xeddc6c7f, 0xe1f1c6b1, 
	0xc7b44e6e, 0x6e848200, 0x66087adb, 0x0c29678a, 0x4c825ff5, 0xc0b1fe46, 
	0xb281dee1, 0xaf31458b, 0x9ce3c2b0, 0x460e383b, 0xfb869cb8, 0x124b56b8, 
	0x26a763b7, 0xee12a5f6, 0xda357024, 0x52fb8027, 0x1eb61295, 0x8b2e4774, 
	0xfed1073a, 0xd3d2ab16, 0xaa75f8f8, 0xa8fd8834, 0x034fed0a, 0xee9f39be, 
	0xf7146ba0, 0xf5cc8efb, 0x020d7df3, 0x156a9367, 0x8401eb86, 0x8f89eca3, 
	0x54a73e57, 0xfba6ae22, 0xafc0a99d, 0xce0467bc, 0xd7b67c02, 0x8f10d2ac, 
	0x314a9106, 0x2e38e21b, 0xc75ce38e, 0x87969df1, 0x8f684ace, 0x10b662f2, 
	0xbb96cd03, 0xa7f51059, 0xc3f9a1e5, 0x145c3612, 0x2124fcbd, 0xc68baaac, 
	0x8f51f587, 0x5e54435d, 0xdc39e5f3, 0x9efd560e, 0xdb5e9fca, 0x14c7d7ce, 
	0xb68ee13f, 0xee044aeb, 0x20a33aa8, 0x73ae087f, 0xbf11b0df, 0xa6eedf72, 
	0x538ef3df, 0xf8479a39, 0x8698b9fb, 0x54d17538, 0xee43878e, 0xb8c20d12, 
	0xbf706ff3, 0x477bf7ca, 0xce5fa89d, 0xa49f5886, 0x8d0e3f42, 0xf64eff69, 
	0xc12c42c1, 0x9ebe5f7e, 0x7b93f4ec, 0x57ed93f2, 0x8fbf4639, 0x71f016f6, 
	0xf7edd6ec, 0xf36969d6, 0x690797ef, 0x31dbd1de, 0x867befdb, 0x9699aefd, 
	0x7979de71, 0x1e913eb0, 0x27d754a6, 0x17e961d1, 0xc249a83f, 0xcf27764d, 
	0xf718f23b, 0x6457d6b9, 0xe5938fd9, 0x28af8c7d, 0x7967ea59, 0x165be24f, 
	0x8e0a2bf5, 0x83c37138, 0x44ea20af, 0xbae1f63b, 0xb4ddf238, 0xfc1dbe2e, 
	0xff3c2d75, 0xe22632d3, 0xf585c54d, 0x1ae60294, 0x9571be4b, 0xbc6e392f, 
	0xf03cb30b, 0x758d5397, 0x7244a8c7, 0xbf5c7cd0, 0x8eeb4d6a, 0x4dee3f7e, 
	0x7988cf64, 0xf519f505, 0x63d6acb5, 0xeb891cf7, 0x7d5f798d, 0xbd5f79b9, 
	0xf0caabc8, 0xebd027bd, 0x5eafb172, 0x8ef46f5f, 0x9eb44306, 0xf65f5a62, 
	0xe0f70e8d, 0xb751537a, 0xafde1d6f, 0x37ad1a64, 0x092ea7ca, 0x47797da2, 
	0x807c9e17, 0x5be889e6, 0x258d369b, 0xe39563ef, 0x9bd457c2, 0xf595f192, 
	0xdc10ff70, 0xa327cf0f, 0x1457c2b0, 0xcfc17bcc, 0xc4af882b, 0xe8af80c6, 
	0x2be20ef1, 0x8fdbab88, 0xde2be124, 0xc710a1d1, 0xc30f9457, 0x4af889c3, 
	0xbe3254ec, 0x0b20fb12, 0x8e89f2be, 0xf090fcaf, 0x32494095, 0x0b9ea2be, 
	0xaf88925f, 0x7c08ce04, 0xec3f6be5, 0x38af79a5, 0x95f08cb2, 0xe1367bfc, 
	0xf8159d95, 0x858d8cca, 0xef69af18, 0x11e5c7dc, 0xc44c2dee, 0x2e571457, 
	0x3a651bf8, 0xfd0d03cf, 0xe0af82cd, 0x837989f3, 0xbe0b2f51, 0x0b2f5962, 
	0x2f5962be, 0xa692be0b, 0xd9fde11e, 0xbd7315f0, 0x882be331, 0xce0404a7, 
	0x1dd612c2, 0x0e2ae0b3, 0x8d698f1d, 0x63447d88, 0xf83657c3, 0x5fac5c78, 
	0x5a638bc7, 0x1ed82be1, 0x7629edc6, 0xe32be065, 0xa76777f3, 0xc88be725, 
	0x337eb4df, 0xa962be0b, 0x95f05907, 0xfec9e9f6, 0xbfffef56, 0x9c54f5e3, 
	0xb27a148e, 0x2dcb1ae0, 0xae8085da, 0x3e782df2, 0x6762267c, 0xf3b23f3c, 
	0x7f793af9, 0x71e76294, 0x38815799, 0x61ef45c2, 0xe7197ed1, 0xac9efe19, 
	0xbe216157, 0x31daa89e, 0x9d335b0e, 0x7de621c7, 0x17dc6e53, 0xee31f885, 
	0xe7c26a93, 0xd3ee3b35, 0xefff0b72, 0xf77f052b, 0xfa38d83e, 0x8445947f, 
	0xfd1e07cf, 0x7cd32a3d, 0x5eea3450, 0x71bb7487, 0x79c2185e, 0x8b0fdc47, 
	0x2bcd21fd, 0x66fbc982, 0x4df65982, 0xcdfc6805, 0x489ed179, 0x23d0f88c, 
	0x7f7a4df2, 0x09f623ca, 0x16cf42f9, 0x5f626df8, 0xa55fc614, 0xb8e597c0, 
	0xd2576a1f, 0xee1f287e, 0xbea48a9f, 0xa8fb455f, 0xe14977e0, 0xbef96bfa, 
	0xbd3f26d5, 0x5e50c56f, 0x1ee5c477, 0xfc2cc7c7, 0xec7c1662, 0x487d0b06, 
	0xb82cabd1, 0x768b0ed6, 0xeafa4d8a, 0x64279534, 0x382ce7d3, 0xcf5fb598, 
	0xb2ed838c, 0x26a7f7a0, 0xbb0cfafe, 0x59838cca, 0x070591d2, 0x990ff6b3, 
	0x7acb3071, 0x67b07059, 0x1bfdc62c, 0x617e1c93, 0xf3341f2a, 0x107e9c65, 
	0xa9d745e3, 0xeccce374, 0x96991f07, 0x693cee3e, 0x5f7ae7a2, 0xfbb7bd32, 
	0x4c07ef92, 0xdd366ff7, 0xf611db37, 0x763939e3, 0x5f1cb23b, 0x627c7f16, 
	0xa33cf27a, 0x36a0af8f, 0xd8b3bf0b, 0x9e9b5ca3, 0x2fb5e36f, 0xb16571cb, 
	0xfd16c9af, 0x6b8f374f, 0x4965f68c, 0xb2fb1647, 0xf6ccbbd6, 0x8b2f5965, 
	0xe9b5297d, 0x36b4b9e5, 0x4ddaff59, 0xee9bf07c, 0xf3bf758f, 0x7ef96b97, 
	0x8fd11ae7, 0x3ebfbc43, 0xe372b267, 0x8e208bbd, 0xaea3556a, 0xb557100d, 
	0xc79fbfb8, 0xdedcebe3, 0xf23fb162, 0x47175c38, 0xce4ad05f, 0x5e76bf7f, 
	0x6a47d8bd, 0x3a8ed7ec, 0x71e3078e, 0x60fe455d, 0x4adbe708, 0xf1087f6f, 
	0x07d23720, 0xf31ba4f3, 0x8fda0199, 0xaf7da21e, 0x83d5bc37, 0x0ab6ddb5, 
	0xb67cb7c2, 0xe0113dfd, 0x90143baf, 0xc7894c66, 0x02eb538f, 0x67724621, 
	0xf949bd1d, 0xe9e6bb0b, 0x25fcc4e1, 0xe1c1e5fa, 0x6ca5fca4, 0x5fca12f7, 
	0xfca5e82e, 0xe5e81a25, 0x07eb8bf9, 0x517f301b, 0xbf318797, 0xf4e6a8d9, 
	0x12de60e5, 0x526f6afd, 0x8bfb12fe, 0x3cbf9e5e, 0x3f3e14f4, 0xf3c25d57, 
	0xbdd55897, 0x12fe538f, 0xd555fbe5, 0x8a629edc, 0xfbe99793, 0xb1de2951, 
	0x7af99b45, 0xdf657ab1, 0x233e7896, 0xb8490c37, 0x2d5cf5ae, 0x7ac7b79f, 
	0x9f3e01fe, 0xccd9fdfe, 0xd65925ef, 0x47f469db, 0xaf6f8cf9, 0xc6795fd1, 
	0xf51bf6fe, 0xbdf19f28, 0x9a9bd469, 0x85c71ebe, 0x3a0cc77c, 0x7df19f29, 
	0x4be9d062, 0xf7b66747, 0x41ce476c, 0xfae0a33e, 0xb131e400, 0x8cb17af8, 
	0xae3b8df9, 0x6bcc3e3f, 0x6bcc7fb0, 0x8d79a922, 0x1ac5eb8c, 0xf59f33e6, 
	0xe61bf118, 0x82df1833, 0x4be7e95d, 0x38857818, 0x0cc363af, 0xcfc5638e, 
	0xdbad609b, 0x84aafe48, 0xfd8a55ed, 0xc0ef40c9, 0xf3eb22fa, 0x95fb7427, 
	0xf9d10f9b, 0x7f3c1e13, 0xe34ae302, 0x3adb09fc, 0x7fde2cad, 0xa637d891, 
	0xe0a13f9f, 0x8c3113f9, 0xfce82bd3, 0xf3cb5a89, 0x8e5cb427, 0x27f3f243, 
	0x1cf16f50, 0xb64aa29a, 0x7d77e30e, 0xde7eb43f, 0x4d887384, 0x67c21c44, 
	0x7c257eeb, 0x7a8baf0c, 0x9f239723, 0xef68f40e, 0xe7efdc30, 0x80fda5ec, 
	0xed86923d, 0x694bb4bb, 0x741c257d, 0xe7111ff6, 0xef1cbc43, 0xc24f3f5f, 
	0x9d04fe7c, 0x5bef811b, 0xdf90882c, 0xdc24f3a0, 0x139f79a9, 0x3cc095cf, 
	0xe7482bb4, 0x9b9ca44a, 0x57675a61, 0x853f7067, 0x03b87e71, 0x415aa3df, 
	0x4d2bce72, 0xb8e8a7ae, 0x09fce9a5, 0x413f9e1f, 0xfb5d47bf, 0x4b2f5f88, 
	0xbca15efb, 0x3b07e9c7, 0xbfb426f8, 0xbe7bf082, 0x97cf527f, 0x01dc70ca, 
	0xfce747aa, 0x1439e394, 0xef863e3a, 0xde4f1c01, 0xc7df1fe7, 0x5e2e12af, 
	0x75a51038, 0xa5453286, 0x55ca2873, 0x2fd3ed0f, 0xe7f3c19d, 0xdf4fb172, 
	0x7f04afc8, 0xa61f379a, 0xdf62e57a, 0x1af313be, 0xf30ab768, 0xaf28c7a9, 
	0x26bc8a09, 0x394d7988, 0xae504de6, 0x81f7fb12, 0xdcfc7dff, 0x837e7e13, 
	0xef4a34b3, 0xe16cf883, 0xef4c3690, 0x016d3835, 0x10a3cfc6, 0x7ee22279, 
	0xc61439fa, 0x1e784ab8, 0xe22fbfae, 0xcf928b54, 0xa0b81099, 0x58a1cf17, 
	0xe3077a89, 0x8f184ded, 0x14bb9f90, 0xf1cdc0fc, 0x0e7ccdfc, 0x67a6d345, 
	0xbf70dbf3, 0xe4a5f03d, 0x3c7ce234, 0x8f3ca41f, 0xfb43d7d3, 0x39f94772, 
	0x11cdbe1b, 0x8bca3f7a, 0xc7144fe7, 0x2d5dbaaf, 0x52f6e3ab, 0x139fa75b, 
	0xa1ce99a5, 0x20794438, 0x21d50f9d, 0xf52279e4, 0x17ca0dbd, 0x5f79a4a7, 
	0xe742a4e5, 0x9bd1b944, 0x4f7d49ad, 0x9c49a465, 0xf9cb5517, 0xae04f387, 
	0x5cf58e2b, 0x936afb9d, 0xa7f462f1, 0xdb9b3784, 0x977ef2c9, 0xb2cfdfa5, 
	0x19daed6f, 0x4eaffbe9, 0x99ed8bc5, 0x8b6fe2f0, 0xd8bc7476, 0x11dffa8d, 
	0x178e9397, 0xc5e0b3b8, 0xb1786cee, 0x38bc5e36, 0x9f3b70b8, 0x5b0da5cf, 
	0xf17804fe, 0x7de3f718, 0x67b178de, 0xe2f02034, 0xf1c925d8, 0xc965d0d6, 
	0x25d0d6f1, 0xe2f11983, 0x8bbd15d8, 0xe0fade29, 0x7874bcc9, 0x7272fb31, 
	0x295ca5bc, 0xf453ade2, 0xac5e0a7c, 0x7ff8213d, 0xf118a87d, 0x7abe2362, 
	0x7c425376, 0xef73e7a5, 0x73e530cd, 0x7c62f059, 0x93de7d3e, 0xacb62f19, 
	0xb62f0597, 0x2f0597ac, 0x4c6f534e, 0xdeb9b178, 0xfc5e2b9f, 0x5f1e5af3, 
	0x0bcfd7e9, 0x32f6c62f, 0x1f1bc7ef, 0x33cffc5e, 0xe45df392, 0x3b7cda6f, 
	0xa9624e0b, 0x12705907, 0xef392eb9, 0x862ffbd4, 0x08e233df, 0x0989f059, 
	0x95c7e975, 0x76ab178a, 0x178e2f3e, 0xfc43562f, 0xc7662e9c, 0xf60168f8, 
	0x2f1526b7, 0xf7f10cf6, 0xb178cd68, 0x3a3fc447, 0xf116ec5e, 0xde22278d, 
	0x6fbf3457, 0x3d8bc269, 0x1e802f38, 0xef4d848d, 0x2f1b8e27, 0xb67bc456, 
	0xfd62f1e9, 0x0bcfdb3d, 0x728a5e2f, 0x8b1784c8, 0xc25f67f7, 0x057012e7, 
	0xe295ce33, 0x5ce0b317, 0x8c3e858a, 0xd1ba9f17, 0x9adf9da2, 0x466d7de8, 
	0x61befeb2, 0x3c5e3fba, 0x67afdacb, 0xb56eb3c6, 0x675837a0, 0x788c67a2, 
	0x591d2596, 0xff6b2cf0, 0xb2cf1990, 0xcf0597ac, 0xb8c5b6fa, 0x1ee34c87, 
	0x9b379534, 0x42cdcefc, 0xb9fc7a8e, 0xacb936bd, 0x1e25a5eb, 0x2e9ce592, 
	0xcb3538cb, 0x8cc08cbe, 0xf42bf7e4, 0x2687f538, 0xe6e252fa, 0xfd15e72c, 
	0xf18c6eb8, 0x8b739677, 0xcc9e71ac, 0xb01da4e7, 0x4257ffe8, 0xc6b8c64e, 
	0x259d1e78, 0xa1ce591d, 0x321fceb1, 0x59637f9f, 0x9d3ecb2f, 0xfee31643, 
	0x8fee34c4, 0x7be592ea, 0x91ff74dc, 0x6ef2e4da, 0x5379f953, 0x8557dc7d, 
	0xdb66edef, 0xcf5f9387, 0x56dce1f7, 0x8fe8edcb, 0xb9864e75, 0xf91c04df, 
	0x938f1d40, 0x7cf3ac8f, 0xcff0387e, 0x3b79f267, 0x0a9fcf4e, 0xed9e5607, 
	0x9798985d, 0xce483f28, 0x654f624b, 0xfb6381c6, 0xe1b25e44, 0x70e9f9fb, 
	0x7a4fd8e0, 0x6213de93, 0x44bc88cf, 0x7053e7a1, 0xef93b560, 0xf73d5163, 
	0x03874a4e, 0x4f22a3b3, 0x527bbeb9, 0x77fc0e2a, 0x1e3e7cf5, 0xcf8c0e2b, 
	0xf3a54ebb, 0x6071990f, 0x70597acb, 0x597acb60, 0x7ad4e070, 0xcd81c363, 
	0x71dcfef5, 0x381acbe0, 0xee70946e, 0x1c0b31f0, 0xf8afa878, 0x1f03814f, 
	0x3bfe2309, 0x560712dd, 0xcb30384d, 0xd91b7dc5, 0x0245e071, 0x46f5b607, 
	0x81c2660e, 0x1c2b3fd5, 0xbcf86a58, 0x372d6070, 0xd4dc0e1d, 0xb81c3630, 
	0x41439c4a, 0xde057078, 0x0f317ad7, 0x13307032, 0x635bfc2e, 0x60e38d9d, 
	0x071cfcd3, 0xf4187c23, 0xc1c09a6c, 0x69e070ac, 0x71d31f02, 0xafb172e0, 
	0x4f038cc6, 0x3a64e133, 0xcd1dec0e, 0x3e13038c, 0x3be314eb, 0x4ba6f222, 
	0xc14c7013, 0xc0e2b1ff, 0xc5ca1b32, 0x60f086f9, 0x4fe45fa4, 0xa8d85c66, 
	0xe53e6f3f, 0x7c0e3a3b, 0xc1f3fea0, 0xb9335d81, 0xd0689cbd, 0x13fe23cf, 
	0xa6b5c0e3, 0x138c06ef, 0x7d52fe07, 0xfe8b7c72, 0xf18ee314, 0x7e96c0e2, 
	0x5c0e0b3f, 0x7fbe90d2, 0x38e3ff5d, 0xaf4957f0, 0x8be070ad, 0x981c741a, 
	0x72e2fed1, 0x61bef27f, 0x5f441d7d, 0x9f3328ef, 0x41ec2453, 0x3328e75f, 
	0xe064539d, 0xc5ddbac0, 0xe3b2dcb8, 0x0b1fc3c0, 0xdb57321c, 0x0e02fff6, 
	0xe32476cc, 0x99efd1c0, 0xc81fddd6, 0xc7b3038c, 0xdb75bc45, 0x70e9f913, 
	0x64a9e560, 0x07fd581c, 0x5d51be7a, 0xe0a7cf43, 0x441bd1c0, 0x61b1d5bc, 
	0x46c0e212, 0x2ebc357c, 0xf1d2be21, 0xc61bc78e, 0xf3e30387, 0x5b0383e7, 
	0x0382cbd6, 0x82cbd65b, 0x37a9a703, 0x5cd81c26, 0x0715cfef, 0xf1e7abee, 
	0xbcfd7e95, 0xef6c6070, 0xb581c4f3, 0x04bc6486, 0x383e7bf9, 0x641ea5b0, 
	0x6a5f81c1, 0xf581c648, 0xebc4dffe, 0xfc0e01ff, 0xfeed162f, 0xffe070b1, 
	0x6fbf486c, 0xc0e3fff8, 0x13b038c9, 0x1c0630e5, 0xcb9f07b8, 0xf8a70380, 
	0xf0382cc5, 0x187d0b11, 0x355c0e2f, 0x3b3b7d33, 0x346ef44c, 0xca9ab795, 
	0xad81c5e3, 0x1c667afd, 0xde82c1b8, 0x79d93345, 0xa4b46bed, 0x6c0e0b23, 
	0xe3321fed, 0xb2f596c0, 0x5917c0e0, 0x6663bb8c, 0x306e1cb2, 0x536ae1f1, 
	0x4dc856b9, 0xa2ff3f8f, 0xc66cb93e, 0x90f05381, 0x65b0382c, 0x07059a9c, 
	0x5388b0ae, 0x8df44d3b, 0x73be0717, 0xefe318e6, 0x35b0382c, 0x071993ce, 
	0xc64ccf0e, 0x07fef543, 0xc2f3b266, 0xc8e92d81, 0xe75b0382, 0x6071990f, 
	0x70597acb, 0xbe0b7ee0, 0xa3e844ff, 0x263dee3e, 0xe983fc3e, 0xf9268dfe, 
	0x7c9f52df, 0xe7a63bff, 0x1f038ac7, 0xedf7c99c, 0x657414ce, 0xfe644f98, 
	0x77f24a1e, 0x5e5ce880, 0xff48be78, 0xb3df4fee, 0x3f106d05, 0xf07ff7d1, 
	0x5e7170dd, 0xe7e1cb2f, 0xb779eac1, 0x1bff1d83, 0x7e6122a9, 0x95f9e568, 
	0x38f1fce5, 0x27c4ef7f, 0x9fa66fe6, 0x26ef2b2f, 0xf7898b7c, 0xf117f7cd, 
	0x29a1de79, 0x8fd075f6, 0xfaf30fc7, 0xf19f78d3, 0xdfb16873, 0x189fe823, 
	0xc0b2f3cd, 0xdc08ce53, 0x137798d8, 0xf9a655ce, 0xa427bc52, 0x7efadae3, 
	0x4fff631f, 0x4bfbe9ad, 0x00ced111, 0xf3f5bf9f, 0xf867dd7c, 0x3ec6be79, 
	0xcb4fd11f, 0x6edfab83, 0x61e78c59, 0xb5b4bc56, 0x1e9fca07, 0xf1cf57d9, 
	0xfdda15b9, 0x85c2fbf8, 0xefe3376b, 0xbe9ef415, 0xa9d1efde, 0x2bc50e3c, 
	0x4feff9e2, 0x3e1ce265, 0xeff28dd6, 0x11a0bb28, 0x116833cf, 0xf63084e7, 
	0xa7df1072, 0xfdc8d39f, 0xecf37399, 0xa29f3147, 0x7c258cef, 0xbdf08c4f, 
	0x8227c080, 0x04f71f18, 0xdfa1dfbb, 0xa52b620f, 0x66bbfc8d, 0xbd71970f, 
	0xd7efbe6c, 0xe687287d, 0xdce987cd, 0x563cd6f6, 0x03e3fa89, 0xa3ce20b1, 
	0x1e253fcb, 0xc475f941, 0x8df677cf, 0x859ff38a, 0x8971cc9c, 0x8fdfbe2f, 
	0xfaea25f6, 0x2135bfb1, 0x5e20091e, 0xe2325903, 0x44f7c87f, 0x57acc41c, 
	0x9df3899f, 0xf520876d, 0x1c0db607, 0x1f9086f6, 0xf8e21636, 0xfc8c3aa8, 
	0xcd398b47, 0xfce819d7, 0x4acbdc8d, 0x96dd7ce8, 0x90f76687, 0x2cf3c2df, 
	0xc8a8f9c4, 0x4d1a0fe7, 0xf985d2e7, 0x1b471579, 0x4e2af3f5, 0x2af3f237, 
	0xf3f23616, 0xa6351652, 0xd57d6f7d, 0xc2773a06, 0xe98b6ef8, 0x0a9ef5bd, 
	0xcbf5bdfd, 0x1b9e331a, 0x7fdfde77, 0xfd31b6b9, 0x6bae5ff7, 0x5deae7e4, 
	0xef1b744f, 0xcf2f47eb, 0x45eefc49, 0xd3c39cfc, 0xbfdf4939, 0xe5e7e888, 
	0x3da63475, 0x77cb236f, 0xfd14da38, 0x67af989c, 0x7f79f71e, 0x1b6fe387, 
	0xa3877f33, 0xabdc792b, 0xc89390be, 0x8ce7ecdf, 0x9dc7e968, 0xc6d5de45, 
	0x331b7bb8, 0xde70539e, 0x98dadef2, 0xdb983bfe, 0x9185bc68, 0x5bdaf548, 
	0xe200fbf0, 0x552e78fb, 0x3cf1841a, 0x1f9fa8da, 0xeb1a736d, 0xf1e7e87c, 
	0x8bc84abb, 0x3a1cee9c, 0xfe0ee46f, 0x7542a57d, 0xef23b50b, 0xda5e6850, 
	0x4febf50e, 0xca907f62, 0x8a7406dd, 0xbad96273, 0xb6af9f28, 0x12dce946, 
	0x7f4a73ab, 0x5a17be20, 0xcd5f8d39, 0xefe294e7, 0xa66aafe8, 0x9f91fee9, 
	0x2efe6a53, 0x7395bfd6, 0xfd1bf8bf, 0xd6598e3b, 0x1d79f485, 0x624596e2, 
	0x9c33a53d, 0x9662ae78, 0xd973ac75, 0x6592cfbe, 0x3ca72b3d, 0x560c79fd, 
	0x2355fa72, 0xe13b473f, 0x749ceddc, 0xd392b2f2, 0xb4e498bf, 0x9cbd22ba, 
	0x85c631e4, 0xd3d22bf3, 0xeb95d86f, 0x6a3e7e72, 0xb9d302f5, 0xbb24bfb7, 
	0x0b9df9da, 0xd21f3eb8, 0xf4c3eaed, 0x47d5d47e, 0x93b7a576, 0x751a4fe2, 
	0xb33a7a3f, 0xeafab95d, 0x9161e913, 0x3a24fae2, 0x6d4aed2c, 0xb37f3c4c, 
	0xb1d5d854, 0x3ce96bca, 0xb413a3f2, 0xde6fce10, 0xfd7b4fd0, 0xb7781f10, 
	0x678eabf1, 0x3f56aead, 0xae123c45, 0x5d9a006c, 0x827da45d, 0x22eae478, 
	0xe70fbbf5, 0x6340b5c3, 0xdae0cbbd, 0xdef5b43a, 0x2a06bc5e, 0xdd5cef11, 
	0x07d2d816, 0xfbea3ff2, 0x9171c42c, 0x14bc14a8, 0xbfead7e4, 0xb2a21b57, 
	0x3abbcf1d, 0x8b5f6bea, 0xa74724eb, 0xf98b5bce, 0x7ede7191, 0xc20f669b, 
	0x8f305fbc, 0x5ed239d1, 0xf81d9df1, 0xd7bc225d, 0x7bfa9515, 0x9fef6ae9, 
	0xdce7af12, 0x72667431, 0x046f5f17, 0x03bf1bb1, 0x47e86d3f, 0x9dac88ef, 
	0x6b7dfd8f, 0xa47ac5e0, 0x993dd72b, 0xb1eb87ad, 0x2166d3b9, 0x9840d89f, 
	0x7cbccaf8, 0x3977237d, 0x824a61c8, 0x23ee9b3c, 0x14663a79, 0x223bfdd3, 
	0xaeb8b539, 0xc74ded08, 0x671bd2f3, 0x71b27ee9, 0x43c79d96, 0xde9f51d3, 
	0x30f82c99, 0x70bbf393, 0xe476d751, 0xafba3783, 0xf387bfc9, 0xfef39f07, 
	0x76e26b25, 0x36a9d1ae, 0xba77112e, 0xefa71c96, 0xec9f78bd, 0x6f58626a, 
	0xca13576f, 0xefec72e9, 0xc4c79e34, 0x1fd929db, 0x8171885b, 0x8a8a67eb, 
	0xa97ae376, 0xebe7cb49, 0x5ba43675, 0x6989f5d5, 0x2c87ae2e, 0xda90f517, 
	0xc93cfb41, 0xeefaadcf, 0x57ae52aa, 0xbca90fd1, 0xaf296178, 0x0efa09d7, 
	0x9f7f35e3, 0x8fd939cb, 0x0fb11647, 0x604b4366, 0xd98b2307, 0x9a6f6e76, 
	0xe3117a9d, 0x24f7b49b, 0x2fac67d1, 0x28498e2d, 0x188c9777, 0xb8fe331a, 
	0x337a699e, 0x071bac5f, 0x8baf7da0, 0xe0977ad9, 0x5b686a73, 0x6ce7f050, 
	0x570278c2, 0x5d579d13, 0xadd380bc, 0xb6ca92fe, 0xbc6362e1, 0x3ae37449, 
	0x4d1d5e2f, 0x4179e02f, 0xf612cd97, 0x2eefe45d, 0xc559c542, 0x43f4e9c7, 
	0x9a4af7c8, 0xf1b722fe, 0xd849fefe, 0x9504ec63, 0xaed97fa3, 0x72729fcf, 
	0x90eb9a7f, 0xc11fa12d, 0xa83e4837, 0x955b9b1f, 0x37023f78, 0x503f7954, 
	0x93bfc6c5, 0x5d713aad, 0x3a59a21a, 0x1436caef, 0x3677e3b5, 0x167f2fd8, 
	0x65b75c4c, 0xf40bed72, 0x8ae60bde, 0x03e53f60, 0x5bce25ee, 0x435c4708, 
	0xf3caa871, 0x50e39182, 0x4d3886be, 0x516c46f5, 0x5f29073a, 0x9a1bdb79, 
	0xfa85e424, 0xa5f27181, 0xf7437768, 0xdb970a68, 0xca8e78e3, 0x8278a802, 
	0xf3439bbe, 0x768763a1, 0xe5e82f4f, 0x1e7c59a6, 0xb85be5d3, 0x6c15ec06, 
	0xfc5981e9, 0xb954eebc, 0xf4fe4add, 0x117eebd4, 0xf2a41d27, 0x08b697e5, 
	0x39f206bf, 0x2147c092, 0xe58f9d1f, 0xbf197eed, 0xc5d10703, 0x2d7043a2, 
	0x34f3d029, 0xf226aeb1, 0xf1c2a728, 0x59546771, 0xcd0029bf, 0xdf6255be, 
	0xa399f904, 0xf62ce765, 0x3f3ff407, 0x7b9da109, 0xb5e5f75b, 0xda468b01, 
	0x7f5cdda2, 0xc0eecd99, 0xec8bfffb, 0xc55c3737, 0xc2fd43d6, 0xbf1870b6, 
	0xae1b9593, 0x631f5eef, 0xc7da0f2c, 0xc2f2c1f3, 0x189ef6f5, 0xe1217efe, 
	0x8bda9dad, 0x2f2f5825, 0x27beb55c, 0xc3fbe380, 0xd97f1c14, 0x5e3fee72, 
	0x09aabe6a, 0xef6dcffb, 0x87ad712a, 0x12b056e7, 0xdfbafff4, 0x5bad2b84, 
	0xe8137ee9, 0x73f6ea08, 0x749f827f, 0x8a1c9fa2, 0xd47b479f, 0x6b92cff7, 
	0x139eff0a, 0x1013fdc6, 0xf38cee2b, 0xc783f743, 0x0b34bee6, 0x1fdd2ee3, 
	0x743f843a, 0x43df8134, 0xd70f6f7e, 0xfe19dea3, 0xf90f456f, 0x861883bf, 
	0xbffaa6e4, 0xf3e967d7, 0x30b3ebd9, 0x1ffdd63e, 0xf815199b, 0xf346d476, 
	0xf27ee5c0, 0xe14b855f, 0xffd5255f, 0x5ad886e7, 0x0dcf675c, 0x5a84bf81, 
	0x79f4dbde, 0xfadde383, 0x8b682ff8, 0x9be279f2, 0x6585fc7c, 0x700bce9c, 
	0x18fdc09e, 0xcf8da8ae, 0x3fbd9a13, 0x2dfcfda1, 0xe40e5243, 0xf16727b5, 
	0x2f452cf8, 0xf64abebb, 0x88b1343c, 0x2ceba1eb, 0x73e765e9, 0x8f7d8553, 
	0xc75c9fd3, 0xc020bced, 0xa85dc9fd, 0xef871077, 0xa64ee7c4, 0xccd9cb93, 
	0xc9341972, 0x2433f965, 0x05eea297, 0xfc25e769, 0x979f1c26, 0x979c26a4, 
	0xf56c37fe, 0x00008a1f, 0x00039601, 0x7dcd9c78, 0xd5547c0b, 0x999ef7b5, 
	0x1e673333, 0x480f2649, 0x48192120, 0x74120642, 0x204c8108, 0xc4228398, 
	0x7d6e6b6a, 0x0ebda540, 0x215f1628, 0xb540d450, 0x3084999e, 0xac41c051, 
	0x6c5b4024, 0x6d4795bd, 0x6a16adb1, 0xb120f5ef, 0xf7ed7bc6, 0xe954bd4b, 
	0xc4a1b6d5, 0x958ed4db, 0xa235a3f6, 0x6b5adf2d, 0x248f33af, 0xbdb6f6d8, 
	0xe9fbf35f, 0xd9d7ed66, 0xffb5ed7b, 0xd7bded6b, 0x515423de, 0x710af7a5, 
	0x88ddf4ba, 0x6210a565, 0xf7a9d196, 0x38bf910b, 0x42fdd414, 0x27bf879c, 
	0xed4217ee, 0x187a2234, 0xd753bd43, 0x0babc885, 0x774f4b6d, 0x644a1a34, 
	0x7ace1095, 0xa0fb2aa1, 0x8e8857bc, 0x87be43cf, 0x927516e3, 0x21412510, 
	0xbf506d5c, 0x3de2add0, 0xfe033421, 0x65b202e5, 0x146c4d89, 0x52ff63e2, 
	0xa06ef42c, 0xe88bffdb, 0x246be7e9, 0x8755742d, 0x8593a976, 0x41f6c0ea, 
	0x470b4835, 0x4bcb79f0, 0x31795c42, 0xfc2cfbfc, 0x168a1057, 0x5844bb40, 
	0xa0a7ea8f, 0x1761211d, 0x399bfe90, 0x9cac5f8f, 0xcc71e211, 0xb2e9e107, 
	0xfa029df3, 0xc888ff9b, 0xb61e7f68, 0xbb54e1ff, 0xf12c3085, 0xb9ff9895, 
	0xe425ef88, 0xb92277cf, 0xf9763b40, 0x214182d5, 0x547f41e6, 0x18338fe8, 
	0xdc835d12, 0xf4e3d9be, 0xfa91b82f, 0xe797caf3, 0x2ff0fa4a, 0xdb7e986d, 
	0x7fb8847f, 0xfb31fd99, 0xd1cbf661, 0x51abb214, 0x244f77f8, 0xb504e38a, 
	0xfaff305a, 0xb8834778, 0xf4cf8842, 0xd016af1c, 0x50af875f, 0x34384174, 
	0xb2a092ef, 0xaac7f301, 0x4f22bbf1, 0x411c77d0, 0x38c05aad, 0xff40a93c, 
	0xfc7c4026, 0xda0f9550, 0xf3cbe271, 0xe3eb5da8, 0x256f80b6, 0x83e557d5, 
	0xff60977a, 0x4bb56f90, 0xc87aca82, 0x662272cf, 0x2117f8c1, 0x014142bf, 
	0xd25bcbfc, 0x71f2214e, 0xe9d1f017, 0x0fd63a10, 0x41f4eafc, 0xf74bbcfe, 
	0x87edf6ed, 0x3030a778, 0x4361c69e, 0xf76c7a7a, 0x757f480e, 0x6283c7ce, 
	0x144bb61d, 0x44447f23, 0x62b47f30, 0x50b087ea, 0xf55f133b, 0x85ebf5f8, 
	0x8162a2b8, 0x84273df0, 0x7f17a9d5, 0x3ef101cf, 0x2af9d22d, 0x3ff21194, 
	0xb4174f6c, 0x2e327127, 0x2e50d7f4, 0x8d4f5e20, 0x7e404277, 0xf98ac7a8, 
	0x57b0853b, 0xfe451d17, 0xd7f8e998, 0x6abc9e31, 0x4e78d1b7, 0xb497cfee, 
	0xdfd12af1, 0x67db2c3b, 0x5e52678e, 0xb4e8feed, 0x6eb4f1b4, 0x67c5acf9, 
	0xa4077f81, 0x758bae9c, 0xd0a728a8, 0x7be8217b, 0x4238739a, 0x7ac0e7f2, 
	0x6394bf14, 0xbdbb7d7b, 0x9739ca08, 0x10fdd88e, 0x1ddaaaba, 0x3f8c118d, 
	0x18ac54e2, 0xa055521f, 0x0beeeafb, 0xd71df02a, 0x0752b0b2, 0x8f1fdcf9, 
	0x03bca177, 0xa76c155f, 0x21fb8c71, 0x6cf88534, 0x9f0855f2, 0x37ecaafe, 
	0x2a7209f2, 0x625f50fd, 0x6fd08f7a, 0x94ebfc94, 0xb73fb6c9, 0xe305aa7d, 
	0xc821ac47, 0x77e65ced, 0xebb31762, 0x5dc50476, 0x47c5aed0, 0x8ef83e1c, 
	0xa4b359ab, 0x7f3c4fb7, 0xd0a9f681, 0x9cffebbe, 0x30ca19f6, 0x1031377c, 
	0xffc442fc, 0xf913b5e7, 0xd90faf67, 0xabce9f90, 0xa81ad447, 0x5fb991ff, 
	0x76bced95, 0x3e400950, 0xda33d355, 0x40bf1fa9, 0x667f7d3b, 0xc1427d3b, 
	0x0f45e976, 0xebb43a28, 0x0edf39bd, 0x3b41df8a, 0x566dd53b, 0x82b3776a, 
	0x45450df3, 0xd3e34f5f, 0x9bef5e9e, 0xe68da701, 0x28e462bd, 0x8a9be750, 
	0x8835f7d1, 0xfc489477, 0x395e864a, 0x5e304fdf, 0x08610f3d, 0x4c4bf5e6, 
	0x0beb97e7, 0x5aa1181f, 0x79816c67, 0x72e3a8ed, 0x399cb28d, 0x78c07e8f, 
	0xe502e270, 0xbce5054e, 0xa8a9ef86, 0xff28bc27, 0x6a5d014f, 0x8fa45df4, 
	0x57dc3f17, 0x599da823, 0xeefc618e, 0x51e5c4a0, 0x4f8adaf5, 0x5c9fa946, 
	0x940971de, 0x1d2abe43, 0x876bc416, 0x7a76a162, 0xfb350be7, 0xc67e2156, 
	0x9507067a, 0xd97be1e2, 0x4235db88, 0x3be9058d, 0xf52f6a7d, 0x26b1cb2f, 
	0x3b54ddf5, 0xdbd3c7fc, 0x4dbc4161, 0x39fc93c3, 0x7e2288c2, 0x1bad9aaa, 
	0x3e03f5ea, 0x61a0afc4, 0x514fc7b1, 0x8c38d5bb, 0x2fccbbe7, 0xc267fe11, 
	0x919aff87, 0x15667847, 0x0803a5fa, 0x279f873a, 0x94fe103d, 0x9151ca4b, 
	0x54e47cfe, 0x6606370a, 0xf89a7e4b, 0x3cf1f561, 0x022d9a11, 0x40789538, 
	0xb9256bdf, 0xf4847903, 0xad26e3c4, 0xc4fff82b, 0xd9ad2633, 0x9830dd29, 
	0xbe94ec36, 0x55c26809, 0x8de946dd, 0xad8eba66, 0x768a5913, 0x84116c71, 
	0x4388b0de, 0x5c4b27ba, 0xe4bb68f7, 0xe4f7e607, 0x3a3dd718, 0xd04f4692, 
	0x0ba0cfaf, 0x741965b5, 0x419e58a5, 0x33cb1957, 0xff5cbbea, 0x52fa4644, 
	0xf48c86ed, 0x47acfacd, 0x12dc20fb, 0x2b787c1e, 0x3cc7f684, 0xd0805ebb, 
	0xd62bb539, 0xaed3ed85, 0x239f28cc, 0x3f28caae, 0xb32ab8c1, 0x3347fa7d, 
	0x8fb52bd2, 0x5c4fb665, 0xe33ed99d, 0xe9f6ccea, 0xdbed992d, 0x31747817, 
	0xd961efb5, 0xaeca45be, 0xa77db1cb, 0xa3810794, 0x809e38c5, 0x0b33b9cb, 
	0x4fc82b75, 0x8ceb5bae, 0xc29884fb, 0x9f1c79f1, 0xbe29d6e7, 0xb73fc78c, 
	0xfca0d0ba, 0xe30fad1e, 0x39f99aa7, 0x53a3cf3e, 0xf7e7397c, 0x7f303d61, 
	0xf5416e7d, 0x44fc7254, 0xd6e89f8e, 0x157c6337, 0x7ac3e3d7, 0x5047bf30, 
	0xfccc333d, 0xa3d13f1c, 0x05f180bf, 0x16cf3edc, 0xcfc758fd, 0xcd8b7681, 
	0x42571728, 0xf9c80f7e, 0x827fae04, 0x3dfaa35b, 0x0ea2c8f6, 0xc6ae3db0, 
	0x058f9874, 0x8f02dedc, 0xce3cfaa0, 0xdf4c31c8, 0xf89be9c4, 0xbbf813bb, 
	0xe51a3c13, 0x117c7273, 0x2dc8bf7f, 0xc5de30ba, 0xefe6cfed, 0x0ef5bb66, 
	0xcfccd7aa, 0x88f22bdf, 0x167c63ef, 0xfd7367c7, 0x38fd1ed9, 0x3d70e7c6, 
	0xa17f5c85, 0xe7f6a0db, 0xeb93bc72, 0x088dba77, 0x3d73e7c6, 0xa17f5c85, 
	0x4e76a0c7, 0xd72778e0, 0xc718f4ef, 0x7c51fea8, 0x1d1b71cb, 0xccf5b7c8, 
	0xbba73737, 0x9d347add, 0x5f33776f, 0x393bf872, 0x78f8e31e, 0xba73737c, 
	0x4f3fa3db, 0x26f6e3ed, 0x57b2381e, 0x0e74e0b4, 0x1e244811, 0x221e3a67, 
	0x0cf12903, 0xdd39fbd3, 0x11f49118, 0xf404df4e, 0x9c6dd000, 0x2de9c8de, 
	0xebf15d32, 0xeaf51516, 0x3bea8447, 0x0fa3f525, 0x29994970, 0xc456f554, 
	0x2ec44d4f, 0xc48cbc27, 0xc3545110, 0x4fa4f522, 0x39e9c9ea, 0xe6b9c764, 
	0x89af8486, 0x15d20b71, 0xdefbb49f, 0x366bb39b, 0x4f5343ea, 0xcbbefd3a, 
	0xfa027d69, 0x0bfc4756, 0x9a45da85, 0xdeade2bd, 0xf52dc1b5, 0x1eb6ef46, 
	0x7da70bb2, 0x41e2154d, 0x52b769d4, 0xbec8d33d, 0x7dbd4cd0, 0x1ed934e9, 
	0x67c86885, 0xd05ffe20, 0x4b75f48e, 0x2a79723b, 0x723b3c7e, 0x3f503b74, 
	0x7ea4a7e8, 0xc44f51d0, 0xefdc21af, 0xfa04c1fb, 0x29413bee, 0x4837a867, 
	0x2ec0f82f, 0xfe79fe84, 0x6044b160, 0xa90a959c, 0x2de73d8f, 0x3f401d96, 
	0x3aeee307, 0xf583f183, 0x6f43c031, 0x0fdbf87e, 0x3fd0c56e, 0x3b6c07bf, 
	0x622c2daf, 0x33d78d50, 0x14b1dd68, 0xb23d72c2, 0xdfa1823d, 0x6c05e076, 
	0x01e460df, 0x45c273b4, 0x976816ca, 0xa7c207ab, 0xaeb4fbe8, 0xa27d8670, 
	0x81eb256b, 0xd5d7bb34, 0xcb1de323, 0x30eba2fd, 0xa85a0724, 0x99df071f, 
	0x35f4ed29, 0x9fe887ff, 0xfc93cfee, 0x9a4cf5c5, 0x35d7333e, 0xf62c7bce, 
	0x757c9803, 0x7f42a5c8, 0xc3fd9adf, 0x4237e2d9, 0xcaf7c37c, 0x13ffb46c, 
	0x3fe85d0e, 0x768ae393, 0x15ef2392, 0xe7057f4a, 0xeafbc817, 0x499f3285, 
	0x69329a5b, 0xfd265363, 0x3a4ccef5, 0x76192aa1, 0x72aeca54, 0xc15c7159, 
	0xb74f6cce, 0x395e1383, 0x3dda49be, 0x9a42d68a, 0x0e8d2d78, 0xbefafc86, 
	0x9e7175b4, 0x0720e888, 0x0871860a, 0x9a7e425b, 0x8f3ced57, 0xc03a636e, 
	0xf7a662f4, 0x41b13d31, 0xa206fed2, 0x59f71fdd, 0x2a838e05, 0xb2c83a2c, 
	0x64116232, 0xf5f8c08f, 0x396ebc50, 0xd3f6630c, 0x8d9c7fd9, 0x7e526bf6, 
	0x08015db1, 0xa97eed9b, 0xac4cc5f7, 0x81e76ccf, 0xb620e33c, 0xd08610f3, 
	0x166b43ce, 0x87be69fa, 0x0f77d217, 0xdb285fad, 0x2ac9a411, 0x24d1dd0e, 
	0xfd39dbd3, 0x35b74c73, 0x35407d11, 0x9730ea66, 0x0efb710f, 0xc3ccdaa8, 
	0x33bf9a61, 0x9e5e407b, 0x44eb089c, 0x85e6a9c4, 0x73b42ed4, 0xc35c8077, 
	0x3ff29052, 0xab04db79, 0xeedfed8f, 0x899fd833, 0x640728b5, 0xb89d030f, 
	0x4297e174, 0xb5c4a2c0, 0xf0811e10, 0x71ff4916, 0xec5a94f6, 0x3eeda277, 
	0xbda687a2, 0x5fbaeb46, 0x90a42fcc, 0x72e61dca, 0x98772e41, 0xe3961ff3, 
	0x3ffac118, 0x38e348d2, 0xaa62acb4, 0x6fad49e8, 0xa9959b3b, 0x47ea3cd6, 
	0x0d9fae35, 0x45a9d783, 0xffb421da, 0xab3a84b6, 0xff00bf71, 0xf9ff6862, 
	0x5e71abf3, 0x2dd57f34, 0xdeda39f3, 0x1b7b1c47, 0x42e205e7, 0x45b3fb41, 
	0xd48f41db, 0x60781c4a, 0x8dd507e9, 0x0e6c42d9, 0xbb202e74, 0xf5d72fd4, 
	0x3fcc1f4e, 0x50459bb4, 0x348832d9, 0xf671dbcc, 0x60651c1b, 0xf6d386c7, 
	0x423f9a23, 0xb7e767f6, 0xf2dfbcdc, 0x5fd3cd01, 0xe87c17b7, 0xb35bc3fe, 
	0xfe22d497, 0xf574733a, 0xb0c98e80, 0x24f6827e, 0x40be1af2, 0x70e0af7c, 
	0x46da871e, 0xfef34f0a, 0x583fe9c2, 0x82ed0a34, 0xe56b3bc2, 0x610c21ba, 
	0x207bc210, 0x38f9c66c, 0xf29512cd, 0x038aa868, 0xa2ba2ff3, 0xd7961563, 
	0xf81448d5, 0x2a98f85f, 0xa96fc300, 0xb4fd7695, 0xf92a88a2, 0x0f68e90f, 
	0xa3babaab, 0xd3e72537, 0x5b56560a, 0xe61e76cc, 0xb9661e76, 0x3dedc0d9, 
	0x3c3dedcc, 0x3f097bf6, 0x54bde7b4, 0x5fefcc7b, 0x9df7df0f, 0x1f8efb49, 
	0xd8f0f1da, 0x71c0ac76, 0x7b4e30dc, 0x9da21b4a, 0xb2bea1d3, 0xce42a8ef, 
	0x15c8ea83, 0xed99f6a9, 0xb667fb32, 0xee6ed92f, 0xeada280f, 0x1fc7201d, 
	0xbae0efc7, 0x7f9322b0, 0x9f58361d, 0x9aed49bc, 0xfe9cf52a, 0x6813ea18, 
	0x49f163df, 0xb4a9ddf4, 0xe520500f, 0x0bc70bb6, 0x17f66ff2, 0x4854c708, 
	0x0c7fefb6, 0x073681f7, 0x063b8e2b, 0x1300fd53, 0x33bf6c5b, 0x51aa2e8d, 
	0xfc630f36, 0x5f965df0, 0x8d023b42, 0x3171026d, 0xa54248d8, 0xbbe877c0, 
	0xdefa0ed0, 0xbb3e52fd, 0x47a83be0, 0x44551736, 0xcd7f9c75, 0x48d42e5c, 
	0x77f661b8, 0xd944bfb3, 0x16e22b72, 0xbd6407a7, 0xd9296462, 0xac9f3111, 
	0x9171e94f, 0x9d17b57e, 0x0df50bbf, 0x4eefbfac, 0xff5577c7, 0x36f2d898, 
	0xb2ddf4e1, 0xc0ab891e, 0xcfb60b07, 0x05bd9efc, 0xffea1af4, 0xc34be400, 
	0x4788bdff, 0x3dff5388, 0x2fbe37b4, 0xc375ef35, 0x9e7823b4, 0xe79a268b, 
	0xceb931da, 0xd8768bdb, 0x81cf3c9b, 0xe2dd7baf, 0x5620f889, 0xa610e8ba, 
	0x7b807d53, 0xafee745f, 0x163d979e, 0x079df607, 0xfb4ed81c, 0xbae40b8f, 
	0xa7e8b0cf, 0x3a83eec6, 0x85745045, 0x3adf5245, 0xf44a2045, 0x7b2b7de8, 
	0xe3b88a20, 0x20f8952c, 0x2efea5da, 0xa64ab878, 0xd11dfbef, 0x53b31f93, 
	0xfd9adffb, 0x6b51c27d, 0x57ed3b61, 0x0701eb39, 0x8be9db20, 0x13d45eb4, 
	0xd3df27ab, 0x5840762b, 0xeb2b71d7, 0x9ffc6a93, 0x516e4fa9, 0x9c3f6fb4, 
	0x970a5eb6, 0x7b467f8a, 0xee1a5c25, 0xe10bda7f, 0xee94fb45, 0x47f43017, 
	0xc8f60ebf, 0x935bf390, 0x096f6710, 0x89adfe5f, 0xe46eeb69, 0x898fc937, 
	0x8813cdb3, 0x54ece47e, 0xea1d3fa2, 0x78e916a8, 0x3b3f0f6a, 0x2d66f80f, 
	0x7c6868eb, 0x269b8840, 0xa37567fd, 0x71cf421b, 0xae95d5c2, 0x61405cff, 
	0x2105f1fe, 0x6a0ff7e2, 0x5574bf71, 0x2105ceee, 0xac170f88, 0x1ff8c6a8, 
	0xb8c038e0, 0x7ee5b386, 0xb4dbeae6, 0xdfb9945e, 0xe3250e31, 0xe1ef5aa3, 
	0x7d9f8cb8, 0xb7e28646, 0xf81bbf10, 0x25e1f104, 0xcb2dcf9c, 0xf28e7a9b, 
	0x9fe5a5b5, 0xe927f326, 0xfd5e92f9, 0x2853d70a, 0x1085228a, 0x78084196, 
	0xa6b9ae15, 0xbabaf917, 0xd72ff800, 0xe7c445f9, 0xb6bf8902, 0x42336039, 
	0x5add2b3d, 0xcc377e0f, 0x3d2b41fb, 0x31a449da, 0x30c8ed1d, 0xf2ad0fef, 
	0x206327e8, 0x7adcab9f, 0xed4f5c4f, 0x782ead3b, 0xebd256f6, 0x8d1a02ea, 
	0x73c04ac2, 0xe7b017c4, 0xfcd07f59, 0xeefa5d3b, 0xb7da0b22, 0xfb82dd61, 
	0xf9df4e22, 0xabea15a0, 0xd0a8ef80, 0x517e6b0e, 0xca98e514, 0x4326f7c3, 
	0xbff4317c, 0x45a48270, 0x249b940b, 0x92bb63f3, 0xa5ba83f1, 0x6127e397, 
	0x6f8e2cfe, 0x3e5fccce, 0x70b3f247, 0x9e7fa42e, 0xbba5af26, 0x333ead37, 
	0x0729d61e, 0xcc0cdcb8, 0xd3eb90bf, 0xa1f519a2, 0x7eb8853d, 0x03a9acba, 
	0xfa0d4be5, 0x7f40b6bb, 0x05ba9d1c, 0x1fb385f5, 0x6f03c068, 0xd91b6863, 
	0x275c9a45, 0x4448be9d, 0x9d5c7f71, 0xe7046efc, 0x3952a4c7, 0x2e6e26fe, 
	0x85f72399, 0x83e841e6, 0x24fa4fef, 0xfcb57ff0, 0xed13f11e, 0xe67d34b7, 
	0x61b8e450, 0x576e7cb9, 0x3c8879e6, 0x83f4711f, 0xbcde305d, 0xf4709c67, 
	0x4e78a3fb, 0xa36f8621, 0x5bcb7e79, 0xd27ce5b3, 0xf58479e5, 0xf3495ec7, 
	0xffe8137e, 0x77ff3439, 0xeba4b22d, 0x6cc542ff, 0xd63b8c2f, 0xf76b0aaf, 
	0x8c176e4a, 0xea57917f, 0xf5a5d393, 0x73ea021d, 0xd56fd62e, 0xcbf0a7f7, 
	0x6c48b271, 0xbfd6953f, 0x21e53e93, 0x7e81df5a, 0x80e10b99, 0x0d7dba3f, 
	0xc8f6b5f0, 0x5706346e, 0xe87891cc, 0x37647f9d, 0xebe133d6, 0xc4189b21, 
	0x02c58cf0, 0x0d7a77df, 0xedfa044b, 0x63be04ec, 0xb6724a73, 0x9d570045, 
	0xbf68fb8d, 0xd70eb10c, 0x6c2f3fc7, 0x514ed0ea, 0x9da0d518, 0xf76d7cea, 
	0x0bbf72a5, 0x9f2c5d45, 0xd688f6c3, 0x173cdbbe, 0xd939f6c2, 0xd01a719e, 
	0x830c61ae, 0xbed443ca, 0x7d1f6a76, 0x6bed8e3f, 0x1a25f6a7, 0x88f2c943, 
	0x7fb64e83, 0xc6733e26, 0x167e82e2, 0xbab010bd, 0x2e1fef50, 0x9da07bf2, 
	0x7691cd77, 0x21bbe245, 0xf3ed147f, 0xd0f6476b, 0x12aa2b7c, 0x1b898008, 
	0x64efc680, 0x3bf08b19, 0x4b407b49, 0xee841efb, 0x5777c90a, 0xbd4511a7, 
	0xe79469e5, 0x847ce673, 0x9f70cbbf, 0x516575d9, 0x41ce7987, 0x723583fd, 
	0x9f1a0ef4, 0x1efbca08, 0x3c0dcf94, 0xce9fa17f, 0x24ff35e6, 0xd0fd70d6, 
	0x6f3c1d8f, 0xe6338cdd, 0xae72c5bc, 0xb79e78f4, 0xf7093f18, 0xcc671839, 
	0xdfe66b79, 0xace2473d, 0xcd9df79b, 0xcfac9b79, 0x8b79e78c, 0x3f3033f1, 
	0xf39b4fef, 0xce6fccd6, 0x57ce2f5b, 0xc20d0b94, 0x5c87e4a0, 0x4ffd48cf, 
	0x37ec18f3, 0xfcfcd475, 0x83cfcf2e, 0xe4d53f3c, 0xde5834fc, 0x34e1eb0d, 
	0x3e5879fe, 0x3f369bbe, 0xf369adfb, 0xbcc0bb4e, 0xd0ed7d64, 0x4979bcfe, 
	0xfa69bffb, 0xdfd9adff, 0x1e29f9a5, 0x3d6944b1, 0x7013f3cd, 0x53d67098, 
	0x934dfd07, 0x0e9b9463, 0xd6cf9fdc, 0x94472823, 0xbbe3720e, 0x7004e40a, 
	0xe849b7cc, 0x75a909d1, 0x81a3eb8e, 0xa7e8228e, 0xb6ff66f7, 0xd9eaa349, 
	0xa1d381b3, 0x66af5e1d, 0xe1045ded, 0x936dc155, 0x166f7e50, 0x9f5023bb, 
	0x072d2afb, 0xcfacc7e5, 0x48b615eb, 0xed17a62e, 0x5f773946, 0xf43927eb, 
	0xe632d2ae, 0x4a4ed99b, 0x5823fae7, 0x923447ff, 0x22d9d3f3, 0xb67af642, 
	0x309dd111, 0x5fedb5be, 0xa193ed8a, 0xe1de6d2f, 0x2ded183a, 0xcfac630c, 
	0x7f396722, 0xc7eff380, 0xf0831b7d, 0x118a2954, 0xf0fb097e, 0x98aefc31, 
	0x9fd27805, 0x24864f66, 0x3d79abbe, 0xc31f50c7, 0x89da5a7a, 0x4e643923, 
	0x4be40426, 0x1ab037df, 0x59e18fb4, 0xf9df9653, 0x6bd76ca8, 0xe53be1e7, 
	0x1a339fe3, 0x78d2ce73, 0x450ecd0e, 0x6b3e504a, 0xe12e747d, 0x539d4bac, 
	0x41067f23, 0x2e786cce, 0xf685b7dc, 0xfa1d2887, 0x65c49b91, 0x16b2f58d, 
	0x55286da1, 0xfda0ecb3, 0x4e9b3ea7, 0x86cd52eb, 0x95039c38, 0xda5c8276, 
	0xc0765cb9, 0x0fb1dc7f, 0xe226bffb, 0xc7cb253b, 0x76b91f80, 0x03b337a9, 
	0xf00b653e, 0xf807cb25, 0x761e14fd, 0x16ff2d80, 0x1eeca0d0, 0x970d35bd, 
	0x64ed43da, 0x86fb9b67, 0x8e9f786b, 0x2f37eeed, 0x11136f3e, 0xf0a7a79e, 
	0x82a96b1c, 0x79e672e7, 0x66a0c955, 0x4099f3c3, 0x70e39f1d, 0x893a94fc, 
	0x9679e63b, 0x7ca8f967, 0x6dd93b8c, 0xebd3f199, 0x6a38be24, 0xe6ae3d64, 
	0x5e38e551, 0x605b34d5, 0x7c478c92, 0xbcc1cf31, 0x79fccce1, 0x8e96cd71, 
	0x806b599f, 0xc06103de, 0xe1c67a49, 0xfb02fc05, 0x9fc822ea, 0xea37f58b, 
	0x7ee507de, 0x193eb760, 0x7ed3a7bf, 0x96b6e390, 0xd2fb810e, 0xef341c9b, 
	0x39fe40e6, 0x72359fb8, 0x9baf077f, 0xff0dffa2, 0xff773acf, 0x61db07ac, 
	0xeabf51cc, 0x1c5ddf69, 0x730b90ca, 0xba8da99e, 0x3e63173c, 0x1036dd65, 
	0xf55a7dc1, 0x4b88e1f2, 0x62b84bee, 0x2a584eb8, 0xff8c2f54, 0xfea4eb47, 
	0x474f8319, 0x837da0ae, 0x483577dd, 0xb440303a, 0xde62eabf, 0x7f7f18c7, 
	0x50d9adef, 0xb3b1c823, 0xe863d84c, 0x7e9210b7, 0xdc2ed80b, 0xa73aceb7, 
	0x873f6247, 0xc688a670, 0xd7bc80b6, 0xf02a2dc7, 0xe31d4d63, 0xdf47af2d, 
	0x865e820c, 0xbae23b7f, 0x3a7f42a2, 0xa65da4ea, 0x63867fb2, 0x88cd61b9, 
	0x36f8e02f, 0x5f1196dd, 0x6b00f922, 0x3c466759, 0xfc3aabef, 0x5f1192c2, 
	0x5a03f9c3, 0xb8863c46, 0x38eb57ae, 0x3be82c3d, 0x3d64abee, 0x7d6112ee, 
	0xae52e7ea, 0x77d3770f, 0xe5dfb8ad, 0x3d0b57b8, 0x0b72c1a5, 0x7ea115ca, 
	0xeb42d91a, 0x279e074e, 0x1f3f70f7, 0xb0a38d49, 0x11b28a1a, 0x00f904f9, 
	0x8683f2e7, 0x1f98a222, 0xcaec0aa0, 0x21f30c7c, 0x53e162df, 0x01f943de, 
	0xf5137941, 0x69c56eab, 0x8b6d6895, 0x1091733e, 0xbd49d5f7, 0x7fcb3f7b, 
	0x07e41456, 0x3db6b7f1, 0xa65179da, 0x0f7f90fc, 0xc1dcadd4, 0x592780f1, 
	0x7103ad6e, 0xf20a2b2e, 0xc230fe49, 0x3592388a, 0x5fc48f53, 0x1d69f6c4, 
	0x7e7455f1, 0x7f42e4aa, 0x7a93aa9f, 0x9c6d6873, 0x85a895fa, 0xfd03b179, 
	0x06c2fc88, 0xf38ebfe5, 0x4a3c6d37, 0xbf403ec0, 0x8d47c7a0, 0xe79e6ed3, 
	0x967b38e6, 0xe3c7ca8f, 0x1996dd9c, 0x67ec15ff, 0xecfc6a5b, 0x38e55181, 
	0x022dcf1e, 0xed1e32bd, 0xbd3c737f, 0x79fccce1, 0x6fde7971, 0x06b1dfb6, 
	0xecd2f3d2, 0x62b71c56, 0xf7981394, 0xa3faa79f, 0x6bfbb471, 0x717c3a5b, 
	0xefdc5fd9, 0xa4b4daca, 0xff9c8f66, 0xa64f363b, 0xff51597e, 0x1fb28daa, 
	0x7e5f215b, 0xa177bcda, 0x9fbe43be, 0xe76b2e7b, 0xe7de6a48, 0x8ec9f8b6, 
	0xcfcf9b78, 0x798bacc7, 0x59b7315f, 0xfda23dda, 0x623f685f, 0x79eaf7eb, 
	0xde89dafe, 0x90fd893b, 0xc70dfb92, 0x245fd0eb, 0xad08cb67, 0x8c6f738f, 
	0x9dda782c, 0x521d67da, 0x84e3db34, 0x5059cfdb, 0x259fc12f, 0x0ffc92b2, 
	0xa47fe8ac, 0xc5f9b8f0, 0xe4e22b31, 0x667f98cf, 0x4f1e09fc, 0xf4b3c785, 
	0x8f99918c, 0x9aaa73c7, 0x3c27fe59, 0x5b8f0a9e, 0x39546c6e, 0x1b8bcf8e, 
	0x9fedc456, 0x3c2a78f1, 0x3386539e, 0x188d97f3, 0x06dc74d6, 0x67e341fd, 
	0x8d5bf1c7, 0x5377a421, 0xffbf093b, 0xbf1bf11b, 0x47cfa8d3, 0x9b8dc5fc, 
	0x5df4ddae, 0xc37f9fb9, 0x1da05440, 0xabfdf8c5, 0x8f9f7e24, 0x3a36fc4a, 
	0x3cbf01ce, 0xe4fb9ee7, 0xb9edf878, 0xfb936c59, 0x8b591a26, 0xdbdc71a3, 
	0x4dc70828, 0xf06e78fe, 0x577b8e11, 0xf5c71807, 0xcae38805, 0xd0a441a7, 
	0xf12b99ce, 0xe48b94d3, 0x43fed4fe, 0xf99dee34, 0xbe072cc5, 0xbf1c4cea, 
	0x63b47ed0, 0x288bee2e, 0xf7f54685, 0x2f8e23b6, 0x4afd843a, 0x13c78bb6, 
	0xa276a7cf, 0x45a73e3e, 0x9e7f80e2, 0x47122299, 0xc5b8bf5c, 0x953e03e2, 
	0xa0b895cf, 0xb80eb898, 0x1f6eb88a, 0xb58f0831, 0x9aaf52b9, 0xe8cfd9f5, 
	0x7fdcf199, 0xcd48babb, 0xb2f96788, 0xc4677c03, 0x59dbae33, 0x4de3246f, 
	0x1969885c, 0xfae218f1, 0xfb1b94d2, 0xcfdf46b0, 0x29cf5c61, 0xad4fadd1, 
	0xd87f7292, 0x13af3885, 0x80752bae, 0x39e3c0eb, 0xf508be50, 0x82d388e7, 
	0x81694e7a, 0xf03803a9, 0x4c95e826, 0x882cd75c, 0x90739ed7, 0xccb8e7ef, 
	0x31583e06, 0x1edde83f, 0x70847fdc, 0x16bbe427, 0xc7c61d70, 0x79e42855, 
	0x21b0d7b1, 0xe6f33bae, 0x436c2dcd, 0xe741257f, 0xb48faebf, 0x13eb79d0, 
	0xe6e61a9b, 0x71fb43ae, 0x19f15cc1, 0x1bb21392, 0x5f20153d, 0x17ca65ef, 
	0xaf9e3ce2, 0x974c092a, 0xc371ef38, 0x98e5117a, 0xafc69e71, 0x4469db10, 
	0x8a95df11, 0xe85cd67d, 0x238f2b77, 0xfe7083ae, 0xb3e8dd0f, 0xbfdc6688, 
	0x5e827e87, 0x70127f71, 0xfb77f812, 0x3ddf395c, 0x44585c49, 0xf992bab8, 
	0x332fc66d, 0x417125f3, 0xc497cccb, 0xe1f2cc85, 0x799f52b9, 0xaa30b892, 
	0x3417125c, 0x478c79c2, 0xc493ce7b, 0x65fccc85, 0xc6afd223, 0x4b8e3f6c, 
	0x03dbce3a, 0xfc813869, 0xe70831a9, 0xa207333d, 0x33b7f388, 0xba9b3c5f, 
	0x6fce3056, 0xf637707c, 0xf71c20cb, 0x315fce30, 0x4d0fae57, 0xeaf6c87c, 
	0xf73f4a36, 0x9c7482dc, 0xe701db57, 0xce34ff07, 0xf38c6dab, 0x3e946dfe, 
	0x7a65faac, 0x2dd1057f, 0xe14759af, 0x21573ebc, 0xf389527f, 0xf38932ea, 
	0xefe98a39, 0x35dfc82a, 0x51df36eb, 0x1ec5f115, 0x257ca088, 0x0716d134, 
	0x65717dfb, 0xad3aa848, 0x69e2da73, 0x088aebfb, 0x28bde25a, 0xbe63be8f, 
	0xfb8f195e, 0x632f98e1, 0xe0f5043d, 0x0aa8ca3a, 0x6d3d7689, 0x2abb147d, 
	0xfca273bf, 0x22eb78ee, 0xfc582f58, 0x7ae66944, 0x7c7e4ac1, 0x2f282ebc, 
	0xe71058b2, 0x69e3cebf, 0xae657fc6, 0x5eec37b4, 0xcc8bbf53, 0x285ebc7c, 
	0xff8cc91b, 0xbd97cb1a, 0x463fb4c6, 0x5878e395, 0xef505b6f, 0xcbe59d7c, 
	0xfc85ebce, 0x53fccc9e, 0x5d258b55, 0x0b8828ef, 0x78505eb0, 0x6af760bd, 
	0x3dbe6fa4, 0x7b1bea57, 0xf5e568a3, 0x93add1c2, 0xe91a7bf1, 0x5f34fb1b, 
	0x0a0bd704, 0x73a39beb, 0x14d37d4d, 0xa846fa91, 0x9ca617e8, 0xc1e5bf3b, 
	0x46fab191, 0xbd7f1a19, 0x11a8d250, 0x527c9b9e, 0x9995c718, 0xe1a5df60, 
	0xe72c1bf8, 0x9c71a359, 0x5cccf971, 0x4cb367a9, 0x38fb671c, 0x38e26f19, 
	0xde327ee3, 0x63a2f1c4, 0x3898f599, 0x4656760e, 0x6ce389bc, 0x18f19bff, 
	0x659e7da2, 0x418f78e2, 0x8abfef38, 0xb744a871, 0xc8d71c49, 0x1a06cf3e, 
	0x28dedc71, 0xd7313c71, 0x9297cfb4, 0xd36f6e7d, 0xfd8e7da4, 0x1b71c4cc, 
	0x6e72b3e2, 0x59e7d929, 0xa373b001, 0x21b75f98, 0x986167ee, 0xfb216d4f, 
	0x5fc11bfc, 0x17ff15cf, 0xf185efbe, 0xe25ef981, 0xe34bf897, 0xb8abf801, 
	0x69202fd9, 0xb4366b67, 0x64ff81b3, 0x00e72b67, 0x651fa18f, 0xcdff24f3, 
	0x1550faf5, 0x852c6fe0, 0xa4f325bf, 0xb3f26fbd, 0xeb4228bc, 0x293cdf56, 
	0x63bc6687, 0xe6179c9e, 0x9bdd8138, 0xa9c78f99, 0x3e33246c, 0x23af1e67, 
	0xf7f5cc6a, 0xbae672a8, 0x3ad3a829, 0x5e71e31a, 0xdf91e398, 0xaa7f9993, 
	0xb475a11a, 0xbb890efd, 0x4f487ed9, 0xe46cddc3, 0x77dc1ee3, 0xab24f390, 
	0xf911e406, 0xf117debb, 0xc97f64f9, 0xfdf4d8ae, 0xced27b2d, 0x4d739499, 
	0x014f116b, 0x71d3defd, 0x08d5ee5d, 0x351ab367, 0x6e397dd1, 0x2f9e0c6f, 
	0x20da0fbd, 0x287d76a6, 0xd9088ace, 0x616fcf4d, 0x86b9a9bb, 0x4e57a7d2, 
	0x3e34f3e6, 0x423a6a67, 0xb5854ce7, 0x5f10f335, 0xe847abd5, 0x83b4491c, 
	0xb29bd4bd, 0xa55f11a3, 0x773cbeff, 0x6972fda4, 0xb0bc7227, 0xd395ba72, 
	0x5e383439, 0xd9ad24d8, 0x87001ef8, 0x850bc706, 0x9e5c2bcb, 0x85e38343, 
	0xb9dbcb9d, 0xc706873c, 0x3ba7070b, 0x83439d38, 0xeb9385e3, 0x1cfd7277, 
	0xea0f1c1a, 0x9caba641, 0xf1c1a1ce, 0xbbf5c5c2, 0x0d0e7eb8, 0x4e6e178e, 
	0x873a7377, 0x0f0bc706, 0xfae1efd7, 0x5e383439, 0x97bcb978, 0x706873cb, 
	0xf2e2c8bc, 0x439e5c59, 0x3645e383, 0x3a7367a7, 0x8bc70687, 0x873fae1c, 
	0xe0d0e7eb, 0xf2e3e178, 0xa1cf2e3e, 0x9722f1c1, 0x7972e7cb, 0x178e0d0e, 
	0xc79e9c79, 0x1c1a1ce9, 0xfeb9f22f, 0x439fae7c, 0x0145e383, 0xf2e02f97, 
	0x2f1c1a1c, 0x09f97026, 0x83439e5c, 0x4e44c5e3, 0x1ce9c89f, 0x0a2f1c1a, 
	0xae42feb9, 0xe383439f, 0x17a71145, 0x06873a71, 0x5c498bc7, 0x9fae24ff, 
	0xc5e38343, 0xcc9f4e64, 0x1c1a1ce9, 0xfeb98a2f, 0x439fae62, 0x0945e383, 
	0xf2e12f97, 0x2f1c1a1c, 0x29f970a6, 0x83439e5c, 0xa72945e3, 0x873a7297, 
	0x328bc706, 0xeb8cbfae, 0x78e0d0e7, 0x3f74e7e1, 0x706873a7, 0x087f60bc, 
	0xcfd72a6d, 0x62f1c1a1, 0xe34fa71a, 0x8e0d0e74, 0x7f5ce517, 0xa1cfd739, 
	0x82a2f1c1, 0x797057cb, 0x178e0d0e, 0x92be5c95, 0x706873cb, 0xe9ce98bc, 
	0x439d39d3, 0x1545e383, 0xf5c55fd7, 0xbc706873, 0x807a7008, 0x383439d3, 
	0xfae0cc5e, 0x1cfd7067, 0x662f1c1a, 0x4e4cfa72, 0x78e0d0e7, 0x57f5cd51, 
	0x1a1cfd73, 0x6fda3f14, 0x5ed1e310, 0x9271527c, 0xef798dbf, 0xc2f77129, 
	0x455f23e8, 0xaa7b9c3f, 0x9f12457d, 0xf3a96d63, 0x2edb2781, 0x22ff26af, 
	0x21dea8d5, 0xfc80b3db, 0x17ac7d35, 0xf1471966, 0x6ddbc21e, 0xdfbc8453, 
	0x3c59ffb3, 0x5e45f82f, 0x8fe8fbcf, 0xd4d35897, 0xecddfb46, 0x7940a707, 
	0x9a1f6fdc, 0x412bf856, 0x01a376eb, 0x61fd33eb, 0x8cab6ede, 0x1e5083ea, 
	0xaeff43ea, 0xfa49b044, 0x9d5fb0bb, 0xd10e2598, 0xa04cd6f7, 0x8844f7fd, 
	0xeb235feb, 0x03d1da4f, 0x0ce792cb, 0xf77db2ef, 0xbc42f39d, 0xf30fef3e, 
	0xbb01bf6c, 0x6429a6f6, 0xdee37f5f, 0x648fe4d5, 0x27f87fda, 0x051939ef, 
	0x0ed4fd99, 0x89af77e2, 0x067ee64d, 0xd3f9e20e, 0xb7a2bc81, 0xd1216f70, 
	0x43b65f33, 0x2875485b, 0xcfd43388, 0x7eca76d7, 0x7ee9998a, 0xa6c4d73f, 
	0x43f73f51, 0xa1b35d7d, 0xecbe7c7c, 0xa33f3ea7, 0x0af8d79f, 0xa1352fc9, 
	0x3de9942d, 0x79fb33f3, 0x17ad3964, 0x7273f6c6, 0xc1d60dbd, 0xe3ca6f57, 
	0xd3b9be7e, 0x7ebc6932, 0xeee7da8e, 0x673a67f9, 0x5a66069b, 0xe8dc3fba, 
	0xcd6f5bfb, 0xfe8f519e, 0xeffbd670, 0x4170f8b3, 0x90ba7e8e, 0xcd9ae4fe, 
	0xf12b7f74, 0xed1f90e5, 0x7e5da1eb, 0xd05fdd25, 0xd2284fb7, 0x7f7c6c4f, 
	0xe5cf5c41, 0x060bfba6, 0xc77646bf, 0x651343e1, 0xc89bfafb, 0xf5fc38ee, 
	0xbf3e7c79, 0x77dc59e6, 0x4c6bf737, 0x2eeb217f, 0x3d6043b0, 0x23a5fb97, 
	0xe782dfe4, 0xb36fc864, 0x7fe2ca1f, 0x8dfe96ed, 0xffbffaa3, 0xe9ffd453, 
	0xd0fbc95f, 0xfd636cfb, 0xa7acaf03, 0xc7be47f3, 0xd3b35fb6, 0xcd03aafd, 
	0xd4de8fc0, 0xdf88c3f7, 0x873cf12f, 0x3fa3b77c, 0x947b5a76, 0x04f865eb, 
	0x7e8edfc7, 0x9f4ed8d8, 0xd9fe4c98, 0x7bf64d86, 0x2dd10b79, 0xb6bfa5e7, 
	0xb4198b88, 0xf69ba5cf, 0xd303369a, 0xe992dd55, 0xef295e5f, 0x1fd40a09, 
	0x063be92b, 0x1ea1b5fa, 0xbb507119, 0x442d8d8a, 0x893bf497, 0xf490192e, 
	0x9e929394, 0x56a14832, 0xd2e92c3a, 0x6cbd3233, 0x8665d244, 0x9fbfb44a, 
	0x103fc342, 0x49ea7a23, 0x941d4f49, 0x2586d3e9, 0x4c8ced3d, 0x74911f2f, 
	0x5fdb21b9, 0x36fc4fd1, 0x5d24062a, 0x95d25279, 0xd99ef283, 0x4f4961f4, 
	0xabd3233f, 0x655d2446, 0xf40e89b8, 0xe876f843, 0x84a72473, 0xdcf12bbb, 
	0xe38c9f58, 0x1c0ce102, 0x68aa0d97, 0xb87eb013, 0xf5b9e603, 0x16b442db, 
	0xac2b4189, 0xcaaf1247, 0xdd9769fb, 0x11ad8860, 0x7dc9a75c, 0xabe7b02a, 
	0xf1f45f70, 0xee3d58da, 0x86973a07, 0x5a2e8d02, 0x7d6156c7, 0x52a7be34, 
	0xe29481df, 0x331e71f4, 0x8ab8e60e, 0xb81d71cc, 0xc615c79f, 0xe6aba643, 
	0x3eb33afd, 0xa1c5371a, 0xd40a38d3, 0xe3fd2ff7, 0xa1dbdb8d, 0x48bce527, 
	0x53d63f1b, 0x6949f5e7, 0xeaafd8fe, 0x72db6fc4, 0xe53a57d0, 0x74ff7b27, 
	0xc451fdd9, 0xe645572f, 0xf70564fd, 0x5c3c615d, 0xbc0a85d3, 0xe297ee4f, 
	0x4c6df67c, 0x55d1f7f7, 0xb84d0f79, 0xa99a1ef0, 0x077e84df, 0x76d6ebcd, 
	0xfdf7ffde, 0x7a8be884, 0xc438e5ea, 0xdc74d122, 0xf7f66b7b, 0xff183f65, 
	0x3b21855c, 0xa5d3fbce, 0xdf5044f7, 0xf3a6fcc1, 0xb1e79571, 0x6858f3ca, 
	0xf74499bf, 0xf12bbf63, 0x7eefecd4, 0xd42285ed, 0x4ae6ee1f, 0x377457f2, 
	0xa1768acf, 0x14f3495f, 0x212fcb65, 0xcc8ad16c, 0x273c127d, 0xec1a344f, 
	0xe82c2b87, 0x8c6f6ad7, 0x14feacc5, 0xba0f22ae, 0xde7bc4ee, 0x47b6117a, 
	0xe7459e69, 0xfdafdf23, 0xd2bfc909, 0x65b5d95c, 0x422be50d, 0xfec03d39, 
	0x9f78072b, 0xffef00e6, 0x73c90a1c, 0xfc399b9a, 0x0f3cc869, 0x74afe415, 
	0xdd3365b0, 0xf79a1eb3, 0xefae3d56, 0x817f2d0e, 0x782b5bee, 0xebbf1adf, 
	0x50ffc8d7, 0xa3558dec, 0x7ef240ff, 0x2d4799f5, 0x9f93f788, 0x0e23f795, 
	0xc160bcb6, 0xcb43f573, 0x0ff456ed, 0xfcbd6dff, 0x931e335e, 0x39d056ff, 
	0x0d5fbcbd, 0xf1fd057c, 0xc4bbfd54, 0x044eb57f, 0xfc809cf9, 0x3b50d494, 
	0x5a77cbdd, 0x409fb9e5, 0xce5bb5bb, 0xd27bf4bb, 0xce6479a9, 0xbc64ad2b, 
	0x3e702579, 0x45d23ce1, 0xfbc91e72, 0xc853152a, 0x3e6d221f, 0xd1fcd10d, 
	0x8a14134b, 0x2e92b3b2, 0xfed240fb, 0xba1f9a3e, 0xc50a65ff, 0x9e9213d4, 
	0xa7a486fa, 0x5a7a490d, 0x67e5d242, 0x81fe5d25, 0xa8fa2ba4, 0xcbc57a1f, 
	0x9e570f52, 0x1be57490, 0x439c4a14, 0x06df0237, 0x9de1176a, 0x05ce7389, 
	0xf8953f45, 0x6e3fc633, 0x10b87f7c, 0xbe6973df, 0xed5ff489, 0x079c8751, 
	0xefd2033d, 0xa6576ee6, 0xd38e1c3f, 0xac3f9486, 0x17e95de3, 0x38c374ef, 
	0x2abdff48, 0xffa41fe9, 0x8861ef02, 0xf22b669e, 0xf20e952f, 0x889ae984, 
	0xbf1256c6, 0xd46f78a3, 0x49d31411, 0xc518c17e, 0xda03d8f6, 0x972f9474, 
	0x9c2dfd26, 0x9081fd0b, 0x142fe50b, 0x5e53f942, 0x08bab7bc, 0xd5ef7bf4, 
	0x07a1d523, 0x4ff6fe52, 0x756951de, 0x1459fcc1, 0xb40ef3e2, 0xdcf9877b, 
	0x08afd205, 0x4b62fbc9, 0x78429b6a, 0x979cc28f, 0x41ed0e58, 0xf55b94d5, 
	0x93c4163b, 0xea1e2383, 0x47d18f7f, 0xafdbdb72, 0xc15edc90, 0xd794c4f3, 
	0x59887a8e, 0x59cfd697, 0xf187445a, 0x0c689fb4, 0xfa981e22, 0xee3ff481, 
	0x08f5badb, 0x7e90e5fa, 0xdeac6c78, 0xc1290c77, 0x55ef293c, 0x95fe1764, 
	0xa5e90076, 0x3fbd2953, 0x2780fdfa, 0xfd4571cc, 0x0f76f908, 0x8c2a5528, 
	0x8b939ecb, 0xf1ded4ab, 0xd0f6e070, 0xef40e287, 0x23501c28, 0xbf79cfc4, 
	0x038b8c0f, 0x8f8d099f, 0xdfd54f03, 0x9dfc221d, 0x9fd047a5, 0xdf2351d4, 
	0x4fcd18e3, 0x1f12cf53, 0x07f6a767, 0x2025ba83, 0xff3d7f5c, 0xd4cbf346, 
	0x78f04fc3, 0xb3e2b141, 0xd911c60e, 0x1b8962ae, 0xe24fa4a2, 0x12cbc943, 
	0x909ca61f, 0x243794f4, 0x13fffa5d, 0x3757024f, 0xfe80af4c, 0xe8f1bccd, 
	0x6b081af4, 0xd55436d6, 0xfdd17841, 0xbed0ab47, 0x636bbd99, 0x997c0540, 
	0x08123853, 0x10fbd174, 0x2c95bec3, 0x9ea12f27, 0xe8f34fdf, 0x896e3c57, 
	0x778cdce6, 0xa5f20426, 0xfc57be8b, 0xa787c48f, 0xb9498fea, 0xa8c3f24a, 
	0x929dd93c, 0xec1556ab, 0x0fb221c1, 0x6bae18c3, 0xf5deceb9, 0xc0ce4a74, 
	0x606cd45e, 0x1f968a37, 0x7839be91, 0x6e87ee50, 0x95da4fe8, 0x76786cfb, 
	0xf48132df, 0x3383c1cd, 0x5f18ded9, 0x0e50070e, 0x672c2fbb, 0x7ce17df0, 
	0x578f4ffa, 0x8086a1f0, 0x80f1e6e2, 0xa5fb59f9, 0xea2f01a3, 0xafcd9687, 
	0xdba65647, 0xc1f4a3a7, 0xe7ffc4b0, 0x45ffa6b3, 0x975879ef, 0x8ef197de, 
	0x5e7bad07, 0x57e9bb42, 0x3da61724, 0xa777da6d, 0xacf3bf4b, 0xb41afb90, 
	0x2d5af39e, 0xdf5fefd4, 0xf431affc, 0x7c1304bf, 0xb619f93d, 0x4fb7a42d, 
	0xde5cba84, 0x3ce4d127, 0xe18dda4d, 0x5d71eb85, 0xc92a686c, 0x3c37afd9, 
	0xa0fbcb27, 0xc80bed3c, 0x949da6f2, 0xfca26b68, 0x32e5215e, 0x7e67a7e9, 
	0x44adf70f, 0xebcf2d06, 0x4bd91a2e, 0x98af33eb, 0xc318bdda, 0xdb83c4f0, 
	0x82de3ce9, 0xc94ae8fb, 0xe43b7d3e, 0xfc906fcb, 0x643df3b6, 0x7ba347bb, 
	0xbe78c9cf, 0x6b776cdf, 0x0778f491, 0x1f503bc7, 0xcb83bc40, 0x953a3c3b, 
	0x1a6fd857, 0xbb7e41db, 0x0c97be41, 0x8f3c09eb, 0x9313d734, 0x5a5cf81a, 
	0x744fee31, 0xac659c91, 0xf5dafe3f, 0xb8984386, 0xdeb98ff6, 0x5619d730, 
	0xaf793ea7, 0xc2baec6b, 0x8a37aab5, 0x6ab5c97a, 0xc2e50452, 0xbd2e537d, 
	0xe9bee1a7, 0x0c28229f, 0xe077c760, 0x9afb8bbe, 0xdf945193, 0xa3062b9a, 
	0xcd6b5025, 0x863e3f4d, 0xeeb6eaf2, 0x3cfdd19b, 0xdfe26b86, 0xad57f184, 
	0x5fc70386, 0xcf2cc6b5, 0x0cdfbe08, 0x1c7aeafa, 0xdacbb457, 0xa7f3453f, 
	0xc91cbaf1, 0xce8470ef, 0x77de6bbb, 0x283cf546, 0x33ec0d37, 0x389b9b18, 
	0x9165a3bf, 0xcbc71ad5, 0x33a5ba43, 0xf84faa9e, 0x1cbcd156, 0xe396c96e, 
	0x7e88f5c2, 0xf47fea83, 0x47de6cce, 0x23377cc9, 0x63735fb5, 0xdcd7ed03, 
	0xc835ed28, 0x42ef92e1, 0x6b4f34e9, 0x1e7b41ce, 0xa1c7b54e, 0xee403b41, 
	0x203b6066, 0x77d2bef4, 0x2140ec8c, 0x7d84a7b7, 0x1ff74238, 0xdd8e7975, 
	0x71e10a17, 0x418bb0ac, 0x3449c73a, 0x187ee487, 0xcfdd29cb, 0xbf2a65fc, 
	0xee7994d1, 0xcc1fd6ed, 0xdcc82cef, 0x794332c7, 0xb7ec03ef, 0x1ffba935, 
	0x2f7c837a, 0x3ded4960, 0x256f680d, 0xced337ed, 0xc39d2a10, 0xffb43e63, 
	0x217f204e, 0x397cfe7f, 0xc3acc6df, 0xe74acd55, 0x8475c9c5, 0xe9e9f641, 
	0x0f927ad2, 0xd9127867, 0xf56bde35, 0x84177e6e, 0x77e668b8, 0xf6c57386, 
	0xef1fd0c7, 0xefef0c48, 0x87f56b42, 0x4bb548ee, 0x43123c6d, 0xe5c772ff, 
	0x32fbbea2, 0xd184a708, 0x79fc8a5d, 0xf9222363, 0xc4ccef87, 0xc3bfe5da, 
	0xb88d7b48, 0x586637bc, 0xd3963a7c, 0x1ef96642, 0x0384b3a4, 0x647015df, 
	0xeadf6df9, 0xd1967080, 0x6187ddd0, 0x1b287638, 0xf5fca0fd, 0x5840963b, 
	0xe7647e19, 0xb06fac76, 0xe40bff60, 0xe1ff7b77, 0x370b9608, 0xfd14b8ef, 
	0x3d81c385, 0x383edf98, 0x9638fbb7, 0x5001f6e3, 0xdad3dbc6, 0x21ed0257, 
	0x2f6c78da, 0x4131ddb4, 0x08b1ddaf, 0x8161adc2, 0xad8ee57e, 0x65bb1dfa, 
	0x7b6d81fa, 0xfed43da9, 0x5858bd24, 0x9d703b23, 0xcb77c46c, 0xeeb6c7f8, 
	0x3f90efa5, 0xcbfa17bc, 0x62bc65e5, 0x1daff991, 0xbfe66f15, 0x711eb32a, 
	0xa506d1f1, 0x2573c78d, 0xfb01bbdf, 0xfc075bcb, 0x8b71cbf7, 0x3af7eda4, 
	0x1a1adef8, 0x42cf7878, 0x0f9d6ab1, 0xf4b8efc8, 0x6571082f, 0x7207d413, 
	0xa7e51473, 0x8f37cf0d, 0x7499bc92, 0x7a666e67, 0x7e932787, 0x8f6cb772, 
	0x66368749, 0x9cf82fa6, 0xc4f9274c, 0x827cc577, 0x2e924fe6, 0x555273e2, 
	0x7e1adbc6, 0x54fa80d4, 0xbde27db0, 0xfee45214, 0xdd03ed0f, 0xf209f61e, 
	0xce00bb5b, 0x8933fa9b, 0xdd00c1eb, 0x7356156b, 0xabda491f, 0x47dca478, 
	0x618ffd38, 0xf65189a7, 0xec05bbaa, 0x790fde97, 0x2740629f, 0x27f6d3fb, 
	0x3e00a7de, 0xa44bff44, 0x19e71dc6, 0x03d07bea, 0xa547bc36, 0xd41662f8, 
	0x035f7473, 0xa08f1ae8, 0xefa344fb, 0x9e4b7ad5, 0x6c388639, 0xfbe423e2, 
	0x6823d40f, 0x673d915f, 0x52288fde, 0x21c4dd29, 0x6eeb06b7, 0xcc96c5c4, 
	0xce26b67b, 0x83c5b8d5, 0xc5d13f78, 0xc70d18eb, 0xd7c69bbd, 0x0831ef26, 
	0x2915f75b, 0x91d7321c, 0xf7307949, 0xc0794d77, 0x625c8de7, 0xca69bd8c, 
	0xbf611dc3, 0x1776cab0, 0xfaf6407f, 0xc5baf63f, 0x64e8f4ba, 0xc667f43f, 
	0x03d38db2, 0xfa7f5610, 0x0841e9bd, 0x2abf809b, 0x3dd677f0, 0xbf70ab1b, 
	0x63f6e2e0, 0x08bb3fb4, 0xfc81bef9, 0xa4bfc84c, 0xc714f455, 0x263da276, 
	0x3d80fbef, 0x81ded46f, 0xf49c4376, 0x123f6a52, 0x6fcf1686, 0xb593b634, 
	0x5b075a7e, 0xa5f29f71, 0x8fc9f471, 0x7974d1ec, 0xcf35f610, 0x06091e93, 
	0xdd20e714, 0xe34f5ebf, 0x5c76ccdd, 0x48bd684b, 0xd49357bb, 0xe70f3d8b, 
	0xe5823e77, 0xd07ef203, 0xa60f23e2, 0x95aa83ef, 0x16bb0d83, 0xf0867de3, 
	0x1fa27797, 0xaeed04db, 0x7abf12ed, 0xaa1e03b7, 0x8abd6fb8, 0x5bef3cf4, 
	0xa15f38df, 0xa04340f5, 0x6fb53bb1, 0x20b1fb4d, 0x3ee5962f, 0x3fea176b, 
	0x1da10058, 0x11c91961, 0xfd69d5f6, 0xdf80bd5b, 0x722c31a7, 0xd7354d7f, 
	0x64cfb433, 0x66e12151, 0x1da22792, 0xf9120f7c, 0xf9cba437, 0xb4fc9090, 
	0xedb4959d, 0x7d2b4903, 0x9795a211, 0x13f61429, 0x21bfb692, 0xa490c769, 
	0x3b49091d, 0xf9da4acf, 0xbed5a481, 0xcbead128, 0x09d70a14, 0x90debb49, 
	0xd2487bb4, 0x3da484ee, 0x3c342967, 0x79d4d123, 0x79de39a9, 0xea7bfdf1, 
	0xbf5bfe40, 0xc4af693b, 0x4238ad57, 0x47be9bf6, 0xcef79fbe, 0xadee38eb, 
	0x43da9fcf, 0x5fa2fbe9, 0x6db43e44, 0xee7ba7ca, 0xdab7f782, 0xcf174f3a, 
	0x20fcc958, 0x3796e83e, 0x1f84bff4, 0xa1403286, 0x16493f66, 0xa41f6187, 
	0x4b0c7350, 0xa64671da, 0xed24473b, 0x55c3c834, 0x3bbde553, 0x7ea01d43, 
	0x9293ae6a, 0x74ca0d76, 0xdda4b0f7, 0x67ba6467, 0xd19ed244, 0xd43f7c76, 
	0xfb42b6bb, 0x6b85da12, 0x0edd7115, 0x1290b790, 0x79076d0e, 0xd7f0aa6b, 
	0x47f6043d, 0x67a27dd3, 0x79885dab, 0x42871279, 0x113e82f7, 0xc52e7eb4, 
	0xe9faaf73, 0x06685eb0, 0xc5e88c7e, 0xb884bb9d, 0x13f48179, 0xca5b8b6e, 
	0xed6dded0, 0x40a25639, 0x5b61d6be, 0xc83ed74e, 0x3147777f, 0x5856a12a, 
	0xdcbce02c, 0x39aff90f, 0xa555f383, 0xe36a07f7, 0xe4151296, 0xa44f4e73, 
	0xeb33fd18, 0x48bc45f6, 0xcc7fddcf, 0x9855fb8b, 0xb759ef1f, 0x8c2cb6e9, 
	0x2cbb6d6f, 0x5461e30b, 0xf5ab7ce8, 0x9c12bac8, 0xb9466d8f, 0xf11f79b2, 
	0xe6e7d69d, 0xfceb103b, 0x5441fed0, 0xa177c3d1, 0x845da97f, 0xd19de94b, 
	0x5fa97cb6, 0x7e933d61, 0x2f889d6e, 0x2eaef690, 0xf3af85ef, 0xf2c45f1b, 
	0x85eed11b, 0x05c18972, 0xd32b7e7c, 0x7f392713, 0x9d71a4bf, 0xafa9f384, 
	0xe737d640, 0xbc4b1b1b, 0x4fb9ced0, 0x2155e7bc, 0x636bb75c, 0xb8f18096, 
	0x7b35fd6f, 0x5fd8ddb1, 0x3fd8cf9c, 0x318dbf94, 0xf6825db3, 0x6b275bab, 
	0x50a5f57b, 0x2ffcf9ee, 0xc060fde2, 0xffb8bd8f, 0x597e3eb5, 0xca61dfaa, 
	0xfb32fd4f, 0x76e7e899, 0x5bee3f72, 0x7acde50f, 0xea1ef85d, 0x4388a565, 
	0x160b80ed, 0xb0b685c0, 0x079aef45, 0xfd9962e5, 0x7ded3369, 0xc92f9323, 
	0x5db6eb73, 0xba7f3e74, 0x883db9ec, 0x5b09ad3f, 0x7dcef9c6, 0xde195a8d, 
	0x00afbbe7, 0xeef3b042, 0xc2cbef33, 0xf92c39bc, 0xe30c396f, 0x3b5422fe, 
	0xb5a7ec1b, 0x0ff1fbdf, 0xfb6b9fb0, 0x3de366a6, 0x03af10e1, 0x62f42a9a, 
	0xba6f0ff4, 0xf7815b4f, 0xc8164b5b, 0x8da5c5fd, 0x70e2ac32, 0x6c9607ed, 
	0xed6aef7c, 0xaecf52cd, 0x04bcb7bd, 0x3bea1bf9, 0x2b92dc50, 0xbca035f3, 
	0xffc8d9b6, 0x55d9c9ae, 0x37a843fc, 0xf8adf1c6, 0xe9e7e2be, 0x25d68a5c, 
	0xf7def96b, 0xeef5efda, 0xbbd6d6c1, 0x0f686d8d, 0xdcdbf25c, 0xa43ed09f, 
	0x147434b8, 0xa9f9e9c7, 0x60c7105f, 0x0aed067d, 0x5ea77ed1, 0xbbf8147c, 
	0x3f9075e1, 0x8bfe179c, 0x2e05ca05, 0xa19ba379, 0x9efad3be, 0xbdb253fe, 
	0xbdb9031f, 0x8a9bdef3, 0xf379c0af, 0x6f5fd7e5, 0x05b81c06, 0x7f61afbe, 
	0xcc7c66fa, 0x269bf102, 0xfcc15e03, 0x95f4dd6d, 0x23fde22f, 0xc4c33cf3, 
	0x7fd93bf9, 0xedf49d15, 0x667c9095, 0x900ef14b, 0xfb98cf83, 0x8a5b2305, 
	0x5dff21bb, 0x77829b61, 0x337d43c7, 0xc64ded84, 0xb941c7f9, 0x642e41c7, 
	0x4233b27e, 0xb62cbf7d, 0xd831f1c8, 0x8579a0ae, 0x469083d7, 0xf02b7b7f, 
	0x018aa5d8, 0x43ed1d4b, 0xfd423c91, 0x08eed18b, 0xb14735dd, 0x76fdf8c3, 
	0x77dfd481, 0xd0378816, 0x2f7b5aee, 0x5f8823e8, 0xe8e8625b, 0x09f688bf, 
	0x8cbd1fe9, 0xd1fb35ea, 0xba2c5eda, 0x903842a6, 0x2c3bd0af, 0x93f02f77, 
	0x4817873c, 0xd0458b3d, 0x03d15c2e, 0xeef7c215, 0x6a11c513, 0x16158cf7, 
	0xfe2ad3e0, 0x473c226e, 0x37ded358, 0xa18fbf83, 0xd97c843e, 0x902f1816, 
	0x8d03d235, 0x5c529683, 0x777c2f3f, 0x89c06963, 0x34ae7172, 0xc2a2e108, 
	0x0821654d, 0x573aab2f, 0x97a97e86, 0xabf26fd7, 0x974b8830, 0x80fbf39e, 
	0xa6d962be, 0x8a0a60a9, 0x6e7d3f2b, 0x8fe81faa, 0x5a69b3de, 0xb7abe800, 
	0x84169b9c, 0x6d769ff0, 0x78410f2a, 0xcae713cd, 0xfbae5e51, 0x150aa6ce, 
	0x9e2f65c2, 0x7f41f0ab, 0xa6daf13f, 0x57a022ca, 0xa55ce2fc, 0xbd4fe81f, 
	0x9fec89bb, 0x4fef9d1b, 0xb2bd020f, 0xf764b3f0, 0x7ef554dc, 0x88407895, 
	0xa59ff5d5, 0x2f4fdbfd, 0x03e03f7d, 0x9f65d6fa, 0x26e4519d, 0xfe40aefe, 
	0xf8fcbede, 0xc4f7940c, 0x5612df2d, 0x4b0a1bf4, 0x7ed1a1bf, 0x45f16d44, 
	0xd02fb825, 0xf4a8b3da, 0xc4daf0c3, 0xff1ed369, 0xa5b5f029, 0x9d03c24d, 
	0xf70e0097, 0xff0e2077, 0x5fe38bc6, 0x5161c49b, 0xcf1efe92, 0xdae1c61c, 
	0x960f0e24, 0x21b6fca2, 0xe95e230e, 0x06f1578c, 0xcf2e51c6, 0xfb176cb8, 
	0x734e38bc, 0xea2f62fc, 0x3538d19f, 0x963f5bef, 0x7a7137df, 0xdcf37d54, 
	0xa7bf17ba, 0xb1ce40d9, 0xdd0b713d, 0x04bc228f, 0x479e7b3b, 0xd8ef4adf, 
	0xcc6b7d08, 0xdfd7e695, 0x43f680b9, 0xf1de1f6a, 0xb3ffac03, 0x5cbef93e, 
	0x2fa864ed, 0xa8bdf88c, 0x56a6e504, 0xdca0948f, 0xa8bfddcf, 0x1b3ff914, 
	0x43de27e6, 0x11b71f5e, 0xc97a98fe, 0xf6c90bd4, 0xfcf898f5, 0x489f6c9f, 
	0x879c267c, 0x91efacef, 0xb275a0fa, 0xb4ff57b1, 0x47288bd4, 0xbe7037a4, 
	0xd2305ea2, 0x41f59ff0, 0x5b3ffdb2, 0xf0d3da20, 0x9befecdf, 0x28c9fee6, 
	0xfe92277d, 0xf07f7286, 0xa8cbc1de, 0x682fa47f, 0x1eff6a1f, 0x492a83f6, 
	0xc36d73d7, 0x7efc4edc, 0xdf86e510, 0xd9fb324f, 0x7a0fd666, 0x087689db, 
	0xda0f638c, 0x707fa011, 0xff405fbe, 0x9bf726b4, 0xea49eb32, 0x205f339f, 
	0x56bfa9bf, 0x5f3bbcff, 0x30df99fa, 0x0ebc3e1f, 0xf897a9e5, 0xac53720b, 
	0x45f1822f, 0xc926f17d, 0x68cf8d21, 0xc171a179, 0x47c94af1, 0xc907ca31, 
	0xba97da0d, 0x8ddf04a5, 0x29bdf531, 0xf20d9a1f, 0xcbf1a775, 0x520db71c, 
	0x9874daee, 0xd70fb88f, 0x30eeca36, 0xe392edf3, 0x51bf4c2b, 0xffde9f1c, 
	0x8d3cf8f9, 0xe3b186c1, 0xd6d5ea64, 0xafc9cb7b, 0x17abd5bd, 0xcefc001f, 
	0x1153fc85, 0x12d66c07, 0x96f03fbc, 0xb6e99e59, 0x44ff172f, 0xf5f3838c, 
	0xd61b17b7, 0xeb8f38d1, 0xee3fd00c, 0x78e5ff6f, 0xfe70a7ff, 0xc93f454e, 
	0x1e3341fb, 0x5ef80298, 0xfa89ed20, 0x5de97b67, 0x231fc700, 0x878c1e6a, 
	0x1cb1fce3, 0xb5d3f41f, 0x97dfbcc0, 0x89fcde79, 0x93bef285, 0xe30d3e79, 
	0x9071eff2, 0xb7587137, 0x57643be2, 0x68b8942d, 0xfb2b65e2, 0x3b5a3ff9, 
	0x6df711a1, 0xc02ec15b, 0xb72a0073, 0x4225f25f, 0xeea327e7, 0x89878a37, 
	0x529dfede, 0x57f7aeb9, 0xc4c9b9d2, 0xcefc4db5, 0x37ee85c6, 0xbae23796, 
	0xf79df1b0, 0x68143ee8, 0x3ef443b0, 0xf826104d, 0x55df284b, 0xf6d10ed4, 
	0x3df75a5b, 0xea8aba73, 0x6e50dd6f, 0xb038e795, 0xfdc95e0e, 0x37eea70e, 
	0xf7fc70ba, 0xf13ebf21, 0xd3d7ca3c, 0x801df28d, 0x02387c31, 0xfdf4807c, 
	0x637f928d, 0x11af30f9, 0xf2c6e9cf, 0xffd56fe1, 0xeffb32cb, 0xc4affe83, 
	0xff6411f7, 0xfd403a85, 0xc2a874be, 0x7da48bf4, 0x83e61bf9, 0xbef30925, 
	0x230fdce9, 0xaa3dfe74, 0xfecff5ff, 0xfbbd18f8, 0x6bde50b3, 0x436fd31e, 
	0xc6edfbf6, 0x75ff8d0b, 0xaf7ee77f, 0x2ab7ecca, 0x710cedfb, 0xd0cf07bf, 
	0xac9772fb, 0xf7ea8db4, 0xc16fd42d, 0xee8d18ef, 0xddc713b7, 0x449ffd8f, 
	0xfe2896ef, 0x7ae38f8b, 0x5e57c379, 0xe09473a7, 0x3457e942, 0x42221f86, 
	0x82fca1f3, 0xbf9ee1f3, 0x1b3a3f33, 0x91afafd1, 0x228a05ef, 0x61bc0f39, 
	0x48fe0e53, 0xcbeab072, 0x88fc518e, 0xde483f11, 0x608fccc3, 0xbea11f8a, 
	0xfbe29795, 0xf83ce64c, 0xdfbca361, 0xfdffa636, 0x5dce0f12, 0x5d761e50, 
	0x56fe0f00, 0x533c7ffd, 0xea34461e, 0xb41e727f, 0xe1e491fc, 0x547534ec, 
	0xd2e661ff, 0xf3a8f4be, 0xd13735e4, 0xeffb54f9, 0xdff8de79, 0xe3b665b4, 
	0x3c66ef42, 0xf8dce34d, 0xbdfc834e, 0x2a245f0f, 0xcc5601db, 0xf3ee784b, 
	0xdf86634c, 0xc9f9f30e, 0x18a5fe3b, 0x38d42cf9, 0xda479efd, 0x3f480d7c, 
	0xfd0aa340, 0x7f316700, 0x1a35af1f, 0xdf92df95, 0xfd83ef0f, 0x83f8f8ad, 
	0x2593c50f, 0xd9e37cf8, 0xe262b8b1, 0x57da92e9, 0x6b9cc71a, 0xe5aff7a5, 
	0x8fd0aadf, 0x321c6d26, 0xd93db7fa, 0xf11a37bf, 0xf6fe4af7, 0x87e5fbfd, 
	0x6613c9ca, 0x4bc946ff, 0xadfc5f4a, 0xcd1ce4e4, 0xa89ca487, 0x6ef7f311, 
	0x37fae35c, 0x03bf8ffc, 0x9dfe9e08, 0x9eefe911, 0xe1754792, 0xe0d78e87, 
	0x34af1a61, 0xaf18cd1c, 0x3def58ab, 0xf0b79b5e, 0x655e33ef, 0x2ed7090b, 
	0x71abf380, 0xc58c36bc, 0x78fdbffb, 0xbce3f201, 0xa7c77f36, 0x7ad9fa48, 
	0x671f26c3, 0xd51f387f, 0x9d79a37f, 0x7c19bf86, 0x71f24d6c, 0xcfbfc2c1, 
	0x485e6ebc, 0xfd017f72, 0xe3e4c5b0, 0xb7f13d28, 0x1627e3e7, 0x90a3e066, 
	0x4d04747c, 0xf0b0de3e, 0xedb1f143, 0xd347c49b, 0x47cd1b8e, 0x263f126f, 
	0x44c7e066, 0xea5b5fec, 0x6ce9e71e, 0xb9cf222d, 0xdfdcb70c, 0x1f912a36, 
	0x047fb8d5, 0x7befbda1, 0xb4aef8dd, 0x0a1955fd, 0xed0537bc, 0x47f295dc, 
	0x8473cb71, 0xd12539e4, 0xb9f3f72d, 0x22545c54, 0xfcc0bdad, 0xe34469f2, 
	0x5e98f9f3, 0x614efb8d, 0xeffc8faa, 0x4873dec6, 0xbd180bdd, 0x10746dcf, 
	0x11b7eded, 0x74901ded, 0x674949d6, 0x65a8520d, 0xfb3a4b0f, 0x19cf4c8c, 
	0x218e7491, 0xfd7d0fcf, 0x01bed10a, 0x949ee749, 0x8520ee74, 0xa4b0de5a, 
	0xf4c8cef3, 0xe74911fc, 0x2e899b1b, 0x205fa7e8, 0x24060a31, 0x1da4e13d, 
	0x5d1ee9fd, 0x2616f7c8, 0x37027df0, 0xf6bb639e, 0x7dc09ef8, 0x712ba04e, 
	0xfbc35f3d, 0xbde11769, 0xd4ff5805, 0x3b867de1, 0xcbd70f81, 0x3ecb9b7d, 
	0x2d978861, 0xc17fdce3, 0xfeef1971, 0x24c5c9cb, 0x7d4ffe7f, 0x8d39eff8, 
	0x4872ffbd, 0xbffd97b6, 0xee850c7a, 0x77f6f4bf, 0x6517fdd2, 0x61d439cc, 
	0xfaf6479a, 0x5613fbcc, 0x9afeeea7, 0xd6e7e595, 0xb84bef71, 0xe0b77fd3, 
	0x1777d0ed, 0x8a02fdf2, 0x5252681f, 0xfc4c3172, 0x7067bccb, 0xeefe4c7d, 
	0x98f39f10, 0xe3907deb, 0xf38fe40e, 0xd8ec8d71, 0xd64fe62c, 0xd9bc32ab, 
	0x493bdf29, 0xb7ac2797, 0x8e9b4eb7, 0x5bbd17fe, 0xc41f3bfd, 0xc2219ee8, 
	0x4fef7dcf, 0x2f8476a0, 0x7707a411, 0x4b5eecff, 0xe7922e91, 0x831a89f8, 
	0x2dd6a9df, 0xc3f9174a, 0xfea4bf49, 0xd00fba0a, 0xfdd1f463, 0x0d7f5700, 
	0xeae887bd, 0x0cfda12f, 0xef47c06f, 0xdd6da39f, 0xf7085735, 0x7598b1cd, 
	0x46e3bd1f, 0xfe8eff7e, 0x20cb651a, 0x5b5d1586, 0xffffd186, 0x7a5c72a7, 
	0x087ba1de, 0x4054db9f, 0x1fd6f37c, 0x7cf21229, 0xb53ce337, 0xec91df97, 
	0x9fcf2add, 0xc07ef97b, 0xb8912f37, 0x7f0e39fa, 0xafbf0979, 0x4df24b33, 
	0x905efde0, 0x2d16accf, 0x4f8efe98, 0x5fd312d6, 0x02f0b0df, 0xd0a1373b, 
	0x3f0cf83d, 0x9e5b977e, 0xe23eb91b, 0x5efb41db, 0xbf471eaa, 0xf69ac5f1, 
	0xab63ee1a, 0x6f6a3bf8, 0x0b0bfd12, 0x66eb3df4, 0x547bcef8, 0x8bfc95af, 
	0xef4d5dce, 0xab91896f, 0xa9dd623b, 0x66a136fc, 0xb2337c4b, 0xaf172e51, 
	0xa78429f1, 0x0edb3453, 0x692eafc8, 0x7f30b9b3, 0xf8e96685, 0xc8bf9cb9, 
	0xc8fd471f, 0x8bff882b, 0xb51f84d7, 0xb4785ca1, 0x4d47c20e, 0xc817f593, 
	0x33b58bfc, 0x047b60cf, 0xde5fd9fb, 0x8907eb22, 0xfb79d0f6, 0xde7219c1, 
	0x91eb5c0c, 0xffeca1fe, 0x4979f2d9, 0x1fe935ef, 0x287fa479, 0xecfa5dfb, 
	0x0757d25e, 0x5a24f7f9, 0x74caf3ae, 0x0ffb57d6, 0xeb86fa52, 0x9ade9ef8, 
	0xe3fe89b7, 0x8f4926b2, 0xf25d2c88, 0xc80b5def, 0x619e7b93, 0xa6ceef93, 
	0xf0886df0, 0xb97ecf4c, 0x12bc3c73, 0x5e2967f9, 0x5e40ffcf, 0x23e82d20, 
	0x5e0bd27c, 0x384c50a6, 0x6f09e921, 0x1d5f6840, 0xbd420eca, 0xd00f9441, 
	0xb58b9e7f, 0xfea08b9c, 0xedf75bac, 0xf7c4ea28, 0xa7bfc4cf, 0x2ac2778f, 
	0x18fc9dfe, 0x8c0002f1, 0x233afb9f, 0xa9f214b7, 0x8bbd1a9d, 0x945f8627, 
	0xbe0eb4ef, 0x12f1d968, 0xe0851afe, 0x4b7420f7, 0xa1c494ec, 0x247fc618, 
	0x3df3c11e, 0x477c23c4, 0x2e5372f6, 0x735ae347, 0xa6dae133, 0x3f6728ff, 
	0xdfcbefd7, 0xe2cb68eb, 0x3df20d7b, 0x7f1f1370, 0xbcd6f3c7, 0x258620df, 
	0xd28239ae, 0x5794ce5f, 0xff2313d1, 0x6c0b920e, 0x72720eaf, 0xb4a7ec85, 
	0x93f2746b, 0xf791af77, 0xaf78ec17, 0x9bf429e1, 0xed04b96f, 0x91b2cf31, 
	0xee9b90ea, 0x11efd039, 0xac2feea6, 0x85fde1b6, 0xefc25c4f, 0x9bffb0ac, 
	0x5642fd9d, 0x5fde625e, 0x86497658, 0xf0e504bd, 0xe99642fe, 0x4836d707, 
	0x7dee6ef7, 0xe9fa92b0, 0xf4166b0d, 0xe477c6db, 0xb10d77f0, 0x417f791e, 
	0x85a1d2e2, 0x64bea92b, 0xbf4166ff, 0xb3fed063, 0xbfa9410d, 0x3f3c4a8d, 
	0x3445bb77, 0xfe3d661e, 0x60678c18, 0x8997d092, 0xeb37bf94, 0xfd269f71, 
	0xc07b4c8d, 0x62aad3d4, 0xf835ef35, 0x84ff3468, 0x276d1f9e, 0x953bfe90, 
	0xe989ffd2, 0xfbfa3f1e, 0xefe42aba, 0xf1c61ce7, 0x137ac0db, 0x19c97bfa, 
	0x89cf0f8b, 0x07e18d9d, 0x469b9c70, 0x3ce8f916, 0x0d17ef18, 0xfee17eca, 
	0x0a175a84, 0xd930ffa2, 0xca766933, 0x7909fe98, 0xcbf6602e, 0xb5ef3561, 
	0xfeb8ce00, 0xb68cfef2, 0x79f1767b, 0x982ff51a, 0xffd33fde, 0xfb60f142, 
	0xe55b416a, 0x3d1f110d, 0x1eeb2f52, 0xf692c3b6, 0x8a14cbcd, 0xbe7213ac, 
	0xe921bd67, 0x9ffe736c, 0xffce7691, 0x66935d8a, 0x3bd254cf, 0x6e4e73a7, 
	0x64047be7, 0xfa1dbcdf, 0xefdfc93d, 0x1e68fc71, 0x3f4b731f, 0x277e4c8d, 
	0xcd5855f1, 0xfb447e7b, 0x53c68eb6, 0x65a49f7e, 0x7f133782, 0x9ab53c4d, 
	0x8ee32bfe, 0x345f9a47, 0xf299239d, 0x96454426, 0xb2d683f4, 0x0c63afd8, 
	0xce92135f, 0x9ce92b39, 0xebed240f, 0x93eab893, 0x4f722bb8, 0x0df73a48, 
	0x490de749, 0xe9212f3a, 0xdf8708bf, 0x25c6f39b, 0x72cbe7e4, 0x49de1faf, 
	0x8168a7bf, 0xdffb8889, 0xc7cf7e63, 0xaf110f3c, 0xf0bc79d1, 0x8b75a21f, 
	0xaeedfb8a, 0x0edf7bd4, 0x6ad75380, 0x2ad3e77c, 0xf1e69f72, 0x57669b39, 
	0xe9f90bcd, 0x3c9fc5fc, 0xdfc4c9af, 0xb7841581, 0x4be61af3, 0xf7b9fefe, 
	0x37bc5e0a, 0xd9015ee3, 0xbda12f93, 0x4df82d09, 0xbb4dceca, 0xbbb84a37, 
	0xef93a07b, 0x9c279d27, 0x8fb273dd, 0xf9d927ee, 0x6f096177, 0x8c5f3bf1, 
	0x9e7f2355, 0xc8cfb454, 0x458d0d77, 0xd6d34bdb, 0x44f7a537, 0x7677ee33, 
	0x77ef2b3e, 0x44c32a3e, 0x19c7699d, 0x2c532f74, 0xf6127d7f, 0xf219def3, 
	0xfd36ea9d, 0x34b7dd38, 0x958ce4f9, 0x7ae3efd3, 0xf7ba3e82, 0xbca4faef, 
	0x558ce9c7, 0xb854efd3, 0x73aed2fc, 0xefe58ac6, 0x95aac551, 0x8ed1872d, 
	0x77a26c2b, 0xced24364, 0xe9cac573, 0x8dd733bd, 0xee9522a1, 0xe5fa676d, 
	0xea57bbad, 0x458b7589, 0x4e56efc6, 0x377e926d, 0xc3f42073, 0x65e75afc, 
	0xfd0adc7f, 0x9b5ef925, 0x065ddbd1, 0x3fac9df1, 0x831a2202, 0x4935d7f6, 
	0xdbeeb43d, 0x7bcb1e32, 0xfeb3d3c6, 0x01fbe5fb, 0xd17f0db5, 0x66b791fd, 
	0xbbbf8d43, 0x0ac1eff0, 0x7377a0bf, 0xa5da15af, 0xe5635d23, 0x2fa975d4, 
	0x0d41cf2a, 0x6873173a, 0x1b5b0ed2, 0xf88e3eab, 0xdd1dfc99, 0xbff8c417, 
	0x7e4a3ba3, 0xaf3df9ad, 0x05d9f9d3, 0x27b7477f, 0xc85c1f43, 0x4eb534bf, 
	0x400af796, 0x3fb03a9e, 0x6823945e, 0x1951f797, 0xcaf7eea6, 0x341880f5, 
	0xb7128e48, 0x874af7cb, 0x3bd215a6, 0x0fcb2adc, 0xd1f1378e, 0xbfbe1b94, 
	0x80dca2a9, 0x9575917d, 0xe3f42b94, 0x9430fda2, 0x383bf92b, 0x0ab94692, 
	0x1ea8bf13, 0x20d3ca27, 0x244dd9ca, 0x474b6d67, 0xce1db08a, 0xad7ca5ab, 
	0x837fd12b, 0x35d65ef7, 0xf6cfff86, 0x8c6e5087, 0xf294ed9f, 0x97eb72b2, 
	0xbd63fca4, 0x0f30efe6, 0xc26d6bcd, 0x1efe6779, 0x05ef93b3, 0x79cafc82, 
	0x3bce47b7, 0xe81dbfd0, 0x2c5de657, 0x6437aef5, 0x7fa41fae, 0x671df27d, 
	0x0d9dfcbb, 0x53fdf2f5, 0xea0e77e8, 0x9c0a5343, 0x2e6c0748, 0xc5515fa8, 
	0xb6bbb464, 0xc67b4935, 0x05ef33ef, 0x8e75936a, 0xc9c9f3e7, 0x7c0b17e4, 
	0x0589dfc3, 0x1916c7bb, 0xeda65f6f, 0xc55ef293, 0xa17f0586, 0xfe256f1c, 
	0x018e505d, 0x7e3de8aa, 0xf3a5e7f6, 0xbeea5757, 0x1bbf4a57, 0xe78bbfe4, 
	0x122f78b8, 0xe53551e5, 0x3fe5cc39, 0xd4eb929f, 0xe4a35d3b, 0xf115407a, 
	0x53fd3934, 0x7dad0bbf, 0x80b720da, 0x85f3c90b, 0xbc5f6bde, 0xff472b58, 
	0x9315fdaa, 0x3903e87f, 0xbbd6ee9a, 0x6f81f0e3, 0xe8f7c936, 0x6a3bf056, 
	0xf2b46a2b, 0x8b47e85e, 0xfb700a2a, 0xfc9368e1, 0x510c189d, 0x7be36c9f, 
	0x86ab17e8, 0xe6477f07, 0x755aafaa, 0xad99bfba, 0x0fffa395, 0x75c4edfc, 
	0x62d955c1, 0xea0d0ee7, 0x71f243bb, 0x2f151ddb, 0xad487ee3, 0x5fd17baa, 
	0xc239e3fa, 0xe83defc0, 0xe2f5a635, 0xb6971b38, 0x7ce4baf7, 0x6c6daa7c, 
	0xa2ef92bf, 0xf7a52f38, 0xc0f0cd46, 0x472e6f27, 0x6d915df9, 0x3fa0eb94, 
	0xe42bb5b7, 0xa7e2b1ff, 0x0e5133b5, 0x5f7681df, 0xd8adf509, 0x75a2ac6c, 
	0xf806180b, 0x36af547b, 0x15ce73c9, 0x38fbdaa5, 0x0a2a1e6f, 0x0e50fcbf, 
	0x8e1ffa86, 0x9550822e, 0x90f84bbf, 0x7eeb6c2f, 0xb7c04211, 0x0f71a007, 
	0x77f78c05, 0x79643d4a, 0xdb634be8, 0x0a8af713, 0x7ec1d7f4, 0x3bf87045, 
	0x3e71ca87, 0xe56af7ed, 0xd0f06fe8, 0x57b3ce9a, 0x71b979ca, 0xf866f2bc, 
	0xa4dbf30e, 0xfa802c1f, 0xd1f363e2, 0xe217fe77, 0xe3d72709, 0xd027e9b8, 
	0xc7ff62df, 0xf71dfae4, 0x4dbe785b, 0x85f479c7, 0xb51f3b96, 0xf7c9fe10, 
	0x926fde3f, 0x7c914deb, 0x1aa8c407, 0xff3f7081, 0xe4ed7aee, 0xc1f29bf7, 
	0xf9363c9e, 0xa7ef137c, 0xd5e70afd, 0xabae1ba1, 0x683a9c46, 0xeafc1ff3, 
	0x50bf9003, 0x03ffcbca, 0xd9787eda, 0x0003aa31, 0x7dbd9c78, 0xd5547c0f, 
	0xc99dff95, 0x18849924, 0x81809326, 0x4cc867f2, 0x0eb44842, 0x94012a09, 
	0xff204847, 0x81511188, 0xd7101da8, 0x594dac14, 0xd6bb52eb, 0xbf902137, 
	0x04a024c0, 0xa0236ddb, 0xfe089250, 0x5dbb15a1, 0x740b881f, 0x6b582ed9, 
	0x0bfb75ad, 0x04ff1318, 0x236ea917, 0x7cefebb5, 0xf32fbdcf, 0xbb680927, 
	0x7a3e7cdd, 0x77ddefb9, 0x9ee7b9ef, 0x739cf77f, 0xa22108ef, 0xfd046702, 
	0x62815169, 0x60547a94, 0x2a234a05, 0x0b084270, 0x5abeabfd, 0x85a3bd88, 
	0x3c1efeb1, 0x037f2e17, 0xf8eab7bf, 0x0d5c2ece, 0xc3bf5df4, 0x50dff42e, 
	0xe8435efd, 0x75c5ea7e, 0x7ea7479d, 0x110aa546, 0x58dee543, 0xae1dfefa, 
	0x6a2e311b, 0xf1561017, 0xb59f2a1d, 0xc78e3d0a, 0x854f8ab7, 0xa116eaf0, 
	0xa9fdff53, 0x3b7e84e3, 0xbea3ef8d, 0xc3615878, 0xb1e10178, 0xb7b519e1, 
	0x1c30b71d, 0xae7e53b6, 0xeb21bf47, 0xead718d1, 0x8208d40c, 0x5bad1acb, 
	0x7bf3d40f, 0x4b9d80f7, 0xcf1e71cf, 0x79e29cf0, 0xc86fe968, 0xcb11ba7a, 
	0xb9c709f5, 0xaa9c2634, 0x37c4fae3, 0xb7627d64, 0x5de93f7c, 0x5e749f59, 
	0x203c9fbe, 0x5f0193eb, 0x8dd476bd, 0xfe8a0171, 0x6efb1080, 0x85bef83f, 
	0xa77d3f9e, 0x704fc6be, 0x3d1d4536, 0x4422df5b, 0x45854fd9, 0xfe2216ef, 
	0x795a3b27, 0x0bda2972, 0xfc579a7e, 0x17ad974f, 0xa90d109a, 0x03e008d7, 
	0x106cd720, 0x925840a2, 0xb885bbf4, 0x3565b9ee, 0xfddf01a2, 0xf6a09f76, 
	0xb2cef765, 0x8b7e085a, 0xa1f53c5d, 0x6e71fbc0, 0x892ff341, 0xc7e977d7, 
	0xd5b241e9, 0x6514fb62, 0xf846c58d, 0xea735a6e, 0x1a7820ac, 0xef5b5e4a, 
	0xae6c7ea5, 0xb6df5aff, 0x16e6a502, 0x02d25027, 0x536210ec, 0x1f584391, 
	0xc1316215, 0x885e7d92, 0xd04f962b, 0x90fcdf51, 0xe9cfcb83, 0x4223e36f, 
	0xa9f7a72c, 0xee32c1d5, 0xa7cf8259, 0x7eabf1c6, 0x163a6e88, 0xf30fbabf, 
	0x75b8bcdc, 0x4a8fde17, 0xb658ac30, 0x5b8712b8, 0x90a2138c, 0x0f5577be, 
	0xb46cb785, 0x52f015f8, 0x19b88570, 0xed4f9bf8, 0x2db5e104, 0xf9e06441, 
	0x87adc026, 0xf1b3edc0, 0x162eb478, 0xd9a5e13f, 0x6e8e2c2b, 0x2e834fd9, 
	0xfa6069fb, 0x98f59dd6, 0xd3ad557f, 0xdf52f541, 0xcd162751, 0xd074231e, 
	0x75f9fd29, 0x96e10fa6, 0x5a59ae74, 0x44713f08, 0x7fd435ae, 0x35691bf3, 
	0xe176c74c, 0x5734bf07, 0x618e5eb8, 0x939e14ba, 0x8a656e34, 0x6697e010, 
	0x410afb57, 0xf91a96ed, 0x65da2f1e, 0xff30bbb6, 0xf1eadd0a, 0x7477bf52, 
	0x44bc78d7, 0xcf9d772f, 0x90aea4f7, 0xdfaa54f5, 0x4f11eef9, 0x166fbd2a, 
	0xcbdb7716, 0x64db4442, 0x0957a07f, 0x56fe9e97, 0x15b7a283, 0x0ddfafc0, 
	0xb52b69ba, 0xf1a4e93f, 0x76dfe96b, 0x453d93c2, 0x7f25fba4, 0x2c7cd5bb, 
	0x751f542d, 0x42dd2f87, 0x4b1dece3, 0xe7947df3, 0x17186961, 0x5766d75c, 
	0x055457b7, 0xacee38e9, 0x806b4af5, 0x95da12e0, 0x0d3e54b5, 0xef918d3c, 
	0x9edd689b, 0x618f7f06, 0x805a3ab8, 0x9df5abdf, 0x1a212281, 0xcebd639b, 
	0x73b8f0ef, 0x4f257078, 0xeb17bf1a, 0x7d73f2b5, 0x58dffe36, 0x8dd550b5, 
	0x98e7ae3c, 0xeb1b2d75, 0x9eb57e5b, 0x3ede13a6, 0x61d87eaa, 0x585fb2a3, 
	0xc0dbf5aa, 0xbd1fd4f5, 0x5b9fafef, 0x77436e2d, 0xf4605973, 0x6af553af, 
	0xfaa2af55, 0x299f54eb, 0xe6a78deb, 0x9fa95965, 0x5bf42bf2, 0x5efd8740, 
	0x06eabed5, 0xd626d606, 0x67dd6366, 0xd6ad3d0b, 0x3745f7a0, 0xe62befc8, 
	0xc01e7308, 0xd523974b, 0x105ef756, 0x379be31e, 0x7fd47588, 0x89a9d69d, 
	0xfbf1056f, 0x518f5a53, 0xb1e547c4, 0x4ef5eeb6, 0x45387f2a, 0x23e10a8f, 
	0xfbd3b7bc, 0xe466551e, 0xb3e01926, 0x6c68e2c9, 0x4c42dbfd, 0xca304124, 
	0x983ddf43, 0x077d8573, 0xf905c5e3, 0x2cc9f420, 0x315dc52f, 0xa5feb74c, 
	0x27c6c413, 0xdabeaca8, 0x4875a166, 0x9ce10875, 0xce25f041, 0xdafc3171, 
	0xffff9e1c, 0x0eb438c3, 0xb5c2b505, 0xd3b72cfe, 0xe383bbac, 0xabfd709a, 
	0xaa57e782, 0xe35d92fd, 0x107e404f, 0xab2ca73c, 0x9740fcd4, 0xfc03082f, 
	0x582a2a26, 0x9b0c396e, 0x1867cb84, 0x6efbc790, 0xbd07587f, 0x47f54efd, 
	0x0f5cfa98, 0x98feb7a1, 0x8d7fa17a, 0x26d65b40, 0x8e489b6a, 0x1da53f3d, 
	0x8cd7acfc, 0x64b37963, 0x7d84f3a7, 0xae371c85, 0xa0e1c247, 0xb82b8fef, 
	0x0ab58a50, 0xf7fa7eae, 0x5e47eeaa, 0x86d741d6, 0xde11dfee, 0xaa0dd1ff, 
	0x6a5fad3d, 0xe818dcf7, 0x7cf9ffa1, 0xf5458d2e, 0xd5863775, 0x6f479dfb, 
	0x5c287491, 0x07850836, 0x24b5f1ac, 0x5e12264f, 0x3daf08a3, 0x3f3157a3, 
	0x1e710b97, 0xb81828f8, 0x37f30921, 0x8abac7bf, 0x2786498f, 0xb65976ec, 
	0x6ecfbfa1, 0xb20c55b1, 0x142ca883, 0xa4afd6f3, 0x1d95adf2, 0xb5d7f082, 
	0x9492ee7a, 0x93365976, 0x303d28dc, 0xaf89584e, 0xbabe56ca, 0xac7ccbcf, 
	0x81399e5b, 0xac0fb842, 0x00e6f290, 0x3cd375e1, 0x30fcfd82, 0x33aecbf2, 
	0x22bcb3bf, 0xf94d4bb8, 0xe5f53555, 0xfca0f698, 0xf8b0f5a2, 0x90739fa9, 
	0xb47df45b, 0xc168c8e7, 0x80b0cdf2, 0xd18e599f, 0xacb7b6f7, 0xb36f9889, 
	0x9798e497, 0xb6625ee0, 0x512c59f7, 0xd55ec442, 0x7cd0b16d, 0x3b53c06c, 
	0xe227e79e, 0x3e99e6bb, 0x72c03887, 0xd57c1d34, 0x8e9d6d5c, 0x90e7a27e, 
	0x69b9669c, 0xa1e2f478, 0xc94cad72, 0xf16582b5, 0x9e7a4ee9, 0xebb15fe1, 
	0x6be7d25a, 0x6bc25f30, 0xbb56b7f9, 0x6d7ea873, 0x01dfd7d7, 0x5c7b47bd, 
	0x072f2cbb, 0xbc466fe5, 0xa0c836f6, 0x07294aec, 0x28370e59, 0xc942bbb9, 
	0x37e7c261, 0x15fd49e6, 0xf44b3903, 0xe49e6d36, 0x26fa41d7, 0x67bb6796, 
	0xf0493904, 0x4de7413b, 0x4ebf3651, 0x906e56df, 0xf95b6aeb, 0xadc1eb2a, 
	0xfa992cf4, 0x6ed81f6f, 0x5db7fcc1, 0xc3feac21, 0x7257ec42, 0xe224ed9d, 
	0x35927edb, 0xbb4ca3b0, 0xd636eac7, 0x4ef47deb, 0xe6d67eeb, 0xe113f652, 
	0x82607ed3, 0xed483988, 0xf6f0f6ed, 0x4ffa1f04, 0x8c28e75c, 0xf2df7295, 
	0xa6790e96, 0xe13e00d5, 0x69f88ed5, 0xbd94d6be, 0xbe7a4cd6, 0x13b2e096, 
	0x7d33ad1e, 0x4988fff3, 0x823c6eba, 0xe7123676, 0x5ae68f58, 0xd0798191, 
	0xfcf256fc, 0xe8256335, 0x9168df61, 0x9f5827ed, 0x33247ee8, 0x8e3a5f94, 
	0x3a3e9858, 0xc34c3672, 0x96155957, 0xe763ac0c, 0xe683b212, 0x678a9eb1, 
	0x199de0fb, 0xfd2f407b, 0xfb5fcd0e, 0xff1d84ba, 0xd483ca0d, 0x22f3611d, 
	0xa7ac697c, 0xe8364406, 0xec89b459, 0xf6c11386, 0xe4f3df4f, 0x55d90b1a, 
	0xf40af4a5, 0xfeaa6fbd, 0xfd85ec3e, 0xe8364609, 0xfad1e9eb, 0x0df39007, 
	0x134d6f4b, 0x643d4149, 0x78e957f2, 0xe92f63ad, 0x8fb3aeb5, 0x7cd26474, 
	0x353c046e, 0xa0682f6c, 0x8ff773ef, 0x09899ad9, 0xacd9680d, 0xecb4dadf, 
	0xcf3b1086, 0xbeeba384, 0xe32d9327, 0x4de6f482, 0x9a7edcd4, 0x0f7d5dc0, 
	0x520dec79, 0x838ec39f, 0xc7bf077e, 0xc692b4d8, 0x695f4c75, 0xaf5e2e0d, 
	0xfdbf58a9, 0x6acf78ff, 0x9e7e09cb, 0x553ffa81, 0x0b31e37c, 0x9b56a8f8, 
	0xcb43d72a, 0x46407650, 0x53ebd4bf, 0x3e5da407, 0xb8b7eb15, 0x600fd5f5, 
	0x4f1e1dcf, 0xc26df8d4, 0x63afa27b, 0xdfb73c67, 0x69a074c6, 0xd58a5bab, 
	0xfad4063a, 0xebf5fd24, 0x949e7cb1, 0x85d643ab, 0x7cf012f4, 0x4aceaaae, 
	0xa9d7895d, 0xafe274dd, 0x7996b46b, 0x8bf023e2, 0x8079ba5e, 0xf5d569f1, 
	0x4ec1bee0, 0xdae62332, 0xdd589f20, 0x1b1e875a, 0x82ab13e4, 0x06e079a7, 
	0x35dca877, 0x6ab124f9, 0x74ec614c, 0xf721cbcc, 0x097f6827, 0x9e69787e, 
	0x8b849bb4, 0x7c5741f8, 0x3784fd80, 0xe27e88f1, 0x65a0fc52, 0xce2fb5fb, 
	0xf7c05d0f, 0x1f9cbfe1, 0xda27fe9e, 0x797d244f, 0x7d61f77a, 0xe82dffce, 
	0x432fdfec, 0x871f8467, 0x17cb779a, 0x800be79f, 0xbe706d77, 0xf5a28dd7, 
	0xf96bb2a7, 0x08e10ee2, 0xced5bbe1, 0x4263c4ab, 0xcc2fa81c, 0xb8a24da6, 
	0x7ec5cef6, 0x1ad175e0, 0x575fd3aa, 0xdfad9691, 0x5baea54b, 0xd65d3f41, 
	0xbd00ec7f, 0xee7e7c98, 0x3efa8736, 0xa37e8fda, 0x7dfc02d3, 0x7da9da74, 
	0x5bbae400, 0xba97dfc2, 0x72435f68, 0xadf56621, 0xee7f781d, 0xa476b79b, 
	0x17e2de12, 0xf8946ed3, 0xf0de3e3a, 0xdcfd51b7, 0xa5f6a775, 0xee5780ea, 
	0x8f963a9f, 0x3e4978b1, 0xc42f9d5c, 0x5b0f5a38, 0x82f98d91, 0x00cfacfe, 
	0x7dd5ba5f, 0x4787ae40, 0xf58377ea, 0xeb87da3b, 0x37f79d77, 0xacac8fa4, 
	0x1f7e959f, 0xfea5bfaa, 0xeb36f537, 0xfa83bbe9, 0x76aae63f, 0x1acdd7d6, 
	0x885773e9, 0xbe92f6be, 0xa6efd10e, 0xc7fde73e, 0xb7f4e18a, 0xb7f52e9e, 
	0x0fba1e91, 0xf5097de6, 0x759e9057, 0xa6e8858f, 0x93dc7a74, 0xeb2d91d7, 
	0xeee4a07d, 0x33b7a419, 0xef1e95f2, 0x8635dbca, 0x873b13e6, 0x857f25f6, 
	0xf134cf1e, 0x78417904, 0xa8faa34d, 0x8f40bfea, 0x59f5f9af, 0x58dc7ac1, 
	0x7f00d8f5, 0xf9f216b7, 0xbb75ca8b, 0x7257af4d, 0x0a7d7dfd, 0xf935dce4, 
	0xfca5efe2, 0xd91b5d83, 0xaeb82daf, 0x2e6fccb1, 0xfa0dd78d, 0xd0667a1b, 
	0xec6cd6ae, 0x4b45b12f, 0x74c964bd, 0xf63ac3cd, 0x3960757f, 0xb252cfaf, 
	0x49fe09c3, 0x6b3cd72e, 0xd31ff737, 0x637ee7e3, 0xa68ca9fa, 0xebceac7d, 
	0x0fd16225, 0xad8a477f, 0x78e4f098, 0xfd8bc780, 0xbb0bdb8c, 0xbf6ec43f, 
	0x2d1ebda4, 0x8fdb0ce1, 0x11d63da0, 0xd89411fb, 0xf49f608f, 0xfb6199d5, 
	0xfa7ec890, 0x05cb0545, 0x7754e149, 0x66d7f4cd, 0x8dfdc188, 0x8359af68, 
	0x5f9e9bf5, 0x613e2f99, 0xde59c5ff, 0x2ddaa79f, 0x75037f4c, 0x9c10b7ef, 
	0x1f73b0d1, 0xbe38bd95, 0xa9ab8413, 0x077e07f2, 0x7ceeffe1, 0x31886fb9, 
	0x1c2ebae1, 0x0fd889ae, 0xa13f3d91, 0x90c7b442, 0x251d1f9d, 0x89d9c80c, 
	0x86a31615, 0x215f49f6, 0xfb451275, 0x610e0990, 0xedcf3d44, 0x82ab517d, 
	0xbaf1adfb, 0xc64f463f, 0xd1ce487c, 0x100ad0be, 0xb178836a, 0x1bac3854, 
	0xbba8bfa9, 0x21babd68, 0xd320899f, 0x60638fd9, 0x1f78c2ff, 0xe53f1437, 
	0x13b7dedf, 0x9be9affb, 0xbaf3719f, 0x63762d5c, 0x40e26d3d, 0xd8dfe612, 
	0xc225fb48, 0x95da4f53, 0xb5fb04bb, 0x72eb1384, 0xeb92e094, 0x9fa139a2, 
	0xf6435a0c, 0xdbbf45bb, 0x70147d02, 0x1ba5dd2e, 0x0d38df28, 0xb93594bf, 
	0x4cfc34ed, 0x377513d3, 0x7aec4bfb, 0xb98de41a, 0x03c0f4fe, 0xbb7f97bc, 
	0xb63d0dc7, 0xfa70c0a5, 0xea81fe69, 0x66f8371e, 0xd658f9cb, 0x12af9b4b, 
	0xbcf89d1e, 0xfb8f6d7f, 0x7033f466, 0xfa887dcc, 0xe79a9c09, 0xbd2eee81, 
	0xfbc56b4a, 0x88f47fd2, 0xdfb077a8, 0xc25a9e16, 0xcfc5f17f, 0xab6e0277, 
	0x17c5cf92, 0xdc05691f, 0x5a45fd66, 0xc605ef3f, 0xc11b4b67, 0x8534b451, 
	0xe82d85ed, 0xa22fe08f, 0x19df1b37, 0xc3b70fda, 0x94b36b7a, 0xaf16603f, 
	0xfdff6477, 0x3f9473f5, 0xc103d241, 0x8a9e01e7, 0x49f1b2a8, 0xc96603f8, 
	0x8c59def7, 0x34292de4, 0x93e14fae, 0xd678a1d6, 0x1f21a79b, 0x2ec65903, 
	0x444b6fcc, 0x4e4545ff, 0xa1f5f311, 0xebb64470, 0xdf27953f, 0x116ec1bf, 
	0x61bcd061, 0xbf8e455f, 0xa76bf569, 0xfb225721, 0xe4479c8b, 0x4356fd77, 
	0x648fffe8, 0x4a6c63a4, 0xbeb958ed, 0xe89cf9bf, 0x83ee4128, 0xc834a3e8, 
	0x780fcda1, 0x5f24493c, 0x8fc68dff, 0x0f79be23, 0xfa0c7c70, 0x77983cd3, 
	0xd33776a0, 0xc7ad6363, 0x73723b03, 0xaec0f082, 0x25903c0c, 0x1f0e48a2, 
	0x24c9f6a3, 0x62d81797, 0x945de2ed, 0xcd473e52, 0x05acfb97, 0xc3e6af39, 
	0xcfa8325f, 0xddf87bd5, 0x3b64e302, 0x7347fb8c, 0xf903c85c, 0x07de30fe, 
	0x2d38f01e, 0x2945e344, 0xdb275b86, 0xd7a1e5b1, 0xd80ec176, 0x5e39bdf2, 
	0xbbf435e8, 0xb69dfa87, 0xcddbea4e, 0x3dfbba09, 0x52ce43b2, 0xdfa82b7f, 
	0xcd5bf45e, 0x77013b70, 0x31bb8291, 0xa06b4f41, 0xf7a5df7e, 0x39e70449, 
	0x718b5bb4, 0x0afc370d, 0x73ce47e8, 0xca859a77, 0xf8d23bc6, 0xf7295a3b, 
	0xb7fef413, 0x7d1a7ed4, 0x57798457, 0x1d7894a1, 0xfde737c8, 0xdfec3e51, 
	0xa03de691, 0xdf391df0, 0xc601fcca, 0x3db316d7, 0xa27a81c9, 0x3d14c6fb, 
	0x3f889ead, 0x5db5f8b0, 0x9bc480f6, 0x72d9c683, 0x3335e2f4, 0x796f9f49, 
	0xb3dd955d, 0xb6c933bc, 0xb4f453ae, 0x63ac82e5, 0x7fd4fdbd, 0xfdea4da3, 
	0xdeec0fcd, 0x305dbd06, 0x5f986370, 0x23c3e883, 0x4be913f5, 0x5f349f7a, 
	0xd6ae75f9, 0x02ff8277, 0xfff80758, 0x0dd94a1e, 0x9470297b, 0x0371a7fa, 
	0xfbb2abaf, 0x702f1e21, 0xc6059641, 0x84ec2f11, 0x8c8ec7c5, 0x28eec1b6, 
	0x6e3f668a, 0xd1d6cbe1, 0x2f17da36, 0x60d8d53b, 0xf978fb25, 0xa4b759d9, 
	0xd3751c92, 0xfb823e78, 0x4c5e3fce, 0xf9666382, 0x21a739eb, 0x9036bf17, 
	0x2dff04ef, 0xb034ef5d, 0x5335a4ce, 0x0d6e0952, 0xb6bd2333, 0x5e14db6c, 
	0x72f9ac9f, 0x9e1ecbde, 0xe4ee41a2, 0x3684fa88, 0x388d7f7a, 0x292daa3e, 
	0xf34cfbfc, 0x3efc117b, 0x42bdbbf4, 0x63fd877e, 0x06918141, 0xcbe979bb, 
	0x7e41b7e3, 0x935e3b2e, 0xd30d4370, 0x69d81acb, 0xa4d46f95, 0xf99cbe01, 
	0xafecff52, 0x236f9dcd, 0x97cee5bc, 0x94ac77f4, 0x15cbf0ea, 0x43f46e68, 
	0x49fba5fd, 0x91ce5418, 0x49d26374, 0xa51efab5, 0xcf0a7e17, 0x19379678, 
	0xdcdc3af1, 0x48c129a2, 0xc8ccbb63, 0x1db9075f, 0x7c7e87a9, 0xa4b3c907, 
	0xd8885f20, 0xedfc077c, 0xfbf95966, 0x2dc42c9c, 0xd1cec92a, 0xaa07be49, 
	0x2a8cdf24, 0x9e785924, 0xf09597ed, 0x079fd263, 0x8236f6fa, 0xa9e08923, 
	0xa9ada49c, 0x28f24a3f, 0xd9b93f55, 0x6037e5c1, 0xebb26fc3, 0x4d986102, 
	0x5acff68e, 0xdf6fc216, 0x7c246fee, 0x4e34ca6f, 0xc83b4ab6, 0x50c4f4da, 
	0x23900238, 0x011f353e, 0x8dcab339, 0x7c4bde75, 0xa6cb3f07, 0x4ad7daea, 
	0x78f59da4, 0x9bdf30c3, 0xe3f7e325, 0x8529bd60, 0x6d0c0bfa, 0x0dfce3c7, 
	0x5f190f9e, 0x242cafbd, 0xff859e3c, 0xebeb2cef, 0xb0e7ab2d, 0xfc250fff, 
	0x77118b7f, 0x24af75a3, 0xd683ba3d, 0xcfd487eb, 0x9b7bd274, 0x63de7fee, 
	0x933e01d9, 0x5f795ffc, 0x0c3c7d38, 0x78f5a0ba, 0x654ffc04, 0xb7297cdb, 
	0xf4373be8, 0xf7e532c4, 0x3c2a9658, 0xafb1bb7b, 0x5bb57632, 0x3d7397c0, 
	0x57fb2199, 0xdf49977c, 0xa562fff5, 0xefd10a7b, 0x6eb58da6, 0xfcb641f8, 
	0xf21bb9c2, 0xb204d375, 0x3be95b83, 0x62c6bfec, 0x1b8af47f, 0xd77d17cf, 
	0xd7be61e6, 0x0f6c0e49, 0x7be9b5c2, 0x06ddaa29, 0x7dd7cf96, 0x7347acd7, 
	0xd79a817f, 0xf9b7efd8, 0x616ead17, 0xadc738d0, 0x3d36072c, 0x9e71cb50, 
	0xf8d20f4d, 0x9b7f6081, 0xd338e42b, 0xabc71b74, 0x35de09da, 0xe67b9f44, 
	0xe43e60fe, 0x02fde323, 0xa1a6d5da, 0x1e1427ff, 0xfc810f10, 0x86ea7926, 
	0x71569bbc, 0xaaba03d4, 0xbae48abc, 0xe25cfa05, 0xcfb50f73, 0xefc41f3d, 
	0x3d4be7cf, 0x23f949b6, 0xb2d855a6, 0xddafb485, 0x4fafea01, 0xaad6c1f1, 
	0x69df8c19, 0xe59dae34, 0xe7aec8a4, 0xaeee9afd, 0x9fdaa15f, 0xf216f290, 
	0xf418f01c, 0x55fe91be, 0x0a75df43, 0xb327afb9, 0x20df53d0, 0xd8840ce1, 
	0x0f889bdf, 0xd10ab6a2, 0xcd36a4ba, 0x117ff341, 0xdae091fa, 0xd0f1215a, 
	0x1e878837, 0x9fa6c3c6, 0xf909d8ec, 0xb5bbc260, 0xdbe18522, 0xf6eb56da, 
	0x5dc6857c, 0xe941e29c, 0x3ccefe20, 0x9d83e12f, 0x7da759ba, 0x71c861dc, 
	0xe11b73c2, 0x631f6845, 0x69fa635f, 0x753a784c, 0x1e7a1f29, 0x75774da9, 
	0x05db3d73, 0x24f490bb, 0x1e696dc7, 0x77f51d7a, 0x5b4dd6a0, 0x5c47ea67, 
	0xda181d68, 0xa9d9644f, 0x784cdce0, 0x7ae6ef6b, 0xfc02cbb6, 0x86b69f1b, 
	0xf579b1c0, 0xdf3fb50c, 0x79bcebc0, 0xae930ccd, 0xf8d21d14, 0x1977a0a9, 
	0x6e800a47, 0x1467bbe8, 0x7f76365f, 0xdbf50eee, 0x7a49d604, 0x72995e69, 
	0x910b8c48, 0x1eb7f493, 0xe3b3c276, 0xf7007f4c, 0x71b9f9bf, 0xb9dff461, 
	0xa06dd1f2, 0xd4ba2da7, 0x47805b83, 0x0aeb23d8, 0x853aff98, 0xfce63ff6, 
	0x5b76e7d1, 0x61fd4b7b, 0x340e9fd0, 0x6feed953, 0x7465423d, 0xc5e20c4d, 
	0xa4f41b95, 0xadce522d, 0x7d51a7f6, 0x2ad9c895, 0x1babe6e5, 0xf6f10a76, 
	0x3d2ae275, 0xa49c8f94, 0xc6ae0987, 0x892e8f07, 0x58d27926, 0xedab7796, 
	0xb876b514, 0x55c6a3f8, 0x431adc57, 0x9a23eb8a, 0xa0e3e5bf, 0xe0f8d31d, 
	0x32624b5b, 0x7c65c721, 0x9671684f, 0xaf407617, 0xd02fc388, 0x64059dfb, 
	0x78e5ae5a, 0xe12665b1, 0x14e81965, 0x9c516276, 0x6c9c7ea5, 0xd9daaf57, 
	0xd9bb3b55, 0xb279e88e, 0x8f0bb45d, 0xae1c3310, 0x3c40fe5b, 0x6fb44a34, 
	0xfaf49d7d, 0x60ef6a64, 0xcf8ccabb, 0x7a415d92, 0x8bd95132, 0xc9ceca89, 
	0xf9fb902e, 0x05a93905, 0xd117b297, 0x9230fc0e, 0x963958bd, 0xe3e81cec, 
	0xf066e2b1, 0xf7bbdb3b, 0xb2f83dc0, 0xdf187213, 0x271bef83, 0xd3d436b8, 
	0x7a3d1bbf, 0xec127d45, 0xe15e232b, 0xf09fb17d, 0xd3da1f7e, 0x1e96ab7c, 
	0x560e8271, 0x02f1f2a9, 0x7a2c6725, 0x95cdf614, 0x567c29b7, 0x14da59c4, 
	0x121cdb3e, 0x2417a94f, 0x5d17e09e, 0xf0393b46, 0xed4a58bf, 0xf8870780, 
	0xdc3de215, 0xd97fe89e, 0x80fbb178, 0x19ddf11e, 0x9c4719d8, 0xce047ff0, 
	0xd433b4be, 0x4ffa65af, 0xe6917ffa, 0xb54e40b1, 0x3798c9e9, 0xcf0f43af, 
	0x1bd466e3, 0x07ad888f, 0xfb370534, 0xf095c401, 0x24ee353f, 0x03cf4111, 
	0x7e45b413, 0xc03fb067, 0xb60b8fe5, 0xcc9e8613, 0x3d76a971, 0x17698779, 
	0xddd70716, 0x8177d6ea, 0xfa8f81ff, 0xb19d6a33, 0x8529d5be, 0x763f69a3, 
	0x53b48167, 0x977ad4cb, 0xeefcf5a9, 0x76df7ae0, 0xeefef5c9, 0xbbef5c17, 
	0xd88f5a35, 0xeb9b7ae0, 0x79db489f, 0x91585ff6, 0xe0e8a301, 0x710f848c, 
	0x95eff414, 0xf619b0f4, 0x1bc3d10d, 0x89f41e92, 0x7c82eb4d, 0xc3b03bec, 
	0xf7e515f5, 0xe8a69f59, 0x37cde483, 0x88ff2935, 0xc743a254, 0xefff4149, 
	0xf5a1fa29, 0x7c91a35d, 0x201e83aa, 0x609dfa81, 0xb76aa73b, 0x17bbb54a, 
	0x7f72c5fd, 0x681ced61, 0x5c60f5f7, 0xfee086a3, 0x37c479ca, 0xe3501e48, 
	0xde4a05f5, 0x3bbb9d9d, 0x6bca4e94, 0xb3a2b653, 0x6dc7e7f2, 0x719afd05, 
	0x3be5fe8f, 0x0fe02cd3, 0x20caffac, 0xda018aff, 0x7a60ae17, 0x9a3ac34a, 
	0x64b8d2eb, 0x2a3fc737, 0x47f88837, 0x779c815f, 0xa9a204c5, 0xdff0833e, 
	0x34afba12, 0x3e374c9c, 0x77f656eb, 0x39fa23ae, 0x12f7fb23, 0x40b0fe5d, 
	0x6956e3c6, 0x1a0a0f4a, 0x71c9e39f, 0x87e0debc, 0x0e339280, 0x0f106725, 
	0x09db3a26, 0x42b1237b, 0x4372abe2, 0x42b6ec77, 0x76c36386, 0x1de54fc2, 
	0x62aafc6a, 0xe1da87c5, 0x9767ea36, 0xcd83df5a, 0x96ce98bb, 0x7f05c26b, 
	0x762dd5b1, 0x08f43d63, 0x25d448fa, 0x9e3e305d, 0x08f9f397, 0xda09e201, 
	0xf0b58ba6, 0xda3f769b, 0xfb72c058, 0x182d2d27, 0xe4ad9f5f, 0x891b9bc6, 
	0x1d02ee2e, 0x20ad91f6, 0xa7b62de2, 0x0b616f78, 0x3c623feb, 0x092f1a87, 
	0xd5e7c20e, 0xff475ff8, 0xc636db3e, 0x8b7d6fb3, 0x8e37f415, 0x56fdd2fd, 
	0xf33bf337, 0xbae0d9ed, 0xba3f20f9, 0x201bfc83, 0xc486f03a, 0xbba37cbb, 
	0x41b5ad9d, 0x2edd7139, 0x0724ffc5, 0xdd5ec00e, 0xe3956ed0, 0x96ad35e9, 
	0xa976f591, 0xaa96efda, 0x05ebeefd, 0x3ff77ee6, 0x68c7c92e, 0xbe7da977, 
	0x21bd4847, 0x55f3b744, 0x4e094b94, 0xf7df37a6, 0xb8609db7, 0x0a496ade, 
	0x20505ff6, 0x0ca7d85c, 0x9f4979fa, 0x54227f23, 0x5c11379f, 0x79139585, 
	0xfbd237bf, 0xf67482a6, 0x003db14f, 0xd8dabc3a, 0xbd7c4f55, 0xda756bc0, 
	0xccb7fe89, 0x4f5bc878, 0xcce175aa, 0xbdec277c, 0x4f3bca8e, 0x9ccf01db, 
	0xa976bc87, 0x7c1f8572, 0x7ec6ceb8, 0xa2e7ce24, 0xf5a80d75, 0x7f5a3c5a, 
	0x009bf10d, 0x1f01e9f1, 0x247cc9da, 0x8437a9f0, 0x902d3f4f, 0x4a8bedfe, 
	0x6f82b4bf, 0xc15b5f89, 0xd63eb4b7, 0xb7bf2942, 0x84af5b74, 0xa7ecad7f, 
	0xece87f64, 0x32fce29f, 0xb031dfce, 0x7de02b0f, 0x0957e714, 0xf0a55f95, 
	0x4ef30c76, 0x9f6171ae, 0xe2a1c9b2, 0x1756c913, 0xff30b2f2, 0xaa03ec4c, 
	0xe0999d6a, 0xb79902fb, 0x87b6ef85, 0xae9347d8, 0x13fbcb27, 0x24f81caa, 
	0xd5e9f20a, 0x3ff614b4, 0xb475dc66, 0xe0c6fae3, 0xcced977e, 0xb4e7b071, 
	0xfc946eff, 0x13cb6b31, 0xab7afe61, 0x2ef81f99, 0x79eb0d57, 0xb251eb9d, 
	0xb06511b9, 0x0f9e1dfd, 0x24405f68, 0x0f3f31fe, 0x0b8e05e6, 0x395e93b5, 
	0xc5f57c04, 0xc5c80e8b, 0x2e2eebce, 0xb8207399, 0x7aec0bee, 0x75e10d52, 
	0x6a9230a1, 0x8533f7cd, 0xab3f3078, 0xedf846d0, 0x4aefaa73, 0x10aaaec8, 
	0xef157683, 0x0a7e899b, 0x7a9e536c, 0x4fe83e6c, 0x4aa4fce7, 0xf7f7768f, 
	0x1be3c025, 0x56d37ed9, 0x62f0792b, 0x03e71a73, 0x2e3fa366, 0xb13a9d69, 
	0xf5d0f65e, 0xd737f890, 0xef915fc5, 0xd3b486b2, 0xd02eac2b, 0x5dd08d55, 
	0xba1666ec, 0xe3a50f53, 0x7f075ae8, 0xf796a63f, 0xed05059f, 0xbec334cf, 
	0x1f1be8f4, 0x4f0a196f, 0xc9c947a5, 0xdd76e175, 0x42a2e6c1, 0x76821ffb, 
	0xdee8a95d, 0x36587d0f, 0x2365ff59, 0xb7271af2, 0x823b6bef, 0x6b6e8938, 
	0x76aa7d42, 0x7630d367, 0x3235d97e, 0x62f48c5f, 0xd876fd76, 0x3d947ac3, 
	0x85e9de44, 0x5351bfd2, 0x6ee4e928, 0x7979076a, 0x41e466af, 0xe845f5ef, 
	0xbe7835bd, 0x30f5cf1d, 0x3c4dfa39, 0x1ff652bf, 0x422fbeda, 0xef9c930f, 
	0x8f1e3b40, 0x37d126e8, 0x03ade586, 0xa7a433e5, 0x9d7e1251, 0xbe4f193e, 
	0xabdcf017, 0x9e061dc6, 0x870dc791, 0xf2e372ef, 0x76a9ef78, 0x85e3a17d, 
	0xf5e3cbf7, 0x04a7efa9, 0x8b848bfb, 0x61bd25fb, 0xf8e6a5da, 0x79f9ea89, 
	0xfc50b6ad, 0xd456f201, 0xf8a9c7f8, 0xafd2a3f2, 0x24e2ff04, 0x7bc570bb, 
	0x4ec9bfa4, 0x50ae71fc, 0x6a956dda, 0x17615cbf, 0x7813d029, 0x2cbcee3e, 
	0xffa67eb1, 0xef42e30a, 0x0b03dc63, 0xe1dbdca5, 0x4f5fe393, 0x70d85f70, 
	0x6dfbd0ae, 0x4f9b5e39, 0xaa0a938e, 0x9f2b1bb4, 0xcfec11d9, 0xfc337b8c, 
	0x230fa075, 0xecaf702f, 0xe06cfb1f, 0xe78211c7, 0x217b5af3, 0x2f3523cb, 
	0xfce6be73, 0x5e4689bc, 0x77e78f83, 0x7d376e3e, 0x49ea673f, 0xbf39b7d0, 
	0x659f0a73, 0x9f39594f, 0x6c512caf, 0x7e66e96d, 0x10d0dad9, 0x3c8caf2a, 
	0xedb1d5e8, 0x4a379556, 0xe81e92fd, 0x88aae334, 0xe6081ed3, 0xeccf3433, 
	0x166692f3, 0x3be8739d, 0x6c1df21f, 0x41f48622, 0xe333caa7, 0x2fe4083c, 
	0xf9a137d0, 0xd2ab7dd0, 0x0ede5977, 0xdd5b53e6, 0xbfac21c6, 0x39da5970, 
	0x2221da7f, 0x8e35a7f2, 0xbcce24d7, 0xe905e552, 0x9e32939e, 0x8c9afe9f, 
	0xd75c73ef, 0x89edf887, 0x9655fe60, 0x5c46efcb, 0xe6e72328, 0xf71985b7, 
	0x6c4ec8d4, 0x7a1b8ef9, 0x0a3ca470, 0xb3e27f33, 0x614f9942, 0x3f9451e6, 
	0xf236f398, 0x37992c0d, 0x5fa5d11e, 0xe70b64e4, 0x879c6919, 0x9c11f9c8, 
	0xe9cf4157, 0x09fc8ebd, 0x855e6863, 0xcc0a7c8e, 0x1813f90d, 0x1ec66fbe, 
	0x9e5ff24b, 0x7aebc2cf, 0xc403a48f, 0x427f3975, 0xa3c583d1, 0x9e082bf2, 
	0x672bf726, 0xfa7e47e1, 0xec0d7d61, 0x9ebb1ca3, 0xf441ebc0, 0x7a28ce22, 
	0x9987b108, 0x262d684e, 0x1b14bdb5, 0x75c4ff0a, 0x4fab0bdf, 0x3c73d422, 
	0xe378c851, 0x879f99e4, 0xaac227b7, 0x1c76e1e9, 0x72809c6f, 0x8943f215, 
	0x73f0667a, 0x889c3fce, 0x877de87e, 0xe2017176, 0xda9d540a, 0x2b79c8db, 
	0x3993f82e, 0xaaaa43bf, 0x942f9e8c, 0xf326f1d7, 0xcbeec78d, 0xedc8db3e, 
	0xf63af2c3, 0xd6fcca26, 0x7e640ba5, 0xa21f885b, 0xcb35fa03, 0xd37db0b0, 
	0x04fa24e9, 0x4b18169e, 0x2beeaf10, 0x7447f70a, 0xdfb00f96, 0x13f53c73, 
	0x78e5bc87, 0xd87d0351, 0x12f8e0b7, 0x173a29f8, 0x75a92c0c, 0xdd99f505, 
	0xcfd0ac2e, 0xb0176471, 0xd0f7a67e, 0x8a24b7cf, 0x0f7bd81a, 0x605a4fe6, 
	0x85bd7e23, 0x3f5c6374, 0x36f4f7e8, 0x5c6675d8, 0x3acc7217, 0x8177c543, 
	0x518b22b7, 0x84f98333, 0x3de862f3, 0x9f3237e3, 0x2f68ec93, 0xe1ed85c7, 
	0x93a65f71, 0x435e25e7, 0x3f9068f3, 0x2fdb2ef3, 0x8979c646, 0x359fa9ef, 
	0x0b39af00, 0x8cd91e58, 0xaf031f35, 0x5ebed736, 0x6fb4afc6, 0xc053cf22, 
	0x66bf41de, 0x3f97d45e, 0xdf9ba13f, 0x48d45e73, 0x3d17d376, 0xf38ed147, 
	0x5c94671d, 0x3cbc3139, 0x27d64b79, 0x1273e51c, 0x5c9384fa, 0xc9af898a, 
	0x64b7c4fa, 0xac8f527d, 0xf597ea4f, 0xfacb1fc9, 0xfca8cfe4, 0x4d67b293, 
	0x29e7c479, 0x14f3a9e6, 0x4559dfc4, 0x01c86cb6, 0x720b2382, 0x5a2fa677, 
	0x1c1bffe5, 0x31599eaf, 0xe08aad2f, 0x69fc34ec, 0x65d81655, 0x2ff604f3, 
	0x3af5638b, 0x2a1b55f8, 0x1db1e68e, 0x9db273e8, 0xb453213b, 0xa7ae557f, 
	0x61e89b2f, 0xa8cb62ea, 0xe7196ecc, 0xf03926cf, 0x4e7502e0, 0x8167aec1, 
	0xe27a4dff, 0xb3a200bc, 0xbfdee68f, 0x91507900, 0xd274c374, 0x3a3f943f, 
	0xc6f23b4d, 0xb6d497cf, 0xe606e507, 0x933b051d, 0xfbe0c7f4, 0x487da0cc, 
	0xd61e7d76, 0x17f7f2b5, 0xc32f90d2, 0x30f1e076, 0x4fcf9dfb, 0x6229e798, 
	0x60588e2b, 0x7b29f62f, 0xc6a2a631, 0x1a927c02, 0x2f6b0cb2, 0x78cbab5e, 
	0x76ceba46, 0xbf75d923, 0x76cf9faa, 0xc927fb1e, 0xc70d13be, 0xa2b9df60, 
	0xe7b0ad1a, 0xe926aeb4, 0x837578f7, 0x5ecefffb, 0xa481717b, 0x7b6bff8f, 
	0x4d71a46d, 0xc7b4cd7b, 0xd8dc60d6, 0x3613e761, 0xd99fd9be, 0x9bf543bf, 
	0xf535faa8, 0xd865ec3b, 0xb1fd913b, 0xedfb675e, 0xcf20179f, 0xe37ed228, 
	0xe131ae3c, 0xd0b885f4, 0x3f7205f1, 0x58f5fa69, 0x7156ee2e, 0x2697a244, 
	0xa0f515c4, 0xd54bf75d, 0x08f2251e, 0xf4937a83, 0x5cebb52e, 0x907ace95, 
	0x50cf61e5, 0x0784c93b, 0x887b64f1, 0xc71d037e, 0xfbf2fe21, 0x277159b5, 
	0x8e2df082, 0x35b67e35, 0x38bfcfc4, 0xbd06df51, 0x9a7a18bc, 0x7153eafa, 
	0xf7bd117a, 0xf4f1ce10, 0x03b2255d, 0xb574f738, 0x84402871, 0x1902c9fa, 
	0x653cee97, 0x543e46c9, 0x53edb39f, 0x5e798df0, 0x2e77a8e3, 0xb662cfb6, 
	0x7d6bb2d0, 0x3ceeb220, 0x9c3ed3c8, 0x867e40eb, 0x50fb9d4f, 0xcf0642e7, 
	0x2b9dcc79, 0xf983ee40, 0xa7b71513, 0x71863ed4, 0x6152fd69, 0xf57ac5cf, 
	0x2d3f20f6, 0x1a37db9e, 0x600a56e7, 0xbf601def, 0xd4f41644, 0x7fa40bc7, 
	0x85dd5373, 0xeefb8805, 0x33df19b7, 0xc47561f7, 0x9f658947, 0x787c402c, 
	0x00a3f2bf, 0x91b3d02f, 0xe68fdcf1, 0xf7d61bd2, 0xf45ef9e1, 0xacb1fb17, 
	0x6575e587, 0x82cbcc55, 0xabcc1f7e, 0xe61a7a12, 0x5841369d, 0xe906b7d6, 
	0x7225cfe4, 0x54b8b61f, 0x97f4c1da, 0x01da5479, 0x7ca92799, 0x85a8dc69, 
	0x37f47790, 0xbfa935ed, 0x18d1bda6, 0xb996fefc, 0xbaec30e2, 0x6985a58e, 
	0x2c85ea42, 0x5ed48f3e, 0x317606b3, 0x3c64b7f2, 0xea7ce0cc, 0xbae44a47, 
	0x1d12e107, 0x5e43f7ec, 0x0fb76c97, 0x9b02e57e, 0xa97e82d5, 0xdef00fbf, 
	0xf65c2b1d, 0x632e791e, 0xc2e1e914, 0x67eb2368, 0xafba1964, 0x3e69f1a4, 
	0xde244b87, 0x34dfcadc, 0x4977f491, 0xe5ffd48f, 0x66f7e724, 0x7a1dfb48, 
	0xfce494bd, 0x383daa73, 0x71e747ac, 0x8a5cfdac, 0x3d658fa8, 0xb75933ea, 
	0xb5f8951d, 0x8df8949d, 0xa3d64d7e, 0xd8d2e2df, 0x780f1bd9, 0x94b3622d, 
	0xe0d7fc8f, 0x8b27bc5b, 0xa3565aeb, 0xbdd0f41b, 0x8261cb78, 0x588ea36f, 
	0x154f7095, 0x2bd8ff7f, 0x4394d798, 0x5bd98201, 0x78caee33, 0x9e9347de, 
	0xe7def7a7, 0x0bd584a6, 0x4da8b40a, 0x9fd3fdf4, 0x7aa67c90, 0xfbe6f786, 
	0xed0bcd47, 0x63edff4f, 0xb1dded21, 0xe4c7ee96, 0xd29b6bf8, 0x903eee99, 
	0x739a8af9, 0xe9ffcd03, 0x3e5f8d47, 0xfa4be2a7, 0xb3e5f06e, 0x2807c869, 
	0xad96a9fb, 0x7e24aa6b, 0xa93e82ea, 0x8453f30f, 0xae8bdf9d, 0x63bd67c8, 
	0x5855b3b6, 0x08c4ef59, 0xa3bd787d, 0x7fa98df4, 0x051b26ca, 0x10ef4a0d, 
	0x31be90db, 0x057868ee, 0x381746fa, 0xa5765938, 0x2fc51bf1, 0x2127f53b, 
	0xd22e091f, 0xfe115d2b, 0xdf1bce53, 0xdfc1f2ae, 0xb15c9c83, 0x24b9f790, 
	0x1e07108e, 0x2cee4e49, 0x76ff7492, 0x349cb849, 0x551a2cf3, 0x47cb05de, 
	0xe8a737aa, 0xca61ff9c, 0x4a9f7351, 0x1cafe7f6, 0x7b979771, 0x69d378e6, 
	0x6e7d8c6f, 0x4ecb4e46, 0x72330bc4, 0xae562b7e, 0x2ddfae0b, 0xede4ae89, 
	0x4bfd072f, 0x9da27f4f, 0x3c487ef9, 0xaff5dc51, 0xd28637f7, 0x6138cd4b, 
	0xef3fa10f, 0xc6a62b73, 0xfa7cfeab, 0xfbffebb0, 0xeee442e7, 0x39eb8bd4, 
	0xd6753a6e, 0x37113ce9, 0x3077dfb2, 0xadf4b00e, 0x890fcfdf, 0x3ccc348b, 
	0xc6a5955d, 0xf706de03, 0x6c721161, 0xbc7efea4, 0x521fd574, 0xd91f480b, 
	0x56c694f4, 0x7e4767cc, 0x7e50bafc, 0x4a736338, 0x7bd717f8, 0x82ff9f2e, 
	0xb9fa7f7e, 0xf1b79218, 0xf27a3be3, 0x7e000f38, 0xbfe438bc, 0x3b245c90, 
	0x9b76efb3, 0xae38d128, 0x544db301, 0x37fdf24e, 0xf55281c7, 0x944ecdf1, 
	0xc443acda, 0xb9768d7f, 0x768e8d1e, 0xa3ec804b, 0x73b69746, 0x6357f10b, 
	0xd150f8a6, 0x1d3d2ce9, 0xa72cbafd, 0xfebd8d69, 0x78afda8f, 0x23fc2874, 
	0xe644b1e5, 0x803c70af, 0x4a3258e4, 0x50636392, 0x48be73f6, 0xeb21e3c9, 
	0x4d39f54f, 0xd88f1cf9, 0xbefe1db8, 0x6e379de8, 0xe8798a3a, 0x22b52ff5, 
	0xdc3da74e, 0xdf1fc72a, 0xe2a5e4f4, 0x19f9227c, 0x8bb69de4, 0x71211de4, 
	0x5c0e335a, 0x6e4f5639, 0x16d57151, 0x832fd07f, 0xe4839a78, 0xa962d6f4, 
	0x2413cb8f, 0xb1fa459f, 0xfb21ced8, 0x20f896a7, 0xaed06d75, 0x2d59e331, 
	0xd52bfcf4, 0xe3e59e2a, 0xe23254f8, 0x7b888d1c, 0xb9e8677e, 0x51ee331d, 
	0x6520e2ae, 0xf2b6524b, 0x4e08066c, 0x3d36a1e8, 0xfca87a19, 0x1db04f87, 
	0x85e0fe5d, 0x55bbe43c, 0x3f376ba6, 0x955f4216, 0xa149f463, 0xe9f1b3f2, 
	0x5ee22be2, 0xcb29ff66, 0xadbf2a5b, 0x96f567f8, 0xf2efec5d, 0xadebcb3f, 
	0x6ef362fd, 0x8aff9bc8, 0x9fc63790, 0xf5f8429b, 0x29a7f2cb, 0xbfe03267, 
	0xf06f91d6, 0xce395feb, 0x2ab3b928, 0x179c7eb8, 0xf27c9426, 0x1216e505, 
	0xcb85c764, 0x335cff97, 0x17875e4c, 0x9f392fe7, 0x97aecb51, 0x88d92a79, 
	0x922a8cc3, 0x887a48eb, 0x3b0a8bcf, 0x1a11df3d, 0xad6c31d7, 0xf972feeb, 
	0xdcc2f053, 0xa0d3fdb0, 0xef682d1e, 0xf5947cdd, 0x6d1f57da, 0xddf35e85, 
	0xe4f59db6, 0x3ec7ace1, 0x48a72a19, 0xfe72fd0e, 0x6a1ca840, 0xc9d7f659, 
	0x71e8daa1, 0x685d0e52, 0x4ecf4274, 0x015466bf, 0x36eef3c3, 0x22edeb27, 
	0xeb13cf09, 0x9b29891b, 0x769f1026, 0xa0d0e507, 0x7f0cbc9e, 0x5bc7c90f, 
	0x4965f925, 0x424bb4b1, 0xc4167ce2, 0x3e2a6d67, 0x9d3af1cb, 0xac7e7ce3, 
	0xb6ff49b7, 0xa1fd73b3, 0xe21b3e71, 0xfe41dd79, 0x09dffee6, 0xdb243fe6, 
	0x4abeb7db, 0x2455d878, 0x3d4d5ef3, 0xc71bf4c6, 0x004b3bfb, 0x6fe546fe, 
	0x1adfc1b5, 0xb5e7c7c2, 0x85d8228a, 0xa3f19fb4, 0x3d6ff41d, 0x5d125bed, 
	0xcf2bc28e, 0xfa3c3d48, 0x5f83e619, 0x0f890d6e, 0x86de4978, 0xfdccddfa, 
	0xcf12e345, 0xb915c049, 0x1f5c889f, 0xff6fcd6f, 0xe40bf93d, 0x19964515, 
	0xc5f56fde, 0x6ffaba4b, 0xb5ae8eb9, 0x8eb18bdb, 0x44edd4fe, 0x489a0567, 
	0xfd0eb7d2, 0xc7e12c6e, 0x9f4836b2, 0xd9695795, 0xbd937388, 0xf91db5f3, 
	0xcfd5a3c8, 0x3e42b7d6, 0xc876b318, 0x5b9bcb78, 0x07ca8692, 0xc3be3f8e, 
	0x6a2fa976, 0x8df73cb7, 0xbe7c24f3, 0x3b90f080, 0x4e857b10, 0x912f9d70, 
	0x121441f6, 0xcd0ed7dc, 0xe07dcdcb, 0x8777a7c2, 0xc6e71fcc, 0xcf329fe1, 
	0x70e39829, 0xb7ec51ff, 0x91e382bc, 0x4f11510e, 0x912cdeed, 0x43fdcdeb, 
	0x15f04f4e, 0xca5e1037, 0x33737a3d, 0xe49ca3cd, 0x5f08634e, 0xf32c0efb, 
	0xfb7c978c, 0xd85de6e2, 0xefbc6b67, 0xd23a055f, 0x2bbb7283, 0x50edbe22, 
	0x0b37fd72, 0x243ddc65, 0x79e580df, 0x2199e219, 0xf6067bf4, 0x394103d0, 
	0x4e3b72ce, 0x3b9271c9, 0x614e2cb7, 0x3d0b7539, 0x9c7dd6fa, 0xc43bfb37, 
	0xb47e9ffd, 0xfbb6fefd, 0x38e6fed9, 0xa84ae430, 0xabee65fd, 0x7dca97f6, 
	0x14468758, 0x575a2dff, 0x6ff9cadd, 0x7dedf836, 0x757afe21, 0xf2b443ef, 
	0xfebfb3cf, 0xbcff50e0, 0x73e3a7e9, 0x39e0de52, 0x611cdb5e, 0xe91c1d81, 
	0xaf3c1f9f, 0xcfbb7388, 0xac6dce20, 0x4bf72a3e, 0xfa7e27ff, 0x0e7922be, 
	0x9bcbf4d8, 0x55db7a7e, 0x2f385dae, 0x06fbfec6, 0xdea591f8, 0x6c93bfa1, 
	0xfd3f2817, 0xb7c4d1be, 0xbd3f50da, 0x43b1de79, 0x943bf1f9, 0xfe11bedf, 
	0xfcf04b79, 0xd7effb23, 0x7afe25ff, 0x4d82f39d, 0x67fb037f, 0x0e730c67, 
	0x8d2f35d2, 0xe75021ef, 0x7f8fd924, 0x2df1f946, 0x1bef8fca, 0x7298ce59, 
	0xd6cefe85, 0xc3de9878, 0x789a4fce, 0xf5fef2f9, 0x8e4e598f, 0xbc675fe4, 
	0xbebe143a, 0xffc9b9c4, 0x03bcfc6d, 0xe5f1f079, 0x8da754f1, 0xa21f862a, 
	0x7933d37c, 0xb3f7b780, 0x05eea158, 0x033dc349, 0xd4fa0fb4, 0xfef2f341, 
	0xe050eea9, 0xfce3ec2c, 0x10bb4758, 0x9fa54a3b, 0xfc7331a1, 0x38fc1b3c, 
	0x23622981, 0x2baf54f1, 0xf18756c7, 0x6eada774, 0x375f3d3a, 0x8d2366a5, 
	0xd9cbebd7, 0xf1807758, 0x711871c9, 0x8eefed35, 0x1ce97ce3, 0xcdf6922f, 
	0xaeba3e7b, 0x8815eb9b, 0x31e45433, 0xa76bfb90, 0xdf7e2314, 0x3bc87de5, 
	0xf9952673, 0xa3b48cb2, 0x40ef5d85, 0xaf4f6cbf, 0xe03ff862, 0xb4ab933c, 
	0x442e7aff, 0x50ce56be, 0x35e55ef2, 0xe645f999, 0x9128ccba, 0x7376edf2, 
	0x53cea8ff, 0xf674d72e, 0xb70ef643, 0x2437bd4f, 0x479d4acf, 0x0aeb7de4, 
	0xaf390729, 0x72dc5521, 0x24d03791, 0xcd0dc70f, 0x5cbdea27, 0xcfea913e, 
	0x8c3d1f3c, 0x96e9fbfd, 0xcbc1ec61, 0xa7b9e995, 0xeb0ff4c3, 0x43d61e9d, 
	0x72eee81a, 0xfe5617df, 0xa978c4e7, 0xd2ea6a4f, 0x53676e47, 0xe5368279, 
	0xfca2d9cf, 0x07e62335, 0xe53232ad, 0x0b2d0339, 0x6edb9bfc, 0x5be93ce1, 
	0xbbffdc95, 0xcc5fa922, 0xdf198e78, 0xf24fbd61, 0x29c42dcf, 0xff50eecb, 
	0x3f9f217d, 0x7ad272ee, 0x601c54f9, 0xfa4de837, 0x884711f1, 0x3302e331, 
	0x54213c64, 0x07c6470f, 0x0f44ed7a, 0xf53e353e, 0xe4a17b33, 0x532fee37, 
	0x101bc60c, 0x2b99208f, 0xfaafd9f1, 0xf77c0fbb, 0xf4ddf310, 0x901d65a6, 
	0x877fccff, 0x8acff8c3, 0xff88be7b, 0xe7fc555e, 0x8abc900f, 0xbc91ff07, 
	0xed225e5a, 0x1ff078f9, 0xfc552bb5, 0x23fe0317, 0xff078b7e, 0xfc535ec1, 
	0xf3fe0317, 0x036bbe2a, 0x7c94cddf, 0xe29674b6, 0x0f9299bb, 0x2b1ddf15, 
	0x1e23140d, 0x2277c917, 0x4fe0ff41, 0xde7f6cf1, 0x45e7d6aa, 0xf91ee83f, 
	0x3f142b09, 0x2f9c131c, 0xe4133fea, 0xca0e9303, 0xb9599e55, 0x5ebfe3d2, 
	0xfd99e668, 0xe752f8a0, 0xf86ed0aa, 0x8abb5573, 0xeb83ffa1, 0xd610e1bc, 
	0xb46ff7b9, 0xdbeb91ce, 0x6beb4157, 0x7fdabf88, 0x599fb913, 0x3c2fff9c, 
	0xc0dfec2f, 0x1a095d0f, 0x09bdffcb, 0x8be21e46, 0xeba4bfa6, 0x4fd927be, 
	0x963338db, 0x1f7223f9, 0x4de102f2, 0xcdd60eab, 0x39f3cc7e, 0xcfd1cf83, 
	0x3cffd50a, 0x9bec77f4, 0x768e9cf2, 0xa1aed364, 0x979e46fd, 0x7bd94179, 
	0x360fef91, 0xe398b6ff, 0x2d8aeba6, 0xbf9938fa, 0x2dd8f889, 0xd84efa89, 
	0x8127c877, 0xd83ec23e, 0x5ffb91e9, 0x7d85ffdc, 0x07a0fc2f, 0x3b228837, 
	0xbecae4fc, 0xcdb2f335, 0x5e936bbc, 0xfcca970e, 0x0d297fd3, 0x1b2dfbf7, 
	0x7020744f, 0x874bc84f, 0xfd0dfd42, 0x0d9958bf, 0xb72839f9, 0x233aafb1, 
	0xe7a1b2f3, 0xa7ed0593, 0x3f492e58, 0xb7caaf4a, 0xb6fb52ee, 0xdf729dde, 
	0x91b9da66, 0xaff64afe, 0xfe7f225c, 0x6f9952f6, 0xca8bea6f, 0xcb5e7ab1, 
	0x331e60bc, 0x1e4339e7, 0x6cf53d28, 0x360bcca9, 0x1a4680f3, 0x4be102f7, 
	0x958c2dfa, 0x6f131ba0, 0xa8f9ed7f, 0x16aff7c8, 0x47cf618b, 0xeef0fa99, 
	0xbde5f411, 0xe0a7de78, 0xdea8627d, 0x3bdea35b, 0x11ebdf06, 0x4f7a3f71, 
	0x64ab3bfd, 0x14d7d4de, 0x0a117a1e, 0x5297690a, 0xcc85f325, 0x5bf70dfd, 
	0xee3c7437, 0x73ff186f, 0x9e26b8e4, 0xb94cf1cd, 0xd8fa50e6, 0xf333c6a9, 
	0xcae9079f, 0x11f9c477, 0xac68f3f1, 0x17cbd93b, 0x74dda58a, 0x094e79b0, 
	0xe17c61c7, 0x2fe2617c, 0x5c386f08, 0xfc4dfce6, 0x36dfcc85, 0x2f785ec4, 
	0xe35d9f34, 0x245766b8, 0x7bafb09e, 0xc677882f, 0xf9d0dd57, 0xcd07ee47, 
	0xbe2777fc, 0xe798227f, 0x29c4fbce, 0xf6fe47d8, 0xff295c93, 0x63776b1a, 
	0x7ce5cbbe, 0x3bbe68ab, 0x5aedf382, 0xdf336b7d, 0xf2e2a64f, 0xce6be923, 
	0x7bf960fb, 0xe48d896c, 0xc92f44f8, 0x678c55ef, 0xd8653b01, 0x5c887df8, 
	0x6f73f537, 0x3a079e82, 0x61327ee5, 0xc6cdad3f, 0x36aea179, 0x2c6c5f69, 
	0x4cc5e795, 0x0def823b, 0x37b41ddb, 0x8768aec8, 0x6f683e5d, 0x919b8c44, 
	0xff6ffd25, 0x09fb2c50, 0xeb3453b1, 0x068a76f0, 0x0efcc53b, 0xec938276, 
	0xe44b0783, 0x702d88f9, 0xbde884e4, 0x7d4b179f, 0x4d5341f9, 0x230fc709, 
	0xe33059ee, 0xc2cf7c6e, 0x1bb8d089, 0x86e21fed, 0xefe8ddc6, 0xc8c87383, 
	0xa75e91b2, 0xf6614cfd, 0x1f03ef9b, 0x63f52bee, 0xfc52fcea, 0xe7e874c6, 
	0xf4a5c940, 0xa962f2f3, 0x2b16779f, 0xa7a1103d, 0x7847e707, 0x1bf85788, 
	0x3fce4335, 0x407be68e, 0x581f11c5, 0x20d5e528, 0x7e6532be, 0x55ebeb15, 
	0xb30f5f4a, 0xddcd1fde, 0x6835f4cb, 0xbb643abf, 0x586c3b48, 0xed040afa, 
	0x1d7e7303, 0xa89281da, 0x0ffe944f, 0x69bef504, 0x1cfe99c7, 0xe7339ed3, 
	0xe49137bb, 0x275c9278, 0xe557a3e0, 0xbe172659, 0xcd3d7250, 0x87baaf6b, 
	0x5a8ddf11, 0xf4c1f0a5, 0xdd857070, 0x48d9e727, 0x3e1497f5, 0x8f943ccc, 
	0xb0251ae6, 0xc3b43a07, 0x7c524e5c, 0xde49bd3f, 0x267c07ff, 0x6122bfa3, 
	0xb4119d8c, 0xb27df197, 0xc4b277c2, 0x8224a9f7, 0x3f6535f7, 0xe48ef89a, 
	0xf08fa603, 0x5e476a75, 0xeba1ebd6, 0x3ae876b4, 0x71ef433c, 0x62fd937e, 
	0x9abfa0fd, 0xf879e834, 0x93ef92b5, 0xb9ae81df, 0x4f30755d, 0x2b2cfe1f, 
	0xa7d925e4, 0x5dfa79a1, 0x4a3f4f2a, 0xbe6451f1, 0xd7ca977e, 0xc99fee0f, 
	0xd72691be, 0xe34b9c56, 0xf416aefd, 0xca7e9a87, 0xd75eb8c8, 0xc20f327d, 
	0x9e21eb8c, 0xf1ccfd07, 0xce321dbe, 0x98ef0837, 0xfa4670a1, 0xdc28bef5, 
	0x5cff9b07, 0x7551f6c2, 0x8cf45cb8, 0x886b8712, 0x81513d6f, 0xa64f9c43, 
	0x761f3ed1, 0x487ebc48, 0xef7ad827, 0xdd69e1bf, 0x07ec4b25, 0x16316c1a, 
	0x799ddf3e, 0xa9bafd82, 0x3ce44d6f, 0x54f3ab33, 0x8cd9ce36, 0x5746f652, 
	0xe21a7455, 0xa7ae9307, 0x90276c27, 0x7f7aa7bc, 0xce2740da, 0xdf2d37f5, 
	0x20760276, 0xce16b119, 0x7bde8b13, 0x09c48458, 0x9f794e6c, 0x95392dac, 
	0xcf985fcf, 0x81be54b3, 0xb7674659, 0x7a9e81e5, 0xadf3ca97, 0x7a8eaf34, 
	0xf38f7c87, 0x6fab4db6, 0xb4bcee3d, 0x8cdc7cbd, 0x8e5ec397, 0x64e3b59e, 
	0xc01c487c, 0xc6484b05, 0x9e22ceb3, 0xde4b3d15, 0x69da42a3, 0x697f8c8d, 
	0x54b39ef2, 0x9b39ef8d, 0x7f234f9e, 0x5bef7a12, 0xff7905ba, 0xa0ffa244, 
	0x331afdf3, 0x98341f79, 0x83bd521f, 0xbc4c43f3, 0x5b6ef198, 0xce39f68a, 
	0xb4c6dadc, 0x1efcee7f, 0x03a2a7d6, 0xe796177e, 0x7bfb17a4, 0x75fd2e1d, 
	0x3f9bae21, 0xc5cd5447, 0x5d80c2f8, 0xc84550d9, 0xf3fb7822, 0x5bde59ff, 
	0x93ef2453, 0x7cc58e14, 0xe4d0904f, 0x47fd9bfd, 0xfd78f22f, 0x7bb2abaf, 
	0x5fee1756, 0x4aa0bfe8, 0x7e2eecdb, 0xae95563e, 0x39e7caef, 0xaef82caa, 
	0x2a9b7e7c, 0xe5933f7d, 0xe48e555a, 0xecf5128f, 0x35bdc28f, 0x9cc7c7b8, 
	0xc4bee46f, 0x598937cc, 0x91e1f728, 0xcdbbe97a, 0x08ff43b4, 0x1cb87ee6, 
	0x620fdc18, 0x9e0be7ff, 0xe625150f, 0xd28eeffe, 0x42339d4b, 0x97e94bbb, 
	0xc77fcd83, 0xc28a2beb, 0x2a2fa9ed, 0x4a95d6d7, 0xcf2916b9, 0xb4d0fd06, 
	0xd8c9f5be, 0x5fa6e9b7, 0x4f4da1e2, 0xfdaf5e5e, 0xfb87e2a3, 0x7d271e95, 
	0x87950aec, 0x3d798e78, 0x5ef4aa5c, 0x72209f84, 0xf5c9cbbc, 0xd72952c6, 
	0xcb85e383, 0xa48a7bdf, 0x31f5e5fc, 0x5c1b5dc7, 0xa9fec1a7, 0xafda8a3e, 
	0x05f19628, 0x042e9fb6, 0xabc48ae1, 0x7eb98e39, 0x487950df, 0xdb250f18, 
	0x7c541731, 0xf88bffa3, 0x379da465, 0x95ebef98, 0xf261f5fb, 0xc435857b, 
	0xcefb63ce, 0x975fba17, 0xa6f4de76, 0x6390cd65, 0xfe5f765f, 0x48a78573, 
	0xc67e803e, 0x904ef57a, 0x91ebda74, 0xf7d4de7a, 0xe1d6acff, 0x2a4fca67, 
	0x52c81c54, 0x8ce78222, 0x59bb2857, 0x7e4b9e0b, 0x7987ad41, 0x3360f93e, 
	0x37616ced, 0x0fd70d2f, 0xca8f9b07, 0xf4e115e7, 0x98f9b07e, 0xb785ae7c, 
	0x3168db2f, 0xbf46edf1, 0x3e9e84b3, 0x8eb95f78, 0x8dc33a7c, 0x5a3d3a7c, 
	0x3637a078, 0x23a5b01d, 0x2e26c80f, 0xaa1ef878, 0x5f1cf9bd, 0x74b422d9, 
	0xc9bd55dc, 0x18e396b7, 0xb7eef101, 0xaf80532d, 0x17ec1e05, 0xf9fcd28e, 
	0x3c731afb, 0xe6c46f79, 0x8d7ad18b, 0x6deae7bc, 0xd1b65799, 0x55af7e13, 
	0xa7dc6ee6, 0xa37e4d6d, 0xfeeffb07, 0x461f7952, 0x86a988bf, 0x3b5a3d3c, 
	0xfafef387, 0x48fdd5db, 0x48fdd57b, 0xa3f1bdea, 0x7df9e139, 0xde0d1fde, 
	0x6e73848f, 0xe8713ecd, 0xa373b229, 0x0fbec552, 0x9aed1791, 0x63fb133f, 
	0x87f15e93, 0x802d7073, 0xd5951cec, 0xa7bef229, 0x4298fb88, 0xe4f7c5e6, 
	0xa027810c, 0x4eb26dea, 0xde06edbd, 0xfb82a85a, 0xe04f30ad, 0x6bed75ad, 
	0xd6ef713b, 0x2edaf1e6, 0x705ae7ec, 0x3c14d5cf, 0x9befc6df, 0xc8096d6a, 
	0x6fba6f9f, 0x24f71b95, 0xb63caa05, 0xdcc3550d, 0x8e60750f, 0x275c77cc, 
	0xf8e449f5, 0x0cd0f883, 0x165f67d6, 0xb7693d1f, 0x66f92fbf, 0x61518cd9, 
	0xc22b3bf9, 0xbe0505ea, 0x398a9bf5, 0xb6c6ed9f, 0x83aee261, 0x89d2f8f1, 
	0xf0cfdec3, 0x0342a3f4, 0x37bde11f, 0xd573fde2, 0xca8813c8, 0x9d08fdc6, 
	0x86d25eea, 0x91765b0a, 0xe2d7b64f, 0x4cbfdbc2, 0x3339d67c, 0xe5d2e589, 
	0x2b5fc3f2, 0x1f9fa9a3, 0xbc311e59, 0x315daf44, 0x60fef19f, 0x48f23ca4, 
	0x85dba4b9, 0x886fd42b, 0xea82fd3f, 0x397ff327, 0x3ce420cf, 0xc8b292ea, 
	0xb3bb837c, 0x8aebb711, 0x1bee0f38, 0xdf2075af, 0xc027ccc0, 0xe45fba3d, 
	0xf217715c, 0x9fec1c10, 0xca55b49f, 0x19f59cc9, 0x97e717f0, 0x72f61f21, 
	0x6515ff7e, 0xcb00fde6, 0x9fb52ecb, 0xa9e83b44, 0xd7fa7cca, 0xfbea87b7, 
	0x260dc44b, 0x13b10d6d, 0xc43aaf39, 0x0de66d2f, 0x701af79a, 0xe1c2c45e, 
	0x79aa21f2, 0xd33e135c, 0x0f7e66bf, 0x3bf950ba, 0xc956e3e7, 0x1dee077d, 
	0x1ec23ec3, 0x695b47c1, 0x7cd06f1e, 0x3479d8be, 0x8434bfda, 0xf793479e, 
	0xb3c64716, 0xe1deab9b, 0x78ccb7fb, 0x7b8a9776, 0xbacfe79b, 0x85f6b710, 
	0x1d711f9c, 0xd43907de, 0x6fb83885, 0x76dbfc68, 0xc69f3c9f, 0x82e243e7, 
	0xb3c4287e, 0x8749def9, 0x629f3888, 0x5ce34278, 0xef1c6fe2, 0x8becb97e, 
	0xf7934b9e, 0x9afc72fd, 0xdde323a7, 0x4636c71c, 0x3c73778e, 0x6f8abe7b, 
	0xfbf2fe07, 0xa1f7236f, 0xd71c6d7f, 0x8e331ba4, 0x61d4fbcb, 0xf191b8e2, 
	0xdf57f16d, 0x7655dc0f, 0x236473a9, 0xf7a1f1c9, 0x944aad96, 0x8f686bf7, 
	0xf9f064d7, 0xfe50a880, 0x627ab2fc, 0x1125ad42, 0x7e1c7878, 0x4b079c34, 
	0xae7eb111, 0xcbfa19eb, 0x7fc82f54, 0x0ed57201, 0xfc13d67b, 0xc1c79c1d, 
	0xa38724f2, 0x7b5b1e49, 0x3aa58fe0, 0xfdaedf7d, 0x3b588ff9, 0xe91fb2bb, 
	0xf6f00f6f, 0x67df3ab8, 0xc63e89b1, 0x5635b24f, 0x507b49e5, 0x76d0cdee, 
	0x237f8ceb, 0xc57afc16, 0x5e4eb922, 0x13a09511, 0x18e4e51f, 0x4d4fe401, 
	0xfef9d6e8, 0xc0176a00, 0x5b9351fd, 0xfd03ab5f, 0xa9da3cf3, 0xfff0904c, 
	0x03e8b460, 0xea24e43d, 0x6d5f7ccd, 0xfb06abb7, 0xb971c8fb, 0xeb4bc23f, 
	0x97bdfc80, 0xc78081d6, 0xdae7fd45, 0x07dc048d, 0x73703d36, 0xc2a9ea02, 
	0x084ed31e, 0xf793281e, 0x0b58e543, 0x0fef00ea, 0x00f6935a, 0x55cea79a, 
	0xfc5e41d4, 0xc54faed0, 0x5fbcb43a, 0x44f21bb1, 0x443e69d8, 0x82d62d5f, 
	0x398dd858, 0xe0b16bef, 0x3bde8987, 0xd10ece17, 0xc66d93f7, 0x2fb92682, 
	0xa9febf79, 0xf391dc20, 0x203b79a2, 0x7a88163f, 0xf39a77f6, 0xc83e80b2, 
	0x4c696dce, 0x617d83a9, 0x3f48fe01, 0x5d3d6fce, 0x2b90f187, 0xd9d17b0e, 
	0xf217aa7a, 0x2f75f1e1, 0xd7ea8465, 0x4d3f0305, 0xf1f08472, 0x5ef245b8, 
	0xa3810991, 0xa112470e, 0x7fc1fd0b, 0x8ecf3b56, 0xf15c1179, 0x87865eb5, 
	0x1ce262f9, 0x7b4fd62d, 0xfbcab713, 0xaa392971, 0x7df275eb, 0xe1dff74f, 
	0x5bab633e, 0xba0e41d4, 0x7eddb9d5, 0x3e0e5c2d, 0xc1ebcfae, 0x1dba33bf, 
	0x3fa0071c, 0x407948cf, 0x66fc11dd, 0x2d5849f0, 0x469738f3, 0xd52bf826, 
	0x7fc032d0, 0x3c3ea633, 0x6de10275, 0x1ab122ef, 0x0cef6bfa, 0x40790591, 
	0xc95eb272, 0x4e4ae3c9, 0xb7c8edda, 0x7f8af974, 0x91c5a543, 0x93f01c70, 
	0x5f806c9c, 0xe5b94464, 0x5b93086a, 0x63d6b109, 0xa74713f0, 0x0af60d0a, 
	0x44fe01f8, 0xc6cfdabb, 0xfc077b29, 0xbd72fb83, 0x8426e7e7, 0xe7af07ae, 
	0x58afb803, 0x669790f8, 0xad73c877, 0xfd8e9df4, 0xb2da37ac, 0x49c3fb10, 
	0xc8db0eb4, 0xdf7fe81e, 0x29f9c5b8, 0xea1623e3, 0xf522e57b, 0x6c7f2a7b, 
	0x22fce58f, 0x558acfda, 0x7e277841, 0xdfe58bec, 0x407f78e3, 0xf7471efe, 
	0x0414294c, 0x51fa27d1, 0x5def05f7, 0x7db2c7a4, 0xbfc89de6, 0xbcf132ab, 
	0xc5577f8b, 0x0ffeff5c, 0x8bff4a67, 0x120f9e4b, 0x8ac3d13a, 0xf82c9d20, 
	0x4c1794a6, 0x0e8af51f, 0xf5bb46ee, 0x26dcf219, 0xe08ac3d1, 0x117d93ba, 
	0x49a33f0b, 0x4cf7e647, 0xbd72e94f, 0x4bb77db9, 0xfc960efd, 0x65ea6dde, 
	0x939e5efa, 0x1a7bfc11, 0x1ea6f7e6, 0x790bfd66, 0xc14bedd4, 0x923d26f7, 
	0x3d73d3fc, 0xe991e943, 0x6fbf0570, 0x8f9f0aff, 0x2cddfc8d, 0x77103191, 
	0xbddbfa79, 0x19f4d3e7, 0x0f7c7db2, 0xf1eaf3e7, 0x518a5cfd, 0xa8facb1f, 
	0x4f2e6acf, 0x2b874c8f, 0x7bd25d14, 0x0bd1bc67, 0xf5c173bb, 0xa74cf6b3, 
	0xdf5b9dfe, 0xf71d4de8, 0xc174e9c5, 0x30fc483f, 0x7482797d, 0x407c2369, 
	0xddf2981f, 0x21fbe794, 0xc4ae4817, 0x7e1d0855, 0x8b0ad884, 0x74c19c68, 
	0x769679ca, 0x05898f15, 0xf177d29d, 0x73b19cea, 0xe42d5b6b, 0x2ac3f336, 
	0x03df0fc6, 0x0d9a405d, 0x6f0b40f7, 0xe6efd845, 0xdd327f10, 0x89677815, 
	0xa27f921a, 0x5debde4d, 0x2cfb3de0, 0xad826ee4, 0xdb1dfb5b, 0x9e127aab, 
	0xf1f1e84f, 0x31fddd3d, 0xb33fbc6d, 0xda89b654, 0xe007648d, 0x787bf09e, 
	0xdf1ef5df, 0x3fe9ad07, 0x3bc81e46, 0x0c7fdb59, 0x56b7b1bf, 0xdbff069b, 
	0x3645f3b5, 0xeaf077ee, 0x3ce70122, 0x5caf7df3, 0xf7b92761, 0xc7e922c6, 
	0x2bf2a7da, 0x9b15ad9c, 0xc9f67f70, 0xf69ed245, 0xc03a8eda, 0xd981de87, 
	0xd3f2a109, 0x0a6daf19, 0x61fde0b4, 0xd5a73a87, 0x1de03d0c, 0x6a109398, 
	0x226ae52f, 0xfccdd03b, 0xf83deba9, 0xbd45af4e, 0x4f67aef4, 0x4a1e1126, 
	0x1038d6c7, 0x7ee537bf, 0x546221a7, 0xf278013d, 0x64d31ad6, 0xf18fdaff, 
	0xd2e527fe, 0xf17f97ff, 0x7a758fd8, 0x64b0d33e, 0x5a7bde63, 0x0b9c74f3, 
	0x2f3e3bce, 0xef3ff21b, 0x61339e58, 0xa96710bd, 0xee6ab4fd, 0x3dfded8f, 
	0xe3ee9fad, 0x7bd1fc73, 0x3a78f7f9, 0xaadc2e2e, 0x5922ff73, 0xaf8c8ff2, 
	0xe43d6a2f, 0x9c87fd84, 0xe40de406, 0xd66cf37c, 0xffccddcd, 0xffa88759, 
	0x63fed49b, 0x93279ccf, 0xd49ed893, 0x771ef993, 0xde8626da, 0x27539dc7, 
	0x01e3afe9, 0xb25af799, 0xdc649ef4, 0xd1ee5f67, 0x5338755a, 0x59f796ae, 
	0xd17dc7ef, 0x169fcfd4, 0x17af7bc9, 0xb8c96bc5, 0xd9d8ae0f, 0x07ae81f6, 
	0x7d117be9, 0x45b6648f, 0x76192d2e, 0xe238a94d, 0x68b31d84, 0xf6d67340, 
	0x30379d91, 0x5f19ef9a, 0x84e0dbe4, 0x6bd4a63f, 0x1d9237d1, 0xe8555c55, 
	0x72c4f9c4, 0x718ad88f, 0xd877fe19, 0xbcaaf27f, 0x00ef5c47, 0x09a7ecdd, 
	0xdf855d8c, 0xdaa1bad7, 0x25afbfc1, 0x72f8dee5, 0x2ff36f29, 0x2be876c6, 
	0x93dd4ed1, 0x9beea15d, 0x4df7922e, 0xf9c9a677, 0x57617e30, 0x2fa4bce2, 
	0xe74ebf38, 0xdb9f7e52, 0x9d6277e6, 0x79e413ca, 0xea9f7eca, 0x1517e547, 
	0x03f47caf, 0x693df5c8, 0xd5c92f04, 0x09df2d22, 0xb170063b, 0x4570563c, 
	0x4fd91f8e, 0xd3ebfef0, 0xd730cfec, 0x089af383, 0xc6091d0f, 0xd767dc34, 
	0x69d3edb1, 0xde7d69d3, 0x3379fc9e, 0x6093d9c6, 0x1d5c03ec, 0xfef0c7ab, 
	0x7936f3be, 0x5b6e727f, 0xf5f6215e, 0xdeb2059d, 0xef887be9, 0x4abd2e3b, 
	0xae88b7ee, 0xa8ae71b3, 0xfe7cad73, 0x0e7972a3, 0x518374a3, 0xb8ba7b06, 
	0x0af4cac8, 0x47cd0952, 0xfa5ca879, 0x78521efb, 0x246b1d2e, 0x3730ef20, 
	0x9c37ff45, 0xcf92a38f, 0xf04ee5c7, 0xa15feb59, 0xb06c23d2, 0x8c137279, 
	0x6cb9e5c7, 0x53f5d5ed, 0x8cabee09, 0x1d61d82c, 0xf23346f1, 0xff5772b6, 
	0xefe01f7a, 0xdf1e61f8, 0x6731d243, 0x55b9e0ee, 0xeb7275f8, 0xefe093f4, 
	0x1cb199be, 0x2e5459f7, 0xe88fbef9, 0x12ec7c08, 0xfb09f7f2, 0x81f6448a, 
	0xa9ac42ed, 0x74bef790, 0x527f12a6, 0xc46dc5ff, 0x1ee7047f, 0xb8eb8d0f, 
	0x6833b8c4, 0x71d0d75c, 0xb2c7bd7b, 0x50ee6f20, 0xdc62f6e3, 0xf6e3834f, 
	0x18591916, 0x3926eeb7, 0xc5c6076e, 0x4b8c5bf9, 0xc267b07c, 0xdf7be665, 
	0x573df3f0, 0x535dc725, 0xe7e9fd2e, 0x0e7be622, 0x6b495ee3, 0xbf5c9371, 
	0x5ca6e321, 0x1997be66, 0x8ccba1f7, 0xe308e6fb, 0x4e9eb4e6, 0xe45f6410, 
	0xb8d96bc4, 0x17cbb9b7, 0xd9f4cd9d, 0xd0413876, 0xfa42b977, 0x965da81b, 
	0x9d887603, 0xdb113ee4, 0xe75e357a, 0xfb8f6a52, 0x24af7c98, 0xa8760e40, 
	0x92874af8, 0x7f389d07, 0x34e52f5e, 0xeafc88ec, 0x4fb81d27, 0x1d17d536, 
	0x5fa5f683, 0xe824f17b, 0x52e5e7fb, 0xe4bfe46f, 0x2febf37f, 0xfbc87f43, 
	0xd25f539f, 0xa3adfd7e, 0xc6ca9f84, 0xf4adf4cc, 0x6a2fa07e, 0xae1242db, 
	0x4fdf5cdb, 0x12f3c1a8, 0xe7885691, 0x6cdfdfb1, 0xf2487c51, 0x171dcf60, 
	0x719f21a7, 0xe48bbe24, 0x22bf9337, 0xc13a6ef9, 0x9b7e0b95, 0xea63e723, 
	0x24a7da11, 0xe6a3381c, 0x2bcd4f35, 0x53d03e64, 0x0f882fba, 0xe3126f9e, 
	0xafe29765, 0x01ec37f7, 0xd5a6c7dc, 0xed7b1f10, 0x1f7e0122, 0xbb70baef, 
	0xd242bf36, 0xa4f193f1, 0x9f2e88af, 0xf1c31aca, 0x87b327cf, 0x7eb253f7, 
	0xddf8ba23, 0x4387e922, 0xb1f6e1bb, 0x3819c643, 0xc55db1d6, 0xc2f66a1d, 
	0xe52ff63f, 0x9ac3c5c3, 0xb48cbe95, 0x83b0ed7b, 0xbae0f790, 0x5af1b2c6, 
	0xf2b739d8, 0x1f6c44bd, 0x57b108cd, 0x247bf934, 0x7bf93513, 0x6e9da683, 
	0x0a38c873, 0xec1a41d9, 0x325ed328, 0xbb48a8ed, 0x3e8def79, 0xb108bd6d, 
	0x010a965f, 0x93dbe177, 0x7cc0efae, 0xb2bf973b, 0x97fef438, 0xde559b0e, 
	0x49e9a527, 0xb568df7c, 0xe9077a7e, 0xe5cab793, 0xbedd4aef, 0xef9e2de8, 
	0xcbbbeba4, 0xfa978e39, 0xd8673e27, 0x8658e2fa, 0x1f2bfaf7, 0x8f139eca, 
	0xfc016476, 0xed2a623d, 0xf2a7b02d, 0xad6c2e2f, 0xe0dd8569, 0x027dc44f, 
	0x270fc779, 0xeec04e3a, 0x9f8649cc, 0x1922ccf0, 0xfd4eb97f, 0xee19481e, 
	0x7f827809, 0xf915a897, 0x5952d7ed, 0xb9e2096f, 0x4243bf18, 0x692e2b78, 
	0xeb9677fd, 0x7a139af1, 0xeb39da94, 0x7a76c1fd, 0x4576c694, 0x6fa278f1, 
	0x5d105fdc, 0x6c7d8ad5, 0xef21e231, 0xef2e5db1, 0x259b282b, 0x3ab7a41c, 
	0xe273cece, 0x106f38f7, 0xdff713ba, 0x43aefe0c, 0xaa73d285, 0x2cef71bd, 
	0x41ca3dfe, 0x9bf0373d, 0x1ffdbf41, 0x192f091f, 0x2d5fe55e, 0x7d51f456, 
	0xb3bba493, 0x7ed2ffd8, 0xe47fe66c, 0x6788cf65, 0x39c6497e, 0xd9579246, 
	0xb4f9f836, 0xc7b0cd53, 0x1f727ecd, 0xfb609d3f, 0xc04f3f3e, 0x1db7f6bc, 
	0x027c43ce, 0xb780c647, 0xb2c799dc, 0x3d082059, 0x8cfe90cf, 0xfdf4e3ac, 
	0x8afd69d7, 0x923ebc69, 0xf744356b, 0xe924ddd7, 0xac557f73, 0xb361fbf9, 
	0xb9eddf71, 0x7b661b75, 0x84e7a9e7, 0x8376fddf, 0xc068ccf3, 0xb737b8d9, 
	0xd9c2ee67, 0x87e3c25e, 0x60b2c7d5, 0x2a3df377, 0x90d7e0f3, 0x27ea007e, 
	0xae45f60f, 0x62cf5c23, 0xabd7e83c, 0xf3f7526e, 0x7bfecb57, 0x827b52e6, 
	0xaf75c3f7, 0xfecd7964, 0xe6f7c1fc, 0xafd4bdf8, 0x4ffb27d7, 0x2ff7fea5, 
	0xf4d1f795, 0x80963dcc, 0xd2c758e0, 0x63bf8642, 0xef6ce15d, 0xb37be0e1, 
	0xc43be83f, 0xf4a972ad, 0x925faa1a, 0xf6bee7db, 0xcdd4ace7, 0x7e87f4c3, 
	0xe37ea856, 0x784def82, 0xc804dfa8, 0xc12f5ce9, 0x53207b05, 0xfcf6f5e6, 
	0xc38270e8, 0xb183c727, 0x5fa575f1, 0x38267883, 0x93758790, 0x9e20a7e4, 
	0x97e8d9b5, 0x9ee1f3fb, 0xe09fea0c, 0xf5c2673e, 0x72d9c3a3, 0xf024af9e, 
	0x258eab3c, 0xfbe69e60, 0x5a7bea73, 0x2ff62cdf, 0xb5ceb82a, 0x7aa27bc9, 
	0xd30af6be, 0x61db6e45, 0x03820789, 0xe05d63df, 0xf5db330f, 0xcebe24b9, 
	0xc17d9e61, 0xcf384c7e, 0x89c13ad1, 0x05f6f0c0, 0x61c26fe7, 0x76f0cdc2, 
	0x044f782b, 0x16dc33df, 0x829f6f05, 0xf1c6afd7, 0x65ff8c85, 0x14331ee0, 
	0xdf3905de, 0xb8d869ba, 0x88674405, 0xaeb9b63c, 0x817c83a9, 0x5c92755c, 
	0x3a74568e, 0x8cf77201, 0x5fcfd792, 0x7cb34e5e, 0xe5ca09ee, 0xc3925efe, 
	0x70e505b7, 0x491e9ca4, 0xfcdd132e, 0x375f7c85, 0x91bdf25b, 0xf2099c6d, 
	0xbe08f2fd, 0x8c93783f, 0x95e87ceb, 0x5debdaf4, 0x5bd37cc8, 0x86f990bd, 
	0x1f7f539f, 0x92d9f5da, 0xfc3cf5ef, 0xd4f8100e, 0x77e9245b, 0xdc07be38, 
	0x7c91c390, 0x7bf1507f, 0xac3f2a87, 0x18fef932, 0x9239f3d3, 0x6f7ca123, 
	0xdfc737be, 0xbb7afd4f, 0xc3e0ff65, 0xfdf0870f, 0x45d03c86, 0x37c13547, 
	0x507ef82f, 0x32bd108e, 0x68be40dd, 0xfbe25faa, 0x39fbe25e, 0x87f4c38d, 
	0x7ea8ce7e, 0x4def821b, 0x7ef90678, 0xc3d92bdd, 0x03c63df1, 0x7c572fdf, 
	0xe4b3c41f, 0x97cc5efb, 0x6e579bec, 0x41f07992, 0x47fe2b7c, 0x7ff3c3bf, 
	0xe4ab7cf8, 0x7fe2477c, 0xaa73be13, 0x04a3e27f, 0x072987d0, 0xf347c17b, 
	0xff40fae4, 0xa9ceed98, 0x61c20e79, 0xc2d563f2, 0x97dddb6c, 0x36aecba7, 
	0xaf65d33f, 0xf2417490, 0xfdc6e196, 0xb974a18d, 0x6f65d14e, 0xba0d96aa, 
	0x7d4857b4, 0x93941b94, 0xda8facd9, 0xce03670e, 0xf017455c, 0xa3e9879f, 
	0x8b6e89eb, 0xa857de14, 0xdf6a503c, 0x417c9765, 0xf579f0fd, 0xcfb4872e, 
	0x1e31b84d, 0x147ffcf8, 0x8baee65d, 0xfd797496, 0xc447d631, 0xdc974c5f, 
	0xdef83f9f, 0xfa8fbf1c, 0x58e8fa95, 0xd732e81e, 0xa5eba75c, 0x13fffdfe, 
	0x0069ea94, 0x00035b01, 0x7ddd9c78, 0xd5d4780b, 0x4999f799, 0x08c24cc2, 
	0x9c048203, 0x90930184, 0x10edd0cc, 0xf2851250, 0x537092e7, 0xe41a091b, 
	0x4048203a, 0xd76d4b76, 0xc7ed7e8d, 0x0490213f, 0x245c24bc, 0x6c777744, 
	0x04932109, 0xf8add2a2, 0x0ff5fb3c, 0x77560285, 0x7caed775, 0xc2776edd, 
	0x43f71b5d, 0xd5d4db4b, 0xef7f7bf6, 0x99332739, 0xeeec0624, 0xcf2fbf76, 
	0x7fe673c3, 0x7df7973b, 0x0f7f7bcf, 0xfc0a4b2d, 0x6885aba9, 0x0fe99fa9, 
	0xf26214cc, 0x5f612492, 0xa765c427, 0x0b966f99, 0xb4ef2571, 0x508fcf0f, 
	0xb9e8301b, 0xa39972d3, 0xf55b6884, 0x6cf3cf99, 0x538bfdf4, 0xb545fb4f, 
	0x5a83a7ea, 0x7d135bf4, 0xa155dfce, 0xca6fcb5f, 0x8203f2fe, 0xb0876cda, 
	0xb7efa5ef, 0x83bbf29c, 0x5f313c72, 0x85fbb288, 0xdf46be48, 0xf3f12695, 
	0xbe53d2b6, 0x4c42d1d4, 0x9262122c, 0xafdb1fbe, 0x1d9bf0db, 0xe7bb7ed1, 
	0x7253b5f5, 0xb3acfd5e, 0xcb54fbfb, 0xdd2f3b17, 0xf255c5ff, 0x9e9f1e7b, 
	0xf71fd5b7, 0xcd277be1, 0xbe8f5c43, 0xe12bd977, 0xa307dfc5, 0xf8e7eafd, 
	0xfbab944e, 0x637cd457, 0xe4f3d7de, 0xe3fded79, 0x04aef7cd, 0x73d05561, 
	0x31cac133, 0x0e777f09, 0xd4d5c2b6, 0xd6d45dcf, 0xa48fa8da, 0xe082cdab, 
	0xfd72289c, 0xc5a9e126, 0x4b8acc2e, 0xfbdd2ed4, 0xf7e64896, 0x7fc0d57d, 
	0xa5abe58a, 0xd5c49bfe, 0xf7d1b73f, 0xc4d4eead, 0xfee997aa, 0x466c2b18, 
	0xcab3c884, 0x74b38887, 0xcfb8fe7d, 0x9fe7e34e, 0xd0443e39, 0xd8869d78, 
	0xc4243e6c, 0x85d369c9, 0xba6214db, 0xb595fc30, 0xf4c97f74, 0x8bee82cd, 
	0x7f02e9d2, 0xfd6b3dfa, 0x6b865174, 0x7fcc25bb, 0x39f06215, 0xdbcac8fb, 
	0xfd3df884, 0xcf4b66fd, 0x4db53b76, 0xb8a70e89, 0xad88568a, 0x44fd6923, 
	0x0b378367, 0xa6bb9851, 0x7d147c48, 0x6f3d4daf, 0xab9a314c, 0xa71c42dd, 
	0x7bd186f7, 0x4d237d07, 0x9fd1a7e0, 0xf4402c76, 0x8fee9478, 0x0efd1cde, 
	0x33375b7f, 0x2f13fb1d, 0xf6f185d0, 0xe8d9e6d3, 0xef0dc9f3, 0xe11f12f8, 
	0xefc02efb, 0x3e5392c8, 0x40e08c31, 0xc9c700b7, 0x4e7f084b, 0x5be662f4, 
	0xff3bb9ab, 0x216f7a19, 0xfa9f338d, 0x553c216d, 0x84a7a70c, 0x0fb4c1cf, 
	0x3e1194ae, 0x873c6247, 0xaf83bb3f, 0xeae3defd, 0x0477f53e, 0xf64aadfb, 
	0xf403a877, 0x3bdf2db1, 0x99f1fb8f, 0x7aab6e34, 0x1f26e88f, 0x765ad374, 
	0xbe05e5ca, 0xd95ca782, 0xbae7d1c9, 0x1f2efa1f, 0x50257774, 0xfc25ef95, 
	0x77fbd15c, 0xec7ce9c6, 0x8701cbdf, 0xa85d781f, 0x5f9aaff7, 0x61f2db8b, 
	0x36f5c9fc, 0x43ddfa3f, 0x59b71ff3, 0x32e983ae, 0xdfee1c6e, 0xad4fbd1d, 
	0xbf47fb1f, 0xbf78fe8f, 0x804fbdc7, 0x62df8875, 0xe80563b9, 0xf7e42897, 
	0x205a6f98, 0x3c076c4d, 0x3d01d403, 0xc2891b77, 0x3c8879a4, 0xb9e39561, 
	0xd044a5f1, 0xe5bfe769, 0xd13fc579, 0x33a4af7d, 0x6bbdb3fa, 0x3f6cfc32, 
	0x2fd856e3, 0xa6101b52, 0x43da93bd, 0x15e30c83, 0xd5073b6a, 0x96d9fd33, 
	0x2f495108, 0x6f1d4e15, 0x8e3f6025, 0xfb1f792f, 0x3b0d12e2, 0x7c3bd699, 
	0xf01318fc, 0xc3997428, 0xba608fde, 0x57decab3, 0xbc1357cf, 0x5e51853a, 
	0xc76d7449, 0x6e929588, 0x1cae81f6, 0x4f89dcb3, 0xa9c2db46, 0x3417c9df, 
	0x4c4385df, 0xe5f1f61f, 0x17afb922, 0xc73c7cae, 0x5bfb2356, 0xdc2de348, 
	0xbad86c66, 0xabefe78b, 0x71fd7a23, 0x85e3a491, 0xd5d191e9, 0xa7088473, 
	0x66a6fe86, 0xe7af5a04, 0x6113e235, 0xd3544867, 0x60eec27a, 0x6a5ccd42, 
	0x3bb3e6bd, 0xb387df68, 0xcabb63c5, 0xf6f09fb8, 0x09f3deec, 0x795f4cbb, 
	0xa68bae50, 0x2f8bc223, 0x46bf30f9, 0xea19f117, 0x7a7025b7, 0xfdf902d2, 
	0xf8fa679a, 0x0fadb75e, 0xaf76fc48, 0x57f50473, 0x5dfac7db, 0x7bf739ff, 
	0xc79eaf8d, 0x27a445e3, 0xb30fe09a, 0xae1d393e, 0xaf7c435d, 0x3716e1e5, 
	0xe45a7dc1, 0xa26e3df8, 0xcb57e9cb, 0xbed371ef, 0x39fd40dd, 0x7e5f81af, 
	0x884f72cc, 0x07e063ea, 0xd83e9797, 0x6fd8f80c, 0xd00bf73d, 0xa278cb47, 
	0xc7227ae7, 0xc0d30525, 0x4cba5b0f, 0x75d1255f, 0x69b6d17e, 0x266d7489, 
	0xffa99e12, 0x6fc41dc6, 0x1f0f81d7, 0xefa60b0a, 0xe7a0f9b3, 0xa6438493, 
	0x17e35167, 0x8b6b6f34, 0xff830ebc, 0xacf3906e, 0x43e515d8, 0xc0af3429, 
	0x993ad966, 0x9b3792ee, 0x1727f744, 0x3f05df13, 0xf9219ead, 0xc90ced6d, 
	0x6b73d56f, 0x0fb7e48b, 0xcb09386a, 0x494ad3f7, 0x3568e65f, 0x4483c10e, 
	0x4328359c, 0xe9f60bd2, 0x7c3eaf5d, 0x9dc2f80f, 0x5c34c583, 0x6db6fddf, 
	0x97e69388, 0x31b8fd41, 0x878d1e7e, 0xfb44577d, 0x43efe88e, 0xfefbc1d3, 
	0x8733739e, 0x6f9d3e00, 0xe7e7cbe7, 0x8f9cfbf2, 0x0cd8eb17, 0x65be6539, 
	0x863db906, 0x8c797aed, 0xa71d70c9, 0xfc261be6, 0x57216bd8, 0x992a7bcc, 
	0x34fbd05f, 0xfe78f9ef, 0xce8eb94d, 0x2b0edc1d, 0xe38dfba7, 0xd3089fa9, 
	0x33f2b0f1, 0x3f27dfd4, 0x32f80638, 0xf3f0541d, 0x12bf3c16, 0x75062518, 
	0x6a2de744, 0xde69ee89, 0xe6f7b397, 0xc76a3a8b, 0x254bdc93, 0x1f7dc6bc, 
	0x8bcbeebf, 0x41955c93, 0xbdcbdfd5, 0xa53850f1, 0x7a06df29, 0x61e4acdc, 
	0x1c2efc99, 0xedb89098, 0x68feef6a, 0xe31e96bc, 0x1e71c1c5, 0x66f8dbad, 
	0x79eefeef, 0x626f98ef, 0xdf31c30a, 0xa0df4374, 0x2d38e096, 0xbb1efa70, 
	0x4e7e063b, 0x217ecb82, 0x1cf40942, 0xc530c7f2, 0x9f4c4bf6, 0x5c27a0c7, 
	0x7c8626c9, 0x7a57be91, 0x884361c0, 0x998bdfed, 0x57d14067, 0xe6e75a99, 
	0xfc7e3c19, 0xfbe5ba7c, 0x2b23296b, 0x24bec79f, 0xfc17bb39, 0x4e6395ee, 
	0x0fa3d3c2, 0x1976be48, 0x65f699f2, 0x90d4e8b8, 0x25a7f400, 0x880486db, 
	0xf3d3d6ee, 0x259f9049, 0x246487d3, 0xfbf71e80, 0xd236bf30, 0x97924c53, 
	0x1177a561, 0xea2d9a34, 0x3fbd1d6f, 0x68c9e993, 0x7d1bfac6, 0x07ecdfa4, 
	0xac1c8c1e, 0xf2f409b7, 0x713f8d38, 0x89d186c5, 0xf2a2c7a0, 0xa5e27fca, 
	0xeba0a490, 0x95e5e9a2, 0x47df6907, 0xff00d866, 0x067efddf, 0xbe9e9fc3, 
	0xa4437903, 0xe08db6f1, 0xdb966292, 0xfc695bcd, 0x374f9291, 0x81e37d14, 
	0x3e291fc1, 0x0bebc1d1, 0x3cbe1f43, 0x04c73bfc, 0x23a20ff3, 0xdce1f7da, 
	0x4ce82651, 0x67de7bf3, 0xd059af34, 0x5e31d65b, 0xefb8f5c2, 0x746dfd24, 
	0x2cb7df74, 0xb0961c6e, 0xf03fee5b, 0xf02fec29, 0xcf093ba9, 0x2e121db5, 
	0x6a4d63e0, 0x5203853f, 0xd53f63be, 0xaa7ee5ba, 0xadebfb95, 0xd3e5c25a, 
	0xd4e7bdea, 0xca4709fe, 0x583e8a7d, 0xb5fde36f, 0xdcb17c1a, 0x7c4ffd87, 
	0x83462fd1, 0xface3e1f, 0xe081287a, 0xa0dbf74f, 0xa05f021f, 0x9fa04993, 
	0xbbc061ab, 0x2e5c1f5b, 0xab8241f5, 0x71cd9ba4, 0x88d7e07a, 0x49d2c40f, 
	0x7ab9f5c4, 0x03d2a160, 0x879e950b, 0xf03d4af5, 0xa5f40fbb, 0x45b92607, 
	0xc9277870, 0xf119d04f, 0x6611c6ab, 0xfbed397e, 0xc07f630b, 0x4d1709f8, 
	0x910ca82f, 0xd252ff7c, 0x87e254b0, 0xcacce797, 0xe7e0dc83, 0xcc17deb4, 
	0xd2c567df, 0xba6ba041, 0x5f5b7c0b, 0x191d7617, 0xde1d7b16, 0x8579fd4c, 
	0x6b365dc8, 0xe80e7baa, 0x3f55942c, 0x6d39ad12, 0xf5c849c7, 0x887b9bd0, 
	0xe11c2fe7, 0x205ed31d, 0xdafa8530, 0xc779d151, 0x5eb51eb7, 0xb9cf5a8f, 
	0x58fea407, 0x01fc7b98, 0xebdef5f1, 0x0921cfd5, 0x4fad6f31, 0xed6e1225, 
	0xef1fa96b, 0xc7d86d97, 0x244de81e, 0x932f3a5f, 0xaafd84de, 0x5ba726f4, 
	0x6fa27618, 0x6283d147, 0x8c97bd10, 0x3f7cb5eb, 0xf4547098, 0xf41cc3d2, 
	0x279e813c, 0xd0730917, 0x97add114, 0x0256fbd1, 0xce6873f5, 0xba36d33a, 
	0x21759eb7, 0x40c7fbfd, 0x4f739727, 0xb1fc022f, 0xc75a268e, 0xf33b44e5, 
	0x4f7ddc87, 0x1607c1fa, 0x0fc4faae, 0x7fea203e, 0xf5a0109d, 0x0770b92c, 
	0xd69e7b8f, 0x4f784a99, 0xe19e7a9f, 0xf4c5edf0, 0x0c42c7ce, 0xfdd50d4d, 
	0x55c32273, 0x3e3c1054, 0xdd6ef7a0, 0x05c1fccc, 0x3c02cdba, 0x24496883, 
	0x579d3177, 0x5108e654, 0x5c1f106c, 0xc3ba304f, 0x0d3b616a, 0xb51f40a3, 
	0xeba2a6c3, 0xfc5c27e5, 0x02c8d95d, 0x62f7f107, 0x75fb4ff4, 0x598fd4ee, 
	0x2812beff, 0xdd93764f, 0x2cde7f30, 0x65fbe417, 0xfcfb03e0, 0x6cafd236, 
	0xb80d3edc, 0x7c279914, 0x1e7f3e78, 0xfc2bdbed, 0xf4f21fbe, 0x351fb533, 
	0xf74cbebf, 0xab8bd021, 0xc95b07c4, 0xb514286e, 0xf02f6ac3, 0x35d5fd7c, 
	0xefc2a7e8, 0x17d9f826, 0x12eefda9, 0xbe89eb33, 0x58d6be8a, 0xabe88236, 
	0xf671a470, 0x8d9f5a59, 0xe1f05df4, 0xedcf5dc3, 0xaf6ba06e, 0x34569730, 
	0x9219fbd3, 0x5487805e, 0x09178785, 0x4916230f, 0xafeb42fd, 0xafc41f1a, 
	0xcfb91f18, 0x11f1247f, 0x63e311f9, 0x317723d7, 0x004ebe3e, 0xdbba2549, 
	0x3e60c00c, 0xf5e7c91e, 0x334e9a38, 0xe5bd4916, 0xe9bad4cb, 0xe25555bd, 
	0x77a4ad8d, 0x2e084514, 0xd6846798, 0xddeb5115, 0xf7a5f84a, 0x829ef192, 
	0xc9e02af7, 0xc188fc01, 0x0899f8b1, 0x5f3d10bc, 0xbb06da09, 0x432f2f89, 
	0x2f89e7bf, 0xab5faa59, 0xba14fd82, 0xd2459cdf, 0xa42659ce, 0xfd0cb6fd, 
	0xc4a7bc4a, 0xfdd3ebf6, 0xa0a79516, 0x6fdd12df, 0xea1bf548, 0xd514efd9, 
	0xb7ea896f, 0x915fbba4, 0xf551fbc2, 0xdf7e8d9b, 0xa54a7ea7, 0xb0c5749d, 
	0xfbe9b8a5, 0x9f924582, 0x5a3fb40d, 0x400cdec8, 0xc27fd5ae, 0xd2bbb078, 
	0x293f0f19, 0x5de2fb96, 0x627c01e0, 0xe82f75a4, 0x50d770e7, 0xcc5eb7de, 
	0x1f145b6b, 0x1f12c599, 0xdf922ff7, 0xe5245ead, 0x4fa261c1, 0x91e81f73, 
	0xe3d10df6, 0x94a7cde1, 0x0c7b5bfd, 0x27ef2ff6, 0xfcbedf9e, 0x3ef9dbc4, 
	0x2f6411eb, 0xe5c904f8, 0xf9b64bcb, 0xc7db2a44, 0x49946ff5, 0xa75e843a, 
	0x245c3dc7, 0xb5db36e5, 0x636f5c41, 0xdbed97fb, 0xa433d80e, 0x26dc11ff, 
	0xbcbae605, 0xdac7e8b5, 0x9fa6227b, 0xf15e6a49, 0xad0272fc, 0xf031f6c7, 
	0xa4cc3d51, 0x9eafcef9, 0x7fd812e9, 0x70130bcf, 0x6ff7a78b, 0xc3ef43f6, 
	0xfe491577, 0x4963f2b3, 0x917f57ef, 0x9df82010, 0xf33f4bf9, 0x6917c7d3, 
	0x62bf43fe, 0xfc0d8ff8, 0xc7fc12a7, 0x18fa2a29, 0xf18062af, 0xe7bf67e6, 
	0x1ec09c0f, 0x9de3ce3a, 0xc79c36dc, 0xfdc91733, 0x7e953e95, 0xcf1d147d, 
	0xdfb3c6ae, 0xf12efa41, 0x985b80af, 0x7e2101e6, 0x875ffc03, 0x287c919c, 
	0xc0aa302b, 0x8ff312f1, 0x143bcba7, 0xf8af9a9f, 0x87c925e4, 0xb8625da4, 
	0xb0bc77a0, 0x2ccbca48, 0x94b27f25, 0x48b3d97c, 0x45badbcb, 0xebe7f271, 
	0xe37ababb, 0xac2f1639, 0x64ccdba7, 0xdf3c15e8, 0x30efacd3, 0x51f9e45f, 
	0x83f5dc5b, 0xef4f297c, 0x9712e701, 0x443f4b37, 0xfb9b1c3c, 0xece1e381, 
	0xf6807f12, 0x08e03167, 0x33fdcdbd, 0xd755e386, 0x731fde58, 0x542a9f15, 
	0xef862a7c, 0xef8beb1f, 0x8afa9dcf, 0x1e7ef98f, 0xca23afcd, 0x841e59f7, 
	0x27411c14, 0xf2be59b7, 0xbcf83d99, 0x1862ca1f, 0xcc56e172, 0x75d928cf, 
	0xf43cfc12, 0x4e12f73f, 0x6d865c5a, 0xa2ffc93f, 0x9ed89eaf, 0xf9f15db2, 
	0x302e52f3, 0x6072537f, 0xcb2e607e, 0x4df14b01, 0x377319f0, 0xf5fc97be, 
	0x64d09a76, 0x2192dfba, 0xf4e1e3af, 0xb5d38077, 0xb79f9c3f, 0xf5fe2478, 
	0xbfaf1a38, 0x284af350, 0x2fbcfc56, 0xfe625dfc, 0xf7a217ee, 0x800fcefc, 
	0xe0fd55c7, 0xafcd5ab1, 0x9639f14a, 0x1f14bb23, 0x525f7826, 0xb940787c, 
	0x7f12bc01, 0x81b96b0f, 0x7bd93ff9, 0x9a2c47fe, 0xfe7bd9bf, 0xff300c9f, 
	0xbdbf9865, 0x280ffcf7, 0x355dfd3e, 0xc357967f, 0xecfff3a3, 0x9e93e546, 
	0xfd4f96bf, 0xf7d43fcd, 0xf71787fc, 0xfe7a1f4d, 0x3fccfd25, 0xc494ce5e, 
	0xb1647fcd, 0xca03db94, 0xe49fcc41, 0x8ff21860, 0xe2a23bbe, 0xd04b9006, 
	0x83920763, 0xd1bfc97d, 0x5fe462d7, 0xe87bf7d7, 0x3f17cce7, 0xb3b27c56, 
	0xe990bd4f, 0xd6b1527c, 0xf8a4ffb3, 0xafdcf866, 0xdcf983ff, 0xe97ee2fc, 
	0x035816cb, 0xd6ca373e, 0x9f347e17, 0xe6509a4b, 0xb902969f, 0xe4627741, 
	0x93d2b246, 0xdd7fe207, 0xd4f02f7a, 0xfc7def43, 0x1fbde81e, 0xef7a81fe, 
	0xd7cfe2f2, 0xf9f3897b, 0x7e4bf7ab, 0xe8ad5eea, 0x8f10b66b, 0xd7bd6b14, 
	0xa0a7f514, 0xbaabaef7, 0x0dae3b65, 0xe5505d75, 0x9ebfdeda, 0xe07e8dfb, 
	0xe307cf1a, 0x8be6a4f9, 0xdebf53e9, 0x0a299e03, 0xbde9fd9e, 0xd59e947b, 
	0x66fd2c5e, 0x7d27c39f, 0x1dd3ed7d, 0xe101d2fd, 0xd124f99f, 0xc9f0e7c3, 
	0x3a6b2fc4, 0xef31eea8, 0xd07f4ac1, 0xf108f3fc, 0xfbfd58e9, 0xe39be2d9, 
	0xc00e1fa3, 0x1e3eb547, 0xfd83bebf, 0xbeb921f2, 0xe7df5865, 0xfae8d1f0, 
	0xeac7140e, 0x17852e63, 0xc7c15fcd, 0x70f5f563, 0xd9f1cdf1, 0xb3e0070f, 
	0x5f882eda, 0x9f3fd59f, 0x825c7de5, 0xbf81f675, 0xf1f67c1e, 0xfcd67ee8, 
	0x763d7c16, 0x926f273d, 0xe3fb6aef, 0xbc7f6543, 0xf6637c57, 0xd5df3c47, 
	0x6f9e88f6, 0xf49fd4fa, 0x8a2dc3c0, 0x023db4ce, 0xf18cecbe, 0xe15afcab, 
	0x94ec08e1, 0xca76a327, 0xed17e211, 0xd21da4a3, 0x43a1fc4e, 0xa575f3d1, 
	0xfb291c97, 0xf58976a2, 0xf07d1be9, 0x924523f1, 0xe4bb6b0f, 0x01a9d148, 
	0x93f312ec, 0xedbd5d13, 0x43fb7892, 0x0a499bcb, 0xdb71022f, 0x748f1964, 
	0x17c28fee, 0xc9af3b7f, 0x045f18f7, 0x9e21c009, 0x3f8b5c9e, 0x04988edf, 
	0xb11d82ba, 0xd3d30ce4, 0xb636a19e, 0x6b165223, 0x5fafd0fc, 0x5b653d12, 
	0xe359e07e, 0x17ed4129, 0xed7a0bcc, 0xd693cc24, 0x2eabbb9f, 0xcf9f105f, 
	0x12ee386d, 0x819ce916, 0xafb12ed3, 0xcb54fc77, 0xcc5385d3, 0x97c3e87c, 
	0xf58a9e95, 0x7938d3b6, 0x75dc658b, 0xedba21b1, 0xb968f723, 0xf4843dae, 
	0x9f258b09, 0x8b5d6fec, 0x7ecabaf5, 0xe077f4c7, 0x2fe99bb0, 0xcbe6b173, 
	0xbd1bebf4, 0xe8a895d7, 0x4cd2616f, 0x2e42d7f6, 0xf0515f57, 0x7972964f, 
	0xf3de86e8, 0x3de8f8d1, 0xb3afda0f, 0x33f061e8, 0x0aed479e, 0xaee3cf3f, 
	0xc5def86e, 0xf6f44df0, 0xcf5b879c, 0x9394b963, 0xc05c19c4, 0xe77e3c4b, 
	0x615f83f6, 0xfc367c48, 0xd78f0466, 0x3f2ea76d, 0xa0a9f2cf, 0x2bf40e1b, 
	0x2927cf86, 0x8be82ebc, 0x1f21f56f, 0x7cfe2c97, 0xf340b57e, 0x3c93d2ab, 
	0x779ca79f, 0xd43d7d33, 0x2487febd, 0xa57e297d, 0xcd4831e7, 0xe962e163, 
	0xd0605eef, 0x3c48727e, 0x7a4dafc0, 0x52fa1848, 0xe18bab18, 0xf86fa457, 
	0xaca5c905, 0x7f592325, 0x43bd236a, 0x9fbe1f10, 0x598ce3d6, 0x36eafe0f, 
	0xf1c5d747, 0x7eff7a7e, 0xe76e4cc3, 0x204a457e, 0xd167af86, 0xd9d7b138, 
	0x0ed4ffd4, 0xda54ce39, 0x17c46d84, 0x78e41703, 0x3851ad81, 0xe31dafe1, 
	0xf07ab79c, 0x9c374f47, 0xee9c31f6, 0x50797257, 0x813c60c0, 0x6fa7812e, 
	0x5be9e375, 0xef22af4c, 0xde40277f, 0x650ce684, 0x9d143a38, 0x92b7dc94, 
	0x2ca3dafd, 0x31fb072b, 0x642824e0, 0x8fbd3e20, 0x864d90e3, 0x45ce6395, 
	0x77f486be, 0xd355fe22, 0x353bedc1, 0x1f6fb167, 0x911fbb08, 0xcaceebf7, 
	0x5ec35779, 0x38b9da2c, 0x1ef963f1, 0x79a6b3f4, 0x3cc4fa0f, 0x5e25a9f8, 
	0x0626bd46, 0x9c9d7ec1, 0x15c72057, 0x33e01736, 0xdb14ef39, 0x9de693bb, 
	0xff5c41ca, 0xe3ebf63c, 0x21702eb8, 0xd261621f, 0xb1d822f1, 0x780c9201, 
	0x6da5767f, 0xda957988, 0x9cbb9611, 0x3cf36ef8, 0xfa4b5dcb, 0xb339ece6, 
	0x86272b5e, 0xae953b39, 0x96753f71, 0xc31b5dcf, 0xf0ad6f07, 0x56f7bc71, 
	0x5b6d1fbb, 0xfb478d29, 0x582aa9b2, 0x7ff687bf, 0xe1634973, 0xba8bc468, 
	0x85f13abe, 0x24d7e932, 0x52f90ece, 0xc1e27f04, 0xa0c791dc, 0xfb78f26f, 
	0x9ecce3a2, 0x0e3dd057, 0xbcf356f8, 0xcbf46e53, 0xecacd890, 0x9857826b, 
	0xc79f03be, 0xe1e7e077, 0xe21f0ad4, 0xa745cd81, 0x78cbb702, 0x278c18f8, 
	0x6f7db78c, 0x9bfb4655, 0x3fb8663d, 0x638e05f1, 0x79fca5b9, 0x387e0ddb, 
	0x87e4983b, 0x7a5569fc, 0x0160ecd4, 0x3de0fbe7, 0x62c1ff8c, 0xbb322799, 
	0xf59fc954, 0x3f903905, 0xb94f4bb3, 0x5b47c4bd, 0x2ee3829d, 0xe6434e6d, 
	0xf29f6473, 0x55a26f21, 0x58ff7798, 0x98a7e7ce, 0x0151734f, 0xee18c7c7, 
	0x731c28a1, 0xcfbf4887, 0x41e1176c, 0x481ae144, 0x96615f1d, 0xeba4ae02, 
	0xbfee8975, 0xfbdfd770, 0xe2fe955e, 0xdebeed8a, 0x15170eeb, 0x993ca8e4, 
	0x4977295a, 0xeb57ee3e, 0x7dd6a0bf, 0xf987be56, 0x33fd6234, 0xeb1faf7b, 
	0x8cb8885e, 0xae2efbb2, 0x7046f5a7, 0x6befeb4d, 0x7c27a9dd, 0xeb31bb90, 
	0x61ed87fe, 0x2de46f85, 0x7c915e40, 0x807dae6a, 0x9c251dc7, 0xd1679083, 
	0x6adfb418, 0xef737ea7, 0xbfa53a26, 0xab7184fb, 0xb949738c, 0x02def1a5, 
	0xc7fb3b7c, 0x2fd14377, 0xef3f8b17, 0xcde86e23, 0xa2ccaf2b, 0x71b7907e, 
	0x0e5bc55e, 0x2aae9c90, 0x7921a9c8, 0x558beff3, 0x8932a9fc, 0x44fa02ed, 
	0x6f71a6ec, 0x79642a49, 0x989deb84, 0x173136c7, 0xd1077bf4, 0x0897a0ea, 
	0x6289edfe, 0xc489c910, 0x3d0c6122, 0xaa28fe0a, 0xae21af60, 0xe3807095, 
	0x6524c268, 0x70e416cf, 0x0a7428ab, 0xe396b9cb, 0x47e1c132, 0x506b1fb9, 
	0x1a13e784, 0x5af8853c, 0xb3fccdc4, 0x3ee61090, 0x38cfd3ca, 0x1990e329, 
	0x322b726f, 0x99d795df, 0x58a81a91, 0xe7275666, 0xd7098827, 0x9f09fde5, 
	0x61b2f7ca, 0x91857adf, 0x666ff12d, 0x7883b9bf, 0x676f84da, 0x43fde879, 
	0x7c0f8453, 0x627dd0e5, 0x44c0ec23, 0x1e735461, 0x5338c045, 0x1f61744e, 
	0x84e9c871, 0xe706f0fc, 0xcdad47bf, 0x3c033aed, 0x06ab0a27, 0x0dba75fd, 
	0x84d62f86, 0x757f7a7f, 0xf9846b7a, 0x80bd745e, 0x1778899b, 0x4f203af2, 
	0x72be1cbb, 0xdf642fcc, 0xbd13f188, 0x2537de47, 0x949e73df, 0x9be75c71, 
	0x77e48adc, 0xcff275e5, 0xe60a75e4, 0xa4162897, 0xc8a4f5a8, 0x8291bcf9, 
	0xa7fa7fef, 0x4de701d4, 0xfef2c188, 0x4fb8c182, 0xfccb07cf, 0x7f307310, 
	0x5663e3a7, 0xaa63cca2, 0xe6b0f197, 0xf208624d, 0xb2d04443, 0x9cd0b790, 
	0xf7797a18, 0x3affc249, 0xc4f3cceb, 0xf7496e27, 0x439bed36, 0x6156a3ed, 
	0x4fc218dd, 0x5f386441, 0x66fe3b6f, 0x4744f3dd, 0xbaff358e, 0x5e1ffa97, 
	0x88522edb, 0xce54b4bf, 0x9cbb021c, 0xe21264e9, 0x88f4f792, 0xe692064b, 
	0xb51d03cc, 0x897da1cc, 0xe1af34bc, 0x60b963ac, 0x9fa86b38, 0xe4b2b2cc, 
	0x38e6b8d8, 0x6c1b4bd7, 0xbd287cf4, 0x85f6f88b, 0xb1aa5bb1, 0x8cfd349f, 
	0x9c73e773, 0x82524054, 0xfad57b2f, 0x8c7603c4, 0x794e176b, 0xb9f935ed, 
	0xf326cc35, 0x06c2dc5a, 0x453a64f8, 0xa5d12b68, 0x39db0c21, 0x4d85f993, 
	0x5bec5fba, 0x6064347f, 0x234e143a, 0x0bccaaeb, 0xfd26bacb, 0x98ba13d4, 
	0x5609ad2e, 0x9f675f0a, 0xba62d6e1, 0x953de03c, 0xd06dcec9, 0xb55d0c5b, 
	0xd0499bb4, 0xa91e9823, 0x42a3f19f, 0xf91da77e, 0x8467f53c, 0xe461eb94, 
	0xcb120409, 0xfc23ef67, 0x59423204, 0x90b7907b, 0x42bff1fb, 0xf71f0f6e, 
	0xa9d6efca, 0x4de4303c, 0xf40c0f21, 0x54679f16, 0x0e7cf538, 0x3cb747f8, 
	0x5a5fcb8b, 0x1c95f2b8, 0x1c2c55e4, 0x9a18f322, 0xffbe4896, 0x3f2487fb, 
	0x597fe68c, 0xcf9a3abe, 0xff2487d5, 0x691e9858, 0x4b57fe47, 0xcd50e86a, 
	0x63bd686d, 0xe27d81de, 0x929d810d, 0xeadaf05c, 0x095ec2e6, 0x2779dd1d, 
	0x29dddbe7, 0x9ad69ce3, 0xe7bdc3a7, 0x4aaf2bd1, 0x591d6de5, 0xd016e27e, 
	0x15e5e5d7, 0xbf3090b7, 0xfd3838e9, 0x9c3c807d, 0x526b65dc, 0x38e49d87, 
	0x6dff7078, 0x77c3bd68, 0xf838e1ce, 0x479fe7da, 0xfab4227c, 0x84438e65, 
	0xc53d6086, 0x62725b5d, 0xcdc6d3f5, 0xbfc02e52, 0xf67e9014, 0x9f95979c, 
	0x57e565fd, 0xb7fc100a, 0x54fa912c, 0x20e461b1, 0xbf0c374f, 0x8fbe9795, 
	0x77ed23d3, 0x4e78cd18, 0x000fa4fa, 0xacacfed3, 0xc72bd26c, 0x0f2a77d1, 
	0xad7e19a3, 0xc2b718ad, 0x6f953c87, 0x953cc896, 0x7de32ae2, 0xf87c9785, 
	0xeea6bea5, 0xa73b2937, 0x34b5c545, 0x225a9abf, 0x25f3f5e7, 0x9fd3efd2, 
	0x2ccc4bfd, 0x760dbd0c, 0xbfed3562, 0x7df22573, 0x4bf713b6, 0xcb07707b, 
	0x4937f921, 0xf02f5d98, 0xb3fc6875, 0x8923d784, 0x4eebbbc1, 0xb3cdffb1, 
	0xf7de84d7, 0xb5ec0e4e, 0x760dfb6e, 0xdfd2ad5b, 0x397de1f6, 0xce34bddf, 
	0xdf94d7ad, 0x6b6fe88e, 0x2f978c89, 0x49f690cc, 0xd9145383, 0xaaea77e9, 
	0xe83e59a5, 0xc0708683, 0xbc14370e, 0x0709af3d, 0x258f3ef4, 0x991fc81c, 
	0x0ccb6d54, 0x49d25e12, 0xf04488ff, 0x211599bd, 0x79569ab9, 0xf090687c, 
	0x5ff501f1, 0x967bfd4a, 0x1f6087db, 0x93878036, 0x18bb4a5c, 0xe11ed874, 
	0x8d0260eb, 0x1f2ca9e7, 0x6c479eaa, 0xb646a724, 0x3453f60b, 0xda26f55c, 
	0x48869fa8, 0x04425d68, 0x2a52dafd, 0x398359e9, 0x826422f3, 0x13a672a7, 
	0x2699eaf4, 0x0f37d01c, 0x21562526, 0x19d3ccaf, 0x1096d479, 0xde7bcf93, 
	0xfd10513d, 0x5e9357b5, 0xa05cb809, 0x4d70dbeb, 0xf1d69e52, 0x4e9e683f, 
	0x6498c5e4, 0x873f509f, 0x03957f0a, 0xa3ce18fe, 0x28f006e7, 0x08fa74e5, 
	0xa678871a, 0x846cfa07, 0x3aaf90f9, 0x84b5b659, 0xa507aeb7, 0x443b9b3d, 
	0x8f891fc6, 0xfee9eaf9, 0x00b08721, 0x1cc3d26f, 0x6e3fb089, 0xfb40c8ad, 
	0xef089b6f, 0x9a1f97a4, 0xb93f99fb, 0x73b7ed03, 0x74ef8992, 0x03ad677e, 
	0xf21262fc, 0x34f5e9bf, 0xa728e18f, 0x9ca69bf1, 0x6968c1ce, 0x341d68d3, 
	0xf1aca87e, 0x54d3e00a, 0xe841d744, 0xf49774e1, 0x1a40a684, 0xbde365d3, 
	0x64091c97, 0x7e542d37, 0x490f2dca, 0xe82d0d7b, 0x921f1fed, 0xd37865f3, 
	0xd5136efc, 0xe011b549, 0xeb43d69d, 0x1c8cb66c, 0xa78707f8, 0x696b9758, 
	0xe42be922, 0xdf6a8dfb, 0x8dc21835, 0xf190c1fc, 0x0f806fd9, 0x612b1fa2, 
	0x2b37de0a, 0x25868781, 0xd084a564, 0xb817d90f, 0xdaf21abe, 0xdf0fcc43, 
	0xde177c04, 0x7f86e156, 0x7199f721, 0xdbd0014d, 0xe827d7dc, 0x6ee424b8, 
	0x07a9f663, 0x4217d7c0, 0xeb3d224f, 0x1959d2be, 0x5fef7e78, 0x4ae19ebc, 
	0xb2b29f06, 0x282dc7a0, 0xfdc6c8aa, 0xbad297b7, 0x12993ec8, 0xe641399a, 
	0xaaab7961, 0x3df4fbe9, 0x3f1a3784, 0xf98d7093, 0x62c84676, 0xee8cd381, 
	0x17aeb499, 0xe4270a87, 0x9f6ba876, 0x33ac7203, 0x877ac9cf, 0x99f34e7e, 
	0x2e92b90f, 0x8c495e3a, 0xb0f34f40, 0x4a99969e, 0x6f68e66c, 0xcdf90cbd, 
	0x6a1e929f, 0xc33c4e73, 0x70a70171, 0x51b87f40, 0x3de0e73d, 0x3ec7df7b, 
	0xdd3179a3, 0x6c467a1c, 0xf438bf04, 0x4758d8a1, 0x7dc21efd, 0x4b97e7c2, 
	0xd0eeffa4, 0x8f806125, 0x4a461eb1, 0x3243c952, 0xf5f7398f, 0xc5e43e93, 
	0xf87a68b5, 0x2bcd7096, 0x3791cf95, 0xac7c48d7, 0x0ccf863a, 0xe96e75df, 
	0xeeee2a63, 0x987875c6, 0x13b18d28, 0xe96b2e02, 0xf3e8aebe, 0xfead9240, 
	0x93bc98b9, 0x05cce729, 0xe33fb983, 0xcf1f8542, 0xca65ffa5, 0x4f83d139, 
	0xfe921f06, 0xca9fdf7c, 0xb76ef876, 0x04c9e785, 0xdbe414f6, 0xf830fe91, 
	0x3e58f028, 0xda72c9c8, 0x17cd89c8, 0xbd69f7e7, 0x7f17c88d, 0xc11de549, 
	0xe1f9d01e, 0x47bd327f, 0x7f81787e, 0xc12749cc, 0xfc37c0af, 0x346cfba4, 
	0xca70bbef, 0x325b1cf8, 0x9cccffe4, 0xb77931ad, 0xfa54fe13, 0x1f32d063, 
	0xed86ba9f, 0x447b038b, 0xc6d8ec0e, 0x62239480, 0x184fc92a, 0xe7230158, 
	0x0bd0fdb5, 0x971e2552, 0x29fcb3d5, 0x0169989c, 0x997c07a7, 0xee89db15, 
	0xbe36271b, 0xb84fba03, 0x8e3bbe8b, 0xfd0b5199, 0xd325e27c, 0x99d43446, 
	0x87613df5, 0x53791df3, 0xf033c2a6, 0x8335659a, 0x95ec9b0e, 0xdcabec3e, 
	0x3558f35c, 0x8bb947d9, 0x9abc71b6, 0x4b5639fa, 0xf6b868eb, 0xf91eac83, 
	0x25fbc069, 0xc40f77c5, 0xf32153ec, 0xc12202bb, 0x919e7265, 0x9fdd0268, 
	0x11e4bc24, 0x8a25b41f, 0x67045d2b, 0x0ed5becf, 0xcd6be90f, 0x5857ad42, 
	0xefc572fe, 0x5a760f58, 0x3c1df87e, 0x1b39fa42, 0x794e465d, 0xf98b5a25, 
	0x6d5ff815, 0xf5bf8c4d, 0xf8274cde, 0x9e47be11, 0x490febfb, 0xdc95f5ff, 
	0x87c16af7, 0xf38752d3, 0xd98f677c, 0xe23f83e5, 0x07ee7a23, 0xd64fdb1d, 
	0x4569dd62, 0x21f80e05, 0x43fda60e, 0xf5cdd62d, 0x34dd7430, 0x719a1fe6, 
	0x01f6a93d, 0xd9379e17, 0xfde0e4e7, 0x3483d854, 0x80afae5a, 0xbb8be3f9, 
	0xc275c186, 0xfe718374, 0x504e69ca, 0x1de735fb, 0xcbb34bc2, 0x125b95f0, 
	0xa19bf90e, 0xa67f6bb7, 0x3fb35391, 0x4fc68eba, 0x67e44ebd, 0xfdf03be2, 
	0x691d6a93, 0xf139fa42, 0x98e8ed7e, 0xeb944f75, 0x2921f17e, 0x7aef876f, 
	0x93f832fb, 0xcd3b7607, 0xfc92e3cb, 0x9a76ed89, 0x4f59437f, 0xb3917a3c, 
	0xd9b8f327, 0x788810bf, 0xcccf902b, 0x6adde77e, 0xdfaa75dc, 0x43dfde9a, 
	0xd93f70ff, 0x49f03fb3, 0x7983578c, 0x6edcb55c, 0x3d7fb45b, 0xf6ae3d2f, 
	0x853cf36f, 0xca54bf1a, 0x90f3e609, 0xbca51703, 0x1c0e5a10, 0x4a139188, 
	0x1fd3740e, 0xca4040e4, 0x523f7c1b, 0x1e024bcc, 0xcd706720, 0xc95921f2, 
	0xf9e5c007, 0x3f905749, 0xfcc5e93b, 0x7f747909, 0x4a5a419e, 0x562b9287, 
	0x2f2c9e74, 0x63f92b56, 0x9f587e31, 0x897e596a, 0x5d075afd, 0x77facfc2, 
	0xb96fd550, 0xa0d9df2c, 0x3661efd4, 0xe4a0fd3e, 0x39bfd08b, 0x2fa71bae, 
	0xede0fecf, 0xd6d3f45a, 0xf2916fed, 0x45ba03dc, 0x0ff518fd, 0x3be5a0fe, 
	0xc02beff1, 0x5998206b, 0xcf41f781, 0xfc63d7d9, 0x49ce8a33, 0x05e63b7f, 
	0x038623dc, 0x8c21b7f9, 0xeaf3ed7f, 0xb52d1c19, 0xb0cf51e7, 0xfde6ec3f, 
	0x96a5af38, 0x9e3ad5e6, 0x213cdbf6, 0xf924dfee, 0x9f9adb6a, 0xb9db0584, 
	0x6f83e71f, 0x7f097736, 0x67ae7ae5, 0xcdc62df8, 0x0390579b, 0x344cd53b, 
	0x24416eb8, 0xf9fbf295, 0x893953c1, 0xf7f9bf0c, 0x385bacf4, 0xaeb5c7eb, 
	0x21d9685b, 0x919acaeb, 0xce4e3c0f, 0x9a4f750b, 0x4937d3ee, 0x1f6ff2bf, 
	0xb85fab8b, 0x642fd557, 0x3ce13cab, 0xebac2795, 0x10cc6605, 0xbe192c52, 
	0xfb90ed9f, 0xa75a760c, 0x95e71cfd, 0x3c3ea4a6, 0x295ee4f2, 0x0f8f00bf, 
	0x5072931e, 0xd83e5ad4, 0xff970b21, 0x95d186e5, 0xdfb2d76c, 0xc308e0f4, 
	0xc680ba8f, 0x7bff956c, 0x6dffcca7, 0xc0bff953, 0x7ba7e83b, 0xe36f677f, 
	0x9bd667fc, 0xa1eae462, 0xd70e485b, 0x743bdf45, 0x61a67229, 0x4bdce40e, 
	0x7b7bd3d6, 0x9526bfcb, 0xf2a4d33f, 0xf9f5f469, 0xbe9f524d, 0x65c244af, 
	0xa7ce8945, 0x8d8fe2d9, 0xed2e1f13, 0x71d62719, 0x8ffe3d5b, 0xfa6c9fa8, 
	0xe7eaae7e, 0x3e44e44a, 0xb7fb0bf6, 0xb8e36212, 0xad69fd82, 0xd8c6e388, 
	0x65b31347, 0x777363be, 0x3f8b771c, 0xe3d31ed6, 0x8eae38eb, 0x5ff1eaab, 
	0x9497e353, 0x62bb7a48, 0xe891f8d1, 0x2b38d1f8, 0x3f60ef8d, 0xa4b88f5e, 
	0x1ddf8f4f, 0x7c67ed67, 0x892d6715, 0x355dff1b, 0x7e3d7afe, 0xd1f8e7a8, 
	0x5f1ea8b8, 0x66f388f4, 0xccbccb67, 0xd28f9566, 0xea6db452, 0xbf3f6970, 
	0xea2f8cfe, 0xb24e1427, 0xfed9936f, 0xa0df87cc, 0xaaea15c9, 0xc9573e47, 
	0xaf87e7a9, 0x1ae27655, 0x8f068fd8, 0xfc22f6c3, 0x2e34a998, 0xb256c7ed, 
	0xaff0412b, 0x09e7283c, 0xccf1123b, 0xc7e94ec9, 0x98bdbce7, 0x0f6b81fc, 
	0x16837dca, 0xb7b91274, 0x017104bc, 0x2f6473e6, 0xddbfce78, 0x8b0c798c, 
	0xc6c64dea, 0xfb0f328b, 0x5fd229b1, 0x8853b1b8, 0x20fbe937, 0x449908fc, 
	0x8607a8ff, 0xe523de7c, 0xc81be634, 0xec00f75e, 0x2a4df6e6, 0x53ea65ff, 
	0x8edfc839, 0x6f59f7b7, 0xbeb03fd9, 0xc6c87b77, 0x5b7a157c, 0xe7d48769, 
	0xcf9e2f30, 0xdefce8da, 0x7e52f3d0, 0xec23838f, 0x5fe9f87e, 0xc2e324d9, 
	0x8a66d6b3, 0xdeb2bd84, 0xa8b1f514, 0xbe254d43, 0xac937878, 0xd7fae62b, 
	0x03eeb2bd, 0x527710f5, 0xb31e5d5b, 0xfeb2ed7f, 0x9241eb8a, 0x5fc99eb9, 
	0x513a875d, 0x1d45afe1, 0x3317a2a7, 0x7d13e481, 0x6cc63adf, 0x1c3f8936, 
	0x073c7f3c, 0x83e2637e, 0x89a390cd, 0x73d671e2, 0x3adfc11a, 0x261cea62, 
	0x5d35fe4a, 0x7a4abe98, 0x117519bf, 0xa83760e3, 0xd755187a, 0xf0f75dd3, 
	0xd7faf8d5, 0xf75b9f15, 0xa4fc88d0, 0x5f92b452, 0xfce89754, 0x7d2513a4, 
	0x424001d5, 0xe3f463b9, 0xaad39383, 0xbf033f90, 0xf28bf0f4, 0xae07f07b, 
	0x7950e803, 0xde5547ff, 0xf79525ff, 0xb8fe7c8f, 0x03ae7f7c, 0xfef2a8b8, 
	0x1faef4a7, 0x85003ae0, 0x8793e857, 0xb63412be, 0xfff9de8a, 0xfce2e257, 
	0x69da27d0, 0xfda15d5f, 0x7d855ed2, 0x10bd6d42, 0xda49b97f, 0x0b4bf3a7, 
	0xfda7f05c, 0xe3f2f82d, 0xd025fd82, 0xbeae3993, 0xa9b97116, 0xadcfe02d, 
	0x422d4f1b, 0xbbf685fd, 0x69b8e9b5, 0xff6c39aa, 0xd9df6e6a, 0xebdff64f, 
	0xa2bac98f, 0xe03efb92, 0x3a59d47d, 0x6c78e39d, 0xb93f1257, 0xf839e695, 
	0xb40ee23a, 0x9d66095f, 0x087e7a41, 0x0fcb3974, 0x4dacc17f, 0x7b238f44, 
	0x43be23d3, 0x147a51bf, 0x44c39055, 0xb6d5556f, 0x550eba98, 0x5f39ed7f, 
	0xf0d1e8ab, 0x928fc357, 0x7e3d3062, 0x648f4dd6, 0x18bf4227, 0x1e815563, 
	0xe99f9ec7, 0x5d98f490, 0xc512ef85, 0xa3dcfc2b, 0xe9bab4ea, 0xaa9e62f1, 
	0xa81cb6c3, 0xf4d74b4b, 0xca4f3578, 0x293caed7, 0xfe3d355f, 0x3d27af26, 
	0xaf5c9a96, 0x68f4a375, 0x48fd263d, 0xae69ae81, 0x08a6eabe, 0xf872feae, 
	0x8aeb8353, 0x7c4c4f90, 0x6f1ce183, 0x225b8e07, 0xb1e5b2e9, 0x7b03b51b, 
	0x3b68b9d6, 0x703b03d0, 0xd40ed45c, 0xaf4f1e74, 0xf8d65385, 0xc1ed9f71, 
	0xed903b18, 0x6d03b642, 0x72f9588e, 0x07690ae7, 0xa07655a2, 0x98a77a03, 
	0x39707a4a, 0x5db595ea, 0xf41c7644, 0xe8e180a7, 0x74f40ecb, 0x4c0ed97a, 
	0x03bd0ceb, 0x2ee136bd, 0xbbe89efa, 0x08897e0d, 0x1b4cabfb, 0x81f3cfe1, 
	0xea3b62b7, 0xf7b72f03, 0x4e1703b0, 0xf49cfb93, 0xed3d7f6d, 0x84d7b693, 
	0x0fbe953f, 0xa272946f, 0x5ab8fe15, 0x3f80f7e9, 0x645441ae, 0x3d087e45, 
	0x1833a675, 0xd5b57e94, 0xd32fc704, 0x7ef4a5fb, 0x6f6934db, 0x169fc2b4, 
	0x68d3fa89, 0x4db35c4b, 0x88e1ea89, 0x780f80ff, 0xd47a5ed6, 0x696571c6, 
	0x8f2a7a27, 0xd19e850f, 0x7b5ebf06, 0x60dfbe34, 0xdebc599a, 0xdb7e994d, 
	0xd9dda885, 0xb44ccc10, 0x05ff9445, 0xf0b72871, 0xf69adc73, 0x0bd4e21b, 
	0x41e71f41, 0x22ffd2a7, 0x5f8c85b2, 0x2fc70578, 0x7b536b3a, 0xf3fa63f8, 
	0x48bab4cf, 0xb8471dce, 0xe02aa5e2, 0x4433fd99, 0x97a5e947, 0xef9b7ea2, 
	0x68d7f6f5, 0x36fc123f, 0x01dd1eaa, 0x36fda0b9, 0x19c66f36, 0xea3711d8, 
	0x2ffed1bf, 0x383b0f1d, 0x5dfd91a5, 0x3d904707, 0xb27d2863, 0x71fd606e, 
	0xaf373e40, 0x7c6b9f27, 0x92c7ca4c, 0x4096aafb, 0xef97f44e, 0xdca5717a, 
	0x55bcd1bf, 0x02bc82d1, 0xf764b7e6, 0x72470564, 0x5bf33bfe, 0xe93707a2, 
	0x884e3f3f, 0x3fc159d6, 0x1dff66ef, 0x3fcaf1d9, 0x7e917c0f, 0x347d8394, 
	0xcfdca362, 0x32af44c5, 0x430cd4df, 0xcb8b6cff, 0xdf856d37, 0x5592f09e, 
	0xf5675f14, 0x739f0e78, 0x8df3fca0, 0x13f9fedd, 0xdfcff0f9, 0x3fdbb1b2, 
	0x9b8e81ff, 0xaec18ea0, 0x82bb37ee, 0xae09fbf9, 0x2f4e3345, 0xfd81b5bf, 
	0xd967feb7, 0xd67165af, 0x73d74b48, 0x79c0d67f, 0x67ecc604, 0x1dd744a6, 
	0x9f1c3f9f, 0x0a70bc37, 0xb64cd7d1, 0x85fc24f3, 0x71a7aae5, 0xca52b07f, 
	0x19f3ce01, 0xaa96f129, 0x8422f6f0, 0xf99e8ade, 0xf9716d3d, 0x279f3a45, 
	0xf8e7df3e, 0x42379d12, 0x5e023ebf, 0xf384b87f, 0xcd5e546c, 0xb597c511, 
	0x4ad0ff7f, 0x90185fe9, 0xd27aca6e, 0x5a9581cd, 0x8f1dfe3e, 0xc7555ff3, 
	0xf8aeedaf, 0xbfce03e7, 0x11dfe694, 0xcba7ff9d, 0xcb2ffcf5, 0x30f8ebf9, 
	0xcfe33853, 0x2d2f8e76, 0x7ff121b0, 0xc4b87f16, 0x6fbe2bf9, 0xc5f7cabf, 
	0xa039a056, 0xcf1d62f4, 0x85e3f927, 0x8bda44fe, 0xfc147618, 0xe410e672, 
	0x3890a65f, 0x3374451d, 0xf3a4836a, 0xf4b1e2fe, 0xe3edc73d, 0x73adb1e3, 
	0x55045f68, 0xe235773c, 0x90c2e3b1, 0xa877905b, 0x1e2fecaf, 0x15c71f1b, 
	0x1dafd906, 0x18ab78d1, 0x273aae30, 0xa38caaeb, 0xd57141fe, 0xd5715eb6, 
	0x7df11f88, 0x7f65571d, 0x771e1aea, 0xcb22e403, 0xbfb918d9, 0x77b4ad6c, 
	0xf2951e3b, 0x36f3bfab, 0xe6f57cf0, 0x636f399b, 0x99f21fbc, 0x77c4ace3, 
	0xf3e8975b, 0xfae15e36, 0x57d7f46b, 0xa3dcf5bc, 0xacd6f1dd, 0x6f1c939a, 
	0xd199f17d, 0xbe9fcd68, 0x41f39c76, 0x2dd5bc65, 0xd7cf2abe, 0x9f6c76b0, 
	0xf5ac388c, 0x2be64eca, 0xbf8c0122, 0x4b9e9b25, 0xf6d671fb, 0xafcf7b57, 
	0x40abf8bf, 0x7de094fc, 0xe0d7f118, 0x735fc7cd, 0xd77acd97, 0xeb5771cd, 
	0xa3d75fda, 0x83b13c8d, 0xafd6aee3, 0xb8e7af9f, 0xb3f692eb, 0xfa56dfe0, 
	0x5dc47ace, 0xb3b0f467, 0x2ff9d55b, 0x91abb8d1, 0xd8f1f2f3, 0x1f2cebb8, 
	0x639833e2, 0x6ebe0f6a, 0xf6ef6185, 0xbf91d7cb, 0xaf962937, 0xe58be2bf, 
	0xbe6ee1eb, 0xd7307a4e, 0x23e45409, 0x7376133f, 0xf573cd2d, 0x243f52c3, 
	0x7a1f39fb, 0x363c4c78, 0xe91de707, 0x3b9600fa, 0xa0f89f52, 0xbd73e88e, 
	0x87fb4efa, 0xbc7d559a, 0x6a41bfa6, 0x7f56e71d, 0x7eb69c7e, 0x920ba4b5, 
	0x3bca1b02, 0xff47f6a2, 0xa2b15a71, 0x3fbdaf81, 0xf84ad9de, 0x92e9144c, 
	0xefbfc41e, 0xdf3f089c, 0x8478bf30, 0x3839b4e3, 0x6ef7256f, 0x0a6c8f19, 
	0x61ed38ca, 0x82cb9f25, 0xfd65c603, 0xee3bc4ed, 0xd0f94a0f, 0x87e19afa, 
	0x8d16d4bd, 0x07a03acb, 0xb2e2e386, 0x43e595ad, 0x4247c483, 0x165c64ab, 
	0x6bfb21fa, 0xb6cb8c85, 0x1f58334d, 0xf100f8e5, 0xab1dcebd, 0xb8e65f59, 
	0xe6df8d2c, 0xd7e03231, 0xae36086f, 0xf545084b, 0x971556c6, 0x0e68343d, 
	0xa0d35fc7, 0x898d6e2f, 0x1dd07ebf, 0x70c0756f, 0x1d0bfc9e, 0xfae24d8f, 
	0x3053568f, 0x25e49c3f, 0xeba0cbfd, 0x798fc26b, 0x60d0fc1d, 0x275d4a6f, 
	0x34a704b5, 0xfdd195e4, 0x679a08f0, 0xb33dd735, 0x788698de, 0xc8d9832c, 
	0x22f156a9, 0x0fc3e5f8, 0x131cfe4b, 0x19e9cd8f, 0xc870ad8f, 0xafe943bc, 
	0x1dd55dad, 0xaf24758f, 0x99dd3b46, 0xe2ad7e0c, 0x1abe3a05, 0xb15d2f12, 
	0x3b18e091, 0x57c71d71, 0x5701f3bb, 0x0b42ba49, 0xb47ad2ba, 0xd0be938e, 
	0x73e2cc32, 0xe99eb447, 0x12351c34, 0xfdf05ebe, 0x8cefc8c9, 0x5af9ff28, 
	0x246793f6, 0x3cdf9504, 0xb29b8d10, 0xf5183d3f, 0x1f54378f, 0x31bddaf0, 
	0x8df5d471, 0x44763213, 0xfc3de4fd, 0x04dd74e1, 0xd9c139bf, 0x33bbb5f3, 
	0xf1a26b13, 0x15837bd5, 0x7fbd5f1c, 0x8efe09f3, 0x23b262f5, 0xcb1d3416, 
	0xbafd429e, 0x64c27c14, 0x95b8d4b7, 0xaa317f3e, 0x14fc7357, 0xc2f1ec7e, 
	0x77b6bedc, 0x6f5e359c, 0xe928717f, 0x5e79ab53, 0x8b5fe1f3, 0xdeb5cbd7, 
	0x3aace3ae, 0x797acaae, 0xdeaf8a87, 0xc718fe44, 0x07fe0953, 0x1f7dee17, 
	0xb8bfbb4c, 0x4b0f47ea, 0xcdc758fd, 0xaa37dfb5, 0xd0198bb7, 0xbeb7872f, 
	0x6dbaea94, 0xee58bf60, 0xb37e89eb, 0x2ff47416, 0xe8c4165b, 0xcb5bc3a1, 
	0xd93e0e67, 0xf6dffebf, 0xfd82e12d, 0x3ab37d0c, 0x7c3b0e26, 0xc6c17d57, 
	0xec0fd92e, 0x5a71defe, 0xb2f9e0b3, 0x8c03e798, 0x62cc72e3, 0xaa5265ff, 
	0x04afa030, 0x21e8cdae, 0x4b88926f, 0x43cfc0a4, 0xc2bc8974, 0x7f254b91, 
	0x7ecf5f85, 0xd1ffea31, 0x4fed22fe, 0x77b4d6a2, 0x789f0c0e, 0x30c81ef9, 
	0x7240fe94, 0xefca46b1, 0x1db7da64, 0x0e3f25cb, 0x4ed9da24, 0xf4a973bf, 
	0x1e22b7fb, 0x2b707a43, 0x7511fcfc, 0xb75e891d, 0x92183f81, 0xc8f74e2e, 
	0x7ffb9637, 0x8d38956c, 0x9e54daf1, 0xae83e732, 0xc684f256, 0x94e4bd9f, 
	0xba75f60f, 0x23c81d30, 0x1e3fd6ed, 0xf9e526dc, 0x036e4caf, 0x01e95f5d, 
	0x98ebd837, 0x5fd7cd07, 0x16e5873e, 0x821ad7c7, 0x7ed84a97, 0xe31e3b26, 
	0x16465aa4, 0xc76c3bfc, 0xff2f5f63, 0x13f0a3ce, 0xfbf650bc, 0x0f3c711e, 
	0xe80371ad, 0x7f382332, 0xeb9609ff, 0x8dbd1f4f, 0xbe4f03fd, 0xdf12f52a, 
	0x7fa987b3, 0x3fa0c7e5, 0x047be23f, 0xf5b3b673, 0x9b5d68be, 0x579f8619, 
	0x1526fbef, 0x211a6acf, 0x17efa0fc, 0xd0629982, 0x12bf5555, 0x59ae97e3, 
	0x5a1af92e, 0xd4ee7fe0, 0x47a8875c, 0x59dcc37c, 0x21b443f3, 0xce226ed1, 
	0x7d59de61, 0x2189da8a, 0x7ee4cbb1, 0xb45e95eb, 0xe730fca8, 0x7f40b565, 
	0x7a25c688, 0x95656de6, 0x47bcbf4a, 0x7e43fde5, 0x7e11fc71, 0x3bf29087, 
	0x2b72a244, 0xf9c0dfc6, 0xe5fd6d44, 0xe10fc113, 0xc9de3d65, 0x8e494bcf, 
	0x69d6b3d1, 0x06d30fd2, 0x7f441639, 0x282ebf24, 0xe68a16f9, 0x2eaa4d15, 
	0xa1dd78e7, 0xe0395fc2, 0x15e68f0f, 0x3f7fb015, 0xe524579a, 0x64cb27da, 
	0xb7cb115e, 0x4931e854, 0xf9d44fec, 0x27c84d44, 0x4f91eeaa, 0xa27c8394, 
	0x76932f5f, 0x245396ac, 0x7e55f28f, 0xd1e40650, 0xbb0e781b, 0xa89f2e29, 
	0x073ad173, 0xaf2843e4, 0xd282f389, 0xe1c7263c, 0x430adcb5, 0x63f8d2be, 
	0x474d3c95, 0xb57256eb, 0x1a39c956, 0x35c94eaf, 0x5a9effcd, 0xb40cf526, 
	0x2f4fdbd0, 0x3e357293, 0x43f8886f, 0xc901f070, 0x95af060f, 0xf08521fc, 
	0x4952c2f3, 0xe8910137, 0x4f611e02, 0xfc842fc1, 0x2a779632, 0xdd41ec7e, 
	0x3f1a3043, 0xbe877ae6, 0x64d7c7e2, 0xe346f8fc, 0x9e73adc5, 0x2079bc62, 
	0xa6bc68f7, 0xc40f53bc, 0xf96919e6, 0x519e5fd8, 0x132928b8, 0xc3cb54fb, 
	0x72932caf, 0x1145cb50, 0x1fa156f2, 0xe5e30f2d, 0x3a8b969e, 0x4a3fe86f, 
	0xfce17e0e, 0xbabfc822, 0xc822fc98, 0x0f250ebf, 0xdbac1ca5, 0x9fe0f32d, 
	0xeba169aa, 0x7611b14c, 0xc8fae14a, 0xc2f3ec72, 0x4f5121f5, 0x35ce151d, 
	0xdcf5f356, 0xa280dc10, 0x55b2c4b0, 0xb615a017, 0xd4f5c2bf, 0xf10d5248, 
	0x9119c281, 0xc3e45a8a, 0xe0ad096c, 0x3e48b7f7, 0x779cf851, 0xc2adec25, 
	0x6f3f42e7, 0xb8537da3, 0x3ce3b2cf, 0x99afc2c3, 0xfcf167f6, 0x55d7ac2f, 
	0x756e6b3e, 0xdbb3f31b, 0xebe76faf, 0x15b8bbdb, 0x6e7c939e, 0xc339e5a6, 
	0x577b48ad, 0x939da75e, 0xe517e9d7, 0x7955fa75, 0xbcbaf63d, 0xaf25db1e, 
	0xf9ab27bd, 0x5b867bda, 0x795dee31, 0xbc9cee3d, 0x5e517f1e, 0xaf2abf8f, 
	0xaf2eb8ef, 0x66aae8ef, 0xf1255576, 0x7b27784a, 0xd2dcd326, 0x79d73ec3, 
	0x8d78dd67, 0xea7b0ba3, 0xa65fc634, 0x4eca7e90, 0xcfd3ddc3, 0x9cf88379, 
	0xe3f71f01, 0xfa31bcd1, 0xe1293d4b, 0xc2467a94, 0xf2bbf469, 0x6a39f47a, 
	0xca3f683b, 0x98c4f473, 0x98fef28b, 0xcf63dbab, 0xfde0a907, 0xc5b5dc52, 
	0x13b18eef, 0xe32e5bdf, 0xdeaa6d73, 0xc87618aa, 0xdb679915, 0x2078f8ae, 
	0x5d9f8f86, 0xe706f92e, 0xde5506df, 0x1ed4476d, 0xae7deb6c, 0xb9dc4e46, 
	0xde475c1a, 0x68d5ceac, 0x77ea344b, 0x6ae791cf, 0x38851eec, 0x7fde19ac, 
	0x7c6ae716, 0x6df24967, 0x748dfb7d, 0xdfac7ebd, 0xe0545c2d, 0x9dcee797, 
	0xf54de752, 0x2c0d6fac, 0xf46d75d3, 0x2bf0ebeb, 0xdd432ee5, 0xd56bae96, 
	0x73e8cbe7, 0x7f38f45f, 0xd77e5cb3, 0xcfadd6ac, 0x6aff6163, 0xaabf6f55, 
	0x77ce3bf6, 0x5b9dae18, 0xfde1c919, 0x5bf763a3, 0xeccd6368, 0xf916fdd8, 
	0x6fdfcfb3, 0xdcb55256, 0x07d4766f, 0x3e096e17, 0x45bf73d6, 0xedfb531e, 
	0xcbcfc3f5, 0x3a7d56fd, 0xff19bf76, 0xab59ed24, 0xfe97e761, 0xf8b7edfb, 
	0xf50f65fd, 0xedfd7fdc, 0x677fde2f, 0xde2fef7b, 0x7c6e9b77, 0xfb18fd9f, 
	0xff28e3e6, 0x7d9f681c, 0xfbdf5975, 0x4f4f3e2c, 0x78e9f9e7, 0xec8b9d49, 
	0xde4a8bec, 0x7a79a285, 0x4e11bf5a, 0x4a5ffaef, 0xb604debf, 0xd0de54b7, 
	0x2c232ca1, 0x4f3236e3, 0xe565d1af, 0x5cdc9fa3, 0x40ed52d1, 0xf97e66bf, 
	0x0b4f9e79, 0xed9af2f2, 0x0fa07327, 0x5421fb74, 0x2bfc289e, 0xfe1d10ef, 
	0x0f3265af, 0x8597fb4e, 0x89a9cad3, 0x9a6b6bc9, 0x7990e4d2, 0xbbe71670, 
	0x799efde1, 0xe1db1670, 0xd32bfdfa, 0x68af591a, 0x2d4ef5dd, 0xfd61fde2, 
	0xdfde777e, 0x9df01ca2, 0x0e45d4b4, 0xfc8c6f9c, 0xe64d90be, 0xf91ae1f5, 
	0xc442217c, 0x1b2efa51, 0xb2bdbd76, 0xce83fa0a, 0x7809dbeb, 0xf0745e93, 
	0xc055b557, 0x6befceb1, 0x0c28b8fe, 0x45c47fb9, 0xf3bd1170, 0x6e6f38e3, 
	0x8b2f3474, 0x1fe207ed, 0x7f654b6d, 0xf08a571c, 0x0fe0dd3a, 0x502e1f3a, 
	0xf781599a, 0x47985e74, 0x9f3ad1e9, 0x44bff38f, 0x9bce5fb4, 0xdeb5f7a3, 
	0xaf9aa2f6, 0x8f1843b6, 0x9f3e6ffb, 0x3de54daf, 0xfc1f1e73, 0x9af7e840, 
	0xaf40bbd4, 0x54175f9c, 0xaa2276f9, 0x008f41d7, 0x49973a7e, 0x3b89eebe, 
	0xcf33cc37, 0xa7bf8074, 0xa1f24675, 0x9aa7a54f, 0x53f00f5c, 0xae7a0fa5, 
	0x83ec0e99, 0x2c61daf4, 0x8cbfa80f, 0xe1675a76, 0xec06462d, 0x7e0a6d93, 
	0x9d75ff1a, 0xddd48cc1, 0x90e9a758, 0x2d458375, 0x5f2afeaa, 0xe7c5b1d2, 
	0x7c6db752, 0xf9d64330, 0xd7a1f917, 0xc9cf57a4, 0x96c35c80, 0xab6a7c83, 
	0xc47ec39e, 0x3fa4cbeb, 0x553cc8f7, 0xa55cf947, 0x4784f503, 0xfe3ac9e6, 
	0x8191a73a, 0x069d9b7e, 0xbe5ff1d7, 0xd3f9f266, 0x6f67cfd4, 0xfe373e48, 
	0xa7d836b9, 0x5fb2e6b3, 0x40f049d1, 0x966b8bfe, 0xa7ec86a3, 0xfbbe94b7, 
	0x69c7da96, 0x1dc75d2e, 0xee20dff5, 0xfe788ff4, 0xe26b9f38, 0x45bf9e80, 
	0x4efd9bad, 0x72361f1c, 0x7fecfbd4, 0xe7ef2fea, 0x4e32a5a9, 0x24721684, 
	0x0e58af72, 0xf0a6d3f9, 0xc45f39e8, 0x3e7254e7, 0x344fdb15, 0xa7ec3e8f, 
	0x273cb8b4, 0x1db16f6d, 0xa22beda5, 0x1952ecd7, 0x4f65eb77, 0xe18aeec1, 
	0x96c31e37, 0x0fd9aea2, 0x475076c8, 0xedac0e34, 0x928bb62f, 0xd82fec63, 
	0xd05fed5b, 0xabedaade, 0x3b6fa37e, 0x1abede2b, 0xabe37df9, 0xec9a43a8, 
	0xca3f5d0c, 0x5fe64775, 0xf5acbf49, 0xbd0df009, 0x89457605, 0x7f69f461, 
	0x9f9dc5b6, 0x3eef0311, 0xe2dad8f3, 0x782147ce, 0xa2ddb157, 0xcdd57de1, 
	0x2d1b3f72, 0x753ed519, 0x4ded113d, 0x5453dfc0, 0xae48229e, 0xc1b6827b, 
	0xa3e13fff, 0x5977c144, 0xa558f83f, 0xad70c5f0, 0x789f8dea, 0x017f687c, 
	0x829c7dc3, 0xf7056afb, 0x056f022f, 0xd04fed57, 0x80fed5f0, 0x8cbe143f, 
	0x67050ea7, 0xce0f3feb, 0xf71c2e1a, 0x0be189af, 0x5988ef4a, 0x6807d727, 
	0xadd7a13e, 0xefc34ce9, 0xbb3a35ff, 0x2d17fe90, 0x6b6daf90, 0x5b95c67a, 
	0x8c8c1761, 0x9e51973d, 0x37e7c23b, 0x9747fbd0, 0xfd3c38eb, 0x9b0df9c2, 
	0x0df9f38f, 0x92c6bcfa, 0xfff348fb, 0xc67cf465, 0xbfa71d1b, 0xeead26f3, 
	0xc717e8f1, 0xff704ffd, 0xce4de7dd, 0xfd9375a3, 0xf06a9ad3, 0x6e97e7fa, 
	0x58f8c9f3, 0x4f7bfbe4, 0xa1ea7e72, 0x9f5c5186, 0xf6914fe8, 0x4be6afb3, 
	0xf5d5c703, 0xfdc51639, 0x93f1639c, 0xfde7dde5, 0x7e707cf0, 0xcfa0e011, 
	0xefb92a2f, 0x3e8f863d, 0xfcbfac6f, 0x6fcb4b93, 0xcf84ff2e, 0x4e5c8353, 
	0x3a75c59c, 0x230f07f0, 0x54badef8, 0x4b198fea, 0x9853bea5, 0x5f79797b, 
	0x018b42e7, 0x79ff23f2, 0xfd67f4b9, 0xd323f2b1, 0x02158aa7, 0x876408f9, 
	0x343b188a, 0x7cdbeabc, 0xc402ca9e, 0x131b7f6b, 0xb27555af, 0xec7ea773, 
	0xae70440b, 0x9f6fe18a, 0xb1b0e32b, 0xae149be7, 0xcaa87650, 0x61dfb2cf, 
	0x657e4335, 0x68f3a9e5, 0xccf57f95, 0x773fd283, 0x5f16d77f, 0x79ebfc8f, 
	0x0dfb9c72, 0x27da17c3, 0xa637aef9, 0x3215bcff, 0xde39baff, 0xf4a79b7f, 
	0x5fa93c8b, 0xdafe28b4, 0x15babe02, 0x697184f6, 0xe03c4c77, 0xd915a272, 
	0x5e67cf2d, 0x81d6fa83, 0xfc744aea, 0xc046fe0b, 0x7099d755, 0xea23223c, 
	0xf8aa1c27, 0x049bd73b, 0x7ed078a3, 0x8a1ff648, 0x7511eb81, 0x63ae897d, 
	0x3e933ae4, 0xd12287fc, 0x89a7e77c, 0x565df831, 0xdfb72a2f, 0xefebbef8, 
	0x2b3998fc, 0x5fa3bef4, 0xe77177d8, 0x47dc94c7, 0xf446fe98, 0x1d1b991c, 
	0x673a816f, 0x45bc7e2d, 0x59ff342b, 0xdce2fdc4, 0xcfa78c1f, 0x6fb929fd, 
	0xe7d7df31, 0xe757f4fb, 0x67eaaaf0, 0x2d1baa83, 0xc3cfa15b, 0x707f99eb, 
	0x34f32838, 0x6873abfa, 0xbded215c, 0x3cf45647, 0xdf5a3517, 0x78b2f520, 
	0x7d77ac3d, 0xa47dcf43, 0xbeafedc7, 0xefa29f61, 0x8dc6e3c7, 0x7d4835d6, 
	0xfcfe2da5, 0x0d755eb8, 0x4fdb8cfd, 0x1a8d435d, 0xdc6e3cb7, 0x1e833d68, 
	0xb79cee37, 0x5f0cf55e, 0xf497ff8c, 0xbb7b1743, 0x8aef70e9, 0xbefff9be, 
	0xb27eb115, 0x996f1d1b, 0x8f4a5f3a, 0x30b47387, 0xc7bb77de, 0xe33f6efb, 
	0x7d7df235, 0x8e8ddfee, 0xa39d4ab7, 0xcbde3f19, 0xdcbde3dd, 0xf2af78cf, 
	0xe0df06fa, 0x773a06fa, 0xc7bb6ff7, 0x67ec5fa3, 0xaff701fc, 0xbae497cf, 
	0xff850e93, 0x03b9f21f, 0x9b10be0f, 0xdf8718c7, 0xd68f4a05, 0x8f5e3e7c, 
	0xf98072d6, 0xaf924bf3, 0x7157af57, 0xde34673c, 0xa7da9ef6, 0x57bd7cf1, 
	0x949e4cfd, 0xa4dfdcd3, 0xfd19bd18, 0xb8de856c, 0x2b7e0b35, 0xc50933ce, 
	0x7d2b1be4, 0x8721e752, 0x36bc7790, 0xf3adb75a, 0x912d164a, 0xf940c0fa, 
	0xd58f5ac8, 0xa8afc1f1, 0x64f1c6fd, 0x99174bce, 0x7d2887ac, 0xf50c2ed6, 
	0x5918fcff, 0xf886cf9c, 0x714f5d17, 0x0f205b8a, 0xd2eccb5a, 0x973d00cf, 
	0x6115faf0, 0xfd5c850e, 0x7b16fe14, 0xd22cdcf4, 0xe7911b7f, 0x4336f0b2, 
	0x869d59c6, 0x4ee2f11f, 0xfb62a9df, 0x23bfdc93, 0x773c44d1, 0xe58da67c, 
	0x72107184, 0x9df2a022, 0xae6536db, 0x9ba55f83, 0x9e7a79cf, 0x4ae0fcb7, 
	0x95c48789, 0x82993f52, 0x213a84fa, 0x7f4a0f6e, 0x641b53c7, 0x69a7485d, 
	0xa2b9bae7, 0x5fff826d, 0x6ef34ea8, 0x7d5ff799, 0xb3be2f37, 0x97596ef6, 
	0xacb77f52, 0xeba9094b, 0x5dbaea43, 0x7a9affbd, 0xcfcf52df, 0xab6fe7a8, 
	0xf3d4e7e7, 0xaabeba88, 0xf7a9afae, 0xd3ff74bb, 0xe4d3f7d4, 0x10eaa5b5, 
	0x7df9f3aa, 0xcca735a2, 0xc1c57c27, 0xf2d71bf9, 0xfcf9f7d5, 0x6c2fd73e, 
	0xd74bae88, 0x7b69a42b, 0x8aee12c2, 0x636fec29, 0x5f01a23b, 0x6f1a2f7d, 
	0xb4909e87, 0x9dd79a36, 0x0be64d36, 0x0235bc69, 0x671521af, 0x19633d87, 
	0xda43ce7c, 0x95d308c5, 0xa19a47b6, 0xd2895c87, 0xa6626795, 0x534af603, 
	0x5b8e71e5, 0x18acc57c, 0xbc45e3ca, 0xbe3f7889, 0xaff5359e, 0x63cacc9f, 
	0xfebbc13d, 0x41a74497, 0xf49b935a, 0x4f252988, 0x44a6704d, 0x9e79bae9, 
	0x6e0e27d4, 0x0fffc39d, 0xb1fc7c53, 0x7dedb739, 0xdaad873e, 0xc8fac996, 
	0xa3f64cb4, 0xb8f2a8be, 0x3ae2fde3, 0x279f5e1f, 0xd44f1f15, 0xc7752fe7, 
	0xffd06e9d, 0x78fd865d, 0xafb5e55d, 0xe08f7a56, 0xb041b3bc, 0x9d8c2ec7, 
	0xc7bb0551, 0x19e929b3, 0xf9bb41f8, 0x2fe134e1, 0x0c7c85df, 0x57ac1fa9, 
	0xc0edab74, 0x87336bf4, 0xf7e5d80a, 0x7822df12, 0x46bfc126, 0xf4b4d174, 
	0x2eb19a5f, 0xe7579aa7, 0xa984f13c, 0x1ba2e1cf, 0x9d171f4d, 0x79883d06, 
	0x79d6bfd2, 0x5909ef35, 0xf190e2ef, 0x27eef333, 0x13c1f6e2, 0x89e0fb71, 
	0x44f07db8, 0x22783edc, 0x113c1f6e, 0x889e0fb7, 0x7ff007dd, 0x8715b9f2, 
	0xbc8bf5e8, 0xdd889e2f, 0x8e2f3417, 0x26a5d703, 0x19741f1e, 0xe432b08b, 
	0x9ed29fb9, 0xae9ecce8, 0x7b8d3be6, 0x83a708f3, 0x20ec97e9, 0x4dc2b73e, 
	0x4ff9e7eb, 0xb68ab903, 0xe6fc134f, 0xfd5df079, 0xb25978ff, 0x6086773e, 
	0xf453ad3d, 0x6cda5784, 0xcde834e3, 0xe839fd43, 0xe4dbbb7d, 0x2ab1967a, 
	0xc175b00f, 0xfbe0b4bf, 0x786b786e, 0x50fd5446, 0xd09f9a99, 0xdcf21775, 
	0xebd7b18c, 0x021f8b4f, 0xbd72f99e, 0x83b8f2d7, 0xbd252b71, 0x22783f10, 
	0x113c1f8e, 0xa46c0fcb, 0x09b75eba, 0x3f01ff59, 0x8298e896, 0xfa39ed44, 
	0x1ef55efb, 0x63c33eb2, 0xda099f1e, 0x687a9f4c, 0xc369ce25, 0x78031bff, 
	0x2637ffea, 0x5fd2d977, 0x5d8148cc, 0x8bf2bcd8, 0x5a3f85d8, 0x9badc7f2, 
	0xe15373e3, 0xc7e7563f, 0xf380afc2, 0xd857e14a, 0xefebfb43, 0x3f3cf657, 
	0xa0bfde35, 0xfd652dcf, 0x5be5f686, 0x4f5eb52b, 0x97d7a0bf, 0xa5e18efd, 
	0xb92d55cf, 0x65fc7a8f, 0xe353f3ef, 0x4df9fdc7, 0xeeb3fb8e, 0xc7267f71, 
	0xe3c67e0d, 0x4b5473ea, 0x8f39fbee, 0xfffeeeeb, 0xfc0b442d, 0xd807ec1b, 
	0x58bdb030, 0xe5697b98, 0xdc8ba917, 0xefc647f9, 0xf60a75c0, 0x29d57d55, 
	0xe9d9e7c4, 0xed89efff, 0xc7bda3df, 0x2eff281f, 0x5e0e6f1a, 0x166f19ec, 
	0xde3f3f57, 0x1df955ec, 0xc45ec566, 0x2f78b6a5, 0xf1ddf7f1, 0x9aa5d0e6, 
	0x743edc39, 0x7e6c5f78, 0x77e75787, 0xf529dd9c, 0x5f35f3d7, 0xb7fdf5e6, 
	0xcf23378a, 0xf1d17015, 0x30854f65, 0x2de94fb7, 0x3b8a076f, 0xb0587c5f, 
	0xfc5fdb1e, 0x47100c59, 0xbe255b4e, 0x2c791c50, 0x89b961ce, 0x35fa7238, 
	0x20490323, 0xfe0d3307, 0x06f17fff, 0x711b2ff2, 0x68dae88e, 0x4bac791c, 
	0x6e25479e, 0x455c8e30, 0xc6bfcff3, 0x7dca08c7, 0xee471f19, 0x2388f48c, 
	0x23c47de3, 0xdea7de39, 0xcf238d8f, 0xc549769e, 0x22358791, 0x558dfc8e, 
	0x17580fd2, 0xf576c11a, 0xe62cef9e, 0x685d7238, 0xc5e7c671, 0x4abdbf91, 
	0xf6b9d9da, 0xa7df9c93, 0x018bc8e3, 0xbf39e86f, 0xfa0abb7b, 0xf91c7745, 
	0x7030a293, 0x5c1175e7, 0x91c78dc4, 0xb8b0fc7f, 0x9ef238a1, 0x211a231d, 
	0x77d5d38f, 0xefb32ee9, 0x6f35f238, 0x447f3c85, 0x69d78dc6, 0x807950fa, 
	0xd1d1c78c, 0xc68de978, 0xc44f3191, 0x4fabd391, 0x09f91c72, 0x3639bbf4, 
	0x00656c5e, 0x1282730f, 0x7571e93f, 0x0cf3e9dd, 0x61d93b47, 0x70cc5fbb, 
	0x6f8e38da, 0x3738bc70, 0xabdceca8, 0x971f9f06, 0xb62f1dd6, 0x6c5e321c, 
	0x6e2f1039, 0x78d27057, 0x45e2fb1e, 0xf1c5e207, 0x5767daf5, 0x6d7ab17d, 
	0x511ff77c, 0x2aeafdaf, 0x04cc3729, 0xb690f583, 0xb5eb8231, 0x9c6de73d, 
	0x4a922bbf, 0x01f9e4ab, 0x2d3b5eb2, 0xce80fcfe, 0x407e753c, 0x2476bd5c, 
	0x0341d94f, 0xfea76bd4, 0xb5eaa6fc, 0xd64abd7f, 0xf5a1fc93, 0x92adefda, 
	0x412de876, 0x6efffeb9, 0xa09edaf5, 0x95a39f8c, 0x1de3daf5, 0x953dc79c, 
	0xe30d95f8, 0xbbf8f3aa, 0xe385b5eb, 0xebbdd1b5, 0xca2ed3b5, 0x45cf6d7a, 
	0xdf4daf5d, 0xb6bd430f, 0xec91fbc1, 0x4ed7ae44, 0xb5eaaf3b, 0xd85dadff, 
	0x5eba2f09, 0x37f730bb, 0xbe88beab, 0xdf557679, 0x0bff8871, 0xbcb1fe2d, 
	0x0002c4f1, 0x7ddd9c78, 0xd554740b, 0xc999f0d5, 0x46493324, 0x04084c98, 
	0x1388c09d, 0x75743248, 0x85821188, 0x04248972, 0xd0117e02, 0x265f95a4, 
	0x478409ef, 0xfae8ada9, 0x2042772d, 0x1e1d5683, 0x636b43ca, 0x33242117, 
	0xf95ab051, 0x05ebf65c, 0x75684f93, 0x95afe8fd, 0x1d5ff3f6, 0xc76a4820, 
	0x91ad2916, 0xdef7fd6a, 0x2579dce7, 0xb1620921, 0x73bd2d66, 0x73ece3ee, 
	0xbdefd9f6, 0x7a5f41cf, 0xcb384b27, 0x4989a258, 0x98c63cda, 0x4fb194a3, 
	0x3a493318, 0x66322726, 0x5c673130, 0x787a630f, 0x83cf071e, 0xd95be7ef, 
	0x759ef05d, 0xc4bfc336, 0x54272652, 0xdc4a7bd3, 0xf81d8c0b, 0x04da53b6, 
	0xbb0983f7, 0xc607fc99, 0x358ce534, 0xc4ccfb41, 0x1ed8f95f, 0x886d9ec6, 
	0x616e447f, 0x6bf873ec, 0xe758c8db, 0x6f77662c, 0x863fcc67, 0xd0694db1, 
	0xed24d26e, 0xa7f7c174, 0xfbe6a595, 0xd7ac8211, 0x744d8cc9, 0x8cf38c02, 
	0xb4cdacf5, 0x930c00b3, 0xe00c13b1, 0x6002bbbe, 0x52cc645c, 0xecd7a99d, 
	0x96faefc4, 0x67c04eea, 0x53e1f3e7, 0x37e4eab8, 0x188baf7f, 0x59bbddcf, 
	0xba1a16d3, 0xf2ff619e, 0x856f2644, 0x6c191def, 0x879a29cb, 0xe87985a4, 
	0x458bc087, 0x734e86fa, 0xde07e04a, 0xd31899d7, 0x14f18756, 0xbc58978b, 
	0x09a7860d, 0xeebd25e7, 0x4a90fc0c, 0x6c02f27d, 0x1e367a2b, 0x71f2b2f0, 
	0xee8aae9b, 0xd8e3e5db, 0x2b97a483, 0x36f0cb18, 0xc65cd8d9, 0x11ac8500, 
	0x9de9dbc6, 0x8c3cc397, 0x957c022d, 0x15bc03ac, 0xe3ed33c7, 0xba5db780, 
	0xdb13ab4c, 0x11eb7add, 0xdb20df78, 0xbb7f1864, 0x9b91ca41, 0x79969fa1, 
	0xfa97ab7a, 0x06f5fd49, 0xf719e21a, 0x7c769841, 0x704dfcc1, 0xd02c61d3, 
	0x770d3d6f, 0xbbcd8a0d, 0x362b1f15, 0x0ee7ac0f, 0x1d69bfc0, 0xa17bb2bf, 
	0x475f231f, 0xe303cf7c, 0xd7f783de, 0x1874fdc3, 0xd3186eef, 0x66fcfe2c, 
	0xa777d989, 0x961fbac3, 0x18dbe9ec, 0x38b9816b, 0x454e9fa0, 0x38c2d6ca, 
	0x17cc49cc, 0xcfeef180, 0x22bd7d6b, 0x1372db11, 0x9a34c7b5, 0x0faeb09c, 
	0xbc176fc3, 0xf6d8efef, 0x5e30cdbf, 0x32b4530d, 0x1acbdfdc, 0x4855cb27, 
	0x0c0d7347, 0xf40fcce8, 0xb2f404d4, 0xb8acc0d7, 0xcc01370e, 0x3d658004, 
	0x2f0963a8, 0xaca4f632, 0x197bfbd0, 0x486c680b, 0x1bb64a8f, 0x9e5c9efa, 
	0xf787a856, 0x48901282, 0xe4eff419, 0x2bdf04e4, 0x3c9fd809, 0x440347b7, 
	0xa697a798, 0xb07c221c, 0xe7c06e73, 0xa56cc581, 0x63abf01b, 0x87d70792, 
	0x6e63a439, 0x98ed2f58, 0x23430603, 0xc173bfae, 0x5cf88dbb, 0x35cf8ad9, 
	0x5c31e326, 0xb3eab6cf, 0x001d9ab5, 0x9bb924cf, 0xe161cb7e, 0x5b27c87f, 
	0xd6824f80, 0x377e4cad, 0xbe8f8e3c, 0xf983ff03, 0x2930eca7, 0x9925beb8, 
	0x73c7fecc, 0x26067740, 0x387984ad, 0x5d1966fa, 0xfcffaf40, 0x01930e7c, 
	0xdf7846de, 0x4a32f889, 0x411eeed9, 0x565ef897, 0x4fc81dcd, 0x48c740f1, 
	0x1cf0adf7, 0x2be81bd7, 0xaf8c2b7b, 0xd903c668, 0xe3c3c729, 0xfada9d68, 
	0xddd606a6, 0x4dcf77ec, 0x78fa42ee, 0xc031f946, 0x2f293bcf, 0x91ba264c, 
	0x61da34ce, 0x4bd9aebc, 0x25ff009a, 0x4dfcd99b, 0x805ec666, 0x9f032771, 
	0x5d981a76, 0x3a095e06, 0x5c01f9e1, 0x833b02cf, 0xc8682ef5, 0x17407164, 
	0x191d8f33, 0xf3700e95, 0xf4a8f715, 0x69bbfce3, 0x71e9ee30, 0x3804694c, 
	0xb35993d3, 0x02df9e17, 0x3c268f57, 0xa6168b2e, 0x396ff409, 0x25837ded, 
	0xeec973e2, 0x92768149, 0xf5c2f764, 0xe43f2169, 0x5843a038, 0x59ebcea7, 
	0xdf0c7cb3, 0xf0b5e8d7, 0x9abbc58c, 0x975c56d9, 0xb15f39e7, 0x7f201fde, 
	0x93affac3, 0x82bb6f81, 0xcd860cf9, 0xdf453366, 0x304fef04, 0x6f9aeba5, 
	0xfc81e784, 0x7dd7c475, 0xea0444f9, 0xf9c7cafb, 0xd411d10c, 0xc9dfc42a, 
	0x36c7e2eb, 0xfde3e58d, 0x95f46378, 0x1bd3aaf0, 0xc0af0b98, 0x30afc81f, 
	0x7cf3d486, 0xa94e511d, 0x783308eb, 0x78415dd3, 0xff11bbb5, 0xd6529ace, 
	0x21a0eb8b, 0x649de73c, 0xbf6aefc4, 0x4fbcc547, 0x68f015e1, 0x7402f416, 
	0x1d012722, 0x24970124, 0xb5e7bac3, 0x7b0c13b8, 0x7a45cbfa, 0x47c846bf, 
	0x7981ef98, 0x22a6b235, 0xe562ff2c, 0xa55e515a, 0xda17ef1d, 0x1c32efaf, 
	0xa499fa47, 0x85f7c1c4, 0x132ee639, 0xa7438bac, 0xd538e3d1, 0x71879df1, 
	0x2bf3ce39, 0x5f7811ca, 0x666f90cf, 0x06b77a48, 0x06b972e1, 0x23714a03, 
	0xfe98399f, 0x2095c830, 0x00fce74b, 0x838e5cf2, 0x2ab1eaf5, 0x9e961bc8, 
	0x00353796, 0x7c3a6e27, 0xb9deeb0f, 0x7c4eae13, 0xc035901e, 0xada71938, 
	0x5f005b8d, 0x641f3fc1, 0x8617585a, 0xe2fe5772, 0x02afe9fa, 0x09fab1bf, 
	0xf7b9aff1, 0x5a9fa3eb, 0xad0f1c6d, 0x6aa74e16, 0x966b05db, 0xa968eb0e, 
	0x5a9878e0, 0x4573d7c1, 0x233b46df, 0x262df439, 0xce7b196b, 0xe808fa05, 
	0x905034a1, 0x34567083, 0xbca35fb3, 0xbbe1e951, 0x7c165df0, 0xd3f45637, 
	0xcd9a3816, 0xcc458700, 0x8ceb829b, 0xbe11a4ea, 0x03fa015f, 0x581f96f5, 
	0x65a4f08b, 0x51530744, 0xb191ff6e, 0xd926a70e, 0xddd8ca94, 0xfefeff08, 
	0x8015dbf0, 0x1bbff80f, 0xe3d047e1, 0xf30f8422, 0x57c2ac98, 0x0c207e00, 
	0x67a16eff, 0x7af846ef, 0x45272f84, 0xe151cfc2, 0x1093ba97, 0xf060d97e, 
	0xb2fc385b, 0x16dff818, 0x7057a7f0, 0x896b6dbe, 0xe0265f86, 0xb3e08597, 
	0x0aafc424, 0xd7e10b3f, 0x43497c03, 0xfa1ddbf0, 0x3eb99a1f, 0x5e187aaf, 
	0x8661333e, 0xff09ed0f, 0x4d25eeca, 0xd73a08d6, 0x9f3d6969, 0x71a5dacb, 
	0xcb2f9e80, 0x8071a71a, 0x487049bc, 0x458c0776, 0x0eec5567, 0x6285e7e0, 
	0x80cc279d, 0x5e87df5f, 0x21c5ef4d, 0x44e35efc, 0xc5b2bba2, 0x75fee88b, 
	0xfedb2de9, 0xf0f869a7, 0x5e041eee, 0xf95e0879, 0x6280f020, 0x1198cafe, 
	0xde10e9e1, 0x9dc7c47d, 0xfcf0d195, 0x0c2d2f08, 0xd3c2056f, 0x8b5787f6, 
	0xbc21d6f0, 0x3fb7ea5a, 0x238d173c, 0x2bf39879, 0xf53d67b9, 0x47c4fb9f, 
	0xfc0b3fd4, 0xe8039c77, 0x74d57b61, 0x087d6fea, 0x1efafc1e, 0xc12f7ff6, 
	0x7ce61a4d, 0xa94bdbcc, 0x655969ff, 0x5051c71a, 0x0f305963, 0x08637f78, 
	0xde391b6f, 0x3cd18fca, 0x90d68e76, 0xec5b293c, 0x21713826, 0x13ad4338, 
	0xb192abe0, 0xed0708a5, 0x1bc72b17, 0x3d7983c1, 0x23c79a12, 0x31ede083, 
	0x80a2471a, 0x11827607, 0xd464f0f5, 0xe96f687b, 0x56311cb8, 0x0eb7bd72, 
	0x17b01bed, 0x444e4698, 0x49bdac7d, 0x435f90e9, 0x31fe52bb, 0x3ed53fea, 
	0x4d1beb6b, 0x7c8acf72, 0xc5da19b1, 0x2ee0fd92, 0x5c3a7718, 0x87fcdec1, 
	0x77f503c0, 0x93c8f901, 0x02def682, 0x8c11a157, 0x9297d046, 0x909ea19d, 
	0x44de91a7, 0x1bbbd4bb, 0x951052ed, 0x92adbf70, 0xc28b01cb, 0xda135af4, 
	0x40e4f27d, 0xcda7d915, 0x9937b201, 0x76082ab5, 0x47b72561, 0xb2291d2d, 
	0xdf972cf6, 0x4c0cafa4, 0x987c75bf, 0x5a06f7bf, 0x3fa0716c, 0x357e7af6, 
	0x67d84599, 0x9d57b416, 0x80d31fd4, 0x0a992e7c, 0xd13900f8, 0x4b6bf686, 
	0x606a9d84, 0x783efc4a, 0xbd23167f, 0x5c287646, 0x53cbd66f, 0xed86250e, 
	0xb996bcd0, 0x0ff81853, 0x4cb8c34f, 0xa585c780, 0x57a8598d, 0xfbca49cd, 
	0x83df82b2, 0xc67e09bd, 0xcd815762, 0xdfeddf00, 0x3c466ba4, 0xda36722f, 
	0xfdba0ed0, 0xa86c4fb1, 0x2f052daf, 0x7d8191fe, 0x4c6f299e, 0xa443b68c, 
	0xec870805, 0xedfdb3e8, 0xe16bb264, 0xa58a2679, 0xb5dbe19e, 0x70573f64, 
	0x7edb1f7b, 0x7da02585, 0x3f5891f8, 0x1e51ffb4, 0x7a805fa2, 0x7dba287e, 
	0xe89f31df, 0x9bb8bdb4, 0x4beedff3, 0xe35a7fc4, 0xd3cba204, 0x2d3dba21, 
	0xe887aff8, 0x455f9557, 0xbee967b9, 0x414ede3a, 0xa6beb8a7, 0x79fac24f, 
	0xcd19cdff, 0x67ae0aa6, 0x6edc3dcd, 0xeb09ba25, 0xede961e1, 0xb76fe5ab, 
	0x44e617e5, 0xd03091fa, 0xc8fc991c, 0x49eebb34, 0xe3b26fbc, 0x0b3bb77a, 
	0x6c7fd073, 0x5fd57a17, 0xfe8d985c, 0xf7256b63, 0x84b2db1f, 0xf11ff8ff, 
	0xdb1ff476, 0xd1b3bab2, 0x11bf247f, 0x906ad5e6, 0x770f51b2, 0x58e73738, 
	0xd48fd84d, 0x1a3eebfe, 0x21f24dea, 0x9575dfc4, 0x1dbf8257, 0x2b5dff42, 
	0x2ffac5fc, 0xccaf2a8b, 0xaeefc17f, 0xbd32ff86, 0x185ff552, 0xd79d27f9, 
	0x3172cd4b, 0x8573b3da, 0x8cd592ff, 0x8bfea9df, 0x8a97fd05, 0x07a5ff08, 
	0x007917fc, 0xfc17a5ff, 0x21cbe017, 0x798717fd, 0xc313d36c, 0x459e5ff7, 
	0x8beebe39, 0x15df2ffb, 0xf2bfbef3, 0x78bfe9ab, 0x02dc792a, 0xf8f3a6af, 
	0xc19ea57e, 0xc8066cf7, 0x8fac3767, 0xd855f383, 0x87f4917f, 0x5ff7f4f7, 
	0xbfee412c, 0xff550464, 0x86dfbe05, 0x035c0bfe, 0x2ffb9cf8, 0xff840f96, 
	0x2ff83ef2, 0x255f0c68, 0xcae1e5ff, 0x886be381, 0xff93afff, 0xd70cffb2, 
	0x5a5d8b73, 0xa2cbf21b, 0x19b01efb, 0x774b7c60, 0xd77d225d, 0x8eedc15d, 
	0xc81f9a3b, 0xd61adf4c, 0xfbc13f7f, 0x81ce41eb, 0x13a7215d, 0x7b68b5fd, 
	0x082ff0c2, 0x28e2857b, 0xd0b47f70, 0x949c37e3, 0x3aef5013, 0xef14ac0c, 
	0x573ee517, 0xb91a3ec9, 0x79545c3c, 0xaa09f56d, 0x0b4f9410, 0x10731b8a, 
	0xe6fb4b6f, 0x7e114dd8, 0x4db07add, 0xfc7e8112, 0xc05f401b, 0x604a967c, 
	0xbb71d57f, 0x29f820ed, 0x471a309d, 0x61f29f84, 0xf3bbd725, 0xff27ac67, 
	0x96e7b54e, 0xf9687aaa, 0x751a2351, 0x8c0b8a0b, 0xb192bf88, 0xd5c60e52, 
	0xfb72c64a, 0xbf0654af, 0xead4f008, 0x9fa22770, 0xdcb5d7e3, 0xc9e41dbd, 
	0xeba566d2, 0xdadfb071, 0xeefc728d, 0x3fef786e, 0x3271dab4, 0xd83e97de, 
	0x49fd8954, 0xa67537e4, 0x05c75a33, 0xb030b7a0, 0x1fe823d3, 0xd00fb5ec, 
	0xeb7f21ae, 0xaf87ec55, 0x7c695b4f, 0x57d25c94, 0xa3fff1f1, 0xfa2dc452, 
	0xb4894a5e, 0x877fd6e7, 0xc4c38bd3, 0x1c383964, 0xf6f2e4bf, 0xaa9527f5, 
	0x06bf029d, 0x2461afb4, 0x50f5f611, 0x0b4a3af0, 0xfcb6ffa9, 0xf8a2ed81, 
	0x807fd52a, 0xff611f5f, 0xbb08e330, 0xfdf85da8, 0xa00e22ed, 0x77c56bb6, 
	0x4f8e2a96, 0x7150d57b, 0xb9475800, 0xbca01c7f, 0x4401c44a, 0x3b1eb43f, 
	0xb7ffef86, 0x93ffe10e, 0xf7f72f5f, 0xb80a17ff, 0x87703199, 0x0eb7f7eb, 
	0x3f93f7e1, 0xfbf7f72f, 0xbf715567, 0xee062f3f, 0x56fdfd70, 0x95b7efe1, 
	0x9997ff76, 0xcd255fdb, 0x774f8687, 0xda774865, 0x1c5774fe, 0x35f803a2, 
	0x30bdffa0, 0x0b862e8a, 0xe041eeef, 0x778215dd, 0xcaf020d7, 0xefe646ab, 
	0x062b7873, 0x2aeaabe1, 0xabaaaf95, 0xdaabe606, 0xff7f68aa, 0xf286f0f2, 
	0xe085d7f7, 0x37f22fc1, 0x49ff53d6, 0xcdc5f843, 0xfa9edc55, 0x961b2553, 
	0x04f25c5f, 0x172f9193, 0x8c6b4080, 0x013e5b90, 0x2d7169ff, 0xace0bb41, 
	0xfe1f47e8, 0x9e56e49e, 0xffa06390, 0xe325e817, 0x6418a8c3, 0x1ecf7eb9, 
	0xaa9e63d4, 0x7febb12b, 0xed6d7558, 0x53c6e1fa, 0x53c4c416, 0xd97443da, 
	0xdd72e9ce, 0xae93a211, 0x4f1166cd, 0x68fd11f1, 0x2a274987, 0x2e7b929c, 
	0xfde93a70, 0xc7ea1c53, 0x53b13f63, 0xe8862f7f, 0x274145e4, 0x8d5c112f, 
	0x71f49fe8, 0xa68fd71a, 0xb31fa453, 0xfae5cdb7, 0xd429db71, 0x2639058f, 
	0x55ffe7e8, 0xf501bb71, 0x5e175cb1, 0x91c7d467, 0x6df48472, 0xb4ffac40, 
	0x3f9e1eb0, 0x27ca79e3, 0x1e3c75fa, 0x76fa81d1, 0xdea3d713, 0xcc0f6473, 
	0xea01f8c4, 0xbc9b8c53, 0xe1f9e02e, 0xa045fa3e, 0xf3c8ff77, 0xa7b64a49, 
	0xef35cb82, 0xe37f5c6d, 0x6edf51b8, 0x25bcc983, 0x2a356bbe, 0x83cf7667, 
	0xb35e33e7, 0xb57f058d, 0xf97a4d28, 0xb1efca51, 0x6d9b9438, 0x9f998f7d, 
	0xf2983684, 0xc3ef9871, 0xe22c8f78, 0x245f983d, 0xce2018fe, 0x215f1833, 
	0xbca3263d, 0x6ffd3dcd, 0xbceacf49, 0xbb24f24a, 0xd3bfd61b, 0xe031f5c8, 
	0xf01bb8db, 0x98fa0537, 0x592be306, 0xf183e7ce, 0x2f117492, 0x32e80a79, 
	0x5fe79ab9, 0x22bbde70, 0xfa2126e2, 0xd39a7e5c, 0xe88c74a7, 0x63c7ef73, 
	0xd589fc68, 0x2fc27d2a, 0x09e84fa2, 0xc85e33e8, 0x1f6085b1, 0xd57bea46, 
	0xe33f9c2e, 0xe803b642, 0x87da216c, 0x85dbfbf3, 0x2e427555, 0x16f4e32d, 
	0xbf409725, 0x31fd01b6, 0x7e0f73d0, 0xb715db87, 0x89cc6df7, 0x1cc5b3d2, 
	0x9492edce, 0x017482d3, 0xd11ad5a2, 0x5c759dff, 0x2ce3b7bf, 0x2ab7f422, 
	0x1e9f48f7, 0xc0ce7012, 0x032af415, 0x63ab3fc4, 0xbd73b613, 0xa7878ffa, 
	0x124cb632, 0x31419d7e, 0x650e22ca, 0xbaf1c3da, 0xbfdc05b3, 0x83cf4e6a, 
	0xc61975e1, 0xfc628fa1, 0x5b97cb99, 0x5f84f842, 0xfc3687a8, 0xb7c70e33, 
	0xd09359ef, 0xbf083343, 0x25ffc13a, 0x91eb73f1, 0x16e162af, 0xbcee108d, 
	0x1c79dc10, 0x8233f3ae, 0x765ffdeb, 0xe088b701, 0x5a5c049a, 0xf5e15d8f, 
	0x17cbc588, 0xac2d3b8d, 0x93b8d2bf, 0x2dd784bc, 0x3e364f48, 0xe4b5fe8f, 
	0x968bba6e, 0xe84dc997, 0x9bf56bb7, 0x3f38d34e, 0xe4bc3f40, 0x31b3e79e, 
	0xf0fe000e, 0x63d02f28, 0xdf6618e7, 0xfac0fe06, 0xfecfce6a, 0x31870579, 
	0xd1cf8abe, 0xeee7c69f, 0x2faf1cdd, 0xa4bd0e7d, 0x90e8e636, 0x7ab5527e, 
	0x4657d01d, 0xfa1afcb3, 0x431df417, 0xa4fc113f, 0x00df210a, 0xdde56dde, 
	0x00d75839, 0xc9beb2e6, 0x761f5e1b, 0xf51366e7, 0x61365673, 0x967f183f, 
	0x26bfc49d, 0xf4700bac, 0xe918db7d, 0x9a5c6057, 0x815d49fc, 0x7113addd, 
	0x5eff1869, 0xf432d9d7, 0xf0dc9e97, 0xb95c5479, 0xfbc3d5e4, 0xa68eb06d, 
	0x285cc65a, 0xef016c07, 0xfbd402ee, 0x78d0ee8a, 0xdc90c7ac, 0xa1f9e73f, 
	0xbc051e1b, 0x0df115ed, 0xfe63b3f8, 0x7dae641f, 0xdffe445b, 0x8f5add5f, 
	0x8b8a7ff9, 0x35b8c69d, 0xf1058fc7, 0x93f27e03, 0xd0964cce, 0xe847320b, 
	0x5fbbf527, 0x08f8f0d5, 0xe0bf115e, 0xe019e9f7, 0x5e5162db, 0x5746dcf4, 
	0xb9e41076, 0xe0dca6c5, 0xd4eb8429, 0xa65db616, 0xe0eca77e, 0xe1e675f4, 
	0xc93fa45c, 0x6c2c7a87, 0xb1f0c7ff, 0x0665d38b, 0x8c0eeff2, 0x1ea2cb97, 
	0xf11a3dc4, 0x7b38c7e3, 0xf7671c20, 0x61f9e2cf, 0x0e3c9368, 0x1da3743e, 
	0x07ad42e9, 0x79834a29, 0x5b7e2256, 0x7bf0e26b, 0x5777ac8b, 0xc60a38f2, 
	0xce1a3307, 0x68aa6ad6, 0xd0377a9c, 0x798481ef, 0x147eb8cd, 0x7a216f97, 
	0xbd00f6cc, 0x3268f34e, 0xfcdf6951, 0x1b2a6981, 0x4f41d8cb, 0x379df921, 
	0x4fda09ff, 0x88e29b50, 0x5e92acd3, 0x41947a46, 0xfb7f419f, 0xa8f4943f, 
	0xe18b3aaf, 0x12fdfc39, 0xb1ec13e9, 0x0fb84109, 0xde9059ef, 0x0bc70e64, 
	0xf15c3270, 0x29b20676, 0xffb71477, 0x6ec9f018, 0x7a03af58, 0x3ffca0a6, 
	0x7d33ff30, 0xfa08f8e2, 0xacebf413, 0xa00279e1, 0x0fb61b6b, 0x9f507fcc, 
	0xf4b5df08, 0xb8c39cb5, 0xc1f00394, 0x0c8e5f10, 0x5319af92, 0x52e3eacf, 
	0x5a9bebc3, 0xaa48e5c3, 0x33ca6758, 0x66241e20, 0x3e3c004a, 0xd4514be9, 
	0x15ca08bc, 0x3c708bca, 0x91aae35b, 0x9c6c95ee, 0xb037e637, 0x6812794d, 
	0x7d9f48b7, 0xc036758c, 0x7ea3afaf, 0x540e5bdd, 0xa73b44e5, 0x92f944d1, 
	0x2d562df3, 0x91f739e0, 0xd01cdb1b, 0xad75cdef, 0x810f6c53, 0x6d6922df, 
	0x3ca38718, 0x93d61282, 0x904f986d, 0xf98bf4c2, 0x2c238c0f, 0x9b65efba, 
	0x679c3131, 0xdc097ca1, 0x67a0bfff, 0x3e45eb0c, 0x05a1f905, 0x70fc0dc6, 
	0x74ad9320, 0xd5157ac3, 0xbcf53f29, 0x1bb6574a, 0x3e68a1d6, 0xe7b519fb, 
	0xebc33d03, 0x068a6545, 0x8ca8b9e9, 0xf6c69e69, 0xd3ce250c, 0x0139d70d, 
	0xb668178d, 0x82dca368, 0x91b45ff4, 0x63d17fd3, 0x174f19ec, 0x0763155e, 
	0x14bbd9da, 0xfbec07ad, 0xe6b2b5a2, 0x9f7e7c51, 0xf9cc3d2c, 0x3cf3caa1, 
	0x148bdbe7, 0xe86e536f, 0x4b3771e3, 0x2db53357, 0x32cae8c7, 0x8cede6de, 
	0xa13dbc93, 0xf427b787, 0x8bc4f6f2, 0x8fb13dbc, 0x1e5dadb7, 0xd18f5b6a, 
	0x36f8dd95, 0x9278df6f, 0xf0f527b7, 0xde5ea4f6, 0x6f22e9be, 0x5707d4df, 
	0x42f7a887, 0xd3c7b93c, 0x3e2ef4f3, 0x7c63f4be, 0xe6dfe37c, 0xe127f1ed, 
	0x8d6b07da, 0x5dfc05fe, 0x5fefc3df, 0xd705bbdf, 0x763f3a35, 0x6fd03460, 
	0x7ddbe08d, 0x7c066758, 0xa3e823db, 0xce33e905, 0x7c119f28, 0xb2fa436c, 
	0xea95fdd6, 0xb829e4b2, 0x648096ee, 0x9fdbfe43, 0x9d207529, 0x09025ea1, 
	0x4ca6f601, 0x32e6e4fd, 0xfd8f479f, 0xf0dfc42a, 0xb73ac3e7, 0xb6576d76, 
	0x7b9ceb0c, 0xf236776b, 0x3fd21b67, 0xdfb2afb7, 0xc195f984, 0xdd026698, 
	0x37b88877, 0x91d903d8, 0x4fb6bef9, 0x1db8fa9d, 0x78af7dfc, 0x07de113f, 
	0x11f24951, 0x09eef7df, 0x56613fbf, 0x7f95f10d, 0x135e9bfb, 0xc35c5bc0, 
	0xd2db6ae3, 0xb83f14cd, 0xd925faed, 0x96db7f18, 0x0566c4be, 0xec19bc7a, 
	0x6fb0168f, 0x30ef79a7, 0x199d3b62, 0x4e805a12, 0x76e1ab6e, 0xe416ae4e, 
	0xa9f7cc11, 0x386d29ed, 0xc70d5b0a, 0x973f81f7, 0x78fca336, 0x81f800da, 
	0x941fed5b, 0xc3bb6076, 0xf6817808, 0xedbd0f6d, 0xc909fe45, 0x37cf2377, 
	0x9d9a353e, 0xa3b9e7c3, 0xe784dfc0, 0x51b5808e, 0xc8e586b6, 0x557fa22d, 
	0x61de108e, 0x44377bde, 0xfb79a7af, 0xbef1f789, 0xe11f8fda, 0x107f3f40, 
	0x8237e0f4, 0x04eb4b3d, 0x6c31307a, 0x995c3bcf, 0x77f08f04, 0xb5b3f456, 
	0x8f18ff7f, 0x1de44533, 0xf8135fb0, 0x974f1605, 0xa5baf309, 0x87d44e38, 
	0x6cbd9096, 0x27d875c3, 0x9312c7d6, 0x4b14b657, 0xefe083fa, 0x47aa78ec, 
	0xac79f18f, 0xf2fcc467, 0x2cf72176, 0xb78f20bd, 0x0a663d61, 0xcfac47c9, 
	0xcefe883c, 0x0f7e9275, 0x312edbe8, 0x339d752f, 0xa7d6aa9e, 0x24f110ef, 
	0x7eb267d2, 0x21367d20, 0xfa43de26, 0xa7afec0f, 0xd7903fb0, 0x4eefa859, 
	0x4a07bd09, 0xd5ed0337, 0xe2ffa12a, 0xfe83efd0, 0x48fc61cf, 0xa25f501a, 
	0x0ed91c7d, 0x301a478f, 0xf189d5ce, 0xc8f1a8b6, 0x8038f2cd, 0xe344de7f, 
	0x8c2bc2c8, 0xa7b44723, 0x7850f5e2, 0x2aae34bc, 0xdbac4e31, 0xa9926a72, 
	0x36a6ea5d, 0xfd544bd0, 0xe72025ab, 0xc23d1f90, 0xac3f57fa, 0x6fac094b, 
	0x7a07f087, 0xa1b3cd76, 0x0c51d91d, 0x0191e2f6, 0xa13d5fea, 0xbf55d7fa, 
	0x8fc6f611, 0xfeba1f9f, 0xfb86aab5, 0xee825521, 0xeb5feb63, 0xfd54586b, 
	0xefc0996b, 0x07ac83dd, 0xd85cf3e1, 0x9f5d89be, 0xc588f5d8, 0x699e2c7b, 
	0xf8146e1d, 0xfabbc08d, 0x514f6a9e, 0xd86b693c, 0xc6285a7e, 0xbb7ef609, 
	0x71a883a0, 0xe4d9feaa, 0x19ff787c, 0xea796fee, 0xd5cbaed0, 0x16676e83, 
	0x23bda7e1, 0x7f5881ec, 0x331c5fab, 0x3e71d05f, 0x8e0b63a7, 0x67e88cf3, 
	0x9b53da13, 0x65ebae06, 0xf5538edc, 0x6e2ce776, 0xd72e7587, 0x5e76128e, 
	0xe602f340, 0xa69db8af, 0xf8ea65da, 0x46474d2d, 0x86967f63, 0x43d63b4c, 
	0x864d8264, 0xdbeb0af6, 0x7ba27545, 0x0d3a999d, 0xd81321ca, 0x415e3cc3, 
	0xe60970f6, 0x909fc92b, 0x611ea016, 0x7180cc59, 0x86181017, 0x41b740ad, 
	0xa1efcf2f, 0x8a71828d, 0xaa21be60, 0xe80df24d, 0xa67baad7, 0xf589e519, 
	0x05e285a0, 0x38f39430, 0xb3ae099f, 0x6e00ebcf, 0xf9437426, 0xbeba292d, 
	0x0f8eeb02, 0xbab21d13, 0x47a26e8b, 0xdf5aaf1a, 0xa8dab1a1, 0x760b42fe, 
	0x70cbf216, 0x11de2feb, 0x9bb22e79, 0x431ea29c, 0x9ac07483, 0xa6f61e91, 
	0xf8074933, 0x91301c99, 0x5bf64cbf, 0xc187af1e, 0xf560f8bc, 0xbc89cf2f, 
	0x0c1d6c5a, 0xe1add1e5, 0x5accfb3c, 0x1bf7679e, 0xc7679e24, 0xe6167c3c, 
	0xb476b5d9, 0x33aa0b97, 0xfde3dc59, 0xddf8ecf3, 0x99d9e595, 0xf30db3dd, 
	0x85eeccec, 0xd1b54deb, 0xe63f7679, 0x0bfd8fd9, 0xefbbecf3, 0xbd9e5118, 
	0x3ca876b6, 0x3cd9d03b, 0xa5359bd4, 0x7960ddf8, 0x3cb5f9f6, 0xed60f06e, 
	0x3ecf2abf, 0xe1acfc89, 0x5c7fd9e6, 0x78ecf3cb, 0xecf232fd, 0xbedc9dfe, 
	0x5ecf2a19, 0x7b575b94, 0x99dbf925, 0x7f36d7b5, 0xa80faa1b, 0xed047f8e, 
	0x7a3c50a7, 0x01f54496, 0x3d38639d, 0xd9dd5ca1, 0xe03ebfdb, 0x3d17c131, 
	0xf5513575, 0xb4374801, 0x5321a6ff, 0xeff319af, 0x2cf01f5f, 0xc52f57f2, 
	0x0f5d68b5, 0x2a1afe09, 0xebbb9f9e, 0x5d2f1e7e, 0x53e44971, 0x9f794eff, 
	0xd13733f2, 0x55ab9f78, 0xd5cf07f3, 0xf42a7cf2, 0x46c67dfc, 0x5169788b, 
	0x57b5f3ee, 0xbd6e7f12, 0xf4c574c6, 0x257e3c05, 0xe04645ae, 0xbfd5ef3f, 
	0xa1e44b3f, 0x96fb9f62, 0xbf46cd9f, 0xec11bf7c, 0xdaebb015, 0xe86e3c9c, 
	0xc7392a33, 0x5c3dfc9d, 0x2e7efc0e, 0x6d64ffe0, 0x35ea3f74, 0x26c85e36, 
	0x7fc464e8, 0xcfbd25c1, 0x16fe7a0b, 0x940e9edf, 0x4702b34b, 0xc67f88ec, 
	0xd05e7d8a, 0x4ea7fff3, 0x81270bc4, 0xfa40191d, 0x6183a778, 0xd98fb29c, 
	0x4f48ea9b, 0xe77c44cc, 0xa3661717, 0xeea6d0fe, 0x15fd04fe, 0x43ef0759, 
	0xdd9d333f, 0xd7d03ad9, 0x5eb887be, 0x0eaef162, 0xc17d7a46, 0x04bf28b7, 
	0x12f1453c, 0xb6267c76, 0xddbc8d95, 0x9ea77a8e, 0x4231af8f, 0xc7533e4e, 
	0xeb1bf9e3, 0xc1045d38, 0xef41919b, 0x4d9a2d74, 0x598257fb, 0xca1eb9b3, 
	0x3eacebe7, 0x61cc6657, 0x995f901b, 0x43def394, 0xa376cd74, 0xa49ed4fc, 
	0x94724ef5, 0xbac2ed8f, 0x7edf617f, 0x4de78eaf, 0x41c95798, 0xf964bf3f, 
	0x63c7ea4f, 0xc6e26bde, 0x318f5a76, 0x6f405720, 0x2ecd66b6, 0xf99938c4, 
	0x7494f896, 0xaf39de78, 0x4dd71f20, 0x5e90cf5d, 0x23b6eacb, 0x7ad17d7f, 
	0xca9d4b4e, 0xf88bf067, 0x645d426c, 0xfdb07a7e, 0x77c40b0b, 0xbb7814df, 
	0x19eb8eb5, 0x0ca84baa, 0xfdc057ef, 0xc880a608, 0x64430163, 0x3cff71d7, 
	0xea20975c, 0xa4fc624b, 0xb012fb7e, 0x7de1d3df, 0x608f5808, 0xcdfb8672, 
	0x788efd13, 0xafda81bf, 0xf5805fd8, 0xcefd9106, 0x6dfee3a9, 0x1a40aeb8, 
	0xb7e8cfd0, 0xfcc6608f, 0x4b8c66d3, 0x3d6f29a5, 0xc3ce1e92, 0xfabd12c1, 
	0x5e2fb4e8, 0x4eb4bf07, 0x2fc043cd, 0x59dd27ca, 0x3f075d17, 0xdbf4fabc, 
	0x9111bf31, 0x073ca7e7, 0xd108abc0, 0xfcc2fc05, 0x28effe6d, 0x6f32db7f, 
	0x56dfc8b4, 0xb0fd3c11, 0x78702df7, 0xb69e110b, 0xa1b5bc3f, 0x7ea5acf9, 
	0xe08bab99, 0x55b8603d, 0xdd1efbc0, 0xf3f3104f, 0x4657377d, 0xbf96d5b9, 
	0xd3959479, 0x71eb28f7, 0xca8fc76c, 0xa8e176a2, 0x4227682c, 0x6bf456bf, 
	0xf9455ec1, 0xbfe7fd31, 0xe17941cb, 0xfe0f7213, 0xb278ca7c, 0x80c77d7f, 
	0xf7841fe1, 0x80df7825, 0xf5d81e3e, 0xdfc7cafe, 0x49bf6460, 0x7c1fe81d, 
	0xd09fac08, 0x277cfd83, 0xac29ed1b, 0x1a39453b, 0x72e1cd74, 0xe93678a2, 
	0xbf5156f1, 0xcd09eb72, 0x3c178428, 0x3f3f9331, 0x39407339, 0xa6b60692, 
	0x871f02e1, 0x5befe817, 0x428ee727, 0xb27a79bb, 0xd3c606fc, 0x7ca6aec0, 
	0x53c8276d, 0x66cc8bcc, 0x22f31db2, 0x25a7f2b1, 0x43f3cf8e, 0x485b6649, 
	0x50f9663e, 0xc5987cbe, 0xf20f7d24, 0x77a7df03, 0xcb6c624e, 0x76e3112d, 
	0xeaeb71f2, 0x6e099cb8, 0x9d6f7210, 0xe2f97b90, 0x6a1cc73d, 0x2d3d1c93, 
	0xe30b61f0, 0xf24937c7, 0x758e4179, 0xc3e39a5e, 0x07e91278, 0x90b72fa0, 
	0xf30bccfb, 0xd33a3c40, 0x67695f68, 0xc71d9a79, 0xde28b457, 0x162f7288, 
	0x7c27a08f, 0x937c27a8, 0xbf44ff94, 0x771e5622, 0xf9f9025e, 0xfa0e1849, 
	0x167fd427, 0xea0cfff4, 0x7c0bc035, 0x6dd7bb3f, 0xade678c7, 0xfe908e27, 
	0xccabcd6b, 0xe7fd28d6, 0x7b6baea5, 0x736ea656, 0x45758060, 0xeb4b39ba, 
	0x9d7d7543, 0xcfff3e97, 0xebb1f848, 0xd3d206fc, 0x24e00185, 0xad4d7f73, 
	0xece59bab, 0x097ee3b6, 0x0a775d75, 0x047cc3fa, 0x2b208bea, 0xff147f25, 
	0xc1e10d64, 0xd61fb4dd, 0x3347302b, 0x43031f90, 0x3f41a13b, 0x656b7644, 
	0x69ad4790, 0x313fe512, 0x8a72978f, 0x89bb4be4, 0x074a42e2, 0xfd5441e6, 
	0xac4b837c, 0xe3bc0313, 0xf92798fa, 0x5ad45e30, 0x56fc4699, 0x601aea20, 
	0x94ddbe5c, 0x3c3a5097, 0x5f5bf111, 0xc60a6b43, 0xb1ee9163, 0xd8e9015e, 
	0x8baf80b4, 0xda1ff057, 0x1e824905, 0x7c043e54, 0xda26bcf8, 0xfa476a67, 
	0x02f7ba47, 0xe3138e8d, 0x66e607f1, 0xd928fc73, 0x13b01f88, 0x89681ec8, 
	0xfa00bb03, 0xf1bf40ef, 0x87f3d094, 0x3e305d84, 0x4c1ccfc2, 0x657eab9f, 
	0xbf68ecd9, 0xcb8afcf2, 0xc24595fa, 0x76122dee, 0x5a9d5267, 0x1aef1117, 
	0x3ac1dfc8, 0xb7357357, 0xc2dec733, 0x1ed4c8ed, 0xf39a7f6e, 0xed50f8c2, 
	0xa1d8cbcc, 0x7b473d0a, 0x3b706f33, 0x9fa0bb73, 0xfb16fad9, 0x1f4fd01e, 
	0xfa06be09, 0x36f10378, 0x8ec9f00b, 0x3f005f23, 0xd4b9bc60, 0x123d42e2, 
	0x74285f1b, 0x017c595d, 0xf11abbbf, 0xb8ba6f85, 0xe2cd717d, 0x11ee7d0b, 
	0x56de43ed, 0xe43ed43f, 0x9617c5e1, 0x2f5fba0a, 0xf8b55fae, 0xe3c5db82, 
	0x96bd780b, 0x133385f1, 0xe3bb273f, 0x3ae8eab9, 0xe9fae1fe, 0xfd81ae4d, 
	0xd53fc474, 0xfc4d7ff1, 0x78cff274, 0xfdc3519c, 0x92734923, 0x6b850a9a, 
	0x3cf3d6c7, 0xf6d7dc39, 0x29b33572, 0xebfbff08, 0x5c929fb2, 0xfddd3a00, 
	0x95d61f58, 0x7f9c5ac9, 0xe305f9ec, 0x1c529740, 0x6ffd04d3, 0x3d93fde5, 
	0x3c68658f, 0x4f79a8af, 0x3db57ea6, 0x31832d70, 0x7dd22f3b, 0x1bef106d, 
	0xa4bd393c, 0x9e1c5887, 0xe2caf0ff, 0x583a5d67, 0x7b2d1f97, 0x3a03a5ce, 
	0xe6664e63, 0x4f0819fd, 0x680c27a0, 0xc27d503f, 0xae5ed041, 0x9d1bc234, 
	0xd44d3157, 0xe7c3381b, 0x6e0b0456, 0x084f0995, 0x051e0b71, 0xe41c9ee1, 
	0x7b42cce3, 0xf0718fc1, 0xf5b71463, 0xce813e61, 0x73d2b0ad, 0x98a7ad33, 
	0x595c6c47, 0xd9384fdd, 0xe0a0ebc9, 0xe7c5d6cf, 0xc79d7b6b, 0xe6df339b, 
	0x6f00cced, 0xf9e3e94f, 0x124a2990, 0x1d7acfdd, 0xb6f4b7ec, 0xc1e727fb, 
	0xbb59f6bc, 0x393ed133, 0x7ea8c790, 0x47dfdd5f, 0x3e7063e7, 0x3ff9863a, 
	0x41ebd9ad, 0x2f1b467b, 0xe3471e1b, 0xc71d2ac3, 0xc64e74fb, 0x427ef082, 
	0x03d2f6f3, 0x582de728, 0xfc3a9177, 0x51b076b8, 0xdf096b23, 0xbe019192, 
	0x4da1db82, 0x2c8c5078, 0x533fda01, 0xd475d2db, 0x5f7d5e7e, 0x3fde8eb9, 
	0x8a3e7a1a, 0x7a15bf9e, 0x9f9e8a3e, 0x9a3ff50e, 0xfd4217da, 0xb5f7a68f, 
	0x137bf55a, 0xf55acdb5, 0x5fbe137b, 0x52dce30c, 0x8011fb8d, 0x260f9150, 
	0x14a5cfa9, 0x65f70e7c, 0x3070103d, 0x4947ed57, 0x3a547ea1, 0x1695be28, 
	0xfa105823, 0x58e34cce, 0x4cdf7a12, 0xc68657ef, 0xf5ed4a91, 0xd2a471a1, 
	0xefa18dfb, 0x853c70c7, 0xf1c31fbe, 0x8d3efa14, 0x7df429e3, 0xe853c71a, 
	0xa78e58f9, 0x1cb1f3d0, 0xc7fea14f, 0xfa853c71, 0x0fef871f, 0x597f97c5, 
	0xf91eae36, 0xf293f897, 0x6f4e726c, 0xeb0fe905, 0x9c47ae4a, 0x5b181aab, 
	0x3bcfcf54, 0x46716579, 0xa39df23d, 0xf26b9f89, 0xeb1365a3, 0xc1fea347, 
	0x97f7053c, 0x53e21e6c, 0xf5e1e6c9, 0xc50f366a, 0xe79b1477, 0xd46be738, 
	0x7f629d07, 0x0e9de52e, 0x79a70e62, 0xc323d232, 0x9102d3bc, 0xf9867277, 
	0x913e6867, 0x55d18eb2, 0x9f3d42c9, 0x919348ae, 0x3ca6f3ae, 0x1892c538, 
	0x1be213e6, 0xed5fc88d, 0x8d7e7fe8, 0xf953bf9a, 0xd59f963b, 0xaf286873, 
	0x7e423157, 0xfe7c33db, 0x51977e32, 0x98f7fd3e, 0xde10bda3, 0x78057527, 
	0xb9bca11b, 0x03a71e3c, 0x03bd501d, 0x9c22b1e2, 0xb9f152cf, 0xf23cccff, 
	0x0fdb06f3, 0x8b0f7056, 0x9ed60fda, 0xc1fb49db, 0x2f5457d8, 0xa738999e, 
	0xcb7bfd19, 0xcf00fb10, 0xa7d4cd4e, 0xb4bed0f4, 0x8c7da613, 0xba8bd5d5, 
	0x5da71e87, 0x59d50373, 0x2bdcd96c, 0x786f4ef4, 0x87aaa05f, 0xea6a6b5a, 
	0xd6be3035, 0xcd6c9aea, 0x263baa26, 0x1bf5b6bf, 0x7c63d0df, 0xd4cae2c0, 
	0xf8c176eb, 0xaa5b3e72, 0x5eb3a983, 0x7ddc676e, 0xbf0f5f0f, 0xe5ba5959, 
	0x048fd600, 0xdfa0d63e, 0xfebdbb91, 0x852af24a, 0xff1b6bae, 0x9fd4c5f6, 
	0x3e4ef2ff, 0xaf3baa3f, 0xf628fb10, 0x1d95fa89, 0xce95c743, 0xecbfcfe5, 
	0xf5c3acbe, 0x70eb1c6a, 0xbe6f8f3d, 0xdf191f5c, 0x677795f4, 0x51093a8b, 
	0x0f652b7f, 0xe6db7f54, 0x3f46ceec, 0xd0828b18, 0x17e7f15f, 0x3ede60e6, 
	0xbfaf2579, 0x86e7a9f5, 0x5bb789cd, 0xa6eed803, 0x833689ba, 0x37591d92, 
	0xcc2cead1, 0x36dbfac6, 0xbef88b70, 0x4786e96f, 0x1fdf06f3, 0xfe3177f6, 
	0x9db9eaf7, 0xec5eae7a, 0x59c50b0f, 0x5f28fef9, 0x644e68e0, 0x82b7f59c, 
	0xb38c873e, 0x50fd8a96, 0x75567131, 0x814f97bf, 0x7ee19d7e, 0x330fd54f, 
	0x1bf6aace, 0xf7556713, 0xa25af973, 0x0fd60dfb, 0x2a5ace33, 0xfba98df6, 
	0x76bce6b7, 0xb38f2a4b, 0x7f056f96, 0xd8f7d7dd, 0x6714bd9a, 0x247b6e95, 
	0x59c78bef, 0x7e954ad9, 0x8fd117e0, 0x9c646576, 0x219df695, 0xc83ee0fd, 
	0x91a7da44, 0x8ddaf083, 0xc07b99ce, 0xf39d2bcf, 0xbdd4f2da, 0x7f6b1754, 
	0x86bb9c54, 0xe38a5eab, 0xb38f0bec, 0xf82ee503, 0x0f42adeb, 0x04bfeec4, 
	0x7a839d79, 0xc545e296, 0x747dff58, 0xfbdffa26, 0xc05d39cb, 0xb37ce8a8, 
	0xfc6df6c1, 0x533c72cf, 0xf8c6e50b, 0x37225795, 0x296bfbf0, 0x17cf6237, 
	0x26f98728, 0xf3f23bdf, 0xdc3bf005, 0xcf45f1df, 0xa9582817, 0xf3d425c6, 
	0x4b8a14d1, 0xb52e58e8, 0x90347ce9, 0x378c1627, 0xd1f38854, 0xe77eb10e, 
	0x38c44da3, 0x27c44986, 0x4b8997bc, 0x38a7cb9c, 0xe12e2871, 0xb8a23edd, 
	0x5e56efc4, 0x6ad1f39d, 0xaf37bcc5, 0x25c557fc, 0xc0be7646, 0x2e3c95ce, 
	0x7b6bd781, 0x4b8880be, 0x0fd74434, 0x817cf70c, 0x3e072b5d, 0xfff1005f, 
	0x13bf3a75, 0xf68ecbe8, 0x13cf1fa1, 0x76bac34a, 0x83b42fe0, 0xd63b330f, 
	0x12ad369d, 0xb7dc5ff1, 0x960ef941, 0xc7fee019, 0xd7f000e4, 0xd8e6fbb7, 
	0xf7f1119d, 0xdf7c55c4, 0xa4499686, 0x0d5ea9b7, 0x19d3b1d6, 0x3c86794f, 
	0xd10ebb03, 0xe5a0dfe4, 0xf7588ff5, 0x6df3eb06, 0x7dc68f26, 0x5f229f55, 
	0x09e7c368, 0x5b321a59, 0x192b5ed1, 0x1dfdf12b, 0xfb8ec906, 0xdd398253, 
	0x46df854b, 0x7cb255eb, 0xc7e22652, 0xc7ed249c, 0xa887327a, 0xc86ceb77, 
	0x8d6cd1ac, 0xdfa14be0, 0x95f9f6d5, 0xeeeb9f5c, 0x87957ce1, 0x71f00cf2, 
	0x61d79383, 0x186a7da2, 0x8f53edcf, 0xef87bf95, 0x0d2bf687, 0x7dfea761, 
	0x9bd7d725, 0x085cbf50, 0xb945abdb, 0x3d22bfbf, 0x1af2be50, 0xed5547ef, 
	0x72ea21f5, 0x5d4e6ed0, 0xfba5d5f7, 0xee7b38d8, 0xb38b2baa, 0x235777e3, 
	0xa5596ece, 0xf49933ea, 0xfb38ff57, 0x27de7101, 0x62136fd7, 0x18bcfbcf, 
	0xe927de7d, 0xa04667bd, 0x467b9ccf, 0xe8f7c754, 0x6713abaa, 0x57bcc497, 
	0xc66afaac, 0xe2acd7d9, 0xfd7829f5, 0xf4fbce32, 0x819f79e3, 0xf9f79ce1, 
	0xdfece2c5, 0x9c70355b, 0x75fff11d, 0x3d8b87aa, 0xf3a866e7, 0x0d9c0e6d, 
	0x6f3bdb1c, 0x8b8173f0, 0x755b1f72, 0xb96e7525, 0xbdadaeab, 0x38d66cfe, 
	0xe78d3b0d, 0xb0d2ecb3, 0x7c9ff446, 0x580fd8ab, 0x7422f3bf, 0x67d83633, 
	0x7b717d25, 0x0355dde9, 0x96374bdb, 0x263cfe5f, 0xeb8be7dc, 0x79c70d31, 
	0xaca9c714, 0xfd637f62, 0x3ac47fce, 0x453bd415, 0x68ae47b9, 0xafcb523d, 
	0x57e1dd71, 0x5b865f94, 0x0cb933c7, 0xae175aba, 0x8eaa18ef, 0x78abefe7, 
	0x477e0f1d, 0x77581475, 0x79ea2157, 0x4be1eea8, 0x3399e7aa, 0x3bc7f287, 
	0xc83ef81b, 0xdc79eba1, 0x3eeb2333, 0xe79eb4ae, 0x7ae06939, 0x0e63a09e, 
	0xad5b6f3f, 0x7aeb51e3, 0xe7f0e7f2, 0x4062bd6a, 0xd28af511, 0x587fbe71, 
	0x8bd8f25e, 0xf9f3af23, 0x833b9087, 0xb0f8f9d5, 0xd973d50e, 0x95df1f3a, 
	0x02ccf9d4, 0x0f5d523c, 0x3f4111d6, 0x535b5345, 0x7549b130, 0xcffb5b3f, 
	0xe3e7543b, 0xecdba498, 0x87cebc1c, 0x52b685ea, 0x72ef8f9d, 0x608b3e75, 
	0x077ba5bd, 0x74f40380, 0x17ae102c, 0x508dc90a, 0x99e6cfdd, 0xa35cf591, 
	0xd3b41fa0, 0x3f75d5ff, 0x7588354f, 0x7eeb92fb, 0xaf0d94a6, 0x437767ee, 
	0x4727eea8, 0x934e47f0, 0x0bcfed09, 0x4b419e74, 0xf18d949c, 0xaf889f5a, 
	0x7eeb86b4, 0x7eeaa3da, 0x9fba8aa6, 0xa52eb162, 0x3b542f82, 0x68ecc574, 
	0xd5f7b43b, 0xe0fdd511, 0x4fdd787c, 0x7a40c353, 0x1fbaa861, 0xab571f15, 
	0xf488c7ee, 0x03e75513, 0xf040b17c, 0x1d65e001, 0xf918bf3e, 0x38f2e81c, 
	0x837da73d, 0xd27f4b7b, 0xb9e17e80, 0x98c6f9fc, 0xe780f8b8, 0x16734c52, 
	0xe84e911a, 0x8b8c02fc, 0xb9d08e7b, 0xf0342f14, 0xf2e784fd, 0x31fc5c45, 
	0xcfc5c50d, 0xb4cf77e5, 0xb106fbe2, 0xe3e31cbf, 0x0b7cfccd, 0x3f438b8c, 
	0xb70df8df, 0x3cde6e7f, 0x0e79ffbd, 0xfe09968f, 0x11f1f210, 0x8d3076d1, 
	0x7f05f311, 0x57f3e328, 0xa7b6bff7, 0x280173f3, 0xe86db0bf, 0x2dda3078, 
	0x81ed7cfc, 0x1abb54eb, 0xf8553ad4, 0x57f9e035, 0xf580ddff, 0x6f3dc3b2, 
	0x62b7854b, 0xb7dc3a90, 0xf3f8d41a, 0x9f030d5b, 0xc376f5ef, 0x56d7ce48, 
	0x320d95e1, 0x7e6840bf, 0x77e64181, 0xe72461ba, 0x5f150f95, 0x05e0860f, 
	0xf31d781b, 0xcf221b9f, 0x6fd88af7, 0xe0fdc7ac, 0xdd07ab19, 0x27e74c6f, 
	0x6034fc4e, 0x7a8b78c7, 0x6af2759e, 0x9e1ebe71, 0x4efe80f3, 0xb331bf68, 
	0xccc6fdf3, 0x558dfb8e, 0x6a7ff5be, 0x1c83a7b5, 0x2c9de7fb, 0x1f9dff6a, 
	0xe9e376f3, 0x51d92d3b, 0x51d91d56, 0xbcd5a65a, 0x8ce9732d, 0x761a2df5, 
	0xbfe29687, 0xbe72d64c, 0x433475e1, 0x012de9e5, 0x1cfa3b29, 0xf7c6c918, 
	0x91332be1, 0x0ef9633f, 0x9f2448f3, 0x260f3899, 0x7c8f50ab, 0xf05ab997, 
	0xf7cf2f5d, 0x9f937cf7, 0x57ae7307, 0x28f98999, 0xfa06073a, 0xb44830cd, 
	0xb39b7a7f, 0xd77c86d0, 0x7c05a4ca, 0xf3e4af1f, 0xc7dc8f4c, 0x7d8bb5ab, 
	0x226f7abc, 0xfb94075f, 0xf8f0351f, 0x9e4247ea, 0x78fbc3f8, 0xf7cfb8f5, 
	0xb6c7a163, 0x1b1f3c89, 0xfda38fc4, 0x2f31e30f, 0x32bf4c3a, 0x99a97ba7, 
	0x436447d7, 0x6b67ec77, 0x9d2bf607, 0xb2bf7177, 0x6dd601b5, 0x555e444c, 
	0xd54313d8, 0x9965fd43, 0x03f0dab4, 0x0f551fba, 0x44d27e65, 0xfd9072e7, 
	0x87fc8fbb, 0x9e05670e, 0x366e04e3, 0x1acdfdc0, 0x87cfeac6, 0x17dc78fd, 
	0x50e5e78a, 0xd9f7135c, 0xf3012c2a, 0xaf1f405e, 0x25e8bee3, 0x8ddeb9ab, 
	0xe7a8638d, 0x04b03877, 0x7e7c27a0, 0xf0dfd607, 0x84c52a7a, 0xdba906f5, 
	0x09c5324d, 0xe82aee01, 0xb797bcc7, 0xaefd047f, 0x5a5b3d42, 0x3eb75abe, 
	0xb831ff8c, 0xceed04cf, 0x6ec382a6, 0x6bf7c713, 0x849ae711, 0x65e9e7ce, 
	0xfca8efe4, 0x781ae787, 0x96dcfc5c, 0xf7fdf0ad, 0x757af357, 0xab654f3c, 
	0xa1e1ce97, 0xa75a5873, 0x39aebeb6, 0x24ece74e, 0xe2b47ae0, 0x7872e3f9, 
	0x7bed2c7f, 0xc019f6c5, 0x5df38c23, 0x69f7f718, 0xc6acf79c, 0xa07b93ba, 
	0x988bac5f, 0x69c78c70, 0x12979fc6, 0xfc38a71c, 0x5cfc2d83, 0xef004385, 
	0xdcb86b4f, 0x5c14f3a0, 0x5805dce2, 0x5cf2cb28, 0x4155938a, 0xc79d373f, 
	0x23ea34f9, 0x0bf21dcf, 0xbdf7c0be, 0x36dfde2e, 0xb16ac3c0, 0x3a2f380e, 
	0x1bf45487, 0x892fc674, 0xdc4ba48f, 0xb9f14c87, 0x0709258c, 0x689bdc70, 
	0x4439eadc, 0xad29f9ea, 0xc275dce2, 0x9738a247, 0xd05b9e1d, 0xe879c07e, 
	0xbadb7dac, 0x89ef7de0, 0x893df795, 0xa675e6eb, 0xf9fbfe72, 0x0e18bf43, 
	0x901cee7d, 0x9ce21d3e, 0x1c9f90ab, 0x5d3f2fc3, 0x1c9fb03d, 0x9ca1b38a, 
	0x5f9fd9db, 0x29687e42, 0x7111f3b8, 0x515ed50d, 0x818341fd, 0xe7607ffb, 
	0xf81cf8c8, 0x3543fc82, 0x0bf6464e, 0xe9c3cdf2, 0x7b21feb4, 0x6f8f3569, 
	0xe3e1aca5, 0xb183ad8b, 0x8c767ee2, 0xc1d4c57b, 0xc2131d60, 0xddd8ef35, 
	0x97fff684, 0x60331755, 0xc215517d, 0x69e7493d, 0x8ceb557c, 0xad3bd286, 
	0xd20d04ba, 0x8f0d758b, 0xf5270797, 0xdf01f3f9, 0xa6e5736d, 0xce143d9f, 
	0xc8c6e833, 0x5e805347, 0xd64a6975, 0x5d601b98, 0x1da978f7, 0x359dd79f, 
	0x6f3c49e6, 0x2a737d2c, 0x9ce891c1, 0xcc127341, 0x6da2681f, 0x401ff725, 
	0xe3226a1e, 0x70d6639a, 0x4d5ea1fd, 0x6348ecc9, 0x4ee35c25, 0xd39fa3b4, 
	0x7f08c496, 0x7469f9ad, 0xf6ffa178, 0x5c62cfd9, 0xb826af08, 0xd212d332, 
	0x7ae24cff, 0x53a74e38, 0xe565a6de, 0xbef8387a, 0xf8fe8ac9, 0xccd992f4, 
	0x7058ae05, 0x64ad2fe1, 0xfb0967ff, 0x7f25de7f, 0xf07f103e, 0xde75712e, 
	0x0ef389da, 0x26d717ae, 0x5c427d71, 0xa4e81e5b, 0xd7179ef7, 0xfdf807ae, 
	0xe06b8adf, 0xc0bd7e65, 0xb9d44caf, 0xedadf5aa, 0xee8d967a, 0xc6eba0fd, 
	0x607d1376, 0xdfbd55bc, 0xf7a3f746, 0x277cde59, 0x85458f97, 0x7999d7e0, 
	0x1ffa1dbd, 0xfdf8bb4f, 0x65d37bfd, 0x6a6fcf2d, 0xe028bd79, 0xa99fe409, 
	0x0f49e380, 0xee427484, 0x8e504f2f, 0x6fd138e0, 0x8dd154f4, 0xe867ac38, 
	0xdd19eff7, 0x03f424c9, 0x8ec199d3, 0x39c5f8dd, 0x299f2c99, 0xea7808ee, 
	0x3716b0ba, 0xd80a4bd9, 0xb16f5c5e, 0x8c297b28, 0x668b4527, 0xda27aabd, 
	0x0bbc7d6e, 0xd75bd99d, 0x3c64baf0, 0x8fef07a7, 0x0f789e65, 0xeae9dfbc, 
	0x3df903be, 0x7bc7158d, 0xd31e30a4, 0x0ef9720e, 0x6789c872, 0x4a9ca235, 
	0xa73943ca, 0x70ce7a33, 0x1f792a3f, 0xcefd07ef, 0xe703d6a1, 0x945cf48d, 
	0xf335cfc9, 0x751bc4e7, 0x6b79e237, 0x6f580d9b, 0x9f1a9963, 0x4debe068, 
	0xe453a372, 0x063e611b, 0x699d53f2, 0xd66fe23a, 0x11d79938, 0x141e04db, 
	0xe553ebaa, 0x24494006, 0xd5cf0f7b, 0xfcbfadb8, 0x06750760, 0x6a765efc, 
	0x0192f7c5, 0xcc00dfe9, 0x3f03f422, 0xb6f1842f, 0x7a870e7a, 0x8cbb0dce, 
	0xb78f7c3c, 0xfde79f27, 0x76e3e94e, 0x8a2e94de, 0x64fa8943, 0xcf1934bd, 
	0x49f202df, 0x902df6e4, 0x9353b70a, 0x45a2a97a, 0x714f3a49, 0x8fb92908, 
	0x08e593b7, 0xe94e6679, 0x5ed06fdd, 0xcc92df06, 0xc28556e5, 0xad7bc18e, 
	0xae74499f, 0xfdf10594, 0xcb23d80c, 0xc8d21d84, 0x6eb03d9a, 0x79e1ac0f, 
	0x21fef54d, 0xf200df68, 0xedc6c32b, 0x13568b50, 0xf154defd, 0x7dfe69fd, 
	0x00f62f28, 0x80626de8, 0xcde21f62, 0xa6fa656f, 0x668f3473, 0xb4f67b8a, 
	0xc6a61d90, 0x4da7fc43, 0xcd1d79ea, 0xb8e10eb8, 0x403e6b08, 0x19a91171, 
	0xffb55fed, 0x9d2b1e8c, 0x2e3fd567, 0xc520f602, 0x31ebc731, 0xe85fb22e, 
	0xe78b8b3d, 0x486e297d, 0x8fa64271, 0xb6bc8b8c, 0x0391c446, 0x6e3cf573, 
	0x5c79d2c4, 0x697fef84, 0x97e7e389, 0xa1fb104c, 0xae0c3f68, 0xd993ee3f, 
	0x8bedfac3, 0xd8e7e509, 0x22e3a2b7, 0xd860fbb1, 0x37ad973b, 0xe0073d89, 
	0xfcd46b17, 0xe54b8f2b, 0x487b038e, 0x98cf2fe9, 0x0546e40b, 0xa5ab579d, 
	0x5153a6f8, 0x6479dfe8, 0x31798626, 0x8a649266, 0x98782583, 0xe815f58c, 
	0x5e002437, 0x96acf9c5, 0x6f4f584a, 0xc0379d78, 0x8c8efd15, 0x177af857, 
	0xe6b4bee5, 0xa963f64a, 0xb8d231eb, 0xa9df368c, 0xcbfacabc, 0xae381dcd, 
	0x9e8bb8e8, 0xe9345dc7, 0x6dc7d9c3, 0x7e4e51de, 0x13deea74, 0xfd768fdc, 
	0x7d97ce86, 0x24f1ede0, 0xa359de0f, 0x59de09c6, 0xc0d4ebc3, 0x3dff06b2, 
	0xfcf0dd65, 0xf37fb574, 0x81bfd176, 0xcf70c79f, 0x9ff7ee78, 0xe9faa35a, 
	0x74fc8bf0, 0x4fc038f0, 0xfb8ebb1f, 0xfc5741e9, 0xa00b5d12, 0xa89cc367, 
	0xe7130d78, 0xf8b2be99, 0xf7f1d5ae, 0xb72bdd52, 0xd6aec19f, 0x177cfd81, 
	0xb8ebdbda, 0xf0f1447f, 0x441ea2c3, 0x65fc7bd4, 0xcc0ff72d, 0x111db90b, 
	0xb92da574, 0x53a1e507, 0xbc9397d2, 0x7e41fbe3, 0x3badef0f, 0x8fa97c4f, 
	0xf041afdc, 0x0f034e50, 0xf785b26d, 0x7f70588d, 0x9c53e600, 0xb3e24b19, 
	0xe8c81cf0, 0x0fc123fd, 0x8bf6a3f2, 0x43f7d57c, 0x507feec4, 0x80ccedcf, 
	0x79c16f79, 0x5083eec6, 0x791017e7, 0x7db37ff9, 0x01fc0c10, 0xe249675c, 
	0xfdbf4576, 0x24fb313e, 0xd83b7d54, 0x7dd89f3e, 0xbaf6b13c, 0x9fc3ff6a, 
	0xdb5fe84d, 0x6d27ae31, 0xf33b7827, 0xc119b524, 0x29b0d169, 0x7935dcfc, 
	0xbf5ca7ca, 0xd3e94566, 0xb64e0f29, 0x7a93f7f0, 0x05249f38, 0x2f92cae9, 
	0xa7f276f2, 0x77ffc38d, 0xbf7fd571, 0x47efb42c, 0x46cb77fd, 0xad47efb8, 
	0x436b07fb, 0x8df1e38e, 0x1aced047, 0xa36ed2e7, 0xf08775f3, 0x5bf68627, 
	0xfc35ad57, 0xe80fee8d, 0xe7160eb7, 0x7120e1f9, 0x3adf909e, 0x56279c48, 
	0xab7eab7e, 0x553de45e, 0xd7fc91ff, 0xfcf2febc, 0xd69bc595, 0x3f0a2eea, 
	0xb5f85ab6, 0x47da302f, 0xfdc67883, 0xdd5f7833, 0x38f6832f, 0x68fca5d6, 
	0xb8b596d9, 0x0fbd4d6f, 0x11935bdf, 0xa363316e, 0x5effe05e, 0xe9c027b3, 
	0xde1893c9, 0xf8219337, 0x0cf482d6, 0x6e36b493, 0x91ffda8a, 0x2bbf9ea1, 
	0x97b555e8, 0xf8485e29, 0xeefe3abe, 0x2f9728ab, 0x9207dff6, 0xbf2013d1, 
	0xcef95fd7, 0x15dcfcfb, 0xcd5ef246, 0xaf303b2b, 0xbcfc315c, 0xcaf303b2, 
	0x2bc82315, 0xfdc9996f, 0x75f6a1b8, 0x09eff50c, 0x0dbbeac4, 0xd69f4897, 
	0x71a58c26, 0xaaad6afd, 0xe917e0ef, 0x516b23bb, 0x53afa69f, 0xa3bb9dff, 
	0x8aeda36b, 0x39e3e5c0, 0xc277f931, 0xc583d00f, 0x96cd4dfa, 0x1d61af17, 
	0xe2932b9a, 0xa3230e5b, 0x1f89bef3, 0x06ba09f6, 0xf8bc9cc6, 0x1f94dad4, 
	0x5bedea44, 0xdac65f48, 0x1be14371, 0x7eda2be8, 0xfb251e71, 0xfb96b962, 
	0x55ae1f33, 0xd70f97ed, 0x2fe5fb72, 0xd734ef84, 0x6828f2f0, 0xbfbc603f, 
	0x0e359153, 0x50a5e718, 0xe30bf07f, 0xa37ff964, 0x5547da73, 0x8e7c228f, 
	0x8793bac3, 0x6ba7ce10, 0xa3198ed1, 0x94a349da, 0x674fc89d, 0x0cf4bc26, 
	0x7dd2c3f2, 0x7f456f2f, 0xf82fe97f, 0x9603fff5, 0x00f70ff1, 0x0003a1a1, 
	0x7dd59c78, 0xd5547c0f, 0xc999e899, 0x8c937324, 0x32064938, 0x4ccc03f9, 
	0xd408c926, 0x844a904e, 0x14012f58, 0xa89892ab, 0x4eb67fa5, 0xdd5a0120, 
	0xe1ab452d, 0x4c33708f, 0x30a01326, 0x41265124, 0xe968a26d, 0xb5d16e96, 
	0x5eb6adad, 0xc7d0d630, 0x9a8ad2ee, 0x41db73ee, 0x97dd35d2, 0xafa8f2ee, 
	0xf7d6948d, 0x667739fd, 0xfba02132, 0xfcbeddda, 0x9bf4f57e, 0xdf39ee7b, 
	0xbe77cef9, 0x5c20f7ff, 0x4d8917af, 0x7d7c6c42, 0x053ad0ba, 0x694e99fe, 
	0xb7a668d8, 0x11e615a8, 0x0c63cd86, 0x626788ef, 0xa518cea3, 0xb6719f56, 
	0x71c2e09d, 0xeab0ef80, 0x7e0117ce, 0x6ff6fe1f, 0xfeec6217, 0x26f34163, 
	0x09605e7a, 0x7fbe110b, 0x4aecc467, 0x90edbf3e, 0x85478447, 0xd6a1b958, 
	0x9e109a21, 0xb1c70c13, 0x0074b62d, 0x86fa12bc, 0x7af0063f, 0x069c43b3, 
	0x4b1cd0f8, 0xd1ff3c07, 0xe20d92fc, 0x7b7108ff, 0xf7c4e824, 0x84f21e56, 
	0x76d0023b, 0x3ce2722c, 0x37e8f677, 0x36c65e47, 0xf780622e, 0x17c6f79d, 
	0x2b529645, 0x9dcd8062, 0x9d05159f, 0x8e6da04b, 0x322e288b, 0xa7b79f47, 
	0x72f3d695, 0xab088bfb, 0xb8bc2573, 0x6dfa06bd, 0x964496d5, 0xe37f1b61, 
	0x1b428f1b, 0x6e4797d2, 0xb8c5f684, 0xb41677bf, 0x07dbf5cf, 0x7183be70, 
	0x0ff1c111, 0xc607356a, 0xcb429881, 0xb57e3c10, 0x8e85ef1c, 0xf76b821a, 
	0x2bbc138c, 0x8a0fe382, 0xfa533b1d, 0xea96f9df, 0x5fcfc9de, 0xc3f3c10e, 
	0x6afe2dae, 0x1dc3ed3f, 0x0e09813f, 0xabfb165b, 0x833b408f, 0x450c96db, 
	0x9e92fe0f, 0x151f68bb, 0x44da27ad, 0xe3b4bbef, 0x07aedcf8, 0x62efe3a7, 
	0xef0bda20, 0x0ef1e7cd, 0xe3c2db2f, 0xc0db25dc, 0x946edc0b, 0x8fb6486d, 
	0xf7ffb6c8, 0xb2b3defc, 0xff3dfc1d, 0xe36c86fe, 0xf7e8ab8b, 0xd4b5b273, 
	0xa1efe154, 0xbc70ad68, 0x1fd34422, 0x56cfcc33, 0x032e3e20, 0xef8901df, 
	0x5bb7c480, 0x0b9f19bb, 0x7407bc5d, 0xc8825f82, 0x1dde8a5f, 0x09be622d, 
	0x2dd4df03, 0xd11b0af0, 0x325aff93, 0x009dc2d4, 0x02fd0267, 0xb4b3ce1a, 
	0x9fa259e4, 0x3afdabb6, 0xc60d67e6, 0xd6bfa3bf, 0x871e902c, 0x2a56dfbe, 
	0x51e71af9, 0xd97ff875, 0xc9af5600, 0xe170f3c0, 0x7e19d3eb, 0xfb8275fe, 
	0xf3e1cdd6, 0x663fe591, 0x8a543e02, 0xf8859285, 0x0e83aa3a, 0x86fb2718, 
	0x88254cea, 0x9c416bef, 0xb22fcb27, 0xab7f9e71, 0xe20debfa, 0xf5a2844b, 
	0x9f5a36dd, 0xf3483075, 0x15a8272a, 0xce18a7d9, 0x9cdb8b7e, 0xf73dfe31, 
	0x2f73865d, 0xdc1b6c30, 0x04edb041, 0x538ae2b5, 0x16f15f0c, 0x1846d3c3, 
	0xf0c6369e, 0x7c32ef95, 0xed8605e5, 0xed822183, 0x7915a827, 0x7bce18a7, 
	0x11fce18b, 0xa0c7f386, 0x0d0b296d, 0x2cce7068, 0x26e8ffae, 0xd1dd083a, 
	0x37537c06, 0x239de1df, 0x758354f9, 0xf7e0da37, 0xaa7efe00, 0xf725b45b, 
	0xde16aa67, 0x535a78f7, 0x75747fde, 0xc733d207, 0xcd595c27, 0xf5999c42, 
	0xcf3c1ebb, 0x19108a39, 0x19ce3700, 0x17ef686c, 0x7db321e2, 0x997e8340, 
	0x20fdf876, 0x9b9e1310, 0x9a9fa99b, 0x17e21cf1, 0xb5f3e2b2, 0x8ed0e68a, 
	0x4cbed10a, 0x1b78ecb5, 0x0311cd7e, 0xc3ac075a, 0x7f42130e, 0xf63a1145, 
	0x938a76cf, 0x56db0099, 0xdbe20d88, 0x43dbcf30, 0x6b20ed0d, 0x6a85eb32, 
	0x7df1811d, 0x7e82cd42, 0x5e4b732d, 0xf8e8f895, 0x16eb3dfe, 0x298178e7, 
	0x2caf7a1f, 0xf2d9cc82, 0xcc865beb, 0xe59aafb4, 0x166fef14, 0xb4d37fee, 
	0xf7157fbf, 0x33d541bf, 0xb66d8e91, 0x80f29be6, 0x5e435faf, 0x7af01778, 
	0x69dfd164, 0xb51caeb8, 0xdf1ab83b, 0x67484353, 0x78c25ce3, 0x932baf4d, 
	0xb35af9cf, 0x11b9f1a2, 0xc497da2e, 0x785d51b9, 0xed9ad66e, 0x803904da, 
	0xf634ffe7, 0x37a20753, 0xfb48e527, 0xa335af02, 0xfe7f4feb, 0xa601b67f, 
	0x1cb2777a, 0x49766b58, 0x777ce0bc, 0x78ccf3ca, 0x42de300f, 0x01de789b, 
	0xdef394df, 0xb5f575be, 0xf2935ad3, 0x2b59ad71, 0xf3e71eee, 0xb008b1ae, 
	0x1cf99b0e, 0xc54b7ae1, 0xc011428e, 0xdb1fa976, 0x8453bb0a, 0x15b9e8ab, 
	0x6454a7f7, 0x61dfc39c, 0x9cc8657e, 0x7a54ae7a, 0xc7747f3e, 0xf3e71141, 
	0x5d73d3aa, 0x50e74939, 0xe269ce35, 0xf7e49e5c, 0xcc2618ae, 0xd4e22bf4, 
	0x1946d3aa, 0x9f96769e, 0xf0ce395f, 0x339d3a95, 0x21643ed5, 0xe1927ed8, 
	0xf38661bc, 0xf9aad4e2, 0x23e70ca3, 0x8cd5eb3e, 0xcfa7e41c, 0x8e4b727f, 
	0xe7b9f01f, 0x2d727b86, 0x65f6de30, 0x69ce6c5b, 0x978afbf0, 0x147ea2e7, 
	0x945cdabd, 0xc6d615f7, 0xc7e07eb9, 0x97c56b91, 0x6b1fb02c, 0xb359766b, 
	0x2f7d5f90, 0xdcfc8adf, 0x1437c574, 0x0cfdd013, 0xf403b1cc, 0x6def37c2, 
	0xbd036771, 0xb33f81b3, 0xb5e10acf, 0x8f5b09c0, 0x187f3c2d, 0x9efc1184, 
	0x38dfbf0b, 0xf125fadf, 0x82fb93bf, 0x2e4099ef, 0xcad4dbb4, 0xfae7295d, 
	0x0385accc, 0x8cbacf38, 0xc79e00e8, 0x3a31d750, 0xd81ce1c7, 0x0e6077ff, 
	0x70cd50bb, 0xe71eeb8e, 0x6da99073, 0xfd9ca137, 0x0837fbe3, 0xb0dae80d, 
	0x80ed374c, 0x88a99173, 0xc42bd980, 0x9ccf77b6, 0xd5f5c3c8, 0x036b6f2f, 
	0x8ae5d7bc, 0x39373c41, 0xe45f8087, 0x927ef638, 0x4e78fd0f, 0x002fbce9, 
	0x408bb236, 0xece79c06, 0x0165a17a, 0x83050e2c, 0x719f286d, 0xb12f947e, 
	0xcdd20160, 0x681c80a6, 0x6fdc7581, 0xe80735ce, 0xed13927d, 0xe483c636, 
	0xa8a51786, 0x44d9d05e, 0x0fb05bfc, 0xf07768f0, 0x9c456cf3, 0xe7c41d34, 
	0xab9f9baa, 0xd99e7c6e, 0xe06611ea, 0x39a1eb23, 0xcce40b22, 0x7c75ef61, 
	0x475c165e, 0xf5d427e7, 0xe2108693, 0xc2e83bed, 0xfb07207e, 0x17e780ad, 
	0x20e477ea, 0x2780acfd, 0x3c6b1dc9, 0x9c827da7, 0xcf9132d1, 0xacbe505b, 
	0x696456c0, 0x907f2901, 0x72c2993e, 0x67c424c8, 0xcccb0437, 0x3c628fb0, 
	0x7f60d0ec, 0x3d5d166d, 0xbf9b7681, 0xb379e05e, 0x6bd216eb, 0x09a04e8d, 
	0xc5aab78c, 0x85dd036c, 0x7d200feb, 0x3f309cb2, 0x1c2a2dd2, 0x675727a4, 
	0x75513b48, 0x9a297ee0, 0xd8e4f489, 0xed2e39d3, 0x9b3a210d, 0x4bfb0916, 
	0xfabafc42, 0x65f156a9, 0x3a1316e8, 0xd7c61bd2, 0xf33f00b3, 0x381d67fe, 
	0x335cba7d, 0xff2192e4, 0x82da9602, 0xb517241d, 0x538b9212, 0x6f5829c8, 
	0xf841de89, 0x09590e94, 0xf0c93d2e, 0x678661cc, 0x6755a9c6, 0xeb3c328d, 
	0x3d9f3f2c, 0x1d6cf0ce, 0xc03dece4, 0x2cfdcadf, 0x0e008747, 0xd5785f58, 
	0x053f629e, 0xf1d0cfde, 0x7373c09c, 0xa088ec8c, 0x5bbf89c9, 0x009d04b7, 
	0x98e879df, 0xff7409c9, 0x9c2146f6, 0x25ff101b, 0x08ba3b05, 0x69e881ff, 
	0xd0a27b6a, 0x17cf13bf, 0x72835f3c, 0x52b63a7c, 0x66bda35e, 0x722941d8, 
	0xbab3dc2f, 0xf09f2320, 0x6eb9ec30, 0xcf22271c, 0xab941ae9, 0x3ec245d3, 
	0x8e49335a, 0xc9bd7bc2, 0xc2b71af1, 0x7ec95d78, 0x78cfd916, 0x1b2ae38e, 
	0xfe006d92, 0xdd2afa87, 0xf8735a7e, 0x9fb426fb, 0xbc1714d6, 0x80de602a, 
	0x5af5a54d, 0xa015a114, 0x8937acfe, 0x7f9be02e, 0x74077d42, 0x8dab940d, 
	0x5ce08e74, 0x6939c015, 0x904414f6, 0x4a4a6bbe, 0x3fc7ec86, 0x912c3f08, 
	0x914a20fc, 0xc5d6021f, 0x600f241d, 0x03df91df, 0x97e0d521, 0xcbcfe452, 
	0x2cffb5e9, 0x25f2bc9f, 0x9f066fd6, 0xdcabf424, 0xd7dc6697, 0xc42fde16, 
	0xb7f719b3, 0xe74fee45, 0x09e3f6c5, 0x67f0c3d2, 0x1c01f1e8, 0x49f25067, 
	0xc3efee33, 0x9b0fa122, 0xa536df71, 0xf3db2fee, 0x79a178c6, 0xa33c6907, 
	0xe2fefa5f, 0x64d9cab8, 0x36fed53b, 0xdc0afee3, 0xda0eeea7, 0x6fef075f, 
	0xa3584ba9, 0x909c4205, 0xe78a57fc, 0x02e19f34, 0xa77f2b18, 0x3f033353, 
	0x198bb2ae, 0xc817e811, 0xef88d25c, 0x99fc5bad, 0xebdfb8dd, 0xc09e3516, 
	0xaae7b6fd, 0x3ec105af, 0x0fd467b3, 0xed110880, 0x4feda768, 0xa2d845da, 
	0x7181af3c, 0xe24fee33, 0x790510df, 0x72f44bdd, 0x6f09860e, 0x456a09e7, 
	0x8b8629d1, 0x78b862de, 0x31e2e184, 0x65de4b86, 0xc302e4b8, 0xcc1d83a5, 
	0x15a8272f, 0x3c314f33, 0x67862df3, 0x6b3c308d, 0xefd9e18c, 0x02fb3c32, 
	0x08c1aec3, 0x8450ffef, 0xf63ac5fc, 0xa0dfb4e7, 0x8797f8bf, 0xfa40b69f, 
	0x80c34b9b, 0xc661699f, 0x440bb446, 0xfe40ea9f, 0xd048ebbd, 0x7d1ce021, 
	0xb3f079f2, 0x12cfced1, 0xc3bbca1a, 0x0e7f0c96, 0xe04eeffb, 0x069f3828, 
	0xbff13bac, 0xd8dec18f, 0x81d60f81, 0xc8e713dc, 0x61bd272e, 0x0d5db08b, 
	0xd9377cf6, 0x3c0f4025, 0x6c7d75a7, 0x4378e007, 0x49ce3c59, 0x345aaf5a, 
	0xd7a3700c, 0x117ac738, 0x5e7f1dfb, 0x909f5d3a, 0x34bd06fb, 0xd20889d7, 
	0xf4d2f2a7, 0x79f40699, 0x9f93e998, 0x14fc9f46, 0x48f8e0fa, 0xe39c619f, 
	0xc1e3d22c, 0xb47a5481, 0x9ae45da3, 0x480d1e9a, 0x12ffb78f, 0x46f371e8, 
	0xfbdefe0b, 0xe381e8e1, 0xae486de5, 0x0efe8cdf, 0x454a8bc8, 0xc99bb344, 
	0xcf3911be, 0x1dc85eb1, 0x56ade213, 0xa7d117a6, 0x534fc929, 0x12e907d1, 
	0x1e2d56a7, 0x2cf8b865, 0x67192f3f, 0x1f624ff8, 0xb0f7904c, 0x5ea38fde, 
	0x71177e03, 0x0b4cabb6, 0xf4f2faff, 0x1c20bd21, 0x6b732fd2, 0x681dcfac, 
	0x7bd35e27, 0xef0ec0bc, 0x1dd55539, 0xa8fc09bd, 0x5f3e59fb, 0x66f59331, 
	0xfa053de2, 0xfa64ff23, 0x52fc707a, 0x5387f31b, 0x159adcd5, 0x02c6fde5, 
	0xe623b71c, 0xb8bfe811, 0x703b0e77, 0x15687cdc, 0x7ceb1bb0, 0x7b066116, 
	0xd3bb36e3, 0xbb06e1d2, 0xd01b174d, 0xbed65b6e, 0x1af2e048, 0x068daec1, 
	0x563e2ed0, 0xe75da0a0, 0xee20d9af, 0x20d50782, 0xc73f6034, 0x190dee62, 
	0x2eb45fd0, 0x8ec6a422, 0xe473f354, 0xadffe414, 0xa35f488b, 0xc61afebc, 
	0xf1175aff, 0xbf116d73, 0xbfd3e72f, 0xf86048b8, 0x0baccc66, 0x5be017ed, 
	0x8617668c, 0xbefbc066, 0x4fd17e2d, 0x0fe3b974, 0xb61d17e0, 0x170bf62d, 
	0x17a801db, 0x5d35ce28, 0x6ec8b3c6, 0x7e4a7d02, 0x873fdb30, 0xfa85b73f, 
	0xdaba3dd7, 0xe82dfe42, 0x1fdf0d7d, 0xe3855c5d, 0xf4a36b7e, 0x7c33cf4f, 
	0x855356d8, 0x28f193fd, 0x54a3c655, 0x81b58fa9, 0xd2a3c78b, 0x9779b4ec, 
	0x38ed478b, 0xe73d2cf2, 0x1fd35478, 0x1cbce833, 0xd9ae7c03, 0x359af340, 
	0xfea25769, 0x5f769a6d, 0x12bb4850, 0x9c5279f7, 0x145dd56a, 0xafc2fa97, 
	0xaf1ed80a, 0xebb0433f, 0x3e7e3ec7, 0x5eea9c45, 0x8cb3efa9, 0x2d0ad578, 
	0xbd9afc88, 0xe255e382, 0xd538bbff, 0xa9c73760, 0xe52038be, 0x54e31ba3, 
	0xbe1b9bed, 0x0aa71a97, 0x00f7e0d9, 0x41f03efd, 0xefd054e2, 0x54f19ebb, 
	0x3dbbf67f, 0xde43b728, 0xc6130ee6, 0x5c463c75, 0x2697ec0a, 0x883abf19, 
	0xcbf00c76, 0x057e323b, 0x95c60370, 0xe3085fa0, 0xf193ab51, 0x39da30ab, 
	0x6a17192e, 0x8cb3c64a, 0xb5c51078, 0xeecfdcbc, 0xf11965c2, 0x2da1dd2d, 
	0x8b3c7cb9, 0xc9d3a4ec, 0x81f91678, 0xeb5c64f1, 0x1054352e, 0x16b8c80c, 
	0xa149f3e0, 0x32e28416, 0xc1f9d5de, 0x31e25ce3, 0x9fc47790, 0x33f1086a, 
	0x85a65ee2, 0xf287de57, 0xd3fd11b0, 0x59f7c600, 0x1f1c521e, 0xefabcfe3, 
	0xf172901c, 0x01b8d4da, 0x24cd05e8, 0x017982f5, 0xf73e13ea, 0xde996977, 
	0x04f59c60, 0x03f0e5d2, 0x5791bf66, 0xb3deffc0, 0x4b3285ee, 0xf343ae36, 
	0x80be6086, 0xeb8431b9, 0x07bb9808, 0xd0809e71, 0xf652bb2d, 0x6f00c453, 
	0x85aa3fc0, 0x3540af08, 0xff386b9c, 0x438b515d, 0x7aa91f20, 0xf469ef59, 
	0x5594ce3b, 0xb47c7ad1, 0xf63f831e, 0x694f53ce, 0x8bf8c9ce, 0x3714688f, 
	0x748713c5, 0x952fe709, 0x601dc678, 0x47b08ae6, 0x5d3f61eb, 0x86bf21f5, 
	0xf37eb523, 0xb24f447b, 0xcbec1a17, 0x518a2c25, 0xfc62365e, 0x3686f485, 
	0x8e7fca5b, 0xfe39d83f, 0x7ece7c90, 0x8b69f851, 0xc3c7873f, 0x1f088568, 
	0x08f618b4, 0x466d7bc1, 0xe383dd7f, 0xc0da7c35, 0x6934e02f, 0xda094f34, 
	0x4bef2ba9, 0x489501d8, 0x1eadbaa7, 0xc28bc607, 0x8cb77ab5, 0xe13a3833, 
	0x3f1926fd, 0x2f587c02, 0x1e767f01, 0x4393a14f, 0xffff9077, 0x299f6ae8, 
	0x3a07f65b, 0xbd835787, 0x96ddeb8f, 0x704b2fb0, 0xc15b0dbd, 0x092f787e, 
	0x53f8ca37, 0x92a5c9dd, 0xd4576c2e, 0xfbbc0c79, 0xd377881d, 0x52afec7d, 
	0xc52f3a3c, 0xa7e0485f, 0x5a7e3115, 0x6b7e2a51, 0xdb393c17, 0x57ec9454, 
	0x490cc7f7, 0x5d4e8d3f, 0x9ec305dd, 0x77a0d861, 0xc0740838, 0xf0331953, 
	0x29d167d0, 0xaf027efd, 0xfbefdc22, 0x9e3d63ef, 0xb95ad78e, 0xb1cbc02e, 
	0x9a45e28f, 0x14e6f3a3, 0xa53c7bbc, 0x6b5b5718, 0xf004f7cc, 0x8fb1ca0d, 
	0x4c55e827, 0xe824d5f3, 0x0fc09c55, 0xccbf55e9, 0xd1172be0, 0xfb80d6ab, 
	0x8eaf118b, 0x42faf029, 0xe829af12, 0xf483c675, 0x65d5fa32, 0x6626fc19, 
	0x83163cd3, 0xd04e18df, 0x0bd018eb, 0xd06237f7, 0xbf109447, 0x1afb1837, 
	0xf5788d98, 0x43d7814d, 0xc9ebc597, 0x43d7a412, 0x6b6f7cc6, 0x9eff5fcc, 
	0x5fed17a0, 0x5e8258c3, 0x75c4fdc9, 0xd4bc0df8, 0xb9c75a4a, 0xb9761265, 
	0x4e6faf11, 0xcba15fc1, 0x22eae3ee, 0x412857a4, 0x7fc34caf, 0xb2fe24aa, 
	0x187c4a64, 0x0f09f036, 0x1caff627, 0x5b1f09f1, 0x7fdf8136, 0xe464e928, 
	0x0e7c9351, 0x27c64172, 0xf380f153, 0x73e0995b, 0x56817f38, 0x60f513af, 
	0xc4b371f8, 0x3ff1b847, 0x12cd47e1, 0x60c7861f, 0x6fd81ad5, 0x1110a66a, 
	0x034c7798, 0xbfed0e7b, 0xecffb488, 0x73bed98b, 0xaefb662e, 0x318bda5f, 
	0xb60a2f69, 0x2104e8f7, 0xcfcf5cac, 0xfbf3d7ed, 0xeafbe4ab, 0x175b8662, 
	0x25ebf8f3, 0x59fefe9c, 0x7ca4fcf9, 0x2bef92ee, 0xb0971e12, 0x35f98a7d, 
	0xfb263cf9, 0x1bc72f3f, 0xcb57f896, 0x5f162be7, 0x3555fdfc, 0x9d9ebfdc, 
	0xc25531fc, 0xb90b094e, 0xf814f8fe, 0x47e3906f, 0x72f5f8e4, 0x478480fe, 
	0x814cac25, 0xf73e4fbf, 0xe567fecb, 0xfcc6a37c, 0xf1f3f3d7, 0x4b8fde29, 
	0x7f65877c, 0xbcffbe5d, 0x7f726384, 0x1f7f175d, 0x6ff20bfc, 0x7f03cef6, 
	0x47ae0563, 0xf7e1178e, 0x6543f8f7, 0x1dbf3f18, 0xd0018bfd, 0x178b7eaf, 
	0xf5427de1, 0x49f85286, 0x3ff60bdf, 0xfa85d78c, 0xf9fa4a3a, 0x3d14aed5, 
	0xa18f6e9a, 0x57fb46be, 0x7a835b80, 0xf8b0b4cb, 0x9fc7d47e, 0x8722eefc, 
	0xe7c29992, 0xc658fae9, 0x16bdda3f, 0x88a603f6, 0x7a6c8633, 0x97e2c5d6, 
	0x763fadb7, 0x14e1da23, 0x64bb04b7, 0x78a08e65, 0xfe557feb, 0x46b0e3fc, 
	0x3cc9bbff, 0x9bdf4afa, 0x0fb04e05, 0x71efde57, 0x561d0157, 0xb01fcc6e, 
	0x9afe2094, 0xf98e2da3, 0x9ff29d4e, 0xb75ab175, 0x2fe63f65, 0x3e5b7734, 
	0x6e3d91c6, 0x71fd9d93, 0xf213ffb4, 0x23f23bcb, 0xbcc90b94, 0x3c78dea3, 
	0x1de483f3, 0xcbbbf913, 0x9eb51de4, 0xc363bcd4, 0x259fcf56, 0xf737f8ef, 
	0x7532bdb3, 0x5f9271de, 0xbcf173d7, 0xe29be023, 0xe3cc35d7, 0x29dae93c, 
	0x237fe5e2, 0x9da374fd, 0x56ba9e2a, 0x9fc5cbc6, 0xf8694f20, 0x327ef867, 
	0x1394294f, 0xd3f0dcf4, 0x8671ecf4, 0xef28276d, 0xc3f5e7f8, 0xbfb1d7d6, 
	0x17bb85f0, 0x76802ee7, 0xd8d61fdd, 0xf7f03b2c, 0xc9abae17, 0x04979c11, 
	0x4bfc2b7c, 0x3dbda2e6, 0x9d176d72, 0x32fcc0df, 0xa7ac356b, 0x8ad77aa9, 
	0x3e6a60ac, 0xe60729f2, 0xcfdc0f23, 0x7cf4f071, 0x9efc3f64, 0x91f301bb, 
	0x7d63f7bd, 0xf91f3245, 0x80ed0394, 0x1fb25b06, 0xc3dfa5c6, 0x9039d45c, 
	0xba57153f, 0xb764fe50, 0x992a9e70, 0x4dd93ca7, 0x8e3eca79, 0xa8e5d5c7, 
	0xca79a903, 0xc86b6bf6, 0x53cf4b5f, 0xf29e6236, 0xa79e0fed, 0x9fd071c4, 
	0xca79b0fb, 0x21343fb0, 0x9690d94f, 0x94986ca7, 0x87989ca7, 0xa794986c, 
	0xda453b04, 0x2efcf82b, 0xfe8b9831, 0x2bcfa660, 0xf0cb3eb0, 0x596f2907, 
	0xd2de753e, 0xbc8d2bf0, 0x09f46665, 0xde5263ca, 0x7798f312, 0x0f3390bf, 
	0x2ea2d0f9, 0x1f11321b, 0x649b0e67, 0xf32032de, 0x5f882b96, 0x50db46b3, 
	0x7c41bfae, 0xd75dc461, 0x44192e2d, 0x17e8f97e, 0x9910efbf, 0xa8e338c9, 
	0x7e8157dc, 0xa889f016, 0xbd633ce6, 0x30a6a3eb, 0xdfbea7d0, 0x0d7fda2c, 
	0x47c6eb6d, 0x7db1eb4c, 0xcf6e69f6, 0xf9db877d, 0xf1bb72af, 0x7c8d6c4d, 
	0x381bc9e8, 0x8c11f2be, 0xa61cc0d5, 0x5361f9d6, 0xc77fde80, 0x0b1feb04, 
	0xbeb1722f, 0xb0e7fb66, 0x55e286b7, 0x447115f3, 0x06bed334, 0x871fb0cc, 
	0x7f0c99b7, 0xc2e29325, 0x7ea6a9df, 0x3f25fc86, 0x3bde8476, 0x214e8029, 
	0x98ade0d7, 0x717f1167, 0x62bd0379, 0x73c031ef, 0xe774bc79, 0x5e0ce063, 
	0x87b6dda9, 0xea9d68fc, 0xb4f5d22e, 0x144abeb1, 0xae322380, 0xe5f240b1, 
	0xa64e30bd, 0x3151a3f0, 0xf942f31f, 0x4474b714, 0xcae25e39, 0x886dbe07, 
	0x60edba75, 0x6568ef5f, 0x673e1a79, 0x111e279f, 0xd32448e2, 0x857f402d, 
	0x0cf0037f, 0x20179784, 0x16a69b7c, 0x9b7e1fa0, 0x1601596b, 0xd306ddf2, 
	0xa3ecbe63, 0x3e9fac39, 0xdd27f9ba, 0xbf12674a, 0x3af92dfc, 0x36eb3fc6, 
	0xe07c5177, 0xba97eccc, 0xebcfd003, 0x3816525a, 0x458a718e, 0x9f6047cb, 
	0xbe3385ae, 0x5f2fe61e, 0x0d595d78, 0xb0b2a1ac, 0xe882acad, 0x17f89e22, 
	0xab6b038a, 0x5c2e38c7, 0x77d24bfe, 0xebf2375a, 0x07660dca, 0xb33afbca, 
	0xbc6a48f6, 0xeb79e561, 0xdc714680, 0x4305e508, 0xf09fb01e, 0xbd678afc, 
	0x4e93c51a, 0x0b097c51, 0xf0af1001, 0x808770b8, 0xa023e22e, 0xaf1e60a7, 
	0xe78e52df, 0x1b105cca, 0x0adf3411, 0xa0ebf22f, 0xfc7cc85d, 0x92e51790, 
	0xb7f99dbe, 0x8239df21, 0x96bb97e3, 0x7f302c39, 0x794166e3, 0x90fe9ec8, 
	0x7c47df03, 0xd06f0e30, 0x8f9056e5, 0xa2dcb3fe, 0x69d8639f, 0x880d5a83, 
	0xdebb148a, 0x3b0dfbb0, 0xd90d7f6e, 0x165fbd71, 0xf709ef52, 0x8a83d510, 
	0x3922b6f2, 0xff68dbcf, 0x483f01c1, 0x3a441fbf, 0xca8a0a79, 0x73bb5cf1, 
	0x0bd672b5, 0xa7dc6ca6, 0x1d8e30f5, 0xf9c88fe7, 0x7b43b634, 0x1984588e, 
	0x5eacaff0, 0x8ff88d92, 0x7193aff9, 0x9da4ebe9, 0xd59f113a, 0x5c9e1d72, 
	0x00e9086d, 0x6bf20f6d, 0x6b70b143, 0x123b9031, 0xf26a90df, 0x5786819a, 
	0x7681d509, 0x84360c28, 0xbf07d77a, 0xb55e3ee3, 0xcf038962, 0x58a657e5, 
	0xe387a35f, 0xfd1e8d3d, 0xf0b1ca20, 0x0c061bf9, 0x83f5027b, 0x973ef781, 
	0x27b96443, 0xba2c6baf, 0xaf5d0268, 0x911d50ea, 0x5d073c4c, 0x635a246e, 
	0xd849f30e, 0x21b40623, 0x4bfcf7c0, 0x8fe3a93d, 0x1dfda4c5, 0x7a3bfb65, 
	0xed04638d, 0x7cd17d85, 0x79303591, 0xf7f9d0be, 0x63f91a0f, 0x8e9d3f7a, 
	0x86ede369, 0xeeb0ab75, 0x47be9b8a, 0xa3a03171, 0xfb8e287b, 0x9c237260, 
	0x353b7f88, 0xed0faba2, 0x3d0a68fd, 0xc613a015, 0xe51accdf, 0x9aa9f63b, 
	0x322cf940, 0x6c1e510f, 0x56a84f9f, 0xf4626fd4, 0xde7826cb, 0x6fbd72ad, 
	0xf4bf6f02, 0x899ab44b, 0x9e1a677e, 0xf0c23c89, 0x902185ad, 0x9c463d17, 
	0x7c71e30b, 0x80227b4e, 0xc78f7847, 0xa102ed9f, 0xccf989b7, 0xef6f9ff0, 
	0x35bca7cb, 0xff6ce1c8, 0x669f8a69, 0x5d3f81fb, 0xfa0aafd0, 0x8c8fa215, 
	0x16d3fffe, 0x5efdd729, 0xf71bc3f4, 0xdc6ffcb0, 0x43bca163, 0x84871ee3, 
	0xd01e094b, 0xe96f94bc, 0x44ac1fe9, 0x2a3e357a, 0xa21f9bfb, 0x5be366b8, 
	0x692fc95b, 0x7e56e1fc, 0x0c8be4ff, 0xc301ffcf, 0xf7fe1283, 0x723e1917, 
	0xf39bdf81, 0x22a71e07, 0x02f77e93, 0xa7d83e7e, 0x7e1d6bc6, 0x22fbdfd4, 
	0xa42edccb, 0xe742c46f, 0x01a7d8cc, 0xf687d9ad, 0xaefef44e, 0x88efdc6e, 
	0x6f22b07f, 0x79ca1c19, 0x3e8f45f1, 0xa3f7ed46, 0x220fb0b5, 0x133dd3de, 
	0xbd7695ec, 0xff202be2, 0x1ff13da3, 0x8ee7c01d, 0xc76297fe, 0xbb8ff9e8, 
	0xdd56c31f, 0x8d79cdde, 0x9ba5c05b, 0xf68e9e3a, 0x7ab628db, 0x9c5caa7b, 
	0xf38dffaa, 0x42797d4f, 0x6f4d999d, 0x5efcf397, 0x71f0117b, 0x7db6eea8, 
	0xf1559f54, 0xeff412cc, 0xbdbbceb8, 0x5e445fb4, 0xb0203841, 0x2c40e2ac, 
	0xacbe5b74, 0x65c0d6bb, 0xb064703e, 0x01c4f502, 0xf7385a1d, 0x384a4e07, 
	0x07fcdfad, 0xc46effe0, 0xfd0229f5, 0x01d6a9bd, 0xd3f96cf8, 0x1737fbae, 
	0x7bfa775d, 0x61ac76e9, 0x98ec24af, 0xa02f52ed, 0x6a72045d, 0x6e4bf8ff, 
	0x63175bb6, 0xe1844926, 0x9987e63f, 0x63eccf8e, 0xf674577d, 0x9974f462, 
	0xd1719e98, 0xd3a64da5, 0xdddbe353, 0x6e319f38, 0x22db8e3b, 0xdc782ce9, 
	0x8f373812, 0x16fe6c5d, 0xb25a0fb9, 0xe369d3df, 0xded3fb19, 0x08a2ac71, 
	0xaf81f1e4, 0xff9bdc8e, 0xd1ba64f8, 0xe7c4a57e, 0x3a7271bb, 0xd7f22ea7, 
	0xf8302e0e, 0x0a82fd85, 0x96725fe8, 0x0ff48de5, 0x1fec6ddd, 0xeb533bba, 
	0xeaea2d4e, 0x2e78e5ce, 0xec0fb044, 0xe59f83d3, 0xeb0abff7, 0x69e0a7f1, 
	0xeba0cfd0, 0x8fd83bc1, 0xe7c1c631, 0xf0b61758, 0xfd3b9601, 0xc3dba317, 
	0xc6228f12, 0x54de99e3, 0x08815c3c, 0xd3ea61e3, 0x97f1a5a8, 0x6c10eb1b, 
	0x573accf7, 0x11afb6ef, 0x2d4561e2, 0x66dac08f, 0xc288fe81, 0x203c97ba, 
	0x8598a9ed, 0x6f90a8ec, 0x42145b99, 0x72b2df3f, 0xd3ce0f84, 0x4b373e88, 
	0xbc1d863a, 0x7d1c8ece, 0xe91448e0, 0xf718dc27, 0x5e78d90c, 0x4048ff1c, 
	0x9abd473e, 0xfa15fa03, 0xe3b43a95, 0xf53ec08f, 0xdbef115c, 0xe1e3f20d, 
	0x7c7b6ffd, 0x21a37f20, 0x7be507af, 0x77fa06d4, 0xd825f508, 0xedef303b, 
	0x3977205d, 0x77f3217f, 0x6e2827a0, 0x6a0ea820, 0x34fef040, 0x9b76689c, 
	0x60507fd0, 0x0974293d, 0xbe7e0f7b, 0x5942e590, 0x6b85c827, 0x82eb0ebe, 
	0x7aa977f7, 0x76fdca01, 0xcb8be615, 0xa3d81a7c, 0xdcfe3f2b, 0xc310732e, 
	0xba6fbb6f, 0x4eecf41a, 0x50337bef, 0x555a572e, 0xda3b7b6f, 0xf83d4721, 
	0x27fa3b7e, 0x336ad843, 0x6b50fdf0, 0xf4010ced, 0xd7bef8f4, 0xf03b02ed, 
	0x64d60f2b, 0xedbec297, 0x3fd96ab5, 0x77749f00, 0x39d9addd, 0xc5987700, 
	0xa7f1a9eb, 0x3d1df3ba, 0xf5a3eed2, 0x4a7ebb85, 0xb116edf5, 0x2ff28cb1, 
	0xf941cd1e, 0x93df4ca2, 0xae3e2f54, 0xd0eb43b9, 0x06755bce, 0x8346f2f1, 
	0xca4fb41e, 0x963ccbfd, 0x8b3eaa40, 0x4a79e194, 0xb2117fda, 0xcffb0d07, 
	0xf9c2f7b0, 0x1e0633ce, 0xcedef6a9, 0xc3ded807, 0x17bd8276, 0x116dc1a8, 
	0xff52f563, 0x8ae230ae, 0x62fabed2, 0xdfede50d, 0x38e13e44, 0x6cc7fb87, 
	0x5d61950f, 0xf603cd04, 0xf7b41ede, 0x9e24e328, 0x29efbd44, 0x53d919f8, 
	0x0cbd5cee, 0x7bdec361, 0xf7ae01fa, 0x0311c448, 0xeb775f3c, 0x24f7b407, 
	0xbf92fd3e, 0x8a3dec53, 0x758b87ff, 0x4f25da07, 0xd51b7c4a, 0x4fb48f36, 
	0xbded133c, 0x49ea0f36, 0x683cf7b0, 0x6538fdef, 0xded9677d, 0xaf7b4877, 
	0xed3ded87, 0xc347f220, 0x520697f9, 0x69a129ed, 0xe3dc5794, 0xad3d5077, 
	0xe7b20eb1, 0xd9d7934c, 0xb8baf188, 0x98ae0bcc, 0xf1f4f74c, 0xf9f2a2c7, 
	0x76e7b67a, 0x833fc81f, 0xcf9a1ff1, 0x787c793d, 0x5ef6d2ff, 0x61c778da, 
	0x7f9c2add, 0x3cf7dd5f, 0xcaf3e05e, 0xfb73df85, 0x874f4423, 0xe0d18c06, 
	0xdfc17c04, 0x1382c5f2, 0x0e68a8e9, 0xf274f3b6, 0x9da0f7db, 0x73357287, 
	0x8f7df894, 0x8dd0f38f, 0xf3c1e768, 0xe14b382e, 0x1be0a76f, 0xce90fae3, 
	0x1f948315, 0xfe41d04e, 0xc2678e9e, 0x8bba1bde, 0xde233dec, 0xc9603bb3, 
	0x5e309a56, 0x215b2cb2, 0x11dd537e, 0x1d7a37f2, 0x2232cf58, 0xeb01adf9, 
	0x779eb860, 0xb9e7c740, 0x9e90c0ea, 0xf4e76f22, 0xa19d510c, 0x11f14fdc, 
	0xf1a7f69d, 0xddbf696a, 0xd8f6c35a, 0x11979188, 0x7f1ac7a4, 0x196ac068, 
	0x80b7dfd1, 0x3cf0bfec, 0xef7a34cb, 0x8fda4850, 0xff621860, 0xbfa3218d, 
	0x89ade08f, 0x1fc4e5e7, 0x273c4dbf, 0x1818da7d, 0x3ec3f234, 0x8e41ff1a, 
	0xf3fe370f, 0x55fc84e0, 0xae2fadfb, 0xdea365f6, 0xc1b83b66, 0xf9039cf7, 
	0x4fdb7daf, 0xe780f1bb, 0x70457bc0, 0xa07451ee, 0x9ceb337d, 0x46f50cbd, 
	0xd46e2848, 0xeb0a9d1b, 0x641e5b8d, 0xfe6b30f9, 0xed1bd232, 0xec5b9081, 
	0x4f49dfe7, 0xf91baaa8, 0xbd63e421, 0xf74f3ed2, 0x76e89ea2, 0xd0947cc8, 
	0xde2847bd, 0x1c8fca2a, 0xde23e7c7, 0x467b802a, 0x71fd2bf4, 0x7689c71e, 
	0x4bce3cc7, 0xa1afff41, 0x019f6afc, 0x80f4987a, 0xc9d7deea, 0xef88267a, 
	0x6839182d, 0xa2a678c2, 0x95f70d7f, 0x7b8c05f4, 0x0a788e7b, 0xcfb77dcf, 
	0xbec30c1b, 0x01e6557c, 0xde00573b, 0xb87f7ef0, 0x897c83d6, 0xc43d9221, 
	0xb0068797, 0xdc73b51e, 0xa5d632fb, 0x15c6557f, 0xf9a456c7, 0x44be461d, 
	0x69f3f097, 0xcd28787c, 0x59f8310f, 0x56adf991, 0xcd48ffd9, 0x90cd7cc4, 
	0x16120384, 0x9c3c33d7, 0xfc31cf96, 0xbb097e9c, 0xd863ec24, 0x6b759e22, 
	0xb9e45e74, 0x7ae7c55e, 0xe75c83c9, 0xcc3cc614, 0x327fd0af, 0x42d5dd73, 
	0xe7138ff6, 0x9d34f947, 0x03e43e9f, 0x2d1cd7a0, 0x02fa8398, 0xf20f08ec, 
	0x77220803, 0x07dbe804, 0x7d8510fb, 0x2c83c4fd, 0x09cd6767, 0xe9063c71, 
	0x3486798b, 0x473db83e, 0x9d873aa5, 0x051fd836, 0xf7d019fd, 0x841a2720, 
	0x16a456fe, 0xd0fc64f5, 0xbe918f23, 0xfaed203c, 0x90be7727, 0x19fd0d84, 
	0xdb26a9bd, 0x1d719411, 0xaad76fc0, 0x7d83e910, 0xf498fe0f, 0x6fa0d5ed, 
	0x875fa4a2, 0x88dabea8, 0x4078351b, 0x6afcc10e, 0x34a7d706, 0xf4053c62, 
	0x17575d6a, 0x6344ffd5, 0xa78c02c1, 0x3739c458, 0xf5cccfe9, 0xb8897f14, 
	0x3a2c0b06, 0x9651978e, 0xd8014f1a, 0x0716f143, 0x1c372bc3, 0x76e13b23, 
	0xe786b7e9, 0x9833ca08, 0xa34f860b, 0x356baede, 0x007e51bb, 0x7aa9dd7e, 
	0xd79e1377, 0x9e22dc0d, 0xf6832263, 0x22f77065, 0xf918b38e, 0x4ebea345, 
	0x606fd73e, 0x9e5c773d, 0xf8bfac3b, 0x0ae9c729, 0xd01e6334, 0xde8491bb, 
	0xde93fa05, 0x38c8f5ed, 0xef55238b, 0x8ca0fc3e, 0xfd13a8b3, 0x33519dea, 
	0x1ff02bc9, 0x48ddea27, 0xd9f145cd, 0xdeba60fb, 0xa14ea9d5, 0x02f018b1, 
	0xf885dbbd, 0xa9d61f02, 0xe213056d, 0x5bbd4902, 0xf9671a90, 0x057d7241, 
	0xa0aed827, 0x87b0ae7a, 0x36c24eeb, 0x086da0ad, 0x27f78ced, 0x1ec241c4, 
	0x79e033b0, 0xb02f9624, 0x5d7d2dde, 0xbccaba09, 0xe14eb1a6, 0xa8ffb417, 
	0x11ae30df, 0x402a9ff2, 0xd1e75939, 0xedd7cf49, 0x0e30db36, 0x9d7188de, 
	0x72ba3d14, 0x718dc7ab, 0x75c608e1, 0xb1ce5206, 0x17dc93ac, 0xbd402c19, 
	0x6bcbbb77, 0xc64c0f69, 0x727bc607, 0x9d271c42, 0xbde369ce, 0x2f4260f8, 
	0x3e305817, 0xc17c64e4, 0xa378a55e, 0x68be5fc1, 0xfe2d20b0, 0xc044fe42, 
	0x491ffbcc, 0xcc43e5e8, 0x372f52ef, 0xadde3e48, 0xe06cbd4a, 0xdbf4951b, 
	0x4ff79690, 0x4f212fc3, 0xea8e7d56, 0x45f91338, 0x1c602fe9, 0x7da01233, 
	0x3e608eef, 0x3f8f01e2, 0x5f885fbb, 0xd8fac83c, 0x9cacc388, 0x4c38a0ef, 
	0xed982c63, 0xd6a3bac7, 0xe3fed963, 0x9db39b08, 0xcdae11a7, 0x7e6cefc6, 
	0x3b91cf21, 0x9e39b857, 0x3e724bd8, 0x3f48b2ec, 0xb0e80c4a, 0xbf439fee, 
	0xe09fc425, 0xe3dfa05f, 0xf0bebd61, 0x6764a3f9, 0x28e17acc, 0xce163fc5, 
	0x9b1a3f8b, 0xc7fead85, 0x3e2131e8, 0xfbc3e226, 0xc4697fc1, 0xc3f807f8, 
	0x7f611f0b, 0xa86263f8, 0x3bfb17a2, 0xc11c6fe2, 0x15c0defe, 0xe088fccf, 
	0xf8e3d8e1, 0x39da5b5c, 0x23cf6d44, 0xfcfda991, 0xb59f3295, 0x7267a2d2, 
	0x10cf5bde, 0x5b76be34, 0xf809c51f, 0x7718422b, 0x705791da, 0x80e3ad1e, 
	0x1a19da15, 0xc4d553d5, 0xae3c528f, 0x0debfa41, 0x906f5fd2, 0xb7837afe, 
	0x9f20f45f, 0x2dbb6a1d, 0xe352fc7f, 0xb238ae07, 0xc3d7c71c, 0xac72818f, 
	0x50398f51, 0xb8ba374e, 0x71e780bd, 0x006dda23, 0xde0c3fdb, 0x8d0cf6c2, 
	0x5962b22b, 0xe83a0a7f, 0x205e3c39, 0xc62640f3, 0x13ad9c49, 0xdd367ef2, 
	0xeb92f3ba, 0xfdf9b3d4, 0xbd7505b8, 0x8ad17d70, 0x9e994fe7, 0xba012712, 
	0xf2df5cce, 0x99eb9e08, 0xda7a9feb, 0x2fed8a34, 0xf96dc3bf, 0xbcb6dcab, 
	0xbe7a6d89, 0x3cbeb4c8, 0x7bd38a6c, 0x70fc98ef, 0x7abdfe1e, 0x44089e42, 
	0xfbe6544a, 0x010f9802, 0xb9e1a6f9, 0x9fa8e734, 0xdc65df90, 0x694709d7, 
	0xe7462b2c, 0x6d0ab4c8, 0x986e2131, 0x7c804e22, 0x03e48cf0, 0xfe32767f, 
	0xded360d0, 0xfc48323f, 0x2cdf6f70, 0xc14d07e4, 0xbb80203a, 0xb79fc0a2, 
	0xbde61c60, 0xda1871c9, 0x5e313177, 0x34dde381, 0xb884c37e, 0xb963484d, 
	0x9221fc49, 0x88a59b71, 0x833f4a67, 0xe0b5da5f, 0xbebcc56d, 0xbf417b33, 
	0xf5c05c2f, 0x2e528d53, 0xe395aa7c, 0x8d531f17, 0xabc80c38, 0x9d5b966c, 
	0xc87e7e29, 0x0e7457a2, 0x513b9ea6, 0x7ee3c7d2, 0x6dd00766, 0x5ccb8ca1, 
	0xe392fe3b, 0x06997162, 0xb9e11f8c, 0x2c7e23bd, 0x343bef82, 0x2e83f313, 
	0xd1622c80, 0xc5497414, 0xcba299e7, 0xc5e463e3, 0x39e0ed4a, 0x7bf94bdc, 
	0xd60676ab, 0xfe483eb7, 0xd01cacdf, 0x185f188b, 0xae30d311, 0x49dceb3b, 
	0xdf835887, 0x5eb9c291, 0x60687581, 0x7fb0053f, 0x94ed15ad, 0x6f5c6487, 
	0x3b07d5e1, 0x1c373e50, 0xa6dd525c, 0x31e1dd61, 0xb75dda2b, 0x1794b569, 
	0x4de31b0e, 0x10da3ad3, 0xe8353ac6, 0x04f31a57, 0xf78cf5b5, 0xb187df77, 
	0xcb0ecc32, 0x999ef87b, 0x608c9ffd, 0x8febc101, 0x7d60fae5, 0x6b9f30ad, 
	0x9de3cc83, 0x103e6213, 0xd12f7cd8, 0x2f35bfe1, 0x4515e469, 0xa4527e5a, 
	0xfd9fc5d7, 0xffc1d504, 0x3e4ad2e3, 0x041bfad7, 0x24c478bf, 0x8d9138ed, 
	0x1751307a, 0x7a0ae99f, 0xbc5d64b4, 0x4d9b6bf9, 0xf9338c76, 0xcefe2eb8, 
	0xf5054143, 0x11d3d8eb, 0xe40ddda1, 0x20c4c40a, 0xdf85f79e, 0xb53ca568, 
	0xe2e49751, 0xa47a8df9, 0xbcda69ba, 0xbf0f8e2e, 0xfd845e1c, 0xefa5699f, 
	0x98ead289, 0x2bd5fd92, 0x0efff626, 0x4bd77f8d, 0x5f16f79c, 0xe3163b05, 
	0xc6f4d32b, 0x9c5efd89, 0x1d3d8788, 0xb539b50f, 0xf8d7a97f, 0xa19d445e, 
	0xee2e77f1, 0x58b71148, 0x2b4af2f7, 0x77c67bfb, 0x617fe87c, 0x6ebd2dbc, 
	0xbbcf9568, 0xd636e504, 0x28470549, 0xde62ad9f, 0x2bd65b3b, 0xe18eb158, 
	0x035d64b9, 0x8111d1f0, 0x3f3237cf, 0x73439d53, 0xf2804eb2, 0xeb26f7e1, 
	0x1bfea831, 0x73e6879e, 0x3f8d3d9d, 0xcfcaf322, 0x30e7f325, 0x27b3d50f, 
	0x706a81e3, 0xec13cc8f, 0xaba94ead, 0xa017f7c0, 0xa7f3cdbf, 0x7c0debe7, 
	0xf14f5914, 0xe9efcddf, 0xdde46e7c, 0x9d5ffe01, 0xf8797fd5, 0xc09e5fcd, 
	0xdf1d96ef, 0x4dfffaa3, 0x1272f813, 0x27076bbf, 0x4df4f1f2, 0xa4c7ce13, 
	0xa5daa4f3, 0x1bfd489f, 0x946ce6a2, 0xfe5cee7b, 0xb854221e, 0x1da73b29, 
	0x1c466ce3, 0xfb41ef5d, 0x2191fd0f, 0x2059a5e0, 0x03d05403, 0x325d7d8d, 
	0x3c53a3ae, 0x0b88deaf, 0x2a8f350e, 0x9c606fe8, 0xef442027, 0x8c1e86e6, 
	0xc0ea26f7, 0x469e1aba, 0x339bacbe, 0x60962dd2, 0xa5bd5f7e, 0x2d7ff19b, 
	0x3f9242f8, 0xd216ef8d, 0xd5d7f3f9, 0x495ec9f3, 0x93bfabf4, 0xce3003ee, 
	0xf429f10b, 0xc626c8fb, 0xdfeef8c7, 0xce3207a8, 0x57972187, 0xd6866229, 
	0x9a65e70d, 0xca7e86de, 0x28f0a788, 0xc1d679fa, 0x3eb13a17, 0xb706fac7, 
	0x507a3563, 0x164c93c6, 0x37eaf7dc, 0x8fa7bee8, 0xf611f21b, 0x19ffbe95, 
	0x38e1132a, 0x946cea82, 0x7343d98f, 0x83a06183, 0x61176d52, 0xe9625e7a, 
	0xe7be8678, 0x17efe36c, 0x57e8d9b5, 0x2245975b, 0x37a27ee6, 0x7d85638d, 
	0x82751b0b, 0xb5cd0f08, 0x2eb8f074, 0xa86f9efa, 0x1269ee8c, 0x1fc2bbf2, 
	0x84dc6fcd, 0xd6b538f7, 0x4dbdd38d, 0x9daa9bd6, 0x169bb40a, 0x5ce92ff4, 
	0xd7df2d8a, 0xb5d4a9b4, 0x0952e080, 0xcc2602db, 0xc4726ccb, 0x86ee7633, 
	0x31daabd6, 0x5e69b23f, 0xe113a720, 0xe7557add, 0x3fe36c32, 0xbf0503ec, 
	0x0d6d0ee9, 0xffa407df, 0x807aed4f, 0xda33262d, 0xefda4a21, 0xc42d85a6, 
	0xf17f9bb7, 0x3eddcb02, 0xefcaee43, 0x1f846b1b, 0xdceeb7eb, 0x066975cc, 
	0xfc65587f, 0xdd8d70f1, 0xeb1fb3bf, 0x3bf9e727, 0xb7189fa1, 0x1b1eb006, 
	0x0ed05ae4, 0x89b9daf4, 0x974a32e3, 0x9ebfb0de, 0x93fe42e8, 0x45b7a435, 
	0x5f0e7780, 0x78be282b, 0x6dfbf666, 0x17e937a2, 0x297b4965, 0xc8ae68a8, 
	0xfd0f1e19, 0xdebe6578, 0x8f1715f0, 0xcecf9a9b, 0x36e6aaf2, 0x13e50fe0, 
	0x1f610dc3, 0xf0a37b8c, 0xdf93fa9b, 0x5f1229e5, 0xcceb071a, 0xe753359a, 
	0x70de38cb, 0xc9439ec3, 0xe8df0ef1, 0x1d709bf2, 0x96d4cd51, 0x87be0f82, 
	0xacb5907c, 0x825a64df, 0x686d9def, 0xc3d0a5f7, 0x043cbd5f, 0xb2cb81ef, 
	0x4eb2943c, 0xa9960ff8, 0xae69fa26, 0xb63f541d, 0xee833cb5, 0x91ee309d, 
	0x98b65e38, 0x16599af2, 0x84e593b1, 0xfda4105e, 0x3fb89de9, 0xb3fb69bd, 
	0xbaefeec0, 0xf418fec8, 0xd7cf23db, 0xdfcd8b61, 0xa7f72fd9, 0x6a7dc708, 
	0xe8f4c5d3, 0x4b173796, 0xf7c723f9, 0xa837df1a, 0xbaebaa6e, 0x8d7df136, 
	0xf38bff1b, 0xa0c43c62, 0x6395fc0f, 0x1459527c, 0x58763d27, 0x74754add, 
	0x9d0a57ed, 0xcb51c3bf, 0x87b61cf1, 0x9c48b6b5, 0xecda91ea, 0x21bea718, 
	0xb03b426e, 0x8105eafd, 0x323f786c, 0xf64cddbe, 0x0178e0b5, 0xca664d78, 
	0xf0fe2193, 0x9baab67e, 0xac277d04, 0x155678d1, 0xd339d39e, 0xf9acfe69, 
	0x2adce927, 0xb59937e3, 0x40f3f197, 0xa7c41fd8, 0xdc39f181, 0xb807db2c, 
	0x30bd86cd, 0x40ae39f3, 0x1de3283a, 0x03c518a6, 0x3f1c0ad5, 0x0f8e0e32, 
	0x7e0db3e0, 0xb0bd6209, 0xdfbf22f6, 0xffed2dc5, 0x62a7c221, 0xe54ce58c, 
	0x55275cbb, 0xdf618179, 0x7d824ee0, 0x19fda027, 0xefe7e58c, 0xc53aae8d, 
	0x16f55fbf, 0xc216b3b4, 0x51bdac13, 0x38ec89fe, 0xf69f976d, 0xb9a2fc05, 
	0x9c18cf1c, 0x1fd9f68b, 0x22360f70, 0xda0b316c, 0x9a5f9fcf, 0x11f6d24f, 
	0x7ef2c8e3, 0x1de6370d, 0x3f847d8d, 0xa9c808cf, 0xa17ada50, 0xeb8c67bf, 
	0x65decac1, 0x02ecb43b, 0x5e41dec3, 0xaf04f7a7, 0xc314fcb3, 0x5c316fe5, 
	0xc1f9d231, 0x136172e9, 0xd327f7c7, 0xcdc902e5, 0x7212e8a9, 0x2e425d31, 
	0x495ec7a6, 0xa5b0bc1f, 0xde63e88d, 0x4136fa8c, 0xe8d3479f, 0x9fdea8b3, 
	0x39317fdf, 0x6eb099a7, 0x80a2f0ef, 0x67f90f3f, 0x883fbd7e, 0x55fc61f2, 
	0x786bfa13, 0x77404cbe, 0x802b8d6b, 0xfd5be575, 0xfd612ff1, 0xfda16983, 
	0x5c81f3d2, 0x3e6c5e8d, 0xb5f546af, 0x1c61ab5b, 0x52a7ce17, 0x88fc013f, 
	0xbe637a79, 0xc05f39c4, 0x0bf24ef3, 0x819d3f46, 0xd9d63ff0, 0xf05f943e, 
	0xcdbe556f, 0x57e67fc8, 0x6dec98b7, 0x6c17e122, 0x7e41da1a, 0x88ae7e01, 
	0x8f2060e3, 0x66d2a66f, 0xd47d810e, 0xefe70fda, 0x801e211d, 0x04f59473, 
	0x59c47cfc, 0x27d9f94a, 0x6a7ce432, 0xc827d729, 0x4ceaedf9, 0xcd867582, 
	0x7c41288a, 0xcbed501e, 0x6a97c4ad, 0x3fdbce09, 0xbf84bfbe, 0x79e9d4b7, 
	0xf14bd096, 0x4cdfc37c, 0xfacaf28d, 0x05cd844c, 0x8f28b7b1, 0x42db5766, 
	0xc5e8b06f, 0x47ea25ff, 0xfb426386, 0x8233fa24, 0x03a8ebbe, 0xf9f7e3ba, 
	0xc60f1c16, 0x1f47e731, 0xa38eefa5, 0x7f22c2e0, 0xbdc64c79, 0xa6f0133f, 
	0xfbaf0079, 0xa6a0fef0, 0x8f17cc4b, 0x3ada7cd0, 0x296de85d, 0xe80b87df, 
	0x838c977f, 0x32fe6086, 0x5144f7e7, 0xedfe39f2, 0x3dfc90d8, 0xce52f751, 
	0x47d0c1fa, 0x9bf83f46, 0x63714231, 0xc718c66d, 0x65df0b8f, 0xc302f0b8, 
	0x52dfbd97, 0x63aa7ea7, 0xeeb9ce88, 0xf4f0c938, 0x23a78661, 0x5c739adf, 
	0x7d02f72b, 0xbf4f334a, 0x7ffc1bbd, 0x09c888d7, 0x76343f81, 0x79946f4e, 
	0xc605ab38, 0x15bab11b, 0x39e24ce1, 0x356032cb, 0x78dfb039, 0xe2f505a3, 
	0xca113568, 0xb4a991d6, 0xa138c175, 0x57cbd24c, 0xb4dd6664, 0xd06f2523, 
	0xa4e399b7, 0x8d2e527d, 0x5ef2e98d, 0x64b5614d, 0x9089be91, 0xb760d9be, 
	0xfe8c3f12, 0x69f708be, 0xde5e5dcf, 0x0ff50db7, 0xed98ff23, 0xebee3a62, 
	0xebb051ec, 0xf14abf60, 0xebb04d9e, 0x8ed8175c, 0xee33bf33, 0xb71dfc14, 
	0xe35df695, 0x347e9efb, 0x81ce93bf, 0xfba12c4b, 0x6c5d4b36, 0xcfbe95e7, 
	0x0df01af6, 0xf52d7de5, 0x7e87cf5c, 0x54afda15, 0x9131feaf, 0x852a3fb8, 
	0x28fee88f, 0xdee88f83, 0xcfc5e029, 0x66658206, 0x170003b4, 0x1a784ded, 
	0xee323e60, 0xdd60b2a7, 0x07c9d83c, 0xdce15f90, 0x1c871d9b, 0xb1ffb768, 
	0xffc758f5, 0xfdfdbf06, 0x9cf1687e, 0xf1c5beba, 0x9f366d3d, 0x2bbee32f, 
	0xacf042d5, 0xe262ddb8, 0x1f5ec8f1, 0x78c4edfb, 0xa5d9b59d, 0xb3b403ff, 
	0x9434042f, 0xb971e927, 0x11bc6f31, 0xa7c1a7f5, 0xf2763996, 0xa13ec797, 
	0x47efca37, 0x7fffb8cd, 0x9de6780f, 0xb663ee4d, 0xccfc904d, 0x7de6a9b6, 
	0xbc7fd83d, 0xba1271d1, 0x601f33d7, 0xa8c7aa7f, 0x175df180, 0xe303df19, 
	0x70997f33, 0xec550c7c, 0xe2df194b, 0xbe38cd50, 0x344c21c5, 0x47c607be, 
	0xf8f1f33e, 0x81b23fd8, 0xb26ced5b, 0x772c75b5, 0x2535ff22, 0x55c6eff8, 
	0xabf7fca9, 0xfe0f6ccd, 0xec67e24a, 0x8588ebb3, 0xd26118fc, 0x49967e48, 
	0x532e6039, 0x16ff2823, 0xefc48083, 0xb07e0dcb, 0xc29fe226, 0xccc472c7, 
	0x82a987f7, 0x49a983e4, 0x4b9df817, 0x1617de19, 0xfc37ee4f, 0xa57f2979, 
	0x92b72de4, 0x877aa55d, 0xdeea8e48, 0xe54fcc93, 0x49c72cc3, 0xfd406ebf, 
	0x7e9a70ca, 0x39437d55, 0xc70f9ef4, 0x857ae83b, 0xb70323ea, 0xf3ca6188, 
	0x8c21d5fb, 0x295f01f7, 0x2b823f74, 0x419bf370, 0x89fba749, 0x9fb13bcf, 
	0x421b6fc9, 0xb0116c39, 0x2b8fe04e, 0xbd1097da, 0x4e4df8c4, 0x9eaf5bcc, 
	0xef139f71, 0x33de347b, 0x7b64d8e8, 0xf4fc8632, 0xc313ff5e, 0xdef0b347, 
	0xf8c68f82, 0xb7b5101e, 0x3d6666ed, 0xb347befe, 0x2856a05e, 0x4187be97, 
	0xfa5c8ce4, 0xca8b863e, 0x3bca0b3b, 0xdad66c00, 0x465fbe61, 0x17bae064, 
	0xf8c3aa17, 0x6f819c1d, 0xefbc43ff, 0xe9b6ca8f, 0xef0d315e, 0xfbbe3393, 
	0xbe02ebce, 0xefc97e04, 0xf95178e2, 0xdea72c43, 0xea72cadb, 0x5f995b77, 
	0x31434bfc, 0xef1a73aa, 0x2b3ce188, 0x37f9f514, 0x59546e40, 0xeabfbc8c, 
	0x633bfac4, 0x609e44dc, 0xbc5fbf0b, 0x1963da45, 0xf905bb66, 0xc768233f, 
	0x79c025b8, 0xf0f306dc, 0xa27d74f7, 0x56a73f4a, 0x319c7d70, 0x785b53ee, 
	0x7e25db3d, 0x8f6f6667, 0xdb717ea0, 0x7a9e5baf, 0x8e4e3dae, 0xd596a827, 
	0x35f61b8a, 0xf70c4bb0, 0x14b3bf83, 0xd70abbde, 0x9d53e3b5, 0x55adbf18, 
	0x3f7e2754, 0xea5dcfe4, 0xd6bdbb44, 0x57a829a9, 0x3bb77c9b, 0xafcc3bc5, 
	0x664de7c8, 0xe7277c61, 0xd4e8efe5, 0x4eed8458, 0x2793f22f, 0xfa9292fe, 
	0x22d3517d, 0x37405738, 0xe9e30a8f, 0x7a81fad0, 0x72afda01, 0x1442bf7c, 
	0xfd9d3b48, 0xe333b408, 0xc0bcbed2, 0x9ec13ffc, 0xdb0b6bbc, 0x508cfed9, 
	0xcdadc704, 0xdfcc69ff, 0xe561df89, 0xdf29fcc5, 0x456a0735, 0xa079e50c, 
	0xfbc4eb56, 0xf3f33cb9, 0x132f5934, 0xf74d3feb, 0x40fa742a, 0x7ff204cf, 
	0xfe63e9d2, 0x71821d8d, 0x5df180ee, 0xf9954fb0, 0xd7d75479, 0x5a62a394, 
	0xefc2344a, 0x30959cd7, 0x0f915fe0, 0xdb098b5e, 0x3c8a749f, 0xbce81fd9, 
	0x03e70b72, 0xc5e5172a, 0xe69a3f70, 0xc3a115e4, 0x8d79ecdf, 0xb7675ae0, 
	0x5fa7fa82, 0x2f26fd11, 0x2ea89585, 0xf7714d60, 0xd61f30d7, 0x62a97f17, 
	0x4f6cfd02, 0xe6e30d7e, 0x0053017d, 0xbca929f1, 0xfd0a5bde, 0xae6e5496, 
	0x2ef80798, 0x72a8bd9f, 0xb0e5b401, 0x4fb0769f, 0x2b0467a7, 0x3cd276b3, 
	0x6fc79c76, 0xe6274a13, 0xde798b67, 0x6170973e, 0xae33dd7e, 0xe04f5829, 
	0xc06de782, 0xb0b39e67, 0x8eb0eb3f, 0xf476e9a2, 0xd7ce3ddf, 0xe7e64f48, 
	0x763a2168, 0xf9845a8a, 0xdd4e35a5, 0xd6831da9, 0xbae0a6de, 0xb06f67fd, 
	0xf181de71, 0xb80fb3ed, 0xfb2f60cc, 0x73c1421d, 0x2d5afab9, 0xca7406d6, 
	0xc117dbef, 0xb5fa7c7b, 0x2e79eda3, 0x16b37f18, 0xf266efc1, 0x8affa2bb, 
	0xfa6b8071, 0xd62bfdf6, 0x4dedf8b3, 0xd7d03b76, 0xaa5feb2d, 0x61b1ade6, 
	0xd5cb64dd, 0xfbf17a6b, 0xf0b657cf, 0x554b6dbd, 0xecf94561, 0xdf4a523a, 
	0x14a29577, 0xec244f7e, 0xe8997358, 0x3c90f5c0, 0x8a7d801f, 0x724a1db3, 
	0xaabbfc19, 0xf2acabf6, 0xf22b44bb, 0x42b558ed, 0x437f1afa, 0xd53b07be, 
	0x23c5ef2a, 0xa4e4847b, 0x278f5f21, 0x1ab9abe5, 0x4539abe4, 0xae58faae, 
	0xef4bfd82, 0x2fbf2297, 0xa95d84bd, 0x48276c6a, 0xd162d1bd, 0x27dc60b7, 
	0xc5f67a3f, 0x74071f2b, 0x9e5be876, 0x38eef941, 0x1f47e2f3, 0x1a707da7, 
	0xdd4b8c71, 0xd16552ff, 0xd4be3172, 0xaefc0964, 0x7ee4c1f3, 0xf8a8e7e4, 
	0xf770bc19, 0x61fb4edd, 0x642a06d2, 0x6a97cd1c, 0xab37bb17, 0x7ec63fb4, 
	0x9147f625, 0xefb393fb, 0xe2ee315f, 0xeb84bd02, 0x36a9b2ad, 0x30b8dbcc, 
	0x2d8fda1f, 0x6996c5cb, 0xac8817a0, 0x30b6626b, 0x7d7489cb, 0xe9cf5137, 
	0xfde7a995, 0x97cf47e0, 0xcb28bde3, 0xd7befcae, 0x864bcf0b, 0x44ed1785, 
	0x27904be2, 0x907be441, 0xf5bfd307, 0x0f683bfc, 0x39041e91, 0x896d5816, 
	0xff927969, 0x30bf21f6, 0xef5e937f, 0xab0773c0, 0x0c7bf14c, 0x03d86fbd, 
	0x575fed55, 0xa1312eb0, 0x4fdf71af, 0xa1baf527, 0x4faa2f57, 0x7b9ca49b, 
	0xde9f8619, 0x27f27c4f, 0xca9affd8, 0x4e3e89c7, 0x0bb427da, 0xddf91e81, 
	0xc2e51d76, 0x61a3901a, 0x1325b637, 0x8b59c2ed, 0x71742ed9, 0x2782d73d, 
	0xd395068b, 0x66ca3bf2, 0x9e4e37d4, 0x7df3157f, 0xf3df164b, 0xbc89e0b5, 
	0x54e38c41, 0xf733e9a5, 0x4637d636, 0xb8e8f80b, 0x70872ade, 0xc0047ee2, 
	0xaa3ac05b, 0x0359fbf4, 0x0536e035, 0x0d1a3ee8, 0xfb0151ef, 0xd6b94342, 
	0x37bf2372, 0xf0131016, 0x5589b2a8, 0x9c26dfd4, 0xcb1c5798, 0x06617bfa, 
	0xfda055fb, 0xebbae1aa, 0xce9f2463, 0xf98bdcbf, 0x908f26ce, 0x7a5a56f7, 
	0x45cadee9, 0xfcf4bddd, 0x8ab3b891, 0xd9dd69ec, 0x39baf00b, 0x41d6117a, 
	0x9d571bae, 0xe22cff28, 0x5ff6315c, 0x6c525f17, 0xccd6f986, 0x045abd13, 
	0x2b6d1bc6, 0x5b3ee0b6, 0xbfe03fa0, 0xf48cb8b6, 0x33ac3ac1, 0x16522019, 
	0xacb2fd53, 0xbf3e6aa7, 0x8ea1363d, 0xd4a28856, 0xb747abfa, 0x6b2df7f2, 
	0x019e414a, 0x052bd7fd, 0x0c16676c, 0x49e233ff, 0xa477e2f3, 0xe4bda399, 
	0x9ef2aaf7, 0x0f796a85, 0x6f790ac3, 0x37bcbd42, 0x6237b8c1, 0x3e6e7c95, 
	0x1cbdf949, 0xd0c2d1e7, 0x4c37b674, 0x6b512f18, 0x3da3f67f, 0x9cc7be30, 
	0xb96beb87, 0x2081ce11, 0xb6d450bd, 0x5087f41a, 0x301fd0f3, 0xaa53ddf6, 
	0xfac1b6b6, 0x9c3f9cfb, 0x519a87a0, 0x5d008c4f, 0xf0fbc196, 0xfc2dbefc, 
	0x115fbabd, 0x8a4d6d36, 0xed6a50de, 0xae5b4328, 0x1b28afbe, 0x2d6675cf, 
	0xfc8639d9, 0x288a8401, 0x96bd3d1f, 0xbd74a0ec, 0x77f9ca20, 0xfa183f43, 
	0xc78c7c43, 0xa2917d21, 0xa12e4827, 0x7fd163dd, 0x73ace321, 0xfc80fcf7, 
	0xf363a249, 0xaa437adb, 0x316a543d, 0x72853d93, 0x0dc1ef02, 0x98b12c78, 
	0x3380f589, 0xb23d5ce5, 0x4473eb95, 0x267bf980, 0x03942f9e, 0x29984fd2, 
	0x4ea259cf, 0x432f9e42, 0x03f9d0ef, 0x351ae1bf, 0x4968ee64, 0x0fc033f1, 
	0x24ebf3e0, 0x0ee430be, 0x94aaa7e9, 0xf019f8f3, 0x7a92b2d7, 0xe18f992a, 
	0xf3de257c, 0xcb1af740, 0x47ff5673, 0xc720988b, 0xafc72c83, 0xcce13c51, 
	0xa5ef5240, 0x200529fb, 0xf78aa6c0, 0x8a661da1, 0xde42bd7e, 0xe32157f3, 
	0x1fc81f34, 0x56d4a259, 0x79269ca0, 0x7e527378, 0x11a3f39a, 0xd4ce6e7c, 
	0xb0f18794, 0x6de3d4b8, 0xbd1ca5a7, 0x1851ca59, 0x4a67e4a7, 0x880fdd33, 
	0xcf00b472, 0x2bfe46bf, 0xfabf21fe, 0x1e28ff80, 0x2da55428, 0x38dfee45, 
	0x09d6c77f, 0xa3163575, 0x62b5578e, 0x714d781e, 0xda1d8763, 0xcf8f6941, 
	0xa62c0a54, 0x6e3b43cf, 0x4e68ee8a, 0xfc8d81e6, 0x934721ad, 0xffb125df, 
	0xe9efbe9d, 0x135132f9, 0x93165f57, 0xef8f6efd, 0x5ee71493, 0x426fdbea, 
	0x216b3161, 0x838c0648, 0xe283ffda, 0x31bef77b, 0x5ccfc68b, 0x06b73ad8, 
	0x39dadff4, 0x27e26f6c, 0x61ddf8de, 0x7a1bf9d3, 0x9acce553, 0xa7648d05, 
	0x701577ad, 0xdc9a5f1d, 0x1a727920, 0x92f961c7, 0x709a472e, 0x6b73907c, 
	0x786c326a, 0x875ad8ef, 0xf346d456, 0xba5d9d71, 0x7f9f499c, 0x2719e96d, 
	0xf3190dd6, 0x599673af, 0xe32747da, 0x58defe91, 0x63c63afc, 0x5f963af4, 
	0xd1b3c953, 0x0f430a57, 0xeb67964f, 0xae6bf615, 0x9eed7f02, 0x545f28b3, 
	0xdd37d91b, 0x9426bbb0, 0x7986c20f, 0xaff9d5a6, 0xf9bac6ed, 0x007e84e6, 
	0xf51b2e3f, 0x7e2f4646, 0x48ff92d7, 0xfd0559c0, 0x63ba7b57, 0xa9727f14, 
	0x4f945ece, 0xed18b516, 0x8239e6b7, 0xb8f345f4, 0x99efc4ee, 0x1ff28f3f, 
	0xbc736cf4, 0x9345f48d, 0xfa39e40d, 0x91bf2845, 0x8b47a38e, 0x879d2a2d, 
	0xe1fa89a2, 0xbd6a58fd, 0xa91ceae4, 0xf4059c4f, 0x5afc03dd, 0x0bfdfa94, 
	0x3fba25e8, 0x469e69b4, 0xc43da6fb, 0xdedd23fa, 0xfbeb9916, 0xd0493bf0, 
	0x75a9c323, 0x01ee9394, 0x31e9ee32, 0xb097ebe8, 0x4191ef71, 0x12af55ef, 
	0x8a3bfdbd, 0x5c2fd17a, 0x313ad4af, 0x82a4dc5f, 0x9028587f, 0xa9cea8d5, 
	0xc4edd5c9, 0xfb5add62, 0x6fca3b0e, 0xa0551e7c, 0x8f6ff905, 0xe95bf10a, 
	0x8176af3f, 0x3d4a89de, 0xc8266d03, 0xff03cc3b, 0xe8bf38dc, 0xf526f74f, 
	0x3afb4983, 0xa4f26be5, 0xf6f24a7d, 0x86a7d803, 0xb4f24a5d, 0x21bf192a, 
	0xed2e5bb9, 0x4bf894d4, 0x23d64ede, 0xce403fa4, 0x06335894, 0xb2097ef1, 
	0xe3a994fb, 0x3ef29939, 0x622c5bf9, 0x26e4a5d5, 0x2cb3cbca, 0x27292f1f, 
	0xf5167b0d, 0x2cafca10, 0x7af43a8b, 0x68b96a70, 0xdec353c8, 0xa24cec35, 
	0x42e3e827, 0x0a22a2b1, 0xaf3e1678, 0x655fa056, 0x9b7e9fd8, 0xd15d1f3c, 
	0xd399fa18, 0xac628897, 0x2b697e6f, 0x4b84f7c7, 0xf7cf7e23, 0x47ac31e8, 
	0x477e7358, 0x5afa46af, 0x1bf353da, 0x73a2dec9, 0x44f28d91, 0xf4b9422b, 
	0xcc3df979, 0x04a9b8da, 0xc76ba0f3, 0xec085145, 0x25d1e6eb, 0x97bdf825, 
	0x7ba7cc45, 0x8d8a9b7f, 0xcfe772fa, 0xc1fffbf8, 0x747ad4a2, 0xec139738, 
	0xa487baa5, 0xa6fe05fe, 0x3f3a79b8, 0xd9eed207, 0x95d9f832, 0x3f7c3f26, 
	0xea367e26, 0x0fa954c7, 0x9d1a4bf2, 0xee0bf076, 0x35f38879, 0xaa22d14d, 
	0x29784327, 0x9a8963d0, 0x0d65f241, 0xf65863d0, 0x9bf412fb, 0x19e62d0b, 
	0xe2f66e40, 0xb949d7fa, 0xfb7e72dc, 0x05f6f904, 0xba62b5e5, 0xe7c7c597, 
	0x5a7f1d3b, 0x39ef9e17, 0x99efbe7c, 0xfca1f7a3, 0xe595baa8, 0xfc039370, 
	0xca5f1a3c, 0xdef5b4e1, 0xc8a5f383, 0x4ddda693, 0x27358c4e, 0xc7a34be6, 
	0x381fb0f5, 0x3295e7df, 0x1ebee7aa, 0x8e2ef1d7, 0x7184d2f3, 0xa91f606a, 
	0xfe09c4be, 0x957dd01c, 0x87d9d7a4, 0x4f9abef8, 0xeff4b4dd, 0xc9fe053e, 
	0xdff8feaa, 0xc216cee6, 0xcef61361, 0xa9b60057, 0x45d9a059, 0x23e82955, 
	0xb9f9e738, 0x1f184519, 0x45749668, 0xf038f0ff, 0xea8d5549, 0x03bd421c, 
	0x18f1e676, 0x7ccaab8f, 0x0798abd9, 0xa0cf35c9, 0x706e5878, 0x72c9c506, 
	0x06dc85cd, 0xaaf7f10b, 0x70cfd60b, 0x1b9e8add, 0x97c821fe, 0x8d772c39, 
	0xd34e687d, 0xbe91ab33, 0xdb171748, 0x1a1dabdb, 0x51c9b5d1, 0xa28e2450, 
	0x17fd077c, 0xe93fbc9b, 0x2fd8cafa, 0xe59a3f63, 0x55b8d13e, 0x6aebe593, 
	0x1fb493ef, 0xe03e83d7, 0xca2610ef, 0x32b7b7db, 0x8f406bfd, 0xbcfff9e0, 
	0x29a5f79d, 0xb88c3f6d, 0xbe36e56c, 0x66e8e62f, 0x925fe938, 0xf0f81de7, 
	0x056d168a, 0x0bb22dca, 0xf14f2cbd, 0x1ec31c5e, 0x7c43ddf9, 0x42e2f57f, 
	0x51718831, 0xd1f70f7c, 0x26ed1718, 0x71e62efc, 0xe5d20e79, 0x9487fe70, 
	0xf6ff60c3, 0xf24bfda2, 0x5fb27fb8, 0xaec3909d, 0x18c78a02, 0x567ffcf6, 
	0x8e2a5f0e, 0xc2b8c97e, 0x51cbc62f, 0x35dc920e, 0x3fd83ae2, 0xe437afcd, 
	0x497f21ad, 0x72971eee, 0xb7948d77, 0xf70fd31a, 0x536ee493, 0x105b9d8a, 
	0xd02d7aa3, 0xec0245a7, 0xc6a74f91, 0x47a8a359, 0x17ec9ce1, 0xdf47ca58, 
	0xfa3f61b1, 0xe1fa096e, 0x7f3f4b77, 0x4d5de388, 0x1fbfe82e, 0x0fbc2bf5, 
	0x1529f5fb, 0x60bbd260, 0x39f8449f, 0x814fd9ea, 0xbf438e1e, 0x4519d9e9, 
	0x5f3e3c81, 0x9b5f61eb, 0xbdc64583, 0xf36f3433, 0x5ee3228e, 0x3582229a, 
	0xaaf60718, 0xc07c0159, 0xce34fde6, 0x1d37ef07, 0x4b7e7c11, 0x3b2e43bb, 
	0xe371878f, 0xff995ba3, 0x00fde4aa, 0x08a09c46, 0xeb2cf4f9, 0x7b31717f, 
	0x715cb045, 0x758285f9, 0x195f06c5, 0xe0d2e37c, 0x8c7894f7, 0x2d27115b, 
	0x31e2520b, 0xe05c6f92, 0x09dfa101, 0xfcc2e07c, 0x352f824c, 0x6395cfce, 
	0x5a88157c, 0xeb00e709, 0x23e2a6cf, 0xf3035037, 0xf5cfa833, 0x13f34bec, 
	0x0fd465e6, 0xf8319799, 0x4527f884, 0xd42e2f1f, 0x0deb277e, 0xe3e57f17, 
	0x6f14b7e8, 0x426f709b, 0x7162df9a, 0xdb03b17d, 0x95fd00df, 0xe67fec73, 
	0x4e884afd, 0xf1e90fb9, 0xff990296, 0xea0b38a3, 0x3fecb5cf, 0xc9f8c865, 
	0xa2bf22df, 0x3ccab5fd, 0x8c9ff98c, 0x4fca02ea, 0xf4edea9a, 0x71498cfd, 
	0xa7904c8a, 0x4e808719, 0x81e649df, 0xb443a2f0, 0xd08a4c4b, 0xe76bbe91, 
	0xdfc86b77, 0xdce6ab66, 0x61f1859d, 0xa7f037d8, 0x4e28a780, 0x18b06da5, 
	0xd4ce02f5, 0x18c76f7f, 0x73b74c6f, 0x2ead7d5e, 0xafbd2b74, 0x5d628d67, 
	0x5ca208a0, 0xc1eb333f, 0x9151d220, 0x14ca8175, 0x35d98175, 0x1977fa11, 
	0x100eb173, 0x91de28e4, 0x64b0f782, 0x005efd63, 0x0c1b9f7f, 0xc13aa11f, 
	0xe11c4770, 0xde074b12, 0x9fe2b753, 0xa078eec8, 0x36e89732, 0x9b717472, 
	0xc5f30b2d, 0xbe61b72b, 0xbcf75ad8, 0x77e16453, 0xd53f8041, 0x3ae87c65, 
	0xd3bab4d4, 0x27fc3de4, 0x7546dea9, 0x8eec330f, 0x9e2f3df3, 0x673d8651, 
	0x38d979f9, 0xe77a65c3, 0x2f53f8a5, 0x2b9d338f, 0xd84e1946, 0x570ce39f, 
	0xf91339ea, 0x43c924f4, 0x8061aaf5, 0xf5c2ad9b, 0x43aa4ee8, 0xe8eb1d7c, 
	0x71efc936, 0x9ff43936, 0x23a21d53, 0x6cd8f39e, 0x44d45bac, 0x6bac26e4, 
	0xb27bacd4, 0x43b615b0, 0x4778b758, 0xf0007ac0, 0x4dc5acdd, 0x3508fb89, 
	0x79d53f5a, 0x0a7d816d, 0xf1f500e9, 0xbd8a7a3d, 0x23f7f290, 0x86d96ed7, 
	0x85d63575, 0x7b3dd3cf, 0x45ceaa8a, 0xc6537f3a, 0xef79bf8f, 0xac132653, 
	0x42adf0e3, 0xd18af3de, 0x07f7593e, 0xe36ccefd, 0xa9b61d7c, 0x27caddf5, 
	0x9f549dc6, 0xbce2ef50, 0x6dcec2f1, 0x038fad97, 0xf6dbaf7e, 0x9977cf2c, 
	0xc8dfb93a, 0x0f51a7f8, 0xda1d5537, 0xc4cceae5, 0xd57d63ff, 0xd5536da1, 
	0x4b93c157, 0x751957d4, 0x8880ff67, 0x3bad4b9d, 0x29b6e6fb, 0x412eceeb, 
	0x7f56911f, 0x7c449bf6, 0xfeb7bff8, 0xa9b6c4ec, 0x6c4ef2ea, 0x5e5d54bb, 
	0x5099fd7a, 0xcd1faa74, 0xe03fe8b2, 0x03f4737b, 0xbd212f1d, 0xaf489b5e, 
	0xd7a0a747, 0x5dfdea27, 0xec974cfd, 0xd6ebf08b, 0xd99d4615, 0xb29b6cbf, 
	0xbc752cce, 0x666f5c65, 0x4718978c, 0x13d67185, 0x6d716d7e, 0xbd22be32, 
	0x4adb4cae, 0xe7a7a771, 0x81fc30e4, 0x437ecaeb, 0x5d5535fc, 0xf2da1959, 
	0x3bd7271b, 0xa5597819, 0x97af4b7e, 0xfe31bac5, 0x12d4c6f7, 0xfa7577bc, 
	0x4523e676, 0xd58be6a8, 0x10dd81a9, 0x81e1bb44, 0xd4eb1315, 0x583f67d4, 
	0xf5869a9d, 0xeb53a768, 0x2d2eb8d4, 0x97544fe7, 0x2b387446, 0xb93d3bc7, 
	0x9bf74d2e, 0x7fe78a2e, 0xe61a5d55, 0xce5ea893, 0xcddfd60e, 0xe21173f4, 
	0x2bd646b9, 0xa78f4e5d, 0x48716feb, 0x7fa7de35, 0xefc84f2f, 0x1ffb3e39, 
	0xa0bd8a8b, 0xfef73e2f, 0xd1e78bf7, 0xe7f36bbf, 0xeb839efa, 0x7dcfe1f2, 
	0x5bf7618a, 0xfa1c930c, 0x849dc973, 0x3f90947d, 0xda886fba, 0xfdebd74b, 
	0xdb912cd5, 0xf2bf5296, 0xb1d4b357, 0x310a0caf, 0x637f16cf, 0x69dbe80f, 
	0x7b73ae2d, 0x9b4eff41, 0x9decf719, 0xde2ef58d, 0xf9e17b73, 0xcff8de95, 
	0xcaf8011f, 0x7be7e265, 0x637f7cf9, 0x5e324bd7, 0x8aad463d, 0x9b4dbddf, 
	0xdbdcde29, 0x977df53a, 0x785e459f, 0xfcb5c717, 0xc107f40f, 0xf7f9146f, 
	0xd69f7f26, 0x7f416e22, 0xe173c610, 0xdcf0b0fd, 0x2be30f95, 0xf83780a5, 
	0x3de4f393, 0x6e47804b, 0xbed5bd6a, 0xd29f5ced, 0x80e39dba, 0xbfecb34a, 
	0x73e3fb8c, 0xdb7d67f4, 0xbb476d37, 0xffce1177, 0x7bb7acb6, 0x329dfa0a, 
	0x3d60f4e5, 0x8da3c6e2, 0x5cfbbef2, 0x24202c0b, 0xe7591bc7, 0x12ea35ce, 
	0x9babbe71, 0x2ea97207, 0x5c7be371, 0x3afeb897, 0x57cb283a, 0x0b7e5b88, 
	0x73e32087, 0xbec87828, 0x429f8735, 0x6e56f96e, 0xd5dd7d6a, 0xe7ca3c81, 
	0x98d24098, 0x5bed2dbe, 0x03d8e758, 0x3f9c71d7, 0x7cb8f7ce, 0x5926dee4, 
	0xd3dfc74f, 0x2262aba9, 0xbb442ed4, 0x8c777794, 0xc4be695b, 0xa2f53177, 
	0xec8ffd1f, 0xe41e937a, 0xdbca31fa, 0x72e2e424, 0xf1fe7b96, 0x49f827eb, 
	0xdfeeaebf, 0xf8d5f28e, 0xef8d2c77, 0x36b4b2ba, 0xd94dfa13, 0x7e868f58, 
	0xedf18bcf, 0xd6c6e32f, 0xfbc4fccb, 0x79840f32, 0x733c74ab, 0x290a4f89, 
	0xfcb2acce, 0x53bfe337, 0x9cfeeb05, 0x7f5fdf21, 0xfe227f65, 0x7d33dd80, 
	0x468728c3, 0xd26f853c, 0x8be38477, 0x1f7df236, 0x5fe70e32, 0x9efab04c, 
	0x399de49d, 0xc93f7ebf, 0xdfceb347, 0x17fa1fd3, 0x64439fba, 0xf947ee8e, 
	0xe085f773, 0xa4feb6ae, 0x997bba1c, 0xceffc85e, 0xfd9130a4, 0xdff0fd00, 
	0xdbdbbbd7, 0xdbf50bbf, 0xd7ff2931, 0x1f24de62, 0x82fc36f5, 0x8c75bb7a, 
	0x0ba2d4f4, 0xccdeb499, 0x74b9d6ca, 0xf354f34f, 0xe217a73c, 0x8777e23d, 
	0x72fcef58, 0x29fb9bce, 0x95fd01ae, 0xddf9b894, 0x15d89e17, 0x77bca571, 
	0xbf28acde, 0xa73e794a, 0xa57ac350, 0xb4ffcfbb, 0xdd07e317, 0x3db27fdb, 
	0xaaf7f817, 0x8edd3f6d, 0x565b1971, 0x8bf18828, 0x380e055c, 0xbd1463c6, 
	0x07bdfe90, 0xff885ebb, 0x4aed83de, 0xf3e44df5, 0x6166f45c, 0x4fe32cff, 
	0xd371813c, 0x60c7bc5c, 0x17fa45c1, 0xe46cff72, 0xf7f62f47, 0x5bfd4cbc, 
	0xf68b91c5, 0xf9fe84af, 0xfc61dfc9, 0x76dfd833, 0xfd438f13, 0xe5636e50, 
	0xcc6dc837, 0x273ed3a7, 0x192c7bfa, 0x6263bfd8, 0x29fd637f, 0x9fa97ae3, 
	0xfa65c975, 0xbf739679, 0xd78dcbda, 0x79e8fd82, 0xb4cb7d4a, 0xa442d1d0, 
	0xce138c27, 0xa7e7c970, 0xdeb07be5, 0x50f20bff, 0x00000459, 0x00032b11, 
	0x7ddd9c78, 0xe554740b, 0x27b7e8b9, 0x1093267b, 0x1e45e4c2, 0x01921804, 
	0x148d4102, 0x9b34106d, 0x60f50697, 0x8f28ad04, 0x2030100e, 0x2d47a22e, 
	0x93dd62a7, 0x301924e7, 0xd5092d10, 0x1b046273, 0xf42d1441, 0xee5db1e8, 
	0x5bc5b484, 0xa96d2aef, 0x41b458e5, 0x63c6a222, 0x968db16c, 0xe3dfb973, 
	0x04c999df, 0x6739ed48, 0xb59bd5dd, 0xf7bfcfec, 0xf7c7ffbf, 0xf3d3fd7e, 
	0xaf9fcfe7, 0x64601479, 0xb95e95b6, 0x9fd5c01a, 0x0ad1d873, 0xbd2b1e00, 
	0x6eb624ee, 0x1bfb7d2b, 0x71ede700, 0xce3c1d55, 0xc1539fd9, 0x49fde8e3, 
	0x8dc71e35, 0x54770b1c, 0x773f08ee, 0xf57e7cd2, 0x4f3c25be, 0xcf65a962, 
	0x685cc7a3, 0xe783b59e, 0xb5b7f571, 0xab233cd1, 0x3be83bb5, 0x9e17171e, 
	0x9b5ebc2f, 0x39c6862f, 0xcb8cc35d, 0xc6e3c059, 0xccc31599, 0xadc796b7, 
	0x4e5c6e1b, 0x09ab8f0d, 0xb3df370c, 0x3355ce3c, 0xe33f7cdc, 0xdf8de371, 
	0xc977be56, 0x71e03ef9, 0x1c7a5f77, 0x7e1815e2, 0x330fd7b1, 0xe34bcdae, 
	0x3b8e9d12, 0x8ab71986, 0x5c2225c7, 0xc32ebd2e, 0xb0d27125, 0x89bcf8e3, 
	0x5c7a5fd7, 0x1ba39d2c, 0x370cd5c7, 0xe341cf0e, 0xe6e1815c, 0x2ae3239b, 
	0x956f9b86, 0x341aab8c, 0x7e0dde2e, 0xa79e46c7, 0xb7c7de82, 0xb9ab6bef, 
	0x273d286a, 0xecfc428e, 0x1b5f3418, 0xcf8e97cf, 0xb107412f, 0x6e343fc4, 
	0xdae370f2, 0x1bb8f14e, 0x8f4f9d86, 0x73b171a1, 0x47cf9b86, 0x76f9a2e3, 
	0x7cc9de94, 0xe17c4b1b, 0x189cb8bd, 0x38f177a5, 0x3bc5c137, 0x46a31e14, 
	0xb76fe60e, 0x34a8c782, 0xbadf24b8, 0xcec4786d, 0xddfee4bf, 0x16a31e0a, 
	0x58be7a5c, 0x571a47e2, 0x02badc3d, 0x4bce518f, 0xc9371fcb, 0xcdc00b95, 
	0xeef28093, 0x92e79e3d, 0xcaa4f370, 0xe1f89d38, 0xf67ce352, 0x4bffe438, 
	0xbf12738c, 0xf5e8019c, 0xb7aa8118, 0xff904c00, 0xeebdf7ec, 0x00ef3046, 
	0x19abbce8, 0x31bfe02c, 0x31a86b67, 0x16e39cc7, 0xb96abbb2, 0xb726fd9f, 
	0xf498f630, 0xfe909ec7, 0x8fe91eb8, 0xf8fe95eb, 0x7f1fd2b3, 0xaedefa4e, 
	0x6fbdf720, 0x8e130b72, 0x09c27f49, 0x48f4e7e9, 0xfa57a73f, 0x9fa567b9, 
	0xbefa4e7b, 0xfbee3aae, 0x2616e4de, 0xc4fe931e, 0xd49fd213, 0xbd49fd23, 
	0x967c9fd2, 0x3f726b5b, 0xe780bdb6, 0x838006fe, 0x2c015446, 0x2af5953f, 
	0xe98802ac, 0x49d7064b, 0x3fc1af1e, 0x06873be1, 0xa3cf1c66, 0xb8d417c1, 
	0x4a79a4c1, 0x2befc27e, 0xe0fa4072, 0xa9fbd071, 0x42bfa553, 0x8171e137, 
	0xe967981b, 0x37020d7f, 0x34abe7ae, 0x1c3ef157, 0x9a03e226, 0xd71374ad, 
	0x3950575b, 0xdc021613, 0x1f38785d, 0x774dffb0, 0xe3cb5e8a, 0xff7a0c8c, 
	0x7c8afecd, 0x7393df7a, 0xbf7a4ec7, 0x350e93ca, 0xeae7bef8, 0x1ffa9b3f, 
	0x979eefb0, 0xfb00990f, 0x34ca8075, 0xbf47a680, 0xc33e5330, 0xfc947c7d, 
	0xbe7f3d2a, 0xe1415674, 0x521f6c01, 0x4170f9ad, 0x3bb60161, 0xb55bbb54, 
	0xf5ad543f, 0x95fb8c9a, 0xfb547b6a, 0x39c2d527, 0xeb559369, 0xaad5ed53, 
	0xc95f6635, 0x96d562ed, 0xd521f6aa, 0x94ae5b9a, 0x5bbb55f5, 0xad543fb5, 
	0xf71923f5, 0x386d692b, 0x9ea3df3e, 0x79e069ff, 0xbf255742, 0x5b93784d, 
	0xfa4c7918, 0x3f484f23, 0x89fa47b1, 0x751fd2bd, 0xcea3fa56, 0x55d3df49, 
	0x9bcf7dc5, 0x31d242dc, 0x909d27e9, 0xf48f727e, 0x9fa57b93, 0x29fa5672, 
	0xda9fa4e7, 0xd4fdcd55, 0xb485b937, 0x3b4fd263, 0x3dd1fd21, 0x8bdd1fd2, 
	0xdb404f6d, 0xf802e559, 0xa02cbcc4, 0x2ee985f7, 0xa9691dbe, 0x4ce0a014, 
	0xd1d10251, 0x045f39ff, 0xddf60566, 0x41e8e050, 0x5d43cdf6, 0x2bff0338, 
	0xe384d941, 0x8143b446, 0x7f02fd89, 0x59ba078c, 0x198e98df, 0xd13a2f4c, 
	0xd681ee97, 0xd62efc18, 0x8e0c460d, 0xa380cb8f, 0xe09f7c4e, 0x8f9e1286, 
	0xb78f13f4, 0x61ae98e2, 0xcbb9d324, 0x3f1a7e03, 0x81470dc2, 0x81bcafe7, 
	0x2b032fe7, 0xbdc020f6, 0x01e25609, 0x8783db84, 0xe7803d72, 0x08ff707f, 
	0x6643513d, 0x7eae5b71, 0x9fa9cf8d, 0x3dd2440b, 0xf9f0fbb8, 0xd7a1ba43, 
	0x4c25b323, 0x7df2a304, 0x2be12fe1, 0x5dce3b43, 0x3086eb4b, 0x207f109f, 
	0x7137c359, 0xb3ce0f2e, 0xb26bd3fc, 0x95b7087c, 0x6b2dffe7, 0x3f45b61a, 
	0xa803d235, 0x09745627, 0x665fe3bd, 0x32c5f890, 0xf06f8332, 0xc22fdcf7, 
	0x55288c23, 0xac0394f3, 0x403dbda1, 0x64ce6abb, 0xf14035fe, 0x5a07a437, 
	0xf8b639e8, 0x7344a9dd, 0xd70479a7, 0x4756bdf3, 0x6af2b674, 0xaf2ff169, 
	0xcfe79eab, 0xdaed823b, 0xc14d8dc7, 0xd682d4c3, 0x80fb626c, 0x1ff72d7f, 
	0x5a8e3ec0, 0x83f86a5b, 0xcf85a9f3, 0xdb15b9ff, 0x775696e5, 0xde55b603, 
	0xd4d97503, 0xc1f9ceb6, 0x23cb8402, 0x3db6e3b1, 0xeeaefd85, 0x2efbf9fb, 
	0xef41df35, 0xb51760a6, 0xf42fff90, 0x46e36efd, 0xeb58fefe, 0x70a75b15, 
	0xf34edd5b, 0x1a77809f, 0x6a79a69f, 0x9fadbd7f, 0xfd7379f7, 0x87b3a21c, 
	0x84fdfa03, 0x4c33eb8c, 0x465b0394, 0x609ffc22, 0x7c13a738, 0x3953391e, 
	0xfaf08dd3, 0x7ce1df4e, 0x291df637, 0x51ba774b, 0xb481dcce, 0xf923e9e7, 
	0x09d01d52, 0x3e66cd5e, 0xe04789d3, 0x5ccce2b5, 0x48a73796, 0x9f3e20de, 
	0x4efb7d5f, 0x37fbe7c0, 0xc38f49ee, 0x9c218fe7, 0x2bde10e3, 0x33c0a475, 
	0xb69e0ad4, 0x3811f3e3, 0xb7d3f5ef, 0xb0bee006, 0xb4efa1be, 0xbe671a16, 
	0x093363b1, 0x934dd05f, 0x3e326da0, 0x2bc16152, 0xd79f2f24, 0x32f915af, 
	0x47deb55a, 0x574d5e44, 0xe447fced, 0x5da437f9, 0x02e3f651, 0xb8adb840, 
	0xdef2c7ff, 0xd302e3ff, 0x9824eb8b, 0x65db95e9, 0xa7a49dfd, 0x8ea70e1d, 
	0x5ad690f4, 0xd4653508, 0x9cd45416, 0xaf4f36a1, 0x4549f6c5, 0xdead6987, 
	0x8f7c5a9a, 0xe343ce02, 0xe757769f, 0xed3eff10, 0x16982636, 0x302e33c0, 
	0x9b62d72b, 0xd40e7b75, 0xa811df51, 0x27388e4c, 0xf9e063ce, 0x7c08085f, 
	0xc67d2137, 0x4cf89da0, 0xa438f022, 0xf490672b, 0x1d58d58f, 0x5cfc285c, 
	0x45c07a27, 0xf0a191f6, 0xfeaa0382, 0x3e7c44e4, 0x4998d663, 0xbb527b00, 
	0x51e70667, 0x47b7742b, 0x27f04f07, 0x669826d8, 0x93db8e03, 0x88273ddd, 
	0x3e67b0f4, 0xd7088d68, 0x96c3b73d, 0x274ccdfa, 0xf607457a, 0x8adf1ac7, 
	0xdde6a7ec, 0x9de90afb, 0x67c80915, 0x36282e78, 0xb76501dc, 0xec79ebfc, 
	0xbebc23c7, 0xda8e36e0, 0xe69c0354, 0x2d94a807, 0x7ea269c3, 0xb860909e, 
	0xed6f092b, 0xb39204e0, 0xe5e181bb, 0xc04e6af3, 0xf8a27e79, 0x0f3c2af1, 
	0xe8fa7d20, 0xc7dc74fb, 0xe26d50f5, 0xbf7cf601, 0xb11a1ab1, 0x8dc5089d, 
	0x5fd18708, 0xad83816a, 0xedda3861, 0x88cfc4db, 0xdc3e1597, 0xfdf69fa7, 
	0xcfcc2be0, 0xd21f3825, 0x3c3a2421, 0x38373fbc, 0xffdf102b, 0x1053e38e, 
	0xbad3577e, 0xee73e17d, 0x5d73fcb9, 0xa9cf837b, 0xd9dce807, 0xf1719f38, 
	0x182526f3, 0xce8f9f3a, 0x1b8cf64b, 0x9d5274f1, 0x04e898a3, 0xfc829dcf, 
	0x207ce741, 0xa0c47e7c, 0x1c11c793, 0x1599bd70, 0x167c8f22, 0x3c33b77e, 
	0x714fcf6e, 0x9ecf3c5e, 0x847e7c5a, 0x809c33e6, 0xe1b715fd, 0xf7da4cbe, 
	0x9c90af23, 0xbcbe767f, 0xb5cb673f, 0x52afec62, 0xcf6f11e3, 0xc49cb7ee, 
	0x68f603b3, 0xaf083c14, 0x07045f44, 0x712fb7a2, 0x193ea49e, 0x2347fdff, 
	0xf9973dcf, 0xa6af0063, 0x716332e1, 0x43d7131d, 0xf3aa657c, 0xcea22a3a, 
	0xa5ba46eb, 0x441d10fd, 0x40e0979c, 0xffdfcd7c, 0x69dce22c, 0x5cf7cfc0, 
	0x86bc5976, 0x4d3a93fc, 0x2115dc6b, 0xbb4c560f, 0xba235d37, 0x6c722b18, 
	0x6ee19a4f, 0xc4e49bb9, 0x119a5782, 0xcc4e13ef, 0xfcc2dcdd, 0xd82d7102, 
	0x143a449f, 0x857c6ce9, 0x989409d0, 0x19c926e9, 0x6c272af7, 0x97c3c30f, 
	0x9c017100, 0xc09be7d7, 0x0b7489f4, 0x2c7f9c0e, 0xc213777e, 0xec4f4263, 
	0xc0347334, 0x49d3a081, 0xf6ede7eb, 0x0a34c7c6, 0x0f288d1d, 0x365e51d3, 
	0x1f1007c4, 0xbaa73071, 0xa56ef91f, 0x920e2131, 0x38cf082e, 0x81aa6f3a, 
	0x27fee1eb, 0x50e23b7a, 0x825a40f7, 0x4ef824e1, 0x84c67826, 0x4f3132e1, 
	0xe29a66f8, 0x5df489ff, 0x4cfdf87a, 0xd70c47c5, 0x93bb864c, 0x6f4575f8, 
	0xe9c9354e, 0x20795fd4, 0xff02f44f, 0xbde6e9a5, 0x5702fdf5, 0xe535c20f, 
	0xcbfb6301, 0x473861fd, 0x0aedd9f3, 0x8f71db6f, 0xf9f86f5a, 0xe85b9226, 
	0x3528106f, 0xca01d21f, 0x45abed8b, 0x941f90bf, 0xe51f7244, 0x7fb7e8e1, 
	0xa0242ef7, 0xcac57d92, 0xd375fb21, 0xf35d1c99, 0x4fd871ab, 0x9e9fd279, 
	0x7f8d50b4, 0xe6ddf682, 0x96f9f0d3, 0x9cfc359e, 0x4df845c7, 0xa4f1ae78, 
	0xf1f5a22f, 0x17d8a716, 0x8de65b49, 0xdbf39400, 0xb8f5f3bb, 0x06b3966e, 
	0x369b3fd9, 0xd0c833cf, 0x6a31e1d8, 0x9f887e6a, 0xf89f8065, 0xe677d37d, 
	0x673b25ad, 0xe9b9e8d3, 0xf8ffdc01, 0x8bc7d7ee, 0xfde0ef1d, 0x49efdfe3, 
	0xea7c3cae, 0x3764bbfc, 0xb52a475c, 0x3a3dc682, 0x6379ec5e, 0xacfb89b7, 
	0x078322ac, 0x6740b6a0, 0xd6854afa, 0xbfa823c6, 0xa8fa4583, 0xab9fa8f5, 
	0x6bc9f44b, 0x5cdece44, 0x04f889d5, 0x84d9846d, 0x11acff6d, 0xb4df7691, 
	0x03ef8f9e, 0xf4d333d4, 0x05e93ab9, 0xe35acbb4, 0xb9718ed1, 0xcf1935a1, 
	0xfa215951, 0xd8e4a035, 0xa787a50e, 0x24c23e81, 0xe99b71ba, 0x331f0c8d, 
	0x7ff8883d, 0xede442a4, 0xed87a516, 0xc52f34f7, 0x5d9da629, 0x69e92b7d, 
	0x9f9a3d7b, 0xa29574f4, 0xa2d75c2b, 0xdb9e3871, 0x57e66387, 0xdd2f0899, 
	0xf29569fb, 0xee89d28f, 0x764bea52, 0x57e08d4f, 0x9724b3d2, 0x568fea53, 
	0xba68c3d1, 0xfbf16e8a, 0x3a089cb6, 0x139fbfc4, 0xda3da15f, 0x46fe780d, 
	0x63e22fc2, 0x069cd9e5, 0x6f9d4ead, 0xc90f3a95, 0x61c88f6f, 0xefe4c792, 
	0x417054ae, 0x3ed0353c, 0x533cf4b7, 0x07a5744c, 0x7f633fbd, 0xdf4cc33c, 
	0x5768708e, 0xd02c157c, 0x63c1ef99, 0xca65d7a6, 0xad738273, 0xabd71cfd, 
	0x6f3f096b, 0xa57a16cc, 0x0cce9ff5, 0x8265639f, 0x1496fdd0, 0x21f49d23, 
	0xb4f1dffa, 0x91c2274f, 0x1af488f0, 0x2ae748df, 0xa3df8544, 0x01f1c5d6, 
	0xd93c5577, 0x56edbd0d, 0x05f58385, 0xb7f47538, 0x91547fb7, 0x87f0fa4e, 
	0x60759f6a, 0x0111dfed, 0x8fe695a7, 0xec59a1d2, 0xefce077e, 0x359ac609, 
	0x433d1357, 0xbc03c715, 0x1eec41b7, 0xd24b071c, 0xa1af7e89, 0xbfb08493, 
	0xe93c70e5, 0x3baefc15, 0xef4ae906, 0x08e7f893, 0xca0e27f2, 0x52afb6b9, 
	0x9e1858f0, 0xf7c1e9cf, 0x711fc5bb, 0x3a819f91, 0xebdf21c6, 0xbfc73df4, 
	0x5615fbf0, 0xe789bc71, 0xf3c4f1da, 0x1f38c7c2, 0xfeba83e9, 0x3370e979, 
	0x060793ae, 0xa24e33f9, 0x9f3c83ab, 0x7f43e79f, 0x3a0dfc87, 0x51fec9bf, 
	0xf10bab7e, 0x8af08718, 0x7909f7c5, 0x621fa250, 0x5ff20e38, 0xff124fd8, 
	0x307680e5, 0x16c52fec, 0x6be69f83, 0x8e3f3a58, 0x303cadfd, 0x0b879e69, 
	0xa2a555ce, 0xac2dabce, 0xeff3d272, 0x9177cde4, 0x9b71acde, 0x00e3932e, 
	0xbce0f768, 0xc7662bc1, 0x3f782b79, 0xd37f45ff, 0x79d11cf0, 0xeca39edf, 
	0xc7491a3f, 0xcdd49fa5, 0x467c91ad, 0xf27dc9fa, 0xfa5fa53e, 0x91fb1629, 
	0x2711ea46, 0x4a8f53f7, 0xf4b8ed3f, 0x35b9bad3, 0xfe919f46, 0x93ffda68, 
	0x515796a7, 0x93c9e0dc, 0xe703a37a, 0xd4bdf27b, 0x8ae73a2e, 0x0fb62e82, 
	0xea06b4dc, 0xdb9294c5, 0x3bce083b, 0x8669a346, 0xc50405fe, 0xab3e46ee, 
	0x13e8bb26, 0x3f64af53, 0x9065e602, 0x0abf44fe, 0x9c09d62a, 0x6a2c4fc9, 
	0x61f8e5cf, 0x03943142, 0xdd68a5e2, 0x15d12f3e, 0xd126ff5a, 0xd824d155, 
	0x450479c9, 0x3d8fe537, 0xe110aa3c, 0x6bbbe9b1, 0xbca3678a, 0xf229529a, 
	0xa5603be9, 0x69533e13, 0x721f067e, 0x51e3ee28, 0xb855ff94, 0x0327bf5f, 
	0xdd324e6a, 0xe7c44e98, 0x4bfe7fa3, 0xfc83865c, 0x9d4aac94, 0x998b7bf4, 
	0x1c25e2af, 0xfa7ff14f, 0xf1d9fced, 0x13ca7e91, 0xcb594fca, 0x52af8a7e, 
	0xf28578f8, 0xf9285653, 0xf6d2b938, 0xe12a7253, 0x653f48b3, 0x2b29fb2d, 
	0x69ef8412, 0x4d93d91c, 0xd0bfe28f, 0xf8f9599f, 0x563bf64c, 0xe19696ee, 
	0xab6c8e4b, 0xc0b4c7c8, 0xfbf24ab4, 0xca379e07, 0x82cc4ff3, 0x80e38a4a, 
	0xbbe18739, 0x17847af1, 0x4545b7fa, 0x7b61f1c0, 0x9eb805fd, 0x545bf71b, 
	0xce207229, 0xd2330e83, 0x5a04bbb7, 0x57103e29, 0x471459a2, 0xb8647e40, 
	0x3b5ff417, 0x84509e28, 0xe37920f8, 0x218b7e46, 0x9a0330fe, 0xf1e78a79, 
	0xfe56ecc7, 0x93ac9a79, 0x34b8eb42, 0xfd1b87d9, 0x98278968, 0x402e5823, 
	0xc241c91e, 0x1b05d91b, 0xef7bb8d5, 0x41e8d319, 0x21bbdd7c, 0xe907a8e5, 
	0x17d7dc66, 0x38e7c255, 0x623ffda6, 0xfcdcee48, 0x2f1548e5, 0x094f1833, 
	0x93e4cf6b, 0xce25085d, 0xed87a4b9, 0x8d7c50f3, 0x37f78fe8, 0x772e7c2f, 
	0x3cade689, 0x3963e7c8, 0xe744f447, 0xcad62848, 0x5e8ce501, 0xfa237222, 
	0xae2a71dc, 0xb63b9f61, 0xd6620d24, 0xe18b3e8a, 0x77dfc838, 0x1563737c, 
	0x707abb28, 0xf04dd39c, 0x7ff7f8dc, 0xa2ce9b3e, 0xa3ecf7cf, 0xf89f9853, 
	0xbe385f7d, 0xe227eb64, 0xa25ba203, 0x5ba27893, 0xff285745, 0xcf425d5b, 
	0xa16e4742, 0x61892823, 0x017d443a, 0x9e981fa4, 0x411cdf48, 0xcf1576b9, 
	0x44744adb, 0x86e88dfa, 0xe794a7e9, 0xbe88c7f1, 0x8af2431a, 0xba87b4e9, 
	0x177e98c6, 0xc58c77ef, 0x8fb23370, 0xfb3f72c4, 0x1ec7f4a8, 0x6ed8fe97, 
	0x67718d6e, 0x4fae3fa4, 0x97ef8fde, 0xcdcb78fe, 0x6e11ef7d, 0x8651ef2d, 
	0xb8e131a3, 0xcb7427f4, 0xd2339cfb, 0xf793e9cf, 0xcfd2fdb9, 0x7cef84b5, 
	0xb35ed847, 0x3fa5477c, 0x27f4b8f1, 0x6e3c4b76, 0x4fe919d2, 0x93f793ea, 
	0xe122e3fb, 0x25fe4d6f, 0x07d1cbea, 0x48fe45c0, 0xf8c7b282, 0xff7f75dc, 
	0xfb258de7, 0xb9f081fd, 0x4714bce9, 0x12fca758, 0x67c5273a, 0xee50dc12, 
	0xcbce5f79, 0x15f227f6, 0x3df4cff9, 0x3be465c9, 0x8255d13f, 0x887d635b, 
	0x3965e2f4, 0xf3f916ed, 0x419f0af7, 0x2773c170, 0x93b46537, 0x6a6e4d9e, 
	0x733f22ae, 0x5867b4ed, 0x9df95e3f, 0x41e0ab87, 0x890c8fe4, 0x891eeb3f, 
	0x1b3ef737, 0x02df35ef, 0x16673858, 0x6bff5e78, 0x2df7f4e0, 0xabc940b7, 
	0x9398ff30, 0xb93f61cf, 0xa072acd1, 0x9ce2b25d, 0x8597af16, 0xcfd20eed, 
	0xfebfd123, 0x5c51d21a, 0xd4a1c51f, 0x8f3caf73, 0x0b09f7d6, 0x7eb1de44, 
	0xef543ddc, 0x02e416b5, 0x3db6b5f9, 0x47affac0, 0x6119c3e9, 0x9fff0ffd, 
	0x7d346ff0, 0x38785dde, 0xe48bec8f, 0xfe458f26, 0xe667b5d5, 0x7df1b9e4, 
	0xa6197bf6, 0x576c2d23, 0xf952adad, 0xafb12a81, 0xde9f5272, 0xa56df249, 
	0xc9ef471a, 0xb8a9f21e, 0x892abad0, 0x207ab4fb, 0xc477fc8f, 0x8fdb0263, 
	0xee939a3f, 0x707de148, 0x50fd099c, 0x75edb3f6, 0x79b4cf5a, 0xfd80dc69, 
	0xde4a6cd7, 0xe115d501, 0x7cecb0cd, 0xa862b7c4, 0x48b2719f, 0x1ee6a5ec, 
	0x9bae9fb6, 0x09fb2ba9, 0x64cf58e2, 0xf245db81, 0xc8ade9c7, 0xa7be0131, 
	0xe4c779ec, 0xe50f3587, 0x0accf263, 0xe6d6b3b2, 0x0e09ba55, 0xfb1c95cb, 
	0xaa91f0a4, 0xa157b414, 0x17dc1504, 0x79962694, 0xd6bd4bd3, 0xeec936ff, 
	0xc86a6d5f, 0x20aebdcf, 0x7dc4df98, 0xaa866d2d, 0xf6f50011, 0x647cf1be, 
	0xf1f40eb7, 0x818e749c, 0x90fa47be, 0xbf28e321, 0xd5d0fb43, 0x0f1e5d7e, 
	0xbd632fe7, 0x1829a85e, 0x27977e7a, 0x3d25af43, 0x82a7267c, 0x837c17df, 
	0x9203b1e1, 0xdf9b3e05, 0xd6febee1, 0x87849735, 0x9ed0d6a3, 0xebf636c3, 
	0xa83db8af, 0xf2ba3eb7, 0xd3b22ac9, 0xcebf77c7, 0xf869d779, 0xf8a52cce, 
	0xe283b5cb, 0xd3e7e42f, 0x6bdd95fb, 0x7a06e1d2, 0xc104793f, 0xa2bf7edf, 
	0x46e188bb, 0xf20aa071, 0x25afd0c3, 0x3bad30bd, 0x9efc82bf, 0x932b9b69, 
	0xf7d29e39, 0x71c7015e, 0xb8abad82, 0x77de79bf, 0x34e2dda9, 0xede2a7be, 
	0xd83b2b07, 0x8fb3078f, 0x567372fc, 0x0b33ffa4, 0x385559ac, 0xec665c1f, 
	0x562f8933, 0xf7e24cba, 0x7df49c9e, 0x3fd82714, 0x8505dbe3, 0x9ebda0af, 
	0xe447f6ff, 0xcbffcdd7, 0xe71afb0d, 0x2d52dc02, 0xa4700c74, 0x3fb2e08d, 
	0x714a98c7, 0xbf0d86e9, 0x9bf8a369, 0x24cf2f0e, 0x6fd73e38, 0x407d57e4, 
	0x2fe69f79, 0x8bebbe68, 0xfaa6cc17, 0xe389d308, 0xb2cece09, 0x0def34bd, 
	0xbad9ce65, 0x74fdf345, 0x2bafed26, 0xebd3a6d5, 0xa3d6bf79, 0x0bb86fd2, 
	0x7bfb83c1, 0xa83cce0e, 0x7cfde04d, 0xbfe1115c, 0xf1255a7c, 0x7f6a69d8, 
	0x272ae0bd, 0xf375d07d, 0x86a614b5, 0x395160de, 0x5180837c, 0xf60905c4, 
	0x45ebeb7b, 0xba64d9b0, 0xe392ffcb, 0xa23fb87d, 0xe605874f, 0x5f1791ef, 
	0xeaa33eb9, 0x282f00bb, 0x4abbacbf, 0xa565b7fc, 0x78d9e1b0, 0x38d2fbf2, 
	0x107edacf, 0xe1030efd, 0x06146a91, 0xf3ed9cf0, 0x16d1cfdf, 0xf081e446, 
	0xd5f712af, 0x59f4f6f0, 0x458e2ab9, 0x0ca196cf, 0x4fc44508, 0x74c0f6bf, 
	0x17beabf0, 0x13a2f5f7, 0x3c549aca, 0x6cb5d086, 0x6872f9a2, 0x82872a3e, 
	0x266b29a4, 0x4db5fbf0, 0x21b3ef82, 0x5bfecfc4, 0xe2f6491e, 0x7e2b6fcc, 
	0xdf5cb659, 0xf0578be0, 0x51193f42, 0x7c7cb962, 0x8744bdce, 0xbec6390d, 
	0xfedfc446, 0xe7dd1f2f, 0x2dd542f9, 0x5e5c8120, 0x7c46f12d, 0x0be51aff, 
	0xe34b283e, 0x048685fa, 0x07ce9f33, 0xf22f3c7e, 0xc2216f7d, 0xc508e115, 
	0xf75c32d7, 0x9f2dbd2f, 0xf0d193e2, 0x47d93a46, 0xbfc82cf3, 0xf5e9366b, 
	0x5df532de, 0x1e6f1141, 0x220d7fd7, 0x1e25bfd6, 0x3efed366, 0xd7074b28, 
	0x999f00d3, 0xfac71cb1, 0x426766e4, 0x19e71795, 0xe08fb301, 0xf8d85e3e, 
	0x64cd7cfd, 0x40efc93e, 0x3e573c3c, 0x5ff6af51, 0xf3515f60, 0xa8d71af7, 
	0xfaf0d7f7, 0xc6bcf063, 0x55f74303, 0xa7b7cb7c, 0xf99788ce, 0xcbef7ec9, 
	0x011d7dc0, 0x76b30ff8, 0xeb090396, 0x46a3e253, 0x73e34eca, 0xc303ff5c, 
	0xdfb21a84, 0x223f799c, 0xe280f8ba, 0x42e43d50, 0xf7e2dd20, 0x508d209f, 
	0xfec0d6bd, 0x572c7a6c, 0x6eb2cdfd, 0xe8063ef4, 0x20e178b1, 0x2af7fc7a, 
	0x5d101389, 0xaf187942, 0xa19ee78c, 0x1e25b870, 0xf18ab6f1, 0x15e29530, 
	0x193995cf, 0x4546c5ae, 0xa307c712, 0x27cd12e0, 0x902e89bb, 0x771616ae, 
	0x2fbf1126, 0x6dec6118, 0xb6e7c234, 0x165cf7cf, 0x7c3f91f2, 0x11cae7fe, 
	0xfe3cdd5e, 0x4fae8497, 0x75576601, 0x7f11df0b, 0x4b35ba9b, 0xe70862e2, 
	0x590f8a85, 0x8d799ede, 0x04a7cbf4, 0xce230fbf, 0x9934e0a3, 0x08d9e464, 
	0x8cf0d9f8, 0x70941f86, 0x80af123d, 0x7c5bd4cc, 0x59eaa06d, 0x88fcc65a, 
	0x6671b6fc, 0x01e29620, 0x973ebf36, 0xb8a6ad66, 0xef77b2c3, 0x92749a9f, 
	0x2553e9da, 0xafbc505f, 0xfff51571, 0x887146d0, 0xf66f2536, 0x8fbfdce7, 
	0x1b0d31f2, 0xd8874cd2, 0x7f44fbef, 0xc4a66d58, 0xe335f78d, 0xc794f9f8, 
	0xd5aeb8e5, 0xdfd08c16, 0xcfdf1b0d, 0x3c114989, 0x7c0a4e78, 0x5f190b3d, 
	0x5f191ab3, 0xd4f4cf6f, 0x59bb5f09, 0xa4f91b9e, 0xfe796c37, 0xc7f21941, 
	0xcdd724fb, 0xa60a4499, 0x7e31df8e, 0x0fc236ac, 0xe111bdc1, 0xcd6590dd, 
	0x5f79446c, 0x41fdf6a3, 0xc27c82d9, 0xae4a27cb, 0x8d7e5ca2, 0x3f8756e8, 
	0x43bca4cc, 0x26e501af, 0xc6d771f2, 0xa7a39622, 0x2bc27e69, 0x0409d1e9, 
	0xcf856be7, 0xf1ab386d, 0x4bd21156, 0xcdc2dd24, 0xbcb6b74c, 0xc443f65c, 
	0x979615bb, 0xca0bcf08, 0x998ba44b, 0xf702775c, 0x7cfda2cf, 0xad11f360, 
	0xf9c312ff, 0xe75f0c97, 0x72215799, 0xbf65b3bf, 0xa6dfdd17, 0xb9efef0b, 
	0xca4e3f4d, 0x27c22fd6, 0xcfb0df52, 0xee78616a, 0x7c0b823b, 0xb946e48f, 
	0x8748b792, 0xdb1957fb, 0xbd102f49, 0x09f2bf90, 0x2c3fbf3d, 0x57fba397, 
	0xfa8e45ce, 0xe1967c47, 0x7cef48d6, 0x367639ba, 0x4fcd95f1, 0x7cd85f36, 
	0xcb60fcc4, 0xf3e1b591, 0x1aac7f33, 0xf1c31fca, 0xc43fcd85, 0x8af53d87, 
	0xba1f70ff, 0xd91473af, 0x8e13ce1b, 0xe7803844, 0x9ce24db9, 0x10b7e819, 
	0xbcd3eabf, 0xbdf6469a, 0x44751c07, 0x50706ee7, 0xf5e43f3c, 0xd390dd73, 
	0xda913737, 0x4ae3b950, 0xeccb3b40, 0x1db1a9df, 0xc08e0095, 0x81c7dc1c, 
	0xa403ae0c, 0x30cf2835, 0xfb262702, 0x11c07f4a, 0x43e3855f, 0x5c2a73c7, 
	0xe8cbbdf8, 0xf5c7597e, 0x2556b91d, 0x0fb801d5, 0x226b8364, 0xd0db3fce, 
	0xdf83ff28, 0x17ae3459, 0xb7f33b1d, 0x7cfd27a8, 0xd1f3fa4c, 0x3d9b897a, 
	0xde25620b, 0x9f7b517e, 0x735057e0, 0xdfd12e5f, 0xac3707a2, 0x149afa21, 
	0xfa229c6f, 0x8fc37a9c, 0xdf8b6772, 0x18267620, 0x50874415, 0x3e927460, 
	0x56372470, 0x9039dd10, 0xc2d10fed, 0x7a61c685, 0xe9a1e8be, 0xadbe28a7, 
	0xa4ee8e15, 0xde7d387d, 0xf4c3b467, 0x7a75c5bd, 0x5c68370e, 0xe30607a7, 
	0x92f5a2fd, 0x2e7c2d19, 0xe2934e1b, 0xab9236cd, 0x5facbeed, 0x54a1d7d2, 
	0xeff14a98, 0xa2dfe471, 0x58c2f69f, 0x67921ef3, 0x5ca3277b, 0x0ffb280b, 
	0x89f3daf5, 0x85e08fb0, 0xfcd1d7df, 0xfd8f8bf5, 0xb9f483da, 0xdbca9a6c, 
	0xe0a9ceb5, 0xdcff10fa, 0x3577ca0a, 0x1e0f2538, 0xbdd1e377, 0x4ecb6f44, 
	0x6f7169b4, 0xbbb85d08, 0x88dc2e85, 0x895af2a7, 0xb8a82c4b, 0x447924d6, 
	0xf242b5fa, 0x215fdb07, 0x0d6b4d78, 0x3ad4f368, 0xdfae3f48, 0xfe502457, 
	0xc8c38174, 0x009c7d25, 0xa365ae72, 0x1afc9341, 0x3f11db68, 0xdccdfb5b, 
	0xbf69bbaa, 0xc0259516, 0xb91da3d6, 0x2dffdc0e, 0x41ddbf0f, 0xf1db6a7a, 
	0x1064b939, 0x39d6bee9, 0x5171e21a, 0xf949deac, 0x9ac5b8a3, 0xbabe74c6, 
	0xf383896b, 0xc743a637, 0xe23567fe, 0xff1a9ef7, 0x13c50568, 0x56c3e6e2, 
	0x9fce1bd3, 0x5d2367bb, 0x2a9b6326, 0x2c51757a, 0x3089ea22, 0x22b5821e, 
	0xa56bb32f, 0xa25166ce, 0xc67820e5, 0x0a3f9e6f, 0x6cdf5026, 0x2d823ea2, 
	0x317ee597, 0xa79e09f2, 0xe119e891, 0xd23378d5, 0x21d0b74d, 0xaeee3de1, 
	0x2f041515, 0x6f77c2b7, 0xda643c31, 0x73a4c9fa, 0x9c229c94, 0x342fd087, 
	0xcedf1377, 0x16f9887e, 0xdf7a609d, 0xefa4b30b, 0xee7c259e, 0xb9c93ec1, 
	0xe7c2598c, 0x53cfd55e, 0xbe3502fd, 0xd4378d50, 0xbef562fb, 0xaa5fbd44, 
	0xbf55fbde, 0x5fd0fa4c, 0xbb744b9b, 0x70ef433d, 0xa2b9269d, 0x4b3cdfbe, 
	0x59fa2d11, 0xd9d4579c, 0xcff5ef5e, 0xd9c1f796, 0x0836f9fc, 0x106b9ae6, 
	0xc9301e8f, 0xe0f5ecfe, 0x497de979, 0x34d81821, 0x99f18b9e, 0x0cdbc748, 
	0x82dde7e4, 0x49ffb637, 0x025d916c, 0x75b3e183, 0xc227f21e, 0x17ce1b67, 
	0x16d1e38b, 0xe2bd25cb, 0xcf83b926, 0xaa7c6f1b, 0x801fbe82, 0xf2bf0daf, 
	0x85bcead9, 0xb9f357d2, 0xc14fb34b, 0x838fc61a, 0x4bbd72f2, 0x7a18a1e1, 
	0xf7fd97ef, 0x85f1a816, 0x16f7d285, 0x5e96f9ca, 0xfca00b23, 0x4174bf23, 
	0xa6eddcc5, 0xf8ef4c27, 0xe901e84e, 0x4aadeb9a, 0x08dfbe90, 0xbe5b37cb, 
	0x6778a836, 0xec3debc8, 0x7caef2f2, 0x1c946f2c, 0x28b7901e, 0xca5f94bf, 
	0xb796cb72, 0x163817f8, 0xe247f8a7, 0x4e491386, 0xdcad6305, 0xab5e4927, 
	0xdbc8553c, 0x63fe25ea, 0xe2fe8cb9, 0x53c91ae6, 0xfa968fb5, 0x02d3fc32, 
	0xf2237ef6, 0x376f21ce, 0x82ba9bfb, 0x1ae893af, 0x06cfadf7, 0x16fbc396, 
	0x91097207, 0xb467cfb8, 0xd27e4a35, 0xb57b3734, 0x1e4a3598, 0x1bf15c12, 
	0x9cb6fb92, 0xc6e0782e, 0x00823335, 0xf891ae3f, 0xbcdf15e8, 0x39f3a7c6, 
	0xc7243dac, 0x8f241f68, 0xef25d45e, 0xe9e27acd, 0x8bd03eb0, 0xad6867bb, 
	0x05de1ad8, 0xfac17f54, 0xee5840e0, 0xe0e80fbb, 0xfd01743a, 0x76877fd0, 
	0xadd0379c, 0x48e034e1, 0x51e4776d, 0xf79febdf, 0x54df6c67, 0xbf7961fb, 
	0x846dc94a, 0x5d7796a7, 0x425fc527, 0x92a93055, 0x036051eb, 0x7d9e0bd1, 
	0xefe3d503, 0x54f9051d, 0xf774f6d7, 0x7e9179a3, 0x8d4ebefd, 0x7a6fb6e1, 
	0x68fa14f5, 0x8936896a, 0xdbf9f5e8, 0xcda47d0e, 0xbe71f861, 0x19fdfdbc, 
	0x872ad7df, 0x39f607d7, 0x886b3a6c, 0x5d91f7d1, 0xdf017acb, 0x6fd77f3d, 
	0xbfe163de, 0xae59f214, 0xedfc866e, 0x8bea870b, 0x73b7a5ba, 0x2fad8cdd, 
	0xf2b04c5e, 0x8c2f9f09, 0x2ec63f32, 0x7d4ad7a4, 0xf76b0be2, 0xc5f643dc, 
	0xa7d878a4, 0xd99d50f4, 0xda0bf4a8, 0xadb85733, 0xe38fc411, 0x3bbabe28, 
	0xff862f8c, 0x6cbe30c4, 0x067af5fc, 0xc7ad81d3, 0x852f6f19, 0xf67acee1, 
	0x5a7e308d, 0x981d546a, 0x4fad93c2, 0x4fa22f19, 0xbc5f1327, 0x06ed65b8, 
	0xadc3bbae, 0x92a9ff52, 0xf44bbf7b, 0x2632aa11, 0x498cde0b, 0xb53c5466, 
	0x687fe55f, 0x7e3bc5be, 0x1df931f5, 0xd76f591d, 0x5f719e50, 0x5b5f7fa2, 
	0x9c7f8f3c, 0x1b1865f7, 0xef8c9e08, 0xa4c78546, 0x8c6f1dbf, 0xbc6155af, 
	0x386de344, 0x6778d93c, 0x3f0a693c, 0x42be30fe, 0x8f0be6a9, 0x47e09c49, 
	0x5219cf54, 0xff45dff1, 0x898cc13c, 0xaa7f73d0, 0x53c2ff11, 0xa628e2a3, 
	0x92bffd83, 0xb3dd4a6a, 0xd28f29de, 0x7a51e53b, 0xef4a3ca7, 0x9de94794, 
	0x53bd28f2, 0xca77a51e, 0xea0ef523, 0x3d48f299, 0x3cb87283, 0x47970e4a, 
	0x13f461ca, 0x7d64ced8, 0xbbd87c8c, 0x2fbcb679, 0x861b6d9b, 0x4e2b920e, 
	0x415c0715, 0xc207ffb1, 0x28aeb4e7, 0xe580bf64, 0x139d3778, 0xd85d41f5, 
	0xb4e5b28e, 0xafcfe74d, 0xddafcdfe, 0xe3fd1527, 0x9697ef7a, 0x5c52b43a, 
	0xd6b3741f, 0xc980f647, 0xb231f37a, 0xbb8db013, 0x7dab9fd9, 0xf997df0f, 
	0x9e51aa6a, 0x81f6556e, 0x3dbdd95b, 0x09734a9b, 0xe05f6c8f, 0x7d7ba17c, 
	0x3a3e786b, 0xb421ee0f, 0x7a4b97d1, 0x478d3b60, 0xbb5a17b9, 0x62e89731, 
	0xc517d93b, 0xc79b9ed8, 0xe1ab747a, 0xc963d5cf, 0xa19e36de, 0xeb2fcc73, 
	0x7ee48fb9, 0x4b73eaef, 0x7ac0a3f4, 0x6d11e097, 0xb64d6c87, 0x5fb4d496, 
	0xf6f91ec0, 0xcf44a7e3, 0xc7d60e98, 0xed8fffe5, 0xe1836291, 0xc8f64f1a, 
	0x23d80bba, 0x7f6cb1fd, 0x89fb256d, 0xcad326fc, 0x651e7a95, 0x80f6d89f, 
	0xdc084382, 0x8b6c9f6c, 0xcf364fb6, 0x60c57406, 0xed933cdb, 0xc761908d, 
	0x9f6d2ecf, 0x884876d8, 0x888393ec, 0x2247b217, 0x7e1b3ded, 0x65117db6, 
	0x421db08f, 0xd70785fe, 0xf6463921, 0xdbb3e905, 0x70e13b9a, 0xf6a27d84, 
	0xf8e89cbf, 0xca76f0ec, 0x90976d5f, 0xbb4171dd, 0x2747f844, 0xe34fc5bb, 
	0x61169afc, 0x0fd90137, 0xa1e607e4, 0x4887e25d, 0xf227c47b, 0x997fec39, 
	0x223d94ab, 0xb27d2574, 0xec83fc4b, 0x906e7f96, 0x9593e878, 0x0dcc47e4, 
	0x87dd72d5, 0x7f23578a, 0xb70f7dca, 0x1998d1d1, 0xe4f7778e, 0x794c7fa4, 
	0x26574996, 0x02e9ae65, 0x53089258, 0x99dea276, 0x23f8df3f, 0xf85f49c5, 
	0xa5a5fe1c, 0xac27db0d, 0xf3ccbdaf, 0x0842c71b, 0x93d325d7, 0x04b32f38, 
	0xf1b7dc9f, 0xba35e3e2, 0x2663830f, 0x9f2f397f, 0xa5fee0f4, 0xa81f1cd9, 
	0x5f9f992b, 0x17edba8c, 0xc1ccd368, 0x4c2fec7d, 0x3b2f9a02, 0x2f2f5a0f, 
	0xcfe1b965, 0x2ddf819f, 0xe1e446d6, 0x603db3b9, 0xfd3d23e5, 0xc97bc71c, 
	0x541ab93f, 0xabf5703d, 0x9d38c014, 0x744abe6c, 0x73f29637, 0xbb4e6f28, 
	0x7c46ddce, 0x2a736e0f, 0xaaac79c1, 0x7fdf995f, 0x9e64526d, 0xe1e52c61, 
	0x241f657a, 0x2bd44cdf, 0x3efe4fb4, 0xb53de86f, 0xd60f73c5, 0x43523d52, 
	0x7a439582, 0x9bb9ac05, 0x1a8e0ed9, 0xddf2dcf7, 0x447b6133, 0x5cec71dd, 
	0x2d56c7a9, 0x5fc83dc7, 0x4df2344c, 0x534e6bb4, 0xffcf04dc, 0x3711da21, 
	0x56593ea1, 0xfb96ad6d, 0x10d7a808, 0x95a8bf5f, 0xe365f0ba, 0x7dd25ffc, 
	0xf019fd94, 0x534f63fa, 0x95ee7adb, 0x7e916c0e, 0xf7ecef48, 0x378263f8, 
	0x2a35eb60, 0xee1051ea, 0x6cbeb3cf, 0x7378ba12, 0xfba1e1db, 0x58013e78, 
	0x8079f23f, 0xcdad89ee, 0x827d38e7, 0x79a4d339, 0x87f67e0b, 0xe5fbe49b, 
	0xfa1bcd8f, 0x5c7eddbd, 0xfbb3f02b, 0x5f38a90d, 0xbc71d0e3, 0xf3c0ffce, 
	0xf7abeb21, 0x5c7d562f, 0x6e5d75cb, 0x3bf21eeb, 0xbae0f4d0, 0x916a14c3, 
	0x328f16be, 0x48bc918f, 0x968ff103, 0x5a7af34d, 0xf3ff330e, 0xce658d3d, 
	0x5d43e7d5, 0xf8f87704, 0xef5ff475, 0x28685684, 0xb6c0fc26, 0x1ce7686d, 
	0x52d7f50a, 0x858c1d9e, 0x68bbd91a, 0xfd1077cf, 0x45fd0a1c, 0xe42f179e, 
	0xfcfd85b8, 0x81547c4e, 0x1bbc6272, 0x9e7a4227, 0xf92ef1e1, 0xb5714ea3, 
	0x62b7a6d6, 0x1d224600, 0x7967ee7a, 0x3bdcab70, 0x9ec992b1, 0x71f5544e, 
	0x23d8ba89, 0x3ebb4199, 0x741c15ce, 0xebb7478f, 0xf88d0d8b, 0xdf91c69c, 
	0xce2e6cb2, 0xb483cb6c, 0x36581cb0, 0xfe218cda, 0x6e1a3658, 0x4850a00d, 
	0x7eb37554, 0xf14c9c38, 0x6bfefa3c, 0x76627df8, 0xe10ea3b7, 0xcb83e890, 
	0x89dfc882, 0x876b86a9, 0x132e83c8, 0xf1a46f9f, 0xa5b2be78, 0x8fc4c99d, 
	0xe475aaa5, 0xfdd25f22, 0x218ccd00, 0x90589a39, 0x43f620be, 0xa667cf5c, 
	0x5a84fcb6, 0xae235d7f, 0x201becb3, 0xa8592afb, 0x35782b35, 0x41b97ce3, 
	0x0a1d57c9, 0x233ebfe1, 0x4150e9f8, 0xb8e296e3, 0x3cb8f096, 0xe347d71a, 
	0xcb1e18f2, 0x771ce552, 0x38fae166, 0xaf7bf4fc, 0x37591abf, 0x9a13ba7e, 
	0x395ca00e, 0x744d06dd, 0x7ff7abcf, 0xbb24cdb5, 0xe9cbc6dd, 0x021fe36c, 
	0x7e189f7c, 0x9f6dfc4d, 0x9d23cee3, 0x3668170c, 0x7c6e0853, 0xa413c61e, 
	0x56f6901f, 0xf32fcb8a, 0x02cb5241, 0x776b5b6a, 0x63f786d4, 0xde3037cf, 
	0x28979482, 0x290ad64e, 0xb6f8112d, 0x8b91c4e9, 0xc0ad6976, 0xd152782f, 
	0x3f83d105, 0x8428c16d, 0x8941ade3, 0xfa222d2b, 0xe256a328, 0x92829b32, 
	0xfa7ebf1f, 0xf541c18d, 0x41f45193, 0xb3de28e3, 0x17adee6c, 0xe2148fa3, 
	0xca06358f, 0x1693b403, 0xb45e8825, 0x9834e5e9, 0xc126079c, 0x4cef7547, 
	0x7f652737, 0x526e57e4, 0xdd945978, 0x1f37509a, 0x10741f5b, 0x354a2cfd, 
	0x7e95eab3, 0x3feb7d20, 0x8b3632d0, 0x54236eed, 0xca13d369, 0xdd6a4da5, 
	0xfe2264d3, 0x549d7853, 0x4543ff9a, 0x7bc7886f, 0xef2d5c68, 0x971c8f47, 
	0xaa95c6ac, 0x8c0f7771, 0xd88a4243, 0xadc687b7, 0x207bd947, 0x43f0e593, 
	0x0831efb8, 0x7e889bbf, 0xa5bebe90, 0x1d3443f4, 0xbd233cdd, 0xe6fee889, 
	0xcedc9983, 0x20f5291f, 0x3d2177bd, 0xb23a6169, 0xcdfa0ae9, 0x9be7ac99, 
	0x0b7599cd, 0x3d3978c3, 0x9429fbe3, 0xf3e65fef, 0x2f999bba, 0xb89d988c, 
	0xcc3365b7, 0x23d40199, 0xfaec13a7, 0xe9992b27, 0x3a68efc6, 0x66c27640, 
	0x93a5e533, 0xca017f32, 0xcfb81db5, 0xa977dc0c, 0xf083f421, 0x538e07fc, 
	0x8d6a17f8, 0x911a5f8a, 0xc505b72f, 0xda14396f, 0xf4c2fcc6, 0x3f9233bd, 
	0xebf425c1, 0x806ef8ad, 0xfd6aa3f2, 0xb77cc1b2, 0x773f8073, 0x45dd9d32, 
	0x4c3bbdf0, 0x61f4d1b7, 0x43c305d3, 0x3f92b0ea, 0x6c849a43, 0x5597eb63, 
	0xa7f73f14, 0xf5c19c92, 0x2c476403, 0x94d359f3, 0x3d58d99c, 0xa0f3ee9f, 
	0xe480f91c, 0x3fa6bc78, 0x898f143b, 0xf18f5917, 0x9bcf12fb, 0x79fc22d1, 
	0xa1b6f6f7, 0xb3601ff7, 0xa143ebc8, 0x7e49041f, 0x7edb72db, 0x0a1c67df, 
	0x0f991fc2, 0x7ffe282b, 0xc229f113, 0x6335f9e5, 0x147ca55f, 0x3df1a5f9, 
	0xfc5267e2, 0xd24bfc97, 0x9af991cb, 0x0f253ea6, 0x3712bbf0, 0xf9c01ea4, 
	0xb32a06a9, 0xa3aa5a5c, 0xde5b365c, 0xf16a7e93, 0xbb59bccb, 0xbf66be65, 
	0x43819fcc, 0x2c7d50ff, 0xb1fbc058, 0x12d4bf56, 0x03f69efe, 0x07f61199, 
	0xa8689e48, 0x64fbe29d, 0xf30fba8c, 0xff30e1d8, 0x065a79f3, 0x7efb4f7f, 
	0x5fe656a9, 0x6a9e6b1c, 0xfbf17cda, 0xb17b764a, 0xbd64747d, 0x3ed774c3, 
	0xa7892c0a, 0xb1015919, 0x9fc8b34f, 0xfb57bd37, 0x53b60e48, 0x84f3997c, 
	0xd7ec8396, 0x5d5ce2c6, 0x75c0afc5, 0xd8abdd25, 0x77f28bb4, 0x5d9ef7ba, 
	0xebd7ff54, 0xdc15f891, 0xe019816d, 0x5d70c6e5, 0xe2f18ecb, 0x0e6464cf, 
	0x2c6ca78a, 0x767a914e, 0x1e430f15, 0xcbecf896, 0x615f550e, 0x6052ffb0, 
	0xacbfe26a, 0xbf65e59b, 0x93f018c1, 0x6b72ce63, 0xbe939cc6, 0x9aebc5de, 
	0xbeb29bfa, 0x9df498f3, 0xf1110227, 0xb6ba88b3, 0xfed9ea61, 0x6cedea47, 
	0xdd541d3f, 0x576dd95d, 0x1a3d9165, 0x2972ba34, 0x4e3ed06f, 0x8e95f1f4, 
	0x944159c3, 0x35531b5f, 0xca2b7c77, 0x2b333cd9, 0x37df2e94, 0xea371e22, 
	0xf2325cb6, 0xc3330eb9, 0xdffbe7ca, 0x718c7fed, 0x9f3adc23, 0xcb70ce9d, 
	0xaefa93ae, 0x7fc75f71, 0x90d89ca1, 0x92056660, 0xd47d15a8, 0xf9e7fd7e, 
	0x7e692719, 0x67f27b43, 0xe4601654, 0xe53f2867, 0x377d1f40, 0x7ff38eb1, 
	0xc3ae7efe, 0x60ccb7f2, 0x4c7ed8fc, 0x21e4ba7b, 0x3c93ab2e, 0x94d6477f, 
	0xfb2fa23a, 0x4693bd9c, 0x8d4fc979, 0x3c1b305b, 0x8febd294, 0x3dfe22cd, 
	0x3c3cbc11, 0x1f5bbf0e, 0xa07448ec, 0xceaf5d1e, 0x7ba2fb45, 0x1e7c2ed9, 
	0x2ae3348f, 0xc8ddf230, 0xe7038517, 0x1d7d9429, 0x75f78779, 0x78535fe6, 
	0x7708935f, 0xd165c768, 0x8ff41e3d, 0xf88117da, 0x08fe8061, 0x13aa2fbe, 
	0x25ddadfb, 0x559e9e70, 0x60f54754, 0xf29f5dfc, 0xf15fd063, 0x79eea506, 
	0x2ff8b16c, 0x749d5463, 0xa357d516, 0x7556c99c, 0x57d1e39a, 0x3f947bd1, 
	0xbf122333, 0xdd174246, 0xbe2dd147, 0xceaa92b7, 0xbee0aa97, 0x0674cda4, 
	0xae2cfe51, 0x35203b13, 0x6fcfbed5, 0xbe9f293a, 0x5bdf13a4, 0x0fa3f1e1, 
	0x7cef7c18, 0x23f89d69, 0x484d904b, 0xaadf81fe, 0x4ee17b26, 0x15f54e7a, 
	0xbe6aad4b, 0xe8860bff, 0xd33c736d, 0xafcdee81, 0x56bcbae6, 0xb1f93547, 
	0x54972fa9, 0xa919fa03, 0x26a9e6ff, 0x77dec97f, 0xd747ab5a, 0xbef71f50, 
	0xbf65e850, 0x8cdf807c, 0x101df92c, 0x097d6f99, 0xf0faeff2, 0xc64beb77, 
	0x068b77c8, 0x4ee4e9f3, 0x1ce29aa3, 0xcfa033e3, 0x6d387a81, 0x5db3542e, 
	0x7953208a, 0x5147c502, 0xf936e6fc, 0x5be7b4bb, 0x349c52b7, 0xd5e3d9ed, 
	0xeed89599, 0xd07df0f5, 0xebe7ba74, 0xe801ff61, 0x5e48069c, 0x72d5bd2f, 
	0x8cbd2016, 0x49ab378e, 0x13a96cac, 0xc2a0fef9, 0x4b97e8ef, 0x4acfc89a, 
	0xe946060d, 0xd68e32dd, 0x24774879, 0x6ff97dd2, 0xa048e53d, 0x4fcd837a, 
	0xf8a08c56, 0xeb4ee4c2, 0x64bf7a1d, 0x88778ed7, 0xb04caf3f, 0x715d92c6, 
	0x1c62b06b, 0x70df17f5, 0xec6a5c6e, 0x37ffcf5f, 0xb1d635d5, 0x7ff8a7bd, 
	0xfc95bff4, 0xbbb3f79a, 0xebdd0575, 0x51dac8eb, 0xbe6e7ac7, 0x8e69ef77, 
	0x0f7c5ae7, 0xc836ecac, 0x7abe200a, 0x9792dcf3, 0x556b3946, 0x9ab77e72, 
	0x9274beec, 0x36a764cb, 0x7886bda2, 0xd8c7a732, 0x0e984df7, 0x9efca6dc, 
	0x36816f4b, 0xf8db0e48, 0xf5a0a473, 0xb1e78ab3, 0x97257e5c, 0x089ed892, 
	0x3a11fa44, 0x27df0dc1, 0x620b3d7a, 0x3da00f49, 0xb2fe415b, 0xfa4dbc65, 
	0x4a927100, 0x265dd6f7, 0x8c1f72e4, 0xbc8fca5c, 0x5b712757, 0x737d40c8, 
	0x5f7f9c32, 0xb9f62d9f, 0xa085e2ae, 0x3f9ce2f2, 0x0d38662f, 0x8371d396, 
	0x5bf074e5, 0x774ee51f, 0xf34ebc03, 0x6be70d9f, 0x714d9f38, 0x82f8371f, 
	0x8f8aaf44, 0x36e5a042, 0x6dca9e52, 0x89ffc8f8, 0xb3fe17ad, 0xbf9cfbf3, 
	0x263e40bf, 0x51603f22, 0x4f3a299c, 0x93f2f9c4, 0x1cf9f283, 0xbaa56de7, 
	0xfd2b8902, 0x58f9f955, 0x3ff87fdd, 0x6feb4f71, 0xb67beff0, 0x2de1e89e, 
	0x81b02f45, 0xebde6bc6, 0xce7be93a, 0x73aa642b, 0xcb2b7ca1, 0x6420fa46, 
	0x25ddcf16, 0x5ddccafe, 0xbf5b0784, 0xbb7ddee8, 0xea6bff08, 0xd17cf24e, 
	0x8dc378fa, 0x7445dbdf, 0xa6c6feb4, 0xbe4221b7, 0xa8d01eeb, 0x155a118e, 
	0xc60ccd7e, 0xa4f5e327, 0x5ffa87e0, 0xaf85f8d8, 0xeebb5f8a, 0x28ef88e1, 
	0x3c4c6baf, 0xce0e792e, 0xc45eb21f, 0x9eaa2c73, 0x8855ccf0, 0x24ead7e7, 
	0x41d762bf, 0x2a177e30, 0x1d09377c, 0xe7479f10, 0x5e661d01, 0x98d7baae, 
	0x7953f0cb, 0xa3938e41, 0x6a919f7c, 0xe2ae75dc, 0x1706f402, 0xce9b37a6, 
	0x14d89f38, 0xce173f49, 0x3f470de7, 0xfa488e74, 0xfbd6dcd1, 0xc81f0614, 
	0x3f470e03, 0xa01fa44e, 0xff8718fd, 0x37be9aa3, 0x3d4b4fd3, 0xef04c7fb, 
	0xe32d37f5, 0xc8ea51df, 0xfe13d6f2, 0xef7fbadd, 0xf343f17b, 0x9e9d5f53, 
	0x0abfebf2, 0x591cb13d, 0xcfcae4a5, 0x15591c94, 0x7855af91, 0x3750f9b3, 
	0xdd1c70a7, 0x3ad0ef86, 0x33b3891a, 0x50bc953e, 0xe6eea5e3, 0x8aee7002, 
	0x213c84bb, 0xf81bfb7a, 0xb1abaed6, 0xdbb0b0f3, 0x7d6ce7ba, 0xb7ccce18, 
	0x3775c2ab, 0x6474fd36, 0xd9f8662d, 0x23966979, 0xb07e4a71, 0xef59371e, 
	0x7a501e1a, 0xb45d9efc, 0x074fc61f, 0x3d597fc1, 0xf0d14bf9, 0xee66df5f, 
	0xf881bd12, 0xefe1840a, 0x4f515ba9, 0xb47ad776, 0x6dcf492b, 0x40e4bb20, 
	0xd25c1ed8, 0xe20aed66, 0x25eb6b5a, 0xc061b57e, 0xded8b12e, 0xef89d25f, 
	0x169db08d, 0x6a7b17a8, 0x8e14d2df, 0xb341672f, 0xeee455ab, 0xe4eae786, 
	0xbf7c14fd, 0xf8a4e701, 0xf10c86d1, 0xe53f6cdb, 0x0fe2f5db, 0xe45ea77f, 
	0x8cb706c7, 0x7b17adab, 0x3fdd4372, 0xbadd93d6, 0x284a1124, 0x7ae4b189, 
	0x3dd51763, 0xca1a79d2, 0x496bfac3, 0xbb473c8d, 0x6f7ba0cf, 0x438db04b, 
	0x0918ccfb, 0x23f9e873, 0xead39f6a, 0x29b43e45, 0x493ed139, 0xd42b1dea, 
	0x805d467a, 0xde86bbd7, 0x60199db3, 0x1fc940fc, 0xd635bfd9, 0x927f8815, 
	0xc938f721, 0xc7fca54e, 0xc837afb8, 0xe73fa5b8, 0x8ddfcb71, 0x2e5771e5, 
	0xa8afb79a, 0x1cff0c3e, 0x7e2e36ba, 0xfc57ab89, 0xd2b3d894, 0x1fbf558f, 
	0x0a6a3c15, 0xfbf62ffe, 0x3ef27d50, 0x56c3c246, 0x19dfc58c, 0xfb8d11fa, 
	0x3be951fa, 0xdbbf738f, 0x3f847629, 0x120af49f, 0xea4b5ee8, 0x888ef3c8, 
	0x1477917d, 0xb667affb, 0x98c1fec9, 0x4f9e5c72, 0x8c117b61, 0x137df6c9, 
	0x4f3b27a2, 0xe979510d, 0xcebb00f3, 0x869d51c5, 0x3cdd7b75, 0xdfe0d7ae, 
	0x997769e3, 0xb601705a, 0x98f9a689, 0x5ed6f0c9, 0x56a2fea2, 0xdc101b73, 
	0x8b75965e, 0xbe3b67df, 0x1ce85ebe, 0x39fe463c, 0x7515c7dc, 0x5e3e31af, 
	0x2c7c17ab, 0xe98d7faf, 0xa18feed7, 0x091b3dfb, 0x0f9f835f, 0x2c0a3bf1, 
	0x895ce58b, 0x8975c1c7, 0x9f58b041, 0xbcc40642, 0x0112f24f, 0x3655f48d, 
	0xfba0cd7f, 0xcd9de61f, 0x8fb94550, 0x9fbeea05, 0x9e0da681, 0x8c113bd3, 
	0x75a3a926, 0x958d7e29, 0xfec79dfc, 0xfc01bcdd, 0xd71b63f6, 0x080a7520, 
	0xd44ed8d7, 0xa1b5b733, 0x08facfe5, 0x3bdfa926, 0xe79f741a, 0x98c731be, 
	0x3eea21af, 0x6fd6475e, 0xf1e239e5, 0xe509e12c, 0xdb527fcb, 0x3c881b1f, 
	0xf3bfed9f, 0xb0e226f9, 0xe00557c5, 0x6ee73aa4, 0x0dbb4b6c, 0xaf9c3b0a, 
	0xad0af557, 0x3bf2019d, 0x900fafd0, 0x7e7dd73e, 0x4fb2e293, 0x8204675d, 
	0x58ee8447, 0x08af7a0e, 0x947d5d70, 0x30f2cfbf, 0xeb0f4e42, 0x2bc947cf, 
	0xe13b3fb4, 0x436e5864, 0xe74e9f84, 0xad5c2732, 0xaf1773f2, 0x5ee4b493, 
	0x6def45d6, 0x3db63cd1, 0x612d4fa1, 0x67714078, 0x9a0efd40, 0xca5fc836, 
	0x87cd40f3, 0x3fa216d8, 0xd3d121f4, 0xd7a87f60, 0xaa5fe754, 0xf491a5f2, 
	0xf2defe82, 0x3d32dfec, 0x230718ae, 0xfcc9ef02, 0x1534ceb4, 0x2ef967e7, 
	0xbf53477a, 0xbf55e75b, 0x65ecc18f, 0xc7dc0c34, 0x950f7c54, 0x5f349e48, 
	0xe8a7e503, 0xf5e521de, 0xb8a03bf1, 0x7d06b617, 0xe908f74f, 0x4f7d2fbe, 
	0xb591e9f1, 0xf7f9cfda, 0x1f703359, 0xc8655762, 0x08c0b6ef, 0x5ead5dfa, 
	0x6309fc4b, 0x1631e09d, 0x778f7cbc, 0xc89fd84d, 0xe30eba60, 0x64e08331, 
	0x9fe5d1e3, 0xbb17bfc0, 0x8056f086, 0x18cf1df3, 0xb6a4f76c, 0xfef9b867, 
	0xeebf7da2, 0xe59571d2, 0x4698d6b1, 0x5c799f19, 0x6ecc97ec, 0x33ac8d6e, 
	0x16eacfd2, 0xf74dfebc, 0x5c20e6ef, 0xec155f38, 0x0539f09c, 0x4762fae3, 
	0x6e481c90, 0xc91df8ca, 0x8eadf3f1, 0x779e7e06, 0x1f7a22c4, 0x17de1790, 
	0xdb949ef9, 0xe5d67894, 0xf13a4965, 0x1917f307, 0x93ca265e, 0x10bf8a55, 
	0xcd0fbd0f, 0x5bb83f14, 0xa0bddaf2, 0x19b4bce0, 0x83a47c3d, 0x672255d2, 
	0x68dd09d6, 0x10554748, 0xd68567d6, 0x27e2549c, 0x9a1e63d4, 0xd582096f, 
	0x0f8e1bd9, 0x222b2a11, 0xdfddf1ee, 0x15917120, 0x74d5ef0a, 0xe637964e, 
	0x7c996f6d, 0x4f3a1cfe, 0x0e55715d, 0xc95d7fd1, 0xacec8d1c, 0x668741a9, 
	0xfba1f65f, 0x5ce0ce4b, 0x8f77e3ee, 0x6dfdc11f, 0x313c9068, 0xae383285, 
	0xfea431ed, 0xa39ccc0e, 0x56df542d, 0x28d85395, 0xfae095eb, 0x7ef75a01, 
	0xe64b8ff4, 0xc15c50e4, 0x43fe8dd9, 0xe677cc92, 0xe1ff7ca4, 0x328fb21b, 
	0xdfad4fec, 0x0e7fb8f1, 0xf9df8dce, 0x729c77e5, 0x79aa64ce, 0x1fdd54fa, 
	0xb829e7ea, 0xc092774f, 0xda9f7b67, 0xd6ff9e2f, 0x315a39e2, 0xe70533ce, 
	0x4df62231, 0xbbdd51f3, 0xef0af293, 0x507e9e93, 0xeafaff23, 0xb399dc1f, 
	0xa070e094, 0x87696725, 0x72cefbec, 0xcf7f879e, 0xf843ce8e, 0xd157b01a, 
	0xd6bc25bf, 0x94399b75, 0x846e862f, 0x3f1e4463, 0x3728bc74, 0xc36daf32, 
	0x0bf54431, 0x4fef8a31, 0xa2459d52, 0x70b1ee9f, 0x1ff620bd, 0xb359af07, 
	0xb1f0c90e, 0xdd0b732f, 0xae44cebc, 0x06f5504b, 0x82401d36, 0x23f93ef1, 
	0xe407f40e, 0x3960e85e, 0x3e7df485, 0x4bebee52, 0x3aae39b3, 0x0eaa9740, 
	0x4cbf2f41, 0x3613fba7, 0xdca0667d, 0x8a53dfa0, 0xdd196b96, 0xc4772e45, 
	0x5f363279, 0x0aefa837, 0x71c0dea1, 0x8478ef7b, 0x63ce03f5, 0xd50cf724, 
	0x7b0d3597, 0xdb6f481b, 0xda3703f1, 0x243dae98, 0x83e5806f, 0x5b07c943, 
	0x04f1d85f, 0xe3672f92, 0x53517eb8, 0x881b7075, 0x9e3d7ade, 0xb6e67541, 
	0xe47b609e, 0xe325c300, 0xb7c88d48, 0x8fc8c3a3, 0xc8f241be, 0x93f5231a, 
	0xc0abf697, 0x5fdf651b, 0x85f3bee0, 0xddb2f3ea, 0xffb27cfe, 0x368eb23b, 
	0x1476de90, 0x3d127624, 0xadff7e5c, 0xd0a161c7, 0x9ebd546b, 0xe8dc4016, 
	0xfdb7af54, 0x7bd7afaf, 0x0344e1bc, 0x310d51d9, 0x7fe6807a, 0x1ef329e1, 
	0xdfd3c3aa, 0xbea3deb3, 0x59f7975d, 0x978c3bd1, 0xe5de1bc7, 0x6effb336, 
	0x281d6457, 0xf74fc3a2, 0x7e4133a4, 0xe4032897, 0x482674de, 0x8d42737c, 
	0x4cfae016, 0x97d50884, 0x31f0de3d, 0x0a29eb9f, 0x56b8cbc4, 0x0dde371a, 
	0x33a114fe, 0x81aeddfe, 0x8ad6987a, 0xf47e587b, 0x9db47ed7, 0xdf4f8ded, 
	0xd3eebd23, 0xd6df0a5d, 0xaceba25e, 0xed1efc0c, 0x241bcfba, 0xb464b33e, 
	0x49644efc, 0x230de7c3, 0xdd71533e, 0x36e38934, 0x07f6113d, 0x5e4513da, 
	0xdee484a4, 0xce0dca32, 0xa39fe22b, 0x477ffc5b, 0xd1ddc0b7, 0x72d07acd, 
	0xdf21bf74, 0x71e7299f, 0x19669fec, 0x74c6d687, 0x3b01f8f3, 0xd3deabfb, 
	0xb91ece1e, 0x39f23dd0, 0xdf756fb8, 0x919f4065, 0x08a4be1d, 0x79ea42e9, 
	0x67a31f39, 0x3c293aab, 0x1c23b28f, 0x3feca6bd, 0x55f22f2a, 0xa57ff1ef, 
	0x210dc7bc, 0x890e3f65, 0x3cdca27f, 0xf9007e29, 0xa3cabaa9, 0xfc92155e, 
	0x970d6dee, 0x723ec887, 0x21a786ea, 0xe0695ea2, 0xbf6dba77, 0x8b65e493, 
	0xea8ea7e0, 0xd83e082e, 0x2c696ade, 0xa3baedd7, 0x805dfa6c, 0x346f5552, 
	0xd1bd6863, 0x7fcefc5c, 0x3d0bf956, 0xf1c4d752, 0xa2e0337c, 0xab1801df, 
	0xf388077e, 0x89deb804, 0xbfbcb986, 0x67a2e3ba, 0xe66b4ff0, 0x95398838, 
	0x4f0806ea, 0x9e3ee257, 0x7c08406b, 0xee9f3e16, 0xf4526803, 0x618fbf26, 
	0x7977e438, 0x51c7074d, 0xdec8de90, 0x1e50f3a7, 0xd40be6c7, 0xa7f11aeb, 
	0x874c17cd, 0x62bcd50b, 0xbf28c62f, 0x45ebc6c2, 0x7e5be77e, 0x7e060167, 
	0x7bccd01f, 0x72985b93, 0x4e53fa4c, 0x0bfecbd4, 0x1f88ce88, 0xf990f823, 
	0xddf8990f, 0xc8a1d586, 0x5fd20cfc, 0x379ff107, 0x3e20ef56, 0xd7bf425d, 
	0xa3f25bb0, 0x11e3e7c4, 0x97e7c4ae, 0x29e20797, 0x6ffc8b1f, 0xef9c20a4, 
	0x6f5f890b, 0xcbcb8dcb, 0x5e3244b5, 0x2a942e58, 0xc1f24139, 0xbca48c6d, 
	0xbaa73d10, 0x930f3b30, 0xc1ef7ead, 0xa31b23ae, 0x1a28f77e, 0xccbeb6bf, 
	0x60f3bf56, 0xbf1863e7, 0x33386129, 0x70c2391f, 0x0339f3b6, 0x89f25670, 
	0x507481e1, 0xc1fc921d, 0xc32d509a, 0xafe896a3, 0xc51ff15c, 0xfbf2bc4b, 
	0x04378f14, 0x7fa47df9, 0x0afc9e6e, 0xfc90d0fe, 0xaf7f69a9, 0xe24b21fc, 
	0x525eb666, 0xbc1392fe, 0x6c8fa2b9, 0xcbdff4b9, 0xfaf943df, 0x767746bf, 
	0x81ef8d7c, 0x43be9075, 0xea15f4bd, 0xd47a6dd2, 0xae965d55, 0x90ac6aea, 
	0x6af5975d, 0x597552e8, 0xb2ea4e34, 0xa8175ff0, 0xee3539bb, 0x2fca01eb, 
	0xe2d639e9, 0xfe70d6aa, 0xc3dfa75c, 0x5676fe44, 0x19a07683, 0x0ad05cdb, 
	0x117e009a, 0x670fba92, 0x1973fa17, 0x422237e4, 0x4fe89e51, 0x2f75e23a, 
	0x95b27ee2, 0x9c52629f, 0x9eb217e3, 0xe71c57fb, 0xa9dd26b8, 0xd79279e2, 
	0xe165f1e3, 0x9215bcf3, 0x29dfa23a, 0x1bd3607d, 0x48041778, 0x95dd308e, 
	0xfb63beb2, 0x89d1f894, 0xf55747b2, 0x082c600d, 0xb50be9a0, 0x9942efc6, 
	0xbe025d9f, 0x127ce3d8, 0xcd155d88, 0xfe69ce77, 0xdaf78a54, 0x5fcce7fc, 
	0x67f08c7a, 0x3e68d1cb, 0x21ff20bc, 0xcbcd6e3c, 0x9c7fffe3, 0x60883ae8, 
	0x9f9653e8, 0x45ee1c76, 0xf7b45715, 0xf890e7f7, 0xc4865f35, 0xfefe89af, 
	0xf99fc344, 0xefe7e8fb, 0x12197c36, 0xdc2fe73b, 0x1b5c553a, 0xd49f2ebc, 
	0xe2baaae3, 0x762ba902, 0x959cb6ea, 0xe7dd077a, 0xf922d52d, 0xc8925d17, 
	0x375db2b8, 0x4ba3f36c, 0x5f3321d5, 0xee413c4a, 0x7e1179d7, 0x39cfee7e, 
	0xc77f0eeb, 0x2efa0d71, 0x2f552c06, 0xddf253e4, 0x7579df27, 0x6537bbfb, 
	0x219f1cbf, 0xfc50be7e, 0x02f93865, 0xd1b99eaa, 0x79a3eadb, 0xc32fe3a3, 
	0x7f0187c9, 0xe609c944, 0xe3e1cce3, 0xb6d93999, 0x926e0f1d, 0xd63c76ab, 
	0x5b75efc6, 0xadd83f45, 0x57ef8691, 0xfd067f2b, 0x03f7b405, 0x00826792, 
	0x1fad51e9, 0xa3c4640d, 0xf3f258b7, 0xf24caf54, 0x199afd9b, 0x7a267f12, 
	0x7c09598b, 0x389bf331, 0xadfbfb2f, 0x943f8c15, 0x9abf1ceb, 0x1ad6839c, 
	0xa4d6a5fb, 0xcbc371b3, 0x3731e6af, 0x9c78956c, 0xbf3b31c8, 0x88bbbe37, 
	0xda7a04f3, 0x33cbefc0, 0x6e7f697e, 0x754dff55, 0x8a4fb435, 0x2ade2ccf, 
	0xdce7cc74, 0x5275cea1, 0x308df39d, 0x77f6065c, 0x4f5c7064, 0x71205e9f, 
	0x03d7153c, 0x0a7125b7, 0x1510ee3b, 0x684bfa97, 0x013bef05, 0x23ca171d, 
	0xe48f5c71, 0x9e63f78d, 0x2e118a17, 0x8e0ccfe2, 0x387a157f, 0xa817afbf, 
	0xf8e8807a, 0xebbc5457, 0x776b89af, 0xf45e1d0b, 0x8e2c8b77, 0x4b8e0f3b, 
	0xdc1fb33b, 0x74b8a17a, 0x91d72d9d, 0xe383ddee, 0x44770e53, 0xd6c76a7c, 
	0xe78ddf81, 0xafcda5f8, 0xe197e243, 0x99e4a3f8, 0xf087f086, 0x8b1f5873, 
	0x297ae5be, 0x7c54f3b1, 0xbbd36ff2, 0x514e8887, 0xe96f07ce, 0xe4c27dcc, 
	0xd9008d7a, 0xf5037561, 0x99cf8387, 0x84657641, 0xfb03f93d, 0x7c1fb49c, 
	0xe52e2eee, 0xc571977b, 0x33a5dfa5, 0xd15b75d8, 0xf62c6ee7, 0x17719cb1, 
	0xbd50e6fb, 0xeef15c43, 0xae78d567, 0xa7121acb, 0xc6de7155, 0x472cdde2, 
	0x303e3fc8, 0xdbfa2fc8, 0x3683a1fc, 0x69c5469f, 0xc32e78a1, 0xe5a55a01, 
	0x25e733f8, 0x1eb22d4c, 0xdf95e5c5, 0x413e6255, 0xf3cae0b9, 0xd9cf8e0c, 
	0x4f9b71f1, 0x541c2eae, 0x154fa2a7, 0x8a7e62be, 0xfa47ca1b, 0x7951bf3a, 
	0x319fba01, 0xf55ba7fd, 0x7ffb70f2, 0x3af2ac01, 0x00000090, 0x00023822, 
	0xffffffff, 0x00007f86, 0x00000020, 0x001e32b5, 0x001e393c, 0x00000030, 
	0x001e362d, 0x001e37c6, 0x00123a81, 0x00000070, 0x001e37c6, 0x001e9d1f, 
	0x001e30b7, 0x001e3072, 0x001e3086, 0x001e374b, 0x001e309a, 0x00000020, 
	0x001e373b, 0x00001c8d, 0x00000020, 0x001e3dbe, 0x001e3d66, 0x00000060, 
	0x000298ad, 0x00029304, 0x001e9bae, 0x00129128, 0x00029295, 0x00029295, 
	0x00000020, 0x00029a10, 0x000299e2, 0x00000020, 0x000405b7, 0x0004102c, 
	0x00000030, 0x00040fea, 0x000410b0, 0x0004102c, 0x00000030, 0x00040fea, 
	0x00040feb, 0x00040feb, 0x00000030, 0x00040fea, 0x0004111e, 0x0004102c, 
	0x00000020, 0x000612a8, 0x000613ee, 0x00000030, 0x00085522, 0x00126ffc, 
	0x00087aef, 0x00000020, 0x00126ffc, 0x00127a5a, 0x00000030, 0x000a8e42, 
	0x000a90bd, 0x000a9099, 0x00000020, 0x000c8d26, 0x000c8ac3, 0x00000030, 
	0x0012814b, 0x000c8a8c, 0x000c8ac3, 0x00000070, 0x0012814b, 0x000c46fa, 
	0x000c8ac3, 0x000c46fa, 0x0012814b, 0x000c8d67, 0x000c8ac3, 0x00000030, 
	0x0012814b, 0x00128b0a, 0x00128b0a, 0x00000030, 0x0012814b, 0x00127f54, 
	0x00127f54, 0x00000060, 0x0001000a, 0x00032a08, 0x5d83924e, 0x00000000, 
	0x010201fe, 0x00400804, 0x00000020, 0x01560008, 0x00000018, 0x000000e0, 
	0xffffffdf, 0x00000fff, 0xc3fc81e1, 0x00000fff, 0xf7003ff3, 0x00000fff, 
	0x9ffc00ff, 0x00000fff, 0xee000003, 0x00000fff, 0xfefff003, 0x00000fff, 
	0xee000003, 0x00000fff, 0x00010012, 0x001e25f2, 0x0003f411, 0x7dcd9c78, 
	0xe554780b, 0x673bf79d, 0x999ccce6, 0x9849924c, 0x300804cc, 0x05220124, 
	0xaa62951d, 0x08b84f54, 0xa22356ba, 0x275dd6a6, 0xd15a2d28, 0x2d06c100, 
	0x61726678, 0xe1261022, 0xa237ea2e, 0xdd9f4456, 0xd6b2d488, 0x57170f5d, 
	0xc5bf6ddc, 0x7b5d2aea, 0xb5968a09, 0x65d47ed9, 0xfa7eba2d, 0xf7ff7ffd, 
	0x0249993d, 0x9f4f7eea, 0x3cf2f9ef, 0xcb9ef2fa, 0x6fdff97b, 0x3fcf99ef, 
	0x8ef3fcff, 0x98e885fb, 0x939e12e0, 0x1084b842, 0xe7f4b516, 0x58d0b7ee, 
	0x15dc53ee, 0x68d2a755, 0x13bb2aec, 0xd87d59ad, 0x4fe8c42f, 0x0b59715f, 
	0x45b57af9, 0xade67dd7, 0x5a167a46, 0x5747d8b7, 0x3a59a17d, 0x6faa43f7, 
	0xb9e9ddb8, 0x7954d6d4, 0x9f1fa1d6, 0x42bf4be5, 0xb3dbbd6d, 0x83fafd1e, 
	0xd443e1da, 0x6067b836, 0xd5a25f3a, 0xe785a078, 0x1eb452b7, 0xffb9643d, 
	0xae3d6d48, 0xcc610b34, 0x2e7ad79b, 0x9998d3fd, 0x0a462839, 0xfb92fde1, 
	0x6717dc1e, 0x175cefbf, 0x1ab56886, 0x842bf5d5, 0xa9d9d7f0, 0x70b974e9, 
	0x83f5fbe8, 0x4e50dfdf, 0xd6f7a06b, 0xa34ed41b, 0xd6585cb6, 0x0dba2171, 
	0x2fa8d591, 0xc5b729b2, 0x7ae10df7, 0x2175884f, 0xcadd6551, 0x18ded9ef, 
	0xc022173d, 0x6df7e71f, 0xfe7a5ed7, 0x63ae4f84, 0x78ab4356, 0xfb1fd695, 
	0xd7d0075f, 0x618f334a, 0x749cda5d, 0x53c0c5d5, 0xdc9bbc48, 0xc87f442e, 
	0x49bdb64c, 0xbff212c0, 0xfb7e15cf, 0x7585bbcb, 0xc8685d23, 0xd7127f5d, 
	0x037f3d05, 0xdbe7838d, 0xff08bed4, 0xbfed217a, 0x94abe68f, 0x1ebfd7fb, 
	0x08b6229a, 0xf97e9bd1, 0xe7a8c880, 0x45f5d196, 0xe7815699, 0x447d68aa, 
	0x210afe0f, 0xbdd1175a, 0xf96dcb72, 0xd6835d79, 0xe47f981f, 0x072c7180, 
	0x9723a257, 0x8f9318f8, 0x4f1fa013, 0xa0e8b953, 0x6a06f5e7, 0xe2fea59f, 
	0x3d0d6790, 0x3c8537af, 0xce9967ae, 0x779e312a, 0x74bc3094, 0xdadcffbd, 
	0x8afda098, 0x7f50ad58, 0xafae8b2e, 0xf5a81e05, 0x4da243c4, 0x9c6f6df6, 
	0xe053b6e1, 0x6dc6827a, 0x8a55f5e4, 0x2d065895, 0xe1ebcfc1, 0x7878487e, 
	0xdab1fd3d, 0x3906e2e5, 0xd38045b0, 0x077b6c46, 0x9c2b3e78, 0x7ac29d43, 
	0xe4242e8b, 0xb38367f3, 0x309667c3, 0x4b37ac0d, 0xe55eb120, 0x87860c59, 
	0x3ef8cf5a, 0x6347ca77, 0x11ab6e55, 0xcfb1f3a9, 0xdf58358d, 0x78051fbc, 
	0x77e4e27d, 0xdaf9e226, 0xf5a8668f, 0xf8de3cdb, 0x6ef559be, 0x04e56f7a, 
	0x5d057c9a, 0x789ac73e, 0xa16bee9a, 0xe652fa78, 0xe8afdb5f, 0xa17813a8, 
	0xa82abd7d, 0x8dc1493f, 0xb8c7ec70, 0x9c9728f6, 0xcc7e9847, 0x7f54b71b, 
	0x348e3ae8, 0x7d3e3af3, 0x63af2c7e, 0x720d84e5, 0x8899915e, 0xfc024cf5, 
	0x24da3d69, 0x9917c9eb, 0x92574c2e, 0x68bcf3e6, 0xf47e8017, 0x05cb84ea, 
	0x045178ba, 0xa2778c01, 0xa3fa0922, 0xd11631bf, 0xb9a26789, 0xcdfbd712, 
	0x5cd7c310, 0x49584471, 0x8c18d75e, 0xf5b84cdf, 0xb6fe83be, 0x8ad7d889, 
	0xa68fb95a, 0x66bfebd4, 0x4713577c, 0xd99efcd3, 0xf88b9731, 0xedf5a9ad, 
	0x6e674587, 0x1ea7d5de, 0x253a249b, 0x883d30fd, 0xd58fbc71, 0xd87d6ea7, 
	0xd30c7a05, 0x3109e77a, 0x0c766a62, 0x894fa4e0, 0xfdef4125, 0x40fe8913, 
	0xf0977d1f, 0x898bdecb, 0x38afb12e, 0xc3867bb5, 0xba04e569, 0xe6589ff8, 
	0xfd711335, 0xf3969ff2, 0x8789de3c, 0xf18c9c9f, 0xd61690fe, 0x49bf742d, 
	0x9fa23688, 0xaea28579, 0x47d254b5, 0x4bd251a6, 0x27490ae6, 0x8c775a19, 
	0xfc219df0, 0x65044cdd, 0x8fd53d10, 0xe024b4b5, 0x87dbab10, 0xe1610371, 
	0xe8e5f64a, 0xd599e3c8, 0x26657e82, 0x028f5224, 0x9169e5ef, 0xd7a02f47, 
	0xef4e7c9f, 0x1edca417, 0xe68161d0, 0x92d45b42, 0xbf786b72, 0xbc40d345, 
	0x42d189c6, 0x162f3e23, 0x19c89bb6, 0x5a715dd7, 0xbfdfaadf, 0xd1fb8a9d, 
	0x3795768e, 0xcfdc7e32, 0xa2af7ad2, 0x2bd0e277, 0x03c8442b, 0xad504ef8, 
	0xb721ba61, 0xa7e73d0a, 0xcba6095d, 0x1e039612, 0xd68da057, 0x48f41739, 
	0x9d585f7c, 0x5cfee370, 0xa30111d0, 0x0bb753f0, 0xfbf55cfb, 0x3781a4ef, 
	0xec6ee3a2, 0x758b1623, 0xe66e83b4, 0x3234fd11, 0x3906bf5d, 0x25d7cf43, 
	0x047a2a17, 0xa171639c, 0x6ce128dd, 0xc25165f1, 0xe5da377c, 0x2f9281c8, 
	0xcb7df7a4, 0xfc5fde99, 0xef4544e6, 0xed78ceff, 0x9f490d37, 0x2d8447cd, 
	0x63de88be, 0xd151ab9a, 0xef473faf, 0xad0dd07e, 0xd12e73d3, 0x13cf0c7b, 
	0x3d14243f, 0x77fa1c13, 0x581ffa49, 0x731f28b7, 0x947a0fc2, 0xb07ccdf4, 
	0xadf5d147, 0xbee9fe8a, 0xe7ce4531, 0x3a50fdd0, 0x4b42c237, 0x101f1426, 
	0xbcff8cbc, 0x6f997f70, 0xaffb7d38, 0xfccfbccc, 0xbf94b174, 0xd8bbe9c3, 
	0x74df7cc5, 0xfb27c33b, 0xf5ca4f92, 0xf09323ca, 0xc499aade, 0xe9c3753f, 
	0x64c8bebc, 0x8ffc253a, 0xbf8afcb0, 0x9040f9e8, 0xe90099e8, 0xda5a9549, 
	0x6c4e787b, 0xaa07db02, 0xa994cf49, 0x4eded4eb, 0x634e55f4, 0x486d415d, 
	0x3026b1b5, 0x1f20d0a4, 0x78d327ea, 0xd9075875, 0x7a4fd011, 0xa9700a4d, 
	0x9d73129f, 0xae10fbcf, 0xdab798ed, 0x860f0174, 0xf982b138, 0x98d2913e, 
	0x8f89abee, 0xfa91fed8, 0xca5850ea, 0x53096fe7, 0x7afba36b, 0xe3bc262c, 
	0xb5355f69, 0xcc8fac4d, 0x01a47d01, 0xf2fdf63e, 0x2c754f79, 0x45797d85, 
	0xad720b93, 0x3f3d5ebf, 0xaa1196af, 0x6b3dca87, 0xd11d076e, 0x46bdc075, 
	0x6cd7ef5e, 0xd696fd61, 0x6a1fcfb5, 0xfd3e48cb, 0x5b83fdd3, 0xc78f1fe8, 
	0x2b474b47, 0xe09b33e1, 0xb77c4050, 0x2ea5c279, 0x73dcc7f1, 0xf2b0af11, 
	0x6f7d0fef, 0xaed984f3, 0x507cf411, 0xbf00fb98, 0x7fb405c2, 0xcd87ee93, 
	0xc227895a, 0x9767abcb, 0xe2418517, 0x04ba0ceb, 0x35ef1a6f, 0x147c22dc, 
	0x8e3c1254, 0x6e118ec3, 0xbbea1de8, 0x0f3443c4, 0x52790d8d, 0x4a48f330, 
	0x89cb8724, 0x659cc812, 0xe06edc72, 0x08c0e5a7, 0xf3218066, 0xb4e66816, 
	0xdc334e07, 0xc6e01e9b, 0x429bf866, 0x1fd1f1f1, 0xdfcf99b9, 0x3796fd55, 
	0xd1dfb8dd, 0xd95af8ae, 0x5f65010f, 0x347ddf00, 0xb709acf7, 0xb3d6ba4b, 
	0x3798c9a9, 0x9cf0a764, 0xd25db216, 0x4f32198e, 0x33cf237c, 0x2908ee6f, 
	0xb927324f, 0x2167e97f, 0x36ce5f25, 0xd62e3dcf, 0x2799670f, 0xf5817b01, 
	0x4a0bd900, 0x5ed19c0f, 0x667b57d8, 0xcbdc417b, 0x55b4597c, 0xf6a1fd57, 
	0x7f9cbb42, 0x9d0bd93c, 0x8285edc3, 0x7ac82ba0, 0xe607d959, 0x63af3968, 
	0xd3175437, 0xe7ef38fd, 0xc385ed8b, 0xdbfeb2f7, 0x3e5257f2, 0x67921db0, 
	0xb09cac27, 0xe9ade185, 0x1a2eff19, 0xfa7420bf, 0xe6771777, 0x238168e4, 
	0x6ace6f47, 0xd91f862e, 0xa3909d09, 0x9cbeaf04, 0xe4a0503d, 0x142763a8, 
	0x6f9a7928, 0x482cd847, 0xab0ddb07, 0x9afd554f, 0x55c95ff9, 0x4f2966fd, 
	0x2b537b9b, 0x605e345c, 0x53ca564a, 0xec075f25, 0x034f2558, 0x9f035b61, 
	0x3c25bcb0, 0x489cdc15, 0x28086ec2, 0x6ec060fb, 0xe5957255, 0xf253e62e, 
	0x6abc187f, 0xfdbc606f, 0x2568fb61, 0xf0ca7f67, 0xf242de89, 0xd5db18f4, 
	0xfd0eb093, 0x228ff49c, 0x5d3c686b, 0x859bad98, 0x6a688978, 0x7970d344, 
	0xf50f303b, 0xfea75f3d, 0x1ff33769, 0x85f3c1f6, 0xeb49d684, 0x8aba2669, 
	0xb4213db0, 0xfc87c06e, 0x2136e312, 0x87f58e09, 0x4fdbf787, 0x917fb02f, 
	0x752f7690, 0x0569e06d, 0xd8114cd9, 0x4913b375, 0xebe1f6d7, 0xf296e558, 
	0xe5853611, 0x7fb05066, 0x499955a4, 0xaf8e6e6b, 0x257c39d6, 0x43ee18ac, 
	0xfdfd605e, 0x720b44b4, 0x471081b2, 0x13582372, 0xfba3e39a, 0x80bfdc29, 
	0x310d1bae, 0x493acbe6, 0xda89fda7, 0xbad5c866, 0x4cebc198, 0x3be985c5, 
	0x0171e0a6, 0x8cf1abee, 0xfea6bc19, 0xde7e0cd0, 0x6b7d1c23, 0x091d078d, 
	0x7bcf2fa2, 0x84c7f379, 0x1ddf7f27, 0x50bfca35, 0x7f1d3270, 0xbde34e22, 
	0x1648e429, 0x0b2e73db, 0x2466f170, 0xb07e085c, 0xaab91ca7, 0xd2cbcd07, 
	0x938ad087, 0x616f034f, 0x87f2bf71, 0x7ea06e4f, 0x87c50e00, 0xa3b06e12, 
	0xf506fa06, 0x43f5e647, 0x4e4c3fb2, 0xe59aff65, 0x55e7a5df, 0xe52dbecb, 
	0x8ebd8be1, 0x80bc241d, 0x66a723b7, 0xf311a04d, 0xf10d60e5, 0x1c9e635b, 
	0xfd28d79c, 0xe12e9b91, 0xa63582f1, 0xa86d0a7b, 0x4a40edbf, 0xe9d7295b, 
	0x4dffa0e9, 0x6720d52c, 0x944e73f4, 0xbd5ebee2, 0x0ba3c7af, 0xac3799f1, 
	0xd820ff89, 0x8d956dde, 0xbc7e19d3, 0x04c89b1e, 0x1f40b1eb, 0x4796efcc, 
	0x7736bfca, 0xb923fcbe, 0xfdfde1e4, 0x8b7e3852, 0xc2e3f707, 0xf4cd8fd9, 
	0xffba1855, 0x941f777a, 0x9f41edb3, 0x7d0e91f4, 0xa2d45fa4, 0x7dde1397, 
	0x31eb4f73, 0xb637fd6a, 0x23a06b78, 0x139336a3, 0x048793d9, 0x62d635f0, 
	0x926aec7d, 0x1db4f2f8, 0xa62cf42c, 0x73fa4836, 0xf475ae73, 0x83c262ed, 
	0x4a5ecf41, 0x6df40d6d, 0xb4b3d485, 0xe8ad3b1e, 0xd248b829, 0x6794a74f, 
	0x9215f4ae, 0x7327324e, 0xa5f8e474, 0x6eb4a7cc, 0xef6cd132, 0xb4cf78fb, 
	0xc83e7740, 0x678c3ecf, 0xa1ef8126, 0x19504574, 0x6dcbc87d, 0xd778e039, 
	0xd11e5225, 0x3a47e530, 0x4791dc78, 0xb23dbef9, 0xd4735b8f, 0x751fd909, 
	0x8d1fde52, 0xdda696f7, 0x379780e5, 0x3c068f6e, 0xeb147ee8, 0x0d4cb989, 
	0xf1c5b978, 0x3f27c123, 0xbb491f06, 0x4dbc86d8, 0x7f8fdf0d, 0x3e9fe91f, 
	0x59e79fb5, 0x76ddb29a, 0xb407d28b, 0xe5cfd701, 0xf821b5fa, 0x9a1eb28e, 
	0x7b7639af, 0xf4ef5f34, 0x4b7ec7c3, 0xe6fc09e2, 0xb1fa47df, 0x57a9c14f, 
	0xafd483f2, 0x37e99456, 0x041d7314, 0x9e121b5d, 0x04a51fe4, 0x8667e5fb, 
	0x9172f867, 0x9f877d6c, 0x89f2572f, 0xb568d3e1, 0x049fa1c6, 0xf98d2122, 
	0x7fcab670, 0x231470c6, 0x1ad6e0df, 0x1fd92bf9, 0x47f65c75, 0x057b53f5, 
	0xde0645e8, 0x50ea9f46, 0x91745670, 0x61bd9339, 0x327cc83e, 0xd952dcf3, 
	0xfdcc7d0f, 0x0785dfcc, 0xdece4bd1, 0xbc2d7c90, 0x575c07bd, 0x24dbaf80, 
	0xa5f7875f, 0xd87fb02a, 0xe2f3db1d, 0xef495e1a, 0xe98271cc, 0xde8495d4, 
	0x58261e81, 0x1b09f3cc, 0x02cf1f71, 0xd05daff2, 0x62ca56c3, 0x02ff59bc, 
	0xae7034ff, 0xefe9dff4, 0x8623d017, 0x57f4c3d2, 0x67b3c996, 0x7913706e, 
	0x3eab38d0, 0x3f052eb8, 0x2e1fd565, 0xe9e462dc, 0x89b379e1, 0xeaee486f, 
	0xb31f49b3, 0xfed930be, 0xe70048b1, 0x928429c7, 0xefb21e17, 0x2ed9a7a1, 
	0xbd95f9e2, 0x87ca5634, 0x4f3e4fd2, 0x3b843db1, 0xb4b7d829, 0x82679a2f, 
	0x1f6003b2, 0xf2639c31, 0xaa4ec779, 0x99ff206c, 0x1f9651e3, 0x15e7a6f8, 
	0xc93b4a9d, 0x4c6d271b, 0x4b712efb, 0xd33a123c, 0xff652c5b, 0xcf575c13, 
	0xd7e1fb15, 0xfa96e9df, 0xb8c8f759, 0xad02c159, 0x18c07118, 0xcdef83ae, 
	0xebbfb63a, 0x713d92c7, 0x7d63ee80, 0x0f8fcae5, 0x42bcfc49, 0xd7c321f8, 
	0x3760eca3, 0x8b50e5ec, 0x12df81e6, 0x7a1cbf24, 0x148f33d1, 0x84adc13a, 
	0x47f021e4, 0xd7f0ddd7, 0xc54b9fc9, 0x7ee77da5, 0x21fa18f6, 0x09e23977, 
	0xb7afe56e, 0x117c3b2b, 0xb0df18b5, 0xff0be0dd, 0x137f64bd, 0x6fc3160f, 
	0x563e7497, 0x596393d9, 0xbdff2a9e, 0xfd8fbab8, 0xb64efbf6, 0xfc11731e, 
	0xcbb7e18b, 0xc518f178, 0x3cad632f, 0xafc1ddbf, 0xb87f27a8, 0x83af9f93, 
	0xffef4f9f, 0xee1b15d1, 0x859c73b7, 0xc540ffee, 0xbdbf4609, 0x49f011ed, 
	0x79eb3d0b, 0xb6a7e727, 0x234cef98, 0x8fd74f1d, 0xf8bd80ac, 0x240f1503, 
	0xe98631f9, 0xafc49b67, 0x34facaff, 0xde96b0ec, 0x3c648b99, 0x2f931cc2, 
	0x7d4ec84f, 0xe93fc798, 0x8fbf9efe, 0xf1afc1f5, 0xccec82fc, 0x1bbe02bf, 
	0x0dfc2d0e, 0x6d4a6fc6, 0xfd418dfc, 0xdf1f150f, 0x3ebfdcf0, 0xdeffd822, 
	0xfe0188f1, 0x770fdc35, 0xc1d1cc8e, 0xab07452a, 0x114d0f2f, 0xf559c411, 
	0x3098f114, 0x2c47c934, 0xfdd22717, 0xc61499f9, 0x9a5be559, 0xe92220e2, 
	0xbefbc00f, 0x55a790fa, 0x3f2d17ca, 0xbef03a9e, 0xd80f2f8a, 0x22383fbd, 
	0x1cdf7e2c, 0x47578724, 0xb7043d69, 0xc790bcc0, 0x31c628f5, 0x52c09c65, 
	0x830dd3f6, 0x3b55d6ed, 0xfe06fbc9, 0xee16429b, 0x6c2cde17, 0x7e482629, 
	0x3ff1cb1e, 0xc9e416e4, 0xfc1fe7ea, 0x93942317, 0xb66dd6a3, 0xc42ed438, 
	0xae883395, 0xb37a734b, 0x349793f4, 0x5f1e6563, 0x91145f12, 0x0437fa7f, 
	0x65d110cf, 0x79731620, 0x38ae78a2, 0x479e0299, 0x3fc93ed1, 0xe33522af, 
	0x8274fb27, 0xbdfeb221, 0xa14ddcf4, 0x687e41a4, 0x02e32dd6, 0xdeb45fcc, 
	0xdfe498ca, 0x9690b7e3, 0x88053f07, 0xdda84ade, 0x0f44d299, 0x413e6bed, 
	0x34f3de97, 0x55b13564, 0xa3b0bd88, 0x4cfcb14e, 0xaafcf45a, 0xc714faca, 
	0xb712cfc1, 0x67da0828, 0x54145b8c, 0xc540fb2b, 0xeb437e2d, 0x34fda72a, 
	0xd0bee5b8, 0x78aa4ec6, 0xbc5e4945, 0xe3f04bc2, 0x2dc24578, 0x1ba615e3, 
	0xd7a10af1, 0xb71c7cf0, 0xc5788c38, 0x43eb4d01, 0xeffc8cbc, 0x3c2bc433, 
	0x71635c4e, 0x9c93c64c, 0xfc5e4578, 0xf15e3f3c, 0x10b7b22d, 0x0578e0df, 
	0x8a8369f4, 0x5c64244b, 0xb94ef0a2, 0x1c5b8e5f, 0x90f978e3, 0xc661c5b8, 
	0x5469bfb3, 0x57e950e8, 0xa53c5b8f, 0x3f89c1f8, 0x343cdf14, 0x25f040fe, 
	0xda0e2a3e, 0xe270671c, 0x60e543ec, 0x8207f100, 0xc64d61f7, 0x090b021f, 
	0xc11f441e, 0x357b6084, 0x05b850b0, 0x1a9e62d9, 0x4c087f19, 0x1abe48ce, 
	0x206af722, 0xf3943fc7, 0x23a0fe21, 0x38ce20fe, 0x3ec71edf, 0x8b95c07f, 
	0x911a8adf, 0x4f1bde86, 0x1b7dd3b4, 0x74b56dc7, 0xacf79d9e, 0x7a116ba2, 
	0xe9d9ed91, 0x7b4b77df, 0x599fefa6, 0x6cfcef8f, 0x70df639c, 0xcfd1c09c, 
	0x481f6622, 0xcfb7cb1e, 0xc5e49249, 0x1f2ed80f, 0x0cae5c39, 0x31fd1395, 
	0x94dff4bf, 0xfbe55d5c, 0x1ca9c723, 0x19c8e3b9, 0x96533343, 0x0cae5c3d, 
	0xe5432395, 0x695c80cc, 0x9e32b920, 0xb3d657fa, 0xa3f5131c, 0xe07acd7f, 
	0xb7cce44b, 0x58d56b0f, 0xa4f37dcf, 0xb7e9bb9c, 0x521b56f7, 0x5d6354df, 
	0x0968872c, 0x4cc47745, 0xc2056fd8, 0xb50affde, 0x9a11b0c5, 0xa63a1c95, 
	0x93998fe4, 0xdb03c047, 0x4e43e841, 0xf864ec35, 0x4134596f, 0x0ffd3bc2, 
	0x1bdd5fdc, 0xc0cb7ee6, 0xb0f18378, 0xf76ec279, 0x416be299, 0x91989e91, 
	0x2924f5f6, 0x1949ad07, 0xb702c7c2, 0x9cafd78c, 0xdb3763f0, 0x7dfd435d, 
	0x47e97efb, 0xf3c85f35, 0xd8e45bbe, 0xec257653, 0xd3c4c0a4, 0x1cd96de5, 
	0x92ad9b7f, 0x97bc9c3e, 0xf93b4763, 0x8ecab5ae, 0xcfb418f6, 0xa767c284, 
	0xdf68871a, 0x5232ea53, 0x38bb398d, 0x3dcbb5e0, 0x415e2447, 0x193d9e0f, 
	0xe717f60d, 0xe3873abf, 0x4e0df57b, 0x124e707e, 0x7c687172, 0xa6cf2063, 
	0x797e4bf0, 0x94dbaf25, 0xf86183f1, 0xca0c950f, 0x155fd257, 0x122980e4, 
	0x55ee2a55, 0xe0ff78c5, 0x71f02af5, 0xf08fde3e, 0xb67fa40b, 0xc333d70f, 
	0x7125fdf0, 0x5be1b3ba, 0xf8372c84, 0xff621f4e, 0x942e2116, 0x266bfd84, 
	0x7e276701, 0xbfd80faf, 0xec050e92, 0xfddfe960, 0xd5bfd9df, 0xe275fed2, 
	0xba3fab50, 0xf9497350, 0x70f685f0, 0x9c716c20, 0x0e1389df, 0x0b0387b5, 
	0xb1c50762, 0x7a4bfd9c, 0xf4f22538, 0x61ecd9f0, 0xee397fb6, 0xcae1ed27, 
	0xb4afd27a, 0x8e3da7ae, 0x2ed8331f, 0x7f95fc06, 0xb1df4695, 0x2eb7fe83, 
	0x03d65eed, 0xf428cfb4, 0xf84dc335, 0xe8a7ee38, 0x6992fe94, 0x1e8bc3c2, 
	0x9afdd7a9, 0x3d7493d2, 0xfdfcfd29, 0x89bbef1c, 0x17a4b9e4, 0x2f43e2af, 
	0x2e897ee0, 0x9c45cff9, 0x57c273f3, 0x3d4ed781, 0xccfe716b, 0xa0b37b07, 
	0x9e21f4c1, 0xe6eca056, 0xa5ffc8b1, 0xdd93a761, 0xd13b609d, 0xbc89db57, 
	0xf80bdc64, 0x3f32227b, 0xabaecfa8, 0xa972ec75, 0xfa7c648f, 0xa5d3269a, 
	0x6816ee41, 0xb144f43a, 0x8fb0dcb0, 0xdc072dc3, 0x6d7a37d0, 0x446b47b9, 
	0xf7d1d35f, 0x03de0e81, 0x675ec9dc, 0xb56acd3b, 0x93146e48, 0x887ac48e, 
	0x34335a5a, 0xea0f98ff, 0xf7697193, 0x38259e79, 0xf9f73516, 0x218e7f60, 
	0x136e54fd, 0x76c1f5bc, 0x42f7efbc, 0x1456bd87, 0x04493cb4, 0xfa909eb5, 
	0x23fbf7cd, 0x4617a1fb, 0x0da4707c, 0xd7614bf7, 0x0f023c13, 0xf17ed886, 
	0x7acf507f, 0xa7f7f111, 0xefb0cf40, 0xe6232f09, 0xa1ab691f, 0x10a74bf9, 
	0xc279e23d, 0xf3d86ecf, 0xc7cf6435, 0x7e097873, 0x91056a10, 0x77e0e79f, 
	0x19e4a994, 0x4fc00df9, 0x05d7ccbd, 0x8a4facaf, 0xe7eedcfd, 0xe72e933c, 
	0xaff76a19, 0x79c63cbe, 0x06c2c8db, 0xabf06658, 0x35590ed8, 0x0fafbe59, 
	0x7ecd83d0, 0x474ae789, 0xec49e93e, 0x1cccaf53, 0x13573ec0, 0xf35497c7, 
	0xe0575c73, 0xff8e13f8, 0x7c4b7ec0, 0xfec11fb8, 0x9fce634b, 0xe05bf018, 
	0xc4b8c8cf, 0x91c2bf20, 0xf4c7eccb, 0xa18bfce6, 0xa7238b7e, 0x0e5e54bf, 
	0xca864bf1, 0x713fc74b, 0x38609cfc, 0x8818d461, 0xbd955ba7, 0x8da39286, 
	0xfc128e4a, 0x31aef0b5, 0x1f946be5, 0x31f94c73, 0x3e4d8788, 0x8b7ec552, 
	0x39d667f2, 0xa5ff0cfc, 0x5735f951, 0xcf26bf28, 0xc2a5f99f, 0x1df7a3b3, 
	0x4bd8c23b, 0xd94fb7fa, 0x8677c417, 0xdeb03b1e, 0x182f6e1a, 0xbd95cb0b, 
	0x7676ced2, 0x0a797e60, 0x8dec72f8, 0x6c4333d5, 0x698fe83f, 0xff63451c, 
	0xc935f003, 0x55f2903e, 0x7d9595c6, 0x162fbce3, 0x06793b0b, 0x65c8e5fd, 
	0xe009f603, 0x5d1f5432, 0x0f283b5e, 0xfd76704a, 0xce71e2d6, 0x9cae67a8, 
	0x87a0f241, 0xcf6cb6e3, 0xbf727e96, 0x4cfe4ceb, 0x7dda4789, 0xc7a31f8e, 
	0xe10f6eb2, 0xd49468a1, 0xa33f8e1f, 0x02b4cfcf, 0x54d7ec6e, 0xb94b3f43, 
	0x7244d957, 0x939298f6, 0xe4834ba0, 0x9c9cb1e4, 0x8252fe3c, 0x403d1bfd, 
	0xc69ba3f2, 0xc5d339dd, 0xcb64cdfe, 0xed16b80d, 0x47e4fba3, 0x202c848d, 
	0xde63a73d, 0x943de03e, 0x7e265c84, 0xdf517b62, 0xb7917a69, 0xce6d670b, 
	0xa4f239db, 0x9bb4b0f8, 0x3824ff7d, 0x93c8eb5a, 0x5a17c852, 0xa79548ff, 
	0x84376c43, 0xac7fa17a, 0xfdf53e67, 0xc11bc913, 0xe73f117e, 0xb6a14ff8, 
	0x75e056be, 0xb0e4906c, 0x9ee3939d, 0xd4eb9222, 0xb4df862f, 0x8d4fe728, 
	0xbe607955, 0xcffe764e, 0xf14fe974, 0x7f65aa7c, 0x92e3452a, 0x295c553f, 
	0x6df591f3, 0xa3f28f09, 0xff09db3c, 0x01e16aa1, 0x331286af, 0x4a4dc475, 
	0xe40f4daa, 0x3a3ff93d, 0x80721ffc, 0x38fc4e3c, 0xff229fdf, 0x29fb0dab, 
	0xeeb8c74e, 0xeaff042b, 0x5a1e88df, 0x0d655f94, 0x7c9e55f8, 0x5d64aabf, 
	0x81e64dac, 0x0f39ba4f, 0x4df94bbc, 0x1537e959, 0x4b60793b, 0xe2196f5d, 
	0xbf73d94f, 0x862a9fd0, 0xad18b53f, 0x2ab737f4, 0xd43d2c7e, 0xc11d86e7, 
	0xc7ef157e, 0x0e297a62, 0xfa451f93, 0xfe9878ab, 0x586ff01a, 0x9fcae96f, 
	0xbff9262a, 0xea6fe309, 0xf9e88773, 0x7c65d0bf, 0x099698bb, 0xb29b16f8, 
	0xb9fca71d, 0x6fada997, 0x6e81cf92, 0x3f74565f, 0x1bbaf206, 0x17f1886d, 
	0xfb3be354, 0x7a91e998, 0x7e356afa, 0xc40bb285, 0x0367a254, 0xbc4974fc, 
	0x5169e496, 0x55ab6aa9, 0xe6b55d3b, 0xaf9db27d, 0x7b64dbda, 0x7a23c605, 
	0xf647ba2f, 0xbb59bf47, 0xf1878660, 0xf9887ac4, 0x603cfa06, 0x9f55fe72, 
	0x6859f349, 0xfd17e705, 0x226a673b, 0xf98a7ac5, 0xc42cbfc3, 0xfdc63cfe, 
	0x68b3ad1a, 0xeb95a666, 0x1057108d, 0xff3f5fb8, 0xdd2f326b, 0x6a3b09d0, 
	0xfaefe4aa, 0x88bd0f8e, 0xc7d8eabf, 0x554b6a3e, 0xe9daad5b, 0xd03ec5aa, 
	0x6ded57ce, 0x9ac4adb2, 0xf7eb1e49, 0x2d35fec8, 0xbdfc2f29, 0x197d706b, 
	0x7b0ad7cf, 0x7ae0ac35, 0x1283a297, 0x11f699e0, 0x869627bb, 0x0c2faabd, 
	0xea05df31, 0x11e70f2d, 0x3e49dfa1, 0xb759cde9, 0x14b51bab, 0xe717cfa4, 
	0x28e622f0, 0xe4b378ff, 0xc2be6777, 0xf21a633b, 0xae5d217c, 0x1fe148ab, 
	0x3bbba0f2, 0xe5d8bf87, 0x3dfe0d22, 0x0fd112fe, 0xf150c3ad, 0xcdb66342, 
	0xc13169f6, 0x340f432d, 0xefef32ea, 0x42b9a9d9, 0x06bde90b, 0xffc9075a, 
	0x7ed299e2, 0x65c99e28, 0xd37803a1, 0x102f492b, 0x25f319ed, 0x1f02d63e, 
	0x995d1788, 0xe0eff961, 0x647f98c3, 0x9fa4d7e1, 0x0d01e27e, 0x4bf08f72, 
	0xeaa454fc, 0xb5fe4815, 0xa28fb41a, 0xd0d6a165, 0x342f4576, 0x02f435ce, 
	0x4f82b2ec, 0xf0925add, 0x2bfeff58, 0xc18bd86e, 0xf676a185, 0xd6adca8b, 
	0x3e525d37, 0x411a3f41, 0x3f524f5b, 0x5279261a, 0x886bcfce, 0x5bfc127f, 
	0x9be2ffb0, 0xf34dc263, 0xad6d8595, 0x814fe49b, 0xb76d5667, 0x92adbfe2, 
	0x77c034ff, 0x6ef4aeb5, 0xb803ca41, 0x7fc86697, 0x43c39edf, 0x696b8299, 
	0xe80f56cd, 0x288bc1d2, 0x93e47537, 0xdea682ca, 0xdc37124d, 0x7a852473, 
	0xe18f070b, 0xb0dd689b, 0xc1ef49f3, 0xff610bbe, 0xe6a84e34, 0x871811ad, 
	0x277744ec, 0x349be7ad, 0x8e53497f, 0xc43fb08e, 0xbfb4a233, 0x32ef7a6e, 
	0xf827efba, 0x61de012c, 0xf80e578f, 0x31c71a83, 0x1afa54af, 0xfd714e70, 
	0x5372c6a7, 0x1d5669d4, 0x47a48de2, 0xbdc60e08, 0xa24d5a47, 0xce348593, 
	0xaf212715, 0xd229ad5d, 0x65d5df53, 0x1aa1683c, 0x6d84f37f, 0xd5fa58ba, 
	0x3ccfedfd, 0x9cac7e52, 0xf1ce98f0, 0xb7f72f91, 0xa1fd655b, 0xce8bb7f4, 
	0x97f6fe95, 0x9c4ed7f9, 0xf064fd84, 0xf2ba61b5, 0x4e3c24e3, 0xfb1dd30d, 
	0x34f43ab3, 0xb7f045b5, 0xfa56a8b9, 0x0c9efadb, 0xd3b669cb, 0xdf26fe54, 
	0x8f7d5fcf, 0xfe91cf13, 0xcbf8b0f6, 0x1effdd9f, 0xc26b6fe2, 0x50607844, 
	0xe0cff7bc, 0x7c797f6f, 0xbccb2c8b, 0x7c40f3fc, 0xe676aceb, 0x0cb7ecb3, 
	0xe24399d8, 0xf33b395c, 0x05e39665, 0xc31313b0, 0x4e274ced, 0x3a871035, 
	0xbce99d8b, 0x9991d37f, 0x938a67d5, 0xbf73b50c, 0x8d553473, 0xb27a8df1, 
	0xc19d8f3b, 0x2df154ce, 0xe1ed73b6, 0x1ee27278, 0x903d294f, 0xf1505f17, 
	0x9d86d32c, 0x90e355fa, 0xfd3f9423, 0x37c87165, 0x886787c0, 0xe377fc8b, 
	0x871b6769, 0x93c7bcfe, 0x3f6f1fbc, 0x8a77c2b7, 0xfb87db5b, 0x877dd585, 
	0x0acf24d3, 0xa090d0a7, 0xf6330ac3, 0xe1a2d900, 0x7bab8931, 0xf9f7ce08, 
	0xcf9979c6, 0xd31f2dcb, 0x01eaa5b9, 0xf22f2dca, 0xe245e1b8, 0xa4a3c072, 
	0xd3f2ee2b, 0xd4364b7a, 0xbd69f9d6, 0x49629ba5, 0xd6e1e43f, 0x827efdda, 
	0x695e8dc7, 0x4bf88ca7, 0x3bb23d62, 0xffb4ff4b, 0xe9481400, 0x9feb24d6, 
	0xe3dc4c82, 0xa5093a22, 0x905abfa4, 0x3e461c59, 0xeb3eb42c, 0xfbf31022, 
	0xfcf0a7e5, 0x9413ce01, 0x0ea078de, 0xc8b118db, 0xc15db99e, 0x95da57a9, 
	0x8bb9f383, 0xb4e196ff, 0x6a79c96f, 0xfdc1ffdd, 0xfa8c97b1, 0x1bdcf94a, 
	0x43ae0abc, 0x70f3b9f2, 0x2ba9f49d, 0x703ef966, 0xbd334e01, 0xe3f53962, 
	0xfd85a7d4, 0xbd1b9cee, 0xe9d1d01e, 0xf42e39cf, 0x4cbeffd9, 0x6442bde6, 
	0xfb976d6d, 0x6ab8ef01, 0xcae9f79d, 0x61f5dcd2, 0xcf3d88fb, 0x4f687eeb, 
	0x97d52bfc, 0xf7f5f00c, 0x5842bb4e, 0x292faab7, 0xff744c5c, 0x669ff82a, 
	0x3d7e63fa, 0x3d43e589, 0x93bad0c9, 0x77858b51, 0x2675078a, 0x2f2178b7, 
	0x75976f0a, 0x39b78526, 0x5e8d2675, 0x5f0499d4, 0x44267591, 0xf083a212, 
	0x1c5a9a3b, 0x96ac28f4, 0x8491d8f9, 0xf9c7f6db, 0xfc86b5be, 0xdd92729f, 
	0xf1a63fed, 0x9e824cc9, 0xf49be7a4, 0x1b3f7469, 0x8d3c40eb, 0xb738bdfa, 
	0xd3741cb1, 0x0eadf1cc, 0x5548f7f0, 0x631e126f, 0xff393afa, 0xac07fe99, 
	0xc9e159b3, 0x946363d1, 0x46ba08bf, 0x3f6e8a3b, 0x20a8eb40, 0x0d36df19, 
	0xfcf52e74, 0x47a1e838, 0x0c647f51, 0x08f2bbaa, 0x35e00d73, 0xf481d54e, 
	0xce91211b, 0x9b8acbaf, 0x929e40af, 0xe7c35ade, 0xf3ed1647, 0xfe17cf41, 
	0xc830c5a0, 0x735e2a0e, 0x401b20da, 0xf16d6c94, 0xe23b5397, 0x18fed3c9, 
	0x49fb2fdd, 0x9106a04b, 0x2bd55896, 0x7dd15bd0, 0xe8f80076, 0xb9eb2e9f, 
	0x4b183a9c, 0x9fcc4198, 0x38aad025, 0x7cff306d, 0xc109f9c5, 0xe00bc771, 
	0x3ea99eb7, 0xaaeb2131, 0xa270757f, 0x16817950, 0x84fcf7ac, 0xa2c671c9, 
	0xe5252203, 0x75941d8b, 0x9f310f70, 0xbf5cdbd3, 0x49ac6a27, 0x285a3b90, 
	0xc952eebe, 0xdc968557, 0xefde7aef, 0x073f6d88, 0xcea45e9f, 0x2cee90e9, 
	0x772cbf64, 0xeb90a1ce, 0xa55c5485, 0x8e5eaef0, 0xd4e45eaf, 0x4b5308d5, 
	0xd557fc72, 0xe32cdf73, 0x1f757abf, 0x1d7019d7, 0xaf3b91b7, 0x8affc4e0, 
	0xbf587c55, 0xa06f9e59, 0x4c42b98d, 0x475e4ebf, 0x196ec114, 0xba80a738, 
	0xbe797785, 0x7fdd0ca2, 0x3fed2bdb, 0x7e61e61f, 0x2fbaf8b7, 0xff94bb6c, 
	0x10ba845c, 0xd72c8cdf, 0x0e7a9219, 0x651f8c59, 0x1d7ca807, 0x6a9f15fd, 
	0x3f8bf7e5, 0x008456e5, 0xb337df1f, 0x8acdc421, 0xa299da96, 0x1381c436, 
	0x3bd7ae19, 0x449739db, 0xb598f586, 0x5db088fc, 0x6863c067, 0x3e77d731, 
	0x55d7f2f0, 0x0a6bfc7d, 0x0f3e694f, 0x8fc9ed32, 0x2773a927, 0xfe5cc093, 
	0x3f76c9a0, 0x9e437bd7, 0x3176902f, 0x93c854f2, 0x533f3d0f, 0x8998adf8, 
	0xa57a4ffb, 0x3eac333f, 0x1c255845, 0x72ead837, 0xb48238c9, 0xc24b2c9f, 
	0x7b2333db, 0x8175f02d, 0xf841cf29, 0x1273c90e, 0x900d93e7, 0x8cf7de24, 
	0xbab7f731, 0x0528ecf3, 0xe2bddbbf, 0xb922bf5b, 0x7464d452, 0x2d4e0297, 
	0xdb6892d9, 0x39c9c397, 0x70e5f00f, 0x0ccfe8fa, 0x46a7bea7, 0x70f3bf48, 
	0x7153f607, 0xc91b7949, 0xfec777b4, 0x73c63360, 0x47eb8cfc, 0xfbff608d, 
	0xd9a351fa, 0x5fd6726f, 0x737693e4, 0x9ffd27d0, 0xf947275b, 0xff63bbfe, 
	0x23fd8db4, 0x6ffbb49f, 0x56d45afd, 0x0e228fd7, 0x7425eb88, 0xfb2d443d, 
	0xa2d886a1, 0x6b16faf4, 0x86fc6e64, 0x4b14c40b, 0x619b09fa, 0x301f5ec7, 
	0xdf685b37, 0x8fb5cad0, 0x0f116f19, 0xf7faf401, 0x62fccfa9, 0x5cea6047, 
	0xeaa6727f, 0x6bee519b, 0x51fb9cb3, 0xcb3c3e7e, 0xef9cbf79, 0x679e774f, 
	0x18dc4957, 0xb9c7bf17, 0x36c56a44, 0x07f643f4, 0x31bcb3a8, 0x423d9624, 
	0x61237cf4, 0xb50af32b, 0xb51f64f5, 0xf44eb5a1, 0xfc427ee2, 0x13f70ba2, 
	0x969f2fd6, 0x03fd63fe, 0x123747c4, 0xba2fc3cf, 0x337ac0a9, 0x2774344d, 
	0x7d2672e0, 0xeb0dff68, 0x5952a2c3, 0xfd322cf7, 0x7f7b0fac, 0xd497fe76, 
	0x5f88d39f, 0x637e7f50, 0xc37fce4c, 0x89bc5f9e, 0x09df75f3, 0x66d25bd8, 
	0xfdce1d6e, 0x6b62039b, 0x95cf026f, 0x3a7385be, 0x79e9ec37, 0xfe74e70b, 
	0xdd6d602a, 0xe3e7cb66, 0x3e85b24d, 0xc674d1bf, 0x718a39ed, 0x6dac0617, 
	0xed35c683, 0x70939f37, 0xbe896b10, 0x3cec5c6e, 0x782ffa5f, 0x6c40417e, 
	0x0a7e7fce, 0x8bbce5c6, 0xcede3915, 0xb9fb45af, 0x64a7a2b5, 0x53fcb104, 
	0xed2fcd5d, 0xaf5972d9, 0x7a8eca28, 0xc90ff5d4, 0x5b980f0e, 0xff4e2740, 
	0xdff33d86, 0xcbfbdc82, 0xb2d5b980, 0x2837ef73, 0x05dbf67f, 0xdb009be6, 
	0xdadf937b, 0x7b517586, 0xfe457434, 0xa147a5fb, 0xb1011217, 0xbe7de06d, 
	0x70b78bfe, 0xbd8096fd, 0xf9f5f075, 0x635f3147, 0x7cf21cc0, 0x7eb86bcf, 
	0xc6eac079, 0x003901f5, 0xba05dbbe, 0x55e658be, 0x82cc5f0f, 0x2ff7fae2, 
	0xd1df7e96, 0xd793798b, 0xf657bc9f, 0x76bea84f, 0x969fec9f, 0x5ad443cf, 
	0xfbefa0cd, 0xf48638e4, 0xae9fae13, 0xf7cacbde, 0x5ea3bf1c, 0xe902f938, 
	0x364eba97, 0xea7d816d, 0x079f038c, 0xa9ec6c7a, 0x71bb0d98, 0x5b4e9fec, 
	0x36fd7cae, 0x8592bce4, 0xfcfe07f3, 0x9fb679f3, 0xa90de7cf, 0xd40cf7b3, 
	0x9f3e0df7, 0x9efcf430, 0x7ce4d793, 0x6e773c64, 0x8c13cf89, 0xe25b9dcf, 
	0x92f1fcba, 0xecebf21f, 0xd94b739d, 0x8293f381, 0x37a832f3, 0x3a9fbce7, 
	0x1c8d60a7, 0xe835d738, 0xb6e5425c, 0x39cfc718, 0x9dcf198f, 0x51ce703f, 
	0xd5a3f30d, 0x73818979, 0xea7feb93, 0x3c8358af, 0x273e72ed, 0x76766238, 
	0xe728f40c, 0xaf0fb735, 0xff261f77, 0xfe527533, 0xeaa6be87, 0x41f79ffa, 
	0x67b01bfe, 0x2c239e78, 0xd94ce7ff, 0x80dff2c9, 0x8a79a05e, 0x618239d5, 
	0x2d5cd5e3, 0x9affabc7, 0x94b627d2, 0x22ec821b, 0x95ee5bc4, 0xca1f95e3, 
	0xcdf58fbe, 0x93b96299, 0xfb040bc8, 0x9336db3e, 0x5d10cfae, 0xe638881b, 
	0x204f8b54, 0x8854e70f, 0x4f081b03, 0xbd32ae73, 0x3f743999, 0x9bdd6b18, 
	0x779f833a, 0xad72c534, 0xae48b4a9, 0xdcc7de63, 0xfd24d19f, 0x3f815fc7, 
	0x95e7e0ce, 0x1b8af8bf, 0x61c55f75, 0xdc62ef69, 0x6ddc6a6d, 0x55e7caaf, 
	0xf08dbbdf, 0xca9f27f9, 0xe2ec3667, 0x6d737ff1, 0xdb6f9ca1, 0xb2fee4ff, 
	0x9e37657e, 0xcc707e35, 0x41f8a677, 0xfe72cdf9, 0xc6c75a72, 0x758dffcd, 
	0xbcf09f88, 0xc0525aff, 0x33ec0ef3, 0xbebe73f4, 0xd0647669, 0xedc1867a, 
	0xff2906c4, 0x897c4a67, 0xbdf9b7fa, 0x2fb1f1f2, 0x95fd1b84, 0xc743671e, 
	0x0697ed2a, 0xb25388cf, 0xd953e23f, 0x72921f0f, 0x6a33fc35, 0xfb934ce7, 
	0xb83d539b, 0xc867dd2e, 0x90d0497c, 0xaa399279, 0xb71bdd2e, 0x207750ca, 
	0x8865d9e6, 0x521a140b, 0x85a887cf, 0xd5739efc, 0xe81ae790, 0x3f8757b9, 
	0x956b9de7, 0x56fec43d, 0x6dbf0191, 0x315655ce, 0x5ec791d3, 0x033ad9b3, 
	0x185b423c, 0x7ab49f1e, 0x23e87c55, 0xa777c786, 0x3c217e54, 0x73f6c746, 
	0x56b8ab3e, 0xc62238e3, 0x6bfc75ed, 0xf7d53f85, 0x267ed2f6, 0x9a8b7daa, 
	0x3ff1e3bf, 0x60ee70db, 0xf84f89fc, 0x9cdf47fa, 0x737f0836, 0x6538ca4f, 
	0x3d3e33cc, 0xedb3f59e, 0x239fb2cb, 0x3f514fd2, 0xac9b5da6, 0xe0077ea1, 
	0xab1f3c49, 0xe452f194, 0xc37e788d, 0x72976f72, 0x2a7a0dca, 0x1ee7d43f, 
	0x6a5fcf49, 0x5fba7a48, 0x21162dc1, 0xa4c324be, 0x8b5d5368, 0x75c6df53, 
	0x2dcb01be, 0xfacae3cf, 0x5a31b9c4, 0xb73f8d0f, 0x10d5f6c5, 0xf7a0cf1f, 
	0xf9c937c7, 0x8b514e31, 0x8efc86ed, 0x7b78c915, 0x2b6cfbcc, 0x7b48bef8, 
	0xed99382d, 0x06de3342, 0xdc5f4883, 0x2767e7ca, 0x11d46eda, 0xae09f716, 
	0x5253d057, 0x78218e7f, 0x2cb2fcb2, 0x7d0b710d, 0x9f3b564a, 0xf9f26df7, 
	0x1921438a, 0xabe7d15f, 0x76d54e73, 0xc531ea2b, 0x64136a54, 0xd884b60b, 
	0x177ce2df, 0x70d697e4, 0x3e4932d0, 0x6c9e55a6, 0x532793b1, 0x9e543de7, 
	0x726d502c, 0x6878b61c, 0x7c83617d, 0x99f17fbe, 0x5f7a63f3, 0x01e8742a, 
	0x2435ee21, 0xbc9c8b3e, 0xfcaf8d11, 0x9c3774ad, 0xce32a9fe, 0x1d10685b, 
	0xbf78e3ce, 0x342feb0b, 0xfa9b39e8, 0x395a6537, 0x6d537a4f, 0xf2e58adc, 
	0x9906c162, 0xa4db9d3f, 0xf8209fe0, 0x5fc75f63, 0x3f053f71, 0x77b9683a, 
	0x516b0e91, 0x7659e57c, 0xb6ba15a4, 0xbc46fad8, 0x714b7496, 0x571f6a8f, 
	0xb5aaf3ed, 0x17f6ca57, 0xdb2e3daa, 0xd907d8d5, 0xc91fc533, 0x8f61d73e, 
	0x20c43ac4, 0x24ee06fc, 0xe43de07f, 0xaedcfa61, 0xf077494e, 0x8c86120b, 
	0xf89013df, 0x5eaf3d3d, 0x51aceb86, 0xe31c7947, 0x4aea248a, 0xd588f206, 
	0xe49b9731, 0xfd219d73, 0xcb3189ac, 0x1055ef8f, 0x7f2abd1c, 0xcaf42af8, 
	0xafcd5adc, 0xfd9b94f4, 0x1ef5cc53, 0x792d3386, 0xf454875e, 0x297c9cf1, 
	0x48a8f252, 0x86ad91c9, 0x49b3173c, 0x1cfa01f1, 0x23a81c87, 0xa0e1bb26, 
	0x5a7bf990, 0xb093c87f, 0xfdf16e7f, 0x7341983a, 0xcee199a6, 0x6dce5283, 
	0x298f30b3, 0xde4257b2, 0xcfd80564, 0x3ed38fd9, 0x7649e0a6, 0xfcfe124e, 
	0x9d4b5e40, 0x967920f3, 0x1ba3fd84, 0x75e2e322, 0x35ef5cdb, 0x47e09aa7, 
	0xdf562e80, 0xf378e0b9, 0x909704e3, 0x15bdefe5, 0xec723c79, 0x647c95ab, 
	0xa3f7b37a, 0x7a08a0de, 0x9fbe3de5, 0x773c7d6d, 0xb46ace5e, 0x7873ad85, 
	0xc1f214a6, 0x9af3bf39, 0xd333cf21, 0x5f80c27a, 0xbf9a6cf9, 0xf7c9e94e, 
	0x9b85e700, 0x98535f80, 0x321e2aa5, 0x613fd942, 0x1ed6e7f4, 0xbe9e7308, 
	0x2cf4dcd6, 0x6988aff5, 0x3399771c, 0x8d7fbe45, 0xc7d51f8a, 0xebc939e5, 
	0xf68b1788, 0x074b3e30, 0x23230f7d, 0x6e3f3046, 0x647c4e17, 0xe47c7e44, 
	0xbad7150a, 0xbf4f9d56, 0xdebfad46, 0xf5f1cd8e, 0x7d78baf2, 0x7313cdd7, 
	0x5cfda98a, 0xc50b5dc1, 0x27896a7a, 0x85774767, 0x7472db6b, 0x1e203801, 
	0x5fa57d8d, 0xf231eb95, 0x8fbc47ec, 0x07e86c78, 0x70ae59fb, 0xbf5d1e1d, 
	0x41d645b2, 0x7892b9f0, 0xaac50e0e, 0x87e8af3e, 0x33ec3759, 0x9f256fde, 
	0x75556d13, 0xe2b70c90, 0x9e7d4ed5, 0x97dbe5a9, 0x077f0509, 0x3eafbc7e, 
	0xe9f3bf05, 0x0cc61fbd, 0xe2ffb791, 0xcc77c4d9, 0xf018761f, 0x3de2bb61, 
	0x740bbf35, 0xcbec7840, 0x35b42dc1, 0xe77ce6e9, 0xef5c130f, 0x3c5bc0e7, 
	0x3b786678, 0x944ebdf0, 0x579c228a, 0xa7d95abc, 0x7c558bb1, 0xec9bc247, 
	0x778e1ecf, 0x008d7785, 0xf79f677c, 0xb1d75842, 0xae1bd88e, 0xcb6f7a12, 
	0x712f1936, 0x696152ec, 0x9ab7e7f9, 0xf90d2daa, 0x15973e14, 0x0ac79dcb, 
	0x923d93d0, 0x9cefb9ae, 0xcbf32aa7, 0x527a0efa, 0x3b963eef, 0xe9e4d537, 
	0x05df60d0, 0xf7e31a3c, 0x7f75ff87, 0xcc1d7e7b, 0x6fee4faa, 0x73f5e50f, 
	0x6753387c, 0xc4976dbb, 0x22bf80eb, 0xaeb807d2, 0x75c0e88f, 0x4cfbcd1b, 
	0x8afec536, 0xe4d67f3a, 0x39c75cb9, 0xc0e7a199, 0x22ff30ca, 0xbc6d2e75, 
	0x26373818, 0x33ac6e70, 0xde73be37, 0x710d2fec, 0x9d4d3824, 0xb1bc830b, 
	0xe2708544, 0x3d1fa47b, 0x12ba7f47, 0x7909a0fa, 0x6c448595, 0xc5759109, 
	0xe7ca2e38, 0x0bdfa971, 0x73ff96fc, 0x126ad8ed, 0xb77ea312, 0xda9c6c6f, 
	0x196a7f31, 0x38ed4b57, 0x04e3c7df, 0x65747574, 0x6ab6a0cc, 0xd831c7d2, 
	0x5a2e134c, 0xda9cbe39, 0x1e9cd749, 0xdd45a1ef, 0xdce2b807, 0x3cfb2dc1, 
	0x998e1741, 0xeb474391, 0xfd6bf971, 0x2787bb88, 0x05ab7ac9, 0x885e757e, 
	0x79fb0ac4, 0xc20ef4b4, 0x9d7f48d3, 0x755ded9f, 0x8465d52e, 0x83f5ce84, 
	0xae020fe4, 0xb7301906, 0x3e8cbf31, 0xac7e41dd, 0xd03dfad5, 0x61165df3, 
	0xbe2f37bd, 0x74c5390c, 0xddb3cf22, 0x79f2cd69, 0xd73c6712, 0xe90ae7c7, 
	0xf31a45fe, 0xef3b57d7, 0xa399f516, 0xffb6a45f, 0xb9d06b23, 0xe16aa6ca, 
	0xe211ed6a, 0xffccbf62, 0x149e74d2, 0xb8f3cfad, 0x7cb2d7e9, 0x50fd928e, 
	0x4a9ebf67, 0xce1575c1, 0x34cf2739, 0x20715111, 0x83cac797, 0x0187038f, 
	0x003828b8, 0x5e4f442e, 0x42a572c3, 0x3f62df80, 0xf7a5539f, 0xcf05ddf1, 
	0xfb08dab4, 0xf10335dd, 0xe12fffd4, 0xa8dc7cc6, 0x51ca56f8, 0x5242d729, 
	0xb7763a8e, 0xf992ee73, 0x579f8f35, 0x03b9e1fd, 0x26c9e42e, 0xbd751fd9, 
	0xee243c0c, 0xad455eeb, 0xf1e54baa, 0x2dc6f33b, 0x91caf291, 0x7f38ce13, 
	0x367597eb, 0xb8231381, 0xebe7981e, 0xc8efcdcd, 0xc46ba589, 0xd2d1f041, 
	0xba8ea671, 0xcb9b708a, 0xb863e99d, 0xfe46bdb0, 0xefd37b89, 0x7151aec8, 
	0xd96de080, 0x0e522503, 0x973f4134, 0x2e3ea585, 0x87df95ac, 0xc5220d11, 
	0x477b2578, 0xb9e421e6, 0x7e5c6f5f, 0x2edf0277, 0xc2f33c43, 0x7e7cb98e, 
	0x493d5a93, 0xfc8fdb76, 0x19489cf2, 0x678f1f31, 0xbe935f10, 0xbeba99fe, 
	0x32f99274, 0x5b00adf8, 0xc3c94dbe, 0x0e1c331f, 0x590e5864, 0x7f253fa3, 
	0xdbb4aeeb, 0x8b73bd05, 0x9d04efaa, 0xb4d039f0, 0xc9d244bb, 0xedd05eac, 
	0x6873b92d, 0xbd6b1cf2, 0x41fdc8e6, 0x4f91cbf2, 0xcbdda677, 0xacf4fdf9, 
	0x8e67400b, 0x3e7ffa7c, 0xfa36716f, 0x5b7050b4, 0xbb6270c8, 0x358ec2e7, 
	0xbf4977b7, 0x07bd7ca2, 0x751b02f5, 0x721e07f6, 0x22b7a105, 0xf3dd59f5, 
	0x3f1bc63b, 0xd66854df, 0x8091fe01, 0x89360ed5, 0x51db328c, 0x93eab787, 
	0xcff3da97, 0xc9ed9665, 0x681d73b4, 0xdb83e92f, 0x07851e69, 0xedbc5f47, 
	0xf022f697, 0xc2783867, 0x444e4ab8, 0xbefc682a, 0x5c8afe9c, 0x0a17fb20, 
	0x0fc8df89, 0x596d236b, 0x7a0647de, 0x2d3bf185, 0x7b01d787, 0xc46eec98, 
	0x36c3771d, 0xd5ef566a, 0x86417108, 0xae7a4ffc, 0x47efdfc3, 0xe578f15e, 
	0x9781fb5b, 0x94d33765, 0xf63f0f84, 0xe65b704f, 0x74da7491, 0x5bd31668, 
	0xae0eeb53, 0x7d6a69bf, 0x0b9c21fb, 0x5f4d7e3c, 0xdff98845, 0xfddf876e, 
	0xf2cfdaa9, 0xce10fd80, 0xd9ef2da7, 0x5faa415f, 0x5838ed34, 0x3e5e5e01, 
	0xe702afaf, 0xa28f96d3, 0xe59fb4fb, 0x0edebe0f, 0xf53cbfbd, 0x5fb843f6, 
	0xcf2dc876, 0xfb75db99, 0x1f101750, 0x26ee8f6b, 0xd87778fd, 0x4ba37ae4, 
	0xfc0f9202, 0xe7a1cdc7, 0xeeaa2349, 0x8bea0c6f, 0x115c5a1a, 0x96e6a5c8, 
	0xbb751d3a, 0xa46616df, 0x31aefb8d, 0x6db29220, 0x5a0fd823, 0x3188e0fe, 
	0xf2cf34e5, 0xa017f77b, 0x96149cfe, 0x30e09db6, 0x95c640b7, 0xac9acbc5, 
	0xcdc27b1b, 0xd9fe49f5, 0xeb0b94f1, 0x6d022d9c, 0x4cffa98b, 0x30657342, 
	0x775c75ce, 0x758bcc61, 0x4d1e03b4, 0xee341744, 0xb5c4d95d, 0xd967da1e, 
	0x813e7a1c, 0x13ca4d7e, 0xe0e4fd47, 0x239670fa, 0x1e9e40ef, 0x336127ac, 
	0x3d221f20, 0xb72942c9, 0x1f8d3ee9, 0x9b7a13d9, 0xd4c364ed, 0xf745af51, 
	0xf4d44883, 0x677f0687, 0x66fb07e9, 0xee7ac68d, 0x03ab15da, 0x16fe301f, 
	0x8fdd73aa, 0xa7bf382a, 0x368369ce, 0xc3c78b4c, 0xde41d6be, 0x20fa93ef, 
	0xa20fba89, 0x9480dae7, 0x1f95f18b, 0xa6e42b7f, 0xd4499f79, 0x8f7fc9f9, 
	0xedfd2c5f, 0xc311e008, 0x1dbea638, 0xd46b6b78, 0x47357fcf, 0x137b6587, 
	0x7ce3b075, 0xadff9497, 0x7ae1c793, 0x056bfa4d, 0x37b8a8bd, 0xef5923fc, 
	0x7e565e2c, 0x1e7568c2, 0xfa5bb0b3, 0x6f230f65, 0x41d152b8, 0x4677eb53, 
	0x58f8bc63, 0x23f00aab, 0x9761d4fa, 0x097e012e, 0x82615d7e, 0x6527d91b, 
	0xf00497a0, 0x4b2751b4, 0x1753e844, 0xc2b9f057, 0x0f3fba32, 0x475618f0, 
	0x9fbc095a, 0x231ece67, 0x2aa441cf, 0x614eff81, 0xefeea215, 0xd115d001, 
	0x796c8ad1, 0xfd0c76a5, 0x1f0b2564, 0x758c3e61, 0x6566174f, 0x0bd27edb, 
	0x67443fd0, 0x39cebd65, 0xf861f308, 0xace7e1ab, 0x4f5a72ca, 0x8ee885a4, 
	0x99e2b610, 0xa1f82aaa, 0x2f42e7e1, 0x07570e83, 0x8e6ebc54, 0x5dc5d647, 
	0x5c3a61ef, 0x24c6b411, 0x01ee3689, 0x7b3f621d, 0xfa043c8e, 0xa657e076, 
	0x27bcd0f0, 0xf8f830f4, 0x3a12679e, 0x92ec6596, 0x024b90f5, 0x83291fd2, 
	0xad3b2160, 0xdba4a779, 0x2f9228e8, 0xc91ef0f3, 0x98abc22d, 0x89bcb26a, 
	0x885f9c77, 0xbeb2faba, 0x2cd7ae5a, 0x1eb550fb, 0xb749fff2, 0x1b544595, 
	0x5faf295b, 0x2bd9daa0, 0x352cfaf9, 0xb20dd94f, 0x7ecb5e7f, 0x3382fefe, 
	0xddabc13f, 0xe59f9bca, 0x4cd9e326, 0x54468f41, 0xf551237d, 0x099df918, 
	0xcefcbd6b, 0xf4063584, 0x5993d910, 0xedf5a21f, 0xf0e0f450, 0x5bded965, 
	0xb5279675, 0x6653bf32, 0xaa9d76ca, 0x90175cef, 0x143bbdf5, 0xef561e3c, 
	0xbb3f9f4f, 0x03ff7e0a, 0x8e75b3f5, 0x97f82bc7, 0x3d30f62d, 0x56dfbf85, 
	0xf0a60cc9, 0x41f00f71, 0x784f5e70, 0x0a5eaac4, 0xf0cffac8, 0x832fc3f7, 
	0xb1dfa6ef, 0x62e83d69, 0x7443aaba, 0xa7a1cae8, 0x03d480b6, 0x30bad42b, 
	0x234eea1e, 0x3c65ae7b, 0x3acb7644, 0x7521e6e3, 0xbd6a8dc6, 0x23ad527f, 
	0x866f19a7, 0xe15c57c2, 0xd5f0ae2b, 0xabd5f0ab, 0xf85715f0, 0xd17c2b8a, 
	0x3203dbf5, 0xa2f8cf6f, 0x97d5b4fe, 0x8343355c, 0x48e84f9c, 0x8ea1963c, 
	0xfa0cf215, 0x47f2c92f, 0xba677c87, 0xae477821, 0x65ac7594, 0xdb3db301, 
	0xaec2f527, 0x859b6557, 0x75d1497c, 0xf883ce53, 0xd68fef09, 0xacd80d1d, 
	0xacaecb4f, 0xe4658f6f, 0x2e0873fd, 0x4ca4042f, 0x9f11178b, 0x00533d4a, 
	0x267b28ba, 0xdb7413b6, 0xb7be2415, 0x2742f273, 0x3a7e8cfd, 0xc6e3c255, 
	0xc43ac48b, 0xdd54ba99, 0x38275f3d, 0xe320583e, 0xfe155b15, 0x15ee22d1, 
	0x92e34ddf, 0xbaab4a9c, 0xb133f8fb, 0xb5bdf54a, 0x97ddd44a, 0xf43a9b55, 
	0x5922597d, 0xae92fd09, 0xaa65f296, 0xdf212bb0, 0xcca8976d, 0x5e672eff, 
	0xb7af3ddd, 0xbbac9773, 0x9eeea34f, 0x79fe82ec, 0xd03c6433, 0xe7d8e19c, 
	0xc4e8e75c, 0x7a7d9d13, 0xd7255345, 0xe7abd447, 0x9df3e41b, 0x1bfe3388, 
	0xd43354f2, 0xf066d977, 0xd7f7ce20, 0x86b76a0a, 0xbd9cb6da, 0x9d4cbeee, 
	0x38f32e63, 0xf7fb51df, 0xd3f208c0, 0x0fb122dc, 0x1d67bcf0, 0x97c311f1, 
	0x7a0c7ce0, 0xa5e58be9, 0xef44d743, 0xbb48f68f, 0x7b5b68ea, 0xcb8d3e8e, 
	0x4a15cec9, 0xb6e62c5f, 0xbae2f110, 0xc737c902, 0xb0eac9af, 0x78ec8c27, 
	0x40c2befe, 0x6b4cecbd, 0x122ee83d, 0xee807730, 0x8dd4f496, 0xdd95dd06, 
	0xd80edd71, 0x94f64b59, 0xfdd1dd30, 0x9c313654, 0xba29fcee, 0x5457744e, 
	0xc96ee920, 0x989cf295, 0x3dfe7743, 0x7740a6d7, 0xf3ba0fb8, 0x9bba4817, 
	0xb75382fe, 0xfa085eda, 0xdae7b25e, 0x1947c01d, 0x5e9183ce, 0xebc7725c, 
	0x88939dfc, 0x245a1648, 0x75eeefef, 0x167dbc71, 0x49ab3fbd, 0x8cdb279d, 
	0x764777f3, 0xddbf0084, 0x2e7187a1, 0xbc8df409, 0xd64279c3, 0x74fb4f67, 
	0xcafb0696, 0x40c7341f, 0x5fdfc7cf, 0x42bf0853, 0x80159b94, 0x8ef7ddfb, 
	0xebbeaf58, 0xba0fa1a2, 0x56f9a4ee, 0xa8d1cd84, 0x59e7a6d3, 0x24392fbf, 
	0xefa7b4eb, 0x4b167595, 0x4dde96c3, 0xcdc723f7, 0xa0cceeda, 0xd7c66d3a, 
	0xaf520585, 0xd02ade13, 0x8f71965f, 0x52da7591, 0x78552dee, 0xb5b3565b, 
	0xbb69d642, 0x0aed3a9d, 0x834b0bd8, 0xb4ea0566, 0xbebcf5a7, 0x1dd2e716, 
	0xb7bb4d7c, 0xb2e03d64, 0xf59ba5ac, 0xa7e94464, 0x055bcd48, 0x21750718, 
	0xb27ed3a8, 0x4c5dd640, 0xfb1e7253, 0x1176efe2, 0x8da7501c, 0x7beec1fd, 
	0xb9ca40aa, 0x7205e02a, 0x8532ed03, 0x85e05287, 0x6df10fe4, 0x0eff72a4, 
	0x0aa3c1f8, 0x511dffa4, 0xd01f2fcf, 0x277f2623, 0x8dd5f44c, 0xc4f056ee, 
	0x83d9cd7c, 0x21ebf23a, 0xef974f25, 0xdce21774, 0xd8afd73d, 0x3a831fdc, 
	0xc5d668f4, 0xe41a607a, 0x8867083d, 0xd148b87d, 0xd79df2f1, 0xd4ca7af2, 
	0x135497be, 0x6618849e, 0x95f33aa7, 0x0eb0f9a9, 0x9ba9d9e0, 0xc1bcc329, 
	0x1865bcdc, 0xde7c3937, 0x3c640a1b, 0x0215d78b, 0xf542ad1c, 0x979601dd, 
	0x6b1ef7d3, 0x1ddedd07, 0x3f6347b4, 0xf1f221d1, 0xa31f256e, 0x8f23e443, 
	0x90b6527b, 0x22df248f, 0x3df10b90, 0x3de11e34, 0x36eca95a, 0xec0b66bd, 
	0xf1def8c8, 0x165e4a85, 0x101ef7f2, 0x2738fe2d, 0x5b57a707, 0x69e3e085, 
	0xf3f7c4d5, 0xefcaf6e0, 0xe3b3443b, 0x9e9bffd9, 0x196a1648, 0xcf2a9fd8, 
	0x01f53b62, 0x797962c4, 0x9ecaa996, 0x3a938af7, 0x7ef729d7, 0xeaaf3e43, 
	0x3e3da614, 0x2fe80b7e, 0xec61e4ea, 0xdcdca58b, 0x94fbf837, 0x850f0d05, 
	0x976722da, 0x2e75518f, 0xc83b4509, 0xd09e6e43, 0x08f9005d, 0xc87c14bb, 
	0x850af272, 0x92cf5a5f, 0x75ad6f3b, 0x677fe675, 0xcbbe3072, 0x1ecdfb34, 
	0x2d313fae, 0xf69df38b, 0x8c3be99f, 0xf05f49c4, 0xbf87461d, 0x2c5f14aa, 
	0xd3cf2439, 0x52c75718, 0xdd96f388, 0xc00efafb, 0x5adb39ab, 0x3db23c01, 
	0x14f65096, 0x6455fdf4, 0xc07e8247, 0x23c82e67, 0x92ecefe5, 0x3d81c1df, 
	0xc9ce6ae7, 0x244e470d, 0x72cfdf3e, 0xc5a89de9, 0xc2b44976, 0x5cb5e4e5, 
	0x54478388, 0xdafe925c, 0xe32790d3, 0x52878e6c, 0x7682dd9b, 0xab63ac52, 
	0xb11b7386, 0xf007d28f, 0x97756c7e, 0x3b17f11b, 0xbe0af5b8, 0xe1d1ec1f, 
	0x9c35b8df, 0x379a1c5f, 0x871ada19, 0x58d9ae0e, 0xae1bf1c7, 0xce3a5ec3, 
	0x43fae1fa, 0x976aefb4, 0x7da3a5d6, 0x53750fb4, 0xc7c6ebcd, 0xeed1dabb, 
	0xd11b637f, 0xf194f379, 0x6d704d22, 0xaf67569e, 0x1d66bd65, 0x6cb0435d, 
	0x2efb24de, 0x3f9bbca5, 0x1bf7ffdd, 0xbd237de5, 0xb624f316, 0x3cc6cd74, 
	0x18d3c7b1, 0x81fc7aaf, 0x7e37cf34, 0xdf1e5ef2, 0x20fa72f5, 0x5d75c7cf, 
	0xaff653cd, 0x3792db5e, 0x36bab4de, 0x25835f35, 0x321b6be7, 0x97cd4a5f, 
	0x8f82d6b6, 0xf40a7f2c, 0x6e4f986a, 0x5c271bcd, 0x65b7bf6c, 0x6e63ad16, 
	0xd4b1f78c, 0x56c17337, 0x6f179fa9, 0xe2f3c768, 0xeeb556f0, 0xb7850ece, 
	0xd25bc01e, 0xbeed227d, 0xddc684a7, 0x56f52456, 0xa58bc954, 0x80d17f9d, 
	0xd3d47a7c, 0x85f9c01a, 0xd3ec5ef7, 0x5973fe71, 0x8348e0e6, 0xa505abf0, 
	0x2173c43c, 0xafb12e7a, 0xa13f856f, 0x7c9169f8, 0xf45afe0e, 0x381fd371, 
	0xf6ecf981, 0xe8abe934, 0x0e496a64, 0x488af744, 0x67673651, 0x7a82ee20, 
	0x235ee8b5, 0xec8bb452, 0xd2a9d460, 0x3245323a, 0xe4fb4c9e, 0xa7f41573, 
	0xe38c3b29, 0x1dd78676, 0xdb361c40, 0x8678e321, 0x1f09f075, 0xb8d517f5, 
	0x437ba0dd, 0x4fe0b2cc, 0x09a25bf5, 0x893447df, 0xd7a70016, 0xf45d648a, 
	0x6a350fed, 0xc6b469e3, 0xf2664be2, 0x771179f9, 0xafe90fc3, 0x9dca44b9, 
	0x336f595a, 0xf55c1df0, 0xce30dc7d, 0x833ed0f9, 0x40344390, 0xd44bb6ff, 
	0x944bc9b9, 0x57d727bd, 0x5b2c9260, 0xfedf9b94, 0x3160ad5e, 0x7cee9961, 
	0xad17707b, 0xde735e67, 0xac846d77, 0xb320be93, 0x7e49a67f, 0x2d7fa370, 
	0xfc62539f, 0x4634bf11, 0xb1f02aad, 0xcde65ebf, 0x897e3f1a, 0xc467cde5, 
	0x893e2943, 0xfe28f32e, 0x1ac74d78, 0xd2c30be8, 0xb96fa1f6, 0x1c3c03af, 
	0x736ff57e, 0x30c575cd, 0xea11764e, 0xb1e20ab1, 0x18bd358e, 0xa78e32ef, 
	0x273e3c62, 0xcf8874d5, 0xd10dfbeb, 0x85bf7384, 0x258eafb4, 0xfcd2a388, 
	0x55dec077, 0x87c9dd72, 0xe8f052ef, 0x3c5bf055, 0x1d3d7bf8, 0xf888337e, 
	0x25ab9f14, 0xa0aee4bb, 0x4aee23a9, 0x90e3fe7e, 0xfdb6e153, 0xef82777a, 
	0x6e329deb, 0x647a70f0, 0x7d1bee2e, 0x8870f631, 0xadbbbb9e, 0xcf4330b5, 
	0x8c2f9b2d, 0xee39f39e, 0x3c1377a7, 0x022cdc96, 0x4f2fa221, 0xd15b8ca1, 
	0x5a479cf8, 0xed17f88a, 0x7d0bd977, 0x976e810f, 0x100f7bd3, 0xb38822fe, 
	0x38c49fc2, 0xb9e8fbb0, 0xf1c38222, 0x6375649f, 0xfb54ec1b, 0x5a1f74a1, 
	0xb3f41db3, 0xc7d5d944, 0x85563c37, 0x6f888373, 0x22e8eec0, 0x5ee7963a, 
	0x0788fdec, 0x0fe6a05c, 0x8273cb14, 0xbafd9e91, 0xbb2dfc20, 0xc704f432, 
	0x556a7edb, 0xe95d1e01, 0xfe71aac7, 0xf59467b9, 0x4f68f438, 0x3f1c1bcf, 
	0xe9b8da6b, 0x9efde871, 0xdec73b01, 0x89f8e699, 0x7f7e4635, 0xf8e4accf, 
	0x61566189, 0x69411dfe, 0x45f5d077, 0x79724eff, 0xeef75ff9, 0xb5da80bc, 
	0x1f1ecf2a, 0xfd804d6b, 0xed2c25b9, 0xb0c3f810, 0x46ee395b, 0xcc4baef3, 
	0xbf5243d6, 0xc2e7ce3f, 0xc3b9e8ca, 0x984838f8, 0x6a7d14ed, 0xa0f4254d, 
	0x81267a1f, 0xb8e02e75, 0x4cfece4b, 0xa57c7155, 0xfa0aada9, 0x373fb1de, 
	0x2fcf8b08, 0x1ba96b2f, 0xaba73b03, 0x635abcb6, 0x9159323b, 0x88899dff, 
	0xe8dbab30, 0x4e5d8afe, 0x1c7ec55c, 0xbb65e5f5, 0x4b8e1feb, 0xfbe1a8bd, 
	0x3a1f1b12, 0x329571ce, 0x168859c4, 0xbe742d1f, 0x94f5212f, 0x02ab69ef, 
	0xb08d9271, 0x508890b7, 0xf4f7cb7a, 0x2bf0fd91, 0x7faeef36, 0x88a1e382, 
	0x37fc10b7, 0xdfb30cef, 0xf33bb3d0, 0x3eb7d638, 0x4f6d5668, 0x9b5fe2e4, 
	0x02782e77, 0xdeff44f1, 0x37e78eac, 0x083c9d11, 0x7a4bd379, 0x87e157b2, 
	0xfbbb5fde, 0xf2ac4ec8, 0x3ea50abf, 0x39b28e8e, 0xcb5772de, 0xaed07bbb, 
	0x41c5417d, 0x9e844710, 0x79e68d4c, 0xf4488e39, 0x9789d77a, 0xef80d746, 
	0xf98cbf3e, 0xf13c686e, 0x93e4b0ae, 0xde842fb5, 0x27154916, 0x10b8a84c, 
	0x91cf6cf8, 0xe123f876, 0x476bae27, 0x67f30b78, 0x1f9fc706, 0x42fffd63, 
	0xc110e1e8, 0x5cb26bad, 0x37f6279f, 0x33e89ebc, 0xf6bcfe32, 0x076c05a6, 
	0x9e833ddc, 0x0e3c379f, 0x1a67e039, 0xd46737e4, 0xd3c8357b, 0x747778c8, 
	0xe20fdcb6, 0x22a7b08f, 0xbb63af3b, 0xa262f232, 0x6cb6720e, 0xb1fb1bd9, 
	0x6962c2fe, 0x671d2e87, 0xf8f7e446, 0xfa250fc8, 0x2faab6fa, 0x4c6b38e0, 
	0x3945c40c, 0xc5c89ace, 0xdaae3941, 0xa52efb97, 0x1a1d1713, 0xe8f8e4e7, 
	0xeebeb1bf, 0xfb7a4adb, 0x1d0262c2, 0x89b98dec, 0xea5fd127, 0xb80f22d3, 
	0xbd5ccf59, 0x29b0f595, 0x88d4a9cf, 0x9630ea08, 0xf5203dce, 0xe58d6ce6, 
	0xca163fc4, 0x553795ef, 0xf07a3e13, 0x7819789e, 0x088a0869, 0x8a0f9bfc, 
	0x5a09fe24, 0x3cb9fe7a, 0xa91b5e27, 0x791d172d, 0x4d48daf1, 0xaee77f0d, 
	0x795af9ff, 0xd49f6eee, 0xb2237b23, 0x7657595e, 0x1ca089ea, 0x9960e597, 
	0xd6fe0f9c, 0xe2dd55b7, 0xfdeccbd2, 0x7e88f9f9, 0x0b4a7f25, 0xda519c25, 
	0x6a24fc8c, 0x737bbc13, 0xd5044af9, 0x7f131ff4, 0xfbdb6e58, 0xd457ac5d, 
	0xf9737b5b, 0x66051d49, 0x7ca0c4d3, 0x4313f22d, 0xd23cb7bf, 0xfcf9d1e3, 
	0xd8b73aa3, 0x0ea24370, 0x5e123bc7, 0x9e6b7b4f, 0xa50a271d, 0xa16dfa9c, 
	0xc7f5938c, 0x79121e54, 0xe7e1d6ca, 0x52ef9c28, 0xe464713a, 0x7c79d32d, 
	0xfe962f11, 0xdf527866, 0x065e1b47, 0x6df7139e, 0x922f018c, 0xf48f191e, 
	0x99411bde, 0xc6f0733f, 0xbc66eaf8, 0xed20df4f, 0xbe35faa6, 0xf86270e1, 
	0xe5e127bc, 0x9c3868b9, 0x8666ba9c, 0x9c5c1e53, 0x34f538fd, 0x6382370c, 
	0x2e12d5c3, 0xd4b9f743, 0x1ced8077, 0x098ebea8, 0xc7ce1ebc, 0xed036826, 
	0x8b7b49ef, 0xdbb200ed, 0x42ffc7a0, 0xd2a471c1, 0x988ea347, 0x78c9e723, 
	0x57c3c8ea, 0x1e6c3b48, 0xea310beb, 0xd103f430, 0xbf24d9a5, 0xed38886f, 
	0x3e565b85, 0xe1764358, 0x9d7b0185, 0xc51943aa, 0x76c56ef5, 0xbc13ecbb, 
	0x763c67a1, 0xf31f51dd, 0x8c8fcee1, 0x13b97e9c, 0x52dd90e3, 0x8f85c8f6, 
	0x36ebe64d, 0xbd9647e7, 0x0eadfa40, 0x6c93c3fd, 0x59be00fe, 0xa3ffeb83, 
	0x4a779d56, 0xbbf24988, 0x0739c26f, 0x039e493c, 0xfedbf996, 0x77ee755a, 
	0xfa2ba49e, 0x3abef3bf, 0xc8d764ff, 0xbfc5aa3c, 0x697e4113, 0xe153f504, 
	0xb2966b62, 0x5e1db37f, 0xe67d5bb2, 0xbfb46dc8, 0x647b3e65, 0xfbe5fbd6, 
	0x4b597b26, 0x2874ff11, 0xeaa91dfe, 0x3e2abef5, 0x3a8ef81c, 0x7774bccb, 
	0x417dd614, 0xf10a3926, 0xafb09700, 0x457cfe42, 0xd82eab4f, 0x92ad6ebe, 
	0x7a9135df, 0x7d57abac, 0xd239e4d7, 0x7a53f867, 0x442389cc, 0x11e2bc54, 
	0x3487d1f0, 0xfe7a9ece, 0x39efa82e, 0x78935df9, 0xbe283591, 0x7d9bd91a, 
	0x4b73720c, 0x9b00ec90, 0x4d77f3af, 0xd76af89c, 0x16c1f890, 0xa9740fe5, 
	0x1187c1f8, 0x88faaf59, 0xa8b45be2, 0x765db52f, 0xd01f8c85, 0xaef784f8, 
	0x89c1f881, 0x20fc6487, 0x07e3255b, 0xade21556, 0xe74b6a91, 0x138aa13c, 
	0x0ac91244, 0x5cf10fad, 0x2f7e4aab, 0x274dca52, 0x885530be, 0x910fd86a, 
	0xfbf96aa6, 0x9ecabd16, 0x0f5036dc, 0x471f915f, 0xfe3e6ae8, 0x49aefc90, 
	0xd5f1ceaf, 0x2de7b28c, 0x388d5f19, 0x6ec755f1, 0xab7655ef, 0xf6d83f13, 
	0x1f8c2fb3, 0x357c5444, 0xdd5f1032, 0xa9df885e, 0x9c7ecff0, 0x1f8e64ed, 
	0x0984bac8, 0xb4c2ffac, 0xbaa3b22f, 0x06653760, 0x55ab57c5, 0xa4ed957c, 
	0x83ceca15, 0xe309b1dd, 0xf1d5955f, 0x915f135d, 0x9511e394, 0xb29888f7, 
	0x4fe6a0dd, 0x07bcca14, 0x125e039e, 0xed97de4a, 0x55e328de, 0x61be647b, 
	0x437c90ed, 0x7b8e5057, 0x897f1a89, 0x553a9f53, 0x9511f5fa, 0x7ca8886f, 
	0x1be54443, 0x10df2a22, 0x8886f951, 0x544437ca, 0x245221be, 0x95110df3, 
	0xfe7ce86f, 0xa466ab92, 0x7ce65ed8, 0xd9f10443, 0x88bc9cee, 0xc4ab24f6, 
	0xb2df5a4c, 0x8c7dfc05, 0x3bb24cc8, 0x61db6e2c, 0xc8f7f85f, 0xc5c603fc, 
	0xcb223477, 0xb9e3b536, 0xd3379c5c, 0x475535fe, 0x2975c5dc, 0xf71839f6, 
	0x51d6c37c, 0x0f390bdf, 0xeaa93c3c, 0x2ffe5836, 0xd3acbee4, 0x86738848, 
	0xfb80977c, 0x7fa23c8e, 0x78f5964d, 0xfd75fbf2, 0x3da44af3, 0x27c8ef54, 
	0xc03fb931, 0xc11ce8f2, 0xd4419af3, 0x817eb2ed, 0x9acfbd1f, 0x10cd7ecc, 
	0x2c27c33d, 0x4efae56e, 0xfecdfa81, 0xb473e0f8, 0x064b9c2e, 0x6fdfaa7f, 
	0xb927aa1b, 0xbf18f5fe, 0x6b1f416f, 0xcef9c285, 0x5eaf3ca4, 0xdbd06c2c, 
	0x7133eb97, 0x33e8abf0, 0x475956f3, 0x8d9f4c34, 0x233eb33d, 0x337b623a, 
	0x12b4b1de, 0xd02ec6f9, 0xeba0e113, 0x9e82d543, 0x8aec87c8, 0xf32636a8, 
	0xa8175d89, 0x3bccb676, 0xeba67a3a, 0xaf3fd906, 0xf9063925, 0x7ed5a7e1, 
	0x08fb2a37, 0xfcfa1172, 0x37e7456e, 0x9741f8ab, 0xb89c57f2, 0xadbd3dd8, 
	0x5e7b6215, 0xfde54f3c, 0xcebc7722, 0xeec71979, 0x42abfe27, 0xbb91db7e, 
	0x47755346, 0xbb3c89fb, 0x6571f17e, 0xbb2bd7d7, 0xba3b62de, 0x91f5d94c, 
	0xbdf5d9b3, 0x6b7aed43, 0xbcdf5d90, 0xfb79e65b, 0x9f3d9377, 0xb1bf3d84, 
	0xb613f91d, 0x08fde9e7, 0xb79a77ec, 0xc8bff60c, 0xe76cebd9, 0x7f3d9427, 
	0xa4fbd94c, 0x90cfd743, 0xdf7b6078, 0x67f9d9cc, 0x9eb7ebb2, 0xfb67aec1, 
	0xd76731bd, 0xfd8efdb3, 0x2bf7bec2, 0xed9bbebb, 0xe61b23af, 0x78b5fdb0, 
	0x3c9cfae3, 0xc743f271, 0x1a3adc37, 0x2d9ae8fb, 0x66ba26eb, 0x4abe32db, 
	0xecef8c7c, 0xe3245d5c, 0xf807904a, 0x52d18ece, 0xcd9ed1d5, 0xe42589c9, 
	0x96af837f, 0x4e403e40, 0xff805e40, 0xbe598597, 0x43e4abdd, 0x63cceed7, 
	0x7c80df80, 0x11e9b658, 0xb31d9df9, 0x7d43e53e, 0x7a4fbd0f, 0xc9d14bbe, 
	0x8f8f3bfa, 0x2216f7c6, 0x84ec8e7b, 0x6cb5dc3f, 0xc8d08ec1, 0xe4ed3f9c, 
	0xb4feee73, 0x33fe0ab5, 0xce4acdc9, 0xb73fbcd7, 0x5273e542, 0xbce1ae6f, 
	0x9c91e711, 0x721a4e3c, 0xb238f39f, 0x790ba93e, 0xd2d05a1c, 0x671e6467, 
	0xc873f905, 0xcb0d9483, 0xdb7cc8e3, 0xf343459d, 0xf74cad38, 0x0a037503, 
	0xe3c867be, 0xf39d5e70, 0xbb8eb42d, 0xfbc9c791, 0xf7ddcede, 0xe643b6be, 
	0x3ce5ae71, 0x28cf938e, 0x09c7921b, 0x7d7ac914, 0x3c9c9f87, 0x0ff69a4e, 
	0xc3fb073f, 0x124583fa, 0xd037e04e, 0x030bd952, 0xe1d1dddf, 0xd777fb6f, 
	0xc31f5d73, 0x7bdfc53d, 0x897f40af, 0xddf1d3a8, 0xe4bb659d, 0x1dff05f9, 
	0x8930edd7, 0x71a1aedf, 0xaa3e80ae, 0xef81dbac, 0xf6502cee, 0xef23ae18, 
	0x5f3a05d3, 0xcd856d4c, 0xabd15a75, 0xab9d4444, 0xa7223cd5, 0xa986fd5f, 
	0x1d746f21, 0x4829c4e4, 0x7ea1a15b, 0x6d557a32, 0xaa29cf84, 0x0feac7df, 
	0xeb0ab4fc, 0xd91efc69, 0x03c44925, 0xf473e3ef, 0x3fa4e55d, 0xf7bad00e, 
	0xc3885559, 0x575c7638, 0x1147ae88, 0x451c4a87, 0x0db2efdd, 0xdf1231ff, 
	0x09f4687f, 0x9aeb8c97, 0x339adb56, 0x6c4a2b9c, 0xe4dfb8e1, 0x8f77ea09, 
	0x38c95fac, 0x06cbeee0, 0xc5f1a7be, 0x55d99ddf, 0x2aefa674, 0x32fa705f, 
	0xf23af1c1, 0x42ed5283, 0x8d38269c, 0x44ef893e, 0x87be7ed2, 0x868161f8, 
	0x73cb6c78, 0xbfe40fb4, 0x77780648, 0x83ec3ed2, 0x3822ea3a, 0x2ef2484e, 
	0x73cf931a, 0xf6ab309c, 0x4e2e5b7d, 0xf79215d8, 0x6137fe39, 0xc6509c70, 
	0x65dd651d, 0x43c2f104, 0x7db4deac, 0xc415efd0, 0xaec70407, 0xd9e736bd, 
	0xf7d219a3, 0xd91d62ef, 0xc9c79845, 0x79341427, 0x2e654744, 0xce71c93e, 
	0x26f8e0f4, 0xf18027e8, 0x2478b913, 0x9f172dc7, 0xa9791e3d, 0xc597dbc2, 
	0xcbff1d25, 0xb07ab310, 0xb837efae, 0x1a1388dd, 0x67515fa4, 0x397dc4e9, 
	0xff04fbae, 0x279c8f8e, 0xa1f5fd2e, 0x0e276271, 0xdb32b88c, 0xc4e243a1, 
	0xebef81c1, 0xb87c717d, 0x9e6fd69a, 0x987c7b3a, 0x3bf7fff0, 0x66ff034e, 
	0xbe1afb43, 0xb0ee283b, 0x7c71a7d4, 0x0c3b89c2, 0x12ce21c4, 0x267ef877, 
	0x869c8419, 0x38b1947f, 0x8d8df14e, 0x822e322d, 0xf8b726bf, 0xdef3a286, 
	0xd03382f6, 0xe7c58d79, 0xa83d46a7, 0xf2796bbe, 0xf8cfee75, 0xc7f3a491, 
	0x0fe3848a, 0x384f390d, 0xb7ecdd78, 0x3775aa37, 0xbfbaf97e, 0xc74b9d6c, 
	0xefc32f99, 0x051c55b7, 0x1df809f9, 0x8559e691, 0xe6b0bdf8, 0xaf7f8b1e, 
	0xce0af902, 0x1d36ed6b, 0xfde7c2b9, 0x8ccc6fa3, 0x600f7fe4, 0xb23db084, 
	0xa9c64ffe, 0x83c26d22, 0x954e38f1, 0x89dff555, 0xf35ffd5c, 0xebbf936e, 
	0x4eabf1c8, 0xcc95acfe, 0xbd7aaa77, 0x08a91bc8, 0xaeb8d2ea, 0x8dea7211, 
	0xe7f9237b, 0x864e39b4, 0x16eed438, 0x1e54bf29, 0x399789d5, 0x978e33f1, 
	0x071e1c8d, 0x03e2b9fb, 0xce2d938e, 0x9b16c5c5, 0xe8a122ee, 0x66761dbc, 
	0x2ec83193, 0x7b4a8c68, 0xc5189e87, 0x0d0c89df, 0xeb7fafbe, 0x64d503be, 
	0xcb71de00, 0xe0a68b4f, 0xa445e29b, 0xcd5f69ef, 0x01e0a764, 0x5fe287fd, 
	0x120fb62d, 0x133e32bd, 0xf71d406b, 0x5e32b9d2, 0xf11762b5, 0x54fdea19, 
	0x65bf0bbc, 0x61737d0c, 0xf77a2bc7, 0x0d6fdc42, 0xabbd2e22, 0x228fde58, 
	0x36bc8f5e, 0xf027f4e2, 0x6eacbefd, 0xc576bbe0, 0x0489ffd2, 0xc374cf48, 
	0x4c75900e, 0x57e45d91, 0xf6bb3c13, 0x53a8e9f5, 0x720dfb65, 0xcf9bb768, 
	0x909b9dcf, 0xefafe6f1, 0x7bf2ea4a, 0x2f417659, 0xf8db7bf4, 0x7c77a875, 
	0x1f3dc682, 0x7eaa4af5, 0xe917a2e8, 0xe8bfdd3a, 0xf6fa2bf8, 0xeb7d6899, 
	0xe33ad3b6, 0xf852242f, 0xc5ada6dd, 0xb0d4ceaa, 0xf9213fdb, 0xc5855175, 
	0xbef24fe7, 0x7d029d0f, 0xea75bbe3, 0xff2a5bbc, 0x76745bbc, 0x3779c34c, 
	0x115b9ff2, 0xb44f8dcf, 0x2961ccf5, 0xe71f435f, 0x5d6239ce, 0x89a2dbf0, 
	0xe3741ba4, 0xa724e757, 0x06ddd30a, 0x8eb658c4, 0xabfe9273, 0x939c74fa, 
	0xd3f7c674, 0xab9ed93a, 0xdc43be26, 0xbdfcaa66, 0x9e41a33a, 0x8ed02c8f, 
	0x7942b41e, 0xe065acf2, 0xdfa0c19c, 0xcb568c91, 0x7c0e50ef, 0x3d49b43f, 
	0x1651ceaf, 0xc91dfd0f, 0xca91f381, 0x62bf16cf, 0xd94bbb3f, 0x7d0581ef, 
	0xb5d6095a, 0xa92f4fa0, 0x612e7093, 0x9d6b62b9, 0xd1a77579, 0xd474fb9b, 
	0x28bc16e7, 0xa307a8ed, 0x831d77ea, 0x74e99ba6, 0xbb7bb4aa, 0x607690ee, 
	0xeb30b2d7, 0xb565aebf, 0x979b2b71, 0x98b26c77, 0x77a4822e, 0xf2a75534, 
	0xddfc9f68, 0xbe2d478c, 0x687ea3af, 0x17d6546d, 0x7d98bc15, 0xe80a40bf, 
	0xc0d6eb79, 0x3b63f9af, 0x5f53aff4, 0x55588f11, 0x755d114f, 0x9e5b329d, 
	0x20fc48ca, 0x67e0323e, 0x7efe6c04, 0xda57b469, 0xd4bcce13, 0x6a7d63d7, 
	0x71f79a7e, 0x939cef7a, 0x63c08e92, 0x00bb5ec1, 0x58537c7e, 0x345f9068, 
	0x12e0216f, 0x0c2ba96c, 0x2e5f21d5, 0x265bc8f9, 0x43a69dfd, 0x5bd07507, 
	0xef5b90f4, 0x2a35fdc1, 0xefae3c3f, 0x7f8bcab4, 0x8fade657, 0xe6cef475, 
	0x34a6f53c, 0x1aebe4f2, 0x179c1bef, 0x2b5c1fdf, 0x1938bbf7, 0xf65a9e40, 
	0xbaea7973, 0xdea79502, 0xd74bfb86, 0x3aeccdf4, 0xe77dfcc4, 0x5f8c36da, 
	0x367a7777, 0x7d3fc5e7, 0x2cf3c3de, 0x724ef7c3, 0x2fd77179, 0x1794181f, 
	0xfe46fe4f, 0x5d95856e, 0x64f989db, 0xeb9f373f, 0xc2ceb2d7, 0xf216b23a, 
	0xc4717912, 0x6a710c49, 0x0fdc9e6b, 0x6f96c717, 0x2f283839, 0x0f3c937e, 
	0x5aee1d60, 0xdbade783, 0x0d38e4ba, 0x07a50ceb, 0xf29db316, 0x5742e418, 
	0x8771cda9, 0xc8daece8, 0x5e8e788c, 0x0907c40c, 0xbc08ff6f, 0xc7ee5d90, 
	0xcf3aaeef, 0x6875e3ed, 0x5e391ea9, 0xadbde729, 0xf78d0cf6, 0x08d3e28e, 
	0x3e1deb9e, 0xdf0e339e, 0xc5f3fdaf, 0x6f16cf1d, 0x6dd3e5cc, 0x76974f95, 
	0x3e40c15b, 0x5dbefe5d, 0x7d3e40c1, 0xa2f21b96, 0xf4f92ce0, 0x3e4ea3a7, 
	0x9536bc7d, 0x9dabdffa, 0xa07ea1a5, 0x66bff8b1, 0x031e7be2, 0x8f4272f9, 
	0xdd9e4277, 0xffa4eca5, 0x61bc8903, 0x000000bc, 0x00037a91, 0x7ddd9c78, 
	0xd5547c0d, 0xc999f799, 0x92be64dc, 0xccc9924c, 0x490993e4, 0xa8ea2020, 
	0xdc8301a8, 0xbad12024, 0x8bb6aa6b, 0xe283adae, 0x1260294a, 0xeb688d83, 
	0xc237c99d, 0xf0c04130, 0xad023b61, 0x1b775e59, 0xca46ddad, 0x5d41bdbb, 
	0xcdaedf61, 0x5b656eae, 0x2b8a0ddb, 0xd4ad9bee, 0x5954ddd2, 0x39ff9f7c, 
	0x0857cee7, 0xeeeed1f8, 0x6bf7e5ef, 0x73dce78f, 0x9e73c7cf, 0x9c7cffe7, 
	0x96264ee7, 0x2fb0b6d7, 0x5ad4c632, 0x47977f86, 0xe3d41beb, 0xc058598c, 
	0xd8cf5dac, 0xe235e0c4, 0xc61aec79, 0x2eacc634, 0x5df7a59f, 0x8b58d76a, 
	0xb2faed46, 0xed41d65a, 0xeccdd34c, 0x847f5477, 0xd8c6d3fe, 0x4d632f1e, 
	0x482fd4ed, 0x0f94ffe3, 0x178d34cd, 0x63115a19, 0x4bfa2c2b, 0x398c7d23, 
	0x7ccb1847, 0xc05b3193, 0xa01bd3df, 0xc8fddff6, 0xec641ecc, 0x6163066c, 
	0x6ab6f533, 0xa82b2395, 0xa7a6a05f, 0xe0b19c77, 0xe84aa347, 0x196baa2e, 
	0x8c6298b7, 0xac4d4b79, 0x0faa6df3, 0xfc99969a, 0xbfecb654, 0x1cfd44c7, 
	0xdf3d632a, 0x5829e3e7, 0xc2d3c617, 0x956af754, 0x59fa905a, 0x04ed8b59, 
	0x17969e63, 0xeb92e615, 0xdeb49d58, 0xdfbe5aa6, 0xffb92189, 0xe2f86be1, 
	0xd5e8d227, 0x62eb9b63, 0xf4bfe3f7, 0x63276d51, 0xd2aa9ceb, 0xe96beb49, 
	0xfacfd92c, 0x8d777319, 0xfe41032a, 0xe7efe95c, 0xa3eee854, 0x4c192d7e, 
	0xbdbad30f, 0x2edd6287, 0xaba07f6a, 0xeb4a3b33, 0x5999bd6e, 0xd8c65eb7, 
	0x95bd3d15, 0xdb195b03, 0x68244797, 0x3b9ae3e1, 0xc1f9e9f3, 0x9d176ef1, 
	0x6dfa978f, 0x88b1927c, 0xb6dfec45, 0xa4cce4c7, 0x7de217fd, 0x0e7aa73c, 
	0x8fc4f3d1, 0x41d69562, 0x76a0d7ea, 0xea5105f7, 0xafb47ddd, 0xcecc1dc8, 
	0xc67de24e, 0xbf53b73a, 0x2e25829b, 0x7dddceb1, 0xed6bee74, 0x00e8eeea, 
	0xda239f63, 0x7d514f58, 0xa3097d6b, 0xdabe5bf9, 0xad7a0258, 0x3157f26d, 
	0x3168e33a, 0xbad1afdb, 0x76d7e1a3, 0x6fb1ebb3, 0x8f3c7ef7, 0xf7dc899a, 
	0x55cf6630, 0x1a566b77, 0xfd0c12d6, 0xe57f9c42, 0x13773a59, 0x7dfef753, 
	0x185d6316, 0xf0a4f89f, 0xa3267440, 0x5d5d6e73, 0xa3d597b0, 0xc347ba9b, 
	0x2b360e3e, 0x8e55b718, 0xd5672817, 0x6d8be221, 0x4424b56e, 0xd21c2deb, 
	0x7bd62b15, 0x7d40ed42, 0x0a8bf363, 0x7c5ca9e8, 0xc689a672, 0x5fa90a53, 
	0xb9a38d13, 0x5fde9999, 0x6d7d62fb, 0x55ebe348, 0x3f0f896a, 0x138f7fa2, 
	0xb84732cf, 0x727c42ca, 0xa5497469, 0xa5ebc5d9, 0xc7c3e216, 0x45d65a98, 
	0xa0eb6bfb, 0xdb1887fd, 0x65583b5c, 0xa87a815e, 0x75813694, 0xd73ac3ee, 
	0x6baabd33, 0x9c2cb194, 0x43cd216b, 0x98f984fc, 0xb517dd55, 0x0eec7df1, 
	0xabfde71c, 0x6ef5a19e, 0xccb2b35e, 0x8c75fd84, 0x633a7c3a, 0x019cd36f, 
	0x6edb33a2, 0xacde6171, 0x8ca56a1f, 0x54ecdde6, 0xb41642ab, 0xbeb0b867, 
	0x8d8e1fac, 0x07edbe82, 0xf9e04f5d, 0x184092c0, 0x706f68cb, 0x7a2f986b, 
	0xeb1fb5d0, 0x33aa77ea, 0xd63d1277, 0x2ef6612e, 0x84fe7f3f, 0xb03dd68f, 
	0xf42aeee6, 0xd93e23ef, 0xfb5bf345, 0x87ba7aaa, 0x7ad5e713, 0xf80f79b0, 
	0x51cd30fe, 0xc0f77c40, 0x34cf7773, 0x57debf11, 0x39c3edac, 0xf13a6baf, 
	0xb5a7e42c, 0x9c6eb5ed, 0xbb516b17, 0x70deef21, 0x70bf9f09, 0x7247cd29, 
	0x8fe4eeb9, 0x77206a4a, 0x72e62d1f, 0x60143137, 0x7f413fe6, 0x9d6c562e, 
	0x7789c85b, 0x0689c86b, 0x3768c1cf, 0xe6dad3f6, 0x3ce839fe, 0xdbac7071, 
	0xf647e345, 0xad3336ab, 0x68fdfddf, 0x7b9e8bb7, 0x68eef58b, 0xbf07f458, 
	0x25bc6eb6, 0xb66ce5cc, 0xe12752fa, 0xef54a448, 0xe779bf06, 0xf07b4952, 
	0xb079d7b6, 0x8b9709ff, 0xe627af69, 0x423dce37, 0x6545a2f8, 0x536221bf, 
	0xc0dd7bff, 0x7a3afea7, 0x1b3df31f, 0x8c7e07dd, 0xd3ba241c, 0xc44bbc7a, 
	0x63427efe, 0x9c71dabb, 0xfa88655a, 0xeb050e47, 0xadab244d, 0xf00f5433, 
	0x221ef209, 0x66e6dcba, 0xc5d73e5c, 0xf8b79f82, 0xc02bfcb9, 0x60cda637, 
	0x4ac0f01a, 0xcf1c70b8, 0xda16c26b, 0xc7d6a78f, 0x359e687a, 0x8ccd0bda, 
	0xc46265ce, 0x5ba234ca, 0x9c636be8, 0xfc46eb8e, 0x6afd0cf5, 0xc2262c6a, 
	0x908daf89, 0x75ff523c, 0x266b30d7, 0x557f1395, 0x34f8e7eb, 0xf33af022, 
	0xaf64bd52, 0xb17edb42, 0x9e110951, 0xb198be14, 0x2e0eb1e0, 0x09185c7f, 
	0x3a3c1687, 0xb872f9c9, 0xc5c541db, 0x3f1a6fb4, 0x4aebf3d0, 0xefda51d3, 
	0x96a06d78, 0xbefbcea0, 0x020b2d2c, 0x5edbc4b5, 0x0ffd2c8f, 0x65cbf68a, 
	0xd141e4b9, 0x5e5145fe, 0x64aa61da, 0x2abf9c45, 0xfdf07636, 0x38fb850f, 
	0xa4ea5e9d, 0x9f001cf5, 0x717bdf11, 0xdbef44ce, 0x35b31bda, 0xab67b7da, 
	0x5bdd4166, 0xe7477c4a, 0xe0dc3919, 0xd7c83f31, 0x221c40a9, 0x77fd51af, 
	0xda16ce82, 0xcc5d6de7, 0x1775a662, 0x45d2dd30, 0xb54c79ad, 0x7ab9d174, 
	0x903d9b0e, 0x0b5edbe7, 0x90bcf07b, 0x2f73c7de, 0x98e787bd, 0xf8c69d9f, 
	0x66963c1b, 0x8121effa, 0xa8d791eb, 0x0a3a063e, 0x7c85e03d, 0x447e4e10, 
	0xdeb41dfd, 0xc203e0ed, 0x569bedcf, 0xb71e4356, 0xfdc83753, 0xeb945576, 
	0xbe54ab81, 0x4f9acf47, 0x545cf789, 0x3c0cf39a, 0xa466aced, 0x8da2da7f, 
	0x4268ecd5, 0x5b0fb7ee, 0x25f89998, 0xa55d7beb, 0xdca5519c, 0x6807000f, 
	0x2f083bfd, 0x8c0abeb0, 0xbdfa3ef3, 0x59b90a36, 0xbbadecfb, 0x78e9f721, 
	0x5ad8e066, 0xeb60beb3, 0xe35dce24, 0x7afd187a, 0x8966dfa8, 0x807f18ff, 
	0xfabbdef0, 0x978cdd96, 0x50b99a05, 0x44f6eee2, 0x7d49afff, 0x97a905f0, 
	0x47b8feb8, 0xe49f4df2, 0x2fc96197, 0x025f92c3, 0x92025f92, 0xbf25865f, 
	0xa17e4b0c, 0x7b8c6ef6, 0xd50df25a, 0xdd59fcb7, 0xa161758d, 0x27af808f, 
	0x18571a6e, 0xfc4edc70, 0xb6477340, 0x8fa12a86, 0x0d6edb5a, 0x06deff63, 
	0x92b9c76a, 0xdb3c837e, 0xf334ba0e, 0x45ee3176, 0x15e02fe0, 0x4ecfbbf5, 
	0x6f3c31e3, 0xf82b98ae, 0xf11f64f1, 0x2f472057, 0xe7fd090d, 0xbfdd9e00, 
	0xc81edf67, 0xe92736d5, 0x8fb79d1b, 0xb64a1d62, 0x5b7a8f5a, 0x5de38f38, 
	0x226d8720, 0xaadb62b8, 0x3b791d04, 0x187bef95, 0x1fbcd1f3, 0xe94773c8, 
	0xe93752a7, 0xb0271855, 0x5c27c68b, 0xf4499b69, 0xca66f3a5, 0x042f6e49, 
	0xbaabecf6, 0xd7eab80c, 0x1d6276aa, 0x70297a55, 0x727631e8, 0xfdc5f43d, 
	0xf8355341, 0x56956b78, 0xebe3ea15, 0xbc9e052a, 0xd77616e8, 0xed2b4cc5, 
	0x47f7e7a2, 0x93e658ab, 0x60dbf649, 0xd23e009d, 0xda76c953, 0xf6276dd6, 
	0xec999f63, 0x7c46a954, 0x13ab1138, 0x3f02a3fd, 0xbdec37ee, 0x17613ac1, 
	0xc83b4a0d, 0x9fed33ac, 0xec9abd89, 0xc11e5d79, 0x48f1ff1f, 0x697e096a, 
	0xd95964b3, 0x3e82942a, 0xca6fabdb, 0xf135f82b, 0xb9fb1ddb, 0xc160cb7e, 
	0x07e0e011, 0x5fe90e52, 0xd5fa0875, 0x6f4295ad, 0x475f41b7, 0xbd667c13, 
	0x4c43858e, 0xc0d445f0, 0xb54a20e3, 0x722efd14, 0xbf00b90b, 0xfb585f40, 
	0x83ba7b2a, 0x1b78f589, 0x8df030d4, 0xc12851f3, 0xa07f9c47, 0xedb6db2f, 
	0xb46de8c1, 0xbbe39c00, 0x227f8205, 0x481e9037, 0xb6b69fe2, 0xfc903f5b, 
	0x55a8f353, 0x815ba5da, 0xc19f6257, 0xf2078cbe, 0xc47ddf68, 0x5ff036ab, 
	0xd683c095, 0xb72dcffe, 0x4e96dd62, 0x7bc695bb, 0x62b8d0fb, 0x781c095b, 
	0xe74ac8a1, 0xd7290df1, 0x17fd07e8, 0x6f5f191c, 0xfee57ac3, 0x027c0fd1, 
	0xc49fb4bc, 0xf9cf647c, 0x83ebbe84, 0x798e7b1e, 0xbf626272, 0x3d7ed14f, 
	0xa137b276, 0x7ab39f07, 0xadbf4872, 0xd63a62c8, 0x3a5cabf1, 0x09df923b, 
	0x192b0ffb, 0x7b8ad5f1, 0x58f40535, 0x0990fb91, 0xa7c45376, 0x7a61da2b, 
	0x55f4847f, 0xa467f454, 0xd22e3cef, 0xf3d38f97, 0x60c795f6, 0xf96db417, 
	0x07a5914d, 0x3e1f6ae3, 0xb2a1e9ca, 0xcf127d4d, 0x86fc4957, 0xd6a4b9fd, 
	0xac481753, 0xe6656acb, 0xc6cbad30, 0x98703354, 0xd17d273f, 0x1478759a, 
	0xd8a21c7a, 0xf3c7cd53, 0xac825e41, 0x2dbf7586, 0x82f582e8, 0xf4ea26be, 
	0x43817c8b, 0x8b6f1245, 0x26a2d4c7, 0x1ceed75a, 0xf14feac6, 0x56d229f3, 
	0xcf5dba48, 0xe318a719, 0xf3ebb15d, 0x635dc0c5, 0x6967975f, 0x52674fc5, 
	0x04df5dbb, 0x5c0c50fc, 0xb0ef2463, 0xc305e727, 0xdd69bbb0, 0x2f3a76da, 
	0x0f0b0e6b, 0x52adf9d0, 0x745c7233, 0x3c4acf6e, 0xc62fffa4, 0x84bc2b7c, 
	0xbe884743, 0xbb14d62d, 0xf27f2be3, 0xf90d4e50, 0xfe5d5f22, 0x4ee40e42, 
	0x4cfd9879, 0x8ff6951b, 0x6a4a760b, 0xfd6cf77f, 0xa0979197, 0xedef832f, 
	0x317ea568, 0x73a616cd, 0xfbf558f7, 0x3c087476, 0xae773fc7, 0x8d1deeff, 
	0x9f996fd4, 0x3a27bec1, 0xf82220fe, 0xa1f48d53, 0xe11c3b3f, 0xf6b35e7a, 
	0xb55da4d9, 0x744bda4a, 0x3a7cde3e, 0xe7f4e8a7, 0x909e7cf4, 0xf2f3f4cf, 
	0x3156f9e0, 0x89fc3e5e, 0x4a3bad52, 0xa4bdfde3, 0x86fd0787, 0xfe773fa7, 
	0xdf9e56bc, 0xdcff1fdb, 0x8d2abe71, 0x16a59c5f, 0xb5ff120d, 0xb145e965, 
	0xa71efe4c, 0x10d1e5ff, 0xd3135f3f, 0x01e89c6f, 0x57ce747d, 0xe0661b84, 
	0x6333fd1e, 0x8666477c, 0x18e74c3d, 0x14bf21eb, 0x6f85ed75, 0x9efd5167, 
	0x9c0cc69a, 0x6a35838f, 0x77f0cf98, 0x40a5b255, 0xef89d7df, 0xaf8f445c, 
	0x5f30a9ec, 0x6b7bf54c, 0xeb90cd1b, 0x361fb915, 0xdccf8898, 0xff034c99, 
	0xc81ec938, 0xac4cfda4, 0xe1a37e92, 0xfc81fe57, 0x5d69fbee, 0xe7cfa74d, 
	0xed6f6b77, 0xb64fc109, 0xd6efc05c, 0x3bbf5495, 0x77ec9954, 0xeefdd247, 
	0xfc05d891, 0x6093c26e, 0xa23ddf92, 0xbbbf467f, 0x86fd9f28, 0xefc2679f, 
	0xddebcade, 0xdfa42b7d, 0x3f7027ad, 0xff936fe1, 0x2b5a744c, 0xf90f6dfd, 
	0xf8619ec9, 0xe079aa95, 0xbb17e12e, 0xe58f3f68, 0x7a37d9a7, 0x2d53d73d, 
	0x71bbbb9d, 0x107e27ce, 0x7e9174ab, 0x811e908a, 0xe23d0c9f, 0xee5bf9a2, 
	0xc174aaef, 0x5f9370fe, 0x0c8dfb40, 0x32d714c7, 0xe498a79a, 0xa9f87502, 
	0x784f2344, 0x61fa3777, 0x88f83f7d, 0x3d9877c6, 0xf2daf6c9, 0x57b7130e, 
	0x84accfc9, 0x531b775d, 0x84c15d3d, 0x761919df, 0x9e67d831, 0x044f5d67, 
	0x2fbe7056, 0xea28e67d, 0xf11f52d1, 0xf0836791, 0xd2f9c32b, 0xccc97caf, 
	0x9ec34bed, 0x14b4bf24, 0xfc2b4b7e, 0xf71671c7, 0x9f5222e3, 0xd6f55bae, 
	0x45f11ab3, 0x4afefb6b, 0x7f86f73c, 0x89738dde, 0x1a5c699c, 0xe697937a, 
	0x3afc79d0, 0xa7bf936b, 0x34f5863b, 0xc6472187, 0x37d813b8, 0x31e5afad, 
	0x74b5f7e1, 0x721cfc96, 0x20d3e9cd, 0xc2f83cfd, 0xe45d850b, 0x40fc967d, 
	0x7ae817ea, 0xfe0cb952, 0x3b29aab3, 0xe7f54e8f, 0xd3cfff0c, 0x64deb2be, 
	0xc617f84a, 0x76901ff9, 0x8f6901eb, 0xb47f8079, 0xbfa5db9e, 0x41bf85e1, 
	0x17e10f75, 0xdfcf0dfc, 0x9e1bfaa6, 0x837f0c37, 0x7dbf5079, 0x8bc37f1a, 
	0xfdbca8f7, 0xfe29c38d, 0x2f7a72c6, 0xfcf0dfd9, 0xe1bfaa6d, 0x1bfa4379, 
	0x078142fa, 0x97198b93, 0xe14fd21f, 0x543ac66e, 0x52f6195d, 0x32ad43f9, 
	0x64ce3640, 0x232fb08e, 0x730a0bfa, 0xfd26aec3, 0xd7d738fd, 0xb51b6c95, 
	0xa8de48bb, 0x4ba5b7bf, 0x55f69d41, 0x885e2219, 0x84ed473c, 0x9e2567cf, 
	0x8521a37b, 0x19e64b8c, 0xa7e01b56, 0x13ef6079, 0xc2f9a95f, 0xdadf69cf, 
	0x7db8c959, 0x30e3c8d2, 0x64652f54, 0x7e1214e3, 0x6f6dfec0, 0xe3c13f73, 
	0xf5fc6920, 0xc7617c9d, 0x9cafe044, 0x9d5bcf87, 0x376b6ec2, 0x0ff4a8b3, 
	0x4fb65dfd, 0xe6f77fae, 0xe84df38b, 0xa6c73a5f, 0xc17faf8f, 0x39e75867, 
	0xf52eaff4, 0x87f6f8ef, 0x4aabef60, 0xf8509fb2, 0xc61f6c74, 0x335539b1, 
	0x9a4882fc, 0x7693605f, 0x2fcd245f, 0xd1fd0cd8, 0x0b7f4a22, 0xc1e602fc, 
	0x620703ba, 0xf710de22, 0x90766a0b, 0xa78164b2, 0xff9c9563, 0x4ee55afd, 
	0x956147a2, 0x582fc0aa, 0xde80bf0e, 0x7bd60c2b, 0xaa472fe0, 0x04fb9ce8, 
	0x05f9a6df, 0x5b0a3f1c, 0x80a82fc8, 0x953c4adc, 0x441606fc, 0x448f437f, 
	0x4076abda, 0x8b59332e, 0x2382fdc2, 0x8f3e050b, 0x2984e42d, 0xbe91f434, 
	0xf9238c50, 0x0417ee38, 0x3b5d793d, 0x6c0bf7a6, 0xc5b02fd2, 0xc87f82fd, 
	0xf415682f, 0xfdc63d80, 0x1f03c402, 0x5e10fda6, 0xad6adc46, 0xf9d13ba0, 
	0x244ec268, 0xfa15bcfd, 0x89e6ffe8, 0xd02cfef7, 0x1dbac668, 0x2b798c74, 
	0x198dce71, 0x7b0fd22e, 0xec8dbcf0, 0x45659aed, 0x67d4a76c, 0xecd25bb0, 
	0xbf34b3f5, 0x669fb80d, 0x7b0c47af, 0xd930f09d, 0xbe0d3f5e, 0xd7b24b6b, 
	0x7b704e5b, 0x861bd0dd, 0xf6911ebd, 0xfb47d93a, 0xe647af60, 0x6a3b0952, 
	0x923d7b1a, 0x22ffaf66, 0x3fd7b0cf, 0xaf65ce54, 0x97647d7b, 0xbc875ec3, 
	0x617f4547, 0x171cebaf, 0x698287bc, 0x35fabaf6, 0xbdc36f29, 0x2f07b2e7, 
	0x3f7baf60, 0x56debda5, 0xd3f4e420, 0xbec6ebda, 0xaf75edd2, 0xf838ec85, 
	0x35a6551b, 0x2b288d7d, 0xa9f118d8, 0xf5899377, 0xe5a4a2e9, 0xe3bcef32, 
	0x806d6cf7, 0xc66feadd, 0xafe77919, 0x997818c8, 0x9da36dca, 0xcf2a4e91, 
	0x58fddc54, 0x97079e13, 0x3dc63f73, 0x2591d5fa, 0x0e2b3a54, 0x5bfa0dfe, 
	0x2ad95f46, 0xffb1b6e9, 0xc5add3d3, 0x4f433162, 0xf8c4ba72, 0xd717157e, 
	0x77d2bae3, 0x5a6e8934, 0xe37419a3, 0xdc3a0b7c, 0xd08c58d0, 0xcd0e9c5d, 
	0xfe3cc59d, 0x9dd64231, 0x3f0f412d, 0x1e3e5cec, 0xd97e4133, 0xf40640e4, 
	0xa702c6c9, 0x2fea3b88, 0x3bdd7af1, 0xf7de5cd5, 0x7fe930e5, 0xe071a6ab, 
	0xc30f4bb9, 0xf27ae2ae, 0xfb1fd724, 0x5dadf034, 0x37bc57c4, 0x991fa932, 
	0xd8d0fa19, 0xf2aacdaf, 0x150a92fd, 0x56b1bdfb, 0xcec339e8, 0xc054ee6d, 
	0x03b2412c, 0x3e49fb4d, 0x7fee3587, 0xf93b45b6, 0xf17d8dfa, 0xfdcb8e7d, 
	0x864639d1, 0x27b662f4, 0x0eb43d79, 0xbad2f7ee, 0x3df8bcb8, 0xe426af88, 
	0x237fc448, 0x46bda887, 0x1ca4f9d2, 0xf0720dbf, 0xa64b22bd, 0x0f71c3f0, 
	0x3102e5f2, 0x6287dbef, 0x65f4898a, 0x3d7c7870, 0x09cfc7fa, 0x389d57a8, 
	0x98b7aa27, 0xe2f3c84e, 0x994ecefc, 0xb73d4e56, 0x8b1b07fb, 0x2bdff992, 
	0xdf7dadf1, 0x7da3169f, 0xcaa7f63d, 0xe77a23f3, 0x27ef1d63, 0x29ddaa70, 
	0x27c922fd, 0x3badfbc6, 0x9295f21e, 0xfb7fb71c, 0x1710c7ab, 0x8ed80e02, 
	0x974f3d26, 0xe317d03b, 0x4e224db9, 0x89d87545, 0xef93e7e8, 0xb4be1115, 
	0xe4893ee3, 0xc09e7db2, 0x37af0345, 0xd53d0814, 0xa7ec205e, 0xd6339c84, 
	0x3ed24ef5, 0x9d3d9563, 0x8e3909e3, 0xb3fd2fcf, 0xfbbffef8, 0xaa1aaed0, 
	0xbeaa66b7, 0x78f87ba7, 0x1215b5cb, 0x7496de47, 0xc2dd4719, 0xde27f77a, 
	0xa248fbe3, 0x7d4ffdf7, 0x07ab3c58, 0x3fe42b78, 0x037c7552, 0xe5223fe4, 
	0x3fe5223f, 0x323fe522, 0xadfaf8ef, 0x6ffc8587, 0x322cc321, 0xa26fc57f, 
	0xb6479f64, 0xcc6c67d5, 0x715b5d80, 0x5c23d6cb, 0x98dbaffe, 0xe4f3bd09, 
	0xc47fc806, 0x32f43159, 0x7fe427fa, 0xe9f6c455, 0xe5531ce3, 0xc852b3bf, 
	0x71f956bf, 0xb71e3fe4, 0xb48a7490, 0xffc8a574, 0x4bb13914, 0xca63feff, 
	0x7282e46d, 0x72c92bab, 0x5d27ac6b, 0xe453bd6e, 0x7188e256, 0x6e45333f, 
	0xdb7b3c85, 0x96e452ab, 0xb7249f8f, 0xffb72911, 0xfb6dc868, 0xdca83ffe, 
	0x7dbb48d6, 0x6db5b93a, 0x16479828, 0x5bee1b14, 0xdb6ff5ca, 0xf41ee881, 
	0x337b8b5b, 0xb6da93f2, 0xefca5abe, 0x02bd588f, 0xd27ef37b, 0x4adff0ed, 
	0x846b3ec8, 0xece321bd, 0xf95bb691, 0xd5dad7bd, 0x1eb1ecb7, 0xc46bf115, 
	0xe9a52f0f, 0x9eb60f61, 0xdf84ace9, 0x99b27115, 0xff91c421, 0xc3f71965, 
	0xe27d4f98, 0xa3dc2197, 0x35b8f336, 0x9a7ecfec, 0xa87e0fa7, 0x765efd0f, 
	0xbc8f7fc0, 0xfb81df58, 0x15c3db4f, 0xfa10a32c, 0xd00c774d, 0xa84f4bf3, 
	0x94d103b5, 0xb09983fb, 0xe2ddb3d3, 0xd7b0d67e, 0xe0cbbce9, 0x882fb027, 
	0x5c788afb, 0x52f1e6b2, 0xfe187586, 0xfa574fa5, 0xaea75fb1, 0x5a3ad00c, 
	0x28fabeb7, 0x93c0c0f8, 0xe79f0dd6, 0xc8eb69f4, 0x5f7dc32b, 0x6c7fbcbb, 
	0xc1dd79af, 0xa75f44cc, 0x7b4fd65a, 0xe7f3419f, 0x21ee24b5, 0x1a01afb0, 
	0x3ff68fb7, 0x1bfb1260, 0x70abb920, 0x3ffd7f0b, 0xaf440fc1, 0xcf6483b6, 
	0x66631ee3, 0xfaf8377d, 0x7ec205d7, 0x279e2dfa, 0xb8fe878d, 0xce208ce7, 
	0xfd6ce74c, 0x89b0cacb, 0x30c0f3d6, 0x13c739f9, 0x495aeb7e, 0x6fd3c8d7, 
	0x1d6e7829, 0xa4f6ff21, 0xf68c9f38, 0xfd8c3d04, 0x2bf03e63, 0xa9fcff3f, 
	0xd3f06e38, 0x7f1e3874, 0x1c7109fe, 0x9a9d15ef, 0x70afc71e, 0xd8bf1c0b, 
	0x4f8ffc2d, 0x7971e38b, 0x6e3884f8, 0x8e1d37bc, 0x3d37c527, 0x37c6a78f, 
	0xdf16907f, 0x888b73bc, 0x373bfa67, 0x6ae438f2, 0xb66eb759, 0xf397039f, 
	0x0d32dda5, 0x2dc17f3e, 0x4edd2470, 0x5e9be233, 0xcaf4df19, 0xb75ae6f8, 
	0x7fff63b0, 0x7b766f8d, 0xeff6fdc5, 0x6169be2b, 0xaa3da4a7, 0x69be339d, 
	0xf01d3fc4, 0xc524572b, 0x7114ef39, 0x22bc07ce, 0x3534c9ae, 0x99de3923, 
	0xf234e71e, 0xf253ec8a, 0x8d9b168a, 0x5e726478, 0xaf2d3d91, 0x57969ec8, 
	0x4df19764, 0xca2bccbb, 0x579fcf56, 0x2bcb4f64, 0xcdf11bb2, 0x37c40be6, 
	0x372dfa0d, 0x77df9be2, 0x9be39eff, 0xcdf1c9a5, 0x5b3f0a6b, 0x13f5b37c, 
	0x1ec337c7, 0x8f528f8e, 0x4a11dedc, 0x29fe6f89, 0x6f89a7d3, 0xf2213f36, 
	0xb9d95866, 0x0b739be2, 0x1ff37c65, 0xc4ef42cd, 0x0cac9be3, 0x1976cdf1, 
	0xccf1e4df, 0x8e638c98, 0x7aa75c4b, 0xa66f8cbb, 0x7c7923c7, 0xbf1121b3, 
	0x084cf1e4, 0x8dd68b6f, 0xe99c88f3, 0x39507114, 0x7a70c4ce, 0xe7e3541c, 
	0x799de3c5, 0x1ff93e92, 0xe3c9be3f, 0xe353f999, 0x49be3c9c, 0x142ee1e7, 
	0xf305f876, 0x4bf2d24d, 0x9e117c8c, 0xcefb425f, 0xd825e80c, 0xf25791af, 
	0xcf814e77, 0x904ef253, 0x632ef25f, 0x2acb6aff, 0x3d3f08b4, 0x86a58f35, 
	0xeb6f7079, 0x93deef01, 0x53cf1758, 0x5e6a7279, 0x47cdc7ca, 0x93b8e231, 
	0xf227916e, 0xc5b715df, 0x6e271ffc, 0xdf4fc46b, 0xe9f88b70, 0x794fc47a, 
	0x250bc79e, 0x88f5ebc0, 0x741d929f, 0xf3c88b5f, 0xab76df58, 0xf1a69f88, 
	0x8a171fef, 0xf8d4d2b8, 0x911caa69, 0xf886515d, 0xbb337ae9, 0x0b4dd05a, 
	0x793fdbf6, 0xc286f4fc, 0xdfcbfbf4, 0xfb54fc57, 0xce29646d, 0xfdb0df51, 
	0xc237ec0c, 0xafce718d, 0x5c67110e, 0xc78be5c9, 0x6d9e4981, 0x56d3f169, 
	0xa5b38719, 0x94af4fc5, 0xe4528ffc, 0x9e1e6855, 0xe346d157, 0xf16c7ad1, 
	0x0ed0e9f8, 0xbed1579e, 0x2af22cd2, 0xa7e23354, 0x7e229388, 0xabccbb7a, 
	0x69fe3260, 0x88234bc4, 0xbf1106a7, 0x8bd4f115, 0x7fd44f81, 0x353f11b9, 
	0x1e329ee2, 0x49e7ff4a, 0xf6914bd6, 0x5e443bfd, 0x1293c045, 0xf8263d3f, 
	0x3f11b964, 0x92ed931d, 0xd3f1e27f, 0x9bcee7d8, 0x7e353157, 0xf110a1ba, 
	0x7c03d053, 0xdb4fc46a, 0x4b4fc6a7, 0x2e9d3f11, 0x859be15f, 0x615f2c9f, 
	0x4d7fe15b, 0x5283c2be, 0xbe6e3e9e, 0xbc8683c2, 0xa0af9b4e, 0x19794b96, 
	0xbff1b4de, 0xe6c15f2e, 0x4ff16cf9, 0xf1e95f63, 0xc7f8a4cf, 0x70bdf75f, 
	0xf3c7f8de, 0x7d11fe32, 0x3fc79bb4, 0xff1a9bbe, 0xd25d7d30, 0x0dbf58e5, 
	0xdbcdc6fd, 0x0a6ddcf1, 0xefc2748f, 0x5f46551c, 0xaff57cc2, 0xeffe663f, 
	0xe9c47f8b, 0xfe243ff0, 0x0fe7ac61, 0xe3e0ff15, 0xfe353fbf, 0xef295bf1, 
	0xc7f8e87f, 0xa6fee4f7, 0x5b3c7f8b, 0xb71bcec8, 0xce9fde34, 0xff3f8ddf, 
	0xde2efe84, 0x9bbf9f3b, 0xc1fa11e7, 0xfe6cf9e1, 0x9fff7c6e, 0xde35dfd0, 
	0xbddfce9b, 0x0565e7a2, 0xc355e476, 0x938e0ca1, 0xea9f9f32, 0x1e475e4e, 
	0x55e79d3f, 0x158ae323, 0x12c5b9f7, 0x650d9f3f, 0x7d895d58, 0xf898b4e6, 
	0x2c4e6c7d, 0x74bc88a4, 0x1c4311dd, 0x5362aba8, 0x50c8e105, 0xb415632e, 
	0x614cc0ff, 0xbffd5c9f, 0xbd826ce7, 0x2fdbf579, 0xa30f3b2b, 0x93b4dacc, 
	0xe83811d6, 0xfbd1f4ef, 0x0057a221, 0xddeab2f4, 0xbbfe901f, 0xe3374cba, 
	0xe329d8fe, 0x0c2ff434, 0x9df10fbb, 0xcac9f810, 0xa4fed1c2, 0x7e25bb3c, 
	0xb6620673, 0xb0e3cd4a, 0x74b3023b, 0xc8447a25, 0xe4f48b9d, 0xbc76b48b, 
	0x0f01758f, 0x1990c1bd, 0x2c3397f6, 0x4cc5f6f4, 0x5e82e8cd, 0x276574d5, 
	0x72b9c3ed, 0xfaecb95c, 0x5a4ef8c4, 0x55a78f27, 0x3bc89de9, 0x49531765, 
	0xb876b5c4, 0x67cd2658, 0x4033d66f, 0xefb35cef, 0x6ff08d75, 0xd5fe9542, 
	0x99afa1b8, 0x93bef939, 0xf6185df4, 0x2f6be900, 0xa43b4ff7, 0xc84ab6bf, 
	0xd7d01dff, 0x4e3a995f, 0xdf375f5c, 0xf1b5f5c2, 0x8ee3853d, 0xd61e4660, 
	0x92b8c777, 0x9de82a37, 0xcd4df1c7, 0x449a3fe8, 0x8ae335a7, 0x7d9df689, 
	0x71e3cfc8, 0x9e84f8af, 0xff9276cb, 0x98bc7e0e, 0x587e00f0, 0x981f7443, 
	0xcdb6d227, 0x3489bc0c, 0x64b406d4, 0x956aa9bd, 0xb0397bd0, 0xec9c652b, 
	0xa38c71c9, 0xf1a93c66, 0xb81f8ae7, 0x69ac6b46, 0x2bb17cc1, 0xad8e3cec, 
	0xca3e760f, 0x11bbbdf3, 0x3b4af3d7, 0xca96ac8b, 0x9f9e073f, 0x3cfe3b56, 
	0x7209ce2a, 0xed43b714, 0x7fe3c2ba, 0x2571bfb8, 0xe2baa5e6, 0xd3f3971f, 
	0x9fb463bc, 0x3f04a739, 0x19cc26c1, 0xb7381dd6, 0xf7c413ec, 0xe90ff061, 
	0x8ec79a67, 0xa7d75cfc, 0xf2361fcf, 0xc0efe186, 0xf30ebbef, 0x127d09b5, 
	0x563dd73a, 0x77f1c6be, 0x3bcdf8ba, 0xef92960e, 0x7e71c466, 0xad7ab8df, 
	0xdab8fcf3, 0x3927bf22, 0xcbf114e1, 0x7e444b75, 0x9333cd0d, 0xad4c5dfb, 
	0x4a3cfe04, 0x2e3cca7b, 0x7aeb2bf6, 0xc5c94026, 0x4d3f7266, 0xcd3f0935, 
	0xcdebc1df, 0xcdd785aa, 0x98bdd1f9, 0xf995b377, 0x26204ff3, 0x161ccdad, 
	0xba95c579, 0x08eabf18, 0x55e9278f, 0x7d5ea263, 0xc7abd44c, 0x23cb7ca9, 
	0x7da8e0f2, 0xafaa49d6, 0x5bf77bb9, 0x16731ef2, 0x8fee5eec, 0x8dda2616, 
	0xec1ef079, 0xb1ae234c, 0x2b9feee6, 0xecd733b0, 0x7a5c571b, 0xb9d63e42, 
	0xcafb0299, 0x742a8dab, 0xaee26c0c, 0xa7f70add, 0xfc229a7d, 0x3f814d69, 
	0x1ff78dfd, 0x901e3853, 0xdf7e4e5e, 0xc070ef83, 0x660aa797, 0xd9b08e21, 
	0x939762c5, 0x47aefb6d, 0x5f9177dc, 0xbdf98a32, 0x65996ea7, 0x62efdf85, 
	0x7e0abdaa, 0xbffb8d8c, 0xae22e5a6, 0x3df458a4, 0x7ef84bfd, 0x764a3d8e, 
	0x6d62eb52, 0xdf22e3c9, 0xe66f5575, 0x6b5bee39, 0x3a229ac8, 0x097655df, 
	0xf2d617c7, 0xc77ebcb7, 0xef3eaf8f, 0x7194eb7d, 0x78f18f02, 0x02b2d357, 
	0x14f44e31, 0xd67b5faf, 0xd271de75, 0x67c1aff5, 0xf8dfe9d3, 0x7fa84ff3, 
	0xf4f9def1, 0x702bc9af, 0xa8cfc3e3, 0xf272e37f, 0xf1aff509, 0xd7fa74de, 
	0xbf84eef8, 0xc7697dff, 0x77ec278e, 0xaf8d9ec3, 0xd38bae5b, 0x9f626769, 
	0x6e0ff1e7, 0x44f822de, 0x1b7c47ed, 0xa8703a76, 0xb857e2aa, 0x4ec0f4a7, 
	0xd81ea7a7, 0x4728aae9, 0x4cf3d780, 0xf74ec2ef, 0x88e1fd5a, 0xa3f9f542, 
	0x76156caf, 0x0947aaf9, 0xeadb3daf, 0x5268fe7f, 0x8673dc7c, 0x3b7649ea, 
	0xbb0197bd, 0x08aee3dd, 0xf57e221f, 0xfe7feb38, 0x7f5264c2, 0xc0bc7c4b, 
	0xbeff8ea3, 0x3c8b063c, 0x18f2e99f, 0x33ebaca6, 0x282ff1db, 0x3b0c3f9c, 
	0x2b72f91e, 0xb1bc7612, 0x0ff2e99e, 0xee1dfc92, 0xcae67857, 0x20cf20f5, 
	0xad075896, 0x979e3bb3, 0x77189430, 0xf232f93a, 0x143ede10, 0x45b934ab, 
	0x9569911e, 0xeec92f7c, 0xa8179a9f, 0xc0bcf255, 0x92545ffb, 0x7abd02f3, 
	0x02f22567, 0x205e4623, 0x1fe4d1e2, 0x530fe178, 0x64fc08ff, 0xfa48179e, 
	0x3c3fdf12, 0x2ef0f427, 0x49120f79, 0xcf4c0bcb, 0xfd95eab7, 0x72b7cba6, 
	0x3da3cf42, 0xa15bcf4d, 0x3fbfa3e7, 0x5ca5ff3d, 0xcf431f41, 0x3a8d7a0f, 
	0x87f9df3d, 0xbcae57a7, 0xbd10bacf, 0x9f9ee4ce, 0x63d0975e, 0x1fc247dc, 
	0x25bf77c0, 0x9187193e, 0xa87ebab8, 0xfddfe153, 0xf2081fc2, 0xab157aef, 
	0x064bc64f, 0x52103ca8, 0x0f2eb4ac, 0x5ec2b3f5, 0x78f0bf81, 0x4070bf92, 
	0x75781bb4, 0x8bd0b0e5, 0xf913ae34, 0x595857c3, 0xcbd232ec, 0x615a1f57, 
	0xcc48acbe, 0x225cba0f, 0x189fc1fb, 0x89fc2e3e, 0x8bae48cb, 0xa765f9e8, 
	0x4389fc92, 0xa09fc215, 0x80d9def3, 0xbb89fc92, 0xbb044fe0, 0xafda217d, 
	0x289fcd2f, 0xf1027f25, 0xd38cb35f, 0x627f6c7d, 0xfcf9c768, 0xd92bac09, 
	0x0b0c289f, 0xe462e57f, 0x1136734f, 0xd3e144fe, 0x2144fea9, 0x13f853ad, 
	0x5eff076c, 0xc72a62f9, 0x867cdcb1, 0xcded2aef, 0xcbe783cc, 0xd53f83cd, 
	0x603f24d4, 0xc4fe42ec, 0x13fb87b0, 0x88f0bc46, 0xba7b7fe8, 0xe696313f, 
	0x4ceec44f, 0xb3c627f3, 0xdb09fd93, 0x4fe97e8d, 0xfe29d9e8, 0xdce3a1c4, 
	0xfa5ab89f, 0x3fa48b13, 0xf427f571, 0x8554ae27, 0xf349ef5d, 0xea76ae27, 
	0xafebb0d9, 0xf86cd554, 0xf8d09713, 0x50ff1835, 0x13fa5730, 0xce38b727, 
	0x0ae84fe5, 0xf4af09fc, 0xe74e7027, 0x428627f4, 0xe6318fdc, 0x67d50ef5, 
	0x3e13fb27, 0x822d13f8, 0x784fe09f, 0x0c1d4686, 0x7d4760f6, 0xe68ae436, 
	0x7ed136cd, 0xc3b3675a, 0xc4543ee2, 0xa6701fbf, 0xf25f25da, 0x62f1f889, 
	0xfef7119f, 0xe0cfb9af, 0xf27295eb, 0xc67ff487, 0x702838e2, 0x2a5f1af1, 
	0xaa6c9a2e, 0x39d2b58f, 0xec7d1ad8, 0x043f34b7, 0xff78dff0, 0xa74fde30, 
	0xd7d71187, 0x43918fd7, 0x97cba092, 0x32cc6c02, 0x2d139e9f, 0x12d4dcf1, 
	0x07c4deff, 0x6bd38cbb, 0xc17a54c5, 0xefc23a9e, 0x98df75b3, 0x8e8ae3b0, 
	0xb8d17a89, 0x293ee7bc, 0x7aa7c5ea, 0x95ac7f70, 0xd7faa19c, 0xf64b552e, 
	0xdf7a4b76, 0x7cc5cf25, 0xb14fba61, 0xb807adab, 0xa78dfe3d, 0x7abb0867, 
	0xd5db8c78, 0x0d7c3eff, 0x7674efdf, 0x8ca1faf5, 0xcbebe80c, 0x95983287, 
	0x5dfe2f8f, 0x8d92d4c2, 0x6c9d7e7c, 0x569ff01d, 0xcd03fc2f, 0x3816e917, 
	0xf1e0fc0b, 0xae04869e, 0x031df11b, 0x7c941fcf, 0xb880e3c9, 0x675c2577, 
	0x5cb9d702, 0x99d70844, 0x0f6e75c4, 0x40f5a01d, 0x7196490e, 0x10e5749f, 
	0x8a9feff5, 0xaf01afd7, 0x5e0e3e5b, 0xd781878f, 0x9af053a3, 0x1cf7a179, 
	0x2faf149f, 0x0f713bd6, 0xbf5e1d3d, 0xe38fe526, 0x9af11075, 0x3fc017c1, 
	0xf1c3fe3c, 0xfa0654f3, 0xe78e2439, 0x122b3702, 0x98b84e38, 0x5a0ee382, 
	0xad71c0bf, 0x32b8e393, 0xb37909d4, 0x8e38b8b6, 0xa5b6f1c7, 0x73ba38d6, 
	0x59bdb6e2, 0x7dfc40cb, 0x97f645a2, 0xfbf8a071, 0xf169b51d, 0xef9e6e9f, 
	0x1df5e06e, 0xf112ee27, 0x2a6f139f, 0xde82f579, 0x73fe271f, 0xfcfc27d2, 
	0xc1ff1b4f, 0x37b85d77, 0xf3fe2e9f, 0xfe233e4f, 0xe7685fe3, 0x760fabfc, 
	0xff1c2f3b, 0x6f2139c1, 0x8ff8ba68, 0xfc7a6f31, 0xff1955e7, 0xbd789519, 
	0x11971e3b, 0x41e3c438, 0xd2f22903, 0xda4b39bc, 0x2deb848f, 0x7f86666e, 
	0xfd075c0e, 0xaef3849c, 0x65f2a9fa, 0x71e99bd8, 0xc77f8e25, 0x9faabe25, 
	0x7c7b5f1e, 0x71d20f02, 0xab8e27b6, 0x125fbeda, 0xde0f1c4e, 0xa5479d6b, 
	0x4c8ea035, 0xd56e5952, 0x4903c2b2, 0xdb30cb74, 0xe13bbf71, 0x2535f913, 
	0x75ff3dd7, 0x89426efc, 0xfc41ef5d, 0xd2c3f892, 0x2a2be3c7, 0x88d157cf, 
	0x41ffc13d, 0x3b63cf99, 0x0c85f2d6, 0x69d685f0, 0x261d7116, 0xe38c02e3, 
	0x75961a97, 0x0f3c33e2, 0x75e3e3c0, 0x10e3f2cd, 0x41c0cfd0, 0xc976033d, 
	0x679ff74c, 0x9539d2d4, 0x0ba5aafd, 0x65d33372, 0x67ef80b2, 0x81851416, 
	0x352e1373, 0x0153f5d4, 0xc19ff8d9, 0xc1ae13b7, 0x01a7bf29, 0xd4609c3e, 
	0x2a108bff, 0x7412ef6a, 0x89954238, 0x0ebe46eb, 0x6ab4ce7a, 0x53cd30d6, 
	0xcb327ce1, 0x7d82bd04, 0x1114ff13, 0x89ed6d2d, 0xc652d9f1, 0xf04ae9f3, 
	0x1ef1205e, 0x763d13a7, 0xb682ff53, 0xb4403f44, 0xd3f2f546, 0x3d135ac1, 
	0x0a21cb2b, 0x989d4e11, 0xe011faf9, 0x95f21961, 0x557ff492, 0xe713b091, 
	0xb9fc0914, 0xf78e28b8, 0x3009a499, 0xd6bd1fda, 0x635f6899, 0xfe82660a, 
	0x6c814c6b, 0x6dcbdf8d, 0x5afa8cdc, 0xfa1b3053, 0x6f3e5da4, 0x5ebe7b4f, 
	0x80ce073e, 0x22a5ac5f, 0x135d561e, 0x7d52b2ca, 0xf3b09169, 0xb085f68d, 
	0x563d69bd, 0x59f8af69, 0x68b73f5a, 0x6d48159f, 0xf13ac46f, 0xaf719e7c, 
	0x27bea5a8, 0xb5c74bdb, 0xa29d9aac, 0x7594761d, 0x319f68be, 0xcabfda99, 
	0x8e4aca1f, 0xd29f946f, 0x950958b2, 0x2edc5935, 0x9199f5a3, 0x22b9f99f, 
	0xad699f91, 0xdf116fd3, 0xfd2de893, 0x985f3e4e, 0x47ef7bfb, 0xe54b817b, 
	0xbe79321b, 0xffa8f7e5, 0x69be3415, 0xd0bd47f2, 0xfc1fe5a7, 0x49c6ed68, 
	0x29eb57dc, 0xae514bbf, 0xb161aed6, 0x79e373d4, 0xf123a0a9, 0xd5c1b581, 
	0xdf2d3e03, 0xac23ef20, 0x09c81eb4, 0xe47ac7c6, 0x7903eafd, 0xe45159b1, 
	0xdf89514f, 0x24595a5d, 0x0d2b50e2, 0x8afd197a, 0x68915fa8, 0x925c43cf, 
	0xcf1f58ea, 0xab5f4357, 0xf8827396, 0xab59f5e1, 0xf9a72c8b, 0x2f90b97c, 
	0xcc7a1555, 0x9ca1daf7, 0xffc89d79, 0xae41fea2, 0x3fd0c2f7, 0x69c2268e, 
	0x027c527f, 0x3764919c, 0xb7edd9d8, 0x5f930e21, 0xdd1ec7a0, 0x82cffa84, 
	0x282f2fc8, 0x6a3b0dd0, 0x98d1e616, 0x5db2df8c, 0xef8ea2f7, 0xd75cb804, 
	0x8fcfe06e, 0x7d453a0d, 0xf0d57ffc, 0x8ee22178, 0xb1e1d758, 0x4fd720a7, 
	0x87df8b14, 0xec7bbdb1, 0xefd405a9, 0x22ceeabe, 0x31fa1eb6, 0x1855d4f8, 
	0x077d8c77, 0xe9766afc, 0xed5d38b3, 0x1ae22f5a, 0x6e4ce1e5, 0x908f002f, 
	0x573e5b77, 0xc65f470f, 0xd1bd69b9, 0xfd7fa0bb, 0xff7a3ce6, 0x591ca4af, 
	0x89e39e65, 0x233318ff, 0xbb713308, 0x0fbe0666, 0xab788917, 0x541be64d, 
	0xad9a8cd7, 0x92fddf44, 0x5df68cdf, 0x4e6dff92, 0x967e2e71, 0x93c64fd6, 
	0xdb520567, 0x2c0915f7, 0x63f8c9b2, 0xfa9e98f1, 0x1d2f6c9e, 0x4535cdd7, 
	0x6ffc1da2, 0x67da2f9b, 0xaff6a64c, 0xa19a8ff2, 0x0a37ad0f, 0xa668ecbd, 
	0x93df49e7, 0x66eb963a, 0xc84a9bb6, 0xe6267203, 0x7c28e1a9, 0xbda3dbf6, 
	0x4b0f4788, 0xe86f947a, 0x526bbb59, 0x4a0085d8, 0x715bf7e2, 0x0fa666de, 
	0xefca766f, 0xb6ce8906, 0x5feb18ba, 0xf1b33c8a, 0x8ebfca8f, 0x9c358b7e, 
	0x7114702b, 0x448b9b8b, 0xd8a8729e, 0x132c37d0, 0xbde27e38, 0x177e1b31, 
	0x97bf17c5, 0x4f82c3d3, 0x9e909c84, 0xbcf7e30a, 0x4a161e38, 0x8a4a2939, 
	0x65f9d25b, 0xa5d0af20, 0xd0af20e6, 0x8faafa47, 0x0e5a69db, 0x87ca31ee, 
	0x58ac7346, 0x9b90b17a, 0x2d1d67d7, 0xe09fbcb2, 0x01feb8ff, 0xfbe20fbf, 
	0x1fae5aef, 0xf138f113, 0x2acc387b, 0xe7a23fc7, 0xfe395558, 0x5f71e4ce, 
	0xe25c669b, 0xf96ba243, 0xa77b54b1, 0x1f715ae4, 0x596a70e9, 0x72afe221, 
	0x7982af99, 0x62faf760, 0x5d0139a3, 0xc0b383cc, 0xbc67883c, 0xf9f8eb3e, 
	0x75e52fd7, 0xbbd8e6e2, 0x77027cc6, 0xdc689ce8, 0x5cb51b8a, 0xf3a4abdc, 
	0x3e34d9f1, 0x7c34cdfe, 0x3e1a767c, 0x4ccfda36, 0xa767c7c3, 0xd3b3e3e1, 
	0x34d9f1f0, 0x6f969e3e, 0xe380ff89, 0x7b816296, 0x16163ab6, 0x6ed7a4f8, 
	0x06be0a71, 0xc9d7c05d, 0x162b6e38, 0x78e06b38, 0x0ec2b385, 0x30becbfb, 
	0x39876564, 0x7192c6ff, 0x1cd0dadd, 0x97ca3ac6, 0x1f2235b3, 0x1e75854f, 
	0x4c99f7c7, 0x758cbfc4, 0xe17c95ce, 0x5472162f, 0x461830d1, 0xee1ecdfc, 
	0x769be30d, 0x47ec32e0, 0x7f7365c2, 0x5bb29e92, 0x498db6d8, 0x327356f2, 
	0x91ded9ba, 0x907d97a8, 0xbdc44db5, 0x3650e1f5, 0xd3c8eebd, 0xf1cb6fcd, 
	0x3c7d9f6c, 0x0073037b, 0x4ddae767, 0x50cf99b9, 0xfb4bb379, 0x3a8f8c7d, 
	0xb5c941d4, 0xf43df38c, 0x612f286f, 0x860f0027, 0x3739de69, 0x80143e7c, 
	0x902affbc, 0x0ab77c89, 0x0347e7fb, 0x0e7c7f64, 0x1ce3cffc, 0x551bb73a, 
	0xfc9c9f43, 0x3d1bb736, 0xd0fea5db, 0x4bd786ff, 0x2f3c5aff, 0x0ebfed3f, 
	0xe87644f7, 0xaf38e38f, 0x52e6eb9a, 0x1a6ac6b7, 0x3dc3fa11, 0xc2c52e12, 
	0xc0fc918e, 0x03463b3e, 0xeafffcd3, 0xdb73f8d3, 0xe83ed10d, 0xab2f929f, 
	0xb167b8b9, 0x611e0e36, 0x7fa1ee52, 0xd70cf5d3, 0xeb278f2f, 0xcf399897, 
	0x0f83fa26, 0x2caf32ec, 0x4ec85fa1, 0xe12cf6e6, 0x7afbf500, 0x2a8fb8b1, 
	0xd6cf934f, 0xaf5df162, 0xd52f7ed1, 0x4d2fd04b, 0xd2fde33e, 0x6f68d3e4, 
	0x269dd631, 0xd2f7f19f, 0xf0ed13e4, 0xe4d3ca7f, 0xc86fe8d3, 0xe934fda7, 
	0x9af9c419, 0xca67afce, 0x805d11e7, 0x60cf5287, 0x4963b0bf, 0x7aa9632e, 
	0xa94e91e6, 0x36575867, 0x01f449f6, 0xd654eb9d, 0x77cd12ff, 0x7fccf48a, 
	0x8f49ef02, 0x59efbb50, 0x3be97791, 0x4611bcdc, 0xd149654a, 0xe75a7ef3, 
	0xe25f12f3, 0xebfd3976, 0xf1197aa4, 0x0f877e33, 0xcccc7d1c, 0xca76d9e5, 
	0xf321cfc4, 0x1f65950c, 0xf9d06e12, 0x76445d95, 0x82ec1660, 0x3fb8cdd8, 
	0x97fd3ab5, 0x1d84ce6c, 0xffa5bfeb, 0xfebdd845, 0x50f736ab, 0x85bb1559, 
	0xbfe79f3f, 0xaf9f3f96, 0xb2b9490d, 0x6c666f76, 0x86dee82f, 0xd97275df, 
	0x6ea52f98, 0xf5c98365, 0xdeb52da8, 0x6577569c, 0x44cff5a5, 0x634dc4fd, 
	0x48a4bdbc, 0xadfb57e8, 0x7df05ec1, 0xeaadbfd9, 0x552b3f05, 0x2ffd5dfa, 
	0x1ba3f4a0, 0x9ddadc53, 0xf6e2af58, 0xeb49bf3b, 0xeb1a9c55, 0x9948bb23, 
	0xb9b15e3f, 0x35d06502, 0xa95cfa44, 0x1044558b, 0xca6c18af, 0x5f26fae3, 
	0xe6078bd8, 0x3b0c5b3c, 0x64f17332, 0xa4fc9f9e, 0x8f1ff337, 0x24ea0f82, 
	0x5f93b21e, 0xc938859c, 0x205caeaf, 0x9990277f, 0xc88ec760, 0x0e657ef3, 
	0xb9afd7fd, 0x71e2eade, 0x2487f802, 0xee3f05e7, 0xe0b7fae0, 0xab7ca297, 
	0x296eeafc, 0x25f8161f, 0x90164105, 0x06679bbf, 0xfc49149f, 0x59f71fc8, 
	0x26aec0b6, 0xfbe5b7dd, 0xa9850744, 0x8eb6f7fc, 0x50b67bf8, 0x4770c15b, 
	0xc178f600, 0x17ee0ec1, 0x02d49c17, 0xc6359e46, 0x3ffcab79, 0x05d720ba, 
	0x9232463b, 0x7e4adbef, 0x2b62d271, 0x36578c4a, 0x4bc96e31, 0xbfb9138a, 
	0x6ad06ea9, 0x9693e740, 0x58af613c, 0xf44faffa, 0x47efebe7, 0xc21be5bf, 
	0x53b5c043, 0xba6b9fa2, 0x421b2d7e, 0xa4def7e8, 0x7ea3e7e8, 0x1e3dcf47, 
	0x3d3e15fa, 0xa7f9fa2e, 0xc0dd4f1b, 0xe42fefd0, 0x1fa66afa, 0x28fb4ccf, 
	0xbeb94bfc, 0x5afd74c0, 0xefd09836, 0xb57d72bb, 0x59d2de62, 0x87118ba7, 
	0xc48afde5, 0xd137e878, 0xbf1c3875, 0x743c44e7, 0xe02cdb79, 0xb6df73f3, 
	0x6a50be71, 0x23cfe48e, 0xf598c9fe, 0x56f0296a, 0xb7cc9ea9, 0x4ff7e374, 
	0x0fc2b687, 0x25662dee, 0xdfabf216, 0x4158b19a, 0xeb06761c, 0xbc1f02c8, 
	0x9791e335, 0xc5bd5e71, 0x0cf9fc19, 0xdd53b52b, 0xdbc83fbd, 0xb1eb427f, 
	0xe7eea1b4, 0xe25a74f8, 0x763981de, 0x6f853fde, 0x4d5d8fb1, 0xce371879, 
	0x9c8de3bf, 0x74be737f, 0x922bd099, 0x06255d7f, 0x197fd2ff, 0xd5024bfc, 
	0xd05ff722, 0xe327f064, 0xedc1785e, 0x12ef9cb5, 0x4c9717f3, 0xbfcc1b91, 
	0xc9fe6d33, 0x87fe7cf5, 0xc8a408df, 0xbf3e3f8f, 0xe9cfcf9f, 0xe3ae42b1, 
	0xf84fe608, 0xdecfe06b, 0x2c929ae2, 0x6376177c, 0x8df61bb0, 0x23758bad, 
	0xa5d6cc9f, 0x45b88cbe, 0x2945f16f, 0x530c2bf4, 0x7e89347b, 0xf4295d7b, 
	0x57038a9b, 0x0a67a54c, 0xf7cedc0e, 0x92c5abb1, 0x25058fb2, 0x32be1f42, 
	0x35abfe87, 0x7a6f0381, 0x77dbcf19, 0x907c175f, 0xe8858df3, 0xa059f248, 
	0xcfb90d9a, 0x6b9d74e3, 0x97a899d4, 0x8aec751a, 0x9a12d2f4, 0x64bbc689, 
	0x216b9e89, 0x84b39f79, 0x91fbe2e5, 0x39a8972b, 0xd5f1802c, 0xa7444307, 
	0x059d7265, 0x5cf1f139, 0x06e6be7c, 0x51f35759, 0xd1e30cbf, 0x5e34a5fb, 
	0x2fac5878, 0x58593c04, 0xbfe3f46f, 0x711c096b, 0x6a37ff81, 0x58f68a0f, 
	0x4538099e, 0x51565bef, 0xb6553afb, 0x2f68cdfb, 0x21e2b758, 0x32c9c917, 
	0x9c9389e4, 0xad9be779, 0x38c5cca4, 0xf3c5ae74, 0x5775f30f, 0x6067f9ca, 
	0x45feb43f, 0x60d73f72, 0x3f62c33f, 0xdf75a7b8, 0x04d07a1c, 0xfd775bbc, 
	0xae340343, 0xb78c577b, 0x3efbe47b, 0xd6203fac, 0xe5ee7e8f, 0xae353ac6, 
	0x91e1dd05, 0xfbbf3107, 0xa73b78e1, 0x4fd63e7f, 0x37cd97ef, 0x55ba7a73, 
	0x17f841ed, 0x7c4d5bfe, 0xfc7b85dc, 0xbdcfb456, 0xdf173475, 0xbf375deb, 
	0x7e2baf81, 0x9fe7293f, 0x06a3cf29, 0x257ea7eb, 0x78d079c6, 0x3fc27f21, 
	0x37e7972a, 0x1ab7a0df, 0x9e36f4e3, 0x93d06d5f, 0xef4963de, 0xd5ef902d, 
	0x255d3a4a, 0x6922b9e7, 0x38d2531e, 0x5e7fd901, 0xa4a63cd2, 0xf31966f1, 
	0x937ed034, 0x7be42bda, 0xae7ee58b, 0x6d51e795, 0x4ff5079c, 0xb245ef5e, 
	0x3cc6a5ff, 0xfd94b10d, 0x99644d36, 0x39741f71, 0xec27f3e6, 0x5c97a5e2, 
	0xd9fe866e, 0x54e2225f, 0xc5bfab47, 0x93a97ee5, 0xe97fd0d9, 0xee266ab5, 
	0xd62e968f, 0x4bd1f7f8, 0xe22755b2, 0xd53ad6c7, 0xe9bb3b0e, 0x37dc68df, 
	0x96eb74a9, 0x0535d910, 0x6ad9b8c6, 0xbed433f6, 0xeb298ce4, 0xbe627099, 
	0x7c99d2c6, 0x844b67be, 0xfab4753f, 0x2e7cb82f, 0x18add1c9, 0xb34eb1a7, 
	0x45c6be60, 0x6be6167a, 0x3914d5cc, 0xef9f2e5f, 0x42be7257, 0x98942f9a, 
	0x9eae496f, 0x9ffa0cf3, 0x633e6535, 0xe0d7cc4e, 0xe3d3fb11, 0xef90fdf3, 
	0xf2a9c1af, 0x6b86b1fb, 0xdf8c6cf5, 0xf3e358b0, 0x1d9367d7, 0x98ebf788, 
	0x4d95f71d, 0x35ba09ef, 0x6be75279, 0x3133d6c8, 0x5319fd5f, 0x54fef276, 
	0x2bdfd88b, 0xe51e7a71, 0xa8e7d5f3, 0xad471839, 0x4f986cd3, 0x3d44c45d, 
	0x7cc53997, 0x5be6365a, 0xc9a9cf26, 0xfacf4a9b, 0x7a09dd5c, 0x8e4d67aa, 
	0xf86ef9e4, 0x1bdfd8a2, 0xe75ef9f1, 0x54e0ddf3, 0x86e718ad, 0xfe3e356b, 
	0x5cf58b0d, 0xd6cfafd4, 0x1a9e82ed, 0x7932e7a7, 0xced2cb7e, 0xd56c86ef, 
	0x7f5dfd86, 0x4c91d466, 0x1575d9cf, 0x8d7fbe7c, 0x3f36f7cf, 0x7473ebbf, 
	0xbb3da79e, 0xf8c1cb4e, 0x996917b3, 0xaccb9ebc, 0x166a7f62, 0x0dce1fdf, 
	0x327e10f7, 0x9d7f88fa, 0xbc1e0abe, 0x53110c77, 0x8fdadf12, 0x38f89d50, 
	0xebc15acf, 0x5b843d7c, 0xef3f11ae, 0xc2b2dd9f, 0x4e737905, 0x0b905d06, 
	0xedd44b87, 0xcf5e0afa, 0xc692a49b, 0x73d18d73, 0x73ebc792, 0x2dd03cb5, 
	0x1ea2a9bb, 0x93ce47f9, 0x0e238e54, 0x1be62543, 0xde0832a6, 0x49d77510, 
	0x3d9e7f3f, 0xf215bc74, 0x25463cec, 0x9c6c77d6, 0x5483edd7, 0xc46afac7, 
	0x4367d9f3, 0x15c9d076, 0x3815b378, 0xc157dd91, 0x39d76f7f, 0xb9e30fec, 
	0x419514e3, 0xed4b377c, 0xf172df58, 0x3d44c5dc, 0x15b83c7b, 0xa9d4e678, 
	0x2b627ec4, 0xa41edd78, 0xebcfde92, 0x69fb12a0, 0x679fc15e, 0x145bf11f, 
	0x54a33baa, 0x0a91fc62, 0xa807b75e, 0x2a51f8c4, 0xa898fe31, 0xa8fde9bf, 
	0xae397a0b, 0x3c75d6f7, 0x067f60c8, 0x7b9cfdc5, 0x37a888f9, 0x5946facb, 
	0xea7d84d7, 0xe5d6587e, 0x8dc1607d, 0x5bd866aa, 0xd164dfe8, 0xf9258fec, 
	0xb04a4de3, 0x96fc806f, 0x8fff4ca6, 0x34d7e4a3, 0x511cc565, 0x2996a7f2, 
	0x4bd2359a, 0xe22e50b8, 0xdd2f4b6c, 0x7a46d870, 0x88a9567a, 0x57ed18c3, 
	0x73bf0a97, 0x9bd08e69, 0xfc01afd4, 0x6897ef16, 0xe71d170f, 0x9bf719a5, 
	0x5bfb8e78, 0x9623b094, 0xb3cc625e, 0x9e6521b0, 0x8e79bb44, 0xb6ff876c, 
	0x7b78aaf4, 0x1f3fb938, 0x68381daf, 0x30f0bbcc, 0xef28d3d6, 0x56cb1a23, 
	0x94ac7df3, 0x9bf68dfd, 0x0d1a3ee4, 0xcd5b2bdc, 0x97ef11f7, 0x44f9e768, 
	0xeffae52b, 0x36547cc4, 0x9fc633ce, 0x7e3290db, 0x7faf9da2, 0xe37f5ca5, 
	0x387b78fc, 0x319d7fa5, 0xc9c3dccf, 0xea6537f3, 0xe096069b, 0x81f6fc7c, 
	0x9b0f9c2c, 0x7401f227, 0xaf84777f, 0xc1ef8c2b, 0x49afd42e, 0xa59d37da, 
	0xa1b65ee2, 0xbc1bd45c, 0xe53b7ce2, 0x5b7b467c, 0x35fb88a9, 0xf52b78c8, 
	0xf78974e3, 0xba73b44b, 0x68ba4a74, 0x2e1b5cf2, 0xe717c631, 0xd12f7f1a, 
	0x29d2e9ce, 0x5570d2e9, 0xd29c3dbc, 0x1e635aff, 0x7b469e71, 0x1338d653, 
	0x78cfeafc, 0x21d7ccd4, 0xb1a590e8, 0x1f68a581, 0x5187f70f, 0xc68a7b27, 
	0xadf72bdd, 0x155773ca, 0xe57b0fc1, 0x80fb4678, 0xd0d507e4, 0x87e08a13, 
	0x3b44bf78, 0xb95ef7df, 0x7e496fef, 0xe319e750, 0xbf887e0b, 0xfbe76897, 
	0xadf72bde, 0x87b78fce, 0x19d7fa53, 0x307e08f3, 0x95cfd3da, 0x9df7c1d6, 
	0xfe0cbede, 0x2c3fbd1a, 0xc65b3df7, 0xfa2f668b, 0xb0f7df0a, 0xff68cf1c, 
	0xd9ef3c81, 0xfd448e32, 0xfde3bef8, 0x9e5ced12, 0x3cf2e4a9, 0x4cbff72c, 
	0x9bc28efe, 0x3fc2c5de, 0x6343b1bc, 0xf733fe49, 0x5f85da1b, 0xf7413c88, 
	0x1d8cfeba, 0x9ece9764, 0x4e6bac67, 0x12baca43, 0xc35e9ced, 0xe7b35e92, 
	0xc9c3dbc7, 0xfca587fd, 0xd633aecf, 0xedd38739, 0x7fc8cbbd, 0x2df84969, 
	0x497f83df, 0xc955f07a, 0x88e253a7, 0xfbf28f63, 0x38efa6e6, 0xa7f11c64, 
	0xd8687ebc, 0xf7167fb8, 0xb11c4615, 0x22469ab1, 0xb1298f7f, 0x55c25cf0, 
	0xfc79abf2, 0x4dd2ecd0, 0x69c7bbe2, 0x8f5dbfee, 0xc823217c, 0xc6ffbda6, 
	0xefc8c96f, 0xd6fcf822, 0x6e99bdf8, 0x98f3433e, 0xbefc43dd, 0xad6972db, 
	0xdf8262c5, 0x52716235, 0x89f02e69, 0x20cf6efb, 0x3c14eed3, 0xf625a5d9, 
	0xef39d3fb, 0xfafaf58a, 0xb27bf166, 0xf8d9b1fc, 0x1799531e, 0x4d7f0d9b, 
	0x0facaa71, 0x53371ef1, 0x79212236, 0xebe3cd50, 0xbcfc33a9, 0x8be7a553, 
	0xde7f90f7, 0x3ba0b88d, 0x91f4d6c6, 0xa95dff1e, 0xee3203c8, 0x8c75dc1f, 
	0x69ba9de7, 0xdd7dc47c, 0x4aceaf92, 0x2bec63b9, 0x7fd01efc, 0xbe7ce5c9, 
	0x7967d5e3, 0xf2eea03c, 0x886a97da, 0xfab5593e, 0xaeafec6c, 0x7f69fc83, 
	0xf1885c72, 0x36ba803c, 0x7f89df11, 0x7ac1d55f, 0x95317df0, 0x23e65966, 
	0x99ca993f, 0xb65cbcb2, 0xcdfac837, 0xfddbbba8, 0xe443dd85, 0xfe3397f7, 
	0xbda833f7, 0xb6e7870d, 0x33574f30, 0x7fc60793, 0x35d3c43f, 0x7e475496, 
	0xb373f266, 0x92dcfa9a, 0xeb4ccf56, 0x4cb7df8f, 0xe235dfae, 0xf311aae9, 
	0x607be45a, 0x696bcc33, 0xbcd3aa4e, 0xde69cf29, 0xb496e794, 0xff6a667a, 
	0x7e426505, 0x38ea7f30, 0x537bca5a, 0x79f065e4, 0xcf37afce, 0xecb4f715, 
	0x5f9ccbd8, 0x78aefe87, 0x99a1791a, 0x8a2f23ce, 0xc343defc, 0x97c0da79, 
	0xef46c57e, 0x0ca68d91, 0x07909f5c, 0xf224f21d, 0x3f9c2c43, 0x3043f293, 
	0x6be4365e, 0x9097cb9c, 0x597c84a7, 0x98f43df8, 0x067a5f21, 0x82c5e7fa, 
	0xa4bec2af, 0x7dff85ba, 0xff951a84, 0x95c92c4e, 0x983c8a52, 0xf1336a9b, 
	0x77ec6707, 0x2f22648e, 0xe9aaecc6, 0x77f086b4, 0xe5c29856, 0xf9e35cad, 
	0x441bc853, 0xfa22ee7e, 0x90bfd75f, 0x736e483f, 0xd75e4af8, 0x9f904f7a, 
	0xabe1ed48, 0x580b1ea8, 0x1a9f3442, 0x69847ea5, 0x69eef88d, 0xd6331705, 
	0xde7a03f5, 0x0ac9efe7, 0x0a2dfef2, 0x376ecf3d, 0xefa1077e, 0x27fbe227, 
	0xd9d618f3, 0x68a3ef88, 0x7ee48b9f, 0xe9b0ffa9, 0xd44b8439, 0x2d75f628, 
	0xf788dd75, 0x8858ea02, 0x8a347bcb, 0x19ef997d, 0xbe48b971, 0x91d6bfb3, 
	0xb732a3e7, 0xde73c857, 0x35f91de3, 0x42879916, 0xf5781673, 0x8833cbfc, 
	0x881dbe0f, 0xfc09d65e, 0xe7e71568, 0x47e0a68b, 0x1f811af6, 0x74f72ff4, 
	0xdc873f27, 0xae64bc33, 0xb2c27917, 0xe1653aee, 0xc93055e7, 0xef40bd4b, 
	0x11f775e6, 0x63ddd785, 0x4c785ea2, 0x79c70bd4, 0x8a4e7aa9, 0x7894e7ba, 
	0x75149dee, 0x2bf22eaf, 0x25fe513f, 0x45264bd5, 0xe5ef44bd, 0x5923d2f5, 
	0xb88a5ebc, 0xe092f657, 0x9446fea1, 0x4c48367e, 0x9ec55d98, 0x592af5e7, 
	0x91eed52f, 0xe5a5d67a, 0x307e7d52, 0x3f196867, 0x1f5f6b1f, 0x130d954a, 
	0x1a6f667e, 0x71a3edef, 0x7f256fb3, 0xb16e708e, 0x8b76d35b, 0x2db43af7, 
	0x45b3ae3c, 0xe3cf16e2, 0x54da7c5c, 0x0967e5d8, 0x8e2abdbc, 0x4263a6ff, 
	0x5bcff8ee, 0x949c9f43, 0xe7fa0872, 0xa079e8b4, 0xfb3981ff, 0xcb7f10ca, 
	0x47cecef5, 0xa5b5c2ee, 0x37dc16fa, 0x2dd5d9d7, 0xefceae32, 0x36b917d3, 
	0x7c24dc70, 0x07bfe02e, 0xef819c43, 0xd4870afd, 0x885f9e02, 0xc813d394, 
	0x7a8cd7ff, 0xef89594c, 0xdfd17459, 0x0b1bb875, 0xd07f9c59, 0x362315d3, 
	0xdbad49f8, 0xfc51e742, 0x276e23cf, 0xd5efa595, 0x9e15ba16, 0xdfc85367, 
	0xa3e79977, 0xbd498cff, 0x6e6fbc50, 0x7e22f7c7, 0x7a88f266, 0x15ea3f78, 
	0xef0f7ad6, 0x5ff8ea7f, 0xe67d5065, 0xf33de78c, 0x4baa9c68, 0x53e77817, 
	0xf3f16b39, 0x6b2a3ade, 0x43e05a6e, 0x9dee78fc, 0x549cfbcf, 0x416fbbce, 
	0xbb216111, 0x8be791e4, 0x6c0ca94a, 0x855c5059, 0xf5be4bef, 0x2a3cf17c, 
	0x41777fe7, 0xaf2a7cc9, 0x25f3d1fa, 0x6e58a3a4, 0x5738e339, 0xa50593fb, 
	0x6b9f3a16, 0xa95dff5e, 0xfbf40b35, 0xce5fa731, 0xd8f16923, 0xf129aa6f, 
	0x7c66b7d8, 0x6dfa05b4, 0x9ad349f1, 0x3fe3a23e, 0xb7eaa596, 0xde747545, 
	0x6ade715b, 0x17f3ee2e, 0x67f17b49, 0x62bec265, 0x4b9e45cb, 0x71571fcb, 
	0xfd5e3a3c, 0x754f2e33, 0xe8dfa46d, 0xa43b727c, 0x8cc03b7e, 0x8f1e097b, 
	0x8b43e233, 0x7973d69e, 0x3a69e9bc, 0x7ec4e19a, 0x0359b916, 0xb1648f7e, 
	0x4743999b, 0x6c438e88, 0x39bbbe3b, 0x739de730, 0xfa776bef, 0x82d91ebe, 
	0x9345a9bc, 0xcaa75f62, 0xb1b5bdc4, 0xeb88c5af, 0x3a3cc56c, 0xa962d7df, 
	0x265b7fb7, 0x4acd76f5, 0xbf7fcf1e, 0x45f72022, 0x6b9fd64f, 0x81ff225f, 
	0xcea0b570, 0x8297edc2, 0xc3f816f9, 0x92666dd6, 0x779942ef, 0xf2d8ff93, 
	0x2bbfb86d, 0x9afcd5d8, 0x4531f7bc, 0x88390a8f, 0x5e89b94a, 0xf88ff62f, 
	0x9b43a731, 0xe79e1790, 0xf87ee534, 0xfe07ae39, 0x3d096581, 0xc53d0170, 
	0xac6a7ea4, 0x7ce991a6, 0x9a4ef7cc, 0x8646fbf0, 0xa55ecabe, 0x3777209a, 
	0xe395e597, 0x5ac5e6ef, 0x75e7c299, 0x12e43ae9, 0xf116a4b9, 0xf30c35bb, 
	0x7fa13544, 0xfc5c3a26, 0x168ccc7b, 0xf84e3e99, 0x89fffb8d, 0x3fae41cc, 
	0x2e006360, 0xa17d244b, 0xe2bf90c0, 0xd8e699fa, 0x7f2af348, 0x176bbdac, 
	0xd7ee69f1, 0x38b97bff, 0x161c92a7, 0x1a0277c2, 0x13cc15d3, 0xff80cf23, 
	0x8b2b39dd, 0xc29cfbe1, 0x9f430b20, 0x38083b78, 0x59aa1fa1, 0xfef8a77d, 
	0x13e9c7d6, 0x3d7095a5, 0x78e5e829, 0x96b13983, 0x9cdaa0c2, 0xf1f3e011, 
	0xebd309df, 0xb6912e05, 0xbb874053, 0x0abaf7e5, 0x8d790fad, 0x119f2885, 
	0x36f3ccb8, 0xddde3135, 0xcf5e3bf2, 0xcf032d31, 0x7c5cbeff, 0x11766b6f, 
	0x8e7bd14a, 0xbf106c4d, 0x2bf642ef, 0xd37a37bf, 0x6e0587ab, 0x47c025a9, 
	0x987f97fb, 0x1d9bef81, 0x76f110df, 0x783b17c7, 0x95fe961c, 0x3b83dff2, 
	0x77f9b2c6, 0x4f61b8c2, 0xab0ef7d2, 0x25df0a6e, 0xa9e05e70, 0xaf758a56, 
	0x9ef063a6, 0x7117efe0, 0xf9991bfb, 0x8007a936, 0xceb533ab, 0x93618d28, 
	0xabf14d7e, 0xfbf0bb83, 0x6ea77642, 0x1959efc2, 0xb968e5f6, 0xf2cdff90, 
	0xd69f981c, 0x26afef4d, 0x2563224f, 0x0eff979f, 0x862fc951, 0x90efe176, 
	0x393f52e9, 0x61779ada, 0x9904f7df, 0xd0ef7f05, 0x27fb1552, 0x6e396bdc, 
	0x1f63b0cd, 0xcf34f98e, 0x12f9fc9b, 0x8b38ddfc, 0x7b5988e5, 0xf735b18b, 
	0xbe1b743e, 0x55e3590b, 0x9bb81b6f, 0x4e5b3fb1, 0xfd4bdff4, 0xf4a9694b, 
	0x3be24ade, 0x27cf3e6d, 0xb5fc6137, 0x922e82b4, 0x915c82a7, 0x1e12bb2f, 
	0x8ec9b7c1, 0xecf22e5e, 0xefb127a1, 0x2163b99c, 0x55eacae0, 0xf446d46c, 
	0x17efe455, 0xfda4cd64, 0x67ec9430, 0xd78c0f38, 0xf9afef49, 0x7d421e8e, 
	0x9b8d95a5, 0xedf9e8aa, 0x467e3c63, 0x3a7097b3, 0xf1b7936a, 0x8b16d5ef, 
	0x397af873, 0xec88bb7e, 0x9df8a0e8, 0xbb967bae, 0x2f88dd2c, 0xfb160eae, 
	0x5c6b97a1, 0xd76e7e26, 0xbcc97e09, 0x0d6664f4, 0xb3132119, 0x13bb1846, 
	0x72e2e2f2, 0x5d137561, 0xb4948708, 0x3ad5e7bf, 0x311df8c3, 0xf1362f71, 
	0xe20b49e5, 0x8345cae7, 0xbec4c37f, 0xe91e7e75, 0x8ac804f3, 0x4bc899d8, 
	0x47317e20, 0x777de25d, 0x4bf9d4cd, 0xe86e490a, 0x2e5f3ffc, 0xf56bc77e, 
	0x96fe4623, 0xe51df9c0, 0x9ecdbf22, 0xf6adfa2d, 0x7c442193, 0x67cc9ab6, 
	0x0af81dc8, 0xcc940bbf, 0x38271227, 0xe6f8249f, 0xf0fdfe3a, 0x55f50eea, 
	0xd1623f7e, 0x13f7e176, 0x8df2a7ff, 0x5f9c17c1, 0xb45f9282, 0xe0c4f9e9, 
	0xe13e74b3, 0x1fc493fc, 0x4bc6fbce, 0xd92f24fc, 0x21765aeb, 0xf97c41ce, 
	0xf22fdd93, 0x77378bbc, 0xd40f82f4, 0xac7b0c37, 0x2fa08b6b, 0x677c87e6, 
	0x3b79e7ed, 0x0e2780bb, 0x2dc3f06b, 0x236f3c0d, 0x7217bdba, 0x96f5fc1c, 
	0xb19e7097, 0x8b0f6dc9, 0xc33d86f3, 0xa12264f9, 0x17c5cef7, 0x3ce486db, 
	0x3d471879, 0x2b05df85, 0x4477f429, 0x337ad0cf, 0xfb9c21cd, 0x771172c2, 
	0xe6ca5e71, 0x74f7fc69, 0x27430a5f, 0x75a1be38, 0xf472fec3, 0x1ef2dd69, 
	0x6cca7f93, 0x712b97cc, 0xb556af3f, 0x38c406f8, 0x69e4af88, 0x5d0477e2, 
	0x17c5990b, 0x0838b814, 0xba46d37c, 0xdd9eb47d, 0x07efc433, 0x95937026, 
	0x55371f9e, 0xc617838e, 0xa6e24d4d, 0x70e9c5c0, 0x0a63e393, 0x3d8ffa6e, 
	0xe3e822f6, 0x0b29bbdf, 0x89b751f4, 0x8ef41cef, 0xeb0bdcae, 0x7b47a52b, 
	0xdf87d257, 0x24ea2b9f, 0xd74c63cf, 0x37eedc63, 0xf5a99f41, 0xe8553bfc, 
	0x9a55f02d, 0x2c7ae33e, 0x33d5f528, 0xf5c5fd09, 0xe625f20d, 0x63f86eb3, 
	0x27afe836, 0x8f281f69, 0xf67d7c7f, 0xefc619fd, 0xd3bf1047, 0xfe63eeb8, 
	0xa971ee9e, 0x9ea5c6d7, 0x6bd14feb, 0xe2bfb045, 0x729913e7, 0xd7e7253e, 
	0xfc39aa6b, 0x5b673ca6, 0xd7a73ce2, 0x8fe95a6b, 0x867cb97b, 0xa1931df0, 
	0x22995ccf, 0x6c7c4abe, 0x333bfe4a, 0x3c0bf4bf, 0xaa9fd17d, 0x705c0cd7, 
	0x6438142c, 0x49dafdc8, 0xff7e29f5, 0x6a7301f2, 0x5d870f44, 0xf7b500e0, 
	0xfeb81f02, 0xa9fffbc3, 0x5adfa216, 0xac4eef92, 0xd57f5277, 0x2b5ffb44, 
	0x6fea8fcf, 0x63fef899, 0xdc90ef25, 0xee2fcb7f, 0xbb7c0caf, 0xdff26587, 
	0xf7f26037, 0xbf91ee15, 0x4f98e083, 0x2a6bbfeb, 0x1c1c722e, 0x1c838a9f, 
	0xe04aeeff, 0x968b819e, 0x3bfe7497, 0x189796d4, 0x7b818f5f, 0x4b8eef1c, 
	0x15313b1c, 0xa74006b7, 0x837ea5f7, 0xb5dab91f, 0x2d1f7f8b, 0xcab1d5f1, 
	0x097e1875, 0x6b9253c7, 0xacd1c4ab, 0x7d9e31b6, 0x72a998e6, 0x7024749c, 
	0x8189f393, 0x63b98e93, 0x2e383f1c, 0x93f8857e, 0x29367ade, 0x62867eff, 
	0xea929b62, 0xbacd6e25, 0x30f7df8b, 0x466c57b8, 0x0136c6b7, 0x8ee39cef, 
	0x5cc9c261, 0x76e67fb7, 0x331cadc2, 0x4398dbcb, 0xcd2735ed, 0x790eb7d0, 
	0x22f5c78f, 0x5fb96bed, 0x435633e8, 0xa49f8143, 0xf57ea4de, 0xfd54d721, 
	0xdfb496f8, 0xf0b3fe89, 0x45c94c5d, 0x8b99df7d, 0x47359efc, 0xe34b5f66, 
	0x7c61996d, 0x3df69aa7, 0xee5ef040, 0xc4be1c3f, 0x8eeaea2f, 0xf9bf3c1a, 
	0x7a89168f, 0xe03bcb66, 0xffff231f, 0x0cf0eabe, 0x7770871e, 0xfc0f353c, 
	0x03bec4dd, 0xdae9f07e, 0xabf3c86c, 0xf8335dd5, 0xb3f6b3df, 0x13f5f832, 
	0xf8156bcb, 0x1eda9fd7, 0x9db7f7a0, 0xe2981ec3, 0xe29f0467, 0x1f62457e, 
	0xb1f1153f, 0x0f863ef8, 0x0cfd929b, 0x58da7799, 0x67ef9bbd, 0x267547d7, 
	0xd0fd86b7, 0x7ade93f9, 0xcd6fd2fb, 0xbce51f80, 0xfc06b277, 0x0248dae4, 
	0x1f702a3d, 0x53ff5cf9, 0x278e64ec, 0xfb8c2f3b, 0x9c2c7e86, 0xec7e8d31, 
	0x5e46e91b, 0xa112e39e, 0x98bd0d27, 0xc82d5517, 0xfd0c51f0, 0xdfe2e4d8, 
	0x4af3c4ef, 0x50fbfea4, 0xe4adb696, 0x0b381b37, 0x7a226d7e, 0x5e879cd5, 
	0x42f7f053, 0xf7f032f4, 0xe38bd193, 0x5cbd126f, 0xd6c97a99, 0x977f1c25, 
	0xec95dee3, 0xb8f3ffcb, 0x3d0267b0, 0xd13c84ae, 0xcf30b3f8, 0xb907335b, 
	0x367d513c, 0x4c75dbc6, 0x8bc04137, 0xbfc63d5f, 0x4c75d98f, 0x90bd43cd, 
	0x43bf80f6, 0xec61bb6b, 0x69fbc61d, 0x90103933, 0x6f5f211c, 0xf9a9d357, 
	0x872e9ebc, 0x7d794bb5, 0xb2399be5, 0x877f85be, 0x889fe373, 0xaafbcdfc, 
	0xbe219fdf, 0x14f559b7, 0x4790d8f8, 0x77ca4ba2, 0x9f56af37, 0xf77fc19e, 
	0xafe486b9, 0xd37f2128, 0xc0af57d9, 0x553d3f7f, 0xf4bedede, 0xb7fe14a3, 
	0x1d73a46d, 0xff9e7a9d, 0xe81e100f, 0x000000c9, 0x0003b2b1, 0x7dc59c78, 
	0xe5547c0b, 0x6777f895, 0x99dcccee, 0xc937264c, 0x804c4c24, 0x0421cf21, 
	0xe0751118, 0x21e5cb17, 0xa91f5d84, 0xedb1addb, 0x4a4f836e, 0x8d82a351, 
	0xe4cee5af, 0x21854041, 0x8d4404a8, 0x6b6b2ad6, 0x4db5bb1b, 0x106f5b5b, 
	0xd2b6ba05, 0xbbb29fda, 0xb8786eee, 0x8db67742, 0x55236eda, 0xbe739ff9, 
	0x8095e773, 0xfffb7f76, 0xfd5fd3ff, 0xbf77cef8, 0xe77d79d7, 0x4231ef9c, 
	0x4ae61518, 0xfb7f7c21, 0x90f36763, 0xda5b0510, 0x420f88ef, 0x3bcef9fa, 
	0x3f80b0cc, 0x023cd2a3, 0xd0a2c3f9, 0xf3798edd, 0x8201f11c, 0x805e5fe1, 
	0x7123866b, 0x0aa2e114, 0x655050f3, 0x8d6212ae, 0xc729cc2e, 0xee215e09, 
	0xb21544c0, 0x757aacdc, 0xbce710a3, 0x874bb03e, 0x56d53d76, 0xe96d093c, 
	0x7fb2ab6e, 0x6fc38c19, 0xf2816db4, 0x8ff132ca, 0x7bf1c63b, 0x53abda2b, 
	0x0c76c0ea, 0x137308a1, 0x4e3d6364, 0x47b5c71c, 0xcd7f9c03, 0x5c97e589, 
	0x85e640b9, 0x7c38e370, 0x0dcd08e7, 0x60d708fd, 0x6214d1a2, 0x58755d69, 
	0xf1c217ac, 0x6e8a87e6, 0x04ad70e2, 0xf1b1efce, 0x28388a65, 0x885531c4, 
	0x7885b7ae, 0x17e5b4f4, 0x9bcaff30, 0x6d886f06, 0x1f6bfd92, 0x079ffa64, 
	0xd6077a65, 0xb1c69e7f, 0xfb29c3a7, 0x38d14f35, 0xcb94d776, 0x3fb4277c, 
	0x85a038e9, 0xf638c03f, 0x1e38d38f, 0x0ee62d7d, 0x3d45b0d2, 0x79ed37d6, 
	0x9f29eb1a, 0x1147ff69, 0xbedd2fec, 0x051de3bb, 0xdb047dda, 0xb0447e87, 
	0xc026e9f3, 0x9f75cdf3, 0x5e8679a1, 0xa66fae1b, 0xcca78871, 0xaf5e210a, 
	0x7de2c233, 0x54c527c8, 0x62daa7cc, 0xcb986eae, 0x674130b5, 0xf0d3884a, 
	0xd00363b7, 0x8e11e235, 0xe5afa432, 0xbbf2ea48, 0x8f802207, 0x444709c8, 
	0x96a36e81, 0x7284ec5b, 0x7b97f8bf, 0x44ac9d25, 0xdbfbbe12, 0xf6855571, 
	0x5e06b35c, 0xddb8ab11, 0x2ed2cf6b, 0x76841f7c, 0xb96effdd, 0xf6c4c49b, 
	0x2e00feec, 0x7ee3aeba, 0xa76b7e61, 0xfe0c6c03, 0xe870941f, 0xa1c23f6f, 
	0x42fd83dc, 0x92be80fe, 0x19f21af2, 0x07ea0fe4, 0xeb0d3d65, 0xf3dba6d5, 
	0xff283d62, 0xe5156859, 0x9483a17d, 0x11d0c7ff, 0x568417ca, 0xa4517aca, 
	0x83080477, 0xd25cbcfc, 0xb0fe75c7, 0xb4a4efdf, 0x81a64ab0, 0x35169926, 
	0xabf754cb, 0xc9571694, 0xa649a4b4, 0x0d32cda5, 0x96945dfa, 0xbcb4c955, 
	0x9a53a649, 0xc5ef345d, 0xfd53c471, 0x165f10b0, 0x8ba1d9c2, 0x53e1916e, 
	0x5eb076b5, 0xde547181, 0x2354f7d6, 0xf6b023cc, 0x2067c340, 0xd9e715bf, 
	0xb53f0931, 0xfc8f50df, 0x984e77b3, 0x08a1ebf9, 0xe9715f96, 0xd3f29345, 
	0xc47d75cd, 0x895f36a7, 0x8023e016, 0x41b32c87, 0xda7e44ac, 0x0c29f92c, 
	0x93f3b4fc, 0xea3969f9, 0xf9137594, 0xd52600aa, 0x3f10a0f5, 0x56ba4b0e, 
	0x14fa4956, 0x1c06687c, 0x96fc8fa8, 0x70fc0e23, 0xbf785b6d, 0x178c04f3, 
	0x35df01e9, 0xaba50df8, 0x6aa0f01f, 0xe1e61d0e, 0xbc011140, 0xed0f5fd7, 
	0xd877e487, 0x3966d69f, 0x5c42edf4, 0xf94426df, 0xe6176c1a, 0x3aecfa07, 
	0xcfbd16e1, 0x14c62a63, 0x30b5f418, 0xe93e7326, 0xe79c0aa9, 0x7542ed75, 
	0x46ff628f, 0xf29dbc65, 0xff981ccb, 0xf587d39c, 0x38874aa1, 0x02b5f89f, 
	0xe38dc8f5, 0xae5873d6, 0xabcdf35e, 0xbbe17aca, 0xabbe30f9, 0x8c4d3be1, 
	0xce38b52a, 0x18f30e03, 0xe97e277e, 0xe3985c40, 0x3e3d2157, 0xe9f5245e, 
	0x1e07f7b4, 0x38e44716, 0x26af50dd, 0x098bfe60, 0x1914d4fd, 0x203f1cff, 
	0xaaddbf84, 0x53b5f2c4, 0xbdb6ab8c, 0x0cbded04, 0xd4c12978, 0x2bfdcdf8, 
	0xfae18f11, 0x9fd07d6d, 0xb9a4f121, 0x3655d184, 0x37453f11, 0x7c83f064, 
	0x51278d92, 0x06fffdca, 0x18b1b0f5, 0xe504dbf1, 0x9addf0a5, 0x923fb20d, 
	0xcfd7a047, 0x2bee12c3, 0x01addf94, 0xbd022ab6, 0xfd00c6bf, 0xdfa93dff, 
	0x6ba700fb, 0x55d78cfa, 0xd08dcbc0, 0xc8f3f74d, 0x62ef522f, 0xf95ce91e, 
	0x29767baf, 0x69e33f84, 0x582df301, 0xe50bbad8, 0x511bf218, 0x129c170f, 
	0xcd7efc7e, 0x82baf5b8, 0xea0f94eb, 0x7e3777c3, 0xf7e19464, 0x60a63f00, 
	0xdaba6dfb, 0x63d22e75, 0x371df2b0, 0x6bc4ebe4, 0x193ea55b, 0x78e5d6ef, 
	0x4fae1eb0, 0x8741279e, 0x60bb9227, 0x9c7e4285, 0xe00965ba, 0x0cfc6fc5, 
	0x87f3e7f1, 0x197d6e0f, 0xdf1e6fe7, 0x53d4b1f6, 0x429f83dd, 0x0f77c24f, 
	0x8a7ee1ec, 0x60711db1, 0x9eb4c5cb, 0x3de0fb5d, 0x2a05b919, 0x1dbca3d4, 
	0xaa781eab, 0xb317d691, 0xebb7e701, 0xed28a5b0, 0x7e1e3eb8, 0xebbfe71a, 
	0xf98c51b0, 0xf681c032, 0xa1ef1c7b, 0x677d0477, 0xe51c2356, 0x33bf18b5, 
	0xfce3e6c7, 0xec7bc827, 0xd667ca62, 0x7eb4adc9, 0xcde4ebd8, 0xb819ae75, 
	0xead7084e, 0x595595a7, 0x720188eb, 0x7438fd0e, 0xb9ca5eab, 0x8db88667, 
	0x5aa7dff4, 0x7913fe37, 0xe513f7fb, 0x2e18507c, 0x85aa176c, 0x9ec0eed0, 
	0xdacace51, 0x4ed3c245, 0xd2f2a078, 0xf80fe000, 0x51e01afd, 0xdacb375c, 
	0x1467568d, 0xea1a53c6, 0x9b94bc41, 0x5a4048ba, 0x89e8a17a, 0xfd3dbcc3, 
	0xf63504a1, 0x8c9f1fed, 0xacb87f01, 0xfb249d3f, 0x38422925, 0x77960b5f, 
	0x88424fb6, 0xf129a88f, 0x285bed03, 0x5881c1c7, 0xc6944f6f, 0xb79c88f5, 
	0x8f79c219, 0x9f1a2c3a, 0x47adbfa7, 0xbd5fd058, 0xa07a83d9, 0x97a1d1f4, 
	0x734f6815, 0xf3013308, 0x886d4fd5, 0x68013f63, 0xf890e121, 0xf47c05e8, 
	0x8deb90cf, 0x4406569d, 0xa5ec0bbc, 0xc24453a3, 0x977632d4, 0xfa0c3b40, 
	0xc189a299, 0x36aa4062, 0x1a61da47, 0xdb1a61db, 0x853a535f, 0x6f957285, 
	0xa59a6987, 0x76a6ae24, 0xeb3b6d2a, 0x559876ec, 0x5afcf385, 0xda08f5b5, 
	0xc2ddeb5f, 0xbb24be44, 0x6b7c8bcc, 0x99255d29, 0x61aa7879, 0x57fe308e, 
	0xa7bb4866, 0x241c2034, 0x42567d7f, 0xb0b5fe00, 0x51fb379d, 0x04b6bf5e, 
	0x63ca0d54, 0xe63af89f, 0xc8555f01, 0xa16fa45f, 0x7a25a29f, 0x88487893, 
	0xe38bbea1, 0x3f5c2340, 0x1bde381c, 0xd421d693, 0xa970da9f, 0x7a4ce903, 
	0x26b3c601, 0x695afc69, 0x3f3d3d67, 0xac2efea7, 0x8a203daf, 0xafaceddc, 
	0x505a9f01, 0x504e9038, 0xbbd638ef, 0x122708d5, 0xca1efeb6, 0xa7a877e8, 
	0x58d77ea1, 0x0ffabbbf, 0xdaa711c7, 0x7237d066, 0xbdf8433c, 0x6fa413e6, 
	0x7fa1fd5c, 0x7b583e46, 0x91575dc3, 0xdf4032be, 0xf875a2ac, 0x1a7e709f, 
	0xad9a0baf, 0x793d71f7, 0xd45fea52, 0x41b7a4fb, 0x486f5eff, 0x1faf6efd, 
	0xde30cbea, 0x788ebca3, 0xf918bf29, 0xf2375ec4, 0x63c089d7, 0xec152ae1, 
	0x5b3ba2e4, 0x507d42df, 0xa27587ec, 0xe903f805, 0x5c577204, 0xcc05eb08, 
	0xf582ef4b, 0x1baf20e4, 0xae173eb0, 0xf7e177d1, 0x9fa603da, 0xa8fac6e8, 
	0xc20ea6f0, 0x24a7daf3, 0x16acd71d, 0x7fc0c523, 0x42c245a5, 0x58fa5cfd, 
	0x467682a7, 0x84aeef06, 0x8d3db980, 0x86eb00fc, 0x409e8967, 0xdf764c3d, 
	0xa0d3b626, 0x3f00eb9f, 0x44c4473d, 0x9aed09bb, 0x35db27e4, 0x4fd3a9fa, 
	0x266572db, 0xd7c31c70, 0xfd3dde23, 0x7481ff03, 0xfbe70f38, 0xea4bce1e, 
	0xda1ee145, 0x78483deb, 0xb617f3cc, 0xefbe9d92, 0x3ddb2f62, 0x6d3e506f, 
	0x24f6b8f7, 0x4edb5db0, 0xf4f75a5f, 0xa13f1c8c, 0xb6f1da45, 0xca0ae09f, 
	0xbb5a7e71, 0x7219fef3, 0xcad5759d, 0xeed69f7a, 0xe7687ac4, 0x3bb6bffc, 
	0xdb1f44cf, 0xc331581e, 0xd90407b6, 0x03db1a03, 0xbb38cdaf, 0x06fa803d, 
	0xe93381ed, 0xb011358f, 0x87f47213, 0xfeb627d4, 0x7a327d20, 0xeb61fd66, 
	0x907f5b17, 0xec67093e, 0x3bcedb0b, 0x3d20fe93, 0x0fe8cd13, 0xf5b3fedb, 
	0x6893e907, 0xf6d86f46, 0x1f6796a2, 0x907f499e, 0xd19959de, 0xa3f6f91b, 
	0x0f483fad, 0x81beb28d, 0x6d75b5bf, 0x66f45557, 0x3db495e9, 0xa04af529, 
	0x4d895443, 0xe944f513, 0x88ddd6ae, 0xe4df5b07, 0xf5498beb, 0x297d8e44, 
	0xff0cbed8, 0x63b07eee, 0xd741eeb4, 0x63a4b8e6, 0xfeb51db6, 0x4764ed99, 
	0x7cb89a69, 0x6e215ecb, 0x0f551bf7, 0xfed51d90, 0x7fb256ce, 0xe87b6f06, 
	0xe5a7e02e, 0x1a51db93, 0x5f500ddb, 0xa5cb0bda, 0x90fd451d, 0xc7fc651d, 
	0xc2c7b216, 0x13fb6fef, 0x5bf2438e, 0x017fc83b, 0x41d347ae, 0xd9dd214f, 
	0x947e005f, 0xc1db02fe, 0xcb23377f, 0xf59ab85f, 0xa7f097a0, 0xd00dfae4, 
	0x43eb3b7f, 0x806a87c0, 0x44cd7029, 0x2cf886bd, 0x717aca3f, 0x4a7d44d5, 
	0x1eb0547a, 0x6f51313d, 0xb24cbe92, 0xea0afc7e, 0xcd9ae359, 0x058aa764, 
	0xcd2927f7, 0xa72ee3b3, 0x7d7f467c, 0xa8b6df92, 0x33baec9a, 0xab8b6dfa, 
	0x4336fc73, 0x7b1973da, 0xc8bed724, 0x5e881fb7, 0xb2ddb36f, 0x9a36e989, 
	0x3db03fb1, 0x3b6cf7b4, 0xd0aefb44, 0x5ed84712, 0x0fed9b7a, 0x5041db2f, 
	0x2a287caf, 0xfb62af36, 0xeecb24a8, 0xdb20edb1, 0x68fb41fe, 0x21dec67e, 
	0xed96a87b, 0x77b65198, 0xd98ed96a, 0xa8cd7689, 0x2da571c1, 0x7f90fb9b, 
	0xd43ecfac, 0xbc59f349, 0x89dcf005, 0x852811fe, 0xfd9aad6b, 0x7e44f0ce, 
	0x3906fdb8, 0xd417e42f, 0x7ac77feb, 0x1c42f91c, 0x369baccb, 0x6672d81f, 
	0xf9f23fc7, 0xc8bf1d22, 0x3b6d675b, 0x93e5cfeb, 0x913fa9ff, 0xfd613b64, 
	0xfae7af33, 0x3ec43013, 0x9f79efcc, 0x333f89fd, 0xafeb06ee, 0x0aef1d92, 
	0x4caa270e, 0xc7a14f5c, 0xa7bb403f, 0x0a20959b, 0x76ddc606, 0x67e7c64e, 
	0xf22657f7, 0x39d5c3f9, 0x5bf409f1, 0x3f7f2276, 0xafe39d52, 0x2bfb9318, 
	0x0209deb6, 0xb5ffc83e, 0xaff30ff5, 0x15bc9882, 0x6ef33ef2, 0x40b055b3, 
	0xf817824c, 0x1fb2ccd4, 0xc22ed0c4, 0x8f5eddcb, 0x497fd72c, 0x44d627f9, 
	0x19443f6d, 0xf1d3c6c5, 0xbca5e7c0, 0xec5fa4c6, 0xa82b0e69, 0x52ffc07f, 
	0x640aaf50, 0xb16fa849, 0xa5843a3c, 0xa2595ca0, 0xbbe1314f, 0xef8617d4, 
	0x3af17946, 0x0a9eb422, 0xd41189d7, 0x77abc757, 0xbafa45ec, 0xb7a2c35b, 
	0xab75e69d, 0x89fb0378, 0x97e0a351, 0x46347cc9, 0x563af2f3, 0x729a7ad3, 
	0x77fcc258, 0x4bcae7f4, 0x5d1f81ba, 0x9f026e50, 0xf42afefa, 0xbf23e443, 
	0xb24d4ab0, 0xa4528cb3, 0x5fb0618f, 0x1c528ba1, 0x9217c157, 0x14cf51db, 
	0x75e0717c, 0x4f35dfec, 0x1e5e9868, 0x2bfb85d1, 0x8388b5d4, 0x0e354e3e, 
	0x7beb8ddf, 0x5f8b9fca, 0xb708ff6a, 0x8fd332b7, 0xfed07ec0, 0xe5050cd1, 
	0xda0372e7, 0x37ea1c7b, 0xb0eddd0f, 0xdb8eb5e9, 0xa2fc3f45, 0xb758d2c1, 
	0x85f8e3cc, 0xcb786d6a, 0x13dfd0cc, 0xc6acbc01, 0x80709234, 0x5e214e9e, 
	0x33e390de, 0xdb94bbe1, 0x1fe03c24, 0x0ea93fda, 0x07c76eeb, 0x8e171e34, 
	0x6c84f533, 0x79b1f537, 0xa3f483b7, 0x7f5e1270, 0xd2677f64, 0x6adf6577, 
	0x5d1d238f, 0x04b5e1ad, 0x845ef557, 0x3e8d0707, 0xbfbe12b5, 0xf81efec4, 
	0x29bddb0a, 0x2af6a79d, 0xa42a073e, 0x4803ed1d, 0x2b7b19a3, 0x89eec665, 
	0xcfd53e41, 0x2f4e7ce9, 0xf1e1ee53, 0x179d24f8, 0x11f4de73, 0x0da06b9d, 
	0xc03553c4, 0xf51a3f65, 0x81e76cdb, 0x01e3269a, 0x584a44f4, 0x8fa40b77, 
	0x99ba8e06, 0x9744379d, 0x1d377889, 0x46d9af44, 0x610aed1c, 0xbbf26e98, 
	0xbeafc975, 0xff14ed03, 0x31335101, 0xf6f606de, 0x73a3e446, 0x425f840e, 
	0xc8edea3b, 0x8f575a7e, 0x026b1517, 0x63977efc, 0x37d23f60, 0x57b937b4, 
	0xff717948, 0x8dc78e5a, 0x46215cf2, 0x271be17e, 0x99a62b7a, 0xa5939fd1, 
	0xcd4d21fb, 0x3e304919, 0xf21baa3c, 0xe21d6287, 0x931b90f3, 0x876a9f7c, 
	0x83bdd23c, 0x1d10c2e5, 0x575b9426, 0x172e04c6, 0x55887969, 0xb01e5038, 
	0xfb723fdd, 0xf2869cef, 0x89095adf, 0xc23ed937, 0xa9f2869f, 0xc023c511, 
	0x0c3aa97e, 0x4ceb0b32, 0x540c1468, 0x222aafe8, 0x232353f3, 0x4f6f8c6e, 
	0xd0562c8d, 0xf61e000f, 0xb2247f48, 0x3525f91f, 0xc685bb1e, 0xb2e3ca35, 
	0x905561c7, 0x8668565c, 0x3e224cdb, 0x9252bf16, 0x56908f85, 0x00ef10ec, 
	0xbdaa81be, 0xc54f92b5, 0xb7234421, 0x23e716f3, 0x0d6afe72, 0xf7f635c8, 
	0x19dbc331, 0x92e31d2f, 0xdeb87bce, 0xc43f388f, 0xdf384bf9, 0x389bf9c6, 
	0x91f5c9df, 0x3f99873f, 0x313f9987, 0x3dc16cbd, 0xe40b3c72, 0xc8776d77, 
	0x6102eb7c, 0x55df11ff, 0x0bdb1c03, 0x99aa7849, 0xcfce51f3, 0xc4d1fd63, 
	0x966e3df2, 0x84365e92, 0x2243bbd4, 0x6db8f948, 0x8f9418c7, 0xa83c748a, 
	0xe70af48c, 0x5fd49add, 0xef506fa8, 0x0f59c784, 0x79882b09, 0x5fc0bf5b, 
	0x27e85bd9, 0xa65c385d, 0xa87108f5, 0xf21ac6fa, 0x635f5117, 0x27d7803c, 
	0x20775ab5, 0x2331155e, 0xaa5ced88, 0xcad71f41, 0x043e5071, 0x33e2866a, 
	0x6855f066, 0xbfb7a7c7, 0xabea3efe, 0xef529347, 0xf3bd4bb4, 0x8d67757c, 
	0x08ae7e0a, 0xebe99cb3, 0x7517a413, 0xab3c7af1, 0x0708b0dd, 0x7699fc71, 
	0x1701e08d, 0xabe91f8f, 0x37eef11b, 0xff8612e4, 0x3524e5b7, 0x295dfd00, 
	0x09e5b3fb, 0x980537f9, 0xdb3cfeeb, 0x3e19dd43, 0xaff1cbb1, 0x5fa323ab, 
	0xf50bb86d, 0xebf51953, 0x5dc83fd0, 0xbf129327, 0x8fd6124a, 0x9f786b87, 
	0x5a45ec62, 0xa81d7f1f, 0xfc897495, 0xc18cec9a, 0xdb679eff, 0x79fb399f, 
	0x26a0eb4b, 0x5cbafbae, 0x00eec92f, 0xa33c387c, 0x6da7ae0a, 0xc46bbb35, 
	0x69ffd4bb, 0x9e6b22b3, 0xf3080e8f, 0x1267c8cb, 0xa7abc7af, 0x3c7ce08c, 
	0xdf7d62dd, 0x621a984b, 0xd67bea00, 0x056fa29a, 0x714dbba4, 0x30750a2f, 
	0xbbb61bfe, 0xe41fbaae, 0xf7ab5ff9, 0xc05b88d4, 0xb1c1aa7e, 0xe6a9b10b, 
	0x3fefea19, 0xf9808ed0, 0x2dfd5d3c, 0x22ca272a, 0x4ebc627e, 0xf42993cc, 
	0x4c78c71b, 0xa1f6be3a, 0xf9eee7d4, 0x8ab68a83, 0x5724ace8, 0x68a9e066, 
	0x975ecf4c, 0xb4136ff0, 0x842bf1eb, 0xee46ab67, 0x8954789b, 0xd2357df7, 
	0xfab27f0f, 0xe00e3427, 0xf6e949c3, 0xce4773ed, 0xf3583e5a, 0x71da8d72, 
	0x6b67f2e6, 0x63a8d60e, 0x77c9d713, 0x46bcfe66, 0xd5c9bb05, 0x0e69ae30, 
	0x571407c9, 0xd026492d, 0x0e94702e, 0x80525d90, 0xc455ddf1, 0x7f5c8ec7, 
	0x2ebca0c3, 0x805f7ae4, 0xa7585a71, 0x397de553, 0x79df0172, 0xea822ec9, 
	0xeb092f54, 0x4963b61d, 0x795407f9, 0x3e9afca5, 0x7b74af69, 0x61f1faf3, 
	0x4fe6cd7d, 0xebefa2c5, 0xed7f9dc2, 0x7796cf6c, 0xa7fc87cb, 0x933747d6, 
	0x7063385f, 0x32f34eb3, 0x45878254, 0x75cbce01, 0x0c416761, 0xe3159ee0, 
	0x884ba205, 0x577e1ac7, 0xf31e82a3, 0xd7e9d95e, 0x7df72560, 0x77f553a9, 
	0x389478d1, 0x255ddfd0, 0xdc173be9, 0x1ef20d07, 0x8eded5d0, 0xa043fc0c, 
	0x59e62563, 0xceaf669e, 0xe1282efb, 0xe1723a73, 0xbe426718, 0x6c554dc4, 
	0xbcbedce7, 0x9a8f0c7a, 0x90a9128a, 0xfdf899f0, 0x979f097c, 0xa9befdcc, 
	0x9644515d, 0x157cc11c, 0x6ca430f1, 0xa6fdbb3f, 0xfad609b2, 0x18bef842, 
	0xd5366fdb, 0x159fa57b, 0xfb0dbadf, 0x00e6e333, 0x64add5a4, 0x74eeba5f, 
	0xf7e4099b, 0xc51e3d6a, 0x3bd41078, 0xc657fa17, 0x5e51c517, 0x2d6c48d5, 
	0x7147f1c6, 0xe1fc833d, 0x655a8a9a, 0xf77fa67d, 0xfc8e3d3c, 0x8a35cea3, 
	0x9eb8ed1c, 0x3a53fe48, 0x9cb0be6c, 0x55cba367, 0xd45aea91, 0x8cba191f, 
	0x9746cf3b, 0xb1878885, 0xe4ed782c, 0x977f4974, 0x1e1b1747, 0x21fa95ab, 
	0x7ae92e9f, 0xf8417479, 0x74898ecc, 0x489fbfb1, 0x95114317, 0x5d003e68, 
	0xc5d0cc1e, 0x28c5d348, 0xa2ebfb96, 0x459fde22, 0xe89d4697, 0x905d22a2, 
	0x44ad8d9e, 0xba69e597, 0x5fa3886c, 0xb58a8ae5, 0x14328ed2, 0xcfa02d89, 
	0xa5cfa44e, 0x321fcab5, 0x323570e3, 0x233c2e7d, 0x67283c7d, 0x4d8fa267, 
	0x71868297, 0xeb99ca3f, 0x821698c2, 0xafebbff4, 0xde3155aa, 0x1bd3a2bc, 
	0x2ef81185, 0xfda0f719, 0xc5f15954, 0xc71f5a5a, 0x5f907857, 0x86fe2b2a, 
	0xefcc61f2, 0xba45e394, 0xbae8f2ba, 0x861796de, 0x8eba41af, 0x9b2fd665, 
	0xf2efe9ae, 0x6fc36ae8, 0xf2baba63, 0x97ae9ae8, 0x2cf5d747, 0xba3cae6f, 
	0xbca33fae, 0x37574499, 0x37e5d5d3, 0x2177ae88, 0x669db15d, 0xbeba6611, 
	0xfec7e89b, 0x6baba20c, 0x5d5d2e5e, 0xd74492f3, 0x03b5d238, 0xd122fae9, 
	0xf2961dd5, 0x7a24d406, 0x1b91feda, 0xafdeb5fc, 0x6afb7d20, 0x3771bed1, 
	0x604f3d00, 0xf8d0431c, 0x76fae9f2, 0xf07143c4, 0xa1156a80, 0x6ab6ffbd, 
	0xd816ffec, 0x892a815e, 0xfeca74b7, 0x72b5d3cb, 0x4841ec5f, 0xbb1702c1, 
	0x303da56b, 0x5fc45ff5, 0x19f3976c, 0xef8129e9, 0x66bd73e7, 0xcbc6cf59, 
	0xb76f7f20, 0x7bef5f93, 0x44759748, 0x89fd0d4f, 0xce1fb42a, 0x6334fc85, 
	0x327c4e64, 0x2691eaf8, 0xd0a1f885, 0xd8f1027d, 0xb6fc91be, 0x959d76bc, 
	0x9e697b87, 0x19e61f58, 0x27ac8cf8, 0xc6272ed4, 0x42aa034b, 0x285aace3, 
	0x2149c0b4, 0x1af2cbbe, 0x0e121d50, 0x108e05fd, 0x517d685f, 0xab4467ea, 
	0xe2163a20, 0x37ee973a, 0xfef08e3d, 0xfbe471ec, 0x1dc0a93d, 0xff0befd2, 
	0xe2f3a650, 0xc7e7ffb6, 0x55dfd8ff, 0x77f39a16, 0x08faca74, 0xce322caf, 
	0x8997c9cf, 0x53f2720b, 0x8c760bac, 0xccebe567, 0x1bca730b, 0xf94e588c, 
	0x4e4162c5, 0x416b0af9, 0xf18f794e, 0x20fb43c8, 0xb5bc68dd, 0xb8adcf0d, 
	0x610fab16, 0x7713d87c, 0xad009bdc, 0xd19af4c0, 0x75c4c538, 0xe8cf8665, 
	0x5ecc78c3, 0x5a3ac384, 0x5fc07087, 0x84d8cf9d, 0x9f0c7df0, 0x458a6b31, 
	0x071817df, 0xb70afe10, 0xfc708753, 0x8838c0be, 0x7dfc03f0, 0xed5fb735, 
	0x9ffda933, 0xdcf5f7f1, 0xa4cfbd7e, 0x78655ff6, 0x5d5fb735, 0xbffb5260, 
	0xb9ea76e0, 0x9302fafd, 0x76e5afda, 0x18237e61, 0x89f5ae67, 0xd3a0494d, 
	0x538cad58, 0xea3cb947, 0xf7e1f713, 0x52f8ae95, 0xbefe778c, 0xb56fda56, 
	0x816d4fdc, 0x3d2af6a0, 0x1f70478b, 0xa3cb9c65, 0x102d1e5c, 0x157962af, 
	0x27f48ff7, 0x7f6749ff, 0xfc00f90a, 0x40ebf3ac, 0x357e302e, 0xdcb287ef, 
	0x1f95e594, 0x4f90562d, 0xc70a3f69, 0xb2b17a7b, 0xd475cf0d, 0xd5753e49, 
	0x07de3fb6, 0x352aaa74, 0x317b365a, 0xc0faff6d, 0x434ea408, 0x553341f4, 
	0x6fa39605, 0xa335a43f, 0x4c15fb89, 0x5fdfc72d, 0x94b1e38c, 0xef69092d, 
	0xc8c7c5e5, 0x1a776f7e, 0x912df90a, 0xcff7d924, 0x9651aefc, 0xe505feaf, 
	0x094f6dff, 0xc75565d9, 0xcb222342, 0x2352afde, 0xc2b6234a, 0x75f9c4f1, 
	0x29222e92, 0xdf2ae5f7, 0xfed1bb0a, 0x569bfa9f, 0x7038b38a, 0xf9c8b7e6, 
	0xe2765ea3, 0xe4cddebf, 0xbfc13767, 0xa47aa7de, 0x23f86cc7, 0xddeb73b3, 
	0x3afcecb8, 0xfced7fb4, 0xf3730bc7, 0xfe69e613, 0xed18fc84, 0x1bd79f24, 
	0x6af34bda, 0xedaf1bff, 0x09c6e4c7, 0xb680e2f3, 0xe47e433f, 0xe473f44a, 
	0xa1c427b8, 0xe313b534, 0x2306b413, 0x96e3c1bd, 0x3bed2f79, 0x67c834a4, 
	0xd2fcb1c7, 0x7de74b8f, 0x66237979, 0xf2b33788, 0x67a7c6cb, 0x095a73fb, 
	0xc29809db, 0xd2fee27a, 0x3f6cf4f8, 0xe43b7ddf, 0xae38bf91, 0x858d6ee8, 
	0xf9cc3ca9, 0xb963c846, 0x34d7bf25, 0x7f806758, 0x408ae3dd, 0x1cfe103b, 
	0xfc644703, 0xe212c875, 0xd7cfbac2, 0xe3413da1, 0x5f61f3c0, 0xea747e90, 
	0x1ce9bef8, 0x33088b7f, 0x25ddbe33, 0x7c131ed6, 0x0a63af89, 0xbefafbe3, 
	0xf4f8e50f, 0xaff1a88b, 0x87f382ff, 0x44fe659b, 0xa1cf1cb3, 0xd7cf1a66, 
	0x4c7e714f, 0xacd6ef96, 0xe3c3b508, 0x8689addb, 0x6a2a76a1, 0x0eba0018, 
	0xfc930b94, 0x4e1fe3b2, 0xe548f737, 0xe6e40db6, 0x9d714871, 0x741bd81d, 
	0xc203fee0, 0x7ce18d37, 0x22be226e, 0xa5fd027f, 0x40d93fe5, 0x8fd69071, 
	0xdd7cfd28, 0x47b43aba, 0x1e435753, 0x275a9450, 0x945df4e1, 0xc5668bbf, 
	0x21bbf137, 0x5fcb0efe, 0xc1847181, 0x78f37caf, 0xacc818bd, 0x6a5b0fdf, 
	0xc684a3bd, 0xb87e8f5d, 0x423dc765, 0xf924a9e2, 0x14ef1dcd, 0xafa35c73, 
	0x52e9e303, 0x079fe5af, 0x154073a2, 0x9d5df913, 0x28d3eb0e, 0x5073f3f3, 
	0xf899b2dc, 0x7c1ffbbf, 0x0fd69fb2, 0xdb7fff89, 0x8fefa419, 0x23a2baab, 
	0xe5ab83b1, 0x05eb003e, 0x5a5f7fdb, 0xdc9d60f7, 0x2e7292b7, 0x904fb934, 
	0x2cfa972a, 0x1ee0fe15, 0x4e3ccfc2, 0xf0407d97, 0x1ef7ec63, 0xf3a148fb, 
	0xdcf8c76e, 0xd2750bdb, 0x9d4ef83e, 0x0af9bf3c, 0x8fe82da4, 0x0f1c2897, 
	0xd78c34b4, 0x5e2d731d, 0xd8fafa89, 0x071bc247, 0x61bc75fd, 0x24701786, 
	0x587d679e, 0x126b8a1b, 0x7686a68f, 0xdafaac24, 0xbdff2cb6, 0x8f78f83a, 
	0x8ce3c152, 0xb28738f2, 0xe64f35e8, 0x89d1bc69, 0x2574a5fd, 0x7161c761, 
	0xdfff763c, 0x6ee793a8, 0x756a7eec, 0xc4ff4718, 0x74c33c71, 0x059e389b, 
	0xa0a7ee89, 0xd47fe9bd, 0x98405f68, 0x9983f13d, 0xaae3d9f1, 0xecfce5d1, 
	0xcdc7a5f1, 0x7a7e81f3, 0xb1c79fb0, 0x824f5c1f, 0xaad3f8b9, 0xb1d43ee4, 
	0xe04b5f69, 0xb2f783be, 0x61433bce, 0xcfd03b82, 0x332074a0, 0x1a1f2c3e, 
	0xad74fd94, 0x611b82cb, 0xc001d887, 0x67c4fdf1, 0xce805678, 0x82fe84c3, 
	0xa10507e2, 0x2f91ebd3, 0x3db8ba53, 0xcd79ff5b, 0x1bc6c4cb, 0xbb12de01, 
	0x1c24e29d, 0xc3b8a48f, 0x0a7cccce, 0xde286b06, 0xef836a9f, 0xd9e3eab2, 
	0xd4f3946b, 0x24f78393, 0xa6c75c61, 0x4fa0d8bf, 0x6f221f22, 0xeb882abf, 
	0x272cdbf9, 0x9f41fc20, 0x507da1e8, 0xf75a1f94, 0x5a7da45e, 0xcf84a463, 
	0x513a49db, 0x3a3fb83f, 0xed65f728, 0xd7137673, 0x39c9434d, 0xd729de3f, 
	0x837f60cd, 0x3fc1af94, 0xc79cfe50, 0x43bdf45d, 0x747f1417, 0x9972934d, 
	0xfd995f2f, 0xc93d6738, 0x9fae5459, 0xca854f30, 0x2b17ab5d, 0x178e913b, 
	0xb7bca3f6, 0x157e1724, 0xd9eb6fe9, 0x8ece582b, 0x44af395f, 0xb7e8c81f, 
	0x89470196, 0xaf514be4, 0xb099eb65, 0xb64faa78, 0xf1978eff, 0xb63c4498, 
	0x7afb483c, 0x067efc0f, 0xd3c9bf9f, 0xd6f75b37, 0x67fea047, 0xf4cbf537, 
	0xc73a098b, 0xfd5797fe, 0xf219a1aa, 0xb7b5d97f, 0xacf84621, 0xd9bd47ac, 
	0x886fef1a, 0xe375bc01, 0x7651de8f, 0xa86cf466, 0xee00f40e, 0x22bac28f, 
	0x39d269f1, 0x12df9811, 0xe1bb6f9a, 0x4d7904d8, 0x73c51d3f, 0xa5eb0b1b, 
	0x1d28e4bd, 0xa9fce048, 0xf55bda3e, 0x950fdfd2, 0x8568bcc9, 0x7bf2157a, 
	0xd47c366f, 0x7864ec70, 0xc85ff605, 0xefdc96f0, 0xf68a4017, 0x287ce843, 
	0x84cff5c7, 0xed599df2, 0x70c370d9, 0x43d73dfc, 0x1174317f, 0xc92c67b7, 
	0x65e30f69, 0xaa420fa8, 0x6beb4f3c, 0x1c6ef709, 0xef9a7094, 0xf0bb17f4, 
	0xa0d0877c, 0x0f675c1f, 0xf83b7941, 0xad6c4623, 0x75cbbb8c, 0xd9cf82b9, 
	0x03f69b1f, 0x8b5f6392, 0xfb49aaf8, 0x1c71c2f8, 0x24346ce5, 0xf3a2acb6, 
	0xf9cb623a, 0x4e1f2fb8, 0xb847696c, 0xfd056eae, 0x61fdfe5f, 0xece6c627, 
	0x3ce057fa, 0xcb7cee41, 0x3d42ef3b, 0x0efdfe5d, 0xaf25ea07, 0x35f3a0df, 
	0xb7136ede, 0x542f8493, 0xfd0e36b4, 0xd3092f78, 0x1b3a8f3a, 0x53a3dced, 
	0x47184c5e, 0x8032ed28, 0xe2e5815e, 0xfe32258e, 0xcbb7d140, 0xb196fda1, 
	0xe65cfdac, 0x8c00ed4f, 0x51a6356b, 0x4ff82b75, 0x7762cbbe, 0x5ce64888, 
	0xec796f88, 0xaa579c0e, 0xd441d215, 0xdbb5327b, 0xfe24b9f1, 0xc874fca7, 
	0x2bfe85e1, 0x20711e7e, 0x385ea6ff, 0xea00bd3c, 0x7a97adad, 0xf8caf539, 
	0xd41ec4f4, 0x11efbc27, 0x0f03006a, 0xdf0fd7f2, 0x0af9fd8d, 0x5fd825cd, 
	0xcb2e9f5a, 0x75e257ea, 0xda7c7649, 0xa8f52b5f, 0x42e8dbb7, 0x1ad854bd, 
	0xbaeb8b5b, 0xbfdea7cd, 0x8e90250c, 0xa06a71e9, 0xd7c452b7, 0xb3b43889, 
	0xebee5ebd, 0x719f90f9, 0x3fab2dde, 0xbb704e2b, 0xf54d9780, 0xe7e1be32, 
	0xc7cd8638, 0xd28f99db, 0xede3e670, 0x3b7ec7cc, 0xfb92df9e, 0x17d23f7d, 
	0x618e39cb, 0x3dba71f3, 0xbc7cce1b, 0xdfd8f99d, 0x1f31edcc, 0x63e3cf6f, 
	0x27f01b5f, 0x7c86a3c8, 0x40f1243c, 0x2bfde5f8, 0xe8ba6758, 0x6ff2233c, 
	0x7b3f8338, 0x2202d13d, 0x72a77881, 0x07614fa0, 0x5be811e0, 0xaf3ca778, 
	0xb02fe36b, 0xe78dd23e, 0x8ceb02ed, 0x9fd079a2, 0x56d7866e, 0xf7b6e60c, 
	0x77ccbaf0, 0xee70dfba, 0xeae90c5c, 0xa40adae8, 0x88ee29bb, 0x51fa3387, 
	0x5e350bf7, 0x1dd0f08c, 0x758117c8, 0xa71c6ee1, 0xfcd22bde, 0x2a4e3d95, 
	0xd8e376e7, 0xf8824dee, 0x9f8c18e2, 0x918083ec, 0x6e023730, 0x7d9b0d96, 
	0x83ea9961, 0x9f397659, 0xcfb4c1bb, 0x7fc6ed94, 0xe1efdfcf, 0x7fb423ef, 
	0x77c07a43, 0xf22f7245, 0xe16e1a8f, 0xbf905afd, 0xda3b8016, 0x34f9d2f6, 
	0xca2f6457, 0xb57d7a6d, 0x75ed0bf7, 0xf688bc75, 0x6ee5808d, 0xec2ff1cf, 
	0xcfb6c97d, 0xa3fbd897, 0xf3e69e6f, 0x1bec9302, 0x2bff523c, 0x2f8e7f5a, 
	0x42d4761b, 0x2b496d7d, 0x886bd3d1, 0xfa78d9b5, 0x1385f009, 0xf3eda3e6, 
	0x2a3439d0, 0xe334f987, 0xa8eba239, 0x55fb00b9, 0x904bef97, 0x768adf9e, 
	0x33038ced, 0xe5e03744, 0xec6e62b8, 0xeb337803, 0x19d1eac5, 0x34c3b92f, 
	0xed3a2dcf, 0x7d2d8943, 0x8f668f80, 0x674f88b0, 0x9f105b1b, 0x6abf5f0b, 
	0xd8f0068b, 0x02f44561, 0x62adaa1d, 0xf0b9e375, 0x86939e1d, 0xda381676, 
	0xf810f8f0, 0xc93a0b59, 0x7bbf608e, 0xeef801c1, 0x52ea902b, 0x54382e4f, 
	0x973a1e2c, 0xe2fb47fb, 0x2d6f7f00, 0xee1ff610, 0x37f1a4e3, 0x77496570, 
	0x9903de39, 0x9bc76f1c, 0x7ed03836, 0x06ee7b7e, 0x4b504425, 0x70f7b941, 
	0x122ead5c, 0x511c6277, 0x64f2906f, 0x520d5dc3, 0x771c3dee, 0xefbc8b0b, 
	0x1f5e1282, 0x1a0785cd, 0x69e53ae4, 0x739ced92, 0xc7adccc8, 0x9d30cd70, 
	0x3844d718, 0xe387b7ca, 0x73c7d375, 0xc70dafbf, 0xcd71d99d, 0xc4e98740, 
	0xef00847d, 0x16fc7823, 0x1bcb35c5, 0xd3dabc64, 0xfbc2be6c, 0x6e370708, 
	0xf22cfec7, 0x26b73d43, 0x19ae30bb, 0x2566b8e0, 0x18de7f7c, 0x4cbb33c5, 
	0xae8c53f2, 0x811e80f7, 0xc31e2f53, 0x9053a8b8, 0x1bf4ce5a, 0x26d8e3b3, 
	0xe7d923ad, 0x485ce805, 0x8af745b3, 0x78aca702, 0xd03fd01f, 0x207d1228, 
	0x1d17c787, 0xffe83452, 0xff520d33, 0xdebae7db, 0x0ebf818e, 0x1584f6ff, 
	0xfa7c06af, 0x37e906a5, 0x3c34e7d8, 0xe072d142, 0x344f6f8c, 0xd33dfb9e, 
	0x9c5913cb, 0xefe5af0b, 0x07278547, 0x1cf7f8ce, 0x70d9dd32, 0x133ce94c, 
	0x6e33c1d3, 0x4bc2bd51, 0xec10be64, 0x96aee7f1, 0x95e433fc, 0xb7fa39f6, 
	0xf6235a9e, 0x65c4219c, 0x86343f50, 0xe29fbef2, 0xe6031ec1, 0x7cf3c037, 
	0xe12f8320, 0x1dea1cb0, 0xeef82788, 0x008f9e28, 0xf8e315fb, 0xbe0e3e78, 
	0x14b4c02f, 0x74265bbe, 0x5f3dec15, 0xe7823583, 0xdf510bda, 0xc57fbae1, 
	0xf40ea721, 0x15c9707a, 0x1f18650d, 0xba9cfd65, 0xfdf123bd, 0xc317e039, 
	0x0f802a38, 0x030f98da, 0xb7314b09, 0xcec2f941, 0xa5b7f744, 0xa71392fd, 
	0xd750a100, 0x44f41c32, 0xa17667c0, 0xc8481f1f, 0xf11c26fd, 0x8df7d436, 
	0x02b93c56, 0x25766dc7, 0x0f7a46af, 0x0f018a3a, 0x1c641b9b, 0x0ed7f8f9, 
	0xa57fe829, 0xf07cc216, 0xb0b2e9fc, 0x36b8c270, 0x69691cb2, 0xb8a11b79, 
	0xf4793dfd, 0xda41adbb, 0xde5a5a8b, 0xcb4bbef2, 0x6efc2e5b, 0x9696a79e, 
	0x1eb72b37, 0x2d46abc3, 0x384047da, 0x69690fee, 0xbefdcb79, 0xf1423c36, 
	0x9efc7b2d, 0xbecf2836, 0x7cf481d7, 0xcf8df918, 0x048936df, 0x16d30bde, 
	0x5d74bb26, 0xb16d17ce, 0x47bd9dc0, 0x7872961f, 0x19a57dd5, 0x78e34a3b, 
	0x720d75fc, 0x3f96d9bf, 0x589c17b0, 0x7fb7f20e, 0xb9fc967b, 0x5c558757, 
	0x78e11fd7, 0x2a7f60bb, 0xf9f02fed, 0xb4bb773e, 0x75e7454f, 0x0bdf7e54, 
	0x80b9f217, 0x76a7f21e, 0xf32f9c57, 0xbbaefbe9, 0x513d701b, 0xaefbcae7, 
	0xc366adee, 0xfe87e8e3, 0xd6fbe4c5, 0x7f742eb0, 0x8be8f48f, 0xf493268e, 
	0x8abe3380, 0xb89c2ff6, 0x14fbda3e, 0xc6271f80, 0xeb647fe5, 0x877f8643, 
	0xc7dec0f9, 0xbef24570, 0xa3bafa63, 0xa461f0b9, 0x3a63d62f, 0xeaf25b7a, 
	0xe5a9f5a5, 0x7094ec8c, 0xfef6a7d4, 0xee5f7147, 0x72d86af7, 0x28239f66, 
	0x257c84ea, 0x144fbca4, 0xd44e9bf0, 0xdc8356a7, 0x8b340a27, 0x569f5977, 
	0xfd8a5fdc, 0x200c7c81, 0x3e910f7d, 0xd97de22d, 0xf4fad397, 0x9fef1774, 
	0x040afcf5, 0xe9d4e8b6, 0x489dcdc2, 0xff67234f, 0xac43a8a1, 0x539cb8e5, 
	0x69f51398, 0xfb94d9a0, 0x00af8c22, 0x65edb3e8, 0x4ee89ed8, 0x6a283e82, 
	0x00f43904, 0x2aea365d, 0x61bf95fa, 0xfad80c39, 0x0aed04d5, 0x82c3d6ff, 
	0xe115d7f8, 0x4f6e14fd, 0x70b9188f, 0x351ebfc6, 0x3f4ce173, 0xc2e5663d, 
	0xa0eabf59, 0x4ce072af, 0xdeec1d0f, 0xa8a6386c, 0xe8ba6d5f, 0xe58a867d, 
	0xcb5fac65, 0xea552caa, 0xfa89d357, 0xa8f214b5, 0x039f035f, 0x71096afd, 
	0x375fad2a, 0x81bf113a, 0x51075801, 0x987ae2bf, 0x8a855fa3, 0x14e8b5fa, 
	0xdd35777c, 0xbf5152bd, 0x152c0606, 0x4531d7bf, 0xea5bbafd, 0xe306c2d7, 
	0xcb1bb425, 0xf50b86fc, 0x569ae16b, 0x6f21c627, 0x4371f25e, 0x7768bbf1, 
	0x3ef25781, 0x7b2003dd, 0xa1ba326b, 0x6780049c, 0x839614d4, 0xb23b051e, 
	0x1e9167c8, 0xf5c84a2d, 0x6ea5e616, 0xdb74c55b, 0x48b3e38f, 0xab3d828f, 
	0x9ddc8316, 0xe37a9117, 0xcd2486f8, 0xcc2b752b, 0xfea8f40b, 0xd143d480, 
	0x129f9488, 0xe5b577de, 0xf9223eac, 0x39e386da, 0x25a3d439, 0x72d87fec, 
	0xfd8efe96, 0x6cce5b15, 0xea445d78, 0x77de12d1, 0x5d2ce5b5, 0x9cb6e18f, 
	0xace51c21, 0x5b15fd84, 0x6defecce, 0x5fc7b339, 0x25e501d4, 0x92bb9667, 
	0xf51bb326, 0x95c80968, 0x45f3949e, 0xf9dd147c, 0xed177f8a, 0xc78f1a23, 
	0x532f3883, 0xc2593d45, 0xbe0050fe, 0xbb92cd2b, 0xb0b85fa0, 0xa2d4e8bc, 
	0xa8f5b2f7, 0xd3a7cf7f, 0xd641fea3, 0xe94be1a3, 0x7009f7de, 0x720e29dc, 
	0xbf8a49e0, 0xc8e9beb4, 0x4717a3d3, 0xfbe29e30, 0xfea3d4b2, 0x0147a08d, 
	0x757ec65e, 0x0fd0f6c9, 0xc0b7de35, 0x18aa5bf3, 0x5cb9e792, 0xcf78e3ab, 
	0x264dcf09, 0x36582fc1, 0x38a6063b, 0xc91d09f9, 0xe15b38ac, 0xae08e49a, 
	0xfc70f9f7, 0x3acb1beb, 0xde617977, 0x04a1cbb9, 0xffd815f9, 0xec1cfa64, 
	0x1da35561, 0xf521cb46, 0xce957ef8, 0xb8f5a71f, 0xde7a40e9, 0xe1b4f4c6, 
	0x0abf99ab, 0xef3c7ad2, 0xcf1eb4bb, 0x9112df85, 0xad20bc7a, 0x65eaf3c7, 
	0xf20762ec, 0x5fcc6dd7, 0x8a2fac05, 0x57bf733a, 0x668760c3, 0x2b5f71e9, 
	0x7c9f81e4, 0xff784fcc, 0x1df8f51d, 0x17176911, 0x37d31b34, 0x8e371e93, 
	0xfec01e24, 0xf1ea04ac, 0x74922b82, 0x7ac7c05f, 0x6922effc, 0x6f3ed8bb, 
	0xe0bfa2af, 0x363a753b, 0x0df71e99, 0x2ffc72c6, 0x9b077f5b, 0xdae38a2d, 
	0xb29df278, 0x7db7a812, 0xdbd4868d, 0x40e43e5f, 0x4478fdbd, 0x5b42edea, 
	0x727de36f, 0xeb0177f8, 0xfeb1efed, 0x0a76e42c, 0xe1a76f58, 0xd602ef8c, 
	0xd33869db, 0x76f580ab, 0xbb7ace1a, 0x1a76f580, 0x602ff8ce, 0xbfc36dbd, 
	0x90bb7ac7, 0x29d050e9, 0xbd6758e5, 0x4e9957ad, 0xa81d8bb6, 0x479003b7, 
	0x9f705dbd, 0x45cfdbd4, 0xc53176d2, 0x2c3a0b95, 0x9e6973b2, 0x70db7a39, 
	0x9df6dea2, 0xbef0ef82, 0x57e81b51, 0xf52f7e07, 0xa5a6217c, 0xdbd21634, 
	0x7e803714, 0xfbbc6182, 0xf8c074c8, 0x73fc0f91, 0xef5a67a4, 0x5fb44e1a, 
	0xff808d7d, 0x99bed8fd, 0x8e5d0248, 0x180bde31, 0x4cafc7ef, 0x36a3703a, 
	0xf6498575, 0xc64468eb, 0xf2330a71, 0xafd97e40, 0x33fbf0f3, 0x1985cbd6, 
	0x2efdc879, 0xf0390f23, 0x16df59d7, 0xb721e466, 0x889f9e5e, 0x0b5bb470, 
	0xf390f233, 0xf903c83d, 0x416b0589, 0xd0bda2df, 0x67fde50a, 0x9b0b1bf6, 
	0xdf410f80, 0x4c9ade16, 0x651dbea0, 0x7ceef87c, 0xce8bb625, 0xae0a1823, 
	0x1b53be6f, 0xb8e3fdc2, 0x1b151aac, 0x043f601f, 0x86cd44e3, 0xf43174d8, 
	0xf4f47ab7, 0x07408fb4, 0x9e6f529b, 0xc58abf51, 0xb1bbdf94, 0xbe5be652, 
	0xbeb4fa45, 0x77991cee, 0x017d3fb5, 0x8eb7e3c6, 0xe6fafc53, 0xda08b1ba, 
	0x8d8f25a7, 0x781a9c53, 0xbef4a9e0, 0xafb518c4, 0xa494e7d8, 0x6a726aff, 
	0xb8385c31, 0x9ce5c1dc, 0x4e170c5a, 0x329d7bf6, 0x316a726f, 0x5f5ca85c, 
	0x5a9cfae5, 0xae2e170c, 0x9cfae2ef, 0xe7970c5a, 0x3e1cf1ee, 0x316a7397, 
	0xace7d85c, 0xa73edc3c, 0xc685c316, 0x73971ae5, 0x785c316a, 0xb72f7db9, 
	0x70c5a9cf, 0x1f72e3e1, 0x316a7397, 0xfb70145c, 0xa73edc05, 0x9f85c316, 
	0x3eb9fbeb, 0x45c316a7, 0xe42fd721, 0x0c5a9cfa, 0x0f2e0117, 0x16a73970, 
	0xb71145c3, 0x73edc45f, 0xe85c316a, 0xfae75f5c, 0x170c5a9c, 0x98bf5cc5, 
	0x316a73eb, 0x7970945c, 0x6a739709, 0x56581c31, 0xedca5fb6, 0x5c316a73, 
	0x907eb904, 0x316a73eb, 0xfd71945c, 0xa9cfae32, 0xce5170c5, 0xce5ce5e5, 
	0x3170c5a9, 0xc29fdb85, 0x316a73ed, 0x3cb8845c, 0x5a9ce5c4, 0xdc15170c, 
	0xcfb7057e, 0x7170c5a9, 0xc39f970e, 0x0c5a9ce5, 0x7edc9517, 0xa9cfb725, 
	0xc55170c5, 0x3eb8abf5, 0xe5c316a7, 0x9f28313d, 0xb539f5ca, 0x71a62e18, 
	0xe72e34f9, 0x98b862d4, 0xe74fedce, 0x18b539f6, 0x1e5cc22e, 0x2d4e72e6, 
	0xdc198b86, 0x9f6e0cfe, 0xa2e18b53, 0xb9abcb9a, 0xe18b539c, 0xafdb86a2, 
	0xb539f6e1, 0xb96a2e18, 0xe7d72d7e, 0xa8b862d4, 0x5c75fae3, 0xceab539f, 
	0xe5c7a7be, 0xa9ce5cf5, 0xc0d170c5, 0xfb7037ed, 0x170c5a9c, 0x708f2e11, 
	0xc316a739, 0x7f6e4cc5, 0xa9cfb726, 0xc8d170c5, 0xce5c8de5, 0x3170c5a9, 
	0xc59fdb8b, 0x116a73ed, 0x0cfcff3c, 0x3b456dfc, 0xfb13d708, 0x13de0f1e, 
	0x347aac5a, 0x8e531ab1, 0x4c2fd6d7, 0xfb8f503c, 0xedd03fe7, 0x07dc4efd, 
	0x4bece3b6, 0xf69d09c2, 0x75b1353d, 0x31571c9b, 0xf9d5d3dd, 0x236cc9fe, 
	0xe5f57189, 0x7c847391, 0x0db22bff, 0x3b1767f7, 0x2d34bf42, 0x50bfd73c, 
	0x2f0a43de, 0x8ab1f8a4, 0xef0abf72, 0x95b95c07, 0x2f40ebf6, 0x0daa3dd0, 
	0x797c1f72, 0x91ee9aa4, 0x7af6832f, 0x057bc39f, 0x25bde50b, 0xb317d643, 
	0x4fea56c5, 0xe237512f, 0xcb98793e, 0xb1a90ba3, 0xb62d3db4, 0xb1f99c50, 
	0xf1332399, 0xbf45d17c, 0xaed49e29, 0x3d1fb09e, 0x37ed28f0, 0xfcf6ff57, 
	0x5b59df49, 0x998bf75a, 0x0ce32f74, 0xd48e99e7, 0xd5ca8afd, 0xe30b8f71, 
	0xd4476085, 0xf02efde3, 0xa4841aff, 0x8d7dee57, 0xbf4f73fc, 0xb9cf80fd, 
	0x7c6116d4, 0x9b4fb6ce, 0x7f45284f, 0x111739ce, 0xf7eb4b5d, 0xe5cb37d0, 
	0xa45e0777, 0xdbe87bf5, 0xd3ece417, 0xcc1cf19f, 0xf9936b6c, 0xe8e3dd0e, 
	0x0692fdc5, 0xf5a05fde, 0x91f2f10d, 0xffa5c5f0, 0x8eb9f74f, 0x61a558af, 
	0xa66c78dc, 0x0fbf1b8c, 0x0d4bda29, 0x5f1ed7ec, 0xcb07b8f1, 0x7df68e11, 
	0x0d91b2ea, 0xac841e7c, 0x332e9b0d, 0xda1f145a, 0x1fe5a98d, 0x70fb406c, 
	0xebc46c66, 0x539406b8, 0x094ee00c, 0x8faefdc7, 0x2a3b4a67, 0xadb1ef4d, 
	0xf7d93fe4, 0x13de8618, 0xbc39e297, 0xb36473fc, 0x05e890f4, 0x17d7cd7c, 
	0xaa5bbed1, 0x062bf78d, 0xd1fe4817, 0xe7dfcf39, 0x053a1fd7, 0xfba11eed, 
	0x97ba5ea9, 0x043f5f9a, 0x52ce37f9, 0xca5ca1df, 0xf17b08f7, 0xf5099ffd, 
	0x0db5cef3, 0xa62de2f9, 0x203e1fdc, 0x389c2fcf, 0x8e69fb88, 0x247dc3d2, 
	0x0768313f, 0x871d6ff7, 0x39bca00f, 0x20a87ed0, 0xce8cfeba, 0x2dc58593, 
	0x82cb5ed4, 0x6f08f95c, 0xf748f923, 0xcf205b17, 0xe7e3da55, 0x1f0a9efd, 
	0xbd9c5fb4, 0x55eb25ff, 0x67dcf7d8, 0x9df19b1b, 0x0b2d999f, 0x4d3f74a2, 
	0x97a4bd58, 0xb937ab34, 0xc8e7c333, 0x3c5ef20e, 0xae290f8c, 0xecbebe19, 
	0xdd46b7f2, 0xb76e7ece, 0xd69f032c, 0x0569f928, 0x75e413a7, 0x3ce837cf, 
	0x7ac6d1d6, 0x4bdb1f99, 0x59bff2f9, 0x65bdf934, 0xb4b88f3e, 0x7f5c5a0e, 
	0x4d4e3966, 0x6713f9b3, 0x18cffe07, 0x90b5e9f0, 0xf4358b6a, 0xacb96cf7, 
	0x023dc58e, 0x0346bce4, 0x27ff04fe, 0x8e6a6632, 0xf01a9063, 0x77ef179d, 
	0xbb443fea, 0x90f6f89f, 0xd4c7dcc8, 0xe1cf1315, 0xf829fda4, 0x57e617bb, 
	0x61a7e78d, 0x9a1fd5fe, 0x97dc36da, 0xc97a326b, 0xb8f29cff, 0xc6f9fa86, 
	0x49671946, 0xf435c495, 0xb0542a7b, 0x73a65feb, 0xd003ca0d, 0xe301b56e, 
	0x44db8ac8, 0xfd0d118c, 0x23f61a88, 0x73c5bed0, 0xa51b1b4e, 0xb31b4e1c, 
	0x0a93e434, 0x7fabb1bf, 0x8811fa5c, 0xd43a698e, 0x6a47f2cb, 0x68ed7942, 
	0xa6454ed0, 0x6e5a199d, 0xec370a79, 0x9a3fa95b, 0x5da3f62f, 0xdf03fdc3, 
	0x99e98d7e, 0x8d5ddedf, 0x01505e32, 0xbf7f46f3, 0xf65f9ce2, 0x735fbfa1, 
	0xb8be214a, 0xb71d31bb, 0xef75a3ed, 0xa0c98800, 0x1cfb43d4, 0x7cc0ba19, 
	0x0bbef4dc, 0xbeb04796, 0xb8fa87d5, 0xf5da11a6, 0x2f58de20, 0x86acff4d, 
	0xf2f72a7b, 0x4a34b63c, 0xffb135bd, 0xe2ef0fc5, 0x9bae0478, 0x1e3fec15, 
	0x83cdbe9f, 0x7d70b7f5, 0x9dc937a4, 0xbea9816f, 0x3db7a191, 0x75c3fc2e, 
	0x83dd48e7, 0x74a7188d, 0x2fd13ae1, 0xe204bde4, 0x561f584f, 0xf80a7ee2, 
	0xa04fb835, 0xd9d8ba2f, 0x42e8690e, 0x845c47ba, 0x1cf0c9f7, 0xcf882ea2, 
	0x5179eeb3, 0x3de4293e, 0x33af54f5, 0xbc26714c, 0xbd22fef7, 0x75c4e5f7, 
	0x03df88b9, 0x93eb4d4b, 0xd9db04f7, 0x93bf185e, 0xaeef8bd6, 0xf1b9242e, 
	0x69281cb6, 0xc5ef0282, 0x0f6a25e3, 0xe9ee97a4, 0x09ecb257, 0x1a77fd67, 
	0x5ac87f9d, 0xdaf7bac7, 0x6a9d8ff7, 0xbeeaa52f, 0x7d45d138, 0x9f2f5215, 
	0xfc72f0cf, 0xcd71cbd1, 0x1fa51a0f, 0xebe6d27b, 0xd6fef946, 0xdc7f3333, 
	0x7ccaf788, 0x0e2f1e5f, 0x968e38c3, 0xf8e248ec, 0x6296eec5, 0x53ed0fc4, 
	0x6c577ee3, 0xd387ad03, 0xe5239aae, 0x5e28335d, 0xeb356be7, 0x978b3df1, 
	0x9037fdb8, 0xfea2b7ae, 0xb67875e2, 0x1af785d1, 0xb0bb4d8e, 0x6168f51b, 
	0x802a2c6d, 0xc4e70a8f, 0x9efeb8a2, 0x1c3d5fa9, 0x98139551, 0x7d310476, 
	0x346be666, 0xb621b54e, 0xe965cf0f, 0x845ac191, 0x5e67c7a7, 0x6def8f5f, 
	0x2998ef8c, 0x8ce5ef58, 0x9f1e4def, 0x8dedae3d, 0x3325b900, 0x23ca073e, 
	0x2c5e6f8e, 0x5914e74a, 0x1f7e819f, 0xcfa771c1, 0x673df031, 0x7f2568b7, 
	0xe8d3153a, 0xff0682fc, 0x15c475c3, 0x4f6c0b0b, 0x9d03028d, 0x9f02eb8b, 
	0x997ae40f, 0x483bdffb, 0xfd74dbbf, 0x5281e580, 0x98dce79c, 0xf4fe82aa, 
	0x8e9e385c, 0x63e8e647, 0x3e7971eb, 0x9cb999fc, 0x2ff2837f, 0xde93290c, 
	0xf7e91573, 0x7d203e21, 0x4e3158ec, 0x444567e7, 0xb6f3db9e, 0x951ef418, 
	0x8fe40f2d, 0xc34239d3, 0x3a29cf25, 0x7e229fa8, 0xe592af47, 0x777edda3, 
	0xd7f0df4f, 0x792cd1ce, 0xa5e57331, 0x5cf954d5, 0xe72b977b, 0xd05264de, 
	0x1dc47efd, 0xd374539f, 0x0f394cbc, 0x312a8e5b, 0x5cbde28d, 0xc15bb9d3, 
	0xf1bb0ff1, 0xcaf796de, 0xf30c4f4e, 0xe69eb16d, 0x925bca38, 0x7558cde4, 
	0x685ca048, 0xd077901e, 0xe8556e41, 0xbc01742f, 0xf7c1acd3, 0x0a775c49, 
	0xca5ce27f, 0x93ef879f, 0xa8f9e22c, 0xd5de8301, 0x295ff803, 0xe2974a61, 
	0x7fb88bf7, 0x97bc8b6f, 0x571a746d, 0xbde41c23, 0x7ac5e648, 0x5189cef9, 
	0xe92fe724, 0x7e20f004, 0x0e269177, 0x7cd3e705, 0x0b9de88b, 0xab942f9e, 
	0xa8a2ef58, 0xef97e438, 0x82afe9f1, 0x6b6e043c, 0x5def443b, 0x6feec0f8, 
	0x96783c01, 0xa4377ed3, 0xb1ef1c4a, 0x52e5faf1, 0x37e724dd, 0xfdfc92ce, 
	0xbe5259b5, 0x2d54e52f, 0xa309f397, 0x00f4459f, 0xbbc60a3f, 0x3f581eeb, 
	0xe61d2e51, 0x8e30c353, 0x3ea4b3a3, 0xa73fcfb0, 0x264f869a, 0xca4728c3, 
	0x7e2fb454, 0xfcd9edcb, 0x7c0bdf6a, 0x2cc96ebd, 0x1df1c3b4, 0x04ef7a0d, 
	0xfe21edeb, 0xf87f7bcb, 0xeaffca46, 0xcf3e46c3, 0x7fda0df9, 0x5179bf2d, 
	0xe6433ece, 0x0198163d, 0x7bf60dda, 0xce321d2c, 0x5dfef825, 0x62c96b91, 
	0x22329fdc, 0x89390fed, 0x594ba24e, 0x384df38d, 0xd5ded27d, 0xabf66c55, 
	0x4cf5c2c2, 0xd9e237ad, 0x32be10ef, 0xb4e3be4b, 0x1f5c9663, 0x21878c0d, 
	0x0116efbe, 0x2fcb377a, 0xe11c3df8, 0xe7fcfba0, 0xce9025b5, 0x0ecbc626, 
	0x0991fbd2, 0x26378fa4, 0x74a33d7a, 0xef812abf, 0x8bc6055f, 0x7e6c0784, 
	0x827fc81f, 0x39cf8dca, 0x438dfec1, 0xa875a13f, 0x65fde5a5, 0xedee122d, 
	0xca71a769, 0xb79e1ab8, 0x4ba37f45, 0xde99c5ca, 0x8de7b34d, 0x89be2dfa, 
	0xbcc93fe7, 0xbfb87c6d, 0xc3fe756a, 0xd0ff9a32, 0x77d61f16, 0xae45b1bc, 
	0x7bef07af, 0xfd3dab30, 0xfcbda77f, 0x3e209479, 0xc7299fc0, 0xce2179f4, 
	0x3af014c1, 0xc1f3d30d, 0x7af2e28e, 0xf2e46f2e, 0x8f3e5c39, 0x9e7017f3, 
	0xbf808ce2, 0xe30f5c85, 0x1fa9298a, 0xfbcaaf3d, 0x4c94dee1, 0x7ba55e0b, 
	0xca6156b8, 0x3a7c3679, 0xb45f2316, 0xa2f792cd, 0xef1172d4, 0x44e59aba, 
	0xcfadf39e, 0xefcde7bd, 0x94fcb121, 0x0377c936, 0xb17f4d8f, 0xb4edd71e, 
	0x1c82d4fc, 0x7e599e0c, 0xafcefbec, 0xf2433dd7, 0xca426aa3, 0xfc8bd60f, 
	0xf3cfc86f, 0x33de72b3, 0xe7c9f962, 0x23efe273, 0x992bdfcc, 0xdaf8b3bf, 
	0x6fe273e6, 0x7490d083, 0xfe7ccb5e, 0x28f7f33c, 0x6773fbf3, 0xffc06fe6, 
	0xee577f3f, 0x4f917a57, 0xebb4bd6c, 0x5847181e, 0xcf1c7be2, 0x51dd4c5b, 
	0xe14eef8f, 0xcb9465fd, 0x90e8fa09, 0xf6849a98, 0x1f519d4e, 0x92fffafd, 
	0x5cf7fa3e, 0x77cab67c, 0x291f09d0, 0x3bf10794, 0xc8b79f7c, 0x7de3f895, 
	0x88be4177, 0x31cecdef, 0x63bda24f, 0x3b2eddfb, 0x32e3041e, 0xe600be00, 
	0x799272b1, 0x0cbfe3d8, 0x099f71ca, 0x1923d7bf, 0x1ec137fd, 0xf14edd68, 
	0x9a2feb94, 0x9b79f3cd, 0x9cf999f2, 0x53ad3de9, 0x1e5daf34, 0x8404d7e9, 
	0xfe3464b5, 0x503ed9bf, 0x7da67d72, 0x9cafb61f, 0x41413f05, 0x7ce2c5ef, 
	0xdf8941b5, 0xfc42b582, 0xfdccace3, 0xe0931d95, 0x5a8fc6c9, 0xdf027a3f, 
	0x5d722e5b, 0xcebeeebd, 0xa1ea7eac, 0x1fa6709f, 0x8d4e4b35, 0x6b0b94b0, 
	0xe58b9495, 0xcf8fcfc0, 0x3e7bf792, 0x7e543e49, 0xc4e48ebf, 0x4807599b, 
	0x5f3fcd9e, 0xfa3c705e, 0x4dc8b39e, 0x030bde48, 0xd7e828b2, 0x04afe0ab, 
	0x43ee6756, 0x3ad03ed0, 0xfc0a167c, 0xff19d599, 0xfe90cc44, 0x4f5e4889, 
	0x2efabf7c, 0xd222675e, 0x49d570ff, 0x3b35c3ff, 0xd458ffdf, 0xc3ff3674, 
	0xde6c6555, 0x1bef0cb4, 0xf77dbd1b, 0x62cd78e2, 0xd8d9bf79, 0x88487896, 
	0xff249a2b, 0xbe2f91fa, 0x83b5e902, 0xf8c9944b, 0xe27eec77, 0x743efba7, 
	0x767b2a7c, 0x9cb41d69, 0x3b641f1d, 0xd82b8ed6, 0x9efda776, 0x5afb8987, 
	0xaa9ad764, 0x5a2d6bb4, 0xbb6d0a47, 0xe672ecd5, 0xd52aa5d9, 0xa976d2b7, 
	0xf799e58a, 0x10bbe47e, 0x8e1768a5, 0x0aeebd92, 0x8bddf202, 0x90555d86, 
	0xdcc7976a, 0x7f9d0ab5, 0x6e7de370, 0xcea99947, 0x353ed133, 0x1fb9ee73, 
	0x534afba9, 0x142a7fae, 0xf4906ef9, 0x596e854f, 0xd201bef4, 0x09a9c713, 
	0x2025cf0b, 0x86fea5dd, 0xa3fb6701, 0xde87356e, 0xffae7729, 0x7863d539, 
	0xf37cf107, 0x5d6897f8, 0x9fcc7c3b, 0x84e4bf7e, 0xae29375c, 0xdc0a3557, 
	0xb4ce760c, 0x2adec3d3, 0x5dcd5780, 0x5f77c41c, 0x249e66eb, 0xfd9ba97e, 
	0xf93e69f7, 0x93e469c1, 0x89f033ee, 0xd49f20a1, 0xbabef9f1, 0x23bcf8fb, 
	0x4d5ad7ef, 0x29fd6ed2, 0xb268bfa7, 0x4d2dd2fd, 0x3b4defe8, 0x3e1fe79d, 
	0xc1e1fe0a, 0x50efbf2c, 0xdfa5f91b, 0x8e7e793e, 0x4c6d3a5f, 0x710f7dfa, 
	0xc13437bb, 0x73a36ebf, 0x8a97ec8d, 0xc869fa38, 0xb5678841, 0xddf94445, 
	0x4d377a2d, 0x4de7685d, 0x46d42eb2, 0x9613cec3, 0x8c3a2fd0, 0x6c9147fe, 
	0xcc797bc7, 0xb5437185, 0x02a4f07e, 0x91e3cb7a, 0x630688ef, 0x9bf51c46, 
	0xc1e8c8b7, 0x6b3182ef, 0x6822d21b, 0x69813e0c, 0xfbfc6c59, 0xed3d0ef8, 
	0x7dc11e83, 0xa2efd1fb, 0x553ee15d, 0x1173c714, 0xde28bc62, 0x1ed329b7, 
	0x8fc465f9, 0xc2bbf496, 0xd77a8aba, 0x18285533, 0x8a2cf2c7, 0x8f195e29, 
	0xe27c8cdb, 0x757f808a, 0xf060fd10, 0xb07be8ab, 0x00cf48ef, 0xfdd20cd7, 
	0xe5215e9a, 0x7cfbc142, 0xee9ca747, 0x5bcab8c5, 0xf0053780, 0x2f0e1e5f, 
	0x6a7efbc6, 0xe839f833, 0xad166b17, 0x5ca2af3f, 0xe2f547bf, 0x829f80c7, 
	0x699df265, 0xeff657ea, 0x407193ea, 0x9bc91f57, 0x7c93eae9, 0xfb93eaed, 
	0x772e6e11, 0xcb9bb973, 0x0e0e54dd, 0xd71e36e0, 0x3c7295a6, 0xbf805718, 
	0x9251bff8, 0x4b0e3fa7, 0xfbd8587f, 0x1fd29f09, 0xfd23bc76, 0x6f75a5e0, 
	0x8ba93e91, 0x49f794ac, 0xcdd49f59, 0x7ffc8aba, 0x9043cf95, 0x517b623c, 
	0x6b73c143, 0xf8d06422, 0x0fb8e5d2, 0x1677a5ed, 0x8d4ba42c, 0x88512efd, 
	0x7bf217bf, 0xbf6d6e5b, 0x44afaed8, 0x883dc2c2, 0xe4f2eed3, 0x3ec09dc4, 
	0x532476df, 0x27de9ddf, 0xd409fe90, 0xa74ff7a3, 0xf9ffa001, 0xe1c2f6ac, 
	0x559c255e, 0xdfee923f, 0x467a7643, 0xbe707a3f, 0xe8b0c6ee, 0xc1fb7a45, 
	0xf1a518ce, 0xd5737e93, 0x53f41586, 0x25f858b5, 0x0d57177c, 0x9cf18b9a, 
	0x9fd454c9, 0x869ed483, 0x7b7ed9ed, 0x0e151a2a, 0x2ede07bc, 0x2ab0fb7d, 
	0x5e224f7c, 0x70c1a093, 0x7ad8af5e, 0x4ca474d5, 0xdf879bc2, 0xf484d7cb, 
	0x9ca236af, 0x02cbfada, 0xf91bbe7f, 0xd9f250ac, 0xf5f83960, 0xbe916f52, 
	0x0a2b5e0c, 0xb8446e50, 0xeff28e3d, 0xc3977186, 0xb6653bba, 0xb64127d4, 
	0xd97ce8bb, 0xcd9f7a11, 0xa59e3f2a, 0x6efca2af, 0x8269c71f, 0x3df4eefc, 
	0xe479e5b3, 0x70ed1994, 0xe4f3df64, 0x4ee2a871, 0xe2ca471a, 0x3de407fa, 
	0xa21e9717, 0x9d291bfb, 0x95cda1cf, 0x71ecd0e7, 0x9aaefdd8, 0x1d9aed2d, 
	0x4a9ea5b3, 0x7cd00e39, 0x4b076d9d, 0x6d89b9f6, 0x9f503ec9, 0x946cd304, 
	0xb1d78be6, 0xbaf03188, 0xb08ba696, 0x9781e603, 0x1f6df038, 0x1de8844d, 
	0xb36a6067, 0xee921bf7, 0x40e85f64, 0x7c59e3c7, 0xf9d309a1, 0x04c79424, 
	0x1916a5f1, 0x83f8463c, 0x17d7bc22, 0x833d420c, 0x7d1d7bc7, 0x7df8296f, 
	0x11c5f02b, 0x78ac4bb2, 0x60efbd0b, 0xdc42c52a, 0x7d07e385, 0x3fb60ca0, 
	0x87397184, 0x7a29196a, 0x5def21bf, 0x017b58ad, 0xc7166bd2, 0x577e4c91, 
	0x0eb32eab, 0x61d6f37b, 0x9a570ef9, 0x2d9df85f, 0x0c60cf9b, 0x3d729be6, 
	0x2e7ff3e5, 0xf5e2df6e, 0xea34f491, 0x011f7a1d, 0x9909cdf4, 0x9fb38f77, 
	0xf187fd88, 0x25e9075c, 0x5e807fc3, 0xd2fcb4ca, 0x0aef909e, 0xca11f9d1, 
	0x777a3e9b, 0x74db43ac, 0x9fc32241, 0xf625bb66, 0x22f83225, 0xde71857a, 
	0xcda3bef2, 0xde9173e7, 0x31fa4ab7, 0x6bbec25d, 0x5ea31f25, 0x481bc6d5, 
	0x7a7c7daf, 0xaf53bd11, 0x9b5ba2a1, 0xdbc43745, 0x117a1993, 0xd0cfcf9d, 
	0xed7ae891, 0x4b8e9cff, 0xd67f4b66, 0xfcce63a6, 0x687699e2, 0xc3f960bd, 
	0x9b209076, 0x8397660e, 0xa2bd4b3c, 0xeb033d91, 0xebd236f2, 0xacd7a46d, 
	0x995ed2c5, 0x1c31face, 0xdf027c1d, 0x45e5b737, 0x3191889c, 0x4ff59d3b, 
	0x2ca2f418, 0xc736f7e7, 0x26d97bed, 0xdff50fb5, 0x8949fe41, 0xfbd91d05, 
	0x1f30558a, 0xd4c5a77a, 0x69278dd5, 0xe9ca51df, 0x8908346a, 0x5b3ee81d, 
	0xc5ad7cbe, 0x36bdf27a, 0xa1913ec7, 0x63d7d90f, 0xce0db768, 0x43427b46, 
	0x73cf0dbb, 0x47feb377, 0xcfae4dfb, 0x61de69a7, 0xefef8e2b, 0xef127ac1, 
	0x44e3b6cb, 0xdf877cb7, 0xed7c4e9c, 0x7e3ac18e, 0x583aed84, 0xc4175367, 
	0x7e4e34c2, 0xb9c262f7, 0x64a5c883, 0x0d2ff7c7, 0x3f6c77c9, 0x9e1f8ed1, 
	0xb67f5ced, 0xedc9847d, 0x2c7db4e5, 0x63ec73ba, 0x17ae9d10, 0xb2d723e0, 
	0x2f4d91c1, 0x71e06a61, 0x2007f044, 0x02fc94bf, 0xf810ff7a, 0x337dc14b, 
	0xe7b47057, 0x27bd1f5e, 0xcb9df3f5, 0xa4675d21, 0xf0bfa376, 0x7c7b4b25, 
	0xa35dfa05, 0x7962b79b, 0xbc80f9b7, 0xb67c6057, 0x0fefef0b, 0x0839d0b4, 
	0x79c36bdc, 0xd0f3333e, 0xdd0bb46c, 0xc2ecb28b, 0xb07b2c8a, 0x03ed1575, 
	0xf7e490bc, 0xe35ef1cc, 0x003e7911, 0xb3c3c1ed, 0xf660dc65, 0x44f6411c, 
	0x6cc0bcfa, 0xd5df2bd1, 0x0c1ec8b7, 0xe28b11bd, 0xf7a1067b, 0x7693eec0, 
	0x1bff07ac, 0xfda4ed1a, 0xb901d0d7, 0xf7c9517f, 0x20cf50f8, 0xfd79ce5e, 
	0x2fae0f70, 0xd636ff95, 0x4dfbef83, 0xc6f7932b, 0x7d1adf2b, 0x57f1ef19, 
	0xe0f50b1d, 0x0915a778, 0xdfd073f7, 0x7a443fb4, 0xff7a85ce, 0x079e5b35, 
	0xa15ff69d, 0xb390729e, 0xc2e19550, 0x5cd30e7b, 0xdf0fb3a6, 0xf15bf235, 
	0xc7e4a61d, 0xdb47bb1c, 0xd6fb7449, 0x2fa921b9, 0xf68ef90d, 0xa8d3ad65, 
	0xb257da1c, 0xf7b1bfdf, 0x11cfd765, 0xf2612e7c, 0x1fbb597d, 0x31533dfb, 
	0xffa20df6, 0x9fdf2889, 0xf9463f19, 0x7e49173b, 0x58c7f698, 0xbfb83f4e, 
	0x6e047149, 0x31cfeedf, 0x359e52c5, 0x85091f09, 0xed0543f6, 0x8cf685ff, 
	0xc3fdc49f, 0x4f874fd0, 0xa0edfed2, 0xfc41875c, 0xa5f51e65, 0xf1ba7a20, 
	0xa3284dbc, 0xbf725c87, 0xbec9b847, 0xdb370a89, 0xf19cae37, 0x25b2f6db, 
	0x75860fdf, 0xac21f685, 0xa55f2597, 0xb77c9a42, 0x7f1e43b4, 0xbda44571, 
	0x11d7853c, 0x8fc8ebf0, 0x33cebf03, 0x9e75fa5f, 0x4c638c66, 0x9043b889, 
	0x9eb0e6a6, 0x94ec05bc, 0xfd69f238, 0x3a7c099c, 0xe7b2ff99, 0xf3afc46b, 
	0x7de52bdf, 0x9d7e5cab, 0xabf24733, 0xce8fa7cd, 0xccbbc806, 0x433ba0af, 
	0x55fb92df, 0x7e863f36, 0x6cd7f724, 0xbf432f39, 0x19e24ca1, 0xbe86b5cf, 
	0x1b72743f, 0xdf9cb9e0, 0xcdc0c935, 0x9f00fd93, 0xd3d5f7c2, 0x39ee9ff0, 
	0x9ef78fd9, 0x24fb48e7, 0x6ff494f4, 0x6d8a38ec, 0xc0094ccf, 0x13ceb27c, 
	0x8a63dfd8, 0x62284df6, 0x0b73e49d, 0x71d57cb9, 0x5b6bf12f, 0xc76c05c7, 
	0xfe7e508f, 0xe359f0d2, 0xee17424a, 0xabe2caff, 0xa3968d29, 0x7e53f214, 
	0x3c415ab2, 0xf3f3333d, 0xbf7df073, 0x387ff809, 0xe5c9ff0f, 0x5b65ff84, 
	0x8bea9342, 0x9c79e5bf, 0x81f85f49, 0xbd607a6d, 0xf1213d0d, 0xec85f18f, 
	0xb0a95673, 0xcd89f646, 0xea532157, 0xfe5b4295, 0x0fe10e38, 0x05b8ae88, 
	0x50727bd3, 0x9c993f9d, 0x7c65c4b7, 0x9fd544e4, 0xc7e4dfe5, 0xddd69645, 
	0xc013fc4e, 0xf593dffe, 0x72f35d70, 0xb1fbdc1c, 0xb927d9c8, 0x9fb48e67, 
	0x8a1f33b7, 0xbdaa38fc, 0x55b9749f, 0xaefeb680, 0xd29f84cb, 0xfa3f4c4b, 
	0x352ebb8b, 0xd20b77e8, 0xafb59fe7, 0xb8c1dc50, 0xfb8f1665, 0xdd771487, 
	0xda94b47b, 0xb032ec7b, 0xc7fbe0b7, 0xc80a352e, 0xfb78e4df, 0x04989763, 
	0xdb6eb9bf, 0x91f7191c, 0x9ec5a2e7, 0xcb17dfdc, 0x1edd275f, 0x53e70465, 
	0x81285774, 0x7e16e1ef, 0xbc65edb5, 0xa6b85d8f, 0x4def07b5, 0x722bf3d8, 
	0x038e166a, 0xf5809849, 0xd0b77dd3, 0x9e1e604a, 0x095145bb, 0xf9fca38c, 
	0xe8628e3d, 0xed0bca67, 0xffd4316a, 0xc8a3e335, 0x07e64b09, 0xac635df2, 
	0xe22c3a17, 0x9d558e68, 0x44e51cb0, 0x4bee8347, 0xc0b9bf68, 0xc6df6ecc, 
	0xcedc6bef, 0x051c794f, 0xa30fc0dd, 0xb930df78, 0xfdcbf68f, 0xa07dfcaa, 
	0xef8a965d, 0xb0f7da59, 0xb847faed, 0x339636fe, 0xe1f0be75, 0x5faa7f3b, 
	0x507ea374, 0x3c6ef5bb, 0x31cfa157, 0x437c73e7, 0x749cfdc1, 0xb2ec15bc, 
	0xcfc03804, 0xe902fa5f, 0xba53282b, 0xf9e1fbe9, 0x33ddea2a, 0x4eae1fd8, 
	0xe577ce9d, 0xe7cf6b9f, 0x5dda170b, 0x12b50764, 0x4b757fdd, 0xf0fba493, 
	0x5c9ce98f, 0x673d71ed, 0xeee2855f, 0x3fce9107, 0x6f1d939f, 0xacc0fd77, 
	0xf9987bc7, 0x413c20e3, 0x1bc462bd, 0xe22ab1d8, 0x4efe3b69, 0x3bb271c7, 
	0x7fa355dc, 0xcc0f71da, 0x41fbe907, 0x81bb7d16, 0x5ef4a3be, 0x10c95173, 
	0xe04b63dd, 0x5977b6fd, 0xe658a7de, 0x78f41512, 0xe7a4a8c5, 0x27a031d4, 
	0xf5a71daa, 0x7df2f70f, 0xfe831c17, 0xceffdf9f, 0xd76c4ef6, 0x4533d958, 
	0x3e9c3be0, 0xa7b1777c, 0xbf1a6df5, 0xf180e90b, 0x9e83a467, 0x97a30f39, 
	0x5b8c6e88, 0xee4a5d23, 0x4fe5d0c8, 0xce3a7fdc, 0xb4f9f4cd, 0x27df7174, 
	0x73ca5f68, 0x7b42289f, 0x5cc87439, 0x37e34252, 0xd4fde296, 0xbc7b66e9, 
	0xaf15f216, 0xfeb8abb6, 0xc67ce316, 0xc629f333, 0xe6678cf9, 0xfc60fba3, 
	0xf0fd6fd8, 0x973dfc7c, 0x135cfc74, 0x2e582e34, 0x3cb0b8e4, 0xf63c7136, 
	0x449b8a3c, 0xbf8e5993, 0xe132f247, 0xb326f4a1, 0x0e77fb27, 0x1ee18d4a, 
	0x1b4a1f5c, 0xde41b86d, 0x0097e959, 0xf3f3440e, 0x69da533a, 0xf749b971, 
	0xed0b530c, 0x8a4df2f7, 0xfa24e233, 0x8669af50, 0x2903df1b, 0x8609db4a, 
	0x4552e31b, 0xf2d9bebc, 0xc4ae65b3, 0xa9a73377, 0xb73889cf, 0x9e10e48f, 
	0xef114c08, 0x163b7f89, 0x765df7a7, 0x09e30a43, 0x6577cab6, 0x3e124d52, 
	0x97bcae67, 0xc41bb765, 0x154fe07a, 0x1f7fa7f6, 0x0779c14a, 0xfd7be407, 
	0x5d6d59ae, 0xf5805fb8, 0x9c107566, 0xefa4f9fa, 0x0d7df023, 0x358413f4, 
	0x203ff719, 0xe58b8575, 0xc2ffb1f8, 0x289350fe, 0x1b2fd4cf, 0xdf8fadcc, 
	0xac353de1, 0xfb3bfb27, 0xf7c017f7, 0x85f7c1e7, 0x8ce5085f, 0xe024f52b, 
	0xa2784c29, 0xc0aba5b8, 0x645736ea, 0xc5f05df0, 0x5fac5e81, 0x7a21f0f0, 
	0x1313db9f, 0xa9357bf4, 0x1471c347, 0x7227c2c2, 0xc37429e7, 0xb82cef89, 
	0x70556e1e, 0xb59a10fd, 0xf0cbfc94, 0xbb9d3748, 0x8c6eadd5, 0xe51aba13, 
	0xa7d2d37d, 0xbefb3c44, 0x3c876dbe, 0x8fbe573a, 0xf821fc59, 0x9d21476b, 
	0xbbe0f46f, 0xc61fc527, 0x7b473c55, 0x85d86e7c, 0x3e4a99f7, 0x83657be4, 
	0xd5190ba6, 0x507a265f, 0x884f834e, 0xa39f5b1e, 0xa33e0efa, 0x0cfea0f7, 
	0x1a34e2ee, 0x956f6813, 0xecf1172e, 0xd7a57773, 0x3617c46b, 0xa6a3cbfd, 
	0xcafe8512, 0xef829663, 0x657f530d, 0xbe187f5c, 0xe3c440bf, 0xd64f1e61, 
	0xd07763f9, 0x76dea388, 0xb3c4613d, 0xa67ae1c7, 0xc4f087b5, 0xb6597bbf, 
	0xfd3750eb, 0xda04648e, 0x20cb92cb, 0x06ba1bf4, 0xa250cff9, 0x6ac55920, 
	0xf7e0ec84, 0xc61fd21c, 0x1eefe5ef, 0xb6dafb48, 0xbdee903f, 0xa39e2747, 
	0xbc73c52d, 0xc40f37e8, 0xfe5579e4, 0x797c86fd, 0x3ac5b54e, 0x2463e3b3, 
	0x750778cf, 0xd90f70ef, 0x3fb22def, 0xffea6794, 0xf4a76c90, 0xdfe72e26, 
	0x7aff2089, 0xb8f9ca1d, 0x68eff384, 0x93d07580, 0xe46407ed, 0x126ff81a, 
	0x1cdc293e, 0x9b6be1c9, 0xc85f5c5f, 0xef6877e5, 0x4fe6d325, 0xe16a3b8c, 
	0x4ccd8fae, 0xc7cd231c, 0x45ef0eb3, 0xae62be79, 0xd59effbc, 0xa5fbf93f, 
	0xaf9007a0, 0xbf83e78b, 0xc78e037f, 0xbd41b654, 0xd72b9a7f, 0x5aaeb767, 
	0x2e577c0e, 0xe285bb12, 0x94ff8c13, 0x7c6cf421, 0xcb902cbb, 0x3a57e276, 
	0x24fa53e7, 0xf30897e8, 0x7c24c973, 0x23e490f7, 0xcdb3f337, 0x0a3f36df, 
	0x7255ffbe, 0x785abe26, 0x0fbf4e28, 0xfc04fc85, 0xcac30a5d, 0xcd3b977e, 
	0xc44fc057, 0x93cfc057, 0xa23e15f2, 0xe489f488, 0xb2c615f2, 0x4f9bddf1, 
	0xc7c62be4, 0xb2be6fff, 0x5c06eff1, 0xe9293ef5, 0xddf3e789, 0xa8e5a749, 
	0xb17e849b, 0x0b3dfa5c, 0x51b8c6f4, 0xc7406e86, 0x897e99ab, 0x7d7f9c8c, 
	0x332ce37c, 0x76fececb, 0xea5bcc23, 0xbce26fc3, 0x91b2dd9f, 0x11ab39d7, 
	0xd43679fb, 0xebf7c3d3, 0x67daf9e9, 0xe6e5d8d7, 0xf75f2a02, 0xa5ea0f62, 
	0xb65f5b67, 0xf7aa55d7, 0xf967be4d, 0x71bb3ccd, 0xe5f25446, 0x7b7f4e0a, 
	0xf80f7c9e, 0x37c60577, 0x5a98e8f7, 0x9493da7f, 0xf2841b78, 0x629d6f67, 
	0xdf1a6beb, 0xcd94d6ef, 0x16f97e42, 0x3f78bfd8, 0x9000fff8, 0x00891984, 
	0x00033e91, 0x7de59c78, 0xe554780b, 0x6677ff99, 0x49325cce, 0x640b9326, 
	0x22190242, 0x465170e2, 0x00843008, 0xb82b1207, 0xad5a9b6e, 0xc4eda52c, 
	0x7696a54b, 0x880d45a3, 0x36e4cce5, 0x24141d78, 0xad0edc58, 0x1b6d54ae, 
	0x2ec5ddac, 0x05a403d6, 0xe3cbb76b, 0xfdada152, 0xb410406f, 0xdd752db3, 
	0xfbaa5e36, 0x6e6fbe5e, 0xfeda8849, 0xfcffe7d9, 0xe5f03cf3, 0x977ce73b, 
	0xdf7bf6f7, 0x73befdef, 0xe56a7272, 0x426dbe13, 0xdd3f0fbc, 0xf278841b, 
	0x8bfc5f9a, 0x6eeffa80, 0x189a7abf, 0xcd63f010, 0xf10a3733, 0xad31b71d, 
	0x37aa06f3, 0x29543d52, 0x710bd76c, 0xdd17e7ca, 0x75788513, 0xf84fd5e6, 
	0xadca5da1, 0x169f9bb7, 0xf09a63f4, 0x98bf8ddc, 0x7f418e26, 0x3de8c6ab, 
	0x577c42ad, 0xde269aac, 0x1b0de212, 0x55afffdf, 0x237dd10e, 0x6a2f0bb4, 
	0x77aed817, 0xe780dc11, 0xe6e98aa6, 0xc5f44283, 0xf842792f, 0x02fb7ee0, 
	0xf5faafbe, 0x5a25db3f, 0x0174b2a0, 0x1b9dff3d, 0x8712eb9f, 0x445a1ea0, 
	0xcd677ccf, 0xdde15d73, 0xfcf86842, 0x2bdfa81a, 0xc05f2fef, 0xccfe5bf7, 
	0x7feb8375, 0xa27b1af0, 0x45a72a11, 0xb395bfb1, 0x108c7d85, 0xd31090f6, 
	0xcff5c0ce, 0x5becb02f, 0x35bf41e0, 0x5055dbf5, 0x3ba9ac06, 0xf07ef8aa, 
	0xfc7fffcc, 0x5accfdfa, 0xebf157a2, 0x62b0bb49, 0x0a3e4bd7, 0x4293bfc9, 
	0x2afd449c, 0x8a5faa18, 0x22be696f, 0x27de813f, 0x9ecb773e, 0xfef8cb29, 
	0x07f83694, 0xf6e368a5, 0xc17da15b, 0xbccb8f60, 0x04dfd33f, 0xd12c7ba4, 
	0x421223dd, 0xecd57f8c, 0x5445bdb2, 0xf8fff8eb, 0x1d0baab0, 0x2fbf1ee9, 
	0xf541df7d, 0x8b5f50c3, 0xf549c375, 0xdbeea5b8, 0x3ce38eb1, 0x1594e306, 
	0x6bebcf25, 0x8f54a216, 0x822894bc, 0x26a0457a, 0x9ab2f50e, 0x42371fc8, 
	0xcf9f5c7d, 0xef04bc13, 0x31ddcf0b, 0x5643ffe0, 0x3431fb8c, 0x29ea1bbd, 
	0x2c71e511, 0xfa9ffe3b, 0x266a386e, 0xcb997ca1, 0xc5384b72, 0xd3af5026, 
	0x50c6d842, 0xdd400ce9, 0x9f003e44, 0xa6f9d66a, 0x86af960b, 0x851ff5f2, 
	0x8ebf80e7, 0x511efe69, 0x6b4dcfc0, 0x514eeba3, 0xebf3fa3a, 0xa0f3f9e0, 
	0xb84eff5f, 0x674a85be, 0xe4aef400, 0x00d1e5f6, 0x3d2fbfdc, 0x20ba7fae, 
	0x8ed8fefe, 0x04b18cfd, 0xedc971e9, 0x573e0fdc, 0x71edc6dd, 0xd55335fe, 
	0xbf3fc3b8, 0x059f9e11, 0x7280dfcf, 0x7743237d, 0xa88177ea, 0x5df86648, 
	0x44cfbaf3, 0xa9b7083e, 0xfde1bda3, 0x1fd00129, 0xd2c81768, 0xe520f187, 
	0xe0bfe80e, 0x8d15c35d, 0xf8f5be91, 0xfc4e8f40, 0x4b12e23e, 0x8c633e41, 
	0xf4f4131e, 0x134369e4, 0xbdff28fd, 0x60e4021d, 0xd0066413, 0x7a2db16e, 
	0x6a5f5c0d, 0xac016d7a, 0xa7c07f43, 0x7a5bd792, 0xe17a1f48, 0x7232b7d9, 
	0xb473f353, 0x71ff765b, 0x3d2d7b28, 0xe3e8cb14, 0x20b0def8, 0xd30f6b3b, 
	0x33f44300, 0xd0ed9bbc, 0x8e52930c, 0x7deb27df, 0x37787eb2, 0xae41d9db, 
	0xff1c7b2b, 0xc12e7caa, 0x0f8f8efd, 0x9f8dbd72, 0x7e342aab, 0xeca84662, 
	0x7cd64531, 0x01eb4c5e, 0x7af55f8d, 0x0383e90b, 0xf20b75ed, 0x3668eaeb, 
	0xb6a63bfe, 0x8e7da374, 0xc5c5a17b, 0x4c386678, 0xb778db90, 0x333c62e1, 
	0xe367886c, 0x4fa47cfb, 0x76cf1063, 0xa9f63108, 0xd57f1e96, 0xff1b3c50, 
	0x539d83bb, 0x88261001, 0x1c6cae55, 0xef3d002b, 0xdf9e1d7e, 0x2f176e19, 
	0x5d312e21, 0x97595ea9, 0xff15cfed, 0x01c44a6a, 0x129affc4, 0xbfbc23d0, 
	0x97102c39, 0xaffc4bf6, 0x32643079, 0x6e3e83fe, 0xf532bc43, 0x3ef8db1d, 
	0xe2b9d8e2, 0x9bb461d7, 0xadf3a335, 0x1ae5a9ea, 0xe3d147ce, 0x744cf890, 
	0xf5df490a, 0x4305fe52, 0x4ae8afe5, 0x02f48dd3, 0x0d6d943e, 0x3cf2981f, 
	0x7e7c47df, 0xda33e24d, 0xda55b469, 0x7f6912e1, 0xb3fb6cfe, 0x39780174, 
	0x9a2329fe, 0x77647f6d, 0x350ec8ab, 0xb28743b4, 0x76b99dbb, 0x1cbb40e7, 
	0x72fbb193, 0xbe783fb4, 0x08e1a77c, 0x901718d9, 0xdfbd692f, 0xd0876b99, 
	0x35c70d8f, 0x1e502340, 0x8ed1b822, 0x31b2e775, 0xedc7175c, 0xf3cdefc8, 
	0x342eb26c, 0x8cf5e813, 0x31e76e13, 0x0036a392, 0xfe74d4ca, 0x7fc58bd4, 
	0xb19284e3, 0xcfafd8a9, 0x3673e18a, 0xf009a59f, 0x233aa95b, 0x7b524d1a, 
	0xf289ffc7, 0xccaad1b8, 0xe822f4bc, 0x0f4fec17, 0x63f4369b, 0xd990981e, 
	0xd749ce8b, 0x3d6fd04c, 0x4aceb424, 0x0744cb28, 0x2fa9573e, 0x7f8147b1, 
	0x51f4df45, 0xf8337a6f, 0xa84ff611, 0x723c69da, 0xe031efc3, 0x42c5d34f, 
	0xdc3c8214, 0xb5dde006, 0x8c117bf0, 0x5571096f, 0xe2c5f168, 0xba6fe816, 
	0x38bd4361, 0x11180331, 0x100cfe87, 0xfb4ce6c5, 0x1cbed0f9, 0x70433bda, 
	0xdfc715bd, 0x95f6c0eb, 0x0f1403ab, 0x2385b855, 0xc30af30e, 0x1fa0a573, 
	0x876e0115, 0x1893c774, 0x0f511897, 0x0f6839f9, 0xe787a9fc, 0xa15fd07c, 
	0x4d4bf2ce, 0x96b8bf05, 0xf17e8fe7, 0x0da7ec5a, 0x3ad862f9, 0x1e7d6fc0, 
	0xbafd0fe7, 0x4a7082c3, 0xe09d020f, 0xf621dc1f, 0x4b907a53, 0xe1ebcfc5, 
	0x971b60f9, 0x0a97686e, 0xb8c26f85, 0xdb1560e7, 0x7c2c2a41, 0x0a95f6d9, 
	0xd04d47b4, 0x4665d4ad, 0x52be84d4, 0xc68f2c57, 0x8534eeb0, 0x5cfc1ff9, 
	0x14fbfc27, 0x49fe87f4, 0x2fc90618, 0x2fbf4065, 0xce2fdc8d, 0x4209bc5b, 
	0x644b0547, 0xd191738d, 0xbd300d11, 0xf6e3f22f, 0x16de3668, 0x8e0fa419, 
	0x7d4761b0, 0xa1b90628, 0x3344383e, 0x642383e9, 0xea383e90, 0x1bd231a2, 
	0x9c4366dd, 0x896cccf2, 0x2b1d7f22, 0x4d015c55, 0x50a1f4b2, 0xea4bb3ca, 
	0xd672e143, 0x1822a287, 0x83a1f49f, 0x7d4758f4, 0x583ea088, 0xe5ae0fa4, 
	0x6a83e916, 0x03ea077f, 0x916939ca, 0xa6bae83e, 0x39bd7b61, 0x74e8f840, 
	0xc3ea1a9b, 0x4e0fa93a, 0x77400fa5, 0xd54f7e1c, 0xb79e1d1b, 0xab70fa32, 
	0xd42287d4, 0x07282d87, 0xd3420fa5, 0x2a3c429d, 0x7601c1f5, 0x43b0fa82, 
	0x81f033e9, 0x8b52d6fc, 0x71cc21f5, 0x97296392, 0x5d8f9f8a, 0xa585b8cc, 
	0xc4e50dbb, 0x31d77372, 0x3c8ca40c, 0xdede987d, 0xd9307a41, 0x7d7920e8, 
	0x2c477965, 0xb61f5438, 0x6841f5a4, 0x0fa53f28, 0xf38bf523, 0x302a3c46, 
	0x71e9de78, 0x11eb9ba6, 0xe6f5521f, 0xd3f9137a, 0x618fae6c, 0x5eb930b9, 
	0x0be2b204, 0xec4e103d, 0x22d87903, 0x8455df37, 0xe38648fc, 0x2a38bf10, 
	0xdd777d22, 0x688d650d, 0x469dbfbf, 0x80bde5fb, 0xcae9ceb3, 0x5145764f, 
	0xab419cff, 0xa74be28b, 0x21fc9eb9, 0x80fd1c4c, 0xe4874fc2, 0xb26173bf, 
	0xb2f3012b, 0xfa4e38cf, 0xe79bba90, 0x348e6ee5, 0x71e7406b, 0x986da3a4, 
	0x5d9a17fe, 0x30675f38, 0x94db3f1d, 0xaeff61fe, 0xb1dfee22, 0xa5fcd0d4, 
	0x67c5cfdc, 0x247c3ed0, 0x8665f72f, 0x2cfd8fcd, 0x3185dddd, 0xfdc3bfe8, 
	0x78cc99d0, 0x37c0a9ee, 0xe7127768, 0xaa95b805, 0x41df5ae9, 0xdf1f81e3, 
	0xaaee7999, 0x55f6fc10, 0x49b97fb8, 0xb475d5f7, 0xf98ab337, 0xf8664b1c, 
	0xcbe0f80a, 0x1d2993f6, 0xfcc2d3f8, 0xefd63921, 0xd38391ce, 0x63d9f52d, 
	0xcf93efae, 0xf7a883e1, 0x5f1ca5bd, 0xed919df4, 0xece67f50, 0xf5e1fe26, 
	0xa47f2c8e, 0x853dc970, 0x1a2e75c7, 0x62a00d2c, 0x14b4bc3d, 0xb2f1c7fd, 
	0x1ff409ad, 0xeeb6ea27, 0xc7ef3017, 0xb179bca7, 0xc236fd0e, 0x28f904aa, 
	0xd932de76, 0x7a947607, 0xf8c0aa67, 0x4b5b0002, 0x96de7c80, 0x29f3f7b8, 
	0xe01fdbf0, 0x0f5685fa, 0x5f6d47e2, 0xcc061438, 0x0f696dac, 0xeed41ea1, 
	0xb847f593, 0xb8f12b1c, 0xf75c63f6, 0x02572d84, 0x87eb51e4, 0x3526f012, 
	0x01f51ed8, 0xc21d633d, 0xf00ae7c0, 0xb7e8847e, 0xe7ca3627, 0xf33c414e, 
	0x1f0ef2c4, 0xd93303d4, 0x408fc8de, 0xfc7a939c, 0x1e013ee8, 0x7b6ef52b, 
	0x7ce20887, 0x18fc572d, 0xe5cb25fa, 0xdfc1f883, 0x30d0e91f, 0x7c41f05e, 
	0x4fc42974, 0x0a5ed933, 0x21630707, 0xa0ed4fe0, 0xa438c369, 0xad4f8570, 
	0x77a85c3f, 0xc02388b5, 0x94548407, 0x68e9bb97, 0x1ecbd70c, 0xc053f837, 
	0x83c48f02, 0x68e195d4, 0x9cb5e500, 0x17d4bbe3, 0xb0768ea0, 0x3315eb8a, 
	0x458c6fd9, 0x63f3c2fe, 0xc8eac25d, 0x332991c2, 0x5954a719, 0xfbc5ed29, 
	0xee33ff55, 0xc0fd196d, 0xff80bb9f, 0x0c86cf95, 0x3e56ef5c, 0xd703b3bb, 
	0x9ecf9539, 0xc2caaaee, 0xfb67caf9, 0x441b8e76, 0x84bd00bd, 0x7af4de36, 
	0x883dc7fd, 0xd34bb50f, 0x778a54eb, 0x5dcc5f6a, 0xa9bed6c7, 0x5272ccec, 
	0x9d74d5fd, 0x5e955f9f, 0xe1d8e6b7, 0x59726758, 0x12b1e21c, 0xbbbf123d, 
	0xfe34e908, 0xea97be26, 0x29130122, 0x8df619b3, 0x48be9007, 0x9078236c, 
	0x91f32292, 0x8e5718a7, 0x3e436c75, 0x95b3365b, 0xb904d9f1, 0x1433c489, 
	0x35f1bd37, 0xab49c72f, 0x29b8a25e, 0xf54d583c, 0x551ca46b, 0xd1f144bc, 
	0x75cfea36, 0xfb21e386, 0x256e309b, 0xa67afbf2, 0xd32de397, 0xfcf28a99, 
	0x83aabc71, 0x5e302780, 0xdd49a3c5, 0xf4c7d70d, 0xe10b5d27, 0xbfd942ee, 
	0x1d43d9ff, 0xafb9a873, 0xd72ade27, 0x9986cb7d, 0x9a4efc6f, 0x117161ef, 
	0xf3c7d7cf, 0x0352f8ad, 0x3cfe51db, 0x68bed603, 0x74d7dc56, 0xb3330dfe, 
	0xf38a3de3, 0xb6bd3ec0, 0x83e22ed3, 0x2e81cf8c, 0xc686253d, 0xef18e5f3, 
	0x435ea2b7, 0x2b333efc, 0x597a974e, 0x137af3ac, 0x851ec3ec, 0xa112a5f9, 
	0x7b565b76, 0xce135f98, 0xc4feeca7, 0xa547e401, 0xbd12ef5c, 0x995e511b, 
	0xecf518b8, 0x078c9981, 0x3c64cff7, 0xdf7bfd55, 0x7c7d68b5, 0x1701fde2, 
	0x4cef7bfa, 0x7ee417a0, 0xcf421072, 0x2d6e90eb, 0xf87e4096, 0x59f90c44, 
	0x04700632, 0x9bf6a96c, 0x4bf20f56, 0x2bb5ebc5, 0xcc3ad10e, 0xeb46aefb, 
	0x5025dae6, 0x74f1ebc7, 0xde7e4ebc, 0x8bdb2efd, 0xc41f43d2, 0xfbaf1815, 
	0xf18e86e2, 0x6d6f9aba, 0x92e9c65c, 0xe81fa81f, 0x87da875f, 0x3845bf5c, 
	0x317daf9e, 0xfb573d77, 0x1df75ca6, 0x6557f595, 0xb5ffc65d, 0xaf7ae4ab, 
	0x8f5eeb85, 0x95f181d9, 0xee6787f7, 0x9765999a, 0x25f95e6a, 0xcaa8bdda, 
	0x8c0efbb5, 0x4bd11eab, 0x1fd69e30, 0x66218bd1, 0x75bd7a16, 0x69f81f55, 
	0xf588f2fd, 0x2718ddf0, 0x9c7c3f59, 0x0f6d69ed, 0xb0d7a5d0, 0xc46584bc, 
	0x0fdfd092, 0xcf134e40, 0xf880bad0, 0x2c469225, 0xe4c5f981, 0x1b7c58e2, 
	0x29fc47df, 0x5c927d78, 0x217577c7, 0x5ca50a3f, 0x9d146e1f, 0x6c7ef026, 
	0x7285d12c, 0x657c7b1d, 0xf0f68e17, 0x7cba5af7, 0x4edf5803, 0x3e24e7f5, 
	0xf0cffc3f, 0x215dd01c, 0xb7e8ffd7, 0x7f78c137, 0xd771c99c, 0x771049e6, 
	0x1aba1c41, 0xfd0cb2cb, 0x38f385ff, 0x683d2993, 0x29eeb867, 0x6fd0c44b, 
	0x97089cc1, 0x9fecb791, 0xcb7af396, 0x001eb9d0, 0xd0fd233d, 0xbac9dd95, 
	0x795b7546, 0xf1c43eef, 0xc8658c42, 0xed1d4d7e, 0x879dc1f8, 0x05780174, 
	0xf36a8fcb, 0x9f0fb001, 0x897ced11, 0x5e5b3175, 0x985c5f29, 0xbf85c357, 
	0x999615eb, 0x3c05efe5, 0xbfa969ff, 0x44df6fe0, 0xe719b8fc, 0x7ebd71c7, 
	0x644794a5, 0x05df9a49, 0x52958f28, 0x64c5811e, 0x80a4fa0f, 0xf10b7e86, 
	0x439f2122, 0xfbff0a7e, 0x5aab2784, 0xff47445d, 0x14cc3f94, 0xbaf10937, 
	0x5be4c1c2, 0x634eff74, 0x1a575c91, 0xdb9321da, 0xe2c43cd3, 0x5d955998, 
	0xc25e2437, 0x00aca0fc, 0xed39426b, 0x7ca30b74, 0x8bdb10b5, 0x249f1fc1, 
	0x7f51893b, 0xfd0c66bd, 0x633418aa, 0x7233e789, 0x0138902d, 0x104b12b8, 
	0x137d09ee, 0xd6d631d0, 0x8bd895d9, 0x46fa16f3, 0xcacec3cc, 0xfdd19f5d, 
	0x289f8c4d, 0xd2d6613f, 0x442b3dbc, 0xf7a1e50c, 0xad7f28f9, 0x7c374ff4, 
	0xe303b6ba, 0xf28070e7, 0xa91bbbcd, 0xb6dd23f1, 0x0e3a6f6f, 0x9aeb6db8, 
	0xca2aea06, 0x26bf3166, 0x24eb8943, 0x05f31fec, 0x09cbf8bd, 0x6d3e8128, 
	0x96f79cb5, 0x41087b4c, 0x8493e592, 0x61b9b6f8, 0xef3fc62a, 0x047c0fbd, 
	0xfb209b1c, 0xec44b47b, 0xfb2e38ed, 0x3fd59499, 0xef4847c4, 0xe94140a3, 
	0xd21e3c75, 0x7ec79eab, 0xbf708fed, 0x17eaa748, 0xebb421e6, 0xd97abb64, 
	0x6fec98ee, 0x20cf4a19, 0x05ebd2ff, 0xca8ebe8d, 0x5ae00768, 0x16e6eec1, 
	0x48d4127b, 0x60bf7413, 0x81731eb7, 0xfc14023d, 0xf79069e3, 0x9bf3e41c, 
	0xe7268f8c, 0xcb133a13, 0x31fdef50, 0x277a738c, 0x77603f43, 0xa1bdbe8f, 
	0x22f4e913, 0x8f3e61eb, 0xd3a1b3bc, 0xe357559d, 0x7b1ea079, 0xef89fb14, 
	0xe50afec3, 0x45d1c5bc, 0x09f16442, 0x7ce3f3c6, 0x8b48b03c, 0x6dddb2b5, 
	0xbe8972a2, 0x2059f591, 0x5bb43efd, 0x68b5f390, 0xfd68c77f, 0x469ed217, 
	0xdb9f9abd, 0x0734025f, 0x4d9776ed, 0xdb1fb1d9, 0xabce4c87, 0x616e7ca4, 
	0xb7cb811e, 0x1416121e, 0x5ce75685, 0xb5fa806d, 0x2e6d1f10, 0x53709fd3, 
	0xa94789bb, 0x700e26b4, 0xd734eebd, 0xa5be70eb, 0x1a632777, 0x8cef4fcc, 
	0xf41ed898, 0x08ff42d7, 0x7da16cfa, 0xee03888c, 0x71be344d, 0xb07121d3, 
	0xceffe643, 0x5781c50c, 0x228dcc26, 0x3180f5df, 0xc19933a3, 0x935f580b, 
	0x4dfaf9fe, 0xf5c60fad, 0x0fad0975, 0x3cefa0fc, 0x85ca85a1, 0xd1c812f8, 
	0x0e7686df, 0x44bac1bf, 0xec8f7a1c, 0x4c9f8dfb, 0x7f31fa25, 0x38901e23, 
	0x8de90d7a, 0x5564f983, 0xd8829d93, 0xf5d3cfe2, 0xf4e80258, 0x17540e75, 
	0xcce77d40, 0xd5bfa95b, 0x7f1d513e, 0x37bf8845, 0x004f3183, 0xfd1c77ee, 
	0x739e1bb5, 0x18fdf12f, 0x1d3e7ffd, 0x9f6e2b6d, 0xc71feb85, 0xae3f5f54, 
	0x9c9fb7cf, 0xae4829de, 0x5666fbd6, 0x04e529de, 0x5c3cfc7c, 0xfa2582fd, 
	0x3a2f1c4d, 0xcd17fc4b, 0xa4eb41c7, 0x5a9f7ebc, 0x42fd45d1, 0x8cef147f, 
	0x0aeadfd6, 0xeaec17a0, 0x12202578, 0xb8c8a3f8, 0x3e62d767, 0x7bacc37f, 
	0xbae29566, 0x8c6c2224, 0xc1feb927, 0x23d28432, 0x31aed38a, 0x4dc10f58, 
	0x746ed144, 0x1869cf19, 0x6e8f3e27, 0x7c73b4c4, 0xb04dd967, 0xef12ed9f, 
	0xbf011708, 0x08fc4bb6, 0xc838e6cf, 0x95fd9b37, 0xd15f952a, 0xe5bbb3af, 
	0x887e9d7e, 0x71c34ee2, 0x60c10614, 0xa9714626, 0xea7920e5, 0x6bd5f1b9, 
	0xbf9fb8b3, 0x33f8cd9d, 0x4ff52076, 0x83659fa8, 0x6b834225, 0x751b735d, 
	0xeedbfa1d, 0x8fde764e, 0x7b661ffa, 0x3c4036f2, 0x6af30bb9, 0xd919aebc, 
	0x8fd8258f, 0x53fe3845, 0xfee10174, 0x169fd43e, 0x965defe1, 0x4e613bb1, 
	0x0245fe20, 0x45e63f41, 0x6a231e22, 0x06b70d82, 0x08bf9701, 0xe7e779fd, 
	0x9cbe72e0, 0x00899e15, 0x4d7ea3b4, 0x2ce5e3f6, 0xb73db497, 0x10ea34c9, 
	0x6784117c, 0x47f0b17a, 0xbfb64ec1, 0x794632b2, 0x716362a2, 0x4ee020f4, 
	0x1d88b95b, 0x1a187893, 0x60a9278a, 0xfab2d848, 0xd4f32edf, 0x8dadc41e, 
	0x7da11f12, 0x6188a564, 0xc79329de, 0x5cda7955, 0xf206f9fc, 0x31e255b9, 
	0xfcb2978c, 0xf0a07839, 0x76081dcd, 0x78328577, 0xfee2ec66, 0xfb77736c, 
	0xc2ae50c3, 0xd92b407c, 0xbe2515a9, 0xdd50ee00, 0xa9b887dc, 0x84e51ff4, 
	0xc71d78cb, 0xf7eb7e05, 0xf3271fee, 0xc8ba3559, 0xedc423ca, 0xeb6fff94, 
	0xa0d756bc, 0x7cd4b6ff, 0xb92aa7ca, 0xfd9b355f, 0xacf5a3f0, 0xa67b6d5f, 
	0xadbe7e51, 0xf544ac58, 0x677defd4, 0x1efb4e9c, 0x83f3a9f3, 0xeb6f9cf5, 
	0x1b7eea0c, 0xb13f41cc, 0x5e03abdf, 0x82641374, 0x17b1ef51, 0xa1d922e1, 
	0xd13b7c0f, 0xe467718c, 0x0b154f9b, 0xd793e5f1, 0xf8c3ee3e, 0xc7f23eb4, 
	0xefa03df8, 0x64f0bc4f, 0xc3bfdc19, 0x04a4cd71, 0x74868fdc, 0x55e28e31, 
	0x2fbac1fe, 0x75066eab, 0x80f59211, 0x06f6ed89, 0xfc73b6b7, 0x86fa811c, 
	0xb07b731e, 0x24c8cb19, 0x35fff41f, 0x77517ed7, 0xde8b9f00, 0x30c15773, 
	0xde7d85f7, 0xf1a1f6b4, 0xb162faf7, 0xea21fd18, 0xafedfa3d, 0x6d05bd01, 
	0x316d8fd8, 0x415da5c6, 0x1c81f75d, 0x3acd43bb, 0xfed0fbae, 0x63bf812a, 
	0xfd0fa2dd, 0xb67ac4f6, 0x1e3127ff, 0xfcea8358, 0xb7a39ebe, 0xe318b16e, 
	0x6cafed8f, 0xef5214ef, 0xf6521709, 0x01709322, 0x09c24de2, 0xbbd033c0, 
	0x6a22dbc8, 0xa6479e02, 0x32b89d82, 0x1713b3f9, 0xe06e6c24, 0x59bf8777, 
	0x633f4377, 0xc6faec06, 0xe4a7cf08, 0x595c4207, 0xc3bd72cf, 0x7c462da1, 
	0x6a8c31ec, 0x668a6f6c, 0xea3d710d, 0xd9bbf7ee, 0xf904b59e, 0x718fcb07, 
	0xbb21d75c, 0x9db57286, 0x04dd7d67, 0x6a3eea50, 0xd79875d7, 0x79c27858, 
	0x35c1e53e, 0x51ea2b5b, 0xcbf9c913, 0x07845780, 0x16b9da36, 0xbf7eff3e, 
	0xb655fd0e, 0xdae25f97, 0xa111f981, 0xfb621da3, 0xab3dc428, 0xa84ebc61, 
	0x35166db7, 0x09bad788, 0xbbf30076, 0x021c2836, 0xf70953f8, 0x4f845f91, 
	0xfb127476, 0x6a15e21d, 0xa127466f, 0xb469369d, 0x176d38de, 0xd1dfe84e, 
	0x58cbfbc2, 0xf286068f, 0x2403e63b, 0x6073f8c5, 0xf2f10c7f, 0x3f8be055, 
	0xad7a3e4b, 0x1d1151dd, 0x1713972a, 0xa285aaf8, 0x8f8664fb, 0xca0f8e8a, 
	0x2cf7c547, 0x8a1d123e, 0x23cf8a8f, 0x39f151f1, 0xb74947cd, 0x33e2a3e2, 
	0x05f253f1, 0xe3466df7, 0x3e0bea2b, 0x9ae2fa87, 0xa86f943d, 0x8a7f8857, 
	0x248f8a6f, 0x8729268f, 0x2bff2504, 0x7a483fbe, 0x43cf717c, 0xcaa7fd30, 
	0xeca0e729, 0x9f01844a, 0xf53ae4ab, 0x186bf4b4, 0x3436afbf, 0x0f5c1fda, 
	0x5794fde5, 0xbfa00f16, 0x2eff3531, 0xea07bbb0, 0x57ab6f39, 0xbae3beb0, 
	0xcdb7ef08, 0x48817de6, 0xf53f5cb3, 0x558dfe69, 0xa9da3cfc, 0x366abeba, 
	0xae47f7ef, 0x84a9eb94, 0x7e9cf646, 0xdf6ca56e, 0x32bfedcb, 0xbb43ae5b, 
	0xc7a2d12e, 0x986974b1, 0x353bd0b7, 0x0eed0e7a, 0xcd9a6fc7, 0xa77a44fb, 
	0xf447ae8d, 0xe052f4f3, 0x6a2796cb, 0x69d7b3fa, 0xd00e324d, 0x59e73b75, 
	0x7141dd70, 0xd9f5c424, 0x029372fb, 0x3fd41acd, 0xf55beb3b, 0xbc437eb8, 
	0xf83f7ca1, 0x9bf7ca5b, 0xaf8819e1, 0x75f7dbfa, 0x9427f3aa, 0xc07d00d7, 
	0xdfdd023c, 0xb9d6b229, 0xbe27f27e, 0xb1c3f484, 0x3bce99b0, 0x8ea56e83, 
	0x37994ddb, 0xa84e15af, 0xce7501bf, 0x8822d49f, 0xbaba6ca7, 0x65fba01f, 
	0xc01fbaba, 0x9cf477fb, 0xb8ffa167, 0x8fef3674, 0x5f71bb9c, 0xeb2164f9, 
	0x0f5df3d9, 0xcf0effa1, 0x94be24e8, 0x3ce3cd44, 0xbd3f1c0f, 0x6836e0cf, 
	0xdb9e8b1f, 0x38c172c9, 0x9c8101d2, 0xf58604f3, 0xe026e282, 0xa8a5a5a3, 
	0xa075c01c, 0x7ff3002f, 0x41fe6b2d, 0x4dfdcfb9, 0x3c635f35, 0x4529f7cd, 
	0xe69e358f, 0x7f7d2fbb, 0x317fdd02, 0xde027f7d, 0x452ef257, 0x0b263aff, 
	0x88de602f, 0x58b38317, 0xe50dff2f, 0x07a596df, 0x227ed9cb, 0x1b352b03, 
	0xc1cc1a4c, 0x947989d1, 0xcdf29d88, 0x841c24aa, 0xbcf577f2, 0xfe91684e, 
	0x1b50cb1c, 0xebed0be1, 0xd8f17c2b, 0xfb40e81e, 0x98fc45ae, 0x576df948, 
	0xfdc03e36, 0x10f9c14e, 0x5bd5f217, 0xd7dfc827, 0xa25dfb98, 0xc2eac483, 
	0xe2026bf8, 0x0161c611, 0xc7590280, 0x816bc27d, 0x44039dbd, 0xc1afb527, 
	0xb15c4279, 0x512dabfd, 0x18811c5a, 0xc0df0e28, 0xc404def1, 0x1e376819, 
	0xed842971, 0xf093c70d, 0x47682ddc, 0xdab1d380, 0x8d24e746, 0x71f809ce, 
	0x7611105d, 0xc54fce17, 0x88a4fab9, 0xdbfaf30b, 0x16e89abf, 0x9ef8858b, 
	0x341077c4, 0xc1c53ae1, 0xf07132c7, 0xfe4981f6, 0x73762032, 0x5c6cc54b, 
	0xb0bf6cff, 0x50413fc4, 0x57fa883e, 0xb802367e, 0x2b701635, 0xe1d61ab2, 
	0xe5a7f7c0, 0xf3223ffa, 0xb07afa1c, 0xd7e71b6b, 0xc192d81e, 0xef3069af, 
	0x0ab9f18b, 0x1bc419c6, 0xb3cfffbc, 0x91db9f79, 0x3cf85f87, 0xf5d47fe6, 
	0x1abd41ef, 0xbf12f5eb, 0xd73de60e, 0xe4efdb28, 0x80f83feb, 0x3c9df5f8, 
	0x47d74afc, 0xcecfa9c0, 0x7fcd1582, 0x4e77fcc3, 0xfa6e51d7, 0xdaf7cb79, 
	0x21df0cb4, 0x9eda4b74, 0xfae57c96, 0x0897da00, 0xbfda311a, 0x0deb80fe, 
	0x7980abe4, 0xe59eb37c, 0xf4077116, 0x56ed2698, 0x65fa2be2, 0x655b638a, 
	0x8d0d6a7c, 0x7d7e214f, 0xb138c3cf, 0x8ca1fbb8, 0xd27ac11d, 0xb69b388f, 
	0x6be320ab, 0xabca1eba, 0xed6fd21b, 0x6f5136ab, 0x17cf4edb, 0xed3780dd, 
	0xc5133ffb, 0x22b6eff8, 0xc19cfe39, 0x8ed1f19c, 0xdd1df711, 0x0dc78c96, 
	0x5db1374d, 0x15fbad35, 0x3e4d393e, 0xe832704f, 0x675f71d2, 0xd28fe650, 
	0xfa1ba17e, 0x9fc1943d, 0xf296bcf4, 0x7a79233c, 0x796bf691, 0x3faea17a, 
	0x1a5bdaa0, 0xe53fd5d1, 0xb17bd216, 0xfd683ff4, 0x69c5f35b, 0x53097de9, 
	0xdf911de6, 0x4f3c2dad, 0x2b7f37b4, 0x5c1559db, 0xe8915cf7, 0x1c1f03f6, 
	0xfc3a2457, 0xd9ee6f60, 0xc8299c69, 0xe022638e, 0x03806cc7, 0x4538c817, 
	0x75f9348f, 0x00b305c2, 0xe640bbc7, 0xe8ee14fb, 0x0402fee6, 0xce32c98f, 
	0x74453af1, 0x0b71ea33, 0x2c9be79f, 0xda783ce3, 0xf0a5788d, 0xcf197ce3, 
	0xe91c464c, 0x2375dc23, 0xe2dc413e, 0x5c3a3a46, 0x317dbbb7, 0x8842fb8e, 
	0x78b17e0b, 0x1e3fcf17, 0x16740bda, 0x1da05b5d, 0xfee2ba23, 0x61474465, 
	0xffc25e36, 0x1997c885, 0x0cb1c748, 0x3ce1175d, 0xe8df1227, 0xff1245fe, 
	0x364f79e0, 0xf8c0cdbe, 0xd6ce8b2b, 0x3e435d88, 0x4ef3885c, 0x22e9ec66, 
	0xe6887f9c, 0x60fec1ef, 0xabcc1efe, 0x783dfcc0, 0x457bcfde, 0x87194ee2, 
	0x9d8ee215, 0x4b9039c2, 0x738d96a1, 0xb86d2417, 0x720d998c, 0x9f33bce1, 
	0xc5e4701f, 0xc93c6943, 0xf5d4878b, 0x5a7daa69, 0x559cf66f, 0x221e206f, 
	0x36e971bd, 0xe8709fda, 0x1f6762b6, 0x1bb198e2, 0x971c27f7, 0x7affee47, 
	0x2ddce131, 0xc4fef04f, 0xe21f7bde, 0x65e68ff8, 0x9fdc5119, 0x9dc61978, 
	0x31e746d8, 0x23495e78, 0x11d7909a, 0x9b357ee7, 0x9e9a64fd, 0xe62892c8, 
	0xea3ef1d1, 0xc09e9a7b, 0xf31c68e2, 0xedf7fe48, 0x7c99b5be, 0x3e32cbf9, 
	0x4c76f353, 0x9fef7d67, 0x41ff3d02, 0xcd9f7f88, 0x1e5238f6, 0x3d93db1d, 
	0x79317b81, 0x9d9a24df, 0x565c72a7, 0xd23fcea7, 0x8c9705b9, 0x9a35977b, 
	0xe15cd051, 0x62889998, 0x466cb210, 0x4bf7144b, 0x444dcd96, 0x427a1731, 
	0xb90c77e6, 0xa593e21f, 0x32cff7ea, 0x8f4aa49f, 0xfe712ab0, 0x56c4b2b6, 
	0x20f9bfca, 0x77cdcfd4, 0x219e5255, 0xf9c21fb3, 0x887ecc9b, 0x487ef3ac, 
	0x718fb76a, 0x2aeb3979, 0xa823c3f8, 0xf9979f6f, 0x47eab80b, 0x3c139abb, 
	0x91fdc7e4, 0x7c9f24f7, 0xdd817f18, 0x519d6d3a, 0x3653d613, 0xd178e8b7, 
	0x2a654da4, 0x9c688151, 0xa38d2d58, 0x90ae01d6, 0xa625ce8f, 0xfe3caa16, 
	0x96d1c23c, 0xcc66db6e, 0xf3295fc3, 0x987325f0, 0x3cc49f2f, 0xacb835fa, 
	0x55fbbce0, 0xd93186e6, 0x39caf479, 0xe2020f6c, 0xcf304dbf, 0xfd3e624f, 
	0xf50dcb04, 0x52bfb55a, 0xdbf3e1e6, 0x9b3e6587, 0xdb2d3dda, 0x9efecab5, 
	0xc2ade4cf, 0x4e1f0f32, 0xe717e1e7, 0xca35e1e5, 0x9bf463c3, 0xc327fa02, 
	0x67377cbc, 0x13f04af2, 0x2c2fb8c5, 0x7c9feff3, 0x3b34517b, 0xcef2deff, 
	0xfe7668a2, 0x7f9f9c3d, 0x786f4fd7, 0x04f5fa0d, 0xa2e7947c, 0xfc623c3c, 
	0x317c3cd0, 0xcd05fde7, 0xf440661f, 0xf99d9e50, 0x57879392, 0xabe33779, 
	0x2b3f6887, 0x57366f3f, 0x5a1593ee, 0xb384b9d1, 0x28f97009, 0xbe5e4cd7, 
	0xe74f9f18, 0x9c7cdbe5, 0xfd035bc7, 0xb63ee075, 0xcff48c59, 0x00fcbcc5, 
	0x4d3def3d, 0xcf796af8, 0x94695c50, 0x84bd720c, 0xe3e710fd, 0xe6e5d71d, 
	0x32dd35e3, 0xf959ec06, 0xf70b56b0, 0x4af1c43c, 0xe0eb8a23, 0x1befb44f, 
	0xa8ecf68b, 0xd716bddb, 0xd13f4bcf, 0x1602a630, 0xfe7d97ab, 0xa06a6387, 
	0x1beffcbc, 0x52824ec6, 0xf2ededbf, 0x0abe9420, 0x07379bce, 0x8e78156c, 
	0xebb992e2, 0xfd70dc2a, 0xaadee7d2, 0x8d6333c0, 0x36579fbf, 0xef85ca09, 
	0x9106533f, 0xa1b2cc10, 0x25ca1ebc, 0xf7299e07, 0xef310a75, 0x3f52dac8, 
	0xfeccf7d4, 0xe01f1cdc, 0xdec7fce3, 0xdd04c52a, 0x833def9c, 0x54b1672b, 
	0xf97117e6, 0x466976cf, 0xfa005f39, 0xde117242, 0x53bf4013, 0xd3099fed, 
	0x943378cb, 0x6fb6282f, 0x99bc3da0, 0x57a52fd1, 0x75876f4b, 0xe8e7c585, 
	0x2fa4be50, 0x63dd71b3, 0x182e7868, 0xed0fa4f4, 0x4d7981c6, 0x6c48cfd4, 
	0x145b949f, 0xed7f04f5, 0xb8faf3c6, 0x9e3d77ff, 0x93f81b7f, 0x2ced7a06, 
	0xf43a7582, 0xb87e0057, 0x2966ec0b, 0x5dca27e8, 0x306167e9, 0x4efc63a0, 
	0xe78bb8fa, 0x02acf981, 0xa24c405c, 0x79d69775, 0x5b7eea0a, 0xe1c495cc, 
	0xc256bc60, 0xdfa662af, 0x971f78d4, 0x3a8ecaf3, 0x7ce02758, 0xaec84bfc, 
	0x6e57989c, 0x6787fa95, 0x5f3c82ad, 0x87e7a7d2, 0x0e6a7dea, 0xdfae09e0, 
	0x5cc40dfc, 0xd4755795, 0x91dd6205, 0x9f9d7aa1, 0xad7a560f, 0xf443b3f2, 
	0x4c4ecb3a, 0x2cfce087, 0xca2c7fe7, 0xb6fe6367, 0x36be686a, 0xaf8a2e5f, 
	0x80652e4a, 0xeecb2203, 0x7f10de95, 0x525e5293, 0xb191a6ce, 0x7d4b927f, 
	0xdf259f16, 0x36979f15, 0x7cc988ad, 0x967c08e3, 0x7a0e5972, 0xb7e19ad1, 
	0x4e5a73e2, 0xf159f0a3, 0x01f6e497, 0xf1a3eef2, 0xc00de159, 0x17dc19db, 
	0xc2bbe7cc, 0xb2ef9213, 0xe764392c, 0x839187cf, 0xec5e926b, 0x7d65055c, 
	0x7ef857f2, 0xc8f2eb8d, 0x2e2187ee, 0xbb5b3571, 0xaf325c65, 0x4f50ebe7, 
	0xa2b09b9f, 0xde2f8849, 0x8971c398, 0xc26e7d2b, 0x75e4268a, 0x30fe4b8c, 
	0xa5736987, 0x51f7f7f7, 0x31f781fc, 0xf7a5712e, 0xbc52f7f7, 0x2ebfaea2, 
	0xf94efddb, 0x0ee211af, 0x7146f621, 0x5273b21f, 0x63fadf52, 0xd8612f3c, 
	0x79cbc41e, 0x5c5401e7, 0x71546ae3, 0x60e7efcd, 0xefcf035c, 0xedf4cadf, 
	0x71c6a9e8, 0x7b1dfdd2, 0x1fbc79f0, 0x3160f719, 0xe3283bc9, 0xae329d8a, 
	0x15c5e608, 0x62b8bcc1, 0x8b39de4a, 0x2ce77929, 0xf11c634e, 0x311c4cad, 
	0x0eeffb05, 0xeb829a1f, 0x59cf51f5, 0xaabfbc18, 0xce9192e2, 0x0ae77859, 
	0x4342ce75, 0x603e43fb, 0x74db7bdc, 0x22e5f7c9, 0x442ae78a, 0xb55ffb3b, 
	0xfad977ce, 0x2bc071a3, 0xf8a0857d, 0x9295ce85, 0x0439f09d, 0x6fc937e1, 
	0x747d8416, 0x261c0aae, 0x980517c5, 0xe9963a2f, 0x6971f527, 0x9a46e10f, 
	0xdb6ee6e8, 0x9cf89ba3, 0xc131c500, 0x6e771cb9, 0xe201e791, 0xd3c021c8, 
	0xc986e66d, 0x084871d9, 0xa45378e9, 0x422d98e3, 0x38e0279d, 0xfce64b66, 
	0xf931c501, 0xc66ee3ed, 0x2f576a19, 0xc7130ddb, 0x398e31c4, 0xfb146541, 
	0xb737082b, 0x715903d8, 0xb98f584c, 0xc13ce806, 0x2f634f37, 0x13cff373, 
	0x79d51f30, 0x33c63882, 0xc62e3065, 0x61fe5933, 0x5933c633, 0x47de3575, 
	0xeafc6788, 0x8987dd9c, 0x80b9d467, 0x9f4a3c7c, 0xe73a303b, 0x72fb596a, 
	0x38339e23, 0xd1b1f1cd, 0xb41c4876, 0x51f8fe13, 0x419ce9af, 0xfe35e684, 
	0x334c9d30, 0xa54cbfc7, 0xeb827098, 0x323d5213, 0xa97d419e, 0xa6067887, 
	0x180c55aa, 0xfba1cdfb, 0x412bc7da, 0x8cfdf10f, 0xfc50f687, 0xc0dcfb42, 
	0x567343d7, 0x29bf2dcd, 0xc9b7cfa3, 0x726dc03c, 0x2e67bfdd, 0xa4a7c9c7, 
	0x7590ed9e, 0xc7093111, 0x0780ee49, 0xfd8275ce, 0x4037ca33, 0x727de4f3, 
	0x73e28c18, 0x643723f4, 0xc7cd21f4, 0x742e389b, 0x8e5cfdbe, 0xdbfb57ff, 
	0x3a4d926b, 0x03dac5e2, 0x28a2f5f3, 0xf8b1bf5a, 0x0be8c8b4, 0x439f09e9, 
	0xa17cf0d0, 0x3188718e, 0xfbe22fd4, 0x517ed92a, 0x87dcee44, 0xc00617fd, 
	0x34d00e0f, 0xd4852fd9, 0xbf5c92f9, 0x45f54fa6, 0x3f666b45, 0x9c8f5f37, 
	0xfe496ed2, 0x45ea86bb, 0x3b49afda, 0x1dafdfce, 0xbf6a17a2, 0x942f4f37, 
	0x80f4d25f, 0xa862aff5, 0xabe6ca1f, 0xfbd6d7dc, 0xc74c7f09, 0xf390e300, 
	0x2cc1e534, 0x35639f27, 0xa75c835c, 0x43baebfc, 0xf7c475fb, 0x45fe07b5, 
	0x1beb80af, 0x51df34fe, 0x07d5cf03, 0x10bfc5cc, 0x79273b19, 0x3393671b, 
	0x7230c1eb, 0x7a003895, 0x298f7c00, 0x9e451a5c, 0x52b39e42, 0xcff6a6fa, 
	0x828c75e9, 0xfa337c8c, 0x3ffff727, 0x95fb76c5, 0xc4e437b7, 0x9eee4a41, 
	0xe2fbc820, 0xa709fc8c, 0x8e5bfee4, 0x8a84ebfc, 0x3839fc5b, 0x0279c230, 
	0xa207d487, 0x7d186fb3, 0xe9c3e8b8, 0xf643bac3, 0x102e24f3, 0xc7ebe4be, 
	0xd4ef03da, 0xf543dd05, 0xc40ee6c4, 0x7c3ebd38, 0x2faf92dc, 0x67e86136, 
	0xd74c1f48, 0xf8f720bb, 0x7cbbb611, 0xe339387d, 0xcfe60739, 0xdf3538ef, 
	0xdfea1d39, 0xa1ae3941, 0x2cfaceeb, 0x2fa7117d, 0xddf23f25, 0x7447987f, 
	0x960fc694, 0x4b81874d, 0xf4cb06bb, 0xd9ef282e, 0xf326bf79, 0xff027f1c, 
	0xe7fc9f6b, 0xb25bf6b9, 0xbee774fc, 0x4a6af79c, 0x8dee1b37, 0xd08cb1fb, 
	0x35d2b959, 0xafaa7603, 0xb1f03a81, 0xdf61a574, 0x452c63f8, 0xfde23fe7, 
	0xedbea4ce, 0x47f65063, 0x85ef7b3a, 0x6ba4e9f2, 0xc47fde07, 0xcf85dfb2, 
	0xfafe861f, 0xb75c8cb1, 0x6cbfef13, 0xf949dc14, 0x1326eb5e, 0x27d2b562, 
	0x16e5dc65, 0x4d93f436, 0x0d63ce61, 0xf96f0f79, 0xd55fca16, 0xce3075ad, 
	0xfaa09ef7, 0x7aba79c2, 0xeb49cf0f, 0x9e1ef513, 0x74dd873c, 0xe63092fe, 
	0x833d6cbf, 0x8921ee1a, 0x13e745a0, 0x7fa0e34b, 0x73a38ebc, 0xcac24be6, 
	0xbbfb4c4e, 0x79765f50, 0xd7be395d, 0x3c855102, 0xb9d06447, 0x50e7eca2, 
	0x962c8b5f, 0xd861dfb5, 0xdfd208f7, 0x6d87190a, 0x45587196, 0x91561c5e, 
	0x92a5871d, 0x8737f243, 0x253ebf51, 0x078d50f5, 0xc398cae1, 0x3596e6f4, 
	0x665768e6, 0xf09f229c, 0x7d1baed9, 0x0c6df81c, 0xe1b677c7, 0x1ef9c5c7, 
	0xbb6b8ccb, 0x7448acc4, 0xe63bd0e5, 0xb497a865, 0x3718e59b, 0xd78c1360, 
	0x642f32dc, 0x16bf1069, 0x7e067064, 0xb0299ce8, 0x3ac5ce89, 0x92e28292, 
	0x3c1bee34, 0x97db94cf, 0xebd00fb1, 0xa7df8d01, 0xe5ef9ccc, 0x6a6dceb8, 
	0x178e0e8a, 0xe1dedca2, 0x1d9570db, 0x7834eff8, 0x310a9b1d, 0xc8d6fb5d, 
	0x266601f8, 0x45fce3fb, 0xecd4f182, 0x9e39f3b3, 0xa0b69d8a, 0xd14f3829, 
	0x6518f84a, 0x07e7947c, 0xb08f9f95, 0x9fbd179f, 0x49f38c9e, 0x8d1e71bd, 
	0xed8abc5f, 0xb67af8ad, 0xe72fe2b7, 0xc297dbdb, 0xbf1bdbc3, 0x9f5c5fef, 
	0xf106dd2c, 0x08f4f174, 0xc513831e, 0x0e33a645, 0x615c53f6, 0x2f00bb88, 
	0x26b4af8a, 0xbff1443d, 0x8355d055, 0x12dcfbef, 0xbc0701d6, 0x417be41b, 
	0xf79c8cdb, 0xfcbd1a82, 0x2ff60a9e, 0x716a11cf, 0x76d3dbc2, 0xddc6e78c, 
	0x1f5ff2c2, 0xfd26f3e6, 0x8837e053, 0xbe031a4f, 0x04ffbe10, 0x7952e6c8, 
	0x321badd1, 0x431bcde7, 0xb846d081, 0xc42d4aff, 0x9df75989, 0x279f109d, 
	0xd719e884, 0xf7b3d613, 0x0e5aea43, 0x8cf49ea0, 0x2be693bb, 0xafd42ddc, 
	0xb15deeba, 0x06e78c23, 0x4e5dae8b, 0x40ef11ef, 0xfb833b3d, 0xa8dc072b, 
	0xc34eceff, 0x6a75768b, 0xef6a0eca, 0x786a6cdc, 0x3119cd5e, 0x526e78dd, 
	0x7df43f3d, 0x5d69c7dd, 0x1953f9e5, 0x12f58beb, 0x3e9ec4e1, 0x08a29fd6, 
	0x138d983c, 0xb3843712, 0x0cb69f6f, 0xc67a02f1, 0x762a38f7, 0x0ccc6ac7, 
	0x52af145e, 0x96fd2178, 0x29247ec6, 0xbf25ffdf, 0x744e7c8b, 0xd2b7e8e4, 
	0xd6942b37, 0x90e7d25f, 0x4fd67550, 0x8c9ec7a5, 0xa43d269f, 0x87a8eef3, 
	0x67bd38de, 0x5fb1b5a8, 0x5ed03aa9, 0x7c37c3e5, 0xff082b8c, 0xa6cfb4cf, 
	0x8ffb8cf9, 0x703555dd, 0xe1f7e6bd, 0x9ca09371, 0x71eefef0, 0x940ca1d3, 
	0x87aeabcc, 0x99f6aeb2, 0x7d2846ea, 0xbf2985f7, 0xdd8df656, 0xf8ab5f94, 
	0x6bf2985e, 0x3ddb9f63, 0xfe943a76, 0x98154d19, 0xca7ebb37, 0xafbf496f, 
	0xd209f0bf, 0x1fe4fb6b, 0xf2467f13, 0xea7c8f1f, 0x8dbd6127, 0x76bce4e8, 
	0x8c954f86, 0xdf9fa6a3, 0xfbe0ea0f, 0x7f913e19, 0xfb13e2ce, 0xa89f0ce7, 
	0x4f9167fd, 0x604e3203, 0x7a8add7b, 0x8a3a7c0f, 0x1fa9c0fb, 0x3e2abdb1, 
	0x6135aba1, 0xd6ea997d, 0x984be602, 0x59c50335, 0xad3feb84, 0xd16fde84, 
	0xc31f7a35, 0x766a2f5b, 0x5ef29f81, 0x1b63791e, 0x66de3104, 0xf671f8b1, 
	0xdbe38b53, 0x2bce9ea1, 0x9c2bca08, 0xc15e730a, 0x082bce9b, 0xa4882bca, 
	0xbc03f946, 0x877ef98f, 0xe9b677da, 0x63267c78, 0x944d971f, 0x6839abef, 
	0xf0f7e15f, 0xb80dfbbc, 0xf68aa4be, 0xe05ca61f, 0xcea832a3, 0x142ee275, 
	0xdf5cbbe1, 0x5a4e8af6, 0x3a0a0f17, 0x7585ee1f, 0x3317f758, 0x9af031df, 
	0xadc45cf2, 0xe7ef4f32, 0x9d37bd3c, 0xe7a5b0e7, 0xaf0cf989, 0xcfa473ca, 
	0x201d0039, 0x809aef27, 0xd2f493e6, 0xf790cbfe, 0x10f33c18, 0xfdd8ec3f, 
	0xd820f259, 0x345ff79e, 0xea645fca, 0xca61f682, 0x723f64af, 0x3f72aea2, 
	0x342f3525, 0x17beb863, 0xf8cbc33e, 0xcf117a65, 0x97a4fcf0, 0x012293d7, 
	0xd93239f3, 0x41f10f3f, 0x71780db7, 0xdfa55fdc, 0x8f9412b3, 0x7f7ad8f6, 
	0x28f2e78e, 0x487e8b3f, 0x7874fb9e, 0xfd89df38, 0x991e3ea3, 0x71fa913c, 
	0xa8e7ee08, 0xc7a2fd8d, 0x6407ed03, 0xfd331b7f, 0x3f7197e8, 0x991ee3f9, 
	0x207ea41c, 0xb03ca3ce, 0xfbda0ca7, 0x8cbfc6b2, 0xf8e86771, 0xfc43cf17, 
	0x38fe321c, 0x66191f68, 0xcfdc15fc, 0xd4c3f1d0, 0xbafc7a4f, 0x8c57f1bc, 
	0xe1e2ff44, 0xc23a9fe9, 0x348e37f8, 0xfa5cd2fe, 0x44fb4267, 0x8e37f8d6, 
	0x8727fe34, 0x0461bfa7, 0x891baffe, 0xe973cbff, 0x7f4b925f, 0x1f8e1dba, 
	0x75bf1ec9, 0x932ff1f8, 0xfc61bbf4, 0x177e7902, 0x410e2ee8, 0x0f8e14f9, 
	0x6de83d61, 0x88514ce1, 0xd745dffb, 0xa3719ffa, 0xca0b14fd, 0x70c1ebeb, 
	0x33449128, 0xb69b6d30, 0x9a779d65, 0x71f0ebea, 0xa0e2251c, 0x8ce345c7, 
	0x73179e28, 0xf7c2db80, 0x44ca8b88, 0x10ab6247, 0x78e3cfcf, 0xda6453d8, 
	0x3db1363a, 0x7abc9c61, 0xd5eb9f1e, 0x03383d3f, 0xf955dbdf, 0xcc0b4f35, 
	0x7f681aeb, 0xe207cc05, 0x3e2acf21, 0x52f3800f, 0xef516fdf, 0xe3803da5, 
	0xe7efe0ae, 0xe55f748c, 0x7d7dd4c9, 0x770ce0f2, 0x7a874320, 0x9ff7c74e, 
	0xb79873d5, 0xd9214610, 0xba14446d, 0x33a1fcb3, 0x39e21664, 0x85585d4c, 
	0x00332f88, 0x65afbc07, 0x9f3119fa, 0x739e3cb8, 0x7ca464fe, 0x974bb2a2, 
	0x2ccce501, 0x7e012cf9, 0xc687844c, 0xa445be03, 0x0c7e309c, 0xefd27cb0, 
	0x6225d475, 0xf21172d9, 0x38cf7e3d, 0x94e3e493, 0x9994f1f2, 0x0bcf9431, 
	0x713f18f3, 0xdf21dc7d, 0xfa7dc287, 0x638f94a4, 0x9027c80e, 0xc43bbe75, 
	0x64ccf1f2, 0x67c338f9, 0x14678f97, 0x0ef7a8f9, 0xca077dd4, 0x7cba3927, 
	0x01c806dc, 0x296333e4, 0x438bfff0, 0xe54bff9f, 0xf70ce380, 0xd157e41e, 
	0xcbee204f, 0xe963ef7c, 0x5c59f33a, 0xe581fbc8, 0x633e2a0d, 0x2a7d05bb, 
	0x8a9f5932, 0xf2abe3b2, 0x166fb821, 0xc2067bd1, 0x56bb422a, 0xeea27038, 
	0x873a3ec8, 0x91c1fd21, 0xa79ebfc9, 0xaff4c99f, 0x3d7861ce, 0x4e970f22, 
	0x5c417fb0, 0x05c19b58, 0xa17e08c7, 0xfe5fea5c, 0xfe4c8ebc, 0x3a2e0e6d, 
	0x5782fcf2, 0xfe3a1bb6, 0x434b849b, 0x2fc11fc6, 0x30bf4b94, 0x7277fc74, 
	0xe791d170, 0x64fed217, 0xc37af8c8, 0xe08fe3b0, 0x1c6fca17, 0x86c2fc69, 
	0xfcf3f19c, 0x0c9fda42, 0x61a2bf19, 0xe08ffe58, 0x8dd7ca17, 0x86eaffc4, 
	0xbf2bfe1c, 0xdca0e380, 0x79c23b65, 0x870707a5, 0x8df68b8e, 0xc991cbf1, 
	0x8e3d13e7, 0xe97bfccb, 0xd3012b7b, 0x8bfa718b, 0xef46adb8, 0x7be88a67, 
	0x7f27bd26, 0x4a3fe619, 0x9e2b228a, 0x8aca17bc, 0x363627c8, 0x69135943, 
	0xb88bc7be, 0x3f7d3c61, 0xbacb99c7, 0xdef467c7, 0x2afc6211, 0x3a55f897, 
	0xc197e253, 0x628a67ef, 0x52ff474b, 0xf805f88e, 0x9c0db7f2, 0xdbaf4e37, 
	0xb41d12ea, 0x08271ace, 0x7e32f4b7, 0x665bd43f, 0xa2b95f92, 0x57cb7181, 
	0x5b897424, 0xdce79ef4, 0x2b17de06, 0xb71735bf, 0x5b8c6dbc, 0x5b8ccdfa, 
	0x1d7df95e, 0x27c64efd, 0x9c21c49f, 0xf32bae07, 0xa5c072cb, 0x29b6efec, 
	0x16e7523c, 0xf2a0de3f, 0x0170823e, 0xda1144fc, 0xe730aceb, 0xb4f9f201, 
	0x1b8d21b0, 0xb286e23a, 0x7ec1873b, 0x25b7cd39, 0x7cd397ec, 0x337c0f1b, 
	0xf35b7c32, 0x76b6f921, 0xee7dbe04, 0x1adbe42f, 0x72fca7c9, 0x22ddbe34, 
	0x06f8a3e7, 0x5b7cceb8, 0xe6d9cf2a, 0xa57aedf1, 0xca6f929f, 0xb92dbdee, 
	0x0ae38cf1, 0x8e866fa5, 0xc2e259fb, 0xbd7dbe5c, 0x1903d781, 0x913af9be, 
	0xbe3cbe6f, 0x7d60caf9, 0x4a4b7c02, 0x191696f9, 0x8e866f92, 0x7c52eff3, 
	0x37cb9c9b, 0xf37cc03d, 0x70df31d5, 0x9afc494d, 0x952b7cca, 0x03ce0971, 
	0xe5f959d7, 0x9edb7c68, 0x169e6fa7, 0xc3e5b7c9, 0x69dddbeb, 0x7c74337d, 
	0x595ce15e, 0xbd4ed724, 0x937d28d7, 0x1b905b7c, 0xe3cbee07, 0x9281c41b, 
	0xcaf7e06f, 0xe29ff132, 0xdf2901db, 0xd93dbe7c, 0x8bbfe320, 0x473fe372, 
	0x2a6df250, 0xa862e3cc, 0x6edf2427, 0xc96dbe06, 0xe49f6df0, 0xffa97e53, 
	0xcadf2e43, 0x3fb6f8f3, 0x11456f8f, 0xc355b7c9, 0x79fbedf3, 0xae311b7c, 
	0x0f39c488, 0x5c7b3918, 0xd9645251, 0x495340a3, 0x973a14f3, 0xff19f85f, 
	0xdfe00133, 0x9dfc0d05, 0xfe1fd539, 0x7e41bc60, 0xef39e71f, 0xefec0d97, 
	0x5c669cf9, 0x0f8a1e18, 0x627712ca, 0xca9a73de, 0xe5053bfb, 0x0041ac09, 
	0x3fd1679e, 0x9e764f08, 0xfbde56c2, 0x9a77a453, 0x911c3fdc, 0x7a5c969e, 
	0xc5c39e70, 0xff0abf43, 0x5fbe0367, 0x8bdcf30b, 0xde75fff7, 0x0b3cd4ef, 
	0xf1c50fd1, 0x9a32ea9c, 0xee385de7, 0xf517950c, 0x38ecc289, 0x02f5e608, 
	0xe64331d2, 0xfc683f39, 0xfc3f9ae6, 0x5dd44ebc, 0xeaa7794d, 0xe8adc9c6, 
	0xff2faabf, 0xf05ef382, 0x9c93d557, 0x527bf97b, 0x41c5dfd6, 0xfac247be, 
	0x90a73c7c, 0xbf82a72f, 0x23dfbe19, 0xb47cfa0d, 0x5f8f1d65, 0x95bf9d03, 
	0x986f7a75, 0x1efa3ce3, 0xd5e6444b, 0x6f39471c, 0x8e62f2ac, 0x6bed06a3, 
	0xd391e7e5, 0x225ddd79, 0xf726cf37, 0xc0f2b277, 0x2f9b3fc4, 0x6fbcc51c, 
	0xbca09bca, 0x21d3799a, 0xeffaefca, 0x937ef410, 0xab8c9d7e, 0x17e607e7, 
	0xcd4424de, 0x9f3cf8c7, 0x8e6e7981, 0xaa1cf837, 0x4af1cf9c, 0xc478e311, 
	0x1e63f9e2, 0xb114f29b, 0x519f98bd, 0xb8dcb874, 0x22c42247, 0xf107dfa0, 
	0x19e1bb88, 0xf29e2fda, 0x4b7b5df1, 0x357ef2b3, 0xe5f6935e, 0x3886c7e1, 
	0xfbbea982, 0xe61a5f01, 0x4cd65e33, 0xde53fbe6, 0x3ecb145e, 0x677c1887, 
	0x1cfb2c51, 0x6c1ec662, 0xa3efdc36, 0xd5c5393c, 0x0fc8bdf1, 0xe93f3c97, 
	0x71464e6e, 0xf725cd3f, 0xe6035de5, 0xbd156d5c, 0x527b6f87, 0x2429f864, 
	0x56060b3f, 0x911ebbfd, 0xc338bcfc, 0x4f0fb57f, 0x1955f6f9, 0xbf7e62fe, 
	0x372333bf, 0x6e7c3ac4, 0xe2979e2c, 0xe53a18f7, 0x039d0e3e, 0x79f9f677, 
	0x380dd89f, 0x3a1ef9c8, 0xde799777, 0xd03949b0, 0xefd8e77e, 0xb79ce3fb, 
	0x79e2f737, 0x391580a2, 0x7cdbe782, 0xf6827f72, 0x1fbcdde7, 0x97fd4097, 
	0x4f248afb, 0x10ee3f68, 0xafb404a8, 0x7cd86a3e, 0x0c6f5fd4, 0xfb6563eb, 
	0x29e4eec0, 0xafa5cf3c, 0x57de867b, 0x0b98a117, 0x595eeef9, 0x7505fac5, 
	0xac52fbe4, 0xc779f017, 0xfef8699f, 0x257081a0, 0xf7f0c72a, 0x5f91ca38, 
	0x23df703b, 0x2ed05f6b, 0xbdfa8ee5, 0x5439d053, 0xc5114adf, 0xe760f1f3, 
	0xecc38df1, 0x5df9087b, 0x48becc94, 0xc8677d01, 0xb4b96577, 0x77542587, 
	0xe64cb27f, 0xf54b7fc5, 0x5435bd15, 0xe138972f, 0xfbf069d8, 0x740fb8cf, 
	0x114de735, 0xd0337417, 0x03f705dd, 0x3c15616e, 0x29d5f24d, 0x5be52d8f, 
	0x74764be9, 0x251df498, 0xc916e7a9, 0x4f45f407, 0x51b43ed0, 0xee333180, 
	0x6953f45b, 0x23167fba, 0x0f31c679, 0x02afbf92, 0xdc817df6, 0xee4c7b37, 
	0xb7905d9b, 0xde41759f, 0xde60a5f9, 0xce60e8b9, 0x6970e8b9, 0x29dabefe, 
	0x486fcfc4, 0x5279579c, 0xfa883ff8, 0x3fa27f76, 0x73aae388, 0x0c2bab4d, 
	0xbe032efe, 0xd7fdc542, 0x3d11741c, 0x4f7cf835, 0x12c4e031, 0xc7237798, 
	0xab973d69, 0x7162a073, 0x37779e14, 0x3d3a7bf2, 0xce238ccd, 0xeeff7e46, 
	0x4e3f578b, 0x1e98e778, 0xdd3e63b0, 0xe2d607a1, 0x4477407a, 0x409448ae, 
	0x17604d7d, 0xe43ab7ee, 0x59a3ab7e, 0x136368fc, 0x87d11196, 0x24c995f5, 
	0xfaca57d5, 0xdc22e275, 0x4eac758f, 0x1c40f83e, 0x4c0febcf, 0xe695faa6, 
	0xf8a5add8, 0x1f81c01d, 0xf215f3d2, 0x01631af9, 0x8c649fdd, 0x39b8efc5, 
	0x13d3228a, 0x1edca007, 0x8d59de48, 0xd77fa465, 0x8e9f285e, 0xc72759d0, 
	0xaa05e2d3, 0xb63a81ef, 0x362ab7ef, 0x23e50a5e, 0x1e7b96d6, 0x64c9f283, 
	0xcc177e25, 0x72dc99d1, 0xed1b9e17, 0xdbfc781c, 0x771c2fe0, 0x44efda47, 
	0x979b367a, 0xe2fec03e, 0x70ff9d0f, 0x3504bf16, 0xfa909792, 0xf462e327, 
	0x2bf071c7, 0xc6236f56, 0x3b772852, 0x7884db9f, 0x7275e404, 0x487ff33e, 
	0xffb6481e, 0xdef97cf3, 0x497390e3, 0xa3b9ce46, 0xc12fdf21, 0x67183ffd, 
	0xc5eec475, 0xdf2f85fd, 0x0837bb76, 0x37f7fa76, 0x36d2f19c, 0xbcf72fac, 
	0x9f2d79a8, 0x97103667, 0x22ff918e, 0xcf3fc87b, 0x0a2df6a4, 0x1fb5757a, 
	0x63f3cb6a, 0xe5920fb4, 0xadcf72c7, 0x4f980a04, 0x7a0abf12, 0x3a879cf9, 
	0x0bf0e317, 0xda5329ed, 0x5e7931e3, 0xbce65961, 0x3a7c48d7, 0xd3df9f3a, 
	0x3ca7c21d, 0xb9e5b8be, 0xb66e755c, 0x10311bc8, 0x3dcff207, 0x1fa7d3fc, 
	0x02fb8f9f, 0xb9e7cf8f, 0xa055cbfe, 0x753267f7, 0x74a8ddf5, 0xebe525bc, 
	0xf8bdd4ee, 0x23755efe, 0x3e4acbaf, 0xfb88da53, 0x00e6ee84, 0x43e45f7f, 
	0x649b51ca, 0xa1cc0719, 0xb6e752f2, 0xd35f9eee, 0xc94bf188, 0x711b6a67, 
	0x47c70b5f, 0xc791f5bf, 0x86f181ab, 0xde350fd1, 0xea5efa5f, 0x7ee5ef68, 
	0x66bbf907, 0x5f73f7f4, 0xf4973099, 0x7ee46dc1, 0xbf2dc6d7, 0x87f9836b, 
	0xee7f8039, 0xf5bdfb13, 0x108fcc7d, 0xa34973d0, 0x25cdaefa, 0xf0711724, 
	0x7d4bed14, 0x97dca265, 0x5faab02a, 0x34fbf935, 0x8c097ef8, 0xffcf04bf, 
	0xdfc566ff, 0x13b57f10, 0x60f792c6, 0xbd774dfc, 0xff1c6bfc, 0x1397f9ee, 
	0xcd1113ff, 0xe0fead8c, 0x57dea0f8, 0xb7b6dff9, 0xd9df90b7, 0xecf2abe7, 
	0x11e7cd2d, 0xe5f41fbe, 0x216b552f, 0x7603238c, 0xd0e39cf7, 0x7b71ef4d, 
	0xf13fc608, 0x73e6905a, 0xff7f2353, 0xfc0a7fa0, 0x738e1376, 0x09709ab0, 
	0x711fbbf9, 0x557b122a, 0x236f7f20, 0x171adafe, 0x99cf792f, 0x6a76dfcd, 
	0xfbf961f7, 0xcc0cfc29, 0x133e19cd, 0x991eb81d, 0x79113cd1, 0x73a6f4a7, 
	0x06d13ea9, 0xd830dfcc, 0x5dbee1a4, 0xe2263097, 0x821bcefb, 0x3b3bad3a, 
	0x7113cd03, 0x676be43f, 0x37cc349a, 0xc612fd2b, 0x57ce896f, 0x9f129617, 
	0xe93a82bb, 0xfd697dd7, 0x22f48fba, 0x284d5e9f, 0x3eb0b77a, 0xf7a7ca4d, 
	0xbd1ebfc1, 0x770fb167, 0xad0eeeb3, 0xe3c5d8ca, 0xd4ee4e52, 0x1a7122fe, 
	0xcd38ffe7, 0x443d1c4f, 0x0566b1f6, 0x19bb85e3, 0xcedb0656, 0x235f5746, 
	0x8ad2579e, 0x75dae9f2, 0xdb4ae84e, 0x717f737d, 0xfbeecb28, 0x67e972d3, 
	0x9a7e5fbb, 0x93c2fae8, 0x357d72a5, 0x653f3d12, 0x6f9d3d39, 0x247c2ff7, 
	0xf4b0ffbb, 0x6767dadc, 0x897492fb, 0xef48a755, 0x91347e1a, 0xb49bfde6, 
	0x5866fd7d, 0xf1d0cafb, 0x67e5cb0a, 0x389c74f9, 0xf2f97227, 0x85a33e97, 
	0x5feb5e60, 0xc658bc01, 0xc23a47fc, 0xc9f9f337, 0xf8e9a63f, 0xbc7428e3, 
	0x37e8f2cb, 0xcfebf4f2, 0xb61e44e7, 0x3a5c96b2, 0x7447bf76, 0xdc70771c, 
	0xe940b25e, 0x5676fc19, 0x80b31ffb, 0x2f9c38e8, 0xfe0bb18f, 0x9fe8f21a, 
	0x2ff51e72, 0x3ce8d7cc, 0x63ed53c3, 0x50d3de73, 0x687e9fef, 0x6ebdf5b9, 
	0x837f410f, 0xfd4e9d9f, 0xf7a6985d, 0x9de851c2, 0xeff480b5, 0xd5b97ce5, 
	0x1de855ff, 0xf11d0e8d, 0xa0f10060, 0xeb0438b3, 0xbf27f5c5, 0x88e97444, 
	0xb9ff060f, 0x7e03a620, 0xfff07c43, 0xfdc3e12b, 0xbe486773, 0xc7d7448d, 
	0x717d2e99, 0x713f1c9e, 0x221ae84e, 0x925f969f, 0xc5df6e3e, 0x40bad0f8, 
	0x82eb55d9, 0x0dd5dbb3, 0xe66f8fac, 0x39d567cb, 0x52e363a1, 0x4ee7173d, 
	0xecf49aff, 0x39f10f47, 0x3a69759c, 0x87428dd6, 0xe45474c9, 0x82e89ffb, 
	0x230f8173, 0xd39b9dc5, 0xf0df87f3, 0x03fe847b, 0xf72d5fa4, 0xffc51a4c, 
	0x95fac43c, 0xd7cb97ca, 0xd25c89cf, 0x77675cf4, 0xefd3fb67, 0x2ef9e9a6, 
	0x817813d3, 0xeba7e670, 0xcf428ea7, 0x93cf4cd3, 0x83f7b8f9, 0x9e4f4b73, 
	0xe9a60e7c, 0x0cf4c839, 0xecf442bc, 0x28da6fb9, 0xf59cfcf4, 0x3d3e7b6d, 
	0xf44e76ff, 0x6c2bfd6d, 0x938714ff, 0xfd920ffd, 0x24e8dfd7, 0xc6963adc, 
	0xe0a363b5, 0xcb9629f3, 0x767af923, 0x6ed57ffa, 0xe5cb49de, 0xef8b961d, 
	0xe34dd90c, 0x9146f38d, 0xe490b68b, 0x1e9f27b2, 0xa173c2db, 0x4e4feb67, 
	0xe4b3c5cb, 0xdeb3c27e, 0x724f9dcf, 0xe4a858a9, 0x559dbf02, 0x8e98e32e, 
	0xabf5f377, 0x9139e17a, 0xe9d75c8b, 0xd053c748, 0xa253f836, 0xf18f67e3, 
	0x34c2eefa, 0x4b0e171d, 0x377d6647, 0xc7bd216b, 0x4fdf3d30, 0xe4f5ffd6, 
	0x8fbf0c71, 0x9ce74cd7, 0x6e5d3d15, 0xd5abf69d, 0x3d68f3f7, 0xdfa67cf7, 
	0xf76e7af4, 0x2e6ec9cf, 0xe893393b, 0x65b9eb52, 0x2dfe950b, 0xbf76785b, 
	0x539609f3, 0x2d7d3e4d, 0xed4e44e7, 0xd773cafb, 0x227f2de1, 0x33da1e7a, 
	0x26b9e89b, 0xc335c74d, 0xd39191d2, 0x56c3a22a, 0x17c74f9f, 0x08742aff, 
	0x34a9790c, 0x6eb997b5, 0xfa75c13b, 0xef9080ae, 0x1ef908b3, 0x9fbcc88b, 
	0x4a8cffa6, 0xa54c38e1, 0xe51a38e5, 0xb8e00f71, 0x7dff4abf, 0x97be271d, 
	0x4c09fa90, 0xfa94f804, 0xfb54c069, 0xed5fb8cb, 0xdc4e122f, 0xf8fba0d0, 
	0x927e6a77, 0xf4fc8fb9, 0xaf90efcb, 0xeff9c45b, 0x67ef1b2a, 0xfbca7ffb, 
	0xc3ce8af6, 0x77bf388b, 0x0fde22df, 0xa64bcfcf, 0x4019410e, 0xafbc9abe, 
	0xe753ab64, 0x7f941dc0, 0xdf8d2cd4, 0x11efe323, 0xee805a19, 0x35fb938f, 
	0x999f9895, 0xe097ed48, 0xb94a8fb9, 0xdbeeab5f, 0xc843a67c, 0xafb4c9f3, 
	0x427dc960, 0x8afbca33, 0x43f3a797, 0xbe973a0e, 0xdd2e7d24, 0xbd2e7b91, 
	0x8a17e685, 0x203efaf0, 0x3f7b2d84, 0x2c792464, 0x1efa8433, 0x0aa5c904, 
	0x929e7bcf, 0x190540fb, 0x4479153e, 0x0c3f0c47, 0x9da97834, 0xba0c13ce, 
	0x6e889bec, 0xedc1e543, 0x83fea11b, 0xaf079c85, 0x261d18f2, 0x3abc53f4, 
	0x3f41a4d0, 0x6bcf50c5, 0xe1efc1df, 0x6077dba6, 0x85d9fd1e, 0xed8fffbc, 
	0xfb50d763, 0x37e51afd, 0x683b647b, 0xc1d33cff, 0xd43da0ed, 0xdeb8e5fb, 
	0xfc269135, 0x3ed540fe, 0x7b00b75f, 0x76699aa8, 0xbfc83798, 0xff91b2df, 
	0xebf6028e, 0xf1ba225f, 0x7d7099fb, 0x355fbe3f, 0x0df3e0cf, 0xe81e0fef, 
	0x53f81b78, 0xf9a2d535, 0x364fac97, 0x8f12bb61, 0xc07fe725, 0x0677e74e, 
	0x7e983a7b, 0x47ef4ecb, 0xe903b30b, 0xbfa285ff, 0xa171a2ce, 0x3fa47efd, 
	0xe4e5ded3, 0xff2407f6, 0x5bdb9384, 0x28dfbfc4, 0xfcc1c7fa, 0x06fce14e, 
	0x8f7e7f88, 0x2f6bcee8, 0x4f6e97f9, 0xc6a93bfc, 0x44f6806f, 0x6ff100f7, 
	0x3b4bfb68, 0x9d1bdb73, 0xe53ffed8, 0x7e97c0f8, 0xf91a17dc, 0x9cf1e5bb, 
	0x43b43a7d, 0xa9c4ed8d, 0xae585efe, 0xdb4dfa9d, 0x93aa214e, 0xafbe939a, 
	0xe9361fd8, 0x3cfd57ef, 0x8fb425c0, 0x99739d91, 0xb8ed2f6e, 0xbe3b1463, 
	0x7e3b60da, 0x10f3da50, 0x68f81e3b, 0x8a335c76, 0x648cd71d, 0x5da507c7, 
	0x9e3b239e, 0xe3b657ff, 0x65fd168b, 0xab273c76, 0xe3b187fd, 0xff588b05, 
	0xbf1daa3e, 0x05cf88b8, 0xfc76a5fd, 0x997f45f1, 0xb55a7f1d, 0xfc7688ff, 
	0x8f87c939, 0x905fc76a, 0x3b547fe3, 0xb3d1fb4e, 0x9dff2fd8, 0xfd0fb82c, 
	0x9c070ffb, 0x67b472f6, 0x8f7f89b7, 0x3e22e36e, 0x0a0a921f, 0xf7fd999f, 
	0xce669ccb, 0xf653a9df, 0x789d770c, 0xf837517e, 0xc507d93c, 0x0a877c05, 
	0xe9998bbf, 0xf300f807, 0x9f8e5879, 0x175baf3f, 0x92a7ce31, 0x2f344dda, 
	0xe682b8b7, 0x533cca35, 0xf139c387, 0x39c038c5, 0xa3ca14b3, 0xe7128e7c, 
	0xaf8c4bff, 0x826f3f00, 0xe301dff9, 0xd4a2b9e0, 0x1653e009, 0xc2dc6b3f, 
	0xd26aed85, 0x97f384ed, 0x22c75f30, 0xed8dd76e, 0x0b2fc386, 0xd0f8a4ca, 
	0x96df85f8, 0x2300f3c2, 0xffba97e1, 0xb97e1eff, 0x9abafda4, 0x6711ff50, 
	0xc3e29cf0, 0x067fe306, 0x409f00a7, 0x5832df2e, 0xe08f0aee, 0x1f3c7efa, 
	0xf7043841, 0x1b8c1a77, 0xc24c4b55, 0x84deb80b, 0xb42fbdf7, 0x199927e1, 
	0xdc4ab67f, 0x592f7e81, 0x1fd4fbc4, 0xc1bd7943, 0xf3788b76, 0xe647e261, 
	0x1b8b47c3, 0x17ffde49, 0x83d246e2, 0xc6372956, 0x6199db45, 0xa2f6f5e4, 
	0x73a9795c, 0xfeffd043, 0xd827f4b8, 0x9a34efce, 0xd3890b76, 0xfa3fa8a7, 
	0x7b7e69fb, 0xfa2ba9a4, 0x60297061, 0xffffa06a, 0xb7f74603, 0x000000bc, 
	0x00038261, 0x7ded9c78, 0xd5547c7d, 0x77b9ff99, 0x99b99dee, 0x05e4c24c, 
	0x31844098, 0x9a221860, 0xa546a2d1, 0x094492e5, 0xab59952f, 0x997dab35, 
	0x8a8afe00, 0xc8b6d41a, 0x24cef5da, 0x0cbe0084, 0xeb203548, 0xb596ab46, 
	0xb5a2ecfd, 0xb6feae96, 0x5a2b4903, 0x5b2fa5db, 0x34fdd6d9, 0xfee95840, 
	0x6b52e9f2, 0xf2eca45b, 0x39cfbe7b, 0x24cee677, 0xfdfdb111, 0x53f4dafe, 
	0x9cbee72f, 0xfbe5e797, 0xcf39e73c, 0xe3842339, 0x7108d54f, 0xf84263f2, 
	0x122215de, 0x4654fe12, 0xc5ef9188, 0x5d176d1d, 0xfeea9d85, 0x10ba10a4, 
	0x72a6e9c2, 0x54fdae96, 0xdc5d1cb0, 0x4ebd574b, 0x15742538, 0xa0e9d359, 
	0x9cd5968b, 0x0d0b2845, 0xca2d6dcf, 0x108623cf, 0x310b375d, 0xff842239, 
	0x79befe5c, 0xb397074b, 0xb9fe64fe, 0xb14c761e, 0x9adb9f11, 0x9bfe8f78, 
	0xb28384d5, 0x58b2e293, 0x197b642a, 0x6d9ca261, 0xb6fb54d6, 0xc2e2f689, 
	0x7fb8272d, 0xdf1baa71, 0xee6aa947, 0xceeac89f, 0xdf3fdc6b, 0x8e2e0ebb, 
	0x855f14ef, 0x62129831, 0x7b5d4d91, 0x6f1bef97, 0x52a6b950, 0xa6de6574, 
	0x2922ab8f, 0xa69ef541, 0x85fb9ebf, 0x57450508, 0x76bd2b7a, 0x38c3e022, 
	0x85b2dae8, 0xda09adea, 0x84c7995d, 0x8e7a8cd8, 0x6546510b, 0x96d75ef5, 
	0xa16c42ed, 0xe5c725fb, 0x7ce5e97b, 0xfe85207f, 0xc3e8589e, 0xbcf147f3, 
	0x3b379e93, 0x7cdbce5d, 0xcbcf05bf, 0x72d9dfbf, 0x2e6b1509, 0x7f54fba6, 
	0x7ae1d079, 0x55be20df, 0xa03f7d51, 0xc78bb8ab, 0xc69275d7, 0x86e1b473, 
	0x1d7c4101, 0x7eff1309, 0xf211a346, 0x47ff6eff, 0xdce15eac, 0xb6a24c40, 
	0x16fc071c, 0x9f8ab10e, 0xaf7ef57f, 0x9d1c441c, 0xbf6a60e4, 0x7ca877e6, 
	0x84aa7cf7, 0xd83233e8, 0xf81888e4, 0x3e7e5828, 0x07247b6c, 0xf976d4fe, 
	0xb46363de, 0x7b44b90b, 0xd768fb6e, 0x0f2e4b19, 0x92972f8e, 0x38f285cf, 
	0xe8f20cf5, 0xf679673e, 0x257ee3ca, 0x3ca27f5f, 0x28779cb2, 0xe5245cb9, 
	0xf218f8f2, 0xd1c825f8, 0x6479793d, 0xf5c43c39, 0x77f2f40f, 0x45df0fb6, 
	0x1ecb76fc, 0x459a452a, 0xc88dcb0f, 0xc44ed0fa, 0x9f596c97, 0x44be1b3a, 
	0x38e88d1d, 0x49cb43f2, 0x8be2c6c7, 0x63fa05c4, 0x1a7e45be, 0x84aafbf5, 
	0x45c902f8, 0x46e1c929, 0xf72747c8, 0x8e37e5ab, 0xa7f47394, 0x45b4756c, 
	0x0fad192b, 0x0abe348d, 0x31083eaf, 0x062de920, 0x5e948752, 0x047d5e90, 
	0x4ebd71ef, 0xfa49f80b, 0x00fac5d0, 0xf4ac993d, 0xff7473e2, 0xda00e49e, 
	0x6f8a0f29, 0xe982763c, 0xffaa5af0, 0xff67f783, 0x99ced97c, 0x7cc6f3fa, 
	0xde0fefd9, 0xaa47fb1f, 0x9a1e5b3f, 0x87fae92e, 0xedf5e5fb, 0x86d744d3, 
	0x57bf5a6c, 0xa7e1a9ca, 0x49c25d72, 0xd1f5e7f7, 0xe98d0908, 0xa4eed75f, 
	0xb675ff20, 0x439f78e3, 0xfdd2275e, 0x43275ae8, 0x38559542, 0x88d9f2e2, 
	0xd0562091, 0x7a5a12d5, 0x4aff108b, 0x94eeefcf, 0xa3a2a4f5, 0xb31a39eb, 
	0xacb570b5, 0xbced4c2f, 0x733c4b66, 0x0a8cc1e5, 0xee130f4d, 0x45c4f5b8, 
	0xf719f9d8, 0xdf91ca5f, 0x652fce11, 0xdb93d499, 0x8f19c6d1, 0xa236724e, 
	0x01f49d27, 0xe80b13e6, 0x414b0108, 0xfd627f7d, 0x96e307a0, 0x84e93b6e, 
	0x7cba1db7, 0x38af5f32, 0x7a1eaab1, 0xc79f52ba, 0xbbd15a7a, 0x350e72bf, 
	0x44feb150, 0xae9eb1a5, 0xaadaee0f, 0xe7f9e4d5, 0x7db11fab, 0x53e8f79f, 
	0x47c53ef7, 0xe87a335b, 0xd0d16efd, 0xf7ae80b7, 0x58620239, 0x5e8852b1, 
	0x50fb5e5b, 0xf83254fe, 0xaf4977c8, 0xa6ef4e83, 0x67579500, 0xb952374b, 
	0xd5271ee2, 0x45f71ebb, 0x51ef81fc, 0xbfc769f9, 0xb66b8339, 0x5d2f6fbe, 
	0x17a239b7, 0x964cefdf, 0x75d21664, 0x345f31d0, 0x3656fae9, 0x0f2d75b1, 
	0x8a29bd27, 0x3ccfedef, 0x1a2772c4, 0xf2f95336, 0x69a45e1f, 0xccc6e724, 
	0xf8468b64, 0xceca1a13, 0xa3944915, 0x50876b57, 0x2a740b16, 0x1976991f, 
	0x298ccce3, 0x0820317f, 0xa2648c67, 0x60069bb1, 0xf5c6ed44, 0xf354a7a8, 
	0x7e95415d, 0xbda6c691, 0x56b391eb, 0x3e9175a1, 0x861b2219, 0x61c235bd, 
	0x8cf543d1, 0xbce16138, 0x4bb41f49, 0x11c231fc, 0x6f3d0363, 0x045efe01, 
	0xf27b2339, 0xc583e2a6, 0x4b80717c, 0xe6c77e39, 0xdca39fe7, 0x3dfd1c24, 
	0xe8822fa9, 0x3ff4c226, 0xc7851d94, 0x7c187b56, 0xc486dacc, 0x615deadb, 
	0x2818f88b, 0x7ae30e17, 0x9c285454, 0xb06838ae, 0xbfa0565e, 0xd5223981, 
	0xd04cf44b, 0xeb90c2b8, 0x8e78ed4b, 0x8fd28e9f, 0x29def4a3, 0x42d2a7a1, 
	0xea8c2f0c, 0xd470c682, 0x4db45326, 0x3be90b88, 0x3ffa1deb, 0xc955a4c1, 
	0xbeba2872, 0x27d2654c, 0x43b28594, 0x7f689c30, 0x71b5d2e4, 0x6b18f203, 
	0x5da3bee2, 0x346f7841, 0xc70d8d45, 0x3688743c, 0x5d2ec7f1, 0x064ccaf5, 
	0xb8d3397c, 0x57aee98b, 0x5f001df5, 0x9e1dee99, 0x7e7448f6, 0xb070e8aa, 
	0xaf6caf9b, 0xaffca16c, 0x287cb7e8, 0xed2835bf, 0x8cfec8a7, 0x76ecafcb, 
	0xa3f09bed, 0xc229c15f, 0xcd2703f2, 0x350374fe, 0xb51e72d8, 0x776a3bf0, 
	0x8c2d09c3, 0x34d962b7, 0x25e8abde, 0xc01afa7b, 0x088f6b2e, 0xafb65f49, 
	0x23db9d3e, 0x7bc34fb7, 0xac9faaa5, 0xc65ed4af, 0x239b671d, 0xb39dafed, 
	0xcbbfb2bf, 0x6bd9427d, 0x472dcf1d, 0x52c46ff6, 0x80735874, 0x5eea5e3c, 
	0x7debfef8, 0xeb3fae49, 0x23fd4ddf, 0xc0e5bec2, 0x62a5372e, 0x17642f8c, 
	0x48fd4b3f, 0x9520c566, 0xf62c9f2f, 0x8ee61d76, 0x3efd54fa, 0x09c5f587, 
	0x4a962188, 0x83b7dbb6, 0x4ec3f0ff, 0xa48db404, 0x60ff9767, 0x89be9176, 
	0xbf4784cb, 0xd62b7d5c, 0x1d89baaf, 0xf58726be, 0x1bc5c075, 0xdf317eaf, 
	0x7e2b9da8, 0x054b6e7a, 0x249daf3d, 0x0bcb5d52, 0x8f6ac7fb, 0x40bfb07e, 
	0xcbc900fe, 0xf8e25b69, 0x1c55d37f, 0xd6bff3cf, 0xe9deb8d0, 0xe15d3327, 
	0x6efdcf1a, 0xdf545ed9, 0xeec5f7c2, 0xd741ea5b, 0xd32d5f7a, 0xc4956cb9, 
	0x259bb2c7, 0x5edd963e, 0x1e2e8f88, 0xfb24cc8f, 0xa3d29ef6, 0xd6e6e01e, 
	0x79dfbe05, 0xd51515c6, 0x7654e882, 0xc055ff5d, 0x1279b2cb, 0xb3aacb2f, 
	0xc01ded1f, 0x447d11d5, 0xad90b28f, 0xd74abef5, 0x9bbdfd39, 0x73658f89, 
	0x6be832ed, 0xddea9199, 0x8718fe84, 0x48f7f7e4, 0x207b2c7c, 0x87efc659, 
	0x5af6f416, 0xe6c17fa8, 0xea3e2417, 0x2ec927a9, 0x9015433b, 0x6991f81b, 
	0xd9b9ffaa, 0xe0302ecf, 0x2bb0ed6f, 0x95c3dfc0, 0x4d9eb18f, 0x9bb2a210, 
	0x5d5e77f0, 0x7bbb0e34, 0x290589e4, 0x2f312d52, 0x89a78e1e, 0x5491235f, 
	0x66fba0dc, 0xbdde327d, 0x8a97be4b, 0x4337c7e6, 0xe3ead5d9, 0xb530cdf3, 
	0xe7a7dff7, 0xf78d270b, 0xe9ebe33b, 0x8963f37d, 0xef7d0f78, 0x14b476af, 
	0x973199c9, 0x0af50200, 0xf6521e27, 0xcb784baa, 0x8b9f4149, 0xbd984b6a, 
	0x868f0847, 0x3452d55f, 0xa8ccc088, 0xc4223da6, 0xd05f81f7, 0x5cfdb9eb, 
	0x8f6d2f36, 0x383b27af, 0x99c789cf, 0x1be9260f, 0x789dd3ea, 0x5eeed7b7, 
	0x40dc7f78, 0x899f3639, 0xf189cf34, 0xd668ccf8, 0xa463bcc2, 0x8d73dbf6, 
	0x433bf25d, 0x32b80bf5, 0xbb733862, 0x463576bd, 0xf2bbe9cf, 0x44544ffb, 
	0x3b1d15bb, 0xcb5f5d14, 0xb4c8e5d3, 0xdf70a62f, 0x94ad650c, 0x6cfffa0d, 
	0xa2aef181, 0xf4d7f527, 0xeb79973b, 0xe2d1179d, 0x2b979a22, 0xa647ae97, 
	0x22d7a1fd, 0xb1919bb9, 0xbcf61f1b, 0xc4b3417f, 0xb45379f1, 0x4efde6b8, 
	0xb7da32e1, 0xc8ccee48, 0xa307c682, 0x5fb9f7f9, 0x1913bd1e, 0x73f51fea, 
	0x6a5fe906, 0x6f68f400, 0x1b3d01ec, 0xf17ab9a2, 0xddf7be1e, 0xf6c3fb23, 
	0x83f10e73, 0x688cf5ec, 0xecf82367, 0xbffaa5d2, 0x27da3602, 0x52f40b4d, 
	0xdfa6473b, 0x7ffa2aff, 0x577b7c12, 0x9e4b63d1, 0xfca61b0e, 0x0ef18161, 
	0x0bdd3bde, 0xe530d93d, 0x2b5394a4, 0xd86a7011, 0xfb8abf4e, 0x0f5237e5, 
	0x595c26ee, 0x3283ded1, 0x9f3d03fa, 0x8b976dd1, 0x6b4c4255, 0x633d7a96, 
	0x7613f11b, 0x05aaf62b, 0x9248cffa, 0x76a16dd5, 0xfcb1def1, 0xebde267b, 
	0x73defd1b, 0xc19b4bb3, 0xddfc51a7, 0x939bf92e, 0x496b2333, 0xc38a6a39, 
	0x3abc870f, 0xfff8788f, 0x275edec4, 0x1ad8fa09, 0x9918a921, 0xc62e67b3, 
	0xa952e33b, 0x7962f30f, 0xe9df823d, 0xa5a0de1f, 0x6acc8f08, 0x1cc9ea5b, 
	0xc87e27a9, 0x2f1a957d, 0x924e7ee4, 0x85c67ee5, 0xa15faced, 0x2158efc6, 
	0x67b78fd2, 0x1c6cd05f, 0x9465d3cf, 0xc7d3db9d, 0xedf6ad76, 0xc0fe591a, 
	0x846a8e76, 0xd91cfb9d, 0xb2842839, 0xa4ab6573, 0x0b378b9d, 0xdc273f35, 
	0x745a8e01, 0xca58fe25, 0x1708709f, 0x37b57cd5, 0x03337a83, 0xa71cbdbd, 
	0x4473b428, 0x64b80d12, 0xc09eb13a, 0x1c03fb10, 0x2a47f0d7, 0x0bce5a44, 
	0xe6e5eed9, 0x3a2eca9d, 0x667c7275, 0xdf3af67f, 0x17abb290, 0x1f5c7b71, 
	0xe06913f9, 0xa58e1e9c, 0x291fad30, 0x1aff65ef, 0x03b842f3, 0xadaeaf35, 
	0xfd51fb09, 0xabff18a7, 0xeb94b8df, 0x3dcbf29b, 0xbf74b535, 0xa69b3ff6, 
	0xf4eba4cc, 0xe2537bc0, 0x4ee7ef84, 0x136a77be, 0x386c6795, 0xbf0c3531, 
	0x13b5b1f9, 0x569fe423, 0xc4c4f57d, 0x7e279528, 0x18a4ed6b, 0x7abf2795, 
	0xd7419262, 0x67df639b, 0x9cf3723b, 0xd5c56daf, 0xddb177e5, 0x57c6e570, 
	0xfc33637f, 0x1a97b26e, 0x498cdce4, 0x27f4f1fb, 0x3a366a6e, 0x41939e99, 
	0x5162eb17, 0xe881ff0a, 0x0f4fe5c6, 0x4c92dd11, 0x7dc608d7, 0x8f8a15db, 
	0xecc9ae99, 0x7f39d997, 0xba718222, 0x1107a374, 0x1fde7cef, 0xbf40a677, 
	0x32f62d3f, 0x5c8e893d, 0x0223f13f, 0x9ceab7f9, 0xae10ce83, 0x3f6731e2, 
	0xa49fe38d, 0x13d2e13f, 0x2be60971, 0x7afa817d, 0x4fa41f20, 0xbebb2265, 
	0xecb9908f, 0x3977ccd6, 0xc763d29e, 0x707df8d5, 0x38e7cacf, 0x96bf98dd, 
	0xf01aca9f, 0x9c552b3f, 0x876ff862, 0x91bc180c, 0x9f1b5f7f, 0xed7d2717, 
	0x47f01acb, 0x8fe9669d, 0x00223954, 0x2432b3ff, 0x956ab2f1, 0x0ab6b01d, 
	0x3faf01d9, 0x00f7ef8a, 0x4ffc8b03, 0x239ffa47, 0xbe9f95bb, 0x3f9dc9a7, 
	0xaae9fa15, 0x4cbc6d9c, 0x3aff03ac, 0xf6dd3f5d, 0xf1774fc1, 0x387e1cb7, 
	0x2ac8dfe1, 0xfa4d5e27, 0x8cb34f7b, 0xa528c18b, 0xef3b65de, 0xe7c8554b, 
	0x1bf283c0, 0xbf166b1f, 0x733c3b25, 0xb65ebf99, 0xbebfb166, 0x7f004c56, 
	0x37fd9edf, 0xb2d4478c, 0x3539e3c5, 0xd756f99f, 0x702abe14, 0x24bdd50b, 
	0xcf176df2, 0xbafe3ed1, 0xce7b653a, 0x16b3a05d, 0xbed2fcc5, 0x1df5c697, 
	0x9d8179ba, 0x42552e02, 0x74ffd83e, 0x2d9ed1ca, 0x1f8e32ec, 0x1e558926, 
	0x87d4a979, 0xb9fe51ca, 0xc291e6ae, 0x50f25329, 0x174bbf06, 0x3271f976, 
	0x3775c3e0, 0x98dc85ec, 0x9d0fdf7a, 0xd66f10ac, 0xe478cf3f, 0x79286fd6, 
	0x03598234, 0x76c223f2, 0xb37bda39, 0x7c791ffe, 0x73b64255, 0xbcfe9750, 
	0x587aa419, 0x2904c4fe, 0xca9eb2a7, 0xe29eb2c5, 0xbf59bd7e, 0xfb71eb97, 
	0xf7d25663, 0x8bfb4f61, 0xb74778e5, 0xec337aff, 0xa7f6a8cd, 0x31c9f7d0, 
	0xd651bfda, 0x1ffdba33, 0xf6b93d71, 0xbfda8aeb, 0xfff1bc71, 0x37f1ec7c, 
	0xadfed38c, 0xa87fb5e3, 0xe98bfdb0, 0xfda78cfb, 0xff6bc75b, 0xff6ec63f, 
	0xbfe8718a, 0xfffa3c6e, 0x5869ca46, 0xfb46184c, 0x5fe345cd, 0x4ffd1e37, 
	0xc5ff4d8e, 0xb516fc6a, 0x2cf8724f, 0x0ef166d9, 0xbdf527f7, 0x286ee114, 
	0x20ef737a, 0xf7f18eae, 0xf5454ed4, 0xae5c2dd0, 0x0a1e4675, 0xff6a7e63, 
	0xfe0bc54a, 0xf37381e3, 0x4e213ef2, 0x7fd18bd7, 0x066f5372, 0x1147089d, 
	0x8c732d27, 0x19577d0c, 0xfa678a6d, 0x0a5abf49, 0xa43042e3, 0x75199388, 
	0xbdd82e99, 0x6ed929f2, 0xaaa67087, 0x7d21ea92, 0x3874af2f, 0x45ab3e3e, 
	0xa710a7c6, 0xe3c2dae9, 0x14be61f7, 0xb7f1916a, 0x8d13faca, 0x28adf105, 
	0x37e687f5, 0x8fd47555, 0x7d4ca9e7, 0xaabea9d6, 0x13a3b086, 0x3f2b959e, 
	0x1f09fd10, 0x7d457d1f, 0x20d1bf5e, 0x21fd04af, 0xe11b69ba, 0xfc48b53f, 
	0xf60d3fa1, 0x0cbdf099, 0xc1197a7a, 0x1143cb01, 0x6740aa9d, 0xf1cb73d8, 
	0xfabb8ec1, 0xeba6c136, 0x95ba790b, 0xd9ba2b37, 0x7605b6b6, 0x5fa21ce6, 
	0xb6bf4f36, 0x4519fa22, 0x452a32f4, 0xb8faf40a, 0xf34997a2, 0x9b2f491f, 
	0x8b517dfb, 0x607e438c, 0xf445dd7a, 0x4869aba2, 0xd14db7ff, 0x267af8a7, 
	0xa22a2d7a, 0x7a2b6597, 0x7af9c9b5, 0x772ebd31, 0xf9b2d2e5, 0xe7a52afd, 
	0xce521213, 0xf22f40aa, 0xa96b8c83, 0x7f024fbf, 0x97a44e89, 0x4e929d95, 
	0x33928e77, 0x5f7d3ba2, 0x0522577e, 0xdd04c5bf, 0x3374f32a, 0xdba66d2b, 
	0xe56e8a3d, 0x95e7c721, 0xe574bfb3, 0x6e90a7ac, 0xdd31bbe4, 0x83f534cc, 
	0xa2b0a3fc, 0x2857599b, 0x3a2a7767, 0x44cf5f15, 0xba22ceb7, 0x6e8a1305, 
	0x59cb63ed, 0x25374732, 0xcad70a67, 0x16728593, 0x66e8ae5e, 0x672c7d67, 
	0x9cb2cd1f, 0xa8ce4155, 0xcb168f3f, 0xe7825d59, 0x9114e637, 0x228cdd02, 
	0xfaae3dba, 0x55942139, 0xd0facb74, 0x5bc9477f, 0x3a2de415, 0x3accde5a, 
	0x60f83749, 0x969997a0, 0xe4a09b74, 0xa74551ed, 0xa3d56be2, 0x04ab7485, 
	0xe9e626dd, 0xdd1158f6, 0xb7454942, 0x6dd36355, 0x596e8e43, 0xd6fdea5f, 
	0xf5c956a5, 0x8064c40f, 0x4578b9cf, 0x4552fad1, 0x4f1036c8, 0xb97958ae, 
	0xe75c61f0, 0x251dbe47, 0xbf229c7e, 0xce27b665, 0x15f83f8e, 0xbf49d755, 
	0x326eb87e, 0x9fc21baf, 0x2e7855e8, 0xf29c6dd7, 0xe12fc85e, 0xfc87796d, 
	0x381c732e, 0x9e16adff, 0xbc6ec157, 0x0827f5e7, 0x7ef23bdf, 0x822f6b83, 
	0x4183af0a, 0x17b42be1, 0x2427ae59, 0xe3ef3d64, 0xa1fcf02f, 0xf27dd95c, 
	0xeae5f607, 0xfb3d4129, 0x8a77605b, 0x380c13fb, 0x9e7dbbe5, 0x1bfc287e, 
	0x8d1f8fdd, 0xfc718fdd, 0x0b857286, 0x59bdedc5, 0xc0a5b07f, 0x1bf2296f, 
	0x478e3782, 0xb7634387, 0x50df8e3f, 0xed78eb7e, 0xbf6c2b1f, 0xde086fc8, 
	0xbffb5e3a, 0x6a8dfa61, 0xa1bf1c7f, 0xd1ffd95c, 0x29689fed, 0xfc8a5bf0, 
	0xf1bae086, 0x8eb5afe8, 0xbf22fe39, 0x9df95ca1, 0x2b8971a5, 0xcb8f0ae5, 
	0x52b8562e, 0x4932f8e6, 0xdbf846e0, 0x498fde16, 0xc5f5765c, 0xc3a4c86c, 
	0xf71ca5db, 0x896d4f42, 0xee4f34f3, 0x010b3d82, 0x826f485f, 0xf81a4e95, 
	0xd4ab4b72, 0x167b62e7, 0x52f8956a, 0x5c42c9fe, 0xbe24260e, 0xf695ae84, 
	0x712ed82c, 0x6f09fd19, 0x1febf42f, 0xb743efa1, 0xef19dc4a, 0xdcff6bb9, 
	0x9e17e5e7, 0x3dfab468, 0x4f7dc5f6, 0x77bf10e1, 0x50fffd88, 0x43fff4af, 
	0x27ffc796, 0x1d64217f, 0x043f7f62, 0xf908fefd, 0xe4b7e50d, 0x7f1719eb, 
	0x2e32bd92, 0x71fc067d, 0x176833f5, 0xf5d4a7f2, 0x0511ce2f, 0x24c509fc, 
	0x93f87bee, 0xfe3f8b1a, 0xffc65929, 0x7f7fc280, 0x7ff8c3a5, 0xfed8eb5b, 
	0xed2add86, 0x42d2e866, 0x25c7f7fc, 0x4b17027f, 0x2427f7fc, 0xff478ffe, 
	0x0fd28dc0, 0x09fca0f9, 0xfe6c617d, 0xeafb2b94, 0x90fc87f2, 0x62f58590, 
	0x7fca43f2, 0x3ffdfa35, 0x67680f95, 0x156479ac, 0xdfebc5d1, 0xaef9442c, 
	0x7de6997c, 0x75311f9c, 0x115bd3e6, 0xb33a9ecf, 0x53d9e39b, 0xf102dd43, 
	0x6673a9eb, 0xf9a01ea6, 0x06ebd4fc, 0x1da59b63, 0x13aeecab, 0x9104ce62, 
	0xb8defcc5, 0x2741352e, 0x13a9cf7a, 0x0bdbd0dd, 0x9dbbb0af, 0xb917c95e, 
	0xc65d33fe, 0x2e9d7a29, 0x8c7115d8, 0x83a26cfc, 0x16ee1dd1, 0x4de15384, 
	0xfae9ef64, 0xe334e695, 0x3619d981, 0xef105bb4, 0xac0a8a6d, 0x2e5d36ab, 
	0x75b22209, 0xc2fd93c0, 0x6b79e3ae, 0xd829e665, 0x6911cdd9, 0x52de6967, 
	0xeaf79de7, 0x11877d55, 0xf2acdbf7, 0x6fa5c626, 0xa207e378, 0x636dd96f, 
	0xd6bfd3cf, 0x077efd42, 0xce4232eb, 0x7f50a7d3, 0x1ef137ff, 0x788e3e74, 
	0x1baf9ca5, 0x4e98753f, 0xaf1a1cc6, 0x8a54b7c4, 0x2b74f2e8, 0xae79f9bd, 
	0xb8e22f6e, 0x7e463ed3, 0x5f3f1b4f, 0x7759b280, 0xe6c8af60, 0x3a27ebeb, 
	0x8f543589, 0xf7f0385f, 0xb887cfe8, 0x5380e85c, 0xf73d256e, 0x60cf097b, 
	0x349cdbbf, 0x8530def4, 0x1521fb8d, 0xa62e0997, 0x3efe29fb, 0xfe39219d, 
	0x29b7c2b1, 0x44f7cb37, 0xfe2348d2, 0xc3c2b2fb, 0x190bb729, 0xfdd28e17, 
	0x9ffb9eed, 0x3d55f756, 0x69232b81, 0x78877d4b, 0xfa8811b5, 0x986c6eb0, 
	0x8eb0868e, 0xc877b011, 0x6f4f38fe, 0xca1c40a9, 0xc7a43b48, 0xaa7afd93, 
	0x97cf32ab, 0x27faab1f, 0xce398a37, 0xf7762124, 0x93905d9a, 0x7ace35d0, 
	0xed42cd04, 0xfe377ace, 0x9f5e4426, 0xa91c544a, 0x91d59634, 0x2e7a8057, 
	0xee947ea2, 0xcd2f19d6, 0xdf5acddd, 0xd7407d10, 0xc9ff44dd, 0x8b1139df, 
	0x7b638f43, 0x097647d6, 0xc7f1b471, 0xd1dff1ad, 0x16b6ed7b, 0xc7ef22df, 
	0x67968d77, 0x9e8b0ed3, 0x0d38a95f, 0x9209d1e2, 0xe4795fdb, 0x56a1c556, 
	0x923cd357, 0x031d57d7, 0xca7c6ff2, 0xfb520d28, 0xebe8b546, 0x1b5cb24d, 
	0xaf77c7a0, 0xeae6fe96, 0xeb534d6e, 0x49da2665, 0x5ee57f2e, 0xf93265e0, 
	0x5d16bdca, 0xeadab757, 0xce426db9, 0x4fdcfcbf, 0xb72f80bb, 0x2e8bf6df, 
	0x11200be0, 0x99ed4bf8, 0x0eb7fcde, 0x7093a3b2, 0xa53b30bd, 0xd596e992, 
	0xe2fbb711, 0xb7fe8555, 0xb1f1263f, 0xf64ae474, 0x2c7e5d27, 0xf7fb285d, 
	0x5f25abf9, 0x5f395f4b, 0x4a8e48f8, 0x10cdb2cb, 0x4f0b8ea3, 0x9775e14c, 
	0x2b8f1976, 0x87d454fd, 0xd5abb6f5, 0x0dd75bfb, 0xbb8d3aea, 0x1ca07863, 
	0x4ac40ceb, 0xdf8d375f, 0x8217c57c, 0xfd1a6d7f, 0xff343287, 0xea75a8ef, 
	0x4c41a25f, 0x6393f438, 0xc75de261, 0x01f0675c, 0x5af96f2a, 0xf24ab1e9, 
	0x1344bf9d, 0x2937b820, 0x645310c7, 0xa1ff00fe, 0x9d94f61c, 0x4b8886b5, 
	0xc4c522bc, 0x471f7b77, 0x4bf10b9e, 0x4fefd907, 0x5f399f66, 0xe5970595, 
	0xfbfdca9c, 0x33ecf6eb, 0xdfe6d633, 0xe4bcefbf, 0x8bbf87a2, 0xcdb2f47a, 
	0xf4ed5702, 0xbf710b63, 0x3c0fcbff, 0xb5bef28d, 0x81f7ab0f, 0x26279523, 
	0x67d10088, 0x6b762592, 0x723e222f, 0xb8fc80da, 0x6f0f6beb, 0xf4186798, 
	0x6390d6f2, 0x8f93d0bc, 0x1e694797, 0x495779c8, 0xacf71f19, 0xfd72eb9f, 
	0x5c79b85c, 0x8e5fff1c, 0xa949c932, 0xbfb0078a, 0x83f73cf4, 0xf5dd81d7, 
	0x7403f255, 0xc7c7a1c4, 0x7cc14cc1, 0xddb36b63, 0x54587ec7, 0x66d99e70, 
	0x35d627e8, 0x22223392, 0x6987d5e5, 0x90649fdc, 0xdf47d058, 0x71cfaa3d, 
	0xed7d651e, 0x5c96a303, 0x3ac4f325, 0xb7519008, 0x393d2519, 0xed27a3d7, 
	0x9b23b8f3, 0x129e7af3, 0xea4cff88, 0x62373d62, 0xe08f3d39, 0x974e573d, 
	0xd33275ab, 0x5b22d16a, 0xc1173b64, 0x61a5133e, 0x96c193bf, 0x58f50448, 
	0xff5eb32f, 0xbc61c91b, 0x0bae3473, 0x4e99d6cd, 0x5cbfea51, 0x0a75e0d7, 
	0x9dc724c8, 0x0fb496c3, 0x1d0cca9d, 0x7cbc2f9c, 0x7d37e014, 0x22243abf, 
	0xadedc229, 0xc34baf5b, 0x017950ee, 0x2acec1ca, 0x6928ff5e, 0xdd81d237, 
	0x2b89f6f4, 0x891fbe0b, 0x437e85c6, 0x6eadfebe, 0x7af101bc, 0x349163b6, 
	0xa9725cec, 0x321d6348, 0x17a42ebf, 0xb91dffc6, 0xf94db01e, 0xaded25cb, 
	0xe46edf09, 0xffb846c5, 0xb101e776, 0xa15bda9f, 0x9c95a5ec, 0x2e3eb3d1, 
	0x5109ebf2, 0xcbcdda5d, 0x744244f6, 0xbfb9fd5d, 0x3779067a, 0x0a8eb0bb, 
	0x1644b479, 0xfbe688f6, 0x9d3236fb, 0xefac59b2, 0xe008f9b9, 0x581faf2d, 
	0xe3fc40c2, 0xfacbb4c8, 0x4648ff10, 0xa8eec6ed, 0x634b8f37, 0x7e264dbe, 
	0x9f33a47c, 0xd3de606f, 0x60f8013d, 0xacbe5ff8, 0xda7f7c1b, 0xc17f2208, 
	0xd4ae8678, 0x8c16f24f, 0xb9b1b514, 0xbcc4d07d, 0xe390a1f5, 0x9608847f, 
	0x3a48ecb4, 0xbdbaf1c9, 0x2ed96ea9, 0xf964b2fc, 0xdb6d97cb, 0x0338e4a5, 
	0x55d0fb3b, 0xfadb0758, 0xcd8f6931, 0xe0fa27d0, 0x9034742b, 0xf3e4cd7d, 
	0xf55c6867, 0xccca874c, 0xe3e3e0b3, 0x58479e6e, 0xb3e517d4, 0xb3e417d4, 
	0xce984bc4, 0x23ecbfd9, 0x8ffd851f, 0x1eb8c77f, 0xe341ff87, 0xd72859a8, 
	0x672f49bd, 0xebfacbbd, 0x31b53acc, 0x8db07f2f, 0xe47b373d, 0x3af5292f, 
	0x62f949aa, 0x725219f9, 0xc5b57901, 0x6345a933, 0x3f1143c8, 0x58a3e58b, 
	0xdcf95d9e, 0x86eafe4a, 0x0cdc9517, 0x8e013929, 0x2beefe64, 0x259b6f68, 
	0x6e4ada32, 0xed16466f, 0xfccc5784, 0xa5e72f49, 0xfbff2da4, 0x8fb64ae0, 
	0xbf95c571, 0x8557fd71, 0xa983887f, 0xf1318c75, 0x88505ecf, 0x0f0acd7f, 
	0xfe8ff18b, 0xd9c4a77c, 0x45e71ee3, 0x08ee1f11, 0x79c362eb, 0x447be863, 
	0xb095bcc8, 0xfd30b6d0, 0xc1ffce6d, 0xbfd32ada, 0x4585bf48, 0xdfef427a, 
	0x04bd0ce1, 0x161d5df9, 0x9c159d53, 0x4c68e377, 0x9aabd247, 0xf5c8f4d1, 
	0xf9f7cdcf, 0x87df325f, 0x7c761cf1, 0xf39217c4, 0x47cb2cf4, 0x73924ac7, 
	0x7eba6796, 0x4927ae8e, 0x0eb2a9ce, 0x6e1c1715, 0xe8b3e03c, 0xdf37d5fd, 
	0xa0245bad, 0x6061b0e9, 0x6915d85e, 0xc71a2c35, 0xf8ffca39, 0x0160b992, 
	0xb62d8bfc, 0x803673ed, 0xbc11ad56, 0x9f0cb297, 0xc91bc725, 0x0f90b8c8, 
	0x07c3fc7e, 0x56f4267c, 0x6174e19f, 0xeb0cbc9d, 0xe61be087, 0xc7123ef3, 
	0x419a2d83, 0x867727cf, 0x8b9c0aaf, 0x9f7a7675, 0xde049bea, 0xa4cd7d10, 
	0xb21d19f0, 0x3a3b229c, 0x5a7a12c1, 0x3352773e, 0x0fa53be9, 0xafaa37cc, 
	0x267926da, 0xa36c143b, 0x46b654fb, 0x89c0425a, 0xbc7cc749, 0x236d6c6e, 
	0x973a217d, 0xdeea7d92, 0xf529798b, 0x9e7c88e7, 0x1ada1c22, 0x3ef1d2ec, 
	0xe867e7db, 0xa4a8e239, 0x7c8713f7, 0xdb179e06, 0xec8c50e9, 0x6937b51c, 
	0xd1ad2068, 0x3a21bff3, 0x93d7e045, 0x68bac1bd, 0xb4d2b328, 0x537b8c52, 
	0xf30347c1, 0x093f7a4d, 0x6b70873f, 0x16513670, 0x7ffefdfe, 0xc5dea1f1, 
	0x72ca3f53, 0xf0563492, 0x85f130fa, 0x38f4c3fb, 0xefe9e1fa, 0xb7a5cfd2, 
	0xbd0f0fcb, 0xfcc59e99, 0xf2efe971, 0x0bcd0267, 0x9e8a1dd3, 0x428e824f, 
	0xe5243eef, 0xa3b8eb06, 0x7e2311f8, 0x37d3cf2c, 0x9477f344, 0xf4c3f98b, 
	0x1fcf24be, 0x68d0f7a6, 0x812e437a, 0x21ef4cbb, 0x51c09f29, 0xe28b63e6, 
	0xa0f5d91f, 0xa1bfeb10, 0x33ddaae2, 0xc4d2bf90, 0xe4e3a676, 0xb0e73eb2, 
	0x4f128bd2, 0x8b8d305e, 0x1ef1f4f3, 0x75e479fc, 0xc94bfd10, 0x84aff2e1, 
	0xf75840df, 0x64ab8e4d, 0x1d7cd5b5, 0xad7046d2, 0x86d1f392, 0x1f204726, 
	0x23b7f957, 0xf5dcf94f, 0xf90473e3, 0x502f236f, 0xb3abd799, 0xe1e008e7, 
	0x69f3dcbe, 0xb9c7fcfc, 0xdcf0d3e7, 0xfc10efd5, 0xbfb289e8, 0x57ea57cc, 
	0x527cf886, 0x7e3e7fcd, 0xfd6ac4b5, 0xd557b205, 0xe677be34, 0x6fc8078b, 
	0x409098fd, 0xb1d5bab6, 0xdfb6bf5d, 0x69a26b83, 0x73dc3b7c, 0x6ede27bf, 
	0xe3ecf82c, 0x47fe6fd2, 0xdff42be7, 0xf1d77d04, 0xf0bbf67e, 0x536491fd, 
	0xfdcfd1a3, 0x81bcc9f6, 0xc777cb08, 0x10bb87c9, 0x94eb29bf, 0x4590a2f3, 
	0xbd4668fe, 0x5beabc8f, 0xde6e9e89, 0xc8e2c934, 0xf63e9761, 0x3bdfa674, 
	0xd3b2fd2e, 0xe1ba7e99, 0xf3f28f3e, 0x1e7dc34a, 0x7d2ff3c5, 0x1d059a36, 
	0xf9956ddf, 0x71fdc5fe, 0xa0fff1fb, 0x4a968fdd, 0x8377347a, 0xf267ed7e, 
	0xd7e90a7f, 0xeba6d991, 0xe11fc819, 0x7e2aae15, 0x9f195ee8, 0x00cf5c68, 
	0xaa0e4877, 0x2b574e15, 0x39f4967f, 0xfa54e3c0, 0x08f8213c, 0xa1d38bfb, 
	0xb9724fcf, 0x70cbee5b, 0xf043a002, 0xbc023b29, 0x0e506100, 0xf09a4cad, 
	0xdf41a6f3, 0x4e104711, 0x96487ba4, 0x9d351791, 0x74f38670, 0xd127be94, 
	0x6c53f62f, 0xb5eb6fae, 0xda2f9909, 0xb8c9ef46, 0xa2fd9fbb, 0x9e5da5fb, 
	0x7d263d06, 0x1efa073f, 0x9e71ba67, 0x1fb9e912, 0x162bb0eb, 0xa44d7dca, 
	0x7de87ee7, 0x20f1a6c8, 0xec21ad8f, 0x38ba3e03, 0x17d931db, 0x36c98b98, 
	0xe7c84fd9, 0x3d336bd6, 0x3bfc2f62, 0xc83b07d1, 0x1df023fe, 0x8d9413f1, 
	0x9a60a44f, 0xd8717f37, 0xffe0a58c, 0x587190fd, 0x3fbdd113, 0x7c546211, 
	0x2f9d9465, 0x7faee3b2, 0x87f5dfb2, 0x76c4ff5d, 0xf3b211fd, 0xa43f791d, 
	0xff32d85f, 0x6bc7fe09, 0xb0cffa42, 0xfe6493f3, 0xbbf95092, 0x710f1b47, 
	0xf67f36bf, 0xfcfd8c54, 0x05d3c206, 0xc622de72, 0x3ff44fd8, 0xf33f95f3, 
	0x7676257c, 0x91734778, 0xffc7c3b3, 0x9c3f73f1, 0x9676db9f, 0x12cfb17c, 
	0x754df777, 0xc7a56380, 0xf43d14ae, 0x9b81dade, 0x7da38852, 0x4e6d9431, 
	0x5c741e11, 0x82cf185a, 0xeeb0b63d, 0x14ec99f0, 0xfa0bbeef, 0xf76c4fae, 
	0x6e14cfc4, 0xaabd8d1f, 0xdf177f23, 0x1dd3ef21, 0xa867c767, 0xb72203de, 
	0xf6f482af, 0x521dfaac, 0xf2c3a0f6, 0x9f442205, 0x022bd5e5, 0x84ddf435, 
	0x089e9975, 0x32ebd1e6, 0xe2e108e9, 0xe387d85e, 0xbc4a1f6c, 0x5ac75efe, 
	0x67ff01a1, 0x166f7f29, 0xcfe3ddf0, 0x60af8e31, 0xbc812cf9, 0xc0971e11, 
	0xfe57ae7f, 0xba2fd060, 0x97bf11b6, 0x2311dbb7, 0xa2a7ef29, 0x03845faa, 
	0x5a3f29e7, 0x7bccb760, 0xfc803b79, 0xbd47c837, 0xd3d2ebf2, 0x2e8659e7, 
	0x2efe3df1, 0xb097d3af, 0xa9888a9d, 0x745e93cf, 0x68945684, 0xf1bd3c72, 
	0x528e3cbd, 0xffa39daf, 0x1a8f4296, 0xce0e8e31, 0x50208923, 0x49fa2177, 
	0xd4046ae3, 0xfc45c67b, 0x1cf1f7e2, 0x837749f2, 0xa1d53b5e, 0xfa0173c6, 
	0xb5f54fdf, 0x8744f7d1, 0x7edfd10b, 0xd63809e4, 0x77ee75d7, 0x7ccea670, 
	0xee443b63, 0xe6f82973, 0xbae0a9da, 0x838c26cc, 0xb90a5ffa, 0x77ea6c37, 
	0xc54b0d15, 0x942c8f81, 0x4f6b62fb, 0xd614b567, 0x1c65aab7, 0xd285adeb, 
	0xf8a8896f, 0x2b56a06f, 0x540b3d85, 0xc15e3967, 0x09744fb8, 0xe39b7dd4, 
	0xb7e881c1, 0x981c1e39, 0x7f872a9b, 0xd2d1125d, 0x80c7c201, 0xdc70638a, 
	0xf419c640, 0xa328fd82, 0xe65641ec, 0x6d4188ff, 0x78238d23, 0x75362c20, 
	0xb62d7fb0, 0x9eb4737e, 0x027f981b, 0x120b23af, 0xa8e3a63e, 0x28af83f8, 
	0x8c2be0fe, 0xa1c6083f, 0x880e6bbd, 0x7917d52c, 0xf066ed75, 0x79c28279, 
	0xeadc4c3d, 0xbd78e3c8, 0xd83d33a1, 0x9f6094ae, 0x97737f54, 0x9e32edc3, 
	0x725c40cf, 0x7ebf5e6b, 0xb8d4e2ae, 0x033dae22, 0x478e4571, 0x8ae3977e, 
	0x7eb97a81, 0xbd8f8810, 0x8beee07e, 0x2d1cc7f2, 0x41eb2152, 0x5c7fd15c, 
	0x6f1c1fad, 0xee30fad6, 0x1faf3ae3, 0x106eb004, 0xf9ff1d83, 0xf1d938c2, 
	0x8bdfd319, 0x3cf10fc5, 0x002f8b50, 0x41fae49f, 0xb8e1ddb1, 0xf183e117, 
	0x79973db1, 0x65603df5, 0xf3f534b5, 0xdc4a176f, 0xdfd87bc0, 0xc5b6f782, 
	0xbc683d14, 0x4d7b2233, 0x7f54e88b, 0x391e96f1, 0xedeecc2f, 0x14c2f395, 
	0xa173b8f8, 0xdd3fbb8c, 0x22167ffa, 0xa2335eef, 0xce7bf629, 0x7fb0e7e0, 
	0xebe8a1d3, 0xec31d1da, 0x1fcf2ba6, 0x3cf2936b, 0xf66d6e5a, 0x5f0e58c3, 
	0x944f9f03, 0xbcaecf82, 0x7ee3909a, 0x8e4983c4, 0x2b72f3fb, 0x946d37e0, 
	0xe4e23b72, 0x921289fd, 0x9e6907df, 0x1c9b4976, 0xfd94e417, 0x2fb63814, 
	0x76b69c12, 0x2edf9ce8, 0x25e8355a, 0xc95243eb, 0x6fae31e9, 0x1667fb1f, 
	0x31ea82d1, 0x126a75dc, 0x18e66d4d, 0x70df8174, 0xaddfdf88, 0x5b392b0d, 
	0x64bfe4ae, 0xb95cdd34, 0xdca03fb7, 0x4bb5c697, 0x54138380, 0xee58ad9c, 
	0xbf0c4eb1, 0x0bbc84d8, 0x278fbc8f, 0x4d8724cf, 0xb1cb47bb, 0xf8887249, 
	0x3ac3ea38, 0xe3e9d198, 0x677f6975, 0xcee39497, 0xf4376d16, 0xf1caee2a, 
	0xfeb0da47, 0x19b1cae5, 0xc6397f7d, 0x4a8e7b50, 0x225f48bc, 0x06740fe5, 
	0x4b0fd6bf, 0x7cb94afd, 0x405c461a, 0xe7f335ca, 0xf53f9e58, 0xa9e59f86, 
	0xb6ac92fe, 0xbdd9f951, 0xf21a8e92, 0x5cb4ec19, 0x92bdfb77, 0x5ff280eb, 
	0x17902e98, 0x07d53067, 0x4c1a1db9, 0x9a345eed, 0x5c93669f, 0xcfe51baf, 
	0x9110ebba, 0xe3f3b9cb, 0x5ab87bc9, 0x05fb37ee, 0xf113bde4, 0xc3f79268, 
	0x7074dc42, 0x8e0c34df, 0xfc1440ec, 0x2be5bc0b, 0x71721d85, 0x034d73fb, 
	0x0fffc2e7, 0xe5997e1c, 0x32f4303d, 0xeff63bcb, 0x64f9a71f, 0x5354fc40, 
	0xaaa7e6fb, 0x1f721c7d, 0x09575aa6, 0xf75ab344, 0xd57e58e7, 0xce54ecf3, 
	0xf9a26dc7, 0xea475d2c, 0x4b88ffa9, 0x3f82bc1c, 0x29c949be, 0x392ad5fd, 
	0xe01fddac, 0xdb816aef, 0xe7ebf5d7, 0x7fd73fa0, 0x1139dd6b, 0xabc37fba, 
	0xd289cf27, 0x5cdf2ff5, 0xd7462d37, 0xdd61ff4f, 0x7eba26f4, 0xa71fc276, 
	0xf9704723, 0x34a397f4, 0x6d3d1777, 0x65671d72, 0x56e795e3, 0xf17c3953, 
	0xf48c9f1f, 0xf2c57b52, 0x23c92178, 0xf84a3ff4, 0x53927eca, 0x5aa6af80, 
	0x253e4d9f, 0xe03f90d2, 0xeb252464, 0xdf2ece07, 0xa075abaa, 0xc02f38ab, 
	0x79a7086a, 0xb30ec83d, 0x4c5d655f, 0xcbc99cb8, 0xe936f1eb, 0xccba38e7, 
	0x9b66f9e3, 0xbacea3b4, 0x88f326ac, 0x4f18fe48, 0x44078a84, 0xa4855d15, 
	0x7dab66ab, 0xabeb0e89, 0x9637771b, 0xa7c42e8a, 0x0f44fe98, 0x14fce4e7, 
	0x4de3979e, 0x7d553769, 0xa3cbdf52, 0x8fc44784, 0xb63e83b2, 0x79f626c3, 
	0x98bc64af, 0x4426fa82, 0xc1e606a3, 0x125b0765, 0x6263cc3e, 0x536e4f52, 
	0x11230beb, 0xe3e7fa4b, 0x1f08dbcc, 0x71875f78, 0x33dd3445, 0x171c8634, 
	0x7688cbcd, 0xe72ed853, 0xef0a68f1, 0xe8f171bf, 0xbd23c480, 0x7607ce53, 
	0xbc27dc29, 0xdc1e12ed, 0xc4b5e777, 0x1e1cc744, 0x4454fe63, 0xe9d04ab7, 
	0xa49d2f3d, 0x29f4bbfe, 0x2b589ba6, 0xbd30f9f7, 0xcef2f306, 0xd3cfeaf4, 
	0xe8b4f989, 0xe97274cc, 0x4ce1f2e3, 0xe4fb2274, 0xa621fb53, 0x033bbdb0, 
	0x497f98dd, 0x468bb7c5, 0x8579f1d3, 0x5cbf2e6f, 0x68add73c, 0xcf96fc17, 
	0x08e30618, 0xe1ec1be3, 0xc109e9bb, 0x9733a4a4, 0x9594aa8d, 0x936d3d25, 
	0x2667cc7e, 0x6cf39b0a, 0x3c5306ea, 0x708a7b6f, 0xcae9232e, 0xfa67a6f6, 
	0x19dd7e98, 0xc5e14ef1, 0xb4777878, 0xc436ddf1, 0xe5fa6e25, 0x584b8e49, 
	0xca022475, 0xe12e200e, 0x9b05f6e8, 0x376afe38, 0xfd4d3f77, 0x8dd7fb52, 
	0xa61c6577, 0xb34ecebf, 0xbe8ed9fe, 0x77ebfd11, 0xf2639c74, 0x17e415d4, 
	0x09e217ec, 0x134b5c77, 0x0d25252c, 0x7373d609, 0x2781c491, 0xaa5fbed4, 
	0x8d7ec520, 0xef10a763, 0xf73cfd76, 0x197951fd, 0xff5f726d, 0x47ccf413, 
	0x9870417e, 0xe9c20ffc, 0x026c4827, 0xc09fe764, 0x9ce5e1be, 0x0eb851bf, 
	0xa49e707d, 0x47bccd07, 0x671f2282, 0x6a7da8b1, 0xd6a12477, 0xeb946ef7, 
	0x7a535f7b, 0x60d0725b, 0xcbadcb39, 0xdf82c491, 0xd7ddbaee, 0xf51ffad4, 
	0xfd68a1b5, 0x7ebbc1b0, 0x9e3ade38, 0xe20b0e47, 0x7d7ec526, 0x05f3ee2e, 
	0xe8522ff2, 0xa9cb2b57, 0x57a78ebb, 0x6d886aef, 0xff3e3d62, 0x7f7f20dd, 
	0xeb2a29fe, 0x4bd22701, 0xae9c27d7, 0x9baf9859, 0x1b7adf27, 0xa61e247d, 
	0x4fbd36bb, 0xb1b6213c, 0xce967ce0, 0x845f2f1b, 0xacc6507d, 0x41d841a6, 
	0x2dde3ea3, 0x34e5dc64, 0x1a0eebf4, 0x479b86d7, 0x271ba9cb, 0x331a23b8, 
	0xcb47faba, 0x10ae2e6b, 0x5931ea6d, 0xfdc2ec4f, 0xe71961f6, 0xf8e9a3b9, 
	0xe2ebc04b, 0x6aeac238, 0x9c632f99, 0xc93f2c32, 0x4b16a7e5, 0x16fe957f, 
	0x33ee9700, 0x7da96a16, 0xd9fa1788, 0x5b11125f, 0x50fa42db, 0x19e658bd, 
	0x6c87950a, 0x729465bd, 0x67c554dc, 0xd55bba5c, 0x77e72762, 0x88b3ae21, 
	0xb47477f3, 0xc2ff21a7, 0xb72e07e3, 0x1e763e25, 0x9d3cf996, 0xa79f3243, 
	0x4513fe38, 0x24e1485c, 0xf777ebea, 0xa649ccb9, 0x3f4b5e71, 0x8a26eef2, 
	0xe72879dc, 0x8971512c, 0xfa2fd225, 0x1b8962f8, 0x7c06a81b, 0xcfa566b7, 
	0xafd87f82, 0xebc7df5f, 0xb2af33ec, 0x87b7e3a0, 0x87bd3e9d, 0xd23c9bfa, 
	0x21c99b3c, 0xf9f9f1cf, 0x97cfb922, 0xa69fccfe, 0x41e61fb8, 0x7951aeba, 
	0xf0a7b08f, 0x0cc7d78b, 0xedfc4c23, 0xe11ab789, 0x53beb90e, 0xc5abf581, 
	0xafd5de72, 0xd79bb97f, 0xccff9471, 0xd19ad6f1, 0x8db3abf1, 0x6795095b, 
	0x2441d2ef, 0xbefd8d6c, 0x66edada8, 0xe37a9379, 0x2b8f4ffa, 0xae8cc87f, 
	0x3314c0d2, 0xa3eafc48, 0xaeb91cea, 0x7922e4f3, 0xff88c62e, 0x781c02ca, 
	0x98d7e73c, 0x9d33813b, 0xece9afca, 0x46f352ed, 0xda31ae9c, 0xca7fe9af, 
	0xb35f83ee, 0xc2d4b446, 0xf0fd41af, 0xf22a9fbb, 0x121a3a6b, 0x8d77a87d, 
	0x39e32555, 0xbf022fba, 0xccbc53a6, 0x4bd5cd7e, 0x8bff7c64, 0xe2f382e5, 
	0xaaabb8ee, 0x7780eb0f, 0xe2762c5c, 0x2a4e955c, 0xc7e33387, 0x6aaf3987, 
	0xb2abe548, 0x01e32c9f, 0x47098bfd, 0x487966df, 0x40f8de59, 0x399fca54, 
	0xe1279e85, 0xbdb157cf, 0x30bde936, 0x4c4cbbe4, 0x71e6f54d, 0xaf65e78e, 
	0x4f92b9e1, 0x497031e0, 0x17189bcd, 0x84ffaa93, 0x0f11abbf, 0xb9c0c676, 
	0x5a7b5c22, 0xdc5d83c5, 0x1741c62a, 0x8c68acd7, 0x25b1c1e3, 0x0e395e52, 
	0xf81c441c, 0xcf31b38f, 0xb8907924, 0xb878867d, 0x6518f7eb, 0xfed482f6, 
	0x1233f8d1, 0xf3c17f23, 0x4d3e2e7d, 0xbafdb8f3, 0xd27ec0f8, 0xec8b8c1a, 
	0x377a9af1, 0x188d987e, 0x394f278e, 0x2b86e32a, 0xe5f77790, 0x5b2ffcbc, 
	0xe959f4a2, 0x17ac0af5, 0x28ad9e92, 0x3d43b6cb, 0x38abd4d7, 0xee4ae465, 
	0xcb17d7e0, 0x4796683c, 0xd60d6f7a, 0x3bff49a1, 0xbd9d8b16, 0x720377c4, 
	0x29cee541, 0x771a2654, 0xd7031e93, 0xe89f833a, 0x6c7be8b3, 0xf30eee91, 
	0x05756fbc, 0x6a6b63f9, 0x4897c19d, 0xfa1f96fe, 0xad152dc6, 0x64eb9e54, 
	0x86f2a41e, 0x4b76ddaf, 0xe3e720d5, 0x9d91b685, 0x310dc54e, 0x873f93c5, 
	0xce9f37b2, 0xe3e71589, 0x28fb7f69, 0x7ada5baf, 0xcff7ca92, 0x767ebd6a, 
	0xa1ddae2b, 0xafefaa6a, 0xdd456437, 0x64f7bc42, 0x18c0a1f0, 0xb9e71dcf, 
	0x17bdf506, 0x132bee2f, 0x206fd80b, 0xaa7ec03c, 0xff1c292f, 0x802fa992, 
	0x1d6e311e, 0x48b5b852, 0x3cce13e2, 0xfe4d7e02, 0x8b3510a6, 0x83ae9e25, 
	0xe8cf782f, 0xac0ee9f5, 0x3fbf11a7, 0xbccab46f, 0x8bd930ce, 0x06ed82ed, 
	0x62ffd0f2, 0x5c61c491, 0x9e7e3ed5, 0xd7c89977, 0x57305920, 0xb0217b4a, 
	0xb9e49bcf, 0x21fc81b3, 0x49e74be2, 0x79d373f2, 0x3b60dd7d, 0x1fff58b5, 
	0x16a0759e, 0xb3c31b79, 0x7ef09132, 0xe802dba6, 0xae4eb253, 0x55a23bef, 
	0x65281c43, 0x18b54eb5, 0xa32d6cff, 0x475893e6, 0x57c07f5e, 0x9ba8f98b, 
	0xb073d16f, 0xce7116a5, 0x21e5d624, 0x54ecb107, 0x5e9407e4, 0x59211437, 
	0xfbb97716, 0x759c55bf, 0xa996aacd, 0xbb80fcde, 0x28701f91, 0x53006f9f, 
	0xe480fc87, 0xde411136, 0xbb51edf7, 0x7712f916, 0x8d226f22, 0x9f39017c, 
	0xfaa75c65, 0xe38f888c, 0x823e6eaa, 0xf9720621, 0x772f8819, 0x43fbd034, 
	0xa3027cf9, 0x6571c7cf, 0x98a35f37, 0x011e6e1f, 0x16ec0be7, 0x2ff100e2, 
	0x70d11772, 0x94067df2, 0x07c0aff1, 0xef3b87c2, 0x29d599f4, 0x63f75b91, 
	0x1e422e3e, 0x864fcd2e, 0x7f049d94, 0xe09a5b86, 0x2cbdb017, 0xe3ed5e41, 
	0x4f537605, 0xa02efafa, 0x4e1b566a, 0xce9fccb3, 0x6af8071a, 0xd331079b, 
	0x1ae7e9f5, 0x7d2f9fa0, 0xdcf521ae, 0x8366dc44, 0x95b0be70, 0xd6f6f8e3, 
	0x9543f0cd, 0x461fc0fc, 0x9d7f701e, 0xa966f548, 0x9de10d3f, 0x52fae116, 
	0x27ec4725, 0xa2ac1e13, 0xc0a47d71, 0xc1f7a62f, 0xc0a44767, 0x3bfe5767, 
	0x613bc2eb, 0x123ed85f, 0x1f03fadd, 0x95b9e4d5, 0xe6e19fae, 0xfabf2be3, 
	0x5bdfcd98, 0x21e8954e, 0x8dc2f87b, 0x9e462f77, 0x7953159c, 0xf1bb57f8, 
	0xff1fe505, 0xb087e299, 0x7837d8db, 0x3b65da64, 0xb13bff61, 0x5defd1ee, 
	0xdfd9d0f7, 0x6aa7fea0, 0xef735c64, 0x073845f6, 0x0eda9b24, 0x058a89fd, 
	0xa71c69db, 0xf93b4b17, 0xc84236fb, 0xa95ce0df, 0x17e446a6, 0x8cb939af, 
	0xf6ba5df7, 0x2d40cc99, 0x57381fe7, 0xff9c1a36, 0xf9bd6a21, 0x6abd9d01, 
	0xff2be9bc, 0xd301f9bc, 0xe7816467, 0xa5efa847, 0xdb3fff9d, 0x2836b23d, 
	0xef3f67e7, 0x20e2467e, 0x976903ef, 0xa2463efb, 0xa26f4c4d, 0x97ce4ed3, 
	0xfd030a89, 0x2d0fc5c9, 0xf065f321, 0xc5bb8c5e, 0x5b4432f9, 0xd4c197ce, 
	0xe984bb4b, 0x4c9e459a, 0xab32f918, 0xf2abdae9, 0xcf2ad265, 0xcde7fa22, 
	0xcb915997, 0xcc9a1197, 0xe6061197, 0x4916c785, 0xc606ff9c, 0x65f39c79, 
	0xc2673852, 0x97fe677c, 0x7cdcce70, 0x30a709d8, 0xa65705ff, 0x26ddfc0b, 
	0xbef71749, 0xc8695569, 0xec2358cb, 0xac65e45a, 0x3ed8fb09, 0x25c657bb, 
	0xc5c1c7ea, 0xd1632f32, 0xb8afa962, 0x17751e22, 0xeb3c32f2, 0x2437776e, 
	0x32f37a76, 0x73080cee, 0x9ac5e10f, 0x81530375, 0xebc542cf, 0x1efb83a6, 
	0x21bbbcbc, 0xd31bf9c3, 0xedd6bad4, 0xca1913c8, 0x867467e7, 0xf9ba3e25, 
	0xaa9b1d18, 0x60a2dcf8, 0x20ff4ba4, 0x9f5418f9, 0xafc275f9, 0xf8c897bb, 
	0x3cfa7a5e, 0xf78d4cff, 0x779cebc9, 0xc8020625, 0xdbf62abb, 0x9c146cef, 
	0xe9b1d18f, 0x5f3e1e91, 0xbab84c27, 0xf9fdecf1, 0x3dc245ee, 0xe6f34017, 
	0x6fc275cf, 0x39fc8dd9, 0x1e10d99a, 0x7837be89, 0xa1f5b51e, 0xb3a38f08, 
	0x01cfe65b, 0x4d07101f, 0x75477e62, 0xf2944b6e, 0xc4fafdfb, 0xe3ef4c83, 
	0xfc72f7a7, 0xc22faaa5, 0xfc8d8afb, 0x13c84af9, 0xc6969d36, 0x1fb2fd6d, 
	0x9d107dde, 0xea4c7f0a, 0xeca4dcc7, 0xf02fa5d7, 0x7ec34c3c, 0x9912c891, 
	0x9b383807, 0xd1dbf5fe, 0xcbf62bfd, 0x8e76df7f, 0x745d57ec, 0x3877c301, 
	0x87cef29b, 0x17e5d0ca, 0x7964fd15, 0x53798fc8, 0xefbf4ecc, 0xe8b1e13e, 
	0xf9d87249, 0x675e16f5, 0xcb577a79, 0xbbce3577, 0x4b50f391, 0xce64279d, 
	0xacf6cf5c, 0xd89d12d4, 0x3afab09f, 0xfde9cff2, 0xee7526b2, 0xae373aac, 
	0xfdd9c553, 0x92a69271, 0xf6dcfd3c, 0x74912e57, 0x3fcd417b, 0x02e1c247, 
	0xaff5db7f, 0x633b8fe1, 0xefd9e5c4, 0x679381c6, 0xa67fbbf0, 0xfcf1b1fc, 
	0x348da3ef, 0x3efa22d3, 0x47994bfe, 0x85a9b1d3, 0xb19d55e3, 0x1e71eb3d, 
	0x1fca93f0, 0x9b60e1cb, 0xb2b93fb4, 0x06b877da, 0xaff00179, 0xcfd01791, 
	0xa0ed00f9, 0xa981dacb, 0x6dd130a9, 0xfd6aa5cd, 0xc7dbf95e, 0x3d18dc94, 
	0x79cbd7e4, 0xc22446a1, 0xf20b3bfb, 0x2f371c02, 0x2f206020, 0x4bf298e0, 
	0x47bb7672, 0x32f0abd5, 0x5158afd7, 0xfcb2e33f, 0xaf391ec5, 0xf65e432a, 
	0x8e2f38d3, 0xcb987774, 0xecae6d59, 0x446fe707, 0x61738684, 0x61be4f21, 
	0x0566cb8e, 0x33db2f3d, 0x50381870, 0x41f3251e, 0x12f9767a, 0xfe22df45, 
	0xf969ed95, 0xcaa9d62d, 0x4f7c0cf7, 0x3ec17bd0, 0xae777f89, 0xa407f995, 
	0x707f9c0f, 0x38478ef7, 0xf1d8c0ff, 0xbc1fe708, 0x12c1c793, 0x67793faf, 
	0x4f3bc49f, 0x778941fe, 0xc4667e9d, 0x3fcde257, 0xb8062998, 0xd83fc9ec, 
	0x3303fc88, 0xf379a2dc, 0x5fa2660f, 0xfe7d9f37, 0xe443fc01, 0x959e101f, 
	0xffdceb54, 0xd30778de, 0x25f3c16d, 0x2f52ffdc, 0x1de7178e, 0xdc19e714, 
	0xf6fe47d9, 0xe10f3e50, 0xae07794c, 0x1de6ec3f, 0x552ae3b8, 0x7feee87a, 
	0xd2043ce6, 0x8791bbe3, 0x21e7ce90, 0x52be3a74, 0x8f1dfbc6, 0x1c3e426c, 
	0xa8a5d3f9, 0xf9c2f88f, 0xe093f007, 0x6879baef, 0xd5971a1f, 0x6f2bacfa, 
	0xe322583f, 0x2caf9c68, 0xd85ad1fd, 0xb5184763, 0xbb4e2796, 0x547a21de, 
	0xd3b5e5e4, 0xa8fe9019, 0x53ff619d, 0x3ff61db7, 0x78cfbee9, 0x7179fa9c, 
	0xf315c342, 0x426dd018, 0xbda5fc8c, 0xac66e8f2, 0x5dd3fad7, 0xff90f21a, 
	0x825fda85, 0xd4b8c075, 0x030de1ab, 0xca10e8be, 0xf78a2d59, 0xdd11efe1, 
	0x61a396fc, 0xb5ae651e, 0x38e228b5, 0xebddfec2, 0x786a2fd2, 0x3afc99e8, 
	0xd6b6c6e9, 0xdf97a173, 0x7fcea25c, 0x0f197951, 0xb7f792ae, 0x1b9eb6f4, 
	0xefa1cf56, 0x3c53a2b8, 0xf5f1caae, 0x79664cc7, 0x96d9b3ff, 0xb1b6f5f5, 
	0xe756ce1c, 0x909dfd9a, 0xc057e976, 0xf7e6afab, 0x8a2ecc99, 0x882ecf13, 
	0x01a25b13, 0x1baaf974, 0x1c71a657, 0xb66e78e3, 0xbb3f79c1, 0xf245b6db, 
	0x7f7f3db7, 0xff187dac, 0x4b3be376, 0x6337f710, 0xcf38cded, 0xec4ba8ca, 
	0x299d8e03, 0x9dc6eb8e, 0xf55d3876, 0x78e8c0ce, 0xb8b11df4, 0x2dfd45d1, 
	0xb98c63d9, 0xcbc6e32e, 0xbf6e2077, 0x3e9e20b2, 0x5e439e4b, 0xd672c794, 
	0x20bb72f1, 0x2d123c6e, 0xdf5f8829, 0xf1c13b11, 0xad3d92e3, 0xe6e73ebc, 
	0xbac0ee1d, 0x27195cc1, 0x1f31b3df, 0x33b8e6af, 0x4888f595, 0x44f9837f, 
	0x63ed9df3, 0x5e559fc4, 0x518af984, 0xb36d048a, 0x823fee5a, 0xc22f20be, 
	0xc1e327dc, 0xefed5666, 0x61f33ac4, 0x8aad6fee, 0xb1bed7f3, 0x029bc781, 
	0xa9757fee, 0xa63bb3b4, 0xe555cee5, 0x9fd5cdf5, 0x7e0c63fb, 0xf23c0c10, 
	0x5c7c76f5, 0x5c771bce, 0xbaf3f725, 0x4b57f072, 0xb03efca5, 0xdc39c654, 
	0x43be3238, 0x1a68c0dc, 0xf11f610c, 0x5dcc372d, 0x361d738a, 0xf720de20, 
	0x9ed8faaf, 0xea1f1d44, 0x981d195f, 0x6fedb905, 0x993e31f0, 0x91ffb446, 
	0x7a9fbc66, 0xfbc55320, 0x591f5b7b, 0x1033e32b, 0xf6677338, 0xb82d8dc5, 
	0xb4be7c3a, 0xcebe2dd9, 0xbe556ee5, 0xf7ad3927, 0x2fbd74bb, 0x10fade99, 
	0x75101f5d, 0x75d157bd, 0x5ce3ad9b, 0xf145f327, 0xb8ad8d8d, 0xc35fd53a, 
	0x88afa1b9, 0x907cfc59, 0x7df2bfd4, 0xde4a9ee4, 0xddc6e073, 0x0070a47f, 
	0x7433b8fb, 0x79c7fedf, 0x071b8fbc, 0xb3be21eb, 0xa02bd152, 0xb4df57f6, 
	0x46e7ce54, 0xcc39ee62, 0xea78668e, 0x59131337, 0xae7b9ede, 0x0bd7a441, 
	0xb552fd71, 0xf98670ee, 0x7f3455b3, 0x3693ca36, 0xcd463ff2, 0xb9be959f, 
	0xbeae35f9, 0x5f467494, 0xd475dc45, 0x191ed07a, 0x55c5cd8f, 0x2a7d44ff, 
	0xec3d1fd6, 0x58876044, 0x3d1da87f, 0xfaf8f826, 0x493b3f80, 0x3f601b9e, 
	0xdbcfae97, 0xb5d87e91, 0xb61f1127, 0xb1c85eb5, 0xaa196b65, 0xd3ebe5f7, 
	0x78fe772c, 0x9f9f1676, 0x714a7388, 0xcc2dec35, 0x78675aff, 0xd9ae1563, 
	0x100bedbe, 0x2f4474e7, 0xf85aabe4, 0x39815e71, 0x21eba873, 0x8b89df13, 
	0xf6ed511e, 0xd5c42b3c, 0x7b9c7f44, 0xf7e9ce60, 0x39c7b9f1, 0x1e79b7b9, 
	0x04b30a69, 0x3e97b671, 0xf02975b9, 0x540f372f, 0x807abbed, 0x03bd617e, 
	0x28749ffd, 0xdfebaf1f, 0x22b872d3, 0xc45799ea, 0x546dc6ec, 0x26e4a4de, 
	0x79804eb7, 0xe7f1c4c5, 0x2a595f15, 0xb38393e7, 0x03775fe9, 0x6fd98667, 
	0x4cd2fc3f, 0x4acf83e6, 0x8d19fdee, 0xc1e30077, 0x4c9e35bc, 0x98e3f1f1, 
	0xde9d93af, 0x4ae5f581, 0x5ebdc729, 0x43b92639, 0x672b8d1e, 0x78ca9733, 
	0x4dfcb172, 0xa5c5e9b8, 0x8cc7a3f0, 0xc77950e3, 0x60d1ccbf, 0xb3e746b7, 
	0x316973c9, 0xc71c6f6e, 0xb7edef1d, 0x9f21a4dd, 0x5323bee8, 0x5bea38b5, 
	0xc717d875, 0xf395f73c, 0xdcd95c78, 0xbf5fe9b8, 0x84538fc9, 0x7e4e7c69, 
	0x3258bf7c, 0x1fe714b8, 0x2e04fcb8, 0x53393fc1, 0x63ef4cfb, 0x7a719f92, 
	0xf6b947ef, 0x36fcc47e, 0x0ffcef31, 0x08e86eaa, 0xf2bc27e7, 0xe72cf9f0, 
	0x156de8a3, 0xed4ce7f6, 0x1f775342, 0x0a5ff592, 0x6bf5df39, 0x3dd0f71e, 
	0x72ff9ed2, 0xfc8f3ba9, 0x546b8f25, 0xd7679d7b, 0x583ad99e, 0xf38cf716, 
	0xfe71b9d7, 0xb19c70ba, 0x5ab964ff, 0xb184ecfd, 0xcb3d19c7, 0x2cfa5776, 
	0x95ffbb6f, 0xb17fd71b, 0x8ddae53c, 0xfbe99f7e, 0x630d7dfa, 0x94291bb7, 
	0x492687e7, 0xdf80d1bf, 0x2bea51b4, 0x6d86abe7, 0xc3faf38d, 0x4e7906e1, 
	0x54e25468, 0xc82ecc52, 0x676defa7, 0xe5b6ca7f, 0x5b48ebfa, 0x84c5c485, 
	0xc6afadc4, 0xed77ec7c, 0xc2af458a, 0x2b9603fe, 0x9c0539e4, 0x7d634fd9, 
	0x6e7d9fdc, 0x8f4ff057, 0x9e299d5f, 0xff1a8577, 0x677ae299, 0x7f8967ad, 
	0xf9db7965, 0xfe3cb9fc, 0xf2ee3e0b, 0x7905fe85, 0x917f4413, 0x1766bfa7, 
	0xe903ffd2, 0x363818d5, 0xfd0ed72f, 0xc891f10b, 0x896f2cab, 0xbe4a6707, 
	0x74dbb717, 0x1ab6ed96, 0xf4b6f205, 0xcdce52e3, 0xce108191, 0x4d9c1e93, 
	0xf2efb077, 0xde582fd8, 0x3c8769fe, 0x83fd1577, 0x7ed5195d, 0xdfb6d9fb, 
	0x7b27165d, 0x76df4061, 0xea175ce3, 0x4f884647, 0xff4dc6e5, 0xf22adc42, 
	0xba171903, 0xf1e591ac, 0x8db7a3be, 0xece27edd, 0xa8f50df4, 0x52eb633c, 
	0x03fd8bf8, 0xb38d38be, 0x4f1233ef, 0xe3f5cd6f, 0xdcf9b1d6, 0xdded7676, 
	0x13c91b7e, 0x27d464ec, 0xe69c4bdb, 0x555daef6, 0xcdadedca, 0xec76b7b5, 
	0x921d22f6, 0x480fe1be, 0x2b8ed55f, 0x6de9a257, 0x9e07e396, 0x4b9e40bd, 
	0xd71771fc, 0x19bf5fe8, 0x8770bda3, 0x6d87df1c, 0xb730c0ef, 0xc5dd67b7, 
	0xae529f72, 0xb7636dbd, 0xe52ceab7, 0xb5bdb8a7, 0x85dedc83, 0xbe3c15c6, 
	0x3ded72a7, 0xd67b7635, 0xfc8f8e59, 0x790f4bf4, 0xc121b4f4, 0x8e7cfa7a, 
	0x3d4bcf6f, 0xeb35fded, 0xbe79d0cb, 0x5934f5b1, 0x73353728, 0x7a4fd045, 
	0xa533b358, 0xe0b7dce3, 0xf6388935, 0x97edb8d3, 0x9c2e9ce0, 0x66fe4a1b, 
	0xf998f118, 0x68237d72, 0x0879030b, 0xeeed3335, 0x25179f0c, 0x48aaffcf, 
	0xfc42e81f, 0x1617d822, 0x9ca24f3d, 0x41f587d9, 0x8c25d85b, 0x472689df, 
	0x07fcfeb8, 0xd7963df9, 0xd325ee9b, 0x87193f80, 0xfe6ea2d2, 0x695bc954, 
	0x28de1fd4, 0x13513e68, 0x3661e756, 0xfdfc3ad9, 0x1c6424cf, 0x385fa460, 
	0xe11fefee, 0xdaf3e89c, 0x774e7ca2, 0x9df323bd, 0x3fb26bcf, 0x981c23e1, 
	0xe2388965, 0xafa124a8, 0x5d581e61, 0xf809e72e, 0xde79169d, 0x742fdc8e, 
	0xebee4273, 0xf24bfd75, 0x38f17527, 0xf3e75672, 0x7afb017c, 0x3e205f31, 
	0xe1ee31fa, 0xbc7adacf, 0xc721be8d, 0xfe4d5e3b, 0xafc932f4, 0x1e7213d2, 
	0xf1f7aba1, 0xf2dd2d7b, 0x9fd8aff7, 0x4e11daad, 0x64bb7d63, 0xd1ef9c99, 
	0xae81f738, 0xd8d47b46, 0x6231f240, 0xddb2f3ab, 0x3a2299f5, 0x7b5e750a, 
	0x547696d6, 0x8748fe47, 0xc2fc0be2, 0xf34f9f89, 0x6c6603f9, 0xdabb609f, 
	0x13af1774, 0xe63eb2da, 0x8bf3155b, 0x4b2ca7ef, 0xf2cf43f2, 0x63d2c7fe, 
	0x3f746cff, 0xfee0e92a, 0xe57b871e, 0x0230dddf, 0x77fbce16, 0x84e6f4fd, 
	0xe616bbcc, 0x58afde2e, 0xaf9e43b5, 0xbd1b9c1a, 0xcd7f01d5, 0xbfe63a55, 
	0x5ec4e915, 0xe2e457ac, 0xe90957ae, 0xf3225fb7, 0x7ffadc02, 0xbffa4cbb, 
	0xb5e42777, 0x87b26964, 0xb6456bf3, 0xcd6efe14, 0x9fb7aa52, 0x79843a15, 
	0xf3ce0d55, 0x6696f1a6, 0xe0fc2162, 0xcc8ed545, 0xbe23f466, 0x75803a3f, 
	0xf7ef1a07, 0x62e0afc1, 0xdc91789a, 0xe513cc96, 0x26367388, 0x2adf3cc2, 
	0x6ad276a9, 0xfd441fde, 0x7b9dd7c1, 0xc119dfb9, 0xbf6cc5f1, 0xa514e370, 
	0x2a537cde, 0xc9818f07, 0xb8741b22, 0xf856e4bd, 0x587fa1dc, 0x427cb215, 
	0x50c3ff94, 0xbf7aeac8, 0x30538fb8, 0xefc52b4f, 0x95c72d6c, 0xcf248fe6, 
	0x1fb67d25, 0xbfa20c7c, 0x6b9a87d4, 0xea24f8ec, 0x1dbd4d57, 0xc1ae887f, 
	0x87b7ea5a, 0xef87256e, 0x218f434f, 0x3fbf1ca7, 0x79653f3c, 0x5386d7cb, 
	0xc959c916, 0xd87489b5, 0xe2dafa87, 0xafa86293, 0xae10fe2d, 0x578c9d7f, 
	0x07d792ef, 0xf8bc0fb0, 0xf7f6c5f7, 0x7e0f4dc7, 0xe7fe28d5, 0xb2c45f7e, 
	0xf9eb1745, 0x707efe1e, 0xb8775a99, 0x835ccf6e, 0x693d2bbe, 0x97877f73, 
	0x68643465, 0xab8e3be1, 0x24bbf90b, 0x6f1aa8c1, 0x43de53bb, 0xdb5e0c74, 
	0x0dbd069e, 0x9c12b745, 0x3beae57f, 0x9f8d01eb, 0x6a7a5ff8, 0xc13c8eaf, 
	0x4e2a53d2, 0x7ae67210, 0x1fc49f7f, 0x0af8b5b3, 0x22d1e3ce, 0xb0bd0f3e, 
	0xd713cfcf, 0x8eb96dd7, 0x97b37a4a, 0xdfdfd1cf, 0x9d60a6b4, 0xeb0fd5d4, 
	0xc41fac27, 0xefbc2ef7, 0x4f378fd5, 0xb3cb7bd3, 0x05e7bf05, 0x11f7787a, 
	0x1515b9f1, 0xda98bf44, 0x185fbe4f, 0x334f1931, 0x6fafa1fa, 0xef3cbd10, 
	0x5f7238d7, 0x08d73de1, 0xf638f531, 0x44bb538d, 0x877d309f, 0x79f70a3c, 
	0xdcf235e7, 0xbbcd209e, 0x7ae8a536, 0x1f8ebf5f, 0x67de0a50, 0x6d9fb0fb, 
	0xdc5f5564, 0xdf2dfc4f, 0xf235d496, 0xcbee4a87, 0x8c5df89a, 0xe4cb78e2, 
	0x7950db5a, 0xde2aa530, 0x4fece320, 0xa508f1ba, 0x0d77ea07, 0xfdca5e2a, 
	0xdca615de, 0xf23b4f52, 0x93d5e4fa, 0x17efdcac, 0x6cd7cfda, 0x57c680e8, 
	0xb49c7403, 0xc274d6cb, 0xc8d703a5, 0x7693027d, 0xe0adce13, 0x461eff2b, 
	0xab8971c9, 0xdc4f0e2e, 0xe1f3f0e5, 0x381fb665, 0x7ab2c66c, 0x66bcf49c, 
	0x07c663b7, 0xf0a0de69, 0xe977e5d8, 0x914f4d29, 0xbe40d57e, 0x29d6be88, 
	0xb9601f19, 0xd45f91d4, 0x5d38c697, 0xdb120b79, 0xf72f7fa5, 0xfa823c49, 
	0x097b41de, 0x1c5cdf96, 0x74d1c9a2, 0xf5e38719, 0xd480fc1f, 0x3b1eed96, 
	0xb6e5d6a2, 0xaae3932f, 0xe3dedc59, 0x789aeb95, 0x20fec093, 0x63473fb7, 
	0x8f231bd4, 0xaca6c193, 0x247f2116, 0xce933b08, 0x35dfcbd7, 0x295fe68d, 
	0xec3e9fb5, 0x474711c5, 0x87f040be, 0x04ddfe49, 0x7d201f5c, 0x19327e0c, 
	0xb7cd189f, 0xd93af353, 0xcd5be25b, 0x29e330fe, 0xafd83f9e, 0x9f18f470, 
	0xfef2171b, 0x75c954ae, 0x063f4b51, 0xdebc9bbb, 0x702ceab7, 0x76f481ae, 
	0xe8afd532, 0x92c31d52, 0xaf9b10be, 0xa837f691, 0x1e5935f2, 0xb1559f88, 
	0x7d1c01ac, 0x67691af0, 0x3ee8fbaa, 0xcf1505f9, 0xd1f895ae, 0xf873f527, 
	0xe23f493b, 0x4a627aa3, 0xfbedce0f, 0x7f1235c5, 0xb0e7a422, 0x13f74717, 
	0x743dab5d, 0xaa561e85, 0xcefc31e7, 0x35e7c385, 0xa64b6e57, 0xeb25ffa1, 
	0xd0a379e4, 0xf8fd9dc7, 0x4747097d, 0x6bdaff7e, 0x7059fae4, 0xf197d12d, 
	0xa3edea8c, 0xf9b5aef7, 0xb412c35c, 0x60e5c1e3, 0x0a99da82, 0x7d480cf9, 
	0x4dcf275f, 0x1ae7d1cd, 0xfdfc07e9, 0xcd6f5932, 0xdff7c2fe, 0x7ee0fa51, 
	0x0f61fe47, 0x5edfc3fc, 0xb557f323, 0xb0f7f713, 0x977fb7bf, 0xf6e43e76, 
	0x639f28d6, 0x8932e2fb, 0x24f32307, 0x054ff89e, 0xeaf17ae4, 0xc4e70a64, 
	0x70376385, 0x7b92473f, 0x34093fd8, 0xce08e784, 0x8fcabdab, 0xf9c0a53c, 
	0xb1799654, 0x3bffe71a, 0xffdf86b6, 0xf235f4f9, 0xfd132cbc, 0xf236fdc4, 
	0xf178b687, 0x94eefd5c, 0xbdf829df, 0xd2139ac5, 0x32e3fb8f, 0xd2352f99, 
	0x7dd53a70, 0xdceb5d21, 0x3a116bdf, 0x01e10cec, 0xde8e0eff, 0xb3bd7076, 
	0x91afcf28, 0x06522799, 0x31f958f0, 0xd6f770a3, 0x67eea913, 0x9cecbf09, 
	0x7beeeade, 0x64ecbef8, 0x34f91baa, 0x1eed2765, 0x53cac3d8, 0x7fedbcea, 
	0xafc8e84e, 0x98e6da3b, 0x09498f90, 0x4e108f47, 0x1e85b24c, 0x9a7cf3d7, 
	0xe761768c, 0xb87f7212, 0x11fea09e, 0x722727dd, 0xe9e38976, 0xffeca795, 
	0xfc8c7c7e, 0x24de9cc7, 0x42f0ae84, 0x7ba17857, 0x0bd5c2f1, 0x9c7ea7b2, 
	0xa12739e7, 0xdaf45f7e, 0xf8bdeb83, 0xcd6edc54, 0x98d207eb, 0x729e56bf, 
	0xdf1c1dac, 0xcfda0a77, 0xe4d59bb7, 0x396509ef, 0x1e7dde9f, 0xc6bcf650, 
	0xf12f7a12, 0x2cf6a2d5, 0x51cd4e0f, 0x84e4d8fe, 0x59ab27d4, 0xe974c7b6, 
	0xff067a67, 0x1fc376a4, 0xe4a75db6, 0xdba31385, 0x7c4fb5cd, 0x807eb7d4, 
	0x7ed423f6, 0xbb8d43e6, 0xc63185e4, 0x47edd67d, 0x83f8f43f, 0xd3f1967f, 
	0xcfe306bc, 0xf5239bc9, 0xc49971b5, 0x7b93b2dd, 0x6dc94775, 0xae43fce1, 
	0x727d1877, 0xf8988f7f, 0x58ff354d, 0x29790fb5, 0xb4433cee, 0xf9a1bd49, 
	0xebcc5ece, 0xff74a246, 0x3fcc6367, 0x01f5bd56, 0x67591fe7, 0xacdbccb3, 
	0xf0f7e34c, 0x71ca3ec8, 0xde1dbfbe, 0xcfbb8d75, 0x93fb91c4, 0xb918efd4, 
	0x798fd7f6, 0xcd65e118, 0x67fe8515, 0x97161e6e, 0xfd8128e3, 0xf3e67b8d, 
	0x642bd3b0, 0x693ee23f, 0x4be7bccf, 0x487bfbf0, 0xf3c84fbf, 0xcf551fc1, 
	0x79a06f87, 0xb6fc10e4, 0xa26efabd, 0xdb2ec969, 0xd7030f8c, 0xc87deb4f, 
	0x6db851eb, 0x34d7e9ce, 0xf3f5938e, 0x1bb0e9b9, 0x78bb0798, 0x1fe57bff, 
	0x70bde316, 0xa8d9bfc8, 0xad709ef0, 0x4f9a56e4, 0x7fe34791, 0xfcef9e43, 
	0x1f7fc2e7, 0xd6d609c9, 0xdfd21247, 0xf799991d, 0x257d7963, 0x3923df21, 
	0xf8957f67, 0x3927ee96, 0x66de48b4, 0x94179e63, 0x686ad2fb, 0x19fe801e, 
	0x257be5fb, 0xfcbda17a, 0xf893b2be, 0x6473760e, 0xa33713bf, 0xeff1dfec, 
	0x0aa719bc, 0x966aa0f3, 0xb25cf826, 0x1fa4b592, 0x86cf3843, 0xf87ebffc, 
	0x2c87e47d, 0xf210b9c7, 0x5af33e3c, 0xf83ccbf2, 0xa27af25a, 0xc35a7907, 
	0x7cf86437, 0x334fd735, 0xec61ced1, 0xe4f59373, 0x7df009fc, 0x7cd7f285, 
	0x1be01faa, 0xfde749da, 0x6f6b92b5, 0xe3ffd31c, 0x7e452276, 0xaf550adf, 
	0xf392de67, 0xebec8afb, 0x2c3fece0, 0xf666b8e3, 0x0cd71c37, 0x94bae447, 
	0x06b0e2ff, 0x497fc67f, 0xd651f6b6, 0x672ee717, 0xfc1cd116, 0x0f8f2bba, 
	0x544cffc3, 0xb8f5e648, 0xfc11e486, 0x5ba93f60, 0xe7f52de9, 0xa9e302ff, 
	0x0000459e, 0x00025fb1, 0x7cd59c78, 0xd554740d, 0x673eefbd, 0x849cccce, 
	0x4999ccc9, 0xc81c0642, 0xa4632808, 0x77aae530, 0x409eb624, 0xd55ae02c, 
	0xf5c81031, 0x1a088ea3, 0x2037b67d, 0x33c0504a, 0xf4049093, 0x5e7c80e2, 
	0xfb60d7db, 0x7b7ad72c, 0xc55dcb69, 0x42279f56, 0x5576f48b, 0xd9e55bd4, 
	0x0603af7b, 0x52b1aeb4, 0xb51a6db4, 0xbfffffbc, 0x33399ef7, 0xf1af6a81, 
	0x96b2f5ad, 0xfbd9f66e, 0xc7ff8fec, 0xf7b1ffef, 0xd52cc619, 0x7e58c0da, 
	0x8b5c677a, 0x16d95631, 0x19db7ad5, 0xc665f53b, 0x1e784ad8, 0x55ec584d, 
	0xc13277f8, 0xf8750598, 0xd198b5bf, 0xa4f5859f, 0x33f77715, 0x4543e636, 
	0xac612f49, 0xf7f2cda2, 0x90fb5d40, 0x8c6daeb1, 0x9ebf819d, 0xd87da007, 
	0x5ed058ca, 0xac6586b9, 0x4b7a630c, 0x13fb0f5b, 0x2c3463f4, 0xb279f8ab, 
	0x1b18e587, 0x59559c5c, 0x62e3631f, 0x0bd89609, 0xb3b8e4fd, 0x1f28dc61, 
	0x578c076f, 0xf8953319, 0x2dc650ad, 0xf312ec25, 0x38fe832d, 0x67dfca8f, 
	0xce381849, 0x72d15dd7, 0xf97cc97d, 0xc6fef96b, 0x343cf9c5, 0x04b1986f, 
	0xfd015f3e, 0x5baaa64d, 0xd65dbb18, 0x310f5093, 0x3eacb8b6, 0x8ba7eb17, 
	0xbac957fd, 0x3583af68, 0x72227fab, 0x087138a9, 0xe80279d7, 0xd0ccde31, 
	0x719917be, 0x707a6ede, 0x635e926d, 0xec30bc61, 0x29946c7b, 0xbcf8b571, 
	0x65f62a2e, 0xcad06826, 0x56a299e7, 0x4e6ffac3, 0x260a7aaa, 0xbeb6be49, 
	0xd7ef3e6f, 0x00787c07, 0x307463d6, 0xa03c3556, 0x3b19c75a, 0x03a80f31, 
	0x5cf05913, 0x87de1f79, 0xf78859f1, 0xb630f6b7, 0x493982ed, 0x0eb1dcb6, 
	0x6abab30f, 0xd0f9ab19, 0xf7866cf4, 0x9999a66b, 0xf7cc2f6c, 0x006abf42, 
	0x00d75cbd, 0x0afc61cd, 0x44ffd38d, 0x6eb0f4d2, 0xe8a5aba4, 0xd6126e30, 
	0xfe0a715a, 0x2d7b41f3, 0xe7a4c5f2, 0x65fcfc72, 0x9fb87720, 0x6c13e718, 
	0x0f44614c, 0x5015599d, 0xd864f7b8, 0x5ca0502d, 0x27f21ce6, 0x125e57fa, 
	0x1a02d3bd, 0xd9a99db3, 0x660f5035, 0xbaac0392, 0xaae7be38, 0x3f1de9dc, 
	0x94d2f285, 0xf0d7f9b2, 0x6ac4bcfe, 0x3be8e426, 0x7b015ed0, 0xb29c80c8, 
	0x186ea9b0, 0x54c26507, 0xec62ef37, 0x7df32fc5, 0xd14ec961, 0xee34d5fe, 
	0xc7b312ff, 0xbb8ffd82, 0xc77e54ba, 0x7112fd01, 0xa2a4d7ec, 0xdb5e0ebc, 
	0xf15c724f, 0x5cb7df21, 0xf86dca0f, 0x38f74e56, 0x84efedc8, 0x1a76ca1c, 
	0xd7693f67, 0xfbec1685, 0xee99e31b, 0x7d5885b9, 0x738d5b21, 0x95f50c29, 
	0xb62a7b31, 0x659c63ff, 0xb5c90a59, 0xcf5c42ea, 0xce9edfcf, 0x1ddd96e9, 
	0x66b9fec3, 0x6b33af17, 0xfa8c75aa, 0xbfff63f7, 0xc92ba0bf, 0x4df48f7e, 
	0x1c32e77d, 0xe38f66cf, 0x5f61aa78, 0xf27e40c8, 0xaf598b1e, 0xc6ef3d73, 
	0xa74f5f6e, 0x38e8032d, 0x71ef193d, 0x635dcfd0, 0x705b5d2a, 0x01b3d37e, 
	0x64aeafde, 0xec21ece9, 0x036f8a97, 0xa9a053f9, 0xb9e8e80f, 0x86ef152c, 
	0xd4eb3d7a, 0xe0f3a02c, 0xfa82948c, 0xc54dd6e6, 0xcd1c820a, 0x8f208e80, 
	0x02bc035a, 0xa49769e3, 0x58cb2534, 0xa74fc60a, 0xd6c22e48, 0x383fe861, 
	0x7d869127, 0xf7ec02dc, 0xb58f0f9c, 0xc04bc0e8, 0xbceb9480, 0x964e51a7, 
	0xb29fb24c, 0x0b2f7e70, 0xf1140c6f, 0xf3d4b982, 0x572b9435, 0xe80d7ce6, 
	0x768acc72, 0xaa03bcf5, 0x00fe71aa, 0x240e494b, 0x81d7921f, 0x7fdf00de, 
	0x43a9b208, 0xa5d2b279, 0x7280ee7b, 0xeaf181d3, 0x444b226a, 0x21d22bea, 
	0x2a62e7d5, 0x6f91d38c, 0xbf072e64, 0x9c7c2d3d, 0x3af1889f, 0xb998be9e, 
	0xaa3a4f40, 0x86698dd8, 0x9e307de3, 0xa46adfe4, 0xfd09bf41, 0xed2f4082, 
	0xe397bdc2, 0x58fb4e7e, 0x9fa132c4, 0x866fc7c5, 0xe71846f6, 0xb5076654, 
	0xd2ea5f2f, 0xa3279f91, 0x1197531a, 0xdf9cc39f, 0x2f79f876, 0x4da19195, 
	0xff223654, 0x7d6d27bb, 0xec5f3a2a, 0xf38d1977, 0x2ffa0c54, 0xfaf14ad7, 
	0xc6e39258, 0xf7c75e3f, 0x45a63ebf, 0x0143be88, 0xf57e00a6, 0x0c239bc4, 
	0xaf125bc6, 0xb2503d63, 0xa20c73f5, 0xb52f2d6f, 0x7c84d62a, 0xf6ceadfb, 
	0xe786df2a, 0xd239e0db, 0x54b99eed, 0xf7599a9e, 0x3ea20b34, 0x45eee99b, 
	0xf2b08e08, 0xc63f22ee, 0x30fd7f00, 0xd3167f9f, 0x3a079ffd, 0x07552dc6, 
	0xd04db9b9, 0x7bc06f31, 0xb3dd70af, 0x3799b81c, 0x21f08cb2, 0x69d3edc5, 
	0x1a45759f, 0x94f4e8e4, 0xf105f138, 0xd38c3765, 0xa8bbfb0f, 0x05a7cb83, 
	0xb4c775e3, 0xe50a6a09, 0x035f80eb, 0x6661ed39, 0x66f01ba4, 0x1f2ed3c9, 
	0xa25b0c68, 0x83d9cd99, 0x6fe91ed0, 0xc656e1f8, 0xf2627abe, 0x97eb031c, 
	0xac1ffbf4, 0xf77e7a01, 0xe684e6df, 0xfdd6b630, 0xbcc2cb18, 0xc6c6b8e9, 
	0x1fc2b277, 0xdd470dd6, 0x2e2c698a, 0xdf0b51ea, 0xef6e9653, 0x6a58f5c4, 
	0xf40fea0a, 0x20d0dd75, 0xaeea8cea, 0xf5d7f792, 0xc930dd77, 0x554d7fd1, 
	0xaba6ca6e, 0xd6e79c70, 0xbc68c23c, 0xe2e63b33, 0xc6c37373, 0xfd9f582d, 
	0xbc43edf9, 0x982345bf, 0xeeefa88d, 0x9167cbbc, 0x5409b17e, 0x51a66a5f, 
	0x500ddcde, 0xb0e50ede, 0xa9ed13b5, 0x60c7c85b, 0x1d4682dd, 0x90b676f4, 
	0xa6eeb5d3, 0xbbc02ea6, 0xd7bd96bb, 0x4b0d9008, 0x1874566d, 0x116bad27, 
	0x77a730fd, 0x97d718f6, 0xfaddc82c, 0x22267323, 0x96fb7f9d, 0xe7b7f48b, 
	0x342b81e8, 0x9d034f51, 0x89ccc757, 0x0bb394aa, 0x82cf7b18, 0xeeff7876, 
	0x034b4b9c, 0x7803bcee, 0xdff68191, 0x14640ee6, 0x760affde, 0xd234209c, 
	0x35eccc0d, 0xc4de4f01, 0x2822baf7, 0x4f696e54, 0xe216dfe0, 0x0beebc6d, 
	0x9dd5f02a, 0xbbcabba8, 0x724ed8bb, 0xceeeed04, 0x037b0ab9, 0xf9061af6, 
	0x18c8bd06, 0xcddfee5c, 0x7fa1f1cf, 0xd056eef2, 0x00ba30a3, 0xf28dd2a6, 
	0x140879d2, 0xae7eca1e, 0xf294b29f, 0x29d02ef8, 0x8ef5f20c, 0xd1a023d0, 
	0x778c34c4, 0x33dd6672, 0xa4b3e80c, 0xddcfeb9f, 0x9eb2a73b, 0x68f523bd, 
	0xa45df3f5, 0x274fda67, 0xe8e62937, 0x49abd1e9, 0xd74edf6e, 0x207d09b0, 
	0xa623a737, 0x597821ff, 0x7fa27587, 0x3d575833, 0x7f84ed81, 0x9a61ab57, 
	0xeeba014f, 0x4cb97a42, 0x0a60e02f, 0x27dc457c, 0xdfd8e2e2, 0xc54d9b20, 
	0x211dbb20, 0x3123f37b, 0x1cc8963e, 0x534ebc77, 0x037cbde0, 0x848b93f8, 
	0xe24665de, 0xfce1c4b2, 0x442b2e63, 0x004e6b38, 0x1ff96465, 0xb7c69d40, 
	0x114f3027, 0xb9cff397, 0x4d3fe12c, 0x412f7ea4, 0x27b3de9d, 0x71fcbf62, 
	0xa9eb3759, 0xb7f65a7e, 0xaabfa9eb, 0xb528f6c9, 0x1ed93487, 0x665ef6c5, 
	0x7a48db4f, 0xdfac3567, 0xaabaf443, 0xabd230ef, 0x5b43de7f, 0xed3e7c8b, 
	0xaaf1fae3, 0x9898efd8, 0x6f81f98b, 0xee9706fe, 0x4b633eff, 0x77445da3, 
	0x0cf606d6, 0x8d93d3ca, 0x9f8c1726, 0xc6df5c42, 0xa9f2f1e9, 0xa43d3eff, 
	0xf4b4fd9d, 0xfcacbe20, 0x3fa8ba78, 0xb0669058, 0xb6acf77f, 0x22cefe59, 
	0xd8b368ae, 0xd896edd1, 0xd397d817, 0x280ea75b, 0xe13a4515, 0x3ac22ff8, 
	0xa19ca057, 0xfe816b9d, 0x497f646c, 0x99bf428f, 0xe55fb09f, 0xef2fe7d9, 
	0x671a3797, 0x72723fa0, 0xd0a7e1f8, 0x897b462f, 0x17f4957e, 0x4760e896, 
	0x8c5fa2b3, 0x7e8c3a40, 0x6651adcb, 0x1da10679, 0xec52e255, 0x4f256cc7, 
	0x8bb94e65, 0xfca6a1ec, 0x68d5e906, 0x2c4fb031, 0xa6e3c8dc, 0x297c0ac7, 
	0x85f04ff0, 0x7c71f7f8, 0xff23f493, 0x2f5f1b61, 0x2bac2ae1, 0x43eb987b, 
	0x71ebec05, 0x28b4fec7, 0x8d1847b5, 0xdae76613, 0xe887b69f, 0xbf02d3b0, 
	0xcd51857c, 0x234b74f5, 0xbe4929e9, 0x68f5e9fa, 0x1b64ef6d, 0x60f7efed, 
	0xce50639d, 0xb9d876a3, 0xbce55bae, 0x5e7747e3, 0x7ce18fe9, 0xf38a9f1c, 
	0xd7c37f05, 0xea323843, 0x77707ef3, 0x8ac6e388, 0xef3f20f5, 0xcf497bb7, 
	0xfe7f03a7, 0x6e53f806, 0xbfee2407, 0x4ec771b3, 0x0f6437b4, 0x76657f90, 
	0x8b8d9de0, 0x1589acd3, 0x58eac0ec, 0xfbe9ec92, 0x2433c60d, 0xd09760e4, 
	0x60fa778e, 0xec159b7c, 0xed8ffbc4, 0x63dff7a0, 0x76dd15f6, 0xc0ad4ed1, 
	0x55ec3975, 0x5857f85c, 0xbf9d61c6, 0xc600f613, 0xfff102bd, 0x59e773e4, 
	0x6f1d57a8, 0x56fad235, 0x058fc0f9, 0x29e93a39, 0x3e2563f5, 0xd273da77, 
	0x74ffc1e3, 0xb37e958f, 0xf09668a9, 0x3ca28d6b, 0x838e0ca6, 0x61bd6227, 
	0x3d71577d, 0xb8c2c727, 0xde215847, 0x1c78bf23, 0x3e07c3fa, 0xf44432d7, 
	0xe811b49d, 0x64fecdab, 0x58f7ff7a, 0xe6ce7c42, 0x72ef0e01, 0x971ca3d4, 
	0x6f18f50b, 0x3cf9e02f, 0x8ed057f0, 0x00710d5e, 0xb376d1d8, 0xf6ce654b, 
	0xde23b404, 0xc07682cf, 0xbce2dbfb, 0xf703fe7d, 0x2006984d, 0x7667bade, 
	0x1f3fe914, 0x7e0182f0, 0xa84a23dc, 0x223ed733, 0xbda384d9, 0xe0720f1c, 
	0x6bd97fb7, 0x6503dc4e, 0xf7eacbd2, 0x6c96f3c1, 0x4fdf1ea6, 0xf3859782, 
	0x70cef82c, 0x8b97c63d, 0xd471fd9e, 0xbdb46307, 0x1afceb30, 0xfd7faf28, 
	0xf447e7c7, 0x06b78e22, 0x87e805ec, 0xf53a5feb, 0x6b47a415, 0xaf15fcc0, 
	0xd014e477, 0x7549c183, 0xa16f2803, 0x0cce3c59, 0x178f635d, 0x2a7c4438, 
	0x6e71c9c4, 0xce4fddef, 0xfc91fc22, 0xe6f88ac9, 0x47a116ae, 0x73a6868b, 
	0xc8af01dc, 0xe1a1dfa1, 0x3f02c640, 0xa41a67d4, 0xd83a95e7, 0x0fe8ac8b, 
	0x925f93f8, 0xc7bfd528, 0xb55fa954, 0x503f5fa4, 0x92d57ea5, 0x68573dfe, 
	0x2fed4b1f, 0x62c7da15, 0xe88ceb7b, 0x7f4e95a3, 0x723d6cb7, 0x6f3fa31d, 
	0x61c8476a, 0xa631dd0f, 0xda1981b8, 0x82e6318d, 0x03edc9b8, 0xe74862b9, 
	0x76b912a1, 0x9d3514df, 0x2d3de371, 0xa6fafe3c, 0xa1f4eba4, 0x42af68e9, 
	0x93770fc3, 0xd5328abd, 0x4714e789, 0x41d73d03, 0xa9a38c7f, 0xc1e04c7f, 
	0x39df2e38, 0x5fb08f5c, 0xbf642220, 0x74bf6174, 0xacf4bf61, 0x04eccba0, 
	0x7d625fb7, 0xee4cd9f9, 0xb77da55b, 0x956fb930, 0xd644b2e8, 0x57d5174d, 
	0xcbb6fec8, 0x1bb4bf69, 0x04147d4e, 0x96d8337f, 0x8401b3fb, 0x5b092d08, 
	0x4b9209ea, 0xd6ef8ba2, 0xf9e0da70, 0x2c0f4c9e, 0x29597438, 0x343d249d, 
	0x9e075394, 0xccf53948, 0x227a72e3, 0xadfc9736, 0x6f48bcc2, 0xa1699e47, 
	0x45bca5e6, 0x67c6cebb, 0x4d0fdfc1, 0x45f4a819, 0x066c1cb9, 0xbe4487ba, 
	0x9a53542a, 0xcc5279bf, 0xee16bdff, 0x5c4486df, 0x92ca30b4, 0xef8abbbe, 
	0xc70b4bff, 0x4f012a1b, 0xa92c1a16, 0x86179d01, 0xe70bbca1, 0x472b7453, 
	0xa0a96ffa, 0x56a5a1ff, 0xd4e7a8b7, 0x9667c829, 0x2c297cc6, 0xa7f49ab6, 
	0xa76fda01, 0x7fa2b7e1, 0x36f9121d, 0xf1ea2fe2, 0xf982a4d4, 0x058fe43f, 
	0x2d33d671, 0xdffb3e3c, 0xaed01d62, 0x4daf3fa2, 0x3631fb49, 0x68c6056e, 
	0x58dca097, 0x5053c61a, 0xa7105d67, 0x2d1546b7, 0x28fdc39d, 0x91e20cbd, 
	0x8e738c0a, 0x01a6f3e1, 0x8d35838c, 0xb21b2fe7, 0x10cb0d56, 0xf5182add, 
	0xfec0ef4f, 0x97b9ada1, 0xa35a4f11, 0x3ce22f03, 0xa6b4c90d, 0xd2cafe53, 
	0x7e814fd0, 0x8d6a7f94, 0x78b04fa6, 0xbe783c71, 0xa172f317, 0xef8b1b2c, 
	0x84a84f6b, 0x95b71747, 0x5dfe0fbe, 0xe855e31a, 0xa67ae36f, 0x955a99da, 
	0xf84bcaea, 0x657c36be, 0xe29cf51a, 0x05df5820, 0x536f40db, 0x0a94d744, 
	0x7a0c5bfb, 0x9bfd4ddc, 0x12bfd472, 0xf6a32dba, 0x2fda0c23, 0x15fc199c, 
	0x7841bf5f, 0xc46ae30e, 0xdd331897, 0x6e0ba7c0, 0xe620bd5d, 0xa88fec66, 
	0x9f67a09f, 0xf5a01f6b, 0x6bb31c5e, 0x3f5c6cd8, 0x7ee002e0, 0x3ed9c9e8, 
	0x91ca16f6, 0x906ba5a5, 0xeb86962e, 0xdee6cd6e, 0x79bd7a43, 0x1a2d7bd1, 
	0xce86cfbc, 0xae7f18e8, 0xc725733b, 0x33a5b8c9, 0xdbf3e008, 0x0f303313, 
	0x043ae521, 0xc4bc227c, 0xd3d7a0e7, 0x305a865a, 0x0e4dab4f, 0x15c6c53f, 
	0x175fe1fb, 0xa4e117fa, 0x33677842, 0xf26dd71a, 0x6c17a9fc, 0x3de82f6e, 
	0x5bb784d0, 0x62989f22, 0xda5d6711, 0xfb95cf0f, 0xe22f3e23, 0x7dc11998, 
	0x804ed1b9, 0x57bee4df, 0x39a59fea, 0x768fcff5, 0xbfee1b62, 0x2eb44ed4, 
	0xf9f678e0, 0xaecf0205, 0x2ec27691, 0xb0b765c1, 0xcf810113, 0xedc9ba15, 
	0x4ec235c4, 0x78ca37dc, 0x8bf523bd, 0xf8013b52, 0x854f58e6, 0x8f5713b4, 
	0xcffdbcf6, 0xc904ed3b, 0x24e50a49, 0x765da1a5, 0x2af02bdf, 0x882af1cb, 
	0x5ae903f6, 0x09662766, 0xc05b2eba, 0x84e908f1, 0x7c3dc276, 0x35c79a6d, 
	0x8a2a2760, 0x73d24276, 0x3b27f40e, 0x13b08d71, 0xeff46fb0, 0x7980aed0, 
	0x89da3a60, 0xb0ffa8a5, 0xf7c57fc6, 0x45dc4ec0, 0x45ed0e65, 0x71e0cc45, 
	0x388ba48e, 0x3b2d188f, 0xf13b4411, 0xdb6fd853, 0x2082eb5b, 0x9d82ee8c, 
	0xa2b13a00, 0x3b09089d, 0x427696e1, 0x43d24bd0, 0x67f48afb, 0x7bd1a298, 
	0x2fa9196d, 0x1b4f0f48, 0x21e77e13, 0x5677e9d5, 0x3fd0457c, 0x50b5f7ca, 
	0xb7a6ab9b, 0xf77bd960, 0x1d60e7f6, 0x3bcddd9e, 0xc3dcf06a, 0x0716e6f3, 
	0xb898df1f, 0x98afc68a, 0x1f58ce67, 0xa0578e2d, 0xba53337f, 0xfbb71c42, 
	0xa55f918e, 0x553e058f, 0xf9403d0c, 0xdc0b3f93, 0x49e84fba, 0xaa68bc61, 
	0xd9ea1e30, 0xe528d4e0, 0x6093f3cf, 0x13ec20ea, 0x9bcc55fc, 0x065993ab, 
	0x175544ed, 0x0ff02c53, 0xf01db0ab, 0x5ea13344, 0x2515e747, 0x34cd30f9, 
	0x3ea2f2ae, 0x73561ea3, 0xfbfca13a, 0xc0038e34, 0x22d695ea, 0xbc240741, 
	0x98ed46de, 0xcef6a423, 0xbfe44ac4, 0xcfc75435, 0x3fa25303, 0xd8a559da, 
	0xd206fe8e, 0xea1e30a7, 0xeba8e597, 0xc2a7ddbc, 0xad1f81f6, 0x97064b3a, 
	0x564a5d92, 0x1c2eee00, 0x301ad44a, 0x27119fef, 0x8f7f8833, 0x0f7fd02e, 
	0xf60a3bf6, 0xebb79abb, 0xd799768e, 0x497da85d, 0x7f308749, 0xaf1d91a9, 
	0xfe79a564, 0xffb80b2d, 0x9bd045ba, 0xfdc15bde, 0x36e80b02, 0xbfad31a8, 
	0x7a15f89b, 0x0d39234b, 0xeaf5e29d, 0xb6af5e21, 0xe6bd53d7, 0x6bd53779, 
	0x171adfd0, 0xd5e61931, 0xd9314dc6, 0xf2dad883, 0xe40d02cc, 0x3bd419f1, 
	0x00b3c798, 0x58bcb5fe, 0xf580fd27, 0x277cf29b, 0xc5c25df9, 0xf0a7b7ca, 
	0x15fb1bf3, 0x57bd3faa, 0x86d87aa1, 0x95ff208e, 0xc03c79e3, 0x0699fddc, 
	0x0b9ce020, 0x8ba04460, 0x8290c2fa, 0xc62c61e7, 0xd140ef3c, 0x9dc84d3e, 
	0x903ed4c1, 0xb80b83f3, 0xcb41f07f, 0x3bf602c0, 0xd70dfec6, 0x3e4a7e01, 
	0xabc90e07, 0xfb6b8eb0, 0xf6c19d98, 0xa0802d9f, 0xe39bfb91, 0xc507f18a, 
	0xf18afb31, 0x5331c505, 0xf8017c44, 0xb20c6462, 0x8f9d794b, 0x69b52d67, 
	0x0c79c2bc, 0xff2a76e3, 0xba33e5da, 0xa8dd721d, 0x7bc27edb, 0xdf780e7c, 
	0x9bdb9e38, 0xf4162fc6, 0xbb9e7558, 0xefee09a8, 0x4a264fe9, 0xc72b4ded, 
	0x790b8dc5, 0x316103a9, 0x89ada00d, 0xee8bf9d1, 0x738a2a63, 0x6e0517e3, 
	0xd7d2fc08, 0x57ebe296, 0x84b2fbc5, 0xaf8c7e8e, 0x0c6c431b, 0x1271a1d2, 
	0xffb05ff8, 0x2fe4f1c8, 0xd1af8e31, 0x2711f90e, 0xfade411a, 0x18dd2c4c, 
	0xb27941a6, 0x960e6faf, 0xd9f512df, 0xf8f23667, 0x5f0fc7f5, 0x2fffef04, 
	0x8438a94b, 0x0d5bca65, 0x3683f37c, 0xed7a816c, 0x237ba8fa, 0x75b9e7c3, 
	0xde7c7cc6, 0xf987d3df, 0x84dcdd1f, 0x493a40fc, 0x3389c13f, 0xbfa23a4e, 
	0xf37c0260, 0xf0303df3, 0xa13f0587, 0x410c05ee, 0xfa126b3f, 0x7b6ebc8d, 
	0xf8474f00, 0xb09fc207, 0x31e5c66c, 0xda5b1a05, 0x03b497ae, 0x1f61e61e, 
	0xb3d2d7aa, 0xc55ba219, 0xbce49551, 0xa5f1e702, 0x1d611540, 0x2b3aab55, 
	0xd03cf063, 0xe789543b, 0x733ec1dc, 0xc6b9c60c, 0x42ce5c79, 0xe63fdcdf, 
	0xf35e780a, 0x069f092f, 0xd9f63578, 0x941f3efd, 0x551217e1, 0x7f8e5035, 
	0x04557f7d, 0xa7bbef4a, 0xf981bff4, 0x4fe6036a, 0x55031e51, 0xefe41cf6, 
	0x7489cf39, 0xa4a44e7e, 0x05cbf3f8, 0x3a5818ee, 0xe0a17ff8, 0x390b93fb, 
	0xceba684e, 0x97385ff9, 0xae78bdb5, 0x103a3916, 0x2fcf1cd0, 0x58d1fa10, 
	0x0066f569, 0x53e427df, 0x9bf8c0bf, 0x9bfc8759, 0x6d3b5f51, 0xb8c386ff, 
	0x25af763e, 0x48580afd, 0x5ff1e7e4, 0xbc4b3e22, 0xbf1a3f84, 0xacf9e8fe, 
	0xe4e38527, 0x158e56ae, 0x97dbc9e7, 0x77f64bdf, 0x9cafcb88, 0xf305d68f, 
	0x80fcfe5d, 0xa5863f57, 0x3b0e35e2, 0xe0943ff6, 0xdd84e5ef, 0xce9652fe, 
	0x9f88157b, 0x8fe261ba, 0xe8d41e04, 0xd4295e3c, 0x709f5e0d, 0x0c4d91f7, 
	0x69e35fec, 0x1cf78d23, 0xdb0adf22, 0xfeff43aa, 0x96557028, 0x47902ec1, 
	0x8c1aab90, 0x83d7007f, 0xd1f80daf, 0xf09a34de, 0x6352ec1c, 0x4f725d99, 
	0x3b5937b2, 0xb9e86e48, 0xff1347b4, 0x8bf14430, 0x95783476, 0xfd8716f7, 
	0x31a6f610, 0x768a380a, 0x96a9df4c, 0xb036a9d8, 0xc59caf43, 0x9d85254e, 
	0xee92ed12, 0xe8ff491f, 0xd495ec63, 0xf88fa93f, 0x91fdeb9e, 0xe57f97fa, 
	0x6997e44f, 0x81ff30a0, 0x617e1a7c, 0x07b8e593, 0x78b74b31, 0xfd07ec7f, 
	0x02ffc2bd, 0x2ffc8897, 0x3cbff08f, 0x1cf2ffc2, 0x74bf720d, 0x12bff0a6, 
	0xe31f8f82, 0x0533e55f, 0xfaa34cff, 0xa67f8296, 0xbc42ff61, 0x9bfb86bc, 
	0x12d135ee, 0x7a13ed5c, 0xcbd85270, 0xf94ea1bb, 0x1cada8c1, 0x22fd7c65, 
	0xfd38acef, 0x40e1c6e8, 0x89ebf71a, 0xb9da7f72, 0x67ebf25f, 0x85d7fb96, 
	0xbe79b87d, 0x370fb0bc, 0xda1797cf, 0x5e5f3c3d, 0x7b60f768, 0x68705ced, 
	0x09ffdd60, 0x31d31ceb, 0x1d723d72, 0xea6f3fa3, 0xef3c958f, 0x13f776fb, 
	0xdf6e3fb8, 0x9e40e7d8, 0xe7532fc1, 0x65ea00b1, 0xa57b88a3, 0x1f9fc29e, 
	0xc47d9cf5, 0x82d9e9bc, 0x10e7203e, 0x4e80bd78, 0xcf686df8, 0x80f18b4e, 
	0xe66f835e, 0xbdffe4bc, 0xf71714d6, 0xbb4ebc11, 0xe2147f58, 0x5f238c7c, 
	0x79471d5a, 0xaf31cc6a, 0x49882b7a, 0x79e3f2ce, 0xba473e25, 0x837180af, 
	0xe1ee04a7, 0x5eb1e67a, 0x1fb6e78e, 0x56eea1f3, 0x52277f7e, 0x9b337ac9, 
	0x13f7bde1, 0x8e406a33, 0x9f90bf7f, 0x98b94837, 0xe25e5ba8, 0x3f13b427, 
	0x5dcb2a8f, 0xf3972f84, 0x136a91fc, 0xfce98cbe, 0x58f76d52, 0xb98f8f58, 
	0x22a7e8d2, 0xfe26ed8e, 0x9fbdf8b8, 0x4b2f2e1a, 0x584c7e73, 0x4f81dbf9, 
	0x798e51bb, 0xfa114a3e, 0x8e721a39, 0xcd50d276, 0x1db907a6, 0x1069e86e, 
	0x995c07fb, 0x702afd25, 0x22eb9c07, 0xd57b40ba, 0x683fd011, 0xfff9dfcf, 
	0x7ff95d66, 0xabce9cbf, 0x4671c198, 0x11e82bf6, 0x5e30c7b6, 0xf426d1f8, 
	0x6d1d66bb, 0x34abf52a, 0x6854f295, 0xfcc32e37, 0x4ce5018a, 0x9d76bfa8, 
	0xf9c5df12, 0x07d4e78c, 0xa17f822f, 0x910ec7bf, 0x6f5cf9bf, 0xfe79ec9c, 
	0xcce429b8, 0xd1b06af2, 0x67e2b613, 0x86274f80, 0x8bba9e40, 0x0f6899eb, 
	0x3e3cf178, 0x1df00472, 0x90e37eec, 0x80df55e5, 0x65e2a8f2, 0xadafc388, 
	0x84bdf7e6, 0x6c1fcabd, 0x728d6f8a, 0x1477ab3b, 0xf58849c7, 0xfcb43e26, 
	0x312cef78, 0x7acdeacd, 0xdd5fee41, 0x327637ed, 0xf795a536, 0x60f2289f, 
	0xde4097f9, 0x01efb8d3, 0x57fe0ebf, 0x46eb90a7, 0xa147b3a8, 0x0e73f18c, 
	0xa066ff5c, 0x0f1c44cf, 0x95aba7f4, 0xd7c4d8e3, 0xbe04dc5e, 0x4294e031, 
	0x2b467ff6, 0xe489a73f, 0xf3f792ec, 0x49ef199a, 0x81a4ff12, 0xb17de2f6, 
	0xc89c62cd, 0x581f9034, 0xcbc7045f, 0x7dc3c716, 0x6dfe03ee, 0x70e37e84, 
	0x0f1c0d5d, 0x5eed871a, 0x1e24578c, 0x9fcc7c24, 0x7e417416, 0xbc319e0e, 
	0x6295dfb8, 0x53d079bf, 0xdda467f4, 0x488fe91e, 0xfc74617f, 0xfe11fa91, 
	0x2df9e808, 0x7f70efe8, 0x233ffa44, 0xf49c91fc, 0x96370047, 0xfc85bf08, 
	0xf317b491, 0x9497e879, 0xc0a723f8, 0x21c5791f, 0x48fe6517, 0xffc78663, 
	0xb7ee01b5, 0xfe3c5d1b, 0xfc793bd7, 0xd4b638df, 0x49f6978f, 0x54f32e9b, 
	0xba37fe3c, 0xc6726e76, 0xc64c6aff, 0xcc1573ff, 0x76149f17, 0xa79760bf, 
	0x1e45718b, 0xf39c51a0, 0xf519be0f, 0xfe393beb, 0x88a9fe56, 0x7d85fbbf, 
	0x527fe394, 0xc8581e1c, 0x9380b671, 0xc9c25cc6, 0xcf5f2b44, 0x7e9019e0, 
	0xc274ef9c, 0xf2295ed2, 0x53c8a267, 0x49b21acf, 0x4b9ca7ee, 0x519f01ee, 
	0x3c08a74e, 0x3947f947, 0xfcfdc875, 0xbaddb947, 0xd083436f, 0x7e077ed3, 
	0x07bc639c, 0x891c795a, 0x9b1c62e3, 0xba268fff, 0xcf7857e7, 0x2d997807, 
	0x63da83ee, 0x7296390e, 0x8d976436, 0x514f48cf, 0x34ced05f, 0x3650fbe0, 
	0xe50ebb33, 0x9cdf796f, 0xec53dd10, 0x3f1fb833, 0xcde7cb8f, 0x2ccf1e09, 
	0x84bf7947, 0x7eef55b1, 0xf1835d50, 0x11d58a79, 0x15e3178e, 0x99e23baa, 
	0xd07b5960, 0xedcf2ed9, 0x0b9c6396, 0xebf7e6e3, 0xedd99efc, 0xccee4636, 
	0xebfbb7f3, 0x1d0020c2, 0x23da165e, 0xceb804f2, 0x6aaefd95, 0x3f3de75c, 
	0x013abfba, 0x685f3bcf, 0x909081ac, 0xaba477dd, 0x4ef7e306, 0xffdf4f11, 
	0x863507e6, 0x3fc0f31b, 0x69408da9, 0x3b18ae05, 0xfd4cca05, 0x41a763d3, 
	0x73d0f379, 0x568b8c41, 0xe137d955, 0xcfccaeb9, 0xaf980dae, 0xf2b3bc63, 
	0x6016f7f1, 0xe3e570de, 0x194aff77, 0xc3d73c57, 0x2e743f7b, 0x5e70aeb9, 
	0xf5af9252, 0xaf51cf00, 0x5ca50f82, 0x3c419fa8, 0x7bf8772f, 0xf38917bb, 
	0x0e3c45bd, 0xca4cfa0a, 0xa1ff0653, 0xfcf9c15d, 0xac9e44eb, 0xaadde78f, 
	0xe084fdc4, 0xe74d9333, 0xf7899738, 0xeb46b965, 0xc65e6175, 0xfc1e702f, 
	0x09e50567, 0x64fcf0ff, 0xcf38ffcd, 0x4a303926, 0x13e5df9f, 0xa6c34df7, 
	0xe175f742, 0xef3c036f, 0xc26cd4bb, 0xc61046fc, 0x2afa86af, 0x7ea699bf, 
	0x5c7f7831, 0x73f87df1, 0xcdfc5f21, 0xbdefce9a, 0x2fc42e99, 0x0bab52ff, 
	0x037f0563, 0xfecb8094, 0xfe8d3361, 0xa3dc5fa0, 0xb8619c1a, 0x7019c074, 
	0xc09b938b, 0x764c6dee, 0xd6c71147, 0x50e9d200, 0xb97d8b0f, 0x7c520f9b, 
	0x05e416b2, 0xc2dc75cf, 0x9985ad3e, 0x04a053d2, 0xcaf9e3f2, 0x17b9b31a, 
	0x59103fcf, 0xf3d0b7b2, 0xeebdf097, 0x78c516a8, 0x8bb6ffcd, 0x095fd4f0, 
	0xff5149eb, 0x815e781d, 0xdef00df7, 0x9bb31ac7, 0xc3fc51ce, 0xcf3976cf, 
	0x9ac7d63b, 0xeeccbaf9, 0xb0ce78bd, 0xabd77581, 0x9d375f34, 0x5d99a497, 
	0xd71af78f, 0xff741876, 0x3fce2fce, 0x71da98d6, 0xccefbf1c, 0xef7c7a81, 
	0x5183b6c1, 0x170bd7b4, 0xe9f3fd71, 0x8c732b96, 0xe7853fe4, 0x2e785553, 
	0xe7867a84, 0x6c66df22, 0x22d56b7b, 0x3d630f76, 0x4ffd2c97, 0x3bba8bf4, 
	0x1e7889ac, 0x4f663eb2, 0xc624bcc4, 0x976f7871, 0x8fe62bce, 0x5be8af3c, 
	0x7ec3fc0f, 0xaeebe051, 0xf9cb5f22, 0xbf025ff8, 0x383a3708, 0x8b067a3f, 
	0xa07e46f4, 0xf7bd129e, 0x2e92df21, 0x729de926, 0xb0f907f0, 0x229fc8b7, 
	0x8fcecf7d, 0x5f05bd02, 0x8b7bbe88, 0xcfba20fc, 0xf89bd22f, 0x96f48ac6, 
	0x17e72ff4, 0xe3f25dd1, 0x375720fb, 0xf9e74d3f, 0xc70307c4, 0x708fd331, 
	0x732c7e5c, 0x6dcee031, 0x1fefbf3c, 0x9f8bb87e, 0x672edb03, 0x75de1f7e, 
	0x9b783f91, 0x3a85ff3c, 0xce27cdd0, 0xc78c037d, 0x4f110193, 0x193c4406, 
	0x90f110e8, 0x25495f3c, 0x92def546, 0xd3f705c4, 0xa5f04b93, 0x0bcbe045, 
	0x02f9bfc2, 0x31f74dce, 0x9843eb98, 0x2ef78fdf, 0x59f4a1db, 0xf3473c2e, 
	0xa85cb56f, 0x723b6b0f, 0xde3f21ef, 0x45c6e8bc, 0xf960e01a, 0xcf1f9a39, 
	0x3d61aad1, 0x1ee826f7, 0x924b9494, 0xb72141df, 0xfc3ae2f9, 0xb744df20, 
	0x42fc797b, 0xb9441ef2, 0x26b9276e, 0xe42e3e79, 0x72e4f95e, 0xf7107c8d, 
	0x471e3421, 0x72c3de94, 0xf5e70bf2, 0xf0ba070f, 0x0948cbfc, 0x39c4647e, 
	0x7ba51b3c, 0xb8f30f58, 0x02bef118, 0x5267e2e4, 0x0e710a9f, 0x9c955f5f, 
	0x9dd1ceff, 0xb2cbec9f, 0x7d41bda2, 0xc2cbde77, 0xf05bc1e7, 0x0b4304b3, 
	0x23ebe31e, 0x3121b7bf, 0x82b3f7aa, 0xabfbfbf9, 0xdccd5eb9, 0x5fba7104, 
	0x7b026bdc, 0x9d4be74a, 0x1b486e07, 0xff707f30, 0xb9fa0ce4, 0xed4acbfe, 
	0xf757949c, 0x65f7a56d, 0xda3c0f3a, 0xce3976c5, 0x3ef25297, 0xbce5d782, 
	0xadbfe08f, 0xb9c23ef4, 0xc2cbe1ec, 0x477891ff, 0xe2f81cf6, 0x5bcc29ef, 
	0xee2dcf6a, 0xf1db96cf, 0x67ae62e4, 0xec194513, 0x07faf133, 0x74c5e3e8, 
	0x3aec852f, 0xbf8571c3, 0x6e59f62b, 0x5f7899c7, 0xf375c596, 0xe45fb77c, 
	0xe3dafdbb, 0x600df5af, 0x830c2df9, 0x7c4f57d8, 0xeadbf28b, 0x66ab973e, 
	0xa8e7d603, 0x7cb17315, 0x1c820d43, 0xd78e0bdc, 0x5dafa846, 0xb078ad1f, 
	0x081f9f02, 0x73e1571a, 0xe588f156, 0xa73b4ba0, 0x2ec26bcb, 0x359e73c9, 
	0xb15fbf3a, 0x8bd7f5bd, 0x9e455cf0, 0xee7e90e3, 0x2fafe7c2, 0x3f437762, 
	0xbca30f71, 0xc717757d, 0x9f983595, 0xbd587c04, 0xdfa172c2, 0x79e137ee, 
	0x4ddde61d, 0xf9123f9e, 0xe0327549, 0xf7bc0efb, 0x2fb243fe, 0x2ae30eee, 
	0x98edda2f, 0xb473f1a5, 0x7965bcd2, 0x47e9929e, 0xc9f9255d, 0xd1ce39ec, 
	0x327e453a, 0xb68e7a5b, 0x45c3f5bd, 0x71f3ce78, 0x7df2c9f9, 0x5e29ea16, 
	0x9ed5ffff, 0xa2d6dc90, 0xf25c995d, 0x31644dbd, 0x5f9ec3f7, 0x2f3fe3c4, 
	0x9f94e8fa, 0xef04f6e4, 0x7eed9d45, 0x2a3df95a, 0x7c7847ea, 0xadee9a6d, 
	0xf2eef3c9, 0x84a362fb, 0x922ecfc7, 0xeecb62f7, 0xf3467da9, 0xf9c07c4a, 
	0xf38bf89c, 0xebe0ef05, 0xa31a7ba1, 0x7e4fef3e, 0x78777021, 0x3d7fc5fd, 
	0xfebe4aee, 0xef8bb8b5, 0x72fae339, 0xc5e82dfc, 0x493d32bc, 0xfdc5d596, 
	0xe4dd42fd, 0xb96f1975, 0xf74a3dc5, 0xdb3eb926, 0xe02beb85, 0xb78f1f73, 
	0x1ea26b02, 0x65029f8c, 0xeffcbd38, 0xd43efcb8, 0xc080cbc6, 0xe59e7967, 
	0xb9f024de, 0xa3bbaf93, 0xa0fbc78d, 0x97984def, 0x78b83774, 0x7294d2de, 
	0x58c7bfc4, 0xc7e0e783, 0x2eed3c85, 0xfe4b879e, 0x9cf07ed2, 0x6f18a3ae, 
	0xe2394f65, 0x38d2ceb0, 0x367b8d6a, 0x60005bc5, 0x8cbafe25, 0x7580eec3, 
	0xdf129f55, 0x949fa107, 0xcfbf7d2d, 0xbbf46ccb, 0xbca6bfc1, 0x41d8fae0, 
	0x596ff20f, 0x0df5c71b, 0xff055cf0, 0xb3466fb7, 0x069819a2, 0x1d3da9b7, 
	0x4f1e183b, 0x3a6c2df7, 0xcac74c4d, 0x1e8aabbe, 0xed14cf0c, 0x81ec0220, 
	0x45df5119, 0x9bf658cd, 0x758fb075, 0x30dc3339, 0x2f11dbc4, 0x1376dc59, 
	0xb895fe0e, 0xf7abff74, 0x2b7c30bb, 0xf11aa7c7, 0xa0ed553d, 0x22f6b74b, 
	0xc0d0808b, 0x0783f197, 0x8fa1fbe8, 0x7eb49fd3, 0x0587fa90, 0x29f5cb1f, 
	0x36b4ff53, 0x57a91945, 0xe4143fe1, 0x3050f28d, 0x3dd361b3, 0x7281a485, 
	0x7914db30, 0x3036dd0e, 0xab3d9dfe, 0x426c2f90, 0xc3feb5ff, 0x9872b77e, 
	0xb8a7a5b1, 0xf65f50ff, 0x428de31d, 0xb909a72e, 0x5ed9f7ac, 0x7fd403cc, 
	0x95f74ed4, 0x72107fc2, 0x6377f229, 0x8f5fbf85, 0x1c6383fe, 0x965f78bf, 
	0x07af346b, 0x9ac3cbcf, 0xfdf7db8b, 0xe5267265, 0x18e786cf, 0x5d4fed77, 
	0xe3394be7, 0x8c5ee6b2, 0x8af20bcb, 0xe28e5c71, 0x48dfba3f, 0x18aa5771, 
	0x9b35ae0f, 0xc53ac65f, 0xb5c0c073, 0x67ca51fd, 0xfc2e78c8, 0x9afba736, 
	0xa997a923, 0xc87ac95e, 0x0603d82f, 0xc3ea1faf, 0xe338f657, 0x3f2570b7, 
	0x436b5937, 0xb57a06fc, 0x68cecdfe, 0x79d8cbc2, 0x75ea863b, 0xd801f5d0, 
	0xccf10ea7, 0x4f81e7b8, 0xb06eafb0, 0x6f5f2abb, 0xbeb1f904, 0xaa34799d, 
	0xffba115b, 0xfdf45966, 0xda9f2c1b, 0x89ed3bc3, 0xc6dbfdf8, 0x17fe3705, 
	0xf8af49ea, 0xcb636ede, 0x9749ffc2, 0x11d5d8b3, 0xb8ebdbf2, 0xf65ea11f, 
	0xc2d46ff5, 0xf414bffc, 0x7806bd85, 0xfff24b5e, 0xf07de068, 0x8000be5f, 
	0x5e71df81, 0x03d0aa09, 0xd3be608e, 0x726ef928, 0x0db7ab7b, 0xdc4f0bfd, 
	0x5e3ca00a, 0xe06af229, 0x788c3faf, 0xd40ef147, 0x7bf18e6f, 0xf3179def, 
	0xd62e78b8, 0xa9a77bf1, 0x987ca13f, 0x8ff03bf4, 0xdc75a1e2, 0x070f08df, 
	0x61bfb87a, 0x46fe9d7a, 0xbfb9b740, 0x1bfa4eb1, 0x011bf936, 0x604c6fe1, 
	0x2098dfdc, 0xc2098dfc, 0x0b6098df, 0xb0b6f93b, 0xeba39d57, 0x0e79486f, 
	0x0dafc596, 0x1647ce82, 0x16a078f3, 0xd43ce2ea, 0xef9a7ef5, 0xf08dfd03, 
	0xf2bdb5f0, 0x9f7cb7bc, 0xdf9467e8, 0x25bc0c83, 0xdf7e53f6, 0x1bfad3f1, 
	0x1df4a267, 0xc63bea0e, 0xcb16877f, 0x7e74aff8, 0x626383c2, 0xfe8cb71d, 
	0xdf8bea3a, 0x1ff894e5, 0x7fc62f38, 0x7fc62f38, 0x475d0487, 0x8dfbfe7f, 
	0xd9af9d10, 0x2c5d36b3, 0xc3bcc5c6, 0x0bcf6e1e, 0xbf2e7ef5, 0x73c61298, 
	0xddb6161c, 0x647c7798, 0xef7bcf31, 0xdc419d46, 0x0f76e5a9, 0xbc92a082, 
	0x7bfdb964, 0xfe697178, 0xd04a9f2a, 0xbee15d39, 0x67e1c426, 0xbf600fcd, 
	0x895af43d, 0xf8c55dff, 0x712afe3d, 0xdc4abf8f, 0x958aafe3, 0xeca3efc5, 
	0xff85877f, 0xdfe1eb8d, 0xbc2e99a1, 0xec5abd9f, 0x81ea156f, 0x239e1fd8, 
	0xaf28fec0, 0x697db671, 0xccb4ff74, 0xc73f6def, 0x569f19f7, 0xfee01ffe, 
	0x155ffa36, 0x8b95d7c0, 0x965d7c45, 0x0cff219f, 0x1768d0e4, 0x79ca3ff2, 
	0xffd14098, 0xa5d58cd6, 0xe3dca2f3, 0xfae258bc, 0xf51f0fc8, 0x098feff9, 
	0xc1ec7ff9, 0x98ecc2ef, 0x4a0b7b67, 0x9e60f31f, 0x7995bc2d, 0xcb66cf28, 
	0xdb87eafb, 0x3d5f76ce, 0x79e2ed1c, 0x4a259fb6, 0x76fda1ee, 0x1307bf31, 
	0xac9c61d6, 0x6f3e0768, 0xf0d6e8ea, 0xa9fa431c, 0xfe4bbf32, 0x2b5703a0, 
	0xfab8e7af, 0x70efc20f, 0x8179024f, 0x343a8475, 0xe002f786, 0x3dbcc34f, 
	0xc3bc0dd4, 0xf4107985, 0x571ea06b, 0x9f133f78, 0xf598461b, 0x09e41e7c, 
	0xc6eb8396, 0xfb418adf, 0xcd994be6, 0x624ff78c, 0x75a1bcff, 0x7d3dcf3a, 
	0x5df435ed, 0x14a7b436, 0x56f203f0, 0x2fe893a2, 0x7b5f10e2, 0xefe5eb44, 
	0xc7942877, 0x7e625db7, 0xe7b3d68b, 0x79e50d6d, 0x8f2d6b61, 0x745753ef, 
	0x9430f53a, 0x43a46e65, 0xde3664c0, 0xb9efc9f3, 0xfe0dde3a, 0x1237eb53, 
	0x6004f92c, 0x37ef904b, 0xfbd96600, 0xc52bf06d, 0xaff841b8, 0xbd63a667, 
	0x5377f29d, 0x2becfef8, 0x107df899, 0x0813eb93, 0xb65fcd0b, 0xe6a99afe, 
	0xbe11fa00, 0x73d64ee8, 0x3c77d001, 0xd558c7bf, 0xf44fddd1, 0x077f4148, 
	0x5d3c403d, 0xbef97fe8, 0x77d0576d, 0x3756c926, 0x13c4f7ce, 0x9fbee20d, 
	0xeaa8fc4d, 0x3ae38ed0, 0x4edac9f3, 0x4f6c15eb, 0x30afd8b0, 0xe43d189f, 
	0x05ab7182, 0xf777e43f, 0x870fa778, 0xfbe2e807, 0x23fee769, 0x7a48ffae, 
	0x31dc5f24, 0xadd20e73, 0x2dcdd046, 0x748354f8, 0x9db973c2, 0x1c629f62, 
	0x2ad3e0b7, 0x7dad7c1d, 0xd3a217c4, 0xefc8be08, 0xd61f249c, 0x601a1f02, 
	0x174e41dd, 0x973f6be2, 0x0b9d2733, 0xe717ebeb, 0x3de3205f, 0xa441e380, 
	0x5c8ebfeb, 0xee8eaacf, 0x178e453a, 0x5e523a27, 0xdf31d249, 0x83774657, 
	0xbc14f9d1, 0xae84b537, 0x56d7400d, 0xb1f24718, 0x9e127ba3, 0xbfbf405f, 
	0x3af9fe45, 0x3e74a5b4, 0xb37ee611, 0xdbe72b7b, 0xa4838eaa, 0x12bed017, 
	0x1d55dffd, 0xff51d7cd, 0xa549b458, 0xb1dbc1fa, 0x0f7e397d, 0x722cefb3, 
	0xb469dba0, 0xed0fd28f, 0x7e3f59d0, 0x67ee5357, 0xf0332e2a, 0x8cf6f021, 
	0xf78fafc0, 0xeeff5b37, 0x0c66feac, 0xff5dcdfc, 0x8c337f7d, 0xcff405f9, 
	0x58af1003, 0x75f82798, 0xea17e617, 0xfb00bf31, 0xbe285f0e, 0x8b71155b, 
	0x6502e3f4, 0x81e77bf1, 0xf79c7af3, 0x15f69606, 0xce680dee, 0x2cb86ebc, 
	0x7c573f3e, 0x4b8beff3, 0xb16ebaf3, 0x577e00ce, 0xd5df8fdb, 0xa39fbc42, 
	0x0a8cbb79, 0x620df7c7, 0x9d62d5dc, 0xee15afbe, 0x653ad037, 0x28f3001e, 
	0xf2823cf2, 0xf585ed21, 0x39df9cba, 0xf226bfb8, 0x08970220, 0x9f60ef97, 
	0x2dd07f3a, 0xb7f72ef8, 0x50c19ec1, 0x067cfe3e, 0x2fba28fc, 0xc14e7acf, 
	0xc0017d7c, 0x6eb413fd, 0x4f8a4ed7, 0x93976798, 0x2ea34b9e, 0xee5c23d7, 
	0x663c7036, 0xb3e22915, 0xade38fbb, 0x9a740151, 0xc44ed23b, 0x0b709d85, 
	0x9db9365c, 0x106ed260, 0x05db97ee, 0xe21cfbc2, 0xf7d4e009, 0x521762cf, 
	0x131d99ac, 0xb12a9fb8, 0xf9cfa413, 0x162fa17e, 0x27692797, 0xf6af116a, 
	0x6c03b48d, 0x1e09434f, 0xdb80b285, 0x6cf11fd8, 0xcb4781d0, 0x68191e38, 
	0xb3845217, 0xf9251296, 0xc4533b24, 0xe39f9b7d, 0xeb97dc48, 0x53d7c3df, 
	0x1c717885, 0x018097cf, 0x0b4f3093, 0xaeff0f78, 0x74babc46, 0x3f01fae4, 
	0xa83f785c, 0xfb892eea, 0x5e272eb5, 0x4011bb49, 0xf039cfdc, 0xa085e24e, 
	0xe39da07f, 0x96bf017f, 0xa73afc70, 0x35d8281d, 0xfc4f3e7e, 0x7b6e7638, 
	0x70e7f640, 0x4b541ed1, 0x94fdcb7a, 0xa46a83d9, 0xf891beef, 0xa9dcf6cf, 
	0x4907d894, 0xda95cfff, 0x5327b203, 0xe9393cb8, 0x4edf585f, 0x0f616f41, 
	0xfc487ca4, 0x2de9ca37, 0x3d995eed, 0xe2598660, 0xb8ec1457, 0x0bb4bfd8, 
	0xf1ff8855, 0xb207db73, 0x9b92510b, 0x8e0e74a5, 0x0ace20f6, 0x85da41f6, 
	0x390bb42a, 0xe2f61761, 0xe42ec1fa, 0xf500f68a, 0x2777bf0c, 0x62fe013b, 
	0x3d74bdbe, 0xba75535f, 0xc6fd8f47, 0xbccf9e50, 0x60e77f94, 0x34d0f9df, 
	0xbf18332a, 0xf7c7398c, 0x67aede1c, 0x17ffa455, 0xca93c719, 0x97ca0de7, 
	0x32b4a98e, 0xd889fe38, 0x5f89c521, 0xdfbeca63, 0xd9d9fca8, 0x9d770dc7, 
	0x7ae39c51, 0x186ddc71, 0xda0ad9ce, 0x71d71a03, 0x8bf2ad1f, 0xb8c51702, 
	0xbf304263, 0x3f8e19f1, 0x7ecfc61e, 0xfa4fe386, 0xf0dfd78c, 0xe67faf19, 
	0x6cfe3c67, 0xff904b90, 0x9cb8b331, 0xd0f3b5fd, 0x7cc4c7f8, 0xb518cf30, 
	0x967dee92, 0x9eb813cf, 0x5ec9ebe7, 0xa83df942, 0x78077dd3, 0xf9557e84, 
	0xfce138ef, 0x17691683, 0x30c34f7d, 0x3a75e2ac, 0x7dc4d2cf, 0xfdca5944, 
	0xfdcf5df5, 0xc650f583, 0x786ad4a0, 0x052efe3b, 0xdfc20fde, 0x85dfc0ab, 
	0xf73d78da, 0xdfa4b043, 0xfbf08bdf, 0x16fbf84e, 0xff1e6fd4, 0x628da31d, 
	0x51fbf89d, 0xbbf8b788, 0xe187e852, 0x3d511aef, 0xa31f7fc6, 0x7de057e0, 
	0x8f7865cd, 0x70187011, 0x6a876c12, 0x8fdf41bd, 0x2fe8e9b2, 0x7fb9ec1a, 
	0xbfbf463a, 0x3b01ed68, 0x8fc61db7, 0x131e3ac2, 0xb830a8eb, 0x661558bf, 
	0x7afc1539, 0x10075ba6, 0xe0b8e437, 0x46973c27, 0x19998c7c, 0xbc7077f4, 
	0xf8f9f30d, 0x188bcc7e, 0xf012bfac, 0xfcf5cf6a, 0xb1e71a9c, 0x423f2906, 
	0xbfe1b7bf, 0x838bdf9e, 0xe34296fe, 0x1ce8079b, 0xaefe13e0, 0x3ae33fdc, 
	0xff52fe3b, 0xc0fe92be, 0x41ef051f, 0x6952536a, 0x2c30fb46, 0x1815fdfa, 
	0x3c8762e7, 0x012e7868, 0xdf17e9fb, 0xfcfbc3f1, 0xfb93647b, 0xfff4e5d5, 
	0x1ffff3a4, 0xc5ba6729, 0xef5cece5, 0xfbf9cd41, 0xcbee52ae, 0x7e23d2e5, 
	0xebc5e117, 0x227bce39, 0xe5cabe5c, 0x5f2165e6, 0x7abe0b2f, 0xfa557dc4, 
	0x8a5bac3d, 0xbf4593bf, 0xf8ac7297, 0x749f2a3b, 0x459f1e5f, 0x925cf574, 
	0xf4fbe852, 0x9f73f728, 0xee3aba45, 0x81b98c07, 0x61b1df89, 0x175fee2a, 
	0xbc35adf7, 0xa77e4a4f, 0x163cc199, 0xf5c51fde, 0x74eb9d00, 0xa875df2e, 
	0xbf7f0ccf, 0x631fc44e, 0x466f3f29, 0x59daeff8, 0xdbb52c91, 0xb3316ed4, 
	0x0156f90e, 0xc7bf0d8e, 0xff404f61, 0x63c83969, 0x9df8a968, 0x8f786dd4, 
	0x737d7cd3, 0x3553df8a, 0xbe2a3f40, 0xbd726d1c, 0x6e77efc1, 0xbef158b6, 
	0xc43be0aa, 0x38e2af76, 0x1b198537, 0xdeac720b, 0xabbbfa50, 0x633f8137, 
	0x5cf938c1, 0xe03e84b8, 0xf68abc13, 0x739426fd, 0x0c8727f4, 0x1bb67596, 
	0xde59abf6, 0xfe0e0d9e, 0xefefba05, 0xe538efa3, 0x0b92e77b, 0xf812aefa, 
	0x390b37a1, 0x724c3abf, 0x3f197afe, 0x27331310, 0x186fbc84, 0xca16e729, 
	0x27ce43bf, 0x158d7ec1, 0xf687f945, 0xdb0efe20, 0xfc15af52, 0xc0e226ba, 
	0x1ef1583b, 0x9e0718af, 0xfeb79edb, 0x4afabec2, 0xe549f5f7, 0xe7a3ee4e, 
	0x9a0dd882, 0xcabffca3, 0x0085b8cc, 0x0004d622, 0xffffffff, 0x00007f86, 
	0x00000160, 0x001e25f2, 0x001e2b13, 0x001e2aa5, 0x001e2c35, 0x001e1aa5, 
	0x001e23c8, 0x001e248a, 0x001e23e8, 0x001e244f, 0x001e23cb, 0x001e28f1, 
	0x001e3e71, 0x001e2e78, 0x001e40af, 0x001e241b, 0x001e312a, 0x001e316c, 
	0x00122d0d, 0x00001e1a, 0x0000210e, 0x001e2dae, 0x00122c75, 0x00000020, 
	0x00025f89, 0x001e2369, 0x00000020, 0x00025d90, 0x001e5e23, 0x00000030, 
	0x001e0925, 0x001e1d6d, 0x00040229, 0x000000c0, 0x00060287, 0x000603e7, 
	0x001e0613, 0x001e01f3, 0x00060783, 0x001e07ae, 0x001e0284, 0x001e068a, 
	0x00060070, 0x000600b4, 0x00060176, 0x000601d0, 0x00000060, 0x00084949, 
	0x001247f4, 0x00124852, 0x00084c19, 0x000844d9, 0x0012479a, 0x00000030, 
	0x001240e2, 0x00124186, 0x001e4245, 0x00000050, 0x000a5bee, 0x001e5d06, 
	0x000a5d2e, 0x001e5d79, 0x001e5b30, 0x000000a0, 0x001237f3, 0x00123861, 
	0x000c3389, 0x000c3764, 0x0012364b, 0x000c3b9e, 0x00123b1d, 0x001e38b2, 
	0x00123b49, 0x001253d0, 0x00000060, 0x0001000a, 0x00032a08, 0x5d83924e, 
	0x00000000, 0x010201ff, 0x00400804, 0x00000020, 0x88cc8808, 0x00000000, 
	0x00000020, 0x01660000, 0x00000018, 0x000000e0, 0xfffc3def, 0x00000fff, 
	0xd806ff01, 0x00000800, 0xd9e2ff01, 0x00000800, 0xffff800f, 0x00000fff, 
	0x000007f9, 0x00000fff, 0xe0000ff9, 0x00000fff, 0xd87eff01, 0x00000800, 
	0x00010012, 0x001e13a5, 0x00037981, 0x7ded9c78, 0xd55c7879, 0x33b9e87d, 
	0xa4ae6677, 0x68ccd199, 0x95f6c797, 0x2363db2c, 0x3031b19c, 0x257d8a36, 
	0x4d89c82f, 0x85b29244, 0x84d9b184, 0x903224eb, 0x0be5f220, 0x96d92477, 
	0x017904c0, 0x8278486c, 0x2049c6d0, 0x26252915, 0xd8570bed, 0x5275a2c1, 
	0x2d382e01, 0xa90bc66d, 0x1282f54b, 0x29086368, 0x339cb7ef, 0x490d84ab, 
	0x9e3fbdfb, 0xcf8e0fbe, 0x3bf2ce5d, 0xf3b97dbf, 0xbdef7bde, 0x210ef5b7, 
	0xa1342bea, 0x61b1084f, 0x777ad0a5, 0x214bf10a, 0x9bf60544, 0xfb127fb8, 
	0x143c425d, 0x6bf109f4, 0xe8f71e21, 0x66fd78ad, 0x739e1d79, 0x8e806ef5, 
	0x01a9dcb0, 0x3d7b356a, 0x1ee58634, 0xd0ad8358, 0xdd78dbc4, 0x10897614, 
	0xd78f4e9e, 0xef42169b, 0xb0c4864c, 0x84b98f10, 0x5d3d73dd, 0xe132ed5f, 
	0xfeb5d0ba, 0x01bfd413, 0x84f9815e, 0xf51afbd5, 0x84862cbf, 0x33cef4d8, 
	0x0bb7ed7d, 0xb4460331, 0x5c44425d, 0x27b5f60f, 0x42b27ee1, 0xb430f2df, 
	0xa7fd2183, 0x349ebf30, 0x42e3780f, 0xab977524, 0x67ce38f7, 0xe10f721e, 
	0x55ed6c3a, 0x32e15b1b, 0x468e5d70, 0x426a8aeb, 0x223f6084, 0x1f65c07e, 
	0xc2776583, 0x0dceb0e4, 0xf79b967d, 0x61b11dd7, 0xad4a9b7f, 0xb846fb5e, 
	0x7f570a6f, 0x4d8110af, 0x783567e9, 0x2079583e, 0x6f3ce7a8, 0xc66c5684, 
	0xac31aff5, 0x8d67ee08, 0x7b06456d, 0xc2177e69, 0x0c2f5027, 0x4c6bb42f, 
	0xd1b45f79, 0xae3dc7fd, 0x4b5eb815, 0xfc1f34d8, 0x46f3e255, 0x17bd2cff, 
	0x583e39f6, 0x8457ec2b, 0x36ad60d0, 0xf04223ef, 0xf3e06005, 0x0fb35da5, 
	0x35b9e0f9, 0x5b5d219d, 0xf341e748, 0x8891ed25, 0xaf9e86bd, 0xd68fab78, 
	0xb52ef151, 0x47a8e556, 0x5fe00788, 0xefb0b7a1, 0x369b7cd0, 0x9e29daec, 
	0x6add7d87, 0xf07516ee, 0x78385bbe, 0x44371f4e, 0x56826b5c, 0xb8f72e88, 
	0x1bc09710, 0x17841325, 0x014beeb4, 0xa1479ee6, 0x9bd00035, 0xdc19f884, 
	0x009e130f, 0xc66f005c, 0x5fad108d, 0x59a1fae0, 0x989fef2f, 0xec3ec3f1, 
	0x7f0be784, 0x4e91b41f, 0xce1b1cfb, 0xbdf4d013, 0x069e036f, 0xbd9f76fc, 
	0x83ddda07, 0xee10627d, 0xf39bb26f, 0x47f1cbef, 0xf2ffa243, 0x1bfff8ec, 
	0x6df587c7, 0xbde885d6, 0x425bee17, 0x2efcc20c, 0x5e3f3f09, 0x32e09ebf, 
	0xfc60f10b, 0xcc18ad54, 0x78fbff79, 0xd38235ff, 0x78ef842c, 0x57de84a8, 
	0xb3ffe1f7, 0xfb97edde, 0xbe7c488f, 0xa34ef117, 0x194a20f5, 0x083dff30, 
	0x077e09df, 0x2daf71db, 0x00d05fec, 0xafff8fa2, 0xee3dde23, 0xac14b4b7, 
	0xa5dc9231, 0xcaf43c23, 0xf01b0115, 0x0a64d3d6, 0xbbb41577, 0x5aa2cd43, 
	0x2dfee188, 0x5f57070c, 0x068860df, 0xd8edc4d0, 0x2e7c24cc, 0x0ade7fc1, 
	0xadcdc3ef, 0xcdf306ff, 0x32e29849, 0x3c45cc5c, 0xe9a46869, 0xb5cc580d, 
	0x384dbdb5, 0x34d0aecf, 0x9228f881, 0x49f189a2, 0xb8c238d0, 0xac16fa82, 
	0x866ff689, 0x1f039d85, 0xe2366ff8, 0xe15aaecb, 0xa7049378, 0x726947d9, 
	0xb7bdb667, 0x93db9f78, 0xf7c06700, 0x06be707b, 0x925b5fb8, 0xc8620f87, 
	0x1c014b69, 0xd2f1c1ee, 0x85be47c4, 0x2ce7587d, 0x27e047c4, 0x097b5227, 
	0x9fafd1be, 0x41bb8ece, 0x6bc7ff9e, 0xe0055745, 0x4bc46add, 0x7c4ff318, 
	0x1773c1c2, 0x20e76462, 0x2616b38c, 0x7bce0fb9, 0xe2acc02d, 0x01d6213a, 
	0x57f7de8d, 0x8700fc42, 0x2eafe786, 0xfd833c03, 0x0856a27c, 0xf8f1e037, 
	0x7837c04e, 0xcf8813ef, 0x527ff780, 0xeb0ff403, 0x77de04ba, 0x7a91fbc3, 
	0x780d9767, 0x879f0ebf, 0xbf8911fb, 0x8bf3e097, 0x7df12f01, 0xf95acb80, 
	0x2da7f23e, 0xbc9d7f70, 0xb2edf30f, 0x499d0077, 0x01f7a33c, 0xa93d23af, 
	0xe8079c3e, 0x8bdf0ba8, 0x3913df00, 0x9bb82f7c, 0x6030edc7, 0x7fdc6a1f, 
	0x2bb53a43, 0x74b864ee, 0xe87320f4, 0x789cdfde, 0xdc8dda02, 0xc2e47d22, 
	0x07293dfb, 0xdc715fc2, 0x00a7c02e, 0x981eedf0, 0x23a7b617, 0xfa4b375c, 
	0xdddb0a08, 0x9713c727, 0x341222e2, 0x788ca209, 0xeba7c78b, 0x90bd7c5d, 
	0x4a5436ce, 0x1d7e04fa, 0xb27e7802, 0x801dd796, 0x4186eefd, 0x08f0093e, 
	0x827e662f, 0xb7a910e7, 0xd0ae117b, 0x2361b6ee, 0x1dc08dc1, 0x4a91bf61, 
	0x7a075077, 0xc175c888, 0x9feb7b25, 0x9e77fdc3, 0xcf85cde9, 0x802e10a7, 
	0x195b9107, 0xe9dd914e, 0x6292a1dd, 0x06e0a3fe, 0xbef6a9fc, 0x20fa5a6e, 
	0x395d6dc2, 0xd259bc3c, 0x3ec3ca11, 0x26fe46e1, 0xe5f13b44, 0x72cebe62, 
	0xfd7c822f, 0x575f3158, 0x69bfcf72, 0x5ee51f8b, 0x81afde21, 0x211ca075, 
	0xf44c3839, 0xd3c69d33, 0x0e510457, 0x7d967f41, 0xea45ca4c, 0xafdc11db, 
	0xa5d242bd, 0xeb7d97dc, 0xeee07098, 0x5c5f006d, 0x9c19d107, 0x90f77fbb, 
	0xcac86dae, 0x75972551, 0x6724cb94, 0xbdd11774, 0xc95ee925, 0x890fd515, 
	0x325fc4e9, 0x5bea2df7, 0x0fbd0230, 0x7f7b9d74, 0xc79194fc, 0xfc936e27, 
	0xf69ae881, 0x3ebc1367, 0x92fe9836, 0xd1c37c46, 0x6003124e, 0x6912e8f9, 
	0x5d3cfd97, 0x323f508f, 0x7fa44df8, 0x7f9ec557, 0x9133a446, 0xf92f3f1f, 
	0x067c24c2, 0x70a75cfe, 0xbe7902bc, 0xfbe814a9, 0xb9f2b35f, 0xfc941f10, 
	0xb20b7924, 0xda76e22c, 0xf18bb51e, 0x0871ec43, 0xe185a2fe, 0x1dde5def, 
	0x4f270131, 0xc775ce56, 0xd5e70160, 0x5ea1ab9c, 0x9dca52b5, 0xf7973313, 
	0xcec87518, 0x00fd15ec, 0x96340bff, 0xf77f4803, 0x2d19fd03, 0xf90295c2, 
	0x1b425461, 0xefcfd686, 0x4dcf045d, 0xff44e783, 0xef9c46a2, 0x69ea8fc8, 
	0x1715ddbe, 0x345bfa69, 0x7002636f, 0xa353657d, 0xaaf4e50f, 0xf1c7774f, 
	0x955d577c, 0xe9e376e0, 0x13cfb885, 0x41ec2e33, 0x00fa463e, 0xc74601e8, 
	0x79a939d0, 0xe8a0dfb0, 0x25bf61b1, 0xe241c057, 0x18561839, 0x3aba5de1, 
	0x048883d4, 0xbf6cd8a7, 0x42c1e420, 0x4bfd05df, 0xf76bfa73, 0x91dfdb37, 
	0xf3f1d6e3, 0x7847de42, 0x85e2f3e2, 0xdf9ebe9c, 0xe92aeb57, 0x7a853904, 
	0xf3dd25ce, 0x11d7586d, 0xfc4d4afd, 0x9c3bc107, 0xaf0c8f2b, 0x7c773f35, 
	0xd3d086ff, 0x2171efb8, 0xcb33adf1, 0xf8ae10d7, 0xbb670bd7, 0xc10366ae, 
	0x37b6d44b, 0x79227c4a, 0x374e69e2, 0xfc78fe22, 0x055fe896, 0xeed0a56d, 
	0xda62c784, 0xef0e9acd, 0x6e31acdd, 0xc26ea8c0, 0x45f58b77, 0x6ef7fb51, 
	0x7fe8d75c, 0x47ff8c1a, 0x7f78e9b7, 0x25eb4fdf, 0x971e307d, 0x48ef3d49, 
	0x12fa4604, 0x7ba4f65c, 0x6302e016, 0x1d70dfc0, 0x51405021, 0xd356b32f, 
	0xe8aa22fb, 0xee1ff6cb, 0x59d53a25, 0x75d4367f, 0x3a199bee, 0xa9d1e6f5, 
	0x477d4bdd, 0x04740bc2, 0x517fdd3f, 0xfcb73a48, 0x8a6827ac, 0x7f1e0d8e, 
	0xa1c3f50e, 0xc02eade5, 0x4e90f383, 0xa47f44e3, 0xe1216897, 0xf2d1fd61, 
	0xbae8d51c, 0x09afd707, 0x1dd7cbcb, 0xee8a44ef, 0x7df34efb, 0xf5a2e39f, 
	0x6089871a, 0x6a11c944, 0xb95792ed, 0xfb927a5f, 0x2fdce3a5, 0x65fb8b7b, 
	0x7fab42ef, 0x74a81124, 0x0fef7e23, 0xf744dd44, 0xe79ce987, 0xa39d120c, 
	0x5f3a615c, 0x6feb4f5d, 0xe873fb52, 0xfb926f7c, 0x17d5b000, 0xee1a6fc0, 
	0x1fc92ee7, 0x7e9545e7, 0xf7e34ce7, 0xf802faed, 0x9ef8f346, 0x83cd17dd, 
	0xd18be2af, 0xe91bbc0c, 0x5e354bfd, 0x7445ad4f, 0xbfdc386b, 0xa041b3a9, 
	0x0b2bb81c, 0xcf5c7adf, 0x94e10c17, 0x8738449f, 0xe1307d68, 0x9a6fe434, 
	0x3d9288e8, 0xf3289c25, 0xabfa7b43, 0x35ff60db, 0xa031e9c9, 0xa7aad77b, 
	0xced0e31b, 0x59f6fcbb, 0xf41007c8, 0xe77de836, 0x8b32315c, 0xb8b0f384, 
	0x8bdf006a, 0x5036981f, 0x40707487, 0x75c56fd3, 0xc1d1e475, 0x88c7b5bc, 
	0xe8de600e, 0x4be78fa8, 0x8cfea36f, 0x319fdc53, 0xa799fdc1, 0x31d33fb9, 
	0x528e6fa8, 0xfd6398eb, 0xca386fd4, 0xe33486fd, 0xac539cdb, 0xe099ce0f, 
	0xdcd3dcfe, 0xfe30eb9f, 0xbf728d35, 0xe7ef8c69, 0x56f38fe9, 0x1ff7d75a, 
	0x2e5816c0, 0x64d79d5c, 0x26fd465e, 0x5a5a8fd9, 0x2ed0c5ff, 0xdaeeaa76, 
	0x988b6d0d, 0x86ebfd47, 0x520aeeaa, 0x119ed97b, 0x2c0d3f68, 0xdabf9f14, 
	0x087fd699, 0x55935bda, 0x35de80f7, 0x7df5bb6f, 0x1bed2fa9, 0x4f3dfc00, 
	0xe788a3da, 0x5b5affac, 0x20fe09fa, 0xe3cf10af, 0xe796cf52, 0x6dea58bf, 
	0x6ff4befa, 0x77be5335, 0xd52ba88c, 0x9d0d700f, 0xc8352a7a, 0xfbe3a9e7, 
	0xbd45f9ea, 0xd3f765c2, 0x18019ef8, 0xfc0bde3f, 0x5fc71da2, 0xeed9724b, 
	0x4aae7b61, 0xf1c1ef3e, 0x371c6887, 0xdb92a3e3, 0xcb4e368e, 0x36d3ee17, 
	0xd10eddf5, 0xa61fada1, 0x255e7856, 0x93de147a, 0x5e3bdd7c, 0x9907a740, 
	0x174e88ee, 0xd5debdde, 0xb12ce304, 0xb9da1945, 0x3e35624b, 0x7ce2c610, 
	0x3fd8185b, 0x997f763f, 0xe1eae780, 0x67f2819a, 0xe441c751, 0xe0da8bdf, 
	0xf8973829, 0x02fb4127, 0x07bce7bd, 0xe545ed2e, 0xca2d39a9, 0x621aee50, 
	0xd78441df, 0x16c5ab79, 0xe39b8fb4, 0xf04dbe30, 0x39e909fc, 0x6df4f313, 
	0x342eb849, 0x80c2be7a, 0xbdfe83ff, 0x83d5b464, 0x91a20c78, 0x790b75f4, 
	0xf9efe00a, 0x09ebddbf, 0xbb9bfac3, 0xecc1f9e0, 0xdb66cb3c, 0xf15b6a5a, 
	0x85af4b3c, 0xcfb892e7, 0xdb843e89, 0xcf3c0dd2, 0x1f1831d2, 0xcb5d17fa, 
	0xa68e8bfd, 0x9f81bfb8, 0x788f496f, 0xf22d1f70, 0x69f7f3fd, 0xf7cbea5e, 
	0xf56e182f, 0xdd6af3e2, 0x714fee17, 0x4f9f8bbf, 0xfcf42338, 0x25fdf205, 
	0xe4479aa3, 0x4b5171f2, 0x1c8178e7, 0x134a722f, 0x1c6047de, 0xdc489eb9, 
	0xbc03eadc, 0x07ae50ba, 0xfb0ab4e0, 0xb5b7aecb, 0x268fa01d, 0x0b3b39f0, 
	0x1d6f6597, 0xde123d23, 0xf383555b, 0x89f0906f, 0x102194d5, 0x83e849a3, 
	0x0b6cdf72, 0x6c435d9f, 0x5d80f44b, 0x53863a29, 0xdecbe788, 0x0066dbac, 
	0x277f2e9e, 0xbc20c87c, 0xfa085505, 0x1fec5ccb, 0xee282f39, 0x79b83d42, 
	0xf7147843, 0x6cb17c09, 0x4c47d207, 0x419f2194, 0xf407d216, 0xff6c4df3, 
	0xddb79f0a, 0x667e7829, 0xae10e1b2, 0x547ef33b, 0x2f48bc04, 0xff0de4be, 
	0x5874e381, 0xbaf00846, 0xdaba62cd, 0x37f3f92b, 0xfa085db1, 0x01c61fbd, 
	0x22dcd8fe, 0x7f8052ca, 0xa17e969f, 0x0462c087, 0xbb78560b, 0x7c226fd2, 
	0x0e1b26f6, 0x5728c3e8, 0xbac1a041, 0x3a7d89be, 0x38ce7b77, 0x89f2e3cc, 
	0xf3837fb9, 0x997aa675, 0xdc328aaf, 0x970edadf, 0x301ca170, 0xcc20d944, 
	0x02e10ebf, 0xd23357fa, 0xcbe7c01f, 0xa2d8ff72, 0x5b25d27d, 0x0bf002ab, 
	0x1b27f8d6, 0x45455c24, 0x52e7d219, 0xbc3b719c, 0xd945cf2b, 0x518ecd59, 
	0x7b074f66, 0x55640627, 0xeabfbd95, 0xf432f2f4, 0x7bd7fd47, 0x1f70fb48, 
	0xfe9ca1fa, 0x7bf9f0a7, 0x3dfebe79, 0xe7819f3c, 0xccb4b43a, 0xe2f3c3d8, 
	0x4fde6afb, 0x67b7fbe1, 0xbf9dcfdf, 0xfd399bff, 0xf5d57982, 0xe3e20373, 
	0x250f4e78, 0x059ae135, 0xabbb49f6, 0x6b768429, 0x08535b67, 0xae92f9ce, 
	0xe3b4269e, 0x6cfdd13e, 0xb7e00853, 0xf963c253, 0x0cfeeaef, 0x7bbdc1f9, 
	0xf7f11d34, 0xff1b27b2, 0xfd8f5b4c, 0x8f9e0554, 0xa6be37a5, 0x2cd4fdd1, 
	0xefbbdfec, 0xb3a8c5d9, 0x73efd11d, 0x1867be91, 0x7eb9efa4, 0x0769e52c, 
	0x972ca3e8, 0xd157c8fc, 0x1e02f1e4, 0x9da0dd84, 0x4e7873e2, 0x037ce85b, 
	0xd7b79e78, 0x927dd30a, 0xed205af8, 0xa782f7a6, 0xf8ce7c5d, 0x90cec2fe, 
	0xf773e3ee, 0x1886f3d3, 0xcf475cf6, 0xd77c3f53, 0x1e50bbd1, 0xfafdfb2e, 
	0xf097a332, 0xa7ee0668, 0x200ad87a, 0x03ed545d, 0xd3fa1913, 0xc2008a8e, 
	0x0acc7ea1, 0x46ea5c20, 0xa1c200ed, 0x080271d6, 0x22fd9a97, 0x217ff788, 
	0x0fde17cf, 0xfb5573e2, 0xae7c32ec, 0x85944872, 0x710b5f60, 0x6377e48d, 
	0xb1f9d73d, 0x0f5063d4, 0xbfeffbaf, 0x89ff447f, 0x2ecf572b, 0x06dfffbc, 
	0x70e4d0f7, 0xeeb31e8f, 0xe1ff752a, 0xde0a9f70, 0x6787bef1, 0x909fbc68, 
	0xb7c7f306, 0x1a73e77c, 0xeb8d3faf, 0xe27d6f8f, 0xaf77ea21, 0x7f00d4af, 
	0x66a577e3, 0xb3be8334, 0x6e05e070, 0x88cc8d77, 0x74597c83, 0xb6267853, 
	0xcda83ee7, 0x66f28c5c, 0x1733a5ef, 0xbef3fdc3, 0x01333ad5, 0xef0fc5fd, 
	0xfe809998, 0x66a5efe2, 0xfe7b40b6, 0xf6e05e77, 0x0266472f, 0x3c17118f, 
	0xfda93611, 0xa1d4cd6b, 0x4be9f0bd, 0x6ad03db9, 0x4626d01a, 0x77fb7076, 
	0xed0fd329, 0xe05fe792, 0x331196f6, 0x82c37a04, 0x1086e1cd, 0xab5c17f4, 
	0xdb425435, 0x6b3c66e6, 0xf5297f5e, 0xfdbc6f9b, 0xcf17b698, 0x9ee77357, 
	0x2ae8a5af, 0xebabbe73, 0x259bfe11, 0x077e56df, 0x1e007bec, 0x8069f23a, 
	0x933066c3, 0xf5664f3d, 0x3c2ff257, 0x9f25d701, 0xf49b7d26, 0xdb1a7b59, 
	0x7ebe4617, 0x89fc676c, 0x89fd73d3, 0xd9b02fca, 0x1b6f9934, 0x2f99eb8b, 
	0xaed2f5db, 0xf018fd20, 0x12768a21, 0x2ded330c, 0x969f5d2f, 0x6d9817e7, 
	0xbd221f4f, 0xe2afab34, 0xfdbdc6fe, 0xde06bec2, 0x4098c2fb, 0xf44ce73d, 
	0x32f500b0, 0x7fb9dfd8, 0x38b3e57a, 0xc979e66e, 0xf0959e97, 0xcefa805b, 
	0x4a9fc909, 0xd84f1926, 0x36855fb3, 0x2692cf7e, 0xfa2fee1d, 0xf9374f5f, 
	0x8bfc5f51, 0x732bb325, 0x5f447fe0, 0xab6046e4, 0x1c3c03f3, 0xbe226cf6, 
	0x5d8ac134, 0x3f19dd81, 0xe467764c, 0xb2b381d3, 0x79bd953b, 0x7846d224, 
	0x6df8bae0, 0x657d042d, 0x6f6bce7f, 0x7b9f70d5, 0x0eb415b5, 0x8aaa87b2, 
	0x4071e9ed, 0xbbabf446, 0xf79fd93a, 0xc3cb3771, 0x1ed997f1, 0x663da373, 
	0x7ecdfe93, 0xc7e782f6, 0x1ce9b65f, 0x83c973d4, 0x877f4342, 0x3f9f92be, 
	0xe595e304, 0xd66e9dc4, 0x50f50e39, 0x975a32f0, 0xdfa13b8a, 0x32fc20ca, 
	0xf5aafd95, 0x6b629e93, 0xefdf6fa8, 0x4e4abf66, 0x9e57aa5c, 0x6cf51baf, 
	0x8a2b87e5, 0x2a3c613b, 0xc36bfd2d, 0xf2287179, 0x1438a997, 0x5e70b9fc, 
	0x65252f8a, 0xc52169dc, 0xdfdb7aa5, 0x951fface, 0x4ee289bf, 0xd7411740, 
	0xa718bd83, 0xee58b64a, 0xe945f214, 0x8574f297, 0x1b429ff4, 0x087154a8, 
	0xa981bf38, 0x3fca4ce3, 0x9c94f145, 0x1fa15338, 0xf202ed0b, 0xd1b8c97b, 
	0x9b97083d, 0xa7e41e09, 0x87e33139, 0xcb5fc8bd, 0x883abfa5, 0xbc8696f1, 
	0xea2f4b78, 0x075b8135, 0x0c7f517b, 0xe1a5bc62, 0xe596f1cc, 0xde73c73a, 
	0xef72de37, 0xaa967114, 0xa14af8e2, 0xae7b2f5f, 0x53846e7d, 0x934bb930, 
	0xe73a2d7e, 0x444f41c7, 0x66f3a5fa, 0x1fc6527b, 0xbde22e39, 0xee2cd439, 
	0xaac9f8c3, 0x30abee14, 0x20be393e, 0x45978a61, 0xfd224e36, 0x723f0aba, 
	0xfa8bc6f0, 0x109e0e6b, 0x2bc4e51e, 0xc1997e29, 0x78a3c413, 0x3e109e31, 
	0xa278931d, 0xc4bd69f0, 0xf049e19f, 0x1177d246, 0x953e20de, 0x21397c48, 
	0x8c57c7f1, 0x692f8417, 0x62f14789, 0x38fc413c, 0xedbe242a, 0x273b7845, 
	0x6c53dfa4, 0x8eeb7b07, 0x440fd1f2, 0x217aa58f, 0x8a770a3d, 0x0f709ff8, 
	0x7a1f7b1c, 0x93bc024c, 0x1547a667, 0xab842df7, 0x8b829b82, 0x2dde9782, 
	0x602dc2e3, 0xd2c86c4f, 0x11c25073, 0xdb90ebce, 0xd3313f24, 0x433a125f, 
	0xfa650718, 0xc8aef823, 0xc79d0fd2, 0x8e43c41a, 0x62f82a57, 0x89efa35c, 
	0xc2327f62, 0x7ecfe317, 0xdbd02fa4, 0x605f48fd, 0xcbaf0437, 0xfdfa678f, 
	0x93ebe882, 0x0bd9c73a, 0xc55cb1cf, 0x78412d2d, 0x11d7185f, 0x605f20ed, 
	0x673bfe7d, 0xf5856cf5, 0xc2e3278c, 0x53574b95, 0xdd11dfd0, 0x694fc9d0, 
	0x73833c80, 0x3fa5b1ed, 0x592e88bf, 0xa39d3aae, 0x7efebb62, 0x9de7c974, 
	0xf7384ba5, 0x65d33392, 0x963e1d21, 0xcc68cbf5, 0x2bc8a7cf, 0x9f89bc40, 
	0xfc332e99, 0x3929f117, 0xf264fe35, 0xc19ffe0a, 0x849c4c9f, 0xd1e112f8, 
	0x91e1fbe8, 0xabaffbfd, 0xd1c605b8, 0x1766edfa, 0x04400dc1, 0x09dc1cf4, 
	0xcb5fa27d, 0xe2a9fd8d, 0x5a77e583, 0x2307c63a, 0x164fad86, 0xfbc00c1f, 
	0xeff60fd8, 0x8cbeff67, 0xf523de0f, 0x194ee0a7, 0x3c9cec1f, 0xbaf5383e, 
	0x8aa45b84, 0x9d70bff1, 0x5a5f5c01, 0xf1497de2, 0xf8bd153a, 0xa75a3c61, 
	0xc1324f5a, 0xd51d2003, 0x3ce97a49, 0xa4297a7b, 0x177a2393, 0x1c214fd1, 
	0xeb3f44ce, 0x91d16fca, 0xb7a54eaf, 0x79afde10, 0x90ffbc1f, 0xc94234f9, 
	0x0aa7291f, 0xa3c940e9, 0xe4863d42, 0xd2e52993, 0x0d1f4906, 0x928c7ac5, 
	0x2b0f8a47, 0x7af086bd, 0x0ac78b28, 0xc7a4cfef, 0x271e3004, 0x9292e58a, 
	0x2e63c6d3, 0x863dfd03, 0x394a9bf2, 0xb821e6ad, 0xaae3b3a4, 0xe18fea78, 
	0x4256e379, 0x7ef842bf, 0xc6ca9c59, 0xb5a184e3, 0x733879f2, 0xbc046fd0, 
	0x9b918e63, 0x0684812f, 0x6d480ef2, 0xada7af2e, 0x1137c71c, 0x37df301e, 
	0x38f5a1ac, 0xf3f521bf, 0x167c6507, 0xdf8a65f5, 0xfd131e6e, 0x56a5ef80, 
	0xf3c1f448, 0xa978aa0f, 0x321cc571, 0x3f255bc2, 0x42dc48ee, 0xfd3051fc, 
	0xe7b3eb5c, 0xe0fec93c, 0x2607a7b9, 0x4d3a878b, 0x19129eb8, 0xdcf1369f, 
	0x3ef367d7, 0xe702fcd4, 0xed1a7807, 0x152eff3c, 0x2f2298a7, 0x0b1eb324, 
	0x765973d6, 0xb75d603d, 0x268dbcca, 0x31fadbb4, 0x9df9044f, 0x38c6cd66, 
	0xcf23f8c6, 0x6ffc96ce, 0x7ae93db6, 0x23cf412d, 0xea5db301, 0xfcc9bc50, 
	0x67984bca, 0x718e4785, 0xaff3958e, 0x9caf7fa2, 0xfc8dbafd, 0xdc373355, 
	0xe3e4f187, 0xb6ebe235, 0x2f98673a, 0x0748f2f1, 0xe7313a6e, 0xf8468778, 
	0xf1c75ab0, 0x82bb3496, 0xa6ce7a5e, 0x22e6387e, 0x698df27a, 0x9f43bfa4, 
	0x23bef1e2, 0x1578859a, 0xdf48450e, 0x4ec1f9f7, 0x74753a21, 0xa2088786, 
	0x69d13f9f, 0xc2491897, 0xe98f8a77, 0x9412ac9b, 0x2d41fa2f, 0xe167fec8, 
	0x2a26fdc5, 0xfa8a609d, 0x77d71796, 0x0bd61aa2, 0xb16240fa, 0xb1f92058, 
	0x312f7c86, 0xf300bdd4, 0x59deda36, 0x37e6e5ae, 0x2560b8a8, 0xc48f6434, 
	0x33f90d6d, 0xe41efed8, 0x1ae6407b, 0x573031c2, 0xab3ae08c, 0xb861e584, 
	0xcfb61eda, 0xe2c4bdf9, 0x83e202c4, 0x3483e631, 0x83e012df, 0x660f951e, 
	0x472ef3d0, 0x37c737e1, 0xd70724f0, 0xe4ec3848, 0x80e9f93e, 0x1b43f53f, 
	0x85e798b8, 0x05e620bf, 0x71f41882, 0x6208a05e, 0x74d2605e, 0xd44e38bc, 
	0x3f462f4c, 0x898dd94b, 0x0b27b312, 0xb1ce69d7, 0x90ef1cc5, 0x534b4bf1, 
	0x5f8cb576, 0xae7ae4ba, 0xa4bc38e0, 0xf6d998d7, 0xb5c02552, 0xc5f5ac69, 
	0xb033ca4a, 0x909a8e28, 0x7992c0fc, 0x4da4c975, 0x9d9427f3, 0xfa604b0c, 
	0x7fc82c6a, 0x239af390, 0xb958c7d4, 0xf4c95fbc, 0x3ff79210, 0xf68e7e45, 
	0x7ee52f3f, 0x3fd4ebc7, 0x7a7e5ff9, 0xf79dedbe, 0xd5982e28, 0xe4b5edfb, 
	0xf1e46907, 0xc3e5b692, 0xc271acf5, 0x929ffa3a, 0x4af04d8e, 0xcc9f1d26, 
	0xf08e3083, 0x6a7e327b, 0xbea29e95, 0xc67c4a53, 0x5c02c802, 0x36ef2e4b, 
	0x956eba0c, 0x816dffa1, 0x708eca70, 0x55e061de, 0xcd6bbd68, 0xa8097ee7, 
	0x3f3a22bd, 0xa2eba210, 0x4d35e702, 0x73a6c2ab, 0x7cf82bb1, 0x979e0a9d, 
	0x5e5503f3, 0xc62b0ea0, 0x0d7496e7, 0x2cc9009e, 0x7ce19b82, 0xd8dd3ed0, 
	0x1fa1d7ee, 0x83c4b8a8, 0xb880f671, 0xeb87efca, 0x77b49d17, 0xe58883da, 
	0xd67196c2, 0xa8a7e96a, 0xbc8079c1, 0x275f8f9d, 0xd116eb44, 0xcfe6fe8a, 
	0x61e93fa0, 0xee875d3c, 0xe5fe0e7f, 0x59aeeb85, 0xd2371f40, 0xfbe4eb7a, 
	0xcf9eb875, 0x90b13ca8, 0x5fcfcea8, 0x0b6fa8b1, 0xd4629f95, 0x6bbdc5e4, 
	0xf9e86a3b, 0x31afe956, 0xfbe65aad, 0x2667e621, 0x6f67a1cb, 0xef58a319, 
	0xe4540035, 0xc2739f9b, 0xff407cab, 0xd57dcaae, 0x0f002db1, 0x7865acd3, 
	0xe795af6d, 0xfd847b54, 0x6a697553, 0xb567f22d, 0xf1ea47a4, 0x5d22b67c, 
	0x68fadf01, 0xfc8f553a, 0xfd0915c5, 0xad28e31c, 0x1cfc0f65, 0x8367e1f9, 
	0x2303fdd6, 0xc3d3bf38, 0xf4d6c07c, 0x9bfdd9ad, 0x3a661718, 0xe7f138a0, 
	0xfe305d71, 0x03058c7a, 0xbb60371c, 0x469df418, 0xffc70ea7, 0xfc887742, 
	0x804789f7, 0x38df893e, 0x12fcf0d3, 0x5f7865c2, 0xda3bf587, 0xf42d7134, 
	0xf3e63c65, 0x1d01c34e, 0x7df8dde4, 0xdb1f887b, 0x7d131a5f, 0xce513f8c, 
	0xf8a271cb, 0x2e78cdfe, 0x21d5a740, 0x1316f8e1, 0x4f896adc, 0xd5ffcad8, 
	0x29e19d36, 0x446934e9, 0xc507e40b, 0x9f8b6dd5, 0xf9661f1f, 0x0636dda3, 
	0x16e2163b, 0x119bafb9, 0x73a04fde, 0xc1cb6c6d, 0xda8eb4ad, 0x0f195bc3, 
	0x7ebf728e, 0xdbc92b7c, 0x386fd2e9, 0x74c39e5d, 0x7dc9fff2, 0xca77e908, 
	0x72c105ca, 0x2e5267e1, 0x0eb1cbfc, 0x172c37e6, 0xc816d7ca, 0x0b967685, 
	0x0b94a8fa, 0xf4172ced, 0xc42e52c3, 0x3ac02e41, 0x71a5bf75, 0xb933989e, 
	0x908d085c, 0x5ca0f05c, 0x283c7180, 0x523d7817, 0x14c1d82e, 0xc2e40bf5, 
	0x039209a3, 0x02d6a589, 0x1f281785, 0xc773bf56, 0x974172a4, 0x1219ef78, 
	0x9910171e, 0x943470cf, 0x280e4a0b, 0xa96400b9, 0x3f05cbe5, 0x2df347bd, 
	0x59baf9c1, 0x3e59c43e, 0x2e467dfc, 0x0b90a684, 0xbcf83696, 0xfb844384, 
	0x2c3667e4, 0x58aebfad, 0x583c902e, 0xf3c1e52f, 0x4fa03959, 0x951c0725, 
	0x072452b7, 0xb6f5722a, 0x97d6d1d8, 0x4dbf612a, 0x32072ca3, 0x19e307f2, 
	0x77141f8c, 0x7c407900, 0x6887c94e, 0x9df34d2c, 0xe0a87c85, 0x0f94bc38, 
	0x73f508f6, 0xfb1543e4, 0x0f90a7bd, 0x37d43bc6, 0x57ff18bb, 0xbdb87ca3, 
	0x39883e58, 0x1d61f2f9, 0x396387ca, 0x23f9c1f2, 0xb34f87cb, 0x25b8b87c, 
	0xef881f23, 0xc4a87c83, 0x543e4079, 0x4a947cca, 0x75540f99, 0x1543e594, 
	0x3e5211d9, 0x1f294f94, 0x0f925e22, 0x20fe8db1, 0xb49e97f4, 0x587ca177, 
	0xf59ffc85, 0x87841aa9, 0x3f78322b, 0x646bc3f2, 0x72d8017c, 0xce1e6e4d, 
	0xd7d2af2c, 0xf8aeba2d, 0xcf62abbc, 0xbdf7182b, 0xec8f9326, 0xad0f5078, 
	0x938744c6, 0x46dd7cf9, 0x3da1f2bb, 0x9f01876c, 0x1c13683b, 0x4c279f88, 
	0xc7488fe0, 0xcce4829d, 0x1df99306, 0x0fba3ff0, 0x1f65353c, 0x3aad79c2, 
	0x237b77de, 0xe1b3d1e1, 0xd7fce39f, 0xa97f98c6, 0x21983671, 0x6d221b92, 
	0x8fb19c90, 0x49093c4a, 0xa8f123b9, 0x78457d70, 0xfd4f7e23, 0x4cb73fd7, 
	0xabdd41d1, 0x4feb0fcc, 0x6843f0e6, 0x081b8d67, 0xf98bcb6f, 0xb57f173e, 
	0x8bdaaeb3, 0x38f4bbeb, 0xece551e5, 0xf907afbb, 0xf9629da2, 0xbbd17cc0, 
	0xe8be21cc, 0xf89a5afd, 0x9e77eae2, 0x2febe4f1, 0x20d727cc, 0x74f7849f, 
	0x92937334, 0x6c5f224f, 0xe9ea1611, 0xf9293e19, 0x06c9f122, 0x1b5b7fc4, 
	0xc8bdf784, 0x5eb4d317, 0x2e2f8f3d, 0x75d08006, 0x89e8f887, 0xa79f5e6a, 
	0x46a48ed2, 0x94c7bde1, 0x9078ec9e, 0xb11f7a0f, 0x42e6f4f2, 0x34fc883e, 
	0xf7abd70d, 0x3d5c9e59, 0xcfde06b9, 0x6f4a87e5, 0xde87e42e, 0xbc9ea4c7, 
	0xf7a0f99f, 0xbd3cee91, 0x0f0a1419, 0x1cf945c7, 0x3e4af66f, 0xbcf56a19, 
	0x0d75e29a, 0xbe2b3dee, 0x045f2068, 0x671a583e, 0x300c6e7e, 0xe78896fd, 
	0xbc717cb3, 0x91a5d1ad, 0xc8ac9bdd, 0xbb9b7fd5, 0xb17be22d, 0x2562f584, 
	0xcaa66dd8, 0xf63e424f, 0x5eef5670, 0x31be7267, 0x973a6548, 0x67c32269, 
	0x965e3403, 0xe4f206cf, 0xb985e838, 0xaf872e7c, 0x2ebc6406, 0xbe2be380, 
	0xaf49e16a, 0xf1957c97, 0xe376cfcb, 0x49147c14, 0x0a6f9735, 0x15f51d7b, 
	0x997c941f, 0x93f3e1f8, 0x9392c1f2, 0xcc857979, 0xc53ae0e7, 0x01da4ba1, 
	0xa59d60bf, 0x0fa4bb3e, 0x295d537d, 0x5614b3ce, 0xadc514f0, 0x9cc1e09d, 
	0xd5df287c, 0x34187e19, 0xea64b9e1, 0x5450fc4c, 0x78b8e11d, 0x5ad4abd5, 
	0x3f98a7d5, 0xc1fce356, 0xd6efc72f, 0x245f10d6, 0x33dedafe, 0x19610bb2, 
	0xddd742f8, 0x702fec1a, 0x84a81593, 0xf12affeb, 0xdf82d567, 0xe9cf14fc, 
	0x1127c863, 0xc34b5198, 0xb6f69a7c, 0x11e53f48, 0xf307f215, 0x56bbd255, 
	0x2bcf8b7e, 0xd12cf150, 0x597ca17f, 0x5991f6b3, 0x235f8722, 0xbe051ddf, 
	0x857e45e1, 0xa2ed8074, 0xfe25ff2c, 0xff98a8b7, 0x7c48fe29, 0x07c979f0, 
	0xdff0e58f, 0xc85dbe02, 0x0fcccfaf, 0x390e296b, 0xf7dc3f25, 0xf4b7ed06, 
	0xafbd1d48, 0xb7e2aef8, 0x24d7a7a0, 0xc0ce3cf8, 0x38235f27, 0xee349779, 
	0x7bd804ad, 0x047cef6e, 0x43f8e5f9, 0x11c9f136, 0x370093e4, 0xef86536f, 
	0xf078e868, 0xc19696e8, 0x4f1fc04f, 0xe615f00c, 0x098d00ef, 0xbcf00bf3, 
	0xa7540dec, 0x228f6b61, 0xfe86855c, 0xac3b821f, 0xf4e307df, 0x9c79e525, 
	0x9e1679c5, 0xf7e2a063, 0xc926eebc, 0x6fec129f, 0x6ddeba04, 0xb9fffe47, 
	0x1f4c2a06, 0xe19fc9e5, 0x58d78f5c, 0x83cff279, 0x87e022fe, 0x931d5f9e, 
	0xe48b22fe, 0x27ca5793, 0x725a27e5, 0xa054b5bc, 0x2fe05fde, 0x28bf95d2, 
	0x95f8e2e6, 0x97317f92, 0x48b0bfac, 0xfca479fe, 0x34f1855b, 0xd08b9f38, 
	0xbdf7051f, 0xc2ff2ccd, 0xbbbf4466, 0xa5d2f281, 0xa56a205d, 0xe5e745de, 
	0xeff34779, 0xaaf1b6c4, 0x9fed8854, 0x6ba7c95a, 0xd2159fd9, 0xf2863def, 
	0x3a3fb333, 0x0157cf4f, 0x4edfd98f, 0x7683d3f2, 0xaed9f505, 0xf0ee7810, 
	0xc29dd57e, 0x51407e8f, 0xbf5cf42b, 0x0bd61551, 0x78fe19a5, 0x4430955e, 
	0x90ef8d1f, 0x0decae7d, 0xef8a173c, 0xf7419da0, 0xc81e1ec1, 0x2f3c5bca, 
	0x0abe53b2, 0xf2fe8bf8, 0x1ea79621, 0x1fb03bb4, 0xe455f257, 0x0bcc57c9, 
	0xb673a099, 0xf9969da6, 0x27e70e20, 0x4797f267, 0xae8e1f69, 0xd0d3d5f2, 
	0xfb63ef5e, 0x2381f51b, 0x2337ef1a, 0x9f738f97, 0x40bb73f5, 0x2ddf032e, 
	0x7827dac9, 0x54bf187e, 0xcb928b76, 0xfde10f24, 0x7f6929d8, 0x47943f48, 
	0x502c1fc6, 0x72fef143, 0xe4846b9f, 0xc245ca2e, 0x42fb7caf, 0x9c68b9c9, 
	0xffd2a6e5, 0xbf31de49, 0xfefa50fe, 0x8f072005, 0x3963bc92, 0x3b67720d, 
	0x3b9023ca, 0x07ae1d7e, 0xa8fc366f, 0x38f80fb7, 0x371837bf, 0x3802dffd, 
	0xf6995cae, 0xf10a79fd, 0xdf71c5d4, 0x1db291ae, 0xe796b700, 0xfff4355a, 
	0xe6afd25b, 0xc5eaa839, 0xdc21bf98, 0xf2ac3e28, 0xfbc675f3, 0x87ec6981, 
	0x72451d86, 0x575836ed, 0xf80d9f9e, 0x53945ae9, 0x1eef81ad, 0xadce00d6, 
	0xe8c3c6fe, 0xabd4f31f, 0x74fc0bf7, 0xa6b2eeca, 0x7fdabbb0, 0x4daffd47, 
	0x6b7ea5cc, 0x51db3bf9, 0xb189aebe, 0xbc1ad43e, 0xabb630f9, 0x3b617dde, 
	0xb47cbfd6, 0xe51fb8e2, 0x29679b74, 0x19e4e5c9, 0xf2a265fd, 0xcaa5f320, 
	0xf3ff2cc3, 0x7f25a3ec, 0xedf283bb, 0xfa4f1503, 0xf45f6f90, 0xdc46b1ea, 
	0x64fd025f, 0x67cadf30, 0xfaa09d9d, 0xf8f7fd00, 0xb9a47f29, 0xccf18fcd, 
	0x9ebfe4a0, 0xa35f393b, 0x63a15f68, 0x6387b7d4, 0x3c540fd4, 0x8f4f7c43, 
	0x00589f0d, 0x38bbd07c, 0x507f7a49, 0xf5ca3474, 0x182fdcb2, 0x88715027, 
	0x25f383de, 0x17e8fbfe, 0x561ce8ca, 0x91e57c36, 0xbc59fda5, 0x791abf85, 
	0x4ba7e4be, 0x70a6b5f4, 0x05c3e3fd, 0x54431bf1, 0x167e3e23, 0xfecbdbe0, 
	0x5e87d201, 0xcdfb29f1, 0x41ed3ea9, 0x8af6837f, 0xb8d14ff4, 0x5db33c19, 
	0xb8bf312b, 0x914310d3, 0xe64f9293, 0x4783c75c, 0x7ceff27f, 0xdcbc875c, 
	0x7ea08fa7, 0xb5ec7a6d, 0xcc3df283, 0xd721171b, 0xc638ec3f, 0x4da3baf8, 
	0xfe707788, 0x8ebe2c89, 0xda7d2a37, 0xe8e46b5e, 0xba7ef09b, 0x09bde60c, 
	0xb327d2da, 0x6e6c32fa, 0x445be517, 0xd6c7d26d, 0xc8345d62, 0x35eeef77, 
	0xe85ae85a, 0x3f0ae703, 0xc48f339a, 0x7ede7c63, 0xa98fcb36, 0xf7c6142e, 
	0x42bd28b4, 0xf3015e90, 0x6677b2ec, 0x09bc98eb, 0x0e3f4347, 0x6fad11b0, 
	0xf2979f10, 0x0f7964de, 0xc14b55f2, 0xf8b686f9, 0x9dff715a, 0x0b07a8a6, 
	0xff8bfd1c, 0x6e780214, 0x47d4fd14, 0xfd0838be, 0xa5d7835a, 0xd69e84e4, 
	0x5cf91d0c, 0xbe5d476d, 0xeb3f675c, 0x705f52b5, 0xfe877f21, 0x48b3c00d, 
	0xee4e689f, 0x56b97a45, 0x59ae05ea, 0x157fafb0, 0x30d1c6e2, 0x9e82f7d5, 
	0x27a05b50, 0x09e9e6d4, 0xe98ea349, 0x718ded9f, 0x54cef387, 0x322bbb7d, 
	0x76e107b8, 0xfee40c43, 0x8fefb27a, 0xf501d6e6, 0x1bf2cadc, 0xf7c3f4e1, 
	0xf6cb8eb0, 0x56c4ac0e, 0x43d7db2c, 0xeb8062f6, 0xa5272c3b, 0x1d65fc13, 
	0x9c25e727, 0xfd7d16a8, 0x2e90b7b0, 0xd4e7f416, 0x3834adb9, 0x15e4256f, 
	0xdfeb720b, 0x905ac242, 0x7216ff5b, 0x61f7f959, 0x36fadc9c, 0x5eb73f7c, 
	0x78c5c70d, 0xf7938e38, 0xf4538c1c, 0x7e886fdc, 0x99ae78dc, 0xa2fb887e, 
	0xf4302f30, 0xbe1fd4ef, 0x7570ca2d, 0xfd7923ee, 0x3b19c337, 0x0d1ea0ae, 
	0x7abf7c46, 0x8a06f6b4, 0xbaae2457, 0xc7f3c688, 0xc833771c, 0x0eebf1db, 
	0x3cb8a8f4, 0xaa9fa5fa, 0x0ffe0c00, 0xa9de6618, 0x69efbc7a, 0x4b40ffda, 
	0xd2e13029, 0x26f10c4b, 0x961dd5e0, 0x33186b0f, 0x06666df5, 0x7d5c3eaf, 
	0xafcbe89b, 0x5fa82b6f, 0x566ef553, 0x2dbea65d, 0xea6ddeaf, 0x23c336fa, 
	0xf5051de3, 0x695eed6d, 0xd6b7fe57, 0x489f19b7, 0x2da09b04, 0xb07f66bd, 
	0x8ddeaf39, 0x7ad934fd, 0x97928b37, 0x161ea43b, 0x51e8bc05, 0x6c81d1f1, 
	0x2b03145c, 0x21bf5c29, 0xff80eb06, 0xbd8efd45, 0x9389f517, 0x73c1a3a6, 
	0xf7590dd3, 0xea1f0861, 0xbd19b73f, 0x40d7f846, 0x8b8bd7fe, 0xaf02bf91, 
	0xfef01bf1, 0xc7e590c2, 0x5dc5957c, 0xb8041109, 0x0a63842d, 0x0cf3c93e, 
	0xdf029ac2, 0xff943e16, 0x1bff310b, 0x4742fc64, 0xc69d630c, 0x70002679, 
	0xc4d7cc31, 0xa9e175fc, 0xfb6053f4, 0xb3976088, 0xbcf9e90e, 0xd7cbd0a4, 
	0xf0bbd767, 0xe47e1dd4, 0xdef5ffbb, 0x0843aa72, 0x451d8274, 0x5c8c2e78, 
	0xc283fc7b, 0x07fcfe19, 0x0df0737b, 0x77f5ce86, 0x24f05fc2, 0xdce383f7, 
	0xf58b7f2f, 0xd0d3f2a3, 0x66ec9b86, 0x9b84c78c, 0x9c07e885, 0x86c5470b, 
	0xae4fcc9d, 0xa4fc02d8, 0xc1d3ba76, 0x67560879, 0xaa901e3f, 0x80f5960b, 
	0x613cd5e7, 0xed9dbd70, 0x64643f43, 0x7d208ad0, 0x7ec6ff1d, 0xa9ce17aa, 
	0xf586de0f, 0xd734d1c1, 0xe0c8ff07, 0xffc55afc, 0x67002da3, 0x84a9dfac, 
	0xc9e78c36, 0xc8633def, 0x26cee0fa, 0xf82f0bb2, 0x0facb0a7, 0x3940c67e, 
	0x713072be, 0x76e409a8, 0xea9b1ec5, 0x53f957a4, 0x1bf7a971, 0xdd5668c8, 
	0x86dc74f0, 0xf9d55973, 0x7a013c76, 0x724faaea, 0x067dd51b, 0x65443de6, 
	0x602fcb9e, 0xcf58329e, 0x03518abc, 0x5e5454f3, 0x8c2fba90, 0xa5071a2b, 
	0x7ffe815e, 0x7eb02bd4, 0xf815e945, 0x0487d63e, 0x3c308e2a, 0xbf4897cc, 
	0x285eefd0, 0xfc97bfa4, 0xdc662711, 0x73e11c76, 0x21b2f19b, 0xe4fc616e, 
	0xb70bd57c, 0xcda3fae1, 0xf9b94589, 0xc3d01e4d, 0xd74c7fd1, 0x167ad1e7, 
	0x05051f11, 0xca87e518, 0xe63cc1b3, 0x3dc71b3e, 0x98497c46, 0x77c2ae3c, 
	0xbdf11f1c, 0xad71fbea, 0xfe8fe604, 0x0356f4f2, 0xc25652e0, 0x2feaa072, 
	0x77a8ad12, 0x378b7006, 0xa4fd510a, 0x21fd9299, 0x7f9863ac, 0x18159ad9, 
	0xf57f9b06, 0xa04b15e6, 0xdfb3e73d, 0xaff74159, 0xc636f918, 0xdcf9cfb7, 
	0x93946e13, 0x4f53e181, 0xe0df3ea1, 0xb07ca06f, 0x839a15c0, 0x0e87b07d, 
	0x086a5ca0, 0xd8d1ebcc, 0x9fbca1be, 0x495a4df2, 0xe5e74928, 0xb2683e66, 
	0x3ed7369e, 0xbf86f680, 0xbc803cdb, 0xc5ef9e12, 0x8df2adfa, 0xc61abf9a, 
	0x9b0a0aad, 0xb53a9df2, 0x23ee3a23, 0x9a43060d, 0x36bf73d6, 0x7f31fd4c, 
	0x510fdf1a, 0x7043557d, 0x17ae1b61, 0xb4208bae, 0x9ebaae0d, 0x0ffa36d9, 
	0x46ccf4d7, 0xb2b86d70, 0x9bf41e67, 0x01e81baf, 0x1fe68b30, 0x40b4f60d, 
	0x6a4b735b, 0x1eb832c5, 0x59f4713d, 0x8827ce03, 0x16e4973c, 0x77d02bd8, 
	0x9def9699, 0x796f5214, 0x8e4de209, 0x68e9f0fc, 0x99c815b7, 0xc928ff70, 
	0x6a2aa791, 0x84ae504a, 0x6fae9cb7, 0xbbda13b9, 0xf9803df7, 0x75a555a8, 
	0xa17e7825, 0x095cb2df, 0x91be5547, 0x6f7e2213, 0x8e4436ad, 0xc79851bd, 
	0x18f502be, 0x57aa9fdc, 0x20518430, 0xf9028c7f, 0x5f5f9a53, 0xe38a57dd, 
	0x084fe467, 0x7fbc36ec, 0x066fb4b5, 0x7fce0ae1, 0x84fe4665, 0x93983ef0, 
	0xb518dfac, 0xec95ffa2, 0x438ed07a, 0xc642b3f9, 0xa850b5b1, 0x4ad1c644, 
	0xf12fbd64, 0x94744d39, 0x94bdbd4a, 0x6fe63fed, 0x19649aae, 0xb6b93ae6, 
	0x80850fec, 0xefef84ff, 0xce62d70e, 0x874fb7e8, 0xfd57e84d, 0x83123bb0, 
	0xd3a1cd7e, 0xebf43891, 0xc0aee95e, 0xa3b4d758, 0x97c9054e, 0x5e5e76d5, 
	0x8a1d30be, 0xe76c8757, 0xb253b41c, 0x1c5165e7, 0x40bcf0ba, 0x1ea097fe, 
	0xffdede11, 0xea97b340, 0xc711fe78, 0x825ff905, 0xd0ba1bf4, 0x214fedf2, 
	0xe49475dd, 0x69fa33d2, 0x10069e71, 0x7e815bef, 0x04e589cc, 0x51ffc577, 
	0x1af2dc75, 0xbcea231c, 0x57310be7, 0x01a69fea, 0xb82bfd2b, 0x875498ef, 
	0x6ed03582, 0x8c10bc24, 0xcb10fa4f, 0x1f52b9c5, 0x2488679d, 0xa41bc3c6, 
	0xb09137dc, 0xa8ff9316, 0x43e496a4, 0x75b9f3ed, 0xeb236222, 0x75c62293, 
	0x870f6727, 0x87014fcf, 0x961c322f, 0x84341c03, 0x383ce6c3, 0xf67f8098, 
	0x980e12b5, 0x503f16d8, 0xed427282, 0xdc7aed1f, 0xbe30ee97, 0x9d9b7da9, 
	0x8f9f21a0, 0x7e45b8fa, 0xa0a8b9ed, 0x279ddc80, 0xc18e7bf1, 0x7dc2f971, 
	0x38e12b9f, 0x27991517, 0x12f44c91, 0xa7e51f9c, 0x594bbfb4, 0x87bc040f, 
	0x6bc06f7d, 0x1be0e56f, 0xfa64fbe2, 0xc47bc4e7, 0x267e0e9f, 0xa7fa567c, 
	0xdca5d4c8, 0xdaee744b, 0xe10b5a76, 0x0d0f5263, 0x97545bf7, 0xb9c6bc72, 
	0xb72fd727, 0xd78e39fc, 0x7e59ff2f, 0x7f22febc, 0x70debc41, 0x052e2979, 
	0xa5c52cea, 0xa46ad70c, 0xc6a0fd77, 0x7989a971, 0x1c55c794, 0xd1ca77af, 
	0x899e5c6e, 0x3b5c714b, 0x777a9713, 0x7f7e5ca4, 0x97c3ea85, 0xd69ebc63, 
	0x11f7d0e7, 0xd667544e, 0x5845df4b, 0x1cebb19e, 0xbe5d63ca, 0x2a714ce8, 
	0xe792e7e9, 0x60a3ecbd, 0x9678d1f7, 0xc068fc97, 0x56afd048, 0x164de30e, 
	0xecae5ab7, 0x9bf66ec2, 0x1f945f2d, 0x92583aa7, 0xcb3903a9, 0x9e539478, 
	0xf5c97092, 0xe9c51577, 0x7e531f4f, 0x17a7192c, 0x856be553, 0x46b5f2f3, 
	0xcb5f395b, 0x5578a569, 0x7d38ea72, 0xfd29e098, 0xfa718568, 0x507f59e5, 
	0x9c3e9c61, 0x9c721fe7, 0x571e4170, 0xe9c6fbc5, 0x4f49379d, 0xfebfcff9, 
	0x7e1c5e48, 0x38fce9d5, 0x7f03da3c, 0xfc9e1c68, 0xe074f172, 0xd64bd904, 
	0x5bdfd46a, 0x46ef878e, 0x3ff9683a, 0x04ffc84b, 0x7f19117f, 0x53f8c88a, 
	0xbf2fce44, 0x9c5566ef, 0x7e4fa9d6, 0xc3f452a9, 0x4d1773c1, 0x48f89c0c, 
	0x17bfd67f, 0xa3f4d5bc, 0xf6dd37bc, 0x8d9fbc5a, 0x294b7bcf, 0xa5713f3e, 
	0xf9f1c03f, 0x2611361d, 0x4f40affb, 0xafd717bb, 0xf86dd4e2, 0xec8d21bd, 
	0xfd407f95, 0x7fc972ed, 0x15560a40, 0xe55563e4, 0xef8d63e6, 0x44fcf233, 
	0xeebf2397, 0x1d03ce2c, 0x7395f8df, 0xfa53df51, 0xde1f465f, 0x7eb1b118, 
	0xdeb1ba3a, 0xa568bac6, 0x652ece8f, 0xd92cc6bf, 0x435f9bae, 0xb95e81cf, 
	0xbc13f50b, 0x5b05df8f, 0x238d4e77, 0x7a84bfaf, 0xbac75e37, 0xd2d0b9a5, 
	0x6ec10dc7, 0x6863bae2, 0x5be3b2eb, 0x4db3448b, 0x6d9e0a75, 0x4b456368, 
	0x3fd236c5, 0xb9cafaaf, 0xd127e009, 0x013ed0b5, 0xc6d932ed, 0xebd7c47e, 
	0xcafdc47f, 0xff59739e, 0xfc687c76, 0xeb5b88cc, 0x0b600e06, 0x620003a6, 
	0x43ac4846, 0xf7b405ff, 0x7185c37d, 0x5e0c471e, 0xe3876d0c, 0xfda9d7ea, 
	0xa10713d8, 0xdcff8a4d, 0xa1f6a2ee, 0x923db2ef, 0x5f40f1ee, 0x2f1f75da, 
	0x87ec5e73, 0x94ad7df5, 0xfc4562fd, 0xfa8379da, 0xea4f88c1, 0xbf118f2d, 
	0x50bc3e1e, 0x8fca21f1, 0x206bf0ce, 0x80073020, 0x5888c35f, 0x06fcaa4f, 
	0xc7d7e021, 0x19837eb2, 0xfd3fcf26, 0xb117c1f5, 0xa563f75e, 0x2b7ecef6, 
	0x7f750ebb, 0x73b5a94d, 0x75cf8938, 0x7b4718bc, 0x17b1f5f4, 0x8bf9e16a, 
	0x7b1d9d4b, 0x3e3e7e1c, 0x7f7e2dc1, 0xc6a5866b, 0x71c31b1d, 0x833a9457, 
	0xd65ae379, 0x38603f83, 0x1c22f60c, 0xd3cf333a, 0x96660c77, 0x9f72db3a, 
	0xb8ca565f, 0x4cdd01a7, 0x9158bd10, 0xe1374c53, 0x47c3f734, 0xfb3f3975, 
	0x7d634329, 0x7da36e7c, 0xc9e03af2, 0xf94152da, 0xfd3faa2b, 0x488bd0f5, 
	0x82a5ed07, 0x7deab9fc, 0x41f2f30b, 0x132daf9e, 0x5ed8212f, 0x2ef97f9b, 
	0x2fb4175c, 0xf6727d61, 0x30178efd, 0xd4aab87e, 0x9f7991da, 0xf5d20fae, 
	0xc176a5d5, 0x380bd0f5, 0x5152cadf, 0x5e18fcf8, 0x07b52b6f, 0x5fc2baf1, 
	0x8c79a7a2, 0x4a7fe4af, 0x46c3a52e, 0xd13925bc, 0x64cbfb21, 0x044a5adf, 
	0xf1cc788a, 0xecafbe18, 0xf66bc476, 0x2ae7ca43, 0xd9a773e5, 0x46bc792f, 
	0x8edf38a4, 0x997417eb, 0x973fad87, 0x5c55bf2f, 0xc4cf30ad, 0xe5e5a633, 
	0x688e7895, 0x1e257979, 0x2bc828bf, 0xa1da1a11, 0x2bb7caba, 0x36f693c8, 
	0x62579909, 0x7ae788eb, 0x6ae325a5, 0xedf32e8e, 0x9e597ae4, 0x4eef32eb, 
	0x13bbc82f, 0xc1449f32, 0xecf31ab5, 0x93df7492, 0x2a9aff1b, 0xf9974edf, 
	0x7e417a75, 0x4e975fdd, 0x6b675f95, 0xe4323bf2, 0x9efb52a7, 0x34255e3a, 
	0x4da75f99, 0x41e75f96, 0xdb728fb9, 0x731a3964, 0xba55e3f2, 0x6d791bcc, 
	0xb0404d7e, 0x7e435a3d, 0x55179562, 0x64276f90, 0x18de94de, 0x81f229fa, 
	0x43af0d40, 0xa5089de5, 0xe793d817, 0x3de61771, 0x95a7c615, 0x56f2a05e, 
	0xb6ebcc84, 0x285fc704, 0x57f24d7e, 0xb1c5e7d4, 0xe7b794cf, 0xe814548c, 
	0x7b79f903, 0x27738a67, 0xbc82da8d, 0xbcfcdae2, 0xef2eb362, 0xe5d569be, 
	0xf7c751c6, 0xf31c1c70, 0x6c9e9cb0, 0x7ee29d7c, 0xf7b8e2f1, 0x622ff994, 
	0x0b8a0fe4, 0x1d1fe916, 0x3f207fa0, 0x0405b44e, 0xe503f5c3, 0x1efe5201, 
	0xf4f2e73c, 0xf991ecd7, 0x79f1f9d0, 0xee2ded31, 0xeb777b4f, 0x27897a24, 
	0x96892f5f, 0xbca85d31, 0xf4245741, 0x970fc88f, 0x338c5e60, 0x7310de89, 
	0x5b3c547a, 0x64a74fe6, 0xe25474fe, 0x6f33e52b, 0x46adf096, 0xd0ec097b, 
	0xfa7f31eb, 0x768bac49, 0xdcef91ea, 0x3826fd80, 0x7f8047ad, 0x8cdc7d01, 
	0x2f68d4f9, 0x5e500fc5, 0x8f07a2a1, 0x4798a229, 0xed683ebd, 0x707f1149, 
	0xf20f44a2, 0xe9e309fb, 0xbe877d7c, 0xbe893077, 0x87a7a283, 0x403b3eec, 
	0xd38c317e, 0xb02efac2, 0xe2a2de39, 0x7798f52b, 0x89f128fd, 0xebbcbc92, 
	0xc82811a4, 0xe6e40eb3, 0xcfd85f59, 0x3105d9fa, 0x18b0a7c6, 0xfc41fadb, 
	0x7194d7a9, 0x19fe0edc, 0x5b447f64, 0xd829fa50, 0x773baa7f, 0xb7fb4bbc, 
	0xa66bef29, 0xe85d07d4, 0x71b680e7, 0xe803ef0f, 0x1fa057ca, 0xf5f20afa, 
	0x10b8dc8d, 0x75fb15d0, 0x94cd5d24, 0xb94692fe, 0x7eb3110f, 0x6b31e786, 
	0x9c53708f, 0x97c86aaa, 0x291d6148, 0x02b77fe7, 0x9d4be95f, 0x3fecfac5, 
	0xce0a7d6c, 0xcb8beb45, 0x9ff849f5, 0xffd0facd, 0xf282dbac, 0xefca6676, 
	0xa1f5a920, 0x83fbcdcf, 0x2f09baec, 0x397ea62e, 0x683b4b9d, 0xf2e3cf66, 
	0xebf610ad, 0xf5ff396b, 0x3d5dc343, 0x0bca369f, 0xf3ca7af2, 0xf9627af2, 
	0x7056a7df, 0x942f7da0, 0x2ef580f0, 0x7c09f6c3, 0x708bc47f, 0xe32fde59, 
	0x08fb958b, 0xfb03e22e, 0x61d0edf9, 0x8f84900e, 0x5f876b50, 0x767cb685, 
	0xda0ba0fb, 0xd7e5aff1, 0x79d91401, 0xfd437f47, 0xcae76dfd, 0x32bef838, 
	0x7ec883b4, 0x4efd963a, 0x13ebf85e, 0xf0bc9df4, 0xfdfc7caf, 0x36a4a68a, 
	0xf4e30ab0, 0x56fb6243, 0xe66e8692, 0x10afec8b, 0x3d233fb5, 0x73b6a9fb, 
	0x1effff24, 0x7b49d9e9, 0x2bf3cd3e, 0xaff627a0, 0xfa4d7eb0, 0x961dda34, 
	0x74e6764d, 0xe8e3ff3c, 0x1961fa47, 0x0bc34ffa, 0x9a0bafd8, 0xa519e912, 
	0xaa714e86, 0x73a141aa, 0xfe4db3be, 0xfbf42a8a, 0xd07fb1a4, 0x4fca7a83, 
	0xd2f932ca, 0xdfc853de, 0xe88b4eb1, 0x453f21d7, 0xf71802f8, 0xea375e5e, 
	0xb195cf11, 0xd95e743d, 0x32ef3c73, 0xf4fa0fb8, 0x65a3652d, 0xf7a6bf65, 
	0x593da37c, 0x5cbc21fa, 0x528f8b94, 0x7481fefe, 0x827c2674, 0x7286d973, 
	0x23e511a0, 0xf6c7939e, 0x2b5cb20d, 0xaf72ca39, 0x8cfdcd24, 0xb9609c1c, 
	0xbe137848, 0xfa4df784, 0x3eacceca, 0xbf67e657, 0xdc659bff, 0xfa6b9d16, 
	0xf4d73a4d, 0x4f528237, 0x55ce9878, 0xe671787f, 0xe779083b, 0xa00fb319, 
	0xbf8d9f3d, 0xf139c8c2, 0xea9fb257, 0x4c7eeb8a, 0xf3c083f4, 0x0b07891e, 
	0x2d98ff25, 0x8f507ceb, 0xf296fa22, 0x29d1bcab, 0x0735b945, 0x959a3fef, 
	0x1f704d7b, 0xcbad67bf, 0xdf78203a, 0x3d217ac1, 0x09d97a06, 0x3ac91621, 
	0x446b9021, 0x95b9198f, 0x6f8effcc, 0xdaf8cfc0, 0xf1fab410, 0xc72885b9, 
	0x7eae0886, 0x5c6193b4, 0xe69275db, 0x524fddb3, 0xed0ca9dc, 0xafa23990, 
	0x2c503ec4, 0xc5fc14ef, 0xe30fb615, 0x33ec3a17, 0xaae51c78, 0xfcbb43e5, 
	0x1b8e32a9, 0x64e90f7d, 0xddba1262, 0x9fe4cfff, 0x4f3deae9, 0x3f4cedd2, 
	0x05fc97c6, 0x5fd1fb74, 0xf6e89afd, 0x8f1833a3, 0xf8c61ed1, 0xc61ec654, 
	0xe769467a, 0x23eafc62, 0x311f997e, 0xe73a13f6, 0xfcd53ccb, 0x925fff5c, 
	0xc87f113d, 0x82d8f4a7, 0xf9bc3ab8, 0x8bb19125, 0x59e27785, 0xf9725bcc, 
	0x8102dad2, 0x4fc8bc74, 0xd676a7f1, 0x35a7a6db, 0x6bc7efe2, 0x3f5cde9c, 
	0x73f4b967, 0xa73f4b96, 0x3d2a2c23, 0x33eaf152, 0x4bd337fa, 0x969bfc0a, 
	0xe3a59efc, 0x67967dc6, 0xfdf3eef3, 0xe4cd5f9b, 0x7f707bdd, 0x5d79aa27, 
	0xb673f41e, 0x3cd97bc3, 0x2c1bca15, 0xa99fc29f, 0x27652dec, 0xa8772cb5, 
	0x2ff9553e, 0x14505f29, 0x95cb2ffb, 0x01e652ff, 0x2ff81796, 0xf957e73f, 
	0x527ef97b, 0xf1e607f1, 0xe43d6cb5, 0xe6e5b54e, 0xc9de39f1, 0x8f2a93fc, 
	0xbc65f30f, 0x3ebeb08d, 0x4949d90f, 0x3227f799, 0xe666aaf5, 0x6ea3bb7b, 
	0xa5eb1f49, 0x72fa453d, 0x79425dbe, 0xdeace980, 0xff9e953f, 0xe633f0c7, 
	0x34acfbd5, 0x2a65fb9f, 0x0ceeff47, 0xe6501fb1, 0xe123de03, 0x8fa06a6d, 
	0x7d1fb8c3, 0x98c3ede3, 0x1e76482f, 0x4db0e3f4, 0xaead6efc, 0x507b819b, 
	0x700d395f, 0x73e348d9, 0xf32352fd, 0xe29e7a71, 0xdffef906, 0xc650dd4c, 
	0x4f5764cf, 0x5d70b278, 0xc3def685, 0xe546fec5, 0xad2abc67, 0xfe441e91, 
	0xaae3d661, 0xe3523da5, 0x5e687e70, 0x49d5f35e, 0x7a0fd351, 0x9fc0d5fa, 
	0x0e744d22, 0x7c3fcc1f, 0xc826bf06, 0x7902eab3, 0xcf279d56, 0xc953dfa4, 
	0x3ca5cbb3, 0xf77e0cfb, 0xf5a1f413, 0x7983c2b5, 0x7cc59f16, 0x57efe033, 
	0x3576b949, 0xbf11a1e6, 0x5ffe60ff, 0xb905afe5, 0xf29fb558, 0x1c1f3911, 
	0x18c6bef3, 0xa547753e, 0x93cf867d, 0xfb22d7bf, 0x5751a8ea, 0xf28bafcc, 
	0x909d65a4, 0xf3c9b9e7, 0x3c6145a4, 0x2909d546, 0x84eaa57e, 0xf40dd70c, 
	0x279516dd, 0x8cbeb86d, 0x49e616e3, 0x5ffe62b7, 0xdbc6bc4e, 0xb49e736c, 
	0x3f77e888, 0xf3abcd9c, 0x30257e4a, 0x51eb830e, 0xe58fd279, 0xab8a2ff3, 
	0xebaf75c0, 0x6c085481, 0xd58fcf0b, 0x4e83db7d, 0xa43c70ae, 0x28937bdf, 
	0x62f67fca, 0x41bfe61e, 0x27ae5dfb, 0xcf1c31aa, 0xa40d7c64, 0x8f3df506, 
	0xcf35f3e5, 0x587f658f, 0xe415efe6, 0xc32eff37, 0x3efdf2e7, 0x27ac2eb8, 
	0x8cb6fdd2, 0x6e32d8db, 0x82e7c453, 0xf82e7c05, 0xcacaf9be, 0x86eb23ff, 
	0xae2ae896, 0x4947fa0e, 0x68f2be4e, 0x81f3ce26, 0xe41d95f2, 0x1a6fac5b, 
	0xa32acf32, 0xf5eae59f, 0x861227c6, 0x1cfaa2ee, 0x3fbc49e3, 0xbdfa929c, 
	0x7cca3fe3, 0x68eb2034, 0x555ca3b6, 0x8f8a85f5, 0x5bce0199, 0x3633c4ce, 
	0x3798fd25, 0xa4f98ad0, 0xb7992f08, 0xe70b2b0c, 0xbc5aaffa, 0x4efd14ae, 
	0x1157f490, 0xf5cf59df, 0x664f15e9, 0x55fc0bf9, 0x1e15fae3, 0xb26f317a, 
	0x7943f691, 0x967e8aae, 0x4cbdaa3e, 0xc3886274, 0xda5b87e8, 0xe3baa297, 
	0xb62bcc56, 0x9fdb71f1, 0xc055575f, 0x43e48487, 0xc7f285eb, 0x6406f7f3, 
	0x61f1335e, 0x58e577b8, 0x7b45ef58, 0x5021bc6a, 0x6749f5c3, 0xff930fe0, 
	0x05e80ffe, 0xbfe46395, 0x9fce3f61, 0x7f22384a, 0x837cc53e, 0x8bbc97ea, 
	0xf8a7bfd8, 0x02dbe508, 0x83ac0c1c, 0x6fc73878, 0xd6931717, 0x56ff2895, 
	0xdb8a5b08, 0xcd7fa59f, 0xb833f8ce, 0xb862c4ae, 0x60f00b5c, 0x5d7e613f, 
	0x65014dc8, 0x23ba88ef, 0x3aa267ec, 0x23d77191, 0x3aedc21a, 0x1f414fd4, 
	0xae415b36, 0x5c865e21, 0x2f005247, 0xba21d46f, 0x868546f0, 0xb42e19df, 
	0x6c02fa0b, 0x203e7c0f, 0xf3287fbf, 0x1d2e5150, 0x63efcbec, 0x1d717cdd, 
	0x1bfe4dbf, 0x131bc48f, 0x2e8821eb, 0x37977bf8, 0xcb54fdc9, 0x11f7bdf8, 
	0x5875f49b, 0xfa0dda6f, 0xea2637ba, 0x3f475f51, 0x8bdfae15, 0xdfdc3a7a, 
	0x79fbfa88, 0xbe58df30, 0xa9f9499f, 0xf49b8a6e, 0x4ff2641d, 0x5d521d31, 
	0x20277d06, 0x7d0fbc54, 0xe0efa0a5, 0x76834058, 0xe31be72f, 0x9374fff7, 
	0x65db98f3, 0xeb07937d, 0xdbdce08e, 0x1c798f31, 0x3deb03d7, 0x89daeb4e, 
	0xe533fbfe, 0xac6a072d, 0xb8e1eeab, 0xde5de74d, 0xff50ea49, 0xef60f585, 
	0x605e2acb, 0x105b77f1, 0xe0f472df, 0xd1ffc604, 0x40b47d6f, 0x3b557e1f, 
	0xafc97c83, 0x4d745543, 0xad99b0fa, 0x17cacd43, 0xb8ea8755, 0x5cd8be59, 
	0x8be52ab7, 0xe3c9c257, 0x62152aba, 0x7a9cb338, 0x46debf2a, 0xfaaa97e5, 
	0xc0336f1c, 0x7bee81a5, 0xaa6eeb73, 0xdb1a3a96, 0xf59796f1, 0x44397c89, 
	0x8bc1337a, 0xc36afbf5, 0xb284f4f6, 0x23c947f2, 0x77fe4b6f, 0xe54fbc5e, 
	0x6dfcdbd7, 0x16af40a0, 0x94bd3f19, 0xe587b63f, 0x4eb91fc6, 0xd7ea4c66, 
	0xebf5f347, 0x21f3b922, 0xa7fe64eb, 0x671bcee4, 0xf30a772d, 0x90e5f221, 
	0xbeaa3392, 0x163b40c5, 0x2a62abfa, 0xe4c1f1ee, 0xfcbdb144, 0x3f2f64b7, 
	0x089d7064, 0x79b5a1c8, 0xaf28d979, 0x73eb67d6, 0xa5a55e48, 0xcac819bc, 
	0xd66f6599, 0xf24ffe91, 0x37948d66, 0x61bca4c7, 0x609910f9, 0x47d192f9, 
	0xe17c920f, 0x454098ba, 0x6bfd1045, 0x7d4b9e4b, 0xcbc023eb, 0x819e65ca, 
	0x17bae7ee, 0x7e8dbf9f, 0x7590c927, 0xeaa9de2f, 0xd24e265e, 0x3ed1be7e, 
	0x33ffda57, 0xfbff6882, 0xa2f75ce2, 0x8bdd7137, 0x97bac671, 0x911eb439, 
	0xaf1a77fc, 0xcbe994bb, 0x25eeb8d2, 0xf90a77ab, 0xf7961afd, 0x62f758e5, 
	0xb0aadc11, 0xb9d6257f, 0xe4811fb0, 0x72706768, 0xfa8e5a39, 0x9f959381, 
	0xc945eeaa, 0xcfffc54f, 0xb16d1f28, 0xc94bcf12, 0xca5054d5, 0xf108d0bd, 
	0x461c4cfd, 0xe501177e, 0x52358edc, 0x39c8ee0e, 0x79a7697f, 0x4adf4ca3, 
	0x145e91fe, 0xbbbfcac9, 0x36ff2c83, 0x23f53306, 0x79241714, 0x56a17cc6, 
	0x7aaa89d6, 0x886fea11, 0xfb05f8a9, 0x74bea8a3, 0x64d3fc80, 0x33efa877, 
	0xbe836188, 0x29d4e3cb, 0xaafde6fc, 0x3ac2c9fc, 0xb9639452, 0xc38281fa, 
	0xb27f58b5, 0x32bbf690, 0xd603f4a5, 0x5da0b683, 0xe8fd5538, 0x078189b2, 
	0xc31d63e6, 0x56f61baf, 0xb5fe5b42, 0x756b9fae, 0x4b7d7205, 0xfb579cb1, 
	0x64384af6, 0xc33f1df6, 0xfe5f95be, 0x05b2f54c, 0xfda43bdf, 0xaef9cfad, 
	0xb07514c4, 0x87dbf7de, 0xe6eb367e, 0xf7cd1378, 0xa887d230, 0x2d7fb5cd, 
	0x1d71afb4, 0x0b53b631, 0x5a57d7c7, 0x7abf065a, 0x4a5075b3, 0x1af6507f, 
	0x15d70fe9, 0xea1541d7, 0x0f5b6713, 0x79ede2d5, 0xed15ea40, 0xf3ca3e3d, 
	0xff3e0949, 0x9eff48e9, 0x4b6f6f65, 0x1587fd50, 0xbf50fc45, 0x5ef99697, 
	0x69f923b9, 0xaf7e53a8, 0x84b3f95c, 0xbf2f3e5b, 0xaf7f622f, 0x7b4e8ed0, 
	0x9dc7f0b3, 0xc5dfa49f, 0xfbc71bb1, 0xd7a6ef09, 0x8be2136e, 0x5b1f7e32, 
	0x7c8ed0d9, 0x5e6ab635, 0x898f9e3f, 0xdf4720fc, 0x3d672d6c, 0x7ece5e33, 
	0x5d65c7d0, 0xf39068dc, 0x5f251bf1, 0x115c94da, 0xaef1fac4, 0x7ea897be, 
	0x075d0be4, 0xfd9f31ca, 0x41bd9df3, 0x2091ffa4, 0x427f338f, 0xa21ea5b3, 
	0xb9f5fe61, 0xb7f3df85, 0xa9ca28ac, 0x49e73968, 0x223d466d, 0x9b237e82, 
	0xbf024f7e, 0xee758f59, 0x4481ef45, 0xd311117e, 0x571853b0, 0x42292eb8, 
	0x83679c36, 0xa5d7e794, 0x44dd9745, 0xa8236bef, 0x9bd3c77f, 0xaaf34f51, 
	0x16d071fb, 0x0be90486, 0xa377a758, 0x7f456e69, 0xa1b5d618, 0x5c7a00fe, 
	0x6249fa09, 0xeb49d73a, 0x109fc095, 0x468e5dae, 0xd9a681f5, 0x6bf7f683, 
	0x8bdfeff3, 0x1b19dce7, 0x937a813a, 0xdb82d747, 0xc3be714f, 0x5f091ec0, 
	0xeade37f4, 0x103d9a70, 0xcf0fbe18, 0x534f6e95, 0x3bf73ebf, 0xae272d60, 
	0xa3c7007c, 0xe7b347f7, 0x24afa0d2, 0x92d3c63d, 0x673b34d6, 0xe066bf1c, 
	0xb539ea38, 0xc8df7a3f, 0xc335f75e, 0x90df387b, 0x39241a95, 0xbfbf4adc, 
	0x80f77be2, 0xc7c87e86, 0x67783d65, 0x267d14c2, 0xdf41df3e, 0x439bd5c5, 
	0x6edc220f, 0xf4033942, 0xcf9cb9b8, 0xfbfb8d47, 0xb049e320, 0xe6f4f99c, 
	0xa40fbe1a, 0xcaeaee24, 0x4c540b8e, 0x57b76ff5, 0x5a18efaa, 0x65efc4df, 
	0x8ce53e13, 0x4ef12257, 0xb94ff3b5, 0x889f456d, 0xd51f0a3f, 0x5e62d8f8, 
	0xfd979750, 0xc720ddec, 0xf609b63e, 0xdc14ed2f, 0x0c2efe2a, 0xf738ebad, 
	0xdcc7603d, 0x5c2dc7b9, 0xbf4fa827, 0x4db40033, 0x2a03b175, 0xcfb0d09f, 
	0x881bba41, 0xf0831d81, 0x3abeb20d, 0x9540e7b0, 0xf75b13bb, 0x3929cf36, 
	0xdbc484ff, 0x07ee92e3, 0x3193de90, 0x5817cbd2, 0x19879eb1, 0x2e6e51cf, 
	0x71521e00, 0xc7dfbb32, 0x6704425b, 0x8f50d2cf, 0x34f880d8, 0x97c74298, 
	0xc3ae08be, 0xb1b6f53e, 0x0bfb43bf, 0x4bfa14da, 0x5ce1f37d, 0xe5ae9e60, 
	0xd5ead221, 0x989f4873, 0xc66275f7, 0xcefa2985, 0x00773e06, 0x8eb005da, 
	0xd575c8ef, 0xad9c7ae1, 0x9ea73329, 0x1ebae745, 0x7f11dacf, 0x87e7ec25, 
	0x8f43a641, 0xf1a073ac, 0xefc7ef50, 0x2e7ae080, 0xad697d38, 0x10f0edc9, 
	0x6aa5a73d, 0x99a4f873, 0x108340d4, 0x97c96373, 0x706ebbf0, 0x7c903f5e, 
	0xf00b7471, 0xf8062fc5, 0xaf9e7bbb, 0x50fafdba, 0xe430bd76, 0x87c60944, 
	0xe6faf0e6, 0x0578af75, 0xb8d415f3, 0xe7041f94, 0xc57bb73b, 0x7eb87e8b, 
	0xceff3941, 0x42f8e16e, 0x8a849efe, 0x7e087d27, 0xc79da0fb, 0x3bef456f, 
	0x679b5277, 0xefa28bd7, 0x77ce4c3f, 0x0bcb77d5, 0x72bae6e9, 0xf4be67d6, 
	0x2e9ba247, 0x3f6a9e39, 0xe864dd2c, 0x71177e44, 0x9e3b64c0, 0x732fe5e8, 
	0x00e904e8, 0xae037be0, 0xf43937ff, 0xcc917482, 0x1989c5d2, 0x8df3a5bf, 
	0xf46cda59, 0xbf56f8e3, 0xeef90dbd, 0x64f93317, 0x57ac5e70, 0x39d83fb9, 
	0xf3eb7cc1, 0x7ce8a9ce, 0xb9dfb14e, 0x13bfcd3e, 0x7f8a78d7, 0x0efd4e27, 
	0x878eff1d, 0x71e9e9e7, 0xc350dfb8, 0x6b3767bf, 0x5df4dbee, 0xde17d994, 
	0x3b4064de, 0x376f13f7, 0x3efcc255, 0xe036df90, 0x9e6bfce5, 0xeb851d9e, 
	0x325c5fcd, 0x05da09a7, 0xa73d3c77, 0x777e84b9, 0x12e2ee63, 0xb98dddfa, 
	0xbbf4252d, 0x14bd311b, 0xa799f4f0, 0x13687e63, 0x5e64bf7f, 0x7f4bb425, 
	0x28bcf4f1, 0x2c6f2db4, 0xed04df99, 0x9e9ef7b2, 0xeb4a5cdf, 0xe41fa10d, 
	0x47e572a9, 0xd882fce2, 0x577ebaca, 0x086e964f, 0x1eb8259e, 0xe91d13a6, 
	0x65e92d28, 0x78d1d258, 0xedd7df0e, 0xd3757637, 0xff9226ef, 0xed575d5f, 
	0xe30f9821, 0x485748ab, 0xd2baeaaf, 0xf43e700b, 0x037ce3cb, 0xee7cfc43, 
	0x24fa88ef, 0x3fc8ea5d, 0xf23ef93a, 0xcefe5d0f, 0x0bbd6661, 0x8b606f98, 
	0x3a8f437c, 0xd87c4fc4, 0xebcec9ee, 0x7135a449, 0x0127ac3f, 0xdbc603fc, 
	0x3ca9141c, 0x9bfb637d, 0xa57b73c1, 0x6278419e, 0xf17da3f7, 0xa57bc49a, 
	0x7e50f89f, 0xc2570c9b, 0x91e314a3, 0x25f30fcf, 0x6d3b7e31, 0x2a3bc710, 
	0x2fe957f1, 0x43cc2517, 0xdeb174be, 0xd79ab9b2, 0x7a6208d1, 0x7e3ca3cb, 
	0xccd49275, 0x8893f089, 0xe30856ff, 0x9d938ebb, 0xd38c0767, 0x6079c068, 
	0xf33b54de, 0x7f1f1c21, 0xddf36d27, 0xae11da7f, 0xb5c6bd23, 0xf3ac9bb3, 
	0xb2db3df4, 0x72abfd74, 0xe6ff0efe, 0x21ec8239, 0x8a782f9c, 0x861035e1, 
	0x8253c5b6, 0xaf1c1b71, 0xfebd9e3c, 0xca9fec6d, 0x31f2a7be, 0x3f56caf5, 
	0x3829f5d6, 0xdfe4dd7f, 0x0d9c6b2f, 0x3b3c517a, 0x34bbee2f, 0x5c106f87, 
	0x4b6f9d60, 0x58e490bd, 0x60ddbace, 0xf15a001d, 0xe71e8339, 0xc31dd39b, 
	0x3c5cf3fc, 0xbff93c43, 0xaa1a616f, 0x0003b801, 0x7ddd9c78, 0xd55c7c7b, 
	0x3b99e079, 0x199a1e77, 0xbd19dccd, 0x596bef46, 0xcc6d83c6, 0x8e0c7e00, 
	0x2cb6d7c0, 0xc8978ecb, 0x49411086, 0x11b21322, 0xe208dd29, 0x85ebc23a, 
	0xc921233b, 0xe64918c6, 0x0ac8f321, 0xa4251a12, 0x55aa1048, 0x1b5cda52, 
	0x34d9db13, 0x684d2955, 0x57e54d37, 0x2a855223, 0x38e11684, 0x77df7ef1, 
	0xcb2f3bbe, 0xfdb76921, 0x1f0fcd63, 0xce77d79f, 0x9ce7def9, 0x7d519eef, 
	0x17ecd256, 0x9bdd6ce2, 0x10877149, 0x9fd0dc7f, 0xea10a614, 0xb8a4c9c2, 
	0x1af7085d, 0x3884a7c8, 0x525ef35d, 0x96bcc49c, 0xf0841b14, 0x4b19d65c, 
	0x2b88537c, 0xef12c29c, 0x2108a10b, 0x5fc00f52, 0x3af758c2, 0x235e17f4, 
	0xefed07d9, 0x099a1368, 0x42a81770, 0xf21a7d74, 0xacc3a253, 0x38e17ac7, 
	0xb1f203bc, 0x9b45bba9, 0x3ebb2e10, 0x30c4a7a6, 0x018e9bd6, 0x5d19ffe8, 
	0x414c71ef, 0x7b1d335e, 0xc8feaf21, 0x7c86e051, 0x75d7554c, 0x62d4fcc1, 
	0xc1f648e1, 0x7e3c97fc, 0x76bc0048, 0xa0a54f5d, 0x7c3e3dbe, 0xadd4815a, 
	0xe3fb823a, 0xc243bfd0, 0xce000773, 0x05679a71, 0x0b001bce, 0x77ca00b3, 
	0x6fb43942, 0x13cb7d38, 0xba10af62, 0x35dc3d47, 0xf516f588, 0xdf0ea8f3, 
	0x05e7987e, 0x3f73d3f8, 0x639603e4, 0xbf2650ef, 0xe076ed40, 0xa62b3c7c, 
	0xbf5c0e1c, 0xe076f180, 0xfeef0e78, 0x7b3b4ca9, 0x2f0f349d, 0x92361b34, 
	0x6d083bfd, 0x42cdbec9, 0x9223dddc, 0xce10a75d, 0x6081c3b0, 0xe09396a2, 
	0x2472ef9c, 0x937d43d7, 0x6b2f77ac, 0xc7b53a21, 0xf30dd175, 0xa9a633ba, 
	0x3e01575d, 0x224f6996, 0xd44d153e, 0x840eb069, 0xe501d7d1, 0xf110a255, 
	0xfba24506, 0xd7d8844f, 0xa7ca14ef, 0x82b5de64, 0x7934bdf0, 0xeba6f292, 
	0x1851a40c, 0x75482de3, 0x5a7555fd, 0x427731c2, 0x12d5ffbe, 0xcea634e7, 
	0x4e3b575e, 0x4dde7850, 0x12bd3e12, 0xb3e13a9f, 0xd4cc2220, 0x9aaa2159, 
	0x7a46eee7, 0x1a9e682e, 0x3e61b577, 0xc271bc2e, 0xf53ce78f, 0x4bdfbd33, 
	0x37829c11, 0x7e0b3528, 0x33bef324, 0x919bef32, 0xa9bbff79, 0x6fe03ccc, 
	0xb214f9ff, 0xeef1e199, 0x6a3814c0, 0x0ff3c4b3, 0xea9ac02f, 0x57bef28d, 
	0x10c5d531, 0x2ad8b1ae, 0xa98a3bed, 0xa021cf7e, 0x8a602b81, 0x76b863be, 
	0x49ffba33, 0x57d0ad4c, 0xa0da4237, 0x0ec41f47, 0xb423c743, 0x048c089e, 
	0xaca6b948, 0x05df535d, 0x8cedac9c, 0x54ffd0e8, 0x7141f1e4, 0xa4468848, 
	0xaed0a3e7, 0x0d3afae5, 0x0ca92fda, 0x1b8a7e49, 0x4df21a75, 0xc1a85cc2, 
	0x98343abc, 0x91e1d023, 0x7d4d0ea2, 0x63dff887, 0x857a4396, 0x114e6839, 
	0xda1314fe, 0x674ef96d, 0xd9f8013c, 0x4f113932, 0x15bad18c, 0xdfca24f3, 
	0xfae14aff, 0x33ad7cb6, 0xd116280e, 0x025b8c00, 0xfbb80348, 0x30055e81, 
	0x065ec7a9, 0xc5466fb0, 0xdca8b781, 0x5ee5803c, 0xb951ab31, 0x277c3ea6, 
	0x14ba03f7, 0xf0bf5358, 0x4d7c5d02, 0x08e6bd73, 0xf5cc37a4, 0x8f39118a, 
	0xf5eb1329, 0x08a7879e, 0x55f0fa9e, 0xb9e03e3c, 0x1f575260, 0x796e3a06, 
	0xca79e799, 0xd2f72b8c, 0x57f85d3c, 0x08184b85, 0x0a0fda1f, 0xa696c3c0, 
	0x0486b9ce, 0x48cdff94, 0x533ca0a4, 0x3866755f, 0x919bde12, 0x47cddf0b, 
	0xaa3ce1b6, 0xc2448ece, 0x231f883b, 0xc0e7377b, 0xfa73214b, 0x6dbbfe6e, 
	0xfbb418a9, 0x4ed931c7, 0x77bb54bb, 0xddb125b6, 0xbb64264f, 0x313bb428, 
	0x576c3c3f, 0xd961e5fc, 0xbc14bf4e, 0xb604db23, 0x17e78e7b, 0x053c34bb, 
	0x47fc51d6, 0xa5f8bf3c, 0xcdb3bdda, 0xc2beed81, 0x71c84bf3, 0x2ca8b2ff, 
	0xdb90fe22, 0xd8784b95, 0x98854a0e, 0x0b07e215, 0x9f135eff, 0xdacafa87, 
	0x11429757, 0x90b980e4, 0x534cff3f, 0x27f1e677, 0xe2788df0, 0x913cc478, 
	0x06dea7c5, 0xfffdd3e2, 0x3e5e78bd, 0x74f90d7d, 0x35f4f916, 0x8f27bd4d, 
	0x6a2e414f, 0xb6fce58b, 0xfe209adc, 0x825372dc, 0xdf9ed1f8, 0xbfdf6535, 
	0x1e704e58, 0x31e6f287, 0xf1e698b7, 0xbcf89ee6, 0x5a41f8f3, 0x2f907e5e, 
	0x7413292f, 0x227d6f93, 0xf8670e6e, 0x7f0b07e7, 0x05ff39a4, 0x3cc3759a, 
	0xd96d9ec1, 0x7ca2711e, 0xa83ed96e, 0xcc1f7a60, 0xccc8ed5b, 0x3ef962f3, 
	0xb2fe3173, 0xd274dbe5, 0x757fdb7c, 0x9df3bce5, 0x6677cf49, 0x553ef95e, 
	0x466ef306, 0x216a9b79, 0x07855179, 0x29cb65e5, 0x198fcb07, 0xc851fca4, 
	0x0ab51e93, 0x196fbf51, 0xf803e74f, 0x2011ac77, 0x8da5bc03, 0xfc054856, 
	0x21146faf, 0x37d7f215, 0x8631411a, 0x2496adf0, 0x5b8d63d0, 0x2def3898, 
	0xbfb8eb9d, 0xabbc13f0, 0x1af2dbd7, 0x43aebfc6, 0xebcf2078, 0x2e2a5e00, 
	0xbc0497e7, 0xe0c3b96e, 0xfb13a67e, 0xc86b3ca1, 0xdb12df8f, 0x08b6ff64, 
	0xd0b5b9da, 0xef83ed1f, 0x975c96c7, 0xdf2c15d0, 0x47aa6bb2, 0xe35dbe03, 
	0x3bda1611, 0x8bc556ff, 0x00e08076, 0x3d6e17bf, 0xdc615212, 0x06fe3c8d, 
	0xdf8c0f5c, 0x84d9ebcc, 0xf5cb89eb, 0x294f5038, 0xb74c36ca, 0x33de3aec, 
	0x7b6afa80, 0xac0736dd, 0xe3e32573, 0x98ff9c6a, 0xfb963f9c, 0xa1b6278e, 
	0x491df27e, 0xf4fe436c, 0x50f21d7d, 0x85f38d5f, 0x2ab68af1, 0x10cf9e34, 
	0x2fa84cdb, 0x13821556, 0x8bcea9be, 0x23d43578, 0x3623f421, 0x784f5d6f, 
	0x86acf9b5, 0xf9e5abc7, 0x805f38ea, 0x17cf6757, 0x2f9925e0, 0xebed02bf, 
	0xf665fdb9, 0x1b7d0cfc, 0xbfaec7d2, 0x2ed3e71c, 0x7eac89fb, 0x38bf7057, 
	0xe33179d3, 0x674d9165, 0x82c8ef68, 0xb8f190b3, 0x8c23a6c0, 0xb782c8e3, 
	0x3d671ec2, 0xfcab37ac, 0x9cb7ee2a, 0xebc259c7, 0x0e3d90f9, 0xef9ecfb4, 
	0x90af3cb5, 0x3d7ace3d, 0x330dbd67, 0x7e09251e, 0x41e38690, 0xca406f3f, 
	0x573be24f, 0x3fffa829, 0x06175c0a, 0xd453dbf9, 0x43771612, 0xb0f84079, 
	0x2b7ae27d, 0x9e7b0494, 0x7e516b58, 0x4a11a175, 0x4caea82a, 0x587e092d, 
	0x2e00cfc3, 0xc50d3df8, 0x4e092466, 0x6e1b16c0, 0x117a19a1, 0xa75f9fdb, 
	0x8cca98bd, 0x05e5eab7, 0xd2a7de34, 0x2c227de3, 0x82ed0e7e, 0xafe11846, 
	0x383c306a, 0x2cebaade, 0x0aaee10d, 0xf7988519, 0x8d088836, 0x578f36f7, 
	0x3325e302, 0x590eade3, 0xd56f1c61, 0x178193af, 0xd778cc95, 0xefae517c, 
	0x7778f4ee, 0x09aefad1, 0x73841e98, 0x0f86f5cd, 0xd6b35fe1, 0x57f8e0f2, 
	0x1e028a16, 0x1d049bcf, 0x12cff0d4, 0xb9a50d6f, 0x68535de3, 0x2bbc717a, 
	0xb20b27cf, 0x87765bc7, 0x38fddf5c, 0xb78e075e, 0x6577d69b, 0x78e3f0d0, 
	0xad041acb, 0x2275d967, 0xe590f940, 0x0559e395, 0x4c35beb8, 0x5cb286a7, 
	0x32195e7c, 0xf6c45e0a, 0xcde75ebf, 0xd569af1e, 0x43de34d5, 0xd1f5f5e9, 
	0x06029afa, 0x5eba6fc1, 0xa6af48a8, 0xe11fa6b5, 0x411a1636, 0xd70f9fa6, 
	0xb7e986b7, 0x4d7e8f26, 0xd7105685, 0xb0fe78d7, 0xc0bc7b33, 0xf78d3a1d, 
	0x8f7d7a64, 0x418d78d1, 0x1a04e08b, 0x13d7150c, 0x5270ceb8, 0xbc5c243e, 
	0x43c6953e, 0xae7e81ba, 0x4ba01634, 0x7562aa2a, 0x7cb6f902, 0xb7c03216, 
	0x0e50ed15, 0xb7d65e7c, 0x1f34f280, 0x56d153d0, 0xae7e07a8, 0xa1a1dd6c, 
	0x6f45541c, 0xcbce50d7, 0x5f28dae7, 0xc8394261, 0xac875945, 0x51b7b68f, 
	0x446431be, 0x5a951d70, 0xfa153add, 0xe2901957, 0x3ac16278, 0x58915fec, 
	0x16b2f940, 0x747da148, 0xe57ca748, 0x71bbc9ec, 0x29c4aafc, 0x6b9507da, 
	0x83115f32, 0x29bfdb14, 0x3b5f81f3, 0x6d1f8434, 0x74fe453e, 0x1482f4e5, 
	0x811aafb6, 0xcba7e714, 0x5214457c, 0x4871df9c, 0x58747fa1, 0xf7a57ca7, 
	0x67d441f6, 0x063bfd55, 0xc7950f51, 0xc2be5077, 0x2ff4290b, 0x7ca36ceb, 
	0xf94edc54, 0x2a05b9ca, 0xbad3ebf9, 0xcdf6c2ea, 0x0c315f32, 0xa137b629, 
	0xe9f7db1c, 0xf37b2794, 0x7d73b669, 0x5ae60f68, 0x839824c4, 0x1b1904a9, 
	0x9f94c7d4, 0x38b7fce4, 0x94de416f, 0x40b459fa, 0xa3d64c7e, 0xbf6497ff, 
	0xc1bf0357, 0xee79abb7, 0x93db18b1, 0x10fcb947, 0x15ccb796, 0x2ef632c7, 
	0xdbd53e53, 0x7733e50f, 0xfb629abc, 0x083da8aa, 0x809d6577, 0xa591dbfc, 
	0xb15df764, 0xa0cb15e3, 0x17e8bc7c, 0x83fe0161, 0x455cd16b, 0xaf483ec3, 
	0x01c27918, 0x3e2f6e70, 0x0bf77c4b, 0x10f796b4, 0x9cb2489c, 0x31c022ed, 
	0x03f9070c, 0xca7dfda2, 0x1f26ff7f, 0x63d615c1, 0x195fe62a, 0xdf187ae3, 
	0xafe7bb04, 0xa4375e10, 0x78e4446f, 0x5a9535c2, 0x3761a26e, 0xd15eb0bb, 
	0xf9fa072c, 0x86bfdacd, 0x8202cfd1, 0x9ed06728, 0x11fb74de, 0x346b8e07, 
	0x25515c11, 0x3815ae18, 0x8f02f84f, 0x0ff97de2, 0x75e64f1e, 0x53709dbb, 
	0xd9bce0de, 0xe4cb7945, 0x5008bf7c, 0xbdbb61fd, 0x0471a011, 0xb4135fcf, 
	0x587fbb3e, 0x014ebb5b, 0x2a26b87e, 0xe7ed372c, 0x29f7152c, 0xb943cc21, 
	0x5c2e1343, 0xa170740f, 0xcadb87df, 0x9a11251f, 0x96e596e1, 0xca3bf71b, 
	0xe68089e2, 0xeeac3404, 0xd13a8c2c, 0x07bf029f, 0x70c273f7, 0x7806bd52, 
	0xd4cf7586, 0x93f309f4, 0x49ceedd0, 0x1080fdd1, 0xbc7a423f, 0xd107a193, 
	0x56f11667, 0x5aa9fe4d, 0xc32f9426, 0xdacb5cda, 0xe3c74852, 0xd7bfd160, 
	0x4f0efff5, 0x37e911c6, 0x52e9e3e6, 0x6c7c2178, 0x9378f896, 0xe116f636, 
	0x99b1f087, 0x37f441f1, 0xa2f28203, 0x2a2e8df0, 0xd2137c2f, 0x85facb99, 
	0x0f500ff9, 0x4a5bb0ba, 0x83db1388, 0xf6c42d8d, 0x9a6dfc69, 0xbd21d42b, 
	0x08fae4bc, 0x1f05b3fa, 0x20c60ceb, 0xe12dbbef, 0x7894e65c, 0x7c94ee38, 
	0xf9edfd83, 0x1178cefe, 0x4978b9dd, 0xcb2fffef, 0x70e593c1, 0xe0278bcc, 
	0x3f3650a7, 0xaf283fc1, 0xd7ccb0c1, 0xd26bb784, 0x6175e4fc, 0x6a7e62fe, 
	0xc972cb76, 0x479e264f, 0xf3ed7e10, 0x4e3de105, 0x779607e7, 0xe0a35292, 
	0x05f2854d, 0xbe1a9453, 0xcdf79969, 0x9cff7aca, 0x00e7fbcc, 0x0ccb8a4f, 
	0xbff882bc, 0x477fc32f, 0xa86ba769, 0x36ff09bf, 0x7c954fde, 0xbfd1f88e, 
	0x70182e78, 0xd2dadfa0, 0x9ffcfc8d, 0xffe5074e, 0x3d183a53, 0x9c72a3ce, 
	0xbe49bfc0, 0x89fc4b7f, 0x5f2fe04b, 0x132bd5de, 0xdc4ec585, 0x56144e47, 
	0x48fdea41, 0xf28f5822, 0x2089c9f7, 0x11ea9fca, 0xff8efda1, 0x14f63c7c, 
	0xbd908e1f, 0x7c227c01, 0x2efef6df, 0x452ae301, 0x7e43df43, 0x20f82dfc, 
	0xfe0f3734, 0xa76abc67, 0x4bcd3379, 0x19d93098, 0xa05f3821, 0x21ea1640, 
	0xfaac83ff, 0xceec9180, 0xcbcbef6e, 0xfc4309eb, 0x34df2b30, 0x33fb8b57, 
	0x8de17f7b, 0x873c4998, 0xfb0a6370, 0xb9aef77c, 0xfa23f25a, 0xeee11fa5, 
	0x47e4e84c, 0xe11fa424, 0x3af395be, 0x1e4197e7, 0xf6c8b7db, 0x07347bc1, 
	0xe9af1bd9, 0xeeed6130, 0x3d488739, 0xa1954d4a, 0x942e5893, 0x35e40b31, 
	0x6c724d32, 0x5e6903ef, 0x799d0fb0, 0xef2d68ec, 0x3c2217cf, 0x11839e7b, 
	0xcf38cbeb, 0x3cc29883, 0x52ff8e0f, 0x43e473ce, 0xd1a0fc04, 0xf135e720, 
	0xc1c79a21, 0x6e6f9ced, 0x1b3bf590, 0x1b5b3ce4, 0x6bd07ea8, 0x941a9bd5, 
	0xbd06fcf3, 0x1b58fd66, 0x087ea961, 0x54abb3e8, 0x8f333ffa, 0x2179a79d, 
	0x3d800ccb, 0x54d2187c, 0x54bfd409, 0x08bf40e4, 0xe2cef7cb, 0xfa11447a, 
	0x3a9e7435, 0xd5f9eb8b, 0x48098983, 0x4fdbae5b, 0x0290ede9, 0x9e23a68a, 
	0x999be422, 0x4cfcb29d, 0xc8d3d95d, 0x2d9f3b2f, 0x65d926fa, 0x7ee717ec, 
	0xc637ee71, 0x8e92e3ed, 0xfb3f8449, 0x9df71d21, 0xe5f23e67, 0x0869f06a, 
	0x9e038f4f, 0x5576cd76, 0x6ece742b, 0x8af9e356, 0x459cb065, 0x01fba7cd, 
	0x70985fff, 0x1ed269d6, 0xe3803e8a, 0xe07f8228, 0xec7baff9, 0xf7ea0394, 
	0x78a53fb1, 0xf497aaa6, 0xbf1c9c11, 0xe795ad4c, 0x5d77e4de, 0xaefdf885, 
	0xfbb9e513, 0xd7c93e1b, 0x7e90af2d, 0x98b3bb78, 0x6aa33dc6, 0x53523c0e, 
	0xc51ddb8a, 0xbf23c126, 0x8f67b84d, 0xdfa04e38, 0x43e13976, 0xaaa5cf14, 
	0x6fc11a48, 0xb8cebc03, 0xa4e6bdad, 0x39220160, 0x579397d8, 0x9592df20, 
	0xd0f2f357, 0xe49e705f, 0xe4e7fa06, 0xcc98bfa1, 0xf9b9abca, 0x0f3caad3, 
	0x872bfd3e, 0x379e2941, 0x245ada42, 0x0bfea5cf, 0x6f4871a4, 0xe919b487, 
	0x7ec153f1, 0x6ea8f0b1, 0x84dc9f6c, 0x7fa70af7, 0xd053fb05, 0x4c2e6717, 
	0x374e9079, 0xe802fb42, 0x3c253b57, 0x27b6444a, 0x3c2bd7ff, 0xd2ff4803, 
	0xdd12f7f7, 0x61f76bf5, 0xcfcf9f6a, 0x33f32d5c, 0x5d8e908d, 0x1a667f0c, 
	0x333f7fc6, 0x46de3dbe, 0xc8eb4f18, 0x34ed59c8, 0xd1fc0b8c, 0x777f748c, 
	0x4edff19e, 0x08ffbaa4, 0xf6aed7fa, 0xfe7f41e0, 0xbfb8aa7c, 0x579ecfdd, 
	0x3f3c9e7a, 0x1c3ade1b, 0x99cafc07, 0xa4fc5c99, 0xc39d16dc, 0x17442b8b, 
	0xd709e39e, 0x0dea1774, 0xb8547b7f, 0x7be03ca1, 0xe73c55f3, 0x38f7533b, 
	0x42aaef9d, 0xdff9e271, 0x43a26b4c, 0x94eb7ea0, 0xaed026fa, 0x37ba4ca7, 
	0x53e414b1, 0x6fa97eeb, 0xd76e0c67, 0xdc21db2c, 0xd01f801e, 0x17ded4ca, 
	0x25b4e0b3, 0xf22c9f98, 0x2bc7fd07, 0xa18fddc3, 0x1e48d73e, 0x7f83fd6d, 
	0xde8f00ba, 0x7fde792a, 0x340be6ba, 0xe61b82af, 0xa98745b6, 0x0073c15c, 
	0xb1eeb34a, 0x974c7eb0, 0x99dae9f8, 0x8ae86e55, 0xe70a1c78, 0x9794213c, 
	0x5bce4d3e, 0x016efa1d, 0xf44347ca, 0x3ca21fc2, 0x576268ce, 0x6c583db6, 
	0xff7a20de, 0xd713ca00, 0x076812ee, 0xf9a5aea6, 0xe2109fc3, 0xc343a6c7, 
	0x33d102dc, 0xb8a6ed0d, 0x62aff71d, 0x8ff335fd, 0x023db7c3, 0x7b5d3af3, 
	0x21db4ea1, 0xa59c3fe5, 0x207f5017, 0xfb964d3e, 0xa66525aa, 0x0fd669f2, 
	0x27de40cf, 0x90a7fb7a, 0x3acf236e, 0x4fdf8ec8, 0x8b300ded, 0x5eb6f728, 
	0x1ef071a1, 0xcd3e4b44, 0x716ab1fb, 0x02bd62e2, 0xef6472ff, 0x24e744e7, 
	0x2e0f17d5, 0x7fc3f596, 0xe2a57a42, 0x57c11719, 0xc6764134, 0x51f52355, 
	0xf5b15ebe, 0x71911bc9, 0x72e25fa9, 0x1ddc283f, 0xd3ae070e, 0xf70ebed5, 
	0x27c74031, 0x1a77ce90, 0xf91eba7f, 0x3b77a6d8, 0x8f99ffcb, 0x0da1535d, 
	0x7b7cf465, 0xd6c2b3b3, 0xfd6cdeaf, 0xf74f9baa, 0x360b1e31, 0x1dfdf6cb, 
	0xad1f7fc8, 0xf23f79c6, 0x0ed902ee, 0x4b23b5f1, 0x5affdecf, 0xd9e83d75, 
	0x5a3f7bd1, 0xf485ef57, 0x25d436f7, 0x5bfdfd20, 0xf4a42e0e, 0x970b5d53, 
	0xbf3e21f5, 0x00f7845f, 0xebf8ed77, 0x7e5065ba, 0x797e67d7, 0xb19e51ca, 
	0xe48b6537, 0x1af0887d, 0x18fef64a, 0xf09eb7d6, 0xbc1426d1, 0x2ed02def, 
	0xfabfd1c4, 0x7bb1ea19, 0x7ba15fc8, 0x7a8fea11, 0x50cf08ae, 0xf3225f20, 
	0xbd9533a0, 0xd47b6487, 0x29f2e95b, 0xf2e21ca1, 0xc85f6c72, 0xedb9cde5, 
	0xb00f9067, 0xd3d4257e, 0x97d43fb9, 0xcbb3c167, 0x957ca10d, 0xed8e5dfb, 
	0x867863af, 0xfe0f0392, 0xca77a828, 0x67d7def8, 0xbabd3de8, 0xbd7ba72c, 
	0xb45db5da, 0x633f03df, 0x1dafde2f, 0x8fe07a87, 0x86c4f340, 0xbec53f6c, 
	0x1fdf4bb7, 0x337ae619, 0xef0ebefb, 0x015fd0fd, 0x625607d8, 0x461f535e, 
	0x4f5266bf, 0x56fd001d, 0x89c242f2, 0x7f7641e7, 0x77e4b157, 0x0f5cd35f, 
	0x1792f5da, 0x4fa4143a, 0x9250c041, 0x6e82ef80, 0xea628533, 0x01bc3e8b, 
	0xb60ac7ef, 0xbd43fc82, 0x4794ea17, 0xdbe79cf1, 0xa624e329, 0xa00cbb6b, 
	0x6cc9a057, 0x9cbeff59, 0xe00e2d0f, 0xec647737, 0x8986efbc, 0x9b3fbc16, 
	0x41689e69, 0xfccbc03f, 0x7e60b5ea, 0xd5c698d3, 0x162f4187, 0xbd7e24b8, 
	0x28f34101, 0x0a50ef1d, 0xd09e700a, 0x0257fa0f, 0xf3f50d5c, 0xb587904d, 
	0x59bf8cce, 0x6c3f44eb, 0x20a7a122, 0x2236be8d, 0xac6851d7, 0xe967f64f, 
	0x9fd966f9, 0xccde11fa, 0x4679660d, 0x25ea05bf, 0x46ddfd7e, 0x10bbae17, 
	0x6df08ff0, 0xdefff43e, 0xf6cbf910, 0xa7800a7a, 0xdeb43353, 0x3d77d214, 
	0x2efbcbcc, 0xa7ac2bf3, 0x9b7db5a0, 0xb0b86768, 0x57d404ce, 0xc5023e02, 
	0x29f36f32, 0xcd982bf6, 0xc53e672a, 0xcf6c72f2, 0x9f36bcf7, 0x15d7edda, 
	0xac0d3e4b, 0x24a7efb0, 0xd9e1a69f, 0x58a7cce5, 0x6bc2397e, 0xa7cc7860, 
	0x4f9b7b76, 0xff805a0b, 0xe441ef00, 0x03c4b8d3, 0xd21d21f9, 0xecf9067f, 
	0x42b17bc2, 0x0cf5ca03, 0xe17b6cfe, 0xe2148a0d, 0xcf01ea9d, 0x23c016a1, 
	0x5bb43bd0, 0xa6b7e898, 0x23a3e1f9, 0x1380515d, 0x50de18ec, 0xe70b9c3e, 
	0x0f5c9dc9, 0x4c060f78, 0x4861d0e5, 0x9436c65b, 0x4c3afd23, 0xdff2dfba, 
	0xcf108464, 0xe7683c36, 0x7eb1864c, 0xc0f905a8, 0xcd30db7f, 0x6ccbb833, 
	0x9e2f8731, 0xfc33d527, 0xd9bfc224, 0x0d38be24, 0x8e38c7f3, 0x652341d3, 
	0x9a3e02f6, 0xd7edb712, 0x9c3c5a65, 0x79010fb5, 0x69827b45, 0x26e1299f, 
	0x23f6e5df, 0x71463edc, 0x5fcf5231, 0x0affef21, 0x84743c3e, 0xb15d43ee, 
	0x96736223, 0x7e2434bd, 0x415798d5, 0x8be7d27f, 0x037dc11e, 0xc8bb05f8, 
	0x6c85cfee, 0xce5770bf, 0x03f6ca7e, 0xbb843726, 0xf3f3334b, 0xd79d18dd, 
	0x9c5ad81f, 0xcc7dc62c, 0x299d6d99, 0xf6df6f64, 0xeb922ec9, 0x36437366, 
	0xbe02ee9e, 0xd1f9e270, 0x9e0a4dd1, 0xac3d53a7, 0xdf95ece7, 0xb9d0350e, 
	0x61247094, 0x1e63675d, 0x56a1d70d, 0x24f2be49, 0xe017a72c, 0xd95f330d, 
	0x4b168fe5, 0xf9f2ad3d, 0xd7962bbe, 0xbb9658ae, 0x5fe5b9e3, 0xc0ef3e44, 
	0x778e16b8, 0xc7ebce68, 0x72c35ee5, 0x72c90ec6, 0x857573e4, 0xe4760f2c, 
	0x3a986fb6, 0xf6c2f74c, 0x969d433a, 0x1a425453, 0x835e90f3, 0x82f639f9, 
	0xc547f36f, 0x6d439ef2, 0x383c9730, 0xee6ed847, 0xd1e347de, 0x0ddd53fe, 
	0xbe47eb78, 0x3f5f1376, 0x81afed0f, 0x17731d71, 0x04003f68, 0xe8077aed, 
	0xedf73a13, 0x013b07a6, 0xa43d4097, 0x5d5c7a5f, 0x6f3b17ea, 0x20dab1f3, 
	0x1477181c, 0x7d92273a, 0x96872fe0, 0x0f3ea958, 0xe6b16bd0, 0x7fb8c2f0, 
	0xe60ffa81, 0xbea557e5, 0xeb03ab3a, 0x29d5bfc1, 0x740bc847, 0xfa75e69a, 
	0xcc6acf19, 0x3394e470, 0x99b8d59e, 0x5274ce5b, 0x796e5613, 0x3d07b73d, 
	0x78ce5392, 0x9c8d9b57, 0x2bb669f2, 0xdabfc67e, 0xbeb13a61, 0x17ccab70, 
	0xde0a5956, 0x8cff2063, 0x96b8e015, 0xf558fb82, 0x178975dd, 0x1efe210d, 
	0x1f5147fa, 0x881c79cd, 0xd615b547, 0x7cebc437, 0xa12f8324, 0x5ef52118, 
	0x03b413c4, 0x46e9d778, 0x6d4d8508, 0xda1abf05, 0xda29875f, 0xa684dbf2, 
	0x07facfbe, 0xc0616fec, 0xca31e270, 0xa91d7dcc, 0x7ec017f1, 0xc33d9eb1, 
	0x129434fa, 0x48f5130e, 0x1baa675d, 0x19ad43ea, 0xf91ca13a, 0xdea28f61, 
	0xdfa8e5c5, 0xca17567c, 0x7c052869, 0xfc157a80, 0x0b178c7a, 0xfec9112d, 
	0xab3f3863, 0xd4e31fab, 0x1842dbea, 0x225a52ef, 0xee6763f7, 0x335d68d7, 
	0x037fc075, 0x74dbdf30, 0x173c04e1, 0xf1394895, 0x3849e5a7, 0x828780bc, 
	0xd84fe912, 0x9e5817e5, 0xca7969fc, 0xa796976b, 0x896f72dc, 0x2d3fa75c, 
	0xd2fd794f, 0xb11c24f2, 0xfe8e5972, 0x4f2d3f8d, 0xa61bedb9, 0x1fd40e1c, 
	0x4ed5fcf6, 0xd0cc1fa8, 0x3dba4549, 0xf2087c89, 0xadf08255, 0xd0e03f54, 
	0xa5d9375f, 0x22f5cbf5, 0x7bbb423e, 0x49d93e36, 0xb7d13672, 0x2965d70f, 
	0x0dfc4768, 0x873f1d72, 0x66cd14f5, 0xa2ec0be4, 0xbe41eb13, 0xcb9c1e96, 
	0xaed197c8, 0xf6bf68ab, 0xde7dfbd9, 0x5efda417, 0xda30373e, 0x3a259fa4, 
	0xd07dd117, 0x4b5657fe, 0x91b63dbf, 0xbe553fda, 0x278be652, 0x45eaad9e, 
	0x8256367f, 0x5fd7e9e7, 0x5dfc97b8, 0x775582e3, 0x67f193c8, 0x2f4438cf, 
	0xaf6715ba, 0x49aaab5c, 0x3f5207c9, 0x37e8aaf6, 0x3869e864, 0x798d7f11, 
	0x44b6bcf4, 0x7a1907fa, 0xd34bb5e6, 0x7d7cb733, 0x198fd489, 0x4bf5e67a, 
	0x2270d3d3, 0xe8f31b3d, 0x6dcb6819, 0xd386eaaf, 0xbf481bb6, 0x03c876c2, 
	0xfa6d0afd, 0x3f505d01, 0xfa91296e, 0xde60dfd1, 0x5ba4a0f8, 0x927ddefb, 
	0xfd1fa8be, 0xfd216d9f, 0xca5bb858, 0xffe047c5, 0xf77e886b, 0x8c5c5177, 
	0xa48efa30, 0xdadcfea0, 0x63f4f98e, 0xc1b9ab61, 0xe213b7be, 0x6fe93d62, 
	0xd92ec8b0, 0x753d42f8, 0x39cbf510, 0x10ade493, 0xd03f66f4, 0xfa17cced, 
	0xda1fb89d, 0x9ae32259, 0xf4137ad2, 0x20cdea12, 0xa7ea27f0, 0x18be3603, 
	0xe6f5905e, 0x07fc3c81, 0xc81e6f59, 0xf5905fa3, 0xf59cba66, 0xe6f59066, 
	0x047a3c81, 0xe5da6f59, 0x46f9e298, 0x04dace5a, 0x5b05cde9, 0x55059c25, 
	0x4dea5396, 0x97c097d0, 0xdea3c821, 0xf4957f04, 0x89f43766, 0xee637ee2, 
	0xfe0ff918, 0x207fd04e, 0x0f516767, 0xd34de8e6, 0xf0b37a89, 0xfb03b41c, 
	0x3c056c12, 0x89ded428, 0x298828fa, 0xa03dcdea, 0xaf9da137, 0xfe823cd7, 
	0xe18082d0, 0x44feb645, 0xd1496f59, 0xd88fd1cf, 0x6871825b, 0xfe959f85, 
	0x22f47cc3, 0xa2bc097d, 0x04fd60ce, 0x3e850ff9, 0x6165f483, 0x584dda4a, 
	0x12b7c50f, 0xbce136bd, 0xf81fa20c, 0x97d44e67, 0xf2fad8af, 0x9eb49373, 
	0x3d615b99, 0x7b839fa0, 0xdd40df40, 0x865f5937, 0x6c9e24aa, 0xbc651af9, 
	0xb1cfe5da, 0x9fd8857c, 0xdd2be5b6, 0x5b6ffd8e, 0x17f2ecbe, 0x96865f58, 
	0x7cb63849, 0xb971fba5, 0x2ca35f2d, 0xbff6215f, 0xdbb2f96d, 0xcf65f2db, 
	0x20d5b0bf, 0xde4a5f3a, 0x7ec0cb42, 0x2043bac0, 0xbf2fa84f, 0xb900f8c9, 
	0xd293dcfa, 0x687e992f, 0x92cbae1f, 0xfbfd90fa, 0xa2ffe1c7, 0xe9bc8c8e, 
	0xbf25e101, 0x6fb7dcfc, 0x1197d6ca, 0x4adf82ef, 0x02c4465f, 0xc2f52fa9, 
	0x981f3c3a, 0xd5268d86, 0xce83bf1f, 0xa87e5a0b, 0xefcbe9e4, 0x5ffee097, 
	0xf493b87b, 0xa93de465, 0x3c70172f, 0xe8e9d55d, 0xa527bd37, 0xfe8fd01f, 
	0x507318a3, 0x962bb41c, 0x433a78a4, 0x9f83f474, 0x2128b8db, 0xbdf926bc, 
	0xe759fd1d, 0xfdedbe4a, 0x2d1e3187, 0xe0ff1cbf, 0x47f61079, 0x9d5adabf, 
	0xd29ea810, 0x0ddcf27e, 0xe3865e74, 0x9f1fe7cf, 0x1282f2bd, 0x631f2537, 
	0xd8d9c1fc, 0xb7fa2726, 0x497f34be, 0xe99e77fb, 0x9cff9769, 0xe697d0f9, 
	0x6976bcaf, 0x3f2dcafe, 0x97dbfac7, 0x7ebcafe6, 0xf692fe69, 0x97f33cf8, 
	0xdc2bf98f, 0x68bedb97, 0xf5b23848, 0xf5fdbe77, 0xf5077ec1, 0xf52a52b7, 
	0x4cc1afb7, 0x7b1b7fb2, 0x99e387d8, 0x757dbfa4, 0xeca0525a, 0x94f6feb2, 
	0x6d7bfada, 0x536fea52, 0x767fa24d, 0xf393ed6e, 0x78756fe9, 0xb8b6ff7e, 
	0x6dbd24c1, 0x673d49e3, 0x0f41faa6, 0xcf804ba9, 0x58fdcfd1, 0x7afa82bf, 
	0x05fb2949, 0xb6726e7c, 0xfc0af405, 0xa96437db, 0x575c5fe8, 0x5b4dfd2a, 
	0xafa87d9e, 0xdf19cbb3, 0xd9d7d43e, 0x1f2f4ce5, 0x72ecebea, 0x50fba7de, 
	0x3397675f, 0xafa87dfe, 0x4531cab3, 0x7396d73f, 0xf3419f5f, 0x8ebeb08a, 
	0xe3150954, 0xc68f90a8, 0xc8344e40, 0xddf6bea3, 0x12dafa06, 0xada94d62, 
	0xc4157baf, 0xc934cfa7, 0xe675a56f, 0x89cb6be8, 0x0e7aabfe, 0xfb8eddda, 
	0x29cfd069, 0x40d80f6c, 0x41e980bd, 0xe4014181, 0x400246e7, 0x58a71817, 
	0xe9939f47, 0xea898e00, 0xa65f7413, 0x755de9e6, 0x18ffe009, 0x157f07c2, 
	0xa9577fe6, 0xc63e93b4, 0x443bee3b, 0xc0a9fa1f, 0xef77a047, 0x67e7952c, 
	0x542b7d19, 0xe78fbfe4, 0xd2c6f7e1, 0xd79b7d7c, 0x390f232e, 0x4a95b7e5, 
	0xdbe8c879, 0x79197ebc, 0xb01e5150, 0xa17bf71c, 0xb4e43c8c, 0x29507907, 
	0xf48f7a8e, 0xea1d354f, 0x86adf4b3, 0xd0f903f8, 0x4a6df5f2, 0xbdbea24b, 
	0x7201f193, 0xa7fa24f0, 0x56bc3e0e, 0x753b7dcf, 0xf7f713b0, 0x3f975b66, 
	0x621aff5b, 0x5e306bef, 0x9a85d4e7, 0xedbe815f, 0x25e67e97, 0x9070abf5, 
	0xb7a479ff, 0xe6cfea52, 0x5e9f48bb, 0xe642a8b6, 0xe2cfc35d, 0xc9f296bd, 
	0x75773a39, 0x8a5bdd14, 0xb9f0357a, 0x05673a09, 0xfa74fead, 0xe39e5d1c, 
	0xe9ff7838, 0xd4e53960, 0x70a172e2, 0x9cf5c2bd, 0x9c2e5c5a, 0x65399fec, 
	0xe2d4e4de, 0x7f72a172, 0xdc03d6d5, 0x8b85cb9f, 0x3fb8bbfb, 0x0b9716a7, 
	0xb9bbd737, 0xcb8b539e, 0x7be18785, 0x16a73e18, 0x90398397, 0xe7ae5ef5, 
	0x5172e2d4, 0x180bf0c0, 0x9716a73e, 0x7ac8e883, 0x6a73d71f, 0x33f0b971, 
	0xe7c33f7c, 0x1172e2d4, 0xee01fee0, 0xe5c5a9cf, 0x17fb90a2, 0x2d4e7f72, 
	0xae41172e, 0xa73d720f, 0x7bcb9716, 0x677fbc11, 0x5c5a9cf8, 0xfb2b2c0e, 
	0x539fdc6b, 0x9845cb8b, 0x3fb987fb, 0x8b9716a7, 0xb847d708, 0xcb8b539e, 
	0x2fc31145, 0x5a9cf862, 0xb98a2e5c, 0xe7f7317f, 0x5172e2d4, 0xb84bfdc2, 
	0x9716a73f, 0x2fae528b, 0x2d4e7ae5, 0x0c65172e, 0x73e18cbf, 0x88b9716a, 
	0xeb947d72, 0x5cb8b539, 0x72fc3394, 0xc5a9cf86, 0xeb82a2e5, 0x539eb82b, 
	0x2545cb8b, 0xf864afc3, 0x2e5c5a9c, 0x157fb8aa, 0xe2d4e7f7, 0xfdcd5172, 
	0xa73fb9ab, 0x1a8b9716, 0x7ae1afae, 0x172e2d4e, 0x96bf0cb5, 0x716a73e1, 
	0x5eb9d0b9, 0x2d4e7ae7, 0x180b172e, 0xcf8602fe, 0xa2e5c5a9, 0xb8ebeb8e, 
	0xcb8b539e, 0xbf8642c5, 0x6a73e190, 0xe7a8b971, 0x9fdcf5fe, 0xc5cb8b53, 
	0x88bfee22, 0x716a73fb, 0xeb8cb8b9, 0x4e7ae32f, 0x8b172e2d, 0x8662fe19, 
	0xe5c5a9cf, 0x31f5c622, 0xe2d4e7ae, 0xc3397172, 0x73e19cbf, 0x58b9716a, 
	0xb84bf5c2, 0xcb8b539e, 0xbf8652c5, 0x6a73e194, 0xdb8cf951, 0xff123f24, 
	0x185e1c70, 0x27b420fd, 0x739fb1ef, 0xd526d20c, 0x98d315e3, 0xb3373b4a, 
	0x11ea4d6a, 0x2f7ea7ba, 0xe1cfdf6c, 0xb9f67977, 0x2a78a6f1, 0x5e74f74c, 
	0x79601e11, 0x14703b45, 0x13b2307c, 0xb3018857, 0x56b5da0d, 0x70b37dd0, 
	0x39e00c8d, 0xe86fa372, 0xef0b4caf, 0xd074d757, 0x0d7c69bd, 0xb9454a4d, 
	0x1af141df, 0x2fef257f, 0xbefb3c25, 0x2eb5a9b9, 0x08d5f785, 0xbc2ae7af, 
	0xef23591f, 0xf2358d97, 0x630af67e, 0x5a9beb00, 0xc9ef6a22, 0xfda7e18b, 
	0xe95be6e9, 0xb65639dc, 0xcfe30ca5, 0xcc56171b, 0x74cf57eb, 0x3fa3ab5e, 
	0xf523e678, 0x8ff8ecfe, 0xbf0e9d65, 0x3f982b8c, 0x7ba2e3fe, 0xb232f8de, 
	0x97cf6397, 0xfc78fb4a, 0x6397b27e, 0xb9caac2f, 0xdee8bdc7, 0x0171ef12, 
	0xe5db33af, 0x676151bd, 0xa53fda5f, 0xa9af08fb, 0xa93de4a4, 0x6021f693, 
	0x5c680717, 0xa1f30fb3, 0x5819e16a, 0xa85ba19f, 0x1fa0f2d0, 0x7a33e75b, 
	0xeaa47bf1, 0xe39c7356, 0x99aa9c80, 0xacfdffb5, 0xf2b9e266, 0x5a274fcc, 
	0x2bee6ef0, 0xdd9e3265, 0xa1aa3ff6, 0x5e63fb07, 0xc70267bc, 0x8bdf83c6, 
	0xfd265bdd, 0xbcaf6af9, 0x3f3daeff, 0x79c02de5, 0xe85eb269, 0x19cf0786, 
	0x794cceab, 0x2d333f11, 0x7df62d13, 0x47ff9d0c, 0xd261ae19, 0x8e6c2479, 
	0xa5f7ec14, 0x8c9954ea, 0xb5769303, 0x4d99f8ae, 0xd85bbfb8, 0x06927a68, 
	0x5e5333a4, 0x7859800c, 0x829fdc93, 0x730cf1b5, 0xde9005bb, 0xcd8af307, 
	0x32be9c22, 0x52fa1f8c, 0x9e1283f5, 0x4cfb24d7, 0xf9610ef0, 0xe7ae5901, 
	0xc9940f97, 0xf1ace6b8, 0x5911fca9, 0x1fcbf22e, 0xfcb1e597, 0xf8ca27f2, 
	0x3ca73c9e, 0xa67bc8a4, 0xe0888760, 0xfe84f0fe, 0xe6185974, 0xff0b4ff9, 
	0x579e1967, 0x549f15d4, 0x27dd5db0, 0xfbc5eee6, 0x9d37980e, 0x9b1d11d3, 
	0xc635df01, 0xc924cf78, 0xb9e3b0bf, 0x17dce87a, 0xee22a3fc, 0x5ef80317, 
	0xb0da8bf0, 0x3fd7899f, 0x7fcf8ea2, 0x39e4cbdb, 0xb9f78fa5, 0x020f2fc8, 
	0x37e3971d, 0xb5be50cf, 0xfc4cac7e, 0xfc9ce482, 0x64e7c0ae, 0xfef060bc, 
	0x13a0bc74, 0x7df5c73f, 0x9189c272, 0x0995ea60, 0x567abb05, 0x243129cf, 
	0x0f78db87, 0xd95d63bf, 0xfc7d1fa0, 0x74e7ba01, 0xe588dfed, 0x1e3f4ac3, 
	0x49c64cd0, 0x98f7be3e, 0x395fbfbc, 0xdbe28272, 0x3ef73e57, 0x178fb5c5, 
	0x667c211d, 0x070de2e2, 0xfcafc5c6, 0xbc52afe3, 0x3f3e4afb, 0xeb142828, 
	0x570822ba, 0x553f9898, 0x3072e326, 0xf26476f5, 0x79e077e4, 0xc097fa2a, 
	0xcefc6187, 0x01b2f018, 0xfe961fbf, 0x3deb186e, 0x85fe2798, 0x4c4e50ff, 
	0xb78487a9, 0x87719355, 0x8c7b94aa, 0x645f7893, 0x5e5221c7, 0x037eb213, 
	0x5e8259c6, 0xafe9f4f2, 0xa2a5bc62, 0x41ea1a99, 0x2986f0af, 0x4f5f5a8e, 
	0xfe7cade3, 0xdf14c36f, 0xac0e99a8, 0x087d4557, 0x838f2ce3, 0x8c71855f, 
	0xa01cc39a, 0x1f60d278, 0xf7eb31e9, 0x238c8527, 0x7433c115, 0x670665bf, 
	0x58f832ba, 0x73d25fb9, 0x6e33ef25, 0xc43c4a8e, 0x547cfd38, 0xf408cbde, 
	0x55bc61bf, 0x7822eb63, 0xd94d706e, 0xdcf0cbcf, 0x2384f578, 0xcad0f342, 
	0xd547ae28, 0x83c608cd, 0x8f1e2f88, 0xdfd3bce0, 0xab2d0e19, 0xaf1f00d3, 
	0x99c733fc, 0x173a0d78, 0x74963559, 0xfbc8b9e0, 0xca17ff8c, 0x5e7e27de, 
	0xf698713d, 0xbbafa0fb, 0x53850f51, 0xb3efbf82, 0x5e12ab68, 0x9ea38891, 
	0xe33ac70b, 0x2d71fbd9, 0x0ec1ed04, 0x1ce86f85, 0x7d7ac6ef, 0x387bbc62, 
	0x9edb7eeb, 0xfa1fec0f, 0x1ecf0f48, 0xad1138c1, 0x4051c277, 0x553a67f6, 
	0x492cf800, 0x3e2f3baf, 0x285fe866, 0x1e23e07f, 0x37f8d749, 0xaa661e28, 
	0xa7aa0aef, 0xe2b21cef, 0x5e8c5667, 0x182bc0eb, 0x5ee322d1, 0x07d871dc, 
	0x8c1dbc53, 0x03e273f0, 0xcf585de5, 0x6588efe9, 0xb19bd826, 0x785d8dbe, 
	0xaeb9e13e, 0xaf3d415d, 0xb461c5fa, 0x491c7683, 0xd24cdc41, 0x2eb87cf7, 
	0x16ad1c10, 0xfd463dfa, 0x1a5cf1ba, 0xa6b33bf7, 0xc479f79c, 0x76d67dd3, 
	0xca5a07d4, 0x3643aa9b, 0xfebbdcbc, 0x45bb9432, 0x5ce50a66, 0x7f74590b, 
	0xfcc1f2eb, 0x7c1ef0a6, 0x106dc535, 0x117b4bdf, 0xfb5e38a0, 0xe6dd0cfb, 
	0x9ddf195f, 0xbf92ffc5, 0x13c7612d, 0x64c5be53, 0x8a8ffffe, 0xe3a5765f, 
	0x97e27296, 0x8a2f3c13, 0x3cd38e63, 0x78ecbe49, 0x3a63c566, 0x6578977e, 
	0xe00f7e91, 0x4caf17df, 0x2718def1, 0x89ca1c18, 0x265cf637, 0xcb13d5f9, 
	0x5efb57e5, 0x9fb5f919, 0xa2ed15f9, 0x11d871b7, 0x1fabb946, 0xdff9875e, 
	0xfcfdca8f, 0x7c3afc45, 0x074df29c, 0xafcbcd96, 0x2c8eefc8, 0xf2be557e, 
	0x1689c53e, 0x37f43c03, 0x74eeae56, 0x05fe6cc4, 0x8df97479, 0x822f12c3, 
	0xbe689be2, 0xd3c7c931, 0x317fc322, 0xedfb8fee, 0xfbce5939, 0x25f9bcec, 
	0x56e296fe, 0xdd61fedf, 0x917df56f, 0xec8aefe0, 0xb5f3d9f9, 0x395a33bf, 
	0xf281ceb2, 0x153eb5b5, 0xec223d45, 0x4ad68173, 0x32ee1fb2, 0x5ea38d27, 
	0xfb452d69, 0x9a7cbae1, 0x5dfd88ec, 0xdf1de214, 0xda2f1859, 0x61fe751f, 
	0xda745c56, 0xd41f80ae, 0xf92de923, 0x7f9b32ed, 0xce8947bd, 0xde1f7799, 
	0x3f307d4c, 0xeadbfee0, 0x7f6bfc92, 0xf3293137, 0x7cca6f85, 0x5e52a5a1, 
	0xb4a94e3b, 0x822eaa4b, 0x7d067dfc, 0x34d9e18f, 0xd1778c17, 0x04a119f7, 
	0x56adfde4, 0xd742fd08, 0xd0f4661d, 0xd36f483a, 0xf189b0c5, 0xf6bbc351, 
	0x117bd236, 0xeb88bc37, 0x767e1aae, 0x3ba438e0, 0x612ff5f5, 0x31cb8ede, 
	0xd07d0352, 0xfa52bc7f, 0x6dadae6b, 0x77c5edf7, 0x62eab627, 0x1954e108, 
	0x01bbdd1f, 0x2c07ce53, 0x086bdf67, 0xf0fbd8d7, 0x527df40b, 0x3bbe18fb, 
	0x70be68d1, 0x77a43960, 0xfda8bb89, 0xc56efc5d, 0x5ed3666d, 0xbc4dbfac, 
	0x023812fc, 0xf7c33dae, 0xe8f6bcd1, 0x79c05e67, 0xfbe38b74, 0x9acdfee8, 
	0x70885fde, 0x303d79ec, 0x999e57d0, 0x0f90d7d7, 0xacbda966, 0x799cccb7, 
	0xa798f5db, 0x730caaef, 0x9d943cc0, 0xe5980e4f, 0xe6537959, 0xa2f7e8cd, 
	0x79f59fe4, 0x7f8e6f89, 0x5bb6913c, 0x98574fc4, 0x0b7df203, 0xa683fc93, 
	0x4d47b494, 0xe5f7f61d, 0xe6cb5106, 0x649799bf, 0xc0f6987c, 0x40e7c508, 
	0x05fa449a, 0x60362787, 0x1ed36e9c, 0xd37fddf9, 0xfb3c46ad, 0x86e9a9be, 
	0x6e2f2a4e, 0xf7e296b0, 0x0b2fdea0, 0x51f90aaf, 0xbad39b8e, 0xdc0e9387, 
	0x6d248cf7, 0xd7df48fb, 0x8b7dd537, 0xe7f831de, 0x3785e94b, 0x25f94e7f, 
	0xe52c5c5f, 0xe49fb66e, 0xfd4765ae, 0x5dbb946f, 0xab772ce5, 0x499a1ce7, 
	0x7e42ecf8, 0xd46022f4, 0xbe8b5e9f, 0x60070a1f, 0x08afb0be, 0x1df49a17, 
	0x5519916b, 0xb8219f7b, 0x79d45f54, 0xaefc25f6, 0x57dfcc33, 0xafe87516, 
	0x7e082da2, 0xdf1ba87e, 0xb58a281f, 0xf806b5fd, 0xdcdc61f5, 0x9bbd05a7, 
	0x7413ef43, 0xfda3a73e, 0xa98af22b, 0x3e2cf808, 0x98eeefee, 0xa3f7e38a, 
	0x8da3ae45, 0xef19a703, 0xefc18718, 0xeb016853, 0xa5df1379, 0xf77a0cd1, 
	0x070dc446, 0xf8014bbe, 0x52c47a63, 0xa0e2ff38, 0x99cf0078, 0x0a7a628b, 
	0xe3b6f3bf, 0xd643dd61, 0xa7cf7a46, 0x4e7a2a35, 0x68a3fe52, 0xa90d4657, 
	0xe7cb82ff, 0xb0b8c5ee, 0x148fe052, 0xafddd7ac, 0xa00bbda9, 0xe39d8bfe, 
	0xfcddfa2a, 0x30a8c71d, 0xdbe39e65, 0x7e821f71, 0xf4c0f690, 0x570fc8f3, 
	0xbb78cb95, 0x8fe92ae0, 0x4c7f228f, 0xa6a0bee0, 0xe611f91c, 0xe09afb4b, 
	0x7abdf91e, 0x31f0e770, 0x3a86fb41, 0x0afda7aa, 0x01ee8fd4, 0xd1fa87f9, 
	0x6b63a19e, 0x597f581c, 0x42df7a79, 0x0faa4dfd, 0xeb127d62, 0xdc7ac897, 
	0xfec0ecbf, 0x9bd70846, 0x3cbcbfe9, 0x81d95fbd, 0xbea82afc, 0x627ffb89, 
	0xaf5455c1, 0xd10f7d23, 0xb07be93c, 0xfe05bf8c, 0xb78c21de, 0x2184736c, 
	0xfa5caebd, 0xed955a7b, 0x7e403cbf, 0x3b71e00f, 0xae4643ed, 0x477e51bd, 
	0x33112d72, 0x46e6b758, 0x6dd043c4, 0x7efecf6d, 0xf5fd7960, 0x6b5fb8e5, 
	0x52ac7fa8, 0xf9e4ffee, 0xe6ddd6b0, 0xc7c978c0, 0x8bfca52a, 0x6dfe802b, 
	0xf149df14, 0x6b75a38e, 0x5b463e48, 0x2f7bd376, 0x886b0da3, 0xdf9e507f, 
	0x97aef1c0, 0x80c6e9fb, 0xb15c8bf4, 0x8f8475ba, 0xfdb235a6, 0xff65bbed, 
	0x3e49bb9d, 0x93767b47, 0xe77e8ffc, 0xf27eb25b, 0x9d4f4c9c, 0x95deed93, 
	0xbafac6f9, 0x2eb7b46e, 0xb77d0d7d, 0xe36fbc1d, 0xdfd003f8, 0xc35bb2d5, 
	0xe2571573, 0xef4cba6b, 0xf06986d9, 0x01fc837a, 0x36d9e757, 0x2574bb8c, 
	0x3529c5ce, 0xe98ddd4e, 0xcf396ecc, 0xfe4c39a0, 0x75a7b043, 0xdb1d01fc, 
	0xbd624a2f, 0x62bb6d47, 0xb6abec2f, 0x07b7f478, 0xc7be30dd, 0x11ef6aba, 
	0x73023621, 0x767a083f, 0x7bbcdba3, 0x1dfd0e70, 0xa373f88b, 0x0343eda7, 
	0xb9376ba0, 0xd083b9f4, 0xb867937e, 0x74f40064, 0xa1eda7b3, 0xf467f707, 
	0xe7e78e82, 0x1eb517e8, 0xddedfb26, 0xa47a901d, 0x22377e55, 0x9f910f5a, 
	0xdeb053b1, 0x26af998c, 0x5a27d1e7, 0xe321c259, 0x8e50bfc3, 0x8ec7b0fe, 
	0x96c4f847, 0x7262c7f1, 0x71d3f43c, 0xdba03ebc, 0x5fa5caa7, 0x487ac1de, 
	0xc69f7fb4, 0xe44fe57f, 0xf8f6577b, 0x909bf61e, 0x03a07d7e, 0xf8c6a583, 
	0x5c1be601, 0xb3fd6367, 0x173f185d, 0x7bb5efbc, 0xfc2586fb, 0x7fb243fe, 
	0xfbeec23f, 0x57ee2757, 0x7092ecb6, 0x3972c8bf, 0xd2d8e67a, 0x1c7fb0bd, 
	0xee96b62d, 0x93f37d85, 0xecbf92e5, 0x0bc7a779, 0xe9e38efe, 0x8de34b7f, 
	0x7f99467c, 0x6f1c80bc, 0x3df3f21d, 0xf6d7e317, 0xc53e1053, 0x9787796f, 
	0xf474043d, 0x1efbf5b8, 0x4a7a3a04, 0x74d9cfac, 0x4023bd26, 0xba5da33f, 
	0x6caf9e47, 0xd03cf3e4, 0x0e074bdf, 0xf213c165, 0x80e9069c, 0x5fa0dc71, 
	0x5f37a89c, 0x35f6972a, 0x31e795e8, 0x7f5083a7, 0x465bee3b, 0x0e32059c, 
	0x4ee1ee9f, 0x9e0a98d7, 0x6024cd2f, 0x3d93941c, 0xcfb79f67, 0xc5bfd0d1, 
	0x37c103fd, 0x31cf3e0c, 0x15e73cf8, 0x3c3e47d2, 0xfc2369bf, 0x373b426d, 
	0xd251fbba, 0xc39dbe77, 0x3bf6038a, 0x7ffaadbe, 0x84fd225b, 0x5e0183d8, 
	0xaf9a59c7, 0x4bf1f907, 0xbd269fd5, 0x1729ba74, 0x18e3ac0e, 0x88d3fde2, 
	0xf76c0efb, 0x34dfa95d, 0x4add9fd6, 0x65e7f480, 0xfc7eb04f, 0x3cfa797e, 
	0xf88fea88, 0xeba41f49, 0x75fd975f, 0xcfe53ebb, 0x5c83ffed, 0x3ebddafd, 
	0xb233feaf, 0xb06bf59e, 0x20faa15b, 0xfdfe83d6, 0xac19f30c, 0xd9fa036b, 
	0x952273c1, 0x892b7c02, 0xef89265f, 0x8c09f5ad, 0x9e553e73, 0x73a38739, 
	0x50a5254a, 0x28404bbc, 0xe3529df8, 0x1e83d00a, 0xbfeefbc0, 0xdfe71e79, 
	0xf7a4de78, 0x848d4626, 0x78d53d40, 0x43bd30fe, 0x61f1e671, 0xcf47ef15, 
	0xf8a936c6, 0x7ed9ca5d, 0xd236f543, 0x63ca2af8, 0xa08bf710, 0x39e7fc32, 
	0x7a0bdffe, 0x888857a1, 0xb071aa61, 0x536691bf, 0xeb86efa5, 0x917c3be4, 
	0x9e89433e, 0x712854c2, 0x345fc325, 0xa0c6982e, 0xe076b7d2, 0xd11de930, 
	0xb1dea26f, 0x77a4fd9c, 0x9e3f754c, 0x3b339d23, 0x1674931f, 0x3947ef0f, 
	0x51447583, 0x3fa41b1f, 0x0d06f5ed, 0x18ed5bb0, 0xc53574b7, 0x60de92bd, 
	0xd1bf4339, 0x77cf2153, 0x8e516e48, 0x07e433f4, 0xdca3fcf5, 0x4a0a6eb7, 
	0x8afbc57f, 0x6cbc4147, 0x827e77e2, 0x09239655, 0x862c1ebc, 0x8f7c36fa, 
	0xaf1c5743, 0xe3adf8e2, 0xabe4313d, 0xa3d7c453, 0xf3597f28, 0xb1d1fd19, 
	0xba9e78a5, 0xeef5c61c, 0xff4876e4, 0x074ec39d, 0xbba3c3f8, 0xf4d7922c, 
	0x5bcfae7a, 0x2cec024f, 0x8ea301da, 0xd7f371ee, 0xea42a0b3, 0xc67af4c3, 
	0xc3e937fe, 0x8ebb9e77, 0x73d9e3d6, 0x69eb81cc, 0x057238c6, 0xf22901d7, 
	0x48e1bd55, 0x59efdf82, 0xb3c0e536, 0x3febd1e5, 0xc8af1d60, 0xfe6a5c75, 
	0x857efccd, 0x03f1f301, 0x2407377e, 0xf85d691e, 0x832acd5d, 0x5eb052ec, 
	0x0cb82fe2, 0xe8ce6fc6, 0x1ef9f701, 0x2f77c207, 0x59f3936b, 0xf919f30e, 
	0xf3d9f30d, 0x99b3e79b, 0x7d4413bf, 0xc1def78c, 0x978fd61b, 0x8c3d488e, 
	0x1bc1a7e7, 0x3f6f7a7e, 0xbe80b7e4, 0x92be23e8, 0xe35e427f, 0xa94e81e0, 
	0x0f80db27, 0x1f16ec3f, 0xb5b87b41, 0x043d8f50, 0x896b72f6, 0xda41d5f5, 
	0xdd735ad0, 0xc2d92fb0, 0x09f925fe, 0x0f3d8cde, 0x6ee39876, 0xa83de7a9, 
	0xa6993e67, 0xc29bb3ff, 0x59ef7790, 0x7d4bef44, 0x0ae6faa9, 0xfb6e7bb4, 
	0x74dd093b, 0x1d0bf7e0, 0xdf9ef215, 0xa2c7ef6d, 0x559e5e50, 0xf7f40cbe, 
	0x9e03ed00, 0x45ca427a, 0x2843d77b, 0x75e38247, 0xa493dc61, 0xb5cfc84f, 
	0x5efec5c7, 0x969f77d2, 0x087c72e3, 0x3d9943bd, 0xa03bc72e, 0xde539ddf, 
	0xf5e29e20, 0xca157677, 0x84bbe272, 0x17efa0e9, 0x221e90e3, 0x9e5f91bc, 
	0xfd34978f, 0x0dfa4a8e, 0x5b9db056, 0xe914b531, 0xe3efbc1e, 0x661f87c4, 
	0x0fefcbb9, 0xe3b018eb, 0x466f91dc, 0x8a5e1fcf, 0xfdd9fbdf, 0x4b23d546, 
	0x63ce1807, 0x6caddf40, 0x007cd2d7, 0xb3d51e70, 0xcd1ea1e6, 0x0de34f69, 
	0xe0df3c5d, 0x7882e79e, 0x43fc81c0, 0xfe2057df, 0x0c3bf19b, 0x832f872b, 
	0x349dbbe7, 0x97673d9f, 0x7f820e3a, 0x6b78f6cc, 0xe7fefca1, 0xbf190ae9, 
	0xa0af6ae6, 0x1b7752f3, 0xdc022fa4, 0xeffcfb2a, 0x1cf1e7b5, 0xd2152bef, 
	0xc87571bf, 0x7b772a7b, 0x1c97be84, 0xa46e278d, 0x7262a7ef, 0x44b5b13f, 
	0xc30afdc2, 0xd75c3375, 0x7fa57045, 0x2e7866ed, 0xc25c1786, 0xde12e2f0, 
	0x0a91faf2, 0x8cffa7f4, 0x6c070cfd, 0x9e4eff90, 0x7bf8383f, 0xf413018f, 
	0x449ad346, 0xd715dcfa, 0x7d8069ed, 0x23879e28, 0xa62f10fe, 0xf0e7ce39, 
	0x83700a8a, 0xcf733a07, 0xb7191561, 0x93faa5ae, 0xf696ddf8, 0x033d2b50, 
	0x2d7de613, 0xedd7286c, 0xb0a772c5, 0x7b6d9f90, 0xefac67f1, 0x931f308e, 
	0xff1d0a1f, 0x4625f19a, 0xcbecf9e4, 0x47f4b74e, 0x55b9e59b, 0x789fdf01, 
	0x3fba741a, 0xd2153ff9, 0x7fa1397f, 0x3f9bd687, 0x970f815f, 0xbbcee796, 
	0x1c0cfee7, 0x3cf6fe7b, 0x8c1cfed3, 0xa7c22987, 0xfd29b77d, 0x7c638ee3, 
	0x0dfeda2e, 0xd4df67da, 0x7e8dfdee, 0x6cfb45f1, 0xa7f9678e, 0x815f7f85, 
	0x869e2cf7, 0x59efba29, 0x9263ff5e, 0xe32e2d63, 0x98b9f0d2, 0xc74a199e, 
	0xef454c84, 0x41ee80cf, 0x11df8933, 0x3c11bb51, 0x507685ae, 0xa378c23e, 
	0xcbbee275, 0x88ecfd84, 0x2c6f9f48, 0xefb98582, 0xfb0b7a40, 0xe402bcdd, 
	0x7a28a513, 0x1160e502, 0xfd60395e, 0xde7cfb0a, 0xa686dba0, 0x86f6ed9b, 
	0xd230c73c, 0xf1f9eeef, 0x394a82ef, 0x75eed36e, 0x4285b9f6, 0xd1ac428f, 
	0x5f3ea2f6, 0xae6315e4, 0xdf7a443b, 0x7463cf66, 0xfcce3d8d, 0x915d18f3, 
	0x31e6971e, 0x5e7a737a, 0x23518f34, 0xf342be7d, 0xbf6ddd18, 0xbe379823, 
	0x345fc726, 0xd2017f7d, 0xd617d7ef, 0xa681c102, 0x7fa497a8, 0x3d024ce9, 
	0xee4f57dd, 0x818bf6c3, 0x0fc0bd3e, 0x0fada5ae, 0x28c37f52, 0xfd255f30, 
	0xe2f07e49, 0x40f54d66, 0xa988d4ba, 0xd6bc36ce, 0xd82ed5d0, 0xacbbba0f, 
	0xa8beb4a5, 0xc0679dd0, 0x61994a8f, 0x98ee2fcc, 0xe901cf7a, 0xc7bc44d2, 
	0x9ca7eb25, 0x70fc632f, 0x78a7a7cc, 0x31df8b5f, 0xabfdb119, 0x1aee6e30, 
	0x053f17f0, 0xc07eefe3, 0xfa199c27, 0xa43f61d5, 0xc1e30f4f, 0xf8ef4edd, 
	0x40ba986e, 0xbaf653f7, 0x66961836, 0xa0dabe82, 0x3fee99b7, 0xbbe7bcc8, 
	0xc96312c1, 0x7a73e27a, 0x4fce98a7, 0x2b5ea04e, 0x6194f091, 0xd886f3c2, 
	0x9bbe38d4, 0xf19cb4db, 0x44fe01ef, 0xc9a1dfba, 0xa29fd2bc, 0x509da973, 
	0xaaef8c3f, 0x3ddcb2e9, 0x5a76c4e7, 0xe1a3e80c, 0xfda406fd, 0xc8221dfc, 
	0x1693537d, 0x50ba0fc7, 0xdf8026be, 0x5bbac137, 0x2762ae50, 0x1312ae49, 
	0x73bef397, 0xbd4ae480, 0x6df7cc3d, 0x20fd0fbc, 0xa39deaf9, 0x97ba63f3, 
	0xdb237dc1, 0x2562a68b, 0x77d3a83e, 0x2fa893b9, 0xf5295e3e, 0x10b9e8ce, 
	0xf14bffbd, 0xface3049, 0x9e8deae8, 0x9e47f476, 0xdd8150d3, 0x19ed295a, 
	0x0394796c, 0xb0f5c780, 0x1c5dff0e, 0x83700f9f, 0xfc3f41db, 0xb43bca04, 
	0xa6016454, 0xe841cf7a, 0xdf0c7bff, 0x7d747efe, 0x25bfd40b, 0x3c640bcb, 
	0xd5da24e5, 0xaca79f10, 0x345e84d7, 0x7145fc43, 0x46beb61a, 0x9d664fbe, 
	0x77e5a64f, 0xdf2e227b, 0xddbe00ad, 0xb4979191, 0x35bcb0fc, 0x4ff7ca35, 
	0x7c09efed, 0xf61e41db, 0x23971f32, 0x537d65dd, 0xbd32bdcb, 0x2ed293ba, 
	0xddd61f1c, 0xd1c8ccb4, 0xda3a8b13, 0xffed1d8a, 0xff68f986, 0x6a5cf9be, 
	0x6cf2f91e, 0x7ed20f9f, 0xf6e580b8, 0xa2cf2453, 0xfb909177, 0xe2cf9861, 
	0x39eaa896, 0xc9079999, 0xe2c5c82b, 0xe1efb3ce, 0x7cb6de3b, 0xd3d0aeba, 
	0x477de9f2, 0x872d2588, 0x671df27d, 0x813de7d3, 0xfc24e7ef, 0x0fbc142b, 
	0x4037f09f, 0x19dfddaa, 0x84fd7940, 0x802cfe7d, 0xa3aeb09e, 0xa2550e0b, 
	0xff5e5f5e, 0x63de2564, 0x0fe996b8, 0x406fbea3, 0xecf78cfb, 0xc761d9a2, 
	0xeb9ce631, 0xb9251c8e, 0xaec7ecf8, 0x53eeadfe, 0x9710396c, 0xd0adaf78, 
	0xc4d0173e, 0x4263d431, 0xe3f6f774, 0xb1b36f39, 0x0b52f109, 0x740453c2, 
	0xb4a546fa, 0x4066d177, 0xbd6be42b, 0x0158ee22, 0x0efd10a9, 0xedc0ffe0, 
	0xa714bd93, 0xf7287cb2, 0x8bb32fbd, 0xddf1e3ce, 0x6a3f795a, 0x9ff2fdf0, 
	0xa83c6256, 0x24716ca7, 0x5f5d22a6, 0x5bbe5d7f, 0x7be12e6b, 0x5e87a301, 
	0x1de8b58e, 0x6dc62f27, 0x42f2109e, 0xc86ee91d, 0x1d19c37b, 0xbbbe2cec, 
	0x7fc32ed3, 0x07f87c14, 0x3ef997cf, 0x69073ed0, 0x581b9f4a, 0xf1cfbe1e, 
	0xd41bbee4, 0x3efb794d, 0xe979a1d2, 0xbf5ed07e, 0x30aa7703, 0x985c68ff, 
	0x0e486783, 0x657de50b, 0x892a3dfa, 0x8bd5333f, 0x3e2005df, 0x3887bde8, 
	0x23cf11e0, 0x8c0adf59, 0xf5ba44ab, 0xfbecc28b, 0x89c61d4c, 0x5e95dc00, 
	0x32fc5931, 0x765175e6, 0xe1fdf296, 0x85fdf415, 0xbaa9e117, 0xe9f78859, 
	0x02feb7a0, 0x888c4ef9, 0x18be1087, 0xf9d10f16, 0x9e6bc60d, 0xc757acc8, 
	0x7187ea77, 0x9cae4dba, 0x70af58fb, 0xf7d3f1c9, 0xfbecaeb5, 0xbf8cd5df, 
	0x055fbc12, 0xeb2afb79, 0x3d878c3d, 0x3dd4a493, 0xcb7a449d, 0x9f75b2b8, 
	0x20dd149f, 0xd69aff17, 0x28ef1253, 0xdfefc85f, 0xe4afe8c9, 0xa46301df, 
	0xe92ae7a2, 0xd78e61bd, 0xfdca97f5, 0xe683ce04, 0x7ce4b513, 0xdf7d8145, 
	0x65b8f74c, 0x7e8a9aad, 0xea4aa068, 0x51cf0ad3, 0xa2a7cefa, 0xfb82b0f7, 
	0x78d6b2df, 0xbe5a74aa, 0x09df821f, 0x8c11f940, 0x62f32907, 0xb2d00460, 
	0xababe38a, 0xbbf85ca4, 0x67ffc41d, 0xf85c9b63, 0xd3a8475d, 0xfb1ca174, 
	0x12ef932f, 0x80113f41, 0xa646657e, 0x197dca3f, 0xde41ec5e, 0x99c65cbf, 
	0xfbe9f5d8, 0x7788b744, 0x98c60c7f, 0xc64f77e0, 0xf9157113, 0x2f7e4474, 
	0xbe91368d, 0xca1b7fef, 0x2fbf1db1, 0xd9b18339, 0xbda8afec, 0x709b7819, 
	0x0f18a79d, 0xe1929f80, 0x0b78eab0, 0x44b1d3df, 0x19dc1677, 0x5bfb15a0, 
	0x3593d52e, 0xb976e39f, 0x3b86cee9, 0x678f6d33, 0x8fda727a, 0xb078e1a4, 
	0xa78e0afd, 0x5437ebb1, 0x157cff49, 0xdad561d3, 0x2c18eedd, 0x3aef536a, 
	0x4afbee17, 0x83d11dba, 0x4cdf8e52, 0x15fe801d, 0xc82aed82, 0x8c33d031, 
	0xde93bff3, 0xa784120f, 0x9d93c63e, 0x129919c7, 0x2f3b434f, 0xdfcfcf2e, 
	0xc0ecf48d, 0x3f130ff1, 0x1f803cd0, 0x7192ac6f, 0x57fcf64d, 0x2373ad8d, 
	0x19ad379d, 0xbdd2f1ec, 0xb8e6e1bf, 0x7bd41eb9, 0x854f2ee0, 0xb3accaef, 
	0x154ca122, 0xe5f2674c, 0xcf1fada2, 0xdd142a0b, 0xfc4bd03d, 0xe7ce3fa5, 
	0xccc15d93, 0x1f76e838, 0xada0ff04, 0x95d79e4a, 0x3c019f30, 0x529a68ab, 
	0xac96f651, 0xa6163e27, 0xf5fc0ba3, 0x76df95f0, 0xf07c70ad, 0x18272838, 
	0x76a970af, 0x14c0e759, 0xbfe36ebf, 0x20bef10c, 0xff137f0b, 0x88afbc3e, 
	0xb9e00f18, 0x9c5b8956, 0x3f8aceeb, 0xb9eb6d83, 0xf1f3acee, 0xadc8c512, 
	0xd0f2f357, 0xf7bacd5f, 0xf7d9fec1, 0x20bcb668, 0x6a769c9c, 0x75a2fe6e, 
	0x35084f8e, 0xe7df9d7b, 0x0e4664fc, 0x436f9d69, 0x2cd1ca39, 0x6dfe5bb7, 
	0x96b62ed9, 0x39d7a5da, 0xbf87389e, 0xbc72500b, 0x326fce53, 0x7e4b9e57, 
	0xa70ce5ca, 0x72fdd964, 0xa6a70c7e, 0xc135e8ce, 0x63d9ac3f, 0xaabea294, 
	0x852c773e, 0x40d633df, 0x23f80f5d, 0x7bf234b7, 0x291bca1e, 0xdcffafc4, 
	0x41cca43f, 0x5fb5bfa8, 0xed94ee57, 0x99deb3ba, 0xe5b319ab, 0xcb6570d7, 
	0x5a70cd75, 0xaf2c557e, 0x2ae12f79, 0x335b3d00, 0x7a4f6e99, 0x792af5e0, 
	0x67ee956e, 0x5b8feae5, 0x3bfe5ef8, 0x98bbf255, 0xa93cf85b, 0x174ebde6, 
	0xfd8c73be, 0xffcab20b, 0x6c576edc, 0x00789bb7, 0xcbb74dc7, 0xce56bf94, 
	0xce5df8e5, 0xf974812d, 0xfff6ecc6, 0x0b7d72ca, 0xb8c1afc7, 0xe532f0b9, 
	0xa49f95af, 0x9b55e374, 0xb355fd65, 0x77fea532, 0xd4e6edd8, 0xf973799c, 
	0xdf79eccf, 0x3c4bb764, 0x532ed390, 0x0ef95afe, 0x755e374a, 0x0d4e3322, 
	0xf99d879f, 0xe94bdbcb, 0xdbbbfd5c, 0xec02f31f, 0x3d1fb01a, 0xd7ff41cf, 
	0xa7bc7bfb, 0x900b8e98, 0x5fc9096e, 0x866bb7ac, 0x86ff9213, 0xfd9abe64, 
	0x0eef8a85, 0xb33be0f6, 0x724cfa69, 0xbe19e3bf, 0xe9077feb, 0xf633fdc6, 
	0x87c457e6, 0xee185db6, 0x3ca1f994, 0x973af3fb, 0xa399bc33, 0xc0c96f90, 
	0x4da765b9, 0x1ceeb997, 0x1bca67bc, 0xe13c672f, 0xecb77df7, 0x68f9e349, 
	0x0e88fe36, 0x5d7d10ef, 0x33eaef14, 0x01dfdc64, 0x82fe7d23, 0xace14ce7, 
	0x87bc64fb, 0xd0a7f7c0, 0xb776871e, 0x9777e524, 0x84f782a6, 0xca0eeeb4, 
	0xdac7fae7, 0x6faf298f, 0xe27de4a8, 0xa7c7f908, 0x83c71c5c, 0xcc9d56ef, 
	0x5038cf7e, 0xde2ef39d, 0xa657dc94, 0x7cf167e3, 0xdf11e50a, 0xfbe2f04b, 
	0x18e3c309, 0x938e9037, 0x7a2959f6, 0xf1cb0147, 0x1cd5ae5e, 0xe79e1d2f, 
	0xd76816dd, 0x1f7d61af, 0x4eff539d, 0x25bfc3f0, 0x7c0c81fc, 0xaebcefc1, 
	0x301a173c, 0x533c93d7, 0x8f587d5c, 0x9d3f78a8, 0xeed81bf6, 0x718a5fa2, 
	0x2f9f2b49, 0xf8fc887f, 0xe21fb4be, 0x3a0bf1cc, 0x5937d7e7, 0xfb4e477e, 
	0x028baf92, 0xe12d573c, 0x8d36dcf7, 0xe2fd0340, 0xc37cf6f6, 0xed13967d, 
	0x188e7db2, 0x94089afa, 0x1fe995be, 0xc4e93dda, 0xaeaa07df, 0x7eceac6a, 
	0x69d432d7, 0x6f0fe8a8, 0xb2d4d4ea, 0x4feeb893, 0x157a803e, 0xfe519263, 
	0x9e025656, 0x7c569e41, 0x19efe40d, 0xc7639e59, 0x6935ebd2, 0x5a172b5d, 
	0xeba031ce, 0x3974898a, 0xc450cbe9, 0xbe031aea, 0xa7f6915d, 0x69bf1c8c, 
	0x6f1a6cc5, 0xf9426fd2, 0xf71c03ff, 0x85bcae90, 0xf2fcb0e3, 0x262be17b, 
	0xe8f63912, 0xfae0d533, 0x59f08bbe, 0x7d25a79e, 0xbb72cc56, 0x742ed939, 
	0x0aed2120, 0xe44d09c3, 0x77d0a3da, 0x43fdcf39, 0xdd9276ef, 0xe7c1595a, 
	0xba7f7c9a, 0x06d3d712, 0x85f36972, 0xecfbed9b, 0x37417efc, 0xf0b7efce, 
	0x0fe8420b, 0x90ffd964, 0x21f7b5c8, 0x083fd725, 0xf47979a9, 0x3fecb207, 
	0xf3b6cff6, 0x5ea73fd8, 0xebdbcdcd, 0x5d83fc24, 0xf407595d, 0xf40dfa9c, 
	0x7edbcbcf, 0x43b507c1, 0xf63d407e, 0x5b5ebd1f, 0xbad07f5f, 0x29c276d3, 
	0x3d7a1df9, 0x25f67482, 0xd60e3262, 0x4fd23e6b, 0x7a45af7e, 0xa42854b1, 
	0x63678b27, 0x9a2aafb4, 0x209b8a9d, 0xa7fdc59b, 0xf27cf1c6, 0x4adfc446, 
	0x0953efa0, 0x9871f89d, 0x4cd022f9, 0xfb1fc078, 0x8f643f22, 0xea3557b4, 
	0xfe608fa3, 0xf241c1c6, 0xce5e6657, 0x773517d5, 0x5728c599, 0xf5ce5f33, 
	0xcc47b64f, 0x66ae5047, 0x4ff5c8de, 0x68e5fad2, 0x63725fae, 0x31bcfd9e, 
	0xf4da7ecf, 0x5ecf31bb, 0x276798de, 0x1cb38fb7, 0xc3ed9c31, 0x679f329d, 
	0xcebfb727, 0xfb670ce5, 0x862f9651, 0x673e9253, 0x8ca4ee12, 0x7dd14e9f, 
	0x71b8578a, 0x7ac25e7f, 0x6833ce9e, 0xbafa0dff, 0xe8beb33c, 0x138a536d, 
	0x396905df, 0x0bf78ddc, 0x77e6ae3f, 0x1b43f089, 0xa026afdc, 0x814841df, 
	0x87dc6ecc, 0x467edce2, 0x78637271, 0x1cd452fe, 0xa7c1fb91, 0x9fccbd78, 
	0xc8bb3a19, 0x0c8d15fe, 0xc9cf04ff, 0x1c676a2e, 0x421576a6, 0xd454c77e, 
	0x785e66bc, 0x7de94333, 0xa3ff5a64, 0xb1aa2a9d, 0x27fdf0ba, 0xabc213ff, 
	0x565fbf41, 0x5b21bbf3, 0x4477d0d6, 0x587dc798, 0x2ddf6d34, 0x1050e305, 
	0xefdef8bf, 0x1d9d71af, 0x8f3a478c, 0x385de8b2, 0x20f7c7ac, 0x641d1a67, 
	0x855f70af, 0x9a977ae7, 0x4d312f87, 0x94ffc476, 0x7b0ef8a0, 0xd4d6451d, 
	0x9e7a63b8, 0x4dc3e4f5, 0xf10587ef, 0xcf9f3e59, 0xf6d8a2bc, 0x2ec724a0, 
	0x7cf0a1be, 0xdf0e6944, 0x9b97653e, 0x5fe539c5, 0xc12fb74f, 0x388092f2, 
	0x60abe0fa, 0x74754ad7, 0xd55f851f, 0x9063c195, 0x1f770e0f, 0x8c5e22f0, 
	0x3a7ef2af, 0x62121dda, 0xe3709d73, 0xf59f823d, 0x20cb7f9b, 0xc4ff17d9, 
	0x63dfc91a, 0xff387bf2, 0x5eb91ae4, 0xe6ff7e4b, 0x3f7ce21f, 0x3f3847e7, 
	0x2b9bf32c, 0xe0dfd3c4, 0x7c2edcb8, 0xc0b27984, 0xea42f925, 0x05339989, 
	0x7aebe23a, 0x6cee03d4, 0x79f4883a, 0x601f9a43, 0x7e051e1f, 0xe864cf10, 
	0x477faf6e, 0xc44f3c8d, 0x145bdf14, 0xd73a5989, 0x1f190a8b, 0x91ef3d15, 
	0xfb826bbf, 0xf44ba023, 0xda20db68, 0xff3c22a7, 0x1d0f31d9, 0x74392d03, 
	0xfec34c72, 0x5798fd09, 0x573a76d2, 0x8971bc9f, 0x72a78f73, 0x57a19fe9, 
	0x9fe07fae, 0xfe2bd5c8, 0xfece44c9, 0x79c43fd1, 0x11fe97d6, 0x9ebdb3ce, 
	0x85c4f3f9, 0xb27bbf1c, 0xbef642f3, 0x178053f1, 0x9980fc0d, 0x25bca027, 
	0xebe66703, 0xd2cb1f9c, 0x677bf44f, 0x6de78296, 0xd7fd578f, 0xe4efec9a, 
	0x767e1fa2, 0x74092253, 0xd93d6b75, 0x06b9b2fc, 0x77e82bf6, 0x91fb911e, 
	0xff9be20f, 0xfeed2351, 0x134ff207, 0xb9f825f0, 0x41e888d1, 0xf3fd18bb, 
	0x324f5235, 0x6ee4e8dc, 0xd1b86799, 0xbd4b7627, 0x5fa2f0ca, 0xabc33ce7, 
	0xefc23e46, 0xa3d0752c, 0xc2a2bf68, 0xb60ef18d, 0xcfeb4e5e, 0xf4bef2a3, 
	0x7229d703, 0xfe7e77ed, 0x7fe91ad9, 0x8bbb507d, 0xff6799d6, 0x3ff679a3, 
	0xa3ff679a, 0x9a3ff679, 0x79a3ff67, 0x679a3ff6, 0x7679a3f7, 0xcfd54bff, 
	0xe427ba49, 0x6f9b8b77, 0x2bbe8978, 0x181e3afc, 0x2a7194ec, 0x3fa3ff68, 
	0x993c7905, 0x13e40be1, 0x6b105dfa, 0xe6ddc92d, 0x18bd832d, 0x1578f38f, 
	0x0ceefc50, 0x772fc17e, 0x85030b5c, 0xbdbaa75b, 0xaab9fc80, 0xefd0d46f, 
	0xfbbd0843, 0xde128009, 0x29ef453f, 0x29935245, 0x7dfe4e34, 0x3414a66f, 
	0x4eb98652, 0x6e9b4b9e, 0x189c3bf6, 0xfe8062b7, 0xf9913fef, 0x3e98352e, 
	0xa4d4379f, 0x9157c38c, 0x8707e1de, 0xf79e307a, 0x1a61e55c, 0xecddd22f, 
	0x2a9d0559, 0x4d8ec0fa, 0x284df467, 0x4f892568, 0x93ef1fc0, 0xfe3744fb, 
	0x238e292e, 0x97c516f3, 0xc646b8fe, 0x3cab9d87, 0xf51f5e91, 0x83fe81af, 
	0xf337f717, 0x8d4dfffa, 0x573baf3c, 0xf7f357f9, 0xb37ac2f7, 0xbbee16ec, 
	0xf4555f70, 0xde00e4c4, 0x0dd8af1b, 0xfb81dff8, 0x9cb11f97, 0x36af641a, 
	0xda7ac075, 0x857d7d70, 0xffdfb015, 0x3bdba407, 0x7b46b919, 0xa7bf7f29, 
	0x657f7e99, 0xbd79c333, 0xf1c10cfa, 0x2c8d69af, 0xb8fef152, 0x83a435ed, 
	0x0cd78efd, 0x66cff1c0, 0xaec127ee, 0x8abbefd2, 0x7bd8e5a8, 0xf23962e2, 
	0x7bd30c34, 0xc16a81cd, 0xf458f7df, 0x61a7837d, 0xfefd952a, 0x77e39864, 
	0x8e5afbc2, 0x8c77f209, 0x864769ee, 0x7ec1916e, 0x1d585ba2, 0x71fc80de, 
	0x3597f2ae, 0x8b593bf2, 0xe885ff7e, 0xd83deb87, 0x40eb8bda, 0xb39b993a, 
	0xb94869e9, 0x113e018f, 0xef17ac1e, 0xe89ffc3f, 0xa2efc418, 0x1df8fd70, 
	0xaf3fcd81, 0xe56abb57, 0x9ef240f7, 0xedb3b820, 0xd98f7c75, 0xf70ce77e, 
	0x30c74cb7, 0x821751d2, 0xf98a86f3, 0x8be4ad60, 0x2d70aaea, 0x0645bfde, 
	0x4307da35, 0xc753be4e, 0x737114f8, 0x12dfb65d, 0x7053c3cd, 0xe513c4a7, 
	0xc9f77f91, 0xf308abdf, 0xc0f85f39, 0xa9f18aac, 0xb5955573, 0x32b08f88, 
	0xf8fc4495, 0xdf7a2d5b, 0xf22bc6d3, 0x27877f1f, 0x561515f1, 0xa277bc91, 
	0x5f1b287b, 0x77cad797, 0xe596a385, 0x30ec7bc4, 0xd2149eff, 0x55f3ef81, 
	0xe7d33ff4, 0x31fa7dd9, 0x157ff827, 0xee7aa696, 0xa92cba44, 0xa0e3e1cd, 
	0x0e4f9ae8, 0x760e50da, 0x7b60e464, 0x57472dad, 0x11aff6e7, 0x61c9f35d, 
	0xabad1cbe, 0x4d68e5b5, 0xe683de2d, 0xf47ac7f7, 0xf8893f17, 0x6f73377f, 
	0x192d9a2f, 0x7c0430a7, 0x3cab39bc, 0x4dc9fd2a, 0xbdbcf2b5, 0xf9072ec8, 
	0xfe03fd21, 0xde2efca4, 0xb2f7f30a, 0x4d9f4885, 0x298f80ad, 0x2cb393e6, 
	0x1f20cf9f, 0x1db2d4b4, 0xb4f9242d, 0xd442b9e4, 0xf38c5432, 0x12f6b1be, 
	0x266de9f2, 0x96ed0bfe, 0x71e4967a, 0xc4cb9e07, 0xe436ded5, 0xee895bd3, 
	0xa7bd0ea1, 0x2dce9db7, 0x7af2d922, 0xaf8cad7b, 0x85abaf4c, 0x516c3bd7, 
	0xc907c65c, 0xcf7327ab, 0xe33ef0a9, 0xdef3c508, 0xbfdf4933, 0x857f107c, 
	0xaf3bf7f7, 0xabb0bb06, 0x421ffa56, 0x3bf89335, 0x595fc42e, 0xf3bbf77c, 
	0xe97217d9, 0xab77cb6c, 0x2cb50fb4, 0xef9697cf, 0xaf6f94a4, 0xd2effa41, 
	0x19e52df2, 0xbf25ece9, 0xcc0efe4f, 0xd56fcc83, 0xae880755, 0x1fe8ff28, 
	0x72939ed5, 0xce5f207e, 0xf397e6db, 0x6fc00faa, 0x13b0ff64, 0x6bf7853b, 
	0x9449229b, 0xcf1a21f3, 0x64dca62f, 0x4acc0f27, 0xed05d93b, 0x87e73f61, 
	0xfb27647e, 0xfbc39ea5, 0x05cfba5b, 0x6fe468fa, 0x9a3ef2ea, 0x2fd360f1, 
	0x57e80f78, 0x00e17e39, 0xa5d225cb, 0x898dcf92, 0x975f184e, 0x700cfd02, 
	0xf99e262b, 0xd831c609, 0xf7a6d6fa, 0x7b97888b, 0x7563fa32, 0x3d484eda, 
	0x8dfdf44e, 0x8f297d74, 0x90feb6ae, 0x3116c9ef, 0xc1f5f31d, 0xffe5a53f, 
	0xa8b7d215, 0x75accc1f, 0x649f4a5c, 0x2c9c01e0, 0x34c3f47d, 0x4f88d7bc, 
	0x39e5fd68, 0xf34539f6, 0x0e7894ea, 0xb8413db3, 0x7faf0cfd, 0xe7cf0673, 
	0xe092ff2a, 0xbf1eb1b4, 0x243abce4, 0x4df786ff, 0x3cbde376, 0x7087c3d8, 
	0x7bff2b7e, 0x57d6ff2e, 0x7e56b0ff, 0x33df2e0f, 0xd36ae9b1, 0x4067f80b, 
	0xe96e7bc8, 0x130f0c0f, 0x0a7ad2bd, 0x108775e9, 0x6a5cb16f, 0xe843e603, 
	0x013d1427, 0x097acbfc, 0x097d5fc7, 0x47be97bd, 0x43f4956e, 0x0b79e67d, 
	0x72a7e1e5, 0x631eb65e, 0x44f455fd, 0xf3f220cb, 0xa4b3d5eb, 0xe6a7fcaf, 
	0x6d842ff7, 0x5e41da17, 0x1ebbd336, 0xe6796f29, 0x4bd6de7c, 0x1fbef695, 
	0x3f1e65e5, 0x934bcf02, 0x641d257b, 0x71ce825c, 0xf907960a, 0x8a27f6db, 
	0x2ffefe58, 0x0b755a4c, 0x00032191, 0x7ddd9c78, 0xd554780b, 0x93dae8b9, 
	0x267b333d, 0x864cce21, 0x93092010, 0x21008417, 0x96b46088, 0x0f0860ee, 
	0xc1cb46c5, 0x3397b67c, 0xaf416870, 0x6a544f5f, 0x9ec7d7a3, 0x90332630, 
	0x084013a6, 0x6d11b5ad, 0xc47d3da5, 0xd7a983d6, 0x5106ee7b, 0xa363c7a1, 
	0x6debd9f5, 0x36a68083, 0x27b6a455, 0xffef6b50, 0x99ad6bff, 0x092667bd, 
	0x7e9ce7a8, 0x3b07df37, 0xd7b5af6b, 0xf6bf7fe3, 0x8e66630e, 0xdfcc6711, 
	0x8e56e75d, 0xb46d3631, 0x88652def, 0xfafb82b1, 0xc45da872, 0x0c1382cc, 
	0xc8868c7e, 0x6674c67a, 0x8c958c3a, 0xeff042f9, 0x47ae787d, 0x611c5cef, 
	0x7334c8ac, 0x9b19537c, 0x75b632a1, 0x4cd70c32, 0x33c61c77, 0x81eee99f, 
	0x9f857ff1, 0xfe71bb8e, 0xc33933d0, 0xaa7d3570, 0xcec67afb, 0xd887f74e, 
	0x61ffbc7b, 0xdf20bfe8, 0xe00d6c8c, 0x3e034672, 0xa676e33f, 0xb91f60f9, 
	0xf8775aeb, 0xb452bae1, 0x6b121815, 0x9285ec65, 0x0b7621e9, 0x0d3ba7ae, 
	0x227c5f18, 0x147282fc, 0x7d8b17c6, 0xed8ce630, 0xea382c65, 0x65bf3d53, 
	0xf7dc32ec, 0x5c46c629, 0x0b5e8b26, 0xb0f57dbd, 0x4b4da596, 0x7dc6dc4f, 
	0xc66f9831, 0xc3b46634, 0x6602333a, 0x5c1160e7, 0x8becec5d, 0xa74a3883, 
	0xeb033f79, 0x337ac3d5, 0xda367e98, 0xc33fba9c, 0xb8cb6d01, 0x1b5a6a19, 
	0x78c551e6, 0xeaf3d268, 0xf38daa60, 0x3cf9f7b2, 0xbdaa71b6, 0x70095b9d, 
	0x658117b8, 0xe5ecf434, 0xfd81eb70, 0x2fc09514, 0x47cb185b, 0xf1c49d7c, 
	0xe10f5780, 0x18ec50ed, 0x9da871c2, 0xacfc451d, 0xd0afb108, 0xc061ee7c, 
	0x3b8e1f73, 0x8c73e346, 0x41bc2995, 0x7fe11dbb, 0x30a99b41, 0x352eefb8, 
	0x35c174a6, 0x16dcd1d7, 0xb0fcc4d7, 0x533d6e7e, 0x88fbc015, 0x057cf00a, 
	0x13d4b76e, 0x18da474c, 0xe3e19c73, 0xbd14ced4, 0xfdc0b48c, 0x557d68db, 
	0xf7ee5b75, 0xfd86fbca, 0xc3ce427e, 0xee3ef29c, 0x2733182f, 0x058c0db1, 
	0xcc49f45a, 0xeec5d8c1, 0x6fadc1e8, 0xa9f99b60, 0x11d079dd, 0x00b001d9, 
	0x3e007ab8, 0xe88551b9, 0x73b40b67, 0xf6f8e14f, 0xba974483, 0xf9d188e9, 
	0x4712390f, 0xd6e6eb53, 0xa038721d, 0x7bc7e2ff, 0x8faf44a2, 0x7885792b, 
	0xf2e7cebd, 0xcb1a5c01, 0x01f61c77, 0xf9811e3c, 0x222f9834, 0x7158d7f0, 
	0xbf41945d, 0x34477fff, 0xabf3a616, 0xd96d5f08, 0x71d228e6, 0x44765d72, 
	0xeb387bac, 0xcc6d05ba, 0xac437be5, 0xadeb11ef, 0x8efbf3e7, 0x79a5d6a6, 
	0xd3d6598f, 0xdbe03d60, 0x108f19d1, 0xd638e21f, 0x5850f08a, 0x00e1ce97, 
	0xac4d6520, 0x11abb02e, 0x55f43bee, 0x45cf803d, 0x78982fac, 0x0df5fb1a, 
	0x0fe8313d, 0x875d8199, 0xce7afdad, 0xdcf8e58e, 0xc142477a, 0xf1272cfb, 
	0x7477dd14, 0x2474db51, 0xe43b6196, 0xf5740ed8, 0xc40f016d, 0xd8233b33, 
	0x8bf7c3c0, 0xb1f3c1f0, 0x4871f643, 0xd767086f, 0x8438d4fa, 0x086dd237, 
	0xdd8d8ffb, 0x1f4669bf, 0x45f6179d, 0x6608bbfc, 0x0537bf6c, 0x3908efd7, 
	0xb176e121, 0x2b6390fb, 0x33c807d0, 0x1cc3078e, 0xdf12ff17, 0x4f817f04, 
	0xefff05bf, 0x7f6fc296, 0x4e187810, 0x52fb95f1, 0x52c72b90, 0xfa7676fc, 
	0xe03fe080, 0xdbbfd837, 0x4c356c6b, 0x25bf02bc, 0xf913722c, 0xef8a6a6e, 
	0xdfcd1df2, 0xb45e0048, 0x51876649, 0xda51f844, 0xd7d3ff61, 0xf6881db5, 
	0xa08cf631, 0x3ffee4f3, 0xff482a6d, 0x2f2e3cee, 0xc8cc7d72, 0x738d491b, 
	0x1b9a790b, 0x8e51f7e2, 0xf98b3718, 0xff9f71aa, 0x1c7f6216, 0x21ec4e5f, 
	0x20f46139, 0xca505dbd, 0x7e00ba6a, 0xbee68e4d, 0xfba09a6d, 0x556784bd, 
	0x3e45adf9, 0xb0f90af4, 0xbaf921d9, 0xe41f2ec0, 0xbb60237d, 0xf908731f, 
	0xf93682c0, 0x1bef26d0, 0x70f95605, 0x9521f355, 0x7a091f21, 0x13f8fd80, 
	0xf515f97b, 0x87a0b0c7, 0x13b4b6cf, 0xfc6f819e, 0x41473831, 0xd6d0e467, 
	0x3f9f340d, 0x79747a02, 0x06bfb36f, 0xfd56e937, 0x19afbc11, 0xdb1c78fe, 
	0xc7c843d1, 0xca3f424d, 0x79c69cfd, 0x22fedf81, 0xfc942fae, 0x30adf089, 
	0xca2279dd, 0x0dc68ad8, 0xef42282f, 0xf526fd11, 0x418c1e9a, 0xb6fc157b, 
	0x87f7e41d, 0x14ffbcf0, 0xbcf4673e, 0xd579cf0f, 0xb7774bc3, 0xebdff9d1, 
	0x447df1f4, 0x2bcb1ce0, 0x767239f7, 0x11ea7d72, 0xde9c6af3, 0xae1f389c, 
	0x29fa41e7, 0xa17de7e3, 0x6ec659c4, 0xefebadb2, 0xc40d78e1, 0x77b9d28e, 
	0x78e47c20, 0x3290cfd8, 0x2239eb42, 0x45ef1f00, 0xe7ccae1b, 0xc189e8fb, 
	0xc45d963e, 0xe32a6fd7, 0xf6197572, 0x293d128f, 0xc7e157a8, 0x24de7485, 
	0xfa84dbce, 0x8457ce15, 0xd1665174, 0xbd7666c3, 0x6fd6f38d, 0x377f5899, 
	0x910e8005, 0x5acf402f, 0x9a536ef5, 0xd34a6e9e, 0x7a694dd3, 0x4f4d29ba, 
	0x69e9a537, 0xabca0fdc, 0xdd3d34a6, 0xe5a7a694, 0x73c4af79, 0x7efd802e, 
	0x22a671f9, 0xe52f87fd, 0xb44ebff4, 0x1bbb459b, 0xe31e78da, 0xbb870e52, 
	0xb795bb44, 0x825d849b, 0xa4bb44e7, 0x9e97cbe9, 0x9a98335d, 0xf004e08f, 
	0x9db96a6f, 0xdbcc43ef, 0xc5b44db4, 0x88774dbc, 0xf25798b6, 0x74f6f7b5, 
	0x8cbab539, 0x53973ff3, 0x57c02f5e, 0x29c82bc7, 0xa54e459f, 0xea1f7ef8, 
	0x3b67158d, 0x0be40c7b, 0x5ac7c0af, 0x78e49f2e, 0x474da7ef, 0x8573fa04, 
	0x5ca2f25c, 0xebb191ba, 0x169e84ca, 0xf10de974, 0xb69724fb, 0x038c1e20, 
	0xe5aef836, 0x03902a72, 0xe117ca86, 0x08b905ea, 0x316f4feb, 0x7780b80e, 
	0x3f5affa6, 0xb5284f70, 0x90f5fbae, 0xfb466ea6, 0xf251c385, 0xd5d6026b, 
	0x5c7f4f80, 0x1dd5f9c6, 0x48bff584, 0x404576e7, 0x452bb95f, 0x715d335b, 
	0xc9dfef0f, 0xfae546f9, 0x6f90b99b, 0x47976702, 0xb8ae7063, 0x8ce09be0, 
	0x1f50cb9b, 0x274c9cb9, 0x4a698d7b, 0x4157c382, 0x15d8133d, 0x5700fc52, 
	0x88eaa2d7, 0xb151da1f, 0x0e6d380f, 0xeba67903, 0x764be90a, 0xa839e7ea, 
	0x0be5c33f, 0xab75bb78, 0x7373fd8a, 0xf3b43217, 0xf483bc61, 0xa1a634e6, 
	0xd23efc5e, 0x398bc027, 0x116bda87, 0x5fa0c350, 0xc7c3bee0, 0xaae9b8ed, 
	0x4c8b1fb0, 0xce97be25, 0xe54cf4a5, 0x607097e7, 0xe22e1fa8, 0xb8340078, 
	0x76062e51, 0x4cf72df5, 0xc1e9c14d, 0x23926e92, 0x06f41e34, 0x837d06ab, 
	0xc02e6afa, 0x3d30e00d, 0x2f17e84f, 0x87a2dbc0, 0xe0f8080f, 0xf515aeb5, 
	0x67415ef6, 0xe15875cc, 0x58763470, 0xc494c6e1, 0xf6e1b1fa, 0xff5c654f, 
	0x7eadc066, 0xfa3fda98, 0x09ce0b87, 0xebc1636e, 0x113fc0c5, 0x051ea51e, 
	0xc389417b, 0x0ec85939, 0x22bfa237, 0x77409fd4, 0x3dcf7a16, 0xbbd10cfc, 
	0xcbdce3a4, 0xe4051486, 0x2d25f4e5, 0x11aa3a07, 0x375ed25e, 0x2fb42272, 
	0x44e90798, 0x2be27233, 0x780af453, 0x25fd40ea, 0xfaff98e1, 0xec872390, 
	0xf78dc348, 0xcb7e3f11, 0x392c1e7e, 0xe24efb44, 0x07e38ea7, 0xf9c118e1, 
	0x71a8b1e7, 0x73738e04, 0xe1619d7d, 0x3b847c93, 0xe741b7d1, 0x3d0729eb, 
	0x2cedf304, 0xcae174e7, 0x90c6ed63, 0x19af79e5, 0xbdc5bb41, 0xc34517d4, 
	0xd594b7d2, 0xc2eebd09, 0xa06b7cff, 0x077dedcd, 0x06ed2ffe, 0xb81994ad, 
	0x7de589ce, 0xff6c0d7e, 0x4ebe32a1, 0xa235e863, 0xaf6575ab, 0xfd005d13, 
	0x2da11d91, 0x7b451fdb, 0x52eec9c8, 0xfe1f8f10, 0x180033f5, 0x3ca07f68, 
	0xd1f5cdd4, 0x187eadca, 0x48d4cf97, 0xf02bac0f, 0xf7d825f5, 0x0b93b474, 
	0xd7ce3d61, 0xe359c10a, 0x1ae6d478, 0xbc49ec7a, 0x6f17acea, 0x397da107, 
	0xf40da15e, 0x2c99e5a0, 0x8b5c0cf6, 0x03afcecd, 0x6c9568ef, 0x64ec0c49, 
	0xf67f51ad, 0x2ec7b43e, 0x3f76ff0b, 0xd2bb41c0, 0x0fdd88ec, 0x7a935070, 
	0xf77e4555, 0x76d5ee7e, 0x5ec11bb4, 0xf5dfd154, 0x764cd35e, 0xdd045fe4, 
	0x6cf4b0fe, 0x9a07da19, 0x559e3390, 0xed188783, 0xfdc46f4f, 0x59aaeb39, 
	0x739670fb, 0x7684b94a, 0xaef78c31, 0x116aafd9, 0x7cf943b4, 0xeab0c69e, 
	0xc39e6852, 0x2567e7c8, 0x67f7275f, 0x6bef503a, 0xb1345893, 0x9775e002, 
	0xa05ee07e, 0x4e72ca83, 0x2e925a3f, 0xe718bc05, 0x039b800b, 0x06e492e9, 
	0x307739fa, 0xf07a054d, 0x97be1ca0, 0xca2b76e8, 0xeea7490b, 0x0e4a432d, 
	0x72aef3f0, 0x8bf81f6e, 0x382e5e39, 0x1c4e4cfc, 0x69505fee, 0xc00bc4e6, 
	0xf0e72d3f, 0x91b90bf0, 0x7ef20fec, 0x86e51e7c, 0x37ce2eef, 0x3d22a3f0, 
	0xb378813b, 0xd20d67c1, 0x0615f92b, 0x7e9243f9, 0x70e2e752, 0xa6a334db, 
	0x4575e09c, 0xbb098b91, 0xf4f9d19e, 0xe49fc228, 0xde4917d0, 0xe9078aa8, 
	0x446254d1, 0x6d11c38f, 0x03475f2a, 0x1bd772fe, 0xcb4bb62a, 0xc59ce1d3, 
	0xf57181ff, 0x19c1bce2, 0x254f8967, 0xfb61367e, 0x49fcf126, 0x0a4f2fb1, 
	0xabaf12bf, 0x673bf3c4, 0x7c8e5e5c, 0x3c945da2, 0x4788e1d7, 0x75db9de0, 
	0xe668e30e, 0x8c7ef039, 0x6edc32e0, 0x8b6e473d, 0x33a31cfd, 0x19f04b3e, 
	0xdb357e67, 0x31b7c8fc, 0x2f6d7701, 0xc6f50f9f, 0xedf832ba, 0xbcf9d4bd, 
	0x48a224d7, 0x7dd5deef, 0xf9491aaa, 0xc60eb8b3, 0x1e82c299, 0x7c10ce77, 
	0x1f525972, 0x26788c3b, 0xb8e28f7d, 0xa5c65a3f, 0xe3fd17ef, 0x4ef1a995, 
	0x23edcc90, 0x7691fa29, 0xd32e6fab, 0xc85ec1da, 0xf1133377, 0xd380fbe8, 
	0x7feba4ad, 0x1bb9e714, 0xf4d9cdae, 0xd4b3d0f6, 0x00bbfb5e, 0xf72d37d7, 
	0xde941d12, 0xa5fa8d37, 0xc3e751de, 0xfd29fd3a, 0x2a6e58e3, 0x4366dc7e, 
	0xf51f835d, 0xef9cabd1, 0x44b4573c, 0x9bba3eb8, 0x5abde1f0, 0x2818d48f, 
	0x1887122f, 0x094635f9, 0xf5c867ae, 0x63961747, 0x15dfcdfb, 0x8efff588, 
	0xdbfae5fa, 0xe4f1fac4, 0x6afb7dfa, 0x497eb462, 0x86b5ca15, 0xf5780dd6, 
	0xbc1ec734, 0x414aae14, 0xfc0ab977, 0x64715de4, 0xf68c6d5f, 0x2be42df5, 
	0x23370bd2, 0x63151b1c, 0x4307ea27, 0x701e8089, 0x3963a96d, 0x0167af00, 
	0x094e73ce, 0xdef447fd, 0x71eaf44b, 0xe0288eb3, 0x610bf73b, 0x3be4b7c2, 
	0x48bd9fa2, 0x0ee7464f, 0x089ecfce, 0x20dea402, 0x1ede0fb9, 0xead5c79d, 
	0x8ba771e3, 0xcd1db9ea, 0x7a801fb8, 0x085ce10b, 0xba73c23b, 0x52de075a, 
	0xd38cb386, 0x1a6e3423, 0x5f34587a, 0xd353f71d, 0x25d48dc6, 0xf48a58e3, 
	0xba4f5147, 0x6b8a0d4a, 0xcd3217aa, 0x29f8fb07, 0x7403c1c0, 0x675cdea0, 
	0x335f4838, 0xee782fd2, 0x7f94a9f8, 0x87a43f0d, 0x6e2c1c47, 0x9192fc58, 
	0xc3b4767c, 0x3f6087e2, 0xa5ba241b, 0xa8ff807d, 0xd8f9d30c, 0x1afc93d2, 
	0x037bf841, 0xfc1da446, 0x47c893d2, 0x31bc94d1, 0x0b9d18aa, 0xf188f6ec, 
	0x8dcb5c06, 0xe5f806c3, 0xee7c14bf, 0x7545a8bd, 0x4757c82a, 0xe16e31ca, 
	0x7eb980bd, 0x57766cc0, 0x5fffea0e, 0xd43f7394, 0xed23301b, 0x05e68f30, 
	0x7ce8cffd, 0xd78e7839, 0x3383b9c5, 0x6578457e, 0x79368dfd, 0x3b06ace7, 
	0xf3ae2f60, 0x0dc75f12, 0x759618eb, 0x8ed2a3fa, 0x7f7e41ce, 0xeb1bd85d, 
	0x1cb5feca, 0x69cba0e5, 0xa51b6c0e, 0x3d9dd9fe, 0x686fceb8, 0xaa63e71d, 
	0x77fb0a2b, 0xb3f4045d, 0x683e6d37, 0x73ce4c9f, 0xfda1e69c, 0xf5791f22, 
	0x80b78c76, 0x08c8731f, 0x9c12fdf3, 0xc29c0296, 0xc6235f34, 0xfa587ee9, 
	0x1767ce7b, 0xb821fdc2, 0x999b7a0f, 0x476c1d78, 0xa7ae473b, 0xfd04597a, 
	0x0e02d3e0, 0xfebec279, 0x683bea13, 0x82ba7d3b, 0x7fc17af3, 0x9979b846, 
	0xf73da18f, 0xd05fd02f, 0x9535788a, 0xe4e3a097, 0xdb3b44d2, 0xfb03f625, 
	0x96de2274, 0x90f83ea3, 0x67aee1f6, 0x799c9fa4, 0x0872347a, 0x5ae40cf9, 
	0x6adfd680, 0x70f25c00, 0xf89945ff, 0xba006d77, 0xe5abfd80, 0xdf6724cd, 
	0x702ad52d, 0x1e7c3cbe, 0xe78799f0, 0x61dc68d3, 0x3da60c0a, 0x363ee1af, 
	0x8fa975c1, 0x049aa1eb, 0xa434ddc5, 0x35e218a7, 0x76f24150, 0x8fbf3369, 
	0x4cfed2f3, 0x384abf8a, 0x86c4dd21, 0x247a5cf0, 0x8375e706, 0x9b708d1d, 
	0xbaf5c15e, 0x27ee1af3, 0x70133c20, 0xf705509e, 0xbe514707, 0x868e9c00, 
	0x7e902a4a, 0x401abf58, 0xe0a8efba, 0x27c92772, 0x042fdc6d, 0x53838dfe, 
	0xd3efba9b, 0xb7d05c85, 0x04bb161a, 0x2a00adce, 0x27b078f8, 0x35c31646, 
	0x0d6fe294, 0xfee213fb, 0xfa357e7e, 0x6cdffc2c, 0x8f770828, 0x61fb079c, 
	0x9a1b499e, 0xf45af15f, 0x190ba4c8, 0xd3400fd1, 0xbd527a85, 0x5193b9a1, 
	0x2669e79b, 0x7744652d, 0x76730f32, 0x9f8465fa, 0x19fd5e49, 0x90deafbc, 
	0xd3d1c0e8, 0xa5bdf736, 0x55e6b66c, 0x2fc608f4, 0x29d02f73, 0xb5cf2c9e, 
	0xcbeb82a6, 0xdfae02d5, 0xe0aa6f2c, 0x9fae46f1, 0xd7735e24, 0xbe456ff5, 
	0x029da554, 0xb9be4570, 0xcdf382ae, 0x0aaad0d1, 0xe92dd3d4, 0xf0e7ae70, 
	0x1aa03dcc, 0x7884b9f2, 0x5dcf43ce, 0x9d39fd9d, 0xb434773f, 0x64c786d6, 
	0xdfc71d7f, 0x3773e52f, 0xabdbc5d6, 0xd15b0e09, 0x21b498bf, 0x02c06cf1, 
	0xf4de7957, 0x22be726b, 0x6fdb1f3e, 0xb9c29e50, 0xf28df06a, 0xca5c6b36, 
	0x57007d70, 0x5c918067, 0xc207b8c3, 0x3eb0f085, 0x36f32795, 0xcdd83cf3, 
	0x3e814e92, 0xbe4203db, 0x63ec3da3, 0x161f2d8a, 0x66b0f912, 0xa5bb0f99, 
	0x3a4fe502, 0x3e1f10de, 0x722fb3e4, 0x3b7f9939, 0x15ed23d7, 0x66fbaedc, 
	0x4704edf9, 0x3e49da55, 0x9e243f2e, 0xdd3c4962, 0xf832e34d, 0xff9f99a1, 
	0x1d9a2868, 0xe0d22bde, 0xbde0173d, 0xc227f39f, 0xf9aab9db, 0x1c5b1ab5, 
	0x9ed8774f, 0x8e7c710f, 0xd2cf0785, 0xa3e5bbc4, 0xf2337876, 0x5e744303, 
	0x07bb808f, 0x71f80be5, 0x9d015727, 0x85f14c6f, 0x32180567, 0xd5a6ef20, 
	0x3387dd01, 0x0570f2f1, 0x567a57cf, 0xe3833f35, 0xa77ae53c, 0xe39f02b1, 
	0x553f02f8, 0x782e7ad9, 0xb4f1215a, 0xc64f0d3f, 0x481a78b8, 0xf4c7e9e2, 
	0xf803479c, 0x3a5f1024, 0x76853f8b, 0xf9aee87a, 0x6d47ff04, 0x6f7827f0, 
	0x2c31c0b1, 0x905cd6e4, 0xfc71fb1f, 0xff9415e3, 0x0b7c6b1c, 0x95c8fb87, 
	0xe221fc72, 0xb57f64ef, 0xef897ba0, 0xe3147e90, 0xb02e2361, 0x86f62c2f, 
	0x1155c3f4, 0x7de7c05f, 0xcc59bfd8, 0xcd1f0a1f, 0xbcf77903, 0xc731fba0, 
	0xd0f18ab7, 0xb9f12cd6, 0xdf6ed511, 0xc467fb48, 0x762df70b, 0x14f55e4e, 
	0x6b380307, 0xb72e062b, 0x2e3c21c6, 0x0ec93870, 0xccdc45d1, 0xe78cfca0, 
	0xfd0556aa, 0x753ae668, 0x382ff308, 0xfd9b2c6f, 0x8a47fcdd, 0x5a5f0d9b, 
	0x113de226, 0x6e9cff8a, 0x73b8f615, 0xc4b15db8, 0xfc0c5e7f, 0x7148e08e, 
	0x2fb4f59f, 0x2c53f305, 0x80de906c, 0x0e283bf9, 0xaf999d7a, 0x7ee63d02, 
	0x1f303860, 0x76135de0, 0xe273bfa1, 0x819bb0da, 0x6c393dfe, 0x4f8f51b8, 
	0x46ed180b, 0xd01ff42f, 0xa3f6e56f, 0x665604ee, 0x95b8d35e, 0xa74c43c7, 
	0xd5dc606a, 0x279935b8, 0x9287fec5, 0x367d646d, 0x588dd555, 0xf4f35c23, 
	0x33ac18bc, 0x13fa0835, 0x317ac5db, 0x76f52bb5, 0xe7d5cf6a, 0xc322fb52, 
	0xcddb93bd, 0xad1c63cf, 0xfca0dfa4, 0xe1bf6946, 0xacbb41f4, 0x3573db92, 
	0x6af48c95, 0xbfd17ec9, 0x6fdecf5f, 0x2fdc3f42, 0x6b2b9935, 0x1fe880ff, 
	0xdf3fb330, 0x80dbfa26, 0xb7f5b32f, 0x4c5bf588, 0x3efed647, 0xcb1f7cf1, 
	0x78af7f3e, 0xb154d7be, 0x1ea3ef1f, 0xedbfc14a, 0xefdf8a56, 0xaf2779e7, 
	0xc52b7039, 0xbe780791, 0x00fb7bc1, 0x6b7917ef, 0x2da243ef, 0xbcd354f2, 
	0xebe07780, 0xec8d0e69, 0xa42af793, 0x99fdc6dd, 0xd38fb805, 0xa476af84, 
	0xc7915c93, 0xf58af5cb, 0x35a0fa5d, 0x7d65e0ff, 0xfa169d83, 0x5f997ec7, 
	0x39e21888, 0x67bc27b0, 0x7567c43d, 0x8b42ff30, 0xf614e4ff, 0x886e7394, 
	0xa5cd76fc, 0xedabb12b, 0xcd3b167c, 0xc3cf6bef, 0x1b3adcae, 0xa31d3ca5, 
	0xe37de1fd, 0x6c78d4f9, 0xe353abb3, 0xfd87bec8, 0x3a2eed6b, 0xfda5636f, 
	0x9a0abbbc, 0x740fd12b, 0xe8ddba8e, 0xf4eab857, 0xdd2bb472, 0xf70546f5, 
	0x22bfcd43, 0xb7c0689f, 0xbd30ef68, 0x6d0ef889, 0x1dc7832b, 0xfa6f8c14, 
	0x70699f7d, 0x5ca11f00, 0xc80bfab6, 0x9476f6d9, 0xdbc1a6da, 0x7a419f0e, 
	0x86bc0dc1, 0x52fb0b7c, 0x5f9c288f, 0xa7c55e70, 0xe05d6939, 0x7df957b7, 
	0xd85123aa, 0x7fbf170a, 0xee8a75d8, 0xde51eeeb, 0x322936ef, 0xe8476ba9, 
	0xe1606a6a, 0x2af3db63, 0x78867b6f, 0xb79877bf, 0x7f78a7bd, 0xe76f28ee, 
	0x9da95b9a, 0xda872477, 0x9dbc4379, 0xf0439c3f, 0x0e41f86d, 0x663177fa, 
	0x5f6e06fc, 0x3b0ec83f, 0x0e8d7e01, 0xc7fa0a2d, 0x8fcf0efd, 0x47d27f68, 
	0x50d09c85, 0xc26a842e, 0x97d81887, 0xb2fa5c8b, 0xc16ec29d, 0xe66592de, 
	0x5f6f3077, 0x77cbd412, 0x564a3c01, 0xe6b5fe87, 0x4d9d5c30, 0xae307a27, 
	0x04df9aa0, 0xb9959e4b, 0x57cc3cf4, 0x16cc9a4c, 0x53fee1ed, 0xf78023bc, 
	0x85fd5cb9, 0x13616bc0, 0xff6423d8, 0xc5ca3f30, 0x17a653d2, 0xafd8dbe1, 
	0xd4ed057f, 0x5cb547b2, 0x077fec2f, 0xd0b6d78c, 0xaaaffcfe, 0xc23f4e74, 
	0x1d1011b5, 0x753c7d00, 0x7980d9b2, 0x7b3593d3, 0x784fd07a, 0xfeafcc4a, 
	0xcf10d140, 0xe3cc8dce, 0x85ff43a8, 0xd06a9bdb, 0x33994f1e, 0x7f99eb93, 
	0xd757e4ae, 0xc04bbd1a, 0x5aeca083, 0x5f55df52, 0xe843d297, 0x9f03b54f, 
	0x2a653f04, 0x07a7d80e, 0x0bfba1c6, 0x8a238cae, 0xb69ad9fe, 0xb77c862e, 
	0x3e39f382, 0xce50edcf, 0xdc8748d7, 0x7441991e, 0x53a9d855, 0xbf7b88fd, 
	0x0194758f, 0x87d496be, 0x7ee85ad8, 0x021f3f95, 0xaa7cc67a, 0x3e45f40b, 
	0xf2669b5c, 0xceb38ff8, 0x3718a2c7, 0x85bfaea8, 0x2667ccbd, 0x31a4587d, 
	0x79d45ae3, 0x608ccc83, 0x8cc12f7e, 0xb32467bf, 0x8aafd0a2, 0x2663b4f8, 
	0x015d13f7, 0x67fe4a23, 0xe7c51e8d, 0x97584bfd, 0xde136bc8, 0xf3f64d03, 
	0xa15335bb, 0x1cce5ff3, 0xab407e78, 0x3827e782, 0x83bff9c0, 0xce0b6972, 
	0xc75dce23, 0x0cf341cf, 0x0ddd79c0, 0xa3ff5e74, 0xfd01fde0, 0x1aa683f9, 
	0x1e567981, 0x803d7d81, 0x18aa697c, 0x0dec6ddf, 0x18fce035, 0x0678c337, 
	0x55c601d2, 0xf656de25, 0x7685bdf6, 0x3fc424d4, 0x0517dfc8, 0x051e2bde, 
	0x4afe06d1, 0x876e46c5, 0xf8f25475, 0xafd2f1ef, 0x78189f92, 0xb8c3ccd4, 
	0xc798a071, 0xb0c502e9, 0x77ee3b7e, 0x10a2eaf4, 0xbec3f6bf, 0x2d4d8a0a, 
	0xcf9fcbd2, 0xfef91f79, 0x01ed9501, 0x5f844d3a, 0xc5d65a71, 0x1da10af5, 
	0x637ee4ad, 0xc15d46c5, 0x119e6afb, 0xdfb1858d, 0xe21bcbcc, 0x2a3fa8fd, 
	0xad5db98a, 0xa8a66aee, 0xa1b14549, 0xf7ec3fa2, 0x82ff049a, 0xd4d7a325, 
	0x74bee3f7, 0xe64fd715, 0xa953742d, 0xdc61e4b7, 0x4fda21b1, 0x97f86f61, 
	0x97f230ea, 0x53db7a79, 0xc3fd2fb8, 0xfcf05dc4, 0x00e79188, 0x99348c38, 
	0x2bef4239, 0xe7c2fed2, 0xbb074003, 0x67f25946, 0xc3463dd1, 0xfb37611e, 
	0xb3415f10, 0xe820ebaf, 0x691d4680, 0x186c2d9b, 0xff80d3ec, 0xe7a65e17, 
	0x175f8179, 0xb9dbc25e, 0x4f44feaa, 0xb53fd69c, 0xffad196d, 0x139dc497, 
	0x32b503cb, 0xff68f14c, 0xacdba192, 0x5d5baffe, 0xb91b784a, 0x174ce07f, 
	0x4143cfdc, 0xdfee0237, 0x583dbb2c, 0x1866ed50, 0xfa002aef, 0xf8f8f848, 
	0x5e27fb5d, 0xfc0b9177, 0xa2ff8047, 0xa4f7bd1f, 0x8aaba712, 0x4cf8abf9, 
	0xe182bf8e, 0xb3f41527, 0x9536ef0a, 0xcf375c38, 0x0b7378e4, 0x7c44e1b9, 
	0x9cef5c03, 0x13bdf5c9, 0x73a01df1, 0xce3f1e5f, 0xf73b85d8, 0xbcc1a3de, 
	0x4fdc5595, 0x0bd843ba, 0x985b9f32, 0xc05cca98, 0xf60ac1e7, 0xc175f214, 
	0x0baf2c0d, 0xf5cb93da, 0x514e307b, 0x63466e50, 0xbd498480, 0xd76bf53e, 
	0x742de78b, 0x7644eb8f, 0xe5c1fd72, 0x24724a88, 0x7c4233af, 0xa99fa335, 
	0xfd69cc6e, 0xee97db84, 0xec1c821f, 0xf9467927, 0xa23d6ab7, 0x6cd2dd61, 
	0xfa06bfd8, 0xe7aaf67a, 0x967f513b, 0xd296c3dc, 0x6130a3f3, 0x1433f11c, 
	0xa0a67f45, 0x900941b4, 0x19444c3c, 0x33e993c8, 0x7051ffb9, 0x1e38aebf, 
	0xa0ade148, 0x2cd30a66, 0xcdb054f4, 0x1edc7cc7, 0xa7a42164, 0x4f995355, 
	0xee9187f4, 0xe4760f9b, 0xcde8a5b6, 0xc3dfeaa9, 0xcff3b67c, 0x947b2f2b, 
	0xa111aff4, 0x1e64eebc, 0xc0d3cfdf, 0xe9087b41, 0x879636f9, 0xa2a309f5, 
	0x36e9a79e, 0xdffdb5bf, 0x6f1c9d04, 0x8582be02, 0xa53b1a7c, 0x29cae7f0, 
	0x39486abe, 0xae3c1ccc, 0xe5db993b, 0x82f64eba, 0x71b7e30b, 0x584223f2, 
	0xc188e1e7, 0xff83eff8, 0x3d7987a5, 0x1d70fd5d, 0xf5fc55c6, 0x71ed0cd5, 
	0x49fabead, 0x91c7c817, 0xce10fac6, 0xc0fb03ef, 0x2fe6a688, 0x2d637114, 
	0x6c675431, 0x31638d4e, 0x57d60761, 0x85ab7f93, 0xdc0e3c42, 0x2febcf58, 
	0xa1673c84, 0x22afb4cd, 0xc0fd079c, 0x9baa7aa2, 0xc23ee3f0, 0xe6593f62, 
	0x0702e665, 0x8c452fda, 0xee1a25fb, 0xfce67377, 0x3d18df23, 0x2ff85aa3, 
	0x3fa0af83, 0x61f88d58, 0xed5bb7eb, 0xbbd0e081, 0x5607b409, 0x68b543eb, 
	0xfbbf380f, 0x1e5c5dd3, 0x83d3b1dc, 0xdbca17fc, 0xec20f24e, 0x0a4f71dc, 
	0xb55e921e, 0xc0eb3f66, 0x654f3473, 0xfa608f1d, 0x798d700e, 0xd55315bd, 
	0x6f5047ce, 0x3ce9f9b5, 0x886a6f42, 0x5fba11c7, 0x670fbd6e, 0x17a1b8a5, 
	0xf3c1e8f1, 0xc15ede01, 0xbc7a9fe2, 0xf7838209, 0xf9f80a97, 0x70d79c24, 
	0x3d053afc, 0xf9c555dc, 0x102e0d8c, 0x1b70e6f0, 0xc68f82f9, 0x7e718915, 
	0xa43b5729, 0x5389c55c, 0x90cfe9fc, 0x568dfaab, 0x860feab9, 0x8d5c900e, 
	0xa91ab90a, 0xb572403b, 0x8b90df51, 0xb781b572, 0x6e647053, 0xda87d72e, 
	0x7c9075ef, 0x0ee10c7b, 0xede9edf2, 0xb7079271, 0x48f6f90a, 0xa1d5c937, 
	0x4573f218, 0x3ed5c813, 0x3d515c4b, 0xca497a44, 0x20dd91d3, 0x17ffa15f, 
	0x213db8b3, 0xf1006ae5, 0xa02e720f, 0x30ff1c19, 0xae35576e, 0xe7a7edcb, 
	0x053eb8ab, 0xe714bab9, 0x0ffa102b, 0x2c3ca3ef, 0x3c9268d8, 0xd274f354, 
	0xff42057f, 0x31835da9, 0x21c7c12d, 0x3d08167f, 0x4835e158, 0x99d605ef, 
	0x59e158d7, 0x802ffa80, 0xc3d05b79, 0xc2fa9645, 0xb668e616, 0xa13553c4, 
	0xa0130b97, 0xeca73707, 0x393fb94c, 0x8f1578ee, 0xc556be4f, 0xec205bcf, 
	0xec5fb904, 0x78e87b47, 0xd0c7bfe9, 0x3b0bf50e, 0x04ec2fc1, 0x0769ea3f, 
	0x84ec15c2, 0x0fed7e3e, 0xc8a1fb09, 0xc37ba7a2, 0x71884edc, 0xc9b0a13b, 
	0xbebaf08c, 0x51dcedf1, 0x47af1fdc, 0x85cec31d, 0x5cec58f3, 0x1e7697b4, 
	0xd0c2fb43, 0x2a7f207c, 0x93da8682, 0x7da0f310, 0xa0fae6ed, 0x54760131, 
	0xa190321f, 0x07d21e52, 0xec5a8ee3, 0x51d804a8, 0x4b0d8700, 0xfac954ce, 
	0x913fbc79, 0x48ed2cfd, 0x7bb7909f, 0x8fbaf92b, 0xbaf87255, 0x2caec2bc, 
	0x0f12bb07, 0x7613157f, 0xd32bb0b5, 0x638c6aec, 0x696aed59, 0x3abb4a57, 
	0x555e5769, 0x696bedcf, 0xd7d9a657, 0x6703bd23, 0x3a41afd0, 0x1c71b9cf, 
	0xdcf7a17b, 0x9fe705ec, 0x0dd6263d, 0xf5460182, 0x78aaab08, 0xbbb7875d, 
	0xd032f06d, 0x607d5eab, 0xfa93d710, 0xc007292a, 0x02f5c5bd, 0x93f21730, 
	0xbca21956, 0xfe8215e4, 0x7a79afd3, 0x4905c51d, 0x7c269d0e, 0xd2ceb045, 
	0xe93af229, 0xa116cb7e, 0xf8081787, 0x046da2bb, 0x78afe94f, 0x65f233ee, 
	0x6dea3b5d, 0x5f3d3acf, 0x6d81dfc0, 0x15aa8bd0, 0xaba67ede, 0x4f846f08, 
	0x3b8090fb, 0x379f83b4, 0xc00fcec9, 0xc2f6d83c, 0xe0e7e4f3, 0xfe99037a, 
	0xe793c48d, 0xf47c81be, 0xe38259ef, 0x2daeb3c9, 0xdfffa19f, 0x49cedbcc, 
	0x83af037a, 0xb77d9366, 0x7ee71c91, 0x1932d6b7, 0x8ea89ee3, 0xa67dbdb1, 
	0x2732b3ac, 0x7e43df0f, 0x9fe464f8, 0x0e1f856b, 0x6fc90a77, 0xdd257a17, 
	0x696c61ff, 0x9bc7c1a1, 0x0b07382e, 0x0d3c2b1d, 0x287e4d6b, 0x9ee6b6b6, 
	0x7fa47f94, 0x5e619065, 0x973f292f, 0x5ba7e5d8, 0x6976e06d, 0x9766d46c, 
	0x5da670fe, 0xfc85fa7e, 0xa73a6bf4, 0x2e7f1833, 0x3da63674, 0xcbedc8dc, 
	0xfd2edca4, 0x8f8c19d9, 0xdd6d2b7e, 0xd2df410a, 0x4cd0ac5e, 0xf187d68d, 
	0x175dbfa8, 0x40917f82, 0x87cec2ff, 0x5f8475c9, 0xfc47f127, 0xfcede347, 
	0xa27c2636, 0x31dcfb69, 0xd5fcfb40, 0x45faeccc, 0x67a933ee, 0xf3ee3c60, 
	0xeb5c548e, 0x10ffa449, 0x57f103ec, 0x0ea5e221, 0xdb193836, 0x8b3f22ae, 
	0x64ecf8f2, 0x86d79394, 0x65da19aa, 0x7f767523, 0x3afddaf8, 0x86d721e5, 
	0x64166080, 0xaf5a87d2, 0x4701e7f1, 0x0c7d20f7, 0xf2e32784, 0x97897dc1, 
	0xfa569cf0, 0xe3b1f400, 0xc75bd72a, 0x0fbddc67, 0xa3fab0e5, 0x8ccc37eb, 
	0x30733ed1, 0x888ef23f, 0x37ed3027, 0x7a7e0714, 0x4c03a893, 0xc876413c, 
	0xf2a61b9b, 0xef889b76, 0x464f1b56, 0x03d667d6, 0xca0018be, 0xf79c23fa, 
	0x00281fb3, 0xe1e7361e, 0x4682399f, 0x51d87d6a, 0x956b88b9, 0x4de3fee3, 
	0xf20a2d0e, 0xfec564b6, 0x3f61eb07, 0xeb9336ff, 0x2de5e393, 0x8e7f68fb, 
	0xffa1f7e7, 0x6ffd5ccb, 0xd65afc60, 0xd79d306d, 0x8cd0b021, 0xaf9fdc72, 
	0x47c3d854, 0xb6c12f2e, 0xe2215223, 0x61f7fbd6, 0x6fd65adc, 0x67070528, 
	0xb1ce3c62, 0xdbd92cc7, 0xf48eeb09, 0xfcc14b7d, 0x3393c168, 0x67508f29, 
	0x8079405e, 0xd4676ddd, 0xd338f22c, 0x133b68ce, 0xc93e073c, 0x3887b788, 
	0xe6fb539c, 0x7dc996f5, 0xc21d4ebb, 0x7c248f3a, 0xa0eda383, 0xbfbe01d2, 
	0xbfc6f822, 0xc412997a, 0xdebc1369, 0xd44b7b65, 0x8491fe81, 0xb031fc73, 
	0x38294213, 0x9f31de13, 0x01bc207a, 0xf2839ce1, 0x7df934f7, 0x17c899c7, 
	0xfb767a88, 0x139fab3e, 0x7cb53975, 0xb4dd035f, 0x0b478dcf, 0x5027d827, 
	0xfb2c57d4, 0xd99f6034, 0x8e346eea, 0xddbd14bf, 0x7a49fd41, 0xfce3bc03, 
	0x0ff392db, 0x44ee2bec, 0xa99d9e3c, 0xf45fbf02, 0x98ab3ff7, 0xa4ba231b, 
	0x0f561afa, 0xf88bdbf8, 0xda2660fc, 0xb7f72305, 0x96309f91, 0x9cfc955e, 
	0x88dbc7f2, 0x59f6339f, 0x876e5f9d, 0x674455c3, 0xf7d83829, 0xcfe414a9, 
	0xfdc9fdc2, 0x85bff9c2, 0xd033fafb, 0xea97d537, 0x7ae99f7c, 0x5227da52, 
	0xeb89d64f, 0x4edc59c2, 0x90d778a1, 0xcc317f88, 0xf6d49a0b, 0x265898d4, 
	0x15ed91f0, 0xf8f9871c, 0xf96d258a, 0x7eca5946, 0x9a5bb0c9, 0x5ef40da0, 
	0x22f418b1, 0x6a682b8c, 0x247fafcb, 0xf9e98725, 0x30e4a5ef, 0x997cdbc5, 
	0xfe7a3671, 0x4bf9e27b, 0x842ee752, 0x79c01673, 0x78e2cda7, 0x2c2c3b21, 
	0xaf3c32ec, 0x1cb79c57, 0x2b936bce, 0x20f117a6, 0xb7f546e5, 0xbaf0933d, 
	0x66fce90c, 0x436c178a, 0x8ef2853d, 0x6bff64e8, 0xae5f7fc4, 0x3efc212e, 
	0x8bef933c, 0xf4463c0d, 0x157772fd, 0x18ef6bc7, 0x6a7fbb74, 0x3679f5b9, 
	0x87a255f0, 0xd26373e4, 0x1744d5ed, 0x1ab748d5, 0x4e2dffcd, 0x459b9faf, 
	0x4e5ecf79, 0xfcb49f17, 0xf903f8c1, 0x38f6a39f, 0xddf3f482, 0xe2bc7893, 
	0x658e9378, 0xd98b4c85, 0x2a0c7efd, 0xf94fdf1b, 0x3c59f1fd, 0xfff16dbe, 
	0x3b84716d, 0x9b3c04aa, 0x7f56ab37, 0x428d647e, 0xfd13ae7e, 0x6bc7957d, 
	0x64155f50, 0xc9077df8, 0x3a291bef, 0xd49efe43, 0x959e3fcf, 0xda487edd, 
	0xfb9e300d, 0x9bfbe37d, 0xb7b00923, 0x0c85c8b3, 0xce0626f8, 0x19873e6d, 
	0xfd25ae89, 0x0018e3c6, 0xe1b79e32, 0xf0cd02f1, 0x9ed49da9, 0x3ea276aa, 
	0xa88d1aef, 0x03c65e38, 0x883cd55e, 0x03e0550f, 0xa2eff3f7, 0xbfade03e, 
	0xa3a5f8c2, 0x2d77e891, 0xfd0209f0, 0x9e2bac03, 0x9e52f996, 0x9218ad1f, 
	0x85c352f9, 0x36c558ee, 0x2f9466d9, 0xe64fb8ad, 0xc7150d4b, 0x7873448f, 
	0x097421dc, 0xb0e47bed, 0xf913e7a8, 0x221391be, 0xfc2832ee, 0x2fd12e94, 
	0x44fb96fd, 0x2597b0bf, 0x3d2a47de, 0x9f54ef34, 0x187a4147, 0xf7a3e359, 
	0xb0f5908f, 0xc76fe17e, 0x5672781e, 0xda407b36, 0x4f051d01, 0x857ac2cd, 
	0xfcecee91, 0x77376198, 0x5c71f927, 0x6e48997a, 0xebc5992d, 0x656e490e, 
	0xcb39ef39, 0xbef38ca1, 0xfcbbcfc1, 0x97c2094c, 0xe5d00fe4, 0xe583969c, 
	0x461c1f68, 0x253a7bb9, 0xc2ffdc87, 0xab536df3, 0xeb40de78, 0x5c4547d0, 
	0x95edf29e, 0x175a1c6b, 0xce6f7ff8, 0x2a197ce6, 0x70f32f5f, 0xf1b476f3, 
	0x8ba44c3a, 0x17c2cb29, 0x98f00bde, 0xeff7d412, 0xd5d706d8, 0xd8398ae6, 
	0xf6553676, 0x7d5e1178, 0xfc80f417, 0xefe9702a, 0x65e09d7c, 0x7826ef16, 
	0x41ad91e9, 0x7fdfcfbc, 0xd73572f8, 0xe9378b0f, 0x10bf7a6e, 0xbe300de3, 
	0x93c252a4, 0x0cae2bc7, 0x9c1abc3b, 0xd70df577, 0x6e00d36c, 0x75fbffab, 
	0xfcf7c73f, 0xf76d6aae, 0x42ce706a, 0x88a4ef9c, 0xbc308467, 0xcb1be3c0, 
	0x62b89635, 0x57cf2a63, 0x76df0df0, 0x7f0b97b4, 0xf1167892, 0x7f5fbcb0, 
	0x200fbf04, 0xaa931de3, 0xf9967eb9, 0x387b8c3c, 0x0ef1121e, 0x6ac6df80, 
	0x62774f1e, 0x539e025c, 0x9fd12e31, 0x5f9577d2, 0x02f3cf68, 0xe6cdd6fc, 
	0x20cafaf1, 0x5e5c578f, 0x9555e3cd, 0x73dffea2, 0xb8c71e83, 0x1652e794, 
	0xb9ef4547, 0xb0278f59, 0x13c594bd, 0xe78a76d0, 0x7cf35796, 0xeb1a6b92, 
	0x78a9bf44, 0xd007b49d, 0xa0fb84d1, 0x534f31cf, 0xcbe7a4d5, 0xafd1caf7, 
	0xf4925cae, 0xab9da9b3, 0x78276499, 0x8fc85afa, 0x8fc95f86, 0x40e634d6, 
	0x69fc9b3f, 0x5efbbb68, 0xe4e1f9b5, 0xc2bad36f, 0x47f1106e, 0x8423b497, 
	0x7a055d1f, 0x116cfc9f, 0x225cadf7, 0x47216cfc, 0x4e4ba898, 0x30ba37cf, 
	0xd500f8df, 0x5fc8860f, 0x5637cb4a, 0xf011be61, 0xd446b0b8, 0xbf83559f, 
	0xe7f9fd75, 0xf89e091b, 0x3d06c13e, 0x5cf1db8e, 0x6758e2c8, 0xe79abd30, 
	0xe95c645b, 0x4f1cd992, 0xc9de80ae, 0x274691f3, 0x36ba5fce, 0x0b8a7709, 
	0xf993ac96, 0xaacf9e49, 0x1bc24aba, 0x5a9602f0, 0x3e3b62e5, 0xb736be64, 
	0xbf8255ef, 0xfd906b8c, 0xcc376d06, 0x5f576d83, 0x0fc562af, 0xeb8121e1, 
	0x390b780b, 0xc44eb25d, 0x7b79ea3b, 0xd3973561, 0xb8095755, 0x2e553c0b, 
	0xe645e3b6, 0xde454b3d, 0x5cc834b3, 0xe5489f98, 0xdf0b993d, 0x4334698b, 
	0x63413ebc, 0x00bf7c2e, 0xf796c2f9, 0x4ebc7934, 0x116f1fe6, 0xf1825c7c, 
	0x12ffa04c, 0xfdc27bcc, 0xcc959f7f, 0x1f91c67b, 0xb33c454b, 0xe133c454, 
	0x6678c2ea, 0xcf1e12d5, 0x33c62bc4, 0x1b998a8b, 0x3cf899e3, 0x42873de5, 
	0xfa678c1e, 0x715feb42, 0x122dd65a, 0xce3fb079, 0x122c78e2, 0xc7e03079, 
	0xe163cc4e, 0xde61797a, 0xd728fc8f, 0xe2f84f55, 0x1f5a0f08, 0x0bd2bcf8, 
	0x36b846f8, 0xc72ff8c9, 0x3587dcab, 0xfb8d69ff, 0x86157dca, 0xb7dc53d6, 
	0xc23435c0, 0xbba10df3, 0x7cc21f12, 0xff9f8c4f, 0x7fccc92c, 0xca3ddece, 
	0xdbfa2ce5, 0xf8334125, 0xfe5b06b5, 0x4c39e833, 0x3d2bcff9, 0x527fca5e, 
	0xcfd5573b, 0xfad1b626, 0xeff58b6f, 0x6265fc4c, 0xf656ac39, 0x2f12a275, 
	0xf9ff2b1d, 0x5ecd80f4, 0xb76399cb, 0xbe848ad7, 0x9173f604, 0xda5a7cbe, 
	0x9bafe357, 0xc9bcff99, 0xefcff983, 0x7df8f0d4, 0xa9ff3255, 0xa83df1bb, 
	0xfe386a5b, 0xac5c844a, 0x4dfef112, 0x55ef1c35, 0xf32ddf22, 0xd27f8b9f, 
	0xc3cff943, 0x1eff5e42, 0x94a9e0f5, 0xf7ec295e, 0x259ff2db, 0x207cff98, 
	0x292cff95, 0xff293bd7, 0xbf53ec39, 0xfcf15bf6, 0x7fcff396, 0xf3fe6316, 
	0xcff9d8d8, 0x7693abb7, 0xa73fe501, 0x209ff324, 0xadbe61b7, 0xd2af9cb5, 
	0xe03bbfe3, 0x973874fe, 0x307d69f7, 0x63113df9, 0x917038ec, 0xd3fb0388, 
	0x6b3bc0e2, 0xafd33e39, 0xe32c0e32, 0x7d8253bf, 0xbf507afb, 0xcc4fd6af, 
	0xfe7a8ede, 0xe5ef7bbb, 0x7b1ba1f9, 0x0d9e23b6, 0xa1eef3c6, 0xa58f3d81, 
	0x738dfbf4, 0x7ea5fef9, 0xd0bdfa96, 0x9c8eeed5, 0x21f9fa10, 0x78e3f3ac, 
	0xdc2a7559, 0xd169728a, 0x0019dd11, 0x88e2bdbe, 0x7f71843e, 0xa558bf99, 
	0xf9da183b, 0xbed11a28, 0xef70015c, 0xe3d29138, 0xb1160c57, 0x57c7b076, 
	0xb431091c, 0x001ec93b, 0x3dbefbb8, 0x3b03ade4, 0xba3150b5, 0x935ac176, 
	0x873ccb67, 0x697b47e1, 0xae078ff2, 0x98aec051, 0x05e242f6, 0xa3be4e36, 
	0xc01cf308, 0xe64145cf, 0xcd073cc6, 0x0c73cd63, 0x910cdc81, 0x0bdf14dc, 
	0x05efb662, 0xf5e21cad, 0x662fcb22, 0x523b941e, 0xfd0a56ee, 0x706d18d4, 
	0x84ac3ca3, 0x74cdb475, 0xbe0713df, 0xfef2892a, 0xbbf5a1e5, 0x67284373, 
	0x10497f79, 0x5967c3f8, 0xe0d4247f, 0x713a23ed, 0xee8b3cf3, 0x86cb3cc6, 
	0x6366b325, 0x3d51a6fc, 0x72bd7c4c, 0xf001f618, 0xa1b1a15a, 0xe713a3c0, 
	0x735da45b, 0x4fce5cd7, 0x1ff9aed2, 0x6bb02773, 0x12199ed0, 0x8ccb0df6, 
	0x5175c88b, 0x571c230f, 0x423c8b56, 0xaff5c1b9, 0xbfffcb90, 0x5391dfe8, 
	0x52d4fdd9, 0x354b4721, 0xf4724dc3, 0x51c9b9d4, 0xe202fef9, 0xb9f80027, 
	0x8943c85b, 0x9cd5df9f, 0x4ec07e1f, 0x8b36fcfa, 0xd3ccef9d, 0xad3d782b, 
	0x0a15891e, 0x9f9f143b, 0x2ed03ac6, 0xf12dde2a, 0x7ae2f1c0, 0x45b7592e, 
	0x1d556b75, 0xd3a60f12, 0x6eea976e, 0x2cbd176c, 0xf103a6db, 0xd93a7e86, 
	0xe7c9dda9, 0xfb539f08, 0xbc565c5a, 0x2868de51, 0x029d6ed3, 0x9a7b60eb, 
	0xbfb0b866, 0x3c21d604, 0xd8a8b5f6, 0x50eb0b9f, 0x25e6097e, 0x3db776bb, 
	0x4e7ae46f, 0xdb5da5b4, 0x9037f021, 0xf30ed766, 0xd17bc4b6, 0xa8bee2cb, 
	0x8b74f5a3, 0xf5937ae7, 0x27a6e776, 0x22f159fe, 0x713d49df, 0xf49db865, 
	0x73678fc4, 0x86fab13d, 0x84f4d217, 0xf2627a4e, 0xa27aec9c, 0x13c88e72, 
	0x3184f526, 0x3b089ebe, 0x4d24bc78, 0xe1cd544f, 0xcd7e997c, 0x0dac13d4, 
	0xc4f415e9, 0x48dbf9ae, 0x2f72dc4f, 0x770a4fb7, 0xf89e92e5, 0x40be95b2, 
	0x8fdc1a8f, 0x7afbdfd6, 0x7c6f4a61, 0x3dfb8f30, 0x3619378b, 0x13f4b0bf, 
	0x5eb90bf7, 0x1c2fc899, 0xea5e7214, 0xf0bf7483, 0x2e5c79dd, 0xfcf2586e, 
	0x7afe6b6c, 0x99513f22, 0x6ca79767, 0x9fffcf0e, 0x73d2bf07, 0xcba74e52, 
	0xd067f453, 0xe902bd9f, 0xbf4ce6f4, 0x70eb0aa6, 0x2dbd6337, 0xb47ef9f8, 
	0xced88ccb, 0x6f9fab51, 0x7e7e154e, 0x788b9134, 0x39cc770d, 0xcbfe7e4c, 
	0x2e29723b, 0x9f217df2, 0x097bb786, 0xc3dc5f9f, 0x974f45e5, 0x81099f05, 
	0xc03b4ccf, 0xcc6c8ee1, 0x810c0762, 0x66ca101d, 0x7e3f7007, 0xf2a03b2c, 
	0xe10f3359, 0x17ebf84d, 0x617ac0f6, 0xf0a5d40f, 0x0a1eeb2f, 0x2b61eeb0, 
	0xf635f963, 0x2fc987ba, 0x89a9aec5, 0xf8071d8e, 0x8f6e3cf6, 0xd398bf2e, 
	0x0f6de827, 0x0a966fd6, 0x3af52e3d, 0xf730d1e9, 0xec7eb4b7, 0x575f4837, 
	0xb21fb945, 0xf49854fc, 0x03f61579, 0x7505543d, 0xdce7d70f, 0x5b9c6b4f, 
	0x110de0d6, 0x3db87b3f, 0x9ed07ba1, 0xae555468, 0x781fabc7, 0xd29c272b, 
	0x270744e3, 0x4bef1e85, 0x8ba495d1, 0xbe71e627, 0x74e1ae1d, 0xede949f1, 
	0x5cece889, 0x577fecf3, 0x679d9ff3, 0x2d3c910f, 0x3ecf2b1e, 0x3fb3cf6c, 
	0x7ff7635c, 0x2ede844a, 0xf48b7b01, 0xb3ccb0f6, 0x31b7af8f, 0xacfb81be, 
	0xbee5c69c, 0x433b27cc, 0x73a5167e, 0xab93e5a6, 0xc9f363ff, 0xe981fa63, 
	0x3c43f4f9, 0x8d62fe9f, 0xfa560ebd, 0x4a4fd281, 0x788783fa, 0x384c7d3e, 
	0xd415d7a7, 0x7782baf2, 0x255ce0d3, 0xfe7202f2, 0x9a07e02a, 0x15d656bf, 
	0x37a471e8, 0x7f68ab94, 0xe54e2d57, 0x557de8c9, 0x967ca0cd, 0xbda5b3b4, 
	0x1806e347, 0x9df84fbb, 0xc7d87e49, 0x1bee3c78, 0xbd241f9c, 0x0a6ae25b, 
	0x75e92fda, 0x901ed20b, 0xbda4b2f9, 0xae6df220, 0x826ec10b, 0x798b4571, 
	0xfda26edc, 0x347838d1, 0x84f5c356, 0x5b8f0767, 0x107ddc7d, 0x7c7de91c, 
	0x5130df5e, 0x888a7efc, 0xf3533fdf, 0xffbf1d1f, 0x4f98359f, 0x29fbf193, 
	0xfe7cc84f, 0xe5b1aaff, 0x96de67f3, 0x295f7e35, 0x6352b0e8, 0x5c603e9c, 
	0xf1f81cf0, 0x03e7cb93, 0xe3e57c67, 0x3e7ff3e7, 0x17f3e78f, 0xb8e7a4ff, 
	0xf9c5bef8, 0xf8c7f1e5, 0x818bd3be, 0xac9fda61, 0x3e3ca0e7, 0xb5bba39c, 
	0xe7f5c151, 0x4efec7e0, 0x50e8f88b, 0xd2d4bc5a, 0x7e870676, 0xfa465b11, 
	0xfb3d1be6, 0x1651eb32, 0xc3eeb555, 0x131c67ef, 0xff63327a, 0x8ca5d513, 
	0x90b05f09, 0xe1e25eb0, 0x6e20944b, 0x77c38da4, 0xe0844b4e, 0xd9d9ebfb, 
	0xcfc96ff7, 0x33f35b94, 0x5a3befab, 0x8a9c133e, 0x2b5c449b, 0x79699f63, 
	0xf27c8ce5, 0x8b04fb98, 0xd360e91c, 0xbd9f7ca5, 0x0e92ce1c, 0x51c61e40, 
	0x36d656de, 0x7b8f9c28, 0x7d6fc93b, 0x07b0ac27, 0xd6217e2c, 0x75fa8bb3, 
	0xc37d29fc, 0x725ecf5e, 0x3b64b4c3, 0xd5acf28c, 0x96dbd9b1, 0x553a1f8a, 
	0x28fc6363, 0xfd37b3d5, 0xcbe74bd4, 0xa5fecf5e, 0x259e59db, 0xbf6d0c9f, 
	0x239f1db5, 0x0799d9eb, 0xac7ec5e3, 0x71a4ae83, 0x942f94e5, 0xf519def5, 
	0x7af646ec, 0x67ac84f6, 0xb3d5b3ef, 0x9eb7ce07, 0x5ecc743d, 0xf5909e77, 
	0xbbe9fbec, 0x67cc0159, 0x5760be63, 0x424ff7da, 0x5d2ea2d5, 0xd00fb3d6, 
	0xfb522777, 0x3d30eb80, 0xc9f3a217, 0x88f9aebc, 0xf69b2ead, 0xff399c3b, 
	0x24a3dbc8, 0xce5ca49f, 0x1fa013b0, 0x655392e5, 0x1abcca37, 0x5aa19f07, 
	0x6b409bed, 0x5b9be780, 0x7a7d51a7, 0xd3ebc620, 0x78d3cdb5, 0x9b537a7d, 
	0x0daf9adf, 0xa46e5e20, 0xfbd6e5fb, 0xb591cff0, 0xd64f5d3e, 0xf5ac3ba7, 
	0x7d7a5ae9, 0x3f7f38ba, 0x01d617f2, 0x64702e0c, 0xbe4f4fad, 0xeaf1f65f, 
	0x3b82942b, 0x335e60e7, 0xf2236f59, 0x570fe09a, 0x1474ff20, 0xf4873ddc, 
	0xf8afac81, 0xf201f584, 0x9f796a83, 0xb325e243, 0xd0b982be, 0x43980cec, 
	0xd5497a36, 0x7c3a7057, 0xafaf0e6d, 0x8d23d0b0, 0x7375d24b, 0xb29e1db5, 
	0x19e102ae, 0xec09d14d, 0xb036e0ef, 0xf2334a83, 0x6fa63a0a, 0x694a7693, 
	0x88fffd66, 0x1a50af35, 0xcf6add0c, 0x4addd42b, 0x7d2e8579, 0xb7e005c3, 
	0xbb438c2f, 0x0fb7ead1, 0xfff5e41d, 0x60f4efe1, 0x3e1aba8d, 0x8060f188, 
	0xf7e116df, 0x9078fcd9, 0xdf281d6f, 0xf6ec9a8a, 0x1fffaca4, 0x5efed379, 
	0xddae6855, 0xf6162bde, 0x38c6b15e, 0xeb29bcbf, 0x775fc7a4, 0x5f1eccc4, 
	0x9853c8cb, 0xe136be32, 0xce9cb839, 0x67a88738, 0x0ff76539, 0x5dbb5cd8, 
	0x1bd7199c, 0x8c73b73d, 0x90127f51, 0x9f3127f5, 0xdb1eb9da, 0x9764fea2, 
	0x5ac4febd, 0xccd7826f, 0x49d6137a, 0x5579cbdf, 0x7597be23, 0xeb2fc52a, 
	0x44e35ab7, 0xf7c9c3c5, 0xb02435f1, 0xac88f2e2, 0x7f51713f, 0x9f8db25e, 
	0x9fd54b34, 0x17927ac8, 0x2324f5ed, 0x164e4223, 0x2bfbc25d, 0xf96de12f, 
	0xd13cdbfd, 0x4fcf121e, 0xce927750, 0x763b7f17, 0x366e706c, 0x8755363b, 
	0xea973852, 0x5ec9de50, 0x2fa19287, 0x287591de, 0x58cdd3e3, 0xebc2ce76, 
	0xfac3ec37, 0xf48e6d34, 0x7cae3faf, 0x3c77305e, 0xf8193cf9, 0x210bfc80, 
	0xb3f4279f, 0x7c6c6743, 0x3c9a6574, 0x30e390c8, 0x8fb3d45e, 0x191a7f1b, 
	0x320f2ece, 0x5d64f6fd, 0xfdf3b8d8, 0x7857d0ed, 0xc0dafa02, 0xb6f6abe9, 
	0xd2b2f5ac, 0xd1f94e9f, 0x3d1f91b7, 0xfbe5f9d1, 0xbc89374c, 0xf7c8a95e, 
	0x4bfbe297, 0xd50fff70, 0x9e25fdf2, 0xf9122fef, 0x779122fe, 0x3b7a7ca7, 
	0x7c888bd6, 0xa97f78bf, 0xcaec18b8, 0x0e7cfe22, 0x77ae21d5, 0x8f0029b3, 
	0xfbe530e1, 0xe9cd9a2f, 0x510fc329, 0x6cd4f153, 0xcf4f8ff9, 0x53f264fb, 
	0x96f88a37, 0xbabf1e6f, 0xc41e786a, 0xee19e605, 0x5de223c3, 0x2aef111e, 
	0x8bcf6b5e, 0xb666ed14, 0x9eabf9f7, 0xa48bcb4b, 0x07941df2, 0xeedfbd29, 
	0x55fccbdf, 0x9e7b12c9, 0xabd7d02b, 0x5322f35a, 0x1ef29d35, 0x32007bf2, 
	0x22f321ef, 0x991abdf2, 0x13799107, 0x794c3759, 0xac8bcc2f, 0x8a45e7b5, 
	0xbedbd776, 0x5cf55027, 0xe6445e5a, 0xf9ec5a3b, 0xedfbd2b0, 0x25928771, 
	0xa498fcf6, 0xcf9162a7, 0xc79aaf7f, 0xef938a61, 0x57c231ef, 0x78e3a891, 
	0x25f3e44f, 0x5795a93d, 0x90fed277, 0xf980deae, 0x17cf06bd, 0x27c7bda6, 
	0x7fd24be9, 0x827bfbc6, 0xc3870ade, 0xbcc38ea2, 0x514f2d2c, 0x4dece42c, 
	0x147f775b, 0xdfaccbfb, 0xc2bfb363, 0xafedd9f7, 0xfd84fbd6, 0x3b67b4f5, 
	0xb6d05fda, 0xf7d3d7e5, 0xf5dd3a13, 0xd99ff50c, 0xfbc4e775, 0x6c7b5f3d, 
	0x1dbb3cc6, 0x663db633, 0xe2f216ee, 0xeb37b8cd, 0x3f65e7ba, 0xd5cef3e9, 
	0xdd609a7e, 0x67a2f209, 0x79327de6, 0xbe172916, 0x9ebeec26, 0x5dee9cb9, 
	0x901f20e5, 0x3e42bcaf, 0x287c8578, 0xfe79f4e7, 0xe7f8ea76, 0x57ef4b1d, 
	0x8053db7f, 0xbcfbd257, 0x1eab24ce, 0xa7f5e8fa, 0x1e91e60b, 0x629fd6b2, 
	0xbe57aabc, 0xde70b1b7, 0xc673b347, 0xe10c6f3f, 0xe79c6e3c, 0xaf3f5abf, 
	0x3f4d9799, 0xef8f385f, 0x5969ea5b, 0xea2a56c7, 0xe6cf4ed8, 0xaa9a5a74, 
	0xba40eb63, 0xeff214ac, 0x952bacb4, 0xafb0eff2, 0x316fe493, 0xf62d9faf, 
	0x61543872, 0xdbb71b1d, 0x14941e49, 0xeff4ee1b, 0xd8ead878, 0x245c854e, 
	0xff294cff, 0x9ebc3dc2, 0xe5df6cc7, 0x6c7528f8, 0xef2ad87a, 0xfea1824a, 
	0x5fb37f34, 0x7239b1d4, 0x8d8eb173, 0xfd9e41b7, 0x3bc90760, 0x9e5da776, 
	0xbcb8390d, 0x7bdc8beb, 0xbb7eb667, 0x75be729d, 0x65e7fb6d, 0xd66467cf, 
	0x1f644db5, 0x2bde7c71, 0xe2c59df2, 0xf162eefd, 0x67f7981d, 0x4aa3eddb, 
	0x7c491f61, 0xd4b31e12, 0xe1fc4a43, 0x491f68f3, 0x6e4cf97c, 0x217cc91f, 
	0xbcf111e6, 0x07984155, 0x3ff58f01, 0x961cef98, 0x1bba9cf5, 0xdf3139eb, 
	0xa367ad69, 0xffcda07a, 0xf1e47295, 0x7d6472ac, 0xb4911f9a, 0x9af2d2f7, 
	0x1e786abb, 0xf8f3d7f2, 0xbdec3cf5, 0xe4b36fcf, 0x77ac55bb, 0xac207111, 
	0xeff8f977, 0x2f34bd8d, 0xf2637bdb, 0x828eb17d, 0x9c7cb857, 0xf3257e20, 
	0xac71e95e, 0xacb1e7a7, 0xbec67176, 0x797bf23f, 0x7e879fbf, 0x797bfa5e, 
	0x26394b2f, 0xf593cfde, 0xaea24567, 0xece3eb18, 0x6e6253df, 0x90d29efa, 
	0x73129efc, 0x0694f7e3, 0xa1d1a767, 0x9dcb8fa8, 0x4bbe5d97, 0xcda9517b, 
	0x3e3c7fee, 0x1ff9e3fb, 0xeececf8f, 0xa9dba47f, 0xb7c7b303, 0x3fffb153, 
	0xbf1d4ec7, 0xceb3269e, 0x0fc78176, 0x0ad48af8, 0x6ceb087b, 0x6ceaa477, 
	0xaf66d797, 0xad54fdb3, 0xab4dcba8, 0x19df95b3, 0xcfcb505a, 0xf3e236fb, 
	0x36cea594, 0x13433bed, 0x9dbed9d5, 0xceb20f46, 0xd3f37cf6, 0x5ecdab9f, 
	0xffe72ca7, 0x99e9f9c8, 0x07933b3f, 0x6d63ffeb, 0x9c84f8f6, 0x3fa7c53f, 
	0xd73d3e23, 0xa9ffdfbc, 0xf935f2e1, 0xf258ef1e, 0xa4390275, 0x96a97c14, 
	0x726933e2, 0x31cfe496, 0x0967cefa, 0x43929bae, 0xfde96b9b, 0x05e209da, 
	0x71e97cf2, 0x47deb183, 0xf7d37dc7, 0xffbec563, 0x263beb20, 0x67284792, 
	0xdf16fbac, 0xee0a57e7, 0xf13d25ae, 0x4d09e830, 0xfb04e7bc, 0x976b54df, 
	0x788b6f47, 0x7f6fcc81, 0xb4b6f962, 0x355547ef, 0xcf6c5c1f, 0xe02fe9b7, 
	0xfe7107df, 0x8f13e579, 0x7ff3a36c, 0xfd47efa4, 0x6f9ed6a6, 0x9b7cc80b, 
	0xf2547efc, 0xf29d1abd, 0x1b7ca912, 0xe464e3cf, 0xaf8fd0db, 0x885b7cc1, 
	0xefa9c2f2, 0xfa335536, 0xdbe60cbe, 0x407de9fa, 0xcc425e7b, 0x7e1ef32f, 
	0xa70db7cc, 0x80f8c9c6, 0xe5337eb7, 0xbf32fc39, 0xbe5135d1, 0x6f96cdad, 
	0x5b7ccbf3, 0xedbe7a57, 0xcdbe5b26, 0x5d6df32f, 0x66df351f, 0xb7cf6a5e, 
	0x07bff1b1, 0xfb824605, 0x1efa47d8, 0x6f9227d4, 0xa3889dfb, 0xcb6f944c, 
	0x1f581f7c, 0x97e55f37, 0xf4aeaaf9, 0xe3c7157c, 0x7fb96a1f, 0x79e7c164, 
	0x9c38abe6, 0x3a0b1f61, 0xfbc39cf6, 0xcf9e09b4, 0xda7deb18, 0x78cf9c8f, 
	0x61fdf927, 0x2538cf9e, 0x43cc19f3, 0x6c889aed, 0x71467cf3, 0x9f3d9db2, 
	0xb217f321, 0xd17dfb9e, 0xcedbef96, 0x3be784bd, 0x58a33e64, 0x9f39cfb4, 
	0x595b8761, 0xac7cd2e3, 0xacf29af3, 0x41d58931, 0xddbfd85b, 0x2eda1c6b, 
	0x46eedfe0, 0x8fd5d687, 0x76de75ef, 0xda09e300, 0x7de20dd3, 0xfb83c34e, 
	0x91bcdd0f, 0xfa94dfde, 0x942b9174, 0xb191a3b7, 0x6f85978b, 0x35c1744f, 
	0x7be2a6c8, 0x0eaf17ad, 0x841b375f, 0x0ecec5fe, 0x0d09e795, 0xe5261fc1, 
	0xca6927e7, 0x201f7097, 0x7f8c72bf, 0xa8adf6a0, 0x0e719127, 0x419ddd53, 
	0xf8721cfc, 0x4a57a83d, 0x8c3a1fdf, 0x9e6964f6, 0x277f8151, 0x4d55b2ab, 
	0x29fc4dca, 0xfc1c3a73, 0x4a18cdef, 0xcabf40d8, 0xaafd10f8, 0xf6fd2e99, 
	0xfbd45cee, 0x63b0a8c6, 0xc1ef74ce, 0xf48ebcfb, 0x76e7ceff, 0xefc3849f, 
	0xde4a7b45, 0x38e72531, 0x5e83ff8a, 0x45333fd4, 0x774ae75d, 0x7c5c4547, 
	0x0fbf0af7, 0xae7cf0fd, 0x5555bbb7, 0x3cfc09c6, 0x5ff8604e, 0x0f147c07, 
	0x7bfa7ee9, 0x2eac45a7, 0x27b18278, 0x41f7cbe7, 0x3f6fdd45, 0x1d64356b, 
	0x1d54b1e8, 0xf1bf6369, 0xd3ddfe20, 0xbaf3e7c7, 0x7db7929d, 0xea5ea3cf, 
	0x1261a27e, 0xfb16efde, 0xa8be6d7d, 0xa8dbbd83, 0x758aefc0, 0x6b3b7257, 
	0xb76e7cdf, 0x05fef58e, 0x8520af9d, 0xf1d6afc7, 0xcf98ec73, 0xac6e9dfd, 
	0xb07b037b, 0x2f6dd85b, 0x93baf98b, 0xa7d8107e, 0x1907e843, 0xc83f720f, 
	0x41fb9078, 0x19537dfc, 0x334d76f7, 0x2977f863, 0x2eb2d62a, 0x1f2119ef, 
	0x0592ffa1, 0xe48cbde2, 0x8e3c177b, 0xe343aa9d, 0xe7eeec71, 0x1769f192, 
	0x7b87adc5, 0xe9117be9, 0x87b85def, 0xb77db55f, 0xcbf7d656, 0x7b963538, 
	0x22ba1c62, 0x92ed0e2d, 0x48ac5def, 0x7117c7ab, 0x44e7eee8, 0xd1fa94db, 
	0xdcefcf3c, 0xea262532, 0xb73bf132, 0xe7e3a9bf, 0xbde24356, 0x2dfd50d3, 
	0xbd099e34, 0xff1be453, 0xae12b73b, 0x2780ba8d, 0xaeb89b8f, 0x3e72f802, 
	0xbb5e3825, 0x524f6520, 0x677c453c, 0x4e857823, 0x80f59370, 0xed57bbf2, 
	0xfc7d71f8, 0x9b63469e, 0xf4943ded, 0x151772f7, 0xd0b7bff2, 0x8f41e382, 
	0xde001494, 0xdfddb801, 0x07c7be6f, 0x25bc1674, 0x922f94f8, 0x44cd9759, 
	0x93acb55d, 0x3f72a29f, 0xcbd1d646, 0x4f90a6f7, 0xbe704ef2, 0xc6fbbac1, 
	0xc3e46616, 0xbd0417f8, 0x740c9d4c, 0x8fe086fe, 0x2187e43e, 0xb79853e2, 
	0xd1f0b15f, 0x943622f2, 0x37c531b3, 0x46ba48d7, 0x09f6127f, 0x73a39526, 
	0xcc37d211, 0xa715ed07, 0x84865c40, 0x657e897f, 0xf203656b, 0xf4df8a4b, 
	0xf973b697, 0x87e51471, 0xc15ff3ac, 0x839180d4, 0xd79db372, 0x0af9c389, 
	0x04f3a51e, 0xaea2a246, 0xd833ef1c, 0x06efdc1f, 0x61ef85f9, 0xa1c2b15c, 
	0x34bd03b6, 0x8fca7e8e, 0xfdfe45fa, 0x27ad55bd, 0xd1fdc26e, 0xeb122ffe, 
	0xfcfea987, 0x7e7f5827, 0xfe6dcaf2, 0x8add805a, 0x8102c7df, 0x36bee668, 
	0x7fc85e21, 0x7ee41e37, 0x06bbf82e, 0xabf047be, 0xb01718f9, 0x459789c8, 
	0xb5ffc25c, 0xf47f293d, 0xbaff210d, 0x2ddc1f85, 0xcf4fe0fc, 0xc5f07e97, 
	0x74d38c71, 0x5bb83f0b, 0xc5dda3f8, 0x67be2f30, 0x37bfc4d6, 0xdefc578c, 
	0xe96a9970, 0x0cfd6607, 0x70fe83ce, 0xe81543eb, 0x6eb7d677, 0xf1787f24, 
	0x91dfe826, 0x119f5f92, 0x3efe98f4, 0x7187bd06, 0x7197bc4c, 0x6eefb534, 
	0xd4fcef11, 0xca87ee7c, 0x2079ab7d, 0xd53e809f, 0xd41ebb2d, 0xe49fbc7c, 
	0x03e017b5, 0xe69ddf74, 0x36b9d32f, 0xfff5cea7, 0x6eca1600, 0x000000fb, 
	0x0002ffe1, 0x7dcd9c78, 0xd5547c0d, 0xc99eefb5, 0x33339999, 0x77c99e21, 
	0xc90c84d2, 0x96bd0180, 0xc40984af, 0x83109070, 0x87d68a56, 0xa061e5b4, 
	0xafda96dc, 0xf7852d54, 0x184cf3ec, 0x063881f2, 0xedab0444, 0x3ec55e08, 
	0x62d68deb, 0xf79e3fb8, 0xf5a168a8, 0x59f5a2f9, 0x03af7ada, 0x6a6d8d2a, 
	0x786d57a9, 0xb5adf4b5, 0xe673def6, 0x3e10999c, 0x7efcbdb4, 0x3e73dc72, 
	0xaf6bdef6, 0xfd7fd6bd, 0x449b5ef7, 0x73175195, 0xebc09633, 0xcb82c64e, 
	0x05697b99, 0x3f857f63, 0xa632b7dd, 0xc7503e76, 0xed2b18ca, 0x6573f35c, 
	0xbc53632d, 0x9f9be3a9, 0x89426c63, 0xdfed97f9, 0xdd646c61, 0x61e3272d, 
	0x3319f2c6, 0xdfcabef3, 0x4bde1bbb, 0xfb98fbd4, 0x46aab82e, 0x9fc6bf5d, 
	0xdf0f5edb, 0x5b538c57, 0xf477e20f, 0xe20896ff, 0xbbd18c77, 0xd1fc1947, 
	0x66ee264f, 0x9620722c, 0xe7861eef, 0xf73ccdbb, 0xb99dfc06, 0x27b56199, 
	0xa76d1502, 0x869ff9e7, 0xb1dd4c4d, 0x3317319e, 0x8b0d505c, 0xdd6feb14, 
	0xacd8cade, 0x5babaeb8, 0x14d31ae0, 0xd59bea15, 0xf0aba1da, 0x76cbacee, 
	0x9e88b4fe, 0x59f05dd7, 0x7b9244a6, 0xd137f418, 0xc2c0da96, 0x1fb23d56, 
	0x6b8cf2aa, 0xcf6836e3, 0xb727fd94, 0x2a9fa124, 0x037debcb, 0xbebaadda, 
	0x9df942a8, 0x27698c99, 0x62a625b0, 0xd7dfa51c, 0x1a6a0eb1, 0x6f2e4995, 
	0x1e50bb42, 0x54fd48ff, 0xab283e8c, 0xc29fdfcc, 0xfc6541b2, 0x6267ca3e, 
	0xc06751be, 0x4bdf13ef, 0x661d741d, 0xf90eec2c, 0xbe782ed9, 0x465a6153, 
	0xdc7927bf, 0x77e884ee, 0x5cbe3187, 0x463e19a1, 0xe19854f2, 0xc615f787, 
	0x6a7b4236, 0x9be29806, 0xc7ef98c4, 0xd42140ae, 0x4ba1fbeb, 0xec674c0d, 
	0xee5e1baa, 0xf63156d1, 0x552e8ea9, 0xd4d8cc5b, 0x51ea5e2b, 0xc7af5ca1, 
	0xf9ca1554, 0x37a7b13d, 0xbbefa31e, 0x9abdf062, 0x83413651, 0x7780ae76, 
	0x398f20fd, 0x2865d89b, 0xaeeaa637, 0xeafdf83e, 0x3a858c59, 0xd9fcf319, 
	0x3095766f, 0xf6e403b6, 0x12072809, 0x671890fa, 0x02c49a05, 0x3c50e0fa, 
	0xc5897249, 0xa430f432, 0xde1b98b9, 0x55e01943, 0x1e59848d, 0x28ddd7e8, 
	0x6becceff, 0x27fd3ebe, 0x3f58c379, 0x9fea077c, 0xfa2acc53, 0x5ce62f41, 
	0xa9b9f1d5, 0x3c732830, 0x920ecadd, 0x1f75718f, 0xabc1a7c8, 0x82df1b18, 
	0x7c7fa3eb, 0xd787d5d6, 0xbc10fe19, 0xef067b37, 0xcf38644f, 0x29fd05dd, 
	0xfb54d5bd, 0x0c9b190a, 0xf7e087bf, 0x239062ba, 0x04f223b4, 0xfcc2940b, 
	0xafcf9528, 0x266f4931, 0xfb0be894, 0x335fa08a, 0xee49ff78, 0x3bccfcf0, 
	0xf28bd97f, 0xa5fc7c6c, 0xecaf945e, 0xd6e55d67, 0x73de384d, 0xdb7d2516, 
	0x1dc5bdb1, 0xbdb15bfd, 0x45df3157, 0x9fbb61cf, 0x77edb93f, 0x9df14720, 
	0xae55fcb2, 0xf7ad3bbc, 0xabf905df, 0x332dff50, 0x5e82ee70, 0x77cae8af, 
	0xd812bb43, 0x56db904e, 0x7f104f90, 0xfbefe2af, 0xbd7d606f, 0xb9feee30, 
	0xd05e9ec6, 0xc665ff23, 0xff4bd41e, 0x1fafac8d, 0x9fe88aca, 0xd17592b7, 
	0xbbac9573, 0x92bac517, 0xb8d0096d, 0xbbfc1e99, 0x7bddc852, 0xe3e16d8a, 
	0x77f8a869, 0xc05e9964, 0x9417bacb, 0x160a2595, 0x63e1b288, 0x5bcac631, 
	0x1a49fee0, 0x07ef157f, 0xddb88f87, 0xc7fd9130, 0xbd06efe5, 0xe23c9357, 
	0x65fd4373, 0xf51c5f50, 0x1ba77864, 0x0f50b5cb, 0x97252796, 0x80ae58ab, 
	0x1becb07a, 0xf2c2e23e, 0xcb07a844, 0x7a72c955, 0x3d38a61f, 0x8ddf095f, 
	0xa23f63f7, 0xf852d85b, 0xd0ca3061, 0x414f78ce, 0x5aca0879, 0xcb239513, 
	0xabb017d6, 0x4a287ca1, 0x6c144c8d, 0xfc13e5e0, 0xc24faef9, 0xfd87bfff, 
	0xc25ee780, 0x39e89a27, 0x1e5171ff, 0xb2e5efe2, 0x7d910f33, 0x97db9a79, 
	0x6e4f0fce, 0x97db6709, 0xcce335ff, 0x61c24bec, 0x66eec85f, 0xfef817da, 
	0xffd0bdf6, 0x26fbca0f, 0xd99d84b8, 0x6576fe79, 0xdb9fbc24, 0xf1b7687f, 
	0xec6ede05, 0xc3db79df, 0x0f6bc7f0, 0x05f4133d, 0x56349f64, 0xc23ea1a2, 
	0x9917683b, 0x0344bcba, 0x6e75d3bd, 0xc1986f27, 0xbb3413e7, 0xd8137864, 
	0x6128cd1e, 0xcaeb8fd0, 0xe1565741, 0x4652eeef, 0x1f9fca7a, 0x7198d729, 
	0xc6eb7c1d, 0xf0c66621, 0x0d4acbf7, 0xc5e9bcfe, 0x968f85fe, 0x95750bbe, 
	0x6cbbd03c, 0x246f7c1a, 0xeb8ccfd1, 0x0d6fbea1, 0x8b8c38b1, 0x6bd9a677, 
	0x35d65e80, 0xa744b746, 0x3d527a5b, 0xbce170cb, 0xe49fcb28, 0xf0fd03ca, 
	0x7a85d331, 0x820dcf4c, 0x5e79823d, 0x23eb96b8, 0x98b277b6, 0x7a6dfeb7, 
	0xe7bc2f5f, 0x72697612, 0xfe03b715, 0xcd1f7add, 0x3ee07bf3, 0xe4c7ecb3, 
	0x0d5f3916, 0x74cfce17, 0xaa4cf3fd, 0x17bbea5f, 0x99fce3ee, 0xc7e622dc, 
	0xa41f3e74, 0x3c7c6b7d, 0x451da7d4, 0xa7d1573b, 0x45d5b8c2, 0x45d5eff8, 
	0x91da2f66, 0x798870d2, 0x06e47ee1, 0x6de5bf96, 0xd4be56b8, 0x9c6086ab, 
	0xedca43ca, 0xa6ec665f, 0xd91ebce9, 0xb1a3b42e, 0x751e713b, 0x4ff8e1f4, 
	0xcc9479c6, 0x6e714798, 0x1b2e476f, 0xe61f993c, 0x011c167a, 0xdb83307f, 
	0x473fb4a5, 0xa1ff43bd, 0x12e13732, 0x6f78be78, 0xffab7b2e, 0x6845a2f1, 
	0x73bf8f6f, 0x1bd60767, 0x5bf9c6ee, 0xadbf9cee, 0xfb89dea2, 0xad27e64f, 
	0xa8e87f7a, 0x5bd44eb7, 0xd52a9aa7, 0xd717cf0b, 0xe3b7aae7, 0x5ea8d30f, 
	0xbfb7d7ef, 0x6cf77a4e, 0x303fa72c, 0x7bede1df, 0x415bf7f0, 0x617c947f, 
	0x3c616ba7, 0x69debda1, 0x6f6fd93a, 0xe58de400, 0x8617b342, 0x946e4d8b, 
	0xaae399f6, 0xc2e3b03a, 0xaff17afe, 0xeb1eda48, 0xc4ff1c6e, 0xa07d6953, 
	0x277877b2, 0x793041e9, 0x182fec84, 0xbda67779, 0xe58169c5, 0x0f11e4b2, 
	0x1df0fd96, 0x3ef0d7b2, 0xb0a34be9, 0x8bb73aaf, 0x9afed275, 0x911a7b76, 
	0xff9db4f6, 0xe84a789e, 0xb65e52d9, 0x97fdcbfa, 0x2bf81a77, 0xf72144ec, 
	0xf700de5f, 0xb2259167, 0xbe8ba67f, 0x6fee98d3, 0xf8e2571a, 0x93a95f54, 
	0x79c629df, 0x17e6b296, 0xa33faff5, 0x7b444b5d, 0x341fc2a3, 0x4fe8b28a, 
	0xce05e618, 0x4c95c9f7, 0x66e0fb45, 0xf6582543, 0xfc5887d6, 0xc4b1c928, 
	0x0bafdf80, 0x6bb433d7, 0x37a3d323, 0x0db957b1, 0xd73da033, 0x0ce3d5ed, 
	0x06165f7e, 0xb6c8ce49, 0xe5544a27, 0x6ece83ef, 0xd8327b42, 0x5c2ef251, 
	0xfff7778a, 0x99179c5f, 0xcb20e4f6, 0xe82fdff0, 0x7219025b, 0x44cabef0, 
	0xd7fb8f99, 0xaff6ff84, 0xede36c30, 0x00fa936f, 0xd5ca1e7e, 0x24bdd33f, 
	0xde1b9fa7, 0x7f55394c, 0x8e6774de, 0x4642f17f, 0x26771a65, 0xb63f76fc, 
	0x7f1f3d63, 0xabef3f21, 0xe31c1f42, 0x68315fef, 0x9b7f6f1b, 0x0cc187d0, 
	0xa3fe033b, 0xf01649ef, 0x5cded186, 0x757887dd, 0xed9f9de6, 0x06fa7c43, 
	0xda8b7fde, 0xe4fe8b5d, 0x775b9a8d, 0xfb06dda3, 0xf705dbb1, 0xabee2f4b, 
	0xaf860b9b, 0x8ddf8d3d, 0xbac7c43c, 0xa07ee2ee, 0x2f2a45fe, 0x0c25ddfb, 
	0x098367df, 0x0e6bcb05, 0xf7b2f297, 0xf82e33c4, 0x338c505e, 0x02ed1e2b, 
	0x295ecad3, 0x3eff9984, 0xcddbebb4, 0xb83d102e, 0xb0e16317, 0xda87b561, 
	0x1e57df01, 0x29eaf2fd, 0xf55ebcbd, 0xf5ef55a4, 0xebea3db2, 0x9e57e879, 
	0xbc05d2ff, 0x1407fd3d, 0x5d5f1f2c, 0x8debcbc1, 0xe907a88d, 0xaea93dfa, 
	0x1fac0c4b, 0x40b7c310, 0x21fd3eef, 0x3d1743c5, 0x6c5ddfb4, 0xaf43ca64, 
	0x2e51f7a5, 0x9b5f5ef0, 0x7d838d5b, 0x77bed398, 0xfd94144f, 0x375bb403, 
	0xcbb5f3c3, 0xc2fb6377, 0xb37697ee, 0xfebfbc55, 0x14e439c5, 0x26d4ede6, 
	0x1cb97096, 0x727248da, 0xd978eac7, 0xcae5dc33, 0xd76ca768, 0x532f852b, 
	0xdfd7133b, 0xcfc7aae2, 0xc07f43f6, 0x768856be, 0xeabb7a96, 0x0d38a062, 
	0x214f7487, 0xce8aefb4, 0xba6c9d35, 0x3cae5fe5, 0xa002a7a4, 0x9980575f, 
	0x97bf02da, 0x35e0f3fc, 0x2b8f187e, 0x66d9ca87, 0xec2ebeb8, 0xfdcbe56f, 
	0xdbfb632f, 0x03773fc1, 0x143f68ee, 0x0b887166, 0x7c40262a, 0x56b19ab2, 
	0x47a0859d, 0x003975ac, 0xb97fb842, 0xb35c06ca, 0xec603ca1, 0x7972dc41, 
	0x41e54b39, 0x3df8b7f9, 0x94aacbd0, 0x6879221e, 0xc3d6dd46, 0x5d464e38, 
	0xfd57d41f, 0x0625ed5b, 0xdda6b7e5, 0xacf515bd, 0xb7c30555, 0x039fde06, 
	0xd3d43571, 0x1bc0f9de, 0xc385a4ee, 0xaa184f13, 0xde1cb84a, 0x94548107, 
	0x4f1073c0, 0x66b9de5d, 0x39f41047, 0xcae52071, 0x9ae1b883, 0xfebc724f, 
	0xb82f382f, 0x1c53569e, 0xf947f287, 0xed6a6b86, 0x8d585ff2, 0xbdfcb4e5, 
	0x4f50c703, 0xbbf90b37, 0x95335c8a, 0x075f50f7, 0xc0f55777, 0xfe30efb8, 
	0x631f2eeb, 0x337945dd, 0xfbf04dd9, 0x1c02f374, 0x1b299187, 0xecc92a4e, 
	0xe2223eb8, 0x1a6bc27a, 0x67fd0e7f, 0x22fbde06, 0x3c0cafda, 0x34fd0eb8, 
	0x8483a29a, 0xf5050c87, 0x61dc708e, 0x0a8eeb81, 0xfce8779c, 0x5f865d71, 
	0xa17e16e8, 0x0042fc9b, 0xf40e97e2, 0xcb0bac0f, 0x38e92de5, 0xab7f8dc5, 
	0x417ed3c7, 0x28dfdc25, 0xc6e99efd, 0xfc2fc3f8, 0xd5f85faa, 0x7c7b29c4, 
	0xd67e17e2, 0x92ecfd2f, 0x738a7df4, 0xbc823fc8, 0x7f4c5eea, 0x8ca9ec97, 
	0x249da44b, 0xe2b29aff, 0x04f71914, 0xf6581da1, 0xbb272f0f, 0x940bf14a, 
	0xbdcb922b, 0xb48e7199, 0xc22de5b3, 0xa9fb0aae, 0x4a7e171e, 0x469127c4, 
	0x0b974fe1, 0x1eca763f, 0x3c3b48af, 0x5df88979, 0x2f753bc4, 0x1d84f78a, 
	0xa468fa96, 0xad4166ed, 0x212e6edd, 0xa6ecb47d, 0x333f1f53, 0xd2d9b953, 
	0xf7827047, 0x3870bb19, 0xa1770f41, 0x9997fe5e, 0x3f9c8fec, 0xb98fa5ca, 
	0x78dca678, 0xe394fd8e, 0xef5fb6a5, 0xbb472178, 0x2c8f3e55, 0xdd0b7b7b, 
	0x475bdb4f, 0x5d7b65bb, 0xf9a15f45, 0xfdfafb34, 0x92f71775, 0xe70fbe5d, 
	0xc760b5cf, 0x5ff08dd9, 0x4ce3f794, 0xe05f99f1, 0x2fc0bf19, 0xa435c47e, 
	0x0c6b8057, 0xb7a90f1c, 0x39d78fdc, 0xe299dcf0, 0x0e073a99, 0x357f808b, 
	0x47efc7ee, 0xb139fe6d, 0x100f1ec4, 0xdf049b2e, 0x89aeff47, 0x385aa6f7, 
	0xcdeb18bd, 0x09c64fa8, 0x30f75c36, 0x371ed77e, 0x7973a7c4, 0x7b1a67f9, 
	0x57f91710, 0x43c43eb3, 0x0258e792, 0xa93a8bf7, 0xf90bc41d, 0xfe8e984a, 
	0x998cec1f, 0x7b8c00f7, 0x0f9606e9, 0xf28d8938, 0x94394376, 0x71665659, 
	0x1b46fabf, 0xe79059d8, 0x709d956c, 0x956af7f1, 0xc903c05f, 0x18716126, 
	0xd84c5ff7, 0xf7fe1d53, 0x43c3f624, 0x858511e5, 0x375df0e3, 0x631a6dca, 
	0x8dd87a05, 0x0e8b4cf6, 0xab76c74f, 0xa4a67ad1, 0xacff5cb0, 0x123cda17, 
	0xfbf1868f, 0x2323001a, 0x14bf7d6e, 0x7d0fab87, 0x8dd39bd4, 0x7273d6b5, 
	0x7ad1023c, 0x0b48f505, 0xdbd71587, 0xd7299f74, 0x5ca206f1, 0xda9eb858, 
	0x01df8e55, 0x8f282cfd, 0x4555fd92, 0x393da83b, 0x19cccbbe, 0xeb8f7f0a, 
	0x5ded86bd, 0x91fdfd9b, 0xdf3493da, 0x65939c64, 0xce3ee1f7, 0x7c628f33, 
	0xbf1ed7b6, 0x4bf1e01c, 0x6dfdb5f7, 0xbc6d7f56, 0xefd85de3, 0xdb03b642, 
	0x76c959db, 0x7a9d6f80, 0x5089c425, 0x952beabe, 0x05f81a7d, 0x4b056975, 
	0x1a5b5940, 0x19198962, 0xa438747c, 0x93bca0f4, 0x7c43e62e, 0x443eb6dc, 
	0xff7836ed, 0x11d71c34, 0xf336bdfa, 0x9231d077, 0x15c70057, 0x1856f4e3, 
	0x178b9047, 0x7d4012e5, 0x0a27f7e7, 0xee52aa79, 0xf6f1f2d7, 0xcd0df948, 
	0xa47f6370, 0x685646fc, 0xdc5cbf74, 0x94678f1f, 0xd2e255b8, 0x79786eab, 
	0x9fc9c637, 0x13aae8ea, 0x946eeb3c, 0xab1ebd43, 0x80b1c4cb, 0x885d6b1b, 
	0x78bbbf1b, 0xd66214f7, 0x6cb1b8ec, 0x6c3bc716, 0x8f092fef, 0x9abebd7d, 
	0x27c1addb, 0x26affe49, 0xde7d7326, 0x68eb3809, 0x3308dc2e, 0xde370324, 
	0xee03edf6, 0x188f3e62, 0x47988fe9, 0x4df5fd4e, 0x8df0f3e0, 0xf747e636, 
	0xda8f85ae, 0xab9d0ef4, 0x9f4b03f1, 0xaa76822f, 0xdaf4d9ef, 0xa10e3f36, 
	0xb07f44dd, 0xc9b15eb4, 0x8d175af9, 0x93c70797, 0x7ec391e6, 0xb5a8adef, 
	0xe4dbfbf7, 0xcefdd277, 0xb3b53bf2, 0xc8107132, 0x6fee3ee5, 0x7fd8b322, 
	0xeddb9960, 0x7f9070f1, 0x0e6bb0a6, 0x36e2343c, 0x8c65f163, 0x93f7080c, 
	0x2d4fcf8c, 0x7f49bac4, 0x5ca98f41, 0x863cf4a1, 0x531a38fa, 0xd7d0cd5e, 
	0x53cd2a23, 0xeb19c845, 0x975893fd, 0x915fcdf8, 0xc58d18b7, 0x21e0cc1f, 
	0x225ec18a, 0xbebcf79f, 0x8aadf04e, 0x7646f502, 0x3c44eb1a, 0x3d7e47ef, 
	0x2898b9f2, 0xb37efc1b, 0xde2a9b2c, 0xf1e7891f, 0x31da2179, 0xc7ca3072, 
	0xe9db97bf, 0x9d857b91, 0x72f6e7a8, 0xbf134564, 0x37ee2fdf, 0xbf39728b, 
	0x2473c72f, 0x56efa7e2, 0x8e177e68, 0x1ab5c8f3, 0x815379c3, 0xe0cae92d, 
	0xe0592f47, 0xd239ede2, 0x5b43fc4b, 0x4dfd0b87, 0x5699479a, 0xcbdca066, 
	0x2fcb1fff, 0x3ed9fd05, 0xd25af393, 0x84e92cae, 0xb2cab479, 0xc296d323, 
	0xec255a3c, 0xcf50f20b, 0x3ff10668, 0x4eba21b5, 0xdf89bc06, 0x2ee221db, 
	0x2fd715e7, 0xfe78dfd0, 0xf74ff7dc, 0xc5b927ac, 0xfece40ba, 0x100acbd6, 
	0x60bc96e7, 0x5003604c, 0xae47f516, 0x3bdbab75, 0x56eadae0, 0xbeefc0b7, 
	0xc3efd6a7, 0x79f50cf5, 0x4be0547d, 0x5c3dca0f, 0xb619eabb, 0x0d6bb2d5, 
	0xdbede4de, 0x2d96d700, 0x7fd6d8ea, 0xcd8b5c3b, 0x948ed13b, 0x9de1d55d, 
	0x9eae013a, 0x5ce21f6e, 0x9d5cc1c4, 0xdbc5b3cc, 0x1b38b66e, 0xb788ab6f, 
	0x1ff4b3d7, 0x3b9edbc0, 0x753b786c, 0xd8a3b62b, 0xc77c51db, 0xfee1e216, 
	0xe1cb83bc, 0xf02a3bea, 0xbf606677, 0xff716787, 0x8a30e52c, 0xc95f9065, 
	0x57c492a7, 0x00669b96, 0x27e2dee3, 0xe20060d4, 0xaf3ec5ad, 0x55356fbf, 
	0xdf85ea19, 0x2bf6111f, 0x4e3228a2, 0xd538f10d, 0xe716bd08, 0xc9da1771, 
	0xbd3672d6, 0x43b4e218, 0x59cf38b3, 0x5016c251, 0x3ac0371c, 0xe232078d, 
	0x5bfd01af, 0xe38a1728, 0x57fbde20, 0x228dfefc, 0xf8fe434e, 0xad813e80, 
	0x7b78fac5, 0xffb44dff, 0x03e00d58, 0x8d794f78, 0x1c617be5, 0x7e239b95, 
	0x30d75e17, 0xcf0c3bbf, 0x3d27ee47, 0x8932f275, 0xe314fa29, 0x617f8b61, 
	0x81b8adf0, 0x04332c71, 0x3b22110f, 0xf1c5fd04, 0xffb33880, 0x4b0f884a, 
	0xf6a77d84, 0x0d7f7986, 0x37fccfd1, 0x1fd1bf79, 0x005a7c60, 0x9b39bfcf, 
	0x178ca5eb, 0xde307fa9, 0x9cb84789, 0x90cd7e29, 0x6bafc503, 0x7f7f7eac, 
	0x8a175f16, 0xf189fc40, 0xbb84a82d, 0x4dd701a7, 0x3f6a2e39, 0xda11d301, 
	0x637418b1, 0x27212ae3, 0xced6e3d0, 0x975c02c8, 0xf0c6288d, 0xdecfee66, 
	0x4af7c04e, 0xe50c58db, 0x2175f10f, 0x7bf0d1c6, 0xd13fb621, 0x388f95da, 
	0x78f3e310, 0xe8b7f78a, 0x1f3df809, 0x60f104fc, 0xe3ca2166, 0x6fd1f08a, 
	0xa0cd9c52, 0xfa884fdd, 0xdb2bf9e0, 0x63d74add, 0x51fe7c62, 0xd5fa03f4, 
	0x842f3a3a, 0x5fd4f176, 0x48dd93e7, 0x7f4073f7, 0xedef05dc, 0xbd81fec6, 
	0x736abf69, 0xd58a25e1, 0xff2dd5ef, 0xf37d8b3e, 0x09df1fa3, 0x18db7fa8, 
	0x9fd0bdfb, 0xe02c13c4, 0xd6253905, 0x858dae18, 0xf7e06fe0, 0x89cee220, 
	0xde41ee4f, 0x9984f220, 0x5230f88f, 0x5705fbc5, 0xb7bfad3f, 0x1e5d5e8d, 
	0xa481d7e6, 0x1f744798, 0x7efe0bda, 0x66e77e0b, 0x1f88bb1c, 0xc3cbe3d7, 
	0x81e17eab, 0x04bf1a7a, 0x44fea1f7, 0xf80af384, 0x4fa3fa1c, 0x6803b875, 
	0xe1baaef7, 0x2388cd9a, 0x38062ec0, 0x4fdcfabe, 0x76ca0ed1, 0x65bac427, 
	0x476e2cef, 0x5e21bb65, 0x472debe9, 0x8f75bcbb, 0x38fbf1aa, 0xf001133f, 
	0x1ef81d33, 0xb5e503f4, 0x3326bcd2, 0x7e8848fe, 0x22bf4425, 0xb4815f62, 
	0x0bfbd973, 0xc34a7f78, 0x017f68ab, 0xdc3f93d8, 0x97db08b6, 0xbff6cefc, 
	0x6b9a7f70, 0x1e2e417f, 0x382fef82, 0x1c8abdbd, 0x743d6830, 0xbfbd2da4, 
	0xd3719140, 0x820bfb18, 0xfdf2eed2, 0x6fafa905, 0x09fb4839, 0xa760ab96, 
	0xdfe82d67, 0x7ee2b6a4, 0x3aee5103, 0xeb856ff2, 0xf69d3b2d, 0x7ad68d6b, 
	0x02fee645, 0xda75d2af, 0x1aa705fd, 0x05fdda3e, 0x595607e4, 0xc1fc9ff6, 
	0x03f7f3ae, 0x5205fdce, 0x7f7dcf7f, 0x8de9eb81, 0xfee41fe4, 0x41a03302, 
	0x73676b3d, 0x04db2d3d, 0x2a7a0bfa, 0x370c17f7, 0xb978f5f0, 0xca1fa0bf, 
	0xfe71389f, 0x0ab60bfb, 0xceaf3bf9, 0xf96305fd, 0xff67a86b, 0xed72bb6d, 
	0x0eac782f, 0x2ebc17f7, 0xef4893fa, 0x3efe602f, 0xe6cd0eb8, 0xbe0889fd, 
	0xe9e62bd0, 0xaf79e2d3, 0x7f72a798, 0xf3c58fc1, 0xbad2ffd2, 0x0eb151db, 
	0xbf433877, 0x82fef96b, 0x3ee145b2, 0x8aca47e4, 0x62b79a3b, 0x19d2af7b, 
	0x9e6523f2, 0xf9dc37e7, 0xfb7adc87, 0xec6be910, 0xbed5ebb4, 0xb3d7d433, 
	0x9aeeaf58, 0xabd6b310, 0x3f4f57cf, 0x8feaf5ee, 0x71c97e6b, 0x6b7c7c6d, 
	0xeeabaf8c, 0x8f1da18a, 0x5d5fbb08, 0x4a5788c4, 0xd42a7ae0, 0xd10da89f, 
	0xd74e97f8, 0xdfe61798, 0x6f9b8804, 0x2b7cbc07, 0xf1e209e8, 0x70d575ec, 
	0xc4778e1f, 0x8371de39, 0x078df78f, 0x0b9beb6c, 0x9bebec1a, 0x3c1c3c59, 
	0xd99beb8f, 0x60fc967a, 0xf799e91a, 0x3dbfedfd, 0x46adbd4d, 0xae662eda, 
	0xf4275ee7, 0xb03f6c6b, 0xecafe29f, 0xb8f7cd7a, 0xbe6f7b7e, 0xde34cbeb, 
	0xfd9aaeb4, 0xde3df85c, 0x63ffe7be, 0xebd9dbdb, 0xd1aed211, 0xfc72447a, 
	0x02138875, 0x1d669daf, 0xacd9c162, 0xf679fc43, 0x5c43ad99, 0xeffc073e, 
	0xf10eb16a, 0x6f23b080, 0x1210eb59, 0x540e223f, 0x828e16c3, 0x7a7dfce7, 
	0xaf0c9e06, 0xc408f5a2, 0x810eb88d, 0x8fb11a38, 0xf3049eb5, 0x493d6324, 
	0x6549eb13, 0x0bd49eb8, 0xeb906ced, 0x7771e549, 0x4f5863ec, 0xeb1519ea, 
	0x8e535049, 0x5df3a4f5, 0xde78b12f, 0x0be406fa, 0x5af5bbb4, 0x3b292f5c, 
	0x55cfbc90, 0xb4c17c81, 0xbaf1bf86, 0xc712c7c9, 0xd2d6bd49, 0xfdf6a9eb, 
	0xa9ebd91b, 0x3d7ce3f3, 0xf5a71c35, 0xdd5f48d4, 0x5fa9c05c, 0x8fffdb4a, 
	0x3af53d6a, 0xcc6d571a, 0x076854f5, 0x6d4ea7ad, 0xd9397375, 0x655bb178, 
	0x3d79ce7b, 0xbf544bf5, 0x9eb933d4, 0x1eebfe7a, 0xad643537, 0x69df207b, 
	0xbe38b5e8, 0xb7c7fad6, 0xfd65ce1a, 0x4bfd8723, 0xc377fb09, 0x68e7d75d, 
	0x7faf39ff, 0x687ea16c, 0x8da86d0f, 0xb80ff5ca, 0xa7f2d17f, 0xdd0ed16b, 
	0x5ccff20c, 0xfe7c9107, 0x7e7366e7, 0xfcf95ce0, 0x7fee46e2, 0x117f9f24, 
	0x0c91bef2, 0x93797f3e, 0x0edcdde4, 0xc9c95f3e, 0x3e691be7, 0xc599e69f, 
	0x5f3e73a3, 0x6b7e7c95, 0xceef9f16, 0xc95543e4, 0x24e78be7, 0xd688179f, 
	0xa43ed1bb, 0x2cd6e579, 0xf0715f3e, 0x87d26ef9, 0x70c2baf4, 0x7332efce, 
	0xcf933b86, 0xdf9f2557, 0xbe7cae7a, 0x307bd839, 0xbf526f53, 0xea1cf698, 
	0x6d6f83cd, 0x5fd5b5fd, 0x0bbfce1b, 0x7cf9cdfb, 0x5f3e0c6d, 0xeabe7c13, 
	0xc135f3e0, 0x5dcbabe7, 0x683c87cc, 0x05f3e0b7, 0x3e4aae9f, 0xf9f05bbf, 
	0xf8378792, 0xf9f16638, 0x57cf9a46, 0xcd7cf932, 0xf94be7c9, 0x7250cd0d, 
	0xfee2f9f2, 0x8d3eb878, 0xbab5d65f, 0x3cb19c78, 0x91c1eb8e, 0xbb170ec6, 
	0x21a79adf, 0xbe312de4, 0xf012de40, 0xe381a247, 0x25bf2978, 0xe0bf6e9d, 
	0x1e30bb2d, 0xe5d4b69a, 0x1765bc17, 0x2ea143c6, 0x2f7a5bce, 0x9844d7e3, 
	0x02fd2bc7, 0x16af3987, 0xf35fe96f, 0xa3dede5d, 0x9d96955d, 0x87f5fb3f, 
	0x7f5f0af9, 0xaeddc7f0, 0x617b3b6c, 0x3faef9e3, 0xdf7e8cc0, 0x59a7b3b2, 
	0x6e9f707f, 0xeb9541fd, 0xeb59ad0f, 0x9aff340f, 0x43faf91b, 0xcdb43cc6, 
	0x5ed067e7, 0xc7c0bae1, 0xab30febe, 0x21fd6b31, 0x1777fec3, 0xcd9e3435, 
	0x6c74c43a, 0xb0e7cdf7, 0xcc5cb10e, 0x1d7a8fbf, 0xb902e262, 0x1d7b90ee, 
	0x1d63ae62, 0xac4c7662, 0x1a8a805b, 0xaa21d639, 0x1b3db89a, 0xd9a21d6b, 
	0x5b310eb1, 0x7ee61f3c, 0x78eb8e40, 0xf22a10eb, 0x4fb81dfa, 0xfb8098cd, 
	0x1dadbc8d, 0xea618384, 0x04ff4db3, 0xf384b6fa, 0xcf7d8bf9, 0xff28fabb, 
	0x5bd7f381, 0xf0ce391b, 0xe3cd7f21, 0xd7f2d3c4, 0x3b3c6e3f, 0x4681fafe, 
	0x761d7f3b, 0x8462ed5f, 0xd1974cff, 0xdd097a0e, 0xac74f8c6, 0x4ae25678, 
	0x4bfaf026, 0xf8e01e62, 0x7159721c, 0xd31ab1ea, 0x83d4fe85, 0xefd428fc, 
	0x83ed045f, 0x539a7a7e, 0x7cb4242e, 0xd618a9cd, 0x9f44bbef, 0xf95c4062, 
	0x514ef82b, 0x5f993c46, 0x445e261f, 0x2f9ea153, 0xc8a6be90, 0x153e0b2f, 
	0xc3540763, 0xbdc9e5b3, 0x299d6ec2, 0x4687fe4f, 0x7f4393c9, 0xb93c5b56, 
	0x19c7766f, 0x6edfe4f1, 0x0fb93ce4, 0xc594f279, 0xbaf13b93, 0xcbcb98af, 
	0xdc939bc9, 0x07725ba7, 0x1dc0b333, 0xe3b7f2e6, 0xc3c71879, 0xac3b1c62, 
	0xf99eee7d, 0xcf4593a9, 0x763f8e21, 0x6c7baf4b, 0x3c87dd9e, 0xcf36477b, 
	0x21ef83ee, 0x87df4ecf, 0x9a22bef1, 0x57b626fa, 0x3eb2ecf2, 0x6717e1e2, 
	0x67938feb, 0xa8fe3e27, 0xf53a8715, 0x3bc3c9cb, 0x59ea4df5, 0x5f8f2357, 
	0x5bdf7fdb, 0x62f30858, 0x6d3f95e2, 0xf14e24bd, 0x7879f10a, 0x91cce31f, 
	0xe327f596, 0x4f9dec39, 0xe7c6a3ec, 0x54f9ded0, 0x0ef645d3, 0xa8be479e, 
	0x1147ac41, 0xe96256df, 0x3c626de5, 0x79f0e69b, 0x833bdbe7, 0xbee30f75, 
	0x912e85ac, 0xbcc2e3d7, 0x3873a99e, 0xfb13e68f, 0xbbc87d66, 0x873e9c61, 
	0x1adf6bfb, 0xea1bbc46, 0xa85ef237, 0xb807fedf, 0xc2fef77e, 0x39c2efd2, 
	0x5170ff5c, 0xd4e1db15, 0x78578b77, 0xc45315c6, 0x38e16f73, 0xfca27475, 
	0xfe15e3c7, 0xf2d1f8dc, 0x3c39de0a, 0x0578b74e, 0xe315b5d3, 0xdf6f9010, 
	0x6fedd3aa, 0x863b3d04, 0x6f93b4db, 0x725b7ea0, 0x98755433, 0xbfbe0fcf, 
	0xcbc3cf91, 0x823b1da3, 0xf1161e72, 0x8de38679, 0x23650df6, 0xdd9630e5, 
	0x6772bb20, 0x88953cb6, 0xfdf64bb4, 0x4eb89ef9, 0x78c6523c, 0xbc701399, 
	0x013cf2e6, 0x2dc70e7d, 0xdea47ace, 0xeb4b7d48, 0x2f9e5cd9, 0xb7f5c670, 
	0xcb7f518e, 0xcb69f120, 0x719c9e84, 0xf21ef0fd, 0x89face6a, 0xe42a3acf, 
	0xcb99e6f6, 0xdadbca4d, 0x8c52fd47, 0x65fea3ef, 0x3a8fb1cc, 0x751f7390, 
	0x14abbb73, 0xc85ab3be, 0x90b80c31, 0xe2f19778, 0xe070037d, 0x78ce7c2e, 
	0xee339636, 0xee64c906, 0x731e5e63, 0xdac77ca3, 0xf6f58d47, 0x2766bb42, 
	0xfd3d9017, 0xc77273ef, 0x77e14bfd, 0xe2b977c2, 0xe8be0cff, 0x2b7ae35c, 
	0x1cfafe2e, 0x9f1e77c4, 0xca88f751, 0xec6bec72, 0x91eb839c, 0x1d70b768, 
	0x9a5fc32d, 0x3f7a1c9e, 0x1fac3eb6, 0xaa3e1f43, 0x0e67bef8, 0xfdcef7c6, 
	0x3940df8d, 0x8881e262, 0x370283eb, 0x0a6e0405, 0xa6e070ac, 0xea6e24a7, 
	0x26e266f6, 0x69f62a25, 0xaa6e219f, 0x64dc4a8f, 0x2a6e119e, 0xd3713a8b, 
	0xcfc13e4b, 0xd59bc8ab, 0x59cfbae0, 0xe8b6a6e0, 0xf749b858, 0x9572bae1, 
	0x5b2e5758, 0xaa6e1264, 0x117a491a, 0x92be5537, 0x6bfac1ea, 0x6e10174a, 
	0xb81d478a, 0xc3649b49, 0x1ab7a54d, 0xad3f5c5e, 0xfa7b708c, 0x1d7c39d7, 
	0xa5c47959, 0xe0f7bfa2, 0xd9c8357a, 0x4bfdcf93, 0x96ca4560, 0x2169fa07, 
	0xe1cc3fd7, 0xf312af7e, 0x95fbe140, 0x8c2f3ec2, 0x295bbb72, 0x606ec1f3, 
	0x797fb43d, 0x9df941ae, 0x6e8ccbfe, 0x237a77da, 0xa97dc1eb, 0xdea81e56, 
	0xab551b83, 0x3ff3a597, 0x23ea1f69, 0xbcdf3e51, 0x547ee52b, 0x5755f69d, 
	0x3bf7d9b5, 0xbebf3e57, 0xe4433a20, 0x1e566a6f, 0xea7f7a51, 0x333bb970, 
	0x593ca86f, 0xfbcccdee, 0xaa4efca4, 0xe3879edf, 0xadf6295d, 0xaaa17c8a, 
	0x653efb36, 0xe93f77aa, 0xebe78b95, 0x97de90d5, 0xc794e8f6, 0xb1abddec, 
	0x47d7886e, 0xca61a31a, 0xdfc239c7, 0xd5dd330b, 0x0552fa0b, 0xf400a2f3, 
	0xa7e88762, 0x3e51a527, 0xc05bd90f, 0xf6f52353, 0xf0f19e3c, 0xcd9e5a6e, 
	0xaf872f32, 0x48977b9f, 0xe97df2b9, 0x3ad6a287, 0x1e46774b, 0x2b67dc9e, 
	0x7e64aff3, 0xfb0bbfd5, 0x6f5e6de6, 0x95ebdfdb, 0x3f624b79, 0x1ea94378, 
	0x0fb4bf43, 0xd719bf9f, 0x21bc608f, 0xc1fcab6e, 0x0a5a4dd2, 0xe7b47bf3, 
	0x8b8c6a60, 0x896703cb, 0xbc4dbdcb, 0x21fc693f, 0xcfcd08f0, 0xe72e1c0c, 
	0xcc094573, 0xfee0cbab, 0xdfa41db5, 0xf4239bdf, 0x0e5c1c76, 0x233bee7a, 
	0x0b1a9e5c, 0xb09d8397, 0x5edcecf3, 0x513aad94, 0x6af108b4, 0xc23efaed, 
	0x63c720e5, 0x12af2e16, 0x70e25c78, 0xf123e9c4, 0xf02e7c0c, 0xe9be5577, 
	0x7b3d1d8b, 0x28c57dbc, 0x3ed2f1c7, 0xb01ede11, 0x7afd45e4, 0xb23fbb36, 
	0x038bd5fd, 0x876f115b, 0x53db7edb, 0xabf658af, 0xfbf5cca6, 0xba378a42, 
	0xde0db83e, 0x77d84e7a, 0x1ba34cff, 0x6aff04e3, 0x3c7a83d6, 0xe10cf3c9, 
	0x3d8587f4, 0xc67f6f1a, 0x9d1f42c3, 0x0f2434fb, 0xc8a27e4c, 0x8477efd2, 
	0xc4d69f7d, 0x75bb4eaf, 0xf7af1353, 0x0756ec9c, 0xbe53afe5, 0x78bf65ab, 
	0x26a2fa9e, 0xbcacbf61, 0xafd91f10, 0xf5fcf695, 0x476053ca, 0x967da31e, 
	0xed26bb36, 0xa72f9599, 0x91f794ab, 0x329179e4, 0xdbf29d4f, 0x86be5653, 
	0x7990efcc, 0xdcc3e5eb, 0xfe4585de, 0xf6e49a87, 0x49bfda50, 0xfd9b5df0, 
	0x5eea7913, 0xf221ef99, 0xda56aa34, 0xddb1d6f3, 0x1ff91654, 0x9e444ed2, 
	0x74c9dbb7, 0xbfca9d9e, 0xf53c563b, 0x9ea388b8, 0xc9fb126a, 0xfdc29e30, 
	0x8acfc374, 0x62f0ca78, 0x26c3f53c, 0x1c81ee7e, 0x4f112abf, 0xc789bf7d, 
	0x9e225553, 0xef89a7ba, 0x7c0a0a9f, 0x0f307e47, 0xfbf19ffd, 0xd53af93b, 
	0x713e3bc9, 0xbfdb79e6, 0xdb795a8e, 0x862e0646, 0x7f294ba7, 0x6dfc9c72, 
	0xf233b769, 0x5b7f29bd, 0x08e97a67, 0x7610789e, 0x5adc442d, 0x55ffbbbc, 
	0x8f259bc4, 0x7ae2940e, 0xdb9f33a0, 0x7a30fbca, 0x41923e79, 0x80de1e79, 
	0x3ef223d9, 0xd36b4f48, 0x31f3c77a, 0xf9ed1a6b, 0x50cfe849, 0xda572aef, 
	0x15e64ef5, 0x6d3b9379, 0x8fd2b7f9, 0xe922bcca, 0x955fa567, 0x2db54279, 
	0x9acbfcf6, 0x90de7b46, 0xbfaa13d4, 0xebb7eb09, 0x15be464b, 0x9834cfef, 
	0xe1e50677, 0x06f43cd2, 0x72acbcf8, 0x9e54ade4, 0xba4ade63, 0x953c8e3d, 
	0x0b3e474a, 0xf71c6dfa, 0xa3d9e208, 0x27ae1e56, 0x1a71621c, 0xae1e7b77, 
	0xcb1dbbcc, 0xee3e539f, 0x3b77912a, 0x3227ad90, 0x501a172f, 0xf14a7c82, 
	0x8f5de4fe, 0xb8f9d91b, 0x0f6699de, 0x8cd7f7e6, 0x581fdf91, 0x7de57611, 
	0x8d77eac1, 0xc5afefc8, 0xde61fefc, 0x5aebd47f, 0xbfc82fb1, 0xbe0af40d, 
	0x9f2897f7, 0x5cf2b54f, 0x67a0dd8f, 0x0fdf981d, 0xde6b0df7, 0xbbf3a6d6, 
	0xa7f7e773, 0xdbc883f1, 0xd87995a9, 0x63274f22, 0xcb6a843f, 0x5156d4cf, 
	0xf050667e, 0x17f1e31d, 0xf1e34d45, 0xf159e617, 0xb29b1317, 0x62a845f6, 
	0x6b9a845f, 0x8ae1045f, 0x117d8cae, 0x2fb4fdda, 0xa443f682, 0x3b31bf04, 
	0xe1045f7b, 0xfb582f90, 0xc11e2422, 0xe1750338, 0xd7adf34c, 0xbdfffe89, 
	0x78e5adf3, 0x9d6f978f, 0xc3d6bf91, 0xc3de98ed, 0xbfc898ed, 0xc5e7e42f, 
	0xf39d85f8, 0x98637da3, 0x50f426bf, 0x74eab9d8, 0xab41be3e, 0xddb49148, 
	0xef0aff03, 0x9f4b2d57, 0x78a5e307, 0xf9fb03e1, 0x394fb530, 0x1f3132f2, 
	0x9353e412, 0x7eec338e, 0x5998f497, 0x3f48c5e7, 0xd3b9313b, 0x60af3b67, 
	0x10579f98, 0x995df876, 0xbbf69977, 0xf98b4712, 0x53f69110, 0x65aad9f8, 
	0xbe426e42, 0xcfd81f95, 0xaef29185, 0x7f9eca7d, 0x15e32359, 0xe05777e1, 
	0xd7f039cf, 0x041ee798, 0xea14b8c4, 0x041c7c3d, 0xd7f6122e, 0x4539768f, 
	0x0f948479, 0xa1173ceb, 0x45cf1cfa, 0x7f9c76a8, 0xe3027e80, 0x0939e75b, 
	0x76ec4b95, 0xcaed0aa7, 0x211e56fd, 0xf8f0f7bd, 0xfb698479, 0xc54fef8f, 
	0x93eddaef, 0x7e320fc4, 0x1397bc96, 0x30912847, 0x2d55e3c5, 0x3e677df6, 
	0x8f010be4, 0xfce31c8c, 0x176f2660, 0x67b1807c, 0xdefbec9b, 0x531f04aa, 
	0xe11f32a5, 0x1f9c63db, 0xa3afaecc, 0xaa991707, 0xa0fcec5b, 0x27d795af, 
	0xbc8db7f7, 0x5fc179ca, 0xb9f7d936, 0xb07a8a55, 0x9ed0fd3d, 0xe2f0d54a, 
	0xc8f3e338, 0xbb1e10ff, 0x6b7bf791, 0x674725a1, 0x484f243b, 0x6c6679f2, 
	0x5a3948f9, 0x6ed6e0bc, 0xeaee0bce, 0xf05e233e, 0xe1427515, 0x6cdec646, 
	0x4179a8fa, 0xce69cc90, 0x0bc9c837, 0x354ef7c2, 0x7f03e6e5, 0x46fec4de, 
	0x2689e07c, 0x3e4613ca, 0xe0e597b0, 0xa26ddf03, 0x72af3e7d, 0x4f19d03e, 
	0xebfe3d8d, 0x3ffc72cf, 0x30305e2a, 0xf3de5737, 0x8d989b1f, 0xe6a37c17, 
	0x61ef295f, 0x8455d276, 0xe76274f1, 0xfa0342e0, 0x86e4f0d7, 0xd98c28a2, 
	0x0a9a3bf4, 0xe663c731, 0x5e17f7f7, 0xbcf6e0ac, 0xcc3360a6, 0x075b82db, 
	0x87a317bd, 0x62174630, 0x17cd4e7b, 0xe4759f38, 0xfefd05bd, 0x986f6f87, 
	0xa0b80e50, 0xf94dd3fe, 0x5da75c0a, 0x3f3f3fbf, 0xdaf3cf0f, 0x633c8a30, 
	0xea4d05f9, 0xb5eff06c, 0x860c19bf, 0xa7fd5ae1, 0xf87a81f5, 0x5143fe6e, 
	0x3fb074ef, 0x47eb83ea, 0xb6bece51, 0x7814fbf5, 0xf5c9e4be, 0xe7d428be, 
	0xbefd747b, 0x1f92d878, 0x6dbd21fc, 0x72bf86f0, 0x55d5c427, 0xe50c1d3d, 
	0x3499e25e, 0xc022fb67, 0x89db0a0d, 0x9e25e4e9, 0xf7cb3fa7, 0x37539885, 
	0xe2995357, 0xe7117694, 0xe6a5efca, 0xd0f0f9f1, 0xf026e23c, 0xff7e174f, 
	0x37119958, 0xae1519c0, 0x191a9734, 0xcf9828f6, 0x995543ed, 0xefdf34f1, 
	0x5f77d26d, 0x2071cb9c, 0x75af515e, 0x775c2d71, 0xe32c6970, 0x5f3e44fd, 
	0xeb2f507f, 0x1879017f, 0x10be2fda, 0xcfeb0d6a, 0x66bd52f4, 0x8bebd71c, 
	0x634b53ba, 0x0c097619, 0x627682bc, 0x0bf1d1a6, 0xf3c8874f, 0xed8ebcc2, 
	0x2f28ab4f, 0xf51b8768, 0x1cb9caec, 0x382b6a77, 0x2e72733f, 0x8a4ae38f, 
	0xfc542f39, 0x5d0bb58d, 0xd24e311b, 0x84fc136e, 0xf71c0419, 0x9d7c79a7, 
	0xef1164ad, 0xbe3ced4f, 0x395dac1f, 0x884dfd48, 0xc884ba3c, 0x0bf293a3, 
	0x42e918df, 0xdf204a7d, 0x0d7ec61c, 0xb5768d3d, 0x1df538a4, 0x7d42173c, 
	0x4d60f3b8, 0x60ffe502, 0x6fa05dc7, 0x638eaee1, 0xf89ca0fb, 0xb057cb15, 
	0xba49e0ff, 0x8ae90f31, 0x3f109b23, 0x33dd3f22, 0x99cfcad9, 0xf9053260, 
	0x83bac4db, 0x500e38dd, 0x273e456e, 0x818d8c1f, 0x86e5cdbc, 0xec10f738, 
	0xe723e919, 0x5d3bf2c3, 0x4fec0c9d, 0x5fcf20e2, 0x70a67e87, 0x2ff1397d, 
	0x8f887bfd, 0x6137e94e, 0x3fff697b, 0xac59d3d6, 0xa97b426c, 0x7e71d6f4, 
	0xd7def399, 0x70ebe3cf, 0xe82b4792, 0xf0179854, 0x2c6792aa, 0xa97417bc, 
	0xed221c0a, 0x5d37cef7, 0xe1e20ed8, 0x421d9ea0, 0x28fa237e, 0x176913ed, 
	0xad595cbc, 0x95d409b9, 0x8fda81f2, 0xf6a07cf2, 0xa81f3cc3, 0x07cf157d, 
	0x799c5f6a, 0xd751962e, 0xdff7cfdf, 0x3c495da3, 0x1e404fa2, 0x78f4213d, 
	0xbe3e3cfb, 0x87883c72, 0x31e310ee, 0xb7e8f820, 0xb49d4f04, 0xffcf93de, 
	0xd3d71e60, 0x45bfa121, 0x1229df82, 0x8f3dd9b8, 0x8b22e9e3, 0x7e7389df, 
	0x7e738cc7, 0x7e0b8cc7, 0x77e76e27, 0xe73c2ecc, 0xd984b82c, 0x66d4f770, 
	0xb32cebc1, 0x476d1be3, 0xce12571a, 0x8d347a2e, 0xe1c2151f, 0xc2eeeeaa, 
	0xdfb06c78, 0x3893fd8d, 0x943550a4, 0xbbc594ae, 0xf52e0c96, 0x5c62fde0, 
	0x8065446a, 0x4161b1f7, 0x5dea7c47, 0xda49c766, 0x925b810e, 0x3d14b71c, 
	0xd89ff02a, 0xe71292df, 0xeec26948, 0x37ce0d7a, 0xf8fefee3, 0x141fa463, 
	0x662e866f, 0x3ce2eeb4, 0x73c9ca47, 0x8c3e8487, 0x863db8dc, 0xb0f193fd, 
	0xbcd36b8c, 0xe9adc0b7, 0x39e4a673, 0xe3aae555, 0x24bd3b5c, 0x0fb189b5, 
	0x43d7a6e6, 0xe03d874a, 0xc9463c6f, 0xe7189b23, 0x21f07247, 0xff0ae68b, 
	0xfde05500, 0x3ab5f8f4, 0x0f0725e2, 0x4dd84a7e, 0x07290f29, 0xc70dc73c, 
	0x1490e483, 0xe421d4e3, 0x0cb8fe03, 0x1f1c5002, 0x22fde7ea, 0xfd10ea3e, 
	0x8ebd63f7, 0x93c1c8f8, 0x78d1b94b, 0x2071adf8, 0x2f8c0cb9, 0x51f79277, 
	0x6cbecf21, 0xd7258f39, 0x7695cd9f, 0x41d721c0, 0xe4572596, 0xddde6415, 
	0xd0e7131b, 0x65ad687e, 0x24f2eaf4, 0xf1840ebf, 0x9e60aebe, 0x50caa860, 
	0xed0f1f30, 0xcdc60bb6, 0xf3a49fd7, 0x5cea2f7d, 0x3b84f943, 0x67f8f8c5, 
	0xa0e85f82, 0xdd8e23b8, 0xe6711ed2, 0x73b699cd, 0x9bcc3579, 0xde7fd8cb, 
	0x8e7f49b0, 0xba6bcb9f, 0xc56f9c34, 0x2fb7d5c9, 0x0839bca0, 0x6e6f31c9, 
	0x15bfb560, 0xa63a2bae, 0x9e7d8015, 0xa67ed9f5, 0xcd7b422e, 0xc66efbbc, 
	0xe3dafeab, 0xddbe9fdc, 0x67df1f75, 0x735d788e, 0xcf27fb9e, 0x80775de7, 
	0x1c09cfe7, 0x3b52ec7d, 0x27dece7e, 0xebe7807d, 0xdf77e974, 0xbbe9ebc3, 
	0x37923eed, 0xc4d19bed, 0xaf33a67a, 0x46fc134d, 0x294b80cd, 0xfa6ae783, 
	0xc782ec5d, 0x28dbf3b2, 0x95956daf, 0xddf326cf, 0xb16dcf28, 0x10b73f38, 
	0x3c8cdaf3, 0xe177373c, 0x4b47ee3c, 0xaee6e71c, 0xd79ed4bb, 0x9e752ec6, 
	0xa1ba6b9b, 0xb5e6e349, 0x6d791d05, 0x7cf94bae, 0x5e655e72, 0x9e7235db, 
	0x86b6fc8a, 0x1ff68352, 0xbad31d55, 0x333ebf50, 0xca47ac4f, 0x5c67313c, 
	0x35c47713, 0xd35c799b, 0x971f6cdd, 0x90971890, 0x2e342baa, 0xd33c799b, 
	0xb0bab4ae, 0x0c2dc43e, 0x6c0ccde6, 0x5f227bcf, 0xe025fd09, 0x7cefda17, 
	0x28edff59, 0x1b5386bf, 0xe1ab3d69, 0xc42e6fd1, 0x9eaababc, 0x3c7723d4, 
	0xd5603883, 0x74051de6, 0x873fb6d5, 0x0fc64ddf, 0x7fe20d7f, 0x2b31f394, 
	0x1e78863f, 0x19e23794, 0x8f44c390, 0xde27ee9b, 0xcf18f965, 0xd7e00226, 
	0xde2484c1, 0x6f29f3d3, 0xc6f7fc1a, 0x5df9f8c7, 0x98447431, 0xe4547387, 
	0x3f087749, 0x79e316fd, 0xa7e17e39, 0x07bdf047, 0x16b7937e, 0xbdf1b7fd, 
	0xf317cd04, 0x9df72db1, 0x62d87ce6, 0xe764be71, 0x11478a01, 0x70d624bf, 
	0x1b3bd23c, 0xf62cdbbe, 0x391e22dd, 0x5bccf02a, 0x5c218e16, 0xdf2b63f2, 
	0x324cf08e, 0x858edf33, 0x01ddbe78, 0x4e255b8a, 0xcf4cba82, 0x49270b6c, 
	0x127122fc, 0x16c598e1, 0x72fc424e, 0x84fea144, 0x23fd0c8c, 0x1c09a43c, 
	0x877859a4, 0x8124cff0, 0x2c0f286f, 0x43ae2cf9, 0x2fbabe01, 0xc9e3e7c1, 
	0xde61f7cd, 0xdc5ccf76, 0xe383d127, 0x8a6f819f, 0x2be5c93e, 0xabae0df1, 
	0x1f384685, 0x0b55f458, 0xd29e5cff, 0xb3250c9f, 0x9ee10ff1, 0x9d070255, 
	0xef31fe11, 0xe6ef79e7, 0x85aa5bfd, 0xd63f723e, 0xe2127e85, 0xbe3017e3, 
	0x4e5aeb91, 0xe66a13dc, 0x362f24eb, 0x3ce3dc73, 0x4b5e7997, 0x02ccb9d6, 
	0xcb9d64f7, 0x3a3dc0ec, 0x20d2ae7f, 0x97da147c, 0xd7943fc6, 0x75e62a3c, 
	0xd5c1fe06, 0x93bda60b, 0xe43e3fc6, 0xb9d612d1, 0x172c1e9f, 0x90f34cae, 
	0xaa95c3c4, 0xbecba786, 0x61eb45be, 0x41151f12, 0xaa4bc47d, 0xb1fd0fba, 
	0xc1be43c4, 0x07cd1721, 0x0e500934, 0xebf926aa, 0x7887a812, 0xde8d41a4, 
	0x93d404ff, 0xda1fbeb9, 0x4ed3f027, 0x78127e07, 0xe0477b49, 0x9fbf14a7, 
	0x5ef53c90, 0xb091fe5e, 0xc52b8517, 0xbc1c47ef, 0x1aebe0a6, 0x8457cd4a, 
	0x7cd82dbe, 0x3ce879ba, 0xb5d859a7, 0xf8e3cdfd, 0xeac79919, 0xdf3833f0, 
	0x669bad72, 0x4fdb9fbf, 0x35fef78d, 0xefceffa2, 0x7187f064, 0x17135eb1, 
	0x73b635eb, 0x7ac73553, 0xa6e758cd, 0x365c9c4a, 0xe26570d3, 0xca0fc964, 
	0xe79cd071, 0x4378398a, 0x19c04cef, 0x58e6bcf0, 0x86aaf117, 0x109fbf0b, 
	0x5f7e59f3, 0x4122eb13, 0x8ff1ee71, 0x2c113c44, 0xf31ee796, 0xccdc2078, 
	0x7d3079ed, 0xc5d9b1ee, 0xfb863dcf, 0x825ce32c, 0xc63dce31, 0xbf58567d, 
	0x21e487ec, 0x8f738e83, 0xb8f1f833, 0x62e3c7e0, 0x3b9c4f9d, 0x83b9d268, 
	0xde7665a1, 0x0758e835, 0xf34c1ed3, 0x2e238aa4, 0x8081f5a1, 0xbdbc906a, 
	0x7936fd83, 0x93ccab17, 0x84292e2b, 0xd69960ef, 0x395e70fd, 0x1d04cdf6, 
	0xf1e966eb, 0x93cc507a, 0x227c477e, 0xbe48d7f6, 0xe0d7efad, 0x7f51262f, 
	0xfa53ff28, 0x5ed5250f, 0xf31a193b, 0xffbe66f9, 0x3be7f2aa, 0x8c1c40df, 
	0x30f7be78, 0x81f9ed5d, 0x2f138f3b, 0x0be7eaf7, 0x41df5978, 0x5735dc7c, 
	0x7e4e3a5d, 0x2df0d420, 0x3655bceb, 0x2743f824, 0x4a73b5cf, 0xcbfbfdad, 
	0x7df5bee8, 0x17c67e67, 0x19f96d9b, 0xa87cf243, 0xef94cdb5, 0x19791619, 
	0x788f2f22, 0x9e2d3785, 0xb1fdbce0, 0xcffbe3c8, 0x79d38fe6, 0x6b1f02be, 
	0x87000f42, 0xd69c41ed, 0xce2878f8, 0x788ae279, 0xa12e279a, 0x3cf2d4f6, 
	0x69e3ce5c, 0x0fa4fd5d, 0x3e82d7c4, 0xde4f5124, 0x2af1fc15, 0xf07e7636, 
	0x27a4f3e0, 0x45b349f1, 0x8f1fc1d9, 0xd42cde79, 0xdbf43ef0, 0xed28bba7, 
	0x4f4318d6, 0xf6b5bd06, 0xc7978fef, 0x739b3ff9, 0x5dd95f9d, 0x27ae43f4, 
	0x591ddf82, 0xc25d79c9, 0x73acabb3, 0x0ac70805, 0x6cf62e5e, 0x78123d86, 
	0xd925fd04, 0xe79c95ef, 0xf0983895, 0xff0b36f1, 0x6fbe778e, 0x63e79449, 
	0xfeccddbf, 0xbefbe746, 0x1f2b9cd8, 0xee5b8d3b, 0x6b7bec75, 0x20c5b891, 
	0xe1696dad, 0x371fc5b8, 0xcb7debec, 0x914d3cec, 0x7fe42a6a, 0x0f649ae6, 
	0x9e43fda5, 0xb4a1ed1c, 0x18d7657f, 0x7ae43384, 0xbc69e49e, 0xc9f63af7, 
	0x613cf5c9, 0xf43da4f7, 0xeb6d07c7, 0x7665fe75, 0xf79d86be, 0xd9efbcb9, 
	0x7d24a8f4, 0xcd07ef2e, 0xf3260794, 0x0f32cfcb, 0x241b89d8, 0x77986d3e, 
	0x9fb7f97e, 0xccb5f111, 0x9e702dbf, 0xcf69d9a7, 0x6ff2b3d7, 0x69e7dccd, 
	0xb7f9972e, 0xfe667729, 0xf37cf06d, 0x699f976f, 0xf3b0edfe, 0xbfca4d3c, 
	0x7f958e0d, 0xf32cfcbb, 0xd0fc6f6f, 0x7d9b7f96, 0x2287c65e, 0x0f8f96ff, 
	0x3e3e37e2, 0xff173ba6, 0x3f3acc10, 0x9e1ed773, 0x9ecf7b6f, 0x8333f3cc, 
	0xc133f3ce, 0x1fbe63ce, 0xf3b61ac6, 0x827f4533, 0x6533f3ce, 0xf7330d3f, 
	0x65cb99f9, 0x3b69adbe, 0xcce8333f, 0x91df15b7, 0xfd0d94b8, 0x9a39f731, 
	0x76fad3cb, 0xa09f7986, 0xdc7b2c7f, 0x5b9f799d, 0xde7d3d2e, 0x6c3a5b27, 
	0xf7cc8f6f, 0x3df3ce5c, 0x7db18a3d, 0xefd78f1b, 0xf9489bef, 0x17c85d1e, 
	0xc7eb9d04, 0x6466bd62, 0x09c520db, 0x8dfc123f, 0x18a17f94, 0x6991e477, 
	0x8c39e1dc, 0xf87aaa0f, 0x7345cefa, 0xcf10d8f9, 0xf134ebb2, 0x96dd0ec9, 
	0x9ef89c6f, 0x99449cfd, 0x7c8aac6f, 0x070253e3, 0xceb1fd4b, 0xc895fc49, 
	0x24e79637, 0x1be792fe, 0xa2e33c8b, 0xde7469cf, 0x939e2162, 0x5a27f828, 
	0xad5e7547, 0xe79d637c, 0xfbfb9b1b, 0x9fe573aa, 0xfcccee9a, 0x96a760d3, 
	0xa94c1cfb, 0x790e4777, 0x3cce5c70, 0xcdf014ff, 0x83c7904e, 0xce4c1cf2, 
	0x0dfa258f, 0x97a62e79, 0xdb3195ca, 0xfc899939, 0x4e2a3e74, 0x54ff2b41, 
	0x79197fec, 0x29839c40, 0x28bb73f5, 0x3f231a1f, 0xa3e45f35, 0xe3fb880e, 
	0xf53a9de4, 0xa5cfe9cb, 0xf5fb4ebf, 0x3cc1e994, 0xfd63aabb, 0x52faff84, 
	0x7f96097a, 0x07df2976, 0xf080b805, 0x98ca5f55, 0xee13bf82, 0x635ef2c6, 
	0xfddb2886, 0x2a41f0fc, 0x8b35da9f, 0x9077a397, 0x75d4ff9f, 0x6fe0e34d, 
	0x0cfdf1a8, 0x0c687dfc, 0xd4ac355c, 0x69ffbfda, 0xf7d687f2, 0xd5f0fe9d, 
	0xfbf86d4b, 0x4755c490, 0x555c252e, 0x6261fc2f, 0x987f4e7d, 0x73c22bc5, 
	0x3acf34c5, 0x20fbbd1e, 0xdde681f1, 0xcca38805, 0xe5ca7fb7, 0x5b558b1e, 
	0x7d47e671, 0x9694ef3e, 0x1f8fcdf3, 0xcf3b3925, 0x4ee2b5e7, 0x26f3c453, 
	0x0603e78f, 0x0d0b438f, 0xb3ed172a, 0x8e853ff3, 0xe3b5eff3, 0xc4557de9, 
	0x1c45f8f7, 0x6c7117eb, 0x3e1e7d22, 0x22fc87e7, 0xb8cbf5ae, 0x490bc1d6, 
	0xde9828be, 0x73f3a3f7, 0x241f05f0, 0x37dc21f9, 0x7d2d3883, 0x6b88bdfe, 
	0xd7241f25, 0xe45f2477, 0x384a5c1f, 0xaae3ee4e, 0x0362ef86, 0xf9d9f68b, 
	0xf9c742a1, 0x8171daf7, 0x940f04d7, 0x3bdfe790, 0x8390a2f8, 0xfdca0a1f, 
	0x9c76c345, 0xff79ee77, 0x9f725a33, 0x85ab3c3b, 0x3da77af4, 0x9c573cae, 
	0x3be024f7, 0x9e4c7fb1, 0xd8371ea7, 0x7e14f399, 0x9c650fc1, 0xfb171f43, 
	0xfa1ce8c7, 0xf3d392d0, 0x0fca6718, 0x4d07f939, 0x390b1fec, 0xc71d9dff, 
	0xd89af439, 0xa1fa463f, 0xf632f789, 0x3f75c98f, 0x34b1fee7, 0x8ff621bf, 
	0xf7a1cf39, 0xe0eefd8a, 0x2afabacf, 0xb18afd70, 0x3e0427ad, 0x67f90bbe, 
	0x6fde55d0, 0xf7e302b7, 0x9f588b50, 0x2fcdb811, 0x3beb97de, 0xbce16ddf, 
	0x9c2dedef, 0x5c59ba9f, 0xb430ad83, 0x350fcc29, 0x2e6eb483, 0x35f220f2, 
	0xfd7f2266, 0xbfb85a3f, 0xd83eeb96, 0xc09eef8e, 0xefa02eef, 0x778240fa, 
	0xe1ae0d7f, 0xb801db30, 0x1845f7c7, 0x39fcb59a, 0x4088e203, 0x62a186e9, 
	0xc4a8eb94, 0x884383bf, 0x54ff5833, 0xf8955e1b, 0xafe502ac, 0xfda5fef0, 
	0x3ec64f66, 0x5bdab194, 0x235ded0e, 0x613c75f6, 0xb41d77b5, 0xd109d67f, 
	0x7819139e, 0x177eb9c9, 0xb513ac71, 0xde3ad20e, 0x3efb16be, 0x179f8b3b, 
	0x418af0f1, 0x4632479e, 0x7287237d, 0xc0a2a3f7, 0xa6f9d188, 0x3fc41ed0, 
	0x7e5736ea, 0x65dbda29, 0xfd1a5c1b, 0xc22e537b, 0x82bc728e, 0xf72eed6d, 
	0x7fae34c3, 0xf34973c1, 0x72de8e7b, 0x78d62dfb, 0x85cbc867, 0x97f1c8f5, 
	0xf13bf87a, 0x1e85d79d, 0x80f3f1c8, 0x4acf313c, 0x036a7901, 0x277dddbc, 
	0x2e53f1ac, 0x1a7ed30e, 0xe4865fb9, 0x39c73b3c, 0x4c17025c, 0xc7b3f2bd, 
	0x703f1c78, 0xe97e042c, 0xff9916e5, 0x4757b0e0, 0x92af643c, 0x363c453b, 
	0xbfee88bc, 0x7e26a7fc, 0xf897b3df, 0xfd5ecb17, 0xfb95ec84, 0xf8d593ba, 
	0xf2b103ef, 0x8757b098, 0x0a4abdb9, 0x7b96dc3f, 0xb8d65adf, 0xac631e09, 
	0x25c2cb71, 0xb3cb9e47, 0xf11377b7, 0x82f6e982, 0x6e7dc8df, 0xc33c4817, 
	0xc9bb425f, 0xca5b4eaf, 0xc4c783f3, 0x6c7d4eef, 0xff40fbe6, 0x9947d0e4, 
	0x2bc72b87, 0x2cdb8f9d, 0xd90fc3f2, 0x3fd2c2f5, 0xbe7fa6dd, 0xea4ff431, 
	0xea45b04b, 0x6de4f99f, 0x737ca71c, 0x43dfcd53, 0xc8f9d40f, 0x41eb644f, 
	0x13f13e60, 0x725a0f52, 0xf298c1eb, 0xdbcbf912, 0x2be68a8b, 0xa3b54237, 
	0x48519f3e, 0x8e2bfafd, 0xaa99926b, 0xdeb17c81, 0x70714056, 0xc807dc95, 
	0x44ea78f3, 0xaa6e0f1e, 0xadb8e2ef, 0x606bee94, 0xeb4ed120, 0xca9d79f2, 
	0x4d1c454b, 0x91f0644f, 0x6ca96b30, 0x0be7e91a, 0x453ddc79, 0xd0848bec, 
	0x8c9bef13, 0x22e98bcb, 0xb3cb886f, 0xeb4f9b49, 0x279875be, 0x43794034, 
	0xcfefe22a, 0x11a1bc8b, 0xe31fbea8, 0x461cb583, 0x860a1c80, 0xb30f1ce9, 
	0x9412f500, 0xf88302f4, 0x5182fd37, 0xd805fbfe, 0x35d3173f, 0xb5333fea, 
	0x2c3be221, 0x5745375e, 0x7f085f9e, 0xaba3de8a, 0x2f21f451, 0x44dc1f17, 
	0xe817e2e5, 0xe15e4aca, 0xe0d792e5, 0xa27ffe5a, 0x5f71b365, 0x6583ebc9, 
	0x177570cd, 0xfe957ced, 0xfd75b8fd, 0xca1d78cc, 0xa398fc9d, 0xf9b6fcd0, 
	0xc355cf34, 0x387eb845, 0x687e3848, 0xbbf53962, 0xcaa1d0e2, 0xfae1bb8b, 
	0xf36568dc, 0xeffeb866, 0x6f20f7bd, 0x7db4e32c, 0xe7e74b45, 0xc3d96fbd, 
	0x76cf3591, 0x53e91c09, 0xfe5da9ba, 0x5da8ba57, 0xcae8d7fe, 0x72f26f02, 
	0x83978460, 0xf072f1ef, 0x3fce5e43, 0xf9ca91b8, 0x4d95d02f, 0x27978578, 
	0x8ad706bc, 0x15cbb708, 0x5b9c79b3, 0xbbc6f821, 0xf4f9f3e6, 0x9ded711d, 
	0xacf3e7cf, 0xd7a435b2, 0x2fafaf95, 0x8f3c830c, 0x8dbdde15, 0x3dee29d6, 
	0x6f728854, 0x959e7615, 0x5f98b5ab, 0x334bfcf6, 0xdd59bec5, 0x53e30fd5, 
	0x22d7a439, 0xf155f2df, 0x5ff9d6dd, 0x89f0f9a5, 0xca1d4623, 0xd983fd93, 
	0xcd68f183, 0xc0ba6cc5, 0x6a978447, 0xd1d3a31a, 0xebe8d4ee, 0x4b611ba7, 
	0x8385ca3e, 0x29de718b, 0x76bde113, 0xc0f0ebd0, 0xf7fc12e2, 0x3daf2611, 
	0xca72388c, 0xe782b0f4, 0x2a2e7b95, 0xdca8cc3f, 0x1cf18c59, 0x78f30ff6, 
	0xfd2517bd, 0x9a90181a, 0xb43eceda, 0x64f45303, 0x57df05c4, 0x17f5193e, 
	0xf9deefc3, 0xb82afe83, 0x068e9faa, 0x5c0d7022, 0x18b8183f, 0x237ec5f7, 
	0xf7cd9c1a, 0x5bfed2dd, 0xed288eed, 0xfefc2dab, 0x95abed20, 0xe7fe2fdf, 
	0x286284e8, 0x4a393d97, 0xecb36ffb, 0x540bc0f5, 0x4cef7e3e, 0x1dcc4f3e, 
	0x181cdf14, 0xaf638d70, 0xd7b406a1, 0xfda5193f, 0x9f9eac42, 0x487158c7, 
	0x764d7b27, 0xf798a8e0, 0x03d9738b, 0x559dfe93, 0xf3d20f69, 0xf9c970df, 
	0xa1bfe7ca, 0x0acab2f0, 0x6555fcf8, 0xcc3978bb, 0xe1f62efe, 0x681d9d3f, 
	0xf62076e3, 0xa7162195, 0x6dc75188, 0x37f24c9a, 0xca807afe, 0xc36d741d, 
	0x22fd701b, 0xcfd80fe3, 0xeb67ac07, 0x948de6d0, 0x64f7d2f6, 0xc402fbfe, 
	0x58bfe4d3, 0x9f8f8c7b, 0xef78cd5f, 0xf6a6368d, 0x542ff7c1, 0xee0b952b, 
	0x1fa37ee7, 0x2b50bdde, 0x865fdd64, 0xfc171def, 0x1a252620, 0x96650e54, 
	0xf31e442f, 0x6d7bf4ab, 0x374cefe6, 0x2cbed8fd, 0xffef19fe, 0xbb39e700, 
	0xc17b7880, 0x894c8137, 0x9aa409b7, 0x76c69f88, 0x43c97de2, 0x79c4c85e, 
	0x614dcd73, 0x97aa7fe4, 0x1037be72, 0xbda3f61d, 0xe5ad50bc, 0x9f3ca37c, 
	0x39be098c, 0x26417f59, 0x6f723cdf, 0x9d53d539, 0x2579fd12, 0x4687e364, 
	0x780b8052, 0x7c57e1dc, 0x2e689e16, 0x2788bd65, 0xf39f32fe, 0x36bfd2c5, 
	0x41dff017, 0xe2b7dbbd, 0xac374678, 0xf7ad278b, 0xe471142e, 0xaf2107ff, 
	0x0000200d, 0x00036891, 0x7ded9c78, 0xd755540b, 0x973ef79d, 0x02e05c03, 
	0x8840a797, 0xfae1105e, 0x0a8a8248, 0x1101e896, 0xd34c19f1, 0xe5f1f4c4, 
	0x4e2a4c62, 0x318d31da, 0xe7b5669a, 0x4f8795c2, 0x2ac47c40, 0xa4d44341, 
	0x5f331959, 0x99333127, 0xd56941ce, 0x798d597c, 0xfd699a4c, 0x634c68a6, 
	0xa4eb4c3b, 0x7e3321b6, 0xefffbf5f, 0x3ee1f7bf, 0xbe4d8d00, 0xc6b599ae, 
	0x7ddd95d5, 0xf1fb39f7, 0xfffefe7f, 0x1341f7bd, 0x84eb9842, 0x715a7228, 
	0x06216e6d, 0xefae374a, 0x0a3f4a3c, 0x84eb3343, 0x1fd47198, 0x910a1627, 
	0x1bf86994, 0x6a51082f, 0x95a21969, 0xb60d8fea, 0x510bcfba, 0x4322ba76, 
	0x7ff7a19c, 0xf531bbd3, 0x2667bc13, 0xd988530b, 0x232578bf, 0x14885a37, 
	0x3af70843, 0x73b42efc, 0x13829ff4, 0xe3e98ce2, 0xd4fce3fe, 0x66dd1fcf, 
	0x214695f2, 0x5a180f6e, 0x8510aa63, 0xbed68649, 0x97688847, 0x10ef6e48, 
	0xdf7a26e2, 0x6a751979, 0x0aaefaa7, 0x0ad6d221, 0xe87cc1e1, 0xe5ffdbf9, 
	0x9a4ed3de, 0xdc29c7a7, 0x7b64ab71, 0xa85f3d0a, 0xdc7e3be6, 0x0e2d0ac6, 
	0x138c1ad3, 0x3bffbf34, 0xacaffe97, 0xfdd68457, 0x23fb9ef4, 0xbfe66f7a, 
	0xbad1c5c5, 0x1c3ee426, 0x7fd8d1a7, 0xdf4d7fa4, 0x6a5df5a5, 0xbc681ad4, 
	0x65fe3047, 0x7e05fe35, 0x4ffd17be, 0xdae23028, 0x9afd79fb, 0xce8aeb49, 
	0xdfda2a30, 0xe12f2217, 0xd4ddd7c9, 0x9c5e305e, 0xe8f6a369, 0xa3a25a29, 
	0xe897e89b, 0x87d2d71b, 0xb6781cd2, 0xfe8cca8d, 0xc13eb99b, 0xf542df5c, 
	0x66319718, 0x63f409f7, 0x44be013e, 0xb5bef867, 0x4dc697bb, 0xd11b4532, 
	0xbad12637, 0xe9907bb8, 0xf0f168ea, 0xfaaab7ef, 0xd20f5b5b, 0xab56e9f3, 
	0x9ef34599, 0xd26b5839, 0x2d69d378, 0xfef6e882, 0x443b59d8, 0xbfe510b6, 
	0x7bf26dec, 0xd08efae4, 0x2175cafa, 0xb8f1771a, 0xdd7b674c, 0xedfd140b, 
	0x78d8bf32, 0xd112fa37, 0x612cbd35, 0x9fe8838a, 0xa27e686b, 0xc38f4c43, 
	0x5c60f019, 0xe68327ea, 0xda5b4423, 0x254f2443, 0x53a7d61b, 0x7deae7e5, 
	0xfa87bbf4, 0x0ac6f18d, 0x9a73c607, 0x9e1dcb1a, 0x5dbbb923, 0xcfe3c79f, 
	0x168e7451, 0xf889a231, 0x6633d3aa, 0xcb3bf509, 0x123c6274, 0x0cfcd12d, 
	0x262d5e95, 0xafaae886, 0x198ad6d5, 0x1a02bf34, 0x7baa03ff, 0xc05d1584, 
	0xb40ed5ed, 0xaa2b5e8b, 0x24cbd258, 0xb27b46fe, 0xd6544df5, 0xb5ce38d3, 
	0x34566f92, 0xda3a65cb, 0x31be6863, 0x42bc692b, 0x92b8d0d1, 0x6e59d3db, 
	0x126e9584, 0x9c959afd, 0xb50d2525, 0xb5ef8267, 0x68275b42, 0x88fb2fbc, 
	0x60d22ff8, 0xfa266ce2, 0x9dbd15ab, 0x30fee482, 0xcd0aece4, 0x0999d4a7, 
	0xeacafafd, 0xf3d26162, 0xdddccd1e, 0x2be7e343, 0x8a6525fa, 0xf6e1d016, 
	0xf944e102, 0xf1a3de2e, 0xe921517e, 0x16554bf8, 0x9fa70ae6, 0x92e93dda, 
	0xbb92347f, 0xb89dfa85, 0x79cdbda8, 0xc1ba7a06, 0xb69e790d, 0x4eb3def3, 
	0x4a8ce3d2, 0x731bcfd9, 0x447886fd, 0x25a1af08, 0xfc83278b, 0x030b44f6, 
	0x37380fe3, 0x66ef4fae, 0x03695bba, 0xfc215424, 0x8a7973c3, 0x70ac427f, 
	0x4e791d62, 0xcf46dc91, 0x7bd3f40c, 0x15779a5e, 0x92e89bcd, 0x3454b6b7, 
	0x4d67c079, 0x2211acc4, 0x7a237416, 0x0b0ac627, 0x3bd0f4e3, 0x9bd75409, 
	0xa7d0d3b5, 0x16cda782, 0xd5d72fd3, 0x9636fa4e, 0x39771be6, 0x1cc4beb8, 
	0xed9e2ead, 0x93a7158c, 0x2b3a241e, 0x3237e2ea, 0xc2249d5f, 0xcfad50a2, 
	0x4e7e679e, 0x86d1d3af, 0x06ce19f9, 0xbd1173a2, 0x9f2c1017, 0xfa1b40ce, 
	0x6bd3ab2b, 0x32d287e9, 0x8dbfb821, 0x7459fa75, 0x269dc657, 0xff1f92e9, 
	0x611ddb6a, 0xaebd6144, 0x218ce11c, 0xdcfa26ba, 0xeb4f5022, 0x88fa5d5e, 
	0x115f9bb8, 0x1472c9a6, 0x1a5e7825, 0x0b8297db, 0xf6c9a346, 0x4e414441, 
	0x6deff312, 0xcbbef414, 0x794655ab, 0xaec474b8, 0x59be7ea6, 0x7c7ee1ea, 
	0x921f3ca5, 0xb9d846af, 0xd12cda81, 0x61d48f72, 0x295c9f74, 0xa9206fe5, 
	0xa0bf9845, 0x2b3d1e1f, 0x7e7a34fa, 0xee62989c, 0xcb58e216, 0xad055a8f, 
	0xeb56e8af, 0xadbfe84e, 0xcf4ad1e7, 0xeb94ad9f, 0x403d9eb9, 0x517cec3b, 
	0x9d33af67, 0x273e3fe6, 0x3b3b8b65, 0x728a0f68, 0x5007b9e9, 0xb27e715a, 
	0x0733e507, 0xcb756797, 0xdb8798f2, 0x437bfd93, 0x2f3fbef4, 0xaf7d9059, 
	0x3d223d81, 0xfbafefc8, 0xbe49ec29, 0x721e37bb, 0xb6549038, 0xaf990f5e, 
	0x5f2c672d, 0x2cbf13b0, 0xaaa27693, 0x0559d3df, 0xdbf33239, 0xe3753f61, 
	0x981b1ddb, 0xd136d3be, 0x3cd305fb, 0xcd3b443b, 0x94dba563, 0xefe56a72, 
	0x3fbdbe25, 0xd9f9bbee, 0x95ae17a4, 0xa8b217b5, 0xc38cfade, 0x75d69fb9, 
	0xf8a7cd27, 0x7eebde32, 0xe5efd05a, 0x20937a57, 0x5a074c24, 0x593e415f, 
	0xc0e3e273, 0x5deb8dc5, 0x12df691e, 0xcfc5bec8, 0xd61bca0b, 0x5be6ae57, 
	0x9e97cf6e, 0x2a2d7697, 0xcfb4bb63, 0xfcd2b51f, 0x2f46c93c, 0xe5ec9de4, 
	0x9e85b30e, 0xee5d2e2f, 0x4ad378c4, 0xf085b797, 0xb9e5c621, 0xdb3e7bb4, 
	0xad7627ff, 0xf4ebb10b, 0x9cf619bc, 0x1f9ee1f9, 0xb57139e1, 0x37ea9d63, 
	0x2b50f98b, 0xffeb9ec2, 0xce7e6ee5, 0x15db76fa, 0xf7fca7e9, 0xc2257f53, 
	0x4fc3ba05, 0x9fc33fc1, 0xa28a1a91, 0xd1d7cc87, 0x5ba1f90f, 0x7efa4b77, 
	0x7a213904, 0xeb7ca53a, 0xdbe3df2c, 0x9258f5b2, 0xd9b5ed93, 0xdeec89a2, 
	0xd114daf8, 0xb64d7a84, 0x81f54cde, 0xfd084ff5, 0x9678f4a7, 0x65912bd4, 
	0xdd7fe13a, 0x0fa12164, 0x04f0ba03, 0x6e1dbe48, 0x9f8e7f6a, 0x7e7d094f, 
	0xd65c53bc, 0xfcf7f806, 0x934c7eb0, 0x322f11e7, 0x55031e78, 0xc7b50fd4, 
	0xd0cd9fa0, 0x163ed96b, 0xfe7b50e3, 0x835d52da, 0xc725debe, 0xbd4b768b, 
	0xe45f6717, 0x7d2964f9, 0x9baaf81d, 0xfb54b3db, 0x0e135b80, 0x53863bb6, 
	0x33d20d8f, 0x34ec893f, 0x2db673f4, 0x8b7e5617, 0xb238b392, 0xae483bb7, 
	0x0ed96bdc, 0xae58d4af, 0x0ff0c9fc, 0x07939045, 0xe9ff9760, 0xa4d4f010, 
	0x805f973b, 0x330e31dc, 0x1b907f64, 0xcc0f0f5b, 0x503afa93, 0x3f4c31be, 
	0x0dbc948a, 0xf972b7e1, 0x4566bd1e, 0xba3f400d, 0x23fedd7f, 0xbb0963b6, 
	0x037f53d6, 0xd20e49bd, 0x2b6a81b7, 0xfa51b1ca, 0xb6d7fc3d, 0x212ee597, 
	0xf29ca53a, 0xe24dc2bf, 0x06bbe08b, 0xca1d10d6, 0xadf8cdd3, 0xabd377a4, 
	0xa4f1bdcc, 0xda2bd377, 0x2f513a26, 0x3f8d3aa1, 0x46565a7d, 0xda5e7aaa, 
	0x94df2b41, 0xff824eeb, 0x1380fcc3, 0xbced1f40, 0xf228a3d4, 0x160749ef, 
	0xc2742cae, 0x0879bd6f, 0x75a468f6, 0xf4837a75, 0x8850f5b0, 0x4eb5ad6a, 
	0x8b9683e2, 0x49e61b84, 0x84e2477a, 0xc66f4572, 0xfd28cf09, 0xc1f857ec, 
	0x1bd3d413, 0x8a750fc5, 0x8d8a5fbf, 0x2e1f8649, 0x2fec1dd7, 0x916cce9c, 
	0x85eefe49, 0x8d7fd279, 0x27802f86, 0x9c626f4e, 0xc3eca391, 0x2ebcadec, 
	0x95cf1f23, 0x7960a95f, 0xd310edb1, 0x77e995b3, 0x70a3fe08, 0xb417c3e6, 
	0xb47b4133, 0x07ce52af, 0x139509eb, 0x29152edb, 0x9f691bbb, 0x7e3d3c6c, 
	0x9ad1518c, 0xf3adc426, 0x2a2e9fa4, 0x2e9a2a9e, 0x8c9eff01, 0x7ff52edb, 
	0xafd816df, 0x6a7b896a, 0xf470c29d, 0xa4c1f108, 0x4f989d3d, 0xef1bde91, 
	0x13a77c86, 0x4bf2a77e, 0x677d14ce, 0x0dab109e, 0x4d3cb389, 0xbcfebdea, 
	0x4160e00a, 0xf7a568f3, 0xb72410c8, 0x89cf919f, 0xfc794175, 0x0fc1ff52, 
	0x9e412ea3, 0x151cb34e, 0xac9cd15d, 0x141e8a3f, 0xad6be487, 0x1e39bf58, 
	0x5fd2daf4, 0x9b7681d7, 0xc5445b3e, 0xa05dc861, 0xbcfbe252, 0xb3f9155d, 
	0x61f4825b, 0x6e181bf9, 0xa1466bbf, 0x44cc2193, 0xbc04538c, 0xc94c798b, 
	0x75fe81db, 0x28ccd0a7, 0xec224fe6, 0xd9d3e98d, 0x9a5795ae, 0xbd3cf0db, 
	0xa0bd40e9, 0x8fb2ec92, 0x90eb81e5, 0xa6a3b627, 0x65484b8a, 0x21096eb9, 
	0x1d656bdb, 0xe9f6a42b, 0xd84d39cf, 0xa5fa7ca9, 0x72c9e581, 0x46b8f3f4, 
	0xcb2a25d2, 0x26df9f67, 0x892b3c78, 0x87b3279f, 0x9e781de7, 0xaffa6ce4, 
	0xa3dd7267, 0xa52a27ea, 0x555bff1f, 0xef9552fe, 0x840f52eb, 0x171ae893, 
	0xfbe9e3d4, 0x0c2d4ec8, 0x68eb17d2, 0xa6bdbe21, 0x8cea8ee4, 0xda430c7b, 
	0x41ffd151, 0xd9fbc614, 0xdd65132b, 0x7a8e8cf3, 0x95ce5fe6, 0x27cb98f5, 
	0x80120760, 0x917fa8a7, 0x9040d83e, 0x4a93bc42, 0xf251f788, 0xeb42c9cf, 
	0x6e391d84, 0x7b770236, 0x81a71966, 0x942e0787, 0xcc9e87ad, 0x52283850, 
	0x46f887ce, 0x259e21cf, 0x9b6ef09c, 0x4efe83b4, 0x658b91f8, 0xe82303eb, 
	0xf6df9047, 0x28ffdd7b, 0xda29a7ed, 0x1394cf11, 0xcb5cf13e, 0xfe3196fe, 
	0xa4f58c4d, 0xf7e42db6, 0xefd2b496, 0x031ac2dd, 0x1d1191fa, 0x78d9fa03, 
	0xadf23ef7, 0xff2c7931, 0x681ca463, 0xd706ef8a, 0x6c5c956b, 0x7e747d21, 
	0xfc98f80b, 0xcf7e79ff, 0x9c66e98a, 0x854fec9c, 0x3538965d, 0x4dc64f30, 
	0xd3114e59, 0x7516e340, 0xe483ba98, 0x31185b2d, 0xc269bdc0, 0x0a6d03d2, 
	0x5d7f12d7, 0xd479723e, 0x1b63e27f, 0x84319cb2, 0xb3079b2b, 0xeca654dc, 
	0x459d90d9, 0xc191da65, 0x9159d26c, 0x1c86f2f1, 0x9cc7d52f, 0xa629cc1a, 
	0x374ff67a, 0xf54a54dc, 0xbc1c3e9b, 0x3c3f9049, 0xbd26fd0c, 0x0de3f9bd, 
	0x8faa4eb9, 0x6172b41b, 0x3d0fbfc7, 0x1c0f79a2, 0xf8130a77, 0x85a79bf5, 
	0xeef540d5, 0x8fc2612c, 0x7c0b3c2b, 0x6a4f561b, 0x3c6b5c63, 0x34045672, 
	0x9e02fb89, 0xda8bf06b, 0xc7d7bd3b, 0x88d38985, 0x8ec5c07e, 0xe2f2bab2, 
	0xa71e7f60, 0x795e8270, 0x7603dfe4, 0xefe1f1fb, 0x0e2a5c7b, 0xc9d5a399, 
	0x71c5877c, 0x9c546fc7, 0x1c6fa892, 0x24f617ea, 0x1c6f767f, 0x9fee0fe2, 
	0x7a78c5ec, 0xc7b07c1e, 0xe2a39c49, 0xf867850f, 0x1dc611fd, 0xb91d7d98, 
	0x2ee52d9b, 0xad8850a9, 0xe29bfe21, 0x15f836b0, 0x9d9863f8, 0x6bdf58c4, 
	0x7fd1f3ed, 0xbf9de3ff, 0x861ff394, 0x8d1f08e3, 0x06fc21af, 0xf1bd549c, 
	0xf55b70c6, 0x5b7191c6, 0x9cffc6f5, 0x8d82edb8, 0x9db70823, 0x15b71d1f, 
	0x1e56dc29, 0x1c6cdb81, 0xd9117131, 0x1fd956c5, 0x9fed84fc, 0x3c7f86bc, 
	0x157debf4, 0x6d7eda47, 0x3c3bcaa6, 0x5bda4f35, 0x9b256831, 0xa534ff14, 
	0xfe29523d, 0x3374098d, 0x8edb11fb, 0x47c84ed6, 0xb7f7edbd, 0x79e0fb4a, 
	0x7683db80, 0xd805d8f4, 0x8ecacdd1, 0xa9df696a, 0x9ec0afd4, 0xdb943f1e, 
	0x7fd7a54c, 0x7e63fd00, 0x17d1e923, 0xfe613e68, 0x5bc482ee, 0x31c5bcf6, 
	0xf48db92b, 0xce40fff9, 0x2d9e62d7, 0xcfe1e295, 0xc33b9e63, 0x0cd479e7, 
	0xd3e7a79b, 0xf9c8e7fa, 0x7e721f92, 0xe087e212, 0xbaafe0a7, 0xabf846cd, 
	0x6f13856c, 0x93bd3fd4, 0xeff3914a, 0xe4aa7e83, 0xe034278e, 0x610ca4e2, 
	0x26491e30, 0x36384eff, 0xec6116e9, 0x37c3fd44, 0xa5179ad9, 0x242dad5a, 
	0x56f14527, 0xe577f22b, 0xc0eb4f14, 0x3bad3355, 0xd0427ca5, 0x4f1577e9, 
	0x3a78ab97, 0xdc867e34, 0x2b530d38, 0xb4583e25, 0xe21d6d7e, 0x8871f3e9, 
	0x5295a7a7, 0xfd9abd1c, 0xe69fb248, 0x6b844a59, 0xab3efb22, 0x28e1e0ff, 
	0xe694b71a, 0xe403f514, 0x1dd9ac97, 0x9a6633c8, 0x46e2dc3f, 0xa8dcc97e, 
	0x4689e770, 0x63c033b2, 0xa6fde59f, 0xc52bd7b4, 0xde8f30ef, 0xcfebf864, 
	0x0d3f1f2e, 0x24e38f97, 0x3e32d91f, 0x1588f962, 0x3545c76e, 0x79e1bfdf, 
	0xabcffb24, 0xf0d567f8, 0x9771dbf9, 0x32709667, 0xa7ec877d, 0xd60f1f94, 
	0xfa0d7557, 0xfffec964, 0x9624fa54, 0x108e756b, 0x5f1891bf, 0xc908e751, 
	0x0dfa455f, 0xfb656f3b, 0xb79d8f0d, 0x79932f2a, 0xc46fdb2a, 0x647e946f, 
	0xee156f28, 0x5c3f3e3f, 0x718f3f16, 0x5ae563d9, 0x6d7d60ba, 0x22bddc64, 
	0xc03ec0e0, 0x92cff575, 0xff3ff7fa, 0xcd23fd64, 0xedbfd10d, 0xb9013fd0, 
	0xf21e69bb, 0xeb3de299, 0xa2bb9273, 0x10bafa79, 0xb926ebb9, 0xba4bdfa3, 
	0x099f9ec9, 0xfb08bf91, 0x67111454, 0x4097ca45, 0xb0f1c29c, 0x21b88c96, 
	0x0e5dd718, 0x12f2eb8b, 0x3d9c65ee, 0x9c93e76d, 0x0938c28f, 0x554be724, 
	0x5f8ec9be, 0x77f9af10, 0x018fb70e, 0xc375f3d8, 0xf95197e3, 0x3237f1e3, 
	0xf0de887f, 0x2d3eab7f, 0x352fa27f, 0xf9063fc0, 0xc3e594b3, 0xe655c771, 
	0xaf0596cb, 0x43272038, 0xfa47f6e3, 0x3ef3e591, 0xd5f23f1f, 0x7ed97e70, 
	0xe989f144, 0x57e2bf74, 0xd97e70cf, 0x57e48af4, 0x5283da53, 0x5e7f2eae, 
	0xf0adf572, 0x2cfc7a79, 0xce138c57, 0xe45efd04, 0x31e707be, 0x73ee081e, 
	0xbc1efbd8, 0xfc90929e, 0x845bca86, 0x1daa37e4, 0xf0bf951e, 0x8bc5bca9, 
	0xe7697f41, 0x1af20449, 0x460559c0, 0x8b1bb296, 0x3e6478b6, 0x4edb7c08, 
	0x724090f2, 0xb114eb97, 0xb47fc9c0, 0x66d7f5e9, 0xcde58034, 0x7d8588c2, 
	0xc3c3431a, 0x63edd93e, 0x3f3f269d, 0xf8b1584e, 0xc669c73d, 0x487fbd84, 
	0x5137fbf0, 0xc9f78338, 0xeffbf28d, 0x95b8fd8f, 0xe4a340f3, 0x950fb1a5, 
	0xa1e65ab1, 0x11284721, 0x362b4c3b, 0x8c1f86de, 0xf2da57cc, 0x8f8abcf7, 
	0xf87b3f3e, 0xf43db87c, 0xe1ecc3fa, 0x11ce48b7, 0x6ef8d8ff, 0x3930a669, 
	0xab6e443f, 0x8fe64d25, 0x037c3710, 0xe648f8f4, 0x0d7e628d, 0x799bfbb9, 
	0x7d2f47ec, 0x8567725e, 0xfca59dcb, 0x567075e8, 0xcc8abe24, 0x734b8b63, 
	0x45ef1e78, 0x4479e74f, 0x4ce74f7b, 0x7a30f8a1, 0x394e60c2, 0x5be8f8e1, 
	0xd4d3ee8e, 0xd4c7d2fe, 0x6f694bef, 0x347a8bcd, 0x56066788, 0xfe906c9d, 
	0x14e872cf, 0x5ae7464f, 0x51e216fe, 0x5a29b974, 0x76fbec4c, 0x46bdb747, 
	0x1dde8271, 0x1e91adb5, 0x5f6a152b, 0xf4ebc9c5, 0xb7a07bd1, 0x63abd6ab, 
	0x7316e2bd, 0x1259f613, 0x58a69ebc, 0x9581ab92, 0xa7ef26a5, 0x49e528ac, 
	0x4721ac0f, 0x146dfd24, 0x781898a9, 0x289fea9c, 0x0f79a079, 0xa4ebb66c, 
	0xb3efa832, 0x7e75379f, 0xf7a1b9fe, 0xdafeb9a3, 0x9e0c7b50, 0xa03e60f7, 
	0xf50edfeb, 0x12e78313, 0xf022bd6a, 0x457dfa2b, 0xe6513ef8, 0x0162d29a, 
	0x7bf6adbf, 0x3aa09f32, 0x395afafc, 0xaaedccdf, 0xbdf554dd, 0x4dbd641b, 
	0x06dcff3d, 0xaab77cf9, 0x67eaaebf, 0xa40ff3e5, 0x3f015525, 0xfd50fe65, 
	0xc4e7c96e, 0xf30a232c, 0x7a92aa4c, 0xba0fa913, 0xa844d4c7, 0xe03f7bbc, 
	0x6e041ff6, 0xed65f293, 0xf57f51d6, 0xc3bfd058, 0x9c9eb18e, 0xcf505e81, 
	0x24f5068f, 0xbda136e6, 0x6a8d7182, 0xdae44f7e, 0x85cb2ef9, 0x73dc52f7, 
	0x7540382b, 0x9b3bd60a, 0xd4774cbf, 0xb1f9433d, 0xf61bae18, 0xd7237e3e, 
	0xddd5532d, 0xafdb9622, 0x9b59fcaa, 0x5a6ea170, 0x7063ddaa, 0xe50d69dd, 
	0xbc729c59, 0x3a3e7b42, 0xf23a69e4, 0x721f342b, 0x2ebcd162, 0x19e64bb2, 
	0x39f44f9e, 0x2369e23f, 0xc56efe46, 0xf7f90b98, 0x9e7eabd8, 0x0374f39f, 
	0xcb3ceeff, 0x9ef711a5, 0xfd71eb83, 0x97f11a5c, 0xb2fe3d64, 0x94184f6c, 
	0xab8c04f5, 0xd8588c7b, 0xb8e8bd0d, 0x42451dcb, 0x62436b36, 0xa5b19516, 
	0xe1ec2256, 0x8bcca140, 0x01678838, 0xc26f9c31, 0x58ed957b, 0x596ce2fe, 
	0xd33cfcbf, 0x33b7e5bb, 0x6669fa6c, 0xa1855f28, 0xfc421851, 0x15f92f9a, 
	0x2b70dfdd, 0xb896e4f8, 0x4226e1ce, 0xaedd7d61, 0x781bf47c, 0x5ba616f0, 
	0xe3656dc1, 0x2e9e284a, 0xb8cafb9c, 0x77bd2a72, 0xc2747994, 0x7bee93c0, 
	0x72a2e3c5, 0xe5965fca, 0xeb7953a5, 0x23c95f77, 0x7826219f, 0x985db0cf, 
	0xb613e130, 0x796e130b, 0xec2ec876, 0xa5f0bb61, 0x8fdfa8aa, 0x38cc1764, 
	0xfb0985d8, 0x4bdf3f7d, 0xa7427236, 0xca8c5049, 0x873f7c87, 0x90f0989d, 
	0xfea2f629, 0x38edeed5, 0x9561313f, 0x852db679, 0x79ef1de6, 0xded93b67, 
	0xb5d980e2, 0x7ac5ea8b, 0x02e76545, 0xd3c27f6a, 0xca08f5b3, 0xd5ddadee, 
	0x1e6abe54, 0x13ed403e, 0x1ce4f79e, 0xf75f7b45, 0x5445cd91, 0xda5eb39e, 
	0x655ced22, 0x07aa21e3, 0x3629dfa4, 0xd13274b5, 0xe902ece2, 0xffd18677, 
	0x73d720f2, 0x7ca4b206, 0x4327a28d, 0x7ef457f4, 0xd5e7f527, 0x3e8a9b8c, 
	0x785278e1, 0xa075fe89, 0x7906855b, 0x7f0bc470, 0x5f1a4ac3, 0x0b7585c5, 
	0xb49e3fa4, 0xc4efea40, 0x0764fe55, 0xe989bdf9, 0xd7ec66c6, 0x6cb3bc4d, 
	0x277df639, 0x9f78273e, 0x8b5fe270, 0x17d47ee5, 0x7bf72de5, 0xf09e7482, 
	0x49d648bc, 0x2f3d27ce, 0x9518fd0c, 0xf234557a, 0xb03f85f3, 0xb9e81b92, 
	0xc38cc7a9, 0xbde9fb3b, 0xbd4e7925, 0x4bb1fc98, 0xe929dc4c, 0x68702872, 
	0xcb6b7184, 0xe38c0b96, 0x674396d5, 0xcb151e27, 0xf26bd435, 0xe3a16b96, 
	0x1192d14e, 0x4f3e16ff, 0xfd56ace3, 0x6ff60a5f, 0x85391fef, 0x439047f7, 
	0xfd64c38f, 0x07d584d3, 0x8fa138ba, 0x0b559724, 0x43da3dfe, 0xd2db4f0f, 
	0x0b453f3e, 0x9c655ff6, 0xb2109a98, 0x8eff650f, 0x6fe811f3, 0x6715a34e, 
	0x0ca0a69e, 0xe3ec8ff6, 0x6d1dd5dc, 0x67732000, 0x1f7f2e13, 0xcf3bfad9, 
	0x94536f22, 0x53a4f32e, 0x3f688c8b, 0xa5f74df9, 0x93809b99, 0x373a8e53, 
	0xb76bbf21, 0xa21b3857, 0x3f49ff91, 0x780fb674, 0x7158b45d, 0xc8176cad, 
	0x917db04f, 0x5f7d30f2, 0x7f6e26ca, 0xa76b8acf, 0x89f74af6, 0xf4d9d868, 
	0xf87553bd, 0x8e5979ab, 0x94b7ae18, 0xcabd47cd, 0xe7831953, 0x7f4a8fd3, 
	0xdfd67f36, 0x3b214cc6, 0xecc160b3, 0xe23f12d8, 0x33a37bfe, 0xb7159169, 
	0xa6e3da1d, 0x6ace54b5, 0xe4853c78, 0xaa5cde79, 0x1a7d019f, 0x0ca5c7b6, 
	0xeb68f75f, 0xc9ee637d, 0xc8f1e02a, 0xb70120f3, 0x795e03c8, 0x95e24aad, 
	0x79b9a5c0, 0x8fea7e7c, 0x8ec83784, 0x6193778d, 0x9a7c801c, 0x4f128db1, 
	0x63bd60d6, 0x47be8e45, 0xa3672fc6, 0x4e2e3e29, 0x4ed19ab2, 0xe8334d71, 
	0x0744bc25, 0x5e994769, 0x0b4649c5, 0xceda6fe4, 0xf6c116ec, 0x76ca70cc, 
	0xc37689c3, 0xbd11c341, 0x41df22c7, 0x7de25572, 0x9ce04e23, 0x34ea938e, 
	0xef695148, 0x2a87de02, 0xbb61a8ad, 0xbef17e85, 0x7a21c687, 0x9d7a4b78, 
	0x49e7927e, 0x902af253, 0x7e5f1d4f, 0xf1f345be, 0x8d65ca7e, 0x2e4982e2, 
	0xfcdbcf8b, 0xf8c17cd3, 0xeea6a134, 0x487b9c6d, 0xfa4952f4, 0x73f855e1, 
	0x9657dc98, 0x94fb3d49, 0xbe85e6fa, 0xd23fa315, 0x53539c37, 0x7d0c56fa, 
	0x9bea85f3, 0x2df4a559, 0x847f25b5, 0xa9328d71, 0xdf529f67, 0x37d30fc6, 
	0xd5a7ffd9, 0x497379b7, 0xa6ee48df, 0xf9be9236, 0x2bcffd83, 0x2d71dcad, 
	0xc95dbb7d, 0xa4b5465d, 0x87d59ceb, 0x651670da, 0xe28fe40e, 0xbeffb9b2, 
	0x8adf4c3c, 0xa3b16fa1, 0x3e219beb, 0xeb4dbe9d, 0x0ab7d708, 0x36b7d2a7, 
	0xe87eb7d2, 0x9337d29f, 0xfa1fadf4, 0x556fae17, 0xd1be91b7, 0x92e7aaa2, 
	0x553951be, 0xb4519be9, 0x1f7719f2, 0xeee1aef4, 0x1de876d4, 0x0d3e99d5, 
	0x4652bb8f, 0xebacff5f, 0xced23fac, 0xb1f63fbf, 0x1fa96ecd, 0xe27fac0e, 
	0x9c26decc, 0x40bbd90f, 0x4f098de5, 0x60975f20, 0x68a3f36a, 0xadd8a2be, 
	0xb746fd61, 0x4bb53bc2, 0xc8366eb8, 0xbda17d7c, 0xc7e247af, 0xc469c9fe, 
	0x75fecab7, 0xf42e7bf0, 0xa308f90b, 0x8178534f, 0x35e93bcf, 0xfc877fe7, 
	0x1a2c3537, 0xcdbdf934, 0x28bdf22d, 0xcb9145c8, 0x36e857ee, 0x7def536e, 
	0x36f7c9ac, 0xc742d59f, 0x38aa7893, 0xf9e43857, 0xf253c239, 0x5fde18bd, 
	0xf93e7bc7, 0x7bd840de, 0x98719622, 0xe22a1c87, 0x8dbe4f21, 0x605c64e3, 
	0xed5d5478, 0x0e92186b, 0x1fe73531, 0xbc65be46, 0x3ec29da9, 0xf72ae83e, 
	0xcc588d2f, 0xe8ffe27f, 0x0adf826f, 0x8c7d71c5, 0xdf3e4ccf, 0xf777e736, 
	0xbe1f809e, 0x1cf35ffd, 0x7f94e348, 0x4051d070, 0x5feb9874, 0xe7a2481e, 
	0x8ba95ee7, 0x9ebc98f2, 0x7191ef6f, 0x8c76cfe7, 0xd29fafa4, 0x27617b2f, 
	0x2fc46ffa, 0x94ec0f5b, 0x7adecee3, 0x686cbf2d, 0x4ec51cb2, 0xf346ab78, 
	0xcfffb2cb, 0xbe1b97ee, 0x7d783099, 0xca37fcbf, 0xf7d7fefe, 0x94978ecb, 
	0xb1a5f65f, 0xf4baa65f, 0xda12ebcb, 0x747baf87, 0xfcd2fcbf, 0xbfe5f96b, 
	0xe8f12f9f, 0x3cbf557f, 0xe8997e01, 0xfc8aa938, 0x7ee8f772, 0x1b1fc879, 
	0x4fdc9254, 0x9267ca18, 0xce0ecc1d, 0xbda2f603, 0xa8be4435, 0xa7b886de, 
	0x3d874f26, 0xccbe70fa, 0xe2fddaa3, 0x49b3d87d, 0x1d1d75c5, 0x23c4eed2, 
	0x60e7894f, 0x5a252767, 0xf51cfc35, 0xcb7142d3, 0x9f1d9437, 0xe2b56051, 
	0x2bcd073c, 0xcd16fd1d, 0x9cf85ab6, 0x82b453a7, 0x9c3e7fce, 0xfad93460, 
	0xffff8e6f, 0xff641381, 0x884e379f, 0xf9a38ff4, 0x66e637c5, 0xbfcb8756, 
	0x67c543b9, 0xff8ff6bf, 0x2a1b84af, 0x407b0c7f, 0x7a5561b8, 0xd502ec0a, 
	0xc37104cf, 0x6947a7a7, 0x80f688f5, 0x31bddff4, 0xaa73ffa8, 0xd51f5e25, 
	0xeb660c0e, 0xd887ce7b, 0xdb8fbd01, 0xc5196ea7, 0x7c55e80e, 0x96ea7bae, 
	0x8d80ed91, 0x303b6c1f, 0xc2e0761d, 0x8503b7a7, 0xf01c5a25, 0xb48a77b9, 
	0x03b00503, 0xe03b41fd, 0x30b88975, 0x7970a03b, 0xc789ae08, 0x1c2192bd, 
	0x503b1d73, 0x80ed2d5f, 0x076dafdd, 0x076459bc, 0x007683fa, 0x780ec1cf, 
	0x83520761, 0x77eec076, 0x201d8469, 0xb37f4a31, 0xb703d941, 0x2f60e710, 
	0x21e7c5be, 0xd10f698e, 0x1f4fd0ef, 0x12e8cdd7, 0xf3d6e7a2, 0x822cbf9c, 
	0x5d869ebe, 0x61389528, 0x176436b6, 0x84c92790, 0x3e79a01d, 0xcdcf2d5e, 
	0x9b693427, 0x5a5a9f50, 0x8d58e9e7, 0xce3c457a, 0xf9544d03, 0x8b69e80a, 
	0xbbec4bd2, 0xb79add4d, 0xea4eae29, 0x7fd10b6d, 0xe7dcb553, 0x51f987d9, 
	0x8df53c1c, 0x92e7e657, 0xd25d96be, 0xf6e13f78, 0x888c5a4b, 0xa63f5d1b, 
	0x3d4e1016, 0x8aea6485, 0x5b7fd04d, 0xf31e663f, 0xb43eb347, 0x9cbfb1e4, 
	0xea57bc75, 0x135e694f, 0x28df4bda, 0xf8d0298b, 0x49eb109e, 0x58cb6ff9, 
	0x4812664f, 0x6fafc074, 0xbdc68fab, 0x91ef319a, 0xceb920a1, 0x8f9077a2, 
	0x8df352ee, 0xbbbe792c, 0x373bfca4, 0x44bffb86, 0x8a53f7a2, 0xe697f07f, 
	0xc576124e, 0xe480e28f, 0xb1f975fb, 0x6f3b0b48, 0xe1f1513d, 0x143e0885, 
	0x6dad5ba5, 0xdadf217b, 0xe79094f2, 0x8de9fc83, 0xa2d139c3, 0xd75bf480, 
	0x6a2bcfe3, 0xfe513f7d, 0x882fea66, 0x2fa7443f, 0xccfe4a0c, 0x7f1ebc1d, 
	0x0c161f48, 0x15a94fe7, 0xd3b29fce, 0x79353f8a, 0xff66bf6c, 0xfca7f242, 
	0x733f92b7, 0x53f928fe, 0x1dc72fda, 0x286f3f8d, 0x792c8a7d, 0xfc82bbbe, 
	0x7492ae28, 0xf5d639ff, 0x8827b491, 0x60776073, 0x1fa4c90f, 0x4721b9c3, 
	0x1dbbf5bc, 0x3d374f0a, 0x6781ed4d, 0x539f7f19, 0x5ade28f4, 0x942998e1, 
	0xa7f7a5bf, 0xc0e969b5, 0x2c4251e9, 0xfd9136b4, 0xa07651c8, 0xd07e5846, 
	0xe4cea8c9, 0x3ec0a0b8, 0xde08695f, 0x75566947, 0xc88cc8a7, 0xe446673f, 
	0xf3c2b39f, 0xbc2c81cf, 0xce7f921f, 0x552ef6e6, 0xf60b2c37, 0xbf3b5efc, 
	0x0fbe2c2d, 0x63ddb9a4, 0x18d93e64, 0x71cf2833, 0x4d40f9f2, 0xdfc966d4, 
	0x62f7acad, 0x7996ccb8, 0xf05b2358, 0x62e722ef, 0x672bcf13, 0xd3714b80, 
	0xe9bf5915, 0xf6e7acaa, 0xf73d7335, 0x426f2a75, 0x7f85789c, 0xf91df9bf, 
	0xa8e7cdfb, 0x3da6581c, 0x22183fea, 0xbefb2ecf, 0x6eadc7c7, 0x4b456bb2, 
	0xd4ede9b4, 0x7e105cee, 0x81626b6f, 0xbf437cc1, 0x34ff9c09, 0xeafcc26e, 
	0x1731af89, 0x9eb83ce5, 0x7f383c25, 0x91cff341, 0xa62e35fb, 0x76ac5fef, 
	0xceb4b1eb, 0xf31c4b7a, 0x225d6097, 0xef587207, 0xb452ff39, 0x6aebae4f, 
	0xd875f0cc, 0xcbbf8ff3, 0x1fce137b, 0xf240bcde, 0xe669c9bf, 0xe317e499, 
	0x0f7ed516, 0x366b507a, 0x48f7057c, 0xf063fc68, 0x7f38f577, 0x63cf10f6, 
	0x4cbf9f2c, 0x7ce2eb6d, 0x7fdeda6a, 0xc6dfb8c6, 0x81c44bf9, 0x1189046d, 
	0xf7b4af37, 0xa1b18dc3, 0xe40304fb, 0x317e7063, 0xfc4f9d4a, 0x7007f636, 
	0x45a63e8e, 0x7bd1f798, 0x808b4fab, 0x5a571a1e, 0xf111f00e, 0x7ff8ec3a, 
	0xd9ffe9c7, 0x4cab74e2, 0xdd7fe9c5, 0xdf023f9c, 0x9e6f89aa, 0x779be71b, 
	0xc8c73ce8, 0x4f8a1b7c, 0x616f9bfe, 0x1ffb9b7c, 0x7e736f92, 0xfb76f92f, 
	0x19be4abf, 0xc66f92ad, 0xc66f9b55, 0x5f6a3dd8, 0xdf123026, 0xf4d3fd6e, 
	0xf475c26d, 0xf6f9bfed, 0xbe26f959, 0xb3f6f8a2, 0x9f94872d, 0x8b88327e, 
	0xf2b66fc9, 0x39158739, 0xbe58cfbc, 0xd7cf3666, 0x6ea597f5, 0xf493789d, 
	0x176ee3dd, 0xa51dee95, 0xa654e929, 0x253c753e, 0xbff4ca97, 0xa02d4d2a, 
	0x8e1ff332, 0x32a14ea7, 0x7f3cb571, 0x3c80f890, 0x8df8907f, 0x8cfb11a3, 
	0xbc8c1617, 0xec3428cf, 0xb3ae2633, 0x9449eb44, 0xd1315f72, 0xf623fbe5, 
	0xe65d1315, 0xa76abfb9, 0x3da12ef2, 0x71377849, 0xddb515ab, 0x8ffcd28f, 
	0xb3e487ef, 0xcd0af512, 0xdf45cf4f, 0x3ae3eea5, 0x8d22f685, 0xd843505f, 
	0xc2fda465, 0xf79bffe3, 0x24bfc56b, 0x7d5f735c, 0xf8e17ef8, 0xfc2fde1a, 
	0x7ed860fa, 0x836ae261, 0x5d330bf7, 0x1351ef82, 0xe7f0fd3f, 0xf4c453d1, 
	0xbfa0bcf6, 0x4f21dfe7, 0x3f6b4205, 0x7a6b3289, 0x27a244c7, 0x203dc3de, 
	0x81e22f9a, 0x5d678081, 0xde9444fb, 0xb2cfed75, 0x239da45c, 0xb4f4b55c, 
	0xf747f3e0, 0xe54e7fc0, 0xba93df3a, 0x7c917e07, 0x4f53bc65, 0xefd2bc83, 
	0xb87eb20f, 0x4dc48645, 0xb3dddf6a, 0x41d2433a, 0xbd81aee2, 0x6fff3e6e, 
	0x34967a3c, 0x869dd799, 0xebfbd0f5, 0x5f7bcb05, 0xea7f7d9a, 0xe94bc4b4, 
	0x7f053eea, 0x9018807f, 0x377f9179, 0x31360733, 0xe15cc73f, 0x55731cd2, 
	0x24fab3d6, 0x5d7aca4e, 0x77eca4e2, 0xd6ad1fb0, 0x9f67bf49, 0xff0ddfe3, 
	0x0794a65b, 0xbf4893e4, 0xec87d4b8, 0x712c9983, 0x386c755d, 0x3192b48e, 
	0xe7839b9f, 0x70236218, 0x8e046c64, 0x91c08b8c, 0x52386171, 0xe7610918, 
	0x3244da12, 0x9f1b2bdb, 0xf4392308, 0x19bd317e, 0x1dcf7a0b, 0x76e0b73a, 
	0x4e0b73aa, 0xf9c13e75, 0xcbe3037a, 0xc91f7938, 0x8bbf938a, 0x9f528bf8, 
	0x14b807e3, 0xfcf28309, 0xc8d58242, 0xcb4ebbef, 0xb3ae4d7b, 0x9ef89eb2, 
	0x7b84e7ba, 0xe46b2b47, 0xeea10fbd, 0xcda2391f, 0x70a3e7e4, 0xc64cc4af, 
	0x12c48579, 0x1593fc7f, 0x79f81654, 0xc3f49edf, 0x5447f471, 0xf7c5fba6, 
	0x25c4ade8, 0x9e4ff1bd, 0x7fcab2a0, 0xf40768f4, 0x99b19fcb, 0x68e1b2fd, 
	0x57df78a4, 0x8b43eca3, 0x724fc3be, 0x0fd13b7c, 0xe016f338, 0xb78fc23b, 
	0x1d59c53b, 0x1fbce075, 0x33c59cb0, 0xe7dbf65d, 0xe43de83f, 0x8a2c2853, 
	0xa75c18ba, 0x63c467cb, 0xff2e8b7e, 0xbe686a43, 0xfd1fbed4, 0xb7c48d60, 
	0xc64c7303, 0x017dc077, 0x94cf7813, 0x3c85adf7, 0x5fa1d17f, 0xec8bb858, 
	0xf358dec3, 0x37a493dd, 0x8903a207, 0x1dae883b, 0x8762f301, 0xb1f027cc, 
	0xaf0afda4, 0xf9d25f45, 0x458921be, 0xd504fc03, 0x36f66f59, 0xef6c7d5b, 
	0xe68c8f71, 0x2d55f4dd, 0x6a7ff91e, 0x3e90507f, 0xc3ff46e9, 0x8bd7d642, 
	0xbc57f462, 0x839ceb13, 0xf1be4915, 0xc1b3323d, 0xf262d73e, 0xe2f43bf7, 
	0x24515382, 0x942caf0f, 0xbe201ddf, 0x1d691769, 0x9765a455, 0x5c279ca4, 
	0xb84ffc91, 0xf571fb2a, 0x9f7e4a35, 0x34fac46e, 0x24e255b1, 0xba2077fe, 
	0x9f7941e1, 0x4cf870c4, 0xb44453ac, 0x6fdbc207, 0x6c75af16, 0xd70c7590, 
	0xff5e106e, 0xbe15cc90, 0xe783d1bb, 0xfbac0af5, 0x08a04940, 0x9b637bef, 
	0xef54fcf3, 0x24581cba, 0x08b35ae3, 0x3abb03f7, 0x15ee2775, 0xb6d1e936, 
	0x3c40ad3f, 0xc5f2e937, 0xab8a358f, 0xe650b9bf, 0x573726b9, 0xeffde1a4, 
	0x8239eb9d, 0xf666bbf7, 0x74be446d, 0xbbb78aa9, 0x11bbd87e, 0x916120f8, 
	0x57242910, 0x9dd2d365, 0x1f4af531, 0x554d5e88, 0xd7f4025a, 0xc7177c71, 
	0x47054d93, 0xdf47408f, 0x11f2fb1f, 0x95aec5f8, 0x3770056f, 0x60f0ebaf, 
	0xd762fc33, 0xc84dbd0b, 0xf4ada6df, 0x37de436f, 0x8cd6a56d, 0xb09da675, 
	0xd3ef20ce, 0x8cd835d5, 0xb27bd2f1, 0x4351a71a, 0x733bab9b, 0x39112547, 
	0xb5aab036, 0xea67a503, 0xcc42f9c9, 0x3adb980a, 0x25b489c8, 0xbfb0a58a, 
	0xcdad0b93, 0x9a88fdad, 0xb238e5c4, 0xae143331, 0x2ee80d2c, 0x98675bec, 
	0x7c853f55, 0x6f5599a4, 0x4a1e48b9, 0xf6a2cd73, 0x83cf3c0b, 0xc9ffe26e, 
	0xa4bf791a, 0xbbae5734, 0x7c27f0e9, 0xee251f2f, 0x9ae577e5, 0xf2f7a179, 
	0x8a7b8a4b, 0x8d9c18c4, 0xf236f55c, 0x2202b3bd, 0x3903fe11, 0x6e3bdc3d, 
	0xe444f5d3, 0xd8ff2705, 0xa7913448, 0x1122ae79, 0x566b98f2, 0x7ea4efe5, 
	0x22447867, 0xadbbbde7, 0x4adfe43a, 0xc0b4ad06, 0x56fe21d7, 0x5f93ea1e, 
	0xe786d94a, 0x69e73a6f, 0xf3c38b8e, 0xce89df64, 0xfa29ddd1, 0x4f693ca6, 
	0x18c9bde4, 0xb7cd67b6, 0x0de7e45f, 0x538cb7dc, 0xfb79c3fc, 0x9936d643, 
	0xdd85f637, 0xfeffd48b, 0x267e7e4d, 0x17f724fc, 0xe3d28f7e, 0x7bb04911, 
	0xe8a58e33, 0x5ed05d5a, 0x65e49ee1, 0x0792d769, 0xe2d93d65, 0xfb865583, 
	0xf775ceb4, 0x794f5959, 0xfa53d64f, 0x2f5234b9, 0xc8b35951, 0x958dbefe, 
	0xb599790a, 0x186dadf2, 0xc90c7273, 0x343af203, 0x483d2dbd, 0xd987943f, 
	0x163fc999, 0x35a7c069, 0xfb8fd14e, 0x46ae4bb3, 0xae1ce1a5, 0x48f796ee, 
	0x829e84ab, 0x97c6b6b8, 0xdf44022f, 0x27623d25, 0x2fa169e4, 0x15fc6f55, 
	0xbe3e6fbd, 0x3ef894b5, 0xad8e9bf9, 0x1a619cea, 0xb703d302, 0xee895f13, 
	0xe3d4ec5f, 0x9857ee71, 0x9fc0c617, 0x3a453ad5, 0xf50811ee, 0xe4e5931d, 
	0x5e3e0347, 0xc3e80647, 0x3a271dfd, 0x834cadaf, 0x5ace123d, 0x06c96e7e, 
	0x21f61a47, 0x6fcdef96, 0xe877bc80, 0xfe65d227, 0xfb434ad8, 0xd4599701, 
	0xda7a93e2, 0xa44776c6, 0xcc55bf4b, 0xa832ef74, 0x6dabfa9d, 0xbf403fd3, 
	0xe795b11d, 0x0077efa1, 0xf6a41c37, 0xf874be96, 0xf0776a77, 0xc7249d7c, 
	0xf49b8fe0, 0x5df4217e, 0xf80efdf2, 0x3bd60f35, 0x2f3cab7b, 0x1c1a5b39, 
	0x50b4eacf, 0xcdff4b3c, 0x2f6bdd00, 0x3af05417, 0x509744dc, 0x8cac21dc, 
	0x3223897e, 0x911c492f, 0x81f19979, 0x3aecc3cc, 0x4e519e92, 0xca16d7e5, 
	0xa9e389bc, 0x37a2d357, 0x4ec6ae81, 0x2db6b5d0, 0x3a069b10, 0xb1071924, 
	0x3eb4dd8e, 0xae09f7dc, 0xd5145023, 0x2882e5cd, 0x9bf88dd0, 0xddea7e4a, 
	0x9dbfb245, 0x07bfdbdf, 0x6f5a2e79, 0xd5d7e61f, 0xe3774812, 0x0755bdbd, 
	0x13e27eb1, 0x40efdbdf, 0x5ced9f3e, 0x26f30f20, 0x89f7ca3b, 0x2f9f4a9a, 
	0x1d3b8412, 0x5843d2ce, 0x4f695767, 0x3e65e89e, 0x9aff41e4, 0xb50f9a4c, 
	0xb7f8ad77, 0xe2ff7c3c, 0x0a475a3d, 0x2d3cdb8d, 0xdf908a7d, 0xef883905, 
	0x5be73482, 0x920f7107, 0xef2f9dd6, 0xfa638e9d, 0xa738aa74, 0x345d34b5, 
	0xa89e441d, 0x648f7e5c, 0xbb933943, 0xf0585933, 0xbe7e368f, 0x0fcca177, 
	0xdf645b1d, 0x31f955ff, 0x10c3f253, 0x4f30b22b, 0x1eabf75f, 0xac2d27be, 
	0x5d61e82c, 0x7e00b977, 0x2d5f75f4, 0x6ef1efc6, 0xe03f3002, 0x17109bdf, 
	0x8ba56fdd, 0x3fb91798, 0x09657fce, 0x18e15b23, 0x192d69c6, 0x0bf62562, 
	0x640f1cf7, 0xa33bbdf1, 0xef423844, 0xe9f8468f, 0xe7166701, 0x6947a26f, 
	0xef417d07, 0x99b3f076, 0x902579e8, 0xdb797987, 0x9f628f02, 0xfc98a9ac, 
	0x57ae79d1, 0x16cbaf81, 0x93e4fbcb, 0x1e38fada, 0x6aa192f3, 0x2aeee12d, 
	0x8fd85380, 0x457f2875, 0x8d5f77f6, 0x9128a3b4, 0x5677dab7, 0x9671cc5f, 
	0xe7e93cdb, 0xcbde8db8, 0x0804e20e, 0xde1fbaac, 0xdc29d660, 0x8e197ac0, 
	0x322ff61b, 0xda9fc20f, 0x42f181b8, 0x840bc2bf, 0x2fc89a1b, 0x71853f60, 
	0xc653d483, 0x10be3605, 0xc58370c3, 0xdc6d43e7, 0xf3861c00, 0x2a3ffba1, 
	0x61fbc9d8, 0x4f7c139e, 0xf0b36f60, 0x1801efc8, 0x81eb6daf, 0xa0b9231f, 
	0xd69c6779, 0xbfe1af58, 0xffa4f8ce, 0xf413d85a, 0x207fb61f, 0xe8f7c7fb, 
	0xf331ff6d, 0xc4fec690, 0x1e2517f6, 0x0949fd83, 0xec3104fc, 0x61b7454d, 
	0xe67e047e, 0xe91fa0c3, 0x408bf808, 0xef40aef7, 0x770acdea, 0x7a1de180, 
	0x551d94de, 0x6c4e5f8c, 0xcdbf00ee, 0xbd52b42f, 0x798cc323, 0xe209f519, 
	0x9f1ccdb1, 0x9f5bf11a, 0x794d73c1, 0xd26947d8, 0x31debfab, 0x8a5f8618, 
	0xfd4131cc, 0x52113964, 0x321df03e, 0xc5fb802f, 0x3e407ea0, 0x3e59fae2, 
	0xf9216ed6, 0xcc916a7e, 0x9c9cb387, 0x53e5f257, 0x64697572, 0x21bac1b9, 
	0x4941c01f, 0xb8ed2614, 0xe307e528, 0x700db525, 0x3a6d5dff, 0xda6a27df, 
	0x7f113baf, 0x024d9e91, 0x263f499f, 0x13e47c71, 0x33bec293, 0x29315ce0, 
	0x7fa2fe34, 0x76dda593, 0xb5b47bcb, 0xb1f76129, 0x193185bb, 0xf43efafc, 
	0x71fb0eb2, 0xf2cb89d6, 0xf9d0f33c, 0x0178c8e5, 0x5dfcefe3, 0xa7d864df, 
	0xc99e92a6, 0x179fdbc0, 0xbe71a49e, 0x9c61e815, 0x629c079d, 0x12829c28, 
	0xdf6d82f1, 0x2ce6f086, 0x9fc1475a, 0x82333788, 0x12c27338, 0xef5b3389, 
	0x69284f29, 0xcb67f208, 0x284d5fd7, 0xabb83a27, 0x30fffe3c, 0xd263d247, 
	0x363d30d3, 0x31ea860f, 0x79ec2feb, 0x1e87ee28, 0x3d645f17, 0x5b53d48e, 
	0x05cbf59f, 0x4977e4a7, 0x199ced4c, 0x53d657d4, 0x0bfec75a, 0xbed53be9, 
	0xe7059fc1, 0xdc997cdb, 0x0cf1cbdc, 0x8938e6e3, 0x08578183, 0x9e7df38f, 
	0x5fa58b43, 0x8824f5b2, 0x76f33d8f, 0x3c7c609c, 0xe3e32b65, 0x3e24dbfe, 
	0xfc3b3a36, 0x1b63e3a3, 0x828c9427, 0xef084b8f, 0x047c7c2a, 0x9168b8f8, 
	0x0a255bf4, 0x40bd771f, 0xcb23d8f8, 0x6ecadd63, 0x19e3e086, 0xeecfc997, 
	0xc38afea1, 0x8bbdf1f1, 0xa309dca5, 0xae780eb7, 0xfa0fc54b, 0xca0e7bef, 
	0x33d920bc, 0x26e4ff5a, 0xa7901bb2, 0x6c0db106, 0xe779592a, 0x64aff029, 
	0xb641c765, 0x89e91f1f, 0xef6ccbf0, 0xc22cb9fa, 0xfdab9373, 0x82ef5047, 
	0xda0d8b9d, 0x9d69aec1, 0xf47cf047, 0x537d74e5, 0xc83e307d, 0x362b5ffe, 
	0xac737df1, 0x79fe7613, 0x727d85cb, 0xdb9003c4, 0xa7495ca6, 0x077fe026, 
	0x171918e2, 0x20b8a974, 0x9725dd72, 0x6302e323, 0x63ffbcaa, 0x7ccada2c, 
	0xb8e6ded6, 0x0a58d8b5, 0x08b22dbb, 0xf9679dbf, 0xb1f6fc66, 0x7cd8afca, 
	0xe7b9759e, 0x8ddcec30, 0xd2bc47ea, 0x862f5b0f, 0x3f487fe4, 0xffd3fca4, 
	0x7be61c1c, 0x90031c1a, 0xb99df54b, 0xf3c92f8e, 0xfe3cf611, 0x21ab7c40, 
	0x645aec7a, 0xc70ca39f, 0x8ba384ad, 0x809af780, 0x8fd1bba3, 0x2ffb24e3, 
	0x3c6d8b85, 0xa0b8bcbb, 0x716f8e41, 0x9de68bbe, 0xe422f387, 0xeb5af3d7, 
	0xff05ae14, 0xfd963882, 0x2adc70e3, 0x8b6afff7, 0x0eadc647, 0xbc0699b7, 
	0xe59838c0, 0x477f4cca, 0xce32b7e6, 0xe656fcc9, 0x961f5945, 0x76bcc2ff, 
	0x7033d51d, 0xc28762de, 0x5d4feda1, 0xb5c50f4d, 0xecaf879d, 0x076e7ec1, 
	0x417737be, 0x8f28dce2, 0x0afdb7c2, 0x70c2fad7, 0xdce002ee, 0xf9962d5f, 
	0xdacf1b1f, 0xe7087778, 0x4bf6d702, 0x31be0b9c, 0xbe41edbe, 0x45fec9cf, 
	0x81317f83, 0xdfe1dccf, 0x67c488ff, 0xf179a1df, 0xc1612bf9, 0xdc08eb3e, 
	0x1a2dc22e, 0xea30e702, 0xb9dcfe14, 0x80dbca48, 0x591bdf50, 0xe88bfaad, 
	0xa37bc6df, 0x0bf23be1, 0x1417ad45, 0x6ff6a3be, 0xbb7e962c, 0xd683f94b, 
	0xf9013d1a, 0x55b5cdd3, 0xbbf73809, 0x01204565, 0xebeaddeb, 0xf5fec04b, 
	0x0d5c946f, 0x70836ff9, 0x15affa1e, 0xa2fb1fa6, 0x9d7bc4a6, 0x3e6724c9, 
	0xf083077c, 0x39defd2f, 0x03f5e48e, 0x2b2991d8, 0x2cefde91, 0x73bb7892, 
	0xc5b52c8c, 0xa83fdfb2, 0x31bf81fe, 0x39f7f22f, 0x12eeeb8c, 0x35ffc871, 
	0x197ecba5, 0x3efec36f, 0xfb9fb261, 0xf2cea70b, 0xce33b767, 0x89f18206, 
	0x907c089c, 0x2a1bef23, 0xc70be07c, 0xf5ced4f5, 0x648276a1, 0xfc9e3f18, 
	0x640fce11, 0xde617da9, 0x63ff660f, 0x0229bb71, 0x8d1fca39, 0xcf19eb88, 
	0xa2be5d13, 0xae2478fc, 0xb8a4c8ef, 0x5f2823ab, 0xb7446f2c, 0xf7e50be9, 
	0x301f6aaa, 0xe4fed0eb, 0x01ecef6b, 0x93dda87f, 0x902106c6, 0x8860f387, 
	0x62ce709b, 0x93dba2ba, 0x671c6563, 0x4f1c55c7, 0x9a9cb1d5, 0x9c4105a9, 
	0x7655c767, 0x95f1c59c, 0x5db2e2a6, 0xb9abe3c3, 0xbf222e2a, 0xcbbf2b59, 
	0x9db5bc6a, 0x7c993ee4, 0x92a2e051, 0x1c609283, 0x95535ad0, 0xbe6cba00, 
	0x5b08e24f, 0xe3deb66e, 0x161dfd71, 0x0ae32dde, 0xe7d8fb1d, 0x9174bc55, 
	0x823632f9, 0xf823632f, 0x7fcf0e32, 0x6e33abdb, 0x938f7a23, 0x1c736179, 
	0x35881ee8, 0xcb1abec7, 0x228ee6fd, 0xc7e8393f, 0xfe6cdb8e, 0x923dcfda, 
	0x669c73a5, 0x97cb6f3f, 0x7cb66f2d, 0xeff4edd9, 0xb94f2566, 0x1b96f211, 
	0x499f6f21, 0x379d691e, 0xa857ce87, 0xb10d0f73, 0x98b1ee66, 0xb7cf971b, 
	0x8e3d2917, 0x7c0ed390, 0xc71763f7, 0x5c68460f, 0x7e58b95c, 0x62ee724f, 
	0xdc6c9769, 0x2cbe2c39, 0x08283925, 0xb8811fda, 0xff27c780, 0x0ffd9e71, 
	0xaf8ed0e3, 0x1527fec9, 0x4fba1c4b, 0x29d873f9, 0x306e778e, 0x4e2a14ce, 
	0xa27f7ea5, 0x815bdb70, 0xd3cc6b9e, 0x39e6e9f9, 0x79a8f714, 0x91dff646, 
	0xe38dbfd8, 0x9df344ae, 0x3f413ba3, 0x19eb734f, 0xec74cfd0, 0x423dc0e9, 
	0xe1a1f1ea, 0x44bc9aeb, 0xd7b377de, 0x93c632d5, 0xb82277f0, 0x64fe3b1e, 
	0xc41dd5fc, 0x0a871c5f, 0x217cbb85, 0x63c2a9f1, 0xf1b2fe36, 0x32af1d98, 
	0x00dc831e, 0x3c2ab5d7, 0xf12472c6, 0x6fca975c, 0xe329f1da, 0xf8e8f734, 
	0xee96e3ac, 0xf1f6b66f, 0x60b50f3a, 0x968c13dd, 0x0e997b27, 0xe499cf7c, 
	0x8a76d1c8, 0xb5c219ca, 0xdbca893d, 0x690efe8d, 0x1c35a637, 0x7d7c7a26, 
	0xf1e12e88, 0x61038aa1, 0xdf7df03f, 0x0481b5cd, 0xe8acb7d4, 0x7ff7c04b, 
	0x6e76543f, 0x74f89ec8, 0xdb67f817, 0xee9ef8a1, 0xee0fc893, 0x9459f7b3, 
	0x11ff305c, 0xc446c537, 0x65de2a4d, 0xf254acfe, 0x0e5c3710, 0xf4f222ba, 
	0x2e593cf6, 0x3c50c5fa, 0x4e04b90b, 0x5b6ef8c4, 0xf1072f6e, 0x167868fc, 
	0x1fbf9df8, 0x3678e371, 0x10ecf18f, 0x2b36378e, 0xe6dafb3c, 0x78fe3867, 
	0x4b1fc554, 0x61fc7076, 0xbcfca8c5, 0xe7e7337f, 0x8ad785cd, 0x89470a3f, 
	0xe2230a3f, 0xcb17978f, 0x1da17cfc, 0xf151cc7f, 0xe3919cc7, 0xf161a28f, 
	0xb0e7c987, 0xdcb17efe, 0xfe7ebaa7, 0x5c071025, 0xd347eb67, 0x499f1145, 
	0x451785ed, 0x44f22642, 0x9b5e6605, 0xee95790f, 0x43ff7c38, 0xfee3e718, 
	0x3e6429d9, 0x72e70ea6, 0xe652e27b, 0x85557d61, 0xeb68c738, 0xe7bd2179, 
	0x2dc93927, 0xeb1f9bce, 0xe49bee09, 0x39f01716, 0x3743d64f, 0x4fcc9beb, 
	0x408f309e, 0xa656ba5f, 0x757e836e, 0xef04ef41, 0x78e19cab, 0xcb8c9a68, 
	0xb20e9f49, 0x081e459f, 0x88b8abcf, 0x41cd3df3, 0xd43a6b3d, 0xd767a61e, 
	0x7dd01b93, 0x86e838c4, 0xd6fc6fe9, 0x136d9b96, 0x77e44b80, 0x0971239a, 
	0x4fbe36f0, 0x9880fb58, 0x5c48f687, 0xef8c1c02, 0x7838db3a, 0xedb1c287, 
	0x393cdfca, 0x78cbf656, 0xb27ff484, 0xceaad8cf, 0x880ce82b, 0x74d1dc54, 
	0xbfc17742, 0xd88efe4f, 0x033df43a, 0xf2fa6f6a, 0x83b0458b, 0x5176f943, 
	0x663b0511, 0x0713d3e7, 0x31d83ccd, 0x5e882f8e, 0x9288a72e, 0xc70604fb, 
	0x5d3ac439, 0x7dc813ee, 0x560dc483, 0x24eb8394, 0x7d6b88e2, 0x77f2b61b, 
	0x09f7d405, 0x519ad69a, 0x7dcbb73a, 0xe09e3b05, 0xfb08fcbc, 0xf3f2c303, 
	0xf3b22e2a, 0x53bf9352, 0xeafdf32a, 0xdfc8087b, 0x55d4f7f3, 0x894621bc, 
	0xc738ec7b, 0x476fffde, 0xc83e72dc, 0x7509f017, 0x0556478e, 0x97191de9, 
	0xc96e23b4, 0xdb51fa0e, 0xf3deb66e, 0x23a94244, 0x3573ff34, 0xd34e8701, 
	0x1ff992ef, 0xe53279fb, 0x10c5f366, 0xce1065bf, 0x536defc3, 0x7fb1369a, 
	0xfbcbfe91, 0xbdfb230f, 0xec8f17bb, 0xb21fb9cf, 0x3902ceef, 0x7a65f79e, 
	0x7fb8607f, 0x9c643168, 0x59ec7982, 0xbb6eed25, 0x7f577f1a, 0x58ceeed0, 
	0x7b631822, 0x33f48b6f, 0xf951fe9b, 0x85fce7a1, 0x9191fbf4, 0x44b759e7, 
	0x078c21da, 0x824c9cfc, 0xa4155813, 0x7b1f4d93, 0x7b1edb1d, 0x7aa4e5c2, 
	0xff353aee, 0x1fe686fb, 0xe2f5efd6, 0x489647ac, 0x67191a3b, 0xa05c3cd1, 
	0xf0ba7a4f, 0xfff45fff, 0x59f4c8d4, 0x37d244b4, 0x26efc859, 0x9173fbd8, 
	0x87bd6e74, 0xd6037970, 0xc3d2ee51, 0xcbaaf1d6, 0x0d6448d5, 0x3b0875c8, 
	0xc63e4baf, 0x9eba155c, 0x8e8a854d, 0x7b256b3f, 0x49171de1, 0x8f3a70c7, 
	0xf1d81716, 0x19071040, 0x5c621fae, 0x60edfa4b, 0xa834455e, 0x5fbcccf3, 
	0x8e45f9c0, 0x3ded0cb3, 0xcf3247a9, 0x7415ceaf, 0xfc070ee8, 0x6aaf9ac9, 
	0x997eaef1, 0x59224987, 0x9fc76bd7, 0x3cc9f04a, 0xa7d53c4c, 0xa278952e, 
	0x7bf21be3, 0xf18f9c77, 0xfb118770, 0xe5438608, 0x83bee46b, 0x8888c7ca, 
	0xa5dae43c, 0x441f7f43, 0xd74d23e5, 0x3f8c8deb, 0x4bb24c72, 0x9dc216de, 
	0xaa5abfe4, 0x698a1373, 0xf3028efd, 0xe36447e4, 0x2e36d4d7, 0xc9b1f9c2, 
	0xefde7ecd, 0xeb27f27f, 0xa81f61f6, 0xbc93eefe, 0xed4cbfdf, 0x24bfd7f7, 
	0x683bfbf7, 0x848f949c, 0x2d33bd28, 0x0d7fbf6c, 0x77ad21fc, 0xeff75dc9, 
	0x7fd93cc3, 0xef0b9fa1, 0xff275004, 0xc1aefdc1, 0xbbf53f7e, 0x7bf227e6, 
	0x7b2b6944, 0xee464f19, 0x7ec1aff7, 0x9f3427bf, 0xf0addbe9, 0x2775af84, 
	0xe4ff234a, 0x1998848f, 0xb5ae5b10, 0xf2a65fdf, 0x27803379, 0x89e387ba, 
	0x8e46b919, 0xf0fb13c2, 0x957a45f7, 0x95c8cc1e, 0x1cd657e7, 0x250cfe96, 
	0xae7d59fc, 0x83861399, 0x61ce9f6a, 0xff7b541c, 0x9e6afadb, 0x71e6224f, 
	0xfdf0d2df, 0xe56dd17e, 0x335fb48c, 0xd235fb0b, 0xdf00e57e, 0xc86bf705, 
	0x93cfd11f, 0xfec2987f, 0x634fb83d, 0x6d1e5e30, 0xf63f7fbf, 0xfdc17df5, 
	0xbf6a65fe, 0x7d5e2fff, 0xfbb49b73, 0xabfdfbe1, 0xcfefbbf1, 0xc6ffdfbf, 
	0x3473a1d2, 0x04bfdfbc, 0x0cfeb0f3, 0x4abefdfb, 0x748dd7e5, 0x4dc9f5f8, 
	0xf93fbef6, 0xebe4116d, 0xc348a712, 0x376ab5f7, 0xa7e1d238, 0xfc1f9f79, 
	0xfd2e3df0, 0x37dc8b68, 0x45ff3c27, 0xab65f9e0, 0xee74d21b, 0xafabed4f, 
	0xf531cd9d, 0x7c4a9657, 0xf194f7bd, 0x6a873cae, 0x90c59f32, 0xcee756ff, 
	0xfc0e669c, 0x5f5f7d49, 0x945fdc9c, 0xe6b6a478, 0x6f8c3ae9, 0xc37689db, 
	0x962931c8, 0xdf1dada8, 0x50efdf80, 0xe04d06e7, 0x358fe60c, 0xc0e9f606, 
	0xe11cc692, 0xeb93e20b, 0x3a6103e1, 0xb72eded8, 0xfc907ac8, 0xb4cd6239, 
	0xf03e7516, 0xcfd7dcac, 0xd5d64f78, 0xf9c8ffbe, 0x3f2fddd1, 0xe346aef1, 
	0x51ecafbf, 0x1ecef587, 0x5358039c, 0xf86eef3b, 0xee36617f, 0x35d4f9c3, 
	0x9f787e5f, 0x56f5a148, 0xfd25cd3e, 0xc61bf753, 0x7cd63d31, 0xec3efc79, 
	0x7f540fbb, 0xdcdf6c21, 0x6b1515c6, 0x8ef3cacf, 0xbdcdf911, 0x7549c4a7, 
	0x6ce997de, 0x80d7c1e7, 0xd123c5ae, 0x0fba60dd, 0x74d91fed, 0xb77495af, 
	0x25eea7ed, 0xf304f63a, 0x4435b5e6, 0xdd20e2ff, 0xfd360f99, 0xd7703ca9, 
	0xf3c81cbc, 0xe76ee8f5, 0xf275ad53, 0x3e50e6bc, 0x4b9f071e, 0xe66a7982, 
	0x79e1b1cb, 0x27cacff9, 0x35f53f9b, 0xf7c33f92, 0x74fce5fb, 0xd11cbf3b, 
	0x592f143e, 0xaea7e71a, 0x27fd5fb1, 0x8037bfd9, 0xdf5caea7, 0x2a04760e, 
	0x5ccfb072, 0x6df5e81f, 0xafdd0c19, 0x738fdc8e, 0x7dfdf508, 0xd7fb41e1, 
	0xc81d718c, 0x1dac0417, 0x3f783bad, 0x0d8edf6e, 0x7efef437, 0x63115df9, 
	0x5851635f, 0x478d67fd, 0x0e757cf0, 0xfebd4970, 0xc8ed0be0, 0x74cd7c5b, 
	0xe2de416f, 0x3ece7a01, 0xc424799f, 0x79a0e34f, 0x1f1f928f, 0x7ccb238e, 
	0x6b854b51, 0x7d5e6871, 0xdc02e82f, 0x0049e692, 0x69afa98e, 0x0f24f994, 
	0xa133c7d9, 0x498f86fb, 0xc37d8e7f, 0xd9d7ec63, 0x1b2f66ef, 0xfc50df6d, 
	0xd9d9f940, 0x6e38d25b, 0x3e62771f, 0xf6f75afc, 0x35d9f96b, 0x635ecfca, 
	0x5da730df, 0xf67e07cd, 0xfbe1a585, 0xc82ff586, 0xe44a037c, 0x5f90d61b, 
	0xac37db0e, 0x67bb3f21, 0xb4dd9fb8, 0x70877e4c, 0x0fb1837f, 0x70066f7e, 
	0x64bfbd08, 0x7936da49, 0xca57a20e, 0x4dd9135d, 0xefb4f7b4, 0xf467d503, 
	0xf7253f2c, 0xafb70515, 0xf6a51459, 0x4f3e2d0d, 0x23987247, 0xdc1551f3, 
	0x2de43d6f, 0xf58f2836, 0x87dcee77, 0x36ba2ea0, 0xabf4df4d, 0xc608ce20, 
	0xe24eb4cb, 0xcbc41ac7, 0x102b893e, 0xdf51af2f, 0x1c035e25, 0xaf5efa41, 
	0xc2bd45f0, 0x2eeb9117, 0x17c489a9, 0x290ef156, 0xf9beff5f, 0xc37df0f0, 
	0x9137f9eb, 0x1c607c45, 0x5f20e66b, 0xfd9ff368, 0x5663d11d, 0xb187d3ed, 
	0xf7e9155f, 0x87b9bfd8, 0x7f48bffb, 0xefba2077, 0xfcbf356e, 0xbe60c296, 
	0x4e733c95, 0xfa97d90b, 0x38e74f15, 0x97bbaec9, 0xc6bbfc49, 0xf6073fb8, 
	0xf24b80ff, 0x3d24dea7, 0x2befd3f0, 0xb67df2a6, 0xfc7d9d35, 0x79ec83f7, 
	0x66945eae, 0xfd300fef, 0xc9ea7757, 0x7d5a9bd8, 0x5139fdd7, 0xec6b0c6e, 
	0x27d63ec3, 0xebbd254b, 0x073777d5, 0xe7bcca97, 0x3be87d01, 0x1f70fb07, 
	0xaf21cf19, 0x3ec63c20, 0x70c87df9, 0xc55bb43f, 0x4e5ff501, 0x45f587db, 
	0xcfe423fa, 0xf5f921dd, 0xfc4a965b, 0xe5b96038, 0x6fda99be, 0xdbfbca19, 
	0x79110dfb, 0x26bf48f6, 0xf39cde54, 0xb6de54fe, 0xe71dca54, 0x03bee5d1, 
	0xc4f7d3e7, 0x9bfb599a, 0x255ffd68, 0x36790a3f, 0xef53ede7, 0x5ea3ad87, 
	0x0fcc5bf9, 0xcefea376, 0xae47ae34, 0x4fbff487, 0xbd9dab9d, 0x6f306775, 
	0x3b791337, 0x3b79e8ff, 0x91afff5b, 0xffd30bb7, 0xe785975b, 0x28e7eaed, 
	0xb2339ffd, 0xd30d17fe, 0xf30e337f, 0xf9265928, 0x243f7d7a, 0x4ffb76f3, 
	0x21899f10, 0xebb7906b, 0xd6ede60f, 0xe1399814, 0xb8debb79, 0x24fee0df, 
	0xbfd112fc, 0xe3a7aef0, 0x988e4e52, 0xbec1cbb7, 0x2bb79daf, 0x7216e754, 
	0xc537c76b, 0xceed0716, 0xd93b2592, 0xf5de14ee, 0x5463f645, 0x1460829e, 
	0x19f6f5de, 0x5e2a5bc6, 0x8ccdedb2, 0x30df8445, 0x781e754f, 0x1992ec0d, 
	0xb0253fb4, 0xbd121f47, 0xb9676b9e, 0x9ad0edb4, 0xd021d8eb, 0x743b447d, 
	0xdb17f4c3, 0xf8379e94, 0x9b57fd43, 0xff6d338c, 0x2e2b7ec5, 0x3ceca7e8, 
	0x52bfed86, 0xfbf9673c, 0x9a6cf488, 0x63f2a17f, 0x06ed064f, 0xf20b6ef0, 
	0x2d496be7, 0xd344587a, 0xb03eef90, 0xd38e5e64, 0x3f38fd90, 0x7be1ef92, 
	0xccafdc82, 0x1f21a7bf, 0xd5af3434, 0xce468fd2, 0x747e7aeb, 0x41bcbf54, 
	0xe837d3c5, 0x65396d97, 0x7282257f, 0x6cb7e91a, 0xe57f6639, 0x82247253, 
	0x6b96cb7e, 0x313e5bf6, 0x6fd8e7e4, 0x47fd4bf5, 0xa4e15ebd, 0xf21278a1, 
	0x1fba36d5, 0xbcfc9ebb, 0xcf99e2a0, 0x43c4c7ee, 0x21267e4a, 0xbeaddd53, 
	0xeead59a7, 0xa9c5e967, 0x9eaf3bf2, 0xfabceff0, 0x9bbed65b, 0xaa442552, 
	0x0cc1f3b3, 0x6d0d68f2, 0xeb4ddf6b, 0x6e757b63, 0xc9abd93b, 0xf797cc0b, 
	0x3093dc84, 0x7c76cc0b, 0x527aa5b7, 0x41c70cea, 0x0a8a27aa, 0x04de67e4, 
	0xcff5a06e, 0x0a41757f, 0xa4f56370, 0xb3da199c, 0x897dea54, 0x694a12e2, 
	0xccb87e97, 0x7bd017de, 0xeed7bb6d, 0xfc11fbe6, 0xcc80fcde, 0x184e0413, 
	0xf44ef8ed, 0x053326e4, 0x4fe781c7, 0xd371486b, 0x21df0f73, 0xe2e4ce71, 
	0xf99cf20d, 0x195e76ad, 0xe38d0801, 0x73f679a1, 0xcef98299, 0xc08e141f, 
	0x3cf7f91e, 0xd7467f11, 0x12e21a18, 0x7e0d1b12, 0xa6843758, 0x8efea9b7, 
	0xd7953fa3, 0xaebca8f5, 0xfba9abd3, 0x654f2a4a, 0xdc99ef69, 0x96deff22, 
	0xb20b9d57, 0x3b5e4af3, 0xbaed31ee, 0xf47667bc, 0xc73cfd84, 0x91dff623, 
	0x980b3f81, 0x90ed172c, 0xb517a66b, 0xd2e757cf, 0x01bed5aa, 0x7a9ba4f2, 
	0x2103e786, 0x7fd3d057, 0xd6f52659, 0xf4619dc6, 0x529df255, 0xea67bf80, 
	0x31e66758, 0x7e414d9e, 0xfb71ebca, 0x62119ea2, 0x1ee86041, 0xefe922d9, 
	0x9d835f2a, 0xe70e7e46, 0x8dcbaa86, 0x8805e414, 0x77f0a72f, 0x43bbee22, 
	0x7f41af9e, 0xe69fafb8, 0xf236f95d, 0x392819eb, 0x2c79942e, 0x710bc3b6, 
	0xfed3d4ce, 0x2df78e96, 0x7a7e3bfe, 0x034f21c9, 0x405ea909, 0xc69f62fd, 
	0x0f7b61e3, 0xb97f837e, 0xd426fcde, 0x2fd00721, 0x92781ff0, 0xc48daaf8, 
	0x587921df, 0x2c0f2e16, 0x5f453eaf, 0xabd517b2, 0x5f4a4b4a, 0x9c43ca09, 
	0x288c70d7, 0xe5c2cb0f, 0xe9617e60, 0xe917d2ba, 0xfdf2f5fd, 0x0943736a, 
	0x756734fe, 0x77f12c87, 0x9e1fd0b6, 0x7a559f33, 0xbf1f12b1, 0xeadfb830, 
	0x4bfcf51e, 0xcb8eb4aa, 0xe552de7e, 0x41fe5545, 0x5913e295, 0x40b2aaa6, 
	0x69553395, 0xf2e0cd94, 0xf2da594e, 0xd2d6ff3b, 0x7fc68275, 0x67da9967, 
	0x735f9218, 0x31df7e48, 0x8d5b7283, 0xafe49d73, 0xa60c8703, 0x27afcb13, 
	0x717a0f28, 0xa79c29fe, 0x995a39c2, 0x3c658b17, 0x41330865, 0x77cb33c9, 
	0x768e94d5, 0xf906ff3e, 0xc1fa96ee, 0xbec1a978, 0xc2122807, 0x5ad87eff, 
	0x63d08f75, 0xe7941bdf, 0x789e9543, 0xf2a5c23c, 0xe7bcd7c2, 0x67f369f7, 
	0xf7d877b5, 0x8efe2d01, 0xff18e4d1, 0xe697b316, 0x2dade33d, 0x2481ab90, 
	0x21d3ef93, 0xd4bce72e, 0x552e498f, 0x00b1acde, 0x87772deb, 0xabfcddea, 
	0x060fac8d, 0xe00566f2, 0xd68fd12f, 0x745b9b7f, 0xe2f9e147, 0x7aa0117c, 
	0x6f553785, 0x8f017dc4, 0xfeff98b1, 0x846af207, 0x9e85ca7b, 0x44bdef8c, 
	0x59581b8e, 0xdbe0fdc1, 0xc305cdc4, 0x9b6888f5, 0x8b727e82, 0xf634150f, 
	0x2fa49e63, 0x2c4353d0, 0x7acfbc47, 0x467a53e2, 0xbad0c73f, 0x5f5897e1, 
	0xc2f23bf0, 0xaf9bd2a6, 0x9e827d2b, 0x5db6bf7c, 0xb3efd274, 0x3bf84bcd, 
	0x1817939c, 0x1fac7657, 0x71ecaf5d, 0xe8e6be79, 0xd67ac9fa, 0x1d8bc6af, 
	0x3fe0df5d, 0x6dbd1cf8, 0x4ff42387, 0xecfd302f, 0x28de9d87, 0xe9898b9c, 
	0x117fb920, 0xf499df7f, 0xaa4be511, 0x397036b4, 0x95e8817d, 0x14467bfb, 
	0x4b7f27df, 0x51731efe, 0xa5507f95, 0x74a4a578, 0xaaa9952a, 0x4ce5502c, 
	0xc89f1a55, 0xae554ef2, 0x597ae552, 0x3d4ad5e6, 0x7ce5318b, 0x9579bfb0, 
	0xd9bd3e16, 0x26bec1af, 0x57be08d6, 0x89f4a319, 0x1eeff2ea, 0xa9e797ec, 
	0x3aa0fea9, 0xea87ad47, 0x39e3cb8b, 0x99ed4515, 0xf825fbb0, 0xa35705fb, 
	0x51cfe543, 0x95bf743b, 0x3f53edef, 0x68e33f72, 0xc53afe83, 0x889bd315, 
	0x9a1ba80f, 0x6132dc06, 0xf8c9a1b2, 0x8f51f85d, 0xbe849f86, 0xbfe62c7b, 
	0x47e190f3, 0x60d06e3d, 0xb5f3d93e, 0xbcc1def3, 0x7d7fd4b8, 0xe31fad4a, 
	0xea5b3e71, 0x07dfc477, 0xa1189b5c, 0x9e4b9fdf, 0x7a839ffb, 0xe9ee79cc, 
	0x1e936fc8, 0xdd9eb7eb, 0x5e9bf906, 0xcd0fb43c, 0x77e9a6f9, 0xeb4b72db, 
	0x89123967, 0x1d8a3ef8, 0x607ed86f, 0xe99dc93a, 0x3923bb85, 0x6eb9e1f5, 
	0xf13cf23f, 0x7f03a6a5, 0x760626ef, 0x0fc4a0fd, 0xdfa7db88, 0x2bd3e4ad, 
	0x031f5bbf, 0xe8307bbb, 0x1b1ba607, 0xf2e402b6, 0x1f95137b, 0x51cf5368, 
	0xccac607d, 0x3f7ad9fb, 0x06a6c7fd, 0x7b2b76bd, 0x8a357313, 0xb29667e5, 
	0xc98f7a27, 0xb23b21fc, 0x72ee7a14, 0xe5e4288b, 0xf5bb1617, 0xafebbcc6, 
	0x3fef323b, 0x7957d794, 0x6b4f5b7f, 0xf3c8a188, 0xf440e907, 0xe1f496ea, 
	0xea4374fd, 0x8425d323, 0x1f4a374e, 0x1f362e9b, 0xfff3e922, 0xdadaa500, 
	0x000000ba, 0x00014031, 0x5a9d9c78, 0xd55c700d, 0xedef3e75, 0xbfa7dddb, 
	0x918fd3d5, 0xead25b2c, 0xe823c2d7, 0x164638da, 0x0b64f5b2, 0xae90a4d5, 
	0x7fe20164, 0xc0550c2d, 0x6b9fcd69, 0xdddca431, 0x9615e595, 0x2c436483, 
	0x14e54093, 0x880d438a, 0xa5a70184, 0xd83259e5, 0x12226704, 0xb7133893, 
	0x3541635d, 0x1854ceed, 0x4f136a67, 0xdee739e8, 0x3224aef5, 0xf0676499, 
	0xbcf779d5, 0x3f3def73, 0x3ee739df, 0xc4026512, 0x5b18027f, 0xe000fa00, 
	0x4d6d77aa, 0x463fc46c, 0x000f0b41, 0x35b52f54, 0x436d2388, 0xdfb76898, 
	0x468845d6, 0xc0021347, 0x261d9efc, 0x239106da, 0x9c0f9032, 0x1005e81c, 
	0xe4082f21, 0x6183ea37, 0x1fbf79c0, 0x781e727c, 0x79e01c1e, 0x70392d80, 
	0xc83f4681, 0xed37db79, 0x99be3962, 0xe7b9d328, 0xf4eb9d25, 0x331d6d31, 
	0x2526b698, 0xd252779d, 0xed1e7179, 0xe74969fc, 0xce3239d3, 0x51df7adb, 
	0x9395c7dc, 0x571f68bb, 0x84bbc279, 0x73e9e006, 0x9e73dd3e, 0x6b7ecff9, 
	0x10cbef09, 0xeb7371a7, 0xf389e3c1, 0x47de8373, 0x5a674dba, 0x597be924, 
	0x93c6071f, 0x6e495bfc, 0xc4086ca2, 0xd41c745d, 0x59f7e0a3, 0x826f818f, 
	0xe7971e1e, 0x88f77e21, 0x737c9066, 0x63f44013, 0x6d680fa4, 0x35c028fa, 
	0x8da7b8c5, 0x010bdf4c, 0xc7c0b764, 0xb3f5417a, 0x3e3dfc9e, 0x4b6d9bd2, 
	0x43bf21bd, 0x2b7f9072, 0x8264018c, 0x4206ed21, 0x7af1d713, 0x5ba7ad1a, 
	0xf1ef07c2, 0xb1cf72f9, 0x45ee453e, 0xc23ac11e, 0x71d613fa, 0x84ef211e, 
	0xe14ef3a4, 0xf7104b78, 0xe79f8e78, 0xf9e7c94f, 0xad031c09, 0x023f47a0, 
	0xb95d0d58, 0xa098e482, 0xfde46f0f, 0x6eb803ea, 0x61aac760, 0x8d5dd70d, 
	0x00a7d3fb, 0x7c560d96, 0x937ce1a0, 0x3d216fed, 0xfbe50a06, 0x774ffe81, 
	0x65ef686b, 0xb6edf73b, 0x09b57e70, 0xc9d47cf1, 0x5f2d21f2, 0xbe0176d1, 
	0x465b401f, 0x5dbe41ef, 0xf129ff5f, 0xffe09937, 0xedf5026a, 0x8adfb18b, 
	0x48e12687, 0xc3b6f904, 0x8e3e68da, 0x02f2d9d1, 0x379f8d6e, 0x792fbc91, 
	0x5c27d3af, 0xa73e6ee1, 0x9f4ffcae, 0x510e7a06, 0x91ea27da, 0x5fe0e79f, 
	0x5f000591, 0x71ffafe0, 0x7ea06f80, 0xcd8019ac, 0x79b427a4, 0x0f4726ef, 
	0x22c806ef, 0x43df22bb, 0xe70b3cf8, 0xd88fd44d, 0x76997c83, 0xf115fc54, 
	0x57401fc6, 0xfa348d07, 0x4b6dda30, 0xfa2f51cd, 0x32ab198f, 0x9cf768a2, 
	0xbed626ab, 0xe3f7eb42, 0xd36fb8fa, 0x40ac7a0f, 0x52e707ae, 0x3ee527eb, 
	0x841bdb9e, 0xc9bfa407, 0x71572a38, 0xfec98464, 0xd9ebcf19, 0xf7469fe4, 
	0x9d103086, 0xb068fe8d, 0xb8f4b4dd, 0xe0d95c4b, 0x39205f87, 0x4b1b88d2, 
	0x8761aff9, 0x83f7f22c, 0xda08883a, 0xf6e3ddc1, 0x06ff7078, 0x0cec5bfa, 
	0xd23a6dd3, 0x484eca19, 0x23e74bdf, 0x7ae30e7d, 0x666ebd66, 0xfcdbfad2, 
	0xcf109e13, 0x36ff256f, 0x1751ff6c, 0x6302a1d1, 0x508032fb, 0x3c20a9f0, 
	0x94f7fd22, 0xf625df5c, 0xb686b401, 0x7f20360d, 0xfc40b4c2, 0x4d17c652, 
	0x61ab7eb7, 0x893ae050, 0xe79fb363, 0xae6c7daa, 0xfbe62e14, 0xc44186bb, 
	0x174c4832, 0x29cdd0c3, 0x190c57be, 0x7d5c087f, 0x032b7e7c, 0x64e4d286, 
	0xe08ae09b, 0xaa27adb9, 0xbef8fd22, 0x7a1b662f, 0x76c0fc88, 0xbef03851, 
	0x2e9da10e, 0x0b927e93, 0x884f3f0e, 0xcf37e800, 0xed9027de, 0x83f035b6, 
	0x40bf9537, 0xc338f3a1, 0xfa2d2102, 0x6bf436f9, 0x6e7cebd7, 0x0a1f38a0, 
	0x68cf38cb, 0x213f3bf5, 0xe3189eb9, 0x0c73d38b, 0xfbd48d06, 0xe9ef210e, 
	0x98cd1c94, 0x123d0fcd, 0xc39fd08f, 0x29cff451, 0xd700bf5c, 0xb0e7ce7f, 
	0x36ecbcdf, 0xd939e85a, 0xc5fca63b, 0x30ff4b8c, 0x51fe537b, 0x9dfd2ed4, 
	0xca5367fd, 0xc17e920f, 0xf8a7f27e, 0xf90fe845, 0xf0832fc5, 0x30bf349b, 
	0xaa162fd1, 0xef9fccf8, 0xf3c3bf17, 0xd9dfe065, 0xd0d45d6a, 0x2fc7a417, 
	0xf982ffb5, 0x64784f76, 0xd91fa43e, 0x8fdc86f3, 0x2a69f083, 0xa78a4c1e, 
	0x31f8fcf8, 0xd72fedb3, 0xcbd47acb, 0x98bd7ce8, 0x74feffca, 0x47fe7cbd, 
	0xa8d7e5e9, 0x5fb43c97, 0xa83d8f6b, 0xce1dbef3, 0x0dfdadaa, 0xa7ac5f1c, 
	0x9c6e2a8d, 0x839571f9, 0xc61623f2, 0x838e0081, 0xa03fbfa4, 0xf9879cf4, 
	0xdd1ffd92, 0xd3a9f497, 0xe1d9427b, 0xffafdfe9, 0xb36d9ed6, 0x73f783e2, 
	0x05db0fe8, 0x397bbe54, 0x4d9cf31b, 0x20d02afa, 0x9a7f1f69, 0x472ec8bd, 
	0xeb17e3e6, 0x47b2a36b, 0x1d31ea5c, 0xab468d3f, 0x18032e1e, 0xc30f6d8b, 
	0xb37b7cd0, 0x7eca435d, 0xbbecb363, 0xc97dec95, 0xfdaf64be, 0xcc9bedf3, 
	0x873b49cf, 0x09db2b82, 0xe72b12ff, 0x3850b0e2, 0xd73fed2c, 0x673e9dae, 
	0x31b7b7e5, 0x751dd9df, 0x38cad748, 0x5360d7ff, 0xf7c6017b, 0x76eae0b6, 
	0xf9e4f38a, 0x0f14eec9, 0x54980956, 0x4da2e46f, 0xba77180b, 0xd09fb45c, 
	0xbdffda28, 0x9fc27e54, 0x8b8dcf8b, 0x760fb9d1, 0xa8b5187f, 0x419611ee, 
	0x170afd79, 0xebce1042, 0x0ed912c8, 0x95b717f0, 0xdb88007c, 0xc8bc435f, 
	0x8f2e3dc3, 0x5f31be1d, 0x13f76fee, 0x7afeb007, 0x0b52f4fb, 0xcdfcb1ed, 
	0x3fe4affd, 0x55fd7985, 0x786ea9a4, 0xfcc9d251, 0x50bb1c96, 0x2c3ed00e, 
	0xa5f747ac, 0x883d939e, 0x184ee7c6, 0x162d71f7, 0xcf97e498, 0x976ceef9, 
	0xc2cf6171, 0x1c74cd51, 0x36800f8a, 0xeee6e7d6, 0x83543d0f, 0x1db03142, 
	0x8375ebdc, 0xc29d90ec, 0x45d38e2b, 0x2ef5c0a3, 0xbe7469db, 0x3abfe31f, 
	0x196d91fb, 0x038709db, 0x3c93a3ff, 0xd347f7ce, 0x315d4cf2, 0x9d4611d7, 
	0x5715d47e, 0xdf303f79, 0xe6f693cf, 0x5dd7007a, 0xedb7fedd, 0xda3a2f32, 
	0x6ce43214, 0xfb6b8f8e, 0x2733d198, 0x7bd3f7df, 0x43db1c8b, 0x5ddc5bf1, 
	0x10f14fd0, 0x8401ba14, 0xbf2aef7f, 0x2fc8df5a, 0x03883ab7, 0xc3c2ef8c, 
	0xc489f771, 0x8fbdf681, 0x7f1a261a, 0x1b9f8bc3, 0x26c58e16, 0xde0f2878, 
	0x9bad6078, 0x7f2094e4, 0xa6ebee1f, 0x0bd308b1, 0xbd25e0e3, 0xdc687cdf, 
	0x3c29190d, 0xfbdb0528, 0xead07865, 0xe24fbc60, 0xdc8364c4, 0xde2a27c7, 
	0xbf21a0b1, 0x493ad96e, 0x7f297891, 0xc18f9bd9, 0xff18a911, 0xd7ef1891, 
	0x76463c7f, 0x05e9467e, 0x73f04e2a, 0x2c64e2a7, 0xd6becf95, 0x788d7e81, 
	0x75eedc17, 0xb30f1185, 0xa0de24fb, 0xfa00e0f0, 0x32ed0bc1, 0x4d0d044f, 
	0x7ea4bc23, 0xfb34e067, 0x5d7c36b9, 0x6a8ccfca, 0x985b507f, 0x43bdbb92, 
	0xdba0cfe6, 0xc35c91ab, 0x30df18d0, 0xf218b44c, 0xb14fe819, 0x91cfac22, 
	0x033e42cf, 0x3c3234fd, 0x8ee7afdf, 0x4d7e5507, 0x437f17ee, 0x6f147d13, 
	0xfea1b758, 0x576c9b83, 0x7755eb18, 0xd8b7eca5, 0xadff50ef, 0x02836d81, 
	0x22bed2fd, 0x38107cc8, 0x7aedcfc3, 0x3ebb698b, 0xd73d6118, 0x9fd1dea1, 
	0x3b48d75b, 0x91a14c7b, 0xe04a8d5d, 0x71e50e3e, 0x51eb27fc, 0x5f67e237, 
	0xb4178528, 0x4eaddb0e, 0xe0d1b4e2, 0x23cf3a68, 0x38500ece, 0xeefc4e82, 
	0x5de316f5, 0x19bfb24e, 0x33f2b8c1, 0xde16745f, 0x6f0efe22, 0x9719f854, 
	0xb6f962fb, 0xeb300bf4, 0x61dc74f4, 0xb33ca1fb, 0xe74fd467, 0x9b7154c8, 
	0xddc6338c, 0x068eaa50, 0xe325cfd5, 0x63b9fa8d, 0x98c79f1a, 0xdd79f30c, 
	0x8e32c2a7, 0x49ed24a6, 0x4e7bda48, 0x728bded2, 0x82acb0d4, 0xe69ed15b, 
	0x670e32c3, 0xce5d0e28, 0x2c71d7da, 0xc26ecd14, 0xd17ddf99, 0xf68b008c, 
	0xd3b7b7ca, 0x20eb0b39, 0x7cc6a9e4, 0x10b670a9, 0xc4afae20, 0xbd6cbc5d, 
	0xa9cde743, 0x23fd93c3, 0x9b8b5ff9, 0x1142c7ea, 0x83794b39, 0xba85d8f0, 
	0x741fb0b3, 0x2dbe40ad, 0xe10b6712, 0xcf286707, 0x4ddd0a14, 0xf353e538, 
	0xe1130750, 0xd13e2ad3, 0x90ebaf6f, 0x34e11b7d, 0x8d5dbfc5, 0x81e21fe5, 
	0x4a297eed, 0x7f7adcb8, 0xef6bca8d, 0xa13b11b8, 0x4ddc6c68, 0x2f3a28f6, 
	0x003b7ddc, 0x71143b2e, 0xce7c431b, 0xf93fd222, 0x6097c49a, 0x85ab9d11, 
	0xfb9a73ce, 0x776da67d, 0x2d4110e5, 0xbda48afe, 0x708abf64, 0x77f34c5c, 
	0xf506f998, 0x5d857683, 0x62d3faac, 0x53a8fdc1, 0xcf78712c, 0x314fea5e, 
	0xec5182be, 0x0feeecc3, 0x866af2f7, 0x265c516e, 0x3a4ae3e3, 0xec6a4cd7, 
	0x8bad09ca, 0x2ae91e61, 0x0bb95d1d, 0x0d5746f3, 0xc1dec6e4, 0x8b138171, 
	0x54fde0ed, 0xf2833df1, 0xaaba1b1f, 0x6cb64eb8, 0x71fd4c2b, 0xf44436b1, 
	0x9f92f3a0, 0xaa7023fb, 0x9cbb3f68, 0x757d40a5, 0xa41063cb, 0xaccb30be, 
	0x741fdc64, 0x7c403bfe, 0x8dafdf38, 0xe26afcb1, 0x3e64f27f, 0x5809edf7, 
	0x2feeab3e, 0xbacbcd46, 0x79d3545c, 0xaa8af56f, 0xa207da41, 0x23f1f92d, 
	0x1fe4c3e8, 0xa77fbf68, 0x43a5b63c, 0x698967d6, 0xa39441c4, 0x7dfcbc29, 
	0xaa03ea75, 0xf7c2eaae, 0x5f50b6b2, 0x3978c23b, 0xf424c8f1, 0x64471845, 
	0x59b42f5d, 0xf6c3f4b8, 0x9a970e3f, 0xbd2e243b, 0x9cf8794e, 0x248fa7c2, 
	0x7de5853e, 0x985e158e, 0x0f6e57ee, 0x43ab95f9, 0xbdf6dff2, 0x31677e7f, 
	0x98f151c6, 0x8a3ae1ee, 0xd3c236ea, 0xc25f8c6c, 0x35cfd09f, 0xf52e362e, 
	0xcbdb1aaf, 0xbfac995b, 0xebfae5ae, 0xd9feb4bb, 0xf26a7df9, 0xdce987dc, 
	0xa2588458, 0x8f1398d9, 0x8b07647d, 0x54f9f1e2, 0x8f145a3c, 0xbbaae06f, 
	0x8b491ab0, 0x10e28b47, 0xaf8a5ce9, 0x67f153d7, 0x6805fc51, 0x4e2fe31e, 
	0xfd06b075, 0x63d3a15f, 0xf1546dfc, 0x7bcf89b8, 0xdbcf1b24, 0x9ea3f6f5, 
	0x4dd73c3a, 0xf1ee7eaf, 0x747d296b, 0x1ba8fabe, 0x877a0653, 0x89b81513, 
	0x9fb03560, 0x595742f7, 0x77a46eec, 0xe0668e34, 0x2b07dbf9, 0xb72819e3, 
	0x4c9c18b7, 0xf95117ba, 0xfc8ad824, 0xff60ffa8, 0x1f74fdd9, 0x035beb82, 
	0x58265714, 0x582b79e9, 0x41b6f928, 0x31d50b65, 0xd99f3bed, 0xbd22f74f, 
	0x63a45eea, 0x3450af48, 0x7c90b3df, 0x2a82b3aa, 0xbaefb77f, 0xfe483fef, 
	0x12df7536, 0x93ce03ec, 0xd1b4fcb7, 0x0deb93ca, 0xbf5fa30d, 0xe9347948, 
	0x2e285b1f, 0x538abe31, 0x13f1c5f1, 0xe74b7192, 0x3ddab8e7, 0xfe305e3f, 
	0x00f8972e, 0x421f194b, 0xfc7a7970, 0x34c5d982, 0x2f84fad5, 0x894b5f18, 
	0x9d1ec5ff, 0x2e9f0fe3, 0x70013c4d, 0x3972287d, 0x5bca1ce1, 0x3ae2faa2, 
	0xc10b0fbe, 0x827cf492, 0x934e98f2, 0x7ffc4757, 0x64f285df, 0x471dd6dc, 
	0x460d5f79, 0x9642c096, 0x3875c357, 0x579484e1, 0x357f6733, 0xf9c3fbe9, 
	0x55f339aa, 0xd77bf3e9, 0x3f1875cb, 0x6b3ef196, 0x47dc7d69, 0x13bfbcad, 
	0x5be409b5, 0xf43515ef, 0xd93c5cfe, 0x3889f4a9, 0xeb7438ca, 0x708aa464, 
	0x64ffa934, 0x2d7d7efd, 0x002314ec, 0x62388df5, 0x0c58ad1c, 0x54bfe439, 
	0xff91f642, 0x677bed7a, 0xb3b042b8, 0xba3ece48, 0x1275c487, 0x7d598c81, 
	0xe72bfe06, 0x8c262b47, 0xe07f7a78, 0x467bc964, 0xef7905a8, 0x903d3b58, 
	0x1d736f3e, 0xea430b6e, 0xebd63d61, 0x33aaefc8, 0x2c27cf1c, 0x7b45ef98, 
	0xe83cfe31, 0x9fa90b87, 0x13f54de8, 0xe4caf740, 0xdcb001a7, 0x672f2c53, 
	0x91573b8a, 0x9d2fef2b, 0x60779e5c, 0x65f38c2c, 0xa2658e33, 0x2769d2bc, 
	0x547d44c7, 0xa1ce1f15, 0x3ad2a57e, 0x5748596c, 0x688f9a98, 0xa873843f, 
	0x6f3f28ef, 0x941c50e7, 0xa23ed8cd, 0x2e45a74b, 0xdb8e2fcd, 0xd6bdd116, 
	0xf1b86f47, 0x2c07cdbc, 0xaf1afbc3, 0xe77ba3e7, 0xa18cfe85, 0x024c51a5, 
	0xd1770b55, 0x742f5abd, 0xa7c86a17, 0x3595adbf, 0xfab9fe60, 0x0de5c347, 
	0x45171c5e, 0x5e909bca, 0xe567f0b7, 0x9baf484d, 0xc54e5c38, 0x3ce1c352, 
	0xd43f8f3f, 0xb0c588fc, 0x3976b5f2, 0x1f8b53fe, 0xcaf8614b, 0xf8e587f7, 
	0x8d9fd87e, 0xf7aaed75, 0x2367f03e, 0xc3b3eabd, 0x35c70b7e, 0xf055e69f, 
	0x1457a598, 0xd192d8e2, 0xb6dfc721, 0x7ae3d454, 0x283e17cd, 0x9af5c7ab, 
	0xacb87d7f, 0x7e6bc70e, 0xaac72c35, 0x1c0ad948, 0xca3a2b5b, 0x7b79fc79, 
	0xb29bc079, 0x683fe357, 0x7f7c01e5, 0xdf970bc5, 0xfbef7545, 0xa81b191d, 
	0xadf3d29f, 0x589ea927, 0xf973f0ad, 0xe74161ee, 0xc9e48d76, 0xe1d967fc, 
	0x5f485fbe, 0x3892ffa1, 0xfb188094, 0xa15bdd11, 0x8764c00b, 0xa21e01b5, 
	0xdd161078, 0xdf0025ef, 0x5bda49bb, 0x3c7da9f4, 0x91f4d008, 0xc79d3f92, 
	0x9fd738fe, 0xeea47f26, 0xf6e33ac7, 0xf9682d04, 0x239e292a, 0xdf902f57, 
	0xc1acfe1d, 0xe27e8d57, 0xabe43e69, 0xcbfcd1c7, 0x3815dc86, 0x2875de66, 
	0xecc709b7, 0x0cb069bf, 0xf1ef8fdc, 0x7cf51643, 0x2563baee, 0xd638fdf5, 
	0xc2692f9c, 0x715f77b8, 0xf54d19e0, 0x1cf17b9b, 0xbe5c146f, 0xda48f5c1, 
	0x444d36b9, 0x19a4ff54, 0xd0b65ef4, 0xdeb879c2, 0x01faa0f5, 0xfbe62ae1, 
	0x4fd54d7a, 0xc8d91f42, 0x411d1468, 0x80d86abf, 0x03dd3aa5, 0xd1759d0e, 
	0x9bfbbe79, 0xf9cf92e5, 0xb7afe736, 0x277be4c6, 0xfa9391f2, 0x38cccf1c, 
	0x4a5951d5, 0xae37baff, 0x68eac95d, 0x55ae3373, 0x78c1dc2b, 0xe5ef2539, 
	0x3fa52eb9, 0xf692fad4, 0xf039eb27, 0x5a2b6d32, 0x8e4979f4, 0xb02bc493, 
	0xb5fbe433, 0xdf521e92, 0x9e481e6d, 0xcf49cec7, 0x66ac0bd7, 0x9abfdfbe, 
	0x7d704bbe, 0x2e29b8e4, 0xc8f2cb35, 0x4cf6cf7a, 0xc3dbfacb, 0x55e821cf, 
	0x8ebc29df, 0x31e6f3ce, 0x92731d1e, 0x9c6448f1, 0xa73211e2, 0x90999d24, 
	0x4939d674, 0x74945d67, 0x5df911f6, 0x8e38fb23, 0x4fc8c17a, 0x5712dc08, 
	0xd722fbca, 0xb231efa5, 0xb134cfef, 0xda4f78fe, 0x3a91fb8d, 0x13f28797, 
	0x479e47d9, 0x9fba94e1, 0x42b9d371, 0x5143ff29, 0xf510c33a, 0xdb87dcf9, 
	0x0af2b3b5, 0x77dc2538, 0xe1567124, 0x1234fde9, 0x42d85bce, 0x53aefecf, 
	0xad6179c2, 0xdf9f7f7c, 0xbf7af8cf, 0x896ea3d2, 0x14038a12, 0x71e948bf, 
	0xaf0f79d1, 0x3ae1c8b3, 0xcc7c5ed7, 0x49e2f4cb, 0x949e9749, 0x479c6974, 
	0x3bda6cbb, 0xa6cbaf0b, 0xa07fc833, 0x0bfb20f6, 0x7bf14d94, 0xeb212ca2, 
	0x9273f2e6, 0xe928bf2e, 0x5c377d59, 0xc545b7ea, 0x4e574929, 0x2132ba49, 
	0x9273aae9, 0xe928baae, 0x2fd223ea, 0xf5cb8fab, 0xba484e6a, 0x6ba494e6, 
	0xf9cd24a7, 0xce4b7f0e, 0x45c97a49, 0x84276b49, 0x2efc97b4, 0xd1e7fa80, 
	0x5c71a7d1, 0x9ee8d4f6, 0x9df4c391, 0x27da9469, 0x7479b658, 0x8f1d6c4f, 
	0xedf44230, 0xc17d45c2, 0xaef64db2, 0x2c7e8927, 0x63f4ce5e, 0x7cd7aef6, 
	0x7f15be38, 0x23413632, 0x83bc93f2, 0xcd00c976, 0xdf39141f, 0xfee3fe21, 
	0x8d2b58a1, 0xc7df8da3, 0x89d97c3a, 0x653f9cb8, 0x38b93d8b, 0x15eeaf3e, 
	0x9d51612c, 0xaca758fd, 0x21fe2887, 0x8c0ffe3d, 0x6b5a3df3, 0x47a48e4b, 
	0x5f38e79e, 0xc648cab3, 0x2523df2d, 0xf1dc1be3, 0xc630ba08, 0xc5275f7f, 
	0x82e3bebf, 0x11b9d166, 0x596f883f, 0x7ca345ac, 0xebdd0d7f, 0x18d13f61, 
	0xf1025db5, 0x743ef1bf, 0x776c33e0, 0xa06dc92f, 0x01dfe4e7, 0xbf918570, 
	0xf3c13ee1, 0x1d8816d9, 0x7dc7ccd5, 0x6ff7aaff, 0x09dfc239, 0x431a3b4d, 
	0xdc7eabf9, 0xbcf947de, 0x2d83d549, 0xfb04b202, 0x6b79e091, 0x50e88dfa, 
	0x4f767cda, 0x51b4fffc, 0xf74bdf7e, 0x45752d28, 0xe596b019, 0xfdb1dc4b, 
	0xc552ce7c, 0x26405abf, 0xf5c083c9, 0xd11127ac, 0xdd757e79, 0x7d8059cd, 
	0x94b4ce57, 0xd2710677, 0xfbe07cc4, 0x42fec6d5, 0xfdebabac, 0xf9f7165a, 
	0xe25de070, 0xbee00faf, 0x024a5e30, 0x7e1d8d4b, 0xd39b47d4, 0x02eddfcf, 
	0x5cf49470, 0x12fe4b6f, 0xe780547c, 0x5edff96d, 0xf298436f, 0x64fd7006, 
	0x7ee11e12, 0x1e5456db, 0xf5fcf0d5, 0x943fc83d, 0x46ada75a, 0x3794c2b8, 
	0xf50760db, 0xda1ebca7, 0x72dded61, 0x9fa6601e, 0x8ddb59d6, 0xad63ee34, 
	0xf74bd6b5, 0x96eeeb60, 0x88e2baf4, 0x7f25bba4, 0x4bdc7fab, 0xeaad66f7, 
	0x9ad3d5fd, 0x7f7ab4c9, 0x098b4ccd, 0x3e6efb69, 0x8f74961f, 0x67186da4, 
	0x7e4a35fe, 0x3cb3a98b, 0xbc63c7be, 0xae3d662e, 0xd495eb51, 0x89599d61, 
	0x257ad472, 0x5efdfc5b, 0x5ab353d4, 0xad76f50f, 0x76dcf517, 0x530d708f, 
	0x227c4dff, 0x15b69fa5, 0xffa8791f, 0x2daef7c1, 0x95bbf5a2, 0xb28aea7e, 
	0xea81fb00, 0x6405a290, 0x869cbd88, 0x2ff94220, 0xefa51638, 0x95576d49, 
	0xf61d500c, 0xeff98de7, 0xcfbeb299, 0xeded218c, 0x35ccfd94, 0x7a49d83e, 
	0x05f47ae5, 0x1ee113f2, 0x3dd27996, 0xcee8f640, 0xdfe131fb, 0x31ff34b3, 
	0x5f5167f3, 0x7fcc64be, 0x7c9df694, 0x4fdf2b1f, 0xffd91c64, 0xcfacf645, 
	0xc630ee16, 0x0e3a7d6d, 0xb416fd53, 0xc38c2d33, 0xdbc4b6b5, 0x879426fa, 
	0xcd2cf2fe, 0xddb807ef, 0xe7f9360d, 0x51a30073, 0x8b19bfba, 0xda7a467f, 
	0x77bac217, 0xb8b9d54c, 0x0e8967bf, 0xad0b70a5, 0x5a2de4b0, 0x5dbc27bf, 
	0x315931f5, 0x21ce8f8c, 0xffba741d, 0x086b2135, 0xe951bbd7, 0xf5f55ea7, 
	0x8d03d2b6, 0xb1b05df4, 0xac6fde53, 0x433f402f, 0xa923bb00, 0x22c8286f, 
	0xadedd2fb, 0x41b80418, 0x8f5927d9, 0x96663bd4, 0x003ec528, 0xe9fd3c8b, 
	0xe70dfcd4, 0xee4cb39b, 0xe1fb8187, 0xd2b6915b, 0x7f88dbe8, 0x562f5c81, 
	0xb133d72c, 0x378fad2f, 0x72c59966, 0x6a42f35d, 0xfde8dbdd, 0xd3f7a90b, 
	0x9b3d8fd7, 0x69bad346, 0xbd31ed7c, 0xf4f8ec9a, 0x3f20cd49, 0x81a42e7c, 
	0x70e8867e, 0xcd6bdd01, 0xfb81fbaf, 0x22af9c0a, 0xb1aa87fd, 0xe9f1c17f, 
	0xf415f1e9, 0x3e6f8dfe, 0x3ea26d5a, 0xaf1e6e6f, 0xcef1c7ce, 0xf27b92b6, 
	0xd221ff50, 0xb313aca7, 0xefaaebce, 0x9f613b61, 0xd3657c82, 0xff014976, 
	0x32a21f7f, 0xbb2612fa, 0x01ba0af2, 0xfda2b280, 0x6f50b33f, 0xa348b9a5, 
	0x257b16dd, 0xe43ef73d, 0xcc57a53e, 0xbe7339e3, 0xd93d3047, 0xf84e8df1, 
	0x8b7d640c, 0xb462bffb, 0x7a2ea802, 0x907bde96, 0x59bcaafa, 0x74bfd57d, 
	0x6aa7cce0, 0x6ffeed1e, 0x0d9ee873, 0xc77d308f, 0x3e3cad86, 0x7e4fd6a3, 
	0x275b1207, 0x79a7ea81, 0xeb259afd, 0x6f8ec9eb, 0x483de4a6, 0x9aaba96d, 
	0xb30de3fb, 0xf511e1d7, 0xa6bdca16, 0xdd3d40da, 0xd65bf45d, 0x39ea13ef, 
	0xba56e8da, 0x046bf8e7, 0xc226ef4c, 0x744589d7, 0xab0f65de, 0x07e7177a, 
	0x2a721eb8, 0xe0dd724f, 0xec1c5294, 0xea0ff554, 0xe9f194ab, 0x0cf7554e, 
	0xceebd701, 0x641d6496, 0x923a6d33, 0xdf024c4e, 0x79d4b983, 0x052ecb74, 
	0x7aa1cf29, 0x503c2f4d, 0x45f58759, 0x5555c9e0, 0x5def302b, 0x5542f7b5, 
	0x360b8e03, 0x95cf877c, 0x08fcbdfe, 0xb6872f7d, 0xb275d992, 0x3ebed3ac, 
	0x1f77f1aa, 0x4f9c9fb4, 0xf692cbd5, 0x1797aa5f, 0x1797a9cf, 0x58cbd7a7, 
	0x79622ee7, 0xaf4c5eaa, 0xbbbd54d3, 0x8bbbd558, 0x6ecb2ec9, 0xca3dca87, 
	0xa696fb0f, 0xe0a4a8fc, 0x4cc69d07, 0xa57ffc6a, 0x00a210c5, 0x000b4c22, 
	0xffffffff, 0x00007f86, 0x000000d0, 0x001e13a5, 0x00124003, 0x001e3f46, 
	0x001e43c8, 0x001e105a, 0x001e58c8, 0x001e4438, 0x001e1237, 0x001e1298, 
	0x001e121a, 0x001e167a, 0x001e3fc5, 0x001e1267, 0x00000090, 0x00002475, 
	0x000027e4, 0x00002f1a, 0x00003367, 0x00003662, 0x00003789, 0x001e1bf8, 
	0x001e17b0, 0x00003a0c, 0x00000020, 0x00025816, 0x001e585c, 0x00000020, 
	0x00040002, 0x001e015e, 0x00000020, 0x00040350, 0x0004049a, 0x00000020, 
	0x00060d93, 0x00060cc7, 0x000000a0, 0x001e0895, 0x001e081a, 0x00060a8d, 
	0x001e0ba0, 0x00060c17, 0x00060995, 0x00060722, 0x0006059f, 0x00060642, 
	0x000604dc, 0x00000040, 0x00084868, 0x00084c7a, 0x00084ea8, 0x001e4f82, 
	0x00000020, 0x001e4445, 0x001247d2, 0x00000020, 0x000a54b8, 0x001e5662, 
	0x00000060, 0x00125380, 0x001e5319, 0x000c513a, 0x000c5195, 0x0012502b, 
	0x000c5148, 0x00000020, 0x80008000, 0x00000000, 0x00000020, 0x00000000, 
	0x00000082, 0x00000020, 0x00000000, 0x00000080, 0x00000020, 0x000012b5, 
	0x000017c1, 0x00000090, 0xffffb569, 0xffffffff, 0x2504ffff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xffffffe5, 0xffffffff, 0x0018ffff, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xffffffff, 0xffffffff, 
	0x0000ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xffffffe4, 0xffffffff, 0x0010ffff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xfffffdc0, 0xffffffff, 0x0088ffff, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xfffffd82, 0xffffffff, 
	0x0084ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xfff19cc1, 0xffffffff, 0x0098ffff, 0x00000069, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xfffffd69, 0xffffffff, 0x0204ffff, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xffffffe5, 0xffffffff, 
	0x001effff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xfffffc64, 0xffffffff, 0x0110ffff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xfffffdc0, 0xffffffff, 0x0084ffff, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xffffffe2, 0xffffffff, 
	0x0004ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xffff9cc1, 0xffffffff, 0x8084ffff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xfffffd69, 0xffffffff, 0x0404ffff, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xffffffe4, 0xffffffff, 
	0x0008ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xffff8ce1, 0xffffffff, 0x0220ffff, 0x00000001, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xfffffd69, 0xffffffff, 0x0304ffff, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xffffffe4, 0xffffffff, 
	0x0012ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xffffffe0, 0xffffffff, 0x0008ffff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xfffffc67, 0xffffffff, 0x0314ffff, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xffffffe1, 0xffffffff, 
	0x0004ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xfffffcab, 0xffffffff, 0x0784ffff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xffffa120, 0xffffffff, 0x4108ffff, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xffffffe3, 0xffffffff, 
	0x0014ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xffffffe7, 0xffffffff, 0x0004ffff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xfffffd69, 0xffffffff, 0x0504ffff, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xffff8ce1, 0xffffffff, 
	0x0420ffff, 0x00000001, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xffffffe8, 0xffffffff, 0x0004ffff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xffff8ce1, 0xffffffff, 0xa308ffff, 0x00000001, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xffffffe5, 0xffffffff, 
	0x0014ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xffff8ce1, 0xffffffff, 0x4110ffff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xffffbd09, 0xffffffff, 0x6114ffff, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xfffffc46, 0xffffffff, 
	0x0184ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xffffc067, 0xffffffff, 0x418effff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xfffffde9, 0xffffffff, 0x0198ffff, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xffffb808, 0xffffffff, 
	0x2104ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xffff9cc1, 0xffffffff, 0xe108ffff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xfffffe02, 0xffffffff, 0x0104ffff, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xffffbd09, 0xffffffff, 
	0x6104ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xffffffe6, 0xffffffff, 0x0004ffff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000090, 
	0xfff10e07, 0xffffffff, 0x6104ffff, 0x00000018, 0x00000000, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000090, 0xfffffd09, 0xffffffff, 
	0x0108ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
	0x00000000, 0x00000090, 0xffffffe7, 0xffffffff, 0x0008ffff, 0x00000000, 
	0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000580, 
	0x000d0000, 0x000c00d0, 0x00000190, 0x00080190, 0x00050210, 0x00030260, 
	0x00220290, 0x000004b0, 0x00060000, 0x000f0060, 0x00000150, 0x000a0150, 
	0x000301f0, 0x00020220, 0x00070240, 0x000002b0, 0x000a0000, 0x000c00a0, 
	0x00000160, 0x00040160, 0x000501a0, 0x000201f0, 0x001c0210, 0x000003d0, 
	0x00080000, 0x000f0080, 0x00000170, 0x00090170, 0x00040200, 0x00020240, 
	0x00100260, 0x00020360, 0x00000000, 0x00020000, 0x00110020, 0x00090130, 
	0x000801c0, 0x00020240, 0x000a0260, 0x00020300, 0x000c0000, 0x000c00c0, 
	0x00000180, 0x00080180, 0x00050200, 0x00020250, 0x00200270, 0x00000470, 
	0x000c0000, 0x000c00c0, 0x00020180, 0x000801a0, 0x00050220, 0x00020270, 
	0x00170290, 0x00000400, 0x000c0000, 0x000a00c0, 0x00000160, 0x00080160, 
	0x000501e0, 0x00020230, 0x000c0250, 0x00000310, 0x000f0000, 0x000500f0, 
	0x000c0140, 0x00000200, 0x00000200, 0x00000200, 0x00000200, 0x00000200, 
	0x000f0000, 0x000500f0, 0x000d0140, 0x00040210, 0x00000250, 0x00000250, 
	0x00000250, 0x00000250, 0x00070000, 0x00020070, 0x000a0090, 0x00000130, 
	0x00000130, 0x00000130, 0x00000130, 0x00000130, 0x00000200, 0x00060000, 
	0x00020060, 0x00040080, 0x000000c0, 0x000000c0, 0x000000c0, 0x000000c0, 
	0x000000c0, 0x000f0000, 0x000500f0, 0x000c0140, 0x00000200, 0x00000200, 
	0x00000200, 0x00000200, 0x00000200, 0x000f0000, 0x000500f0, 0x000d0140, 
	0x00040210, 0x00000250, 0x00000250, 0x00000250, 0x00000250, 0x00070000, 
	0x00020070, 0x000a0090, 0x00000130, 0x00000130, 0x00000130, 0x00000130, 
	0x00000130, 0x00000080, 0x00060000, 0x00020060, 0x00040080, 0x000000c0, 
	0x000000c0, 0x000000c0, 0x000000c0, 0x000000c0, 0x00000020, 0x0000c220, 
	0x0001ffff, 0x000000e0, 0x00000138, 0x00000128, 0x00000132, 0x00000136, 
	0x0000012a, 0x00000126, 0x00000138, 0x00000130, 0x0000012c, 0x00000134, 
	0x00000138, 0x00000124, 0x0000012e, 0x00000138, 0x00000020, 0x00000220, 
	0x0001ffff, 0x000000e0, 0x00000137, 0x00000127, 0x00000131, 0x00000135, 
	0x00000129, 0x00000125, 0x00000137, 0x0000012f, 0x0000012b, 0x00000133, 
	0x00000137, 0x00000123, 0x0000012d, 0x00000137, 0x00000050, 0x00000000, 
	0x0000a5d1, 0x00008000, 0x00008000, 0x00008023, 0x00000060, 0x00008000, 
	0x00000000, 0x0000a032, 0x00008011, 0x00008011, 0x00008023, 0x00000060, 
	0x00008000, 0x00000000, 0x0000e032, 0x00008011, 0x000085d1, 0x000085e3, 
	0x00000050, 0x000085d1, 0x00000000, 0x00008003, 0x00008003, 0x00008003, 
	0x00000060, 0x00008023, 0x00000000, 0x000085c4, 0x00008004, 0x00008004, 
	0x00008003, 0x00000020, 0x00000000, 0x000012b5, 0x00000020, 0x00000001, 
	0x00000007, 0x00000080, 0x00000000, 0x00000001, 0x00000002, 0x00000003, 
	0x00000004, 0x00000005, 0x00000006, 0x00000007, 0x00000080, 0x00000000, 
	0x00000002, 0x00000004, 0x00000006, 0x00000008, 0x0000000a, 0x0000000c, 
	0x0000000e, 0x00000040, 0x00000000, 0x00000004, 0x00000008, 0x0000000c, 
	0x00000080, 0x00000001, 0x00000003, 0x00000005, 0x00000007, 0x00000009, 
	0x0000000b, 0x0000000d, 0x0000000f, 0x00000040, 0x00000001, 0x00000005, 
	0x00000009, 0x0000000d, 0x00000040, 0x00000002, 0x00000006, 0x0000000a, 
	0x0000000e, 0x00000040, 0x00000003, 0x00000007, 0x0000000b, 0x0000000f, 
};
/* Data size: 574080 bytes */

/* modes tree buffer */
ARRAY_DECL u8 modes_tree_buf[] = {
	0x02, 0x02, 0x04, 0x02, 0x00, 0x11, 0x0f, 0x04, 0x02, 0x02, 0x04, 0x02, 
	0x00, 0x11, 0x0e, 0x04, 0x02, 0x02, 0x01, 0x07, 0x08, 0x05, 0x00, 0x09, 
	0x02, 0x02, 0x00, 0x0a, 0x00, 0x12, 0x00, 0x04, 0x02, 0x02, 0x01, 0x07, 
	0x08, 0x04, 0x00, 0x09, 0x02, 0x02, 0x00, 0x06, 0x05, 0x00, 0x04, 0x02, 
	0x02, 0x00, 0x06, 0x04, 0x00, 0x05, 0x02, 0x02, 0x05, 0x0c, 0x00, 0x00, 
	0x06, 0x02, 0x02, 0x05, 0x00, 0x10, 0x00, 0x04, 0x02, 0x02, 0x00, 0x06, 
	0x0f, 0x00, 0x04, 0x02, 0x02, 0x00, 0x06, 0x0e, 0x00, 0x04, 0x02, 0x02, 
	0x00, 0x0a, 0x00, 0x12, 0x04, 0x02, 0x02, 0x00, 0x06, 0x10, 0x00, 0x04, 
	0x00, 0x01, 0x06, 0x01, 0x07, 0x09, 0x02, 0x02, 0x05, 0x0c, 0x00, 0x04, 
	0x02, 0x02, 0x00, 0x06, 0x04, 0x04, 0x02, 0x02, 0x04, 0x00, 0x11, 0x04, 
	0x02, 0x02, 0x00, 0x06, 0x0f, 0x04, 0x02, 0x02, 0x00, 0x06, 0x10, 0x04, 
	0x02, 0x02, 0x00, 0x06, 0x0e, 0x04, 0x02, 0x02, 0x05, 0x10, 0x00, 0x04, 
	0x02, 0x05, 0x02, 0x00, 0x0b, 0x0e, 0x02, 0x05, 0x02, 0x00, 0x0b, 0x0f, 
	0x02, 0x05, 0x02, 0x00, 0x0b, 0x10, 0x02, 0x05, 0x00, 0x00, 0x13, 0x02, 
	0x02, 0x04, 0x11, 0x04, 0x02, 0x02, 0x04, 0x0f, 0x04, 0x02, 0x01, 0x0b, 
	0x0d, 0x04, 0x02, 0x05, 0x02, 0x0b, 0x10, 0x02, 0x05, 0x00, 0x00, 0x06, 
	0x01, 0x06, 0x01, 0x0a, 0x08, 0x02, 0x00, 0x06, 0x00, 0x04, 0x02, 0x05, 
	0x02, 0x0b, 0x0e, 0x02, 0x05, 0x02, 0x0b, 0x0f, 0x02, 0x05, 0x00, 0x06, 
	0x02, 0x05, 0x00, 0x04, 0x00, 0x01, 0x07, 0x09, 0x02, 0x00, 0x0b, 0x04, 
	0x02, 0x04, 0x00, 0x09, 0x02, 0x04, 0x00, 0x05, 0x02, 0x00, 0x0d, 0x04, 
	0x02, 0x0c, 0x04, 0x01, 0x06, 0x0a, 0x02, 0x05, 0x0f, 0x02, 0x0d, 0x04, 
	0x02, 0x0e, 0x04, 0x02, 0x0f, 0x04, 0x02, 0x0b, 0x04, 0x00, 0x07, 0x03, 
};
/* Data size: 264 bytes */

/* FW overlays array */
ARRAY_DECL u32 fw_overlays[] = {
	0x001bb000, 0x00502800, 0x0000f900, 0x0000d010, 0x00008980, 0x40e0ac0f, 
	0x000000c3, 0x81400a02, 0x0000788e, 0x54000000, 0x00004180, 0xffc00000, 
	0x00001980, 0xffffffff, 0x00007f86, 0x008806ec, 0x00005f80, 0x00804080, 
	0x00008a84, 0x6000100a, 0x0000e402, 0x60005009, 0x0000b406, 0xc0005009, 
	0x00006c06, 0x82012c13, 0x00007204, 0x00000823, 0x00006c05, 0x6000100a, 
	0x0000e402, 0x40155009, 0x0000b502, 0x00008208, 0x0000f400, 0x00001009, 
	0x0000ec03, 0x40015009, 0x0000ec83, 0x2b809800, 0x0000f900, 0x00002200, 
	0x00008980, 0x2a3aff5e, 0x00008a2c, 0x016714e4, 0x00008a34, 0x821432a1, 
	0x00007004, 0x9c8004aa, 0x0000f892, 0x04000001, 0x00008080, 0x08c00080, 
	0x00006180, 0x09000000, 0x00004980, 0x233b4406, 0x0000b038, 0x23bba006, 
	0x00003038, 0x233b5606, 0x0000b038, 0x237b6006, 0x00003038, 0x237b7206, 
	0x00003038, 0x237b8406, 0x00003038, 0x237b9606, 0x00003038, 0x23bbb206, 
	0x00003038, 0x23bbc406, 0x0000b038, 0x23bbd606, 0x0000b038, 0x23fbe006, 
	0x00003038, 0x23fbf206, 0x00003038, 0x23fc0406, 0x0000b038, 0x23fc1606, 
	0x0000b038, 0x243c2006, 0x00003038, 0x243c3206, 0x00003038, 0x243c4406, 
	0x0000b038, 0x81000e68, 0x00006283, 0x01808275, 0x00008880, 0x08003375, 
	0x00006300, 0x34c34023, 0x00002003, 0x01802800, 0x00006191, 0x01a554aa, 
	0x0000c909, 0x0c800000, 0x000002d4, 0x55603023, 0x0000e005, 0x03834032, 
	0x00003001, 0x81b71ee3, 0x00006100, 0x13834032, 0x0000e001, 0xe0212606, 
	0x00002085, 0xe0003606, 0x0000a085, 0x0b400000, 0x00006180, 0x23834032, 
	0x0000e001, 0x0c000000, 0x00006180, 0x70834632, 0x00006000, 0x09800000, 
	0x000082dc, 0x01004406, 0x0000e283, 0x0a000000, 0x00008980, 0xc8e44c89, 
	0x00006111, 0x0a400000, 0x0000c980, 0x81040632, 0x00006283, 0x0ac00000, 
	0x00008980, 0x0b000000, 0x000082f8, 0x0bc00000, 0x000003c4, 0x0cc00000, 
	0x000083d0, 0x0d400000, 0x000003d8, 0x0dc00000, 0x000003e0, 0x0e400000, 
	0x000003e8, 0x0ec00000, 0x000083f0, 0x0f400000, 0x000003f8, 0x0fc00000, 
	0x000084c0, 0x10400000, 0x000004c8, 0x10c00000, 0x000084d0, 0x11400000, 
	0x000004d8, 0x11c00000, 0x000004e0, 0x12400000, 0x000004e8, 0x12c00000, 
	0x000084f0, 0x13400000, 0x000004f8, 0x13c00000, 0x000085c0, 0x14400000, 
	0x000005c8, 0x14c00000, 0x000085d0, 0x15400000, 0x000005d8, 0x15c00000, 
	0x0000e180, 0xc85b536a, 0x0000c900, 0xc89b6b6d, 0x0000e100, 0x0a80406e, 
	0x00004880, 0x0863c476, 0x00008208, 0x073bd779, 0x00008134, 0x07bbe77b, 
	0x0000013c, 0x493c2f85, 0x0000e101, 0xc9734e69, 0x00004900, 0x00008276, 
	0x00007410, 0x88c00c6d, 0x00006080, 0x8b5b7b6f, 0x00004900, 0xcc134a69, 
	0x0000e100, 0x2a038871, 0x0000c908, 0x826732a1, 0x00007404, 0x2ac39072, 
	0x00006100, 0x2b809900, 0x0000c980, 0xab581302, 0x00009900, 0x000004e3, 
	0x00001583, 0x012554aa, 0x00001909, 0x00008270, 0x00007009, 0x08070404, 
	0x0000e800, 0x00000404, 0x00001583, 0x00008273, 0x0000f00b, 0x826e2ea6, 
	0x0000f100, 0xffffffff, 0x00007f86, 0x01255cab, 0x00009901, 0x00000404, 
	0x00001583, 0x00008273, 0x0000f00b, 0x827381fc, 0x0000f100, 0x2339a406, 
	0x0000b038, 0x2339b406, 0x00003038, 0x0bfb8f72, 0x00008238, 0xb9102a05, 
	0x00006100, 0x40001008, 0x0000e402, 0x6000100a, 0x0000e402, 0xa0001008, 
	0x00003402, 0x81040632, 0x00006283, 0x8000002c, 0x00002403, 0x60002809, 
	0x0000e406, 0xc000080a, 0x0000b402, 0x0180086e, 0x00006180, 0x00005008, 
	0x00002407, 0x03800000, 0x000001e4, 0x0d038070, 0x0000e110, 0x0000a80b, 
	0x0000e482, 0x81000e68, 0x00006283, 0xc000002c, 0x00002407, 0xc0002809, 
	0x0000e406, 0xc000080a, 0x00003403, 0xc9000000, 0x00006180, 0x60005008, 
	0x0000e407, 0x45e00400, 0x000001e1, 0x00000000, 0x0000f480, 0x43803006, 
	0x0000e100, 0x865c3b87, 0x0000c900, 0xcd181302, 0x00009910, 0x2b809800, 
	0x0000f900, 0x00002000, 0x00000980, 0x2a3aff5e, 0x00008a2c, 0x016714e4, 
	0x00008a34, 0x829332a1, 0x00007004, 0x000004aa, 0x00009583, 0x829581fc, 
	0x0000f113, 0x23bba006, 0x00003038, 0x233b4406, 0x0000b038, 0x08c00080, 
	0x00006180, 0x09000000, 0x00004980, 0x237b6006, 0x00003038, 0x01008274, 
	0x00006080, 0x02001008, 0x0000c380, 0x08002374, 0x00006300, 0x34c34023, 
	0x00002003, 0x01040468, 0x00006283, 0xb9102a05, 0x00008900, 0x01002800, 
	0x0000e191, 0x012554aa, 0x00004909, 0x237b7206, 0x00003038, 0x55602023, 
	0x00006005, 0x40005008, 0x0000b406, 0x81371ee3, 0x0000e100, 0x6000080a, 
	0x0000e402, 0xe0212604, 0x0000a085, 0xe0002604, 0x0000a085, 0x237b9606, 
	0x00003038, 0x23bbb206, 0x00003038, 0x23bbc406, 0x0000b038, 0x23bbd606, 
	0x0000b038, 0x243c2006, 0x00003038, 0x243c3206, 0x00003038, 0x01004404, 
	0x00006283, 0xa0001008, 0x0000a402, 0x11800000, 0x0000e180, 0x0d034404, 
	0x00006006, 0xe000a80a, 0x00006480, 0x00005008, 0x0000b407, 0x04202046, 
	0x00006005, 0x02b2d009, 0x0000b586, 0x0e034404, 0x00006006, 0x0000280b, 
	0x00003406, 0xa000080a, 0x0000e401, 0x60005008, 0x0000b407, 0x09400000, 
	0x0000e180, 0x34e02046, 0x00006005, 0x0100086d, 0x0000e180, 0x0012a809, 
	0x00002503, 0x233b5606, 0x0000b038, 0x237b8406, 0x00003038, 0x23fbe006, 
	0x00003038, 0x23fbf206, 0x00003038, 0x23fc0406, 0x0000b038, 0x23fc1606, 
	0x0000b038, 0x03800000, 0x00007900, 0x000c0000, 0x00008980, 0xc000080a, 
	0x00006403, 0xc0005008, 0x0000b407, 0x09800000, 0x000082e0, 0x0b000000, 
	0x000002fc, 0x0c000000, 0x000083c4, 0x0c800000, 0x000083cc, 0x0d000000, 
	0x000083d4, 0x0d800000, 0x000083dc, 0x0e000000, 0x000083e4, 0x0e800000, 
	0x000083ec, 0x0f000000, 0x000083f4, 0x0f800000, 0x000083fc, 0x10000000, 
	0x000084c4, 0x10800000, 0x000084cc, 0x11000000, 0x000084d4, 0x11c00000, 
	0x000004e0, 0x12400000, 0x000004e8, 0x12c00000, 0x000084f0, 0x13400000, 
	0x000004f8, 0x13c00000, 0x000085c0, 0x14400000, 0x000005c8, 0x14c00000, 
	0x000085d0, 0x15400000, 0x000005d8, 0x15e00000, 0x000080f2, 0x04400000, 
	0x000081de, 0x45e00400, 0x000001e1, 0x086b4c75, 0x00000204, 0x03c0406d, 
	0x0000e080, 0x0400406d, 0x00004880, 0x09cb776c, 0x0000020a, 0x0b7b9f72, 
	0x00008238, 0x08bbc477, 0x00008130, 0x077bd779, 0x00000138, 0x07cc2f7b, 
	0x00008211, 0x88c00c85, 0x00006080, 0x865c3b87, 0x0000c900, 0xc8e43486, 
	0x00006111, 0x02d0000b, 0x0000c380, 0x00000000, 0x0000f480, 0x096b4d69, 
	0x0000e101, 0x0a404004, 0x00004880, 0x0ac04004, 0x0000e080, 0x0a804004, 
	0x00004880, 0x01038458, 0x00001281, 0x00028404, 0x00001583, 0x02400000, 
	0x0000e190, 0x03000020, 0x00004990, 0x4262ec5d, 0x00006111, 0x0f02c409, 
	0x00006014, 0x00000001, 0x00007088, 0x03dec800, 0x00007900, 0x00347cca, 
	0x00008980, 0x04e12800, 0x00007900, 0x001be384, 0x00000980, 0x02800000, 
	0x00006180, 0x08001a07, 0x00006106, 0x8301c800, 0x0000e180, 0xc1f00600, 
	0x0000c901, 0x83042c3c, 0x00007500, 0x81f81400, 0x00008014, 0x0202e05c, 
	0x00001900, 0x2b470800, 0x0000e180, 0x08008010, 0x00004900, 0x08789711, 
	0x00000208, 0x08f8a713, 0x00000210, 0x0978b715, 0x00000218, 0x09f8c717, 
	0x00000220, 0x830d32d9, 0x0000f500, 0x0a78d719, 0x00000228, 0x2b78dd0c, 
	0x0000022c, 0x82c524ec, 0x0000f902, 0x01000000, 0x00000604, 0x2bb73800, 
	0x00007900, 0x0037bd5e, 0x00008980, 0x01888811, 0x00008018, 0x83152f20, 
	0x0000f500, 0x01b88511, 0x0000801c, 0xa3802411, 0x000088b9, 0x73003c11, 
	0x00004198, 0x01002411, 0x000080a0, 0x6ca01411, 0x00004488, 0xd9001411, 
	0x0000a09e, 0x00c00c11, 0x0000c789, 0x07204c11, 0x0000068f, 0x6fa04c11, 
	0x000044a8, 0x05005411, 0x0000a08f, 0xe6008c11, 0x0000f88a, 0x64000000, 
	0x0000418c, 0x2c002ee3, 0x00001680, 0x828588b0, 0x00009000, 0xaec0020a, 
	0x00005084, 0x00400000, 0x00008000, 0xaec0040a, 0x00005084, 0x00400000, 
	0x00008000, 0xaec0060a, 0x0000d084, 0x00400000, 0x00008000, 0xaf00000a, 
	0x00005084, 0x00400000, 0x00008000, 0xaf00020a, 0x0000d084, 0x00400000, 
	0x00008000, 0x4007fd18, 0x00006583, 0x2b809a00, 0x00000980, 0xaec0020a, 
	0x0000d004, 0x00400000, 0x00000080, 0xaec0040a, 0x0000d004, 0x00400000, 
	0x00000080, 0xaec0060a, 0x00005004, 0x00400000, 0x00000080, 0xaf00000a, 
	0x0000d004, 0x00400000, 0x00000080, 0xaf00020a, 0x00005004, 0x00400000, 
	0x00000080, 0x82808518, 0x00006090, 0x82bf1fe3, 0x00000908, 0x833e32a1, 
	0x0000f404, 0x2a208012, 0x00007900, 0x00000002, 0x00008082, 0x2ac00013, 
	0x00006084, 0xab5712e2, 0x00000900, 0x23002406, 0x0000a080, 0x2b809a00, 
	0x0000e180, 0xab5712e2, 0x0000c900, 0x2af89713, 0x00008a20, 0xffffffff, 
	0x00007f86, 0xa1c0220a, 0x00002804, 0x834932a1, 0x0000f404, 0xa1c0020a, 
	0x00005084, 0x00400000, 0x00008000, 0xa1c0020a, 0x0000d004, 0x00600800, 
	0x00008082, 0x23002406, 0x00002000, 0x81f71ee3, 0x00009900, 0x23004406, 
	0x0000a002, 0x23005e06, 0x00007902, 0x02600000, 0x00000001, 0x23005606, 
	0x0000a001, 0xe0009607, 0x00005087, 0x00400000, 0x00008000, 0x23203606, 
	0x00002001, 0x00000404, 0x00001583, 0x00000409, 0x00009583, 0xffffffff, 
	0x00007f86, 0x00008361, 0x00007010, 0x00008361, 0x00007008, 0xe0002e07, 
	0x00002085, 0x0000040a, 0x00009583, 0xffffffff, 0x00007f97, 0x01406405, 
	0x00006391, 0x01002405, 0x00008381, 0xe0182607, 0x00002886, 0x01009000, 
	0x00009991, 0xe0182e07, 0x00002896, 0x01a03404, 0x00009111, 0xe0303607, 
	0x00002895, 0x00008398, 0x00007400, 0x82771ee3, 0x00001900, 0x19785a09, 
	0x00005100, 0x00204000, 0x00000000, 0x4007fd18, 0x00009583, 0x827f1fe3, 
	0x0000e108, 0x82408518, 0x0000c090, 0x00008398, 0x00007400, 0xffffffff, 
	0x00007f86, 0xa1c00209, 0x0000d004, 0x00600000, 0x00000082, 0x4007fd18, 
	0x00006583, 0x82371ee3, 0x00000900, 0xe0202608, 0x00002085, 0x82408518, 
	0x00006090, 0x0800b005, 0x00002206, 0x827f1fe3, 0x00009908, 0x017ff805, 
	0x00007900, 0x000000fe, 0x00008280, 0x012027e4, 0x00001800, 0x01000804, 
	0x00001180, 0x01002804, 0x00001200, 0xa1f82a09, 0x00002084, 0x01004004, 
	0x00001880, 0x0107f804, 0x00001380, 0x00008398, 0x0000f401, 0x00002804, 
	0x00009502, 0xa1f82209, 0x0000289c, 0x838086b3, 0x0000f404, 0x82389010, 
	0x00008a20, 0x2ac09813, 0x00001900, 0x00008398, 0x00007200, 0xca18a314, 
	0x00009900, 0x8398874b, 0x0000f404, 0x07c08010, 0x0000e780, 0x2a009012, 
	0x00008900, 0x2ac09813, 0x00001900, 0x00008398, 0x0000f000, 0x839887a4, 
	0x00007404, 0x02c08010, 0x0000e780, 0x2a009012, 0x00008900, 0x2ac09813, 
	0x00001900, 0x00008398, 0x0000f000, 0x03000020, 0x0000e180, 0x08001a07, 
	0x00006106, 0x03f56800, 0x00007900, 0x002750dc, 0x00000980, 0x04d6c000, 
	0x0000f900, 0x0001b0bc, 0x00000980, 0x02800000, 0x00006180, 0xc1f00600, 
	0x0000c901, 0x81f81400, 0x00008014, 0x83982c3c, 0x00007500, 0x02388f10, 
	0x00000024, 0x83002800, 0x00009980, 0x07c00004, 0x00006180, 0x07800000, 
	0x00004980, 0x07009000, 0x00007900, 0x00012280, 0x00008980, 0x83a02c13, 
	0x00007404, 0x07400000, 0x0000f900, 0x00010000, 0x00000980, 0xc7981302, 
	0x00009900, 0x00803eec, 0x00005f80, 0x00004801, 0x00008084, 0x0900a408, 
	0x0000e002, 0x0880a40a, 0x00003002, 0x00000408, 0x0000e583, 0x0a00a409, 
	0x0000a002, 0x18000000, 0x00006180, 0xa0001011, 0x00006412, 0x0000040a, 
	0x00006583, 0x18400000, 0x00000980, 0x18800000, 0x0000e180, 0xc0001011, 
	0x00006412, 0x00000409, 0x00006583, 0x18c00000, 0x00008980, 0x19000000, 
	0x0000e180, 0x60001011, 0x00006412, 0x19400000, 0x000006d8, 0x19c00000, 
	0x000006e0, 0x1a400000, 0x000006e8, 0x1ac00000, 0x000000d0, 0x01400000, 
	0x000000d8, 0x00000408, 0x0000e583, 0x01c00000, 0x00000980, 0x82000a02, 
	0x00009282, 0xffffffff, 0x00007f86, 0x000083bb, 0x0000f010, 0x000083d7, 
	0x0000f010, 0x0000040a, 0x00009583, 0x00000409, 0x00009583, 0xffffffff, 
	0x00007f86, 0x000083d7, 0x0000f008, 0x000083d7, 0x0000f008, 0x1850c800, 
	0x0000e180, 0x00001010, 0x0000e403, 0x23800000, 0x0000f900, 0x00064080, 
	0x00008980, 0x0190c800, 0x00006180, 0x40005010, 0x00006407, 0x82c524ec, 
	0x0000f902, 0x01400000, 0x00008604, 0x2bba4800, 0x00007900, 0x003cf616, 
	0x00000980, 0x01f81702, 0x00008600, 0x83ce2f20, 0x0000f500, 0x5a095502, 
	0x00008606, 0x8180212a, 0x000008b9, 0x01c00004, 0x00006180, 0x01800000, 
	0x00004980, 0x01009000, 0x00007900, 0x00012280, 0x00008980, 0x01400000, 
	0x0000f900, 0x00010000, 0x00000980, 0x000808ec, 0x0000d780, 0x00884e00, 
	0x000081c0, 0xc1981302, 0x00009900, 0xc0003000, 0x0000e181, 0x20001010, 
	0x0000e402, 0x83dd2c13, 0x00007404, 0x00502800, 0x0000f900, 0x00004510, 
	0x00008980, 0xc0c00000, 0x00001980, 0xffc00000, 0x00001980, 0xffffffff, 
	0x00007f86, 0x008806ec, 0x00005f80, 0x00804100, 0x000082c4, 0x01400805, 
	0x00001180, 0x00001805, 0x00009582, 0x00000001, 0x0000f0b3, 0x08070405, 
	0x00006800, 0x00000405, 0x00009583, 0x000083ec, 0x0000700b, 0x83e82ea6, 
	0x0000f100, 0xffffffff, 0x00007f86, 0x00000cab, 0x00009583, 0x000083ec, 
	0x00007013, 0x83ec81fc, 0x00007100, 0x00000001, 0x00007280, 0x18000860, 
	0x00009380, 0x83f132d9, 0x0000f500, 0x2b470800, 0x00009980, 0xeb5ac358, 
	0x00001900, 0x82c524ec, 0x0000f902, 0x01000000, 0x00000604, 0x2bb60800, 
	0x0000f900, 0x001333d4, 0x00000980, 0x02000000, 0x000080e4, 0x02800000, 
	0x000080ec, 0x1a000000, 0x0000e180, 0x0022e804, 0x00006086, 0x1a400000, 
	0x00006180, 0x822ae804, 0x0000e086, 0x1a800000, 0x00006180, 0x041ae804, 
	0x00006187, 0x1ac00000, 0x000086f0, 0x1b400000, 0x000006f8, 0x1bc00000, 
	0x000087c0, 0x1c400000, 0x000007c8, 0x1cc00000, 0x000087d0, 0x1d400000, 
	0x000007d8, 0x1dc00000, 0x000007e0, 0x1e400000, 0x000007e8, 0x1ec00000, 
	0x000087f0, 0x1f400000, 0x000007f8, 0x1fc00000, 0x000008c0, 0x20400000, 
	0x000008c8, 0x20c00000, 0x000088d0, 0x21400000, 0x000008d8, 0x21c00000, 
	0x000008e0, 0x22400000, 0x000008e8, 0x22c00000, 0x00006180, 0x01c2e05c, 
	0x00004900, 0x84132f20, 0x00007500, 0xa3802000, 0x00006180, 0xa3aaed5d, 
	0x0000c901, 0x01802004, 0x00009900, 0x9d80945d, 0x0000c388, 0x0100945d, 
	0x00000098, 0x00006c5d, 0x00004088, 0x00006c5d, 0x00000098, 0xcae05c5d, 
	0x00004188, 0x0100645d, 0x00008090, 0x03c03e23, 0x0000458f, 0x25a00a02, 
	0x0000258a, 0x02403e23, 0x0000c794, 0x01807c5d, 0x00000b8a, 0x12a07c5d, 
	0x000045a8, 0x0ca0845d, 0x0000238d, 0x4b600a02, 0x0000c58f, 0x88e0360c, 
	0x00000895, 0xa320b45d, 0x0000c388, 0x0100b45d, 0x00008098, 0x0000a45d, 
	0x0000c088, 0x0000a45d, 0x000080b0, 0x07600c60, 0x00004596, 0xa8600a02, 
	0x0000a88c, 0x07200c60, 0x0000c596, 0xa6a00a02, 0x0000038c, 0x20c03e23, 
	0x00004794, 0x90c0c45d, 0x00009088, 0x4500c45d, 0x0000c5a8, 0x0e80dc5d, 
	0x0000228e, 0x02101202, 0x00006100, 0x0c011c05, 0x0000e004, 0x843332e2, 
	0x00007500, 0x04dfb800, 0x0000f900, 0x00301a04, 0x00008980, 0x02602c05, 
	0x00009900, 0x01000c66, 0x00001283, 0x843582f2, 0x00007113, 0x9a800a02, 
	0x0000f88f, 0x5c000000, 0x00004383, 0x02101202, 0x00006100, 0x0c011c05, 
	0x0000e004, 0x843d32e2, 0x0000f500, 0x04dd4000, 0x0000f900, 0x001a3a9a, 
	0x00000980, 0x02602c05, 0x00009900, 0x9d000a02, 0x0000f88f, 0x6c000000, 
	0x00004383, 0x233b4406, 0x0000b038, 0x233b5606, 0x0000b038, 0x237b7206, 
	0x00003038, 0x237b8406, 0x00003038, 0x01010468, 0x00009283, 0xc8935a6b, 
	0x00001910, 0x0703706e, 0x0000e110, 0x0743786f, 0x00004910, 0x07838070, 
	0x00006110, 0x07c38871, 0x0000c910, 0x01008468, 0x00009283, 0x41001568, 
	0x00006283, 0xc85b4b69, 0x00008910, 0x03c34032, 0x0000e811, 0x13c34032, 
	0x00006811, 0x01020468, 0x00006283, 0x23c34032, 0x00002011, 0x01000c68, 
	0x00006283, 0xc97b4768, 0x00000910, 0x237b6006, 0x00003038, 0x237b9606, 
	0x00003038, 0x00008460, 0x0000f208, 0x23bba006, 0x00003038, 0x81040632, 
	0x00006283, 0x80001009, 0x0000a402, 0x6000100a, 0x00006412, 0x00001023, 
	0x0000b405, 0x0000080b, 0x0000e412, 0xe0001009, 0x00003402, 0x6000080a, 
	0x0000640a, 0xc000080a, 0x0000b413, 0xc6000000, 0x0000e190, 0xc5c00000, 
	0x0000c990, 0x01807800, 0x00009981, 0x16000800, 0x00009981, 0x0101e000, 
	0x00001981, 0x00502800, 0x0000f900, 0x00004010, 0x00008980, 0x00000406, 
	0x00006583, 0x80602404, 0x00008901, 0x81200000, 0x000000cd, 0x01000800, 
	0x00006191, 0x01c00004, 0x00004980, 0x00000458, 0x0000e583, 0x80e03406, 
	0x00000901, 0x01400000, 0x0000f900, 0x00018008, 0x00000980, 0x000808ec, 
	0x0000d780, 0x00884dc0, 0x00008680, 0x96602001, 0x0000e001, 0x00001807, 
	0x00003106, 0x00008667, 0x0000f408, 0x01009000, 0x00007900, 0x00036240, 
	0x00008980, 0x01801002, 0x0000e100, 0xc0003406, 0x00004081, 0x86652c13, 
	0x0000f004, 0x233b4406, 0x0000b038, 0x237b6006, 0x00003038, 0x237b8406, 
	0x00003038, 0x237b9606, 0x00003038, 0x233b5606, 0x0000b038, 0x01008468, 
	0x00009283, 0x07038070, 0x0000e110, 0x07438871, 0x00004910, 0xc893626c, 
	0x00006110, 0x07839072, 0x00004910, 0x01004468, 0x00006283, 0x07c39873, 
	0x00000910, 0x41000d68, 0x00006283, 0xc85b4b69, 0x00008910, 0x01020468, 
	0x00006283, 0x09c3586b, 0x00008910, 0x0b034405, 0x0000e816, 0x01040468, 
	0x00006283, 0x04202846, 0x0000a015, 0x0c034405, 0x00006816, 0x01001468, 
	0x00006283, 0x34e02846, 0x0000a015, 0x237b7206, 0x00003038, 0x23bba006, 
	0x00003038, 0x0000849b, 0x00007208, 0x23bbb206, 0x00003038, 0x01001460, 
	0x00001283, 0x01002468, 0x00006283, 0x20000809, 0x00002412, 0x0000849b, 
	0x0000f00b, 0x4100650d, 0x00001283, 0x027f9809, 0x0000f910, 0x003ffffe, 
	0x00008280, 0xffffffff, 0x00007f86, 0x80000809, 0x0000ec0b, 0x01000c68, 
	0x00009283, 0x00001023, 0x00006415, 0x20000808, 0x0000b413, 0x40015009, 
	0x00006492, 0x6000080a, 0x00003412, 0x00008460, 0x00007008, 0x00001009, 
	0x00006403, 0xc000080a, 0x00003403, 0xc5d93326, 0x0000e100, 0x40015009, 
	0x00006483, 0x00008463, 0x00007400, 0x8180080f, 0x000005e2, 0x0101d000, 
	0x00001981, 0x000084ab, 0x0000f200, 0xc100670c, 0x00009283, 0x0101840d, 
	0x00001283, 0x000084af, 0x00007400, 0x01000000, 0x00009980, 0x01000800, 
	0x00009990, 0x01000800, 0x00001980, 0x00008460, 0x00007400, 0xffffffff, 
	0x00007f86, 0x51602060, 0x0000e800, 0x01000c66, 0x00001283, 0x84b482f2, 
	0x00007113, 0xa0c00a02, 0x0000788f, 0xec000000, 0x0000c383, 0x80001009, 
	0x00006402, 0x6000100a, 0x0000b402, 0x233b4406, 0x0000b038, 0x233b5606, 
	0x0000b038, 0x000084c9, 0x00007400, 0x96655032, 0x00006001, 0xe0001009, 
	0x00003402, 0x0101b800, 0x00009981, 0x03800000, 0x00007900, 0x00080000, 
	0x00000980, 0xa6a5500e, 0x0000e003, 0xe0005009, 0x00003406, 0x233b4406, 
	0x0000b038, 0x1065504a, 0x00006000, 0x6000100a, 0x0000b402, 0xf7e5500e, 
	0x00006001, 0x40015009, 0x00003483, 0x0101b000, 0x00006181, 0x02d0000b, 
	0x0000c380, 0x60000809, 0x0000e402, 0x00000023, 0x00003405, 0x889aeb5d, 
	0x00006100, 0xa0002809, 0x0000e406, 0x00008463, 0x00007200, 0x96007801, 
	0x000000da, 0x01000c66, 0x0000e283, 0x50001823, 0x0000a405, 0x00008663, 
	0x0000f00b, 0x84d382f2, 0x00007100, 0x81771ee3, 0x00001900, 0xe0002e05, 
	0x0000a085, 0xffffffff, 0x00007fa7, 0x01004405, 0x00001283, 0xc8c00000, 
	0x0000e189, 0x2a02f05e, 0x0000c910, 0x2ac2f85f, 0x0000e110, 0x2b809a00, 
	0x00004990, 0x00008663, 0x0000f008, 0x84de32a1, 0x0000f204, 0xab5712e2, 
	0x00009900, 0x000004aa, 0x00009583, 0x23035606, 0x0000790a, 0x1ac00000, 
	0x00008000, 0x23034406, 0x0000790a, 0x1a400000, 0x00000000, 0x00008460, 
	0x00007409, 0xffffffff, 0x00007f86, 0xc8e35c6b, 0x00001909, 0x855b81fc, 
	0x00007100, 0x01000c66, 0x0000e283, 0x50000023, 0x0000a405, 0x00008460, 
	0x0000700b, 0x846082f2, 0x0000f100, 0x00008460, 0x0000f000, 0x81000a02, 
	0x00009282, 0x90000832, 0x0000e409, 0x80001009, 0x0000b40a, 0xe0001009, 
	0x00006c0a, 0x0000868c, 0x00007008, 0x00008689, 0x0000f000, 0x01001c0d, 
	0x0000e283, 0x99512a25, 0x00008900, 0x233b4406, 0x0000b038, 0xd9592b25, 
	0x0000e100, 0x1a80402a, 0x0000c780, 0x000084fc, 0x0000f210, 0x01000800, 
	0x00009990, 0xc100670c, 0x00009283, 0x01000000, 0x00009980, 0x01000800, 
	0x00009990, 0xc1001f2c, 0x0000e283, 0x01401f2c, 0x00008281, 0x1b00402a, 
	0x0000e788, 0x0020206b, 0x00002000, 0x01191322, 0x00006310, 0x1b000827, 
	0x0000c190, 0x00008508, 0x00007008, 0x1b036322, 0x00009000, 0x1b00206c, 
	0x00009700, 0x1b00406c, 0x00001880, 0x1b03602a, 0x00009100, 0x1b00406c, 
	0x00001780, 0x00001405, 0x0000e583, 0x01000000, 0x00008981, 0x01000800, 
	0x00006189, 0x1b58bb18, 0x0000c100, 0x1c013828, 0x0000e102, 0x1b89612c, 
	0x00008900, 0x00008460, 0x00007400, 0x1c8728e5, 0x0000e100, 0x1060206b, 
	0x0000e000, 0x1c400029, 0x00006184, 0x1bc1582b, 0x00000900, 0xc018c317, 
	0x00001502, 0x00008460, 0x00007400, 0xd998c318, 0x00006110, 0xc000080a, 
	0x0000e413, 0x1740d000, 0x00006189, 0xc5d8c318, 0x00004910, 0x01c00000, 
	0x0000e180, 0x817f1fe3, 0x00004900, 0xa1c03a05, 0x0000a004, 0x01080000, 
	0x00001980, 0xab0002ec, 0x00005080, 0x00400000, 0x00008000, 0x00391804, 
	0x0000e886, 0xab3838ec, 0x0000a880, 0xab3824ec, 0x0000d000, 0x00381000, 
	0x00000000, 0x85284410, 0x0000f500, 0xab0002ec, 0x0000d000, 0x00400000, 
	0x00000080, 0xab0000ec, 0x00005000, 0x00400000, 0x00000080, 0x7f400604, 
	0x0000f88b, 0x04000001, 0x00008080, 0xffffffff, 0x00007f86, 0xffffffff, 
	0x00007f86, 0x00008460, 0x00007400, 0x90000832, 0x0000ec01, 0xffffffff, 
	0x00007f86, 0x02101202, 0x00006100, 0x0c011c04, 0x00006004, 0x853532e2, 
	0x0000f500, 0x04f0f000, 0x00007900, 0x0022f376, 0x00000980, 0x02602404, 
	0x00009900, 0x01000c66, 0x00001283, 0x853782f2, 0x00007113, 0xa5c00a02, 
	0x0000788f, 0xfc000000, 0x0000c384, 0x23382606, 0x00002000, 0x90000832, 
	0x0000ec01, 0x23612c06, 0x0000a080, 0xb0000832, 0x00006c01, 0x4b002004, 
	0x00009900, 0x23382406, 0x0000a000, 0xffffffff, 0x00007fa7, 0x0100206e, 
	0x00009100, 0xffffffff, 0x00007f86, 0x2c191204, 0x00001600, 0x014588b0, 
	0x00001000, 0x2c191304, 0x00009600, 0x010588b0, 0x00009000, 0x01008004, 
	0x00001880, 0x01002804, 0x00009000, 0x00000004, 0x00001582, 0x23002c06, 
	0x00002080, 0x09c02004, 0x00001910, 0x00008557, 0x00007008, 0xffffffff, 
	0x00007f86, 0x01001405, 0x00001283, 0x8000082c, 0x00006c0b, 0x23415806, 
	0x0000f912, 0x0a000000, 0x00000000, 0x00008557, 0x00007008, 0x23794a06, 
	0x0000a080, 0x8000102c, 0x0000ec03, 0x0a014027, 0x00001002, 0xffffffff, 
	0x00007f86, 0x0a400029, 0x00009084, 0x01000c05, 0x00001283, 0x00001023, 
	0x0000ec15, 0x00008563, 0x0000f200, 0x0101e000, 0x00001981, 0x23382606, 
	0x0000a080, 0xffffffff, 0x00007fa7, 0x85c82104, 0x00000122, 0x23002406, 
	0x0000a080, 0xffffffff, 0x00007fa7, 0x01000c04, 0x00009283, 0x00001023, 
	0x0000ec15, 0x0101d800, 0x00009981, 0x000084cd, 0x0000f200, 0x01001404, 
	0x00001181, 0x01001f2c, 0x00009281, 0x00000c04, 0x00009583, 0x00008608, 
	0x00007013, 0xc018c317, 0x00001502, 0x81d8bb18, 0x00006168, 0x8cd8bb18, 
	0x00008168, 0x9607fb24, 0x0000e2e8, 0x81480000, 0x000009e8, 0x000085fc, 
	0x00007060, 0xa352c205, 0x0000e100, 0x16c00380, 0x00008980, 0x16002258, 
	0x0000e080, 0x24320004, 0x00004980, 0x96e80500, 0x0000e100, 0x0100f858, 
	0x0000c784, 0x1642c034, 0x0000e002, 0x75e8005b, 0x0000a101, 0x23040000, 
	0x0000f900, 0x000014c4, 0x00000980, 0x23c40000, 0x0000f900, 0x00007fc0, 
	0x00000980, 0xe4181302, 0x0000e100, 0x01402035, 0x0000c004, 0x80003a8d, 
	0x00001582, 0xc107fb24, 0x00009282, 0xffffffff, 0x00007f86, 0x0000858a, 
	0x0000f030, 0x0000858a, 0x00007008, 0x700400ec, 0x00005680, 0x003adcc4, 
	0x00008010, 0x703ac8ec, 0x0000d600, 0x00382800, 0x00008000, 0x700400ec, 
	0x00005680, 0x003c87c0, 0x00000078, 0x000085d9, 0x00007400, 0x96000000, 
	0x000085ec, 0x16400000, 0x00001980, 0xc107fb24, 0x00006282, 0xc000008c, 
	0x0000a406, 0x96c00000, 0x00006180, 0x16996b2d, 0x0000c900, 0x16000a2d, 
	0x0000e180, 0x0d01b036, 0x00000908, 0x000085a6, 0x0000f010, 0x703c60ec, 
	0x00005600, 0x003ad800, 0x00000000, 0x0002c05a, 0x00006502, 0x0d41b837, 
	0x00000900, 0x7039b0ec, 0x0000d600, 0x0039b800, 0x00000000, 0x700400ec, 
	0x00005680, 0x003c87c0, 0x00000078, 0x000085a0, 0x0000f008, 0xcb400b2d, 
	0x00006080, 0x81000b2d, 0x00000080, 0x01001a04, 0x00001880, 0x000085a3, 
	0x0000f400, 0x01417004, 0x00009002, 0x2380002f, 0x00001084, 0xcb400000, 
	0x00006180, 0x0141702e, 0x0000c900, 0x2381782f, 0x00009900, 0x000085cd, 
	0x00007400, 0x16400000, 0x000085ec, 0x16000000, 0x00001981, 0x8100228d, 
	0x0000e080, 0xa3c0228d, 0x0000c880, 0x813ffa04, 0x00007900, 0x00000002, 
	0x00008280, 0x0002c05a, 0x00006502, 0x0010208c, 0x0000a106, 0x703c60ec, 
	0x00005600, 0x003ad800, 0x00000000, 0x703ac8ec, 0x0000d600, 0x00382800, 
	0x00008000, 0x01404000, 0x0000e180, 0x16400c8d, 0x00004881, 0x2381782f, 
	0x0000e100, 0x01146805, 0x00004100, 0x81402204, 0x00009880, 0x813ffa05, 
	0x0000f900, 0x00000002, 0x00008280, 0x0c02dc04, 0x0000e084, 0x0010208c, 
	0x00003106, 0x16602459, 0x00009001, 0x703c78ec, 0x00005600, 0x003c8000, 
	0x00008000, 0x1641b837, 0x0000e100, 0x0422c85b, 0x00006085, 0x703c60ec, 
	0x00005600, 0x003ad800, 0x00000000, 0xa3fffa05, 0x0000f900, 0x00000002, 
	0x00008280, 0x7039b0ec, 0x0000d600, 0x0039b800, 0x00000000, 0x000085cc, 
	0x00007440, 0x703c78ec, 0x00005600, 0x003c8000, 0x00008000, 0x16f97736, 
	0x00008014, 0x01000b2d, 0x00001080, 0x01001804, 0x00009880, 0x0140202e, 
	0x00009002, 0x2380002f, 0x00001084, 0x16000800, 0x00009981, 0x01000360, 
	0x0000e180, 0x0080408c, 0x00006586, 0x81280500, 0x0000e100, 0x4000288c, 
	0x00006407, 0x75e80004, 0x00006101, 0x0000408f, 0x0000b586, 0x703c60ec, 
	0x00005600, 0x00382000, 0x00000000, 0x703828ec, 0x0000d600, 0x003c7000, 
	0x00008000, 0x703c78ec, 0x00005600, 0x003c8000, 0x00008000, 0x00c002ec, 
	0x0000df80, 0x184ed80b, 0x00001684, 0xffffffff, 0x0000ffb7, 0x00000c58, 
	0x00009583, 0x80003a07, 0x00009582, 0xffffffff, 0x00007f86, 0x000085f1, 
	0x00007010, 0x000085e9, 0x0000f018, 0x85e483e1, 0x0000f500, 0x0981dc07, 
	0x00006804, 0x01603c07, 0x00009900, 0x81e03c07, 0x00009900, 0x80146a07, 
	0x00001502, 0x0dc2c859, 0x00006130, 0x0d82d85b, 0x0000c930, 0x000085f2, 
	0x00007031, 0x01596b2d, 0x0000e100, 0x01000a2d, 0x00004180, 0x00002005, 
	0x00006502, 0x0d02d85b, 0x00008900, 0x81000b2d, 0x000060c8, 0x81000000, 
	0x000009c0, 0x0d42c859, 0x00009900, 0xcb502204, 0x00009900, 0x23404000, 
	0x00001981, 0x85f683e1, 0x0000f500, 0xc724682c, 0x00006007, 0x0981dc04, 
	0x0000b004, 0x01602404, 0x00009900, 0x3841e000, 0x0000e181, 0x0981dc04, 
	0x0000e004, 0x00008612, 0x0000f400, 0x01c00000, 0x00006181, 0x34e02032, 
	0x0000e007, 0x01013827, 0x00001900, 0x30000032, 0x00006c07, 0x00008460, 
	0x00007200, 0x18000860, 0x00009380, 0x0101d004, 0x0000e100, 0x0b419405, 
	0x0000a006, 0x01407c05, 0x0000e081, 0x01c00c07, 0x00000081, 0xc9000b24, 
	0x00006080, 0x34e02832, 0x0000a007, 0x8143c632, 0x00009283, 0x18000860, 
	0x00001388, 0x00008610, 0x0000f011, 0x96007801, 0x000000da, 0x01003e23, 
	0x00006281, 0xb0000032, 0x0000a401, 0x00001404, 0x00009583, 0x00008462, 
	0x0000f400, 0x6000080a, 0x0000640a, 0x80001009, 0x0000b40a, 0xe0001009, 
	0x00006c0a, 0x0e020300, 0x00007904, 0x0e820300, 0x0000f904, 0x0001d004, 
	0x00009502, 0x0e80203a, 0x00009128, 0x000085ff, 0x00007021, 0x0e01c004, 
	0x00009002, 0x00000407, 0x0000e583, 0x0e400039, 0x00000084, 0x01407800, 
	0x00006191, 0x09016404, 0x00006016, 0x01a03c05, 0x00006111, 0x01203c04, 
	0x00000111, 0x00008608, 0x00007008, 0x001838ec, 0x00005780, 0x00004001, 
	0x00008080, 0x01403800, 0x00006181, 0xc720202c, 0x0000e007, 0x000870ec, 
	0x0000d780, 0x00004000, 0x00000080, 0x01007c07, 0x0000e081, 0x41203c05, 
	0x00008101, 0x00008609, 0x0000f400, 0x003020ec, 0x00005702, 0x00004000, 
	0x00000080, 0x16000000, 0x00001981, 0x0a830861, 0x00006100, 0x00000809, 
	0x00006403, 0x89931a63, 0x0000e100, 0x0ac80062, 0x0000c180, 0x844b1f63, 
	0x0000011e, 0xc6131a63, 0x00009900, 0x0000802b, 0x00009502, 0x12bfc84a, 
	0x00007900, 0x003ffffe, 0x00008280, 0x12bf784a, 0x0000f900, 0x003ffffe, 
	0x00008280, 0x00008645, 0x00007260, 0x0101e000, 0x000061e1, 0x02d0000b, 
	0x000043e8, 0x00000027, 0x00006582, 0x03800000, 0x00000980, 0x013ff827, 
	0x00007910, 0x0000fffe, 0x00008280, 0x11804046, 0x00006380, 0x0107d000, 
	0x00008988, 0xffffffff, 0x00007f86, 0x0000200e, 0x00006b02, 0x82c028ec, 
	0x0000f902, 0x01000000, 0x00000604, 0xffffffff, 0x00007fa7, 0x08007004, 
	0x0000eb02, 0x0101d800, 0x0000e181, 0x0a002804, 0x00004000, 0x0001580f, 
	0x0000e502, 0x01403e23, 0x00008281, 0x00001405, 0x0000e583, 0x6000080a, 
	0x0000a472, 0x20000808, 0x0000e40b, 0x40015009, 0x0000348a, 0x00001009, 
	0x0000e40b, 0x6000080a, 0x0000340a, 0x00008651, 0x00007010, 0x40015009, 
	0x00006483, 0xc000080a, 0x00003403, 0xc5d93326, 0x00009900, 0x000084cd, 
	0x0000f200, 0x01000c04, 0x00001181, 0x00008460, 0x00007400, 0xc1001732, 
	0x00006283, 0x90000032, 0x00002401, 0x18000860, 0x00001388, 0x03000020, 
	0x0000e180, 0x08001a07, 0x00006106, 0x03ed7800, 0x0000f900, 0x000eee5c, 
	0x00000980, 0x04d6c000, 0x0000f900, 0x0001b0bc, 0x00000980, 0x02800000, 
	0x00006180, 0xc1f00600, 0x0000c901, 0x81f81400, 0x00008014, 0x86632c3c, 
	0x0000f500, 0x023aef5c, 0x00000024, 0x83002800, 0x00009980, 0x00008461, 
	0x0000f200, 0x01a2ec5d, 0x00001901, 0x008806ec, 0x00005f80, 0x00804080, 
	0x00008a84, 0x86682c13, 0x00007004, 0x008806ec, 0x00005f80, 0x00804080, 
	0x000082c4, 0x8559820f, 0x0000f004, 0x8562828e, 0x00007004, 0x00008562, 
	0x0000f000, 0x2b809800, 0x0000f900, 0x00001000, 0x00000980, 0x867232a1, 
	0x00007404, 0x2a3aff5e, 0x00008a2c, 0xab5712e2, 0x00009900, 0x1e0004aa, 
	0x0000f88b, 0x34000000, 0x0000c287, 0x867832a1, 0x00007404, 0x2a3aff5e, 
	0x00008a2c, 0xab5712e2, 0x0000e100, 0x2b809f00, 0x0000c980, 0x0fc004aa, 
	0x0000f88b, 0x34000000, 0x0000c287, 0x1840402a, 0x00001780, 0x2b801c0d, 
	0x00007897, 0x44000000, 0x0000c285, 0x868132a1, 0x00007404, 0x2a3aff5e, 
	0x00008a2c, 0xab5712e2, 0x0000e100, 0x2b809900, 0x0000c980, 0x2f8004aa, 
	0x0000f88b, 0x34000000, 0x0000c287, 0x868732a1, 0x00007404, 0x2a3aff5e, 
	0x00008a2c, 0xab5712e2, 0x0000e100, 0x2b809a00, 0x0000c980, 0x2d8004aa, 
	0x0000788b, 0x34000000, 0x0000c287, 0x1280104a, 0x00006380, 0xe0005009, 
	0x0000a406, 0x40015009, 0x0000ec83, 0x6000100a, 0x0000e402, 0xc0000809, 
	0x0000b402, 0x00008463, 0x00007400, 0x8180080f, 0x000005e2, 0x0101b800, 
	0x00009981, 0x869532a1, 0x00007404, 0x2a3aff5e, 0x00008a2c, 0xab5712e2, 
	0x0000e100, 0x2b809900, 0x0000c980, 0x3c8004aa, 0x0000788b, 0x34000000, 
	0x0000c287, 0x8698820f, 0x00007004, 0x1604405e, 0x00009082, 0x869d32bd, 
	0x00007404, 0x0100005f, 0x00001084, 0x01009d00, 0x00006180, 0x16402004, 
	0x0000c900, 0x4e4004aa, 0x0000788b, 0x34000000, 0x0000c287, 0x86a0828e, 
	0x0000f004, 0x1604005e, 0x0000e082, 0x1280104a, 0x00000380, 0x0100005f, 
	0x0000e084, 0x6000100a, 0x00002402, 0x86a932bd, 0x0000f404, 0x1280804a, 
	0x00006380, 0x00001009, 0x0000a403, 0x01009a00, 0x0000e180, 0x16402004, 
	0x0000c900, 0x56c004aa, 0x0000f88b, 0x34000000, 0x0000c287, 0x10000732, 
	0x00006c02, 0x59404732, 0x0000f897, 0x44000000, 0x00004380, 0x0000080b, 
	0x00006402, 0x2000080a, 0x00003401, 0xc000080a, 0x0000ec03, 0x8a40844a, 
	0x00007897, 0x7c000000, 0x00004381, 0xc21722e4, 0x00006100, 0x813f1fe3, 
	0x0000c900, 0x55803404, 0x0000a080, 0xffffffff, 0x00007fa7, 0x01803c06, 
	0x00001281, 0xc1401406, 0x0000788b, 0x04000001, 0x00008080, 0xffffffff, 
	0x00007f86, 0xffffffff, 0x00007f86, 0xab5712e2, 0x0000e100, 0x2b809d00, 
	0x00004980, 0x86c132a1, 0x0000f404, 0xffffffff, 0x00007f86, 0xffffffff, 
	0x00007f86, 0xc1400caa, 0x0000788b, 0x04000001, 0x00008080, 0x03c00000, 
	0x0000f900, 0x00020000, 0x00000980, 0x23784a06, 0x00002080, 0x23382406, 
	0x0000b038, 0x23396e06, 0x0000b038, 0x23405006, 0x00007902, 0x0c000000, 
	0x00000000, 0x23405c06, 0x00007902, 0x01c00000, 0x00008000, 0x0f004806, 
	0x0000e106, 0xc700200f, 0x0000b001, 0x03800000, 0x000001fc, 0x03400000, 
	0x000080f0, 0x83803006, 0x00006305, 0x2b809900, 0x0000c980, 0xc180870f, 
	0x00006283, 0xab504208, 0x00000900, 0x2a01682d, 0x00006100, 0xd700200f, 
	0x0000e011, 0x2ac0572e, 0x0000003a, 0xc7d0520a, 0x00006100, 0x03402805, 
	0x0000c910, 0x86dd32a1, 0x00007404, 0x83182304, 0x0000e110, 0xc5118230, 
	0x00004910, 0xc5172ae5, 0x00001908, 0x000004e3, 0x00001583, 0x012554aa, 
	0x00001909, 0x000086e6, 0x0000f009, 0x08070404, 0x0000e800, 0x00000404, 
	0x00001583, 0x000086e8, 0x0000f00b, 0x86e42ea6, 0x0000f100, 0xffffffff, 
	0x00007f86, 0x01255cab, 0x00009901, 0xc1400c04, 0x0000f88b, 0x04000001, 
	0x00008080, 0xffffffff, 0x00007f86, 0x19382eec, 0x00002180, 0x23005406, 
	0x00007902, 0x01000000, 0x00008000, 0xffffffff, 0x00007f97, 0x01802805, 
	0x00006300, 0x02402805, 0x0000c900, 0x0000f806, 0x00001582, 0x018037e4, 
	0x00009830, 0x01402806, 0x00001430, 0x000086f5, 0x00007018, 0x000086f6, 
	0x0000f200, 0x01804809, 0x00001b00, 0x01bff801, 0x00001980, 0x003ff806, 
	0x00007900, 0x00000002, 0x00008582, 0x19382eec, 0x00002990, 0x0bc00000, 
	0x00006190, 0x19203406, 0x00004911, 0x00008722, 0x00007008, 0x19400000, 
	0x00006180, 0x0420302f, 0x0000e087, 0x87035d5c, 0x00007404, 0x803980ec, 
	0x00005700, 0x00397800, 0x00000000, 0x800000ec, 0x00005780, 0x00000000, 
	0x00008080, 0xc0000f64, 0x00009583, 0x00008708, 0x0000f013, 0x87062c13, 
	0x00007004, 0x008006ec, 0x0000df80, 0x00000000, 0x00000084, 0xb9184308, 
	0x00001900, 0x2c004a06, 0x00001680, 0x818588b0, 0x00009000, 0x0778fe06, 
	0x00002980, 0x07800006, 0x00005180, 0x00400000, 0x00008000, 0x07800206, 
	0x0000d180, 0x00400000, 0x00008000, 0x07385606, 0x0000d100, 0x00382000, 
	0x00000000, 0x07785006, 0x00005100, 0x00382000, 0x00000000, 0x07785a06, 
	0x00005100, 0x00383800, 0x00000000, 0x07796c06, 0x0000d100, 0x00397000, 
	0x00008000, 0x07b87c06, 0x0000d100, 0x00387000, 0x00000000, 0x07b86e06, 
	0x0000d100, 0x00386000, 0x00008000, 0x07400606, 0x0000d100, 0x00400000, 
	0x00000080, 0x00000000, 0x0000f480, 0x07800006, 0x0000d100, 0x00400000, 
	0x00000080, 0x07b98206, 0x0000a900, 0x87245d93, 0x00007300, 0x9e118230, 
	0x00001900, 0x02730004, 0x0000e180, 0x018006a0, 0x00004980, 0x001c2806, 
	0x0000e906, 0x703830ec, 0x0000d600, 0x00000000, 0x00008080, 0x703850ec, 
	0x0000d600, 0x00382000, 0x00000000, 0x703850ec, 0x0000d600, 0x00382000, 
	0x00000000, 0x703858ec, 0x00005600, 0x00383800, 0x00000000, 0x703968ec, 
	0x0000d600, 0x00397000, 0x00008000, 0x7038f8ec, 0x00005600, 0x00000000, 
	0x00008080, 0x700000ec, 0x0000d680, 0x00000000, 0x00008080, 0x700000ec, 
	0x0000d680, 0x00398000, 0x00008000, 0x703878ec, 0x0000d600, 0x00387000, 
	0x00000000, 0x81b71ee3, 0x00001900, 0x19603206, 0x00002100, 0x01400000, 
	0x0000f900, 0x00007fc0, 0x00000980, 0xc2780208, 0x00007900, 0x0000003e, 
	0x00000380, 0x815c2b85, 0x00001900, 0x80103230, 0x00009502, 0x703868ec, 
	0x00005628, 0x00386000, 0x00008000, 0x00008744, 0x0000f021, 0xb9184308, 
	0x00001900, 0x703bc0ec, 0x0000d600, 0x00000000, 0x00008080, 0x703828ec, 
	0x0000d600, 0x00384800, 0x00008000, 0xffffffff, 0x00007f86, 0x00000000, 
	0x00007083, 0x2b809900, 0x0000e180, 0xab5712e2, 0x0000c900, 0x831722e4, 
	0x00001900, 0x874f32a1, 0x0000f004, 0xd9400caa, 0x0000788b, 0x04000001, 
	0x00008080, 0xffffffff, 0x00007f86, 0x23384c06, 0x0000a080, 0xffffffff, 
	0x00007f86, 0xffffffff, 0x00007f97, 0x803848ec, 0x00005700, 0x00000000, 
	0x00000880, 0x800000ec, 0x00005780, 0x00000000, 0x00008080, 0x803f28ec, 
	0x0000d700, 0x00000000, 0x00008080, 0x800020ec, 0x0000f902, 0x01400000, 
	0x00008700, 0xffffffff, 0x00007fa7, 0x80000e04, 0x00009583, 0x19400000, 
	0x0000e188, 0x19202404, 0x00004909, 0x0000877a, 0x00007011, 0x87635d5c, 
	0x0000f004, 0xc0000f64, 0x00009583, 0x00008768, 0x0000f013, 0x87662c13, 
	0x00007004, 0x008006ec, 0x0000df80, 0x00000000, 0x00000084, 0x0141fc64, 
	0x0000e281, 0x0200fc64, 0x00008281, 0x0000fc05, 0x0000e583, 0x012047e4, 
	0x00008800, 0x82003464, 0x00009780, 0x820c9a08, 0x00007900, 0x00000008, 
	0x00000080, 0x00383008, 0x0000b038, 0x01400000, 0x0000f900, 0x00080000, 
	0x00000980, 0x04232005, 0x00006887, 0xffffffff, 0x00007f86, 0x01c03804, 
	0x0000e318, 0x01803004, 0x00008330, 0xffffffff, 0x00007f86, 0x00383008, 
	0x00003838, 0x800000ec, 0x00005780, 0x00382800, 0x00008000, 0x877d5d93, 
	0x00007500, 0x1e000409, 0x000002b4, 0x8b504a09, 0x00001900, 0x82371ee3, 
	0x0000e100, 0x024006a0, 0x00004980, 0x001c2809, 0x0000e906, 0x703848ec, 
	0x0000d600, 0x00000000, 0x00008080, 0x700000ec, 0x0000d680, 0x00000000, 
	0x00008080, 0x700000ec, 0x0000d680, 0x00000000, 0x00008080, 0x700000ec, 
	0x0000d680, 0x00000000, 0x00008080, 0x700000ec, 0x0000d680, 0x00000000, 
	0x00008080, 0x700000ec, 0x0000d680, 0x00000000, 0x00008080, 0x700000ec, 
	0x0000d680, 0x00000000, 0x00008080, 0x700000ec, 0x0000d680, 0x00396800, 
	0x00008000, 0x700000ec, 0x0000d680, 0x00000000, 0x00008080, 0x19604208, 
	0x00002100, 0x01c00000, 0x00007900, 0x00007fc0, 0x00000980, 0x81dc2b85, 
	0x0000e100, 0x02730004, 0x0000c980, 0xc278021f, 0x00007900, 0x0000003e, 
	0x00000380, 0x8010422d, 0x00001502, 0x700000ec, 0x0000d6a8, 0x00000000, 
	0x00008080, 0x0000879d, 0x00007021, 0xb910620c, 0x00001900, 0x703bc0ec, 
	0x0000d600, 0x00000000, 0x00008080, 0x703838ec, 0x00005600, 0x00384800, 
	0x00008000, 0xffffffff, 0x00007f86, 0x00000000, 0x00007083, 0x2b809900, 
	0x0000e180, 0xab5712e2, 0x0000c900, 0xc2d722e4, 0x00001900, 0x87a832a1, 
	0x0000f004, 0xefc00caa, 0x0000f88b, 0x04000001, 0x00008080, 0xffffffff, 
	0x00007f86, 0x23005406, 0x00007902, 0x02400000, 0x00000000, 0xffffffff, 
	0x00007f86, 0xffffffff, 0x00007f97, 0x803850ec, 0x00005700, 0x00000000, 
	0x00000880, 0x800000ec, 0x00005780, 0x00000000, 0x00008080, 0x803f28ec, 
	0x0000d700, 0x00000000, 0x00008080, 0x800020ec, 0x0000f902, 0x01400000, 
	0x00008700, 0xffffffff, 0x00007fa7, 0x80000e04, 0x00009583, 0x19400000, 
	0x0000e188, 0x19202404, 0x00004909, 0x000087cd, 0x00007011, 0x87bd5d5c, 
	0x0000f004, 0xc0000f64, 0x00009583, 0x000087c2, 0x0000f013, 0x87c02c13, 
	0x00007004, 0x008006ec, 0x0000df80, 0x00000000, 0x00000084, 0x2c004c64, 
	0x00009680, 0x818588b0, 0x00009000, 0x07b82c06, 0x0000a180, 0x010f2809, 
	0x00006200, 0xb9185b0b, 0x00008900, 0xffffffff, 0x00007f97, 0x01400005, 
	0x0000f900, 0x003fc000, 0x00000280, 0x01002005, 0x00009300, 0x07b82406, 
	0x0000a980, 0x00000000, 0x00007080, 0x01800000, 0x00006180, 0x01730004, 
	0x0000c980, 0x9e10520a, 0x00006100, 0x81a80500, 0x00004900, 0x700018ec, 
	0x0000d680, 0x00383540, 0x00008008, 0xc178020b, 0x00007900, 0x0000003e, 
	0x00000380, 0x87da5d93, 0x0000f500, 0x01800000, 0x0000f900, 0x00007fc0, 
	0x00000980, 0x703848ec, 0x0000d600, 0x00000000, 0x00008080, 0xb9185b0b, 
	0x00006100, 0x0101c078, 0x00004080, 0x00001806, 0x00006d86, 0x703820ec, 
	0x00005600, 0x00000000, 0x00008080, 0x703830ec, 0x0000d600, 0x00382800, 
	0x00008000, 0x00000000, 0x00007083, 0xffffffff, 0x00007f86, 0xffffffff, 
	0x00007f86, 0xffffffff, 0x00007f86, 0xffffffff, 0x00007f86, 0xffffffff, 
	0x00007f86, 0xffffffff, 0x00007f86, 0x00020037, 0x00006587, 0x40001011, 
	0x00003402, 0x02c00000, 0x0000e180, 0x04316037, 0x00006083, 0xb6e02037, 
	0x00006081, 0x00001011, 0x00003403, 0x03800000, 0x0000e180, 0x0000180b, 
	0x00006106, 0x81002302, 0x00006780, 0x0000182b, 0x00002405, 0x20003010, 
	0x0000e406, 0x60001012, 0x0000b402, 0x0200b000, 0x0000f900, 0x00016080, 
	0x00008980, 0x02400000, 0x0000f900, 0x00018008, 0x00000980, 0x03400000, 
	0x00007900, 0x00010000, 0x00000980, 0x001010ec, 0x0000d780, 0x00884880, 
	0x000081c8, 0x00502800, 0x0000f900, 0x0000c350, 0x00008980, 0xc000180b, 
	0x0000e006, 0x40003011, 0x0000b407, 0x22030800, 0x0000e180, 0x4510200e, 
	0x00006107, 0x22400000, 0x000008e8, 0x23000000, 0x000088f8, 0x23c00000, 
	0x000089c0, 0x24400000, 0x000009c8, 0x24c00000, 0x00006180, 0x22c80033, 
	0x0000c080, 0x23400734, 0x000080b0, 0x03c00004, 0x0000e180, 0x82901202, 
	0x00004900, 0x82222c13, 0x0000f404, 0x02a0ad02, 0x00000083, 0xc0c07800, 
	0x00001980, 0xffc00000, 0x00001980, 0xffffffff, 0x00007f86, 0x008806ec, 
	0x00005f80, 0x00804100, 0x00008a84, 0x822832d9, 0x0000f300, 0xab6b016a, 
	0x00000a37, 0xc0040f7a, 0x00001583, 0x00008230, 0x0000700b, 0x2c002ee3, 
	0x00001680, 0x810588b0, 0x00001000, 0xaef82a04, 0x0000a084, 0xffffffff, 
	0x00007fa7, 0x01400805, 0x00001082, 0xaef82a04, 0x0000a894, 0x007f8001, 
	0x00007900, 0x003ffffe, 0x00008280, 0x82362c13, 0x0000f404, 0xc0000800, 
	0x00006181, 0x82020001, 0x0000e604, 0x80c00000, 0x00001981, 0xffc00000, 
	0x00001980, 0xffffffff, 0x00007f86, 0x008806ec, 0x00005f80, 0x00004000, 
	0x00008084, 0x1843ff16, 0x0000e080, 0x0239772e, 0x00008900, 0x00030808, 
	0x00001502, 0x2b400000, 0x00006188, 0xab101202, 0x0000c908, 0xeb181302, 
	0x00006108, 0x08001a04, 0x0000e10e, 0x00008251, 0x0000f010, 0x0140417c, 
	0x00006080, 0x39800040, 0x00004980, 0x2bb0d800, 0x00007900, 0x002a31f0, 
	0x00008980, 0x2bc00800, 0x00007900, 0x001d9ef0, 0x00000980, 0x2b602404, 
	0x0000e101, 0x08001aed, 0x0000e106, 0x2b517100, 0x00008a35, 0xc268047c, 
	0x00008e36, 0x82762e75, 0x0000f500, 0xbb781400, 0x00000e1c, 0xb980d800, 
	0x00006180, 0x3bc02805, 0x00004900, 0x00008276, 0x00007000, 0x40000d6f, 
	0x0000e583, 0x22000000, 0x00008980, 0x22400000, 0x000008e8, 0x22c00000, 
	0x000088f0, 0x23400000, 0x000008f8, 0x23c00000, 0x000089c0, 0x24400000, 
	0x000009c8, 0x24c00000, 0x000089d0, 0x25400000, 0x000009d8, 0x25c00000, 
	0x000009e0, 0x26400000, 0x000009e8, 0x0000826f, 0x00007418, 0x26c00000, 
	0x0000e180, 0x02404032, 0x0000c780, 0x98402302, 0x00009780, 0x9db8b72e, 
	0x0000f812, 0x04000001, 0x00008080, 0x63c00800, 0x0000e180, 0xa0000089, 
	0x0000e401, 0x02400809, 0x0000e180, 0xa000108f, 0x00002403, 0xa2d8fb20, 
	0x00006100, 0xd000088f, 0x00002401, 0x001848ec, 0x0000d780, 0x00004003, 
	0x00000080, 0xe3116a2d, 0x00006100, 0xf000008f, 0x0000e401, 0x0000828d, 
	0x00007400, 0x2471a521, 0x00008824, 0x62004809, 0x00001900, 0xc038b72e, 
	0x00001503, 0x0b80b016, 0x00001908, 0xffffffff, 0x00007f86, 0x020be02e, 
	0x00009100, 0x02004008, 0x00001880, 0x00000008, 0x00001582, 0x00008277, 
	0x00007043, 0x82778226, 0x0000f100, 0x4000156f, 0x0000e583, 0xb000088f, 
	0x00002401, 0xa0000089, 0x0000e401, 0xd000088f, 0x0000b401, 0x02400809, 
	0x0000e180, 0xf000088f, 0x0000a401, 0x001848ec, 0x0000d780, 0x00004003, 
	0x00000080, 0x4b8be17c, 0x00006100, 0xcb800f2e, 0x0000c081, 0x00008288, 
	0x0000f410, 0xa2d8fb20, 0x00006100, 0x6249a134, 0x00000900, 0x62004809, 
	0x00006100, 0x25800800, 0x0000c989, 0x0000828c, 0x0000f200, 0x25440080, 
	0x00009900, 0x40001d6f, 0x00006583, 0x25404000, 0x00000980, 0x25801800, 
	0x00006191, 0x25801000, 0x0000c989, 0x2533e32e, 0x00008910, 0x02c00000, 
	0x000000f8, 0x0000180b, 0x00006106, 0x4513080e, 0x00003107, 0x0200b000, 
	0x0000f900, 0x0001e180, 0x00008980, 0x02400000, 0x0000f900, 0x00018008, 
	0x00000980, 0x03400000, 0x00007900, 0x00010000, 0x00000980, 0x001010ec, 
	0x0000d780, 0x00884880, 0x000082c8, 0x03000000, 0x00006180, 0xc000180b, 
	0x0000e006, 0x00000001, 0x00007480, 0x03c00004, 0x0000e180, 0x82901202, 
	0x00004900, 0xc2981302, 0x00009900, 0x40000561, 0x0000e583, 0x18000000, 
	0x00000981, 0x18000800, 0x0000e191, 0x0200b000, 0x00004980, 0x03800000, 
	0x000000ec, 0x00000460, 0x00006583, 0x82230008, 0x0000a000, 0x03801000, 
	0x00006191, 0x03800000, 0x0000c989, 0x03400000, 0x00007900, 0x00010000, 
	0x00000980, 0x00000460, 0x00006583, 0x92630008, 0x0000a000, 0x82230c61, 
	0x00006101, 0x0020700d, 0x0000e006, 0xc2330e61, 0x0000e101, 0x8623000d, 
	0x00006001, 0x187ff862, 0x0000f910, 0x000003fe, 0x00008280, 0x18400000, 
	0x00006188, 0x0000180b, 0x00006106, 0x9663000d, 0x00006001, 0xc000180b, 
	0x0000b006, 0x98002302, 0x0000e780, 0x0003080e, 0x00002206, 0x02400000, 
	0x0000f900, 0x00018008, 0x00000980, 0x03000000, 0x00006180, 0x4513000e, 
	0x0000e107, 0x00000001, 0x00007480, 0x03c00004, 0x0000e180, 0x82901202, 
	0x00004900, 0xc2981302, 0x00009900, 0x82c132d9, 0x00007300, 0xab6b016a, 
	0x00000a37, 0x00020037, 0x00006587, 0x40001011, 0x00003402, 0x04316037, 
	0x00006083, 0x00001011, 0x00003403, 0x0000182b, 0x0000e405, 0x40000810, 
	0x0000b402, 0xb6e02837, 0x0000e081, 0x60001012, 0x0000b402, 0x22030800, 
	0x0000e180, 0x40003011, 0x0000e407, 0x22400000, 0x000008e8, 0x23000000, 
	0x000088f8, 0x23c00000, 0x000089c0, 0x24400000, 0x000009c8, 0x24c00000, 
	0x00006180, 0x22c80033, 0x0000c080, 0x82d5829e, 0x0000f500, 0x2341a034, 
	0x0000e100, 0x184410a0, 0x0000c980, 0x18800000, 0x00009980, 0x00502800, 
	0x0000f900, 0x0000c010, 0x00000980, 0x001010ec, 0x0000d780, 0x00884880, 
	0x000081c8, 0x82dc2c13, 0x00007404, 0xc0207c15, 0x000000cd, 0x80730660, 
	0x00001901, 0xffc00000, 0x00001980, 0xffffffff, 0x00007f86, 0x008806ec, 
	0x00005f80, 0x00804100, 0x00008a84, 0x82e282bf, 0x00007300, 0x41703406, 
	0x00000231, 0x1940417c, 0x00001880, 0x18880065, 0x00009180, 0x00031033, 
	0x00009502, 0x0cc80065, 0x000091e8, 0x00008350, 0x0000f061, 0x18800c4e, 
	0x00001283, 0x18c00800, 0x00006188, 0x0f044063, 0x0000e010, 0x18806415, 
	0x0000e283, 0x22000888, 0x00000380, 0x223df888, 0x0000f900, 0x003ffffe, 
	0x00008280, 0x18c01800, 0x0000e181, 0x61a31888, 0x0000e000, 0x00032817, 
	0x0000e502, 0x18c00000, 0x00008989, 0x13bfd84e, 0x0000f900, 0x003ffffe, 
	0x00008280, 0xa6a31810, 0x0000e003, 0x8000004e, 0x00003482, 0x00008329, 
	0x00007058, 0x0b800c4e, 0x00009283, 0x98c00000, 0x00006188, 0x0fc4442e, 
	0x00006008, 0x0c40b817, 0x0000e108, 0x8dd90320, 0x00004908, 0x0000830b, 
	0x00007010, 0xc019032e, 0x00006502, 0x10000093, 0x0000a403, 0x98c00800, 
	0x0000e190, 0xcb990320, 0x0000c900, 0x87c02614, 0x0000e283, 0xa4d90320, 
	0x00008900, 0x18e31c2e, 0x0000e301, 0x0000182b, 0x0000a415, 0x10631888, 
	0x0000e000, 0x20000810, 0x0000b413, 0xe4e0fc1f, 0x0000e111, 0xa0000888, 
	0x0000e410, 0xe4c00000, 0x00006189, 0xd8000800, 0x0000c991, 0x00032818, 
	0x0000e502, 0x60000812, 0x00002402, 0xc7d90320, 0x00006100, 0xc0000812, 
	0x00006403, 0x00000811, 0x00006c73, 0x00008319, 0x00007058, 0x45801513, 
	0x00006283, 0x04d00013, 0x00000380, 0x13bfb84e, 0x0000f900, 0x003ffffe, 
	0x00008280, 0x00008348, 0x0000f400, 0x05800000, 0x00007900, 0x00040000, 
	0x00000980, 0x98000e60, 0x00009189, 0x4b801513, 0x00001283, 0x98000e60, 
	0x00006189, 0x04d00013, 0x00008388, 0x82c180ec, 0x0000790a, 0x05800000, 
	0x00000604, 0x00008348, 0x0000f010, 0x0000002f, 0x0000e582, 0x05800000, 
	0x00000980, 0x0cbff82f, 0x0000f910, 0x0000fffe, 0x00008280, 0x1380404e, 
	0x00006380, 0x0c87d000, 0x00008988, 0x00008348, 0x0000f400, 0xffffffff, 
	0x00007f86, 0x0c018032, 0x0000e000, 0x00019016, 0x00002302, 0x65a01513, 
	0x0000438c, 0x01032f32, 0x00000058, 0xa2400c4e, 0x0000488d, 0x4a31b82e, 
	0x00008766, 0x0000002f, 0x0000e582, 0x98000e60, 0x00008181, 0x82c310ec, 
	0x00007902, 0x05800000, 0x00000604, 0x0c3ff82f, 0x00007910, 0x0000fffe, 
	0x00008280, 0x0c07d000, 0x0000e188, 0x05800000, 0x0000c980, 0x1380404e, 
	0x00006380, 0x04d00013, 0x00000380, 0x0c031030, 0x0000e000, 0x00018016, 
	0x0000a302, 0x69032f32, 0x0000425a, 0x7b000c4e, 0x0000a096, 0xd411bb2e, 
	0x0000f862, 0x54000000, 0x0000418a, 0xc011732e, 0x00006502, 0x98c00000, 
	0x00000980, 0x98c00800, 0x0000e190, 0x0fc44431, 0x00006000, 0x8dd1722e, 
	0x0000e100, 0x10000093, 0x00006403, 0x18e31c31, 0x00006301, 0xcb91722e, 
	0x00000900, 0xe4c00000, 0x0000e181, 0x10631888, 0x0000e000, 0x0c617732, 
	0x0000090c, 0x00008350, 0x0000f200, 0x8bb8b820, 0x00000308, 0x18800c4e, 
	0x00001283, 0x22001088, 0x0000e388, 0x10000093, 0x0000240b, 0xcb91ba37, 
	0x00006108, 0xe4c00000, 0x00004989, 0xa4d1ba37, 0x00009908, 0x18c3077d, 
	0x00006281, 0x083bec65, 0x0000a080, 0x00010463, 0x00001583, 0x0c027463, 
	0x0000680c, 0x0000838c, 0x0000f011, 0x00003c63, 0x00001583, 0x0e027462, 
	0x00006814, 0x00008367, 0x0000f009, 0x00231c62, 0x00001503, 0x98f71ee3, 
	0x00009908, 0xe0031e63, 0x0000a08c, 0x00008367, 0x00007010, 0xffffffff, 
	0x00007f97, 0x00010463, 0x00001583, 0x0217297c, 0x00006230, 0x0e027463, 
	0x00002034, 0x02631c63, 0x00009930, 0x00008365, 0x00007018, 0x836532e2, 
	0x0000f300, 0x04d8d800, 0x00007900, 0x00199bb6, 0x00000980, 0x000083ba, 
	0x00007200, 0x81404802, 0x000082f3, 0x0e027463, 0x00006804, 0x00003c63, 
	0x00001583, 0x18c00c63, 0x00001091, 0x8223184e, 0x00006814, 0x00008372, 
	0x0000f008, 0x2c002ee3, 0x00001680, 0x98c588b0, 0x00009000, 0xaf38b263, 
	0x0000a004, 0xffffffff, 0x00007fa7, 0x05800816, 0x00001082, 0xaf38b263, 
	0x0000a814, 0x19401c65, 0x00006281, 0x05801465, 0x00000781, 0x00001465, 
	0x0000e583, 0x98e0b416, 0x00008900, 0xa1610a63, 0x0000a00c, 0x0000837e, 
	0x00007009, 0x00001c65, 0x00009583, 0xa1410a63, 0x0000a00e, 0x0000837e, 
	0x00007009, 0x00000c65, 0x00001583, 0xa1610a63, 0x00002094, 0xa1410a63, 
	0x0000208e, 0x45801513, 0x00006283, 0x1380404e, 0x00000380, 0x82c100ec, 
	0x00007902, 0x05800000, 0x00000604, 0x98000e60, 0x00006189, 0x05800000, 
	0x00000980, 0x80000221, 0x00006582, 0x04d00013, 0x00000380, 0x0847d000, 
	0x0000e188, 0x08510a21, 0x00004910, 0x00000001, 0x00007480, 0xffffffff, 
	0x00007f86, 0x0c010021, 0x0000e000, 0x00010816, 0x0000a302, 0x00020463, 
	0x00001583, 0x00002465, 0x00001583, 0xffffffff, 0x00007f86, 0x00008391, 
	0x00007008, 0x0000839c, 0x00007050, 0x98f71ee3, 0x00001900, 0xe0031e63, 
	0x00002084, 0xffffffff, 0x00007fa7, 0x00020463, 0x00001583, 0x027bef7d, 
	0x0000e130, 0x0217297c, 0x0000c230, 0x04fef800, 0x00007930, 0x002342ca, 
	0x00000980, 0x0000839b, 0x0000f018, 0x839b32e2, 0x0000f100, 0x839c8226, 
	0x00007100, 0x00001465, 0x00001583, 0x00001465, 0x00001583, 0x00000c65, 
	0x00001583, 0x000083dc, 0x00007008, 0x000083a3, 0x0000f038, 0x000083e9, 
	0x00007008, 0x000083a8, 0x0000f000, 0x00001c65, 0x00009583, 0x00002465, 
	0x00001583, 0xffffffff, 0x00007f86, 0x000083cf, 0x0000f008, 0x000083f6, 
	0x0000f008, 0x58003d4e, 0x00009283, 0x0b427462, 0x0000600c, 0x0d427463, 
	0x0000b00c, 0x00000001, 0x0000f091, 0x00231463, 0x00001503, 0x98f71ee3, 
	0x00009908, 0xe0031e63, 0x0000a08c, 0x000083bb, 0x0000f010, 0xffffffff, 
	0x00007f97, 0x00010463, 0x00001583, 0x0217297c, 0x00006230, 0x0d427463, 
	0x0000a034, 0x02631c63, 0x00009930, 0x000083b9, 0x0000f018, 0x83b932e2, 
	0x00007300, 0x04e7d000, 0x0000f900, 0x001f2e16, 0x00008980, 0x81405003, 
	0x000002f3, 0x83bb82bf, 0x00007100, 0x18c00c63, 0x00009081, 0xb2e3184e, 
	0x0000e804, 0x2c002ee3, 0x00001680, 0x98c588b0, 0x00009000, 0xaf390263, 
	0x00002084, 0xffffffff, 0x00007fa7, 0x08000820, 0x00001082, 0xaf390263, 
	0x00002894, 0x08000c4e, 0x00001283, 0x22000888, 0x0000e388, 0x1380204e, 
	0x00008390, 0x22008088, 0x00001388, 0x00000001, 0x00007090, 0x2c002ee3, 
	0x00001680, 0x98c588b0, 0x00009000, 0xaef90463, 0x0000a084, 0x1380084e, 
	0x00009380, 0x00000001, 0x00007483, 0x08000820, 0x00001082, 0xaef90463, 
	0x0000a894, 0x98f71ee3, 0x00001900, 0xe0031e63, 0x00002084, 0xffffffff, 
	0x00007fa7, 0x00008463, 0x00001583, 0x0217297c, 0x00006230, 0x0a03d463, 
	0x000020b0, 0x02631c63, 0x00009930, 0x000083da, 0x0000f018, 0x83da32e2, 
	0x00007300, 0x04c30000, 0x00007900, 0x003f584e, 0x00000980, 0x000083ba, 
	0x00007200, 0x81404004, 0x000002f3, 0x98f71ee3, 0x00001900, 0xe0031e63, 
	0x00002084, 0xffffffff, 0x00007fa7, 0x00008463, 0x00001583, 0x0217297c, 
	0x00006230, 0x0a03d463, 0x000020b0, 0x02631c63, 0x00009930, 0x000083e7, 
	0x00007018, 0x83e732e2, 0x0000f300, 0x04d1a000, 0x00007900, 0x003d558c, 
	0x00008980, 0x000083ba, 0x00007200, 0x81403805, 0x000082f3, 0x98f71ee3, 
	0x00001900, 0xe0031e63, 0x00002084, 0xffffffff, 0x00007fa7, 0x00008463, 
	0x00001583, 0x0217297c, 0x00006230, 0x0a03d463, 0x000020b0, 0x02631c63, 
	0x00009930, 0x000083f4, 0x0000f018, 0x83f432e2, 0x00007300, 0x04dd9000, 
	0x00007900, 0x0023cc2c, 0x00008980, 0x000083ba, 0x00007200, 0x81403006, 
	0x000002f3, 0x98f71ee3, 0x00001900, 0xe0031e63, 0x00002084, 0xffffffff, 
	0x00007fa7, 0x00008463, 0x00001583, 0x0217297c, 0x00006230, 0x0a03d463, 
	0x000020b0, 0x02631c63, 0x00009930, 0x00008401, 0x00007018, 0x840132e2, 
	0x0000f300, 0x04c3e000, 0x0000f900, 0x0032e5fc, 0x00008980, 0x000083ba, 
	0x00007200, 0x81406013, 0x000082f3, 0x840632d9, 0x0000f500, 0x01870804, 
	0x00000ab5, 0xeb53526a, 0x00001900, 0x00003406, 0x00009583, 0x98003e60, 
	0x0000e089, 0x22000000, 0x00000990, 0x22400000, 0x0000f910, 0x00010000, 
	0x00000980, 0x00008430, 0x00007008, 0x00000406, 0x00006583, 0x22c00000, 
	0x00008980, 0x01404032, 0x00006780, 0xa0000834, 0x00002409, 0x00002c06, 
	0x00006583, 0x0020308b, 0x0000a080, 0x23000000, 0x000009c4, 0x01400805, 
	0x0000e180, 0x22800000, 0x00000980, 0x23c00800, 0x0000f900, 0x00020000, 
	0x00000980, 0x23400000, 0x000008f8, 0x24000000, 0x000089c8, 0x24c00000, 
	0x000089d0, 0x25400000, 0x000009d8, 0x25c00000, 0x000009e0, 0x26400000, 
	0x000009e8, 0x26c00000, 0x0000e180, 0x6249a134, 0x0000c900, 0x0000842b, 
	0x0000f410, 0x22c3008b, 0x00006390, 0xe3116a2d, 0x00008900, 0x62002805, 
	0x00006100, 0xe4590b21, 0x00004900, 0x2c002ee3, 0x00001680, 0x814588b0, 
	0x00009000, 0xaef82205, 0x00002004, 0x5000088b, 0x00006c02, 0xffffffff, 
	0x00007f97, 0x01000804, 0x00001082, 0xaef82205, 0x00002814, 0x842e829e, 
	0x00007300, 0x18800000, 0x0000e180, 0x184430e0, 0x0000c980, 0x001010ec, 
	0x0000d780, 0x00884880, 0x000082c8, 0x00502800, 0x0000f900, 0x0000c010, 
	0x00000980, 0x84352c13, 0x0000f404, 0xc0207c15, 0x000000cd, 0x80730660, 
	0x00001901, 0xffc00000, 0x00001980, 0xffffffff, 0x00007f86, 0x008806ec, 
	0x00005f80, 0x00804100, 0x00008a84, 0x814000ec, 0x00005684, 0x00000002, 
	0x00008480, 0x1807062b, 0x00009281, 0x00050460, 0x00009583, 0x22080000, 
	0x00006190, 0x22400000, 0x00004990, 0x22800000, 0x00006190, 0x22c00000, 
	0x0000c990, 0x00000001, 0x00007088, 0x01c3c0e0, 0x00006180, 0x0d001c08, 
	0x0000e006, 0x02c00000, 0x000000f8, 0x98402302, 0x00006780, 0x82204007, 
	0x0000a004, 0x02400000, 0x0000f900, 0x00018008, 0x00000980, 0x03400000, 
	0x00007900, 0x00010000, 0x00000980, 0x001808ec, 0x00005780, 0x00884880, 
	0x000081c8, 0xc000180b, 0x0000e006, 0x4513080e, 0x00003107, 0x0200b000, 
	0x0000f900, 0x00016080, 0x00008980, 0x23000000, 0x000088f4, 0x23800000, 
	0x000088fc, 0x24000000, 0x000089c4, 0x24800000, 0x000089cc, 0x01000804, 
	0x0000e180, 0x01400000, 0x00004980, 0x01800000, 0x000000f0, 0x00000001, 
	0x00007480, 0x03c00000, 0x00006180, 0x82800a02, 0x00004080, 0xc2981302, 
	0x00009900, 0x00003463, 0x00006583, 0x02800000, 0x00000981, 0x02000000, 
	0x00006181, 0x02800800, 0x0000c991, 0x00004464, 0x00006583, 0x02c00000, 
	0x00008981, 0x02000800, 0x00006191, 0x0000182b, 0x0000e405, 0x00000461, 
	0x00001583, 0x00000408, 0x0000e583, 0x02c00800, 0x00008991, 0x0241fc64, 
	0x00009291, 0x0000846c, 0x0000f011, 0x0000040b, 0x00001583, 0x0241f800, 
	0x00006189, 0x0241fc61, 0x0000c291, 0x00000408, 0x00001583, 0x02400800, 
	0x0000e191, 0x00204838, 0x00006082, 0x00008473, 0x00007011, 0x0000040b, 
	0x00001583, 0x02400000, 0x00006189, 0x02401000, 0x0000c991, 0xab630460, 
	0x0000e100, 0x60000038, 0x00006502, 0x847932d9, 0x00007500, 0xeb53526a, 
	0x00006100, 0x61a04838, 0x0000e002, 0xb2e31038, 0x0000e880, 0x02404032, 
	0x00006780, 0x22000000, 0x00008980, 0x02400809, 0x0000e180, 0x22400000, 
	0x00000980, 0x22c00800, 0x000008fc, 0x0000040a, 0x00006583, 0x62004809, 
	0x00008900, 0x02400934, 0x0000e180, 0xa6a0408f, 0x00002001, 0x23000000, 
	0x0000e180, 0x0003008b, 0x00006494, 0x24400000, 0x0000e180, 0x62404809, 
	0x0000c900, 0xb6e0508f, 0x00006001, 0x0023188b, 0x0000b090, 0x22800000, 
	0x0000e180, 0xa6a05089, 0x00006001, 0x23400000, 0x000008f8, 0x24000000, 
	0x000089c8, 0x24c00000, 0x000089d0, 0x25400000, 0x000009d8, 0x25c00000, 
	0x000009e0, 0x26400000, 0x000009e8, 0x26c00000, 0x0000e180, 0xa2d8fb20, 
	0x00004108, 0x24496d21, 0x00000832, 0x93c00c08, 0x00004292, 0x2f04063a, 
	0x0000a191, 0x33400c0b, 0x00007893, 0x34000000, 0x00004286, 0x00002c64, 
	0x0000e583, 0x1000089b, 0x0000a403, 0xc7c00b1f, 0x0000e090, 0xc0000812, 
	0x00002413, 0x000084a7, 0x0000f400, 0xffffffff, 0x00007f86, 0xa6d8fb1f, 
	0x00009900, 0x0207062b, 0x0000e281, 0xb0000889, 0x00002401, 0x00050408, 
	0x0000e583, 0x2501e83d, 0x00008900, 0x02001800, 0x0000e189, 0x02001000, 
	0x00004991, 0x24b9f739, 0x00000914, 0x1460409b, 0x0000e803, 0xa6d1e23c, 
	0x00009900, 0x0000040b, 0x0000e583, 0xe6e32464, 0x00000901, 0x0200b000, 
	0x00007910, 0x0001e180, 0x00008980, 0x02400000, 0x00007910, 0x00018008, 
	0x00000980, 0x000084cd, 0x0000f008, 0x02c00000, 0x000000f8, 0x98002302, 
	0x0000e780, 0x0000180b, 0x0000a106, 0x03400000, 0x00007900, 0x00010000, 
	0x00000980, 0xc000180b, 0x0000e006, 0x4513000e, 0x0000b107, 0x03000000, 
	0x00006180, 0x03c00004, 0x0000c980, 0x02a01502, 0x00008028, 0x814010ec, 
	0x0000d684, 0x00000080, 0x00000080, 0xffffffff, 0x00007f86, 0x009010ec, 
	0x00005780, 0x00884880, 0x000082c8, 0x98003e60, 0x00001181, 0xffffffff, 
	0x00007f97, 0x814000ec, 0x00005684, 0x00000002, 0x00008480, 0x000084c9, 
	0x00007400, 0x25a30c61, 0x00006101, 0xa000008f, 0x0000e401, 0xa5b81702, 
	0x0000e101, 0xe000088f, 0x0000e401, 0x25a30c61, 0x00006101, 0xe000088f, 
	0x0000e401, 0xa5b81702, 0x00009901, 0x00005c61, 0x00009583, 0x2501e03c, 
	0x0000e108, 0x25880096, 0x00004388, 0xa5b9e73c, 0x00001909, 0x84d0829e, 
	0x0000f300, 0x18800000, 0x0000e180, 0x184430e0, 0x0000c980, 0x814010ec, 
	0x0000d684, 0x00000080, 0x00000080, 0xffffffff, 0x00007f86, 0x009010ec, 
	0x00005780, 0x00884880, 0x000082c8, 0xffffffff, 0x00007fa7, 0x814000ec, 
	0x00005684, 0x00000002, 0x00008480, 0x9844063a, 0x0000e283, 0x1807062b, 
	0x00000281, 0x60001012, 0x00006412, 0x00000813, 0x0000b412, 0xc7c00000, 
	0x00006190, 0xc0000812, 0x0000e413, 0xc8000000, 0x00006190, 0x80001011, 
	0x00006402, 0x60000812, 0x0000640a, 0xe0001011, 0x00003402, 0x00050460, 
	0x00006583, 0xc000a800, 0x00008981, 0x00502800, 0x0000f900, 0x0000c010, 
	0x00000980, 0x000800ec, 0x00005780, 0x00804100, 0x00000a80, 0x84ea8439, 
	0x0000f310, 0x00607a60, 0x0000808d, 0x84eb2c13, 0x00007004, 0xffc00000, 
	0x00001980, 0xffffffff, 0x00007f86, 0x008006ec, 0x0000df80, 0x00000000, 
	0x00000084, 0x84f0845c, 0x00007100, 0x58006800, 0x00009981, 0x00010715, 
	0x0000788c, 0x00000000, 0x00000000, 0x3fc0273a, 0x0000f897, 0x04000001, 
	0x00000060, 0x00001c15, 0x0000f88c, 0x00000000, 0x00000000, 0x00006714, 
	0x0000788c, 0x00000000, 0x00008010, 0x45c0273a, 0x00007897, 0x04000001, 
	0x00000060, 0xad00173a, 0x0000c48e, 0xd1001f14, 0x0000218a, 0x5a060714, 
	0x0000788f, 0x3c000000, 0x0000c28a, 0xd800173a, 0x00009283, 0xc019031f, 
	0x0000e502, 0xa000083a, 0x0000a411, 0x22000000, 0x0000e190, 0x22400000, 
	0x00004990, 0x22800000, 0x00006190, 0x22c00000, 0x0000c990, 0x00008568, 
	0x00007008, 0x26c00000, 0x00007900, 0x0001c080, 0x00008980, 0x23c00000, 
	0x00007900, 0x00050000, 0x00008980, 0x23000000, 0x0000e180, 0xc0000812, 
	0x00006403, 0x23400000, 0x000008f8, 0x24000000, 0x000089c4, 0x24800000, 
	0x000089cc, 0x25000000, 0x000089d4, 0x25800000, 0x000089dc, 0x26000000, 
	0x000089e4, 0x00008557, 0x00007400, 0x26800000, 0x00006180, 0xc7d90320, 
	0x00004900, 0xa6d90320, 0x00009900, 0xd800173a, 0x00006283, 0x80001011, 
	0x0000a402, 0xa000083a, 0x00006411, 0x60000812, 0x0000b402, 0x18001c15, 
	0x00006283, 0x0000182b, 0x00002405, 0x5800a000, 0x0000e191, 0xe0001011, 
	0x00006402, 0x00008523, 0x0000f009, 0x98001614, 0x00009283, 0x00000001, 
	0x0000708b, 0x00008546, 0x0000f000, 0x0000041f, 0x0000e583, 0x82000000, 
	0x00008980, 0x02c00000, 0x0000e180, 0x02000800, 0x00004991, 0x23c00000, 
	0x0000e180, 0x0000180b, 0x00006106, 0x25800000, 0x000080f8, 0x98402302, 
	0x00006780, 0xc000180b, 0x00002006, 0x02400000, 0x0000f900, 0x00018008, 
	0x00000980, 0x03400000, 0x00007900, 0x00010000, 0x00000980, 0xe7a0408f, 
	0x0000e001, 0x4513080e, 0x00003107, 0x0200b000, 0x0000f900, 0x0001e180, 
	0x00008980, 0x22000000, 0x000088e4, 0x22800000, 0x000088ec, 0x23000000, 
	0x000088f4, 0x23800000, 0x000009c0, 0x24400000, 0x000009c8, 0x24c00000, 
	0x000089d0, 0x25400000, 0x000089dc, 0x26000000, 0x000089e4, 0x26800000, 
	0x000089ec, 0x03000000, 0x00006180, 0x03c00004, 0x0000c980, 0x02a81402, 
	0x00008028, 0x6580fa02, 0x00000918, 0x814010ec, 0x0000d684, 0x00000080, 
	0x00000080, 0xffffffff, 0x00007f86, 0x009010ec, 0x00005780, 0x00884880, 
	0x000082c8, 0x00008439, 0x0000f000, 0x00001010, 0x0000e403, 0xa000083a, 
	0x0000b401, 0xc0001011, 0x0000e402, 0x60001010, 0x0000b403, 0x22400000, 
	0x00007900, 0x00200000, 0x00000980, 0x9800040f, 0x000008e0, 0x22800000, 
	0x000088ec, 0x23000000, 0x000088f4, 0x23800000, 0x000088fc, 0x24000000, 
	0x000089c4, 0x24800000, 0x000089cc, 0x25000000, 0x000089d4, 0x25800000, 
	0x000089dc, 0x26000000, 0x000089e4, 0x26c00000, 0x000089e8, 0x02c00000, 
	0x000000f8, 0x98402302, 0x00006780, 0x0000180b, 0x0000a106, 0x0200b000, 
	0x0000f900, 0x0001e180, 0x00008980, 0x02400000, 0x0000f900, 0x00018008, 
	0x00000980, 0x03400000, 0x00007900, 0x00010000, 0x00000980, 0x001010ec, 
	0x0000d780, 0x00884880, 0x000082c8, 0xc000180b, 0x0000e006, 0x4513080e, 
	0x00003107, 0x00000001, 0x00007480, 0x03000000, 0x00006180, 0x03c00004, 
	0x0000c980, 0x02a01502, 0x00008028, 0x00000001, 0x00007280, 0x5800a000, 
	0x00001981, 0xffffffff, 0x00007f86, 0xffffffff, 0x00007f86, 0xffffffff, 
	0x00007f86, 0xffffffff, 0x00007f86, 0xffffffff, 0x00007f86, 0xffffffff, 
	0x00007f86, 0x0d400000, 0x00001980, 0xc2040743, 0x00006283, 0x04113835, 
	0x0000a101, 0x00c004ec, 0x0000d784, 0x0039a800, 0x00008000, 0x000200ec, 
	0x00007902, 0x0f800000, 0x00008704, 0xffffffff, 0x00007f86, 0x000210ec, 
	0x0000f902, 0x10400000, 0x00000704, 0xffffffff, 0x00007f86, 0x0001b0ec, 
	0x0000f902, 0x0d400000, 0x00000704, 0xffffffff, 0x00007f86, 0x0001c0ec, 
	0x00007902, 0x09800000, 0x00008704, 0x80000627, 0x00009583, 0xffffffff, 
	0x00007f86, 0x00008221, 0x00007008, 0x00008214, 0x00007010, 0x10ba1f34, 
	0x00000404, 0x09818743, 0x00009281, 0x8f818426, 0x0000f892, 0xcc000000, 
	0x00004181, 0x80001a27, 0x00006582, 0x0e000000, 0x00000980, 0x04113838, 
	0x00006901, 0x00c006ec, 0x00005784, 0x0039c000, 0x00000000, 0x00c006ec, 
	0x00005784, 0x00000000, 0x00008080, 0x00000001, 0x00007498, 0x00c006ec, 
	0x00005784, 0x00000000, 0x00008080, 0x00c006ec, 0x00005784, 0x00000000, 
	0x00008080, 0x0000824f, 0x00007000, 0xc2018743, 0x0000e283, 0x09818743, 
	0x00000281, 0x00008231, 0x0000f013, 0x80000627, 0x00009583, 0x1081a034, 
	0x00006108, 0x90521a43, 0x0000c908, 0x10800000, 0x0000e190, 0x90400000, 
	0x00004990, 0xe0000041, 0x0000ec11, 0xffffffff, 0x00007f86, 0xe0021841, 
	0x0000e809, 0xffffffff, 0x00007f86, 0x4c200042, 0x00004490, 0xc3000241, 
	0x0000a094, 0x98418741, 0x0000f896, 0x1c000000, 0x0000c182, 0x80000627, 
	0x00009583, 0x00000041, 0x0000ed93, 0x0000823e, 0x00007011, 0x00018426, 
	0x00001583, 0xc0021841, 0x0000e813, 0x00021841, 0x0000e917, 0x0000823e, 
	0x0000f010, 0x01800041, 0x00006d83, 0x103f2f0f, 0x00000318, 0x4c200042, 
	0x00004490, 0xc3000241, 0x0000a094, 0x98418741, 0x0000f896, 0x1c000000, 
	0x0000c182, 0x10000000, 0x000083d8, 0x4c200042, 0x00004490, 0xc3000241, 
	0x0000a094, 0x98418741, 0x0000f896, 0x04000001, 0x00008080, 0x03c00000, 
	0x00001980, 0x80001a27, 0x00006582, 0x0411380f, 0x0000a101, 0x00c006ec, 
	0x00005784, 0x00387800, 0x00008000, 0x00c006ec, 0x00005784, 0x00000000, 
	0x00008080, 0x00000001, 0x00007498, 0x00c006ec, 0x00005784, 0x00000000, 
	0x00008080, 0x00c006ec, 0x00005784, 0x00000000, 0x00008080, 0x89801227, 
	0x00009880, 0x48400226, 0x0000d084, 0x00400000, 0x00008000, 0x48400426, 
	0x0000d084, 0x00400000, 0x00008000, 0x48400626, 0x00005084, 0x00400000, 
	0x00008000, 0x48800026, 0x00005084, 0x00400000, 0x00008000, 0x48400226, 
	0x00005004, 0x00400000, 0x00000080, 0x48400426, 0x00005004, 0x00400000, 
	0x00000080, 0x00000001, 0x00007480, 0x48400626, 0x0000d004, 0x00400000, 
	0x00000080, 0x48800026, 0x0000d004, 0x00400000, 0x00000080, 0x80001a27, 
	0x00006582, 0x0411383e, 0x00002101, 0x00ba06ec, 0x00005704, 0x0039f000, 
	0x00000000, 0x00ba16ec, 0x0000d704, 0x003a0800, 0x00008000, 0x00000001, 
	0x00007498, 0x00b9b6ec, 0x0000d704, 0x0039a800, 0x00008000, 0x00bf2eec, 
	0x00005704, 0x003f2800, 0x00000000, 0x89801227, 0x00009880, 0x487a0226, 
	0x00005004, 0x0039f000, 0x00000000, 0x487a1426, 0x0000d004, 0x003a0800, 
	0x00008000, 0x00000001, 0x00007480, 0x4879b626, 0x00005004, 0x0039a800, 
	0x00008000, 0x48bf2826, 0x0000d004, 0x003f2800, 0x00000000, 0x0380120d, 
	0x00009880, 0x83800a0e, 0x00009080, 0xf6c0760e, 0x0000a081, 0xffffffff, 
	0x00007fa7, 0x0000040e, 0x00001583, 0x02400000, 0x0000e188, 0x02001002, 
	0x0000c908, 0x82506a0d, 0x0000e108, 0x03000020, 0x00004988, 0x00000001, 
	0x00007090, 0x03de1000, 0x00007900, 0x001b4320, 0x00008980, 0x04e81000, 
	0x0000f900, 0x002605e2, 0x00000980, 0x02800000, 0x00006180, 0x08001a07, 
	0x00006106, 0x828a2c3c, 0x0000f500, 0x83011000, 0x0000e180, 0xc1f00600, 
	0x0000c901, 0x01600702, 0x0000801e, 0xffffffff, 0x00007f86, 0xc0000308, 
	0x0000e582, 0x03401208, 0x00000880, 0x83400a0d, 0x00009080, 0xf6c0460d, 
	0x00002002, 0xffffffff, 0x00007fa7, 0x82000a08, 0x00009080, 0xf6c8460d, 
	0x00002802, 0xf720400d, 0x0000a090, 0xffffffff, 0x00007f86, 0x00000001, 
	0x00007483, 0x82000a08, 0x00001090, 0xf720400d, 0x00002890, 0xffffffff, 
	0x00007f86, 0xc000030d, 0x0000e582, 0x0380120d, 0x00000880, 0x83800a0e, 
	0x00009080, 0xf6c06e0e, 0x00002002, 0xffffffff, 0x00007fa7, 0x83400a0d, 
	0x00001180, 0xf6c86e0e, 0x00002802, 0xf720680e, 0x0000a090, 0xffffffff, 
	0x00007f86, 0x00000001, 0x00007483, 0x83400a0d, 0x00009190, 0xf720680e, 
	0x00002890, 0x02400000, 0x00006180, 0x8fcffa39, 0x00004280, 0x10c00000, 
	0x0000e180, 0x0411f809, 0x00006101, 0x00c004ec, 0x0000d784, 0x00384800, 
	0x00008000, 0x03c00000, 0x000002dc, 0x89c00039, 0x00008390, 0x000068ec, 
	0x00007902, 0x02000000, 0x00008704, 0xffffffff, 0x00007f86, 0x000040ec, 
	0x00007902, 0x09800000, 0x00008704, 0xffffffff, 0x00007f86, 0x000040ec, 
	0x00007902, 0x02400000, 0x00000704, 0xffffffff, 0x00007f86, 0xc0013043, 
	0x0000e803, 0x000040ec, 0x00007902, 0x02400000, 0x00000704, 0xffffffff, 
	0x00007fa7, 0x09013408, 0x0000e802, 0x00001c08, 0x00001583, 0x0c01320d, 
	0x00006916, 0x00001c08, 0x0000e583, 0x03506a0d, 0x00000910, 0x82c281fc, 
	0x00007500, 0xffffffff, 0x00007f86, 0x03c0680d, 0x00006108, 0x04106843, 
	0x0000e117, 0x8e1ffa39, 0x0000e280, 0x0000003e, 0x0000a586, 0xc0001b39, 
	0x00006582, 0x2091c23e, 0x0000a102, 0x0000003e, 0x00005784, 0x00000000, 
	0x00008080, 0x0000783e, 0x0000f902, 0x09800000, 0x00008704, 0x03402339, 
	0x000010b0, 0x0000403e, 0x00007902, 0x02400000, 0x00000704, 0x8340120d, 
	0x000018b0, 0x0001a83e, 0x0000f902, 0x0d800000, 0x00000704, 0xffffffff, 
	0x00007f86, 0x0001383e, 0x0000f902, 0x0d000000, 0x00008704, 0x0000083e, 
	0x00006d86, 0x2099ca3e, 0x0000e902, 0x0038783e, 0x00005704, 0x00393000, 
	0x00000000, 0x0038403e, 0x0000d704, 0x00384800, 0x00008000, 0x000082e5, 
	0x0000f418, 0x0039a83e, 0x00005704, 0x0039b000, 0x00008000, 0x0039383e, 
	0x00005704, 0x0039a000, 0x00000000, 0x48787a0d, 0x0000d004, 0x00393000, 
	0x00000000, 0x4878440d, 0x0000383c, 0x4879ae0d, 0x00005004, 0x0039b000, 
	0x00008000, 0x48b9380d, 0x00005004, 0x0039a000, 0x00000000, 0x80001a39, 
	0x00006582, 0x0d400000, 0x00008980, 0x83401239, 0x0000e0b0, 0x0411f835, 
	0x00006101, 0x00c006ec, 0x00005784, 0x0039a800, 0x00008000, 0x00c006ec, 
	0x00005784, 0x00000000, 0x00008080, 0x00008302, 0x00007418, 0x00c006ec, 
	0x00005784, 0x00000000, 0x00008080, 0x00c006ec, 0x00005784, 0x00000000, 
	0x00008080, 0x4840020d, 0x0000d084, 0x00400000, 0x00008000, 0x4840040d, 
	0x0000d084, 0x00400000, 0x00008000, 0x4840060d, 0x00005084, 0x00400000, 
	0x00008000, 0x4880000d, 0x00005084, 0x00400000, 0x00008000, 0x4840020d, 
	0x00005004, 0x00400000, 0x00000080, 0x4840040d, 0x00005004, 0x00400000, 
	0x00000080, 0x4840060d, 0x0000d004, 0x00400000, 0x00000080, 0x4880000d, 
	0x0000d004, 0x00400000, 0x00000080, 0x80001a39, 0x00006582, 0x0000083e, 
	0x00002586, 0x03402239, 0x000060b0, 0x2091c23e, 0x0000a102, 0x0000003e, 
	0x00005784, 0x00000000, 0x00008080, 0x0000003e, 0x00005784, 0x00000000, 
	0x00008080, 0x00000001, 0x00007498, 0x0000003e, 0x00005784, 0x00000000, 
	0x00008080, 0x0000003e, 0x00005784, 0x00000000, 0x00008080, 0x8340120d, 
	0x00001880, 0x4840020d, 0x0000d084, 0x00400000, 0x00008000, 0x4840040d, 
	0x0000d084, 0x00400000, 0x00008000, 0x4840060d, 0x00005084, 0x00400000, 
	0x00008000, 0x4880000d, 0x00005084, 0x00400000, 0x00008000, 0x4840020d, 
	0x00005004, 0x00400000, 0x00000080, 0x4840040d, 0x00005004, 0x00400000, 
	0x00000080, 0x00000001, 0x00007480, 0x4840060d, 0x0000d004, 0x00400000, 
	0x00000080, 0x4880000d, 0x0000d004, 0x00400000, 0x00000080, 0x83248276, 
	0x0000f500, 0x4200000e, 0x00000092, 0x8369e53c, 0x00009900, 0x8251db3a, 
	0x00001300, 0x8251d209, 0x00009302, 0x01004000, 0x00006189, 0x0e400000, 
	0x0000c990, 0x03800000, 0x00006190, 0x03400040, 0x0000c990, 0x00000001, 
	0x00007088, 0x00000408, 0x0000e583, 0x02400000, 0x00000981, 0x02400800, 
	0x0000e191, 0x8e51d23a, 0x00004900, 0x83327fd6, 0x0000f500, 0x8f89d83a, 
	0x0000033a, 0xe7a04839, 0x00006801, 0xffffffff, 0x00007fa7, 0x81c00e0d, 
	0x00009283, 0x0f800000, 0x00006188, 0x0e400000, 0x0000c988, 0x03400040, 
	0x0000e188, 0x03800000, 0x00004988, 0x0000834f, 0x00007010, 0x833a7fd6, 
	0x0000f100, 0xffffffff, 0x00007fa7, 0x81c01e0d, 0x00001283, 0x0f800000, 
	0x00006188, 0x0e400000, 0x0000c988, 0x03400080, 0x0000e188, 0x03800000, 
	0x00004988, 0x00008346, 0x00007010, 0x83427fd6, 0x0000f100, 0xffffffff, 
	0x00007fa7, 0x81c01e0d, 0x00001283, 0x01000800, 0x00001989, 0x00000001, 
	0x0000f089, 0x10c00000, 0x000082dc, 0x90d1d23a, 0x0000e100, 0x08006a27, 
	0x00006100, 0x834d81fc, 0x00007500, 0x03c00000, 0x00006180, 0xe7a04043, 
	0x0000e001, 0x8d09d83a, 0x00000312, 0x00008350, 0x0000f200, 0x02400800, 
	0x00001981, 0x02400000, 0x00009981, 0x04880000, 0x0000e180, 0x08006a4e, 
	0x00006100, 0x83558087, 0x0000f500, 0x13b9e20e, 0x00000439, 0xc4a04c09, 
	0x00009900, 0x0000240e, 0x00009583, 0x0000835b, 0x0000700b, 0x00000001, 
	0x00007480, 0x0000040e, 0x00001583, 0x01001000, 0x00006191, 0x01001800, 
	0x0000c989, 0x0000828a, 0x0000f400, 0x02000000, 0x00009980, 0x8229e53c, 
	0x00009900, 0xffffffff, 0x00007f86, 0xc000070c, 0x00006583, 0xcf90620c, 
	0x00008900, 0x83000000, 0x000083e4, 0x03000800, 0x0000e191, 0x8e507a0f, 
	0x00004900, 0x4180040c, 0x00008092, 0x836a7fd6, 0x00007500, 0x03800000, 
	0x0000e180, 0xe7a06039, 0x0000e001, 0x8f987b0f, 0x0000e100, 0x03400040, 
	0x00004980, 0xffffffff, 0x00007fa7, 0x82000e0d, 0x00009283, 0x01002800, 
	0x0000e189, 0x08006a10, 0x00006110, 0x93b0760e, 0x00006111, 0x08006a4e, 
	0x0000e110, 0x00000001, 0x00007088, 0x83748087, 0x0000f300, 0x04800000, 
	0x00006180, 0xd3a03406, 0x00004901, 0x00001c0e, 0x00001583, 0x0d000000, 
	0x00006188, 0x10c00000, 0x00004988, 0x09c00020, 0x00006188, 0x03c00000, 
	0x0000c988, 0x0000837d, 0x0000f010, 0x838081fc, 0x0000f300, 0x89d08210, 
	0x00001900, 0x00008380, 0x0000f000, 0x0000240e, 0x00009583, 0x01003000, 
	0x00009991, 0x00000001, 0x0000f091, 0x00008297, 0x0000f400, 0x03400000, 
	0x00009980, 0x83603406, 0x00009900, 0x0f607c0f, 0x00000105, 0x83878276, 
	0x0000f500, 0x8940020f, 0x00000092, 0x8347fa0f, 0x00001280, 0xc000070f, 
	0x00006583, 0x0e400000, 0x00008980, 0x03800000, 0x0000e180, 0xc0001839, 
	0x00006413, 0x0f800000, 0x0000e180, 0x03400040, 0x00004980, 0x00008395, 
	0x00007210, 0x0381b837, 0x00009910, 0x8000060f, 0x00009583, 0x02000800, 
	0x00006189, 0x02001000, 0x00004991, 0xffffffff, 0x00007f86, 0xc7204039, 
	0x00006803, 0x0411b839, 0x00006907, 0x83967fd6, 0x0000f100, 0xffffffff, 
	0x00007fa7, 0x81c00e0d, 0x00009283, 0x0f800000, 0x00006188, 0x0e400000, 
	0x0000c988, 0x03400060, 0x00006188, 0x03800000, 0x00004988, 0x000083be, 
	0x0000f010, 0x839e7fd6, 0x00007100, 0xffffffff, 0x00007fa7, 0x81c01e0d, 
	0x00001283, 0x0f800000, 0x00006188, 0x0e400000, 0x0000c988, 0x03400080, 
	0x0000e188, 0x03800000, 0x00004988, 0x000083ad, 0x00007010, 0x83a67fd6, 
	0x0000f100, 0xffffffff, 0x00007fa7, 0x81c01e0d, 0x00001283, 0x000083ad, 
	0x00007013, 0x000083c9, 0x0000f400, 0x00000425, 0x00001583, 0x01004800, 
	0x0000e189, 0x01009800, 0x00004991, 0x00000425, 0x00001583, 0x02001800, 
	0x00009991, 0x000083b3, 0x0000f011, 0x00000411, 0x00009583, 0x02000800, 
	0x00006189, 0x02001000, 0x00004991, 0x10c00000, 0x000080fc, 0x09c00000, 
	0x00006180, 0xc7204043, 0x00006003, 0x00001c08, 0x0000e583, 0x08006a27, 
	0x0000a100, 0x83bc81fc, 0x0000f500, 0x0d000000, 0x0000e180, 0x0411b843, 
	0x0000e117, 0x03c1b837, 0x00001908, 0x000083bf, 0x00007200, 0x02000800, 
	0x00009981, 0x02000000, 0x00001981, 0x04880800, 0x00006180, 0x08006a4e, 
	0x00006100, 0x83c48087, 0x00007500, 0x1399ea0e, 0x00000439, 0xc4a04408, 
	0x00009900, 0x0000240e, 0x00009583, 0x000083ca, 0x0000f00b, 0x00000425, 
	0x00001583, 0x01005000, 0x0000e189, 0x0100a000, 0x0000c991, 0x00000001, 
	0x0000f080, 0x0000828a, 0x0000f400, 0x00000425, 0x0000e583, 0x02000000, 
	0x00000980, 0xc2000800, 0x0000e188, 0x8211ea3d, 0x0000c900, 0xc000070f, 
	0x00006583, 0x0e400000, 0x00008980, 0x03800000, 0x0000e180, 0xc0001839, 
	0x00006413, 0x04107c0f, 0x00008216, 0x000083de, 0x00007410, 0x81000000, 
	0x000083f8, 0x0381b837, 0x0000e110, 0x03400040, 0x00004980, 0x8000060f, 
	0x00009583, 0x03c00800, 0x0000e189, 0x03c01000, 0x0000c991, 0xffffffff, 
	0x00007f86, 0xc7207839, 0x0000e803, 0x0411b839, 0x00006907, 0x83df7fd6, 
	0x00007100, 0xffffffff, 0x00007fa7, 0x82000e0d, 0x00009283, 0x01005800, 
	0x00006189, 0x08006a26, 0x00006110, 0x93b0760e, 0x00006111, 0x08006a4e, 
	0x0000e110, 0x00000001, 0x00007088, 0x83e98087, 0x00007300, 0x04800800, 
	0x0000e180, 0xd3a08410, 0x00004901, 0x00001c0e, 0x00001583, 0x0d000000, 
	0x00006188, 0x03c00000, 0x0000c988, 0x10c00000, 0x0000f908, 0x00040000, 
	0x00000980, 0x000083f3, 0x0000f010, 0x83f681fc, 0x00007500, 0x09c00020, 
	0x00009980, 0x89d13226, 0x00001900, 0x000083f6, 0x00007000, 0x0000240e, 
	0x00009583, 0x01006000, 0x00009991, 0x00000001, 0x0000f091, 0x00008297, 
	0x0000f400, 0x00000425, 0x0000e583, 0x03400000, 0x00000980, 0xc3400800, 
	0x0000e188, 0x83508210, 0x0000c900, 0x04607c0f, 0x00000215, 0x84008276, 
	0x00007500, 0x8900420f, 0x0000010c, 0x83707e0f, 0x0000e100, 0x01000000, 
	0x00004981, 0x82107b0c, 0x00001300, 0x82106208, 0x00009302, 0x01009000, 
	0x0000e189, 0x0f400000, 0x0000c991, 0x0e400000, 0x00007910, 0x00200000, 
	0x00000980, 0x00000001, 0x00007088, 0xc000070f, 0x00006583, 0x8e50620c, 
	0x00008900, 0x0f400800, 0x00006191, 0x03800000, 0x0000c980, 0x00000413, 
	0x0000e583, 0x03400040, 0x00008980, 0xcf907a0f, 0x00006100, 0xe7a1e839, 
	0x00006001, 0x8f98630c, 0x0000e100, 0xc0001839, 0x00006413, 0x00008419, 
	0x00007210, 0x0381b837, 0x00009910, 0x0000043d, 0x00001583, 0x02001000, 
	0x00006191, 0x02000800, 0x00004989, 0xffffffff, 0x00007f86, 0xc7204039, 
	0x00006803, 0x0411b839, 0x00006907, 0x841a7fd6, 0x0000f100, 0xffffffff, 
	0x00007fa7, 0x81c00e0d, 0x00009283, 0x02000000, 0x0000e191, 0x08006a0e, 
	0x00006110, 0x0f800000, 0x00006188, 0x0e400000, 0x0000c988, 0x00008453, 
	0x00007010, 0x84247fd6, 0x0000f300, 0x03400080, 0x00006180, 0x03800000, 
	0x0000c980, 0xffffffff, 0x00007fa7, 0x81c01e0d, 0x00001283, 0x0f800000, 
	0x00006188, 0x08006a0e, 0x00006110, 0x0e400000, 0x0000e188, 0x03800000, 
	0x00004988, 0x0000843f, 0x00007010, 0x842d7fd6, 0x0000f300, 0x03400040, 
	0x00001980, 0xffffffff, 0x00007fa7, 0x81c01e0d, 0x00001283, 0x01007800, 
	0x0000e189, 0x08006a08, 0x00006110, 0x0f800000, 0x00006190, 0x0e400000, 
	0x0000c990, 0x00000001, 0x00007088, 0x84377fd6, 0x00007300, 0x03400060, 
	0x0000e180, 0x03800000, 0x0000c980, 0xffffffff, 0x00007fa7, 0x81c01e0d, 
	0x00001283, 0x01007000, 0x00006189, 0x83904208, 0x00004910, 0x8e504208, 
	0x0000e110, 0x08006b39, 0x00006110, 0x00000001, 0x00007088, 0x843f82a4, 
	0x0000f100, 0x10c00000, 0x00007900, 0x00200000, 0x00000980, 0x00000413, 
	0x0000e583, 0x90d0620c, 0x00000900, 0x03c00000, 0x00006180, 0xe7a12043, 
	0x00006001, 0x09c00000, 0x00006180, 0xc0001843, 0x0000e413, 0x00008451, 
	0x00007410, 0x8d006111, 0x00008312, 0x89d0720e, 0x00006100, 0x03c1b837, 
	0x00004910, 0x0000043d, 0x00001583, 0x02000800, 0x00006189, 0x02001000, 
	0x00004991, 0xffffffff, 0x00007f86, 0xc7204043, 0x0000e803, 0x0411b843, 
	0x0000e907, 0x845281fc, 0x0000f100, 0x02000800, 0x00009981, 0x04880800, 
	0x00006180, 0x9390720e, 0x00004900, 0x84588087, 0x0000f500, 0x13992a0e, 
	0x00000439, 0xc4a04408, 0x00009900, 0x0000240e, 0x00009583, 0x02000000, 
	0x00006188, 0x01006800, 0x00004991, 0x82212c25, 0x00001908, 0x00000001, 
	0x00007090, 0x0000828a, 0x0000f400, 0x00000413, 0x00001583, 0xc2000800, 
	0x00009988, 0xffffffff, 0x00007f86, 0xc000070f, 0x00006583, 0x0f400000, 
	0x00008981, 0x0e400000, 0x0000f900, 0x00200000, 0x00000980, 0x0f400800, 
	0x00006191, 0x8e50620c, 0x00004900, 0x00000411, 0x00006583, 0x03800000, 
	0x00000980, 0x0d307e0f, 0x0000e101, 0xe7a1e839, 0x00006001, 0x09e08c11, 
	0x00006101, 0xc0001839, 0x00006413, 0x01000000, 0x00006181, 0x03400040, 
	0x00004980, 0x00008478, 0x0000f410, 0x8f80610f, 0x0000833a, 0x0381b837, 
	0x00009910, 0x0000043d, 0x00001583, 0x0f400800, 0x00006189, 0x0f401000, 
	0x00004991, 0xffffffff, 0x00007f86, 0xc721e839, 0x00006803, 0x0411b839, 
	0x00006907, 0x84797fd6, 0x0000f100, 0xffffffff, 0x00007fa7, 0x81c00e0d, 
	0x00009283, 0x01008000, 0x00006189, 0x08006a3d, 0x00006110, 0x93b0760e, 
	0x00006111, 0x08006a4e, 0x0000e110, 0x00000001, 0x00007088, 0x84838087, 
	0x0000f300, 0x04800800, 0x0000e180, 0xd3a1a434, 0x00004901, 0x00001c0e, 
	0x00001583, 0x09400000, 0x00001988, 0x0411e825, 0x00006909, 0x000084a4, 
	0x0000f010, 0x00c006ec, 0x00005784, 0x00392800, 0x00000000, 0x00c006ec, 
	0x00005784, 0x00000000, 0x00008080, 0x00c006ec, 0x00005784, 0x00000000, 
	0x00008080, 0x00c006ec, 0x00005784, 0x00000000, 0x00008080, 0x08006a3d, 
	0x00006900, 0x80001a3d, 0x00001582, 0x8f40123d, 0x000018d0, 0x4840023d, 
	0x0000d0d4, 0x00400000, 0x00008000, 0x000084a7, 0x0000f038, 0x4840043d, 
	0x0000d084, 0x00400000, 0x00008000, 0x4840063d, 0x00005084, 0x00400000, 
	0x00008000, 0x4880003d, 0x00005084, 0x00400000, 0x00008000, 0x4840023d, 
	0x00005004, 0x00400000, 0x00000080, 0x4840043d, 0x00005004, 0x00400000, 
	0x00000080, 0x000084a7, 0x0000f400, 0x4840063d, 0x0000d004, 0x00400000, 
	0x00000080, 0x4880003d, 0x0000d004, 0x00400000, 0x00000080, 0x0000240e, 
	0x00009583, 0x01008800, 0x00009991, 0x00000001, 0x0000f091, 0x00008297, 
	0x0000f400, 0x00000427, 0x00006583, 0x03400000, 0x00000980, 0xc3400800, 
	0x0000e188, 0x8361a434, 0x0000c900, 0x84b07fd6, 0x00007500, 0x0f800000, 
	0x000083e4, 0x034000a0, 0x0000e180, 0x03800000, 0x0000c980, 0xffffffff, 
	0x00007fa7, 0x81800000, 0x0000e180, 0x0200680d, 0x00004900, 0xa4801e08, 
	0x0000c98c, 0x49100206, 0x0000218a, 0x03000000, 0x00001980, 0x0400400c, 
	0x0000e901, 0x00c004ec, 0x0000d784, 0x00386000, 0x00008000, 0x000070ec, 
	0x00007902, 0x03000000, 0x00000704, 0xffffffff, 0x00007f86, 0x000060ec, 
	0x0000f902, 0x03400000, 0x00008704, 0xffffffff, 0x00007f86, 0x000078ec, 
	0x0000f902, 0x04000000, 0x00008704, 0xffffffff, 0x00007f86, 0x000080ec, 
	0x00007902, 0x04400000, 0x00000704, 0xffffffff, 0x00007fa7, 0x0f406811, 
	0x0000e200, 0x11006010, 0x00000200, 0xc1c4073d, 0x00006283, 0x0fc06010, 
	0x00000200, 0x0101873d, 0x00009281, 0x000084eb, 0x0000f009, 0x00018404, 
	0x00001583, 0x000084dc, 0x0000f00b, 0xc1c2073d, 0x00009283, 0x03004000, 
	0x00006188, 0x03020000, 0x00004990, 0xffffffff, 0x00007f86, 0x0302300c, 
	0x00001202, 0x8311ea3d, 0x0000e110, 0x0c01ea06, 0x00006116, 0x0dd03206, 
	0x0000e110, 0xc311fa3f, 0x00004910, 0x00008519, 0x00007008, 0x000084e9, 
	0x0000f400, 0x83d9fb3f, 0x00006100, 0x0881ef0f, 0x00006000, 0x04400000, 
	0x00006180, 0x83e9e53c, 0x0000c901, 0xc1c2073d, 0x00009283, 0x03080000, 
	0x00006188, 0x03040000, 0x00004990, 0xffffffff, 0x00007f86, 0x0302300c, 
	0x00001202, 0x0dc0700f, 0x00006210, 0x8311ea3d, 0x00000910, 0xc311fa3f, 
	0x00006110, 0x83d9fb3f, 0x0000c910, 0x00008519, 0x00007008, 0x83e9e53c, 
	0x0000e101, 0x0881ef0f, 0x00006000, 0x04400800, 0x00009980, 0x85198460, 
	0x00007100, 0x00008519, 0x0000f000, 0x0001873d, 0x0000408c, 0x00018404, 
	0x00000090, 0x9f300046, 0x00004494, 0x1b00023d, 0x0000a192, 0xa1a00044, 
	0x00004690, 0x33008404, 0x00002192, 0x9fc02046, 0x0000c494, 0x1b00023d, 
	0x0000a192, 0x03400044, 0x00004792, 0x02610046, 0x00000190, 0x0300023d, 
	0x0000c590, 0x02400044, 0x0000018c, 0x02c0023d, 0x00004590, 0x02200044, 
	0x0000818b, 0x0dc0700f, 0x00001200, 0x00008507, 0x00007400, 0x03c00000, 
	0x0000f900, 0x00004000, 0x00000980, 0x83e9e53c, 0x00001900, 0x00008507, 
	0x00007400, 0x03c00000, 0x00006180, 0x0c01ea06, 0x0000e106, 0x83e9e53c, 
	0x00006100, 0x0dd03206, 0x00004900, 0x03c00020, 0x0000e180, 0x0c01ea06, 
	0x0000e106, 0x83e9e53c, 0x00006100, 0x0dd03206, 0x00004900, 0x850883cf, 
	0x0000f100, 0x8000023d, 0x00001582, 0x00000044, 0x00009582, 0xffffffff, 
	0x00007f86, 0x0000850d, 0x00007010, 0x00008519, 0x00007008, 0x0102073d, 
	0x00009283, 0x03001000, 0x00006188, 0x03008000, 0x00004990, 0xffffffff, 
	0x00007f86, 0x0302300c, 0x00001202, 0x83d1ea3d, 0x0000e110, 0xc3d1fa3f, 
	0x00004910, 0x8319fb3f, 0x0000e110, 0x8329e53c, 0x00004911, 0x00008519, 
	0x00007008, 0x8519835e, 0x0000f300, 0x0881ef0c, 0x0000e800, 0x034000a0, 
	0x0000e180, 0x08004208, 0x0000e100, 0x0f800000, 0x000083e4, 0x85207fd6, 
	0x0000f500, 0x03800000, 0x0000e180, 0x81800a08, 0x00004080, 0x83400a08, 
	0x00009080, 0xffffffff, 0x00007fa7, 0x0200680d, 0x00001900, 0xa4801e08, 
	0x0000c98c, 0x6b100206, 0x00002191, 0x84c0153c, 0x00001880, 0x03002046, 
	0x0000e282, 0x84c00a13, 0x00000080, 0xf7384013, 0x00002080, 0x0000852f, 
	0x0000f009, 0xffffffff, 0x00007f86, 0x80000e08, 0x00009583, 0x82001000, 
	0x00009989, 0x0000852f, 0x0000f009, 0x80001e08, 0x00001583, 0x82002000, 
	0x00009989, 0x00000001, 0x00007280, 0xf7384013, 0x0000a880, 0xc000030c, 
	0x00006582, 0x0200120c, 0x00008880, 0x04c00808, 0x00009080, 0xf7206813, 
	0x00002080, 0xf7204013, 0x0000a081, 0xffffffff, 0x00007f97, 0x8000020d, 
	0x00001582, 0xffffffff, 0x00007f86, 0x00008562, 0x00007008, 0x00008580, 
	0x00007010, 0x00001408, 0x00006583, 0x04000000, 0x00008981, 0x00002408, 
	0x00006583, 0x04000800, 0x00008989, 0x00001408, 0x00001593, 0x03c00000, 
	0x0000e188, 0x0dc00000, 0x00004988, 0x83c7fa0c, 0x00001288, 0x0000855b, 
	0x00007010, 0x85458383, 0x00007100, 0x00000404, 0x00001583, 0x02080000, 
	0x0000e190, 0x02400000, 0x0000c990, 0x0220640c, 0x00006111, 0x82202404, 
	0x0000c911, 0x00008556, 0x0000f008, 0x03000020, 0x0000e180, 0x08001a07, 
	0x00006106, 0x03caf000, 0x0000f900, 0x00312260, 0x00000980, 0x04c37000, 
	0x0000f900, 0x00330b2c, 0x00008980, 0x02800000, 0x00006180, 0xc1f00600, 
	0x0000c901, 0x0000857b, 0x0000f400, 0x81f81400, 0x00008014, 0x83019000, 
	0x00001980, 0x00000410, 0x00001583, 0x02001800, 0x00009989, 0x02000800, 
	0x00001991, 0x00008580, 0x00007008, 0x00008580, 0x0000f000, 0x00003408, 
	0x00001583, 0x10c00020, 0x00009988, 0x50e0640c, 0x00009909, 0x00008580, 
	0x00007010, 0x85608059, 0x00007100, 0x00008580, 0x00007200, 0x02002800, 
	0x00001981, 0x0107ec08, 0x00001281, 0x00000c04, 0x00009583, 0x80000a0d, 
	0x00009582, 0xffffffff, 0x00007f86, 0x00008582, 0x0000f010, 0x00008582, 
	0x00007030, 0x856b83cf, 0x00007500, 0x0dc00000, 0x000080fc, 0x83c7fa0c, 
	0x00009280, 0x00000404, 0x00001583, 0x02000000, 0x00006190, 0x02400000, 
	0x0000c990, 0x0220640c, 0x00006111, 0x82202404, 0x0000c911, 0x0000857c, 
	0x00007008, 0x03000020, 0x0000e180, 0x08001a07, 0x00006106, 0x03e83800, 
	0x00007900, 0x000f63ae, 0x00000980, 0x04c37000, 0x0000f900, 0x00330b2c, 
	0x00008980, 0x02800000, 0x00006180, 0xc1f00600, 0x0000c901, 0x81f81400, 
	0x00008014, 0x83019000, 0x00001980, 0x857c2c3c, 0x0000f100, 0x00000c08, 
	0x00009583, 0x02001000, 0x00001989, 0x02002000, 0x00001991, 0x00008580, 
	0x00007008, 0x00000001, 0x00007280, 0xf7304013, 0x0000a881, 0x00002c08, 
	0x0000e583, 0x01000000, 0x00008981, 0x8000020d, 0x0000e582, 0x01000800, 
	0x00008989, 0x83400000, 0x00001980, 0x83400800, 0x00001990, 0xffffffff, 
	0x00007f86, 0x01206c04, 0x00009203, 0x10c00000, 0x00001990, 0x50e0640c, 
	0x00009911, 0x00008580, 0x00007008, 0x858e8059, 0x00007100, 0x00008580, 
	0x00007200, 0x02003000, 0x00001981, 0x82402d00, 0x00006080, 0x02800000, 
	0x0000c981, 0x23385c09, 0x00002080, 0x81c15800, 0x00001980, 0xffffffff, 
	0x00007f97, 0x0000040b, 0x0000e583, 0x04205806, 0x0000a001, 0x02c00000, 
	0x0000e191, 0x14685806, 0x0000e001, 0x65b85806, 0x0000e801, 0x00008667, 
	0x0000f210, 0x24b05806, 0x00006807, 0x00008669, 0x00007000, 0x82402d00, 
	0x00006080, 0x82000c0b, 0x00004880, 0x00000c0b, 0x00006583, 0x81800a09, 
	0x00000080, 0x82504206, 0x00009000, 0x2301e409, 0x00007902, 0x0dc00000, 
	0x00008000, 0x000085af, 0x0000f218, 0x2339d609, 0x0000b038, 0x00000c0b, 
	0x00009583, 0xa929e53c, 0x0000e109, 0x2929e53c, 0x00004911, 0xffffffff, 
	0x00007f86, 0x8621e0a4, 0x0000600b, 0x8221e0a4, 0x00003012, 0xffffffff, 
	0x00007f86, 0xa6b1e0a4, 0x0000e00b, 0xa2b1e0a4, 0x0000b012, 0x80001e3c, 
	0x00009583, 0x11a1e7e4, 0x00001808, 0x000085ba, 0x0000f011, 0x85b384ac, 
	0x00007100, 0x85b68531, 0x0000f500, 0x03000020, 0x00009980, 0x8329e53c, 
	0x00001900, 0x02be000a, 0x00007900, 0x003ffffe, 0x00008280, 0x9981fc0a, 
	0x0000f88f, 0x04000000, 0x00004382, 0x02400e3c, 0x00009181, 0x00000c09, 
	0x00001583, 0x0000863d, 0x0000f01b, 0x8000163c, 0x0000e583, 0x01000000, 
	0x00008981, 0x01000800, 0x00001989, 0xbb602c3c, 0x00004388, 0x01002c3c, 
	0x00008098, 0xbb60143c, 0x0000c388, 0x0100143c, 0x00000098, 0x00c00c3c, 
	0x0000c789, 0x07801c3c, 0x0000048e, 0xb940243c, 0x0000c688, 0x7b00443c, 
	0x0000219c, 0x89003c3c, 0x000048a8, 0x80c04c3c, 0x00009d8a, 0x00000404, 
	0x00001583, 0x03800000, 0x00001990, 0x000085d4, 0x00007009, 0x85d08321, 
	0x00007500, 0x0000243c, 0x00001583, 0x43800800, 0x00009989, 0xffffffff, 
	0x00007f86, 0x0020200a, 0x0000e882, 0x9981fc0a, 0x0000f88f, 0x04000000, 
	0x00004382, 0x0000243c, 0x0000e583, 0x03000000, 0x00008980, 0x03e9d43a, 
	0x0000803c, 0x85d0835e, 0x0000f500, 0x0321e43b, 0x00000032, 0xc3000800, 
	0x00009989, 0x000085d0, 0x0000f000, 0x00000404, 0x00001583, 0x03000000, 
	0x00006191, 0x0240153c, 0x0000c890, 0x82400a09, 0x0000e090, 0x03400000, 
	0x00000991, 0x000085f9, 0x0000f008, 0x00002c3c, 0x00006583, 0x82000000, 
	0x00008980, 0x03000800, 0x0000e189, 0x03400800, 0x00004991, 0xc000033b, 
	0x00001582, 0x82000800, 0x00001988, 0xf7202009, 0x00002081, 0x0220440d, 
	0x00009203, 0x000085f2, 0x0000700b, 0x00001c04, 0x00001583, 0xf7002009, 
	0x0000508b, 0x00400000, 0x00008000, 0x0000866e, 0x0000f009, 0x00000c04, 
	0x00009583, 0xf7001009, 0x0000508b, 0x00400000, 0x00008000, 0x0000866e, 
	0x0000f009, 0x866b8383, 0x0000f500, 0x8dc0073b, 0x000080bc, 0x83e0640c, 
	0x0000e101, 0x83e9e53c, 0x00004900, 0x0000862b, 0x0000f400, 0x03000000, 
	0x00001980, 0x8329e53c, 0x00001900, 0x00002c3c, 0x00006583, 0x03c00000, 
	0x00008980, 0x85ff83cf, 0x0000f500, 0x0dd9db3b, 0x00006100, 0x83e9e53c, 
	0x00004900, 0x83c00800, 0x00001989, 0x00000404, 0x0000e583, 0x02602404, 
	0x00008901, 0x02000020, 0x00009988, 0x8229e53c, 0x00001908, 0x0000862b, 
	0x00007208, 0x03004008, 0x00001908, 0x0020480a, 0x00006882, 0x9981fc0a, 
	0x0000f88f, 0x04000000, 0x00004382, 0x00000404, 0x00001583, 0x03c00000, 
	0x0000f900, 0x00004000, 0x00000980, 0x83e9e53c, 0x00001900, 0x0000860f, 
	0x0000f008, 0x85d08383, 0x00007100, 0x000085d0, 0x0000f000, 0x85d083cf, 
	0x0000f100, 0x00000404, 0x0000e583, 0x0dd9db3b, 0x00008900, 0x0329d43a, 
	0x00008030, 0x03e1e43b, 0x0000003e, 0x00008621, 0x0000f008, 0x861a83fb, 
	0x0000f500, 0x0000343c, 0x00006583, 0xc3c00000, 0x00000981, 0xc3c00800, 
	0x0000e189, 0x02000000, 0x0000c980, 0x00000404, 0x0000e583, 0x02602404, 
	0x00008901, 0x02000000, 0x00001988, 0x8229e53c, 0x00001908, 0x0000862b, 
	0x00007208, 0x03004008, 0x00001908, 0x00008605, 0x00007000, 0x86268460, 
	0x0000f500, 0x0000343c, 0x00006583, 0xc3c00000, 0x00000981, 0xc3c00800, 
	0x0000e189, 0x04400000, 0x00004980, 0x00000404, 0x0000e583, 0x02602404, 
	0x00008901, 0x03000020, 0x00001988, 0x8329e53c, 0x00009908, 0x00008605, 
	0x0000f010, 0x86058531, 0x0000f100, 0x00000404, 0x0000e583, 0x8311d23a, 
	0x00008900, 0x0321dd3a, 0x0000003c, 0x83e9e53c, 0x0000e101, 0xc3c00000, 
	0x00004991, 0x00008637, 0x00007008, 0x85d083fb, 0x0000f500, 0x00003c3c, 
	0x0000e583, 0x02000800, 0x00008980, 0xc3c00800, 0x00009989, 0x000085d0, 
	0x0000f000, 0x85d08460, 0x0000f500, 0x00003c3c, 0x0000e583, 0xc3c00000, 
	0x00000981, 0xc3c00800, 0x0000e189, 0x04400800, 0x0000c980, 0x000085d0, 
	0x0000f000, 0x0001000a, 0x0000ec82, 0x9981fc0a, 0x0000f88f, 0x04000001, 
	0x00008080, 0x08005409, 0x0000e882, 0xc000070b, 0x00001583, 0x0000fc09, 
	0x00001583, 0xffffffff, 0x00007f86, 0x00008646, 0x00007010, 0x00008654, 
	0x0000f050, 0x03000020, 0x0000e180, 0x08001a07, 0x00006106, 0x03cce000, 
	0x00007900, 0x0012eb56, 0x00008980, 0x04d55800, 0x00007900, 0x001a9c1e, 
	0x00000980, 0xc1f00600, 0x0000e101, 0x08005708, 0x0000e082, 0x81f81400, 
	0x00008014, 0x4209e03c, 0x00008021, 0x4201de3c, 0x00000026, 0x86542c3c, 
	0x00007500, 0x8240d13a, 0x000080b1, 0x8281d13b, 0x0000002a, 0x39800040, 
	0x00006180, 0x08001aed, 0x0000e106, 0x2bb3f800, 0x0000f900, 0x0013ebe6, 
	0x00008980, 0x2bd55800, 0x0000f900, 0x001a9c1e, 0x00000980, 0xfb700600, 
	0x00006101, 0x080057ac, 0x00006082, 0xbb781400, 0x00000e1c, 0x6b09e03c, 
	0x00008a31, 0x6b01de3c, 0x00000a36, 0x86632e75, 0x0000f500, 0xab41d13a, 
	0x00008e3e, 0xb980d000, 0x0000e180, 0xfbd1da3b, 0x00004900, 0x00008669, 
	0x0000f200, 0x02bbf80a, 0x0000f900, 0x003ffffe, 0x00008280, 0x02c00c0b, 
	0x00009081, 0x00305c0b, 0x00001503, 0x0000859d, 0x0000f02b, 0x00000001, 
	0x00007280, 0x0120540a, 0x00009901, 0x02602404, 0x00001901, 0x81400404, 
	0x0000f893, 0xb4000000, 0x0000c28f, 0x00008605, 0x0000f200, 0x02400000, 
	0x00009981, 0xffffffff, 0x00007f86, 0xffffffff, 0x00007f86, 0xffffffff, 
	0x00007f86, 0xffffffff, 0x00007f86, 0x00006802, 0xfef828ec, 0x0000a080, 
	0xffffffff, 0x00007f86, 0x50952029, 0x0000f503, 0x01400805, 0x00009080, 
	0xfef828ec, 0x00002880, 0xffc00000, 0x00001980, 0xffffffff, 0x00007f86, 
	0x008006ec, 0x0000df80, 0x00000000, 0x00000084, 0xffffffff, 0x00007f86, 
	0xffffffff, 0x00007f86, 0xffffffff, 0x00007f86, 0xfef828ec, 0x0000a080, 
	0xffffffff, 0x00007f86, 0x00000001, 0x00007483, 0x01401005, 0x00009080, 
	0xfef828ec, 0x00002880, 0xffffffff, 0x00007f86, 0xffffffff, 0x00007f86, 
	0xffffffff, 0x00007f86, 0xfef828ec, 0x0000a080, 0xffffffff, 0x00007f86, 
	0x00000001, 0x00007483, 0x01410005, 0x00009080, 0xfef828ec, 0x00002880, 
	0xfef820ec, 0x00002080, 0xffffffff, 0x00007f86, 0x00000001, 0x00007483, 
	0x01020004, 0x00009080, 0xfef820ec, 0x0000a880, 0xffffffff, 0x00007f86, 
	0xffffffff, 0x00007f86, 0xffffffff, 0x00007f86, 0xffffffff, 0x00007f86, 
	0xffffffff, 0x00007f86, 0xffffffff, 0x00007f86, 0xfef828ec, 0x0000a080, 
	0xffffffff, 0x00007f86, 0x00000001, 0x00007483, 0x01402807, 0x00001000, 
	0xfef828ec, 0x00002880, 0x50a6275e, 0x0000f100, 0xfef838ec, 0x00002080, 
	0xffffffff, 0x00007fa7, 0x01c03805, 0x00009000, 0x000050a0, 0x00007400, 
	0xfef838ec, 0x0000a880, 0x01c40000, 0x00001980, 0xffffffff, 0x00007f86, 
	0xffffffff, 0x00007f86, 0xffffffff, 0x00007f86, 0xffffffff, 0x00007f86, 
};
/* Data size: 28776 bytes */

/* Total of 631400 bytes in 77 blocks */

#endif /* __INIT_VALUES_ZIPPED_H__ */
